  *** Copyright Notice ***
  BerkeleyGW, Copyright (c) 2011, The Regents of the University of
  California, through Lawrence Berkeley National Laboratory (subject to
  receipt of any required approvals from the U.S. Dept. of Energy).
  All rights reserved.

  If you have questions about your rights to use or distribute this
  software, please contact Berkeley Lab's Technology Transfer Department
  at  TTD@lbl.gov.

  NOTICE.  This software was developed under partial funding from the
  U.S. Department of Energy.  As such, the U.S. Government has been
  granted for itself and others acting on its behalf a paid-up,
  nonexclusive, irrevocable, worldwide license in the Software to
  reproduce, prepare derivative works, and perform publicly and display
  publicly.  Beginning five (5) years after the date permission to
  assert copyright is obtained from the U.S. Department of Energy, and
  subject to any subsequent five (5) year renewals, the U.S. Government
  is granted for itself and others acting on its behalf a paid-up,
  nonexclusive, irrevocable, worldwide license in the Software to
  reproduce, prepare derivative works, distribute copies to the public,
  perform publicly and display publicly, and to permit others to do so.

  For license information see "license.txt"

-------------------------------------------------------

  BerkeleyGW - The Berkeley GW (And More) Package
  http://www.berkeleygw.org

  Version 1.1   (June, 2014)

  Version 1.0	(Aug, 2011)
  J. Deslippe, G. Samsonidze, D. A. Strubbe, M. Jain

  Version 0.5	(July, 2008)
  J. Deslippe, G. Samsonidze, L. Yang, F. Ribeiro

  Version 0.2	M. L. Tiago	(2001)	Original BSE Code, PlotXct
        	S. Ismail-Beigi	(2002)	FFT, Documentation, General Improvements
        	C. Spataru	(2005)	Cylindrical Coulomb Truncation, Transform (obsolete)
  Version 0.1	X. Blase	(1998)	Implemented F90, Preprocessing, Dynamical Memory Allocation
        	G. M. Rignanese				"		"
        	E. Chang				"		"
  Version 0.0	M. Hybertsen	(1985)	Original GW Code

  To report current bugs or problems, contact Jack Deslippe: jdeslip@civet.berkeley.edu

------------------------------------------------------

  See more details in the README and .inp files in individual directories.

------------------------------------------------------

Compilation
-----------

  We have tested the code extensively with various configurations, and support the following compilers and libraries:
  * Operating systems: Linux, AIX, MacOS
  * Fortran compilers (required): pgf90, ifort, gfortran, g95, openf90, sunf90, pathf90, crayftn, af90 (Absoft), nagfor, xlf90 (experimental)
  * C compilers (optional): pgcc, icc, gcc, opencc, pathcc, craycc, clang
  * C++ compilers (optional): pgCC, icpc, g++, openCC, pathCC, crayCC, clang++
  * MPI implementation (optional): OpenMPI, MPICH1, MPICH2, MVAPICH2, Intel MPI
  * LAPACK/BLAS implementation (required): NetLib, ATLAS, Intel MKL, ACML, Cray LibSci
  * ScaLAPACK/BLACS implementation (required by BSE if MPI is used): NetLib, Cray LibSci, Intel MKL, AMD
  * FFTW (required): versions 2.1.5.x

  1. Architecture-specific Makefile-include files appropriate for various supercomputers as well as
     for using standard Ubuntu or Macports packages are provided in the config directory. Copy or
     link one to the top directory. Example:

     cp config/lonestar.tacc.utexas.edu.mk arch.mk

  2. Edit it to fit your needs. Refer to config/README for details.

  3. Copy flavor_real.mk or flavor_cplx.mk to flavor.mk to set flavor. 
     Complex may always be used. Real may be used for systems that
     have both inversion (about the origin) and time-reversal symmetry, and will be
     faster and use less memory.

  4. Stay in the root directory and run the following commands 
     to compile the various codes:

     MAIN:
     make epsilon
     make epsilon-all               Epsilon + utilities
     make sigma
     make sigma-all                 Sigma + utilities
     make bse
     make bse-all                   BSE + utilities

     MISC:
     make plotxct
     make meanfield
     make epm
     make sapo
     make siesta2bgw
     make bgw2para
     make kgrid
     make icm
     make surface

     EVERYTHING:
     make all                       All codes/packages (for selected flavor)
     make -j all                    parallel build (for selected flavor)
     make all-flavors               everything, for both flavors
     make -j all-flavors            parallel build of everything, for both flavors
     make install INSTDIR=          install binaries, library, examples, testsuite into specified prefix

     These commands will generate executables with extension .x in 
     the source directory and symbolic links with the same name in 
     the bin directory.

  5. Test your build. See testsuite/README for more info.

Development
-----------
Spirit of contributions:

  0. Follow guidelines at https://civet.berkeley.edu/BerkeleyGW/wiki/CodingStandards
  1. These codes are to be used on various machine architectures
     employing various compilers and libraries. Therefore, try not
     to write machine-specific code or quick fixes that will have to
     be reversed later.
  2. Limit compilation changes as much as possible to arch.mk and ensure
     that this is suitable for all codes in Epsilon/, Sigma/, and BSE/.
     Hopefully individual Makefiles will only require the addition of
     new source-code files.
  3. Test the codes using the examples/ and please augment the examples/
     with your own test cases (provided they are not too computationally
     expensive).

-----------------------------------------------------------------
----------  PlotXct code  ---------------------------------------
-----------------------------------------------------------------

  Version 1.1   (June, 2014)

  Version 1.0	(July, 2011)

  Version 0.5	F. Ribeiro (2008), S. Ismail-Beigi
  Version 0.2	M. L. Tiago (2002-2007)

-----------------------------------------------------------------

Description:

PlotXct plots the exciton wavefunction in real space based on
output of BSE/absorption (with full diagonalization).

Reads files WFN_fi/WFNq_fi (from mean field) and eigenvectors (output
from BSE/absorption code when using diagonalization, not Haydock) and
plots selected exciton state in real space according to:

   Psi(r,r`,s) = Sum_cvk A_svck * phi_sck(r) * exp(ik.r) * conjg( phi_svk(r`) * exp(i[k+q].r`) 

where r`, hole coordinate, is fixed at some point and r, electron coordinate,
runs over a supercell of given size (typically, equivalent to the fine k-grid),
with a real-space mesh defined by the FFT grid of the wavefunction files.
A separate plot can be generated for each spin s.


Output is written in format suitable for Data Explorer (DX).

The input option 'restrict_kpoints' reduces the sum over k-points
above to a sum over the ones that give most of the contribution
to the norm of eigenvectors. This is handy if there are many k-points
but only a few of them give sizable contribution.

input: WFN_fi WFNq_fi       wavefunction files
       eigenvectors         output from BSE/absorption code
       plotxct.inp          input parameters

-----------------------------------------------------------------

1. Copy/edit plotxct.inp. 

   You'll need:
     . index of the exciton state you want to plot
     . hole position in lattice coordinates
     . supercell dimensions (or k-grid)
     . spin component you want to plot (if spin-polarized)

2. Run plotxct.x

   The ASCII file 'xct.[state]_s[spin].a3Dr' will be created.

   'a3Dr' means that the file is in ASCII and contains 3D data in 'r' real space.

   The header of this file contains information on
     . state index
     . state energy in eV
     . hole position in atomic units (a.u.)
     . spin component plotted
     . supercell lattice vectors in a.u.
     . number of discretization points
   followed by three columns of data corresponding to the complex values of the 
   electronic part of the excitonic wavefunction, and its magnitude squared.

   The values are written with very low precision due to file-size concerns.


3. Convert to a format readable by the plotting utility of your choice.

   Use the 'volume.py' utility:

   Usage: volume.py imfn imff ivfn ivff ovfn ovff phas cplx [hole]

   imfn = input matter file name
   imff = input matter file format
          (mat|paratec|vasp|espresso|siesta|tbpw|xyz|xsf)
   ivfn = input volumetric file name
   ivff = input volumetric file format (a3dr)
   ovfn = output volumetric file name
   ovff = output volumetric file format (cube|xsf)
   phas = remove wavefunction phase (true|false)
   cplx = complex wavefunction (re|im|abs|abs2)
   hole = plot hole (true|false)

   You can specify whether you want a .xsf (XCrysDen) or .cube (Gaussian Cube)
   file format. You can remove or keep the arbitrary phase of the wavefunction
   by setting parameter "phas" to true or false. You can plot the re, im, abs,
   or abs2 part of the wavefunction.

   You must specify a path to the input file (example: "../01-scf/input")
   in one of the supported formats (DFT and others) so that the script can
   obtain the atomic positions from the file.

   You can choose whether to display or not the position of the hole by setting
   parameter "hole" to true or false.

   The resulting .xsf or .cube file can be viewed in XCrysDen or converted to
   POV-Ray script format using Surface code (for more details on the latter
   option, see Visual/README).

   ****************
   Example:

     % ~/BerkeleyGW/Visual/volume.py ../01-scf/input paratec xct.000001_s1.a3Dr a3dr \
                    xct.000001.abs2.xsf xsf false abs2 false
     % xcrysden --xsf xct.000001.abs2.xsf

   ****************

-----------------------------------------------------------------
----------  GW code, Sigma  -------------------------------------
-----------------------------------------------------------------

  Version 1.1	(June, 2014)
  Version 1.0	(September, 2011)

  Version 0.5	J. Deslippe, D. Prendergast, L. Yang, F. Ribeiro, G. Samsonidze (2008)
  Version 0.2	S. Ismail-Beigi (2002)
  Version 0.1	G. M. Rignanese, E. Chang, X. Blase  (1998)
  Version 0.0	M. Hybertsen (1985)

-----------------------------------------------------------------

Description:

Sigma is the second half of the GW code.  It should be run after
calculating epsmat/esp0mat in Epsilon.  It gives the quasiparticle
self-energies and dispersion relation for quasielectron and
quasihole states.  The main result is written to sigma.log file.

-----------------------------------------------------------------

Required Input:

	sigma.inp	Input parameters.  See example in this directory.
	epsmat(.h5)	Inverse dielectric matrix (q<>0).  Created using Epsilon.
	eps0mat(.h5)	Inverse dielectric matrix (q->0).  Created using Epsilon.
	WFN_inner	Real or complex wavefunctions. k-grid should be the same as
                        the q-grid of epsmat, though there can be a shift.
			This is usually the reduced points from an
			unshifted grid.
	RHO		Charge density (only needed for generalized plasmon-pole model),
                        from SCF calculation on which WFN_inner is based.
	vxc.dat		Matrix elements of the exchange-correlation potential,
                        from a mean-field calculation or a previous Sigma run.
                        VXC file may be used instead via keyword dont_use_vxcdat.

Additional Input:

	WFN_outer		Outer wavefunctions between which the
				self-energy operator and exchange-correlation
				potential are sandwiched. If absent inner
				wavefunctions will be used instead. Note that
				VXC should be consistent with outer wfn while
				RHO with inner wfn. If outer wfn is generated
                                using a hybrid functional, VXC contains the
                                local part of exchange-correlation potential.
				In this case set bare_exchange_fraction in
				sigma.inp to compensate for the non-local part,
				or use vxc.dat instead of VXC.

	The file below will be read only if eqp_corrections is set in sigma.inp.
	eqp.dat			A list of quasiparticle energy corrections
				for the bands in WFN_inner.
				The corrected eigenvalues are used for
				constructing the self-energy operator.

	The file below will be read only if eqp_outer_corrections is set in sigma.inp.
	eqp_outer.dat		A list of quasiparticle energy corrections for
				the bands in WFN_outer.
				The corrected eigenvalues determine
				the energies at which the self-energy
				operator is calculated.

	vxc2.dat		Matrix elements of the exchange-correlation potential,
                                from a mean-field calculation or a previous Sigma run. This
				is for a one-shot hybrid functional like calculation instead
				of a Sigma calculation. VXC2 file may be used instead via 
				keyword dont_use_vxc2dat.
				

Auxiliary Files:

	x.dat		Matrix elements of the bare exchange, generated by a previous
			Sigma run to speed up subsequent calculations.
                        Read if use_xdat keyword is present, written otherwise.
	VXC		Exchange-correlation potential (whose matrix elements
			are subtracted from DFT eigenvalues). Produced by
			mean-field code, from SCF calculation on which WFN_inner is based
                        (or WFN_outer, if present).
                        Used only if vxc.dat is not present or keyword dont_use_vxcdat is set.
	VXC2		Exchange-correlation potential (whose matrix elements
			are added to the hybrid functional like exchange). Produced by
			mean-field code, from SCF calculation on which WFN_inner is based
                        (or WFN_outer, if present).
                        Used only if vxc2.dat is not present or keyword dont_use_vxc2dat is set.
                        

-----------------------------------------------------------------

	sigma.inp	Please see example sigma.inp in this directory for complete options.

-----------------------------------------------------------------

Output Files:  

	sigma.log	The log file containing quasiparticle energy values
			for desired states. For a full-frequency calculation
                        only the value for Sigma calculated at energy closest
                        to the outer wavefunction eigenvalue is shown. The file 
                        spectrum.dat contains the full Sigma(E) spectra.

        sigma_hp.log	High-precision version of sigma.log.

        ch_converge.dat Convergence of Coulomb-hole term with respect to empty orbitals.

        spectrum.dat	The real and imaginary parts of Sigma as a function of
                        energy. The energy grid is specified in sigma.inp. This
                        file is only output in full-frequency calculations.
                        Some general notes:

                        * IM(SIGMA) was calculated using the same broadening
                        as RE(SIGMA), while IM(SIGMA2) was calculated without
                        any broadening.

                        There are 4 Sigmas currently reported.

                        1. Sigma = SX + CH with broadening in the CH Integral. 
                        2. Sigma = SX + CH with no Broadening. We do the energy 
                           denominator integral analytically.
                        3. Sigma = X + COR with broadening in the COR integral.
                        4. Sigma = X + COR with no broadening. We do the energy 
                           denominator integral analytically.

                        * Ew is not the same as the frequencies specified in
                        sigma.inp. Ew is the absolute off-shell quasiparticle
                        energy, and it is *not* measured wrt the Fermi energy.
                        The (physically meaningful) on-shell quasiparticle
                        energy EQP is the solution of Dyson's equation:
                        Ew = E_LDA - Vxc + Re[Sig(Ew)].
                        

-----------------------------------------------------------------

A Note About the Wings of Epsilon (for Semiconductors Only):

The wings of Chi have terms of the following form:

< vk | e^(i(G+q)r) | ck+q >< ck+q | e^(-iqr) | vk > (1)

The matrix element on the right is < u_ck+q | u_vk > where u is the periodic part 
of the Bloch function. From k.p perturbation theory, this matrix element is proportional
to q. The matrix element on the left with a non-zero G is typically roughly
a constant as a function of q for small q (q being a small addition to G).

Thus for a general G-vector, Chi_wing(G,q) \propto q. This directly leads 
to the wings of the screened untruncated Coulomb interaction being proportional 
to 1/q. Note that this function changes sign as q -> -q. Thus, when treating the 
q=0 point, we set the value of the wing to zero (the average of its value in the 
mini-Brillouin zone (mBZ).

For G-vectors on high-symmetry lines, some of the matrix elements on the left of (1)
will be zero for q=0, and therefore proportional to q. For such cases,
Chi_wing(G,q) \propto q^2, and the wings of the screened Coulomb interaction
are constant as a function of q. However, setting the q->0 wings to zero still 
gives us, at worst, linear convergence to the final answer with increased k-point 
sampling, because the q->0 point represents an increasingly smaller area in the 
BZ. Thus, we still zero out the q->0 wings, as discussed in
A Baldereschi and E Tosatti, Phys. Rev. B 17, 4710 (1978).

In the future, it may be worthwhile to have the user calculate chi / epsilon at 
two q-points (a third q-point at q=0 is known) in order to compute the linear 
and quadratic coefficients of each chi_wing(G,q) so that all the correct analytic
limits can be taken. This requires a lot of messy code and more work for the user
for only marginally better convergence with respect to k-points (the wings tend
to make a small difference, and this procedure would matter for only a small set
of the G-vectors). 

It is important, as always, for the user to converge their calculation 
with respect to both the coarse k-point grid used in sigma and kernel as well
as with the fine k-point grid in absorption.

-JRD+MJ

-----------------------------------------------------------------

Tricks and hints:

1. Comments on convergence of scc (screened_coulomb_cutoff)
   and bcc (bare_coulomb_cutoff)

The parameters scc and bcc are independent to each other and are
related to the number or terms taken into account in the
plane-wave expansion of Sigma_(SEX + COH) and V_xc, respectively.

Since Sigma_(SEX) is related to epsilon, scc should be equal to 
or less than the epsilon_cutoff used to compute chi0 and epsilon.

If you are to use large values for scc and bcc (say 50 Ry or so),  
a good suggestion is run the sigma code twice: first with large
bcc and small scc, just to get x.dat and vxc.dat; then with large
scc and any bcc, using the x.dat and vxc.dat files generated before.
The second run is usually much faster than a run with large scc
and bcc.

2. Metals

If you are doing a metal you should report the shift used in sigma.inp 
whether using truncation or not.

3. Off-diagonal

If you are doing off-diagonal matrix elements of Sigma use the utility 
offdiag in this directory to diagonalize the Sigma matrix.

4. Linear extrapolation for eqp1

If |eqp0 - ecor| > finite_difference_spacing linear extrapolation 
for eqp1 may be inaccurate. You should test the validity of eqp1 
by rerunning calculation with self-energy evaluated at the eqp0 
energies. For that, use the eqp_outer.dat file created 
with eqp.py script and point WFN_outer to WFN_inner (if you were
not already using WFN_outer), i.e. run
i) ln -s WFN_inner WFN_outer
ii) eqp.py eqp0 sigma_hp.log eqp_outer.dat
and add eqp_outer_corrections to sigma.inp. If you get the same eqp1,
the linearization looks good; if not, you can continue iterations like
this to converge to the solution of the Dyson equation.

-----------------------------------------------------------------
----------  BerkeleyGW library  ---------------------------------
-----------------------------------------------------------------

To build other codes with BerkeleyGW output support, type 'make library'
to create libBGW_wfn.a and wfn_rho_vxc_io_m.mod (and dependent modules),
and then compile with -I library/ and link library/libBGW_wfn.a with
the other code.

An m4 macro for configure scripts is provided in this directory, for
use in linking to this library. Codes linking the library should 'use'
the module 'wfn_rho_vxc_io_m'.

To generate real wavefunctions, a Gram-Schmidt process should be used.
The appropriate parallelization scheme etc. will be dependent on the code,
and cannot be easily handled in a general manner here, but examples can
be found in MeanField/SIESTA/real.f90 and MeanField/ESPRESSO/pw2bgw.f90
(routine real_wfng).

# Information about how to set the various options here.
# Ideally you can use a file already created for your platform in this directory.
# Otherwise, you can work from the one most similar that is here.

# Select the Fortran compiler you are using.
# if you have a different one than these, modifications in Common/compiler.h
# and Common/common-rules.mk will be necessary.
COMPFLAG  = -D{INTEL, PGI, GNU, PATH, XLF, G95, ABSOFT, NAG, OPEN64, SUN, CRAY}

# Use -DMPI to compile Fortran in parallel with MPI. Otherwise is serial.
# Add -DOMP to compile with OpenMP support. Also add appropriate compiler-dependent flag to F90free:
# ifort, sunf90, absoft, pathscale, Open64: -openmp. PGI: -mp=nonuma. gfortran: -fopenmp. XLF: -qsmp=omp.
# crayftn: on by default (to turn off use -h noomp). g95 and NAG do not support OpenMP.
PARAFLAG  = -DMPI
# -DUSESCALAPACK enables usage of ScaLAPACK (required in parallel for BSE).
# -DUSEESSL uses ESSL instead of LAPACK in some parts of the code.
# -DUNPACKED uses unpacked rather than packed representation of the Hamiltonian
# in EPM. Packed LAPACK operations give bad results eventually in Si-EPM kernel 'max x'
# test for ACML, Cray LibSci, and MKL sometimes.
# -DUSEFFTW3 uses fftw3 instead of fftw2, which is recommended for better performance, and enables threading.
# -DHDF5 enables usage of HDF5 for writing epsmat and bsemat files. The produced files will be
# eps0mat.h5, epsmat.h5 and bsemat.h5 and are used in place of eps0mat, epsmat, bsedmat, bsexmat 
# (the latter two are combined in one .h5 file). 
# Using -DHDF5 gives you substantially better IO performance in many cases by taking advantage
# of HDF5's parallel IO options and other options. However, you must have the HDF5 libraries
# installed on your system and define HDF5LIB and HDF5INCLUDE below.
MATHFLAG  = -DUSESCALAPACK -DUSEESSL -DUNPACKED -DHDF5
# For Fortran and C++. -DDEBUG enables extra checking. -DVERBOSE writes extra information.
# Only use these flags if you need to develop or debug BerkeleyGW.
# The output will be much more verbose, and the code will slow down by ~20%.
DEBUGFLAG = -DDEBUG -DVERBOSE
# Same, but for C.
C_DEBUGFLAG = -DDEBUG -DVERBOSE

# Command for the preprocessor. -ansi should generally be used.
# add -P if the Fortran compiler will not accept indication of line numbers.
# Use gcc's (often in /lib/cpp) or a C compiler (even mpicc) with "-E". Some need "-x c" as well.
FCPP    = cpp -ansi
# Fortran compiler and its flags for F90 and f90 files (free source form)
# see above at PARAFLAG regarding flags for OpenMP.
# With -DOMP and openmp flags here, you will get threaded BerkeleyGW.
# Without -DOMP, but with openmp flags here, is appropriate for just using threaded libraries.
# Sometimes, flags such as -fno-second-underscore or -assume 2underscores may be necessary
# to make linking succeed against C libraries such as FFTW, depending on what compiler built them.
F90free = {mpif90, mpiifort, ftn, ifort, pgf90, gfortran, ...}
# Fortran compiler and any flag(s) required for linking
LINK    = {mpif90, mpiifort, ftn, ifort, pgf90, gfortran, ...}
# Fortran optimization flags. The levels below will generally work.
FOPTS   = {-fast, -O3}
# Fortran optimization flags for epsilon_main and sigma_main which can have
# trouble in high optimization due to their long length. If below does not
# work, try -O2.
FNOOPTS = $(FOPTS)
# Fortran compiler flag to specify location where module should be created.
# different for each compiler, refer to examples.
MOD_OPT =
# Fortran compiler flag to specify where to look for modules.
INCFLAG = -I

# Use this to compile C++ in parallel with MPI. Leave blank for serial.
# MPICH, MVAPICH, Intel MPI require also -DMPICH_IGNORE_CXX_SEEK, or an error may occur such as:
# "SEEK_SET is #defined but must not be for the C++ binding of MPI. Include mpi.h before stdio.h"
C_PARAFLAG  = -DPARA
# C++ compiling command and any needed flags
CC_COMP = {mpiCC, mpicxx, mpiicpc, CC, icpc, pgCC, g++, ...}
# C compiling command and any needed flags
C_COMP  = {mpicc, mpiicc, cc, icc, pgcc, gcc, ...}
# C/C++ link command and any needed flags
C_LINK  = {mpiCC, mpicxx, mpiicpc, CC, icpc, pgCC, g++, ...}
# C/C++ optimization flags
# Note: for Intel compilers, it is equivalent to use icc or icpc on C++ files.
C_OPTS  = -fast

# command to remove, for make clean
REMOVE  = /bin/rm -f
# command for making archives (.a). Default is /usr/bin/ar.
# Usually that is fine and AR does not need to be specified, but
# to do interprocedural optimizations (IPO) with ifort, you need xiar instead.
#AR = /usr/bin/env xiar

# Math Libraries
# path for FFTW library, used in lines below
FFTWPATH     = 
# link line for FFTW2 library. Sometimes needs to be -ldfftw
FFTWLIB      = -L$(FFTWPATH)/lib -lfftw
# link line for FFTW3 library, if -DUSEFFTW3 is used. Including fftw_omp allows threaded run.
FFTWLIB      = -L$(FFTWPATH)/lib {-lfftw3_omp} -lfftw3
# FFTW2 requires include file fftw_f77.i;
# Sometimes supercomputer installations will not have it.
# If not, find it online and copy it: e.g. http://www.fifi.org/doc/fftw-dev/fortran/fftw_f77.i
# FFTW3 requires include file fftw3.f03 instead.
FFTWINCLUDE  = $(FFTWPATH)/include

# Different styles will apply depending on the package used.
# Must provide BLAS as well as LAPACK: some packages will do this in one library file,
# others will not. See examples in this directory for how to link with MKL, ACML,
# ATLAS, Ubuntu packages, etc. For MKL, if you will use ScaLAPACK, it is most
# convenient to include BLACS here too. For further info on linking with MKL, see
# the link-line advisor at http://software.intel.com/sites/products/mkl/
LAPACKLIB    = 

# Specify below if you have -DUSESCALAPACK in MATHFLAG.
# BLACS must be provided here too, if it is not provided in LAPACKLIB above. See
# examples in this directory for different packages, as with LAPACKLIB. Note that
# you may have problems if ScaLAPACK was not built with the same LAPACK used above.
SCALAPACKLIB =

# Specify below if you have -DHDF5 in MATHFLAG.
# If compiling in parallel, you must have HDF5 compiled with parallel support or linking will fail.
# Path as below should generally work. Sometimes -lsz too, or static linkage, might be required.
# Note that "-lz" is not from HDF5, but its dependency zlib.
# libdl may be required on your system even when linking static HDF5 due to plugin support in 1.8.11 and higher
HDF5PATH     =
HDF5INCLUDE  = $(HDF5PATH)/include
HDF5LIB      = -L$(HDF5PATH)/lib -lhdf5hl_fortran -lhdf5_hl -lhdf5_fortran -lhdf5 -lz

# Flags for performance profiling with an external tool such as IPM on NERSC
PERFORMANCE  = 

# Command to submit testsuite job script from testsuite directory.
# qsub is for PBS. If no scheduler, put make check-parallel here.
# In serial, delete this line.
TESTSCRIPT = qsub {architecture}.scr

-----------------------------------------------------------------
----------  BSE code, IntEqp  -----------------------------------
-----------------------------------------------------------------

  Version 1.0	(July, 2011) J. Deslippe, D. A. Strubbe

-----------------------------------------------------------------

Description:

This code takes the eqp_co.dat file from Sigma and
interpolates it from the coarse to the fine grid using wavefunction
projections (to resolve band crossings) and linear interpolation
in the Brillouin zone.

-----------------------------------------------------------------

Required Input:

	inteqp.inp	Input parameters. See example absorption.inp in this directory
			for complete options (noting which sections apply to inteqp).
	WFN_fi		Wavefunctions in unshifted fine grid.
	WFN_co		Wavefunctions on coarse grid.
	eqp_co.dat	A list of quasiparticle energy corrections
			for the bands in WFN_co. 

Optional Input:

        WFNq_fi         Wavefunctions in shifted fine grid
                        (used for valence bands if use_velocity is selected)

Auxiliary Files: (output files from previous runs - used as input to speed up calculation)

	dtmat		Transformation matrices, dcc/dvv use for interpolation
			between coarse and fine grid.  This file must be consistent
			with your bsedmat and bsexmat files and corresponding
			coarse and fine wavefunctions.
			NOTE: the file format for dtmat was changed in BerkeleyGW 1.1.0	(r5961)

-----------------------------------------------------------------

Output Files:

        bandstructure.dat	The GW bandstructure on the fine grid.	
        eqp.dat                 Quasiparticle energy corrections for the bands in WFN_fi.
        eqp_q.dat               Quasiparticle energy corrections for the bands in WFNq_fi (if use_velocity).
        dvmat_norm.dat		The norms of the dvv overlap matrices between the valence 
                        	band k on the fine grid and the closest k-point on the coarse grid
        dcmat_norm.dat		The norms of the dcc overlap matrices between the conduction
                        	band k on the fine grid and the closest k-point on the coarse grid

-----------------------------------------------------------------
----------  Visualization Tools  --------------------------------
-----------------------------------------------------------------

  Version 2.4	(May, 2009)

  Version 2.3	G. Samsonidze (October, 2008)

-----------------------------------------------------------------

Description:

This directory contains a set of visualization tools designed to 
simplify your work with the DFT codes and the BerkeleyGW package. 
Here you will find the following scripts and codes:

1. Surface is a C++ code for generating an isosurface of a volumetric 
scalar field (such as the wave function, charge density, or local 
potential). The scalar field is read from Gaussian Cube or XCrySDen 
XSF file, the surface triangulation is performed using marching cubes 
or marching tetrahedra algorithm, and the isosurface is written in 
the POV-Ray scripting language. The final image is rendered using 
the ray-tracing program POV-Ray.

Running the code requires a fairly complicated input parameter file,
described with an example in surface.inp.

2. Matter is a python library for manipulating atomic structures with 
periodic boundary conditions. It can translate and rotate the atomic 
coordinates, generate supercells, assemble atomic systems from fragments, 
and convert between different file formats. The supported file formats 
are mat, paratec, vasp, espresso, siesta, xyz, xsf, and povray.

mat is the native file format of the library. paratec, vasp, espresso, 
and siesta represent the formats used by different plane-wave and 
local-orbital DFT codes. xyz is a simple format supported by many 
molecular viewers, and xsf is the internal format of XCrySDen viewer. 
povray stands for a scripting language used by the ray-tracing 
program POV-Ray.

The core of the library consists of files common.py, matrix.py, and 
matter.py. Script convert.py is a command-line driver that performs 
the basic operations supported by the library. Script link.py is a 
molecular assembler that can be used to rotate and link two molecules 
together. Script gsphere.py generates a real-space grid and a sphere 
of G-vectors given lattice parameters and a kinetic energy cutoff. 
This helps to estimate the number of unoccupied states needed in GW 
calculations. Script average.py takes an average of the scalar field 
on the faces or in the volume of the unit cell. This is used to 
determine the vacuum level in DFT calculations. Script volume.py 
converts the a3Dr file produced by PARATEC or BerkeleyGW to Gaussian 
Cube or XCrySDen XSF format.

Each script requires a different set of command-line arguments. 
Running individual scripts without arguments displays a list of 
all possible command-line arguments and a short description of 
each argument.

-----------------------------------------------------------------

Examples:

1. Benzene Charge Density

This example demonstrates how to plot isosurfaces. 
Go to directory ./benzene and run ESPRESSO:

$ sh link
Submit script. Suggested ncpu = 36, walltime = 0:30:00

This will produce the Gaussian Cube file rho.cube containing 
the charge density of the benzene molecule. For your convenience, 
the compressed file rho.cube.tgz is included in the ./benzene 
directory.

Let us generate an isosurface that contains 90% of the charge 
density using the marching cubes algorithm with the smooth triangles 
and render it in POV-Ray:

$ ../surface.x rho_uc.inp
$ povray -A0.3 +W640 +H480 +I rho_uc.pov

Examine the rho_uc.gif file to find that the pieces of the benzene 
molecule are placed in the corners of the unit cell. To assemble the 
pieces together we define a supercell in the rho_sc.inp file. This 
is done by setting the parameter sc to T and by placing the supercell 
origin (sco) at position (-0.5 -0.5 -0.5) in crystal coordinates 
(scu which stands for supercell units is set to latvec). The lattice 
vectors of the supercell are not changed (scv or supercell vectors 
in the parameter file). Let us render a new image:

$ ../surface.x rho_sc.inp
$ povray -A0.3 +W640 +H480 +I rho_sc.pov

Now the charge density comes up nice and centered in the middle 
of the supercell.

2. Nanotube Exciton Wavefunction

In this example we will plot an isosurface of the exciton 
wavefunction. Run ../examples/DFT/swcnt_8-0/ fully. Then 
go to directory ../examples/DFT/swcnt_8-0/8-absorption/.

PlotXct will produce the a3Dr file xct.020_s1.a3Dr containing 
a wavefunction of the 20th exciton in the (8,0) nanotube. 
Then volume.py will convert the a3Dr file to Gaussian Cube.

$ volume.py ../ESPRESSO/1-scf/in espresso xct.020_s1.a3Dr a3dr xct020.cube cube false abs2 true

The command will produce the Gaussian Cube file xct020.cube that 
contains the squared absolute value of the wavefunction 
(cplx = abs2) without the sign (phas = false) and the
position of the hole (hole = true). Then surface will generate an
isosurface that contains 90% of the charge density.

$ ../surface.x xct020.inp

You can then render it in POV-Ray (which you must install separately):

$ povray -A0.3 +W2560 +H1920 +I xct020.pov

The resulting image xct020.gif is included in the example directory.
Alternately, you can visualize the Cube file directly in XCrySDen.

3. Rock-Salt Lattice

Here you will learn how to make large supercells of bulk crystals. 
Go to directory ./rocksalt where you will find the nacl.mat file. 
Render it in POV-Ray:

$ ../convert.py nacl.mat mat nacl.pov povray
$ povray -A0.3 +W640 +H480 +I nacl.pov

The unit cell contains only two atoms. Let us make a supercell that 
contains a fractional number of unit cells. The supercell is described 
by the sc1 file which defines the origin of the supercell, the lattice 
vectors of the supercell, and the units in which these quantities 
are given. These are equivalent to sco, scv, and scu in the surface 
parameter file in the first example. The last line in the sc1 file 
corresponds to sct (supercell translation) in the surface parameter 
file. We will get back to it later on. Let us render the supercell:

$ ../convert.py nacl.mat mat nacl_sc1.pov povray supercell sc1
$ povray -A0.3 +W640 +H480 +I nacl_sc1.pov

Note the broken bonds on the faces of the supercell. 
That is because the supercell contains a fractional number 
of the unit cells, so the translational symmetry is broken 
which results in the Na-Na and Cl-Cl bonds. We disable the 
translational symmetry of the supercell by setting sct to 
false (the last line in the sc2 file). This enforces the 
translational symmetry of the underlying unit cell structure. 
Render the new supercell in POV-Ray:

$ ../convert.py nacl.mat mat nacl_sc2.pov povray supercell sc2
$ povray -A0.3 +W640 +H480 +I nacl_sc2.pov

Now the bonds on the faces of the supercell come out right.

4. Organic Molecule Synthesis

In this example you will assemble the bipolar molecule, bithiophene 
naphthalene diimide, from the donor and acceptor units, bithiophene 
and naphthalene diimide. Go to directory ./btnd and open files 
nd.xyz and bt.xyz in any molecular viewer, for example Jmol. 
Identify the atoms you want to link together, these are the two 
carbon atoms, # 15 in nd.xyz and # 8 in bt.xyz. You need to remove 
the two hydrogen atoms, # 21 in nd.xyz and # 14 in bt.xyz, and place 
# 15 and # 8 at the distance of 1.49 Angstrom from each other along 
the 15-21-14-8 line. This is done by invoking the following command:

$ ../link.py nd.xyz xyz bt.xyz xyz btnd.xyz xyz 15 21 8 14 0.0 degree 1.49 angstrom

You can also rotate bt.xyz around the 15-21-14-8 axis by an arbitrary 
angle, although the rotation angle is set to zero in the above command.

5. Estimate the number of unoccupied states for Epsilon and Sigma

Go to directory ../examples/DFT/benzene/0-gsphere/ and run the following:

$ gsphere.py g_eps.in g_eps.out

Examine input file g_eps.in. It contains the lattice vectors in bohr, 
the cutoff energy in Ry (epsilon_cutoff from ../5-gw/epsilon.inp or 
screened_coulomb_cutoff from ../5-gw/sigma.inp), '0 0 0' for the FFT 
grid to be determined automatically, and 'true' to sort the G-vectors 
by their kinetic energies. Examine output file g_eps.out. Look for the 
number of G-vectors, ng. You will find 'ng = 2637' meaning that you 
will need at least that many unoccupied states. Of course the number 
of unoccupied states is a convergence parameter, but gsphere.py gives 
you an idea in which range of values should you check the convergence.

Now run the following:

$ gsphere.py g_rho.in g_rho.out

Input file g_rho.in is similar to g_eps.in but it has a different 
cutoff energy which is 4 times ecutwfc from ../ESPRESSO/1-scf/in. 
This is the charge density cutoff or ecutrho in espresso documentation. 
Note that the last line in g_rho.in is set to 'false'. This is because 
using built-in Python sort function on that many G-vectors (up to 
ecutrho) will freeze your python interpreter. Examine output file 
g_rho.out. You should see the following:

 grid = ( 128 72 140 ) -- minimal
        ( 128 72 140 ) -- factors 2, 3, 5, 7, 1*11, 1*13
        ( 128 72 144 ) -- factors 2, 3, 5

The third line is the size of FFT grid in espresso calculation. 
(Well, not necessarily, because espresso algorithm starting with 
version 5 is smarter than what is implemented in gsphere.py.) 
The z-component is equal to 144 meaning that for an optimal 
load-balancing you should run espresso on a number of cores 
which is a divisor of 144 (that is, 144, 72, 36, 18, etc. cores).

-----------------------------------------------------------------

Notes:

Matter library may lack support for some advanced features 
of PARATEC, VASP, ESPRESSO and SIESTA formats. For example, 
LatticeParameters and ZMatrix are not implemented for SIESTA. 
This can be added to functions paratec_read, paratec_write, 
vasp_read, vasp_write, espresso_read, espresso_write, 
siesta_read and siesta_write in file matter.py.

Also note that all the additional information not related 
to the crystal structure (k-points, energy cutoffs, etc.) 
will be lost and replaced with the default parameters when 
converting between PARATEC, VASP, ESPRESSO and SIESTA formats.

-----------------------------------------------------------------
----------  BerkeleyGW, Doxygen Documentation -------------------
-----------------------------------------------------------------

Description
-----------

 This directory automatically generates documentation for BerkeleyGW 
using Doxygen. This is aimed towards developers, and end-users might
as well just ignore this directory.

 To create the documentation, simply type `make`. You`ll need doxygen and
graphviz installed. Then open doxygen/html/index.html in a web browser.


Obtaining Doxygen and Graphviz
------------------------------ 

 Doxygen and graphviz are available at:

 http://www.doxygen.org/
 http://www.graphviz.org/

 Alternatively, if you have a Debian-based distribution, such as
Ubuntu, you can ask your administrator to install the following packages:

 apt-get install doxygen graphviz

or on MacOS with MacPorts (www.macports.org):

 port install doxygen graphviz

Brief descriptions of the scripts in this directory:

----Energies-----

qp_shifts.py - from sigma_hp.log file, writes two files which contain the LDA 
	       energies and the GW shifts (E_qp-E_lda) for that energy. Useful
	       for determining scissor shifting parameters ecdel, evdel, etc.

eqp.py       - extracts QP energies from sigma_hp.log file and generates file
               eqp.dat. This file can be read in directly from the BGW
	       code if you want to shift the energies for each kpoint and band 
	       exactly instead of relying on the scissor shift.

----Kpoints-----


kptlist.pl   - extracts a formatted list of k-points from PARATEC file for use in the Sigma code
	   
qptlist.pl   - extracts a formatted list of q-points from PARATEC file for use in the Epsilon code

-----------------------------------------------------------------
----------  BSE code, Kernel  -----------------------------------
-----------------------------------------------------------------

  Version 1.1   (June, 2014)

  Version 1.0	(July, 2011) J. Deslippe, M. Jain, D. A. Strubbe, G. Samsonidze.
  Version 0.5	J. Deslippe, D. Prendergast, L. Yang, F. Ribeiro, G. Samsonidze (2008)
  Version 0.2	C. Spataru, S. Ismail-Beigi (2004)
  Version 0.1	M. L. Tiago, E. Chang, G. M. Rignanese (1999)

-----------------------------------------------------------------

Description:

This code constructs the direct and exchange Kernel matrix on
the coarse grid.  This is done essentially by computing Eqs 34,
35 and 42-46 of Rohlfing and Louie.

-----------------------------------------------------------------

Required Input:

	kernel.inp	Input parameters.  See detailed explanation below.
	WFN_co		Wavefunctions on coarse grid. Recommended: use an unshifted
                        grid of the same size as the q-grid in epsmat.
                        Shift will increase number of q-vectors needed in epsmat.

	epsmat		Inverse dielectric matrix (q<>0).  Created using Epsilon.
			Must contain the all q=k-k' generated from WFN_co, including
			with symmetry if use_symmetries_coarse_grid is set.
	eps0mat		Inverse dielectric matrix (q->0).  Created using Epsilon.

                        Note Kernel does not require quasiparticle eigenvalues. It
                        may be run in parallel with Sigma.

-----------------------------------------------------------------

	kernel.inp	Please see example kernel.inp in this directory
			for more complete options.

-----------------------------------------------------------------

Output Files:

	bsedmat		Direct kernel matrix elements on unshifted coarse grid.
	bsexmat		Exchange kernel matrix elements on unshifted coarse grid.

        or

        bsemat.h5	Includes data from both of above if compiled with HDF5 support
                        For specification, see bsemat.h5.spec

-----------------------------------------------------------------

A Note About the Wings of Epsilon (for Semiconductors Only):

The wings of Chi have terms of the following form:

< vk | e^(i(G+q)r) | ck+q >< ck+q | e^(-iqr) | vk > (1)

The matrix element on the right is < u_ck+q | u_vk > where u is the periodic part 
of the Bloch function. From k.p perturbation theory, this matrix element is proportional
to q. The matrix element on the left with a non-zero G is typically roughly
a constant as a function of q for small q (q being a small addition to G).

Thus for a general G-vector, Chi_wing(G,q) \propto q. This directly leads 
to the wings of the screened untruncated Coulomb interaction being proportional 
to 1/q. Note that this function changes sign as q -> -q. Thus, when treating the 
q=0 point, we set the value of the wing to zero (the average of its value in the 
mini-Brillouin zone (mBZ).

For G-vectors on high-symmetry lines, some of the matrix elements on the left of (1)
will be zero for q=0, and therefore proportional to q. For such cases,
Chi_wing(G,q) \propto q^2, and the wings of the screened Coulomb interaction
are constant as a function of q. However, setting the q->0 wings to zero still 
gives us, at worst, linear convergence to the final answer with increased k-point 
sampling, because the q->0 point represents an increasingly smaller area in the 
BZ. Thus, we still zero out the q->0 wings, as discussed in
A Baldereschi and E Tosatti, Phys. Rev. B 17, 4710 (1978).

In the future, it may be worthwhile to have the user calculate chi / epsilon at 
two q-points (a third q-point at q=0 is known) in order to compute the linear 
and quadratic coefficients of each chi_wing(G,q) so that all the correct analytic
limits can be taken. This requires a lot of messy code and more work for the user
for only marginally better convergence with respect to k-points (the wings tend
to make a small difference, and this procedure would matter for only a small set
of the G-vectors). 

It is important, as always, for the user to converge their calculation 
with respect to both the coarse k-point grid used in sigma and kernel as well
as with the fine k-point grid in absorption.

-JRD+MJ

-----------------------------------------------------------------

Tricks and hints:

1. To optimize distribution of work among PEs, do the following:

Choose processors to divide:

nk^2 (if npes < nk^2)
nk^2*nc^2 (if npes < nk^2*nc^2)
nk^2*nc^2*nv^2 (if npes < nk^2*nc^2*nv^2)

2. All input and output files (except kernel.inp) are in 
binary format.

3. The interaction matrices are calculated in full! i.e. not only the 
upper triangle. In diag, currently only the upper triangle is used.

4. The Brillouin zone is built using a Wigner-Seitz construction, 
this way the head matrix elements are easily calculated.

5. The dielectric matrix is by default stored in memory but may be stored 
on disk if the comm_disk options is specified.

6. The parameters scc (screened_coulomb_cutoff) and bcc 
(bare_coulomb_cutoff) are the same as scc and bcc used in Simga. 
The parameters scc and bcc should be equal to or less than the 
epsilon_cutoff and wavefunction_cutoff used in Epsilon and DFT, 
respectively. See Sigma/README for more details.

Converters from old versions of file formats to current version are available in version 2.4.

-----------------------------------------------------------------
----------  BSE code, Absorption  -------------------------------
-----------------------------------------------------------------

  Version 1.1   (June, 2014)

  Version 1.0	(July, 2011) J. Deslippe, M. Jain, D. A. Strubbe, G. Samsonidze
  Version 0.5	J. Deslippe, D. Prendergast, L. Yang, F. Ribeiro, G. Samsonidze (2008)
  Version 0.2	M. L. Tiago, C. Spataru, S. Ismail-Beigi (2004)

-----------------------------------------------------------------

Description:

This code is the second half of the BSE code.  It interpolates the coarse grid
electron-hole kernel onto the fine grid and then diagonalized the BSE equation.
The output is the electron-hole eigenfunctions and eigenvalues as well the
absorption spectra.

-----------------------------------------------------------------

Required Input:

	absorption.inp	Input parameters.  See detailed explanation below.
	WFN_fi		Wavefunctions in unshifted fine grid
			(conduction and valence for momentum operator,
			conduction for velocity operator).
	WFNq_fi		Wavefunctions in shifted fine grid
			(not needed for momentum operator,
			valence for velocity operator).
	WFN_co		Wavefunctions on unshifted coarse grid.
			Must be the same as used for Kernel.
	eps0mat		Must be same as used in Kernel.
	epsmat		Must be same as used in Kernel.
	bsedmat		BSE matrix elements in coarse grid, direct part. This
			should be generated with Kernel code using same WFN_co.
	bsexmat		BSE exchange matrix elements.  This should be generated
			with Kernel code using same WFN_co.

Additional Input:

	eqp.dat		A list of quasiparticle energy corrections for the bands in WFN_fi.
                        Used if eqp_corrections is set in absorption.inp.
	eqp_q.dat	A list of quasiparticle energy corrections for the bands in WFNq_fi.
                        Used if eqp_corrections is set in absorption.inp.
	eqp_co.dat	A list of quasiparticle energy corrections for the bands in WFN_co.
                        Used if eqp_co_corrections is set in absorption.inp.

	kpoints		A list of k-points in unshifted fine grid. EXPERIMENTAL.
			If absent k-points from WFN_fi file are used.
	kpoints_co	A list of k-points in unshifted coarse grid. EXPERIMENTAL.
			If absent k-points from WFN_co file are used.

Auxiliary Files: (output files from previous runs - used as input to speed up calculation)

	dtmat		Transformation matrices, dcc/dvv use for interpolation
			between coarse and fine grid.  This file must be consistent
			with your bsedmat and bsexmat files and corresponding
			coarse and fine wavefunctions.
			NOTE: the file format for dtmat was changed in BerkeleyGW 1.1.0	(r5961)
	vmtxel		Optical matrix elements (velocity or momentum) between
			single particle states.
	epsdiag.dat	Diagonal elements of dielectric matrix on the q-grid.
			Must be consistent with epsmat and eps0mat.
	eigenvalues.dat	Contains electron-hole eigenvalues and transition matrix elements.


-----------------------------------------------------------------

	absorption.inp	Please see example absorption.inp in this directory
			for more complete options.

-----------------------------------------------------------------

Output Files:

	eigenvalues.dat	  	Has eigenvalues/transition matrix elements of e-h states,
			  	eigenvalues in eV, mtxels in atomic units.
	eigenvalues_noeh.dat	As above but for non-interacting e-h transitions, showing
                                k-point, bands, and spin for each.
	eigenvectors	  	Has the excitonic wavefunctions in Bloch space: A_svck 
	absorption_eh.dat	Dielectric function and density of excitonic states.
			  	Four Columns
			  	energy (in eV) | epsilon_2 | epsilon_1 | DOS
			 	DOS is normalized (\int (DOS) d(omega) = 1)
	absorption_noeh.dat	Non-interacting (RPA) dielectric function and joint density
				of states.  Four columns:
				energy (in eV) | epsilon_2 | epsilon_1 | JDOS
				JDOS is normalized (\int (JDOS) d(omega) = 1)
        dvmat_norm.dat		The norms of the dvv overlap matrices between the valence 
                        	band k on the fine grid and the closest k-point on the coarse grid
        dcmat_norm.dat		The norms of the dcc overlap matrices between the conduction
                        	band k on the fine grid and the closest k-point on the coarse grid
	eqp.dat, eqp_q.dat      Quasiparticle corrections for WFN_fi and WFNq_fi interpolated from
                                the coarse grid if eqp_co_corrections is used.
        bandstructure.dat       Same as eqp.dat and eqp_q.dat but in a format suitable for plotting
                                as a bandstructure.

-----------------------------------------------------------------

Tricks and hints:

1. To optimize distribution of work among PEs, choose the number of
PEs so that Nk*Nc*Nv in the fine grid is a multiple of the
number of PEs. The parallelization is first done over over k-points.

2. The Brillouin zone is built using a Wigner-Seitz construction;
this way the head matrix elements are easily calculated.

3. Check if the transformation matrices have norm close to 1! They
are usually normalized (look at the end of intwfn.f90). The norms are in
the files dvmat_norm.dat and dcmat_norm.dat.
 
4. Unfolding of irreducible BZ: if you want to skip the unfolding and
use the set of k-points in WFN_fi as a sampling of the whole BZ, specify
the no_symmetries_* options in absorption.inp.

5. The "number_eigenvalues" keyword: using this keyword tells the code 
to store only the first nn eigenvalues/eigenvectors. So far, this option 
is implemented only with the SCALAPACK diagonalization routines. 

6.  Analyzing eigenvectors.  We have a tool called summarize_eigenvectors to read in
and analyze eigenvectors for a group of exciton states.  For specific states
specified, it sums the total contribution from each k-point.
Please see the example input summarize_eigenvectors.inp.

-----------------------------------------------------------------
----------  GW code, Epsilon  -----------------------------------
-----------------------------------------------------------------

  Version 1.1   (June, 2014)

  Version 1.0	(September, 2011)
  Version 0.5	J. Deslippe, D. Prendergast, L. Yang, F. Ribeiro, G. Samsonidze (2008)
  Version 0.2	S. Ismail-Beigi (2002)
  Version 0.1	G. M. Rignanese, E. Chang, X. Blase  (1998)
  Version 0.0	M. Hybertsen (1985)

-----------------------------------------------------------------

Description:

Epsilon is the name of the code that generates the polarizability matrix and 
the inverse dielectric matrix for a bulk or nanoscale system. The main 
result of the Epsilon code is the generation of epsmat which can be used
in a Sigma or BSE calculation.

-----------------------------------------------------------------

Required Input:

	epsilon.inp	Input parameters. See example in this directory. 
	WFN		This is linked to the unshifted grid. 
	WFNq		This is linked to the shifted grid.
			When a shift is not required, this can be the same file as WFN
			(i.e. for semiconductor or graphene screening with spherical or
			box truncation).

Auxiliary Files: (output files from previous runs, used as input to speed up calculation)

	chimat		Polarizability matrix. No need to recalculate matrix elements.
	chi0mat		Polarizability matrix at q=0. No need to recalculate matrix elements.

        The files below are used if eqp_corrections is set in epsilon.inp.
        The corrected eigenvalues are used for constructing the polarizability matrix.
        eqp.dat         A list of quasiparticle energy corrections for the bands in WFN.
        eqp_q.dat       A list of quasiparticle energy corrections for the bands in WFNq.

-----------------------------------------------------------------

	epsilon.inp	Please see example epsilon.inp in this directory
			for more complete options.

-----------------------------------------------------------------

Output Files: 
	
	espmat			Inverse dielectric matrix (q<>0).
	eps0mat			Inverse dielectric matrix (q->0).

        or

        espmat.h5		Equivalent of above when using HDF5
        eps0mat.h5		For specification, see epsmat.h5.spec

	epsilon.log		The log file containing values of chimat and epsmat.
        chi_converge.dat	Convergence chi with respect to empty orbitals.
                                Columns: number of conduction bands,
                                Re chi(G=0,G'=0,q),     extrapolated Re chi(G=0,G'=0,q),
				Re chi(G=Max,G'=Max,q), extrapolated Re chi(G=Max,G'=Max,q)

-----------------------------------------------------------------

Tricks and hints:

1. Comments on convergence of epsilon_cutoff

There are many ways to check convergence of this parameter:

-Ideally, the inverse epsilon matrix is almost diagonal for large 
G vectors. So, for small ( G , G' ) it is usually large but, for 
 G or G' close to G_max, it is smaller by a factor of 100, more or 
less. Check if the ratio between the greatest and lowest matrix 
elements is large.

-Alternatively, one can check if epsinv( G_max , G'_max ) is close 
to 1 for G = G'. It should be about 0.999 or so. Note that 0.9 isn't 
"close to 1" in this case! Also check if epsinv( G_max , G'_max ) is 
indeed small for G != G'.

2. Comments on the null point

The null point (Gamma point) is treated in a special manner. In input, 
declare it as slightly shifted from the true Gamma point:

  0.0000    0.0050    0.0050   1.0   1

This is the only k-point with itestq=1 instead of 0!

The magnitude of this vector must be small: of order 0.01 or smaller 
for less than 100 points in full Brillouin zone. If the density 
of points in BZ increases, that magnitude should decrease accordingly.

3. Macroscopic dielectric constant

In GW, the screened interaction gives the formula:

  eps(G,G';q) = delta_GG' - [4pi e^2/(q+G)^2 ] chi(G,G';q) 

where chi(G,G';q) is the polarizability (P in the literature).

  if G=0  and q=0

  then we let

   eps(0,G';q) = delta_0G' - lim(q->0) [4pi/(q)^2] chi(0,G';q)

always check chi(0,0;q->0) and eps^(-1)(0,0;q->0)
in epsilon.log

1/eps^(-1)(0,0;q->) should be the macroscopic epsilon, 
                    local-field effects
1/(1-4*pi*chi(0,0;q->0)*V_c(0) should also be (roughly) the macroscopic epsilon,
                              without local-field effects

4. Merging epsmat files

The Epsilon code is complicated and involves lots of computation. Frequently, 
it is useful to calculate the epsilon matrix for a small number 
of q-points, and later put all those pieces of matrix into a big
epsmat file. Use epsmat_merge to do this. See below.

Notes:
-epsilon cutoff *must* be the same for all files to be merged
-The ordering of q-points in the input file must correspond to the ordering of
epsmat files: the first file has the first set of points, the second file 
has the second and so on.

5. Utilities:

----------------------------------------------------------------------
---------  epsmat, eps0mat binary/ASCII conversion  ------------------
----------------------------------------------------------------------

TOOLS: epsbinasc, epsascbin

USAGE: simply type name of executable. 

The input file is named epsconv.inp.

----------------------------------------------------------------------
--------  WFN/RHO/VXC binary/ASCII conversion ------------------------
----------------------------------------------------------------------

TOOL: mf_convert_wrapper.sh

USAGE: ./mf_convert_wrapper.sh infile outfile

Real/complex, bin/asc, file type, is automatically detected.

----------------------------------------------------------------------
---------  epsmat merging  -------------------------------------------
----------------------------------------------------------------------

TOOL: epsmat_merge

USAGE: epsmat_merge.[real/cplx].x

Merges the content of multiple binary epsmat files into an output file
called 'epsmat', concatenating data. See input file epsmat_merge.inp,
for specification of cutoff, q-points, and input epsmat filenames.

-----------------------------------------------------------------
----------  MeanField -------------------------------------------
-----------------------------------------------------------------

Description:

BerkeleyGW uses a mean-field starting point, typically from DFT.
Currently, BerkeleyGW supports two plane-wave DFT codes, 
PARATEC and Quantum ESPRESSO; one localized-orbital DFT code, SIESTA;
and two real-space codes, Octopus and PARSEC. 
You can find details on how to use BerkeleyGW with these codes in
their respective directories.

For testing purposes and for crude calculations of large systems,
BerkeleyGW can be executed on top of the empirical pseudopotential
plane-wave code. See MeanField/EPM for details.

There is a tool for generating large numbers of unoccupied orbitals
(approximate from plane waves or exact by iterative diagonalization).
It is located in MeanField/SAPO.

You can find a simple code for computing the Coulomb integral within
an image-charge model in MeanField/ICM.

-----------------------------------------------------------------

Tricks and hints:

1. Vxc0

Vxc0 is the G=0 component of the exchange-correlation potential Vxc. 
Vxc0 is added to the eigenvalues in the wavefunction files produced 
by PARATEC and ESPRESSO. Vxc0 is also included in the VXC and vxc.dat 
files produced by PARATEC and ESPRESSO (the VXC file contains Vxc(G) 
and the vxc.dat file contains matrix elements of Vxc). The two Vxc0 
terms cancel out when calculating the quasiparticle corrections 
in the Sigma code.

2. Vacuum level

To correct the DFT eigenvalues for the vacuum level take the average 
of the electrostatic potential on the faces of the unit cell in the 
non-periodic directions and subtract it from the DFT eigenvalues. 
The electrostatic potential is defined as Velec = Vbare + Vhartree, 
while the total potential is Vtot = Vbare + Vhartree + Vxc, hence 
Vtot contains Vxc0 and Velec does not. The average of Velec is 
fed into the Sigma code using keywords avgpot and avgpot_outer. 
The potentials can be generated with PARATEC and ESPRESSO. 
In PARATEC, use elecplot for Velec or potplot for Vtot, then 
convert from a3dr to cube using the Visual/volume.py script. 
In ESPRESSO, use iflag=3, output_format=6, and plot_num=11 
for Velec or plot_num=1 for Vtot. The averaging is done with 
the Visual/average.py script.

3. Unit cell size

If you truncate the Coulomb interaction, make sure that the size 
of the unit cell in non-periodic directions is at least two times 
larger than the size of the charge distribution. This is needed 
to avoid spurious interactions between periodic replicas but at 
the same time not to alter interactions within the same unit cell. 
Run Visual/surface.x to plot an isosurface that contains 99% of the 
charge density (see Visual/README for instructions on how to do this). 
The code will print the size of the box that contains the isosurface 
to stdout. Multiply the box dimensions in non-periodic directions 
by two to get the minimum size of the unit cell.

4. Inversion symmetry

When using the real flavor of the code, make sure the inversion 
symmetry has no associated fractional translation (if it does, 
shift the coordinate origin). Otherwise WFN, VXC, RHO (and VSC 
in SAPO) have non-vanishing imaginary parts which are simply 
dropped in the real flavor of the code. This won't do any 
good to your calculation...

-----------------------------------------------------------------
----------  BerkeleyGW, Common  ---------------------------------
-----------------------------------------------------------------

  Version 2.2	(July, 2008)
  J. Deslippe, G. Samsonidze, L. Yang, F. Ribeiro

-----------------------------------------------------------------

Description:

This directory contains common files shared by different components of 
the BerkeleyGW package. The most important files are described below:

1. typedefs.f90

This file contains the derived data types that are used throughout 
the code.

2. nrtype.f90

This file contains some general constants and the definitions of 
single- and double-precision real and complex types following the 
convention of the Numerical Recipes book. The definitions of DP 
and DPC are used throughout the code.

It also contains the fundamental physical constants. The units used 
throughout the code are Rydberg atomic units with a few exceptions, 
such as eV in Sigma and Hartree atomic units in EPM. The difference 
between Hartree and Rydberg atomic units is sketched below.

Hartree atomic units:
hbar=1  e=1        m=1    a0=hbar^2/(m*e^2)=1  E=hbar^2/(2*m*a0^2)=0.5

Rydberg atomic units:
hbar=1  e=sqrt(2)  m=0.5  a0=hbar^2/(m*e^2)=1  E=hbar^2/(2*m*a0^2)=1

3. f_defs.h

This file contains preprocessor definitions for the built-in Fortran 
functions. This helps to avoid accidental conversion from double to 
single precision.

An example siesta2bgw calculation is provided in examples/DFT/benzene. 
Please see this example for usage and example siesta and denchar input
files.

The SIESTA wrapper reads lattice vectors, atomic species and
positions from SystemLabel.XV file, k-points from SystemLabel.KP
file, eigenvalues from SystemLabel.EIG file, wavefunctions in R-space
from SystemLabel{.K$k}.WF$n{.UP|.DOWN}{.REAL|.IMAG}.cube file, symmetry
group, kinetic energy cutoffs for wavefunctions and charge density,
k-grid dimensions and offsets from the input file, generates reciprocal
lattice vectors, rotation matrices, fractional translations, FFT grid and
G-vectors, performs FFT from R-space to G-space, and writes the selected
range of bands to the output WFN file. Make sure to set up the real
space grid in SIESTA/DENCHAR utility same as FFT grid. If the two grids
differ the SIESTA wrapper will return an error. The output WFN file
can be used as an auxiliary wavefunction for the SAPO code.

A full GW/BSE calculation with SIESTA wavefunctions also requires RHO and 
VXC files. These files can be generated from SystemLabel.RHO{.UP|.DN}.cube, 
SystemLabel.VT{.UP|.DN}.cube and SystemLabel.VH.cube files obtained with 
SIESTA/GRID2CUBE utility on SIESTA real space grid. Make sure SIESTA real 
space grid is equivalent to FFT grid by setting parameter MeshCutoff 
in SIESTA input file same as kinetic energy cutoff for charge density.

Input is read from file siesta2bgw.inp:

&input_siesta2bgw
   systemlabel      = 'ammonia'
   wfng_output_file = 'wfng.lo'
   rhog_output_file = ''
   vxcg_output_file = ''
   ecutwfn          = 60.0
   ecutrho          = 240.0
   wfng_nk1         = 1
   wfng_nk2         = 1
   wfng_nk3         = 1
   wfng_dk1         = 0.0
   wfng_dk2         = 0.0
   wfng_dk3         = 0.0
   wfng_ref_flag    = .true.
   wfng_ref_kpoint  = 1
   wfng_ref_spin    = 1
   wfng_ref_band    = 4
   wfng_ref_energy  = -5.87
   wfng_band_flag   = .true.
   wfng_band_min    = 5
   wfng_band_max    = 28
   wfng_energy_flag = .false.
   wfng_energy_min  = 0.0
   wfng_energy_max  = 0.0
   wfng_gamma_real  = .true.
/

Here, lattice vectors, k-points, eigenvalues and wavefunctions in R-space 
are read from ammonia.XV, ammonia.KP, ammonia.EIG and ammonia.WF$n.cube 
files, respectively. The kinetic-energy cutoffs for 
wavefunction and charge density are set to 60 and 240 Ry, respectively. 
The k-grid is set to the Gamma-point. The SIESTA eigenvalues are shifted 
in energy so that the HOMO state (1st k-point, 1st spin, 4th band) appears 
at -5.87 eV. The real parts of resonant SIESTA wavefunctions (from 5th to 
28th band) are read from Gaussian Cube files and the imaginary parts are 
set to zero (wfng_gamma_real), the wavefunctions are brought from R-space 
to G-space and written to wfng.lo file. The SIESTA charge density and 
exchange-correlation potential files are not generated.

================================================================================

"The empirical pseudopotential method never lost a battle to experiment."
-- Marvin Cohen, 2008

================================================================================

EPM stands for Empirical Pseudopotential Method. It is the plane-wave 
part of TBPW-1.1 modified to generate input files for BerkeleyGW. 
Numerous other corrections and improvements have also been made
by Georgy Samsonidze and David Strubbe.
TBPW-1.1 is available for download from http://www.mcc.uiuc.edu/software/

The input variables are described in epm.inp. Most variables are common to both
epm.x and epm2bgw.x, but a few are just for one or the other.

The real wavefunctions for systems with inversion symmetry 
are obtained by applying the Gram-Schmidt process adapted from 
paratecSGL-1.1.3/src/para/gwreal.f90

To plot silicon band structure calculated with the EPM executable:
% epm.x < silicon-epm.in
% gnuplot bands.plt
Uses variables NumberOfLines, NumberOfDivisions, KPointsAndLabels.

To use the explicit form factors and to compute the band gap and 
the effective masses (mass only correct for Si-like band structures):
% epm.x < silicon-epm-ff.in
Uses variables gap_flag, gap_file, mass_flag, mass_file.

To generate input files for BerkeleyGW executable, use epm2bgw.x.
The scripts epm2bgw_cplx.sh and epm2bgw_cplx_spin.sh are just for use
with the testsuite. They force complex, or complex and spin-polarized.

You can find the actual input files for GW/BSE calculations on top of 
EPM in directory examples/EPM, as well as testsuite directories
Si-EPM, GaAs-EPM, and Si-Wire-EPM.

The k-points for the EPM input files can be generated using utility 
kgrid. Please refer to file MeanField/ESPRESSO/README for details.

Virtual crystal approximation (VCA) is implemented within EPM in 
the form of two pre-processing scripts, ff2vq.py and vca.py.

ff2vq.py reads EPM form factors from file form_factors.dat, fits them 
to the chosen functional form of the V(q) potential, writes potential 
coefficients to file v_of_q.dat, and writes new form factors computed 
from V(q) to file vq2ff.dat. This procedure is described by equations 
(8) and (9) and the accompanying text in Phys. Rev. B 84, 195201 (2011).

vca.py reads V(q) potential coefficients from file v_of_q.dat, 
employs the virtual crystal approximation to compute hybrid form 
factors, and writes them to file vca_ff.dat. The potential mixing 
is controlled by identifiers host_material and doping_level hard 
coded below. This procedure is described by equations (10) -- (12) 
and the accompanying text in Phys. Rev. B 84, 195201 (2011).

The original form factors from file form_factors.dat or the hybrid 
ones from file vca_ff.dat can be fed to epm.x and epm2bgw.x using 
keywords LatticeConstant and FormFactors in the input file for epm.x 
or epm2bgw.x. See example of using these keywords in silicon-epm-ff.in.

The README file of TBPW-1.1 follows below.

================================================================================

TBPW-1.1

========================================

Author/Affiliation

--------------------

 * Dyutiman Das, UIUC
 * William Mattson, UIUC
 * Nichols A. Romero, UIUC
 * Richard M. Martin, UIUC

========================================

Author email

--------------------

nromero@uiuc.edu

========================================

Description of Software

--------------------

TBPW is an electronic structure code primarily intended for pedagogical purposes. It is written from the ground-up in a modular style using Fortran 90. This code is composed of two distinct parts: a tightbinding (TB) and plane wave (PW). Additionally, there is a plane wave density (PWD) code which outputs the electron density on a grid.

The main characteristics of these codes are:

 * Readily provides band structure plots
 * TB implemented using a rotation matrix formalism allows the use of orbitals with arbitrary angular momentum l
 * PW implemented using the option of diagonalisation via direct-inversion

Send email to tbpw-subscribe@mcc.uiuc.edu to subscribe to the mailing list, tbpw@mcc.uiuc.edu

This material is based upon work supported by the NSF under Award No. 99-76550 and the DOE under Award No. DEFG-96-ER45439

========================================

Submitted

--------------------

2003-01-31

========================================

Disclaimer

--------------------

Developed by Electronic Structure Group, University of Illinois, Department of Physics, http://www.physics.uiuc.edu/research/ElectronicStructure/ Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the Software), to deal with the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimers.
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimers in the documentation and/or other materials provided with the distribution.
 * Neither the names of the Electronic Structure Group, the University of Illinois, nor the names of its contributors may be used to endorse or promote products derived from this Software without specific prior written permission.

THE SOFTWARE IS PROVIDED AS IS, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.

========================================

Copyright

--------------------

University of Illinois Open Source License. Copyright (c) 2003, University of Illinois Board of Trustees. All rights reserved. Users also agree to terms of License Agreement available at http://www.mcc.uiuc.edu/

================================================================================

This program reads the wavefunction file in Gaussian Cube or 
XCrySDen XSF format and computes the Coulomb integral within 
an image charge model.

It is based on Visual/surface.cpp code, so the input parameter 
file formats for the two codes are quite similar. You can find 
more details in Visual/surface.inp and Visual/README.

Input is read from file icm.inp:

inputfilename C6H6.b_15.cube
inputfileformat cube
threshold 0.99
threshold_power 1
coulomb_power 1
mirrorplaneorigin
0.0 0.0 -2.0
mirrorplanenormal
0.0 0.0 1.0
mirrorplaneunit angstrom
uc F
uco
0.0 0.0 0.0
ucv
1.0 0.0 0.0
0.0 1.0 0.0
0.0 0.0 1.0
ucu latvec
sc T
sco
-0.5 -0.5 -0.5
scv
1.0 0.0 0.0
0.0 1.0 0.0
0.0 0.0 1.0
scu latvec

In the above example, the HOMO wavefunction of benzene is read from 
Gaussian Cube file. The wavefunction is placed in the center of the 
supercell (see the meaning of uc, uco, ucv, ucu, sc, sco, scv, scu
parameters in Visual/surface.cpp). The parts of the wavefunction 
outside an isosurface that contains 99% of the charge density are 
dropped (parameters threshold and threshold_power have the same 
meaning as isovalue and power in Visual/surface.cpp). Parameter 
coulomb_power tells the code whether the wavefunction in the Coulomb 
integral needs to be squared. Set both powers to 1 if the wavefunction 
file contains the squared amplitude as produced by ESPRESSO, and to 2 
for the linear amplitude as in PARATEC or SIESTA. The mirror plane 
is defined by parameters mirrorplaneorigin and mirrorplanenormal, 
in the above example it is parallel to the xy plane crossing the 
z axis at -2 Angstrom. Problems may occur with non-orthogonal unit cells;
use of cubic cells is recommended.

Quantum ESPRESSO is available for download at http://www.quantum-espresso.org/

The interface between Quantum ESPRESSO and BerkeleyGW consists of three programs, 
kgrid.x, pw2bgw.x and bgw2pw.x. kgrid.x is compiled with BerkeleyGW package and 
pw2bgw.x and bgw2pw.x are compiled with Quantum ESPRESSO. 
Files for versions 4.3.2, 5.0.x, and 5.1.x are supplied here. 
Starting with version 5.0, compatible files of pw2bgw.f90 and bgw2pw.f90 are 
distributed with Quantum ESPRESSO.

If you are using espresso-5.1, apply a patch following the
instructions in BerkeleyGW/MeanField/ESPRESSO/version-5.1/README_patch.
Alternatively, you can use BerkeleyGW/MeanField/ESPRESSO/version-5.1/pw2bgw.f90
(rather than espresso-5.1/PP/src/pw2bgw.f90), which includes a bugfix to
the problem of an immediate segmentation fault or error
saying 'MPI_Comm_rank: Invalid communicator'. To use:
cp BerkeleyGW/MeanField/ESPRESSO/version-5.1/pw2bgw.f90 espresso-5.1/PP/src/
Then 'make pp' in espresso. This seems to happen for MPICH and MVAPICH (and
probably the related IntelMPI) but not OpenMPI, but the updated version should work
in all cases.

The development versions of pw2bgw.f90 and bgw2pw.f90 are available from 
Quantum ESPRESSO trunk. Quantum ESPRESSO allows anonymous checkouts of its 
source code. Use the command below and use 'anonymous' as the username and 
a blank password to checkout the code: 
svn checkout http://qeforge.qe-forge.org/svn/q-e/trunk/espresso

You can find more details about Quantum ESPRESSO svn on this website: 
http://www.qe-forge.org/gf/project/q-e/scmsvn/

--------------------------------------------------------------------------------

kgrid.x

pw.x can automatically generate a uniform grid of k-points, either unshifted 
or shifted by half a grid step (Monkhorst-Pack grid), and reduce it to the 
irreducible wedge of the Brillouin Zone with the symmetries of the point group 
of the Bravais lattice and optionally with time-reversal symmetry. The same 
functionality (and more) is provided by kgrid.x in this directory. Additionally, 
kgrid.x can use the symmetries of the space group of the crystal instead of the 
symmetries of the point group of Bravais lattice, which is needed for BerkeleyGW. 
kgrid.x is not limited to the unshifted/half-step shifted Monkhorst-Pack grids. 
It can generate an asymmetrically shifted fine grid used to improve the 
convergence in absorption calculations. Also, kgrid.x can generate a grid 
of k-points with a small q-shift used in Epsilon calculation to avoid the 
divergence of the Coulomb interaction. The list of k-points generated by 
kgrid.x must be manually added to the input file of pw.x. Note that time-reversal
symmetry should NOT be used for BerkeleyGW (noinv = .false. if generating the
k-grid in pw.x), unless the utility wfn_time_reversal.x is run afterward.

The format of the input file for kgrid.x (along with an example for Si) is found 
in kgrid.inp. See also more information in the header of kgrid.f90. You can find 
the input files for kgrid.x in examples/DFT in the ESPRESSO subdirectories of 
each example.

--------------------------------------------------------------------------------

pw2bgw.x

Converts the output files produced by pw.x to the input files for BerkeleyGW.

You cannot use USPP, PAW, or spinors in a pw.x run for BerkeleyGW.

You cannot use "K_POINTS gamma" in a pw.x run for BerkeleyGW. 
Use "K_POINTS { tpiba | automatic | crystal }" even for the 
Gamma-point calculation.

The format of the input file for pw2bgw.x is described 
in files MeanField/ESPRESSO/version-4.3.2/pw2bgw.inp,
MeanField/ESPRESSO/version-5.1/INPUT_pw2bgw.html (copy of espresso-5.1/PP/Doc/INPUT_pw2bgw.html),
which is generated from MeanField/ESPRESSO/version-5.1/INPUT_pw2bgw.def, and
MeanField/ESPRESSO/version-5.0/INPUT_pw2bgw.html (copy of espresso-5.0.3/PP/Doc/INPUT_pw2bgw.html),
which is generated from MeanField/ESPRESSO/version-5.0/INPUT_pw2bgw.def. 
You can find the input files for pw2bgw.x in examples/DFT 
in the ESPRESSO subdirectories of each example.

Version 4.3.2 and earlier:

It is recommended to run a pw.x "nscf" calculation with "K_POINTS crystal" 
and a list of k-points produced by kgrid.x.

Sometimes pw.x generates additional k-points in a "nscf" run with an explicit 
list of k-points. If this is the case for your calculation, there are several 
ways to go around this problem:

* Apply the patch provided with BerkeleyGW. It will prevent pw.x from 
  generating additional k-points if they are provided explicitly, and 
  take care of the normalization of the weights of k-points in a "bands" 
  calculation. 
* Do not specify the atomic positions in the input file of kgrid.x (set 
  number of atoms = 0). Then pw.x will generate additional k-points which 
  are the correct ones. Also set noinv = .true. in the input file of pw.x 
  if time-reversal symmetry was not used in kgrid.x. 
* Run a pw.x "bands" calculation instead of "nscf". In this case you have 
  to explicitly specify the occupations in the input file of pw2bgw.x (note 
  that this only works for insulators) and to normalize the weights of 
  k-points to one in the input file of pw.x.

Version 5.0 and later:

It is recommended to run a pw.x "bands" calculation with "K_POINTS crystal" 
and a list of k-points produced by kgrid.x.

You can also run a pw.x "nscf" calculation instead of "bands", but in this 
case pw.x may generate more k-points than provided in the input file of pw.x. 
If this is the case for your calculation you will get errors in BerkeleyGW.

--------------------------------------------------------------------------------

bgw2pw.x

Converts BerkeleyGW WFN and RHO files to the format of pw.x. 
This can be useful, for example, if you generate the plane waves 
on top of the valence bands and want to diagonalize them in pw.x. 
Look at the documentation for SAPO code in BerkeleyGW for more information.
Another possible use is to convert between different versions of pw.x.

bgw2pw.x reads common parameters from file prefix.save/data-file.xml and 
writes files prefix.save/charge-density.dat (charge density in R-space), 
prefix.save/gvectors.dat (G-vectors for charge density and potential), 
prefix.save/K$n/eigenval.xml (eigenvalues and occupations for nth k-point), 
prefix.save/K$n/evc.dat (wavefunctions in G-space for nth k-point), and 
prefix.save/K$n/gkvectors.dat (G-vectors for nth k-point).

You must have prefix.save/K$n/eigenval.xml files present, or an error will occur,
even though their contents will not be used and will be overwritten.
The best is to run a pw.x calculation and use its prefix.save, e.g. from scf
and then get unoccupied bands from bgw2pw.x.

bgw2pw.x doesn't create restart files, so you cannot use restart_mode = 'restart'
for a subsequent pw.x run. Instead, use startingwfc = 'file'. Make sure
wf_collect = .true. and there are no prefix.wfc* files present. Also, the pw.x run
that generated the prefix.save directory originally must have wf_collect = .true.
also, for the appropriate links to the K$n files to be present.

bgw2pw.x doesn't modify file prefix.save/data-file.xml so make changes to this 
file manually. For example, you will need to change the NUMBER_OF_BANDS and
NUMBER_OF_PROCESSORS tags (as well as per pool and per image) to make sure these
match the number of bands from the WFN file, as well as the number of processors
you will use in a subsequent run.

The format of the input file for bgw2pw.x is described 
in files MeanField/ESPRESSO/version-4.3.2/bgw2pw.inp,
MeanField/ESPRESSO/version-5.1/INPUT_bgw2pw.html (copy of espresso-5.1/PP/Doc/INPUT_bgw2pw.html),
which is generated from MeanField/ESPRESSO/version-5.1/INPUT_bgw2pw.def, and
MeanField/ESPRESSO/version-5.0/INPUT_bgw2pw.html (copy of espresso-5.0.3/PP/Doc/INPUT_bgw2pw.html),
which is generated from MeanField/ESPRESSO/version-5.0/INPUT_bgw2pw.def.

--------------------------------------------------------------------------------

Notes on running pw.x

Sometimes pw.x crashes when trying to generate a LARGE number of unoccupied 
states needed for GW calculations. The error messages may refer to "Cholesky 
decomposition" or "diagonalization". If you run into this problem try one of 
the following workarounds, or a combination of them:

1) Increase ecutwfc. Iterative diagonalization becomes inefficient and 
unstable with increasing the ratio of the number of states to the size 
of the Hamiltonian. Increasing ecutwfc will decrease this ratio 
at the cost of computation time.

2) Split the calculation over k-points. If one k-point fails, it won't 
affect the other k-points. You can merge the final wavefunction file 
using MeanField/Utilities/wfnmerge.x after running pw2bgw.x for each 
k-point.

3) Start with random instead of randomized atomic wavefunctions. For 
this use the following parameter in the input file of pw.x:

    startingwfc = 'random'

4) Split the diagonalization into several steps alternating between 
different diagonalization schemes. For example, use the following 
parameters in the input files for consequent runs of pw.x:

    1st run:
        conv_thr = 1.0d-2
        diagonalization = 'david'

    2nd run:
        conv_thr = 1.0d-4
        diagonalization = 'cg'
        startingwfc = 'file'

    3rd run:
        conv_thr = 1.0d-6
        diagonalization = 'david'
        startingwfc = 'file'

    etc.

5) Run pw.x with "-ndiag 1". Often serial diagonalization is more 
stable than the parallel one, and the time and memory overhead 
is bearable in most cases.

6) Compile pw.x without "-D__SCALAPACK" in DFLAGS in make.sys 
for using a custom distributed-memory diagonalization instead 
of ScaLAPACK. This is useful to check if the problem 
is caused by improper installation of ScaLAPACK. 
Note that you will have to explicitly specify ndiag, 
e.g. "mpirun -np 24 pw.x -ndiag 16 -in prefix.in > prefix.out", 
because pw.x only sets ndiag automatically in case of ScaLAPACK.

7) Last but not least, perform iterative diagonalization 
in SAPO instead of using pw.x, see examples/DFT/Si2_sapo 
for details.

Finally, it is recommended to always use the following parameters 
in the input files for pw.x:

    wf_collect = .true.
    diago_full_acc = .true.

See documentation on Quantum ESPRESSO for information on these 
parameters.

BEWARE: Sometimes wavefunctions may lose orthogonality during 
iterative diagonalization. Neither Quantum ESPRESSO nor BerkeleyGW 
checks for orthogonality of wavefunctions. This may cause erroneous 
behavior like diverging head of eps0mat and possibly many other things. 
This problem could be avoided by using SAPO [see 7) above] which keeps 
wavefunctions orthogonal during iterative diagonalization.

Octopus is a real-space DFT and TDDFT code available under the GPL from http://www.tddft.org/programs/octopus.
Support for BerkeleyGW output is implemented in Octopus since version 4.1.0.
For more information, see the Octopus wiki: http://www.tddft.org/programs/octopus/wiki/index.php/BerkeleyGW.

-----------------------------------------------------------------
----------  MeanField Utilities  --------------------------------
-----------------------------------------------------------------

degeneracy_check.x:

  Determine which numbers of bands do not break a degenerate subspace, to avoid warnings or
  errors in Epsilon, Sigma, and BSE codes. Supply any number of binary WFN files as command-
  line arguments, and a list of numbers that are acceptable for all k-points in all files
  will be written to standard output.

mf_convert_wrapper.sh:

  Converts WFN/RHO/VXC files between binary and ASCII. This can be useful for moving files
  correctly between big- and little-endian machines, or for examining the contents of a
  file (though wfn_rho_vxc_info.x is more user-friendly). Using this wrapper script, the
  flavor (real/complex), type of file, and binary/ASCII is determined automatically.

wfn_rho_vxc_info.x:

  Prints the contents of the header of a (binary) WFN, RHO, or VXC file in a clearly labeled
  format, for human inspection.

wfnmerge.x:

  Merges many WFN files into one. It assumes that all input files have the 
  same number and same ordering of G-vectors for the charge density.
  The number and name of input files is read from "wfnmerge.inp", as well
  is the kgrid and the kshift.
 
  FAQ:
  Q: Why would someone want to use this?
  A: For example, maybe to do a converged calculation one needs to include a
      large number of unoccupied states. There may not be the resources (either
      CPUs or wallclock) to do this all in one shot, so it may be beneficial to
      split up a calculation of kpoints (e.g., 4x4x4 MP grid) into smaller
      pieces and then add up the final wavefunctions.
  Q: What is the deal with kpoint weights?
  A: Quantum Espresso renormalizes the kpoint weights that you use in a 
     calculation. If you are splitting up a MP grid into different groups of 
     kpoints, and each group is normalized, the relative weights between
     kpoints in different groups is no longer correct. BerkeleyGW does not 
     make use of the kpoint weights (except for in determining whether the 
     Fermi level is reasonable for metallic calculations). So for most uses
     the fact that these weights are incorrect does not matter. If it matters
     to you, you can simply modify wfnmerge to read in the kpoint weights of
     your choosing.

convert_old_to_new.x:

  Convert wavefunction, density, and exchange-correlation potential files from the old
  CWFE(q)/CD95/VXC formats (used in the pre-1.0 version of the code prior to June 2011)
  to the current WFN/RHO/VXC formats. Some additional information is required which was not
  available in the old files, so an input file convert_old_to_new.inp is required. See the
  example in this directory. Input and output files are both binary.

scissors2eqpx:

  Write an eqp.dat file based on a WFN file and scissors parameters.
  For testing equivalence of eqp_corrections and scissors.

fix_occ.x:

  Fix the occupations of a WFN file. This is useful if you have split a
  large nscf calculations into smaller blocks, and you want the occupations
  of the merged WFN to be consistent. It can also fix inconsistencies in the
  occupations and in the Fermi energy for metals.

wfn_dotproduct.x

  Form the overlap between the bands in two wavefunction files.
  If they are copies of the same file, you can check orthonormality.
  Only bands at corresponding k-points are considered, since
  the overlap is zero by Bloch`s theorem if the k-points differ.
  Warning: a known issue is possible errors from gmap when relating
  k-points by symmetry operations.

wfn_time_reversal.x

  Give a WFN file with a k-grid reduced by time-reversal symmetry, and get a new WFN file
  with the k-points unfolded by time-reversal symmetry. This can save up to half the time
  in the non-self-consistent DFT calculations for input to BerkeleyGW. It can be used
  after calculating k-points from kgrid.x with time-reversal symmetry, or from 'automatic'
  k-points from Quantum ESPRESSO. Either use VXC, or add the new k-points to vxc.dat by
  hand according to the rule <n,-k|Vxc|m,-k> = <n,k|Vxc|m,k>*.

paratecSGL is available for download through SVN repository at 
https://civet.berkeley.edu/svn/CODES/paratecSGL/
(only for authorized users).

To build with support for BerkeleyGW output, in arch.mk set the
line GWWFNPATH to BerkeleyGW/library, and add -DBGW to M4OPTLIBS.

Full documentation for PARATEC 5.1:
http://www.tcm.phy.cam.ac.uk/~jry20/paratec/doc/doc.html

Literature:
* B. G. Pfrommer, J. Demmel, and H. Simon, "Unconstrained Energy Functionals
  for Electronic Structure Calculations," J. Comp. Phys. 150, 287 (1999).
* B. G. Pfrommer, M. Cote, S. G. Louie, and M. L. Cohen, "Relaxation of
  Crystals with the Quasi-Newton Method," J. Comp. Phys. 131, 233 (1997).
* Mathieu Taillefumier, Delphine Cabaret, Anne-Marie Flank, and Francesco
  Mauri, "X-ray absorption near-edge structure calculations with
  pseudopotentials: Application to the K-edge in diamond and alpha-quartz,"
  Phys. Rev. B 66, 195107 (2002).
* http://cmsn.drupalgardens.com/sites/cmsn.drupalgardens.com/files/CMSN_Newsletter_Vol2No2.pdf

[An older version was available at http://www.nersc.gov/projects/paratec.
PARATEC 5.1 produces only the old GW wavefunction format, incompatible
with this version of BerkeleyGW. However, you can convert them to the
new format using MeanField/Utilities/convert_old_to_new.x.]

The pseudopotentials for PARATEC can be generated with 
the fhi98PP program which is available for download at 
http://www.fhi-berlin.mpg.de/th/fhi98md/fhi98PP/

PARATEC output for BerkeleyGW is controlled by flags 
gw_shift, gwc, gwr, gwscreening, gwcscreening, and vxc_matrix_elements.
The flags can be combined with an underscore: e.g. output_flags gwr_gwscreening
gwr and gwc are incompatible; gwscreening and gwcscreening are incompatible.

gw_shift q1 q2 q3
 -- generates q-shifted grid, q-vector is in crystal coordinates
    in units of reciprocal lattice vectors (for WFNq, WFNq_fi)
    This variable does the same job as the kgrid.x utility.

output_flags gwc
 -- writes complex wavefunctions in G-space, for systems without
    inversion symmetry about the origin, to file WFN (for all codes).

output_flags gwr
 -- writes real wavefunctions in G-space, for systems with
    inversion symmetry about the origin, to file WFN (for all codes)

output_flags gwscreening
 -- writes charge density in G-space to file RHO,
    exchange-correlation potential in G-space to file VXC,
    and matrix elements of exchange-correlation potential to file
    vxc.dat (for Sigma). Real if possible and gwc not set, else complex.

output_flags gwcscreening
 -- like gwscreening, except forces complex even if real is possible.

vxc_matrix_elements diagmin diagmax offdiagmin offdiagmax
 -- specifies the range of bands for which to compute diagonal and
    off-diagonal matrix elements of exchange-correlation potential
    (for Sigma, in conjunction with output_flags gwscreening)

Other key input flags:

pw_job {scf, nonselfcon}
 -- Use scf for initial calculation, nonselfcon for generating
    BerkeleyGW outputs. (bandstructure does not seem to work)

energy_cutoff ecut
 -- Plane-wave cutoff for wavefunctions, in Ry.

number_kpoints
 -- set to 0  to use k_grid and reduce with symmetries
    set to -1 to use k_grid and do not reduce with symmetries
    set to any other number to read from file KPOINTS

k_grid nx ny nz
 -- 3 integers specifying Monkhorst-Pack k-grid dimensions

k_grid_shift dx dy dz
 -- Monkhorst-Pack k-grid shifts (typically 0.0 or 0.5)

number_bands nb
 -- Number of bands to use in calculation. Fraction actually useful
    or written to BerkeleyGW output determined by next variable.

eigspacefrac frac
 -- Fraction of bands to converge. Setting a higher number_bands
    and lower eigspacefrac can make the calculation more efficient
    depending on the diagonalization scheme. 0 < frac <= 1.0.

You can find the actual input files for PARATEC and BerkeleyGW in 
examples/DFT, in PARATEC subdirectories for each example.

There are also bgw2para and rho2cd utilities that convert 
BerkeleyGW files WFN and RHO to PARATEC format. This may be 
useful, for example, if one generates the plane waves on top of the 
valence and conduction bands (look into MeanField/SAPO/README for details) 
and wants to diagonalize them further in PARATEC. There are no input 
files; bgw2para takes as argument the wfn filename,
and it creates files WFN$n.$s and BAND needed for PARATEC. 
Similarly, rho2cd requires file RHO and it creates file CD.

* Imported spglib-1.0.9 from http://spglib.sourceforge.net. This is a BSD-licensed C library for symmetries by Atsushi Togo. --DAS
* Added src/spglib_f.c which is not actually part of spglib 1.0.9 although it appears to have been forgotten by accident since it is mentioned in the documentation and was present in earlier version. I obtained it by e-mailing the author. --DAS
* Removed test directory which we do not need and contains a large number of files. --DAS
* Removed examples, python, etc., blank files, and automake/libtool-related files. --DAS

DISCLAIMER
==========

This directory contains source code from Qhull. The file COPYING.txt 
 has the terms for distributing these files.

The following files are part of the BerkeleyGW package, and not Qhull:
 - libtile_qhull.c
 - libtile_qhull.h
 - test_delaunay_f.f90
 - test_delaunay_c.c
 - Makefile
 - README

The files listed above are distributed under the BerkeleyGW license
 found in the topmost directory.


CHANGES TO QHULL
================

The following change had to be made to Qhull:

 - qhull_a.h: line 105
   Remove macro for intel compilers.
   Source: http://mail.scipy.org/pipermail/scipy-user/2011-July/029908.html

The SAPO (Simple Approximate Physical Orbitals) code reads DFT 
wavefunctions from WFN file, generates additional wavefunctions on top 
of them, and writes both to another WFN file. It can generate plane waves, 
decompose them into irreducible representations of the space group of the 
Bravais lattice or the crystal, and orthonormalize them with respect to 
DFT wavefunctions. It can insert SIESTA wavefunctions read from auxiliary 
WFN file in between plane waves and orthonormalize them altogether. 
It can apply a random variation to the plane waves and SIESTA wavefunctions 
or generate completely random wavefunctions and orthonormalize them. 
It can correct eigenvalues during orthonormalization or perform subspace 
diagonalization. It can drop the plane waves and SIESTA wavefunctions which 
have a large overlap with DFT wavefunctions. It can keep wavefunctions with 
the eigenvalues in a given energy range. It can extract eigenvalues and 
plane wave coefficients from WFN file for plotting purposes.

The SAPO method is described in Phys. Rev. Lett. 107, 186404 (2011)

2012-12-24 (gsm): added iterative Davidson diagonalization, see 
examples/DFT/Si2_sapo for details

Note: When using iterative Davidson diagonalization, it is recommended 
to generate VXC rather than vxc.dat in pw2bgw run, then compute matrix 
elements of VXC between SAPO wavefunctions. This is more consistent 
than using vxc.dat because vxc.dat is computed between ESPRESSO 
wavefunctions, and those might be slightly different from SAPO 
wavefunctions.

Note: wfng_input_file should contain all occupied orbitals (and may or 
may not contain some unoccupied orbitals), otherwise occupations written 
to wfng_output_file will be wrong.

Note: Symmetrization of planewaves (sapo_symmetry .gt. 0) has no effect 
on a SAPO calculation since it is just a linear combination in a degenerate 
subspace. It is currently disabled because it requires symmetry subroutines 
from Quantum ESPRESSO. To enable it open MeanField/SAPO/pw.f90, comment out 
die, and uncomment s_axis_to_cart, find_group, set_irr_rap, divide_class.

Input is read from file sapo.inp:

&input_sapo
   wfng_input_file = 'wfng.in'
   wfng_aux_file = ''
   vlr_input_file = ''
   vnlg_input_file = ''
   wfng_output_file = 'wfng.out'
   sapo_band_number = 0
   sapo_planewave_min = 1
   sapo_planewave_max = 580
   sapo_energy_shift = 0.0
   sapo_energy_match = .true.
   sapo_symmetry = 2
   sapo_print_ir = .true.
   aux_flag = .false.
   aux_band_min = 0
   aux_band_max = 0
   aux_energy_shift = 0.0
   sapo_random = 1
   sapo_random_ampl = 1.0d-3
   sapo_overlap_flag = .false.
   sapo_overlap_max = 0.0
   sapo_orthonormal = .true.
   sapo_ortho_block = 0
   sapo_ortho_order = 0
   sapo_ortho_energy = .false.
   sapo_energy_sort = .false.
   sapo_hamiltonian = .false.
   sapo_energy_range = .false.
   sapo_energy_min = 0.0
   sapo_energy_max = 0.0
   sapo_check_norm = .false.
   sapo_plot_kpoint = 0
   sapo_plot_spin = 0
   sapo_plot_bandmin = 0
   sapo_plot_bandmax = 0
   sapo_plot_pwmin = 0
   sapo_plot_pwmax = 0
   sapo_eigenvalue = .false.
   sapo_projection = 0
   sapo_amplitude = .false.
   sapo_ampl_num = 0
   sapo_ampl_del = 0.0
   sapo_ampl_brd = 0.0
/

Here, the wavefunctions are read from wfng.in file and written to wfng.out 
file. The parameter sapo_band_number specifies the number of wavefunctions 
to be read from the input file (if set to 0 all the wavefunctions will be 
read). The PW wavefunctions will be constructed from plane waves ranging 
from 1 (sapo_planewave_min) to 580 (sapo_planewave_max). The kinetic energies 
of the plane waves will be shifted to match the eigenvalues of the input 
wavefunctions (sapo_energy_match). The plane waves will be decomposed into 
irreducible representations of the space group of the Bravais lattice 
(sapo_symmetry = 2), and the decomposition will be printed to the standard 
output (sapo_print_ir). The auxiliary wavefunctions will not be inserted in 
between the PW wavefunctions (aux_flag). A random variation (sapo_random = 1) 
with a small amplitude (sapo_random_ampl = 1.0d-3) will be added to the PW 
wavefunctions. The PW wavefunctions will be orthonormalized with respect 
to the valence and conduction bands (sapo_orthonormal) in the ascending 
order with respect to energy (sapo_ortho_order = 0). The orthonormality 
check will not be performed (sapo_check_norm). The energy eigenvalues, 
the projections of wavefunctions onto plane waves, and the squared 
absolute values of amplitudes of the wavefunctions with respect to 
kinetic energies of plane waves will not be plotted (sapo_eigenvalue, 
sapo_projection, and sapo_amplitude).

The auxiliary wavefunctions can be used in two different ways:

(1) Use hybrid valence wavefunctions as wfng_input_file and LDA conduction 
wavefunctions as wfng_aux_file, set sapo_planewave_min and sapo_planewave_max 
to 0, sapo_orthonormal to .true. and sapo_ortho_block to 1. This way you will 
get a good starting point for nscf hybrid calculations in PARATEC or ESPRESSO.

(2) Use Siesta wrapper in MeanField/SIESTA directory to construct the resonant 
states from SIESTA wavefunctions (look into MeanField/SIESTA/README for details 
on how to use siesta2bgw), feed them to the SAPO code through wfng_aux_file 
parameter, and generate continuum states from plane waves by setting 
sapo_planewave_max to a large number. Also set sapo_orthonormal, 
sapo_ortho_block and sapo_ortho_order to orthonormalize the resonant and 
continuum states in the desired order with respect to the bound states 
from PARATEC or ESPRESSO. You may want to set sapo_ortho_energy to .true. 
for correcting the eigenvalues during the orthonormalization, or to set 
sapo_hamiltonian to .true. for correcting both the wavefunctions and 
the eigenvalues by diagonalizing the Hamiltonian. The latter requires 
the local potential file in Gaussian Cube format (vlr_input_file), 
and optionally the non-local pseudopotential file (vnlg_input_file). 
Finally, set sapo_energy_sort to .true. for sorting the resonant 
and continuum states by their eigenvalues before writing them 
to the output file. You may also set sapo_energy_range to .true. 
for keeping the eigenvalues in the energy range of sapo_energy_min 
to sapo_energy_max.

PS: If you don't know or don't want to manually set 
sapo_planewave_min and aux_band_min, set both of them to 1, 
sapo_overlap_flag to .true., and sapo_overlap_max to 0.3. 
This will automatically throw away plane-waves and auxiliary 
states that have large overlaps (scalar products > 0.3) 
with DFT states and among themselves. The scalar products 
of PW and AUX states with DFT states will be written to files 
overlap_dft_k#_s#.dat, and the scalar products of PW states 
with AUX states will be written to files overlap_aux_k#_s#.dat, 
so you can inspect what states were thrown away after the run. 
This useful feature is informally known as boverlap, in honor 
of Brad Malone who first proposed this idea. This confirms 
once again that evolution is a byproduct of laziness.

This directory contains a patch for espresso-5.1 that fixes bugs 
listed below. Assuming BerkeleyGW is installed in $BGWPATH/BerkeleyGW, 
to apply the patch execute the following command 
in the directory containing the espresso-5.1 directory:

% patch -p0 -i $BGWPATH/BerkeleyGW/MeanField/ESPRESSO/version-5.1/espresso-5.1-patch

(1) <<< THIS IS FIXED IN QUANTUM ESPRESSO TRUNK >>>
Incorrect weights of k-points along the lines in Modules/read_cards.f90

(2) <<< THIS IS DISABLED IN QUANTUM ESPRESSO TRUNK >>>
Incorrect off-diagonal matrix elements of Vxc with real wavefunctions in PP/src/pw2bgw.f90

(3) <<< THIS IS FIXED IN QUANTUM ESPRESSO TRUNK >>>
Obsolete preprocessor flags and MPI initialization in PP/src/pw2bgw.f90 and PP/src/bgw2pw.f90

(4) <<< THIS IS FIXED IN QUANTUM ESPRESSO TRUNK >>>
gk_sort vs iunigk bug in PP/src/pw2bgw.f90 and PP/src/bgw2pw.f90

This directory contains a patch for denchar-1.4 and 
grid2cube-1.1.1 in siesta-3.1 that adds support 
for non-orthogonal cells. The modified versions 
generate Gaussian Cube files on real-space grid. 
To apply the patch execute the following command 
in the directory where you have siesta-3.1:

% patch -p0 -i siesta-3.1-patch

Use the following keywords in siesta input file:

WaveFuncKPointsScale ReciprocalLatticeVectors
%block WaveFuncKPoints
0.000  0.000  0.000
%endblock WaveFuncKPoints
WriteDenchar T
SaveRho T
SaveElectrostaticPotential T
SaveTotalPotential T
MeshCutoff 240.0 Ry

Then run denchar for wavefunctions and grid2cube for 
charge density and potentials. In denchar input file, 
use keywords LatticeConstant and LatticeVectors same as 
in siesta input file. Keywords Denchar.{Min|Max}{X|Y|Z} 
will be ignored. In grid2cube input file, 3rd and 4th 
lines (shift of the origin of coordinates and nskip) 
will be ignored.

There is also irrbz.py that extracts irreducible wedge 
from siesta output files prefix.KP and prefix.EIG. 
This is needed because siesta reduces k-points by 
time-reversal symmetry only.

This directory contains a patch for espresso-4.3.2 that fixes bugs 
listed below. Assuming BerkeleyGW is installed in $BGWPATH/BerkeleyGW,
to apply the patch execute the following command 
in the directory containing the espresso-4.3.2 directory:

% patch -p0 -i $BGWPATH/BerkeleyGW/MeanField/ESPRESSO/version-4.3.2/espresso-4.3.2-patch

espresso-4.3.2 buglist:

(1) <<< THIS IS FIXED IN QUANTUM ESPRESSO 5.0 >>>
If you run espresso nscf calculation with startingwfc set to file 
you may get error message saying "cannot read wfc : file not found". 
This happens because subroutine verify_tmpdir in PW/input.f90 renames 
data-file.xml to data-file.xml.bck and subroutines read_planewaves and 
read_wavefunctions in PW/pw_restart.f90 try to read from data-file.xml 
which doesn't exist. To get around this problem read from .xml.bck in 
read_planewaves and read_wavefunctions if opening .xml returns error.

(2) <<< THIS IS FIXED IN QUANTUM ESPRESSO 5.0 >>>
Missing "CALL stop_pp ( )" at the end of PP/plan_avg.f90 causes it 
to crash sometimes.

(3) <<< THIS IS FIXED IN QUANTUM ESPRESSO 5.0 >>>
Sometimes pw.x generates additional k-points in a "nscf" run with an explicit 
list of k-points. If this is the case for your calculation, there are several 
ways to go around this problem: 
* Apply the patch provided with BerkeleyGW. It will prevent pw.x from 
  generating additional k-points if they are provided explicitly, and 
  take care of the normalization of the weights of k-points in a "bands" 
  calculation. 
* Do not specify the atomic positions in the input file of kgrid.x (set 
  number of atoms = 0). Then pw.x will generate additional k-points which 
  are the correct ones. Also set noinv = .true. in the input file of pw.x 
  if time-reversal symmetry was not used in kgrid.x. 
* Run a pw.x "bands" calculation instead of "nscf". In this case you have 
  to explicitly specify the occupations in the input file of pw2bgw.x (note 
  that this only works for insulators) and to normalize the weights of 
  k-points to one in the input file of pw.x.

This directory contains patches for older versions of espresso that fixes bugs 
listed below. Assuming BerkeleyGW is installed in $BGWPATH/BerkeleyGW,
to apply the patch execute the following command 
in the directory containing the espresso-xxx directory:

% patch -p0 -i $BGWPATH/BerkeleyGW/MeanField/ESPRESSO/patch_oldversions/espresso-xxx-patch

espresso buglist:

(1) <<< THIS IS FIXED IN QUANTUM ESPRESSO 5.0 >>>
If you run espresso nscf calculation with startingwfc set to file 
you may get error message saying "cannot read wfc : file not found". 
This happens because subroutine verify_tmpdir in PW/input.f90 renames 
data-file.xml to data-file.xml.bck and subroutines read_planewaves and 
read_wavefunctions in PW/pw_restart.f90 try to read from data-file.xml 
which doesn't exist. To get around this problem read from .xml.bck in 
read_planewaves and read_wavefunctions if opening .xml returns error.

(2) <<< THIS IS FIXED IN QUANTUM ESPRESSO 5.0 >>>
Missing "CALL stop_pp ( )" at the end of PP/plan_avg.f90 causes it 
to crash sometimes.

BerkeleyGW testsuite
David Strubbe 2009-2011

== Running tests ==

* To run the testsuite in serial, type "make check" in this directory or the main directory. "make check-save" will do the same, but retain the working directories for debugging.
* To run in parallel without a scheduler, you can just use "make check-parallel" if you do not have a scheduler (e.g. PBS). Set environment variable SAVETESTDIRS=yes to save working directories. The tests use 4 cores, so be sure that at least that many are available, or use BGW_TEST_MPI_NPROCS (see below).
* To run in parallel with a scheduler, type "make check-jobscript" or "make check-jobscript-save", which will execute the job script for the machine you are using, as specified in arch.mk by the line TESTSCRIPT. See example job scripts for various machines in this directory called *.scr. The tests use 4 cores, so be sure to request at least that many in the job script, or use BGW_TEST_MPI_NPROCS (see below).
* Environment variables:
  - TEMPDIRPATH: sets the scratch directory where temporary working directories will be created. Default is /tmp, but on some machines you may not have permission to write there.
  - MPIEXEC: sets the command for parallel runs. Default is `which mpiexec`. Note that mpiexec and mpirun are generally equivalent (except for Intel MPI, in which case mpirun is recommended). Set this if you are using a different command such as 'ibrun' (SGE parallel environment), 'runjob' (BlueGene), or 'aprun' (Cray), if you need to use a different mpiexec than the one in your path, or if some options need to be appended to the command. Depending on the value of this variable, three styles of command line are used: ibrun, runjob, and mpirun/aprun.
  - BGW_TEST_MPI_NPROCS: set to overrule the number of processors listed in the test files. Useful for testing correctness of parallelization, if you don't have 4 cores, or to run the testsuite faster with more cores.
 [- BGW_TEST_NPROCS: deprecated, same as BGW_TEST_MPI_NPROCS, provided for compatibility with versions 1.0.x.]
  - MACHINELIST: if set, will be added to command line for MPI runs. This is needed in some MPI implementations.
  - EXEC: if set, will be added before name of executable. Used to run code through valgrind.
* To run just one test, in its directory, run "../run_regression_test.pl [-s] [-p] -D ../../bin -f [testname].test". Include the -s flag to run in serial; otherwise it will be in parallel. Include the -p flag to preserve the working directory.

Contents:
(1) run_testsuite.sh -- this script runs tests from filenames ending in *.test in this directory.
(2) run_regression_test.pl -- called from run_testsuite.sh for each individual test.
(3) *.scr -- job scripts for running the testsuite on various parallel machines.
(4) interactive*.sh -- scripts to run in parallel, in interactive mode. You have to follow the instructions in the script, not just run it.
(5) queue_monitor.pl -- a Perl script for parallel tests with a SLURM or PBS scheduler, which submits a job and monitors the queue to see what happens. Used by the BuildBot.
(6) test directories.
(7) fix_testsuite.py -- (for developers) can be used to create or update match reference values in test files.
(8) no_hires.sh -- Some clusters will not have the Perl package Time::HiRes installed which is needed for timing in run_regression_test.pl. You can just deactivate the usage with this script.
(9) buildbot_query.pl -- (for developers) can be used to find the range of values obtained on the buildslaves for a particular match, to set values in the test files.

== Writing tests ==

The test files consist of lines beginning with one of a set of tags, parsed by the Perl script. Comment lines beginning with '#' will be ignored.
Test : title
  Write a title to output to identify the test. Should be the first tag in the file.
Banner : text
  Write a heading in a box to identify a specific part of a test. Helpful when input files are generated by sed and do not have a distinct name.
Enabled : Yes/No
  If Yes, will be run; if No, will not be run. Use to turn off a test without deleting it from the repository. Should be the second tag in the file.
TestGroups : group-name [group-name2 [...]]
  The run_testsuite.sh script can be run with argument "-g" and a list of groups. Then tests will only be run if there is a match between the argument list and the list in TestGroups. Examples of groups that could be used: parallel, serial, long. [This tag is actually read by run_testsuite.sh rather than run_regression_test.pl.]
Executable : program.x
  Name of executable to be run (path is bin directory). Persists for multiple runs, until next Executable tag.
Processors : integer
  Number of processors to use. Ignored if mpiexec is not available. May not exceed the number in the reservation in the job scripts.
  Set to special value "serial" to run without mpiexec.
Command : shell-command
  Specify a shell command, which will be executed in the working directory. Useful for renaming log files that would be overwritten by a subsequent run, or preprocessing input files by sed or other utilities (after putting in working directory with Copy).
Copy : file.in [file_newname.in]
  Copy a file from test directory to run directory. If new name is not supplied, original name will be used. Useful if you want to sed a file before it is run.
Unpack : data.tar.gz
  The file data.tar.gz in the test directory will have "tar xzf" run on it, with resulting files going to the working directory.
Output : file.out
  Output will be piped into the file named here, in the working directory.
Arguments : arg1 arg2
  The current Executable will be executed (in serial) with the text given here as command-line argument(s). No files will be copied to working directory. Use redirection with ">" to capture the output if necessary.
Input : file.in [file_newname.in/PIPE/CMDLINE/NONE]
  The file named here will be copied from the test directory to the working directory, for use as input. If it is followed by "PIPE", the file will be piped into the executable. If it is followed by "CMDLINE", the file will be given as a command-line argument to the executable. If it is followed by "NONE", no file will be copied (useful if an input file was already generated by sed in the working directory). If it is followed by another name, the file's name in the working directory will be the new name. This tag causes actual execution of the run that has been set up by previous tags.
Precision : 1e-5
  A floating point number, the tolerance for testing whether a match has passed or failed. Persists until next Precision tag. Default is 1e-4.
match ; name ; COMMAND(..); reference-value
  Extracts a calculated number from a run and tests it against the reference value. The name is an identifier printed to output. The number is extracted as the standard output from the listed COMMAND, which is one of this set:
  . GREP(filename, 'search-text', field, offset)
      Finds the first line in file containing 'search-text' (which MAY NOT contain a comma), and returns the specified field of that line. "Field" is meant in the sense used by 'awk', i.e. the line is parsed into white-space separated groups, indexed starting with 1. The optional 'offset' directs the use of the Mth line after the line containing 'search-text'.  No offset is equivalent to offset = 0. This is the most robust of the commands and should be used when possible in preference to the others.
  . SIZE(filename)
      Returns the size of the specified file via 'ls -lt'. Useful for binary files whose contents cannot easily be checked.
  . LINE(filename, line, field)
      Returns the specified field of the specified line number from the file. Use GREP instead if possible.
  . SHELL(shell-command)
      The result is the standard output of the listed command. Deprecated; use GREP or LINE unless absolutely necessary.
STOP TEST
  For debugging purposes, to halt test after the part you are studying has run.

All the DFT examples may be done with either ESPRESSO or PARATEC.
Each directory's README tells you how to run it and suggests number of processors and walltime for parallel calculations.
Needed pseudopotentials are contained in DFT/pseudos.

Note: ESPRESSO examples are compatible with Quantum ESPRESSO 5.0 and later versions.
If you want to run them with Quantum ESPRESSO 4.3.2 or earlier version, you should modify the input files for pw.x.
Change "calculation = 'bands'" to "calculation = 'nscf'" and "CELL_PARAMETERS" to "CELL_PARAMETERS cubic".

This directory contains example runs for a variety of physical systems:

silicon: a bulk semiconductor
  Includes PREBUILT tarball of DFT inputs from PARATEC.
  Includes ref directories containing sample output from ESPRESSO and BerkeleyGW steps.
  Available for EPM as well as DFT.
  Shows how to use Wannier90 and sig2wan.x to obtain a GW bandstructure by interpolation.

Si2_bs: another silicon example
  Shows how to use inteqp to obtain a GW bandstructure by interpolation.

Si2_sapo: another silicon example
  Shows how to perform iterative Davidson diagonalization in SAPO,
    requires pw2bgw with write_vscg capability as in espresso-5.0.2.

Zn2O2: a bulk semiconductor
  Includes ref directories containing sample output from ESPRESSO and BerkeleyGW steps.
  Shows how to use inteqp to obtain a GW bandstructure by interpolation.
  Shows how to perform iterative Davidson diagonalization in SAPO,
    requires pw2bgw with write_vscg capability as in espresso-5.0.2.
  Shows how to use valence only charge density in the Generalized Plasmon Pole model,
    requires pw2bgw with calc_rhog capability as in espresso-5.0.2.

sodium: a bulk metal

swcnt_5-5: (5,5) single-walled carbon nanotube, a metallic 1D system

swcnt_8-0: (8,0) single-walled carbon nanotube, a semiconducting 1D system
  Has runs of plotxct with visualization by volume.py and surface.x.

CO: a small molecule

benzene: a slightly larger molecule
  Includes run of gsphere.py and SIESTA.

There are also examples in the Visual directory for the scripts there.
The testsuite runs may also be consulted, although they are not realistic calculations.

#
# BENZENE MOLECULE for PARATEC/ESPRESSO/SIESTA
#
# this example teaches to select unit-cell size and number of unoccupied states,
# to generate SIESTA wavefunctions and simple approximate physical orbitals (SAPO),
# to iteratively compute self-energy at quasiparticle energy and to get absolute
# quasiparticle energies relative to the vacuum level
#
# ----------------------------------------
#
# get size of FFT grid and dielectric matrix (directory 0)
# ng = 2637 in ./0-gsphere/g_eps.out ==> use approximately that many unoccupied states
# ESPRESSO: grid3 = 144 in ./0-gsphere/g_rho.out ==> run espresso on 144 processors
#
sh ./script_0
#
# create symbolic links
#
# Enter PARATEC or ESPRESSO directory.
sh ./script_1
#
# generate charge density, do post-processing (directory 1)
# PARATEC: run nscf calculation, generate WFN/RHO/VXC/vxc.dat (directory 2)
# ESPRESSO: run nscf calculation, run pw2bgw wrapper (directory 2)
# multiply dx,dy,dz from ./1-scf/surface.out by a factor of 2 to get unit-cell size
# electrostatic potential averaged on unit-cell faces in ./1-scf/velec_avg_face.out is used via keyword avgpot_outer in sig.inp
# the averaging is taken on planes 0.5 0.5 0.5 because benzene is at the origin of the coordinate system
# total potential averaged in unit-cell volume in ./1-scf/vtot_avg_vol.out is used to align kinetic energies of plane-waves in sapo.inp
#
PARATEC: Submit script_2. Suggested ncpu = 128, walltime = 6:00:00
ESPRESSO: Submit script_2. Suggested ncpu = 144, walltime = 6:00:00
#
# Leave PARATEC or ESPRESSO directory.
# run siesta, denchar, grid2cube (directory 3)
# this step is performed in serial because denchar doesn't run in parallel
# grid2cube step is to generate rho and vxc for running Sigma on top of SIESTA (not done in this example)
# note that Denchar.MaxX = a1 * (nr1 - 1) / nr1 in ./3-siesta/in_denchar, same for MaxY and MaxZ
# this is needed to generate wavefunctions on periodic grid, not on general grid
#
sh ./script_3
#
# run siesta2bgw wrapper (directory 3)
# for siesta-2, set wfng_gamma_real = .true. in ./3-siesta/siesta2bgw.inp
# for siesta-3, set wfng_gamma_real = .false. in ./3-siesta/siesta2bgw.inp
# this controls the naming convention of siesta wavefunction files
#
Submit script_4. Suggested ncpu = 144, walltime = 0:15:00
#
# run SAPO (directory 4)
# replace ./4-sapo/sapo.inp with ./4-sapo/sapo_ham.inp to diagonalize Hamiltonian
# sapo_planewave_max = 4087 is obtained by changing 6.0 to 8.0 in ./0-gsphere/g_eps.in
# sapo_energy_shift = -0.987586 is obtained from ./1-scf/vtot_avg_vol.out
# aux_energy_shift = -0.06421 is obtained by subtracting SIESTA HOMO from PW HOMO
# sapo_energy_min = -0.060680486 is set to highest PW state included in SAPO (sapo_band_number = 17) converted to Ry
# sapo_energy_max = 7.031033188 is obtained by adding ./1-scf/velec_avg_face.out converted to Ry to cutoff energy = 7 Ry
#
Submit script_5. Suggested ncpu = 144, walltime = 0:15:00
#
# compute inverse dielectric matrix, calculate quasiparticle energies on top of PW and SAPO (directories 5 and 6)
# run Sigma twice to compute self-energy at quasiparticle energy (this should be done iteratively until convergence)
# include states up to 6.0 Ry + ./1-scf/velec_avg_face.out = 82.05637958 eV
# for PW, there are 2699 states
# for SAPO, the eigenvalues can be found in ./4-sapo/ener_k1_s1.dat
# for ./4-sapo/sapo.inp, there are 2749 states
# for ./4-sapo/sapo_ham.inp, there are 2601 states
#
Submit script_6. Suggested ncpu = 256, walltime = 0:30:00
#

#
# BULK SODIUM
#
# Enter PARATEC or ESPRESSO directory.
#
# ESPRESSO: generate k-points (directory 00); you must manually add the k-points to espresso input files
ESPRESSO: sh ./script_0
#
# create symbolic links
#
sh ./script_1
#
# generate charge density (directory 01)
# run nscf calculations (directories 02 to 04)
Submit script_2. Suggested ncpu = 6, walltime = 0:15:00
(You can benefit from more MPI tasks for the NSCF, but SCF will crash with
ESPRESSO and more than 7 MPI tasks, with message:
     Error in routine check_para_diag (1):
     Too few bands for required ndiag)
# generate dielectric matrix (directory 07)
# calculate self-energy corrections (directory 08)
Submit script. Suggested ncpu = 64, walltime = 0:15:00
#
# A couple of notes about the differences between this and a semicondutor 
# calculation:
#
# 1). Note that instead of using a k-grid shifted by a small q-vector 
# we use a uniform, unshifted fine grid to represent the small q 
# behavior in 03-wfn_fi. This  changes way that we calculate epsilon. 
# Note that in 07-epsilon we calculate epsilon on a uniform grid 
# but exclude the first small q point that is given in a calculation 
# on a semiconductor (see silicon example). The first point in the 
# qpoint list in 07-epsilon/epsilon.inp does NOT have the '1' flag at the end. 
# In 07-epsilon_fine we calculate a single q point of size 1/gridsize where 
# the gridsize is the linear dimension of the grid size specified in the 
# 03-wfn_fi calculation.
#
# 2). For the calculation of Sigma, we link the epsmat file from 07-epsilon 
# to epsmat in the 08-sigma directory. But now we link the epsmat file 
# from 07-epsilon_fine to eps0mat in the 08-sigma directory.
#
# 3). The fine grid should be dense enough to adequately represent the 
# intraband transitions as well as the density of states. If you plot 
# the head of inverse epsilon as a function of the small q-vector, 
# you should see a parabolic behavior which agrees very well with 
# a Thomas-Fermi model of the system calculated from the density 
# of states at the Fermi level.
#
# 4). We cannot run the BSE codes on sodium because the unusual case 
# of a system in which some k-points have no occupied bands is not 
# implemented. We could overcome this limitation by using a semicore 
# pseudopotential for sodium at the price of a higher computational 
# cost.

#
# BULK SILICON
#
# Sample output from each run, generated based on PARATEC DFT input, is
# in each directory of the GW/BSE calculations, for comparison.
#
# Enter PARATEC, ESPRESSO, ABINIT or PREBUILT directory.
#
# ESPRESSO: generate k-points (directory 00)
# ESPRESSO: you must manually add the k-points to espresso input files
ESPRESSO: sh ./script_0
ABINIT: sh ./script_0
#
# create symbolic links
#
sh ./script_1
#
# generate charge density (directory 01)
# run nscf calculations (directories 02 to 06)
# This step is not needed in the PREBUILT case.
# The WFNq steps ask for more bands than just the valence. Sometimes, this is necessary to get correct
# results from the diagonalization algorithms. The extra bands will not be used in BerkeleyGW regardless.
#
ESPRESSO/PARATEC/ABINIT: Submit script_2. Suggested ncpu = 24, walltime = 0:30:00
#
# cd ..
#
# generate dielectric matrix (directory 07)
# calculate self-energy corrections (directory 08)
# generate electron-hole interaction kernel (directory 09)
# solve BSE and calculate optical absorption (directory 10)
#
Submit script_3. Suggested ncpu = 48, walltime = 0:30:00
#
The steps in ESPRESSO/07-wannier and 11-sig2wan construct a Wannier-interpolated
bandstructure. This is optional because it requires the Wannier90 code.
Visualize the bandstructures in gnuplot with: load 'silicon_band.gnu'
Also, see Wannier90 1.2 example 11 on which this example is based.

#
# CO MOLECULE
#
# A similar calculation may be found in
# Sohrab Ismail-Beigi and Steven G. Louie,
# "Excited-State Forces within a First-Principles Green's Function Formalism,"
# Phys. Rev. Lett. 90, 076401 (2003)
#
# create symbolic links
#
# cd PARATEC or ESPRESSO
sh ./script_1
Submit script_2. Suggested ncpu = 4, walltime = 0:30:00
#
# generate charge density (directory 1)
# run nscf calculation (directory 2)

# cd ..
# generate dielectric matrix (directory 3)
# calculate self-energy corrections (directory 4)
# generate electron-hole interaction kernel (directory 5)
# solve BSE and calculate optical absorption (directory 6)
#
Submit script. Suggested ncpu = 16, walltime = 0:30:00
#

#
# BULK ZINC OXIDE
#
# This example is from J. Phys.: Condens. Matter 26, 475501 (2014) (arXiv:1407.3781)
#
# Sample output from each run, generated based on ESPRESSO DFT input, is
# in each directory of the GW/BSE calculations, for comparison.
#
# Enter ESPRESSO directory.
# cd ./ESPRESSO
#
# run scf, generate rho and vxc
# Submit qscript_1. Suggested ncpu = 144, walltime = 1:00:00
#
# generate wavefunctions
# Submit qscript_2. Suggested ncpu = 3136, walltime = 2:00:00
#
# Return to ZnO directory.
# cd ..
#
# generate dielectric matrix
# Submit qscript_3. Suggested ncpu = 2304, walltime = 3:00:00
#
# calculate self-energy corrections
# Submit qscript_4. Suggested ncpu = 2048, walltime = 12:00:00
#
# interpolate quasiparticle band structure
# Submit qscript_5. Suggested ncpu = 16, walltime = 0:30:00
#
# plot the results
# Run plot_Zn2O2_epsinv.py and plot_Zn2O2_band.py
#

#
# (5,5) Metallic SWCNT
#
# Enter ESPRESSO or PARATEC directory.
#
# ESPRESSO: generate k-points (directory 0); you must manually add the k-points to espresso input files
ESPRESSO: sh ./script_0
#
# create symbolic links
#
sh ./script_1
#
# generate charge density (directory 1)
# run nscf calculations (directories 2 & 3)
# Note that we override the occupations in pp_in. ESPRESSO gives non-integer occupations for metals
# that may round to the incorrect occupations.
#
Submit script_2. Suggested ncpu = 32, walltime = 24:00:00
#
# cd ..
#
# generate dielectric matrix (directories 4 & 5)
# calculate self-energy corrections (directory 6)
# generate electron-hole interaction kernel (directory 7)
# solve BSE and calculate optical absorption (directory 8)
#
Submit script. Suggested ncpu = 32, walltime = 24:00:00
#

#
# EPM - BULK SILICON
#
# generate k-points (directory 0)
# you must manually add the k-points to EPM input files
#
sh ./script_0.sh
#
# create symbolic links
#
sh ./script_1.sh
#
# generate wavefunction files (directories 1 to 5)
#
sh ./script_2.sh
#
# generate dielectric matrix (directory 6)
# calculate self-energy corrections (directory 7)
# generate electron-hole interaction kernel (directory 8)
# solve BSE and calculate optical absorption (directory 9)
#
Submit script_3.sh. Suggested ncpu = 96, walltime = 0:30:00
#

!*************************************************************************

Program EPM2BGW
!*************************************************************************
! EPM calculates the band structure along various directions in
! k-space using a plane-wave basis and a fixed effective potential.
! Several choices of empirical pseudopotentials are provided.
!*************************************************************************
! Written by William Mattson and Richard M. Martin of the University
! of Illinois, based upon program written by K. Glassford and I. Souza.
! Modified by G. Samsonidze for use with BerkeleyGW (August 2008).
!*************************************************************************
! Note: atomic units (a.u.) are used throughout the program.
!*************************************************************************

#include "f_defs.h"

  use sysParams,           only : double, zero, one
  use TagHandlerMod,       only : tagHandlerT, TagHandlerInit, TagHandlerDestroy, &
                                  & FindTag
  use StructureMod,        only : StructureT, StructureInit, StructureDestroy
  use kPointsMod,          only : kPointsT, KPointsInit, KPointsDestroy
  use graphMod,            only : graphT, PlotBands
  use hamiltonianMod,      only : hamiltonianArrayT, HInit, HDestroy, HDiagonalize, & 
                                  & HPrint, HCheck
  use eigenStatesMod,      only : eigenStatesT, EigenStatesInit, EigenStatesDestroy, &
                                  & PrintEigenvalues
  use pwHamMod,            only : hamInfoT, HamInfoInit, HamInfoDestroy, &
                                  & HGenerate, FindHMaxSize, GridInit, &
                                  & PotentialRGenerate, KineticGenerate, &
                                  & CalculateDensity, GridDestroy
  use cgParamsMod,         only : cgParamsT, cgParamsInit
  use typeMod,             only : GridT
  use ConjGradMod,         only : cgEigenSystem,cgFFTDiagonalise
  use densityArrayMod,     only : densityArrayT, DensityArrayInit, &
                                  & DensityArrayDestroy

  use nrtype_m
  use message_m
  use wfn_rho_vxc_io_m,    only : write_binary_header, write_binary_gvectors, &
                                  & write_binary_real_data, write_binary_complex_data, write_matrix_elements
  use fftw_m,              only : check_FFT_size
  use check_inversion_m,   only : check_inversion
  use symmetries_m,        only : get_symmetries

  implicit none

  type(tagHandlerT),       pointer :: tagHandler
  type(hamInfoT),          pointer :: hamInfo
  type(StructureT),        pointer :: structure1
  type(kPointsT),          pointer :: kPoints
  type(eigenStatesT),      pointer :: eigenStates
  type(hamiltonianArrayT), pointer :: hamiltonian
  type(graphT),            pointer :: graphinfo
  type(cgParamsT)                  :: cgParams
  type(GridT),             pointer :: Grid
  type(densityArrayT),     pointer :: densityArray

  integer, allocatable :: gVectorsK(:,:)
  real(double), allocatable :: eigenVectorsReal(:,:,:,:)
  complex(double), allocatable :: eigenVectorsComplex(:,:,:,:)
  real(double), allocatable :: dataReal(:,:)
  complex(double), allocatable :: dataComplex(:,:), vxc_mtxel(:,:)

  integer, pointer :: atyp(:)
  real(double), pointer :: apos(:,:)
  integer, pointer :: ngk(:)
  real(double), pointer :: kw(:)
  real(double), pointer :: kpt(:,:)
  integer, pointer :: ifmin(:,:)
  integer, pointer :: ifmax(:,:)
  real(double), pointer :: energies(:,:,:)
  real(double), pointer :: occupations(:,:,:)
  logical :: wfng_flag, rhog_flag, vxcg_flag, vxc_flag, v_of_q, disable_symmetries
  integer :: real_or_complex, ReportNo, error, i, j, k, &
   & ik, ispin, ib, ig, cell_symmetry, nat, nsym, nspin, &
   & vxc_diag_nmin, vxc_diag_nmax, vxc_offdiag_nmin, &
   & vxc_offdiag_nmax, ndiag, noffdiag, FFTgrid(3), &
   & rotation(3, 3, 48), spin_index(2), idiag, ioffdiag, spacegroup, &
   & identity(3,3)
  integer, allocatable :: diag(:), offdiag(:)
  real(double) :: celvol, recvol, al, bl, ecutwfn, ecutrho, &
   & gcutm, abstol, &
   & a(3, 3), b(3, 3), adot(3, 3), bdot(3, 3), translation(3, 48), ff(6)
  character(len=3) :: sheader
  character(len=256) :: wfng_file, rhog_file, vxcg_file, vxc_file, &
   & filename, tmpstr
  character*21 :: symbol

  integer, parameter :: Nfac = 3

! Initialization

  nullify(tagHandler)
  nullify(hamInfo)
  nullify(structure1)
  nullify(kPoints)
  nullify(eigenStates)
  nullify(hamiltonian)
  nullify(graphinfo)
  nullify(Grid)
  nullify(densityArray)

  nullify(atyp)
  nullify(apos)
  nullify(ngk)
  nullify(kw)
  nullify(kpt)
  nullify(ifmin)
  nullify(ifmax)
  nullify(energies)
  nullify(occupations)

  ReportNo = 110

  filename = 'input.tmp'
  call open_file(unit = 10, file = trim(filename), status = 'replace')
  i = 0
  do while (i .eq. 0)
     read(unit = 5, fmt = 999, iostat = i) tmpstr
     write(unit = 10, fmt = 999) tmpstr
  enddo
  call close_file(unit = 10)

  ! Necessary if using conjugate gradient method
  call Random_Seed

  ! Initialize "tag handler" to read the input from file 'filename'.
  call TagHandlerInit( tagHandler, 10, filename)

  ! Input parameter real_or_complex for BerkeleyGW files
  call FindTag( tagHandler, 'real_or_complex', error)
  if(error .eq. 0) then
     read(unit = tagHandler%fileno, fmt = *, iostat = error) real_or_complex
     if(error .eq. 0) then
        if(real_or_complex .ne. 1 .and. real_or_complex .ne. 2) error = 1
     endif
  endif
  if(error .ne. 0) real_or_complex = 2
  write(*,'(" real_or_complex ",i1)')real_or_complex

  ! Input parameter disable_symmetries for BerkeleyGW wavefunction file
  call FindTag( tagHandler, 'disable_symmetries', error)
  if(error .eq. 0) then
     read(unit = tagHandler%fileno, fmt = *, iostat = error) disable_symmetries
  endif
  if(error .ne. 0) disable_symmetries = .false.
  write(*,'(" disable_symmetries ",l1)')disable_symmetries

  ! Input parameter wfng_flag for BerkeleyGW wavefunction file
  call FindTag( tagHandler, 'wfng_flag', error)
  if(error .eq. 0) then
     read(unit = tagHandler%fileno, fmt = *, iostat = error) wfng_flag
  endif
  if(error .ne. 0) wfng_flag = .false.
  write(*,'(" wfng_flag ",l1)')wfng_flag

  ! Input parameter wfng_file for BerkeleyGW wavefunction file
  call FindTag( tagHandler, 'wfng_file', error)
  if(error .eq. 0) then
     read(unit = tagHandler%fileno, fmt = *, iostat = error) wfng_file
  endif
  if(error .ne. 0) write(wfng_file,'("WFN")')
  write(*,'(" wfng_file ",a)')trim(wfng_file)

  ! Input parameter rhog_flag for BerkeleyGW charge density file
  call FindTag( tagHandler, 'rhog_flag', error)
  if(error .eq. 0) then
     read(unit = tagHandler%fileno, fmt = *, iostat = error) rhog_flag
  endif
  if(error .ne. 0) rhog_flag = .false.
  write(*,'(" rhog_flag ",l1)')rhog_flag

  ! Input parameter rhog_file for BerkeleyGW charge density file
  call FindTag( tagHandler, 'rhog_file', error)
  if(error .eq. 0) then
     read(unit = tagHandler%fileno, fmt = *, iostat = error) rhog_file
  endif
  if(error .ne. 0) write(rhog_file,'("RHO")')
  write(*,'(" rhog_file ",a)')trim(rhog_file)

  ! Input parameter vxcg_flag for BerkeleyGW exchange-correlation potential file
  call FindTag( tagHandler, 'vxcg_flag', error)
  if(error .eq. 0) then
     read(unit = tagHandler%fileno, fmt = *, iostat = error) vxcg_flag
  endif
  if(error .ne. 0) vxcg_flag = .false.
  write(*,'(" vxcg_flag ",l1)')vxcg_flag

  ! Input parameter vxcg_file for BerkeleyGW exchange-correlation potential file
  call FindTag( tagHandler, 'vxcg_file', error)
  if(error .eq. 0) then
     read(unit = tagHandler%fileno, fmt = *, iostat = error) vxcg_file
  endif
  if(error .ne. 0) write(vxcg_file,'("VXC")')
  write(*,'(" vxcg_file ",a)')trim(vxcg_file)

  ! Input parameter vxc_flag for BerkeleyGW exchange-correlation matrix element file
  call FindTag( tagHandler, 'vxc_flag', error)
  if(error .eq. 0) then
     read(unit = tagHandler%fileno, fmt = *, iostat = error) vxc_flag
  endif
  if(error .ne. 0) vxc_flag = .false.
  write(*,'(" vxc_flag ",l1)')vxc_flag

  ! Input parameter vxc_file for BerkeleyGW exchange-correlation matrix element file
  call FindTag( tagHandler, 'vxc_file', error)
  if(error .eq. 0) then
     read(unit = tagHandler%fileno, fmt = *, iostat = error) vxc_file
  endif
  if(error .ne. 0) write(vxc_file,'("vxc.dat")')
  write(*,'(" vxc_file ",a)')trim(vxc_file)

  ! Input parameter vxc_diag_nmin for BerkeleyGW exchange-correlation matrix element file
  call FindTag( tagHandler, 'vxc_diag_nmin', error)
  if(error .eq. 0) then
     read(unit = tagHandler%fileno, fmt = *, iostat = error) vxc_diag_nmin
  endif
  if(error .ne. 0) vxc_diag_nmin = 0
  write(*,'(" vxc_diag_nmin ",i2)')vxc_diag_nmin

  ! Input parameter vxc_diag_nmax for BerkeleyGW exchange-correlation matrix element file
  call FindTag( tagHandler, 'vxc_diag_nmax', error)
  if(error .eq. 0) then
     read(unit = tagHandler%fileno, fmt = *, iostat = error) vxc_diag_nmax
  endif
  if(error .ne. 0) vxc_diag_nmax = 0
  write(*,'(" vxc_diag_nmax ",i2)')vxc_diag_nmax

  ! Input parameter vxc_offdiag_nmin for BerkeleyGW exchange-correlation matrix element file
  call FindTag( tagHandler, 'vxc_offdiag_nmin', error)
  if(error .eq. 0) then
     read(unit = tagHandler%fileno, fmt = *, iostat = error) vxc_offdiag_nmin
  endif
  if(error .ne. 0) vxc_offdiag_nmin = 0
  write(*,'(" vxc_offdiag_nmin ",i2)')vxc_offdiag_nmin

  ! Input parameter vxc_offdiag_nmax for BerkeleyGW exchange-correlation matrix element file
  call FindTag( tagHandler, 'vxc_offdiag_nmax', error)
  if(error .eq. 0) then
     read(unit = tagHandler%fileno, fmt = *, iostat = error) vxc_offdiag_nmax
  endif
  if(error .ne. 0) vxc_offdiag_nmax = 0
  write(*,'(" vxc_offdiag_nmax ",i2)')vxc_offdiag_nmax

  ! for nspin = 2, a second copy of the wavefunctions and eigenvalues will be written
  call FindTag( tagHandler, 'nspin', error)
  if(error .eq. 0) then
    read(unit = tagHandler%fileno, fmt = *, iostat = error) nspin
  endif
  if(error .ne. 0) nspin = 1
  write(*,'(" nspin ",i2)') nspin

  ! Use form-factors from input file or hard-coded V(q) potentials
  call FindTag( tagHandler,'FormFactors', error)
  if(error .eq. 0) then
    read(unit = tagHandler%fileno, fmt = *, iostat = error) ff
    if(error /= 0) stop 'Error, could not read FormFactors.'
    v_of_q = .false.
    write(*,'("Using Form Factors V_3,8,11^S & V_3,4,11^A")')
  else
    ff(:) = 0.0d0
    v_of_q = .true.
    write(*,'("Using Potentials V(q) for Species")')
  endif

  ! Read LAPACK Absolute Tolerance
  call FindTag( tagHandler, 'AbsoluteTolerance', error)
  if(error .eq. 0) then
     read(unit = tagHandler%fileno, fmt = *, iostat = error) abstol
  endif
  if(error .ne. 0) abstol = -one
  write(*,'(" AbsoluteTolerance ",e13.6)')abstol

  ! Read the Conjugate Gradient Parameter
  call cgParamsInit(cgParams,tagHandler)

  ! This will call DimensionsInit, LatticeInit, and AtomsInit.
  call StructureInit( structure1, tagHandler )

  call KPointsInit( kPoints, graphInfo, structure1%ndim, structure1%lattice, tagHandler)

  ! Gvector list and structurefactor
  call HamInfoInit( hamInfo, structure1, tagHandler, v_of_q, ff )

  ! Find hMaxSize = max size of H at any k point
  call FindHMaxSize( hamInfo, structure1, kPoints )
  
  ! Allocates array for H and work arrays
  call HInit( hamiltonian, hamInfo%hMaxSize )
  hamiltonian%abstol = abstol

  ! Allocates array for eigenStates array
  call EigenStatesInit( eigenStates, kPoints%numBands, kPoints%numKPoints, &
                      & hamInfo%hMaxSize, -1.0d0, 1)
  eigenStates%eigenVectors = zero

  ! Initialise the FFT Grid and Plans
  Call GridInit(Grid, hamInfo, eigenStates, structure1%ndim)

! DAS -- do not write this useless file if not using CG
  if(cgParams%Switch.eq.1) then
    call open_file(unit=ReportNo,file='Report.cg',status='replace',position='rewind')
    write(ReportNo,*) 'Eigenvalues:'
    write(ReportNo,*) 'The FFT Grid Size +/-',Grid%Size(1)
    write(ReportNo,*) 'The number of GVectors:',Grid%NumgVec
    write(ReportNo,*) 'Eigenvalues:'
  endif

  ! Calculate the Potential and FFT to Vr
  Call PotentialRGenerate(hamInfo, Grid)

  if(cgParams%Switch .eq. 1) then 
     do k = 1, kPoints%numKPoints 
        call HGenerate( hamInfo, structure1, kPoints, eigenStates, &
             & k, hamiltonian%h, hamiltonian%sqH, hamiltonian%hSize )

        write(ReportNo, *) 'k point ', k

        call cgEigenSystem( hamiltonian, eigenStates, k, cgParams%tol, &
             & cgParams%period ,ReportNo )

        write(*, '(" k point ", i4, " out of ", i4)') k, kPoints%numKPoints

     end do ! k
  else
     do k = 1, kPoints%numKPoints

        call HGenerate( hamInfo, structure1, kPoints, eigenStates, &
             & k, hamiltonian%h, hamiltonian%sqH, hamiltonian%hSize )

! DAS -- do not write this useless file
!        write(ReportNo, *) 'k point ', k
     
        call HDiagonalize( hamiltonian, eigenStates, k )

! DAS -- make sure stupid LAPACK routines have genuinely solved the Hamiltonian, else die 
#ifdef DEBUG
        call HCheck( hamiltonian, eigenStates, k )
#endif

        write(*, '(" k point ", i4, " out of ", i4)') k, kPoints%numKPoints

     end do ! k
  end if

  if(cgParams%Switch.eq.1) then 
    call close_file(unit=ReportNo)
  endif

! Initialize data structures for BerkeleyGW output

  a(:,:) = structure1%lattice%aLatVec(:,:)
  al = sqrt(a(1,1)**2 + a(2,1)**2 + a(3,1)**2)
  a(:,:) = a(:,:) / al
  celvol = a(1,1) * (a(2,2) * a(3,3) - a(2,3) * a(3,2)) - &
           a(2,1) * (a(1,2) * a(3,3) - a(1,3) * a(3,2)) + &
           a(3,1) * (a(1,2) * a(2,3) - a(1,3) * a(2,2))
  bl = 2.0d0 * PI_D / al
  b(1,1) = (a(2,2) * a(3,3) - a(3,2) * a(2,3)) / celvol
  b(2,1) = (a(3,2) * a(1,3) - a(1,2) * a(3,3)) / celvol
  b(3,1) = (a(1,2) * a(2,3) - a(2,2) * a(1,3)) / celvol
  b(1,2) = (a(2,3) * a(3,1) - a(3,3) * a(2,1)) / celvol
  b(2,2) = (a(3,3) * a(1,1) - a(1,3) * a(3,1)) / celvol
  b(3,2) = (a(1,3) * a(2,1) - a(2,3) * a(1,1)) / celvol
  b(1,3) = (a(2,1) * a(3,2) - a(3,1) * a(2,2)) / celvol
  b(2,3) = (a(3,1) * a(1,2) - a(1,1) * a(3,2)) / celvol
  b(3,3) = (a(1,1) * a(2,2) - a(2,1) * a(1,2)) / celvol
  celvol = abs(celvol) * al**3
  recvol = (2.0d0 * PI_D)**3 / celvol
  adot(:,:) = 0.0d0
  do i=1,3
    do j=1,3
      do k=1,3
        adot(j,i) = adot(j,i) + a(k,j) * a(k,i)
      enddo
    enddo
  enddo
  adot(:,:) = adot(:,:) * al**2
  bdot(:,:) = 0.0d0
  do i=1,3
    do j=1,3
      do k=1,3
        bdot(j,i) = bdot(j,i) + b(k,j) * b(k,i)
      enddo
    enddo
  enddo
  bdot(:,:) = bdot(:,:) * bl**2

  ! kinetic energy cutoff for wave functions
  ! convert from Hartree to Rydberg
  ecutwfn=2.0d0*hamInfo%gVectors%energyCutOff
  ! kinetic energy cutoff for charge density and potential
  ecutrho=4.0d0*ecutwfn
  gcutm=ecutrho/bl**2

  call FindTag( tagHandler, 'FFTGrid', error)
  if(error .eq. 0) then
    read(unit = tagHandler%fileno, fmt = *, iostat = error) (FFTgrid(j),j=1,3)
    if(error /= 0) stop 'Error, could not read FFTgrid.'
    if(any(FFTgrid(:) <= 0)) stop 'Error, FFTGrid values must be positive.'
  else
    do i=1,3
      FFTgrid(i)=int(2.0d0*sqrt(gcutm)*sqrt(a(1,i)**2+a(2,i)**2+a(3,i)**2))+1
      do while (.not.check_FFT_size(FFTgrid(i), Nfac))
        FFTgrid(i)=FFTgrid(i)+1
      enddo
    enddo
  endif
  write(*,'(a,3i6)') 'FFT grid: ', FFTgrid(:)

  nat=structure1%atomBasis%totalNumAtoms
  SAFE_ALLOCATE(atyp, (nat))
  SAFE_ALLOCATE(apos, (3, nat))
  atyp(:) = structure1%atomBasis%atomicNumber(structure1%atomBasis%speciesOfAtom(:))
  apos(:,:) = structure1%atomBasis%atomCart(:,:)/al

! gsm: if using form-factors make sgam_at think we have different species
  if (.not. v_of_q .and. abs(ff(4)) + abs(ff(5)) + abs(ff(6)) .gt. TOL_Small) &
    atyp(1) = atyp(1) + 1000

  if(disable_symmetries) then
    cell_symmetry = 0
    nsym = 1
    write(*,'(a)') 'Symmetries have been disabled.'
    identity = reshape((/1, 0, 0, 0, 1, 0, 0, 0, 1/), shape(identity))
    rotation(:,:,nsym) = identity
  else
    call get_symmetries(nat, atyp, structure1%atomBasis%atomLat, a, FFTgrid, cell_symmetry, nsym, &
      rotation, translation, spacegroup, symbol)
    write(*,'(a,i3,a,a)') 'Space group ', spacegroup, ', symbol ', trim(symbol)
  endif

! gsm: restore atomic species back to normal
     if (.not. v_of_q .and. abs(ff(4)) + abs(ff(5)) + abs(ff(6)) .gt. TOL_Small) &
   atyp(1) = atyp(1) - 1000

  call check_inversion(real_or_complex, nsym, rotation(:,:,:), nspin, .true., .true., tnp = translation)

  if (wfng_flag) then

     write(*,*)

     SAFE_ALLOCATE(ngk, (kPoints%numKPoints))
     SAFE_ALLOCATE(kw, (kPoints%numKPoints))
     SAFE_ALLOCATE(kpt, (3, kPoints%numKPoints))
     ngk(1:kPoints%numKPoints)=eigenStates%numBasisVectors(1:kPoints%numKPoints)
     kw(1:kPoints%numKPoints)=kPoints%kPointWeights(1:kPoints%numKPoints)
     kpt(1:3,1:kPoints%numKPoints)=kPoints%kPointsLat(1:3,1:kPoints%numKPoints)

     SAFE_ALLOCATE(ifmin, (kPoints%numKPoints,nspin))
     SAFE_ALLOCATE(ifmax, (kPoints%numKPoints,nspin))
     ifmin(1:kPoints%numKPoints,1:nspin)=1
     ifmax(1:kPoints%numKPoints,1:nspin)=kPoints%numOccupiedBands
     

     ! Convert eigenvalues from Hartree to Rydberg for BerkeleyGW
     SAFE_ALLOCATE(energies, (kPoints%numBands, kPoints%numKPoints, nspin))
     do ispin=1,nspin
        do ik=1,kPoints%numKPoints
           do ib=1,kPoints%numBands
              energies(ib,ik,ispin)=eigenStates%eigenValues(ib,ik)*2.0d0
           enddo
        enddo
     enddo

     SAFE_ALLOCATE(occupations, (kPoints%numBands, kPoints%numKPoints, nspin))
     do ispin=1,nspin
       do ik=1,kPoints%numKPoints
         do ib=1,kPoints%numBands
           if(ib < ifmin(ik, ispin) .or. ib > ifmax(ik, ispin)) then
             occupations(ib, ik, ispin) = 0.0d0
           else
             occupations(ib, ik, ispin) = 1.0d0
           endif
         enddo
       enddo
     enddo

     ! Convert eigenvalues from Hartree to Rydberg for stdout
     do ik=1,kPoints%numKPoints
        do ib=1,kPoints%numBands
!           eigenStates%eigenValues(ib,ik)=eigenStates%eigenValues(ib,ik)*2.0d0*RYD
           eigenStates%eigenValues(ib,ik)=eigenStates%eigenValues(ib,ik)*2.0d0
        enddo
        call PrintEigenvalues(eigenStates,ik)
        write(*,*)
     enddo

     SAFE_ALLOCATE(gVectorsK, (3, eigenStates%maxBasisVectors))

     if(real_or_complex .eq. 1) then
        write(*,'(" Applying Gram-Schmidt process...")')
        SAFE_ALLOCATE(eigenVectorsReal, (eigenStates%maxBasisVectors, nspin, eigenStates%numStates, eigenStates%numKPoints))
        call real_wfng(eigenStates%numKPoints, eigenStates%numStates, &
           & nspin, eigenStates%maxBasisVectors, eigenStates%numBasisVectors, &
           & eigenStates%eigenValues, eigenStates%eigenVectors, eigenVectorsReal)
        write(*,'(" ...done!")')
        write(*,*)
     else
        SAFE_ALLOCATE(eigenVectorsComplex, (eigenStates%maxBasisVectors, nspin, eigenStates%numStates, eigenStates%numKPoints))
        do ik=1,kPoints%numKPoints
           do ib=1,kPoints%numBands
              do ispin=1,nspin
                 do ig=1,eigenStates%numBasisVectors(ik)
                    eigenVectorsComplex(ig, ispin, ib, ik) = &
                       eigenStates%eigenVectors(ig, ib, ik)
                 enddo
              enddo
           enddo
        enddo
     endif

     write(*,'(" Writing BerkeleyGW wavefunction file...")')

     call open_file(20,file=trim(wfng_file),status='replace',form='unformatted')

     sheader = 'WFN'
     call write_binary_header(20, sheader, real_or_complex, nspin, &
        hamInfo%gVectors%numGVectors, nsym, cell_symmetry, nat, &
        kPoints%numKPoints, kPoints%numBands, eigenStates%maxBasisVectors, &
        ecutrho, ecutwfn, FFTgrid, kPoints%kPointNumbers, kPoints%kPointOffsets, &
        celvol, al, a, adot, recvol, bl, b, bdot, rotation, translation, &
        atyp, apos, ngk, kw, kpt, ifmin, ifmax, energies, occupations)

     call write_binary_gvectors(20, hamInfo%gVectors%numGVectors, &
        hamInfo%gVectors%numGVectors, hamInfo%gVectors%gVectors(:,:))

     do ik=1,kPoints%numKPoints
        do ig=1,eigenStates%numBasisVectors(ik)
           gVectorsK(:,ig)= &
              hamInfo%gVectors%gVectors(:,eigenStates%basisIndex(ig,ik))
        enddo
        call write_binary_gvectors(20, eigenStates%numBasisVectors(ik), &
           eigenStates%maxBasisVectors, gVectorsK(:,:))

        do ib=1,kPoints%numBands
           if(real_or_complex .eq. 1) then
              call write_binary_real_data(20, eigenStates%numBasisVectors(ik), &
                 eigenStates%maxBasisVectors, nspin, eigenVectorsReal(:, :, ib, ik))
           else
              call write_binary_complex_data(20, eigenStates%numBasisVectors(ik), &
                 eigenStates%maxBasisVectors, nspin, eigenVectorsComplex(:, :, ib, ik))
           endif
        enddo

     enddo

     call close_file(20)

     write(*,'(" ...done!")')

     SAFE_DEALLOCATE(gVectorsK)
     if (real_or_complex .eq. 1) then
        SAFE_DEALLOCATE(eigenVectorsReal)
     else
        SAFE_DEALLOCATE(eigenVectorsComplex)
     endif

  endif

  if (rhog_flag) then

     write(*,*)

     write(*,'(" Calculating charge density...")')

     call DensityArrayInit( DensityArray, structure1%ndim, &
        & FFTgrid, hamInfo%gVectors%numGVectors)

     call CalculateDensity( hamInfo, kPoints, eigenStates, densityArray )

     write(*,'(" ...done!")')

     write(*,*)

     if(real_or_complex .eq. 1) then
        SAFE_ALLOCATE(dataReal, (hamInfo%gVectors%numGVectors, nspin))
        do ispin=1,nspin
           do ig=1,hamInfo%gVectors%numGVectors
              dataReal(ig,ispin)= &
                 dble(densityArray%rhog(ig)*cmplx(2.0d0/dble(nspin),0.0d0,kind=double))
           enddo
        enddo
     else
        SAFE_ALLOCATE(dataComplex, (hamInfo%gVectors%numGVectors, nspin))
        do ispin=1,nspin
           do ig=1,hamInfo%gVectors%numGVectors
              dataComplex(ig,ispin)= &
                 densityArray%rhog(ig)*cmplx(2.0d0/dble(nspin),0.0d0,kind=double)
           enddo
        enddo
     endif

     write(*,'(" Writing BerkeleyGW charge density file...")')

     call open_file(20,file=trim(rhog_file),status='replace',form='unformatted')

     sheader = 'RHO'
     call write_binary_header(20, sheader, real_or_complex, nspin, &
        hamInfo%gVectors%numGVectors, nsym, cell_symmetry, nat, &
        kPoints%numKPoints, kPoints%numBands, eigenStates%maxBasisVectors, &
        ecutrho, ecutwfn, FFTgrid, kPoints%kPointNumbers, kPoints%kPointOffsets, &
        celvol, al, a, adot, recvol, bl, b, bdot, rotation, translation, &
        atyp, apos, ngk, kw, kpt, ifmin, ifmax, energies, occupations)

     call write_binary_gvectors(20, hamInfo%gVectors%numGVectors, &
        hamInfo%gVectors%numGVectors, hamInfo%gVectors%gVectors(:,:))

     if(real_or_complex .eq. 1) then
        call write_binary_real_data(20, hamInfo%gVectors%numGVectors, &
           haminfo%gVectors%numGVectors, nspin, dataReal(:, :))
     else
        call write_binary_complex_data(20, hamInfo%gVectors%numGVectors, &
           haminfo%gVectors%numGVectors, nspin, dataComplex(:, :))
     endif

     call close_file(20)

     write(*,'(" ...done!")')

     call DensityArrayDestroy( densityArray )

     if(real_or_complex .eq. 1) then
        SAFE_DEALLOCATE(dataReal)
     else
        SAFE_DEALLOCATE(dataComplex)
     endif

  endif

  if (vxcg_flag) then

     write(*,*)

     if(real_or_complex .eq. 1) then
        SAFE_ALLOCATE(dataReal, (hamInfo%gVectors%numGVectors, nspin))
        do ispin=1,nspin
           do ig=1,hamInfo%gVectors%numGVectors
              dataReal(ig,ispin)=0.0d0
           enddo
        enddo
     else
        SAFE_ALLOCATE(dataComplex, (hamInfo%gVectors%numGVectors, nspin))
        do ispin=1,nspin
           do ig=1,hamInfo%gVectors%numGVectors
              dataComplex(ig,ispin)=(0.0d0,0.0d0)
           enddo
        enddo
     endif

     write(*,'(" Writing BerkeleyGW exchange-correlation potential file...")')

     call open_file(20,file=trim(vxcg_file),status='replace',form='unformatted')

     sheader = 'VXC'
     call write_binary_header(20, sheader, real_or_complex, nspin, &
        hamInfo%gVectors%numGVectors, nsym, cell_symmetry, nat, &
        kPoints%numKPoints, kPoints%numBands, eigenStates%maxBasisVectors, &
        ecutrho, ecutwfn, FFTgrid, kPoints%kPointNumbers, kPoints%kPointOffsets, &
        celvol, al, a, adot, recvol, bl, b, bdot, rotation, translation, &
        atyp, apos, ngk, kw, kpt, ifmin, ifmax, energies, occupations)

     call write_binary_gvectors(20, hamInfo%gVectors%numGVectors, &
        hamInfo%gVectors%numGVectors, hamInfo%gVectors%gVectors(:,:))

     if(real_or_complex .eq. 1) then
        call write_binary_real_data(20, hamInfo%gVectors%numGVectors, &
           hamInfo%gVectors%numGVectors, nspin, dataReal(:, :))
     else
        call write_binary_complex_data(20, hamInfo%gVectors%numGVectors, &
           hamInfo%gVectors%numGVectors, nspin, dataComplex(:, :))
     endif

     call close_file(20)

     write(*,'(" ...done!")')

     if(real_or_complex .eq. 1) then
        SAFE_DEALLOCATE(dataReal)
     else
        SAFE_DEALLOCATE(dataComplex)
     endif

  endif

  SAFE_DEALLOCATE_P(atyp)
  SAFE_DEALLOCATE_P(apos)
  SAFE_DEALLOCATE_P(ngk)
  SAFE_DEALLOCATE_P(kw)
  SAFE_DEALLOCATE_P(kpt)
  SAFE_DEALLOCATE_P(ifmin)
  SAFE_DEALLOCATE_P(ifmax)
  SAFE_DEALLOCATE_P(energies)
  SAFE_DEALLOCATE_P(occupations)

  if (vxc_flag) then

     write(*,*)

     if (vxc_diag_nmin .lt. 1) vxc_diag_nmin = 1
     if (vxc_diag_nmax .gt. kPoints%numBands) vxc_diag_nmax = kPoints%numBands
     ndiag = MAX (vxc_diag_nmax - vxc_diag_nmin + 1, 0)
     if (vxc_offdiag_nmin .lt. 1) vxc_offdiag_nmin = 1
     if (vxc_offdiag_nmax .gt. kPoints%numBands) vxc_offdiag_nmax = kPoints%numBands
     noffdiag = MAX (vxc_offdiag_nmax - vxc_offdiag_nmin + 1, 0)
     noffdiag = noffdiag**2

     do ispin = 1, nspin
       spin_index(ispin) = ispin
     enddo
     SAFE_ALLOCATE(diag, (ndiag))
     do idiag = 1, ndiag
       diag(idiag) = vxc_diag_nmin + idiag - 1
     enddo
     SAFE_ALLOCATE(offdiag, (noffdiag))
     do ioffdiag = 1, noffdiag
       offdiag(ioffdiag) = vxc_offdiag_nmin + ioffdiag - 1
     enddo
     SAFE_ALLOCATE(vxc_mtxel, (ndiag + noffdiag, nspin))
     vxc_mtxel(:,:) = CMPLX(0d0, 0d0)

     write(*,'(" Writing BerkeleyGW exchange-correlation matrix element file...")')

     call open_file(20,file=trim(vxc_file),status='unknown',form='formatted')
     do ik=1,kPoints%numKPoints
       call write_matrix_elements(20, kPoints%kPointsLat(:,ik), nspin, ndiag, noffdiag, &
         spin_index, diag, offdiag, offdiag, vxc_mtxel(:,:))
     enddo
     call close_file(20)

     SAFE_DEALLOCATE(diag)
     SAFE_DEALLOCATE(offdiag)
     SAFE_DEALLOCATE(vxc_mtxel)

     write(*,'(" ...done!")')

  endif

  write(*,*)

  ! Clean up memory
  call EigenStatesDestroy( eigenStates )

  call HDestroy( hamiltonian )

  call GridDestroy( Grid)
                
  call HamInfoDestroy( hamInfo )

  call KPointsDestroy( kPoints )

  call StructureDestroy( structure1 )

  ! Clean up and close the input file
  call TagHandlerDestroy( tagHandler )

  call open_file(unit = 10, file = filename, status = 'old')
  call close_file(unit = 10, delete = .true.)

  999 format(a)

contains

!*************************************************************************
subroutine real_wfng (nk, nb, ns, ngkmax, ng, en, wfc, wfr)
!*************************************************************************
! Constructs real wavefunctions in G-space for systems
! with inversion symmetry by applying Gram-Schmidt process.
! Based on paratecSGL/src/para/gwreal.f90
!*************************************************************************

  use SysParams, only : double
  use message_m

  implicit none

  integer, intent(in) :: nk
  integer, intent(in) :: nb
  integer, intent(in) :: ns
  integer, intent(in) :: ngkmax
  integer, intent(in) :: ng(nk)
  real(double), intent(in) :: en(:, :) !< (nb, nk)
  complex(double), intent(in) :: wfc(:, :, :) !< (ngkmax, nb, nk)
  real(double), intent(out) :: wfr(:, :, :, :) !< (ngkmax, ns, nb, nk)

  real(double), parameter :: eps2 = 1.0d-2
  real(double), parameter :: eps5 = 1.0d-5
  real(double), parameter :: eps6 = 1.0d-6

  integer :: i, j, k, ik, ib, jb, is, ig, deg, mdeg, inc
  integer :: dimension_span, reduced_span
  real(double) :: x
  integer, allocatable :: inum (:)
  integer, allocatable :: imap (:, :)
  integer, allocatable :: inull(:)
  integer, allocatable :: null_map(:, :)
  real(double), allocatable :: psi(:, :)
  real(double), allocatable :: phi(:, :)
  real(double), allocatable :: vec(:)

  ! determine size of degenerate subspace
  mdeg = 1
  do ik = 1, nk
    do ib = 1, nb
      deg = 1
      do jb = ib + 1, nb
        if (abs(en(ib, ik) - en(jb, ik)) .lt. &
          eps5 * dble(jb - ib + 1)) deg = deg + 1
      enddo
      if (deg .gt. mdeg) mdeg = deg
    enddo
  enddo
  mdeg = mdeg * 2

  SAFE_ALLOCATE(imap, (nb, nk))
  SAFE_ALLOCATE(inum, (nk))
  SAFE_ALLOCATE(inull, (nb))
  SAFE_ALLOCATE(null_map, (mdeg, nb))

  do ik = 1, nk
    inum(ik) = 1
    do ib = 1, nb
      if (ib .eq. nb) then
        imap(inum(ik), ik) = ib
        inum(ik) = inum(ik) + 1
      elseif (abs(en(ib, ik) - en(ib + 1, ik)) .gt. eps5) then
        imap(inum(ik), ik) = ib
        inum(ik) = inum(ik) + 1
      endif
    enddo
    inum(ik) = inum(ik) - 1
  enddo

  SAFE_ALLOCATE(psi, (ngkmax, mdeg))
  SAFE_ALLOCATE(phi, (ngkmax, mdeg))
  SAFE_ALLOCATE(vec, (ngkmax))

  do ik = 1, nk
    inc = 1
    do i = 1, inum(ik)
      inull(i) = 1
      do ib = inc, imap(i, ik)
        x = 0.0d0
        do ig = 1, ng(ik)
          x = x + dble(wfc(ig, ib, ik))**2
        enddo
        if (x .lt. eps2) null_map(inull(i), i) = 0
        if (x .gt. eps2) null_map(inull(i), i) = 1
        inull(i) = inull(i) + 1
        x = 0.0d0
        do ig = 1, ng(ik)
          x = x + IMAG(wfc(ig, ib, ik))**2
        enddo
        if (x .lt. eps2) null_map(inull(i), i) = 0
        if (x .gt. eps2) null_map(inull(i), i) = 1
        inull(i) = inull(i) + 1
      enddo
      inull(i) = inull(i) - 1
      inc = imap(i, ik) + 1
    enddo
    inc = 1
    ib = 1
    do i = 1, inum(ik)
      k = 1
      do j = 1, 2 * (imap(i, ik) - inc) + 1, 2
        if (null_map(j, i) .eq. 1 .or. null_map(j + 1, i) .eq. 1) then
          if (null_map(j, i) .eq. 1) then
            do ig = 1, ng(ik)
              phi(ig, k) = dble(wfc(ig, ib, ik))
            enddo
            k = k + 1
          endif
          if (null_map(j + 1, i) .eq. 1) then
            do ig = 1, ng(ik)
              phi(ig, k) = IMAG(wfc(ig, ib, ik))
            enddo
            k = k + 1
          endif
          ib = ib + 1
        endif
      enddo
      dimension_span = k - 1
      if (dimension_span .eq. 0) then
        write(0,201)ik,inc
        stop
      endif
      do j = 1, dimension_span
        x = 0.0d0
        do ig = 1, ng(ik)
          x = x + phi(ig, j)**2
        enddo
        x = sqrt(x)
        do ig = 1, ng(ik)
          phi(ig, j) = phi(ig, j) / x
        enddo
      enddo
!
! the Gram-Schmidt process begins
!
      reduced_span = 1
      do ig = 1, ng(ik)
        psi(ig, 1) = phi(ig, 1)
      enddo
      do j = 1, dimension_span - 1
        do ig = 1, ng(ik)
          vec(ig) = phi(ig, j + 1)
        enddo
        do k = 1, reduced_span
          x = 0.0d0
          do ig = 1, ng(ik)
            x = x + phi(ig, j + 1) * psi(ig, k)
          enddo
          do ig = 1, ng(ik)
            vec(ig) = vec(ig) - psi(ig, k) * x
          enddo
        enddo
        x = 0.0d0
        do ig = 1, ng(ik)
          x = x + vec(ig)**2
        enddo
        x = sqrt(x)
        if (x .gt. eps6) then
          reduced_span = reduced_span + 1
          do ig = 1, ng(ik)
            psi(ig, reduced_span) = vec(ig) / x
          enddo
        endif
      enddo
!
! the Gram-Schmidt process ends
!
      if (reduced_span .lt. imap(i, ik) - inc + 1) then
        write(0,202) ik,inc
        stop
      endif
      do ib = inc, imap(i, ik)
        do is = 1, ns
          do ig = 1, ng(ik)
            wfr(ig, is, ib, ik) = psi(ig, ib - inc + 1)
          enddo
        enddo
      enddo
      inc = imap(i, ik) + 1
    enddo
  enddo

  SAFE_DEALLOCATE(inum)
  SAFE_DEALLOCATE(imap)
  SAFE_DEALLOCATE(inull)
  SAFE_DEALLOCATE(null_map)
  SAFE_DEALLOCATE(psi)
  SAFE_DEALLOCATE(phi)
  SAFE_DEALLOCATE(vec)

  return

  201 format(1x,"ERROR: failed Gram-Schmidt dimension span",/,14x, &
        & "k-point =",1x,i4.4,1x,"band =",1x,i4.4,/)
  202 format(1x,"ERROR: failed Gram-Schmidt reduced span",/,14x, &
        & "k-point =",1x,i4.4,1x,"band =",1x,i4.4,/)

end subroutine real_wfng

end Program EPM2BGW

!-------------------------------------------------------------------------------
!
!   bgw2para.f90
!   converts BerkeleyGW file WFN to PARATEC files WFN$n.$s and BAND
!   written by M. Jain (May 2010)
!
!-------------------------------------------------------------------------------

#include "f_defs.h"

program bgw2para

  use global_m
  use band_m
  use input_utils_m
  use iolib_m
  use wfn_rho_vxc_io_m

  implicit none

  type(band) :: bands
  type(crystal) :: crys
  type(kpoints) :: kp
  type(symmetry) :: syms
  type(gspace) :: gvec

  character(len=11) :: file_wfn
  character(len=24) :: bdate
  character(len=8) :: btime
  character(len=11) :: cdate
  character(len=14) :: stime
  integer :: iproc

  integer :: i, ib
  integer :: ik, ig, ngk_local, is
  integer ::  nstart_local
  integer, allocatable :: gvec_local(:,:)
  integer, allocatable :: ngk_dist(:), ngk_start(:), ngk_end(:), ngk_t(:)
  complex(DPC), allocatable :: zc(:,:), wfn(:,:,:)
  SCALAR, allocatable :: temp(:,:)
  real(DP), allocatable :: ekin(:)
  integer :: nargs, iflavor
  character(len=80) :: infile, usage
  character(len=3) :: sheader

  usage = 'Usage: bgw2para.x infile'

  call peinfo_init()

  if (peinf%inode == 0) then
    nargs = iargc()

    if (nargs .ne. 1) then
      call die(usage)
    endif

    call getarg(1, infile)

    call open_file(unit=10, file=infile, form='unformatted', status='old')
  endif

  sheader = 'WFN'
  iflavor = 0
  call read_binary_header_type(10, sheader, iflavor, kp, gvec, syms, crys, warn = .false.)

! Assign the band values to the corresponding ones...
  bands%nspin = kp%nspin
  bands%nrk = kp%nrk
  bands%min(1) = kp%mnband
  bands%min(2) = kp%mnband
  bands%max = kp%mnband

  SAFE_ALLOCATE(bands%nband, (kp%nrk, kp%nspin)) 
  bands%nband = 0 
  SAFE_ALLOCATE(bands%occup, (kp%mnband, kp%nrk, kp%nspin)) 
  bands%occup = 0d0 
  SAFE_ALLOCATE(bands%energy, (kp%mnband, kp%nrk, kp%nspin)) 
  bands%energy = 0d0 
  SAFE_ALLOCATE(bands%ekn, (kp%mnband, kp%nrk, kp%nspin)) 
  bands%ekn = 0d0 
  SAFE_ALLOCATE(bands%ifmax, (kp%nrk, kp%nspin)) 
  bands%ifmax = 0 
  do is = 1, kp%nspin
    do ik = 1, kp%nrk
      do i = 1, kp%mnband
         bands%energy(i, ik, is) = kp%el(i, ik, is)
         bands%occup(i, ik, is)  = kp%occ(i, ik, is)*kp%w(ik)*2.0d0
      enddo
      bands%nband(ik, is) = kp%mnband
      bands%ifmax(ik,is) = kp%ifmax(ik,is)
    enddo
  enddo

  SAFE_ALLOCATE(gvec%components, (3, gvec%ng))
  call read_binary_gvectors(10, gvec%ng, gvec%ng, gvec%components)

  SAFE_ALLOCATE(zc, (kp%ngkmax, kp%nspin))
  SAFE_ALLOCATE(ngk_dist, (peinf%npes))
  SAFE_ALLOCATE(ngk_start, (peinf%npes))
  SAFE_ALLOCATE(ngk_end, (peinf%npes))
  SAFE_ALLOCATE(ngk_t, (peinf%npes))

  do ik = 1, kp%nrk
      call read_binary_gvectors(10, kp%ngk(ik), gvec%ng, gvec%components)

    ! Calculate the local dimensions, start and end (wrt to global index)
    if (peinf%inode .lt. mod(kp%ngk(ik), peinf%npes)) then
      ngk_local = kp%ngk(ik)/peinf%npes + 1
      nstart_local = peinf%inode*ngk_local
    else
      ngk_local = kp%ngk(ik)/peinf%npes 
      nstart_local = peinf%inode*ngk_local + mod(kp%ngk(ik),peinf%npes)
    endif
    ngk_dist = 0
    ngk_start = 0
    ngk_end = 0
    ngk_dist(peinf%inode+1) = ngk_local
    ngk_start(peinf%inode+1) = nstart_local
#ifdef MPI
    ngk_t = 0
    call mpi_allreduce(ngk_dist,ngk_t,peinf%npes,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,mpierr)
    ngk_dist = ngk_t
    ngk_t = 0
    call mpi_allreduce(ngk_start,ngk_t,peinf%npes,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,mpierr)
    ngk_start = ngk_t
#endif

    ! Now everyone knows where everyone begins and how many G-vectors they hold

    SAFE_ALLOCATE(gvec_local, (3,ngk_local))
    if (peinf%inode == 0) then
      SAFE_ALLOCATE(ekin, (kp%ngk(ik)))
      call kinetic_energies(gvec, crys%bdot, ekin, qvec = kp%rk(:, ik))
    endif
#ifdef MPI
    call mpi_scatterv(gvec%components(1,:),ngk_dist,ngk_start,MPI_INTEGER,gvec_local(1,:), &
      ngk_local,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
    call MPI_barrier(MPI_COMM_WORLD,mpierr)
    call mpi_scatterv(gvec%components(2,:),ngk_dist,ngk_start,MPI_INTEGER,gvec_local(2,:), &
      ngk_local,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
    call MPI_barrier(MPI_COMM_WORLD,mpierr)
    call mpi_scatterv(gvec%components(3,:),ngk_dist,ngk_start,MPI_INTEGER,gvec_local(3,:), &
      ngk_local,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
    call MPI_barrier(MPI_COMM_WORLD,mpierr)
#else
    gvec_local(:,:) = gvec%components(:,:)
#endif
    
    SAFE_ALLOCATE(wfn, (ngk_local,kp%mnband,kp%nspin))
    SAFE_ALLOCATE(temp, (kp%ngk(ik),kp%nspin))

    do ib = 1, kp%mnband
      call read_binary_data(10, kp%ngk(ik), kp%ngk(ik), kp%nspin, temp, bcast = .false.)
      if (peinf%inode == 0) then
        zc(1:kp%ngk(ik), 1:kp%nspin) = COMPLEXIFY(temp(1:kp%ngk(ik), 1:kp%nspin))
        do is = 1, kp%nspin
          do ig = 1, kp%ngk(ik)
            bands%ekn(ib,ik,is) = bands%ekn(ib,ik,is) + &
              ekin(ig)*real(zc(ig,is)*conjg(zc(ig,is)),dp)
          enddo
        enddo
      endif
#ifdef MPI
      call MPI_barrier(MPI_COMM_WORLD,mpierr)
#endif
      do is = 1, kp%nspin
#ifdef MPI
        call mpi_scatterv(zc(:,is),ngk_dist,ngk_start,MPI_DOUBLE_COMPLEX,wfn(:,ib,is), &
          ngk_local,MPI_DOUBLE_COMPLEX,0,MPI_COMM_WORLD,mpierr)
#else
        wfn(:,ib,is)=zc(:,is)
#endif
      enddo
#ifdef MPI
      call MPI_barrier(MPI_COMM_WORLD,mpierr)
#endif
    enddo ! ib

    ! For this k point all the data is now read and stored parallel fashion
    ! Write the corresponding WFN file
    
    do is = 1, kp%nspin
      write(file_wfn, 120) ik, is
      if (peinf%inode == 0) then
        call date_time(cdate, stime)
        write(bdate, '(a11,13x)') cdate
        write(btime, '(a8)') stime(1:8)
        write(6,*) "Opening file : ", file_wfn, " for writing!"
        call open_file(unit=21, file=file_wfn, form = 'unformatted', status = 'unknown')
        rewind(21)
        write(21) bdate, btime
        write(21) kp%mnband, 1
        call close_file(21)
      endif
#ifdef MPI
      call MPI_barrier(MPI_COMM_WORLD,mpierr)
#endif
      do iproc = 0, peinf%npes-1
        if (peinf%inode == iproc) then
          call open_file(unit = 21, file = file_wfn, position = 'append', status = 'unknown', form = 'unformatted')
          
          do ig = 1, ngk_local
            write(21) gvec_local(1,ig),gvec_local(2,ig),gvec_local(3,ig)
            write(21) (wfn(ig,ib,is), ib = 1, kp%mnband)
          enddo
          call close_file(21)
        endif
#ifdef MPI
        call MPI_barrier(MPI_COMM_WORLD,mpierr)
#endif
      enddo
#ifdef MPI
      call MPI_barrier(MPI_COMM_WORLD,mpierr)
#endif
      if(peinf%inode == 0) then
        call open_file(unit = 21, file = file_wfn, position = 'append', status = 'unknown', form = 'unformatted')
        write(21) -1234567, 0, 0
        call close_file(21)
      endif
    enddo
    
    SAFE_DEALLOCATE(wfn)
    SAFE_DEALLOCATE(gvec_local)
    if (peinf%inode .eq. 0) then
      SAFE_DEALLOCATE(ekin)
    end if
    SAFE_DEALLOCATE(temp)

  enddo

  call dealloc_header_type(sheader, crys, kp)
  SAFE_DEALLOCATE_P(gvec%components)

  SAFE_DEALLOCATE(zc)
  SAFE_DEALLOCATE(ngk_dist)
  SAFE_DEALLOCATE(ngk_start)
  SAFE_DEALLOCATE(ngk_end)
  SAFE_DEALLOCATE(ngk_t)
  
  if (peinf%inode == 0) then
    call write_band('BAND',bands)
    call close_file(10)
  endif
  
120 format('WFN',i5.5,'.',i1)
  
#ifdef MPI
  call MPI_Finalize(mpierr)
#endif
  
end program bgw2para

!===============================================================================
!
! Routines:
!
! 1. xvfilename()        Originally By gsm        Last Modified 9/1/2010 (gsm)
!
! Returns SIESTA file name SystemLabel.XV
!
! 2. kpfilename()        Originally By gsm        Last Modified 9/1/2010 (gsm)
!
! Returns SIESTA file name SystemLabel.KP
!
! 3. eigfilename()       Originally By gsm        Last Modified 9/1/2010 (gsm)
!
! Returns SIESTA file name SystemLabel.EIG
!
! 4. wfnrfilename()      Originally By gsm        Last Modified 9/1/2010 (gsm)
!
! Returns SIESTA file name SystemLabel{.K$k}.WF$n{.UP|.DOWN}{.REAL|.IMAG}.cube
!
! 5. rhorfilename()      Originally By gsm        Last Modified 9/1/2010 (gsm)
!
! Returns SIESTA file name SystemLabel.RHO{.UP|.DN}.cube
!
! 6. vtrfilename()       Originally By gsm        Last Modified 9/1/2010 (gsm)
!
! Returns SIESTA file name SystemLabel.VT{.UP|.DN}.cube
!
! 7. vhrfilename()       Originally By gsm        Last Modified 9/1/2010 (gsm)
!
! Returns SIESTA file name SystemLabel.VH.cube
!
!===============================================================================

#include "f_defs.h"

module name_m

  use global_m

  implicit none

  private

  public :: xvfilename, kpfilename, eigfilename, &
    wfnrfilename, rhorfilename, vtrfilename, vhrfilename

contains

!-------------------------------------------------------------------------------

subroutine xvfilename(systemlabel,filename)

  character(len=256), intent(in) :: systemlabel
  character(len=256), intent(out) :: filename
  
  PUSH_SUB(xvfilename)
  
  filename = TRUNC(systemlabel) // '.XV'
  
  POP_SUB(xvfilename)

  return

end subroutine xvfilename

!-------------------------------------------------------------------------------

subroutine kpfilename(systemlabel,filename)
  
  character(len=256), intent(in) :: systemlabel
  character(len=256), intent(out) :: filename
  
  PUSH_SUB(kpfilename)
  
  filename = TRUNC(systemlabel) // '.KP'
  
  POP_SUB(kpfilename)
  
  return
  
end subroutine kpfilename

!-------------------------------------------------------------------------------

subroutine eigfilename(systemlabel,filename)
  
  character(len=256), intent(in) :: systemlabel
  character(len=256), intent(out) :: filename
  
  PUSH_SUB(eigfilename)
  
  filename = TRUNC(systemlabel) // '.EIG'
  
  POP_SUB(eigfilename)
  
  return
  
end subroutine eigfilename

!-------------------------------------------------------------------------------

subroutine wfnrfilename(ik,is,ib,ip,ns,np,systemlabel,filename)
  
  integer, intent(in) :: ik,is,ib,ip,ns,np
  character(len=256), intent(in) :: systemlabel
  character(len=256), intent(out) :: filename
  
  character(len=16) :: c1,c2,s1,s2,s3,s4
  
  PUSH_SUB(wfnrfilename)
  
  write(c1,301)ik
  write(c2,301)ib
  
  if (np .eq. 1) then
    s1 = ''
  else
    s1 = '.K' // TRUNC(c1)
  endif
  
  s2 = '.WF' // TRUNC(c2)
  
  if (ns .eq. 1) then
    s3 = ''
  else
    if (is .eq. 1) then
      s3 = '.UP'
    elseif (is .eq. 2) then
      s3 = '.DOWN'
    else
      s3 = ''
    endif
  endif
  
  if (np .eq. 1) then
    s4 = ''
  else
    if (ip .eq. 1) then
      s4 = '.REAL'
    elseif (ip .eq. 2) then
      s4 = '.IMAG'
    else
      s4 = ''
    endif
  endif
  
  filename = TRUNC(systemlabel) // TRUNC(s1) // TRUNC(s2) // &
    TRUNC(s3) // TRUNC(s4) // '.cube'
  
  POP_SUB(wfnrfilename)
  
  return
  
301 format(i16)
  
end subroutine wfnrfilename

!-------------------------------------------------------------------------------

subroutine rhorfilename(is,ns,systemlabel,filename)
  
  integer, intent(in) :: is,ns
  character(len=256), intent(in) :: systemlabel
  character(len=256), intent(out) :: filename
  
  character(len=16) :: s1
  
  PUSH_SUB(rhorfilename)
  
  if (ns .eq. 1) then
    s1 = ''
  else
    if (is .eq. 1) then
      s1 = '.UP'
    elseif (is .eq. 2) then
      s1 = '.DN'
    else
      s1 = ''
    endif
  endif
  
  filename = TRUNC(systemlabel) // '.RHO' // TRUNC(s1) // '.cube'
  
  POP_SUB(rhorfilename)
  
  return
  
end subroutine rhorfilename

!-------------------------------------------------------------------------------

subroutine vtrfilename(is,ns,systemlabel,filename)
  
  integer, intent(in) :: is,ns
  character(len=256), intent(in) :: systemlabel
  character(len=256), intent(out) :: filename
  
  character(len=16) :: s1
  
  PUSH_SUB(vtrfilename)
  
  if (ns .eq. 1) then
    s1 = ''
  else
    if (is .eq. 1) then
      s1 = '.UP'
    elseif (is .eq. 2) then
      s1 = '.DN'
    else
      s1 = ''
    endif
  endif
  
  filename = TRUNC(systemlabel) // '.VT' // TRUNC(s1) // '.cube'
  
  POP_SUB(vtrfilename)
  
  return
  
end subroutine vtrfilename

!-------------------------------------------------------------------------------

subroutine vhrfilename(systemlabel,filename)
  
  character(len=256), intent(in) :: systemlabel
  character(len=256), intent(out) :: filename
  
  PUSH_SUB(vhrfilename)
  
  filename = TRUNC(systemlabel) // '.VH' // '.cube'
  
  POP_SUB(vhrfilename)
  
  return
  
end subroutine vhrfilename

!-------------------------------------------------------------------------------

end module name_m

!===============================================================================
!
! Modules:
!
! input_utils_m   Originally By DAS
!
!   Several routines useful for analysis after input of wavefunctions.
!
!===============================================================================

#include "f_defs.h"

module input_utils_m

  use global_m
  use blas_m
  implicit none

  private

  public ::               &
    assess_degeneracies,  &
    find_efermi,          &
    calc_qtot,            &
    gvec_index,           &
    kinetic_energies,     &
    check_trunc_kpts

contains

  !> calculates the degeneracy of each state in the kp object
  !> if sig is provided, dies if Sigma diagonals cannot be correctly calculated
  subroutine assess_degeneracies(kp, kp_el_extra, nband, efermi, tolerance, sig)
    type(kpoints), intent(inout) :: kp
    real(DP), intent(in) :: kp_el_extra(:, :) !< (kp%nrk, kp%nspin) !< one more band
    integer, intent(in) :: nband !< number of states
    real(DP), intent(in) :: efermi
    real(DP), intent(in) :: tolerance !< energy tolerance
    type(siginfo), optional, intent(in) :: sig

    integer :: ii, jj, ik, is
    real(DP) :: energy_compare
    character :: tmpstr*100,tmpstr1*16,tmpstr2*16
    logical :: written_header

    PUSH_SUB(assess_degeneracies)
    
    SAFE_ALLOCATE(kp%degeneracy, (nband, kp%nrk, kp%nspin))
    kp%degeneracy(:,:,:) = 1
    written_header = .false.

    do ii = 1, nband
      do jj = 1, nband + 1
        if(jj == ii) cycle ! self-degeneracy        
        do ik = 1, kp%nrk
          do is = 1, kp%nspin
            if(jj > nband) then
              energy_compare = kp_el_extra(ik, is)
            else
              energy_compare = kp%el(jj, ik, is)
            endif
            if(abs(kp%el(ii, ik, is) - energy_compare) .lt. tolerance) then
              kp%degeneracy(ii, ik, is) = kp%degeneracy(ii, ik, is) + 1

              if(abs(kp%el(ii, ik, is) - efermi / ryd) < tolerance) then
                if(.not. written_header) then
                  write(0,'(a)') "WARNING: Degeneracies at Fermi level:"
                  written_header = .true.
                endif
                write(0,'(a,i6,a,i6,a,i6)') 'k ', ik, ', spin ', is, ', band ', ii
              endif

              if(present(sig)) then
              ! There is a problem only if: we are trying to use q-symmetry,
              ! we are calculating Sigma for this k-point and band, and the
              ! other degenerate states are not being included.
                if(sig%qgridsym .and. any(sig%indkn(1:sig%nkn) == ik) .and. &
                  any(sig%diag(1:sig%ndiag) .eq. ii) .and. all(sig%diag(1:sig%ndiag) .ne. jj)) then
                  write(tmpstr1,660) ii
                  write(tmpstr2,660) jj
660               format(i16)
                  write(tmpstr,'(a,a,a,a)') "Cannot correctly calculate Sigma for band ", TRUNC(tmpstr1), &
                    " without its degenerate partner ", TRUNC(tmpstr2)
                  write(0,'(a)') "Run degeneracy_check.x for allowable numbers or set no_symmetries_q_grid."
                  call die(tmpstr)
                endif
              endif

            endif
          enddo ! is
        enddo ! ik
      enddo ! ii
    enddo ! jj
    if(written_header) write(0,*)

    POP_SUB(assess_degeneracies)
    return
  end subroutine assess_degeneracies


  !---------------------------------------------------------------------------------------------------
  !> only fine unshifted grids use should_search = .true., should_update = .true.
  !! coarse grids have should_search, should update true or false depending on eqp corrections vs fine grid
  !! shifted grids use should_search = .false. (since may have only valence bands), should_update = .false.
  subroutine find_efermi(rfermi, efermi, efermi_input, kp, nband, minband, label, should_search, should_update, &
    write7, dont_die_consistency)
    logical, intent(in) :: rfermi         !< relative or absolute Fermi level
    real(DP), intent(inout) :: efermi
    real(DP), intent(in) :: efermi_input  !< used to see if different from previous Fermi level
    type(kpoints), intent(inout) :: kp
    integer, intent(in) :: nband          !< total number of bands to consider
    integer, intent(in) :: minband        !< lowest band to consider
    character(len=*), intent(in) :: label !< name to be used in output
    logical, intent(in) :: should_search  !< if true, efermi is calculated
    logical, intent(in) :: should_update  !< if true, efermi is reset
    logical, intent(in) :: write7         !< write to unit 7 as well as unit 6
    !> If .true., don`t die if the consistency of ifmin/ifmax are wrong.
    !! This is only ok in inteqp with unrestricted_transformation. Default=.false.
    logical, intent(in), optional :: dont_die_consistency

    integer :: ik, is, ib, consistency_err
    real(DP) :: emiddle, efermi_temp
    logical :: should_reset_fermi, should_warn_occ, first_occ_warning, die_consistency
    real(DP), allocatable :: vbm(:,:), cbm(:,:)

    PUSH_SUB(find_efermi)

    die_consistency = .true.
    if (present(dont_die_consistency)) then
      die_consistency = .not. dont_die_consistency
    endif

    should_reset_fermi = .false.
    if(should_update .and. .not. should_search) then
      call die("BUG: cannot call find_efermi with should_update but not should_search")
    endif

    if(nband < 1 .or. nband > kp%mnband) then
      call die("find_efermi: nband out of bounds")
    endif

    if(peinf%inode == 0) then
      write(6,900) TRUNC(label), maxval(kp%ifmax(1:kp%nrk, 1:kp%nspin))
      if(write7) write(7,900) TRUNC(label), maxval(kp%ifmax(1:kp%nrk, 1:kp%nspin))
900   format(1x,'Highest occupied band (', a, ') =',i3)     
    endif

    if(all(kp%ifmax(1:kp%nrk, 1:kp%nspin) <= 0)) then
      call die("All k-points have no occupied bands.")
    endif

    if(should_search) then
      if(any(kp%ifmax(1:kp%nrk, 1:kp%nspin) < nband)) then
        SAFE_ALLOCATE(vbm, (1:kp%nrk, 1:kp%nspin))
        SAFE_ALLOCATE(cbm, (1:kp%nrk, 1:kp%nspin))
        do is=1,kp%nspin
          do ik=1,kp%nrk
            vbm(ik, is) = maxval(kp%el(minband:kp%ifmax(ik, is), ik, is))
            cbm(ik, is) = minval(kp%el(kp%ifmax(ik, is)+1:nband, ik, is))
          enddo
        enddo
        emiddle = (maxval(vbm) + minval(cbm)) / 2.0d0
        if(peinf%inode == 0) then
          write(6,901) 'Valence max   ', TRUNC(label), maxval(vbm)*ryd
          write(6,901) 'Conduction min', TRUNC(label), minval(cbm)*ryd
          write(6,901) 'Middle energy ', TRUNC(label), emiddle*ryd
          if(write7) then
            write(7,901) 'Valence max   ', TRUNC(label), maxval(vbm)*ryd
            write(7,901) 'Conduction min', TRUNC(label), minval(cbm)*ryd
            write(7,901) 'Middle energy ', TRUNC(label), emiddle*ryd
          endif
901       format(1x,a,' (', a, ') =',f14.6,1x,'eV')
        endif

        ! check for consistency: i.e. no valence band or conduction band is on the wrong side of the Fermi energy
        consistency_err = 0 !0 = no error
        do is = 1, kp%nspin
          do ik = 1, kp%nrk
            if(kp%ifmax(ik, is) > 0) then
              if(any(kp%el(minband:kp%ifmax(ik, is), ik, is) > emiddle + TOL_Zero)) then
                consistency_err = ior(consistency_err, 1)
              endif
            endif
            if(kp%ifmax(ik, is) + 1 <= nband) then
              if(any(kp%el(kp%ifmax(ik, is) + 1:nband, ik, is) < emiddle - TOL_Zero)) then
                consistency_err = ior(consistency_err, 2)
              endif
            endif
          enddo
        enddo
        if (consistency_err>0 .and. die_consistency) then
          if (peinf%inode==0) then
            write(0,*)
            write(0,*) 'WFN ifmin/ifmax fields are inconsistent:'
            if (iand(consistency_err, 1)==1) then
              write(0,*) ' - there is a valence state above the middle energy'
            endif
            if (iand(consistency_err, 2)==2) then
              write(0,*) ' - there is a conduction state below the middle energy'
            endif
            write(0,*) 'Possible causes are:'
            write(0,*) '(1) Your k-point sampling is too coarse and cannot resolve the Fermi energy.'
            write(0,*) ' Try to carefully inspect your mean-field energies, and consider using a finer k-grid.'
            write(0,*) '(2) You are using eqp.dat and the QP corrections change the character of some states'
            write(0,*) ' from valence<->conduction. In this case, you should use another mean-field theory'
            write(0,*) ' that gives the same ground state as your GW calculation.'
            write(0,*) '(3) You are running inteqp, but you are either shifting the Fermi energy or using '
            write(0,*) ' restricted transformation.'
          endif
          call die("WFN ifmin/ifmax fields are inconsistent", only_root_writes = .true.)
        else if (consistency_err>0 .and. peinf%inode==0) then
          write(0,*)
          write(0,*) 'WARNING: ifmin/ifmax fields are inconsistent. Beware that the reported Fermi '
          write(0,*) ' and middle energy are probably wrong, as well as the order of the states.'
          write(0,*)
        endif

        ! adjust by level set in input file if appropriate
        if(rfermi) then
          efermi_temp = emiddle * ryd + efermi_input
        else
          efermi_temp = efermi_input
        endif
        if(peinf%inode == 0) then
          write(6,902) TRUNC(label), efermi_temp
          if(write7) write(7,902) TRUNC(label), efermi_temp
902       format(1x,'Fermi  energy  (', a, ') =',f14.6,1x,'eV',/)
        endif

        if(should_update) then
          efermi = efermi_temp
        endif
        
        should_reset_fermi = (abs(efermi / ryd - emiddle) .gt. TOL_Small)
      else
        if(peinf%inode == 0) write(0,'(a)') &
          'WARNING: There are only valence bands present; cannot determine Fermi energy.'
        if ((rfermi.and.efermi_input/=0).or..not.rfermi) then
          call die('No conduction bands; cannot determine nor shift the Fermi energy.', &
            only_root_writes=.true.)
        endif
        ! pick a large arbitrary value to initialize and make sure we consider all the bands fully occupied
        if(should_update) efermi = INF
      endif
    endif ! should_search

    ! reset ifmax if Fermi level was moved by input file, or using Fermi level from other wfns
    ! if neither of these is true, we should have died above if any occs are inconsistent with Fermi level!
    ! FHJ: reset occupations if we are dealing with...
    !  1) a regular WFN_fi file (should_search/update==.true.) and the FE changed; or
    !  2) a WFNq_fi file (should_search/update==.false.), in any condition; or
    !  3) BSE/input_co.f90 (should_search==.true.) with eqp_co (should_update=.true.)
    !     and the FE changed => equivalent to (1)
    if ( (should_update.and.should_reset_fermi).or.(.not.should_search) ) then

!FHJ: never warn about resetting occupations if we manually moved the FE
      should_warn_occ = (peinf%inode==0) .and. ((dabs(efermi_input)<TOL_SMALL).and.rfermi)
      first_occ_warning = .true.

      do is = 1, kp%nspin
        do ik = 1, kp%nrk
          if (kp%ifmin(ik, is) == 0 .and. kp%el(1, ik, is) .lt. efermi / ryd) then
            kp%ifmin(ik, is) = 1
          endif
          if(kp%ifmin(ik, is) == 0) cycle
          do ib = max(minband, kp%ifmin(ik, is)), nband - 1
            if (kp%el(ib, ik, is) .lt. efermi / ryd .and. kp%el(ib + 1, ik, is) .gt. efermi / ryd) then
              if(kp%ifmax(ik, is) /= ib) then
                if (should_warn_occ) then
                  if (first_occ_warning) then
                    write(0,'(3a)') ' WARNING: resetting occupations of ', TRUNC(label), ' according to Fermi level.'
                    write(0,'(a)') ' Make sure your shifted and unshifted WFNs are consistent. The following kpoints'
                    write(0,'(a)') '  had their occupations reset (spin, kpoint, original band, energy, reset band, energy):'
                    first_occ_warning = .false.
                  endif
                  write(0,'(3i9,f12.6,i9,f12.6)') is, ik, kp%ifmax(ik, is), &
                    kp%el(kp%ifmax(ik,is), ik, is)*ryd, ib, kp%el(ib, ik, is)*ryd
                endif
                kp%ifmax(ik, is) = ib
                kp%occ(ib+1:, ik, is) = 0.0
                kp%occ(:ib, ik, is) = 1.0
                cycle !FHJ: we can`t reset a kpt twice!
              endif
            endif
          enddo
        enddo
      enddo
      if (.not.first_occ_warning) write(0, *)
    endif !should_reset_fermi .or.

!FHJ: TODO - create input flag to output occupations.
!    call write_occupations(kp)
    POP_SUB(find_efermi)
    return
  end subroutine find_efermi

  !> Write LDA energies, shifted energies and occupations to file OCCUPATIONS.
  !!
  !! Useful to debug whether scissors operators/spline adjustment to band
  !! structure is correct.
  subroutine write_occupations(kp)
    type (kpoints), intent(in) :: kp
    integer :: is, ik, nb

    PUSH_SUB(write_occupations)
    nb=8 !TODO create an input flag to set number of energies to output
    if (peinf%inode==0) then
      call open_file(unit=60, file="OCCUPATIONS", status='replace', form='formatted')
      write(60, '(a)') '# kx ky kz  spin  ifmin ifmax'
      write(60, '(a)') '#   LDA energies before shift (in eV)'
      write(60, '(a)') '#   LDA energies after scissors/spline shift (in eV)'
      write(60, '(a)') '#   occupations'

      do is=1, kp%nspin
        do ik = 1, kp%nrk
          write(60, '(3(F9.5,1x),4x,I1,2x,I3,1x,I3)') kp%rk(:, ik), is, kp%ifmin(ik, is), kp%ifmax(ik, is)
          write(60, '(2x, 8(F12.5,1x))') kp%elda(1:8, ik, is)
          write(60, '(2x, 8(F12.5,1x))') kp%el(1:8, ik, is)*ryd
          write(60, '(2x, 8(F12.5,1x))') kp%occ(1:8, ik, is)
        enddo
      enddo
      call close_file(60)
    endif

    POP_SUB(write_occupations)
    return
  end subroutine write_occupations

  !---------------------------------------------------------------------------------------------------
  subroutine calc_qtot(kp, celvol, efermi, qtot, omega_plasma, write7)
    type (kpoints), intent(in) :: kp
    real(DP), intent(in) :: celvol
    real(DP), intent(in) :: efermi
    real(DP), intent(out) :: qtot
    real(DP), intent(out) :: omega_plasma
    logical, intent(in) :: write7

    integer :: is, ik
    real(DP) :: qkpt

    PUSH_SUB(calc_qtot)

    qtot = 0.0d0
    do is = 1, kp%nspin
      do ik = 1, kp%nrk
        if(kp%ifmax(ik, is) == 0) then
          if(kp%el(1, ik, is) < efermi / ryd + TOL_Degeneracy) then
            qkpt = 0.5d0
          else
            qkpt = 0.0d0
          endif
        else
          qkpt = kp%ifmax(ik, is) - kp%ifmin(ik, is)
          if(kp%el(kp%ifmax(ik, is), ik, is) > efermi / ryd - TOL_Degeneracy) then
            qkpt = qkpt + 0.5d0
          else
            qkpt = qkpt + 1.0d0
          endif
        endif
        qtot = qtot + qkpt * kp%w(ik)
      enddo
    enddo

    qtot = qtot * 2.0d0 / dble(kp%nspin*kp%nspinor)
    omega_plasma = 4.0d0 * sqrt(PI_D * qtot / celvol)

    if(peinf%inode == 0) then
      write(6,904) qtot
      if(write7) write(7,904) qtot
904   format(1x,'Number of electrons per unit cell =',f11.6)
      if(abs(qtot - nint(qtot)) > TOL_Small * 100) then
        write(0,'(a)') " WARNING: Fractional number of electrons per unit cell."
      endif
      if(qtot < TOL_Small) then
        write(0,'(a)') " WARNING: No electrons per unit cell!"
      endif
      write(6,905) omega_plasma
      if(write7) write(7,905) omega_plasma
905   format(1x,'Plasma Frequency =',f11.6,1x,'Rydberg',/)
    endif

    POP_SUB(calc_qtot)
    return
  end subroutine calc_qtot

!> FOR HISTORICAL INTEREST: SIB describes original scheme, GSM describes new scheme
!! SIB: gvec%nFFTgridpts is product of 1+2*FFTgrid(i) over all directions i
!! gvec%index_vec(gvec%nFFTgridpts) is allocated.
!!
!! gvec%index_vec(:) is a table of g-vector addresses: put in address,
!! and get out g-vector index in gvec%components(1:3,index) so that
!! index = gvec%index_vec(address) points to gvec%components(:,index).
!!
!! What does this imply about the organization of gvec%components(:,:) ?
!! The address of gvec%components(:,i) is given by
!! address=((gx_i+gxmax)*(2*gymax+1)+gy_i+gymax)*(2*gzmax+1)+gz_i+gzmax+1
!! so that this means z-fastest, then y, then x.  Also the g-vectors
!! live on a grid that is 2*gmax+1 in each axial direction.
!!
!! gsm: saving on memory: FFTgrid is FFT grid size, gvec%nFFTgridpts=FFTgrid(1)*FFTgrid(2)*FFTgrid(3),
!! address=((g(1)+FFTgrid(1)/2)*FFTgrid(2)+g(2)+FFTgrid(2)/2)*FFTgrid(3)+g(3)+FFTgrid(3)/2+1

  !---------------------------------------------------------------------------------------------------
  !> Compute index_vec indices relating G-vectors in reduced coordinates to positions in the FFT grid
  subroutine gvec_index(gvec)
    type(gspace), intent(inout) :: gvec

    integer :: ig, iadd

    PUSH_SUB(gvec_index)

    gvec%nFFTgridpts = product(gvec%FFTgrid(1:3))
    SAFE_ALLOCATE(gvec%index_vec, (gvec%nFFTgridpts))

    gvec%index_vec(:)=0
    do ig = 1, gvec%ng
      ! if a mean-field code does not use the appropriate convention, this could happen.
      if(any(2 * gvec%components(1:3, ig) >= gvec%FFTgrid(1:3) .or. 2 * gvec%components(1:3, ig) < -gvec%FFTgrid(1:3))) &
        call die("gvectors must be in the interval [-FFTgrid/2, FFTgrid/2)")

      iadd = ((gvec%components(1,ig)+gvec%FFTgrid(1)/2)*gvec%FFTgrid(2)+gvec%components(2,ig)+ &
        gvec%FFTgrid(2)/2)*gvec%FFTgrid(3)+gvec%components(3,ig)+gvec%FFTgrid(3)/2+1
      gvec%index_vec(iadd) = ig
    enddo

    POP_SUB(gvec_index)
    return
  end subroutine gvec_index

  !-----------------------------------------------------------------
  !> This routine calculates the kinetic energies |G+q|^2 or |G|^2 for all
  !! the G-vectors in gvec%components using the reciprocal metric bdot:
  !!   ekin(ig) = \sum_{m,n} G(m,ig) B(m,n) G(n,ig)
  !! We perform the sum by first performing the Cholesky decomposition of B,
  !! B := U^T U. Then, we write V := U G and write ekin = V^T V
  !! Using Cholesky decomposition has the same flop count as using dgemms, but
  !! it`s easier for the compiler to vectorize.
  !!
  !! \param gvec gspace structure that contains all the gvectors gvec%components
  !! \param bdot reciprocal metric
  !! \param ekin array holding the output kinetic energies
  !! \param qvec use this to compute |q+G|^2 instead of |G|^2
  subroutine kinetic_energies(gvec, bdot, ekin, qvec)
    type(gspace), intent(in) :: gvec
    real(DP), intent(in) :: bdot(3, 3)
    real(DP), intent(out) :: ekin(:) !< (gvec%ng)
    real(DP), optional, intent(in) :: qvec(3)

    integer :: ig, info
    real(DP) :: qkv(3,gvec%ng), vmid(3), U(3,3) ! FHJ: stack allocation is faster!

    PUSH_SUB(kinetic_energies)

    if (present(qvec)) then
      do ig = 1,gvec%ng
        qkv(1:3,ig) = qvec(1:3) + gvec%components(1:3,ig)
      enddo
    else
      qkv(1:3,1:gvec%ng) = gvec%components(1:3,1:gvec%ng)
    endif

    U(1:3, 1:3) = bdot(1:3, 1:3)
    ! FHJ: Cholesky decomposition of the metric: bdot = U^T U
    call dpotrf('U', 3, U, 3, info)
    do ig = 1,gvec%ng
      vmid(1) = U(1,1)*qkv(1,ig) + U(1,2)*qkv(2,ig) + U(1,3)*qkv(3,ig)
      vmid(2) =                    U(2,2)*qkv(2,ig) + U(2,3)*qkv(3,ig)
      vmid(3) =                                       U(3,3)*qkv(3,ig)
      ekin(ig) = vmid(1)**2 + vmid(2)**2 + vmid(3)**2
    enddo

    POP_SUB(kinetic_energies)
    return
  end subroutine kinetic_energies

  !-----------------------------------------------------------------
  !> Write a warning if any k-point is nonzero in a truncated direction.
  subroutine check_trunc_kpts(itruncflag, kp)
    integer, intent(in) :: itruncflag
    type(kpoints), intent(in) :: kp
    
    if(peinf%inode /= 0) return
    PUSH_SUB(check_trunc_kpts)
    
    select case(itruncflag)
    case(0) ! none
    case(2) ! spherical
      if(any(abs(kp%rk(1:3,:)) > TOL_Zero)) &
        write(0,'(a)') 'WARNING: spherical truncation should not be done with k-sampling in any direction.'
      ! there is one exception: Hartree-Fock with the Spencer-Alavi scheme (Phys. Rev. B 77, 193110 (2008))
    case(4) ! cell_wire
      if(any(abs(kp%rk(1:2,:)) > TOL_Zero)) &
        write(0,'(a)') 'WARNING: cell_wire truncation should not be done with k-sampling in the x- or y-directions.'
    case(5) ! cell_box
      if(any(abs(kp%rk(1:3,:)) > TOL_Zero)) &
        write(0,'(a)') 'WARNING: cell_box truncation should not be done with k-sampling in any direction.'
    case(6) ! cell_slab
      if(any(abs(kp%rk(3,:)) > TOL_Zero)) &
        write(0,'(a)') 'WARNING: cell_slab truncation should not be done with k-sampling in the z-direction.'
    case default
      write(0,*) 'itruncflag = ', itruncflag
      call die("Unknown truncation type.")
    end select
    
    POP_SUB(check_trunc_kpts)
    return
  end subroutine check_trunc_kpts

end module input_utils_m

!==========================================================================
!
! Module push_pop_m     Originally By DAS
!
!   Create a stack trace of routines entered and exited, for debugging.
!   This only takes effect if the code is compiled with -DDEBUG.
!   Enable by setting 'debug_level' below, and recompile:
!     0: no debugging trace
!     1: only node 0 writes trace
!     2: all nodes write trace. Very slow.
!   Inspired by Octopus messages.F90 (originally revision 6920)
!
!==========================================================================

#include "f_defs.h"

module push_pop_m

  use message_m
  use nrtype_m
  use peinfo_m

  implicit none

#ifdef DEBUG

  private

  public ::              &
    open_debug_trace,    &
    push_sub,            &
    pop_sub,             &
    set_debug_level

  integer, parameter, private :: offset = 1000
  integer, parameter, private :: namelength = 100
  integer, private            :: debug_level = 0
  !< 0: no debugging trace
  !! 1: only node 0 writes trace
  !! 2: all nodes write trace. Very slow.
  logical, private            :: first_write = .true.

 !> The stack.
  character(len=namelength), public :: sub_stack(50)
  real(DP), public                  :: time_stack(50)
  integer, public                   :: stacksize = 0

contains

  ! ---------------------------------------------------------
  subroutine set_debug_level(level)
    integer, intent(in) :: level

    if(level < 0 .or. level > 2) call die("Invalid value for debug_level")
    debug_level = level
    
    return
  end subroutine set_debug_level

  ! ---------------------------------------------------------

  subroutine open_debug_trace(iunit)
    integer, intent(out) :: iunit

    character(len=6) :: filenum, pos
    character(len=7) :: status

    iunit = peinf%inode + offset
    write(filenum, '(i6.6)') iunit - offset

    if(first_write) then
      pos = 'rewind'
      first_write = .false.
      status = 'replace'
    else
      pos = 'append'
      status = 'old'
    endif
    call open_file(iunit, 'debug_trace.node.'//filenum, position=pos, status=status)

  end subroutine open_debug_trace

  ! ---------------------------------------------------------

  subroutine push_sub(sub_name)
    character(len=*), intent(in) :: sub_name

    integer :: iunit
    character(len=namelength) :: sub_name2

    if(debug_level == 0) return

    stacksize = stacksize + 1
    if(stacksize > 49) then
      sub_stack(50) = 'push_sub'
      call die('Too many recursion levels (max=50)')
    end if

    call trim_sub_name(sub_name, sub_name2)
    sub_stack(stacksize) = trim(sub_name2)

    if(debug_level > 1) then
      call open_debug_trace(iunit)
      call push_sub_write(iunit)
      ! close file to ensure flushing
      call close_file(iunit)
    else if(debug_level == 1 .and. peinf%inode == 0) then
      ! write to stderr if we are node 0
      call push_sub_write(0)
    end if

  contains

    subroutine push_sub_write(iunit_out)
      integer,  intent(in) :: iunit_out

      integer :: ii

      write(iunit_out,'(a)', advance='no') "* I | "
      do ii = stacksize - 1, 1, -1
        write(iunit_out,'(a)', advance='no') "..|"
      end do
      write(iunit_out,'(a)') trim(sub_name2)

    end subroutine push_sub_write

  end subroutine push_sub

  ! ---------------------------------------------------------

  subroutine pop_sub(sub_name)
    character(len=*), intent(in) :: sub_name

    integer :: iunit
    character(len=namelength) :: sub_name2
    character(len=namelength*3) :: tmp_str

    if(debug_level == 0) return

    call trim_sub_name(sub_name, sub_name2)

    if(stacksize <= 0) then
      stacksize = 1
      sub_stack(1) = 'pop_sub'
      write(tmp_str,'(a)') 'pop ' // trim(sub_name2) // ': Too few recursion levels.'
      call die(tmp_str)
    end if

    if(sub_name2 .ne. sub_stack(stacksize)) then
      write (tmp_str,'(a,3x,a,3x,a)') 'Wrong sub name on pop_sub ', &
        trim(sub_name2), trim(sub_stack(stacksize))
      call die(tmp_str)
    end if

    if(debug_level > 1) then
      call open_debug_trace(iunit)
      call pop_sub_write(iunit)
      ! close file to ensure flushing
      call close_file(iunit)
    else if (debug_level == 1 .and. peinf%inode == 0) then
      ! write to stderr if we are node 0
      call pop_sub_write(0)
    end if
    
    stacksize = stacksize - 1

  contains

    subroutine pop_sub_write(iunit_out)
      integer, intent(in) :: iunit_out

      integer :: ii

      write(iunit_out,'(a)', advance='no') "* O | "
      do ii = stacksize - 1, 1, -1
        write(iunit_out,'(a)', advance='no') "..|"
      end do
      write(iunit_out,'(a)') trim(sub_stack(stacksize))

    end subroutine pop_sub_write

  end subroutine pop_sub

  ! ---------------------------------------------------------

  ! remove leading directory names and slashes from routine names
  subroutine trim_sub_name(sub_name, output)
    character(len=*), intent(in)  :: sub_name
    character(len=*), intent(out) :: output

    integer :: ic, slash

    slash = 0 ! if no slash, take whole name
    do ic = 1, len(sub_name)
      if(sub_name(ic:ic) == '/') slash = ic
    enddo

    if(slash >= len(sub_name) - 1) then
      output = ""
    else
      output = sub_name(slash + 1:len(sub_name))
    endif

  end subroutine trim_sub_name

#endif

end module push_pop_m

!! Local Variables:
!! mode: f90
!! coding: utf-8
!! End:

!===============================================================================
!
! Routines:
!
! (1)  inteqp         Originally by JRD       Last Edited: 10/11/2010 (JRD)
!
! Extrapolates Eqp corrections from the coarse grid to the fine grid by
! a wavefunction-based plus linear interpolation scheme that preserves band crossings/character. 
! The code reads eqp_co.dat and writes eqp.dat and
! eqp_q.dat. The DFT wavefunctions for the interpolation are read
! from WFN_co, WFN_fi, and WFNq_fi files.
!
! See absorption.inp for options and keywords.
!
!================================================================================

#include "f_defs.h"

program inteqp

  use global_m
  use fullbz_m
  use inread_m
  use intwfn_m
  use bse_init_m
  implicit none

  type (crystal) :: crys
  type (symmetry) :: syms
  type (gspace) :: gvec
  type (eqpinfo) :: eqp
  type (xctinfo) :: xct
  type (flags) :: flag
  type (grid) :: kg_fi,kgq_fi
  type (kpoints) :: kp_fi,kpq_fi
  type (int_wavefunction) :: intwfnc
  type (int_wavefunction) :: intwfnv

  integer :: ii,ncount
  integer :: iunit_c,iunit_v
  real(DP) :: vol,omega_plasma
  real(DP) :: tsec(2),tmin(2),tmax(2)
  
  character*16, allocatable :: routnam(:)
  integer, allocatable :: routsrt(:)
  integer, allocatable :: fi2co_wfn(:,:),indexq_fi(:)
  real(DP), allocatable :: kco(:,:)
  character :: filename*20
  SCALAR, allocatable :: dcc(:,:,:,:,:),dvv(:,:,:,:,:)
  real(DP), allocatable :: intp_coefs(:,:)

  call peinfo_init()

!----------------------
! Initialize timer

  call timacc(0,0)
  call timacc(1,1)

!---------------------------
! Write header

  call write_program_header('BSE/IntEqp', .false.)

!---------------------------
! Read inteqp.inp
  
  call logit('Calling inread_inteqp')
  call open_file(8,file='inteqp.inp',form='formatted',status='old')
  call inread(eqp,xct,flag)
  call close_file(8)

! FHJ: Initialize xct%nkpt_co and dimentionality of the problem
  call bse_init(xct,flag)

!--------------------------
! Read wavefunctions on the fine grid

  call logit('Calling input')
  call timacc(2,1)
  call input(crys,gvec,kg_fi,kp_fi,syms,eqp,xct,flag,omega_plasma,.false.,intwfnc)

  vol = xct%nktotal*crys%celvol
  if (peinf%inode.eq.0) then
    write(6,*) ' '
    write(6,*) 'More Job Parameters: '
    write(6,'(a,f32.14,a)') ' Crystal volume = ',vol,' a.u.'
    write(6,*) 'Number of valence bands = ',xct%nvb_fi
    write(6,*) 'Number of cond. bands   = ',xct%ncb_fi
    write(6,*) 'Number of spins   = ',xct%nspin
    write(6,*) ' '
  endif
  call timacc(2,2)

  SAFE_ALLOCATE(indexq_fi, (xct%nkpt_fi))
!  if (flag%vm.ne.1.or.flag%dtm.ne.1) then ! both are always 0 in this code --DAS
  call timacc(3,1)
  call logit('Calling input_q')
  call input_q(kp_fi,crys,gvec,kg_fi,kgq_fi,kpq_fi,syms,xct,indexq_fi,eqp,flag,intwfnv)
  call timacc(3,2)

!------------------------------
! Calculate the transformation matrices from coarse grid wavefunctions
! FHJ: These are the final transformation coefs that will be used to interpolate
! the kernel. However, we might use an unrestricted version of dvv/dcc to
! interpolate eqp if xct%unrestricted_transf==.true..
  SAFE_ALLOCATE(dvv, (xct%nvb_fi,xct%n1b_co,xct%nspin,xct%nkpt_fi,xct%npts_intp_kernel))
  SAFE_ALLOCATE(dcc, (xct%ncb_fi,xct%n2b_co,xct%nspin,xct%nkpt_fi,xct%npts_intp_kernel))
  SAFE_ALLOCATE(kco, (3,xct%nkpt_co))
  SAFE_ALLOCATE(fi2co_wfn, (xct%npts_intp_kernel,xct%nkpt_fi))
  SAFE_ALLOCATE(intp_coefs, (xct%npts_intp_kernel, xct%nkpt_fi))

  call logit('Calling intwfn')
  call timacc(4,1)
  call intwfn(kp_fi,crys,syms,xct,flag,gvec,kg_fi,kgq_fi,dcc,dvv,&
    kco,fi2co_wfn,indexq_fi,eqp,intwfnv,intwfnc,intp_coefs)
  call timacc(4,2)

  call dealloc_grid(kg_fi)
  call dealloc_grid(kgq_fi)

!  if(peinf%inode.eq.0 .and. xct%iwriteint.eq.0) then
!    call close_file(126, delete = .true.) ! delete INT_CWFN_CO
!    call close_file(127, delete = .true.) ! delete INT_VWFN_CO
!    if (xct%qflag .eq. 0) then
!      call close_file(123, delete = .true.) ! delete INT_CWFN_CO_Q
!      call close_file(124, delete = .true.) ! delete INT_VWFN_CO_Q
!    endif
!  endif

  SAFE_DEALLOCATE_P(xct%ifmax)
  SAFE_DEALLOCATE_P(xct%ifmaxq)

  if (xct%iwriteint.eq.1) then
    SAFE_DEALLOCATE_P(intwfnc%cgk)
    SAFE_DEALLOCATE_P(intwfnv%cgk)
    SAFE_DEALLOCATE_P(intwfnc%isort)
    SAFE_DEALLOCATE_P(intwfnv%isort)
  endif

! JRD: Now close the no-longer-needed wavefunction files

  ! intwfn deletes INT_CWFN_CO, INT_CWFN_CO_Q, INT_VWFN_CO, INT_VWFN_CO_Q itself
  if (xct%iwriteint.eq.0) then
    write(filename,'(a,i4.4)') 'INT_VWFNQ_', peinf%inode
    iunit_v = 128+(2*peinf%inode)+2
    call open_file(iunit_v, filename, status = 'old')
    call close_file(iunit_v, delete = .true.) ! files INT_VWFNQ_*
    
    write(filename,'(a,i4.4)') 'INT_CWFN_', peinf%inode
    iunit_c = 128+(2*peinf%inode)+1
    call open_file(iunit_c, filename, status = 'old')
    call close_file(iunit_c, delete = .true.) ! files INT_CWFN_*
  endif

  SAFE_DEALLOCATE_P(eqp%ecqp)
  SAFE_DEALLOCATE_P(eqp%evqp)
  
#ifdef MPI
  call MPI_BARRIER(MPI_COMM_WORLD,mpierr)
#endif

!--------------------------------
! Time accounting

  SAFE_ALLOCATE(routnam, (60))
  routnam(1)='TOTAL:'
  routnam(2)='INPUT:'
  routnam(3)='INPUT_Q:'
  routnam(4)='INTWFN:'
  routnam(5)='INTKERNEL:'
  routnam(6)='PEIG_INTER:'
  routnam(41)='IW Input_co:'
  routnam(42)='IW Interp:'
  routnam(43)='IW Genwf:'
  routnam(44)='IW Gwnwf_Co:'
  routnam(45)='IW Mtxel_t:'
  routnam(46)='IW Write:'
  routnam(47)='IW Reduce:'
  SAFE_ALLOCATE(routsrt, (13))
  routsrt=(/ (ii,ii=2,6), (ii,ii=41,47), 1 /)
  
  call timacc(1,2)
  if(peinf%inode.eq.0) then
    write(6,*)
    write(6,9000) 'CPU [s]','WALL [s]','#'
    write(6,*)
  endif
 
  do ii=1,ubound(routsrt, 1)
    call timacc(routsrt(ii),3,tsec,ncount)
#ifdef MPI
    call MPI_ALLREDUCE(tsec,tmin,2,MPI_REAL_DP,MPI_MIN,MPI_COMM_WORLD,mpierr)
    call MPI_ALLREDUCE(tsec,tmax,2,MPI_REAL_DP,MPI_MAX,MPI_COMM_WORLD,mpierr)
#else
    tmin = tsec
    tmax = tsec
#endif
    if(peinf%inode==0) then
      if (ii>1) then
        if (routsrt(ii)-routsrt(ii-1)/=1) write(6,*)
      endif
      write(6,9001) routnam(routsrt(ii)),tmin(1),tmin(2),ncount
      write(6,9002) tsec(1),tsec(2)
      write(6,9003) tmax(1),tmax(2)
    endif
  enddo
  
9000 format(17x,a13,  3x,a13,  3x,a8)
9001 format(1x,a11,'(min.)',f13.3,3x,f13.3,3x,i8)
9002 format(  12x,'(PE 0)',f13.3,3x,f13.3)
9003 format(  12x,'(max.)',f13.3,3x,f13.3)

  call write_memory_usage()

#ifdef MPI
  call MPI_FINALIZE(mpierr)
#endif
  
end program inteqp

!===============================================================================
!
! Routines:
!
!
!===============================================================================

#include "f_defs.h"

module read_rho_vxc_m

  use global_m
  use gmap_m
  use wfn_rho_vxc_io_m

  implicit none

  private

  public :: read_vxc, read_rho

contains

  !---------------------------------------------------------------------------------------------------
  !> Read in the exchange-correlation potential and store in array sig%vxc
  subroutine read_vxc(sig, gvec, kp, syms, crys, isrti, isrt, vxc2_flag)
    type(siginfo), intent(inout) :: sig
    type(gspace), intent(in) :: gvec
    type(kpoints), intent(in) :: kp
    type(symmetry), intent(in) :: syms
    type(crystal), intent(in) :: crys
    integer, intent(in) :: isrti(:) !< (gvec%ng)
    integer, intent(in) :: isrt(:) !< (gvec%ng)
    logical, intent(in) :: vxc2_flag
    
    character*3 :: sheader
    integer :: iflavor, ig, ispin
    type(gspace) :: gvec_dummy
    type(crystal) :: crys_dummy
    type(symmetry) :: syms_dummy
    type(kpoints) :: kp_dummy
    real(DP) :: discrepancy
    
    PUSH_SUB(read_vxc)
    
    call logit('Reading VXC')
    if (vxc2_flag) then
      SAFE_ALLOCATE(sig%vxc2, (gvec%ng,kp%nspin*kp%nspinor**2))
    else
      SAFE_ALLOCATE(sig%vxc, (gvec%ng,kp%nspin*kp%nspinor**2))
    endif
    
    if (vxc2_flag) then
      if(peinf%inode == 0) call open_file(96,file='VXC2',form='unformatted',status='old')
    else
      if(peinf%inode == 0) call open_file(96,file='VXC',form='unformatted',status='old')
    endif
    
    sheader = 'VXC'
    iflavor = 0
    call read_binary_header_type(96, sheader, iflavor, kp_dummy, gvec_dummy, syms_dummy, &
         crys_dummy, warn = .false.)
    
    call check_header('WFN_inner', kp, gvec, syms, crys, 'VXC', kp_dummy, gvec_dummy, &
         syms_dummy, crys_dummy, is_wfn = .false.)
    
    SAFE_ALLOCATE(gvec_dummy%components, (3, gvec_dummy%ng))
    call read_binary_gvectors(96, gvec_dummy%ng, gvec_dummy%ng, gvec_dummy%components)
    do ig = 1, gvec%ng
      if(any(gvec_dummy%components(:,isrt(ig)) .ne. gvec%components(:,ig))) call die("gvec mismatch in VXC")
    enddo
    SAFE_DEALLOCATE_P(gvec_dummy%components)
    
    if (vxc2_flag) then
      call read_binary_data(96, gvec_dummy%ng, gvec_dummy%ng, kp%nspin*kp%nspinor**2, sig%vxc2, gindex = isrti)
    else
      call read_binary_data(96, gvec_dummy%ng, gvec_dummy%ng, kp%nspin*kp%nspinor**2, sig%vxc, gindex = isrti)
    endif
    
    if(peinf%inode == 0) then
      call close_file(96)

      if (vxc2_flag) then
        do ispin = 1, kp%nspin*kp%nspinor**2
          discrepancy = check_field_is_real(sig%vxc2(:, ispin), gvec)
          if(discrepancy > TOL_Zero) then
            write(0,*) 'WARNING: VXC2 is not real in real space, with discrepancy ', discrepancy, ' for spin ', ispin
          endif
        enddo
      else
        do ispin = 1, kp%nspin*kp%nspinor**2
          discrepancy = check_field_is_real(sig%vxc(:, ispin), gvec)
          if(discrepancy > TOL_Zero) then
            write(0,*) 'WARNING: VXC is not real in real space, with discrepancy ', discrepancy, ' for spin ', ispin
          endif
        enddo
      endif
    endif

    call dealloc_header_type(sheader, crys_dummy, kp_dummy)
    
    PUSH_SUB(read_vxc)
    
  end subroutine read_vxc

  !---------------------------------------------------------------------------------------------------
  !> Read in the charge density and store in array wpg%rho (formerly known as CD95)
  !! CD95 Ref: http://www.nature.com/nature/journal/v471/n7337/full/nature09897.html
  subroutine read_rho(wpg, gvec, kp, syms, crys, isrti, isrt, check_filename)
    type(wpgen), intent(inout) :: wpg
    type(gspace), intent(in) :: gvec
    type(kpoints), intent(in) :: kp
    type(symmetry), intent(in) :: syms
    type(crystal), intent(in) :: crys
    integer, intent(in) :: isrti(:) !< (gvec%ng)
    integer, intent(in) :: isrt(:) !< (gvec%ng)
    character(len=*), intent(in) :: check_filename !< This is the file
                                            !< against which the header is
                                            !< checked

    
    character*3 :: sheader
    integer :: iflavor, ig, ispin
    type(gspace) :: gvec_dummy
    type(crystal) :: crys_dummy
    type(symmetry) :: syms_dummy
    type(kpoints) :: kp_dummy
    real(DP) :: discrepancy
    
    PUSH_SUB(read_rho)
    
    call logit('Reading RHO')
    
    SAFE_ALLOCATE(wpg%rho, (gvec%ng,kp%nspin))
    
    if(peinf%inode == 0) call open_file(95,file='RHO',form='unformatted',status='old')
    
    sheader = 'RHO'
    iflavor = 0
    call read_binary_header_type(95, sheader, iflavor, kp_dummy, gvec_dummy, &
        syms_dummy, crys_dummy, warn = .false.)
    
    call check_header(trim(check_filename), kp, gvec, syms, crys, 'RHO', kp_dummy, &
        gvec_dummy, syms_dummy, crys_dummy, is_wfn = .false.)
    
    SAFE_ALLOCATE(gvec_dummy%components, (3, gvec_dummy%ng))
    call read_binary_gvectors(95, gvec_dummy%ng, gvec_dummy%ng, gvec_dummy%components)
    do ig = 1, gvec%ng
      if(any(gvec_dummy%components(:,isrt(ig)) .ne. gvec%components(:,ig))) call die("gvec mismatch in RHO")
    enddo
    SAFE_DEALLOCATE_P(gvec_dummy%components)
    
    call read_binary_data(95, gvec_dummy%ng, gvec_dummy%ng, kp%nspin, wpg%rho, gindex = isrti)
    
    if(peinf%inode == 0) call close_file(95)
    
    ! otherwise if nspin == 1, the 2 component may be uninitialized to NaN
    wpg%wpsq(1:2) = 0d0
    wpg%nelec(1:2) = 0d0
    
    ! since they are sorted, if G = 0 is present, it is the first one
    if(any(gvec%components(1:3, 1) /= 0)) call die("gvectors for RHO must include G = 0")
    ! otherwise, the code below will not do what we think it does
    
#ifdef CPLX
    if(any(abs(aimag(wpg%rho(1,:))) > TOL_Zero)) then
      call die("Charge density in RHO has imaginary part for G=0", only_root_writes = .true.)
    endif
#endif
    
    do ispin=1,kp%nspin
      wpg%nelec(ispin)=dble(wpg%rho(1,ispin))
      wpg%wpsq(ispin)=ryd*ryd*16.0d0*PI_D*wpg%nelec(ispin)/crys%celvol
    enddo
    
    ! This is unacceptable because it means the number of electrons is negative,
    ! and the plasma frequency will be imaginary!
    if(any(wpg%nelec(1:kp%nspin) < TOL_Zero)) then
      write(0,*) wpg%nelec(:)
      call die("Charge density in RHO has negative part for G=0", only_root_writes = .true.)
    endif

    if(peinf%inode == 0) then
      do ispin = 1, kp%nspin
        discrepancy = check_field_is_real(wpg%rho(:, ispin), gvec)
        if(discrepancy > TOL_Zero) then
          write(0,*) 'WARNING: RHO is not real in real space, with discrepancy ', discrepancy, ' for spin ', ispin
        endif
      enddo
    endif
    
    call dealloc_header_type(sheader, crys_dummy, kp_dummy)

    POP_SUB(read_rho)
  end subroutine read_rho
  
  !---------------------------------------------------------------------------------------------------
  !> RHO and VXC must be real in real space, i.e. c(G) - c(-G)* = 0 
  real(DP) function check_field_is_real(field, gvec)
    SCALAR, intent(in) :: field(:)
    type(gspace), intent(in) :: gvec

    integer :: ig, umklapp(3)
    SCALAR :: diff
    type(symmetry) :: syms_inv
    integer, allocatable :: ind(:), identity(:)
    SCALAR, allocatable :: phase(:)

    PUSH_SUB(check_field_is_real)

    syms_inv%ntran = 1
    syms_inv%mtrx = 0
    syms_inv%tnp = 0d0
    syms_inv%mtrx(1:3, 1:3, 1) = reshape((/-1, 0, 0, 0, -1, 0, 0, 0, -1/), shape(syms_inv%mtrx(:,:,1)))
    umklapp(1:3) = 0

    SAFE_ALLOCATE(phase, (gvec%ng))
    SAFE_ALLOCATE(ind, (gvec%ng))
    SAFE_ALLOCATE(identity, (gvec%ng))

    do ig = 1, gvec%ng
      identity(ig) = ig
    enddo

    call gmap(gvec, syms_inv, gvec%ng, 1, umklapp, identity, identity, ind, phase, die_outside_sphere = .true.)
    if(any(abs(phase(1:gvec%ng) - 1d0) > TOL_Zero)) call die("non-unity phase in check_field_is_real")
    if(any(ind(1:gvec%ng) == 0)) call die("ind array from gmap has a zero")

    check_field_is_real = 0d0
    do ig = 1, gvec%ng
      diff = field(ig) - MYCONJG(field(ind(ig))*phase(ig))
      check_field_is_real = max(check_field_is_real, abs(diff))
    enddo

    SAFE_DEALLOCATE(phase)
    SAFE_DEALLOCATE(ind)
    SAFE_DEALLOCATE(identity)

    POP_SUB(check_field_is_real)
  end function check_field_is_real

end module read_rho_vxc_m

!!! this file contains post-espresso-5.1 commits: r11037, r11038 !!!

!
! Copyright (C) 2008-2012 Georgy Samsonidze
!
! Converts the output files produced by pw.x to the input files for BerkeleyGW.
!
!-------------------------------------------------------------------------------
!
! BerkeleyGW, Copyright (c) 2011, The Regents of the University of
! California, through Lawrence Berkeley National Laboratory (subject to
! receipt of any required approvals from the U.S. Dept. of Energy).
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are
! met:
!
! (1) Redistributions of source code must retain the above copyright
! notice, this list of conditions and the following disclaimer.
!
! (2) Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! (3) Neither the name of the University of California, Lawrence
! Berkeley National Laboratory, U.S. Dept. of Energy nor the names of
! its contributors may be used to endorse or promote products derived
! from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
! A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
! OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
! SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
! LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
! THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
! You are under no obligation whatsoever to provide any bug fixes,
! patches, or upgrades to the features, functionality or performance of
! the source code ("Enhancements") to anyone; however, if you choose to
! make your Enhancements available either publicly, or directly to
! Lawrence Berkeley National Laboratory, without imposing a separate
! written license agreement for such Enhancements, then you hereby grant
! the following license: a  non-exclusive, royalty-free perpetual
! license to install, use, modify, prepare derivative works, incorporate
! into other computer software, distribute, and sublicense such
! enhancements or derivative works thereof, in binary and source code
! form.
!
!-------------------------------------------------------------------------------
!
! pw2bgw subroutines:
!
! write_wfng  - generates complex wavefunctions in G-space (normalized to 1)
! real_wfng   - constructs real wavefunctions by applying the Gram-Schmidt
!               process (called from write_wfng)
! write_rhog  - generates real/complex charge density in G-space
!               (units of the number of electronic states per unit cell)
! calc_rhog   - computes charge density by summing over a subset of occupied
!               bands (called from write_rhog), destroys charge density
! write_vxcg  - generates real/complex exchange-correlation potential in
!               G-space (units of Rydberg) [only local part of Vxc]
! write_vxc0  - prints real/complex exchange-correlation potential at G=0
!               (units of eV) [only local part of Vxc]
! write_vxc_r - calculates matrix elements of exchange-correlation potential
!               in R-space (units of eV) [only local part of Vxc]
! write_vxc_g - calculates matrix elements of exchange-correlation potential
!               in G-space (units of eV) [supports non-local Vxc]
! write_vscg  - generates real/complex self-consistent potential in G-space
!               (units of Rydberg) [only local part of Vsc]
! write_vkbg  - generates complex Kleinman-Bylander projectors in G-space
!               (units of Rydberg)
! check_inversion - checks whether real/complex version is appropriate
!               (called from everywhere)
!
! Quantum ESPRESSO stores the wavefunctions in is-ik-ib-ig order
! BerkeleyGW stores the wavefunctions in ik-ib-is-ig order
! the outer loop is over is(QE)/ik(BGW) and the inner loop is over ig
! ik = k-point index, is = spin index, ib = band index, ig = G-vector index
!
! write_wfng reverts the order of is and ik using smap and kmap arrays,
! distributes wavefunctions over processors by ig (either real case or
! spin-polarized case), calls real_wfng that applies the Gram-Schmidt
! process (real case), reverts the order of is and ib (spin-polarized
! case), and writes wavefunctions to disk
!
!-------------------------------------------------------------------------------

module pw2bgw_m

  implicit none

  private

  public :: &
    write_wfng, &
    real_wfng, &
    write_rhog, &
    write_vxcg, &
    write_vxc0, &
    write_vxc_r, &
    write_vxc_g, &
    write_vscg, &
    write_vkbg, &
    check_inversion

contains

SUBROUTINE write_wfng ( output_file_name, real_or_complex, symm_type, &
  wfng_kgrid, wfng_nk1, wfng_nk2, wfng_nk3, wfng_dk1, wfng_dk2, &
  wfng_dk3, wfng_occupation, wfng_nvmin, wfng_nvmax )

  USE cell_base, ONLY : omega, alat, tpiba, tpiba2, at, bg, ibrav
  USE constants, ONLY : pi, tpi, eps6
  USE fft_base, ONLY : dfftp
  USE gvect, ONLY : ngm, ngm_g, ig_l2g, g, mill, ecutrho
  USE io_files, ONLY : iunwfc, nwordwfc
  USE io_global, ONLY : ionode, ionode_id
  USE ions_base, ONLY : nat, atm, ityp, tau
  USE kinds, ONLY : DP
  USE klist, ONLY : xk, wk, ngk, nks, nkstot
  USE lsda_mod, ONLY : nspin, isk
  USE mp, ONLY : mp_sum, mp_max, mp_get, mp_bcast, mp_barrier
  USE mp_global, ONLY : mpime, nproc, world_comm, kunit, me_pool, &
    root_pool, my_pool_id, npool, nproc_pool, intra_pool_comm
  USE mp_wave, ONLY : mergewf
  USE start_k, ONLY : nk1, nk2, nk3, k1, k2, k3
  USE symm_base, ONLY : s, ftau, nsym
  USE wavefunctions_module, ONLY : evc
  USE wvfct, ONLY : npwx, nbnd, npw, et, wg, g2kin, ecutwfc
#ifdef __PARA
  USE parallel_include, ONLY : MPI_DOUBLE_COMPLEX
#endif

  IMPLICIT NONE

  character ( len = 256 ), intent (in) :: output_file_name
  integer, intent (in) :: real_or_complex
  character ( len = 9 ), intent (in) :: symm_type
  logical, intent (in) :: wfng_kgrid
  integer, intent (in) :: wfng_nk1
  integer, intent (in) :: wfng_nk2
  integer, intent (in) :: wfng_nk3
  real (DP), intent (in) :: wfng_dk1
  real (DP), intent (in) :: wfng_dk2
  real (DP), intent (in) :: wfng_dk3
  logical, intent (in) :: wfng_occupation
  integer, intent (in) :: wfng_nvmin
  integer, intent (in) :: wfng_nvmax

  character :: cdate*9, ctime*9, sdate*32, stime*32, stitle*32
  logical :: proc_wf, bad_kgrid
  integer :: unit, i, j, k, cell_symmetry, nrecord
  integer :: id, ib, ik, iks, ike, is, ig, ierr
  integer :: nd, ntran, nb, nk_l, nk_g, ns, nst, nsf, ng_l, ng_g, npw_g2
  integer :: nkbl, nkl, nkr, ngg, npw_g, npwx_g
  integer :: local_pw, ipsour, igwx, ngkdist_g, ngkdist_l
  real (DP) :: alat2, recvol, dr1, t1 ( 3 ), t2 ( 3 )
  real (DP) :: r1 ( 3, 3 ), r2 ( 3, 3 ), adot ( 3, 3 )
  real (DP) :: bdot ( 3, 3 ), translation ( 3, 48 )
  integer, allocatable :: kmap ( : )
  integer, allocatable :: smap ( : )
  integer, allocatable :: ifmin ( : )
  integer, allocatable :: ifmax ( : )
  integer, allocatable :: itmp ( : )
  integer, allocatable :: ngk_g ( : )
  integer, allocatable :: ipmask ( : )
  integer, allocatable :: igwk ( : )
  integer, allocatable :: igwf_l2g ( : )
  integer, allocatable :: g_g ( :, : )
  integer, allocatable :: igk_l2g ( :, : )
  real (DP), allocatable :: et_g ( :, : )
  real (DP), allocatable :: wg_g ( :, : )
  real (DP), allocatable :: energy ( :, : )
  complex (DP), allocatable :: wfng ( : )
  complex (DP), allocatable :: wfng_buf ( :, : )
  complex (DP), allocatable :: wfng_dist ( :, :, : )

  INTEGER, EXTERNAL :: atomic_number

  CALL check_inversion ( real_or_complex, nsym, s, nspin, .true., .true. )

  IF ( real_or_complex .EQ. 1 .OR. nspin .GT. 1 ) THEN
    proc_wf = .TRUE.
  ELSE
    proc_wf = .FALSE.
  ENDIF

  bad_kgrid = .FALSE.
  IF ( wfng_kgrid ) THEN
    IF ( wfng_nk1 .LE. 0 .OR. wfng_nk2 .LE. 0 .OR. wfng_nk3 .LE. 0 ) &
      bad_kgrid = .TRUE.
  ELSE
    IF ( nk1 .LE. 0 .OR. nk2 .LE. 0 .OR. nk3 .LE. 0 ) &
      bad_kgrid = .TRUE.
  ENDIF
  IF ( bad_kgrid .AND. ionode ) THEN
    WRITE ( 6, 101 )
  ENDIF

  CALL date_and_tim ( cdate, ctime )
  WRITE ( sdate, '(A2,"-",A3,"-",A4,21X)' ) cdate(1:2), cdate(3:5), cdate(6:9)
  WRITE ( stime, '(A8,24X)' ) ctime(1:8)
  IF ( real_or_complex .EQ. 1 ) THEN
    WRITE ( stitle, '("WFN-Real",24X)' )
  ELSE
    WRITE ( stitle, '("WFN-Complex",21X)' )
  ENDIF

  unit = 4
  nrecord = 1
  nd = 3

  nb = nbnd
  nk_l = nks
  nk_g = nkstot
  ng_l = ngm
  ng_g = ngm_g
  call set_spin(ns,nst,nsf,nspin)

  nkbl = nkstot / kunit
  nkl = kunit * ( nkbl / npool )
  nkr = ( nkstot - nkl * npool ) / kunit
  IF ( my_pool_id .LT. nkr ) nkl = nkl + kunit
  iks = nkl * my_pool_id + 1
  IF ( my_pool_id .GE. nkr ) iks = iks + nkr * kunit
  ike = iks + nkl - 1

  ALLOCATE ( kmap ( nk_g ) )
  ALLOCATE ( smap ( nk_g ) )

  DO i = 1, nk_g
    j = ( i - 1 ) / ns
    k = i - 1 - j * ns
    kmap ( i ) = j + k * ( nk_g / ns ) + 1
    smap ( i ) = k + 1
  ENDDO
  ierr = 0
  DO i = 1, nk_g
    ik = kmap ( i )
    is = smap ( i )
    IF ( ik .GE. iks .AND. ik .LE. ike .AND. is .NE. isk ( ik ) ) &
      ierr = ierr + 1
  ENDDO
  CALL mp_max ( ierr )
  IF ( ierr .GT. 0 ) &
    CALL errore ( 'write_wfng', 'smap', ierr )

  alat2 = alat ** 2
  recvol = 8.0D0 * pi**3 / omega

  DO i = 1, nd
    DO j = 1, nd
      adot ( j, i ) = 0.0D0
    ENDDO
  ENDDO
  DO i = 1, nd
    DO j = 1, nd
      DO k = 1, nd
        adot ( j, i ) = adot ( j, i ) + &
          at ( k, j ) * at ( k, i ) * alat2
      ENDDO
    ENDDO
  ENDDO

  DO i = 1, nd
    DO j = 1, nd
      bdot ( j, i ) = 0.0D0
    ENDDO
  ENDDO
  DO i = 1, nd
    DO j = 1, nd
      DO k = 1, nd
        bdot ( j, i ) = bdot ( j, i ) + &
          bg ( k, j ) * bg ( k, i ) * tpiba2
      ENDDO
    ENDDO
  ENDDO

  ierr = 0
  IF ( ibrav .EQ. 0 ) THEN
    IF ( TRIM ( symm_type ) .EQ. 'cubic' ) THEN
      cell_symmetry = 0
    ELSEIF ( TRIM ( symm_type ) .EQ. 'hexagonal' ) THEN
      cell_symmetry = 1
    ELSE
      ierr = 1
    ENDIF
  ELSEIF ( abs ( ibrav ) .GE. 1 .AND. abs ( ibrav ) .LE. 3 ) THEN
    cell_symmetry = 0
  ELSEIF ( abs ( ibrav ) .GE. 4 .AND. abs ( ibrav ) .LE. 5 ) THEN
    cell_symmetry = 1
  ELSEIF ( abs ( ibrav ) .GE. 6 .AND. abs ( ibrav ) .LE. 14 ) THEN
    cell_symmetry = 0
  ELSE
    ierr = 1
  ENDIF
  IF ( ierr .GT. 0 ) &
    CALL errore ( 'write_wfng', 'cell_symmetry', ierr )

  ntran = nsym
  DO i = 1, ntran
    DO j = 1, nd
      DO k = 1, nd
        r1 ( k, j ) = dble ( s ( k, j, i ) )
      ENDDO
    ENDDO
    CALL invmat ( 3, r1, r2, dr1 )
    t1 ( 1 ) = dble ( ftau ( 1, i ) ) / dble ( dfftp%nr1 )
    t1 ( 2 ) = dble ( ftau ( 2, i ) ) / dble ( dfftp%nr2 )
    t1 ( 3 ) = dble ( ftau ( 3, i ) ) / dble ( dfftp%nr3 )
    DO j = 1, nd
      t2 ( j ) = 0.0D0
      DO k = 1, nd
        t2 ( j ) = t2 ( j ) + r2 ( k, j ) * t1 ( k )
      ENDDO
      IF ( t2 ( j ) .GE. eps6 + 0.5D0 ) &
        t2 ( j ) = t2 ( j ) - dble ( int ( t2 ( j ) + 0.5D0 ) )
      IF ( t2 ( j ) .LT. eps6 - 0.5D0 ) &
        t2 ( j ) = t2 ( j ) - dble ( int ( t2 ( j ) - 0.5D0 ) )
    ENDDO
    DO j = 1, nd
      translation ( j, i ) = t2 ( j ) * tpi
    ENDDO
  ENDDO

  ALLOCATE ( et_g ( nb, nk_g ) )

  DO ik = 1, nk_l
    DO ib = 1, nb
      et_g ( ib, ik ) = et ( ib, ik )
    ENDDO
  ENDDO
#ifdef __PARA
  CALL poolrecover ( et_g, nb, nk_g, nk_l )
  CALL mp_bcast ( et_g, ionode_id )
#endif

  ALLOCATE ( wg_g ( nb, nk_g ) )
  ALLOCATE ( ifmin ( nk_g ) )
  ALLOCATE ( ifmax ( nk_g ) )

  IF ( wfng_occupation ) THEN

    DO ik = 1, nk_g
      DO ib = 1, nb
        IF ( ib .GE. wfng_nvmin .AND. ib .LE. wfng_nvmax ) THEN
          wg_g ( ib, ik ) = 1.0D0
        ELSE
          wg_g ( ib, ik ) = 0.0D0
        ENDIF
      ENDDO
    ENDDO
    DO ik = 1, nk_g
      ifmin ( ik ) = wfng_nvmin
    ENDDO
    DO ik = 1, nk_g
      ifmax ( ik ) = wfng_nvmax
    ENDDO

  ELSE

    DO ik = 1, nk_l
      DO ib = 1, nb
        wg_g ( ib, ik ) = wg ( ib, ik ) 
        IF ( abs ( wk ( ik ) ) .GT. eps6 ) THEN
          wg_g ( ib, ik ) = wg_g ( ib, ik ) / wk ( ik ) 
        ENDIF
      ENDDO
    ENDDO
#ifdef __PARA
    CALL poolrecover ( wg_g, nb, nk_g, nk_l )
#endif
    DO ik = 1, nk_g
      ifmin ( ik ) = 0
    ENDDO
    DO ik = 1, nk_g
      ifmax ( ik ) = 0
    ENDDO
    DO ik = 1, nk_g
      DO ib = 1, nb
        IF ( wg_g( ib, ik ) .GT. 0.5D0 ) THEN
          IF ( ifmin ( ik ) .EQ. 0 ) ifmin ( ik ) = ib
          ifmax ( ik ) = ib
        ENDIF
      ENDDO
    ENDDO

  ENDIF

  ALLOCATE ( g_g ( nd, ng_g ) )

  DO ig = 1, ng_g
    DO id = 1, nd
      g_g ( id, ig ) = 0
    ENDDO
  ENDDO
  DO ig = 1, ng_l
    g_g ( 1, ig_l2g ( ig ) ) = mill ( 1, ig )
    g_g ( 2, ig_l2g ( ig ) ) = mill ( 2, ig )
    g_g ( 3, ig_l2g ( ig ) ) = mill ( 3, ig )
  ENDDO
  CALL mp_sum ( g_g, intra_pool_comm )

  ALLOCATE ( igk_l2g ( npwx, nk_l ) )

  ALLOCATE ( itmp ( npwx ) )
  DO ik = 1, nk_l
    DO i = 1, npwx
      itmp ( i ) = 0
    ENDDO
    npw = npwx
    CALL gk_sort ( xk ( 1, ik + iks - 1 ), ng_l, g, ecutwfc / tpiba2, &
      npw, itmp ( 1 ), g2kin )
    DO ig = 1, npw
      igk_l2g ( ig, ik ) = ig_l2g ( itmp ( ig ) )
    ENDDO
    DO ig = npw + 1, npwx
      igk_l2g ( ig, ik ) = 0
    ENDDO
    ngk ( ik ) = npw
  ENDDO
  DEALLOCATE ( itmp )

  ALLOCATE ( ngk_g ( nk_g ) )

  DO ik = 1, nk_g
    ngk_g ( ik ) = 0
  ENDDO
  DO ik = 1, nk_l
    ngk_g ( ik + iks - 1 ) = ngk ( ik )
  ENDDO
  CALL mp_sum ( ngk_g )

  npw_g = MAXVAL ( igk_l2g ( :, : ) )
  CALL mp_max ( npw_g )

  npwx_g = MAXVAL ( ngk_g ( : ) )

  CALL cryst_to_cart ( nk_g / ns, xk, at, - 1 )

  IF ( ionode ) THEN
    OPEN ( unit = unit, file = TRIM ( output_file_name ), &
      form = 'unformatted', status = 'replace' )
    WRITE ( unit ) stitle, sdate, stime
    WRITE ( unit ) nsf, ng_g, ntran, cell_symmetry, nat, ecutrho, &
      nk_g / ns, nb, npwx_g, ecutwfc
    IF ( wfng_kgrid ) THEN
      WRITE ( unit ) dfftp%nr1, dfftp%nr2, dfftp%nr3, wfng_nk1, wfng_nk2, wfng_nk3, &
        wfng_dk1, wfng_dk2, wfng_dk3
    ELSE
      WRITE ( unit ) dfftp%nr1, dfftp%nr2, dfftp%nr3, nk1, nk2, nk3, &
        0.5D0 * dble ( k1 ), 0.5D0 * dble ( k2 ), 0.5D0 * dble ( k3 )
    ENDIF
    WRITE ( unit ) omega, alat, ( ( at ( j, i ), j = 1, nd ), i = 1, nd ), &
      ( ( adot ( j, i ), j = 1, nd ), i = 1, nd )
    WRITE ( unit ) recvol, tpiba, ( ( bg ( j, i ), j = 1, nd ), i = 1, nd ), &
      ( ( bdot ( j, i ), j = 1, nd ), i = 1, nd )
    WRITE ( unit ) ( ( ( s ( k, j, i ), k = 1, nd ), j = 1, nd ), i = 1, ntran )
    WRITE ( unit ) ( ( translation ( j, i ), j = 1, nd ), i = 1, ntran )
    WRITE ( unit ) ( ( tau ( j, i ), j = 1, nd ), atomic_number ( atm ( ityp ( i ) ) ), i = 1, nat )
    WRITE ( unit ) ( ngk_g ( ik ), ik = 1, nk_g / ns )
    WRITE ( unit ) ( wk ( ik ) * dble ( nst ) / 2.0D0, ik = 1, nk_g / ns )
    WRITE ( unit ) ( ( xk ( id, ik ), id = 1, nd ), ik = 1, nk_g / ns )
    WRITE ( unit ) ( ifmin ( ik ), ik = 1, nk_g )
    WRITE ( unit ) ( ifmax ( ik ), ik = 1, nk_g )
    WRITE ( unit ) ( ( et_g ( ib, ik ), ib = 1, nb ), ik = 1, nk_g )
    WRITE ( unit ) ( ( wg_g ( ib, ik ), ib = 1, nb ), ik = 1, nk_g )
    WRITE ( unit ) nrecord
    WRITE ( unit ) ng_g
    WRITE ( unit ) ( ( g_g ( id, ig ), id = 1, nd ), ig = 1, ng_g )
  ENDIF

  CALL cryst_to_cart ( nk_g / ns, xk, bg, 1 )

  DEALLOCATE ( wg_g )
  DEALLOCATE ( ifmax )
  DEALLOCATE ( ifmin )

  ALLOCATE ( igwk ( npwx_g ) )

  IF ( proc_wf ) THEN
    IF ( nspin == 4) THEN
      IF ( MOD ( npwx_g, nproc ) .EQ. 0 ) THEN
        ngkdist_l = ( 2 * npwx_g ) / nproc
      ELSE
        ngkdist_l = ( 2 * npwx_g ) / nproc + 1
      ENDIF
    ELSE
      IF ( MOD ( npwx_g, nproc ) .EQ. 0 ) THEN
        ngkdist_l = npwx_g / nproc
      ELSE
        ngkdist_l = npwx_g / nproc + 1
      ENDIF
    ENDIF
      ngkdist_g = ngkdist_l * nproc
      IF ( real_or_complex .EQ. 1 ) &
      ALLOCATE ( energy ( nb, ns ) )
      ALLOCATE ( wfng_buf ( ngkdist_g, ns ) )
      ALLOCATE ( wfng_dist ( ngkdist_l, nb, ns ) )
  ENDIF

  DO i = 1, nk_g

    ik = kmap ( i )
    is = smap ( i )

    IF ( real_or_complex .EQ. 1 ) THEN
      DO ib = 1, nb
        energy ( ib, is ) = et_g ( ib, i )
      ENDDO
    ENDIF

    DO j = 1, npwx_g
      igwk ( j ) = 0
    ENDDO
    ALLOCATE ( itmp ( npw_g ) )
    DO j = 1, npw_g
      itmp ( j ) = 0
    ENDDO
    IF ( ik .GE. iks .AND. ik .LE. ike ) THEN
      DO ig = 1, ngk ( ik - iks + 1 )
        itmp ( igk_l2g ( ig, ik - iks + 1 ) ) = igk_l2g ( ig, ik - iks + 1 )
      ENDDO
    ENDIF
    CALL mp_sum ( itmp )
    ngg = 0
    DO ig = 1, npw_g
      IF ( itmp ( ig ) .EQ. ig ) THEN
        ngg = ngg + 1
        igwk ( ngg ) = ig
      ENDIF
    ENDDO
    DEALLOCATE ( itmp )

    IF ( ionode ) THEN
      IF ( is .EQ. 1 ) THEN
        WRITE ( unit ) nrecord
        WRITE ( unit ) ngk_g ( ik )
        WRITE ( unit ) ( ( g_g ( id, igwk ( ig ) ), id = 1, nd ), &
          ig = 1, ngk_g ( ik ) )
      ENDIF
    ENDIF

    local_pw = 0
    IF ( ik .GE. iks .AND. ik .LE. ike ) THEN
      CALL davcio ( evc, nwordwfc, iunwfc, ik - iks + 1, - 1 )
      local_pw = ngk ( ik - iks + 1 )
    ENDIF

    ALLOCATE ( igwf_l2g ( local_pw ) )

    DO ig = 1, local_pw
      igwf_l2g ( ig ) = 0
    ENDDO
    DO ig = 1, local_pw
      ngg = igk_l2g ( ig, ik - iks + 1 )
      DO j = 1, ngk_g ( ik )
        IF ( ngg .EQ. igwk ( j ) ) THEN
          igwf_l2g ( ig ) = j
          EXIT
        ENDIF
      ENDDO
    ENDDO

    ALLOCATE ( ipmask ( nproc ) )
    DO j = 1, nproc
      ipmask ( j ) = 0
    ENDDO
    ipsour = ionode_id
    IF ( npool .GT. 1 ) THEN
      IF ( ( ik .GE. iks ) .AND. ( ik .LE. ike ) ) THEN
        IF ( me_pool .EQ. root_pool ) ipmask ( mpime + 1 ) = 1
      ENDIF
      CALL mp_sum ( ipmask )
      DO j = 1, nproc
        IF ( ipmask ( j ) .EQ. 1 ) ipsour = j - 1
      ENDDO
    ENDIF
    DEALLOCATE ( ipmask )

    igwx = 0
    ierr = 0
    IF ( ik .GE. iks .AND. ik .LE. ike ) &
      igwx = MAXVAL ( igwf_l2g ( 1 : local_pw ) )
    CALL mp_max ( igwx, intra_pool_comm )
    IF ( ipsour .NE. ionode_id ) &
      CALL mp_get ( igwx, igwx, mpime, ionode_id, ipsour, 1 )
    ierr = 0
    IF ( ik .GE. iks .AND. ik .LE. ike .AND. igwx .NE. ngk_g ( ik ) ) &
      ierr = 1
    CALL mp_max ( ierr )
    IF ( ierr .GT. 0 ) &
      CALL errore ( 'write_wfng', 'igwx ngk_g', ierr )

    IF (nspin == 4) THEN
      igwx = 2 * igwx
    ENDIF

    ALLOCATE ( wfng ( MAX ( 1, igwx ) ) )

    IF (nspin == 4) THEN
      npw_g2 = MAXVAL ( ig_l2g ( 1: local_pw) )
      CALL mp_max (npw_g2)
    ENDIF

    DO ib = 1, nb

      DO j = 1, igwx
        wfng ( j ) = ( 0.0D0, 0.0D0 )
      ENDDO
      IF ( npool .GT. 1 ) THEN
        IF ( ( ik .GE. iks ) .AND. ( ik .LE. ike ) ) THEN
          CALL mergewf ( evc ( :, ib ), wfng, local_pw, igwf_l2g, &
            me_pool, nproc_pool, root_pool, intra_pool_comm )
        ENDIF
        IF ( ipsour .NE. ionode_id ) THEN
          CALL mp_get ( wfng, wfng, mpime, ionode_id, ipsour, ib, &
            world_comm )
        ENDIF
      ELSE
        CALL mergewf ( evc ( :, ib ), wfng, local_pw, igwf_l2g, &
          mpime, nproc, ionode_id, world_comm )

        IF (nspin == 4) THEN
          CALL mp_barrier ( )
          CALL mergewf ( evc ( npwx_g + 1 : npwx_g + local_pw, ib), &
            wfng (local_pw + 1 : 2 * local_pw ), &
           local_pw, igwf_l2g, mpime, nproc, ionode_id, world_comm )
        ENDIF
      ENDIF

      IF ( proc_wf ) THEN
        DO ig = 1, igwx
          wfng_buf ( ig, is ) = wfng ( ig )
        ENDDO
        DO ig = igwx + 1, ngkdist_g
          wfng_buf ( ig, is ) = ( 0.0D0, 0.0D0 )
        ENDDO
#ifdef __PARA
        CALL mp_barrier ( )
        CALL MPI_Scatter ( wfng_buf ( :, is ), ngkdist_l, MPI_DOUBLE_COMPLEX, &
        wfng_dist ( :, ib, is ), ngkdist_l, MPI_DOUBLE_COMPLEX, &
        ionode_id, world_comm, ierr )
        IF ( ierr .GT. 0 ) &
          CALL errore ( 'write_wfng', 'mpi_scatter', ierr )
#else
        DO ig = 1, ngkdist_g
          wfng_dist ( ig, ib, is ) = wfng_buf ( ig, is )
        ENDDO
#endif
      ELSE
        IF ( ionode ) THEN
          WRITE ( unit ) nrecord
          WRITE ( unit ) ngk_g ( ik )
          WRITE ( unit ) ( wfng ( ig ), ig = 1, igwx )
        ENDIF
      ENDIF

    ENDDO

    DEALLOCATE ( wfng )
    DEALLOCATE ( igwf_l2g )

    IF ( proc_wf .AND. is .EQ. ns ) THEN
      IF ( real_or_complex .EQ. 1 ) THEN
        CALL start_clock ( 'real_wfng' )
        CALL real_wfng ( ik, ngkdist_l, nb, ns, energy, wfng_dist )
        CALL stop_clock ( 'real_wfng' )
      ENDIF
      DO ib = 1, nb
        DO is = 1, ns
#ifdef __PARA
          CALL mp_barrier ( )
          CALL MPI_Gather ( wfng_dist ( :, ib, is ), ngkdist_l, &
          MPI_DOUBLE_COMPLEX, wfng_buf ( :, is ), ngkdist_l, &
          MPI_DOUBLE_COMPLEX, ionode_id, world_comm, ierr )
          IF ( ierr .GT. 0 ) &
            CALL errore ( 'write_wfng', 'mpi_gather', ierr )
#else
          DO ig = 1, ngkdist_g
            wfng_buf ( ig, is ) = wfng_dist ( ig, ib, is )
          ENDDO
#endif
        ENDDO
        IF ( ionode ) THEN
          WRITE ( unit ) nrecord
          WRITE ( unit ) ngk_g ( ik )
          IF ( real_or_complex .EQ. 1 ) THEN
            WRITE ( unit ) ( ( dble ( wfng_buf ( ig, is ) ), &
              ig = 1, igwx ), is = 1, ns )
          ELSE
            WRITE ( unit ) ( ( wfng_buf ( ig, is ), &
              ig = 1, igwx ), is = 1, ns )
          ENDIF
        ENDIF
      ENDDO
    ENDIF

  ENDDO

  DEALLOCATE ( igwk )
  DEALLOCATE ( ngk_g )
  DEALLOCATE ( igk_l2g )
  DEALLOCATE ( et_g )

  IF ( proc_wf ) THEN
    IF ( real_or_complex .EQ. 1 ) &
    DEALLOCATE ( energy )
    DEALLOCATE ( wfng_buf )
    DEALLOCATE ( wfng_dist )
  ENDIF

  IF ( ionode ) THEN
    CLOSE ( unit = unit, status = 'keep' )
  ENDIF

  DEALLOCATE ( g_g )
  DEALLOCATE ( smap )
  DEALLOCATE ( kmap )

  CALL mp_barrier ( )

  RETURN

101 FORMAT ( /, 5X, "WARNING: kgrid is set to zero in the wavefunction file.", &
             /, 14X, "The resulting file will only be usable as the fine grid in inteqp.", / )

END SUBROUTINE write_wfng

!-------------------------------------------------------------------------------

SUBROUTINE real_wfng ( ik, ngkdist_l, nb, ns, energy, wfng_dist )

  USE kinds, ONLY : DP
  USE io_global, ONLY : ionode
  USE mp, ONLY : mp_sum

  IMPLICIT NONE

  integer, intent (in) :: ik, ngkdist_l, nb, ns
  real (DP), intent (in) :: energy ( :, : ) ! ( nb, ns )
  complex (DP), intent (inout) :: wfng_dist ( :, :, : ) ! ( ngkdist_l, nb, ns )

  real (DP), PARAMETER :: eps2 = 1.0D-2
  real (DP), PARAMETER :: eps5 = 1.0D-5
  real (DP), PARAMETER :: eps6 = 1.0D-6

  character :: tmpstr*80
  integer :: i, j, k, is, ib, jb, ig, inum, deg, mdeg, inc
  integer :: dimension_span, reduced_span, ierr
  real (DP) :: x
  integer, allocatable :: imap ( :, : )
  integer, allocatable :: inums ( : )
  integer, allocatable :: inull ( : )
  integer, allocatable :: null_map ( :, : )
  real (DP), allocatable :: psi ( :, : )
  real (DP), allocatable :: phi ( :, : )
  real (DP), allocatable :: vec ( : )
  complex (DP), allocatable :: wfc ( : )

  mdeg = 1
  DO is = 1, ns
    DO ib = 1, nb - 1
      deg = 1
      DO jb = ib + 1, nb
        IF ( abs ( energy ( ib, is ) - energy ( jb, is ) ) &
          .LT. eps5 * dble ( jb - ib + 1 ) ) deg = deg + 1
      ENDDO
      IF ( deg .GT. mdeg ) mdeg = deg
    ENDDO
  ENDDO
  mdeg = mdeg * 2

  ALLOCATE ( imap ( nb, ns ) )
  ALLOCATE ( inums ( ns ) )
  ALLOCATE ( inull ( nb ) )
  ALLOCATE ( null_map ( mdeg, nb ) )

  DO is = 1, ns
    inum = 1
    DO ib = 1, nb
      IF ( ib .EQ. nb ) THEN
        imap ( inum, is ) = ib
        inum = inum + 1
      ELSEIF ( abs ( energy ( ib, is ) - &
        energy ( ib + 1, is ) ) .GT. eps5 ) THEN
        imap ( inum, is ) = ib
        inum = inum + 1
      ENDIF
    ENDDO
    inum = inum - 1
    inums ( is ) = inum
  ENDDO

  ALLOCATE ( wfc ( ngkdist_l ) )
  ALLOCATE ( psi ( ngkdist_l, mdeg ) )
  ALLOCATE ( phi ( ngkdist_l, mdeg ) )
  ALLOCATE ( vec ( ngkdist_l ) )

  DO is = 1, ns
    inc = 1
    inum = inums ( is )
    DO i = 1, inum
      inull ( i ) = 1
      DO ib = inc, imap ( i, is )
        DO ig = 1, ngkdist_l
          wfc ( ig ) = wfng_dist ( ig, ib, is )
        ENDDO
        x = 0.0D0
        DO ig = 1, ngkdist_l
          x = x + dble ( wfc ( ig ) ) **2
        ENDDO
        CALL mp_sum ( x )
        IF ( x .LT. eps2 ) null_map ( inull ( i ), i ) = 0
        IF ( x .GT. eps2 ) null_map ( inull ( i ), i ) = 1
        inull ( i ) = inull ( i ) + 1
        x = 0.0D0
        DO ig = 1, ngkdist_l
          x = x + aimag ( wfc ( ig ) ) **2
        ENDDO
        CALL mp_sum ( x )
        IF ( x .LT. eps2 ) null_map ( inull ( i ), i ) = 0
        IF ( x .GT. eps2 ) null_map ( inull ( i ), i ) = 1
        inull ( i ) = inull ( i ) + 1
      ENDDO
      inull ( i ) = inull ( i ) - 1
      inc = imap ( i, is ) + 1
    ENDDO
    inc = 1
    ib = 1
    DO i = 1, inum
      k = 1
      DO j = 1, 2 * ( imap ( i, is ) - inc ) + 1, 2
        IF ( null_map ( j, i ) .EQ. 1 .OR. &
          null_map ( j + 1, i ) .EQ. 1 ) THEN
          DO ig = 1, ngkdist_l
            wfc ( ig ) = wfng_dist ( ig, ib, is )
          ENDDO
          IF ( null_map ( j, i ) .EQ. 1 ) THEN
            DO ig = 1, ngkdist_l
              phi ( ig, k ) = dble ( wfc ( ig ) )
            ENDDO
            k = k + 1
          ENDIF
          IF ( null_map ( j + 1, i ) .EQ. 1 ) THEN
            DO ig = 1, ngkdist_l
              phi ( ig, k ) = aimag ( wfc ( ig ) )
            ENDDO
            k = k + 1
          ENDIF
          ib = ib + 1
        ENDIF
      ENDDO
      dimension_span = k - 1
      IF ( dimension_span .EQ. 0 ) THEN
        ierr = 201
        WRITE ( tmpstr, 201 ) ik, is, inc
        CALL errore ( 'real_wfng', tmpstr, ierr )
      ENDIF
      DO j = 1, dimension_span
        x = 0.0D0
        DO ig = 1, ngkdist_l
          x = x + phi ( ig, j ) **2
        ENDDO
        CALL mp_sum ( x )
        x = sqrt ( x )
        DO ig = 1, ngkdist_l
          phi ( ig, j ) = phi ( ig, j ) / x
        ENDDO
      ENDDO
!
! the Gram-Schmidt process begins
!
      reduced_span = 1
      DO ig = 1, ngkdist_l
        psi ( ig, 1 ) = phi ( ig, 1 )
      ENDDO
      DO j = 1, dimension_span - 1
        DO ig = 1, ngkdist_l
          vec ( ig ) = phi ( ig, j + 1 )
        ENDDO
        DO k = 1, reduced_span
          x = 0.0D0
          DO ig = 1, ngkdist_l
            x = x + phi ( ig, j + 1 ) * psi ( ig, k )
          ENDDO
          CALL mp_sum ( x )
          DO ig = 1, ngkdist_l
            vec ( ig ) = vec ( ig ) - psi ( ig, k ) * x
          ENDDO
        ENDDO
        x = 0.0D0
        DO ig = 1, ngkdist_l
          x = x + vec ( ig ) **2
        ENDDO
        CALL mp_sum ( x )
        x = sqrt ( x )
        IF ( x .GT. eps6 ) THEN
          reduced_span = reduced_span + 1
          DO ig = 1, ngkdist_l
            psi ( ig, reduced_span ) = vec ( ig ) / x
          ENDDO
        ENDIF
      ENDDO
!
! the Gram-Schmidt process ends
!
      IF ( reduced_span .LT. imap ( i, is ) - inc + 1 ) THEN
        ierr = 202
        WRITE ( tmpstr, 202 ) ik, is, inc
        CALL errore ( 'real_wfng', tmpstr, ierr )
      ENDIF
      DO ib = inc, imap ( i, is )
        DO ig = 1, ngkdist_l
          wfng_dist ( ig, ib, is ) = &
          CMPLX ( psi ( ig, ib - inc + 1 ), 0.0D0 )
        ENDDO
      ENDDO
      inc = imap ( i, is ) + 1
    ENDDO
  ENDDO

  DEALLOCATE ( vec )
  DEALLOCATE ( phi )
  DEALLOCATE ( psi )
  DEALLOCATE ( wfc )
  DEALLOCATE ( null_map )
  DEALLOCATE ( inull )
  DEALLOCATE ( inums )
  DEALLOCATE ( imap )

  RETURN

201 FORMAT("failed Gram-Schmidt dimension span for kpoint =",i6," spin =",i2," band =",i6)
202 FORMAT("failed Gram-Schmidt reduced span for kpoint =",i6," spin =",i2," band =",i6)

END SUBROUTINE real_wfng

!-------------------------------------------------------------------------------

SUBROUTINE write_rhog ( output_file_name, real_or_complex, symm_type, &
  rhog_nvmin, rhog_nvmax )

  USE cell_base, ONLY : omega, alat, tpiba, tpiba2, at, bg, ibrav
  USE constants, ONLY : pi, tpi, eps6
  USE fft_base, ONLY : dfftp
  USE gvect, ONLY : ngm, ngm_g, ig_l2g, mill, ecutrho
  USE io_global, ONLY : ionode
  USE ions_base, ONLY : nat, atm, ityp, tau 
  USE kinds, ONLY : DP
  USE lsda_mod, ONLY : nspin
  USE mp, ONLY : mp_sum
  USE mp_global, ONLY : intra_pool_comm
  USE scf, ONLY : rho
  USE symm_base, ONLY : s, ftau, nsym

  IMPLICIT NONE

  character ( len = 256 ), intent (in) :: output_file_name
  integer, intent (in) :: real_or_complex
  character ( len = 9 ), intent (in) :: symm_type
  integer, intent (in) :: rhog_nvmin
  integer, intent (in) :: rhog_nvmax

  character :: stitle*32
  integer :: unit, is, ig
  integer :: ns, nst, nsf, ng_l, ng_g
  integer :: nrecord
  complex (DP), allocatable :: rhog_g ( :, : )

  CALL check_inversion ( real_or_complex, nsym, s, nspin, .true., .true. )

  IF ( real_or_complex .EQ. 1 ) THEN
    WRITE ( stitle, '("RHO-Real",24X)' )
  ELSE
    WRITE ( stitle, '("RHO-Complex",21X)' )
  ENDIF

  unit = 4
  nrecord = 1

  ng_l = ngm
  ng_g = ngm_g
  call set_spin(ns,nst,nsf,nspin)

  IF ( rhog_nvmin .NE. 0 .AND. rhog_nvmax .NE. 0 ) &
    CALL calc_rhog ( rhog_nvmin, rhog_nvmax )

  ALLOCATE ( rhog_g ( ng_g, ns ) )

  DO is = 1, ns
    DO ig = 1, ng_g
      rhog_g ( ig, is ) = ( 0.0D0, 0.0D0 )
    ENDDO
  ENDDO

  DO is = 1, ns
    DO ig = 1, ng_l
      rhog_g ( ig_l2g ( ig ), is ) = rho%of_g ( ig, is )
    ENDDO
  ENDDO

  CALL mp_sum ( rhog_g, intra_pool_comm )

  DO is = 1, ns
    DO ig = 1, ng_g
      rhog_g ( ig, is ) = rhog_g ( ig, is ) * CMPLX ( omega, 0.0D0 )
    ENDDO
  ENDDO

  IF ( ionode ) OPEN ( unit = unit, file = TRIM ( output_file_name ), &
      form = 'unformatted', status = 'replace' )

  CALL write_header(unit, stitle, symm_type)

  IF ( ionode ) THEN
    WRITE ( unit ) nrecord
    WRITE ( unit ) ng_g
    IF ( real_or_complex .EQ. 1 ) THEN
      WRITE ( unit ) ( ( dble ( rhog_g ( ig, is ) ), &
        ig = 1, ng_g ), is = 1, ns )
    ELSE
      WRITE ( unit ) ( ( rhog_g ( ig, is ), &
        ig = 1, ng_g ), is = 1, ns )
    ENDIF
    CLOSE ( unit = unit, status = 'keep' )
  ENDIF

  DEALLOCATE ( rhog_g )
  RETURN

END SUBROUTINE write_rhog

!-------------------------------------------------------------------------------

SUBROUTINE calc_rhog (rhog_nvmin, rhog_nvmax)

! calc_rhog    Originally By Brad D. Malone    Last Modified (night before his thesis defense)
! Computes charge density by summing over a subset of occupied bands

  USE cell_base, ONLY : omega, tpiba2
  USE fft_base, ONLY : dfftp
  USE fft_interfaces, ONLY : fwfft, invfft
  USE gvect, ONLY : ngm, g, nl
  USE io_files, ONLY : nwordwfc, iunwfc
  USE klist, ONLY : xk, nkstot
  USE lsda_mod, ONLY : nspin, isk
  USE mp, ONLY : mp_sum
  USE mp_global, ONLY : kunit, my_pool_id, inter_pool_comm, npool
  USE noncollin_module, ONLY : nspin_mag
  USE scf, ONLY : rho
  USE symme, ONLY : sym_rho, sym_rho_init
  USE wavefunctions_module, ONLY : evc, psic, psic_nc
  USE wvfct, ONLY : npwx, npw, igk, wg, g2kin, ecutwfc

  IMPLICIT NONE

  integer, intent (in) :: rhog_nvmin
  integer, intent (in) :: rhog_nvmax

  integer :: ik, is, ib, ig, ir, nkbl, nkl, nkr, iks, ike

  nkbl = nkstot / kunit
  nkl = kunit * (nkbl / npool)
  nkr = (nkstot - nkl * npool) / kunit
  IF (my_pool_id .LT. nkr) nkl = nkl + kunit
  iks = nkl * my_pool_id + 1
  IF (my_pool_id .GE. nkr) iks = iks + nkr * kunit
  ike = iks + nkl - 1

  CALL weights ()

  rho%of_r (:, :) = 0.0D0

  ! take psi to R-space, compute rho in R-space
  DO ik = iks, ike
    is = isk (ik)
    CALL gk_sort (xk (1, ik - iks + 1), ngm, g, ecutwfc &
      / tpiba2, npw, igk, g2kin)
    CALL davcio (evc, nwordwfc, iunwfc, ik - iks + 1, -1)
    DO ib = rhog_nvmin, rhog_nvmax
      psic (:) = (0.0D0, 0.0D0)
      psic_nc (:,:) = (0.0D0, 0.0D0)
      DO ig = 1, npw
        IF (nspin == 4) THEN
          psic_nc (nl (igk (ig)),1) = evc (ig, ib)
          psic_nc (nl (igk (ig)),2) = evc (ig+npwx, ib)
        ELSE
          psic (nl (igk (ig))) = evc (ig, ib)
        ENDIF
      ENDDO
      IF (nspin == 4) THEN
        CALL invfft ('Dense', psic_nc(:,1), dfftp)
        CALL invfft ('Dense', psic_nc(:,2), dfftp)
      ELSE
        CALL invfft ('Dense', psic, dfftp)
      ENDIF
      DO ir = 1, dfftp%nnr
        IF (nspin == 4) THEN
          rho%of_r (ir, is) = rho%of_r (ir, is) + wg (ib, ik) / omega &
            * (dble (psic_nc (ir,1)) **2 + aimag (psic_nc (ir,1)) **2 + &
               dble (psic_nc (ir,2)) **2 + aimag (psic_nc (ir,2)) **2)
        ELSE
          rho%of_r (ir, is) = rho%of_r (ir, is) + wg (ib, ik) / omega &
            * (dble (psic (ir)) **2 + aimag (psic (ir)) **2)
        ENDIF
      ENDDO
    ENDDO
  ENDDO
  CALL mp_sum (rho%of_r, inter_pool_comm)

  ! take rho to G-space
  DO is = 1, nspin
    psic (:) = (0.0D0, 0.0D0)
    psic (:) = rho%of_r (:, is)
    CALL fwfft ('Dense', psic, dfftp)
    rho%of_g (:, is) = psic (nl (:))
  ENDDO

  ! symmetrize rho (didn`t make a difference)
  CALL sym_rho_init (.False.)
  CALL sym_rho (nspin_mag, rho%of_g)

  RETURN

END SUBROUTINE calc_rhog

!-------------------------------------------------------------------------------

SUBROUTINE write_vxcg ( output_file_name, real_or_complex, symm_type, &
  vxc_zero_rho_core )

  USE cell_base, ONLY : omega, alat, tpiba, tpiba2, at, bg, ibrav
  USE constants, ONLY : pi, tpi, eps6
  USE ener, ONLY : etxc, vtxc
  USE fft_base, ONLY : dfftp
  USE fft_interfaces, ONLY : fwfft
  USE gvect, ONLY : ngm, ngm_g, ig_l2g, nl, mill, ecutrho
  USE io_global, ONLY : ionode
  USE ions_base, ONLY : nat, atm, ityp, tau 
  USE kinds, ONLY : DP
  USE lsda_mod, ONLY : nspin
  USE mp, ONLY : mp_sum
  USE mp_global, ONLY : intra_pool_comm
  USE scf, ONLY : rho, rho_core, rhog_core
  USE symm_base, ONLY : s, ftau, nsym
  USE wavefunctions_module, ONLY : psic

  IMPLICIT NONE

  character ( len = 256 ), intent (in) :: output_file_name
  integer, intent (in) :: real_or_complex
  character ( len = 9 ), intent (in) :: symm_type
  logical, intent (in) :: vxc_zero_rho_core

  character :: stitle*32
  integer :: unit, is, ir, ig
  integer :: ns, nst, nsf, nr, ng_l, ng_g
  integer :: nrecord
  real (DP), allocatable :: vxcr_g ( :, : )
  complex (DP), allocatable :: vxcg_g ( :, : )

  CALL check_inversion ( real_or_complex, nsym, s, nspin, .true., .true. )

  IF ( real_or_complex .EQ. 1 ) THEN
    WRITE ( stitle, '("VXC-Real",24X)' )
  ELSE
    WRITE ( stitle, '("VXC-Complex",21X)' )
  ENDIF

  unit = 4
  nrecord = 1

  nr = dfftp%nnr
  ng_l = ngm
  ng_g = ngm_g
  call set_spin(ns,nst,nsf,nspin)

  ALLOCATE ( vxcr_g ( nr, nsf ) )
  ALLOCATE ( vxcg_g ( ng_g, nsf ) )

  DO is = 1, nsf
    DO ig = 1, ng_g
      vxcg_g ( ig, is ) = ( 0.0D0, 0.0D0 )
    ENDDO
  ENDDO

  vxcr_g ( :, : ) = 0.0D0
  IF ( vxc_zero_rho_core ) THEN
    rho_core ( : ) = 0.0D0
    rhog_core ( : ) = ( 0.0D0, 0.0D0 )
  ENDIF
  CALL v_xc ( rho, rho_core, rhog_core, etxc, vtxc, vxcr_g )
  DO is = 1, nsf
    DO ir = 1, nr
      psic ( ir ) = CMPLX ( vxcr_g ( ir, is ), 0.0D0 )
    ENDDO
    CALL fwfft ( 'Dense', psic, dfftp )
    DO ig = 1, ng_l
      vxcg_g ( ig_l2g ( ig ), is ) = psic ( nl ( ig ) )
    ENDDO
  ENDDO

  CALL mp_sum ( vxcg_g, intra_pool_comm )

  IF ( ionode ) OPEN ( unit = unit, file = TRIM ( output_file_name ), &
      form = 'unformatted', status = 'replace' )

  CALL write_header(unit, stitle, symm_type)

  IF ( ionode ) THEN
    WRITE ( unit ) nrecord
    WRITE ( unit ) ng_g
    IF ( real_or_complex .EQ. 1 ) THEN
      WRITE ( unit ) ( ( dble ( vxcg_g ( ig, is ) ), &
        ig = 1, ng_g ), is = 1, nsf )
    ELSE
      WRITE ( unit ) ( ( vxcg_g ( ig, is ), &
        ig = 1, ng_g ), is = 1, nsf )
    ENDIF
    CLOSE ( unit = unit, status = 'keep' )
  ENDIF

  DEALLOCATE ( vxcg_g )
  DEALLOCATE ( vxcr_g )

  RETURN

END SUBROUTINE write_vxcg

!-------------------------------------------------------------------------------

SUBROUTINE write_vxc0 ( output_file_name, vxc_zero_rho_core )

  USE constants, ONLY : RYTOEV
  USE ener, ONLY : etxc, vtxc
  USE fft_base, ONLY : dfftp
  USE fft_interfaces, ONLY : fwfft
  USE gvect, ONLY : ngm, nl, mill
  USE io_global, ONLY : ionode
  USE kinds, ONLY : DP
  USE lsda_mod, ONLY : nspin
  USE mp, ONLY : mp_sum
  USE mp_global, ONLY : intra_pool_comm
  USE scf, ONLY : rho, rho_core, rhog_core
  USE wavefunctions_module, ONLY : psic

  IMPLICIT NONE

  character ( len = 256 ), intent (in) :: output_file_name
  logical, intent (in) :: vxc_zero_rho_core

  integer :: unit
  integer :: is, ir, ig
  integer :: ns, nr, ng_l
  real (DP), allocatable :: vxcr_g ( :, : )
  complex (DP), allocatable :: vxc0_g ( : )

  unit = 4

  ns = nspin
  nr = dfftp%nnr
  ng_l = ngm

  ALLOCATE ( vxcr_g ( nr, ns ) )
  ALLOCATE ( vxc0_g ( ns ) )

  DO is = 1, ns
    vxc0_g ( is ) = ( 0.0D0, 0.0D0 )
  ENDDO

  vxcr_g ( :, : ) = 0.0D0
  IF ( vxc_zero_rho_core ) THEN
    rho_core ( : ) = 0.0D0
    rhog_core ( : ) = ( 0.0D0, 0.0D0 )
  ENDIF
  CALL v_xc ( rho, rho_core, rhog_core, etxc, vtxc, vxcr_g )
  DO is = 1, ns
    DO ir = 1, nr
      psic ( ir ) = CMPLX ( vxcr_g ( ir, is ), 0.0D0 )
    ENDDO
    CALL fwfft ( 'Dense', psic, dfftp )
    DO ig = 1, ng_l
      IF ( mill ( 1, ig ) .EQ. 0 .AND. mill ( 2, ig ) .EQ. 0 .AND. &
        mill ( 3, ig ) .EQ. 0 ) vxc0_g ( is ) = psic ( nl ( ig ) )
    ENDDO
  ENDDO

  CALL mp_sum ( vxc0_g, intra_pool_comm )

  DO is = 1, ns
    vxc0_g ( is ) = vxc0_g ( is ) * CMPLX ( RYTOEV, 0.0D0 )
  ENDDO

  IF ( ionode ) THEN
    OPEN (unit = unit, file = TRIM (output_file_name), &
      form = 'formatted', status = 'replace')
    WRITE ( unit, 101 )
    DO is = 1, ns
      WRITE ( unit, 102 ) is, vxc0_g ( is )
    ENDDO
    WRITE ( unit, 103 )
    CLOSE (unit = unit, status = 'keep')
  ENDIF

  DEALLOCATE ( vxcr_g )
  DEALLOCATE ( vxc0_g )

  RETURN

101 FORMAT ( /, 5X, "--------------------------------------------", &
             /, 5X, "spin    Re Vxc(G=0) [eV]    Im Vxc(G=0) [eV]", &
             /, 5X, "--------------------------------------------" )
102 FORMAT ( 5X, I1, 3X, 2F20.15 )
103 FORMAT ( 5X, "--------------------------------------------", / )

END SUBROUTINE write_vxc0

!-------------------------------------------------------------------------------

SUBROUTINE write_vxc_r (output_file_name, diag_nmin, diag_nmax, &
  offdiag_nmin, offdiag_nmax, vxc_zero_rho_core)

  USE kinds, ONLY : DP
  USE constants, ONLY : rytoev
  USE cell_base, ONLY : tpiba2, at, bg
  USE ener, ONLY : etxc, vtxc
  USE fft_base, ONLY : dfftp
  USE fft_interfaces, ONLY : invfft
  USE gvect, ONLY : ngm, g, nl
  USE io_files, ONLY : nwordwfc, iunwfc
  USE io_global, ONLY : ionode
  USE klist, ONLY : xk, nkstot
  USE lsda_mod, ONLY : nspin, isk
  USE mp, ONLY : mp_sum
  USE mp_global, ONLY : kunit, my_pool_id, intra_pool_comm, &
    inter_pool_comm, npool
  USE scf, ONLY : rho, rho_core, rhog_core
  USE wavefunctions_module, ONLY : evc, psic
  USE wvfct, ONLY : npw, nbnd, igk, g2kin, ecutwfc

  IMPLICIT NONE

  character (len = 256), intent (in) :: output_file_name
  integer, intent (inout) :: diag_nmin
  integer, intent (inout) :: diag_nmax
  integer, intent (inout) :: offdiag_nmin
  integer, intent (inout) :: offdiag_nmax
  logical, intent (in) :: vxc_zero_rho_core

  integer :: ik, is, ib, ig, ir, unit, nkbl, nkl, nkr, iks, ike, &
    ndiag, noffdiag, ib2
  real (DP) :: dummyr
  complex (DP) :: dummyc
  real (DP), allocatable :: mtxeld (:, :)
  complex (DP), allocatable :: mtxelo (:, :, :)
  real (DP), allocatable :: vxcr (:, :)
  complex (DP), allocatable :: psic2 (:)

  if(diag_nmin > diag_nmax) then
    call errore ( 'write_vxc_r', 'diag_nmin > diag_nmax', diag_nmin )
  endif
  IF (diag_nmin .LT. 1) diag_nmin = 1
  IF (diag_nmax .GT. nbnd) then
    write(0,'(a,i6)') 'WARNING: resetting diag_nmax to max number of bands', nbnd
    diag_nmax = nbnd
  ENDIF
  ndiag = MAX (diag_nmax - diag_nmin + 1, 0)

  if(offdiag_nmin > offdiag_nmax) then
    call errore ( 'write_vxc_r', 'offdiag_nmin > offdiag_nmax', offdiag_nmin )
  endif
  IF (offdiag_nmin .LT. 1) offdiag_nmin = 1
  IF (offdiag_nmax .GT. nbnd)  then
    write(0,'(a,i6)') 'WARNING: resetting offdiag_nmax to max number of bands', nbnd
    offdiag_nmax = nbnd
  ENDIF
  noffdiag = MAX (offdiag_nmax - offdiag_nmin + 1, 0)

  IF (ndiag .EQ. 0 .AND. noffdiag .EQ. 0) RETURN

  unit = 4

  nkbl = nkstot / kunit
  nkl = kunit * (nkbl / npool)
  nkr = (nkstot - nkl * npool) / kunit
  IF (my_pool_id .LT. nkr) nkl = nkl + kunit
  iks = nkl * my_pool_id + 1
  IF (my_pool_id .GE. nkr) iks = iks + nkr * kunit
  ike = iks + nkl - 1

  IF (ndiag .GT. 0) THEN
    ALLOCATE (mtxeld (ndiag, nkstot))
    mtxeld (:, :) = 0.0D0
  ENDIF
  IF (noffdiag .GT. 0) THEN
    ALLOCATE (mtxelo (noffdiag, noffdiag, nkstot))
    mtxelo (:, :, :) = (0.0D0, 0.0D0)
  ENDIF

  ALLOCATE (vxcr (dfftp%nnr, nspin))
  IF (noffdiag .GT. 0) ALLOCATE (psic2 (dfftp%nnr))

  vxcr (:, :) = 0.0D0
  IF ( vxc_zero_rho_core ) THEN
    rho_core ( : ) = 0.0D0
    rhog_core ( : ) = ( 0.0D0, 0.0D0 )
  ENDIF
  CALL v_xc (rho, rho_core, rhog_core, etxc, vtxc, vxcr)

  DO ik = iks, ike
    CALL gk_sort (xk (1, ik - iks + 1), ngm, g, ecutwfc &
      / tpiba2, npw, igk, g2kin)
    CALL davcio (evc, nwordwfc, iunwfc, ik - iks + 1, -1)
    IF (ndiag .GT. 0) THEN
      DO ib = diag_nmin, diag_nmax
        psic (:) = (0.0D0, 0.0D0)
        DO ig = 1, npw
          psic (nl (igk (ig))) = evc (ig, ib)
        ENDDO
        CALL invfft ('Dense', psic, dfftp)
        dummyr = 0.0D0
        DO ir = 1, dfftp%nnr
          dummyr = dummyr + vxcr (ir, isk (ik)) &
            * (dble (psic (ir)) **2 + aimag (psic (ir)) **2)
        ENDDO
        dummyr = dummyr * rytoev / dble (dfftp%nr1x * dfftp%nr2x * dfftp%nr3x)
        CALL mp_sum (dummyr, intra_pool_comm)
        mtxeld (ib - diag_nmin + 1, ik) = dummyr
      ENDDO
    ENDIF
    IF (noffdiag .GT. 0) THEN
      DO ib = offdiag_nmin, offdiag_nmax
        psic (:) = (0.0D0, 0.0D0)
        DO ig = 1, npw
          psic (nl (igk (ig))) = evc (ig, ib)
        ENDDO
        CALL invfft ('Dense', psic, dfftp)
        DO ib2 = offdiag_nmin, offdiag_nmax
          psic2 (:) = (0.0D0, 0.0D0)
          DO ig = 1, npw
            psic2 (nl (igk (ig))) = evc (ig, ib2)
          ENDDO
          CALL invfft ('Dense', psic2, dfftp)
          dummyc = (0.0D0, 0.0D0)
          DO ir = 1, dfftp%nnr
            dummyc = dummyc + CMPLX (vxcr (ir, isk (ik)), 0.0D0) &
              * conjg (psic2 (ir)) * psic (ir)
          ENDDO
          dummyc = dummyc &
            * CMPLX (rytoev / dble (dfftp%nr1x * dfftp%nr2x * dfftp%nr3x), 0.0D0)
          CALL mp_sum (dummyc, intra_pool_comm)
          mtxelo (ib2 - offdiag_nmin + 1, ib - offdiag_nmin &
            + 1, ik) = dummyc
        ENDDO
      ENDDO
    ENDIF
  ENDDO

  DEALLOCATE (vxcr)
  IF (noffdiag .GT. 0) DEALLOCATE (psic2)

  IF (ndiag .GT. 0) CALL mp_sum (mtxeld, inter_pool_comm)
  IF (noffdiag .GT. 0) CALL mp_sum (mtxelo, inter_pool_comm)

  CALL cryst_to_cart (nkstot, xk, at, -1)

  IF (ionode) THEN
    OPEN (unit = unit, file = TRIM (output_file_name), &
      form = 'formatted', status = 'replace')
    DO ik = 1, nkstot / nspin
      WRITE (unit, 101) xk(:, ik), nspin * ndiag, &
        nspin * noffdiag **2
      DO is = 1, nspin
        IF (ndiag .GT. 0) THEN
          DO ib = diag_nmin, diag_nmax
            WRITE (unit, 102) is, ib, mtxeld &
              (ib - diag_nmin + 1, ik + (is - 1) * nkstot / nspin), &
              0.0D0
          ENDDO
        ENDIF
        IF (noffdiag .GT. 0) THEN
          DO ib = offdiag_nmin, offdiag_nmax
            DO ib2 = offdiag_nmin, offdiag_nmax
              WRITE (unit, 103) is, ib2, ib, mtxelo &
                (ib2 - offdiag_nmin + 1, ib - offdiag_nmin + 1, &
                ik + (is - 1) * nkstot / nspin)
            ENDDO
          ENDDO
        ENDIF
      ENDDO
    ENDDO
    CLOSE (unit = unit, status = 'keep')
  ENDIF

  CALL cryst_to_cart (nkstot, xk, bg, 1)

  IF (ndiag .GT. 0) DEALLOCATE (mtxeld)
  IF (noffdiag .GT. 0) DEALLOCATE (mtxelo)

  RETURN

  101 FORMAT (3F13.9, 2I8)
  102 FORMAT (2I8, 2F15.9)
  103 FORMAT (3I8, 2F15.9)

END SUBROUTINE write_vxc_r

!-------------------------------------------------------------------------------

SUBROUTINE write_vxc_g (output_file_name, diag_nmin, diag_nmax, &
  offdiag_nmin, offdiag_nmax, vxc_zero_rho_core)

  USE constants, ONLY : rytoev
  USE cell_base, ONLY : tpiba2, at, bg
  USE ener, ONLY : etxc, vtxc
  USE exx, ONLY : vexx
  USE fft_base, ONLY : dfftp
  USE fft_interfaces, ONLY : fwfft, invfft
  USE funct, ONLY : exx_is_active
  USE gvect, ONLY : ngm, g, nl
  USE io_files, ONLY : nwordwfc, iunwfc
  USE io_global, ONLY : ionode
  USE kinds, ONLY : DP
  USE klist, ONLY : xk, nkstot
  USE lsda_mod, ONLY : nspin, isk
  USE mp, ONLY : mp_sum
  USE mp_global, ONLY : kunit, my_pool_id, intra_pool_comm, &
    inter_pool_comm, npool
  USE scf, ONLY : rho, rho_core, rhog_core
  USE wavefunctions_module, ONLY : evc, psic
  USE wvfct, ONLY : npwx, npw, nbnd, igk, g2kin, ecutwfc

  IMPLICIT NONE

  character (len = 256), intent (in) :: output_file_name
  integer, intent (inout) :: diag_nmin
  integer, intent (inout) :: diag_nmax
  integer, intent (inout) :: offdiag_nmin
  integer, intent (inout) :: offdiag_nmax
  logical, intent (in) :: vxc_zero_rho_core

  integer :: ik, is, ib, ig, ir, unit, nkbl, nkl, nkr, iks, ike, &
    ndiag, noffdiag, ib2
  complex (DP) :: dummy
  complex (DP), allocatable :: mtxeld (:, :)
  complex (DP), allocatable :: mtxelo (:, :, :)
  real (DP), allocatable :: vxcr (:, :)
  complex (DP), allocatable :: psic2 (:)
  complex (DP), allocatable :: hpsi (:)

  if(diag_nmin > diag_nmax) then
    call errore ( 'write_vxc_g', 'diag_nmin > diag_nmax', diag_nmin )
  endif
  IF (diag_nmin .LT. 1) diag_nmin = 1
  IF (diag_nmax .GT. nbnd) then
    write(0,'(a,i6)') 'WARNING: resetting diag_nmax to max number of bands', nbnd
    diag_nmax = nbnd
  ENDIF
  ndiag = MAX (diag_nmax - diag_nmin + 1, 0)

  if(offdiag_nmin > offdiag_nmax) then
    call errore ( 'write_vxc_g', 'offdiag_nmin > offdiag_nmax', offdiag_nmin )
  endif
  IF (offdiag_nmin .LT. 1) offdiag_nmin = 1
  IF (offdiag_nmax .GT. nbnd)  then
    write(0,'(a,i6)') 'WARNING: resetting offdiag_nmax to max number of bands', nbnd
    offdiag_nmax = nbnd
  ENDIF
  noffdiag = MAX (offdiag_nmax - offdiag_nmin + 1, 0)

  IF (ndiag .EQ. 0 .AND. noffdiag .EQ. 0) RETURN

  unit = 4

  nkbl = nkstot / kunit
  nkl = kunit * (nkbl / npool)
  nkr = (nkstot - nkl * npool) / kunit
  IF (my_pool_id .LT. nkr) nkl = nkl + kunit
  iks = nkl * my_pool_id + 1
  IF (my_pool_id .GE. nkr) iks = iks + nkr * kunit
  ike = iks + nkl - 1

  IF (ndiag .GT. 0) THEN
    ALLOCATE (mtxeld (ndiag, nkstot))
    mtxeld (:, :) = (0.0D0, 0.0D0)
  ENDIF
  IF (noffdiag .GT. 0) THEN
    ALLOCATE (mtxelo (noffdiag, noffdiag, nkstot))
    mtxelo (:, :, :) = (0.0D0, 0.0D0)
  ENDIF

  ALLOCATE (vxcr (dfftp%nnr, nspin))
  IF (noffdiag .GT. 0) ALLOCATE (psic2 (dfftp%nnr))
  ALLOCATE (hpsi (dfftp%nnr))

  vxcr (:, :) = 0.0D0
  IF ( vxc_zero_rho_core ) THEN
    rho_core ( : ) = 0.0D0
    rhog_core ( : ) = ( 0.0D0, 0.0D0 )
  ENDIF
  CALL v_xc (rho, rho_core, rhog_core, etxc, vtxc, vxcr)

  DO ik = iks, ike
    CALL gk_sort (xk (1, ik - iks + 1), ngm, g, ecutwfc &
      / tpiba2, npw, igk, g2kin)
    CALL davcio (evc, nwordwfc, iunwfc, ik - iks + 1, -1)
    IF (ndiag .GT. 0) THEN
      DO ib = diag_nmin, diag_nmax
        psic (:) = (0.0D0, 0.0D0)
        DO ig = 1, npw
          psic (nl (igk (ig))) = evc (ig, ib)
        ENDDO
        CALL invfft ('Dense', psic, dfftp)
        DO ir = 1, dfftp%nnr
          psic (ir) = psic (ir) * vxcr (ir, isk (ik))
        ENDDO
        CALL fwfft ('Dense', psic, dfftp)
        hpsi (:) = (0.0D0, 0.0D0)
        DO ig = 1, npw
          hpsi (ig) = psic (nl (igk (ig)))
        ENDDO
        psic (:) = (0.0D0, 0.0D0)
        DO ig = 1, npw
          psic (ig) = evc (ig, ib)
        ENDDO
        IF (exx_is_active ()) CALL vexx (npwx, npw, 1, &
          psic, hpsi)
        dummy = (0.0D0, 0.0D0)
        DO ig = 1, npw
          dummy = dummy + conjg (psic (ig)) * hpsi (ig)
        ENDDO
        dummy = dummy * CMPLX (rytoev, 0.0D0)
        CALL mp_sum (dummy, intra_pool_comm)
        mtxeld (ib - diag_nmin + 1, ik) = dummy
      ENDDO
    ENDIF
    IF (noffdiag .GT. 0) THEN
      DO ib = offdiag_nmin, offdiag_nmax
        psic (:) = (0.0D0, 0.0D0)
        DO ig = 1, npw
          psic (nl (igk (ig))) = evc (ig, ib)
        ENDDO
        CALL invfft ('Dense', psic, dfftp)
        DO ir = 1, dfftp%nnr
          psic (ir) = psic (ir) * vxcr (ir, isk (ik))
        ENDDO
        CALL fwfft ('Dense', psic, dfftp)
        hpsi (:) = (0.0D0, 0.0D0)
        DO ig = 1, npw
          hpsi (ig) = psic (nl (igk (ig)))
        ENDDO
        psic (:) = (0.0D0, 0.0D0)
        DO ig = 1, npw
          psic (ig) = evc (ig, ib)
        ENDDO
        IF (exx_is_active ()) CALL vexx (npwx, npw, 1, &
          psic, hpsi)
        DO ib2 = offdiag_nmin, offdiag_nmax
          psic2 (:) = (0.0D0, 0.0D0)
          DO ig = 1, npw
            psic2 (ig) = evc (ig, ib2)
          ENDDO
          dummy = (0.0D0, 0.0D0)
          DO ig = 1, npw
            dummy = dummy + conjg (psic2 (ig)) * hpsi (ig)
          ENDDO
          dummy = dummy * CMPLX (rytoev, 0.0D0)
          CALL mp_sum (dummy, intra_pool_comm)
          mtxelo (ib2 - offdiag_nmin + 1, ib - offdiag_nmin &
            + 1, ik) = dummy
        ENDDO
      ENDDO
    ENDIF
  ENDDO

  DEALLOCATE (vxcr)
  IF (noffdiag .GT. 0) DEALLOCATE (psic2)
  DEALLOCATE (hpsi)

  IF (ndiag .GT. 0) CALL mp_sum (mtxeld, inter_pool_comm)
  IF (noffdiag .GT. 0) CALL mp_sum (mtxelo, inter_pool_comm)

  CALL cryst_to_cart (nkstot, xk, at, -1)

  IF (ionode) THEN
    OPEN (unit = unit, file = TRIM (output_file_name), &
      form = 'formatted', status = 'replace')
    DO ik = 1, nkstot / nspin
      WRITE (unit, 101) xk(:, ik), nspin * ndiag, &
        nspin * noffdiag **2
      DO is = 1, nspin
        IF (ndiag .GT. 0) THEN
          DO ib = diag_nmin, diag_nmax
            WRITE (unit, 102) is, ib, mtxeld &
              (ib - diag_nmin + 1, ik + (is - 1) * nkstot / nspin)
          ENDDO
        ENDIF
        IF (noffdiag .GT. 0) THEN
          DO ib = offdiag_nmin, offdiag_nmax
            DO ib2 = offdiag_nmin, offdiag_nmax
              WRITE (unit, 103) is, ib2, ib, mtxelo &
                (ib2 - offdiag_nmin + 1, ib - offdiag_nmin + 1, &
                ik + (is - 1) * nkstot / nspin)
            ENDDO
          ENDDO
        ENDIF
      ENDDO
    ENDDO
    CLOSE (unit = unit, status = 'keep')
  ENDIF

  CALL cryst_to_cart (nkstot, xk, bg, 1)

  IF (ndiag .GT. 0) DEALLOCATE (mtxeld)
  IF (noffdiag .GT. 0) DEALLOCATE (mtxelo)

  RETURN

  101 FORMAT (3F13.9, 2I8)
  102 FORMAT (2I8, 2F15.9)
  103 FORMAT (3I8, 2F15.9)

END SUBROUTINE write_vxc_g

!-------------------------------------------------------------------------------

SUBROUTINE write_vscg ( output_file_name, real_or_complex, symm_type )

  USE cell_base, ONLY : omega, alat, tpiba, tpiba2, at, bg, ibrav
  USE constants, ONLY : pi, tpi, eps6
  USE fft_base, ONLY : dfftp
  USE fft_interfaces, ONLY : fwfft
  USE gvect, ONLY : ngm, ngm_g, ig_l2g, nl, mill, ecutrho
  USE io_global, ONLY : ionode
  USE ions_base, ONLY : nat, atm, ityp, tau 
  USE kinds, ONLY : DP
  USE lsda_mod, ONLY : nspin
  USE mp, ONLY : mp_sum
  USE mp_global, ONLY : intra_pool_comm
  USE scf, ONLY : vltot, v
  USE symm_base, ONLY : s, ftau, nsym
  USE wavefunctions_module, ONLY : psic

  IMPLICIT NONE

  character ( len = 256 ), intent (in) :: output_file_name
  integer, intent (in) :: real_or_complex
  character ( len = 9 ), intent (in) :: symm_type

  character :: stitle*32
  integer :: unit, is, ir, ig
  integer :: ns, nr, ng_l, ng_g
  integer :: nrecord
  real (DP), allocatable :: vscr_g ( :, : )
  complex (DP), allocatable :: vscg_g ( :, : )

  CALL check_inversion ( real_or_complex, nsym, s, nspin, .true., .true. )

  ! this is supposed to be VSC-Real/Complex but BGW wfn_rho_vxc IO
  ! does not recognize VSC header so we are using VXC instead
  IF ( real_or_complex .EQ. 1 ) THEN
    WRITE ( stitle, '("VXC-Real",24X)' )
  ELSE
    WRITE ( stitle, '("VXC-Complex",21X)' )
  ENDIF

  unit = 4
  nrecord = 1

  ns = nspin
  nr = dfftp%nnr
  ng_l = ngm
  ng_g = ngm_g

  ALLOCATE ( vscr_g ( ng_g, ns ) )
  ALLOCATE ( vscg_g ( ng_g, ns ) )

  DO is = 1, ns
    DO ig = 1, ng_g
      vscg_g ( ig, is ) = ( 0.0D0, 0.0D0 )
    ENDDO
  ENDDO

  vscr_g ( :, : ) = 0.0D0
  DO is = 1, ns
    DO ir = 1, nr
      psic ( ir ) = CMPLX ( v%of_r ( ir, is ) + vltot ( ir ), 0.0D0 )
    ENDDO
    CALL fwfft ( 'Dense', psic, dfftp )
    DO ig = 1, ng_l
      vscg_g ( ig_l2g ( ig ), is ) = psic ( nl ( ig ) )
    ENDDO
  ENDDO

  CALL mp_sum ( vscg_g, intra_pool_comm )

  IF ( ionode ) OPEN ( unit = unit, file = TRIM ( output_file_name ), &
      form = 'unformatted', status = 'replace' )

  CALL write_header(unit, stitle, symm_type)

  IF ( ionode ) THEN
    WRITE ( unit ) nrecord
    WRITE ( unit ) ng_g
    IF ( real_or_complex .EQ. 1 ) THEN
      WRITE ( unit ) ( ( dble ( vscg_g ( ig, is ) ), &
        ig = 1, ng_g ), is = 1, ns )
    ELSE
      WRITE ( unit ) ( ( vscg_g ( ig, is ), &
        ig = 1, ng_g ), is = 1, ns )
    ENDIF
    CLOSE ( unit = unit, status = 'keep' )
  ENDIF

  DEALLOCATE ( vscg_g )
  DEALLOCATE ( vscr_g )

  RETURN

END SUBROUTINE write_vscg

!-------------------------------------------------------------------------------

SUBROUTINE write_vkbg (output_file_name, symm_type, wfng_kgrid, &
  wfng_nk1, wfng_nk2, wfng_nk3, wfng_dk1, wfng_dk2, wfng_dk3)

  USE cell_base, ONLY : omega, alat, tpiba, tpiba2, at, bg, ibrav
  USE constants, ONLY : pi, tpi, eps6
  USE fft_base, ONLY : dfftp
  USE gvect, ONLY : ngm, ngm_g, ig_l2g, g, mill, ecutrho
  USE io_global, ONLY : ionode, ionode_id
  USE ions_base, ONLY : nat, atm, ityp, tau, nsp
  USE kinds, ONLY : DP
  USE klist, ONLY : xk, wk, ngk, nks, nkstot
  USE lsda_mod, ONLY : nspin, isk
  USE mp, ONLY : mp_sum, mp_max, mp_get, mp_barrier
  USE mp_global, ONLY : mpime, nproc, world_comm, kunit, me_pool, &
    root_pool, my_pool_id, npool, nproc_pool, intra_pool_comm
  USE mp_wave, ONLY : mergewf
  USE start_k, ONLY : nk1, nk2, nk3, k1, k2, k3
  USE symm_base, ONLY : s, ftau, nsym
  USE uspp, ONLY : nkb, vkb, deeq
  USE uspp_param, ONLY : nhm, nh
  USE wvfct, ONLY : npwx, npw, g2kin, ecutwfc

  IMPLICIT NONE

  character (len = 256), intent (in) :: output_file_name
  character ( len = 9 ), intent (in) :: symm_type
  logical, intent (in) :: wfng_kgrid
  integer, intent (in) :: wfng_nk1
  integer, intent (in) :: wfng_nk2
  integer, intent (in) :: wfng_nk3
  real (DP), intent (in) :: wfng_dk1
  real (DP), intent (in) :: wfng_dk2
  real (DP), intent (in) :: wfng_dk3

  character :: cdate*9, ctime*9, sdate*32, stime*32, stitle*32
  integer :: i, j, k, ierr, ik, is, ig, ikb, iat, isp, ih, jh, &
    unit, nkbl, nkl, nkr, iks, ike, npw_g, npwx_g, ngg, ipsour, &
    igwx, local_pw, id, nd, ntran, cell_symmetry, nrecord, &
    ns, nst, nsf
  real (DP) :: alat2, recvol, dr1, t1 ( 3 ), t2 ( 3 )
  real (DP) :: r1 ( 3, 3 ), r2 ( 3, 3 ), adot ( 3, 3 )
  real (DP) :: bdot ( 3, 3 ), translation ( 3, 48 )
  integer, allocatable :: kmap ( : )
  integer, allocatable :: smap ( : )
  integer, allocatable :: gvec ( :, : )
  integer, allocatable :: ngk_g ( : )
  integer, allocatable :: igk_l2g ( :, : )
  integer, allocatable :: itmp ( : )
  integer, allocatable :: igwk ( : )
  integer, allocatable :: igwf_l2g ( : )
  integer, allocatable :: ipmask ( : )
  complex (DP), allocatable :: vkb_g ( : )

  INTEGER, EXTERNAL :: atomic_number

  IF ( nkb == 0 ) RETURN

  CALL date_and_tim ( cdate, ctime )
  WRITE ( sdate, '(A2,"-",A3,"-",A4,21X)' ) cdate(1:2), cdate(3:5), cdate(6:9)
  WRITE ( stime, '(A8,24X)' ) ctime(1:8)
  ! BGW wfn_rho_vxc IO does not recognize VKB header so this file
  ! is read directly by SAPO code in BerkeleyGW
  WRITE ( stitle, '("VKB-Complex",21X)' )

  unit = 4
  nrecord = 1
  nd = 3

  call set_spin(ns,nst,nsf,nspin)
  nkbl = nkstot / kunit
  nkl = kunit * ( nkbl / npool )
  nkr = ( nkstot - nkl * npool ) / kunit
  IF ( my_pool_id .LT. nkr ) nkl = nkl + kunit
  iks = nkl * my_pool_id + 1
  IF ( my_pool_id .GE. nkr ) iks = iks + nkr * kunit
  ike = iks + nkl - 1

  ierr = 0
  IF ( ibrav .EQ. 0 ) THEN
    IF ( TRIM ( symm_type ) .EQ. 'cubic' ) THEN
      cell_symmetry = 0
    ELSEIF ( TRIM ( symm_type ) .EQ. 'hexagonal' ) THEN
      cell_symmetry = 1
    ELSE
      ierr = 1
    ENDIF
  ELSEIF ( abs ( ibrav ) .GE. 1 .AND. abs ( ibrav ) .LE. 3 ) THEN
    cell_symmetry = 0
  ELSEIF ( abs ( ibrav ) .GE. 4 .AND. abs ( ibrav ) .LE. 5 ) THEN
    cell_symmetry = 1
  ELSEIF ( abs ( ibrav ) .GE. 6 .AND. abs ( ibrav ) .LE. 14 ) THEN
    cell_symmetry = 0
  ELSE
    ierr = 1
  ENDIF
  IF ( ierr .GT. 0 ) &
    CALL errore ( 'write_vkbg', 'cell_symmetry', ierr )

  ntran = nsym
  DO i = 1, ntran
    DO j = 1, nd
      DO k = 1, nd
        r1 ( k, j ) = dble ( s ( k, j, i ) )
      ENDDO
    ENDDO
    CALL invmat ( 3, r1, r2, dr1 )
    t1 ( 1 ) = dble ( ftau ( 1, i ) ) / dble ( dfftp%nr1 )
    t1 ( 2 ) = dble ( ftau ( 2, i ) ) / dble ( dfftp%nr2 )
    t1 ( 3 ) = dble ( ftau ( 3, i ) ) / dble ( dfftp%nr3 )
    DO j = 1, nd
      t2 ( j ) = 0.0D0
      DO k = 1, nd
        t2 ( j ) = t2 ( j ) + r2 ( k, j ) * t1 ( k )
      ENDDO
      IF ( t2 ( j ) .GE. eps6 + 0.5D0 ) &
        t2 ( j ) = t2 ( j ) - dble ( int ( t2 ( j ) + 0.5D0 ) )
      IF ( t2 ( j ) .LT. eps6 - 0.5D0 ) &
        t2 ( j ) = t2 ( j ) - dble ( int ( t2 ( j ) - 0.5D0 ) )
    ENDDO
    DO j = 1, nd
      translation ( j, i ) = t2 ( j ) * tpi
    ENDDO
  ENDDO

  alat2 = alat ** 2
  recvol = 8.0D0 * pi**3 / omega

  DO i = 1, nd
    DO j = 1, nd
      adot ( j, i ) = 0.0D0
    ENDDO
  ENDDO
  DO i = 1, nd
    DO j = 1, nd
      DO k = 1, nd
        adot ( j, i ) = adot ( j, i ) + &
          at ( k, j ) * at ( k, i ) * alat2
      ENDDO
    ENDDO
  ENDDO

  DO i = 1, nd
    DO j = 1, nd
      bdot ( j, i ) = 0.0D0
    ENDDO
  ENDDO
  DO i = 1, nd
    DO j = 1, nd
      DO k = 1, nd
        bdot ( j, i ) = bdot ( j, i ) + &
          bg ( k, j ) * bg ( k, i ) * tpiba2
      ENDDO
    ENDDO
  ENDDO

  ALLOCATE ( kmap ( nkstot ) )
  ALLOCATE ( smap ( nkstot ) )

  DO i = 1, nkstot
    j = ( i - 1 ) / ns
    k = i - 1 - j * ns
    kmap ( i ) = j + k * ( nkstot / ns ) + 1
    smap ( i ) = k + 1
  ENDDO
  ierr = 0
  DO i = 1, nkstot
    ik = kmap ( i )
    is = smap ( i )
    IF ( ik .GE. iks .AND. ik .LE. ike .AND. is .NE. isk ( ik ) ) &
      ierr = ierr + 1
  ENDDO
  CALL mp_max ( ierr )
  IF ( ierr .GT. 0 ) &
    CALL errore ( 'write_vkbg', 'smap', ierr )

  ALLOCATE ( gvec ( 3, ngm_g ) )
  gvec = 0
  DO ig = 1, ngm
    gvec ( 1, ig_l2g ( ig ) ) = mill ( 1, ig )
    gvec ( 2, ig_l2g ( ig ) ) = mill ( 2, ig )
    gvec ( 3, ig_l2g ( ig ) ) = mill ( 3, ig )
  ENDDO
  CALL mp_sum ( gvec, intra_pool_comm )

  ALLOCATE ( ngk_g ( nkstot ) )
  ALLOCATE ( igk_l2g ( npwx, nks ) )
  ngk_g = 0
  igk_l2g = 0
  ALLOCATE ( itmp ( npwx ) )
  DO ik = 1, nks
    itmp = 0
    npw = npwx
    CALL gk_sort ( xk ( 1, ik + iks - 1 ), ngm, g, ecutwfc / tpiba2, &
      npw, itmp ( 1 ), g2kin )
    DO ig = 1, npw
      igk_l2g ( ig, ik ) = ig_l2g ( itmp ( ig ) )
    ENDDO
    ngk ( ik ) = npw
  ENDDO
  DEALLOCATE ( itmp )
  DO ik = 1, nks
    ngk_g ( ik + iks - 1 ) = ngk ( ik )
  ENDDO
  CALL mp_sum ( ngk_g )
  npw_g = MAXVAL ( igk_l2g ( :, : ) )
  CALL mp_max ( npw_g )
  npwx_g = MAXVAL ( ngk_g ( : ) )

  CALL cryst_to_cart (nkstot, xk, at, -1)

  IF (ionode) THEN
    OPEN (unit = unit, file = TRIM (output_file_name), &
      form = 'unformatted', status = 'replace')
    WRITE ( unit ) stitle, sdate, stime
    WRITE ( unit ) nsf, ngm_g, ntran, cell_symmetry, nat, ecutrho, &
      nkstot / ns, nsp, nkb, nhm, npwx_g, ecutwfc
    IF ( wfng_kgrid ) THEN
      WRITE ( unit ) dfftp%nr1, dfftp%nr2, dfftp%nr3, wfng_nk1, wfng_nk2, wfng_nk3, &
        wfng_dk1, wfng_dk2, wfng_dk3
    ELSE
      WRITE ( unit ) dfftp%nr1, dfftp%nr2, dfftp%nr3, nk1, nk2, nk3, &
        0.5D0 * dble ( k1 ), 0.5D0 * dble ( k2 ), 0.5D0 * dble ( k3 )
    ENDIF
    WRITE ( unit ) omega, alat, ( ( at ( j, i ), j = 1, nd ), i = 1, nd ), &
      ( ( adot ( j, i ), j = 1, nd ), i = 1, nd )
    WRITE ( unit ) recvol, tpiba, ( ( bg ( j, i ), j = 1, nd ), i = 1, nd ), &
      ( ( bdot ( j, i ), j = 1, nd ), i = 1, nd )
    WRITE ( unit ) ( ( ( s ( k, j, i ), k = 1, nd ), j = 1, nd ), i = 1, ntran )
    WRITE ( unit ) ( ( translation ( j, i ), j = 1, nd ), i = 1, ntran )
    WRITE ( unit ) ( ( tau ( j, i ), j = 1, nd ), atomic_number ( atm ( ityp ( i ) ) ), i = 1, nat )
    WRITE ( unit ) ( ngk_g ( ik ), ik = 1, nkstot / ns )
    WRITE ( unit ) ( wk ( ik ) * dble ( ns ) / 2.0D0, ik = 1, nkstot / ns )
    WRITE ( unit ) ( ( xk ( id, ik ), id = 1, nd ), ik = 1, nkstot / ns )
    WRITE ( unit ) ( ityp ( iat ), iat = 1, nat )
    WRITE ( unit ) ( nh ( isp ), isp = 1, nsp )
    WRITE ( unit ) ( ( ( ( deeq ( jh, ih, iat, is ), &
      jh = 1, nhm ), ih = 1, nhm ), iat = 1, nat ), is = 1, ns )
    WRITE ( unit ) nrecord
    WRITE ( unit ) ngm_g
    WRITE ( unit ) ( ( gvec ( id, ig ), id = 1, nd ), ig = 1, ngm_g )
  ENDIF

  CALL cryst_to_cart (nkstot, xk, bg, 1)

  ALLOCATE ( igwk ( npwx_g ) )

  DO i = 1, nkstot

    ik = kmap ( i )
    is = smap ( i )

    igwk = 0

    ALLOCATE ( itmp ( npw_g ) )
    itmp = 0
    IF ( ik .GE. iks .AND. ik .LE. ike ) THEN
      DO ig = 1, ngk ( ik - iks + 1 )
        itmp ( igk_l2g ( ig, ik - iks + 1 ) ) = igk_l2g ( ig, ik - iks + 1 )
      ENDDO
    ENDIF
    CALL mp_sum ( itmp )
    ngg = 0
    DO ig = 1, npw_g
      IF ( itmp ( ig ) .EQ. ig ) THEN
        ngg = ngg + 1
        igwk ( ngg ) = ig
      ENDIF
    ENDDO
    DEALLOCATE ( itmp )

    IF ( ionode ) THEN
      IF ( is .EQ. 1 ) THEN
        WRITE ( unit ) nrecord
        WRITE ( unit ) ngk_g ( ik )
        WRITE ( unit ) ( ( gvec ( j, igwk ( ig ) ), j = 1, 3 ), &
          ig = 1, ngk_g ( ik ) )
      ENDIF
    ENDIF

    local_pw = 0
    IF ( ik .GE. iks .AND. ik .LE. ike ) THEN
      ALLOCATE ( itmp ( npwx ) )
      npw = npwx
      CALL gk_sort ( xk ( 1, ik ), ngm, g, ecutwfc / tpiba2, &
        npw, itmp ( 1 ), g2kin )
      CALL init_us_2 ( npw, itmp, xk ( 1, ik ), vkb )
      local_pw = ngk ( ik - iks + 1 )
      DEALLOCATE ( itmp )
    ENDIF

    ALLOCATE ( igwf_l2g ( local_pw ) )
    igwf_l2g = 0
    DO ig = 1, local_pw
      ngg = igk_l2g ( ig, ik - iks + 1 )
      DO j = 1, ngk_g ( ik )
        IF ( ngg .EQ. igwk ( j ) ) THEN
          igwf_l2g ( ig ) = j
          EXIT
        ENDIF
      ENDDO
    ENDDO

    ALLOCATE ( ipmask ( nproc ) )
    ipmask = 0
    ipsour = ionode_id
    IF ( npool .GT. 1 ) THEN
      IF ( ( ik .GE. iks ) .AND. ( ik .LE. ike ) ) THEN
        IF ( me_pool .EQ. root_pool ) ipmask ( mpime + 1 ) = 1
      ENDIF
      CALL mp_sum ( ipmask )
      DO j = 1, nproc
        IF ( ipmask ( j ) .EQ. 1 ) ipsour = j - 1
      ENDDO
    ENDIF
    DEALLOCATE ( ipmask )

    igwx = 0
    ierr = 0
    IF ( ik .GE. iks .AND. ik .LE. ike ) &
      igwx = MAXVAL ( igwf_l2g ( 1 : local_pw ) )
    CALL mp_max ( igwx, intra_pool_comm )
    IF ( ipsour .NE. ionode_id ) &
      CALL mp_get ( igwx, igwx, mpime, ionode_id, ipsour, 1 )
    ierr = 0
    IF ( ik .GE. iks .AND. ik .LE. ike .AND. igwx .NE. ngk_g ( ik ) ) &
      ierr = 1
    CALL mp_max ( ierr )
    IF ( ierr .GT. 0 ) &
      CALL errore ( 'write_vkbg', 'igwx ngk_g', ierr )

    ALLOCATE ( vkb_g ( MAX ( 1, igwx ) ) )

    DO ikb = 1, nkb

      vkb_g = ( 0.0D0, 0.0D0 )
      IF ( npool .GT. 1 ) THEN
        IF ( ( ik .GE. iks ) .AND. ( ik .LE. ike ) ) THEN
          CALL mergewf ( vkb ( :, ikb ), vkb_g, local_pw, igwf_l2g, &
            me_pool, nproc_pool, root_pool, intra_pool_comm )
        ENDIF
        IF ( ipsour .NE. ionode_id ) THEN
          CALL mp_get ( vkb_g, vkb_g, mpime, ionode_id, ipsour, ikb, &
            world_comm )
        ENDIF
      ELSE
        CALL mergewf ( vkb ( :, ikb ), vkb_g, local_pw, igwf_l2g, &
          mpime, nproc, ionode_id, world_comm )
      ENDIF

      IF ( ionode ) THEN
        WRITE ( unit ) nrecord
        WRITE ( unit ) igwx
        WRITE ( unit ) ( vkb_g ( ig ), ig = 1, igwx )
      ENDIF

    ENDDO

    DEALLOCATE ( vkb_g )
    DEALLOCATE ( igwf_l2g )

  ENDDO

  IF ( ionode ) THEN
    CLOSE ( unit = unit, status = 'keep' )
  ENDIF

  DEALLOCATE ( igwk )
  DEALLOCATE ( igk_l2g )
  DEALLOCATE ( ngk_g )
  DEALLOCATE ( gvec )
  DEALLOCATE ( smap )
  DEALLOCATE ( kmap )

  RETURN

END SUBROUTINE write_vkbg

!-------------------------------------------------------------------------------

subroutine check_inversion(real_or_complex, ntran, mtrx, nspin, warn, real_need_inv)

! check_inversion    Originally By David A. Strubbe    Last Modified 10/14/2010
! Check whether our choice of real/complex version is appropriate given the
! presence or absence of inversion symmetry.

  USE io_global, ONLY : ionode

  implicit none

  integer, intent(in) :: real_or_complex
  integer, intent(in) :: ntran
  integer, intent(in) :: mtrx(3, 3, 48)
  integer, intent(in) :: nspin
  logical, intent(in) :: warn ! set to false to suppress warnings, for converters
  logical, intent(in) :: real_need_inv ! use for generating routines to block real without inversion

  integer :: invflag, isym, ii, jj, itest

  invflag = 0
  do isym = 1, ntran
    itest = 0
    do ii = 1, 3
      do jj = 1, 3
        if(ii .eq. jj) then
          itest = itest + (mtrx(ii, jj, isym) + 1)**2
        else
          itest = itest + mtrx(ii, jj, isym)**2
        endif
      enddo
    enddo
    if(itest .eq. 0) invflag = invflag + 1
    if(invflag .gt. 1) call errore('check_inversion', 'More than one inversion symmetry operation is present.', invflag)
  enddo

  if(real_or_complex .eq. 2) then
    if(invflag .ne. 0 .and. warn .and. nspin == 1) then
      if(ionode) write(6, '(a)') 'WARNING: Inversion symmetry is present. The real version would be faster.'
    endif
  else
    if(invflag .eq. 0) then
      if(real_need_inv) then
        call errore('check_inversion', 'The real version cannot be used without inversion symmetry.', -1)
      endif
      if(ionode) then
        write(6, '(a)') 'WARNING: Inversion symmetry is absent in symmetries used to reduce k-grid.'
        write(6, '(a)') 'Be sure inversion is still a spatial symmetry, or you must use complex version instead.'
      endif
    endif
    if(nspin .eq. 2) then
      call errore('check_inversion', &
        'Real version may only be used for spin-unpolarized calculations.', nspin)
    endif
  endif

  return

end subroutine check_inversion

!-------------------------------------------------------------------------------

subroutine write_header(unit, stitle, symm_type)

  USE cell_base, ONLY : omega, alat, tpiba, tpiba2, at, bg, ibrav
  USE constants, ONLY : pi, tpi, eps6
  USE fft_base, ONLY : dfftp
  USE gvect, ONLY : ngm, ngm_g, ig_l2g, mill, ecutrho
  USE io_global, ONLY : ionode
  USE ions_base, ONLY : nat, atm, ityp, tau
  USE kinds, ONLY : DP
  USE lsda_mod, ONLY : nspin
  USE mp, ONLY : mp_sum
  USE mp_global, ONLY : intra_pool_comm
  USE scf, ONLY : rho
  USE symm_base, ONLY : s, ftau, nsym

  IMPLICIT NONE

  integer, intent(in) :: unit
  character(len=32), intent(in) :: stitle
  character ( len = 9 ) :: symm_type

  character :: cdate*9, ctime*9, sdate*32, stime*32
  integer :: id, ig, i, j, k, ierr
  integer :: nd, ns, nst, nsf, ng_l, ng_g
  integer :: ntran, cell_symmetry, nrecord
  real (DP) :: alat2, recvol, dr1, t1 ( 3 ), t2 ( 3 )
  real (DP) :: r1 ( 3, 3 ), r2 ( 3, 3 ), adot ( 3, 3 )
  real (DP) :: bdot ( 3, 3 ), translation ( 3, 48 )
  integer, allocatable :: g_g ( :, : )

  INTEGER, EXTERNAL :: atomic_number

  CALL date_and_tim ( cdate, ctime )
  WRITE ( sdate, '(A2,"-",A3,"-",A4,21X)' ) cdate(1:2), cdate(3:5), cdate(6:9)
  WRITE ( stime, '(A8,24X)' ) ctime(1:8)

  nrecord = 1
  nd = 3

  ng_l = ngm
  ng_g = ngm_g
  call set_spin(ns,nst,nsf,nspin)

  ierr = 0
  IF ( ibrav .EQ. 0 ) THEN
    IF ( TRIM ( symm_type ) .EQ. 'cubic' ) THEN
      cell_symmetry = 0
    ELSEIF ( TRIM ( symm_type ) .EQ. 'hexagonal' ) THEN
      cell_symmetry = 1
    ELSE
      ierr = 1
    ENDIF
  ELSEIF ( abs ( ibrav ) .GE. 1 .AND. abs ( ibrav ) .LE. 3 ) THEN
    cell_symmetry = 0
  ELSEIF ( abs ( ibrav ) .GE. 4 .AND. abs ( ibrav ) .LE. 5 ) THEN
    cell_symmetry = 1
  ELSEIF ( abs ( ibrav ) .GE. 6 .AND. abs ( ibrav ) .LE. 14 ) THEN
    cell_symmetry = 0
  ELSE
    ierr = 1
  ENDIF
  IF ( ierr .GT. 0 ) &
    CALL errore ( 'write_header', 'cell_symmetry', ierr )

  ntran = nsym
  DO i = 1, ntran
    DO j = 1, nd
      DO k = 1, nd
        r1 ( k, j ) = dble ( s ( k, j, i ) )
      ENDDO
    ENDDO
    CALL invmat ( 3, r1, r2, dr1 )
    t1 ( 1 ) = dble ( ftau ( 1, i ) ) / dble ( dfftp%nr1 )
    t1 ( 2 ) = dble ( ftau ( 2, i ) ) / dble ( dfftp%nr2 )
    t1 ( 3 ) = dble ( ftau ( 3, i ) ) / dble ( dfftp%nr3 )
    DO j = 1, nd
      t2 ( j ) = 0.0D0
      DO k = 1, nd
        t2 ( j ) = t2 ( j ) + r2 ( k, j ) * t1 ( k )
      ENDDO
      IF ( t2 ( j ) .GE. eps6 + 0.5D0 ) &
        t2 ( j ) = t2 ( j ) - dble ( int ( t2 ( j ) + 0.5D0 ) )
      IF ( t2 ( j ) .LT. eps6 - 0.5D0 ) &
        t2 ( j ) = t2 ( j ) - dble ( int ( t2 ( j ) - 0.5D0 ) )
    ENDDO
    DO j = 1, nd
      translation ( j, i ) = t2 ( j ) * tpi
    ENDDO
  ENDDO

  alat2 = alat ** 2
  recvol = 8.0D0 * pi**3 / omega

  DO i = 1, nd
    DO j = 1, nd
      adot ( j, i ) = 0.0D0
    ENDDO
  ENDDO
  DO i = 1, nd
    DO j = 1, nd
      DO k = 1, nd
        adot ( j, i ) = adot ( j, i ) + &
          at ( k, j ) * at ( k, i ) * alat2
      ENDDO
    ENDDO
  ENDDO

  DO i = 1, nd
    DO j = 1, nd
      bdot ( j, i ) = 0.0D0
    ENDDO
  ENDDO
  DO i = 1, nd
    DO j = 1, nd
      DO k = 1, nd
        bdot ( j, i ) = bdot ( j, i ) + &
          bg ( k, j ) * bg ( k, i ) * tpiba2
      ENDDO
    ENDDO
  ENDDO

  ALLOCATE ( g_g ( nd, ng_g ) )

  DO ig = 1, ng_g
    DO id = 1, nd
      g_g ( id, ig ) = 0
    ENDDO
  ENDDO

  DO ig = 1, ng_l
    g_g ( 1, ig_l2g ( ig ) ) = mill ( 1, ig )
    g_g ( 2, ig_l2g ( ig ) ) = mill ( 2, ig )
    g_g ( 3, ig_l2g ( ig ) ) = mill ( 3, ig )
  ENDDO

  CALL mp_sum ( g_g, intra_pool_comm )

  IF ( ionode ) THEN
    WRITE ( unit ) stitle, sdate, stime
    WRITE ( unit ) nspin, ng_g, ntran, cell_symmetry, nat, ecutrho
    WRITE ( unit ) dfftp%nr1, dfftp%nr2, dfftp%nr3
    WRITE ( unit ) omega, alat, ( ( at ( j, i ), j = 1, nd ), i = 1, nd ), &
      ( ( adot ( j, i ), j = 1, nd ), i = 1, nd )
    WRITE ( unit ) recvol, tpiba, ( ( bg ( j, i ), j = 1, nd ), i = 1, nd ), &
      ( ( bdot ( j, i ), j = 1, nd ), i = 1, nd )
    WRITE ( unit ) ( ( ( s ( k, j, i ), k = 1, nd ), j = 1, nd ), i = 1, ntran )
    WRITE ( unit ) ( ( translation ( j, i ), j = 1, nd ), i = 1, ntran )
    WRITE ( unit ) ( ( tau ( j, i ), j = 1, nd ), atomic_number ( atm ( ityp ( i ) ) ), i = 1, nat )
    WRITE ( unit ) nrecord
    WRITE ( unit ) ng_g
    WRITE ( unit ) ( ( g_g ( id, ig ), id = 1, nd ), ig = 1, ng_g )
  ENDIF

  DEALLOCATE ( g_g )
  RETURN

end subroutine write_header

!-------------------------------------------------------------------------------

! Set spin-related parameters ns, nst, nsf
!
subroutine set_spin(ns, nst, nsf, nspin)

  IMPLICIT NONE

  integer, intent(out) :: ns, nst, nsf
  integer, intent(in) :: nspin

  IF ( nspin == 4 ) THEN
    ns = 1
    nst = 2
    nsf = 4
  ELSE
    ns = nspin
    nst = nspin
    nsf = nspin
  ENDIF

  RETURN

end subroutine set_spin
end module pw2bgw_m

!-------------------------------------------------------------------------------

PROGRAM pw2bgw

  USE constants, ONLY : eps12
  USE control_flags, ONLY : gamma_only
  USE environment, ONLY : environment_start, environment_end
  USE io_files, ONLY : prefix, tmp_dir, outdir
  USE io_global, ONLY : ionode, ionode_id
  USE kinds, ONLY : DP
  USE lsda_mod, ONLY : nspin
  USE mp, ONLY : mp_bcast
  USE mp_global, ONLY : mp_startup
  USE paw_variables, ONLY : okpaw
  USE scf, ONLY : rho_core, rhog_core
  USE uspp, ONLY : okvan
  USE pw2bgw_m

  IMPLICIT NONE

  character(len=6) :: codename = 'PW2BGW'

  integer :: real_or_complex
  character ( len = 9 ) :: symm_type
  logical :: wfng_flag
  character ( len = 256 ) :: wfng_file
  logical :: wfng_kgrid
  integer :: wfng_nk1
  integer :: wfng_nk2
  integer :: wfng_nk3
  real (DP) :: wfng_dk1
  real (DP) :: wfng_dk2
  real (DP) :: wfng_dk3
  logical :: wfng_occupation
  integer :: wfng_nvmin
  integer :: wfng_nvmax
  logical :: rhog_flag
  character ( len = 256 ) :: rhog_file
  integer :: rhog_nvmin
  integer :: rhog_nvmax
  logical :: vxcg_flag
  character ( len = 256 ) :: vxcg_file
  logical :: vxc0_flag
  character ( len = 256 ) :: vxc0_file
  logical :: vxc_flag
  character ( len = 256 ) :: vxc_file
  character :: vxc_integral
  integer :: vxc_diag_nmin
  integer :: vxc_diag_nmax
  integer :: vxc_offdiag_nmin
  integer :: vxc_offdiag_nmax
  logical :: vxc_zero_rho_core
  logical :: vscg_flag
  character ( len = 256 ) :: vscg_file
  logical :: vkbg_flag
  character ( len = 256 ) :: vkbg_file

  NAMELIST / input_pw2bgw / prefix, outdir, &
    real_or_complex, symm_type, wfng_flag, wfng_file, wfng_kgrid, &
    wfng_nk1, wfng_nk2, wfng_nk3, wfng_dk1, wfng_dk2, wfng_dk3, &
    wfng_occupation, wfng_nvmin, wfng_nvmax, rhog_flag, rhog_file, &
    rhog_nvmin, rhog_nvmax, vxcg_flag, vxcg_file, vxc0_flag, vxc0_file, &
    vxc_flag, vxc_file, vxc_integral, vxc_diag_nmin, vxc_diag_nmax, &
    vxc_offdiag_nmin, vxc_offdiag_nmax, vxc_zero_rho_core, &
    vscg_flag, vscg_file, vkbg_flag, vkbg_file

  integer :: ii, ios
  character ( len = 256 ) :: output_file_name
  logical :: die_spinors

  character (len=256), external :: trimcheck
  character (len=1), external :: lowercase

#ifdef __PARA
  CALL mp_startup ( )
#endif
  CALL environment_start ( codename )

  prefix = 'prefix'
  CALL get_env ( 'ESPRESSO_TMPDIR', outdir )
  IF ( TRIM ( outdir ) == ' ' ) outdir = './'
  real_or_complex = 2
  symm_type = 'cubic'
  wfng_flag = .FALSE.
  wfng_file = 'WFN'
  wfng_kgrid = .FALSE.
  wfng_nk1 = 0
  wfng_nk2 = 0
  wfng_nk3 = 0
  wfng_dk1 = 0.0D0
  wfng_dk2 = 0.0D0
  wfng_dk3 = 0.0D0
  wfng_occupation = .FALSE.
  wfng_nvmin = 0
  wfng_nvmax = 0
  rhog_flag = .FALSE.
  rhog_file = 'RHO'
  rhog_nvmin = 0
  rhog_nvmax = 0
  vxcg_flag = .FALSE.
  vxcg_file = 'VXC'
  vxc0_flag = .FALSE.
  vxc0_file = 'vxc0.dat'
  vxc_flag = .FALSE.
  vxc_file = 'vxc.dat'
  vxc_integral = 'g'
  vxc_diag_nmin = 0
  vxc_diag_nmax = 0
  vxc_offdiag_nmin = 0
  vxc_offdiag_nmax = 0
  vxc_zero_rho_core = .TRUE.
  vscg_flag = .FALSE.
  vscg_file = 'VSC'
  vkbg_flag = .FALSE.
  vkbg_file = 'VKB'

  IF ( ionode ) THEN
    CALL input_from_file ( )
    READ ( 5, input_pw2bgw, iostat = ios )
    IF ( ios /= 0 ) CALL errore ( codename, 'input_pw2bgw', abs ( ios ) )

    DO ii = 1, LEN_TRIM (symm_type)
      symm_type(ii:ii) = lowercase (symm_type(ii:ii))
    END DO
    DO ii = 1, LEN_TRIM (vxc_integral)
      vxc_integral(ii:ii) = lowercase (vxc_integral(ii:ii))
    END DO

    IF ( real_or_complex /= 1 .AND. real_or_complex /= 2 ) &
      CALL errore ( codename, 'real_or_complex', 1 )
    IF ( symm_type /= 'cubic' .AND. symm_type /= 'hexagonal' ) &
      CALL errore ( codename, 'symm_type', 1 )
    IF ( vxc_integral /= 'r' .AND. vxc_integral /= 'g' ) &
      CALL errore ( codename, 'vxc_integral', 1 )
  ENDIF

  tmp_dir = trimcheck ( outdir )
  CALL mp_bcast ( outdir, ionode_id )
  CALL mp_bcast ( tmp_dir, ionode_id )
  CALL mp_bcast ( prefix, ionode_id )
  CALL mp_bcast ( real_or_complex, ionode_id )
  CALL mp_bcast ( symm_type, ionode_id )
  CALL mp_bcast ( wfng_flag, ionode_id )
  CALL mp_bcast ( wfng_file, ionode_id )
  CALL mp_bcast ( wfng_kgrid, ionode_id )
  CALL mp_bcast ( wfng_nk1, ionode_id )
  CALL mp_bcast ( wfng_nk2, ionode_id )
  CALL mp_bcast ( wfng_nk3, ionode_id )
  CALL mp_bcast ( wfng_dk1, ionode_id )
  CALL mp_bcast ( wfng_dk2, ionode_id )
  CALL mp_bcast ( wfng_dk3, ionode_id )
  CALL mp_bcast ( wfng_occupation, ionode_id )
  CALL mp_bcast ( wfng_nvmin, ionode_id )
  CALL mp_bcast ( wfng_nvmax, ionode_id )
  CALL mp_bcast ( rhog_flag, ionode_id )
  CALL mp_bcast ( rhog_file, ionode_id )
  CALL mp_bcast ( rhog_nvmin, ionode_id )
  CALL mp_bcast ( rhog_nvmax, ionode_id )
  CALL mp_bcast ( vxcg_flag, ionode_id )
  CALL mp_bcast ( vxcg_file, ionode_id )
  CALL mp_bcast ( vxc0_flag, ionode_id )
  CALL mp_bcast ( vxc0_file, ionode_id )
  CALL mp_bcast ( vxc_flag, ionode_id )
  CALL mp_bcast ( vxc_integral, ionode_id )
  CALL mp_bcast ( vxc_file, ionode_id )
  CALL mp_bcast ( vxc_diag_nmin, ionode_id )
  CALL mp_bcast ( vxc_diag_nmax, ionode_id )
  CALL mp_bcast ( vxc_offdiag_nmin, ionode_id )
  CALL mp_bcast ( vxc_offdiag_nmax, ionode_id )
  CALL mp_bcast ( vxc_zero_rho_core, ionode_id )
  CALL mp_bcast ( vscg_flag, ionode_id )
  CALL mp_bcast ( vscg_file, ionode_id )
  CALL mp_bcast ( vkbg_flag, ionode_id )
  CALL mp_bcast ( vkbg_file, ionode_id )

  CALL read_file ( )

  if (ionode) then
    if (MAX (MAXVAL (ABS (rho_core (:) ) ), MAXVAL (ABS (rhog_core (:) ) ) ) &
      .LT. eps12) then
      WRITE ( 6, '(/,5x,"NLCC is absent")' )
    else
      WRITE ( 6, '(/,5x,"NLCC is present")' )
    endif
  endif
  if (okvan) call errore ( 'pw2bgw', 'BGW cannot use USPP.', 3 )
  if (okpaw) call errore ( 'pw2bgw', 'BGW cannot use PAW.', 4 )
  if (gamma_only) call errore ( 'pw2bgw', 'BGW cannot use gamma-only run.', 5 )
  die_spinors = (nspin == 4)
  if (die_spinors) call errore ( 'pw2bgw', 'BGW cannot use spinors.', 6 )
  if (real_or_complex == 1 .AND. vxc_flag .AND. vxc_offdiag_nmax > 0) &
    call errore ( 'pw2bgw', 'Off-diagonal matrix elements of Vxc ' // &
    'with real wavefunctions are not implemented, compute them in ' // &
    'Sigma using VXC.', 7)

  CALL openfil_pp ( )

  if ( ionode ) WRITE ( 6, '("")' )

  IF ( wfng_flag ) THEN
    output_file_name = TRIM ( outdir ) // '/' // TRIM ( wfng_file )
    IF ( ionode ) WRITE ( 6, '(5x,"call write_wfng")' )
    CALL start_clock ( 'write_wfng' )
    CALL write_wfng ( output_file_name, real_or_complex, symm_type, &
      wfng_kgrid, wfng_nk1, wfng_nk2, wfng_nk3, wfng_dk1, wfng_dk2, &
      wfng_dk3, wfng_occupation, wfng_nvmin, wfng_nvmax )
    CALL stop_clock ( 'write_wfng' )
    IF ( ionode ) WRITE ( 6, '(5x,"done write_wfng",/)' )
  ENDIF

  IF ( vxcg_flag ) THEN
    output_file_name = TRIM ( outdir ) // '/' // TRIM ( vxcg_file )
    IF ( ionode ) WRITE ( 6, '(5x,"call write_vxcg")' )
    CALL start_clock ( 'write_vxcg' )
    CALL write_vxcg ( output_file_name, real_or_complex, symm_type, &
      vxc_zero_rho_core )
    CALL stop_clock ( 'write_vxcg' )
    IF ( ionode ) WRITE ( 6, '(5x,"done write_vxcg",/)' )
  ENDIF

  IF ( vxc0_flag ) THEN
    output_file_name = TRIM ( outdir ) // '/' // TRIM ( vxc0_file )
    IF ( ionode ) WRITE ( 6, '(5x,"call write_vxc0")' )
    CALL start_clock ( 'write_vxc0' )
    CALL write_vxc0 ( output_file_name, vxc_zero_rho_core )
    CALL stop_clock ( 'write_vxc0' )
    IF ( ionode ) WRITE ( 6, '(5x,"done write_vxc0",/)' )
  ENDIF

  IF ( vxc_flag ) THEN
    output_file_name = TRIM ( outdir ) // '/' // TRIM ( vxc_file )
    IF ( vxc_integral .EQ. 'r' ) THEN
      IF ( ionode ) WRITE ( 6, '(5x,"call write_vxc_r")' )
      CALL start_clock ( 'write_vxc_r' )
      CALL write_vxc_r ( output_file_name, &
        vxc_diag_nmin, vxc_diag_nmax, &
        vxc_offdiag_nmin, vxc_offdiag_nmax, &
        vxc_zero_rho_core )
      CALL stop_clock ( 'write_vxc_r' )
      IF ( ionode ) WRITE ( 6, '(5x,"done write_vxc_r",/)' )
    ENDIF
    IF ( vxc_integral .EQ. 'g' ) THEN
      IF ( ionode ) WRITE ( 6, '(5x,"call write_vxc_g")' )
      CALL start_clock ( 'write_vxc_g' )
      CALL write_vxc_g ( output_file_name, &
        vxc_diag_nmin, vxc_diag_nmax, &
        vxc_offdiag_nmin, vxc_offdiag_nmax, &
        vxc_zero_rho_core )
      CALL stop_clock ( 'write_vxc_g' )
      IF ( ionode ) WRITE ( 6, '(5x,"done write_vxc_g",/)' )
    ENDIF
  ENDIF

  IF ( vscg_flag ) THEN
    output_file_name = TRIM ( outdir ) // '/' // TRIM ( vscg_file )
    IF ( ionode ) WRITE ( 6, '(5x,"call write_vscg")' )
    CALL start_clock ( 'write_vscg' )
    CALL write_vscg ( output_file_name, real_or_complex, symm_type )
    CALL stop_clock ( 'write_vscg' )
    IF ( ionode ) WRITE ( 6, '(5x,"done write_vscg",/)' )
  ENDIF

  IF ( vkbg_flag ) THEN
    output_file_name = TRIM ( outdir ) // '/' // TRIM ( vkbg_file )
    IF ( ionode ) WRITE ( 6, '(5x,"call write_vkbg")' )
    CALL start_clock ( 'write_vkbg' )
    CALL write_vkbg ( output_file_name, symm_type, wfng_kgrid, wfng_nk1, &
      wfng_nk2, wfng_nk3, wfng_dk1, wfng_dk2, wfng_dk3 )
    CALL stop_clock ( 'write_vkbg' )
    IF ( ionode ) WRITE ( 6, '(5x,"done write_vkbg",/)' )
  ENDIF

  ! since calc_rhog (called from write_rhog) destroys charge density,
  ! it must be called after v_xc (called from write_vxcg, write_vxc0,
  ! write_vxc_r, write_vxc_g)
  IF ( rhog_flag ) THEN
    output_file_name = TRIM ( outdir ) // '/' // TRIM ( rhog_file )
    IF ( ionode ) WRITE ( 6, '(5x,"call write_rhog")' )
    CALL start_clock ( 'write_rhog' )
    CALL write_rhog ( output_file_name, real_or_complex, symm_type, &
      rhog_nvmin, rhog_nvmax )
    CALL stop_clock ( 'write_rhog' )
    IF ( ionode ) WRITE ( 6, '(5x,"done write_rhog",/)' )
  ENDIF

  IF ( ionode ) WRITE ( 6, * )
  IF ( wfng_flag ) CALL print_clock ( 'write_wfng' )
  IF ( rhog_flag ) CALL print_clock ( 'write_rhog' )
  IF ( vxcg_flag ) CALL print_clock ( 'write_vxcg' )
  IF ( vxc0_flag ) CALL print_clock ( 'write_vxc0' )
  IF ( vxc_flag ) THEN
    IF ( vxc_integral .EQ. 'r' ) CALL print_clock ( 'write_vxc_r' )
    IF ( vxc_integral .EQ. 'g' ) CALL print_clock ( 'write_vxc_g' )
  ENDIF
  IF ( vscg_flag ) CALL print_clock ( 'write_vscg' )
  IF ( vkbg_flag ) CALL print_clock ( 'write_vkbg' )
  IF ( wfng_flag .AND. real_or_complex .EQ. 1 ) THEN
    IF ( ionode ) WRITE ( 6, '(/,5x,"Called by write_wfng:")' )
    CALL print_clock ( 'real_wfng' )
  ENDIF

  CALL environment_end ( codename )
  CALL stop_pp ( )

  STOP

END PROGRAM pw2bgw

!=============================================================
! Utility:
! 
! wfn_dotproduct (flavorless). Originally by DAS.
!
! Form the overlap between the bands in two wavefunction files.
! If they are copies of the same file, you can check orthonormality.
! Only bands at corresponding k-points are considered, since
! the overlap is zero by Bloch`s theorem if the k-points differ.
!
! Warning: a known issue is possible errors from gmap when relating
! k-points by symmetry operations.
!
! 11/06/2014 - FHJ: Added HDF5 support. Note that, while probably faster the
! the native Fortran binary format, the HDF5 support is far from optimal
! because we perform the loops in the same order as the binary WFN files
! (band is the fast index), and not in the native order of the HDF5 files
! (kpt it the fast index).
!
!=============================================================

#include "f_defs.h"

program wfn_dotproduct

  use global_m
  use blas_m
  use find_kpt_match_m
  use gmap_m
  use input_utils_m
  use misc_m
  use sort_m
  use wfn_rho_vxc_io_m
  use wfn_io_hdf5_m
  implicit none

  type(mf_header_t) :: mf1, mf2
  type(gspace) :: gvec_kpt
  character*11 :: inform
  character(len=16) :: sdq
  character*256 :: sformat, file_1, file_2, usage
  character :: sform
  integer :: ik1, ib1, ik2, ik3, ib2, ngkmax, ig, ispin
  integer :: nargs, itqq, kgqq(3)
  real(DP), allocatable :: dwfn1(:,:), dwfn2(:,:,:), dph(:)
  complex(DPC), allocatable :: zwfn1(:,:), zwfn2(:,:,:), zph(:)
  integer, allocatable :: gindex1(:), gindex2(:), ind(:), isrt(:), ginv(:)
  logical :: informat
  real(DP) :: doverlap, q_shift(3)
  complex(DPC) :: zoverlap

  usage = 'Usage: wfn_dotproduct.x A|B WFN_1 WFN_2'

  ! Get file names from command-line arguments

  nargs = iargc()

  if (nargs < 3) then
    call die(usage)
  endif

  ! mpiexec from mpich1 may add 4 extra arguments to the list
  if (nargs > 3) then
    write(0,'(a,i3,a)') 'WARNING: ', nargs, ' arguments found, only first 3 being used.'
  endif

  call getarg(1, sformat)
  call getarg(2, file_1)
  call getarg(3, file_2)

  ! Open units
  if (len(TRUNC(sformat))/=1) then
    call die(usage)
  endif
  sform = sformat(1:1)

  if (sform=='A') then
    informat = .true.
    inform = 'formatted'
  elseif (sform=='B') then
    informat = .false.
    inform = 'unformatted'
  else  
    call die(usage)
  endif

  ! Read headers

  write(6,'(3x,a)') 'Reading ' // TRUNC(inform) // ' file ' // TRUNC(file_1)
  if (sform=='H') then
  else
    call open_file(unit=7, file=TRUNC(file_1), form=inform, status='old')
    call read_mf_header(7, mf1, sheader='WFN', warn=.false., dont_warn_kgrid=.true.)
  endif

  ! must have same flavor as first one
  write(6,'(3x,a)') 'Reading ' // TRUNC(inform) // ' file ' // TRUNC(file_2)
  if (sform=='H') then
  else
    call open_file(unit=8, file=TRUNC(file_2), form=inform, status='old')
    call read_mf_header(8, mf2, iflavor=mf1%iflavor, sheader=mf1%sheader, warn=.false., dont_warn_kgrid=.true.)
  endif

  call check_header(TRUNC(file_1), mf1%kp, mf1%gvec, mf1%syms, mf1%crys, &
    TRUNC(file_2), mf2%kp, mf2%gvec, mf2%syms, mf2%crys, is_wfn = .true., tolerant = .true.)

  write(6,'(2(a,a,i8,a))') TRUNC(file_1), ' has ', mf1%kp%nrk, ' k-points; ', &
    TRUNC(file_2), ' has ', mf2%kp%nrk, ' k-points'
  if(mf2%kp%nrk > mf1%kp%nrk) then
    write(6,'(a)') "Note: only the second file's k-points will have symmetries applied. Switch the order on the command-line"
    write(6,'(a)') "if you want matches where a symmetry is applied to the first file's k-points."
  endif

  if(all(mf1%kp%kgrid(:) > 0 .and. mf2%kp%kgrid(:) > 0)) then
    q_shift(1:3) = dble(mf2%kp%shift(1:3))/mf2%kp%kgrid(1:3) - dble(mf1%kp%shift(1:3))/mf1%kp%kgrid(1:3)
  else
    q_shift(1:3) = 0d0
  endif
  write(6,'(a,3f12.6)') 'Using q-shift = ', q_shift(1:3)

  ! Read charge density gvectors
  SAFE_ALLOCATE(mf1%gvec%components, (3, mf1%gvec%ng))
  SAFE_ALLOCATE(mf2%gvec%components, (3, mf2%gvec%ng))

  ! use mf1%gvec as the master list of G-vectors
  if (sform=='H') then
  else
    call read_gvectors(7, informat, mf1%gvec%ng, mf1%gvec%ng, mf1%gvec%components)
  endif
  ! needed to be able to use findvector
  call gvec_index(mf1%gvec)

  ngkmax = max(mf1%kp%ngkmax, mf2%kp%ngkmax)
  if (mf1%iflavor .eq. 1) then
    SAFE_ALLOCATE(dwfn1, (mf1%gvec%ng, mf1%kp%nspin))
    SAFE_ALLOCATE(dwfn2, (mf1%gvec%ng, mf2%kp%nspin, mf2%kp%mnband))
    SAFE_ALLOCATE(dph, (mf1%gvec%ng))
  else
    SAFE_ALLOCATE(zwfn1, (mf2%gvec%ng, mf1%kp%nspin))
    SAFE_ALLOCATE(zwfn2, (mf2%gvec%ng, mf2%kp%nspin, mf2%kp%mnband))
    SAFE_ALLOCATE(zph, (mf1%gvec%ng))
  end if
  SAFE_ALLOCATE(gindex1, (ngkmax))
  SAFE_ALLOCATE(gindex2, (ngkmax))
  SAFE_ALLOCATE(ind, (ngkmax))
  SAFE_ALLOCATE(gvec_kpt%components, (3, ngkmax))
  SAFE_ALLOCATE(ginv, (mf1%gvec%ng))
  SAFE_ALLOCATE(mf1%gvec%ekin, (mf1%gvec%ng))
  SAFE_ALLOCATE(isrt, (mf1%gvec%ng))

  if(mf1%kp%nspinor > 1) then
    call die("nspinor > 1 not implemented")
  endif

  if (sform=='H') then
  endif

  do ik1 = 1, mf1%kp%nrk
    write(6,'(/,a,i6,a,3f12.6)') 'k-point ', ik1, ': ', mf1%kp%rk(1:3, ik1)
    call find_kpt_match(mf2%kp, mf2%syms, mf1%kp%rk(1:3, ik1) + q_shift(1:3), ik2, itqq, kgqq)
    if(ik2 == 0) then
      write(6,'(a)') 'No match in ' // TRUNC(file_2)
      if (sform/='H') then
        call read_gvectors(7, informat, mf1%kp%ngk(ik1), ngkmax, gvec_kpt%components, dont_read=.not.informat)
      endif
    else
      write(6,'(a,i6,3a,3f12.6)') 'Matches k-point ', ik2, ' in ', TRUNC(file_2), ':', mf2%kp%rk(1:3, ik2)
      write(6,'(a,i3,a,3i3)') 'with symmetry operation ', itqq, ' and Umklapp ', kgqq
      if (sform=='H') then
      else
        call read_gvectors(7, informat, mf1%kp%ngk(ik1), ngkmax, gvec_kpt%components)
      endif
      write(6,'(2(a10,a16,4x),a10,6x,a20)',advance='no') 'band 1', 'energy 1 ', 'band 2', 'energy 2 ', 'spin ', 'Re overlap '
      if(mf1%iflavor == 2) write(6,'(a20)',advance='no') 'Im overlap '
      write(6,'(a20)') '|overlap|^2 '

      do ig = 1, mf1%kp%ngk(ik1)
        call findvector(gindex1(ig), gvec_kpt%components(:, ig), mf1%gvec)
        if (gindex1(ig) ==  0)  call die('could not match G-vector')
      enddo
    endif

    if(ik2 > 0) then
      if(mf1%kp%ngk(ik1) /= mf2%kp%ngk(ik2)) then
        call die("Internal error: ngk mismatch")
      endif

      if (sform=='H') then
      else
        rewind(8)
        call dealloc_header_type(mf2%sheader, mf2%crys, mf2%kp)
        call read_header_type(8, informat, mf2%sheader, mf1%iflavor, mf2%kp, mf2%gvec, mf2%syms, mf2%crys, &
          warn=.false., dont_warn_kgrid=.true.)
        call check_header(TRUNC(file_1), mf1%kp, mf1%gvec, mf1%syms, mf1%crys, &
          TRUNC(file_2), mf2%kp, mf2%gvec, mf2%syms, mf2%crys, is_wfn = .true., tolerant = .true.)
        call read_gvectors(8, informat, mf2%gvec%ng, mf2%gvec%ng, mf2%gvec%components, dont_read = .not. informat)

        do ik3 = 1, ik2 - 1
          call read_gvectors(8, informat, mf2%kp%ngk(ik3), ngkmax, gvec_kpt%components, dont_read = .not. informat)
          do ib2 = 1, mf2%kp%mnband
            if(mf1%iflavor == 1) then
              call read_real_data(8, informat, mf2%kp%ngk(ik3), mf2%gvec%ng, mf2%kp%nspin, &
                dwfn2(:,:,ib2), dont_read =.not.informat)
            else
              call read_complex_data(8, informat, mf2%kp%ngk(ik3), mf2%gvec%ng, mf2%kp%nspin*mf2%kp%nspinor, &
                zwfn2(:,:,ib2), dont_read =.not.informat)
            endif
          enddo
        enddo
        call read_gvectors(8, informat, mf2%kp%ngk(ik2), ngkmax, gvec_kpt%components)
        ! now we are at the right point in the file
      endif

      ginv = 0
      do ig = 1, mf2%kp%ngk(ik2)
        call findvector(gindex2(ig), gvec_kpt%components(:, ig), mf1%gvec)
        if (gindex2(ig) ==  0)  call die('could not match G-vector')
        ginv(gindex2(ig)) = ig
      enddo

      call kinetic_energies(mf1%gvec, mf1%crys%bdot, mf1%gvec%ekin, qvec=mf2%kp%rk(:, ik2))
      call sortrx(mf1%gvec%ng, mf1%gvec%ekin, isrt, gvec=mf1%gvec%components)

      ! FHJ: Keep the following line. It prevents a compiler bug with sunf90
      ! which changes the value of mf1%iflavor.
      mf1%iflavor = mf1%iflavor
      if(mf1%iflavor == 1) then
        call gmap(mf1%gvec, mf1%syms, mf2%kp%ngk(ik2), itqq, kgqq, isrt, ginv, ind, dph, .true.)
      else
        call gmap(mf1%gvec, mf1%syms, mf2%kp%ngk(ik2), itqq, kgqq, isrt, ginv, ind, zph, .true.)
      endif

      if(any(ind(1:mf2%kp%ngk(ik2)) == 0)) call die("ind array from gmap has a zero")

      ! Read "second" WFN
      if (sform=='H') then
      else
        do ib2 = 1, mf2%kp%mnband
          if(mf1%iflavor == 1) then
            call read_real_data(8, informat, mf2%kp%ngk(ik2), mf2%gvec%ng, mf2%kp%nspin, &
              dwfn2(:,:,ib2), gindex=gindex2)
          else
            call read_complex_data(8, informat, mf2%kp%ngk(ik2), mf2%gvec%ng, mf2%kp%nspin*mf2%kp%nspinor, &
              zwfn2(:,:,ib2), gindex=gindex2)
          endif
        enddo
      endif

      if(mf1%iflavor == 1) then
        do ig = 1, mf2%kp%ngk(ik2)
          dwfn2(ind(ig), :, :) = dwfn2(ind(ig), :, :) * dph(ig)
        enddo
      else
        do ig = 1, mf2%kp%ngk(ik2)
          zwfn2(ind(ig), :, :) = zwfn2(ind(ig), :, :) * zph(ig)
        enddo
      endif
    endif !ik2/=0

    ! Read "first" WFN
    do ib1 = 1, mf1%kp%mnband
      if (sform=='H') then
      else
        if(mf1%iflavor == 1) then
          call read_real_data(7, informat, mf1%kp%ngk(ik1), mf1%gvec%ng, mf1%kp%nspin, dwfn1, &
            dont_read = (ik2 == 0) .and. .not. informat, gindex = gindex1)
        else
          call read_complex_data(7, informat, mf1%kp%ngk(ik1), mf1%gvec%ng, mf1%kp%nspin*mf1%kp%nspinor, zwfn1, &
            dont_read = (ik2 == 0) .and. .not. informat, gindex = gindex1)
        endif
        if(ik2 == 0) cycle
      endif

      do ib2 = 1, mf2%kp%mnband
        if(mf1%iflavor == 1) then
          do ispin = 1, mf1%kp%nspin
            doverlap = ddot(mf1%gvec%ng, dwfn1(:, ispin), 1, dwfn2(:, ispin, ib2), 1)
            write(6,'(2(i8,2x,g20.8),i8,8x,2g20.10)') ib1, mf1%kp%el(ib1, ik1, ispin), ib2, mf2%kp%el(ib2, ik2, ispin), &
              ispin, doverlap, dble(doverlap)**2
          enddo
        else
          do ispin = 1, mf1%kp%nspin
            zoverlap = zdotc(mf1%gvec%ng, zwfn1(:, ispin), 1, zwfn2(:, ispin, ib2), 1)
            write(6,'(2(i8,2x,g20.8),i8,8x,3g20.10)') ib1, mf1%kp%el(ib1, ik1, ispin), ib2, mf2%kp%el(ib2, ik2, ispin), &
              ispin, zoverlap, dble(zoverlap)**2 + aimag(zoverlap)**2
          enddo
        endif
      enddo
    enddo
  enddo

  ! Close files

  if (sform=='H') then
  else
    call close_file(7)
    call close_file(8)
  endif

  ! Deallocate arrays

  if (mf1%iflavor .eq. 1) then
    SAFE_DEALLOCATE(dwfn1)
    SAFE_DEALLOCATE(dwfn2)
    SAFE_DEALLOCATE(dph)
  else
    SAFE_DEALLOCATE(zwfn1)
    SAFE_DEALLOCATE(zwfn2)
    SAFE_DEALLOCATE(zph)
  endif

  SAFE_DEALLOCATE_P(mf1%gvec%components)
  SAFE_DEALLOCATE_P(mf2%gvec%components)
  SAFE_DEALLOCATE_P(mf1%gvec%index_vec)
  SAFE_DEALLOCATE_P(gvec_kpt%components)
  SAFE_DEALLOCATE_P(mf1%gvec%ekin)
  SAFE_DEALLOCATE(isrt)
  SAFE_DEALLOCATE(ind)
  SAFE_DEALLOCATE(ginv)
  SAFE_DEALLOCATE(gindex1)
  SAFE_DEALLOCATE(gindex2)
  call dealloc_header_type(mf1%sheader, mf1%crys, mf1%kp)
  call dealloc_header_type(mf2%sheader, mf2%crys, mf2%kp)

end program wfn_dotproduct

!=================================================================================
!
! Routines:
!
! (1) epsinv()          Originally By (?)                Last Modified 5/1/2008 (JRD)
!
!     This routine:
!
!     1. Calculates epsilon based on chi.
!     2. Inverts epsilon.
!     3. Writes the result to unit=12 if q0="zero" and unit 13 otherwise.
!
!=================================================================================

#include "f_defs.h"

subroutine epsinv(gvec,pol,ekin,q0,is_q0,crys,scal,kp,omega_plasma,iq)
  
  use global_m
  use inversion_m
  use misc_m
  use scalapack_m
  use vcoul_generator_m
  use write_matrix_m
  implicit none

  type (gspace), intent(in) :: gvec
  type (polarizability), intent(in) :: pol
  real(DP), intent(in) :: ekin(gvec%ng)
  real(DP), intent(in) :: q0(3)
  logical, intent(in) :: is_q0
  type (crystal), intent(in) :: crys
  type (scalapack), intent(in) :: scal
  type (kpoints), intent(in) :: kp
  real(DP), intent(in) :: omega_plasma
  integer, intent(in) :: iq

  integer :: qgrid(3)
  real(DP) :: q0vec(3)
  type (twork_scell) :: work_scell
  integer :: i,j,jj,ii,is,js,iunit,my_iq,ifreq
  integer :: irow, icol, icurr, irowm, icolm
  integer, allocatable :: isorti(:)
  integer :: iscreen, nfk, iparallel, isize,ifreq_para,freq_grp_ind
  real(DP) :: vc, oneoverq, avgcut
  real(DP) :: epssum1R, epssum2R, epssum1R_rel,epssum2R_rel
#ifdef CPLX
  real(DP) :: epssum1A, epssum2A, epssum1A_rel,epssum2A_rel
#endif
  SCALAR :: chitmp
  SCALAR, allocatable :: eps(:,:),ewng(:)
  real(DP), allocatable :: epsdiag(:,:,:),epsdiagt(:,:,:)
  real(DP), allocatable :: vcoul(:)
  complex(DPC), allocatable :: chiRDyntmp(:), chiADyntmp(:)
  complex(DPC), allocatable :: epsRDyn(:,:,:), epsADyn(:,:,:)
  complex(DPC), allocatable :: epsRDyn_head(:),epsADyn_head(:),epsRDyn_head_temp(:),epsADyn_head_temp(:)
  ! Auxiliary matrix for inversion
  complex(DPC), allocatable :: eps1Aux(:,:)
  SCALAR :: epsheaddummy, wcoul0
  character*80 :: filename

  PUSH_SUB(epsinv)

  SAFE_ALLOCATE(vcoul, (pol%nmtx))
  
  if(pol%freq_dep .eq. 0) then
    SAFE_ALLOCATE(eps, (scal%npr,scal%npc))
    SAFE_ALLOCATE(ewng, (pol%nmtx))
  endif

  if(pol%freq_dep .eq. 2) then
    SAFE_ALLOCATE(chiRDyntmp, (pol%os_nfreq_para))
    SAFE_ALLOCATE(epsRDyn, (pol%os_nfreq_para,scal%npr,scal%npc))
#ifdef CPLX
    SAFE_ALLOCATE(chiADyntmp, (pol%os_nfreq_para))
    SAFE_ALLOCATE(epsADyn, (pol%os_nfreq_para,scal%npr,scal%npc))
#endif
    SAFE_ALLOCATE(eps1Aux, (scal%npr,scal%npc))
  endif

  if(pol%freq_dep .eq. 3) then
    SAFE_ALLOCATE(chiRDyntmp, (pol%os_nfreq_para))
    SAFE_ALLOCATE(epsRDyn, (pol%os_nfreq_para,scal%npr,scal%npc))
    SAFE_ALLOCATE(eps1Aux, (scal%npr,scal%npc))
  endif

  
  SAFE_ALLOCATE(isorti, (gvec%ng))
      
!------------------------------
! Invert isrtx

!
! SIB: isorti is the inverse sort order for pol%isrtx.
! pol%isrtx has the sort indices for |q0+gvec%components|^2
!

  if(pol%freq_dep .eq. 0) then
    eps(:,:)=ZERO
  endif
  
  if(pol%freq_dep .eq. 2) then
    epsRDyn(:,:,:)=(0.d0,0.d0)
#ifdef CPLX
    epsADyn(:,:,:)=(0.d0,0.d0)
#endif
  endif

  if(pol%freq_dep .eq. 3) then
    epsRDyn(:,:,:)=(0.d0,0.d0)
  endif
  
  
  vcoul(:)=0.0d0
  do i=1,gvec%ng
    isorti(pol%isrtx(i)) = i
  end do


!-------------- Construct Dielectric Matrix ---------------------------

!
! e(q+g,q+g`) = del(g,g`) - (8pi/(q+g)**2) chi(q+g,q+g`).  For spin-polarized
! calc., e(G+q,G`+q)=del(G,G`)- (8PI/(G+q)^2) SUM_spin chi(G+q,G`+q,ispin)
! Which is pol%chi(j,1) as compiled in epsilon_main.f90.  If q--> 0 , we have to treat
! the wings separately
!
! SIB:  using the Rydberg as our unit of energy
! if pol%icutv is on (coulomb cutoff) then we multiply the coulomb
! interaction by the appropriate factor (1-cos(vcut*|q0+g|))
!

!      if (peinf%inode .eq. 0) then
!        write(6,*) ' '
!        write(6,*) 'Calculating Coulomb Potential'
!      endif

  icurr=0

! Generator Coulomb Interaction Array Vcoul

! For Epsilon, We want to treat all types of screening the same for vcoul.  Because
! we calculate it exactly

  avgcut=TOL_ZERO
  iscreen=0
  nfk=product(kp%kgrid(1:3))
  q0vec=0d0
  iparallel=1

  if(peinf%inode.eq.0) call timacc(18,1)
  
  qgrid(:)=1

  epsheaddummy=0.0d0
  wcoul0=0.0d0

  call vcoul_generator(pol%icutv,pol%truncval,gvec,crys%bdot, &
    nfk,pol%nmtx,pol%isrtx,iscreen,q0,q0vec,vcoul, &
    pol%iwritecoul,iparallel,avgcut,oneoverq,qgrid,epsheaddummy, &
    work_scell,.false.,wcoul0)

  if(peinf%inode.eq.0) call timacc(18,2)

!      write(6,*) 'Done VCoul'

  if(pol%freq_dep .eq. 0) then
    do i=1,pol%nmtx
      
      irow=MOD(INT(((i-1)/scal%nbl)+TOL_SMALL),scal%nprow)
      if(irow.ne.scal%myprow) cycle
      
      vc = vcoul(i)

!-------------------------
! Actually Construct eps

      do j=1,pol%nmtx
        icol=MOD(INT(((j-1)/scal%nbl)+TOL_SMALL),scal%npcol)
        if(icol .eq. scal%mypcol) then
          icurr=icurr+1
          irowm=INT((icurr-1)/scal%npc+TOL_SMALL)+1
          icolm=MOD((icurr-1),scal%npc)+1

          eps(irowm,icolm) = ZERO
          if (i.eq.j) eps(irowm,icolm) = ONE
          chitmp = pol%chi(irowm,icolm,1)
          eps(irowm,icolm) = eps(irowm,icolm) - vc*chitmp
        endif
      end do
    end do
  endif
  
  if(pol%freq_dep .eq. 2 .or. pol%freq_dep .eq. 3) then
    do i=1,pol%nmtx

!          if (peinf%inode .eq. 0) then
!            write(6,*) 'Starting loop', i
!          endif

      irow=MOD(INT(((i-1)/scal%nbl)+TOL_SMALL),scal%nprow)
      if(irow.ne.scal%myprow) cycle
      
      vc = vcoul(i)

!-------------------------
! Actually Construct eps

      do j=1,pol%nmtx

!            if (peinf%inode .eq. 0) then
!              write(6,*) 'Starting loop', i, j, pol%nmtx
!            endif

        icol=MOD(INT(((j-1)/scal%nbl)+TOL_SMALL),scal%npcol)
        if(icol .eq. scal%mypcol) then
          icurr=icurr+1
          irowm=INT((icurr-1)/scal%npc+TOL_SMALL)+1
          icolm=MOD((icurr-1),scal%npc)+1
          
          epsRDyn(:,irowm,icolm) = (0.0,0.0)
#ifdef CPLX
          if(pol%freq_dep.ne.3) then
            epsADyn(:,irowm,icolm) = (0.0,0.0)
          endif
#endif
          
          if (i.eq.j) then
            epsRDyn(:,irowm,icolm) = (1.0,0.0)
#ifdef CPLX
            if(pol%freq_dep.ne.3) then
              epsADyn(:,irowm,icolm) = (1.0,0.0)
            endif
#endif
          endif
          
          chiRDyntmp(:) = pol%chiRDyn(:,irowm,icolm,1)
#ifdef CPLX
          if(pol%freq_dep.ne.3) then
            chiADyntmp(:) = pol%chiADyn(:,irowm,icolm,1)
          endif
#endif

!              if (.not.is_q0 .or. pol%icutv .ne. 0) then
          epsRDyn(:,irowm,icolm) = epsRDyn(:,irowm,icolm)- &
            vc*chiRDyntmp(:)
#ifdef CPLX
          if(pol%freq_dep.ne.3) then
            epsADyn(:,irowm,icolm) = epsADyn(:,irowm,icolm)- &
              vc*chiADyntmp(:)
          endif
#endif
!              else
!                if (i .eq. 1 .and. j .eq. 1) then
!                  epsRDyn(:,irowm,icolm) = epsRDyn(:,irowm,icolm)- &
!                   vc*chiRDyntmp(:)*q0norm*q0norm
!#ifdef CPLX
!                  epsADyn(:,irowm,icolm) = epsADyn(:,irowm,icolm)- &
!                   vc*chiADyntmp(:)*q0norm*q0norm
!#endif
!                else if (i .eq. 1 .or. j .eq. 1) then
!                  epsRDyn(:,irowm,icolm) = epsRDyn(:,irowm,icolm)- &
!                   vc*chiRDyntmp(:)*q0norm
!#ifdef CPLX
!                  epsADyn(:,irowm,icolm) = epsADyn(:,irowm,icolm)- &
!                   vc*chiADyntmp(:)*q0norm
!#endif
!                else
!                  epsRDyn(:,irowm,icolm) = epsRDyn(:,irowm,icolm)- &
!                   vc*chiRDyntmp(:)
!#ifdef CPLX
!                  epsADyn(:,irowm,icolm) = epsADyn(:,irowm,icolm)- &
!                   vc*chiADyntmp(:)
!#endif
!                end if
!              endif
        endif
      end do
    end do
  endif

!      write(6,*) 'Created Eps'


!------------- Take Care of the Wings for q--> 0 -------------------------
!
! JRD: This section was removed and deleted (rev 184)
! because we now invert the matrix completely (i.e. wings included)
!
! End treatment of wings for q--> 0
!----------------------------------------------------------------------------


3999 format(a,i6,a,2es25.15e3)
  if (peinf%inode .eq. 0 .and. pol%freq_dep .eq. 0) then
    write(6,3999) 'q-pt ', iq, ': Head of Epsilon         = ', eps(1,1)
  end if
  if (peinf%inode .eq. 0 .and. pol%freq_dep .eq. 2) then
    write(6,3999) 'q-pt ', iq, ': Retarded Head of Epsilon         = ', epsRDyn(1,1,1)
    write(6,3999) 'q-pt ', iq, ': Retarded Epsilon(2,2)            = ', epsRDyn(1,2,2)
#ifdef CPLX
    write(6,3999) 'q-pt ', iq, ': Advanced Head of Epsilon         = ', epsADyn(1,1,1)
    write(6,3999) 'q-pt ', iq, ': Advanced Epsilon(2,2)            = ', epsADyn(1,2,2)
#endif
  if (peinf%inode .eq. 0 .and. pol%freq_dep .eq. 3) then
    write(6,3999) 'q-pt ', iq, ': Head of Epsilon         = ', epsRDyn(1,1,1)
    write(6,3999) 'q-pt ', iq, ': Epsilon(2,2)            = ', epsRDyn(1,2,2)
  endif

  end if

!-------------------------------------------------------------
! Print head versus frequency 


  if(pol%os_para_freqs .eq. 1 .and. peinf%rank_f .eq. 0 .and. pol%freq_dep .eq. 2) then

    SAFE_ALLOCATE(epsRDyn_head, (pol%nfreq))
    epsRDyn_head=CMPLX(0d0,0d0)
#ifdef CPLX
    SAFE_ALLOCATE(epsADyn_head, (pol%nfreq))
    epsADyn_head=CMPLX(0d0,0d0)
#endif

    epsRDyn_head(:)=epsRDyn(:,1,1)
#ifdef CPLX
    epsADyn_head(:)=epsADyn(:,1,1)
#endif

  elseif(pol%os_para_freqs > 1 .and. peinf%rank_f .eq. 0 .and. pol%freq_dep .eq. 2) then
    SAFE_ALLOCATE(epsRDyn_head, (pol%nfreq))
    SAFE_ALLOCATE(epsRDyn_head_temp, (pol%nfreq))
    epsRDyn_head=CMPLX(0d0,0d0)
    epsRDyn_head_temp=CMPLX(0d0,0d0)
#ifdef CPLX
    SAFE_ALLOCATE(epsADyn_head, (pol%nfreq))
    SAFE_ALLOCATE(epsADyn_head_temp, (pol%nfreq))
    epsADyn_head=CMPLX(0d0,0d0)
    epsADyn_head_temp=CMPLX(0d0,0d0)
#endif
    do ifreq=1,pol%nfreq
      freq_grp_ind=mod(ifreq-1,pol%os_para_freqs)
      ifreq_para=(ifreq+pol%os_para_freqs-1)/pol%os_para_freqs
      if(freq_grp_ind .eq. peinf%rank_mtxel) then
        epsRDyn_head_temp(ifreq)=epsRDyn(ifreq_para,1,1)
#ifdef CPLX
        epsADyn_head_temp(ifreq)=epsADyn(ifreq_para,1,1)
#endif
      endif
    enddo
#ifdef MPI
    call MPI_REDUCE(epsRDyn_head_temp(1),epsRDyn_head(1),pol%nfreq,MPI_COMPLEX_DPC,MPI_SUM, 0, &
     peinf%mtxel_comm,mpierr)
#ifdef CPLX
    call MPI_REDUCE(epsADyn_head_temp(1),epsADyn_head(1),pol%nfreq,MPI_COMPLEX_DPC,MPI_SUM, 0, &
     peinf%mtxel_comm,mpierr)
#endif
#endif
  endif

  if (peinf%rank_mtxel .eq. 0 .and. peinf%rank_f .eq. 0 .and. pol%freq_dep .eq. 2) then
    write(52,'("# q= ",3f12.5," nmtx=",i6)') q0(:),pol%nmtx
    write(52,*)
    do jj=1,pol%nfreq
      write(52,'(5f12.6)') pol%dFreqGrid(jj), &
        dble(epsRDyn_head(jj)),aimag(epsRDyn_head(jj) &
#ifdef CPLX
        ), dble(epsADyn_head(jj)),aimag(epsADyn_head(jj) &
#endif
        )
    enddo
  endif

!------------ Here we invert the epsilon matrix -----------------------------
!
! JRD: May 2008.  Now we actually invert the whole matrix with wings included.

  if(peinf%inode.eq.0) call timacc(46,1)

#if defined USESCALAPACK

  if(pol%freq_dep .eq. 0) then
    call X(invert_with_scalapack)(pol%nmtx, scal, eps)
  endif
  
  if(pol%freq_dep .eq. 2 .or. pol%freq_dep .eq. 3) then
    do jj=1,pol%os_nfreq_para
      eps1Aux(:,:) = epsRDyn(jj,:,:)
      call zinvert_with_scalapack(pol%nmtx, scal, eps1Aux)
      epsRDyn(jj,:,:) = eps1Aux(:,:)
#ifdef CPLX
      if(pol%freq_dep .ne. 3) then
        eps1Aux(:,:) = epsADyn(jj,:,:)
        call zinvert_with_scalapack(pol%nmtx, scal, eps1Aux)
        epsADyn(jj,:,:) = eps1Aux(:,:)
      endif
#endif
    enddo
  endif

#else

! Serial Version

  if(pol%freq_dep .eq. 0) then
    call X(invert_serial)(pol%nmtx,eps)
  endif
  
  if(pol%freq_dep .eq. 2 .or. pol%freq_dep .eq. 3) then
    do jj=1,pol%os_nfreq_para
      eps1Aux(:,:) = epsRDyn(jj,:,:)
      call zinvert_serial(pol%nmtx,eps1Aux)
      epsRDyn(jj,:,:) = eps1Aux(:,:)
#ifdef CPLX
      if( pol%freq_dep .ne. 3) then
        eps1Aux(:,:) = epsADyn(jj,:,:)
        call zinvert_serial(pol%nmtx,eps1Aux)
        epsADyn(jj,:,:) = eps1Aux(:,:)
      endif
#endif
    enddo
  endif

#endif

  if(peinf%inode.eq.0) call timacc(46,2)

! Done inverting
!-----------------------------------------------------------------------------


  if (peinf%inode .eq. 0 .and. pol%freq_dep .eq. 0) then
    write(6,3999) 'q-pt ', iq, ': Head of Epsilon Inverse = ', eps(1,1)
  end if
  if (peinf%inode .eq. 0 .and. pol%freq_dep .eq. 2) then
    write(6,3999) 'q-pt ', iq, ': Retarded Head of Epsilon Inverse = ', epsRDyn(1,1,1)
#ifdef CPLX
    write(6,3999) 'q-pt ', iq, ': Advanced Head of Epsilon Inverse = ', epsADyn(1,1,1)
#endif
    write(6,3999) 'q-pt ', iq, ': Retarded Epsilon Inverse(2,2)    = ', epsRDyn(1,2,2)
#ifdef CPLX
    write(6,3999) 'q-pt ', iq, ': Advanced Epsilon Inverse(2,2)    = ', epsADyn(1,2,2)
#endif
  end if
  if (peinf%inode .eq. 0 .and. pol%freq_dep .eq. 3) then
    write(6,3999) 'q-pt ', iq, ': Head of Epsilon Inverse = ', epsRDyn(1,1,1)
    write(6,3999) 'q-pt ', iq, ': Epsilon Inverse(2,2)    = ', epsRDyn(1,2,2)
  endif

!--------  put in the effects of the wings  for  q--> 0 ----------------------
!
! JRD: We don`t do this anymore because we now invert entire matrix (wings included)
!
!--------end treatment of the wings  for  q--> 0 -----------------------------


!----------- Print out independent matrix elements ---------------------------

  if(pol%os_para_freqs .eq. 1 .and. peinf%rank_f .eq. 0 .and. pol%freq_dep .eq. 2) then

    epsRDyn_head(:)=epsRDyn(:,1,1)
#ifdef CPLX
    epsADyn_head(:)=epsADyn(:,1,1)
#endif

  elseif(pol%os_para_freqs > 1 .and. peinf%rank_f .eq. 0 .and. pol%freq_dep .eq. 2) then
    epsRDyn_head=CMPLX(0d0,0d0)
    epsRDyn_head_temp=CMPLX(0d0,0d0)
#ifdef CPLX
    epsADyn_head=CMPLX(0d0,0d0)
    epsADyn_head_temp=CMPLX(0d0,0d0)
#endif
    do ifreq=1,pol%nfreq
      freq_grp_ind=mod(ifreq-1,pol%os_para_freqs)
      ifreq_para=(ifreq+pol%os_para_freqs-1)/pol%os_para_freqs
      if(freq_grp_ind .eq. peinf%rank_mtxel) then
        epsRDyn_head_temp(ifreq)=epsRDyn(ifreq_para,1,1)
#ifdef CPLX
        epsADyn_head_temp(ifreq)=epsADyn(ifreq_para,1,1)
#endif
      endif
    enddo
#ifdef MPI
    call MPI_REDUCE(epsRDyn_head_temp(1),epsRDyn_head(1),pol%nfreq,MPI_COMPLEX_DPC,MPI_SUM, 0, &
     peinf%mtxel_comm,mpierr)
#ifdef CPLX
    call MPI_REDUCE(epsADyn_head_temp(1),epsADyn_head(1),pol%nfreq,MPI_COMPLEX_DPC,MPI_SUM, 0, &
     peinf%mtxel_comm,mpierr)
#endif
#endif
  endif

  if (peinf%inode.eq.0.and.pol%freq_dep .eq. 2) then
    write(51,'("# q= ",3f12.5," nmtx=",i6)') q0(:),pol%nmtx
    write(51,*)
    do jj=1,pol%nfreq
      write(51,'(5f12.6)') pol%dFreqGrid(jj), &
        dble(epsRDyn_head(jj)),aimag(epsRDyn_head(jj) &
#ifdef CPLX
        ), dble(epsADyn_head(jj)),aimag(epsADyn_head(jj) &
#endif
        )
    enddo
  endif

!      if (pol%freq_dep .eq. 0) then
  if (peinf%inode.eq.0 .and. pol%freq_dep .eq. 0) then
  
    ! JRD Warn User about possible lack of symmetry
    if (is_q0) then
      write(7,*)
      write(7,*) 'For q0 points, you should check the symmetry (eps(G,G'') = eps*(-G,-G'')) by'
      write(7,*) 'using the eps0sym code. Wavefunction convergence, as well as a finite q-shift'
      write(7,*) 'may cause this property of eps(G,G'') to be broken.'
      write(6,*)
      write(6,*) 'For q0 points, you should check the symmetry (eps(G,G'') = eps*(-G,-G'')) by'
      write(6,*) 'using the eps0sym code. Wavefunction convergence, as well as a finite q-shift'
      write(6,*) 'may cause this property of eps(G,G'') to be broken.'
    endif
    
    write(7,4000) kp%nspin
    do i=1,scal%npr
      is=scal%isrtxrow(i)
      do j=1,scal%npc
        js=scal%isrtxcol(j)
        if (i .eq. j .or. i .eq. j+1) then
          write(7,4200) gvec%components(1:3,is), gvec%components(1:3,js), eps(i,j)
        endif
      end do
    end do
  end if

  if (peinf%inode.eq.0 .and. pol%freq_dep .eq. 2) then
    write(7,4001) kp%nspin
    do jj=1,pol%os_nfreq_para
      do i=1,scal%npr
        is=scal%isrtxrow(i)
        do j=1,scal%npc
          js=scal%isrtxcol(j)
          if (i .eq. j .or. i .eq. j+1) then
            write(7,4300) gvec%components(1:3,is), gvec%components(1:3,js), epsRDyn(jj,i,j &
#ifdef CPLX
              ),epsADyn(jj,i,j)
#else
            )
#endif
          endif
        end do
      end do
    end do
  end if

  if (peinf%inode.eq.0 .and. pol%freq_dep .eq. 3) then
    write(7,4000) kp%nspin
    do jj=1,pol%os_nfreq_para
      do i=1,scal%npr
        is=scal%isrtxrow(i)
        do j=1,scal%npc
          js=scal%isrtxcol(j)
          if (i .eq. j .or. i .eq. j+1) then
            write(7,4200) gvec%components(1:3,is), gvec%components(1:3,js), epsRDyn(jj,i,j)
          endif
        end do
      end do
    end do
  end if


4000 format(/ /,13x,'g',19x,'gp',9x, &
       'inverse epsilon           nspin= ',1i1)
4001 format(/ /,13x,'g',19x,'gp',9x, &
#ifdef CPLX
       'inverse epsilon RDyn/ADyn nspin= ',1i1)
#else
  'inverse epsilon RDyn      nspin= ',1i1)
#endif

4200 format(5x,3i5,5x,3i5,5x,2f13.8)
4300 format(5x,3i5,5x,3i5,5x,4f13.8)

!---------- Full-Frequency Sum-Rule -----------------------------------------

  epssum1R=0D0
  epssum2R=0D0

#ifdef CPLX
  epssum1A=0D0
  epssum2A=0D0
#endif
  
  if (peinf%inode.eq.0 .and. pol%freq_dep .eq. 2) then
    do jj=2,pol%nFreq
      
      epssum1R=epssum1R+(1D0*Ryd/pol%dFreqGrid(jj))* &
        IMAG(epsRDyn_head(jj))*(pol%dFreqGrid(jj)-pol%dFreqGrid(jj-1))/Ryd
#ifdef CPLX
      epssum1A=epssum1A+(1D0*Ryd/pol%dFreqGrid(jj))* &
        IMAG(epsADyn_head(jj))*(pol%dFreqGrid(jj)-pol%dFreqGrid(jj-1))/Ryd
#endif
      
      epssum2R=epssum2R+(pol%dFreqGrid(jj)/Ryd)* &
        IMAG(epsRDyn_head(jj))*(pol%dFreqGrid(jj)-pol%dFreqGrid(jj-1))/Ryd
#ifdef CPLX
      epssum2A=epssum2A+(pol%dFreqGrid(jj)/Ryd)* &
        IMAG(epsADyn_head(jj))*(pol%dFreqGrid(jj)-pol%dFreqGrid(jj-1))/Ryd
#endif
    enddo
    
    epssum1R=(2D0*epssum1R/Pi_D)+1D0
    epssum1R_rel=(epssum1R)/dble(epsRDyn(1,1,1))
    
#ifdef CPLX
    epssum1A=(-2D0*epssum1A/Pi_D)+1D0
    epssum1A_rel=(epssum1A)/dble(epsADyn(1,1,1))
#endif

    epssum2R_rel=(-1D0*epssum2R)/((Pi_D/2D0)*omega_plasma**2)
#ifdef CPLX
    epssum2A_rel=(epssum2A)/((Pi_D/2D0)*omega_plasma**2)
#endif
    
! Ref: Hybertsen & Louie PRB 34, 5390 (1986), eq. 29 and Appendix A
    write(6,*) ' '
    write(6,*) 'Full Frequency: Sum rules for head:'
    write(6,*) 'Retarded Int((1/w)*Im(eps^-1(w))) =', epssum1R_rel*100D0, ' % of exact'
#ifdef CPLX
    write(6,*) 'Advanced Int((1/w)*Im(eps^-1(w))) =', epssum1A_rel*100D0, ' % of exact'
#endif
    write(6,*) 'Retarded Int((w)*Im(eps^-1(w))) =', epssum2R_rel*100D0, ' % of exact'
#ifdef CPLX
    write(6,*) 'Advanced Int((w)*Im(eps^-1(w))) =', epssum2A_rel*100D0, ' % of exact'
#endif
  endif


!---------- Write inverse dielectric matrices to file -----------------------

  if(peinf%inode.eq.0) call timacc(45,1)
  
  if (is_q0) then
    filename = 'eps0mat.h5'
  else
    filename = 'epsmat.h5'
  endif

#ifdef HDF5
  if (pol%use_hdf5) then
    my_iq = iq
    ! If this is not a q->0 point, write to (iq-nq0) q-point
    if (.not.is_q0) my_iq = iq - pol%nq0
    if (peinf%inode .eq. 0) then
      call write_gvec_indices_hdf(gvec%ng,pol%isrtx,isorti,ekin,my_iq,filename)
    endif

! JRD: Write diagonal elements of Matrix

    if (pol%freq_dep .ne. 2) then 
      isize=SCALARSIZE
    else
      isize=2
    endif

    SAFE_ALLOCATE(epsdiag,(isize,pol%nmtx,1))
    epsdiag=0D0

#ifdef USESCALAPACK
    SAFE_ALLOCATE(epsdiagt,(isize,pol%nmtx,1))
    epsdiagt=0D0
    do jj = 1, pol%nmtx
      icol=MOD(INT(((jj-1)/scal%nbl)+TOL_SMALL),scal%npcol)
      if (icol .eq. scal%mypcol) then
        ii = jj
        irow=MOD(INT(((ii-1)/scal%nbl)+TOL_SMALL),scal%nprow)
        if (irow .eq. scal%myprow) then
          if (pol%freq_dep .ne. 2) then
            epsdiagt(1,jj,1)=dble(eps(scal%imyrowinv(jj),scal%imycolinv(jj)))
#ifdef CPLX
            epsdiagt(2,jj,1)=IMAG(eps(scal%imyrowinv(jj),scal%imycolinv(jj)))
#endif
          else
            epsdiagt(1,jj,1)=dble(epsRDyn(1,scal%imyrowinv(jj),scal%imycolinv(jj)))
            epsdiagt(2,jj,1)=IMAG(epsRDyn(1,scal%imyrowinv(jj),scal%imycolinv(jj)))
          endif
        endif
      endif
    enddo
    call MPI_reduce(epsdiagt,epsdiag,pol%nmtx,MPI_SCALAR,MPI_SUM,0,MPI_COMM_WORLD,mpierr)
    SAFE_DEALLOCATE(epsdiagt)
#else
    if (peinf%inode .eq. 0) then
      do jj = 1, pol%nmtx
        if (pol%freq_dep .ne. 2) then
          epsdiag(1,jj,1) = dble(eps(jj,jj))
#ifdef CPLX
          epsdiag(2,jj,1) = IMAG(eps(jj,jj))
#endif
        else
          epsdiag(1,jj,1) = dble(epsRDyn(1,jj,jj))
          epsdiag(2,jj,1) = IMAG(epsRDyn(2,jj,jj))
        endif
      enddo
    endif    
#endif

    if (peinf%inode .eq. 0) then
      call write_matrix_diagonal_hdf(epsdiag,pol%nmtx,my_iq,isize,filename)
    endif
    SAFE_DEALLOCATE(epsdiag)

  else
#endif
    iunit=13
    if (is_q0) iunit=12
    if (peinf%inode .eq. 0) then
      write(iunit) gvec%ng,pol%nmtx, &
        (pol%isrtx(i),isorti(i),i=1,gvec%ng)
      write(iunit) (ekin(i),i=1,gvec%ng)
      write(iunit) (q0(i),i=1,3)
    endif
#ifdef HDF5
  endif
#endif

  if (pol%freq_dep .eq. 0) then
#ifdef HDF5
    if (pol%use_hdf5) then
#ifdef USESCALAPACK
      call write_matrix_d_par_hdf(scal,eps,pol%nmtx,my_iq,1,filename)
#else
      call write_matrix_d_hdf(scal,eps,pol%nmtx,my_iq,1,filename)
#endif
    else
#endif
      call write_matrix_d(scal,eps,pol%nmtx,iunit)
#ifdef HDF5
    endif
#endif
  endif
  
  if(pol%freq_dep .eq. 2) then
#ifdef HDF5
    if (pol%use_hdf5) then
#ifdef USESCALAPACK
      call write_matrix_f_par_hdf(scal,pol%nFreq,epsRDyn,ONLYIFCPLX(epsADyn)pol%nmtx,my_iq,1,filename)
#else
      call write_matrix_f_hdf(scal,pol%nFreq,epsRDyn,ONLYIFCPLX(epsADyn)pol%nmtx,my_iq,1,filename)
#endif
    else
#endif
      call write_matrix_f(scal,pol%nFreq,epsRDyn,ONLYIFCPLX(epsADyn)pol%nmtx,iunit,pol%os_para_freqs)
#ifdef HDF5
    endif
#endif
  endif

  if(pol%freq_dep .eq. 3) then
#ifdef HDF5
    if (pol%use_hdf5) then
#ifdef USESCALAPACK
      call write_matrix_f_par_hdf(scal,pol%nFreq,epsRDyn,ONLYIFCPLX(epsRDyn)pol%nmtx,my_iq,1,filename)
#else
      call write_matrix_f_hdf(scal,pol%nFreq,epsRDyn,ONLYIFCPLX(epsRDyn)pol%nmtx,my_iq,1,filename)
#endif
    else
#endif
      call write_matrix_f(scal,pol%nFreq,epsRDyn,ONLYIFCPLX(epsRDyn)pol%nmtx,iunit,pol%os_para_freqs)
#ifdef HDF5
    endif
#endif
  endif

  if(peinf%inode.eq.0) call timacc(45,2)

! Finished writing eps
!------------------------------------------------------------------------


  SAFE_DEALLOCATE(vcoul)
  SAFE_DEALLOCATE(isorti)
  
  if(pol%freq_dep .eq. 0) then
    SAFE_DEALLOCATE(eps)
    SAFE_DEALLOCATE(ewng)
  endif
  
  if(pol%freq_dep .eq. 2) then
    SAFE_DEALLOCATE(chiRDyntmp)
    SAFE_DEALLOCATE(epsRDyn)
#ifdef CPLX
    SAFE_DEALLOCATE(chiADyntmp)
    SAFE_DEALLOCATE(epsADyn)
#endif
    SAFE_DEALLOCATE(eps1Aux)
  endif

  if(pol%freq_dep .eq. 3) then
    SAFE_DEALLOCATE(chiRDyntmp)
    SAFE_DEALLOCATE(epsRDyn)
    SAFE_DEALLOCATE(eps1Aux)
  endif
  
  
  POP_SUB(epsinv)
  
  return
end subroutine epsinv

!=========================================================================
!
! Included from file kernel_io.F90.
! You might be expected to understand this. --FHJ
!
!=========================================================================

#ifdef READ
  #define READWRITE(x) read ## x
  #define INTENT out
#else
  #define READWRITE(x) write ## x
  #define INTENT in
#endif

#ifdef FORMATTED
  #define READWRITE_FORM(x) READWRITE(_format ## x)
  #define FORMAT , *
#elif defined BINARY
  #define READWRITE_FORM(x) READWRITE(_binary ## x)
  #define FORMAT
#else
  #define READWRITE_FORM(x) READWRITE(x)
#endif

#define READWRITE_FORM_KERNELHEADER READWRITE_FORM(_kernel_header)
#define READWRITE_KERNELHEADER READWRITE(_kernel_header)

#if defined FORMATTED || defined BINARY 

!> Defines a subroutine with the template {read,write}_{formatted,binary}_kernel_header
subroutine READWRITE_FORM_KERNELHEADER(iunit, kernel)
  integer, intent(in) :: iunit !< unit number
  type(kernel_header_t), intent(INTENT) :: kernel !< kernel_header_t type

  integer :: ik

  PUSH_SUB(READWRITE_FORM_KERNELHEADER)

  call READWRITE(_mf_header)(iunit, kernel%mf)
#ifdef READ
  if (kernel%mf%sheader/='KER') then
    write(0,*) 'ERROR: header mismatch (got "'//kernel%mf%sheader//'", expected "KER")'
    call die('Input file is not from a kernel calculation (header="'//kernel%mf%sheader//'")', &
      only_root_writes=.true.)
  endif
#endif

  if (peinf%inode==0) then
    ! General information 
    READWRITE()(iunit FORMAT) kernel%iscreen, kernel%icutv, kernel%ecute

    ! Variables specific to kernel files: kpts
    READWRITE()(iunit FORMAT) kernel%nk
#ifdef READ
    SAFE_ALLOCATE(kernel%kpt, (3,kernel%nk))
#endif
    do ik = 1, kernel%nk
      READWRITE()(iunit FORMAT) kernel%kpt(1:3, ik)
    enddo

    ! Variables specific to kernel files: everything else
    READWRITE()(iunit FORMAT) kernel%ns, kernel%nspinor, kernel%nvb, kernel%ncb, kernel%n1b, kernel%n2b
    READWRITE()(iunit FORMAT) kernel%theory, kernel%nmat, kernel%storage, kernel%nblocks
    ! Empty records: you can use these slots in the future to extend the file format
    READWRITE()(iunit FORMAT)
    READWRITE()(iunit FORMAT)
    READWRITE()(iunit FORMAT)
    READWRITE()(iunit FORMAT)
    READWRITE()(iunit FORMAT)
  endif
#if defined READ && defined MPI
  if (peinf%npes > 1) then
    ! General information 
    call MPI_BCAST(kernel%iscreen, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(kernel%icutv, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(kernel%ecute, 1, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)

    ! Variables specific to kernel files: kpts
    call MPI_BCAST(kernel%nk, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    if (peinf%inode>0) then
      SAFE_ALLOCATE(kernel%kpt, (3,kernel%nk))
    endif
    call MPI_BCAST(kernel%kpt, 3*kernel%nk, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)

    ! Variables specific to kernel files: everything else
    call MPI_BCAST(kernel%ns, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(kernel%nspinor, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(kernel%nvb, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(kernel%ncb, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(kernel%n1b, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(kernel%n2b, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)

    call MPI_BCAST(kernel%theory, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(kernel%nmat, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(kernel%storage, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(kernel%nblocks, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)

  endif
#endif

  POP_SUB(READWRITE_FORM_KERNELHEADER)

end subroutine READWRITE_FORM_KERNELHEADER

#else

!> Automatically call {read,write}_{formatted,binary}_kernel_header
subroutine READWRITE_KERNELHEADER(iunit, kernel)
  integer, intent(in) :: iunit !< unit number
  type(kernel_header_t), intent(INTENT) :: kernel !< kernel_header_t type

  character(len=16) :: fmt_str
  logical :: is_fmt = .false.

  PUSH_SUB(READWRITE_KERNELHEADER)

  if (peinf%inode==0) then
    inquire(unit=iunit, form=fmt_str)
    if (TRUNC(fmt_str)=='FORMATTED') then
      is_fmt = .true.
    else if (TRUNC(fmt_str)/='UNFORMATTED') then
      call die('Unkown value for formatted string: '//TRUNC(fmt_str), &
        only_root_writes=.true.)
    endif
  endif
  ! FHJ: No need to bcast is_fmt because only inode==0 reads the file.

  if (is_fmt) then
    call READWRITE(_format_kernel_header)(iunit, kernel)
  else
    call READWRITE(_binary_kernel_header)(iunit, kernel)
  endif

  POP_SUB(READWRITE_KERNELHEADER)
 
end subroutine READWRITE_KERNELHEADER

#endif

! these undefs prevent lots of cpp warnings
#undef READWRITE_KERNELHEADER
#undef READWRITE_FORM_KERNELHEADER
#undef READWRITE_FORM
#undef READWRITE
#undef FORMAT
#undef INTENT

!================================================================================
!
! Module:
!
! (1) mtxel_sxch()          Originally By ?         Last Modified 10/5/2009 (gsm)
!
!     Computes the sum (for information on current processor) of the
!     screened exchange and Coulomb hole (excluding bare exchange) for
!     the self-energy operator between bands n (sig%diag(in)) and m
!     (sig%diag(im)) at the frequency of the band l (sig%diag(il)).
!
!     Screened exchange is put into asxt(iw), Coulomb hole into acht(iw),
!     iw goes from 1 to 3 (see below for what it is).
!
!     On entry, asxt(:) and acht(:) are zeroed.
!
!     Physically, this routine will compute:
!
!     < psi_n ( k ) | Sigma_SX ( E ) + Sigma_CH ( E ) | psi_m ( k ) >
!
!     where E = E_l ( k ) + ( iw - 2 ) * sig%dw and iw = 1, 2, 3
!     so we evaluate the matrix elements of Sigma at three different
!     energies, E_l ( k ) - sig%dw, E_l ( k ), and E_l ( k ) + sig%dw.
!
!     Sigma(E) is computed within different approximations:
!     - static COHSEX approximation, both exact and partial sum CH (gsm)
!     - Generalized Plasmon Pole model (?)
!     - full frequency dependent inverse dielectric matrix (CDS/CHP/gsm)
!
!     If sig%ggpsum=1 we compute a half of the sum over G and G` vectors
!     (igp=1,ncouls and ig=1,igp) and take the complex conjugate for the
!     other half. This is only valid if we use the same truncation scheme
!     in both Epsilon and Sigma. If sig%ggpsum=2 we compute the full sum.
!
!     ch2 variables are used to calculate the CH part of the imaginary part
!     of the self energy assuming a zero energy broadening in the energy
!     denominator for the evaluation of the self energy (CHP).
!
!================================================================================

#include "f_defs.h"

module mtxel_sxch_m

  use global_m
  use misc_m

  implicit none

  private

  public :: mtxel_sxch

contains

subroutine mtxel_sxch(in,il,ispin,ncouls,neps,gvec,eps,ph,ind, &
  indinv,isrtrqi,isrtrq,vcoul,crys,sig,wpg,wfnk,wfnkq,ncoulch, &
  aqsn,aqsm,aqsch,asigt_imag,acht_n1,asxt,acht,achtcor,nspin,qk, &
  coulfact,inv_igp_index,ngpown,epsR,epsA, &
  achtD_n1,asxtDyn,achtDyn,achtDyn_cor,achtDyn_corb,ach2tDyn,icalc)

  integer, intent(in) :: in,il,ispin,ncouls,neps
  type (gspace), intent(in) :: gvec
  !> (neps,ngpown) Uninitialized unless we are running the complex version
  SCALAR, pointer, intent(in) :: eps(:,:)
  SCALAR, intent(in) :: ph(:) !< (gvec%ng)
  integer, intent(in) :: ind(:), indinv(:), isrtrq(:) !< (gvec%ng)
  !> (gvec%ng) Uninitialized unless freq_dep=0 .or. exact_ch=1
  integer, pointer, intent(in) :: isrtrqi(:)
  real(DP), intent(in) :: vcoul(:) !< (ncoul)
  type (crystal), intent(in) :: crys
  type (siginfo), intent(in) :: sig
  type (wpgen), intent(in) :: wpg
  type (wfnkstates), intent(in) :: wfnk
  type (wfnkqstates), intent(in) :: wfnkq
  integer, intent(in) :: ncoulch
  SCALAR, intent(in) :: aqsn(:,:), aqsm(:,:) !< (peinf%ntband_max,ncoul)
  !> (ncoulch) Uninitialized unless freq_dep=0 .or. exact_ch=1
  SCALAR, pointer, intent(in) :: aqsch(:)
  !> (sig%ntband) Uninitialized in FF calculations
  SCALAR, pointer, intent(out) :: acht_n1(:)
  !> (3 or sig%nfreqeval) Uninitialized unless freq_dep=1
  SCALAR, pointer, intent(out) :: asxt(:), acht(:)
  SCALAR, intent(out) :: achtcor
  SCALAR, intent(out) :: asigt_imag
  integer, intent(in) :: nspin
  real(DP), intent(in) :: qk(:) !< (3)
  real(DP), intent(in) :: coulfact
  integer, intent(in) :: inv_igp_index(:) !< (neps)
  integer, intent(in) :: ngpown
  !> The following pointers are uninitialized unless we are running the complex version
  complex(DPC), pointer, intent(in) :: epsR(:,:,:),epsA(:,:,:) !< (sig%nFreq,neps,ngpown)
  complex(DPC), pointer, intent(out) :: achtD_n1(:) !< (sig%ntband)
  complex(DPC), pointer, intent(out) :: asxtDyn(:), achtDyn(:), achtDyn_cor(:), ach2tDyn(:) !< (sig%nfreqeval)
  complex(DPC), pointer, intent(out) :: achtDyn_corb(:) !< (sig%nfreqeval)
  integer, intent(in) :: icalc

  SCALAR, allocatable :: epstemp(:), aqsntemp(:,:),aqsmtemp(:,:)
  complex(DPC), allocatable :: epsRtemp(:,:),epsAtemp(:,:)
  SCALAR :: acht_n1_loc(sig%ntband)


  integer :: ijk, my_igp, indigp, ipe, j
  integer*8 :: cycle_count, cycle_count_total, ncouls2
  real(DP) :: qkk(3),diff,diffmin,limitone,limittwo
  logical :: flag_occ
  integer :: ig,igp,igpp,igpp2,iw,iwlda,n1,iband,n1true,nstart,nend,igmax,gpp(3)
  real(DP) :: wx,ssxcutoff,delw2,occ,occfact,tempval
  real(DP), allocatable :: wx_array(:)
  real(DP) :: fact1,fact2,wxt,rden
! chs - partial sum static CH, chx - exact static CH
  SCALAR :: achstemp,schstemp,achxtemp,ssx,sch,ssxt,scht, &
    schs,schx,matngmatmgp,matngpmatmg,epsggp,I_epsggp,achxtemp_gp, &
    Omega2,wtilde2,asxtemp_loc,achtemp_loc, &
    mygpvar1,mygpvar2
  SCALAR, allocatable :: asxtemp(:),achtemp(:),ssx_array(:),sch_array(:)
  SCALAR, allocatable :: wpmtx(:),I_eps_array(:,:)
  real(DP) :: e_lk, e_n1kq, lambda, phi
  complex(DPC) :: wtilde,halfinvwtilde,wtilde2_temp,delw,wdiff,cden
  complex(DPC), allocatable :: wtilde_array(:,:)
  integer :: iout, my_id

! full-frequency

  integer :: ifreq
  real(DP) :: E_max, pref_zb
  real(DP), allocatable :: pref(:)
  real(DP) :: delwr,wdiffr
  complex(DPC) :: schD,achsDtemp,schsDtemp
  complex(DPC), allocatable :: matngmatmgpD(:,:),matngpmatmgD(:,:)
  complex(DPC), allocatable :: asxDtemp(:),achDtemp(:),ach2Dtemp(:),achDtemp_cor(:)
  complex(DPC), allocatable :: achDtemp_corb(:)
  complex(DPC), allocatable :: schDi(:),schDi_cor(:),schDi_corb(:)
  complex(DPC), allocatable :: sch2Di(:)
  complex(DPC), allocatable :: ssxDi(:)
  complex(DPC) :: ssxDit,ssxDitt,ssxDittt,schDt,schDtt,sch2dt,sch2dtt
  complex(DPC), allocatable :: schDt_array(:)
  complex(DPC) :: schDttt,schDttt_cor
  complex(DPC) :: schDt_avg, schDt_right, schDt_left, schDt_lin, schDt_lin2, schDt_lin3
  real(DP), allocatable :: wxi(:)
  real(DP) :: cedifft_zb,intfact,cedifft_zb_left,cedifft_zb_right
  complex(DPC) :: cedifft_coh,cedifft_cor
  complex(DPC), allocatable :: epsRggp(:),epsAggp(:),I_epsRggp(:),I_epsAggp(:)
  complex(DPC), allocatable :: I_epsR_array(:,:,:),I_epsA_array(:,:,:)
  complex(DPC) :: I_epsRggp_int, I_epsAggp_int
  
  PUSH_SUB(mtxel_sxch)

  if(sig%freq_dep .eq. -1) then
    call die("BUG: cannot call mtxel_sxch for Hartree-Fock!")
  endif

  limitone=1D0/(TOL_Small*4D0)
  limittwo=sig%gamma**2

! Initialize Output Arrays
! SIB: Zero contribution to asx(n) and ach(n) for this irq

  if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.3) then
    asxt(:) = ZERO
    acht(:) = ZERO
    acht_n1(:) = ZERO
    acht_n1_loc(:) = ZERO
  elseif (sig%freq_dep.eq.2) then
    asxtDyn(:) = (0.0d0,0.0d0)
    achtDyn(:) = (0.0d0,0.0d0)
    achtDyn_cor(:) = (0.0d0,0.0d0)
    achtDyn_corb(:) = (0.0d0,0.0d0)
    ach2tDyn(:) = (0.0d0,0.0d0)
    achtD_n1(:) = (0.0d0,0.0d0)
  endif
  achtcor = ZERO
  asigt_imag = ZERO

  if (peinf%my_pool .eq. -1) then
    POP_SUB(mtxel_sxch)
    return
  endif

  call timacc(41,1)

!-----------------------
! Initialization for full-frequency CH integral

  if (sig%freq_dep.eq.2) then
    SAFE_ALLOCATE(pref, (sig%nFreq))
#ifdef CPLX
    pref_zb = 0.5D0 / PI_D
#else
    pref_zb = 1D0 / PI_D
#endif
    do ifreq=1,sig%nFreq
      if (ifreq .lt. sig%nFreq) then
        pref(ifreq)=(sig%dFreqGrid(ifreq+1)-sig%dFreqGrid(ifreq))/PI_D
      else
        pref(ifreq)=pref(ifreq-1)
      endif
    enddo
    pref(1)=pref(1)*0.5d0
    pref(sig%nFreq)=pref(sig%nFreq)*0.5d0
#ifdef CPLX
    do ifreq=1,sig%nFreq
      pref(ifreq)=pref(ifreq)*0.5d0
    enddo
#endif
    E_max=sig%dFreqGrid(sig%nFreq)
    SAFE_ALLOCATE(asxDtemp, (sig%nfreqeval))
    asxDtemp = 0D0
    SAFE_ALLOCATE(achDtemp, (sig%nfreqeval))
    achDtemp = 0D0
    SAFE_ALLOCATE(achDtemp_cor, (sig%nfreqeval))
    achDtemp_cor = 0D0
    SAFE_ALLOCATE(achDtemp_corb, (sig%nfreqeval))
    achDtemp_corb = 0D0
    SAFE_ALLOCATE(ach2Dtemp, (sig%nfreqeval))
    ach2Dtemp = 0D0
    SAFE_ALLOCATE(schDi, (sig%nfreqeval))
    schDi=0D0
    SAFE_ALLOCATE(schDi_cor, (sig%nfreqeval))
    schDi_cor=0D0
    SAFE_ALLOCATE(schDi_corb, (sig%nfreqeval))
    schDi_corb=0D0
    SAFE_ALLOCATE(sch2Di, (sig%nfreqeval))
    sch2Di=0D0
    SAFE_ALLOCATE(ssxDi, (sig%nfreqeval))
    ssxDi=0D0
    SAFE_ALLOCATE(wxi, (sig%nfreqeval))
    wxi=0D0
    SAFE_ALLOCATE(I_epsR_array, (ncouls,ngpown,sig%nFreq))
    SAFE_ALLOCATE(I_epsA_array, (ncouls,ngpown,sig%nFreq))
    !SAFE_ALLOCATE(I_epsR_array, (sig%nFreq,ncouls,ngpown))
    !SAFE_ALLOCATE(I_epsA_array, (sig%nFreq,ncouls,ngpown))
    SAFE_ALLOCATE(matngmatmgpD, (ncouls,ngpown))
    SAFE_ALLOCATE(matngpmatmgD, (ncouls,ngpown))
  else if (sig%freq_dep.eq.1) then
    SAFE_ALLOCATE(I_eps_array, (ncouls,ngpown))
    SAFE_ALLOCATE(wtilde_array, (ncouls,ngpown))
    call timacc(45,1)
!$OMP PARALLEL DO private(j)
    do j = 1, ngpown
      I_eps_array(:,j)=ZERO
      wtilde_array(:,j)=(0D0,0D0)
    enddo
!$OMP END PARALLEL DO
    call timacc(45,2)
  else if (sig%freq_dep.eq.3) then
    SAFE_ALLOCATE(I_eps_array, (ncouls,ngpown))
    SAFE_ALLOCATE(wtilde_array, (ncouls,ngpown))
    I_eps_array(:,:)=ZERO
    wtilde_array(:,:)=(0D0,0D0)
  else
    SAFE_ALLOCATE(I_eps_array, (ncouls,ngpown))
  endif

! SIB: the array wfnk%ek has bands indexed by sig%diag
! take the right band index

  iband = sig%diag(il)
  e_lk = wfnk%ek(iband,ispin)

! JRD: Initial frequencies for plasmon pole case.
! Note: below assumes that we will use iw=1,2,3 in
! subroutine shiftenergy depending on value of sig%fdf

  if (sig%freq_dep.eq.1 .or. sig%freq_dep.eq.0.or.sig%freq_dep.eq.3) then
    if (sig%fdf.eq.-3) then
      SAFE_ALLOCATE(asxtemp,(sig%nfreqeval))
      SAFE_ALLOCATE(achtemp,(sig%nfreqeval))
    else
      SAFE_ALLOCATE(asxtemp,(3))
      SAFE_ALLOCATE(achtemp,(3))
    endif
  endif

  if (sig%freq_dep.eq.1.or.sig%freq_dep.eq.3) then
    if (sig%fdf.eq.-3) then
      nstart=1
      nend=sig%nfreqeval
      SAFE_ALLOCATE(wxi, (sig%nfreqeval))
      SAFE_ALLOCATE(wx_array, (sig%nfreqeval))
      do iw=1,sig%nfreqeval
        wx = sig%freqevalmin + (iw-1)*sig%freqevalstep
        wxi(iw) = wx
      enddo
    elseif (sig%fdf.eq.-1) then
      nstart = 1
      nend = 2
      SAFE_ALLOCATE(wx_array, (3))
    elseif (sig%fdf.eq.0) then
      nstart = 1
      nend = 3
      SAFE_ALLOCATE(wx_array, (3))
    elseif (sig%fdf.eq.1.or.(sig%fdf.eq.2.and.icalc.eq.1)) then
      nstart = 2
      nend = 3
      SAFE_ALLOCATE(wx_array, (3))
    else
      nstart = 2
      nend = 2
      SAFE_ALLOCATE(wx_array, (3))
    endif
  endif

  call timacc(41,2)

!------------------------
! JRD: This changes qkk to q0vec for q=0 instead of using exactly zero

#ifdef VERBOSE
  qkk=qk
  diff = abs(qkk(1)) + abs(qkk(2)) + abs(qkk(3))
  if (diff.lt.TOL_Zero) then
    qkk(:) = sig%q0vec(:)
    if (in .eq. 1 .and. il .eq. 1) then ! no need to write again for off-diagonals
      if (peinf%inode.eq.0) then
        write(7,998) qkk
      endif
    endif
  endif
998 format(/,6x,"q0vec =",3f7.4)
#endif

!-------------- Main loop over G` (igp) ---------------------------------------

  call timacc(42,1)

  cycle_count = 0
  achxtemp = ZERO

! In below OMP region:
! I_eps_array, I_epsR_array, I_epsA_array, wtilde_array are shared

!$OMP PARALLEL private (ig,epsggp,I_epsggp,gpp,iout,schx,igpp,igpp2,achxtemp_gp,igp,indigp, &
!$OMP                      igmax,epstemp,I_epsRggp,epsRggp,epsRtemp, &
#ifdef CPLX
!$OMP                      epsAtemp,wtilde2_temp,lambda,phi,epsAggp,I_epsAggp, &
#endif
!$OMP                      wpmtx,wtilde,wtilde2,Omega2)

#ifdef OMP
  my_id = omp_get_thread_num()
#else
  my_id = 0
#endif

! Allocate Temporary Arrays

  select case(sig%freq_dep)
  case(0)
    SAFE_ALLOCATE(epstemp, (neps))
  case(1)
    SAFE_ALLOCATE(epstemp, (neps))
    SAFE_ALLOCATE(wpmtx, (neps))
  case(2)
    SAFE_ALLOCATE(epsRtemp, (sig%nFreq,neps))
    SAFE_ALLOCATE(epsRggp, (sig%nFreq))
    SAFE_ALLOCATE(I_epsRggp, (sig%nFreq))
#ifdef CPLX
    SAFE_ALLOCATE(epsAtemp, (sig%nFreq,neps))
    SAFE_ALLOCATE(epsAggp, (sig%nFreq))
    SAFE_ALLOCATE(I_epsAggp, (sig%nFreq))
#endif
  case(3)
    SAFE_ALLOCATE(epsRtemp, (sig%nFreq,neps))
    SAFE_ALLOCATE(epsRggp, (sig%nFreq))
    SAFE_ALLOCATE(I_epsRggp, (sig%nFreq))
  end select

!$OMP DO reduction(+:achxtemp,cycle_count)
  do my_igp=1,ngpown

    indigp = inv_igp_index(my_igp)
    igp = indinv(indigp)

    if (igp .gt. ncouls) write(6,*) "CATASTROPHE", peinf%inode, my_igp, igp
    if (igp .gt. ncouls .or. igp .le. 0) cycle

! JRD: We will soon remove ggpsum 1 for all freq_dep

    if (sig%ggpsum.eq.1) then
      igmax=igp
    else
      igmax=ncouls
    endif
    
    if ( sig%freq_dep .eq. 2) igmax = ncouls

!!------------- Initialize eps^-1 for this G` ---------------------------------

    select case(sig%freq_dep)
    case(0,1)
      epstemp(:)=eps(:,my_igp)
    case(2)
      epsRtemp(:,:)=epsR(:,:,my_igp)
#ifdef CPLX
      epsAtemp(:,:)=epsA(:,:,my_igp)
#endif
    case(3)
      epsRtemp(:,:)=epsR(:,:,my_igp)
    end select

!------------------------------------------------------------------------------
! (gsm) Below you`ll find the code to compute SX & CH in the static COHSEX
!       approximation (both the exact and partial sum expressions for CH),
!       within the GPP model, and using the full frequency dependent RPA
!       inverse dielectric matrix. The GPP section of the code is well
!       commented (thanks to Sohrab), while the COHSEX and RPA sections
!       are not... But most of the variables are the same anyways,
!       so just look at the comments in the GPP section.
!------------------------------------------------------------------------------

! (gsm) <<<<<< static COHSEX approximation - exact static CH >>>>>>

! < n k | \Sigma_{CH} (r, r`; 0) | m k > =
! \frac{1}{2} \sum_{q G G`}
! < n k | e^{i (G - G`) \cdot r} | m k >
! [\eps_{G G`}^{-1} (q; 0) - \delta_{G G`}] v (q + G`)

    if (sig%freq_dep.eq.0.or.sig%exact_ch.eq.1) then
    
! Only Computed on One Processor Per Pool

      ! JRD: Since, we are distributed over igp now, all procs need to do this

      achxtemp_gp = ZERO

      do ig=1,igmax

        if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1) then
          epsggp = ph(ig)*MYCONJG(ph(igp))*epstemp(ind(ig))
        else
          epsggp = ph(ig)*MYCONJG(ph(igp))*SCALARIFY(epsRtemp(1,ind(ig)))
        endif
        if (ig.eq.igp) then
          I_epsggp = epsggp - 1.0d0
        else
          I_epsggp = epsggp
        endif
        if (abs(I_epsggp).lt.TOL_Small) cycle
        if (ig.ne.igp) then
          gpp(:)=gvec%components(:,isrtrq(ig))-gvec%components(:,isrtrq(igp))
          call findvector(iout,gpp,gvec)
          if (iout.eq.0) cycle
          igpp=isrtrqi(iout)
          if (igpp.lt.1.or.igpp.gt.ncoulch) cycle
          gpp(:)=gvec%components(:,isrtrq(igp))-gvec%components(:,isrtrq(ig))
          call findvector(iout,gpp,gvec)
          if (iout.eq.0) cycle
          igpp2=isrtrqi(iout)
          if (igpp2.lt.1.or.igpp2.gt.ncoulch) cycle
        else
          gpp(:)=0
          call findvector(iout,gpp,gvec)
          if (iout.eq.0) cycle
          igpp=isrtrqi(iout)
          if (igpp.lt.1.or.igpp.gt.ncoulch) cycle
        endif
        schx = aqsch(igpp) * I_epsggp
! XXX: TEMP Just turn off ggpsum1 for full_freq. Soon delete for all.
        if (sig%ggpsum.eq.1.and.ig.lt.igp.and.sig%freq_dep.ne.2) then
          schx = schx + aqsch(igpp2) * MYCONJG(I_epsggp)
        endif
        achxtemp_gp = achxtemp_gp + schx 
      enddo ! over G (ig)

      achxtemp = achxtemp + achxtemp_gp * vcoul(igp) * 0.5d0

    endif ! sig%freq_dep.eq.0.or.sig%exact_ch.eq.1

!!-----------------------------------------------------------------------------------------
! (gsm) <<<<<< static COHSEX approximation - CH as a partial sum over empty bands >>>>>>

! < n k | \Sigma_{SX} (r, r`; 0) | m k > =
! - \sum_{n_1}^{occ} \sum_{q G G`}
! < n k | e^{i (q + G) \cdot r} | n_1 k - q >
! < n_1 k - q | e^{- i (q + G`) \cdot r`} | m k >
! [\eps_{G G`}^{-1} (q; 0) - \delta_{G G`}] v (q + G`)

! < n k | \Sigma_{CH} (r, r`; 0) | m k > =
! \frac{1}{2} \sum_{n_1} \sum_{q G G`}
! < n k | e^{i (q + G) \cdot r} | n_1 k - q >
! < n_1 k - q | e^{- i (q + G`) \cdot r`} | m k >
! [\eps_{G G`}^{-1} (q; 0) - \delta_{G G`}] v (q + G`)


    if (sig%freq_dep.eq.0) then

      do ig=1,igmax
        epsggp = ph(ig)*MYCONJG(ph(igp))*epstemp(ind(ig))
        if (ig.eq.igp) then
          I_epsggp = epsggp - 1.0d0
        else
          I_epsggp = epsggp
        endif

        I_eps_array(ig,my_igp) = I_epsggp

      enddo ! over G (ig)

! (gsm) <<<<<< Generalized Plasmon Pole model >>>>>>

    elseif (sig%freq_dep.eq.1) then

! Zero out temporary accumulation variables

!----------------------
! Calculate Plasma Frequencies
!
! SIB: Here we get the plasmon-pole effective plasma frequecies
! Omega(G,G`)^2 (equation (31) of Hybersten & Louie, PRB 34, 1986, p 5396)
! which come in the vector wp(G) for current G`.

! SIB: We calculate wp(G) for a given G` (trade-off for memory)
! Note that wp(G) G=1,ncouls requires O(N) operations
! Even if we redo it for each band n, not so bad

! JRD: I changed this to use qk instead of qkk because we use vcoul at q=0
! (instead of small q) throughout


! given how many times this routine is called, timing it appears to take a non-negligible amount of time

      call wpeff(crys,gvec,wpg,sig,neps,isrtrq,igp,ncouls,wpmtx,nspin,qk,vcoul,coulfact)

!!------ For given G` (igp), loop over all G vectors (ig) in lower triangle ---

      if (my_id.eq.0) call timacc(46,1)

      do ig=1,igmax

! Put epsilon(G,G`) into epsggp

        epsggp = ph(ig)*MYCONJG(ph(igp))*epstemp(ind(ig))

! I_epsggp = Kronecker(G,G`) - eps(G,G`)

        if (ig.eq.igp) then
          I_epsggp = ONE - epsggp
        else
          I_epsggp = ZERO - epsggp
        endif

! If I_epsggp is too small, then we skip this (G,G`) entry
! This only happens when eps is 1 on diagonal or 0 off diagonal
! but, this means no screening correct and is already treated properly in bare
! exchange term

        if (abs(I_epsggp).lt.TOL_Small) cycle

        I_eps_array(ig,my_igp) = I_epsggp

! Omega2 = Omega(G,G`)^2 = effective plasma freq^2

        Omega2 = wpmtx(ig)

! If Omega2 is too small, then we skip this (G,G`) entry
! JRD: I am not sure why we have to cycle here... :/ Probably not needed

        if (abs(Omega2).lt.TOL_Small) cycle

#ifdef CPLX

! <<<<<<<<<<<< COMPLEX GPP >>>>>>>>>>>>

! (gsm) equations (17), (20), (21) from [PRB 40, 3162 (1989)]

        wtilde2_temp = Omega2 / I_epsggp
 
        lambda = abs(wtilde2_temp)
        if (lambda .lt. TOL_Small) cycle
        phi = atan2(IMAG(wtilde2_temp), dble(wtilde2_temp))
        if (abs(cos(phi)) .lt. TOL_Small) cycle
        wtilde2 = lambda / cos(phi)
! this is not needed because we recalculate Omega2 below
!        Omega2 = Omega2 * CMPLX(1.0d0, -tan(phi))

#else

! <<<<<<<<<<<< REAL GPP >>>>>>>>>>>>

! (gsm) equation (30) from [PRB 34, 5390 (1986)]

        wtilde2 = Omega2 / I_epsggp

        if (abs(wtilde2) .lt. TOL_Small) cycle

#endif

! gsm & jrd: find "complex" mode frequency wtilde

        wtilde = sqrt(COMPLEXIFY(wtilde2))

! BEGIN OLD GPP
        !if (ig.eq.igp) then
        !  if (dble(wtilde2_temp).lt.TOL_Small) cycle
        !else
        !  if (abs(wtilde2_temp).lt.TOL_Small) cycle
        !  if (dble(wtilde2_temp)/abs(wtilde2_temp).lt.TOL_Small) cycle
        !endif
        !wtilde = sqrt(wtilde2_temp)
! END OLD GPP

        wtilde_array(ig,my_igp) = wtilde

      enddo ! G Loop for GPP Setup

      if (my_id.eq.0) call timacc(46,2)



!!--------------------------------------------------------------------
! (gsm) <<<<<< full frequency dependent inverse dielectric matrix >>>>>>

! The code below makes use of the following relations:
!
! {eps_{G G`}^r}^{-1}(q, -E) = {eps_{G G`}^a}^{-1}(q, E)
! for general systems (both real and complex versions of the code)
!
! {eps_{G G`}^a}^{-1}(q, E) = {{eps_{G G`}^r}^{-1}}^{*}(q, E)
! for systems with inversion symmetry (the real version of the code)
! since plane-wave matrix elements are real
!
! {eps_{G G}^a}^{-1}(q, E) = {{eps_{G G}^r}^{-1}}^{*}(q, E)
! for general systems, the diagonal of the matrix (G` = G)
! since plane-wave matrix elements are complex conjugates of each other
!
! The complex version of the code uses
! {eps_{G G`}^r}^{-1}(q, E) and {eps_{G G`}^a}^{-1}(q, E) for E >= 0
!
! The real version of the code uses
! {eps_{G G`}^r}^{-1}(q, E) for E >= 0

! CHP: full frequency routine - the case for sig%ggpsum == 1
!
! On top of the above relations, we need the following:
! Assuming that W_{G,G`}={eps_{G,G`}}^{-1} v(q+G`),
!
! W_{G`,G}^r(E) = {W_{G,G`}^a}^{*}(E)
!               = {W_{G,G`}^r}^{*}(-E) (this form is used if E<0)
! for general systems (both real and complex version of the code)
!
! W_{G`,G}^a(E) = {W_{G,G`}^r}^{*}(E)
!               = {W_{G,G`}^a}^{*}(-E) (this form is used if E<0)
! for general systems (both real and complex version of the code)
!
! W_{G`,G}^r(E) = W_{G,G`}^r(E)
! for systems with inversion symmetry
!
! W_{G`,G}^a(E) = W_{G,G`}^a(E)
! for systems with inversion symmetry
!
! Note that eps^{-1} does not have these symmetries.

    elseif (sig%freq_dep.eq.2) then

! JRD: This may be slow - due to reordering of memory
      do ig=1,igmax
        
        epsRggp(:) = ph(ig)*MYCONJG(ph(igp))*epsRtemp(:,ind(ig))
#ifdef CPLX
        epsAggp(:) = ph(ig)*MYCONJG(ph(igp))*epsAtemp(:,ind(ig))
#endif
        
        if (ig.eq.igp) then
          I_epsRggp = 1.0d0 - epsRggp
#ifdef CPLX
          I_epsAggp = 1.0d0 - epsAggp
#endif
        else
          I_epsRggp = - epsRggp
#ifdef CPLX
          I_epsAggp = - epsAggp
#endif
        endif

! XXX - This could be bad with threads. Cachelines could be conflicting.
! Seems OK in practice so far.
        I_epsR_array(ig,my_igp,:) = I_epsRggp(:)
        !I_epsR_array(:,ig,my_igp) = I_epsRggp(:)
#ifdef CPLX
        I_epsA_array(ig,my_igp,:) = I_epsAggp(:)
        !I_epsA_array(:,ig,my_igp) = I_epsAggp(:)
#endif

      enddo
      
    endif ! sig%freq_dep

  enddo ! over G` (igp)
!$OMP END DO



  if (sig%freq_dep.eq.0) then
    SAFE_DEALLOCATE(epstemp)
  endif
  if (sig%freq_dep.eq.1) then
    SAFE_DEALLOCATE(wpmtx)
    SAFE_DEALLOCATE(epstemp)
  endif
  if (sig%freq_dep.eq.2) then
    SAFE_DEALLOCATE(epsRtemp)
    SAFE_DEALLOCATE(epsRggp)
    SAFE_DEALLOCATE(I_epsRggp)
#ifdef CPLX
    SAFE_DEALLOCATE(epsAtemp)
    SAFE_DEALLOCATE(epsAggp)
    SAFE_DEALLOCATE(I_epsAggp)
#endif
  endif
  if (sig%freq_dep.eq.3) then
    SAFE_DEALLOCATE(epsRtemp)
    SAFE_DEALLOCATE(epsRggp)
    SAFE_DEALLOCATE(I_epsRggp)
  endif

!$OMP END PARALLEL

  call timacc(42,2)

  !if (peinf%inode .eq. 0) write(6,*) "Done Setup"

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!! END SETUP / BEGIN COMPUTATION OF SUMS !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! JRD Reduce static cohsex version?

  if (sig%freq_dep .eq. 0) then

    asxtemp(:) = ZERO
    achtemp(:) = ZERO

    SAFE_ALLOCATE(aqsntemp,(ncouls,peinf%ntband_max))
    SAFE_ALLOCATE(aqsmtemp,(ncouls,peinf%ntband_max))

! JRD LOOP OVER NPES PER POOL

    do ipe = 1, peinf%npes_pool

      call timacc(43,1)

      if (peinf%pool_rank .eq. ipe-1) then
        aqsntemp(:,:) = aqsn(1:ncouls,:)
        aqsmtemp(:,:) = aqsm(1:ncouls,:)
      endif

! JRD: broadcast in just pool

#ifdef MPI
      if (peinf%my_pool .ne. -1) then
        call MPI_Bcast(aqsntemp,peinf%ntband_max*ncouls,MPI_SCALAR,ipe-1,peinf%pool_comm,mpierr)
        call MPI_Bcast(aqsmtemp,peinf%ntband_max*ncouls,MPI_SCALAR,ipe-1,peinf%pool_comm,mpierr)
      endif
#endif

      call timacc(43,2)

      do n1=1,peinf%ntband_dist(ipe)

! n1true = "True" band index of the band n1 w.r.t. all bands

        call timacc(51,1)

        n1true = peinf%indext_dist(n1,ipe)

! energy of the |n1,k-q> state

        e_n1kq = wfnkq%ekq(n1true,ispin)

        !if (peinf%inode .eq. 0) write(6,*) 'ipe,n1,n1true',ipe,n1,n1true,e_n1kq

! occupation of the |n1,k-q> state

        flag_occ = (n1true.le.(sig%nvband+sig%ncrit)) &
          .and.((sig%ncrit.eq.0).or.(e_n1kq.le.(sig%efermi+sig%tol)))
          
        tempval=abs(e_n1kq-sig%efermi)
        if (tempval .lt. sig%tol) then
          occ = 0.5d0 ! Fermi-Dirac distribution = 1/2 at Fermi level
        else
          occ = 1.0d0
        endif

        call timacc(51,2)

        call timacc(52,1)

!$OMP PARALLEL do private (my_igp,igp,indigp,igmax,mygpvar1,mygpvar2,ig,ssx,sch, &
!$OMP                       matngmatmgp,matngpmatmg,schstemp,achtemp_loc, &
!$OMP                       asxtemp_loc) reduction(+:achtemp,asxtemp,acht_n1_loc)
        do my_igp = 1, ngpown
          indigp = inv_igp_index(my_igp)
          igp = indinv(indigp)

          if (igp .gt. ncouls .or. igp .le. 0) cycle

          if (sig%ggpsum.eq.1) then
            igmax=igp
          else
            igmax=ncouls
          endif

          schstemp = ZERO
          achtemp_loc = ZERO
          asxtemp_loc = ZERO

          do ig = 1, igmax

            ! Cycle bad for vectorization
            !if (abs(I_eps_array(ig,my_igp)).lt.TOL_Small) cycle
            ssx = I_eps_array(ig,my_igp)

            matngmatmgp = aqsntemp(ig,n1) * MYCONJG(aqsmtemp(igp,n1))
            if (sig%ggpsum.eq.1) &
              matngpmatmg = aqsntemp(igp,n1) * MYCONJG(aqsmtemp(ig,n1))
          
            if(sig%exact_ch == 0) sch = ssx * 0.5d0

            if (sig%ggpsum.eq.1.and.ig.lt.igp) then
              ssx = matngmatmgp*ssx + matngpmatmg*MYCONJG(ssx)
              if(sig%exact_ch == 0) then 
                sch = matngmatmgp*sch + matngpmatmg*MYCONJG(sch)
                achtemp_loc = achtemp_loc + sch
              endif
            else
              ssx = matngmatmgp*ssx
              if(sig%exact_ch == 0) then 
                sch = matngmatmgp*sch
                achtemp_loc = achtemp_loc + sch
              endif
            endif

            if (flag_occ) then
              asxtemp_loc = asxtemp_loc - ssx
            endif

          enddo ! ig
          asxtemp(2) = asxtemp(2) + asxtemp_loc*occ*vcoul(igp)          
          if(sig%exact_ch == 0) achtemp(2) = achtemp(2) + achtemp_loc*vcoul(igp)
          if(sig%exact_ch == 0) acht_n1_loc(n1true) = acht_n1_loc(n1true) + achtemp_loc*vcoul(igp)
        enddo ! my_igp
        call timacc(52,2)
      enddo ! over bands (n1)
    enddo ! over ipe

    if (sig%exact_ch.eq.1) then
      achtemp(2)=achxtemp
      achxtemp=ZERO
    endif

    asxt(:) = asxt(:) + asxtemp(2)
    acht(:) = acht(:) + achtemp(2)

    if (sig%exact_ch .eq. 0) then
      achtcor = achtcor + (achxtemp - achtemp(2))
    endif

    SAFE_DEALLOCATE(I_eps_array)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  else if (sig%freq_dep .eq. 1 .or. sig%freq_dep.eq.3) then

! Some constants used in the loop below, computed here to save
! floating point operations

!!!----- Loop over all bands n1 on curr. processor -----

    asxtemp(:) = ZERO
    achtemp(:) = ZERO
    if (sig%exact_ch.eq.1) achstemp = ZERO

    SAFE_ALLOCATE(aqsntemp,(ncouls,peinf%ntband_max))
    SAFE_ALLOCATE(aqsmtemp,(ncouls,peinf%ntband_max))

! JRD NOW LOOP OVER NPES PER POOL

    do ipe = 1, peinf%npes_pool

      call timacc(43,1)

      if (peinf%pool_rank .eq. ipe-1) then
        aqsntemp(:,:) = aqsn(1:ncouls,:)
        aqsmtemp(:,:) = aqsm(1:ncouls,:)
      endif

! JRD BCAST in just pool

#ifdef MPI
      if (peinf%my_pool .ne. -1) then
        call MPI_Bcast(aqsntemp,peinf%ntband_max*ncouls,MPI_SCALAR,ipe-1,peinf%pool_comm,mpierr)
        call MPI_Bcast(aqsmtemp,peinf%ntband_max*ncouls,MPI_SCALAR,ipe-1,peinf%pool_comm,mpierr)
      endif
#endif

      call timacc(43,2)

      do n1=1,peinf%ntband_dist(ipe)

! n1true = "True" band index of the band n1 w.r.t. all bands

        call timacc(51,1)

        n1true = peinf%indext_dist(n1,ipe)

! energy of the |n1,k-q> state

        e_n1kq = wfnkq%ekq(n1true,ispin)

        !if (peinf%inode .eq. 0) write(6,*) 'ipe,n1,n1true',ipe,n1,n1true,e_n1kq

! occupation of the |n1,k-q> state

        flag_occ = (n1true.le.(sig%nvband+sig%ncrit)) &
          .and.((sig%ncrit.eq.0).or.(e_n1kq.le.(sig%efermi+sig%tol)))
          
        tempval=abs(e_n1kq-sig%efermi)
        if (tempval .lt. sig%tol) then
          occ = 0.5d0 ! Fermi-Dirac distribution = 1/2 at Fermi level
        else
          occ = 1.0d0
        endif
          
! (gsm) compute the static CH for the static remainder

        if (sig%exact_ch.eq.1) then
!$OMP PARALLEL do private (my_igp,igp,indigp,igmax,mygpvar1,mygpvar2,ig,schs, &
!$OMP                       matngmatmgp,matngpmatmg,schstemp) reduction(+:achstemp)
          do my_igp = 1, ngpown
            indigp = inv_igp_index(my_igp)
            igp = indinv(indigp)

            if (igp .gt. ncouls .or. igp .le. 0) cycle

            if (sig%ggpsum.eq.1) then
              igmax=igp
            else
              igmax=ncouls
            endif

            mygpvar1 = MYCONJG(aqsmtemp(igp,n1))
            mygpvar2 = aqsntemp(igp,n1)

            schstemp = ZERO

! We do two loops here for performance. Don`t want to evaluate if statements inside loop 
! at every iteration

            if (sig%ggpsum.eq.1) then
              do ig = 1, igmax - 1
                schs=-I_eps_array(ig,my_igp)
! JRD: Cycle bad for vectorization. 
! I_eps_array is already set to zero above for these ig,igp
!                if (abs(schs).lt.TOL_Small) cycle
                matngmatmgp = aqsntemp(ig,n1) * mygpvar1
                matngpmatmg = MYCONJG(aqsmtemp(ig,n1)) * mygpvar2
                schstemp = schstemp + matngmatmgp*schs + matngpmatmg*MYCONJG(schs)
              enddo
              ig = igp
              schs=-I_eps_array(ig,my_igp)
              matngmatmgp = aqsntemp(ig,n1) * mygpvar1
              if (abs(schs).gt.TOL_Small) schstemp = schstemp + matngmatmgp*schs
            else
              do ig = 1, igmax
                !schs=-I_eps_array(ig,my_igp)
! JRD: Cycle bad for vectorization. 
! I_eps_array is already set to zero above for these ig,igp
!             if (abs(schs).lt.TOL_Small) cycle
                !matngmatmgp = aqsntemp(ig,n1) * mygpvar1
                schstemp = schstemp - aqsntemp(ig,n1) * I_eps_array(ig,my_igp) * mygpvar1
                !schstemp = schstemp + matngmatmgp * schs
              enddo
            endif            

            achstemp = achstemp + schstemp*vcoul(igp)*0.5d0
          enddo
!$OMP END PARALLEL DO
        endif ! sig%exact_ch.eq.1

        call timacc(51,2)

!!!!--- Loop over three energy values which we compute Sigma -----------
!
! SIB: In terms of formulae, the two terms we will compute are given in
! formulae (34a,34b) on p. 5397 of above reference.
!
!                                         Omega^2(G,G`)
!    SX(E) = M(n,G)*conj(M(m,G`)) * ------------------------ * Vcoul(G`)
!                                   (E-E_n1(k-q))^2-wtilde^2
!
!                                           Omega^2(G,G`)
!    CH(E) = M(n,G)*conj(M(m,G`)) * ----------------------------- * Vcoul(G`)
!                                   2*wtilde*[E-E_n1(k-q)-wtilde]
!
! and we are evaluating both at E = E_l(k) and E = E_l(k) +/- dE.
! SX only gets contributions for the band n1 being an occupied state.
!
! For diagonal elements, we need matrix elements at various
! energies (to get quasi-particle energies), i.e. for iw=1,2,3;
! but for off-diagonal elements, we only need them at iw=2
! (the actual energy) so we won`t even bother calculating
! them at other energies

        do iw=nstart,nend
! wx = E_l(k) - E_n1(k-q) + dE = difference in energies
! of the two states appearing as E - E_n1(k-q) above.
          if (sig%fdf .eq. -3) then
            wx_array(iw) = e_lk - e_n1kq + wxi(iw)
          else 
            wx_array(iw) = e_lk - e_n1kq + sig%dw*(iw-2)
          endif
          if (abs(wx_array(iw)) .lt. TOL_Zero) wx_array(iw) = TOL_Zero
        enddo

        call timacc(52,1)

! JRD: This Loop is Performance critical. Make Sure you don`t mess it up

!$OMP PARALLEL private (my_igp,igp,indigp,igmax,mygpvar1,mygpvar2,ssx_array,sch_array,ig, &
!$OMP                      wtilde,wtilde2,halfinvwtilde,ssxcutoff,matngmatmgp,matngpmatmg,sch,ssx, &
!$OMP                      iw,delw,delw2,Omega2,scht,ssxt,wxt, &
!$OMP                      rden,cden,delwr,wdiffr,occfact)

        if (sig%fdf.eq.-3) then
          SAFE_ALLOCATE(ssx_array,(sig%nfreqeval))
          SAFE_ALLOCATE(sch_array,(sig%nfreqeval))
        else
          SAFE_ALLOCATE(ssx_array,(3))
          SAFE_ALLOCATE(sch_array,(3))
        endif

!$OMP DO reduction(+:asxtemp,acht_n1_loc,achtemp)
        do my_igp = 1, ngpown

          indigp = inv_igp_index(my_igp)
          igp = indinv(indigp)

          if (igp .gt. ncouls .or. igp .le. 0) cycle

          if (sig%ggpsum.eq.1) then
            igmax=igp
          else
            igmax=ncouls
          endif

          ssx_array = ZERO
          sch_array = ZERO

          mygpvar1 = MYCONJG(aqsmtemp(igp,n1))
          mygpvar2 = aqsntemp(igp,n1)

! delw measures how close to zero the difference
! wx - wtilde = E - E_n1(k-q) - wtilde is relative to wtilde:
! delw = (E - E_n1(k-q) - wtilde) / (2 * wtilde)
! delw2 is the squared absolute value of delw
      
! If delw is small, both SX and CH blow up, but their sum (for
! an occupied state n1) is finite.  In such a case, their sum
! is Omega^2 / (4 * wtilde2) / (1 + delw). Then the sum is
! assigned to ssx and sch is set to zero.

! If ssx is too large (which can happen due to the pole at
! wx + wtilde = 0 of the SX term), then we should drop this term.
! See the discussion at the bottom of p. 5411-5412 of Hybertsen & Louie.

! If G.neq.G`, then since we sum over only lower triangle,
! we include the contribution we would have had from (G`,G).

          if (flag_occ) then

            do iw=nstart,nend

              scht=0D0
              ssxt=0D0
              wxt = wx_array(iw)

              if (sig%ggpsum.eq.1) then

                do ig = 1, igmax

! Here we recompute Omega2 = wtilde2 * I_eps_array. This contains
! the factor of (1 - i tan phi) from Eqs. 21 & 22 of arXiv paper.

!FIXME: Here we use temporary variables wtilde, wtilde2, Omega2 while
! in the following sections we use wtilde_array and I_eps_array directly.
! JRD, please write a comment here explaining whether this is critical
! for performance or it doesn`t matter.

                  wtilde = wtilde_array(ig,my_igp)
                  wtilde2 = wtilde**2
                  Omega2 = wtilde2 * I_eps_array(ig,my_igp)

! Cycle bad for vectorization. ggpsum=1 slow anyway
                  if (abs(Omega2) .lt. TOL_Zero) cycle

                  matngmatmgp = aqsntemp(ig,n1) * mygpvar1
! JRD: This breaks vectorization but ggpsum=1 is slow for other reasons already
                  if (ig .ne. igp) matngpmatmg = MYCONJG(aqsmtemp(ig,n1)) * mygpvar2

                  halfinvwtilde = 0.5d0/wtilde
                  delw = (wxt - wtilde) * halfinvwtilde
                  delw2 = abs(delw)**2

                  if (abs(wxt-wtilde).lt.sig%gamma .or. delw2.lt.TOL_Small) then
                    sch = 0.0d0
                    if (abs(wtilde) .gt. Tol_Zero) then
                      ssx = -Omega2 / (4.0d0 * wtilde2 * (1.0d0 + delw))
                    else
                      ssx = 0D0
                    endif
                  else
                    sch = wtilde * I_eps_array(ig,my_igp) / (wxt - wtilde)
                    ssx = Omega2 / (wxt**2 - wtilde2)
                  endif

! JRD: Bad for vectorization
                  ssxcutoff = sig%sexcut*abs(I_eps_array(ig,my_igp))
                  if (abs(ssx) .gt. ssxcutoff .and. wxt .lt. 0.0d0) ssx=0.0d0

                  if (ig .ne. igp) then
                    ssxt = ssxt + matngmatmgp*ssx + matngpmatmg*MYCONJG(ssx)
                    scht = scht + matngmatmgp*sch + matngpmatmg*MYCONJG(sch)
                  else
                    ssxt = ssxt + matngmatmgp*ssx
                    scht = scht + matngmatmgp*sch
                  endif

                enddo ! loop over g

              else

                do ig = 1, igmax

! Here we recompute Omega2 = wtilde2 * I_eps_array. This contains
! the factor of (1 - i tan phi) from Eqs. 21 & 22 of arXiv paper.

!FIXME: Here we use temporary variables wtilde, wtilde2, Omega2 while
! in the following sections we use wtilde_array and I_eps_array directly.
! JRD, please write a comment here explaining whether this is critical
! for performance or it doesn`t matter.
  
                  wtilde = wtilde_array(ig,my_igp)
                  wtilde2 = wtilde**2
                  Omega2 = wtilde2 * I_eps_array(ig,my_igp)

! Cycle bad for vectorization. Not needed wtilde is zero
!                  if (abs(Omega2) .lt. TOL_Zero) cycle

                  matngmatmgp = aqsntemp(ig,n1) * mygpvar1

                  wdiff = wxt - wtilde

                  cden = wdiff
                  rden = cden * CONJG(cden)
                  rden = 1D0 / rden
                  delw = wtilde * CONJG(cden) * rden
                  delwr = delw*CONJG(delw)
                  wdiffr = wdiff*CONJG(wdiff)

! This Practice is bad for vectorization and understanding of the output.
! JRD: Complex division is hard to vectorize. So, we help the compiler.
                  if (wdiffr.gt.limittwo .and. delwr.lt.limitone) then
                    sch = delw * I_eps_array(ig,my_igp)
                    cden = wxt**2 - wtilde2
                    rden = cden*CONJG(cden)
                    rden = 1D0 / rden                    
                    ssx = Omega2 * CONJG(cden) * rden
                  else if ( delwr .gt. TOL_Zero) then
                    sch = 0.0d0
                    cden = (4.0d0 * wtilde2 * (delw + 0.5D0 ))
                    rden = cden*MYCONJG(cden)
                    rden = 1D0 / rden
                    ssx = -Omega2 * MYCONJG(cden) * rden * delw
                  else
                    sch = 0.0d0
                    ssx = 0.0d0
                  endif

! JRD: Breaks vectorization. But, I will have to fix later because
! leaving it out breaks GSM example.
                  ssxcutoff = sig%sexcut*abs(I_eps_array(ig,my_igp))
                  if (abs(ssx) .gt. ssxcutoff .and. wxt .lt. 0.0d0) ssx=0.0d0

                  ssxt = ssxt + matngmatmgp*ssx
                  scht = scht + matngmatmgp*sch

                enddo ! loop over g

              endif

! JRD: Not ideal for fdf -3, but user should see spectrum.dat

              ssx_array(iw) = ssx_array(iw) + ssxt
              sch_array(iw) = sch_array(iw) + 0.5D0*scht

            enddo

          else

            do iw=nstart,nend

              scht=0D0
              ssxt=0D0
              wxt = wx_array(iw)

              if (sig%ggpsum.eq.1) then

                do ig = 1, igmax

! Here we recompute Omega2 = wtilde2 * I_eps_array. This contains
! the factor of (1 - i tan phi) from Eqs. 21 & 22 of arXiv paper.

!FIXME: Here we use wtilde_array and I_eps_array directly while in the
! previous sections we use temporary variables wtilde, wtilde2, Omega2.
! JRD, please write a comment here explaining whether this is critical
! for performance or it doesn`t matter.

                  wtilde = wtilde_array(ig,my_igp)
            
! Cycle bad for vectorization. ggpsum=1 slow anyway
                  if (abs((wtilde**2) * I_eps_array(ig,my_igp)) .lt. TOL_Zero) cycle

                  matngmatmgp = aqsntemp(ig,n1) * mygpvar1
! JRD: If statement breaks vectorization but gppsum=1 is slow anyway
                  if (ig .ne. igp) matngpmatmg = MYCONJG(aqsmtemp(ig,n1)) * mygpvar2

                  halfinvwtilde = 0.5d0/wtilde
                  delw = (wx_array(iw) - wtilde) * halfinvwtilde
                  delw2 = abs(delw)**2

                  if (abs(wxt-wtilde).lt.sig%gamma .or. delw2.lt.TOL_Small) then
                    sch = 0.0d0
                  else
                    sch = wtilde_array(ig,my_igp) * I_eps_array(ig,my_igp) / (wxt - wtilde_array(ig,my_igp))
                  endif

                  if (ig .ne. igp) then
                    scht = scht + matngmatmgp*sch + matngpmatmg*MYCONJG(sch)
                  else
                    scht = scht + matngmatmgp*sch
                  endif 

                enddo ! loop over g

              else

                do ig = 1, igmax

! Here we recompute Omega2 = wtilde2 * I_eps_array. This contains
! the factor of (1 - i tan phi) from Eqs. 21 & 22 of arXiv paper.

!FIXME: Here we use wtilde_array and I_eps_array directly while in the
! previous sections we use temporary variables wtilde, wtilde2, Omega2.
! JRD, please write a comment here explaining whether this is critical
! for performance or it doesn`t matter.
            
! Cycle bad for vectorization. Not needed witlde is zero
                  !if (abs((wtilde_array(ig,my_igp)**2) * I_eps_array(ig,my_igp)) .lt. TOL_Zero) cycle

                  wdiff = wxt - wtilde_array(ig,my_igp)

                  cden = wdiff
                  rden = cden * CONJG(cden)
                  rden = 1D0 / rden
                  delw = wtilde_array(ig,my_igp) * CONJG(cden) * rden
                  delwr = delw*CONJG(delw)
                  wdiffr = wdiff*CONJG(wdiff)

! JRD: This if is OK for vectorization
                  if (wdiffr.gt.limittwo .and. delwr.lt.limitone) then
                    scht = scht + mygpvar1 * aqsntemp(ig,n1) * delw * I_eps_array(ig,my_igp)
                  endif

                enddo ! loop over g

              endif

              sch_array(iw) = sch_array(iw) + 0.5D0*scht

            enddo

          endif

! If a valence band, then accumulate SX contribution.

          if (flag_occ) then
            do iw=nstart,nend
              asxtemp(iw) = asxtemp(iw) - ssx_array(iw) * occ * vcoul(igp)
            enddo
          endif

! Accumulate CH contribution.

          do iw=nstart,nend
            achtemp(iw) = achtemp(iw) + sch_array(iw) * vcoul(igp)
          enddo

! Logging CH convergence.

          acht_n1_loc(n1true) = acht_n1_loc(n1true) + sch_array(2) * vcoul(igp)

        enddo ! igp
!$OMP END DO
        SAFE_DEALLOCATE(ssx_array)
        SAFE_DEALLOCATE(sch_array)
!$OMP END PARALLEL
        call timacc(52,2)
      enddo ! over ipe bands (n1)
    enddo ! over ipe

    do iw=nstart,nend
      asxt(iw) = asxt(iw) + asxtemp(iw)
      acht(iw) = acht(iw) + achtemp(iw)
    enddo

    if (sig%exact_ch .eq. 1) then
      achtcor = achtcor + 0.5d0 * (achxtemp - achstemp)
    endif

    SAFE_DEALLOCATE(aqsntemp)
    SAFE_DEALLOCATE(aqsmtemp)
    SAFE_DEALLOCATE(I_eps_array)
    SAFE_DEALLOCATE(wtilde_array)

    if (sig%ggpsum.eq.1) then
      ncouls2 = ncouls**2/2
    else
      ncouls2 = ncouls**2
    endif

! JRD group comm

#ifdef MPI
    if (peinf%my_pool .ne. -1) then
      call MPI_REDUCE(cycle_count,cycle_count_total,1,MPI_INTEGER8,MPI_SUM, 0,peinf%pool_comm,mpierr)
    endif
#endif

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  else if (sig%freq_dep .eq. 2) then

    asxDtemp(:) = (0.0d0,0.0d0)
    achDtemp(:) = (0.0d0,0.0d0)
    achDtemp_cor(:) = (0.0d0,0.0d0)
    achDtemp_corb(:) = (0.0d0,0.0d0)
    ach2Dtemp(:) = (0.0d0,0.0d0)
    if (sig%exact_ch.eq.1) achsDtemp = (0.0d0, 0.0d0)

    SAFE_ALLOCATE(aqsntemp,(ncouls,peinf%ntband_max))
    SAFE_ALLOCATE(aqsmtemp,(ncouls,peinf%ntband_max))

    do ipe = 1, peinf%npes_pool

      call timacc(43,1)

      if (peinf%pool_rank .eq. ipe-1) then
        aqsntemp(:,:) = aqsn(1:ncouls,:)
        aqsmtemp(:,:) = aqsm(1:ncouls,:)
      endif

! JRD BCAST in just pool

#ifdef MPI
      if (peinf%my_pool .ne. -1) then
        call MPI_Bcast(aqsntemp,peinf%ntband_max*ncouls,MPI_SCALAR,ipe-1,peinf%pool_comm,mpierr)
        call MPI_Bcast(aqsmtemp,peinf%ntband_max*ncouls,MPI_SCALAR,ipe-1,peinf%pool_comm,mpierr)
      endif
#endif

      call timacc(43,2)

      do n1=1,peinf%ntband_dist(ipe)

! n1true = "True" band index of the band n1 w.r.t. all bands

        call timacc(51,1)

        n1true = peinf%indext_dist(n1,ipe)

! energy of the |n1,k-q> state

        e_n1kq = wfnkq%ekq(n1true,ispin)

! occupation of the |n1,k-q> state

        flag_occ = (n1true.le.(sig%nvband+sig%ncrit)) &
          .and.((sig%ncrit.eq.0).or.(e_n1kq.le.(sig%efermi+sig%tol)))
          
        tempval=abs(e_n1kq-sig%efermi)
        if (tempval .lt. sig%tol) then
          occ = 0.5d0 ! Fermi-Dirac distribution = 1/2 at Fermi level
        else
          occ = 1.0d0
        endif

! JRD: Find iw closest to e_lk

        diffmin = INF
        do iw=1,sig%nfreqeval
          diff = abs(sig%freqevalmin + (iw-1)*sig%freqevalstep - e_lk)
          if (diff .lt. diffmin) then
            diffmin=diff
            iwlda=iw
          endif
        enddo

        do iw=1,sig%nfreqeval
          wx = sig%freqevalmin - e_n1kq + (iw-1)*sig%freqevalstep
          wxi(iw) = wx
        enddo

! (gsm) compute the static CH for the static remainder

!$OMP PARALLEL do private (my_igp,igp,indigp,igmax,mygpvar1,ig)
        do my_igp = 1, ngpown
          indigp = inv_igp_index(my_igp)
          igp = indinv(indigp)

          if (igp .gt. ncouls .or. igp .le. 0) cycle

          igmax=ncouls

          mygpvar1 = MYCONJG(aqsmtemp(igp,n1))

          do ig = 1, igmax
            matngmatmgpD(ig,my_igp) = aqsntemp(ig,n1) * mygpvar1
          enddo
        enddo
!$OMP END PARALLEL DO

        if (sig%exact_ch.eq.1) then
!$OMP PARALLEL do private (my_igp,igp,indigp,igmax,ig, &
!$OMP                      schsDtemp ) reduction(+:achsDtemp)
          do my_igp = 1, ngpown
            indigp = inv_igp_index(my_igp)
            igp = indinv(indigp)

            if (igp .gt. ncouls .or. igp .le. 0) cycle

            igmax=ncouls

            schsDtemp = ZERO
            do ig = 1, igmax
              schsDtemp = schsDtemp-matngmatmgpD(ig,my_igp)*I_epsR_array(ig,my_igp,1)
              !schsDtemp = schsDtemp-matngmatmgpD(ig,my_igp)*I_epsR_array(1,ig,my_igp)
            enddo
            achsDtemp = achsDtemp + schsDtemp*vcoul(igp)*0.5D0
          enddo
!$OMP END PARALLEL DO
        endif

        ssxDi = (0D0,0D0)
        schDi = (0D0,0D0)
        schDi_cor = (0D0,0D0)
        schDi_corb = (0D0,0D0)
        sch2Di = (0D0,0D0)

        call timacc(51,2)

! JRD: Don`t want to thread here, nfreqeval could be small
        do iw=1,sig%nfreqeval
            
          wx = wxi(iw)

! SX and CH terms: equation (1.42) of Catalin`s thesis
! Note the negative sign in I_epsRggp and I_epsAggp

          if (flag_occ) then

            if(wx.ge.0.0d0) then
              ifreq=0
              do ijk = 1, sig%nFreq-1
                if (wx .ge. sig%dFreqGrid(ijk) .and. wx .lt. sig%dFreqGrid(ijk+1)) then
                  ifreq=ijk
                endif
              enddo
              if (ifreq .eq. 0) then
                ifreq = sig%nFreq+3 ! three is for luck
              endif
            else
              ifreq=0
              do ijk = 1, sig%nFreq-1
                if (-wx .ge. sig%dFreqGrid(ijk) .and. -wx .lt. sig%dFreqGrid(ijk+1)) then
                  ifreq=ijk
                endif
              enddo
              if (ifreq .eq. 0) then
                ifreq = sig%nFreq+3 ! three is for luck
              endif
            endif
              
            if(ifreq.ge.sig%nFreq) then
              write(0,777) iband,n1true,e_lk,e_n1kq,wx,E_max
              ifreq=sig%nFreq-1
            endif
777         format(1x,"WARNING: The real frequency range is too small." &
              ,/,3x,"l =",i3,1x,"n1 =",i5,1x,"E_l =",f8.3,1x,"E_n1" &
              ,1x,"=",f8.3,1x,"wx =",f8.3,1x,"E_max =",f8.3)
              
#ifdef CPLX
            if(wx.ge.0.d0) then

              call timacc(53,1)

              fact1 = (sig%dFreqGrid(ifreq+1)-wx)/(sig%dFreqGrid(ifreq+1)-sig%dFreqGrid(ifreq))
              fact2 = (wx-sig%dFreqGrid(ifreq))/(sig%dFreqGrid(ifreq+1)-sig%dFreqGrid(ifreq))

              ssxDittt = 0D0

!$OMP PARALLEL do private (my_igp,igp,indigp,igmax,ssxDitt,ig, &
!$OMP                       ssxDit) reduction(+:ssxDittt)
              do my_igp = 1, ngpown
                indigp = inv_igp_index(my_igp)
                igp = indinv(indigp)

                if (igp .gt. ncouls .or. igp .le. 0) cycle

                igmax=ncouls

                ssxDitt = (0D0,0D0)
                do ig = 1, igmax
                  ssxDit=I_epsR_array(ig,my_igp,ifreq)*fact1 + &
                  I_epsR_array(ig,my_igp,ifreq+1)*fact2 
                  !ssxDit=I_epsR_array(ifreq,ig,my_igp)*fact1 + &
                  !I_epsR_array(ifreq+1,ig,my_igp)*fact2 
 
                  ssxDitt = ssxDitt + matngmatmgpD(ig,my_igp)*ssxDit
                enddo
                ssxDittt = ssxDittt + ssxDitt*vcoul(igp)
              enddo
!$OMP END PARALLEL DO

              ssxDi(iw) = ssxDi(iw) + ssxDittt

              call timacc(53,2)

            else

              call timacc(53,1)

              fact1 = (sig%dFreqGrid(ifreq+1)+wx)/(sig%dFreqGrid(ifreq+1)-sig%dFreqGrid(ifreq))
              fact2 = (-sig%dFreqGrid(ifreq)-wx)/(sig%dFreqGrid(ifreq+1)-sig%dFreqGrid(ifreq))

              ssxDittt = 0D0

!$OMP PARALLEL do private (my_igp,igp,indigp,igmax,ssxDitt,ig, &
!$OMP                       ssxDit) reduction(+:ssxDittt)
              do my_igp = 1, ngpown
                indigp = inv_igp_index(my_igp)
                igp = indinv(indigp)

                if (igp .gt. ncouls .or. igp .le. 0) cycle

                igmax=ncouls

                ssxDitt = (0D0,0D0)
                do ig = 1, igmax
                  ssxDit=I_epsA_array(ig,my_igp,ifreq)*fact1+ &
                    I_epsA_array(ig,my_igp,ifreq+1)*fact2
                  !ssxDit=I_epsA_array(ifreq,ig,my_igp)*fact1+ &
                  !  I_epsA_array(ifreq+1,ig,my_igp)*fact2

                  ssxDitt = ssxDitt + matngmatmgpD(ig,my_igp)*ssxDit
                enddo
                ssxDittt = ssxDittt + ssxDitt*vcoul(igp)
              enddo                
!$OMP END PARALLEL DO

              ssxDi(iw) = ssxDi(iw) + ssxDittt

              call timacc(53,2)

            endif
#else
            if(wx.ge.0.d0) then

              call timacc(53,1)

              fact1 = (sig%dFreqGrid(ifreq+1)-wx)/(sig%dFreqGrid(ifreq+1)-sig%dFreqGrid(ifreq))
              fact2 = (wx-sig%dFreqGrid(ifreq))/(sig%dFreqGrid(ifreq+1)-sig%dFreqGrid(ifreq))

              ssxDittt = 0D0

!$OMP PARALLEL do private (my_igp,igp,indigp,igmax,ssxDitt,ig, &
!$OMP                       ssxDit) reduction(+:ssxDittt)
              do my_igp = 1, ngpown
                indigp = inv_igp_index(my_igp)
                igp = indinv(indigp)

                if (igp .gt. ncouls .or. igp .le. 0) cycle

                igmax=ncouls

                ssxDitt = (0D0,0D0)
                do ig = 1, igmax
                  ssxDit=I_epsR_array(ig,my_igp,ifreq)*fact1+ &
                    I_epsR_array(ig,my_igp,ifreq+1)*fact2
                  !ssxDit=I_epsR_array(ifreq,ig,my_igp)*fact1+ &
                  !  I_epsR_array(ifreq+1,ig,my_igp)*fact2
                  ssxDitt = ssxDitt + matngmatmgpD(ig,my_igp)*ssxDit
                enddo
                ssxDittt = ssxDittt + ssxDitt * vcoul(igp)
              enddo
!$OMP END PARALLEL DO

              ssxDi(iw) = ssxDi(iw) + ssxDittt

              call timacc(53,2)

            else

              call timacc(53,1)

              fact1 = (sig%dFreqGrid(ifreq+1)+wx)/(sig%dFreqGrid(ifreq+1)-sig%dFreqGrid(ifreq))
              fact2 = (-sig%dFreqGrid(ifreq)-wx)/(sig%dFreqGrid(ifreq+1)-sig%dFreqGrid(ifreq))

              ssxDittt = 0D0

!$OMP PARALLEL do private (my_igp,igp,indigp,igmax,ssxDitt,ig, &
!$OMP                       ssxDit) reduction(+:ssxDittt) 
              do my_igp = 1, ngpown
                indigp = inv_igp_index(my_igp)
                igp = indinv(indigp)

                if (igp .gt. ncouls .or. igp .le. 0) cycle

                igmax=ncouls

                ssxDitt = (0D0,0D0)
                do ig = 1, igmax
                  ssxDit=CONJG(I_epsR_array(ig,my_igp,ifreq))*fact1 + &
                    CONJG(I_epsR_array(ig,my_igp,ifreq+1))*fact2
                  !ssxDit=CONJG(I_epsR_array(ifreq,ig,my_igp))*fact1 + &
                  !  CONJG(I_epsR_array(ifreq+1,ig,my_igp))*fact2
                  ssxDitt = ssxDitt + matngmatmgpD(ig,my_igp)*ssxDit
                enddo
                ssxDittt = ssxDittt + ssxDitt * vcoul(igp)
              enddo
!$OMP END PARALLEL DO

              ssxDi(iw) = ssxDi(iw) + ssxDittt

              call timacc(53,2)
            endif
#endif
          endif
        enddo

! JRD: Now do CH term
          
        call timacc(49,1)

        SAFE_ALLOCATE(schDt_array,(sig%Nfreq))
        schDt_array(:) = 0D0
 
        call timacc(52,1)

!$OMP PARALLEL do private (my_igp,igp,indigp,igmax,ig,schDtt,I_epsRggp_int, &
!$OMP                      I_epsAggp_int,schD,schDt)
        do ifreq=1,sig%Nfreq

            schDt = (0D0,0D0)

            do my_igp = 1, ngpown
              indigp = inv_igp_index(my_igp)
              igp = indinv(indigp)

              if (igp .gt. ncouls .or. igp .le. 0) cycle

              igmax=ncouls

! JRD: The below loop is performance critical

              schDtt = (0D0,0D0)
              do ig = 1, igmax

                I_epsRggp_int = I_epsR_array(ig,my_igp,ifreq)
                !I_epsRggp_int = I_epsR_array(ifreq,ig,my_igp)

#ifdef CPLX
                I_epsAggp_int = I_epsA_array(ig,my_igp,ifreq)
                !I_epsAggp_int = I_epsA_array(ifreq,ig,my_igp)

                ! for G,G` components
                schD=I_epsRggp_int-I_epsAggp_int

                ! for G`,G components
                schDtt = schDtt + matngmatmgpD(ig,my_igp)*schD
#else
                schD= CMPLX(IMAG(I_epsRggp_int),0.0d0)
                schDtt = schDtt + matngmatmgpD(ig,my_igp)*schD
#endif
              enddo
              schDt = schDt + schDtt * vcoul(igp)
            enddo

! XXX: Threads could be stomping on each-other`s cache over this... try reduction?
            schdt_array(ifreq) = schDt

        enddo
!$OMP END PARALLEL DO

        call timacc(52,2)

!$OMP PARALLEL do private (ifreq,schDt,cedifft_zb,cedifft_coh,cedifft_cor, &
!$OMP                      cedifft_zb_right,cedifft_zb_left,schDt_right,schDt_left, &
!$OMP                      schDt_avg,schDt_lin,schDt_lin2,intfact,iw, &
!$OMP                      schDt_lin3) reduction(+:schDi,schDi_corb,schDi_cor,sch2Di) 
        do ifreq=1,sig%Nfreq

            schDt = schDt_array(ifreq)

            cedifft_zb = sig%dFreqGrid(ifreq)
            cedifft_coh = CMPLX(cedifft_zb,0D0)- sig%dFreqBrd(ifreq)

            if( flag_occ) then 
              cedifft_cor = -1.0d0*CMPLX(cedifft_zb,0D0) - sig%dFreqBrd(ifreq)
            else
              cedifft_cor = CMPLX(cedifft_zb,0D0) - sig%dFreqBrd(ifreq)
            endif

            if (ifreq .ne. 1) then 
              cedifft_zb_right = cedifft_zb
              cedifft_zb_left = sig%dFreqGrid(ifreq-1)
              schDt_right = schDt
              schDt_left = schDt_array(ifreq-1)
              schDt_avg = 0.5D0 * ( schDt_right + schDt_left )
              schDt_lin = schDt_right - schDt_left
              schDt_lin2 = schDt_lin/(cedifft_zb_right-cedifft_zb_left)
            endif

#ifdef CPLX
! The below two lines are for sigma1 and sigma3
            if (ifreq .ne. sig%Nfreq) then
              schDi(:) = schDi(:) - CMPLX(0.d0,pref(ifreq)) * schDt / ( wxi(:)-cedifft_coh)
              schDi_corb(:) = schDi_corb(:) - CMPLX(0.d0,pref(ifreq)) * schDt / ( wxi(:)-cedifft_cor)
            endif
            if (ifreq .ne. 1) then
              do iw = 1, sig%nfreqeval
!These lines are for sigma2
                intfact=abs((wxi(iw)-cedifft_zb_right)/(wxi(iw)-cedifft_zb_left))
                if (intfact .lt. 1d-4) intfact = 1d-4
                if (intfact .gt. 1d4) intfact = 1d4
                intfact = -log(intfact)
                sch2Di(iw) = sch2Di(iw) - CMPLX(0.d0,pref_zb) * schDt_avg * intfact
!These lines are for sigma4
                if (flag_occ) then
                  intfact=abs((wxi(iw)+cedifft_zb_right)/(wxi(iw)+cedifft_zb_left))
                  if (intfact .lt. 1d-4) intfact = 1d-4
                  if (intfact .gt. 1d4) intfact = 1d4
                  intfact = log(intfact)
                  schDt_lin3 = (schDt_left + schDt_lin2*(-wxi(iw)-cedifft_zb_left))*intfact
                else 
                  schDt_lin3 = (schDt_left + schDt_lin2*(wxi(iw)-cedifft_zb_left))*intfact
                endif
                schDt_lin3 = schDt_lin3 + schDt_lin
                schDi_cor(iw) = schDi_cor(iw) - CMPLX(0.d0,pref_zb) * schDt_lin3
              enddo
            endif
#else
! The below two lines are for sigma1 and sigma3
            if (ifreq .ne. sig%Nfreq) then
              schDi(:) = schDi(:) + pref(ifreq)*schDt / ( wxi(:)-cedifft_coh)
              schDi_corb(:) = schDi_corb(:) + pref(ifreq)*schDt / ( wxi(:)-cedifft_cor)
            endif
            if (ifreq .ne. 1) then
              do iw = 1, sig%nfreqeval
!These lines are for sigma2
                intfact=abs((wxi(iw)-cedifft_zb_right)/(wxi(iw)-cedifft_zb_left))
                if (intfact .lt. 1d-4) intfact = 1d-4
                if (intfact .gt. 1d4) intfact = 1d4
                intfact = -log(intfact)
                sch2Di(iw) = sch2Di(iw) + pref_zb * schDt_avg * intfact
!These lines are for sigma4
                if (flag_occ) then
                  intfact=abs((wxi(iw)+cedifft_zb_right)/(wxi(iw)+cedifft_zb_left))
                  if (intfact .lt. 1d-4) intfact = 1d-4
                  if (intfact .gt. 1d4) intfact = 1d4
                  intfact = log(intfact)
                  schDt_lin3 = (schDt_left + schDt_lin2*(-wxi(iw)-cedifft_zb_left))*intfact
                else
                  schDt_lin3 = (schDt_left + schDt_lin2*(wxi(iw)-cedifft_zb_left))*intfact
                endif
                schDt_lin3 = schDt_lin3 + schDt_lin
                schDi_cor(iw) = schDi_cor(iw) + pref_zb * schDt_lin3
              enddo
            endif
#endif
        enddo
!$OMP END PARALLEL DO

        SAFE_DEALLOCATE(schDt_array)

        call timacc(49,2)

! JRD: Compute Sigma2 and Sigma4 delta function contributions

        call timacc(50,1)

        do iw = 1, sig%nfreqeval
          wx = wxi(iw)
          if(wx .ge. 0.0d0) then
            ifreq=0
            do ijk = 1, sig%nFreq-1
              if (wx .ge. sig%dFreqGrid(ijk) .and. wx .lt. sig%dFreqGrid(ijk+1)) then
                ifreq=ijk
              endif
            enddo
            if (ifreq .eq. 0) then
              ifreq=sig%nFreq-1
            endif

            fact1=(sig%dFreqGrid(ifreq+1)-wx)/(sig%dFreqGrid(ifreq+1)-sig%dFreqGrid(ifreq))
            fact2=(wx-sig%dFreqGrid(ifreq))/(sig%dFreqGrid(ifreq+1)-sig%dFreqGrid(ifreq))

            schDttt = 0D0
            schDttt_cor = 0D0

!$OMP PARALLEL do private (my_igp,igp,indigp,igmax,ig, &
!$OMP                      sch2Dt,sch2Dtt) reduction(+:schDttt,schDttt_cor) 
            do my_igp = 1, ngpown
              indigp = inv_igp_index(my_igp)
              igp = indinv(indigp)

              if (igp .gt. ncouls .or. igp .le. 0) cycle

              igmax=ncouls

              sch2Dtt = (0D0,0D0)
              do ig = 1, igmax
#ifdef CPLX
                sch2Dt=-0.5D0*((I_epsR_array(ig,my_igp,ifreq)-I_epsA_array(ig,my_igp,ifreq))*fact1 + &
                       (I_epsR_array(ig,my_igp,ifreq+1)-I_epsA_array(ig,my_igp,ifreq+1))*fact2)
                !sch2Dt=-0.5D0*((I_epsR_array(ifreq,ig,my_igp)-I_epsA_array(ifreq,ig,my_igp))*fact1 + &
                !       (I_epsR_array(ifreq+1,ig,my_igp)-I_epsA_array(ifreq+1,ig,my_igp))*fact2)
#else
                sch2Dt = CMPLX(0D0,-1D0)* &
                  (IMAG(I_epsR_array(ig,my_igp,ifreq))*fact1 + IMAG(I_epsR_array(ig,my_igp,ifreq+1))*fact2)
                !sch2Dt = CMPLX(0D0,-1D0)* &
                !  (IMAG(I_epsR_array(ifreq,ig,my_igp))*fact1 + IMAG(I_epsR_array(ifreq+1,ig,my_igp))*fact2)
#endif
                sch2Dtt = sch2Dtt + matngmatmgpD(ig,my_igp)*sch2Dt
              enddo
              schDttt = schDttt + sch2Dtt*vcoul(igp)
              if (flag_occ) then
              else
                schDttt_cor = schDttt_cor + sch2Dtt*vcoul(igp)
              endif
            enddo
!$OMP END PARALLEL DO

            sch2Di(iw) = sch2Di(iw) + schDttt
            schDi_cor(iw) = schDi_cor(iw) + schDttt_cor
          else if (flag_occ) then
            wx=-wx
            ifreq=0
            do ijk = 1, sig%nFreq-1
              if (wx .ge. sig%dFreqGrid(ijk) .and. wx .lt. sig%dFreqGrid(ijk+1)) then
                ifreq=ijk
              endif
            enddo
            if (ifreq .eq. 0) then
              ifreq=sig%nFreq-1
            endif

            fact1=(sig%dFreqGrid(ifreq+1)-wx)/(sig%dFreqGrid(ifreq+1)-sig%dFreqGrid(ifreq))
            fact2=(wx-sig%dFreqGrid(ifreq))/(sig%dFreqGrid(ifreq+1)-sig%dFreqGrid(ifreq))

            schDttt_cor = 0D0

!$OMP PARALLEL do private (my_igp,igp,indigp,igmax,ig, &
!$OMP                      sch2Dt,sch2Dtt) reduction(+:schDttt_cor) 
            do my_igp = 1, ngpown
              indigp = inv_igp_index(my_igp)
              igp = indinv(indigp)

              if (igp .gt. ncouls .or. igp .le. 0) cycle

              igmax=ncouls

              sch2Dtt = (0D0,0D0)
              do ig = 1, igmax
#ifdef CPLX
                sch2Dt=-0.5D0*((I_epsR_array(ig,my_igp,ifreq)-I_epsA_array(ig,my_igp,ifreq))*fact1 + &
                       (I_epsR_array(ig,my_igp,ifreq+1)-I_epsA_array(ig,my_igp,ifreq+1))*fact2)
                !sch2Dt=-0.5D0*((I_epsR_array(ifreq,ig,my_igp)-I_epsA_array(ifreq,ig,my_igp))*fact1 + &
                !       (I_epsR_array(ifreq+1,ig,my_igp)-I_epsA_array(ifreq+1,ig,my_igp))*fact2)
#else
                sch2Dt = CMPLX(0D0,-1D0)* &
                  (IMAG(I_epsR_array(ig,my_igp,ifreq))*fact1 + IMAG(I_epsR_array(ig,my_igp,ifreq+1))*fact2)
                !sch2Dt = CMPLX(0D0,-1D0)* &
                !  (IMAG(I_epsR_array(ifreq,ig,my_igp))*fact1 + IMAG(I_epsR_array(ifreq+1,ig,my_igp))*fact2)
#endif
                sch2Dtt = sch2Dtt + matngmatmgpD(ig,my_igp)*sch2Dt
              enddo
              schDttt_cor = schDttt_cor + sch2Dtt*vcoul(igp)
            enddo
!$OMP END PARALLEL DO
            schDi_cor(iw) = schDi_cor(iw) + schDttt_cor
          endif
        enddo

        call timacc(50,2)

        do iw = 1, sig%nfreqeval
            
          if (flag_occ) then
            asxDtemp(iw) = asxDtemp(iw) + ssxDi(iw)*occ
          endif
            
          achDtemp(iw) = achDtemp(iw) + schDi(iw)
          achDtemp_cor(iw) = achDtemp_cor(iw) + schDi_cor(iw)
          achDtemp_corb(iw) = achDtemp_corb(iw) + schDi_corb(iw)
          ach2Dtemp(iw) = ach2Dtemp(iw) + sch2Di(iw)
  
! JRD: This is now close to LDA

          if (iw.eq.iwlda) achtD_n1(n1true) = &
            achtD_n1(n1true) + schDi(iw)

        enddo ! over iw
          
      enddo ! over bands (n1)
    enddo ! over bands (ipe)

    do iw=1,sig%nfreqeval
      asxtDyn(iw) = asxtDyn(iw) + asxDtemp(iw)
      achtDyn(iw) = achtDyn(iw) + achDtemp(iw)
      achtDyn_cor(iw) = achtDyn_cor(iw) + achDtemp_cor(iw)
      achtDyn_corb(iw) = achtDyn_corb(iw) + achDtemp_corb(iw)
      ach2tDyn(iw) = ach2tDyn(iw) + ach2Dtemp(iw)
    enddo

!------------------------
! (gsm) compute the static remainder
!       a factor of 0.5 accounts for the fact that GPP/FF CH converges
!       with the number of empty bands two times faster than COHSEX CH

    if (sig%exact_ch .eq. 1) then
      achtcor = achtcor + 0.5d0 * (achxtemp - SCALARIFY(achsDtemp))
    endif

    SAFE_DEALLOCATE(I_epsR_array)
#ifdef CPLX
    SAFE_DEALLOCATE(I_epsA_array)
#endif
    SAFE_DEALLOCATE(matngmatmgpD)
    SAFE_DEALLOCATE(matngpmatmgD)

    SAFE_DEALLOCATE(aqsntemp)
    SAFE_DEALLOCATE(aqsmtemp)

  endif ! Freq Dependence

!-----------------------
! Deallocate and Finish

  if (sig%freq_dep.eq.1 .or.sig%freq_dep.eq.3) then
    SAFE_DEALLOCATE(wx_array)
    if (sig%fdf.eq.-3) then
      SAFE_DEALLOCATE(wxi)
    endif
  endif 

  if (sig%freq_dep.eq.1 .or. sig%freq_dep.eq.0 .or. sig%freq_dep.eq.3)  then
    SAFE_DEALLOCATE(asxtemp)
    SAFE_DEALLOCATE(achtemp)
    acht_n1(1:sig%ntband) = acht_n1_loc(1:sig%ntband)
  endif

  if (sig%freq_dep.eq.2) then
    SAFE_DEALLOCATE(pref)
    SAFE_DEALLOCATE(asxDtemp)
    SAFE_DEALLOCATE(achDtemp)
    SAFE_DEALLOCATE(achDtemp_cor)
    SAFE_DEALLOCATE(achDtemp_corb)
    SAFE_DEALLOCATE(ach2Dtemp)
    SAFE_DEALLOCATE(schDi)
    SAFE_DEALLOCATE(schDi_cor)
    SAFE_DEALLOCATE(schDi_corb)
    SAFE_DEALLOCATE(sch2Di)
    SAFE_DEALLOCATE(ssxDi)
    SAFE_DEALLOCATE(wxi)
  endif

  POP_SUB(mtxel_sxch)
  
  return
end subroutine mtxel_sxch

end module mtxel_sxch_m

!============================================================================
!
! MODULE: fixwings_m
!
!> Rescale epsmat to make it compatible with W averaging
!
! DESCRIPTION:
!> This module contains routines to rescale the wings and \b head of the
!! epsilon matrix so that later we can compute <W> = <epsinv(q) * v(q)>.
!! Note that <W> should take into consideration the analytical form of epsmat(q)
!! and v(q) for small q, for each type of truncation/screening.
!
! REVISION HISTORY:
!  15 Jan 2009 - Initial version (JRD and GSM)
!  13 Oct 2011 - Renamed internal variables (FHJ)
!
! (1) fixwings()        Originally by JRD       Last Modified: 2/09/2009 (JRD)
!
! (2) fixwings_dyn()    Originally by GSM       Last Modified: 15/09/2009 (JRD)
!
!============================================================================

#include "f_defs.h"

module fixwings_m

  use global_m
  implicit none

  private

  public ::       &
    fixwings,     &
    fixwings_dyn

contains

  !> Despite its name, this routine fixes both the wings and \b head of the
  !!   GPP epsmat. The goal is to rescale epsmat so that we get the appropriate
  !!   W averaging, i.e., \f$ W_0 = \varepsilon^{-1}(q) v(q) \f$.
  !! 
  !! \param vcoul Bare potential (v) for the given q point, taking into 
  !!   consideration the truncation. For 3D SC, this should be 8*PI/q^2
  !! \param wcoul0 Screened potential W_0. This is actually the value that W_0
  !!   should have, and \f$\varepsilon^{-1}(q)\f$ is rescaled in this function so
  !!   that \f$W_0 = \varepsilon^{-1}(q) v(q)\f$
  !! \param epstemp A specific column (#icol::icol) of the dielectric matrix,
  !!   for a specific q point
  !! \param icutv Truncation
  !! \param iscreen Screening type
  !! \param icol Column of the whole dielectric constant that we are dealing with
  !! \param nmtx Number of cols/rows in the epsmat
  !! \param irow_G0 Which row of epstmp represents the G=0 vector?
  !! \param oneoverq WARNING: This is actually 8*PI/q!!!
  !! \param q0flag Is this the q0 point?
  !! \param averagew Should we do W averaging?
  !! \param bdot Reciprocal metric
  !!
  !! \sa fixwings_dyn - the FF version

  subroutine fixwings(vcoul,wcoul0,epstemp,icutv,iscreen, &
    icol,nmtx,irow_G0,q0len,oneoverq,fact,q0flag,averagew,bdot)

    use global_m
    implicit none
    
    integer, intent(in) :: icol,nmtx,irow_G0,iscreen,icutv
    real(DP), intent(in) :: vcoul,oneoverq,q0len,fact
    SCALAR, intent(inout) :: epstemp(nmtx)
    SCALAR, intent(in) ::  wcoul0
    logical, intent(in) :: q0flag,averagew
    real(DP), intent(in) :: bdot(3,3)
  
    integer :: i
    real(DP) :: zc
    
!if irow_G0 < avgcut \=icol
!epstemp()*oneverq*q0len
!if icol < avgcut i\=icol
!epstemp(i)*oneoverq/(vcoul(icol)*qicol00)

!----------------------
! No Truncation

    PUSH_SUB(fixwings)
    
    if (icutv .eq. 0) then
      if (icol.ne.irow_G0) then ! wing` (Gp/=0)
        if (iscreen .eq. 0) then
          epstemp(irow_G0) = epstemp(irow_G0)*oneoverq*q0len/(8D0*PI_D)
        endif
        ! JRD Zero out q0 wings
        if (q0flag .and. iscreen .eq. 0) epstemp(irow_G0) = 0D0
      else
        do i=1,nmtx
          if (i .ne. irow_G0) then ! wing (G/=0)
            if (iscreen .eq. 0) then
              epstemp(i) = epstemp(i)*fact*oneoverq/(vcoul*q0len)
            endif
            if (iscreen .eq. 1) then
              epstemp(i) = epstemp(i)*fact*8D0*PI_D/(vcoul*q0len**2)
            endif
            ! JRD Zero out q0 wings
            if (q0flag .and. iscreen .eq. 0) epstemp(i) = 0D0
          else ! Head
            if (q0flag .and. averagew) then
               epstemp(i) = wcoul0/vcoul
            endif
          endif
        enddo
      endif
    endif
  
!----------------------
! Cell Wire Truncation
! May not be implemented correctly for graphene screening... I`m not even sure there is a 1D system with linear DOS...

    if (icutv .eq. 4) then
      if (icol.ne.irow_G0) then ! wing` (Gp/=0)
        ! JRD We zero q0 wings
        if (q0flag .and. iscreen .eq. 0) then
          epstemp(irow_G0) = 0d0
        endif
      else
        do i=1,nmtx
          if (i .ne. irow_G0) then ! wing (G/=0)
            ! JRD We zero q0 wings
            if (q0flag .and. iscreen .eq. 0) then
              epstemp(i) = 0d0
            endif
          else ! Head
            if (q0flag .and. averagew .and. iscreen .ne. 2) then
              epstemp(i) = wcoul0/vcoul
            endif
          endif
        enddo
      endif
    endif
    
!----------------------
! Cell Slab Truncation

    if (icutv .eq. 6) then

      zc=2D0*PI_D/(sqrt(bdot(3,3))*2D0)

      if (icol.ne.irow_G0) then ! wing` (Gp/=0)
        ! JRD We zero q0 wings
        if (q0flag .and. iscreen .eq. 0) epstemp(irow_G0) = 0d0
      else
        do i=1,nmtx
          if (i .ne. irow_G0) then ! wing (G/=0)
            if (iscreen .ne. 2) then
              epstemp(i) = epstemp(i) * 8D0 * PI_D * fact * zc &
                / (vcoul * q0len)
              ! JRD We zero q0 wings
              if (q0flag .and. iscreen .eq. 0) epstemp(i) = 0d0
            endif
          else ! Head
            if (q0flag .and. averagew .and. iscreen .ne. 2) then
               epstemp(i) = wcoul0/vcoul
            endif
          endif
        enddo
      endif
    endif

    POP_SUB(fixwings)
    
    return
  end subroutine fixwings

!============================================================================
  
  !> Full frequency version of #fixwings
  !! 
  !! \see fixwings - the GPP version

  subroutine fixwings_dyn(vcoul,epstemp,icutv,iscreen,icol, &
    nfreq,nmtx,irow_G0,q0len,oneoverq,fact,q0flag,bdot)

    use global_m
    implicit none

    integer, intent(in) :: icol,nfreq,nmtx,irow_G0,iscreen,icutv
    real(DP), intent(in) :: vcoul,oneoverq,q0len,fact
    complex(DPC), intent(inout) :: epstemp(nfreq,nmtx)
    logical, intent(in) :: q0flag
    real(DP), intent(in) :: bdot(3,3)

    real(DP) :: zc  
    integer :: i

!----------------------
! No Truncation
    
    PUSH_SUB(fixwings_dyn)
    
    if (icutv .eq. 0) then
      if (icol.ne.irow_G0) then
        if (iscreen .eq. 0) then
          epstemp(:,irow_G0) = epstemp(:,irow_G0)*oneoverq*q0len/(8D0*PI_D)
        endif
        if (q0flag .and. iscreen .eq. 0) then
          epstemp(:,irow_G0) = 0d0
        endif
      else
        do i=1,nmtx
          if (i .ne. irow_G0) then
            if (iscreen .eq. 0) then
              epstemp(:,i) = epstemp(:,i)*oneoverq*fact/(vcoul*q0len)
            endif
            if (iscreen .eq. 1) then
              epstemp(:,i) = epstemp(:,i)*fact*8D0*PI_D/(vcoul*q0len**2)
            endif
            if (q0flag .and. iscreen .eq. 0) then
              epstemp(:,i) = 0d0
            endif
          endif
        enddo
      endif
    endif

!----------------------
! Cell Wire Truncation
! May not be implemented correctly for graphene screening... I`m not even sure there is a 1D system with linear DOS...

    if (icutv .eq. 4) then
      if (icol.ne.irow_G0) then
        if (q0flag .and. iscreen .eq. 0) then
          epstemp(:,irow_G0) = 0d0
        endif
      else
        do i=1,nmtx
          if (i .ne. irow_G0) then
            if (q0flag .and. iscreen .eq. 0) then
              epstemp(:,i) = 0d0
            endif
          endif
        enddo
      endif
    endif

!----------------------
! Cell Slab Truncation

    zc=2D0*PI_D/(sqrt(bdot(3,3))*2D0)

    if (icutv .eq. 6) then
      if (icol.ne.irow_G0) then
        if (q0flag .and. iscreen .eq. 0) then
          epstemp(:,irow_G0) = 0d0
        endif
      else
        do i=1,nmtx
          if (i .ne. irow_G0) then
            if (iscreen .ne. 2) then
              epstemp(:,i) = epstemp(:,i) * 8D0 * PI_D * fact * zc &
                / (vcoul * q0len)
              if (q0flag .and. iscreen .eq. 0) then
                epstemp(:,i) = 0d0
              endif
            endif
          endif
        enddo
      endif
    endif
    
    POP_SUB(fixwings_dyn)
    
    return
  end subroutine fixwings_dyn
  
end module fixwings_m

!==============================================================================
!
! Routines:
!
! (1) bsewrite()        Originally By MLT       Last Modified 7/1/2008 (JRD)
!
!     input:  xct types
!            bsedbody,bsedhead,bsedwing,bsex
!     output: binary files "bsedmat", "bsexmat"
!
!     Write out all interaction matrices elements in "bsedmat", "bsexmat"
!
!     Since all PEs write into the same units, the access must be organized:
!     one PE at a time
!
!     It appears the imatrix code is: 1 dhead, 2 dwing, 3 dbody, 4 x
!
! (2) bse_hdf5_write()  Orgiginally By JRD      Last Modified 4/27/2012 (JRD)
!
!     hdf5 writer routine for bsemat.h5 files 
!
! (3) bse_hdf5_setup()  Orgiginally By JRD      Last Modified 4/27/2012 (JRD)
!
!     hdf5 setup routine for bsemat.h5 files 
!
!=============================================================================

#include "f_defs.h"

module bsewrite_m

#ifdef HDF5
  use hdf5
#endif
  use global_m
  use io_utils_m
  use kernel_io_m
  use wfn_rho_vxc_io_m
  implicit none

  public :: bsewrite
#ifdef HDF5
  public :: bse_hdf5_write, bse_hdf5_setup
#endif

  private

contains


subroutine bsewrite(xct,iownsize,bsedbody,bsedhead,bsex,kg,kp,gvec,syms,crys,&
    bsedwing,bset)
  type (xctinfo), intent(in) :: xct
  type (grid), intent(in) :: kg
  integer, intent(in) :: iownsize
  SCALAR, intent(in) :: bsedbody(:,:,:), bsedhead(:,:,:), &
    bsex(:,:,:) !< (iownsize*peinf%myown,xct%nspin,xct%nspin)
  type (kpoints), intent(in)  :: kp
  type (gspace), intent(in) :: gvec
  type (symmetry), intent(in) :: syms
  type (crystal), intent(in) :: crys
  SCALAR, intent(in), optional :: &
    bsedwing(:,:,:) !< (iownsize*peinf%myown,xct%nspin,xct%nspin)
  SCALAR, intent(in), optional :: &
    bset(:,:,:) !< (iownsize*peinf%myown,xct%nspin,xct%nspin)

  SCALAR, allocatable :: bsemt(:,:,:,:,:), bsemtt(:,:,:,:,:)
  SCALAR :: bsem

  integer :: nmatrices,imatrix,iunit,error
  integer :: ic,icp,ik,ikp,is1,is2,iv,ivp,it
  real(DP) :: bsedhm,bsedwm,bsedbm,bsexm,bsetm
  real(DP) :: bsedhmt,bsedwmt,bsedbmt,bsexmt,bsetmt
  real(DP) :: approx_sz
  type(progress_info) :: prog_info
  type(kernel_header_t) :: kernel_header

  PUSH_SUB(bsewrite)

  approx_sz = (xct%n1b_co*xct%n2b_co*xct%nkpt_co*xct%nspin + 8d0)**2 * 8d0
  approx_sz = SCALARSIZE * approx_sz / (1024d0 * 1024d0)

  if (peinf%inode .eq. 0) then
    write(6,'(1x,a)') 'Expected size of the BSE matrices:'
    write(6,'(1x,a,f15.3,a)') '  bsexmat: ', approx_sz, ' MB'
    write(6,'(1x,a,f15.3,a)') '  bsedmat: ', approx_sz*3, ' MB'
    write(6,*)
  endif

  if (present(bsedwing) .or. present(bset)) then
    nmatrices = 4
  else
    nmatrices = 3
  endif

! JRD: We Find Local Max of Head, Wing, Body, Exchange here...
  bsedhm=maxval(abs(bsedhead(:,:,:)))
  if (present(bsedwing)) bsedwm=maxval(abs(bsedwing(:,:,:)))
  bsedbm=maxval(abs(bsedbody(:,:,:)))
  bsexm=maxval(abs(bsex(:,:,:)))
  if (present(bset)) bsetm=maxval(abs(bset(:,:,:)))

#ifdef HDF5

  if(xct%use_hdf5) then
    call timacc(75,1)

    if (peinf%inode .eq. 0) then
      call bse_hdf5_setup(xct,kg)
    endif

#ifdef MPI
    call MPI_BARRIER(MPI_COMM_WORLD,mpierr)
#endif

    call timacc(75,2)
    call timacc(76,1)

    if (present(bsedwing)) then
      call bse_hdf5_write(xct,iownsize,1,bsedhead)
      call bse_hdf5_write(xct,iownsize,2,bsedwing)
      call bse_hdf5_write(xct,iownsize,3,bsedbody)
      call bse_hdf5_write(xct,iownsize,4,bsex)
    else
      call bse_hdf5_write(xct,iownsize,1,bsedhead)
      call bse_hdf5_write(xct,iownsize,2,bsedbody)
      call bse_hdf5_write(xct,iownsize,3,bsex)
      call bse_hdf5_write(xct,iownsize,4,bset)
    endif

    call h5close_f(error)
    call timacc(76,2)

  else
#endif

    SAFE_ALLOCATE(bsemt,(xct%nspin,xct%nspin,xct%n1b_co,xct%n2b_co,xct%nkpt_co))
    SAFE_ALLOCATE(bsemtt,(xct%nspin,xct%nspin,xct%n1b_co,xct%n2b_co,xct%nkpt_co))
    call init_mf_header_from_types(kernel_header%mf, 'KER', 0, VER_BSE, kp, gvec, syms, crys)
    call xctinfo_to_kernel_header(xct, kg%f, kernel_header, 0)
    if(peinf%inode .eq. 0 ) then
      call open_file(unit=11,file='bsedmat',form='unformatted',status='replace')
      call open_file(unit=12,file='bsexmat',form='unformatted',status='replace')
      if (present(bset)) &
        call open_file(unit=13,file='bsetmat',form='unformatted',status='replace')
    endif
    if (present(bsedwing)) then
      kernel_header%nmat = 3
    else
      kernel_header%nmat = 2
    endif
    call write_binary_kernel_header(11, kernel_header)
    kernel_header%nmat = 1
    call write_binary_kernel_header(12, kernel_header)
    if (present(bset)) then
      kernel_header%nmat = 1
      call write_binary_kernel_header(13, kernel_header)
    endif
    
    ! FHJ: this is to generate nice output / time estimate
    call progress_init(prog_info, 'writing out BSE matrices', 'records', &
      xct%nkpt_co*nmatrices*xct%n2b_co*xct%n1b_co)
    do imatrix = 1, nmatrices
      do ikp=1,xct%nkpt_co
        do icp=1,xct%n2b_co
          do ivp=1,xct%n1b_co
            call progress_step(prog_info)
            bsemt=0.d0
            do ik=1,xct%nkpt_co
              do ic=1,xct%n2b_co
                do iv=1,xct%n1b_co
                  
                  if (xct%icpar .eq. 0) then
                    it = peinf%wown(1,1,ikp,1,1,ik)
                    if (it .ne. 0) then 
                      it = peinf%wown(1,1,ikp,1,1,ik) + xct%n1b_co*xct%n1b_co*xct%n2b_co*(icp-1) &
                        + xct%n1b_co*xct%n1b_co*(ic-1) + xct%n1b_co*(ivp-1) + iv -1
                    endif
                  else if (xct%ivpar .eq. 0) then
                    it = peinf%wown(1,icp,ikp,1,ic,ik)
                    if (it .ne. 0) then
                      it = it + xct%n1b_co*(ivp-1) + iv -1
                    endif
                  else
                    it = peinf%wown(ivp,icp,ikp,iv,ic,ik) 
                  endif
                  
                  if (it .ne. 0) then
                    do is1=1,xct%nspin
                      do is2=1,xct%nspin
                        if (present(bsedwing)) then
                          if ( imatrix .eq. 1) then
                            bsem=bsedhead(it,is1,is2)
                          else if ( imatrix .eq. 2) then
                            bsem=bsedwing(it,is1,is2)
                          else if ( imatrix .eq. 3) then
                            bsem=bsedbody(it,is1,is2)
                          else if ( imatrix .eq. 4) then
                            bsem=bsex(it,is1,is2)
                          endif
                        else if (present(bset)) then
                          if ( imatrix .eq. 1) then
                            bsem=bsedhead(it,is1,is2)
                          else if ( imatrix .eq. 2) then
                            bsem=bsedbody(it,is1,is2)
                          else if ( imatrix .eq. 3) then
                            bsem=bsex(it,is1,is2)
                          else if ( imatrix .eq. 4) then
                            bsem=bset(it,is1,is2)
                          endif
                        endif
                        bsemt(is2,is1,iv,ic,ik) = bsem
                      enddo !is2
                    enddo !is1
                  endif
                enddo !iv
              enddo !ic
            enddo !ik
            bsemtt=0D0
            
            call timacc(75,1)
#ifdef MPI
            call MPI_REDUCE(bsemt(1,1,1,1,1),bsemtt(1,1,1,1,1),xct%nkpt_co*xct%n2b_co*xct%n1b_co*xct%nspin*xct%nspin, &
              MPI_SCALAR,MPI_SUM,0,MPI_COMM_WORLD,mpierr)
! JRD: This barrier may greatly decrease performance. Could hit buffer limit if don`t have it...
            call MPI_BARRIER(MPI_COMM_WORLD,mpierr)
#endif
            call timacc(75,2)
            call timacc(76,1)
            if (peinf%inode .eq. 0) then
              if (present(bsedwing)) then
                if ( imatrix .lt. 4) then
                  iunit = 11
                else if (imatrix .eq. 4) then
                  iunit = 12
                endif
              else
                if ( imatrix .lt. 3) then
                  iunit = 11
                else if (imatrix .eq. 3) then
                  iunit = 12
                else if (imatrix .eq. 4) then
                  iunit = 13
                endif
              endif
#ifdef MPI
              write(iunit) ikp,icp,ivp, bsemtt(:,:,:,:,:)
#else
              write(iunit) ikp,icp,ivp, bsemt(:,:,:,:,:)
#endif
            endif
            call timacc(76,2)
          enddo !ivp
        enddo !icp
      enddo !ikp
    enddo !imatrix
    call progress_free(prog_info)
    
    if(peinf%inode .eq. 0 ) then
      call close_file(11)
      call close_file(12)
      if (present(bset)) call close_file(13)
    endif
    
#ifdef HDF5
  endif
#endif

! JRD: Print out the maximum values of matrix elements found across PEs!
! bse*t are used to write matrix elements in the right format
!
! bse*m contain the maximum values (in absolute value) of each
! part of the kernel calculated by each PE. Their only purpose is
! to check if the matrix elements have the right order or
! magnitude.

#ifdef MPI
  call MPI_Barrier(MPI_COMM_WORLD,mpierr)
  call MPI_Reduce(bsedhm,bsedhmt,1,MPI_REAL_DP, &
    MPI_MAX,0,MPI_COMM_WORLD,mpierr)
  call MPI_Reduce(bsedbm,bsedbmt,1,MPI_REAL_DP, &
    MPI_MAX,0,MPI_COMM_WORLD,mpierr)
  if (present(bsedwing)) &
    call MPI_Reduce(bsedwm,bsedwmt,1,MPI_REAL_DP, &
    MPI_MAX,0,MPI_COMM_WORLD,mpierr)
  call MPI_Reduce(bsexm,bsexmt,1,MPI_REAL_DP, &
    MPI_MAX,0,MPI_COMM_WORLD,mpierr)
  if (present(bset)) &
    call MPI_Reduce(bsetm,bsetmt,1,MPI_REAL_DP, &
    MPI_MAX,0,MPI_COMM_WORLD,mpierr)
#else
  bsedhmt=bsedhm
  bsedbmt=bsedbm
  if (present(bsedwing)) bsedwmt=bsedwm
  bsexmt=bsexm
  if (present(bset)) bsetmt=bsetm
#endif

  if (peinf%inode.eq.0) then
    write(6,*)
    write(6,'(a,f22.15)') 'maximum: head  ',bsedhmt
    if (present(bsedwing))  write(6,'(a,f22.15)') '         wing  ',bsedwmt
    write(6,'(a,f22.15)') '         body  ',bsedbmt
    write(6,'(a,f22.15)') '         x     ',bsexmt
    if (present(bset))  write(6,'(a,f22.15)') '         wing  ',bsetmt
  endif

  if(.not. xct%use_hdf5) then
    SAFE_DEALLOCATE(bsemt)
    SAFE_DEALLOCATE(bsemtt)
  endif

  POP_SUB(bsewrite)
  
  return
end subroutine bsewrite

!============================================================================
!
! (2) bse_hdf5_write
!
!============================================================================

#ifdef HDF5
subroutine bse_hdf5_write(xct,iownsize,imatrix,bsemat)
  type (xctinfo), intent(in) :: xct
  integer, intent(in) :: iownsize
  integer, intent(in) :: imatrix
  SCALAR, intent(in) :: bsemat(:,:,:) !< (iownsize*peinf%myown,xct%nspin,xct%nspin)

  integer :: error, comm, info, rank, ik, ikp, ic, icp, iv, ivp
  integer :: it, ii, iit, is, isp
  integer(HID_T) :: file_id       ! File identifier
  integer(HID_T) :: dset_id       ! Dataset identifier
  integer(HID_T) :: filespace     ! Dataspace identifier in file
  integer(HID_T) :: memspace      ! Dataspace identifier in mem
#ifdef MPI
  integer(HID_T) :: plist_id      ! Property list identifier
#endif

  integer(HSIZE_T) :: count(7), countf(7), offset(7), offsetm(7)

  real(DP), allocatable :: data(:,:,:,:,:,:,:)

  PUSH_SUB(bse_hdf5_write)

#ifdef MPI
  comm = MPI_COMM_WORLD
  info = MPI_INFO_NULL
#endif

! JRD: Initialize rank

  rank = 7

! JRD: Open File and Grab dset_id for this matrix

#ifdef MPI
  call h5pcreate_f(H5P_FILE_ACCESS_F, plist_id, error)
  call h5pset_fapl_mpio_f(plist_id, comm, info, error)
  call h5fopen_f('bsemat.h5', H5F_ACC_RDWR_F, file_id, error, access_prp = plist_id)
  call h5pclose_f(plist_id,error)
#else
  call h5fopen_f('bsemat.h5', H5F_ACC_RDWR_F, file_id, error)
#endif

  if (xct%theory == 0) then
    if (imatrix .eq. 1) then
      call h5dopen_f(file_id, 'head', dset_id, error)    
    else if (imatrix .eq. 2) then
      call h5dopen_f(file_id, 'wing', dset_id, error)    
    else if (imatrix .eq. 3) then
      call h5dopen_f(file_id, 'body', dset_id, error)    
    else if (imatrix .eq. 4) then
      call h5dopen_f(file_id, 'exchange', dset_id, error)    
    endif
  else
    if (imatrix .eq. 1) then
      call h5dopen_f(file_id, 'head', dset_id, error)    
    else if (imatrix .eq. 2) then
      call h5dopen_f(file_id, 'body', dset_id, error)    
    else if (imatrix .eq. 3) then
      call h5dopen_f(file_id, 'exchange', dset_id, error)    
    else if (imatrix .eq. 4) then
      call h5dopen_f(file_id, 'fxc', dset_id, error)    
    endif
  endif

! JRD: Dumb Debugging

  !write(6,*) 'bs', peinf%inode, peinf%mypown, peinf%npown, peinf%nckpe,peinf%myown

#ifdef CPLX
  count(1) = 2
  countf(1) = 2
#else
  count(1) = 1
  countf(1) = 1
#endif

  if (xct%ivpar .eq. 0) then
    count(2) = xct%n1b_co
    count(3) = xct%n1b_co
    countf(2) = xct%n1b_co
    countf(3) = xct%n1b_co
  else
    count(3) = 1
    countf(3) = 1
    countf(2) = peinf%npown
    if (peinf%mypown .eq. 0) then
      count(2) = 1
    else
      count(2) = peinf%mypown
    endif
  endif

  if (xct%icpar .eq. 0) then
    count(4) = xct%n2b_co
    count(5) = xct%n2b_co
    countf(4) = xct%n2b_co
    countf(5) = xct%n2b_co
  else
    count(5) = 1
    countf(5) = 1
    if (xct%ivpar .eq. 1 .or. peinf%mypown .eq. 0) then
      count(4) = 1
    else
      count(4) = peinf%mypown
    endif
    if (xct%ivpar .eq. 1) then
      countf(4) = 1
    else
      countf(4) = peinf%npown
    endif
  endif

  count(7)=1
  countf(7)=1
  if (xct%icpar .eq. 1 .or. xct%ivpar .eq. 1 .or. peinf%mypown .eq. 0) then 
    count(6) = 1
  else
    count(6) = peinf%mypown
  endif
  if (xct%icpar .eq. 1 .or. xct%ivpar .eq. 1) then 
    countf(6) = 1
  else
    countf(6) = peinf%npown
  endif

  SAFE_ALLOCATE(data,(countf(1),countf(2),countf(3),countf(4),countf(5),countf(6),countf(7)))

  !write(6,*) 'bs2', peinf%inode, count(2),count(4),count(6)
  !write(6,*) 'bs3', peinf%inode, countf(2),countf(4),countf(6)

  do isp = 1, xct%nspin
  do is = 1, xct%nspin

! We  pool the writes here...

!  write(6,*) 'before loop', peinf%inode, peinf%npown, peinf%mypown, peinf%myown

  do ii = 1, (peinf%nckpe/peinf%npown)

! Get filespace
! Probably don't need this is if don't close above 

    call h5screate_simple_f(rank, countf, memspace, error)
    call h5dget_space_f(dset_id,filespace,error)

! Construct data and offset

    iit=(ii-1)*peinf%mypown + 1

!    call MPI_BARRIER(MPI_COMM_WORLD,mpierr)
!    write(6,*) 'loop', peinf%inode, ii, iit
!    call MPI_BARRIER(MPI_COMM_WORLD,mpierr)

    if (peinf%mypown .ne. 0 .and. iit .le. peinf%myown) then

      it=(iit-1)*iownsize + 1

      do ikp=1,count(7)
      do ik=1,count(6)
      do icp=1,count(5)
      do ic=1,count(4)
      do ivp=1,count(3)
      do iv=1,count(2)
#ifdef CPLX
        data(1,iv,ivp,ic,icp,ik,ikp) = dble(bsemat(it,is,isp))
        data(2,iv,ivp,ic,icp,ik,ikp) = IMAG(bsemat(it,is,isp))
#else
        data(1,iv,ivp,ic,icp,ik,ikp) = bsemat(it,is,isp)
#endif
        it=it+1
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo

      offsetm(:) = 0
      call h5sselect_hyperslab_f(memspace, H5S_SELECT_SET_F, offsetm, count, error)

      ik=peinf%ik(peinf%inode+1,iit)
      ikp=peinf%ikp(peinf%inode+1,iit)

      if (xct%icpar .eq. 1) then
        ic=peinf%ic(peinf%inode+1,iit)
        icp=peinf%icp(peinf%inode+1,iit)
      else
        ic=1
        icp=1
      endif

      if (xct%ivpar .eq. 1) then
        iv=peinf%iv(peinf%inode+1,iit)
        ivp=peinf%ivp(peinf%inode+1,iit)
      else
        iv=1
        ivp=1
      endif

      offset(1)=0
      offset(2)=(iv-1)
      offset(3)=(ivp-1)
      offset(4)=(ic-1)
      offset(5)=(icp-1)
      offset(6)=(ik-1)+(is-1)*xct%nkpt_co
      offset(7)=(ikp-1)+(isp-1)*xct%nkpt_co

    else

      offset(:) = 0
      call H5sselect_none_f(memspace,error);      

    endif

! Select hyperslab

    call h5sselect_hyperslab_f(filespace, H5S_SELECT_SET_F, offset, count, error)

! JRD: If this proc has no work, nullify filespace

    if (iit .gt. peinf%myown .or. peinf%mypown .eq. 0) call H5sselect_none_f(filespace,error);

!    write(6,*) 'loop3', peinf%inode, ii, iit
!    call MPI_BARRIER(MPI_COMM_WORLD,mpierr)

! Create property list for collective dataset write
! Collectively write the file

#ifdef MPI
    call h5pcreate_f(H5P_DATASET_XFER_F, plist_id, error)
    call h5pset_dxpl_mpio_f(plist_id, H5FD_MPIO_COLLECTIVE_F, error)
    call h5dwrite_f(dset_id, H5T_NATIVE_DOUBLE, data, countf, error, memspace, filespace, &
                      xfer_prp = plist_id)
    call h5pclose_f(plist_id, error)
#else
    call h5dwrite_f(dset_id, H5T_NATIVE_DOUBLE, data, countf, error, memspace, filespace)
#endif

!    write(6,*) 'loop4', peinf%inode, ii, iit
!    call MPI_BARRIER(MPI_COMM_WORLD,mpierr)

! Close property list and filespace. Do we have to do this each time?

    call h5sclose_f(memspace, error)
    call h5sclose_f(filespace, error)

  enddo
  enddo
  enddo

! Close dataset and file

  call h5dclose_f(dset_id, error)
  call h5fclose_f(file_id, error)

  SAFE_DEALLOCATE(data)

  POP_SUB(bsehdf5)

  return

end subroutine bse_hdf5_write

!============================================================================
!
! (3) bse_hdf5_setup
!
!============================================================================


subroutine bse_hdf5_setup(xct,kg)
  type (xctinfo), intent(in) :: xct
  type (grid), intent(in) :: kg

  integer(HID_T) :: file_id       ! File identifier
  integer(HID_T) :: head_id       ! Dataset identifier
  integer(HID_T) :: wing_id       ! Dataset identifier
  integer(HID_T) :: body_id       ! Dataset identifier
  integer(HID_T) :: exchange_id       ! Dataset identifier
  integer(HID_T) :: fxc_id       ! Dataset identifier
  integer(HID_T) :: filespace     ! Dataspace identifier in file
  integer(HID_T) :: infospace
  integer(HID_T) :: versionspace
  integer(HID_T) :: kspace
  integer(HID_T) :: info_id
  integer(HID_T) :: version_id
  integer(HID_T) :: kpoints_id

  integer(HSIZE_T) :: adims(1), dims(7), kdims(2)

  integer :: rank, arank, krank, error, metadata(5), versionnumber(1)

! Create the file

  call h5fcreate_f('bsemat.h5', H5F_ACC_TRUNC_F, file_id, error)

  rank = 7
#ifdef CPLX
  dims(1) = 2
#else 
  dims(1) = 1
#endif
  dims(2) = xct%n1b_co
  dims(3) = xct%n1b_co
  dims(4) = xct%n2b_co
  dims(5) = xct%n2b_co
  dims(6) = xct%nkpt_co*xct%nspin
  dims(7) = xct%nkpt_co*xct%nspin

  call h5screate_simple_f(rank, dims, filespace, error)

! Create the dataset with default properties.

  call h5dcreate_f(file_id, 'head', H5T_NATIVE_DOUBLE, filespace, &
                      head_id, error)
  if (xct%theory == 0) &
  call h5dcreate_f(file_id, 'wing', H5T_NATIVE_DOUBLE, filespace, &
                      wing_id, error)
  call h5dcreate_f(file_id, 'body', H5T_NATIVE_DOUBLE, filespace, &
                      body_id, error)
  call h5dcreate_f(file_id, 'exchange', H5T_NATIVE_DOUBLE, filespace, &
                      exchange_id, error)
  if (xct%theory == 1) &
  call h5dcreate_f(file_id, 'fxc', H5T_NATIVE_DOUBLE, filespace, &
                      fxc_id, error)

  call h5dclose_f(head_id, error)
  if (xct%theory == 0) call h5dclose_f(wing_id, error)
  call h5dclose_f(body_id, error)
  call h5dclose_f(exchange_id, error)
  if (xct%theory == 1) call h5dclose_f(fxc_id, error)
  call h5sclose_f(filespace, error)

! JRD: Write MetaData

  arank = 1
  adims(1) = 5
#ifdef CPLX
  metadata(1) = 1
#else
  metadata(1) = 0
#endif
  metadata(2) = xct%nkpt_co
  metadata(3) = xct%n2b_co
  metadata(4) = xct%n1b_co
  metadata(5) = xct%nspin

  call h5screate_simple_f(arank, adims, infospace, error)

  call h5dcreate_f(file_id, 'info', H5T_NATIVE_INTEGER, infospace, &
                      info_id, error)

  call h5dwrite_f(info_id, H5T_NATIVE_INTEGER, metadata, adims, error)

  call h5dclose_f(info_id, error)
  call h5sclose_f(infospace, error)

! JRD: Write versionnumber

  arank = 1
  adims(1) = 1
  versionnumber(1) =1 

  call h5screate_simple_f(arank, adims, versionspace, error)

  call h5dcreate_f(file_id, 'versionnumber', H5T_NATIVE_INTEGER, versionspace, &
                      version_id, error)

  call h5dwrite_f(version_id, H5T_NATIVE_INTEGER, versionnumber, adims, error)

  call h5dclose_f(version_id, error)
  call h5sclose_f(versionspace, error)


! JRD: Write k-points

  krank = 2
  kdims(1) = 3
  kdims(2) = xct%nkpt_co

  call h5screate_simple_f(krank, kdims, kspace, error)

  call h5dcreate_f(file_id, 'kpoints', H5T_NATIVE_DOUBLE, kspace, &
                      kpoints_id, error)

  call h5dwrite_f(kpoints_id, H5T_NATIVE_DOUBLE, kg%f, kdims, error)

  call h5dclose_f(kpoints_id, error)
  call h5sclose_f(kspace, error)

  call h5fclose_f(file_id, error)

end subroutine bse_hdf5_setup
#endif

end module bsewrite_m

!===============================================================================
!
! Routines:
!
! (1) sigma              Originally By MSH        Last Modified 10/5/2009 (gsm)
!
! This is the main routine for the Sigma code.  Please see the documentation
! in the README for more information on this code.
!
!===============================================================================

#include "f_defs.h"

program sigma

  use global_m
  use checkbz_m
  use checkgriduniformity_m
  use check_screening_m
  use fixwings_m
  use fftw_m
  use fullbz_m
  use gmap_m
  use input_utils_m
  use irrbz_m
  use misc_m
  use mtxel_sxch_m
  use sort_m
  use vcoul_generator_m
  use wfn_rho_vxc_io_m
  use write_result_m
  use write_result_dyn_m
  use write_result_dyn_hp_m
  use write_result_hp_m
  use io_utils_m
#ifdef HDF5
  use hdf5
#endif
  use epsread_hdf5_m
  use epscopy_m
  use io_utils_m
  implicit none

!---------------------
! Derived Types

  type (crystal) :: crys
  type (symmetry) :: syms
  type (gspace) :: gvec
  type (kpoints) :: kp
  type (siginfo) :: sig
  type (wpgen) :: wpg
  type (wfnkstates) :: wfnk,wfnkoff
  type (wfnkqstates) :: wfnkq
  type (epsmpiinfo) :: epsmpi
  type (wfnkqmpiinfo) :: wfnkqmpi
  type (wfnkmpiinfo) :: wfnkmpi
  type (twork_scell) :: work_scell
  type(progress_info) :: prog_info !< a user-friendly progress report

!---------------------
! k-points for the sum over BZ (the rq-points)

  integer :: nm,nrq,ijk,iout,iparallel
  integer, allocatable :: neq(:),indrq(:),itnrq(:),kg0(:,:)
  real(DP), allocatable :: rq(:,:)
  type(grid) :: gr
  
!---------------------
! (k-q) kpoints involved in sigma summations
! ===> see data type cwfnkq and vwfnkq

  real(DP) :: rkq(3)

!---------------------
! Dielectric matrices

  integer :: ngq,neps,nmtx,ncoul,ncoulch,ncoulb,ncouls
  integer :: ngqt,nmtxt,nfreqgpp
  integer, allocatable :: isrtq(:),isrtqi(:)
  integer, allocatable :: isrtrq(:)
  integer, pointer :: isrtrqi(:)
  SCALAR, pointer :: eps(:,:)
  real(DP), allocatable :: vcoul(:), ekin(:)
  complex(DPC), pointer :: epsR(:,:,:),epsA(:,:,:)

!---------------------
! Matrix elements for sigma

  SCALAR, allocatable :: aqs(:,:),aqsaug(:,:,:,:), &
    alda(:,:),alda2(:,:),ax(:,:),axbis(:,:), &
    asx(:,:,:),ach(:,:,:),asig(:,:), &
    ach_n1q(:,:,:),ach_n1(:,:,:),asxbis(:,:,:),achbis(:,:,:), &
    xdum1(:,:),xdum2(:,:),xdum3(:,:,:)
  SCALAR, pointer :: aqsch(:), aqsaugchd(:,:,:), aqsaugcho(:,:,:), acht_n1(:)
  real(DP), allocatable :: enew(:,:),efsto(:,:),zrenorm(:,:)

  complex(DPC), allocatable :: achcor(:,:), achcorbis(:,:)
  complex(DPC), allocatable :: asig_imag(:,:), asig_imagbis(:,:)

  complex(DPC), allocatable :: asxDyn(:,:,:),achDyn(:,:,:),achDyn_cor(:,:,:), &
    achDyn_corb(:,:,:),ach2Dyn(:,:,:),asigDyn(:,:),achD_n1q(:,:,:), &
    achD_n1(:,:,:),asxDbis(:,:,:),achDbis(:,:,:),achDbis_cor(:,:,:),ach2Dbis(:,:,:), &
    achDbis_corb(:,:,:),xdum1Dyn(:,:),xdum2Dyn(:,:),xdum3Dyn(:,:,:)
  complex (DPC), pointer :: achtD_n1(:)
  complex(DPC), allocatable :: efstoDyn(:,:)

!----------------------
! eps distrib variables

  integer :: ngpown
  integer, allocatable :: igp_owner(:),igp_index(:),inv_igp_index(:)
  SCALAR, allocatable :: epstemp(:)
  
  complex(DPC), allocatable :: epsRtemp(:,:),epsAtemp(:,:)

  character :: tmpstr*120
  character :: tmpfn*16
  character*20 :: fnc,fnk,fne
  character*16 :: routnam(100)
  integer :: routsrt(42),nullvec(3)
  logical :: xflag,eqp1flag,imagvxcflag,imagxflag,found,q0flag,bExactlyZero
  integer :: ig,i,j,k,itran,ikn,ika,ioff,error
  integer :: in,im,iw,ib,idum,kg(3),icurr,jj,ii,ispin,g1,g2
  integer :: ncount,ndum,nbandi,tag,dest,source,nfold,ifold
  integer :: iwlda,irq,irq_,irq_min,n1,ierr
  integer :: s2,iunit_c,iunit_k,iunit_eps,ndv_ikn,ngpown_max,ngpown_rem
  integer, allocatable :: ind(:), indinv(:)
  real(DP) :: fact,coulfact,weight,tempval,occ
  real(DP) :: qshift(3),oneoverq,qlen,q0len,vq(3),qk(3)
  real(DP) :: tsec(2),diffmin,diff,e_lk,avgcut,subcut
  complex(DPC), pointer :: achtDyn(:),achtDyn_cor(:),asxtDyn(:),ach2tDyn(:),achtDyn_corb(:)
  SCALAR :: achtcor,axt,epshead,asigt_imag
  SCALAR, pointer :: asxt(:), acht(:)
  SCALAR, allocatable :: ph(:)

  logical :: skip_checkbz, is_subq

!--------------- Begin Program -------------------------------------------------

  call peinfo_init()

!----------------------
! Initialize random numbers

  peinf%jobtypeeval = 1

!------------------------
! Initialize timer

  if (peinf%inode.eq.0) then
    call timacc(0,0)
    call timacc(1,1)
  endif

!------------------------
! Initialize files

  call open_file(55,file='sigma.inp',form='formatted',status='old')
  if(peinf%inode == 0) then
    call open_file(7,file='sigma.log',form='formatted',status='replace')
    call open_file(8,file='sigma_hp.log',form='formatted',status='replace')
  endif

  call write_program_header('Sigma', .true.)

!------------------------
! Initialize temporary files

!  if (sig%iwriteint .eq. 0) then
! We do not yet know, until inread inside input, whether we will use comm_disk
! However, we need to pass fnc and fnk to input. Therefore, we initialize these
! variables in all cases, though we will never use them for comm_mpi. --DAS
  iunit_c=10000+peinf%inode
  iunit_k=20000+peinf%inode
  iunit_eps=30000

  if(peinf%inode.lt.1000000) then
    write(fnc,'(a,i6.6)') 'INT_CWFN_', peinf%inode
    write(fnk,'(a,i6.6)') 'INT_WFNK_', peinf%inode
    write(fne,'(a)') 'INT_EPS'
  else
    call die('temp file names: too many nodes')
  endif

!------- Read crys data and wavefunctions from WFN_inner ----------------------------

! JRD: Included in input is the inread routine which reads the
! job parameters from sigma.inp and initializes the XC potential

  if (peinf%inode.eq.0) call timacc(2,1)
  call input(crys,gvec,syms,kp,wpg,sig,wfnk,iunit_c,iunit_k,fnc,fnk,wfnkqmpi,wfnkmpi)
  if (peinf%inode.eq.0) call timacc(2,2)
  if (peinf%inode.eq.0) call timacc(15,1)
  call input_outer(crys,gvec,syms,kp,sig,wfnk,iunit_k,fnk,wfnkmpi)
  if (peinf%inode.eq.0) call timacc(15,2)
  SAFE_DEALLOCATE_P(sig%band_index)
  SAFE_DEALLOCATE_P(sig%kpt)
  SAFE_DEALLOCATE_P(kp%ifmin)
  SAFE_DEALLOCATE_P(kp%ifmax)

!-------------------
! Initialize Various Parameters from inread

! linear extrapolation for eqp1

  eqp1flag=.false.

! imaginary parts of diagonal vxc or exchange matrix elements

  imagvxcflag=.false.
  imagxflag=.false.

! fraction of bare exchange

  if (abs(sig%xfrac).GT.TOL_Small) then
    xflag=.true.
  else
    xflag=.false.
  endif

!---------------------
! Open Various Files 

  if (peinf%inode .eq. 0) then
    if (.not.(sig%freq_dep .eq. 0 .and. sig%exact_ch .eq. 1) .and. .not. (sig%freq_dep == -1)) then
      call open_file(127,file='ch_converge.dat',form='formatted',status='replace')
    endif

    if (sig%iwritecoul .eq. 1) then
      call open_file(19,file='vcoul',form='formatted',status='replace')
    endif

   ! This if for the hybrid functional calculations (one shot) otherwise just open x.dat
    if (sig%coul_mod_flag .and. (.not. sig%use_vxc2dat)) then
      call open_file(121,file='vxc2.dat',form='formatted',status='replace')
    else if ((.not. sig%use_xdat) .and. xflag .and. (.not. sig%coul_mod_flag)) then
      call open_file(119,file='x.dat',form='formatted',status='replace')
    endif

    if (.not. sig%use_vxcdat) then
      call open_file(120,file='vxc.dat',form='formatted',status='replace')
    endif
  endif

!---------------------
! Write header of sigma_hp.log file

  if (peinf%inode.eq.0) then
    write(8,601) sig%freq_dep
    write(8,602) sig%bmin,sig%bmax
    write(8,603) sig%loff,sig%toff
    write(8,604) sig%fdf
    if(sig%fdf /= -2) write(8,605) sig%dw
    write(8,606) syms%ntran
    do itran=1,syms%ntran
      write(8,607) itran, ((syms%mtrx(i,j,itran),i=1,3),j=1,3)
    enddo
    write(8,*)
  endif
601 format(/,1x,"frequency_dependence",i4)
602 format(/,1x,"band_index",2i6)
603 format(1x,"sigma_matrix",i6,i4)
604 format(/,1x,"finite_difference_form",i4)
605 format(1x,"finite_difference_spacing",f10.6)
606 format(/,1x,"symmetries",/,1x,"ntran  =",i3)
607 format(1x,"mtrx",i2.2,1x,"=",9i3)

!---------------------
! JRD: Initialize the Full Frequency output files

  if (peinf%inode.eq.0 .and. (sig%freq_dep.eq.2 .or. (sig%fdf.eq.-3 .and. sig%freq_dep.eq.1))) then
    call open_file(8000,file='spectrum.dat',form='formatted',status='replace')
  endif

!---------------------
! Determine nq and neps
  
! JRD: This performs significantly better with hdf5

  if (peinf%inode.eq.0) call timacc(59,1)

  call epscopy_init(sig, neps)
  if (sig%freq_dep/=-1) then
    ! FHJ: sig%nq and sig%qpt already defined if this is a HF calculation
    sig%nq = sig%nq0 + sig%nq1 
    SAFE_ALLOCATE(sig%qpt, (3,sig%nq))
  endif
  if (sig%nq0==0) call die('There is no q->0 point in your calculation!', only_root_writes=.true.)

!----------------------------
! Allocate arrays

  SAFE_ALLOCATE(wfnkq%isrtkq, (gvec%ng))
  SAFE_ALLOCATE(wfnkq%ekq, (sig%ntband,kp%nspin))
  SAFE_ALLOCATE(alda, (sig%ndiag+sig%noffdiag,sig%nspin))
  SAFE_ALLOCATE(ax, (sig%ndiag+sig%noffdiag,sig%nspin))
  SAFE_ALLOCATE(axbis, (sig%ndiag+sig%noffdiag,sig%nspin))
  SAFE_ALLOCATE(achcor, (sig%ndiag+sig%noffdiag,sig%nspin))
  SAFE_ALLOCATE(asig_imag, (sig%ndiag+sig%noffdiag,sig%nspin))
  SAFE_ALLOCATE(achcorbis, (sig%ndiag+sig%noffdiag,sig%nspin))
  SAFE_ALLOCATE(asig_imagbis, (sig%ndiag+sig%noffdiag,sig%nspin))
  if (sig%freq_dep.eq.-1.or.sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.3) then
    if (sig%fdf .eq. -3) then
      SAFE_ALLOCATE(asx, (sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin))
      SAFE_ALLOCATE(ach, (sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin))
      SAFE_ALLOCATE(asxbis, (sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin))
      SAFE_ALLOCATE(achbis, (sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin))
    else
      SAFE_ALLOCATE(asx, (3,sig%ndiag+sig%noffdiag,sig%nspin))
      SAFE_ALLOCATE(ach, (3,sig%ndiag+sig%noffdiag,sig%nspin))
      SAFE_ALLOCATE(asxbis, (3,sig%ndiag+sig%noffdiag,sig%nspin))
      SAFE_ALLOCATE(achbis, (3,sig%ndiag+sig%noffdiag,sig%nspin))
    endif
    SAFE_ALLOCATE(asig, (sig%ndiag+sig%noffdiag,sig%nspin))
    SAFE_ALLOCATE(acht_n1, (sig%ntband))
    SAFE_ALLOCATE(ach_n1q, (sig%ntband,sig%ndiag+sig%noffdiag,sig%nspin))
    SAFE_ALLOCATE(ach_n1, (sig%ntband,sig%ndiag+sig%noffdiag,sig%nspin))
    SAFE_ALLOCATE(enew, (sig%ndiag,sig%nspin))
    SAFE_ALLOCATE(efsto, (sig%ndiag,sig%nspin))
    SAFE_ALLOCATE(zrenorm, (sig%ndiag,sig%nspin))
    if (sig%fdf.eq.-3) then
      nfreqgpp=sig%nfreqeval
      SAFE_ALLOCATE(asxt, (sig%nfreqeval))
      SAFE_ALLOCATE(acht, (sig%nfreqeval))
    else
      nfreqgpp=3
      SAFE_ALLOCATE(asxt, (3))
      SAFE_ALLOCATE(acht, (3))
    endif
  endif
  if (sig%freq_dep.eq.2) then
    SAFE_ALLOCATE(asxDyn, (sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin))
    SAFE_ALLOCATE(achDyn, (sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin))
    SAFE_ALLOCATE(achDyn_cor, (sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin))
    SAFE_ALLOCATE(achDyn_corb, (sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin))
    SAFE_ALLOCATE(ach2Dyn, (sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin))
    SAFE_ALLOCATE(asigDyn, (sig%ndiag+sig%noffdiag,sig%nspin))
    SAFE_ALLOCATE(achtD_n1, (sig%ntband))
    SAFE_ALLOCATE(achD_n1q, (sig%ntband,sig%ndiag+sig%noffdiag,sig%nspin))
    SAFE_ALLOCATE(achD_n1, (sig%ntband,sig%ndiag+sig%noffdiag,sig%nspin))
    SAFE_ALLOCATE(asxDbis, (sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin))
    SAFE_ALLOCATE(achDbis, (sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin))
    SAFE_ALLOCATE(achDbis_cor, (sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin))
    SAFE_ALLOCATE(achDbis_corb, (sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin))
    SAFE_ALLOCATE(ach2Dbis, (sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin))
    SAFE_ALLOCATE(efstoDyn, (sig%ndiag,sig%nspin))
    SAFE_ALLOCATE(asxtDyn, (sig%nfreqeval))
    SAFE_ALLOCATE(achtDyn, (sig%nfreqeval))
    SAFE_ALLOCATE(achtDyn_cor, (sig%nfreqeval))
    SAFE_ALLOCATE(achtDyn_corb, (sig%nfreqeval))
    SAFE_ALLOCATE(ach2tDyn, (sig%nfreqeval))
  endif
  SAFE_ALLOCATE(isrtrq, (gvec%ng))
  if (sig%freq_dep.eq.0.or.sig%exact_ch.eq.1) then
    SAFE_ALLOCATE(isrtrqi, (gvec%ng))
  endif
  SAFE_ALLOCATE(ekin, (gvec%ng))
  if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.2.or.sig%freq_dep.eq.3) then
    SAFE_ALLOCATE(isrtq, (gvec%ng))
    SAFE_ALLOCATE(isrtqi, (gvec%ng))
    SAFE_ALLOCATE(ind, (gvec%ng))
    SAFE_ALLOCATE(indinv, (gvec%ng))
    SAFE_ALLOCATE(ph, (gvec%ng))
    if(sig%iwriteint.eq.1) then
      if (peinf%inode .eq. 0) then
        SAFE_ALLOCATE(epsmpi%isrtq, (gvec%ng,sig%nq))
        SAFE_ALLOCATE(epsmpi%isrtqi, (gvec%ng,sig%nq))
      endif
      SAFE_ALLOCATE(epsmpi%qk, (3,sig%nq))
      SAFE_ALLOCATE(epsmpi%nmtx, (sig%nq))
      SAFE_ALLOCATE(epsmpi%igp_owner, (neps))
      SAFE_ALLOCATE(epsmpi%igp_index, (neps))
      epsmpi%ngpown_max = neps/peinf%npes_pool
      epsmpi%ngpown_rem = mod(neps,peinf%npes_pool)
      if (mod(neps,peinf%npes_pool) .ne. 0) epsmpi%ngpown_max = epsmpi%ngpown_max + 1
      SAFE_ALLOCATE(epsmpi%inv_igp_index, (epsmpi%ngpown_max))
    endif
  endif
  ngpown_max = neps/peinf%npes_pool
  if (mod(neps,peinf%npes_pool) .ne. 0) ngpown_max = ngpown_max + 1
  ngpown_rem = mod(neps,peinf%npes_pool)

  if (peinf%inode.eq.0) call timacc(59,2)
 
!----------------------------
! Read eps^-1 from eps0mat/epsmat
!
! JRD: The matrices are read in from eps0mat/epsmat files and writen
! to temporary INT_EPS files on unit iunit_eps. The q->0 matrix is not
! symmetrized. The wavevector q is also read from subroutine epscopy.

  if (peinf%inode.eq.0) call timacc(3,1)
  if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.2.or.sig%freq_dep.eq.3) then
    call logit('Calling epscopy')
    if (sig%iwriteint.eq.0) then
      
      call epscopy(crys,gvec,sig,neps,epsmpi,epshead,iunit_eps,fne)
      
    else if (sig%iwriteint.eq.1) then
      
! JRD: Distribute epsilon over procs in pool

      icurr=0
      epsmpi%igp_owner=-1
      epsmpi%igp_index=0
      
      do ijk = 1,neps
! JRD: I thought we could improve performance by having each own blocks for contiguous igp
! This turns out to be a bad idea because it leads poor load balancing when ggpsum=1 
! (half matrix)
        epsmpi%igp_owner(ijk)=mod(ijk-1,peinf%npes_pool) 
        !if (ijk .le. epsmpi%ngpown_max * epsmpi%ngpown_rem) then
        !  epsmpi%igp_owner(ijk) = (ijk-1) / epsmpi%ngpown_max
        !else
        !  epsmpi%igp_owner(ijk) = ((ijk - 1 - epsmpi%ngpown_max * epsmpi%ngpown_rem) / &
        !      (epsmpi%ngpown_max - 1)) + epsmpi%ngpown_rem
        !endif
        if (peinf%pool_rank .eq. epsmpi%igp_owner(ijk)) then
          icurr=icurr+1
          epsmpi%igp_index(ijk)=icurr
          epsmpi%inv_igp_index(icurr)=ijk
        endif
      enddo
      
      epsmpi%ngpown=icurr
      if (epsmpi%ngpown .gt. epsmpi%ngpown_max) call die('Inconsistency in ngpown/ngpownmax')

      call epscopy(crys,gvec,sig,neps,epsmpi,epshead,iunit_eps,fne)

    endif  ! if (sig%iwriteint.eq.1)
  endif  ! if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.2)
  if (peinf%inode.eq.0) call timacc(3,2)

!----------------------------
! Generate full Brillouin zone from irreducible wedge q -> gr%f

#ifdef VERBOSE
  if (peinf%inode.eq.0) then
    write(6,*)'*** VERBOSE: nq, syms%ntran= ',sig%nq,syms%ntran
  endif
#endif
  
  if (peinf%inode.eq.0) call timacc(4,1)
  gr%nr = sig%nq
  SAFE_ALLOCATE(gr%r, (3, sig%nq))
  gr%r(1:3,1:sig%nq) = sig%qpt(1:3,1:sig%nq)
  call fullbz(crys,syms,gr,syms%ntran,skip_checkbz,wigner_seitz=.false.,paranoid=.true.,nfix=sig%nq0)
  qshift(:)=0.0d0
  if (sig%freq_dep.eq.-1) then
    ! for Hartree-Fock, there is no epsmat/eps0mat file
    tmpfn="sigma.inp"
  else
    if (sig%igamma.ne.0) then
      tmpfn='eps0mat'
    else
      tmpfn='epsmat'
    endif
  endif
  if (.not. skip_checkbz) then
    !FHJ: TODO: ignore change checkbz to support nq0
    !call checkbz(gr%nf,gr%f,sig%qgrid,qshift,crys%bdot,tmpfn,'q',.false.,sig%freplacebz,sig%fwritebz,nfix=sig%nq0)
    call checkbz(gr%nf,gr%f,sig%qgrid,qshift,crys%bdot,tmpfn,'q',.false.,sig%freplacebz,sig%fwritebz)
  endif
  if (peinf%inode.eq.0) call timacc(4,2)
  

!-------- Start computation of sigma operator ----------------------------------

  
  fact = 1D0/(dble(gr%nf-sig%nq0+1)*crys%celvol)
  coulfact = 8D0*PI_D/(dble(gr%nf-sig%nq0+1)*crys%celvol)

!----------------------------
! Initialize distribution of epsilon

  if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.2.or.sig%freq_dep==3) then
    
#ifdef VERBOSE
    call logit('Allocating eps')
    if (peinf%inode.eq.0) then
      write(6,*) '*** VERBOSE: size of eps, neps=',neps
    endif
#endif

! JRD: DISTRIBUTE TO PROCS IN POOLS
! XXX: We do identical thing above in epsmpi
!    : except inv_igp_index allocated of different sizes

    SAFE_ALLOCATE(igp_owner, (neps))
    SAFE_ALLOCATE(igp_index, (neps))
    SAFE_ALLOCATE(inv_igp_index, (neps))
    
    icurr=0
    igp_owner=-1
    igp_index=0
    inv_igp_index=0
    
    do ijk = 1,neps
! JRD: I thought we could improve performance by having each own blocks for contiguous igp
! This turns out to be a bad idea because it leads poor load balancing when ggpsum=1 
! (half matrix)
      igp_owner(ijk)=mod(ijk-1,peinf%npes_pool)
      !if (ijk .le. ngpown_max * ngpown_rem) then
      !  igp_owner(ijk) = (ijk-1) / ngpown_max
      !else
      !  igp_owner(ijk) = ((ijk - 1 - ngpown_max * ngpown_rem) / &
      !      (ngpown_max - 1)) + ngpown_rem
      !endif

      if (peinf%pool_rank .eq. igp_owner(ijk)) then
        icurr=icurr+1
        igp_index(ijk)=icurr
        inv_igp_index(icurr)=ijk
      endif
    enddo

    ngpown=icurr

  endif

  if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1) then
    SAFE_ALLOCATE(eps, (neps,ngpown))
    SAFE_ALLOCATE(epstemp, (neps))
  endif
  if (sig%freq_dep.eq.2.or.sig%freq_dep.eq.3) then
    SAFE_ALLOCATE(epsR, (sig%nFreq,neps,ngpown))
    SAFE_ALLOCATE(epsRtemp, (sig%nFreq,neps))
#ifdef CPLX
    SAFE_ALLOCATE(epsA, (sig%nFreq,neps,ngpown))
    SAFE_ALLOCATE(epsAtemp, (sig%nFreq,neps))
#endif
  endif


!---------- Check grid for uniformity

  if(peinf%inode == 0) call checkgriduniformity(sig%qgrid, crys, sig%icutv)

!-------- Loop over kpoints rkn-------------------------------------------------


  do ika=1,sig%nkn
!----------------------------
! Read wavefunctions for rkn (if sig%nkn.gt.1)
! (else it is already in wfnk)
    ikn = sig%indkn(ika)
    if (peinf%inode.eq.0) call timacc(19,1)
    
    if(sig%nkn.gt.1) then
      if (sig%iwriteint .eq. 0) then
        if (mod(peinf%inode,peinf%npes/peinf%npools).eq.0) then
          call open_file(iunit_k,file=fnk,form='unformatted',status='old')
          
          found = .false.
          do im=1,sig%nkn
            read(iunit_k) wfnk%nkpt,wfnk%ndv,nbandi,(wfnk%isrtk(j),j=1,gvec%ng),(qk(i),i=1,3)
            
! Check k-point
            if(all(abs(kp%rk(1:3,ikn)-qk(1:3)) .lt. TOL_Small)) then
              found = .true.
              in=im
              ndv_ikn=wfnk%ndv
            endif
          enddo

          if(.not. found) then
            call die('sigma main: k-point mismatch')
          endif
          
          ! why are we reading this file a second time?? --DAS
          SAFE_ALLOCATE(wfnk%zk, (ndv_ikn,sig%nspin*kp%nspinor))
          call close_file(iunit_k)
          call open_file(iunit_k,file=fnk,form='unformatted',status='old')
          do im=1,in-1
            read(iunit_k)
          enddo
          
          read(iunit_k) wfnk%nkpt,wfnk%ndv,nbandi,(wfnk%isrtk(j),j=1,gvec%ng),(qk(i),i=1,3), &
            ((wfnk%ek(j,k),j=1,nbandi),k=1,sig%nspin), &
            ((wfnk%elda(j,k),j=1,nbandi),k=1,sig%nspin), &
            ((wfnk%zk(j,k),j=1,ndv_ikn),k=1,sig%nspin*kp%nspinor)
          call close_file(iunit_k)
        endif
        
      else ! sig%iwriteint .eq. 0
        
        nbandi=sig%ntband
        wfnk%nkpt=wfnkmpi%nkptotal(ika)
        wfnk%ndv=peinf%ndiag_max*wfnk%nkpt
        wfnk%isrtk(1:wfnk%nkpt)=wfnkmpi%isort(1:wfnk%nkpt,ika)
        qk(1:3)=wfnkmpi%qk(1:3,ika)
        wfnk%ek(1:sig%ntband,1:sig%nspin) = wfnkmpi%el(1:sig%ntband,1:sig%nspin,ika)
        wfnk%elda(1:sig%ntband,1:sig%nspin) = wfnkmpi%elda(1:sig%ntband,1:sig%nspin,ika)
        SAFE_ALLOCATE(wfnk%zk, (wfnk%ndv,sig%nspin*kp%nspinor))
        wfnk%zk=ZERO
        do k=1,sig%nspin*kp%nspinor
#ifdef MPI
          tag=1024
          if (mod(wfnk%ndv,peinf%npes/peinf%npools).eq.0) then
            jj=wfnk%ndv/(peinf%npes/peinf%npools)
          else
            jj=wfnk%ndv/(peinf%npes/peinf%npools)+1
          endif
          do j=1,peinf%npools
            dest=(j-1)*(peinf%npes/peinf%npools)
            if (peinf%inode.eq.dest) then
              g1=1
              g2=min(jj,wfnk%ndv)
              if (g2.ge.g1) then
                wfnk%zk(g1:g2,k)=wfnkmpi%cg(g1:g2,k,ika)
              endif ! g2.ge.g1
            endif
            do i=2,peinf%npes/peinf%npools
              source=(i-1)+dest
              g1=1+(i-1)*jj
              g2=min(jj+(i-1)*jj,wfnk%ndv)
              if (g2.ge.g1) then
                if (peinf%inode.eq.source) &
                  call MPI_Send(wfnkmpi%cg(1,k,ika),g2-g1+1,MPI_SCALAR,dest,tag,MPI_COMM_WORLD,mpierr)
                if (peinf%inode.eq.dest) &
                  call MPI_Recv(wfnk%zk(g1,k),g2-g1+1,MPI_SCALAR,source,tag,MPI_COMM_WORLD,mpistatus,mpierr)
              endif ! g2.ge.g1
            enddo ! i=2,peinf%npes/peinf%npools
          enddo ! j=1,peinf%npools
#else
          wfnk%zk(1:wfnk%ndv,k)=wfnkmpi%cg(1:wfnk%ndv,k,ika)
#endif
        enddo ! k=1,sig%nspin
      endif ! sig%iwriteint .eq. 0

#ifdef MPI
      call MPI_Bcast(wfnk%nkpt,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
      call MPI_Bcast(wfnk%ndv,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
      call MPI_Bcast(nbandi,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
      call MPI_Bcast(wfnk%isrtk,gvec%ng,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
      call MPI_Bcast(qk,3,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
      call MPI_Bcast(wfnk%ek,nbandi*sig%nspin,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
      call MPI_Bcast(wfnk%elda,nbandi*sig%nspin,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)

      if (sig%iwriteint .eq. 0) then
        if (mod(peinf%inode,peinf%npes/peinf%npools).ne.0) then
          SAFE_ALLOCATE(wfnk%zk, (wfnk%ndv,sig%nspin*kp%nspinor))
        endif
      endif
      
      if (peinf%npools.eq.1) then
        call MPI_Bcast(wfnk%zk,wfnk%ndv*sig%nspin*kp%nspinor,MPI_SCALAR,0,MPI_COMM_WORLD,mpierr)
      else
        tag=1024
        do j=1,peinf%npools
          source=(j-1)*(peinf%npes/peinf%npools)
          do i=2,peinf%npes/peinf%npools
            dest=(i-1)+source
            if (peinf%inode.eq.source) &
              call MPI_Send(wfnk%zk,wfnk%ndv*sig%nspin,MPI_SCALAR,dest,tag,MPI_COMM_WORLD,mpierr)
            if (peinf%inode.eq.dest) &
              call MPI_Recv(wfnk%zk,wfnk%ndv*sig%nspin,MPI_SCALAR,source,tag,MPI_COMM_WORLD,mpistatus,mpierr)
          enddo
        enddo
      endif
#endif
    endif ! sig%nkn.gt.1
    if (peinf%inode.eq.0) call timacc(19,2)
    
    if(peinf%inode.eq.0) then
      write(6,*)
      call print_dealing_with(ika, sig%nkn, kp%rk(:,ikn), 'k')
    endif
    
!----------------------------
! Initialize Matrix Elements

    alda=0.0d0
    ax=0.0d0
    axbis=0.0d0
    achcor(:,:)=(0.0d0,0.0d0)
    asig_imag(:,:)=(0.0d0,0.0d0)
    achcorbis(:,:)=(0.0d0,0.0d0)
    asig_imagbis(:,:)=(0.0d0,0.0d0)
    if (sig%freq_dep.eq.-1.or.sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.3) then
      asx(:,:,:)=ZERO
      ach(:,:,:)=ZERO
      asig(:,:)=ZERO
      ach_n1q(:,:,:)=ZERO
      ach_n1(:,:,:)=ZERO
      asxbis(:,:,:)=ZERO
      achbis(:,:,:)=ZERO
    endif
    if (sig%freq_dep.eq.2) then
      asxDyn(:,:,:)=(0.0d0,0.0d0)
      achDyn(:,:,:)=(0.0d0,0.0d0)
      achDyn_cor(:,:,:)=(0.0d0,0.0d0)
      achDyn_corb(:,:,:)=(0.0d0,0.0d0)
      ach2Dyn(:,:,:)=(0.0d0,0.0d0)
      asigDyn(:,:)=(0.0d0,0.0d0)
      achD_n1q(:,:,:)=(0.0d0,0.0d0)
      achD_n1(:,:,:)=(0.0d0,0.0d0)
      asxDbis(:,:,:)=(0.0d0,0.0d0)
      achDbis(:,:,:)=(0.0d0,0.0d0)
      achDbis_cor(:,:,:)=(0.0d0,0.0d0)
      achDbis_corb(:,:,:)=(0.0d0,0.0d0)
      ach2Dbis(:,:,:)=(0.0d0,0.0d0)
    endif
    
!----------------------------
! Read matrix elements of Vxc from file vxc.dat
! or compute them on the fly from Vxc potential

    if (peinf%inode.eq.0) call timacc(5,1)
    if(sig%use_vxcdat) then
      if(peinf%inode == 0) write(6,*) 'Reading vxc.dat'
      call open_file(120,file='vxc.dat',form='formatted',status='old')
      qk(:)=INF
      ierr=0
      do while (ierr.eq.0)
        call read_matrix_elements_type(120, ierr, qk, sig, alda)
        if (all(abs(kp%rk(1:3,ikn)-qk(1:3)) .lt. TOL_Small)) exit
      enddo
      call close_file(120)
          
! Check k-point

      if(any(abs(kp%rk(1:3,ikn)-qk(1:3)) .ge. TOL_Small)) then
        call die('cannot find k-point in vxc.dat', only_root_writes = .true.)
      endif

! Divide by ryd for diag
! this will be undone by shift_energy routines later

      do s2=1,sig%nspin
        do in=1,sig%ndiag
          alda(in,s2) = alda(in,s2)/ryd
        enddo
      enddo

    else ! not using vxc.dat
      
      call logit('Calling mtxel_vxc')
      call mtxel_vxc(kp,gvec,sig,wfnk,wfnkoff,alda,.false.)

    endif


    if (peinf%inode.eq.0) call timacc(5,2)
    
#ifdef CPLX
    if (any(abs(IMAG(alda(1:sig%ndiag,:)))*ryd > 1.0d-4)) imagvxcflag=.true.
#endif

!----------------------------
! Read ax from existing data

    if(sig%use_xdat .and. xflag .and. (.not. sig%coul_mod_flag)) then

      if(peinf%inode == 0) write(6,*) 'Reading x.dat'
      call open_file(119,file='x.dat',form='formatted',status='old')
      qk(:)=INF
      ierr=0
      do while (ierr.eq.0)
        call read_matrix_elements_type(119, ierr, qk, sig, ax)
        if (all(abs(kp%rk(1:3,ikn)-qk(1:3)) .lt. TOL_Small)) exit
      enddo
      ax(:,:) = ax(:,:) * sig%xfrac
      call close_file(119)
      
! Check k-point

      if(any(abs(kp%rk(1:3,ikn)-qk(1:3)) .ge. TOL_Small)) then
        call die('cannot find k-point in x.dat', only_root_writes = .true.)
      endif

! Divide by ryd for diag

      do s2=1,sig%nspin
        do in=1,sig%ndiag
          ax(in,s2) = ax(in,s2)/ryd
        enddo
      enddo

#ifdef CPLX
    if (any(abs(IMAG(ax(1:sig%ndiag,:)))*ryd > 1.0d-4)) imagxflag=.true.
#endif

    endif ! using x.dat

!----------------------------
! Find subgroup which leaves kn invariant
! Indices of group operations in subgroup stored in array indsub
! stored in structure syms

    qk(:) = kp%rk(:,ikn)
    if (peinf%inode.eq.0) call timacc(6,1)
    if (sig%qgridsym) then
      call subgrp(qk,syms)
    else
      syms%ntranq=1
      syms%indsub(1)=1
      syms%kgzero(1:3,1)=0
    endif
    if (peinf%inode.eq.0) call timacc(6,2)

!----------------------------
! Reduce qpoints with respect to group of kn
! Keep track of number of q-points equivalent
! to give qpoint in irr-bz neq(irq)
!
! Keep track of q-point in the set given in epsmat
! RQ = R(Q) + G0 with transformation R and umklapp G0
! In order to unfold the inverse dielectric matrix from Q to RQ
!
! The q-points are the points for which we have epsilon
! (should be the unshifted irreducible grid)

    SAFE_ALLOCATE(indrq, (gr%nf))
    SAFE_ALLOCATE(neq, (gr%nf))
    SAFE_ALLOCATE(itnrq, (gr%nf))
    SAFE_ALLOCATE(rq, (3,gr%nf))
    SAFE_ALLOCATE(kg0, (3,gr%nf))
    if (peinf%inode.eq.0) call timacc(7,1)
    call irrbz(syms,gr%nf,gr%f,nrq,neq,indrq,rq,sig%nq,sig%qpt,itnrq,kg0,nfix=sig%nq0)
    if (peinf%inode.eq.0) call timacc(7,2)
    

!!---------- Loop over k-points in irr bz with respect to kn (rq) --------------

    irq_min = 1
    call progress_init(prog_info, 'calculating Sigma', 'block', &
      (nrq-irq_min+1)*(peinf%ndiag_max+peinf%noffdiag_max)*sig%nspin)

    do irq_ = irq_min, nrq
      irq = irq_
      is_subq = .false.

#ifdef VERBOSE
      if(peinf%inode.eq.0) then
        write(6,60) irq,nrq
        write(6,*) ' '
      endif
60    format(/,3x,'qpoint',i5,' out of ',i5)
#endif

! Compute energies: |q+g|**2
      if (is_subq) then
        call kinetic_energies(gvec, crys%bdot, ekin)
      else
        call kinetic_energies(gvec, crys%bdot, ekin, qvec = rq(1:3, irq))
      endif

! Sort ekin in ascending order for this q
! The indices are placed in array isrtrq
      call sortrx(gvec%ng, ekin, isrtrq, gvec = gvec%components)
      if ((sig%freq_dep.eq.0.or.sig%exact_ch.eq.1).and.irq_==irq_min) then
        isrtrqi=0
        do j=1,gvec%ng
          if (isrtrq(j).ge.1.and.isrtrq(j).le.gvec%ng) &
            isrtrqi(isrtrq(j))=j
        enddo
      endif

! Compute cutoff in sums over G,G`
      ncoulb = gcutoff(gvec%ng, ekin, isrtrq, sig%ecutb)
      ncouls = gcutoff(gvec%ng, ekin, isrtrq, sig%ecuts)
      ncoul = max(ncouls,ncoulb)

      if (sig%freq_dep.eq.0.or.sig%exact_ch.eq.1) then
        if(irq_==irq_min) ncoulch = ncoul
      else
        ncoulch = 0
      endif

      ! this condition is assumed later in the code (e.g. wpeff array sizes), so we must check it
      if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.2.or.sig%freq_dep.eq.3) then
        if (ncouls.gt.neps) then
          write(tmpstr,'(a,i6,a,i6)')&
            "screened Coulomb cutoff is bigger than epsilon cutoff"//CHAR(10)&
            //' ncouls = ',ncouls,' neps = ',neps
          ! NB: CHAR(10) is the carriage return.
          call die(tmpstr, only_root_writes = .true.)
        endif
      endif

!----------------------------
! Allocate arrays for q-point rq(:,irq)
      SAFE_ALLOCATE(vcoul, (ncoul))
      SAFE_ALLOCATE(aqs, (ncoul,peinf%ntband_max))
      if (sig%noffdiag.gt.0) then 
        SAFE_ALLOCATE(aqsaug, (ncoul,peinf%ntband_max,sig%ndiag,sig%nspin))
      endif
      if ((sig%freq_dep.eq.0.or.sig%exact_ch.eq.1).and.irq_==irq_min) then
        SAFE_ALLOCATE(aqsch, (ncoulch))
        if (nrq.gt.1) then
          SAFE_ALLOCATE(aqsaugchd, (ncoulch,peinf%ndiag_max,sig%nspin))
          if (sig%noffdiag.gt.0) then
            SAFE_ALLOCATE(aqsaugcho, (ncoulch,peinf%noffdiag_max,sig%nspin))
          end if
        endif
      endif
      nm = indrq(irq)


!!!------- Calculate Vcoul -----------------------------------------------------
      if (peinf%inode.eq.0) call timacc(13,1)
      vq=rq(:,irq)
      qlen = sqrt(DOT_PRODUCT(vq,MATMUL(crys%bdot,vq)))
      if(sig%freq_dep /= -1) call check_screening_trunc(sig%icutv,sig%iscreen,sig%q0vec,crys%bdot)
      iparallel=1
      avgcut = sig%avgcut
      if (.not. sig%coul_mod_flag) then
        call vcoul_generator(sig%icutv,sig%truncval,gvec,crys%bdot, &
          gr%nf-sig%nq0+1,ncoul,isrtrq,sig%iscreen,vq,sig%q0vec,vcoul, &
          sig%iwritecoul,iparallel,avgcut,oneoverq,sig%qgrid,epshead, &
          work_scell,sig%averagew,sig%wcoul0)
      endif

      fact = 1D0/(dble(gr%nf-sig%nq0+1)*crys%celvol)
      coulfact = 8D0*PI_D/(dble(gr%nf-sig%nq0+1)*crys%celvol)
      do ig = 1, ncoul
        vcoul(ig)=fact*vcoul(ig)
      enddo
      if (ika.eq.1.and.irq_==irq_min) then
        sig%wcoul0 = sig%wcoul0 * fact
      endif
      if (peinf%inode.eq.0) call timacc(13,2)
      

!!!------- Read inverse dielectric matrix for q-point rq(:,irq) ----------------
      if (peinf%inode.eq.0) call timacc(14,1)
      
      if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.2.or.sig%freq_dep.eq.3) then
        
        q0len = sqrt(DOT_PRODUCT(sig%q0vec,MATMUL(crys%bdot,sig%q0vec)))
        
!----------------------------
! Processor 0 read eps^-1 for this q and broadcast to others
!
! Note: the total number of g-vectors used during
! computation of the inverse dielectric matrix
! may be different than in present calculation
! although the sets must coincide for small g
!
! JRD: We must find correct spot in EPS File
! Possible Performance Hazard
! Speed up might be breaking files up
!
! CHP: Now this hazard is gone with comm_mpi

        if(sig%iwriteint.eq.0) then
          
          if (peinf%inode.eq.0) then
            call open_file(iunit_eps,file=fne,form='unformatted',status='old')
              
! CHP: "if(nm.ne.1) then" is NOT necessary since we have "do ii=1,nm-1"
!                if (nm .ne. 1) then
            do ii=1,nm-1
              read(iunit_eps) ngqt,nmtxt
              if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1) then
                do j=1,nmtxt
                  read(iunit_eps)
                enddo
              else ! sig%freq_dep.eq.2
                do j=1,nmtxt
                  do i=1,nmtxt
                    read(iunit_eps) ! epsR
                  enddo
#ifdef CPLX
                  do i=1,nmtxt
                    read(iunit_eps) ! epsA
                  enddo
#endif
                enddo
              endif
            enddo
!                endif ! if (nm .ne. 1)

            read(iunit_eps) ngq,nmtx,isrtq(1:ngq),isrtqi(1:ngq),(qk(i),i=1,3)
          endif ! proc 0

#ifdef MPI
          call MPI_Bcast(ngq, 1, MPI_INTEGER, 0, MPI_COMM_WORLD,mpierr)
          call MPI_Bcast(nmtx, 1, MPI_INTEGER, 0, MPI_COMM_WORLD,mpierr)
          call MPI_Bcast(isrtq, ngq, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
          call MPI_Bcast(isrtqi, ngq, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
          call MPI_Bcast(qk, 3, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
#endif
        else if (sig%iwriteint.eq.1) then
          ngq = gvec%ng
          nmtx = epsmpi%nmtx(nm)

          if (peinf%inode .eq. 0) then
            isrtq(:) = epsmpi%isrtq(:,nm)
            isrtqi(:) = epsmpi%isrtqi(:,nm)
          endif
#ifdef MPI
          call MPI_Bcast(isrtq, ngq, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
          call MPI_Bcast(isrtqi, ngq, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
#endif
          qk(:) = epsmpi%qk(:,nm)
        endif

! Find g=0 in main gvec list and eps gvector list

        ! write explicitly to avoid possible warning about array temporary
        nullvec(1:3) = 0
        call findvector(iout,nullvec,gvec)
        iout = isrtqi(iout)
          
#ifdef VERBOSE
        if (peinf%inode.eq.0) write(6,*) 'Reading Eps Back'
#endif
        if (sig%iwriteint.eq.0) then
          
          do ijk = 1, nmtx

            if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1) then
              epstemp=0D0
            else ! sig%freq_dep.eq.2 .or. 3
              epsRtemp=0D0
#ifdef CPLX
              epsAtemp=0D0
#endif
            endif
            
            if (peinf%inode .eq. 0) then
              
              if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1) then
                read(iunit_eps) (epstemp(i),i=1,nmtx)
              else ! sig%freq_dep.eq.2 .or. 3
                do i=1,nmtx
                  read(iunit_eps) (epsRtemp(jj,i),jj=1,sig%nFreq)
                enddo
#ifdef CPLX
                do i=1,nmtx
                  read(iunit_eps) (epsAtemp(jj,i),jj=1,sig%nFreq)
                enddo
#endif
              endif
            endif

!-------------------------------------------------------------------------------
! Now distribute it

! JRD: Possible time Hazard.  Can we do this all in epscopy once and for all?
! CHP: Yes, use comm_mpi!

! The Broadcast here is bad. But, that is the price you pay for comm_disk...

#ifdef MPI
            dest=igp_owner(ijk)
            if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1) then
              call MPI_Bcast(epstemp,neps,MPI_SCALAR,0,MPI_COMM_WORLD,mpierr)
            else ! sig%freq_dep.eq.2 .or. 3
              call MPI_Bcast(epsRtemp,sig%nFreq*neps,MPI_COMPLEX_DPC,0,MPI_COMM_WORLD,mpierr)
#ifdef CPLX
              call MPI_Bcast(epsAtemp,sig%nFreq*neps,MPI_COMPLEX_DPC,0,MPI_COMM_WORLD,mpierr)
#endif
            endif
#endif
              
            if (peinf%pool_rank .eq. igp_owner(ijk)) then
              if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1) then
                eps(:,igp_index(ijk))=epstemp(:)
              else !  sig%freq_dep.eq.2 .or. 3
                epsR(:,:,igp_index(ijk))=epsRtemp(:,:)
#ifdef CPLX
                epsA(:,:,igp_index(ijk))=epsAtemp(:,:)
#endif
              endif
#ifdef VERBOSE
699           format(1x,"WARNING: distribution of inverse epsilon matrix", &
                /,3x,"inode =",i5,1x,"ijk =",i6,1x,"igp_index(ijk) =",i2,/)
              if (igp_index(ijk) .eq. 0) then
                write(0,699) peinf%inode, ijk, igp_index(ijk)
              endif
#endif
            endif ! proc non-0
            
          enddo  ! ijk
        endif  ! if (sig%iwriteint.eq.0)

! JRD: XXX This is sort of a waste of memory... Can we use pointers for this sort of thing?
        
        if (sig%iwriteint.eq.1) then
          if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1) then
            eps(:,:)=epsmpi%eps(:,:,nm)
          else ! sig%freq_dep.eq.2 .or. 3
            epsR(:,:,:)=epsmpi%epsR(:,:,:,nm)
#ifdef CPLX
            epsA(:,:,:)=epsmpi%epsA(:,:,:,nm)
#endif
          endif
        endif ! if (sig%iwriteint.eq.1)
        
! CHP: By first distributing and then doing the wing fix, we can let
!      all the processors work together, thus, saving some time.
!      This is the case for both comm_mpi and comm_disk.

!-------------------------------------------------------------------------------
! Fix wing divergence for semiconductors and graphene

! This should really be done for all "|q+G| < avgcut" - but for now,
! it is done if "|q| < avgcut and G=0"

        if (.not.sig%subsample) then
        do ijk = 1, nmtx
          
          if (peinf%pool_rank.ne.igp_owner(ijk)) cycle
          
          if (igp_index(ijk).eq.0) write(6,*) 'ijk!!',peinf%inode,ijk
          
          if (nm .eq. 1) then
            q0flag=.true.
            if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1) then
              call fixwings(vcoul(1),sig%wcoul0,eps(:,igp_index(ijk)),sig%icutv, &
                sig%iscreen,ijk,nmtx,iout,q0len,oneoverq,fact,q0flag,sig%averagew,crys%bdot)
            else ! sig%freq_dep.eq.2 .or. 3
              call fixwings_dyn(vcoul(1),epsR(:,:,igp_index(ijk)), &
                sig%icutv,sig%iscreen,ijk,sig%nFreq,nmtx,iout,q0len,oneoverq,fact,q0flag,crys%bdot)
#ifdef CPLX
              call fixwings_dyn(vcoul(1),epsA(:,:,igp_index(ijk)), &
                sig%icutv,sig%iscreen,ijk,sig%nFreq,nmtx,iout,q0len,oneoverq,fact,q0flag,crys%bdot)
#endif
            endif
          else if (qlen**2 .lt. sig%avgcut) then
            q0flag=.false.
            if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1) then
              call fixwings(vcoul(1),sig%wcoul0,eps(:,igp_index(ijk)),sig%icutv, &
                sig%iscreen,ijk,nmtx,iout,qlen,oneoverq,fact,q0flag,sig%averagew,crys%bdot)
            else ! sig%freq_dep.eq.2 .or. 3
              call fixwings_dyn(vcoul(1),epsR(:,:,igp_index(ijk)), &
                sig%icutv,sig%iscreen,ijk,sig%nFreq,nmtx,iout,qlen,oneoverq,fact,q0flag,crys%bdot)
#ifdef CPLX
              call fixwings_dyn(vcoul(1),epsA(:,:,igp_index(ijk)), &
                sig%icutv,sig%iscreen,ijk,sig%nFreq,nmtx,iout,qlen,oneoverq,fact,q0flag,crys%bdot)
#endif
            endif
          endif
          
        enddo ! ijk
        endif !.not.sig%subsample
        
        if(sig%iwriteint == 0) then
          call logit('Read eps from disk')
        else
          call logit('Read eps from memory')
        endif

        if (peinf%inode.eq.0 .and. sig%iwriteint == 0) then
          write(6,*) 'Done Read Eps Back'
! use of below causes NaNs from bad optimization, blocked by statement containing NaN below
! bad at -O2, -O3, ok at -O1 and -O0 at least for gfortran. --DAS
          call close_file(iunit_eps)
!          close(iunit_eps)  ! using this line instead has no optimization issue
        endif
        
      endif  ! sig%freq_dep
      
      if (sig%freq_dep.eq.-1) then
        ngq=0
        nmtx=0
        qk(:)=sig%qpt(:,nm)
      endif
      
      if (peinf%inode.eq.0) call timacc(14,2)
      
#ifdef VERBOSE
      if (peinf%inode.eq.0) then
        write(6,'(3(a,i10))') ' *** VERBOSE: nmtx =',nmtx,' ncouls =',ncouls
        write(6,*)
      endif
#endif
      if(nmtx.gt.neps) then
        call die('nmtx.gt.neps')
      endif
        
! Check q-vector

      if(any(abs(sig%qpt(1:3, nm) - qk(1:3)) .gt. TOL_SMALL)) then
        write(0,*) peinf%inode,sig%qpt(:,nm),qk(:)
        call die('q-vector check wrong')
      endif
        
      if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.2.or.sig%freq_dep.eq.3) then
        if(ncouls .gt. nmtx) ncouls = nmtx
      endif

#ifdef VERBOSE
      if(peinf%inode.eq.0) then
        if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1) then
          write(6,100) (rq(i,irq),i=1,3),ncouls,dble(eps(1,1))
        endif
        if (sig%freq_dep.eq.2.or.sig%freq_dep.eq.3) then
          write(6,100) (rq(i,irq),i=1,3),ncouls,dble(epsR(1,1,1))
        endif
      endif
100   format(3x,'q=',3f8.5,2x,'n=',i6,2x,'head of epsilon inverse =',f12.6,/)
#endif

! Map g-vectors required for eps**(-1)(r(q)) to those
! for the known matrix eps**(-1)(q) and calculate phases

      itran = itnrq(irq)
      kg(:) = kg0(:,irq)
      if (peinf%inode.eq.0) call timacc(8,1)
      call logit('Calling gmap')
      if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.2.or.sig%freq_dep.eq.3) then
        ind(:)=0
        indinv(:)=0
        ph(:)=ZERO
        call gmap(gvec,syms,ncouls,itran,kg,isrtrq,isrtqi,ind,ph, &
         sig%die_outside_sphere) ! TROUBLE
        do ig = 1, gvec%ng
          if (ind(ig) .gt. 0 .and. ind(ig) .le. gvec%ng) then
            indinv(ind(ig))=ig
          endif
        enddo
      endif
      if (peinf%inode.eq.0) call timacc(8,2)
      

!!!------- Done reading inverse dielectric matrix for q-point rq(:,irq) --------


!--------------------
! Generate needed wavefunctions for rkq = rkn - rq
! stored in derived type wfnkq

      rkq(1:3) = kp%rk(1:3, ikn) - rq(1:3, irq)
      if (peinf%inode.eq.0) call timacc(9,1)
      call logit('Calling genwf')
      if (.not.is_subq.or.irq_==0) then ! FHJ: subsampling uses the same WFNs and matrix elements
        if (sig%iwriteint .eq. 0) then
          call genwf_disk(rkq,syms,gvec,crys,kp,sig,wfnkq,iunit_c,fnc)
        else
          call genwf_mpi(rkq,syms,gvec,crys,kp,sig,wfnkq,wfnkqmpi)
        endif
      endif
      if (peinf%inode.eq.0) call timacc(9,2)
      
!!-------- Loop over spins for which Sigma is computed -------------------------
      do ispin=1,sig%nspin


!!-------- Loop over bands for which diag Sigma is computed --------------------
! Bands are relabelled according to sig%diag(1:sig%ndiag)
! Loop is parallelized according to peinf%index_diag(1:peinf%ndiag_max)

        do in=1,peinf%ndiag_max
          
          call progress_step(prog_info)
#ifdef VERBOSE
          if (peinf%inode.eq.0) then
            if (peinf%npools.eq.1) then
              write(6,999) peinf%index_diag(in)+(ispin-1)*sig%ndiag, &
                peinf%ndiag_max*peinf%npools*sig%nspin
            else
              write(6,997) peinf%index_diag(in)+(ispin-1)*sig%ndiag, &
                peinf%index_diag(in)+(ispin-1)*sig%ndiag+peinf%npools-1, &
                peinf%ndiag_max*peinf%npools*sig%nspin
            endif
          endif
999       format(1x,"Computing Sigma diag",i4,1x,"of",i4)
997       format(1x,"Computing Sigma diag",i4,1x,"to",i4,1x,"of",i4)
#endif
          write(tmpstr,*) 'Working on band ', sig%diag(peinf%index_diag(in)), ' 1st pool'
          call logit(tmpstr)

!---------------------
! Compute planewave matrix elements of g <n,k|exp{i(q+g).r}|n1,k-q>
! Note: wfnk%zk array keeps only the bands specified in sig%diag(:)
! Must keep track of the right band label

          call logit('Calling mtxel')
          if (peinf%inode.eq.0) call timacc(10,1)
          call mtxel(in,gvec,wfnkq,wfnk,ncoul,isrtrq,aqs,ispin,kp)
          if (peinf%inode.eq.0) call timacc(10,2)
          if (sig%noffdiag.gt.0.and.peinf%flag_diag(in)) then
            do j=1,peinf%ntband_node
              do i=1,ncoul
                aqsaug(i,j,peinf%index_diag(in),ispin)=aqs(i,j)
              enddo
            enddo
          endif
          if (sig%freq_dep.eq.0.or.sig%exact_ch.eq.1) then
            if (irq_==irq_min) then
              call logit('Calling mtxel_ch')
              call timacc(16,1)
! JRD ALL PROCS DO THIS NOW. 
              call mtxel_ch(in,in,gvec,wfnk,ncoulch,isrtrq,aqsch,ispin,kp)
              call timacc(16,2)
              if (nrq.gt.1) aqsaugchd(:,in,ispin)=aqsch(:)
            else
              aqsch(:)=aqsaugchd(:,in,ispin)
            endif
          endif

!---------------------
! Compute diag SX and CH

          if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.2.or.sig%freq_dep.eq.3) then
            call logit('Calling mtxel_sxch for diagonal matrix elements')
            if (peinf%inode.eq.0) call timacc(11,1)
          
            call mtxel_sxch(peinf%index_diag(in), &
             peinf%index_diag(in),ispin,ncouls,neps,gvec,eps,ph, &
             ind,indinv,isrtrqi,isrtrq,vcoul,crys,sig,wpg,wfnk,wfnkq,ncoulch, &
             aqs,aqs,aqsch,asigt_imag,acht_n1,asxt,acht,achtcor, &
             kp%nspin,rq(:,irq),coulfact, &
             inv_igp_index,ngpown, &
             epsR,epsA,achtD_n1,asxtDyn,achtDyn,achtDyn_cor,achtDyn_corb,ach2tDyn,1)

            if (peinf%inode.eq.0) call timacc(11,2)
          else
            achtcor = ZERO
            asigt_imag = ZERO
          endif
          
          if (peinf%flag_diag(in)) then
            achcor(peinf%index_diag(in),ispin)= &
              achcor(peinf%index_diag(in),ispin)+neq(irq)*achtcor
            asig_imag(peinf%index_diag(in),ispin)= &
              asig_imag(peinf%index_diag(in),ispin)+neq(irq)*asigt_imag
            if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.3) then
              do iw=1,nfreqgpp
                asx(iw,peinf%index_diag(in),ispin)= &
                  asx(iw,peinf%index_diag(in),ispin)+neq(irq)*asxt(iw)
                ach(iw,peinf%index_diag(in),ispin)= &
                  ach(iw,peinf%index_diag(in),ispin)+neq(irq)*acht(iw)
              enddo
              do ib=1,sig%ntband
                ach_n1q(ib,peinf%index_diag(in),ispin)= &
                  ach_n1q(ib,peinf%index_diag(in),ispin)+neq(irq)*acht_n1(ib)
              enddo
            endif
            if (sig%freq_dep.eq.2) then
              do iw=1,sig%nfreqeval
                asxDyn(iw,peinf%index_diag(in),ispin)= &
                  asxDyn(iw,peinf%index_diag(in),ispin)+neq(irq)*asxtDyn(iw)
                achDyn(iw,peinf%index_diag(in),ispin)= &
                  achDyn(iw,peinf%index_diag(in),ispin)+neq(irq)*achtDyn(iw)
                achDyn_cor(iw,peinf%index_diag(in),ispin)= &
                  achDyn_cor(iw,peinf%index_diag(in),ispin)+neq(irq)*achtDyn_cor(iw)
                achDyn_corb(iw,peinf%index_diag(in),ispin)= &
                  achDyn_corb(iw,peinf%index_diag(in),ispin)+neq(irq)*achtDyn_corb(iw)
                ach2Dyn(iw,peinf%index_diag(in),ispin)= &
                  ach2Dyn(iw,peinf%index_diag(in),ispin)+neq(irq)*ach2tDyn(iw)
              enddo
              do ib=1,sig%ntband
                achD_n1q(ib,peinf%index_diag(in),ispin)= &
                  achD_n1q(ib,peinf%index_diag(in),ispin)+neq(irq)*achtD_n1(ib)
              enddo
            endif
          endif
          
!---------------------
! Compute diag bare exchange (SKIP this computation if you already know it)

          if (peinf%inode.eq.0) call timacc(18,1)
          if ((.not. sig%use_xdat .and. xflag .and. (.not. sig%coul_mod_flag)) .or. (sig%coul_mod_flag &
            .and. (.not.  sig%use_vxc2dat))) then
            call logit('Computing bare X')
            axt=0.0d0
              
! XXX THREAD?  
            do n1=1,peinf%nvband_node
              tempval = wfnkq%ekq(peinf%indext(n1),ispin) - sig%efermi
              if (tempval < sig%tol) then
                if(abs(tempval) < sig%tol) then
                  occ=0.5  ! Fermi-Dirac distribution = 1/2 at Fermi level
                else
                  occ=1D0
                endif
                do ig=1,ncoulb
                  axt = axt + abs(aqs(ig,n1))**2 * occ * vcoul(ig)
                enddo
              endif
                ! sig%ncrit = 0 and tempval > sig%tol should never happen!
            enddo
            if (peinf%flag_diag(in)) then
              ax(peinf%index_diag(in),ispin)=ax(peinf%index_diag(in),ispin)-neq(irq)*axt*sig%xfrac
            endif
          endif ! not use x.dat
          if (peinf%inode.eq.0) call timacc(18,2)
          
        enddo ! in (loop over bands for which we need diag Sigma)
        
        if (ispin.eq.sig%nspin) then
          if (.not.is_subq.or.irq_==sig%nq0) then
            SAFE_DEALLOCATE_P(wfnkq%zkq)
          endif
          SAFE_DEALLOCATE(aqs)
          if ((sig%freq_dep.eq.0.or.sig%exact_ch.eq.1).and.irq_==nrq) then
            if (nrq.gt.1) then
              SAFE_DEALLOCATE_P(aqsaugchd)
            end if
          endif
        endif
        
!!-------- End diag band loop --------------------------------------------------

! (gsm) begin distributing aqsaug matrix elements for offdiag calculation

! $$$ inefficient communication, this should be rewritten $$$

        if (peinf%inode.eq.0) call timacc(17,1)
#ifdef MPI
        if (sig%noffdiag.gt.0.and.peinf%npools.gt.1) then
          tag=1024
          do in=1,sig%ndiag
            jj=mod(in-1,peinf%npools)+1
            do i=1,peinf%npes/peinf%npools
              source=(i-1)+(jj-1)*(peinf%npes/peinf%npools)
              do j=1,peinf%npools
                dest=(i-1)+(j-1)*(peinf%npes/peinf%npools)
                if (j.ne.jj) then
                  if (peinf%inode.eq.source) &
                    call MPI_Send(aqsaug(:,:,in,ispin),peinf%ntband_max*ncoul,MPI_SCALAR,dest,tag,MPI_COMM_WORLD,mpierr)
                  if (peinf%inode.eq.dest) &
                    call MPI_Recv(aqsaug(:,:,in,ispin),peinf%ntband_max*ncoul,MPI_SCALAR, &
                      source,tag,MPI_COMM_WORLD,mpistatus,mpierr)
                endif
              enddo
            enddo
          enddo
        endif ! sig%noffdiag.gt.0.and.peinf%npools.gt.1
#endif
        if (peinf%inode.eq.0) call timacc(17,2)
        
! (gsm) end distributing aqsaug matrix elements for offdiag calculation

!!-------- Loop over bands for which offdiag Sigma is computed -----------------

! Bands are relabelled according to sig%off*(1:sig%noffdiag)
! Loop is parallelized according to peinf%index_offdiag(1:peinf%noffdiag_max)

        do ioff=1,peinf%noffdiag_max
          
          call progress_step(prog_info)
#ifdef VERBOSE
          if (peinf%inode.eq.0) then
            if (peinf%npools.eq.1) then
              write(6,998) peinf%index_offdiag(ioff)+(ispin-1)*sig%noffdiag, &
                peinf%noffdiag_max*peinf%npools*sig%nspin
            else
              write(6,996) peinf%index_offdiag(ioff)+(ispin-1)*sig%noffdiag, &
                peinf%index_offdiag(ioff)+(ispin-1)*sig%noffdiag+peinf%npools-1, &
                peinf%noffdiag_max*peinf%npools*sig%nspin
            endif
          endif
998       format(1x,"Computing Sigma offdiag",i4,1x,"of",i4)
996       format(1x,"Computing Sigma offdiag",i4,1x,"to",i4,1x,"of",i4)
#endif
          write(tmpstr,'(a,2i6,a)') 'Working on bands ', sig%off1(peinf%index_offdiag(ioff)), &
            sig%off2(peinf%index_offdiag(ioff)), ' 1st pool'
          call logit(tmpstr)

! <n|Sigma|m> = 0 if n and m belong to different irreducible representations
! Even without assigning representations, we can tell they are different if
! the size of the degenerate subspace is different for n and m.
! This saves time and helps enforce symmetry. -- DAS
          bExactlyZero = .false.
          if(.not. sig%wfn_outer_present .and. sig%offdiagsym .and. &
             kp%degeneracy(sig%off1(peinf%index_offdiag(ioff)), ikn, ispin) /= &
             kp%degeneracy(sig%off2(peinf%index_offdiag(ioff)), ikn, ispin)) then
            if (peinf%inode.eq.0) write(6,'(a)') 'Zero by symmetry -- not computing.'
            ! the matrix elements are zeroed at the beginning, and at the end of the loop
            ! so we can just leave them as they are
            ! JRD - We cannot cycle here because other pools may have legitimate work to do
            ! and we need to be around for the communication.  Particularly inside the subroutine
            ! mtxel_sxch. Thus we can`t really save time here. We could still zero out elements 
            ! at bottom of loop if want. I leave it up to DAS.
            !cycle
            bExactlyZero=.true.
          endif
            
!---------------------
! Compute planewave matrix elements for exact static CH

          if (sig%freq_dep.eq.0.or.sig%exact_ch.eq.1) then
            if (irq_==irq_min) then
              if (peinf%inode.eq.0) call timacc(20,1)
              wfnkoff%nkpt=wfnk%nkpt
              if (mod(peinf%inode,peinf%npes/peinf%npools).eq.0) then
                SAFE_ALLOCATE(wfnkoff%isrtk, (gvec%ng))
                wfnkoff%isrtk=wfnk%isrtk
                SAFE_ALLOCATE(wfnkoff%zk, (2*wfnk%nkpt,1))
              endif
                
! (gsm) begin gathering wavefunctions over pools

! $$$ inefficient communication, this should be rewritten $$$

              do jj=1,peinf%npools
                dest=(jj-1)*(peinf%npes/peinf%npools)
                do ii=1,2
                  i=sig%offmap(peinf%index_offdiag(ioff),ii)
#ifdef MPI
                  call MPI_Bcast(i,1,MPI_INTEGER,dest,MPI_COMM_WORLD,mpierr)
#endif
                  j=(i-1)/peinf%npools+1
                  source=mod(i-1,peinf%npools)*(peinf%npes/peinf%npools)
                  if (peinf%inode.eq.source.and.peinf%inode.eq.dest) then
                    do k=1,wfnk%nkpt
                      wfnkoff%zk((ii-1)*wfnk%nkpt+k,1) = wfnk%zk((j-1)*wfnk%nkpt+k,ispin)
                    enddo
                  else
#ifdef MPI
                    tag=1024
                    if (peinf%inode.eq.source) &
                      call MPI_Send(wfnk%zk((j-1)*wfnk%nkpt+1,ispin),wfnk%nkpt, &
                        MPI_SCALAR,dest,tag,MPI_COMM_WORLD,mpierr)
                    if (peinf%inode.eq.dest) &
                      call MPI_Recv(wfnkoff%zk((ii-1)*wfnk%nkpt+1,1),wfnk%nkpt, &
                        MPI_SCALAR,source,tag,MPI_COMM_WORLD,mpistatus,mpierr)
#else
                    do k=1,wfnk%nkpt
                      wfnkoff%zk((ii-1)*wfnk%nkpt+k,1) = wfnk%zk((j-1)*wfnk%nkpt+k,ispin)
                    enddo
#endif
                  endif
                enddo
              enddo
              
! (gsm) end gathering wavefunctions over pools

              if (peinf%inode.eq.0) call timacc(20,2)
              call logit('Calling mtxel_ch')
              if (peinf%inode.eq.0) call timacc(16,1)
! JRD Everyone does this now YYYY
              if (mod(peinf%inode,peinf%npes/peinf%npools).eq.0) then
                call mtxel_ch(1,2,gvec,wfnkoff,ncoulch,isrtrq,aqsch,1,kp)
              endif
#ifdef MPI
              call MPI_Bcast(aqsch,ncoulch,MPI_SCALAR,0,peinf%pool_comm,mpierr)
#endif
              if (peinf%inode.eq.0) call timacc(16,2)
              if (mod(peinf%inode,peinf%npes/peinf%npools).eq.0) then
                SAFE_DEALLOCATE_P(wfnkoff%isrtk)
                SAFE_DEALLOCATE_P(wfnkoff%zk)
              endif
              if (nrq.gt.1) aqsaugcho(:,ioff,ispin)=aqsch(:)
            else
              aqsch(:)=aqsaugcho(:,ioff,ispin)
            endif
          endif ! sig%freq_dep.eq.0.or.sig%exact_ch.eq.1

!---------------------
! Compute offdiag SX and CH

          if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.2.or.sig%freq_dep.eq.3) then
            call logit('Calling mtxel_sxch for offdiagonal matrix elements')
            if (peinf%inode.eq.0) call timacc(11,1)
          
            call mtxel_sxch(sig%offmap(peinf%index_offdiag(ioff),1), &
             sig%offmap(peinf%index_offdiag(ioff),3), &
             ispin,ncouls,neps,gvec,eps,ph,ind,indinv,isrtrqi, &
             isrtrq,vcoul,crys,sig,wpg,wfnk,wfnkq,ncoulch, &
             aqsaug(:,:,sig%offmap(peinf%index_offdiag(ioff),1),ispin), &
             aqsaug(:,:,sig%offmap(peinf%index_offdiag(ioff),2),ispin), &
             aqsch,asigt_imag,acht_n1,asxt,acht,achtcor,kp%nspin, &
             rq(:,irq),coulfact, &
             inv_igp_index,ngpown, &
             epsR,epsA,achtD_n1,asxtDyn,achtDyn,achtDyn_cor,achtDyn_corb,ach2tDyn,2)

            if (peinf%inode.eq.0) call timacc(11,2)
          endif
          
          if (bExactlyZero) cycle
         
          if (peinf%flag_offdiag(ioff)) then
            achcor(peinf%index_offdiag(ioff)+sig%ndiag,ispin)= &
              achcor(peinf%index_offdiag(ioff)+sig%ndiag,ispin)+ryd*neq(irq)*achtcor
            asig_imag(peinf%index_offdiag(ioff)+sig%ndiag,ispin)= &
              asig_imag(peinf%index_offdiag(ioff)+sig%ndiag,ispin)+ryd*neq(irq)*asigt_imag
            if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.3) then
              do iw=1,nfreqgpp
                asx(iw,peinf%index_offdiag(ioff)+sig%ndiag,ispin)= &
                  asx(iw,peinf%index_offdiag(ioff)+sig%ndiag,ispin)+ryd*neq(irq)*asxt(iw)
                ach(iw,peinf%index_offdiag(ioff)+sig%ndiag,ispin)= &
                  ach(iw,peinf%index_offdiag(ioff)+sig%ndiag,ispin)+ryd*neq(irq)*acht(iw)
              enddo
              do ib=1,sig%ntband
                ach_n1q(ib,peinf%index_offdiag(ioff)+sig%ndiag,ispin) = &
                  ach_n1q(ib,peinf%index_offdiag(ioff)+sig%ndiag,ispin)+neq(irq)*acht_n1(ib)
              enddo
            endif

            if (sig%freq_dep.eq.2) then
              do iw=1,sig%nfreqeval
                asxDyn(iw,peinf%index_offdiag(ioff)+sig%ndiag,ispin) = &
                  asxDyn(iw,peinf%index_offdiag(ioff)+sig%ndiag,ispin)+ryd*neq(irq)*asxtDyn(iw)
                achDyn(iw,peinf%index_offdiag(ioff)+sig%ndiag,ispin) = &
                  achDyn(iw,peinf%index_offdiag(ioff)+sig%ndiag,ispin)+ryd*neq(irq)*achtDyn(iw)
                achDyn_cor(iw,peinf%index_offdiag(ioff)+sig%ndiag,ispin) = &
                  achDyn_cor(iw,peinf%index_offdiag(ioff)+sig%ndiag,ispin)+ryd*neq(irq)*achtDyn_cor(iw)
                achDyn_corb(iw,peinf%index_offdiag(ioff)+sig%ndiag,ispin) = &
                  achDyn_corb(iw,peinf%index_offdiag(ioff)+sig%ndiag,ispin)+ryd*neq(irq)*achtDyn_corb(iw)
                ach2Dyn(iw,peinf%index_offdiag(ioff)+sig%ndiag,ispin) = &
                  ach2Dyn(iw,peinf%index_offdiag(ioff)+sig%ndiag,ispin)+ryd*neq(irq)*ach2tDyn(iw)
              enddo
              do ib=1,sig%ntband
                achD_n1q(ib,peinf%index_offdiag(ioff)+sig%ndiag,ispin) = &
                  achD_n1q(ib,peinf%index_offdiag(ioff)+sig%ndiag,ispin)+neq(irq)*achtD_n1(ib)
              enddo
            endif
          endif
          
!---------------------
! Compute offdiag bare exchange (SKIP this computation if you already know it)

          if (peinf%inode.eq.0) call timacc(18,1)
          if ((.not. sig%use_xdat .and. xflag .and. (.not. sig%coul_mod_flag)) .or. (sig%coul_mod_flag &
            .and. (.not.  sig%use_vxc2dat))) then
            axt=0.0d0
! XXX THREAD?
            do n1=1,peinf%nvband_node
              tempval = wfnkq%ekq(peinf%indext(n1),ispin) - sig%efermi
              if (tempval < sig%tol) then
                if(abs(tempval) < sig%tol) then
                  occ=0.5  ! Fermi-Dirac distribution = 1/2 at Fermi level
                else
                  occ=1D0
                endif
                do ig=1,ncoulb
                  axt=axt+aqsaug(ig,n1,sig%offmap(peinf%index_offdiag(ioff),1),ispin) &
                    *MYCONJG(aqsaug(ig,n1,sig%offmap(peinf%index_offdiag(ioff),2),ispin))*occ &
                    *vcoul(ig)
                enddo
              endif
            enddo
            if (peinf%flag_offdiag(ioff)) then
              ax(peinf%index_offdiag(ioff)+sig%ndiag,ispin)= &
                ax(peinf%index_offdiag(ioff)+sig%ndiag,ispin) - neq(irq)*axt*ryd*sig%xfrac
            endif
          endif ! not using x.dat
          if (peinf%inode.eq.0) call timacc(18,2)
          
        enddo ! ioff (loop over bands for which we need offdiag Sigma)
        
        if (ispin.eq.sig%nspin) then
          SAFE_DEALLOCATE(vcoul)
          if (sig%noffdiag.gt.0) then
            SAFE_DEALLOCATE(aqsaug)
          end if
          if ((sig%freq_dep.eq.0.or.sig%exact_ch.eq.1).and.irq_==nrq) then
            SAFE_DEALLOCATE_P(aqsch)
            if (nrq.gt.1.and.sig%noffdiag.gt.0) then
              SAFE_DEALLOCATE_P(aqsaugcho)
            end if
          endif
        endif
          
!!-------- End offdiag band loop -----------------------------------------------


      enddo ! ispin

!!-------- End spin loop -------------------------------------------------------

!---------------------
! Add up contributions from all PEs

      if (sig%freq_dep.eq.-1.or.sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.3) then
        SAFE_ALLOCATE(xdum1, ((3+2*nfreqgpp)*(sig%ndiag+sig%noffdiag),sig%nspin))
        do ispin=1,sig%nspin
          do in=1,sig%ndiag+sig%noffdiag
            idum = (in - 1) * (3 + 2*nfreqgpp)
            xdum1(idum+1,ispin) = ax(in,ispin)
            xdum1(idum+2:idum+1+nfreqgpp,ispin) = asx(:,in,ispin)
            xdum1(idum+2+nfreqgpp:idum+1+2*nfreqgpp,ispin) = ach(:,in,ispin)
            xdum1(idum+2+2*nfreqgpp,ispin) = SCALARIFY(achcor(in,ispin))
            xdum1(idum+3+2*nfreqgpp,ispin) = SCALARIFY(asig_imag(in,ispin))

          enddo
        enddo
      endif
      if (sig%freq_dep.eq.2) then
        nfold = (5*sig%nfreqeval+2)            
        SAFE_ALLOCATE(xdum1Dyn, (nfold*(sig%ndiag+sig%noffdiag),sig%nspin))
        do ispin=1,sig%nspin
          do in=1,sig%ndiag+sig%noffdiag
            idum = (in - 1) * nfold
            xdum1Dyn(idum+1,ispin) = ax(in,ispin)
            do ifold = 1, sig%nfreqeval
              xdum1Dyn(idum+1+ifold,ispin) = asxDyn(ifold,in,ispin)
            enddo
            do ifold = 1, sig%nfreqeval
              xdum1Dyn(idum+1+sig%nfreqeval+ifold,ispin) = achDyn(ifold,in,ispin)
            enddo
            do ifold = 1, sig%nfreqeval
              xdum1Dyn(idum+1+2*sig%nfreqeval+ifold,ispin) = achDyn_cor(ifold,in,ispin)
            enddo
            do ifold = 1, sig%nfreqeval
              xdum1Dyn(idum+1+3*sig%nfreqeval+ifold,ispin) = achDyn_corb(ifold,in,ispin)
            enddo
            do ifold = 1, sig%nfreqeval
              xdum1Dyn(idum+1+4*sig%nfreqeval+ifold,ispin) = ach2Dyn(ifold,in,ispin)
            enddo
            xdum1Dyn(idum+5*sig%nfreqeval+2,ispin) = achcor(in,ispin)
          enddo
        enddo
      endif
      
#ifdef MPI
      call logit('Calling MPI_Allreduce xdum1 to xdum2')
#endif
      if (sig%freq_dep.eq.-1.or.sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.3) then
        SAFE_ALLOCATE(xdum2, ((3+2*nfreqgpp)*(sig%ndiag+sig%noffdiag),sig%nspin))
        ndum=(sig%ndiag+sig%noffdiag)*(3+2*nfreqgpp)*sig%nspin
#ifdef MPI
        call MPI_Allreduce(xdum1(1,1),xdum2(1,1),ndum,MPI_SCALAR,MPI_SUM,MPI_COMM_WORLD,mpierr)
#else
        xdum2=xdum1
#endif
        SAFE_DEALLOCATE(xdum1)
      endif
      if (sig%freq_dep.eq.2) then
        ndum=(sig%ndiag+sig%noffdiag)*nfold*sig%nspin
        SAFE_ALLOCATE(xdum2Dyn, (nfold*(sig%ndiag+sig%noffdiag),sig%nspin))
#ifdef MPI
        call MPI_Allreduce(xdum1Dyn(1,1),xdum2Dyn(1,1),ndum,MPI_COMPLEX_DPC,MPI_SUM,MPI_COMM_WORLD,mpierr)
#else
        xdum2Dyn=xdum1Dyn
#endif
        SAFE_DEALLOCATE(xdum1Dyn)
      endif
      call logit('Done reduction of xdum1 to xdum2')
      
      if (sig%freq_dep.eq.-1.or.sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.3) then
        do ispin=1,sig%nspin
          do in=1,sig%ndiag+sig%noffdiag
            idum = (in - 1) * (3 + 2*nfreqgpp)
            axbis(in,ispin) = axbis(in,ispin) + xdum2(idum+1,ispin)
            asxbis(:,in,ispin) = asxbis(:,in,ispin) + xdum2(idum+2:idum+1+nfreqgpp,ispin)
            achbis(:,in,ispin) = achbis(:,in,ispin) + xdum2(idum+2+nfreqgpp:idum+1+2*nfreqgpp,ispin)
            achcorbis(in,ispin) = achcorbis(in,ispin) + xdum2(idum+2+2*nfreqgpp,ispin)
            asig_imagbis(in,ispin) = asig_imagbis(in,ispin) + xdum2(idum+3+2*nfreqgpp,ispin)
            if(.not. sig%use_xdat) ax(in,ispin) = ZERO
            asx(:,in,ispin) = ZERO
            ach(:,in,ispin) = ZERO
            achcor(in,ispin) = (0.0d0,0.0d0)
            asig_imag(in,ispin) = (0.0d0,0.0d0)
          enddo
        enddo
        SAFE_DEALLOCATE(xdum2)
      endif
      if (sig%freq_dep.eq.2) then
        do ispin=1,sig%nspin
          do in=1,sig%ndiag+sig%noffdiag
            idum = (in - 1) * nfold
            axbis(in,ispin) = axbis(in,ispin) + xdum2Dyn(idum+1,ispin)
            do ifold = 1, sig%nfreqeval
              asxDbis(ifold,in,ispin) = asxDbis(ifold,in,ispin) + xdum2Dyn(idum+1+ifold,ispin)
            enddo
            do ifold = 1, sig%nfreqeval
              achDbis(ifold,in,ispin) = achDbis(ifold,in,ispin) + xdum2Dyn(idum+1+sig%nfreqeval+ifold,ispin)
            enddo
            do ifold = 1, sig%nfreqeval
              achDbis_cor(ifold,in,ispin) = achDbis_cor(ifold,in,ispin) + xdum2Dyn(idum+1+2*sig%nfreqeval+ifold,ispin)
            enddo
            do ifold = 1, sig%nfreqeval
              achDbis_corb(ifold,in,ispin) = achDbis_corb(ifold,in,ispin) + xdum2Dyn(idum+1+3*sig%nfreqeval+ifold,ispin)
            enddo
            do ifold = 1, sig%nfreqeval
              ach2Dbis(ifold,in,ispin) = ach2Dbis(ifold,in,ispin) + &
                xdum2Dyn(idum+1+4*sig%nfreqeval+ifold,ispin)
            enddo
            achcorbis(in,ispin) = achcorbis(in,ispin) + xdum2Dyn(idum+5*sig%nfreqeval+2,ispin)
            if(.not. sig%use_xdat) ax(in,ispin) = ZERO
            asxDyn(:,in,ispin) = (0.0d0,0.0d0)
            achDyn(:,in,ispin) = (0.0d0,0.0d0)
            achDyn_cor(:,in,ispin) = (0.0d0,0.0d0)
            achDyn_corb(:,in,ispin) = (0.0d0,0.0d0)
            ach2Dyn(:,in,ispin) = (0.0d0,0.0d0)
            achcor(in,ispin) = (0.0d0, 0.0d0)
          enddo
        enddo
        SAFE_DEALLOCATE(xdum2Dyn)
      endif
      
      in = sig%ntband * (sig%ndiag + sig%noffdiag) * sig%nspin
      if (sig%freq_dep.eq.-1.or.sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.3) then
        SAFE_ALLOCATE(xdum3, (sig%ntband,sig%ndiag+sig%noffdiag,sig%nspin))
        xdum3 = ach_n1q
#ifdef MPI
        call MPI_Allreduce(xdum3(1,1,1),ach_n1q(1,1,1),in,MPI_SCALAR,MPI_SUM,MPI_COMM_WORLD,mpierr)
#endif
        SAFE_DEALLOCATE(xdum3)
        do ispin = 1, sig%nspin
          do in = 1, sig%ndiag + sig%noffdiag
            do ib = 1, sig%ntband
              ach_n1(ib,in,ispin) = ach_n1(ib,in,ispin) + ach_n1q(ib,in,ispin)
              ach_n1q(ib,in,ispin) = 0.0d0
            enddo
          enddo
        enddo
      endif
      if (sig%freq_dep.eq.2) then
        SAFE_ALLOCATE(xdum3Dyn, (sig%ntband,sig%ndiag+sig%noffdiag,sig%nspin))
        xdum3Dyn = achD_n1q
#ifdef MPI
        call MPI_Allreduce(xdum3Dyn(1,1,1),achD_n1q(1,1,1),in,MPI_COMPLEX_DPC,MPI_SUM,MPI_COMM_WORLD,mpierr)
#endif
        SAFE_DEALLOCATE(xdum3Dyn)
        do ispin = 1, sig%nspin
          do in = 1, sig%ndiag + sig%noffdiag
            do ib = 1, sig%ntband
              achD_n1(ib,in,ispin) = achD_n1(ib,in,ispin) + achD_n1q(ib,in,ispin)
              achD_n1q(ib,in,ispin) = 0.0d0
            enddo
          enddo
        enddo
      endif
    enddo ! irq (loop over rq point in BZ summation)
    call progress_free(prog_info)
    
!!-------- End loop over k-points in irr bz with respect to kn (rq) ------------


    if (sig%freq_dep.eq.-1.or.sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.3) then
      do ispin=1,sig%nspin
        do in=1,sig%ndiag+sig%noffdiag
          if(.not. sig%use_xdat) ax(in,ispin) = axbis(in,ispin)
          asx(:,in,ispin) = asxbis(:,in,ispin)
          ach(:,in,ispin) = achbis(:,in,ispin)
          achcor(in,ispin) = achcorbis(in,ispin)
          asig_imag(in,ispin) = asig_imagbis(in,ispin)
        enddo
      enddo
    endif
    if (sig%freq_dep.eq.2) then
      do ispin=1,sig%nspin
        do in=1,sig%ndiag+sig%noffdiag
          if(.not. sig%use_xdat) ax(in,ispin) = axbis(in,ispin)
          asxDyn(:,in,ispin) = asxDbis(:,in,ispin)
          achDyn(:,in,ispin) = achDbis(:,in,ispin)
          achDyn_cor(:,in,ispin) = achDbis_cor(:,in,ispin)
          achDyn_corb(:,in,ispin) = achDbis_corb(:,in,ispin)
          ach2Dyn(:,in,ispin) = ach2Dbis(:,in,ispin)
          achcor(in,ispin) = achcorbis(in,ispin)
        enddo
      enddo
    endif
    
!----------------------------
! Output unsymmetrized values of X,SX,CH
! Symmetrize X,SX,CH matrix elements over degenerate states
! Convert to eV and output symmetrized values of X,SX,CH

    if (peinf%inode.eq.0) then

      ! This beautiful piece of code should never be executed and here only because it somehow
      ! prevents gfortran from an incorrect optimization of this routine that will produce NaNs.
      ! It has some mysterious relation to the ijk loop above reading from iunit_eps.
      ! Insanely, the presence of function 'isNaN' appears to be crucial here. --DAS
#ifdef GNU
      if(ikn == -1) then
        call die("BUG: ikn = -1")
        write(0,*) isNaN(fact)
      endif
#endif

      do ispin=1,sig%nspin
        write(6,989)ikn,sig%spin_index(ispin)
        if (sig%freq_dep.eq.-1.or.sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.3) then
          write(6,988)
          do i=1,sig%ndiag
            write(6,987)sig%diag(i),wfnk%elda(sig%diag(i),ispin), &
              wfnk%ek(sig%diag(i),ispin),dble(ax(i,ispin))*ryd, &
              dble(asx(2,i,ispin))*ryd,dble(ach(2,i,ispin)+achcor(i,ispin))*ryd, &
              dble(ax(i,ispin)+asx(2,i,ispin)+ach(2,i,ispin)+achcor(i,ispin))*ryd, &
              dble(alda(i,ispin))*ryd
          enddo
        endif
          
        if (sig%freq_dep.eq.2) then
          write(6,888)
          do i=1,sig%ndiag
            
! JRD: Find iw closest to e_lk

            diffmin = INF
            e_lk = wfnk%ek(sig%diag(i),ispin)
            do iw=1,sig%nfreqeval
              diff = abs(sig%freqevalmin + (iw-1)*sig%freqevalstep - e_lk)
              if (diff .lt. diffmin) then
                diffmin=diff
                iwlda=iw
              endif
            enddo
            
            write(6,887)sig%diag(i),wfnk%elda(sig%diag(i),ispin), &
              wfnk%ek(sig%diag(i),ispin),dble(ax(i,ispin))*ryd, &
              dble(asxDyn(iwlda,i,ispin))*ryd,dble(achDyn(iwlda,i,ispin)+achcor(i,ispin))*ryd, &
              dble(ax(i,ispin)+asxDyn(iwlda,i,ispin)+achDyn(iwlda,i,ispin)+achcor(i,ispin))*ryd, &
              dble(alda(i,ispin))*ryd, &
              IMAG(asxDyn(iwlda,i,ispin))*ryd,IMAG(achDyn(iwlda,i,ispin))*ryd, &
              IMAG(ax(i,ispin)+asxDyn(iwlda,i,ispin)+achDyn(iwlda,i,ispin))*ryd, &
              IMAG(ax(i,ispin)+asxDyn(iwlda,i,ispin)+ach2Dyn(iwlda,i,ispin))*ryd
          enddo
        endif
      enddo
    endif ! node 0
989 format(1x,"Unsymmetrized values for ik =",i4,1x,"spin =",i2)
988 format(/,3x,"n",5x,"elda",5x,"ecor",8x,"x",5x,"sx-x",7x,"ch",6x,"sig",6x,"vxc")
987 format(i4,7f9.3)
888 format(/,3x,"n",4x,"elda",5x,"ecor",8x,"x",2x,"re sx-x",4x,"re ch",3x,"re sig",6x,"vxc",/,&
      33x,"im sx-x",4x,"im ch",3x,"im sig",2x,"im sig2")
887 format(i4,7f9.3,/,28x,4f9.3)
      
!----------------------------
! Symmetrize matrix elements

    if (sig%freq_dep.eq.-1.or.sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.3) then
      call shiftenergy(sig,wfnk,alda,asx,ach,achcor,ax,efsto,asig,enew,zrenorm,nfreqgpp)
    endif
    if (sig%freq_dep.eq.2) then
      call shiftenergy_dyn(sig,wfnk,alda,asxDyn,achDyn,achDyn_cor,achDyn_corb,ach2Dyn,achcor,ax,efstoDyn,asigDyn,ikn,kp)
    endif
    
!----------------------------
! Write out matrix elements

    if (peinf%inode.eq.0) then
      write(6,'(a)')
      write(6,'(a)') ' Symmetrized values from band-averaging:'

      if (sig%freq_dep.eq.-1.or.sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.3) then
        call write_result(kp,wfnk,sig,ach_n1,ax,asx,ach,achcor,asig,alda,efsto,enew,zrenorm,ikn)
        call write_result_hp(kp,wfnk,sig,ax,asx,ach,achcor,asig,alda,efsto,enew,zrenorm,ikn)
        if (sig%freq_dep.eq.1.or.sig%freq_dep.eq.3) then
          do ispin=1,sig%nspin
            do i=1,sig%ndiag
              if (abs(efsto(i,ispin)+SCALARIFY(achcor(i,ispin)) - wfnk%ek(sig%diag(i),ispin)).gt.sig%dw) then
                eqp1flag=.true.
              endif
            enddo
          enddo
        endif
      endif
      
      if (sig%freq_dep.eq.2) then
        call write_result_dyn(kp,wfnk,sig,achD_n1,ax,asxDyn,achDyn,achDyn_corb,achcor,asigDyn,alda,efstoDyn,ikn)
        call write_result_dyn_hp(kp,wfnk,sig,ax,asxDyn,achDyn,achDyn_corb,achcor,asigDyn,alda,efstoDyn,ikn)
      endif
    endif

    if(peinf%inode == 0) then

!----------------------------
! If not using vxc.dat, create and write Vxc in it

      call timacc(5,1)
      if(.not. sig%use_vxcdat) then
        call write_matrix_elements_type(120, kp%rk(:, ikn), sig, COMPLEXIFY(alda(:,:)))
      endif
      call timacc(5,2)
      
!----------------------------
! If not using x.dat, create and write X in it

      call timacc(18,1)
      if (sig%coul_mod_flag .and. (.not. sig%use_vxc2dat)) then
        call write_matrix_elements_type(121, kp%rk(:, ikn), sig, COMPLEXIFY(ax(:,:)))
      else if((.not. sig%use_xdat) .and. xflag .and. (.not. sig%coul_mod_flag)) then
        ax(:,:) = ax(:,:) / sig%xfrac
        call write_matrix_elements_type(119, kp%rk(:, ikn), sig, COMPLEXIFY(ax(:,:)))
      endif
      call timacc(18,2)
      
    endif
    
    SAFE_DEALLOCATE(indrq)
    SAFE_DEALLOCATE(neq)
    SAFE_DEALLOCATE(itnrq)
    SAFE_DEALLOCATE(rq)
    SAFE_DEALLOCATE(kg0)
    SAFE_DEALLOCATE_P(wfnk%zk)
    
  enddo ! ika (loop over k-points sig%nkn)

  call dealloc_grid(gr)
  call destroy_qran() ! from vcoul_generator

!--------- End loop over rkn points (for which we calculate sigma) -------------

  
  if (peinf%inode.eq.0) then
    if (sig%freq_dep.eq.2) then
      write(6,778)
      write(7,778)
      write(8,778)
    endif
    write(6,777)
    write(7,777)
    write(8,777)
    if (sig%noffdiag.gt.0) then
      write(6,776)
      write(7,776)
      write(8,776)
    endif
  endif
778 format(/,1x,"eqp0 eigenvalue at nearest energy to quasiparticle eigenvalue", &
      /,1x,"for eqp0(omega) look at spectrum.dat")
777 format( &
      /,4x,"n = band index", &
      /,1x,"elda = energy eigenvalue", &
      /,1x,"ecor = corrected energy eigenvalue", &
      /,4x,"x = bare exchange", &
      /,3x,"sx = screened exchange at energy ecor", &
      /,3x,"ch = coulomb hole at energy ecor", &
      /,2x,"sig = sx + ch = self-energy at energy ecor", &
      /,2x,"vxc = exchange-correlation potential", &
      /,1x,"eqp0 = elda - vxc + sig(ecor)", &
      /,1x,"eqp1 = eqp0 + (dsig/de) / (1 - dsig/de) * (eqp0 - ecor)", &
      /,2x,"Znk = quasiparticle renormalization factor",/, &
      /,8x,"finite_difference_form from sigma.inp file:", &
      /,8x,"none     = -2 : dsig/de = 0 [skip the expansion]", &
      /,8x,"backward = -1 : dsig/de = (sig(ecor) - sig(ecor-de)) / de", &
      /,8x,"central  =  0 : dsig/de = (sig(ecor+de) - sig(ecor-de)) / (2*de)", &
      /,8x,"forward  =  1 : dsig/de = (sig(ecor+de) - sig(ecor)) / de", &
      /,8x,"default  =  2 : forward for diagonal and none for off-diagonal", &
      /,8x,"de is finite_difference_spacing from sigma.inp file", &
      /,8x,"elda,ecor,x,sx,ch,sig,vxc,eqp0,eqp,de are in eV", &
      /,8x,"elda and vxc both contain vxc0 so it cancels out", &
      /,8x,"eqp1 and eqp0 are Eqs. (36-37) from Hybertsen & Louie PRB 34 5390",/)
776 format( &
      4x,"n = band index of bra wavefunction", &
      /,4x,"m = band index of ket wavefunction", &
      /,4x,"l = band index of energy eigenvalue",/, &
      /,1x,"< psi_n(k) |       x       | psi_m(k) >" &
      /,1x,"< psi_n(k) | sx(ecor_l(k)) | psi_m(k) >" &
      /,1x,"< psi_n(k) | ch(ecor_l(k)) | psi_m(k) >" &
      /,1x,"< psi_n(k) |      vxc      | psi_m(k) >",/)
  
  if (peinf%inode.eq.0) then
    if (eqp1flag) then
      write(0,666)
    endif
  endif
666 format( &
      1x,"WARNING: |eqp0 - ecor| > finite_difference_spacing",/, &
      3x,"Linear extrapolation for eqp1 may be inaccurate.",/, &
      3x,"You should test the validity of eqp1 by rerunning",/, &
      3x,"calculation with self-energy evaluated at the eqp0",/, &
      3x,"energies. For that, use the eqp_outer.dat file",/, &
      3x,"created with eqp.py script and point WFN_outer to WFN_inner",/, &
      3x,"if you were not already using WFN_outer.",/)
  
  if (peinf%inode.eq.0) then
    if (imagvxcflag) write(0,677) 'Vxc'
    if (imagxflag) write(0,677) 'exchange'
  endif
677 format( &
      1x,"WARNING: ",a," diagonal matrix elements have large imaginary part.",/, &
      3x,"This may indicate a problem with your calculation.",/)
  
    
!--------- Clean Up and Finish -------------------------------------------------

  call destroy_fftw_plans()

  if (sig%spl_tck%n>0) then
    SAFE_DEALLOCATE_P(sig%spl_tck%t)
    SAFE_DEALLOCATE_P(sig%spl_tck%c)
  endif
  if (sig%spl_tck_outer%n>0) then
    SAFE_DEALLOCATE_P(sig%spl_tck_outer%t)
    SAFE_DEALLOCATE_P(sig%spl_tck_outer%c)
  endif

  SAFE_DEALLOCATE_P(kp%rk)
  SAFE_DEALLOCATE_P(wfnk%isrtk)
  SAFE_DEALLOCATE_P(wfnk%ek)
  SAFE_DEALLOCATE_P(wfnk%elda)
  SAFE_DEALLOCATE_P(sig%qpt)
  if (sig%ndiag.ne.0) then
    SAFE_DEALLOCATE_P(sig%diag)
  end if
  if (sig%noffdiag.gt.0) then
    SAFE_DEALLOCATE_P(sig%off1)
    SAFE_DEALLOCATE_P(sig%off2)
    SAFE_DEALLOCATE_P(sig%off3)
    SAFE_DEALLOCATE_P(sig%offmap)
  endif
  SAFE_DEALLOCATE_P(sig%indkn)
  if(.not. sig%use_vxcdat) then
    SAFE_DEALLOCATE_P(sig%vxc)
  end if
  SAFE_DEALLOCATE_P(gvec%components)
  SAFE_DEALLOCATE_P(gvec%index_vec)
  if(sig%freq_dep.eq.1) then
    SAFE_DEALLOCATE_P(wpg%rho)
  endif
  SAFE_DEALLOCATE_P(wfnkq%isrtkq)
  SAFE_DEALLOCATE_P(wfnkq%ekq)
  SAFE_DEALLOCATE_P(peinf%indext)
  SAFE_DEALLOCATE_P(peinf%indext_dist)
  SAFE_DEALLOCATE_P(peinf%ntband_dist)
  SAFE_DEALLOCATE(alda)
  SAFE_DEALLOCATE(ax)
  SAFE_DEALLOCATE(axbis)
  SAFE_DEALLOCATE(achcor)
  SAFE_DEALLOCATE(achcorbis)
  SAFE_DEALLOCATE(asig_imag)
  if (sig%freq_dep.eq.-1.or.sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.3) then
    SAFE_DEALLOCATE(asx)
    SAFE_DEALLOCATE(ach)
    SAFE_DEALLOCATE(asig)
    SAFE_DEALLOCATE_P(acht_n1)
    SAFE_DEALLOCATE(ach_n1q)
    SAFE_DEALLOCATE(ach_n1)
    SAFE_DEALLOCATE(asxbis)
    SAFE_DEALLOCATE(achbis)
    SAFE_DEALLOCATE(enew)
    SAFE_DEALLOCATE(efsto)
  endif
  if (sig%freq_dep.eq.2) then
    SAFE_DEALLOCATE(asxDyn)
    SAFE_DEALLOCATE(achDyn)
    SAFE_DEALLOCATE(achDyn_cor)
    SAFE_DEALLOCATE(achDyn_corb)
    SAFE_DEALLOCATE(ach2Dyn)
    SAFE_DEALLOCATE(asigDyn)
    SAFE_DEALLOCATE_P(achtD_n1)
    SAFE_DEALLOCATE(achD_n1q)
    SAFE_DEALLOCATE(achD_n1)
    SAFE_DEALLOCATE(asxDbis)
    SAFE_DEALLOCATE(achDbis)
    SAFE_DEALLOCATE(achDbis_cor)
    SAFE_DEALLOCATE(achDbis_corb)
    SAFE_DEALLOCATE(ach2Dbis)
    SAFE_DEALLOCATE(efstoDyn)
    SAFE_DEALLOCATE_P(asxtDyn)
    SAFE_DEALLOCATE_P(achtDyn)
    SAFE_DEALLOCATE_P(achtDyn_cor)
    SAFE_DEALLOCATE_P(achtDyn_corb)
    SAFE_DEALLOCATE_P(ach2tDyn)
  endif
  if (sig%freq_dep.eq.1.or.sig%freq_dep.eq.3) then
    SAFE_DEALLOCATE_P(acht)
    SAFE_DEALLOCATE_P(asxt)
  endif
  if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1) then
    SAFE_DEALLOCATE_P(eps)
    if (sig%iwriteint.eq.0) then
      SAFE_DEALLOCATE(epstemp)
    end if
  endif
  if (sig%freq_dep.eq.2.or.sig%freq_dep.eq.3) then
    SAFE_DEALLOCATE_P(epsR)
    SAFE_DEALLOCATE(epsRtemp)
#ifdef CPLX
    SAFE_DEALLOCATE_P(epsA)
    SAFE_DEALLOCATE(epsAtemp)
#endif
  endif
  SAFE_DEALLOCATE(isrtrq)
  if (sig%freq_dep.eq.0.or.sig%exact_ch.eq.1) then
    SAFE_DEALLOCATE_P(isrtrqi)
  endif
  SAFE_DEALLOCATE(ekin)
  if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.2.or.sig%freq_dep.eq.3) then
    SAFE_DEALLOCATE(isrtq)
    SAFE_DEALLOCATE(isrtqi)
    SAFE_DEALLOCATE(ind)
    SAFE_DEALLOCATE(indinv)
    SAFE_DEALLOCATE(ph)
    if(sig%iwriteint.eq.1) then
      if (peinf%inode .eq. 0) then
        SAFE_DEALLOCATE_P(epsmpi%isrtq)
        SAFE_DEALLOCATE_P(epsmpi%isrtqi)
      endif
      SAFE_DEALLOCATE_P(epsmpi%qk)
      SAFE_DEALLOCATE_P(epsmpi%nmtx)
      SAFE_DEALLOCATE_P(epsmpi%igp_owner)
      SAFE_DEALLOCATE_P(epsmpi%igp_index)
      SAFE_DEALLOCATE_P(epsmpi%inv_igp_index)
      if(sig%freq_dep.eq.0.or.sig%freq_dep.eq.1) then
        SAFE_DEALLOCATE_P(epsmpi%eps)
      else
        SAFE_DEALLOCATE_P(epsmpi%epsR)
#ifdef CPLX
        SAFE_DEALLOCATE_P(epsmpi%epsA)
#endif
      endif
    endif
  endif
  if (sig%iwriteint.eq.1) then
    SAFE_DEALLOCATE_P(wfnkqmpi%nkptotal)
    SAFE_DEALLOCATE_P(wfnkqmpi%isort)
    SAFE_DEALLOCATE_P(wfnkqmpi%el)
    SAFE_DEALLOCATE_P(wfnkqmpi%qk)
    SAFE_DEALLOCATE_P(wfnkqmpi%band_index)
    SAFE_DEALLOCATE_P(wfnkqmpi%cg)
    if(sig%nkn.gt.1) then
      SAFE_DEALLOCATE_P(wfnkmpi%nkptotal)
      SAFE_DEALLOCATE_P(wfnkmpi%isort)
      SAFE_DEALLOCATE_P(wfnkmpi%qk)
      SAFE_DEALLOCATE_P(wfnkmpi%el)
      SAFE_DEALLOCATE_P(wfnkmpi%elda)
      SAFE_DEALLOCATE_P(wfnkmpi%cg)
    endif
  endif
  if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.2.or.sig%freq_dep.eq.3) then
    SAFE_DEALLOCATE(igp_owner)
    SAFE_DEALLOCATE(igp_index)
    SAFE_DEALLOCATE(inv_igp_index)
  endif
    
!----------------------------
! Time Accounting
    
  routnam(1)='TOTAL:'
  routnam(2)='INPUT:'
  routnam(3)='EPSCOPY:'
  routnam(4)='FULLBZ:'
  routnam(5)='VXC:'
  routnam(6)='SUBGRP:'
  routnam(7)='IRRBZ:'
  routnam(8)='GMAP:'
  routnam(9)='GENWF:'
  routnam(10)='MTXEL:'
  routnam(11)='SXCH TOT.:'
!  routnam(12)='SX CH (WPEFF):'
  routnam(13)='VCOUL:'
  routnam(14)='EPSREAD:'
  routnam(15)='INPUT_OUTER:'
  routnam(16)='MTXEL_CH:'
  routnam(17)='MTXEL COMM:'
  routnam(18)='BARE X:'
  routnam(19)='WF COMM:'
  routnam(20)='WF_CH COMM:'
  routnam(21)='INPUT (READ):'
  routnam(22)='INPUT (WRITE):'
  routnam(41)='SXCH INIT:'
  routnam(42)='SXCH EPS INIT:'
  routnam(43)='SXCH COMM:'
  routnam(44)='SXCH EX. STAT:'
  routnam(45)='SXCH WPLASMA:'
  routnam(46)='SXCH PP PARS:'
  routnam(49)='SXCH FF CH:'
  routnam(50)='SXCH FF CHX:'
  routnam(51)='SXCH REMAIN:'
  routnam(52)='SXCH PP SUM:'
  routnam(53)='SXCH FF SX:'
  routnam(59)='READ NEPS:'
  routnam(61)='EPSCOPY IO:'
  routnam(62)='EPSCOPY COMM:'
  routnam(81)='INPUT I/O'
  routnam(82)='INPUT COMM'
  routnam(91)='FFT ZERO'
  routnam(92)='FFT PUT'
  routnam(93)='FFT PLAN'
  routnam(94)='FFT EXEC'
  routnam(95)='FFT MLTPLY'
  
  routsrt=(/ 1, 4, 7, 6, 8, 2,81,82,21,22,15, 9, 19,20,3,61,62,59,14,10,16, &
             17,13,5,18,11,41,42,43,44,51,45,46,52,53,49,50,91,92,93,94,95/)
  
  if(peinf%inode.eq.0) then
    call timacc(1,2)
    write(6,9000)
    do i=2,ubound(routsrt, 1)
      call timacc(routsrt(i),3,tsec,ncount)
      write(6,9001) routnam(routsrt(i)),tsec(1),tsec(2),ncount
    enddo
    write(6,*)
    call timacc(routsrt(1),3,tsec,ncount)
    write(6,9002) routnam(routsrt(1)),tsec(1),tsec(2)
    write(6,*)
9000 format(/,22x,"CPU [s]",8x,"WALL [s]",11x,"#",/)
9001 format(a16,f13.3,3x,f13.3,3x,i9)
9002 format(a16,f13.3,3x,f13.3)
  endif
  
!----------------------------
! Close files and finish

  call close_file(55) ! file sigma.inp
  if(peinf%inode == 0) then
    call close_file(7) ! file sigma.log
    call close_file(8) ! file sigma_hp.log
    if (sig%coul_mod_flag .and. (.not. sig%use_vxc2dat)) then
      call close_file(121) ! file vxc2.dat
    elseif ((.not. sig%use_xdat) .and. xflag .and. (.not. sig%coul_mod_flag)) then
      call close_file(119) ! file x.dat
    endif
    if(.not. sig%use_vxcdat) then
      call close_file(120) ! file vxc.dat
    end if
    if (.not.(sig%freq_dep .eq. 0 .and. sig%exact_ch .eq. 1)  .and. .not. (sig%freq_dep == -1)) then
      call close_file(127) ! file ch_converge.dat
    endif
    if (sig%iwritecoul .eq. 1) then
      call close_file(19) ! file vcoul
    endif
  endif  
  if (peinf%inode.eq.0 .and. (sig%freq_dep.eq.2 .or. (sig%fdf.eq.-3 .and. sig%freq_dep.eq.1))) then
    write(8000, '(/,a)')'# Please refer to Sigma/README for more information about this file.'
    call close_file(8000) ! file spectrum.dat
  endif
  if (sig%iwriteint .eq. 0) then
    if (peinf%inode.eq.0 .and. sig%freq_dep >= 0) then
      call open_file(iunit_eps, file=fne, status='old')
      call close_file(iunit_eps, delete = .true.)
    endif
    call open_file(iunit_c, file=fnc, status='old')
    call close_file(iunit_c, delete = .true.) ! files INT_CWFN_*
    if (mod(peinf%inode,peinf%npes/peinf%npools).eq.0) then
      call open_file(iunit_k, file=fnk, status='old')
      call close_file(iunit_k, delete = .true.) ! files INT_WFNK_*
    endif
  endif
  
  call write_memory_usage()

#ifdef HDF5

  if(sig%use_hdf5) call h5close_f(error)

#endif

#ifdef MPI
  call MPI_Finalize(mpierr)
#endif

end program sigma

!=========================================================================
!
! Utilities:
!
! (1) eps0sym     Originally by MJ      Last Modified 1/12/2010 (MJ)
!
!     This utility symmetrizes eps0mat file.
!
!=========================================================================

#include "f_defs.h"

program eps0sym

  use global_m
  use epsread_hdf5_m
  use epswrite_hdf5_m
#ifdef HDF5
  use hdf5
#endif
  use write_matrix_m

  implicit none
  
  character :: ajname*6,adate*11,outfile*80,infile*80
  real(DP)  :: ecuts
  real(DP), allocatable :: dFreqGrid(:), epsdiag(:,:,:)
  complex(DPC), allocatable :: dFreqBrd(:)
  integer   :: i,ig,j, &
    ng,ngq,nmtx, &
    ii,qgrid(3),freq_dep,nFreq, &
    jj,kk,ll,nargs,imap,iout, &
    nq, gx, gy, gz, gmax, &
    ig0, igx, igy, igz, jgx, jgy, jgz, jout  
  real(DP), allocatable :: ekin(:)
  real(DP) :: q(3,1), qk(3,1), errorMax
  SCALAR, allocatable :: eps(:,:), tempeps(:,:)
  SCALAR :: errorMaxTemp
  integer, allocatable :: isort(:),isorti(:),kx(:),ky(:),kz(:)
  integer, allocatable :: minusgidx(:), map(:), old(:,:)
  integer :: nmtx0_of_q(1), isize, error
  logical :: use_hdf5
#ifdef HDF5
  integer(HID_T) :: file_id
#endif
  
  write(6,*) MYFLAVOR // ' version is used to symmetrize file'
  
!------------------
! Get file names from command-line arguments

  nargs = iargc()
  
  if (nargs .ne. 2) then
    call die('Usage: eps0sym eps0mat_in eps0mat_out')
  endif
  
  call getarg(1,infile)
  call getarg(2,outfile)
  
  use_hdf5 = .false.
#ifdef HDF5

  call h5open_f(error)

  call h5fopen_f(trim(infile), H5F_ACC_RDONLY_F, file_id, error)
  if(error == 0) use_hdf5 = .true.

  if(use_hdf5) then
    call read_eps_grid_sizes_hdf5(ngq,nq,ecuts,nFreq,nmtx,qgrid,infile)
    freq_dep = 0
    if (nFreq .gt. 1) freq_dep = 2
    if (freq_dep.ne.0) then
      call die('eps0sym: Full frequency not supported')
    endif
    ng = ngq
    
    call read_eps_qgrid_hdf5(nq,q,nmtx0_of_q,infile)
    qk = q
  else

#endif
  
    call open_file(unit=11,file=TRUNC(infile),form='unformatted',status='old')

!--------------------------
!  Read in the eps0mat file
!

    read(11) ajname,adate
    read(11) freq_dep,nFreq
    if (freq_dep.ne.0) then
      call die('eps0sym: Full frequency not supported')
    endif
    read(11) (qgrid(ii),ii=1,3)
    if (freq_dep .eq. 2) then
      SAFE_ALLOCATE(dFreqGrid,(nFreq))
      SAFE_ALLOCATE(dFreqBrd,(nFreq))
      read(11) (dFreqGrid(i),i=1,nFreq),(dFreqBrd(i),i=1,nFreq)
    else
      read(11)
    endif
    read(11)
    read(11)
    read(11) ecuts
    read(11) nq,(q(j,1),j=1,3)
    !if (nq .ne. 1) then
    !  call die('This only works for the q->0 point.')
    !endif
    read(11) ng
    read(11) ngq,nmtx
    
    call close_file(11)

#ifdef HDF5
  endif
#endif

  SAFE_ALLOCATE(kx, (ng))
  SAFE_ALLOCATE(ky, (ng))
  SAFE_ALLOCATE(kz, (ng))
  SAFE_ALLOCATE(isort, (ngq))
  SAFE_ALLOCATE(isorti, (ngq))
  SAFE_ALLOCATE(ekin, (ngq))
  SAFE_ALLOCATE(eps, (nmtx,nmtx))
 
#ifdef HDF5
  if(use_hdf5) then

    SAFE_ALLOCATE(old,(3,ngq))
    call read_eps_old_gvecs_hdf5(ngq,old,infile)
    kx(:)=old(1,:)
    ky(:)=old(2,:)
    kz(:)=old(3,:)

    call read_eps_gvecsofq_hdf5(ngq,isort,isorti,ekin,1,infile)
    
    call read_eps_matrix_ser_hdf5(eps,nmtx,1,1,infile)

  else
#endif
 
    call open_file(unit=11,file=TRUNC(infile),form='unformatted',status='old')
    read(11)
    read(11)
    read(11)
    read(11)
    read(11)
    read(11)
    read(11)
    read(11)
    read(11) ng,(kx(i),ky(i),kz(i),i=1,ng)
    read(11) ngq,nmtx,(isort(ig),isorti(ig),ig=1,ngq)
    read(11) (ekin(ig),ig=1,ngq)
    read(11) (qk(j,1),j=1,3)
    do jj = 1, nmtx
      read(11) (eps(ii,jj),ii=1,nmtx)
    enddo
    call close_file(11)

#ifdef HDF5
  endif
#endif
  
  ! Since we want the q=0 dielectric function but we have the
  ! q0<>0 but small dielectric, we can average over q0 and -q0
  ! to get a better dielectric (linear terms in q0 will be canceled)

! Calculate the maximum
  gmax = 0
  do ii = 1,ng
    if (abs(kx(ii)) > gmax) gmax = abs(kx(ii))
    if (abs(ky(ii)) > gmax) gmax = abs(ky(ii))
    if (abs(kz(ii)) > gmax) gmax = abs(kz(ii))
  enddo
! Create a map
!  write(6,*) gmax
  SAFE_ALLOCATE(map, ((2*gmax+1)*(2*gmax+1)*(2*gmax+1)))
  map = 0
  do ii = 1, ngq
    iout = isort(ii)
    if (iout.eq.0) cycle
    gx = kx(iout)
    gy = ky(iout)
    gz = kz(iout)
    imap = ((gx+gmax)*(2*gmax+1)+gy+gmax)*(2*gmax+1)+gz+gmax+1
    map(imap) = ii
  enddo

! For each g, find -g in the gvector list
! and also mark which ii corresponds to G=0

  SAFE_ALLOCATE(minusgidx, (nmtx))
  minusgidx = 0
  do ii=1,nmtx
    iout = isort(ii)
    gx = kx(iout)
    gy = ky(iout)
    gz = kz(iout)
    imap = ((-gx+gmax)*(2*gmax+1)-gy+gmax)*(2*gmax+1)-gz+gmax+1
    minusgidx(ii) = map(imap)
    if (gx .eq. 0 .and. gy .eq. 0 .and. gz .eq. 0) ig0 = ii
  enddo
  
!  do ii = 1, min(100,nmtx)
!    iout = isort(ii)
!    gx = kx(iout)
!    gy = ky(iout)
!    gz = kz(iout)
!    mgx = kx(isort(minusgidx(ii)))
!    mgy = ky(isort(minusgidx(ii)))
!    mgz = kz(isort(minusgidx(ii)))
!    write(6,'(7i4)') ii, gx, gy , gz, mgx, mgy, mgz
!  enddo

! Set the wings to zero
! This is as per Baldereschi and Tosatti, PRB 17, 4710 (1978)
! This is perhaps not the correct thing to do. One should 
! still symmetrize epsilon - but the wings should come out
! whatever they need to be automatically. What is given in that
! paper by Baldereschi and Tosatti is at q=0 and the dielectric
! function is weird at that point. What is needed in the GW
! code is the average in the minibz...
  !do ii=1,nmtx
  !  do jj=1,nmtx
  !    if (ii .eq. ig0 .and. jj .eq. ig0) cycle
  !    if (ii .eq. ig0) eps(ii,jj) = 0.0d0
  !    if (jj .eq. ig0) eps(ii,jj) = 0.0d0
  !  enddo
  !enddo
  
! Copy eps(q0) into a temporary

  SAFE_ALLOCATE(tempeps, (nmtx,nmtx))
  tempeps = eps

  errorMax=0D0
  errorMaxTemp=0D0
  
  write(6,'(5a4,3x,3a4,1x)',advance='no') "ig", "ig'", "Gx", "Gy", "Gz", "G'x", "G'y", "G'z"
  ! handle the fact that the two components of the complex numbers will be written in the complex case
#ifdef CPLX  
  write(6,'(6a16)') "Re eps(G,G')", "Im eps(G,G')", "Re eps(-G,-G')", "-Im eps(-G,-G')", "Re diff", "Im diff"
#else
  write(6,'(3a16)') "eps(G,G')", "eps(-G,-G')*", "difference"
#endif

!  do ii = 1, min(100,nmtx)
!    do jj = 1, min(100,nmtx)
  do ii = 1, nmtx
    do jj = 1, nmtx
      iout = isort(ii)
      igx = kx(iout)
      igy = ky(iout)
      igz = kz(iout)
      jout = isort(jj)
      jgx = kx(jout)
      jgy = ky(jout)
      jgz = kz(jout)
      kk = minusgidx(ii)
      ll = minusgidx(jj)
      if ((kk .le. nmtx) .and. (ll .le. nmtx)) then
        errorMaxTemp=eps(ii,jj)-MYCONJG(eps(kk,ll))
        if (abs(errorMaxTemp) .gt. errorMax) errorMax = abs(errorMaxTemp)
        if (ii .lt. 20 .and. jj .lt. 20) then
          write(6,'(5i4,3x,3i4,1x,6E16.5)') ii,jj,igx,igy,igz,jgx,jgy,jgz,eps(ii,jj),MYCONJG(eps(kk,ll)),errorMaxTemp
        endif
      endif
    enddo
  enddo
 
  write(6,*) "Error = eps(G,G')-eps*(-G,-G')"
  write(6,'("The max error in your matrix is",E12.5)') errorMax
  write(6,*) "Symmetrizing the matrix"

! Now add in contribution from -q0 which means conjg(eps(-g,-gp))

  do ii=1,nmtx
    do jj=1,nmtx

      kk = minusgidx(ii)
      ll = minusgidx(jj)
      if ((kk .le. nmtx) .and. (ll .le. nmtx)) then
        tempeps(ii,jj) = tempeps(ii,jj) + MYCONJG(eps(kk,ll))
      endif
    enddo
  enddo
! Average over q0 and -q0 and put back into eps

  eps = 0.5d0*tempeps
  SAFE_DEALLOCATE(tempeps)
  SAFE_DEALLOCATE(minusgidx)
  
#ifdef HDF5
  if(use_hdf5) then

    SAFE_ALLOCATE(dFreqGrid,(nFreq))
    SAFE_ALLOCATE(dFreqBrd,(nFreq))
    call eps_hdf5_setup(0,1,dFreqGrid,dFreqBrd,ecuts,qgrid,ng,old,1,q(:,1:1),nmtx0_of_q(1:1),nmtx,1,outfile)
    SAFE_DEALLOCATE(old)
    SAFE_DEALLOCATE(dFreqBrd)
    SAFE_DEALLOCATE(dFreqGrid)

    call write_gvec_indices_hdf(ng,isort,isorti,ekin,1,outfile)

    isize=SCALARSIZE

    call write_matrix_ser_hdf(eps,nmtx,1,1,outfile)

    SAFE_ALLOCATE(epsdiag,(isize,nmtx,1))

    do ii = 1, nmtx
      epsdiag(1,ii,1) = dble(eps(ii,ii))
#ifdef CPLX
      epsdiag(2,ii,1) = IMAG(eps(ii,ii))
#endif
    enddo
    
    call write_matrix_diagonal_hdf(epsdiag,nmtx,1,isize,outfile)

    SAFE_DEALLOCATE(epsdiag)

    call h5close_f(error)
  else
#endif

    call open_file(unit=20,file=TRUNC(outfile),form='unformatted',status='replace')

    ajname='chiGG0'
    write(20) ajname,adate
    write(20) freq_dep,nFreq
    write(20) (qgrid(ii),ii=1,3)
    if (freq_dep .eq. 2) then
      write(20) (dFreqGrid(i),i=1,nFreq),(dFreqBrd(i),i=1,nFreq)
    else
      write(20)
    endif
    write(20)
    write(20)
    write(20) ecuts
    write(20) nq,(q(j,1),j=1,3)
    write(20) ng,(kx(ig),ky(ig),kz(ig),ig=1,ng)
    write(20) ngq,nmtx,(isort(ig),isorti(ig),ig=1,ngq)
    write(20) (ekin(ig),ig=1,ngq)
    write(20) (qk(j,1),j=1,3)
    do jj = 1, nmtx
      write(20) (eps(ii,jj),ii=1,nmtx)
    enddo
  
    call close_file(20)

#ifdef HDF5
  endif
#endif

end program eps0sym

#include "f_defs.h"

!*************************************************************************
Module densityArrayMod
!*************************************************************************
! Module for density defined on a grid
! densityArrayT is a type containing the wavefunction and density information
!*************************************************************************
! NEED TO CHANGE TO MAKE MORE UNIVERSAL
!*************************************************************************

  use SysParams,    only : double
  use push_pop_m

  type densityArrayT
    complex(double), pointer :: densityArray(:,:,:), waveFunction(:,:,:), rhog(:)
    integer                  :: gridDimensions(3), gridSize
  end type densityArrayT

  contains

!*************************************************************************
  Subroutine densityArrayInit( densityArray, ndim, FFTgrid, numGVectors )
!*************************************************************************

    implicit none
    
    type( densityArrayT ), pointer :: densityArray
    integer, intent(in) :: ndim
    integer, intent(in) :: FFTgrid(3)
    integer, intent(in) :: numGVectors
    integer :: i, error

    PUSH_SUB(densityArrayInit)

    if( associated( densityArray )) stop 'Error, densityArray already allocated.'
    allocate( densityArray, stat=error )
    if( error /= 0 ) stop 'Error, densityArray allocation failed.'
    nullify( densityArray%densityArray )
    nullify( densityArray%waveFunction )
    nullify( densityArray%rhog )

    densityArray%gridSize = 1

    densityArray%gridDimensions = 1
    do i = 1, ndim
      densityArray%gridDimensions(i) = FFTgrid(i)
      densityArray%gridSize = densityArray%gridSize * densityArray%gridDimensions(i)
    end do

    allocate( densityArray%densityArray(densityArray%gridDimensions(1), &
                                        densityArray%gridDimensions(2), densityArray%gridDimensions(3)), &
              densityArray%waveFunction(densityArray%gridDimensions(1), &
                                        densityArray%gridDimensions(2), densityArray%gridDimensions(3)), &
              densityArray%rhog(numGVectors), stat = error )
    if(error /= 0) stop 'Error allocating density arrays in densityArrayInit.'

    POP_SUB(densityArrayInit)
  end Subroutine densityArrayInit

!*************************************************************************
  Subroutine densityArrayDestroy( densityArray )
!*************************************************************************

    implicit none
    
    type( densityArrayT ), pointer :: densityArray
    integer :: error

    PUSH_SUB(densityArrayDestroy)

    if( .not. associated( densityArray )) stop 'Error, densityArray not allocated.'

    deallocate( densityArray%densityArray, &
              & densityArray%waveFunction, densityArray%rhog, stat = error )
    if(error /= 0) stop 'Error deallocating density arrays.'

    deallocate( densityArray, stat = error )
    if(error /= 0) stop 'Error, densityArray deallocation failed.'

    nullify( densityArray )

    POP_SUB(densityArrayDestroy)
  end Subroutine densityArrayDestroy

end Module densityArrayMod

!========================================================================
!
! Routines:
!
! (1) date_time()       Originally by ?         Last Modified: 5/12/2008 (JRD)
!
!     Gets current date and time.
!
! (2) timget()          Originally by gsm       Last Modified: 4/29/2010 (gsm)
!
!     Gets current cpu and wall time.
!
! (3) timacc(n,option,tsec,nslices)   Originally by ?
!                                               Last Modified: 6/17/2009 (PWD)
!
!     Timing subroutine.  Calls machine-dependent subroutine timget
!     which returns elapsed cpu and wall clock times in seconds
!     Also return the number of times the counter has been called
!
!     Depending on value of "option" routine will:
!       (0) zero all accumulators
!       (1) start with new incremental time slice for accumulator n
!           also increase by one the counter for this accumulator
!       (2) stop time slice; add time to accumlator n
!       (3) report accumulated time for accumulator n
!           and number of time that the routine has been called
!       (4) report time slice for accumulator n (not full time accumulated)
!
!       If, on first entry, subroutine is not being initialized, it
!       will automatically initialize as well as rezero accumulator n.
!       However, initialization SHOULD be done explicitly by the user
!       so that it can be done near the top of his/her main routine.
!
!       Input:
!         n=index of accumulator (distinguish what is being timed); not used if option=0
!         option=see comment above
!       Output:
!         on option=3:
!         tottim(2,n)=accumulated time for accumulator n; otherwise
!         tottim is a dummy variable.
!         nslices is optional variable that give number of slices collected
!
! (4) logit()    Originally By (SIB)     Last Modified 6/12/2008 (JRD)
!
!    Write out a debugging message with an inputed string and write time.
!
! (5) logitint() Originally By (SIB)     Last Modified 6/12/2008 (JRD)
!
!    Same as logit but with an integer constant.
!
!========================================================================

#include "f_defs.h"

module timing_m

  use intrinsics_m
  use message_m
  use nrtype_m
  use peinfo_m
  use push_pop_m

  implicit none

  private

  public ::    &
    date_time, &
    timget,    &
    timacc,    &
    logit,     & 
    logitint

  !> MTIM determines the maximum number of "timing slots" available
  integer, parameter, private :: MTIM=100
  real(DP), private, save :: acctim(2,MTIM),tzero(2,MTIM)
  integer, private, save :: ncount(MTIM)

contains

  subroutine date_time(bdate,btime)
    character, intent(out) :: bdate*11,btime*14
    
    integer :: lmonth
    integer :: idate (8)
    character :: day*2,year*4
    character :: adate*8,atime*10,azone*5
    character :: hour*2,min*2,sec*2
    character*3 :: month(12)
      
    DATA month/'Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep', &
      'Oct','Nov','Dec'/

    PUSH_SUB(date_time)

    call date_and_time(adate,atime,azone,idate)
    
    read(adate,101) year,lmonth,day
101 format(a4,i2,a2)
    write(bdate,102) day,month(lmonth),year
102 format(a2,'-',a3,'-',a4)
    read(atime,201) hour,min,sec
201 format(a2,a2,a2,a4)
    write(btime,202) hour,min,sec,azone
202 format(a2,':',a2,':',a2,1x,a5)

    POP_SUB(date_time)

    return    
  end subroutine date_time

!================================================================================

  subroutine timget(cpu,wall)
    real(DP), intent(out) :: cpu,wall
    
    integer :: values(8)

    ! no push_sub, called too frequently

    TIMGET(cpu)

    call date_and_time(VALUES=values)
    wall=((values(3)*24.0d0+values(5))*60.0d0 &
      +values(6))*60.0d0+values(7)+values(8)*1.0d-3

    return
  end subroutine timget

!================================================================================

  subroutine timacc(n,option,tottim,nslices)
    integer, intent(in) :: n !< not used for option = 0
    integer, intent(in) :: option !< 0, 1, 2, 3, 4
    real(DP), intent(out), optional :: tottim(2) !< should be present if option=3 or 4
    integer, intent(out), optional :: nslices !< only used if option=3, still optional in that case
    
    real(DP) :: cpu,wall
    character*100 :: tmpstr

    ! no push_sub, called too frequently
    
! Check that n lies in sensible bounds

    if (n .lt. 0 .or. n .gt. MTIM) then
      write(tmpstr,'(a,i6,a,i8)') 'timacc: dim MTIM = ', MTIM,' but input n =', n
      call die(tmpstr)
    end if

    if (option==0) then

! Zero out all accumulators of time and init timers
      
      acctim(:,:)=0.0d0
      tzero(:,:)=0.0d0
      ncount(:)=0

    else if (option==1) then

! Initialize timepw for n

      call timget(cpu,wall)
      tzero(1,n)=cpu
      tzero(2,n)=wall
        
    else if (option==2) then

! Accumulate time for n
      
      call timget(cpu,wall)
      acctim(1,n)=acctim(1,n)+cpu -tzero(1,n)
      acctim(2,n)=acctim(2,n)+wall-tzero(2,n)
      ncount(n)=ncount(n)+1

    else if (option==3) then

! Return accumulated time for n

      if(.not. present(tottim)) call die("timacc requires tottim for option 3.")

      tottim(1)=acctim(1,n)
      tottim(2)=acctim(2,n)
      if(present(nslices)) then
        nslices=ncount(n)
      end if

    else if (option==4) then

! Return elapsed time for n (do not accumulate)

      if(.not. present(tottim)) call die("timacc requires tottim for option 4.")

      call timget(cpu,wall)
      tottim(1)=cpu-tzero(1,n)
      tottim(2)=wall-tzero(2,n)
      
    else

      write(tmpstr,'(a,i10,a)') 'timacc: input option = ', option, 'not valid.'
      call die(tmpstr)

    end if

    return
  end subroutine timacc

!=====================================================================

  subroutine logit(str)
    character (len=*), intent(in) :: str

#ifdef VERBOSE
    character*15 :: mydate,mytime,tmpstr
    
    if (peinf%inode.eq.0) then
      call date_and_time(mydate,mytime)
      tmpstr = mytime(1:2)//':'//mytime(3:4)//':'//mytime(5:6)//'.'//mytime(8:10)
      mytime = tmpstr
      write(6,*) '*** VERBOSE: ', TRUNC(str),'  time = ', TRUNC(mytime)
    endif
#endif
    
    return
  end subroutine logit

!=====================================================================

  subroutine logitint(str,i)
    character (len=*), intent(in) :: str
    integer, intent(in) :: i

#ifdef VERBOSE
    character*100 :: tmpstr
    
    write(tmpstr,'(a,i5)') str(1:len_trim(str)),i
    call logit(tmpstr)
#endif
    
    return
  end subroutine logitint
  
!=====================================================================

end module timing_m

!==================================================================================
!
! Routines:
!
! (1) iterate()         Originally By MLT               Last Modified 7/1/2008 (JRD)
!
!     Performs a pair of iterations using the moments (Haydock) algorithm
!     for the haydock code.
!
!     input:  mmts, xct types
!            nmat        number of exciton states
!            nit         order of iteration
!            hmtrx       Hamiltonian
!            s1          Haydock vector of order |nit-1>
!            s0          Haydock vector of order |nit>
!            mmts%an(1:nit-1)
!            mmts%bn(1:nit-1)
!
!     output: s1          Haydock vector of order |nit+1>
!             s0          Haydock vector of order |nit+2>
!             mmts%an(1:nit+1)
!             mmts%bn(1:nit+1)
!
! (2) local_s()         Originally By MLT               Last Modified 7/1/2008 (JRD)
!
!     Given a global state ss, defines ss_l with the same parallel
!     distribution as the second index of the Hamiltonian, so that
!     one can easily apply ss to the right of hmtrx by doing
!     matmul(hmtrx,ss_l).
!
!     input: peinf type
!            nmat        number of exciton states
!            ss          global state, size nmat
!
!     output: ss_l       local state, size peinf%nkpe*nmat
!
!====================================================================================

#include "f_defs.h"

subroutine iterate(mmts,xct,nmat,nit,hmtrx,s1,s0)

  use global_m
  use misc_m
  implicit none

  type (mmtsinfo), intent(inout) :: mmts
  type (xctinfo), intent(in) :: xct
  integer, intent(in) :: nmat,nit
  SCALAR, intent(in) :: hmtrx(nmat,peinf%nblocks*peinf%nblockd)
  SCALAR, intent(inout) :: s1(nmat),s0(nmat)

  character :: filename*12
  integer :: ii,ik,ic,iv,is,ikcvs,iprint,itth,ith
  real(DP) :: sum,sum1
  SCALAR :: s1_l(peinf%nblocks*peinf%nblockd), &
    s0_l(peinf%nblocks*peinf%nblockd),dum1(nmat),dum2(nmat)

  PUSH_SUB(iterate)

!----------------------------
! Print out

  if (peinf%inode.eq.0) then
    iprint=0
    if (iprint.ne.0) then
      write(6,*) ' Output of Haydock vectors',nit-1,nit
      write(filename,'(a,i3.3)')  'HAYDOCKN_', nit

      itth=31
      call open_file(itth,file=filename,form='formatted',status='replace')
      do ik=1,xct%nkpt_fi
        do ic=1,xct%ncb_fi
          do iv=1,xct%nvb_fi
            do is=1,xct%nspin
              ikcvs = bse_index(ik, ic, iv, is, xct)
              write(itth,*) ik,ic,iv,is,ikcvs,s1(ikcvs),s0(ikcvs)
            enddo
          enddo
        enddo
      enddo
      call close_file(itth)
    endif
  endif

!---------------------------------
! Initialize local states : s1_l  --> local part of s1
!                           s0_l  --> local part of s0
! Whenever s1 and s0 change, their local parts must be updated

  call local_s(nmat,s1,s1_l)
  call local_s(nmat,s0,s0_l)

! Calculate an(nit) from vector s0 = |nit>

  sum1 = dble( DOT_PRODUCT(s0,MATMUL(hmtrx,s0_l)) )

#ifdef MPI
  call MPI_Allreduce(sum1,sum,1,MPI_REAL_DP,MPI_SUM,MPI_COMM_WORLD,mpierr)
  sum1 = sum
#endif
  mmts%an(nit) = sum1

!----------------------------------
! Calculate vector s1 = |nit+1> and bn(nit)
! Note that bn corresponds to the b^2_n in Benedict & Shirley, eq. (22)

  dum2 = MATMUL(hmtrx,s0_l)

#ifdef MPI
  call MPI_Allreduce(dum2,dum1,nmat,MPI_SCALAR,MPI_SUM,MPI_COMM_WORLD,mpierr)
  dum2 = dum1
#endif

  dum1(:) = dum2(:) - mmts%an(nit)*s0(:) - sqrt(mmts%bn(nit-1))*s1(:)
  s1(:) = dum1(:)
  sum = dble( DOT_PRODUCT(s1,s1) )
  mmts%bn(nit) = sum
  s1(:) = s1(:)/sqrt(sum)
  call local_s(nmat,s1,s1_l)
  
  if (peinf%inode.eq.0) write(6,120) nit,mmts%an(nit),mmts%bn(nit)
  
#ifdef MPI
  call MPI_BARRIER(MPI_COMM_WORLD,mpierr)
#endif

!--------------------------------
! Calculate an(nit+1) from vector s1 = |nit+1>

  sum1 = dble( DOT_PRODUCT(s1,MATMUL(hmtrx,s1_l)) )

#ifdef MPI
  call MPI_Allreduce(sum1,sum,1,MPI_REAL_DP,MPI_SUM,MPI_COMM_WORLD,mpierr)
  sum1 = sum
#endif
  mmts%an(nit+1) = sum1
      
!--------------------------------
! Calculate vector s0 = |nit+2> and bn(nit+1)

  dum2 = MATMUL(hmtrx,s1_l)

#ifdef MPI
  call MPI_Allreduce(dum2,dum1,nmat,MPI_SCALAR,MPI_SUM,MPI_COMM_WORLD,mpierr)
  dum2 = dum1
#endif

  dum1(:) = dum2(:) - mmts%an(nit+1)*s1(:) - sqrt(mmts%bn(nit))*s0(:)
  s0(:) = dum1(:)
  sum = dble( DOT_PRODUCT(s0,s0) )
  
  mmts%bn(nit+1) = sum
  s0(:) = s0(:)/sqrt(sum)
  call local_s(nmat,s0,s0_l)
  
  if (peinf%inode.eq.0) write(6,120) nit+1,mmts%an(nit+1),mmts%bn(nit+1)

! Save coefficients after every 10 iterations

  iprint=0
  if (peinf%inode.eq.0 .and. mod(nit,10).eq.0) iprint=1
  if (iprint.ne.0) then
    ith = 21
    call open_file(ith,file='eps2_moments',form='unformatted',status='replace')
    write(ith) nit+1,mmts%norm,mmts%vol,nmat,xct%nspin
    write(ith) (mmts%an(ii),ii=1,nit+1)
    write(ith) (mmts%bn(ii),ii=1,nit+1)
    write(ith) (s1(ii),ii=1,nmat)
    write(ith) (s0(ii),ii=1,nmat)
    call close_file(ith)
    write(6,*) 'Vectors written in file'
  endif
  iprint=0
  
#ifdef MPI
  call MPI_BARRIER(MPI_COMM_WORLD,mpierr)
#endif
  
120 format(3x,i4,3x,2e12.5)
  
  POP_SUB(iterate)
  
  return
end subroutine iterate


!===========================================================================


subroutine local_s(nmat,ss,ss_l)
  
  use global_m
  implicit none

  integer, intent(in) :: nmat
  SCALAR, intent(in) :: ss(nmat)
  SCALAR, intent(out) :: ss_l(peinf%nblocks*peinf%nblockd)
  
  integer :: ii

  PUSH_SUB(local_s)
  
  ss_l = 0.d0
  
  do ii=1,peinf%ibt(peinf%inode+1)*peinf%nblockd
    ss_l(ii) = ss(peinf%peig(peinf%inode+1,ii))
  enddo
  
  POP_SUB(local_s)
  
  return
end subroutine local_s

#include "f_defs.h"

module genwf_m

  use global_m
  use blas_m
  use gmap_m
  use input_utils_m
  use sort_m
  use misc_m

  implicit none

  private

  public :: genwf

contains

  subroutine genwf(crys,gvec,kg,syms,wfn,xct,ik,ik2,work,intwfn,is_cond)
    type (crystal), intent(in) :: crys
    type (gspace), intent(in) :: gvec
    type (grid), intent(in) :: kg
    type (symmetry), intent(in) :: syms
    type (wavefunction), intent(out) :: wfn
    type (xctinfo), intent(in) :: xct
    integer, intent(in) :: ik, ik2
    type (work_genwf), intent(inout) :: work
    type (int_wavefunction), intent(in) :: intwfn
    logical, intent(in) :: is_cond
    
    integer :: iwrite
    character :: filename*20, wfnname*10
    integer :: irk, iunit
    integer :: hh, ii, jj, kk, eof, ig
    
    integer, allocatable :: isorti(:)
    real(DP), allocatable :: ekin(:)
    
    PUSH_SUB(genwf)
  
    if (xct%iwriteint .eq. 0) then
      if(peinf%inode.lt.10000) then
        if(is_cond) then
          write(filename,'(a,i4.4)') 'INT_CWFN_', peinf%inode
          iunit=128+(2*peinf%inode)+1
          wfnname = "conduction"
        else
          write(filename,'(a,i4.4)') 'INT_VWFNQ_', peinf%inode
          iunit=128+(2*peinf%inode)+2
          wfnname = "valence"
        endif
      else
        call die('genwf: cannot use more than 9999 nodes')
      endif
    endif
  
  !-----------------------------------------------------------------------
  !     Start looking for the right k-point in unit iunit
  
    if(ik.ne.work%ikold) then
      if (xct%iwriteint .eq. 0) then
        call open_file(iunit,file=filename,form='unformatted',status='old')
        
        eof=0
        read(iunit) irk,work%ng,work%nb,work%ns,work%nspinor
        do while((irk.ne.kg%indr(ik2)).and.(eof.eq.0))
          read(iunit)
          read(iunit,iostat=eof) irk,work%ng,work%nb,work%ns,work%nspinor
        enddo
        if(eof.ne.0) then
          write(0,*) 'BUG: PE ', peinf%inode, ' could not find the ', trim(wfnname), &
            'wavefunctions for k-point ', ik2
          write(0,*) '  (equivalent to k-point ', kg%indr(ik2), 'in the IBZ) in file ', filename
          call die("genwf wfns missing")
        endif
      else
        iwrite=0
        do ii=1, peinf%ikt(peinf%inode+1)
          if(peinf%ik(peinf%inode+1,ii).eq.ik) then
            iwrite=ii
            work%ng=intwfn%ng(ii)
            if(is_cond) then
              work%nb=xct%ncb_fi
            else
              work%nb=xct%nvb_fi
            endif
            work%ns=xct%nspin
            work%nspinor=intwfn%nspinor
          endif
        enddo
      endif
      
      if(work%ikold.ne.0) then
        SAFE_DEALLOCATE_P(work%cg)
        SAFE_DEALLOCATE_P(work%ph)
        SAFE_DEALLOCATE_P(work%ind)
        SAFE_DEALLOCATE_P(work%isort)
      endif
      SAFE_ALLOCATE(work%cg, (work%ng,work%nb,work%ns*work%nspinor))
      SAFE_ALLOCATE(work%ind, (work%ng))
      SAFE_ALLOCATE(work%ph, (work%ng))
      SAFE_ALLOCATE(work%isort, (gvec%ng))
    endif
  
    wfn%ng=work%ng
    wfn%nband=work%nb
    wfn%nspin=work%ns
    wfn%nspinor=work%nspinor
    if (work%ns.ne.xct%nspin) then
      write(0,*) 'spin number mismatch in file ', filename, xct%nspin, work%ns
      call die("genwf spin number mismatch")
    endif
    
    SAFE_ALLOCATE(wfn%cg, (wfn%ng,wfn%nband,wfn%nspin*wfn%nspinor))
    SAFE_ALLOCATE(wfn%isort, (gvec%ng))
    if(ik.ne.work%ikold) then
  !       Read the wavefunctions for the rk-kpoint
      if (xct%iwriteint .eq. 0) then
        read(iunit) (work%isort(ii),ii=1,gvec%ng), &
          (((work%cg(ii,jj,kk),ii=1,wfn%ng),jj=1,wfn%nband), kk=1,wfn%nspin*wfn%nspinor)
      else
        work%isort(:)=intwfn%isort(:,iwrite)
        work%cg(1:wfn%ng,:,:)=intwfn%cgk(1:wfn%ng,:,:,iwrite)
      endif
  
  !       Compute inverse index array of Fourier components around rk-kpoint
      SAFE_ALLOCATE(isorti, (gvec%ng))
      isorti(:)=0
      do ii=1,wfn%ng
        isorti(work%isort(ii))=ii
      enddo
  
  !       Compute index array of Fourier components around fk-kpoint
      SAFE_ALLOCATE(ekin, (gvec%ng))
      call kinetic_energies(gvec, crys%bdot, ekin, qvec = kg%f(:, ik2))
      call sortrx(gvec%ng, ekin, work%isort, gvec = gvec%components)
      SAFE_DEALLOCATE(ekin)
  
  !       Find ind and ph relating wavefunctions in fk to rk-kpoint
      work%ind=0
      work%ph=ZERO
      call gmap(gvec,syms,wfn%ng,kg%itran(ik2), &
        kg%kg0(:,ik2),work%isort,isorti,work%ind,work%ph,.true.)
      SAFE_DEALLOCATE(isorti)

  !       Compute and renormalize wavefunctions
      do kk=1,wfn%nspin
        do jj=1,wfn%nband
          do hh=1,wfn%nspinor
            do ii=1,wfn%ng
              if (work%ind(ii) .gt. 0) then
                wfn%cg(ii,jj,kk*hh)=work%ph(ii)*work%cg(work%ind(ii),jj,kk*hh)
              else
                wfn%cg(ii,jj,kk*hh)=ZERO
              endif
            enddo
          enddo
          call checknorm('wfn%cg',jj,ik,wfn%ng,kk,wfn%nspinor,wfn%cg(1:wfn%ng,jj,:))
        enddo
      enddo
      work%cg=wfn%cg


      if(xct%iwriteint == 0) call close_file(iunit)
    endif
    
    wfn%cg=work%cg
    wfn%isort=work%isort
    
    work%ikold=ik
    
    POP_SUB(genwf)
    
    return
  end subroutine genwf
  
end module genwf_m

!=============================================================================
!
! Utilities:
!
! (1) scissors2eqp    Originally By DAS      Last Modified 3/25/2012 (DAS)
!
!     Write an eqp.dat file based on a WFN file and scissors parameters.
!     For testing equivalence of eqp_corrections and scissors.
!
!==============================================================================

#include "f_defs.h"

program scissors2eqp

  use global_m
  use scissors_m
  use wfn_rho_vxc_io_m
  implicit none

  type(crystal) :: crys
  type(symmetry) :: syms
  type(kpoints) :: kp
  type(gspace) :: gvec
  character*3 :: sheader
  character*256 :: infile, usage, tmpstr
  integer :: iflavor, nargs, ik, is, ib, ii
  type(scissors_t) :: scis
  type(spline_tck) :: spl
  logical :: has_splines

  usage = 'Usage: scissors2eqp.x WFN evs ev0 evdel ecs ec0 ecdel [spline_scissors.dat]'

! Get file name from command-line arguments

  nargs = iargc()

  if (nargs<7 .or. nargs>8) then
    call die(usage)
  endif
  has_splines = nargs==8

  call getarg(1, infile)
  call open_file(unit=7,file=TRUNC(infile),form='unformatted',status='old')

  sheader = 'WFN'
  iflavor = -1
  call read_binary_header_type(7, sheader, iflavor, kp, gvec, syms, crys, warn = .false., &
    dont_warn_kgrid = .true.)
  call close_file(7)

  call getarg(2, tmpstr)
  read(tmpstr,*) scis%val%es
  call getarg(3, tmpstr)
  read(tmpstr,*) scis%val%e0
  call getarg(4, tmpstr)
  read(tmpstr,*) scis%val%edel
  call getarg(5, tmpstr)
  read(tmpstr,*) scis%cond%es
  call getarg(6, tmpstr)
  read(tmpstr,*) scis%cond%e0
  call getarg(7, tmpstr)
  read(tmpstr,*) scis%cond%edel

  call scissors_write(6, scis)

  SAFE_ALLOCATE(kp%elda, (kp%mnband, kp%nrk, kp%nspin))
  kp%elda = kp%el

  if (has_splines) then
    call getarg(8, tmpstr)
    call open_file(20,file=TRUNC(tmpstr),form='formatted',status='old')
    read(20,*) spl%n
    SAFE_ALLOCATE(spl%t, (spl%n))
    SAFE_ALLOCATE(spl%c, (spl%n))
    read(20,*) (spl%t(ii), ii=1,spl%n)
    read(20,*) (spl%c(ii), ii=1,spl%n)
    read(20,*) spl%k
    close(20)
    call scissors_shift(kp, scis, spl)
  else
    call scissors_shift(kp, scis)
  endif

  call open_file(unit=9,file='eqp.dat',form='formatted',status='replace')

  do ik = 1, kp%nrk
    write(9,'(3f13.9,i8)') kp%rk(1:3, ik),kp%mnband*kp%nspin 
    do is = 1, kp%nspin 
      do ib = 1, kp%mnband
        write(9,'(2i8,2f15.9)') is, ib, kp%elda(ib, ik, is)*RYD, kp%el(ib, ik, is)*RYD
      enddo
    enddo
  enddo

  call close_file(9)

  call dealloc_header_type(sheader, crys, kp)
  SAFE_DEALLOCATE_P(kp%elda)

  if (has_splines) then
    SAFE_DEALLOCATE_P(spl%t)
    SAFE_DEALLOCATE_P(spl%c)
  endif

end program scissors2eqp

!================================================================================
!
! Modules:
!
! (1) svninfo_m      Originally By gsm       Last Modified 11/08/2010 (gsm)
!
! Returns information on svn repository name, version, and revision number.
!
! Set the following svn properties on this file:
! % svn propset svn:keywords "Date Revision Author HeadURL" Common/svninfo.f90
!
! Use pre-commit hook to ensure this file is modified before each commit.
! Modify text here before making a commit --> manual transmission
!
!================================================================================

#include "f_defs.h"
  
module svninfo_m

  use global_m
  implicit none
      
  private

  character(len=64), parameter :: svndate = &
    '$Date: 2014-12-08 17:55:11 -0500 (Mon, 08 Dec 2014) $'
  character(len=64), parameter :: svnrevision = '$Revision: 6543 $'
  character(len=64), parameter :: svnauthor = '$Author: dstrubbe $'
  character(len=256), parameter :: svnheadurl = &
    '$HeadURL: https://civet.berkeley.edu/svn/BerkeleyGW/tags/BerkeleyGW-1.1-beta2/Common/svninfo.f90 $'

  public :: getsvninfo

contains

!-------------------------------------------------------------------------------

  subroutine getsvninfo(asvninfo)
    character(len=256), intent(out) :: asvninfo

    integer :: j1,j2,l1,i1,i2,i3,i4,f1,f2,f3

    PUSH_SUB(getsvninfo)

    j1=scan(svnrevision,'$',.false.)+11
    j2=scan(svnrevision,'$',.true.)-2
    
    l1=len(svnheadurl)
    i1=index(svnheadurl,'svn')+4
    i2=index(svnheadurl(i1:l1),'/')+i1-2
    
    f1=index(svnheadurl(i2+2:l1),'branches')
    f2=index(svnheadurl(i2+2:l1),'tags')
    f3=index(svnheadurl(i2+2:l1),'trunk')

    if (f1 .ne. 0) then
      i3=index(svnheadurl(i2+2:l1),'/')+i2+2
      i4=index(svnheadurl(i3:l1),'/')+i3-2
      write(asvninfo,'("branch",1x,a,1x,"revision",1x,a)') &
        svnheadurl(i3:i4),svnrevision(j1:j2)
    elseif (f2 .ne. 0) then
      i3=index(svnheadurl(i2+2:l1),'-')+i2+2
      i4=index(svnheadurl(i3:l1),'/')+i3-2
      write(asvninfo,'("tag",1x,a,1x,"revision",1x,a)') &
        svnheadurl(i3:i4),svnrevision(j1:j2)
    elseif (f3 .ne. 0) then
      write(asvninfo,'("trunk",1x,"revision",1x,a)') &
        svnrevision(j1:j2)
    else
      write(asvninfo,'("Unknown")')
    endif

    i1=1
    do while (i1 .ne. 0)
      i1=index(asvninfo,'_')
      if (i1 .ne. 0) asvninfo(i1:i1)=' '
    enddo
    
    i1=1
    do while (i1 .ne. 0)
      i1=index(asvninfo,'-')
      if (i1 .ne. 0) asvninfo(i1:i1)=' '
    enddo

    POP_SUB(getsvninfo)

    return

  end subroutine getsvninfo

!-------------------------------------------------------------------------------

end module svninfo_m

#include "f_defs.h"

!*************************************************************************
Module MinimizeMod
!*************************************************************************

  use NormalizeMod,  only : SelfBandOrthogonalize, VecNormalize
  use push_pop_m
  implicit none

  contains

!*************************************************************************
  Subroutine StDescentVec( eigenStates, minVec, iBand, kPoint )
!*************************************************************************

    use TypeMod, only : minVecT
    use EigenStatesMod, only : eigenStatesT

    integer, intent(in) :: iBand, kPoint
    type(eigenStatesT), pointer :: eigenStates
    type(minVecT), pointer :: minVec

    PUSH_SUB(StDescentVec)

    ! Evaluate the Steepest Descent direction for iBand
    minVec%StDesc = - eigenStates%ePsi( : , kPoint ) + &
         & eigenStates%eigenValues( iBand, kPoint)* &
         & eigenStates%eigenVectors( :, iBand, kPoint )

    POP_SUB(StDescentVec)
  end Subroutine StDescentVec

!*************************************************************************
  Subroutine ConjDirection( eigenStates, minVec, oldVec, iBand, kPoint )
!*************************************************************************

    use SysParams, only : double
    use TypeMod, only : minVecT
    use EigenStatesMod, only : eigenStatesT

    integer, intent(in) :: iBand, kPoint
    type(eigenStatesT), pointer :: eigenStates
    type(minVecT), pointer :: minVec,oldVec

    real( double ) :: Gamma,numer,denom

    PUSH_SUB(ConjDirection)

    !   Calculate Gamma, the phi is adjusted such that in the first 
    ! iteration Gamma becomes inconsequential
    numer = Dot_Product(( minVec%StDesc - oldVec%StDesc ), minVec%StDesc )
    denom = Dot_Product(( minVec%StDesc - oldVec%StDesc ), oldVec%Phi )

!   Gamma = 0.d0     ! This makes it the steepest descent method
    Gamma = -numer / ( denom + 10.d-40 )

    minVec%Phi = minVec%StDesc + Gamma * oldVec%Phi

    ! Orthogonalize Phi against the state-vector of the same band 'iBand'
    call SelfBandOrthogonalize( eigenStates, minVec%Phi, iBand, kPoint )

    ! Normalize Phi
    call VecNormalize( minVec%Phi )

!    print *, 'Conjgdir:',minVec%Phi

    ! Roll the current values into oldVec
    oldVec%sine = minVec%sine
    oldVec%cosine = minVec%cosine
    oldVec%Phi = minVec%Phi
    oldVec%EPhi = minVec%EPhi
    oldVec%StDesc = minVec%StDesc

    POP_SUB(ConjDirection)
  end Subroutine ConjDirection

end Module MinimizeMod

!============================================================================
!
! Included from fftw.F90
!
!============================================================================

!> This routine takes data(1:ndata) and puts it into the FFT box fftbox(:,:,:).
!! The FFT box is zeroed out first, and the data is entered into it.
!! 
!!   ndata -- number of data items in data(:)
!!   data -- the data set, real or complex, depending on ifdef CPLX
!!   ng -- number of g vectors in glist
!!   glist -- a master list of g vectors
!!   gindex(1:ng) -- which g vector (in the master list) the data(1:ndata)
!!                   actually refer to:  so data(j) is for the g-vector
!!                   glist(1:3,gindex(j))
!!   fftbox(:,:,:) -- 3D complex FFT box where the data is put
!!   Nfft(1:3) -- sizes of FFT box Nx,Ny,Nz
subroutine X(put_into_fftbox)(ndata, data, glist, gindex, fftbox, Nfft)
  integer, intent(in) :: ndata
  SCALAR,  intent(in) :: data(:) !< (ndata) this is to avoid creation of array temporary
  integer, intent(in) :: glist(:,:) !< (3, ng)
  integer, intent(in) :: gindex(:) !< (ng)
  integer, intent(in) :: Nfft(:) !< (3)
  complex(DPC), intent(out) :: fftbox(:,:,:) !< (Nfft(1), Nfft(2), Nfft(3))
  
  integer :: j, bidx(3)
  
  PUSH_SUB(X(put_into_fftbox))
  
  ! Zero out FFT box and put data into it
  if(peinf%inode.eq.0) call timacc(91,1)

!$OMP PARALLEL
!$OMP DO
  do j=1,Nfft(3)
    fftbox(:,:,j) = (0.0d0,0.0d0)
  enddo
!$OMP END DO
!$OMP END PARALLEL

  if(peinf%inode.eq.0) call timacc(91,2)
  if(peinf%inode.eq.0) call timacc(92,1)

!$OMP PARALLEL PRIVATE(bidx,j) SHARED(fftbox, glist, gindex, data)
!$OMP DO
  do j=1,ndata
    call gvec_to_fft_index(glist(:,gindex(j)),bidx,Nfft)
    fftbox(bidx(1),bidx(2),bidx(3)) = data(j)
  end do
!$OMP END DO
!$OMP END PARALLEL

  if(peinf%inode.eq.0) call timacc(92,2)

  POP_SUB(X(put_into_fftbox))

  return
end subroutine X(put_into_fftbox)

!> Does the inverse of the above routine:  takes the data in the
!! fftbox(:,:,:) and puts it into the data(1:ndata) array.  ndata entries
!! are extracted, and the gindex and glist specify which ones to get:
!! data(j) corresponds to the g-vector glist(:,gindex(j)).  The data
!! in fftbox is multiplied by scale before storage into data(:).
!!
!! data(:) is zeroed first and then the data is put into it.
!!
subroutine X(get_from_fftbox)(ndata, data, glist, gindex, fftbox, Nfft, scale)
  integer, intent(in) :: ndata
  SCALAR, intent(out) :: data(:) !< (ndata)
  integer, intent(in) :: glist(:,:) !< (3, ng)
  integer, intent(in) :: gindex(:) !< (ng)
  integer, intent(in) :: Nfft(:)
  complex(DPC), intent(in) :: fftbox(:,:,:) !< (Nfft(1), Nfft(2), Nfft(3))
  real(DP), intent(in) :: scale
  
  integer :: j, bidx(3)
  
  PUSH_SUB(X(get_from_fftbox))
  
  ! Zero out data set
  data(:) = 0.0
  do j=1,ndata
    call gvec_to_fft_index(glist(:,gindex(j)),bidx,Nfft)
    data(j) = fftbox(bidx(1),bidx(2),bidx(3))*scale
  end do
  
  POP_SUB(X(get_from_fftbox))
  
  return
end subroutine X(get_from_fftbox)

#include "f_defs.h"

!*************************************************************************
Module EigenStatesMod
!*************************************************************************
! eigenVectors(i,j,k) the cooefficient of the i-th basis vector of
!                     the normalized eigenvector for the j-th eigenvalue
!                     at the k-th k-point.
!                     [ For PW`s The corresponding G-vector is
!                     gVectors(:,basisIndex(i,k)) ]
! eigenValues(j,k)    j-th energy eigenvalue (in ascending order)
!                     at the k-th k point (j=1..numStates) (a.u.)
! basisIndex(i,k)     sorting vector defined for each k-point:
!                     BasisVectors(:,basisIndex(i,k)) is
!                     a BasisVector for the k-th k-point.
!*************************************************************************

  use SysParams, only : double
  use push_pop_m

  implicit none

  type eigenStatesT
    complex(double), pointer :: eigenVectors(:,:,:), ePsi(:,:)
    real(double),    pointer :: eigenValues(:,:)
    integer,         pointer :: basisIndex(:,:), numBasisVectors(:)
    integer                  :: numStates,hSize,hDIm
    integer                  :: numKPoints
    integer                  :: maxBasisVectors
    real( double )           :: tolerance
    integer                  :: maxIterations
  end type eigenStatesT

  contains

!*************************************************************************
  Subroutine EigenStatesInit( eigenStates, nStates, nKP, nBasis, tol, iter )
!*************************************************************************

    implicit none
    
    type( eigenStatesT ), pointer :: eigenStates
    integer, intent(in)           :: nStates, nKP, nBasis, iter
    real( double )                :: tol
    integer                       :: error

    PUSH_SUB(EigenStatesInit)
  
    if( associated( eigenStates )) stop 'Error, eigenStates already allocated.'
    allocate( eigenStates, stat = error )
    if( error /= 0 ) stop 'Error, eigenStates allocation failed.'
    nullify( eigenStates%eigenVectors )
    nullify( eigenStates%ePsi )
    nullify( eigenStates%eigenValues )
    nullify( eigenStates%basisIndex )
    nullify( eigenStates%numBasisVectors )

    eigenStates%numStates = nStates
    eigenStates%numKPoints = nKP
    eigenStates%maxBasisVectors = nBasis
    eigenStates%tolerance = tol
    eigenStates%maxIterations = iter

    allocate( eigenStates%eigenValues( eigenStates%numStates, &
            & eigenStates%numKPoints ), stat = error )
    if( error /= 0 ) stop 'Error allocating eigenValues in EigenStates.'

    allocate( eigenStates%eigenVectors( eigenStates%maxBasisVectors, &
            & eigenStates%numStates, eigenStates%numKPoints ), stat = error )
    if( error /= 0 ) stop 'Error allocating eigenVectors in EigenStates.'

    allocate( eigenStates%ePsi( eigenStates%maxBasisVectors, &
            & eigenStates%numKPoints ), stat = error )
    if( error /= 0 ) stop 'Error allocating eigenVectors in EigenStates.'

    allocate( eigenStates%basisIndex( eigenStates%maxBasisVectors, &
            & eigenStates%numKPoints ), stat = error )
    if( error /= 0 ) stop 'Error allocating basisIndex in EigenStates.'

    allocate( eigenStates%numBasisVectors( eigenStates%numKPoints ), &
            & stat = error)
    if( error /= 0 ) stop 'Error allocating numBasisVectors in EigenStates.'

    POP_SUB(EigenStatesInit)
  end Subroutine EigenStatesInit

!*************************************************************************
  Subroutine EigenStatesDestroy( eigenStates )
!*************************************************************************
 
    implicit none

    type( eigenStatesT ), pointer :: eigenStates
    integer :: error

    PUSH_SUB(EigenStatesDestroy)

    if( .not. associated( eigenStates )) stop &
        & 'Error, eigenStates not allocated.'

    deallocate( eigenStates%eigenVectors, eigenStates%eigenValues, &
              & eigenStates%ePsi, eigenStates%basisIndex, &
              & eigenStates%numBasisVectors, stat=error)
    if(error /= 0) stop 'Error eigenValues deallocating in EigenStatesDestroy.'

    deallocate( eigenStates, stat=error )
    if( error /= 0 ) stop 'Error, eigenState deallocation failed.'

    nullify( eigenStates )

    POP_SUB(EigenStatesDestroy) 
  end Subroutine EigenStatesDestroy

!*************************************************************************
  Subroutine PrintEigenvalues(eigenStates, kpt)
!*************************************************************************

    implicit none
   
    type( eigenStatesT ), pointer, intent(in) :: eigenStates
    integer, intent(in) :: kpt
    integer :: j

    PUSH_SUB(PrintEigenvalues)

    write(*,'(a,i10,a)') 'eigenvalues  1 - ', eigenStates%numStates, &
      & ' at k points in lattice vector units '
    write(*,'(a,i10)') 'kpoint ', kpt  ! , kpoints%kpointsLat(:,kpt)
    do j = 1, eigenStates%numStates
      write(*,'(i5,f23.16)') kpt, eigenStates%eigenValues(j, kpt)
    end do

    POP_SUB(PrintEigenvalues)
  end Subroutine PrintEigenvalues

end Module EigenStatesMod

!================================================================================
!
! Modules:
!
! (1) intrinsics_m      Originally By DAS      Created 9/21/2011
!
!     Some compiler-dependent module usages and external definitions,
!     regarding accessing system calls. There is no actual code here.
!     These are preprocessor symbols defined in f_defs.h.
!
!================================================================================

#include "f_defs.h"

module intrinsics_m

  USEHOSTNAMEMOD
  USEOMPLIB
  SYSTEMMOD

  implicit none

  public

! note: these are split into two lines because ifort for some reason decrees of
! 'end interface' : "END statement must be only statement on line".

  HOSTNAME_INTERFACE
  HOSTNAME_INTERFACE2

  MCLOCK_INTERFACE
  MCLOCK_INTERFACE2

  IARGC_INTERFACE
  IARGC_INTERFACE2

  FTELL_INTERFACE
  FTELL_INTERFACE2

end module intrinsics_m

!===============================================================================
!
! Modules:
!
! scissors_m   Originally By DAS
!
!   Routines for scissors corrections to mean-field eigenvalues.
!
!===============================================================================

#include "f_defs.h"

module scissors_m

  use global_m
  use splines_m

  implicit none

  private

  public ::               &
    scissors_shift,        &
    scissors_write,       &
    scissors_zero,        &
    scissors_function,    &
    scissors_inread

contains

  !---------------------------------------------------------------------------------------------------
  !> Scissors operator to get quasi-particle spectrum from LDA eigenvalues
  !! evs, ecs, ev0, ec0 are supposed to be in eV
  !! kp%el is taken to be in Ry however
  !! spl_tck (spline coefficients) in Ry
  subroutine scissors_shift(kp, scis, spl_tck)
    type(kpoints), intent(inout) :: kp
    type(scissors_t), intent(in) :: scis
    type(spline_tck), optional, intent(in) :: spl_tck

    integer :: is, irk, ib
    logical :: has_spline, use_spline
    real(DP) :: spline_emin, spline_emax

    PUSH_SUB(scissors_shift)

    has_spline=.false.
    if (present(spl_tck)) then
      if (spl_tck%n>0) then
        has_spline = .true.
        spline_emin = spl_tck%t(1)/ryd
        spline_emax = spl_tck%t(spl_tck%n)/ryd
      endif
    endif

    do is=1,kp%nspin
      do irk=1,kp%nrk
        do ib=1,kp%mnband

          use_spline=.false.
          if (has_spline) then
            if ( (kp%el(ib,irk,is) > spline_emin) .and. &
                 (kp%el(ib,irk,is) < spline_emax) ) then
                 use_spline=.true.
            endif
          endif

          if (use_spline) then
            ! use spline interpolation for scissors ops
            call splev_shift( spl_tck, kp%el(ib,irk,is) )
          else
            ! use regular (linear) scissors ops
            if(ib <= kp%ifmax(irk,is)) then
              kp%el(ib,irk,is) = scissors_function(kp%el(ib, irk, is), scis%val)
            else
              kp%el(ib,irk,is) = scissors_function(kp%el(ib, irk, is), scis%cond)
            endif
          endif

        enddo ! ib (band)
      enddo ! irk (kpoint)
    enddo ! is (spin)
    
    POP_SUB(scissors_shift)
    return
  end subroutine scissors_shift

  !---------------------------------------------------------------------------------------------------
  subroutine scissors_write(iunit, scis, suffix)
    integer, intent(in) :: iunit !< unit to which to write
    type(scissors_t), intent(in) :: scis
    character(len=*), optional, intent(in) :: suffix !< identifier to be printed

    PUSH_SUB(scissors_write)

    write(iunit,'(a)')
    write(iunit,'(1x,a)',advance='no') "Scissors parameters"
    if(present(suffix)) then
      write(iunit,'(3a)') ' (', TRUNC(suffix), ')'
    else
      write(iunit,'(a)')
    endif
    write(iunit,'(1x,3(a,f8.4))') &
      'Valence:    es = ', scis%val%es,  ' eV, e0 = ', scis%val%e0,  ' eV, edel = ', scis%val%edel
    write(iunit,'(1x,3(a,f8.4))') &
      'Conduction: es = ', scis%cond%es, ' eV, e0 = ', scis%cond%e0, ' eV, edel = ', scis%cond%edel

    POP_SUB(scissors_write)
    return
  end subroutine scissors_write

  !---------------------------------------------------------------------------------------------------
  subroutine scissors_zero(scis)
    type(scissors_t), intent(out) :: scis

    PUSH_SUB(scissors_zero)

    scis%val%es    = 0d0
    scis%val%e0    = 0d0
    scis%val%edel  = 0d0
    scis%cond%es   = 0d0
    scis%cond%e0   = 0d0
    scis%cond%edel = 0d0

    POP_SUB(scissors_zero)
    return
  end subroutine scissors_zero

  !---------------------------------------------------------------------------------------------------
  real(DP) function scissors_function(energy, scis)
    real(DP), intent(in) :: energy !< should be in Ry
    type(sub_scissors_t), intent(in) :: scis
    
    PUSH_SUB(scissors_function)
    scissors_function = energy + scis%es / ryd + scis%edel * (energy - scis%e0 / ryd)

    POP_SUB(scissors_function)
    return
  end function scissors_function

  !---------------------------------------------------------------------------------------------------
  subroutine scissors_inread(keyword, line, scis, found, suffix)
    character(len=*), intent(in) :: keyword, line
    type(scissors_t), intent(inout) :: scis
    logical, intent(out) :: found
    character(len=*), optional, intent(in) :: suffix

    integer :: iostat, trunc_length
    character*120 :: trunc_keyword

    PUSH_SUB(scissors_inread)

    if(present(suffix)) then
      if(len(suffix) > 0) then
        trunc_length = len(trim(keyword))
        if(keyword(trunc_length-len(suffix)+1:trunc_length) == suffix) then
          trunc_keyword = keyword(1:trunc_length-len(suffix))
        else
          found = .false.
          POP_SUB(scissors_inread)
          return
        endif
      endif
    else
      trunc_keyword = keyword
    endif

    found = .true.
    if(trim(trunc_keyword).eq.'cvfit') then
      read(line,*,iostat = iostat) scis%val%es,scis%val%e0,scis%val%edel, &
        scis%cond%es,scis%cond%e0,scis%cond%edel
    elseif(trim(trunc_keyword).eq.'evs') then
      read(line,*,iostat = iostat) scis%val%es
    elseif(trim(trunc_keyword).eq.'ev0') then
      read(line,*,iostat = iostat) scis%val%e0
    elseif(trim(trunc_keyword).eq.'evdel') then
      read(line,*,iostat = iostat) scis%val%edel
    elseif(trim(trunc_keyword).eq.'ecs') then
      read(line,*,iostat = iostat) scis%cond%es
    elseif(trim(trunc_keyword).eq.'ec0') then
      read(line,*,iostat = iostat) scis%cond%e0
    elseif(trim(trunc_keyword).eq.'ecdel') then
      read(line,*,iostat = iostat) scis%cond%edel
    else
      found = .false.
    endif

    if(found .and. iostat /= 0) call die( &
      'Unexpected characters were found while reading the value for the keyword ' &
      // trim(keyword) // '. ', only_root_writes = .true.)

    POP_SUB(scissors_inread)
    return
  end subroutine scissors_inread

end module scissors_m

#include "f_defs.h"

!*************************************************************************
Module KPointsMod
!*************************************************************************
! This module contains information about the k-points.
!*************************************************************************
! The module contains the public functions:
!    KPointsInit         reads information on k points and 
!                        allocates the space for the dynamic variables
!    KPointsDestroy      deallocates space for the dynamic variables
!*************************************************************************
! The module contains the type:
! kPointsT which contains the variables:
!    numKPoints          total number of k-points used
!    kPointsLat(i,j)     i-th component (reciprocal lattice coordinates)
!                        of the j-th k-point
!    kPointsCart(i,j)    i-th component (cartesian coordinates * 2pi / a)
!                        of the j-th k-point
!    numBands            number of bands to be calculated
!*************************************************************************
! Information for graphs
!*************************************************************************

  use SysParams,     only : double
  use GraphMod,      only : graphT
  use push_pop_m
  implicit none

  save

  type kPointsT
    integer               :: numKPoints
    integer               :: kPointNumbers(3)
    real(double)          :: kPointOffsets(3)
    real(double), pointer :: kPointsCart(:,:)
    real(double), pointer :: kPointsLat(:,:)
    real(double), pointer :: kPointWeights(:)
    integer               :: numBands
    integer               :: numOccupiedBands
  end type kPointsT

  integer, parameter      :: scaledByRecipLatVec = 1
  integer, parameter      :: scaledByTwoPi = 2

  private scaledByRecipLatVec
  private scaledByTwoPi

  contains

!*************************************************************************
  Subroutine KPointsInit( kPoints, graphInfo, ndim, lattice, tagHandler )
!*************************************************************************

!    generate k-points around a BZ for plotting band structure plots such that
!    each line segment has a constant density of points to make the graphics
!    look good

    use SysParams,     only : one, zero, twopi
    use TagHandlerMod, only : FindTag, StringCompare, tagHandlerT
    use LatticeMod,    only : latticeT
    use GraphMod,      only : graphT

    implicit none

    type( kPointsT ),    pointer :: kPoints
    type( LatticeT ),    pointer :: lattice
    type( graphT ),      pointer :: graphInfo
    type( tagHandlerT ), pointer :: tagHandler
    integer, intent(in)          :: ndim
    real(double), allocatable    :: ktemp(:,:) ! temporary list of k-points

    integer       :: j,error,kPointsScale
    real(double)  :: normKPointWeights
    character(80) :: buff
    logical       :: default

    PUSH_SUB(KPointsInit)

    if( associated( kPoints )) stop 'Error, kPoints already allocated.'

    allocate( kPoints, stat = error )
    if( error /= 0 ) stop 'Error, kPoints allocation failed.'
    nullify( kPoints%kPointsCart )
    nullify( kPoints%kPointsLat )
    nullify( kPoints%kPointWeights )

    nullify( graphInfo )  ! used only if associated by another subroutine

    call FindTag( tagHandler, 'NumberOfBands', error)

    if(error .eq. 0) then

      read(unit = tagHandler%fileno, fmt = '(I10)', iostat = error) kPoints%numBands
      if(error /= 0) stop 'Error, couldn''t read NumberOfBands.'

      print *, 'NumberOfBands ', kPoints%numBands

    else

      stop 'Error, could not find NumberOfBands.'

    endif

!   Input parameter NumberOfOccupiedBands for BerkeleyGW wavefunction file

    call FindTag( tagHandler, 'NumberOfOccupiedBands', error)

    if(error .eq. 0) then

      read(unit = tagHandler%fileno, fmt = '(I10)', iostat = error) kPoints%numOccupiedBands
      if(error /= 0) stop 'Error, couldn''t read NumberOfOccupiedBands.'

      print *, 'NumberOfOccupiedBands ', kPoints%numOccupiedBands

    else

      kPoints%numOccupiedBands = kPoints%numBands

    endif

! Determine whether kpoints are read from input file are in units of ReciprocalLatticeVectors
! or in Cartesian units.  Default is scaledByRecipLatVec
 
    default = .True.

    call FindTag(tagHandler, 'KPointsScale', error)

    if(error .eq. 0) then

      read(unit = tagHandler%fileno, fmt = '(A80)', iostat = error) buff

      if(error .eq. 0) then

        if(StringCompare(buff, 'ReciprocalLatticeVectors')) then

          kPointsScale = scaledByRecipLatVec
          print *, 'KPointsScale ReciprocalLatticeVectors'
          default = .False.

        else if(StringCompare(buff, 'TwoPi/a')) then

          kPointsScale = scaledByTwoPi
          print *, 'KPointsScale TwoPi/a'
          default = .False.

        end if
      end if
    end if

    if(default) then
      kPointsScale = scaledByRecipLatVec
      print *, 'Using default KPointsScale ReciprocalLatticeVectors'
    end if

!   Start Various Possible types of generation of k ponts

!   Input parameter KPointNumbers for BerkeleyGW wavefunction file
    call FindTag( tagHandler, 'KPointNumbers', error)
    if(error .eq. 0) then
      read(unit = tagHandler%fileno, fmt = *, iostat = error) (kPoints%KPointNumbers(j),j=1,3)
    else
      do j=1,3
        kPoints%KPointNumbers(j)=0
      enddo
    endif

!   Input parameter KPointOffsets for BerkeleyGW wavefunction file
    call FindTag( tagHandler, 'KPointOffsets', error)
    if(error .eq. 0) then
      read(unit = tagHandler%fileno, fmt = *, iostat = error) (kPoints%KPointOffsets(j),j=1,3)
    else
      do j=1,3
        kPoints%KPointOffsets(j)=0.0d0
      enddo
    endif

    call FindTag( tagHandler, 'KPointsList', error)

    if(error .eq. 0) then

      read(unit = tagHandler%fileno, fmt = '(I10)', iostat = error) kPoints%numKPoints
      if(error /= 0) stop 'Error: Could not read number of KPoints after KPointsList.'

      print *, 'Use k point list read from input file '
      print *, 'Calculation will be done for ' , kPoints%numKPoints, ' k points' 

      allocate(kPoints%kPointsCart(ndim, kPoints%numKPoints), &
        & kPoints%kPointsLat(ndim, kPoints%numKPoints), &
        & kPoints%kPointWeights(kPoints%numKPoints), &
        & ktemp(ndim, kPoints%numKPoints), &
        & stat=error) ! allocate memory for k-points, and temporary ktemp 
      if(error /= 0) stop 'could not allocate memory for k-points'

!     Needed to read data from following line
!     read(unit = tagHandler%fileno,fmt = '(A1)', iostat = error) c

!     Input parameter kPointWeights for BerkeleyGW wavefunction file
      do j = 1, kPoints%numKPoints
        read(unit = tagHandler%fileno, fmt = *, iostat = error) ktemp(:,j), kPoints%kPointWeights(j)
        if(error /= 0) stop 'Error reading KPoints.'
        print *, j, ' ', ktemp(:,j)
      enddo

      normKPointWeights = 0.0d0
      do j = 1, kPoints%numKPoints
        normKPointWeights = normKPointWeights + kPoints%kPointWeights(j)
      enddo
      if (abs(normKPointWeights).gt.1.0d-6) then
        do j = 1, kPoints%numKPoints
          kPoints%kPointWeights(j) = kPoints%kPointWeights(j) / normKPointWeights
        enddo
      else
        stop "k-weights sum is close to zero."
      endif

      print *, ' HERE WE ASSUME INPUT K ARE IN LATTICE VECTOR UNITS - NEED TO CHANGE'

      do j = 1, kPoints%numKPoints
        kPoints%kPointsLat(:,j) = ktemp(:,j)
        print *, j, ' ', ktemp(:,j)
      enddo

      deallocate(ktemp, stat = error)
      if(error /= 0) stop 'Error deallocating ktemp in KPointsInit.'

    else

      !Checking for next option - read lines and divisions for plotting

      call FindTag( tagHandler, 'NumberOfLines', error)

      if(error .eq. 0) then

      call KPointsLinesandGraphInit( kPoints, graphInfo, ndim, lattice, tagHandler )

      else
        if(error /= 0) stop 'Error, could not find any tag for kpoints'
      endif

    endif

    POP_SUB(KPointsInit)
   end Subroutine KPointsInit

!*************************************************************************
  Subroutine KPointsDestroy( kPoints )
!*************************************************************************

    use GraphMod, only : GraphDestroy

    implicit none

    type( kPointsT ), pointer :: kPoints
    integer :: error

    PUSH_SUB(KPointsDestroy)

    if( .not. associated( kPoints )) stop 'Error, kPoints not allocated.'

!    if( associated( kPoints%graph ))  call GraphDestroy( kPoints%graph )

!    deallocate(kPoints%kPointsLat, kPoints%kPointsCart,kPoints%xAxis, stat=error)
    deallocate(kPoints%kPointsLat, kPoints%kPointsCart, kPoints%kPointWeights, stat=error)
    if(error /= 0) stop 'Error deallocating kPointsLat in KPointsDestroy.'

    deallocate( kPoints, stat = error )
    if(error /= 0) stop 'Error deallocating kPoints in KPointsDestroy.'

    nullify( kPoints )

    POP_SUB(KPointsDestroy)
  end Subroutine KPointsDestroy

!*************************************************************************
  Subroutine KPointsLinesandGraphInit( kPoints, graphInfo, ndim, lattice, tagHandler )
!*************************************************************************

!    generate k-points around a BZ for plotting band structure plots such that
!    each line segment has a constant density of points to make the graphics
!    look good

    use SysParams,        only : one, zero, twopi
    use TagHandlerMod,    only : FindTag, StringCompare, tagHandlerT
    use LatticeMod,       only : LatticeT
    use GraphMod,         only : AddLabel, GraphInit, graphT

    implicit none

    type( LatticeT ),    pointer :: lattice
    type( kPointsT ),    pointer :: kPoints
    type( tagHandlerT ), pointer :: tagHandler
    type( graphT ), pointer      :: graphInfo
    integer, intent(in)  :: ndim

    integer                   :: nlines       ! number of lines in k-space to plot
    integer                   :: ndiv         ! number of divisions per line
    integer,      allocatable :: num(:)       ! number of divisions per line
    real(double), allocatable :: length(:)    ! length of line
    real(double), allocatable :: kc(:,:)      ! list of circuit k-points
    real(double), allocatable :: tick(:)      ! list of positions of lables
    character(2), allocatable :: label(:)     ! list of labels for plot
    real(double), allocatable :: dk(:,:)      ! line vector
    character(2)  :: c
    character(80) :: buff
    integer       :: i,j,npt,error, kPointsScale
    real(double)  :: delta_k
    logical       :: default

    PUSH_SUB(KPointsLinesandGraphInit)

    call FindTag( tagHandler, 'NumberOfLines', error)

    if(error .eq. 0) then

      read(unit = tagHandler%fileno, fmt = '(I10)', iostat = error) nlines
      if(error /= 0) stop 'Error, couldn''t read NumberOfLines.'

      print *, 'NumberOfLines ', nlines

    else

      stop 'Error, could not find NumberOfLines.'

    endif

    call FindTag( tagHandler, 'NumberOfDivisions', error)

    if(error .eq. 0) then

      read(unit = tagHandler%fileno, fmt = '(I10)', iostat = error) ndiv
      if(error /= 0) stop 'Error, couldn''t read NumberOfDivisions.'

      print *, 'NumberOfDivisions ', ndiv

    else

      stop 'Error, could not find NumberOfDivisions.'

    endif

    allocate(kc(ndim, nlines + 1), dk(ndim, nlines), &
      & label(nlines + 1), tick(nlines + 1), &
      & num(nlines), length(nlines), stat = error) 
    if(error /= 0) stop 'Error allocating k-points space in KPointsInit.'

! Determine whether kpoints are read from input file are in units of ReciprocalLatticeVectors
! or in Cartesian units.  Default is scaledByRecipLatVec
 
    default = .True.

    call FindTag(tagHandler, 'KPointsScale', error)

    if(error .eq. 0) then

      read(unit = tagHandler%fileno, fmt = '(A80)', iostat = error) buff

      if(error .eq. 0) then

        if(StringCompare(buff, 'ReciprocalLatticeVectors')) then

          kPointsScale = scaledByRecipLatVec
          print *, 'KPointsScale ReciprocalLatticeVectors'
          default = .False.

        else if(StringCompare(buff, 'TwoPi/a')) then

          kPointsScale = scaledByTwoPi
          print *, 'KPointsScale TwoPi/a'
          default = .False.

        end if
      end if
    end if

    if(default) then
      kPointsScale = scaledByRecipLatVec
      print *, 'Using default KPointsScale ReciprocalLatticeVectors'
    end if

    call FindTag( tagHandler,'KPointsAndLabels', error)
    print *, 'KPointsAndLabels'
    if(error .eq. 0) then

      read(unit = tagHandler%fileno,fmt = '(A1)', iostat = error) c

      read(unit = tagHandler%fileno,fmt =*, iostat = error) kc(:,1), label(1)

      print *, kc(:,1),' ', label(1)
!      call AddLabel( graphInfo, label, zero )
      tick(1) = 0.0d0

      do i = 1, nlines

        ! input circuit information
        read(unit = tagHandler%fileno, fmt = *, iostat = error) kc(:,i+1),label(i+1)
        dk(:,i)    = kc(:,i+1) - kc(:,i)
        length(i)  = SQRT(dot_product(matmul(dk(:,i),lattice%bLatMetricTensor),dk(:,i)))
        tick(i+1) = tick(i) + length(i)
!        call AddLabel( graphInfo, label(i+1), tick(i+1) )
        print *, kc(:,i+1),' ', label(i+1)

      end do

    else

      stop 'Error, could not find KPointsAndLabels.'

    end if

    num = (length/minval(length))*ndiv          ! number of divisions per line

    kPoints%numKPoints  = SUM(num) + 1          ! total number of k-points

    allocate(kPoints%kPointsCart(ndim, kPoints%numKPoints), &
        & kPoints%kPointsLat(ndim, kPoints%numKPoints), &
        & kPoints%kPointWeights(kPoints%numKPoints), &
        stat=error) ! allocate memory for k-points
    if(error /= 0) stop 'Error, could not allocate memory for k-points.'

! Generate a continuous set of k-points around the circuit 

    npt = 0
    do i = 1, nlines                             
      delta_k     = one/num(i)                
      npt         = npt + 1
      kPoints%kPointsLat(:,npt) = kc(:,i)
      do j = 1, num(i) - 1
        npt         = npt + 1
        kPoints%kPointsLat(:,npt) = kc(:,i) + j * delta_k * dk(:,i)
      end do
    end do

    kPoints%kPointsLat(:, npt+1) = kc(:, nlines+1) ! get the last k-point

! Generate information for plotting bands

   call GraphInit(graphInfo, kpoints%numKpoints, nlines)

      do i = 1, nlines + 1
        call AddLabel( graphInfo, label(i), tick(i) )
      end do

    graphInfo%xAxis = 0

    do i = 2, kPoints%numKPoints

      dk(:,1)        = kPoints%kPointsLat(:,i) - kPoints%kPointsLat(:,i-1)
      graphInfo%xAxis(i) = graphInfo%xAxis(i-1) + &
          & sqrt(dot_product(dk(:,1),matmul(lattice%bLatMetricTensor,dk(:,1))))

    end do

! Calculate k points in Cartesian coordinates for possible use

    if(kPointsScale .eq. scaledByRecipLatVec) then
      kPoints%kPointsCart = matmul(lattice%bLatVec, kPoints%kPointsLat)  &
                          & * lattice%latticeConst / twopi
    else if(kPointsScale .eq. scaledByTwoPi) then
      kPoints%kPointsCart = kPoints%kPointsLat
      kPoints%kPointsLat = matmul(transpose(lattice%aLatVec), kPoints%kPointsCart) / & 
                 & lattice%latticeConst * twopi
    end if

    deallocate(kc, dk, label, tick, num, length, stat = error)
    if(error /= 0) stop 'Error deallocating kc, dk, label, tick, num, length in KPointsInit.'

    POP_SUB(KPointsLinesandGraphInit)
  end Subroutine KPointsLinesandGraphInit

!*************************************************************************
  Subroutine PrintKPoints( kPoints )
!*************************************************************************

    implicit none

    type( kPointsT ), pointer :: kPoints
    integer :: i

    PUSH_SUB(PrintKPoints)

    do i = 1, kPoints%numKPoints
      print *, kPoints%kPointsLat(:,i)
    end do

    POP_SUB(PrintKPoints)
  end Subroutine PrintKPoints

end Module KPointsMod

!===============================================================================
!
! Routines:
!
! 1. hdiag()             Originally By gsm      Last Modified 9/3/2010 (gsm)
!
!    Computes the residual vectors, diagonalizes the subspace Hamiltonian,
!    or iteratively diagonalizes the Hamiltonian
!
! 2. hpsi()              Originally By gsm      Last Modified 9/3/2010 (gsm)
!
!    Applies the Hamiltonian to a wavefunction
!
! 3. hsub()              Originally By gsm      Last Modified 9/3/2010 (gsm)
!
!    Constructs and diagonalizes the subspace Hamiltonian
!
! 4. dsub()              Originally By gsm      Last Modified 9/3/2010 (gsm)
!
!    Constructs the diagonal subspace Hamiltonian and diagonal eigenvectors
!
! 5. rpsi()              Originally By gsm      Last Modified 9/3/2010 (gsm)
!
!    Rotates wavefunctions
!
! 6. npsi()              Originally By gsm      Last Modified 9/3/2010 (gsm)
!
!    Computes norms of wavefunctions and optionally normalizes wavefunctions
!
! 7. calc_precond()      Originally By gsm      Last Modified 9/3/2010 (gsm)
!
!    Computes a preconditioner for a component of a residual vector
!
!===============================================================================

#include "f_defs.h"

module hdiag_m

  use global_m
  use blas_m
  use lapack_m
  use scalapack_m
  use fftw_m
  use fft_parallel_m
  use misc_m
  use pw_m

  implicit none

  private

  public :: hdiag

contains

subroutine hdiag(fparafft,fparala,fblas,fvkbg,nk,ns,nbstart, &
  nbend,nbmax,ng,ng_l,ng_g,ngk_l,ngk_g,nat,nsp,nkb,nhm,FFTgrid, &
  ngk,ityp,nh,gvec,isort_d,celvol,bdot,kpt,vsc_d,deeq,vkb_d, &
  en,wfn_d,sapo_ham_nrestart,sapo_ham_ndiag,sapo_ham_ndim, &
  sapo_ham_tol,sapo_ham_resinc)

! This subroutine computes the residual vectors, diagonalizes the
! subspace Hamiltonian, or iteratively diagonalizes the Hamiltonian.
! On entrance takes initial eigenvalues and eigenvectors in arrays
! en(nbstart:nbend,nk,ns) and wfn_d(ngk_l,nbstart:nbend,ns,nk) set
! in SAPO. On exit returns final eigenvalues and eigenvectors in the
! same arrays
!
! For computing residual vectors set sapo_ham_ndiag = 0
!
! For subspace diagonalization set sapo_ham_ndiag = 1
!
! For iterative diagonalization set sapo_ham_ndiag > 1, sapo_ham_ndim > 1,
! sapo_ham_tol > 0.0d0
!
! If some k-points/spins didn`t converge during iterative diagonalization,
! try setting sapo_ham_nrestart > 1
!
! Some important variables for iterative diagonalization:
!   nvec - number of eigenvectors (wavefunctions)
!   nmat - leading dimension of the subspace Hamiltonian arrays
!          (nmat = nvec * sapo_ham_ndim)
!   nbas - number of the basis functions (nvec <= nbas <= nmat)
!   npre - number of the basis functions kept from previous iteration
!   nres - number of residual vectors added to the basis functions
!          (nres <= nvec)
!
! There is no point of setting sapo_ham_ndim > (sapo_ham_ndiag + 1).
! Since nbas is initialized to nvec and nbas is incremented by nres
! on each iteration, it requires at least (sapo_ham_ndim - 1)
! iterations for nbas to reach nmat
!
! There is no point of setting sapo_ham_ndiag > 1 if sapo_ham_ndim = 1.
! Subsequent iterations will be identical if the basis set is not
! allowed to expand

  logical, intent(in) :: fparafft,fparala,fblas,fvkbg
  integer, intent(in) :: nk,ns,nbstart,nbend,nbmax,ng,ng_l,ng_g, &
    ngk_l,ngk_g,nat,nsp,nkb,nhm
  integer, intent(in) :: FFTgrid(3)
  integer, intent(in) :: ngk(:) !< (nk)
  integer, intent(in) :: ityp(:) !< (nat)
  integer, intent(in) :: nh(:) !< (nsp)
  integer, intent(in) :: gvec(:,:) !< (3,ng)
  integer, intent(in) :: isort_d(:,:) !< (ngk_l,nk)
  real(DP), intent(in) :: celvol
  real(DP), intent(in) :: bdot(3,3)
  real(DP), intent(in) :: kpt(:,:) !< (3,nk)
  SCALAR, intent(in) :: vsc_d(:,:) !< (ng_l,ns)
  real(DP), intent(in) :: deeq(:,:,:,:) !< (nhm,nhm,nat,ns)
  complex(DPC), intent(in) :: vkb_d(:,:,:,:) !< (ngk_l,nkb,ns,nk)
  real(DP), intent(inout) :: en(:,:,:) !< (nbmax,nk,ns)
  SCALAR, intent(inout) :: wfn_d(:,:,:,:) !< (ngk_l,nbmax,ns,nk)
  integer, intent(in) :: sapo_ham_nrestart,sapo_ham_ndiag,sapo_ham_ndim
  real(DP), intent(in) :: sapo_ham_tol
  logical, intent(in) :: sapo_ham_resinc

  logical :: is_diag,is_precond,is_updatewfn,is_error
  integer :: i,j,k,ik,is,ib,im,jm,ig,irestart,idiag, &
    idiagmax,idiagtot,nvec,nbas,nmat,nres,npre,Nplane,Nrod, &
    m,nz,npr,npc,lwork,lrwork,liwork,liclustr,lgap,mrod,msph, &
    iat,isp,ih,ikb,ijkb0,info,nmpinode,dummyiwork(1), &
    dummyifail(1),dummyiclustr(1),desca(9)
  real(DP) :: minus_scale,plus_scale,plus_scale_v,abstol, &
    orfac,demax,detot,resmax,resold,restot,v_0,vdummy,precond, &
    amem,rmem,size_bool,size_int,size_real,size_cplx,size_scal, &
    impart_hpsi,impart_hsub,impart_ssub,impart_dummy, &
    dummyw(1),dummyrwork(1),dummygap(1),kvec(3)
  complex(DPC) :: ps1,ar
  SCALAR :: dummya(1,1),dummyb(1,1),dummyz(1,1),dummywork(3)
  character(len=16) :: s1,s2,s3
  
  real(DP), allocatable :: enbuf(:)
  real(DP), allocatable :: enold(:)
  SCALAR, allocatable :: wfnbuf_d(:,:)
  SCALAR, allocatable :: wfnnew_d(:,:)
  SCALAR, allocatable :: residual_d(:,:)
  complex(DPC), allocatable :: wfnc_d(:)
  complex(DPC), allocatable :: wfnc(:)
  complex(DPC), allocatable :: hpsic_d(:)
  SCALAR, allocatable :: hpsi_d(:,:)
  integer, allocatable :: isort(:)
  real(DP), allocatable :: ekin(:)
  real(DP), allocatable :: norm(:)
  real(DP), allocatable :: ndum(:)
  real(DP), allocatable :: h_gg(:)
  complex(DPC), allocatable :: betapsi(:)
  complex(DPC), allocatable :: dummykb(:)
  complex(DPC), allocatable :: ps(:)
  logical, allocatable :: is_converged(:,:)
  integer, pointer :: crod(:)
  integer, pointer :: csph(:)
  integer, pointer :: drod(:)
  integer, pointer :: dsph(:)
  integer, pointer :: irod(:,:)
  integer, pointer :: isph(:)
  complex(DPC), pointer :: buffer_rod(:)
  complex(DPC), pointer :: buffer_sph(:)
  complex(DPC), pointer :: fftbox_2D(:,:,:)
  complex(DPC), pointer :: fftbox_1D(:,:)
  complex(DPC), pointer :: buffer_2D(:,:,:)
  complex(DPC), pointer :: buffer_1D(:,:,:)
  complex(DPC), pointer :: vlr_d(:,:,:,:)
  integer, pointer :: inv_indx(:,:,:)
  complex(DPC), pointer :: fftbox_3D(:,:,:)
  complex(DPC), allocatable :: vlg(:)
  complex(DPC), pointer :: vlr(:,:,:,:)
  complex(DPC), allocatable :: vlg_d(:)
  SCALAR, allocatable :: hcol(:)
  SCALAR, allocatable :: scol(:)
  SCALAR, allocatable :: dummyc(:)
  SCALAR, allocatable :: work(:)
  real(DP), allocatable :: rwork(:)
  integer, allocatable :: iwork(:)
  integer, allocatable :: iclustr(:)
  real(DP), allocatable :: gap(:)
  SCALAR, allocatable :: dummym(:,:)
  SCALAR, allocatable :: hmat(:,:)
  SCALAR, allocatable :: hbuf(:,:)
  SCALAR, allocatable :: smat(:,:)
  SCALAR, allocatable :: sbuf(:,:)
  SCALAR, allocatable :: zmat(:,:)
  SCALAR, allocatable :: zbuf(:,:)
  real(DP), allocatable :: w(:)
  integer, allocatable :: ifail(:)

  type (scalapack) :: scal

  PUSH_SUB(hdiag)

!------------------------
! Initialize

  minus_scale=sqrt(celvol)/dble(FFTgrid(1)*FFTgrid(2)*FFTgrid(3))
  plus_scale=1.0d0/sqrt(celvol)
  plus_scale_v=1.0d0
  if (fparafft) then
    call fft_set_p(FFTgrid,Nplane,Nrod)
  endif ! fparafft

  nvec=nbend-nbstart+1
  nmat=nvec*MAX(1,sapo_ham_ndim)
  is_diag=(sapo_ham_ndiag.gt.0)
  is_precond=(sapo_ham_ndiag.gt.1.and.sapo_ham_ndim.gt.1)

  abstol=0.0d0
  ! default sizes for lapack/scalapack arrays, as used in passing to subroutines, regardless of whether will be used
  lwork = 1
  lrwork = 1
  liwork = 1
  liclustr = 1
  lgap = 1
  if (fparala) then
    call blacs_setup(scal, nmat, .true.)
#ifdef USESCALAPACK
    orfac=1.0d-6
    call descinit(desca,nmat,nmat,scal%nbl,scal%nbl,0,0,scal%icntxt, &
      MAX(1,scal%npr),info)
#ifdef CPLX
    call PZHEGVX(1,'V','A','U',nmat,dummya,1,1,desca,dummyb,1,1,desca, &
      0.0d0,0.0d0,0,0,abstol,m,nz,dummyw,orfac,dummyz,1,1,desca, &
      dummywork,-1,dummyrwork,-1,dummyiwork,-1,dummyifail,dummyiclustr, &
      dummygap,info)
    lwork=nint(dble(dummywork(1)))
    lrwork=nint(dummyrwork(1))
#else
    call PDSYGVX(1,'V','A','U',nmat,dummya,1,1,desca,dummyb,1,1,desca, &
      0.0d0,0.0d0,0,0,abstol,m,nz,dummyw,orfac,dummyz,1,1,desca, &
      dummywork,-1,dummyiwork,-1,dummyifail,dummyiclustr,dummygap,info)
    lwork=nint(dummywork(1))
#endif
    liwork=dummyiwork(1)
    liclustr=2*scal%nprow*scal%npcol
    lgap=scal%nprow*scal%npcol
#endif
  else ! fparala
#ifdef CPLX
    call ZHEGVX(1,'V','A','U',nmat,dummya,nmat,dummyb,nmat,0.0d0,0.0d0, &
      0,0,abstol,m,dummyw,dummyz,nmat,dummywork,-1,dummyrwork,dummyiwork, &
      dummyifail,info)
    lwork=nint(dble(dummywork(1)))
    lrwork=7*nmat
#else
    call DSYGVX(1,'V','A','U',nmat,dummya,nmat,dummyb,nmat,0.0d0,0.0d0, &
      0,0,abstol,m,dummyw,dummyz,nmat,dummywork,-1,dummyiwork,dummyifail, &
      info)
    lwork=nint(dummywork(1))
#endif
    liwork=5*nmat
  endif ! fparala

!------------------------
! Memory report

  call procmem(amem,nmpinode)

#ifdef NOSIZEOF
  size_bool=4.0d0
  size_int=4.0d0
  size_real=8.0d0
  size_cplx=16.0d0
#else
  size_bool=dble(sizeof(is_diag))
  size_int=dble(sizeof(i))
  size_real=dble(sizeof(amem))
  size_cplx=dble(sizeof(ar))
#endif
  size_scal=dble(sizeof_scalar())

  rmem=0.0d0

  ! input arrays
  !
  rmem=rmem+dble(3*ng)*size_int
  rmem=rmem+dble(ngk_l*nk)*size_int
  rmem=rmem+dble(ng_l*ns)*size_scal
  if (fvkbg) then
    rmem=rmem+dble(nhm*nhm*nat*ns)*size_real
    rmem=rmem+dble(ngk_l*nkb*ns*nk)*size_cplx
  endif ! fvkbg
  rmem=rmem+dble(nbmax*nk*ns)*size_real
  rmem=rmem+dble(ngk_l*nbmax*ns*nk)*size_scal

  ! allocated arrays
  !
  rmem=rmem+dble(nvec)*size_real
  rmem=rmem+dble(nvec)*size_real
  rmem=rmem+dble(ngk_l*nmat)*size_scal
  rmem=rmem+dble(ngk_l*nvec)*size_scal
  rmem=rmem+dble(ngk_l*nvec)*size_scal
  rmem=rmem+dble(ngk_l)*size_cplx
  rmem=rmem+dble(ngk_g)*size_cplx
  rmem=rmem+dble(ngk_l)*size_cplx
  rmem=rmem+dble(ngk_l*nmat)*size_scal
  rmem=rmem+dble(ng_g)*size_int
  rmem=rmem+dble(ng)*size_real
  rmem=rmem+dble(nmat)*size_real
#ifdef MPI
  rmem=rmem+dble(nmat)*size_real
#endif
  !
  if (is_precond) then
    rmem=rmem+dble(ngk_l)*size_real
  endif ! is_precond
  !
  if (fvkbg) then
    rmem=rmem+dble(nkb)*size_cplx
#ifdef MPI
    rmem=rmem+dble(nkb)*size_cplx
#endif
    rmem=rmem+dble(nkb)*size_cplx
  endif ! fvkbg
  !
  rmem=rmem+dble(ns*nk)*size_bool
  !
  if (fparafft) then
    rmem=rmem+dble(peinf%npes)*size_int
    rmem=rmem+dble(peinf%npes)*size_int
    rmem=rmem+dble(peinf%npes)*size_int
    rmem=rmem+dble(peinf%npes)*size_int
    ! skip irod, isph, buffer_rod, and buffer_sph
    ! these arrays will be reallocated later
    rmem=rmem+dble(FFTgrid(1)*FFTgrid(2)*Nplane)*size_cplx
    rmem=rmem+dble(FFTgrid(3)*Nrod)*size_cplx
    rmem=rmem+dble(Nrod*Nplane*peinf%npes)*size_cplx
    rmem=rmem+dble(Nrod*Nplane*peinf%npes)*size_cplx
    rmem=rmem+dble(FFTgrid(1)*FFTgrid(2)*Nplane*ns)*size_cplx
  else ! fparafft
    rmem=rmem+dble(FFTgrid(1)*FFTgrid(2)*FFTgrid(3))*size_int
    rmem=rmem+dble(FFTgrid(1)*FFTgrid(2)*FFTgrid(3))*size_cplx
    rmem=rmem+dble(ng_g)*size_cplx
    rmem=rmem+dble(FFTgrid(1)*FFTgrid(2)*FFTgrid(3)*ns)*size_cplx
  endif ! fparafft
  rmem=rmem+dble(ng_l)*size_cplx
  !
  if (fparala) then
    npr=MAX(1,scal%npr)
    npc=MAX(1,scal%npc)
    rmem=rmem+dble(nmat)*size_scal
    rmem=rmem+dble(nmat)*size_scal
#ifdef MPI
    rmem=rmem+dble(nmat)*size_scal
#endif
#ifdef USESCALAPACK
    rmem=rmem+dble(lwork)*size_scal
    rmem=rmem+dble(lrwork)*size_real
    rmem=rmem+dble(liwork)*size_int
    rmem=rmem+dble(liclustr)*size_int
    rmem=rmem+dble(lgap)*size_real
#endif
  else ! fparala
    npr=nmat
    npc=nmat
#ifdef MPI
    rmem=rmem+dble(npr*npc)*size_scal
#endif
    rmem=rmem+dble(lwork)*size_scal
    rmem=rmem+dble(lrwork)*size_real
    rmem=rmem+dble(liwork)*size_int
  endif ! fparala
  rmem=rmem+dble(npr*npc)*size_scal
  rmem=rmem+dble(npr*npc)*size_scal
  rmem=rmem+dble(npr*npc)*size_scal
  rmem=rmem+dble(npr*npc)*size_scal
  rmem=rmem+dble(npr*npc)*size_scal
  rmem=rmem+dble(npr*npc)*size_scal
  rmem=rmem+dble(nmat)*size_real
  rmem=rmem+dble(nmat)*size_int

  if (peinf%inode.eq.0) then
    write(s1,222) amem/1024.0d0**2
    write(s2,211) nmpinode
    write(s3,222) rmem/1024.0d0**2
    write(6,233) TRUNC(s1), TRUNC(s2), TRUNC(s3)
  endif ! peinf%inode.eq.0

!------------------------
! Allocate arrays

  SAFE_ALLOCATE(enbuf, (nvec))
  SAFE_ALLOCATE(enold, (nvec))
  SAFE_ALLOCATE(wfnbuf_d, (ngk_l,nmat))
  SAFE_ALLOCATE(wfnnew_d, (ngk_l,nvec))
  SAFE_ALLOCATE(residual_d, (ngk_l,nvec))
  SAFE_ALLOCATE(wfnc_d, (ngk_l))
  SAFE_ALLOCATE(wfnc, (ngk_g))
  SAFE_ALLOCATE(hpsic_d, (ngk_l))
  SAFE_ALLOCATE(hpsi_d, (ngk_l,nmat))
  SAFE_ALLOCATE(isort, (ng_g))
  SAFE_ALLOCATE(ekin, (ng))
  SAFE_ALLOCATE(norm, (nmat))
#ifdef MPI
  SAFE_ALLOCATE(ndum, (nmat))
#else
  SAFE_ALLOCATE(ndum, (1))
#endif
  !
  if (is_precond) then
    SAFE_ALLOCATE(h_gg, (ngk_l))
  endif ! is_precond
  !
  if (fvkbg) then
    SAFE_ALLOCATE(betapsi, (nkb))
#ifdef MPI
    SAFE_ALLOCATE(dummykb, (nkb))
#else
    SAFE_ALLOCATE(dummykb, (1))
#endif
    SAFE_ALLOCATE(ps, (nkb))
  endif ! fvkbg
  !
  SAFE_ALLOCATE(is_converged, (ns,nk))
  !
  if (fparafft) then
    SAFE_ALLOCATE(crod, (peinf%npes))
    SAFE_ALLOCATE(csph, (peinf%npes))
    SAFE_ALLOCATE(drod, (peinf%npes))
    SAFE_ALLOCATE(dsph, (peinf%npes))
    SAFE_ALLOCATE(irod, (1,1))
    SAFE_ALLOCATE(isph, (1))
    SAFE_ALLOCATE(buffer_rod, (1))
    SAFE_ALLOCATE(buffer_sph, (1))
    SAFE_ALLOCATE(fftbox_2D, (FFTgrid(1),FFTgrid(2),Nplane))
    SAFE_ALLOCATE(fftbox_1D, (FFTgrid(3),Nrod))
    SAFE_ALLOCATE(buffer_2D, (Nrod,Nplane,peinf%npes))
    SAFE_ALLOCATE(buffer_1D, (Nrod,Nplane,peinf%npes))
    SAFE_ALLOCATE(vlr_d, (FFTgrid(1),FFTgrid(2),Nplane,ns))
    SAFE_ALLOCATE(inv_indx, (1,1,1))
    SAFE_ALLOCATE(fftbox_3D, (1,1,1))
    SAFE_ALLOCATE(vlr, (1,1,1,1))
    ! vlg is not passed to subroutines in case of fparafft = .true., so it remains unallocated
  else ! fparafft
    SAFE_ALLOCATE(crod, (1))
    SAFE_ALLOCATE(csph, (1))
    SAFE_ALLOCATE(drod, (1))
    SAFE_ALLOCATE(dsph, (1))
    SAFE_ALLOCATE(irod, (1,1))
    SAFE_ALLOCATE(isph, (1))
    SAFE_ALLOCATE(buffer_rod, (1))
    SAFE_ALLOCATE(buffer_sph, (1))
    SAFE_ALLOCATE(fftbox_2D, (1,1,1))
    SAFE_ALLOCATE(fftbox_1D, (1,1))
    SAFE_ALLOCATE(buffer_2D, (1,1,1))
    SAFE_ALLOCATE(buffer_1D, (1,1,1))
    SAFE_ALLOCATE(vlr_d, (1,1,1,1))
    SAFE_ALLOCATE(inv_indx, (FFTgrid(1),FFTgrid(2),FFTgrid(3)))
    SAFE_ALLOCATE(fftbox_3D, (FFTgrid(1),FFTgrid(2),FFTgrid(3)))
    SAFE_ALLOCATE(vlr, (FFTgrid(1),FFTgrid(2),FFTgrid(3),ns))
    SAFE_ALLOCATE(vlg, (ng_g))
  endif ! fparafft
  SAFE_ALLOCATE(vlg_d, (ng_l))
  !
  if (fparala) then
    npr=MAX(1,scal%npr)
    npc=MAX(1,scal%npc)
    SAFE_ALLOCATE(hcol, (nmat))
    SAFE_ALLOCATE(scol, (nmat))
#ifdef MPI
    SAFE_ALLOCATE(dummyc, (nmat))
#else
    SAFE_ALLOCATE(dummyc, (1))
#endif
    SAFE_ALLOCATE(dummym, (1,1))
  else ! fparala
    npr=nmat
    npc=nmat
    SAFE_ALLOCATE(hcol, (1))
    SAFE_ALLOCATE(scol, (1))
    SAFE_ALLOCATE(dummyc, (1))
#ifdef MPI
    SAFE_ALLOCATE(dummym, (npr,npc))
#else
    SAFE_ALLOCATE(dummym, (1,1))
#endif
  endif ! fparala
  SAFE_ALLOCATE(work, (lwork))
  SAFE_ALLOCATE(rwork, (lrwork))
  SAFE_ALLOCATE(iwork, (liwork))
  SAFE_ALLOCATE(ifail, (nmat))
  SAFE_ALLOCATE(iclustr, (liclustr))
  SAFE_ALLOCATE(gap, (lgap))
  SAFE_ALLOCATE(hmat, (npr,npc))
  SAFE_ALLOCATE(hbuf, (npr,npc))
  SAFE_ALLOCATE(smat, (npr,npc))
  SAFE_ALLOCATE(sbuf, (npr,npc))
  SAFE_ALLOCATE(zmat, (npr,npc))
  SAFE_ALLOCATE(zbuf, (npr,npc))
  SAFE_ALLOCATE(w, (nmat))

!------------------------
! Invert indices of G-vectors for potential

  call timacc(14,1)
    
  isort(:)=0
  do ig=1,ng_g
    isort(ig)=ig
  enddo ! ig
  if (fparafft) then
    call fft_map_p(0,ng,ng_l,Nrod,FFTgrid,isort,gvec, &
      mrod,msph,crod,csph,drod,dsph,irod,isph)
    SAFE_DEALLOCATE_P(irod)
    SAFE_DEALLOCATE_P(isph)
    SAFE_DEALLOCATE_P(buffer_rod)
    SAFE_DEALLOCATE_P(buffer_sph)
    SAFE_ALLOCATE(irod, (2,MAX(1,mrod)))
    SAFE_ALLOCATE(isph, (MAX(1,msph)))
    SAFE_ALLOCATE(buffer_rod, (MAX(1,mrod)))
    SAFE_ALLOCATE(buffer_sph, (MAX(1,msph)))
    call fft_map_p(1,ng,ng_l,Nrod,FFTgrid,isort,gvec, &
      mrod,msph,crod,csph,drod,dsph,irod,isph)
  else ! fparafft
    call fft_map_s(ng,FFTgrid,isort,gvec,inv_indx)
  endif ! fparafft

!------------------------
! Bring potential from G-space to R-space

  do is=1,ns

    do ig=1,ng_l
      vlg_d(ig)=COMPLEXIFY(vsc_d(ig,is))
    enddo ! ig

    if (fparafft) then

      call fft_g2r_p(FFTgrid,Nplane,Nrod,mrod,msph,crod, &
        csph,drod,dsph,irod,isph,plus_scale_v,vlg_d,fftbox_2D, &
        fftbox_1D,buffer_2D,buffer_1D,buffer_rod,buffer_sph)
      vlr_d(:,:,:,is)=fftbox_2D(:,:,:)

    else ! fparafft

#ifdef MPI
      call MPI_Gather(vlg_d,ng_l,MPI_COMPLEX_DPC, &
        vlg,ng_l,MPI_COMPLEX_DPC,0,MPI_COMM_WORLD,mpierr)
#else
      vlg(:)=vlg_d(:)
#endif
      call fft_g2r_s(FFTgrid,plus_scale_v,inv_indx,vlg,fftbox_3D)
      vlr(:,:,:,is)=fftbox_3D(:,:,:)

    endif ! fparafft

  enddo ! is

  call timacc(14,2)

!------------------------
! Compute average potential

  if (is_precond) then

    call timacc(20,1)
    !
    v_0=0.0d0
    !
    if (fparafft) then
      !
      do is=1,ns
        do k=1,Nplane
          do j=1,FFTgrid(2)
            do i=1,FFTgrid(1)
              v_0=v_0+vlr_d(i,j,k,is)
            enddo ! i
          enddo ! j
        enddo ! k
      enddo ! is
      !
#ifdef MPI
      vdummy=v_0
      call MPI_Allreduce(vdummy,v_0,1, &
        MPI_REAL_DP,MPI_SUM,MPI_COMM_WORLD,mpierr)
#endif
      !
    else ! fparafft
      !
      do is=1,ns
        do k=1,FFTgrid(3)
          do j=1,FFTgrid(2)
            do i=1,FFTgrid(1)
              v_0=v_0+vlr(i,j,k,is)
            enddo ! i
          enddo ! j
        enddo ! k
      enddo ! is
      !
    endif ! fparafft
    !
    v_0=v_0/dble(FFTgrid(1)*FFTgrid(2)*FFTgrid(3)*ns)
    !
    call timacc(20,2)

  endif ! is_precond

!------------------------
! Iterative diagonalization loop

  is_converged(:,:)=.false.

  restart_loop: do irestart = 1, MAX(1, sapo_ham_nrestart)

    idiagtot=0
    detot=0.0d0
    restot=0.0d0

    do ik=1,nk

      if (all(is_converged(:,ik))) cycle

!------------------------
! Compute kinetic energies of G-vectors

      call timacc(15,1)
      
      do ig=1,ng
        do i=1,3
          kvec(i)=kpt(i,ik)+dble(gvec(i,ig))
        enddo
        ekin(ig)=DOT_PRODUCT(kvec,MATMUL(bdot,kvec))
      enddo

      call timacc(15,2)

!------------------------
! Gather indices of G-vectors for current k-point

      call timacc(12,1)

#ifdef MPI
      call MPI_Gather(isort_d(:,ik),ngk_l,MPI_INTEGER, &
        isort,ngk_l,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
      call MPI_Bcast(isort,ngk_g,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#else
      ! need explicit range here to avoid out of bounds error
      ! because in serial version isort is of size (ng) and
      ! isort_d is of size (ngkmax,nk)
      isort(1:ngk_l)=isort_d(1:ngk_l,ik)
#endif

      call timacc(12,2)

!------------------------
! Invert indices of G-vectors for current k-point

      call timacc(14,1)
      
      if (fparafft) then
        call fft_map_p(0,ngk(ik),ngk_l,Nrod,FFTgrid,isort,gvec, &
          mrod,msph,crod,csph,drod,dsph,irod,isph)
        SAFE_DEALLOCATE_P(irod)
        SAFE_DEALLOCATE_P(isph)
        SAFE_DEALLOCATE_P(buffer_rod)
        SAFE_DEALLOCATE_P(buffer_sph)
        SAFE_ALLOCATE(irod, (2,MAX(1,mrod)))
        SAFE_ALLOCATE(isph, (MAX(1,msph)))
        SAFE_ALLOCATE(buffer_rod, (MAX(1,mrod)))
        SAFE_ALLOCATE(buffer_sph, (MAX(1,msph)))
        call fft_map_p(1,ngk(ik),ngk_l,Nrod,FFTgrid,isort,gvec, &
          mrod,msph,crod,csph,drod,dsph,irod,isph)
      else ! fparafft
        call fft_map_s(ngk(ik),FFTgrid,isort,gvec,inv_indx)
      endif ! fparafft
      
      call timacc(14,2)
      
      do is=1,ns

        if (is_converged(is,ik)) cycle

!------------------------
! Diagonal part of Hamiltonian

        if (is_precond) then

          call timacc(20,1)
          !
          do ig=1,ngk_l
            if (isort_d(ig,ik).ne.0) then
              h_gg(ig)=ekin(isort_d(ig,ik))+v_0
            else
              h_gg(ig)=0.0d0
            endif
          enddo
          !
          ijkb0=0
          do isp=1,nsp
            do iat=1,nat
              if (ityp(iat).eq.isp) then
                do ih=1,nh(isp)
                  ikb=ijkb0+ih
                  ps1=deeq(ih,ih,iat,is)
                  do ig=1,ngk_l
                    if (isort_d(ig,ik).ne.0) then
                      ar=vkb_d(ig,ikb,is,ik)*CONJG(vkb_d(ig,ikb,is,ik))
                      h_gg(ig)=h_gg(ig)+ps1*ar
                    endif
                  enddo
                enddo
                ijkb0=ijkb0+nh(isp)
              endif
            enddo
          enddo
          !
          call timacc(20,2)

        endif ! is_precond

        call timacc(20,1)

!------------------------
! Starting eigenvalues and wavefunctions

        do ib=nbstart,nbend
          im=ib-nbstart+1
          enbuf(im)=en(ib,ik,is)
        enddo ! ib

        do ib=nbstart,nbend
          im=ib-nbstart+1
          do ig=1,ngk_l
            wfnbuf_d(ig,im)=wfn_d(ig,ib,is,ik)
          enddo ! ig
        enddo ! ib

!------------------------
! Initialize subspace Hamiltonian and eigenvector matrices,
! only needed for computing residual vectors (sapo_ham_ndiag = 0)
! or if subspace diagonalization fails on the first iteration

        call dsub(fparala,nvec,nmat,npr,npc,scal, &
          enbuf,hcol,scol,hmat,smat,zmat)

!------------------------
! Initialize counters for the basis functions

        npre=0
        nbas=nvec
        resmax=INF

        call timacc(20,2)

!------------------------
! Iterative diagonalization loop

        diag_loop: do idiag = 1, MAX(1, sapo_ham_ndiag)

          call timacc(20,1)

!------------------------
! Normalize wavefunctions

          if (is_diag) then

            call npsi(.true.,fblas,npre,nbas,nmat,ngk_l,wfnbuf_d,norm,ndum)

          endif ! is_diag

!------------------------
! Store old eigenvectors

          zbuf(:,:)=zmat(:,:)

          call timacc(20,2)

!------------------------
! Apply Hamiltonian to wavefunctions

          impart_hpsi = 0.0d0
          do im=npre+1,nbas

            call hpsi(fparafft,fvkbg,nk,ns,nmat,ng,ngk_l,ngk_g, &
              ik,is,im,Nplane,Nrod,nat,nsp,nkb,nhm,FFTgrid,mrod,msph,crod, &
              csph,drod,dsph,irod,isph,ityp,nh,ekin,inv_indx,isort_d, &
              wfnbuf_d,wfnc_d,wfnc,vlr,vlr_d,vkb_d,deeq,betapsi,dummykb, &
              ps,fftbox_3D,fftbox_2D,fftbox_1D,buffer_2D,buffer_1D, &
              buffer_rod,buffer_sph,minus_scale,plus_scale,hpsic_d, &
              hpsi_d,impart_hpsi)

          enddo ! im
#ifdef MPI
          impart_dummy=impart_hpsi
          call MPI_Reduce(impart_dummy,impart_hpsi,1, &
            MPI_DOUBLE_PRECISION,MPI_MAX,0,MPI_COMM_WORLD,mpierr)
#endif
          if (peinf%inode.eq.0.and.impart_hpsi.gt.TOL_Small) then
            write(0,444) 'hpsi', impart_hpsi, idiag, is, ik, kpt(:,ik)
            write(0,455)
          endif

!------------------------
! Construct and diagonalize subspace Hamiltonian

          if (is_diag) then

            impart_hsub=0.0d0
            impart_ssub=0.0d0
            call hsub(fparala,fblas,npre,nvec,nbas,nmat,npr,npc, &
              ngk_l,lwork,lrwork,liwork,liclustr,lgap,scal,abstol, &
              orfac,desca,wfnbuf_d,hpsi_d,work,rwork,iwork,ifail, &
              iclustr,gap,hcol,scol,dummyc,dummym,w,hmat,hbuf,smat, &
              sbuf,zmat,impart_hsub,impart_ssub,is_error)
#ifdef MPI
            impart_dummy=impart_hsub
            call MPI_Reduce(impart_dummy,impart_hsub,1, &
              MPI_DOUBLE_PRECISION,MPI_MAX,0,MPI_COMM_WORLD,mpierr)
            impart_dummy=impart_ssub
            call MPI_Reduce(impart_dummy,impart_ssub,1, &
              MPI_DOUBLE_PRECISION,MPI_MAX,0,MPI_COMM_WORLD,mpierr)
#endif
            if (peinf%inode.eq.0.and.impart_hsub.gt.TOL_Small) &
              write(0,444) 'hsub', impart_hsub, idiag, is, ik, kpt(:,ik)
            if (peinf%inode.eq.0.and.impart_ssub.gt.TOL_Small) &
              write(0,444) 'ssub', impart_ssub, idiag, is, ik, kpt(:,ik)

          else ! is_diag

            is_error=.false.

          endif ! is_diag

          resold=resmax

          if (is_error) then

            call timacc(20,1)

!------------------------
! If subspace diagonalization failed restore the old
! eigenvectors and reset the variables for residual
! vectors and eigenvalues

            nbas=MAX(nvec,npre)
            zmat(:,:)=zbuf(:,:)
            resmax=INF
            nres=0
            demax=INF

            call timacc(20,2)

          else ! is_error

            call timacc(20,1)

!------------------------
! Rotate wavefunctions, wfnnew_d = zmat . wfnbuf_d

            call rpsi(fparala,fblas,nvec,nbas,nmat,npr,npc,ngk_l, &
              scal,zmat,wfnbuf_d,wfnnew_d,scol,dummyc)

!------------------------
! Rotate hpsi vectors, residual_d = zmat . hpsi_d

            call rpsi(fparala,fblas,nvec,nbas,nmat,npr,npc,ngk_l, &
              scal,zmat,hpsi_d,residual_d,scol,dummyc)

!------------------------
! Compute residual vectors, R = (H - E) psi

            do im=1,nvec
              do ig=1,ngk_l
                residual_d(ig,im)=residual_d(ig,im)-enbuf(im)* &
                  wfnnew_d(ig,im)
              enddo ! ig
            enddo ! im

!------------------------
! Compute norms of residual vectors

            call npsi(.false.,fblas,0,nvec,nvec,ngk_l,residual_d,norm,ndum)

!------------------------
! Compute maximum norm of residual vectors

            resmax=MAXVAL(norm(1:nvec))

            call timacc(20,2)

!------------------------
! If computing the residual vectors only (is_diag = .false.)
! exit iterative diagonalization loop

            if (.not.is_diag) exit diag_loop

            call timacc(20,1)

!------------------------
! Check if convergence is reached

            is_converged(is,ik) = (resmax .le. sapo_ham_tol)

!------------------------
! Count unconverged wavefunctions

            jm=0
            do im=1,nvec
              if (norm(im).gt.sapo_ham_tol) jm=jm+1
            enddo ! im
            nres=jm

!------------------------
! Store old eigenvalues

            do im=1,nvec
              enold(im)=enbuf(im)
            enddo ! im

!------------------------
! Update eigenvalues

            do im=1,nvec
              enbuf(im)=w(im)
            enddo ! im

!------------------------
! Find the maximum change in eigenvalues

            demax=0.0d0
            do im=1,nvec
              if (demax.lt.abs(enold(im)-enbuf(im))) &
                demax=abs(enold(im)-enbuf(im))
            enddo ! im

            call timacc(20,2)

          endif ! is_error

          call timacc(20,1)

!------------------------
! Check whether to update the wavefunctions or to expand
! the basis set. If the size of the new basis set exceeds
! the maximum (nbas + nres > nmat) or we are on the last
! iteration (idiag = sapo_ham_ndiag) or the convergence is
! reached (is_converged(is,ik)) or subspace diagonalization
! failed (is_error) or the maximum norm of residual vectors
! is increasing (only checked if sapo_ham_resinc = .true.)
! then update the wavefunctions, otherwise expand the basis set

          is_updatewfn = ((nbas + nres .gt. nmat) .or. &
            (idiag .eq. MAX(1, sapo_ham_ndiag)) .or. &
            is_converged(is,ik) .or. &
            is_error .or. &
            (sapo_ham_resinc .and. resmax .gt. resold + TOL_Zero))

          if (is_updatewfn) then

!------------------------
! Rotate wavefunctions and hpsi vectors,
! update subspace Hamiltonian and eigenvector matrices,
! reset number of the basis functions

            call rpsi(fparala,fblas,nvec,nbas,nmat,npr,npc,ngk_l, &
              scal,zmat,wfnbuf_d,wfnnew_d,scol,dummyc)

            do im=1,nvec
              do ig=1,ngk_l
                wfnbuf_d(ig,im)=wfnnew_d(ig,im)
              enddo ! ig
            enddo ! im

            call rpsi(fparala,fblas,nvec,nbas,nmat,npr,npc,ngk_l, &
              scal,zmat,hpsi_d,wfnnew_d,scol,dummyc)

            do im=1,nvec
              do ig=1,ngk_l
                hpsi_d(ig,im)=wfnnew_d(ig,im)
              enddo ! ig
            enddo ! im

            call dsub(fparala,nvec,nmat,npr,npc,scal, &
              enbuf,hcol,scol,hmat,smat,zmat)

            npre=nvec
            nbas=nvec

          else ! is_updatewfn

!------------------------
! Precondition residual vectors of unconverged wavefunctions,
! add them to the basis functions, increment number of the
! basis functions

            jm=nbas
            do im=1,nvec
              if (norm(im).gt.sapo_ham_tol) then
                jm=jm+1
                do ig=1,ngk_l
                  if (isort_d(ig,ik).ne.0) then
                    call calc_precond(h_gg(ig),enbuf(im),precond)
                    wfnbuf_d(ig,jm)=precond*residual_d(ig,im)
                  else ! isort_d(ig,ik).ne.0
                    wfnbuf_d(ig,jm)=ZERO
                  endif ! isort_d(ig,ik).ne.0
                enddo ! ig
              endif ! norm(im).gt.sapo_ham_tol
            enddo ! im

            npre=nbas
            nbas=nbas+nres

          endif ! is_updatewfn

!------------------------
! Store the number of diagonalization steps

          idiagmax = idiag

!------------------------
! Print convergence information

          if (peinf%inode.eq.0) write(6,333) &
            ik, is, idiagmax, demax, resmax

          call timacc(20,2)

!------------------------
! If the convergence for this k-point/spin is reached
! exit iterative diagonalization loop

          if (is_converged(is,ik)) exit diag_loop

        enddo diag_loop ! idiag

!------------------------
! Final eigenvalues and wavefunctions

        call timacc(20,1)

        do ib=nbstart,nbend
          im=ib-nbstart+1
          en(ib,ik,is)=enbuf(im)
        enddo ! ib

        do ib=nbstart,nbend
          im=ib-nbstart+1
          do ig=1,ngk_l
            wfn_d(ig,ib,is,ik)=wfnbuf_d(ig,im)
          enddo ! ig
        enddo ! ib

        call timacc(20,2)

!------------------------
! Store total maximum change in eigenvalues,
! total maximum norm of residual vectors,
! total number of diagonalization steps

        if (is_diag) then
          if (idiagtot .lt. idiagmax) idiagtot = idiagmax
          if (detot .lt. demax) detot = demax
        endif ! is_diag
        if (restot .lt. resmax) restot = resmax

      enddo ! is
      
    enddo ! ik

!------------------------
! Print total convergence information

    if (peinf%inode.eq.0) then
      write(6,*)
      if (is_diag) then
        write(6,344) idiagtot, sapo_ham_ndiag
        write(6,355) detot
      endif ! is_diag
      write(6,366) restot
    endif ! peinf%inode.eq.0

!------------------------
! Set random initial wavefunctions
! for iterative diagonalization restart

    call timacc(20,1)

    if (irestart.lt.sapo_ham_nrestart) then
      do ik=1,nk
        do is=1,ns
          if (.not.is_converged(is,ik)) then
            call random_wfng(nk,ns,nbstart,nbend,nbmax,ngk_l,ik,is,ngk, &
              0.0d0,1.0d0,wfn_d)
          endif ! .not.is_converged(is,ik)
        enddo ! is
      enddo ! ik
    endif ! irestart.lt.sapo_ham_nrestart

    call timacc(20,2)

!------------------------
! If the convergence for all k-points/spins is reached
! exit restart loop

    if (all(is_converged(:,:))) exit restart_loop

  enddo restart_loop ! irestart

!------------------------
! Print warning if convergence has not been achieved

  if (peinf%inode.eq.0.and..not.all(is_converged(:,:))) write(0,466)

!------------------------
! Release BLACS

  if (fparala) then
#ifdef USESCALAPACK
    call blacs_exit(1)
#endif
  endif ! fparala
  
!------------------------
! Deallocate arrays

  SAFE_DEALLOCATE(enbuf)
  SAFE_DEALLOCATE(enold)
  SAFE_DEALLOCATE(wfnbuf_d)
  SAFE_DEALLOCATE(wfnnew_d)
  SAFE_DEALLOCATE(residual_d)
  SAFE_DEALLOCATE(wfnc_d)
  SAFE_DEALLOCATE(wfnc)
  SAFE_DEALLOCATE(hpsic_d)
  SAFE_DEALLOCATE(hpsi_d)
  SAFE_DEALLOCATE(isort)
  SAFE_DEALLOCATE(ekin)
  SAFE_DEALLOCATE(norm)
  SAFE_DEALLOCATE(ndum)
  !
  if (is_precond) then
    SAFE_DEALLOCATE(h_gg)
  endif ! is_precond
  !
  if (fvkbg) then
    SAFE_DEALLOCATE(betapsi)
    SAFE_DEALLOCATE(dummykb)
    SAFE_DEALLOCATE(ps)
  endif ! fvkbg
  !
  SAFE_DEALLOCATE(is_converged)
  !
  SAFE_DEALLOCATE_P(crod)
  SAFE_DEALLOCATE_P(csph)
  SAFE_DEALLOCATE_P(drod)
  SAFE_DEALLOCATE_P(dsph)
  SAFE_DEALLOCATE_P(irod)
  SAFE_DEALLOCATE_P(isph)
  SAFE_DEALLOCATE_P(buffer_rod)
  SAFE_DEALLOCATE_P(buffer_sph)
  SAFE_DEALLOCATE_P(fftbox_2D)
  SAFE_DEALLOCATE_P(fftbox_1D)
  SAFE_DEALLOCATE_P(buffer_2D)
  SAFE_DEALLOCATE_P(buffer_1D)
  SAFE_DEALLOCATE_P(vlr_d)
  SAFE_DEALLOCATE_P(inv_indx)
  SAFE_DEALLOCATE_P(fftbox_3D)
  SAFE_DEALLOCATE_P(vlr)
  if (.not.fparafft) then
    SAFE_DEALLOCATE(vlg)
  endif ! .not.fparafft
  SAFE_DEALLOCATE(vlg_d)
  !
  SAFE_DEALLOCATE(hcol)
  SAFE_DEALLOCATE(scol)
  SAFE_DEALLOCATE(dummyc)
  SAFE_DEALLOCATE(dummym)
  SAFE_DEALLOCATE(work)
  SAFE_DEALLOCATE(rwork)
  SAFE_DEALLOCATE(iwork)
  SAFE_DEALLOCATE(ifail)
  SAFE_DEALLOCATE(iclustr)
  SAFE_DEALLOCATE(gap)
  SAFE_DEALLOCATE(hmat)
  SAFE_DEALLOCATE(hbuf)
  SAFE_DEALLOCATE(smat)
  SAFE_DEALLOCATE(sbuf)
  SAFE_DEALLOCATE(zmat)
  SAFE_DEALLOCATE(zbuf)
  SAFE_DEALLOCATE(w)

  call destroy_fftw_plans()

  POP_SUB(hdiag)

  return

211 format(i16)
222 format(f16.1)
233 format(1x,'Memory available:',1x,a,1x,'MB per MPI task,',1x,a,1x, &
  'MPI tasks per node',/,1x,'Memory required for execution:',1x,a,1x, &
  'MB per MPI task',/)

333 format(3x,"ik =",i5,3x,"is =",i3,3x,"idiag =",i5,3x, &
  "dE(Ry) =",g20.15,3x,"residual =",g20.15)
344 format(1x,"Maximum number of iterations:",/, &
  4x,i6,2x,"of",2x,i6,/)
355 format(1x,"Maximum change in eigenvalues (Ry):",/, &
  4x,"max | delta E_nk | =",g20.15,/)
366 format(1x,"Maximum norm of residual vectors (Ry):",/, &
  4x,"max | R_nk | =",g20.15,/)

444 format(1x,"WARNING: max(Im(",a4,")) =",e13.6," for idiag =",i3, &
  " is =",i2," ik =",i3,/,3x,"k = (",3f10.6,")",/)
455 format(1x,"!!! MAKE SURE INVERSION SYMMETRY HAS NO FRACTIONAL", &
  " TRANSLATION !!!",/)
466 format(1x,"WARNING: Convergence has not been achieved.",/)

end subroutine hdiag

!===============================================================================

subroutine hpsi(fparafft,fvkbg,nk,ns,nmat,ng,ngk_l,ngk_g, &
  ik,is,im,Nplane,Nrod,nat,nsp,nkb,nhm,FFTgrid,mrod,msph,crod, &
  csph,drod,dsph,irod,isph,ityp,nh,ekin,inv_indx,isort_d, &
  wfnbuf_d,wfnc_d,wfnc,vlr,vlr_d,vkb_d,deeq,betapsi,dummykb, &
  ps,fftbox_3D,fftbox_2D,fftbox_1D,buffer_2D,buffer_1D, &
  buffer_rod,buffer_sph,minus_scale,plus_scale,hpsic_d, &
  hpsi_d,impart_hpsi)

! This subroutine applies the Hamiltonian to a wavefunction.
! On entrance takes wfnbuf_d(1:ngk_l,im) set in hdiag. On exit
! returns hpsi_d(1:ngk_l,im), in real flavor sets impart_hpsi
! to max imaginary part of hpsi_d(1:ngk_l,im)

  logical, intent(in) :: fparafft,fvkbg
  integer, intent(in) :: nk,ns,nmat,ng,ngk_l,ngk_g, &
  ik,is,im,Nplane,Nrod,nat,nsp,nkb,nhm
  integer, intent(in) :: FFTgrid(3)
  integer, intent(inout) :: mrod,msph
  integer, intent(inout) :: crod(:) !< (peinf%npes)
  integer, intent(inout) :: csph(:) !< (peinf%npes)
  integer, intent(inout) :: drod(:) !< (peinf%npes)
  integer, intent(inout) :: dsph(:) !< (peinf%npes)
  integer, intent(inout) :: irod(:,:) !< (2,MAX(1,mrod))
  integer, intent(inout) :: isph(:) !< (MAX(1,msph))
  integer, intent(in) :: ityp(:) !< (nat)
  integer, intent(in) :: nh(:) !< (nsp)
  real(DP), intent(in) :: ekin(:) !< (ng)
  integer, intent(in) :: inv_indx(:,:,:) !< (FFTgrid(1),FFTgrid(2),FFTgrid(3))
  integer, intent(in) :: isort_d(:,:) !< (ngk_l,nk)
  SCALAR, intent(in) :: wfnbuf_d(:,:) !< (ngk_l,nmat)
  complex(DPC), intent(out) :: wfnc_d(:) !< (ngk_l)
  complex(DPC), intent(out) :: wfnc(:) !< (ngk_g)
  complex(DPC), intent(in) :: vlr(:,:,:,:) !< (FFTgrid(1),FFTgrid(2),FFTgrid(3),ns)
  complex(DPC), intent(in) :: vlr_d(:,:,:,:) !< (FFTgrid(1),FFTgrid(2),Nplane,ns)
  complex(DPC), intent(in) :: vkb_d(:,:,:,:) !< (ngk_l,nkb,ns,nk)
  real(DP), intent(in) :: deeq(:,:,:,:) !< (nhm,nhm,nat,ns)
  complex(DPC), intent(out) :: betapsi(:) !< (nkb)
  complex(DPC), intent(inout) :: dummykb(:) !< (nkb)
  complex(DPC), intent(out) :: ps(:) !< (nkb)
  complex(DPC), intent(out) :: fftbox_3D(:,:,:) !< (FFTgrid(1),FFTgrid(2),FFTgrid(3))
  complex(DPC), intent(out) :: fftbox_2D(:,:,:) !< (FFTgrid(1),FFTgrid(2),Nplane)
  complex(DPC), intent(out) :: fftbox_1D(:,:) !< (FFTgrid(3),Nrod)
  complex(DPC), intent(out) :: buffer_2D(:,:,:) !< (Nrod,Nplane,peinf%npes)
  complex(DPC), intent(out) :: buffer_1D(:,:,:) !< (Nrod,Nplane,peinf%npes)
  complex(DPC), intent(out) :: buffer_rod(:) !< (MAX(1,mrod))
  complex(DPC), intent(out) :: buffer_sph(:) !< (MAX(1,msph))
  real(DP), intent(in) :: minus_scale,plus_scale
  complex(DPC), intent(out) :: hpsic_d(:) !< (ngk_l)
  SCALAR, intent(inout) :: hpsi_d(:,:) !< (ngk_l,nmat)
  real(DP), intent(inout) :: impart_hpsi

  integer :: i,j,k,ig,iat,isp,ih,jh,ikb,jkb,ijkb0

  PUSH_SUB(hpsi)

!------------------------
! Convert wavefunction from scalar to complex

  call timacc(20,1)

  do ig=1,ngk_l
    wfnc_d(ig)=COMPLEXIFY(wfnbuf_d(ig,im))
  enddo ! ig

  call timacc(20,2)

!------------------------
! Bring wavefunction to R-space

  call timacc(14,1)
  
  if (fparafft) then
    call fft_g2r_p(FFTgrid,Nplane,Nrod,mrod,msph,crod, &
      csph,drod,dsph,irod,isph,plus_scale,wfnc_d,fftbox_2D, &
      fftbox_1D,buffer_2D,buffer_1D,buffer_rod,buffer_sph)
  else
#ifdef MPI
    call MPI_Gather(wfnc_d,ngk_l,MPI_COMPLEX_DPC, &
      wfnc,ngk_l,MPI_COMPLEX_DPC,0,MPI_COMM_WORLD,mpierr)
#else
    wfnc(:)=wfnc_d(:)
#endif
    call fft_g2r_s(FFTgrid,plus_scale,inv_indx,wfnc,fftbox_3D)
  endif

  call timacc(14,2)

!------------------------
! Multiply wavefunction by local potential

  call timacc(16,1)
  
  if (fparafft) then
    do k=1,Nplane
      do j=1,FFTgrid(2)
        do i=1,FFTgrid(1)
          fftbox_2D(i,j,k)=vlr_d(i,j,k,is)*fftbox_2D(i,j,k)
        enddo ! i
      enddo ! j
    enddo ! k
  else ! fparafft
    do k=1,FFTgrid(3)
      do j=1,FFTgrid(2)
        do i=1,FFTgrid(1)
          fftbox_3D(i,j,k)=vlr(i,j,k,is)*fftbox_3D(i,j,k)
        enddo ! i
      enddo ! j
    enddo ! k
  endif ! fparafft
  
  call timacc(16,2)

!------------------------
! Bring the product back to G-space
  
  call timacc(14,1)
  
  if (fparafft) then
    call fft_r2g_p(FFTgrid,Nplane,Nrod,mrod,msph,crod, &
      csph,drod,dsph,irod,isph,minus_scale,fftbox_2D,fftbox_1D, &
      buffer_2D,buffer_1D,buffer_rod,buffer_sph,hpsic_d)
  else
    call fft_r2g_s(FFTgrid,minus_scale,inv_indx,fftbox_3D,wfnc)
#ifdef MPI
    call MPI_Scatter(wfnc,ngk_l,MPI_COMPLEX_DPC, &
      hpsic_d,ngk_l,MPI_COMPLEX_DPC,0,MPI_COMM_WORLD,mpierr)
#else
    hpsic_d(:)=wfnc(:)
#endif
  endif
  
  call timacc(14,2)

!------------------------
! Add non-local pseudopotential

  call timacc(17,1)
  
  if (fvkbg) then
    
    betapsi(:)=(0.0d0,0.0d0)
    do ikb=1,nkb
      betapsi(ikb) = betapsi(ikb) + sum(CONJG(vkb_d(:,ikb,is,ik))*wfnc_d(:))
      ! FHJ: The following line is equivalent to the previous, but should be
      ! faster. I`m keeping it commented out because we don`t have a test
      ! case for complex SAPO.
      !betapsi(ikb) = betapsi(ikb) + zdotc(ngk_l, vkb_d(:,ikb,is,ik), 1, wfnc_d(:), 1)
    enddo ! ikb
    
#ifdef MPI
    dummykb(:)=betapsi(:)
    call MPI_Allreduce(dummykb,betapsi,nkb, &
      MPI_COMPLEX_DPC,MPI_SUM,MPI_COMM_WORLD,mpierr)
#endif
    
    ps(:)=(0.0d0,0.0d0)
    ijkb0=0
    do isp=1,nsp
      do iat=1,nat
        if (ityp(iat).eq.isp) then
          do ih=1,nh(isp)
            ikb=ijkb0+ih
            do jh=1,nh(isp)
              jkb=ijkb0+jh
              ps(jkb)=ps(jkb)+ &
                deeq(jh,ih,iat,is)*betapsi(ikb)
            enddo ! jh
          enddo ! ih
          ijkb0=ijkb0+nh(isp)
        endif ! ityp(iat).eq.isp
      enddo ! iat
    enddo ! isp
    
    do ikb=1,nkb
      do ig=1,ngk_l
        ! FHJ: One should technically enclose the following line with a
        ! "if (isort_d(ig,ik)/=0)". I`m not doing that because vkb_d is zero
        ! when isort_d(ig)==0, and conditionals penalize vectorization.
        hpsic_d(ig)=hpsic_d(ig)+ &
          vkb_d(ig,ikb,is,ik)*ps(ikb)
      enddo ! ig
    enddo ! ikb
    
  endif ! fvkbg
  
  call timacc(17,2)
  
!------------------------
! Add kinetic energy

  call timacc(15,1)
  
  do ig=1,ngk_l
    if (isort_d(ig,ik).ne.0) &
      hpsic_d(ig)=hpsic_d(ig)+ &
        ekin(isort_d(ig,ik))*wfnc_d(ig)
  enddo ! ig
  
  call timacc(15,2)

!------------------------
! Convert from complex to scalar

  call timacc(12,1)

  do ig=1,ngk_l
    if (isort_d(ig,ik).ne.0) then
      hpsi_d(ig,im)=SCALARIFY(hpsic_d(ig))
#ifndef CPLX
      impart_hpsi = MAX(impart_hpsi, abs(IMAG(hpsic_d(ig))))
#endif
    else
      hpsi_d(ig,im)=ZERO
    endif
  enddo ! ig

  call timacc(12,2)

  POP_SUB(hpsi)

  return

end subroutine hpsi

!===============================================================================

subroutine hsub(fparala,fblas,npre,nvec,nbas,nmat,npr,npc, &
  ngk_l,lwork,lrwork,liwork,liclustr,lgap,scal,abstol, &
  orfac,desca,wfnbuf_d,hpsi_d,work,rwork,iwork,ifail, &
  iclustr,gap,hcol,scol,dummyc,dummym,w,hmat,hbuf,smat, &
  sbuf,zmat,impart_hsub,impart_ssub,is_error)

! This subroutine constructs and diagonalizes the subspace
! Hamiltonian. On entrance takes wfnbuf_d(1:ngk_l,1:nbas)
! set in hdiag and hpsi_d(1:ngk_l,1:nbas) computed in hpsi.
! On exit returns eigenvalues in w(1:nvec) and eigenvectors in
! zmat(1:npr,1:npc)/(1:nbas,1:nvec) (if fparala = .true./.false.),
! in complex flavor sets impart_hsub/impart_ssub to max imaginary
! part of hmat(im,im)/smat(im,im)

  logical, intent(in) :: fparala,fblas
  integer, intent(in) :: npre,nvec,nbas,nmat,npr,npc,ngk_l, &
    lwork,lrwork,liwork,liclustr,lgap
  type (scalapack), intent(in) :: scal
  real(DP), intent(in) :: abstol,orfac
  integer, intent(in) :: desca(9)
  SCALAR, intent(in) :: wfnbuf_d(:,:) !< (ngk_l,nmat)
  SCALAR, intent(in) :: hpsi_d(:,:) !< (ngk_l,nmat)
  SCALAR, intent(inout) :: work(:) !< (lwork)
  real(DP), intent(inout) :: rwork(:) !< (lrwork)
  real(DP), intent(inout) :: gap(:) !< (lgap)
  integer, intent(inout) :: iwork(:) !< (liwork)
  integer, intent(inout) :: ifail(:) !< (nmat)
  integer, intent(inout) :: iclustr(:) !< (liclustr)
  SCALAR, intent(inout) :: hcol(:) !< (nmat)
  SCALAR, intent(inout) :: scol(:) !< (nmat)
  SCALAR, intent(inout) :: dummyc(:) !< (nmat)
  SCALAR, intent(inout) :: dummym(:,:) !< (nmat,nmat)
  real(DP), intent(out) :: w(:) !< (nmat)
  SCALAR, intent(inout) :: hmat(:,:) !< (npr,npc)
  SCALAR, intent(inout) :: hbuf(:,:) !< (npr,npc)
  SCALAR, intent(inout) :: smat(:,:) !< (npr,npc)
  SCALAR, intent(inout) :: sbuf(:,:) !< (npr,npc)
  SCALAR, intent(inout) :: zmat(:,:) !< (npr,npc)
  real(DP), intent(inout) :: impart_hsub
  real(DP), intent(inout) :: impart_ssub
  logical, intent(out) :: is_error

  integer :: im,jm,ig,icurr,icol,irow,icolm,irowm,m,nz,info
  character :: RANGE

  PUSH_SUB(hsub)

!------------------------
! Construct subspace Hamiltonian

  call timacc(18,1)

  hbuf(:,:)=ZERO
  sbuf(:,:)=ZERO

  if (fparala) then
    icurr=0
    do im=1,nbas
      hcol(:)=ZERO
      scol(:)=ZERO
      if (im.gt.npre) then
        if (fblas) then
          call X(gemv)('C',ngk_l,im,ONE,wfnbuf_d(:,:),ngk_l, &
            hpsi_d(:,im),1,ZERO,hcol(:),1)
          call X(gemv)('C',ngk_l,im,ONE,wfnbuf_d(:,:),ngk_l, &
            wfnbuf_d(:,im),1,ZERO,scol(:),1)
        else ! fblas
          do jm=1,im
            do ig=1,ngk_l
              hcol(jm)=hcol(jm)+MYCONJG(wfnbuf_d(ig,jm))* &
                hpsi_d(ig,im)
              scol(jm)=scol(jm)+MYCONJG(wfnbuf_d(ig,jm))* &
                wfnbuf_d(ig,im)
            enddo ! ig
          enddo ! jm
        endif ! fblas
#ifdef MPI
        dummyc(:)=hcol(:)
        call MPI_Allreduce(dummyc,hcol,im, &
          MPI_SCALAR,MPI_SUM,MPI_COMM_WORLD,mpierr)
        dummyc(:)=scol(:)
        call MPI_Allreduce(dummyc,scol,im, &
          MPI_SCALAR,MPI_SUM,MPI_COMM_WORLD,mpierr)
#endif
#ifdef CPLX
        impart_hsub = MAX(impart_hsub, abs(IMAG(hcol(im))))
        impart_ssub = MAX(impart_ssub, abs(IMAG(scol(im))))
        hcol(im)=CMPLX(dble(hcol(im)),0.0d0)
        scol(im)=CMPLX(dble(scol(im)),0.0d0)
#endif
      endif ! im.gt.npre
      icol=mod(int(((im-1)/scal%nbl)+TOL_Small),scal%npcol)
      ! jm up to nmat instead of nbas to correctly increment icurr
      do jm=1,nmat
        irow=mod(int(((jm-1)/scal%nbl)+TOL_Small),scal%nprow)
        if (irow.eq.scal%myprow.and.icol.eq.scal%mypcol) then
          icurr=icurr+1
          icolm=int((icurr-1)/scal%npr+TOL_Small)+1
          irowm=mod((icurr-1),scal%npr)+1
          if (im.le.npre) then
            hbuf(irowm,icolm)=hmat(irowm,icolm)
            sbuf(irowm,icolm)=smat(irowm,icolm)
          else ! im.le.npre
            hbuf(irowm,icolm)=hcol(jm)
            sbuf(irowm,icolm)=scol(jm)
          endif ! im.le.npre
        endif
      enddo ! jm
    enddo ! im
  else ! fparala
    do im=1,npre
      do jm=1,im
        hbuf(jm,im)=hmat(jm,im)
        sbuf(jm,im)=smat(jm,im)
      enddo ! jm
    enddo ! im
    if (fblas) then
      call X(gemm)('C','N',nbas,nbas-npre,ngk_l,ONE,wfnbuf_d(:,:), &
        ngk_l,hpsi_d(:,npre+1),ngk_l,ZERO,hbuf(:,npre+1),nmat)
      call X(gemm)('C','N',nbas,nbas-npre,ngk_l,ONE,wfnbuf_d(:,:), &
        ngk_l,wfnbuf_d(:,npre+1),ngk_l,ZERO,sbuf(:,npre+1),nmat)
    else ! fblas
      do im=npre+1,nbas
        do jm=1,im
          do ig=1,ngk_l
            hbuf(jm,im)=hbuf(jm,im)+ &
              MYCONJG(wfnbuf_d(ig,jm))*hpsi_d(ig,im)
            sbuf(jm,im)=sbuf(jm,im)+ &
              MYCONJG(wfnbuf_d(ig,jm))*wfnbuf_d(ig,im)
          enddo ! ig
        enddo ! jm
      enddo ! im
    endif ! fblas
#ifdef CPLX
    do im=npre+1,nbas
      impart_hsub = MAX(impart_hsub, abs(IMAG(hbuf(im,im))))
      impart_ssub = MAX(impart_ssub, abs(IMAG(sbuf(im,im))))
      hbuf(im,im)=CMPLX(dble(hbuf(im,im)),0.0d0)
      sbuf(im,im)=CMPLX(dble(sbuf(im,im)),0.0d0)
    enddo ! im
#endif
  endif ! fparala

  call timacc(18,2)

!------------------------
! Assemble subspace Hamiltonian

  call timacc(12,1)

  if (.not.fparala) then
#ifdef MPI
    dummym(:,:)=hbuf(:,:)
    call MPI_Allreduce(dummym(1,1),hbuf(1,1),nmat*nmat, &
      MPI_SCALAR,MPI_SUM,MPI_COMM_WORLD,mpierr)
    dummym(:,:)=sbuf(:,:)
    call MPI_Allreduce(dummym(1,1),sbuf(1,1),nmat*nmat, &
      MPI_SCALAR,MPI_SUM,MPI_COMM_WORLD,mpierr)
#endif
  endif ! .not.fparala

  call timacc(12,2)

!------------------------
! Store subspace Hamiltonian
! (because LAPACK/ScaLAPACK destroys input arrays)

  call timacc(18,1)

  hmat(:,:)=hbuf(:,:)
  smat(:,:)=sbuf(:,:)

  call timacc(18,2)

!------------------------
! Diagonalize subspace Hamiltonian

  call timacc(19,1)

  if (nvec.eq.nbas) then
    RANGE='A'
  else ! nvec.eq.nbas
    RANGE='I'
  endif ! nvec.eq.nbas
  if (fparala) then
#ifdef USESCALAPACK
#ifdef CPLX
    call PZHEGVX(1,'V',RANGE,'U',nbas,hbuf,1,1,desca,sbuf,1,1,desca, &
      0.0d0,0.0d0,1,nvec,abstol,m,nz,w,orfac,zmat,1,1,desca,work, &
      lwork,rwork,lrwork,iwork,liwork,ifail,iclustr,gap,info)
#else
    call PDSYGVX(1,'V',RANGE,'U',nbas,hbuf,1,1,desca,sbuf,1,1,desca, &
      0.0d0,0.0d0,1,nvec,abstol,m,nz,w,orfac,zmat,1,1,desca,work, &
      lwork,iwork,liwork,ifail,iclustr,gap,info)
#endif
    is_error = (info.ne.0.or.m.ne.nvec.or.nz.ne.nvec)
#else
    is_error = .true.
#endif
  else ! fparala
#ifdef CPLX
    call ZHEGVX(1,'V',RANGE,'U',nbas,hbuf,nmat,sbuf,nmat,0.0d0,0.0d0, &
      1,nvec,abstol,m,w,zmat,nmat,work,lwork,rwork,iwork,ifail,info)
#else
    call DSYGVX(1,'V',RANGE,'U',nbas,hbuf,nmat,sbuf,nmat,0.0d0,0.0d0, &
      1,nvec,abstol,m,w,zmat,nmat,work,lwork,iwork,ifail,info)
#endif
    is_error = (info.ne.0.or.m.ne.nvec)
  endif ! fparala

  call timacc(19,2)

!  if (is_error) then
!    call die('hsub: failed to diagonalize subspace Hamiltonian')
!  endif ! is_error

  if (peinf%inode.eq.0.and.is_error) write(0,555)

  POP_SUB(hsub)

  return

555 format(1x, &
  "WARNING: subspace diagonalization failed, resetting the basis functions")

end subroutine hsub

!===============================================================================

subroutine dsub(fparala,nvec,nmat,npr,npc,scal, &
  enbuf,hcol,scol,hmat,smat,zmat)

! This subroutine constructs the diagonal subspace Hamiltonian
! and diagonal eigenvectors. On entrance takes eigenvalues in
! enbuf(1:nvec). On exit returns hmat(1:npr,1:npc)/(1:nvec,1:nvec),
! smat(1:npr,1:npc)/(1:nvec,1:nvec), zmat(1:npr,1:npc)/(1:nvec,1:nvec)
! (if fparala = .true./.false.)

  logical, intent(in) :: fparala
  integer, intent(in) :: nvec,nmat,npr,npc
  type (scalapack), intent(in) :: scal
  real(DP), intent(in) :: enbuf(:) !< (nvec)
  SCALAR, intent(inout) :: hcol(:) !< (nmat)
  SCALAR, intent(inout) :: scol(:) !< (nmat)
  SCALAR, intent(out) :: hmat(:,:) !< (npr,npc)
  SCALAR, intent(out) :: smat(:,:) !< (npr,npc)
  SCALAR, intent(out) :: zmat(:,:) !< (npr,npc)

  integer :: im,jm,icurr,icol,irow,icolm,irowm

  PUSH_SUB(dsub)

!------------------------
! Construct subspace Hamiltonian

  call timacc(18,1)

  hmat(:,:)=ZERO
  smat(:,:)=ZERO
  zmat(:,:)=ZERO

  if (fparala) then
    icurr=0
    do im=1,nvec
      hcol(:)=ZERO
      scol(:)=ZERO
      hcol(im)=SCALARIFY(enbuf(im))
      scol(im)=ONE
      icol=mod(int(((im-1)/scal%nbl)+TOL_Small),scal%npcol)
      ! jm up to nmat instead of nbas to correctly increment icurr
      do jm=1,nmat
        irow=mod(int(((jm-1)/scal%nbl)+TOL_Small),scal%nprow)
        if (irow.eq.scal%myprow.and.icol.eq.scal%mypcol) then
          icurr=icurr+1
          icolm=int((icurr-1)/scal%npr+TOL_Small)+1
          irowm=mod((icurr-1),scal%npr)+1
          hmat(irowm,icolm)=hcol(jm)
          smat(irowm,icolm)=scol(jm)
          zmat(irowm,icolm)=scol(jm)
        endif
      enddo ! jm
    enddo ! im
  else ! fparala
    do im=1,nvec
      hmat(im,im)=SCALARIFY(enbuf(im))
      smat(im,im)=ONE
      zmat(im,im)=ONE
    enddo ! im
  endif ! fparala

  call timacc(18,2)

  POP_SUB(dsub)

  return

end subroutine dsub

!===============================================================================

subroutine rpsi(fparala,fblas,nvec,nbas,nmat,npr,npc,ngk_l, &
  scal,zmat,wfnbuf_d,wfnnew_d,scol,dummyc)

! This subroutine rotates wavefunctions. On entrance takes
! wavefunctions in wfnbuf_d(1:ngk_l,1:nbas) set in hdiag
! and eigenvectors in zmat(1:npr,1:npc)/(1:nbas,1:nvec)
! (if fparala = .true./.false.) computed in hsub. On exit
! returns rotated wavefunctions in wfnnew_d(1:ngk_l,1:nvec)

  logical, intent(in) :: fparala,fblas
  integer, intent(in) :: nvec,nbas,nmat,npr,npc,ngk_l
  type (scalapack), intent(in) :: scal
  SCALAR, intent(in) :: zmat(:,:) !< (npr,npc)
  SCALAR, intent(in) :: wfnbuf_d(:,:) !< (ngk_l,nmat)
  SCALAR, intent(out) :: wfnnew_d(:,:) !< (ngk_l,nvec)
  SCALAR, intent(inout) :: scol(:) !< (nmat)
  SCALAR, intent(inout) :: dummyc(:) !< (nmat)

  integer :: im,jm,ig,icurr,icol,irow,icolm,irowm

  PUSH_SUB(rpsi)

  wfnnew_d(:,:)=ZERO

  if (fparala) then
    icurr=0
    do im=1,nvec
      scol(:)=ZERO
      icol=mod(int(((im-1)/scal%nbl)+TOL_Small),scal%npcol)
      ! jm up to nmat instead of nbas to correctly increment icurr
      do jm=1,nmat
        irow=mod(int(((jm-1)/scal%nbl)+TOL_Small),scal%nprow)
        if (irow.eq.scal%myprow.and.icol.eq.scal%mypcol) then
          icurr=icurr+1
          icolm=int((icurr-1)/scal%npr+TOL_Small)+1
          irowm=mod((icurr-1),scal%npr)+1
          scol(jm)=zmat(irowm,icolm)
        endif
      enddo ! jm
#ifdef MPI
      dummyc(:)=scol(:)
      call MPI_Allreduce(dummyc,scol,nbas, &
        MPI_SCALAR,MPI_SUM,MPI_COMM_WORLD,mpierr)
#endif
      if (fblas) then
        call X(gemv)('N',ngk_l,nbas,ONE,wfnbuf_d(:,:),ngk_l, &
          scol(:),1,ZERO,wfnnew_d(:,im),1)
      else ! fblas
        do jm=1,nbas
          do ig=1,ngk_l
            wfnnew_d(ig,im)=wfnnew_d(ig,im)+ &
              wfnbuf_d(ig,jm)*scol(jm)
          enddo ! ig
        enddo ! jm
      endif ! fblas
    enddo ! im
  else ! fparala
    if (fblas) then
      call X(gemm)('N','N',ngk_l,nvec,nbas,ONE,wfnbuf_d(:,:), &
        ngk_l,zmat(:,:),nmat,ZERO,wfnnew_d(:,:),ngk_l)
    else ! fblas
      do im=1,nvec
        do jm=1,nbas
          do ig=1,ngk_l
            wfnnew_d(ig,im)=wfnnew_d(ig,im)+ &
              wfnbuf_d(ig,jm)*zmat(jm,im)
          enddo ! ig
        enddo ! jm
      enddo ! im
    endif ! fblas
  endif ! fparala

  POP_SUB(rpsi)

  return

end subroutine rpsi

!===============================================================================

subroutine npsi(fnorm,fblas,npre,nvec,nmat,ngk_l,wfnbuf_d,norm,ndum)

! This subroutine computes norms of wavefunctions and optionally
! normalizes wavefunctions. On entrance takes wavefunctions in
! wfnbuf_d(1:ngk_l,1:nvec) set in hdiag. On exit returns norms
! in norm(1:nvec), if fnorm = .true. normalizes wavefunctions
! in wfnbuf_d(1:ngk_l,1:nvec)

  logical, intent(in) :: fnorm,fblas
  integer, intent(in) :: npre,nvec,nmat,ngk_l
  SCALAR, intent(inout) :: wfnbuf_d(:,:) !< (ngk_l,nmat)
  real(DP), intent(out) :: norm(:) !< (nmat)
  real(DP), intent(inout) :: ndum(:) !< (nmat)

  integer :: im,ig
  SCALAR :: inorm

  PUSH_SUB(npsi)

  norm(:)=0.0d0

  if (fblas) then
    do im=npre+1,nvec
#ifdef CPLX
      norm(im)=dble(ZDOTC(ngk_l,wfnbuf_d(:,im),1,wfnbuf_d(:,im),1))
#else
      norm(im)=DDOT(ngk_l,wfnbuf_d(:,im),1,wfnbuf_d(:,im),1)
#endif
    enddo ! im
  else ! fblas
    do im=npre+1,nvec
      do ig=1,ngk_l
        norm(im)=norm(im)+MYCONJG(wfnbuf_d(ig,im))* &
          wfnbuf_d(ig,im)
      enddo ! ig
    enddo ! im
  endif ! fblas

#ifdef MPI
  ndum(:)=norm(:)
  call MPI_Allreduce(ndum,norm,nvec, &
    MPI_REAL_DP,MPI_SUM,MPI_COMM_WORLD,mpierr)
#endif

  do im=npre+1,nvec
    norm(im)=sqrt(norm(im))
  enddo ! im

  if (fnorm) then
    if (fblas) then
      do im=npre+1,nvec
        inorm=SCALARIFY(1.0d0/norm(im))
        call X(SCAL)(ngk_l,inorm,wfnbuf_d(:,im),1)
      enddo ! im
    else ! fblas
      do im=npre+1,nvec
        inorm=SCALARIFY(1.0d0/norm(im))
        do ig=1,ngk_l
          wfnbuf_d(ig,im)=wfnbuf_d(ig,im)*inorm
        enddo ! ig
      enddo ! im
    endif ! fblas
  endif ! fnorm

  POP_SUB(npsi)

  return

end subroutine npsi

!===============================================================================

subroutine calc_precond(h_gg, en, precond)

! This subroutine computes a preconditioner for a component of
! a residual vector. On entrance takes a diagonal part of the
! Hamiltonian in h_gg and an eigenvalue in en computed in hdiag.
! On exit returns a preconditioner in precond

  real(DP), intent(in) :: h_gg, en
  real(DP), intent(out) :: precond

  real(DP), parameter :: eps = 1.0d-4
  real(DP) :: del, denom

! do not use PUSH_SUB / POP_SUB as this subroutine is called
! too many times (for each k-point, spin, band, G-vector, iteration)

!  denom = h_gg - en
!  if (abs(denom) .lt. eps) denom = sign(eps, denom)

!  del = h_gg - en
!  denom = sqrt(1.0d0 + del**2)

  del = h_gg - en
  denom = 1.0d0 + del + sqrt(1.0d0 + (del - 1.0d0)**2)

  precond = 1.0d0 / denom

  return

end subroutine calc_precond

end module hdiag_m

!=============================================================================
!
! Utilities:
!
! (1) wfn_rho_vxc_info    Originally By DAS      Last Modified 12/12/2011 (DAS)
!
!     Prints the contents of the header of a WFN, RHO, or VXC file in
!     a human-readable format.
!
!==============================================================================

#include "f_defs.h"

program wfn_rho_vxc_info

  use global_m
  use wfn_rho_vxc_io_m
  use wfn_io_hdf5_m
#ifdef HDF5
  use hdf5
#endif
  implicit none

  type(mf_header_t) :: mf
  character*256 :: infile, usage, unit_string, length_label, energy_label
  integer :: nargs, ii, iat, ik, isym, is, ierr
  logical :: is_atomic, use_hdf5
  real(DP) :: length_factor, energy_factor

  usage = 'Usage: wfn_rho_vxc_info.x wfn[.h5] [optional units: eVA/au]'

! Get file names from command-line arguments

  nargs = iargc()

  if (nargs < 1 .or. nargs > 2) then
    call die(usage)
  endif

  call getarg(1, infile)

  if(nargs == 2) then
    call getarg(2, unit_string)
    if(trim(unit_string) == 'eVA') then
      is_atomic = .false.
    else if(trim(unit_string) == 'au') then
      is_atomic = .true.
    else
      call die("Unknown unit specifier " // trim(unit_string) // &
        ". Choose 'eVA' for eV/Angstrom, or 'au' for atomic units.")
    endif
  else
    is_atomic = .true.
  endif

  if(is_atomic) then
    length_label = "bohr"
    length_factor = 1
    energy_label = "Ry"
    energy_factor = 1
  else
    length_label = "Ang"
    length_factor = BOHR
    energy_label = "eV"
    energy_factor = RYD
  endif

  use_hdf5 = .false.
#ifdef HDF5
  use_hdf5 = index(infile, '.h5') == len(TRUNC(infile)) - 2
#endif
  if (.not.use_hdf5) then
    call open_file(unit=11, file=TRUNC(infile), form='unformatted', status='old')
    call read_mf_header(11, mf, warn=.false., dont_warn_kgrid=.true.)
    call close_file(11)
  else
#ifdef HDF5
    call h5open_f(ierr)
    call read_hdf5_mf_header(TRUNC(infile), mf)
    call h5close_f(ierr)
#endif
  endif

  write(6,'(a)') '====== GENERAL =====' 
  write(6,'(a,a)')  'Type: ', mf%sheader
  if(mf%iflavor == 1) then
    write(6,'(a)') 'Flavor: real'
  else
    write(6,'(a)') 'Flavor: complex'
  endif
  write(6,'(a,a)')  'Date created: ', mf%sdate
  write(6,'(a,a)')  'Time created: ', mf%stime
  write(6,'(a,i1)') 'Number of spins: ', mf%kp%nspin

  write(6,'(a)') '====== G-VECTORS =====' 
  write(6,'(a,i8)') 'Number of G-vectors: ', mf%gvec%ng
  write(6,'(a,f12.6,a)') 'Charge density cutoff: ', mf%gvec%ecutrho, ' Ry'
  write(6,'(a,3i8)') 'FFT grid: ', mf%gvec%FFTgrid(1:3)
  if(mf%sheader == 'WFN') then
    write(6,'(a,i8)') 'Max number of wfn G-vectors: ', mf%kp%ngkmax
    write(6,'(a,f12.6,a)') 'Wavefunction cutoff: ', mf%kp%ecutwfc, ' Ry'
  endif

  write(6,'(a)') '====== ATOMS =====' 
  write(6,'(a,i6)') 'Number of atoms: ', mf%crys%nat
  write(6,'(2a10,a30)') 'Index', 'Species', 'Coordinates (' // trim(length_label) // ')'
  do iat = 1, mf%crys%nat
    write(6,'(2i10,3f12.6)') iat, mf%crys%atyp(iat), mf%crys%apos(1:3, iat) * length_factor
  enddo

  write(6,'(a)') '====== LATTICE =====' 
  write(6,'(a,f12.6)') 'Cell volume (real space, ' // trim(length_label) // '^3): ', &
    mf%crys%celvol * length_factor**3
  write(6,'(a,f12.6)') 'Lattice constant (real space, ' // trim(length_label) // '): ', &
    mf%crys%alat  * length_factor
  write(6,'(a)') 'Lattice vectors (real space):'
  do ii = 1, 3
    write(6,'(10x,3f12.6)') mf%crys%avec(1:3, ii)
  enddo
  write(6,'(a)') 'Metric (real space, ' // trim(length_label) // '^2):'
  do ii = 1, 3
    write(6,'(10x,3f12.6)') mf%crys%adot(1:3, ii) * length_factor**2
  enddo

  write(6,'(a,f12.6)') 'Cell volume (reciprocal space, ' // trim(length_label) // '^-3): ', &
    mf%crys%recvol / length_factor**3
  write(6,'(a,f12.6)') 'Lattice constant (reciprocal space, ' // trim(length_label) // '^-1): ', &
    mf%crys%blat / length_factor
  write(6,'(a)') 'Lattice vectors (reciprocal space):'
  do ii = 1, 3
    write(6,'(10x,3f12.6)') mf%crys%bvec(1:3, ii)
  enddo
  write(6,'(a)') 'Metric (reciprocal space, ' // trim(length_label) // '^-2):'
  do ii = 1, 3
    write(6,'(10x,3f12.6)') mf%crys%bdot(1:3, ii) / length_factor**2
  enddo

  write(6,'(a)') '====== SYMMETRIES =====' 
  write(6,'(a,i2)') 'Number of symmetries: ', mf%syms%ntran
  if(mf%syms%cell_symmetry == 0) then
    write(6,'(a)') 'Symmetry type: cubic'
  else
    write(6,'(a)') 'Symmetry type: hexagonal'
  endif
  write(6,'(a7,a31,12x,a33)') 'Index', 'Rotation matrix', 'Fractional translations'
  do isym = 1, mf%syms%ntran
    write(6,'(i5,1x,a,2x,3(3i4,2x),3f12.6)') isym, ':', &
      mf%syms%mtrx(1:3, 1:3, isym), mf%syms%tnp(1:3, isym)
  enddo

  if(mf%sheader == 'WFN') then
    write(6,'(a)') '====== K-POINTS =====' 
    write(6,'(a,i8)') 'Number of k-points: ', mf%kp%nrk
    write(6,'(a,i8)') 'Number of bands: ', mf%kp%mnband
    write(6,'(a,3i4)') 'k-grid: ', mf%kp%kgrid(1:3)
    write(6,'(a,3f12.6)') 'k-shifts: ', mf%kp%shift(1:3)
    write(6,'(a)') '[ifmin = lowest occupied band, ifmax = highest occupied band, for each spin]'
    write(6,'(a8,a30,6x,a12,a22)',advance='no') 'Index', 'Coordinates (crystal)', 'Weight', 'Number of G-vectors'
    if(mf%kp%nspin == 1) then
      write(6,'(2a10)') 'ifmin', 'ifmax'
    else
      write(6,'(4a10)') 'ifmin1', 'ifmax1', 'ifmin2', 'ifmax2'
    endif
    do ik = 1, mf%kp%nrk
      write(6,'(i8,4f12.6,i22,4i10)') ik, mf%kp%rk(1:3, ik), mf%kp%w(ik), mf%kp%ngk(ik), &
        (mf%kp%ifmin(ik, is), mf%kp%ifmax(ik, is), is = 1, mf%kp%nspin)
    enddo

    write(6,'(a)') '====== ENERGIES (' // trim(energy_label) // ')/OCCUPATIONS ====='
    do is = 1, mf%kp%nspin
      if(mf%kp%nspin > 1) write(6,'(a,i2)') 'Spin ', is
      do ik = 1, mf%kp%nrk
        write(6,'(a,i6)') 'k-point ', ik
        write(6,'(9999999f14.6)') mf%kp%el(:, ik, is) * energy_factor
        write(6,'(9999999f14.6)') mf%kp%occ(:, ik, is)
      enddo
    enddo
  endif

  call dealloc_header_type(mf%sheader, mf%crys, mf%kp)

end program wfn_rho_vxc_info

!!! this file contains post-espresso-5.1 commits: r11037, r11038 !!!

!-------------------------------------------------------------------------------
!
!   pw2bgw.f90
!   $MPIRUN pw2bgw.x -in pw2bgw.in > pw2bgw.out
!   converts Quantum ESPRESSO output files to BerkeleyGW input files
!   based on espresso-4.3.2/PP/pw_export.f90
!   written by G. Samsonidze (April 2008)
!
!   The format of the input file for pw2bgw is described in the sample file pw2bgw.inp.
!
!   NOTE: you CANNOT use USPP, PAW, or spinors for BerkeleyGW!
!
!   real wavefunctions are constructed by applying the Gram-Schmidt process
!   based on paratecSGL/src/para/gwreal.f90
!
!   make sure to obtain the whole sphere of G-vectors from espresso
!   do not use "K_POINTS gamma" as it produces only half the sphere
!   use "K_POINTS { tpiba | automatic | crystal }" even for the
!   Gamma-point calculation
!
!-------------------------------------------------------------------------------
!
!   Compilation: use install.sh, or manually follow these steps:
!
!   copy pw2bgw.f90 and make.bgw to espresso-4.3.2/PP
!   add this line to the end of espresso-4.3.2/PP/Makefile: "include make.bgw"
!   make as follows : cd espresso-4.3.2 ; make pw ph ; cd PP ; make pw2bgw.x
!
!-------------------------------------------------------------------------------
!
!   subroutines
!
!   write_wfng  - generates complex wavefunctions in G-space (normalized to 1)
!   real_wfng   - constructs real wavefunctions by applying the Gram-Schmidt
!                 process (called from write_wfng)
!   write_rhog  - generates complex charge density in G-space
!                 (units of the number of electronic states per unit cell)
!   write_vxcg  - generates complex exchange-correlation potential in G-space
!                 (units of Rydberg) [only local part of Vxc]
!   write_vxc0  - prints complex exchange-correlation potential at G=0
!                 (units of eV) [only local part of Vxc]
!   write_vxc - calculates matrix elements of exchange-correlation potential
!                 in R-space [only local part of Vxc] or G-space [supports
!                 non-local Vxc]. In units of eV.
!   write_vnlg  - generates Kleinman-Bylander projectors in G-space
!                 (units of Rydberg)
!   check_inversion - checks whether real/complex version is appropriate
!   write_header - writes header for VXC and RHO files
!   k_pools - determines start and end k-points for a pool
!   set_spin - sets parameters associated with LSDA and spinor cases
!
!-------------------------------------------------------------------------------
!
!   Quantum ESPRESSO stores the wavefunctions in is-ik-ib-ig order
!   BerkeleyGW stores the wavefunctions in ik-ib-is-ig order
!   the outer loop is over is(QE)/ik(BGW) and the inner loop is over ig
!   ik = k-point index, is = spin index, ib = band index, ig = G-vector index
!
!   write_wfng reverts the order of is and ik using smap and kmap arrays,
!   distributes wavefunctions over processors by ig (either real case or
!   spin-polarized case), calls real_wfng that applies the Gram-Schmidt
!   process (real case), reverts the order of is and ib (spin-polarized
!   case), and writes wavefunctions to disk
!
!-------------------------------------------------------------------------------

#include "f_defs.h"

module pw2bgw_m

  implicit none

  private

  public :: &
    write_wfng, &
    real_wfng, &
    write_rhog, &
    write_vxcg, &
    write_vxc0, &
    write_vxc, &
    write_vnlg, &
    check_inversion, &
    check_dfpt_modes, &
    initialize_phonon, &
    initialize_electric, &
    dfpt_dwf

contains

!-------------------------------------------------------------------------------

SUBROUTINE write_wfng ( output_file_name, real_or_complex, &
  wfng_kgrid, wfng_nk1, wfng_nk2, wfng_nk3, wfng_dk1, wfng_dk2, &
  wfng_dk3, wfng_occupation, wfng_nvmin, wfng_nvmax )

  USE cell_base, ONLY : omega, alat, tpiba, tpiba2, at, bg, &
    ibrav, symm_type
  USE constants, ONLY : pi, tpi, eps6
  USE grid_dimensions, ONLY : nr1, nr2, nr3
  USE gvect, ONLY : ngm, ngm_g, ig_l2g, g, mill, ecutrho
  USE io_files, ONLY : iunwfc, nwordwfc
  USE io_global, ONLY : ionode, ionode_id
  USE ions_base, ONLY : nat, atm, ityp, tau
  USE kinds, ONLY : DP
  USE klist, ONLY : xk, wk, ngk, nks, nkstot
  USE lsda_mod, ONLY : nspin, isk
  USE mp, ONLY : mp_sum, mp_max, mp_get, mp_bcast, mp_barrier
  USE mp_global, ONLY : mpime, nproc, world_comm, me_pool, &
    root_pool, npool, nproc_pool, intra_pool_comm
  USE mp_wave, ONLY : mergewf
  USE start_k, ONLY : nk1, nk2, nk3, k1, k2, k3
  USE symm_base, ONLY : s, ftau, nsym
  USE wavefunctions_module, ONLY : evc
  USE wvfct, ONLY : npwx, nbnd, npw, et, wg, g2kin, ecutwfc
#ifdef __PARA
  USE parallel_include, ONLY : MPI_DOUBLE_COMPLEX
#endif

  IMPLICIT NONE

  character ( len = 256 ), intent (in) :: output_file_name
  integer, intent (in) :: real_or_complex
  logical, intent (in) :: wfng_kgrid
  integer, intent (in) :: wfng_nk1
  integer, intent (in) :: wfng_nk2
  integer, intent (in) :: wfng_nk3
  real (DP), intent (in) :: wfng_dk1
  real (DP), intent (in) :: wfng_dk2
  real (DP), intent (in) :: wfng_dk3
  logical, intent (in) :: wfng_occupation
  integer, intent (in) :: wfng_nvmin
  integer, intent (in) :: wfng_nvmax

  character :: cdate*9, ctime*9, sdate*32, stime*32, stitle*32
  logical :: proc_wf, bad_kgrid
  integer :: unit, i, j, k, cell_symmetry, nrecord
  integer :: id, ib, ik, iks, ike, is, ig, ierr
  integer :: nd, ntran, nb, nk_l, nk_g, ns, nst, nsf, ng_l, ng_g
  integer :: ngg, npw_g, npwx_g
  integer :: local_pw, ipsour, igwx, ngkdist_g, ngkdist_l, npw_g2
  real (DP) :: alat2, recvol, dr1, t1 ( 3 ), t2 ( 3 )
  real (DP) :: r1 ( 3, 3 ), r2 ( 3, 3 ), adot ( 3, 3 )
  real (DP) :: bdot ( 3, 3 ), translation ( 3, 48 )
  integer, allocatable :: kmap ( : )
  integer, allocatable :: smap ( : )
  integer, allocatable :: ifmin ( : )
  integer, allocatable :: ifmax ( : )
  integer, allocatable :: itmp ( : )
  integer, allocatable :: ngk_g ( : )
  integer, allocatable :: ipmask ( : )
  integer, allocatable :: igwk ( : )
  integer, allocatable :: igwf_l2g ( : )
  integer, allocatable :: g_g ( :, : )
  integer, allocatable :: igk_l2g ( :, : )
  real (DP), allocatable :: et_g ( :, : )
  real (DP), allocatable :: wg_g ( :, : )
  real (DP), allocatable :: energy ( :, : )
  complex (DP), allocatable :: wfng ( : )
  complex (DP), allocatable :: wfng_buf ( :, : )
  complex (DP), allocatable :: wfng_dist ( :, :, : )

  INTEGER, EXTERNAL :: atomic_number

  CALL check_inversion ( real_or_complex, nsym, s, nspin, .true., .true. )

  IF ( real_or_complex .EQ. 1 .OR. nspin .GT. 1 ) THEN
    proc_wf = .TRUE.
  ELSE
    proc_wf = .FALSE.
  ENDIF

  bad_kgrid = .FALSE.
  IF ( wfng_kgrid ) THEN
    IF ( wfng_nk1 .LE. 0 .OR. wfng_nk2 .LE. 0 .OR. wfng_nk3 .LE. 0 ) &
      bad_kgrid = .TRUE.
  ELSE
    IF ( nk1 .LE. 0 .OR. nk2 .LE. 0 .OR. nk3 .LE. 0 ) &
      bad_kgrid = .TRUE.
  ENDIF
  IF ( bad_kgrid .AND. ionode ) THEN
    WRITE ( 0, 101 )
  ENDIF

  CALL date_and_tim ( cdate, ctime )
  WRITE ( sdate, '(A2,"-",A3,"-",A4,21X)' ) cdate(1:2), cdate(3:5), cdate(6:9)
  WRITE ( stime, '(A8,24X)' ) ctime(1:8)
  IF ( real_or_complex .EQ. 1 ) THEN
    WRITE ( stitle, '("WFN-Real",24X)' )
  ELSE
    WRITE ( stitle, '("WFN-Complex",21X)' )
  ENDIF

  unit = 4
  nrecord = 1
  nd = 3

  nb = nbnd
  nk_l = nks
  nk_g = nkstot
  call set_spin(ns,nst,nsf,nspin)

  ng_l = ngm
  ng_g = ngm_g

  CALL k_pools(iks, ike)

  ALLOCATE ( kmap ( nk_g ) )
  ALLOCATE ( smap ( nk_g ) )

  DO i = 1, nk_g
    j = ( i - 1 ) / ns
    k = i - 1 - j * ns
    kmap ( i ) = j + k * ( nk_g / ns ) + 1
    smap ( i ) = k + 1
  ENDDO
  ierr = 0
  DO i = 1, nk_g
    ik = kmap ( i )
    is = smap ( i )
    IF ( ik .GE. iks .AND. ik .LE. ike .AND. is .NE. isk ( ik ) ) &
      ierr = ierr + 1
  ENDDO
  CALL mp_max ( ierr )
  IF ( ierr .GT. 0 ) &
    CALL errore ( 'write_wfng', 'smap', ierr )

  alat2 = alat ** 2
  recvol = 8.0D0 * pi**3 / omega

  DO i = 1, nd
    DO j = 1, nd
      adot ( j, i ) = 0.0D0
    ENDDO
  ENDDO
  DO i = 1, nd
    DO j = 1, nd
      DO k = 1, nd
        adot ( j, i ) = adot ( j, i ) + &
          at ( k, j ) * at ( k, i ) * alat2
      ENDDO
    ENDDO
  ENDDO

  DO i = 1, nd
    DO j = 1, nd
      bdot ( j, i ) = 0.0D0
    ENDDO
  ENDDO
  DO i = 1, nd
    DO j = 1, nd
      DO k = 1, nd
        bdot ( j, i ) = bdot ( j, i ) + &
          bg ( k, j ) * bg ( k, i ) * tpiba2
      ENDDO
    ENDDO
  ENDDO

  ierr = 0
  IF ( ibrav .EQ. 0 ) THEN
    IF ( TRIM ( symm_type ) .EQ. 'cubic' ) THEN
      cell_symmetry = 0
    ELSEIF ( TRIM ( symm_type ) .EQ. 'hexagonal' ) THEN
      cell_symmetry = 1
    ELSE
      ierr = 1
    ENDIF
  ELSEIF ( ibrav .GE. 1 .AND. ibrav .LE. 3 ) THEN
    cell_symmetry = 0
  ELSEIF ( ibrav .GE. 4 .AND. ibrav .LE. 5 ) THEN
    cell_symmetry = 1
  ELSEIF ( ibrav .GE. 6 .AND. ibrav .LE. 14 ) THEN
    cell_symmetry = 0
  ELSE
    ierr = 1
  ENDIF
  IF ( ierr .GT. 0 ) &
    CALL errore ( 'write_wfng', 'cell_symmetry', ierr )

  ntran = nsym
  DO i = 1, ntran
    DO j = 1, nd
      DO k = 1, nd
        r1 ( k, j ) = dble ( s ( k, j, i ) )
      ENDDO
    ENDDO
    CALL invmat ( 3, r1, r2, dr1 )
    t1 ( 1 ) = dble ( ftau ( 1, i ) ) / dble ( nr1 )
    t1 ( 2 ) = dble ( ftau ( 2, i ) ) / dble ( nr2 )
    t1 ( 3 ) = dble ( ftau ( 3, i ) ) / dble ( nr3 )
    DO j = 1, nd
      t2 ( j ) = 0.0D0
      DO k = 1, nd
        t2 ( j ) = t2 ( j ) + r2 ( k, j ) * t1 ( k )
      ENDDO
      IF ( t2 ( j ) .GE. eps6 + 0.5D0 ) &
        t2 ( j ) = t2 ( j ) - dble ( int ( t2 ( j ) + 0.5D0 ) )
      IF ( t2 ( j ) .LT. eps6 - 0.5D0 ) &
        t2 ( j ) = t2 ( j ) - dble ( int ( t2 ( j ) - 0.5D0 ) )
    ENDDO
    DO j = 1, nd
      translation ( j, i ) = t2 ( j ) * tpi
    ENDDO
  ENDDO

  ALLOCATE ( et_g ( nb, nk_g ) )

  DO ik = 1, nk_l
    DO ib = 1, nb
      et_g ( ib, ik ) = et ( ib, ik )
    ENDDO
  ENDDO
#ifdef __PARA
  CALL poolrecover ( et_g, nb, nk_g, nk_l )
  CALL mp_bcast ( et_g, ionode_id )
#endif

  ALLOCATE ( wg_g ( nb, nk_g ) )
  ALLOCATE ( ifmin ( nk_g ) )
  ALLOCATE ( ifmax ( nk_g ) )

  IF ( wfng_occupation ) THEN

    DO ik = 1, nk_g
      DO ib = 1, nb
        IF ( ib .GE. wfng_nvmin .AND. ib .LE. wfng_nvmax ) THEN
          wg_g ( ib, ik ) = 1.0D0
        ELSE
          wg_g ( ib, ik ) = 0.0D0
        ENDIF
      ENDDO
    ENDDO
    DO ik = 1, nk_g
      ifmin ( ik ) = wfng_nvmin
    ENDDO
    DO ik = 1, nk_g
      ifmax ( ik ) = wfng_nvmax
    ENDDO

  ELSE

    DO ik = 1, nk_l
      DO ib = 1, nb
        wg_g ( ib, ik ) = wg ( ib, ik ) 
        IF ( abs ( wk ( ik ) ) .GT. eps6 ) THEN
          wg_g ( ib, ik ) = wg_g ( ib, ik ) / wk ( ik ) 
        ENDIF
      ENDDO
    ENDDO
#ifdef __PARA
    CALL poolrecover ( wg_g, nb, nk_g, nk_l )
#endif
    DO ik = 1, nk_g
      ifmin ( ik ) = 0
    ENDDO
    DO ik = 1, nk_g
      ifmax ( ik ) = 0
    ENDDO
    DO ik = 1, nk_g
      DO ib = 1, nb
        IF ( wg_g( ib, ik ) .GT. 0.5D0 ) THEN
          IF ( ifmin ( ik ) .EQ. 0 ) ifmin ( ik ) = ib
          ifmax ( ik ) = ib
        ENDIF
      ENDDO
    ENDDO

  ENDIF

  ALLOCATE ( g_g ( nd, ng_g ) )

  DO ig = 1, ng_g
    DO id = 1, nd
      g_g ( id, ig ) = 0
    ENDDO
  ENDDO
  DO ig = 1, ng_l
    g_g ( 1, ig_l2g ( ig ) ) = mill ( 1, ig )
    g_g ( 2, ig_l2g ( ig ) ) = mill ( 2, ig )
    g_g ( 3, ig_l2g ( ig ) ) = mill ( 3, ig )
  ENDDO
  CALL mp_sum ( g_g, intra_pool_comm )

  ALLOCATE ( igk_l2g ( npwx, nk_l ) )

  ALLOCATE ( itmp ( npwx ) )
  DO ik = 1, nk_l
    DO i = 1, npwx
      itmp ( i ) = 0
    ENDDO
    npw = npwx
    CALL gk_sort ( xk ( 1, ik + iks - 1 ), ng_l, g, ecutwfc / tpiba2, &
      npw, itmp ( 1 ), g2kin )
    DO ig = 1, npw
      igk_l2g ( ig, ik ) = ig_l2g ( itmp ( ig ) )
    ENDDO
    DO ig = npw + 1, npwx
      igk_l2g ( ig, ik ) = 0
    ENDDO
    ngk ( ik ) = npw
  ENDDO
  DEALLOCATE ( itmp )

  ALLOCATE ( ngk_g ( nk_g ) )

  DO ik = 1, nk_g
    ngk_g ( ik ) = 0
  ENDDO
  DO ik = 1, nk_l
    ngk_g ( ik + iks - 1 ) = ngk ( ik )
  ENDDO
  CALL mp_sum ( ngk_g )

  npw_g = MAXVAL ( igk_l2g ( :, : ) )
  CALL mp_max ( npw_g )

  npwx_g = MAXVAL ( ngk_g ( : ) )

  CALL cryst_to_cart ( nk_g / ns, xk, at, - 1 )

  IF ( ionode ) THEN
    OPEN ( unit = unit, file = TRIM ( output_file_name ), &
      form = 'unformatted', status = 'replace' )
    WRITE ( unit ) stitle, sdate, stime
    WRITE ( unit ) nspin, ng_g, ntran, cell_symmetry, nat, ecutrho, &
      nk_g / ns, nb, npwx_g, ecutwfc
    IF ( wfng_kgrid ) THEN
      WRITE ( unit ) nr1, nr2, nr3, wfng_nk1, wfng_nk2, wfng_nk3, &
        wfng_dk1, wfng_dk2, wfng_dk3
    ELSE
      WRITE ( unit ) nr1, nr2, nr3, nk1, nk2, nk3, &
        0.5D0 * dble ( k1 ), 0.5D0 * dble ( k2 ), 0.5D0 * dble ( k3 )
    ENDIF
    WRITE ( unit ) omega, alat, ( ( at ( j, i ), j = 1, nd ), i = 1, nd ), &
      ( ( adot ( j, i ), j = 1, nd ), i = 1, nd )
    WRITE ( unit ) recvol, tpiba, ( ( bg ( j, i ), j = 1, nd ), i = 1, nd ), &
      ( ( bdot ( j, i ), j = 1, nd ), i = 1, nd )
    WRITE ( unit ) ( ( ( s ( k, j, i ), k = 1, nd ), j = 1, nd ), i = 1, ntran )
    WRITE ( unit ) ( ( translation ( j, i ), j = 1, nd ), i = 1, ntran )
    WRITE ( unit ) ( ( tau ( j, i ), j = 1, nd ), atomic_number ( atm ( ityp ( i ) ) ), i = 1, nat )
    WRITE ( unit ) ( ngk_g ( ik ), ik = 1, nk_g / ns )
    WRITE ( unit ) ( wk ( ik ) * dble ( nst ) / 2.0D0, ik = 1, nk_g / ns )
    WRITE ( unit ) ( ( xk ( id, ik ), id = 1, nd ), ik = 1, nk_g / ns )
    WRITE ( unit ) ( ifmin ( ik ), ik = 1, nk_g )
    WRITE ( unit ) ( ifmax ( ik ), ik = 1, nk_g )
    WRITE ( unit ) ( ( et_g ( ib, ik ), ib = 1, nb ), ik = 1, nk_g )
    WRITE ( unit ) ( ( wg_g ( ib, ik ), ib = 1, nb ), ik = 1, nk_g )
    WRITE ( unit ) nrecord
    WRITE ( unit ) ng_g
    WRITE ( unit ) ( ( g_g ( id, ig ), id = 1, nd ), ig = 1, ng_g )
  ENDIF

  CALL cryst_to_cart ( nk_g / ns, xk, bg, 1 )

  DEALLOCATE ( wg_g )
  DEALLOCATE ( ifmax )
  DEALLOCATE ( ifmin )

  ALLOCATE ( igwk ( npwx_g ) )

  IF ( proc_wf ) THEN
    IF ( nspin == 4) THEN
      IF ( MOD ( npwx_g, nproc ) .EQ. 0 ) THEN
        ngkdist_l = ( 2 * npwx_g ) / nproc
      ELSE
        ngkdist_l = ( 2 * npwx_g ) / nproc + 1
      ENDIF
    ELSE
      IF ( MOD ( npwx_g, nproc ) .EQ. 0 ) THEN
        ngkdist_l = npwx_g / nproc
      ELSE
        ngkdist_l = npwx_g / nproc + 1
      ENDIF
    ENDIF
    ngkdist_g = ngkdist_l * nproc
    IF ( real_or_complex .EQ. 1 ) &
    ALLOCATE ( energy ( nb, ns ) )
    ALLOCATE ( wfng_buf ( ngkdist_g, ns ) )
    ALLOCATE ( wfng_dist ( ngkdist_l, nb, ns ) )
  ENDIF

  DO i = 1, nk_g

    ik = kmap ( i )
    is = smap ( i )

    IF ( real_or_complex .EQ. 1 ) THEN
      DO ib = 1, nb
        energy ( ib, is ) = et_g ( ib, i )
      ENDDO
    ENDIF

    DO j = 1, npwx_g
      igwk ( j ) = 0
    ENDDO
    ALLOCATE ( itmp ( npw_g ) )
    DO j = 1, npw_g
      itmp ( j ) = 0
    ENDDO
    IF ( ik .GE. iks .AND. ik .LE. ike ) THEN
      DO ig = 1, ngk ( ik - iks + 1 )
        itmp ( igk_l2g ( ig, ik - iks + 1 ) ) = igk_l2g ( ig, ik - iks + 1 )
      ENDDO
    ENDIF
    CALL mp_sum ( itmp )
    ngg = 0
    DO ig = 1, npw_g
      IF ( itmp ( ig ) .EQ. ig ) THEN
        ngg = ngg + 1
        igwk ( ngg ) = ig
      ENDIF
    ENDDO
    DEALLOCATE ( itmp )

    IF ( ionode ) THEN
      IF ( is .EQ. 1 ) THEN
        WRITE ( unit ) nrecord
        WRITE ( unit ) ngk_g ( ik )
        WRITE ( unit ) ( ( g_g ( id, igwk ( ig ) ), id = 1, nd ), &
          ig = 1, ngk_g ( ik ) )
      ENDIF
    ENDIF

    local_pw = 0
    IF ( ik .GE. iks .AND. ik .LE. ike ) THEN
      CALL davcio ( evc, nwordwfc, iunwfc, ik - iks + 1, - 1 )
      local_pw = ngk ( ik - iks + 1 )
    ENDIF

    ALLOCATE ( igwf_l2g ( local_pw ) )

    DO ig = 1, local_pw
      igwf_l2g ( ig ) = 0
    ENDDO
    DO ig = 1, local_pw
      ngg = igk_l2g ( ig, ik - iks + 1 )
      DO j = 1, ngk_g ( ik )
        IF ( ngg .EQ. igwk ( j ) ) THEN
          igwf_l2g ( ig ) = j
          EXIT
        ENDIF
      ENDDO
    ENDDO

    ALLOCATE ( ipmask ( nproc ) )
    DO j = 1, nproc
      ipmask ( j ) = 0
    ENDDO
    ipsour = ionode_id
    IF ( npool .GT. 1 ) THEN
      IF ( ( ik .GE. iks ) .AND. ( ik .LE. ike ) ) THEN
        IF ( me_pool .EQ. root_pool ) ipmask ( mpime + 1 ) = 1
      ENDIF
      CALL mp_sum ( ipmask )
      DO j = 1, nproc
        IF ( ipmask ( j ) .EQ. 1 ) ipsour = j - 1
      ENDDO
    ENDIF
    DEALLOCATE ( ipmask )

    igwx = 0
    ierr = 0
    IF ( ik .GE. iks .AND. ik .LE. ike ) &
      igwx = MAXVAL ( igwf_l2g ( 1 : local_pw ) )
    CALL mp_max ( igwx, intra_pool_comm )
    IF ( ipsour .NE. ionode_id ) &
      CALL mp_get ( igwx, igwx, mpime, ionode_id, ipsour, 1 )
    ierr = 0
    IF ( ik .GE. iks .AND. ik .LE. ike .AND. igwx .NE. ngk_g ( ik ) ) &
      ierr = 1
    CALL mp_max ( ierr )
    IF ( ierr .GT. 0 ) &
      CALL errore ( 'write_wfng', 'igwx ngk_g', ierr )

    IF (nspin == 4) THEN
      igwx = 2 * igwx
    ENDIF
    ALLOCATE ( wfng ( MAX ( 1, igwx ) ) )

    IF (nspin == 4) THEN
      npw_g2 = MAXVAL ( ig_l2g ( 1: local_pw) )
      CALL mp_max (npw_g2)
    ENDIF

    DO ib = 1, nb

      DO j = 1, igwx
        wfng ( j ) = ( 0.0D0, 0.0D0 )
      ENDDO
      IF ( npool .GT. 1 ) THEN
        IF ( ( ik .GE. iks ) .AND. ( ik .LE. ike ) ) THEN
          CALL mergewf ( evc ( :, ib ), wfng, local_pw, igwf_l2g, &
            me_pool, nproc_pool, root_pool, intra_pool_comm )
        ENDIF
        IF ( ipsour .NE. ionode_id ) THEN
          CALL mp_get ( wfng, wfng, mpime, ionode_id, ipsour, ib, &
            world_comm )
        ENDIF
      ELSE
        CALL mergewf ( evc ( :, ib ), wfng, local_pw, igwf_l2g, &
          mpime, nproc, ionode_id, world_comm )

        IF (nspin == 4) THEN
!          write(1000+mpime,*) '2: npw_g2, local_pw, igwx =', npw_g2, local_pw, igwx
          CALL mp_barrier ( )
          CALL mergewf ( evc ( npwx_g + 1 : npwx_g + local_pw, ib), & 
            wfng (local_pw + 1 : 2 * local_pw ), &
           local_pw, igwf_l2g, mpime, nproc, ionode_id, world_comm )
        ENDIF
      ENDIF

      IF ( proc_wf ) THEN
        DO ig = 1, igwx
          wfng_buf ( ig, is ) = wfng ( ig )
        ENDDO
        DO ig = igwx + 1, ngkdist_g
          wfng_buf ( ig, is ) = ( 0.0D0, 0.0D0 )
        ENDDO
#ifdef __PARA
        CALL mp_barrier ( )
        CALL MPI_Scatter ( wfng_buf ( :, is ), ngkdist_l, MPI_DOUBLE_COMPLEX, &
        wfng_dist ( :, ib, is ), ngkdist_l, MPI_DOUBLE_COMPLEX, &
        ionode_id, world_comm, ierr )
        IF ( ierr .GT. 0 ) &
          CALL errore ( 'write_wfng', 'mpi_scatter', ierr )
#else
        DO ig = 1, ngkdist_g
          wfng_dist ( ig, ib, is ) = wfng_buf ( ig, is )
        ENDDO
#endif
      ELSE
        IF ( ionode ) THEN
          WRITE ( unit ) nrecord
          WRITE ( unit ) ngk_g ( ik )
          WRITE ( unit ) ( wfng ( ig ), ig = 1, igwx )
        ENDIF
      ENDIF

    ENDDO

    DEALLOCATE ( wfng )
    DEALLOCATE ( igwf_l2g )

    IF ( proc_wf .AND. is .EQ. ns ) THEN
      IF ( real_or_complex .EQ. 1 ) THEN
        CALL start_clock ( 'real_wfng' )
        CALL real_wfng ( ik, ngkdist_l, nb, ns, energy, wfng_dist )
        CALL stop_clock ( 'real_wfng' )
      ENDIF
      DO ib = 1, nb
        DO is = 1, ns
#ifdef __PARA
          CALL mp_barrier ( )
          CALL MPI_Gather ( wfng_dist ( :, ib, is ), ngkdist_l, &
          MPI_DOUBLE_COMPLEX, wfng_buf ( :, is ), ngkdist_l, &
          MPI_DOUBLE_COMPLEX, ionode_id, world_comm, ierr )
          IF ( ierr .GT. 0 ) &
            CALL errore ( 'write_wfng', 'mpi_gather', ierr )
#else
          DO ig = 1, ngkdist_g
            wfng_buf ( ig, is ) = wfng_dist ( ig, ib, is )
          ENDDO
#endif
        ENDDO
        IF ( ionode ) THEN
          WRITE ( unit ) nrecord
          WRITE ( unit ) ngk_g ( ik )
          IF ( real_or_complex .EQ. 1 ) THEN
            WRITE ( unit ) ( ( dble ( wfng_buf ( ig, is ) ), &
              ig = 1, igwx ), is = 1, ns )
          ELSE
            WRITE ( unit ) ( ( wfng_buf ( ig, is ), &
              ig = 1, igwx ), is = 1, ns )
          ENDIF
        ENDIF
      ENDDO
    ENDIF

  ENDDO

  DEALLOCATE ( igwk )
  DEALLOCATE ( ngk_g )
  DEALLOCATE ( igk_l2g )
  DEALLOCATE ( et_g )

  IF ( proc_wf ) THEN
    IF ( real_or_complex .EQ. 1 ) &
    DEALLOCATE ( energy )
    DEALLOCATE ( wfng_buf )
    DEALLOCATE ( wfng_dist )
  ENDIF

  IF ( ionode ) THEN
    CLOSE ( unit = unit, status = 'keep' )
  ENDIF

  DEALLOCATE ( g_g )
  DEALLOCATE ( smap )
  DEALLOCATE ( kmap )

  CALL mp_barrier ( )

  RETURN

101 FORMAT ( /, 5X, "WARNING: kgrid is set to zero in the wavefunction file.", &
             /, 14X, "The resulting file will only be usable as the fine grid in inteqp.", / )

END SUBROUTINE write_wfng

!-------------------------------------------------------------------------------

SUBROUTINE real_wfng ( ik, ngkdist_l, nb, ns, energy, wfng_dist )

  USE constants, ONLY : eps6
  USE kinds, ONLY : DP
  USE io_global, ONLY : ionode
  USE mp, ONLY : mp_sum

  IMPLICIT NONE

  integer, intent (in) :: ik, ngkdist_l, nb, ns
  real (DP), intent (in) :: energy ( nb, ns )
  complex (DP), intent (inout) :: wfng_dist ( ngkdist_l, nb, ns )

  real (DP), PARAMETER :: eps2 = 1.0D-2
  real (DP), PARAMETER :: eps5 = 1.0D-5

  character :: tmpstr*80
  integer :: i, j, k, is, ib, jb, ig, inum, deg, mdeg, inc
  integer :: dimension_span, reduced_span, ierr
  real (DP) :: x
  integer, allocatable :: imap ( :, : )
  integer, allocatable :: inums ( : )
  integer, allocatable :: inull ( : )
  integer, allocatable :: null_map ( :, : )
  real (DP), allocatable :: psi ( :, : )
  real (DP), allocatable :: phi ( :, : )
  real (DP), allocatable :: vec ( : )
  complex (DP), allocatable :: wfc ( : )

  mdeg = 1
  DO is = 1, ns
    DO ib = 1, nb - 1
      deg = 1
      DO jb = ib + 1, nb
        IF ( abs ( energy ( ib, is ) - energy ( jb, is ) ) &
          .LT. eps5 * dble ( jb - ib + 1 ) ) deg = deg + 1
      ENDDO
      IF ( deg .GT. mdeg ) mdeg = deg
    ENDDO
  ENDDO
  mdeg = mdeg * 2

  ALLOCATE ( imap ( nb, ns ) )
  ALLOCATE ( inums ( ns ) )
  ALLOCATE ( inull ( nb ) )
  ALLOCATE ( null_map ( mdeg, nb ) )

  DO is = 1, ns
    inum = 1
    DO ib = 1, nb
      IF ( ib .EQ. nb ) THEN
        imap ( inum, is ) = ib
        inum = inum + 1
      ELSEIF ( abs ( energy ( ib, is ) - &
        energy ( ib + 1, is ) ) .GT. eps5 ) THEN
        imap ( inum, is ) = ib
        inum = inum + 1
      ENDIF
    ENDDO
    inum = inum - 1
    inums ( is ) = inum
  ENDDO

  ALLOCATE ( wfc ( ngkdist_l ) )
  ALLOCATE ( psi ( ngkdist_l, mdeg ) )
  ALLOCATE ( phi ( ngkdist_l, mdeg ) )
  ALLOCATE ( vec ( ngkdist_l ) )

  DO is = 1, ns
    inc = 1
    inum = inums ( is )
    DO i = 1, inum
      inull ( i ) = 1
      DO ib = inc, imap ( i, is )
        DO ig = 1, ngkdist_l
          wfc ( ig ) = wfng_dist ( ig, ib, is )
        ENDDO
        x = 0.0D0
        DO ig = 1, ngkdist_l
          x = x + dble ( wfc ( ig ) ) **2
        ENDDO
        CALL mp_sum ( x )
        IF ( x .LT. eps2 ) null_map ( inull ( i ), i ) = 0
        IF ( x .GT. eps2 ) null_map ( inull ( i ), i ) = 1
        inull ( i ) = inull ( i ) + 1
        x = 0.0D0
        DO ig = 1, ngkdist_l
          x = x + aimag ( wfc ( ig ) ) **2
        ENDDO
        CALL mp_sum ( x )
        IF ( x .LT. eps2 ) null_map ( inull ( i ), i ) = 0
        IF ( x .GT. eps2 ) null_map ( inull ( i ), i ) = 1
        inull ( i ) = inull ( i ) + 1
      ENDDO
      inull ( i ) = inull ( i ) - 1
      inc = imap ( i, is ) + 1
    ENDDO
    inc = 1
    ib = 1
    DO i = 1, inum
      k = 1
      DO j = 1, 2 * ( imap ( i, is ) - inc ) + 1, 2
        IF ( null_map ( j, i ) .EQ. 1 .OR. &
          null_map ( j + 1, i ) .EQ. 1 ) THEN
          DO ig = 1, ngkdist_l
            wfc ( ig ) = wfng_dist ( ig, ib, is )
          ENDDO
          IF ( null_map ( j, i ) .EQ. 1 ) THEN
            DO ig = 1, ngkdist_l
              phi ( ig, k ) = dble ( wfc ( ig ) )
            ENDDO
            k = k + 1
          ENDIF
          IF ( null_map ( j + 1, i ) .EQ. 1 ) THEN
            DO ig = 1, ngkdist_l
              phi ( ig, k ) = aimag ( wfc ( ig ) )
            ENDDO
            k = k + 1
          ENDIF
          ib = ib + 1
        ENDIF
      ENDDO
      dimension_span = k - 1
      IF ( dimension_span .EQ. 0 ) THEN
        ierr = 201
        WRITE ( tmpstr, 201 ) ik, is, inc
        CALL errore ( 'real_wfng', tmpstr, ierr )
      ENDIF
      DO j = 1, dimension_span
        x = 0.0D0
        DO ig = 1, ngkdist_l
          x = x + phi ( ig, j ) **2
        ENDDO
        CALL mp_sum ( x )
        x = sqrt ( x )
        DO ig = 1, ngkdist_l
          phi ( ig, j ) = phi ( ig, j ) / x
        ENDDO
      ENDDO
!
! the Gram-Schmidt process begins
!
      reduced_span = 1
      DO ig = 1, ngkdist_l
        psi ( ig, 1 ) = phi ( ig, 1 )
      ENDDO
      DO j = 1, dimension_span - 1
        DO ig = 1, ngkdist_l
          vec ( ig ) = phi ( ig, j + 1 )
        ENDDO
        DO k = 1, reduced_span
          x = 0.0D0
          DO ig = 1, ngkdist_l
            x = x + phi ( ig, j + 1 ) * psi ( ig, k )
          ENDDO
          CALL mp_sum ( x )
          DO ig = 1, ngkdist_l
            vec ( ig ) = vec ( ig ) - psi ( ig, k ) * x
          ENDDO
        ENDDO
        x = 0.0D0
        DO ig = 1, ngkdist_l
          x = x + vec ( ig ) **2
        ENDDO
        CALL mp_sum ( x )
        x = sqrt ( x )
        IF ( x .GT. eps6 ) THEN
          reduced_span = reduced_span + 1
          DO ig = 1, ngkdist_l
            psi ( ig, reduced_span ) = vec ( ig ) / x
          ENDDO
        ENDIF
      ENDDO
!
! the Gram-Schmidt process ends
!
      IF ( reduced_span .LT. imap ( i, is ) - inc + 1 ) THEN
        ierr = 202
        WRITE ( tmpstr, 202 ) ik, is, inc
        CALL errore ( 'real_wfng', tmpstr, ierr )
      ENDIF
      DO ib = inc, imap ( i, is )
        DO ig = 1, ngkdist_l
          wfng_dist ( ig, ib, is ) = &
          CMPLX ( psi ( ig, ib - inc + 1 ), 0.0D0 )
        ENDDO
      ENDDO
      inc = imap ( i, is ) + 1
    ENDDO
  ENDDO

  DEALLOCATE ( vec )
  DEALLOCATE ( phi )
  DEALLOCATE ( psi )
  DEALLOCATE ( wfc )
  DEALLOCATE ( null_map )
  DEALLOCATE ( inull )
  DEALLOCATE ( inums )
  DEALLOCATE ( imap )

  RETURN

201 FORMAT("failed Gram-Schmidt dimension span for kpoint =",i6," spin =",i2," band =",i6)
202 FORMAT("failed Gram-Schmidt reduced span for kpoint =",i6," spin =",i2," band =",i6)

END SUBROUTINE real_wfng

!-------------------------------------------------------------------------------

SUBROUTINE write_rhog ( output_file_name, real_or_complex )

  USE cell_base, ONLY : omega
  USE gvect, ONLY : ngm, ngm_g, ig_l2g, mill, ecutrho
  USE io_global, ONLY : ionode
  USE ions_base, ONLY : nat, atm, ityp, tau 
  USE kinds, ONLY : DP
  USE lsda_mod, ONLY : nspin
  USE mp, ONLY : mp_sum
  USE mp_global, ONLY : intra_pool_comm
  USE scf, ONLY : rho
  USE symm_base, ONLY : s, ftau, nsym

  IMPLICIT NONE

  character ( len = 256 ), intent (in) :: output_file_name
  integer, intent (in) :: real_or_complex

  character :: stitle*32
  integer :: unit, is, ig
  integer :: ns, nst, nsf, ng_l, ng_g
  integer :: nrecord
  complex (DP), allocatable :: rhog_g ( :, : )

  INTEGER, EXTERNAL :: atomic_number

  CALL check_inversion ( real_or_complex, nsym, s, nspin, .true., .true. )

  IF ( real_or_complex .EQ. 1 ) THEN
    WRITE ( stitle, '("RHO-Real",24X)' )
  ELSE
    WRITE ( stitle, '("RHO-Complex",21X)' )
  ENDIF

  unit = 4
  nrecord = 1

  ng_l = ngm
  ng_g = ngm_g
  call set_spin(ns,nst,nsf,nspin)

  ALLOCATE ( rhog_g ( ng_g, ns ) )

  DO is = 1, ns
    DO ig = 1, ng_g
      rhog_g ( ig, is ) = ( 0.0D0, 0.0D0 )
    ENDDO
  ENDDO

  DO is = 1, ns
    DO ig = 1, ng_l
      rhog_g ( ig_l2g ( ig ), is ) = rho%of_g ( ig, is )
    ENDDO
  ENDDO

  CALL mp_sum ( rhog_g, intra_pool_comm )

  DO is = 1, ns
    DO ig = 1, ng_g
      rhog_g ( ig, is ) = rhog_g ( ig, is ) * CMPLX ( omega, 0.0D0 )
    ENDDO
  ENDDO

  IF ( ionode ) OPEN ( unit = unit, file = TRIM ( output_file_name ), &
      form = 'unformatted', status = 'replace' )

  CALL write_header(unit, stitle)

  IF ( ionode ) THEN
    WRITE ( unit ) nrecord
    WRITE ( unit ) ng_g
    IF ( real_or_complex .EQ. 1 ) THEN
      WRITE ( unit ) ( ( dble ( rhog_g ( ig, is ) ), &
        ig = 1, ng_g ), is = 1, ns )
    ELSE
      WRITE ( unit ) ( ( rhog_g ( ig, is ), &
        ig = 1, ng_g ), is = 1, ns )
    ENDIF
    CLOSE ( unit = unit, status = 'keep' )
  ENDIF

  DEALLOCATE ( rhog_g )

  RETURN

END SUBROUTINE write_rhog

!-------------------------------------------------------------------------------

SUBROUTINE write_vxcg ( output_file_name, real_or_complex, &
  vxc_zero_rho_core, input_dft, exx_flag )

  USE cell_base, ONLY : omega
  USE ener, ONLY : etxc, vtxc
  USE fft_base, ONLY : dfftp
  USE fft_interfaces, ONLY : fwfft
  USE funct, ONLY : enforce_input_dft
  USE grid_dimensions, ONLY : nrxx
  USE gvect, ONLY : ngm, ngm_g, ig_l2g, nl, mill, ecutrho
  USE io_global, ONLY : ionode
  USE ions_base, ONLY : nat, atm, ityp, tau 
  USE kinds, ONLY : DP
  USE lsda_mod, ONLY : nspin
  USE mp, ONLY : mp_sum
  USE mp_global, ONLY : intra_pool_comm
  USE scf, ONLY : rho, rho_core, rhog_core
  USE symm_base, ONLY : s, ftau, nsym
  USE wavefunctions_module, ONLY : psic
#ifdef EXX
  USE funct, ONLY : start_exx, stop_exx
#endif

  IMPLICIT NONE

  character ( len = 256 ), intent (in) :: output_file_name
  integer, intent (in) :: real_or_complex
  logical, intent (in) :: vxc_zero_rho_core
  character ( len = 20 ), intent (in) :: input_dft
  logical, intent (in) :: exx_flag

  character :: stitle*32
  integer :: unit, is, ir, ig
  integer :: ns, nst, nsf, nr, ng_l, ng_g
  integer :: nrecord
  real (DP), allocatable :: vxcr_g ( :, : )
  complex (DP), allocatable :: vxcg_g ( :, : )

  INTEGER, EXTERNAL :: atomic_number

  CALL check_inversion ( real_or_complex, nsym, s, nspin, .true., .true. )

  IF ( real_or_complex .EQ. 1 ) THEN
    WRITE ( stitle, '("VXC-Real",24X)' )
  ELSE
    WRITE ( stitle, '("VXC-Complex",21X)' )
  ENDIF

  unit = 4
  nrecord = 1

  call set_spin(ns,nst,nsf,nspin)
  nr = nrxx
  ng_l = ngm
  ng_g = ngm_g

  ALLOCATE ( vxcr_g ( nr, nsf ) )
  ALLOCATE ( vxcg_g ( ng_g, nsf ) )

  DO is = 1, nsf
    DO ig = 1, ng_g
      vxcg_g ( ig, is ) = ( 0.0D0, 0.0D0 )
    ENDDO
  ENDDO

  CALL enforce_input_dft ( input_dft )
#ifdef EXX
  IF ( exx_flag ) CALL start_exx ( )
#endif
  vxcr_g ( :, : ) = 0.0D0
  IF ( vxc_zero_rho_core ) THEN
    rho_core ( : ) = 0.0D0
    rhog_core ( : ) = ( 0.0D0, 0.0D0 )
  ENDIF
  CALL v_xc ( rho, rho_core, rhog_core, etxc, vtxc, vxcr_g )
#ifdef EXX
  IF ( exx_flag ) CALL stop_exx ( )
#endif
  DO is = 1, nsf
    DO ir = 1, nr
      psic ( ir ) = CMPLX ( vxcr_g ( ir, is ), 0.0D0 )
    ENDDO
    CALL fwfft ( 'Dense', psic, dfftp )
    DO ig = 1, ng_l
      vxcg_g ( ig_l2g ( ig ), is ) = psic ( nl ( ig ) )
    ENDDO
  ENDDO

  CALL mp_sum ( vxcg_g, intra_pool_comm )

  IF ( ionode ) OPEN ( unit = unit, file = TRIM ( output_file_name ), &
      form = 'unformatted', status = 'replace' )

  CALL write_header(unit, stitle)

  IF ( ionode ) THEN
    WRITE ( unit ) nrecord
    WRITE ( unit ) ng_g
    IF ( real_or_complex .EQ. 1 ) THEN
      WRITE ( unit ) ( ( dble ( vxcg_g ( ig, is ) ), &
        ig = 1, ng_g ), is = 1, nsf )
    ELSE
      WRITE ( unit ) ( ( vxcg_g ( ig, is ), ig = 1, ng_g ), is = 1, nsf )
    ENDIF
    CLOSE ( unit = unit, status = 'keep' )
  ENDIF

  DEALLOCATE ( vxcg_g )
  DEALLOCATE ( vxcr_g )

  RETURN

END SUBROUTINE write_vxcg

!-------------------------------------------------------------------------------

SUBROUTINE write_vxc0 ( output_file_name, vxc_zero_rho_core, input_dft, &
  exx_flag )

  USE constants, ONLY : RYTOEV
  USE ener, ONLY : etxc, vtxc
  USE fft_base, ONLY : dfftp
  USE fft_interfaces, ONLY : fwfft
  USE funct, ONLY : enforce_input_dft
  USE grid_dimensions, ONLY : nrxx
  USE gvect, ONLY : ngm, nl, mill
  USE io_global, ONLY : ionode
  USE kinds, ONLY : DP
  USE lsda_mod, ONLY : nspin
  USE mp, ONLY : mp_sum
  USE mp_global, ONLY : intra_pool_comm
  USE scf, ONLY : rho, rho_core, rhog_core
  USE wavefunctions_module, ONLY : psic
#ifdef EXX
  USE funct, ONLY : start_exx, stop_exx
#endif

  IMPLICIT NONE

  character ( len = 256 ), intent (in) :: output_file_name
  logical, intent (in) :: vxc_zero_rho_core
  character ( len = 20 ), intent (in) :: input_dft
  logical, intent (in) :: exx_flag

  integer :: unit
  integer :: is, ir, ig
  integer :: ns, nst, nsf, nr, ng_l
  real (DP), allocatable :: vxcr_g ( :, : )
  complex (DP), allocatable :: vxc0_g ( : )

  unit = 4

  nr = nrxx
  ng_l = ngm
  call set_spin(ns,nst,nsf,nspin)

  ALLOCATE ( vxcr_g ( nr, nsf ) )
  ALLOCATE ( vxc0_g ( nsf ) )

  DO is = 1, nsf
    vxc0_g ( is ) = ( 0.0D0, 0.0D0 )
  ENDDO

  CALL enforce_input_dft ( input_dft )
#ifdef EXX
  IF ( exx_flag ) CALL start_exx ( )
#endif
  vxcr_g ( :, : ) = 0.0D0
  IF ( vxc_zero_rho_core ) THEN
    rho_core ( : ) = 0.0D0
    rhog_core ( : ) = ( 0.0D0, 0.0D0 )
  ENDIF
  CALL v_xc ( rho, rho_core, rhog_core, etxc, vtxc, vxcr_g )
#ifdef EXX
  IF ( exx_flag ) CALL stop_exx ( )
#endif
  DO is = 1, nsf
    DO ir = 1, nr
      psic ( ir ) = CMPLX ( vxcr_g ( ir, is ), 0.0D0 )
    ENDDO
    CALL fwfft ( 'Dense', psic, dfftp )
    DO ig = 1, ng_l
      IF ( mill ( 1, ig ) .EQ. 0 .AND. mill ( 2, ig ) .EQ. 0 .AND. &
        mill ( 3, ig ) .EQ. 0 ) vxc0_g ( is ) = psic ( nl ( ig ) )
    ENDDO
  ENDDO

  CALL mp_sum ( vxc0_g, intra_pool_comm )

  DO is = 1, nsf
    vxc0_g ( is ) = vxc0_g ( is ) * CMPLX ( RYTOEV, 0.0D0 )
  ENDDO

  IF ( ionode ) THEN
    OPEN (unit = unit, file = TRIM (output_file_name), &
      form = 'formatted', status = 'replace')
    WRITE ( unit, 101 )
    DO is = 1, nsf
      WRITE ( unit, 102 ) is, vxc0_g ( is )
    ENDDO
    WRITE ( unit, 103 )
    CLOSE (unit = unit, status = 'keep')
  ENDIF

  DEALLOCATE ( vxcr_g )
  DEALLOCATE ( vxc0_g )

  RETURN

101 FORMAT ( /, 5X, "--------------------------------------------", &
             /, 5X, "spin    Re Vxc(G=0) [eV]    Im Vxc(G=0) [eV]", &
             /, 5X, "--------------------------------------------" )
102 FORMAT ( 5X, I1, 3X, 2F20.15 )
103 FORMAT ( 5X, "--------------------------------------------", / )

END SUBROUTINE write_vxc0

!-------------------------------------------------------------------------------

SUBROUTINE write_vxc (vxc_integral, output_file_name, diag_nmin, diag_nmax, &
  offdiag_nmin, offdiag_nmax, vxc_zero_rho_core, input_dft, exx_flag, &
  dfpt_type, dfpt_mode)

  USE becmod, ONLY : bec_type, allocate_bec_type, deallocate_bec_type
  USE constants, ONLY : rytoev, eps6
  USE control_ph, ONLY : nbnd_occ ! initialize!
  USE cell_base, ONLY : tpiba2, at, bg
  USE ener, ONLY : etxc, vtxc
  USE eqv, ONLY : dpsi, dvpsi
  USE fft_base, ONLY : dfftp
  USE fft_interfaces, ONLY : fwfft, invfft
  USE funct, ONLY : enforce_input_dft
  USE grid_dimensions, ONLY : nr1x, nr2x, nr3x, nrxx
  USE gvect, ONLY : ngm, g, nl
  USE io_files, ONLY : nwordwfc, iunwfc
  USE io_global, ONLY : ionode
  USE kinds, ONLY : DP
  USE klist, ONLY : xk, nkstot
  USE lsda_mod, ONLY : nspin, isk
  USE modes, ONLY : u
  USE mp, ONLY : mp_sum
  USE mp_global, ONLY : intra_pool_comm, inter_pool_comm
  USE phus, ONLY : becp1
  USE units_ph, ONLY : iudvscf, lrdrho
  USE scf, ONLY : rho, rho_core, rhog_core
  USE uspp, ONLY : nkb
  USE wavefunctions_module, ONLY : evc, psic
  USE wvfct, ONLY : npwx, npw, nbnd, igk, g2kin, ecutwfc
#ifdef EXX
  USE funct, ONLY : start_exx, stop_exx, exx_is_active
  USE exx, ONLY : vexx
#endif

  IMPLICIT NONE

  character (len = 1), intent (in) :: vxc_integral ! 'g' = G-space, 'r' = R-space
  character (len = 256), intent (in) :: output_file_name
  integer, intent (inout) :: diag_nmin
  integer, intent (inout) :: diag_nmax
  integer, intent (inout) :: offdiag_nmin
  integer, intent (inout) :: offdiag_nmax
  logical, intent (in) :: vxc_zero_rho_core
  character (len = 20), intent (in) :: input_dft
  logical, intent (in) :: exx_flag
  integer, intent (in) :: dfpt_type ! 0 = none, 1 = ionic, 2 = electric
  integer, intent (in) :: dfpt_mode

  integer :: ik, is, ib, ig, ir, unit, iks, ike, ndiag, noffdiag, ib2
  integer :: ns, nst, nsf
  real(DP) :: dummyr, maxvaldvscf
  complex (DP) :: dummy
  complex (DP), allocatable :: mtxeld (:, :)
  complex (DP), allocatable :: mtxelo (:, :, :)
  real (DP), allocatable :: vxcr (:, :)
  complex (DP), allocatable :: dvscf (:, :)
  complex (DP), allocatable :: psic2 (:)
  complex (DP), allocatable :: hpsi (:)
  type(bec_type) :: becp2 ! we do not care, but need to pass this

  IF ( vxc_integral /= 'r' .AND. vxc_integral /= 'g' ) &
    CALL errore ( 'write_vxc', 'vxc_integral', 1 )

  if(diag_nmin > diag_nmax) then
    call errore ( 'write_vxc', 'diag_nmin > diag_nmax', diag_nmin )
  endif
  IF (diag_nmin .LT. 1) diag_nmin = 1
  IF (diag_nmax .GT. nbnd) then
    if(ionode) write(0,'(a,i6)') 'WARNING: resetting diag_nmax to max number of bands', nbnd
    diag_nmax = nbnd
  ENDIF

  if(offdiag_nmin > offdiag_nmax) then
    call errore ( 'write_vxc', 'offdiag_nmin > offdiag_nmax', offdiag_nmin )
  endif
  ndiag = MAX (diag_nmax - diag_nmin + 1, 0)
  IF (offdiag_nmin .LT. 1) offdiag_nmin = 1
  IF (offdiag_nmax .GT. nbnd)  then
    if(ionode) write(0,'(a,i6)') 'WARNING: resetting offdiag_nmax to max number of bands', nbnd
    offdiag_nmax = nbnd
  ENDIF

  noffdiag = MAX (offdiag_nmax - offdiag_nmin + 1, 0)
  IF (ndiag .EQ. 0 .AND. noffdiag .EQ. 0) RETURN

  unit = 4

  call set_spin(ns, nst, nsf, nspin)
  CALL k_pools(iks, ike)

  IF (ndiag .GT. 0) THEN
    ALLOCATE (mtxeld (ndiag, nkstot))
    mtxeld (:, :) = (0.0D0, 0.0D0)
  ENDIF
  IF (noffdiag .GT. 0) THEN
    ALLOCATE (mtxelo (noffdiag, noffdiag, nkstot))
    mtxelo (:, :, :) = (0.0D0, 0.0D0)
  ENDIF

  ALLOCATE (vxcr (nrxx, nsf))
  IF (noffdiag .GT. 0) ALLOCATE (psic2 (nrxx))
  if(vxc_integral == 'g') ALLOCATE (hpsi (nrxx))

  if(dfpt_type == 0) then

    CALL enforce_input_dft (input_dft)
#ifdef EXX
    IF (exx_flag) CALL start_exx ()
#endif

    vxcr (:, :) = 0.0D0
    IF ( vxc_zero_rho_core ) THEN
      rho_core ( : ) = 0.0D0
      rhog_core ( : ) = ( 0.0D0, 0.0D0 )
    ENDIF
    CALL v_xc (rho, rho_core, rhog_core, etxc, vtxc, vxcr)
  
  else

    IF(dfpt_type == 1) WRITE(6,'(a,i6)') 'Calculating ionic matrix elements for mode ', dfpt_mode
    IF(dfpt_type == 2) WRITE(6,'(a,i6)') 'Calculating electric matrix elements for polarization ', dfpt_mode
    IF(vxc_integral == 'r') WRITE(6,'(a)') 'Only the Hartree and XC parts of the perturbation are being included.'

    ! iudvscf, lrdrho set in check_dfpt_modes
    ALLOCATE (dvscf (nrxx, nsf))
    CALL davcio_drho(dvscf, lrdrho, iudvscf, dfpt_mode, - 1 )
    write(6,'(a)') 'Read dvscf from disk.'

    ! dvscf is real at q=0
    if(any(aimag(dvscf(:,:)) > eps6)) then
      write(6,'(a)') 'This mode has imaginary dvscf (max = ', maxval(abs(aimag(dvscf(:,:)))), ') so not calculating.'
      RETURN
    endif
    vxcr(:,:) = dble(dvscf(:,:))

    maxvaldvscf = maxval(abs(dvscf(:,:)))
    DEALLOCATE(dvscf)

    if(maxvaldvscf < 1e-9) then
      WRITE(6,'(a)') 'This mode has dvscf = 0 (max abs = ', maxvaldvscf, ') so not calculating.'
      RETURN
    endif

    if(dfpt_type == 2) call allocate_bec_type (nkb, nbnd, becp2)
  endif

  DO ik = iks, ike
    CALL gk_sort (xk (1, ik - iks + 1), ngm, g, ecutwfc &
      / tpiba2, npw, igk, g2kin)
    CALL davcio (evc, nwordwfc, iunwfc, ik - iks + 1, -1)

    if(vxc_integral == 'g') then
      if(dfpt_type == 1) then
        ! initialize dvpsi: bare ionic pert applied to all the wfns 'evc'
        ! gradient of local and non-local part of pseudopotential
        dvpsi(:,:) = (0d0, 0d0)
        call dvqpsi_us(ik, u (1, dfpt_mode), .false.)
      else if(dfpt_type == 2) then
        ! for electric field, from PH/dvpsi_e. check initialization of this stuff!
        ! calculate the commutator [H,x_ipol]  psi > and store it in dvpsi
        ! dpsi used as workspace
        dpsi(:,:) = (0d0, 0d0)
        dvpsi(:,:) = (0d0, 0d0)
        call commutator_Hx_psi (ik, nbnd_occ(ik), becp1(ik), becp2, dfpt_mode, dvpsi, dpsi )
      endif
    endif

    IF (ndiag .GT. 0) THEN
      DO ib = diag_nmin, diag_nmax
        psic (:) = (0.0D0, 0.0D0)
        DO ig = 1, npw
          psic (nl (igk (ig))) = evc (ig, ib)
        ENDDO
        CALL invfft ('Dense', psic, dfftp)

        if(vxc_integral == 'g') then
          DO ir = 1, nrxx
            psic (ir) = psic (ir) * vxcr (ir, isk (ik))
          ENDDO
          CALL fwfft ('Dense', psic, dfftp)

          if(dfpt_type == 1) then
            ! add bare part of ionic perturbation
            DO ig = 1, npw
              psic (nl (igk(ig))) = psic (nl (igk(ig))) + dvpsi(ig, ib)
            ENDDO
          endif

          hpsi (:) = (0.0D0, 0.0D0)
          DO ig = 1, npw
            hpsi (ig) = psic (nl (igk (ig)))
          ENDDO
          psic (:) = (0.0D0, 0.0D0)
          DO ig = 1, npw
            psic (ig) = evc (ig, ib)
          ENDDO
#ifdef EXX
          IF (exx_is_active () .and. dfpt_type == 0) &
            CALL vexx (npwx, npw, 1, psic, hpsi)
#endif
          dummy = (0.0D0, 0.0D0)
          DO ig = 1, npw
            dummy = dummy + conjg (psic (ig)) * hpsi (ig)
          ENDDO
          dummy = dummy * rytoev
          CALL mp_sum (dummy, intra_pool_comm)
          mtxeld (ib - diag_nmin + 1, ik) = dummy
        else
          dummyr = 0.0D0
          DO ir = 1, nrxx
            dummyr = dummyr + vxcr (ir, isk (ik)) &
              * (dble (psic (ir)) **2 + aimag (psic (ir)) **2)
          ENDDO
          dummyr = dummyr * rytoev / dble (nr1x * nr2x * nr3x)
          CALL mp_sum (dummyr, intra_pool_comm)
          mtxeld (ib - diag_nmin + 1, ik) = dummyr
        endif
      ENDDO
    ENDIF
    IF (noffdiag .GT. 0) THEN
      DO ib = offdiag_nmin, offdiag_nmax
        psic (:) = (0.0D0, 0.0D0)
        DO ig = 1, npw
          psic (nl (igk (ig))) = evc (ig, ib)
        ENDDO
        CALL invfft ('Dense', psic, dfftp)

        if(vxc_integral == 'g') then
          DO ir = 1, nrxx
            psic (ir) = psic (ir) * vxcr (ir, isk (ik))
          ENDDO
          CALL fwfft ('Dense', psic, dfftp)

          if(dfpt_type == 1) then
            ! add bare part of ionic perturbation
            DO ig = 1, npw
              psic (nl (igk(ig))) = psic (nl (igk(ig))) + dvpsi(ig, ib)
            ENDDO
          endif

          hpsi (:) = (0.0D0, 0.0D0)
          DO ig = 1, npw
            hpsi (ig) = psic (nl (igk (ig)))
          ENDDO
          psic (:) = (0.0D0, 0.0D0)
          DO ig = 1, npw
            psic (ig) = evc (ig, ib)
          ENDDO
#ifdef EXX
          IF (exx_is_active () .and. dfpt_type == 0) &
            CALL vexx (npwx, npw, 1, psic, hpsi)
#endif
        endif
        DO ib2 = offdiag_nmin, offdiag_nmax
          psic2 (:) = (0.0D0, 0.0D0)
          dummy = (0.0D0, 0.0D0)
          if(vxc_integral == 'g') then
            DO ig = 1, npw
              psic2 (ig) = evc (ig, ib2)
            ENDDO
            DO ig = 1, npw
              dummy = dummy + conjg (psic2 (ig)) * hpsi (ig)
            ENDDO
          else
            DO ig = 1, npw
              psic2 (nl (igk (ig))) = evc (ig, ib2)
            ENDDO
            CALL invfft ('Dense', psic2, dfftp)
            DO ir = 1, nrxx
              dummy = dummy + CMPLX (vxcr (ir, isk (ik)), 0.0D0) &
                * conjg (psic2 (ir)) * psic (ir)
            ENDDO
            dummy = dummy / dble (nr1x * nr2x * nr3x)
          endif
          dummy = dummy * rytoev
          CALL mp_sum (dummy, intra_pool_comm)
          mtxelo (ib2 - offdiag_nmin + 1, ib - offdiag_nmin + 1, ik) = dummy
        ENDDO
      ENDDO
    ENDIF
  ENDDO

  ! from dvpsi_e
  if(dfpt_type == 2 .and. nkb > 0) call deallocate_bec_type (becp2)

#ifdef EXX
  IF (exx_flag) CALL stop_exx ()
#endif

  DEALLOCATE (vxcr)
  IF (noffdiag .GT. 0) DEALLOCATE (psic2)
  if(vxc_integral == 'g') DEALLOCATE (hpsi)

  IF (ndiag .GT. 0) CALL mp_sum (mtxeld, inter_pool_comm)
  IF (noffdiag .GT. 0) CALL mp_sum (mtxelo, inter_pool_comm)

  CALL cryst_to_cart (nkstot, xk, at, -1)

  IF (ionode) THEN
    OPEN (unit = unit, file = TRIM (output_file_name), &
      form = 'formatted', status = 'replace')
    DO ik = 1, nkstot / ns
      WRITE (unit, 101) xk(:, ik), ns * ndiag, &
        ns * noffdiag **2
      DO is = 1, ns
        IF (ndiag .GT. 0) THEN
          DO ib = diag_nmin, diag_nmax
            WRITE (unit, 102) is, ib, mtxeld &
              (ib - diag_nmin + 1, ik + (is - 1) * nkstot / ns)
          ENDDO
        ENDIF
        IF (noffdiag .GT. 0) THEN
          DO ib = offdiag_nmin, offdiag_nmax
            DO ib2 = offdiag_nmin, offdiag_nmax
              WRITE (unit, 103) is, ib2, ib, mtxelo &
                (ib2 - offdiag_nmin + 1, ib - offdiag_nmin + 1, &
                ik + (is - 1) * nkstot / ns)
            ENDDO
          ENDDO
        ENDIF
      ENDDO
    ENDDO
    CLOSE (unit = unit, status = 'keep')
  ENDIF

  CALL cryst_to_cart (nkstot, xk, bg, 1)

  IF (ndiag .GT. 0) DEALLOCATE (mtxeld)
  IF (noffdiag .GT. 0) DEALLOCATE (mtxelo)

  RETURN

  101 FORMAT (3F13.9, 2I8)
  102 FORMAT (2I8, 2F15.9)
  103 FORMAT (3I8, 2F15.9)

END SUBROUTINE write_vxc

!-------------------------------------------------------------------------------

SUBROUTINE write_vnlg (output_file_name, wfng_kgrid, wfng_nk1, wfng_nk2, &
  wfng_nk3, wfng_dk1, wfng_dk2, wfng_dk3)

  USE cell_base, ONLY : omega, alat, tpiba, tpiba2, at, bg, &
    ibrav, symm_type
  USE constants, ONLY : pi, tpi, eps6
  USE grid_dimensions, ONLY : nr1, nr2, nr3
  USE gvect, ONLY : ngm, ngm_g, ig_l2g, g, mill, ecutrho
  USE io_global, ONLY : ionode, ionode_id
  USE ions_base, ONLY : nat, atm, ityp, tau, nsp
  USE kinds, ONLY : DP
  USE klist, ONLY : xk, wk, ngk, nks, nkstot
  USE lsda_mod, ONLY : nspin, isk
  USE mp, ONLY : mp_sum, mp_max, mp_get, mp_barrier
  USE mp_global, ONLY : mpime, nproc, world_comm, me_pool, &
    root_pool, npool, nproc_pool, intra_pool_comm
  USE mp_wave, ONLY : mergewf
  USE start_k, ONLY : nk1, nk2, nk3, k1, k2, k3
  USE symm_base, ONLY : s, ftau, nsym
  USE uspp, ONLY : nkb, vkb, deeq
  USE uspp_param, ONLY : nhm, nh
  USE wvfct, ONLY : npwx, npw, g2kin, ecutwfc

  IMPLICIT NONE

  character (len = 256), intent (in) :: output_file_name
  logical, intent (in) :: wfng_kgrid
  integer, intent (in) :: wfng_nk1
  integer, intent (in) :: wfng_nk2
  integer, intent (in) :: wfng_nk3
  real (DP), intent (in) :: wfng_dk1
  real (DP), intent (in) :: wfng_dk2
  real (DP), intent (in) :: wfng_dk3

  character :: cdate*9, ctime*9, sdate*32, stime*32, stitle*32
  integer :: i, j, k, ierr, ik, is, ig, ikb, iat, isp, ih, jh, &
    unit, iks, ike, npw_g, npwx_g, ngg, ipsour, &
    igwx, local_pw, id, nd, ntran, cell_symmetry, nrecord
  real (DP) :: alat2, recvol, dr1, t1 ( 3 ), t2 ( 3 )
  real (DP) :: r1 ( 3, 3 ), r2 ( 3, 3 ), adot ( 3, 3 )
  real (DP) :: bdot ( 3, 3 ), translation ( 3, 48 )
  integer, allocatable :: kmap ( : )
  integer, allocatable :: smap ( : )
  integer, allocatable :: gvec ( :, : )
  integer, allocatable :: ngk_g ( : )
  integer, allocatable :: igk_l2g ( :, : )
  integer, allocatable :: itmp ( : )
  integer, allocatable :: igwk ( : )
  integer, allocatable :: igwf_l2g ( : )
  integer, allocatable :: ipmask ( : )
  complex (DP), allocatable :: vkb_g ( : )

  INTEGER, EXTERNAL :: atomic_number

  IF ( nkb == 0 ) RETURN

  CALL date_and_tim ( cdate, ctime )
  WRITE ( sdate, '(A2,"-",A3,"-",A4,21X)' ) cdate(1:2), cdate(3:5), cdate(6:9)
  WRITE ( stime, '(A8,24X)' ) ctime(1:8)
  WRITE ( stitle, '("VKB-Complex",21X)' )

  unit = 4
  nrecord = 1
  nd = 3

  CALL k_pools(iks, ike)

  ierr = 0
  IF ( ibrav .EQ. 0 ) THEN
    IF ( TRIM ( symm_type ) .EQ. 'cubic' ) THEN
      cell_symmetry = 0
    ELSEIF ( TRIM ( symm_type ) .EQ. 'hexagonal' ) THEN
      cell_symmetry = 1
    ELSE
      ierr = 1
    ENDIF
  ELSEIF ( ibrav .GE. 1 .AND. ibrav .LE. 3 ) THEN
    cell_symmetry = 0
  ELSEIF ( ibrav .GE. 4 .AND. ibrav .LE. 5 ) THEN
    cell_symmetry = 1
  ELSEIF ( ibrav .GE. 6 .AND. ibrav .LE. 14 ) THEN
    cell_symmetry = 0
  ELSE
    ierr = 1
  ENDIF
  IF ( ierr .GT. 0 ) &
    CALL errore ( 'write_vnlg', 'cell_symmetry', ierr )

  ntran = nsym
  DO i = 1, ntran
    DO j = 1, nd
      DO k = 1, nd
        r1 ( k, j ) = dble ( s ( k, j, i ) )
      ENDDO
    ENDDO
    CALL invmat ( 3, r1, r2, dr1 )
    t1 ( 1 ) = dble ( ftau ( 1, i ) ) / dble ( nr1 )
    t1 ( 2 ) = dble ( ftau ( 2, i ) ) / dble ( nr2 )
    t1 ( 3 ) = dble ( ftau ( 3, i ) ) / dble ( nr3 )
    DO j = 1, nd
      t2 ( j ) = 0.0D0
      DO k = 1, nd
        t2 ( j ) = t2 ( j ) + r2 ( k, j ) * t1 ( k )
      ENDDO
      IF ( t2 ( j ) .GE. eps6 + 0.5D0 ) &
        t2 ( j ) = t2 ( j ) - dble ( int ( t2 ( j ) + 0.5D0 ) )
      IF ( t2 ( j ) .LT. eps6 - 0.5D0 ) &
        t2 ( j ) = t2 ( j ) - dble ( int ( t2 ( j ) - 0.5D0 ) )
    ENDDO
    DO j = 1, nd
      translation ( j, i ) = t2 ( j ) * tpi
    ENDDO
  ENDDO

  alat2 = alat ** 2
  recvol = 8.0D0 * pi**3 / omega

  DO i = 1, nd
    DO j = 1, nd
      adot ( j, i ) = 0.0D0
    ENDDO
  ENDDO
  DO i = 1, nd
    DO j = 1, nd
      DO k = 1, nd
        adot ( j, i ) = adot ( j, i ) + &
          at ( k, j ) * at ( k, i ) * alat2
      ENDDO
    ENDDO
  ENDDO

  DO i = 1, nd
    DO j = 1, nd
      bdot ( j, i ) = 0.0D0
    ENDDO
  ENDDO
  DO i = 1, nd
    DO j = 1, nd
      DO k = 1, nd
        bdot ( j, i ) = bdot ( j, i ) + &
          bg ( k, j ) * bg ( k, i ) * tpiba2
      ENDDO
    ENDDO
  ENDDO

  ALLOCATE ( kmap ( nkstot ) )
  ALLOCATE ( smap ( nkstot ) )

  DO i = 1, nkstot
    j = ( i - 1 ) / nspin
    k = i - 1 - j * nspin
    kmap ( i ) = j + k * ( nkstot / nspin ) + 1
    smap ( i ) = k + 1
  ENDDO
  ierr = 0
  DO i = 1, nkstot
    ik = kmap ( i )
    is = smap ( i )
    IF ( ik .GE. iks .AND. ik .LE. ike .AND. is .NE. isk ( ik ) ) &
      ierr = ierr + 1
  ENDDO
  CALL mp_max ( ierr )
  IF ( ierr .GT. 0 ) &
    CALL errore ( 'write_vnlg', 'smap', ierr )

  ALLOCATE ( gvec ( 3, ngm_g ) )
  gvec = 0
  DO ig = 1, ngm
    gvec ( 1, ig_l2g ( ig ) ) = mill ( 1, ig )
    gvec ( 2, ig_l2g ( ig ) ) = mill ( 2, ig )
    gvec ( 3, ig_l2g ( ig ) ) = mill ( 3, ig )
  ENDDO
  CALL mp_sum ( gvec, intra_pool_comm )

  ALLOCATE ( ngk_g ( nkstot ) )
  ALLOCATE ( igk_l2g ( npwx, nks ) )
  ngk_g = 0
  igk_l2g = 0
  ALLOCATE ( itmp ( npwx ) )
  DO ik = 1, nks
    itmp = 0
    npw = npwx
    CALL gk_sort ( xk ( 1, ik + iks - 1 ), ngm, g, ecutwfc / tpiba2, &
      npw, itmp ( 1 ), g2kin )
    DO ig = 1, npw
      igk_l2g ( ig, ik ) = ig_l2g ( itmp ( ig ) )
    ENDDO
    ngk ( ik ) = npw
  ENDDO
  DEALLOCATE ( itmp )
  DO ik = 1, nks
    ngk_g ( ik + iks - 1 ) = ngk ( ik )
  ENDDO
  CALL mp_sum ( ngk_g )
  npw_g = MAXVAL ( igk_l2g ( :, : ) )
  CALL mp_max ( npw_g )
  npwx_g = MAXVAL ( ngk_g ( : ) )

  CALL cryst_to_cart (nkstot, xk, at, -1)

  IF (ionode) THEN
    OPEN (unit = unit, file = TRIM (output_file_name), &
      form = 'unformatted', status = 'replace')
    WRITE ( unit ) stitle, sdate, stime
    WRITE ( unit ) nspin, ngm_g, ntran, cell_symmetry, nat, ecutrho, &
      nkstot / nspin, nsp, nkb, nhm, npwx_g, ecutwfc
    IF ( wfng_kgrid ) THEN
      WRITE ( unit ) nr1, nr2, nr3, wfng_nk1, wfng_nk2, wfng_nk3, &
        wfng_dk1, wfng_dk2, wfng_dk3
    ELSE
      WRITE ( unit ) nr1, nr2, nr3, nk1, nk2, nk3, &
        0.5D0 * dble ( k1 ), 0.5D0 * dble ( k2 ), 0.5D0 * dble ( k3 )
    ENDIF
    WRITE ( unit ) omega, alat, ( ( at ( j, i ), j = 1, nd ), i = 1, nd ), &
      ( ( adot ( j, i ), j = 1, nd ), i = 1, nd )
    WRITE ( unit ) recvol, tpiba, ( ( bg ( j, i ), j = 1, nd ), i = 1, nd ), &
      ( ( bdot ( j, i ), j = 1, nd ), i = 1, nd )
    WRITE ( unit ) ( ( ( s ( k, j, i ), k = 1, nd ), j = 1, nd ), i = 1, ntran )
    WRITE ( unit ) ( ( translation ( j, i ), j = 1, nd ), i = 1, ntran )
    WRITE ( unit ) ( ( tau ( j, i ), j = 1, nd ), atomic_number ( atm ( ityp ( i ) ) ), i = 1, nat )
    WRITE ( unit ) ( ngk_g ( ik ), ik = 1, nkstot / nspin )
    WRITE ( unit ) ( wk ( ik ) * dble ( nspin ) / 2.0D0, ik = 1, nkstot / nspin )
    WRITE ( unit ) ( ( xk ( id, ik ), id = 1, nd ), ik = 1, nkstot / nspin )
    WRITE ( unit ) ( ityp ( iat ), iat = 1, nat )
    WRITE ( unit ) ( nh ( isp ), isp = 1, nsp )
    WRITE ( unit ) ( ( ( ( deeq ( jh, ih, iat, is ), &
      jh = 1, nhm ), ih = 1, nhm ), iat = 1, nat ), is = 1, nspin )
    WRITE ( unit ) nrecord
    WRITE ( unit ) ngm_g
    WRITE ( unit ) ( ( gvec ( id, ig ), id = 1, nd ), ig = 1, ngm_g )
  ENDIF

  CALL cryst_to_cart (nkstot, xk, bg, 1)

  ALLOCATE ( igwk ( npwx_g ) )

  DO i = 1, nkstot

    ik = kmap ( i )
    is = smap ( i )

    igwk = 0

    ALLOCATE ( itmp ( npw_g ) )
    itmp = 0
    IF ( ik .GE. iks .AND. ik .LE. ike ) THEN
      DO ig = 1, ngk ( ik - iks + 1 )
        itmp ( igk_l2g ( ig, ik - iks + 1 ) ) = igk_l2g ( ig, ik - iks + 1 )
      ENDDO
    ENDIF
    CALL mp_sum ( itmp )
    ngg = 0
    DO ig = 1, npw_g
      IF ( itmp ( ig ) .EQ. ig ) THEN
        ngg = ngg + 1
        igwk ( ngg ) = ig
      ENDIF
    ENDDO
    DEALLOCATE ( itmp )

    IF ( ionode ) THEN
      IF ( is .EQ. 1 ) THEN
        WRITE ( unit ) nrecord
        WRITE ( unit ) ngk_g ( ik )
        WRITE ( unit ) ( ( gvec ( j, igwk ( ig ) ), j = 1, 3 ), &
          ig = 1, ngk_g ( ik ) )
      ENDIF
    ENDIF

    local_pw = 0
    IF ( ik .GE. iks .AND. ik .LE. ike ) THEN
      ALLOCATE ( itmp ( npwx ) )
      npw = npwx
      CALL gk_sort ( xk ( 1, ik ), ngm, g, ecutwfc / tpiba2, &
        npw, itmp ( 1 ), g2kin )
      CALL init_us_2 ( npw, itmp, xk ( 1, ik ), vkb )
      local_pw = ngk ( ik - iks + 1 )
      DEALLOCATE ( itmp )
    ENDIF

    ALLOCATE ( igwf_l2g ( local_pw ) )
    igwf_l2g = 0
    DO ig = 1, local_pw
      ngg = igk_l2g ( ig, ik - iks + 1 )
      DO j = 1, ngk_g ( ik )
        IF ( ngg .EQ. igwk ( j ) ) THEN
          igwf_l2g ( ig ) = j
          EXIT
        ENDIF
      ENDDO
    ENDDO

    ALLOCATE ( ipmask ( nproc ) )
    ipmask = 0
    ipsour = ionode_id
    IF ( npool .GT. 1 ) THEN
      IF ( ( ik .GE. iks ) .AND. ( ik .LE. ike ) ) THEN
        IF ( me_pool .EQ. root_pool ) ipmask ( mpime + 1 ) = 1
      ENDIF
      CALL mp_sum ( ipmask )
      DO j = 1, nproc
        IF ( ipmask ( j ) .EQ. 1 ) ipsour = j - 1
      ENDDO
    ENDIF
    DEALLOCATE ( ipmask )

    igwx = 0
    ierr = 0
    IF ( ik .GE. iks .AND. ik .LE. ike ) &
      igwx = MAXVAL ( igwf_l2g ( 1 : local_pw ) )
    CALL mp_max ( igwx, intra_pool_comm )
    IF ( ipsour .NE. ionode_id ) &
      CALL mp_get ( igwx, igwx, mpime, ionode_id, ipsour, 1 )
    ierr = 0
    IF ( ik .GE. iks .AND. ik .LE. ike .AND. igwx .NE. ngk_g ( ik ) ) &
      ierr = 1
    CALL mp_max ( ierr )
    IF ( ierr .GT. 0 ) &
      CALL errore ( 'write_vnlg', 'igwx ngk_g', ierr )

    ALLOCATE ( vkb_g ( MAX ( 1, igwx ) ) )

    DO ikb = 1, nkb

      vkb_g = ( 0.0D0, 0.0D0 )
      IF ( npool .GT. 1 ) THEN
        IF ( ( ik .GE. iks ) .AND. ( ik .LE. ike ) ) THEN
          CALL mergewf ( vkb ( :, ikb ), vkb_g, local_pw, igwf_l2g, &
            me_pool, nproc_pool, root_pool, intra_pool_comm )
        ENDIF
        IF ( ipsour .NE. ionode_id ) THEN
          CALL mp_get ( vkb_g, vkb_g, mpime, ionode_id, ipsour, ikb, &
            world_comm )
        ENDIF
      ELSE
        CALL mergewf ( vkb ( :, ikb ), vkb_g, local_pw, igwf_l2g, &
          mpime, nproc, ionode_id, world_comm )
      ENDIF

      IF ( ionode ) THEN
        WRITE ( unit ) nrecord
        WRITE ( unit ) igwx
        WRITE ( unit ) ( vkb_g ( ig ), ig = 1, igwx )
      ENDIF

    ENDDO

    DEALLOCATE ( vkb_g )
    DEALLOCATE ( igwf_l2g )

  ENDDO

  IF ( ionode ) THEN
    CLOSE ( unit = unit, status = 'keep' )
  ENDIF

  DEALLOCATE ( igwk )
  DEALLOCATE ( igk_l2g )
  DEALLOCATE ( ngk_g )
  DEALLOCATE ( gvec )
  DEALLOCATE ( smap )
  DEALLOCATE ( kmap )

  RETURN

END SUBROUTINE write_vnlg

!-------------------------------------------------------------------------------

SUBROUTINE check_dfpt_modes (imode, dfpt_type, nmode)

  USE control_ph, ONLY : tmp_dir_ph
  USE grid_dimensions, ONLY : nr1x, nr2x, nr3x
  USE io_files, ONLY : diropn
  USE io_global, ONLY : ionode, ionode_id
  USE ions_base, ONLY : nat
  USE lsda_mod, ONLY : nspin
  USE mp, ONLY : mp_bcast
  USE units_ph, ONLY : iudvscf, lrdrho

  IMPLICIT NONE

  integer, intent(in)  :: imode
  integer, intent(in)  :: dfpt_type
  integer, intent(out) :: nmode

  integer :: statb(13)
  logical :: exst
  integer*8 :: unf_recl
  character*10 :: filename

  iudvscf = 27
  lrdrho = 2 * nr1x * nr2x * nr3x * nspin ! from PH/openfilq.f90

  IF(ionode) THEN
    
    IF(dfpt_type == 1) THEN
      filename = "dvscf"
    ELSE
      filename = "dvscf.E"
    ENDIF

    CALL diropn (iudvscf, filename, lrdrho, exst, tmp_dir_ = tmp_dir_ph )
    IF(.NOT. exst) CALL errore ('check_dfpt_modes', 'could not open file', 7)

    ! from io_files.f90, diropn
#if defined(__SX6)
#  define DIRECT_IO_FACTOR 1
#else
#  define DIRECT_IO_FACTOR 8 
#endif

    ! NOTE: ifort needs -assume byterecl or else nrec will be 4 times too large
    unf_recl = DIRECT_IO_FACTOR * int(lrdrho, kind=kind(unf_recl))
    CALL fstat ( iudvscf, statb) ! see EPW, readdvscf.f90
    nmode = statb(8) / unf_recl
    IF(nmode * unf_recl /= statb(8) .and. ionode) &
      WRITE(0,*) 'WARNING: dvscf file does not contain an integral number of records.', &
      statb(8) * 1d0 / unf_recl
    IF(ionode) WRITE(6,*) 'Number of modes in dvscf file: ',  nmode
    IF(ionode) WRITE(6,*) 'Starting with mode number: ',  imode
    IF (imode > nmode) CALL errore('pw2bgw', 'starting mode is not present in dvscf file', iudvscf)

    IF(dfpt_type == 1) then
      IF(nmode < 3 * nat) WRITE(0,'(a)') 'WARNING: dvscf file does not contain all modes.'
      IF(nmode > 3 * nat) WRITE(0,'(a)') 'WARNING: dvscf file contains too many modes.'
    ENDIF
    IF(dfpt_type == 2) then
      IF(nmode < 3) WRITE(0,'(a)') 'WARNING: dvscf_e file does not contain all polarizations.'
      IF(nmode > 3) WRITE(0,'(a)') 'WARNING: dvscf_e file contains too many polarizations.'
    ENDIF
  ENDIF

  CALL mp_bcast ( nmode, ionode_id )

  RETURN

END SUBROUTINE check_dfpt_modes

!-------------------------------------------------------------------------------

subroutine check_inversion(real_or_complex, ntran, mtrx, nspin, warn, real_need_inv)

! check_inversion    Originally By D. Strubbe    Last Modified 10/14/2010
! Check whether our choice of real/complex version is appropriate given the
! presence or absence of inversion symmetry.

  USE io_global, ONLY : ionode

  implicit none

  integer, intent(in) :: real_or_complex
  integer, intent(in) :: ntran
  integer, intent(in) :: mtrx(3, 3, 48)
  integer, intent(in) :: nspin
  logical, intent(in) :: warn ! set to false to suppress warnings, for converters
  logical, intent(in) :: real_need_inv ! use for generating routines to block real without inversion

  integer :: invflag, isym, ii, jj, itest

  invflag = 0
  do isym = 1, ntran
    itest = 0
    do ii = 1, 3
      do jj = 1, 3
        if(ii .eq. jj) then
          itest = itest + (mtrx(ii, jj, isym) + 1)**2
        else
          itest = itest + mtrx(ii, jj, isym)**2
        endif
      enddo
    enddo
    if(itest .eq. 0) invflag = invflag + 1
    if(invflag .gt. 1) call errore('check_inversion', 'More than one inversion symmetry operation is present.', invflag)
  enddo

  if(real_or_complex .eq. 2) then
    if(invflag .ne. 0 .and. warn .and. nspin == 1) then
      if(ionode) write(0, '(a)') 'WARNING: Inversion symmetry is present. The real version would be faster.'
    endif
  else
    if(invflag .eq. 0) then
      if(real_need_inv) then
        call errore('check_inversion', 'The real version cannot be used without inversion symmetry.', -1)
      endif
      if(ionode) then
        write(0, '(a)') 'WARNING: Inversion symmetry is absent in symmetries used to reduce k-grid.'
        write(0, '(a)') 'Be sure inversion is still a spatial symmetry, or you must use complex version instead.'
      endif
    endif
    if(nspin > 1) then
      call errore('check_inversion', &
        'Real version may only be used for spin-unpolarized calculations.', nspin)
    endif
  endif

  return

end subroutine check_inversion

!-------------------------------------------------------------------------------
! Set up some things for DFPT electron-phonon matrix elements.
subroutine initialize_phonon()

  USE atom, ONLY : msh, rgrid
  USE becmod, ONLY : calbec, allocate_bec_type
  USE cell_base, ONLY : omega, tpiba, tpiba2
  USE control_ph, ONLY : current_iq, trans, tmp_dir_ph
  USE eqv, ONLY : dpsi, dvpsi, vlocq
  USE gvect, ONLY : g, ngm
  USE io_files, ONLY : tmp_dir
  USE io_global, ONLY : ionode
  USE ions_base, ONLY : nat, ntyp => nsp
  USE kinds, ONLY : DP
  USE klist, ONLY : nks, xk, nkstot
  USE modes, ONLY : u, npert, name_rap_mode
  USE noncollin_module, ONLY : npol
  USE ph_restart, ONLY : ph_readfile
  USE phus, ONLY : alphap, becp1
  USE qpoint, ONLY : npwq, igkq, xq, eigqts, ikks, ikqs, nksq  ! phcom
  USE uspp, ONLY : nkb, vkb
  USE uspp_param, ONLY : upf
  USE wavefunctions_module, ONLY : evc
  USE wvfct, ONLY : igk, nbnd, npw, npwx, g2kin, ecutwfc

  IMPLICIT NONE

  integer :: nt, ik, ipol, ibnd, ig, ierr, ii, jj, iks, ike
  COMPLEX(DP), ALLOCATABLE :: aux1(:,:)

  if (ionode) then
    WRITE ( 6, '(a)') 'Performing initialization for ionic perturbation.'
  endif

  tmp_dir_ph = trim(tmp_dir) // '_ph0/'

  if ( ANY (upf(1:ntyp)%nlcc) ) then
    CALL errore ( 'initialize_phonon', 'NLCC not implemented.', ierr )
  endif

  ! if gamma_gamma tricks are used, the dvscf file and wfns do not mean what we think they do...
  if(nkstot == 1 .and. ionode) write(0,'(a)') &
    "WARNING: Be sure you are not using a phonon run with gamma_gamma tricks. Must be nogg = .true."

! allocate_phq
  allocate (u ( 3 * nat, 3 * nat))
  allocate (npert ( 3 * nat))
  allocate (name_rap_mode( 3 * nat))

  current_iq = 1
  trans = .true.
!  lgamma = .true.  ! using this causes crash from iotk in ph_readfile??
  CALL ph_readfile ('data_u', ierr) ! reads from XML, for uact
  IF ( ierr /= 0 ) CALL errore ( 'initialize_phonon', 'failed to open phonon XML', ierr )
  if(ionode) then
    OPEN (unit = 16, file = 'displacements.dat', form = 'formatted', status = 'replace')
    write(6,'(a)') 'displacements read from XML file'
    do ii = 1, 3 * nat
      do jj = 1, 3 * nat
        ! we must use (Re, Im) format for this to recognized as complex by a Fortran read
        write(16,'(a,f12.7,a,f12.7,a)',advance='no') '  (', dble(u(jj, ii)), ',', aimag(u(jj, ii)), ')'
      enddo
      write(16,*)
    enddo
    CLOSE(16)
  endif

! allocate_phq
  allocate (dvpsi ( npwx*npol , nbnd))

!  if (lgamma) then
  igkq => igk

! phq_init
!     IF ( lgamma ) THEN
  npwq = npw

  allocate(eigqts(nat))
  eigqts(:) = CMPLX(1d0, 0d0)

  xq(1:3) = 0d0

! allocate_phq.f90

  if(ionode) write(6,'(a,i6)') 'Number of species: ', ntyp
  allocate (vlocq ( ngm , ntyp))

! phq_init.f90:

  ! the fourier components of the local potential at q+G 
  vlocq(:,:) = 0.D0 
  ! 
  DO nt = 1, ntyp
     ! 
     IF (upf(nt)%tcoulombp) then
        CALL setlocq_coul ( xq, upf(nt)%zp, tpiba2, ngm, g, omega, vlocq(1,nt) ) 
     ELSE 
        CALL setlocq( xq, rgrid(nt)%mesh, msh(nt), rgrid(nt)%rab, rgrid(nt)%r,& 
                   upf(nt)%vloc(1), upf(nt)%zp, tpiba2, ngm, g, omega, & 
                   vlocq(1,nt) ) 
     END IF 
    ! 
!     write(6,*) 'init setlocq nt = ', nt
!     write(6,*) vlocq(:, nt)
  END DO

! deallocate_phq.f90:53:  if(allocated(vlocq)) deallocate (vlocq)

! initialize_ph
!  IF ( lgamma ) THEN
  nksq = nks
  ALLOCATE(ikks(nksq), ikqs(nksq))
  DO ik=1,nksq
    ikks(ik) = ik
    ikqs(ik) = ik
  ENDDO

  ALLOCATE (becp1(nksq))
  ALLOCATE (alphap(3,nksq))

  DO ik=1,nksq
     call allocate_bec_type ( nkb, nbnd, becp1(ik) )
     DO ipol=1,3
        call allocate_bec_type ( nkb, nbnd, alphap(ipol,ik) )
     ENDDO
  END DO
!  CALL allocate_bec_type ( nkb, nbnd, becp )

! phq_init
     ! ... e) we compute the becp terms which are used in the rest of 
     ! ...    the code 
     ! 
  ALLOCATE( aux1( npwx*npol, nbnd ) )

  CALL k_pools(iks, ike)

  do ik = 1, nksq

    CALL gk_sort (xk (1, ik - iks + 1), ngm, g, ecutwfc &
      / tpiba2, npw, igk, g2kin)
    CALL init_us_2 ( npw, igk, xk ( 1, ik - iks + 1), vkb )

!      npw = npwx

!    CALL davcio (evc, nwordwfc, iunwfc, ik - iks + 1, -1) ?
     CALL calbec (npw, vkb, evc, becp1(ik) )
     !
     ! ... e') we compute the derivative of the becp term with respect to an 
     !         atomic displacement 
     ! 
     DO ipol = 1, 3 
        aux1=(0.d0,0.d0) 
        DO ibnd = 1, nbnd 
           DO ig = 1, npw 
              aux1(ig,ibnd) = evc(ig,ibnd) * tpiba * ( 0.D0, 1.D0 ) * & 
                              ( xk(ipol,ik) + g(ipol,igk(ig)) ) 
           END DO 
!           IF (noncolin) THEN 
!              DO ig = 1, npw 
!                 aux1(ig+npwx,ibnd)=evc(ig+npwx,ibnd)*tpiba*(0.D0,1.D0)*& 
!                           ( xk(ipol,ikk) + g(ipol,igk(ig)) ) 
!              END DO 
!           END IF 
        END DO 
        CALL calbec (npw, vkb, aux1, alphap(ipol,ik) ) 
     END DO
   enddo

   deallocate(aux1)

   return
end subroutine initialize_phonon

!-------------------------------------------------------------------------------
! Set up some things for DFPT electron-electric matrix elements.
subroutine initialize_electric()

  USE atom, ONLY : msh, rgrid
  USE becmod, ONLY : calbec, allocate_bec_type
  USE cell_base, ONLY : omega, tpiba, tpiba2
  USE control_ph, ONLY : current_iq, trans, tmp_dir_ph
  USE eqv, ONLY : dpsi, dvpsi, vlocq
  USE gvect, ONLY : g, ngm
  USE io_files, ONLY : tmp_dir
  USE io_global, ONLY : ionode
  USE ions_base, ONLY : nat, ntyp => nsp
  USE kinds, ONLY : DP
  USE klist, ONLY : nks, xk, nkstot
  USE modes, ONLY : u, npert, name_rap_mode
  USE noncollin_module, ONLY : npol
  USE ph_restart, ONLY : ph_readfile
  USE phus, ONLY : alphap, becp1
  USE qpoint, ONLY : npwq, igkq, xq, eigqts, ikks, ikqs, nksq  ! phcom
  USE uspp, ONLY : nkb, vkb
  USE uspp_param, ONLY : upf
  USE wavefunctions_module, ONLY : evc
  USE wvfct, ONLY : igk, nbnd, npw, npwx, g2kin, ecutwfc

  IMPLICIT NONE

  if (ionode) then
    WRITE ( 6, '(a)') 'Performing initialization for electric perturbation.'
  endif

  tmp_dir_ph = trim(tmp_dir) // '_ph0/'

  ! if gamma_gamma tricks are used, the dvscf file and wfns do not mean what we think they do...
  if(nkstot == 1 .and. ionode) write(0,'(a)') &
    "WARNING: Be sure you are not using a phonon run with gamma_gamma tricks. Must be nogg = .true."

  allocate ( dpsi ( npwx*npol , nbnd))

  ! more is needed!

  return

end subroutine initialize_electric

!-------------------------------------------------------------------------------

subroutine write_header(unit, stitle)

  USE cell_base, ONLY : omega, alat, tpiba, tpiba2, at, bg, &
    ibrav, symm_type
  USE constants, ONLY : pi, tpi, eps6
  USE grid_dimensions, ONLY : nr1, nr2, nr3
  USE gvect, ONLY : ngm, ngm_g, ig_l2g, mill, ecutrho
  USE io_global, ONLY : ionode
  USE ions_base, ONLY : nat, atm, ityp, tau 
  USE kinds, ONLY : DP
  USE lsda_mod, ONLY : nspin
  USE mp, ONLY : mp_sum
  USE mp_global, ONLY : intra_pool_comm
  USE scf, ONLY : rho
  USE symm_base, ONLY : s, ftau, nsym

  IMPLICIT NONE

  integer, intent(in) :: unit
  character(len=32), intent(in) :: stitle

  character :: cdate*9, ctime*9, sdate*32, stime*32
  integer :: id, ig, i, j, k, ierr
  integer :: nd, ns, nst, nsf, ng_l, ng_g
  integer :: ntran, cell_symmetry, nrecord
  real (DP) :: alat2, recvol, dr1, t1 ( 3 ), t2 ( 3 )
  real (DP) :: r1 ( 3, 3 ), r2 ( 3, 3 ), adot ( 3, 3 )
  real (DP) :: bdot ( 3, 3 ), translation ( 3, 48 )
  integer, allocatable :: g_g ( :, : )

  INTEGER, EXTERNAL :: atomic_number

  CALL date_and_tim ( cdate, ctime )
  WRITE ( sdate, '(A2,"-",A3,"-",A4,21X)' ) cdate(1:2), cdate(3:5), cdate(6:9)
  WRITE ( stime, '(A8,24X)' ) ctime(1:8)

  nrecord = 1
  nd = 3

  ng_l = ngm
  ng_g = ngm_g
  call set_spin(ns,nst,nsf,nspin)

  ierr = 0
  IF ( ibrav .EQ. 0 ) THEN
    IF ( TRIM ( symm_type ) .EQ. 'cubic' ) THEN
      cell_symmetry = 0
    ELSEIF ( TRIM ( symm_type ) .EQ. 'hexagonal' ) THEN
      cell_symmetry = 1
    ELSE
      ierr = 1
    ENDIF
  ELSEIF ( ibrav .GE. 1 .AND. ibrav .LE. 3 ) THEN
    cell_symmetry = 0
  ELSEIF ( ibrav .GE. 4 .AND. ibrav .LE. 5 ) THEN
    cell_symmetry = 1
  ELSEIF ( ibrav .GE. 6 .AND. ibrav .LE. 14 ) THEN
    cell_symmetry = 0
  ELSE
    ierr = 1
  ENDIF
  IF ( ierr .GT. 0 ) &
    CALL errore ( 'write_header', 'cell_symmetry', ierr )

  ntran = nsym
  DO i = 1, ntran
    DO j = 1, nd
      DO k = 1, nd
        r1 ( k, j ) = dble ( s ( k, j, i ) )
      ENDDO
    ENDDO
    CALL invmat ( 3, r1, r2, dr1 )
    t1 ( 1 ) = dble ( ftau ( 1, i ) ) / dble ( nr1 )
    t1 ( 2 ) = dble ( ftau ( 2, i ) ) / dble ( nr2 )
    t1 ( 3 ) = dble ( ftau ( 3, i ) ) / dble ( nr3 )
    DO j = 1, nd
      t2 ( j ) = 0.0D0
      DO k = 1, nd
        t2 ( j ) = t2 ( j ) + r2 ( k, j ) * t1 ( k )
      ENDDO
      IF ( t2 ( j ) .GE. eps6 + 0.5D0 ) &
        t2 ( j ) = t2 ( j ) - dble ( int ( t2 ( j ) + 0.5D0 ) )
      IF ( t2 ( j ) .LT. eps6 - 0.5D0 ) &
        t2 ( j ) = t2 ( j ) - dble ( int ( t2 ( j ) - 0.5D0 ) )
    ENDDO
    DO j = 1, nd
      translation ( j, i ) = t2 ( j ) * tpi
    ENDDO
  ENDDO

  alat2 = alat ** 2
  recvol = 8.0D0 * pi**3 / omega

  DO i = 1, nd
    DO j = 1, nd
      adot ( j, i ) = 0.0D0
    ENDDO
  ENDDO
  DO i = 1, nd
    DO j = 1, nd
      DO k = 1, nd
        adot ( j, i ) = adot ( j, i ) + &
          at ( k, j ) * at ( k, i ) * alat2
      ENDDO
    ENDDO
  ENDDO

  DO i = 1, nd
    DO j = 1, nd
      bdot ( j, i ) = 0.0D0
    ENDDO
  ENDDO
  DO i = 1, nd
    DO j = 1, nd
      DO k = 1, nd
        bdot ( j, i ) = bdot ( j, i ) + &
          bg ( k, j ) * bg ( k, i ) * tpiba2
      ENDDO
    ENDDO
  ENDDO

  ALLOCATE ( g_g ( nd, ng_g ) )

  DO ig = 1, ng_g
    DO id = 1, nd
      g_g ( id, ig ) = 0
    ENDDO
  ENDDO

  DO ig = 1, ng_l
    g_g ( 1, ig_l2g ( ig ) ) = mill ( 1, ig )
    g_g ( 2, ig_l2g ( ig ) ) = mill ( 2, ig )
    g_g ( 3, ig_l2g ( ig ) ) = mill ( 3, ig )
  ENDDO

  CALL mp_sum ( g_g, intra_pool_comm )

  IF(ionode) then
    WRITE ( unit ) stitle, sdate, stime
    WRITE ( unit ) nspin, ng_g, ntran, cell_symmetry, nat, ecutrho
    WRITE ( unit ) nr1, nr2, nr3
    WRITE ( unit ) omega, alat, ( ( at ( j, i ), j = 1, nd ), i = 1, nd ), &
      ( ( adot ( j, i ), j = 1, nd ), i = 1, nd )
    WRITE ( unit ) recvol, tpiba, ( ( bg ( j, i ), j = 1, nd ), i = 1, nd ), &
      ( ( bdot ( j, i ), j = 1, nd ), i = 1, nd )
    WRITE ( unit ) ( ( ( s ( k, j, i ), k = 1, nd ), j = 1, nd ), i = 1, ntran )
    WRITE ( unit ) ( ( translation ( j, i ), j = 1, nd ), i = 1, ntran )
    WRITE ( unit ) ( ( tau ( j, i ), j = 1, nd ), atomic_number ( atm ( ityp ( i ) ) ), i = 1, nat )
    WRITE ( unit ) nrecord
    WRITE ( unit ) ng_g
    WRITE ( unit ) ( ( g_g ( id, ig ), id = 1, nd ), ig = 1, ng_g )
  ENDIF

  DEALLOCATE ( g_g )
  RETURN
  
end subroutine write_header

!-------------------------------------------------------------------------------

! Alternate method of calculating DFPT matrix elements, for testing.
! Project variation of occupied wavefunctions (dwf files) onto wavefunctions.
! Must hack ph code to preserve dwf's. Must be done one mode at a time.
! Only gives occ-unocc mtxels, which are actually not the ones needed in forces.
subroutine dfpt_dwf()

  USE cell_base, ONLY : tpiba2
  USE constants, ONLY : rytoev
  USE control_ph, ONLY : tmp_dir_ph
  USE eqv, ONLY : dpsi
  USE gvect, ONLY : g, ngm
  USE io_files, ONLY : diropn, prefix, nwordwfc, iunwfc, nd_nmbr
  USE kinds, ONLY : DP
  USE klist, ONLY : xk, nelec
  USE lsda_mod, ONLY : nspin
  USE mp, ONLY : mp_sum
  USE mp_global, ONLY : intra_pool_comm
  USE noncollin_module, ONLY : npol
  USE qpoint, ONLY : nksq
  USE units_ph, ONLY : iudwf, lrdwf
  USE wavefunctions_module, ONLY : evc
  USE wvfct, ONLY : nbnd, npw, npwx, igk, g2kin, ecutwfc, et

  IMPLICIT NONE

  integer :: nrec, ipert, ik, ib, ib2, nbnd_occ, iks, ike
  logical :: exst
  complex(DP), allocatable :: mtxel(:,:)

  nbnd_occ = nelec
  if(nspin == 1) nbnd_occ = nbnd_occ / 2d0
  allocate (dpsi (npwx*npol, nbnd_occ / nspin))
  allocate (mtxel (nbnd_occ, nbnd))

  ! from openfilq.f90
  iudwf = 22
  ! we do not actually know the number of bands in scf/ph. we guess...
  lrdwf = 2 * nbnd_occ * npwx * npol
  CALL diropn (iudwf, 'dwf', lrdwf, exst, tmp_dir_ = tmp_dir_ph)
  IF (.NOT.exst) CALL errore ('dfpt_dwf','file '//trim(prefix)//'.dwf not found', 1)

  ! this would be the index of the perturbation within the irrep.
  ! we do not have this info though, so we will just deal with the first one
  ipert = 1

  CALL k_pools(iks, ike)
  do ik = iks, ike
    nrec = (ipert - 1) * nksq + ik
    CALL gk_sort (xk (1, ik - iks + 1), ngm, g, ecutwfc &
      / tpiba2, npw, igk, g2kin)
    CALL davcio (evc, nwordwfc, iunwfc, ik - iks + 1, -1)
    call davcio (dpsi, lrdwf, iudwf, nrec, -1)
!    write(37,*) evc
!    write(38,*) dpsi
    do ib = 1, nbnd_occ
      do ib2 = 1, nbnd
        ! zgemm?
!        mtxel(ib, ib2) = sum(conjg(evc(1:npw, ib)) * evc(1:npw, ib2))
        mtxel(ib, ib2) = sum(conjg(dpsi(1:npw, ib)) * evc(1:npw, ib2))
        CALL mp_sum (mtxel(ib, ib2), intra_pool_comm)
        write(6,'(2i6,2f12.6)') ib, ib2, mtxel(ib, ib2) * (et(ib2, ik) - et(ib, ik)) * rytoev
      enddo
    enddo
  enddo

  deallocate(dpsi)
  deallocate(mtxel)

  RETURN
  
end subroutine dfpt_dwf

!-------------------------------------------------------------------------------

! determine start and end k-points for this pool
! taken from PW/pw_restart.f90
subroutine k_pools(iks, ike)

  USE klist, ONLY : nkstot
  USE mp_global, ONLY : kunit, my_pool_id, npool

  IMPLICIT NONE

  integer, intent(out) :: iks, ike

  integer :: nkbl, nkl, nkr

! ... find out the number of pools
!  npool = nproc / nproc_pool
! apparently this is already initialized. --DAS

! ... find out number of k-points blocks
  nkbl = nkstot / kunit
! ... k-points per pool  
  nkl = kunit * ( nkbl / npool )
! ... find out the remainder
  nkr = ( nkstot - nkl * npool ) / kunit
! ... Assign the remainder to the first nkr pools
  IF ( my_pool_id .LT. nkr ) nkl = nkl + kunit
! ... find out the index of the first k-point in this pool
  iks = nkl * my_pool_id + 1
  IF ( my_pool_id .GE. nkr ) iks = iks + nkr * kunit
! ... find out the index of the last k-point in this pool
  ike = iks + nkl - 1

  RETURN

end subroutine k_pools

!-------------------------------------------------------------------------------

! Set spin-related parameters ns, nst, nsf
!
subroutine set_spin(ns, nst, nsf, nspin)

  IMPLICIT NONE

  integer, intent(out) :: ns, nst, nsf
  integer, intent(in) :: nspin

  IF ( nspin == 4 ) THEN
    ns = 1
    nst = 2
    nsf = 4
  ELSE
    ns = nspin
    nst = nspin
    nsf = nspin
  ENDIF

  RETURN

end subroutine set_spin

end module pw2bgw_m

PROGRAM pw2bgw

  USE constants, ONLY : eps12
  USE control_flags, ONLY : gamma_only
  USE environment, ONLY : environment_start, environment_end
  USE io_files, ONLY : prefix, tmp_dir, outdir
  USE io_global, ONLY : ionode, ionode_id
  USE kinds, ONLY : DP
  USE klist, ONLY : nkstot
  USE mp, ONLY : mp_bcast
  USE mp_global, ONLY : mp_startup
  USE paw_variables, ONLY : okpaw
  use scf, ONLY: rho_core, rhog_core
  USE uspp, ONLY : okvan
  USE wvfct, ONLY : nbnd

  USE pw2bgw_m

  IMPLICIT NONE

  character(len=6) :: codename = 'PW2BGW'

  integer :: real_or_complex
  logical :: wfng_flag
  character ( len = 256 ) :: wfng_file
  logical :: wfng_kgrid
  integer :: wfng_nk1
  integer :: wfng_nk2
  integer :: wfng_nk3
  real (DP) :: wfng_dk1
  real (DP) :: wfng_dk2
  real (DP) :: wfng_dk3
  logical :: wfng_occupation
  integer :: wfng_nvmin
  integer :: wfng_nvmax
  logical :: rhog_flag
  character ( len = 256 ) :: rhog_file
  logical :: vxcg_flag
  character ( len = 256 ) :: vxcg_file
  logical :: vxc0_flag
  character ( len = 256 ) :: vxc0_file
  logical :: vxc_flag
  character ( len = 256 ) :: vxc_file
  integer :: dfpt_type  ! 0 = none, 1 = ionic, 2 = electric
  logical :: dfpt_from_dwf
  character ( len = 256 ) :: dfpt_file
  character :: vxc_integral
  integer :: vxc_diag_nmin
  integer :: vxc_diag_nmax
  integer :: vxc_offdiag_nmin
  integer :: vxc_offdiag_nmax
  integer :: dfpt_mode_start
  integer :: dfpt_mode_end
  logical :: vxc_zero_rho_core
  character ( len = 20 ) :: input_dft
  logical :: exx_flag
  logical :: vnlg_flag
  character ( len = 256 ) :: vnlg_file

  NAMELIST / input_pw2bgw / prefix, outdir, &
    real_or_complex, wfng_flag, wfng_file, wfng_kgrid, &
    wfng_nk1, wfng_nk2, wfng_nk3, wfng_dk1, wfng_dk2, wfng_dk3, &
    wfng_occupation, wfng_nvmin, wfng_nvmax, rhog_flag, rhog_file, &
    vxcg_flag, vxcg_file, vxc0_flag, vxc0_file, vxc_flag, &
    vxc_file, vxc_integral, vxc_diag_nmin, vxc_diag_nmax, &
    vxc_offdiag_nmin, vxc_offdiag_nmax, vxc_zero_rho_core, &
    input_dft, exx_flag, vnlg_flag, vnlg_file

  integer :: ii, ios, imode, nmode
  character ( len = 256 ) :: output_file_name, tmpstr
  logical :: die_spinors

  character (len=256), external :: trimcheck
  character (len=1), external :: lowercase

#ifdef __PARA
  CALL mp_startup ( )
#endif
  CALL environment_start ( codename )

  ! assign defaults
  prefix = 'prefix'
  CALL get_env ( 'ESPRESSO_TMPDIR', outdir )
  IF ( TRIM ( outdir ) == ' ' ) outdir = './'
  real_or_complex = 2
  wfng_flag = .FALSE.
  wfng_file = 'WFN'
  wfng_kgrid = .FALSE.
  wfng_nk1 = 0
  wfng_nk2 = 0
  wfng_nk3 = 0
  wfng_dk1 = 0.0D0
  wfng_dk2 = 0.0D0
  wfng_dk3 = 0.0D0
  wfng_occupation = .FALSE.
  wfng_nvmin = 0
  wfng_nvmax = 0
  rhog_flag = .FALSE.
  rhog_file = 'RHO'
  vxcg_flag = .FALSE.
  vxcg_file = 'VXC'
  vxc0_flag = .FALSE.
  vxc0_file = 'vxc0.dat'
  vxc_flag = .FALSE.
  vxc_file = 'vxc.dat'
  vxc_integral = 'g'
  vxc_diag_nmin = 0
  vxc_diag_nmax = 0
  vxc_offdiag_nmin = 0
  vxc_offdiag_nmax = 0
  vxc_zero_rho_core = .TRUE.
  input_dft = 'sla+pz'
  exx_flag = .FALSE.
  vnlg_flag = .FALSE.
  vnlg_file = 'VNL'
  dfpt_type = 0
  dfpt_from_dwf = .FALSE.
  dfpt_file = 'dfpt.dat'
  dfpt_mode_start = 1
  dfpt_mode_end = 0 ! do all

  IF ( ionode ) THEN
    CALL input_from_file ( )
    READ ( 5, input_pw2bgw, iostat = ios )
    IF ( ios /= 0 ) CALL errore ( codename, 'input_pw2bgw', abs ( ios ) )

    DO ii = 1, LEN_TRIM (vxc_integral)
      vxc_integral(ii:ii) = lowercase (vxc_integral(ii:ii))
    END DO

    IF ( real_or_complex /= 1 .AND. real_or_complex /= 2 ) &
      CALL errore ( codename, 'real_or_complex', 1 )
    IF ( vxc_integral /= 'r' .AND. vxc_integral /= 'g' ) &
      CALL errore ( codename, 'vxc_integral', 1 )
  ENDIF

  tmp_dir = trimcheck ( outdir )
  CALL mp_bcast ( outdir, ionode_id )
  CALL mp_bcast ( tmp_dir, ionode_id )
  CALL mp_bcast ( prefix, ionode_id )
  CALL mp_bcast ( real_or_complex, ionode_id )
  CALL mp_bcast ( wfng_flag, ionode_id )
  CALL mp_bcast ( wfng_file, ionode_id )
  CALL mp_bcast ( wfng_kgrid, ionode_id )
  CALL mp_bcast ( wfng_nk1, ionode_id )
  CALL mp_bcast ( wfng_nk2, ionode_id )
  CALL mp_bcast ( wfng_nk3, ionode_id )
  CALL mp_bcast ( wfng_dk1, ionode_id )
  CALL mp_bcast ( wfng_dk2, ionode_id )
  CALL mp_bcast ( wfng_dk3, ionode_id )
  CALL mp_bcast ( wfng_occupation, ionode_id )
  CALL mp_bcast ( wfng_nvmin, ionode_id )
  CALL mp_bcast ( wfng_nvmax, ionode_id )
  CALL mp_bcast ( rhog_flag, ionode_id )
  CALL mp_bcast ( rhog_file, ionode_id )
  CALL mp_bcast ( vxcg_flag, ionode_id )
  CALL mp_bcast ( vxcg_file, ionode_id )
  CALL mp_bcast ( vxc0_flag, ionode_id )
  CALL mp_bcast ( vxc0_file, ionode_id )
  CALL mp_bcast ( vxc_flag, ionode_id )
  CALL mp_bcast ( vxc_integral, ionode_id )
  CALL mp_bcast ( vxc_file, ionode_id )
  CALL mp_bcast ( vxc_diag_nmin, ionode_id )
  CALL mp_bcast ( vxc_diag_nmax, ionode_id )
  CALL mp_bcast ( vxc_offdiag_nmin, ionode_id )
  CALL mp_bcast ( vxc_offdiag_nmax, ionode_id )
  CALL mp_bcast ( vxc_zero_rho_core, ionode_id )
  CALL mp_bcast ( input_dft, ionode_id )
  CALL mp_bcast ( exx_flag, ionode_id )
  CALL mp_bcast ( vnlg_flag, ionode_id )
  CALL mp_bcast ( vnlg_file, ionode_id )
  CALL mp_bcast ( dfpt_type, ionode_id )
  CALL mp_bcast ( dfpt_from_dwf, ionode_id )
  CALL mp_bcast ( dfpt_file, ionode_id )
  CALL mp_bcast ( dfpt_mode_start, ionode_id )
  CALL mp_bcast ( dfpt_mode_end, ionode_id )

  if(dfpt_type < 0 .or. dfpt_type > 2) &
    call errore ( 'pw2bgw', 'unknown dfpt_type', dfpt_type)
  if(dfpt_type /= 0 .and. dfpt_mode_start < 1) &
    call errore ( 'pw2bgw', 'dfpt_mode_start < 1', dfpt_mode_start)

  if (ionode) then
    WRITE ( 6, '(a)') 'Reading basic information from files.'
  endif
  CALL read_file ( )

  if (ionode) then
    if (MAX (MAXVAL (ABS (rho_core (:) ) ), MAXVAL (ABS (rhog_core (:) ) ) ) &
      .LT. eps12) then
      WRITE ( 6, '(/,5x,"NLCC is absent")' )
    else
      WRITE ( 6, '(/,5x,"NLCC is present")' )
    endif
  endif
  if (okvan) call errore ( 'pw2bgw', 'BGW cannot use USPP.', 3 )
  if (okpaw) call errore ( 'pw2bgw', 'BGW cannot use PAW.', 4 )
  if (gamma_only) call errore ( 'pw2bgw', 'BGW cannot use gamma-only run.', 5 )
  die_spinors = (nspin == 4)
  if (die_spinors) call errore ( 'pw2bgw', 'BGW cannot use spinors.', 6 )
  if (real_or_complex == 1 .AND. vxc_flag .AND. vxc_offdiag_nmax > 0) &
    call errore ( 'pw2bgw', 'Off-diagonal matrix elements of Vxc ' // &
    'with real wavefunctions are not implemented, compute them in ' // &
    'Sigma using VXC.', 7)

  CALL openfil_pp ( )

  if ( ionode ) WRITE ( 6, '("")' )

  if ( ionode ) write ( 6, '(a, i8)' ) "Total number of bands    available: ", nbnd
  if ( ionode ) write ( 6, '(a, i8)' ) "Total number of k-points available: ", nkstot

  IF ( wfng_flag ) THEN
    output_file_name = TRIM ( outdir ) // '/' // TRIM ( wfng_file )
    IF ( ionode ) WRITE ( 6, '(5x,"call write_wfng")' )
    CALL start_clock ( 'write_wfng' )
    CALL write_wfng ( output_file_name, real_or_complex, &
      wfng_kgrid, wfng_nk1, wfng_nk2, wfng_nk3, wfng_dk1, wfng_dk2, &
      wfng_dk3, wfng_occupation, wfng_nvmin, wfng_nvmax )
    CALL stop_clock ( 'write_wfng' )
    IF ( ionode ) WRITE ( 6, '(5x,"done write_wfng",/)' )
  ENDIF

  IF ( rhog_flag ) THEN
    output_file_name = TRIM ( outdir ) // '/' // TRIM ( rhog_file )
    IF ( ionode ) WRITE ( 6, '(5x,"call write_rhog")' )
    CALL start_clock ( 'write_rhog' )
    CALL write_rhog ( output_file_name, real_or_complex )
    CALL stop_clock ( 'write_rhog' )
    IF ( ionode ) WRITE ( 6, '(5x,"done write_rhog",/)' )
  ENDIF

  IF ( vxcg_flag ) THEN
    output_file_name = TRIM ( outdir ) // '/' // TRIM ( vxcg_file )
    IF ( ionode ) WRITE ( 6, '(5x,"call write_vxcg")' )
    CALL start_clock ( 'write_vxcg' )
    CALL write_vxcg ( output_file_name, real_or_complex, &
      vxc_zero_rho_core, input_dft, exx_flag )
    CALL stop_clock ( 'write_vxcg' )
    IF ( ionode ) WRITE ( 6, '(5x,"done write_vxcg",/)' )
  ENDIF

  IF ( vxc0_flag ) THEN
    output_file_name = TRIM ( outdir ) // '/' // TRIM ( vxc0_file )
    IF ( ionode ) WRITE ( 6, '(5x,"call write_vxc0")' )
    CALL start_clock ( 'write_vxc0' )
    CALL write_vxc0 ( output_file_name, vxc_zero_rho_core, input_dft, &
      exx_flag )
    CALL stop_clock ( 'write_vxc0' )
    IF ( ionode ) WRITE ( 6, '(5x,"done write_vxc0",/)' )
  ENDIF

  IF ( vxc_flag ) THEN
    output_file_name = TRIM ( outdir ) // '/' // TRIM ( vxc_file )
    IF ( ionode ) WRITE ( 6, '(5x,"call write_vxc")' )
    CALL start_clock ( 'write_vxc' )
    CALL write_vxc ( vxc_integral, output_file_name, &
      vxc_diag_nmin, vxc_diag_nmax, &
      vxc_offdiag_nmin, vxc_offdiag_nmax, &
      vxc_zero_rho_core, input_dft, exx_flag, 0, 0 )
    CALL stop_clock ( 'write_vxc' )
    IF ( ionode ) WRITE ( 6, '(5x,"done write_vxc",/)' )
  ENDIF

  IF ( vnlg_flag ) THEN
    output_file_name = TRIM ( outdir ) // '/' // TRIM ( vnlg_file )
    IF ( ionode ) WRITE ( 6, '(5x,"call write_vnlg")' )
    CALL start_clock ( 'write_vnlg' )
    CALL write_vnlg ( output_file_name, wfng_kgrid, wfng_nk1, &
      wfng_nk2, wfng_nk3, wfng_dk1, wfng_dk2, wfng_dk3 )
    CALL stop_clock ( 'write_vnlg' )
    IF ( ionode ) WRITE ( 6, '(5x,"done write_vnlg",/)' )
  ENDIF

  IF ( dfpt_type /= 0 ) THEN
    IF(dfpt_type == 1) THEN
      call initialize_phonon()
    ELSE
      call initialize_electric()
    ENDIF
    CALL check_dfpt_modes ( dfpt_mode_start, dfpt_type, nmode )
    IF(dfpt_mode_end == 0) dfpt_mode_end = nmode

    IF(dfpt_from_dwf) CALL dfpt_dwf()

    DO imode = dfpt_mode_start, dfpt_mode_end
      WRITE(tmpstr,'(i6.6)') imode
      IF ( ionode ) WRITE ( 6, '(5x,"call write_dfpt")' )
      CALL start_clock ( 'write_dfpt' )

!      output_file_name = TRIM ( outdir ) // '/' // TRIM ( dfpt_file ) // "_dvscf_mode" // TRIM ( tmpstr )
!      CALL write_vxc ( 'r', output_file_name, &
!        vxc_diag_nmin, vxc_diag_nmax, &
!        vxc_diag_nmin, vxc_diag_nmax, & ! we need the whole matrix here
!        input_dft, .false., dfpt_type, imode)

      output_file_name = TRIM ( outdir ) // '/' // TRIM ( dfpt_file ) // "_mode" // TRIM ( tmpstr )
      CALL write_vxc ( 'g', output_file_name, &
        vxc_diag_nmin, vxc_diag_nmax, &
        vxc_diag_nmin, vxc_diag_nmax, & ! we need the whole matrix here
        vxc_zero_rho_core, input_dft, .false., dfpt_type, imode)
      CALL stop_clock ( 'write_dfpt' )
      IF ( ionode ) WRITE ( 6, '(5x,"done write_dfpt",/)' )
    ENDDO
  ENDIF

  IF ( ionode ) WRITE ( 6, * )
  IF ( wfng_flag ) CALL print_clock ( 'write_wfng' )
  IF ( rhog_flag ) CALL print_clock ( 'write_rhog' )
  IF ( vxcg_flag ) CALL print_clock ( 'write_vxcg' )
  IF ( vxc0_flag ) CALL print_clock ( 'write_vxc0' )
  IF ( vxc_flag )  CALL print_clock ( 'write_vxc' )
  IF ( dfpt_type /= 0 ) CALL print_clock ( 'write_dfpt' )
  IF ( vnlg_flag ) CALL print_clock ( 'write_vnlg' )
  IF ( wfng_flag .AND. real_or_complex .EQ. 1 ) THEN
    IF ( ionode ) WRITE ( 6, '(/,5x,"Called by write_wfng:")' )
    CALL print_clock ( 'real_wfng' )
  ENDIF

  CALL environment_end ( codename )
  CALL stop_pp ( )

  STOP

END PROGRAM pw2bgw

!=========================================================================
!
! Included from file wfn_io_hdf5.f90.
! You are not expected to understand this. --JIM
!
!=========================================================================

#ifdef READ
  #define HDF5_READ_WRITE(x) hdf5_read ## x
  #define READ_WRITE(x) read ## x
  #define INTENT out
  #define FLAVOR_INTENT inout
  #define H5D_READ_WRITE call h5dread_f
  #define H5F_FILE_ACCESS H5F_ACC_RDONLY_F
#else
  #define HDF5_READ_WRITE(x) hdf5_write ## x
  #define READ_WRITE(x) write ## x
  #define INTENT in
  #define FLAVOR_INTENT in
  #define H5D_READ_WRITE call h5dwrite_f
  #define H5F_FILE_ACCESS H5F_ACC_RDWR_F
#endif

#ifdef HDF5
  #define NAME(x) READ_WRITE(_hdf5 ## x)
#endif

#ifdef TEMP_WFN_DATA
  #ifdef TEMP_COMPLEX
    #define TEMP_SCALAR complex(DPC)
    #define MPI_TEMP_SCALAR MPI_COMPLEX_DPC
    #define LONGNAME(x) NAME(x ## _complex)
  #else
    #define TEMP_SCALAR real(DPC)
    #define MPI_TEMP_SCALAR MPI_REAL_DP
    #define LONGNAME(x) NAME(x ## _real)
  #endif
#endif

! begin read/write header
#ifdef TEMP_HEADER
subroutine NAME(_header_type)(sFileName, sheader, iflavor, kp, gvec, syms, crys)
  character(len=*), intent(in) :: sFileName
  character(len=3), intent(inout) :: sheader
  integer, intent(FLAVOR_INTENT) :: iflavor
  type(kpoints), intent(INTENT) :: kp
  type(gspace), intent(INTENT) :: gvec
  type(symmetry), intent(INTENT) :: syms
  type(crystal), intent(INTENT) :: crys
  
  ! set values based on epsilon calculation
  logical :: is_get=.false.
  logical :: wfnflag=.true.
  
  PUSH_SUB(NAME(_header_type))
  
  if (peinf%inode == 0) then
    call READ_WRITE(_info)(TRUNC(sFileName),iflavor)
    call READ_WRITE(_kpoints)(TRUNC(sFileName),kp)
    call READ_WRITE(_gspace)(TRUNC(sFileName),gvec)
    call READ_WRITE(_symmetry)(TRUNC(sFileName),syms)
    call READ_WRITE(_crystal)(TRUNC(sFileName),crys)
  endif
#ifdef READ
#ifdef MPI
  if (peinf%npes > 1) then
    call MPI_BCAST(is_get, 1, MPI_LOGICAL, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(kp%nspin, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(gvec%ng, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(syms%ntran, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(syms%cell_symmetry, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(crys%nat, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(gvec%ecutrho, 1, MPI_DOUBLE_PRECISION, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(gvec%FFTgrid, 3, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(crys%celvol, 1, MPI_DOUBLE_PRECISION, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(crys%alat, 1, MPI_DOUBLE_PRECISION, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(crys%avec, 9, MPI_DOUBLE_PRECISION, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(crys%adot, 9, MPI_DOUBLE_PRECISION, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(crys%recvol, 1, MPI_DOUBLE_PRECISION, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(crys%blat, 1, MPI_DOUBLE_PRECISION, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(crys%bvec, 9, MPI_DOUBLE_PRECISION, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(crys%bdot, 9, MPI_DOUBLE_PRECISION, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(syms%mtrx(1,1,1), 3*3*48, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(syms%tnp, 3*48, MPI_DOUBLE_PRECISION, 0, MPI_COMM_WORLD, mpierr)
    if (wfnflag) then
      call MPI_BCAST(kp%nrk, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
      call MPI_BCAST(kp%mnband, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
      call MPI_BCAST(kp%ngkmax, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
      call MPI_BCAST(kp%ecutwfc, 1, MPI_DOUBLE_PRECISION, 0, MPI_COMM_WORLD, mpierr)
      call MPI_BCAST(kp%kgrid, 3, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
      call MPI_BCAST(kp%shift, 3, MPI_DOUBLE_PRECISION, 0, MPI_COMM_WORLD, mpierr)
    endif
  endif
#endif
  if(peinf%inode > 0 ) then
    allocate(crys%atyp (crys%nat))
    allocate(crys%apos (3, crys%nat))
    if (wfnflag) then
      allocate(kp%ngk (kp%nrk))
      allocate(kp%w (kp%nrk))
      allocate(kp%rk (3, kp%nrk))
      allocate(kp%ifmin (kp%nrk, kp%nspin))
      allocate(kp%ifmax (kp%nrk, kp%nspin))
      allocate(kp%el (kp%mnband, kp%nrk, kp%nspin))
      allocate(kp%occ (kp%mnband, kp%nrk, kp%nspin))
    endif
  endif
#endif
  
#if defined READ && defined MPI
  if (peinf%npes > 1) then
    call MPI_BCAST(crys%atyp, crys%nat, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(crys%apos, 3*crys%nat, MPI_DOUBLE_PRECISION, 0, MPI_COMM_WORLD, mpierr)
    if (wfnflag) then
      call MPI_BCAST(kp%ngk, kp%nrk, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
      call MPI_BCAST(kp%w, kp%nrk, MPI_DOUBLE_PRECISION, 0, MPI_COMM_WORLD, mpierr)
      call MPI_BCAST(kp%rk, 3*kp%nrk, MPI_DOUBLE_PRECISION, 0, MPI_COMM_WORLD, mpierr)
      call MPI_BCAST(kp%ifmin, kp%nspin*kp%nrk, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
      call MPI_BCAST(kp%ifmax, kp%nspin*kp%nrk, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
      call MPI_BCAST(kp%el(1,1,1), kp%mnband*kp%nspin*kp%nrk, MPI_DOUBLE_PRECISION, 0, MPI_COMM_WORLD, mpierr)
      call MPI_BCAST(kp%occ(1,1,1), kp%mnband*kp%nspin*kp%nrk, MPI_DOUBLE_PRECISION, 0, MPI_COMM_WORLD, mpierr)
    endif
  endif
#endif
  POP_SUB(NAME(_header_type))
end subroutine NAME(_header_type)

subroutine READ_WRITE(_info)(sFileName, iflavor)
  character(len=*), intent(in) :: sFileName
  integer, intent(INTENT) :: iflavor
  
  integer(HID_T) :: hidFile
  integer :: iError
  
  PUSH_SUB(READ_WRITE(_info))
  
  call h5fopen_f(sFileName, H5F_FILE_ACCESS, hidFile, iError)
  call HDF5_READ_WRITE(_int)(hidFile, '/info', iflavor, iError)
  call h5fclose_f(hidFile, iError)
  
  POP_SUB(READ_WRITE(_info))
end subroutine READ_WRITE(_info)
  
subroutine READ_WRITE(_gspace)(sFileName,gvec)
  character(len=*), intent(in) :: sFileName
  type(gspace), intent(INTENT) :: gvec
  
  integer(HID_T) :: hidFile
  integer :: iError
  
  PUSH_SUB(READ_WRITE(_gspace))
  
  call h5fopen_f(sFileName, H5F_FILE_ACCESS, hidFile, iError)
  call HDF5_READ_WRITE(_int)(hidFile, '/mf_header/gspace/ng', gvec%ng, iError)
  call HDF5_READ_WRITE(_double)(hidFile, '/mf_header/gspace/ecutrho', gvec%ecutrho, iError)
  call HDF5_READ_WRITE(_int_array)(hidFile, '/mf_header/gspace/FFTgrid', (/3/), gvec%FFTgrid, iError)
  call h5fclose_f(hidFile, iError)
  
  POP_SUB(READ_WRITE(_gspace))
end subroutine READ_WRITE(_gspace)

subroutine NAME(_gvectors)(sFileName, ng, gvec)
  character(len=*), intent(in) :: sFileName
  integer, intent(in) :: ng !< used size of array
  integer, intent(INTENT) :: gvec(:, :) !< (3, ng_bound)
  
  integer(HID_T) :: hidFile
  integer :: iError
  logical :: bcast_, dont_read_
  
  PUSH_SUB(NAME(_gvectors))
  
  dont_read_=.false.
  bcast_=.not. dont_read_
  
  if(peinf%inode == 0) then
    call h5fopen_f(sFileName, H5F_FILE_ACCESS, hidFile, iError)
    call HDF5_READ_WRITE(_int_array)(hidFile, '/mf_header/gspace/components', (/3,ng/), gvec, iError)
    call h5fclose_f(hidFile, iError)
  endif

#ifdef READ
#ifdef MPI
  if(peinf%npes > 1) then
    if(bcast_) then
      call MPI_BCAST(gvec(1,1), 3 * ng, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    endif
  endif
#endif
#endif
  
  POP_SUB(NAME(_gvectors))
end subroutine NAME(_gvectors)

subroutine READ_WRITE(_symmetry)(sFileName,syms)
  character(len=*), intent(in) :: sFileName
  type(symmetry), intent(INTENT) :: syms
  
  integer(HID_T) :: hidFile
  integer :: iError
  
  PUSH_SUB(READ_WRITE(_symmetry))
  
  call h5fopen_f(sFileName, H5F_FILE_ACCESS, hidFile, iError)
  call HDF5_READ_WRITE(_int)(hidFile, '/mf_header/symmetry/ntran', syms%ntran, iError)
  call HDF5_READ_WRITE(_int)(hidFile, '/mf_header/symmetry/cell_symmetry', syms%cell_symmetry, iError)
  call HDF5_READ_WRITE(_int_array)(hidFile, '/mf_header/symmetry/mtrx', (/3, 3, 48/), syms%mtrx, iError)
  call HDF5_READ_WRITE(_double_array)(hidFile, '/mf_header/symmetry/tnp', (/3, 48/), syms%tnp, iError)
  call h5fclose_f(hidFile, iError)
  
  POP_SUB(READ_WRITE(_symmetry))
end subroutine READ_WRITE(_symmetry)

subroutine READ_WRITE(_crystal)(sFileName,crys)
  character(len=*), intent(in) :: sFileName
  type(crystal), intent(INTENT) :: crys
  
  integer(HID_T) :: hidFile
  integer :: iError
  
  PUSH_SUB(READ_WRITE(_crystal))
  
  call h5fopen_f(sFileName, H5F_FILE_ACCESS, hidFile, iError)
  call HDF5_READ_WRITE(_double)(hidFile, '/mf_header/crystal/celvol', crys%celvol, iError)
  call HDF5_READ_WRITE(_double)(hidFile, '/mf_header/crystal/recvol', crys%recvol, iError)
  call HDF5_READ_WRITE(_double)(hidFile, '/mf_header/crystal/alat', crys%alat, iError)
  call HDF5_READ_WRITE(_double)(hidFile, '/mf_header/crystal/blat', crys%blat, iError)
  call HDF5_READ_WRITE(_int)(hidFile, '/mf_header/crystal/nat', crys%nat, iError)
  call HDF5_READ_WRITE(_double_array)(hidFile, '/mf_header/crystal/avec', (/3, 3/), crys%avec, iError)
  call HDF5_READ_WRITE(_double_array)(hidFile, '/mf_header/crystal/bvec', (/3, 3/), crys%bvec, iError)
  call HDF5_READ_WRITE(_double_array)(hidFile, '/mf_header/crystal/adot', (/3, 3/), crys%adot, iError)
  call HDF5_READ_WRITE(_double_array)(hidFile, '/mf_header/crystal/bdot', (/3, 3/), crys%bdot, iError)
  
#ifdef READ
  SAFE_ALLOCATE(crys%atyp, (crys%nat))
  SAFE_ALLOCATE(crys%apos, (3,crys%nat))
#endif
  
  call HDF5_READ_WRITE(_int_array)(hidFile, '/mf_header/crystal/atyp', (/crys%nat/), crys%atyp, iError)
  call HDF5_READ_WRITE(_double_array)(hidFile, '/mf_header/crystal/apos', (/3, crys%nat/), crys%apos, iError)
  call h5fclose_f(hidFile, iError)
  
  POP_SUB(READ_WRITE(_crystal))
end subroutine READ_WRITE(_crystal)

subroutine READ_WRITE(_kpoints)(sFileName,kp)
  character(len=*), intent(in) :: sFileName
  type(kpoints), intent(INTENT) :: kp
  
  integer(HID_T) :: hidFile
  integer :: iError
  
  PUSH_SUB(READ_WRITE(_kpoints))
  
  call h5fopen_f(sFileName, H5F_FILE_ACCESS, hidFile, iError)
  call HDF5_READ_WRITE(_int)(hidFile, '/mf_header/kpoints/nspin', kp%nspin, iError)
  call HDF5_READ_WRITE(_int)(hidFile, '/mf_header/kpoints/nrk', kp%nrk, iError)
  call HDF5_READ_WRITE(_int)(hidFile, '/mf_header/kpoints/mnband', kp%mnband, iError)
  call HDF5_READ_WRITE(_int)(hidFile, '/mf_header/kpoints/ngkmax', kp%ngkmax, iError)
  call HDF5_READ_WRITE(_double)(hidFile, '/mf_header/kpoints/ecutwfc', kp%ecutwfc, iError)
  call HDF5_READ_WRITE(_int_array)(hidFile, '/mf_header/kpoints/kgrid', (/3/), kp%kgrid, iError)
  call HDF5_READ_WRITE(_double_array)(hidFile, '/mf_header/kpoints/shift', (/3/), kp%shift, iError)
  
#ifdef READ
  SAFE_ALLOCATE(kp%ngk, (kp%nrk))
  SAFE_ALLOCATE(kp%ifmin, (kp%nrk, kp%nspin))
  SAFE_ALLOCATE(kp%ifmax, (kp%nrk, kp%nspin))
  SAFE_ALLOCATE(kp%w, (kp%nrk))
  SAFE_ALLOCATE(kp%rk, (3,kp%nrk))
  SAFE_ALLOCATE(kp%el, (kp%mnband,kp%nrk,kp%nspin))
  SAFE_ALLOCATE(kp%occ, (kp%mnband,kp%nrk,kp%nspin))
#endif
  
  call HDF5_READ_WRITE(_int_array)(hidFile, '/mf_header/kpoints/ngk', (/kp%nrk/), kp%ngk, iError)
  call HDF5_READ_WRITE(_int_array)(hidFile, '/mf_header/kpoints/ifmin', (/kp%nrk, kp%nspin/), kp%ifmin, iError)
  call HDF5_READ_WRITE(_int_array)(hidFile, '/mf_header/kpoints/ifmax', (/kp%nrk, kp%nspin/), kp%ifmax, iError)
  call HDF5_READ_WRITE(_double_array)(hidFile, '/mf_header/kpoints/w', (/kp%nrk/), kp%w, iError)
  call HDF5_READ_WRITE(_double_array)(hidFile, '/mf_header/kpoints/rk', (/3, kp%nrk/), kp%rk, iError)
  call HDF5_READ_WRITE(_double_array)(hidFile, '/mf_header/kpoints/el', (/kp%mnband, kp%nrk, kp%nspin/), kp%el, iError)
  call HDF5_READ_WRITE(_double_array)(hidFile, '/mf_header/kpoints/occ', (/kp%mnband, kp%nrk, kp%nspin/), kp%occ, iError)
  call h5fclose_f(hidFile, iError)
  
  POP_SUB(READ_WRITE(_kpoints))
end subroutine READ_WRITE(_kpoints)
#endif
! end read/write header



#undef READ_WRITE
#undef INTENT
#undef FLAVOR_INTENT
#undef NAME
#undef TEMP_SCALAR
#undef MPI_TEMP_SCALAR
#undef LONGNAME

#undef HDF5_READ_WRITE
#undef H5D_READ_WRITE
#undef H5F_FILE_ACCESS

!==============================================================================================
!
! Utilities:
!
! (1) sig2wan           Originally By gsm               Last Modified 2/12/2010 (gsm)
!
! This program converts Sigma output file sigma_hp.log and Wannier90 input
! file prefix.nnkp to Wannier90 input file prefix.eig. The k-points in the
! irreducible wedge (read from sigma_hp.log) are mapped to the k-points in
! the full Brillouin zone (read from prefix.nnkp) using symmetries of the
! space group of the crystal (read from sigma_hp.log). The quasiparticle
! eigenvalues (read from sigma_hp.log) for all the k-points in the full
! Brillouin zone are written to prefix.eig. This program requires input
! file sig2wan.inp in the working directory (an example follows below).
! This utility ignores off-diagonal Sigma matrix elements.
!
! sig2wan.inp:
!
! sigma_hp.log ! Sigma output file to read k-points, eigenvalues and symmetries from
! spin         ! spin component to read from sigma_hp.log file
! eqpn         ! set to 0 or 1 to read eqp0 or eqp1 from sigma_hp.log file
! prefix.nnkp  ! Wannier90 input file to read k-points from
! prefix.eig   ! file where the output of sig2wan is written
! nbands       ! number of bands to write out
!
!==============================================================================================

#include "f_defs.h"

program sig2wan

  use global_m
  use misc_m
  implicit none

  character*256, parameter :: finp = "sig2wan.inp"
  character*256 :: fsig,fnnkp,feig,tmpstr1,tmpstr2
  integer :: spin,eqpn,eof,is,ikr,ikf,ib,isym,nkr,nkf,nb,nsym
  integer :: i,j,g(3),sym(48,3,3)
  real(DP) :: elda,ecor,x,sx,ch,sig,vxc,eqp0,eqp1,k(3)
  logical :: reading_offdiags
  integer, allocatable :: f2r(:)
  real(DP), allocatable :: kr(:,:)
  real(DP), allocatable :: eig(:,:)
  real(DP), allocatable :: kf(:,:)

!-----------------------------
! read input file

  write(6,'(/,1x,"reading",1x,a,1x,"file",/)')TRUNC(finp)

  call open_file(55,file=TRUNC(finp),form='formatted',status='old')

  spin=0
  eqpn=-1
  read(55,*) fsig
  read(55,*) spin
  read(55,*) eqpn
  read(55,*) fnnkp
  read(55,*) feig
  read(55,*) nb

  call close_file(55)
  
  if (spin.ne.1.and.spin.ne.2) then
    call die('illegal spin value: only 1 or 2 allowed')
  endif
  if (eqpn.ne.0.and.eqpn.ne.1) then
    call die('illegal eqpn value: only 0 or 1 allowed')
  endif
  if (nb <= 0) then
    call die('illegal nbands value: must be positive')
  endif
  
  write(6,901) TRUNC(fsig), spin, eqpn, TRUNC(fnnkp), TRUNC(feig)

!-----------------------------
! read sig file

  write(6,'(1x,"reading",1x,a,1x,"file",/)')TRUNC(fsig)

  call open_file(55,file=TRUNC(fsig),form='formatted',status='old')

  nkr=0
  nsym=0
  eof=0
  do while(eof.eq.0)
    read(55,'(A)',iostat=eof)tmpstr1
    write(tmpstr2,'(A)')TRUNC(tmpstr1)
    if (len(trim(tmpstr2)).eq.0) cycle
    if (tmpstr2(1:14).eq."n = band index") exit
    if (tmpstr2(1:20).eq."frequency_dependence") cycle
    if (tmpstr2(1:10).eq."band_index") cycle
    if (tmpstr2(1:12).eq."sigma_matrix") cycle
    if (tmpstr2(1:17).eq."finite_difference") cycle
    if (tmpstr2(1:10).eq."symmetries") cycle
    if (tmpstr2(1:5).eq."ntran") then
      read(tmpstr2(9:11),*)nsym
      cycle
    endif
    if (tmpstr2(1:4).eq."mtrx") cycle
    if (tmpstr2(1:3).eq."k =") then
      read(tmpstr2(51:51),*)is
      if (is.eq.spin) nkr=nkr+1
      cycle
    endif
    if (tmpstr2(1:1).eq."e") cycle
    if (tmpstr2(1:1).eq."n") cycle
  enddo
  
  rewind(55)
  
  if (nkr.le.0) then
    call die('nkr <= 0')
  endif
  if (nb.le.0) then
    call die('nb <= 0')
  endif
  if (nsym.le.0) then
    call die('nsym <= 0')
  endif
  
  SAFE_ALLOCATE(kr, (3,nkr))
  SAFE_ALLOCATE(eig, (nb,nkr))
  kr(:,:)=0.0d0
  eig(:,:)=0.0d0
  sym(:,:,:)=0
  
  ikr=0
  eof=0
  reading_offdiags = .false.
  do while(eof.eq.0)
    read(55,'(A)',iostat=eof)tmpstr1
    write(tmpstr2,'(A)')TRUNC(tmpstr1)
    if (len(trim(tmpstr2)).eq.0) cycle
    if (tmpstr2(1:14).eq."n = band index") exit
    if (tmpstr2(1:20).eq."frequency_dependence") cycle
    if (tmpstr2(1:10).eq."band_index") cycle
    if (tmpstr2(1:12).eq."sigma_matrix") cycle
    if (tmpstr2(1:17).eq."finite_difference") cycle
    if (tmpstr2(1:10).eq."symmetries") cycle
    if (tmpstr2(1:5).eq."ntran") cycle
    if (tmpstr2(1:4).eq."mtrx") then
      read(tmpstr2(5:6),*)isym
      read(tmpstr2(9:),*)((sym(isym,i,j),i=1,3),j=1,3)
      cycle
    endif
    if (tmpstr2(1:3).eq."k =") then
      read(tmpstr2(51:51),*)is
      if (is.eq.spin) then
        ikr=ikr+1
        read(tmpstr2(4:33),*)(kr(i,ikr),i=1,3)
      endif
      reading_offdiags = .false.
      cycle
    endif
    if (tmpstr2(1:1).eq."e") cycle
    if (tmpstr2(1:13).eq."n        elda") cycle
    if (tmpstr2(1:9).eq."n   m   l") then
      reading_offdiags = .true.
      cycle
    endif
    if (is.eq.spin .and. .not. reading_offdiags) then
      read(tmpstr2,*)ib,elda,ecor,x,sx,ch,sig,vxc,eqp0,eqp1
      if(ib <= nb) then
        if (eqpn.eq.0) eig(ib,ikr)=eqp0
        if (eqpn.eq.1) eig(ib,ikr)=eqp1
      endif
    endif
  enddo
  
  call close_file(55)
  
  write(tmpstr1,*)nkr
  write(6,'(11x,"nkr =",1x,a)') TRUNC(tmpstr1)
  write(tmpstr1,*)nb
  write(6,'(12x,"nb =",1x,a)') TRUNC(tmpstr1)
  write(tmpstr1,*)nsym
  write(6,'(10x,"nsym =",1x,a,/)') TRUNC(tmpstr1)

!-----------------------------
! read nnkp file

  write(6,'(1x,"reading",1x,a,1x,"file",/)')TRUNC(fnnkp)
  
  call open_file(55,file=TRUNC(fnnkp),form='formatted',status='old')
  
  i=0
  ikf=0
  nkf=0
  eof=0
  do while(eof.eq.0)
    read(55,'(A)',iostat=eof)tmpstr1
    write(tmpstr2,'(A)')TRUNC(tmpstr1)
    if (len(trim(tmpstr2)).eq.0) cycle
    if (i.eq.2) then
      ikf=ikf+1
      read(tmpstr2,*)(kf(j,ikf),j=1,3)
      if (ikf.eq.nkf) i=0
      cycle
    endif
    if (i.eq.1) then
      read(tmpstr2,*)nkf
      SAFE_ALLOCATE(kf, (3,nkf))
      kf(:,:)=0.0d0
      i=2
      cycle
    endif
    if (tmpstr2(1:13).eq."begin kpoints") i=1
  enddo
  
  if (nkf.le.0) then
    call die('nkf <= 0')
  endif
  
  call close_file(55)
  
  write(tmpstr1,*)nkf
  write(6,'(11x,"nkf =",1x,a,/)') TRUNC(tmpstr1)

!-----------------------------
! unfold irreducible wedge

  write(6,'(1x,"unfolding irreducible wedge",/)')

  SAFE_ALLOCATE(f2r, (nkf))
  f2r(1:nkf) = 0
  
  do ikf = 1, nkf
    ikr_do: do ikr = 1, nkr
      do isym = 1, nsym
        k(1:3) = matmul(sym(isym, 1:3, 1:3), kr(1:3, ikr))
        !First check without folding and then fold
        if (all(abs(k(1:3) - kf(1:3, ikf)) .lt. TOL_Small)) then
          f2r(ikf) = ikr
          exit ikr_do
        endif
        call k_range(k, g, TOL_Small)
        if (all(abs(k(1:3) - kf(1:3, ikf)) .lt. TOL_Small)) then
          f2r(ikf) = ikr
          exit ikr_do
        endif
      enddo
    enddo ikr_do
    
    if (f2r(ikf) .eq. 0) then
      write(tmpstr1,'(a,i6)') "no match for ikf = ", ikf
      call die(tmpstr1)
    endif
  enddo
      
!-----------------------------
! write eig file

  write(6,'(1x,"writing",1x,a,1x,"file",/)')TRUNC(feig)
  
  call open_file(55,file=TRUNC(feig),form='formatted',status='replace')
  do ikf=1,nkf
    ikr=f2r(ikf)
    do ib=1,nb
      write(55,'(2i5,f18.12)') ib,ikf,eig(ib,ikr)
    enddo
  enddo
  
  call close_file(55)

!-----------------------------
! deallocate and finish

  SAFE_DEALLOCATE(kr)
  SAFE_DEALLOCATE(eig)
  SAFE_DEALLOCATE(kf)
  SAFE_DEALLOCATE(f2r)
  
901 FORMAT(6x,"sig file =",1x,a,/,10x,"spin =", &
      1x,i1,/,10x,"eqpn =",1x,i1,/,5x,"nnkp file =", &
      1x,a,/,6x,"eig file =",1x,a,/)
  
end program sig2wan

!-------------------------------------------------------------------------------
!
!   kgrid.f90
!   kgrid.x kgrid.in kgrid.out kgrid.log
!   Generates a list of k-points with a small q-shift for espresso input file
!   inspired by espresso-3.2.3/pwtools/kpoints.f
!   written by G. Samsonidze (March 2008)
!
!-------------------------------------------------------------------------------
!
!   See kgrid.inp for input file description.
!
!-------------------------------------------------------------------------------
!
!   kgrid generates k-points in the irreducible wedge of the Brillouin
!   zone with the symmetries of the space group of the crystal (for real
!   and complex versions of GW) and also with time-reversal symmetry
!   (for DFT) where real and complex stand for systems with and without
!   inversion symmetry.
!
!   Set trs to .true. for DFT and to .false. for complex version of GW
!   (it does not matter for real version of GW since inversion symmetry
!   takes k to -k same way as time-reversal symmetry).
!
!   Time-reversal symmetry is not currently implemented in BerkeleyGW.
!
!   If a non-zero q-shift is given, the irreducible wedge is unfolded with all
!   the symmetries of the space group of the crystal and folded back to the
!   irreducible wedge with the symmetries of a subgroup of the q-vector.
!
!   If some of the fractional translations are not commensurate with
!   the FFT grid, the corresponding symmetries of the space group of
!   the crystal will be dropped; you can skip FFT grid check by setting
!   (nr1 nr2 nr3) to (0 0 0).
!
!   Set number of atoms to 0 and skip atomic species and positions
!   to use the symmetries of the space group of the Bravais lattice.
!
!   Note that the units of dqj are nkj times the units of dkj (j=1,2,3)
!   according to convention inherited from PARATEC.
!
!   In the case of supercell calculation espresso generates additional
!   k-points; to use the list of k-points from espresso input file as is
!   set calculation to 'bands' rather than 'nscf' in namelist control in
!   espresso input file; note that in this case occupations in espresso
!   will be set to zero, so you will have to use flags wfng_occupation,
!   wfng_nvmin, and wfng_nvmax in pw2bgw input file,
!
!   If you set flag nosym in namelist system in espresso input file
!   to .true. there will be no symmetries written to WFN file which
!   means you will have to use the full Brillouin zone instead of
!   the irreducible wedge.
!
!   To use the k-point grid automatically generated by espresso
!   for complex version of GW set flag noinv in namelist system
!   in espresso input file to .true. (this disables the use of
!   time-reversal symmetry in k-point generation).
!
!-------------------------------------------------------------------------------

#include "f_defs.h"

program kgrid

  use global_m
  use kgrid_routines_m
  use misc_m
  use symmetries_m
  implicit none

  logical :: trs,trs_dq,dqflag,symr(48),syms(48),output_cartesian,output_octopus
  integer :: i,j,i1,i2,i3,ierr,ierr2,ia,na,ikf,nkf,nkfq,ikr,nkr,ikq, &
    nkq,nrb,irc,nrc,nrn,irr,nrr,nrq,cell_symmetry,nk(3),nfft(3),nfft_zero(3), &
    rb(3,3,48),rc(3,3,48),rn(3,3,48),rq(3,3,48),c2b(48),gpt(3),no_as(1),spacegroup_b,spacegroup_c,spacegroup_n
  real(DP) :: celvol,al,bl,dk(3),dq(3),a(3,3),b(3,3),no_ap(3,1),tnp_b(3,48),tnp_c(3,48),tnp_n(3,48)
  character*256 :: fi,fo,fl
  character*21 :: symbol_b, symbol_c, symbol_n

  integer, allocatable :: as(:)
  real(DP), allocatable :: ap(:,:),ap_lat(:,:)
  real(DP), allocatable :: kpoint(:,:)
  integer, allocatable :: kweight(:)
  integer, allocatable :: kfold(:)
  integer, allocatable :: ksymmetry(:)
  integer, allocatable :: kindex(:)
  real(DP), allocatable :: kr(:,:)
  real(DP), allocatable :: kw(:)
  real(DP), allocatable :: kf(:,:)
  real(DP), allocatable :: kfw(:)
  real(DP), allocatable :: kq(:,:)
  real(DP), allocatable :: kqw(:)

  output_cartesian = .false. ! default
  output_octopus = .false. ! default

  if (iargc().ne.3) then
    call die("USAGE: kgrid.x kgrid.in kgrid.out kgrid.log")
  else
    call getarg(1,fi)
    call getarg(2,fo)
    call getarg(3,fl)
  endif
  
  call open_file(21,file=TRUNC(fi),status='old')
  read(21,*,iostat=ierr)nk
  if (ierr.eq.0) read(21,*,iostat=ierr)dk
  if (ierr.eq.0) read(21,*,iostat=ierr)dq
  dqflag = (any(abs(dq(1:3)) > TOL_Zero))
  do i=1,3
    if (ierr.eq.0) read(21,*,iostat=ierr)(a(j,i),j=1,3)
  enddo
  na=0
  if (ierr.eq.0) read(21,*,iostat=ierr)na
  if (na.gt.0) then
    SAFE_ALLOCATE(as, (na))
    SAFE_ALLOCATE(ap, (3,na))
    SAFE_ALLOCATE(ap_lat, (3,na))
  endif
  do ia=1,na
    if (ierr.eq.0) read(21,*,iostat=ierr)as(ia),(ap(i,ia),i=1,3)
  enddo
  if (ierr.eq.0) read(21,*,iostat=ierr)(nfft(i),i=1,3)
  if (ierr.eq.0) read(21,*,iostat=ierr)trs
  if (ierr.eq.0) read(21,*,iostat=ierr2)output_cartesian ! this one is optional
  if (ierr2.eq.0) read(21,*,iostat=ierr2)output_octopus ! this one is optional
  if (ierr.eq.0) call close_file(21)
  if (ierr.ne.0) call die("Reading " // TRUNC(fi) // " failed.")
  
  if (any(nk(1:3) <= 0)) call die("kgrid must be > 0.")
  if (na < 0) call die("Number of atoms must be >= 0.")
  if (any(nfft(1:3) < 0)) call die("FFT grid must be >= 0.")
  
  nkf=nk(1)*nk(2)*nk(3)
  SAFE_ALLOCATE(kpoint, (3,nkf))
  SAFE_ALLOCATE(kweight, (nkf))
  SAFE_ALLOCATE(kfold, (nkf))
  SAFE_ALLOCATE(ksymmetry, (nkf))
  SAFE_ALLOCATE(kindex, (nkf))
  
  al = sqrt(a(1,1)**2 + a(2,1)**2 + a(3,1)**2)
  a(:,:) = a(:,:) / al
  celvol = a(1,1) * (a(2,2) * a(3,3) - a(2,3) * a(3,2)) - &
    a(2,1) * (a(1,2) * a(3,3) - a(1,3) * a(3,2)) + &
    a(3,1) * (a(1,2) * a(2,3) - a(1,3) * a(2,2))
  celvol = abs(celvol)
  if (celvol.le.TOL_Zero.or.celvol.ge.INF) call die("cell volume is <= 0 or infinite.")
  bl = 2.0d0 * PI_D / al
  b(1,1) = (a(2,2) * a(3,3) - a(3,2) * a(2,3)) / celvol
  b(2,1) = (a(3,2) * a(1,3) - a(1,2) * a(3,3)) / celvol
  b(3,1) = (a(1,2) * a(2,3) - a(2,2) * a(1,3)) / celvol
  b(1,2) = (a(2,3) * a(3,1) - a(3,3) * a(2,1)) / celvol
  b(2,2) = (a(3,3) * a(1,1) - a(1,3) * a(3,1)) / celvol
  b(3,2) = (a(1,3) * a(2,1) - a(2,3) * a(1,1)) / celvol
  b(1,3) = (a(2,1) * a(3,2) - a(3,1) * a(2,2)) / celvol
  b(2,3) = (a(3,1) * a(1,2) - a(1,1) * a(3,2)) / celvol
  b(3,3) = (a(1,1) * a(2,2) - a(2,1) * a(1,2)) / celvol
  celvol = abs(celvol) * al**3

  call open_file(23,file=TRUNC(fl),status='replace')

  ! Find symmetries of the empty Bravais lattice
  no_as(1) = 0        ! dummy species
  no_ap(1:3, 1) = 0d0 ! dummy atom at origin
  call get_symmetries(1, no_as, no_ap, a, nfft, cell_symmetry, nrb, rb, tnp_b, spacegroup_b, symbol_b)

  ! Find symmetries of the actual crystal with atoms
  if (na.gt.0) then
    ap_lat = matmul(transpose(b),ap) / al ! convert to crystal coords

    ! first, with FFT grid = 0
    nfft_zero(1:3) = 0
    call get_symmetries(na, as, ap_lat, a, nfft_zero, cell_symmetry, nrn, rn, tnp_n, spacegroup_n, symbol_n)

    ! then, with FFT grid as given in input
    call get_symmetries(na, as, ap_lat, a, nfft, cell_symmetry, nrc, rc, tnp_c, spacegroup_c, symbol_c)
  else
    nrc = nrb
    rc = rb
  endif

  ! Originally, c2b was used to map crystal symmetries to Bravais symmetries
  ! for writing into the log file. Here the mapping is disabled, hence the
  ! log file contains the indices of crystal symmetries instead of Bravais.
  do irc = 1, nrc
    c2b(irc) = irc
  enddo

  if(output_cartesian) then
    write(23,'(a)') 'k-points are in Cartesian coordinates'
  else
    write(23,'(a)') 'k-points are in crystal coordinates'
  endif
  if(trs) then
    write(23,'(a)') 'time-reversal symmetry is being used'
    write(0,'(a)') 'WARNING: you will need to run the wfn_time_reversal.x utility to unfold'
    write(0,'(a)') 'a WFN file generated with this k-grid before you can run BerkeleyGW.'
  endif
  write(23,'("nk(3) =",1x,3i5)')nk
  write(23,'("dk(3) =",1x,3f13.9)')dk
  if(dqflag) then
    write(23,'("dq(3) =",1x,3f13.9)')dq
  endif
  write(23,'(a)')
  write(23,'("direct lattice vectors")')
  do i=1,3
    write(23,'("a",i1," =",1x,3f13.9)')i,(al*a(j,i),j=1,3)
  enddo
  write(23,'(a)')
  write(23,'("unit cell volume =",1x,e16.9)')celvol
  write(23,'(a)')
  write(23,'("reciprocal lattice vectors")')
  do i=1,3
    write(23,'("b",i1," =",1x,3f13.9)')i,(bl*b(j,i),j=1,3)
  enddo
  call write_sym("of the Bravais lattice", symbol_b, nrb, rb, tnp_b, spacegroup = spacegroup_b)
  if (na.gt.0) then
    call write_sym("of the crystal without FFT grid", symbol_n, nrn, rn, tnp_n, spacegroup = spacegroup_n)
    if(any(nfft(1:3) /= 0)) then
      write(23,'(/,a,3i6)') 'FFT grid: ', nfft(1:3)
      call write_sym("of the crystal with FFT grid", symbol_c, nrc, rc, tnp_c, spacegroup = spacegroup_c)
    endif
  endif

  ikf=0
  do i1=0,nk(1)-1
    do i2=0,nk(2)-1
      do i3=0,nk(3)-1
        ikf=ikf+1
        kpoint(1,ikf)=(dble(i1)+dk(1))/dble(nk(1))
        kpoint(2,ikf)=(dble(i2)+dk(2))/dble(nk(2))
        kpoint(3,ikf)=(dble(i3)+dk(3))/dble(nk(3))
        call k_range(kpoint(:,ikf),gpt,TOL_Zero)
        kweight(ikf)=1
        kfold(ikf)=0
        ksymmetry(ikf)=0
      enddo
    enddo
  enddo
  nkf=ikf
  call fold(nkf,kpoint,kweight,kfold,ksymmetry,nrc,rc,trs,TOL_Zero)
  ikr=0
  do ikf=1,nkf
    if (kweight(ikf).gt.0) ikr=ikr+1
  enddo
  nkr=ikr
  call sort(nkf,nkr,kpoint,kweight,kindex,TOL_Zero)
  call reduce(nkf,kweight,kfold)
  SAFE_ALLOCATE(kr, (3,nkr))
  SAFE_ALLOCATE(kw, (nkr))
  do ikr=1,nkr
    kr(:, ikr) = kpoint(:, kindex(ikr))
    kw(ikr) = kweight(kindex(ikr))
  enddo

  irr=0
  do irc=1,nrc
    symr(irc)=.false.
    do ikf=1,nkf
      if (ksymmetry(ikf).eq.irc) symr(irc)=.true.
    enddo
    if (symr(irc)) irr=irr+1
  enddo
  nrr=irr

  if (nkr.lt.nkf) then
    write(23,'(a)')
    write(23,'("symmetries that reduce the k-points")')
    do irc=1,nrc
      if (symr(irc)) then
        write(23,'("r",i2.2," =",2x,3i4,2x,3i4,2x,3i4)') &
          c2b(irc),((rc(j,i,irc),j=1,3),i=1,3)
      endif
    enddo
    if (nrr.eq.0) write(23,'("none")')
  endif
  
  if (dqflag) then
    ! allocate to a simple upper bound of the number of k-points to unfold to
    nkfq=nkr*nrc
    ! even with time-reversal symmetry, there can be a maximum of 48 symmetries
    if(trs) nkfq = min(nkfq * 2, nkr * 48)
    SAFE_ALLOCATE(kf, (3,nkfq))
    SAFE_ALLOCATE(kfw, (nkfq))

    call dqunfold(nkr,kr,nkfq,kf,kfw,nrc,rc,trs,TOL_Zero)
    call dqsubgrp(dq,nrc,rc,nrq,rq,syms,trs_dq,TOL_Zero)
    if(.not. trs) trs_dq = .false.

    write(23,'(a)')
    write(23,'("symmetries of a subgroup of the q-vector")')
    do irc=1,nrc
      if (syms(irc)) then
        write(23,'("r",i2.2," =",2x,3i4,2x,3i4,2x,3i4)') &
          c2b(irc),((rc(j,i,irc),j=1,3),i=1,3)
      endif
    enddo
    if (nrq.eq.0) write(23,'("none")')

    ! another upper bound: the folded number can be no more than the unfolded number
    nkq=nkfq
    SAFE_ALLOCATE(kq, (3,nkq))
    SAFE_ALLOCATE(kqw, (nkq))

    call dqfold(nkfq,kf,kfw,nkq,kq,kqw,nrq,rq,trs_dq,TOL_Zero)
    call dqsort(nkfq,kf,kfw,TOL_Zero)
    call dqsort(nkq,kq,kqw,TOL_Zero)
    do ikf=1,nkfq
      kf(1:3,ikf)=kf(1:3,ikf)+dq(1:3)
    enddo
    do ikq=1,nkq
      kq(1:3,ikq)=kq(1:3,ikq)+dq(1:3)
    enddo

    call open_file(22,file=TRUNC(fo),status='replace')
    if(output_octopus) then
      call write_octopus(22, nkq, kq, kqw, nk, dk + dq * nk)
    else
      call write_espresso(22, nkq, kq, kqw)
    endif
  else
    call open_file(22,file=TRUNC(fo),status='replace')
    if(output_octopus) then
      call write_octopus(22, nkr, kr, kw, nk, dk)
    else
      call write_espresso(22, nkr, kr, kw)
    endif
  endif
  call close_file(22)
  
  write(23,'(a)')
  write(23,'("k-points in the original uniform grid")')
  write(23,'(i7)')nkf
  do ikf=1,nkf
    if(output_cartesian) kpoint(1:3, ikf) = bl * matmul(b(1:3, 1:3), kpoint(1:3, ikf))

    if (kfold(ikf).eq.0) then
      write(23,'(i7,3f13.9,f6.1,1x,i7,2x,"---")')ikf, &
        (kpoint(j,ikf),j=1,3),dble(kweight(ikf)),0
    else
      if (ksymmetry(ikf).eq.0) then
        write(23,'(i7,3f13.9,f6.1,1x,i7,2x,"r",i2.2)')ikf, &
          (kpoint(j,ikf),j=1,3),dble(kweight(ikf)), &
          kfold(ikf),c2b(ksymmetry(kfold(ikf)))
      else
        write(23,'(i7,3f13.9,f6.1,1x,i7,2x,"r",i2.2)')ikf, &
          (kpoint(j,ikf),j=1,3),dble(kweight(ikf)), &
          kfold(ikf),c2b(ksymmetry(ikf))
      endif
    endif
  enddo
  write(23,'(a)')
  write(23,'("k-points in the irreducible wedge")')
  write(23,'(i7)')nkr
  do ikr=1,nkr
    if(output_cartesian) kr(1:3, ikr) = bl * matmul(b(1:3, 1:3), kr(1:3, ikr))
    write(23,'(i7,3f13.9,f6.1,1x,i7)')ikr,kr(1:3,ikr),dble(kw(ikr)),kindex(ikr)
  enddo
  if (dqflag) then
    write(23,'(a)')
    write(23,'("k-points in the unfolded Brillouin Zone")')
    write(23,'(i7)')nkfq
    do ikf=1,nkfq
      if(output_cartesian) kf(1:3, ikf) = bl * matmul(b(1:3, 1:3), kf(1:3, ikf))
      write(23,'(i7,3f13.9,f6.1)')ikf,(kf(j,ikf),j=1,3),1.0d0
    enddo
    write(23,'(a)')
    write(23,'("k-points folded with the symmetries of a subgroup of the q-vector")')
    write(23,'(i7)')nkq
    do ikq=1,nkq
      if(output_cartesian) kq(1:3, ikq) = bl * matmul(b(1:3, 1:3), kq(1:3, ikq))
      write(23,'(i7,3f13.9,f6.1)')ikq,(kq(j,ikq),j=1,3),kqw(ikq)
    enddo
  endif
  write(23,'(a)')
  call close_file(23)
  
  if (na.gt.0) then
    SAFE_DEALLOCATE(as)
    SAFE_DEALLOCATE(ap)
  endif
  SAFE_DEALLOCATE(kpoint)
  SAFE_DEALLOCATE(kweight)
  SAFE_DEALLOCATE(kfold)
  SAFE_DEALLOCATE(ksymmetry)
  SAFE_DEALLOCATE(kindex)
  if (dqflag) then
    SAFE_DEALLOCATE(kr)
    SAFE_DEALLOCATE(kf)
    SAFE_DEALLOCATE(kfw)
    SAFE_DEALLOCATE(kq)
    SAFE_DEALLOCATE(kqw)
  endif
  
end program kgrid

#include "f_defs.h"

!*************************************************************************
Module LatticeMod
!*************************************************************************
! This module contains information on the lattice.
! The Lattice portion contains information on the direct and reciprocal 
!   Bravais lattices.
!*************************************************************************
! The module contains the public functions:
!    LatticeInit           allocates arrays; reads lattice constant and vectors;
!                          calculates reciprocal lattice, metric tensors
!    LatticeDestroy        deallocates arrays for the dynamic variables 
!*************************************************************************
! The module contains the public variables:
!    latticeConst          scale factor for lengths
!    aLatVec(i,j)          i-th component of the (scaled) j-th lattice vector
!    aLatVecLen(j)         length of the j-th lattice vector (a.u.)
!    aLatMetricTensor(i,j) = aLatMetricTensor(j,i) metric tensor in
!                          real space, used to scale the integer multiples
!                          of the reciprocal lattice vectors into real values
!    bLatVec(i,j)          i-th component of the j-th reciprocal lattice vector
!    bLatVecLen(j)         length of the j-th reciprocal lattice vector
!    bLatMetricTensor(i,j) = bLatMetricTensor(j,i): metric tensor in
!                          reciprocal space, used to scale the integer multiples
!                          of the reciprocal lattice vectors into real values
!*************************************************************************
! The module contains the private functions:
!    InvertMatrix(a)    returns the inverse of a.
!*************************************************************************
  
  use SysParams, only : double
  use push_pop_m
  implicit none

  type LatticeT
    real(double)             :: latticeConst
    real(double),    pointer :: aLatVec(:,:)
    real(double),    pointer :: aLatVecLen(:)
    real(double),    pointer :: aLatMetricTensor(:,:)
    real(double),    pointer :: bLatVec(:,:)
    real(double),    pointer :: bLatVecLen(:)
    real(double),    pointer :: bLatMetricTensor(:,:)
  end type LatticeT

  contains

!*************************************************************************
  Subroutine LatticeInit( lattice, ndim, tagHandler )
!*************************************************************************

    use TagHandlerMod,    only : FindTag, StringCompare, tagHandlerT
    use SysParams,     only : one, twopi, bohr2ang, double

    implicit none

    type( LatticeT ),    pointer :: lattice
    type( tagHandlerT ), pointer :: tagHandler
    integer, intent(in)  :: ndim

    integer :: i, error
    character :: c
    character(80) :: buff
    logical :: default
    real( double ) :: temp

    PUSH_SUB(LatticeInit)
    if( associated( lattice )) stop 'Error: lattice already associated.'

    allocate( lattice, stat = error )

    if( error /= 0 ) stop 'Error allocation lattice.'

    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Allocate space for the lattice vectors, the reciprocal lattice
    ! vectors, and the metric tensor.
    allocate( lattice%aLatVec(ndim,ndim), &
            & lattice%bLatVec(ndim,ndim), &
            & lattice%aLatMetricTensor(ndim,ndim), &
            & lattice%bLatMetricTensor(ndim,ndim), &
            & lattice%aLatVecLen(ndim), lattice%bLatVecLen(ndim), &
            & stat = error)

    if(error /= 0) stop 'Error allocating vector space in LatticeInit.'
    ! Allocation succeeded.
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Read in the lattice constant.  If there is no lattice constant in
    ! the input file or if there is an error reading it then the default
    ! value of 1.0d0 will be used.

    print *, 'Lattice Constant = scale factor for lengths'
    default = .True.

    temp = 1.0D0
    call FindTag( tagHandler, 'LatticeConstantFormat', error)
    if(error .eq. 0) then
      read(unit = tagHandler%fileno, fmt = '(A)', iostat = error) buff
      if (error .eq. 0) then
        if (StringCompare(buff, 'Angstrom')) temp = bohr2ang
      endif
    endif

    call FindTag( tagHandler, 'LatticeConstant', error)
    if(error .eq. 0) then
      read(unit = tagHandler%fileno, fmt = *, iostat = error) lattice%latticeConst

      if(error .eq. 0) then
        lattice%latticeConst = lattice%latticeConst / temp
        print *, 'LatticeConstant ', lattice%latticeConst
        default = .False.
      end if

    end if

    if(default) then
      lattice%latticeConst = one
      print *, 'Using default value of LatticeConstant 1.0.'
    end if
    ! latticeConst has been initialized
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Read in the lattice vectors and scale them by the lattice constant.
    ! Calculate the lengths of the lattice vectors.
    ! If the lattice vectors are missing or there is an error reading them
    ! the program will halt.

    call FindTag( tagHandler, 'LatticeVectors', error)
    print *, 'Lattice Vectors as read in (unscaled) LatticeVectors'

    if(error .eq. 0) then ! read dummy variable c to start 

      ! folowing read staement on next line

      read(unit = tagHandler%fileno, fmt ='(A1)') c  

      do i = 1, ndim
        read(unit = tagHandler%fileno, fmt = *, iostat = error) lattice%aLatVec(:,i)
        if(error /= 0) stop 'Error, couldn''t read LatticeVector.'
        print *, lattice%aLatVec(:,i)
      end do

    else
      stop 'Error, could not find lattice%aLatVec.'
    endif

    lattice%aLatVec = lattice%latticeConst * lattice%aLatVec ! rescale lattice vectors

    lattice%aLatMetricTensor = matmul(TRANSPOSE(lattice%aLatVec),lattice%aLatVec)

    do i = 1, ndim         ! determine lattice vector lengths
      lattice%aLatVecLen(i) = SQRT(dot_product(lattice%aLatVec(:,i),lattice%aLatVec(:,i)))
    end do

    ! lattice%aLatVec and lattice%aLatVecLen has been initialized and scaled.
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Calculate the reciprocal lattice vectors using Invertmatrix.  Then
    ! calculate the metric tensor for the reciprocal lattice vectors.

    ! calculate reciprocal lattice
    lattice%bLatVec=twopi*TRANSPOSE(InvertMatrix(lattice%aLatVec))

    ! reciprocal space metric tensor
    lattice%bLatMetricTensor = matmul(TRANSPOSE(lattice%bLatVec),lattice%bLatVec)

    do i = 1, ndim          ! determine lattice vector lengths
      lattice%bLatVecLen(i) = SQRT(dot_product(lattice%bLatVec(:,i),lattice%bLatVec(:,i)))
    end do

    !  lattice%bLatVec and lattice%aLatMetricTensor have been initialized.
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    POP_SUB(LatticeInit)
  end Subroutine LatticeInit

!*************************************************************************
  Subroutine LatticeDestroy( lattice )
!*************************************************************************

! Deallocate space for the lattice information 

    implicit none

    type( LatticeT ), pointer :: lattice
    integer :: error

    PUSH_SUB(LatticeDestroy)

    deallocate(lattice%aLatVec, lattice%bLatVec, lattice%aLatMetricTensor, lattice%bLatmetricTensor, &
             & lattice%aLatVecLen, lattice%bLatVecLen, stat = error)
    deallocate(lattice, stat = error)
    if(error /= 0) stop 'Error deallocating in LatticeDestroy.'

    POP_SUB(LatticeDestroy)
  end Subroutine LatticeDestroy

!*************************************************************************
  Subroutine LatticePrint( lattice )
!*************************************************************************

    use SysParams,    only : twopi

    implicit none

    type( LatticeT ), pointer :: lattice

    PUSH_SUB(LatticePrint)

    print *, ' '
    print *, 'The scaled lattice vectors are:'
    print *, lattice%aLatVec
    print *, ' '
    print *, 'The reciprocal lattice vectors (in units of 2pi/a) are:'
    print *, lattice%bLatVec/twopi

    POP_SUB(LatticePrint)
  end Subroutine LatticePrint

!*************************************************************************
  Function InvertMatrix(m)
!*************************************************************************

    implicit none

    real(double), intent(in) :: m(3, 3)

    real(double) :: InvertMatrix(3, 3)

    real(double) :: a(3, 3)
    real(double) :: b

    PUSH_SUB(InvertMatrix)

    a(1, 1) =   m(2, 2) * m(3, 3) - m(2, 3) * m(3, 2)
    a(2, 1) = - m(2, 1) * m(3, 3) + m(2, 3) * m(3, 1)
    a(3, 1) =   m(2, 1) * m(3, 2) - m(2, 2) * m(3, 1)
    a(1, 2) = - m(1, 2) * m(3, 3) + m(1, 3) * m(3, 2)
    a(2, 2) =   m(1, 1) * m(3, 3) - m(1, 3) * m(3, 1)
    a(3, 2) = - m(1, 1) * m(3, 2) + m(1, 2) * m(3, 1)
    a(1, 3) =   m(1, 2) * m(2, 3) - m(1, 3) * m(2, 2)
    a(2, 3) = - m(1, 1) * m(2, 3) + m(1, 3) * m(2, 1)
    a(3, 3) =   m(1, 1) * m(2, 2) - m(1, 2) * m(2, 1)

    b = m(1, 1) * a(1, 1) + m(1, 2) * a(2, 1) + m(1, 3) * a(3, 1)

    if (abs(b) .lt. 1.0d-6) stop 'Singular Matrix in InvertMatrix.'

    InvertMatrix(1, 1) = a(1, 1) / b
    InvertMatrix(2, 1) = a(2, 1) / b
    InvertMatrix(3, 1) = a(3, 1) / b
    InvertMatrix(1, 2) = a(1, 2) / b
    InvertMatrix(2, 2) = a(2, 2) / b
    InvertMatrix(3, 2) = a(3, 2) / b
    InvertMatrix(1, 3) = a(1, 3) / b
    InvertMatrix(2, 3) = a(2, 3) / b
    InvertMatrix(3, 3) = a(3, 3) / b

    POP_SUB(InvertMatrix)
  end function InvertMatrix

end module LatticeMod

!==============================================================================
!
! Module:
!
! (1) vcoul_generator()     Originally by JRD   Last Modified: 06/21/2013 (FHJ)
!
!     Generates the (Truncated) Coulomb Interaction for all G at a particular
!     q.  Outputs what would be 8Pi/q^2 if not for truncation.
!
!==============================================================================

#include "f_defs.h"

module vcoul_generator_m

  use global_m
  use minibzaverage_m
  use random_m
  use trunc_cell_box_m
  use trunc_cell_box_d_m

  implicit none

  private

  public ::          &
    vcoul_generator, &
    destroy_qran

  real(DP), allocatable, private :: qran(:,:)
  integer, private :: ifirst = 1

contains

  !> FHJ: Calculates the (average) bare Coulomb interaction v(q+G) in Rydberg.
  !! This function uses different forms of v(q+G) (see below) depending on the
  !! dimensionality of the system and whether the potential is truncated. The
  !! Coulomb interaction is optionally averaged on the mini-BZ around the q
  !! vector, and the average screened interaction wcoul0 is also calculated for
  !! q->0 and G=0.
  !!
  !! Note: we use a special flag, peinf%jobtypeeval, to determine whether
  !! vcoul_generator should be a "dumb generator" (if jobtypeeval=0) or 
  !! "smart consumer" (if 1). The main reasons for this division are the following:
  !! 1) For sigma and absorption, the idea is that we are evaluating the
  !! "best estimate" for W(q=0) and v(q=0) for a given k-grid, using the known
  !! analytical limits for epsinv and performing a Monte Carlo integration to
  !! evaluate quantities such as <1/q^2>. Epsilon is always calculated with a
  !! finite but non-averaged v(q), and each program that calculates W determines
  !! if it`s necessary to performing such an averaging.
  !! 2) In sigma, we divide SX into (SX-X) + X, so we have to be consistent with
  !! the way we average the quantities v=<1/q^2> and w=<epsinv/q^2>. In particular,
  !! we "hack" v to make it consistent with W, otherwise the partition (SX-X) + X
  !! would not be correct for metals. We never perform these "hacks" on v(q) 
  !! if peinf%jobtypeeval=0.
  subroutine vcoul_generator(itruncflag, truncval, gvec, bdot, nfk, ncoul, &
    isrtq, iscreen, qvec, q0vec, vcoul, iwritecoul, iparallel, avgcut, &
    oneoverq, qgrid, epshead, work_scell, averagew, wcoul0, coulomb_mod)
    !> Truncation flag. The current supported options are:
    !! 0: No truncation (for 3D systems)
    !! 4: Wire truncation (for 1D systems)
    !! 5: Box truncation (for 0D systems)
    !! 6: Slab truncation (for 2D systems)
    integer, intent(in) :: itruncflag
    !> Used for spherical truncation only. 
    real(DP), intent(in) :: truncval(3) 
    !> G space containing the G-vectors used to calculate v(q+G)
    type (gspace), intent(in) :: gvec
    !> Metric of the reciprocal lattice
    real(DP), intent(in) :: bdot(3,3)
    !> FIXME This is used in 1D minibz average, and I`m not sure why!
    integer, intent(in) :: nfk
    !> Number of G vectors to calculate v(q+G)
    integer, intent(in) :: ncoul
    !> (ncoul) Indices of the G vectors from gvec which we are using to build v(q+G)
    integer, intent(in) :: isrtq(:)
    !> Screening type. 0 for semiconductor, 1 for graphene, 2 for metal
    integer, intent(in) :: iscreen
    !> The q vector that we use to calculate v(q+G).
    !! The null vector q=(/0,0,0/) is perfectly valid here.
    real(DP), intent(in) :: qvec(3)
    !> The q0 vector that was used in eps0mat, which can never be the null vector.
    real(DP), intent(in) :: q0vec(3)
    !> (ncoul) The output, 8*pi*<1/(q+G)^2> if there`s no truncation.
    real(DP), intent(out) :: vcoul(:)
    !> Write vcoul to a file?
    integer, intent(in) :: iwritecoul
    !> FIXME Not sure what 0 really means if you use MPI!
    integer, intent(in) :: iparallel
    !> If |q+G|^2 < avgcut, calculate <1/(q+G)^2>. Otherwise, calculate 1/(q+G)^2.
    !! The default value for avgcut is TOL_SMALL, i.e., average only done if G=0.
    real(DP), intent(in) :: avgcut
    !> Returns <1/q> or 1/q0
    real(DP), intent(out) :: oneoverq
    !> The q/k-grid being used, which determined the mini-BZ used to construct
    !! averages such as <1/(q+G)^2>
    integer, intent(in) :: qgrid(3)
    !> Head of epsilon^{-1}. Used to construct wcoul0.
    SCALAR, intent(in) :: epshead 
    !> FIXME A mysterious working buffer for "supercell box truncation"
    type (twork_scell), intent(inout) :: work_scell
    !! If .true., calculate W as <eps*v(q)>
    logical, intent(in) :: averagew
    !> If averagew==.true., wcoul0 is <epsinv*v(q)>. We use the analytical limit of
    !! epsinv(q->0) to perform the proper average. Examples:
    !! - For 3D semiconductors, epsinv(q->0)~const => wcoul0 = epsinv*vcoul(0)
    !! - For 3D metals, epsinv(q->0)~q^2 => wcoul0 = epsinv*8*pi/q0^2, where q0 is
    !! the same q used to evaluate epsinv(q->0).
    SCALAR, intent(inout) :: wcoul0
    !> Optional coulomb modifier parameters. Used in TDDFT and hybrid functional calculations
    !! they allow one to change the bare coulomb interaction. Can only 
    !! be used with no truncation 
    type(coulomb_modifier_t), optional, intent(in) :: coulomb_mod

    integer :: i1, i2, i3, ii, jj, nn, ig, nint, iCommFlag, iCommFlagGlobal
    integer :: gk(3), seed
    real(DP), allocatable :: vcoul2(:)
    real(DP) :: dvalue, temp_exp, screeninv
    real(DP) :: qk(3), qkxy(3), qlen, q0len, ekinx, kxy
    real(DP) :: kz, zc, qkz(3), dummy, qvec_mod(3)
    real(DP) :: dd(3),fq(3),vlength, lmin, qpp(3) 
    real(DP), allocatable :: ran(:,:)
    real(DP), allocatable :: qran2(:,:)

    real(DP), save :: oneoverq0
    real(DP), save :: vcoul0
    !> Depending on avg_cut, the code needs to average the potential in the
    !! miniBZ. The following flag is set to true after we calculated <v(q)> for
    !! q->0, so we can reuse that integral later for q=0.
    logical, save :: minibz_done = .false.
    !> It there`s no truncation, we also need to calculate the average <1/q>
    !! for the wings. The following flag is set to true after we calculated
    !! <1/q> for q->0.
    logical, save :: oneoverq0_done = .false.
    !> Depending on avg_cut, the code needs to average the modified potential in the
    !! miniBZ. The following flag is set to true after we calculated <v(q)> for
    !! q->0 for the modified potential, so we can reuse that integral later for q=0.
    !! This is separate from minibz_done because you may need to recalculate vcoul 
    !! without the modifier for the exchange part of the kernel etc.
    logical, save :: minibz_mod_done = .false.
    logical :: verbose

    PUSH_SUB(vcoul_generator)

#ifdef VERBOSE
    verbose = .true.
#else
    verbose = .false.
#endif

    if(size(isrtq) < ncoul) call die("vcoul_generator: isrtq not allocated to size ncoul")
    if(size(vcoul) < ncoul) call die("vcoul_generator: vcoul not allocated to size ncoul")

    if(ifirst == 2) call die("you destroyed qran already!")
    if(nfk == 0) call die("Illegal value nfk = 0 in vcoul_generator")

    iCommFlag = 0
    iCommFlagGlobal = 0

    vcoul = 0d0

    nint=100

    qlen  = sqrt(DOT_PRODUCT(qvec,MATMUL(bdot,qvec)))
    q0len = sqrt(DOT_PRODUCT(q0vec,MATMUL(bdot,q0vec)))
    
! JRD: If we have a metal then the divergent components of W cancel
!      and you get a constant.  Epsilon was calculated at q ~ q0vec
! MJ:  Not quite. We while W goes to a constant, V does not. See the
!      comment below about metals. Here we set the q to be qvec (i.e.
!      0 0 0) but later make sure we change W to be evaluated at this
!      q. We change epsiloninv such that epsinv*V(q0vec) = epsnewinv*V(q)
!      where V(q) is the averaged quantity.

    if (abs(qlen) .lt. TOL_Zero .and. iscreen .eq. 2 .and. peinf%jobtypeeval .eq. 1 .and. itruncflag .ne. 0) then
      qvec_mod = q0vec
    else
      qvec_mod = qvec
    endif
    
!------------------------------------------------------------------
! Generate random numbers for minibz averaging

    nn = nmc

    if (peinf%jobtypeeval .eq. 1 .and. ifirst .eq. 1 .and. &
     (itruncflag .eq. 0 .or. itruncflag .eq. 6)) then

      if (any(qgrid(1:3) .eq. 0)) then
        if(peinf%inode == 0) then
          write(0,*) 'Error qgrid', qgrid
          write(0,*) 'You must specify qgrid in .inp file'
        endif
        call die ('Zero qgrid. Cannot determine minibz', only_root_writes = .true.)
      endif

      SAFE_ALLOCATE(ran, (3,nn))

      if (peinf%inode .eq. 0) then
!     We require a fixed seed for reproducibility of our 'random' numbers.
!     call date_and_time(VALUES=values)
!     seed=((values(3)*24+values(5))*60+values(6))*60+values(7)
        seed = 5000
        call genrand_init(put=seed)
        do jj = 1, 3*nn
          call genrand_real4(dummy)
        enddo
        do jj = 1, nn
          do ii = 1, 3
            call genrand_real4(ran(ii, jj))
          enddo
        enddo
      endif
      
#ifdef MPI
!   Our 'random' numbers must be the same on all processors.
      call MPI_Bcast(ran, 3*nn, MPI_REAL_DP, 0, MPI_COMM_WORLD,mpierr)
#endif
      
      dd(1:3) = 1D0 / dble(qgrid(1:3))

      SAFE_ALLOCATE(qran, (3,nn))
      
      qran = 0D0
      
      do jj = 1, nn
        
        if (iparallel .eq. 1) then
          if (mod(jj,peinf%npes).ne.peinf%inode) cycle
!            write(12000+peinf%inode,*) jj, ran(:,jj)
        endif
        
        lmin = INF
        qpp(:) = ran(:,jj)

        do i1 = -ncell+1, ncell
          fq(1) = qpp(1) - dble(i1)
          do i2 = -ncell+1, ncell
            fq(2) = qpp(2) - dble(i2)
            do i3 = -ncell+1, ncell
              fq(3) = qpp(3) - dble(i3)
              vlength = DOT_PRODUCT(fq,MATMUL(bdot,fq))
              if (vlength .lt. lmin) then
                lmin = vlength
                qran(:,jj) = fq(:)
              endif
            enddo
          enddo
        enddo

        qran(1:3,jj)=dd(1:3)*qran(1:3,jj)

      enddo ! jj

      SAFE_DEALLOCATE(ran)

#ifdef MPI
      if (iparallel .eq. 1) then
        SAFE_ALLOCATE(qran2, (3,nn))
        qran2(:,:)=0D0
        call MPI_ALLREDUCE(qran(1,1),qran2(1,1),3*nn,MPI_REAL_DP, MPI_SUM, MPI_COMM_WORLD,mpierr)
        qran(:,:)=qran2(:,:)
        SAFE_DEALLOCATE(qran2)
      endif
#endif

    endif

!-------------------------------------------------------------------
! No Truncation

    if (itruncflag .eq. 0 .and. (.not. present(coulomb_mod))) then

! Calculate Wing Correction Factor - this is not done for Epsilon and Kernel
! since avgcut is zero and qvec_mod is not

      if (peinf%inode .eq. 0 .and. qlen**2 .lt. avgcut .and. peinf%jobtypeeval .eq. 1) then
        if (qlen**2 .gt. TOL_Zero .or. .not.oneoverq0_done) then
          call minibzaverage_3d_oneoverq(nn,bdot,dvalue,qran,qvec_mod)
          oneoverq=dvalue
          if (qlen**2 .le. TOL_Zero) then
            oneoverq0=dvalue
            oneoverq0_done = .true.
          endif
        else
          oneoverq=oneoverq0
        endif
      endif
      ! otherwise we set oneoverq a little later

      do ig=1,ncoul
        if (iparallel .eq. 1) then
          if(mod(ig-1,peinf%npes).ne.peinf%inode) cycle
        endif
        
        gk(:)=gvec%components(:,isrtq(ig))
        qk(:)=gk+qvec_mod(:)
        ekinx=DOT_PRODUCT(qk,MATMUL(bdot,qk))

! We Do 3D Mini Brillouin Zone Average if q is exactly 0
! and G = 0. This should be the case when constructing W,
! but don`t want this in Epsilon code for example, where you
! have to use a finite Q.

        if ( ekinx .lt. avgcut .and. peinf%jobtypeeval .eq. 1 ) then
          if (iscreen .eq. 0) then ! semiconductor
            if (ekinx .gt. TOL_Zero .or. .not.minibz_done) then
              call minibzaverage_3d_oneoverq2(nn,bdot,dvalue,qran,qk,averagew,epshead,wcoul0)
              vcoul(ig)=dvalue
              if (ekinx .le. TOL_Zero) then
                vcoul0=dvalue
                iCommFlag = peinf%inode+1
                minibz_done = .true.
              endif
            else
              vcoul(ig)=vcoul0
            endif

          elseif (iscreen .eq. 1) then ! graphene
            
            if (ekinx .gt. TOL_Zero .or. .not.minibz_done) then
              call minibzaverage_3d_oneoverq2(nn,bdot,dvalue,qran,qk,averagew,epshead,wcoul0)

              if (ekinx .lt. TOL_ZERO) then
                vcoul0=dvalue
                call minibzaverage_3d_oneoverq(nn,bdot,dvalue,qran,qk)
                if (q0len .lt. TOL_ZERO) then
                  write(0,'(a)') 'You have q0vec=0 but a graphene-type system!!'
                  call die('Bad q0vec', only_root_writes = .true.)
                endif
                wcoul0=epshead*dvalue/q0len
                iCommFlag = peinf%inode+1
                minibz_done = .true.
                vcoul(ig)=vcoul0
              else
! JRD: This seems wrong. We now use correct vcoul average.
!              vcoul(ig)=dvalue/sqrt(ekinx)
              endif
            else
              vcoul(ig)=vcoul0
            endif

          elseif (iscreen .eq. 2) then
! MJ : W(q->0) goes to a constant. But the COH term (as well as the
!      Fock term) also require V(q->0). It is simpler to see this in the 
!      context of the COH term in COHSEX which is 0.5*(W-V). Setting V(q->0)
!      based on the q0vec is dangerous because it just adds a constant to all
!      the quasiparticle levels. So we keep both of these quantities
!      at hand. This is only needed in the Sigma code.
             ! write(0,'(a)') 'You want cell averaging on a metal!!'
             ! write(0,'(a)') 'Specify q0vec and cell averaging will automatically'
             ! write(0,'(a)') 'be done for vcoul. Wcoul will use the q0vec that you'
             ! write(0,'(a)') 'specify!!'
             ! call die('Bad Screening Options', only_root_writes = .true.)
            if (ekinx .gt. TOL_Zero .or. .not.minibz_done) then
              call minibzaverage_3d_oneoverq2(nn,bdot,dvalue,qran,qk,averagew,epshead,wcoul0)

!      Keep in mind that while the vcoul average out of minibzaverage_3d_oneoverq2
!      is correct, wcoul0 is not. wcoul0 is just modified so that when multiplied
!      by vcoul it gives the correct result.
              !if (abs(ekinx-q0len) .lt. TOL_Zero) then
              if (ekinx .lt. TOL_Zero) then
                vcoul0=dvalue
                !wcoul0=epshead*(q0len*q0len)/(dvalue/8.0/PI_D)
                wcoul0=epshead*8.0*PI_D/(q0len*q0len)
                iCommFlag = peinf%inode+1
                minibz_done = .true.
                vcoul(ig)=vcoul0
              endif
            else
              vcoul(ig)=vcoul0
            endif

          endif

        else if (ekinx .lt. Tol_zero) then

! We are not in an evaluation job and were sent q=0, we don`t average. We just zero. The outside code should
! do something about this value.

          vcoul(ig) = 0D0

        else

! For metal - we already changed qvec_mod to q0vec above

          vcoul(ig) = 8.0d0*PI_D/ekinx
        endif
      enddo

      if (qlen**2 .ge. avgcut) then
        oneoverq=vcoul(1)*qlen
      endif

#ifdef MPI
      if (iparallel .eq. 1) then
        call MPI_Bcast(oneoverq, 1, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)

        SAFE_ALLOCATE(vcoul2, (ncoul))
        vcoul2(:)=0.0d0
        call MPI_ALLREDUCE(vcoul,vcoul2,ncoul, &
          MPI_REAL_DP, MPI_SUM, MPI_COMM_WORLD,mpierr)
        call MPI_ALLREDUCE(iCommFlag,iCommFlagGlobal,1, &
          MPI_INTEGER, MPI_SUM, MPI_COMM_WORLD,mpierr)
        if (iCommFlagGlobal .ne. 0) then
          minibz_done = .true.
          call MPI_BCAST(vcoul0,1,MPI_DOUBLE_PRECISION,iCommFlagGlobal-1, MPI_COMM_WORLD, mpierr)
          call MPI_BCAST(wcoul0,1,MPI_SCALAR,iCommFlagGlobal-1, MPI_COMM_WORLD, mpierr)
        endif
        vcoul(:)=vcoul2(:)
        SAFE_DEALLOCATE(vcoul2)
      endif
#endif

!--------------------------------------------------------------------
! Rectangular Box Truncation

    elseif (itruncflag .eq. 1) then
    
      call die('Rectangular Truncation is No Longer Supported', only_root_writes = .true.)
    
!------------------------------------------------------------------
! Spherical Truncation

    elseif (itruncflag .eq. 2 .and. (.not. present(coulomb_mod))) then
      
      do ig=1,ncoul
        qk(:)=gvec%components(:,isrtq(ig))+qvec_mod(:)
        ekinx=DOT_PRODUCT(qk,MATMUL(bdot,qk))
        if ( ekinx.lt.TOL_ZERO .and. peinf%jobtypeeval .eq. 1 ) then
          vcoul(ig)=8.0D0*PI_D*((truncval(1))**2)/2D0
        else if ( ekinx.lt.TOL_ZERO ) then
          vcoul(ig) = 0D0
        else
          vcoul(ig)=8.0d0*PI_D/ekinx* &
            (1.0d0-cos(truncval(1)*sqrt(ekinx)))
        endif
      enddo
      
      oneoverq=vcoul(1)*qlen
      wcoul0 = vcoul(1)


!------------------------------------------------------------------
! Cylindrical Box Truncation

    elseif (itruncflag .eq. 3) then

      call die('Cylindrical Truncation is No Longer Supported', only_root_writes = .true.)
      
!-----------------------------------------------------------------
! Cell Wire Truncation

    elseif (itruncflag .eq. 4) then
      
!    if (peinf%inode .eq. 0) then
!      write(6,*) 'Generating Vcoul_cell_wire with FFT'
!    endif

! JRD: This is hopefully temporary.  q=0 gives NaN
! because the log diverges in Eq. 5 of Ismail-Beigi paper.  
! For all G =/ 0, using the q0vec (small shifted vector) is 
! probably good enough.  
!
! JRD: This is now fixed in trunc_cell_wire where we use the scheme
! of Ismail-Beigi

      if (iparallel .eq. 1) then
        call trunc_cell_wire(gvec,verbose,peinf%inode, &
          peinf%npes,bdot,qvec_mod(3),ncoul,isrtq,vcoul)
      else
        call trunc_cell_wire(gvec,verbose,0, &
          1,bdot,qvec_mod(3),ncoul,isrtq,vcoul)
      endif

! We Do 1D Mini Brillouin Zone Average if q=0, G=0 or less than avgcut
! May not be implemented correctly for graphene-type system... I`m not even sure there is a system with linear DOS in 1D...

      if (iscreen .eq. 0) then ! semiconductor
        do ig=1,ncoul
          qk(:)=gvec%components(:,isrtq(ig))+qvec_mod(:)
          ekinx=DOT_PRODUCT(qk,MATMUL(bdot,qk))
          if ( ekinx .lt. avgcut .and. peinf%jobtypeeval .eq. 1) then 

            if (ekinx .gt. TOL_Zero .or. .not.minibz_done) then
              if (peinf%inode .eq. 0) then
                write(6,'(" minibz wire averaging for q =",3f8.3)') qk(1:3)
              endif
              call minibzaverage_1d(gvec,nfk,bdot,dvalue,iparallel,qk,epshead,q0len,averagew,wcoul0)
              vcoul(ig)=dvalue
              if (ekinx .lt. TOL_Zero) then
                vcoul0=dvalue
                minibz_done = .true.
              endif
            else
              vcoul(ig)=vcoul0
            endif
          else if (ekinx .lt. Tol_Zero) then
            vcoul(ig) = 0
          endif
        enddo
      endif

      if (peinf%inode .eq. 0) then
        write(6,*)
      endif

      oneoverq=vcoul(1)*qlen

!----------------------------------------------------------------
! Cell Box Truncation

    elseif (itruncflag .eq. 5) then
      
      if (qlen .gt. Tol_ZERO) then
        write(0,'(a)') 'You asked for cell box truncation but have more q-points than q=0!!'
        call die('Bad Truncation', only_root_writes = .true.)
      endif
      
      if (iparallel .eq. 1) then
        if (.not. present(coulomb_mod)) then
          call trunc_cell_box_d(gvec,verbose,peinf%inode, &
            peinf%npes,bdot,ncoul,isrtq,vcoul)
        endif
      else
        if (.not. present(coulomb_mod)) then
          call trunc_cell_box(gvec,verbose,bdot,ncoul,isrtq,vcoul)
        endif
      endif
      
      oneoverq=vcoul(1)*qlen
      wcoul0 = vcoul(1)

!----------------------------------------------------------------
! Cell Slab Truncation

! JRD: This is easy because an analytic expression exists.  See Sohrab.

    elseif (itruncflag .eq. 6) then
      
      if (abs(qvec_mod(3)) .gt. Tol_ZERO) then
        write(0,'(a)') 'You asked for cell slab truncation but have more q-points in z direction than qz=0!!'
        call die('Bad Truncation', only_root_writes = .true.)
      endif
      
      do ig=1,ncoul
        
        if (iparallel .eq. 1) then
          if(mod(ig,peinf%npes).ne.peinf%inode) cycle
        endif
        
        qk(:)=gvec%components(:,isrtq(ig))+qvec_mod(:)
        ekinx=DOT_PRODUCT(qk,MATMUL(bdot,qk))
        qkxy(1:2)=qk(1:2)
        qkxy(3)=0D0
        kxy=sqrt(DOT_PRODUCT(qkxy,MATMUL(bdot,qkxy)))
        qkz(1:2)=0D0
        qkz(3)=qk(3)
        kz=sqrt(DOT_PRODUCT(qkz,MATMUL(bdot,qkz)))
        zc=2D0*PI_D/(sqrt(bdot(3,3))*2D0)
        
!          write(6,*) "zc", zc

        if ( ekinx .lt. avgcut .and. peinf%jobtypeeval .eq. 1 ) then
          if (iscreen .ne. 2) then ! semiconductor or graphene
            if (ekinx .gt. TOL_Zero .or. .not.minibz_done) then
              call minibzaverage_2d_oneoverq2(nn,bdot, &
                dvalue,qran,qk,kz,zc,epshead,q0len,averagew,wcoul0)
              vcoul(ig)=dvalue
              if (ekinx .lt. TOL_Zero) then
                vcoul0=dvalue
                if (iscreen .eq. 1) then
                  wcoul0=vcoul0*epshead
                endif
                minibz_done = .true.
                iCommFlag=peinf%inode+1
              endif
            else
              vcoul(ig)=vcoul0
            endif
          else
            write(0,'(a)') 'You have q0vec=0 but a metal!!'
            call die('Bad Screening Options', only_root_writes = .true.)
          endif
        else if (ekinx .lt. Tol_Zero) then
          vcoul(ig) = 0D0
        else
          vcoul(ig) = 8.0d0*PI_D/ekinx
          vcoul(ig) = vcoul(ig)*(1.0d0-exp(-kxy*zc)*cos(kz*zc))
        endif
      enddo
      
#ifdef MPI
      if (iparallel .eq. 1) then
        SAFE_ALLOCATE(vcoul2, (ncoul))
        vcoul2(:)=0.d0
        call MPI_ALLREDUCE(vcoul,vcoul2,ncoul, &
          MPI_REAL_DP, MPI_SUM, MPI_COMM_WORLD,mpierr)
        vcoul(:)=vcoul2(:)
        SAFE_DEALLOCATE(vcoul2)
        call MPI_ALLREDUCE(iCommFlag,iCommFlagGlobal,1, &
          MPI_INTEGER, MPI_SUM, MPI_COMM_WORLD,mpierr)
        if (iCommFlagGlobal .ne. 0) then
          minibz_done = .true.
          call MPI_BCAST(vcoul0,1,MPI_DOUBLE_PRECISION,iCommFlagGlobal-1, MPI_COMM_WORLD, mpierr)
          call MPI_BCAST(wcoul0,1,MPI_SCALAR,iCommFlagGlobal-1, MPI_COMM_WORLD, mpierr)
        endif
      endif
#endif
      
! This is wrong too?

      oneoverq=vcoul(1)*qlen

!----------------------------------------------------------------
! Supercell Box Truncation

    elseif (itruncflag .eq. 7) then
      
      if (iparallel .eq. 1) then
        call trunc_scell_box_d(gvec,.true.,peinf%inode,peinf%npes, &
          bdot,qvec_mod,qgrid,ncoul,isrtq,vcoul,work_scell)
      else
        call trunc_scell_box_d(gvec,.true.,0,1, &
          bdot,qvec_mod,qgrid,ncoul,isrtq,vcoul,work_scell)
      endif
      
      oneoverq=vcoul(1)*qlen
      wcoul0 = vcoul(1)
      
    endif

! Saving qran between calls
!      deallocate(qran)

!-----------------------------------------------------------------
! Print vcoul to file

    if (iwritecoul .eq. 1) then
      if (peinf%inode.eq.0) then
        do ig=1,ncoul
          write(19,'(3f12.8,1x,3i7,1x,e20.8)') &
            qvec_mod(:),gvec%components(:,isrtq(ig)),vcoul(ig)
        enddo
      endif
    endif

    ifirst = 0
    
    POP_SUB(vcoul_generator)
    
    return
  end subroutine vcoul_generator

!-----------------------------------------------------------------
  subroutine destroy_qran()

    PUSH_SUB(destroy_qran)

    ifirst = 2
    SAFE_DEALLOCATE(qran)

#ifdef VERBOSE
    if(peinf%inode == 0) write(6,'(a)') ' *** VERBOSE: Deallocated random numbers.'
#endif

    POP_SUB(destroy_qran)
    return
  end subroutine destroy_qran

end module vcoul_generator_m

!==========================================================================
!
! Routines:
!
! (1) genwf_co()        Originally By MLT       Last Modified 4/19/2009 (gsm)
!
!     input: crys, gvec, kg, kgq,  syms, xct, distgwfco, distgwfcoq types
!            ik    label of k-point in FBZ
!            ikq   label of k-point in FBZ Q Shifted
!
!     output: wfnc   conduction wavefunctions at point k
!             wfnv   valence wavefunctions at point k
!
!==========================================================================

#include "f_defs.h"

subroutine genwf_co(crys,gvec,kg,kgq,syms,wfnc,wfnv,xct, &
  ik,ikq,distgwfco,distgwfcoq,workco,workcoq)

  use global_m
  use gmap_m
  use input_utils_m
  use misc_m
  use sort_m
  implicit none

  type (crystal), intent(in) :: crys
  type (gspace), intent(in) :: gvec
  type (grid), intent(in) :: kg
  type (grid), intent(in) :: kgq
  type (symmetry), intent(in) :: syms
  type (wavefunction), intent(out) :: wfnc
  type (wavefunction), intent(out) :: wfnv
  type (xctinfo), intent(in) :: xct
  integer, intent(in) :: ik
  integer, intent(in) :: ikq
  type (tdistgwf), intent(in) :: distgwfco
  type (tdistgwf), intent(in) :: distgwfcoq
  type (work_genwf), intent(inout) :: workco
  type (work_genwf), intent(inout) :: workcoq

  character :: filenamev*20,filenamec*20,errmsg*100
  integer :: irk,iunit_v,iunit_c,kval
  integer :: ig,hh,ii,jj,kk,eof,ipe

  integer, allocatable :: distint(:),distkval(:)
  integer, allocatable :: distik(:),distikold(:)
  integer, allocatable :: isorti(:),distisort(:)
  real(DP) :: qk(3)
  real(DP), allocatable :: ekin(:)
  SCALAR, allocatable :: distz(:,:,:)
  PUSH_SUB(genwf_co)

!-----------------------------------------------------------------------
! Initialize temp file names

  if (xct%iwriteint.eq.0) then
    if (xct%qflag .eq. 0) then
      write(filenamev,'(a)') 'INT_VWFN_CO_Q'
    else
      write(filenamev,'(a)') 'INT_VWFN_CO'
    endif
    write(filenamec,'(a)') 'INT_CWFN_CO'
    if (xct%qflag .eq. 0) then
      iunit_v=124
    else
      iunit_v=127
    endif
    iunit_c=126
  endif

!-----------------------------------------------------------------------
! Deal with the (possibly shifted) valence wavefunctions

  if (xct%qflag .eq. 0) then
    kval=kgq%indr(ikq)
  else
    kval=kg%indr(ikq)
  endif
    
  if (ikq.ne.workcoq%ikold) then
    
    if (xct%iwriteint.eq.1) then
      workcoq%ng=distgwfcoq%ng(kval)
      workcoq%nb=distgwfcoq%nv
      workcoq%ns=distgwfcoq%ns
      workcoq%nspinor=distgwfcoq%nspinor
    endif
    if (xct%iwriteint.eq.0) then
      call open_file(iunit_v,file=filenamev,form='unformatted',status='old')
      eof=0
      read(iunit_v) irk,workcoq%ng,workcoq%nb,workcoq%ns,workcoq%nspinor
      do while ((irk.ne.kval).and.(eof.eq.0))
        read(iunit_v)
        read(iunit_v,iostat=eof) irk,workcoq%ng,workcoq%nb,workcoq%ns,workcoq%nspinor
      enddo
      if (eof.ne.0) then
        write(errmsg,999) ikq, kval, trim(filenamev)
        call die(errmsg)
      endif
999   format('Could not find the valence wavefunctions for k-point',i4,&
        '(equivalent to k-point ',i4,' in the IBZ) in file ',a)
    endif
    
    if (workcoq%ikold.ne.0) then
      SAFE_DEALLOCATE_P(workcoq%cg)
      SAFE_DEALLOCATE_P(workcoq%ph)
      SAFE_DEALLOCATE_P(workcoq%ind)
      SAFE_DEALLOCATE_P(workcoq%isort)
    endif
    SAFE_ALLOCATE(workcoq%cg, (workcoq%ng,workcoq%nb,workcoq%ns*workcoq%nspinor))
    SAFE_ALLOCATE(workcoq%ind, (workcoq%ng))
    SAFE_ALLOCATE(workcoq%ph, (workcoq%ng))
    SAFE_ALLOCATE(workcoq%isort, (gvec%ng))
    
  endif ! ikq.ne.workcoq%ikold
  
  wfnv%ng=workcoq%ng
  wfnv%nband=workcoq%nb
  wfnv%nspin=workcoq%ns
  wfnv%nspinor=workcoq%nspinor
  if (workcoq%ns.ne.xct%nspin) then
    write(0,998) xct%nspin,workcoq%ns,trim(filenamev)
    write(errmsg,*) ' Spin mismatch in workcoq ', workcoq%ikold, ikq
    call die(errmsg)
  endif
998 format(1x,'The given number of spins',i2,1x,'does not match with', &
      1x,'the number of spins',i2,1x,'in file',1x,a,'.')
  
  SAFE_ALLOCATE(wfnv%cg, (wfnv%ng,wfnv%nband,wfnv%nspin*wfnv%nspinor))
  SAFE_ALLOCATE(wfnv%isort, (gvec%ng))
  
  if (xct%iwriteint.eq.1) then
    
! Share kval, ikq, ikoldq among processors

    SAFE_ALLOCATE(distint, (peinf%npes))
    SAFE_ALLOCATE(distkval, (peinf%npes))
    SAFE_ALLOCATE(distik, (peinf%npes))
    SAFE_ALLOCATE(distikold, (peinf%npes))
    
    distint(:)=0
    distint(peinf%inode+1)=kval
#ifdef MPI
    call MPI_Allreduce(distint,distkval,peinf%npes,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,mpierr)
#else
    distkval(:)=distint(:)
#endif

    distint(:)=0
    distint(peinf%inode+1)=ikq
#ifdef MPI
    call MPI_Allreduce(distint,distik,peinf%npes,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,mpierr)
#else
    distik(:)=distint(:)
#endif
    
    distint(:)=0
    distint(peinf%inode+1)=workcoq%ikold
#ifdef MPI
    call MPI_Allreduce(distint,distikold,peinf%npes,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,mpierr)
#else
    distikold(:)=distint(:)
#endif

    SAFE_DEALLOCATE(distint)

! Gather distributed wavefunctions for rk-kpoint

    SAFE_ALLOCATE(distisort, (distgwfcoq%ngm))
    SAFE_ALLOCATE(distz, (distgwfcoq%ngm,distgwfcoq%nv,distgwfcoq%ns*distgwfcoq%nspinor))
    
    do ipe=1,peinf%npes
      if (distik(ipe).ne.distikold(ipe)) then
        distisort(:)=0
        distz(:,:,:)=ZERO
        do ii=1,distgwfcoq%ngl
          distisort(ii+distgwfcoq%tgl)=distgwfcoq%isort(ii,distkval(ipe))
        enddo
        do kk=1,distgwfcoq%ns*distgwfcoq%nspinor
          do jj=1,distgwfcoq%nv
            do ii=1,distgwfcoq%ngl
              distz(ii+distgwfcoq%tgl,jj,kk)=distgwfcoq%zv(ii,jj,kk,distkval(ipe))
            enddo
          enddo
        enddo
#ifdef MPI
        ii=distgwfcoq%ng(distkval(ipe))
        call MPI_Reduce(distisort,workcoq%isort,ii,MPI_INTEGER,MPI_SUM,ipe-1,MPI_COMM_WORLD,mpierr)
        do kk=1,workcoq%ns*workcoq%nspinor
          do jj=1,workcoq%nb
            call MPI_Reduce(distz(:,jj,kk),workcoq%cg(:,jj,kk),ii,MPI_SCALAR,MPI_SUM,ipe-1,MPI_COMM_WORLD,mpierr)
          enddo
        enddo
#else
        do ii=1,workcoq%ng
          workcoq%isort(ii)=distisort(ii)
        enddo
        do kk=1,workcoq%ns*workcoq%nspinor
          do jj=1,workcoq%nb
            do ii=1,workcoq%ng
              workcoq%cg(ii,jj,kk)=distz(ii,jj,kk)
            enddo
          enddo
        enddo
#endif
      endif ! distik.ne.distikold
    enddo ! ipe
    
    SAFE_DEALLOCATE(distisort)
    SAFE_DEALLOCATE(distz)
    
    SAFE_DEALLOCATE(distkval)
    SAFE_DEALLOCATE(distik)
    SAFE_DEALLOCATE(distikold)
    
  endif ! xct%iwriteint.eq.1

! Read wavefunctions for rk-kpoint from temp file
  if (xct%iwriteint.eq.0 .and. ikq.ne.workcoq%ikold) then
    read(iunit_v) (workcoq%isort(ii),ii=1,gvec%ng),(((workcoq%cg(ii,jj,kk), &
      ii=1,wfnv%ng),jj=1,wfnv%nband),kk=1,wfnv%nspin*wfnv%nspinor)
    call close_file(iunit_v)
  endif ! xct%iwriteint.eq.0
  
  if (ikq.ne.workcoq%ikold) then

! Compute inverse index array of Fourier components around rk-kpoint

    SAFE_ALLOCATE(isorti, (gvec%ng))
    isorti(:)=0
    do ii=1,wfnv%ng
      isorti(workcoq%isort(ii))=ii
    enddo
    
! Compute index array of Fourier components around fk-kpoint
    
    SAFE_ALLOCATE(ekin, (gvec%ng))
    if (xct%qflag .eq. 0) then
      qk(1:3)=kgq%f(1:3,ikq)
    else
      qk(1:3)=kg%f(1:3,ikq)
    endif
    call kinetic_energies(gvec, crys%bdot, ekin, qvec = qk)
    call sortrx(gvec%ng, ekin, workcoq%isort, gvec = gvec%components)
    SAFE_DEALLOCATE(ekin)

! Find ind and ph relating wavefunctions in fk to rk-kpoint

    workcoq%ind(:)=0
    workcoq%ph(:)=ZERO
    if (xct%qflag .eq. 0) then
      call gmap(gvec,syms,wfnv%ng,kgq%itran(ikq), &
        kgq%kg0(:,ikq),workcoq%isort,isorti,workcoq%ind,workcoq%ph,.true.)
    else
      call gmap(gvec,syms,wfnv%ng,kg%itran(ikq), &
        kg%kg0(:,ikq),workcoq%isort,isorti,workcoq%ind,workcoq%ph,.true.)
    endif
    SAFE_DEALLOCATE(isorti)

! Compute and renormalize valence wavefunctions

    do kk=1,wfnv%nspin
      do jj=1,wfnv%nband
        do hh=1,wfnv%nspinor
          do ii=1,wfnv%ng
            if (workcoq%ind(ii) .gt. 0) then
              wfnv%cg(ii,jj,kk*hh)=workcoq%ph(ii)*workcoq%cg(workcoq%ind(ii),jj,kk*hh)
            endif
          enddo
        enddo
        call checknorm('wfnv%cg',jj,ik,wfnv%ng,kk,wfnv%nspinor,wfnv%cg(1:wfnv%ng,jj,:))
      enddo
    enddo

    workcoq%cg(:,:,:)=wfnv%cg(:,:,:)
    
  endif ! ikq.ne.workcoq%ikold


  wfnv%cg(:,:,:)=workcoq%cg(:,:,:)
  wfnv%isort(:)=workcoq%isort(:)
  workcoq%ikold=ikq

!-----------------------------------------------------------------------
! Deal with the conduction wavefunctions

  kval=kg%indr(ik)
    
  if (ik.ne.workco%ikold) then
    
    if (xct%iwriteint.eq.1) then
      workco%ng=distgwfco%ng(kval)
      workco%nb=distgwfco%nc
      workco%ns=distgwfco%ns
      workco%nspinor=distgwfco%nspinor
    endif
    if (xct%iwriteint.eq.0) then
      call open_file(iunit_c,file=filenamec,form='unformatted',status='old')
      eof=0
      read(iunit_c) irk,workco%ng,workco%nb,workco%ns,workco%nspinor
      do while ((irk.ne.kval).and.(eof.eq.0))
        read(iunit_c)
        read(iunit_c,iostat=eof) irk,workco%ng,workco%nb,workco%ns,workco%nspinor
      enddo
      if (eof.ne.0) then
        write(errmsg,999) ik, kval, trim(filenamec)
        call die(errmsg)
      endif
    endif
    
    if (workco%ikold.ne.0) then
      SAFE_DEALLOCATE_P(workco%cg)
      SAFE_DEALLOCATE_P(workco%ph)
      SAFE_DEALLOCATE_P(workco%ind)
      SAFE_DEALLOCATE_P(workco%isort)
    endif
    SAFE_ALLOCATE(workco%cg, (workco%ng,workco%nb,workco%ns*workco%nspinor))
    SAFE_ALLOCATE(workco%ind, (workco%ng))
    SAFE_ALLOCATE(workco%ph, (workco%ng))
    SAFE_ALLOCATE(workco%isort, (gvec%ng))
    
  endif ! ik.ne.workco%ikold
  
  wfnc%ng=workco%ng
  wfnc%nband=workco%nb
  wfnc%nspin=workco%ns
  wfnc%nspinor=workco%nspinor
  if (workco%ns.ne.xct%nspin) then
    write(errmsg,998) xct%nspin,workco%ns,trim(filenamec)
    call die(errmsg)
  endif
  
  SAFE_ALLOCATE(wfnc%cg, (wfnc%ng,wfnc%nband,wfnc%nspin*wfnc%nspinor))
  SAFE_ALLOCATE(wfnc%isort, (gvec%ng))
  
  if (xct%iwriteint.eq.1) then

! Share kval, ik, workco%ikold among processors
    
    SAFE_ALLOCATE(distint, (peinf%npes))
    SAFE_ALLOCATE(distkval, (peinf%npes))
    SAFE_ALLOCATE(distik, (peinf%npes))
    SAFE_ALLOCATE(distikold, (peinf%npes))
    
    distint(:)=0
    distint(peinf%inode+1)=kval
#ifdef MPI
    call MPI_Allreduce(distint,distkval,peinf%npes,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,mpierr)
#else
    distkval(:)=distint(:)
#endif
    distint(:)=0
    distint(peinf%inode+1)=ik
#ifdef MPI
    call MPI_Allreduce(distint,distik,peinf%npes,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,mpierr)
#else
    distik(:)=distint(:)
#endif
    distint(:)=0
    distint(peinf%inode+1)=workco%ikold
#ifdef MPI
    call MPI_Allreduce(distint,distikold,peinf%npes,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,mpierr)
#else
    distikold(:)=distint(:)
#endif
    
    SAFE_DEALLOCATE(distint)

! Gather distributed wavefunctions for rk-kpoint

    SAFE_ALLOCATE(distisort, (distgwfcoq%ngm))
    SAFE_ALLOCATE(distz, (distgwfcoq%ngm,distgwfcoq%nc,distgwfcoq%ns*distgwfcoq%nspinor))

    do ipe=1,peinf%npes
      if (distik(ipe).ne.distikold(ipe)) then
        distisort(:)=0
        distz(:,:,:)=ZERO
        do ii=1,distgwfco%ngl
          distisort(ii+distgwfco%tgl)=distgwfco%isort(ii,distkval(ipe))
        enddo
        do kk=1,distgwfco%ns*distgwfco%nspinor
          do jj=1,distgwfco%nc
            do ii=1,distgwfco%ngl
              distz(ii+distgwfco%tgl,jj,kk)=distgwfco%zc(ii,jj,kk,distkval(ipe))
            enddo
          enddo
        enddo
#ifdef MPI
        ii=distgwfco%ng(distkval(ipe))
        call MPI_Reduce(distisort,workco%isort,ii,MPI_INTEGER,MPI_SUM,ipe-1,MPI_COMM_WORLD,mpierr)
        do kk=1,workco%ns*workco%nspinor
          do jj=1,workco%nb
            call MPI_Reduce(distz(:,jj,kk),workco%cg(:,jj,kk),ii,MPI_SCALAR,MPI_SUM,ipe-1,MPI_COMM_WORLD,mpierr)
          enddo
        enddo
#else
        do ii=1,workco%ng
          workco%isort(ii)=distisort(ii)
        enddo
        do kk=1,workco%ns*workco%nspinor
          do jj=1,workco%nb
            do ii=1,workco%ng
              workco%cg(ii,jj,kk)=distz(ii,jj,kk)
            enddo
          enddo
        enddo
#endif
      endif ! distik.ne.distikold
    enddo ! ipe
    
    SAFE_DEALLOCATE(distisort)
    SAFE_DEALLOCATE(distz)
    
    SAFE_DEALLOCATE(distkval)
    SAFE_DEALLOCATE(distik)
    SAFE_DEALLOCATE(distikold)
    
  endif ! xct%iwriteint.eq.1
  
! Read wavefunctions for rk-kpoint from temp file
  if (xct%iwriteint.eq.0 .and. ik.ne.workco%ikold) then
    read(iunit_c) (workco%isort(ii),ii=1,gvec%ng),(((workco%cg(ii,jj,kk), &
      ii=1,wfnc%ng),jj=1,wfnc%nband),kk=1,wfnc%nspin*wfnc%nspinor)
    call close_file(iunit_c)
  endif ! xct%iwriteint.eq.0
  
  if (ik.ne.workco%ikold) then

! JRD: Below is now necessary because kg might be different from kgq

! Compute inverse index array of Fourier components around rk-kpoint

    SAFE_ALLOCATE(isorti, (gvec%ng))
    isorti(:)=0
    do ii=1,wfnc%ng
      isorti(workco%isort(ii))=ii
    enddo

! Compute index array of Fourier components around fk-kpoint

    SAFE_ALLOCATE(ekin, (gvec%ng))
    call kinetic_energies(gvec, crys%bdot, ekin, qvec = kg%f(:, ik))
    call sortrx(gvec%ng, ekin, workco%isort, gvec = gvec%components)
    SAFE_DEALLOCATE(ekin)
    
! Find ind and ph relating wavefunctions in fk to rk-kpoint

    workco%ind(:)=0
    workco%ph(:)=ZERO
    call gmap(gvec,syms,wfnc%ng,kg%itran(ik), &
      kg%kg0(:,ik),workco%isort,isorti,workco%ind,workco%ph,.true.)
    SAFE_DEALLOCATE(isorti)

! Compute and renormalize conduction wavefunctions

    do kk=1,wfnc%nspin
      do jj=1,wfnc%nband
        do hh=1,wfnc%nspinor
          do ii=1,wfnc%ng
            if (workco%ind(ii) .gt. 0) then
              wfnc%cg(ii,jj,kk*hh)=workco%ph(ii)*workco%cg(workco%ind(ii),jj,kk*hh)
            endif
          enddo
        enddo
        call checknorm('wfnc%cg',jj,ik,wfnc%ng,kk,wfnc%nspinor,wfnc%cg(1:wfnc%ng,jj,:))
      enddo
    enddo

    workco%cg(:,:,:)=wfnc%cg(:,:,:)
    
  endif ! ik.ne.workco%ikold
  

  wfnc%cg(:,:,:)=workco%cg(:,:,:)
  wfnc%isort(:)=workco%isort(:)
  workco%ikold=ik

  POP_SUB(genwf_co)
  
  return
end subroutine genwf_co

#include "f_defs.h"

!*************************************************************************
Module GraphMod
!*************************************************************************
! The Graphics module is used  to print a GNU plot with Ticks 
! and Labels and lines from a matrix y, and an axis x.  Multiple y`s
! are allowed for each x.  The module can only deal with on graph
! at a time.  Each Graph must be create and destroyed with GraphInit
! and GraphDestroy.  GraphInit must be called before GraphDestroy,
! AddLabel, or CreateGNUPlot.  If creating a second plot, GraphDestroy
! must be called for the first graph before GraphInit can be called for
! the second.
!*************************************************************************
! The module contains the public functions:
!    GraphInit(integer :: nl)
!    GraphDestroy
!    AddLabel(character(2) :: label,real(double):: tick)
!    CreateGNUPlot(real(double) :: x(:), real(double) :: y(:,:))
!*************************************************************************
! The module contains the public variables:
!*************************************************************************
! The module contains the private functions:
!*************************************************************************
! The module contains the private variables:
!    nlabel    The current number of labels on the graph.
!    labelmax  The maximum number of labels that can be used in the
!              current graph.  It is set by GraphInit(nl) and is equal
!              to nl + 1.
!    xlabel(:) The array of labels.  Each label is two characters.
!    xtick(:)  The x position of each tick(i) for xlabel(i)
!*************************************************************************

  use SysParams, only : double
  use EigenStatesMod, only : eigenStatesT
  use push_pop_m

  implicit none

  save

  type GraphT
    integer :: nlabel                  ! current number of labels
    integer :: labelmax                ! max number of labels
    integer :: npoints                 ! number of points on xAxis
    character(2), pointer :: xlabel(:) ! label marker
    real(double), pointer :: xtick(:)  ! tick-markers
    real(double), pointer :: xAxis(:)  ! points on x axis
  end type GraphT

  contains

!*************************************************************************
  Subroutine GraphInit( graph, npoints, nlines )
!*************************************************************************

! Initializes graph data module by creating space 
! for nl+1 labels and ticks.

    type( graphT ), pointer :: graph
    integer, intent(in) :: npoints, nlines
    integer             :: error

    PUSH_SUB(GraphInit)

    if( associated( graph )) stop 'Error, graph already allocated.'

    allocate( graph, stat = error )

    if( error /= 0 ) stop 'Error, graph allocation failed.'

    nullify( graph%xlabel )
    nullify( graph%xtick )
    nullify( graph%xAxis )

    graph%labelmax = nlines + 1
    graph%nlabel = 0
    graph%npoints = npoints   
    allocate(graph%xAxis(npoints), graph%xlabel(graph%labelmax), &
      & graph%xtick(graph%labelmax), stat=error)
    if(error /= 0) stop 'Error allocating space in GraphInit'

    POP_SUB(GraphInit)
  end Subroutine GraphInit

!*************************************************************************
  Subroutine GraphDestroy( graph )
!*************************************************************************

!   Destroys graph data space for nlabel labels and ticks.

    type( graphT ), pointer :: graph
    integer :: error

    PUSH_SUB(GraphDestroy)

    if( .not. associated( graph )) stop 'Error, graph not allocated.'

    deallocate( graph%xAxis, graph%xlabel, graph%xtick, stat = error )
    if( error /= 0 ) stop 'Error xlabel deallocating in GraphDestroy.'
    graph%nlabel = 0
    graph%labelmax = 0

    deallocate( graph, stat = error )
    if( error /= 0 ) stop 'Error, graph deallocation failed.'

    nullify( graph )

    POP_SUB(GraphDestroy)
  end Subroutine GraphDestroy

!*************************************************************************
  Subroutine AddLabel( graph, label, tick )
!*************************************************************************

!   Enters graph data labels and ticks.

    type( graphT ), pointer :: graph
    character(2), intent(in) :: label
    real(double), intent(in) :: tick

    PUSH_SUB(AddLabel)

    graph%nlabel = graph%nlabel + 1

    if(graph%nlabel > graph%labelmax) STOP 'Error the number of labels is to larger.'

    graph%xlabel( graph%nlabel ) = label
    graph%xtick( graph%nlabel ) = tick

    POP_SUB(AddLabel)
  end Subroutine Addlabel

!*************************************************************************
  Subroutine PlotBands( graph, eigenStates )
!*************************************************************************

!   Plots the bands with labels.

!    use GraphMod,       only : CreateGNUPlot, graphT
    use EigenStatesMod, only : eigenStatesT

    implicit none

    type( graphT ),       pointer :: graph
 !   type( kPointsT ),     pointer :: kPoints
    type( eigenStatesT ), pointer :: eigenStates

    PUSH_SUB(PlotBands)

! generate a graphics data file
    call CreateGNUPlot( graph, graph%xAxis, eigenStates%eigenValues ) 

    POP_SUB(PlotBands)
  end Subroutine PlotBands

!*************************************************************************
  Subroutine CreateGNUPlot( graph, x, y )
!*************************************************************************

! CreateGNUPlot creates the files need to create a two-dimensional plot
! with GNU plot.  There are two files created: bands.plt, the gnuplot
! command file, and bands.dat, the data file.  To view the graph at the 
! command line: gnuplot bands.plt.
!
! Inputs:
!       real(double) :: x(i)   The x coordinate of the ith point.
!       real(double) :: y(i,j) The y coordinate of the ith point for the jth line.
!
! Outputs:
!       file bands.plt
!       file bands.dat

    use message_m
    implicit none
 
    type( graphT ), pointer   :: graph
    real(double), intent(in)  :: x(:), y(:,:)
    real(double)              :: ymin,ymax
    integer                   :: i,j, ulines, upoints, llines, lpoints

    PUSH_SUB(CreateGNUPlot)

    call open_file(7, file = 'bands.dat', status='replace') ! output data for use by gnuplot

    lpoints = lbound(y, 2)
    llines  = lbound(y, 1)
    upoints = ubound(y, 2)
    ulines  = ubound(y, 1)

    if((upoints - lpoints) /= (ubound(x,1) - lbound(x,1))) then
      stop 'Error: unequal number of points in x and y'
    end if

    do i = llines, ulines
      do j = lpoints, upoints
        write(7,700) x(j),y(i,j)
      end do
      if (i .lt. ulines) write(7,126)
    end do

    call close_file(7)

    ymin = minval(y)
    ymax = maxval(y)

    ! plot vertical lines in a separate file
    ! only needed if not using gnuplot below

    call open_file(7, file = 'line.dat', status='replace')

    do i = 1, graph%nlabel
      write(7,700) graph%xtick(i), ymin - 2.0d0
      write(7,700) graph%xtick(i), ymax + 2.0d0
      if (i .lt. graph%nlabel) write(7,127)
    enddo

    call close_file(7)

    ! make a gnuplot data file: at command prompt type the following:
    ! % gnuplot bands.plt
    ! hit any key to end display of plot (program will do this automatically)

    call open_file(7, file = 'bands.plt', status='replace')

    write(7,701) graph%xtick(graph%nlabel),ymin,ymax
    do i = 2, graph%nlabel-1
      write(7,705) graph%xtick(i),ymin,graph%xtick(i),ymax
    end do
    write(7,702,ADVANCE="NO") ( graph%xlabel(i), graph%xtick(i), i=1, graph%nlabel-1)
    write(7,703) graph%xlabel(graph%nlabel), graph%xtick(graph%nlabel)
    write(7,704)

    call close_file(7)

    700 format(8F11.5)
    701 format('set style data lines'/'set nokey'/&
       & 'set xrange [0:',F8.2,']'/'set yrange [',F8.2,' :',F8.2,']')
    702 format('set xtics (',:20('"',A2,'" ',F8.2,','))
    703 format(' ',A2,'" ',F8.2,')')
    704 format('plot "bands.dat"'/'pause -1'/'set output "bands.ps"'/&
       & 'set terminal postscript'/&
       & 'replot')
    705 format('set arrow from ',F8.2,',',F8.2,' to ',F8.2,',',F8.2,' nohead')
    126 format()
    127 format('-- --')

    POP_SUB(CreateGNUPlot)
  end Subroutine CreateGNUPlot

end Module GraphMod

!===============================================================================
!
! Routines:
!
! (1) absorption         Originally by JRD       Last Edited: 9/12/2011 (JRD)
!
!     This routine calls either diag or haydock.
!
!     For more details the README_absorption file:
!
!     Please report bugs to: jdeslip@civet.berkeley.edu
!     
!================================================================================

#include "f_defs.h"

program absorption

#ifdef HDF5
  use hdf5
#endif

  use global_m
  use inread_m
  use bse_init_m
  implicit none

  type (eqpinfo) :: eqp
  type (xctinfo) :: xct
  type (flags) :: flag

  integer :: nmax,neig,error
  logical :: diagonalization

  call peinfo_init()

!---------------------------
! Write header

  call write_program_header('BSE/Absorption', .false.)

!---------------------------
! Read absorption.inp

  call logit('Calling inread')
  call open_file(8,file='absorption.inp',form='formatted',status='old')
  call inread(eqp,xct,flag,nmax,neig,diagonalization)
  call close_file(8)

! FHJ: Initialize xct%nkpt_co and dimensionality of the problem
  call bse_init(xct,flag)

!----------------------
! Initialize HDF5

#ifdef HDF5
  if(xct%use_hdf5) call h5open_f(error)
#endif

!----------------------
! Initialize random numbers

  peinf%jobtypeeval = 1

!----------------------
! Initialize wcoul0

  xct%wcoul0 = 0d0

!----------------------
! Initialize timer

  call timacc(0,0)
  call timacc(1,1)

!---------------------------
! Initialize files

  if (xct%iwritecoul .eq. 1 .and. peinf%inode .eq. 0) then
    call open_file(19,file='vcoul',form='formatted',status='replace')
  endif

  if (diagonalization) then
    call diag(eqp,xct,flag,neig)
  else 
    call haydock(eqp,xct,flag,nmax)
  endif

  call write_memory_usage()

#ifdef MPI
  call MPI_FINALIZE(mpierr)
#endif

end program absorption

!
! Copyright (C) 2010-2012 Georgy Samsonidze
!
! Converts BerkeleyGW WFN and RHO files to the format of pw.x.
!
!-------------------------------------------------------------------------------
!
! BerkeleyGW, Copyright (c) 2011, The Regents of the University of
! California, through Lawrence Berkeley National Laboratory (subject to
! receipt of any required approvals from the U.S. Dept. of Energy).
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are
! met:
!
! (1) Redistributions of source code must retain the above copyright
! notice, this list of conditions and the following disclaimer.
!
! (2) Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! (3) Neither the name of the University of California, Lawrence
! Berkeley National Laboratory, U.S. Dept. of Energy nor the names of
! its contributors may be used to endorse or promote products derived
! from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
! A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
! OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
! SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
! LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
! THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
! You are under no obligation whatsoever to provide any bug fixes,
! patches, or upgrades to the features, functionality or performance of
! the source code ("Enhancements") to anyone; however, if you choose to
! make your Enhancements available either publicly, or directly to
! Lawrence Berkeley National Laboratory, without imposing a separate
! written license agreement for such Enhancements, then you hereby grant
! the following license: a  non-exclusive, royalty-free perpetual
! license to install, use, modify, prepare derivative works, incorporate
! into other computer software, distribute, and sublicense such
! enhancements or derivative works thereof, in binary and source code
! form.
!
!-------------------------------------------------------------------------------
!
! bgw2pw subroutines:
!
! write_evc - generates eigenvalues and wavefunctions in espresso format
! write_cd  - generates charge density in espresso format
! check_inversion - checks whether real/complex version is appropriate
!
!-------------------------------------------------------------------------------

module bgw2pw_m

  implicit none

  private

  public :: &
    write_evc, &
    write_cd, &
    check_inversion

contains

!-------------------------------------------------------------------------------

SUBROUTINE write_evc ( input_file_name, real_or_complex, &
  wfng_nband, output_dir_name )

  USE cell_base, ONLY : omega, alat, tpiba, tpiba2, at, bg
  USE constants, ONLY : eps6
  USE fft_base, ONLY : dfftp
  USE gvect, ONLY : ngm, ngm_g, ig_l2g, mill, g
  USE io_global, ONLY : ionode, ionode_id
  USE ions_base, ONLY : nat
  USE iotk_module, ONLY : iotk_attlenx, iotk_free_unit, iotk_open_write, &
    iotk_write_begin, iotk_write_attr, iotk_write_empty, iotk_write_dat, &
    iotk_write_end, iotk_close_write, iotk_index
  USE kinds, ONLY : DP
  USE klist, ONLY : xk, nks, nkstot
  USE lsda_mod, ONLY : nspin
  USE mp, ONLY : mp_bcast, mp_sum, mp_max, mp_barrier
  USE mp_global, ONLY : nproc, kunit, npool, my_pool_id, world_comm, &
    intra_pool_comm
  USE symm_base, ONLY : s, nsym
  USE xml_io_base, ONLY : create_directory, kpoint_dir, wfc_filename
#ifdef __PARA
  USE parallel_include, ONLY : MPI_INTEGER, MPI_DOUBLE_COMPLEX
#endif
  USE wvfct, ONLY : npwx, g2kin, ecutwfc

  IMPLICIT NONE

  character ( len = 256 ), intent ( in ) :: input_file_name
  integer, intent ( in ) :: real_or_complex
  integer, intent ( in ) :: wfng_nband
  character ( len = 256 ), intent ( in ) :: output_dir_name

  logical :: f1, f2
  integer :: ierr, i, j, iu, ik, is, ib, ig, jg, fg, ir, &
    na, nk, ns, nb, nbgw, ng, ngkmax, ntran, cell_symmetry, &
    nkbl, nkl, nkr, iks, ike, npw, npw_g, ngkdist_l, ngkdist_g, &
    igk_l2g, irecord, nrecord, ng_irecord, nr ( 3 )
  real ( DP ) :: ecutrho, ecutwfn, celvol, recvol, al, bl, xdel, &
    a ( 3, 3 ), b ( 3, 3 ), adot ( 3, 3 ), bdot ( 3, 3 )
  character :: sdate*32, stime*32, stitle*32
  character ( len = 256 ) :: filename
  character ( iotk_attlenx ) :: attr

  integer, allocatable :: itmp ( : )
  integer, allocatable :: ngk ( : )
  integer, allocatable :: gvec ( :, : )
  integer, allocatable :: igk_buf ( : )
  integer, allocatable :: igk_dist ( :, : )
  integer, allocatable :: gk_buf ( :, : )
  integer, allocatable :: gk_dist ( :, : )
  real ( DP ), allocatable :: k ( :, : )
  real ( DP ), allocatable :: en ( :, :, : )
  real ( DP ), allocatable :: oc ( :, :, : )
  real ( DP ), allocatable :: wfngr ( :, : )
  complex ( DP ), allocatable :: wfngc ( :, : )
  complex ( DP ), allocatable :: wfng_buf ( :, : )
  complex ( DP ), allocatable :: wfng_dist ( :, :, :, : )

  CALL check_inversion ( real_or_complex, nsym, s, nspin, .true., .true. )

  IF ( ionode ) CALL iotk_free_unit ( iu )

  IF ( ionode ) THEN
    OPEN ( unit = iu, file = TRIM ( input_file_name ), &
      form = 'unformatted', status = 'old' )
    READ ( iu ) stitle, sdate, stime
  ENDIF

  CALL mp_bcast ( stitle, ionode_id )
  f1 = real_or_complex == 1 .AND. stitle(1:8) == 'WFN-Real'
  f2 = real_or_complex == 2 .AND. stitle(1:11) == 'WFN-Complex'
  IF ( ( .NOT. f1 ) .AND. ( .NOT. f2 ) ) &
    CALL errore ( 'write_evc', 'file header', 1 )

  IF ( ionode ) THEN
    READ ( iu ) ns, ng, ntran, cell_symmetry, na, ecutrho, nk, nb, ngkmax, ecutwfn
    READ ( iu ) ( nr ( ir ), ir = 1, 3 )
    READ ( iu ) celvol, al, ( ( a ( j, i ), j = 1, 3 ), i = 1, 3 ), &
      ( ( adot ( j, i ), j = 1, 3 ), i = 1, 3 )
    READ ( iu ) recvol, bl, ( ( b ( j, i ), j = 1, 3 ), i = 1, 3 ), &
      ( ( bdot ( j, i ), j = 1, 3 ), i = 1, 3 )
  ENDIF

  CALL mp_bcast ( ns, ionode_id )
  CALL mp_bcast ( ng, ionode_id )
  CALL mp_bcast ( ntran, ionode_id )
  CALL mp_bcast ( cell_symmetry, ionode_id )
  CALL mp_bcast ( na, ionode_id )
  CALL mp_bcast ( ecutrho, ionode_id )
  CALL mp_bcast ( nk, ionode_id )
  CALL mp_bcast ( nb, ionode_id )
  CALL mp_bcast ( ngkmax, ionode_id )
  CALL mp_bcast ( ecutwfn, ionode_id )
  CALL mp_bcast ( nr, ionode_id )
  CALL mp_bcast ( celvol, ionode_id )
  CALL mp_bcast ( al, ionode_id )
  CALL mp_bcast ( a, ionode_id )
  CALL mp_bcast ( adot, ionode_id )
  CALL mp_bcast ( recvol, ionode_id )
  CALL mp_bcast ( bl, ionode_id )
  CALL mp_bcast ( b, ionode_id )
  CALL mp_bcast ( bdot, ionode_id )

  IF ( ns .NE. nspin ) CALL errore ( 'write_evc', 'ns', 1 )
  IF ( ng .NE. ngm_g ) CALL errore ( 'write_evc', 'ng', 1 )
  IF ( na .NE. nat ) CALL errore ( 'write_evc', 'na', 1 )
  IF ( nk .NE. nkstot / nspin ) CALL errore ( 'write_evc', 'nk', 1 )
  IF ( nr ( 1 ) .NE. dfftp%nr1 .OR. nr ( 2 ) .NE. dfftp%nr2 .OR. nr ( 3 ) .NE. dfftp%nr3 ) &
    CALL errore ( 'write_evc', 'nr', 1 )
  IF ( abs ( celvol - omega ) .GT. eps6 ) &
    CALL errore ( 'write_evc', 'unit cell volume', 1 )
  xdel = 0.0D0
  DO i = 1, 3
    DO j = 1, 3
      xdel = xdel + abs ( al * a ( j, i ) - alat * at ( j, i ) )
    ENDDO
  ENDDO
  IF ( xdel .GT. eps6 ) &
    CALL errore ( 'write_evc', 'direct lattice vectors', 1 )
  xdel = 0.0D0
  DO i = 1, 3
    DO j = 1, 3
      xdel = xdel + abs ( bl * b ( j, i ) - tpiba * bg ( j, i ) )
    ENDDO
  ENDDO
  IF ( xdel .GT. eps6 ) &
    CALL errore ( 'write_evc', 'reciprocal lattice vectors', 1 )

  nbgw = nb
  IF ( wfng_nband .GT. 0 .AND. wfng_nband .LT. nb ) nb = wfng_nband

  IF ( MOD ( ngkmax, nproc ) .EQ. 0 ) THEN
    ngkdist_l = ngkmax / nproc
  ELSE
    ngkdist_l = ngkmax / nproc + 1
  ENDIF
  ngkdist_g = ngkdist_l * nproc

  ALLOCATE ( ngk ( nk ) )
  ALLOCATE ( k ( 3, nk ) )
  ALLOCATE ( en ( nb, nk, ns ) )
  ALLOCATE ( oc ( nb, nk, ns ) )
  ALLOCATE ( gvec ( 3, ng ) )
  ALLOCATE ( igk_buf ( ngkdist_g ) )
  ALLOCATE ( igk_dist ( ngkdist_l, nk ) )
  ALLOCATE ( gk_buf ( 3, ngkdist_g ) )
  ALLOCATE ( gk_dist ( 3, ngkdist_l ) )
  IF ( real_or_complex .EQ. 1 ) THEN
    ALLOCATE ( wfngr ( ngkmax, ns ) )
  ELSE
    ALLOCATE ( wfngc ( ngkmax, ns ) )
  ENDIF
  ALLOCATE ( wfng_buf ( ngkdist_g, ns ) )
  ALLOCATE ( wfng_dist ( ngkdist_l, nb, ns, nk ) )

  IF ( ionode ) THEN
    READ ( iu )
    READ ( iu )
    READ ( iu )
    READ ( iu ) ( ngk ( ik ), ik = 1, nk )
    READ ( iu )
    READ ( iu ) ( ( k ( ir, ik ), ir = 1, 3 ), ik = 1, nk )
    READ ( iu )
    READ ( iu )
    READ ( iu ) ( ( ( en ( ib, ik, is ), ib = 1, nb ), ik = 1, nk ), is = 1, ns )
    READ ( iu ) ( ( ( oc ( ib, ik, is ), ib = 1, nb ), ik = 1, nk ), is = 1, ns )
    READ ( iu ) nrecord
    ig = 1
    DO irecord = 1, nrecord
      READ ( iu ) ng_irecord
      READ ( iu ) ( ( gvec ( ir, jg ), ir = 1, 3 ), jg = ig, ig + ng_irecord - 1 )
      ig = ig + ng_irecord
    ENDDO
  ENDIF

  IF ( ionode ) THEN
    CALL cryst_to_cart ( nk, k, bg, 1 )
    DO is = 1, ns
      DO ik = 1, nk
        DO ib = 1, nb
          en ( ib, ik, is ) = en ( ib, ik, is ) / 2.0D0
        ENDDO
      ENDDO
    ENDDO
  ENDIF

  CALL mp_bcast ( ngk, ionode_id )
  CALL mp_bcast ( k, ionode_id )
  CALL mp_bcast ( en, ionode_id )
  CALL mp_bcast ( oc, ionode_id )
  CALL mp_bcast ( gvec, ionode_id )

  fg = 0
  DO ig = 1, ngm
    IF ( ( gvec ( 1, ig_l2g ( ig ) ) .NE. mill ( 1, ig ) ) .OR. &
         ( gvec ( 2, ig_l2g ( ig ) ) .NE. mill ( 2, ig ) ) .OR. &
         ( gvec ( 3, ig_l2g ( ig ) ) .NE. mill ( 3, ig ) ) ) &
      fg = fg + 1
  ENDDO
  CALL mp_sum ( fg, intra_pool_comm )
  IF ( fg .GT. 0 ) THEN
    IF ( ionode ) WRITE ( 6, 101 )
    gvec ( :, : ) = 0
    DO ig = 1, ngm
      gvec ( 1, ig_l2g ( ig ) ) = mill ( 1, ig )
      gvec ( 2, ig_l2g ( ig ) ) = mill ( 2, ig )
      gvec ( 3, ig_l2g ( ig ) ) = mill ( 3, ig )
    ENDDO
    CALL mp_sum ( gvec, intra_pool_comm )
  ENDIF

  DO ik = 1, nk

    IF ( ionode ) THEN
      READ ( iu ) nrecord
      ig = 1
      DO irecord = 1, nrecord
        READ ( iu ) ng_irecord
        READ ( iu ) ( ( gk_buf ( ir, jg ), ir = 1, 3 ), jg = ig, ig + ng_irecord - 1 )
        ig = ig + ng_irecord
      ENDDO
      DO ig = ngk ( ik ) + 1, ngkdist_g
        DO ir = 1, 3
          gk_buf ( ir, ig ) = 0
        ENDDO
      ENDDO
    ENDIF
#ifdef __PARA
    CALL mp_barrier ( )
    CALL MPI_Scatter ( gk_buf, 3 * ngkdist_l, MPI_INTEGER, &
    gk_dist, 3 * ngkdist_l, MPI_INTEGER, &
    ionode_id, world_comm, ierr )
    IF ( ierr .GT. 0 ) CALL errore ( 'write_evc', 'mpi_scatter', ierr )
#else
    DO ig = 1, ngkdist_g
      DO ir = 1, 3
        gk_dist ( ir, ig ) = gk_buf ( ir, ig )
      ENDDO
    ENDDO
#endif
    DO ig = 1, ngkdist_l
      DO jg = 1, ng
        IF ( gk_dist ( 1, ig ) .EQ. gvec ( 1, jg ) .AND. &
             gk_dist ( 2, ig ) .EQ. gvec ( 2, jg ) .AND. &
             gk_dist ( 3, ig ) .EQ. gvec ( 3, jg ) ) THEN
          igk_dist ( ig, ik ) = jg
          EXIT
        ENDIF
      ENDDO
    ENDDO

    DO ib = 1, nb
      IF ( ionode ) THEN
        READ ( iu ) nrecord
        ig = 1
        DO irecord = 1, nrecord
          READ ( iu ) ng_irecord
          IF ( real_or_complex .EQ. 1 ) THEN
            READ ( iu ) ( ( wfngr ( jg, is ), jg = ig, ig + ng_irecord - 1 ), is = 1, ns )
          ELSE
            READ ( iu ) ( ( wfngc ( jg, is ), jg = ig, ig + ng_irecord - 1 ), is = 1, ns )
          ENDIF
          ig = ig + ng_irecord
        ENDDO
        DO is = 1, ns
          IF ( real_or_complex .EQ. 1 ) THEN
            DO ig = 1, ngk ( ik )
              wfng_buf ( ig, is ) = CMPLX ( wfngr ( ig, is ), 0.0D0 )
            ENDDO
          ELSE
            DO ig = 1, ngk ( ik )
              wfng_buf ( ig, is ) = wfngc ( ig, is )
            ENDDO
          ENDIF
          DO ig = ngk ( ik ) + 1, ngkdist_g
            wfng_buf ( ig, is ) = ( 0.0D0, 0.0D0 )
          ENDDO
        ENDDO
      ENDIF
#ifdef __PARA
      DO is = 1, ns
        CALL mp_barrier ( )
        CALL MPI_Scatter ( wfng_buf ( :, is ), ngkdist_l, MPI_DOUBLE_COMPLEX, &
        wfng_dist ( :, ib, is, ik ), ngkdist_l, MPI_DOUBLE_COMPLEX, &
        ionode_id, world_comm, ierr )
        IF ( ierr .GT. 0 ) CALL errore ( 'write_evc', 'mpi_scatter', ierr )
      ENDDO
#else
      DO is = 1, ns
        DO ig = 1, ngkdist_g
          wfng_dist ( ig, ib, is, ik ) = wfng_buf ( ig, is )
        ENDDO
      ENDDO
#endif
    ENDDO

    IF ( ik .LT. nk ) THEN
      DO ib = nb + 1, nbgw
        IF ( ionode ) THEN
          READ ( iu ) nrecord
          DO irecord = 1, nrecord
            READ ( iu )
            READ ( iu )
          ENDDO
        ENDIF
      ENDDO
    ENDIF

  ENDDO

  IF ( ionode ) THEN
    CLOSE ( unit = iu, status = 'keep' )
  ENDIF

  DEALLOCATE ( gk_buf )
  DEALLOCATE ( gk_dist )
  IF ( real_or_complex .EQ. 1 ) THEN
    DEALLOCATE ( wfngr )
  ELSE
    DEALLOCATE ( wfngc )
  ENDIF

  CALL mp_bcast ( ngk, ionode_id )

  nkbl = nkstot / kunit
  nkl = kunit * ( nkbl / npool )
  nkr = ( nkstot - nkl * npool ) / kunit
  IF ( my_pool_id .LT. nkr ) nkl = nkl + kunit
  iks = nkl * my_pool_id + 1
  IF ( my_pool_id .GE. nkr ) iks = iks + nkr * kunit
  ike = iks + nkl - 1

  npw_g = 0
  ALLOCATE ( itmp ( npwx ) )
  DO ik = 1, nks
    DO ig = 1, npwx
      itmp ( ig ) = 0
    ENDDO
    npw = npwx
    CALL gk_sort ( xk ( 1, ik + iks - 1 ), ngm, g, ecutwfc / tpiba2, &
      npw, itmp ( 1 ), g2kin )
    DO ig = 1, npw
      igk_l2g = ig_l2g ( itmp ( ig ) )
      IF ( igk_l2g .GT. npw_g ) npw_g = igk_l2g
    ENDDO
  ENDDO
  DEALLOCATE ( itmp )
  CALL mp_max ( npw_g )

  CALL create_directory ( output_dir_name )
  DO ik = 1, nk
    CALL create_directory ( kpoint_dir ( output_dir_name, ik ) )
  ENDDO

  filename = TRIM ( output_dir_name ) // '/gvectors.dat'

  IF ( ionode ) THEN
    CALL iotk_open_write ( iu, FILE = TRIM ( filename ), SKIP_ROOT = .TRUE., BINARY = .TRUE. )
    CALL iotk_write_begin ( iu, "G-VECTORS" )
    CALL iotk_write_attr ( attr, "nr1s", nr ( 1 ), FIRST = .TRUE. )
    CALL iotk_write_attr ( attr, "nr2s", nr ( 2 ) )
    CALL iotk_write_attr ( attr, "nr3s", nr ( 3 ) )
    CALL iotk_write_attr ( attr, "gvect_number", ng )
    CALL iotk_write_attr ( attr, "gamma_only", .FALSE. )
    CALL iotk_write_attr ( attr, "units", "crystal" )
    CALL iotk_write_empty ( iu, "INFO", ATTR = attr )
    CALL iotk_write_dat ( iu, "g", gvec ( 1 : 3, 1 : ng ), COLUMNS = 3 )
    CALL iotk_write_end ( iu, "G-VECTORS" )
    CALL iotk_close_write ( iu )
  ENDIF

  DO ik = 1, nk

    filename = TRIM ( wfc_filename ( output_dir_name, 'gkvectors', ik ) )

    IF ( ionode ) THEN
      CALL iotk_open_write ( iu, FILE = TRIM ( filename ), ROOT="GK-VECTORS", BINARY = .TRUE. )
      CALL iotk_write_dat ( iu, "NUMBER_OF_GK-VECTORS", ngk ( ik ) )
      CALL iotk_write_dat ( iu, "MAX_NUMBER_OF_GK-VECTORS", ngkmax )
      CALL iotk_write_dat ( iu, "GAMMA_ONLY", .FALSE. )
      CALL iotk_write_attr ( attr, "UNITS", "2 pi / a", FIRST = .TRUE. )
      CALL iotk_write_dat ( iu, "K-POINT_COORDS", k ( :, ik ), ATTR = attr )
    ENDIF
#ifdef __PARA
    CALL mp_barrier ( )
    CALL MPI_Gather ( igk_dist ( :, ik ) , ngkdist_l, MPI_INTEGER, &
    igk_buf, ngkdist_l, MPI_INTEGER, &
    ionode_id, world_comm, ierr )
    IF ( ierr .GT. 0 ) CALL errore ( 'write_evc', 'mpi_gather', ierr )
#else
    DO ig = 1, ngkdist_g
      igk_buf ( ig ) = igk_dist ( ig, ik )
    ENDDO
#endif
    IF ( ionode ) THEN
      CALL iotk_write_dat ( iu, "INDEX", igk_buf ( 1 : ngk ( ik ) ) )
      CALL iotk_write_dat ( iu, "GRID", gvec ( 1 : 3, igk_buf ( 1 : ngk ( ik ) ) ), COLUMNS = 3 )
      CALL iotk_close_write ( iu )
    ENDIF

    DO is = 1, ns

      IF ( ns .GT. 1 ) THEN
        filename = TRIM ( wfc_filename ( output_dir_name, 'eigenval', ik, is, EXTENSION = 'xml' ) )
      ELSE
        filename = TRIM ( wfc_filename ( output_dir_name, 'eigenval', ik, EXTENSION = 'xml' ) )
      ENDIF

      IF ( ionode ) THEN
        CALL iotk_open_write ( iu, FILE = TRIM ( filename ), BINARY = .FALSE. )
        CALL iotk_write_attr ( attr, "nbnd", nb, FIRST = .TRUE. )
        CALL iotk_write_attr ( attr, "ik", ik )
        IF ( ns .GT. 1 ) CALL iotk_write_attr ( attr, "ispin", is )
        CALL iotk_write_empty ( iu, "INFO", ATTR = attr )
        CALL iotk_write_attr ( attr, "UNITS", "Hartree", FIRST = .TRUE. )
        CALL iotk_write_empty ( iu, "UNITS_FOR_ENERGIES", ATTR = attr )
        CALL iotk_write_dat ( iu, "EIGENVALUES", en ( :, ik, is ) )
        CALL iotk_write_dat ( iu, "OCCUPATIONS", oc ( :, ik, is ) )
        CALL iotk_close_write ( iu )
      ENDIF

      IF ( ns .GT. 1 ) THEN
        filename = TRIM ( wfc_filename ( output_dir_name, 'evc', ik, is ) )
      ELSE
        filename = TRIM ( wfc_filename ( output_dir_name, 'evc', ik ) )
      ENDIF

      IF ( ionode ) THEN
        CALL iotk_open_write ( iu, FILE = TRIM ( filename ), ROOT = "WFC", BINARY = .TRUE. )
        CALL iotk_write_attr ( attr, "ngw", npw_g, FIRST = .TRUE. )
        CALL iotk_write_attr ( attr, "igwx", ngk ( ik ) )
        CALL iotk_write_attr ( attr, "gamma_only", .FALSE. )
        CALL iotk_write_attr ( attr, "nbnd", nb )
        CALL iotk_write_attr ( attr, "ik", ik )
        CALL iotk_write_attr ( attr, "nk", nk )
        CALL iotk_write_attr ( attr, "ispin", is )
        CALL iotk_write_attr ( attr, "nspin", ns )
        CALL iotk_write_attr ( attr, "scale_factor", 1.0D0 )
        CALL iotk_write_empty ( iu, "INFO", attr )
      ENDIF
      DO ib = 1, nb
#ifdef __PARA
        CALL mp_barrier ( )
        CALL MPI_Gather ( wfng_dist ( :, ib, is, ik ), ngkdist_l, MPI_DOUBLE_COMPLEX, &
        wfng_buf ( :, is ), ngkdist_l, MPI_DOUBLE_COMPLEX, &
        ionode_id, world_comm, ierr )
        IF ( ierr .GT. 0 ) CALL errore ( 'write_evc', 'mpi_gather', ierr )
#else
        DO ig = 1, ngkdist_g
          wfng_buf ( ig, is ) = wfng_dist ( ig, ib, is, ik )
        ENDDO
#endif
        IF ( ionode ) CALL iotk_write_dat ( iu, "evc" // iotk_index ( ib ), wfng_buf ( 1 : ngk ( ik ), is ) )
      ENDDO
      IF ( ionode ) CALL iotk_close_write ( iu )

    ENDDO
  ENDDO

  DEALLOCATE ( ngk )
  DEALLOCATE ( k )
  DEALLOCATE ( en )
  DEALLOCATE ( oc )
  DEALLOCATE ( gvec )
  DEALLOCATE ( igk_buf )
  DEALLOCATE ( igk_dist )
  DEALLOCATE ( wfng_buf )
  DEALLOCATE ( wfng_dist )

  CALL mp_barrier ( )

  RETURN

  101 FORMAT ( 5X, "WARNING: reordering G-vectors" )

END SUBROUTINE write_evc

!-------------------------------------------------------------------------------

SUBROUTINE write_cd ( input_file_name, real_or_complex, output_dir_name )

  USE cell_base, ONLY : omega, alat, tpiba, at, bg
  USE constants, ONLY : eps6
  USE fft_base, ONLY : dfftp
  USE fft_interfaces, ONLY : invfft
  USE gvect, ONLY : ngm, ngm_g, ig_l2g, nl, mill
  USE io_global, ONLY : ionode, ionode_id
  USE ions_base, ONLY : nat
  USE io_rho_xml, ONLY : write_rho
  USE iotk_module, ONLY : iotk_attlenx, iotk_free_unit, iotk_open_write, &
    iotk_write_begin, iotk_write_attr, iotk_write_empty, iotk_write_dat, &
    iotk_write_end, iotk_close_write
  USE kinds, ONLY : DP
  USE lsda_mod, ONLY : nspin
  USE mp, ONLY : mp_bcast, mp_sum
  USE mp_global, ONLY : intra_pool_comm
  USE scf, ONLY : rho
  USE symm_base, ONLY : s, nsym
  USE wavefunctions_module, ONLY : psic
  USE xml_io_base, ONLY : create_directory

  IMPLICIT NONE

  character ( len = 256 ), intent ( in ) :: input_file_name
  integer, intent ( in ) :: real_or_complex
  character ( len = 256 ), intent ( in ) :: output_dir_name

  logical :: f1, f2
  integer :: i, j, iu, is, ig, jg, fg, ir, ns, ng, &
    ntran, cell_symmetry, na, irecord, nrecord, ng_irecord, nr ( 3 )
  real ( DP ) :: ecutrho, celvol, recvol, al, bl, xdel, &
    a ( 3, 3 ), b ( 3, 3 ), adot ( 3, 3 ), bdot ( 3, 3 )
  character :: sdate*32, stime*32, stitle*32
  character ( len = 256 ) :: filename
  character ( iotk_attlenx ) :: attr

  integer, allocatable :: gvec ( :, : )
  real ( DP ), allocatable :: rhogr ( :, : )
  complex ( DP ), allocatable :: rhogc ( :, : )
  complex ( DP ), allocatable :: rhog ( :, : )
  complex ( DP ), allocatable :: rhog_unsrt ( :, : )

  CALL check_inversion ( real_or_complex, nsym, s, nspin, .true., .true. )

  IF ( ionode ) CALL iotk_free_unit ( iu )

  IF ( ionode ) THEN
    OPEN ( unit = iu, file = TRIM ( input_file_name ), &
      form = 'unformatted', status = 'old' )
    READ ( iu ) stitle, sdate, stime
  ENDIF

  CALL mp_bcast ( stitle, ionode_id )
  f1 = real_or_complex == 1 .AND. stitle(1:8) == 'RHO-Real'
  f2 = real_or_complex == 2 .AND. stitle(1:11) == 'RHO-Complex'
  IF ( ( .NOT. f1 ) .AND. ( .NOT. f2 ) ) &
    CALL errore ( 'write_cd', 'file header', 1 )

  IF ( ionode ) THEN
    READ ( iu ) ns, ng, ntran, cell_symmetry, na, ecutrho
    READ ( iu ) ( nr ( ir ), ir = 1, 3 )
    READ ( iu ) celvol, al, ( ( a ( j, i ), j = 1, 3 ), i = 1, 3 ), &
      ( ( adot ( j, i ), j = 1, 3 ), i = 1, 3 )
    READ ( iu ) recvol, bl, ( ( b ( j, i ), j = 1, 3 ), i = 1, 3 ), &
      ( ( bdot ( j, i ), j = 1, 3 ), i = 1, 3 )
  ENDIF

  CALL mp_bcast ( ns, ionode_id )
  CALL mp_bcast ( ng, ionode_id )
  CALL mp_bcast ( ntran, ionode_id )
  CALL mp_bcast ( cell_symmetry, ionode_id )
  CALL mp_bcast ( na, ionode_id )
  CALL mp_bcast ( ecutrho, ionode_id )
  CALL mp_bcast ( nr, ionode_id )
  CALL mp_bcast ( celvol, ionode_id )
  CALL mp_bcast ( al, ionode_id )
  CALL mp_bcast ( a, ionode_id )
  CALL mp_bcast ( adot, ionode_id )
  CALL mp_bcast ( recvol, ionode_id )
  CALL mp_bcast ( bl, ionode_id )
  CALL mp_bcast ( b, ionode_id )
  CALL mp_bcast ( bdot, ionode_id )

  IF ( ns .NE. nspin ) CALL errore ( 'write_cd', 'ns', 1 )
  IF ( ng .NE. ngm_g ) CALL errore ( 'write_cd', 'ng', 1 )
  IF ( na .NE. nat ) CALL errore ( 'write_cd', 'na', 1 )
  IF ( nr ( 1 ) .NE. dfftp%nr1 .OR. nr ( 2 ) .NE. dfftp%nr2 .OR. nr ( 3 ) .NE. dfftp%nr3 ) &
    CALL errore ( 'write_cd', 'nr', 1 )
  IF ( abs ( celvol - omega ) .GT. eps6 ) &
    CALL errore ( 'write_cd', 'unit cell volume', 1 )
  xdel = 0.0D0
  DO i = 1, 3
    DO j = 1, 3
      xdel = xdel + abs ( al * a ( j, i ) - alat * at ( j, i ) )
    ENDDO
  ENDDO
  IF ( xdel .GT. eps6 ) &
    CALL errore ( 'write_cd', 'direct lattice vectors', 1 )
  xdel = 0.0D0
  DO i = 1, 3
    DO j = 1, 3
      xdel = xdel + abs ( bl * b ( j, i ) - tpiba * bg ( j, i ) )
    ENDDO
  ENDDO
  IF ( xdel .GT. eps6 ) &
    CALL errore ( 'write_cd', 'reciprocal lattice vectors', 1 )

  ALLOCATE ( gvec ( 3, ng ) )
  IF ( real_or_complex .EQ. 1 ) THEN
    ALLOCATE ( rhogr ( ng, ns ) )
  ELSE
    ALLOCATE ( rhogc ( ng, ns ) )
  ENDIF
  ALLOCATE ( rhog ( ng, ns ) )

  IF ( ionode ) THEN
    READ ( iu )
    READ ( iu )
    READ ( iu )
    READ ( iu ) nrecord
    ig = 1
    DO irecord = 1, nrecord
      READ ( iu ) ng_irecord
      READ ( iu ) ( ( gvec ( ir, jg ), ir = 1, 3 ), jg = ig, ig + ng_irecord - 1 )
      ig = ig + ng_irecord
    ENDDO
    READ ( iu ) nrecord
    ig = 1
    DO irecord = 1, nrecord
      READ ( iu ) ng_irecord
      IF ( real_or_complex .EQ. 1 ) THEN
        READ ( iu ) ( ( rhogr ( jg, is ), jg = ig, ig + ng_irecord - 1 ), is = 1, ns )
      ELSE
        READ ( iu ) ( ( rhogc ( jg, is ), jg = ig, ig + ng_irecord - 1 ), is = 1, ns )
      ENDIF
      ig = ig + ng_irecord
    ENDDO
    DO is = 1, ns
      IF ( real_or_complex .EQ. 1 ) THEN
        DO ig = 1, ng
          rhog ( ig, is ) = CMPLX ( rhogr ( ig, is ), 0.0D0 )
        ENDDO
      ELSE
        DO ig = 1, ng
          rhog ( ig, is ) = rhogc ( ig, is )
        ENDDO
      ENDIF
    ENDDO
    CLOSE ( unit = iu, status = 'keep' )
  ENDIF

  IF ( real_or_complex .EQ. 1 ) THEN
    DEALLOCATE ( rhogr )
  ELSE
    DEALLOCATE ( rhogc )
  ENDIF

  IF ( ionode ) THEN
    DO is = 1, ns
      DO ig = 1, ng
        rhog ( ig, is ) = rhog ( ig, is ) / CMPLX ( omega, 0.0D0 )
      ENDDO
    ENDDO
  ENDIF

  CALL mp_bcast ( gvec, ionode_id )
  CALL mp_bcast ( rhog, ionode_id )

  fg = 0
  DO ig = 1, ngm
    IF ( ( gvec ( 1, ig_l2g ( ig ) ) .NE. mill ( 1, ig ) ) .OR. &
         ( gvec ( 2, ig_l2g ( ig ) ) .NE. mill ( 2, ig ) ) .OR. &
         ( gvec ( 3, ig_l2g ( ig ) ) .NE. mill ( 3, ig ) ) ) &
      fg = fg + 1
  ENDDO
  CALL mp_sum ( fg, intra_pool_comm )
  IF ( fg .GT. 0 ) THEN
    IF ( ionode ) WRITE ( 6, 101 )
    ALLOCATE ( rhog_unsrt ( ng, ns ) )
    rhog_unsrt ( :, : ) = rhog ( :, : )
    rhog ( :, : ) = ( 0.0D0, 0.0D0 )
    DO ig = 1, ng
      DO jg = 1, ngm
        IF ( ( mill ( 1, jg ) .EQ. gvec ( 1, ig ) ) .AND. &
             ( mill ( 2, jg ) .EQ. gvec ( 2, ig ) ) .AND. &
             ( mill ( 3, jg ) .EQ. gvec ( 3, ig ) ) ) THEN
          DO is = 1, ns
            rhog ( ig_l2g ( jg ), is ) = rhog_unsrt ( ig, is )
          ENDDO
        ENDIF
      ENDDO
    ENDDO
    DEALLOCATE ( rhog_unsrt )
    CALL mp_sum ( rhog, intra_pool_comm )
    gvec ( :, : ) = 0
    DO ig = 1, ngm
      gvec ( 1, ig_l2g ( ig ) ) = mill ( 1, ig )
      gvec ( 2, ig_l2g ( ig ) ) = mill ( 2, ig )
      gvec ( 3, ig_l2g ( ig ) ) = mill ( 3, ig )
    ENDDO
    CALL mp_sum ( gvec, intra_pool_comm )
  ENDIF

  DO is = 1, ns
    DO ig = 1, ngm
      rho%of_g ( ig, is ) = rhog ( ig_l2g ( ig ), is )
    ENDDO
  ENDDO

  DEALLOCATE ( rhog )

  DO is = 1, ns
    DO ig = 1, ngm
      psic ( nl ( ig ) ) = rho%of_g ( ig, is )
    ENDDO
    CALL invfft ( 'Dense', psic, dfftp )
    DO ir = 1, dfftp%nnr
      rho%of_r ( ir, is ) = psic ( ir )
    ENDDO
  ENDDO

  CALL create_directory ( output_dir_name )

  filename = TRIM ( output_dir_name ) // '/gvectors.dat'

  IF ( ionode ) THEN
    CALL iotk_open_write ( iu, FILE = TRIM ( filename ), SKIP_ROOT = .TRUE., BINARY = .TRUE. )
    CALL iotk_write_begin ( iu, "G-VECTORS" )
    CALL iotk_write_attr ( attr, "nr1s", dfftp%nr1, FIRST = .TRUE. )
    CALL iotk_write_attr ( attr, "nr2s", dfftp%nr2 )
    CALL iotk_write_attr ( attr, "nr3s", dfftp%nr3 )
    CALL iotk_write_attr ( attr, "gvect_number", ng )
    CALL iotk_write_attr ( attr, "gamma_only", .FALSE. )
    CALL iotk_write_attr ( attr, "units", "crystal" )
    CALL iotk_write_empty ( iu, "INFO", ATTR = attr )
    CALL iotk_write_dat ( iu, "g", gvec ( 1 : 3, 1 : ng ), COLUMNS = 3 )
    CALL iotk_write_end ( iu, "G-VECTORS" )
    CALL iotk_close_write ( iu )
  ENDIF

  DEALLOCATE ( gvec )

  CALL write_rho ( rho%of_r, nspin )

  RETURN

  101 FORMAT ( 5X, "WARNING: reordering G-vectors" )

END SUBROUTINE write_cd

!-------------------------------------------------------------------------------

subroutine check_inversion(real_or_complex, ntran, mtrx, nspin, warn, real_need_inv)

! check_inversion    Originally By D. Strubbe    Last Modified 10/14/2010
! Check whether our choice of real/complex version is appropriate given the
! presence or absence of inversion symmetry.

  USE io_global, ONLY : ionode

  implicit none

  integer, intent(in) :: real_or_complex
  integer, intent(in) :: ntran
  integer, intent(in) :: mtrx(3, 3, 48)
  integer, intent(in) :: nspin
  logical, intent(in) :: warn ! set to false to suppress warnings, for converters
  logical, intent(in) :: real_need_inv ! use for generating routines to block real without inversion

  integer :: invflag, isym, ii, jj, itest

  invflag = 0
  do isym = 1, ntran
    itest = 0
    do ii = 1, 3
      do jj = 1, 3
        if(ii .eq. jj) then
          itest = itest + (mtrx(ii, jj, isym) + 1)**2
        else
          itest = itest + mtrx(ii, jj, isym)**2
        endif
      enddo
    enddo
    if(itest .eq. 0) invflag = invflag + 1
    if(invflag .gt. 1) call errore('check_inversion', 'More than one inversion symmetry operation is present.', invflag)
  enddo

  if(real_or_complex .eq. 2) then
    if(invflag .ne. 0 .and. warn) then
      if(ionode) write(6, '(a)') 'WARNING: Inversion symmetry is present. The real version would be faster.'
    endif
  else
    if(invflag .eq. 0) then
      if(real_need_inv) then
        call errore('check_inversion', 'The real version cannot be used without inversion symmetry.', -1)
      endif
      if(ionode) then
        write(6, '(a)') 'WARNING: Inversion symmetry is absent in symmetries used to reduce k-grid.'
        write(6, '(a)') 'Be sure inversion is still a spatial symmetry, or you must use complex version instead.'
      endif
    endif
    if(nspin .eq. 2) then
      call errore('check_inversion', &
        'Time-reversal symmetry is absent in spin-polarized calculation. Complex version must be used.', -2)
    endif
  endif

  return

end subroutine check_inversion

end module bgw2pw_m

!-------------------------------------------------------------------------------

PROGRAM bgw2pw

  USE environment, ONLY : environment_start, environment_end
  USE io_files, ONLY : prefix, tmp_dir, outdir
  USE io_global, ONLY : ionode, ionode_id
  USE kinds, ONLY : DP
  USE mp, ONLY : mp_bcast
  USE mp_global, ONLY : mp_startup
  USE bgw2pw_m

  IMPLICIT NONE

  character(len=6) :: codename = 'BGW2PW'

  integer :: real_or_complex
  logical :: wfng_flag
  character ( len = 256 ) :: wfng_file
  integer :: wfng_nband
  logical :: rhog_flag
  character ( len = 256 ) :: rhog_file

  NAMELIST / input_bgw2pw / prefix, outdir, &
    real_or_complex, wfng_flag, wfng_file, wfng_nband, &
    rhog_flag, rhog_file

  integer :: ios
  character ( len = 256 ) :: input_file_name
  character ( len = 256 ) :: output_dir_name

  character (len=256), external :: trimcheck

#ifdef __PARA
  CALL mp_startup ( )
#endif
  CALL environment_start ( codename )

  prefix = 'prefix'
  CALL get_env ( 'ESPRESSO_TMPDIR', outdir )
  IF ( TRIM ( outdir ) == ' ' ) outdir = './'
  real_or_complex = 2
  wfng_flag = .FALSE.
  wfng_file = 'WFN'
  wfng_nband = 0
  rhog_flag = .FALSE.
  rhog_file = 'RHO'

  IF ( ionode ) THEN
    CALL input_from_file ( )
    READ ( 5, input_bgw2pw, iostat = ios )
    IF ( ios /= 0 ) CALL errore ( codename, 'input_bgw2pw', abs ( ios ) )
    IF ( real_or_complex /= 1 .AND. real_or_complex /= 2 ) &
      CALL errore ( codename, 'real_or_complex', 1 )
    IF ( wfng_nband .LT. 0 ) CALL errore ( codename, 'wfng_nband', 1 )
  ENDIF

  tmp_dir = trimcheck ( outdir )
  CALL mp_bcast ( outdir, ionode_id )
  CALL mp_bcast ( tmp_dir, ionode_id )
  CALL mp_bcast ( prefix, ionode_id )
  CALL mp_bcast ( real_or_complex, ionode_id )
  CALL mp_bcast ( wfng_flag, ionode_id )
  CALL mp_bcast ( wfng_file, ionode_id )
  CALL mp_bcast ( wfng_nband, ionode_id )
  CALL mp_bcast ( rhog_flag, ionode_id )
  CALL mp_bcast ( rhog_file, ionode_id )

  CALL read_file ( )
  CALL openfil_pp ( )

  IF ( wfng_flag ) THEN
    input_file_name = TRIM ( outdir ) // '/' // TRIM ( wfng_file )
    output_dir_name = TRIM ( outdir ) // '/' // TRIM ( prefix ) // '.save'
    IF ( ionode ) WRITE ( 6, '(5x,"call write_evc")' )
    CALL start_clock ( 'write_evc' )
    CALL write_evc ( input_file_name, real_or_complex, wfng_nband, &
      output_dir_name )
    CALL stop_clock ( 'write_evc' )
    IF ( ionode ) WRITE ( 6, '(5x,"done write_evc",/)' )
  ENDIF

  IF ( rhog_flag ) THEN
    input_file_name = TRIM ( outdir ) // '/' // TRIM ( rhog_file )
    output_dir_name = TRIM ( outdir ) // '/' // TRIM ( prefix ) // '.save'
    IF ( ionode ) WRITE ( 6, '(5x,"call write_cd")' )
    CALL start_clock ( 'write_cd' )
    CALL write_cd ( input_file_name, real_or_complex, output_dir_name )
    CALL stop_clock ( 'write_cd' )
    IF ( ionode ) WRITE ( 6, '(5x,"done write_cd",/)' )
  ENDIF

  IF ( ionode ) WRITE ( 6, * )
  IF ( wfng_flag ) CALL print_clock ( 'write_evc' )
  IF ( rhog_flag ) CALL print_clock ( 'write_cd' )

  CALL environment_end ( codename )
  CALL stop_pp ( )

  STOP

END PROGRAM bgw2pw

!===============================================================================
!
! Routines:
!
! 1. read_cube()        Originally By gsm       Last Modified 9/3/2010 (gsm)
!
!    Reads Gaussian Cube file fnam on unit unum. The result is placed
!    into real (if ip = 1) or imaginary (if ip = 2) part of array boxr
!    on node 0 (if fparafft = .true.) or array boxr_d distributed over
!    nodes (if fparafft = .false.). Gaussian Cube file is tested using
!    lattice vectors a and lattice constant al (in Bohr), FFTgrid is FFT
!    grid size, Nplane is number of FFT xy-planes per node, ierr is
!    return error code (0 means success).
!
!===============================================================================

#include "f_defs.h"

module read_cube_m

  use global_m
  implicit none

  private

  public :: read_cube

  contains

subroutine read_cube(fparafft,unum,fnam,a,al,ip,Nplane,FFTgrid,boxr,boxr_d,ierr)
  logical, intent(in) :: fparafft
  integer, intent(in) :: unum
  character(len=256), intent(in) :: fnam
  real(DP), intent(in) :: al
  real(DP), intent(in) :: a(3,3)
  integer, intent(in) :: ip
  integer, intent(in) :: Nplane
  integer, intent(in) :: FFTgrid(3)
  complex(DPC), pointer, intent(inout) :: boxr(:,:,:) !< (FFTgrid(1),FFTgrid(2),FFTgrid(3))
  complex(DPC), pointer, intent(inout) :: boxr_d(:,:,:) !< (FFTgrid(1),FFTgrid(2),Nplane)
  integer, intent(out) :: ierr

  real(DP), parameter :: eps4 = 1.0d-4
  
  integer :: i,j,k,k0,k1,k2,jerr,knum,na,ngrid(3)
  real(DP) :: dr,origin(3),step(3,3)
  real(DP), allocatable :: buffer(:)
  character(len=256) :: tmpstr
  
  PUSH_SUB(read_cube)
  
  if (peinf%inode.eq.0) then
    na=0
    ngrid(:)=0
    origin(:)=0.0d0
    step(:,:)=0.0d0
    call open_file(unit=unum,file=fnam,status='old',form='formatted')
    read(unum,*,iostat=jerr)
    if (jerr.eq.0) read(unum,*,iostat=jerr)
    if (jerr.eq.0) read(unum,*,iostat=jerr)na,(origin(j),j=1,3)
    do i=1,3
      if (jerr.eq.0) read(unum,*,iostat=jerr)ngrid(i),(step(j,i),j=1,3)
    enddo
    if (jerr.eq.0) call close_file(unit=unum)
  endif
  
#ifdef MPI
  call MPI_Bcast(jerr,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(na,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(ngrid,3,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(origin,3,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(step,9,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
#endif
  
  if (ngrid(1).ne.FFTgrid(1).or.ngrid(2).ne.FFTgrid(2).or. &
    ngrid(3).ne.FFTgrid(3)) jerr=1
  dr=0.0d0
  do j=1,3
    dr=dr+abs(origin(j))
  enddo
  dr=dr/dble(3)
  if (dr.gt.eps4) jerr=1
  dr=0.0d0
  do i=1,3
    do j=1,3
      dr=dr+abs(dble(ngrid(i))*step(j,i)-al*a(j,i))
    enddo
  enddo
  dr=dr/dble(9)
  if (dr.gt.eps4) jerr=1

  if (jerr .ne. 0) write(0,*) 'WARNING: Inconsistency in your calculation and .cube file.'
  if (jerr .ne. 0) write(0,*) 'al',al
  if (jerr .ne. 0) write(0,*) 'a',a
  if (jerr .ne. 0) write(0,*) 'ngrid',ngrid
  if (jerr .ne. 0) write(0,*) 'FFTgrid',FFTgrid
  if (jerr .ne. 0) write(0,*) 'step',step
  
  if (jerr.eq.0) then
    SAFE_ALLOCATE(buffer, (FFTgrid(3)))
    if (peinf%inode.eq.0) then
      if (mod(FFTgrid(3),6).eq.0) then
        knum=FFTgrid(3)/6
      else
        knum=FFTgrid(3)/6+1
      endif
      call open_file(unit=unum,file=fnam,status='old',form='formatted')
      do i=1,6+na
        read(unum,*)
      enddo
    endif
    do i=1,FFTgrid(1)
      do j=1,FFTgrid(2)
        if (peinf%inode.eq.0) then
          do k=1,knum
            read(unum,103)tmpstr
            k1=6*(k-1)+1
            k2=6*(k-1)+6
            if (k2.gt.FFTgrid(3)) k2=FFTgrid(3)
            read(tmpstr,*)(buffer(k0),k0=k1,k2)
          enddo
        endif
        if (fparafft) then
#ifdef MPI
          call MPI_Bcast(buffer,FFTgrid(3),MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
#endif
          if (ip.eq.1) then
            do k=1,FFTgrid(3)
              if (k.ge.Nplane*peinf%inode+1.and.k.le.Nplane*(peinf%inode+1)) &
                boxr_d(i,j,k-Nplane*peinf%inode)=CMPLX(buffer(k),IMAG(boxr_d(i,j,k-Nplane*peinf%inode)))
            enddo
          elseif (ip.eq.2) then
            do k=1,FFTgrid(3)
              if (k.ge.Nplane*peinf%inode+1.and.k.le.Nplane*(peinf%inode+1)) &
                boxr_d(i,j,k-Nplane*peinf%inode)=CMPLX(dble(boxr_d(i,j,k-Nplane*peinf%inode)),buffer(k))
            enddo
          endif
        else
          if (ip.eq.1) then
            do k=1,FFTgrid(3)
              boxr(i,j,k)=CMPLX(buffer(k),IMAG(boxr(i,j,k)))
            enddo
          elseif (ip.eq.2) then
            do k=1,FFTgrid(3)
              boxr(i,j,k)=CMPLX(dble(boxr(i,j,k)),buffer(k))
            enddo
          endif
        endif
      enddo
    enddo
    if (peinf%inode.eq.0) then
      call close_file(unit=unum)
    endif
    SAFE_DEALLOCATE(buffer)
  endif
  
  ierr=jerr
  
  POP_SUB(read_cube)
  
  return
  
103 format(a)
  
end subroutine read_cube

end module read_cube_m

!-----------------------------------------------------------------------
!
! module fullbz_m
!
! Routines: fullbz
!
! If wigner_seitz = .true. (for BSE, PlotXct, NonLinearOptics)
!     Uses a Wigner-Seitz construction to define the Brillouin zone.
! If wigner_seitz = .false. (for Epsilon, Sigma)
!     Uses the usual "box" BZ.
!
!     input: crys,syms type
!            ntran (number of symmetry operations)
!            gr%nr
!            gr%rk
!
!     output: gr type (except gr%nr, gr%rk)
!
!-----------------------------------------------------------------------

#include "f_defs.h"

module fullbz_m

  use global_m
  use misc_m
  implicit none

  private

  public :: fullbz, dealloc_grid

contains

  subroutine fullbz(crys,syms,gr,ntran,skip_checkbz,wigner_seitz,paranoid,do_nothing,nfix)
    type (crystal), intent(in) :: crys
    type (symmetry), intent(in) :: syms
    type (grid), intent(inout) :: gr
    integer, intent(in) :: ntran !< number of sym ops, typically syms%ntrans
    logical, intent(out) :: skip_checkbz
    logical, intent(in) :: wigner_seitz !< do a Wigner-Seitz construction
    logical, intent(in) :: paranoid !< perform paranoia check: no k-pts differ by G-vector
    logical, optional, intent(in) :: do_nothing !< initialize without performing any checks.
    integer, optional, intent(in) :: nfix !< don`t unfold the first nfix points
    
    integer :: ii,jj,kk,it,ir,if,i1,i2,i3,gpt(3),iostat_c,ntran_
    real(DP) :: tmpf(3),tmpfm(3),length,lmin,fq(3)
    real(DP), allocatable :: fk(:,:),kg0(:,:)
    integer, allocatable :: indr(:),itran(:)
    logical :: found
!
!  i  r,nr   k-points in irr bz
!  o  fk,gr%nf   k-points in full bz
!  o  sz     radius of a spherical subzone equivalent to
!            one point in the set fk
!
!     Loop over ir-points
!
    PUSH_SUB(fullbz)

    if(present(do_nothing)) then
      if(do_nothing) then
        if(wigner_seitz .or. paranoid) call die("bug: cannot call fullbz with do_nothing and wigner_seitz or paranoid.")
        gr%nf=gr%nr
        gr%sz=2.0d0*PI_D*(3.0d0/(4.0d0*PI_D*gr%nf*crys%celvol))**(1.0d0/3.0d0)
        SAFE_ALLOCATE(gr%kg0,(3,gr%nf))
        SAFE_ALLOCATE(gr%f,(3,gr%nf))
        SAFE_ALLOCATE(gr%itran,(gr%nf))
        SAFE_ALLOCATE(gr%indr,(gr%nf))
        gr%kg0(:,:)=0
        gr%itran(:)=1
        gr%f(:,:)=gr%r(:,:)
        do ii=1,gr%nf
          gr%indr(ii)=ii
        enddo
        skip_checkbz = .true.
        POP_SUB(fullbz)
        return
      endif
    endif

    SAFE_ALLOCATE(fk, (3,gr%nr*ntran))
    SAFE_ALLOCATE(indr, (gr%nr*ntran))
    SAFE_ALLOCATE(itran, (gr%nr*ntran))

    call open_file(unit=21,file='fullbz.dat',status='old',iostat=iostat_c)
    skip_checkbz = (iostat_c==0)
    if (skip_checkbz) then
      write(6,'(3x,a)') 'Reading the full Brillouin Zone from fullbz.dat'
      write(6,'(3x,a)') 'Will not be checking if the points there form a full zone'
      read(21,*) gr%nf
      do ii=1,gr%nf
        read(21,*) fk(1:3,ii),itran(ii),indr(ii)
      enddo
      call close_file(21)
      ! This is just in case we want to do wigner_seitz or paranoid
    else
      gr%nf=0

      do ir=1,gr%nr
!
!       Loop over transformations
!
        ntran_ = ntran
        if (present(nfix)) then
          if (ir<=nfix) ntran_ = 1
        endif
        do it=1,ntran_
!
!         Rotate gr%r and put into tmpf
!
          tmpf(:) = matmul(dble(syms%mtrx(:,:,it)),gr%r(:,ir))
        
          call k_range(tmpf, gpt, TOL_Small)
!
!         Compare to other points in full zone
!
          found = .false.
          do if=1,gr%nf
            if(all(abs(tmpf(1:3)-fk(1:3,if)).lt.TOL_Small)) then
              found = .true.
              exit
            endif
          enddo
          if(found) cycle  ! skip adding it
!
!         Store new kpoint in fbz
!
          gr%nf=gr%nf+1
          if (gr%nf > gr%nr * ntran) call die('fullbz internal error')
          fk(1:3,gr%nf)=tmpf(1:3)
!
!         Store index of rotation itran and corresponding IBZ point
!
          itran(gr%nf)=it
          indr(gr%nf)=ir

        enddo !end loop over symmetries
      enddo !end loop over the q-points from epsmat and eps0mat
    endif ! whether reading from fullbz.dat

!
! SIB:  Now that we have the full BZ with components [0,1), we
! will move each point into the Wigner-Seitz cell by adding G-vectors
! to it until we get the shortest length vector we can.  Then we find
! the appropriate Umklapp vector as well (kg0).
!

    if(wigner_seitz) then
      SAFE_ALLOCATE(kg0, (3,gr%nr*ntran))

      do ii=1,gr%nf
        tmpf(:) = fk(:,ii)
        lmin = 1.0d10
        do i1=-ncell+1,ncell
          do i2=-ncell+1,ncell
            do i3=-ncell+1,ncell
              fq(1) = tmpf(1) - i1
              fq(2) = tmpf(2) - i2
              fq(3) = tmpf(3) - i3
              length = DOT_PRODUCT(fq,MATMUL(crys%bdot,fq))
              if (length.lt.lmin) then
                lmin = length
                tmpfm(:) = fq(:)
              endif
            enddo
          enddo
        enddo
        fk(:,ii) = tmpfm
!
! SIB: Find Umklapp (kg0) a.k.a. translation
!
        tmpf = MATMUL(dble(syms%mtrx(:,:,itran(ii))),gr%r(:,indr(ii)))
        tmpf(:) = fk(:,ii) - tmpf
        do jj=1,3
          if (tmpf(jj).ge.0.0) kg0(jj,ii)=tmpf(jj)+TOL_Small
          if (tmpf(jj).lt.0.0) kg0(jj,ii)=tmpf(jj)-TOL_Small
        enddo

      enddo !over full zone (ii)

      SAFE_ALLOCATE(gr%kg0, (3,gr%nf))
      gr%kg0(1:3,1:gr%nf)=kg0(1:3,1:gr%nf)
      SAFE_DEALLOCATE(kg0)

    else
      nullify(gr%kg0)
    endif

!------------------------------------------------------------------------
! SIB:  Paranoia check.  We will compare all pairs of points in the full
! zone to each other in order to see if any of them differ by a G-vector.
! If they do, we are in big trouble and stop!


    if(paranoid) then
      ii_loop: do ii=1,gr%nf
        do jj=1,ii-1
          tmpf = abs(fk(:,ii)-fk(:,jj))
! after this loop, tmpf contains how far each component of fii-fjj is
! from the closest integer to it.
          do kk=1,3
            it = tmpf(kk)
            tmpf(kk) = tmpf(kk)-it
            if (tmpf(kk).ge.0.5) tmpf(kk)=1.0-tmpf(kk)
          enddo
! if fkii-fkjj is very close to an integer vector (G-vector), trouble!
          if (sum(abs(tmpf)).le.TOL_Small) then
            write(0,123) ii,jj,fk(:,ii)-fk(:,jj)
123         format('equiv kpts',i4,' and ',i4,' diff=',3f10.5)
            call die('equivalent points found in the full BZ')
          endif
        enddo
      enddo ii_loop
    endif

!------------------------------------------------------------------------
! SIB: Now store all gathered information where it belongs

    SAFE_ALLOCATE(gr%f, (3,gr%nf))
    SAFE_ALLOCATE(gr%indr, (gr%nf))
    SAFE_ALLOCATE(gr%itran, (gr%nf))
    gr%f(1:3,1:gr%nf)=fk(1:3,1:gr%nf)
    gr%indr(1:gr%nf)=indr(1:gr%nf)
    gr%itran(1:gr%nf)=itran(1:gr%nf)
    SAFE_DEALLOCATE(fk)
    SAFE_DEALLOCATE(indr)
    SAFE_DEALLOCATE(itran)

!     Compute radius of spherical subzone
!     assuming bz filled with gr%nf spheres

    gr%sz=2.0d0*PI_D*(3.0d0/(4.0d0*PI_D*gr%nf*crys%celvol))**(1.0d0/3.0d0)

    if (ntran.eq.1 .and. gr%nf.ne.gr%nr .and. paranoid) then
      write(0,*) gr%nf, ' and ', gr%nr
      call die('fullbz paranoia check failed')
    endif
    
    POP_SUB(fullbz)
    
    return
  end subroutine fullbz
  
  !-----------------------------------------------------------------------
  subroutine dealloc_grid(gr)
    type(grid), intent(inout) :: gr

    PUSH_SUB(dealloc_grid)

    SAFE_DEALLOCATE_P(gr%r)
    SAFE_DEALLOCATE_P(gr%f)
    SAFE_DEALLOCATE_P(gr%indr)
    SAFE_DEALLOCATE_P(gr%itran)
    SAFE_DEALLOCATE_P(gr%kg0)

    POP_SUB(dealloc_grid)
    return
  end subroutine dealloc_grid

end module fullbz_m

!===============================================================================
!
! Module:
!
! (1) check_inversion_m   Originally By DAS            Last Modified 10/14/2010
!
!   Check whether our choice of real/complex version is appropriate given the
!   presence or absence of inversion symmetry about the origin, and a guess
!   about time-reversal symmetry depending on the number of spin-components.
!
!===============================================================================

#include "f_defs.h"

module check_inversion_m

  use global_m
  implicit none

  private

  public :: check_inversion, check_inversion_type

contains  

subroutine check_inversion(iflavor, ntran, mtrx, nspin, warn, real_need_inv, tnp)
  integer, intent(in) :: iflavor
  integer, intent(in) :: ntran
  integer, intent(in) :: mtrx(3, 3, 48) !< symmetry operations matrices
  integer, intent(in) :: nspin
  logical, intent(in) :: warn !< set to false to suppress warnings, for converters
  logical, intent(in) :: real_need_inv !< use for generating routines to block real without inversion
     !! this is not always true so that it is possible to run real without using symmetries
  real(DP), optional, intent(in) :: tnp(3, 48) !< fractional translations.
     !! optional only to avoid changing external interface for library.

  integer :: invflag, isym, ii, jj, itest, real_or_complex
  logical :: origin_inv
  character(len=7) :: sflavor

  PUSH_SUB(check_inversion)

  if(iflavor .eq. 0) then
#ifdef CPLX
    real_or_complex = 2
#else
    real_or_complex = 1
#endif
  elseif(iflavor .eq. 1 .or. iflavor .eq. 2) then
    real_or_complex = iflavor
  else
    write(sflavor, '(i7)') iflavor
    call die("Illegal value iflavor = " // TRUNC(sflavor) // " passed to check_inversion: must be 0,1,2.", &
      only_root_writes=.true.)
  endif

  invflag = 0
  origin_inv = .false.
  do isym = 1, ntran
    itest = 0
    do ii = 1, 3
      do jj = 1, 3
        if(ii .eq. jj) then
          itest = itest + (mtrx(ii, jj, isym) + 1)**2
        else
          itest = itest + mtrx(ii, jj, isym)**2
        endif
      enddo
    enddo
    if(itest .eq. 0) then
      invflag = invflag + 1
      if(present(tnp)) then
        if(sum(abs(tnp(1:3, isym))) < TOL_Small) origin_inv = .true.
      else
        origin_inv = .true.
      endif
    endif
  enddo
  if(invflag > 0 .and. .not. origin_inv .and. peinf%inode==0) then
    write(0, '(a)') "WARNING: Inversion symmetry is present only with a fractional translation."
    write(0, '(a)') "Apply the translation so inversion is about the origin, to be able to use the real version."
  endif
  if(invflag .gt. 1 .and. peinf%inode==0) &
    write(0, '(a)') "WARNING: More than one inversion symmetry operation is present."

  if(invflag > 0 .and. .not. present(tnp) .and. peinf%inode==0) then
    write(0, '(a)') "WARNING: check_inversion did not receive fractional translations."
    write(0, '(a)') "Cannot confirm that inversion symmetry is about the origin for use of real version."
  endif

  if(real_or_complex .eq. 2) then
    if(origin_inv .and. warn .and. nspin == 1) then
      if(peinf%inode .eq. 0) &
        write(0, '(a)') "WARNING: Inversion symmetry about the origin is present. The real version would be faster."
    endif
  else
    if(.not. origin_inv) then
      if(real_need_inv) then
        call die("The real version cannot be used without inversion symmetry about the origin.", only_root_writes = .true.)
      endif
      if(peinf%inode .eq. 0) then
        write(0, '(a)') "WARNING: Inversion symmetry about the origin is absent in symmetries used to reduce k-grid."
        write(0, '(a)') "Be sure inversion about the origin is still a spatial symmetry, or you must use complex version instead."
      endif
    endif
    if(nspin > 1) then
      call die("Real version may only be used for spin-unpolarized calculations.", only_root_writes = .true.)
    endif
  endif

  POP_SUB(check_inversion)
  return
end subroutine check_inversion

!=========================================================================
!> wrapper routine that uses typedefs types
subroutine check_inversion_type(iflavor, syms, nspin, warn, real_need_inv)
  integer, intent(in) :: iflavor
  type (symmetry), intent(in) :: syms
  integer, intent(in) :: nspin
  logical, intent(in) :: warn
  logical, intent(in) :: real_need_inv !< use for generating routines to block real without inversion

  PUSH_SUB(check_inversion_type)

  call check_inversion(iflavor, syms%ntran, syms%mtrx, nspin, warn, real_need_inv, tnp = syms%tnp)

  POP_SUB(check_inversion_type)
  return
end subroutine check_inversion_type

end module check_inversion_m

!===============================================================================
!
! MODULE:
!
!   splines_m     Originally by FHJ     Last Modified 10/24/2011 (FHJ)
!
!>    Routines to evaluate spline curves.
!
! DESCRIPTION:
!
!     Main functions were adapted from P. Dierckx`s FITPACK (BSD License):
!       http://www.netlib.org/dierckx/
!       http://nalag.cs.kuleuven.be/research/topics/fitpack.shtml
!       http://www.scipy.org/doc/api_docs/SciPy.interpolate.fitpack.html
!
!===============================================================================

#include "f_defs.h"

module splines_m

  use global_m
  implicit none

  private

  public :: splev, splev_shift

contains

  !The following functions were downloaded from:
  ! http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=dierckx%2Fsplev.f
  !The code was converted to F90 using Alan Miller`s 'to_f90' utility:
  ! http://jblevins.org/mirror/amiller/to_f90.f90


  !> Subroutine fpbspl evaluates the (k+1) non-zero b-splines of degree k at
  !! t(l) <= x < t(l+1) using the stable recurrence relation of de Boor and Cox.
  subroutine fpbspl(t,n,k,x,l,h)
    real(DP), intent(in)   :: t(:) !< (n)
    integer, intent(in)    :: n
    integer, intent(in)    :: k
    real(DP), intent(in)   :: x
    integer, intent(in)    :: l
    real(DP), intent(out)  :: h(6)

    !  ..local scalars..
    real(DP) :: f,one
    integer :: i,j,li,lj
    !  ..local arrays..
    real(DP) :: hh(5)
    !  ..

    PUSH_SUB(fpbspl)

    one = 0.1d+1
    h(1) = one
    do j=1,k
      do i=1,j
        hh(i) = h(i)
      end do
      h(1) = 0.0d0
      do i=1,j
        li = l+i
        lj = li-j
        f = hh(i)/(t(li)-t(lj))
        h(i) = h(i)+f*(t(li)-x)
        h(i+1) = f*(x-t(lj))
      end do
    end do

    POP_SUB(fpbspl)
  end subroutine fpbspl

  !> Subroutine splev evaluates in a number of points x(i),i=1,2,...,m
  !!   a spline s(x) of degree k, given in its b-spline representation.
  !!
  !! Restrictions:
  !!   \li m >= 1
  !!   \li t(k+1) <= x(i) <= x(i+1) <= t(n-k) , i=1,2,...,m-1.
  !!
  !!   \param t  array, length n, which contains the position of the knots.
  !!   \param n  integer, giving the total number of knots of s(x).
  !!   \param c  array, length n, which contains the b-spline coefficients.
  !!   \param k  integer, giving the degree of s(x).
  !!   \param x  array, length m, which contains the points where s(x) must
  !!     be evaluated.
  !!   \param m  integer, giving the number of points where s(x) must be
  !!     evaluated.
  !!   \param y  array,length m, giving the value of s(x) at the different
  !!     points.
  !!   \param ier error flag:
  !!     \li ier = 0:  normal return
  !!     \li ier = 10: invalid input data (see restrictions)
  subroutine splev(t,n,c,k,x,y,m,ier)
    !  Other subroutines required: fpbspl.

    !  References :
    !    de boor c  : on calculating with b-splines, j. approximation theory
    !                 6 (1972) 50-62.
    !    cox m.g.   : the numerical evaluation of b-splines, j. inst. maths
    !                 applics 10 (1972) 134-149.
    !    dierckx p. : curve and surface fitting with splines, monographs on
    !                 numerical analysis, oxford university press, 1993.

    !  Author :
    !    p.dierckx
    !    dept. computer science, k.u.leuven
    !    celestijnenlaan 200a, b-3001 heverlee, belgium.
    !    e-mail : Paul.Dierckx@cs.kuleuven.ac.be

    !  Latest Update : march 1987
    !  Removed go to usage, DAS Jan 2012

    !  ..scalar arguments..

    real(DP), intent(in)      :: t(:) !< (n)
    integer, intent(in)       :: n
    real(DP), intent(in)      :: c(:) !< (n)
    integer, intent(in)       :: k
    real(DP), intent(in)      :: x(:) !< (m)
    real(DP), intent(out)     :: y(:) !< (m)
    integer, intent(in)       :: m
    integer, intent(out)      :: ier

    !  ..array arguments..

    !  ..local scalars..
    integer :: i,j,k1,l,ll,l1,nk1
    real(DP) :: arg,sp,tb,te
    !  ..local array..
    real(DP) :: h(6)

    PUSH_SUB(splev)

    !  ..
    !  before starting computations a data check is made. if the input data
    !  are invalid control is immediately repassed to the calling program.
    ier = 10
    if(m-1 < 0) then
      POP_SUB(splev)
      return
    endif
    do i=2,m
      if(x(i) < x(i-1)) then
        POP_SUB(splev)
        return
      endif
    end do
    ier = 0
    !  fetch tb and te, the boundaries of the approximation interval.
    k1 = k+1
    nk1 = n-k1
    tb = t(k1)
    te = t(nk1+1)
    l = k1
    l1 = l+1
    !  main loop for the different points.
    do  i=1,m
    !  fetch a new x-value arg.
      arg = x(i)
      if(arg < tb) arg = tb
      if(arg > te) arg = te
    !  search for knot interval t(l) <= arg < t(l+1)
      40    if(arg < t(l1) .or. l == nk1) go to 50
      l = l1
      l1 = l+1
      go to 40
    !  evaluate the non-zero b-splines at arg.
      50    call fpbspl(t,n,k,arg,l,h)
    !  find the value of s(x) at x=arg.
      sp = 0.
      ll = l-k1
      do  j=1,k1
        ll = ll+1
        sp = sp+c(ll)*h(j)
      end do
      y(i) = sp
    end do

    POP_SUB(splev)
    return
  end subroutine splev
  
  !> Similar to splines_m::splev, but modifies the energy by using the scissors operators
  !!   described by tck.
  !!   \param tck b-spline coefficient for scissors operators, in eV.
  !!   \param E LDA energy (will be overwritten by the corrected one).
  !!   \param ryd optional parameter that tells whether E is in Ryd.
  !!     Default is <tt>.true.</tt>. Note: tck is always assumed to be in eV.
  !!
  !!   \sa typedefs_m::spline_tck
  subroutine splev_shift(tck, E, in_ryd)
    type(spline_tck), intent(in)  :: tck
    real(DP), intent(inout)       :: E
    logical, optional, intent(in) :: in_ryd
  
    real(DP) :: x_arr(1)
    real(DP) :: y_arr(1)
    integer :: m, ier
    logical :: conv_units

    PUSH_SUB(splev_shift)

    conv_units = .true.
    if (present(in_ryd)) then
      if (.not. in_ryd) conv_units = .false.
    endif

    m=1 
    if (conv_units) then
      x_arr(1) = E*ryd
    else
      x_arr(1) = E
    endif
    call splev(tck%t,tck%n,tck%c,tck%k,x_arr,y_arr,m,ier)
    if (ier==0) then
      if (conv_units) then
        E = E + y_arr(1)/ryd
      else
        E = E + y_arr(1)
      endif
    else
      write(0,'(a)') 'WARNING: Error doing spline interpolation. Ignoring correction!'
    endif

    POP_SUB(splev_shift)
  end subroutine splev_shift

end module splines_m

!=========================================================================
!
! Routines:
!
! (1) offdiag           Originally By gsm        Last Modified 5/8/2009 (gsm)
!
! This routine reads in sigma_hp.log file, builds the Sigma matrix for each
! k-point and for each finite difference point (Ecor - dE, Ecor, Ecor + dE)
! according to Eq. (6) of Rohlfing & Louie PRB 62 4927, diagonalizes it with
! LAPACK and writes out the eigenvalues. This is a serial program, no MPI.
! If toff = -1/+1 the Hermitian matrix is constructed from the lower/upper
! triangle. No input file or command-line arguments are needed.
!
!=========================================================================

#include "f_defs.h"

program offdiag

  use global_m
  use lapack_m
  implicit none

  integer :: iunit,ierr,spin,ii,jj,ll
  integer :: freq_dep,bmin,bmax,loff,toff,fdf
  integer :: info,lda,ldvl,ldvr,lwork,nband,iw,nstart,nend
  real(DP) :: kk(3),elda,ecor,exch,sx,ch,sig,vxc,eqp0,eqp1,z1,z2
  SCALAR :: sig3,vxc3
  real(DP) :: max6(6)
  integer :: idx6(6,2)
  character*256 :: fl,str,tag
  integer, allocatable :: isort(:)
  SCALAR, allocatable :: ham(:,:),alda(:,:),vl(:,:),vr(:,:),work(:)
#ifdef CPLX
  real(DP) :: x2,sx2,ch2,sig2,vxc2,i2,j2,l2
  real(DP), allocatable :: rwork(:)
  complex(DPC), allocatable :: ww(:)
#else
  real(DP), allocatable :: wi(:),wr(:)
#endif  

  iunit=21
  fl = "sigma_hp.log"
  max6(:) = 0.0d0
  idx6(:,:)=0

  freq_dep=-2
  bmin=0
  bmax=0
  loff=-3
  toff=-2
  fdf=-3
  call open_file(unit=iunit,file=fl,status='old',form='formatted')
  ierr=0
  do while (ierr.eq.0)
    read(iunit,'(a)',iostat=ierr) str
    if (str(2:21).eq."frequency_dependence") then
      read(str(22:),*) freq_dep
      write(6,'(a,i2)') 'frequency_dependence = ', freq_dep
    endif
    if (str(2:11).eq."band_index") then
      read(str(12:),*) bmin, bmax
      write(6,'(a,i6,a,i6)') 'band min = ', bmin, ', band max = ', bmax
    endif
    if (str(2:13).eq."sigma_matrix") then
      read(str(14:),*) loff, toff
      write(6,'(a,i6,a,i6)') 'loff = ', loff, ', toff = ', toff
    endif
    if (str(2:23).eq."finite_difference_form") then
      read(str(24:),*) fdf
      write(6,*) 'finite difference form = ', fdf
    endif
  enddo
  call close_file(unit=iunit)
  if(freq_dep.lt.-1.or.freq_dep.gt.2) call die("unknown frequency dependence")
  if(bmin.lt.1.or.bmax.lt.bmin) call die("bmin out of range")
  if(loff.lt.-2.or.(loff.gt.0.and.loff.lt.bmin).or.loff.gt.bmax) call die("loff out of range")
  if(loff < 0) write(0,'(a)') 'WARNING: Sigma is not Hermitian unless all matrix elements are evaluated at the same energy.'
  if(toff.lt.-1.or.toff.gt.1) call die("toff out of range")
  if(fdf.lt.-2.or.fdf.gt.2) call die("fdf out of range")
  if (freq_dep .eq. 2) call die("Full frequency is not supported")
  
  if(loff == 0) call die("You need to use sigma_matrix in the sigma run to be able to use offdiag.")

  if (fdf.eq.-1) then
    nstart = 1
    nend = 2
  elseif (fdf.eq.0) then
    nstart = 1
    nend = 3
  elseif (fdf.eq.1) then
    nstart = 2
    nend = 3
  else
    nstart = 2
    nend = 2
  endif
  
  nband=bmax-bmin+1
  lda=nband
  ldvl=1
  ldvr=1
  lwork=2*nband
  
  SAFE_ALLOCATE(isort, (nband))
  SAFE_ALLOCATE(ham, (lda,nband))
  SAFE_ALLOCATE(alda, (lda,nband))
  SAFE_ALLOCATE(vl, (ldvl,nband))
  SAFE_ALLOCATE(vr, (ldvr,nband))
  SAFE_ALLOCATE(work, (lwork))
  lwork=-1
#ifdef CPLX
  SAFE_ALLOCATE(ww, (nband))
  SAFE_ALLOCATE(rwork, (2*nband))
  call zgeev('N','N',nband,ham,lda,ww,vl,ldvl,vr,ldvr,work,lwork,rwork,info)
  if (info.eq.0) lwork=int(dble(work(1)))
#else
  SAFE_ALLOCATE(wr, (nband))
  SAFE_ALLOCATE(wi, (nband))
  call dgeev('N','N',nband,ham,lda,wr,wi,vl,ldvl,vr,ldvr,work,lwork,info)
  if (info.eq.0) lwork=int(work(1))
#endif
  if (lwork.lt.1) then
    lwork=2*nband
  else
    SAFE_DEALLOCATE(work)
    SAFE_ALLOCATE(work, (lwork))
  endif
  
  alda(:,:)=0.0d0
  
  call open_file(unit=iunit,file=fl,status='old',form='formatted')
  write(6,*) "Reading matrix elements from " // trim(fl)
  ierr=0
  do while (ierr.eq.0)
    read(iunit,'(a)',iostat=ierr) str
    if (str(8:10).eq."k =") then
      read(str(11:40),*) kk(1:3)
      read(str(57:),*) spin
      write(6,205) kk(1:3), spin
      read(iunit,*)
      read(iunit,*)
      do
        read(iunit,'(a)') str
        if (len(trim(str)).eq.0) exit
        read(str,*) ii,elda,ecor,exch,sx,ch,sig,vxc,eqp0,eqp1
        alda(ii-bmin+1,ii-bmin+1)=elda
      enddo
      do iw = nstart, nend
        ham=alda
        if (iw.eq.1) write(6,501)
        if (iw.eq.2) write(6,502)
        if (iw.eq.3) write(6,503)
        read(iunit,*)
        read(iunit,*)
        do
          read(iunit,'(a)') str
          if (len(trim(str)).eq.0) exit
          read(str,*) ii,jj,ll,tag,exch,sx,ch,sig,vxc
          if(tag(1:4) /= 'real') call die("Incorrect tag " // TRUNC(tag) // " found in place of 'real'.")
#ifdef CPLX
          read(iunit,'(a)') str
          read(str,*) i2,j2,l2,tag,x2,sx2,ch2,sig2,vxc2
          if(tag(1:4) /= 'imag') call die("Incorrect tag " // TRUNC(tag) // " found in place of 'imag'.")
          sig3=CMPLX(sig,sig2)
          vxc3=CMPLX(vxc,vxc2)
#else
          sig3=sig
          vxc3=vxc
#endif
          ham(ii-bmin+1,jj-bmin+1)=ham(ii-bmin+1,jj-bmin+1)+sig3-vxc3
          if (ii .eq. jj) then
            if (max6(1) .lt. abs(sig3)) then
              max6(1) = abs(sig3)
              idx6(1,1) = ii
            endif
            if (max6(2) .lt. abs(vxc3)) then
              max6(2) = abs(vxc3)
              idx6(2,1) = ii
            endif
            if (max6(3) .lt. abs(sig3 - vxc3)) then
              max6(3) = abs(sig3 - vxc3)
              idx6(3,1) = ii
            endif
          else
            if (max6(4) .lt. abs(sig3)) then
              max6(4) = abs(sig3)
              idx6(4,1) = ii
              idx6(4,2) = jj
            endif
            if (max6(5) .lt. abs(vxc3)) then
              max6(5) = abs(vxc3)
              idx6(5,1) = ii
              idx6(5,2) = jj
            endif
            if (max6(6) .lt. abs(sig3 - vxc3)) then
              max6(6) = abs(sig3 - vxc3)
              idx6(6,1) = ii
              idx6(6,2) = jj
            endif
          endif
        enddo
        !
        ! construct the Hermitian matrix from the lower triangle
        !
        if (toff.eq.-1) then
          do ii=1,nband
            do jj=ii+1,nband
              ham(ii,jj)=MYCONJG(ham(jj,ii))
            enddo
          enddo
        endif
        !
        ! construct the Hermitian matrix from the upper triangle
        !
        if (toff.eq.1) then
          do ii=1,nband
            do jj=1,ii-1
              ham(ii,jj)=MYCONJG(ham(jj,ii))
            enddo
          enddo
        endif
        !
        ! diagonalize with LAPACK
        !
#ifdef CPLX
        call zgeev('N','N',nband,ham,lda,ww,vl,ldvl,vr,ldvr,work,lwork,rwork,info)
#else
        call dgeev('N','N',nband,ham,lda,wr,wi,vl,ldvl,vr,ldvr,work,lwork,info)
#endif
        !
        ! sort and output eigenvalues
        !
        if (info.eq.0) then
          do ii=1,nband
            isort(ii)=ii
          enddo
          do ii=1,nband-1
            ll=0
            z1=1.0d6
            do jj=ii,nband
#ifdef CPLX
              z2=dble(ww(isort(jj)))
#else
              z2=wr(isort(jj))
#endif
              if (z2.lt.z1) then
                ll=jj
                z1=z2
              endif
            enddo
            if (ll.gt.0) then
              jj=isort(ii)
              isort(ii)=isort(ll)
              isort(ll)=jj
            endif
          enddo
          do ii=1,nband
#ifdef CPLX
            write(6,209) ii,ww(isort(ii))
#else
            write(6,209) ii,wr(isort(ii)),wi(isort(ii))
#endif
          enddo
          write(6,*)
          write(6,701)max6(1),idx6(1,1)
          write(6,702)max6(2),idx6(2,1)
          write(6,703)max6(3),idx6(3,1)
          write(6,704)max6(4),idx6(4,1),idx6(4,2)
          write(6,705)max6(5),idx6(5,1),idx6(5,2)
          write(6,706)max6(6),idx6(6,1),idx6(6,2)
        else
          write(0,'(a,i6)') 'LAPACK error code = ', info
          call die("Failed to diagonalize Sigma matrix.")
        endif
      enddo
    endif
  enddo
  call close_file(unit=iunit)
  
  SAFE_DEALLOCATE(isort)
  SAFE_DEALLOCATE(ham)
  SAFE_DEALLOCATE(alda)
  SAFE_DEALLOCATE(vl)
  SAFE_DEALLOCATE(vr)
  SAFE_DEALLOCATE(work)
#ifdef CPLX
  SAFE_DEALLOCATE(ww)
  SAFE_DEALLOCATE(rwork)
#else
  SAFE_DEALLOCATE(wr)
  SAFE_DEALLOCATE(wi)
#endif

205 format(/,1x,"k =",3f10.6,1x,"s =",i2)
209 format(1x,i4,2f12.6)
501 format(/,1x,"sig(ecor - de)",/)
502 format(/,1x,"sig(ecor)",/)
503 format(/,1x,"sig(ecor + de)",/)
701 format(1x,"max_n  |<n|sig|n>|       =",f10.6," eV at n =",i4)
702 format(1x,"max_n  |<n|vxc|n>|       =",f10.6," eV at n =",i4)
703 format(1x,"max_n  |<n|sig - vxc|n>| =",f10.6," eV at n =",i4)
704 format(1x,"max_nm |<n|sig|m>|       =",f10.6," eV at n =",i4," m =",i4)
705 format(1x,"max_nm |<n|vxc|m>|       =",f10.6," eV at n =",i4," m =",i4)
706 format(1x,"max_nm |<n|sig - vxc|m>| =",f10.6," eV at n =",i4," m =",i4)

end program offdiag

!============================================================================
!
! included from bse_convert.F90
!
!============================================================================

subroutine NAME(bsemat)(iunit, ounit)
  integer, intent(in) :: iunit, ounit

  type(kernel_header_t) :: kernel
  SCALAR, allocatable :: bsemat(:,:,:,:,:)
  integer :: ik, ikp, imat, ibb, ic, iv

  PUSH_SUB(NAME(bsemat))

  call read_kernel_header(iunit, kernel)
  call write_kernel_header(ounit, kernel)
  SAFE_ALLOCATE(bsemat, (kernel%nk, kernel%n2b, kernel%n1b, kernel%ns, kernel%ns))
  do ik = 1, kernel%nk
    do imat = 1, kernel%nmat
      do ibb = 1, kernel%n1b*kernel%n2b
        READWRITE(ikp,ic,iv,bsemat(:,:,:,:,:))
      enddo
    end do
  end do
  
  POP_SUB(NAME(bsemat))

end subroutine NAME(bsemat)

!============================================================================
! compare read and write in intwfn.f90
subroutine NAME(dtmat)(iunit, ounit)
  integer, intent(in) :: iunit, ounit

  integer :: nk, nc, nv, nkf, ncf, nvf, ns, nmat, &
    ik, ic, jk, jc, is, ii, iv, jv, npts, ndims
  logical :: per(3)
  real(DP) :: kk(1:3)
  SCALAR :: dcc, dvv

  PUSH_SUB(NAME(dtmat))

  READWRITE(ndims, per(1:3), npts, nk)

  READWRITE(nk,nc,nv,nkf,ncf,nvf,ns)
  do ik=1, nk
    READWRITE(kk(1:3))
  enddo

  ! cc
  nmat=nkf*ncf*nc*ns
  do ii=1,nmat
    READWRITE(ik,ic,jk,jc,is,dcc)
  enddo

  ! vv
  nmat=nkf*nvf*nv*ns
  do ii=1,nmat
    READWRITE(ik,iv,jk,jv,is,dvv)
  enddo
  
  POP_SUB(NAME(dtmat))
  return
end subroutine NAME(dtmat)

!============================================================================
subroutine NAME(vmtxel)(iunit, ounit)
  integer, intent(in) :: iunit, ounit

  integer :: nkf, ncf, nvf, ns, ic, nmat, ii
  SCALAR, allocatable :: s1(:)

  PUSH_SUB(NAME(vmtxel))

  READWRITE(nkf,ncf,nvf,ns,ic)

  nmat=nkf*ncf*nvf*ns
  SAFE_ALLOCATE(s1, (nmat))
  
  READWRITE((s1(ii),ii=1,nmat))
  SAFE_DEALLOCATE(s1)

  PUSH_SUB(NAME(vmtxel))
  return
end subroutine NAME(vmtxel)

!============================================================================
subroutine NAME(eps2_moments)(iunit, ounit)
  integer, intent(in) :: iunit, ounit
  
  integer :: nn, nmat, ii
  real(DP) :: tmp(2)
  SCALAR, allocatable :: s1(:)
  real(DP), allocatable :: array(:)

  PUSH_SUB(NAME(eps2_moments))

  READWRITE(nn,tmp(1:2),nmat,ii)

  SAFE_ALLOCATE(array, (nn))
  ! an
  READWRITE((array(ii),ii=1,nn))
  ! bn
  READWRITE((array(ii),ii=1,nn))
  SAFE_DEALLOCATE(array)
  
  SAFE_ALLOCATE(s1, (nmat))
  READWRITE((s1(ii),ii=1,nmat))
  READWRITE((s1(ii),ii=1,nmat))
  SAFE_DEALLOCATE(s1)
  
  PUSH_SUB(NAME(eps2_moments))
  return
end subroutine NAME(eps2_moments)
  
!============================================================================
subroutine NAME(eigenvectors)(iunit, ounit)
  integer, intent(in) :: iunit, ounit

  integer :: ns, nv, nc, nk, nmat, ii, ik, isvck
  real(DP), allocatable :: kg(:,:)
  real(DP) :: energy
  SCALAR, allocatable :: Asvck(:)
  
  PUSH_SUB(NAME(eigenvectors))

  READWRITE(ns)
  READWRITE(nv)
  READWRITE(nc)
  READWRITE(nk)

  SAFE_ALLOCATE(kg, (3,nk))
  READWRITE(((kg(ii,ik),ii=1,3),ik=1,nk))
  SAFE_DEALLOCATE(kg)

  nmat = ns*nv*nc*nk
  SAFE_ALLOCATE(Asvck, (nmat))

  ! FIXME: there can be between 1 and nmat eigenvectors here, actually
  ! The code will crash if it is less than nmat, though what is written
  ! will be correct and complete nonetheless.
  do isvck = 1, nmat
    READWRITE(energy)
    READWRITE((Asvck(ik),ik=1,nmat))
  enddo
    
  SAFE_DEALLOCATE(Asvck)
    
  POP_SUB(NAME(eigenvectors))
  return
end subroutine NAME(eigenvectors)

!==========================================================================
!
! Module:
!
! genwf_eps      Originally By FHJ             Last Modified 04/2012 (FHJ)
!
!
!==========================================================================

#include "f_defs.h"

module genwf_eps_m

  use global_m
  use input_utils_m
  use fftw_m
  use genwf_mpi_m
  use genwf_disk_m
  use gmap_m
  use spinor_symmetries_m
  use sort_m

  implicit none

  private

  !> communicator object for the WFN FFTs
  type wfn_FFT_comm_t
    logical :: done !< Have we received all the buffers?
    integer, pointer :: req_recvv(:), req_recvc(:) !< Array of MPI_REQUEST
    integer, pointer :: req_sendv(:), req_sendc(:) !< Array of MPI_REQUEST
    integer :: recv_cntv, recv_cntc !< Number of requests
    integer :: send_cntv, send_cntc !< Number of requests
    integer :: nv !< Number of valence bands
  end type wfn_FFT_comm_t

  public :: genwf_gen, genwf_FFT, free_wfns, genwf_lvl2, &
    genwf_FFT_Isend, genwf_FFT_Wait, wfn_FFT_comm_t, &
    get_wfn_fftgrid, get_eps_fftgrid

contains  

  !> FHJ: Figure out what is the min/max gvec components give an isort array
  !! Note: you should manually initialize box_min and box_max to zero!
  subroutine get_gvecs_bounds(gvec, ng, isort, box_min, box_max)
    type(gspace), intent(in) :: gvec
    integer, intent(in) :: ng
    integer, intent(in) :: isort(:)
    integer, intent(inout) :: box_min(3), box_max(3)

    integer :: ig

    PUSH_SUB(get_gvecs_bounds)

    do ig=1,ng
      box_min(1:3) = min(box_min(1:3),  gvec%components(1:3, isort(ig)))
      box_max(1:3) = max(box_max(1:3),  gvec%components(1:3, isort(ig)))
    enddo

    POP_SUB(get_gvecs_bounds)
    return

  end subroutine get_gvecs_bounds

  !> FHJ: Figure out the minimum fftbox that holds all the WFNs
  subroutine get_wfn_fftgrid(pol, gvec, kp, intwfn)
    type(polarizability), intent(inout) :: pol
    type(gspace), intent(in) :: gvec
    type(kpoints), intent(in) :: kp
    type(int_wavefunction), intent(in) :: intwfn

    integer :: ik, wfn_box_min(3), wfn_box_max(3)

    PUSH_SUB(get_wfn_fftgrid)

    wfn_box_min(:) = 0; wfn_box_max(:) = 0
    do ik=1,kp%nrk
      call get_gvecs_bounds(gvec, intwfn%ng(ik), intwfn%isort(:,ik), wfn_box_min, wfn_box_max)
    enddo
    pol%WFN_FFTgrid(1:3) = wfn_box_max(1:3) - wfn_box_min(1:3) + 1
#ifdef VERBOSE
    if(peinf%inode==0) then
      write(6,*) 'WFN min. FFT grid:',pol%WFN_FFTgrid
    endif
#endif

    POP_SUB(get_wfn_fftgrid)
    return

  end subroutine get_wfn_fftgrid

  !> FHJ: Figure out the minimum fftbox that allows us to convolve the WFNs within
  !! an energy window of nmtx G vectors.
  subroutine get_eps_fftgrid(pol, gvec)
    type(polarizability), intent(inout) :: pol
    type(gspace), intent(in) :: gvec
    integer :: eps_box_min(3), eps_box_max(3)

    PUSH_SUB(get_eps_fftgrid)

    eps_box_min(:) = 0; eps_box_max(:) = 0
    call get_gvecs_bounds(gvec, pol%nmtx, pol%isrtx, eps_box_min, eps_box_max)
    ! FHJ: Note: the amount of padding is actually N_sig + N_window - 1
    pol%FFTgrid(1:3) = pol%WFN_FFTgrid(1:3) + (eps_box_max(1:3) - eps_box_min(1:3))
    pol%FFTgrid(1:3) = min(pol%FFTgrid(1:3), gvec%FFTgrid(1:3))
#ifdef VERBOSE
    if(peinf%inode==0) then
      write(6,*) 'Original FFT grid:',gvec%FFTgrid
      write(6,*) 'Minimal  FFT grid:',pol%FFTgrid
    endif
#endif

    POP_SUB(get_eps_fftgrid)
    return

  end subroutine get_eps_fftgrid

  !> FHJ: to be used internally with genwf_FFT_Isend
  subroutine do_my_FFTs(this,gvec,Nfft,wfn_fft,intwfn,my_bands,my_cnt,ng,tmp_wfn,isort,ind,ph,is_val)
    type (wfn_FFT_comm_t), intent(inout), target :: this !< communicator object for the WFN FFTs
    type(gspace), intent(in) :: gvec
    complex(DPC), intent(inout) :: wfn_fft(:,:,:,:)
    integer, intent(in) :: Nfft(3)
    type(int_wavefunction), intent(in) :: intwfn
    integer, intent(in) :: my_bands(:)  !< my bands
    integer, intent(in) :: my_cnt       !< number of FFTs to do = sizeof(my_bands)
    integer, intent(in) :: ng           !< number of gvectors for the k-pt in question
    SCALAR,  intent(inout) :: tmp_wfn(:)!< buffer to reorder WFN using ind and ph
    integer, intent(in) :: isort(:)     !< wfn isort
    integer, intent(in) :: ind(:)
    SCALAR,  intent(in) :: ph(:)    
    logical, intent(in) :: is_val       !< .true. to take the conjg_fftbox

    integer :: is, ig, fft_size
    integer :: ib_list, ib_local, ib, iproc, offset
    integer, pointer :: invindex(:), send_cnt, req_send(:)
    logical, pointer :: does_it_own(:,:)

    PUSH_SUB(do_my_FFTs)

    is = 1
    if ( is_val ) then
      invindex => peinf%invindexv
      does_it_own => peinf%does_it_ownv
      req_send => this%req_sendv
      send_cnt => this%send_cntv
      offset = 0
    else
      invindex => peinf%invindexc
      does_it_own => peinf%does_it_ownc
      req_send => this%req_sendc
      send_cnt => this%send_cntc
      offset = this%nv
    endif
    fft_size = product(Nfft(1:3))

    do ib_list = 1, my_cnt
      ib_local = my_bands(ib_list)
      do ig=1,ng
        tmp_wfn(ig) = intwfn%cg(ind(ig), ib_local, is)*ph(ig)
      enddo
      if(peinf%inode==0) call timacc(43,1)
      call put_into_fftbox(ng, tmp_wfn, gvec%components, &
        isort, wfn_fft(:,:,:,ib_local), Nfft)
      call do_FFT( wfn_fft(:,:,:,ib_local), Nfft, 1)
      if ( is_val ) call conjg_fftbox( wfn_fft(:,:,:,ib_local), Nfft )
      if(peinf%inode==0) call timacc(43,2)

#ifdef MPI
      ! FHJ: distribute all real-space WFNs
      if(peinf%inode==0) call timacc(42,1)
      ib = invindex(ib_local)
      do iproc=0, peinf%npes-1
        if (does_it_own(ib, iproc+1).and.iproc/=peinf%inode) then
          send_cnt = send_cnt + 1
          call MPI_Isend( wfn_fft(1,1,1,ib_local), fft_size, MPI_COMPLEX_DPC, iproc, &
            offset + ib, MPI_COMM_WORLD, req_send(send_cnt), mpierr )
        endif
      enddo
      if(peinf%inode==0) call timacc(42,2)
#endif        
    enddo

    POP_SUB(do_my_FFTs)
    return

  end subroutine do_my_FFTs

  !> Generates all the real-space wavefunctions. Used only if pol%os_opt_fft==2
  !! This version avoids communication, and it`s under development!
  !!TODO`s:
  !! (1) we are just supporting one spin and one kpt/qpt.
  !! (2) support serial code
  subroutine genwf_FFT_Isend(this,crys,gvec,syms,kp,kpq,vwfn,pol,cwfn,intwfnv,intwfnvq,intwfnc)
    type (wfn_FFT_comm_t), intent(inout) :: this !< communicator object for the WFN FFTs
    type (crystal), intent(in) :: crys
    type (gspace), intent(in) :: gvec
    type (symmetry), intent(in) :: syms
    type (kpoints), target, intent(in) :: kp
    type (kpoints), target, intent(in) :: kpq
    type (valence_wfns), intent(inout) :: vwfn
    type (polarizability), intent(inout) :: pol
    type (conduction_wfns), intent(inout) :: cwfn
    type (int_wavefunction), intent(inout) :: intwfnv
    type (int_wavefunction), intent(inout) :: intwfnvq
    type (int_wavefunction), intent(inout) :: intwfnc

    integer :: npes_per_pool, nc_groups, nproc_max, nc
    integer, allocatable :: nv_bands(:), v_owners(:)
    integer :: Nfft(3), fft_size
    real(DP) :: scale
    integer, allocatable :: my_vbands(:)
    integer :: my_vcnt, iv, iv_local
    integer :: ipool, isubrank, inode, ioffset
    integer, allocatable :: grp_global_ranks(:), ntot_bands(:), &
      grp_local_owners(:) 
    integer, allocatable :: my_cbands(:)
    integer :: my_ccnt, ic, ic_local
    integer :: my_grp_rank, grp_nprocs
    integer :: min_bands, iproc, iworker
    integer :: ik, is, ib

    !sort stuff
    SCALAR, allocatable :: tmp_wfn(:)
    SCALAR, allocatable :: ph(:)
    real(DP), allocatable :: ekin(:)
    integer, allocatable :: ind(:), isorti(:)
    integer, allocatable, target :: wfn_isort(:)
    integer :: ng0, ig

    PUSH_SUB(genwf_FFT_Isend)

    call logit('generating all real-space wavefunctions')

    if(peinf%inode==0) call timacc(40,1)

    if(pol%nq>1.or.kp%nrk>1.or.kpq%nrk>0.or.pol%need_WFNq) &
      call die('FFT opt. level 2 only works for 1 qpt and 1 kpt, and without WFNq',&
      only_root_writes=.true.)

#ifdef MPI

    ik = 1 ! Fixing one kpt for now
    is = 1 ! And the spin
    vwfn%idx_kp = ik
    cwfn%idx_kp = ik    
    nc = cwfn%nband - vwfn%nband  ! `real` number of conduction bands
    npes_per_pool = (peinf%npes/peinf%npools) ! number of processors per pool
    nc_groups = (nc + peinf%ncownmax - 1)/(peinf%ncownmax) ! number of conduction groups     
    nproc_max = (peinf%npes + nc_groups - 1)/(nc_groups) ! max num. of proc. per conduction group

    ! Basic initialization of the communicator object
    this%recv_cntv = 0; this%recv_cntc = 0
    this%send_cntv = 0; this%send_cntc = 0
    this%done = .false.
    this%nv = vwfn%nband
    SAFE_ALLOCATE(this%req_recvv, (vwfn%nband*npes_per_pool))
    SAFE_ALLOCATE(this%req_recvc, (nc*nproc_max))
    SAFE_ALLOCATE(this%req_sendv, (vwfn%nband*npes_per_pool))
    SAFE_ALLOCATE(this%req_sendc, (nc*nproc_max))

    if(peinf%inode==0) call timacc(41,1)

    ! FHJ: prepare the sorting buffers
    ng0 = intwfnv%ng(ik) ! We all have at least one valence band
    SAFE_ALLOCATE(ind,(ng0))
    SAFE_ALLOCATE(ph, (ng0))
    SAFE_ALLOCATE(wfn_isort, (gvec%ng))
    SAFE_ALLOCATE(isorti, (gvec%ng))
    SAFE_ALLOCATE(ekin, (gvec%ng))
    call kinetic_energies(gvec, crys%bdot, ekin)
    call sortrx(gvec%ng, ekin, wfn_isort, gvec=gvec%components)

    do ig=1,gvec%ng
      isorti(wfn_isort(ig)) = ig
    enddo
    do ig=1,ng0
      isorti(intwfnv%isort(ig, ik)) = ig
    enddo
    call gmap(gvec,syms,ng0,1,(/0,0,0/),wfn_isort,isorti,ind,ph,.true.)
    vwfn%ngv=ng0
    cwfn%ngc=ng0

    ! FHJ: this will be more complicated to implement for more than 1 kpt
    if (pol%min_fftgrid) then
      pol%isrtx => wfn_isort
      pol%nmtx = gcutoff(gvec%ng, ekin, pol%isrtx, pol%ecuts)
      call get_eps_fftgrid(pol, gvec)
      nullify(pol%isrtx)
    endif
    call setup_FFT_sizes(pol%FFTgrid,Nfft,scale)
    fft_size = Nfft(1)*Nfft(2)*Nfft(3)

    ! FHJ: Distribute VALENCE bands !
    !--------------------------------
    ! NOTE: we index the processors wrt their real MPI ranks (peinf%inode)
    !       we refer all the val bands wrt the local index in my_vbands

    ! Number of valence bands that a particular processor owns      
    SAFE_ALLOCATE(nv_bands, (peinf%npes))
    ! Who owns a particular valence band?
    SAFE_ALLOCATE(v_owners, (vwfn%nband + pol%ncrit))
    ! Which valence bands do I own?
    SAFE_ALLOCATE(my_vbands, (peinf%nvownmax))
    nv_bands(:) = 0; v_owners(:) = 0
    my_vbands(:) = 0
    my_vcnt = 0

    do iv=1, vwfn%nband + pol%ncrit
      ipool = (iv-1)/peinf%nvownmax ! Get pool for the band
      ! Distribute bands to the processors in a round-robin way. We add an
      ! offset so that we get a good load balance for the cond. bands later on.
      isubrank = mod(iv-1, peinf%nvownmax)
      ioffset = ipool*peinf%nvownmax
      inode = mod(isubrank+ioffset, npes_per_pool) + ipool*npes_per_pool
      v_owners(iv) = inode
      ! Keep track of the # of times that each processors got a band:
      nv_bands(inode+1) = nv_bands(inode+1) + 1
      if (peinf%inode == inode) then
        my_vcnt = my_vcnt + 1
        my_vbands(my_vcnt) = isubrank + 1
      endif
    enddo

    ! FHJ: Distribute CONDUCTION bands !
    !----------------------------------!
    ! NOTE: we use *local ranks* to organize the processors in a particular cond. group
    !       we refer all the cond. bands wrt the local index in my_cbands

    ! Ranks of the processors that participate in this conduction group
    SAFE_ALLOCATE(grp_global_ranks, (nproc_max))
    grp_global_ranks(:) = -1
    SAFE_ALLOCATE(ntot_bands, (nproc_max)) ! Total number of bands per processor
    ntot_bands(:) = 0
    ! Who owns a particular conduction band? (in terms of local workers)
    SAFE_ALLOCATE(grp_local_owners, (peinf%ncownactual))
    grp_local_owners(:) = 0
    ! Which conduction bands do I own?
    SAFE_ALLOCATE(my_cbands, (peinf%ncownactual))
    my_cbands(:) = 0
    my_ccnt = 0

    ! This will be set to my rank within the group of conduction bands, starting at 0.
    my_grp_rank = -1

    ! Create list of all processors in that same group
    ! want: grp_global_ranks(:) = [icgroup, icgroup + npes_per_group, ...]
    grp_global_ranks(:) = 0
    grp_nprocs = 0
    ib = peinf%invindexc(1) ! index of first band that I own.
    if (ib>0) then
      do iproc=0, peinf%npes-1
        if (peinf%does_it_ownc(ib, iproc+1)) then
          grp_nprocs = grp_nprocs + 1
          grp_global_ranks(grp_nprocs) = iproc
          if (iproc==peinf%inode) then
            my_grp_rank = grp_nprocs - 1
          endif
        endif
      enddo
    endif

    ! Initialize list of the number of bands that each processor has
    do iproc = 1, grp_nprocs
      ntot_bands(iproc) = nv_bands(grp_global_ranks(iproc)+1)
    enddo

    do ic_local = 1, peinf%ncownactual
      ! Get smallest index of ntot_bands array -> iworker
      ! note: rank = grp_local_ranks(iworker)
      iworker = 0
      min_bands = cwfn%nband + 1
      do iproc=1, grp_nprocs
        if (ntot_bands(iproc)<min_bands) then
          min_bands = ntot_bands(iproc)
          iworker = iproc - 1
        endif
      enddo

      ! add ic_local to list of bands that iworker owns
      grp_local_owners(ic_local) = iworker
      ntot_bands(iworker+1) = ntot_bands(iworker+1) + 1
      if (my_grp_rank == iworker) then
        my_ccnt = my_ccnt + 1
        my_cbands(my_ccnt) = ic_local
      endif
    enddo

    if(peinf%inode==0) call timacc(41,2)
    if(peinf%inode==0) call timacc(42,1)

    ! FHJ: Non-blocking Recvs !
    !-------------------------!

    ! Recv valence bands
    SAFE_ALLOCATE( vwfn%wfn_fft, (Nfft(1), Nfft(2), Nfft(3), peinf%nvownactual) )
    do iv_local=1, peinf%nvownactual
      iv = peinf%invindexv(iv_local)
      if (v_owners(iv)/=peinf%inode) then 
        this%recv_cntv = this%recv_cntv + 1
        call MPI_Irecv( vwfn%wfn_fft(1,1,1,iv_local), fft_size, MPI_COMPLEX_DPC, v_owners(iv), &
          iv, MPI_COMM_WORLD, this%req_recvv(this%recv_cntv), mpierr )
      endif
    enddo
    ! Recv conduction bands
    SAFE_ALLOCATE( cwfn%wfn_fft, (Nfft(1), Nfft(2), Nfft(3), peinf%ncownactual) )
    do ic_local=1, peinf%ncownactual
      ic = peinf%invindexc(ic_local)
      if (grp_local_owners(ic_local)/=my_grp_rank) then
        this%recv_cntc = this%recv_cntc + 1
        iproc = grp_global_ranks(grp_local_owners(ic_local)+1)
        call MPI_Irecv( cwfn%wfn_fft(1,1,1,ic_local), fft_size, MPI_COMPLEX_DPC, iproc, &
          vwfn%nband + ic, MPI_COMM_WORLD, this%req_recvc(this%recv_cntc), mpierr )
      endif
    enddo

    if(peinf%inode==0) call timacc(42,2)

    ! FHJ: Do the FFTs + Isend`s !
    !----------------------------!

    call logit('doing FFTs')

    SAFE_ALLOCATE(tmp_wfn, (ng0))
    call do_my_FFTs(this,gvec,Nfft,vwfn%wfn_fft,intwfnv,my_vbands,my_vcnt,&
      ng0,tmp_wfn,wfn_isort,ind,ph,.true.)
    call do_my_FFTs(this,gvec,Nfft,cwfn%wfn_fft,intwfnc,my_cbands,my_ccnt,&
      ng0,tmp_wfn,wfn_isort,ind,ph,.false.)
    SAFE_DEALLOCATE(tmp_wfn)

    ! FHJ: Deallocate original wavefunctions (but only the wfn!)
    call free_wfns(pol, intwfnv, intwfnvq, intwfnc, .false.)

    call logit('done with FFTs')

    ! Free comm buffers
    SAFE_DEALLOCATE(nv_bands)
    SAFE_DEALLOCATE(v_owners)
    SAFE_DEALLOCATE(my_vbands)
    SAFE_DEALLOCATE(grp_global_ranks)
    SAFE_DEALLOCATE(ntot_bands)
    SAFE_DEALLOCATE(grp_local_owners)
    SAFE_DEALLOCATE(my_cbands)

    ! and free sorting stuff
    SAFE_DEALLOCATE(ind)
    SAFE_DEALLOCATE(ph)
    SAFE_DEALLOCATE(wfn_isort)
    SAFE_DEALLOCATE(isorti)
    SAFE_DEALLOCATE(ekin)

#endif

    call logit('done generating real-space wavefunctions')

    if(peinf%inode==0) call timacc(40,2)

    POP_SUB(genwf_FFT_Isend)
    return

  end subroutine genwf_FFT_Isend


  ! FHJ: call me after genwf_FFT_Isend, but just before you actually need the data
  subroutine genwf_FFT_Wait(this)
    type (wfn_FFT_comm_t), intent(inout) :: this !< communicator object for the WFN FFTs

    PUSH_SUB(genwf_FFT_Wait)

#ifdef MPI      
    if(peinf%inode==0) call timacc(40,1)
    if(peinf%inode==0) call timacc(42,1)
    if (this%recv_cntv>0) then
      call MPI_Waitall(this%recv_cntv, this%req_recvv,  MPI_STATUSES_IGNORE, mpierr)
    endif
    if (this%send_cntv>0) then
      call MPI_Waitall(this%send_cntv, this%req_sendv,  MPI_STATUSES_IGNORE, mpierr)
    endif
    if (this%recv_cntc>0) then
      call MPI_Waitall(this%recv_cntc, this%req_recvc,  MPI_STATUSES_IGNORE, mpierr)
    endif
    if (this%send_cntc>0) then
      call MPI_Waitall(this%send_cntc, this%req_sendc,  MPI_STATUSES_IGNORE, mpierr)
    endif
    if(peinf%inode==0) call timacc(42,2)

    SAFE_DEALLOCATE_P(this%req_recvv)
    SAFE_DEALLOCATE_P(this%req_sendv)
    SAFE_DEALLOCATE_P(this%req_recvc)
    SAFE_DEALLOCATE_P(this%req_sendc)
    this%done = .true.
    if(peinf%inode==0) call timacc(40,2)
#endif

    POP_SUB(genwf_FFT_Wait)
    return

  end subroutine genwf_FFT_Wait


  subroutine genwf_lvl2(kp,kpq,vwfn,pol,cwfn)
    type (kpoints), target, intent(in) :: kp
    type (kpoints), target, intent(in) :: kpq
    type (valence_wfns), intent(inout) :: vwfn
    type (polarizability), intent(in) :: pol
    type (conduction_wfns), intent(inout) :: cwfn

    type(kpoints), pointer :: kp_point

    PUSH_SUB(genwf_lvl2)

    if(pol%need_WFNq) then ! FIXME I think this is wrong if pol%nq1>0
      kp_point => kpq
    else
      kp_point => kp
    endif

    SAFE_ALLOCATE(vwfn%ev, (vwfn%nband+pol%ncrit, kp%nspin))
    SAFE_ALLOCATE(cwfn%ec, (cwfn%nband,kp%nspin))
    vwfn%ev(1:vwfn%nband+pol%ncrit,1:kp%nspin) = &
      kp_point%el(1:vwfn%nband+pol%ncrit, vwfn%idx_kp, 1:kp%nspin)
    cwfn%ec(1:cwfn%nband,1:kp%nspin) = &
      kp%el(1:cwfn%nband, cwfn%idx_kp, 1:kp%nspin)

    POP_SUB(genwf_lvl2)
    return
  end subroutine genwf_lvl2


  !> Generates all the real-space wavefunctions. Used only if pol%os_opt_fft==2
  !!TODO`s:
  !! (1) we are just supporting one spin and one kpt/qpt.
  !! (2) communication can be reduced if we distribute the WFNs in a smarter way
  !! (3) support serial code
  subroutine genwf_FFT(crys,gvec,syms,kp,kpq,vwfn,pol,cwfn,intwfnv,intwfnvq,intwfnc)
    type (crystal), intent(in) :: crys
    type (gspace), intent(in) :: gvec
    type (symmetry), intent(in) :: syms
    type (kpoints), target, intent(in) :: kp
    type (kpoints), target, intent(in) :: kpq
    type (valence_wfns), intent(inout) :: vwfn
    type (polarizability), intent(inout) :: pol
    type (conduction_wfns), intent(inout) :: cwfn
    type (int_wavefunction), intent(inout) :: intwfnv
    type (int_wavefunction), intent(inout) :: intwfnvq
    type (int_wavefunction), intent(inout) :: intwfnc

    integer :: ik, is, ipe
    integer :: own_max
    integer, allocatable :: band_owners(:)
    integer :: ib_loc, ib, ng0
    integer :: receiver, recv_cnt, send_cnt
    integer :: local_band_idx
    integer, allocatable :: req_send(:), req_recv(:)
    integer, allocatable :: my_bands(:), isort0(:)
    SCALAR, allocatable :: bufs_wfn(:,:)
    complex(DPC), allocatable :: work_ffts(:,:,:,:)
    integer :: Nfft(3), fft_size
    real(DP) :: scale
    SCALAR, allocatable :: tmp_wfn(:)
    SCALAR, allocatable :: ph(:)
    real(DP), allocatable :: ekin(:)
    integer, allocatable :: ind(:), isorti(:)
    integer, allocatable, target :: wfn_isort(:)
    integer :: ig

    PUSH_SUB(genwf_FFT)

    call logit('generating all real-space wavefunctions')

    if(peinf%inode==0) call timacc(40,1)

    if(pol%nq>1.or.kp%nrk>1.or.kpq%nrk>0.or.pol%need_WFNq) &
      call die('FFT opt. level 2 only works for 1 qpt and 1 kpt, and without WFNq',&
      only_root_writes=.true.)

#ifdef MPI

    own_max = (cwfn%nband + peinf%npes - 1)/(peinf%npes)

    ik = 1 ! Fixing one kpt for now
    is = 1 ! And the spin

    vwfn%idx_kp = ik
    cwfn%idx_kp = ik

    if(peinf%inode==0) call timacc(41,1)

    ! FHJ: Only root is guaranteed to have at least one band.
    if (peinf%inode==0) ng0 = intwfnv%ng(ik)
    call MPI_Bcast(ng0, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    SAFE_ALLOCATE(isort0, (ng0))
    if (peinf%inode==0) isort0(1:ng0) = intwfnv%isort(1:ng0, ik)
    call MPI_Bcast(isort0(1), ng0, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)

    ! FHJ: prepare the sorting stuff
    SAFE_ALLOCATE(ind,(ng0))
    SAFE_ALLOCATE(ph, (ng0))
    SAFE_ALLOCATE(wfn_isort, (gvec%ng))
    SAFE_ALLOCATE(isorti, (gvec%ng))
    SAFE_ALLOCATE(ekin, (gvec%ng))
    SAFE_ALLOCATE(tmp_wfn, (ng0))
    call kinetic_energies(gvec, crys%bdot, ekin)
    call sortrx(gvec%ng, ekin, wfn_isort, gvec=gvec%components)
    do ig=1,gvec%ng
      isorti(wfn_isort(ig)) = ig
    enddo
    do ig=1,ng0
      isorti(isort0(ig)) = ig
    enddo
    call gmap(gvec,syms,ng0,1,(/0,0,0/),wfn_isort,isorti,ind,ph,.true.)
    vwfn%ngv=ng0
    cwfn%ngc=ng0

    ! FHJ: Work buffers
    SAFE_ALLOCATE(band_owners, (cwfn%nband))
    SAFE_ALLOCATE(my_bands, (cwfn%nband))
    SAFE_ALLOCATE(req_send, (cwfn%nband))
    SAFE_ALLOCATE(req_recv, (cwfn%nband))
    SAFE_ALLOCATE(bufs_wfn, (ng0, own_max))

    ! FHJ: Re-distribute WFNs
    recv_cnt = 0
    send_cnt = 0
    do ib = 1, cwfn%nband
      receiver = mod(ib-1, peinf%npes)
      band_owners(ib) = receiver

      ! FHJ: Receiving part
      if (receiver==peinf%inode) then
        recv_cnt = recv_cnt + 1
        my_bands(recv_cnt) = ib
        call MPI_Irecv( bufs_wfn(1, recv_cnt), ng0, MPI_SCALAR, MPI_ANY_SOURCE, &
          ib, MPI_COMM_WORLD, req_recv(recv_cnt), mpierr )
      endif

      ! FHJ: Sending part
      if (ib<=vwfn%nband) then
        local_band_idx = peinf%indexv(cwfn%band_index(ib))+(ik-1)*peinf%nvownactual
        if (should_send(peinf%does_it_ownv)) &
          call MPI_Isend( intwfnv%cg(1, local_band_idx, is), ng0, MPI_SCALAR, receiver, ib, &
          MPI_COMM_WORLD, req_send(send_cnt), mpierr )
      else
        local_band_idx = peinf%indexc(ib-vwfn%nband)+(ik-1)*peinf%ncownactual
        if (should_send(peinf%does_it_ownc)) &
          call MPI_Isend( intwfnc%cg(1, local_band_idx, is), ng0, MPI_SCALAR, receiver, ib, &
          MPI_COMM_WORLD, req_send(send_cnt), mpierr )
      endif
    enddo

    if (recv_cnt>0) then
      call MPI_Waitall(recv_cnt, req_recv,  MPI_STATUSES_IGNORE, mpierr)
    endif
    if (send_cnt>0) then
      call MPI_Waitall(send_cnt, req_send,  MPI_STATUSES_IGNORE, mpierr)
    endif

    if(peinf%inode==0) call timacc(41,2)
    if(peinf%inode==0) call timacc(43,1)

    ! FHJ: TODO - change genwf_mpi.f90 so that it doesn`t use cwfn%el
    ! (see genwf_mpi.f90)

    ! FHJ: Deallocate original wavefunctions (but only the wfn!)
    call free_wfns(pol, intwfnv, intwfnvq, intwfnc, .false.)

    call logit('doing FFTs')

    ! FHJ: this will be more complicated to implement for more than 1 kpt
    if (pol%min_fftgrid) then
      pol%isrtx => wfn_isort
      pol%nmtx = gcutoff(gvec%ng, ekin, pol%isrtx, pol%ecuts)
      call get_eps_fftgrid(pol, gvec)
      nullify(pol%isrtx)
    endif
    ! FHJ: Do all the FFTs
    call setup_FFT_sizes(pol%FFTgrid,Nfft,scale)
    fft_size = Nfft(1)*Nfft(2)*Nfft(3)

    SAFE_ALLOCATE( vwfn%wfn_fft, (Nfft(1), Nfft(2), Nfft(3), peinf%nvownactual) )
    SAFE_ALLOCATE( cwfn%wfn_fft, (Nfft(1), Nfft(2), Nfft(3), peinf%ncownactual) )
    SAFE_ALLOCATE( work_ffts, (Nfft(1), Nfft(2), Nfft(3), recv_cnt) )

    if (peinf%inode==0) write(0,*)
    do ib = 1, recv_cnt
      do ig=1,ng0
        tmp_wfn(ig) = bufs_wfn(ind(ig), ib)*ph(ig)
      enddo
      call put_into_fftbox(ng0, tmp_wfn, gvec%components, wfn_isort, work_ffts(:,:,:,ib), Nfft)
      call do_FFT(work_ffts(:,:,:,ib), Nfft, 1)
      if (my_bands(ib)<=vwfn%nband) then
        call conjg_fftbox(work_ffts(:,:,:,ib), Nfft)
      endif
    enddo

    if(peinf%inode==0) call timacc(43,2)
    if(peinf%inode==0) call timacc(42,1)

    call logit('done with FFTs')

    do ib_loc = 1,peinf%nvownactual
      ib = peinf%invindexv(ib_loc)
      call MPI_Irecv( vwfn%wfn_fft(1,1,1,ib_loc), fft_size, MPI_COMPLEX_DPC, band_owners(ib), &
        ib, MPI_COMM_WORLD, req_recv(ib_loc), mpierr )
    enddo
    do ib_loc = 1,peinf%ncownactual
      ib = peinf%invindexc(ib_loc)+vwfn%nband
      call MPI_Irecv( cwfn%wfn_fft(1,1,1,ib_loc), fft_size, MPI_COMPLEX_DPC, band_owners(ib), &
        ib, MPI_COMM_WORLD, req_recv(peinf%nvownactual+ib_loc), mpierr )
    enddo

    ! FHJ: And send them back using point-to-point communication.
    send_cnt = 0
    do ib_loc = 1, recv_cnt
      ib = my_bands(ib_loc)

      if (ib<=vwfn%nband) then
        do ipe = 0, peinf%npes-1
          if ( peinf%does_it_ownv(ib,ipe+1) ) then
            send_cnt = send_cnt + 1
            call MPI_Isend( work_ffts(1,1,1,ib_loc), fft_size, MPI_COMPLEX_DPC, ipe, &
              ib, MPI_COMM_WORLD, req_send(send_cnt), mpierr )
          endif
        enddo
      else
        do ipe = 0, peinf%npes-1
          if ( peinf%does_it_ownc(ib-vwfn%nband,ipe+1) ) then
            send_cnt = send_cnt + 1
            call MPI_Isend( work_ffts(1,1,1,ib_loc), fft_size, MPI_COMPLEX_DPC, ipe, &
              ib, MPI_COMM_WORLD, req_send(send_cnt), mpierr )
          endif
        enddo
      endif
    enddo

    recv_cnt = peinf%nvownactual + peinf%ncownactual
    if (recv_cnt>0) then
      call MPI_Waitall(recv_cnt, req_recv,  MPI_STATUSES_IGNORE, mpierr)
    endif
    if (send_cnt>0) then
      call MPI_Waitall(send_cnt, req_send,  MPI_STATUSES_IGNORE, mpierr)
    endif

    if(peinf%inode==0) call timacc(42,2)

    SAFE_DEALLOCATE(work_ffts)
    SAFE_DEALLOCATE(bufs_wfn)
    SAFE_DEALLOCATE(req_send)
    SAFE_DEALLOCATE(req_recv)
    SAFE_DEALLOCATE(my_bands)
    SAFE_DEALLOCATE(band_owners)
    SAFE_DEALLOCATE(isort0)

    ! and free sorting stuff
    SAFE_DEALLOCATE(ind)
    SAFE_DEALLOCATE(ph)
    SAFE_DEALLOCATE(wfn_isort)
    SAFE_DEALLOCATE(isorti)
    SAFE_DEALLOCATE(ekin)
    SAFE_DEALLOCATE(tmp_wfn)

    call logit('done generating real-space wavefunctions')

    if(peinf%inode==0) call timacc(40,2)

#endif

    POP_SUB(genwf_FFT)
    return

  contains

    logical function should_send(own_arr)
      logical, intent(in) :: own_arr(:,:)

      integer :: sender, ib_

      PUSH_SUB(genwf_FFT.should_send)

      ib_ = ib
      if (ib_ > vwfn%nband) ib_ = ib_ - vwfn%nband

      should_send = .false.
#ifdef MPI
      sender = -1
      do ipe = 0, peinf%npes-1
        if (own_arr(ib_, ipe+1)) then
          sender = ipe
          exit
        endif
      enddo

      if (sender==-1) call die('No sender found!')

      if (sender==peinf%inode) then
        send_cnt = send_cnt + 1
        should_send = .true.
      endif
#endif

      POP_SUB(genwf_FFT.should_send)
      return

    end function should_send

  end subroutine genwf_FFT

  !> Generic routine that generates wavefunctions using either genwf_disk or genwf_mpi
  subroutine genwf_gen(syms,gvec,crys,kp,kpq,irk,rk,qq,vwfn,pol,cwfn,use_wfnq,intwfnv,intwfnvq,intwfnc,iv)
    type (symmetry), intent(in) :: syms
    type (gspace), intent(in) :: gvec
    type (crystal), intent(in) :: crys
    type (kpoints), target, intent(in) :: kp
    type (kpoints), target, intent(in) :: kpq
    integer, intent(in) :: irk
    real(DP), intent(in) :: rk(3)
    real(DP), intent(in) :: qq(3)
    type (valence_wfns), intent(inout) :: vwfn
    type (polarizability), intent(in) :: pol
    type (conduction_wfns), intent(inout) :: cwfn
    logical, intent(in) :: use_wfnq
    type (int_wavefunction), intent(in) :: intwfnv
    type (int_wavefunction), intent(in) :: intwfnvq
    type (int_wavefunction), intent(in) :: intwfnc
    integer, intent(in) :: iv

    integer :: ivr

    PUSH_SUB(genwf_gen)

#ifdef VERBOSE
    call logit('calling genwf')
#endif
    if(peinf%inode==0) call timacc(9,1)
    if (pol%iwriteint == 0) then !COMM_DISK
      if (iv .le. peinf%nvownactual) then
        ivr=peinf%invindexv(iv)
      else
        ivr=-1
      endif
      call genwf_disk(syms,gvec,crys,kp,kpq,irk,rk,qq,vwfn,pol,cwfn,use_wfnq,ivr)
    else !COMM_MPI
      if (iv .le. peinf%nvownactual) then
        call genwf_mpi(syms,gvec,crys,kp,kpq,irk,rk,qq,vwfn,pol,cwfn,use_wfnq,intwfnv,intwfnvq,intwfnc,iv)
      endif
    endif
    if(peinf%inode==0) call timacc(9,2)
#ifdef VERBOSE
    call logit('done genwf')
#endif

    POP_SUB(genwf_gen)
    return

  end subroutine genwf_gen

  !> Deallocate all "intermediate" wavefunctions
  subroutine free_wfns(pol, intwfnv, intwfnvq, intwfnc, free_all)
    type(polarizability), intent(in) :: pol
    type(int_wavefunction), intent(inout) :: intwfnv, intwfnvq, intwfnc
    logical, intent(in) :: free_all !< if .false., then only %ng and %isort will be preserved

    PUSH_SUB(free_wfns)

    if (pol%iwriteint .ne. 0) then
      if (free_all) then
        SAFE_DEALLOCATE_P(intwfnv%ng)
        SAFE_DEALLOCATE_P(intwfnv%isort)
      endif
      SAFE_DEALLOCATE_P(intwfnv%cg)
      SAFE_DEALLOCATE_P(intwfnv%qk)
      if (pol%need_WFNq) then
        if (free_all) then
          SAFE_DEALLOCATE_P(intwfnvq%ng)
          SAFE_DEALLOCATE_P(intwfnvq%isort)
        endif
        SAFE_DEALLOCATE_P(intwfnvq%cg)
        SAFE_DEALLOCATE_P(intwfnvq%qk)
      endif
      if (free_all) then
        SAFE_DEALLOCATE_P(intwfnc%ng)
        SAFE_DEALLOCATE_P(intwfnc%isort)
      endif
      SAFE_DEALLOCATE_P(intwfnc%cg)
      SAFE_DEALLOCATE_P(intwfnc%cbi)
      SAFE_DEALLOCATE_P(intwfnc%qk)
    endif

    POP_SUB(free_wfns)
    return

  end subroutine free_wfns

end module genwf_eps_m

!============================================================================
!
! Module bse_convert_m
!
!============================================================================

#include "f_defs.h"

module bse_convert_m

  use global_m
  use kernel_io_m

  implicit none

  private

  public ::              &
    bsemat_binasc,       &
    dtmat_binasc,        &
    vmtxel_binasc,       &
    eps2_moments_binasc, &
    eigenvectors_binasc, &
    bsemat_ascbin,       &
    dtmat_ascbin,        &
    vmtxel_ascbin,       &
    eps2_moments_ascbin, &
    eigenvectors_ascbin

contains

#define NAME(x) x ## _binasc
! this is a variadic macro
#define READWRITE(...) \
read(iunit) __VA_ARGS__; \
write(ounit, *) __VA_ARGS__

#include "bse_convert_inc.f90"

#undef NAME
#undef READWRITE

#define NAME(x) x ## _ascbin
#define READWRITE(...) \
read(iunit, *) __VA_ARGS__; \
write(ounit) __VA_ARGS__

#include "bse_convert_inc.f90"

end module bse_convert_m

!! Local Variables:
!! mode: f90
!! coding: utf-8
!! End:

!==============================================================================
!
! Routines:
!
! (1) diagonalize()      Originally AC           Last Modified 7/8/2008 (JRD)
!
! generalised parallel hermitian eigenvalue solver,
! returns eigenvectors in shs and
! eigenvalues in egv. eigenvecs in zg see man pzheevx/pdsyevx,
! to save memory S(program) -> ZG(scala)
!                H(program) -> S(scala)
! -> means transformation to scala layout
! call pzheevx/pdsyevx
!                eigenvecs put in H(scala) -> ZG(program)
!
!        neig = number of eigenvectors
!        nmat = lda of shs and sis (=nv in code)
!
! interface routine for the pzheevx/pdsyevx, generalised parallel eigenvalue
! solver. Starts with the distributed S and H matrices. Redistributes
! them to blacs layout, then calls pzheevx/pdsyevx and
! then collects all the eigenvectors onto
! all pes. For more details of the scalapack routines and data layouts
! see http://www.netlib.org/scalapack/scalapack_home.html
!
! based on pssyevx_inter/pcheevx_inter, written by Andrew Canning
! NERSC/LBL 1998
!
!      distributed solver (block cyclic blacs layout):
!
!           nbl = blocksize
!           nprow = processor grid row
!           npcol = processor grid column
!
! double-precision eigenvalue solvers, pzheevx/pdsyevx
!
!===================================================================================

#include "f_defs.h"

subroutine diagonalize(pblock,neig,nmat,shs,egv,egs)

  use global_m
  use scalapack_m
  implicit none

  integer, intent(in) :: pblock
  integer, intent(in) :: neig
  integer, intent(in) :: nmat
  SCALAR, intent(inout) :: shs(nmat,peinf%nblocks*peinf%nblockd)
  real(DP), intent(out) :: egv(neig)
  SCALAR, intent(out) :: egs(nmat,pblock)

  character :: range
  character*100 :: tmpstr
  real(DP) :: abstol
  integer, allocatable :: iwork(:),ifail(:)
  integer :: nfound,ilow,iup,info,ii,nh_unit
  real(DP) :: ellow,elup
  real(DP), allocatable :: rwork(:),egv_t(:)
  SCALAR, allocatable :: work(:)
  real(DP) :: non_herm_max,non_herm_sum,non_herm,herm_max

! Scalapack and blacs arrays

#ifdef USESCALAPACK
  type(scalapack) :: scal
  integer :: nrow_p(peinf%npes)
  integer :: desca(9)
  integer :: nbc,nbce,nbr,locsize,nn,nnp,np0,mq0
  integer :: clustersize,lwork,lrwork,liwork,nzfound
  integer :: idiff,ibc,ngr,ibr,ic,izero
  real(DP) :: dzero,orfac
  integer, allocatable :: iclustr(:)
  SCALAR, allocatable :: shs_bl(:),egs_bl(:)
  real(DP), allocatable :: gap(:)

  integer :: i,jj,inode,nq0,nod_g(nmat),icol(nmat)
  integer :: idum,kk,nbc_max,nbr_max, &
    numbl_max,iproc_n,num_max,ir_low, &
    ilen,icom,j,num_g_max,icoma(peinf%npes)

! index arrays for mpi  : H matrix

  integer, allocatable :: numr(:),nums(:)
  integer, allocatable :: indr(:,:),inds(:,:),iaddr(:,:), &
    iadds_r(:,:),iadds_c(:,:),iadds_d(:,:)

! index arrays for mpi : S matrix

  integer, allocatable :: numre(:),numse(:)
  integer, allocatable :: indre(:,:),indse(:,:),iaddre(:,:), &
    iaddse_r(:,:),iaddse_c(:,:),iaddse_d(:,:)
#endif  

  integer :: iloop,jloop

#ifdef USEESSL
  SCALAR, allocatable :: hupper(:)
  integer :: hup_counter
#endif

  PUSH_SUB(diagonalize)

! If neig > nmat, only the first neig eigenvectors/eigenvalues will
! be computed. Otherwise, calculate all of them.
! Set range

  if (neig.eq.nmat) then
    range='A'
  else if (neig.lt.nmat) then
    range='I'
  else
    write(tmpstr,'(a,i10,a,i10)') 'diagonalize: ', neig, ' eigenvalues requested > matrix size ', nmat
    call die(tmpstr)
  endif

! If running with single PE, use the serial subroutines. Otherwise,
! do the distributed job

  if (peinf%npes.eq.1) then
    if (nmat.ne.peinf%nblocks*peinf%nblockd) then
      call die('Hamiltonian matrix does not seem to be square!')
    endif
    abstol=0.0
    SAFE_ALLOCATE(ifail, (nmat))
    SAFE_ALLOCATE(work, (10*nmat))
    SAFE_ALLOCATE(iwork, (5*nmat))
    SAFE_ALLOCATE(egv_t, (nmat))
    ilow = 1
    iup = neig
#ifdef CPLX
    SAFE_ALLOCATE(rwork, (7*nmat))

    ! Note: we only do Hermiticity check in serial. parallel is complicated.
    non_herm_max = 0D0
    non_herm_sum = 0D0
    herm_max = 0D0
    do jloop=1,nmat
      do iloop=1,jloop
        non_herm = abs(shs(iloop,jloop)-MYCONJG(shs(jloop,iloop)))
        non_herm_sum = non_herm_sum + non_herm
        if (non_herm .gt. non_herm_max) then
          non_herm_max = non_herm
          herm_max = (shs(iloop,jloop)+MYCONJG(shs(jloop,iloop))) * 0.5d0
        endif
        !shs(iloop,jloop) =  (shs(iloop,jloop)+MYCONJG(shs(jloop,iloop)))/2D0
        !shs(jloop,iloop) = MYCONJG(shs(iloop,jloop))
      enddo
    enddo
    if ( non_herm_max .gt. 1D-4 ) then
      write(0,*) ' '
      write(0,*) 'WARNING!! LARGE NON-HERMITICITY'
      write(0,*) ' '
      nh_unit = 0
    else
      nh_unit = 6
    endif
    write(nh_unit,*) 'Sum of non-Hermitian parts of the kernel: ',non_herm_sum
    write(nh_unit,*) 'Largest non-Hermitian part = ', non_herm_max, " Corresponding Hermitian part = ", herm_max

#ifdef USEESSL
    SAFE_ALLOCATE(hupper, (nmat*(nmat+1)/2))
    hup_counter = 1
    do jloop=1,nmat
      do iloop=1,jloop
        hupper(hup_counter) =  shs(iloop,jloop)
        hup_counter = hup_counter + 1
      enddo
    enddo
    call zhpev(21,hupper,egv_t,egs,nmat,nmat,iwork,0)
    SAFE_DEALLOCATE(hupper)
#else
    call zheevx('V',range,'U',nmat,shs,nmat,ellow,elup,ilow,iup, &
      abstol,nfound,egv_t,egs,nmat,work,8*nmat,rwork,iwork,ifail,info)
    if(nfound .lt. neig) then
      write(tmpstr,'(a, i10, a, i10, a)') 'Diagonalization with zheevx failed: only ', &
        nfound, ' of ', neig, ' eigenvalues found.'
      call die(tmpstr)
    endif
#endif
    SAFE_DEALLOCATE(rwork)

#else

#ifdef USEESSL
    SAFE_ALLOCATE(hupper, (nmat*(nmat+1)/2))
    hup_counter = 1
    do jloop=1,nmat
      do iloop=1,jloop
        hupper(hup_counter) =  shs(iloop,jloop)
        hup_counter = hup_counter + 1
      enddo
    enddo
    call dspev(21,hupper,egv_t,egs,nmat,nmat,iwork,0)
    SAFE_DEALLOCATE(hupper)
#else
    call dsyevx('V',range,'U',nmat,shs,nmat,ellow,elup,ilow,iup, &
      abstol,nfound,egv_t,egs,nmat,work,10*nmat,iwork,ifail,info)
    if(nfound .lt. neig) then
      write(tmpstr,'(a, i10, a, i10, a)') 'Diagonalization with dsyevx failed: only ', &
        nfound, ' of ', neig, ' eigenvectors found.'
      call die(tmpstr)
    endif
#endif
#endif

    if(info.lt.0) then
      write(tmpstr,*) "Problem in input parameters for zheevx/dsyevx: info = ",info
      call die(tmpstr)
    endif

    if(info.gt.0) then
      write(0,*) "Convergence problems in zheevx/dsyevx: info = ",info
      write(tmpstr,*) 'The following eigenvector failed to converge: ifail = ',ifail
      call die(tmpstr)
    endif

    do ii=1,neig
      egv(ii) = egv_t(ii)
    enddo
    SAFE_DEALLOCATE(egv_t)
    SAFE_DEALLOCATE(iwork)
    SAFE_DEALLOCATE(work)
    SAFE_DEALLOCATE(ifail)
        
    POP_SUB(diagonalize)
    return
  endif

! The rest of this routine is only if the # of processors is not 1,
! which means we must be running MPI (the code below assumes it actually)

#if defined MPI && !defined USESCALAPACK
  #error ScaLAPACK is required for MPI builds.
#endif

#ifdef MPI

! Calculate num_g_max
! max number of g vecs per pe

  do i = 1,peinf%npes
    nrow_p(i) = peinf%nblockd*peinf%ibt(i)
  enddo

  idum = 0
  do i = 1,peinf%npes
    if(nrow_p(i).gt.idum) idum = nrow_p(i)
  enddo
  num_g_max = idum

! Calculate node index array for communications

  do ii = 1,peinf%npes
    idum = (ii-1)*peinf%nblockd
    do jj = 1,peinf%ibt(ii)
      do kk = 1,peinf%nblockd
        idum = idum + 1
        nod_g(idum) = ii-1
      enddo
      idum = idum + (peinf%npes-1)*peinf%nblockd
    enddo
  enddo

  do ii = 1,peinf%npes
    idum = (ii-1)*peinf%nblockd
    do jj = 1,peinf%ibt(ii)
      do kk = 1,peinf%nblockd
        idum = idum + 1
        icol(idum) = (jj-1)*peinf%nblockd + kk
      enddo
      idum = idum + (peinf%npes-1)*peinf%nblockd
    enddo
  enddo

  call mpi_comm_rank(mpi_comm_world,inode,mpierr)

! Choose scalapack layout. Block cyclic. Block size as
! close to 32 as possible for large matrices
! processor layout as close as possible to square

  call blacs_setup(scal, nmat, .false.)

! Figure out number of blocks per processor in the column/row
! and array sizes and maximums as well for allocations

  nbc = nmat/(scal%nbl*scal%npcol)
  if(mod(nmat,(scal%nbl*scal%npcol)).gt.scal%mypcol*scal%nbl) nbc=nbc+1
  nbr = nmat/(scal%nbl*scal%nprow)
  if(mod(nmat,(scal%nbl*scal%nprow)).gt.scal%myprow*scal%nbl) nbr=nbr+1
  call mpi_allreduce(nbc,nbc_max,1,mpi_integer,mpi_max, &
    mpi_comm_world,mpierr)
  call mpi_allreduce(nbr,nbr_max,1,mpi_integer,mpi_max, &
    mpi_comm_world,mpierr)
  numbl_max = nbc_max*nbr_max
  
  SAFE_ALLOCATE(egv_t, (nmat))
  SAFE_ALLOCATE(shs_bl, (numbl_max*scal%nbl*scal%nbl))
  shs_bl(:) = 0.0
  
  nbce = neig/(scal%nbl*scal%npcol)
  if(mod(neig,(scal%nbl*scal%npcol)).gt.scal%mypcol*scal%nbl) &
    nbce=nbce+1
  
  SAFE_ALLOCATE(egs_bl, (numbl_max*scal%nbl*scal%nbl))
  egs_bl(:) = 0.0
  
! Calculate work array sizes etc for pzheevx/pdsyevx
! assume no more than 20 eigenvalues in any one cluster
! if more pzheevx/pdsyevx will abort. If more then more memory is
! required for the orthogonalisation ie more work space
! amc  neig set to nv for work space calculation size
! seems to be a problem in pzheevx/pdsyevx with setting it to neig

  clustersize = 50
  dzero = 0.0
  izero = 0
  locsize = scal%nbl*scal%nbl*nbc*nbr
  nn = max(nmat,scal%nbl,2)
  nnp = max(nmat,scal%nprow*scal%npcol+1,4)
  np0 = numroc(nn,scal%nbl,0,0,scal%nprow)
  mq0 = numroc(max(neig,scal%nbl,2),scal%nbl,0,0,scal%npcol)

#ifdef CPLX
! Use nq0 for lwork to be consistent with pzheevx, man pages wrong

  nq0 = numroc(nn,scal%nbl,0,0,scal%npcol)
  lwork = nmat + (np0+nq0+scal%nbl)*scal%nbl
  
  lrwork=4*nmat+max(5*nn,np0*mq0)+iceil(neig,scal%nprow*scal%npcol)*nn + &
    (clustersize-1)*nmat

#else
  lwork=5*nmat+max(5*nn,np0*mq0+2*scal%nbl*scal%nbl)+ &
    iceil(neig,scal%nprow*scal%npcol)*nn+(clustersize-1)*nmat
  lrwork=0
#endif
  liwork = 6*nnp

! Calculate sizes for index arrays for mpi comms. : h matrix
! for s matrix, use the same num_max (requires little additional memory)

  SAFE_ALLOCATE(numr, (peinf%npes))

  numr = 0
  do ibc=0, nbc-1           ! loop over column blocks
    do ic=(ibc*scal%npcol+scal%mypcol)*scal%nbl+1, &
      min((ibc*scal%npcol+scal%mypcol)*scal%nbl+scal%nbl,nmat) ! loop over cols
      iproc_n = nod_g(ic)
      do ibr =0, nbr-1    ! loop over row blocks
        numr(iproc_n+1) = numr(iproc_n+1) + 1
      end do
    end do
  end do

! Get max of numr

  idum = 0
  do i = 1,peinf%npes
    if(numr(i).gt.idum) idum = numr(i)
  enddo

  call mpi_allreduce(idum,num_max,1,mpi_integer,mpi_max,mpi_comm_world,mpierr)

! Allocate index arrays for communications
! for remapping to scalapack layout

  SAFE_ALLOCATE(nums, (peinf%npes))
  SAFE_ALLOCATE(indr, (num_max,peinf%npes))
  SAFE_ALLOCATE(inds, (num_max,peinf%npes))
  SAFE_ALLOCATE(iaddr, (num_max,peinf%npes))
  SAFE_ALLOCATE(iadds_r, (num_max,peinf%npes))
  SAFE_ALLOCATE(iadds_c, (num_max,peinf%npes))
  SAFE_ALLOCATE(iadds_d, (num_max,peinf%npes))
  
  SAFE_ALLOCATE(numre, (peinf%npes))
  SAFE_ALLOCATE(numse, (peinf%npes))
  SAFE_ALLOCATE(indre, (num_max,peinf%npes))
  SAFE_ALLOCATE(indse, (num_max,peinf%npes))
  SAFE_ALLOCATE(iaddre, (num_max,peinf%npes))
  SAFE_ALLOCATE(iaddse_r, (num_max,peinf%npes))
  SAFE_ALLOCATE(iaddse_c, (num_max,peinf%npes))
  SAFE_ALLOCATE(iaddse_d, (num_max,peinf%npes))

! Allocate memory

  SAFE_ALLOCATE(work, (lwork))
#ifdef CPLX
  SAFE_ALLOCATE(rwork, (lrwork))
#endif
  SAFE_ALLOCATE(iwork, (liwork))
  
  SAFE_ALLOCATE(iclustr, (2*scal%nprow*scal%npcol))
  SAFE_ALLOCATE(gap, (scal%nprow*scal%npcol))
  SAFE_ALLOCATE(ifail, (nmat))
  
! Remap state distributed s and h to block-block blacs distribution
! in  zg and s
! calculate index matrices first for communications

  indr(:,:) = 0
  
  numr = 0
  
  idiff=0
  do ibc=0, nbc-1           ! loop over column blocks
    do ic=(ibc*scal%npcol+scal%mypcol)*scal%nbl+1, &
      min((ibc*scal%npcol+scal%mypcol)*scal%nbl+scal%nbl,nmat) ! loop over cols
      ngr = 0
      iproc_n = nod_g(ic)
      do ibr =0, nbr-1    ! loop over row blocks
        ir_low = (ibr*scal%nprow+scal%myprow)*scal%nbl+1
        ilen = min((ibr*scal%nprow+scal%myprow)*scal%nbl+scal%nbl,nmat)-ir_low+1
        ngr = ngr + ilen
        numr(iproc_n+1) = numr(iproc_n+1) + 1
        
        indr(numr(iproc_n+1),iproc_n+1) = ilen
        iaddr(numr(iproc_n+1),iproc_n+1) = idiff+1
        iadds_r(numr(iproc_n+1),iproc_n+1) = ir_low
        iadds_c(numr(iproc_n+1),iproc_n+1) = icol(ic)
        
        idiff = idiff + ilen
      end do
    end do
  end do

  indre(:,:) = 0
  
  numre = 0
  
  idiff=0
  do ibc=0, nbce-1           ! loop over column blocks
    do ic=(ibc*scal%npcol+scal%mypcol)*scal%nbl+1, &
      min((ibc*scal%npcol+scal%mypcol)*scal%nbl+scal%nbl,neig) ! loop over cols
      iproc_n = nod_g(ic)
      do ibr =0, nbr-1    ! loop over row blocks
        ir_low = (ibr*scal%nprow+scal%myprow)*scal%nbl+1
        ilen = min((ibr*scal%nprow+scal%myprow)*scal%nbl+scal%nbl,nmat)-ir_low+1
        numre(iproc_n+1) = numre(iproc_n+1) + 1
        
        indre(numre(iproc_n+1),iproc_n+1) = ilen
        iaddre(numre(iproc_n+1),iproc_n+1) = idiff+1
        iaddse_r(numre(iproc_n+1),iproc_n+1) = ir_low
        iaddse_c(numre(iproc_n+1),iproc_n+1) = icol(ic)
        
        idiff = idiff + ilen
      end do
    end do
  end do
  
! Communicate sending indexes etc to sending processors

  do i = 1,peinf%npes
    call mpi_isend(numr(i),1,mpi_integer,i-1,inode, &
      mpi_comm_world,icom,mpierr)
  enddo
  do i = 1,peinf%npes
    call mpi_recv(nums(i),1,mpi_integer,i-1,i-1, &
      mpi_comm_world,mpistatus,mpierr)
  enddo
  call mpi_barrier(mpi_comm_world,mpierr)
  do i = 1,peinf%npes
    call mpi_isend(indr(1,i),numr(i),mpi_integer,i-1,inode, &
        mpi_comm_world,icom,mpierr)
  enddo
  do i = 1,peinf%npes
    call mpi_recv(inds(1,i),nums(i),mpi_integer,i-1,i-1, &
      mpi_comm_world,mpistatus,mpierr)
  enddo
  call mpi_barrier(mpi_comm_world,mpierr)
  do i = 1,peinf%npes
    call mpi_isend(iadds_r(1,i),numr(i),mpi_integer,i-1,inode, &
      mpi_comm_world,icom,mpierr)
  enddo
  do i = 1,peinf%npes
    call mpi_recv(iadds_d(1,i),nums(i),mpi_integer,i-1,i-1, &
      mpi_comm_world,mpistatus,mpierr)
  enddo
  call mpi_barrier(mpi_comm_world,mpierr)
  do i = 1,peinf%npes
    call mpi_isend(iadds_c(1,i),numr(i),mpi_integer,i-1,inode, &
      mpi_comm_world,icom,mpierr)
  enddo
  do i = 1,peinf%npes
    call mpi_recv(iadds_r(1,i),nums(i),mpi_integer,i-1,i-1, &
      mpi_comm_world,mpistatus,mpierr)
  enddo
  do i = 1,peinf%npes
    call mpi_isend(numre(i),1,mpi_integer,i-1,inode, &
      mpi_comm_world,icom,mpierr)
  enddo
  do i = 1,peinf%npes
    call mpi_recv(numse(i),1,mpi_integer,i-1,i-1, &
      mpi_comm_world,mpistatus,mpierr)
  enddo
  call mpi_barrier(mpi_comm_world,mpierr)
  do i = 1,peinf%npes
    call mpi_isend(indre(1,i),numre(i),mpi_integer,i-1,inode, &
      mpi_comm_world,icom,mpierr)
  enddo
  do i = 1,peinf%npes
    call mpi_recv(indse(1,i),numse(i),mpi_integer,i-1,i-1, &
      mpi_comm_world,mpistatus,mpierr)
  enddo
  call mpi_barrier(mpi_comm_world,mpierr)
  do i = 1,peinf%npes
    call mpi_isend(iaddse_r(1,i),numre(i),mpi_integer,i-1,inode, &
      mpi_comm_world,icom,mpierr)
  enddo
  do i = 1,peinf%npes
    call mpi_recv(iaddse_d(1,i),numse(i),mpi_integer,i-1,i-1, &
      mpi_comm_world,mpistatus,mpierr)
  enddo
  call mpi_barrier(mpi_comm_world,mpierr)
  do i = 1,peinf%npes
    call mpi_isend(iaddse_c(1,i),numre(i),mpi_integer,i-1,inode, &
      mpi_comm_world,icom,mpierr)
  enddo
  do i = 1,peinf%npes
    call mpi_recv(iaddse_r(1,i),numse(i),mpi_integer,i-1,i-1, &
      mpi_comm_world,mpistatus,mpierr)
  enddo

! Allocate shmem dummy array hardwire to block size of 32 used in BLACS layout

!     call shpalloc(dum_p,32*peinf%npes,ierr,-1)

! Now communicate the data

  do j = 1,num_max
    
    call mpi_barrier(mpi_comm_world,mpierr)
    
    do i = 1,peinf%npes
      if(j.le.nums(i)) then
        call mpi_isend(shs(iadds_d(j,i),iadds_r(j,i)),inds(j,i), &
          MPI_SCALAR,i-1,nums(i)+j,mpi_comm_world,icoma(i),mpierr)
!          ix = iadds_d(j,i)-1
!          iy = iadds_r(j,i)
!          do ii = 1,inds(j,i)
!            dum(ii,i) = sis(ix+ii,iy)
!          enddo

      endif
    enddo

!        write(6,*) 'line 606', j, num_max

    call mpi_barrier(mpi_comm_world,mpierr)
    
    do i = 1,peinf%npes
      if(j.le.numr(i)) then
        call mpi_recv(shs_bl(iaddr(j,i)),indr(j,i), &
          MPI_SCALAR,i-1,numr(i)+j,mpi_comm_world,mpistatus,mpierr)
!          call shmem_get(zg(iaddr(j,i)),dum(1,inode+1),indr(j,i),i-1)
      endif
    enddo

    do i = 1,peinf%npes
      if(j.le.nums(i)) then
        call MPI_WAIT(icoma(i),mpistatus,mpierr)
      endif
    enddo
    
  enddo

  call mpi_barrier(mpi_comm_world,mpierr)

  call descinit(desca,nmat,nmat,scal%nbl,scal%nbl,0,0,scal%icntxt,ngr,info)
  if(info < 0) then
    write(0,'(a,i3,a)') 'Argument number ', -info, ' had an illegal value on entry.'
    call die("descinit error")
  else if(info > 0) then
    write(0,*) 'info = ', info
    call die("descinit error")
  endif
  
  abstol =  0.0
  orfac= 5d-7
  ilow=1
  iup=neig

  if (peinf%inode.eq.0) write(6,*) 'Beginning ScaLAPACK Diagonalization. Size: ', nmat
!  if (peinf%inode.eq.0) write(6,*) "range", range
!  if (peinf%inode.eq.0) write(6,*) "nmat", nmat
!  if (peinf%inode.eq.0) write(6,*) "shs_bl", shs_bl
!  if (peinf%inode.eq.0) write(6,*) "ellow", ellow
!  if (peinf%inode.eq.0) write(6,*) "ellup", elup
!  if (peinf%inode.eq.0) write(6,*) "ilow", ilow
!  if (peinf%inode.eq.0) write(6,*) "iup", iup
!  if (peinf%inode.eq.0) write(6,*) "abstol", abstol

#ifdef CPLX
  call pzheevx &
#else
  call pdsyevx &
#endif
    ('V',range,'U',nmat,shs_bl,1,1,desca, &
    ellow,elup,ilow,iup,abstol,nfound, &
    nzfound,egv_t,orfac,egs_bl,1,1,desca,work,lwork, &
#ifdef CPLX
    rwork,lrwork, &
#endif 
    iwork,liwork,ifail,iclustr,gap,info)

  if (peinf%inode.eq.0) write(6,*) 'Done Scalapack Diagonalization'
  if(info.lt.0) call die(" error in parameters for pzheevx/pdsyevx")
  
! Source: http://www.netlib.org/lapack-dev/Patch/SRC/pzheevx.f
! if (MOD(INFO,2).NE.0), then one or more eigenvectors failed to converge.  Their indices are stored
! in IFAIL.  Ensure ABSTOL=2.0*PDLAMCH( 'U' ). Send e-mail to scalapack@cs.utk.edu
  if(mod(info, 2) /= 0) then
    if(peinf%inode == 0) then
      write(0,*) " info = ", info
      write(0,'(a)',advance='no') "Unconverged eigenvalues from ifail: "
      do jj = 1, size(ifail)
        if(ifail(jj) == 0) exit
        write(0,'(i8)',advance='no') ifail(jj)
      enddo
    endif
    call die("Convergence problems in pzheevx/pdsyevx.")
  endif

! if (MOD(INFO/2,2).NE.0),then eigenvectors corresponding to one or more clusters of eigenvalues could not be
! reorthogonalized because of insufficient workspace. The indices of the clusters are stored in the array ICLUSTR.
  if(mod(info / 2, 2) /= 0) then
    if(peinf%inode == 0) then
      write(0,*) " info = ", info
      do jj = 1, size(iclustr)
        if(iclustr(jj) == 0) exit
        write(0,'(i8)',advance='no') iclustr(jj)
      enddo
    endif
    call die("Could not reorthogonalize due to insufficient workspace in pzheevx/pdsyevx.")
  endif

! if (MOD(INFO/4,2).NE.0), then space limit prevented PZHEEVX from computing all of the eigenvectors
! between VL and VU.  The number of eigenvectors computed is returned in NZ.
  if(mod(info / 4, 2) /= 0) then
    if(peinf%inode == 0) then
      write(0,*) " info = ", info
      write(0,*) " number eigenvalues found = ", nzfound
    endif
    call die("Space limit prevented computing all eigenvectors in pzheevx/pdsyevx.")
  endif

! if (MOD(INFO/8,2).NE.0), then PZSTEBZ failed to compute eigenvalues.  Ensure ABSTOL=2.0*PDLAMCH( 'U' )
! Send e-mail to scalapack@cs.utk.edu
  if(mod(info / 8, 2) /= 0) then
    if(peinf%inode == 0) then
      write(0,*) " info = ", info
    endif
    call die("PZSTEBZ failed to compute eigenvalues in pzheevx/pdsyevx.")
  endif

  if(nfound .lt. neig) then
    write(tmpstr,'(a, i10, a, i10, a)') 'Diagonalization with pzheevx/pdsyevx failed: only ', &
      nfound, ' of ', neig, ' eigenvalues found.'
    call die(tmpstr)
  endif

  if(nzfound .lt. neig) then
    write(tmpstr,'(a, i10, a, i10, a)') 'Diagonalization with pzheevx/pdsyevx failed: only ', &
      nzfound, ' of ', neig, ' eigenvectors found.'
    call die(tmpstr)
  endif

! Copy eigenvector layout from scalapack layout back to program layout

  if (peinf%inode.eq.0) write(6,*) 'Sharing eigenvectors'

  do j = 1,num_max

    call mpi_barrier(mpi_comm_world,mpierr)
    
    do i = 1,peinf%npes
      if(j.le.numre(i)) then
        call mpi_isend(egs_bl(iaddre(j,i)),indre(j,i), &
          MPI_SCALAR,i-1,numre(i)+j,mpi_comm_world,icoma(i),mpierr)
!          ix = iaddre(j,i)-1
!          do ii = 1,indre(j,i)
!            dum(ii,i) = shs(ix+ii)
!          enddo

      endif
    enddo
        
    call mpi_barrier(mpi_comm_world,mpierr)
    
    do i = 1,peinf%npes
      if(j.le.numse(i)) then
        call mpi_recv(egs(iaddse_d(j,i),iaddse_r(j,i)),indse(j,i), &
          MPI_SCALAR,i-1,numse(i)+j,mpi_comm_world,mpistatus,mpierr)
!          call shmem_get(zg(iaddse_d(j,i),iaddse_r(j,i)),dum(1,inode+1),
!     >                   indse(j,i),i-1)
      endif
    enddo

    do i = 1,peinf%npes
      if(j.le.numre(i)) then
        call MPI_WAIT(icoma(i),mpistatus,mpierr)
      endif
    enddo
    
  enddo
      
  do ii=1,neig
    egv(ii) = egv_t(ii)
  enddo
  
  call mpi_barrier(mpi_comm_world,mpierr)
      
  call BLACS_GRIDEXIT(scal%icntxt)
  
  SAFE_DEALLOCATE(work)
#ifdef CPLX
  SAFE_DEALLOCATE(rwork)
#endif
  SAFE_DEALLOCATE(iwork)
  SAFE_DEALLOCATE(iclustr)
  SAFE_DEALLOCATE(gap)
  SAFE_DEALLOCATE(ifail)
  SAFE_DEALLOCATE(numr)
  SAFE_DEALLOCATE(nums)
  SAFE_DEALLOCATE(indr)
  SAFE_DEALLOCATE(inds)
  SAFE_DEALLOCATE(iaddr)
  SAFE_DEALLOCATE(iadds_r)
  SAFE_DEALLOCATE(iadds_c)
  SAFE_DEALLOCATE(iadds_d)
  SAFE_DEALLOCATE(numre)
  SAFE_DEALLOCATE(numse)
  SAFE_DEALLOCATE(indre)
  SAFE_DEALLOCATE(indse)
  SAFE_DEALLOCATE(iaddre)
  SAFE_DEALLOCATE(iaddse_r)
  SAFE_DEALLOCATE(iaddse_c)
  SAFE_DEALLOCATE(iaddse_d)
  SAFE_DEALLOCATE(egs_bl)
  SAFE_DEALLOCATE(shs_bl)
  SAFE_DEALLOCATE(egv_t)
  
  if (peinf%inode.eq.0) write(6,*) 'Diagonalization done'

!      call shpdeallc(dum_p,ierr,-1)

#endif

  POP_SUB(diagonalize)

  return
end subroutine diagonalize

!===========================================================================
!
! Routines:
!
! (1) write_result_hp()    Originally By ?         Last Modified 7/3/2008 (JRD)
!
!     Writes the quasiparticle spectrum to the output
!
!===========================================================================

#include "f_defs.h"

module write_result_hp_m

  use global_m
  implicit none

  private
  public :: write_result_hp

contains

subroutine write_result_hp(kp,wfnk,sig,ax,asx,ach,achcor,asig,alda,efsto,&
                           enew,zrenorm,ikn)
  type (kpoints), intent(in) :: kp
  type (wfnkstates), intent(in) :: wfnk
  type (siginfo), intent(in) :: sig
  SCALAR, intent(in) :: ax(:,:) !< (sig%ndiag+sig%noffdiag,sig%nspin)
  SCALAR, intent(in) :: asx(:,:,:) !< (nfreqgpp,sig%ndiag+sig%noffdiag,sig%nspin)
  SCALAR, intent(in) :: ach(:,:,:) !< (nfreqgpp,sig%ndiag+sig%noffdiag,sig%nspin)
  complex(DPC), intent(in) :: achcor(:,:) !< (sig%ndiag+sig%noffdiag,sig%nspin)
  SCALAR, intent(in) :: asig(:,:) !< (sig%ndiag+sig%noffdiag,sig%nspin)
  SCALAR, intent(in) :: alda(:,:) !< (sig%ndiag+sig%noffdiag,sig%nspin)
  real(DP), intent(in) :: efsto(:,:) !< (sig%ndiag,sig%nspin)
  real(DP), intent(in) :: enew(:,:) !< (sig%ndiag,sig%nspin)
  real(DP), intent(in) :: zrenorm(:,:) !< (sig%ndiag,sig%nspin)
  integer, intent(in) :: ikn

  integer :: i, j, ispin, iw, nstart, nend

  PUSH_SUB(write_result_hp)

  do ispin=1,sig%nspin
    
! Sigma Diagonal

    write(8,979) (kp%rk(j,ikn),j=1,3),ikn,sig%spin_index(ispin)
    if (sig%freq_dep .eq. -1 .or. &
       (sig%freq_dep .eq. 0 .and. sig%exact_ch .eq. 1) .or. &
       (sig%freq_dep .eq. 1 .and. sig%exact_ch .eq. 0)) then
      write(8,978)
      write(8,977) (sig%diag(i),wfnk%elda(sig%diag(i),ispin), &
        wfnk%ek(sig%diag(i),ispin),dble(ax(i,ispin)),dble(asx(2,i,ispin)), &
        dble(ach(2,i,ispin)+achcor(i,ispin)), &
        dble(asig(i,ispin)+achcor(i,ispin)),dble(alda(i,ispin)), &
        efsto(i,ispin)+dble(achcor(i,ispin)), &
        enew(i,ispin)+dble(achcor(i,ispin))*zrenorm(i,ispin), &
        zrenorm(i,ispin),i=1,sig%ndiag)
    else
      write(8,976)
      write(8,975) (sig%diag(i),wfnk%elda(sig%diag(i),ispin), &
        wfnk%ek(sig%diag(i),ispin),dble(ax(i,ispin)),dble(asx(2,i,ispin)), &
        dble(ach(2,i,ispin)+achcor(i,ispin)), &
        dble(asig(i,ispin)+achcor(i,ispin)),dble(alda(i,ispin)), &
        efsto(i,ispin)+dble(achcor(i,ispin)), &
        enew(i,ispin)+dble(achcor(i,ispin))*zrenorm(i,ispin), &
        dble(ach(2,i,ispin)),dble(asig(i,ispin)), &
        efsto(i,ispin),enew(i,ispin),zrenorm(i,ispin),i=1,sig%ndiag)
    endif
979 format(7x,"k =",3f10.6,1x,"ik =",i4,1x,"spin =",i2) 
978 format(/,3x,"n",8x,"elda",8x,"ecor",11x,"x",8x,"sx-x",10x,"ch", &
      9x,"sig",9x,"vxc",8x,"eqp0",8x,"eqp1",9x,"Znk")
977 format(i4,10f12.6)
976 format(/,3x,"n",8x,"elda",8x,"ecor",11x,"x",8x,"sx-x",10x,"ch", &
      9x,"sig",9x,"vxc",8x,"eqp0",8x,"eqp1",9x,"ch'",8x,"sig'", &
      7x,"eqp0'",7x,"eqp1'",9x,"Znk")
975 format(i4,14f12.6)
    
! Sigma Off-Diagonal

    if (sig%noffdiag.gt.0) then
      if (sig%fdf.eq.-1) then
        nstart = 1
        nend = 2
      elseif (sig%fdf.eq.0) then
        nstart = 1
        nend = 3
      elseif (sig%fdf.eq.1) then
        nstart = 2
        nend = 3
      else
        nstart = 2
        nend = 2
      endif
      do iw = nstart, nend
        if (iw.eq.1) write(8,951)
        if (iw.eq.2) write(8,952)
        if (iw.eq.3) write(8,953)
        if (sig%freq_dep .eq. -1 .or. &
           (sig%freq_dep .eq. 0 .and. sig%exact_ch .eq. 1) .or. &
           (sig%freq_dep .eq. 1 .and. sig%exact_ch .eq. 0)) then
          write(8,969) iw, iw, iw
          do i=sig%ndiag+1,sig%ndiag+sig%noffdiag
            write(8,968) sig%off1(i-sig%ndiag),sig%off2(i-sig%ndiag), &
              sig%off3(i-sig%ndiag),dble(ax(i,ispin)), &
              dble(asx(iw,i,ispin)),dble(ach(iw,i,ispin)+achcor(i,ispin)), &
              dble(ax(i,ispin)+asx(iw,i,ispin)+ach(iw,i,ispin)+achcor(i,ispin)), &
              dble(alda(i,ispin))
#ifdef CPLX
            write(8,967) sig%off1(i-sig%ndiag),sig%off2(i-sig%ndiag), &
              sig%off3(i-sig%ndiag),IMAG(ax(i,ispin)), &
              IMAG(asx(iw,i,ispin)),IMAG(ach(iw,i,ispin)+achcor(i,ispin)), &
              IMAG(ax(i,ispin)+asx(iw,i,ispin)+ach(iw,i,ispin)+achcor(i,ispin)), &
              IMAG(alda(i,ispin))
#endif
          enddo
        else
          write(8,966) iw, iw, iw, iw, iw
          do i=sig%ndiag+1,sig%ndiag+sig%noffdiag
            write(8,965) sig%off1(i-sig%ndiag),sig%off2(i-sig%ndiag), &
              sig%off3(i-sig%ndiag),dble(ax(i,ispin)), &
              dble(asx(iw,i,ispin)),dble(ach(iw,i,ispin)+achcor(i,ispin)), &
              dble(ax(i,ispin)+asx(iw,i,ispin)+ach(iw,i,ispin)+achcor(i,ispin)), &
              dble(alda(i,ispin)),dble(ach(iw,i,ispin)), &
              dble(ax(i,ispin)+asx(iw,i,ispin)+ach(iw,i,ispin))
#ifdef CPLX
            write(8,964) sig%off1(i-sig%ndiag),sig%off2(i-sig%ndiag), &
              sig%off3(i-sig%ndiag),IMAG(ax(i,ispin)), &
              IMAG(asx(iw,i,ispin)),IMAG(ach(iw,i,ispin)+achcor(i,ispin)), &
              IMAG(ax(i,ispin)+asx(iw,i,ispin)+ach(iw,i,ispin)+achcor(i,ispin)), &
              IMAG(alda(i,ispin)),IMAG(ach(iw,i,ispin)), &
              IMAG(ax(i,ispin)+asx(iw,i,ispin)+ach(iw,i,ispin))
#endif
          enddo
        endif
      enddo
    endif
951 format(/,3x,"e1 = ecor - de")
952 format(/,3x,"e2 = ecor")
953 format(/,3x,"e3 = ecor + de")
969 format(3x,"n",3x,"m",3x,"l",21x,"x",4x,"sx(e",i1,")-x",6x, &
      "ch(e",i1,")",5x,"sig(e",i1,")",9x,"vxc")
968 format(3i4,3x,"real",3x,5f12.6)
967 format(3i4,3x,"imag",3x,5f12.6)
966 format(3x,"n",3x,"m",3x,"l",21x,"x",4x,"sx(e",i1,")-x",6x, &
      "ch(e",i1,")",5x,"sig(e",i1,")",9x,"vxc",5x,"ch'(e",i1,")",4x, &
      "sig'(e",i1,")")
965 format(3i4,3x,"real",3x,7f12.6)
964 format(3i4,3x,"imag",3x,7f12.6)
    
    write(8,*)
    
  enddo ! ispin
  
  POP_SUB(write_result_hp)
  
  return
end subroutine write_result_hp

end module write_result_hp_m

#include "f_defs.h"

!*************************************************************************
Module HamiltonianMod
!*************************************************************************
! gsm [2010-10-31] added zheevx and workspace query for ACML,
! kept zhpevx (implemented in the original EPM code) for MKL,
! replaced abstol = -1.0 with AbsoluteTolerance (default = -1.0)
!-------------------------------------------------------------------------
! on hbar, eigenvectors are reproduced in the following configurations:
! ACML/zheevx with abstol = -1.0, MKL/zhpevx with abstol = -1.0,
! ACML/zhpevx with abstol = 1.0d-12, MKL/zheevx with abstol = 1.0d-14
!*************************************************************************
! HDiagonalize calls LAPACK routines
!*************************************************************************
! The module contains the public functions:
!    HInit
!    HDestroy
!    HDiagonalize (calls LAPACK routines)
!    HPrint
!    HCheck
!*************************************************************************
! The module contains the public variables:
!*************************************************************************
! The module contains the private functions:
!*************************************************************************
! The module contains the private variables:
!*************************************************************************
! The module contains the type:
! hamiltonianArrayT which contains the variables:
!    hDim        Maximum dimension of the Hamiltonian matrix that gets used.
!    hSize       Actual dimension of the Hamiltonian matrix that gets used.
!                The variable name is misleading, but we`re stuck with it for now.
!    h(i)        I-th element of the Hamiltonian matrix in packed storage
!    SqH(i,j)    The complete Hamiltonian matrix 
!    work        work arrays for LAPACK/Conjugate gradient
!*************************************************************************

  use SysParams, only : double
  use push_pop_m
  implicit none

  save

  type hamiltonianArrayT
    integer                   :: hSize, hDim, lwork
    real(double)              :: abstol
    complex(double), pointer  :: h(:)
    complex(double), pointer  :: SqH(:,:)
    complex(double), pointer  :: PotentialR(:)
    real(double),    pointer  :: KineticG(:)
    complex(double), pointer  :: work(:)
    real(double),    pointer  :: rwork(:)
    integer,         pointer  :: iwork(:)
    integer,         pointer  :: fail(:)
  end type hamiltonianArrayT

  contains

!*************************************************************************
  Subroutine HInit(hamiltonian, maxHDim)
!*************************************************************************

!   Allocate space for the Hamiltonian and the work matrices.

    use SysParams,      only : one, zero
    use lapack_m
    implicit none

    type( hamiltonianArrayT ), pointer :: hamiltonian
    integer, intent(in) :: maxHDim

    integer :: error
    ! Workspace variables
#ifdef UNPACKED
    integer             :: dummym, dummyi(1), dummyf(1)
    real(double)        :: dummyw(1), dummyr(1)
    complex(double)     :: dummyh(1,1), dummyz(1,1), dummywork(1)
#endif

    PUSH_SUB(HInit)
    
    if( associated( hamiltonian )) stop 'Error, hamiltonian already allocated.'
    allocate( hamiltonian, stat = error )
    if( error /= 0 ) stop 'Error, hamiltonian allocation failed.'
    nullify( hamiltonian%h )
    nullify( hamiltonian%SqH )
    nullify( hamiltonian%PotentialR )
    nullify( hamiltonian%KineticG )
    nullify( hamiltonian%work )
    nullify( hamiltonian%rwork )
    nullify( hamiltonian%iwork )
    nullify( hamiltonian%fail )

    hamiltonian%hDim  = maxHDim
    
    ! Assume we used the entire Hamiltonian matrix.
    hamiltonian%hSize = maxHDim

    ! workspace query
#ifdef UNPACKED
    ! for ACML
    hamiltonian%lwork = -1
    call zheevx( 'V','I','U', hamiltonian%hDim, dummyh, &
               & hamiltonian%hDim, zero, zero, 1, hamiltonian%hDim, &
               & hamiltonian%abstol, dummym, dummyw, dummyz, hamiltonian%hDim, &
               & dummywork, hamiltonian%lwork, dummyr, dummyi, dummyf, error )
    hamiltonian%lwork = nint(dble(dummywork(1)))
#else
    ! for MKL and Netlib
    hamiltonian%lwork = 2 * hamiltonian%hDim
#endif

    ! The Hamiltonian matrix is stored in packed form. Only the upper triangle
    ! plus half the main diagonal is stored. This is why the allocate statement
    ! looks funny.
    allocate( hamiltonian%h( hamiltonian%hDim * ( hamiltonian%hDim + 1 ) / 2 ), &
            & hamiltonian%sqH( hamiltonian%hDim, hamiltonian%hDim ), &
            & hamiltonian%KineticG(hamiltonian%hDim), &
            & hamiltonian%PotentialR(hamiltonian%hDim), &
            & hamiltonian%fail( hamiltonian%hDim ), stat=error )
    if(error /= 0) stop 'Error in allocating Hamiltonian space, part 1.'
    allocate( hamiltonian%work( hamiltonian%lwork ), &
            & hamiltonian%rwork( 7 * hamiltonian%hDim ), &
            & hamiltonian%iwork( 5 * hamiltonian%hDim ), stat=error )
    if(error /= 0) stop 'Error in allocating Hamiltonian space, part 2.'

    POP_SUB(HInit)
  end Subroutine HInit

!*************************************************************************
  Subroutine HDestroy( hamiltonian )
!*************************************************************************

    implicit none

    type( hamiltonianArrayT ), pointer :: hamiltonian
    integer :: error

    PUSH_SUB(HDestroy)

    if( .not. associated( hamiltonian )) stop 'Error, hamiltonian not allocated.'

    deallocate( hamiltonian%h, hamiltonian%sqH, &
              & hamiltonian%work, hamiltonian%rwork, &
              & hamiltonian%iwork, hamiltonian%fail, &
              & hamiltonian%KineticG, hamiltonian%PotentialR, stat=error )
    if(error /= 0) stop 'Error in deallocating Hamiltonian space.'

    deallocate( hamiltonian, stat = error )
    if(error /= 0) stop 'Error, hamiltonian deallocation failed.'

    nullify( hamiltonian )

    POP_SUB(HDestroy)
  end Subroutine Hdestroy

!*************************************************************************
  Subroutine HDiagonalize( hamiltonian, eigenStates, k )
!*************************************************************************

! Hamiltonian matrix is diagonalized by a call to LAPACK routines.

    use SysParams,      only : one, zero
    use EigenStatesMod, only : eigenStatesT
    use lapack_m

    implicit none

    type( hamiltonianArrayT ), pointer :: hamiltonian
    type( eigenStatesT ),      pointer :: eigenStates
    integer, intent( in )         :: k

    integer :: neig, error, eigenvecdim
    real(double), allocatable :: eigenvalues(:)
    complex(double), allocatable :: eigenvectors(:,:)

#ifdef DEBUG
!#ifdef UNPACKED
    complex(double), allocatable :: sqH(:,:)
    complex(double), allocatable :: packed(:)
    integer :: packed_size
    PUSH_SUB(HDiagonalize)
    allocate(sqH(hamiltonian%hDim, hamiltonian%hDim))
    sqH(1:hamiltonian%hDim, 1:hamiltonian%hDim) = hamiltonian%sqH(1:hamiltonian%hDim, 1:hamiltonian%hDim)
#ifndef UNPACKED
    packed_size = hamiltonian%hSize * (hamiltonian%hSize + 1)/2
    allocate(packed(1:packed_size))
    packed(1:packed_size) = hamiltonian%h(1:packed_size)
#endif
#else
    PUSH_SUB(HDiagonalize)
#endif

    allocate(eigenvalues(1:hamiltonian%hSize))
    eigenvecdim = max(hamiltonian%hSize, eigenStates%maxBasisVectors)
    allocate(eigenvectors(1:eigenvecdim, eigenStates%numStates))

#ifdef UNPACKED
    ! for ACML
    call zheevx( 'V','I','U', hamiltonian%hSize, hamiltonian%SqH, hamiltonian%hDim, &
#else
    ! for MKL and Netlib
    call zhpevx( 'V','I','U', hamiltonian%hSize, hamiltonian%h, &
#endif
               & zero, zero, 1, eigenStates%numStates, &
               & hamiltonian%abstol, neig, eigenvalues(:), &
               & eigenvectors(:,:), eigenvecdim, hamiltonian%work, &
#ifdef UNPACKED
               & hamiltonian%lwork, &
#endif
               & hamiltonian%rwork, hamiltonian%iwork, hamiltonian%fail, error )

    if(neig .lt. eigenStates%numStates) then
       write(0,'(a,i6,a,i6)') 'Error: failed in zheevx: neig = ', neig, ' < numStates = ', eigenStates%numStates
       stop
    endif
    if(error /= 0) then
       write(0,'(a,i6)') 'Error: failed in zheevx: code = ', error
       stop
    endif

    eigenStates%eigenValues(1:eigenStates%numStates, k) = eigenvalues(1:eigenStates%numStates)
    eigenStates%eigenVectors(1:eigenStates%maxBasisVectors, 1:eigenStates%numStates, k) = &
      & eigenvectors(1:eigenStates%maxBasisVectors, 1:eigenStates%numStates)
    deallocate(eigenvalues, eigenvectors)

#ifdef DEBUG
!#ifdef UNPACKED
    hamiltonian%sqH(1:hamiltonian%hDim, 1:hamiltonian%hDim) = sqH(1:hamiltonian%hDim, 1:hamiltonian%hDim)
    deallocate(sqH)
#ifndef UNPACKED
    hamiltonian%h(1:packed_size) = packed(1:packed_size)
    deallocate(packed)
#endif
#endif

    POP_SUB(HDiagonalize)
  end Subroutine HDiagonalize

!*************************************************************************
  Subroutine HPrint( hamiltonian )
!*************************************************************************

    use message_m
    implicit none

    type( hamiltonianArrayT ), pointer :: hamiltonian
    integer :: i, j

    PUSH_SUB(HPrint)

    call open_file(7, file = 'h.dat', status='replace')

    do i = 1, hamiltonian%hSize
      do j = i, hamiltonian%hSize
        write( unit = 7, fmt = '(F8.4)', advance = 'NO') &
             & dble( hamiltonian%h( i + j * ( j - 1 ) / 2 ))
      end do
      write(unit = 7, fmt = '()')
    end do

    POP_SUB(HPrint)
  end Subroutine HPrint

!*************************************************************************
  Subroutine HCheck( hamiltonian, eigenStates, ik )
! Added by DAS, 9 Nov 2010
!*************************************************************************

    use SysParams,      only : one, zero
    use EigenStatesMod, only : eigenStatesT
    use blas_m
    implicit none

    type( hamiltonianArrayT ), pointer :: hamiltonian
    type( eigenStatesT ),      pointer :: eigenStates
    integer, intent(in) :: ik

    integer :: ist, ist2, ng, ig, ig2
    real(double) :: diff, norm
    complex(double) :: energy, overlap
    complex(double), allocatable :: Hpsi(:), Hpsimat(:,:), Hdiag(:,:)
    logical, parameter :: noblas = .true. ! enable naive ways to do it without BLAS

    PUSH_SUB(HCheck)

    ng = hamiltonian%hSize
    allocate(Hpsi(ng))

    do ist = 1, eigenStates%numStates
      if(noblas) then

        energy = 0d0
        do ig = 1, ng
          do ig2 = 1, ng
            energy = energy + conjg(eigenStates%eigenVectors(ig2, ist, ik)) * &
              hamiltonian%SqH(ig2, ig) * eigenStates%eigenVectors(ig, ist, ik)
          enddo
        enddo

      else

#ifdef UNPACKED
        call zhemv('U', ng, (one, zero), hamiltonian%SqH(:,:), hamiltonian%hDim, &
          eigenStates%eigenVectors(:, ist, ik), 1, (zero, zero), Hpsi(:), 1)
#else
        call zhpmv('U', ng, (one, zero), hamiltonian%h(:), &
          eigenStates%eigenVectors(:, ist, ik), 1, (zero, zero), Hpsi(:), 1)
#endif
        energy = zdotc(ng, eigenStates%eigenVectors(:, ist, ik), 1, Hpsi(:), 1)
      endif

! can`t multiply these ways since the leading dimension of SqH is not ng
!      energy = dot_product(conjg(eigenStates%eigenVectors(:, ist, ik)), &
!        matmul(hamiltonian%SqH(:,:), eigenStates%eigenVectors(:, ist, ik)))
!      energy = dot_product(conjg(eigenStates%eigenVectors(1:ng, ist, ik)), &
!        matmul(hamiltonian%SqH(1:ng, 1:ng), eigenStates%eigenVectors(1:ng, ist, ik)))


      if(abs(aimag(energy)) > 1d-10) then
        write(0,'(a)') 'ERROR: EPM diagonalization failure -- expectation value is complex.'
        write(0,'(a,i4,a,i4,a,e13.6)') 'ik = ', ik, '   ist = ', ist, '   aimag(energy) = ', aimag(energy)
        write(0,*) 'energy = ', energy
        write(0,*) 'abs(energy) = ', abs(energy)
        write(0,*) 'eigenvalue = ', eigenStates%eigenValues(ist, ik)
        stop
      endif

      diff = dble(energy) - eigenStates%eigenValues(ist, ik)
      if(abs(diff) > 1d-12) then
        write(0,'(a)') 'ERROR: EPM diagonalization failure -- expectation value differs from eigenvalue.'
        write(0,'(a,i4,a,i4,a,e13.6)') 'ik = ', ik, '   ist = ', ist, '   diff = ', diff
        stop
      endif

      do ist2 = 1, eigenStates%numStates
        if(noblas) then
          overlap = 0d0
          do ig = 1, ng
            overlap = overlap + conjg(eigenStates%eigenVectors(ig, ist, ik)) * eigenStates%eigenVectors(ig, ist2, ik)
          enddo
        else
          overlap = zdotc(ng, eigenStates%eigenVectors(:, ist, ik), 1, eigenStates%eigenVectors(:, ist2, ik), 1)
        endif

        if(ist == ist2) then
! This should be more efficient, but is seg-faulting for some reason
!            norm = dznrm2(ng, eigenStates%eigenVectors(:, ist, ik), 1)
!          norm = sqrt(zdotc(ng, eigenStates%eigenVectors(:, ist, ik), 1, eigenStates%eigenVectors(:, ist2, ik), 1))
          norm = overlap
          if(abs(norm - 1d0) > 4d-14) then
            write(0,'(a)') 'ERROR: EPM diagonalization failure -- eigenvector is not normalized.'
            write(0,'(a,i4,a,i4,a,e13.6,3x,e13.6)') 'ik = ', ik, '   ist = ', ist, '   norm - 1 = ', norm - 1d0
            stop
          endif
        else
          if(abs(overlap) > 4d-14) then
            write(0,'(a)') 'ERROR: EPM diagonalization failure -- eigenvectors are not orthogonal.'
            write(0,'(a,i4,a,i4,a,i4,a,e13.6,3x,e13.6)') 'ik = ', ik, '  ist1 = ', ist, '  ist2 = ', ist2,'  overlap = ', overlap
            stop
          endif
        endif
      enddo
    enddo

    deallocate(Hpsi)

    allocate(Hdiag(eigenStates%numStates, eigenStates%numStates))
    if(.not. noblas) then
      allocate(Hpsimat(ng, eigenStates%numStates))
! DAS -- not clear if there is a way to do this with the packed representation
      call zhemm('L', 'U', ng, eigenStates%numStates, (one, zero), hamiltonian%SqH(:,:), hamiltonian%hDim, &
        eigenStates%eigenVectors(:, :, ik), eigenStates%maxBasisVectors, (zero, zero), Hpsimat(:, :), ng)
    endif
    
    do ist = 1, eigenStates%numStates
      do ist2 = 1, eigenStates%numStates
        if(noblas) then
          Hdiag(ist2, ist) = 0d0
          do ig = 1, ng
            do ig2 = 1, ng
              Hdiag(ist2, ist) = Hdiag(ist2, ist) + conjg(eigenStates%eigenVectors(ig2, ist2, ik)) * &
                hamiltonian%SqH(ig2, ig) * eigenStates%eigenVectors(ig, ist, ik)
            enddo
! DAS -- way to do it with ZHEMM but not ZDOTC
!          Hdiag(ist2, ist) = Hdiag(ist2, ist) + conjg(eigenStates%eigenVectors(ig, ist2, ik)) * Hpsimat(ig, ist)
          enddo
        else
          Hdiag(ist2, ist) = zdotc(ng, eigenStates%eigenVectors(:, ist2, ik), 1, Hpsimat(:, ist), 1)
        endif
      enddo
    enddo

    if(.not. noblas) deallocate(Hpsimat)

    do ist = 1, eigenStates%numStates
      do ist2 = 1, eigenStates%numStates
        if(ist == ist2) then
          diff = Hdiag(ist, ist) - eigenStates%eigenValues(ist, ik)
          if(abs(diff) > 2d-12) then
            write(0,'(a)') 'ERROR: EPM diagonalization failure -- Hdiag(ist, ist) != eigenvalue(ist).'
            write(0,'(a,i4,a,i4,a,e13.6,3x,e13.6)') 'ik = ', ik, '  ist1 = ', ist, ' diff = ', diff
            stop
          endif
        else
          if(abs(Hdiag(ist2, ist)) > 2d-10) then
            write(0,'(a)') 'ERROR: EPM diagonalization failure -- Hamiltonian not diagonalized.'
            write(0,'(a,i4,a,i4,a,i4,a,e13.6,3x,e13.6)') 'ik = ', ik, '  ist1 = ', ist, &
              '  ist2 = ', ist2,'  element = ', Hdiag(ist2, ist)
            stop
          endif
        endif
      enddo
    enddo
    deallocate(Hdiag)

    POP_SUB(HCheck)
  end Subroutine HCheck

end Module HamiltonianMod

!===========================================================================
!
! Routines:
!
! (1) write_result_dyn()        Originally By ?         Last Modified 7/3/2008 (JRD)
!
!     Writes the quasiparticle spectrum to the output
!
!===========================================================================

#include "f_defs.h"

module write_result_dyn_m

  use global_m
  implicit none

  private
  public :: write_result_dyn

contains

subroutine write_result_dyn(kp,wfnk,sig,ach_n1,ax,asx,ach,ach_cor,achcor,asig,alda,efsto,ikn)
  type (kpoints), intent(in) :: kp
  type (wfnkstates), intent(in) :: wfnk
  type (siginfo), intent(in) :: sig
  complex(DPC), intent(in) :: ach_n1(:,:,:) !< (sig%ntband,sig%ndiag+sig%noffdiag,sig%nspin)
  SCALAR, intent(in) :: ax(:,:) !< (sig%ndiag+sig%noffdiag,sig%nspin)
  complex(DPC), intent(in) :: asx(:,:,:) !< (sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin)
  complex(DPC), intent(in) :: ach(:,:,:) !< (sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin)
  complex(DPC), intent(in) :: ach_cor(:,:,:) !< (sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin)
  complex(DPC), intent(in) :: achcor(:,:) !< (sig%ndiag+sig%noffdiag,sig%nspin)
  complex(DPC), intent(in) :: asig(:,:) !< (sig%ndiag+sig%noffdiag,sig%nspin)
  SCALAR, intent(in) :: alda(:,:) !< (sig%ndiag+sig%noffdiag,sig%nspin)
  complex(DPC), intent(in) :: efsto(:,:) !< (sig%ndiag,sig%nspin)
  integer, intent(in) :: ikn
  
  integer :: iw, i, j, ivbm, icbm, idis, ispin
  integer, allocatable :: iwlda(:)
  real(DP) :: sumvcor, sumccor, sumdcor, sumdconv, diff, diffmin, e_lk
  real(DP), allocatable :: sumv(:), sumc(:), sumd(:)
  complex(DPC) :: achconv

  PUSH_SUB(write_result_dyn)

  ! Initialization

  if (sig%fullConvLog .eq. 0) then
    SAFE_ALLOCATE(sumv, (sig%ntband))
    SAFE_ALLOCATE(sumc, (sig%ntband))
    SAFE_ALLOCATE(sumd, (sig%ntband))
    ivbm=0
    icbm=0
    do i = 1, sig%ndiag
      if (sig%diag(i).eq.sig%nvband) ivbm=i
      if (sig%diag(i).eq.sig%nvband+1) icbm=i
    enddo
  endif

  do ispin=1,sig%nspin

! Sigma Diagonal

    SAFE_ALLOCATE(iwlda, (sig%ndiag))

! JRD: Find iw closest to e_lk

    do i = 1, sig%ndiag
      diffmin = INF
      e_lk = wfnk%ek(sig%diag(i),ispin)
      do iw=1,sig%nfreqeval
        diff = abs(sig%freqevalmin + (iw-1)*sig%freqevalstep - e_lk)
        if (diff .lt. diffmin) then
          diffmin=diff
          iwlda(i)=iw
        endif
      enddo
    enddo

    call write_qp(6)
    call write_qp(7)

    SAFE_DEALLOCATE(iwlda)

! CH Convergence Log

    if (sig%fullConvLog .eq. 0) then
      
      write(127,'(a,3e16.8,a,i2)') '# k =',(kp%rk(j,ikn),j=1,3), &
        ' spin=',sig%spin_index(ispin)
      write(127,*) '# n1 ', &
        '<i|Sigma_ch|i> (eV), partial sum'
      write(127,*) '#      nbands   ch(vbm)          ch(cbm)', &
        '           diff        converged'
      
      if (ivbm.ne.0) then
        do j = 1, sig%ntband
          sumv(j) = ryd * sum(dble(ach_n1(1:j,ivbm,ispin)))
        enddo
        sumvcor = sumv(sig%ntband) + dble(achcor(ivbm,ispin))
      else
        do j = 1, sig%ntband
          sumv(j) = 0.0d0
        enddo
        sumvcor = 0.0d0
      endif
      if (icbm.ne.0) then
        do j = 1, sig%ntband
          sumc(j) = ryd * sum(dble(ach_n1(1:j,icbm,ispin)))
        enddo
        sumccor = sumc(sig%ntband) + dble(achcor(icbm,ispin))
      else
        do j = 1, sig%ntband
          sumc(j) = 0.0d0
        enddo
        sumccor = 0.0d0
      endif
      do j = 1, sig%ntband
        sumd(j) = sumc(j) - sumv(j)
      enddo
      sumdcor = sumccor - sumvcor
      
      if (sig%exact_ch.eq.0) then
        idis = sig%ntband / 10
        if (idis.gt.0) then
          sumdconv = (dble(sig%ntband) * sumd(sig%ntband) - &
            dble(sig%ntband - idis) * sumd(sig%ntband - idis)) / dble(idis)
        else
          sumdconv = 0.0d0
        endif
      else
        sumdconv = sumdcor
      endif
      
      do j = 1, sig%ntband
        write(127,'(i8,4e16.8)') j, sumv(j), sumc(j), sumd(j), sumdconv
      enddo
      
    elseif (sig%fullConvLog .eq. 1) then
      
      write(127,801) (kp%rk(j,ikn),j=1,3), ikn, sig%spin_index(ispin)
      write(127,802) sig%ndiag
      do i = 1, sig%ndiag
        write(127,803) sig%diag(i)
        if (sig%exact_ch.eq.0) then
          do j = 1, sig%ntband
            write(127,804) j, ryd * sum(dble(ach_n1(1:j,i,ispin)))
          enddo
        else
          achconv = achcor(i,ispin) + ryd * sum(ach_n1(1:sig%ntband,i,ispin))
          do j = 1, sig%ntband
            write(127,804) j, ryd * sum(dble(ach_n1(1:j,i,ispin))), dble(achconv)
          enddo
        endif
      enddo
      
    elseif (sig%fullConvLog .eq. 2) then
      
      write(127,801) (kp%rk(j,ikn),j=1,3), ikn, sig%spin_index(ispin)
      write(127,802) sig%ndiag
      do i = 1, sig%ndiag
        write(127,803) sig%diag(i)
        if (sig%exact_ch.eq.0) then
          do j = 1, sig%ntband
            write(127,804) j, ryd * sum(ach_n1(1:j,i,ispin))
          enddo
        else
          achconv = achcor(i,ispin) + ryd * sum(ach_n1(1:sig%ntband,i,ispin))
          do j = 1, sig%ntband
            write(127,804) j, ryd * sum(ach_n1(1:j,i,ispin)), achconv
          enddo
        endif
      enddo
      
    endif ! sig%fullConvLog
    
801 format('#',1x,'k =',3f10.6,1x,'ik =',i4,1x,'spin =',i2)
802 format(2x,'nbands',i5)
803 format(2x,'band =',i5)
804 format(i8,4e16.8)
    
  enddo ! ispin
  
  if (sig%fullConvLog .eq. 0) then
    SAFE_DEALLOCATE(sumv)
    SAFE_DEALLOCATE(sumc)
    SAFE_DEALLOCATE(sumd)
  endif
  
  POP_SUB(write_result_dyn)
  
  return

contains

  subroutine write_qp(iunit)
    integer, intent(in) :: iunit

    write(iunit,979) (kp%rk(j,ikn),j=1,3),ikn,sig%spin_index(ispin)
979 format(/,7x,"k =",3f10.6,1x,"ik =",i4,1x,"spin =",i2)

    write(iunit,978)
978 format(/,3x,"n",5x,"elda",5x,"ecor",8x,"x",2x,"re sx-x",4x, &
      "re ch",3x,"re sig",4x,"re cor",4x,"vxc",5x,"re eqp0", &
      /,33x,"im sx-x",4x,"im ch",3x,"im sig",4x,"im cor",12x,"im eqp0")

    write(iunit,977) (sig%diag(i),wfnk%elda(sig%diag(i),ispin), &
      wfnk%ek(sig%diag(i),ispin),dble(ax(i,ispin)),dble(asx(iwlda(i),i,ispin)), &
      dble(ach(iwlda(i),i,ispin)+achcor(i,ispin)),dble(asig(i,ispin)+achcor(i,ispin)),&
      dble(ach_cor(iwlda(i),i,ispin)+achcor(i,ispin)),dble(alda(i,ispin)), &
      dble(efsto(i,ispin)+achcor(i,ispin)),IMAG(asx(iwlda(i),i,ispin)), &
      IMAG(ach(iwlda(i),i,ispin)),IMAG(asig(i,ispin)),&
      IMAG(ach_cor(iwlda(i),i,ispin)),IMAG(efsto(i,ispin)),i=1,sig%ndiag)
977 format(i4,9f9.3,/,31x,4f9.3,9x,f9.3)

! Sigma Off-Diagonal

    if (sig%noffdiag.gt.0) then
      write(iunit,969)
969 format(/,3x,"n",3x,"m",3x,"l",18x,"x",5x,"sx-x",7x,"ch",6x,"sig",6x,"vxc")

      do i=sig%ndiag+1,sig%ndiag+sig%noffdiag
        iw=iwlda(sig%offmap(i-sig%ndiag, 3))

        write(iunit,968) sig%off1(i-sig%ndiag),sig%off2(i-sig%ndiag), &
          sig%off3(i-sig%ndiag),dble(ax(i,ispin)),dble(asx(iw,i,ispin)), &
          dble(ach(iw,i,ispin)+achcor(i,ispin)),dble(ax(i,ispin)+asx(iw,i,ispin)+ach(iw,i,ispin)+achcor(i,ispin)), &
          dble(alda(i,ispin))
968 format(3i4,3x,"real",3x,5f9.3)

#ifdef CPLX
        write(iunit,967) sig%off1(i-sig%ndiag),sig%off2(i-sig%ndiag), &
          sig%off3(i-sig%ndiag),IMAG(ax(i,ispin)),IMAG(asx(iw,i,ispin)), &
          IMAG(ach(iw,i,ispin)),IMAG(ax(i,ispin)+asx(iw,i,ispin)+ach(iw,i,ispin)), &
          IMAG(alda(i,ispin))
#else
        write(iunit,967) sig%off1(i-sig%ndiag),sig%off2(i-sig%ndiag), &
          sig%off3(i-sig%ndiag),0.0d0,IMAG(asx(iw,i,ispin)), &
          IMAG(ach(iw,i,ispin)+achcor(i,ispin)),IMAG(asx(iw,i,ispin)+ach(iw,i,ispin)+achcor(i,ispin)), &
          0.0d0
#endif
967 format(3i4,3x,"imag",3x,5f9.3)
      enddo
    endif

  end subroutine write_qp

end subroutine write_result_dyn

end module write_result_dyn_m

!===============================================================================
!
! Routines:
!
! (1) absp()            Originally By: MLT      Last Modified   6/5/2008 (JRD)
!
!     input: eta,sigma,gamma energy resolution, given in eV
!            neig            number of excitonic states
!            cs              transition matrix elements, given in au
!            en              energy eigenvalue of each state, given in eV
!            vol             crystal volume (cell volume times # of k-points)
!            omega_plasma    plasma frequency, given in Ryd
!            flag            flags type
!
!     output: file "absorption_eh.dat"
!
!     Calculate the absorption with electron-hole interaction,
!     using eq. (26) of Rohlfing & Louie PRB 62 4927 (2000),
!     and the density of exciton states, given in Ryd^-1.
!
!     epsilon_1 always uses Lorentzian broadening.
!     epsilon_2 uses Lorentzian, Gaussian or Voigt, depending on flag%lor
!     delta(x) -> (eta/pi)/(x^2+eta^2)
!     delta(x) -> exp(-x^2/(2*eta^2))/(sqrt(2*pi)*eta)
!     delta(x) -> Voigt(x,sigma,gamma)
!
!     See the comment about the prefactor in file absp0.f90
!
!     omega = frequency, given in eV
!     eta,sigma,gamma = energy broadening, given in eV
!
!===============================================================================

#include "f_defs.h"

subroutine absp(xct,neig,cs,en,vol,omega_plasma,flag)

  use global_m
  use misc_m
  implicit none

  type(xctinfo), intent(in) :: xct
  integer, intent(in) :: neig
  real(DP), intent(in) :: cs(neig), en(neig), vol, omega_plasma
  type (flags), intent(in) :: flag

  integer :: ii,iemax,iw,nwstep
  real(DP) :: emin,emax,eps1,eps2,dos
  real(DP) :: omega,fac,fac1,fac2,sum,sum1,sum2,pref
  
  PUSH_SUB(absp)
  
  pref = 16.d0 * PI_D**2 / vol
  ! the factor 1/sqrt(nspin) in absp0 is handled by the normalization of the exciton here
  
!----------------------------
! Check the f-sum rule using BSE eigenvalues.
! Exact value of the sum rule:
! sum1 = (pi / 2.d0) * (plasma frequency)^2

  sum1 = 0.d0
  do ii=1,neig
    sum1 = sum1 + cs(ii) * en(ii)
  enddo
  sum1 = sum1 * pref * ryd
  if (omega_plasma.lt.TOL_Small) then
    write(6,*)
    write(6,*) 'Sum rule (BSE) : ',sum1,' eV^2'
    write(6,*)
  else
    sum1 = sum1 / (0.5d0 * PI_D * omega_plasma**2 * ryd**2)
    write(6,*)
    write(6,*) 'Plasma Frequency : ',omega_plasma*ryd,' eV'
    write(6,*)
    write(6,*) 'Sum rule (BSE) : ',sum1
    write(6,*)
  endif
  emin = minval(en)
  emax = maxval(en)
!      emin = max(emin - 10.d0 * xct%eta, 0.d0)
!      emax = emax + 10.d0 * xct%eta
!      nwstep = 10000
  emin = 0.d0
  iemax = int(emax + 10.d0 * xct%eta) + 1
  emax = dble(iemax)
  nwstep = 100 * iemax

  call open_file(10,file='absorption_eh.dat',form='formatted',status='replace')
  
  write(10,*) "# Column 1: omega"
  write(10,*) "# Column 2: eps2(omega)"
  write(10,*) "# Column 3: eps1(omega)"
  write(10,*) "# Column 4: JDOS(omega)"

  do iw=0,nwstep
    eps2 = 0.d0
    eps1 = 0.d0

!-----------------------------
! Absorption contribution

    omega = emin + (emax - emin) * dble(iw) / dble(nwstep)
    sum = 0.d0
    sum1 = 0.d0
    sum2 = 0.d0
    do ii=1,neig
      fac = omega - en(ii)
      fac1 = (-fac / PI_D)/(fac**2 + xct%eta**2)
      sum1 = sum1 + cs(ii) * fac1 * ryd
      
      if (flag%lor .eq. 0) then
        fac2 = (xct%eta / PI_D) / (fac**2 + xct%eta**2)
      else if (flag%lor .eq. 1) then
        fac2 = exp(-fac**2 / (2.d0 * xct%eta**2)) / (sqrt(2.d0 * PI_D) * xct%eta)
      else
        fac2 = voigt(fac, xct%sigma, xct%gamma)
      endif
      
      sum2 = sum2 + cs(ii) * fac2 * ryd
      sum = sum + fac2
    enddo
    eps1 = 1.d0 + pref*sum1
    eps2 = pref*sum2
    dos = sum*xct%nspin/dble(neig)

!---------------------------
! Emission contribution
! These correspond to peaks in the spectra at negative omega used so
! eps2 gets negative contribution, so it vanishes at zero frequency.

    sum1 = 0.d0
    sum2 = 0.d0
    do ii=1,neig
      fac = -omega - en(ii)
      fac1 = (-fac / PI_D) / (fac**2 + xct%eta**2)
      sum1 = sum1 + cs(ii) * fac1 * ryd
      
      if (flag%lor .eq. 0) then
        fac2 = -(xct%eta / PI_D) / (fac**2 + xct%eta**2)
      else if (flag%lor .eq. 1) then
        fac2 = -exp(-fac**2 / (2.d0 * xct%eta**2)) / (sqrt(2.d0 * PI_D) * xct%eta)
      else
        fac2 = -voigt(fac, xct%sigma, xct%gamma)
      endif
      
      sum2 = sum2 + cs(ii) * fac2 * ryd
    enddo
    eps1 = eps1 + pref * sum1
    eps2 = eps2 + pref * sum2
    write(10,100)omega,eps2,eps1,dos
  enddo
  
  call close_file(10)
  
  POP_SUB(absp)
  
  return
  
100 format(4f16.9)
  
end subroutine absp

!===========================================================================
!
! Included from inversion.F90
!
!============================================================================

!---------------------- Use scaLAPACK For Inversion -----------------------------------


#ifdef USESCALAPACK

subroutine X(invert_with_scalapack)(nmtx, scal, matrix)
  integer, intent(in) :: nmtx
  type (scalapack), intent(in) :: scal
  SCALAR, intent(inout) :: matrix(scal%npr,scal%npc)

  integer :: ij, ik, info
  integer :: irow, icol, icurr, irowm, icolm
  integer :: descaA(9), descaB(9)
  character*16 :: tmpstr1
  character*256 :: tmpstr
  integer, allocatable :: ipiv(:)
  SCALAR, allocatable :: temp(:, :)

!-------------------------
! scaLAPACK Case (Added by JRD - must specify USESCALAPACK in arch.mk)

  PUSH_SUB(X(invert_with_scalapack))

#ifdef VERBOSE
  if (peinf%inode .eq. 0) then
    write(6,*) ' '
    write(6,*) 'We are doing inversion with scaLAPACK.'
    write(6,*) ' '
    write(6,*) 'Peinf: ', peinf%inode,' Scalapack Grid:'
    write(6,*) scal%nprow,scal%npcol,scal%myprow,scal%mypcol
    write(6,*) nmtx,scal%nbl,scal%npr,scal%npc
    write(6,*) ' '
  end if
#endif

  SAFE_ALLOCATE(temp, (scal%npr,scal%npc))
  temp = 0D0

  call descinit(descaA,nmtx,nmtx,scal%nbl,scal%nbl,0, &
    0,scal%icntxt,MAX(1,scal%npr),info)
  if(info < 0) then
    write(0,'(a,i3,a)') 'Argument number ', -info, ' had an illegal value on entry.'
    call die("descinit error for descaA in inversion")
  else if(info > 0) then
    write(0,*) 'info = ', info
    call die("descinit error for descaA in inversion")
  endif

  call descinit(descaB,nmtx,nmtx,scal%nbl,scal%nbl,0, &
    0,scal%icntxt,MAX(1,scal%npr),info)
  if(info < 0) then
    write(0,'(a,i3,a)') 'Argument number ', -info, ' had an illegal value on entry.'
    call die("descinit error for descaB in inversion")
  else if(info > 0) then
    write(0,*) 'info = ', info
    call die("descinit error for descaB in inversion")
  endif

  SAFE_ALLOCATE(ipiv, (scal%npr+scal%nbl))

!------------------
! Construct identity for rhs

  icurr=0
  
  do ij = 1, nmtx
    irow=MOD(INT(((ij-1)/scal%nbl)+TOL_SMALL),scal%nprow)
    do ik = 1, nmtx
      icol=MOD(INT(((ik-1)/scal%nbl)+TOL_SMALL),scal%npcol)
      if(irow .eq. scal%myprow .and. icol .eq. scal%mypcol) then
        icurr=icurr+1
        irowm=INT((icurr-1)/scal%npc+TOL_SMALL)+1
        icolm=MOD((icurr-1),scal%npc)+1
        if (ik .eq. ij) then
          temp(irowm,icolm)=ONE
        else
          temp(irowm,icolm)=ZERO
        end if
      end if
    enddo
  enddo

  call pX(gesv)(nmtx,nmtx,matrix,1,1,descaA,ipiv,temp,1,1,descaB,info)

  if (info.ne.0) then
    write(tmpstr1,'(i16)') info
    write(tmpstr,'(a)') 'failed in ' // TOSTRING(pX(gesv)) // &
     ' with error code ' // TRUNC(tmpstr1) // '.'
    call die(tmpstr)
  endif

  matrix = temp

  SAFE_DEALLOCATE(ipiv)
  SAFE_DEALLOCATE(temp)
  
  POP_SUB(X(invert_with_scalapack))
  return
end subroutine X(invert_with_scalapack)

#endif

!------------------------------------------------------------

subroutine X(invert_serial)(nmtx, matrix)
  integer, intent(in) :: nmtx
  SCALAR, intent(inout) :: matrix(nmtx,nmtx)

  integer :: ii, info
  character*16 :: tmpstr1
  character*256 :: tmpstr
  integer, allocatable :: ipvt(:)
  SCALAR, allocatable :: temp(:, :)

  PUSH_SUB(X(invert_serial))

  SAFE_ALLOCATE(ipvt, (nmtx))
  SAFE_ALLOCATE(temp, (nmtx, nmtx))
  
  temp(:,:) = ZERO
  do ii=1,nmtx
    temp(ii,ii) = ONE
  enddo

#ifdef USEESSL
  call X(gef)(matrix(1,1),nmtx,nmtx,ipvt(1))
  call X(gesm)('N',matrix(1,1),nmtx,nmtx,ipvt(1),temp(1,1),nmtx,nmtx)
#else
! Call LAPACK routine to solve for X in matrix*X=temp
! and put the result into temp.

  call X(gesv)(nmtx,nmtx,matrix,nmtx,ipvt,temp,nmtx,info)

  if (info.ne.0) then
    write(tmpstr1,'(i16)') info
    write(tmpstr,'(a)') 'failed in ' // TOSTRING(X(gesv)) // &
     ' with error code ' // TRUNC(tmpstr1) // '.'
    call die(tmpstr)
  endif
#endif

! Copy result back into matrix.

  matrix = temp

  SAFE_DEALLOCATE(ipvt)
  SAFE_DEALLOCATE(temp)
  
  POP_SUB(X(invert_serial))
  return
end subroutine X(invert_serial)

#include "f_defs.h"

!-----------------------------------------------------------------------
subroutine input_kernel(crys,gvec,kg,kp,syms,xct,flagbz, &
  intwfnv,intwfnc)
!-----------------------------------------------------------------------
!
!     Read parameters from file WFN_co
!     Initialize k-points sampling, kg type
!     Initialize G-space, gvec
!
!     input: xct type
!
!     output: crys,gvec,syms,kg types
!             INT_VWFN_* and INT_CWFN_* files
!
  use global_m
  use checkbz_m
  use fullbz_m
  use input_utils_m
  use misc_m
  use sort_m
  use wfn_rho_vxc_io_m
  use read_rho_vxc_m
  implicit none

  type (crystal), intent(out) :: crys
  type (gspace), intent(out) :: gvec
  type (grid), intent(out) :: kg
  type (kpoints), intent(out) :: kp
  type (symmetry), intent(out) :: syms
  type (xctinfo), intent(inout) :: xct
  integer, intent(in) :: flagbz
  type (int_wavefunction), intent(out) :: intwfnc,intwfnv


  type (wavefunction) :: wfnc,wfnv
  character :: tmpfn*16
  integer :: iwritev,iwritec,iwritek
  integer :: ickmem,irk
  integer :: ii,jj,kk,is
  integer :: irks,ivband,icband

  real(DP) :: diffvol,vcell,raux,kt(3),div,tol
  
  real(DP), allocatable :: ek_tmp(:)
  integer, allocatable :: index(:),indxk(:),k_tmp(:,:)
  integer, allocatable :: isrti(:)
  SCALAR, allocatable :: cg(:,:), cgarray(:)

  character(len=3) :: sheader
  integer :: iflavor
  type(gspace) :: gvec_kpt
  logical :: skip_checkbz

  PUSH_SUB(input_kernel)

#ifdef VERBOSE
  if (peinf%inode .eq. 0) write(6,*) ' '
#endif

  call logit('input_kernel:  reading WFN_co')

  if (peinf%inode == 0) call open_file(25,file='WFN_co',form='unformatted',status='old')

  sheader = 'WFN'
  iflavor = 0
  call read_binary_header_type(25, sheader, iflavor, kp, gvec, syms, crys, dont_warn_kgrid=xct%patched_sampling_co)
  call check_trunc_kpts(xct%icutv, kp)

  if(any(kp%shift > TOL_Zero) .and. peinf%inode == 0) then
    write(0,'(a)') "WARNING: WFN_co has a shift. This is not recommended."
  endif

  call logit('input_kernel:  reading gvec info')
  SAFE_ALLOCATE(gvec%components, (3, gvec%ng))
  call read_binary_gvectors(25, gvec%ng, gvec%ng, gvec%components)

  call get_volume(vcell,crys%bdot)
  diffvol=abs(crys%celvol-vcell)
  if (diffvol.gt.TOL_Small) then
    call die('volume mismatch', only_root_writes = .true.)
  endif

  ! there is no fine grid to set the Fermi level in kernel
  call find_efermi(xct%rfermi, xct%efermi, xct%efermi_input, kp, kp%mnband, 1, &
    "coarse grid", should_search = .true., should_update = .true., write7 = .false.)

  call assess_degeneracies(kp, kp%el(kp%mnband, :, :), kp%mnband - 1, xct%efermi, TOL_Degeneracy)

  xct%nspin=kp%nspin

  if(any(kp%ifmax(:,:) == 0)) &
    call die("BSE codes cannot handle a system where some k-points have no occupied bands.", only_root_writes = .true.)

  kp%nvband=minval(kp%ifmax(:,:)-kp%ifmin(:,:))+1
  kp%ncband=kp%mnband-maxval(kp%ifmax(:,:))

!----------------------------------------------------------------
! (gsm) check whether the requested number of bands
!       is available in the wavefunction file

  if(xct%nvb_co.gt.kp%nvband) then
    call die("The requested number of valence bands is not available in WFN_co.", &
             only_root_writes=.true.)
  endif
  if(xct%ncb_co.gt.kp%ncband) then
    call die("The requested number of conduction bands is not available in WFN_co.", &
             only_root_writes=.true.)
  endif

! DAS: degenerate subspace check

  if (peinf%inode.eq.0) then
    if(xct%ncb_co.eq.kp%ncband) then
      call die("You must provide one more conduction band in WFN_co in order to assess degeneracy.", &
               only_root_writes=.true.)
    endif
    do jj = 1, kp%nspin
      do ii = 1, kp%nrk
        if(kp%ifmax(ii, jj) - xct%nvb_co > 0) then
          ! no need to compare against band 0 if all valence are included
          if(abs(kp%el(kp%ifmax(ii, jj) - xct%nvb_co + 1, ii, jj) &
            - kp%el(kp%ifmax(ii, jj) - xct%nvb_co, ii, jj)) .lt. TOL_Degeneracy) then
            if(xct%degeneracy_check_override) then
              write(0,'(a)') &
                "WARNING: Selected number of valence bands breaks degenerate subspace in WFN_co. " // &
                "Run degeneracy_check.x for allowable numbers."
              write(0,*)
            else
              write(0,'(a)') &
                "Run degeneracy_check.x for allowable numbers, or use keyword " // &
                "degeneracy_check_override to run anyway (at your peril!)."
              call die("Selected number of valence bands breaks degenerate subspace in WFN_co.", &
                       only_root_writes=.true.)
            endif
          endif
        endif
        if(abs(kp%el(kp%ifmax(ii, jj) + xct%ncb_co, ii, jj) &
          - kp%el(kp%ifmax(ii, jj) + xct%ncb_co + 1, ii, jj)) .lt. TOL_Degeneracy) then 
          if(xct%degeneracy_check_override) then
            write(0,'(a)') &
              "WARNING: Selected number of conduction bands breaks degenerate subspace in WFN_co. " // &
              "Run degeneracy_check.x for allowable numbers."
            write(0,*)
          else
            write(0,'(a)') &
              "Run degeneracy_check.x for allowable numbers, or use keyword " // &
              "degeneracy_check_override to run anyway (at your peril!)."
            call die("Selected number of conduction bands breaks degenerate subspace in WFN_co.",&
                     only_root_writes=.true.)
          endif
        endif
      enddo
    enddo
  endif

!-----------------------------------------------------------------------
!     Read the k-point sampling from kpoints (if it exists) or from
!     WFN_co

  if (xct%read_kpoints) then
    if (peinf%inode.eq.0) then
      call open_file(9,file='kpoints_co',form='formatted',status='old')
      read(9,*) kg%nr
      SAFE_ALLOCATE(kg%r, (3,kg%nr))
      do ii=1,kg%nr
        read(9,*) (kg%r(jj,ii),jj=1,3),div
        kg%r(:,ii) = kg%r(:,ii)/div
      enddo
      call close_file(9)
    endif
#ifdef MPI
    call MPI_BCAST(kg%nr,   1,     MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
    if(peinf%inode.ne.0) then
      SAFE_ALLOCATE(kg%r, (3,kg%nr))
    endif
    call MPI_BCAST(kg%r,    3*kg%nr,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
#endif

!----------------------------------------------------------------
!     indxk : stores the correspondence between k-points kg%r and kp%rk
!     (it is used to select the set of wavefunctions to be stored)
!     tol : tolerance in the coordinates of k-points

    tol = 1.d-4
    SAFE_ALLOCATE(indxk, (kg%nr))
    indxk=0
    do jj=1,kg%nr
      do ii=1,kp%nrk
        kt(:) = kg%r(:,jj) - kp%rk(:,ii)
        if ((abs(kt(1)).lt.tol).and.(abs(kt(2)).lt.tol) &
          .and.(abs(kt(3)).lt.tol)) then
          if (indxk(jj).ne.0) write(0,*) 'WARNING: multiple definition of k-point',jj,indxk(jj),kg%r(:,jj)
          indxk(jj)=ii
        endif
      enddo
      if (indxk(jj).eq.0) write(0,*) 'WARNING: could not find vector ',kg%r(:,jj),' in WFN_co'
!
!     no need to stop here; if indxk.eq.0, the job will stop in genwf
!
    enddo
  else
    kg%nr=kp%nrk
    SAFE_ALLOCATE(kg%r, (3,kg%nr))
    kg%r(1:3,1:kg%nr)=kp%rk(1:3,1:kp%nrk)
    SAFE_ALLOCATE(indxk, (kg%nr))
    do ii=1,kg%nr
      indxk(ii) = ii
    enddo
  endif

!-----------------------------------------------------------------------
!     Order g-vectors with respect to their kinetic energy
!
!     xct%ecute = energy cutoff used in dielectric matrix
!     xct%ecutg = energy cutoff used in wavefunctions and interaction
!                   kernel, see Rohlfing & Louie, PRB 62(8),p. 4938
!                   (must be slightly longer than xct%ecute because
!                   of umklapp vectors)
!
  call logit('input_kernel:  reordering gvecs')
  raux=0.d0
  do ii=1,3
    if (crys%bdot(ii,ii).gt.raux) raux=crys%bdot(ii,ii)
  enddo
  if (abs(xct%ecutg).lt.TOL_Zero) xct%ecutg = xct%ecute + raux
  
  SAFE_ALLOCATE(index, (gvec%ng))
  SAFE_ALLOCATE(gvec%ekin, (gvec%ng))
  call kinetic_energies(gvec, crys%bdot, gvec%ekin)
  call sortrx(gvec%ng, gvec%ekin, index, gvec = gvec%components)


  xct%ng   = gcutoff(gvec%ng, gvec%ekin, index, xct%ecutg)
  if (xct%theory.eq.0) &
  xct%neps = gcutoff(gvec%ng, gvec%ekin, index, xct%ecute) ! cuteness energy??

  if(peinf%inode == 0) then
    if (xct%theory.eq.0) &
    write(6,'(a,f12.6,a,i8,a)') 'Screened coulomb cutoff = ', xct%ecute, ' Ry :', xct%neps, ' G-vectors'
    write(6,'(a,f12.6,a,i8,a)') 'Bare coulomb cutoff     = ', xct%ecutg, ' Ry :',   xct%ng, ' G-vectors'
  endif
  if(xct%ecute > xct%ecutg .and. xct%theory.eq.0) then
    call die("The screened_coulomb_cutoff cannot be greater than the bare_coulomb_cutoff.", only_root_writes = .true.)
  endif

  SAFE_ALLOCATE(ek_tmp, (gvec%ng))
  ek_tmp = gvec%ekin
  SAFE_ALLOCATE(k_tmp, (3,gvec%ng))
  k_tmp = gvec%components
  do ii=1,gvec%ng
    gvec%ekin(ii) = ek_tmp(index(ii))
    gvec%components(:,ii) = k_tmp(:,index(ii))
  enddo

  call gvec_index(gvec)

  ! If we are not doing just purely TDHF then
  ! read the charge density/fxc
  if ((xct%theory == 1) .and. ((1.0d0 - xct%coulomb_mod%long_range_frac_fock > TOL_SMALL) .or. &
     (1.0d0 - xct%coulomb_mod%short_range_frac_fock > TOL_SMALL))) then
    xct%coul_mod_flag=.true.
    SAFE_ALLOCATE(isrti, (gvec%ng))
    do ii=1,gvec%ng
      isrti(index(ii)) = ii
    enddo
    call read_rho(xct%wpg, gvec, kp, syms, crys, isrti, index, 'WFN_co')
    SAFE_DEALLOCATE(isrti)
  endif

  SAFE_DEALLOCATE(index)
  SAFE_DEALLOCATE(ek_tmp)
  SAFE_DEALLOCATE(k_tmp)

  
!-----------------------------------------------------------------------
!     Generate full brillouin zone from irreducible wedge, rk -> fk
!
!     If flagbz.eq.1, only Identity will be used as
!     symmetry operation. In this case, kg%r (irreducible BZ) and kg%f
!     (full BZ) will be identical.
!
  if (flagbz.eq.0.and.peinf%inode.eq.0) write(6,801)
  if (flagbz.eq.1.and.peinf%inode.eq.0) write(6,802)
801 format(1x,'Using symmetries to expand the coarse grid sampling',/)
802 format(1x,'No symmetries used in the coarse grid sampling',/)
!
  call timacc(7,1)
  if (flagbz.eq.1) then
    call fullbz(crys,syms,kg,1,skip_checkbz,wigner_seitz=.true.,paranoid=.true.)
  else
    call fullbz(crys,syms,kg,syms%ntran,skip_checkbz,wigner_seitz=.true.,paranoid=.true.)
  endif
  tmpfn='WFN_co'
  if (.not. skip_checkbz) then
    call checkbz(kg%nf,kg%f,kp%kgrid,kp%shift,crys%bdot, &
      tmpfn,'k',.true.,xct%freplacebz,xct%fwritebz)
  endif
  call timacc(7,2)
  xct%nkpt_co=kg%nf

#ifdef VERBOSE
  if (peinf%inode.eq.0) then
    write(6,*) 'xct%nkpt_co = ',xct%nkpt_co
    write(6,'(a5,3a9,2a7,5x,3a5)') &
      'i',' ','k',' ','indr','itran','kg0'
    do ii=1,kg%nf
      write(6,'(i5,3f9.4,2i7,5x,3i5)') &
        ii,kg%f(:,ii),kg%indr(ii),kg%itran(ii),kg%kg0(:,ii)
    enddo
  endif
#endif

!------------------------------------------------
! Distribute vcks-quadruplets among the PEs

  call logit('input_kernel:  calling distrib_kernel')
  call distrib_kernel(xct,kp%ngkmax,kg,kg,gvec)

#ifdef VERBOSE
  if (peinf%inode .eq. 0) then
    write(6,*)
    write(6,*) "Allocating isort", peinf%iownwfv(peinf%inode+1), peinf%iownwfc(peinf%inode+1), gvec%ng
  endif
#endif
  SAFE_ALLOCATE(intwfnv%cg, (kp%ngkmax,peinf%iownwfv(peinf%inode+1),kp%nspin))
  SAFE_ALLOCATE(intwfnc%cg, (kp%ngkmax,peinf%iownwfc(peinf%inode+1),kp%nspin))
  SAFE_ALLOCATE(intwfnv%isort, (gvec%ng,peinf%iownwfk(peinf%inode+1)))
  SAFE_ALLOCATE(intwfnc%isort, (gvec%ng,peinf%iownwfk(peinf%inode+1)))
  SAFE_ALLOCATE(intwfnv%ng, (peinf%iownwfk(peinf%inode+1)))
  SAFE_ALLOCATE(intwfnc%ng, (peinf%iownwfk(peinf%inode+1)))
  intwfnv%nspin=kp%nspin
  intwfnc%nspin=kp%nspin

!------------------------------------------------
! Begin Loop

  SAFE_ALLOCATE(wfnv%isort, (gvec%ng))
  SAFE_ALLOCATE(wfnc%isort, (gvec%ng))
  wfnv%nspin=kp%nspin
  wfnc%nspin=kp%nspin

  do irk=1,kp%nrk
    irks = 0
    do ii=1,kg%nr
      if (irk == indxk(ii)) then
        irks=ii
        exit
      endif
    enddo

    SAFE_ALLOCATE(gvec_kpt%components, (3, kp%ngk(irk)))
    call read_binary_gvectors(25, kp%ngk(irk), kp%ngk(irk), gvec_kpt%components)

    SAFE_ALLOCATE(cg, (kp%ngk(irk),kp%nspin))
    if(irks > 0) then
      do ii = 1, kp%ngk(irk)
        call findvector(wfnv%isort(ii), gvec_kpt%components(:, ii), gvec)
        if(wfnv%isort(ii) == 0) call die('could not find gvec', only_root_writes=.true.)
      enddo

      wfnv%ng=kp%ngk(irk)
      wfnc%ng=kp%ngk(irk)
      SAFE_ALLOCATE(cgarray, (kp%ngk(irk)))
      wfnc%isort(1:gvec%ng)=wfnv%isort(1:gvec%ng)
      ickmem=0
    endif

!        write(6,*) peinf%inode, 'loop wfnup', irk

! Loop Over Bands

    do ii=1,kp%mnband
          
      call read_binary_data(25, kp%ngk(irk), kp%ngk(irk), kp%nspin, cg)

! If we do not need this band, skip it...
      if(irks == 0) cycle
!
      do is=1, kp%nspin
        if (ii .ge. (kp%ifmax(irk,is)-xct%nvb_co+1) .and. ii .le. (kp%ifmax(irk,is)+xct%ncb_co)) then
! Check normalization of this band
          if (peinf%inode.eq.0) then
            do kk=1, kp%ngk(irk)
              cgarray(kk)=cg(kk, is)
            end do
            call checknorm('WFN_co',ii,irks,kp%ngk(irk),kp%nspin,kp%nspinor,cg(:,:))
          end if
!          write(6,*) peinf%inode, 'Read', irk, ii
              
!-----------------------
! If ii is one of the selected valence band...
          if((ii.le.kp%ifmax(irk,is)).and. &
            (ii.ge.(kp%ifmax(irk,is)-xct%nvb_co+1))) then
                
!            write(6,*) peinf%inode, 'in val',irk,ii
                
                
#ifdef MPI
            call MPI_BCAST(cgarray,kp%ngk(irk),MPI_SCALAR,0, &
              MPI_COMM_WORLD,mpierr)
#endif
                
            ivband=kp%ifmax(irk,is)-ii+1
            iwritev=peinf%ipev(peinf%inode+1,ivband,irk)
            iwritek=peinf%ipek(peinf%inode+1,irk)
!            write(6,*) peinf%inode, 'bcast val',irk,ii,ivband,
!     >       iwritev
            if(iwritev.ne.0) then
              intwfnv%cg(1:wfnv%ng,iwritev,is)=cgarray(1:kp%ngk(irk))
            endif
            if(iwritek.ne.0) then
              intwfnv%isort(1:gvec%ng,iwritek)=wfnv%isort(1:gvec%ng)
              intwfnv%ng(iwritek)=kp%ngk(irk)
            endif

!            write(*,'(a, 4i4)') 'valence', peinf%inode+1, ivband, irk, iwritev
!            write(*, '(a, 6i5)') "valence", ivband, ii, is, peinf%inode, irk, iwritev
!            write(6,*) peinf%inode, 'wrote val',irk,ii

          endif !ii is one of the selected valence band

!-----------------------
! If ii is one of the selected conduction band...
              
          if((ii.ge.(kp%ifmax(irk,is)+1)) &
            .and.(ii.le.(kp%ifmax(irk,is)+xct%ncb_co))) then
                
#ifdef MPI
            call MPI_BCAST(cgarray,kp%ngk(irk),MPI_SCALAR,0, &
              MPI_COMM_WORLD,mpierr)
#endif
                
            icband=ii-kp%ifmax(irk,is)
            iwritec=peinf%ipec(peinf%inode+1,icband,irk)
            iwritek=peinf%ipek(peinf%inode+1,irk)
!            write(6,*) 'icband',ii,icband,iwritec
            if(iwritec.ne.0) then
              intwfnc%cg(1:wfnc%ng,iwritec,is)=cgarray(1:kp%ngk(irk))
            endif
            if(iwritek.ne.0) then
              intwfnc%isort(1:gvec%ng,iwritek)=wfnc%isort(1:gvec%ng)
              intwfnc%ng(iwritek)=kp%ngk(irk)
            endif

!            write(*,'(a, 4i4)') 'conduction', peinf%inode+1, icband, irk, iwritec
!            write(*, '(a, 6i5)') "conduction", icband, ii, is, peinf%inode, irk, iwritec

          endif ! ii is one of the selected conduction bands
        end if
      end do
    enddo ! ii (loop on bands)

    SAFE_DEALLOCATE(cg)
    SAFE_DEALLOCATE(cgarray)
    
  enddo !end loop over k-points

  SAFE_DEALLOCATE_P(wfnv%isort)
  SAFE_DEALLOCATE_P(wfnc%isort)
  SAFE_DEALLOCATE(indxk)
      
! Write out info about xtal

  if(peinf%inode.eq.0) then
    write(6,'(1x,a)') 'Crystal wavefunctions read from unit WFN_co'
    write(6,'(/,1x,a,i0)') 'nrk = ', kg%nr
    write(6,'(/,1x,a,i0,2x,a,f10.6)') 'nfk = ', kg%nf, 'ksz = ', kg%sz
#ifdef VERBOSE
    write(6,*)
    write(6,'(1x,3f10.6)') kg%r(1:3,1:kg%nr)
    write(6,*)
#endif
    call close_file(25)
  endif ! node 0

  if(xct%iwriteint == 0) then
#ifdef MPI
    call MPI_Barrier(MPI_COMM_WORLD, mpierr)
#endif
  endif

  POP_SUB(input_kernel)

  return
end subroutine input_kernel

!=============================================================================
!
! Utilities:
!
! (1) degeneracy_check    Originally By DAS      Last Modified 12/13/2010 (DAS)
!
!     Determines numbers of bands that can be used, compatible with the
!     degenerate subspaces. Any number of wavefunctions can be given,
!     in new format.
!
!==============================================================================

#include "f_defs.h"

program degeneracy_check

  use global_m
  use wfn_rho_vxc_io_m
  implicit none

  type(crystal) :: crys
  type(symmetry) :: syms
  type(kpoints) :: kp
  type(gspace) :: gvec
  character*3 :: sheader
  character*256 :: infile, usage
  integer :: ib, iflavor, minband, minvband, mincband, ik, is
  integer :: nargs, ifile
  logical, allocatable :: ok(:), ok_vband(:), ok_cband(:)

  usage = 'Usage: degeneracy_check.x wfn [wfn2 [...]]'

! Get file names from command-line arguments

  nargs = iargc()

  if (nargs .lt. 1) then
    call die(usage)
  endif

  do ifile = 1, nargs

    call getarg(ifile, infile)
    call open_file(unit=7,file=TRUNC(infile),form='unformatted',status='old')

    sheader = 'WFN'
    iflavor = -1
    call read_binary_header_type(7, sheader, iflavor, kp, gvec, syms, crys, warn = .false., dont_warn_kgrid = .true.)

    ! Output info
    write(6,'(a)') 'Reading eigenvalues from file ' // TRUNC(infile)
    write(6,'("Number of spins:",i16)') kp%nspin
    write(6,'("Number of bands:",i16)') kp%mnband
    write(6,'("Number of k-points:",i13)') kp%nrk

    kp%nvband=minval(kp%ifmax(:,:)-kp%ifmin(:,:))+1
    kp%ncband=kp%mnband-maxval(kp%ifmax(:,:))

    if(ifile == 1) then
      SAFE_ALLOCATE(ok,(kp%mnband - 1))
      ok(1:kp%mnband - 1) = .true.
      minband = kp%mnband

      SAFE_ALLOCATE(ok_vband,(kp%nvband - 1))
      ok_vband(:) = .true.
      minvband = kp%nvband

      if(kp%ncband - 1 > 0) then
        ! avoid allocation <= 0
        SAFE_ALLOCATE(ok_cband,(kp%ncband - 1))
        ok_cband(:) = .true.
      endif
      mincband = kp%ncband
    else
      minband = min(minband, kp%mnband)
      minvband = min(minvband, kp%nvband)
      mincband = min(mincband, kp%ncband)
    endif

    do ib = 1, minband - 1
      ok(ib) = ok(ib) .and. &
        all(abs(kp%el(ib, 1:kp%nrk, 1:kp%nspin) - kp%el(ib + 1, 1:kp%nrk, 1:kp%nspin)) .gt. TOL_Degeneracy)
    enddo

    do ib = 1, minvband - 1
      do is = 1, kp%nspin
        do ik = 1, kp%nrk
          ok_vband(ib) = ok_vband(ib) .and. &
            (abs(kp%el(kp%ifmax(ik, is) - ib + 1, ik, is) &
            - kp%el(kp%ifmax(ik, is) - ib, ik, is)) .gt. TOL_Degeneracy)
        enddo
      enddo
    enddo

    do ib = 1, mincband - 1
      do is = 1, kp%nspin
        do ik = 1, kp%nrk
          ok_cband(ib) = ok_cband(ib) .and. &
            (abs(kp%el(kp%ifmax(ik, is) + ib, ik, is) &
            - kp%el(kp%ifmax(ik, is) + ib + 1, ik, is)) .gt. TOL_Degeneracy)
        enddo
      enddo
    enddo

    call dealloc_header_type(sheader, crys, kp)
    call close_file(7)
  enddo

  if(nargs > 1) write(6,'(a,i6)') 'Minimum number of bands in files: ', minband

  write(6,'(a)')
  write(6,'(a)') '== Degeneracy-allowed numbers of bands (for epsilon and sigma) =='

  do ib = 1, minband - 1
    if(ok(ib)) then
      write(6,*) ib
    endif
  enddo

  write(6,'(a,i6,a)') 'Note: cannot assess whether or not highest band ', minband, ' is degenerate.'

  write(6,'(a)')
  write(6,'(a)') '== Degeneracy-allowed numbers of valence bands (for inteqp, kernel, and absorption) =='

  do ib = 1, minvband - 1
    if(ok_vband(ib)) then
      write(6,*) ib
    endif
  enddo
  write(6,*) minvband ! using all bands is always allowed ... ?

  if(mincband - 1 > 0) then
    write(6,'(a)')
    write(6,'(a)') '== Degeneracy-allowed numbers of conduction bands (for inteqp, kernel, and absorption) =='
    
    do ib = 1, mincband - 1
      if(ok_cband(ib)) then
        write(6,*) ib
      endif
    enddo
    
    write(6,'(a,i6,a)') 'Note: cannot assess whether or not highest conduction band ', mincband, ' is degenerate.'
    SAFE_DEALLOCATE(ok_cband)
  endif

  SAFE_DEALLOCATE(ok)
  SAFE_DEALLOCATE(ok_vband)

end program degeneracy_check

!================================================================================
!
! Modules:
!
! (1) essl_m      Originally By DAS      Last Modified 2/2/2011 (das)
!
!     Interfaces for ESSL functions.
!     Every ESSL function used in the code should be listed here, and this
!     module should be used in every routine containing ESSL calls to ensure
!     the argument types are correct.
!
!     Note that routines can take extra arguments like "*100" which directs to
!     go to line 100 if error 100 occurs. This is an "alternate return specifier"
!     considered an obsolescent feature in Fortran 95 and Fortran 90.
!     It does not appear to be possible to declare in an interface in a way
!     that will not produce compilation warnings.
!
! http://publib.boulder.ibm.com/infocenter/clresctr/vxrx/index.jsp?topic=/com.ibm.cluster.essl43.guideref.doc/am501mst_xtoc.html
!
! In the idiotic tradition of IBM programming, ESSL now bombs
! if the matrix is singular regardless even when calling
! supposedly non-bombing routines like dgeicd... so instead
! we have to catch the error #2103 which means the matrix is singular.
! Beautiful, no!?!?
!
!================================================================================

#include "f_defs.h"

module essl_m

  public ! only interfaces in this module

#ifdef USEESSL
  interface
    subroutine einfo(icode, inf1, inf2)
      implicit none
      integer, intent(in) :: icode
      integer, optional, intent(out) :: inf1
      integer, optional, intent(out) :: inf2
    end subroutine einfo
  end interface

  interface
    subroutine errset(ierno, inoal, inomes, itrace, iusadr, irange)
      implicit none
      integer, intent(in) :: ierno
      integer, intent(in) :: inoal
      integer, intent(in) :: inomes
      integer, intent(in) :: itrace
      integer, intent(in) :: iusadr
      integer, intent(in) :: irange
    end subroutine errset
  end interface

  interface
    subroutine dgef(a, lda, n, ipvt, *)
      implicit none
      real*8, intent(inout) :: a !< (lda,n)
      integer, intent(in) :: lda
      integer, intent(in) :: n
      integer, intent(out) :: ipvt !< (n)
    end subroutine dgef
  end interface

  interface
    subroutine zgef(a, lda, n, ipvt)
      implicit none
      complex*16, intent(inout) :: a !< (lda,n)
      integer, intent(in) :: lda
      integer, intent(in) :: n
      integer, intent(out) :: ipvt !< (n)
    end subroutine zgef
  end interface

  interface
    subroutine dgesm(trans, a, lda, n, ipvt, bx, ldb, nrhs)
      implicit none
      character, intent(in) :: trans
      real*8, intent(in) :: a !< (lda, n)
      integer, intent(in) :: lda
      integer, intent(in) :: n
      integer, intent(in) :: ipvt !< (n)
      real*8, intent(inout) :: bx !< (lda, nrhs)
      integer, intent(in) :: ldb
      integer, intent(in) :: nrhs
    end subroutine dgesm
  end interface

  interface
    subroutine zgesm(trans, a, lda, n, ipvt, bx, ldb, nrhs)
      implicit none
      character, intent(in) :: trans
      complex*16, intent(in) :: a !< (lda, n)
      integer, intent(in) :: lda
      integer, intent(in) :: n
      integer, intent(in) :: ipvt !< (n)
      complex*16, intent(inout) :: bx !< (lda, nrhs)
      integer, intent(in) :: ldb
      integer, intent(in) :: nrhs
    end subroutine zgesm
  end interface

#endif

end module essl_m

!===============================================================================
!
! Routines:
!
! (1) input_outer()       Originally By gsm       Last Modified 10/5/2009 (gsm)
!
! Adapted from subroutine input. Reads in and distributes outer
! wavefunctions. Stores wavefunctions on disk in temporary INT_WFNK_* files
! (comm_disk) or in structures distributed in memory (comm_mpi).
!
!===============================================================================

#include "f_defs.h"

subroutine input_outer(crys,gvec,syms,kp,sig,wfnk,iunit_k,fnk,wfnkmpi)

  use global_m
  use eqpcor_m
  use input_utils_m
  use misc_m
  use scissors_m
  use wfn_rho_vxc_io_m
  use io_utils_m
  implicit none

  type (crystal), intent(in) :: crys
  type (symmetry), intent(in) :: syms
  type (gspace), intent(in) :: gvec
  type (kpoints), intent(in) :: kp
  type (siginfo), intent(inout) :: sig
  type (wfnkstates), intent(inout) :: wfnk !< do not lose the allocations from input
  integer, intent(in) :: iunit_k
  character*20, intent(in) :: fnk
  type (wfnkmpiinfo), intent(inout) :: wfnkmpi !< do not lose the allocations from input

  character :: fncor*32
  integer :: i,j,k,ikn,irk,nbnmin,nbnmax, &
    iouter,istore,nstore,nstore_sum,g1,g2,iknstore, &
    ntband_outer
  integer, allocatable :: isort(:)
  real(DP) :: qk(3)
  SCALAR, allocatable :: zc(:,:)
  logical :: dont_read

  character(len=3) :: sheader
  integer :: iflavor
  type(gspace) :: gvec_outer, gvec_kpt
  type(kpoints) :: kp_outer
  type(crystal) :: crys_outer
  type(symmetry) :: syms_outer
  logical, allocatable :: kpt_outer_required(:)
  type(progress_info) :: prog_info !< a user-friendly progress report

  PUSH_SUB(input_outer)

  call logit('Opening WFN_outer')

!-------------------------------------------
! Try to open WFN_outer file
! Return to caller if error is encountered

  if(peinf%inode.eq.0) call open_file(25,file='WFN_outer',form='unformatted',status='old',iostat=iouter)
#ifdef MPI
  call MPI_Bcast(iouter,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif

  sig%wfn_outer_present = (iouter == 0)
  if (iouter.ne.0) then
    POP_SUB(input_outer)
    return
  endif ! iouter

  sheader = 'WFN'
  iflavor = 0
  call read_binary_header_type(25, sheader, iflavor, kp_outer, gvec_outer, syms_outer, crys_outer, warn = .false.)
  call check_trunc_kpts(sig%icutv, kp_outer)

  call check_header('WFN_inner', kp, gvec, syms, crys, 'WFN_outer', kp_outer, gvec_outer, syms_outer, crys_outer, is_wfn = .true.)

  ! DAS: there is no fundamental reason for the condition below, but seems to be assumed in the code
  ! and it would require some rewriting to make that kp_outer need only contain the kpts in sig%kpt (the ones in the input file).
  if(kp_outer%nrk /= kp%nrk) call die('different number of k-points in WFN_outer')
  if(kp_outer%mnband < maxval(sig%diag)) call die('not enough bands in WFN_outer')

  ntband_outer = min(kp_outer%mnband, sig%ntband)

  kp_outer%el(:,:,:) = kp_outer%el(:,:,:) - sig%avgpot_outer / ryd

  SAFE_ALLOCATE(kp_outer%elda, (ntband_outer,kp_outer%nrk,kp_outer%nspin))
  kp_outer%elda(1:ntband_outer,1:kp_outer%nrk,1:kp_outer%nspin)=ryd*kp_outer%el(1:ntband_outer,1:kp_outer%nrk,1:kp_outer%nspin)
  call scissors_shift(kp_outer, sig%scis_outer, sig%spl_tck_outer)
  kp_outer%el(:,:,:)=ryd*kp_outer%el(:,:,:)

!---------------------------------------------------------------
! If quasi-particle corrections requested, read in qp energies
  if(sig%eqp_outer_corrections) then
    fncor='eqp_outer.dat'
    nbnmin=sig%ntband+1
    nbnmax=0
    do i=1,sig%ndiag
      if (sig%diag(i).lt.nbnmin) nbnmin=sig%diag(i)
      if (sig%diag(i).gt.nbnmax) nbnmax=sig%diag(i)
    enddo

    ! FHJ: Determine which k-points from WFN_outer/eqp_outer.dat we need.
    SAFE_ALLOCATE(kpt_outer_required, (kp_outer%nrk))
    kpt_outer_required(:) = .false.
    do ikn = 1, sig%nkn
      kpt_outer_required(sig%indkn(ikn)) = .true.
    enddo
    call eqpcor(fncor,peinf%inode,peinf%npes,kp_outer,nbnmin,nbnmax,0,0,&
      kp_outer%el,kp_outer%el,kp_outer%el,0,0,kpt_required=kpt_outer_required)
    SAFE_DEALLOCATE(kpt_outer_required)
  endif

!-------------------
! Read in g-vectors

  SAFE_ALLOCATE(gvec_outer%components, (3, gvec%ng))
  call read_binary_gvectors(25, gvec%ng, gvec%ng, gvec_outer%components)
  SAFE_DEALLOCATE_P(gvec_outer%components)
  
  SAFE_ALLOCATE(isort, (gvec%ng))

!----------------------------------------
! Open temporary wavefunction file iunit_k

  if (sig%iwriteint .eq. 0 .and. mod(peinf%inode,peinf%npes/peinf%npools).eq.0) then
    call open_file(iunit_k,file=fnk,form='unformatted',status='replace')
  endif

!---------------------
! Loop over k-points

  call progress_init(prog_info, 'reading wavefunctions (WFN_outer)', 'state', kp_outer%nrk*ntband_outer)
  do irk=1,kp_outer%nrk
    qk(:)=kp_outer%rk(:,irk)
         
!--------------------------------------------
! Read in and sort g-vectors for k-point irk

    SAFE_ALLOCATE(gvec_kpt%components, (3, kp_outer%ngk(irk)))
    call read_binary_gvectors(25, kp_outer%ngk(irk), kp_outer%ngk(irk), gvec_kpt%components)

    do i = 1, kp_outer%ngk(irk)
      call findvector(isort(i), gvec_kpt%components(:, i), gvec)
      if (isort(i) == 0) call die('outer wfn: could not find G-vector')
    enddo

    SAFE_DEALLOCATE_P(gvec_kpt%components)

!--------------------------------------------------------
! Determine if Sigma must be computed for this k-point.
! If so, store the bands and wavefunctions on file iunit_k.
! If there is only one k-point, store directly in wfnk.

    istore=0
    do ikn=1,sig%nkn
      if(sig%indkn(ikn).eq.irk) then
        istore=1
        iknstore=ikn
        wfnk%nkpt=kp_outer%ngk(irk)
        wfnk%ndv=peinf%ndiag_max*kp_outer%ngk(irk)
        wfnk%k(:)=qk(:)
        wfnk%isrtk(:)=isort(:)
        do k=1,sig%nspin
          wfnk%ek(1:ntband_outer,k)= &
            kp_outer%el(1:ntband_outer,irk,sig%spin_index(k))
          wfnk%elda(1:ntband_outer,k)= &
            kp_outer%elda(1:ntband_outer,irk,sig%spin_index(k))
        enddo
        SAFE_ALLOCATE(wfnk%zk, (wfnk%ndv,sig%nspin))
        wfnk%zk=ZERO
      endif
    enddo ! ikn

!---------------------------------------------------------------
! Read the wavefunctions, check the norm, and store in wfnk%zk

    SAFE_ALLOCATE(zc, (kp_outer%ngk(irk),kp_outer%nspin*kp_outer%nspinor))
    do i=1,kp_outer%mnband

! Check whether i-th band is needed for diagonal Sigma matrix elements.
! We don`t need to check for off-diagonal Sigma matrix elements separately
! because whenever off-diagonals are requested the corresponding diagonals
! are also included in the calculation as enforced in Sigma/inread.f90.

      if (i.le.ntband_outer) then
        call progress_step(prog_info, ntband_outer*(irk-1) + i)
        nstore=0
        do j=1,peinf%ndiag_max
          if (.not.peinf%flag_diag(j)) cycle
          if (sig%band_index(i).eq. &
            sig%diag(peinf%index_diag(j))) nstore=j
        enddo
#ifdef MPI
        call MPI_Allreduce(nstore,nstore_sum,1, &
          MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,mpierr)
#else
        nstore_sum=nstore
#endif
      else
        nstore_sum=0
      endif

      dont_read = (istore == 0 .OR. nstore_sum == 0)
      call read_binary_data(25, kp_outer%ngk(irk), kp_outer%ngk(irk), kp_outer%nspin*kp_outer%nspinor, zc, dont_read = dont_read)

      if(.NOT. dont_read) then
        if(peinf%inode.eq.0) then
          do k=1,sig%nspin
            call checknorm('WFN_outer',i,irk,kp_outer%ngk(irk),k,kp_outer%nspinor,zc(:,:))
          enddo
        endif

        if((istore.eq.1).and.(nstore.ne.0)) then
          do k=1,sig%nspin*kp_outer%nspinor
            do j=1,kp_outer%ngk(irk)
              wfnk%zk((nstore-1)*kp_outer%ngk(irk)+j,k) = zc(j,sig%spin_index(k))
            enddo
          enddo
        endif
      else
        ! FHJ: the following lines were introduced in r6294 and are supposed to
        ! be a shortcut if we are past the last band of the last k-point. However,
        ! in light of a previous bug (#223), this feature is commented out for now.
        !! FHJ: shortcut if this is past the last band of the last k-point
        !if (irk==kp_outer%nrk) exit
      endif ! .NOT. dont_read
    enddo ! i (loop over bands)
    SAFE_DEALLOCATE(zc)

!---------------------------------------------------------
! Write the wavefunctions stored in wfnk%zk to file iunit_k
    
    if((istore.eq.1).and.(sig%nkn.gt.1)) then
      if (sig%iwriteint .eq. 0) then
        if (mod(peinf%inode,peinf%npes/peinf%npools).eq.0) then
          write(iunit_k) kp_outer%ngk(irk),wfnk%ndv,ntband_outer, &
            (wfnk%isrtk(j),j=1,gvec%ng),(qk(i),i=1,3), &
            ((wfnk%ek(j,k),j=1,ntband_outer),k=1,sig%nspin), &
            ((wfnk%elda(j,k),j=1,ntband_outer),k=1,sig%nspin), &
            ((wfnk%zk(j,k),j=1,wfnk%ndv),k=1,sig%nspin*kp_outer%nspinor)
        endif
      else
        ikn=iknstore
        wfnkmpi%nkptotal(ikn)=kp_outer%ngk(irk)
        wfnkmpi%isort(1:kp_outer%ngk(irk),ikn)=wfnk%isrtk(1:kp_outer%ngk(irk))
        wfnkmpi%qk(1:3,ikn)=qk(1:3)
        wfnkmpi%el(1:ntband_outer,1:sig%nspin,ikn)=wfnk%ek(1:ntband_outer,1:sig%nspin)
        wfnkmpi%elda(1:ntband_outer,1:sig%nspin,ikn)=wfnk%elda(1:ntband_outer,1:sig%nspin)
        do k=1,sig%nspin
#ifdef MPI
          i=mod(peinf%inode,peinf%npes/peinf%npools)
          if (mod(wfnk%ndv,peinf%npes/peinf%npools).eq.0) then
            j=wfnk%ndv/(peinf%npes/peinf%npools)
          else
            j=wfnk%ndv/(peinf%npes/peinf%npools)+1
          endif
          g1=1+i*j
          g2=min(j+i*j,wfnk%ndv)
          if (g2.ge.g1) then
            wfnkmpi%cg(1:g2-g1+1,k,ikn)=wfnk%zk(g1:g2,k)
          endif ! g2.ge.g1
#else
          wfnkmpi%cg(1:wfnk%ndv,k,ikn)=wfnk%zk(1:wfnk%ndv,k)
#endif
        enddo
      endif
      SAFE_DEALLOCATE_P(wfnk%zk)
    endif
    
  enddo ! irk (loop over k-points)
  call progress_free(prog_info)

!--------------
! Close files

  if (mod(peinf%inode,peinf%npes/peinf%npools).eq.0 .and. sig%iwriteint .eq. 0) then
    call close_file(iunit_k)
  endif
  if(peinf%inode.eq.0) then
    call close_file(25) ! WFN_outer
    write(6,111) 
111 format(/,1x,'Read WFN_outer successfully.',/)
    write(7,111)
  endif
  
  SAFE_DEALLOCATE(isort)
  SAFE_DEALLOCATE_P(kp_outer%w)
  SAFE_DEALLOCATE_P(kp_outer%el)
  SAFE_DEALLOCATE_P(kp_outer%elda)

#ifdef MPI
  if(sig%iwriteint == 0) call MPI_Barrier(MPI_COMM_WORLD, mpierr)
#endif

  POP_SUB(input_outer)

  return

end subroutine input_outer

!============================================================================
!
! Routines:
!
! (1) checkgriduniformity()  Originally by JRD  Last Modified: 3/16/2011 (das)
!
!   To obtain the correct result for integrals in reciprocal space, the k+G
!   sampling should be similar in each direction. This routine determines the
!   sampling and writes a warning if it is too non-uniform.
!
!   gsm: xgrid = sig%qgrid in Sigma/main.f90, kp%kgrid in BSE/intkernel.f90
!
!   Truncation:
!   icutv = 0, none        : 0D truncation, compare x, y, and z
!   icutv = 2, spherical   : 3D truncation, no relevant directions
!   icutv = 4, cell_wire   : 2D truncation, z is uniform by itself automatically
!   icutv = 5, cell_box    : 3D truncation, no relevant directions
!   icutv = 6, cell_slab   : 1D truncation, compare x and y
!
!============================================================================

#include "f_defs.h"

module checkgriduniformity_m

  use global_m
  implicit none

  private

  public :: checkgriduniformity

contains

subroutine checkgriduniformity(xgrid, crys, icutv)
  integer, intent(in) :: xgrid(3)
  type(crystal), intent(in) :: crys
  integer, intent(in) :: icutv !< code for type of truncation

  real(DP), parameter :: TOL_Ratio = 2.0d0

  integer :: maxdir
  integer :: ii, jj, order(3)
  real(DP) :: bb(3, 3), blen(3)
  real(DP) :: cc(3, 3), clen(3)
  character(len=80) :: tmpstr
  character(len=12) :: fmt

  PUSH_SUB(checkgriduniformity)

  if(icutv == 0) then    
    maxdir = 3
  else if(icutv == 6) then
    maxdir = 2
  else
    write(6,'(a)') "No k+G sampling uniformity to check, given selected truncation scheme."
    POP_SUB(checkgriduniformity)
    return
  endif

  ! compute minicell lattice vectors
  do jj = 1, 3
    bb(:, jj) = crys%bvec(:, jj) / dble(xgrid(jj))
    blen(jj) = sqrt(sum(bb(1:3, jj)**2))
  enddo

  ! determine which vector is shortest, middle, and longest
  order(1)      = minloc(blen(1:maxdir), 1)
  order(maxdir) = maxloc(blen(1:maxdir), 1)
  if(order(maxdir) == order(1)) then
    ! all vectors must be of the same length
    ! just make an arbitrary choice, the order(:) elements must all be different
    order(1) = 1
    order(maxdir) = maxdir
  endif
  if(maxdir > 2) then
    do ii = 1, 3
      if(ii /= order(1) .and. ii /= order(3)) order(2) = ii
    enddo
  endif

  ! Gram-Schmidt orthogonalization
  ! go from shortest to longest, since orthogonalization always shortens
  cc(1:3, 1) = bb(1:3, order(1))
  if(maxdir > 2) then
    cc(1:3, 2) = bb(1:3, order(2)) - cc(1:3, 1) * sum(cc(1:3, 1) * bb(1:3, order(2))) / sum(cc(1:3, 1)**2)
  endif
  cc(1:3, maxdir) = bb(1:3, order(maxdir)) - &
    cc(1:3, maxdir - 1) * sum(cc(1:3, maxdir - 1) * bb(1:3, order(maxdir))) / sum(cc(1:3, maxdir - 1)**2)

  do jj = 1, maxdir
    clen(jj) = sqrt(sum(cc(1:3, jj)**2))
  enddo

  write(fmt,'(a,i1,a)') "(a,", maxdir, "f10.6,a)"
  write(tmpstr, fmt) "k+G sampling: ", clen(1:maxdir), " (reciprocal lattice units)"

  if (maxval(clen(1:maxdir)) / minval(clen(1:maxdir)) .gt. TOL_Ratio) then
    write(0,'(a)') TRUNC(tmpstr)
    write(0,'(a)') "WARNING: detected non-uniform k+G sampling, may cause strange results."
    write(0,'(a)') "You should verify your answer with different cell-averaging cutoffs."
  else
    write(6,'(1x,a)') TRUNC(tmpstr)
  endif

  ! Note: for a cell with a small angle between two equivalent lattice vectors, it will
  ! be impossible to satisfy this criterion without using a different k-grid in those
  ! two equivalent directions, breaking crystal symmetry and possibly causing other problems.
  ! It is unclear what should be done in such a case. --DAS

  POP_SUB(checkgriduniformity)

  return

end subroutine checkgriduniformity

end module checkgriduniformity_m

!===========================================================================
!
! Routines:
!
! (1) epsdiag   Originally By MLT               Last Modified 5/6/2008 (JRD)
!
!     input: crys, gvec, syms, xct types
!            read_epsdiag     determine which file to be read
!
!     output: epsi type, contains the head of the dielectric matrix
!               epsi%nq = number of q-vectors stored
!               epsi%eps  = dielec. matrix at a given q-vector
!               epsi%q    = coordinates of a q-vector
!               epsi%emax = maximum length of the stored q-vectors
!
!     Subroutine reads dielectric matrices from unit 10 ('eps0mat')
!     and unit 11 ('epsmat') in formatted form and stores the
!     head part only in epsi%eps.
!
!     The stored q-vectors span a sphere of radius given by epsi%emax
!     (that, in general, contains at least the first BZ).
!
!     no symmetrization around q=0 is performed
!
!     If read_epsdiag, read epsi%eps from unit 12 ("epsdiag.dat") instead
!
!     Non-parallelized subroutine
!
!===========================================================================

#include "f_defs.h"

module epsdiag_m

  use global_m
  use checkbz_m
  use fullbz_m
  use gmap_m
  use input_utils_m
  use misc_m
  use sort_m
  use epsread_hdf5_m
  implicit none

  private
  public :: read_epsdiag, write_epsdiag, calc_emax, epsdiag

contains

  !---------------------------------------------------------------------------------------------------
  !> Read data from "epsdiag.dat"
  subroutine read_epsdiag(epsi)
    type(epsinfo), intent(out) :: epsi

    integer :: iq

    PUSH_SUB(read_epsdiag)

    write(6,'(1x,a)') 'Reading epsdiag.dat'

    call open_file(12,file='epsdiag.dat',form='formatted',status='old')
    read(12,*) epsi%nq, epsi%emax, epsi%q0vec(:), epsi%epshead
    SAFE_ALLOCATE(epsi%eps, (epsi%nq))
    SAFE_ALLOCATE(epsi%q, (3,epsi%nq))
    do iq = 1, epsi%nq
      read(12,*) epsi%eps(iq), epsi%q(1:3, iq)
    enddo
    call close_file(12)

    write(6,'(1x,a,f12.6)') 'Dielectric constant: ', 1.d0/epsi%eps(1)
    write(6,'(1x,a,f12.6)') 'emax = ', epsi%emax
    write(6,*)

    POP_SUB(read_epsdiag)
    return
  end subroutine read_epsdiag


  !---------------------------------------------------------------------------------------------------
  !> Write data to "epsdiag.dat"
  subroutine write_epsdiag(epsi)
    type(epsinfo), intent(in) :: epsi

    integer :: iq

    PUSH_SUB(write_epsdiag)

    call open_file(12,file='epsdiag.dat',form='formatted',status='replace')
    write(12,*) epsi%nq, epsi%emax, epsi%q0vec(:), epsi%epshead
    do iq = 1, epsi%nq
      write(12,*) epsi%eps(iq), epsi%q(1:3, iq)
    enddo
    call close_file(12)

    PUSH_SUB(write_epsdiag)
    return
  end subroutine write_epsdiag


  !---------------------------------------------------------------------------------------------------
  !>  emax is some large energy, not smaller than the length squared of any unit lattice vector.
  real(DP) function calc_emax(bdot)
    real(DP), intent(in) :: bdot(:,:)

    integer :: ii

    PUSH_SUB(calc_emax)

    calc_emax = 0.d0
    do ii = 1, 3
      if (calc_emax < bdot(ii,ii)) calc_emax = bdot(ii,ii)
    enddo
    calc_emax = 1.5d0 * calc_emax

    POP_SUB(calc_emax)
  end function calc_emax


  !---------------------------------------------------------------------------------------------------
  !> Determine if a G vector is in a periodic or aperiodic direction.
  logical function keep_gvec(gvec, xct, ig)
    type(gspace), intent(in) :: gvec
    type(xctinfo), intent(in) :: xct
    integer, intent(in) :: ig

    ! no push/pop, called too often

    keep_gvec = all(gvec%components(1:3,ig)==0 .or. xct%is_periodic(1:3))
  end function keep_gvec


!---------------------------------------------------------------------------------------------------
subroutine epsdiag(crys,gvec,syms,epsi,xct)
  type (crystal), intent(in) :: crys
  type (gspace), intent(in) :: gvec
  type (symmetry), intent(in) :: syms
  type (epsinfo), intent(out) :: epsi
  type (xctinfo), intent(in) :: xct

  type (grid) :: qg
  integer :: igamma,nrq0,nrq1,nmtx,ng,ngmax
  integer, allocatable :: isrtq(:),isrtqi(:)
  real(DP) :: q0t(3,1),qk(3)
  real(DP), allocatable :: q1(:,:),eknq(:),eknqa(:,:)
  SCALAR, allocatable :: eps(:)

  character :: ajname*6,adate*10
  character :: tmpfn*16

  character :: filenameh5*80
  character :: filenameh50*80

  integer :: ii,jj,nold,itot,isize
  integer :: ifq,ifqt,ig,irq,nqtmax,qgrid(3),idummy,idummy2
  real(DP) :: gmax_in,qlength,eaux,epsimax,qshift(3)

  integer, allocatable :: ind(:), ifqta(:), inda(:,:), isrtqia(:,:)
  integer, allocatable :: oldx(:),oldy(:),oldz(:),old(:,:),isrtinvdummy(:),isrtold(:)
  real(DP), allocatable :: ekold(:),qt(:,:),epsdiagt(:,:,:)
  SCALAR, allocatable :: ph(:),epst(:)
  logical :: skip_checkbz

  logical :: file_exists

  integer, allocatable :: nmtx_of_q(:),nmtx0_of_q(:)

  PUSH_SUB(epsdiag)

  qgrid(:)=0

  SAFE_ALLOCATE(ind, (gvec%ng))
  SAFE_ALLOCATE(ph, (gvec%ng))
  SAFE_ALLOCATE(isrtq, (gvec%ng))
  SAFE_ALLOCATE(isrtqi, (gvec%ng))
  SAFE_ALLOCATE(eknq, (gvec%ng))

  ! Read information for inverse dielectric matrix for q->0 unit10

#ifdef HDF5
  if(xct%use_hdf5) then

  filenameh5 = 'epsmat.h5'
  filenameh50 = 'eps0mat.h5'

  call read_eps_grid_sizes_hdf5(nold,nrq0,gmax_in,idummy,idummy2,qgrid,filenameh50)
  ng=nold

  SAFE_ALLOCATE(nmtx0_of_q,(nrq0))
  call read_eps_qgrid_hdf5(nrq0,q0t,nmtx0_of_q,filenameh50)
  epsi%q0vec(:)=q0t(:,1)

  INQUIRE(FILE="epsmat.h5", EXIST=file_exists)
  if ( file_exists ) then
    igamma = 0
  else
    igamma = 1
  endif

  if(igamma.eq.0) then
    call read_eps_grid_sizes_hdf5(nold,nrq1,gmax_in,idummy,idummy2,qgrid,filenameh5)
    SAFE_ALLOCATE(nmtx_of_q,(nrq1))
    SAFE_ALLOCATE(q1, (3,nrq1))
    call read_eps_qgrid_hdf5(nrq1,q1,nmtx_of_q,filenameh5)
  else
    nrq1=0
  endif

  else
#endif

  call open_file(unit=10,file='eps0mat',form='unformatted',status='old')
  call open_file(unit=11,file='epsmat',form='unformatted',status='old',iostat=igamma)

  read(10)
  read(10) ii
  if (ii.ne.0) call die('eps0mat is full-frequency')
  read(10) (qgrid(ii),ii=1,3)
  read(10)
  read(10)
  read(10)
  read(10)
  read(10) nrq0,(epsi%q0vec(ii),ii=1,3)
  read(10) nold
  read(10) ng
  call close_file(10)
  call open_file(unit=10,file='eps0mat',form='unformatted',status='old')

  if(igamma.eq.0) then
    read(11)
    read(11) ii
    if (ii.ne.0) call die('epsmat is full-frequency')
    read(11) (qgrid(ii),ii=1,3)
    read(11)
    read(11)
    read(11)
    read(11)
    read(11) nrq1
    call close_file(11)
    call open_file(unit=11,file='epsmat',form='unformatted',status='old')
    SAFE_ALLOCATE(q1, (3,nrq1))
    read(11)
    read(11)
    read(11)
    read(11)
    read(11)
    read(11)
    read(11)
    read(11) nrq1,((q1(ii,jj),ii=1,3),jj=1,nrq1)
    call close_file(11)
    call open_file(unit=11,file='epsmat',form='unformatted',status='old')
  else
    nrq1=0
  endif

#ifdef HDF5
  endif
#endif

  ! Store the coordinates of q-vectors in the IBZ

  qg%nr=1+nrq1
  SAFE_ALLOCATE(qg%r, (3,qg%nr))

  ! JRD: Remove q0 vec for purpose of generating full zone
  ! we don`t want all the vectors q0 would generate.
  ! qg%r(1:3,1)=q0(1:3)

  qg%r(1:3,1)=0d0
  if(nrq1.ne.0) then
    qg%r(1:3,2:qg%nr)=q1(1:3,1:nrq1)
    SAFE_DEALLOCATE(q1)
  endif

  !-------------------
  ! Generate full brillouin zone from irreducible wedge
  ! rq -> fq

  call fullbz(crys,syms,qg,syms%ntran,skip_checkbz,wigner_seitz=.true.,paranoid=.true.)
  qshift(:)=0.0d0
  if (igamma.ne.0) then
    tmpfn='eps0mat'
  else
    tmpfn='epsmat'
  endif
  if (.not. skip_checkbz) then
    call checkbz(qg%nf,qg%f,qgrid,qshift,crys%bdot, &
      tmpfn,'q',.true.,xct%freplacebz,xct%fwritebz)
  endif

  ! JRD: Leave q0 vector as exactly 0 or else interpolation will ignore it.
  !      qg%f(1:3,1)=q0(1:3)

  !----------- Read q->0 dielectric matrix -------------------------------


  SAFE_ALLOCATE(oldx, (nold))
  SAFE_ALLOCATE(oldy, (nold))
  SAFE_ALLOCATE(oldz, (nold))
  SAFE_ALLOCATE(isrtold, (ng))
  SAFE_ALLOCATE(ekold, (ng))

#ifdef HDF5
  if(xct%use_hdf5) then

  ajname='chiGG0'
  adate = 'nodate'

  SAFE_ALLOCATE(old,(3,ng))
  call read_eps_old_gvecs_hdf5(nold,old,filenameh50)
  oldx(:)=old(1,:)
  oldy(:)=old(2,:)
  oldz(:)=old(3,:)
  SAFE_DEALLOCATE(old)

  else
#endif

  read(10) ajname,adate
  read(10)
  read(10)
  read(10)
  read(10)
  read(10)
  read(10) gmax_in
  read(10) nrq0,(epsi%q0vec(ii),ii=1,3)
  read(10) nold,(oldx(ii),oldy(ii),oldz(ii),ii=1,nold)

#ifdef HDF5
  endif
#endif

  write(6,'(/,1x,a)') 'Epsilon matrix for q->0 read from eps0mat'
  write(6,'(1x,a,i0,2x,a,f12.6)') 'nrq0 = ', nrq0, 'gmax = ', gmax_in
#ifdef VERBOSE
  write(6,*)
  write(6,'(1x,3f10.6)') epsi%q0vec(1:3)
  write(6,*)
#endif

#ifdef HDF5
  if(xct%use_hdf5) then

  SAFE_ALLOCATE(isrtinvdummy, (ng))
  call read_eps_gvecsofq_hdf5(ng,isrtold,isrtinvdummy,ekold,1,filenameh50)
  SAFE_DEALLOCATE(isrtinvdummy)
  nmtx = nmtx0_of_q(1)
  qk = epsi%q0vec

  else
#endif

  read(10) ng,nmtx,(isrtold(ii),jj,ii=1,ng)
  read(10) (ekold(ii),ii=1,ng)
  read(10) (qk(ii),ii=1,3)

#ifdef HDF5
  endif
#endif

  ! Build the sorting/inverse sorting arrays

  isrtq= 0
  isrtqi= 0

  epsi%emax = calc_emax(crys%bdot)

  eaux= 3.d0*epsi%emax
  !      eaux= gmax_in

  call get_ngmax(is_q0=.true.)

  ! Does nqtmax really have to be so big?

  nqtmax = 4*ngmax*qg%nf
  SAFE_DEALLOCATE(isrtold)
  SAFE_DEALLOCATE(ekold)
  SAFE_DEALLOCATE(oldx)
  SAFE_DEALLOCATE(oldy)
  SAFE_DEALLOCATE(oldz)

  !     Initializes arrays epst,qt

  SAFE_ALLOCATE(epst, (nqtmax))
  SAFE_ALLOCATE(qt, (3,nqtmax))

  epst=0.d0
  epsi%nq=0
  qt=0.d0

  ifqt = -1
  do ifq=1,qg%nf
    if (qg%indr(ifq).eq.1) then
      if (ifqt .ne. -1) call die('ifqt multiply defined?')
      ifqt = ifq
    endif
  enddo

  call kinetic_energies(gvec, crys%bdot, eknq, qvec = qg%f(:, ifqt))

  ind=0
  ph=ZERO
  call gmap(gvec,syms,ngmax,qg%itran(ifqt), &
    qg%kg0(:,ifqt),isrtq,isrtqi,ind,ph,.true.)

#ifdef HDF5
  if(xct%use_hdf5) then
  isize=SCALARSIZE

  SAFE_ALLOCATE(epsdiagt,(isize,nmtx,1))
  call read_eps_matrix_diagonal_hdf5(nmtx, isize, 1, epsdiagt, filenameh50)
  epsi%epshead = SCALARIFY2(epsdiagt(1,1,1),epsdiagt(2,1,1))

  do jj=1,nmtx
    do ig=1,ngmax
      if (eknq(ig)<epsi%emax .and. isrtqi(ig)/=0) then
        if (keep_gvec(gvec, xct, ig) .and. ind(isrtqi(ig))==jj) then
          epsi%nq = epsi%nq + 1
          if (epsi%nq.gt.nqtmax) then
            write(0,999) epsi%nq,nqtmax,epsi%emax,eaux
            call die('nqtmax too small! No space to store epsdiag.')
          endif
          epst(epsi%nq) = SCALARIFY2(epsdiagt(1,jj,1),epsdiagt(2,jj,1))
          qt(:,epsi%nq) = gvec%components(:,ig) + qg%f(:,ifqt)
        endif
      endif
    enddo
  enddo

  SAFE_DEALLOCATE(epsdiagt)

  else
#endif

  SAFE_ALLOCATE(eps, (nmtx))

  do jj=1,nmtx

    read(10) (eps(ii),ii=1,nmtx)
    if (jj .eq. 1) epsi%epshead = eps(1)

    ! If (G+q0) has length greater than emax, store the corresponding
    ! (G+q0),epsinv(G+q0,G+q0) in qt,epst
    !
    ! At the end of the loop, epst will have epsi%nq stored matrix elements
    ! gmap is used to find out the right g-vector ind

    ! JRD: Time HAZARD we have a loop over ig inside loop over jj, probably bad!

    ! DAS: why do we need to do this loop rather than just keep the head, G=G`=0?
    ! JRD: well we need eps_q(0,0), but to interpolate near the edge of the zone we might need eps_q=0(1,1)
    ! because that is equivalent to eps_q=1(0,0) etc...   eps_q(G,G`) = eps(q+G,q+G`)
    ! FHJ: but we only have to do this in the periodic directions!
    !      We don`t need the extra G`s from the vacuum direction.

    do ig=1,ngmax
      if (eknq(ig)<epsi%emax .and. isrtqi(ig)/=0) then
        if (keep_gvec(gvec, xct, ig) .and. ind(isrtqi(ig))==jj) then
          epsi%nq = epsi%nq + 1
          if (epsi%nq.gt.nqtmax) then
            write(0,999) epsi%nq,nqtmax,epsi%emax,eaux
            call die('nqtmax too small! No space to store epsdiag.')
          endif
          epst(epsi%nq) = eps(jj)
          qt(:,epsi%nq) = gvec%components(:,ig) + qg%f(:,ifqt)
        endif
      endif
    enddo

  enddo

  SAFE_DEALLOCATE(eps)

  call close_file(10)

#ifdef HDF5
  endif
#endif

999 format('nqt =',i8,1x,'nqtmax =',i8,1x,'emax =',f8.3,1x,'eaux =',f8.3)

  if (nrq0.gt.1) call die('There is more than one q-point in eps0mat.')

  !---------- Read data for dielectric matrices from unit11 for q<>0 ------------------------


  if(igamma.ne.0) then
    nrq1=0
  else

    if(xct%use_hdf5) then

    ! We do this above. 
    ngmax = nold

    else

    read(11)
    read(11)
    read(11)
    read(11)
    read(11)
    read(11)
    read(11)
    read(11) nrq1
    read(11) nold
    ngmax= 0
    do ii=1,nrq1
      read(11) ng,nmtx
      read(11)
      read(11)
      do jj = 1,nmtx
        read(11)
      end do
      if (ng.gt.ngmax) ngmax= ng
    enddo
    call close_file(11)

    endif

    SAFE_ALLOCATE(oldx, (nold))
    SAFE_ALLOCATE(oldy, (nold))
    SAFE_ALLOCATE(oldz, (nold))
    SAFE_ALLOCATE(isrtold, (ngmax))
    SAFE_ALLOCATE(ekold, (ngmax))

#ifdef HDF5
    if(xct%use_hdf5) then

    ajname='chiGG0'
    adate = 'nodate'

    SAFE_ALLOCATE(old,(3,nold))
    call read_eps_old_gvecs_hdf5(nold,old,filenameh5)
    oldx(:)=old(1,:)
    oldy(:)=old(2,:)
    oldz(:)=old(3,:)
    SAFE_DEALLOCATE(old)

    else
#endif

    call open_file(unit=11,file='epsmat',form='unformatted',status='old')

    read(11) ajname,adate
    read(11)
    read(11)
    read(11)
    read(11)
    read(11)
    read(11) gmax_in
    read(11) nrq1
    read(11) nold,(oldx(ii),oldy(ii),oldz(ii),ii=1,nold)

#ifdef HDF5
    endif
#endif

    write(6,'(/,1x,a)') 'Epsilon matrix for q/=0 read from epsmat'
    write(6,'(1x,a,i0,2x,a,f12.6)') 'nrq = ', nrq1, 'gmax = ', gmax_in
    write(6,'(1x,a,i0,2x,a,f10.6)') 'nfq = ', qg%nf, 'qsz = ', qg%sz
    write(6,'(1x,a,i0)') 'ngmax = ', ngmax
#ifdef VERBOSE
    write(6,*)
    write(6,'(1x,3f10.6)') qg%r(1:3,2:nrq1+1)
    write(6,*)
#endif

    !--------------------------
    ! Read inverse dielectric matrices from unit11 for q<>0

    do irq=2,nrq1+1
      isrtold=0
      ekold=0.d0

#ifdef HDF5
      if(xct%use_hdf5) then

      SAFE_ALLOCATE(isrtinvdummy, (nold))
      call read_eps_gvecsofq_hdf5(nold,isrtold,isrtinvdummy,ekold,irq-1,filenameh5)
      SAFE_DEALLOCATE(isrtinvdummy)
      nmtx = nmtx_of_q(irq-1)
      qk = qg%r(:,irq)

      else
#endif

      read(11) ng,nmtx,(isrtold(ii),jj,ii=1,ng)
      read(11) (ekold(ii),ii=1,ng)
      read(11) (qk(ii),ii=1,3)

#ifdef HDF5
      endif
#endif

      isrtqi=0
      isrtq=0

      call get_ngmax(is_q0=.false.)

      itot=0
      do ifq=2,qg%nf
        if (irq.eq.qg%indr(ifq)) then
          itot=itot+1
        endif
      enddo

      SAFE_ALLOCATE(ifqta, (itot))
      SAFE_ALLOCATE(eknqa, (gvec%ng,itot))
      SAFE_ALLOCATE(isrtqia, (gvec%ng,itot))
      SAFE_ALLOCATE(inda, (gvec%ng,itot))

      eknqa= 0.d0
      itot = 0
      inda=0

      do ifq=2,qg%nf
        if (irq.eq.qg%indr(ifq)) then
          itot=itot+1
          ifqta(itot)=ifq

          call kinetic_energies(gvec, crys%bdot, eknqa(:, itot), qvec = qg%f(:, ifq))

          ph=ZERO
          ind = 0
          call gmap(gvec,syms,ngmax,qg%itran(ifq), &
            qg%kg0(:,ifq),isrtq,isrtqi,ind,ph,.true.)

          inda(:,itot)=ind
          isrtqia(:,itot)=isrtqi
        endif
      enddo

#ifdef HDF5
      if(xct%use_hdf5) then

      isize=SCALARSIZE

      SAFE_ALLOCATE(epsdiagt,(isize,nmtx,1))
      call read_eps_matrix_diagonal_hdf5(nmtx, isize, irq-1, epsdiagt, filenameh5)

      do jj = 1,nmtx
        do ii = 1, itot
          do ig=1,ngmax
            if (eknqa(ig,ii)<epsi%emax .and. isrtqia(ig,ii)/=0) then
              if (keep_gvec(gvec, xct, ig) .and. inda(isrtqia(ig,ii),ii)==jj) then
                epsi%nq = epsi%nq + 1
                if (epsi%nq.gt.nqtmax) then
                  write(0,*) epsi%nq,nqtmax,epsi%emax,eaux
                  call die('nqtmax too small! Not enough space to store epsdiag.')
                endif
                epst(epsi%nq) = SCALARIFY2(epsdiagt(1,jj,1),epsdiagt(2,jj,1))
                qt(:,epsi%nq) = gvec%components(:,ig) + qg%f(:,ifqta(ii))
              endif
            endif
          enddo
        enddo
      enddo

      SAFE_DEALLOCATE(epsdiagt)

      else
#endif

      SAFE_ALLOCATE(eps, (nmtx))

      do jj = 1,nmtx

        read (11) (eps(ii),ii=1,nmtx)

        ! If (G+q0) has length greater than emax, store the corresponding
        ! (G+q0),epsinv(G+q0,G+q0) in qt,epst
        !
        ! At the end of the loop, epst will have epsi%nq stored matrix elements
        ! gmap is used to find out the right g-vector

        ! JRD: Possible Time HAZARD

        do ii = 1 , itot
          do ig=1,ngmax
            if (eknqa(ig,ii)<epsi%emax .and. isrtqia(ig,ii)/=0) then
              if (keep_gvec(gvec, xct, ig) .and. inda(isrtqia(ig,ii),ii)==jj) then
                epsi%nq = epsi%nq + 1
                if (epsi%nq.gt.nqtmax) then
                  write(0,*) epsi%nq,nqtmax,epsi%emax,eaux
                  call die('nqtmax too small! Not enough space to store epsdiag.')
                endif
                epst(epsi%nq)= eps(jj)
                qt(:,epsi%nq) = gvec%components(:,ig) + qg%f(:,ifqta(ii))
              endif
            endif
          enddo
        enddo
      enddo

      SAFE_DEALLOCATE(eps)

#ifdef HDF5
      endif
#endif

      SAFE_DEALLOCATE(ifqta)
      SAFE_DEALLOCATE(eknqa)
      SAFE_DEALLOCATE(isrtqia)
      SAFE_DEALLOCATE(inda)

    enddo

    if(.not. xct%use_hdf5) call close_file(11)

    SAFE_DEALLOCATE(isrtold)
    SAFE_DEALLOCATE(ekold)
    SAFE_DEALLOCATE(oldx)
    SAFE_DEALLOCATE(oldy)
    SAFE_DEALLOCATE(oldz)

  endif

  call dealloc_grid(qg)

  SAFE_DEALLOCATE(isrtq)
  SAFE_DEALLOCATE(isrtqi)
  SAFE_DEALLOCATE(eknq)
  SAFE_DEALLOCATE(ind)
  SAFE_DEALLOCATE(ph)

  if(xct%use_hdf5) then
  SAFE_DEALLOCATE(nmtx0_of_q)
  if (igamma .eq. 0) then
    SAFE_DEALLOCATE(nmtx_of_q)
  endif
  endif

  !------------------------
  ! Transfer data from epst to epsi%eps. epsi%eps stores the real
  ! part of epst (its imaginary part should be zero!).
  ! Sorting according to length of epsi%q

#ifdef CPLX
  epsimax=0.d0
  do ii=1,epsi%nq
    if (epsimax.lt.IMAG(epst(ii))) epsimax = IMAG(epst(ii))
  enddo
  write(6,*) 'Maximum value of imaginary part of epsinv : ', epsimax
#endif
  SAFE_ALLOCATE(epsi%eps, (epsi%nq))
  SAFE_ALLOCATE(epsi%q, (3,epsi%nq))
  SAFE_ALLOCATE(eknq, (epsi%nq))
  SAFE_ALLOCATE(isrtq, (epsi%nq))
  isrtq=0
  do ii = 1, epsi%nq
    eknq(ii) = DOT_PRODUCT(qt(1:3, ii), MATMUL(crys%bdot(1:3, 1:3), qt(1:3, ii)))
  enddo
  call sortrx(epsi%nq, eknq, isrtq)

  ! Store data in epsi and write it out
  do ii=1,epsi%nq
    epsi%eps(ii) = dble( epst(isrtq(ii)) )
    epsi%q(:,ii) = qt(:,isrtq(ii))
    qlength = sqrt(DOT_PRODUCT(qt(1:3, isrtq(ii)), MATMUL(crys%bdot(1:3, 1:3), qt(1:3, isrtq(ii)))))
    if(ii == 1) then
      write(6,'(1x,a,f12.6)') 'Dielectric constant : ', 1.d0 / epsi%eps(1)
    endif
    if(ii == epsi%nq) then
      write(6,'(1x,a,i0)') 'Dielectric matrix tabulated, nq = ', epsi%nq
      write(6,'(1x,2(a,f12.6,2x))') 'emax = ', epsi%emax, 'qlen = ', qlength
      write(6,*)
    endif
  enddo

  call write_epsdiag(epsi)

  SAFE_DEALLOCATE(qt)
  SAFE_DEALLOCATE(epst)
  SAFE_DEALLOCATE(eknq)
  SAFE_DEALLOCATE(isrtq)

  POP_SUB(epsdiag)

  return

contains

  !>  ngmax = number of G-vectors within the sphere of radius emax
  !!  (if nqtmax is too small, increase it)
  !! FHJ: Calculate the number of G vectors so that |q+G|^2 < emax.
  !! See DAS/JRD` discussion why we do this.
  subroutine get_ngmax(is_q0)
    logical, intent(in) :: is_q0

    integer :: gg(3),iout
    PUSH_SUB(epsdiag.get_ngmax)

    ngmax = 0
    do ii=1,ng
      if (ekold(isrtold(ii)).lt.eaux) then
        gg(1)=oldx(isrtold(ii))
        gg(2)=oldy(isrtold(ii))
        gg(3)=oldz(isrtold(ii))
        call findvector(iout,gg,gvec)
        if (iout.gt.gvec%ng) then
          write(0,'(a,2i6)') 'WARNING: eps ',iout,gvec%ng
        endif
        if (iout.le.0) then
          write(0,'(a,4i6)') 'WARNING: eps ',iout,gg(1:3)
        endif
        isrtq(ii)=iout
        isrtqi(iout)=ii
        if (.not.is_q0) eknq(ii)=ekold(isrtold(ii))
        ngmax=ii
      else
        exit
      endif
    enddo

    POP_SUB(epsdiag.get_ngmax)
  end subroutine get_ngmax

end subroutine epsdiag

end module epsdiag_m

!================================================================================
!
! Routines:
!
! (1) input()   Originally By ?                 Last Modified 7/7/2008
!
! Read in and setup up various data structures,
! read in and distributes wave functions, do all sorts of setup, etc.
!
!===============================================================================

#include "f_defs.h"

module input_m

  use global_m
  use checkbz_m
  use createpools_m
  use eqpcor_m
  use fftw_m
  use fullbz_m
#ifdef HDF5
  use hdf5
#endif
  use wfn_io_hdf5_m
  use epswrite_hdf5_m
  use input_utils_m
  use io_utils_m
  use irrbz_m
  use misc_m
  use scissors_m
  use sort_m
  use wfn_rho_vxc_io_m

  implicit none
  
  private
  public :: input

contains

subroutine input(kp,crys,syms,gvec,pol,&
  cwfn,vwfn,intwfnv,intwfnc,omega_plasma, gr)
  type (kpoints), intent(out) :: kp
  type (crystal), intent(out) :: crys
  type (symmetry), intent(out) :: syms
  type (gspace), intent(out) :: gvec
  type (polarizability), intent(out) :: pol
  type (conduction_wfns), intent(out) :: cwfn
  type (valence_wfns), intent(out) :: vwfn
  type (int_wavefunction), intent(out) :: intwfnv
  type (int_wavefunction), intent(out) :: intwfnc
  real(DP), intent(out) :: omega_plasma
  type(grid), intent(out) :: gr

  integer, allocatable :: global_nvown_temp(:),global_ncown_temp(:)
  integer, allocatable :: global_pairowner_temp(:,:),global_indexv_temp(:,:)

  character :: aheadinput*60, ajname*6, adate*11, atime*14
  character :: filenameh5*80
  character :: tmpfn*16
  character :: fncor*32
  character :: tmpstr1*16,tmpstr2*16,tmpstr3*16,tmpstr*120
  integer :: ii,ig,jj,itran,ib
  integer :: error
  integer :: nrq,nrqmax,iq,ic,npools,mypool,mypoolrank
  integer :: iv,nrkq,myipe,ipool
  integer :: ipe,orig_group,iw
  integer :: nmtx,nmtx_l,nmtx_t,nmtx0,npairs
  integer :: Nrod,Nplane,Nfft(3),dNfft(3),dkmax(3),nmpinode,nspin_mat
  real(DP) :: qk(3),vcell,qtot,qshift(3),norm
  real(DP) :: mem,fmem,rmem,rmem2,smem,scale,dscale
  real(DP), allocatable :: energies(:,:,:)
  type(grid) :: qgr
  
  character(len=3) :: sheader
  integer :: iflavor
  type(gspace) :: gvecq
  type(kpoints) :: kpq
  type(crystal) :: crysq
  type(symmetry) :: symsq

  logical :: skip_checkbz

  PUSH_SUB(input)

!-------------------------------
! SIB: Read the input file

  call inread(pol,vwfn,cwfn)

!-------------------------------
! JRD: Initial hdf interface
#ifdef HDF5
  if(pol%use_hdf5 .or. pol%os_hdf5) call h5open_f(error)
#endif

!-------------------------------
! Distribute Val/Cond Bands over Processors

! Create pools if not read from epsilon.inp

  if (peinf%npools .le. 0 .or. peinf%npools .gt. peinf%npes) then
    call createpools(vwfn%nband+pol%ncrit,cwfn%nband-vwfn%nband,peinf%npes,npools,peinf%nvownmax,peinf%ncownmax)
    peinf%npools = npools
  else
    npools = peinf%npools
    
    if (mod((vwfn%nband+pol%ncrit),npools) .eq. 0) then
      peinf%nvownmax = (vwfn%nband+pol%ncrit) / npools
    else
      peinf%nvownmax = ((vwfn%nband+pol%ncrit) / npools) + 1
    endif

    if (mod((cwfn%nband-vwfn%nband),(peinf%npes/npools)) .eq. 0) then
      peinf%ncownmax = (cwfn%nband-vwfn%nband) / (peinf%npes / npools)
    else
      peinf%ncownmax = (cwfn%nband-vwfn%nband) / (peinf%npes / npools) + 1
    endif
  endif

  if (peinf%inode .eq. 0) then
    write(tmpstr1,440) npools
    write(tmpstr2,440) peinf%ncownmax
    write(tmpstr3,440) peinf%nvownmax
    write(6,444) TRUNC(tmpstr1),TRUNC(tmpstr2),TRUNC(tmpstr3)
    write(7,444) TRUNC(tmpstr1),TRUNC(tmpstr2),TRUNC(tmpstr3)
  endif
440 format(i16)
444 format(1x,"Running with",1x,a,1x,"valence pools",/, &
      1x,"Number of conduction bands per processor:",1x,a,/, &
      1x,"Number of valence bands per processor:",1x,a,/)

  SAFE_ALLOCATE(peinf%global_pairowner,((vwfn%nband+pol%ncrit),(cwfn%nband-vwfn%nband)))
  peinf%global_pairowner=0
  SAFE_ALLOCATE(peinf%doiownv,(vwfn%nband+pol%ncrit))
  peinf%doiownv=.false.
  SAFE_ALLOCATE(peinf%doiownc,(cwfn%nband-vwfn%nband))
  peinf%doiownc=.false.
  SAFE_ALLOCATE(peinf%does_it_ownv,(vwfn%nband+pol%ncrit,peinf%npes))
  peinf%does_it_ownv=.false.
  SAFE_ALLOCATE(peinf%does_it_ownc,(cwfn%nband-vwfn%nband,peinf%npes))
  peinf%does_it_ownc=.false.
  SAFE_ALLOCATE(peinf%global_nvown,(peinf%npes))
  peinf%global_nvown=0
  SAFE_ALLOCATE(peinf%global_ncown,(peinf%npes))
  peinf%global_ncown=0
  SAFE_ALLOCATE(peinf%indexv,(vwfn%nband+pol%ncrit))
  peinf%indexv=0
  SAFE_ALLOCATE(peinf%global_indexv,(vwfn%nband+pol%ncrit,peinf%npes))
  peinf%global_indexv=0
  SAFE_ALLOCATE(peinf%indexc,(cwfn%nband-vwfn%nband))
  peinf%indexc=0
  SAFE_ALLOCATE(peinf%invindexv,(peinf%nvownmax))
  peinf%invindexv=0
  SAFE_ALLOCATE(peinf%invindexc,(peinf%ncownmax))
  peinf%invindexc=0

  peinf%nvownactual=0
  peinf%ncownactual=0

  ! FHJ: each pool consist of (peinf%npes/npools) (rounded down) sequential
  !      MPI processes.
  !      Except for iv and ic all indices here start at 0.
  mypool = (peinf%inode/(peinf%npes/npools))
  mypoolrank = mod(peinf%inode,(peinf%npes/npools)) ! my rank within the pool
  myipe = peinf%inode + 1

  do iv = 1,vwfn%nband+pol%ncrit
    ! FHJ: The valence bands are assigned to the pools in a sequential fashion.
    !      This is more efficient for the parallel IO.  Eg: 
    !       for 2 (val. bands)/pool, v1->p0, v2->p0, v3->p1, etc.
    ipool = (iv-1)/peinf%nvownmax
    
    if (mypool .eq. ipool) then

      peinf%nvownactual=peinf%nvownactual+1
      peinf%global_nvown(myipe)=peinf%nvownactual
      peinf%indexv(iv)=peinf%nvownactual
      peinf%global_indexv(iv,myipe)=peinf%indexv(iv)
      peinf%invindexv(peinf%nvownactual)=iv
      peinf%doiownv(iv)=.true.

      do ic = 1, cwfn%nband-vwfn%nband
        ! FHJ: Conduction bands are also assigned sequentially. Eg:
        !       c1..c4 -> pr0, c5..c8 -> pr1, etc.
        if ( (ic-1)/peinf%ncownmax == mypoolrank ) then
          ! We only have to create the local list of conduction bands once
          if (peinf%nvownactual .eq. 1) then
            peinf%ncownactual=peinf%ncownactual+1
            peinf%global_ncown(myipe) = peinf%ncownactual
            peinf%invindexc(peinf%global_ncown(myipe))=ic
            peinf%indexc(ic)=peinf%ncownactual
            peinf%doiownc(ic)=.true.
          endif
          peinf%global_pairowner(iv,ic)=myipe
        endif
      enddo

    endif
  enddo
  peinf%does_it_ownv(:,peinf%inode+1) = peinf%doiownv(:)
  peinf%does_it_ownc(:,peinf%inode+1) = peinf%doiownc(:)

#ifdef MPI
  do ipe=0, peinf%npes-1
    call MPI_Bcast(peinf%does_it_ownv(1,ipe+1), vwfn%nband+pol%ncrit,&
                   MPI_LOGICAL, ipe, MPI_COMM_WORLD, mpierr)
    call MPI_Bcast(peinf%does_it_ownc(1,ipe+1), cwfn%nband-vwfn%nband,&
                   MPI_LOGICAL, ipe, MPI_COMM_WORLD, mpierr)
  enddo

  SAFE_ALLOCATE(global_pairowner_temp,((vwfn%nband+pol%ncrit),(cwfn%nband-vwfn%nband)))
  call MPI_ALLREDUCE(peinf%global_pairowner(1,1),global_pairowner_temp(1,1), &
    (vwfn%nband+pol%ncrit)*(cwfn%nband-vwfn%nband),MPI_INTEGER,MPI_SUM, &
    MPI_COMM_WORLD,mpierr)
  peinf%global_pairowner=global_pairowner_temp
  SAFE_DEALLOCATE(global_pairowner_temp)
  
  SAFE_ALLOCATE(global_nvown_temp,(peinf%npes))
  call MPI_ALLREDUCE(peinf%global_nvown,global_nvown_temp,peinf%npes,MPI_INTEGER,MPI_SUM, &
    MPI_COMM_WORLD,mpierr)
  peinf%global_nvown=global_nvown_temp
  SAFE_DEALLOCATE(global_nvown_temp)
  
  SAFE_ALLOCATE(global_ncown_temp,(peinf%npes))
  call MPI_ALLREDUCE(peinf%global_ncown,global_ncown_temp,peinf%npes,MPI_INTEGER,MPI_SUM, &
    MPI_COMM_WORLD,mpierr)
  peinf%global_ncown=global_ncown_temp
  SAFE_DEALLOCATE(global_ncown_temp)

! The below command works for MPI-1 and MPI-2, so we will use it for now. Soon we will have the in-place command
! that is commented out below to use, since it is more efficient with memory and most machines can run with MPI-2 nowadays

  SAFE_ALLOCATE(global_indexv_temp,((vwfn%nband+pol%ncrit),peinf%npes))
  call MPI_ALLREDUCE(peinf%global_indexv(1,1),global_indexv_temp(1,1),peinf%npes*(vwfn%nband+pol%ncrit),MPI_INTEGER,MPI_SUM, &
    MPI_COMM_WORLD,mpierr)
  peinf%global_indexv=global_indexv_temp
  SAFE_DEALLOCATE(global_indexv_temp)

! Here is the command for MPI-2. It will be commented back in when we have appropriate compiler flags set up. All other
! mpi allreduces should be done in the same way once things are set up
!  call MPI_ALLREDUCE(MPI_IN_PLACE,peinf%global_indexv(1,1),peinf%npes*(vwfn%nband+pol%ncrit),MPI_INTEGER,MPI_SUM, &
!    MPI_COMM_WORLD,mpierr)

#endif

! number of processors in your frequency eval group
  peinf%npes_freqgrp = peinf%npes/pol%os_para_freqs

  if(pol%os_para_freqs .gt. 1) then
  else
    peinf%rank_mtxel = 0
    peinf%rank_f = peinf%inode
    peinf%igroup_f=0
    peinf%igroup_mtxel=peinf%inode
  endif

! DVF : number of frequencies owned by a given processor. Each frequency group
! owns frequencies igroup_f, igroup_f+pol%os_para_freqs, igroup_f+2*pol%os_para_freqs, etc.

  pol%os_nfreq_para=0
  do iw=1,pol%nFreq
    if( mod(iw-1,pol%os_para_freqs) .eq. peinf%igroup_f) then
      pol%os_nfreq_para=pol%os_nfreq_para+1
    endif
  enddo

  pol%os_nsfreq_para=0
  do iw=1,pol%nsFreq
    if( mod(iw-1,pol%os_para_freqs) .eq. peinf%igroup_f) then
      pol%os_nsfreq_para=pol%os_nsfreq_para+1
    endif
  enddo

!---------------------------------
! Determine the available memory

  call procmem(mem,nmpinode)

  if(peinf%inode.eq.0) then
    write(6,998) mem / 1024**2
    write(7,998) mem / 1024**2
  endif
998 format(1x,'Memory available:',f10.1,1x,'MB per PE')
  fmem = mem / 8

  sheader = 'WFN'
  iflavor = 0
  if(pol%os_hdf5) then
  else
    if(peinf%inode == 0) then
      write(6,'(a)') ' Reading header of WFN'
      call open_file(25,file='WFN',form='unformatted',status='old')
    endif
    call read_binary_header_type(25, sheader, iflavor, kp, gvec, syms, crys, &
      dont_warn_kgrid=pol%subsample)
  endif
  call check_trunc_kpts(pol%icutv, kp)

  if (pol%need_WFNq) then
    if(pol%os_hdf5) then
    else
      if(peinf%inode == 0) then
        write(6,'(a)') ' Reading header of WFNq'
        call open_file(26,file='WFNq',form='unformatted',status='old')
      endif
      call read_binary_header_type(26, sheader, iflavor, kpq, gvecq, symsq, crysq, &
        dont_warn_kgrid=pol%subsample, warn=.false.)

      if(peinf%inode == 0) call close_file(26)
    endif

    nrkq = kpq%nrk
    call check_trunc_kpts(pol%icutv, kpq)
    call check_header('WFN', kp, gvec, syms, crys, 'WFNq', kpq, gvecq, symsq, crysq, is_wfn=.true.)
    if(any(kp%kgrid(1:3) /= kpq%kgrid(1:3)).and..not.pol%subsample) then
      if(peinf%inode == 0) then
        write(0,*) 'WFN  kgrid = ', kp%kgrid(1:3)
        write(0,*) 'WFNq kgrid = ', kpq%kgrid(1:3)
      endif
      call die('kgrids for WFN and WFNq must be the same', only_root_writes=.true.)
    endif
    call dealloc_header_type(sheader, crysq, kpq)
  endif

  SAFE_ALLOCATE(gvec%components, (3, gvec%ng))
  if(pol%os_hdf5) then
  else
    call read_binary_gvectors(25, gvec%ng, gvec%ng, gvec%components)
  endif

!-------------------------------
! (gsm) Estimate the required memory

  nmtx=0

  gr%nr = kp%nrk
  SAFE_ALLOCATE(gr%r, (3, gr%nr))
  gr%r = kp%rk
  call timacc(4,1)
  if (pol%patched_sampling) then
    call fullbz(crys,syms,gr,1,skip_checkbz,wigner_seitz=.false.,paranoid=.true.)
  else
    call fullbz(crys,syms,gr,syms%ntran,skip_checkbz,wigner_seitz=.false.,paranoid=.true.)
  endif
  tmpfn='WFN'
  if (.not.skip_checkbz.and..not.pol%patched_sampling) then
    call checkbz(gr%nf,gr%f,kp%kgrid,kp%shift,crys%bdot, &
      tmpfn,'k',.false.,pol%freplacebz,pol%fwritebz)
  endif

  ! do not worry if this is the separate q->0 calculation for metals
  if(pol%nq > 1 .or. pol%valueq0 /= 2) then
    qgr%nr = pol%nq
    SAFE_ALLOCATE(qgr%r, (3, pol%nq))
    qgr%r(1:3,1:pol%nq) = pol%qpt(1:3,1:pol%nq)
    if(pol%nq0>0) qgr%r(1:3,1:pol%nq0) = 0d0
    if (pol%patched_sampling) then
      call fullbz(crys,syms,qgr,1,skip_checkbz,wigner_seitz=.false.,paranoid=.true.)
    else
      call fullbz(crys,syms,qgr,syms%ntran,skip_checkbz,wigner_seitz=.false.,paranoid=.true.)
    endif
    qshift(:)=0.0d0
    if (.not.skip_checkbz.and..not.pol%subsample.and..not.pol%patched_sampling) then
      call checkbz(qgr%nf,qgr%f,kp%kgrid,qshift,crys%bdot,'epsilon.inp','q',.false.,pol%freplacebz,pol%fwritebz)
    endif
    call dealloc_grid(qgr)
  endif
  call timacc(4,2)

! XXX - Do this in parallel?

! compute max for nmtx
  if(peinf%inode == 0) then
    SAFE_ALLOCATE(pol%nmtx_of_q,(pol%nq))

    nmtx0=-1

! XXX - THREAD?
    do iq = 1, pol%nq
      SAFE_ALLOCATE(gvec%ekin, (gvec%ng))
      if (iq<=pol%nq0) then
        call kinetic_energies(gvec, crys%bdot, gvec%ekin)
      else
        call kinetic_energies(gvec, crys%bdot, gvec%ekin, qvec = pol%qpt(:,iq))
      endif
      SAFE_ALLOCATE(pol%isrtx, (gvec%ng))
      call sortrx(gvec%ng, gvec%ekin, pol%isrtx, gvec = gvec%components)
      nmtx_t = gcutoff(gvec%ng, gvec%ekin, pol%isrtx, pol%ecuts)
      SAFE_DEALLOCATE_P(pol%isrtx)
      SAFE_DEALLOCATE_P(gvec%ekin)
      pol%nmtx_of_q(iq) = nmtx_t
      if (iq<=pol%nq0) then 
        nmtx0 = nmtx_t
      else
        if (nmtx_t .gt. nmtx) nmtx = nmtx_t 
      endif
    enddo

    nmtx_l = max(nmtx,nmtx0)
    nmtx_l = int(sqrt(dble(nmtx_l)**2 / peinf%npes_freqgrp))
    ! JRD: DUMB Debugging write(6,*) 'computed nmtx_l', nmtx, peinf%npes, nmtx_l, pol%nq
    
    nrqmax=0
    do iq=1,pol%nq
      nrq=0
      call subgrp(pol%qpt(:,iq),syms)
      call irrbz(syms,gr%nf,gr%f,nrq)
      if (nrq .gt. nrqmax) nrqmax=nrq
    enddo

! required memory
    rmem=0.0d0
! array pol%chi in program chi_summation (and chilocal, chilocal2 (if gcomm=-1))
    if (pol%freq_dep.eq.0) then
      rmem = rmem + 2 * dble(kp%nspin) * dble(nmtx_l)**2
      if (pol%gcomm .eq. -1) then
        rmem = rmem + dble(kp%nspin) * dble(nmtx_l)**2
      endif
    endif
! DVF : Arrays pol%chiRDyn, chilocalRDyn in program chi_summation (their advanced counterparts 
! are taken care of via multiplication by sizeof_scalar below). These arrays are present
! for both gcomm=-1 (matrix comm) and 0 (elements comm). The gcomm=-1, you also have 
! chilocal2RDyn and its advanced counterpart. The other factor of two comes from the 
! fact that these arrays are complex. Note : I think the multiplication of the some 
! of the memory by sizeof_scalar is not proper because many of these arrays are
! always complex, so the factor or 2 between real and complex versions of the code
! makes no sense. I guess this is just an estimate, but I think it may be a decent
! bit off because of this.
    if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 0)) then
      rmem = rmem + dble(kp%nspin) * dble(nmtx_l)**2 * dble(pol%os_nfreq_para) *4
      if (pol%gcomm .eq. -1) then
        rmem = rmem + dble(kp%nspin) * dble(nmtx_l)**2 * dble(pol%os_nfreq_para) * 2
      endif
    endif

    if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 1)) then
      !pol%chiRDyn,pol%chiADyn
      rmem = rmem + dble(kp%nspin) * dble(nmtx_l)**2 * dble(pol%os_nfreq_para) *2
      !chilocalRDyn
      rmem = rmem + dble(nmtx_l)**2 * dble(pol%os_nsfreq_para) 
      !pol%chiTDyn
      rmem = rmem + dble(kp%nspin) * dble(nmtx_l)**2 * dble(pol%os_nsfreq_para) 
      !chilocal2RDyn 
      if (pol%gcomm .eq. -1) then
        rmem = rmem + dble(kp%nspin) * dble(nmtx_l)**2 * dble(pol%os_nsfreq_para)
      endif
    endif

    if (pol%freq_dep .eq. 3) then
      rmem = rmem + dble(kp%nspin) * dble(nmtx_l)**2 * dble(pol%os_nfreq_para) *4
      if (pol%gcomm .eq. -1) then
        rmem = rmem + dble(kp%nspin) * dble(nmtx_l)**2 * dble(pol%os_nfreq_para) * 2
      endif
    endif


! arrays gmetempr and gmetempc in program chi_summation
    if (pol%freq_dep.eq.0) then
      if (kp%nrk .eq. 1) then
        rmem = rmem + 2 * dble(nmtx) * dble(vwfn%nband + pol%ncrit) / sqrt(dble(peinf%npes))
      else
        rmem = rmem + 2 * dble(nmtx) * dble(vwfn%nband + pol%ncrit) * dble(syms%ntran) / sqrt(dble(peinf%npes))
      endif
    endif
! arrays gmeR(A)Dyntempr2 and gmeR(A)Dyntempc in program chi_summation
! DVF : I think this is an overestimate because gmeRDyntempc does not 
! have frequency dependence
    if ( ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 0)) .or. pol%freq_dep .eq. 3) then
      if (pol%gcomm .eq. 0) then
        if (kp%nrk .eq. 1) then
          rmem = rmem + dble(nmtx) * dble(pol%nfreq + 1) * dble(vwfn%nband + pol%ncrit) / sqrt(dble(peinf%npes))
        else
          rmem = rmem + dble(nmtx) * dble(pol%nfreq + 2) * dble(vwfn%nband + pol%ncrit) * dble(syms%ntran) / sqrt(dble(peinf%npes))
        endif
#ifdef CPLX
        if (pol%freq_dep .ne. 3) then
          if (kp%nrk .eq. 1) then
            rmem = rmem + dble(nmtx) * dble(pol%nfreq + 2) * dble(vwfn%nband + pol%ncrit) / sqrt(dble(peinf%npes))
          else
            rmem = rmem + dble(nmtx) * dble(pol%nfreq + 2) * dble(vwfn%nband + pol%ncrit)&
                                  * dble(syms%ntran) / sqrt(dble(peinf%npes))
          endif
        endif
#endif
      endif
      npairs=(vwfn%nband+pol%ncrit)*(cwfn%nband-vwfn%nband)
      if (pol%gcomm .eq. -1) then
        if (kp%nrk .eq. 1) then
          rmem = rmem + 2 * dble(nmtx) * dble(npairs) * dble(pol%os_nfreq_para) / peinf%npes_freqgrp**1.5
        else
          rmem = rmem + 2 * dble(nmtx) * dble(kp%nrk) * dble(npairs) * dble(syms%ntran) * dble(pol%os_nfreq_para) &
                           / peinf%npes_freqgrp**1.5
        endif
#ifdef CPLX
        if (pol%freq_dep .ne. 3) then
          if (kp%nrk .eq. 1) then
            rmem = rmem + 2 * dble(nmtx) * dble(pol%nfreq) * dble(npairs) / peinf%npes_freqgrp**1.5
          else
            rmem = rmem + 2 * dble(nmtx) * dble(kp%nrk) * dble(npairs) * dble(syms%ntran) * dble(pol%nfreq) &
                             / peinf%npes_freqgrp**1.5
          endif
        endif
#endif
      endif
    endif

    if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 1)) then
      if (pol%gcomm .eq. 0) then
        !gmeRDyntempr2, gmeRDyntempcs, and gmeRDyntempc
        !It is an overestimate because max_nv is less than nv.
        if (kp%nrk .eq. 1) then
          rmem = rmem + dble(nmtx) * dble(pol%nsfreq + 2)&
                 * dble(vwfn%nband + pol%ncrit) / sqrt(dble(peinf%npes))
        else
          rmem = rmem + dble(nmtx) * dble(pol%nsfreq + 3)&
                 * dble(vwfn%nband + pol%ncrit) * dble(syms%ntran) / sqrt(dble(peinf%npes))
        endif
      endif
      npairs=(vwfn%nband+pol%ncrit)*(cwfn%nband-vwfn%nband)
      if (pol%gcomm .eq. -1) then
        if (kp%nrk .eq. 1) then
          rmem = rmem + 2 * dble(nmtx) * dble(npairs)&
                 * dble(pol%os_nsfreq_para) / peinf%npes_freqgrp**1.5
        else
          rmem = rmem + 2 * dble(nmtx) * dble(kp%nrk)&
                 * dble(npairs) * dble(syms%ntran) * dble(pol%os_nsfreq_para) &
                 / peinf%npes_freqgrp**1.5
        endif
      endif
    endif
! array gmetempn in program chi_summation
    rmem = rmem + dble(nmtx)
! array tmparray in program mtxel
    rmem = rmem + dble(nmtx)
! array pol%gme in program chi_summation
    rmem = rmem + dble(kp%nspin) * dble(nmtx) * dble(peinf%ncownmax) * dble(peinf%nvownmax) * dble(nrqmax)*dble(pol%os_para_freqs)
! arrays zin, vwfn%zv, cwfn%zc, zinc and zinc_old in subroutine genwf
    rmem = rmem + dble(kp%nspin) * dble(2 * 1 + 2 * peinf%ncownmax + 1) * dble(kp%ngkmax)
! intwfn_files
    if (pol%iwriteint .eq. 1) then !COMM_MPI
      rmem = rmem + dble(peinf%nvownmax + peinf%ncownmax) * dble(kp%ngkmax) * dble(kp%nrk) * dble(kp%nspin)
! intvwfnq if have a q=0 point
      if (pol%need_WFNq) then
        rmem = rmem + dble(peinf%nvownmax) * dble(kp%ngkmax) * dble(nrkq) * dble(kp%nspin)
      endif
    endif

    rmem = rmem * sizeof_scalar()

! memory for pol%eden or pol%edenDyn
    if (pol%freq_dep .eq. 0) then
      rmem = rmem + dble(kp%nspin) * dble(vwfn%nband + pol%ncrit) * dble(cwfn%nband) * 8
    endif
    if (pol%freq_dep .eq. 2 .or. pol%freq_dep .eq. 3) then
      rmem = rmem + dble(kp%nspin) * dble(peinf%nvownmax) * dble(peinf%ncownmax) * dble(nrqmax) * dble(pol%os_para_freqs)*8
    endif
! array gvec%index_vec in input
    rmem = rmem + dble(gvec%nFFTgridpts) * 4
! arrays fftbox1 and fftbox2 in subroutines mtxel
    call setup_FFT_sizes(gvec%FFTgrid,Nfft,scale)
    rmem = rmem + dble(product(Nfft(1:3))) * 32

    write(6,989) rmem / 1024**2
    write(7,989) rmem / 1024**2

! store required memory in variable smem
    smem=rmem

! random numbers
    rmem=0.0D0
! (gsm) we don`t do random numbers in Epsilon anymore
!        if (pol%icutv.ne.5) then
! arrays ran, qran, and qran2
! (ran is deallocated before qran2 is allocated)
!          rmem=rmem+6.0D0*dble(nmc)*8.0D0
!        endif
! various truncation schemes
    rmem2=0.0d0
! cell wire truncation
    if (pol%icutv.eq.4) then
      dkmax(1) = gvec%FFTgrid(1) * n_in_wire
      dkmax(2) = gvec%FFTgrid(2) * n_in_wire
      dkmax(3) = 1
      call setup_FFT_sizes(dkmax,dNfft,dscale)
! array fftbox_2D
      rmem2 = rmem2 + dble(dNfft(1) * dNfft(2)) * 16
! array inv_indx
      rmem2 = rmem2 + dble(product(Nfft(1:3))) * 4
! array qran
      rmem2 = rmem2 + 3 * dble(nmc) * 8
    endif
! cell box truncation (parallel version only)
    if (pol%icutv.eq.5) then
      dkmax(1:3) = gvec%FFTgrid(1:3) * n_in_box
      call setup_FFT_sizes(dkmax,dNfft,dscale)
      if (mod(dNfft(3),peinf%npes) == 0) then
        Nplane = dNfft(3)/peinf%npes
      else
        Nplane = dNfft(3)/peinf%npes+1
      endif
      if (mod(dNfft(1)*dNfft(2),peinf%npes) == 0) then
        Nrod = (dNfft(1)*dNfft(2))/peinf%npes
      else
        Nrod = (dNfft(1)*dNfft(2))/peinf%npes+1
      endif
! array fftbox_2D
      rmem2 = rmem2 + dble(dNfft(1)) * dble(dNfft(2)) * dble(Nplane) * 16
! array fftbox_1D
      rmem2 = rmem2 + dble(dNfft(3)) * dble(Nrod) * 16
! array dummy
!          rmem2=rmem2+dble(dNfft(1))*dble(dNfft(2))*16.0d0
! arrays dummy1 and dummy2
      rmem2 = rmem2 + dble(Nrod) * (peinf%npes + 1) * 16
! array inv_indx
      rmem2 = rmem2 + dble(product(Nfft(1:3))) * 4
    endif
    if (rmem2 .gt. rmem) rmem = rmem2
    write(6,988) rmem / 1024**2
    write(7,988) rmem / 1024**2
    if (smem .gt. mem) write(0,777)
  endif
989 format(1x,'Memory required for execution:',f7.1,1x,'MB per PE')
988 format(1x,'Memory required for vcoul:',f7.1,1x,'MB per PE',/)
777 format(1x,'WARNING: Required memory greater than memory available.',/, &
      3x,'This calculation will likely die. To reduce memory,',/, &
      3x,'first make sure you are running on an ideal # of PEs.',/, &
      3x,'Then, try increasing the number of PEs or try adding',/, &
      3x,'gcomm_elements and comm_disk to epsilon.inp',/)

!--------------------------------------------
! SIB: Read in crys%bdot and crys%celvol from file #25
! Complain if crys%celvol and (2pi)^3/sqrt[|det(b)|] are different
! bdot is read in row by row.  get_volume() assumes that bdot is symmetric.
! bdot should be dot products of the reciprocal lattice vectors.
! Therefore vol is the real space volume of the cell.

  if(peinf%inode.eq.0) then

    write(7,'(1x,"Cell Volume =",e16.9,/)') crys%celvol

!-------------------------
! Compute Cell Volume

    call get_volume(vcell,crys%bdot)
    if (abs(crys%celvol-vcell).gt.TOL_Small) then
      call die('volume mismatch')
    endif

#ifdef VERBOSE
    write(6,'(1x,"Num Syms =",i4)') syms%ntran
    write(6,'(1x,"Sym Trans Mtxs")')
    do itran=1,syms%ntran
      write(6,'(1x,9i4)') ((syms%mtrx(ii,jj,itran),ii=1,3),jj=1,3)
    enddo
    do itran=1,syms%ntran
      write(6,'(1x,3f10.6)') (syms%tnp(ii,itran),ii=1,3)
    enddo
    write(6,'(1x,"Sym Trans Vecs")')
    write(6,*)
#endif

  endif

  if(cwfn%nband.gt.kp%mnband) then
    if(peinf%inode == 0) then
      write(tmpstr1,660) cwfn%nband
      write(tmpstr2,660) kp%mnband
      write(tmpstr,666) TRUNC(tmpstr1), TRUNC(tmpstr2)
    endif
660 format(i16)
666 format(1x,'The number of bands (',a,') specified in epsilon.inp is larger than the number of bands (',a,') available in WFN.')
    call die(tmpstr, only_root_writes = .true.)
  endif
  if(cwfn%nband.eq.kp%mnband) then
    call die("You must provide one more band in WFN than used in epsilon.inp in order to assess degeneracy.")
  endif
  
  SAFE_ALLOCATE(energies, (kp%mnband, kp%nrk, kp%nspin))
  energies(1:kp%mnband, 1:kp%nrk, 1:kp%nspin) = kp%el(1:kp%mnband, 1:kp%nrk, 1:kp%nspin)
  do ib = 1, cwfn%nband
    kp%el(ib, 1:kp%nrk, 1:kp%nspin) = energies(cwfn%band_index(ib), 1:kp%nrk, 1:kp%nspin)
  enddo
  kp%el(cwfn%nband + 1, 1:kp%nrk, 1:kp%nspin) = energies(cwfn%band_index(cwfn%nband) + 1, 1:kp%nrk, 1:kp%nspin)
  SAFE_DEALLOCATE(energies)

  call scissors_shift(kp, pol%scis)

!----------------------------------------------------------------
! If quasi-particle corrections were requested, read the corrected
! quasiparticle energies from file (in eV)
    
  if(peinf%inode == 0) then
    if(any(abs(kp%el(cwfn%nband, 1:kp%nrk, 1:kp%nspin) - kp%el(cwfn%nband + 1, 1:kp%nrk, 1:kp%nspin)) .lt. TOL_Degeneracy)) then
      if(pol%degeneracy_check_override) then
        write(0,'(a)') &
          "WARNING: Selected number of bands breaks degenerate subspace. " // &
          "Run degeneracy_check.x for allowable numbers."
        write(0,*)
      else
        write(0,'(a)') &
          "Run degeneracy_check.x for allowable numbers, or use keyword " // &
          "degeneracy_check_override to run anyway (at your peril!)."
        call die("Selected number of bands breaks degenerate subspace.")
      endif
    endif

    if(pol%eqp_corrections) then
      fncor='eqp.dat'
      call eqpcor(fncor,0,1,kp,1,cwfn%nband,0,0,kp%el,kp%el,kp%el,1,0)
    endif

    call find_efermi(pol%rfermi, pol%efermi, pol%efermi_input, kp, cwfn%nband, 1, &
      "unshifted grid", should_search = .true., should_update = .true., write7 = .true.)
    ! note: here ifmax may be updated. We will never use it, so it does not matter that it only happens on proc 0. -DAS

    if(any (kp%ifmax(:,:) < vwfn%nband .or. kp%ifmax(:,:) > vwfn%nband + pol%ncrit)) then
      write(0,'(a,i6,a,i6,a)') 'epsilon.inp says there are ', vwfn%nband, ' fully occupied bands and ', &
        pol%ncrit, ' partially occupied.'
      write(0,'(a,2i6)') 'This is inconsistent with highest bands in WFN file; min, max = ', minval(kp%ifmax), maxval(kp%ifmax)
      call die("band_occupation, number_partial_occup, and WFN inconsistent.")
    endif
    
    if(maxval(kp%ifmax) - minval(kp%ifmax) > pol%ncrit) then
      write(0,'(a,i6,a)') 'epsilon.inp says there are ', pol%ncrit, ' partially occupied bands.'
      write(0,'(a,i6)') 'This is less than the number partially occupied in WFN file: ', maxval(kp%ifmax) - minval(kp%ifmax)
      call die("number_partial_occup and WFN inconsistent.")
    endif

    call assess_degeneracies(kp, kp%el(cwfn%nband + 1, :, :), cwfn%nband, pol%efermi, TOL_Degeneracy)

    call calc_qtot(kp, crys%celvol, pol%efermi, qtot, omega_plasma, write7 = .true.)

    if (mod(peinf%npes,npools) .ne.0) then
      write(0,'(a)') ' WARNING: The number of cpus does not divide evenly in the optimal number of pools.'
      write(0,*)  mod(peinf%npes,npools),'cpus are doing no work'
      write(0,'(a)') ''
    endif
    if (peinf%nvownactual .ne. peinf%nvownmax) then
      write(0,'(a)') ' WARNING: Your valence bands are not equally distributed among the pools'
      write(0,*) 'Max valence bands per pool is',peinf%nvownmax
      write(0,*) 'Min valence bands per pool is',peinf%nvownactual
      write(0,'(a)') ''
    endif
  endif

#ifdef MPI
  call MPI_Bcast(pol%efermi, 1, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
  call MPI_BCAST(omega_plasma, 1, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
  if(peinf%inode.ne.0) then
    SAFE_ALLOCATE(kp%degeneracy, (cwfn%nband, kp%nrk, kp%nspin))
  endif
  call MPI_Bcast(kp%degeneracy(1,1,1), cwfn%nband * kp%nrk * kp%nspin, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
#endif

  call gvec_index(gvec)
  
  if(pol%os_hdf5) then
  else
    call read_wavefunctions(kp, gvec, pol, cwfn, vwfn, intwfnv, intwfnc)
    if(peinf%inode.eq.0) then
      call close_file(25)
    endif
  endif
  
  if (pol%eqp_corrections) call scissors_zero(pol%scis)

  if(peinf%inode == 0) then
    write(aheadinput,'(60x)')
    write(ajname,'("chiGG0")')
    call date_time(adate,atime)
  endif

  if (peinf%inode.eq.0) then
    
    if (pol%nq0>0) then

#ifdef HDF5    
      if (pol%use_hdf5) then
        if (pol%skip_epsilon) then
          filenameh5 = 'chi0mat.h5'
          nspin_mat = kp%nspin
          sheader='CHI'
        else
          filenameh5 = 'eps0mat.h5'
          nspin_mat = 1
          sheader='EPS'
        endif
        call eps_hdf5_setup(pol%freq_dep, pol%nFreq, pol%dFreqGrid, pol%dFreqBrd, &
          pol%ecuts, kp%kgrid, gvec%ng, gvec%components, pol%nq0, &
          pol%qpt(:,1:pol%nq0), pol%nmtx_of_q(1:pol%nq0), nmtx0, nspin_mat, filenameh5, &
          restart=pol%restart)
        if (.not.pol%restart) then
          call setup_hdf5_mf_file(trim(filenameh5), create_file=.false.)
          call write_hdf5_header_type(trim(filenameh5), sheader, SCALARSIZE, &
            kp, gvec, syms, crys)
        endif
      else
#endif
!-------------------------------------------
! Initialize chi0mat and eps0mat:
! SIB: only printed if pol%nq0>0
! All sorts of stuff is printed, such as the epsilon cutoff, number of bands,
! gvectors, bdot matrix, the addresses (gvec%index_vec), and pol%qpt (q-points)
! to chi0mat, and eps0mat has some of it.

        if (pol%skip_epsilon) then
          write(6,'(a)') 'File chi0mat will be written.'
          call open_file(10,file='chi0mat',form='unformatted',status='replace')
          write(10) aheadinput,ajname,adate
          write(10) pol%freq_dep,pol%nFreq
          write(10) kp%kgrid(1:3)
          if (pol%freq_dep .ne. 0) then
            write(10) (pol%dFreqGrid(ii),ii=1,pol%nFreq),(pol%dFreqBrd(ii),ii=1,pol%nFreq)
          else
            write(10)
          endif
          write(10)
          write(10)
          write(10) pol%ecuts,cwfn%nband
          write(10) kp%nrk, 1 ! invflag
          write(10) gvec%ng,gvec%nFFTgridpts,gvec%FFTgrid(1:3), &
            ((gvec%components(ii,ig),ii=1,3),ig=1,gvec%ng), &
            ((crys%bdot(ii,jj),jj=1,3),ii=1,3),(gvec%index_vec(ig),ig=1,gvec%nFFTgridpts)
          write(10) ((pol%qpt(ii,iq),ii=1,3),iq=1,pol%nq0)
        else
          call open_file(12,file='eps0mat',form='unformatted',status='replace')
          write(12) ajname,adate
          write(12) pol%freq_dep,pol%nFreq
          write(12) kp%kgrid(1:3)
          if (pol%freq_dep .ne. 0) then
            write(12) (pol%dFreqGrid(ii),ii=1,pol%nFreq),(pol%dFreqBrd(ii),ii=1,pol%nFreq)
          else
            write(12)
          endif
          write(12)
          write(12)
          write(12) pol%ecuts
          write(12) pol%nq0,((pol%qpt(ii,iq),ii=1,3),iq=1,pol%nq0)
          write(12) gvec%ng, ((gvec%components(jj,ig),jj=1,3),ig=1,gvec%ng)
        endif
#ifdef HDF5
      endif
#endif
      
    endif    

!----------------------------------------
! Initialize chimat and epsmat:
! SIB: chimat and epsmat are printed to for all non-zero q vectors.
! Same sort of information as above.

    if (pol%nq1>0) then

#ifdef HDF5
      if (pol%use_hdf5) then
        if (pol%skip_epsilon) then
          filenameh5 = 'chimat.h5'
          nspin_mat = kp%nspin
          sheader='CHI'
        else
          filenameh5 = 'epsmat.h5'
          nspin_mat = 1
          sheader='EPS'
        endif
        call eps_hdf5_setup(pol%freq_dep, pol%nFreq, pol%dFreqGrid, pol%dFreqBrd, &
          pol%ecuts, kp%kgrid, gvec%ng, gvec%components, pol%nq1, &
          pol%qpt(:,pol%nq0+1:pol%nq), pol%nmtx_of_q(pol%nq0+1:pol%nq), nmtx, nspin_mat, filenameh5, &
          restart=pol%restart)
        if (.not.pol%restart) then
          call setup_hdf5_mf_file(trim(filenameh5), create_file=.false.)
          call write_hdf5_header_type(trim(filenameh5), sheader, SCALARSIZE, &
            kp, gvec, syms, crys)
        endif
      else
#endif
        if (pol%skip_epsilon) then
          write(6,'(a)') 'File chimat will be written.'
          call open_file(11,file='chimat',form='unformatted',status='replace')
          write(11) aheadinput,ajname,adate
          write(11) pol%freq_dep,pol%nFreq
          write(11) kp%kgrid(1:3)
          if (pol%freq_dep .ne. 0) then
            write(11) (pol%dFreqGrid(ii),ii=1,pol%nFreq),(pol%dFreqBrd(ii),ii=1,pol%nFreq)
          else
            write(11)
          endif
          write(11)
          write(11)
          write(11) pol%ecuts,cwfn%nband
          write(11) kp%nrk, 1 ! invflag
          write(11) gvec%ng,gvec%nFFTgridpts,gvec%FFTgrid(1:3), &
            ((gvec%components(jj,ig),jj=1,3),ig=1,gvec%ng), &
            ((crys%bdot(ii,jj),jj=1,3),ii=1,3),(gvec%index_vec(ig),ig=1,gvec%nFFTgridpts)
          write(11) pol%nq,pol%nq0,((pol%qpt(jj,iq),jj=1,3),iq=1,pol%nq) !??????
        else
          call open_file(13,file='epsmat',form='unformatted',status='replace')
          write(13) ajname,adate
          write(13) pol%freq_dep,pol%nFreq
          write(13) kp%kgrid(1:3)
          if (pol%freq_dep .ne. 0) then
            write(13) (pol%dFreqGrid(ii),ii=1,pol%nFreq),(pol%dFreqBrd(ii),ii=1,pol%nFreq)
          else
            write(13)
          endif
          write(13)
          write(13)
          write(13) pol%ecuts
          write(13) pol%nq1, ((pol%qpt(jj,iq),jj=1,3),iq=pol%nq0+1,pol%nq)
          write(13) gvec%ng, ((gvec%components(jj,ig),jj=1,3),ig=1,gvec%ng)
        endif
#ifdef HDF5
      endif 
#endif
 
    endif

!-------------------------------
! SIB: print to stdout and unit=7 (epsilon.log) some information:  cutoffs,
! number of bands, number of q points, and list of q-points.
    write(6,120) pol%ecuts,cwfn%nband,pol%nq
    write(7,120) pol%ecuts,cwfn%nband,pol%nq
120 format(1x,'Screened Coulomb cutoff: ',f0.3,' Ry'/,&
      1x,'Total number of bands: ',i0,/,&
      1x,'Number of q-points: ',i0)
        
! SIB: report on scissors operator parameters to units 6 and 7
    call scissors_write(6, pol%scis)
    call scissors_write(7, pol%scis)
    
    do iq=1,pol%nq
      norm=sqrt(DOT_PRODUCT(MATMUL(crys%bdot, pol%qpt(:,iq)),pol%qpt(:,iq)))
      if (iq<=pol%nq0) then
        write(6,925) (pol%qpt(jj,iq),jj=1,3),norm
      else
        write(6,926) (pol%qpt(jj,iq),jj=1,3),norm
      endif
    enddo
    write(6,*)
925 format(1x,'Q0 and |Q0| =',4f10.6)
926 format(1x,'Q  and |Q|  =',4f10.6)
  endif

#ifdef MPI
  ! FHJ: the pol%restart flag might have been changed by rank 0; need to bcast
  call MPI_Bcast(pol%restart, 1, MPI_LOGICAL, 0, MPI_COMM_WORLD, mpierr)
#endif

  if(pol%iwriteint == 0) then
#ifdef MPI
    call MPI_Barrier(MPI_COMM_WORLD, mpierr)
#endif
  endif

  POP_SUB(input)
      
  return
      
end subroutine input


subroutine read_wavefunctions(kp, gvec, pol, cwfn, vwfn, intwfnv, intwfnc)
  type (kpoints), intent(in) :: kp
  type (gspace), intent(in) :: gvec
  type (polarizability), intent(in) :: pol
  type (conduction_wfns), intent(in) :: cwfn
  type (valence_wfns), intent(in) :: vwfn
  type (int_wavefunction), intent(out) :: intwfnv
  type (int_wavefunction), intent(out) :: intwfnc

  integer, allocatable :: isort(:)
  SCALAR, allocatable :: zc(:,:)

  character :: filename*20
  character :: filenamev*20
  integer :: ii,ig,ik,iiii,ib,is
  integer :: dest
  integer :: iwritecb
  integer :: iunit_v,iunit_c
  real(DP) :: qk(3)
  logical :: dont_read
  
  type(gspace) :: gvec_kpt
  type(progress_info) :: prog_info !< a user-friendly progress report

  PUSH_SUB(read_wavefunctions)
  
!------------------------------------
! Loop over kpoints and read in wavefunctions

! JRD: have proc 0 open unit (iunit_v) with name 'INT_VWFN'

  if (pol%iwriteint .eq. 0) then !COMM_DISK
    if(peinf%inode.eq.0) then
      write(filenamev,'(a)') 'INT_VWFN'
      iunit_v=200028
      call open_file(iunit_v,file=filenamev,form='unformatted',status='replace')
    endif
        
    if(peinf%inode.lt.10000) then
      write(filename,'(a,i4.4)') 'INT_CWFN_', peinf%inode
    else
      call die('too many nodes required')
    endif
    iunit_c=100028+peinf%inode
    call open_file(iunit_c,file=filename,form='unformatted',status='replace')
  else !COMM_MPI
    SAFE_ALLOCATE(intwfnv%ng, (kp%nrk))
    SAFE_ALLOCATE(intwfnv%isort, (kp%ngkmax,kp%nrk))
    SAFE_ALLOCATE(intwfnv%cg, (kp%ngkmax,kp%nrk*peinf%nvownactual,kp%nspin*kp%nspinor))
    SAFE_ALLOCATE(intwfnv%qk, (3,kp%nrk))
    SAFE_ALLOCATE(intwfnc%ng, (kp%nrk))
    SAFE_ALLOCATE(intwfnc%isort, (kp%ngkmax,kp%nrk))
    SAFE_ALLOCATE(intwfnc%cg, (kp%ngkmax,kp%nrk*peinf%ncownactual,kp%nspin*kp%nspinor))
    SAFE_ALLOCATE(intwfnc%cbi, (kp%nrk*peinf%ncownactual))
    SAFE_ALLOCATE(intwfnc%qk, (3,kp%nrk))
  endif

!----------------------------------------------------------------------------
! Beginning k-point loop

  call progress_init(prog_info, 'reading wavefunctions (WFN)', 'state', kp%nrk*cwfn%nband)
  do ik=1,kp%nrk
    qk(:)=kp%rk(:,ik)

! For each G-vector read, tries to find its match in gvec%components(:,:).
! If not found, aborts.  Otherwise stores its index in isort(i)
! where ik is the current k-point we are considering (loop we are in)
! and i is the index of the kx,ky,kz just read.

    SAFE_ALLOCATE(gvec_kpt%components, (3, kp%ngk(ik)))
    
    call read_binary_gvectors(25, kp%ngk(ik), kp%ngk(ik), gvec_kpt%components)
    
    SAFE_ALLOCATE(isort, (kp%ngk(ik)))
    do ig = 1, kp%ngk(ik)
      call findvector(isort(ig), gvec_kpt%components(:, ig), gvec)
      if (isort(ig) ==  0)  call die('input: could not find gvec')
    enddo
    SAFE_DEALLOCATE_P(gvec_kpt%components)

! JRD: 0 proc write kp%ngk, isort, kp%el, and qk to unit iunit_v
! for current (ik-th) k-point and valence wave functions.

    if (pol%iwriteint .eq. 0) then !COMM_DISK
      if (peinf%inode.eq.0) then
        write(iunit_v) kp%ngk(ik), (isort(ig),ig=1,kp%ngk(ik)), &
          ((kp%el(ib,ik,is),ib=1,(vwfn%nband+pol%ncrit)), &
          is=1,kp%nspin),(qk(ii),ii=1,3)
      endif
    else !COMM_MPI
      intwfnv%ng(ik)=kp%ngk(ik)
      intwfnv%isort(1:kp%ngk(ik),ik)=isort(1:kp%ngk(ik))
!            write(6,*) 'Input Vband', ik, qk(:)
      intwfnv%qk(:,ik)=qk(:)
!            write(6,*) 'Input Vband2', ik, intwfnv%qk(:,ik)
    endif

! SIB: each proc writes to unit iunit_c qk, kp%el, kp%ngk(ik), and isort
! for current kpoint (ik) and all bands.
        
    if (pol%iwriteint .eq. 0) then !COMM_DISK
      write(iunit_c) (qk(ii),ii=1,3), &
        ((kp%el(ib,ik,is),ib=1,cwfn%nband),is=1,kp%nspin), &
        kp%ngk(ik),(isort(ig),ig=1,kp%ngk(ik))
    else !COMM_MPI
      intwfnc%ng(ik)=kp%ngk(ik)
      intwfnc%isort(1:kp%ngk(ik),ik)=isort(1:kp%ngk(ik))
      intwfnc%qk(:,ik)=qk(:)
    endif

! SIB: loop over i for kp%mnbands (number of bands) and do the following:
!   - reads the info from unit=25 and checks norm of wavefunction.
!   - if a valence band, proc 0 writes it to unit iunit_v
!   - if a conduction band, then it is sent to/received by the correct
!     destination node (which is proc # i-nvalence-1 mod npes)
!   - the destination processor then writes the data to unit iunit_c

    SAFE_ALLOCATE(zc, (kp%ngk(ik), kp%nspinor*kp%nspin))
    do ib=1,kp%mnband

! JRD: Dumb debugging
#ifdef VERBOSE
      if (peinf%inode .eq. 0) write(6,'("Reading Wavefunction: ik = ",i6," n = ",i6)') ik, ib
#endif

      dont_read = (ib > cwfn%nband)
      call read_binary_data(25, kp%ngk(ik), kp%ngk(ik), kp%nspin*kp%nspinor, zc, dont_read = dont_read)

      ! FHJ: the following lines were introduced in r6294 and are supposed to
      ! be a shortcut if we are past the last band of the last k-point. However,
      ! in light of a previous bug (#223), this feature is commented out for now.
      !! FHJ: shortcut if this is past the last band of the last k-point
      !if (dont_read .and. ik==kp%nrk) exit
      !if (dont_read) cycle
      if(ib > cwfn%nband) cycle
      call progress_step(prog_info)

      if(peinf%inode == 0) then
        do is = 1, kp%nspin
          call checknorm('WFN',ib,ik,kp%ngk(ik),is,kp%nspinor,zc(:,:))
        enddo
      endif

      if(cwfn%band_index(ib).le.vwfn%nband) then
        
! Write to valence file

            
        if (pol%iwriteint .eq. 0) then !COMM_DISK
          if(peinf%inode .eq. 0 ) then
            write(iunit_v) ((zc(ig,is),ig=1,kp%ngk(ik)),is=1,kp%nspinor*kp%nspin)
          endif
        else !COMM_MPI
          if (peinf%doiownv(cwfn%band_index(ib))) then 
            iiii=peinf%indexv(cwfn%band_index(ib))+(ik-1)*peinf%nvownactual
            intwfnv%cg(1:kp%ngk(ik),iiii,1:kp%nspin*kp%nspinor)=zc(1:kp%ngk(ik),1:kp%nspinor*kp%nspin)
          endif
        endif
        
      else
            
! JRD/JBN: For Metals

        if(cwfn%band_index(ib).le.vwfn%nband+pol%ncrit) then
          if (pol%iwriteint .eq. 0) then !COMM_DISK
            if(peinf%inode.eq.0) then
              write(iunit_v) ((zc(ig,is),ig=1,kp%ngk(ik)),is=1,kp%nspinor*kp%nspin)
            endif
          else !COMM_MPI
            if (peinf%doiownv(cwfn%band_index(ib))) then 
              iiii=peinf%indexv(cwfn%band_index(ib))+(ik-1)*peinf%nvownactual
              intwfnv%cg(1:kp%ngk(ik),iiii,1:kp%nspin*kp%nspinor)=zc(1:kp%ngk(ik),1:kp%nspinor*kp%nspin)
            endif
          endif
        endif

! Write to conduction file

        iwritecb=0
        dest=cwfn%band_index(ib)-vwfn%nband
        if (peinf%doiownc(dest)) then
          iwritecb=1
        endif
        
        if(iwritecb .eq. 1) then
          if (pol%iwriteint .eq. 0) then !COMM_DISK
            write(iunit_c) cwfn%band_index(ib)-vwfn%nband,kp%ngk(ik),((zc(ig,is),ig=1,kp%ngk(ik)),is=1,kp%nspinor*kp%nspin)
          else !COMM_MPI
            iiii=peinf%indexc(ib-vwfn%nband)+(ik-1)*peinf%ncownactual
!                if (peinf%inode .eq. 0) write(6,*) 'Cond Band: ',iiii,peinf%ciown(i-vwfn%nband) 
            intwfnc%cbi(iiii)=cwfn%band_index(ib)-vwfn%nband
            intwfnc%cg(1:kp%ngk(ik),iiii,1:kp%nspin*kp%nspinor)=zc(1:kp%ngk(ik),1:kp%nspinor*kp%nspin)
!                if (peinf%inode .eq. 0) write(6,*) 'Cond Band Finished' 
          endif
        endif
      endif
    enddo  ! of loop i over kp%mnbands
    
    SAFE_DEALLOCATE(isort)
    SAFE_DEALLOCATE(zc)
    
  enddo ! of loop over k-points
  call progress_free(prog_info)

  if(peinf%inode.eq.0) then
    if (pol%iwriteint .eq. 0) call close_file(iunit_v)
  endif
  if (pol%iwriteint .eq. 0) call close_file(iunit_c)
  
  POP_SUB(read_wavefunctions)
  return
end subroutine read_wavefunctions

end module input_m

!==============================================================================
!
! Routines:
!
! (1) mtxel_t()         Originally By MLT       Last Modified 02/13/2013 (FHJ)
!
!     Calculated matrix elements needed for interpolation of kernel (dcn,dvn)
!
!     input: gvec, wfnc_co, wfnc_fi, wfnv_co, wfnvq_fi types
!            igumk        index of umklapp, translation, vector
!            ikpt         index of the current k-point
!
!     output: dcc, dvv     transformation matrices between a k-point in the
!                          fine grid and one in the coarse grid
!
!==============================================================================

#include "f_defs.h"

module mtxel_t_m

  use global_m

  implicit none

  public :: mtxel_t

  private

contains

  !> Calculates the transformation matrix between the coarse and fine
  !! wavefunction. Can use full or restricted transformation, where restricted
  !! means cond states are expanded in terms of other cond. states, etc.
  !! TODO: this whole function can be BLAS-ified
  subroutine mtxel_t(gvec,wfnc_co,wfnc_fi,wfnv_co,wfnvq_fi,dcn,dvn,igumk,igumkq,restricted)
    type (gspace), intent(in) :: gvec
    type (wavefunction), intent(in) :: wfnc_co,wfnc_fi,wfnv_co,wfnvq_fi
    !> Restricted: (wfnc_fi%nband, wfnc_co%nband, wfnc_fi%nspin)
    !! Unrestric.: (wfnc_fi%nband, wfnc_co%nband+wfnv_co%nband, wfnc_fi%nspin)
    SCALAR, intent(inout), target :: dcn(:,:,:)
    !> Restricted: (wfnvq_fi%nband, wfnv_co%nband, wfnc_fi%nspin)
    !! Unrestric.: (wfnvq_fi%nband, wfnv_co%nband+wfnc_co%nband, wfnc_fi%nspin)
    SCALAR, intent(inout), target :: dvn(:,:,:)
    integer, intent(in) :: igumk,igumkq
    logical, intent(in) :: restricted

    integer :: ig,ig_co
    integer, allocatable :: isorti(:), isortiq(:)
    SCALAR, pointer :: dmm(:,:,:)
    
    PUSH_SUB(mtxel_t)
    
    dcn(:,:,:)=ZERO
    dvn(:,:,:)=ZERO
    
    ! Compute inverse array to wfnc_co%isort
    
    SAFE_ALLOCATE(isorti, (gvec%ng))
    isorti=0
    do ig=1,gvec%ng
      isorti(wfnc_co%isort(ig))=ig
    enddo
    
    SAFE_ALLOCATE(isortiq, (gvec%ng))
    isortiq=0
    do ig=1,gvec%ng
      isortiq(wfnv_co%isort(ig))=ig
    enddo
    
    ! Loop over G-vectors
    ! Compute matrix element <c_co,k_co|exp(i(k_co-k_fi).r)|c_fi,k_fi>
    
    ! fine grid = valence
    ! v_fi <- v_co
    dmm => dvn(:,:wfnv_co%nband,:)
    do ig=1,wfnvq_fi%ng
      call map_ig(gvec, ig, ig_co, igumkq, isortiq, wfnvq_fi, wfnv_co)
      if (ig_co==0) cycle
      call mtxel_dmm(ig, ig_co, wfnvq_fi%nspinor, wfnvq_fi, wfnv_co, dmm)
    enddo
    if (.not.restricted) then
      ! v_fi <- c_co
      dmm => dvn(:,wfnv_co%nband+1:,:)
      do ig=1,wfnvq_fi%ng
        call map_ig(gvec, ig, ig_co, igumkq, isortiq, wfnvq_fi, wfnc_co)
        if (ig_co==0) cycle
        call mtxel_dmm(ig, ig_co, wfnvq_fi%nspinor, wfnvq_fi, wfnc_co, dmm)
      enddo
    endif
    
    ! fine grid = conduction
    if (restricted) then
      ! c_fi <- c_co
      dmm => dcn(:,:,:)
      do ig=1,wfnc_fi%ng
        call map_ig(gvec, ig, ig_co, igumk, isorti, wfnc_fi, wfnc_co)
        if (ig_co==0) cycle
        call mtxel_dmm(ig, ig_co, wfnc_fi%nspinor, wfnc_fi, wfnc_co, dmm)
      enddo
    else
      ! c_fi <- c_co
      dmm => dcn(:,wfnv_co%nband+1:,:)
      do ig=1,wfnc_fi%ng
        call map_ig(gvec, ig, ig_co, igumk, isorti, wfnc_fi, wfnc_co)
        if (ig_co==0) cycle
        call mtxel_dmm(ig, ig_co, wfnc_fi%nspinor, wfnc_fi, wfnc_co, dmm)
      enddo
      ! c_fi <- v_co
      dmm => dcn(:,:wfnv_co%nband,:)
      do ig=1,wfnc_fi%ng
        call map_ig(gvec, ig, ig_co, igumk, isorti, wfnc_fi, wfnv_co)
        if (ig_co==0) cycle
        call mtxel_dmm(ig, ig_co, wfnc_fi%nspinor, wfnc_fi, wfnv_co, dmm)
      enddo
    endif
    
    SAFE_DEALLOCATE(isorti)
    SAFE_DEALLOCATE(isortiq)
    
    POP_SUB(mtxel_t)
    
    return
    
  end subroutine mtxel_t


  !> Maps the G vector (ig) from a fine WFN to the coarse one, 
  !! including umklapp. Resulting index is saved to ig_co (0 if invalid)
  subroutine map_ig(gvec, ig, ig_co, ig_umklapp, isorti_co, wfn_fi, wfn_co)
    type(gspace), intent(in) :: gvec
    integer, intent(in) :: ig
    integer, intent(out) :: ig_co
    integer, intent(in) :: ig_umklapp
    integer, intent(in) :: isorti_co(:)
    type(wavefunction), intent(in) :: wfn_fi, wfn_co
    
    integer :: igadd, igaddn, kn(3), kaddn
    
    ! no push/pop, called too frequently
    ig_co = 0
    if (ig_umklapp==1) then
      ig_co = isorti_co(wfn_fi%isort(ig))
    else
      igadd = wfn_fi%isort(ig)
      
      ! Compute address of gn=g+gumk:
      ! If the result is beyond planewaves included in wavefunction, skip
      kn(1:3) = gvec%components(1:3,igadd) + &
        gvec%components(1:3,ig_umklapp) + gvec%FFTgrid(1:3)/2 + 1
      if (any(kn(1:3) < 1) .or. any(kn(1:3) > gvec%FFTgrid(1:3))) then
        ig_co = 0
        return
      endif
      kaddn = ((kn(1) - 1)*gvec%FFTgrid(2) + kn(2) - 1)*gvec%FFTgrid(3) + kn(3)
      igaddn = gvec%index_vec(kaddn) ! relate the cube to the sphere
      ig_co = isorti_co(igaddn)
    endif
    if (ig_co > wfn_co%ng) ig_co = 0
    
  end subroutine map_ig
  
  
  !> Calculates the overlap between the coarse and fine wavefunction, store
  !! info the dmm transformation matrix. Assumes you know the mapping between
  !! the the fine g-vector ig and the coarse ig_co
  subroutine mtxel_dmm(ig, ig_co, nspinor, wfn_fi, wfn_co, dmm)
    integer, intent(in) :: ig, ig_co
    integer, intent(in) :: nspinor
    type(wavefunction), intent(in) :: wfn_fi, wfn_co
    SCALAR, intent(inout) :: dmm(:,:,:) !< (wfn_fi%nband, wfn_co%nband, nspin)
    
    integer :: im_fi, im_co, is, ispinor
    
    ! no push/pop, called too frequently
    
    do is=1,wfn_co%nspin
      do im_co=1,wfn_co%nband
        do im_fi=1,wfn_fi%nband
          do ispinor=1,nspinor
            dmm(im_fi, im_co, is) = dmm(im_fi, im_co, is) + &
              wfn_fi%cg(ig, im_fi, is*ispinor) * MYCONJG(wfn_co%cg(ig_co, im_co, is*ispinor))
          enddo
        enddo
      enddo
    enddo
    
  end subroutine mtxel_dmm

end module mtxel_t_m

!===============================================================================
!
! Routines:
!
! (1) epsmodel()        Originally By MLT               Last Modified 7/3/2008 (JRD)
!
!     Model dielectric function for GaAs
!     see G. Cappellini et al, PRB 47, 9892 (1993)
!
! (2) epsmodel_pac()    Orignally By MLT                Last Modified 7/3/2008 (JRD)
!
!     Model dielectric function for polyacetylene
!     see B. Wenzien et al, PRB 51, 14701 (1995)
!     omega_plasma = 2.0 (actual value)
!     q_ThomasFermi = 1.0
!     epsp : dielectric constant perpendicular to chain
!     epsc : dielectric constant along chain
!
! (3) epsmodel_cnt()    Orignally By Li Yang            Last Modified 7/3/2008 (JRD)
!
!     Model dielectric function for carbon nanotube
!     zcut=inf, rho=15.11, grid 1x1x64
!
!  These routines are not used in current version of the code.
!  Calculated dielectric function from Epsilon is used instead.
!
!===============================================================================

#include "f_defs.h"

module epsmodel_m

  use global_m
  implicit none

  public ::       &
    epsmodel,     &
    epsmodel_pac, &
    epsmodel_cnt

contains

subroutine epsmodel(bdot,fq,epsinv)
  real(DP), intent(in) :: bdot(3,3),fq(3)
  real(DP), intent(out) :: epsinv

  real(DP) :: eps0,alpha,beta,q2

  PUSH_SUB(epsmodel)

  q2= DOT_PRODUCT(fq,MATMUL(bdot,fq))
!      eps0 = 0.0747
!      alpha = 1.37
!      beta = 0.76
  eps0 = 0.0971
  alpha = 1.261
  beta = 0.67
  epsinv = 1.d0/(1.d0 + 1.d0/(eps0 + alpha*q2 + beta*q2*q2))

  POP_SUB(epsmodel)

  return
end subroutine epsmodel


!==============================================================================
subroutine epsmodel_pac(bdot,fq,epsinv)
  real(DP), intent(in) :: bdot(3,3),fq(3)
  real(DP), intent(out) :: epsinv
  ! epsinv was complex originally, but the calc here seems to give always a real result

  integer :: jj
  real(DP) :: epsp,epsc,alphac,alphap,sum,qc,qp,cost2,sint2,qq

  PUSH_SUB(epsmodel_pac)

  epsp=3.7
  epsc=20.0
  alphac=8.0
  alphap=1.0
  
  qq= sqrt( DOT_PRODUCT(fq,MATMUL(bdot,fq)) )
  if (abs(qq).lt.1.d-5) then
    epsinv=0.05
  else
    sum=0.0
    do jj=1,3
      sum = sum + fq(jj)*bdot(jj,3)
    enddo
    qc=sum/sqrt(bdot(3,3))
    qp=sqrt(abs(qq**2 - qc**2))
    cost2=(qc/qq)**2
    sint2=(qp/qq)**2
    epsinv = cost2/(1.d0+1.d0/(1.d0/(epsc-1)+alphac*qc*qc+ &
      qq**4/8.d0)) + sint2/(1.d0+1.d0/(1.d0/(epsp-1d0)+ &
      alphap*qp*qp+qq**4/8.d0))
  endif
  
  POP_SUB(epsmodel_pac)
  
  return
end subroutine epsmodel_pac


!==============================================================================
subroutine epsmodel_cnt(diff,epsinv)
  real(DP), intent(in) :: diff(3)
  real(DP), intent(out) :: epsinv

  real(DP) :: a0,a1,a2,x,length2,qz2,qp2,epsz,epsp,v
  
  PUSH_SUB(epsmodel_cnt)
  
  a0 = -248.187d0
  a1 = 921.851d0
  a2 = 347.231d0
  
  x=abs(diff(3))
  
  if(x.lt.1.0d-15) then
    epsinv=1.d0
  else
    epsinv = (1+a2*x*x)/(1+a0*x*x*log(x*0.7889*15.11)+a1*x*x)
  endif
  
  POP_SUB(epsmodel_cnt)
  
  return
end subroutine epsmodel_cnt

end module epsmodel_m

!===============================================================================
!
! Routines:
!
! (1) input()   Originally By ?         Last Modified 10/5/2009 (gsm)
!
! Sets up various data structures. Reads in and distributes wavefunctions.
! Stores wavefunctions on disk in temporary INT_CWFN_* and INT_WFNK_* files
! (comm_disk) or in structures distributed in memory (comm_mpi).
!
!===============================================================================

#include "f_defs.h"

subroutine input(crys,gvec,syms,kp,wpg,sig,wfnk,iunit_c,iunit_k,fnc,fnk,wfnkqmpi,wfnkmpi)

  use global_m
  use checkbz_m
  use createpools_m
  use eqpcor_m
  use fftw_m
  use fullbz_m
  use input_utils_m
  use misc_m
  use read_rho_vxc_m
  use scissors_m
  use sort_m
  use wfn_rho_vxc_io_m
  use io_utils_m
  use epsread_hdf5_m
#ifdef HDF5
  use hdf5
#endif
  implicit none

  type (crystal), intent(out) :: crys
  type (gspace), intent(out) :: gvec
  type (symmetry), intent(out) :: syms
  type (kpoints), intent(out) :: kp
  type (wpgen), intent(out) :: wpg
  type (siginfo), intent(out) :: sig
  type (wfnkstates), intent(out) :: wfnk
  integer, intent(in) :: iunit_c, iunit_k
  character*20, intent(in) :: fnc, fnk
  type (wfnkqmpiinfo), intent(out) :: wfnkqmpi
  type (wfnkmpiinfo), intent(out) :: wfnkmpi

  character :: fncor*32, tmpfn*16
  character :: tmpstr*100,tmpstr1*16,tmpstr2*16
  character :: filenameh5*80
  integer :: i,ierr,ii,j,jj,k,kk
  integer :: ikn,irk
  integer :: istore,nstore,inum,g1,g2,iknstore
  integer :: nq,ndvmax,ndvmax_l
  integer :: ncoul,ncoulb,ncouls,nmtx,nmtx_l,nmtx_col
  integer, allocatable :: isort(:),isrt(:),isrti(:)
  integer :: ipe
  integer :: Nrod,Nplane,Nfft(3),dNfft(3),dkmax(3),nmpinode
  integer :: ntband,npools,ndiag_max,noffdiag_max,ntband_max
  real(DP) :: scalarsize,qk(3),vcell,qtot,omega_plasma,rhog0
  real(DP) :: mem,fmem,rmem,rmem2,scale,dscale
  SCALAR, allocatable :: zc(:,:)
  integer, allocatable :: gvecktmp(:,:)
  logical :: do_ch_sum, dont_read, skip_checkbz
  type(grid) :: gr

  character(len=3) :: sheader
  integer :: iflavor, error
  type(gspace) :: gvec_kpt

  integer :: ngarbage1, ngarbage2, ngarbage4, ngarbage3(3)
  real(DP) :: dgarbage1

  logical :: file_exists
  type(progress_info) :: prog_info !< a user-friendly progress report

  PUSH_SUB(input)

!---------------
! Read sigma.inp

  call inread(sig)

!------------------------
! Initialize HDF5

#ifdef HDF5

  if(sig%use_hdf5) call h5open_f(error)

#endif

  if(sig%nkn .lt. 1) then
    if(peinf%inode.eq.0) write(0,*) 'sig%nkn < 1'
    call die('sig%nkn')
  endif
  
!---------------------------------
! Determine the available memory

  call procmem(mem,nmpinode)

  if(peinf%inode.eq.0) then
    write(6,998) mem/1024.0d0**2
    write(7,998) mem/1024.0d0**2
  endif
998 format(1x,'Memory available:',f10.1,1x,'MB per PE')
  
  fmem=mem/8.0d0

!-------------------------------
! (gsm) Estimate the required memory

  if(peinf%inode.eq.0) then

! determine number of frequencies and number of q-points
    if (sig%freq_dep.eq.-1) then
      nq=sig%nq
      sig%nFreq=1
    endif

    if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1.or.sig%freq_dep.eq.2.or.sig%freq_dep.eq.3) then

#ifdef HDF5
      if(sig%use_hdf5) then
        filenameh5 = 'eps0mat.h5'
        call read_eps_grid_sizes_hdf5(ngarbage1,ngarbage2,dgarbage1,sig%nFreq,ngarbage4,ngarbage3,filenameh5)  

        ! FIXME: if these values are garbage why tell the user?
        ! or, if they are not garbage, give them a proper name!
        write(6,*) 'Read from eps0mat.h5',ngarbage1,ngarbage2,dgarbage1,sig%nFreq,ngarbage4,ngarbage3

        INQUIRE(FILE="epsmat.h5", EXIST=file_exists)
        if ( file_exists ) then
          filenameh5 = 'epsmat.h5 '
          call read_eps_grid_sizes_hdf5(ngarbage1,nq,dgarbage1,ngarbage2,ngarbage4,ngarbage3,filenameh5)  
          nq = nq + 1
        else
          nq = 1
        endif
      else
#endif

        call open_file(10,file='eps0mat',form='unformatted',status='old')
        read(10)
        read(10)i,sig%nFreq
        call close_file(10)
        call open_file(11,file='epsmat',form='unformatted',status='old',iostat=ierr)
        if (ierr.eq.0) then
          read(11)
          read(11)
          read(11)
          read(11)
          read(11)
          read(11)
          read(11)
          read(11) nq
          nq=nq+1
          call close_file(11)
        else
          nq=1
        endif

#ifdef HDF5
    endif
#endif

    endif

  endif

! read wavefunction parameters
  if(peinf%inode == 0) call open_file(25,file='WFN_inner',form='unformatted',status='old')

  sheader = 'WFN'
  iflavor = 0
  call read_binary_header_type(25, sheader, iflavor, kp, gvec, syms, crys)
  call check_trunc_kpts(sig%icutv, kp)

  if(sig%ntband > kp%mnband) then
    call die("number_bands is larger than are available in WFN_inner", only_root_writes = .true.)
  endif

  kp%el(:,:,:) = kp%el(:,:,:) - sig%avgpot / ryd

  if(peinf%inode == 0) call logit('Reading WFN_inner -- gvec info')
  SAFE_ALLOCATE(gvec%components, (3, gvec%ng))
  call read_binary_gvectors(25, gvec%ng, gvec%ng, gvec%components)

!-----------------------
! sort G-vectors with respect to their kinetic energy
  SAFE_ALLOCATE(isrt, (gvec%ng))
  SAFE_ALLOCATE(isrti, (gvec%ng))
  SAFE_ALLOCATE(gvec%ekin, (gvec%ng))
  call kinetic_energies(gvec, crys%bdot, gvec%ekin)
  call sortrx(gvec%ng, gvec%ekin, isrt, gvec = gvec%components)
  ! FIXME: the same exact thing is done in sigma_main a second time!
  ncouls = gcutoff(gvec%ng, gvec%ekin, isrt, sig%ecuts)
  ncoulb = gcutoff(gvec%ng, gvec%ekin, isrt, sig%ecutb)
  SAFE_DEALLOCATE_P(gvec%ekin)
    
  SAFE_ALLOCATE(gvecktmp, (3,gvec%ng))
  gvecktmp(:,:)=gvec%components(:,:)
  do i=1,gvec%ng
    gvec%components(:,i)=gvecktmp(:,isrt(i))
    isrti(isrt(i)) = i
  enddo
  SAFE_DEALLOCATE(gvecktmp)
    
  SAFE_ALLOCATE(isort, (gvec%ng))

  call gvec_index(gvec)
    
! estimate for nmtx

  if(peinf%inode == 0) then
    ncoul=max(ncouls,ncoulb)
    nmtx=ncouls

! divide bands over processors (this is repeated below)
    ntband=min(sig%ntband,kp%mnband)
    if (peinf%npools .le. 0 .or. peinf%npools .gt. peinf%npes) then
      call createpools(sig%ndiag,ntband,peinf%npes,npools,ndiag_max,ntband_max)
    else
      npools = peinf%npools
      if (mod(sig%ndiag,npools).eq.0) then
        ndiag_max=sig%ndiag/npools
      else
        ndiag_max=sig%ndiag/npools+1
      endif
      if (mod(ntband,peinf%npes/npools).eq.0) then
        ntband_max=ntband/(peinf%npes/npools)
      else
        ntband_max=ntband/(peinf%npes/npools)+1
      endif
    endif
    if (sig%noffdiag.gt.0) then
      if (mod(sig%noffdiag,npools).eq.0) then
        noffdiag_max=sig%noffdiag/npools
      else
        noffdiag_max=sig%noffdiag/npools+1
      endif
    endif

    nmtx_l=int(sqrt(dble(nmtx)**2/dble(peinf%npes/npools)))
    nmtx_col=int(dble(nmtx)/dble(peinf%npes/npools))+1

    scalarsize = sizeof_scalar()

! required memory
    rmem=0.0d0
! arrays eps and epstemp in program main
    if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1) then
      rmem=rmem+(dble(nmtx_l)**2+dble(nmtx))*scalarsize
      rmem=rmem+(dble(nmtx_col)*nmtx)*scalarsize
    endif
! wtilde_array, imagloop_ig, imaginary_flag in mtxel_sxch
    if (sig%freq_dep.eq.1) then
      rmem=rmem+(dble(nmtx_col)*nmtx)*16
      rmem=rmem+(dble(nmtx_col)*nmtx)*4
      rmem=rmem+(dble(nmtx_col)*nmtx)*1
    endif
! arrays epsR, epsRtemp, epsA, and epsAtemp in program main
    if (sig%freq_dep.eq.2 .or.sig%freq_dep.eq.3) then
      rmem=rmem+(dble(nmtx_l)**2+dble(nmtx)) &
        *dble(sig%nFreq)*2.0d0*scalarsize
    endif
    if (sig%iwriteint .eq. 1) then
! array epsmpi%eps in subroutine epscopy
      if (sig%freq_dep.eq.0.or.sig%freq_dep.eq.1) then
        rmem=rmem+(dble(nmtx_col)*nmtx)*dble(nq)*scalarsize
      endif
! arrays epsmpi%epsR and epsmpi%epsA in subroutine epscopy
      if (sig%freq_dep.eq.2 .or.sig%freq_dep.eq.3) then
        rmem=rmem+(nmtx_col*nmtx)*dble(nq) &
          *dble(sig%nFreq)*2.0d0*scalarsize
      endif
    endif
! array aqs in program main
    rmem=rmem+dble(ntband_max)*dble(ncoul)*scalarsize
! array aqsaug in program main
    if (sig%noffdiag.gt.0) then
      rmem=rmem+dble(ntband_max)*dble(ncoul) &
        *dble(sig%ndiag)*dble(sig%nspin)*scalarsize
    endif
! array aqsch in program main
    if (sig%exact_ch.eq.1) then
      rmem=rmem+dble(ncoul)*scalarsize
    endif
! arrays aqsaugchd and aqsaugcho in program main
    if (sig%exact_ch.eq.1.and.nq.gt.1) then
      rmem=rmem+dble(ncoul)*dble(ndiag_max) &
        *dble(sig%nspin)*scalarsize
      if (sig%noffdiag.gt.0) then
        rmem=rmem+dble(ncoul)*dble(noffdiag_max)* &
          dble(sig%nspin)*scalarsize
      endif
    endif
! array wfnk%zk in subroutine input
    rmem=rmem+dble(ndiag_max)*dble(kp%ngkmax)* &
      dble(sig%nspin*kp%nspinor)*scalarsize
! array wfnkq%zkq in subroutine genwf
    rmem=rmem+dble(ntband_max)*dble(kp%ngkmax) &
      *dble(sig%nspin*kp%nspinor)*scalarsize
! arrays zc in subroutine input and zin in subroutine genwf
    rmem=rmem+dble(kp%ngkmax)*dble(kp%nspin*kp%nspinor)*scalarsize
! array wfnkoff%zk in program main and subroutines mtxel_vxc and mtxel_sxch
    if ((sig%exact_ch.eq.1.and.sig%noffdiag.gt.0).or. &
      (.not.sig%use_vxcdat)) then
      rmem=rmem+2.0d0*dble(kp%ngkmax)*scalarsize
    endif
! array gvec%index_vec in input
    rmem=rmem+dble(gvec%nFFTgridpts)*4.0d0
! arrays fftbox1 and fftbox2 in subroutines mtxel and mtxel_ch
    call setup_FFT_sizes(gvec%FFTgrid,Nfft,scale)
    rmem=rmem+dble(Nfft(1)*Nfft(2)*Nfft(3))*32.0d0
    if (sig%iwriteint .eq. 1) then
! arrays wfnkqmpi%isort and wfnkqmpi%cg in subroutine input
      rmem=rmem+dble(kp%ngkmax)*dble(kp%nrk)*4.0d0+ &
        dble(kp%ngkmax)*dble(ntband_max)*dble(sig%nspin*kp%nspinor)* &
        dble(kp%nrk)*dble(scalarsize)
! arrays wfnkmpi%isort and wfnkmpi%cg in subroutine input
      rmem=rmem+dble(kp%ngkmax)*dble(sig%nkn)*4.0d0+ &
        dble((ndiag_max*kp%ngkmax)/(peinf%npes/npools))* &
        dble(sig%nspin*kp%nspinor)*dble(sig%nkn)* &
        dble(scalarsize)
    endif

989 format(1x,'Memory required for execution:',f7.1,1x,'MB per PE')
    write(6,989) rmem/1024.0d0**2
    write(7,989) rmem/1024.0d0**2

! random numbers
    rmem=0.0D0
    if (sig%icutv.ne.5) then
! arrays ran, qran, and qran2
! (ran is deallocated before qran2 is allocated)
      rmem=rmem+6.0D0*dble(nmc)*8.0D0
    endif
! various truncation schemes
    rmem2=0.0d0
! cell wire truncation
    if (sig%icutv.eq.4) then
      dkmax(1) = gvec%FFTgrid(1) * n_in_wire
      dkmax(2) = gvec%FFTgrid(2) * n_in_wire
      dkmax(3) = 1
      call setup_FFT_sizes(dkmax,dNfft,dscale)
! array fftbox_2D
      rmem2=rmem2+dble(dNfft(1))*dble(dNfft(2))*16.0d0
! array inv_indx
      rmem2=rmem2+dble(Nfft(1))*dble(Nfft(2))*dble(Nfft(3))* &
        4.0d0
! array qran
      rmem2=rmem2+3.0D0*dble(nmc)*8.0D0
    endif
! cell box truncation (parallel version only)
    if (sig%icutv.eq.5) then
      dkmax(1) = gvec%FFTgrid(1) * n_in_box
      dkmax(2) = gvec%FFTgrid(2) * n_in_box
      dkmax(3) = gvec%FFTgrid(3) * n_in_box
      call setup_FFT_sizes(dkmax,dNfft,dscale)
      if (mod(dNfft(3),peinf%npes) == 0) then
        Nplane = dNfft(3)/peinf%npes
      else
        Nplane = dNfft(3)/peinf%npes+1
      endif
      if (mod(dNfft(1)*dNfft(2),peinf%npes) == 0) then
        Nrod = (dNfft(1)*dNfft(2))/peinf%npes
      else
        Nrod = (dNfft(1)*dNfft(2))/peinf%npes+1
      endif
! array fftbox_2D
      rmem2=rmem2+dble(dNfft(1))*dble(dNfft(2))*dble(Nplane)* &
        16.0d0
! array fftbox_1D
      rmem2=rmem2+dble(dNfft(3))*dble(Nrod)*16.0d0
! array dummy
!          rmem2=rmem2+dble(dNfft(1))*dble(dNfft(2))*16.0d0
! arrays dummy1 and dummy2
      rmem2=rmem2+dble(Nrod)*dble(peinf%npes+1)*16.0d0
! array inv_indx
      rmem2=rmem2+dble(Nfft(1))*dble(Nfft(2))*dble(Nfft(3))* &
        4.0d0
    endif
    if (rmem2 .gt. rmem) rmem = rmem2
988 format(1x,'Memory required for vcoul:',f7.1,1x,'MB per PE')
    write(6,988) rmem/1024.0d0**2
    write(7,988) rmem/1024.0d0**2
    write(6,*)
    write(7,*)
  endif

  if(peinf%inode == 0) then
    write(7,'(1x,"Cell Volume =",e16.9,/)') crys%celvol

!----------------------------------------------
! Compute cell volume from wave number metric

    call get_volume(vcell,crys%bdot)
    if (abs(crys%celvol-vcell).gt.TOL_Small) then
      call die('volume mismatch')
    endif

! (gsm) check consistency of spin indices

    do k=1,sig%nspin
      if (sig%spin_index(k).lt.1.or.sig%spin_index(k).gt.kp%nspin) &
        call die('inconsistent spin indices')
    enddo

    if(sig%ntband.gt.kp%mnband) then
      write(tmpstr1,660) sig%ntband
      write(tmpstr2,660) kp%mnband
      write(0,666) TRUNC(tmpstr1), TRUNC(tmpstr2)
      call die('More bands specified in sigma.inp than available in WFN_inner.')
660   format(i16)
666   format(1x,'The total number of bands (',a,') specified in sigma.inp',/, &
        3x,'is larger than the number of bands (',a,') available in WFN_inner.',/)
    endif
    do_ch_sum = .not.((sig%freq_dep == -1) .or. (sig%freq_dep == 0 .and. sig%exact_ch == 1))
    if(sig%ntband.eq.kp%mnband) then
      call die("You must provide one more band in WFN_inner than used in sigma.inp number_bands in order to assess degeneracy.")
    endif

!--------------------------------------------------------------------
! SIB:  Find the k-points in sig%kpt in the list kp%rk (die if not found).
! sig%indkn holds the index of the k-points in sig%kpt in kp%rk, i.e.
! kp%rk(sig%indkn(ikn))=sig%kpt(ikn)

    SAFE_ALLOCATE(sig%indkn, (sig%nkn))
    do ikn=1,sig%nkn
      sig%indkn(ikn)=0
      qk(:)=sig%kpt(:,ikn)
      do irk=1,kp%nrk
        if(all(abs(kp%rk(1:3,irk)-qk(1:3)) .lt. TOL_Small)) sig%indkn(ikn)=irk
      enddo
      if(sig%indkn(ikn) .eq. 0) then
        write(0,'(a,3f10.5,a)') 'Could not find the k-point ', (qk(i),i=1,3), ' among those read from WFN_inner :'
        write(0,'(3f10.5)') ((kp%rk(i,irk),i=1,3),irk=1,kp%nrk)
        call die('k-point in sigma.inp k_points block not available.')
      endif
    enddo

    if(do_ch_sum) then
      if(any(abs(kp%el(sig%ntband, 1:kp%nrk, 1:kp%nspin) - kp%el(sig%ntband + 1, 1:kp%nrk, 1:kp%nspin)) .lt. sig%tol/RYD)) then
        if(sig%degeneracy_check_override) then
          write(0,'(a)') &
            "WARNING: Selected number of bands for CH sum (number_bands) breaks degenerate subspace. " // &
            "Run degeneracy_check.x for allowable numbers."
          write(0,*)
        else
          write(0,'(a)') &
            "Run degeneracy_check.x for allowable numbers, or use keyword " // &
            "degeneracy_check_override to run anyway (at your peril!)."
          call die("Selected number of bands for CH sum (number_bands) breaks degenerate subspace.")
        endif
      endif
    endif
  endif

!----------------------------------------------------------------
! Check consistency

  if (kp%mnband < maxval(sig%diag) .and. peinf%inode == 0) then
    write(0,*) 'The highest requested band is ', maxval(sig%diag),' but WFN_inner contains only ', kp%mnband,' bands.'
    call die('too few bands')
  endif
  
  SAFE_ALLOCATE(kp%elda, (sig%ntband,kp%nrk,kp%nspin))
  kp%elda(1:sig%ntband, 1:kp%nrk, 1:kp%nspin)=ryd*kp%el(1:sig%ntband, 1:kp%nrk, 1:kp%nspin)
  call scissors_shift(kp, sig%scis, sig%spl_tck)

!-----------------------------------------------------------------
! If quasi-particle corrections requested, read the corrected
! quasiparticle energies from file (in eV)

  if(sig%eqp_corrections) then
    fncor='eqp.dat'
    call eqpcor(fncor,peinf%inode,peinf%npes,kp,1,sig%ntband,0,0,kp%el,kp%el,kp%el,1,0)
    ! note: want in Ry since conversion occurs below
  endif

  ! qgridsym has no meaning when there is only one q-point (Gamma)
  ! setting this to false means warnings about its applicability will not be triggered
  if(all(abs(kp%rk(1:3,1:kp%nrk)) < TOL_Zero)) sig%qgridsym = .false.

  if(peinf%inode == 0) then
    call find_efermi(sig%rfermi, sig%efermi, sig%efermi_input, kp, sig%ntband, 1, &
      "unshifted grid", should_search = .true., should_update = .true., write7 = .true.)

    ! kp%el is still in Ry here, but sig%tol is in eV.
    call assess_degeneracies(kp, kp%el(sig%ntband + 1, :, :), sig%ntband, sig%efermi, sig%tol/RYD, sig = sig)

    call calc_qtot(kp, crys%celvol, sig%efermi, qtot, omega_plasma, write7 = .true.)
  endif

  if (peinf%inode.eq.0) call timacc(4,1)
  gr%nr = kp%nrk
  SAFE_ALLOCATE(gr%r, (3, gr%nr))
  gr%r = kp%rk
  call fullbz(crys,syms,gr,syms%ntran,skip_checkbz,wigner_seitz=.false.,paranoid=.true.)
  tmpfn='WFN_inner'
  if (.not. skip_checkbz) then
    call checkbz(gr%nf,gr%f,kp%kgrid,kp%shift,crys%bdot, &
      tmpfn,'k',.false.,sig%freplacebz,sig%fwritebz)
  endif
  call dealloc_grid(gr)
  if (peinf%inode.eq.0) call timacc(4,2)

  ! For discussion of how q-symmetry may (and may not) be used with degenerate states,
  ! see Hybertsen and Louie, Phys. Rev. B 35, 5585 (1987) Appendix A 
  if(sig%qgridsym .and. sig%noffdiag > 0) then
    if(peinf%inode == 0) then
      write(0,'(a)') "WARNING: Cannot calculate offdiagonal elements unless no_symmetries_q_grid is set."
      write(0,'(a)') "This flag is being reset to enable the calculation."
    endif
    sig%qgridsym = .false.
  endif

  if(peinf%inode == 0) then
    if(sig%qgridsym) then
      write(6,'(a)') ' q-grid symmetries are being used'
      write(7,'(a)') ' q-grid symmetries are being used'
    else
      write(6,'(a)') ' q-grid symmetries are not being used'
      write(7,'(a)') ' q-grid symmetries are not being used'
    endif
  endif

  kp%el(:,:,:)=kp%el(:,:,:)*ryd

 !----------------------------------------------------------------
 ! Distribute data

 #ifdef MPI
  call MPI_Bcast(sig%efermi, 1, MPI_REAL_DP,0, MPI_COMM_WORLD,mpierr)
  if(sig%qgridsym .or. sig%noffdiag > 0 .or. sig%ncrit > 0) then
    if(peinf%inode.ne.0) then
      SAFE_ALLOCATE(kp%degeneracy, (sig%ntband, kp%nrk, kp%nspin))
    endif
    call MPI_Bcast(kp%degeneracy(1,1,1), sig%ntband * kp%nrk * kp%nspin, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
  endif
   if(peinf%inode.ne.0) then
     SAFE_ALLOCATE(sig%indkn, (sig%nkn))
   endif
   call MPI_Bcast(sig%indkn, sig%nkn, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
#endif

!----------------------------------------------------------------
! CHP: Set the init_freq_eval relative to the Fermi energy in case
!      of full frequency. This part should NOT be put before the
!      Fermi energy is set.

  if (sig%freq_dep .eq. 2) then
    sig%freqevalmin = sig%freqevalmin + sig%efermi
  endif

!--------------------------------------------------------------------
! Read in the exchange-correlation potential and store in array vxc

  if(.not. sig%use_vxcdat) then

    call read_vxc(sig, gvec, kp, syms, crys, isrti, isrt, .false.)

  endif ! not using vxc.dat

  if(.not. sig%use_vxc2dat) then
    ! This is for hybrid functional like calculation (one shot)
    if (sig%freq_dep.eq.-1 .and. ((1.0d0 - sig%coulomb_mod%long_range_frac_fock > TOL_SMALL) .or. &
                  (1.0d0 - sig%coulomb_mod%short_range_frac_fock > TOL_SMALL)))  &
      call read_vxc(sig, gvec, kp, syms, crys, isrti, isrt, .true.)

  endif ! not using vxc2.dat

!--------------------------------------------------------------------
! Read in the charge density and store in array rho (formerly known as CD95)
! CD95 Ref: http://www.nature.com/nature/journal/v471/n7337/full/nature09897.html

  if(sig%freq_dep.eq.1) then
    call timacc(21,1)

    call read_rho(wpg, gvec, kp, syms, crys, isrti, isrt, 'WFN_inner')

    rhog0 = sum(wpg%nelec(1:kp%nspin))
    if(peinf%inode == 0 .and. abs(rhog0 - qtot) > TOL_Small) then
      write(0,'(a,g12.6,a,g12.6)') 'WARNING: RHO has total charge ', rhog0, ' but WFN_inner occupations give charge ', qtot
    endif

    call timacc(21,2)
  endif ! sig%freq_dep

!------------------------------------------------------------------------
! Divide bands over processors
!
! sig%ntband           number of total (valence and conduction) bands
! peinf%npools         number of parallel sigma calculations
! peinf%ndiag_max      maximum number of diag sigma calculations
! peinf%noffdiag_max   maximum number of offdiag sigma calculations
! peinf%ntband_max     maximum number of total bands per node
!
! ntband_node          number of total bands per current node
! nvband_node          number of valence bands per current node
! peinf%indext(itb)    indices of total bands belonging to current node
!
! peinf%index_diag     band index for diag sigma calculation
! peinf%flag_diag      flag for storing diag sigma calculation
! peinf%index_offdiag  band index for offdiag sigma calculation
! peinf%flag_offdiag   flag for storing offdiag sigma calculation
!
! flags are needed in case of uneven distribution, nodes still do the
! calculation because they share epsilon and wavefunctions and need to
! participate in global communications, but the result is not stored

  if (peinf%npools .le. 0 .or. peinf%npools .gt. peinf%npes) then
    call createpools(sig%ndiag,sig%ntband,peinf%npes,npools,ndiag_max,ntband_max)
    peinf%npools = npools
    peinf%ndiag_max = ndiag_max
    peinf%ntband_max = ntband_max
  else
    if (mod(sig%ndiag,peinf%npools).eq.0) then
      peinf%ndiag_max=sig%ndiag/peinf%npools
    else
      peinf%ndiag_max=sig%ndiag/peinf%npools+1
    endif
    
    if (mod(sig%ntband,peinf%npes/peinf%npools).eq.0) then
      peinf%ntband_max=sig%ntband/(peinf%npes/peinf%npools)
    else
      peinf%ntband_max=sig%ntband/(peinf%npes/peinf%npools)+1
    endif
  endif

! JRD Create Separate Comms for Each Pool

  peinf%npes_pool = peinf%npes/peinf%npools
  peinf%my_pool=peinf%inode/peinf%npes_pool
  peinf%pool_rank = mod(peinf%inode,peinf%npes_pool)

#ifdef MPI
!  call MPI_Comm_Group(MPI_COMM_WORLD,orig_group,mpierr)
!
!  SAFE_ALLOCATE(ranks,(peinf%npes))
!  do ii=1,peinf%npes
!    ranks(ii)=ii-1
!  enddo
!
!  if (peinf%my_pool .ne. -1) then
!    call MPI_Group_incl(orig_group, peinf%npes_pool, &
!      ranks(peinf%my_pool*peinf%npes_pool+1:(peinf%my_pool+1)*peinf%npes_pool), peinf%pool_group,mpierr)
!  else
!! We need a group to send comm_create below. If you are not in a legit pool, we just use the first group
!    call MPI_Group_incl(orig_group, peinf%npes_pool, &
!      ranks(0*peinf%npes_pool+1:(0+1)*peinf%npes_pool), peinf%pool_group,mpierr)
!  endif
!
!! All procs in original comm need to do this
!
!  call MPI_Comm_create(MPI_COMM_WORLD,peinf%pool_group,peinf%pool_comm,mpierr)

  call MPI_Comm_split(MPI_COMM_WORLD, peinf%my_pool, peinf%pool_rank, peinf%pool_comm, mpierr)

  if (peinf%my_pool .gt. (peinf%npools-1)) then
    peinf%my_pool = -1
  endif

!  !write(6,*) peinf%inode,"Created groups comms"

!  SAFE_DEALLOCATE(ranks)
#endif

  if (sig%noffdiag.gt.0) then
    if (mod(sig%noffdiag,peinf%npools).eq.0) then
      peinf%noffdiag_max=sig%noffdiag/peinf%npools
    else
      peinf%noffdiag_max=sig%noffdiag/peinf%npools+1
    endif
  endif

  SAFE_ALLOCATE(peinf%index_diag, (peinf%ndiag_max))
  SAFE_ALLOCATE(peinf%flag_diag, (peinf%ndiag_max))
  peinf%index_diag=1
  peinf%flag_diag=.false.
  do ii=1,peinf%ndiag_max*peinf%npools
    jj=(ii-1)/peinf%npools+1 ! which number in the pool it is
    kk=mod(ii-1,peinf%npools) ! which pool it is in
    if (peinf%inode/(peinf%npes/peinf%npools).eq.kk) then
      if (ii.le.sig%ndiag) then
        peinf%index_diag(jj)=ii
        peinf%flag_diag(jj)=.true.
      else
        peinf%index_diag(jj)=1
        peinf%flag_diag(jj)=.false.
      endif
    endif
  enddo

  if (sig%noffdiag.gt.0) then
    SAFE_ALLOCATE(peinf%index_offdiag, (peinf%noffdiag_max))
    SAFE_ALLOCATE(peinf%flag_offdiag, (peinf%noffdiag_max))
    peinf%index_offdiag=1
    peinf%flag_offdiag=.false.
    do ii=1,peinf%noffdiag_max*peinf%npools
      jj=(ii-1)/peinf%npools+1
      kk=mod(ii-1,peinf%npools)
      if (peinf%inode/(peinf%npes/peinf%npools).eq.kk) then
        if (ii.le.sig%noffdiag) then
          peinf%index_offdiag(jj)=ii
          peinf%flag_offdiag(jj)=.true.
        else
          peinf%index_offdiag(jj)=1
          peinf%flag_offdiag(jj)=.false.
        endif
      endif
    enddo
  endif
  
  SAFE_ALLOCATE(peinf%indext, (peinf%ntband_max))

!JRD Now is over procs per pool

  SAFE_ALLOCATE(peinf%indext_dist, (peinf%ntband_max,peinf%npes_pool))
  SAFE_ALLOCATE(peinf%ntband_dist, (peinf%npes_pool))
  
  peinf%ntband_node=0
  peinf%ntband_dist=0
  peinf%nvband_node=0
  peinf%indext=0
  peinf%indext_dist=0
  
  do ii=1,sig%ntband
      ! FHJ: The bands are assigned to the processors in a sequential fashion.
      ! This is more efficient for the parallel IO. Eg: for 2  bands/processor,
      ! v1->PE0, v2->PE0, v3->PE1, etc.
      ipe = (sig%band_index(ii)-1)/peinf%ntband_max
      if (peinf%pool_rank.eq.ipe) then
        peinf%ntband_node=peinf%ntband_node+1
        if(sig%band_index(ii).le.(sig%nvband+sig%ncrit)) then
          peinf%nvband_node=peinf%nvband_node+1
        endif
        peinf%indext(peinf%ntband_node)=sig%band_index(ii)
      endif
      peinf%ntband_dist(ipe+1)=peinf%ntband_dist(ipe+1)+1
      peinf%indext_dist(peinf%ntband_dist(ipe+1),ipe+1)=sig%band_index(ii)
  enddo
  
!------------------------------------------------------------------------
! Report distribution of bands over processors

  if (peinf%inode.eq.0) then
701 format(1x,i4,1x,'processor(s),',1x,i4,1x,'pool(s),',1x,i4,1x,'processor(s) per pool')
    write(6,701) peinf%npes, peinf%npools, &
      peinf%npes/peinf%npools
702 format(1x,'WARNING: distribution is not ideal,',1x,i4,1x,'processor(s) is/are idle')
    if (mod(peinf%npes,peinf%npools).ne.0) &
      write(0,702) peinf%npes-(peinf%npes/peinf%npools)* &
      peinf%npools
    if (mod(sig%ndiag,peinf%npools).eq.0) then
703 format(1x,'each pool is computing',1x,i4,1x,'diagonal sigma matrix element(s)')
      write(6,703) peinf%ndiag_max
    else
704 format(1x,'each pool is computing',1x,i4,1x,'to',1x,i4,1x,'diagonal sigma matrix element(s)')
      write(6,704) peinf%ndiag_max-1, peinf%ndiag_max
705 format(1x,'WARNING: distribution is not ideal, number of diagonal sigma',/,&
      1x,'matrix elements',1x,i4,1x,'should be divisible by number of pools',1x,i4)
      write(0,705) sig%ndiag, peinf%npools
    endif
    if (mod(sig%noffdiag,peinf%npools).eq.0) then
706 format(1x,'each pool is computing',1x,i4,1x,'off-diagonal sigma matrix element(s)')
      write(6,706) peinf%noffdiag_max
    else
707 format(1x,'each pool is computing',1x,i4,1x,'to',1x,i4,1x,'off-diagonal sigma matrix element(s)')
      write(6,707) peinf%noffdiag_max-1, peinf%noffdiag_max
708 format(1x,'WARNING: distribution is not ideal, number of off-diagonal sigma',/,&
      1x,'matrix elements',1x,i4,1x,'should be divisible by number of pools',1x,i4)
      write(0,708) sig%noffdiag, peinf%npools
    endif
    if (mod(sig%ntband,peinf%npes/peinf%npools).eq.0) then
709 format(1x,'each processor is holding',1x,i4,1x,'valence and conduction band(s)')
      write(6,709) peinf%ntband_max
    else
710 format(1x,'each pool is holding',1x,i4,1x,'to',1x,i4,1x,'valence and conduction band(s)')
      write(6,710) minval(peinf%ntband_dist), maxval(peinf%ntband_dist)
711 format(1x,'WARNING: distribution is not ideal, number of valence and conduction bands',/,&
      1x,i4,1x,'should be divisible by number of processors per pool',1x,i4)
      write(0,711) sig%ntband, peinf%npes/peinf%npools
    endif
    write(6,*)
  endif

!-----------------------------------------------------------
!
!     LOOP OVER K-POINT GRID AND READ IN WAVEFUNCTIONS
!
!-----------------------------------------------------------

!----------------------------------------
! Open temporary wavefunction files iunit_c and iunit_k

  if (sig%iwriteint .eq. 0) then
    call open_file(iunit_c,file=fnc,form='unformatted',status='replace')
    if (mod(peinf%inode,peinf%npes/peinf%npools).eq.0) then
      call open_file(iunit_k,file=fnk,form='unformatted',status='replace')
    endif
  else
    SAFE_ALLOCATE(wfnkqmpi%nkptotal, (kp%nrk))
    SAFE_ALLOCATE(wfnkqmpi%isort, (kp%ngkmax,kp%nrk))
    SAFE_ALLOCATE(wfnkqmpi%band_index, (peinf%ntband_max,kp%nrk))
    SAFE_ALLOCATE(wfnkqmpi%qk, (3,kp%nrk))
    SAFE_ALLOCATE(wfnkqmpi%el, (sig%ntband,sig%nspin,kp%nrk))
    SAFE_ALLOCATE(wfnkqmpi%cg, (kp%ngkmax,peinf%ntband_max,sig%nspin*kp%nspinor,kp%nrk))
    if (sig%nkn.gt.1) then
      ndvmax=peinf%ndiag_max*kp%ngkmax
      if (mod(ndvmax,peinf%npes/peinf%npools).eq.0) then
        ndvmax_l=ndvmax/(peinf%npes/peinf%npools)
      else
        ndvmax_l=ndvmax/(peinf%npes/peinf%npools)+1
      endif
      SAFE_ALLOCATE(wfnkmpi%nkptotal, (sig%nkn))
      SAFE_ALLOCATE(wfnkmpi%isort, (kp%ngkmax,sig%nkn))
      SAFE_ALLOCATE(wfnkmpi%qk, (3,sig%nkn))
      SAFE_ALLOCATE(wfnkmpi%el, (sig%ntband,sig%nspin,sig%nkn))
      SAFE_ALLOCATE(wfnkmpi%elda, (sig%ntband,sig%nspin,sig%nkn))
      SAFE_ALLOCATE(wfnkmpi%cg, (ndvmax_l,sig%nspin*kp%nspinor,sig%nkn))
    endif
  endif

!-----------------------------------
! Read in wavefunction information

  SAFE_ALLOCATE(wfnk%isrtk, (gvec%ng))
  SAFE_ALLOCATE(wfnk%ek, (sig%ntband,sig%nspin))
  SAFE_ALLOCATE(wfnk%elda, (sig%ntband,sig%nspin))
  
  call progress_init(prog_info, 'reading wavefunctions (WFN_inner)', 'state', kp%nrk*sig%ntband)
  do irk=1,kp%nrk
    write(tmpstr,*) 'Reading WFN_inner -> cond/val wfns irk=',irk
    call logit(tmpstr)
    qk(:)=kp%rk(:,irk)

!----------------------------
! Read in and sort gvectors

    SAFE_ALLOCATE(gvec_kpt%components, (3, kp%ngk(irk)))

    if (peinf%inode.eq.0) call timacc(21,1)
    call read_binary_gvectors(25, kp%ngk(irk), kp%ngk(irk), gvec_kpt%components)
    if (peinf%inode.eq.0) call timacc(21,2)

    do i = 1, kp%ngk(irk)
      call findvector(isort(i), gvec_kpt%components(:, i), gvec)
      if (isort(i) .eq. 0) then
        write(0,*) 'could not find gvec', kp%ngk(irk), i, gvec_kpt%components(1:3, i)
        call die('findvector')
      endif
    enddo
    SAFE_DEALLOCATE_P(gvec_kpt%components)
    
!--------------------------------------------------------
! Determine if Sigma must be computed for this k-point.
! If so, store the bands and wavefunctions on file iunit_k.
! If there is only one k-point, store directly in wfnk.

    istore=0
    do ikn=1,sig%nkn
      if(sig%indkn(ikn).eq.irk) then
        istore=1
        iknstore=ikn
        wfnk%nkpt=kp%ngk(irk)
        wfnk%ndv=peinf%ndiag_max*kp%ngk(irk)
        wfnk%k(:)=qk(:)
        wfnk%isrtk(:)=isort(:)
        do k=1,sig%nspin
          wfnk%ek(1:sig%ntband,k)= &
            kp%el(1:sig%ntband,irk,sig%spin_index(k))
          wfnk%elda(1:sig%ntband,k)= &
            kp%elda(1:sig%ntband,irk,sig%spin_index(k))
        enddo
        SAFE_ALLOCATE(wfnk%zk, (wfnk%ndv,sig%nspin*kp%nspinor))
        wfnk%zk=ZERO
      endif
    enddo ! ikn

    if (sig%iwriteint .eq. 0) then
      write(iunit_c) kp%ngk(irk),sig%ntband,(isort(j),j=1,gvec%ng), &
        ((kp%el(j,irk,sig%spin_index(k)),j=1,sig%ntband), &
        k=1,sig%nspin),(qk(i),i=1,3)
    else
      wfnkqmpi%nkptotal(irk) = kp%ngk(irk)
      wfnkqmpi%isort(1:kp%ngk(irk),irk) = isort(1:kp%ngk(irk))
      do k = 1, sig%nspin
        wfnkqmpi%el(1:sig%ntband,k,irk) = &
          kp%el(1:sig%ntband,irk,sig%spin_index(k))
      enddo
      wfnkqmpi%qk(1:3,irk) = qk(1:3)
    endif

!-------------------------------------------------------------------------
! SIB:  Read wave functions from file WFN_inner (unit=25) and have
! the appropriate processor write it to iunit_c after checking norm.
! The wavefunctions for bands where Sigma matrix elements are
! requested are stored in wfnk%zk for later writing to unit iunit_k.
! If band index is greater than sig%ntband, we will actually
! not do anything with this band (see code below).
!  We still have to read it though, in order
! to advance the file to get to the data for the next k-point.

    SAFE_ALLOCATE(zc, (kp%ngk(irk), kp%nspin*kp%nspinor))

    inum=0
    do i=1,kp%mnband

      if (peinf%inode.eq.0) call timacc(21,1)

      dont_read = (i > sig%ntband)
      call read_binary_data(25, kp%ngk(irk), kp%ngk(irk), kp%nspin*kp%nspinor, zc, dont_read = dont_read)
      if (peinf%inode.eq.0) call timacc(21,2)

      if (.not.dont_read) then
        call progress_step(prog_info, sig%ntband*(irk-1) + i)
        if(peinf%inode.eq.0) then
          do k=1,sig%nspin
            call checknorm('WFN_inner',i,irk,kp%ngk(irk),k,kp%nspinor,zc(:,:))
          enddo
        endif

        nstore=0
        do j=1,peinf%ndiag_max
          if (.not.peinf%flag_diag(j)) cycle
          if (sig%band_index(i).eq. &
            sig%diag(peinf%index_diag(j))) nstore=j
        enddo
        if((istore.eq.1).and.(nstore.ne.0)) then
          do k=1,sig%nspin*kp%nspinor
            do j=1,kp%ngk(irk)
              wfnk%zk((nstore-1)*kp%ngk(irk)+j,k) = zc(j,sig%spin_index(k))
            enddo
          enddo
        endif
        j=0
        do ii=1,peinf%ntband_node
          if (peinf%indext(ii).eq.sig%band_index(i)) j=1
        enddo

        if (peinf%inode.eq.0) call timacc(22,1)

        if (j.eq.1) then
          if (sig%iwriteint .eq. 0) then
            write(iunit_c) sig%band_index(i),kp%ngk(irk), &
              ((zc(j,sig%spin_index(k)),j=1,kp%ngk(irk)), &
              k=1,sig%nspin*kp%nspinor)
          else
            inum=inum+1
            wfnkqmpi%band_index(inum,irk)=sig%band_index(i)
            do k=1,sig%nspin*kp%nspinor
              wfnkqmpi%cg(1:kp%ngk(irk),inum,k,irk)= &
                zc(1:kp%ngk(irk),sig%spin_index(k))
            enddo
          endif
        endif

        if (peinf%inode.eq.0) call timacc(22,2)
      else
        ! FHJ: the following lines were introduced in r6294 and are supposed to
        ! be a shortcut if we are past the last band of the last k-point. However,
        ! in light of a previous bug (#223), this feature is commented out for now.
        !! FHJ: shortcut if this is past the last band of the last k-point
        !if (irk==kp%nrk) exit
      endif
      
    enddo ! i (loop over bands)
    SAFE_DEALLOCATE(zc)
    
    if((istore.eq.1).and.(sig%nkn.gt.1)) then

      if (peinf%inode.eq.0) call timacc(22,1)

      if (sig%iwriteint .eq. 0) then
        if (mod(peinf%inode,peinf%npes/peinf%npools).eq.0) then
          write(iunit_k) kp%ngk(irk),wfnk%ndv,sig%ntband, &
            (wfnk%isrtk(j),j=1,gvec%ng),(qk(i),i=1,3), &
            ((wfnk%ek(j,k),j=1,sig%ntband),k=1,sig%nspin), &
            ((wfnk%elda(j,k),j=1,sig%ntband),k=1,sig%nspin), &
            ((wfnk%zk(j,k),j=1,wfnk%ndv),k=1,sig%nspin*kp%nspinor)
        endif
      else
        ikn=iknstore
        wfnkmpi%nkptotal(ikn)=kp%ngk(irk)
        wfnkmpi%isort(1:kp%ngk(irk),ikn)=wfnk%isrtk(1:kp%ngk(irk))
        wfnkmpi%qk(1:3,ikn)=qk(1:3)
        wfnkmpi%el(1:sig%ntband,1:sig%nspin,ikn)= &
          wfnk%ek(1:sig%ntband,1:sig%nspin)
        wfnkmpi%elda(1:sig%ntband,1:sig%nspin,ikn)= &
          wfnk%elda(1:sig%ntband,1:sig%nspin)
        do k=1,sig%nspin*kp%nspinor
#ifdef MPI
          i=mod(peinf%inode,peinf%npes/peinf%npools)
          if (mod(wfnk%ndv,peinf%npes/peinf%npools).eq.0) then
            j=wfnk%ndv/(peinf%npes/peinf%npools)
          else
            j=wfnk%ndv/(peinf%npes/peinf%npools)+1
          endif
          g1=1+i*j
          g2=min(j+i*j,wfnk%ndv)
          if (g2.ge.g1) then
            wfnkmpi%cg(1:g2-g1+1,k,ikn)=wfnk%zk(g1:g2,k)
          endif ! g2.ge.g1
#else
          wfnkmpi%cg(1:wfnk%ndv,k,ikn)=wfnk%zk(1:wfnk%ndv,k)
#endif
        enddo
      endif

      if (peinf%inode.eq.0) call timacc(22,2)

      SAFE_DEALLOCATE_P(wfnk%zk)
    endif
    
  enddo ! irk (loop over k-points)
  call progress_free(prog_info)

!------------------------------------------
! Close files and write out information about the crystal

  if(sig%iwriteint .eq. 0) then
    call close_file(iunit_c)
    if(mod(peinf%inode,peinf%npes/peinf%npools).eq.0) call close_file(iunit_k)
  endif

  if(peinf%inode.eq.0) then
    call close_file(25) ! WFN_inner
    write(6,111)
111 format(/,1x,'Read WFN_inner successfully.',/)
    write(7,111)    

!------------------------------------------------------
! Write out information about self-energy calculation

    write(6,120) sig%ntband,sig%nvband,sig%ncrit, &
      sig%ecutb,sig%ecuts,sig%sexcut,sig%gamma, &
      sig%fdf,sig%dw
    write(7,120) sig%ntband,sig%nvband,sig%ncrit, &
      sig%ecutb,sig%ecuts,sig%sexcut,sig%gamma, &
      sig%fdf,sig%dw
120 format(/,5x,'ntband =',i6,2x,'nvband =',i6,2x,'ncrit =',i3,/, &
      5x,'ecutb =',f10.4,2x,'ecuts =',f10.4,2x,'sexcut =',f10.4,/, &
      5x,'gamma =',f10.4,2x,'fdf =',i3,2x,'de =',f10.4,1x,'eV')

    call scissors_write(6, sig%scis)
    call scissors_write(6, sig%scis_outer, "outer")
    write(6,'(a)')
    call scissors_write(7, sig%scis)
    call scissors_write(7, sig%scis_outer, "outer")
    write(7,'(a)')

    if(sig%freq_dep.eq.1) then
      do k=1,sig%nspin
        write(6,160) sig%spin_index(k),wpg%nelec &
          (sig%spin_index(k)),sqrt(wpg%wpsq(sig%spin_index(k)))
        write(7,160) sig%spin_index(k),wpg%nelec &
          (sig%spin_index(k)),sqrt(wpg%wpsq(sig%spin_index(k)))
160     format(/,5x,'data for sum rule',3x,'rho(0,',i1,')=',f8.4, &
          3x,'wp =',f8.4,1x,'eV')
      enddo
      write(6,*)
      write(7,*)
    endif ! sig%freq_dep
171 format(/,1x,'ndiag    =',i4)
    write(6,171) sig%ndiag
172 format(1x,'diag(:)  =',999i4)
    write(6,172) sig%diag(:)
173 format(1x,'noffdiag =',i4)
    write(6,173) sig%noffdiag
    if (sig%noffdiag>0) then
      do k=1,sig%noffdiag
174 format(1x,'offmap(:, ',i4,') =',3i4)
        write(6,174) k, (sig%offmap(k,ii), ii = 1, 3)
      enddo
    endif
    write(6,*)
    
  endif ! node 0
  
  SAFE_DEALLOCATE(isort)
  SAFE_DEALLOCATE(isrt)
  SAFE_DEALLOCATE(isrti)
  SAFE_DEALLOCATE_P(kp%w)
  SAFE_DEALLOCATE_P(kp%el)
  SAFE_DEALLOCATE_P(kp%elda)

#ifdef MPI
  if(sig%iwriteint == 0) call MPI_Barrier(MPI_COMM_WORLD, mpierr)
#endif

  POP_SUB(input)
  
  return
  
end subroutine input

!=================================================================================
!
! Module read_matrix
!
! (1) read_matrix_d()           Originally by JRD       Last Modified 5/1/2008 (JRD)
!
! This program reads a distributed matrix like chimat or epsmat to file.
!
! (2) read_matrix_f()           Originally by JRD       Last Modified 9/10/2010 (gsm)
!
! Modification of read_matrix_d for full-frequency.
!
!=================================================================================

#include "f_defs.h"

module read_matrix_m

  use global_m
  use scalapack_m
  use epsread_hdf5_m
#ifdef HDF5
  use hdf5
#endif

  implicit none
  
  private

  public :: &
    read_matrix_d, &
    read_matrix_d_hdf5, &
    read_matrix_f, &
    read_matrix_f_hdf5


contains

subroutine read_matrix_d(scal,matrix,nmtx,iunit)
  type (scalapack), intent(in) :: scal
  SCALAR, intent(out) :: matrix(:,:) !< (scal%npr,scal%npc)
  integer, intent(in) :: nmtx
  integer, intent(in) :: iunit

  PUSH_SUB(read_matrix_d)

  call read_matrix_d_(scal,matrix,nmtx,iunit=iunit)

  POP_SUB(read_matrix_d)

end subroutine read_matrix_d


subroutine read_matrix_d_hdf5(scal,matrix,nmtx,fname,iq,is)
  type (scalapack), intent(in) :: scal
  SCALAR, intent(out) :: matrix(:,:) !< (scal%npr,scal%npc)
  integer, intent(in) :: nmtx
  character(len=*), intent(in) :: fname
  integer, intent(in) :: iq
  integer, intent(in) :: is

  PUSH_SUB(read_matrix_d_hdf5)

  call read_matrix_d_(scal,matrix,nmtx,fname=fname,iq=iq,is=is)

  POP_SUB(read_matrix_d_hdf5)

end subroutine read_matrix_d_hdf5


subroutine read_matrix_d_(scal,matrix,nmtx,iunit,fname,iq,is)
  type (scalapack), intent(in) :: scal
  SCALAR, intent(out) :: matrix(:,:) !< (scal%npr,scal%npc)
  integer, intent(in) :: nmtx
  integer, intent(in), optional :: iunit
  character(len=*), intent(in), optional :: fname
  integer, intent(in), optional :: iq
  integer, intent(in), optional :: is
  
  integer :: ii, jj
  
#ifdef USESCALAPACK
  SCALAR, allocatable :: tempcol(:)
  integer :: irow, icol, irowm, icolm
  integer :: icurr
#endif
  logical :: use_hdf5
  
  PUSH_SUB(read_matrix_d_)

  if (.not.present(iunit).and..not.(present(fname).and.present(iq))) then
    call die("Not enough arguments to read_matrix_d_", only_root_writes=.true.)
  endif
  if (present(iunit).and.(present(fname).or.present(iq))) then
    call die("Too many arguments to read_matrix_d_", only_root_writes=.true.)
  endif
  if ((present(fname).or.present(iq)).and..not.(present(fname).and.present(iq))) then
    call die("Inconsistent arguments to read_matrix_d_", only_root_writes=.true.)
  endif
  use_hdf5 = present(fname).and.present(iq)
#ifndef HDF5
  if (use_hdf5) then
    call die("read_matrix_d_ was not compiled with HDF5 support.", only_root_writes=.true.)
  endif
#endif

#ifdef VERBOSE
  if(peinf%inode .eq. 0) then
    if (use_hdf5) then
      write(6,*) ' Reading matrix: ', nmtx, fname
    else
      write(6,*) ' Reading matrix: ', nmtx, iunit
    endif
    write(6,*)
  endif
#endif
  
#ifdef USESCALAPACK
  
  SAFE_ALLOCATE(tempcol, (nmtx))
  
  icurr=0
  
  do jj = 1, nmtx

!        if (peinf%inode .eq. 0) then
!          write(6,*) ' In loop: ', ii
!        endif

    if (peinf%inode .eq. 0) then
      if (use_hdf5) then
#ifdef HDF5
        call read_eps_matrix_col_hdf5(tempcol,jj,nmtx,iq,is,fname)
#endif
      else
        read(iunit) (tempcol(ii),ii=1,nmtx)
      endif

    endif
    
    call MPI_BCAST(tempcol,nmtx,MPI_SCALAR,0, &
      MPI_COMM_WORLD,mpierr)
    
    icol=MOD(INT(((jj-1)/scal%nbl)+TOL_SMALL),scal%npcol)
    if (icol .eq. scal%mypcol) then
      do ii = 1, nmtx
        irow=MOD(INT(((ii-1)/scal%nbl)+TOL_SMALL),scal%nprow)
        if (irow .eq. scal%myprow) then
          icurr=icurr+1
          icolm=INT((icurr-1)/scal%npr+TOL_SMALL)+1
          irowm=MOD((icurr-1),scal%npr)+1
          matrix(irowm,icolm)=tempcol(ii)
        endif
      enddo
    endif
    
    call MPI_barrier(MPI_COMM_WORLD,mpierr)
    
  enddo
  
  SAFE_DEALLOCATE(tempcol)
  
#else
  
  if(peinf%inode .eq. 0) then
    do jj = 1, nmtx
      if (use_hdf5) then
#ifdef HDF5
        call read_eps_matrix_col_hdf5(matrix(:,jj),jj,nmtx,iq,is,fname)
#endif
      else
        read(iunit) (matrix(ii, jj), ii = 1, nmtx)
      endif
    enddo
  endif
  
#endif
  
  POP_SUB(read_matrix_d_)
  
  return
end subroutine read_matrix_d_


!=================================================================================


subroutine read_matrix_f(scal,nfreq,nfreq_para,retarded,advanced,nmtx,para_freqs,iunit)
  type(scalapack), intent(in) :: scal
  integer, intent(in) :: nfreq
  integer, intent(in) :: nfreq_para
  complex(DPC), intent(out) :: retarded(:,:,:) !< (nfreq_para,scal%npr,scal%npc)
#ifdef CPLX
  complex(DPC), intent(out) &
#else
  complex(DPC), intent(in)  &  ! no value is assigned if not CPLX
#endif
    :: advanced(nfreq_para,scal%npr,scal%npc)
  integer, intent(in) :: nmtx
  integer, intent(in) :: para_freqs
  integer, intent(in) :: iunit

  PUSH_SUB(read_matrix_f)

  call read_matrix_f_(scal,nfreq,nfreq_para,retarded,advanced,nmtx,para_freqs,iunit=iunit)

  POP_SUB(read_matrix_f)

end subroutine read_matrix_f


subroutine read_matrix_f_hdf5(scal,nfreq,nfreq_para,retarded,advanced,nmtx,para_freqs,fname,iq,is)
  type(scalapack), intent(in) :: scal
  integer, intent(in) :: nfreq
  integer, intent(in) :: nfreq_para
  complex(DPC), intent(out) :: retarded(:,:,:) !< (nfreq_para,scal%npr,scal%npc)
#ifdef CPLX
  complex(DPC), intent(out) &
#else
  complex(DPC), intent(in)  &  ! no value is assigned if not CPLX
#endif
    :: advanced(nfreq_para,scal%npr,scal%npc)
  integer, intent(in) :: nmtx
  integer, intent(in) :: para_freqs
  character(len=*), intent(in) :: fname
  integer, intent(in) :: iq
  integer, intent(in) :: is

  PUSH_SUB(read_matrix_f_hdf5)

  call read_matrix_f_(scal,nfreq,nfreq_para,retarded,advanced,nmtx,para_freqs,fname=fname,iq=iq,is=is)

  POP_SUB(read_matrix_f_hdf5)

end subroutine read_matrix_f_hdf5


subroutine read_matrix_f_(scal,nfreq,nfreq_para,retarded,advanced,nmtx,para_freqs,iunit,fname,iq,is)
  type(scalapack), intent(in) :: scal
  integer, intent(in) :: nfreq
  integer, intent(in) :: nfreq_para
  complex(DPC), intent(out) :: retarded(:,:,:) !< (nfreq_para,scal%npr,scal%npc)
#ifdef CPLX
  complex(DPC), intent(out) &
#else
  complex(DPC), intent(in)  &  ! no value is assigned if not CPLX
#endif
    :: advanced(nfreq_para,scal%npr,scal%npc)
  integer, intent(in) :: nmtx
  integer, intent(in) :: para_freqs
  integer, intent(in), optional :: iunit
  character(len=*), intent(in), optional :: fname
  integer, intent(in), optional :: iq
  integer, intent(in), optional :: is

  integer :: ii, jj, ifreq,ifreq_para,freq_grp_ind
#ifdef USESCALAPACK
  complex(DPC), allocatable :: tempcolR(:,:)
  complex(DPC), allocatable :: tempcolA(:,:)
  integer :: irow, icol, irowm, icolm
  integer :: icurr
#endif
  logical :: use_hdf5

  PUSH_SUB(read_matrix_f_)

  if (.not.present(iunit).and..not.(present(fname).and.present(iq))) then
    call die("Not enough arguments to read_matrix_f_", only_root_writes=.true.)
  endif
  if (present(iunit).and.(present(fname).or.present(iq))) then
    call die("Too many arguments to read_matrix_f_", only_root_writes=.true.)
  endif
  if ((present(fname).or.present(iq)).and..not.(present(fname).and.present(iq))) then
    call die("Inconsistent arguments to read_matrix_f_", only_root_writes=.true.)
  endif
  use_hdf5 = present(fname).and.present(iq)
#ifndef HDF5
  if (use_hdf5) then
    call die("read_matrix_f_ was not compiled with HDF5 support.", only_root_writes=.true.)
  endif
#endif
  
#ifdef VERBOSE
  if(peinf%inode .eq. 0) then
    if (use_hdf5) then
      write(6,*) ' Reading matrix: ', nmtx, fname
    else
      write(6,*) ' Reading matrix: ', nmtx, iunit
    endif
    write(6,*)
  endif
#endif
  
#ifdef USESCALAPACK
  
  SAFE_ALLOCATE(tempcolR, (nfreq,nmtx))
#ifdef CPLX
  SAFE_ALLOCATE(tempcolA, (nfreq,nmtx))
#endif
  
  icurr=0
  
  do jj = 1, nmtx

!        if (peinf%inode .eq. 0) then
!          write(6,*) ' In loop: ', i
!        endif

    if (peinf%inode .eq. 0) then
      if (use_hdf5) then
#ifdef HDF5
        call read_eps_matrix_col_f_hdf5(tempcolR,&
#ifdef CPLX
          tempcolA,&
#endif
          nfreq,jj,nmtx,iq,is,fname)
#endif
      else
        do ii = 1, nmtx
          read(iunit) (tempcolR(ifreq,ii),ifreq=1,nfreq)
        enddo
#ifdef CPLX
        do ii = 1, nmtx
          read(iunit) (tempcolA(ifreq,ii),ifreq=1,nfreq)
        enddo
#endif
      endif
    endif
    
    call MPI_BCAST(tempcolR,nfreq*nmtx,MPI_COMPLEX_DPC,0, &
      MPI_COMM_WORLD,mpierr)
#ifdef CPLX
    call MPI_BCAST(tempcolA,nfreq*nmtx,MPI_COMPLEX_DPC,0, &
      MPI_COMM_WORLD,mpierr)
#endif
    
    icol=MOD(INT(((jj-1)/scal%nbl)+TOL_SMALL),scal%npcol)
    if (icol .eq. scal%mypcol) then
      do ii = 1, nmtx
        irow=MOD(INT(((ii-1)/scal%nbl)+TOL_SMALL),scal%nprow)
        if (irow .eq. scal%myprow) then
          icurr=icurr+1
          icolm=INT((icurr-1)/scal%npr+TOL_SMALL)+1
          irowm=MOD((icurr-1),scal%npr)+1
          retarded(:,irowm,icolm)=tempcolR(:,ii)
#ifdef CPLX
          advanced(:,irowm,icolm)=tempcolA(:,ii)
#endif
          do ifreq=1,nfreq
            freq_grp_ind=mod(ifreq-1,para_freqs)
            ifreq_para=1+floor(-TOL_Small+dble(ifreq)/para_freqs)
            if(freq_grp_ind .eq. peinf%rank_mtxel) then
              retarded(ifreq_para,irowm,icolm)=tempcolR(ifreq,ii)
#ifdef CPLX
              advanced(ifreq_para,irowm,icolm)=tempcolA(ifreq,ii)
#endif
            endif
          enddo

        endif
      enddo
    endif
    
    call MPI_barrier(MPI_COMM_WORLD,mpierr)
    
  enddo
  
  SAFE_DEALLOCATE(tempcolR)
#ifdef CPLX
  SAFE_DEALLOCATE(tempcolA)
#endif
  
#else
  
  if(peinf%inode .eq. 0) then
    do jj = 1, nmtx
      if (use_hdf5) then
#ifdef HDF5
        call read_eps_matrix_col_f_hdf5(retarded(:,:,jj),&
#ifdef CPLX
          advanced(:,:,jj),&
#endif
          nfreq,jj,nmtx,iq,is,fname)
#endif
      else
        do ii = 1, nmtx
          read(iunit) (retarded(ifreq, ii, jj), ifreq = 1, nfreq)
        enddo
#ifdef CPLX
        do ii = 1, nmtx
          read(iunit) (advanced(ifreq, ii, jj), ifreq = 1, nfreq)
        enddo
#endif
      endif
    enddo
  endif
  
#endif
  
  POP_SUB(read_matrix_f_)
  
  return
end subroutine read_matrix_f_

end module read_matrix_m

!======================================================================================
!
! Routines:
!
! (1) write_eigenvectors()      Originally By MLT       Last Modified 6/6/2008 (JRD)
!
! Sohrab Ismail-Beigi:  May 4, 2001
!
! This routine is called when we want to write eigenvectors of the BSE
! equations to file (i.e. the eigenvectors coefficients).  It will open
! a file called eigenvectors and write to it.
!
!=====================================================================================

#include "f_defs.h"

subroutine write_eigenvectors(xct,kg,nblock,pblock,neig,egv,egs,nwrite)

  use global_m
  implicit none

  type(xctinfo), intent(in) :: xct
  type(grid), intent(in) :: kg
  integer, intent(in) :: nblock,pblock,neig
  real(DP), intent(in) :: egv(neig)
  SCALAR, intent(in) :: egs(xct%nkpt_fi*nblock,pblock)
  integer, intent(inout) :: nwrite

  integer :: ieig,nmat,ii,jj,kk,peadd
  SCALAR, allocatable :: A(:)
  logical :: io

  PUSH_SUB(write_eigenvectors)

! Who can do io?

  if (peinf%inode.eq.0) then
    io = .true.
  else
    io = .false.
  endif

  if (nwrite.lt.0) nwrite=neig

! Get space for the A coeffs

  nmat = xct%nkpt_fi*nblock
  SAFE_ALLOCATE(A, (nmat))

! Open the file we will write to and write header information

  if (io) then
    write(6,*)
    write(6,*) 'Writing ',nwrite, ' eigenvectors to file "eigenvectors"'
    write(6,*) 'length of vectors = ',nmat
    write(6,*)
    call open_file(unit=200,file='eigenvectors',form='unformatted',status='replace')
!           rewind(200)
    write(200) xct%nspin
    write(200) xct%nvb_fi
    write(200) xct%ncb_fi
    write(200) xct%nkpt_fi
    write(200) ((kg%f(jj,kk),jj=1,3),kk=1,xct%nkpt_fi)
  endif

! Loop over states to be written

  do ieig=1,nwrite

! Figure out which processor (peadd) and column
! state ieig belongs to

    peadd_loop: do peadd=1,peinf%npes
      do jj=1,peinf%neig(peadd)
        if (peinf%peig(peadd,jj).eq.ieig) then

! Get the coeffs for state ieig into A (on all processors)
          if (peinf%inode+1.eq.peadd) then
            A(:) = egs(:,jj)
          endif
#ifdef MPI
          call MPI_BCAST(A,nmat,MPI_SCALAR,peadd-1,MPI_COMM_WORLD,mpierr)
#endif

! Write to file

          if (io) then
#ifdef VERBOSE
            write(6,*) 'Writing state',ieig,' energy=',egv(ieig)
#endif
            write(200) egv(ieig)
            write(200) (A(ii),ii=1,nmat)
          endif
        endif
      enddo
    enddo peadd_loop

  enddo ! of loop over states (ieig)
  
  if (io) call close_file(200)
  SAFE_DEALLOCATE(A)
  
  POP_SUB(write_eigenvectors)
  
  return
  
end subroutine write_eigenvectors

!===============================================================================
!
! Routines:
!
! 1. gsetbas()        Originally By gsm        Last Modified 9/1/2010 (gsm)
!
! Generate basis functions for degenerate set of G-vectors.
!
! 2. gsetirr()        Originally By gsm        Last Modified 9/1/2010 (gsm)
!
! Decompose reducible representation of degenerate set of G-vectors
! into irreducible representations of the group of k-point.
!
! 3. gsetrep()        Originally By gsm        Last Modified 9/1/2010 (gsm)
!
! Construct reducible representation of degenerate set of G-vectors.
!
! 4. pwdeg()          Originally By gsm        Last Modified 9/1/2010 (gsm)
!
! Construct degenerate sets of G-vectors.
!
! 5. pwgen()          Originally By gsm        Last Modified 9/1/2010 (gsm)
!
! Generate plane waves and decompose them into irreducible representations
! of the space group of the Bravais lattice or the crystal.
!
! 6. random_wfng()    Originally By gsm        Last Modified 9/1/2010 (gsm)
!
! Generate random wave functions as opposed to plane waves.
!
!===============================================================================

#include "f_defs.h"

module pw_m

  use global_m
  use lapack_m
  use groupk_m
  use sort_m
  use random_m

  implicit none

  private

  public :: pwdeg, pwgen, random_wfng

contains

subroutine gsetbas(mset,gset,rotk,nclass,nelem,elem, &
  which_irr,char_mat,pwrap,ferr,pwmix)

  integer, intent(in) :: mset,gset(3,48),rotk(3,3,48),nclass, &
    nelem(12),elem(8,12),which_irr(12),pwrap(12)
  complex(DPC), intent(in) :: char_mat(12,12)
  logical, intent(out) :: ferr
  SCALAR, intent(out) :: pwmix(48,48)
  
  logical :: feq1,feq2,fbas(48)
  integer :: i,j,irap,iset,jset,kset,iclass,ielem,imix,ndeg,gvec(3), &
    grot(3)
  real(DP) :: xnorm
  complex(DPC) :: zchar,zphase,zdot,ibas(48,48)
  
  PUSH_SUB(gsetbas)
  
! Generate basis functions for degenerate set of G-vectors

  ferr=.false.
  
  imix=0
  do irap=1,nclass
    if (pwrap(irap).ne.0) then
      ndeg=pwrap(irap)*int(dble(char_mat(irap,1))+0.5d0)

! Construct the coefficients of the basis functions for irap

      ibas(:,:)=(0.0d0,0.0d0)
      do iset=1,mset
        do j=1,3
          gvec(j)=gset(j,iset)
        enddo
        do iclass=1,nclass
          zchar=char_mat(irap,which_irr(iclass))
          do ielem=1,nelem(iclass)
            do i=1,3
              grot(i)=0
              do j=1,3
                grot(i)=grot(i)+rotk(i,j,elem(ielem,iclass))*gvec(j)
              enddo
            enddo
            do jset=1,mset
              if (grot(1).eq.gset(1,jset).and.grot(2).eq. &
                gset(2,jset).and.grot(3).eq.gset(3,jset)) then
                kset=jset
                exit
              endif
            enddo
            ibas(kset,iset)=ibas(kset,iset)+zchar
          enddo
        enddo
      enddo

! Normalize the coefficients

      do iset=1,mset
        xnorm=0.0d0
        do jset=1,mset
          xnorm=xnorm+dble(ibas(jset,iset))**2+IMAG(ibas(jset,iset))**2
        enddo
        if (xnorm.gt.TOL_Zero) then
          xnorm=sqrt(xnorm)
        else
          xnorm=1.0d0
          ferr=.true.
        endif
        do jset=1,mset
          ibas(jset,iset)=ibas(jset,iset)/CMPLX(xnorm,0.0d0)
        enddo
      enddo

! Remove an arbitrary phase

      do iset=1,mset
        jset=0
        xnorm=0.0d0
        do kset=1,mset
          if (abs(ibas(kset,iset)).gt.xnorm+TOL_Small) then
            jset=kset
            xnorm=abs(ibas(kset,iset))
          endif
        enddo
        if (jset.eq.0) then
          jset=1
          ferr=.true.
        endif
        zphase=ibas(jset,iset)
        xnorm=abs(zphase)
        if (xnorm.le.TOL_Small) then
          xnorm=1.0d0
          ferr=.true.
        endif
        zphase=zphase/CMPLX(xnorm,0.0d0)
        do jset=1,mset
          ibas(jset,iset)=ibas(jset,iset)/zphase
        enddo
      enddo

! Find the inequivalent coefficients

      fbas(:)=.false.
      do iset=1,mset
        feq1=.true.
        do jset=1,mset
          if (fbas(jset)) then
            feq2=.true.
            do kset=1,mset
              if (abs(ibas(kset,jset)-ibas(kset,iset)).gt.TOL_Small) &
                feq2=.false.
            enddo
            if (feq2) feq1=.false.
          endif
        enddo
        if (feq1) fbas(iset)=.true.
      enddo

! Check the orthonormality of the coefficients

      do iset=1,mset
        if (fbas(iset)) then
          do jset=iset+1,mset
            if (fbas(jset)) then
              zdot=CMPLX(0.0d0,0.0d0)
              do kset=1,mset
                zdot=zdot+CONJG(ibas(kset,iset))*ibas(kset,jset)
              enddo
              if (abs(zdot).gt.TOL_Zero) then
                ! orthogonalize
                do kset=1,mset
                  ibas(kset,jset)=ibas(kset,jset)-zdot*ibas(kset,iset)
                enddo
                ! normalize
                xnorm=0.0d0
                do kset=1,mset
                  xnorm=xnorm+abs(ibas(kset,jset))**2
                enddo
                if (xnorm.gt.TOL_Zero) then
                  xnorm=sqrt(xnorm)
                else
                  ! remove from the list if norm is zero
                  fbas(jset)=.false.
                  xnorm=1.0d0
                endif
                do kset=1,mset
                  ibas(kset,jset)=ibas(kset,jset)/CMPLX(xnorm,0.0d0)
                enddo
              endif ! abs(zdot).gt.TOL_Small
            endif
          enddo
        endif
      enddo

! Store the coefficients of the basis functions for irap

      iset=0
      do jset=1,mset
        if (fbas(jset)) then
          iset=iset+1
          imix=imix+1
          do kset=1,mset
            pwmix(kset,imix)=SCALARIFY(ibas(kset,jset))
          enddo
          if (iset.eq.ndeg) exit
        endif
      enddo
      
    endif ! pwrap(irap).ne.0
  enddo ! irap

  POP_SUB(gsetbas)

  return

end subroutine gsetbas

!-------------------------------------------------------------------------------

subroutine gsetirr(nclass,which_irr,char_mat,pwclass,ferr,pwrap)

  integer, intent(in) :: nclass,which_irr(12),pwclass(12)
  complex(DPC), intent(in) :: char_mat(12,12)
  logical, intent(out) :: ferr
  integer, intent(out) :: pwrap(12)
  
  integer :: iclass,irap,info,ipiv(12)
  real(DP) :: xdummy
  complex(DPC) :: a(12,12),b(12)
  
  PUSH_SUB(gsetirr)
  
! Decompose reducible representation of degenerate set of G-vectors
! into irreducible representations of the group of k-point

  ferr=.false.
  
  do iclass=1,nclass
    do irap=1,nclass
      a(iclass,irap)=char_mat(irap,which_irr(iclass))
    enddo
  enddo
  do iclass=1,nclass
    b(iclass)=CMPLX(dble(pwclass(iclass)),0.0d0)
  enddo
  
  call ZGESV(nclass,1,a,12,ipiv,b,12,info)
  if (info.ne.0) ferr=.true.
  
  do irap=1,nclass
    xdummy=dble(b(irap))
    if (xdummy.ge.0.0d0) xdummy=xdummy+0.5d0
    if (xdummy.lt.0.0d0) xdummy=xdummy-0.5d0
    pwrap(irap)=int(xdummy)
    if (pwrap(irap).lt.0) ferr=.true.
  enddo
  
! Check if decomposition is correct

  do iclass=1,nclass
    b(iclass)=CMPLX(0.0d0,0.0d0)
  enddo
  do iclass=1,nclass
    do irap=1,nclass
      b(iclass)=b(iclass)+char_mat(irap,which_irr(iclass))* &
        CMPLX(dble(pwrap(irap)),0.0d0)
    enddo
  enddo
  do iclass=1,nclass
    if (abs(b(iclass)-CMPLX(dble(pwclass(iclass)),0.0d0)).gt.TOL_Small) &
      ferr=.true.
  enddo
  
  POP_SUB(gsetirr)
  
  return
  
end subroutine gsetirr

!-------------------------------------------------------------------------------

subroutine gsetrep(mset,gset,nsymk,rotk,nclass,nelem,elem,ferr,pwclass)
  
  integer, intent(in) :: mset,gset(3,48),nsymk,rotk(3,3,48),nclass, &
    nelem(12),elem(8,12)
  logical, intent(out) :: ferr
  integer, intent(out) :: pwclass(12)
  
  integer :: i,j,iset,isymk,iclass,ielem,gvec(3),grot(3),irep(48)
  
  PUSH_SUB(gsetrep)

! Construct reducible representation of degenerate set of G-vectors

  ferr=.false.
  
  do isymk=1,nsymk
    irep(isymk)=0
  enddo
  do iset=1,mset
    do j=1,3
      gvec(j)=gset(j,iset)
    enddo
    do isymk=1,nsymk
      do i=1,3
        grot(i)=0
        do j=1,3
          grot(i)=grot(i)+rotk(i,j,isymk)*gvec(j)
        enddo
      enddo
      if (grot(1).eq.gvec(1).and.grot(2).eq.gvec(2).and. &
        grot(3).eq.gvec(3)) irep(isymk)=irep(isymk)+1
    enddo
  enddo
  
! Check if different elements of the class have the same characters

  do iclass=1,nclass
    do ielem=2,nelem(iclass)
      if (irep(elem(ielem,iclass)).ne.irep(elem(1,iclass))) &
        ferr=.true.
    enddo
  enddo

! Output one character for each class

  do iclass=1,nclass
    pwclass(iclass)=irep(elem(1,iclass))
  enddo
  
  POP_SUB(gsetrep)

  return
  
end subroutine gsetrep

!-------------------------------------------------------------------------------

subroutine pwdeg(pwsym,nsymk,rotk,ng,gvec,ekin,isrt,ndeg,mdeg,rdeg,ideg)
  
  logical, intent(in) :: pwsym
  integer, intent(in) :: nsymk,ng,rotk(3,3,48)
  integer, intent(in) :: gvec(:,:) !< (3,ng)
  real(DP), intent(in) :: ekin(:) !< (ng)
  integer, intent(inout) :: isrt(:) !< (ng)
  integer, intent(out) :: ndeg,mdeg
  integer, intent(out) :: rdeg(:,:) !< (2,ng)
  integer, intent(out) :: ideg(:) !< (ng)
  
  integer :: i,j,p,q,n,m,ig,imap,isymk,ndeg1,mdeg1,grot(3)
  real(DP) :: edeg
  integer, allocatable :: rdeg1(:,:),gvec1(:,:),gmap(:),isrt1(:)
  
  PUSH_SUB(pwdeg)

! Construct degenerate sets of G-vectors. On output, ndeg is the number
! of degenerate sets, mdeg is the maximum number of G-vectors in all
! sets, rdeg(1,:) and rdeg(2,:) are the indices of the first and last
! G-vectors in each degenerate set, and ideg(:) is the index of the
! degenerate set for each g-vector.

  SAFE_ALLOCATE(rdeg1, (2,ng))

! Sort G-vectors according to degeneracies in kinetic energies.

  ndeg1=1
  rdeg1(1,ndeg1)=1
  edeg=ekin(isrt(1))
  do ig=2,ng
    if (abs(ekin(isrt(ig))-edeg).gt.TOL_Small) then
      rdeg1(2,ndeg1)=ig-1
      ndeg1=ndeg1+1
      rdeg1(1,ndeg1)=ig
      edeg=ekin(isrt(ig))
    endif
  enddo
  rdeg1(2,ndeg1)=ng
  mdeg1=1
  do i=1,ndeg1
    j=rdeg1(2,i)-rdeg1(1,i)+1
    if (mdeg1.lt.j) mdeg1=j
  enddo
  
  if (pwsym) then

! Divide each degenerate set of G-vectors into smaller subsets
! using the symmetries of the k-point. The isrt index array is
! rearranged into smaller subsets.

    ndeg=0
    mdeg=1
    SAFE_ALLOCATE(gvec1, (3,mdeg1))
    SAFE_ALLOCATE(gmap, (mdeg1))
    SAFE_ALLOCATE(isrt1, (mdeg1))
    do n=1,ndeg1
      m=rdeg1(2,n)-rdeg1(1,n)+1
      do i=1,m
        ig=isrt(rdeg1(1,n)+i-1)
        do j=1,3
          gvec1(j,i)=gvec(j,ig)
        enddo
      enddo
      do p=1,m
        gmap(p)=0
      enddo
      imap=0
      do p=1,m
        if (gmap(p).eq.0) then
          imap=imap+1
          gmap(p)=imap
          do isymk=1,nsymk
            do i=1,3
              grot(i)=0
              do j=1,3
                grot(i)=grot(i)+rotk(i,j,isymk)*gvec1(j,p)
              enddo
            enddo
            do q=1,m
              if (grot(1).eq.gvec1(1,q).and.grot(2).eq.gvec1(2,q) &
                .and.grot(3).eq.gvec1(3,q)) gmap(q)=imap
            enddo
          enddo
        endif
      enddo
      do i=1,m
        isrt1(i)=isrt(rdeg1(1,n)+i-1)
      enddo
      p=0
      do i=1,imap
        ndeg=ndeg+1
        rdeg(1,ndeg)=rdeg1(1,n)+p
        do j=1,m
          if (gmap(j).eq.i) then
            p=p+1
            isrt(rdeg1(1,n)+p-1)=isrt1(j)
          endif
        enddo
        rdeg(2,ndeg)=rdeg1(1,n)+p-1
        j=rdeg(2,ndeg)-rdeg(1,ndeg)+1
        if (mdeg.lt.j) mdeg=j
      enddo
    enddo
    SAFE_DEALLOCATE(gvec1)
    SAFE_DEALLOCATE(gmap)
    SAFE_DEALLOCATE(isrt1)

  else ! pwsym

! Return the degenerate sets derived from kinetic energies.

    ndeg=ndeg1
    mdeg=mdeg1
    do i=1,ndeg
      do j=1,2
        rdeg(j,i)=rdeg1(j,i)
      enddo
    enddo
    
  endif ! pwsym
  
  SAFE_DEALLOCATE(rdeg1)

! Invert rdeg index array and store it in ideg for output.

  i=1
  do ig=1,ng
    ideg(ig)=i
    if (ig.eq.rdeg(2,i)) i=i+1
  enddo
  
  POP_SUB(pwdeg)
  
  return
  
end subroutine pwdeg

!-------------------------------------------------------------------------------

subroutine pwgen(fsym,fout,ffastsp,fshift,nk,ns,nbinp, &
  nbpw,nbmax,nsyml,b2g,npwdeg,ngk_l,ng,rotl,gvec, &
  pw_num,pw_ind,isort_d,eshift,a,b,bdot,kpt,en,wfn_d)
  
  logical, intent(in) :: fsym,fout,ffastsp,fshift
  integer, intent(in) :: nk,ns,nbinp,nbpw,nbmax,nsyml, &
    b2g,npwdeg,ngk_l,ng
  integer, intent(in) :: rotl(3,3,48)
  integer, intent(in) :: gvec(:,:) !< (3,ng)
  integer, intent(inout) :: pw_num(:,:,:) !< (nbmax,ns,nk)
  integer, intent(inout) :: pw_ind(:,:,:,:,:) !< (2,npwdeg,nbmax,ns,nk)
  integer, intent(in) :: isort_d(:,:) !< (ngk_l,nk)
  real(DP), intent(in) :: eshift
  real(DP), intent(in) :: a(3,3)
  real(DP), intent(in) :: b(3,3)
  real(DP), intent(in) :: bdot(3,3)
  real(DP), intent(in) :: kpt(:,:) !< (3,nk)
  real(DP), intent(inout) :: en(:,:,:) !< (nbmax,nk,ns)
  SCALAR, intent(inout) :: wfn_d(:,:,:,:) !< (ngk_l,nbmax,ns,nk)
  
  logical :: pwsym,fstart,fend,ferr
  integer :: i,j,ik,is,ib,ig,ipw,isym,ndeg,mdeg,nsymk,nclass, &
    iset,mset,jset,inum,gset(3,48),rotk(3,3,48), &
    which_irr(12),nelem(12),elem(8,12),pwclass(12),pwrap(12), &
    pw_inode(48),pw_ig(48),pw_dummy(48)
!  integer :: code_group
  real(DP) :: kvec(3)
!  real(DP) :: rotc(3,3,48)
  complex(DPC) :: char_mat(12,12)
  SCALAR :: pwmix(48,48)
  character(len=64) :: s0
  character(len=16) :: s1,s2,s3,s4,s5
!  character(len=11) :: gname
!  character(len=15) :: name_rap(12)
!  character(len=5) :: name_class(12)
!  character(len=3) :: ir_ram(12)
  
  real(DP), allocatable :: de(:)
  real(DP), allocatable :: ekin(:)
  integer, allocatable :: isrt(:)
  integer, allocatable :: rdeg(:,:)
  integer, allocatable :: ideg(:)

  PUSH_SUB(pwgen)

! Generate plane waves and decompose them into
! irreducible representations of the space group
! of the Bravais lattice or the crystal.

  SAFE_ALLOCATE(de, (ns))
  SAFE_ALLOCATE(ekin, (ng))
  SAFE_ALLOCATE(isrt, (ng))
  SAFE_ALLOCATE(rdeg, (2,ng))
  SAFE_ALLOCATE(ideg, (ng))
  
  do ik=1,nk
    
    ! generate symmetries of the k-point
    call groupk(kpt(:,ik),nsyml,rotl,nsymk,rotk)
    ! transform symmetry matrices from crystal to cartesian axes
    do isym=1,nsymk
!      call s_axis_to_cart(rotk(:,:,isym),rotc(:,:,isym),a,b)
    enddo
    ! construct the character table
!    call find_group(nsymk,rotc,gname,code_group)
!    call set_irr_rap(code_group,nclass,char_mat,name_rap,name_class,ir_ram)
!    call divide_class(code_group,nsymk,rotc,nclass,nelem,elem,which_irr)

    ! to enable (sapo_symmetry .gt. 0) comment out die below and uncomment
    ! s_axis_to_cart, find_group, set_irr_rap, divide_class above
    if (fsym) call die("(sapo_symmetry .gt. 0) is disabled")
    
    do ig=1,ng
      do i=1,3
        kvec(i)=kpt(i,ik)+dble(gvec(i,ig))
      enddo
      ! compute kinetic energies of g-vectors
      ekin(ig)=DOT_PRODUCT(kvec,MATMUL(bdot,kvec))
    enddo
    ! sort kinetic energies in ascending order
    call sortrx(ng,ekin,isrt,gvec=gvec)
    ! construct degenerate sets of g-vectors
    ! first we employ degeneracies in kinetic energies
    ! second (if pwsym is true) we divide each degenerate set
    ! into smaller subsets using the symmetries of the k-point
    pwsym=.true.
    call pwdeg(pwsym,nsymk,rotk,ng,gvec,ekin,isrt,ndeg,mdeg,rdeg,ideg)
    
    ! check if plane waves start in the middle of degenerate set
    ipw=nbinp+1-b2g
    if (ipw.ne.rdeg(1,ideg(ipw))) then
      fstart=.true.
    else
      fstart=.false.
    endif
    ! check if plane waves end in the middle of degenerate set
    ipw=nbinp+nbpw-b2g
    if (ipw.ne.rdeg(2,ideg(ipw))) then
      fend=.true.
    else
      fend=.false.
    endif
    ! print warning if the above check is positive
    if ((fstart.or.fend).and.(peinf%inode.eq.0)) then
      write(s1,101)ik
      if (fstart.and..not.fend) write(0,961)TRUNC(s1)
      if (.not.fstart.and.fend) write(0,962)TRUNC(s1)
      if (fstart.and.fend) write(0,963)TRUNC(s1)
    endif
    
    ! optional energy shift for plane waves
    if (fshift) then
      ipw=nbinp-b2g
      do is=1,ns
        de(is)=en(nbinp,ik,is)-ekin(isrt(ipw))
      enddo
    else ! fshift
      do is=1,ns
        de(is)=eshift/RYD
      enddo
    endif ! fshift
    
    ! index of the previous degenerate set
    jset=0
    
    do ib=nbinp+1,nbinp+nbpw
      
      ! absolute index of the current plane wave
      ipw=ib-b2g
      ! index of the current degenerate set
      iset=ideg(ipw)
      ! relative index of plane wave in degenerate set
      inum=ipw-rdeg(1,iset)+1
      
      ! start a new degenerate set of G-vectors
      if (iset.ne.jset) then
        jset=iset
        pw_inode(:)=0
        pw_ig(:)=0
        i=0
        ! loop over all G-vectors in degenerate set
        do j=rdeg(1,iset),rdeg(2,iset)
          i=i+1
          ! store the current G-vector in array gset
          gset(:,i)=gvec(:,isrt(j))
          ! find the processor that holds the current
          ! G-vector and its local index on that processor
          do ig=1,ngk_l
            if (isort_d(ig,ik).eq.isrt(j)) then
              pw_inode(i)=peinf%inode
              pw_ig(i)=ig
            endif
          enddo
        enddo
        ! total number of G-vectors in the current set
        mset=i
#ifdef MPI
        pw_dummy(:)=pw_inode(:)
        call MPI_Allreduce(pw_dummy,pw_inode,mset, &
          MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,mpierr)
        pw_dummy(:)=pw_ig(:)
        call MPI_Allreduce(pw_dummy,pw_ig,mset, &
          MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,mpierr)
#endif
        
        if (fsym) then
          ! symmetrize G-vectors in the current set
          ! initialize variables for printing to stdout
          write(s1,101)ik
          write(s2,101)rdeg(1,iset)+b2g
          write(s3,101)rdeg(2,iset)+b2g
          write(s4,101)rdeg(1,iset)
          write(s5,101)rdeg(2,iset)
          if (rdeg(1,iset).eq.rdeg(2,iset)) then
            write(s0,201)TRUNC(s1),TRUNC(s2),TRUNC(s4)
          else
            write(s0,202)TRUNC(s1),TRUNC(s2),TRUNC(s3), &
              TRUNC(s4),TRUNC(s5)
          endif ! rdeg(1,iset).eq.rdeg(2,iset)
          ! construct reducible representation
          ! of degenerate set of G-vectors
          call gsetrep(mset,gset,nsymk,rotk,nclass,nelem,elem,ferr,pwclass)
          if (ferr.and.peinf%inode.eq.0) write(0,964)TRUNC(s0)
          ! decompose into irreducible representations
          call gsetirr(nclass,which_irr,char_mat,pwclass,ferr,pwrap)
          if (ferr.and.peinf%inode.eq.0) write(0,965)TRUNC(s0)
          ! generate basis functions
          call gsetbas(mset,gset,rotk,nclass,nelem,elem, &
            which_irr,char_mat,pwrap,ferr,pwmix)
          if (ferr.and.peinf%inode.eq.0) write(0,966)TRUNC(s0)
          ! print representations to stdout
          if (fout) then
            if (peinf%inode.eq.0) then
              write(6,701)trim(s0)
!              write(6,702)(name_class(i),i=1,nclass)
              write(6,703)(pwclass(which_irr(i)),i=1,nclass)
!              write(6,702)(name_rap(i),i=1,nclass)
              write(6,703)(pwrap(i),i=1,nclass)
              write(6,704)
              do i=1,mset
#ifdef CPLX
                write(6,705)(pwmix(j,i),j=1,mset)
#else
                write(6,706)(pwmix(j,i),j=1,mset)
#endif
              enddo
              write(6,*)
            endif
          endif ! fout
        else ! fsym
          ! use one plane wave for one band
          pwmix(:,:)=ZERO
          do i=1,mset
            pwmix(i,i)=ONE
          enddo
        endif ! fsym
        
      endif ! iset.ne.jset
      
      ! compute the energy of the plane wave
      do is=1,ns
        en(ib,ik,is)=ekin(isrt(ipw))+de(is)
      enddo
      
      ! generate the wavefunction of the plane wave
      do is=1,ns
        wfn_d(:,ib,is,ik)=ZERO
        do i=1,mset
          if (peinf%inode.eq.pw_inode(i)) &
            wfn_d(pw_ig(i),ib,is,ik)=pwmix(i,inum)
        enddo ! i
      enddo ! is
      
      ! store plane wave components of wavefunctions
      if (ffastsp) then
        do i=1,mset
          if (abs(pwmix(i,inum)).gt.TOL_Zero) then
            do is=1,ns
              pw_num(ib,is,ik)=pw_num(ib,is,ik)+1
              pw_ind(1,pw_num(ib,is,ik),ib,is,ik)=pw_inode(i)
              pw_ind(2,pw_num(ib,is,ik),ib,is,ik)=pw_ig(i)
            enddo ! is
          endif ! abs(pwmix(i,inum)).gt.TOL_Zero
        enddo ! i
      endif ! ffastsp
      
    enddo ! ib
  enddo ! ik
  
  SAFE_DEALLOCATE(de)
  SAFE_DEALLOCATE(ekin)
  SAFE_DEALLOCATE(isrt)
  SAFE_DEALLOCATE(rdeg)
  SAFE_DEALLOCATE(ideg)
  
  POP_SUB(pwgen)
  
  return
  
101 format(i16)
  
201 format('ik =',1x,a,1x,'ib =',1x,a,1x,'ig =',1x,a)
202 format('ik =',1x,a,1x,'ib =',1x,a,1x,'...',1x,a,1x,'ig =', &
      1x,a,1x,'...',1x,a)
  
701 format(1x,a)
702 format(4x,12a5)
703 format(12i5)
704 format(4x,'Basis-function matrix')
705 format(7x,f6.3,sp,f6.3,ss,'*i',2x,f6.3,sp,f6.3,ss,'*i',2x,f6.3, &
      sp,f6.3,ss,'*i',2x,f6.3,sp,f6.3,ss,'*i',26x,f6.3,sp,f6.3,ss, &
      '*i',2x,f6.3,sp,f6.3,ss,'*i',2x,f6.3,sp,f6.3,ss,'*i',2x,f6.3, &
      sp,f6.3,ss,'*i',18x,f6.3,sp,f6.3,ss,'*i',2x,f6.3,sp,f6.3,ss, &
      '*i',2x,f6.3,sp,f6.3,ss,'*i',2x,f6.3,sp,f6.3,ss,'*i',18x,f6.3, &
      sp,f6.3,ss,'*i',2x,f6.3,sp,f6.3,ss,'*i',2x,f6.3,sp,f6.3,ss, &
      '*i',2x,f6.3,sp,f6.3,ss,'*i',18x,f6.3,sp,f6.3,ss,'*i',2x,f6.3, &
      sp,f6.3,ss,'*i',2x,f6.3,sp,f6.3,ss,'*i',2x,f6.3,sp,f6.3,ss, &
      '*i',18x,f6.3,sp,f6.3,ss,'*i',2x,f6.3,sp,f6.3,ss,'*i',2x,f6.3, &
      sp,f6.3,ss,'*i',2x,f6.3,sp,f6.3,ss,'*i',18x,f6.3,sp,f6.3,ss, &
      '*i',2x,f6.3,sp,f6.3,ss,'*i',2x,f6.3,sp,f6.3,ss,'*i',2x,f6.3, &
      sp,f6.3,ss,'*i',18x,f6.3,sp,f6.3,ss,'*i',2x,f6.3,sp,f6.3,ss, &
      '*i',2x,f6.3,sp,f6.3,ss,'*i',2x,f6.3,sp,f6.3,ss,'*i',18x,f6.3, &
      sp,f6.3,ss,'*i',2x,f6.3,sp,f6.3,ss,'*i',2x,f6.3,sp,f6.3,ss, &
      '*i',2x,f6.3,sp,f6.3,ss,'*i',18x,f6.3,sp,f6.3,ss,'*i',2x,f6.3, &
      sp,f6.3,ss,'*i',2x,f6.3,sp,f6.3,ss,'*i',2x,f6.3,sp,f6.3,ss, &
      '*i',18x,f6.3,sp,f6.3,ss,'*i',2x,f6.3,sp,f6.3,ss,'*i',2x,f6.3, &
      sp,f6.3,ss,'*i',2x,f6.3,sp,f6.3,ss,'*i',18x,f6.3,sp,f6.3,ss, &
      '*i',2x,f6.3,sp,f6.3,ss,'*i',2x,f6.3,sp,f6.3,ss,'*i',2x,f6.3, &
      sp,f6.3,ss,'*i')
706 format(6x,8f8.4,24x,8f8.4,16x,8f8.4,16x,8f8.4,16x,8f8.4,16x,8f8.4)
  
961 format(1x,'WARNING: ik =',1x,a,1x,'plane waves start in',1x, &
      'the middle of degenerate set',/)
962 format(1x,'WARNING: ik =',1x,a,1x,'plane waves end in',1x, &
      'the middle of degenerate set',/)
963 format(1x,'WARNING: ik =',1x,a,1x,'plane waves start and',1x, &
      'end in the middle of degenerate set',/)
964 format(1x,'WARNING:',1x,a,1x,'reducible representation',/)
965 format(1x,'WARNING:',1x,a,1x,'irreducible representation',/)
966 format(1x,'WARNING:',1x,a,1x,'basis generation',/)
  
end subroutine pwgen

subroutine random_wfng(nk,ns,nbstart,nbend,nbmax,ngk_l,ik,is,ngk, &
  arnd,brnd,wfn_d)

  integer, intent(in) :: nk,ns,nbstart,nbend,nbmax,ngk_l,ik,is
  integer, intent(in) :: ngk(:) !< (nk)
  real(DP), intent(in) :: arnd,brnd
  SCALAR, intent(inout) :: wfn_d(:,:,:,:) !< (ngk_l,nbmax,ns,nk)

  integer :: ib,ig
  real(DP) :: x,y

  PUSH_SUB(random_wfng)

  do ib=nbstart,nbend
    do ig=1,ngk_l
      if (peinf%inode*ngk_l+ig.le.ngk(ik)) then
        call genrand_real4(x)
        x=x*2.0d0-1.0d0
#ifdef CPLX
        call genrand_real4(y)
        y=y*2.0d0-1.0d0
#endif
        wfn_d(ig,ib,is,ik)=arnd*wfn_d(ig,ib,is,ik)+brnd*SCALARIFY2(x,y)
      endif ! peinf%inode*ngk_l+ig.le.ngk(ik)
    enddo ! ig
  enddo ! ib

  POP_SUB(random_wfng)

  return
end subroutine random_wfng

end module pw_m

!=======================================================================
!
! Routines:
!
! (1) minibzaverage_3d_oneoverq2() Originally by JRD/MJ Last Modified: 8/27/2009 (MJ/JRD)
!
! (2) minibzaverage_3d_oneoverq() Originally by JRD/MJ  Last Modified: 8/27/2009 (MJ/JRD)
!
! (3) minibzaverage_2d_oneoverq2() Originally by JRD/MJ Last Modified: 9/15/2009 (MJ/JRD)
!
! (4) minbizaverage_1d() Originally by JRD/MJ           Last Modified: 8/27/2009 (MJ/JRD)
!
!  Output: average of <V_q> on the mini-BZ for a 1-D system.
!  output units: units equivalent to 8Pi/q^2
!
!=======================================================================

#include "f_defs.h"

module minibzaverage_m

  use global_m
  use bessel_m
  use misc_m

  implicit none
  
  private

  public :: minibzaverage_3d_oneoverq2, minibzaverage_3d_oneoverq, &
    minibzaverage_2d_oneoverq2, minibzaverage_1d, minibzaverage_3d_oneoverq2_mod

contains

subroutine minibzaverage_3d_oneoverq2(nn,bdot,integral,qran,qk,averagew,epshead,wcoul0)
  integer, intent(in) :: nn
  real(DP), intent(in) :: bdot(3,3), qran(:,:) !< (3, nn)
  real(DP), intent(out) :: integral
  real(DP), intent(in) ::  qk(3)
  logical, intent(in)  :: averagew
  SCALAR, intent(in) :: epshead  
  real(DP) :: gkq(3), length
  SCALAR, intent(inout)  :: wcoul0 
 
  integer :: ii

  PUSH_SUB(minibzaverage_3d_oneoverq2)
  
  integral = 0D0
  
  do ii = 1, nn
    
    gkq(:) = qk(:) + qran(:,ii)
    length = DOT_PRODUCT(gkq,MATMUL(bdot,gkq))
    integral = integral + 1D0/length
    
  enddo
  
  integral = integral * 8D0 * PI_D / dble(nn) 

  length = DOT_PRODUCT(qk,MATMUL(bdot,qk))
  if (length .lt. TOL_Zero .and. averagew) then
    wcoul0 = integral * epshead
  endif
  
  POP_SUB(minibzaverage_3d_oneoverq2)
  
  return
end subroutine minibzaverage_3d_oneoverq2


!========================================================================

! This is for Slab Truncation

subroutine minibzaverage_2d_oneoverq2(nn,bdot,integral,qran,qk,kz,zc,epshead,q0len,averagew,wcoul0)
  integer, intent(in) :: nn
  real(DP), intent(in) :: bdot(3,3), qran(:,:) !< (3,nn)
  real(DP), intent(out) :: integral
  real(DP), intent(in) ::  qk(3)
  logical, intent(in)  :: averagew
  SCALAR, intent(in) :: epshead  
  SCALAR, intent(inout)  :: wcoul0 
  real(DP), intent(in) ::  zc, q0len
  real(DP), intent(out) :: kz

  integer ::  ii
  real(DP) :: gkq(3), length, kxy, gkqxy(3),lengthqk
  real(DP) :: gkqz(3),epsmodel,gamma,alpha,vc,vc_qtozero
  SCALAR  :: integralW
  
  PUSH_SUB(minibzaverage_2d_oneoverq2)
  
!
! Sahar:
! Define Gamma parameter for model epsilon (see Sohrab, PRB 2006)
! Extract the quadratic dependence of 1/epsinv(00)
! 1/epsinv(q;0,0) = 1 + q^2*vc(q)*gamma

!get Vc
  vc_qtozero=((1.0d0 - exp(-q0len*zc))/q0len**2)
! Define Gamma
  gamma = (1.0d0/epshead-1.0d0)/((q0len**2)*vc_qtozero)
!
! Define alpha 
! Set to zero for now
  alpha = 0.0d0

! length of q + G
  lengthqk = sqrt(DOT_PRODUCT(qk,MATMUL(bdot,qk)))

  integral = 0D0
  integralW = 0D0

  do ii = 1, nn
    gkq(:) = qk(:)
    gkq(1:2) = gkq(1:2) + qran(1:2,ii)
    gkqxy(1:2) = gkq(1:2)
    gkqxy(3) = 0D0
    kxy=sqrt(DOT_PRODUCT(gkqxy,MATMUL(bdot,gkqxy)))
    length = DOT_PRODUCT(gkq,MATMUL(bdot,gkq))
    
    ! This is Temporary??
    gkqz(:)=gkq(:)
    gkqz(1)=0D0
    gkqz(2)=0D0
    kz=sqrt(DOT_PRODUCT(gkqz,MATMUL(bdot,gkqz)))
    
! First average v

    integral = integral + (1.0d0+exp(-kxy*zc)* &
      ((kz/kxy)*sin(kz*zc) -  cos(kz*zc))) &
      / length

! Do we also want to average W?

! This is a waste of time if we are not qk=0
    if (lengthqk.lt.TOL_zero.and.averagew) then

! Use model epsilon here 
! Normalize integral by head of epsilon
          
      vc = ((1.0d0 - exp(-kxy*zc))/kxy**2)
      epsmodel=1.0d0 + vc * kxy**2 * gamma*exp(-alpha*kxy)
      integralW = integralW + (vc/epsmodel) 

!      write(6,*)  'USING MODEL EPSILON FOR AVERAGING OF W'
!      write(6,*)  'gamma: ', gamma, 'alpha: ', alpha, 'qk', qk  
!      write(6,*)   'qk', qk  

! No model epsilon here
    endif
  enddo

! Convert integral to Ry

  integral = integral * 8D0 * PI_D / dble(nn) 
  if (lengthqk.lt.TOL_zero.and.averagew) then
    wcoul0 = integralW * 8D0 * PI_D / dble(nn) 
  endif

  POP_SUB(minibzaverage_2d_oneoverq2)
     
  return
end subroutine minibzaverage_2d_oneoverq2


!========================================================================


subroutine minibzaverage_3d_oneoverq(nn,bdot,integral,qran,qk)
  integer, intent(in) :: nn
  real(DP), intent(in) :: bdot(3,3), qran(:,:) !< (3,nn)
  real(DP), intent(out) :: integral
  real(DP), intent(in) ::  qk(3)

  integer :: ii
  real(DP) :: gkq(3), length
  
  PUSH_SUB(minibzaverage_3d_oneoverq)
  
  integral = 0D0
  
  do ii = 1, nn
    
    gkq(:) = qk(:) + qran(:,ii)
    length = DOT_PRODUCT(gkq,MATMUL(bdot,gkq))
    length = sqrt(length)
    integral = integral + 1D0/length
    
  enddo
  
  integral = integral * 8D0 * PI_D / dble(nn)
  
  POP_SUB(minibzaverage_3d_oneoverq)

  return
end subroutine minibzaverage_3d_oneoverq

!===========================================================================

subroutine minibzaverage_1d(gvec,N_k,bdot,integral,iparallel,qk,epshead,q0len,averagew,wcoul0)
  type (gspace), intent(in) :: gvec
  integer, intent(in) :: N_k ! number of k-points
  integer, intent(in) :: iparallel
  real(DP), intent(in) :: bdot(3,3),qk(3)
  real(DP), intent(out) :: integral
  logical, intent(in) :: averagew
  real(DP), intent(in) ::  q0len
  SCALAR, intent(in) ::  epshead
  SCALAR, intent(inout) ::  wcoul0

  real(DP) :: integralTemp
  SCALAR :: wcoul0temp
  real(DP) :: epsmodel,gamma,vc_qtozero

  logical :: first_minibz
  integer :: i, j, i1, i2, l1, l2, iline
  real(DP) :: sum_vt, adot(3,3), rr(3), tt(3), rx, ry
  real(DP) :: gpq_xy(2), gpq_z, r_len, t_len, scale, xline

  integer, parameter :: nline = 1000 ! Number of points in 1-D integral

  PUSH_SUB(minibzaverage_1d)

  integral = 0.0d0

  first_minibz = all(abs(qk(1:3)) .lt. Tol_Zero)

  rr = 0.0d0
  tt = 0.0d0

  call invert_matrix(bdot, adot)
  adot = adot * 4.d0 * PI_D * PI_D
  
  do i=1,2
    do j=1,2
      adot(i,j)=adot(i,j)/(dble(gvec%FFTgrid(i)) * dble(gvec%FFTgrid(j)))
    enddo
  enddo

  scale = adot(1,1)*adot(2,2) - adot(1,2)*adot(2,1)
  scale = 4.d0 * sqrt(scale)

! Compute parameters of epsilon model

  if (first_minibz .and. averagew) then
    vc_qtozero = 0D0

    do i2 = 1, gvec%FFTgrid(2)
      rr(2) = dble(i2-1) + trunc_shift(2)
      do i1 = 1, gvec%FFTgrid(1)
        rr(1) = dble(i1-1) + trunc_shift(1)

        r_len = INF

        do l2 = -ncell+1, ncell
          tt(2) = rr(2) - dble(l2 * gvec%FFTgrid(2))
          do l1 = -ncell+1, ncell
            tt(1) = rr(1) - dble(l1 * gvec%FFTgrid(1))   
            t_len = dot_product(tt,matmul(adot,tt))
            if (t_len < r_len) then
              r_len = t_len
            endif
          enddo ! l1
        enddo ! l2

        r_len = sqrt(r_len)
        vc_qtozero = vc_qtozero + dbesk0(q0len * r_len)

      enddo ! i1
    enddo ! i2

    vc_qtozero = vc_qtozero * scale
    gamma = ((1/epshead)-1.0D0) / (q0len**2 * vc_qtozero)
  endif

!#ifdef VERBOSE
!  if (peinf%inode .eq. 0) write(6,*) 'Using Model Epsilon'
!  if (peinf%inode .eq. 0) write(6,*) 'epshead ', epshead
!  if (peinf%inode .eq. 0) write(6,*) 'gamma ', gamma
!  if (peinf%inode .eq. 0) write(6,*) 'q0len ', q0len
!#endif

! Compute integral along z direction of minibz

  do iline = 1, nline
    if (iparallel .eq. 1 .and. mod(iline-1,peinf%npes) .ne. peinf%inode) cycle

    xline = ((dble(iline) - 0.5d0) / dble(nline) - 0.5d0) / dble(N_k)
    gpq_z = abs(qk(3)+xline)*sqrt(bdot(3,3))

    sum_vt = 0D0

    do i2 = 1, gvec%FFTgrid(2)
      rr(2) = dble(i2-1) + trunc_shift(2)

      do i1 = 1, gvec%FFTgrid(1)
        rr(1) = dble(i1-1) + trunc_shift(1)

        r_len = INF

        do l2 = -ncell+1, ncell
          tt(2) = rr(2) - dble(l2 * gvec%FFTgrid(2))
          do l1 = -ncell+1, ncell
            tt(1) = rr(1) - dble(l1 * gvec%FFTgrid(1))   
            t_len = dot_product(tt,matmul(adot,tt))
            if (t_len < r_len) then
              r_len = t_len
              rx = tt(1)
              ry = tt(2)
            endif
          enddo ! l1
        enddo ! l2

        r_len = sqrt(r_len)
        rx = rx/dble(gvec%FFTgrid(1))
        ry = ry/dble(gvec%FFTgrid(2))

        gpq_xy(1:2) = qk(1:2)
        sum_vt = sum_vt + dbesk0(gpq_z * r_len) * &
         cos(2.0d0 * PI_D * (gpq_xy(1)*rx + gpq_xy(2)*ry))

      enddo ! i1
    enddo ! i2

    sum_vt = sum_vt * scale
    integral = integral + sum_vt

    if (first_minibz .and. averagew) then
      epsmodel = 1.0D0 + gamma * gpq_z**2 * sum_vt
      wcoul0 = wcoul0 + (sum_vt / epsmodel) 
    endif

  enddo

  integral = integral / dble(nline)
  if (first_minibz .and. averagew) then
    wcoul0 = wcoul0 / dble(nline)
  endif

  if (iparallel .eq. 1) then
#ifdef MPI
    integralTemp=integral
    wcoul0Temp=wcoul0
    call MPI_Allreduce(integralTemp,integral,1,MPI_REAL_DP, &
     MPI_SUM,MPI_COMM_WORLD,mpierr)
    if (first_minibz .and. averagew) then
      call MPI_Allreduce(wcoul0Temp,wcoul0,1,MPI_SCALAR, &
       MPI_SUM,MPI_COMM_WORLD,mpierr)
    endif
#endif

#ifdef VERBOSE
    if (peinf%inode .eq. 0) then
      write(6,'(3x,"vcoul =",e20.12,1x,"wcoul0 =",e20.12)') integral, wcoul0
    endif
#endif

  endif

  POP_SUB(minibzaverage_1d)
  
  return
end subroutine minibzaverage_1d

! For modified coulomb interaction
subroutine minibzaverage_3d_oneoverq2_mod(nn,bdot,integral,qran,qk,coulomb_mod)
  integer, intent(in) :: nn
  real(DP), intent(in) :: bdot(3,3), qran(:,:) !< (3, nn)
  real(DP), intent(out) :: integral
  real(DP), intent(in) ::  qk(3)
  type(coulomb_modifier_t), intent(in)  :: coulomb_mod

  real(DP) :: gkq(3), screeninv, temp_exp, length 
  integer :: ii

  PUSH_SUB(minibzaverage_3d_oneoverq2_mod)
  
  integral = 0D0
  screeninv = 1.0D0/(4.0D0 * coulomb_mod%screening_length *coulomb_mod%screening_length)
  ! convert screening_length from A^{-1} to Bohr
  screeninv = screeninv/(BOHR*BOHR)
  
  do ii = 1, nn
    
    gkq(:) = qk(:) + qran(:,ii)
    length = DOT_PRODUCT(gkq,MATMUL(bdot,gkq))
    temp_exp = exp(-screeninv*length)
    integral = integral + 1D0/length*(temp_exp*coulomb_mod%long_range_frac_fock + &
                (1.0D0 - temp_exp)*coulomb_mod%short_range_frac_fock)
    
  enddo
  
  integral = integral * 8D0 * PI_D / dble(nn) 

  POP_SUB(minibzaverage_3d_oneoverq2_mod)
  
  return
end subroutine minibzaverage_3d_oneoverq2_mod

end module minibzaverage_m

!>=========================================================================
!!
!! Module:
!!
!! (1) kernel_io_m     Originally by FHJ     Last Modified 10/07/2013 (FHJ)
!!
!!     Routines to read and write kernel files (bsedmat, ...)
!!     Inspired on wfn_rho_vxc_io.F90.
!!
!!=========================================================================

#include "f_defs.h"

module kernel_io_m

  use global_m
  use wfn_rho_vxc_io_m

  implicit none

  private
 !> For library usage, do not make global_m contents available
 !! to avoid namespace clashes.

  public ::                        &
    read_binary_kernel_header,     &
    write_binary_kernel_header,    &
    read_format_kernel_header,     &
    write_format_kernel_header,    &
    read_kernel_header,            &
    write_kernel_header,           &
    xctinfo_to_kernel_header,      &
    check_xctinfo_kernel_header

contains

!===============================================================================
! FHJ: Below are the routines for kernel*mat files
!===============================================================================


#define FORMATTED
#define READ
!read_formatted_kernel_header
#include "kernel_io_inc.f90"
#undef READ
!write_formatted_kernel_header
#include "kernel_io_inc.f90"
#undef FORMATTED

#define BINARY
#define READ
!read_binary_kernel_header
#include "kernel_io_inc.f90"
#undef READ
!write_binary_kernel_header
#include "kernel_io_inc.f90"
#undef BINARY

#define READ
!read_kernel_header
#include "kernel_io_inc.f90"
#undef READ
!write_kernel_header
#include "kernel_io_inc.f90"

  !> Populate the non-MF part of a kernel_header_t type. We assume that the MF
  !! part, i.e., kernel%mf, is already set (although we do overwrite
  !! kernel%mf%sheader='BSE' to play safe).
  subroutine xctinfo_to_kernel_header(xct, kpts, kernel, nmat)
    type(xctinfo), intent(in) :: xct
    real(DP), intent(in) :: kpts(:,:) !< (3, nk)
    type(kernel_header_t), intent(inout) :: kernel
    integer, intent(in) :: nmat !< 1 for kernelxmat, 3 for kerneldmat

    PUSH_SUB(xctinfo_to_kernel_header)

    ! Generic variables
    kernel%mf%sheader = 'KER'
    kernel%iscreen = xct%iscreen
    kernel%icutv = xct%icutv
    kernel%ecute = xct%ecute

    ! Specific to kernelmat
    kernel%nk = xct%nkpt_co
    SAFE_ALLOCATE(kernel%kpt, (3,kernel%nk))
    kernel%kpt = kpts(1:3, 1:kernel%nk)

    kernel%ns = xct%nspin
    kernel%nspinor = 1 ! Hard coded for now
    kernel%nvb = xct%nvb_co
    kernel%ncb = xct%ncb_co
    kernel%n1b = xct%n1b_co
    kernel%n2b = xct%n2b_co

    kernel%theory = 0 ! Hard coded for now
    kernel%nmat = nmat
    kernel%storage = 0 ! Hard coded for now
    kernel%nblocks = 1
    if (xct%extended_kernel) kernel%nblocks = 4

    POP_SUB(xctinfo_to_kernel_header)

  end subroutine xctinfo_to_kernel_header

  subroutine check_xctinfo_kernel_header(fname, xct, kernel)
    character(len=*), intent(in) :: fname !< file name
    type(xctinfo), intent(in) :: xct
    type(kernel_header_t), intent(in) :: kernel

    integer :: nblocks

    PUSH_SUB(check_xctinfo_kernel_header)

    ! Generic variables
    ! FHJ: absorption doesn`t care about WFN cutoff (for now!)
    !call check_R('WFN cutoff', xct%ecutg, kernel%mf%kp%ecutwfc)
    call check_I('screening flag', xct%iscreen, kernel%iscreen)
    call check_I('truncation flag', xct%icutv, kernel%icutv)
    ! FHJ: absorption doesn`t care about epsilon cutoff
    !call check_R('epsilon cutoff', xct%ecute, kernel%ecute)

    ! Specific to bsemat
    call check_I('# of k-point', xct%nkpt_co, kernel%nk)

    call check_I('# of spins', xct%nspin, kernel%ns)
    call check_I('# of spinor components', 1, kernel%nspinor) ! Hard coded for now
    call check_I('# of val. bands', xct%nvb_co, kernel%nvb)
    call check_I('# of cond. bands', xct%ncb_co, kernel%ncb)
    call check_I('# of bands 1', xct%n1b_co, kernel%n1b)
    call check_I('# of bands 2', xct%n2b_co, kernel%n2b)

    call check_I('theory level', 0, kernel%theory) ! Hard coded for now
    nblocks = 1
    if (xct%extended_kernel) nblocks = 4
    call check_I('number of transition blocks', nblocks, kernel%nblocks)
    call check_I('storage format', 0, kernel%storage) ! Hard coded for now
  
    POP_SUB(check_xctinfo_kernel_header)

    contains

      subroutine check_I(label, ref, got)
        character(len=*), intent(in) :: label
        integer, intent(in) :: ref
        integer, intent(in) :: got

        PUSH_SUB(check_xctinfo_kernel_header.check_I)

        if (ref/=got) then
          if (peinf%inode==0) then
            write(0,'(1x,a)') 'ERROR: incompatible values found in file "'//TRUNC(fname)//'".'
            write(0,'(1x,a)') 'Quantity: '//TRUNC(label)
            write(0,'(1x,i0)') 'Expected: ', ref
            write(0,'(1x,i0)') 'Got: ', got
          endif
          call die('Incompatible values in file "'//TRUNC(fname)//'"/', &
            only_root_writes=.true.)
        endif

        POP_SUB(check_xctinfo_kernel_header.check_I)

      end subroutine check_I

      subroutine check_R(label, ref, got)
        character(len=*), intent(in) :: label
        real(DP), intent(in) :: ref
        real(DP), intent(in) :: got

        real(DP) :: tol=TOL_Small

        PUSH_SUB(check_xctinfo_kernel_header.check_R)

        if (dabs(ref-got)>tol) then
          if (peinf%inode==0) then
            write(0,'(1x,a)') 'ERROR: incompatible values found in file "'//TRUNC(fname)//'".'
            write(0,'(1x,a)') 'Quantity: '//TRUNC(label)
            write(0,'(1x,a,f0.8)') 'Expected: ', ref
            write(0,'(1x,a,f0.8)') 'Got: ', got
          endif
          call die('Incompatible values in file "'//TRUNC(fname)//'"/', &
            only_root_writes=.true.)
        endif

        POP_SUB(check_xctinfo_kernel_header.check_R)

      end subroutine check_R

  end subroutine check_xctinfo_kernel_header


end module kernel_io_m

#include "f_defs.h"

!-----------------------------------------------------------------------
subroutine input(crys,gvec,kg,kp,syms,eqp,xct,flag, &
  omega_plasma,is_diag,intwfnc)
!-----------------------------------------------------------------------
!
!     Read data from file WFN_fi and initialize variables
!
!     output: crys, gvec, kg, syms, eqp types
!             INT_CWFN_* files (if flag%vm.ne.1.or. .not. flag%read_dtmat)
!
  use global_m
  use checkbz_m
  use eqpcor_m
  use fullbz_m
  use input_utils_m
  use misc_m
  use scissors_m
  use sort_m
  use wfn_rho_vxc_io_m
  use intpts_m
  use io_utils_m
  implicit none

  type (crystal), intent(out) :: crys
  type (gspace), intent(out) :: gvec
  type (grid), intent(out) :: kg
  type (kpoints), intent(out) :: kp
  type (symmetry), intent(out) :: syms
  type (eqpinfo), intent(inout) :: eqp
  type (xctinfo), intent(inout) :: xct
  type (flags), intent(in) :: flag
  real(DP), intent(out) :: omega_plasma
  logical, intent(in) :: is_diag
  type (int_wavefunction), intent(out) :: intwfnc

  type (wavefunction) :: wfnc
  character :: filenamec*20
  character :: tmpfn*16
  character :: fncor*32
  integer :: iunit_c,iwrite

  integer :: ii,jj,kk,nn,nmat,is,isp,ik,irk,irk_kp,ib,ib_kp
  integer :: dest,tag,ic,iv,iwritetotal,ijk
  integer :: irks
  real(DP) :: diffvol,vcell,kt(3),div
  real(DP) :: test,tol,qtot
  real(DP), allocatable :: eltr(:),kltr(:,:),ek_tmp(:)
  integer, allocatable :: kcvltr(:,:),indxk(:),k_tmp(:,:)
  integer, allocatable :: index(:),isend(:),iwriteik(:)
  SCALAR, allocatable :: cg(:,:), cgarray(:)

  character(len=3) :: sheader
  integer :: iflavor
  type(gspace) :: gvec_kpt
  integer :: last_ng, last_ng_match, last_ikt
  logical :: skip_checkbz, broken_degeneracy
  !> Number of bands that were corrected (via scissors or eqp). We can`t find 
  !! the FE using more bands than this number.
  integer :: bands_cor, minband
  type(progress_info) :: prog_info

!-----------------------------------------------------------------------
! Read info for crystal from WFN_fi

  PUSH_SUB(input)

  if(peinf%inode == 0) call open_file(25,file='WFN_fi',form='unformatted',status='old')

  sheader = 'WFN'
  iflavor = 0
  call read_binary_header_type(25, sheader, iflavor, kp, gvec, syms, crys, &
    dont_warn_kgrid=xct%patched_sampling.or..not.xct%is_absorption)
  call check_trunc_kpts(xct%icutv, kp)

!-----------------------------------------------------------------------
!     Read info for g-vectors from WFN_fi
!

  call logit('input:  reading gvec info')

  SAFE_ALLOCATE(gvec%components, (3, gvec%ng))
  call read_binary_gvectors(25, gvec%ng, gvec%ng, gvec%components)

  call get_volume(vcell,crys%bdot)
  diffvol=abs(crys%celvol-vcell)
  if (diffvol.gt.TOL_Small) then
    call die('volume mismatch', only_root_writes = .true.)
  endif

  xct%nspin=kp%nspin
  if(xct%nspin == 2 .and. flag%krnl == 0) &
    call die("spin_triplet concept applies only to a spin-unpolarized calculation.", only_root_writes = .true.)

  if(any(kp%ifmax(:,:) == 0)) &
    call die("BSE codes cannot handle a system where some k-points have no occupied bands.", only_root_writes = .true.)

  kp%nvband=minval(kp%ifmax(:,:)-kp%ifmin(:,:))+1
  kp%ncband=kp%mnband-maxval(kp%ifmax(:,:))

!-----------------------------------------------------------
! Manual override of band numbers

  if (xct%vmax.ne.0) then
    kp%nvband = xct%vmax-xct%vmin+1
    kp%ncband = kp%mnband-xct%vmax
    if (peinf%inode.eq.0) then
      write(6,*)
      write(6,*) '*** Overwrite min/max occupied state for fine-grid wavefunctions'
      write(6,*) '*** kp%nvband =',kp%nvband,' kp%ncband =',kp%ncband
      write(6,*)
    endif
  endif

!-----------------------------------------------------------
! Manual override of regular grid
! it matters only if you want to perform minicell averages

  if (xct%rgrid(1).ne.0) kp%kgrid = xct%rgrid

!----------------------------------------------------------------
! (gsm) check whether the requested number of bands
!       is available in the wavefunction file

! we only use the conduction bands from WFN_fi
! if flag%vm.eq.1.and.flag%read_dtmat we don`t need them at all

  if(flag%vm .ne. 1 .or. .not. flag%read_dtmat) then

    if(xct%ncb_fi.gt.kp%ncband) then
      call die("The requested number of conduction bands is not available in WFN_fi.")
    endif

  endif

!----------------------------------------------------------------------
!     Read the k-point sampling from kpoints (if it exists) or from
!     WFN_fi. In either case, this sampling will define the irreducible
!     Brillouin zone.

  if (xct%read_kpoints) then
    if (peinf%inode.eq.0) then
      call open_file(9,file='kpoints',form='formatted',status='old')
      read(9,*) kg%nr
      SAFE_ALLOCATE(kg%r, (3,kg%nr))
      do ii=1,kg%nr
        read(9,*) (kg%r(jj,ii),jj=1,3),div
        kg%r(:,ii) = kg%r(:,ii)/div
      enddo
      call close_file(9)
    endif
#ifdef MPI
    call MPI_BCAST(kg%nr,   1,     MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
    if(peinf%inode.ne.0) then
      SAFE_ALLOCATE(kg%r, (3,kg%nr))
    endif
    call MPI_BCAST(kg%r,    3*kg%nr,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
#endif

!     indxk : stores the correspondence between k-points kg%r and kp%rk
!     (it is used to select the set of wavefunctions to be stored)
!     tol : tolerance in the coordinates of k-points

    tol = TOL_Small
    SAFE_ALLOCATE(indxk, (kg%nr))
    indxk=0
    do jj=1,kg%nr
      do ii=1,kp%nrk
        kt(:) = kg%r(:,jj) - kp%rk(:,ii)
        if (all(abs(kt(1:3)).lt.tol)) then
          if (indxk(jj).ne.0) write(0,*) 'WARNING: multiple definition of k-point',jj,indxk(jj),kg%r(:,jj)
          indxk(jj)=ii
        endif
      enddo
      
!     If some k-point listed in kg%r is not found in WFN_fi, indxk
!     will store zero. Later, the job will stop in genwf.

      if (indxk(jj).eq.0) write(0,*) 'WARNING: could not find vector ',kg%r(:,jj),' in WFN_fi'
    enddo
  else
    kg%nr=kp%nrk
    SAFE_ALLOCATE(kg%r, (3,kg%nr))
    kg%r(1:3,1:kg%nr)=kp%rk(1:3,1:kp%nrk)
    SAFE_ALLOCATE(indxk, (kg%nr))
    do ii=1,kg%nr
      indxk(ii) = ii
    enddo
  endif

!-----------------------------------------------------------------------
!     Generate full brillouin zone from irreducible wedge, rk -> fk
!
!     If flag%bz0.eq.1, only Identity will be used as
!     symmetry operation. In this case, kg%r (irreducible BZ) and kg%f
!     (full BZ) will be identical.
!
  if (flag%bz0.eq.1 .and. .not. xct%is_absorption) then
    ! in the inteqp code, we want to leave the k-points alone, if symmetries are not being used.
    call fullbz(crys,syms,kg,1,skip_checkbz,wigner_seitz=.false.,paranoid=.false.,do_nothing=.true.)
  else if (flag%bz0.eq.1) then
    call fullbz(crys,syms,kg,1,skip_checkbz,wigner_seitz=.true.,paranoid=.true.)
  else
    call fullbz(crys,syms,kg,syms%ntran,skip_checkbz,wigner_seitz=.true.,paranoid=.true.)
  endif
  tmpfn='WFN_fi'
  if (.not. skip_checkbz .and. .not.xct%patched_sampling) then
    call checkbz(kg%nf,kg%f,kp%kgrid,kp%shift,crys%bdot, &
      tmpfn,'k',.true.,xct%freplacebz,xct%fwritebz)
  endif
!
  if (flag%bz0.eq.0.and.peinf%inode.eq.0) write(6,801)
  if (flag%bz0.eq.1.and.peinf%inode.eq.0) write(6,802)
801 format(1x,'Using symmetries to expand the fine-grid sampling',/)
802 format(1x,'No symmetries used in the fine grid-sampling',/)
!
  xct%nkpt_fi = kg%nf
  xct%nktotal = kg%nf
  if (xct%patched_sampling) then
    ! FHJ: the main assumption of the patched sampling is that the volume of
    ! each mini-BZ is given by the number of k-points before decimating the WFN.
    ! Still, shouldn`t this line be used always, even for regular sampling?
    xct%nktotal = product(kp%kgrid)
  endif
  
  if (peinf%inode .eq. 0) then
    write(6,"(1x,'kgrid:',3i4)") kp%kgrid
  endif
  
!-----------------------------------------------------------------------

  SAFE_ALLOCATE(kp%elda, (kp%mnband, kp%nrk, kp%nspin))
  kp%elda(:,:,:) = kp%el(:,:,:)
  call scissors_shift(kp, eqp%scis, eqp%spl_tck)

!-----------------------------------------------------------------------
! If quasi-particle correction requested, read the corrected
! qp energies from file (in eV)

  bands_cor = kp%mnband
  minband = 1
  if(xct%eqp_corrections) then
    fncor='eqp.dat'
    bands_cor = maxval(kp%ifmax(:,:)) + xct%ncb_fi
    minband = minval(kp%ifmax(:,:)-xct%nvb_fi+1)
    ! FIXME: for metals this is asking for a few more bands than actually needed on some k-points
    call eqpcor(fncor,peinf%inode,peinf%npes,kp,&
      minval(kp%ifmax(:,:)-xct%nvb_fi+1),bands_cor,0,0,kp%el,kp%el,kp%el,1,0)
  endif

  call find_efermi(xct%rfermi, xct%efermi, xct%efermi_input, kp, bands_cor, minband, &
    "fine grid", should_search = .true., should_update = .true., write7 = .false.)

  call assess_degeneracies(kp, kp%el(kp%mnband, :, :), kp%mnband - 1, xct%efermi, TOL_Degeneracy)

  call calc_qtot(kp, crys%celvol, xct%efermi, qtot, omega_plasma, write7 = .false.)

! DAS: degenerate subspace check

  ! degeneracy does not matter for WFN_fi in inteqp
  if((flag%vm .ne. 1 .or. .not. flag%read_dtmat) .and. peinf%inode == 0 .and. xct%is_absorption) then
    if(xct%ncb_fi.eq.kp%ncband) then
      call die("You must provide one more conduction band in WFN_fi in order to assess degeneracy.")
    endif
    broken_degeneracy = .false.
    do jj = 1, kp%nspin
      do ii = 1, kp%nrk
        if(abs(kp%elda(kp%ifmax(ii, jj) + xct%ncb_fi, ii, jj) &
          - kp%elda(kp%ifmax(ii, jj) + xct%ncb_fi + 1, ii, jj)) .lt. TOL_Degeneracy) then
          broken_degeneracy = .true.
        endif
      enddo
    enddo

    if(broken_degeneracy) then
      if(xct%degeneracy_check_override) then
        write(0,'(a)') &
          "WARNING: Selected number of conduction bands breaks degenerate subspace in WFN_fi. " // &
          "Run degeneracy_check.x for allowable numbers."
        write(0,*)
      else
        write(0,'(a)') &
          "Run degeneracy_check.x for allowable numbers, or use keyword " // &
          "degeneracy_check_override to run anyway (at your peril!)."
        call die("Selected number of conduction bands breaks degenerate subspace in WFN_fi.")
      endif
    endif
  endif

!-----------------------------------------------------------------------
!     Work with energy arrays: ec,ev,eclda,evlda (all in Ryd!)
!     xct%evqp          QP valence energies
!     xct%ecqp          QP conduction energies
!     xct%evlda         LDA valence energies (used only
!        with momentum operator)
!     xct%eclda         LDA conduction energies (idem)
!      The label of bands in xct%evqp and xct%evlda is again reversed:
!      from higher to lower energies.

  SAFE_ALLOCATE(eqp%evqp, (xct%nvb_fi,xct%nkpt_fi,xct%nspin))
  SAFE_ALLOCATE(eqp%ecqp, (xct%ncb_fi,xct%nkpt_fi,xct%nspin))
  SAFE_ALLOCATE(eqp%evlda, (xct%nvb_fi,xct%nkpt_fi,xct%nspin))
  SAFE_ALLOCATE(eqp%eclda, (xct%ncb_fi,xct%nkpt_fi,xct%nspin))

! FHJ: loop thru indices on `eqp` grid, and then find the
!      corresponding labels on the `kp` grid
  do is=1,xct%nspin
    do irk=1,xct%nkpt_fi
      !irkq = index of q-pt on `kp` grid
      irk_kp = indxk(kg%indr(irk))

      !loop thru bands of `kp` grid
      do ib_kp=1, kp%mnband

        !ib = band index on `eqp` grid
        ib = kp%ifmax(irk_kp,is) - ib_kp + 1

        if (ib > 0) then
          !if ib is one of the selected valence bands
          if (ib <= xct%nvb_fi) then
            eqp%evqp    (ib, irk, is) = kp%el  (ib_kp, irk_kp, is)
            eqp%evlda   (ib, irk, is) = kp%elda(ib_kp, irk_kp, is)
          endif
        else
          ib = 1 - ib !transform negative val. index into positive cond. index
          !if ib is one of the selected conduction bands
          if (ib <= xct%ncb_fi) then
            eqp%ecqp (ib, irk, is) = kp%el  (ib_kp, irk_kp, is)
            eqp%eclda(ib, irk, is) = kp%elda(ib_kp, irk_kp, is)
          endif
        endif

      enddo
    enddo
  enddo
      
  if (peinf%inode.eq.0) then
    call scissors_write(6, eqp%scis)
  endif

!-----------------------------------------------------------------------
!       Distribute kpoints among the PEs
!
  call logit('input:  calling distrib')
  call distrib(xct,gvec%FFTgrid,kp%kgrid,is_diag)

!-----------------------------------------------------------------------
! gsm: store xct%ifmax for generating eqp/eqp_q.dat in intwfn

  SAFE_ALLOCATE(xct%ifmax, (xct%nkpt_fi,xct%nspin))
  xct%ifmax(:,:) = kp%ifmax(kg%indr(:),:)

!-----------------------------------------------------------------------
!     Order g-vectors with respect to their kinetic energy

  call logit('input:  reordering gvecs')
  SAFE_ALLOCATE(index, (gvec%ng))
  SAFE_ALLOCATE(gvec%ekin, (gvec%ng))
  call kinetic_energies(gvec, crys%bdot, gvec%ekin)
  call sortrx(gvec%ng, gvec%ekin, index, gvec = gvec%components)

  SAFE_ALLOCATE(ek_tmp, (gvec%ng))
  ek_tmp = gvec%ekin
  SAFE_ALLOCATE(k_tmp, (3,gvec%ng))
  k_tmp = gvec%components
  do ii=1,gvec%ng
    gvec%ekin(ii) = ek_tmp(index(ii))
    gvec%components(:,ii) = k_tmp(:,index(ii))
  enddo
  SAFE_DEALLOCATE(ek_tmp)
  SAFE_DEALLOCATE(k_tmp)
  SAFE_DEALLOCATE(index)

  call gvec_index(gvec)
  
!-----------------------------------------------------------------------
!     Read the wavefunctions and create INT_CWFN_*
!
  if (flag%read_dtmat .and. flag%vm /= 0) then
    if (peinf%inode.eq.0) write(6,*) ' Bypassing INT_CWFN_*'
    call write_transitions()
    POP_SUB(input)
    return
  endif
    
  call logit('input:  reading WFN_fi')
  wfnc%nband=xct%ncb_fi
  wfnc%nspin=kp%nspin
  wfnc%nspinor=kp%nspinor

  if (xct%iwriteint .eq. 0) then
    if(peinf%inode.lt.10000) then
      write(filenamec,'(a,i4.4)') 'INT_CWFN_', peinf%inode
    else
      call die("input: cannot use more than 10000 nodes")
    endif
    iunit_c=128+(2*peinf%inode)+1
    call open_file(iunit_c,file=filenamec,form='unformatted',status='replace')
  else
    SAFE_ALLOCATE(intwfnc%ng, (peinf%ikt(peinf%inode+1)))
    SAFE_ALLOCATE(intwfnc%isort, (gvec%ng,peinf%ikt(peinf%inode+1)))
    SAFE_ALLOCATE(intwfnc%cgk, (kp%ngkmax,wfnc%nband,kp%nspin*kp%nspinor,peinf%ikt(peinf%inode+1)))
  endif

  SAFE_ALLOCATE(wfnc%isort, (gvec%ng))
  SAFE_ALLOCATE(isend, (peinf%npes))
  wfnc%isort=0
  last_ikt=-1
  last_ng=-1
  last_ng_match=-1
  call progress_init(prog_info, 'reading wavefunctions (WFN_fi)', 'k-point', kp%nrk)
  do irk=1,kp%nrk
    call progress_step(prog_info, irk)
    irks = 0
    do ii=1,kg%nr
      if (irk.eq.indxk(ii)) then
        irks=ii
        exit
      endif
    enddo

    wfnc%ng = kp%ngk(irk)

! FHJ: Realloc arrays. Note that we can`t do something like
!      "if (wfnc%ng>last_ng)"  b/c fortran complains at read_binary_gvectors 
!      if the vectors are not exactly wfnc%ng big.
    if(wfnc%ng/=last_ng) then
      if(last_ng/=-1) then
        SAFE_DEALLOCATE_P(gvec_kpt%components)
        SAFE_DEALLOCATE(cg)
      endif
      SAFE_ALLOCATE(gvec_kpt%components, (3, wfnc%ng))
      SAFE_ALLOCATE(cg, (wfnc%ng, kp%nspin*kp%nspinor))
      last_ng = wfnc%ng
    endif

    call read_binary_gvectors(25, wfnc%ng, wfnc%ng, gvec_kpt%components)

    if(irks > 0) then
      do ii = 1, kp%ngk(irk)
        call findvector(wfnc%isort(ii), gvec_kpt%components(:, ii), gvec)
        if(wfnc%isort(ii) == 0) call die('input: could not find gvec')
      enddo

! FHJ: Realloc arrays.
      if(wfnc%ng/=last_ng_match) then
        if(last_ng_match/=-1) then
          SAFE_DEALLOCATE_P(wfnc%cg)
          SAFE_DEALLOCATE(cgarray)
        endif
        SAFE_ALLOCATE(wfnc%cg, (wfnc%ng, wfnc%nband, wfnc%nspin*wfnc%nspinor))
        SAFE_ALLOCATE(cgarray, (wfnc%ng))
        last_ng_match = wfnc%ng
      endif
      if(peinf%ikt(peinf%inode+1)/=last_ikt) then
        if(last_ikt/=-1) then
          SAFE_DEALLOCATE(iwriteik)
        endif
        SAFE_ALLOCATE(iwriteik,(peinf%ikt(peinf%inode+1)))
        last_ikt = peinf%ikt(peinf%inode+1)
      endif

!       Determine which PEs will write the wavefunctions for this k-point
      iwrite=0
      iwritetotal=0
      iwriteik=0
      do ii=1, peinf%ikt(peinf%inode+1)
        if(kg%indr(peinf%ik(peinf%inode+1,ii)).eq.irks) then
          iwritetotal=iwritetotal+1
          iwriteik(iwritetotal)=ii
          iwrite=1
        endif
      enddo

!       Determine to which PEs the wavefunctions for this k-point
!       need to be sent...
      isend=0
      if(peinf%inode.eq.0) then
        do jj=2,peinf%npes
          do ii=1, peinf%ikt(jj)
            if(kg%indr(peinf%ik(jj,ii)).eq.irks) then
              isend(jj)=1
              exit
            endif
          enddo
        enddo
      endif
    endif
!
!       Loop over the bands
!
    do ii=1,kp%mnband

      call read_binary_data(25, kp%ngk(irk), kp%ngk(irk), kp%nspin*kp%nspinor, cg, bcast=.false.)

      if(irks == 0) cycle

      do is=1, kp%nspin
!         If ii is one of the selected conduction bands...
        if((ii.gt.kp%ifmax(irks,is).and. &
          ii.le.kp%ifmax(irks,is)+xct%ncb_fi)) then

          do isp=1, kp%nspinor
            if (peinf%inode.eq.0) then
              cgarray(1:kp%ngk(irk))=cg(1:kp%ngk(irk), is*isp)
#ifdef VERBOSE
              write(6,'(a, 3i7, 2(f18.13))') 'input', irks, ii, is*isp, cgarray(1)
#endif
            end if
#ifdef MPI
            if(peinf%inode.eq.0) then
              do jj=2,peinf%npes
                if(isend(jj).eq.1) then
                  dest=jj-1
                  tag=1000+dest*2-(is-1)
                  call MPI_SEND(cgarray,kp%ngk(irk),MPI_SCALAR, &
                    dest,tag,MPI_COMM_WORLD,mpierr)
                endif
              enddo
            else
              if(iwrite.eq.1) then
                tag=1000+peinf%inode*2-(is-1)
                call MPI_RECV(cgarray,kp%ngk(irk),MPI_SCALAR,0,tag, &
                  MPI_COMM_WORLD,mpistatus,mpierr)
              endif
            endif
#endif
            if(iwrite.eq.1) then
              wfnc%cg(1:wfnc%ng,ii-kp%ifmax(irks,is),is*isp) = cgarray
            endif
          enddo
          if(iwrite.eq.1) then
            !FHJ: We only Send/Recv and check one spin at a time
            call checknorm('WFN_fi',ii,irks,kp%ngk(irk),is,kp%nspinor,&
                         wfnc%cg(:,ii-kp%ifmax(irks,is),:))
          endif
        endif
      enddo
      
    enddo
    if(irks == 0) cycle
    
    if(iwrite.eq.1) then
      
      if (xct%iwriteint .eq. 0) then 
        write(iunit_c) irks,wfnc%ng,wfnc%nband,wfnc%nspin,wfnc%nspinor
        write(iunit_c) (wfnc%isort(ii),ii=1,gvec%ng), &
          (((wfnc%cg(ii,jj,kk),ii=1,wfnc%ng),jj=1,wfnc%nband),kk=1,wfnc%nspin*wfnc%nspinor)
      else
        do ijk = 1, iwritetotal
          intwfnc%ng(iwriteik(ijk))=wfnc%ng
          intwfnc%isort(:,iwriteik(ijk))=wfnc%isort(:)
          intwfnc%cgk(1:wfnc%ng,:,:,iwriteik(ijk))=wfnc%cg(1:wfnc%ng,:,:)
        enddo
      endif
    endif
  enddo !end loop over k-points
  call progress_free(prog_info)

  SAFE_DEALLOCATE(isend)
  SAFE_DEALLOCATE_P(wfnc%isort)

  if(last_ikt/=-1) then
    SAFE_DEALLOCATE(iwriteik)
  endif
  if(last_ng_match/=-1) then
    SAFE_DEALLOCATE_P(wfnc%cg)
    SAFE_DEALLOCATE(cgarray)
  endif
  if(last_ng/=-1) then
    SAFE_DEALLOCATE_P(gvec_kpt%components)
    SAFE_DEALLOCATE(cg)
  endif
  
  SAFE_DEALLOCATE(indxk)

  if (xct%iwriteint .eq. 0) call close_file(iunit_c)

  call write_transitions()

#ifdef MPI
  if(xct%iwriteint == 0) call MPI_Barrier(MPI_COMM_WORLD, mpierr)
#endif

  POP_SUB(input)  
  return

contains

  subroutine write_transitions()

    PUSH_SUB(input.write_transitions)
    
    if(peinf%inode.eq.0) then
      write(6,'(/,1x,a)') 'Conduction wavefunctions read from file WFN_fi'
      write(6,'(1x,a,i8)') ' - Number k-points in irreducible BZ: ', kg%nr
      write(6,'(1x,a,i8)') ' - Number k-points in full BZ: ', kg%nf
      write(6,'(1x,a,f12.6,a)') ' - Effective k-point radius: ', kg%sz,' Bohr^-1'
#ifdef VERBOSE
      write(6,'(/,1x,a)') 'Listing all k-points:'
      write(6,'(3x,3f15.9)') ((kg%r(ii,jj),ii=1,3),jj=1,kg%nr)
      write(6,'(1x,a,/)') 'Done listing k-points'
#endif
      call close_file(25)
    endif ! node 0

    ! hang on to k-points to check in input_co that grids are the same
    if(.not. xct%skipinterp) then
      SAFE_DEALLOCATE_P(kp%rk)
    endif
    SAFE_DEALLOCATE_P(kp%ifmin)
    SAFE_DEALLOCATE_P(kp%ifmax)
    SAFE_DEALLOCATE_P(kp%el)

!-----------------------------------------------------------------------
!     Print out information about the nn lowest energy transitions for
!     spin up states. The array eltr has the lowest nmat energy
!     transitions, with corresponding bands/k-points in kltr, kcvltr.
!     This can also be used to locate the location in BZ
!     of all transitions within a predefined energy range.
!
    if(peinf%inode.eq.0) then
      nmat=100
      SAFE_ALLOCATE(eltr, (nmat))
      SAFE_ALLOCATE(kltr, (3,nmat))
      SAFE_ALLOCATE(kcvltr, (3,nmat))
      kltr=0.d0
      kcvltr=0
      eltr(:)=1.d8
      eltr(1)=eqp%ecqp(1,1,1) - eqp%evqp(1,1,1)
      kltr(:,1)=kg%f(:,1)
      kcvltr(:,1)=1
      
      do ik=1,xct%nkpt_fi
        do iv=1,xct%nvb_fi
          ic_loop: do ic=1,xct%ncb_fi
            if (ik.eq.1 .and. ic.eq.1 .and. iv.eq.1) cycle ic_loop
            test=eqp%ecqp(ic,ik,1) - eqp%evqp(iv,ik,1)
            do jj=1,nmat
              if (test.lt.eltr(jj)) then
                do kk=nmat-1,jj,-1
                  eltr(kk+1) = eltr(kk)
                  kltr(:,kk+1)=kltr(:,kk)
                  kcvltr(:,kk+1)=kcvltr(:,kk)
                enddo
                eltr(jj)=test
                kltr(:,jj)=kg%f(:,ik)
                kcvltr(1,jj)=ik
                kcvltr(2,jj)=ic
                kcvltr(3,jj)=iv
                cycle ic_loop
              endif
            enddo
          enddo ic_loop
        enddo
      enddo
        
      eltr(:)=eltr(:)*ryd
      write(6,*)
      write(6,*) ' Lowest energy transitions : [eV]'
      nn=5
      do jj=1,nn
        if (kcvltr(1,jj)>0) then
          write(6,210) (kltr(ii,jj),ii=1,3), &
            (kcvltr(ii,jj),ii=1,3),eltr(jj)
        endif
      enddo
210   format(2x,' ( ',f6.3,' , ',f6.3,' , ',f8.3,' ) ',3i4,f11.6)
      SAFE_DEALLOCATE(eltr)
      SAFE_DEALLOCATE(kltr)
      SAFE_DEALLOCATE(kcvltr)
    endif

    POP_SUB(input.write_transitions)
    return
      
  end subroutine write_transitions

end subroutine input

!=======================================================================================
!
! Module inread_m
!
! (1) inread()          Originally By MLT               Last Modified 7/8/2008 (JRD)
!
!     Read input parameters from file absorption.inp / inteqp.inp.
!
!     input: none
!
!     output: many components of xct
!             nmax :            number of iterations to be performed
!                               (Haydock only!)
!             neig :            number of eigenvectors/eigenvalues
!                               to be computed (diagonalization only!)
!
!=============================================================================================

#include "f_defs.h"

module inread_m

  use global_m
  use scissors_m

  implicit none

  private

  public :: inread

contains

!> supply optionals for absorption, and do not for inteqp
subroutine inread(eqp,xct,flag,nmax,neig,diagonalization)
  type (eqpinfo), intent(out) :: eqp
  type (xctinfo), intent(out) :: xct
  type (flags), intent(out) :: flag
  integer, optional, intent(out) :: nmax,neig
  logical, optional, intent(out) :: diagonalization

  character*256 :: blockword,keyword,line,errmsg,filename
  integer :: ii,iostat
  logical :: unknown_keyword, found
  
  PUSH_SUB(inread)

  xct%is_absorption = present(nmax) .and. present(neig) .and. present(diagonalization)
  if(xct%is_absorption .neqv. (present(nmax) .or. present(neig) .or. present(diagonalization))) then
    call die("inread internal error: all or no optional arguments must be supplied.")
  endif

  if(xct%is_absorption) then
    filename = 'absorption.inp'
  else
    filename = 'inteqp.inp'
  endif

#ifdef MPI
  ! Non-root nodes should wait for root to read the whole file.
  ! That way, we can be sure root gets a chance to write errors before
  ! any die call is issued by another node. Root calls MPI_Barrier below.
  if(peinf%inode /= 0) call MPI_Barrier(MPI_COMM_WORLD, mpierr)
#endif

!--------------------------
! Set default values

  xct%nvb_fi=0
  xct%nvb_co=0
  xct%ncb_fi=0
  xct%inteqp = .not. xct%is_absorption
  xct%ncb_co=0
  xct%nkpt_co = 0
  call scissors_zero(eqp%scis)
  eqp%spl_tck%n=0 
  if(xct%is_absorption) then
    flag%opr = -1 ! no default
  else
    flag%opr = 1  ! momentum for inteqp
  endif
  flag%spec=0
  if(xct%is_absorption) flag%lor=1
  flag%read_dtmat=.false.
  flag%vm=0
  flag%read_epsdiag=.false.
  flag%eig=0
  flag%krnl=1
  flag%bz0=1
  flag%bzq=1
  flag%bzc=1
  if(xct%is_absorption) nmax=0
  xct%read_kpoints = .false.
  xct%shift(:)=0.d0
  xct%pol(:)=0.d0
  xct%icutv=0
  xct%iscreen=0
  xct%renorm_transf=.true.
  xct%iwritecoul=0
  xct%skipinterp=.false.
  xct%iabsorp0=0
  xct%truncval(1:3)=0.0d0
  xct%wplasmon=0.0d0
  if(xct%is_absorption) neig=0
  xct%vmin=1
  xct%vmax=0
  xct%rgrid=0
  xct%qflag=1
  xct%efermi_input=0.0d0
  xct%rfermi=.true.
  xct%avgcut=TOL_Zero
  xct%scaling=1.0d0
  xct%iwriteint=1
  xct%freplacebz=.false.
  xct%fwritebz=.false.
  xct%delaunay_interp=.true.
  xct%degeneracy_check_override = .false.
  if(xct%is_absorption) then
    xct%averagew=.true.
    xct%eta=0.0d0
    xct%sigma=0.0d0
    xct%gamma=0.0d0
  endif
  xct%eqp_corrections=.false.
  ! inteqp does nothing without eqp_co_corrections
  xct%eqp_co_corrections = .not. xct%is_absorption
  if(xct%is_absorption) diagonalization=.true.
  xct%extended_kernel=.false.
  xct%unrestricted_transf=.false.
  xct%zero_unrestricted_contrib=.false.
  xct%patched_sampling=.false.
  xct%patched_sampling_co=.false.
  xct%zero_q0_element=0
  xct%theory=0
  xct%coulomb_mod%short_range_frac_fock=1.0d0
  xct%coulomb_mod%long_range_frac_fock=1.0d0
  xct%coulomb_mod%screening_length=0.0d0
  xct%coul_mod_flag=.false.
  xct%npts_intp_kernel = 1
  xct%subsample_cutoff = -10.d0
  xct%subsample_line = .false.
#ifdef HDF5
  xct%use_hdf5 = .true.
#else
  xct%use_hdf5 = .false.
#endif
  xct%tda = .true.

!-----------------------------
! Never ending loop...

  do while(0.eq.0)

! Actually the loop ends when the end of the file is reached

    read(8,'(a256)',iostat=iostat) line
    if(iostat < 0) exit

! Skip comment lines

    if(len_trim(line).eq.0 .or. line(1:1).eq.'#') cycle

! Determine keyword:
    
    keyword=line(1:scan(line," ")-1)
    line=adjustl(line(scan(line," ")+1:256))
    
    unknown_keyword = .false.
    if(trim(keyword).eq.'begin') then
      blockword=line(1:scan(line," ")-1)
      ii=0
      do while(trim(line).ne.'end')
        read(8,'(a256)',iostat=iostat) line
        if(iostat /= 0) then
          write(errmsg,'(3a)') 'The end of the file was reached while reading elements of the ', &
            trim(blockword),' block. '
          call die(errmsg, only_root_writes = .true.)
        endif
        if(trim(line).ne.'end') then
          ii=ii+1
          if(trim(blockword).ne.'XXXX') then
            write(errmsg,'(3a)') 'Unexpected blockword ', trim(blockword), ' was found in ' // trim(filename) // '.'
            call die(errmsg, only_root_writes = .true.)
          end if
        end if
      end do
    elseif(trim(keyword).eq.'number_val_bands_fine') then
      read(line,*,err=110) xct%nvb_fi
    elseif(trim(keyword).eq.'number_val_bands_coarse') then
      read(line,*,err=110) xct%nvb_co
    elseif(trim(keyword).eq.'number_cond_bands_fine') then
      read(line,*,err=110) xct%ncb_fi
    elseif(trim(keyword).eq.'number_cond_bands_coarse') then
      read(line,*,err=110) xct%ncb_co

! Spline scissors
    elseif(trim(keyword).eq.'spline_scissors') then
      if (peinf%inode==0) then
        write(6,*) 'Reading spline coefficients from `spline_scissors.dat`'
        write(6,*)
        ! read number of pts, knots, coefficients, degree
        call open_file(20,file='spline_scissors.dat',form='formatted',status='old')
        read(20,*) eqp%spl_tck%n
        SAFE_ALLOCATE(eqp%spl_tck%t, (eqp%spl_tck%n))
        SAFE_ALLOCATE(eqp%spl_tck%c, (eqp%spl_tck%n))
        read(20,*) (eqp%spl_tck%t(ii), ii=1,eqp%spl_tck%n)
        read(20,*) (eqp%spl_tck%c(ii), ii=1,eqp%spl_tck%n)
        read(20,*) eqp%spl_tck%k
        close(20)
      endif

    elseif(trim(keyword).eq.'coarse_grid_points') then
      read(line,*,err=110) xct%nkpt_co
    elseif(trim(keyword).eq.'read_kpoints') then
      xct%read_kpoints = .true.
    elseif(trim(keyword).eq.'fermi_level') then
      read(line,*,err=110) xct%efermi_input
      if (peinf%inode==0 .and..not. xct%is_absorption) then
        write(0,*) 'WARNING: Interpolating eqp_co.dat using a shifted Fermi level.'
        write(0,*) '         The resulting eqp.dat may be unsuitable for absorption.x'
      endif
    elseif(trim(keyword).eq.'fermi_level_absolute') then
      xct%rfermi=.false.
    elseif(trim(keyword).eq.'fermi_level_relative') then
      xct%rfermi=.true.
    elseif(trim(keyword).eq.'no_symmetries_fine_grid') then
      flag%bz0 = 1
    elseif(trim(keyword).eq.'use_symmetries_fine_grid') then
      flag%bz0 = 0
    elseif(trim(keyword).eq.'no_symmetries_shifted_grid') then
      flag%bzq = 1
    elseif(trim(keyword).eq.'use_symmetries_shifted_grid') then
      flag%bzq = 0
    elseif(trim(keyword).eq.'no_symmetries_coarse_grid') then
      flag%bzc = 1
    elseif(trim(keyword).eq.'use_symmetries_coarse_grid') then
      flag%bzc = 0
    elseif(trim(keyword).eq.'lowest_occupied_band') then
      read(line,*,err=110) xct%vmin
    elseif(trim(keyword).eq.'highest_occupied_band') then
      read(line,*,err=110) xct%vmax
    elseif(trim(keyword).eq.'regular_grid') then
      read(line,*,err=110) xct%rgrid
    elseif(trim(keyword).eq.'comm_mpi') then
      xct%iwriteint=1
    elseif(trim(keyword).eq.'comm_disk') then
      xct%iwriteint=0
    elseif(trim(keyword).eq.'fullbz_replace') then
      xct%freplacebz=.true.
    elseif(trim(keyword).eq.'fullbz_write') then
      xct%fwritebz=.true.
    elseif(trim(keyword).eq.'use_velocity') then
      flag%opr=0
    elseif(trim(keyword).eq.'q_shift') then
      read(line,*,err=110) (xct%shift(ii),ii=1,3)
    elseif(trim(keyword).eq.'use_momentum') then
      flag%opr=1
    elseif(trim(keyword).eq.'degeneracy_check_override') then
      xct%degeneracy_check_override=.true.
    elseif(trim(keyword).eq.'greedy_interpolation') then
      xct%delaunay_interp=.false.
    elseif(trim(keyword).eq.'delaunay_interpolation') then
      xct%delaunay_interp=.true.
    elseif(trim(keyword).eq.'dont_use_hdf5') then
      xct%use_hdf5 = .false.
    else
      call scissors_inread(keyword, line, eqp%scis, found)
      unknown_keyword = .not. found
    endif

    if(unknown_keyword .and. xct%is_absorption) then
      unknown_keyword = .false.
      if(trim(keyword).eq.'eqp_corrections') then
        xct%eqp_corrections=.true.
      elseif(trim(keyword).eq.'eqp_co_corrections') then
        xct%eqp_co_corrections=.true.
      elseif(trim(keyword).eq.'energy_resolution') then
        read(line,*,err=110) xct%eta
      elseif(trim(keyword).eq.'energy_resolution_sigma') then
        read(line,*,err=110) xct%sigma
      elseif(trim(keyword).eq.'energy_resolution_gamma') then
        read(line,*,err=110) xct%gamma
      elseif(trim(keyword).eq.'use_dos') then
        flag%opr=2
      elseif(trim(keyword).eq.'read_eigenvalues') then
        flag%spec=1
      elseif(trim(keyword).eq.'read_dtmat') then
        flag%read_dtmat=.true.
      elseif(trim(keyword).eq.'number_iterations') then
        read(line,*,err=110) nmax
      elseif(trim(keyword).eq.'number_eigenvalues') then
        read(line,*,err=110) neig
      elseif(trim(keyword).eq.'cell_average_cutoff') then
        read(line,*,err=110) xct%avgcut
      elseif(trim(keyword).eq.'lorentzian_broadening') then
        flag%lor=0
      elseif(trim(keyword).eq.'gaussian_broadening') then
        flag%lor=1
      elseif(trim(keyword).eq.'voigt_broadening') then
        flag%lor=2
      elseif(trim(keyword).eq.'polarization') then
        read(line,*,err=110) (xct%pol(ii),ii=1,3)
      elseif(trim(keyword).eq.'read_vmtxel') then
        flag%vm=1
      elseif(trim(keyword).eq.'read_eps2_moments') then
        flag%vm=2
      elseif(trim(keyword).eq.'read_epsdiag') then
        flag%read_epsdiag=.true.
      elseif(trim(keyword).eq.'write_eigenvectors') then
        flag%eig=-1
        read(line,*) flag%eig
      elseif(trim(keyword).eq.'diagonalization') then
        diagonalization = .true.
      elseif(trim(keyword).eq.'haydock') then
        diagonalization = .false.
      elseif(trim(keyword).eq.'spin_triplet') then
        flag%krnl=0
      elseif(trim(keyword).eq.'spin_singlet') then
        flag%krnl=1
      elseif(trim(keyword).eq.'local_fields') then
        flag%krnl=2
      elseif(trim(keyword).eq.'noeh_only') then
        xct%iabsorp0=1
      elseif(trim(keyword).eq.'screening_semiconductor') then
        xct%iscreen=0
      elseif(trim(keyword).eq.'screening_graphene') then
        xct%iscreen=1
      elseif(trim(keyword).eq.'screening_metal') then
        xct%iscreen=2
      elseif(trim(keyword).eq.'spherical_truncation') then
        xct%icutv=2
      elseif(trim(keyword).eq.'cell_wire_truncation') then
        xct%icutv=4
      elseif(trim(keyword).eq.'cell_box_truncation') then
        xct%icutv=5
      elseif(trim(keyword).eq.'cell_slab_truncation') then
        xct%icutv=6
      elseif(trim(keyword).eq.'write_vcoul') then
        xct%iwritecoul=1
      elseif(trim(keyword).eq.'skip_interpolation') then
        xct%skipinterp=.true.
      elseif(trim(keyword).eq.'kernel_scaling') then
        read(line,*,err=110) xct%scaling
      elseif(trim(keyword).eq.'coulomb_truncation_radius') then
        read(line,*,err=110) xct%truncval(1)
      elseif(trim(keyword).eq.'average_w') then
        xct%averagew=.true.
      else
        unknown_keyword = .true.
      endif
    endif ! xct%is_absorption

    if(unknown_keyword) then
      write(errmsg,'(3a)') 'Unexpected keyword ', trim(keyword), ' was found in ' // trim(filename) // '.'
      call die(errmsg, only_root_writes = .true.)
    end if
  enddo
  
  if(xct%nvb_fi.eq.0) then
    call die('The number_val_bands_fine keyword could not be found.', only_root_writes = .true.)
  endif
  
  if(xct%ncb_fi.eq.0) then
    call die('The number_cond_bands_fine keyword could not be found.', only_root_writes = .true.)
  endif
  
  if(xct%nvb_co.eq.0) then
    call die('The number_val_bands_coarse keyword could not be found.', only_root_writes = .true.)
  endif
  
  if(xct%ncb_co.eq.0) then
    call die('The number_cond_bands_coarse keyword could not be found.', only_root_writes = .true.)
  endif


! FHJ: Default values for non-TDA BSE calculation
! FHJ: How many kernel blocks did we compute? (inteqp doesn`t care about this)
  if (xct%is_absorption) then
    if (xct%extended_kernel) then
      xct%unrestricted_transf = .true.
      if (peinf%inode==0) then
        write(6,'(1x,a)') "Kernel was calculated for all possible (n1,n2)->(n1',n2') transitions."
        if (xct%zero_unrestricted_contrib) then
          write(6,'(1x,a)') "However, only the restricted portion of the BSE kernel will be used."
          write(6,'(1x,a)') "Use this option for testing purposes only."
        endif
        write(6,*)
      endif
    else
      if (peinf%inode==0) then
        write(6,'(1x,a)') "Kernel was calculated only for (v,c)->(v',c') transitions."
        write(6,*)
      endif
    endif
  else
    ! FHJ: for inteqp, there`s no point for extended_kernel and unrestricted_transf
    ! to be different, that will only cause extra buffers to be allocated.
    xct%extended_kernel = xct%unrestricted_transf
  endif

  ! FHJ: Note that intwfn will redefine xct%n1b_co temporarily, but below
  ! are the final for values xct%n1b_co that we will use in intkernel.
  if (xct%extended_kernel) then
    xct%n1b_co = xct%nvb_co + xct%ncb_co
    xct%n2b_co = xct%n1b_co
  else
    xct%n1b_co = xct%nvb_co
    xct%n2b_co = xct%ncb_co
  endif

  if (peinf%inode==0) then
    if (xct%unrestricted_transf) then
      ! FHJ: We actually do this unrestricted transformation even if there`s no
      ! eqp to be interpolated. This might sound silly if we are not using an
      ! extended kernel, because we`ll have to restrict the coefficients later
      ! on. However, by comparing the error between the unrestricted/restricted
      ! interpolations, we can determine the validity of the restricted kernel.
      write(6,'(1x,a)') "The unrestricted fi/co WFN transformation dvn',dcn' will be calculated."
      if (.not.xct%extended_kernel) then
        write(6,'(1x,a)') "However, the coefficients will be later projected onto the dvv',dcc' subspaces."
      endif
    else
      write(6,'(1x,a)') "The restricted fi/co WFN transformation dvv',dcc' will be calculated."
    endif
    write(6,*)
  endif

  if(flag%opr.eq.0) then
    if(peinf%inode.eq.0) then
      write(6,*) 'Using the velocity operator'
      write(6,*)
    endif
    if (xct%skipinterp) then
      call die('skip_interpolation is incompatible with velocity operator', only_root_writes = .true.)
    endif
  elseif(flag%opr.eq.1) then
    if(peinf%inode.eq.0) then
      write(6,*) 'Using the momentum operator'
      write(6,*)

      ! for inteqp, this just means we are only interpolating to WFN_fi, which is not
      ! an approximation, so we do not need to write a warning
      if(xct%is_absorption) then
        write(0,999)
        write(0,*)
999     format(1x,'**************************************************',/, &
          1x,'**                                              **',/, &
          1x,'**                   WARNING:                   **',/, &
          1x,'**      THE MOMENTUM OPERATOR IS NOT EXACT      **',/, &
          1x,'**  ONLY USE IT IF YOU KNOW WHAT YOU ARE DOING  **',/, &
          1x,'**  OTHERWISE YOU SHOULD USE VELOCITY OPERATOR  **',/, &
          1x,'**    for details see equations (29) and (30)   **',/, &
          1x,'**    of Rohlfing & Louie PRB 62, 4927 (2000)   **',/, &
          1x,'**                                              **',/, &
          1x,'**************************************************')
      endif
    endif
  elseif(flag%opr.eq.2) then
    if(peinf%inode.eq.0) then
      write(6,*) 'Using the Joint density of states operator'
      write(6,*)
    endif
  else
    call die("No flag for operator", only_root_writes = .true.)
  endif

  if (peinf%inode==0 .and. .not. xct%skipinterp) then
    if (xct%delaunay_interp) then
      write(6,'(1x,a,/)') 'Using the Delaunay interpolation method.'
    else
      write(6,'(1x,a)') 'Using the greedy interpolation method [DEPRECATED].'
      write(0,'(1x,a)') 'WARNING: This interpolation scheme is deprecated, and might lead to'
      write(0,'(1x,a)') 'non-continuous interpolants. Please make sure the new option'
      write(0,'(1x,a,/)') '`delaunay_interpolation` works in your system, and make the migration.'
    endif
  endif

  if (xct%nkpt_co>0 .and. peinf%inode==0) then
    write(0,*) 'WARNING: `coarse_grid_points` keyword is deprecated'
  endif

  if(xct%is_absorption) then ! rest of file does not apply to inteqp
    ! no fundamental reason, but the way the code is written, energy interpolation only occurs if kernel is interpolated
    if(xct%eqp_co_corrections .and. xct%skipinterp) then
      call die("Cannot do eqp_co_corrections with skip_interpolation. Use eqp_corrections instead.", only_root_writes = .true.)
    endif

! FHJ: noeh_only doesn`t interpolate onto fine grid, so eqp_co won`t work
    if(xct%eqp_co_corrections .and. (.not.xct%eqp_corrections) .and. (xct%iabsorp0==1)) then
      if (peinf%inode==0) then
        write(0,*) 'Can`t use `eqp_co_corrections` with `noeh_only`. Either:'
        write(0,*) ' (1) Run inteqp, then run absorption with eqp_corrections, or'
        write(0,*) ' (2) Remove the `noeh_only` flag and run absorption directly.'
      endif 
      call die('Can`t use `eqp_co_corrections` and `noeh_only` simultaneously.',  only_root_writes = .true.)
    endif

    if ((abs(xct%efermi_input) > TOL_Zero .or. .not. xct%rfermi)) then ! Fermi level is being adjusted
      if((xct%eqp_corrections .neqv. xct%eqp_co_corrections) .and. .not. xct%skipinterp) then
        if(peinf%inode == 0) then
          write(0,'(a)') "If Fermi level is adjusted and interpolation is used, you must use both or neither"
          write(0,'(a)') "of eqp_corrections and eqp_co_corrections. (You can get eqp.dat by running inteqp.)"
        endif
        call die("Cannot use this combination of Fermi adjustment / eqp_corrections / interpolation.", only_root_writes = .true.)
      endif
    endif
    ! eqp_corrections only cannot be used because we would need to 'anti-interpolate' to the coarse grid
    ! in order to correctly reset occupations (ifmax) on the coarse grid.
    ! eqp_co_corrections only cannot be used because then the Fermi level is set by the coarse grid, and
    ! it is cumbersome to reset the fine grid Fermi level since WFN_fi was already handled. --DAS
    ! But if we are not interpolating, then it is ok, since eqp.dat will be used on both.

    if(flag%read_dtmat .and. xct%skipinterp) then
      call die("Options read_dtmat and skip_interpolation are incompatible.", only_root_writes = .true.)
    endif

    ! momentum and JDOS do not have q-shift. specifying one mistakenly will break things without this.
    if(flag%opr /= 0) then
      xct%shift(1:3) = ZERO
    endif
  
    if(abs(xct%eta).lt.TOL_Zero) then
      call die('The energy_resolution keyword could not be found.', only_root_writes = .true.)
    endif
  
    if(flag%lor.eq.2.and.abs(xct%sigma).lt.TOL_Small) then
      call die('Voigt requires energy_resolution_sigma > 0 and energy_resolution_gamma >= 0', &
        only_root_writes = .true.)
    endif

! JRD: Check compatibility

    if (xct%qflag .eq. 0 .and. flag%opr .eq. 1) then
      call die('Momentum and Finite_q are incompatible',  only_root_writes = .true.)
    end if

! JRD: Make a note if we have finite Q

    if(peinf%inode.eq.0 .and. xct%qflag.eq.0) then
      write(6,700)xct%shift(:)
    endif
700 format(1x,'We are doing a Finite Q Calculation',/, &
      1x,'Q =',3f10.6,/)

! JRD: What screening is present?

    if(peinf%inode.eq.0) then
      if(xct%iscreen.eq.0) then
        write(6,800)
      elseif(xct%iscreen.eq.1) then
        write(6,801)
      elseif(xct%iscreen.eq.2) then
        write(6,802)
      else
        call die('Need to specify screening type')
      endif
    endif
800 format(1x,'Running with Semiconductor Screening',/)
801 format(1x,'Running with Graphene Screening',/)
802 format(1x,'Running with Metal Screening',/)

  if(peinf%inode == 0) then
    if(xct%iwriteint == 1) then ! comm_mpi
      if(peinf%npes > 1) then
        write(6,803)
      else
        write(6,805)
      endif
    else ! comm_disk
      write(6,804)
    endif
  endif
803 format(1x,'We are communicating via MPI',/)
804 format(1x,'We are communicating via disk',/)
805 format(1x,'We are not communicating',/)

! JRD: What truncation scheme are we using?

    if(peinf%inode.eq.0) then
      if(xct%icutv.eq.0) then
        write(6,900)
      elseif(xct%icutv.eq.2) then
        write(6,902)
        write(6,912)xct%truncval(1)
      elseif(xct%icutv.eq.4) then
        write(6,904)
      elseif(xct%icutv.eq.5) then
        write(6,905)
      elseif(xct%icutv.eq.6) then
        write(6,906)
      elseif(xct%icutv.eq.7) then
        write(6,907)
      endif
    endif
900 format(1x,'We are using no truncation',/)
902 format(1x,'We are using a truncated Coulomb interaction (spherical)')
904 format(1x,'We are using a truncated Coulomb interaction: Cell Wire',/)
905 format(1x,'We are using a truncated Coulomb interaction: Cell Box',/)
906 format(1x,'We are using a truncated Coulomb interaction: Cell Slab',/)
907 format(1x,'We are using a truncated Coulomb interaction: Supercell Box',/)
912 format(1x,'r_cut =',f10.6,/)

  endif ! xct%is_absorption 

#ifdef MPI
  ! root lets the others go after it is done reading (see beginning of function)
  if(peinf%inode == 0) call MPI_Barrier(MPI_COMM_WORLD, mpierr)

  ! FHJ: Broadcast spline scissors (this must be called after the barrier)
  call MPI_BCAST(eqp%spl_tck%n, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
  if ( eqp%spl_tck%n > 0 ) then
    if(peinf%inode/=0) then
      SAFE_ALLOCATE(eqp%spl_tck%t, (eqp%spl_tck%n))
      SAFE_ALLOCATE(eqp%spl_tck%c, (eqp%spl_tck%n))
    endif
    call MPI_BCAST(eqp%spl_tck%t, eqp%spl_tck%n, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(eqp%spl_tck%c, eqp%spl_tck%n, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(eqp%spl_tck%k, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
  endif
#endif

  POP_SUB(inread)
  
  return
  
110 write(errmsg,'(3a)') 'Unexpected characters were found while reading the value for the keyword ', &
      trim(keyword), '. '
  call die(errmsg, only_root_writes = .true.)
  
end subroutine inread

end module inread_m

!============================================================================
!
! MODULE: fftw_m, originally by DAS 1/14/2011
!
!>   Routines used with FFTW, as well as interfaces for library calls.
!
! DESCRIPTION:
!>   No FFTW calls should exist outside this routine: the wrapper routines
!!   here should be used everywhere.
!!
!!   Interfaces for FFTW2 functions are formulated from fftw-2.1.5/fftw/fftwf77.c
!!   http://www.fftw.org/fftw2_doc/fftw_5.html. Every FFTW2 function used should
!!   have an interface to ensure the argument types are correct.
!!   Contains include file fftw_f77.i which has parameters used in FFTW2 calls.
!!
!!   FFTW3 provides its own file of constants and interfaces, fftw3.f03.
!!   See http://fftw.org/doc/Overview-of-Fortran-interface.html
!
!============================================================================

#include "f_defs.h"

module fftw_m

#ifdef USEFFTW3
  !> use of this is recommended by FFTW3 documentation. It causes no harm for
  !! FFTW2, but some compilers (e.g. Open64) do not have it available, so we
  !! will keep it hidden for FFTW2 so as not to have to solve that problem yet.
  use, intrinsic :: iso_c_binding
#endif
  use global_m
  implicit none

  private

#ifdef USEFFTW3
!> It is better to use this one which has interfaces too, rather than fftw3.f which has only constants
  include 'fftw3.f03'
#else
  include 'fftw_f77.i'
#endif

#ifdef USEFFTW3
    integer*8, private :: fft_plan = 0
    integer, private :: ifirst = 0
    integer, private :: num_fft_threads = 0
    integer :: iret
#else
!> fftw_plan type in C is recommended to be integer*8 by FFTW documentation
    integer*8, private :: plus_plan = 0
    integer*8, private :: minus_plan = 0
#endif
    integer, private :: Nfftold(3) = 0

#ifndef USEFFTW3

  interface
    subroutine fftwnd_f77_create_plan(p, rank, n, idir, flags)
      implicit none
      integer*8 :: p
      integer :: rank, n(*), idir, flags
    end subroutine fftwnd_f77_create_plan
  end interface

  interface
    subroutine fftwnd_f77_one(p, in, out)
      implicit none
      integer*8 :: p
      complex*16 :: in(*)
      integer :: out
!< The argument is really complex*16 out(*), but we only use in-place transforms,
!! in which case this argument is ignored. For simplicity we just pass it 0.    
    end subroutine fftwnd_f77_one
  end interface
  
  interface
    subroutine fftwnd_f77_destroy_plan(p)
      implicit none
      integer*8 :: p
    end subroutine fftwnd_f77_destroy_plan
  end interface

#endif

  public ::            &
    check_FFT_size,    &
    setup_FFT_sizes,   &
    gvec_to_fft_index, &
    put_into_fftbox,   &
    get_from_fftbox,   &
    do_FFT,            &
    conjg_fftbox,      &
    multiply_fftboxes, &
    destroy_fftw_plans

  interface put_into_fftbox
    module procedure dput_into_fftbox, zput_into_fftbox
  end interface put_into_fftbox

  interface get_from_fftbox
    module procedure dget_from_fftbox, zget_from_fftbox
  end interface get_from_fftbox

contains

!> Originally by gsm      Last Modified: 4/10/2010 (gsm)
!!     Best FFT grid dimension is given by 2^a*3^b*5^c*7^d*11^e*13^f
!!     where a,b,c,d are arbitrary and e,f are 0 or 1
!! Ref: http://www.fftw.org/fftw2_doc/fftw_3.html
!!     On entry
!!             Nfft = FFT grid dimension to test
!!             Nfac = number of factors to test
!!     On exit
!!             check_FFT_size = .true. if good FFT grid dimension
  logical function check_FFT_size(Nfft, Nfac) 
    integer, intent(in) :: Nfft, Nfac
  
    integer :: remainder, product, ifac, ipow, maxpow
    integer, parameter :: maxfac = 6
    integer :: pow(maxfac)
    integer, parameter :: fac(maxfac) = (/ 2, 3, 5, 7, 11, 13 /)
  
    PUSH_SUB(check_FFT_size)
  
    if(Nfft .lt. 1 .or. Nfac .lt. 1 .or. Nfac .gt. maxfac) then
      call die('check_FFT_size input')
    endif
  
    remainder = Nfft
    do ifac = 1, maxfac
      pow(ifac) = 0
    enddo
  
    do ifac = 1, Nfac
      maxpow = int(log(dble(remainder)) / log(dble(fac(ifac)))) + 1
      do ipow = 1, maxpow
        if (mod(remainder, fac(ifac)) .eq. 0) then
          remainder = remainder / fac(ifac)
          pow(ifac) = pow(ifac) + 1
        endif
      enddo
    enddo
  
    product = remainder
    do ifac = 1, Nfac
      do ipow = 1, pow(ifac)
        product = product * fac(ifac)
      enddo
    enddo
    if (product .ne. Nfft) then
      call die('Internal error in check_FFT_size; factorization failed')
    endif
  
    check_FFT_size = remainder .eq. 1 .and. pow(5) .le. 1 .and. pow(6) .le. 1
  
    POP_SUB(check_FFT_size)
  
    return
  end function check_FFT_size

!> The former "fft_routines.f90"
!! Sohrab Ismail-Beigi   Feb 28 2001
!!
!! There are a set of Fast Fourier-related routines that are used
!! to compute the matrix elements of the type <nk|e^(i*G.r)|mk`>.
!! For many G-vectors, FFTs will be the fastest way to compute them.
!!
!! The FFTW (http://www.fftw.org) suite of routines do the actual work.
!! Most of what is below is interfacing code and routines that simplify
!! small and useful tasks.
 !
!!
!! Given gvec%FFTgrid(1:3) values (in FFTgrid), finds appropriate FFT box
!! sizes to use in Nfft(1:3).  scale = 1/(Nfftx*Nffty*Nfftz).
!!
  subroutine setup_FFT_sizes(FFTgrid,Nfft,scale)
    integer, intent(in) :: FFTgrid(3)
    integer, intent(out) :: Nfft(3)
    real(DP), intent(out) :: scale

    integer, parameter :: Nfac = 3
    integer :: i

    PUSH_SUB(setup_FFT_sizes)

    do i=1,3
      Nfft(i) = FFTgrid(i)
      do while (.not. check_FFT_size(Nfft(i), Nfac))
        Nfft(i) = Nfft(i) + 1
      enddo
    enddo
    scale = 1.0d0/product(Nfft(1:3))
    
    POP_SUB(setup_FFT_sizes)

    return
  end subroutine setup_FFT_sizes

!> Takes the G-vector g(1:3) and FFT box size Nfft(1:3) and finds the
!! point idx(1:3) in the box corresponding to that G-vector.
!!
  subroutine gvec_to_fft_index(g,idx,Nfft)
    integer, intent(in) :: g(3), Nfft(3)
    integer, intent(out) :: idx(3)

! no push/pop since called too frequently.

    idx(1:3) = g(1:3) + 1
    
    if (g(1) < 0) idx(1) = Nfft(1) + idx(1)
    if (g(2) < 0) idx(2) = Nfft(2) + idx(2)
    if (g(3) < 0) idx(3) = Nfft(3) + idx(3)

    return
  end subroutine gvec_to_fft_index

!> Do an FFT on the fftbox in place:  destroys contents of fftbox
!! and replaces them by the Fourier transform.
!!
!! The FFT done is:
!!
!!   fftbox(p) <- sum_j { fftbox(j)*e^{sign*i*j.p} }
!!
!! where j and p are integer 3-vectors ranging over Nfft(1:3).
!!
  subroutine do_FFT(fftbox, Nfft, sign)
    complex(DPC), intent(inout) :: fftbox(:,:,:)
    integer, intent(in) :: Nfft(3)
    integer, intent(in) :: sign

    character (len=100) :: str

    PUSH_SUB(do_FFT)

#ifdef USEFFTW3

!JRD To be removed
    !complex(DPC), allocatable :: fftbox2(:,:,:)

#ifdef OMP
    if (ifirst .eq. 0) then
      call dfftw_init_threads(iret)
      ifirst = 1

#ifdef VERBOSE
      write(str,'(a,i0)') &
        'Setup threaded FFTs. Return: ', iret
      call logit(str)
#endif

!#!$OMP PARALLEL
!#      num_fft_threads = OMP_GET_NUM_THREADS()
!#!$OMP END PARALLEL

      num_fft_threads = peinf%nthreads

      call dfftw_plan_with_nthreads(num_fft_threads)
#ifdef VERBOSE
      write(str,'(a,i0)') &
        'Doing threaded FFTs. Num threads: ', num_fft_threads
      call logit(str)
#endif
    endif 

#endif

#ifdef VERBOSE
! JRD: Too verbose even for verbose
    !write(str,'(a,3(i4,a))') &
    !  'Creating ',Nfft(1),' x',Nfft(2),' x',Nfft(3),' FFTW plans.'
    !call logit(str)
#endif
      
    if(peinf%inode.eq.0) call timacc(93,1)

    if (sign == 1) then
      call dfftw_plan_dft(fft_plan,3,Nfft,fftbox,fftbox,FFTW_BACKWARD,FFTW_ESTIMATE)
      !call dfftw_plan_dft(fft_plan,3,Nfft,fftbox,fftbox2,FFTW_BACKWARD,FFTW_MEASURE)
      !call dfftw_plan_dft_3d(fft_plan,Nfft(1),Nfft(2),Nfft(3),fftbox,fftbox2,FFTW_BACKWARD,FFTW_MEASURE)
    else if (sign == -1) then
      call dfftw_plan_dft(fft_plan,3,Nfft,fftbox,fftbox,FFTW_FORWARD,FFTW_ESTIMATE)
      !call dfftw_plan_dft(fft_plan,3,Nfft,fftbox,fftbox2,FFTW_FORWARD,FFTW_MEASURE)
      !call dfftw_plan_dft_3d(fft_plan,Nfft(1),Nfft(2),Nfft(3),fftbox,fftbox2,FFTW_FORWARD,FFTW_MEASURE)
    else
      call die('sign is not 1 or -1 in do_FFT')
    endif

    if(peinf%inode.eq.0) call timacc(93,2)

#ifdef VERBOSE
! JRD: Too verbose
    ! call logit('Done creating plans')
#endif

    if(peinf%inode.eq.0) call timacc(94,1)

    call dfftw_execute_dft(fft_plan,fftbox,fftbox)

    if(peinf%inode.eq.0) call timacc(94,2)

    ! otherwise there is a memory leak
    call dfftw_destroy_plan(fft_plan)
    !call dfftw_cleanup_threads()

    Nfftold(:) = -1

!JRD To be removed
    !fftbox(:,:,:)=fftbox2(:,:,:)
    !SAFE_DEALLOCATE(fftbox2)

#else

!JRD Determine dimensions

!    ndim = 0
!    do idim=1,3
!      if (Nfft(idim) .gt. 1) ndim = ndim + 1
!    enddo
!    if (ndim .lt. 1) call die('fft of dimension less than 1')
!    if (ndim .gt. 3) call die('fft of dimension more than 3')

    if(any(Nfftold(1:3) .ne. Nfft(1:3))) then
#ifdef VERBOSE
      write(str,'(a,3(i4,a))') &
        'Creating ',Nfft(1),' x',Nfft(2),' x',Nfft(3),' FFTW plans.'
      call logit(str)
#endif
      
      ! otherwise there is a memory leak
      if(any(Nfftold(1:3) /= -1)) call destroy_fftw_plans()
      
      call fftwnd_f77_create_plan(plus_plan,3,Nfft,FFTW_BACKWARD, &
        FFTW_MEASURE+FFTW_IN_PLACE+FFTW_USE_WISDOM)
      call fftwnd_f77_create_plan(minus_plan,3,Nfft,FFTW_FORWARD, &
        FFTW_MEASURE+FFTW_IN_PLACE+FFTW_USE_WISDOM)
      Nfftold(1:3) = Nfft(1:3)
#ifdef VERBOSE
      call logit('Done creating plans')
#endif
    endif

    if (sign == 1) then
      call fftwnd_f77_one(plus_plan,fftbox,0)
    else if (sign == -1) then
      call fftwnd_f77_one(minus_plan,fftbox,0)
    else
      call die('sign is not 1 or -1 in do_FFT')
    endif

#endif

    POP_SUB(do_FFT)

    return
  end subroutine do_FFT

  subroutine destroy_fftw_plans()

    ! FFTW plan was never created
    if(all(Nfftold(1:3) == 0)) return

    PUSH_SUB(destroy_fftw_plans)

    if(all(Nfftold(1:3) == -1)) then 
#ifdef USEFFTW3
#ifdef OMP
      ifirst = 0
      call dfftw_cleanup_threads()
#endif
#endif
      POP_SUB(destroy_fftw_plans)
      return
      ! call die("Cannot destroy FFTW plan for a second time.")
    endif

#ifdef VERBOSE
    if(peinf%inode == 0) &
      write(6,'(a,3(i4,a))') '*** VERBOSE: Destroying ',Nfftold(1),' x',Nfftold(2),' x',Nfftold(3),' FFTW plans.'
#endif

    Nfftold(1:3) = -1 ! make clear there is no plan anymore so we do not try to destroy twice

#ifdef USEFFTW3
    call dfftw_destroy_plan(fft_plan)
#ifdef OMP
    call dfftw_cleanup_threads()
#endif
#else
    call fftwnd_f77_destroy_plan(plus_plan)
    call fftwnd_f77_destroy_plan(minus_plan)
#endif
    ! should forget wisdom here, but I cannot figure out how... --DAS

    POP_SUB(destroy_fftw_plans)
    return
  end subroutine destroy_fftw_plans

!> Complex conjugate contents of FFT box
!
  subroutine conjg_fftbox(fftbox,Nfft)
    integer, intent(in) :: Nfft(3)
    complex(DPC), intent(inout) :: fftbox(:,:,:) !< (Nfft(1), Nfft(2), Nfft(3))
    ! for some reason, absoft segfaults if dims specified for fftbox as above right

    integer :: ix,iy,iz

    PUSH_SUB(conjg_fftbox)

    forall(iz=1:Nfft(3), iy=1:Nfft(2), ix=1:Nfft(1)) fftbox(ix,iy,iz) = CONJG(fftbox(ix,iy,iz))

    POP_SUB(conjg_fftbox)

    return
  end subroutine conjg_fftbox

!> Multiply contents of two fft boxes, result into fftbox2
!
  subroutine multiply_fftboxes(fftbox1, fftbox2, Nfft)
    integer, intent(in) :: Nfft(3)
    complex(DPC), intent(in) :: fftbox1(:,:,:) !< (Nfft(1), Nfft(2), Nfft(3))
    complex(DPC), intent(inout) :: fftbox2(:,:,:) !< (Nfft(1), Nfft(2), Nfft(3))

    integer :: ix,iy,iz

    PUSH_SUB(multiply_fftboxes)

    if(peinf%inode.eq.0) call timacc(95,1)

    !forall(ix=1:Nfft(1), iy=1:Nfft(2), iz=1:Nfft(3)) &
    !  fftbox2(ix,iy,iz) = fftbox1(ix,iy,iz) * fftbox2(ix,iy,iz)

!$OMP PARALLEL PRIVATE (ix,iy,iz)
!$OMP DO
    do iz = 1, Nfft(3)
    do iy = 1, Nfft(2)
    do ix = 1, Nfft(1)
      fftbox2(ix,iy,iz) = fftbox1(ix,iy,iz) * fftbox2(ix,iy,iz)
    enddo
    enddo
    enddo
!$OMP END DO
!$OMP END PARALLEL

    if(peinf%inode.eq.0) call timacc(95,2)

    POP_SUB(multiply_fftboxes)

    return
  end subroutine multiply_fftboxes

#include "undef.h"
!overrules flavor.mk
#undef CPLX
#include "f_defs.h"
#include "fftw_inc.f90"

#include "undef.h"

#define CPLX
#include "f_defs.h"
#include "fftw_inc.f90"

end module fftw_m

!===========================================================================
!
! Modules:
!
! scalapack_m    Originally By DAS
!
!   Functions, types, and interfaces for ScaLAPACK/BLACS.
!   Interfaces are from http://www.netlib.org/scalapack/tools, double, complex16
!   and from http://www.netlib.org/blacs/BLACS/QRef.html (entered manually...)
!   Every ScaLAPACK/BLACS function used in the code should be listed here, and this
!   module should be used in every routine containing ScaLAPACK/BLACS calls to ensure
!   the argument types are correct.
!
!============================================================================

#include "f_defs.h"

module scalapack_m

  use global_m
  implicit none

  private

  public ::           &
    scalapack,        &
    blacs_setup,      &
    layout_scalapack, &
    numroc,           &
    iceil,            &
    descinit,         &
    pdgesv,           &
    pzgesv,           &
    pdsyevx,          &
    pdgeqrf,          &
    pzgeqrf,          &
    pzheevx,          &
    blacs_get,        &
    blacs_gridinit,   &
    blacs_gridmap,    &
    blacs_gridexit,   &
    blacs_exit

!-----------------------------

  type scalapack
    integer :: nprow  !< the number of processors in a row of your processor grid
    integer :: npcol  !< the number of processors in a column of your processor grid
    integer :: nbl    !< the linear dimension of a block of a distributed matrix
    integer :: myprow !< the processor`s row coordinate in your processor grid
    integer :: mypcol !< the processor`s column coordinate in your processor grid
    integer :: npr    !< the number of rows of the matrix the processor owns
    integer :: npc    !< the number of columns of the matrix the processor owns
    integer :: icntxt !< BLACS context; see BLACS documentation 
    integer, pointer :: npcd(:)       !< global list of the number of cols of the matrix owned by all processors
    integer, pointer :: nprd(:)       !< global list of the number of rows of the matrix owned by all processors
    integer, pointer :: isrtxrow(:)   !< isrtxrow/isrtxcol give the sorted index of the gvector in a given block  
    integer, pointer :: isrtxcol(:)   !! owned by a processor in terms of the whole list of gvectors 
    integer, pointer :: imycol(:)     !< imyrow/imycol give the row/column index of a g-vector owned by a given
    integer, pointer :: imyrow(:)     !! processor in the whole matrix
    integer, pointer :: imycolinv(:)  !< inverse of imycol
    integer, pointer :: imyrowinv(:)  !! inverse of imyrow
    integer, pointer :: imycold(:,:)  !< imycold/imyrowd are global lists of the row/column index of g-vectors 
    integer, pointer :: imyrowd(:,:)  !! owned by all the processors in the whole matrix
  end type scalapack

!> SCALAPACK
  interface
    INTEGER FUNCTION NUMROC( N, NB, IPROC, ISRCPROC, NPROCS )
      implicit none
      INTEGER              IPROC, ISRCPROC, N, NB, NPROCS
    end FUNCTION NUMROC
  end interface

  interface
    INTEGER FUNCTION ICEIL( INUM, IDENOM )
      implicit none
      INTEGER            IDENOM, INUM
    end FUNCTION ICEIL
  end interface

  interface
    SUBROUTINE DESCINIT( DESC, M, N, MB, NB, IRSRC, ICSRC, ICTXT, LLD, INFO )
      implicit none
      INTEGER            ICSRC, ICTXT, INFO, IRSRC, LLD, M, MB, N, NB
      INTEGER            DESC( * )
    end SUBROUTINE DESCINIT
  end interface

  interface
    SUBROUTINE PDGESV( N, NRHS, A, IA, JA, DESCA, IPIV, B, IB, JB, DESCB, INFO )
      implicit none
      INTEGER            IA, IB, INFO, JA, JB, N, NRHS
      INTEGER            DESCA( * ), DESCB( * ), IPIV( * )
      DOUBLE PRECISION   A( * ), B( * )
    end SUBROUTINE PDGESV
  end interface

  interface
    SUBROUTINE PZGESV( N, NRHS, A, IA, JA, DESCA, IPIV, B, IB, JB, DESCB, INFO )
      implicit none
      INTEGER            IA, IB, INFO, JA, JB, N, NRHS
      INTEGER            DESCA( * ), DESCB( * ), IPIV( * )
      COMPLEX*16         A( * ), B( * )
    end SUBROUTINE PZGESV
  end interface

  interface
    SUBROUTINE PDSYEVX( JOBZ, RANGE, UPLO, N, A, IA, JA, DESCA, VL, &
      VU, IL, IU, ABSTOL, M, NZ, W, ORFAC, Z, IZ, JZ, DESCZ, WORK, LWORK, IWORK, LIWORK, IFAIL, &
      ICLUSTR, GAP, INFO )
      implicit none
      CHARACTER          JOBZ, RANGE, UPLO
      INTEGER            IA, IL, INFO, IU, IZ, JA, JZ, LIWORK, LWORK, M, N, NZ
      DOUBLE PRECISION   ABSTOL, ORFAC, VL, VU
      INTEGER            DESCA( * ), DESCZ( * ), ICLUSTR( * ), IFAIL( * ), IWORK( * )
      DOUBLE PRECISION   A( * ), GAP( * ), W( * ), WORK( * ), Z( * )
    end SUBROUTINE PDSYEVX
  end interface

  interface
    SUBROUTINE PDGEQRF( M, N, A, IA, JA, DESCA, TAU, WORK, LWORK, INFO )
      implicit none
      INTEGER            IA, INFO, JA, LWORK, M, N
      INTEGER            DESCA( * )
      DOUBLE PRECISION   A( * ), TAU( * ), WORK( * )
    end SUBROUTINE PDGEQRF
  end interface

  interface
    SUBROUTINE PZGEQRF( M, N, A, IA, JA, DESCA, TAU, WORK, LWORK, INFO )
      implicit none
      INTEGER            IA, INFO, JA, LWORK, M, N
      INTEGER            DESCA( * )
      COMPLEX*16         A( * ), TAU( * ), WORK( * )
    end SUBROUTINE PZGEQRF
  end interface

  interface
    subroutine PZHEEVX( JOBZ, RANGE, UPLO, N, A, IA, JA, DESCA, VL, &
      VU, IL, IU, ABSTOL, M, NZ, W, ORFAC, Z, IZ,                   &
      JZ, DESCZ, WORK, LWORK, RWORK, LRWORK, IWORK,                 &
      LIWORK, IFAIL, ICLUSTR, GAP, INFO )
      implicit none
      character          JOBZ, RANGE, UPLO
      integer            IA, IL, INFO, IU, IZ, JA, JZ, LIWORK, LRWORK, LWORK, M, N, NZ
      double precision   ABSTOL, ORFAC, VL, VU
      integer            DESCA( * ), DESCZ( * ), ICLUSTR( * ), IFAIL( * ), IWORK( * )
      double precision   GAP( * ), RWORK( * ), W( * )
      complex*16         A( * ), WORK( * ), Z( * )
    end subroutine PZHEEVX
  end interface

!> BLACS
  interface
    subroutine blacs_get(icontxt, what, val)
      implicit none
      integer, intent(in)  :: icontxt
      integer, intent(in)  :: what
      integer, intent(out) :: val
    end subroutine blacs_get
  end interface

  interface
    subroutine blacs_gridinit(icontxt, order, nprow, npcol)
      implicit none
      integer,   intent(inout) :: icontxt
      character, intent(in)    :: order
      integer,   intent(in)    :: nprow
      integer,   intent(in)    :: npcol
    end subroutine blacs_gridinit
  end interface

  !> note: args are out of order so that ldumap,npcol are declared
  !! prior to their usage as dimensions of usermap.
  interface
    subroutine blacs_gridmap(icontxt, usermap, ldumap, nprow, npcol)
      implicit none
      integer,   intent(inout) :: icontxt
      integer,   intent(in)    :: ldumap
      integer,   intent(in)    :: nprow
      integer,   intent(in)    :: npcol
      integer,   intent(in)    :: usermap(ldumap,npcol)
    end subroutine blacs_gridmap
  end interface

  interface
    subroutine blacs_gridexit(icontxt)
      implicit none
      integer, intent(in)  :: icontxt
    end subroutine blacs_gridexit
  end interface

  interface
    subroutine blacs_exit(icontxt)
      implicit none
      integer, intent(in)  :: icontxt
    end subroutine blacs_exit
  end interface

  interface
    subroutine blacs_gridinfo(icontxt, nprow, npcol, myprow, mypcol)
      implicit none
      integer, intent(in)  :: icontxt
      integer, intent(out) :: nprow
      integer, intent(out) :: npcol
      integer, intent(out) :: myprow
      integer, intent(out) :: mypcol
    end subroutine blacs_gridinfo
  end interface

contains

!>--------------------------------------------------------------------------
!! Originally by AC, last modified 6/12/2008 (JRD)
!!    Figures out a p by q processor grid layout for the scalapack library.
!!    This p by q grid is used to partition the matrix with a block size b.
!!    The goal is to get a processor grid which is as close to "square" as
!!    possible. For more details, see scalapack documentation.
!!
!!    Input         nproc          number of processors
!!                  matsize        size of matrix
!!
!!    Output        nbl              block size
!!                  nprow            processor grid row
!!                  npcol            processor grid column
  subroutine layout_scalapack(matsize, nbl, nproc, nprow, npcol)    
    integer, intent(in) :: matsize
    integer, intent(out) :: nbl
    integer, intent(in) :: nproc
    integer, intent(out) :: nprow, npcol
    
    integer :: i
    
    PUSH_SUB(layout_scalapack)
    
!------------------
! Find processor grid

    nprow = int(sqrt(dble(nproc) + 1.0d-6))
    
    do i = nprow, 1, -1
      if(mod(nproc, i) .eq. 0) exit
    enddo
    
    nprow = i
    npcol = nproc/nprow

!-------------------
! Now for the block size

    nbl = min(32, matsize/(max(nprow, npcol)))

!-------------------
! Ensure nonzero

    nbl = max(nbl, 1)

    POP_SUB(layout_scalapack)

    return
  end subroutine layout_scalapack

!--------------------------------------------------------------------------
  subroutine blacs_setup(scal, matsize, is_row_order,nppgroup_f,n_para_freqs)
    type(scalapack), intent(inout) :: scal !< other elements might have been set earlier
    integer, intent(in) :: matsize
    logical, intent(in) :: is_row_order 
    integer, intent(in),optional :: nppgroup_f !< # of proc. per freq. group
    integer, intent(in),optional :: n_para_freqs !< number of parallel frequencies

    character :: order
    integer :: iw,ir,ic,npe
    logical :: custom_grid
    integer,allocatable :: usermap(:,:)

    PUSH_SUB(blacs_setup)

#ifdef USESCALAPACK

    npe = peinf%npes
    if (present(nppgroup_f)) then
      npe = nppgroup_f
    endif

    call layout_scalapack(matsize, scal%nbl, npe, &
      scal%nprow, scal%npcol)

    custom_grid=.false.
    if (present(n_para_freqs)) then
      custom_grid = n_para_freqs > 1
    endif

    ! FHJ: only bother to create a custom grid if we are doing parallel freqs.
    if (custom_grid) then

      if(is_row_order) then
        call die("grid map requires a column-major grid defined in usermap")
      endif

      SAFE_ALLOCATE(usermap,(scal%nprow,scal%npcol))

      usermap=0

      iw = (1 + peinf%inode/nppgroup_f)

      call blacs_get(-1, 0, scal%icntxt)

      do ir=1,scal%nprow
        do ic=1,scal%npcol
          usermap(ir,ic)=(iw-1)*nppgroup_f+(ic-1)*scal%nprow+ir-1
        enddo
      enddo

      call blacs_gridmap(scal%icntxt,usermap,scal%nprow,scal%nprow, scal%npcol)
      SAFE_DEALLOCATE(usermap)
      call blacs_gridinfo(scal%icntxt, scal%nprow, scal%npcol, scal%myprow, scal%mypcol)

#ifdef VERBOSE
      ! FHJ: FIXME: barriers are ugly, and this is only a temporary hack to
      !      make the output more readable. This block should be removed for
      !      good as soon as we are confident that BLACS is no longer playing
      !      tricks on us.
      call MPI_Barrier(MPI_COMM_WORLD, mpierr)
      write(*,'(4(a,i5,1x))') 'rank=', peinf%inode, 'freq. group=', iw, &
        'row=', scal%myprow, 'col=', scal%mypcol
      call MPI_Barrier(MPI_COMM_WORLD, mpierr)
#endif

    else

      if(is_row_order) then
        order = 'r'
      else
        order = 'c'
      endif
      call blacs_get(-1, 0, scal%icntxt)
      call blacs_gridinit(scal%icntxt, order, scal%nprow, scal%npcol)
      call blacs_gridinfo(scal%icntxt, scal%nprow, scal%npcol, scal%myprow, scal%mypcol)

    endif
    scal%npr = numroc(matsize, scal%nbl, scal%myprow, 0, scal%nprow)
    scal%npc = numroc(matsize, scal%nbl, scal%mypcol, 0, scal%npcol)

    if (peinf%inode.eq.0) then
      write(6,*)
      write(6,'(1x,a,i3,a,i3,a,i4)') 'BLACS processor grid: ', scal%nprow, &
        ' x ', scal%npcol, '; BLOCKSIZE = ', scal%nbl
      write(6,*)
    endif
    
    if(scal%myprow.eq.-1) then
      call die('BLACS initialization returned myprow = -1')
    endif

#else
    scal%npr=matsize
    scal%npc=matsize
    scal%nbl=matsize
    scal%nprow=1
    scal%npcol=1
    scal%myprow=0
    scal%mypcol=0
#endif

    POP_SUB(blacs_setup)
    return
  end subroutine blacs_setup

end module scalapack_m

!==============================================================================
!
! Modules:
!
! chi_convergence_m                               Last Modified: 05/18/2012 (DWV)
!
!   This module has functions to create the structures for the convergence tests 
!   with respect to to bands in epsilon, to do the convergence tests, and to 
!   print the results.
!
!==============================================================================

#include "f_defs.h"

module chi_convergence_m

  use global_m

  implicit none

  private

  public :: create_chi_converger, free_chi_converger,&
    chi_convergence_test,chi_convergence_print, &
    chi_converger_t

  type chi_converger_t
    SCALAR, allocatable :: head(:)
    SCALAR, allocatable :: maxG(:)
    SCALAR, allocatable :: head2(:)
    SCALAR, allocatable :: maxG2(:)
    SCALAR, allocatable :: headtotal(:)
    SCALAR, allocatable :: maxGtotal(:)
  end type chi_converger_t

contains

  subroutine create_chi_converger(conv,nvalbands,ntotbands)
    type(chi_converger_t), intent(inout) :: conv !< the chi_converger_t object
    integer, intent(in) :: nvalbands  !< number of valence bands
    integer, intent(in) :: ntotbands  !< total number of bands

    PUSH_SUB(create_chi_converger)

    SAFE_ALLOCATE(conv%head,(ntotbands-nvalbands))
    SAFE_ALLOCATE(conv%maxG,(ntotbands-nvalbands))
    SAFE_ALLOCATE(conv%head2,(ntotbands-nvalbands))
    SAFE_ALLOCATE(conv%maxG2,(ntotbands-nvalbands))
    SAFE_ALLOCATE(conv%headtotal,(ntotbands-nvalbands))
    SAFE_ALLOCATE(conv%maxGtotal,(ntotbands-nvalbands))      

    conv%head = ZERO
    conv%head2 = ZERO
    conv%headtotal = ZERO
    conv%maxG = ZERO
    conv%maxG2 = ZERO
    conv%maxGtotal = ZERO

    POP_SUB(create_chi_converger)
    return

  end subroutine create_chi_converger

  subroutine free_chi_converger(conv)
    type(chi_converger_t), intent(inout) :: conv !<the chi_converger_t object

    PUSH_SUB(free_chi_converger)

    SAFE_DEALLOCATE(conv%head)
    SAFE_DEALLOCATE(conv%maxG)
    SAFE_DEALLOCATE(conv%head2)
    SAFE_DEALLOCATE(conv%maxG2)
    SAFE_DEALLOCATE(conv%headtotal)
    SAFE_DEALLOCATE(conv%maxGtotal)      

    POP_SUB(free_chi_converger)
    return

  end subroutine free_chi_converger


  subroutine chi_convergence_test(pol,pht,indt,kp,nrk,nst,nvalbands,ntotbands,fact,conv)
    type(polarizability), intent(in) :: pol !< polarizability
    SCALAR, intent(in) :: pht(:, :, :) !< (pol%nmtx,neqmax,nrk) phases
      !! neqmax = max number of kpoints equivalent by symmetry (across all irr. k-points)
    integer, intent(in) :: indt(:, :, :) !< (pol%nmtx,neqmax,nrk) indexing array 
    type(kpoints),intent(in) :: kp !<kpoint array
    integer, intent(in) :: nrk !<number of kpoints
    integer, intent(in) :: nst(:) !< (nrk) !<number of elements in the star
    integer, intent(in) :: nvalbands !< number of valence bands
    integer, intent(in) :: ntotbands !< number of total bands
    real(DP), intent(in) :: fact !< volume factor used throughout the code
    type(chi_converger_t), intent(inout) :: conv

    SCALAR :: gmehead,gmemaxG  !<matrix elements for head and tail (maxG)
    SCALAR :: mod_square_phthead,mod_square_phtmaxG !<mod squared of phase
    integer :: ispin,irk,iv,ic,istar,isend,iown

    ! JRD/DWV: Test convergence with bands for G=G`=0 and G=G`=pol%nmtx
    ! The result is chi(0,0), chi(Gmax,Gmax) as a function of conduction
    ! bands, i.e. for these gvectors the chi summation is done for all
    ! valence bands and k-points for certain numbers of conduction bands
    ! and the convergence is tracked as the number of conduction bands
    ! is increased. These will be printed in chi_convergence_print.

    PUSH_SUB(chi_convergence_test)

    do ispin =1, kp%nspin
      do irk = 1, nrk
        do istar = 1, nst(irk)

          mod_square_phthead=pht(1,istar,irk)*MYCONJG(pht(1,istar,irk))
          mod_square_phtmaxG=pht(pol%nmtx,istar,irk)*MYCONJG(pht(pol%nmtx,istar,irk))

          do iv=1,(nvalbands+pol%ncrit)
            iown =1 
            do ic=1,ntotbands-nvalbands
              isend=peinf%global_pairowner(iv,ic)-1
              if (isend .eq. peinf%inode) then
                if (iown .gt. peinf%ncownactual) write(6,*) 'iown bigger than ncownactual'
                gmehead = pol%gme(indt(1,istar,irk),iown,peinf%indexv(iv), &
                  ispin,irk,pol%os_para_freqs)
                gmemaxG = pol%gme(indt(pol%nmtx,istar,irk),iown,peinf%indexv(iv), &
                  ispin,irk,pol%os_para_freqs)
                conv%head2(ic) = conv%head2(ic) + gmehead*MYCONJG(gmehead)*mod_square_phthead*fact*(-1D0)
                conv%maxG2(ic) = conv%maxG2(ic) + gmemaxG*MYCONJG(gmemaxG)*mod_square_phtmaxG*fact*(-1D0)
                iown=iown+1
              endif
            enddo ! ic
          enddo ! iv

        enddo ! istar
      enddo ! irk
    enddo ! ispin

#ifdef MPI
    call MPI_reduce(conv%head2,conv%head,ntotbands-nvalbands,MPI_SCALAR,MPI_SUM,0,MPI_COMM_WORLD,mpierr)
    call MPI_reduce(conv%maxG2,conv%maxG,ntotbands-nvalbands,MPI_SCALAR,MPI_SUM,0,MPI_COMM_WORLD,mpierr)
#else
    conv%head = conv%head2
    conv%maxG = conv%maxG2
#endif

    POP_SUB(chi_convergence_test)

  end subroutine chi_convergence_test

  subroutine chi_convergence_print(pol,iq,nvalbands,ntotbands,conv)

    type(polarizability), intent(in) :: pol !<polarizability
    integer, intent(in) :: iq !<current qpoint
    integer, intent(in) :: nvalbands !<number of valence bands
    integer, intent(in) :: ntotbands !<total number of bands
    type(chi_converger_t), intent(inout) :: conv

    SCALAR :: extrap_head,extrap_maxG
    integer :: ic,idis,ncondbands
    character*24 :: strhead,strtail

    ! JRD: Print out convergence

    PUSH_SUB(chi_convergence_print)

    conv%headtotal(1)=conv%head(1)
    conv%maxGtotal(1)=conv%maxG(1)
    ncondbands = ntotbands-nvalbands
    do ic = 2, ncondbands
      conv%headtotal(ic)=conv%headtotal(ic-1)+conv%head(ic)
      conv%maxGtotal(ic)=conv%maxGtotal(ic-1)+conv%maxG(ic)
    enddo

    ! DWV: Get the value of the matrix elements extrapolated with respect to bands
    ! idis is some sort of extrapolation "distance"

    idis = (ncondbands)/10
    if (idis.gt.0) then
      extrap_head = (ncondbands*conv%headtotal(ncondbands) - (ncondbands-idis)*conv%headtotal(ncondbands-idis)) / idis
      extrap_maxG = (ncondbands*conv%maxGtotal(ncondbands) - (ncondbands-idis)*conv%maxGtotal(ncondbands-idis)) / idis
    else
      extrap_head = ZERO
      extrap_maxG = ZERO
    endif

    write(strhead,701)1
    write(strtail,701)pol%nmtx

    if (pol%fullConvLog .eq. 0) then
      write(17,'(a,3e16.8,a,i0,a)') '# q=', pol%qpt(:,iq), '  (qpt ', iq, ')'
      write(17,'(a1,a7,4a20)') '#', 'ncbands', 'Re chi(0,0)', 'extrap', 'Re chi(Gmax,Gmax)', 'extrap'

      do ic = 1, ncondbands
        write(17,'(i8,4e20.8)') ic, dble(conv%headtotal(ic)), &
          dble(extrap_head), dble(conv%maxGtotal(ic)), dble(extrap_maxG)
      enddo
      write(17,*)
    elseif (pol%fullConvLog .eq. 1) then
      write(17,801) pol%qpt(:,iq), iq
      write(17,802)

      write(17,803)TRUNC(strhead)
      do ic = 1, ncondbands
        write(17,805) ic, dble(conv%headtotal(ic))
      enddo

      write(17,804)TRUNC(strtail)
      do ic = 1, ncondbands
        write(17,805) ic, dble(conv%maxGtotal(ic))
      enddo
    elseif (pol%fullConvLog .eq. 2) then
      write(17,801) pol%qpt(:,iq), iq
      write(17,802)

      write(17,803)TRUNC(strhead)
      do ic = 1, ncondbands
        write(17,805) ic, conv%headtotal(ic)
      enddo

      write(17,804)TRUNC(strtail)
      do ic = 1, ncondbands
        write(17,805) ic, conv%maxGtotal(ic)
      enddo
    endif

701 format(i16)
801 format('#',1x,'q =',3f10.6,1x,'iq =',i4)
802 format(2x,'nbands',1x,'chi0')
803 format(2x,'head ig = igp =',1x,a)
804 format(2x,'tail ig = igp =',1x,a)
805 format(i8,2e16.8)

    SAFE_DEALLOCATE(conv%headtotal)
    SAFE_DEALLOCATE(conv%maxGtotal)

    POP_SUB(chi_convergence_print)

  end subroutine chi_convergence_print

end module chi_convergence_m

!==============================================================================
!
! Routines()
!
! (1) write_xct()       Originally By MLT       Last Modified 6/2008 FJR
!
!     Writes out the wavefunction.
!
!=============================================================================

#include "f_defs.h"

module write_xct_m

  use global_m
  use plotxct_common_m

  implicit none

  private

  public :: write_xct

contains

subroutine write_xct(pxct, crys, nfft, scfft)
  type(plotxct_t), intent(in) :: pxct
  type(crystal), intent(in) :: crys
  integer, intent(in) :: nfft(3)
  complex(DPC), intent(inout) :: scfft(:,:,:) !< (nw_eff(1),nw_eff(2),nw_eff(3))
  
  integer :: i1,i2,i3
  integer :: nw(3), nw_int(3), nw_eff(3)
  character :: fn*30
  real(DP) :: rh_a0(3), int_val

  PUSH_SUB(write_xct)
  
  nw(:) = nfft(:) * pxct%nsuper(:)
  nw_eff = (nw + pxct%subsample - 1) / pxct%subsample
  !FHJ: nw_int is the size nw_eff but also taking into consideration the 
  !     integration over the appropriate axes.
  where (pxct%int_dim)
    nw_int = 1
  elsewhere
    nw_int = nw_eff
  endwhere

  !FHJ: note that the scfft array is product(nw_eff(1:3)) big, and we should
  !     never use nw directly!
  rh_a0 = matmul(crys%avec, pxct%rhole) * crys%alat
  
!-----------------------------
! Print output data

  write(fn,'(a,i6.6,a,i1.1,a)') 'xct.', pxct%pstate, '_s', pxct%ispin, '.a3Dr'
  
  write(6,'(a,a,a,3i8)') 'Writing data set to "', trim(fn), '" with nw = ',nw_int(:)
  
  call open_file(30,file=fn,form='formatted',status='replace')
  
  write(30, '(a,i6)') '# ie = ', pxct%pstate
  write(30, '(a,f12.4,a)') '# e  = ', pxct%e_S, ' eV'
  write(30, '(a,3f14.6,a)') '# rh = ', rh_a0, ' Bohr'
  write(30, '(a,i1)') '# spin = ', pxct%ispin
  write(30, '(a)') '#'
  write(30, '(a)') '# unit cell'
  write(30, '(a,3f14.6,a)') '# a1 = ', pxct%nsuper(1) * crys%avec(1:3,1) * crys%alat, ' Bohr'
  write(30, '(a,3f14.6,a)') '# a2 = ', pxct%nsuper(2) * crys%avec(1:3,2) * crys%alat, ' Bohr'
  write(30, '(a,3f14.6,a)') '# a3 = ', pxct%nsuper(3) * crys%avec(1:3,3) * crys%alat, ' Bohr'
  write(30, '(a)') '#'
  ! only write 1/8 = (1/2)^3 of the full data to save disk space
  write(30, '(a,3i8)') '# ni = ', nw_int(:)
  write(30, '(a)') '#'
  if (pxct%only_psi2) then
    write(30, '(a)') '#    abs^2'
  else
    write(30, '(a)') '#    real         imag        abs^2'
  endif

  if(.not.any(pxct%int_dim)) then
    !FHJ : Not integrating dimensions, so nw_int = nw_eff.

    if (pxct%only_psi2) then
      do i3 = 1, nw_eff(3)
        do i2 = 1, nw_eff(2)
          do i1 = 1, nw_eff(1)
            write(30, '(3es13.5)') ABS2(scfft(i1, i2, i3))
          enddo
          write(30,*)
        enddo
        write(30,*)
      enddo
    else
      do i3 = 1, nw_eff(3)
        do i2 = 1, nw_eff(2)
          do i1 = 1, nw_eff(1)
            write(30, '(3es13.5)') scfft(i1, i2, i3),ABS2(scfft(i1, i2, i3))
          enddo
          write(30,*)
        enddo
        write(30,*)
      enddo
    endif

  else
    ! FHJ : Integrating on one/two dimensions
    ! The innermost index must be the one(s) we are integrating!

    if (count(pxct%int_dim)==1) then !integrate 1 dim

      if (pxct%int_dim(1)) then
        do i3 = 1, nw_eff(3)
          do i2 = 1, nw_eff(2)
            int_val = 0.d0
            do i1 = 1, nw_eff(1)
              int_val = int_val + ABS2(scfft(i1,i2,i3))
            enddo
            scfft(1,i2,i3) = int_val
          enddo
        enddo
      else if (pxct%int_dim(2)) then
        do i3 = 1, nw_eff(3)
          do i1 = 1, nw_eff(1)
            int_val = 0.d0
            do i2 = 1, nw_eff(2)
              int_val = int_val + ABS2(scfft(i1,i2,i3))
            enddo
            scfft(i1,1,i3) = int_val
          enddo
        enddo
      else
        do i2 = 1, nw_eff(2)
          do i1 = 1, nw_eff(1)
            int_val = 0.d0
            do i3 = 1, nw_eff(3)
              int_val = int_val + ABS2(scfft(i1,i2,i3))
            enddo
            scfft(i1,i2,1) = int_val
          enddo
        enddo
      endif

    else !integrate 2 dims

      if (.not.pxct%int_dim(3)) then
        do i3 = 1, nw_eff(3)
          int_val = 0.d0
          do i2 = 1, nw_eff(2)
            do i1 = 1, nw_eff(1)
              int_val = int_val + ABS2(scfft(i1,i2,i3))
            enddo
          enddo
          scfft(1,1,i3) = int_val
        enddo
      else if (.not.pxct%int_dim(2)) then
        do i2 = 1, nw_eff(2)
          int_val = 0.d0
          do i3 = 1, nw_eff(3)
            do i1 = 1, nw_eff(1)
              int_val = int_val + ABS2(scfft(i1,i2,i3))
            enddo
          enddo
          scfft(1,i2,1) = int_val
        enddo
      else
        do i1 = 1, nw_eff(1)
          int_val = 0.d0
          do i3 = 1, nw_eff(3)
            do i2 = 1, nw_eff(2)
              int_val = int_val + ABS2(scfft(i1,i2,i3))
            enddo
          enddo
          scfft(i1,1,1) = int_val
        enddo
      endif

    endif !count(pxct%int_dim)==1

    !FHJ: Yes, we are using an array of complex to store doubles, but this is
    ! better than allocating yet another array!
    do i3 = 1, nw_int(3)
      do i2 = 1, nw_int(2)
        do i1 = 1, nw_int(1)
          write(30, '(1es13.5)') dble(scfft(i1, i2, i3))
        enddo
        write(30,*)
      enddo
      write(30,*)
    enddo

  endif
  
  call close_file(30)
  
  POP_SUB(write_xct)
  
  return
end subroutine write_xct

end module write_xct_m

!===============================================================================
!
! Routines:
!
! (1) mtxel_jdos()         Originally By MJ               Last Modified 22/7/2010 MJ
!
!     input: s1 and nmat
!
!     output: s1  matrix element of the JDOS operator
!
!     Calculates the JDOS operator 
!     exp(phi(ic,iv))  where phi(ic,iv) = random number between 0 and 2pi
!
!===============================================================================

#include "f_defs.h"

subroutine mtxel_jdos(s1,nmat)

  use global_m
  use random_m
  implicit none

  integer, intent(in) :: nmat
  SCALAR, intent(inout) :: s1(nmat)
  
  integer :: i
  real(DP) :: rnd,sq2
  complex(DPC) :: zi
  SCALAR :: random

  PUSH_SUB(mtxel_jdos)

  s1 = ZERO
  zi = (0.0d0,1.0d0)
  sq2 = sqrt(2.0d0)

!----------------------------------
! Calculate s1(iv) = exp(phi)

  do i = 1, nmat
    call genrand_real4(rnd)
#ifdef CPLX
    random = exp(zi*2.0d0*PI_D*rnd)
#else
    random = sq2*cos(2.0d0*PI_D*rnd)
#endif
    s1(i) = random
  enddo  

  POP_SUB(mtxel_jdos)

  return
end subroutine mtxel_jdos

!==========================================================================
!
! Routines:
!
! (1) genwf_mpi()  Originally By (JRD)             Last Modified 11/2009 (JRD)
!
!     On entry:
!     qq  = current q-vector
!     rk  = current k point in irr. zone
!     irk = its index
!
!     On exit:
!     vwfn%ev and vwfn%zv hold eigenvalues and wavefunctions (valence)
!     cwfn%ec and cwfn%zc hold eigenvalues and wavefunctions (conduction)
!
!     with proper phases and ordering for the k-point rk (given the
!     data on disk for irr. zone)
!
!     subroutine generates valence-band wavefunctions for rk(irk)
!     and conduction-band wavefunctions for rk(irk) from the
!     wavefunctions available for rk in the irreducible wedge of the
!     bz
!
!     i   rk                 rk(irk)
!     o c ngv,...,ev       valence-band wavefunctions for rk+q
!     and associated data
!     o c ngc,...,ec       conduction-band wavefunctions for rk
!     and associated data
!
!==========================================================================

#include "f_defs.h"

module genwf_mpi_m

  use global_m
  use find_kpt_match_m
  use gmap_m
  use input_utils_m
  use misc_m
  use sort_m

  implicit none

  private

  public :: genwf_mpi

contains  

subroutine genwf_mpi(syms,gvec,crys,kp,kpq,irk,rk,qq,vwfn,pol,cwfn,use_wfnq,intwfnv,intwfnvq,intwfnc,ivin)
  type (symmetry), intent(in) :: syms
  type (gspace), intent(in) :: gvec
  type (crystal), intent(in) :: crys
  type (kpoints), target, intent(in) :: kp
  type (kpoints), target, intent(in) :: kpq
  integer, intent(in) :: irk
  real(DP), intent(in) :: rk(3)
  real(DP), intent(in) :: qq(3)
  type (valence_wfns), intent(inout) :: vwfn
  type (polarizability), intent(in) :: pol
  type (conduction_wfns), intent(inout) :: cwfn
  logical, intent(in) :: use_wfnq
  type (int_wavefunction), intent(in) :: intwfnv
  type (int_wavefunction), intent(in) :: intwfnvq
  type (int_wavefunction), intent(in) :: intwfnc
  integer, intent(in) :: ivin

  integer :: itval,jband
  integer :: ng
  integer, allocatable :: isortc(:)
  real(DP), allocatable :: eig(:,:)
  SCALAR, allocatable :: zin(:,:),zinc(:,:)
  SCALAR, allocatable :: zintemp(:,:)
  type(kpoints), pointer :: kp_point

  character :: tmpstr*120
  integer :: itqq,i
  integer :: n,ig,ispin,iband
  integer :: naddc
  integer :: ikrkq,kgq(3),kgqq(3)
  integer, allocatable :: ind(:),isorti(:)
  real(DP), allocatable :: xnorm(:)
  real(DP) :: qk(3),rkq(3)
  real(DP), allocatable :: ekin(:)
  real(DP) :: rkmatch(3)

  SCALAR, allocatable :: ph(:)

  SCALAR, allocatable, save :: ph_old(:)

  integer, allocatable, save :: ind_old(:)
  integer, save :: irk_old=0

  PUSH_SUB(genwf_mpi)

  SAFE_ALLOCATE(isortc, (gvec%ng))
  SAFE_ALLOCATE(eig, (cwfn%nband,kp%nspin))
  SAFE_ALLOCATE(xnorm, (kp%nspin))

  if(peinf%inode.eq.0) call timacc(16,1)

! rkq = rk + qq   (i.e. rkq = current kpoint in irr. zone + qq)

  rkq(1:3) = rk(1:3) + qq(1:3)

! Should we look for the valence WFNs in WFNq or WFN?
  if (use_wfnq) then
    kp_point => kpq
  else
    kp_point => kp
  endif

! We used to assume WFNq contained the needed q->0 point,
! but it is better to unfold the shifted grid for more flexibility.

  call find_kpt_match(kp_point, syms, rkq, ikrkq, itqq, kgqq)

  if(ikrkq == 0) then
    if(peinf%inode == 0) write(0,'(a,3f12.6,/,a,3f12.6)') 'rk = ', rk(:), 'qq = ', qq(:)
    write(tmpstr,'(a,3f8.3,a)') 'genwf_mpi: No match for rkq point:',rkq,' in file '
    if(use_wfnq) then
      write(tmpstr,'(a,a)') TRUNC(tmpstr), ' WFNq'
    else
      write(tmpstr,'(a,a)') TRUNC(tmpstr), ' WFN'
    endif
    call die(tmpstr, only_root_writes = .true.)
  endif

  rkmatch(1:3) = kp_point%rk(1:3, ikrkq)
  vwfn%idx_kp = ikrkq

!      if(peinf%inode.eq.0) then
  itval=vwfn%nband+pol%ncrit
  if (.not.use_wfnq) then
    ng = intwfnv%ng(ikrkq)
    if (irk .ne. irk_old) then
      eig(1:itval,1:kp%nspin)=kp_point%el(1:itval,ikrkq,1:kp%nspin)
      isortc(1:ng)=intwfnv%isort(1:ng,ikrkq)
    endif
    qk(:)=intwfnv%qk(:,ikrkq)
  else
    ng = intwfnvq%ng(ikrkq)
    if (irk .ne. irk_old) then
      eig(1:itval,1:kp%nspin)=kp_point%el(1:itval,ikrkq,1:kp%nspin)
      isortc(1:ng)=intwfnvq%isort(1:ng,ikrkq)
    endif
    qk(:)=intwfnvq%qk(:,ikrkq)
  endif
!      endif

  SAFE_ALLOCATE(zintemp, (ng,kp%nspin*kp%nspinor))
  SAFE_ALLOCATE(zin, (ng,kp%nspin*kp%nspinor))
  
  jband = (ikrkq-1)*peinf%nvownactual + ivin
  zintemp=0D0
  if (use_wfnq) then
    zintemp(1:ng,1:kp%nspin*kp%nspinor)=intwfnvq%cg(1:ng,jband,1:kp%nspin*kp%nspinor)
  else
    zintemp(1:ng,1:kp%nspin*kp%nspinor)=intwfnv%cg(1:ng,jband,1:kp%nspin*kp%nspinor)
  endif

  zin(:,:)=zintemp(:,:) 
  SAFE_DEALLOCATE(zintemp)

! Check kpoint

  if(any(abs(rkmatch(1:3) - qk(1:3)) .gt. TOL_Small)) call die('genwf_mpi: rkmatch')

  if (irk .ne. irk_old) then

! Compute kinetic energies for rkq+g

    SAFE_ALLOCATE(ekin, (gvec%ng))
    call kinetic_energies(gvec, crys%bdot, ekin, qvec = rkq)

! sort array ekin to ascending order, store indices in array vwfn%isort
! WARNING: one should not assume that in the case of
! q-->0 the orders as provided below and as read in from
! WFNq file is the same (sorting may change....)
! ===> need to call gmap also for q-->0 (see below)
! EKC: We initialize vwfn%isort to the appropriate array
! before reading in. this way we do not get zeroes in the array
! these are the valence wave-functions that do not need
! to be changed

    call sortrx(gvec%ng,ekin,vwfn%isort,gvec=gvec%components)

    SAFE_ALLOCATE(isorti, (gvec%ng))
    do i=1,gvec%ng
      isorti(vwfn%isort(i))=i
    enddo
    do i=1,ng
      isorti(isortc(i))=i
    enddo

    vwfn%ngv=ng

! SIB: put read eigenvalues into vwfn%ev(band,spin).

    SAFE_ALLOCATE(vwfn%ev, ((vwfn%nband+pol%ncrit),kp%nspin))
    vwfn%ev(1:(vwfn%nband+pol%ncrit),:) = eig(1:(vwfn%nband+pol%ncrit),:)

! JRD: Map planewave components for rk+q, to those of rk
! (even for q--> 0)
!
! SIB: get phases (ph) and indices (ind) for g-vectors
! gvec%components(:,vwfn%isort(1:vwfn%ngv))+kgqq

    SAFE_ALLOCATE(ind, (vwfn%ngv))
    SAFE_ALLOCATE(ph, (vwfn%ngv))
    call gmap(gvec,syms,vwfn%ngv,itqq,kgqq,vwfn%isort,isorti,ind,ph,.true.)
    if (irk_old .ne. 0) then
      SAFE_DEALLOCATE(ph_old)
      SAFE_DEALLOCATE(ind_old)
    endif
    SAFE_ALLOCATE(ph_old, (vwfn%ngv))
    SAFE_ALLOCATE(ind_old, (vwfn%ngv))
    ph_old(:) = ph(:)
    ind_old(:) = ind(:)
  else

    SAFE_ALLOCATE(ph, (vwfn%ngv))
    SAFE_ALLOCATE(ind, (vwfn%ngv))
    ph(:)=ph_old(:)
    ind(:)=ind_old(:)

  endif  ! irk = irk_old
  SAFE_DEALLOCATE(eig)

  SAFE_ALLOCATE(vwfn%zv, (vwfn%ngv,kp%nspin*kp%nspinor))

! XAV: vwfn%zv(ig) corresponds really to the
! vwfn%isort(ig) G-vector (between 1 and ng)
! The subroutine gmap assumes that, as read from WFNq or WFN,
! zin(ig) corresponds really to isortc(ig) G-vector !!!
!
! SIB:  checks that zin vectors have norm greater than 1e-6, and then
! normalizes them to have unit square modulus.

  do ispin=1,kp%nspin*kp%nspinor
    vwfn%zv(:,ispin)=zin(ind(:),ispin)*ph(:)
  enddo


! BAB:  we check if the norm differs appreciably from unity.
! there is no longer a need to further normalize the vector

  do ispin=1,kp%nspin
    call compute_norm(xnorm(ispin),ispin,vwfn%ngv,kp%nspinor,vwfn%zv(:,:))
    if(abs(xnorm(ispin) - 1d0) > TOL_Small) then
      write(0,*) 'Bad norm: sym op=',itqq,'ik=',ikrkq,'ispin=',ispin,'norm=',xnorm(ispin)
      call die('genwf_mpi: Bad norm')
    endif
  enddo

! End calculation of valence-band wavefunctions

  SAFE_DEALLOCATE(zin)
  SAFE_DEALLOCATE(ind)
  SAFE_DEALLOCATE(ph)
  SAFE_DEALLOCATE(xnorm)
  if(peinf%inode.eq.0) call timacc(16,2)

  !FHJ: only generate conduction WFNs if ivin=1
  if(irk .ne. irk_old) then

!------------------------------------------------------------------------
! Generate conduction-band wavefunctions for rk
! find rk, r, g0 such that rk=r(rk)+g0

! SIB: This seems redundant, but find a k-point and symmetry so that
! rk = sym%mtrx(:,:,itqq)*kp%rk(irk_,:) + kgq, where kgq is integer 3-vec

    if(peinf%inode.eq.0) call timacc(17,1)

    call find_kpt_match(kp, syms, rk, ikrkq, itqq, kgq)
    cwfn%idx_kp = ikrkq

    if(ikrkq == 0) call die('genwf_mpi: kgq mismatch')

! Write out rk, it and kgq

#ifdef VERBOSE
    if(peinf%inode.eq.0) then
      write(6,7000) (rk(i),i=1,3),ikrkq,(kp%rk(i,ikrkq),i=1,3),itqq,(kgq(i),i=1,3)
7000  format(1x,'rk=',3f7.3,1x,'irk_=',i5,1x,' rk=',3f7.3,1x,'it=',i5,1x,'kg0=',3i3)
    endif
#endif

! SIB: if we already found this k-point last time, get its qk, ng,
! and isortc(:).  Otherwise, skip ikrkq-1 records, and read in information (qk,cwfn%ec,ng,isortc),

    SAFE_ALLOCATE(cwfn%ec, (cwfn%nband,kp%nspin))
    
    ng = intwfnc%ng(ikrkq)
    cwfn%ec(1:cwfn%nband,1:kp%nspin)=kp%el(1:cwfn%nband,ikrkq,1:kp%nspin)
    qk(:)=intwfnc%qk(:,ikrkq)
    isortc(1:ng)=intwfnc%isort(1:ng,ikrkq)
    
! Check kpoint (again ...  boring...)
! Check that kp%rk(:,ikrkq) = qk  (why it wouldn`t is a mystery!)

    if(any(abs(kp%rk(1:3, ikrkq) - qk(1:3)) .gt. TOL_Small)) &
      call die('genwf_mpi: qk mismatch')

    cwfn%ngc=ng

! Compute inverse to isort
! NOTE: isortc orders   |kp%rk+G|^2
! It is not necessarily the same order as |rk+G|^2
! (particularly if umklapp, ie kgq non zero)

    if(peinf%inode.eq.0) call timacc(28,1)

    call kinetic_energies(gvec, crys%bdot, ekin, qvec = rk)

    if(peinf%inode.eq.0) call timacc(28,2)

! Sort array ekin to ascending order
! store indices in array isort

    if(peinf%inode.eq.0) call timacc(29,1)

    call sortrx(gvec%ng,ekin,cwfn%isort,gvec=gvec%components)

    if(peinf%inode.eq.0) call timacc(29,2)

    do i=1,ng
      isorti(isortc(i))=i
    enddo
    SAFE_DEALLOCATE(ekin)

! map planewave components for rk to those of rk
! compute phases
! We do not the isorti related to kp%rk BUT the cwfn%isort related to rk

    SAFE_ALLOCATE(ind, (cwfn%ngc))
    SAFE_ALLOCATE(ph, (cwfn%ngc))
    call gmap(gvec,syms,cwfn%ngc,itqq,kgq,cwfn%isort,isorti,ind,ph,.true.)
    SAFE_DEALLOCATE(isorti)

! generate conduction-band wavefunctions
! loop over wavefunctions
! read conduction-band from file one by one

    SAFE_ALLOCATE(cwfn%zc, (peinf%ncownactual*cwfn%ngc,kp%nspin*kp%nspinor))
    SAFE_ALLOCATE(zinc, (cwfn%ngc,kp%nspin*kp%nspinor))

    do n=1,peinf%ncownactual
      
      jband= (ikrkq-1)*peinf%ncownactual + n
      
      iband = intwfnc%cbi(jband)
      zinc(1:ng,1:kp%nspin*kp%nspinor)=intwfnc%cg(1:ng,jband,1:kp%nspin*kp%nspinor)
      
      if(iband .ne. peinf%invindexc(n)) call die('genwf_mpi: invindexc mismatch')

      naddc=(n-1)*cwfn%ngc

!
! Loop over components of wfns
! note that only conduction-band wfns are stored-
! they start in the 1st position with the state nvband+1
!

      do ig=1,cwfn%ngc
        cwfn%zc(naddc+ig,:)=ph(ig)*zinc(ind(ig),:)
      enddo


    enddo  ! n (cond-bands per node [ncownactual] loop)

    SAFE_DEALLOCATE(zinc)
    SAFE_DEALLOCATE(ind)
    SAFE_DEALLOCATE(ph)

!     end generation of conduction-band wavefunctions for rk

    if(peinf%inode.eq.0) call timacc(17,2)

  endif ! (irk .ne. irk_old)

  irk_old = irk
  SAFE_DEALLOCATE(isortc)

  POP_SUB(genwf_mpi)

  return
end subroutine genwf_mpi

end module genwf_mpi_m

!>=========================================================================
!!
!! Module:
!!
!! (1) wfn_io_hdf5_m     Originally by JIM     Last Modified 4/25/2012 (JIM)
!!
!!     Routines to read and write wavefunctions in HDF5 format.
!!     The code is generated through repeated inclusion of a file with
!!     different preprocessor definitions each time. You are not expected to
!!     understand this. Consult the resulting .p.f file for clarity.
!!
!!=========================================================================

#include "f_defs.h"

module wfn_io_hdf5_m
  use global_m
#ifdef HDF5
  use hdf5_io_m
  use hdf5
  
  implicit none
  
  private
  
  public :: &
    read_hdf5_header_type   , &
    write_hdf5_header_type  , &
    read_hdf5_gvectors      , &
    write_hdf5_gvectors     , &
    setup_hdf5_mf_file      , &
    setup_hdf5_wfn_file     , &
    read_hdf5_mf_header

    
contains
  
!===============================================================================
#define READ
!
#define TEMP_HEADER
#include "wfn_io_hdf5_inc.f90"
#undef TEMP_HEADER
!
#define TEMP_WFN_GVEC
#include "wfn_io_hdf5_inc.f90"
#undef TEMP_WFN_GVEC
!
#define TEMP_WFN_DATA
#define TEMP_COMPLEX
#include "wfn_io_hdf5_inc.f90"
#undef TEMP_COMPLEX
#include "wfn_io_hdf5_inc.f90"
#undef TEMP_WFN_DATA
!===============================================================================
#undef READ
!
#define TEMP_HEADER
#include "wfn_io_hdf5_inc.f90"
#undef TEMP_HEADER
!
#define TEMP_WFN_GVEC
#include "wfn_io_hdf5_inc.f90"
#undef TEMP_WFN_GVEC
!
#define TEMP_WFN_DATA
#define TEMP_COMPLEX
#include "wfn_io_hdf5_inc.f90"
#undef TEMP_COMPLEX
#include "wfn_io_hdf5_inc.f90"
#undef TEMP_WFN_DATA
!
#define TEMP_OTHER
#include "wfn_io_hdf5_inc.f90"
#undef TEMP_OTHER
!===============================================================================


  !> Create the appropriate structures that hold info about the mean-field
  !! calculation in an HDF5 file. No data is actually written.
  subroutine setup_hdf5_mf_file(fname, create_file)
    character(len=*), intent(in) :: fname
    logical, intent(in), optional :: create_file

    integer(HID_T) :: file_id
    integer(HID_T) :: group_id
    integer :: error
    logical :: create_file_
    
    PUSH_SUB(setup_hdf5_mf_file)
    
    create_file_ = .true.
    if (present(create_file)) create_file_ = create_file
    if (create_file_) then
      call h5fcreate_f(fname, H5F_ACC_TRUNC_F, file_id, error)
    else
      call h5fopen_f(fname, H5F_ACC_RDWR_F, file_id, error)
    endif
    
    call h5gcreate_f(file_id, '/mf_header', group_id, error)
    call h5gclose_f(group_id, error)
    call h5gcreate_f(file_id, '/mf_header/gspace', group_id, error)
    call h5gclose_f(group_id, error)
    call h5gcreate_f(file_id, '/mf_header/symmetry', group_id, error)
    call h5gclose_f(group_id, error)
    call h5gcreate_f(file_id, '/mf_header/crystal', group_id, error)
    call h5gclose_f(group_id, error)
    call h5gcreate_f(file_id, '/mf_header/kpoints', group_id, error)
    call h5gclose_f(group_id, error)

    call h5fclose_f(file_id, error)
    
    POP_SUB(setup_hdf5_mf_file)

  end subroutine setup_hdf5_mf_file


  !> Create the appropriate structures that hold info about the WFN
  !! coefficients in an HDF5 file. No data is actually written.
  subroutine setup_hdf5_wfn_file(fname, iflavor, kp)
    character(len=*), intent(in) :: fname
    integer, intent(in) :: iflavor
    type(kpoints), intent(in) :: kp

    integer(HID_T) :: file_id
    integer(HID_T) :: group_id
    integer(HID_T) :: dataspace_id
    integer(HID_T) :: dataset_id
    integer(HSIZE_T) :: a3(3)
    integer :: error
    
    PUSH_SUB(setup_hdf5_wfn_file)

    call setup_hdf5_mf_file(fname)

    call h5fopen_f(fname, H5F_ACC_RDWR_F, file_id, error)

    call h5gcreate_f(file_id, '/wfns', group_id, error)
    call h5gclose_f(group_id, error)
    if(iflavor == 1) then
      a3(1) = 1
      a3(2) = sum(kp%ngk)
      a3(3) = kp%mnband
    else
      a3(1) = 2
      a3(2) = sum(kp%ngk)
      a3(3) = kp%mnband
    endif
    CALL h5screate_simple_f(3, a3, dataspace_id, error)
    call h5dcreate_f(file_id, '/wfns/coeffs', H5T_NATIVE_DOUBLE, dataspace_id, dataset_id, error)
    CALL h5sclose_f(dataspace_id, error)

    call h5fclose_f(file_id, error)
    
    POP_SUB(setup_hdf5_wfn_file)

  end subroutine setup_hdf5_wfn_file


  !> A high-level wrapper for write_*_header* functions
  subroutine write_hdf5_mf_header(fname, mf)
    character(len=*), intent(in) :: fname
    type(mf_header_t), intent(in) :: mf

    character(len=3) :: sheader

    PUSH_SUB(write_hdf5_mf_header)

    sheader = mf%sheader
    call write_hdf5_header_type(fname, sheader, mf%iflavor, &
      !mf%kp, mf%gvec, mf%syms, mf%crys, version=mf%version)
      mf%kp, mf%gvec, mf%syms, mf%crys)

    POP_SUB(write_hdf5_mf_header)

  end subroutine write_hdf5_mf_header


  !> A high-level wrapper for read_*_header* functions
  !! Note: the optional fields are ignored for now.
  subroutine read_hdf5_mf_header(fname, mf, iflavor, sheader, warn, dont_warn_kgrid)
    character(len=*), intent(in) :: fname
    type(mf_header_t), intent(out) :: mf
    integer, intent(in), optional :: iflavor
    character(len=3), intent(in), optional :: sheader
    logical, intent(in), optional :: warn
    logical, intent(in), optional :: dont_warn_kgrid

    PUSH_SUB(read_hdf5_mf_header)

    if (present(sheader)) then
      mf%sheader = sheader
    else
      mf%sheader = 'GET'
    endif
    if (present(iflavor)) then
      mf%iflavor = iflavor
    else
      mf%iflavor = -1
    endif
    call read_hdf5_header_type(fname, mf%sheader, mf%iflavor, &
      !mf%kp, mf%gvec, mf%syms, mf%crys, version=mf%version, sdate=mf%sdate, stime=mf%stime)
      mf%kp, mf%gvec, mf%syms, mf%crys)

    !FHJ: FIXME - Implement in WFN file
    mf%sheader = 'WFN'
    mf%stime = 'N/A'
    mf%sdate = 'N/A'

    POP_SUB(read_hdf5_mf_header)

  end subroutine read_hdf5_mf_header

#endif

end module wfn_io_hdf5_m

!! Local Variables:
!! mode: f90
!! coding: utf-8
!! End:

! Imported by MJ from:
! http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/VERSIONS/FORTRAN/mt95.f90
! Modified and added genrand_real4 so that it gives the same random
! numbers as other mt implementations..
! DAS: Commented out parts we do not use because ifort -O3 takes forever to
! optimize this file otherwise. Now it is much faster.
!============================================================================

! A C-program for MT19937, with initialization improved 2002/1/26.
! Coded by Takuji Nishimura and Makoto Matsumoto.                 

! Code converted to Fortran 95 by José Rui Faustino de Sousa
! Date: 2002-02-01

! Enhanced version by José Rui Faustino de Sousa
! Date: 2003-04-30

! Interface:
!
! Kinds:
!   genrand_intg
!     Integer kind used must be at least 32 bits.
!   genrand_real
!     Real kind used 
!
! Types:
!   genrand_state
!     Internal representation of the RNG state.
!   genrand_srepr
!     Public representation of the RNG state. Should be used to save the RNG state.
!
! Procedures:
!   assignment(=)
!     Converts from type genrand_state to genrand_srepr and vice versa.
!   genrand_init
!     Internal RNG state initialization subroutine accepts either an genrand_intg integer
!     or a vector as seed or a new state using "put=" returns the present state using
!     "get=". If it is called with "get=" before being seeded with "put=" returns a state
!     initialized with a default seed.
!   genrand_int32
!     Subroutine returns an array or scalar whose elements are random integer on the
!     [0,0xffffffff] interval.
!   genrand_int31
!     Subroutine returns an array or scalar whose elements are random integer on the
!     [0,0x7fffffff] interval.
!   genrand_real1
!     Subroutine returns an array or scalar whose elements are random real on the
!     [0,1] interval.
!   genrand_real2
!     Subroutine returns an array or scalar whose elements are random real on the
!     [0,1[ interval.
!   genrand_real3
!     Subroutine returns an array or scalar whose elements are random real on the
!     ]0,1[ interval.
!   genrand_res53
!     Subroutine returns an array or scalar whose elements are random real on the
!     [0,1[ interval with 53-bit resolution.

! Before using, initialize the state by using genrand_init( put=seed )  

! This library is free software.                                  
! This library is distributed in the hope that it will be useful, 
! but WITHOUT ANY WARRANTY; without even the implied warranty of  
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.            

! Copyright (C) 1997, 2002 Makoto Matsumoto and Takuji Nishimura. 
! Any feedback is very welcome.                                   
! http://www.math.keio.ac.jp/matumoto/emt.html                    
! email: matumoto@math.keio.ac.jp                                 
!module mt95

#include "f_defs.h"

module random_m

  use global_m  
  implicit none

  public :: genrand_init, genrand_real4

  private

!  public  :: genrand_init, assignment(=)
!  public  :: genrand_int32, genrand_int31, genrand_real1
!  public  :: genrand_real2, genrand_real3, genrand_res53
!  public  :: genrand_real4
!  private :: init_by_scalar, next_state, genrand_int32_0d, uiadd, uimlt
!  private :: uiadd, uisub, uimlt, uidiv, uimod
!  private :: init_by_type, init_by_scalar, init_by_array, next_state
!  private :: genrand_encode, genrand_decode, genrand_load_state, genrand_dump_state
!  private :: genrand_int32_0d, genrand_int32_1d, genrand_int32_2d, genrand_int32_3d
!  private :: genrand_int32_4d, genrand_int32_5d, genrand_int32_6d, genrand_int32_7d
!  private :: genrand_int31_0d, genrand_int31_1d, genrand_int31_2d, genrand_int31_3d
!  private :: genrand_int31_4d, genrand_int31_5d, genrand_int31_6d, genrand_int31_7d
!  private :: genrand_real1_0d, genrand_real1_1d, genrand_real1_2d, genrand_real1_3d
!  private :: genrand_real1_4d, genrand_real1_5d, genrand_real1_6d, genrand_real1_7d
!  private :: genrand_real2_0d, genrand_real2_1d, genrand_real2_2d, genrand_real2_3d
!  private :: genrand_real2_4d, genrand_real2_5d, genrand_real2_6d, genrand_real2_7d
!  private :: genrand_real3_0d, genrand_real3_1d, genrand_real3_2d, genrand_real3_3d
!  private :: genrand_real3_4d, genrand_real3_5d, genrand_real3_6d, genrand_real3_7d
!  private :: genrand_res53_0d, genrand_res53_1d, genrand_res53_2d, genrand_res53_3d
!  private :: genrand_res53_4d, genrand_res53_5d, genrand_res53_6d, genrand_res53_7d

!  intrinsic :: selected_int_kind, selected_real_kind

!  integer, public, parameter  :: genrand_intg = selected_int_kind( 9 )
!  integer, public, parameter  :: genrand_real = selected_real_kind( 15 )

!  integer, private, parameter :: wi = genrand_intg
!  integer, private, parameter :: wr = genrand_real
  integer, private, parameter :: wi = kind(1)
  integer, private, parameter :: wr = DP

  ! Period parameters   
  integer(kind=wi), private, parameter :: n = 624_wi
  integer(kind=wi), private, parameter :: m = 397_wi

  integer(kind=wi), private, parameter :: default_seed = 5489_wi

  integer(kind=wi), private, parameter :: fbs = 32_wi
  integer(kind=wi), private, parameter :: hbs = fbs / 2_wi
  integer(kind=wi), private, parameter :: qbs = hbs / 2_wi
  integer(kind=wi), private, parameter :: tbs = 3_wi * qbs

  real(kind=wr), private, parameter :: p231       = 2147483648.0_wr
  real(kind=wr), private, parameter :: p232       = 4294967296.0_wr
  real(kind=wr), private, parameter :: p232_1     = p232 - 1.0_wr
  real(kind=wr), private, parameter :: pi232      = 1.0_wr / p232
  real(kind=wr), private, parameter :: pi232_1    = 1.0_wr / p232_1
  real(kind=wr), private, parameter :: pi227      = 1.0_wr / 134217728.0_wr
  real(kind=wr), private, parameter :: pi253      = 1.0_wr / 9007199254740992.0_wr
  real(kind=wr), private, parameter :: p231d232_1 = p231 / p232_1
  real(kind=wr), private, parameter :: p231_5d232 = ( p231 + 0.5_wr ) / p232

  character(len=*), private, parameter  :: alph = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"
  character(len=*), private, parameter  :: sepr = "&"
  integer(kind=wi), private, parameter  :: alps = 62_wi
  integer(kind=wi), private, parameter  :: clen = ( n + 1_wi ) * 7_wi !n * ( ceiling( fbs * log( 2.0 ) / log( alps ) ) + 1 )

  type, public :: genrand_state
    private
    logical(kind=wi)                :: ini = .false._wi
    integer(kind=wi)                :: cnt = n+1_wi
    integer(kind=wi), dimension(n)  :: val = 0_wi
  end type genrand_state

!  type, public :: genrand_srepr
!    character(len=clen) :: repr
!  end type genrand_srepr

  type(genrand_state), private, save  :: state

!  interface assignment( = )
!    module procedure genrand_load_state
!    module procedure genrand_dump_state
!  end interface assignment( = )

  interface genrand_init
!    module procedure init_by_type
    module procedure init_by_scalar
!    module procedure init_by_array
  end interface genrand_init

!  interface genrand_int32
!    module procedure genrand_int32_0d
!    module procedure genrand_int32_1d
!    module procedure genrand_int32_2d
!    module procedure genrand_int32_3d
!    module procedure genrand_int32_4d
!    module procedure genrand_int32_5d
!    module procedure genrand_int32_6d
!    module procedure genrand_int32_7d
!  end interface genrand_int32
!
!  interface genrand_int31
!    module procedure genrand_int31_0d
!    module procedure genrand_int31_1d
!    module procedure genrand_int31_2d
!    module procedure genrand_int31_3d
!    module procedure genrand_int31_4d
!    module procedure genrand_int31_5d
!    module procedure genrand_int31_6d
!    module procedure genrand_int31_7d
!  end interface genrand_int31
!
!  interface genrand_real1
!    module procedure genrand_real1_0d
!    module procedure genrand_real1_1d
!    module procedure genrand_real1_2d
!    module procedure genrand_real1_3d
!    module procedure genrand_real1_4d
!    module procedure genrand_real1_5d
!    module procedure genrand_real1_6d
!    module procedure genrand_real1_7d
!  end interface genrand_real1
!
!  interface genrand_real2
!    module procedure genrand_real2_0d
!    module procedure genrand_real2_1d
!    module procedure genrand_real2_2d
!    module procedure genrand_real2_3d
!    module procedure genrand_real2_4d
!    module procedure genrand_real2_5d
!    module procedure genrand_real2_6d
!    module procedure genrand_real2_7d
!  end interface genrand_real2
!
!  interface genrand_real3
!    module procedure genrand_real3_0d
!    module procedure genrand_real3_1d
!    module procedure genrand_real3_2d
!    module procedure genrand_real3_3d
!    module procedure genrand_real3_4d
!    module procedure genrand_real3_5d
!    module procedure genrand_real3_6d
!    module procedure genrand_real3_7d
!  end interface genrand_real3
!
!  interface genrand_res53
!    module procedure genrand_res53_0d
!    module procedure genrand_res53_1d
!    module procedure genrand_res53_2d
!    module procedure genrand_res53_3d
!    module procedure genrand_res53_4d
!    module procedure genrand_res53_5d
!    module procedure genrand_res53_6d
!    module procedure genrand_res53_7d
!  end interface genrand_res53

  contains

  elemental function uiadd( a, b ) result( c )

!    intrinsic :: ibits, ior, ishft

    integer( kind = wi ), intent( in )  :: a, b

    integer( kind = wi )  :: c

    integer( kind = wi )  :: a1, a2, b1, b2, s1, s2

    a1 = ibits( a, 0, hbs )
    a2 = ibits( a, hbs, hbs )
    b1 = ibits( b, 0, hbs )
    b2 = ibits( b, hbs, hbs )
    s1 = a1 + b1
    s2 = a2 + b2 + ibits( s1, hbs, hbs )
    c  = ior( ishft( s2, hbs ), ibits( s1, 0, hbs ) )
    return

  end function uiadd
  
!  elemental function uisub( a, b ) result( c )
!
!    intrinsic :: ibits, ior, ishft
!
!    integer( kind = wi ), intent( in )  :: a, b
!
!    integer( kind = wi )  :: c
!
!    integer( kind = wi )  :: a1, a2, b1, b2, s1, s2
!
!    a1 = ibits( a, 0, hbs )
!    a2 = ibits( a, hbs, hbs )
!    b1 = ibits( b, 0, hbs )
!    b2 = ibits( b, hbs, hbs )
!    s1 = a1 - b1
!    s2 = a2 - b2 + ibits( s1, hbs, hbs )
!    c  = ior( ishft( s2, hbs ), ibits( s1, 0, hbs ) )
!    return
!
!  end function uisub
!  
  elemental function uimlt( a, b ) result( c )

!    intrinsic :: ibits, ior, ishft

    integer(kind=wi), intent(in)  :: a, b

    integer(kind=wi)  :: c

    integer(kind=wi)  :: a0, a1, a2, a3
    integer(kind=wi)  :: b0, b1, b2, b3
    integer(kind=wi)  :: p0, p1, p2, p3

    a0 = ibits( a, 0, qbs )
    a1 = ibits( a, qbs, qbs )
    a2 = ibits( a, hbs, qbs )
    a3 = ibits( a, tbs, qbs )
    b0 = ibits( b, 0, qbs )
    b1 = ibits( b, qbs, qbs )
    b2 = ibits( b, hbs, qbs )
    b3 = ibits( b, tbs, qbs )
    p0 = a0 * b0
    p1 = a1 * b0 + a0 * b1 + ibits( p0, qbs, tbs )
    p2 = a2 * b0 + a1 * b1 + a0 * b2 + ibits( p1, qbs, tbs )
    p3 = a3 * b0 + a2 * b1 + a1 * b2 + a0 * b3 + ibits( p2, qbs, tbs )
    c  = ior( ishft( p1, qbs ), ibits( p0, 0, qbs ) )
    c  = ior( ishft( p2, hbs ), ibits( c, 0, hbs ) )
    c  = ior( ishft( p3, tbs ), ibits( c, 0, tbs ) )
    return

  end function uimlt
!
!  elemental function uidiv( a, b ) result( c )
!    
!    intrinsic :: btest, ishft
!
!    integer(kind=wi), intent(in)  :: a, b
!
!    integer(kind=wi)  :: c
!
!    integer(kind=wi)  :: dl, rl
!
!    if ( btest( a, fbs-1 ) ) then
!      if ( btest( b, fbs-1 ) ) then
!        if ( a < b ) then
!          c = 0
!        else
!          c = 1
!        end if
!      else
!        dl = ishft( ishft( a, -1 ) / b, 1 )
!        rl = uisub( a, uimlt( b, dl ) )
!        if ( rl < b ) then
!          c = dl
!        else
!          c = uiadd( dl, 1 )
!        end if
!      end if
!    else
!      if ( btest( b, fbs-1 ) ) then
!        c = 0
!      else
!        c = a / b
!      end if
!    end if
!    return
!
!  end function uidiv
!
!  elemental function uimod( a, b ) result( c )
!    
!    intrinsic :: modulo, btest, ishft
!
!    integer(kind=wi), intent(in)  :: a, b
!
!    integer(kind=wi)  :: c
!
!    integer(kind=wi)  :: dl, rl
!
!    if ( btest( a, fbs-1 ) ) then
!      if ( btest( b, fbs-1 ) ) then
!        if ( a < b ) then
!          c = a
!        else
!          c = uisub( a, b )
!        end if
!      else
!        dl = ishft( ishft( a, -1 ) / b, 1 )
!        rl = uisub( a, uimlt( b, dl ) )
!        if ( rl < b ) then
!          c = rl
!        else
!          c = uisub( rl, b )
!        end if
!      end if
!    else
!      if ( btest( b, fbs-1 ) ) then
!        c = a
!      else
!        c = modulo( a, b )
!      end if
!    end if
!    return
!
!  end function uimod
!
!  subroutine init_by_type( put, get )
!
!    intrinsic :: present
!
!    type(genrand_state), optional, intent(in ) :: put
!    type(genrand_state), optional, intent(out) :: get
!
!    if ( present( put ) ) then
!      if ( put%ini ) state = put
!    else if ( present( get ) ) then
!      if ( .not. state%ini ) call init_by_scalar( default_seed )
!      get = state
!    else
!      call init_by_scalar( default_seed )
!    end if
!    return
!
!  end subroutine init_by_type

  ! initializes mt[N] with a seed
  subroutine init_by_scalar( put )

!    intrinsic :: ishft, ieor, ibits

    integer(kind=wi), parameter :: mult_a = 1812433253_wi !z'6C078965'

    integer(kind=wi), intent(in)  :: put

    integer(kind=wi)  :: i

    state%ini = .true._wi
    state%val(1) = ibits( put, 0, fbs )
    do i = 2, n, 1
      state%val(i) = ieor( state%val(i-1), ishft( state%val(i-1), -30 ) )
      state%val(i) = uimlt( state%val(i), mult_a )
      state%val(i) = uiadd( state%val(i), i-1_wi )
      ! See Knuth TAOCP Vol2. 3rd Ed. P.106 for multiplier. 
      ! In the previous versions, MSBs of the seed affect   
      ! only MSBs of the array mt[].                        
      ! 2002/01/09 modified by Makoto Matsumoto             
      state%val(i) = ibits( state%val(i), 0, fbs )
      ! for >32 bit machines 
    end do
    state%cnt = n + 1_wi
    return

  end subroutine init_by_scalar

  ! initialize by an array with array-length 
  ! init_key is the array for initializing keys 
  ! key_length is its length
!  subroutine init_by_array( put )
!
!    intrinsic :: size, max, ishft, ieor, ibits
!    
!    integer(kind=wi), parameter :: seed_d =    19650218_wi !z'12BD6AA'
!    integer(kind=wi), parameter :: mult_a =     1664525_wi !z'19660D'
!    integer(kind=wi), parameter :: mult_b =  1566083941_wi !z'5D588B65'
!    integer(kind=wi), parameter :: msb1_d = ishft( 1_wi, fbs-1 ) !z'80000000'
!
!    integer(kind=wi), dimension(:), intent(in)  :: put
!
!    integer(kind=wi)  :: i, j, k, tp, key_length
!
!    call init_by_scalar( seed_d )
!    key_length = size( put, dim=1 )
!    i = 2_wi
!    j = 1_wi
!    do k = max( n, key_length ), 1, -1
!      tp = ieor( state%val(i-1), ishft( state%val(i-1), -30 ) )
!      tp = uimlt( tp, mult_a )
!      state%val(i) = ieor( state%val(i), tp )
!      state%val(i) = uiadd( state%val(i), uiadd( put(j), j-1_wi ) ) ! non linear 
!      state%val(i) = ibits( state%val(i), 0, fbs ) ! for WORDSIZE > 32 machines 
!      i = i + 1_wi
!      j = j + 1_wi
!      if ( i > n ) then
!        state%val(1) = state%val(n)
!        i = 2_wi
!      end if
!      if ( j > key_length) j = 1_wi
!    end do
!    do k = n-1, 1, -1
!      tp = ieor( state%val(i-1), ishft( state%val(i-1), -30 ) )
!      tp = uimlt( tp, mult_b )
!      state%val(i) = ieor( state%val(i), tp )
!      state%val(i) = uisub( state%val(i), i-1_wi ) ! non linear 
!      state%val(i) = ibits( state%val(i), 0, fbs ) ! for WORDSIZE > 32 machines 
!      i = i + 1_wi
!      if ( i > n ) then
!        state%val(1) = state%val(n)
!        i = 2_wi
!      end if
!    end do
!    state%val(1) = msb1_d ! MSB is 1; assuring non-zero initial array
!    return
!
!  end subroutine init_by_array

  subroutine next_state( )

!    intrinsic :: ishft, ieor, btest, ibits, mvbits

    integer(kind=wi), parameter :: matrix_a = -1727483681_wi !z'9908b0df'

    integer(kind=wi)  :: i, mld

    if ( .not. state%ini ) call init_by_scalar( default_seed )
    do i = 1, n-m, 1
      mld = ibits( state%val(i+1), 0, 31 )
      call mvbits( state%val(i), 31, 1, mld, 31 )
      state%val(i) = ieor( state%val(i+m), ishft( mld, -1 ) )
      if ( btest( state%val(i+1), 0 ) ) state%val(i) = ieor( state%val(i), matrix_a )
    end do
    do i = n-m+1, n-1, 1
      mld = ibits( state%val(i+1), 0, 31 )
      call mvbits( state%val(i), 31, 1, mld, 31 )
      state%val(i) = ieor( state%val(i+m-n), ishft( mld, -1 ) )
      if ( btest( state%val(i+1), 0 ) ) state%val(i) = ieor( state%val(i), matrix_a )
    end do
    mld = ibits( state%val(1), 0, 31 )
    call mvbits( state%val(n), 31, 1, mld, 31 )
    state%val(n) = ieor( state%val(m), ishft( mld, -1 ) )
    if ( btest( state%val(1), 0 ) ) state%val(n) = ieor( state%val(n), matrix_a )
    state%cnt = 1_wi
    return

  end subroutine next_state

!  elemental subroutine genrand_encode( chr, val )
!    
!    intrinsic :: len
!
!    character(len=*), intent(out) :: chr
!    integer(kind=wi), intent(in ) :: val
!    
!    integer(kind=wi)  :: i, m, d
!
!    d = val
!    chr = ""
!    do i = 1, len( chr ), 1
!      m = uimod( d, alps ) + 1
!      chr(i:i) = alph(m:m)
!      d = uidiv( d, alps )
!      if ( d == 0 ) exit
!    end do
!    return
!
!  end subroutine genrand_encode
!
!  elemental subroutine genrand_decode( val, chr )
!    
!    intrinsic :: len, len_trim, trim, adjustl, scan
!
!    integer(kind=wi), intent(out) :: val
!    character(len=*), intent(in ) :: chr
!    
!    integer(kind=wi)        :: i, e, p
!    character(len=len(chr)) :: c
!
!    e = 1
!    c = trim( adjustl( chr ) )
!    val = 0
!    do i = 1, len_trim( c ), 1
!      p = scan( alph, c(i:i) ) - 1
!      if( p >= 0 ) then
!        val = uiadd( val, uimlt( p, e ) )
!        e = uimlt( e, alps )
!      end if
!    end do
!    return
!
!  end subroutine genrand_decode
!
!  elemental subroutine genrand_load_state( stt, rpr )
!
!    intrinsic :: scan
!
!    type(genrand_state), intent(out)  :: stt
!    type(genrand_srepr), intent(in )  :: rpr
!
!    integer(kind=wi)    :: i, j
!    character(len=clen) :: c
!
!    i = 1
!    c = rpr%repr
!    do
!      j = scan( c, sepr )
!      if ( j /= 0 ) then
!        call genrand_decode( stt%val(i), c(:j-1) )
!        i = i + 1
!        c = c(j+1:)
!      else
!        exit
!      end if
!    end do
!    call genrand_decode( stt%cnt, c )
!    stt%ini = .true._wi
!    return
!
!  end subroutine genrand_load_state
!
!  elemental subroutine genrand_dump_state( rpr, stt )
!
!    intrinsic :: len_trim
!
!    type(genrand_srepr), intent(out) :: rpr
!    type(genrand_state), intent(in ) :: stt
!
!    integer(kind=wi)  :: i, j
!
!    j = 1
!    rpr%repr = ""
!    do i = 1, n, 1
!      call genrand_encode( rpr%repr(j:), stt%val(i) )
!      j = len_trim( rpr%repr ) + 1
!      rpr%repr(j:j) = sepr
!      j = j + 1
!    end do
!    call genrand_encode( rpr%repr(j:), stt%cnt )
!    return
!
!  end subroutine genrand_dump_state

  ! generates a random number on [0,0xffffffff]-interval
  subroutine genrand_int32_0d( y )

!    intrinsic :: ieor, iand, ishft

    integer(kind=wi), parameter :: temper_a = -1658038656_wi !z'9D2C5680'
    integer(kind=wi), parameter :: temper_b =  -272236544_wi !z'EFC60000'

    integer(kind=wi), intent(out) :: y
    
    if ( state%cnt > n ) call next_state( )
    y = state%val(state%cnt)
    state%cnt = state%cnt + 1_wi
    ! Tempering 
    y = ieor( y, ishft( y, -11 ) )
    y = ieor( y, iand( ishft( y,  7 ), temper_a ) )
    y = ieor( y, iand( ishft( y, 15 ), temper_b ) )
    y = ieor( y, ishft( y, -18 ) )
    return

  end subroutine genrand_int32_0d

!  subroutine genrand_int32_1d( y )
!
!    intrinsic :: size
!
!    integer(kind=wi), dimension(:), intent(out) :: y
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( y, 1 ), 1
!      call genrand_int32_0d( y(i) )
!    end do
!    return
!
!  end subroutine genrand_int32_1d
!
!  subroutine genrand_int32_2d( y )
!
!    intrinsic :: size
!
!    integer(kind=wi), dimension(:,:), intent(out) :: y
!    
!    integer(kind=wi)  :: i
!
!    do i = 1, size( y, 2 ), 1
!      call genrand_int32_1d( y(:,i) )
!    end do
!    return
!
!  end subroutine genrand_int32_2d
!
!  subroutine genrand_int32_3d( y )
!
!    intrinsic :: size
!
!    integer(kind=wi), dimension(:,:,:), intent(out) :: y
!    
!    integer(kind=wi)  :: i
!
!    do i = 1, size( y, 3 ), 1
!      call genrand_int32_2d( y(:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_int32_3d
!
!  subroutine genrand_int32_4d( y )
!
!    intrinsic :: size
!
!    integer(kind=wi), dimension(:,:,:,:), intent(out) :: y
!    
!    integer(kind=wi)  :: i
!
!    do i = 1, size( y, 4 ), 1
!      call genrand_int32_3d( y(:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_int32_4d
!
!  subroutine genrand_int32_5d( y )
!
!    intrinsic :: size
!
!    integer(kind=wi), dimension(:,:,:,:,:), intent(out) :: y
!    
!    integer(kind=wi)  :: i
!
!    do i = 1, size( y, 5 ), 1
!      call genrand_int32_4d( y(:,:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_int32_5d
!
!  subroutine genrand_int32_6d( y )
!
!    intrinsic :: size
!
!    integer(kind=wi), dimension(:,:,:,:,:,:), intent(out) :: y
!    
!    integer(kind=wi)  :: i
!
!    do i = 1, size( y, 6 ), 1
!      call genrand_int32_5d( y(:,:,:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_int32_6d
!
!  subroutine genrand_int32_7d( y )
!
!    intrinsic :: size
!
!    integer(kind=wi), dimension(:,:,:,:,:,:,:), intent(out) :: y
!    
!    integer(kind=wi)  :: i
!
!    do i = 1, size( y, 7 ), 1
!      call genrand_int32_6d( y(:,:,:,:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_int32_7d
!
!  ! generates a random number on [0,0x7fffffff]-interval
!  subroutine genrand_int31_0d( y )
!
!    intrinsic :: ishft
!
!    integer(kind=wi), intent(out) :: y
!
!    call genrand_int32_0d( y )
!    y = ishft( y, -1 )
!    return
!
!  end subroutine genrand_int31_0d
!
!  subroutine genrand_int31_1d( y )
!
!    intrinsic :: size
!
!    integer(kind=wi), dimension(:), intent(out) :: y
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( y, 1 ), 1
!      call genrand_int31_0d( y(i) )
!    end do
!    return
!
!  end subroutine genrand_int31_1d
!
!  subroutine genrand_int31_2d( y )
!
!    intrinsic :: size
!
!    integer(kind=wi), dimension(:,:), intent(out) :: y
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( y, 2 ), 1
!      call genrand_int31_1d( y(:,i) )
!    end do
!    return
!
!  end subroutine genrand_int31_2d
!
!  subroutine genrand_int31_3d( y )
!
!    intrinsic :: size
!
!    integer(kind=wi), dimension(:,:,:), intent(out) :: y
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( y, 3 ), 1
!      call genrand_int31_2d( y(:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_int31_3d
!
!  subroutine genrand_int31_4d( y )
!
!    intrinsic :: size
!
!    integer(kind=wi), dimension(:,:,:,:), intent(out) :: y
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( y, 4 ), 1
!      call genrand_int31_3d( y(:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_int31_4d
!
!  subroutine genrand_int31_5d( y )
!
!    intrinsic :: size
!
!    integer(kind=wi), dimension(:,:,:,:,:), intent(out) :: y
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( y, 5 ), 1
!      call genrand_int31_4d( y(:,:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_int31_5d
!
!  subroutine genrand_int31_6d( y )
!
!    intrinsic :: size
!
!    integer(kind=wi), dimension(:,:,:,:,:,:), intent(out) :: y
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( y, 6 ), 1
!      call genrand_int31_5d( y(:,:,:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_int31_6d
!
!  subroutine genrand_int31_7d( y )
!
!    intrinsic :: size
!
!    integer(kind=wi), dimension(:,:,:,:,:,:,:), intent(out) :: y
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( y, 7 ), 1
!      call genrand_int31_6d( y(:,:,:,:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_int31_7d
!
!  ! generates a random number on [0,1]-real-interval
!  subroutine genrand_real1_0d( r )
!
!    intrinsic :: real
!
!    real(kind=wr), intent(out)  :: r
!
!    integer(kind=wi)  :: a
!
!    call genrand_int32_0d( a )
!    r = real( a, kind=wr ) * pi232_1 + p231d232_1
!    ! divided by 2^32-1
!    return
!
!  end subroutine genrand_real1_0d
!
!  subroutine genrand_real1_1d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 1 ), 1
!      call genrand_real1_0d( r(i) )
!    end do
!    return
!
!  end subroutine genrand_real1_1d
!
!  subroutine genrand_real1_2d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 2 ), 1
!      call genrand_real1_1d( r(:,i) )
!    end do
!    return
!
!  end subroutine genrand_real1_2d
!
!  subroutine genrand_real1_3d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 3 ), 1
!      call genrand_real1_2d( r(:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_real1_3d
!
!  subroutine genrand_real1_4d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:,:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 4 ), 1
!      call genrand_real1_3d( r(:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_real1_4d
!
!  subroutine genrand_real1_5d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:,:,:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 5 ), 1
!      call genrand_real1_4d( r(:,:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_real1_5d
!
!  subroutine genrand_real1_6d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:,:,:,:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 6 ), 1
!      call genrand_real1_5d( r(:,:,:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_real1_6d
!
!  subroutine genrand_real1_7d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:,:,:,:,:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 7 ), 1
!      call genrand_real1_6d( r(:,:,:,:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_real1_7d
!
!  ! generates a random number on [0,1)-real-interval
!  subroutine genrand_real2_0d( r )
!
!    intrinsic :: real
!
!    real(kind=wr), intent(out)  :: r
!
!    integer(kind=wi)  :: a
!
!    call genrand_int32_0d( a )
!    r = real( a, kind=wr ) * pi232 + 0.5_wr
!    ! divided by 2^32
!    return
!
!  end subroutine genrand_real2_0d
!
!  subroutine genrand_real2_1d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 1 ), 1
!      call genrand_real2_0d( r(i) )
!    end do
!    return
!
!  end subroutine genrand_real2_1d
!
!  subroutine genrand_real2_2d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 2 ), 1
!      call genrand_real2_1d( r(:,i) )
!    end do
!    return
!
!  end subroutine genrand_real2_2d
!
!  subroutine genrand_real2_3d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 3 ), 1
!      call genrand_real2_2d( r(:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_real2_3d
!
!  subroutine genrand_real2_4d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:,:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 4 ), 1
!      call genrand_real2_3d( r(:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_real2_4d
!
!  subroutine genrand_real2_5d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:,:,:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 5 ), 1
!      call genrand_real2_4d( r(:,:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_real2_5d
!
!  subroutine genrand_real2_6d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:,:,:,:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 6 ), 1
!      call genrand_real2_5d( r(:,:,:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_real2_6d
!
!  subroutine genrand_real2_7d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:,:,:,:,:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 7 ), 1
!      call genrand_real2_6d( r(:,:,:,:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_real2_7d
!
!  ! generates a random number on (0,1)-real-interval
!  subroutine genrand_real3_0d( r )
!
!    intrinsic :: real
!
!    real(kind=wr), intent(out)  :: r
!
!    integer(kind=wi)  :: a
!
!    call genrand_int32_0d( a )
!    r = real( a, kind=wr ) * pi232 + p231_5d232
!    ! divided by 2^32 
!    return
!
!  end subroutine genrand_real3_0d
!
!  subroutine genrand_real3_1d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 1 ), 1
!      call genrand_real3_0d( r(i) )
!    end do
!    return
!
!  end subroutine genrand_real3_1d
!
!  subroutine genrand_real3_2d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 2 ), 1
!      call genrand_real3_1d( r(:,i) )
!    end do
!    return
!
!  end subroutine genrand_real3_2d
!
!  subroutine genrand_real3_3d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 3 ), 1
!      call genrand_real3_2d( r(:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_real3_3d
!
!  subroutine genrand_real3_4d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:,:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 4 ), 1
!      call genrand_real3_3d( r(:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_real3_4d
!
!  subroutine genrand_real3_5d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:,:,:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 5 ), 1
!      call genrand_real3_4d( r(:,:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_real3_5d
!
!  subroutine genrand_real3_6d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:,:,:,:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 6 ), 1
!      call genrand_real3_5d( r(:,:,:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_real3_6d
!
!  subroutine genrand_real3_7d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:,:,:,:,:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 7 ), 1
!      call genrand_real3_6d( r(:,:,:,:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_real3_7d
!
!  ! generates a random number on [0,1) with 53-bit resolution
!  subroutine genrand_res53_0d( r )
!
!    intrinsic :: ishft, real
!
!    real(kind=wr), intent(out)  :: r
!
!    integer(kind=wi)  :: a, b
!
!    call genrand_int32_0d( a )
!    call genrand_int32_0d( b )
!    a = ishft( a, -5 )
!    b = ishft( b, -6 )
!    r = real( a, kind=wr ) * pi227 + real( b, kind=wr ) * pi253
!    return
!
!  end subroutine genrand_res53_0d
!
!  subroutine genrand_res53_1d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 1 ), 1
!      call genrand_res53_0d( r(i) )
!    end do
!    return
!
!  end subroutine genrand_res53_1d
!
!  subroutine genrand_res53_2d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 2 ), 1
!      call genrand_res53_1d( r(:,i) )
!    end do
!    return
!
!  end subroutine genrand_res53_2d
!
!  subroutine genrand_res53_3d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 3 ), 1
!      call genrand_res53_2d( r(:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_res53_3d
!
!  subroutine genrand_res53_4d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:,:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 4 ), 1
!      call genrand_res53_3d( r(:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_res53_4d
!
!  subroutine genrand_res53_5d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:,:,:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 5 ), 1
!      call genrand_res53_4d( r(:,:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_res53_5d
!
!  subroutine genrand_res53_6d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:,:,:,:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 6 ), 1
!      call genrand_res53_5d( r(:,:,:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_res53_6d
!
!  subroutine genrand_res53_7d( r )
!
!    intrinsic :: size
!
!    real(kind=wr), dimension(:,:,:,:,:,:,:), intent(out)  :: r
!
!    integer(kind=wi)  :: i
!
!    do i = 1, size( r, 7 ), 1
!      call genrand_res53_6d( r(:,:,:,:,:,:,i) )
!    end do
!    return
!
!  end subroutine genrand_res53_7d
  ! These real versions are due to Isaku Wada, 2002/01/09 added 
  ! Altered by José Sousa genrand_real[1-3] will not return exactely
  ! the same values but should have the same properties and are faster

  subroutine genrand_real4( r )

!    intrinsic :: real

    real(kind=wr), intent(out)  :: r

    integer(kind=wi)  :: a

    call genrand_int32_0d( a )
    
    if (a < 0) then
       r = (real( a, kind=wr ) + p232) * pi232_1
       ! divided by 2^32-1
    else
       r =  real( a, kind=wr ) * pi232_1
    endif
    return

  end subroutine genrand_real4

!end module mt95
end module random_m

!=================================================================================
!
! Routines:
!
! (1) mtxel_kernel()         Originally By MLT     Last Modified  02/02/2013 (FHJ)
!
!     input: crys, gvec, syms, qg, wfnc, wfncp, wfnv, wfnvp,
!            xct types
!            ii  = label of ck block
!            ipe = label of the PE that contains the ckp block
!     output: bsedbody,bsedhead,bsedwing,bsex = kernel matrix elements
!              between ck (all v) and ckp (all vp) blocks
!
!     Calculate the head, wings, body, exchange of the kernel (see
!     eq. 34, 35, and 41-46, Rohlfing & Louie). The exchange has just
!     the proper part, no divergent contribution.
!
!=================================================================================

#include "f_defs.h"

module mtxel_kernel_m

  use global_m
  use fftw_m
  use gmap_m
  use misc_m
  use w_sum_m
  use g_sum_m
  use gx_sum_m
  implicit none

  public :: mtxel_kernel

  private

  !> FHJ: pointer to a wavefunction. We use this construction b/c Fortran, in
  !! all its infinite might and wisdom, doesn`t allow arrays of pointers.
  type wavefunction_ptr
    type(wavefunction), pointer :: p
  end type wavefunction_ptr

  !> FHJ: contains the indices of G, G-G0, -G and G0-G. Used by charge_matrix
  !! depending on whether there`s umklapp involved.
  type gvec_indices
    !> Index of G, G-G0, -G, and G0-G
    integer, pointer :: gmg0(:), g0mg(:), g(:), mg(:)
  end type gvec_indices

  type matrix_4
    SCALAR, pointer :: p(:,:,:,:) => Null()
  end type matrix_4

contains

  subroutine mtxel_kernel(crys,gvec,syms,qg,wfnc,wfncp,wfnvp, &
    wfnv,xct,leading_dim,bsedbody,bsedhead,bsedwing,bsex,ii,ik,ikp, &
    ic_in,icp_in,iv_in,ivp_in,vcoularray,fq,qq,g0,ifq,irq,q0len)

    type (crystal), intent(in) :: crys
    type (gspace), intent(in) :: gvec
    type (symmetry), intent(in) :: syms
    type (grid), intent(in) :: qg
    type (wavefunction), target, intent(in) :: wfnc,wfncp,wfnvp,wfnv
    type (xctinfo), intent(in) :: xct
    integer, intent(in) :: leading_dim
    SCALAR, intent(inout) :: bsedbody(:,:,:), bsedhead(:,:,:), bsedwing(:,:,:), &
      bsex(:,:,:) !< (leading_dim,xct%nspin,xct%nspin)
    integer, intent(in) :: ii,ik,ikp,ic_in,icp_in,iv_in,ivp_in
    real(DP), intent(in) :: vcoularray(:,:) !< (xct%ng,qg%nf)
    real(DP), intent(in) :: fq(3),qq
    integer, intent(in) :: g0(3)
    integer, intent(in) :: ifq !< q-pt index in full BZ
    integer, intent(in) :: irq !< k-pt index in reduced BZ
    real(DP), intent(in) :: q0len

    integer :: ipe
    character :: filename*20
    integer :: jj,sinv
    integer :: ig,igp,igpe
    integer :: neps,nepsmin
    !> Number of g-vectors in the gvec G-space needed to describe the dielectric matrix.
    integer :: ng_eps
    !> Number of conduction/valence bands we are dealing with. nbands is an
    !! array with (/ invband, incband /)
    integer :: incband, invband, nbands(2)
    !> The "left" and "right" set of WFNs that we use to get charge density matrices.
    !! The first index represents a v=1 or c=2 type of WFN, and the second
    !! index is whether it is at k(=1) or kp(=2).
    integer :: wfn_l(2), wfn_r(2)
    real(DP) :: qlen,vq(3)

    integer :: ipeDumb
    integer, save :: ik_old = 0
    integer, save :: ikp_old = 0
    integer, save :: iv_old = 0
    integer, save :: ivp_old = 0
    integer, save :: ic_old = 0
    integer, save :: icp_old = 0
    logical :: ivsaved, icsaved, ixsaved, ixpsaved

    integer, allocatable :: isrtqi(:), isrtqt(:), ind(:), indinv(:)
    real(DP), allocatable :: vcoul(:)
    SCALAR :: wval,epshead
    SCALAR, allocatable :: &
      epscol(:),wptcol(:),ph(:),phinv(:),epscolt(:,:),epscolt2(:,:), &
      tempw(:,:,:,:),tempb(:,:,:,:),temph(:,:,:)
    SCALAR, pointer :: mccp(:,:,:,:),mvvp(:,:,:,:),mvc(:,:,:,:),mvpcp(:,:,:,:)
    SCALAR, save, allocatable :: &
      tempw_old(:,:,:,:),tempb_old(:,:,:,:),temph_old(:,:,:)
    SCALAR, save, allocatable :: &
      mccp_old(:,:,:,:),mvc_old(:,:,:,:),mvpcp_old(:,:,:,:)

    integer :: irqt
    real(DP) :: fact

    complex(DPC), dimension(:,:,:), allocatable :: fftbox1,fftbox2
    real(DP) :: scale
    type(gvec_indices) :: g_idx
    integer :: Nfft(3)
    integer :: itotj
    logical :: save_ffts !< reuse WFNs ffts within the subroutine?
    !> If we are saving the ffts, precalculate the fftboxes for all WFNs.
    !! Indices are (x, y, z, spin, band, ik or ikp?)
    complex(DPC), dimension(:,:,:,:,:,:), allocatable :: fftboxes
    ! (c/p, k/kp) points to the appropriate WFW (wfnv, wfnc, wfnvp, wfncp)
    type(wavefunction_ptr) :: wfns(2,2)
    type(matrix_4), target :: mats(2,2,2,2)

    PUSH_SUB(mtxel_kernel)

    !==============================================================================
    ! Initialization: determine if we can reuse previous matrix elements, etc.
    !==============================================================================
    save_ffts = .false.
    wfns(1,1)%p => wfnv
    wfns(1,2)%p => wfnvp
    wfns(2,1)%p => wfnc
    wfns(2,2)%p => wfncp
    ivsaved = .false.
    ixsaved = .false.
    ixpsaved = .false.
    icsaved = .false.
    if ( ik /= -1) then
      if (xct%ivpar .eq. 0) invband=xct%nvb_co
      if (xct%ivpar .eq. 1) invband=1
      if (xct%icpar .eq. 0) incband=xct%ncb_co
      if (xct%icpar .eq. 1) incband=1
      nbands = (/ invband, incband /)

      if (ik_old .eq. ik .and. ikp_old .eq. ikp) then
        if (iv_old .eq. iv_in .and. ic_old .eq. ic_in) then
          ixsaved = .true.
          !            if (peinf%inode .eq. 0) write(6,781) ii,iv_old,iv_in,ic_old,ic_in
        endif
        if (ivp_old .eq. ivp_in .and. icp_old .eq. icp_in) then
          ixpsaved = .true.
          !            if (peinf%inode .eq. 0) write(6,782) ii,ivp_old,ivp_in,icp_old,icp_in
        endif
        if (iv_old .eq. iv_in .and. ivp_old .eq. ivp_in) then
          ivsaved = .true.
          !            if (peinf%inode .eq. 0) write(6,783) ii,iv_old,iv_in,ivp_old,ivp_in
        else
          iv_old=iv_in
          ivp_old=ivp_in
        endif
        if (ic_old .eq. ic_in .and. icp_old .eq. icp_in) then
          icsaved = .true.
          !            if (peinf%inode .eq. 0) write(6,784) ii,ic_old,ic_in,icp_old,icp_in
        else
          ic_old=ic_in
          icp_old=icp_in
        endif
      else
        ic_old=ic_in
        icp_old=icp_in
        iv_old=iv_in
        ivp_old=ivp_in
        ik_old=ik
        ikp_old=ikp
      endif
      !781     format('Reusing Exchange Matrix Elements',5i6)
      !782     format('Reusing Exchange Matrix P Elements',5i6)
      !783     format('Reusing Valence Matrix Elements',5i6)
      !784     format('Reusing Conduction Matrix Elements',5i6)

      sinv = 1
      if (ik.gt.ikp) sinv = -1
      if (.not. ivsaved) then
        SAFE_ALLOCATE(isrtqi, (gvec%ng))
        isrtqi=0
      endif
      call init_g_idx(xct, gvec, g0, sinv, g_idx)
      call timacc(61,1)
    endif

    !==============================================================================
    ! Initialize epsilon and v(q)
    !==============================================================================
    ! Read dielectric matrix at q. The umklapp vector g0 is k - kp = q + g0
    ! JRD: All procs need to participate in the communication
    if (xct%bLowComm) then
      if ( ik /= -1 .and. (.not. ivsaved)) then
        isrtqi(:)=xct%isrtqi(:,irq)
      endif
      ! JRD NEED GLOBAL IVSAVED HERE
    else if (.true.) then
      SAFE_ALLOCATE(isrtqt, (gvec%ng))
      do irqt = 1, qg%nr
        if (peinf%inode .eq. 0) then
          isrtqt(:)=xct%isrtqi(:,irqt)
        endif
#ifdef MPI
        call MPI_BCAST(isrtqt,gvec%ng,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
        if (irq .eq. irqt .and. ik /= -1 .and. (.not. ivsaved)) isrtqi(:) = isrtqt(:)
      enddo
      SAFE_DEALLOCATE(isrtqt)
    endif

    if ( ik /= -1 .and. (.not. ivsaved)) then
      neps=xct%nmtxa(irq)
      nepsmin = max(xct%neps, neps)
      SAFE_ALLOCATE(epscol, (neps))
      call timacc(61,2)

      ! Compute Coulomb interaction at this q vector: vcoul(q+G) for q+G=0 we set
      ! the interaction to V(q0) where q0 is the small vector used for epsilon
      SAFE_ALLOCATE(vcoul, (xct%ng))
      call get_vcoul(.false., fq)

      ! FHJ: There are two G-spaces here, which historically caused several bugs:
      ! - The gvec space: vectors ig_gvec sorted wrt |G|^2; and
      ! - The epsilon space: vectors ig_eps sorted wrt |R(G+q)|^2
      ! Different vectors/matrices will be ordered wrt a different space:
      ! - gvec space: M12 matrices, temp{w/b}, wptcol, vcoul
      ! - eps space: epscol
      ! To get from one space to the other use the following mapping arrays:
      !  ig_eps = ind(ig_gvec); ig_gvec = indinv(ig_eps)
      ! The code below loops over all xct%ng vectors ig_gvec from gvec G-space to
      ! find the mapping to the eps G-space.
      ! IMPORTANT: ind and indinv will always return a valid index. If the mapping
      ! is actually missing, we zero out the phases ph(ig_gvec)/phinv(ig_eps).
      ! So, always use phinv(ig_eps), and not ph(indinv(ig_eps))!
      call timacc(69,1)
      igp=0
      SAFE_ALLOCATE(ind, (xct%ng))
      SAFE_ALLOCATE(indinv, (nepsmin))
      SAFE_ALLOCATE(ph, (xct%ng))
      SAFE_ALLOCATE(phinv, (nepsmin))
      ind(:)=0
      indinv(:)=0
      ph(:)=ZERO
      phinv(:)=ZERO

      call gmap(gvec, syms, xct%ng, qg%itran(ifq), qg%kg0(:,ifq), g_idx%g, &
        isrtqi, ind, ph, xct%die_outside_sphere)
      if(ind(1)==0 .or. ind(1)>neps) then
        call die('Could not map the head of the dielectric matrix!', &
          only_root_writes=.true.)
      endif

      ! FHJ: find the inverse mapping and the maximum number of G-vectors
      ! that we need in order to describe wptcoul(ig_gvec).
      ng_eps = 0
      do ig=1,xct%ng
        if (ind(ig)>0 .and. ind(ig)<=neps) then
          indinv(ind(ig)) = ig
          phinv(ind(ig)) = ph(ig)
          ng_eps = ig
        else
          ind(ig) = neps
          ph(ig) = ZERO
        endif
      enddo
      do ig=1,neps
        if (indinv(ig)>0 .and. indinv(ig)<=xct%ng) then
          if (ind(indinv(ig))/=ig) &
            call die('Error in mtxel_kernel: mapping from eps to g-space not consistent!')
        else
          indinv(ig) = xct%ng
          phinv(ig) = ZERO
          call warn_about_mapping()
        endif
      enddo

      SAFE_ALLOCATE(wptcol, (ng_eps))
      wptcol=ZERO
      call timacc(69,2)
      call timacc(70,1) ! why are we timing retrieving a single value from an array...?

      ! We need to now find the head of epsilon
      epshead=xct%epsdiag(ind(1),irq)

      call timacc(70,2)
    endif

    !==============================================================================
    ! Prepare fftboxes and precalculate WFN FFTs, if there`s enough memory.
    !==============================================================================
    if ( ik /= -1 ) then
      ! Compute size of FFT box we need
      call timacc(34,1)
      call setup_FFT_sizes(gvec%FFTgrid,Nfft,scale)
      ! Allocate FFT boxes
      if (xct%ilowmem==-1) then
        save_ffts = .true.
        SAFE_ALLOCATE(fftboxes, (Nfft(1),Nfft(2),Nfft(3),xct%nspin,invband+incband,2))
        call precompute_ffts()
      endif
      SAFE_ALLOCATE(fftbox1, (Nfft(1),Nfft(2),Nfft(3)))
      SAFE_ALLOCATE(fftbox2, (Nfft(1),Nfft(2),Nfft(3)))
      call timacc(34,2)
    endif

    !==============================================================================
    ! Compute direct term matrix elements: <ck|e^{i(G-G0).r}|cpkp>, etc.
    !==============================================================================
    if ( ik /= -1 ) then

      ! If g0(:) is non-zero, the size of mccp,mvvp must increase: umklapp vector
      call timacc(65,1)
      call logit('         mtxel_kernel: direct term mats')

      call timacc(33,1)
      if (.not. ivsaved) then
        if (ii .ne. 1) then
          SAFE_DEALLOCATE(tempb_old)
          SAFE_DEALLOCATE(tempw_old)
          SAFE_DEALLOCATE(temph_old)
        end if
      endif

      if (.not. icsaved .and. xct%icpar .eq. 1) then
        if (ii .ne. 1) then
          SAFE_DEALLOCATE(mccp_old)
        end if
        SAFE_ALLOCATE(mccp_old, (xct%ng,1,1,xct%nspin))
      endif
      call timacc(33,2)

      ! Compute matrix elements: <ck|exp(i(k-kp-G0+G).r)|ckp> -> mccp
      call timacc(30,1)
      wfn_l = (/2,1/) ! <c,k|
      wfn_r = (/2,2/) ! |c,kp>
      call get_charge_matrix(mats, wfn_l, wfn_r, mccp, .not.icsaved, &
        m12_old=mccp_old, should_save=xct%icpar==1)
      call timacc(30,2)
      ! Compute matrix element: <vk|exp(i(k-kp-G0+G).r)|vkp> -> mvvp
      call timacc(31,1)
      wfn_l = (/1,1/) ! <v,k|
      wfn_r = (/1,2/) ! |v,kp>
      call get_charge_matrix(mats, wfn_l, wfn_r, mvvp, .not.ivsaved)
      call timacc(31,2)

      call timacc(65,2)
    endif ! ik /= -1

    !==============================================================================
    ! Compute screened interaction and perform sum over G (head, wings and body)
    !==============================================================================
    ! FHJ: The direct term is proportional to:
    ! bsed(iv,ivp,ic,icp) = sum(ig,igp) { [Mvvp(igp)]^* * W(ig,igp) * Mccp(ig) }
    !
    ! The strategy is:
    ! (1) Loop over all (distributed) columns of epsilon (igp):
    ! (1.1) Construct W(:, igp) for all G.
    ! (1.2) Call subroutine w_sum to multiply [Mvvp]^* by W. Eventually, we`ll get:
    !     temp?(ig,iv,ivp,is) = \sum{igp} [Mvvp(igp)]^* * W(ig,igp)
    ! (2) After the loop over igp, call g_sum to perform the sum over G and get:
    !     bsed(it,s,sp) = \sum_{ig} temp?(ig,iv,ivp,is) * Mccp(ig)
    !
    ! Things look a little bit messy because:
    ! (a) Epsilon is distributed across all processors
    ! (b) We have to worry about head/wing/body parts separately
    if ( ik /= -1 ) then

      !--------------------------------------------------------------------------
      ! Allocate buffers
      if ( .not. ivsaved ) then
        call timacc(61,1)
        call logit('         mtxel_kernel: head-wings-body')
        fact = 16.0d0 * PI_D / crys%celvol
        call logit('         mtxel_kernel: computing W(g,gp)')
        call timacc(61,2)
        if (xct%ivpar .eq. 1) then
          SAFE_ALLOCATE(temph, (1,1,xct%nspin))
          SAFE_ALLOCATE(tempw, (xct%ng,1,1,xct%nspin))
          SAFE_ALLOCATE(tempb, (xct%ng,1,1,xct%nspin))
        else
          SAFE_ALLOCATE(temph, (xct%n1b_co,xct%n1b_co,xct%nspin))
          SAFE_ALLOCATE(tempw, (xct%ng,xct%n1b_co,xct%n1b_co,xct%nspin))
          SAFE_ALLOCATE(tempb, (xct%ng,xct%n1b_co,xct%n1b_co,xct%nspin))
        endif
        temph(:,:,:) = 0.0d0
        tempw(:,:,:,:) = 0.0d0
        tempb(:,:,:,:) = 0.0d0

        ! JRD: Open EPS File
        call timacc(72,1)
        if (xct%iwriteint .eq. 0) then
          if (irq.le.10000) then
            write(filename,'(a,i4.4)') 'INT_EPS_',irq-1
          endif
          call open_file(17,file=filename,form='unformatted',status='old')
        endif
        call timacc(72,2)
      endif ! ivsaved
    endif ! ik /= -1

    ! FHJ: we want to calculate \sum_igp Mvvp^*(igp) eps_ig,igp for all ig, but eps
    ! is distributed along all processors! So instead of looping over all global
    ! igp, we loop over all processors, broadcast its chunk of eps (epscolt(:,:))
    ! and loop over all its local eps columns (igpe=1..xct%maxpe(ipe)).
    if (xct%iwriteint .eq. 1) then
      SAFE_ALLOCATE(epscolt, (xct%nmtxmax,xct%maxpet))
      SAFE_ALLOCATE(epscolt2, (xct%nmtxmax,xct%maxpet))
      epscolt=0
      epscolt2=0
    endif
    itotj=0
    do ipe = 1, peinf%npes
      ipeDumb = ipe
      if (ipe .eq. 1) ipeDumb = peinf%npes+1

      !----------------------------------------------------------------------
      ! Read and distribute epsilon. All processors must work here.
      if (xct%iwriteint .ne. 0) then
        call timacc(74,1)
        if ( xct%bLowComm ) then
          ! For LowComm, each PE has all epsilon, we we have to present it`s
          ! distributed so that we can still use the loop over ipe.
          epscolt = 0D0
          jj=1
          irqt = irq
          if (irqt .ne. 0) then
            do while ( (peinf%npes*(jj-1)+ipeDumb-1) .le. xct%nmtxmax )
              epscolt(:,jj)=xct%epscol(:,peinf%npes*(jj-1)+ipeDumb-1,irqt)      
              jj = jj + 1
            enddo
          endif
        else ! .not. bLowComm?
          do irqt = 1, qg%nr
            if ((ipe -1) .eq. peinf%inode) then
              epscolt2(:,:)=xct%epscol(:,:,irqt)
            endif
#ifdef MPI
            call MPI_BCAST(epscolt2,xct%nmtxmax*xct%maxpet,MPI_SCALAR,ipe-1,MPI_COMM_WORLD,mpierr)
#endif
            if (irq .eq. irqt) then
              epscolt=epscolt2
            endif
          enddo
        endif
        call timacc(74,2)
      endif ! xct%iwriteint /= 0

      ! FHJ: Epsilon was distributed and we have no work to do. Just cycle.
      if (ik .eq. -1 .or. ivsaved) cycle

      do igpe = 1, xct%maxpe(ipe)

        call timacc(71,1)
        itotj = itotj + 1
        if (xct%iwriteint .eq. 1) then
          igp = xct%epsowni(igpe,ipe)
        else
          igp = itotj
        endif

        epscol=0d0
        if (xct%iwriteint .eq. 0) then
          if (igp .le. nepsmin) then
            read(17) epscol(1:neps)
          else
            cycle
          endif
        else
          if (igp .le. nepsmin) then
            epscol(1:neps)=epscolt(1:neps,igpe)
          else
            cycle
          endif
        endif
        call timacc(71,2)
        if (phinv(igp)==0) cycle

        !------------------------------------------------------------------------
        ! Compute W(g,gp) for q + g0 = kp - k

        ! JRD: What we actually interpolate is only the head matrix elements (i.e. excluding
        ! the 1/q^2 factor), the wing part that does not diverge (i.e. multiplied by |q|), and the
        ! complete body element.  If we are truncating, instead of multiplying the wings by |q|
        ! we divide them noting that in this case the wing is DEFINED as being
        ! some smooth function multiplied by |q|*Vtrunc(G=0,q)*eps^-1(G=0,G`=0,q)
        ! This is because the wings of the dielectric matrix are /propto |q| and pick up a factor
        ! of eps^-1(G=0,G`=0,q) during the inversion process (see Epsilon/epsinv.f90).
        ! We include this factor here and not above because eps^-1(G=0,G`=0,q) varies quicker in truncated case.
        ! The Vtrunc(G=0,q) factor comes from the bare (truncated) coulomb interaction.

        call timacc(63,1)
        if (indinv(igp) .eq. 1) then ! Gp = 0. Treat head and right wing here.
          ! HEAD for q=0 and q<>0. Interpolate different things depending on
          ! what screening/truncation we use. See CPC paper Table 2.
          if (xct%iscreen .eq. 0) then
            ! Semiconductor Screening
            wptcol(1) = 1.0d0
          elseif (xct%iscreen .eq. 1) then
            ! Graphene Screening
            if (xct%icutv .eq. 0) then
              if ( qq .gt. Tol_Zero) then
                wptcol(1)=vcoul(1)*epscol(ind(1))*qq
              else
                wptcol(1)=vcoul(1)*epscol(ind(1))*q0len
              endif
            else
              wptcol(1)=1.0d0
            endif
          else
            ! Metal Screening
            wptcol(1)=vcoul(1)*epscol(ind(1))
          endif
          ! FIRST WING (g<>0, gp=0).
          call calc_wings()
        else ! Gp /= 0 follows.
          ! SECOND WING (g=0, gp<>0).
          call calc_wings()
          ! BODY (g<>0, gp<>0). Does not depend on truncation or screening.
          do ig=2,ng_eps
            wptcol(ig)=ph(ig)*MYCONJG(phinv(igp)) * &
              epscol(ind(ig))*vcoul(indinv(igp))
          enddo
        endif ! indinv(gp)

        ! Take complex conjugate of epsinv if ik>ikp
        if (sinv.eq.-1) wptcol = MYCONJG(wptcol)
        call timacc(63,2)
        ! Perform partial summation over ig
        call calc_direct_w_sum()
      enddo !igpe (gp loop)
    enddo !ipe
    SAFE_DEALLOCATE(epscolt)
    SAFE_DEALLOCATE(epscolt2)
    SAFE_DEALLOCATE(isrtqi)

    if ( .not. ivsaved) then

      if (ik .eq. -1) then
        ! We don`t have to work, and no one else requires our epsilon -> return
        POP_SUB(mtxel_kernel)
        return
      endif
      SAFE_DEALLOCATE(wptcol)
      SAFE_DEALLOCATE(epscol)
      if (xct%iwriteint .eq. 0) call close_file(17)

      ! Add in contribution from unscreened coulomb at high G vectors
      call calc_direct_unscreened_contrib(tempb)
      SAFE_DEALLOCATE(vcoul)
      SAFE_DEALLOCATE(ind)
      SAFE_DEALLOCATE(indinv)
      SAFE_DEALLOCATE(ph)
      call free_charge_matrix(mats, xct, mvvp)

      if (xct%ivpar .eq. 1) then
        SAFE_ALLOCATE(temph_old, (1,1,xct%nspin))
        SAFE_ALLOCATE(tempw_old, (xct%ng,1,1,xct%nspin))
        SAFE_ALLOCATE(tempb_old, (xct%ng,1,1,xct%nspin))
      else
        SAFE_ALLOCATE(temph_old, (xct%n1b_co,xct%nvb_co,xct%nspin))
        SAFE_ALLOCATE(tempw_old, (xct%ng,xct%n1b_co,xct%n1b_co,xct%nspin))
        SAFE_ALLOCATE(tempb_old, (xct%ng,xct%n1b_co,xct%n1b_co,xct%nspin))
      endif
      temph_old = temph
      tempw_old = tempw
      tempb_old = tempb
    endif ! ivsaved

    !==============================================================================
    ! SUM G vectors to get DIRECT kernel term.
    !==============================================================================
    call calc_direct_g_sum()
    call timacc(67,1)

    !==============================================================================
    ! Compute exchange matrix elements: <vk|e^{iG.r}|ck>, etc.
    !==============================================================================
    call logit('         mtxel_kernel: X term matrices')
    if (.not. ixsaved .and. xct%ivpar .eq. 1 .and. xct%icpar .eq. 1) then
      if (ii .ne. 1) then
        SAFE_DEALLOCATE(mvc_old)
      endif
      SAFE_ALLOCATE(mvc_old, (xct%ng,1,1,xct%nspin))
    endif
    if (.not. ixpsaved .and. xct%ivpar .eq. 1 .and. xct%icpar .eq. 1) then
      if (ii .ne. 1) then
        SAFE_DEALLOCATE(mvpcp_old)
      endif
      SAFE_ALLOCATE(mvpcp_old, (xct%ng,1,1,xct%nspin))
    endif

    call timacc(35,1)
    ! Compute matrix elements: <vk|e^{i*G.r}|ck> -> mvc
    wfn_l = (/1,1/) ! <v,k|
    wfn_r = (/2,1/) ! |c,k>
    call get_charge_matrix(mats, wfn_l, wfn_r, mvc, &
      .not.ixsaved.or.xct%icpar==0.or.xct%ivpar==0, m12_old=mvc_old, &
      should_save=(xct%icpar==1.and.xct%ivpar==1))

    ! Compute matrix elements: <vkp|e^{i*G.r}|ckp> -> mvpcp
    wfn_l = (/1,2/) ! <v,kp|
    wfn_r = (/2,2/) ! |c,kp>
    call get_charge_matrix(mats, wfn_l, wfn_r, mvpcp, &
      .not.ixpsaved.or.xct%icpar==0.or.xct%ivpar==0, m12_old=mvpcp_old, &
      should_save=(xct%icpar==1.and.xct%ivpar==1))  
    call timacc(35,2)
    call timacc(67,2)

    !==============================================================================
    ! SUM G vectors to get EXCHANGE kernel term.
    !==============================================================================
    call logit('         mtxel_kernel: computing bsex')
    call timacc(68,1)
    ! Calc. modified Coulomb potential vbar for q=0, where vbar(G=0)=0
    SAFE_ALLOCATE(vcoul, (xct%ng))
    if (xct%qflag .eq. 2) then
    elseif (xct%qflag .eq. 1) then
      call get_vcoul(.true.)
    endif
    ! Sum over G-vectors to get exchange term.
    if (.not.xct%extended_kernel) then
      call gx_sum_TDA(xct,invband,incband,vcoul,mvc,mvpcp, &
        bsex,ivp_in,icp_in,ikp,iv_in,ic_in,ik)
    else
      call calc_exchange_extended()
    endif
    call timacc(68,2)
    call logit('         mtxel_kernel: done bsex')

    call free_charge_matrices(mats)
    SAFE_DEALLOCATE(fftbox1)
    SAFE_DEALLOCATE(fftbox2)
    SAFE_DEALLOCATE_P(g_idx%g)
    SAFE_DEALLOCATE_P(g_idx%gmg0)
    if (xct%extended_kernel) then
      SAFE_DEALLOCATE_P(g_idx%mg)
      SAFE_DEALLOCATE_P(g_idx%g0mg)
    endif
    SAFE_DEALLOCATE(vcoul)
    if (save_ffts) then
      SAFE_DEALLOCATE(fftboxes)
    endif

    POP_SUB(mtxel_kernel)
    return

  contains

    !> Calculates the partial sum over ig for the direct term.
    !! Works for TDA and extended kernels.
    subroutine calc_direct_w_sum()
      integer :: t1, t1p, t1_max
      integer :: ofs1, ofs1p
      integer :: n1, n1p
      SCALAR, pointer :: m11p(:,:,:,:)
      integer :: wfn_l(2), wfn_r(2)

      PUSH_SUB(mtxel_kernel.calc_direct_w_sum)

      call timacc(64,1)
      t1_max = 1
      if (xct%extended_kernel) t1_max = 2
      ! Loop over "generalized valence WFNs"
      do t1=1,t1_max
        ofs1 = invband*(t1-1)
        n1 = nbands(t1)
        do t1p=1,t1_max
          ofs1p = invband*(t1p-1)
          n1p = nbands(t1p)
          ! This would be Mvvp within TDA
          wfn_l = (/t1,1/)  ! <t1,k|
          wfn_r = (/t1p,2/) ! |t1p,kp>
          call get_charge_matrix(mats, wfn_l, wfn_r, m11p, .true.)
          call w_sum(xct,wptcol,ofs1,ofs1p,n1,n1p,temph,tempw,tempb,m11p,indinv(igp),ng_eps)
        enddo !t1p
      enddo !t1
      call timacc(64,2)

      POP_SUB(mtxel_kernel.calc_direct_w_sum)

    end subroutine calc_direct_w_sum

    !> Add in contribution from unscreened coulomb at high G vectors.
    !! We can write W in a blocked structure as:
    !! [ W1     Wd ]
    !! [ Wd^H   W2 ]
    !! W1 is that part that we know (from eps*mat * vcoul), Wd ~ 0,
    !! and W2 can be approximated by a diagonal matrix:
    !! W2 ~ delta(G,Gp) * vcoul(q+Gp).
    !! This routine adds in the contribution from W2 to the body term.
    subroutine calc_direct_unscreened_contrib(tempb)
      SCALAR, target, intent(in) :: tempb(:,:,:,:)

      integer :: t1, t1p, t1_max
      integer :: ofs1, ofs1p
      integer :: n1, n1p, isv
      SCALAR, pointer :: m11p(:,:,:,:)
      SCALAR, pointer :: tempb2(:,:,:,:)
      integer :: wfn_l(2), wfn_r(2)

      PUSH_SUB(mtxel_kernel.calc_direct_unscreened_contrib)

      call timacc(66,1)
      t1_max = 1
      if (xct%extended_kernel) t1_max = 2
      ! Loop over "generalized valence WFNs"
      do t1=1,t1_max
        ofs1 = invband*(t1-1)
        n1 = nbands(t1)
        do t1p=1,t1_max
          ofs1p = invband*(t1p-1)
          n1p = nbands(t1p)
          ! This would be Mvvp within TDA
          wfn_l = (/t1,1/)  ! <t1,k|
          wfn_r = (/t1p,2/) ! |t1p,kp>
          call get_charge_matrix(mats, wfn_l, wfn_r, m11p, .true.)
          tempb2 => tempb(:, ofs1+1:ofs1+n1, ofs1p+1:ofs1p+n1p, :)
          do isv=1,xct%nspin
            do ig=1,xct%ng
              ! FHJ: integers are represented *exactly* by floating points!
              if (ph(ig)==ZERO) then
                wval = vcoul(ig)
                tempb2(ig, :, :, isv) = tempb2(ig, :, :, isv) + &
                  wval*MYCONJG(m11p(ig, :, :, isv))
              endif
            enddo
          enddo
        enddo !t1p
      enddo !t1
      call timacc(66,2)

      POP_SUB(mtxel_kernel.calc_direct_unscreened_contrib)

    end subroutine calc_direct_unscreened_contrib

    !> Calculates the partial sum over ig for the direct term.
    !! Works for TDA and extended kernels.
    subroutine calc_direct_g_sum()
      integer :: t2, t2p, t2_min
      integer :: ofs2, ofs2p
      integer :: n2, n2p
      SCALAR, pointer :: m22p(:,:,:,:)
      integer :: wfn_l(2), wfn_r(2)

      PUSH_SUB(mtxel_kernel.calc_direct_g_sum)

      call timacc(64,1)
      t2_min = 2
      if (xct%extended_kernel) t2_min = 1
      ! Loop over "generalized conduction WFNs"
      do t2=t2_min,2
        ofs2 = invband*(t2-1)
        n2 = nbands(t2)
        do t2p=t2_min,2
          ofs2p = invband*(t2p-1)
          n2p = nbands(t2p)
          ! This would be Mccp within TDA
          wfn_l = (/t2,1/)  ! <t2,k|
          wfn_r = (/t2p,2/) ! |t2p,kp>
          call get_charge_matrix(mats, wfn_l, wfn_r, m22p, .true.)
          call timacc(73,1)
          if (.not.xct%extended_kernel) then
            if (ivsaved) then
              call g_sum_TDA(xct,invband,incband,temph_old,tempb_old,m22p, &
                bsedhead,bsedbody,leading_dim,ivp_in,icp_in,ikp,iv_in,ic_in,ik, &
                tempw=tempw_old, bsedwing=bsedwing)
            else 
              call g_sum_TDA(xct,invband,incband,temph,tempb,m22p, &
                bsedhead,bsedbody,leading_dim,ivp_in,icp_in,ikp,iv_in,ic_in,ik, &
                tempw=tempw, bsedwing=bsedwing)
            endif
            call free_charge_matrix(mats, xct, mccp)
          else
            if (ivsaved) then
              call g_sum_extended(xct,ofs2,ofs2p,n2,n2p,temph_old,tempb_old,m22p, &
                bsedhead,bsedbody,leading_dim,ivp_in,icp_in,ikp,iv_in,ic_in,ik, &
                tempw=tempw_old, bsedwing=bsedwing)
            else 
              call g_sum_extended(xct,ofs2,ofs2p,n2,n2p,temph,tempb,m22p, &
                bsedhead,bsedbody,leading_dim,ivp_in,icp_in,ikp,iv_in,ic_in,ik, &
                tempw=tempw, bsedwing=bsedwing)
            endif
          endif
          call timacc(73,2)
        enddo !t2p
      enddo !t2
      if (.not.ivsaved) then
        SAFE_DEALLOCATE(temph)
        SAFE_DEALLOCATE(tempw)
        SAFE_DEALLOCATE(tempb)
      endif
      call timacc(64,2)

      POP_SUB(mtxel_kernel.calc_direct_g_sum)

    end subroutine calc_direct_g_sum

    !> Calculates all possible kernel exchange blocks:
    !! \sum_G [M_12(G)]^* v(G+q) M_1p2p(G)
    !! Note: within TDA, we would have: 1=1p=v, 2=2p=c
    subroutine calc_exchange_extended()
      integer :: t1, t1p, t2, t2p
      integer :: ofs1, ofs1p, ofs2, ofs2p
      integer :: n1, n1p, n2, n2p
      !> This is vcoul(:) * m1p2p(:,:,:,:)
      SCALAR, pointer :: m1p2p(:,:,:,:), m12(:,:,:,:)
      SCALAR, allocatable :: v_m1p2p(:,:,:,:)
      integer :: i1p,i2p,is
      integer :: wfn_l(2), wfn_r(2)

      PUSH_SUB(mtxel_kernel.calc_exchange_extended)

      ! Loop over WFNs at kp
      do t2p=1,2
        ofs2p = invband*(t2p-1)
        n2p = nbands(t2p)
        do t1p=1,2
          ofs1p = invband*(t1p-1)
          n1p = nbands(t1p)
          ! This would be Mvpcp within TDA
          wfn_l = (/t1p,2/) ! <t1p,kp|
          wfn_r = (/t2p,2/) ! |t2p,kp>
          call get_charge_matrix(mats, wfn_l, wfn_r, m1p2p, .true.)
          SAFE_ALLOCATE(v_m1p2p, (xct%ng,n1p,n2p,xct%nspin))
          ! Construct v * m1p2p. Note that we are using the modified
          ! Coulomb potential here, i.e., vbar(G=0)=0.
          ! TODO: BLASSIFY
          do is=1,xct%nspin
            do i2p=1,n2p
              do i1p=1,n1p
                v_m1p2p(:,i1p,i2p,is) = vcoul(:) * m1p2p(:,i1p,i2p,is)
              enddo
            enddo
          enddo

          ! Loop over WFNs at k
          do t2=1,2
            ofs2 = invband*(t2-1)
            n2 = nbands(t2)
            do t1=1,2
              ofs1 = invband*(t1-1)
              n1 = nbands(t1)
              ! This would be Mvc within TDA
              wfn_l = (/t1,1/) ! <t1,k|
              wfn_r = (/t2,1/) ! |t2,k>
              call get_charge_matrix(mats, wfn_l, wfn_r, m12, .true.)
              call gx_sum_extended(xct, ofs1, ofs2, ofs1p, ofs2p, n1, n2, n1p, n2p, &
                m12, v_m1p2p, bsex, ivp_in, icp_in, ikp, iv_in, ic_in, ik)
            enddo
          enddo
          SAFE_DEALLOCATE(v_m1p2p)
        enddo
      enddo

      POP_SUB(mtxel_kernel.calc_exchange_extended)

    end subroutine calc_exchange_extended

    !> Calculate either W(0,igp) or W(ig,0).
    !! Note: we interpolate different quantities depending on the
    !! truncation and screening, and we change W to take that into account.
    subroutine calc_wings()
      integer :: ig_start, ig_end, igp_gvec, ig_gvec, ig_eps
      SCALAR :: ph2_conjg, ph_tot

      PUSH_SUB(mtxel_kernel.calc_wings)

      igp_gvec = indinv(igp)
      ph2_conjg = MYCONJG(phinv(igp))
      if (igp_gvec==1) then ! First/right wing: gp=1, g>1
        ig_start = 2
        ig_end = ng_eps
      else ! Second/left wing: gp>1, g=1
        ig_start = 1
        ig_end = 1
      endif

      do ig_gvec = ig_start, ig_end
        ph_tot = ph(ig_gvec) * ph2_conjg
        ig_eps = ind(ig_gvec)
        if (xct%iscreen==0) then
          ! Semiconductor Screening
          ! --No Truncation
          wptcol(ig_gvec) = ph_tot*epscol(ig_eps)*vcoul(igp_gvec)*qq
          if (xct%icutv/=0) then
            ! --With Truncation
            wptcol(ig_gvec) = ph_tot*epscol(ig_eps)*vcoul(igp_gvec)
          endif
          if (qq<Tol_Zero) then
            ! Semiconductor => zero q=0 wings
            wptcol(ig_gvec) = ZERO
          endif
        else
          ! Metal/Graphene Screening
          wptcol(ig_gvec) = ph_tot*epscol(ig_eps)*vcoul(igp_gvec)
          if (xct%iscreen==1 .and. xct%icutv==4 .and. qq<TOL_Zero) then
            ! Graphene Wire => zero q=0 wings
            wptcol(ig_gvec) = ZERO
          endif
        endif
      enddo

      POP_SUB(mtxel_kernel.calc_wings)

    end subroutine calc_wings

    !> Populates the array vcoul with v_G(q), where q=qq, if qq is given,
    !! or q=q0, if qq is omitted. If vbar is set to true, we zero out the
    !! G=0 component to get the modified Coulomb potential vbar.
    subroutine get_vcoul(vbar, qq)
      logical, intent(in) :: vbar
      real(DP), intent(in), optional :: qq(3)

      integer :: ikpt, ik

      PUSH_SUB(mtxel_kernel.get_vcoul)

      call timacc(62,1)
      vcoul(:) = 0.0d0
      ikpt = 0
      if (present(qq)) then
        ! if qq is given, find the index of the k-point identical to qq
        do ik=1,qg%nf
          vq(:) = qg%f(:,ik) - qq(:)
          qlen = DOT_PRODUCT(vq,MATMUL(crys%bdot,vq))
          if (qlen < TOL_Zero) then
            ikpt = ik
            exit
          endif
        enddo
      else
        do ik = 1,qg%nf
          ! if no qq is given, find the index of the q0 point
          vq(:) = qg%f(:,ik)
          qlen = DOT_PRODUCT(vq,MATMUL(crys%bdot,vq))
          if (qlen < TOL_Zero) then
            ikpt = ik
            exit
          endif
        enddo
      endif
      if (ikpt == 0) then
        call die("Couldn't find q-point")
      endif
      vcoul(:) = vcoularray(:,ikpt)
      if (vbar) vcoul(1) = 0d0
      call timacc(62,2)

      POP_SUB(mtxel_kernel.get_vcoul)

    end subroutine get_vcoul

    !> Compute all real-space WFNs to speed up the calculation of the charge
    !! density matrix later on. Call this function for each type of wave function
    !! (valence/conduction) at each k-point (k or kp).
    subroutine precompute_ffts()
      type(wavefunction), pointer :: wfn
      integer :: wtype, wprime
      integer :: is, ib, offset

      PUSH_SUB(mtxel_kernel.precompute_ffts)

      do wtype = 1,2 ! loop valence/conduction wfns
        offset = (wtype-1)*invband ! 0 for valence, invband for conduction
        do wprime = 1,2 ! at k/lp
          wfn => wfns(wtype, wprime)%p
          do is = 1, xct%nspin
            do ib = 1, nbands(wtype) ! offset + ib = local band index
              call put_into_fftbox(wfn%ng, wfn%cg(1:,ib,is), gvec%components, &
                wfn%isort, fftboxes(:,:,:,is,offset+ib,wprime), Nfft)
              call do_FFT(fftboxes(:,:,:,is,offset+ib,wprime), Nfft, 1)
            enddo
          enddo
        enddo
      enddo

      POP_SUB(mtxel_kernel.precompute_ffts)   

    end subroutine precompute_ffts

    !> Calculates the matrix elements M_12(G) = <1|e^(i*G.r)|2>
    !! This the complex conjugate of the charge density matrix <2|e^(-i*G.r)|1>,
    !! and we calculate it for all G vectors and for nb1 wavefunctions of type
    !! <1| and nb2 of type |2>. Result is stored in array m12.
    subroutine calc_charge_matrix(w1, w2, m12, &
      should_calculate, m12_old, should_save)
      !> each WFN is a pair (v/c, k/kp)
      integer, intent(in) :: w1(2), w2(2)
      !> The resulting matrix elements (xct%ng, nb1, nb2, xct%nspin).
      SCALAR, intent(out) :: m12(:,:,:,:)
      !> If true, calculate m12, otherwise use m12_old, if present
      logical, intent(in) :: should_calculate
      !> Save/reuse matrix elements, if appropriate/possible
      SCALAR, intent(inout), optional :: m12_old(:,:,:,:)
      !> If true, set m12_old from m12 (calculated in the function)
      logical, intent(in), optional :: should_save

      type (wavefunction), pointer :: wfn1, wfn2
      integer :: ib1, ib2, is
      !> Order to get G-vectors. Should be (1,2,...) unless there`s umklapp involved.
      integer, pointer :: gvecs_order(:)

      PUSH_SUB(mtxel_kernel.calc_charge_matrix)

      wfn1 => wfns(w1(1),w1(2))%p
      wfn2 => wfns(w2(1),w2(2))%p
      if (w1(2)==w2(2)) then ! <k|..|k> or <kp|..|kp> => e^{iG.r}
        gvecs_order => g_idx%g(:)
      elseif(w1(2)<w2(2)) then ! <k|..|kp> => e^{i(G-G0).r}
        gvecs_order => g_idx%gmg0(:)
      else ! <kp|..|k> => e^{i(G0-G).r}
        gvecs_order => g_idx%g0mg(:)
      endif

      if (should_calculate) then
        do is = 1,xct%nspin
          do ib1 = 1, nbands(w1(1))
            if (save_ffts) then
              fftbox1(:,:,:) = CONJG(fftboxes(:,:,:,is,invband*(w1(1)-1)+ib1,w1(2)))
            else
              call put_into_fftbox(wfn1%ng,wfn1%cg(1:,ib1,is),gvec%components,wfn1%isort,fftbox1,Nfft)
              call do_FFT(fftbox1,Nfft,1)
              call conjg_fftbox(fftbox1,Nfft)
            endif
            do ib2 = 1, nbands(w2(1))
              if (save_ffts) then
                ! FHJ: If we use multiply_fftboxes directly we endup moving
                ! more data than necessary here.
                fftbox2 = fftbox1*fftboxes(:,:,:,is,invband*(w2(1)-1)+ib2,w2(2))
              else
                call put_into_fftbox(wfn2%ng,wfn2%cg(1:,ib2,is),gvec%components,wfn2%isort,fftbox2,Nfft)
                call do_FFT(fftbox2,Nfft,1)
                call multiply_fftboxes(fftbox1,fftbox2,Nfft)
              endif
              call do_FFT(fftbox2,Nfft,1)
              call get_from_fftbox(xct%ng,m12(1:,ib1,ib2,is),gvec%components,gvecs_order,fftbox2,Nfft,scale)
            enddo !ib2
          enddo !ib1
        enddo !is
        if (present(m12_old).and.present(should_save)) then
          if (should_save) m12_old(:,:,:,:) = m12(:,:,:,:)
        endif
      else
        if (present(m12_old)) m12(:,:,:,:) = m12_old(:,:,:,:)
      endif

      POP_SUB(mtxel_kernel.calc_charge_matrix)

    end subroutine calc_charge_matrix

    !> Return the matrix element M_12(G) = <1|e^(i*G.r)|2>
    !! The matrix element will be either calculated directly, or obtained
    !! from complex conjugation of a known matrix element.
    !! Parameter m12 will point to the resulting matrix element, so do
    !! not free m12 directly, use free_charge_matri{x|ces} instead.
    subroutine get_charge_matrix(mats, w1, w2, m12, should_calculate, m12_old, should_save)
      type(matrix_4), intent(inout), target :: mats(2,2,2,2)
      integer, intent(in) :: w1(2), w2(2)
      SCALAR, pointer :: m12(:,:,:,:) !< intent not permitted for pointer
      !> If true, calculate m12, otherwise use m12_old, if present
      logical, intent(in) :: should_calculate
      !> Save/reuse matrix elements, if appropriate/possible
      SCALAR, intent(inout), optional :: m12_old(:,:,:,:)
      !> If true, set m12_old from m12 (calculated in the function)
      logical, intent(in), optional :: should_save

      integer :: ig, nb1, nb2, i1, i2
      logical :: is_assoc

      PUSH_SUB(mtxel_kernel.get_charge_matrix)

      if (associated(mats(w1(1),w1(2),w2(1),w2(2))%p)) then
        m12 => mats(w1(1),w1(2),w2(1),w2(2))%p
      else
        nb1 = nbands(w1(1))
        nb2 = nbands(w2(1))

        ! store status in variable, in case some indices are equal and the allocation changes the status
        is_assoc = associated(mats(w2(1),w2(2),w1(1),w1(2))%p)
        SAFE_ALLOCATE(mats(w1(1),w1(2),w2(1),w2(2))%p, (xct%ng,nb1,nb2,xct%nspin))
        m12 => mats(w1(1),w1(2),w2(1),w2(2))%p

        if (is_assoc) then
          m12 = ZERO
          do i2 = 1, nb2
            do i1 = 1, nb1
              do ig=1,xct%ng
                m12(ig,i1,i2,:) = MYCONJG(mats(w2(1),w2(2),w1(1),w1(2))%p(g_idx%mg(ig),i2,i1,:))
              enddo
            enddo
          enddo
        else
          call calc_charge_matrix(w1, w2, m12, should_calculate, m12_old, should_save)
        endif
      endif

      POP_SUB(mtxel_kernel.get_charge_matrix)

    end subroutine get_charge_matrix

  end subroutine mtxel_kernel

  !> If there`s umklapp involved, e.g. <nk|e^{i(G-G0).r}|mkp>, we
  !! perform the FFTs as usual, but map each G vector to G-G0, etc.
  !! This subroutine initializes all these mappings in g_idx.
  subroutine init_g_idx(xct, gvec, g0, sinv, g_idx)
    type (xctinfo), intent(in) :: xct
    type(gspace), intent(in) :: gvec
    integer, intent(in) :: g0(3) !< umklapp vector
    integer, intent(in) :: sinv !< -1 if ik > ikp, 1 o.w.
    type(gvec_indices), intent(out) :: g_idx

    integer :: ig, gg(3)

    PUSH_SUB(init_g_idx)

    call timacc(32,1)
    ! Index of G => identity
    SAFE_ALLOCATE(g_idx%g, (gvec%ng))
    do ig=1,gvec%ng
      g_idx%g(ig)=ig
    enddo
    ! Index of G-G0
    SAFE_ALLOCATE(g_idx%gmg0, (gvec%ng))
    do ig=1,xct%ng
      gg(:) = sinv * (gvec%components(:,ig) - g0(:))
      call findvector(g_idx%gmg0(ig),gg,gvec)
      if (g_idx%gmg0(ig) == 0) call die('cannot find G-G0')
    enddo
    if (xct%extended_kernel) then
      ! Index of -G
      SAFE_ALLOCATE(g_idx%mg, (gvec%ng))
      do ig=1,xct%ng
        gg(:) = - gvec%components(:,ig)
        call findvector(g_idx%mg(ig),gg,gvec)
        if (g_idx%mg(ig) == 0) call die('cannot find -G')
        if (g_idx%mg(ig) > xct%ng) g_idx%mg(ig) = xct%ng
      enddo
      ! Index of G0-G
      ! TODO: remove meh, we never have kp,k
      SAFE_ALLOCATE(g_idx%g0mg, (gvec%ng))
      do ig=1,xct%ng
        gg(:) = sinv * (g0(:) - gvec%components(:,ig))
        call findvector(g_idx%g0mg(ig),gg,gvec)
        if (g_idx%g0mg(ig) == 0) call die('cannot find G0-G')
      enddo
    endif
    call timacc(32,2)

    POP_SUB(init_g_idx)

  end subroutine init_g_idx

  !> Frees and nullifies charge density pointed by m12.
  subroutine free_charge_matrix(mats, xct, m12)
    type(matrix_4), intent(inout) :: mats(2,2,2,2)
    type(xctinfo), intent(in) :: xct
    SCALAR, pointer, intent(inout) :: m12(:,:,:,:)

    integer :: t1, p1, t2, p2

    PUSH_SUB(free_charge_matrix)

    if (xct%extended_kernel) then
      POP_SUB(free_charge_matrices)
      return
    endif

    outer_loop: do t1=1,2
      do p1=1,2
        do t2=1,2
          do p2=1,2
            if (associated(m12, mats(t1,p1,t2,p2)%p)) then
              SAFE_DEALLOCATE_P(mats(t1,p1,t2,p2)%p)
              nullify(mats(t1,p1,t2,p2)%p)
              nullify(m12)
              exit outer_loop
            endif
            SAFE_DEALLOCATE_P(mats(t1,p1,t2,p2)%p)
            nullify(mats(t1,p1,t2,p2)%p)
          enddo
        enddo
      enddo
    enddo outer_loop
    
    POP_SUB(free_charge_matrix)

  end subroutine free_charge_matrix

  !> Deallocates all charge density matrices.
  subroutine free_charge_matrices(mats)
    type(matrix_4), intent(inout) :: mats(2,2,2,2)
    
    integer :: t1, p1, t2, p2
    
    PUSH_SUB(free_charge_matrices)
    
    do t1=1,2
      do p1=1,2
        do t2=1,2
          do p2=1,2
            SAFE_DEALLOCATE_P(mats(t1,p1,t2,p2)%p)
            nullify(mats(t1,p1,t2,p2)%p)
          enddo
        enddo
      enddo
    enddo
    
    POP_SUB(free_charge_matrices)
    
  end subroutine free_charge_matrices

  !> Warn the user that the g-space is too small and that mapping is no good.
  subroutine warn_about_mapping()
    logical, save :: warned=.false.
    
    PUSH_SUB(warn_about_mapping)
    
    if (peinf%inode==0 .and. .not.warned) then
      write(0,*)
      write(0,'(a)') 'WARNING: at least one vector from the epsilon G-space could not be mapped to '
      write(0,'(a)') ' the WFN G-space. This means that either:'
      write(0,'(a)') ' (1) The WFN cutoff is too small (most likely and dangerous); or'
      write(0,'(a)') ' (2) The cutoff of the dielectric matrix is simply huge.'
      write(0,'(a)') ' Consider using the gsphere.py utility to figure out the cause of this warning.'
      write(0,*)
      warned=.true.
    endif
    
    POP_SUB(warn_about_mapping)
    
  end subroutine warn_about_mapping
  
end module mtxel_kernel_m

!=========================================================================
!
! Utilities:
!
! (1) epsmat_merge()  Originally by ?       Last Modified 5/5/2008 (JRD)
!
!     This utility merges a list of epsmat files into one file.
!     It uses the input file epsmat_merge.inp.  See example in current directory.
!
!=========================================================================

#include "f_defs.h"

program epsmat_merge

  use global_m
  implicit none

  character :: ajname*6,adate*11,atime*14
  real(DP) :: dtol,div,ecuts1,ecuts2
  real(DP), allocatable :: dFreqGrid(:)
  complex(DPC), allocatable :: dFreqBrd(:)
  integer i,ig,im,iq,istart,j,k,jm,jj, &
    nfiles,ng1,ng2,ngq1,ngq2,nmtx1,nmtx2,nq,nqtot, &
    freq_dep,nFreq,qgrid(3),ijk
  
  character*20, allocatable :: filename(:)
  real(DP), allocatable :: ekin(:),q1(:,:),q2(:,:)
  complex(DPC), allocatable :: epsDyn(:)
  SCALAR, allocatable :: eps(:)
  integer, allocatable :: isort1(:),isort2(:),kx(:),ky(:),kz(:)

  dtol = 1.0d-5
  
  write(6,*) 'This routine should only be used on non-HDF5-based epsmat files.'
  write(6,*) 'If you built with HDF5 support (which is ideal), or otherwise'
  write(6,*) 'have HDF5-based epsmat files, you should use the routine'
  write(6,*) 'epsmat_hdf5_merge.py instead.'

  call open_file(55,file='epsmat_merge.inp',form='formatted',status='old')
  read(55,*) ecuts1,nqtot
  SAFE_ALLOCATE(q1, (3,nqtot))
  SAFE_ALLOCATE(q2, (3,nqtot))
  do iq=1,nqtot
    read(55,*) q1(1,iq),q1(2,iq),q1(3,iq),div
    do j=1,3
      q1(j,iq)=q1(j,iq)/div
    enddo
  enddo

!---------------------------
! Find maximal values, and check consistency between
! the input file and the epsmat files...

  istart=1
  ng1=0
  ngq1=0
  nmtx1=0
  read(55,*) nfiles
  SAFE_ALLOCATE(filename, (nfiles))
  do i=1,nfiles
    read(55,'(a20)') filename(i)
    write(6,*) 'Checking file ',filename(i)
    call open_file(unit=11,file=filename(i),form='unformatted',status='old')
    
    read(11) ajname,adate
    read(11) freq_dep,nFreq
    read(11) (qgrid(j),j=1,3)
    if (freq_dep .ne. 0 .and. i .eq. 1) then
      SAFE_ALLOCATE(dFreqGrid,(nFreq))
      SAFE_ALLOCATE(dFreqBrd,(nFreq))
      read(11) (dFreqGrid(ijk),ijk=1,nFreq),(dFreqBrd(ijk),ijk=1,nFreq)
    else
      read(11)
    endif
    read(11)
    read(11)
    read(11) ecuts2
    if(ecuts2.ne.ecuts1) then
      write(0,*) 'The cut-off in input file (',ecuts1,') does not match the one in file ',filename(i),' (',ecuts2,').'
      call die('epsmat_merge cutoff mismatch')
    endif

    read(11) nq,((q2(j,iq),j=1,3),iq=istart,istart+nq-1)
    do iq=istart,istart+nq-1
!$$ tolerance
      if((abs(q2(1,iq)-q1(1,iq)).gt.dtol).or. &
        (abs(q2(2,iq)-q1(2,iq)).gt.dtol).or. &
        (abs(q2(3,iq)-q1(3,iq)).gt.dtol)) then
        write(0,*) 'The q-vector ',iq,' in input file (', (q1(j,iq),j=1,3), &
          ') does not match does the one in file ', filename(i),' (',(q2(j,iq),j=1,3),').'
        call die('epsmat_merge q-vector mismatch')
      endif
    enddo

    read(11) ng2
    if(ng1.eq.0) ng1=ng2
    if(ng2.ne.ng1) then
      call die('The number of G-vectors differs in epsmat files')
    endif

    do iq=istart,istart+nq-1
      read(11) ngq2,nmtx2
      if(ngq1.lt.ngq2) ngq1=ngq2
      if(nmtx1.lt.nmtx2) nmtx1=nmtx2
      read(11)
      read(11) (q2(j,iq),j=1,3)
      if(freq_dep.eq.0) then
        do j = 1, nmtx2
          read(11)
        enddo
      else 
        do j = 1, nmtx2
          do k = 1, nmtx2
            read(11)
          enddo
#ifdef CPLX
          do k = 1, nmtx2
            read(11)
          enddo
#endif
        enddo
      endif
!$$ tolerance
      if((abs(q2(1,iq)-q1(1,iq)).gt.dtol).or. &
        (abs(q2(2,iq)-q1(2,iq)).gt.dtol).or. &
        (abs(q2(3,iq)-q1(3,iq)).gt.dtol)) then
        write(0,*) 'The q-vector ',iq,' in input file (', (q1(j,iq),j=1,3), &
          ') does not match does the one in file ', filename(i),' (',(q2(j,iq),j=1,3),').'
        call die('epsmat_merge q-vector mismatch')
      endif
    enddo

    istart=istart+nq
    call close_file(11)
  enddo
  if(istart-1.ne.nqtot) then
    call die('Could not find all q-vectors in epsmat files')
  endif
  
  SAFE_ALLOCATE(kx, (ng1))
  SAFE_ALLOCATE(ky, (ng1))
  SAFE_ALLOCATE(kz, (ng1))
  call open_file(unit=11,file=filename(1),form='unformatted',status='old')
  read(11)
  read(11)
  read(11)
  read(11)
  read(11)
  read(11)
  read(11)
  read(11)
  read(11) ng1,(kx(i),ky(i),kz(i),i=1,ng1)
  call close_file(11)
  SAFE_ALLOCATE(isort1, (ng1))
  SAFE_ALLOCATE(isort2, (ng1))
  SAFE_ALLOCATE(ekin, (ngq1))
  
  if(freq_dep.eq.0) then
    SAFE_ALLOCATE(eps, (nmtx1))
  else 
    SAFE_ALLOCATE(epsDyn, (nFreq))
  endif
  
  ajname='chiGG0'
  call date_time(adate,atime)
  call open_file(unit=12,file='epsmat',form='unformatted',status='replace')
  write(12) ajname,adate
  write(12) freq_dep,nFreq
  write(12) (qgrid(i),i=1,3)
  if (freq_dep .eq. 2) then
    write(12) (dFreqGrid(i),i=1,nFreq),(dFreqBrd(i),i=1,nFreq)
  else
    write(12)
  endif
  write(12)
  write(12)
  write(12) ecuts1
  write(12) nqtot,((q1(j,iq),j=1,3),iq=1,nqtot)
  write(12) ng1,(kx(ig),ky(ig),kz(ig),ig=1,ng1)
  
  write(6,*)
  istart=1
  do i=1,nfiles
    write(6,*) 'Dealing with file ',filename(i)
    call open_file(unit=11,file=filename(i),form='unformatted',status='old')

    read(11)
    read(11)
    read(11)
    read(11)
    read(11)
    read(11)
    read(11)
    read(11) nq
    read(11)
    do iq=istart,istart+nq-1
      write(6,'(a,f9.6,3x,f9.6,3x,f9.6)') ' -> q=',(q1(j,iq),j=1,3)
      read(11) ngq2,nmtx2,(isort1(ig),isort2(ig),ig=1,ngq2)
      write(12) ngq2,nmtx2,(isort1(ig),isort2(ig),ig=1,ngq2)
      read(11) (ekin(ig),ig=1,ngq2)
      write(12) (ekin(ig),ig=1,ngq2)
      read(11)
      write(12) (q1(j,iq),j=1,3)
      if(freq_dep.eq.0) then
        do jm = 1, nmtx2
          read(11) (eps(im),im=1,nmtx2)
          write(12) (eps(im),im=1,nmtx2)
        enddo
      else 
        do jm = 1, nmtx2
          do im = 1, nmtx2
            read(11) (epsDyn(jj),jj=1,nFreq)
            write(12) (epsDyn(jj),jj=1,nFreq)
          enddo
#ifdef CPLX
          do im = 1, nmtx2
            read(11) (epsDyn(jj),jj=1,nFreq)
            write(12) (epsDyn(jj),jj=1,nFreq)
          enddo
#endif
        enddo
      endif
    enddo
    
    istart=istart+nq
    call close_file(11)
  enddo
  
end program epsmat_merge

!
! SIB: This routine looks the same as input().
! Except it reads from WFNq and
! writes to iunit_v='INT_VWFQ' and only valence bands.
! And k-point information is read into kpq.
!
!     SUBROUTINE READS CRYSTAL DATA AND WAVEFUNCTIONS FROM TAPE26
!     AND PARAMETERS FOR POLARIZABILITY CALCULATION FROM TAPE5
!     TAPE10 (OUTPUT TAPE) IS INITIALIZED

#include "f_defs.h"

module input_q_m

  use global_m
  use eqpcor_m
  use input_utils_m
  use misc_m
  use scissors_m
  use wfn_rho_vxc_io_m
  use io_utils_m
#ifdef HDF5
  use hdf5
#endif
  use wfn_io_hdf5_m

  implicit none

  private
  public :: input_q

contains

subroutine input_q(gvec,kpq,cwfn,vwfn,pol,intwfnvq)
  type (gspace), intent(in) :: gvec
  type (kpoints), intent(out) :: kpq
  type (conduction_wfns), intent(in) :: cwfn
  type (valence_wfns), intent(in) :: vwfn
  type (polarizability), intent(inout) :: pol
  type (int_wavefunction), intent(out) :: intwfnvq

  type (crystal) :: crys
  type (symmetry) :: syms

  real(DP) :: vcell
  integer :: dummygvec(1, 1)
  character :: fncor*32

  character(len=3) :: sheader
  integer :: iflavor
  type(gspace) :: gvecq

  PUSH_SUB(input_q)

  sheader = 'WFN'
  iflavor = 0
  if(pol%os_hdf5) then
  else
    if(peinf%inode == 0) then
      write(6,'(a)') ' Reading header of WFNq'
      call open_file(26,file='WFNq',form='unformatted',status='old')
    endif
    call read_binary_header_type(26, sheader, iflavor, kpq, gvecq, syms, crys, &
      dont_warn_kgrid=pol%subsample, warn=.false.)
    call read_binary_gvectors(26, gvecq%ng, gvecq%ng, dummygvec, dont_read = .true.)
  endif
  call check_trunc_kpts(pol%icutv, kpq)

  call scissors_shift(kpq, pol%scis)

  if(peinf%inode == 0) then
    call get_volume(vcell,crys%bdot)
    if (abs(crys%celvol-vcell).gt.TOL_Small) then
      call die('volume mismatch')
    endif

!-----------------------------------------------------------------
! If a quasi-particle correction file exists, read the corrected
! quasiparticle energies from file (in eV)

    if(pol%eqp_corrections) then
      fncor='eqp_q.dat'
      call eqpcor(fncor,0,1,kpq,1,vwfn%nband+pol%ncrit,0,0,kpq%el,kpq%el,kpq%el,1,0)
    endif
    
    call find_efermi(pol%rfermi, pol%efermi, pol%efermi_input, kpq, kpq%mnband, 1, &
      "shifted grid", should_search = .false., should_update = .false., write7 = .true.)
    ! note: here ifmax may be updated. We will never use it, so it does not matter that it only happens on proc 0. -DAS

    if(any (kpq%ifmax(:,:) < vwfn%nband .or. kpq%ifmax(:,:) > vwfn%nband + pol%ncrit)) then
      write(0,'(a,i6,a,i6,a)') 'epsilon.inp says there are ', vwfn%nband, ' fully occupied bands and ', &
        pol%ncrit, ' partially occupied.'
      write(0,'(a,2i6)') 'This is inconsistent with highest bands in WFNq file; min, max = ', minval(kpq%ifmax), maxval(kpq%ifmax)
      call die("band_occupation, number_partial_occup, and WFNq inconsistent.")
    endif
    
    if(maxval(kpq%ifmax) - minval(kpq%ifmax) > pol%ncrit) then
      write(0,'(a,i6,a)') 'epsilon.inp says there are ', pol%ncrit, ' partially occupied bands.'
      write(0,'(a,i6)') 'This is less than the number partially occupied in WFNq file: ', maxval(kpq%ifmax) - minval(kpq%ifmax)
      call die("number_partial_occup and WFNq inconsistent.")
    endif

  endif ! of proc 0 reading

!      if (peinf%inode .eq. 0) write(6,*) ""
!      if (peinf%inode .eq. 0) write(6,*) "Q Read Header", kpq%nspin,kpq%nrk,kpq%kgrid,kpq%shift

  if(pol%os_hdf5) then
  else
    call read_wavefunctions(kpq, gvec, pol, cwfn, vwfn, intwfnvq)
    if(peinf%inode.eq.0) then
      call close_file(26)
    endif
  endif
  
! Writes some info about xtal

  if (peinf%inode.eq.0)  then
    
    write(6,100)
    write(7,100)
100 format(/,1x,'Crystal k+q WFs read from WFNq')
    
  endif

  if(pol%iwriteint == 0) then
#ifdef MPI
    call MPI_Barrier(MPI_COMM_WORLD, mpierr)
#endif
  endif

  POP_SUB(input_q)
  
  return
end subroutine input_q


subroutine read_wavefunctions(kpq, gvec, pol, cwfn, vwfn, intwfnvq)
  type (kpoints), intent(in) :: kpq
  type (gspace), intent(in) :: gvec
  type (polarizability), intent(in) :: pol
  type (conduction_wfns), intent(in) :: cwfn
  type (valence_wfns), intent(in) :: vwfn
  type (int_wavefunction), intent(out) :: intwfnvq

  integer, allocatable :: isort(:)
  SCALAR, allocatable :: zc(:,:)

  character :: filenamevq*20
  integer :: i,j,k,ik,iiii,is
  integer :: iunit_v
  real(DP) :: qk(3)
  logical :: dont_read
  
  type(gspace) :: gvec_kpt
  type(progress_info) :: prog_info !< a user-friendly progress report

  PUSH_SUB(read_wavefunctions)

! JRD:  proc 0 opens unit (iunit_v) with name 'INT_VWFQ'
      
  if (pol%iwriteint .eq. 0) then
    if(peinf%inode.eq.0) then
      write(filenamevq,'(a)') 'INT_VWFQ'
      iunit_v=300028
      call open_file(iunit_v,file=filenamevq,form='unformatted',status='replace')
    endif
  else
    SAFE_ALLOCATE(intwfnvq%ng, (kpq%nrk))
    SAFE_ALLOCATE(intwfnvq%isort, (kpq%ngkmax,kpq%nrk))
    SAFE_ALLOCATE(intwfnvq%cg, (kpq%ngkmax,kpq%nrk*peinf%nvownactual,kpq%nspin*kpq%nspinor))
    SAFE_ALLOCATE(intwfnvq%qk, (3,kpq%nrk))
  endif
  
  call progress_init(prog_info, 'reading wavefunctions (WFNq)', 'state', kpq%nrk*(vwfn%nband+pol%ncrit))
  do ik=1,kpq%nrk
    qk(1:3) = kpq%rk(1:3, ik)
    SAFE_ALLOCATE(gvec_kpt%components, (3, kpq%ngk(ik)))

    call read_binary_gvectors(26, kpq%ngk(ik), kpq%ngk(ik), gvec_kpt%components)

    SAFE_ALLOCATE(isort, (kpq%ngk(ik)))
    do i = 1, kpq%ngk(ik)
      call findvector(isort(i), gvec_kpt%components(:, i), gvec)
      if (isort(i) == 0) then
        if(peinf%inode == 0) write(0,*) 'ik = ', ik, 'ig = ', i, 'gvec = ', gvec_kpt%components(:, i)
        call die('input_q: could not find gvec')
      endif
    enddo
    SAFE_DEALLOCATE_P(gvec_kpt%components)

! JRD: 0 proc write kpq%ngk(ik), isort(), and other stuff to iunit_v

    if (pol%iwriteint .eq. 0) then
      if (peinf%inode.eq.0)  then
        write(iunit_v) kpq%ngk(ik),(isort(j),j=1,kpq%ngk(ik)), &
          ((kpq%el(j,ik,k),j=1,(vwfn%nband+pol%ncrit)), & 
          k=1,kpq%nspin),(qk(i),i=1,3)
      endif
    else
      intwfnvq%ng(ik)=kpq%ngk(ik)
      intwfnvq%isort(1:kpq%ngk(ik),ik)=isort(1:kpq%ngk(ik))
      intwfnvq%qk(:,ik)=qk(:)
    endif
!
! SIB:  loop on max number of bands, and proc 0 reads the wave function
! from unit 26, checks normalization, and if the band is less than
! cwfn%nband (# of bands in total) **AND** is a valence band (so
! its index is <= vwfn%nband), then it is written to iunit_v.
!
    SAFE_ALLOCATE(zc, (kpq%ngk(ik), kpq%nspinor*kpq%nspin))

    do i=1,kpq%mnband

      dont_read = i > cwfn%nband
      if(.not. dont_read) dont_read = cwfn%band_index(i) > vwfn%nband+pol%ncrit
      call read_binary_data(26, kpq%ngk(ik), kpq%ngk(ik), kpq%nspin*kpq%nspinor, zc, dont_read = dont_read)

      ! FHJ: the following lines were introduced in r6294 and are supposed to
      ! be a shortcut if we are past the last band of the last k-point. However,
      ! in light of a previous bug (#223), this feature is commented out for now.
      !! FHJ: shortcut if this is past the last band of the last k-point
      !if (dont_read .and. ik==kpq%nrk) exit
      if (.not.dont_read) then

        call progress_step(prog_info, (ik-1)*(vwfn%nband+pol%ncrit) + i)
        if (peinf%inode == 0) then
          do is = 1, kpq%nspin
            call checknorm('WFNq',i,ik,kpq%ngk(ik),is,kpq%nspinor,zc(:,:))
          enddo
        endif

        if (pol%iwriteint .eq. 0) then
          if (peinf%inode .eq. 0) then
            write(iunit_v) ((zc(j,k),j=1,kpq%ngk(ik)),k=1,kpq%nspinor*kpq%nspin)
          endif
        else
          if (peinf%doiownv(cwfn%band_index(i))) then
            iiii=peinf%indexv(cwfn%band_index(i))+(ik-1)*peinf%nvownactual
            intwfnvq%cg(1:kpq%ngk(ik),iiii,1:kpq%nspin*kpq%nspinor)=zc(1:kpq%ngk(ik),1:kpq%nspinor*kpq%nspin)
          endif
        endif
      endif
    enddo
    SAFE_DEALLOCATE(isort)
    SAFE_DEALLOCATE(zc)
  enddo                     ! end loop over k+q points
  call progress_free(prog_info)

  if(peinf%inode.eq.0) then
    if (pol%iwriteint .eq. 0) call close_file(iunit_v)
  endif

  POP_SUB(read_wavefunctions)
  return

end subroutine read_wavefunctions

end module input_q_m

! This file is based on the work of Michel Olagnon.
! The original code for the MRGRNK subroutine is available at:
! http://fortran-2000.com/rank/mrgrnk.f90

! MRGRNK - Copyright (c) Michel Olagnon
! Copying and distribution of this file, with or without modification,
! are permitted in any medium without royalty provided the copyright
! notice and this notice are preserved.  This file is offered as-is,
! without any warranty.


! FHJ: WARNING - make sure you don`t change the following lines too much,
! otherwise they will be longer than 120 characters after the preprocessors kicks in.
! Note that, if there the extra "gvec" argument, we use a tolerance to figure
! out if the two items AA(ii) and AA(jj) are degenerate.
#ifdef HAS_GVEC
 #define is_greater(ii,jj) \
  (AA(ii)-AA(jj)>TOL.or.(AA(ii)-AA(jj)>-TOL.and.GK(ii)>GK(jj)))
#else
 #define is_greater(ii,jj) \
  (AA(ii)>AA(jj))
#endif

! FHJ: Note - we need to nest the "JOIN" macro otherwise the symbol LABEL
! doesn`t get expanded by the C preprocessor.
#define JOIN2(x,y) x ## _ ## y
#define JOIN(x,y) JOIN2(x,y)
#define LABEL_INSERTSORT JOIN(LABEL,insertsort)

!> Sorts (actually, ranks) a small array AA using the insert sort algorithm.
subroutine LABEL_INSERTSORT(NVAL, AA, ord&
#ifdef HAS_GVEC
, GK&
#endif
)
  integer, intent(in) :: NVAL
  DTYPE, intent(in) :: AA(NVAL)
  integer, intent(inout) :: ord(NVAL)
#ifdef HAS_GVEC
  integer, intent(in) :: GK(NVAL)
  DTYPE, parameter :: TOL=TOL_ZERO
#endif

  integer :: ii, jj, tord

  PUSH_SUB(LABEL_INSERTSORT)

  do ii = 2, NVAL
    tord = ord(ii)
    jj = ii - 1
    do while (jj>0)
      if (.not.is_greater(ord(jj),tord)) exit
      ord(jj+1) = ord(jj)
      jj = jj - 1
    enddo
    ord(jj+1) = tord
  enddo

  POP_SUB(LABEL_INSERTSORT)

end subroutine LABEL_INSERTSORT

!> Sorts (actually, ranks) a real/integer array AA.
!! The rank is written to the output array ord.
!! This subroutine is based on the routine MRGRNK by Michel Olagnon, which
!! uses the merge sort algorithm.
subroutine LABEL(NVAL, AA, ord&
#ifdef HAS_GVEC
, gvec&
#endif
)
  integer, intent(in) :: NVAL
  DTYPE, intent(in) :: AA(NVAL)
  integer, intent(out) :: ord(NVAL)
#ifdef HAS_GVEC
  integer, intent(in) :: gvec(3,NVAL) !< (3, N) G-vectors, used to break tie for equal data

  integer :: GK(NVAL), fftgrid(3)
  DTYPE, parameter :: TOL=TOL_ZERO
#endif
!
  integer :: JT(NVAL)
  integer :: LMTNA, LMTNC, IRNG1, IRNG2
  integer :: IIND, ID, IWRK, IWRKF, JINDA, IA, IB

  PUSH_SUB(LABEL)

  #ifdef HAS_GVEC
  fftgrid(1:3) = maxval(gvec(1:3,1:NVAL), 2) - minval(gvec(1:3,1:NVAL), 2) + 1
  do IIND=1,NVAL
    GK(IIND) = gvec(3,IIND) + fftgrid(3)*(gvec(2,IIND) + fftgrid(2)*gvec(1,IIND))
  enddo
  #endif
!
!  Fill-in the index array, creating ordered couples
!
  Do IIND = 2, NVAL, 2
    If (&
is_greater(IIND,IIND-1)&
    ) Then
      ord (IIND-1) = IIND - 1
      ord (IIND) = IIND
    Else
      ord (IIND-1) = IIND
      ord (IIND) = IIND - 1
    End If
  End Do
  If (Modulo(NVAL, 2) /= 0) Then
    ord (NVAL) = NVAL
  End If

  ! FHJ - shortcut if the array is small enough
  if (NVAL<16) then
    call LABEL_INSERTSORT(NVAL, AA, ord&
#ifdef HAS_GVEC
, GK&
#endif
)
    return
  endif

!
!  We will now have ordered subsets A - B - A - B - ...
!  and merge A and B couples into    C  -  C  - ...
!
  LMTNA = 2
  LMTNC = 4
!
!  First iteration. The length of the ordered subsets goes from 2 to 4
!
  Do
    If (NVAL <= 2) Exit
!
!  Loop on merges of A and B into C
!
    Do ID = 0, NVAL - 1, 4
      If ((ID+4) > NVAL) Then
        If ((ID+2) >= NVAL) Exit
!
!  1 2 3
!
        If (&
is_greater(ord(ID+3),ord(ID+2))&
        ) Exit
!
!  1 3 2
!
        If (&
is_greater(ord(ID+3),ord(ID+1))&
        ) Then
          IRNG2 = ord (ID+2)
          ord (ID+2) = ord (ID+3)
          ord (ID+3) = IRNG2
!
!  3 1 2
!
        Else
          IRNG1 = ord (ID+1)
          ord (ID+1) = ord (ID+3)
          ord (ID+3) = ord (ID+2)
          ord (ID+2) = IRNG1
        End If
        Exit
      End If
!
!  1 2 3 4
!
      If (&
is_greater(ord(ID+3),ord(ID+2))&
      ) Cycle
!
!  1 3 x x
!
      If (&
is_greater(ord(ID+3),ord(ID+1))&
      ) Then
        IRNG2 = ord (ID+2)
        ord (ID+2) = ord (ID+3)
        If (&
is_greater(ord(ID+4),IRNG2)&
        ) Then
!  1 3 2 4
          ord (ID+3) = IRNG2
        Else
!  1 3 4 2
          ord (ID+3) = ord (ID+4)
          ord (ID+4) = IRNG2
        End If
!
!  3 x x x
!
      Else
        IRNG1 = ord (ID+1)
        IRNG2 = ord (ID+2)
        ord (ID+1) = ord (ID+3)
        If (&
is_greater(ord(ID+4),IRNG1)&
        ) Then
          ord (ID+2) = IRNG1
          If (&
is_greater(ord(ID+4),IRNG2)&
          ) Then
!  3 1 2 4
            ord (ID+3) = IRNG2
          Else
!  3 1 4 2
            ord (ID+3) = ord (ID+4)
            ord (ID+4) = IRNG2
          End If
        Else
!  3 4 1 2
          ord (ID+2) = ord (ID+4)
          ord (ID+3) = IRNG1
          ord (ID+4) = IRNG2
        End If
      End If
    End Do
!
!  The Cs become As and Bs
!
    LMTNA = 4
    Exit
  End Do
!
!  Iteration loop. Each time, the length of the ordered subsets
!  is doubled.
!
  Do
    If (LMTNA >= NVAL) Exit
    IWRKF = 0
    LMTNC = 2 * LMTNC
!
!  Loop on merges of A and B into C
!
    Do
      IWRK = IWRKF
      ID = IWRKF + 1
      JINDA = IWRKF + LMTNA
      IWRKF = IWRKF + LMTNC
      If (IWRKF >= NVAL) Then
        If (JINDA >= NVAL) Exit
        IWRKF = NVAL
      End If
      IA = 1
      IB = JINDA + 1
!
!  Shortcut for the case when the max of A is smaller
!  than the min of B. This line may be activated when the
!  initial set is already close to sorted.
!
      IF (&
is_greater(ord(IB),ord(JINDA))&
      ) CYCLE
!
!  One steps in the C subset, that we build in the final rank array
!
!  Make a copy of the rank array for the merge iteration
!
      JT (1:LMTNA) = ord (ID:JINDA)
!
      Do
        IWRK = IWRK + 1
!
!  We still have unprocessed values in both A and B
!
        If (&
is_greater(JT(IA),ord(IB))&
        ) Then
          ord (IWRK) = ord (IB)
          IB = IB + 1
          If (IB > IWRKF) Then
!  Only A still with unprocessed values
            ord (IWRK+1:IWRKF) = JT (IA:LMTNA)
            Exit
          End If
        Else
          ord (IWRK) = JT (IA)
          IA = IA + 1
          If (IA > LMTNA) Exit! Only B still with unprocessed values
        End If
!
      End Do
    End Do
!
!  The Cs become As and Bs
!
    LMTNA = 2 * LMTNA
  End Do
!
  POP_SUB(LABEL)
!
End Subroutine LABEL

#undef is_greater

!================================================================================
!
! Modules:
!
! (1) peinfo_m      Originally by DAS 8/20/2010
!
!     Defines type and global instance of object for "processor equivalent" info.
!     Use mpi module to define interfaces for MPI calls.
!     [For F77, MPI header 'mpif.h' was included.]
!
!================================================================================

#include "f_defs.h"

module peinfo_m

! The MPICH1 version of mpi.mod has a limited set of interfaces which will cause
! errors of inability to match generic procedure on compilation for certain
! multidimensional-array calls to MPI_Bcast, MPI_Allreduce, etc.
! Perhaps related to: http://www.mcs.anl.gov/research/projects/mpi/mpich1-old/docs/mpichman-chshmem/node33.htm#Node37
! Solution: pass explicitly the first element, i.e. (1,1,1), of the array.
#ifdef MPI
  use mpi
! include "mpif.h" -- the old way, which will not provide interfaces
#endif
  use nrtype_m
  use intrinsics_m
  implicit none

  ! default must not be private, or else the types defined in mpi module will not be available.

  public ::      &
    peinfo,      &
    peinfo_init, &
    create_mpi_group

!-------------------------------

  type peinfo
    !> default values for serial
    integer :: npes = 1
    integer :: npes_freqgrp = 1
    integer :: nthreads = 1
    integer :: inode = 0
    !> initialize to zero, then keep track of memory
    real(DP) :: mymem = 0d0
    real(DP) :: mymaxmem = 0d0
    integer :: nckmem
    integer :: nkpe  !< number of k-points per processor, used in absorption only
    !> kernel: total number of block-transitions ( nk^2, (nk*nc)^2 or (nk*nc*nv)^2)
    !! Each block-transition has iholdperown 
    integer :: nck
    !> kernel: number of block-transitions that I own
    integer :: nckpe
    integer :: myown !< Kernel: number of unique (k,kp) pairs I own; BSE: number of blocks I own
    integer :: mypown !< in BSE, number of unprimed indices I own for all my blocks
    integer :: npown !< in BSE, max number of unprimed indices owned by any proc in my pool
    integer :: jobtypeeval
    integer :: nblocks
    integer :: nblockd
    !> kernel: (nv,nc,nk,nv,nc,nk) offset in the bse_matrix for the
    !! block-transition identified by (ivp,icp,ikp,iv,ic,ik)
    integer, pointer :: wown(:,:,:,:,:,:)
    integer, pointer :: ciown(:)
    integer, pointer :: ik(:,:) !< (inode,j) index of jth k owned by inode
    integer, pointer :: ic(:,:) !< (inode,j) index of jth cband owned by inode
    integer, pointer :: iv(:,:) !< (inode,j) index of jth vband owned by inode
    integer, pointer :: ikp(:,:) !< (inode,j) index of jth kp owned by inode
    integer, pointer :: icp(:,:) !< (inode,j) index of jth cpband owned by inode
    integer, pointer :: ivp(:,:) !< (inode,j) index of jth vpband owned by inode
    integer, pointer :: ib(:,:)
    integer, pointer :: ick(:,:)
    integer, pointer :: ipe(:)
    !> (inode,iv,ik) Maps the global index for valence band (iv) at kpt (ik) to
    !! the local list of valence band the proc owns. (ik) is define in the 
    !! reducible wedge. ipec is 0 if the proc doesn`t own that band/kpt
    integer, pointer :: ipec(:,:,:)
    integer, pointer :: ipev(:,:,:) !< See ipec
    integer, pointer :: ipek(:,:)   !< Same as ipec, but w/o band index
    integer, pointer :: ipecb(:,:)
    integer, pointer :: ivckpe(:)
    integer, pointer :: ikt(:)
    integer, pointer :: ibt(:)
    integer, pointer :: ikb(:,:)
    integer, pointer :: ivb(:,:)
    integer, pointer :: icb(:,:)
    integer, pointer :: neig(:)
    integer, pointer :: peig(:,:)
    integer :: npools !< number of pools for the valence bands in Epsilon or outer bands in sigma
    integer :: npes_pool !< number of processors per pool
    integer :: pool_group !< mpi_group for pools
    integer :: pool_comm !< mpi_comm for pools
    integer :: pool_rank !< rank within pool
    integer :: my_pool !< what pool this processor is in 
    integer :: nvownmax  !< max. number of valence bands that I can own
    integer :: ncownmax  !< max. number of conduction bands that I can own
    integer :: nvownactual !< (total) number of valence bands that I *really* own
    integer :: ncownactual !< (total) number of conduction bands that I *really* own
    !> Who owns a particular pair of bands (v,c)?
    integer, pointer :: global_pairowner(:,:)
    !> (total) number of valence bands that a particular MPI process owns
    integer, pointer :: global_nvown(:)
    !> (total) number of conduction bands that a particular MPI process owns
    integer, pointer :: global_ncown(:)
    !> indexv(i) is the local index (in terms of bands that I own) of the ith 
    !! (global) valence band. It is zero if I don`t own valence band #i.
    integer, pointer :: indexv(:)
    integer, pointer :: global_indexv(:,:) !< local indices for all processes
    integer, pointer :: indexc(:) !< see indexv
    !> Given a local band #i that I own, invindexv(i) is the global index of
    !! that band. If i>nvownt, the result is zero.
    integer, pointer :: invindexv(:)
    integer, pointer :: invindexc(:) !< see invindexv
    logical, pointer :: doiownv(:) !< do I own a particular valence band?
    logical, pointer :: doiownc(:) !< do I own a particular conduction band?
    logical, pointer :: does_it_ownc(:,:) !< (band,node) does a particular node own a cond. band?
    logical, pointer :: does_it_ownv(:,:) !< (band,node) does a particular node own a val. band?
    integer, pointer :: iownwfv(:) !< number of val. WFNs each proc. owns
    integer, pointer :: iownwfc(:) !< number of cond WFNs each proc. owns
    integer, pointer :: iownwfk(:) !< number of distinct k-points each proc. (partially) owns
    integer, pointer :: nxqown(:)
    integer, pointer :: nxqi(:)
    integer :: ndiag_max
    integer :: noffdiag_max
    integer :: ntband_max
    integer :: ntband_node
    integer :: nvband_node
    integer, pointer :: indext(:)
    integer, pointer :: ntband_dist(:)
    integer, pointer :: indext_dist(:,:)
    integer, pointer :: index_diag(:)
    logical, pointer :: flag_diag(:)
    integer, pointer :: index_offdiag(:)
    logical, pointer :: flag_offdiag(:)
    !> Parallel frequencies mpi group variables
    !! igroup = your group number
    !! rank = your processor number in your group
    !! _f = frequency evaluation group
    !! _mtxel = matrix element communication group
    integer :: igroup_f
    integer :: rank_f
    integer :: igroup_mtxel
    integer :: rank_mtxel
    integer :: mtxel_comm         !< mtxel group communicator
    integer :: freq_comm          !< frequency group communicator
    integer :: mtxel_group        !< mtxel group handle
    integer :: freq_group         !< frequency group handle
    integer, pointer :: ranks(:)  !< ranks of processors to include in mpi group
  end type peinfo
  
  type(peinfo), save, public :: peinf
#ifdef MPI
  integer, public :: mpistatus(MPI_STATUS_SIZE)
  integer, public :: mpierr
#endif

contains

  subroutine peinfo_init()
    ! cannot use push_pop because that module uses this one

#ifdef MPI
    call MPI_Init(mpierr)
    if(mpierr .ne. MPI_SUCCESS) then
      write(0,'(a)') 'ERROR: MPI initialization failed!'
      stop 999
    endif
    call MPI_Comm_rank(MPI_COMM_WORLD, peinf%inode, mpierr)
    call MPI_Comm_size(MPI_COMM_WORLD, peinf%npes, mpierr)
#endif

#ifdef OMP
!$OMP PARALLEL
    peinf%nthreads = OMP_GET_NUM_THREADS()
!$OMP END PARALLEL

! Why put OMP pragmas here?
! JRD: I want to make sure our code has a parallel region before that of any library. This affects
! performance when the libraries are using a different implementation of threads or OpenMP build.
#endif

! if serial, default values set in type peinfo above are left alone

    return
  end subroutine peinfo_init

  subroutine create_mpi_group(orig_group,group_size,ranks,group_handle,group_comm)
    integer, intent(in) :: orig_group    !< Handle for original MPI group, which you are breaking into smaller groups
    integer,intent(in)  :: group_size    !< number of processors in new mpi group
    integer,intent(in)  :: ranks(:)      !< (group_size) array specifying ranks of processors to include in MPI group 
    integer,intent(out) :: group_handle  !< handle for new MPI group 
    integer,intent(out) :: group_comm    !< communicator for new MPI group 

#ifdef MPI
! DVF : create new group from original group, using ranks specified in `ranks` array 
    call MPI_Group_incl(orig_group, group_size,ranks(1:group_size), group_handle, mpierr)
    if(mpierr .ne. MPI_SUCCESS) write(0,'(a)') "ERROR: mpi_group_incl failed!"
! DVF : create communicator for new group
    call MPI_Comm_create(MPI_COMM_WORLD,group_handle,group_comm,mpierr)
    if(mpierr .ne. MPI_SUCCESS) write(0,'(a)') "ERROR: mpi_comm_create failed!"
#else
    group_handle = -1
    group_comm = -1
#endif

    return
  end subroutine create_mpi_group
  
end module peinfo_m

!=================================================================================
!
! Routines:
!
! (1) epscopy()                                 Last Modified 2014 (FHJ)
!
!     Copy dielectric matrices from eps0mat(.h5)/epsmat(.h5) files to memory.
!
!     This routine reads the eps0mat and epsmat files (units 10 and 11)
!     and copies the relevant information about those dielectric matrices
!     to memory (epsmpi). Processor 0 will actually read data and redistribute
!     them to other processors. The eps0mat can have more than one q-point,
!     which is useful when performing voronoi averages for the q->0 point.
!
!==================================================================================

#include "f_defs.h"

module epscopy_m

  use global_m
  use misc_m
  use io_utils_m
  use epsread_hdf5_m

  implicit none

  private

  public :: epscopy_init, epscopy

contains

!> Determines the number of q-points, the maximum rank of the dielectric matrix,
!! number of frequencies
subroutine epscopy_init(sig, neps)
  type (siginfo), intent(inout) :: sig
  integer, intent(out) :: neps !< Max. rank of dielectric matrix

  integer :: ngarbage1, nmtx, itrash, ig, igp, iq
  integer :: nFreq, freq_dep_flag
#ifdef HDF5
  integer :: ngarbage3(3), nmtxmax
  real(DP) :: dgarbage1
  logical :: file_exists
#endif

  PUSH_SUB(epscopy_init)

  if (sig%freq_dep>=0.and.sig%freq_dep<=3) then
#ifdef HDF5
    if (sig%use_hdf5) then
      if (peinf%inode==0) then
        call read_eps_grid_sizes_hdf5(ngarbage1, sig%nq0, dgarbage1, sig%nFreq, &
          nmtxmax, ngarbage3, 'eps0mat.h5')
        neps = nmtxmax
        ! FB: dirty trick, but it is really unlikely to have a full freq
        ! calculations with only 2 freqs
        select case(sig%nFreq)
        case(1)
          freq_dep_flag = 0
        case(2)
          freq_dep_flag = 3
        case default
          freq_dep_flag = 2
        end select

        ! Consistency check, before continuing
        if (freq_dep_flag==2.and.sig%freq_dep/=2) &
          call die('eps0mat is frequency-dependent, but this Sigma calculation is not.')
        if (freq_dep_flag==0.and.sig%freq_dep==2) then
          call die('This Sigma calculation is frequency-dependent, but eps0mat is not.')
        endif

        INQUIRE(FILE="epsmat.h5", EXIST=file_exists) 
        if (file_exists) then
          sig%igamma = 0
        else
          sig%igamma = 1
        endif

        if(sig%igamma/=0) then ! Gamma-only calculation
          sig%nq1 = 0
        else
          call read_eps_grid_sizes_hdf5(ngarbage1, sig%nq1, dgarbage1, nFreq, &
            nmtxmax, ngarbage3, 'epsmat.h5')
          if (nFreq/=sig%nFreq) then
            call die('nFreq mismatch between eps0mat.h5 and epsmat.h5')
          endif
          if (nmtxmax>neps) neps = nmtxmax
        endif
        write(6,*) "Found neps:", neps, sig%nq1
      endif !peinf%inode==0
    else
#endif
      if (peinf%inode==0) then
        call open_file(unit=10,file='eps0mat',form='unformatted',status='old')
        read(10)
        read(10) freq_dep_flag, sig%nFreq

        ! Consistency check, before continuing
        if (freq_dep_flag==2.and.sig%freq_dep/=2) &
          call die('eps0mat is frequency-dependent, but this Sigma calculation is not.')
        if (freq_dep_flag==0.and.sig%freq_dep==2) then
          call die('This Sigma calculation is frequency-dependent, but eps0mat is not.')
        endif

        read(10)
        read(10)
        read(10)
        read(10)
        read(10)
        read(10) sig%nq0
        read(10)
        read(10) itrash, neps
        call close_file(10)      
        call open_file(unit=10,file='eps0mat',form='unformatted',status='old')

        call open_file(unit=11,file='epsmat',form='unformatted',status='old',iostat=sig%igamma)
        if(sig%igamma/=0) then ! Gamma-only calculation
          sig%nq1 = 0
        else
          read(11)
          read(11) ngarbage1, nFreq
          if (nFreq/=sig%nFreq) then
            call die('nFreq mismatch between eps0mat and epsmat')
          endif
          read(11)
          read(11)
          read(11)
          read(11)
          read(11)
          read(11) sig%nq1
          read(11)
        
          do iq=1,sig%nq1
            read(11) itrash, nmtx
            read(11)
            if (sig%freq_dep==0.or.sig%freq_dep==1) then
              do ig=1,nmtx
                read(11)
              enddo
            endif
            if (sig%freq_dep==2.or.sig%freq_dep==3) then
              do igp=1,nmtx
                do ig=1,nmtx
                  read(11) ! For epsRDyn
                enddo
#ifdef CPLX
                do ig=1,nmtx
                  read(11) ! For epsADyn
                enddo
#endif
              enddo
            endif
            read(11)
            if(neps<nmtx) neps = nmtx
          enddo
          call close_file(11)
          call open_file(unit=11,file='epsmat',form='unformatted',status='old',iostat=sig%igamma)
        endif
      endif ! peinf%inode==0
#ifdef HDF5
    endif
#endif
#ifdef MPI
    call MPI_Bcast(sig%igamma, 1, MPI_INTEGER, 0 ,MPI_COMM_WORLD, mpierr)
    call MPI_Bcast(sig%nq0, 1, MPI_INTEGER, 0 ,MPI_COMM_WORLD, mpierr)
    call MPI_Bcast(sig%nq1, 1, MPI_INTEGER, 0 ,MPI_COMM_WORLD, mpierr)
    call MPI_Bcast(neps, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_Bcast(sig%nFreq, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
#endif
    if (sig%freq_dep==2.or.sig%freq_dep==3) then
      SAFE_ALLOCATE(sig%dFreqGrid,(sig%nFreq))
      SAFE_ALLOCATE(sig%dFreqBrd,(sig%nFreq))
    endif
  else ! sig%freq_dep>=0.and.sig_freq_dep<=2
    neps = 0
    sig%nFreq = 0
  endif
  if (sig%nq0/=1.and..not.sig%subsample) call die('epscopy_init: nq0/=1')

  POP_SUB(epscopy_init)

end subroutine epscopy_init


subroutine epscopy(crys,gvec,sig,neps,epsmpi,epshead,iunit_eps,fne)
  type (crystal), intent(in) :: crys
  type (gspace), intent(in) :: gvec
  type (siginfo), intent(inout) :: sig
  integer, intent(in) :: neps !< number of G-vectors up to epsilon cutoff defined in sigma.inp
  type (epsmpiinfo), intent(inout) :: epsmpi
  SCALAR, intent(out) :: epshead !< for full frequency, this is the retarded static head.
  integer, intent(in) :: iunit_eps
  character*20, intent(in) :: fne

  SCALAR, allocatable :: eps(:)
  complex(DPC), allocatable :: epsRDyn(:,:)
#ifdef CPLX
  complex(DPC), allocatable :: epsADyn(:,:)
#endif
  logical :: is_static

  PUSH_SUB(epscopy)

  is_static = sig%freq_dep/=2 .AND. sig%freq_dep/=3

  ! FHJ: Initialize files and buffers used by COMM_DISK and COMM_MPI
  if (sig%iwriteint==0) then ! COMM_DISK
    if (peinf%inode==0) then
      call open_file(iunit_eps,file=fne,form='unformatted',status='replace')
    endif
  else ! COMM_MPI
    if (is_static) then
      SAFE_ALLOCATE(epsmpi%eps, (neps,epsmpi%ngpown,sig%nq))
    else
      SAFE_ALLOCATE(epsmpi%epsR, (sig%nFreq,neps,epsmpi%ngpown,sig%nq))
#ifdef CPLX
      SAFE_ALLOCATE(epsmpi%epsA, (sig%nFreq,neps,epsmpi%ngpown,sig%nq))
#endif
    endif
  endif ! COMM_DISK

  ! FHJ: Temp buffers. Only used if it`s COMM_MPI or COMM_DISK and node 0
  if (sig%iwriteint==1.or.peinf%inode==0) then
    if (is_static) then
      SAFE_ALLOCATE(eps, (neps))
    else
      SAFE_ALLOCATE(epsRDyn, (sig%nFreq,neps))
#ifdef CPLX
      SAFE_ALLOCATE(epsADyn, (sig%nFreq,neps))
#endif
    endif
  endif

  !------------------------------------------------
  ! FHJ: Read dielectric matrices from eps0mat(.h5)
  !------------------------------------------------
  call read_epsmat(.true.)
#ifdef MPI
  call MPI_Bcast(epshead, 1, MPI_SCALAR, 0, MPI_COMM_WORLD, mpierr)
#endif
  if (dble(epshead)<1d-3.and.sig%iscreen==0.and.peinf%inode==0) then
    write(0,'(a)') 'WARNING: You are using semiconductor screening, but the'
    write(0,'(a)') 'head of epsilon inverse is very small and seems metallic.'
  endif
  !------------------------------------------------
  ! FHJ: Read dielectric matrices from epsmat(.h5)
  !------------------------------------------------
  if (sig%igamma==0) call read_epsmat(.false.)

#ifdef MPI
  call MPI_Bcast(sig%qgrid,3,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
  if (sig%iwriteint==1) epsmpi%qk(:,:) = sig%qpt(:,:)

  ! FHJ: Free temp. buffers
  if (sig%iwriteint==1.or.peinf%inode==0) then
    if (is_static) then
      SAFE_DEALLOCATE(eps)
    else
      SAFE_DEALLOCATE(epsRDyn)
#ifdef CPLX
      SAFE_DEALLOCATE(epsADyn)
#endif
    endif
  endif
  if (sig%iwriteint==0.and.peinf%inode==0) call close_file(iunit_eps)

  POP_SUB(epscopy)

  return

contains


  subroutine read_epsmat(is_q0)
    logical, intent(in) :: is_q0

    character(len=16) :: fname
    integer :: qoffset, nq_file, iunit
    integer :: freq_dep_flag, nFreq, ng_old, ngq, nmtx
    integer :: ii, ig, igp, nq_tmp, iq, qgrid(3), gg(3), iout, iw, dest
    real(DP) :: ecuts, qk(3), ekin
    real(DP), allocatable :: ekold(:)
#ifdef HDF5
    integer :: nmtxmax
    integer, allocatable :: nmtx_of_q(:), isrtinvdummy(:)
#endif
    integer, allocatable :: isrtq(:), isrtqi(:), isrtold(:), gvecs_old(:,:)
    type(progress_info) :: prog_info !< a user-friendly progress report
    character(len=6) :: sname
    character(len=11) :: sdate

    PUSH_SUB(epscopy.read_epsmat)

    if (is_q0) then
      fname = 'eps0mat'
      qoffset = 0
      nq_file = sig%nq0
      iunit = 10
    else
      fname = 'epsmat'
      qoffset = sig%nq0
      nq_file = sig%nq1
      iunit = 11
    endif
    if (sig%use_hdf5) fname = TRUNC(fname) // '.h5'

    if (peinf%inode==0) then
      SAFE_ALLOCATE(ekold, (gvec%ng))
      SAFE_ALLOCATE(isrtold, (gvec%ng))
      SAFE_ALLOCATE(isrtq, (gvec%ng))
      SAFE_ALLOCATE(isrtqi, (gvec%ng))
    endif

!------------------------------------------------------------------------------
! Read q-grid, q-points, G-vectors and freq. grid
!------------------------------------------------------------------------------
    if (peinf%inode==0) then
#ifdef HDF5
      if (sig%use_hdf5) then
        sname = 'chiGG0'
        sdate = 'nodate'
        call read_eps_grid_sizes_hdf5(ng_old, nq_tmp, ecuts, nFreq, nmtxmax, qgrid, TRUNC(fname))
        if (.not.is_static.and.is_q0) then
          call read_eps_freqgrid_hdf5(nFreq, sig%dFreqGrid, sig%dFreqBrd, TRUNC(fname))
        endif

        SAFE_ALLOCATE(nmtx_of_q, (nq_file))
        call read_eps_qgrid_hdf5(nq_tmp, sig%qpt(:,qoffset+1:), nmtx_of_q, TRUNC(fname))
        ! Note: it seems like the old format stores isort up to ngq, and the
        ! HDF5 stores up to ng_old
        SAFE_ALLOCATE(gvecs_old, (3,ng_old))
        call read_eps_old_gvecs_hdf5(ng_old, gvecs_old, TRUNC(fname))
      else
#endif
        read(iunit) sname, sdate
        read(iunit) freq_dep_flag, nFreq
        read(iunit) qgrid(1:3)
        if (.not.is_static.and.is_q0) then
          read(iunit) sig%dFreqGrid, sig%dFreqBrd
        else
          read(iunit)
        endif
        read(iunit)
        read(iunit)
        read(iunit) ecuts
        read(iunit) nq_tmp, ((sig%qpt(ii,qoffset+iq), ii=1,3), iq=1,nq_tmp)
        read(iunit) ng_old
        backspace(iunit)
        SAFE_ALLOCATE(gvecs_old, (3, ng_old))
        read(iunit) ng_old, ((gvecs_old(ii,iq), ii=1,3), iq=1,ng_old)
#ifdef HDF5
      endif
#endif
      if (nq_tmp/=nq_file) call die('nq mismatch for '//TRUNC(fname))
      ! FHJ: only substitute sig%qgrid (used in voronoi averages) if sig%qgrid
      ! is empty and this is epsmat(.h5), if this file is available
      if (all(sig%qgrid(1:3)==0).and.((.not.is_q0).or.(sig%igamma==1))) then
        sig%qgrid(:) = qgrid(:)
      endif
    endif ! peinf%inode==0


!------------------------------------------------------------------------------
! Bcast q-points and allocate/bcast full-frequency and epsilon buffers
!------------------------------------------------------------------------------
#ifdef MPI
    call MPI_Bcast(sig%qpt(1,qoffset+1), 3*nq_file, MPI_DOUBLE_PRECISION, 0, MPI_COMM_WORLD, mpierr)
#endif
    if (is_q0) then
      sig%q0vec(:) = sig%qpt(:,1)
      ! We need to manually set the q0 point in sig%qpt to zero
      if (.not.sig%subsample) sig%qpt(:,:sig%nq0) = 0d0
      if (.not.is_static) then
#ifdef MPI
        call MPI_Bcast(sig%dFreqGrid,sig%nFreq,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,mpierr)
        call MPI_Bcast(sig%dFreqBrd,sig%nFreq,MPI_DOUBLE_COMPLEX,0,MPI_COMM_WORLD,mpierr)
#endif
      endif
    endif !is_q0


!------------------------------------------------------------------------------
! Loop over all q-points, map G-vectors and read/store dielectric matrices
!------------------------------------------------------------------------------
    call progress_init(prog_info, 'reading '//TRUNC(fname), 'q-point', nq_file)
    do iq=1,nq_file
      call progress_step(prog_info, iq)
      call logit('Storing eps to memory')

      ! FHJ: Map old isrt (from epsilon gspace) to new isrt (to gvec gspace)
      !--------------------------------------------------------=------------
      if (peinf%inode==0) then
#ifdef HDF5
        if (sig%use_hdf5) then
          SAFE_ALLOCATE(isrtinvdummy, (ng_old))
          call read_eps_gvecsofq_hdf5(ng_old,isrtold,isrtinvdummy,ekold,iq,TRUNC(fname))
          SAFE_DEALLOCATE(isrtinvdummy)
          nmtx = nmtx_of_q(iq)
          ngq = ng_old
        else
#endif
          read(iunit) ngq, nmtx, (isrtold(ig),ii,ig=1,ngq)
          read(iunit) (ekold(ig),ig=1,ngq)
          read(iunit) (qk(ii),ii=1,3)
#ifdef HDF5
        endif
#endif
        isrtq = 0
        isrtqi = 0
        qk = sig%qpt(:,iq+qoffset)
        if (is_q0) qk(:) = 0d0
        do ig=1,ngq
          if (ekold(isrtold(ig))<=sig%ecutb) then
            gg(:) = gvecs_old(:, isrtold(ig))
            call findvector(iout, gg, gvec)
            isrtq(ig) = iout
            isrtqi(iout) = ig
            if (ig==1) then
              ! just check the first so we do not waste time
              ekin = DOT_PRODUCT(gvec%components(:,iout)+qk(:), MATMUL(crys%bdot, gvec%components(:,iout)+qk(:)))
              if (abs(ekin-ekold(isrtold(ig))) > TOL_Zero) then
                write(0,*) 'iq = ', iq, ' ig = ',ig, ' qk = ', qk
                write(0,*) 'epsmat: ekold(isrtold(i)) = ', ekold(isrtold(ig)), ' ekin = ', ekin
                call die("Incorrect kinetic energies in epsmat.")
              endif
            endif
          endif  ! if (ekold(isrtold(i))<=sig%ecutb) 
        enddo  ! do ig=1,ngq
      endif  ! if (peinf%inode==0)
#ifdef MPI
      call MPI_Bcast(nmtx,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
      if (sig%iwriteint==0) then
        if (peinf%inode==0) write(iunit_eps) gvec%ng, nmtx, &
          isrtq(1:gvec%ng), isrtqi(1:gvec%ng), (sig%qpt(ii,iq+qoffset),ii=1,3)
      else
        if (peinf%inode==0) then
          epsmpi%isrtq(:,iq+qoffset) = isrtq(:)
          epsmpi%isrtqi(:,iq+qoffset) = isrtqi(:)
        endif
        epsmpi%nmtx(iq+qoffset) = nmtx
      endif

#ifdef HDF5
      if (sig%use_hdf5) then
        ! FHJ: Read & store epsinv === HDF5 ===
        !--------------------------------------
        if (sig%iwriteint==1) then ! COMM_MPI below
          if (is_static) then
            call timacc(61,1)
            call read_eps_matrix_par_hdf5(epsmpi%eps(:,:,iq+qoffset), &
              epsmpi%ngpown, epsmpi%ngpown_max, epsmpi%inv_igp_index, nmtx, &
              iq, 1, fname)
            call timacc(61,2)
          else
            call timacc(61,1)
#ifdef CPLX
            call read_eps_matrix_par_f_hdf5(epsmpi%epsR(:,:,:,iq+qoffset), &
              epsmpi%epsA(:,:,:,iq+qoffset), epsmpi%ngpown, epsmpi%ngpown_max, &
              epsmpi%inv_igp_index, nmtx, sig%nFreq, iq, 1, fname)
#else
            call read_eps_matrix_par_f_hdf5(epsmpi%epsR(:,:,:,iq+qoffset), &
              epsmpi%ngpown, epsmpi%ngpown_max, epsmpi%inv_igp_index, nmtx, &
              sig%nFreq, iq, 1, fname)
#endif
            call timacc(61,2)
          endif
          if (is_q0.and.iq==1.and.peinf%inode==0) then
            if (is_static) then
              epshead = epsmpi%eps(1,1,1)
            else
              epshead = epsmpi%epsR(1,1,1,1)
            endif
          endif
        else ! COMM_DISK below
          if (peinf%inode==0) then
            do igp=1,nmtx
              if (is_static) then
                call timacc(61,1)
                call read_eps_matrix_col_hdf5(eps, igp, nmtx, iq, 1, fname)
                call timacc(61,2)
                if (is_q0.and.iq==1.and.igp==1) epshead = eps(1)
                call timacc(62,1)
                write(iunit) (eps(ig),ig=1,nmtx)
                call timacc(62,2)
              else
                call timacc(61,1)
#ifdef CPLX
                call read_eps_matrix_col_f_hdf5(epsRDyn, epsADyn, sig%nFreq, igp, nmtx, iq, 1, fname)
#else
                call read_eps_matrix_col_f_hdf5(epsRDyn, sig%nFreq, igp, nmtx, iq, 1, fname)
#endif
                call timacc(61,2)
                if (is_q0.and.iq==1.and.igp==1) epshead = epsRDyn(1,1)
                call timacc(62,1)
                if (sig%iwriteint==0) then
                  do ig=1,nmtx
                    write(iunit_eps) (epsRDyn(iw,ig),iw=1,sig%nFreq)
                  enddo
#ifdef CPLX
                  do ig=1,nmtx
                    write(iunit_eps) (epsADyn(iw,ig),iw=1,sig%nFreq)
                  enddo
#endif
                endif
                call timacc(62,2)
              endif
            enddo ! ig
          endif ! peinf%inode==0
        endif ! iwriteint==1
      else !HDF5
#endif
        ! FHJ: Read & store epsinv === Fortran binary  ===
        !-------------------------------------------------
        do igp=1,nmtx
          if (is_static) then
            if (peinf%inode==0) then
              call timacc(61,1)
              read(iunit) (eps(ig),ig=1,nmtx)
              call timacc(61,2)
              if (is_q0.and.iq==1.and.igp==1) epshead = eps(1)
              call timacc(62,1)
              if (sig%iwriteint==0) write(iunit_eps) (eps(ig),ig=1,nmtx)
              call timacc(62,2)
            endif

            if (sig%iwriteint==1) then ! COMM_MPI
              call timacc(62,1)
#ifdef MPI
              call MPI_Bcast(eps, neps, MPI_SCALAR, 0, MPI_COMM_WORLD, mpierr)
#endif
              call timacc(62,2)
            endif
          else ! is_static
            if (peinf%inode==0) then
              do ig=1,nmtx
                call timacc(61,1)
                read(iunit) (epsRDyn(iw,ig),iw=1,sig%nFreq) ! Retarded part
                call timacc(61,2)
                if (is_q0.and.iq==1.and.igp==1) epshead = epsRDyn(1,1)
                call timacc(62,1)
                if (sig%iwriteint==0) write(iunit_eps) (epsRDyn(iw,ig),iw=1,sig%nFreq)
                call timacc(62,2)
              enddo
#ifdef CPLX
              do ig=1,nmtx
                call timacc(61,1)
                read(iunit) (epsADyn(iw,ig),iw=1,sig%nFreq) ! Advanced part
                call timacc(61,2)
                call timacc(62,1)
                if (sig%iwriteint==0) write(iunit_eps) (epsADyn(iw,ig),iw=1,sig%nFreq)
                call timacc(62,2)
              enddo
#endif
            endif

            if (sig%iwriteint==1) then ! COMM_MPI
              call timacc(62,1)
#ifdef MPI
              call MPI_Bcast(epsRDyn, sig%nFreq*neps, MPI_COMPLEX_DPC, 0, MPI_COMM_WORLD, mpierr)
#ifdef CPLX
              call MPI_Bcast(epsADyn, sig%nFreq*neps, MPI_COMPLEX_DPC, 0, MPI_COMM_WORLD, mpierr)
#endif
#endif
              call timacc(62,2)
            endif
          endif ! is_static

          if (sig%iwriteint==1) then ! COMM_MPI
            dest = epsmpi%igp_owner(igp)
            call timacc(62,1)        
            if (peinf%pool_rank==dest) then
              if (is_static) then
                epsmpi%eps(:,epsmpi%igp_index(igp),iq+qoffset) = eps(:)
              else
                epsmpi%epsR(:,:,epsmpi%igp_index(igp),iq+qoffset) = epsRDyn(:,:)
#ifdef CPLX
                epsmpi%epsA(:,:,epsmpi%igp_index(igp),iq+qoffset) = epsADyn(:,:)
#endif
              endif ! is_static
            endif ! if (peinf%pool_rank==dest)
            call timacc(62,2)
          endif        
        enddo  ! do ig=1,nmtx
#ifdef HDF5
      endif !HDF5
#endif
    enddo ! iq
    call progress_free(prog_info)
    
!------------------------------------------------------------------------------
! Done!
!------------------------------------------------------------------------------

    if (peinf%inode==0) then
#ifdef HDF5
      if (sig%use_hdf5) then
        SAFE_DEALLOCATE(nmtx_of_q)
      else
#endif
        call close_file(iunit)
#ifdef HDF5
      endif
#endif
      SAFE_DEALLOCATE(ekold)
      SAFE_DEALLOCATE(isrtold)
      SAFE_DEALLOCATE(isrtq)
      SAFE_DEALLOCATE(isrtqi)
    endif

    POP_SUB(epscopy.read_epsmat)

  end subroutine read_epsmat

end subroutine epscopy

end module epscopy_m

!===============================================================================
!
! Program:
!
! (1) SIESTA              Originally By gsm        Last Modified 3/03/2010 (gsm)
!
! The SIESTA wrapper reads lattice vectors, atomic species and
! positions from SystemLabel.XV file, k-points from SystemLabel.KP
! file, eigenvalues from SystemLabel.EIG file, wavefunctions in R-space
! from SystemLabel{.K$k}.WF$n{.UP|.DOWN}{.REAL|.IMAG}.cube file, symmetry
! group, kinetic energy cutoffs for wavefunctions and charge density,
! k-grid dimensions and offsets from the input file, generates reciprocal
! lattice vectors, rotation matrices, fractional translations, FFT grid and
! G-vectors, performs FFT from R-space to G-space, and writes the selected
! range of bands to the output WFN file. Make sure to set up the real
! space grid in SIESTA/DENCHAR utility same as FFT grid. If the two grids
! differ the SIESTA wrapper will return an error. The output WFN file
! can be used as an auxiliary wavefunction for the SAPO code.
!
! A full GW/BSE calculation with SIESTA wavefunctions also requires RHO and
! VXC files. These files can be generated from SystemLabel.RHO{.UP|.DN}.cube,
! SystemLabel.VT{.UP|.DN}.cube and SystemLabel.VH.cube files obtained with
! SIESTA/GRID2CUBE utility on SIESTA real space grid. Make sure SIESTA real
! space grid is equivalent to FFT grid by setting parameter MeshCutoff
! in SIESTA input file same as kinetic energy cutoff for charge density.
!
! Input is read from file siesta2bgw.inp.
!
!===============================================================================

#include "f_defs.h"

program SIESTA

  use global_m
  use check_inversion_m
  use fftw_m
  use fft_parallel_m
  use read_cube_m
  use symmetries_m
  use wfn_rho_vxc_io_m
  use name_m
  use real_m

  implicit none

!------------------------
! Allocatable arrays

  integer, pointer :: as(:)
  real(DP), pointer :: ap(:,:), ap_lat(:,:)
  real(DP), pointer :: kw(:)
  real(DP), pointer :: kpt(:,:)
  real(DP), allocatable :: enlo(:,:)
  real(DP), pointer :: en(:,:,:)
  real(DP), pointer :: occ(:,:,:)
  integer, pointer :: ifmin(:,:)
  integer, pointer :: ifmax(:,:)
  integer, allocatable :: gvec(:,:)
  integer, pointer :: ngk(:)
  integer, allocatable :: idummy(:)
  complex(DPC), allocatable :: wfn(:,:)
  complex(DPC), allocatable :: wfn_d(:,:,:,:)
  integer, allocatable :: isort(:)
  integer, allocatable :: isort_d(:,:)
  complex(DPC), pointer :: fftbox_3D(:,:,:)
  complex(DPC), pointer :: fftbox_2D(:,:,:)
  complex(DPC), allocatable :: fftbox_1D(:,:)
  complex(DPC), allocatable :: buffer_2D(:,:,:)
  complex(DPC), allocatable :: buffer_1D(:,:,:)
  complex(DPC), allocatable :: buffer_rod(:)
  complex(DPC), allocatable :: buffer_sph(:)
  integer, allocatable :: inv_indx(:,:,:)
  integer, allocatable :: crod(:)
  integer, allocatable :: csph(:)
  integer, allocatable :: drod(:)
  integer, allocatable :: dsph(:)
  integer, allocatable :: irod(:,:)
  integer, allocatable :: isph(:)
  complex(DPC), allocatable :: rho(:,:)
  complex(DPC), allocatable :: rho_buf(:)
  complex(DPC), allocatable :: rho_d(:)
  complex(DPC), allocatable :: vxc(:,:)
  complex(DPC), allocatable :: vxc_buf(:)
  complex(DPC), allocatable :: vxc_d(:)
  SCALAR, allocatable :: data_buf(:,:)

  logical :: wfng_ref_flag,wfng_band_flag,wfng_energy_flag, &
    wfng_gamma_real,rhog_flag,vxcg_flag,fparafft
  integer :: cell_symmetry,wfng_nk1,wfng_nk2,wfng_nk3, &
    wfng_ref_kpoint,wfng_ref_spin,wfng_ref_band,wfng_band_min, &
    wfng_band_max,i,j,k,ierr,is,ik,ib,ig,igk,ig0, &
    nsymc,ns,nk,nb,ng,ngkmax,ng_l,ng_g,ngk_l,ngk_g, &
    nbmin,nbmax,nbnum,nbocc,nbstart,nbend,nFFTgridpts,ncount,na, &
    k0,k1,k2,i1,j1,j2,j3,tmpnum,ip,np,Nplane,Nrod,iflavor, &
    nelec,mrod,msph,kgrid(3),FFTgrid(3), &
    rotc(3,3,48),real_or_complex,spacegroup
  real(DP) :: ecutwfn,ecutrho,wfng_dk1,wfng_dk2,wfng_dk3, &
    wfng_ref_energy,wfng_energy_min,wfng_energy_max,efermi,de, &
    x,gcutm,ekin,scale,celvol,recvol,al,bl,relec,rdummy, &
    tsec(2),kvec(3),a(3,3),b(3,3),adot(3,3), &
    bdot(3,3),kshift(3),tauc(3,48)
  character(len=256) :: systemlabel,wfng_output_file, &
    rhog_output_file,vxcg_output_file,siesta_input_file,tmpstr
  character(len=16) :: s1,s2,s3,s4,s5,s6
  character*16 :: routnam(7)
  character :: sheader*3
  character*21 :: symbol

!------------------------
! Parameters

  integer, parameter :: Nfac = 3
  character(len=256), parameter :: input_file = 'siesta2bgw.inp'

!------------------------
! Input namelist

  namelist /input_siesta2bgw/ systemlabel, wfng_output_file, &
    rhog_output_file, vxcg_output_file, ecutwfn, ecutrho, &
    wfng_nk1, wfng_nk2, wfng_nk3, wfng_dk1, wfng_dk2, wfng_dk3, &
    wfng_ref_flag, wfng_ref_kpoint, wfng_ref_spin, wfng_ref_band, &
    wfng_ref_energy, wfng_band_flag, wfng_band_min, wfng_band_max, &
    wfng_energy_flag, wfng_energy_min, wfng_energy_max, wfng_gamma_real
  
!------------------------
! Initialize MPI

  ierr = 0
  call peinfo_init()
  
#ifdef MPI
  fparafft=.true.
#else
  fparafft=.false.
#endif

#ifdef CPLX
  real_or_complex = 2
#else
  real_or_complex = 1
#endif

!------------------------
! Initialize timer

  call timacc(0,0)
  
  call timacc(1,1)
  
  call timacc(2,1)

!------------------------
! Write header

  call write_program_header('SIESTA2BGW', .false.)

!------------------------
! Read input file

  if (peinf%inode.eq.0) then
    write(6,801) TRUNC(input_file)
    systemlabel = 'prefix'
    wfng_output_file = 'wfng.lo'
    rhog_output_file = 'rhog.lo'
    vxcg_output_file = 'vxcg.lo'
    ecutwfn = 0.0d0
    ecutrho = 0.0d0
    wfng_nk1 = 0
    wfng_nk2 = 0
    wfng_nk3 = 0
    wfng_dk1 = 0.0d0
    wfng_dk2 = 0.0d0
    wfng_dk3 = 0.0d0
    wfng_ref_flag = .false.
    wfng_ref_kpoint = 0
    wfng_ref_spin = 0
    wfng_ref_band = 0
    wfng_ref_energy = 0.0
    wfng_band_flag = .false.
    wfng_band_min = 0
    wfng_band_max = 0
    wfng_energy_flag = .false.
    wfng_energy_min = 0.0d0
    wfng_energy_max = 0.0d0
    wfng_gamma_real = .false.
    call open_file(55,file=input_file,status='old',form='formatted')
    read(55,input_siesta2bgw,iostat=ierr)
    if (ierr.eq.0) call close_file(55)
    if (ecutwfn.lt.TOL_Zero.or. &
      ecutrho.lt.TOL_Zero.or. &
      wfng_nk1.lt.0.or. &
      wfng_nk2.lt.0.or. &
      wfng_nk3.lt.0.or. &
      wfng_ref_kpoint.lt.0.or. &
      wfng_ref_spin.lt.0.or. &
      wfng_ref_band.lt.0.or. &
      wfng_band_min.lt.0.or. &
      wfng_band_max.lt.wfng_band_min.or. &
      wfng_energy_max.lt.(wfng_energy_min-TOL_Zero)) &
      ierr=1
    if (ierr.eq.0) then
      if (wfng_nk1.eq.0.or.wfng_nk2.eq.0.or.wfng_nk3.eq.0) then
        write(0,701)
      endif
      if (wfng_band_flag.and.wfng_energy_flag) then
        write(0,702)
        wfng_energy_flag=.false.
      endif
      kgrid(1)=wfng_nk1
      kgrid(2)=wfng_nk2
      kgrid(3)=wfng_nk3
      kshift(1)=wfng_dk1
      kshift(2)=wfng_dk2
      kshift(3)=wfng_dk3
    endif
  endif
#ifdef MPI
  call MPI_Bcast(ierr,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
  if (ierr.ne.0) then
    call die('failed to read input file ' // TRUNC(input_file), only_root_writes = .true.)
  endif
#ifdef MPI
  call MPI_Bcast(systemlabel,256,MPI_CHARACTER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(wfng_output_file,256,MPI_CHARACTER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(rhog_output_file,256,MPI_CHARACTER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(vxcg_output_file,256,MPI_CHARACTER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(ecutwfn,1,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(ecutrho,1,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(kgrid,3,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(kshift,3,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(wfng_ref_flag,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(wfng_ref_kpoint,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(wfng_ref_spin,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(wfng_ref_band,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(wfng_ref_energy,1,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(wfng_band_flag,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(wfng_band_min,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(wfng_band_max,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(wfng_energy_flag,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(wfng_energy_min,1,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(wfng_energy_max,1,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(wfng_gamma_real,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpierr)
#endif

!------------------------
! Initialize flags for output files

  if (len(TRUNC(rhog_output_file)).gt.0) then
    rhog_flag=.true.
  else
    rhog_flag=.false.
  endif
  if (len(TRUNC(vxcg_output_file)).gt.0) then
    vxcg_flag=.true.
  else
    vxcg_flag=.false.
  endif

!------------------------
! Read parameters from SIESTA lattice file

  call xvfilename(systemlabel,siesta_input_file)
  
  if (peinf%inode.eq.0) then
    write(6,802) TRUNC(siesta_input_file)
    a(:,:)=0.0d0
    na=0
    call open_file(7,file=siesta_input_file,status='old',form='formatted')
    do i=1,3
      if (ierr.eq.0) read(7,*,iostat=ierr)(a(j,i),j=1,3)
    enddo
    if (ierr.eq.0) read(7,*,iostat=ierr)na
    if (ierr.eq.0) call close_file(7)
    do i=1,3
      al=sqrt(a(1,i)**2+a(2,i)**2+a(3,i)**2)
      if (al.lt.TOL_Small) ierr=1
    enddo
    if (na.lt.1) ierr=1
  endif
#ifdef MPI
  call MPI_Bcast(ierr,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
  if (ierr.ne.0) then
    call die('failed to read SIESTA file ' // TRUNC(siesta_input_file), only_root_writes = .true.)
  endif
#ifdef MPI
  call MPI_Bcast(a,9,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(na,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif

  al = sqrt(a(1,1)**2 + a(2,1)**2 + a(3,1)**2)
  a(:,:) = a(:,:) / al
  celvol = a(1,1) * (a(2,2) * a(3,3) - a(2,3) * a(3,2)) - &
    a(2,1) * (a(1,2) * a(3,3) - a(1,3) * a(3,2)) + &
    a(3,1) * (a(1,2) * a(2,3) - a(1,3) * a(2,2))
  bl = 2.0d0 * PI_D / al
  b(1,1) = (a(2,2) * a(3,3) - a(3,2) * a(2,3)) / celvol
  b(2,1) = (a(3,2) * a(1,3) - a(1,2) * a(3,3)) / celvol
  b(3,1) = (a(1,2) * a(2,3) - a(2,2) * a(1,3)) / celvol
  b(1,2) = (a(2,3) * a(3,1) - a(3,3) * a(2,1)) / celvol
  b(2,2) = (a(3,3) * a(1,1) - a(1,3) * a(3,1)) / celvol
  b(3,2) = (a(1,3) * a(2,1) - a(2,3) * a(1,1)) / celvol
  b(1,3) = (a(2,1) * a(3,2) - a(3,1) * a(2,2)) / celvol
  b(2,3) = (a(3,1) * a(1,2) - a(1,1) * a(3,2)) / celvol
  b(3,3) = (a(1,1) * a(2,2) - a(2,1) * a(1,2)) / celvol
  celvol = abs(celvol) * al**3
  recvol = (2.0d0 * PI_D)**3 / celvol
  adot(:,:) = 0.0d0
  do i=1,3
    do j=1,3
      do k=1,3
        adot(j,i) = adot(j,i) + a(k,j) * a(k,i)
      enddo
    enddo
  enddo
  adot(:,:) = adot(:,:) * al**2
  bdot(:,:) = 0.0d0
  do i=1,3
    do j=1,3
      do k=1,3
        bdot(j,i) = bdot(j,i) + b(k,j) * b(k,i)
      enddo
    enddo
  enddo
  bdot(:,:) = bdot(:,:) * bl**2
  
  gcutm=ecutrho/bl**2
  do i=1,3
    FFTgrid(i)=int(2.0d0*sqrt(gcutm)*sqrt(a(1,i)**2+a(2,i)**2+a(3,i)**2))+1
    do while (.not.check_FFT_size(FFTgrid(i),Nfac))
      FFTgrid(i)=FFTgrid(i)+1
    enddo
  enddo
  
!------------------------
! Read SIESTA lattice file

  SAFE_ALLOCATE(as, (na))
  SAFE_ALLOCATE(ap, (3,na))
  SAFE_ALLOCATE(ap_lat, (3,na))
  
  if (peinf%inode.eq.0) then
    call open_file(7,file=siesta_input_file,status='old',form='formatted')
    do i=1,4
      read(7,*)
    enddo
    do i=1,na
      read(7,*)k,as(i),(ap(j,i),j=1,3)
    enddo
    call close_file(7)
  endif
#ifdef MPI
  call MPI_Bcast(as,na,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(ap,3*na,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
#endif

  ap_lat = matmul(transpose(b),ap) / al ! convert to crystal coords 
  call get_symmetries(na, as, ap_lat, a, FFTgrid, cell_symmetry, nsymc, rotc, tauc, spacegroup, symbol)
  ap(:,:) = ap(:,:) / al

!------------------------
! Read parameters from SIESTA kpoint file

  call kpfilename(systemlabel,siesta_input_file)
  
  if (peinf%inode.eq.0) then
    write(6,802) TRUNC(siesta_input_file)
    nk=0
    call open_file(7,file=siesta_input_file,status='old',form='formatted')
    read(7,*,iostat=ierr)nk
    if (ierr.eq.0) call close_file(7)
    if (nk.lt.1) ierr=1
  endif
#ifdef MPI
  call MPI_Bcast(ierr,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
  if (ierr.ne.0) then
    call die('failed to read SIESTA file ' // TRUNC(siesta_input_file), only_root_writes = .true.)
  endif
#ifdef MPI
  call MPI_Bcast(nk,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
  
  SAFE_ALLOCATE(kw, (nk))
  SAFE_ALLOCATE(kpt, (3,nk))

!------------------------
! Read SIESTA kpoint file

  if (peinf%inode.eq.0) then
    call open_file(7,file=siesta_input_file,status='old',form='formatted')
    read(7,*)
    do ik=1,nk
      read(7,*)k,(kpt(j,ik),j=1,3),kw(ik)
    enddo
    call close_file(7)
  endif
#ifdef MPI
  call MPI_Bcast(kpt,3*nk,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(kw,nk,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
#endif

  ! convert k-points from cartesian to crystal
  do ik=1,nk
    kvec(:)=kpt(:,ik)
    do j=1,3
      kpt(j,ik)=(kvec(1)*a(1,j)+kvec(2)*a(2,j)+kvec(3)*a(3,j)) &
        *al/(2.0d0*PI_D)
    enddo
  enddo

  ! normalize weights of k-points
  x=0.0d0
  do ik=1,nk
    x=x+kw(ik)
  enddo
  if (abs(x).gt.TOL_Small) then
    do ik=1,nk
      kw(ik)=kw(ik)/x
    enddo
  endif

!------------------------
! Read parameters from SIESTA eigenvalue file

  call eigfilename(systemlabel,siesta_input_file)
  
  if (peinf%inode.eq.0) then
    write(6,802) TRUNC(siesta_input_file)
    efermi=0.0d0
    nb=0
    ns=0
    call open_file(7,file=siesta_input_file,status='old',form='formatted')
    if (ierr.eq.0) read(7,*,iostat=ierr)efermi
    if (ierr.eq.0) read(7,*,iostat=ierr)nb,ns,i
    if (ierr.eq.0) call close_file(7)
    if (i.ne.nk) ierr=1
  endif
#ifdef MPI
  call MPI_Bcast(ierr,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
  if (ierr.ne.0) then
    call die('failed to read SIESTA file ' // TRUNC(siesta_input_file), only_root_writes = .true.)
  endif
#ifdef MPI
  call MPI_Bcast(efermi,1,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(nb,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(ns,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif

!------------------------
! Read SIESTA eigenvalue file

  SAFE_ALLOCATE(enlo, (nb*ns,nk))
  
  if (mod(nb*ns,10).eq.0) then
    tmpnum=(nb*ns)/10
  else
    tmpnum=(nb*ns)/10+1
  endif
  
  if (peinf%inode.eq.0) then
    call open_file(7,file=siesta_input_file,status='old',form='formatted')
    read(7,*)
    read(7,*)
    do i=1,nk
      do k=1,tmpnum
        read(7,103)tmpstr
        k1=10*(k-1)+1
        k2=10*(k-1)+10
        if (k2.gt.nb*ns) k2=nb*ns
        if (k.eq.1) then
          read(tmpstr,*)ik,(enlo(k0,i),k0=k1,k2)
        else
          read(tmpstr,*)(enlo(k0,i),k0=k1,k2)
        endif
      enddo
    enddo
    call close_file(7)
  endif
#ifdef MPI
  call MPI_Bcast(enlo,nb*ns*nk,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
#endif

!------------------------
! Check if real/complex version is appropriate

  call check_inversion(real_or_complex, nsymc, rotc, ns, .true., .true., tnp = tauc)
  
  call timacc(2,2)

  call timacc(3,1)

!------------------------
! Count numbers of G-vectors for rho and V and for wavefunctions
! at each k-point

  ng=0
  do j3=-FFTgrid(3)/2,FFTgrid(3)/2
    if (mod(j3+FFTgrid(3)/2,peinf%npes).ne.peinf%inode) cycle
    kvec(3)=dble(j3)
    do j2=-FFTgrid(2)/2,FFTgrid(2)/2
      kvec(2)=dble(j2)
      do j1=-FFTgrid(1)/2,FFTgrid(1)/2
        kvec(1)=dble(j1)
        ekin=DOT_PRODUCT(kvec,MATMUL(bdot,kvec))
        if (ekin.lt.ecutrho) ng=ng+1
      enddo
    enddo
  enddo
#ifdef MPI
  i=ng
  call MPI_Allreduce(i,ng,1,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,mpierr)
#endif

  SAFE_ALLOCATE(ngk, (nk))
  
  ngk(:)=0
  do ik=1,nk
    do j3=-FFTgrid(3)/2,FFTgrid(3)/2
      if (mod(j3+FFTgrid(3)/2,peinf%npes).ne.peinf%inode) cycle
      kvec(3)=kpt(3,ik)+dble(j3)
      do j2=-FFTgrid(2)/2,FFTgrid(2)/2
        kvec(2)=kpt(2,ik)+dble(j2)
        do j1=-FFTgrid(1)/2,FFTgrid(1)/2
          kvec(1)=kpt(1,ik)+dble(j1)
          ekin=DOT_PRODUCT(kvec,MATMUL(bdot,kvec))
          if (ekin.lt.ecutwfn) ngk(ik)=ngk(ik)+1
        enddo
      enddo
    enddo
  enddo
#ifdef MPI
  SAFE_ALLOCATE(idummy, (nk))
  idummy(:)=ngk(:)
  call MPI_Allreduce(idummy,ngk,nk,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,mpierr)
  SAFE_DEALLOCATE(idummy)
#endif
  
  ngkmax=0
  do ik=1,nk
    if (ngk(ik).gt.ngkmax) ngkmax=ngk(ik)
  enddo
  
  call timacc(3,2)
  
  call timacc(2,1)
  
!------------------------
! Distribute G-vectors over processors, set internal variables,
! and print report to stdout

  if (mod(ng,peinf%npes).eq.0) then
    ng_l=ng/peinf%npes
  else
    ng_l=ng/peinf%npes+1
  endif
  ng_g=ng_l*peinf%npes
  
  if (mod(ngkmax,peinf%npes).eq.0) then
    ngk_l=ngkmax/peinf%npes
  else
    ngk_l=ngkmax/peinf%npes+1
  endif
  ngk_g=ngk_l*peinf%npes
  
  nFFTgridpts=FFTgrid(1)*FFTgrid(2)*FFTgrid(3)
  
  if (wfng_ref_flag.and.wfng_ref_band.ge.1.and.wfng_ref_band.le.nb) then
    i=wfng_ref_kpoint
    k=wfng_ref_band+(wfng_ref_spin-1)*nb
    if (i.ge.1.and.i.le.nk.and.k.ge.1.and.k.le.nb*ns) then
      de=wfng_ref_energy-enlo(k,i)
      do i1=1,nk
        do k1=1,nb*ns
          enlo(k1,i1)=enlo(k1,i1)+de
        enddo
      enddo
    endif
  endif
  
  nbmin=1
  nbmax=nb
  
  if (wfng_band_flag) then
    nbmin=wfng_band_min
    nbmax=wfng_band_max
    if (nbmin.eq.0) nbmin=1
    if (nbmax.eq.0) nbmax=nb
    if (nbmin.gt.nb) nbmin=nb
    if (nbmax.gt.nb) nbmax=nb
  endif
  
  if (wfng_energy_flag) then
    nbmin=nb+1
    do i=1,nk
      do j=1,ns
        do k=1,nb
          if (enlo(k+(j-1)*nb,i).gt.wfng_energy_min- &
            TOL_Small.and.nbmin.gt.k) nbmin=k
        enddo
      enddo
    enddo
    if (nbmin.gt.nb) nbmin=nb
    nbmax=0
    do i=1,nk
      do j=1,ns
        do k=1,nb
          if (enlo(k+(j-1)*nb,i).lt.wfng_energy_max+ &
            TOL_Small.and.nbmax.lt.k) nbmax=k
        enddo
      enddo
    enddo
    if (nbmax.lt.1) nbmax=1
    if (nbmax.lt.nbmin) then
      ib=(nbmin+nbmax)/2
      nbmin=ib
      nbmax=ib
    endif
  endif
  
  nbnum=nbmax-nbmin+1

  if (peinf%inode.eq.0) then
    
    write(s1,101)nsymc
    write(s2,101)nk
    write(s3,101)ns
    write(s4,101)nb
    write(s5,101)ng
    write(s6,101)ngkmax
    write(6,110)TRUNC(s1),TRUNC(s2),TRUNC(s3),TRUNC(s4),TRUNC(s5),TRUNC(s6)
    write(s1,101)ng_l
    write(s2,101)ng_g
    write(s3,101)ngk_l
    write(s4,101)ngk_g
    write(6,120)TRUNC(s1),TRUNC(s2),TRUNC(s3),TRUNC(s4)
    write(s1,101)FFTgrid(1)
    write(s2,101)FFTgrid(2)
    write(s3,101)FFTgrid(3)
    write(s4,101)nFFTgridpts
    write(6,130)TRUNC(s1),TRUNC(s2),TRUNC(s3),TRUNC(s4)
    write(s1,101)nbmin
    write(s2,101)nbmax
    write(s3,101)nbnum
    write(6,140)TRUNC(s1),TRUNC(s2),TRUNC(s3)

  endif

!------------------------
! Store SIESTA eigenvalues for output

  SAFE_ALLOCATE(en, (nbnum,nk,ns))
  SAFE_ALLOCATE(occ, (nbnum,nk,ns))
  SAFE_ALLOCATE(ifmin, (nk,ns))
  SAFE_ALLOCATE(ifmax, (nk,ns))
  
  do ik=1,nk
    do is=1,ns
      do ib=1,nbnum
        en(ib,ik,is)=enlo(nbmin+ib-1+(is-1)*nb,ik)/RYD
      enddo
    enddo
  enddo
  efermi=efermi/RYD
  
  do is=1,ns
    do ik=1,nk
      nbocc=0
      do ib=1,nbnum
        if (en(ib,ik,is).lt.efermi) then
          nbocc=nbocc+1
          occ(ib,ik,is)=1.0d0
        else
          occ(ib,ik,is)=0.0d0
        endif
      enddo
      if (nbmin.le.nbocc) then
        ifmin(ik,is)=1
        ifmax(ik,is)=nbocc
      else
        ifmin(ik,is)=0
        ifmax(ik,is)=0
      endif
    enddo
  enddo
  
  SAFE_DEALLOCATE(enlo)

!------------------------
! Reset output files

  if (peinf%inode.eq.0) then
    call open_file(8,file=wfng_output_file,status='replace',form='unformatted')
    if (ierr.eq.0) call close_file(8)
  endif
#ifdef MPI
  call MPI_Bcast(ierr,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
  if (ierr.ne.0) then
    call die('failed to write wavefunction file ' // TRUNC(wfng_output_file), only_root_writes = .true.)
  endif
  
  if (rhog_flag) then
    if (peinf%inode.eq.0) then
      call open_file(9,file=rhog_output_file,status='replace',form='unformatted')
      if (ierr.eq.0) call close_file(9)
    endif
#ifdef MPI
    call MPI_Bcast(ierr,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
    if (ierr.ne.0) then
      call die('failed to write charge density file ' // TRUNC(rhog_output_file), only_root_writes = .true.)
    endif
  endif
  
  if (vxcg_flag) then
    if (peinf%inode.eq.0) then
      call open_file(10,file=vxcg_output_file,status='replace',form='unformatted')
      if (ierr.eq.0) call close_file(10)
    endif
#ifdef MPI
    call MPI_Bcast(ierr,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
    if (ierr.ne.0) then
      call die('failed to write exchange-correlation potential file ' // &
        TRUNC(vxcg_output_file), only_root_writes = .true.)
    endif
  endif
  
  call timacc(2,2)
  
  call timacc(3,1)

!------------------------
! Construct list of G-vectors for rho and V and indices
! of G-vectors for wavefunctions at each k-point
  
  SAFE_ALLOCATE(gvec, (3,ng))

  ig=0
  do j3=-FFTgrid(3)/2,FFTgrid(3)/2
    kvec(3)=dble(j3)
    do j2=-FFTgrid(2)/2,FFTgrid(2)/2
      kvec(2)=dble(j2)
      do j1=-FFTgrid(1)/2,FFTgrid(1)/2
        kvec(1)=dble(j1)
        ekin=DOT_PRODUCT(kvec,MATMUL(bdot,kvec))
        if (ekin.lt.ecutrho) then
          ig=ig+1
          gvec(1,ig)=j1
          gvec(2,ig)=j2
          gvec(3,ig)=j3
        endif
      enddo
    enddo
  enddo
  
  SAFE_ALLOCATE(isort, (ngk_g))
  SAFE_ALLOCATE(isort_d, (ngk_l,nk))
  
  do ik=1,nk
    isort(:)=0
    igk=0
    do ig=1,ng
      do j=1,3
        kvec(j)=kpt(j,ik)+dble(gvec(j,ig))
      enddo
      ekin=DOT_PRODUCT(kvec,MATMUL(bdot,kvec))
      if (ekin.lt.ecutwfn) then
        igk=igk+1
        isort(igk)=ig
      endif
    enddo
#ifdef MPI
    call MPI_Barrier(MPI_COMM_WORLD,mpierr)
    call MPI_Scatter(isort,ngk_l,MPI_INTEGER,isort_d(:,ik),ngk_l, &
      MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#else
    isort_d(:,ik)=isort(:)
#endif
  enddo
  
  call timacc(3,2)
  
  call timacc(2,1)

!------------------------
! Allocate arrays for wavefunctions

  SAFE_ALLOCATE(wfn, (ngk_g,ns))
  SAFE_ALLOCATE(wfn_d, (ngk_l,nbnum,ns,nk))

!------------------------
! Open files

  if (peinf%inode.eq.0) then
    call open_file(8,file=wfng_output_file,status='old',form='unformatted')
  endif
  
  if (rhog_flag.and.peinf%inode.eq.0) then
    call open_file(9,file=rhog_output_file,status='old',form='unformatted')
  endif
  
  if (vxcg_flag.and.peinf%inode.eq.0) then
    call open_file(10,file=vxcg_output_file,status='old',form='unformatted')
  endif
  
!------------------------
! Initialize SIESTA wavefunction file

  if (nk.eq.1.and.wfng_gamma_real) then
    ! .cube files from siesta-2/denchar
    np=1
  else
    ! .REAL.cube & .IMAG.cube files from siesta-3/denchar
    np=2
  endif

!------------------------
! Initialize FFT

  if (fparafft) then
    call fft_set_p(FFTgrid,Nplane,Nrod)
  endif
  
  if (fparafft) then
    SAFE_ALLOCATE(crod, (peinf%npes))
    SAFE_ALLOCATE(csph, (peinf%npes))
    SAFE_ALLOCATE(drod, (peinf%npes))
    SAFE_ALLOCATE(dsph, (peinf%npes))
    SAFE_ALLOCATE(irod, (1,1))
    SAFE_ALLOCATE(isph, (1))
    SAFE_ALLOCATE(buffer_rod, (1))
    SAFE_ALLOCATE(buffer_sph, (1))
    SAFE_ALLOCATE(fftbox_2D, (FFTgrid(1),FFTgrid(2),Nplane))
    SAFE_ALLOCATE(fftbox_1D, (FFTgrid(3),Nrod))
    SAFE_ALLOCATE(buffer_2D, (Nrod,Nplane,peinf%npes))
    SAFE_ALLOCATE(buffer_1D, (Nrod,Nplane,peinf%npes))
  else
    SAFE_ALLOCATE(inv_indx, (FFTgrid(1),FFTgrid(2),FFTgrid(3)))
    SAFE_ALLOCATE(fftbox_3D, (FFTgrid(1),FFTgrid(2),FFTgrid(3)))
  endif

  scale=sqrt(celvol)/dble(FFTgrid(1)*FFTgrid(2)*FFTgrid(3))
  
  call timacc(2,2)

!------------------------
! Loop over SIESTA wavefunction files

  do ik=1,nk
    
    call timacc(3,1)

#ifdef MPI
    call MPI_Barrier(MPI_COMM_WORLD,mpierr)
    call MPI_Gather(isort_d(:,ik),ngk_l,MPI_INTEGER, &
      isort,ngk_l,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
    call MPI_Bcast(isort,ngk_g,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#else
    isort(:)=isort_d(:,ik)
#endif

!------------------------
! Invert indices of G-vectors for current k-point

    if (fparafft) then
      call fft_map_p(0,ngk(ik),ngk_l,Nrod,FFTgrid,isort,gvec, &
        mrod,msph,crod,csph,drod,dsph,irod,isph)
      SAFE_DEALLOCATE(irod)
      SAFE_DEALLOCATE(isph)
      SAFE_DEALLOCATE(buffer_rod)
      SAFE_DEALLOCATE(buffer_sph)
      SAFE_ALLOCATE(irod, (2,MAX(1,mrod)))
      SAFE_ALLOCATE(isph, (MAX(1,msph)))
      SAFE_ALLOCATE(buffer_rod, (MAX(1,mrod)))
      SAFE_ALLOCATE(buffer_sph, (MAX(1,msph)))
      call fft_map_p(1,ngk(ik),ngk_l,Nrod,FFTgrid,isort,gvec, &
        mrod,msph,crod,csph,drod,dsph,irod,isph)
    else ! fparafft
      call fft_map_s(ngk(ik),FFTgrid,isort,gvec,inv_indx)
    endif ! fparafft
    
    call timacc(3,2)
    
    do is=1,ns
      do ib=1,nbnum
        
        call timacc(4,1)
        
        if (fparafft) then
          fftbox_2D(:,:,:)=(0.0d0,0.0d0)
        else
          fftbox_3D(:,:,:)=(0.0d0,0.0d0)
        endif
        
        do ip=1,np
          
          call wfnrfilename(ik,is,nbmin+ib-1,ip,ns,np,systemlabel,siesta_input_file)

!------------------------
! Read SIESTA wavefunction file

          if (peinf%inode.eq.0) write(6,803) TRUNC(siesta_input_file)
          
          call read_cube(fparafft,7,siesta_input_file,a,al,ip, &
            Nplane,FFTgrid,fftbox_3D,fftbox_2D,ierr)
          
          if (ierr.ne.0) then
            call die('failed to read SIESTA wavefunction file ' // TRUNC(siesta_input_file))
          endif
          
        enddo ! ip
        
#ifdef MPI
        if (.not.fparafft) then
          call MPI_Bcast(fftbox_3D(1,1,1),FFTgrid(1)*FFTgrid(2)*FFTgrid(3),MPI_COMPLEX_DPC,0,MPI_COMM_WORLD,mpierr)
        endif
#endif
        
        call timacc(4,2)
        
        call timacc(5,1)

!------------------------
! Perform FFT from R-space to G-space

        if (fparafft) then
          if (peinf%inode.eq.0) write(6,804)
          call fft_r2g_p(FFTgrid,Nplane,Nrod,mrod,msph,crod, &
            csph,drod,dsph,irod,isph,scale,fftbox_2D,fftbox_1D, &
            buffer_2D,buffer_1D,buffer_rod,buffer_sph,wfn_d(:,ib,is,ik))
        else
          if (peinf%inode.eq.0) write(6,805)
          call fft_r2g_s(FFTgrid,scale,inv_indx,fftbox_3D,wfn(:,is))
#ifdef MPI
          call MPI_Barrier(MPI_COMM_WORLD,mpierr)
          call MPI_Scatter(wfn(:,is),ngk_l,MPI_COMPLEX_DPC, &
            wfn_d(:,ib,is,ik),ngk_l,MPI_COMPLEX_DPC, &
            0,MPI_COMM_WORLD,mpierr)
#else
          wfn_d(:,ib,is,ik)=wfn(:,is)
#endif
        endif

        call timacc(5,2)
        
      enddo ! ib
    enddo ! is
    
  enddo ! ik
  
  if (peinf%inode.eq.0) write(6,*)
  
  call timacc(6,1)

!------------------------
! Normalize wavefunctions in G-space (complex version)
! Construct real wavefunctions in G-space (real version)

#ifdef CPLX
  if (peinf%inode.eq.0) write(6,806)
  nbstart=1
  nbend=nbnum
  call norm_wfng(ngk_l,nbstart,nbend,nbnum,ns,nk,wfn_d)
#else
  if (peinf%inode.eq.0) write(6,807)
  call real_wfng(ngk_l,nbnum,ns,nk,en,wfn_d)
#endif

  call timacc(6,2)
  
  call timacc(7,1)

!------------------------
! Write header of wavefunction file

  if (peinf%inode.eq.0) then
    write(6,808) TRUNC(wfng_output_file)
    sheader = 'WFN'
    iflavor = 0
    call write_binary_header(8, sheader, iflavor, ns, ng, nsymc, &
      cell_symmetry, na, nk, nbnum, ngkmax, ecutrho, ecutwfn, FFTgrid, &
      kgrid, kshift, celvol, al, a, adot, recvol, bl, b, bdot, &
      rotc, tauc, as, ap, ngk, kw, kpt, ifmin, ifmax, en, occ)
    call write_binary_gvectors(8, ng, ng, gvec)
  endif
  
!------------------------
! Loop over k-points

  SAFE_ALLOCATE(data_buf, (ngk_g, ns))
  
  do ik=1,nk

!------------------------
! Gather indices of g-vectors for current k-point
! Write list of g-vectors to wavefunction file

#ifdef MPI
    call MPI_Barrier(MPI_COMM_WORLD,mpierr)
    call MPI_Gather(isort_d(:,ik),ngk_l,MPI_INTEGER, &
      isort,ngk_l,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#else
    isort(:)=isort_d(:,ik)
#endif
    call write_binary_gvectors(8, ngk(ik), ng, gvec, gindex = isort)

!------------------------
! Gather band and spin wavefunctions for current k-point
! Write them to wavefunction file

    do ib=1,nbnum
      do is=1,ns
#ifdef MPI
        call MPI_Barrier(MPI_COMM_WORLD,mpierr)
        call MPI_Gather(wfn_d(:,ib,is,ik),ngk_l, &
          MPI_COMPLEX_DPC,wfn(:,is),ngk_l, &
          MPI_COMPLEX_DPC,0,MPI_COMM_WORLD,mpierr)
#else
        wfn(:,is)=wfn_d(:,ib,is,ik)
#endif
      enddo ! is
      if (peinf%inode.eq.0) then
        do is=1,ns
          do ig=1,ngk_g
            data_buf(ig,is) = SCALARIFY(wfn(ig,is))
          enddo
        enddo
      endif
      call write_binary_data(8, ngk(ik), ngk_g, ns, data_buf)
    enddo ! ib
    
  enddo ! ik
  
  SAFE_DEALLOCATE(data_buf)
  
  call timacc(7,2)
  
  call timacc(2,1)
  
!------------------------
! Deallocate unneeded arrays and reallocate isort

  SAFE_DEALLOCATE(wfn)
  SAFE_DEALLOCATE(wfn_d)
  SAFE_DEALLOCATE(isort_d)
  
  if (rhog_flag.or.vxcg_flag) then
    SAFE_DEALLOCATE(isort)
    SAFE_ALLOCATE(isort, (ng))
  endif

!------------------------
! Find index of G=(0,0,0) for rho(G=(0,0,0)) and Vxc(G=(0,0,0))

  if (rhog_flag.or.vxcg_flag) then
    ierr=0
    ig0=0
    do ig=1,ng
      if (gvec(1,ig).eq.0.and.gvec(2,ig).eq.0.and.gvec(3,ig).eq.0) ig0=ig
    enddo
    if (ig0.lt.1.or.ig0.gt.ng) ierr=1
    if (ierr.ne.0) then
      call die('failed to find zero G-vector')
    endif
  endif
  
  call timacc(2,2)
  
  call timacc(3,1)

!------------------------
! Invert indices of G-vectors for charge density and potential

  if (rhog_flag.or.vxcg_flag) then
    isort(:)=0
    do ig=1,ng
      isort(ig)=ig
    enddo ! ig
    if (fparafft) then
      call fft_map_p(0,ng,ng_l,Nrod,FFTgrid,isort,gvec, &
        mrod,msph,crod,csph,drod,dsph,irod,isph)
      SAFE_DEALLOCATE(irod)
      SAFE_DEALLOCATE(isph)
      SAFE_DEALLOCATE(buffer_rod)
      SAFE_DEALLOCATE(buffer_sph)
      SAFE_ALLOCATE(irod, (2,MAX(1,mrod)))
      SAFE_ALLOCATE(isph, (MAX(1,msph)))
      SAFE_ALLOCATE(buffer_rod, (MAX(1,mrod)))
      SAFE_ALLOCATE(buffer_sph, (MAX(1,msph)))
      call fft_map_p(1,ng,ng_l,Nrod,FFTgrid,isort,gvec, &
        mrod,msph,crod,csph,drod,dsph,irod,isph)
    else ! fparafft
      call fft_map_s(ng,FFTgrid,isort,gvec,inv_indx)
    endif ! fparafft
  endif ! rhog_flag.or.vxcg_flag
  
  call timacc(3,2)

!------------------------
! Loop over SIESTA charge density files

  if (rhog_flag) then
    
    call timacc(2,1)
    
    scale=celvol/dble(FFTgrid(1)*FFTgrid(2)*FFTgrid(3))
    
    SAFE_ALLOCATE(rho, (ng,ns))
    if (fparafft) then
      SAFE_ALLOCATE(rho_buf, (ng_g))
      SAFE_ALLOCATE(rho_d, (ng_l))
    endif
    
    call timacc(2,2)
    
    do is=1,ns
      
      call timacc(4,1)
      
      if (fparafft) then
        fftbox_2D(:,:,:)=(0.0d0,0.0d0)
      else
        fftbox_3D(:,:,:)=(0.0d0,0.0d0)
      endif
      
      call rhorfilename(is,ns,systemlabel,siesta_input_file)

!------------------------
! Read SIESTA charge density file
      
      if (peinf%inode.eq.0) write(6,809) TRUNC(siesta_input_file)
      
      call read_cube(fparafft,7,siesta_input_file,a,al,1, &
        Nplane,FFTgrid,fftbox_3D,fftbox_2D,ierr)

      if (ierr.ne.0) then
        call die('failed to read SIESTA charge-density file ' // TRUNC(siesta_input_file))
      endif
      
#ifdef MPI
      if (.not.fparafft) then
        call MPI_Bcast(fftbox_3D(1,1,1),FFTgrid(1)*FFTgrid(2)*FFTgrid(3),MPI_COMPLEX_DPC,0,MPI_COMM_WORLD,mpierr)
      endif
#endif
      
      call timacc(4,2)
      
      call timacc(5,1)

!------------------------
! Perform FFT from R-space to G-space

      if (fparafft) then
        if (peinf%inode.eq.0) write(6,804)
        call fft_r2g_p(FFTgrid,Nplane,Nrod,mrod,msph,crod, &
          csph,drod,dsph,irod,isph,scale,fftbox_2D,fftbox_1D, &
          buffer_2D,buffer_1D,buffer_rod,buffer_sph,rho_d)
#ifdef MPI
        call MPI_Barrier(MPI_COMM_WORLD,mpierr)
        call MPI_Gather(rho_d,ng_l,MPI_COMPLEX_DPC, &
          rho_buf,ng_l,MPI_COMPLEX_DPC,0,MPI_COMM_WORLD,mpierr)
#else
        rho_buf(:)=rho_d(:)
#endif
        if (peinf%inode.eq.0) then
          do ig=1,ng
            rho(ig,is)=rho_buf(ig)
          enddo
        endif
      else
        if (peinf%inode.eq.0) write(6,805)
        call fft_r2g_s(FFTgrid,scale,inv_indx,fftbox_3D,rho(:,is))
      endif
      
      call timacc(5,2)
      
    enddo ! is
    
    if (peinf%inode.eq.0) write(6,*)
    
    call timacc(7,1)

!------------------------
! Normalize charge density in G-space
! Print rho(G = 0) to stdout
    
    if (peinf%inode.eq.0) then
      relec=0.0d0
      do is=1,ns
        relec=relec+dble(rho(ig0,is))
      enddo
      nelec=nint(relec)
      rdummy=abs(relec-dble(nelec))
      if (nelec.ne.0.and.rdummy.gt.TOL_Zero) then
        rdummy=dble(nelec)/relec
        do is=1,ns
          do ig=1,ng
            rho(ig,is)=rho(ig,is)*rdummy
          enddo
        enddo
        write(s1,102)relec
        write(s2,102)dble(nelec)
        write(6,210)TRUNC(s1),TRUNC(s2)
      else
        write(s1,102)relec
        write(6,211)TRUNC(s1)
      endif
    endif

!------------------------
! Write charge density file

    SAFE_ALLOCATE(data_buf, (ng, ns))
    
    if (peinf%inode.eq.0) then
      write(6,810) TRUNC(rhog_output_file)
      sheader = 'RHO'
      iflavor = 0
      call write_binary_header(9, sheader, iflavor, ns, ng, nsymc, &
        cell_symmetry, na, nk, nbnum, ngkmax, ecutrho, ecutwfn, FFTgrid, &
        kgrid, kshift, celvol, al, a, adot, recvol, bl, b, bdot, &
        rotc, tauc, as, ap, ngk, kw, kpt, ifmin, ifmax, en, occ)
      call write_binary_gvectors(9, ng, ng, gvec)
      do is=1,ns
        do ig=1,ng
          data_buf(ig,is) = SCALARIFY(rho(ig,is))
        enddo
      enddo
      call write_binary_data(9, ng, ng, ns, data_buf)
    endif
    
    SAFE_DEALLOCATE(data_buf)
    SAFE_DEALLOCATE(rho)
    if (fparafft) then
      SAFE_DEALLOCATE(rho_buf)
      SAFE_DEALLOCATE(rho_d)
    endif
    
    call timacc(7,2)
    
  endif ! rhog_flag

!------------------------
! Loop over SIESTA total and electrostatic potential files

  if (vxcg_flag) then
    
    call timacc(2,1)
    
    scale=1.0d0/dble(FFTgrid(1)*FFTgrid(2)*FFTgrid(3))
    
    SAFE_ALLOCATE(vxc, (ng,ns))
    if (fparafft) then
      SAFE_ALLOCATE(vxc_buf, (ng_g))
      SAFE_ALLOCATE(vxc_d, (ng_l))
    endif
    
    call timacc(2,2)
    
    do is=1,ns
      
      call timacc(4,1)
      
      if (fparafft) then
        fftbox_2D(:,:,:)=(0.0d0,0.0d0)
      else
        fftbox_3D(:,:,:)=(0.0d0,0.0d0)
      endif
      
      call vtrfilename(is,ns,systemlabel,siesta_input_file)

!------------------------
! Read SIESTA total potential file

      if (peinf%inode.eq.0) write(6,811) TRUNC(siesta_input_file)
      
      call read_cube(fparafft,7,siesta_input_file,a,al,1, &
        Nplane,FFTgrid,fftbox_3D,fftbox_2D,ierr)
      
      if (ierr.ne.0) then
        call die('failed to read SIESTA total potential file ' // TRUNC(siesta_input_file))
      endif
      
      call vhrfilename(systemlabel,siesta_input_file)

!------------------------
! Read SIESTA electrostatic potential file

      if (peinf%inode.eq.0) write(6,812) TRUNC(siesta_input_file)
      
      call read_cube(fparafft,7,siesta_input_file,a,al,2, &
        Nplane,FFTgrid,fftbox_3D,fftbox_2D,ierr)
      
      if (ierr.ne.0) then
        call die('failed to read SIESTA electrostatic potential file ' // TRUNC(siesta_input_file))
      endif
      
#ifdef MPI
      if (.not.fparafft) then
        call MPI_Bcast(fftbox_3D(1,1,1),FFTgrid(1)*FFTgrid(2)*FFTgrid(3),MPI_COMPLEX_DPC,0,MPI_COMM_WORLD,mpierr)
      endif
#endif
      
      call timacc(4,2)
      
      call timacc(2,1)

!------------------------
! Compute exchange-correlation potential in R-space

      if (fparafft) then
        do k=1,Nplane
          do j=1,FFTgrid(2)
            do i=1,FFTgrid(1)
              fftbox_2D(i,j,k)=CMPLX(dble(fftbox_2D(i,j,k))-IMAG(fftbox_2D(i,j,k)),0.0d0)
            enddo
          enddo
        enddo
      else
        do k=1,FFTgrid(3)
          do j=1,FFTgrid(2)
            do i=1,FFTgrid(1)
              fftbox_3D(i,j,k)=CMPLX(dble(fftbox_3D(i,j,k))-IMAG(fftbox_3D(i,j,k)),0.0d0)
            enddo
          enddo
        enddo
      endif
      
      call timacc(2,2)
      
      call timacc(5,1)
      
!------------------------
! Perform FFT from R-space to G-space

      if (fparafft) then
        if (peinf%inode.eq.0) write(6,804)
        call fft_r2g_p(FFTgrid,Nplane,Nrod,mrod,msph,crod, &
          csph,drod,dsph,irod,isph,scale,fftbox_2D,fftbox_1D, &
          buffer_2D,buffer_1D,buffer_rod,buffer_sph,vxc_d)
#ifdef MPI
        call MPI_Barrier(MPI_COMM_WORLD,mpierr)
        call MPI_Gather(vxc_d,ng_l,MPI_COMPLEX_DPC, &
          vxc_buf,ng_l,MPI_COMPLEX_DPC,0,MPI_COMM_WORLD,mpierr)
#else
        vxc_buf(:)=vxc_d(:)
#endif
        if (peinf%inode.eq.0) then
          do ig=1,ng
            vxc(ig,is)=vxc_buf(ig)
          enddo
        endif
      else
        if (peinf%inode.eq.0) write(6,805)
        call fft_r2g_s(FFTgrid,scale,inv_indx,fftbox_3D,vxc(:,is))
      endif
      
      call timacc(5,2)
      
    enddo ! is
    
    if (peinf%inode.eq.0) write(6,*)
    
    call timacc(7,1)

!------------------------
! Print Vxc(G = 0) to stdout

    if (peinf%inode.eq.0) then
      rdummy=0.0d0
      do is=1,ns
        rdummy=rdummy+dble(vxc(ig0,is))
      enddo
      rdummy=rdummy*RYD/dble(ns)
      write(s1,102)rdummy
      write(6,220)TRUNC(s1)
    endif

!------------------------
! Write exchange-correlation potential file

    SAFE_ALLOCATE(data_buf, (ng, ns))
    
    if (peinf%inode.eq.0) then
      write(6,813) TRUNC(vxcg_output_file)
      sheader = 'VXC'
      iflavor = 0
      call write_binary_header(10, sheader, iflavor, ns, ng, nsymc, &
        cell_symmetry, na, nk, nbnum, ngkmax, ecutrho, ecutwfn, FFTgrid, &
        kgrid, kshift, celvol, al, a, adot, recvol, bl, b, bdot, &
        rotc, tauc, as, ap, ngk, kw, kpt, ifmin, ifmax, en, occ)
      call write_binary_gvectors(10, ng, ng, gvec)
      do is=1,ns
        do ig=1,ng
          data_buf(ig,is) = SCALARIFY(vxc(ig,is))
        enddo
      enddo
      call write_binary_data(10, ng, ng, ns, data_buf)
    endif
    
    SAFE_DEALLOCATE(data_buf)
    SAFE_DEALLOCATE(vxc)
    if (fparafft) then
      SAFE_DEALLOCATE(vxc_buf)
      SAFE_DEALLOCATE(vxc_d)
    endif
    
    call timacc(7,2)
    
  endif ! vxcg_flag
  
  call timacc(2,1)
  
!------------------------
! Done FFT

  if (fparafft) then
    SAFE_DEALLOCATE(crod)
    SAFE_DEALLOCATE(csph)
    SAFE_DEALLOCATE(drod)
    SAFE_DEALLOCATE(dsph)
    SAFE_DEALLOCATE(irod)
    SAFE_DEALLOCATE(isph)
    SAFE_DEALLOCATE(buffer_rod)
    SAFE_DEALLOCATE(buffer_sph)
    SAFE_DEALLOCATE_P(fftbox_2D)
    SAFE_DEALLOCATE(fftbox_1D)
    SAFE_DEALLOCATE(buffer_2D)
    SAFE_DEALLOCATE(buffer_1D)
  else
    SAFE_DEALLOCATE(inv_indx)
    SAFE_DEALLOCATE_P(fftbox_3D)
  endif

  call destroy_fftw_plans()

!------------------------
! Close files

  if (peinf%inode.eq.0) then
    call close_file(8)
  endif
  
  if (rhog_flag.and.peinf%inode.eq.0) then
    call close_file(9)
  endif
  
  if (vxcg_flag.and.peinf%inode.eq.0) then
    call close_file(10)
  endif

!------------------------
! Deallocate remaining arrays

  SAFE_DEALLOCATE_P(kw)
  SAFE_DEALLOCATE_P(kpt)
  SAFE_DEALLOCATE_P(en)
  SAFE_DEALLOCATE_P(occ)
  SAFE_DEALLOCATE_P(ifmin)
  SAFE_DEALLOCATE_P(ifmax)
  SAFE_DEALLOCATE_P(ngk)
  SAFE_DEALLOCATE_P(as)
  SAFE_DEALLOCATE_P(ap)
  SAFE_DEALLOCATE_P(ap_lat)
  SAFE_DEALLOCATE(gvec)
  SAFE_DEALLOCATE(isort)
  
  call timacc(2,2)
  
  call timacc(1,2)

!------------------------
! Time Accounting

  routnam(1)='TOTAL:'
  routnam(2)='INIT:'
  routnam(3)='G-SPACE:'
  routnam(4)='INPUT:'
  routnam(5)='FFT:'
#ifdef CPLX
  routnam(6)='WFN_NORM:'
#else
  routnam(6)='WFN_REAL:'
#endif
  routnam(7)='OUTPUT:'
  
  if(peinf%inode.eq.0) then
    write(6,9000)
    do i=2,7
      call timacc(i,3,tsec,ncount)
      write(6,9001) routnam(i),tsec(1),tsec(2),ncount
    enddo
    write(6,*)
    call timacc(1,3,tsec,ncount)
    write(6,9002) routnam(1),tsec(1),tsec(2)
    write(6,*)
9000 format(/,22x,"CPU [s]",8x,"WALL [s]",11x,"#",/)
9001 format(a16,f13.3,3x,f13.3,3x,i9)
9002 format(a16,f13.3,3x,f13.3)
  endif

!------------------------
! Finish

#ifdef MPI
  call MPI_Finalize(mpierr)
#endif

101 format(i16)
102 format(f16.6)
103 format(a)

110 format(1x,'nsym =',1x,a,2x,'nk =',1x,a,2x,'ns =',1x,a,2x,'nb =', &
      1x,a,2x,'ng =',1x,a,2x,'ngkmax =',1x,a)
120 format(1x,'ng_l =',1x,a,2x,'ng_g =',1x,a,2x,'ngk_l =',1x,a,2x, &
      'ngk_g =',1x,a)
130 format(1x,'FFTgrid =',1x,'(',1x,a,1x,a,1x,a,1x,')',2x,'nFFTgridpts =',1x,a)
140 format(1x,'nbmin =',1x,a,2x,'nbmax =',1x,a,2x,'nbnum =',1x,a,/)
  
210 format(1x,'rho(G = 0) =',1x,a,1x,'renormalized to',1x,a,/)
211 format(1x,'rho(G = 0) =',1x,a,/)
220 format(1x,'Vxc(G = 0) =',1x,a,1x,'eV'/)
  
701 format(/,1x,'WARNING: kgrid is set to zero in the wavefunction file', &
      /,10x,'this could lead to problems in Sigma and absorption',/)
702 format(/,1x,'WARNING: an energy window is incompatible with a range of bands',/)
  
801 format(1x,'Reading parameters from file',1x,a,/)
802 format(1x,'Reading SIESTA file',1x,a,/)
803 format(1x,'Reading SIESTA wavefunction from file',1x,a)
804 format(1x,'Performing parallel FFT from R-space to G-space')
805 format(1x,'Performing serial FFT from R-space to G-space')
806 format(1x,'Normalizing wavefunctions in G-space',/)
807 format(1x,'Constructing real wavefunctions in G-space',/)
808 format(1x,'Writing wavefunctions to file',1x,a,/)
809 format(1x,'Reading SIESTA charge density from file',1x,a)
810 format(1x,'Writing charge density to file',1x,a,/)
811 format(1x,'Reading SIESTA total potential from file',1x,a)
812 format(1x,'Reading SIESTA electrostatic potential from file',1x,a)
813 format(1x,'Writing exchange-correlation potential to file',1x,a,/)
  
end program SIESTA

#include "f_defs.h"

!*************************************************************************
Module NormalizeMod
!*************************************************************************

  use push_pop_m
  implicit none

  contains

!*************************************************************************
  Subroutine EigenStatesOrth( eigenStates, iBand, kPoint )
!*************************************************************************

!   This Subroutine orthonormalizes the starting vector for iBand against
!   all the lower bands.

    use EigenStatesMod, only : eigenStatesT

    integer, intent(in) :: iBand, kPoint
    type(eigenStatesT), pointer :: eigenStates

    PUSH_SUB(EigenStatesOrth)

    ! Orthogonalize to all the LOWER bands
    Call LowerBandOrthogonalize( eigenStates, &
        & eigenStates%eigenVectors( :, iBand, kPoint ), iBand, kPoint )

    ! Normalize the state-vector
    Call VecNormalize( eigenStates%eigenvectors( :, iBand, kPoint ))

!    print *, 'OrthStartVec:',eigenStates%eigenvectors(:,iBand)

    POP_SUB(EigenStatesOrth)
  end Subroutine EigenStatesOrth

!*************************************************************************
  Subroutine LowerBandOrthogonalize( eigenStates, vector, iBand, kPoint)
!*************************************************************************

!   This Subroutine Orthogonalizes the vector corresponding to iBand against 
!   all the bands (in eigenStates) below iBand.

    use SysParams, only : double
    use EigenStatesMod, only : eigenStatesT

    type( eigenStatesT ), pointer :: eigenStates
    complex( double ), intent( inout ) :: vector(:)
    integer, intent( in ) :: iBand, kPoint
    
    integer :: jBand
    complex( double ) :: orthfac

    PUSH_SUB(LowerBandOrthogonalize)

    do jBand = 1, iBand-1

       !    Calculate the orthogonalising factor for the j th band wrt 
       ! the i th band.
       orthfac = Dot_Product( &
               & eigenStates%eigenvectors( :, jBand, kPoint), vector)

       !   Calculate the Orthogonalising vector between i and j bands
       vector = vector - orthfac * eigenStates%eigenvectors( :, jband, kPoint)
          
    end do
    
    vector(eigenStates%hSize+1:eigenStates%hDim) = cmplx(0.d0,0.d0,kind=double)

    POP_SUB(LowerBandOrthogonalize)
  end Subroutine LowerBandOrthogonalize

!*************************************************************************
  Subroutine VecNormalize( vector )
!*************************************************************************

!   This Subroutine normalizes vector

    use SysParams, only : double

    complex( double ), intent( inout ) :: vector(:)
    real( double ) :: norm

    PUSH_SUB(VecNormalize)

    norm = Dot_Product( vector, vector )
    norm = sqrt( norm ) + 1.d-32
    vector = vector / norm

    POP_SUB(VecNormalize)
  end Subroutine VecNormalize

!*************************************************************************
  Subroutine SelfBandOrthogonalize( eigenStates, vector, iBand, kPoint )
!*************************************************************************

!   This Subroutine orthogonalizes the vector corresponding to iBand, against
!   the state-vector iBand contained in eigenStates.

    use EigenStatesMod, only : eigenStatesT
    use SysParams, only : double

    integer, intent( in ) :: iBand, kPoint
    type( eigenStatesT ), pointer :: eigenStates
    complex( double ), dimension(:) :: vector
    complex( double ) :: orthfac

    PUSH_SUB(SelfBandOrthogonalize)

    orthfac = Dot_Product( eigenStates%eigenvectors( :, iBand, kPoint ), vector )

    vector = vector - orthfac * eigenStates%eigenvectors( :, iBand, kPoint )
       
    vector(eigenStates%hSize+1:eigenStates%hDim) = cmplx(0.d0,0.d0,kind=double)

    POP_SUB(SelfBandOrthogonalize)
  end Subroutine SelfBandOrthogonalize

!*************************************************************************
  Subroutine BandOrthogonalize( eigenStates, vector, iBand, kPoint )
!*************************************************************************

!   This Subroutine orthogonalizes the vector corresponding to iBand against
!   all the bands below and including iBand.

    use SysParams, only : double
    use EigenStatesMod, only : eigenStatesT

    integer, intent(in) :: iBand, kPoint
    type(eigenStatest), pointer :: eigenStates
    complex( double ), dimension(:) :: vector

    PUSH_SUB(BandOrthogonalize)

    ! First Orthogonalize against iBand
    Call SelfBandOrthogonalize( eigenStates, vector, iBand, kPoint )

    ! Next Orthogonalize that against all the lower bands
    Call LowerBandOrthogonalize( eigenStates, vector, iBand, kPoint )

    POP_SUB(BandOrthogonalize)
  end Subroutine BandOrthogonalize

end Module NormalizeMod

!===============================================================================
!
! Modules:
!
! inread_common_m   Originally By FHJ
!
!   A first attempt to unity the inread routines. Right now, this module
!   only implements consistency checks and warning/error messages.
!
!===============================================================================

#include "f_defs.h"

module inread_common_m

  use global_m
  implicit none

  private

  public ::                  &
    check_bounds_nkq,        &
    check_bounds_nbands,     &
    check_consistency_nbands

contains


  !> FHJ: Makes sure the number of {q,k}-points is less than MAX_KPTS.
  !! Call this subroutine just after you read the keyword `number_{k,q}-points`.
  subroutine check_bounds_nkq(nkq, k_or_q, keyword)
    !> Number of {k,q}-points expected to be read (eg, pol%nq)
    integer, intent(in) :: nkq
    character(len=1), intent(in) :: k_or_q !< Either "k" or "q"
    character(len=*), intent(in) :: keyword !< a keyword, such as `number_qpoints`

    PUSH_SUB(check_bounds_nkq)

    if (nkq>MAX_KPTS) then
      write(0,*)
      write(0,'(/,a)') 'ERROR: The number of '//&
        k_or_q//'-points specified in the keyword `'//keyword//'` is '
      write(0,'(a,i0)') ' larger than the maximum: MAX_KPTS=',MAX_KPTS
      write(0,'(a,/)') ' Either use less '//&
        k_or_q//'-points or increase MAX_KPTS in Common/nrtype.f90'
      write(0,*)
      call die('Too many '//k_or_q//'-points. Increase MAX_KPTS in Common/nrtypes.f90.')
    endif

    POP_SUB(check_bounds_nkq)

  end subroutine check_bounds_nkq

  !> FHJ: Makes sure nb<MAX_BANDS
  !! Call this subroutine just after you read the keyword `number_bands`.
  subroutine check_bounds_nbands(nb, keyword)
    integer, intent(in) :: nb
    character(len=*), intent(in) :: keyword !< a keyword, such as `number_qpoints`

    PUSH_SUB(check_bounds_nbands)

    if(nb>MAX_BANDS) then
      write(0,*)
      write(0,'(a)') 'ERROR: The number of bands specified in the keyword `'//keyword//'` is larger '
      write(0,'(a,i0)') ' than the maximum: MAX_BANDS=',MAX_BANDS
      write(0,'(a)') ' Either use less bands or increase MAX_BANDS in Common/nrtype.f90'
      write(0,*)
      call die("Too many bands. Increase MAX_BANDS in Common/nrtypes.f90.")
    endif

    POP_SUB(check_bounds_nbands)

  end subroutine check_bounds_nbands


  !> FHJ: Makes sure nb<MAX_BANDS and that nb!=0 if the keyword is required.
  !! Call this after you parse the whole input file.
  subroutine check_consistency_nbands(nb, is_required)
    integer, intent(in) :: nb !< number of bands
    logical, intent(in) :: is_required !< dies if nb==0

    PUSH_SUB(check_consistency_nbands)
    
    if (peinf%inode>0) then
      POP_SUB(check_consistency_nbands)
      return
    endif

    if(is_required .and. nb<1) then
      call die("The keyword `number_bands` could not be found.", only_root_writes = .true.)
    endif

    call check_bounds_nbands(nb, 'number_bands')

    POP_SUB(check_consistency_nbands)

  end subroutine check_consistency_nbands

end module inread_common_m

!==============================================================================
!
! Routines()
!
! (1) write_xct_dens()       By PWD         Last Modified PWD 4/19/2014
!        from write_xct() Originally By MLT       
!
!     Writes excited states density.
!
!=============================================================================

#include "f_defs.h"

module write_xct_dens_m

  use global_m
  use plotxct_common_m

  implicit none

  private

  public :: write_xct_dens

contains

subroutine write_xct_dens(pxct, crys, nfft, typeS, scfft)
  type(plotxct_t), intent(in) :: pxct
  type(crystal), intent(in) :: crys
  integer, intent(in) :: nfft(3)
  character (len=*), intent(in) :: typeS
  complex(DPC), intent(inout) :: scfft(:,:,:,:) !< (xctstate,nw_eff(1),nw_eff(2) ! nw_eff(3))
  
  integer :: ixct,i1,i2,i3
  integer :: nw(3) 
  character :: fn*30
  real(DP) :: rh_a0(3), int_val

  PUSH_SUB(write_xct_dens)
  
  nw(:) = nfft(:) * pxct%nsuper(:)
  !nw_eff = (nw + pxct%subsample - 1) / pxct%subsample

  
!-----------------------------
! Print output data

  do ixct = pxct%pstateLow-pxct%offset,pxct%pstateHigh-pxct%offset

  write(fn,'(a,i6.6,a,i1.1,a,a,a)') 'xct.', ixct+pxct%offset, '_s', pxct%ispin, '_t', typeS, '.a3Dr'
  
  write(6,'(a,a,a,3i8)') 'Writing data set to "', trim(fn), '" with nw = ',nw(:)
  
  call open_file(30,file=fn,form='formatted',status='replace')
  
  write(30, '(a,i6)') '# ie = ', ixct+pxct%offset
  write(30, '(a,f12.4,a)') '# e  = ', pxct%e_Ses(ixct), ' eV'
  write(30, '(a,3f14.6,a)') '# rh = ', 0,0,0, ' Bohr'
  write(30, '(a,i1)') '# spin = ', pxct%ispin
  write(30, '(a)') '#'
  write(30, '(a)') '# unit cell'
  write(30, '(a,3f14.6,a)') '# a1 = ', pxct%nsuper(1) * crys%avec(1:3,1) * crys%alat, ' Bohr'
  write(30, '(a,3f14.6,a)') '# a2 = ', pxct%nsuper(2) * crys%avec(1:3,2) * crys%alat, ' Bohr'
  write(30, '(a,3f14.6,a)') '# a3 = ', pxct%nsuper(3) * crys%avec(1:3,3) * crys%alat, ' Bohr'
  write(30, '(a)') '#'
  ! only write 1/8 = (1/2)^3 of the full data to save disk space
  write(30, '(a,3i8)') '# ni = ', nw(:)
  write(30, '(a)') '#'
  write(30, '(a)') '#    real         imag        abs^2'

  if(.not.any(pxct%int_dim)) then
    !FHJ : Not integrating dimensions, so nw_int = nw_eff.

      do i3 = 1, nw(3)
        do i2 = 1, nw(2)
          do i1 = 1, nw(1)
            write(30, '(3es13.5)') scfft(ixct,i1, i2, i3),ABS2(scfft(ixct,i1, i2, i3))
          enddo
          write(30,*)
        enddo
        write(30,*)
      enddo

  endif
  
  call close_file(30)
  end do

  POP_SUB(write_xct_dens)
  
  return
end subroutine write_xct_dens

end module write_xct_dens_m

!==================================================================================
!
! Routines:
!
! (1) distrib_kernel()       Originally By MLT    Last Modified 01/10/2013 (FHJ)
!
!      nv = # of valence bands
!      nc = # of conduction bands
!      nk = # of k-points
!      np = # of MPI processes
!
! ! TODO: full_kernel calculations only works with parallelization over k^2
!
!==============================================================================

#include "f_defs.h"

subroutine distrib_kernel(xct,ng,kg,kgq,gvec)

  use global_m
  use fftw_m
  use misc_m
  use createpools_m
  implicit none

  type (xctinfo), intent(inout) :: xct
  integer, intent(in) :: ng
  type (grid), intent(in) :: kg
  type (grid), intent(in) :: kgq !< this is only for the not-working finite-q kernel
  type (gspace), intent(inout) :: gvec

  integer :: npools,ipool,ipoolrank,iholdperown
  integer :: nproc, nown, npown
  integer :: ik,ikp,kvp,jcp,iownmax,iownwfmax,iownkmax
  integer :: ii,kv,jc,ipe,ierr,npes_over_2nkpt2
  integer :: ijk,nv,nc,nq
  integer :: Nrod,Nplane,Nfft(3),dNfft(3),dkmax(3),nmpinode
  integer :: cmax,vmax
  real(DP) :: mem,rmem,rmem2,rmemtemp1,rmemtemp2
  real(DP) :: scale,dscale
  character*128 :: tmpstr
  character*16 :: tmpstr1,tmpstr2,tmpstr3,tmpstr4
  integer, allocatable :: iown(:)

  PUSH_SUB(distrib_kernel)
      
!-----------------------------
! Determine the Parallelization Scheme

  npes_over_2nkpt2 = peinf%npes/(2*(xct%nkpt_co)**2)

  if (npes_over_2nkpt2 .ge. xct%ncb_co**2 .or. xct%ilowmem .eq. 1) then
    xct%ivpar = 1
    xct%icpar = 1
    
    ! JIM: integer division can be done in two steps
    !      this prevents overflow of nkpt**2*ncband**2
    !      and subsequent error in computing nproc
    nproc = peinf%npes/xct%nkpt_co**2
    nproc = nproc/xct%ncb_co**2
    
    if (nproc .eq. 0) then
      npools = 0
    else
      call createpools(xct%nvb_co,xct%nvb_co,nproc,npools,nown,npown)
    endif

    peinf%nck = (xct%nkpt_co*xct%ncb_co*xct%nvb_co)**2
    tmpstr = '(nkcv)^2'
    if (peinf%inode .eq. 0) write(6,*) "Parallelizing over (k,c,v)^2"
  else if (peinf%npes .ge. 2*(xct%nkpt_co)**2) then
    !
    ! FHJ: There is a bug in the parallelization over (k,c)^2, so it`s
    ! disabled for now.
    !
    !xct%ivpar = 0
    !xct%icpar = 1
    !nproc = peinf%npes/(xct%nkpt_co**2)
    !
    !call createpools(xct%ncb_co,xct%ncb_co,nproc,npools,nown,npown)
    !
    !peinf%nck = (xct%nkpt_co*xct%ncb_co)**2
    !tmpstr = '(nkc)^2'
    !if (peinf%inode .eq. 0) write(6,*) "Parallelizing over (k,c)^2"

    xct%ivpar = 1
    xct%icpar = 1
    
    ! JIM: integer division can be done in two steps
    !      this prevents overflow of nkpt**2*ncband**2
    !      and subsequent error in computing nproc
    nproc = peinf%npes/xct%nkpt_co**2
    nproc = nproc/xct%ncb_co**2
    
    if (nproc .eq. 0) then
      npools = 0
    else
      call createpools(xct%nvb_co,xct%nvb_co,nproc,npools,nown,npown)
    endif

    peinf%nck = (xct%nkpt_co*xct%ncb_co*xct%nvb_co)**2
    tmpstr = '(nkcv)^2'
    if (peinf%inode .eq. 0) write(6,*) "Parallelizing over (k,c,v)^2"

  else
    xct%ivpar = 0
    xct%icpar = 0
    nproc = peinf%npes
    
    call createpools(xct%nkpt_co,xct%nkpt_co,nproc,npools,nown,npown)

    peinf%nck = (xct%nkpt_co)**2
    tmpstr = '(nk)^2'
    if (peinf%inode .eq. 0) write(6,*) "Parallelizing over (k)^2"
  endif

  if (xct%extended_kernel.and.(xct%ivpar/=0.or.xct%icpar/=0)) then
    write(0,'(a)') 'Can only run extended kernel calculation with parallelization over (k)^2.'
    write(0,'(a)') 'For now, please make sure #proc <= nk^2.'
    call die('Extended kernel calculation requires parallelization over (k)^2.', &
      only_root_writes=.true.)
  endif
  
  if (npools .eq. 0) then
    if (mod((xct%nkpt_co*xct%ncb_co*xct%nvb_co)**2,peinf%npes).eq.0) then
      peinf%nckpe = (xct%nkpt_co*xct%ncb_co*xct%nvb_co)**2 / peinf%npes
    else
      peinf%nckpe = (xct%nkpt_co*xct%ncb_co*xct%nvb_co)**2 / peinf%npes + 1
    endif
  else
    peinf%nckpe = nown * npown
  endif
  
  if (peinf%inode .eq. 0) then
    if (xct%ilowmem==-1) then
      write(6,'(1x,a)') 'We will reuse wavefunction FFTs.'
    else
      write(6,'(1x,a)') 'We will not reuse wavefunction FFTs.'
    endif
    if (npools .eq. 0) then
      tmpstr = "Using Low Memory Option"
    else
      write(tmpstr1,'(i10)') nproc
      write(tmpstr2,'(i10)') npools
      write(tmpstr3,'(i10)') nown
      write(tmpstr4,'(i10)') npown
      tmpstr = "Using pools:  nproc = " // TRUNC(tmpstr1) // &
        "  npool = " // TRUNC(tmpstr2) // "  nown = " // &
        TRUNC(tmpstr3) // "  npown = " // TRUNC(tmpstr4)
    endif
    write(6,*) tmpstr
  endif

!---------------------------------
! Determine if the conditions for a decent load-balancing are met

  if (mod(peinf%nck,peinf%npes).ne.0) then
    if(peinf%inode.eq.0) then
      write(0,993) TRUNC(tmpstr),peinf%nck,peinf%npes
    endif
  endif
993 format(/,1x,'WARNING:',1x,a,1x,"=",i8,/, &
      8x,'is not a multiple of the number of PEs =',i6,/, &
      8x,'Optimal load-balancing cannot be achieved.')

!---------------------------------

  SAFE_ALLOCATE(peinf%ik, (peinf%npes,peinf%nckpe))
  SAFE_ALLOCATE(peinf%ic, (peinf%npes,peinf%nckpe))
  SAFE_ALLOCATE(peinf%iv, (peinf%npes,peinf%nckpe))
  SAFE_ALLOCATE(peinf%ikp, (peinf%npes,peinf%nckpe))
  SAFE_ALLOCATE(peinf%icp, (peinf%npes,peinf%nckpe))
  SAFE_ALLOCATE(peinf%ivp, (peinf%npes,peinf%nckpe))
  SAFE_ALLOCATE(peinf%ipev, (peinf%npes,xct%nvb_co,xct%nkpt_co))
  SAFE_ALLOCATE(peinf%ipec, (peinf%npes,xct%ncb_co,xct%nkpt_co))
  SAFE_ALLOCATE(peinf%ipek, (peinf%npes,xct%nkpt_co))
  
  SAFE_ALLOCATE(iown, (peinf%npes))
  SAFE_ALLOCATE(peinf%iownwfv, (peinf%npes))
  SAFE_ALLOCATE(peinf%iownwfc, (peinf%npes))
  SAFE_ALLOCATE(peinf%iownwfk, (peinf%npes))
  
  if (xct%ivpar .eq. 1) then
    SAFE_ALLOCATE(peinf%wown, (xct%nvb_co,xct%ncb_co,xct%nkpt_co,xct%nvb_co,xct%ncb_co,xct%nkpt_co))
  else if (xct%icpar .eq. 1) then
    SAFE_ALLOCATE(peinf%wown, (1,xct%ncb_co,xct%nkpt_co, 1,xct%ncb_co,xct%nkpt_co))
  else
    SAFE_ALLOCATE(peinf%wown, (1,1,xct%nkpt_co,1,1,xct%nkpt_co))
  endif

  peinf%ik=0
  peinf%ic=0
  peinf%iv=0
  peinf%ikp=0
  peinf%icp=0
  peinf%ivp=0
  peinf%ipev=0
  peinf%ipec=0
  peinf%ipek=0
  peinf%iownwfv=0
  peinf%iownwfc=0
  peinf%iownwfk=0
  peinf%wown=0
  
  ipe=0
  iown=0
  
  if (xct%ivpar .eq. 1) then
    iholdperown = 1
  else if (xct%icpar .eq. 1) then
    !FHJ: Note: this is not supported for full kernel calculations
    iholdperown = (xct%n1b_co)**2
  else
    iholdperown = (xct%n1b_co*xct%n2b_co)**2
  endif

  if (xct%ivpar .eq. 1 .or. npools .eq. 0) then
    vmax=xct%nvb_co
  else
    vmax=1
  endif

  if (xct%icpar .eq. 1 .or. npools .eq. 0) then
    cmax=xct%ncb_co
  else
    cmax=1
  endif 

  peinf%mypown = 0 

  !FHJ: This is the distribution of the WFNs. It is exactly the same for 
  ! full_kernel calculations *if* we parallelizing over k^2.

  do ikp=1,xct%nkpt_co
    do ik=1,xct%nkpt_co
      do jcp=1,cmax
        do jc=1,cmax
          do kvp=1,vmax
            do kv=1,vmax
              
              if (npools .eq. 0) then
                ipe = mod((((ik-1)*xct%nkpt_co+(ikp-1))*xct%ncb_co**2 &
                  +(jc-1)*xct%ncb_co+(jcp-1))*xct%nvb_co**2 &
                  +(kv-1)*xct%nvb_co+(kvp-1),peinf%npes)
              elseif (xct%icpar .ne. 1) then
                ipoolrank = (ik-1)/(npown)
                ipool = (ikp-1)/(nown)
                ipe = ipool*(nproc/npools)+ipoolrank
              else if (xct%ivpar .ne. 1) then
                ipoolrank = (jc-1)/(npown)
                ipool = (jcp-1)/(nown)
                ipe = ipool*(nproc/npools)+ipoolrank &
                  +((ik-1)*xct%nkpt_co+(ikp-1))*nproc
              else
                ipoolrank = (kv-1)/(npown)
                ipool = (kvp-1)/(nown)
                ipe = ipool*(nproc/npools)+ipoolrank &
                  +(((ik-1)*xct%nkpt_co+(ikp-1))*xct%ncb_co**2 &
                  +(jc-1)*xct%ncb_co+(jcp-1))*nproc
              endif
              
              ipe = ipe + 1
              
              if ((xct%ivpar .eq. 1 .or. (kv .eq. 1 .and. kvp .eq. 1)) .and. &
                (xct%icpar .eq. 1 .or. (jc .eq. 1 .and. jcp .eq. 1))) then
                iown(ipe)=iown(ipe)+1
                if (npools>0 .and. ipe==peinf%inode+1) then
                  if (xct%ivpar .eq. 1) then
                    if ((mod(kvp,nown) .eq. 1 .or. nown .eq. 1) .and. ik .eq. 1 &
                     .and. ikp .eq. 1 .and. jc .eq. 1 .and. jcp .eq. 1) then 
                      peinf%mypown = peinf%mypown + 1
                    endif
                  else if (xct%icpar .eq. 1) then
                    if ((mod(jcp,nown) .eq. 1 .or. nown .eq. 1) .and. ik .eq. 1 .and. ikp .eq. 1) then
                      peinf%mypown = peinf%mypown + 1
                    endif
                  else if ((mod(ikp,nown) .eq. 1 .or. nown .eq. 1)) then
                    peinf%mypown = peinf%mypown + 1
                  endif
                endif
                if (ipe==peinf%inode+1) then
                  if (xct%ivpar .eq. 1) then
                    peinf%wown(kvp,jcp,ikp,kv,jc,ik) = (iown(ipe)-1) * iholdperown + 1
                  else if (xct%icpar .eq. 1) then
                    peinf%wown(1,jcp,ikp,1,jc,ik) = (iown(ipe)-1) * iholdperown + 1
                  else
                    peinf%wown(1,1,ikp,1,1,ik) = (iown(ipe)-1) * iholdperown + 1
                  endif
                endif
                peinf%iv(ipe,iown(ipe)) = kv
                peinf%ivp(ipe,iown(ipe)) = kvp
                peinf%ic(ipe,iown(ipe)) = jc
                peinf%icp(ipe,iown(ipe)) = jcp
                peinf%ik(ipe,iown(ipe)) = ik
                peinf%ikp(ipe,iown(ipe)) = ikp
              endif
              
              if (peinf%ipec(ipe,jc,kg%indr(ik)).eq.0) then
                if (xct%icpar .eq. 1) then
                  peinf%iownwfc(ipe)=peinf%iownwfc(ipe)+1
                  peinf%ipec(ipe,jc,kg%indr(ik))=peinf%iownwfc(ipe)
                else if (jc .eq. 1) then
                  do ijk =1, xct%ncb_co
                    peinf%ipec(ipe,ijk,kg%indr(ik))=peinf%iownwfc(ipe)+ijk
                  enddo
                  peinf%iownwfc(ipe)=peinf%iownwfc(ipe)+xct%ncb_co
                endif
              endif
              
              if (peinf%ipec(ipe,jcp,kg%indr(ikp)).eq.0) then
                if (xct%icpar .eq. 1) then
                  peinf%iownwfc(ipe)=peinf%iownwfc(ipe)+1
                  peinf%ipec(ipe,jcp,kg%indr(ikp))=peinf%iownwfc(ipe)
                else if (jcp .eq. 1) then
                  do ijk =1, xct%ncb_co
                    peinf%ipec(ipe,ijk,kg%indr(ikp))=peinf%iownwfc(ipe)+ijk
                  enddo
                  peinf%iownwfc(ipe)=peinf%iownwfc(ipe)+xct%ncb_co
                endif
              endif
              
              if (peinf%ipev(ipe,kv,kgq%indr(ik)).eq.0) then
                if (xct%ivpar .eq. 1) then
                  peinf%iownwfv(ipe)=peinf%iownwfv(ipe)+1
                  peinf%ipev(ipe,kv,kgq%indr(ik))=peinf%iownwfv(ipe)
                else if (kv .eq. 1) then
                  do ijk =1, xct%nvb_co
                    peinf%ipev(ipe,ijk,kg%indr(ik))=peinf%iownwfv(ipe)+ijk
                  enddo
                  peinf%iownwfv(ipe)=peinf%iownwfv(ipe)+xct%nvb_co
                endif
              endif
              
              if (peinf%ipev(ipe,kvp,kgq%indr(ikp)).eq.0) then
                if (xct%ivpar .eq. 1) then
                  peinf%iownwfv(ipe)=peinf%iownwfv(ipe)+1
                  peinf%ipev(ipe,kvp,kgq%indr(ikp))=peinf%iownwfv(ipe)
                else if (kvp .eq. 1) then
                  do ijk =1, xct%nvb_co
                    peinf%ipev(ipe,ijk,kg%indr(ikp))=peinf%iownwfv(ipe)+ijk
                  enddo
                  peinf%iownwfv(ipe)=peinf%iownwfv(ipe)+xct%nvb_co
                endif
              endif
              
              if (peinf%ipek(ipe,kgq%indr(ik)).eq.0) then
                peinf%iownwfk(ipe)=peinf%iownwfk(ipe)+1
                peinf%ipek(ipe,kgq%indr(ik))=peinf%iownwfk(ipe)
              endif
              
              if (peinf%ipek(ipe,kgq%indr(ikp)).eq.0) then
                peinf%iownwfk(ipe)=peinf%iownwfk(ipe)+1
                peinf%ipek(ipe,kgq%indr(ikp))=peinf%iownwfk(ipe)
              endif
              
            enddo
          enddo
        enddo
      enddo
    enddo
  enddo

  if (npools .eq. 0) then
    !write(6,*) 'ds1',peinf%inode,peinf%mypown,peinf%npown,peinf%nckpe
    peinf%mypown = 1
    peinf%npown = 1
  else
    !write(6,*) 'ds2',peinf%inode,peinf%mypown,peinf%npown,peinf%nckpe
    peinf%npown = npown
  endif

!---------------------------------
! Calculate Max of iown and iownwf Their Memory Cost

  iownmax = 0
  iownwfmax = 0
  iownkmax = 0

  do ii=1,peinf%npes
    if (iown(ii) .gt. iownmax) iownmax = iown(ii)
    if ((peinf%iownwfv(ii) + peinf%iownwfc(ii)) .gt. iownwfmax) &
      iownwfmax = (peinf%iownwfc(ii)+peinf%iownwfv(ii))
  enddo
  
  do ii=1,peinf%npes
    if (peinf%iownwfk(ii) .gt. iownkmax) iownkmax = peinf%iownwfk(ii)
  enddo
  
  peinf%myown = iown(peinf%inode + 1)
  
  if (iownmax .ne. peinf%nckpe) then
    write(tmpstr1,'(i10)') peinf%nckpe
    write(tmpstr2,'(i10)') iownmax
    tmpstr = 'nckpe estimate wrong, nckpe = ' // &
      TRUNC(tmpstr1) // ', iownmax = ' // TRUNC(tmpstr2)
    call die(tmpstr)
  endif

  SAFE_DEALLOCATE(iown)

!---------------------------------
! Determine the available memory

  call procmem(mem,nmpinode)
  if (peinf%inode .eq. 0) then
    write(6,998) mem/1024.0d0**2
  endif
998 format(/,1x,'Memory available:',f10.1,1x,'MB per PE')
  
!---------------------------------
! JRD: Report Memory

  if (peinf%inode .eq. 0) then

    call open_file(11,file='epsmat',form='unformatted',status='old',iostat=ierr)
    if (ierr.eq.0) then
      read(11)
      read(11)
      read(11)
      read(11)
      read(11)
      read(11)
      read(11)
      read(11) nq
      nq=nq+1
      call close_file(11)
    else
      nq=1
    endif

    rmem=0D0

! Storing epsilon
    if (xct%bLowComm) then
      rmem=rmem+dble(xct%neps*xct%neps*nq)
      !write(6,*) "Epsilon Low Comm", dble(xct%neps*xct%neps*nq)
    else
      rmem=rmem+dble(xct%neps*xct%neps*nq/peinf%npes)
      !write(6,*) "Epsilon Low Comm", dble(xct%neps*xct%neps*nq/peinf%npes)
    endif
! Storing intwfnv and intwfnc and wfnv wnfc wfnvp wfncp
    rmem=rmem+dble(iownwfmax+4)*dble(ng)
    !write(6,*) "intwfn etc...", dble(iownwfmax+4)*dble(ng)
! Storing bsemats
    rmem=rmem+4D0*dble(iownmax)*dble(iholdperown)
    !write(6,*) "bsemats", 4D0*dble(iownmax)*dble(iholdperown)
! Storing bsemat write temp arrays
    rmem=rmem+8D0*dble(xct%n1b_co*xct%n2b_co*xct%nkpt_co)
    ! FHJ: this is probablly an overshot for full_kernel
    nv=xct%n1b_co
    nc=xct%n2b_co

! JRD: Since mvv,mcc,tempb,tempw etc.. are not allocated
! at the same time as mvc etc.. we see which one is bigger

    rmemtemp1=0D0
    rmemtemp2=0D0

! Note this assumes that bare coulomb cutoff is same as wf cutoff
! Storing tempw(_old), tempb(_old), note mvv is never
! allocated at same time as tempw_old or tempb_old. So, it 
! is neglibible.
    if (xct%ivpar .eq. 1) then
      rmemtemp1=rmemtemp1+4D0*dble(ng)
      !write(6,*) "tempb(w) +old", 4D0*dble(ng) 
    else ! no 
      rmemtemp1=rmemtemp1+4D0*dble(ng*nv*nv)
      !write(6,*) "tempb(w) +old", 4D0*dble(ng*nv*nv) 
    endif
! Storing mcc, mccold
    if (xct%icpar .eq. 1) then
      rmemtemp1=rmemtemp1+2D0*dble(ng)
      !write(6,*) "mcc +old", 2D0*dble(ng) 
    else ! no mccold in this case
      rmemtemp1=rmemtemp1+1D0*dble(ng*nc*nc)
      !write(6,*) "mcc -old", 1D0*dble(ng*nc*nc) 
    endif

! Storing mvc, mvpcp, mvcold, mvpcpold
    if (xct%ivpar .eq. 1 .and. xct%icpar .eq. 1) then
      rmemtemp2=rmemtemp2+4D0*dble(ng)
      !write(6,*) "mvc +old", 4D0*dble(ng) 
    else 
      rmemtemp2=rmemtemp2+2D0*dble(ng*nv*nc)
      !write(6,*) "mvc -old", 2D0*dble(ng*nv*nc) 
    endif

! outtemp in gx_sum
    rmemtemp2=rmemtemp2+dble(iholdperown)    

    if (rmemtemp1 .gt. rmemtemp2) then
      rmem = rmem + rmemtemp1
    else
      rmem = rmem + rmemtemp2
    endif

! FFTBOXES
    call setup_FFT_sizes(gvec%FFTgrid,Nfft,scale)
    rmem=rmem+2D0*dble(Nfft(1)*Nfft(2)*Nfft(3))

    rmem=rmem * sizeof_scalar()

! Storing intwfnc%isort intwfnv%isort
    rmem=rmem+dble(2*iownkmax*gvec%ng)*4D0
! Array gvec%index_vec in input_kernel
    rmem=rmem+dble(gvec%nFFTgridpts)*4.0d0

    write(6,989) rmem/1024.0d0**2
989 format(1x,'Memory required for execution:',f7.1,1x,'MB per PE')
  endif

!---------------------------------------------------------
! (gsm) Determine the amount of memory required for Vcoul

! random numbers
  rmem=0.0D0
! (gsm) We don`t do random numbers in kernel anymore
!      if (xct%icutv.ne.5) then
! arrays ran, qran, and qran2
! (ran is deallocated before qran2 is allocated)
!        rmem=rmem+6.0D0*dble(nmc)*8.0D0
!      endif
! various truncation schemes
  call setup_FFT_sizes(gvec%FFTgrid,Nfft,scale)
  rmem2=0.0d0
! cell wire truncation
  if (xct%icutv.eq.4) then
    dkmax(1) = gvec%FFTgrid(1) * n_in_wire
    dkmax(2) = gvec%FFTgrid(2) * n_in_wire
    dkmax(3) = 1
    call setup_FFT_sizes(dkmax,dNfft,dscale)
! array fftbox_2D
    rmem2=rmem2+dble(dNfft(1))*dble(dNfft(2))*16.0d0
! array inv_indx
    rmem2=rmem2+dble(Nfft(1))*dble(Nfft(2))*dble(Nfft(3))*4.0d0
! array qran
    rmem2=rmem2+3.0D0*dble(nmc)*8.0D0
  endif
! cell box truncation (parallel version only)
  if (xct%icutv.eq.5) then
    dkmax(1:3) = gvec%FFTgrid(1:3) * n_in_box
    call setup_FFT_sizes(dkmax,dNfft,dscale)
    if (mod(dNfft(3),peinf%npes) == 0) then
      Nplane = dNfft(3)/peinf%npes
    else
      Nplane = dNfft(3)/peinf%npes+1
    endif
    if (mod(dNfft(1)*dNfft(2),peinf%npes) == 0) then
      Nrod = (dNfft(1)*dNfft(2))/peinf%npes
    else
      Nrod = (dNfft(1)*dNfft(2))/peinf%npes+1
    endif
! array fftbox_2D
    rmem2=rmem2+dble(dNfft(1))*dble(dNfft(2))*dble(Nplane)*16.0d0
! array fftbox_1D
    rmem2=rmem2+dble(dNfft(3))*dble(Nrod)*16.0d0
! array dummy
!        rmem2=rmem2+dble(dNfft(1))*dble(dNfft(2))*16.0d0
! arrays dummy1 and dummy2
    rmem2=rmem2+dble(Nrod)*dble(peinf%npes+1)*16.0d0
! array inv_indx
    rmem2=rmem2+dble(Nfft(1))*dble(Nfft(2))*dble(Nfft(3))*4.0d0
  endif
  if (rmem2 .gt. rmem) rmem = rmem2
  if (peinf%inode .eq. 0) then
    write(6,988) rmem/1024.0d0**2
  endif
988 format(1x,'Memory required for vcoul:',f7.1,1x,'MB per PE')

!---------------------------------

  if (peinf%inode .eq. 0) then
    write(6,*) iownmax*iholdperown, ' elements per PE'
    write(6,*) iownwfmax, ' wavefunctions stored per PE'
    write(6,*) ng, ' G-vectors per wavefunction'
  endif

  POP_SUB(distrib_kernel)

  return
end subroutine distrib_kernel

!===============================================================================
!
! Routines:
!
! 1. checkbz()        Originally By gsm       Last Modified 7/29/2010 (gsm)
!
!    Check that the Brillouin Zone generated by subroutine fullbz is
!    identical to the original full Brillouin Zone. Subroutine fullbz
!    constructs the Brillouin Zone by unfolding the irreducible wedge
!    with all the symmetries of the space group of the crystal. If the
!    irreducible wedge has missing k-points (for example from using too
!    many symmetries in kgrid.x), the full Brillouin Zone will also have
!    missing k-points.
!
!    For the unshifted grid, fullbz generates the original full grid
!    from the irreducible wedge.
!
!    For the grid shifted by half a grid step, fullbz doubles the grid size.
!    For fcc-Si, (4 4 4 0.5 0.5 0.5) becomes (8 8 8 0.0 0.0 0.0) where half
!    the points uniformly distributed across the grid are missing.
!
!    For the randomly-shifted grid, if symmetries are allowed, fullbz
!    generates a non-uniform grid with the points clustered together.
!    You should never allow symmetries for the randomly-shifted grid.
!
!    For the grid shifted by half a grid step, checkbz would print "extra points"
!    warning message. There is nothing to worry about, so we set
!    allow_half_shift to .true. to suppress this warning message in this case.
!    However, if you see "missing points" warning message, it may indicate a
!    problem with your k-point sampling.
!
!===============================================================================

#include "f_defs.h"

module checkbz_m

  use global_m
  use misc_m
  implicit none

  private

  public :: checkbz

contains

subroutine checkbz(nfk,fk,kgrid,kshift,bdot, &
  filename,kqchar,wignerseitz,freplacebz,fwritebz)
  integer, intent(inout) :: nfk
  real(DP), intent(inout) :: fk(:,:) !< (3, nfk)
  integer, intent(in) :: kgrid(3)
  real(DP), intent(in) :: kshift(3)
  real(DP), intent(in) :: bdot(3,3)
  character(len=*), intent(in) :: filename
  character, intent(in) :: kqchar
  logical, intent(in) :: wignerseitz,freplacebz,fwritebz
  
  logical, parameter :: allow_half_shift = .true.
  
  logical :: f1,f2,f3,flag_half_shift
  integer :: ii,jj,i1,i2,i3,nk,gpt(3)
  real(DP) :: l1,l2,k1(3),k2(3),kpt(3)
  real(DP), allocatable :: kk(:,:)
  real(DP), allocatable :: kref(:,:)
  character(len=128) :: tmpstr
  
  PUSH_SUB(checkbz)

  if(size(fk, 1) /= 3) then
    write(0,*) 'size(fk, 1) = ', size(fk, 1)
    call die("checkbz internal error: fk must have first dimension = 3")
  endif
  if(size(fk, 2) /= nfk) then
    write(0,*) 'nfk = ', nfk, 'size(fk, 2) = ', size(fk, 2)
    call die("checkbz internal error: fk must have second dimension = nfk")
  endif

! Identify the grid type
! Print a warning message if the grid type is unknown
! FHJ: Is this really necessary?!

  kpt(:)=kshift(:)
  call k_range(kpt, gpt, TOL_Small)

  f1=.true.
  f2=.true.
  f3=.true.

  do ii=1,3
! FHJ: ignore dimensions that have only one kpt
    if (kpt(ii)<2) cycle
  ! the unshifted grid
    f1=f1.and.(abs(kpt(ii)).lt.TOL_Small)
  ! the grid shifted by half a grid step
    f2=f2.and.(abs(kpt(ii)-0.5d0).lt.TOL_Small)
  ! the randomly-shifted grid
    f3=f3.and.(abs(kpt(ii)).gt.TOL_Small.and. abs(kpt(1)-0.5d0).gt.TOL_Small)
  enddo


  if (.not.f1.and..not.f2.and..not.f3) then
    if (peinf%inode.eq.0) write(0,901) kqchar, trim(filename)
901 format(1x,"WARNING: checkbz: unknown",1x,a,"-grid type in",1x,a,/)
  endif
  
  flag_half_shift = f2
  
! Find the number of k-points in the full Brillouin Zone

  nk=product(kgrid(1:3))
  if (nk.le.0) then
    if (peinf%inode.eq.0) write(0,902) kqchar, trim(filename)
902 format(1x,"WARNING: checkbz: zero",1x,a,"-grid in",1x,a,/)
    POP_SUB(checkbz)
    return
  endif

! Allocate array for k-points in the full Brillouin Zone

  SAFE_ALLOCATE(kk, (3,nk))

! Construct k-points in the full Brillouin Zone

  ii=0
  do i1=0,kgrid(1)-1
    do i2=0,kgrid(2)-1
      do i3=0,kgrid(3)-1
        ii=ii+1
        kk(1,ii)=(dble(i1)+kshift(1))/dble(kgrid(1))
        kk(2,ii)=(dble(i2)+kshift(2))/dble(kgrid(2))
        kk(3,ii)=(dble(i3)+kshift(3))/dble(kgrid(3))
        call k_range(kk(:,ii), gpt, TOL_Small)
      enddo
    enddo
  enddo

! Construct a Wigner-Seitz box

  if (wignerseitz) then
    do ii=1,nk
      l2=INF
      do i1=-ncell+1,ncell
        k1(1)=kk(1,ii)-dble(i1)
        do i2=-ncell+1,ncell
          k1(2)=kk(2,ii)-dble(i2)
          do i3=-ncell+1,ncell
            k1(3)=kk(3,ii)-dble(i3)
            l1=DOT_PRODUCT(k1,MATMUL(bdot,k1))
            if (l1.lt.l2) then
              l2=l1
              k2(:)=k1(:)
            endif
          enddo
        enddo
      enddo
      kk(:,ii)=k2(:)
    enddo
  endif

! Write unfolded BZ and full BZ to files

  if (fwritebz) then
    if (peinf%inode.eq.0) then
      write(tmpstr,801) kqchar, trim(filename)
801   format(a,"_",a,"_unfolded.dat")
      call open_file(14, tmpstr, status='replace', form='formatted')
      write(14,803) nfk
      do ii=1,nfk
        write(14,804) ii,fk(:,ii)
      enddo
      call close_file(14)
      write(tmpstr,802) kqchar, trim(filename)
802   format(a,"_",a,"_full.dat")
      call open_file(14, tmpstr, status='replace', form='formatted')
      write(14,803) nk
      do ii=1,nk
        write(14,804) ii,kk(:,ii)
      enddo
      call close_file(14)
    endif
  endif

! Replace unfolded BZ with full BZ

  if (freplacebz) then
    if (nk.le.nfk) then
      nfk=nk
      fk(1:3,1:nk)=kk(1:3,1:nk)
    else
      call die('checkbz: failed replacebz')
    endif
  endif

! Before comparing k-points translate from Wigner-Seitz box
! to [0,1) interval

  SAFE_ALLOCATE(kref, (3,nfk))
  kref(1:3,1:nfk)=fk(1:3,1:nfk)
  
  if (wignerseitz) then
    do ii=1,nfk
      call k_range(kref(:,ii), gpt, TOL_Small)
    enddo
    do ii=1,nk
      call k_range(kk(:,ii), gpt, TOL_Small)
    enddo
  endif

! Check that kref(1:3,1:nfk) is a subset of kk(1:3,1:nk)
! Print a warning message otherwise

  if(.not.(flag_half_shift.and.allow_half_shift)) then
    f1=.true.
    do ii=1,nfk
      f3=.false.
      do jj=1,nk
        if (all(abs(kref(1:3,ii)-kk(1:3,jj)).lt.TOL_Small)) f3=.true.
      enddo
      if (.not.f3) then
        f1=.false.
        if (peinf%inode.eq.0) write(0,'(a,3f12.6)') 'Extra point: ', kref(1:3,ii)
      endif
    enddo
    if (.not.f1) then
      if (peinf%inode.eq.0) write(0,903) trim(filename), kqchar
903   format(1x,"WARNING: checkbz: unfolded BZ from",1x,a,1x,"has extra",1x,a,"-points",/)
    endif
  endif

! Check that kk(1:3,1:nk) is a subset of kref(1:3,1:nfk)
! Print a warning message otherwise

  f2=.true.
  do ii=1,nk
    f3=.false.
    do jj=1,nfk
      if (all(abs(kk(1:3,ii)-kref(1:3,jj)).lt.TOL_Small)) f3=.true.
    enddo
    if (.not.f3) then
      f2=.false.
      if (peinf%inode.eq.0) write(0,'(a,3f12.6)') 'Missing point: ', kk(1:3,ii)
    endif
  enddo
  if (.not.f2) then
    if (peinf%inode.eq.0) then
      write(0,904) trim(filename), kqchar
      if (trim(filename) .eq. 'epsilon.inp' .and. kqchar .eq. 'q') &
        write(0,905)
    endif
904 format(1x,"WARNING: checkbz: unfolded BZ from",1x,a,1x,"has missing",1x,a,"-points",/)
905 format(1x,"(disregard this warning if your epsilon calculation is split by q-points)",/)
  endif
  
! Deallocate and finish

  SAFE_DEALLOCATE(kk)
  SAFE_DEALLOCATE(kref)

  POP_SUB(checkbz)

  return
  
803 format(i5)
804 format(i5,3f13.9)
  
end subroutine checkbz

end module checkbz_m

!================================================================================
!
! Modules:
!
! (1) blas_m      Originally By DAS      Last Modified 1/13/2011 (das)
!
!     Interfaces for BLAS functions, taken from http://www.netlib.org/blas/
!     Every BLAS function used in the code should be listed here, and this
!     module should be used in every routine containing BLAS calls to ensure
!     the argument types are correct.
!
!     Note that if any array name from netlib.org is X, the interface will
!     be interpreted as a preprocessor macro and cause a compilation failure,
!     solved by changed to lower-case x.
!
!================================================================================

#include "f_defs.h"

module blas_m

  public ! only interfaces in this module

  interface
    SUBROUTINE DGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      implicit none
      DOUBLE PRECISION ALPHA,BETA
      INTEGER K,LDA,LDB,LDC,M,N
      CHARACTER TRANSA,TRANSB
      DOUBLE PRECISION A(LDA,*),B(LDB,*),C(LDC,*)
    end subroutine DGEMM
  end interface

  interface
    SUBROUTINE ZGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      implicit none
      DOUBLE COMPLEX ALPHA,BETA
      INTEGER K,LDA,LDB,LDC,M,N
      CHARACTER TRANSA,TRANSB
      DOUBLE COMPLEX A(LDA,*),B(LDB,*),C(LDC,*)
    end subroutine ZGEMM
  end interface

  interface
    SUBROUTINE DGEMV(TRANS,M,N,ALPHA,A,LDA,x,INCX,BETA,Y,INCY)
      implicit none
      DOUBLE PRECISION ALPHA,BETA
      INTEGER INCX,INCY,LDA,M,N
      CHARACTER TRANS
      DOUBLE PRECISION A(LDA,*),x(*),Y(*)
    end SUBROUTINE DGEMV
  end interface

  interface
    SUBROUTINE ZGEMV(TRANS,M,N,ALPHA,A,LDA,x,INCX,BETA,Y,INCY)
      implicit none
      DOUBLE COMPLEX ALPHA,BETA
      INTEGER INCX,INCY,LDA,M,N
      CHARACTER TRANS
      DOUBLE COMPLEX A(LDA,*),x(*),Y(*)
    end SUBROUTINE ZGEMV
  end interface

  interface
    SUBROUTINE ZHEMV(UPLO,N,ALPHA,A,LDA,x,INCX,BETA,Y,INCY)
      implicit none
      DOUBLE COMPLEX ALPHA,BETA
      INTEGER INCX,INCY,LDA,N
      CHARACTER UPLO
      DOUBLE COMPLEX A(LDA,*),x(*),Y(*)
    end SUBROUTINE ZHEMV
  end interface

  interface
    SUBROUTINE ZHPMV(UPLO,N,ALPHA,AP,x,INCX,BETA,Y,INCY)
      implicit none
      DOUBLE COMPLEX ALPHA,BETA
      INTEGER INCX,INCY,N
      CHARACTER UPLO
      DOUBLE COMPLEX AP(*),x(*),Y(*)
    end SUBROUTINE ZHPMV
  end interface

  interface
    SUBROUTINE ZHEMM(SIDE,UPLO,M,N,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      implicit none
      DOUBLE COMPLEX ALPHA,BETA
      INTEGER LDA,LDB,LDC,M,N
      CHARACTER SIDE,UPLO
      DOUBLE COMPLEX A(LDA,*),B(LDB,*),C(LDC,*)
    end SUBROUTINE ZHEMM
  end interface

  interface blas_dot
    DOUBLE PRECISION FUNCTION DDOT(N,DX,INCX,DY,INCY)
      implicit none
      INTEGER INCX,INCY,N
      DOUBLE PRECISION DX(*),DY(*)
    end FUNCTION DDOT

    DOUBLE COMPLEX FUNCTION ZDOTC(N,ZX,INCX,ZY,INCY)
      implicit none
      INTEGER INCX,INCY,N
      DOUBLE COMPLEX ZX(*),ZY(*)
    end FUNCTION ZDOTC
  end interface blas_dot

  interface
    SUBROUTINE DSCAL(N,DA,DX,INCX)
      implicit none
      DOUBLE PRECISION DA
      INTEGER INCX,N
      DOUBLE PRECISION DX(*)
    end SUBROUTINE DSCAL
  end interface

  interface
    SUBROUTINE ZSCAL(N,ZA,ZX,INCX)
      implicit none
      DOUBLE COMPLEX ZA
      INTEGER INCX,N
      DOUBLE COMPLEX ZX(*)
    end SUBROUTINE ZSCAL
  end interface

  interface blas_nrm2
    DOUBLE PRECISION FUNCTION DNRM2(N,x,INCX)
      implicit none
      INTEGER INCX,N
      DOUBLE PRECISION x(*)
    end FUNCTION DNRM2

    DOUBLE PRECISION FUNCTION DZNRM2(N,x,INCX)
      implicit none
      INTEGER INCX,N
      DOUBLE COMPLEX x(*)
    end FUNCTION DZNRM2
  end interface

end module blas_m

!===============================================================================
!
! Module:
!
! symmetries_m        Originally By DAS        12/20/2011
!
!   Find symmetry operations from lattice vectors and atomic positions,
!   using spglib 1.0.9. For use in mean-field codes such as EPM and SIESTA wrapper.
!
!===============================================================================

#include "f_defs.h"

module symmetries_m

  use global_m
  use misc_m
  use sort_m

  implicit none

  private
  
  public :: get_symmetries

  real(DP), parameter :: symprec = 1d-5
  ! this is the same tolerance used by the Quantum ESPRESSO routines

  interface
    ! these functions are defined in spglib_f.c

    subroutine spg_get_multiplicity_f(size, lattice, position, types, num_atom, symprec)
      implicit none
      integer, intent(out) :: size
      real(8), intent(in) :: lattice
      real(8), intent(in) :: position
      integer, intent(in) :: types
      integer, intent(in) :: num_atom
      real(8), intent(in) :: symprec
    end subroutine spg_get_multiplicity_f

    subroutine spg_get_symmetry_f(nsym, rotation, translation, max_size, lattice, position, types, num_atom, symprec)
      implicit none
      integer, intent(out) :: nsym
      integer, intent(out) :: rotation
      real(8), intent(out) :: translation
      integer, intent(in)  :: max_size
      real(8), intent(in)  :: lattice
      real(8), intent(in)  :: position
      integer, intent(in)  :: types
      integer, intent(in)  :: num_atom
      real(8), intent(in)  :: symprec
    end subroutine spg_get_symmetry_f

    subroutine spg_get_international_f(spacegroup, symbol, lattice, position, types, num_atom, symprec)
      implicit none
      integer, intent(out) :: spacegroup
      character*11, intent(out) :: symbol
      real(8), intent(in) :: lattice
      real(8), intent(in) :: position
      integer, intent(in) :: types
      integer, intent(in) :: num_atom
      real(8), intent(in) :: symprec
    end subroutine spg_get_international_f

  end interface
  
contains
  
  subroutine get_symmetries(nat, atyp, apos, avec, nfft, cell_symmetry, ntran, mtrx, tnp, spacegroup, symbol)
    integer, intent(in) :: nat            !< number of atoms
    integer, intent(in) :: atyp(:)        !< atomic species
    real(DP), intent(in) :: apos(:,:)     !< (1:3,1:nat) atomic positions in crystal coordinates
    real(DP), intent(in) :: avec(3,3)     !< lattice vectors in real space
    integer, intent(in) :: nfft(3)        !< FFT grid (if = 0, not used)
    integer, intent(out) :: cell_symmetry !< 0 = cubic, 1 = hexagonal
    integer, intent(out) :: ntran         !< number of symmetry operations
    integer, intent(out) :: mtrx(:,:,:)   !< rotation matrices (3, 3, 48)
    real(DP), intent(out) :: tnp(:,:)     !< frational translations (3, 48)
    integer, intent(out) :: spacegroup    !< spacegroup international index
    character, intent(out) :: symbol*21   !< spacegroup symbol in Schoenflies notation

    integer :: isym, ii, jj, ntran_temp, ntran_temp2, identity(3,3)
    real(DP) :: C_avec(3,3), frac_fft(3)
    integer, allocatable :: mtrx_inv(:,:,:) ! allocatable since more than 48 ops may be returned
    real(DP), allocatable :: tnp_temp(:,:)
    logical :: use_this_sym, disable_frac, found_identity

    PUSH_SUB(get_symmetries)

    ! transpose input for C call
    do ii = 1, 3
      C_avec(ii, 1:3) = avec(1:3, ii)
    enddo

    call spg_get_international_f(spacegroup, symbol, C_avec(1, 1), apos(1, 1), atyp(1), nat, symprec)
    
    ! http://en.wikipedia.org/wiki/Trigonal_crystal_system: 143-167
    ! http://en.wikipedia.org/wiki/Hexagonal_crystal_system: 168-194
    ! All others are cubic.

    if(spacegroup >= 143 .and. spacegroup <= 194) then
      cell_symmetry = 1    ! hexagonal
    else
      cell_symmetry = 0    ! cubic
    endif

    disable_frac = .false.
    call spg_get_multiplicity_f(ntran_temp, C_avec(1,1), apos(1,1), atyp(1), nat, symprec)
    SAFE_ALLOCATE(mtrx_inv, (3, 3, ntran_temp))
    SAFE_ALLOCATE(tnp_temp, (3, ntran_temp))

    ! we need to check that it is not a supercell, as in the QE routine (sgam_at)
    ! they disable fractional translations if the identity has one, because the sym ops might not form a group.
    ! spglib may return duplicate operations in this case!

    call spg_get_symmetry_f(ntran_temp2, mtrx_inv(1,1,1), tnp_temp(1,1), ntran_temp, C_avec(1,1), apos(1,1), atyp(1), nat, symprec)
    if(ntran_temp2 /= ntran_temp) call die("Inconsistent number of symmetries from spglib. Internal error.")

! for debugging: write all ops
!    do isym = 1, ntran_temp2
!      write(6,'(10i3, 3f6.2)') isym, mtrx_inv(:,:,isym), tnp_temp(:,isym)
!    enddo

    if(ntran_temp > 48) then
      disable_frac = .true.
      write(0,'(a,i6,a)') "Number of symmetry operations = ", ntran_temp, " > 48"
    endif

    found_identity = .false.
    identity = reshape((/1, 0, 0, 0, 1, 0, 0, 0, 1/), shape(identity))
    do isym = 1, ntran_temp
      if(all(mtrx_inv(1:3,1:3,isym) == identity(1:3, 1:3))) then
        found_identity = .true.
        if(any(abs(tnp_temp(1:3, isym)) > TOL_Zero)) then
          disable_frac = .true.
          write(0,'(a,3f12.6)') 'Identity has a fractional translation ', tnp_temp(1:3, isym)
        endif
      endif
    enddo
    if(.not. found_identity) call die("Symmetries internal error: Identity is missing from symmetry operations.")
    
    if(disable_frac) then
      write(0,'(a)') "WARNING: Disabling fractional translations. System appears to be a supercell."
    endif

    ! spglib does not consider an FFT grid. below is based on QE routine sgam_at.
    ntran = 0
    do isym = 1, ntran_temp
      if(all(nfft(1:3) /= 0)) then
        ! check that rotation matrix is compatible with FFT grid
        use_this_sym = &
          mod(mtrx_inv(2, 1, isym) * nfft(1), nfft(2)) == 0 .and. &
          mod(mtrx_inv(3, 1, isym) * nfft(1), nfft(3)) == 0 .and. &
          mod(mtrx_inv(1, 2, isym) * nfft(2), nfft(1)) == 0 .and. &
          mod(mtrx_inv(3, 2, isym) * nfft(2), nfft(3)) == 0 .and. &
          mod(mtrx_inv(1, 3, isym) * nfft(3), nfft(1)) == 0 .and. &
          mod(mtrx_inv(2, 3, isym) * nfft(3), nfft(2)) == 0

        ! check that fractional translation is compatible with FFT grid
        frac_fft(1:3) = tnp_temp(1:3, isym) * nfft(1:3)
        use_this_sym = use_this_sym .and. all(abs(frac_fft(1:3) - nint(frac_fft(1:3))) / nfft(1:3) < symprec)
      else
        ! if FFT grid is supplied as zero, we accept all operations
        use_this_sym = .true.
      endif

      ! make sure fractional translations are in the right range, just a convention
      ! this makes the results agree with the ESPRESSO routines, but really makes no practical difference
      do jj = 1, 3
        if (tnp_temp(jj, isym).ge.TOL_Zero+0.5d0) & 
          tnp_temp(jj, isym)=tnp_temp(jj, isym)-dble(int(tnp_temp(jj, isym)+0.5d0)) 
        if (tnp_temp(jj, isym).lt.TOL_Zero-0.5d0) & 
          tnp_temp(jj, isym)=tnp_temp(jj, isym)-dble(int(tnp_temp(jj, isym)-0.5d0)) 
      enddo

      if(disable_frac) then
        if(any(abs(tnp_temp(1:3,isym)) > TOL_Zero)) use_this_sym = .false.
      endif

      if(use_this_sym) then
        ntran = ntran + 1
        if(ntran > 48) call die("Internal error: There are more than 48 accepted symmetry operations.")
        ! this could only happen for a supercell, and we are supposed to have handled that situation already

        ! if accepted, add this operation to the list
        call invert_matrix_int(mtrx_inv(1:3, 1:3, isym), mtrx(1:3, 1:3, ntran))
        tnp(1:3, ntran) = 2 * PI_D * tnp_temp(1:3, isym)
      endif
    enddo

    SAFE_DEALLOCATE(mtrx_inv)
    SAFE_DEALLOCATE(tnp_temp)

    call make_identity_symmetry_first(ntran, mtrx, tnp)

    POP_SUB(get_symmetries)
    return

  end subroutine get_symmetries

end module symmetries_m

#include "f_defs.h"

module irrbz_m

  use global_m
  use misc_m

  implicit none

  private

  public :: irrbz

contains

  subroutine irrbz(syms,nfk,fk,nrq,neq,indrq,rq,nq,qq,itnrq,kg0,nfix)
    type (symmetry), intent(in) :: syms
    integer, intent(in) :: nfk
    real(DP), intent(in) :: fk(:,:) !< (3,nfk)
    integer, intent(out) :: nrq
    integer, optional, intent(out) :: neq(:) !< nrq
    integer, optional, intent(out) :: indrq(:) !< nrq
    real(DP), optional, intent(out) :: rq(:,:) !< (3, nrq)
    integer, optional, intent(in) :: nq
    real(DP), optional, intent(in) :: qq(:,:)  !< (3, nq)
    integer, optional, intent(out) :: itnrq(:) !< nrq
    integer, optional, intent(out) :: kg0(:,:) !< (3, nrq)
    !> don`t try to fold back the first nfix points (defaults to 1)
    integer, optional, intent(in) :: nfix
  
    integer :: i,j,irq,ik,it,iflag,iq,kg(3),nq_read,line_skip,iqsave,iostat_c,nfix_
    integer, allocatable :: indrk(:)
    real(DP) :: qk(3)
    real(DP), allocatable :: rq_read(:,:)
    logical :: use_ntran ! true for Sigma, false for Epsilon
    logical :: irrbz_read
  
!
!  i   nq,qq              q-points for which eps**(-1)(q) is known
!  i   nfk,fk             k-points in full BZ
!  o   nrq,rq             q-points in irr BZ with respect to subgroup
!  o   neq                number of points equivalent to rq
!  o   indrq,itnrq,kg0    index, transformation, Umklapp required for
!                           rq = r(q) + kg0
!
    PUSH_SUB(irrbz)

    nfix_ = 1
    if (present(nfix)) nfix_ = nfix
  
    ! all or nothing
    if(present(rq) .and. present(nq) .and. present(qq) .and. present(itnrq) .and. present(kg0) .neqv. &
       present(rq) .or.  present(nq) .or.  present(qq) .or.  present(itnrq) .or.  present(kg0)) then
       call die("irrbz internal error: bad parameters")
    endif
    use_ntran = present(qq)
    if(use_ntran .and. .not. (present(neq) .and. present(indrq))) then
      call die("irrbz internal error: bad parameters 2")
    endif
  
    if(size(fk, 1) /= 3) then
      write(0,*) 'size(fk, 1) = ', size(fk, 1)
      call die("irrbz internal error: fk must have first dimension = 3")
    endif
    if(size(fk, 2) /= nfk) then
      write(0,*) 'nfk = ', nfk, 'size(fk, 2) = ', size(fk, 2)
      call die("irrbz internal error: fk must have second dimension = nfk")
    endif

    irrbz_read = .false.
    if (.not. use_ntran) then
      call open_file(unit=21,file='irrbz.dat',status='old',iostat=iostat_c)
      if (iostat_c==0) irrbz_read=.true.
    endif
    if (irrbz_read) then
      write(6,'(3x,a)') 'Reading the Irreducible Brillouin Zone from irrbz.dat'
      read(21,*) nq_read
      SAFE_ALLOCATE(rq_read,(3,nq_read))
      read(21,*) (rq_read(1:3,iq), iq = 1,nq_read)
  
      !Compare and find which rq_read corresponds to the syms%rq 
      do iq=1,nq_read
        if (all(abs(rq_read(1:3,iq)-syms%rq(1:3)) .lt. TOL_Small)) then
           iqsave=iq
           exit
        endif
        write(0,'(3x,a)') 'rq not found in irrbz.dat',syms%rq(1:3)
        call die("rq not found in irrbz.dat")
      enddo
      SAFE_DEALLOCATE(rq_read)
     
      !Now just go to the line number from where we can read all the information
      line_skip = 3*(iqsave-1)
      do i=1,line_skip
        read(21,*)
      enddo
      read(21,*) nrq
      if (present(neq)) then
        read(21,*) (neq(i), i=1,nrq)
      else
        read(21,*) 
      endif
      if (present(indrq)) then
        read(21,*) (indrq(i), i=1,nrq)
      else
        read(21,*) 
      endif
      call close_file(21)
    
    else
  
      SAFE_ALLOCATE(indrk, (nfk))
  
!   initialize number of points in irr. BZ
!
      nrq = 0
!
!   loop over k-points in full zone
!
      ik_loop: do ik=1,nfk
        if (ik > nfix_) then
!
!       loop over transformation matrices
!
          do it=1,syms%ntranq
            qk(:) = matmul(dble(syms%mtrx(:,:,syms%indsub(it))),fk(:,ik))
            call k_range(qk,kg,TOL_Small)
  
            if(.not. present(neq)) cycle
!
!         compare to other k-points in the irr. BZ with respect to qvec
!
            do irq=1,nrq
              if (all(abs(fk(1:3,indrk(irq))-qk(1:3)) .lt. TOL_Small)) then
                neq(irq) = neq(irq) + 1
                cycle ik_loop
              endif
            enddo
          enddo ! loop over ntranq tranformation
  
        endif
  
        nrq = nrq + 1
        indrk(nrq) = ik
        if(use_ntran) rq(1:3,nrq) = fk(1:3,ik)
        if(present(neq)) neq(nrq) = 1
  
        if(use_ntran) then
!
!     find qq to which rq is equivalent
!
          iflag = 0
          iq_loop: do iq=1,nq
            do it=1,syms%ntran
              qk(:) = matmul(dble(syms%mtrx(:,:,it)),qq(:,iq))
              call k_range(qk,kg,TOL_Small)
            
              if (all(abs(rq(1:3,nrq)-qk(1:3)) .lt. TOL_Small)) then
                iflag = 1
                indrq(nrq) = iq
                itnrq(nrq) = it
                kg0(1:3,nrq) = kg(1:3)
! there may be more than one matching sym op, but better be only one q-vector!
!              exit iq_loop
              endif
            enddo
          enddo iq_loop
  !
  !     end of loop over q
  
          if (iflag .eq. 0) then
            write(0,'(a,3f12.6)') 'rq = ', rq(1:3,nrq)
            call die('irrbz: q/rq mismatch')
          endif
  
        else
          if(present(indrq)) indrq(nrq) = ik
! we do not need these, but this is what they would be
!        kg0(1:3,nrq) = kg(1:3)
!        itnrq(nrq) = it
        endif ! use_ntran
  
      enddo ik_loop !end loop over full BZ
    endif !whether read or generated
  
    if (peinf%inode .eq. 0 .and. use_ntran) then
  
      write(6,'(1x,a,i0)') 'Number of k-points in the irreducible BZ(q) (nrq): ', nrq
      write(6,120)
  120 format(/,15x,'q',21x,'neq',6x,'indrq',6x,'itrq',9x,'kg0',/)
      write(6,130) ((rq(i,j),i=1,3),neq(j),indrq(j),itnrq(j), &
        (kg0(i,j),i=1,3),j=1,nrq)
  130 format(3f10.5,5x,i4,5x,i4,5x,i4,5x,3i4)

    endif
  
    SAFE_DEALLOCATE(indrk)
    POP_SUB(irrbz)
  
    return
  end subroutine irrbz

end module irrbz_m

!===================================================================================
!
! Routines:
!
! (1) sortbyq      Originally By MLT       Last Modified: 9/27/2010 (JRD)
!
!===================================================================================


#include "f_defs.h"

subroutine sortbyq(fqa,qqa,g0a,ifqa,irqa,qg,kg,crys)

  use global_m
  implicit none

  real(DP), intent(out) :: fqa(3,peinf%myown), qqa(peinf%myown)
  integer, intent(out) :: g0a(3,peinf%myown)
  integer, intent(out) :: ifqa(peinf%myown)
  integer, intent(out) :: irqa(peinf%myown)
  type (grid), intent(in) :: qg, kg
  type (crystal), intent(in) :: crys
  
  integer :: sinv,ik,ic,iv,ikp,icp,ivp,ii,ifq,irq,ifqmin
  
  real(DP) :: fq(3),difmin,diff(3),length
  
  PUSH_SUB(sortbyq)
  
  do ii = 1, peinf%myown
    
    ik=peinf%ik(peinf%inode+1,ii)
    ic=peinf%ic(peinf%inode+1,ii)
    iv=peinf%iv(peinf%inode+1,ii)
    ikp=peinf%ikp(peinf%inode+1,ii)
    icp=peinf%icp(peinf%inode+1,ii)
    ivp=peinf%ivp(peinf%inode+1,ii)

! If ik.gt.ikp, define q + g0 = kp-k
! all factors of (G0-G) and (q) must get a minus sign,
! and epsinv must be replaced by its complex conjugate
! otherwise, work with q + g0 = k-kp
! sinv keeps track of signs (in the comments below, assume ik.le.ikp)

    sinv = 1
    if (ik.gt.ikp) sinv = -1

    fq(:)=dble(sinv)*( kg%f(:,ik)-kg%f(:,ikp) )

! For a given pair of k-points (ik,ikp), calculate the shortest
! q = k - kp + G_0 , with G_0 a reciprocal lattice vector

    difmin=1.d10
    ifqmin=0     
    do ifq=1,qg%nf
      diff(1:3) = fq(1:3) - qg%f(1:3, ifq)
      diff(1:3) = diff(1:3) - anint( diff(1:3) )
      
      length = DOT_PRODUCT(diff,MATMUL(crys%bdot,diff))
      
! Found a good matching point. Save it

      if (length <= TOL_Zero) then
        ifqmin = ifq
        difmin = 0.d0
        exit
      endif

! Check other points for the best matching point

      if (length.lt.difmin) then  
        difmin = length
        ifqmin = ifq
      endif
    enddo ! ifq
    
    ifq=ifqmin
    
    if (difmin.gt.TOL_Zero .or. ifq .eq. 0) then
      write(0,'(a,3f12.6,a,i6,a,i6,a)') 'epsmat does not contain q-point ', fq, ' (= k ', ik, ' - k ', ikp, ')'
      write(0,'(a,i6,a,f10.5)') 'Closest q-point is', ifq, ' of distance ', difmin
      call die("Needed q-point not found. This likely means your WFN_co file is shifted, which is not recommended.")
    endif
    
    fqa(:,ii) = qg%f(:,ifq)
    g0a(:,ii) = anint(fq(:) - fqa(:,ii))
    ifqa(ii)=ifq
    irqa(ii)=qg%indr(ifq)
    
    qqa(ii) = sqrt( DOT_PRODUCT(fqa(:,ii),MATMUL(crys%bdot,fqa(:,ii))) )
    
  enddo ! ii
  
  SAFE_ALLOCATE(peinf%nxqown, (qg%nr))
  SAFE_ALLOCATE(peinf%nxqi, (peinf%myown))
  peinf%nxqown = 0
  peinf%nxqi = 0
  
  do irq = 1, qg%nr
    peinf%nxqown(irq)=0
    do ii = 1, peinf%myown
      if (irqa(ii) .eq. irq) then
        peinf%nxqown(irq)=peinf%nxqown(irq)+1
        peinf%nxqi(peinf%nxqown(irq))=ii
      endif
    enddo
  enddo
  
  POP_SUB(sortbyq)
  
  return
end subroutine sortbyq

!*************************************************************************
Module TypeMod
!*************************************************************************

  use SysParams, only : double

  Implicit None

  real( double ), parameter :: small = 1.d-32

  Type minVecT
     real( double )             :: cosine, sine
     complex( double ), pointer :: StDesc(:)
     complex( double ), pointer :: Phi(:)
     complex( double ), pointer :: EPhi(:)
  end Type minVecT

  Type GridT
     complex(double), pointer :: V(:,:,:)
     complex(double), pointer :: Psi(:,:,:)
     complex(double), pointer :: VPsi(:,:,:)
     complex(double), pointer :: VPsiG(:,:,:)
     complex(double), pointer :: Work(:,:,:)
     integer                  :: NumGVec,k
     integer,         pointer :: GVecIndex(:,:)
     integer,         pointer :: GInvIndex(:,:,:)
     integer,         pointer :: BasisIndex(:,:)
     integer,    dimension(3) :: Size,Length
     integer(double)          :: PlanF,PlanB
     real(double)             :: fac
  end Type GridT

end Module TypeMod

!===============================================================================
!
! Module fft_parallel_m
!
! 1. fft_set_p()        Originally By gsm        Last Modified 9/20/2010 (gsm)
!
!    Sets up distribution of planes and rods for parallel 3D (serial 2D/1D) FFT
!
! 2. fft_map_s()        Originally By gsm        Last Modified 9/20/2010 (gsm)
!
!    Builds box to sphere map for serial 3D FFT
!
! 3. fft_map_p()        Originally By gsm        Last Modified 9/20/2010 (gsm)
!
!    Builds box to sphere map for parallel 3D (serial 2D/1D) FFT
!
! 4. fft_r2g_s()        Originally By gsm        Last Modified 9/20/2010 (gsm)
!
!    Performs forward (from R-space to G-space) serial 3D FFT
!
! 5. fft_r2g_p()        Originally By gsm        Last Modified 9/20/2010 (gsm)
!
!    Performs forward (from R-space to G-space) parallel 3D (serial 2D/1D) FFT
!
! 6. fft_g2r_s()        Originally By gsm        Last Modified 9/20/2010 (gsm)
!
!    Performs backward (from G-space to R-space) serial 3D FFT
!
! 7. fft_g2r_p()        Originally By gsm        Last Modified 9/20/2010 (gsm)
!
!    Performs backward (from G-space to R-space) parallel 3D (serial 2D/1D) FFT
!
!===============================================================================
!
!  Forward FFT (from R-space to G-space):
!    f(G) = \sum_r f(r) exp(-iGr) = (N / Omega) \int f(r) exp(-iGr) dr
!
!  Backward FFT (from G-space to R-space):
!    f(r) = \sum_G f(G) exp(iGr)
!
!  Omega = unit cell volume, N = FFTgrid(1)*FFTgrid(2)*FFTgrid(3), FFTgrid = FFT grid size
!
!  Periodic Bloch function:
!    Forward FFT: scale = sqrt(Omega) / N
!      u(G) = (1 / sqrt(Omega)) \int u(r) exp(-iGr) dr
!    Backward FFT: scale = 1 / sqrt(Omega)
!      u(r) = (1 / sqrt(Omega)) \sum_G u(G) exp(iGr)
!  \int |u(r)|^2 dr = \sum_G |u(G)|^2 = 1
!
!  Electron density:
!    Forward FFT: scale = Omega / N
!      n(G) = \int n(r) exp(-iGr) dr
!    Backward FFT: scale = 1 / Omega
!      n(r) = (1 / Omega) \sum_G n(G) exp(iGr)
!  \int n(r) dr = n(G = 0) = number of electrons
!
!  Ionic pseudopotential, Hartree potential, exchange-correlation potential:
!    Forward FFT: scale = 1 / N
!      V(G) = (1 / Omega) \int V(r) exp(-iGr) dr
!    Backward FFT: scale = 1
!      V(r) = \sum_G V(G) exp(iGr)
!  (1 / Omega) \int V(r) dr = V(G = 0) = average potential
!
!  Coulomb potential:
!    Forward FFT: scale = Omega / N
!      V_c(G) = \int V_c(r) exp(-iGr) dr = 4 pi e^2 / G^2
!    Backward FFT: scale = 1 / Omega
!      V_c(r) = (1 / Omega) \sum_G V_c(G) exp(iGr) = e^2 / r
!  e^2 = 2 in Rydberg atomic units
!
!===============================================================================

#include "f_defs.h"

module fft_parallel_m

  use global_m
  use fftw_m

  implicit none

  private

  public :: &
    fft_set_p, &
    fft_map_s, &
    fft_map_p, &
    fft_r2g_s, &
    fft_r2g_p, &
    fft_g2r_s, &
    fft_g2r_p

contains

subroutine fft_set_p(FFTgrid, Nplane, Nrod)

  integer, intent(in) :: FFTgrid(3)
  integer, intent(out) :: Nplane
  integer, intent(out) :: Nrod
  
  PUSH_SUB(fft_set_p)
  
  if (mod(FFTgrid(3),peinf%npes) == 0) then
    Nplane = FFTgrid(3)/peinf%npes
  else
    Nplane = FFTgrid(3)/peinf%npes+1
  endif
  if (mod(FFTgrid(1)*FFTgrid(2),peinf%npes) == 0) then
    Nrod = (FFTgrid(1)*FFTgrid(2))/peinf%npes
  else
    Nrod = (FFTgrid(1)*FFTgrid(2))/peinf%npes+1
  endif
  
  POP_SUB(fft_set_p)
  
  return
  
end subroutine fft_set_p

!-------------------------------------------------------------------------------

subroutine fft_map_s(ng,FFTgrid,isort,gvec,inv_indx)
  
  integer, intent(in) :: ng
  integer, intent(in) :: FFTgrid(3)
  integer, intent(in) :: isort(:) !< (ng)
  integer, intent(in) :: gvec(:,:) !< (3,ngtot)
  integer, intent(out) :: inv_indx(:,:,:) !< (FFTgrid(1),FFTgrid(2),FFTgrid(3))

  integer :: ig,id,idx(3)

  PUSH_SUB(fft_map_s)
  
  inv_indx(:,:,:)=0
  do ig=1,ng
    do id=1,3
      idx(id)=gvec(id,isort(ig))+1
      if (idx(id).lt.1) idx(id)=idx(id)+FFTgrid(id)
    enddo
    inv_indx(idx(1),idx(2),idx(3))=ig
  enddo

  POP_SUB(fft_map_s)
  
  return

end subroutine fft_map_s

!-------------------------------------------------------------------------------

subroutine fft_map_p(imod,ng,ng_l,Nrod,FFTgrid,isort,gvec, &
  mrod,msph,crod,csph,drod,dsph,irod,isph)
  
  integer, intent(in) :: imod
  integer, intent(in) :: ng
  integer, intent(in) :: ng_l
  integer, intent(in) :: Nrod
  integer, intent(in) :: FFTgrid(3)
  integer, intent(in) :: isort(:) !< (ng)
  integer, intent(in) :: gvec(:,:) !< (3,ngtot)
  integer, intent(inout) :: mrod
  integer, intent(inout) :: msph
  integer, intent(inout) :: crod(:) !< (peinf%npes)
  integer, intent(inout) :: csph(:) !< (peinf%npes)
  integer, intent(inout) :: drod(:) !< (peinf%npes)
  integer, intent(inout) :: dsph(:) !< (peinf%npes)
  integer, intent(out) :: irod(:,:) !< (2,MAX(1,mrod))
  integer, intent(out) :: isph(:) !< (MAX(1,msph))

  integer :: i,j,k,ig,id,idx(3)
  integer, allocatable :: orod(:)
  integer, allocatable :: osph(:)
  
  PUSH_SUB(fft_map_p)
  
  if (imod.eq.0) then
    
    crod(:)=0
    csph(:)=0
    do ig=1,ng
      do id=1,3
        idx(id)=gvec(id,isort(ig))+1
        if (idx(id).lt.1) idx(id)=idx(id)+FFTgrid(id)
      enddo
      i=(idx(2)-1)*FFTgrid(1)+idx(1)-1
      j=i/Nrod
      k=(ig-1)/ng_l
      if (peinf%inode.eq.j) crod(k+1)=crod(k+1)+1
      if (peinf%inode.eq.k) csph(j+1)=csph(j+1)+1
    enddo
    do i=1,peinf%npes
      drod(i)=sum(crod(1:i-1))
      dsph(i)=sum(csph(1:i-1))
    enddo
    mrod=sum(crod(:))
    msph=sum(csph(:))
    
  elseif (imod.eq.1) then
    
    irod(:,:)=0
    isph(:)=0
    SAFE_ALLOCATE(orod, (peinf%npes))
    SAFE_ALLOCATE(osph, (peinf%npes))
    orod(:)=drod(:)
    osph(:)=dsph(:)
    do ig=1,ng
      do id=1,3
        idx(id)=gvec(id,isort(ig))+1
        if (idx(id).lt.1) idx(id)=idx(id)+FFTgrid(id)
      enddo
      i=(idx(2)-1)*FFTgrid(1)+idx(1)-1
      j=i/Nrod
      k=(ig-1)/ng_l
      if (peinf%inode.eq.j) then
        orod(k+1)=orod(k+1)+1
        irod(1,orod(k+1))=idx(3)
        irod(2,orod(k+1))=i-j*Nrod+1
      endif
      if (peinf%inode.eq.k) then
        osph(j+1)=osph(j+1)+1
        isph(osph(j+1))=ig-k*ng_l
      endif
    enddo
    SAFE_DEALLOCATE(orod)
    SAFE_DEALLOCATE(osph)
    
  endif
  
  POP_SUB(fft_map_p)
  
  return
  
end subroutine fft_map_p

!-------------------------------------------------------------------------------

subroutine fft_r2g_s(FFTgrid,scale,inv_indx,fftbox_3D,gsphere)
  
  integer, intent(in) :: FFTgrid(3)
  real(DP), intent(in) :: scale
  integer, intent(in) :: inv_indx(:,:,:) !< (FFTgrid(1),FFTgrid(2),FFTgrid(3))
  complex(DPC), intent(inout) :: fftbox_3D(:,:,:) !< (FFTgrid(1),FFTgrid(2),FFTgrid(3))
  complex(DPC), intent(out) :: gsphere(:) !< (ng)
  
  integer :: i1,i2,i3,j1,j2,j3,ig
  
  PUSH_SUB(fft_r2g_s)

  call do_FFT(fftbox_3D,FFTgrid,-1)

  gsphere(:)=(0.0d0,0.0d0)
  do j3=-FFTgrid(3)/2,FFTgrid(3)/2-1
    i3=j3+1
    if (j3.lt.0) i3=FFTgrid(3)+i3
    do j2=-FFTgrid(2)/2,FFTgrid(2)/2-1
      i2=j2+1
      if (j2.lt.0) i2=FFTgrid(2)+i2
      do j1=-FFTgrid(1)/2,FFTgrid(1)/2-1
        i1=j1+1
        if (j1.lt.0) i1=FFTgrid(1)+i1
        ig=inv_indx(i1,i2,i3)
        if (ig.eq.0) cycle
        gsphere(ig)=fftbox_3D(i1,i2,i3)
      enddo
    enddo
  enddo
  
  gsphere(:)=gsphere(:)*scale
  
  POP_SUB(fft_r2g_s)
  
  return
  
end subroutine fft_r2g_s

!-------------------------------------------------------------------------------

subroutine fft_r2g_p(FFTgrid,Nplane,Nrod,mrod,msph,crod,csph, &
  drod,dsph,irod,isph,scale,fftbox_2D,fftbox_1D,buffer_2D,buffer_1D, &
  buffer_rod,buffer_sph,gsphere_d)
  
  integer, intent(in) :: FFTgrid(3)
  integer, intent(in) :: Nplane
  integer, intent(in) :: Nrod
  integer, intent(in) :: mrod
  integer, intent(in) :: msph
  integer, intent(in) :: crod(:) !< (peinf%npes)
  integer, intent(in) :: csph(:) !< (peinf%npes)
  integer, intent(in) :: drod(:) !< (peinf%npes)
  integer, intent(in) :: dsph(:) !< (peinf%npes)
  integer, intent(in) :: irod(:,:) !< (2,MAX(1,mrod))
  integer, intent(in) :: isph(:) !< (MAX(1,msph))
  real(DP), intent(in) :: scale
  complex(DPC), intent(inout) :: fftbox_2D(:,:,:) !< (FFTgrid(1),FFTgrid(2),Nplane)
  complex(DPC), intent(out) :: fftbox_1D(:,:) !< (FFTgrid(3),Nrod)
  complex(DPC), intent(out) :: buffer_2D(:,:,:) !< (Nrod,Nplane,peinf%npes)
  complex(DPC), intent(out) :: buffer_1D(:,:,:) !< (Nrod,Nplane,peinf%npes)
  complex(DPC), intent(out) :: buffer_rod(:) !< (MAX(1,mrod))
  complex(DPC), intent(out) :: buffer_sph(:) !< (MAX(1,msph))
  complex(DPC), intent(out) :: gsphere_d(:) !< (ng_l)

  integer :: i,j,k,i1,i2,i3
  integer :: NSize(3)
  complex(DPC), allocatable :: fftbox_temp(:,:,:)
  
  PUSH_SUB(fft_r2g_p)

  NSize(:)=FFTgrid(:)
  NSize(3)=1
  SAFE_ALLOCATE(fftbox_temp,(NSize(1),NSize(2),NSize(3)))
  do i=1,Nplane
    fftbox_temp(:,:,1)=fftbox_2D(:,:,i)
    call do_FFT(fftbox_temp,NSize,-1)
    fftbox_2D(:,:,i)=fftbox_temp(:,:,1)
  enddo
  SAFE_DEALLOCATE(fftbox_temp) 
  
  buffer_2D(:,:,:)=(0.0d0,0.0d0)
  do k=1,Nplane
    do i2=1,FFTgrid(2)
      do i1=1,FFTgrid(1)
        i=(i2-1)*FFTgrid(1)+i1-1
        j=i/Nrod
        buffer_2D(i-j*Nrod+1,k,j+1)=fftbox_2D(i1,i2,k)
      enddo
    enddo
  enddo
#ifdef MPI
  call MPI_Alltoall(buffer_2D(1,1,1),Nrod*Nplane,MPI_COMPLEX_DPC, &
    buffer_1D(1,1,1),Nrod*Nplane,MPI_COMPLEX_DPC,MPI_COMM_WORLD,mpierr)
#else
  buffer_1D(:,:,:)=buffer_2D(:,:,:)
#endif
  do i3=1,FFTgrid(3)
    do i=1,Nrod
      j=(i3-1)/Nplane
      fftbox_1D(i3,i)=buffer_1D(i,i3-j*Nplane,j+1)
    enddo
  enddo

  NSize(:)=1
  NSize(1)=FFTgrid(3)
  SAFE_ALLOCATE(fftbox_temp,(NSize(1),NSize(2),NSize(3)))
  do i=1,Nrod
    fftbox_temp(:,1,1)=fftbox_1D(:,i)
    call do_FFT(fftbox_temp,NSize,-1)
    fftbox_1D(:,i)=fftbox_temp(:,1,1)
  enddo
  SAFE_DEALLOCATE(fftbox_temp)
  
  buffer_rod(:)=(0.0d0,0.0d0)
  do i=1,mrod
    buffer_rod(i)=fftbox_1D(irod(1,i),irod(2,i))
  enddo
#ifdef MPI
  call MPI_Alltoallv(buffer_rod,crod,drod,MPI_COMPLEX_DPC, &
    buffer_sph,csph,dsph,MPI_COMPLEX_DPC,MPI_COMM_WORLD,mpierr)
#else
  buffer_sph(:)=buffer_rod(:)
#endif
  gsphere_d(:)=(0.0d0,0.0d0)
  do i=1,msph
    gsphere_d(isph(i))=buffer_sph(i)
  enddo
  
  gsphere_d(:)=gsphere_d(:)*scale
  
  POP_SUB(fft_r2g_p)
  
  return
end subroutine fft_r2g_p

!-------------------------------------------------------------------------------

subroutine fft_g2r_s(FFTgrid,scale,inv_indx,gsphere,fftbox_3D)

  integer, intent(in) :: FFTgrid(3)
  real(DP), intent(in) :: scale
  integer, intent(in) :: inv_indx(:,:,:) !< (FFTgrid(1),FFTgrid(2),FFTgrid(3))
  complex(DPC), intent(in) :: gsphere(:) ! <ng)
  complex(DPC), intent(out) :: fftbox_3D(:,:,:) !< (FFTgrid(1),FFTgrid(2),FFTgrid(3))
  
  integer :: i1,i2,i3,j1,j2,j3,ig
  
  PUSH_SUB(fft_g2r_s)
  
  fftbox_3D(:,:,:)=(0.0d0,0.0d0)
  do j3=-FFTgrid(3)/2,FFTgrid(3)/2-1
    i3=j3+1
    if (j3.lt.0) i3=FFTgrid(3)+i3
    do j2=-FFTgrid(2)/2,FFTgrid(2)/2-1
      i2=j2+1
      if (j2.lt.0) i2=FFTgrid(2)+i2
      do j1=-FFTgrid(1)/2,FFTgrid(1)/2-1
        i1=j1+1
        if (j1.lt.0) i1=FFTgrid(1)+i1
        ig=inv_indx(i1,i2,i3)
        if (ig.eq.0) cycle
        fftbox_3D(i1,i2,i3)=gsphere(ig)
      enddo
    enddo
  enddo

  call do_FFT(fftbox_3D,FFTgrid,1)
 
  fftbox_3D(:,:,:)=fftbox_3D(:,:,:)*scale
  
  POP_SUB(fft_g2r_s)
  
  return
end subroutine fft_g2r_s

!-------------------------------------------------------------------------------

subroutine fft_g2r_p(FFTgrid,Nplane,Nrod,mrod,msph,crod,csph, &
  drod,dsph,irod,isph,scale,gsphere_d,fftbox_2D,fftbox_1D,buffer_2D, &
  buffer_1D,buffer_rod,buffer_sph)

  integer, intent(in) :: FFTgrid(3)
  integer, intent(in) :: Nplane
  integer, intent(in) :: Nrod
  integer, intent(in) :: mrod
  integer, intent(in) :: msph
  integer, intent(in) :: crod(:) !< (peinf%npes)
  integer, intent(in) :: csph(:) !< (peinf%npes)
  integer, intent(in) :: drod(:) !< (peinf%npes)
  integer, intent(in) :: dsph(:) !< (peinf%npes)
  integer, intent(in) :: irod(:,:) !< (2,MAX(1,mrod))
  integer, intent(in) :: isph(:) !< (MAX(1,msph))
  real(DP), intent(in) :: scale
  complex(DPC), intent(in) :: gsphere_d(:) !< (ng_l)
  complex(DPC), intent(out) :: fftbox_2D(:,:,:) !< (FFTgrid(1),FFTgrid(2),Nplane)
  complex(DPC), intent(out) :: fftbox_1D(:,:) !< (FFTgrid(3),Nrod)
  complex(DPC), intent(out) :: buffer_2D(:,:,:) !< (Nrod,Nplane,peinf%npes)
  complex(DPC), intent(out) :: buffer_1D(:,:,:) !< (Nrod,Nplane,peinf%npes)
  complex(DPC), intent(out) :: buffer_rod(:) !< (MAX(1,mrod))
  complex(DPC), intent(out) :: buffer_sph(:) !< (MAX(1,msph))

  integer :: i,j,k,i1,i2,i3
  integer :: Nsize(3)
  complex(DPC), allocatable :: fftbox_temp(:,:,:)

  PUSH_SUB(fft_g2r_p)

  buffer_sph(:)=(0.0d0,0.0d0)
  do i=1,msph
    buffer_sph(i)=gsphere_d(isph(i))
  enddo
#ifdef MPI
  call MPI_Alltoallv(buffer_sph,csph,dsph,MPI_COMPLEX_DPC, &
    buffer_rod,crod,drod,MPI_COMPLEX_DPC,MPI_COMM_WORLD,mpierr)
#else
  buffer_rod(:)=buffer_sph(:)
#endif
  fftbox_1D(:,:)=(0.0d0,0.0d0)
  do i=1,mrod
    fftbox_1D(irod(1,i),irod(2,i))=buffer_rod(i)
  enddo

  NSize(:)=1
  NSize(1)=FFTgrid(3)
  SAFE_ALLOCATE(fftbox_temp,(NSize(1),NSize(2),NSize(3)))
  do i=1,Nrod
    fftbox_temp(:,1,1)=fftbox_1D(:,i)
    call do_FFT(fftbox_temp,NSize,1)
    fftbox_1D(:,i)=fftbox_temp(:,1,1)
  enddo
  SAFE_DEALLOCATE(fftbox_temp)
  
  buffer_1D(:,:,:)=(0.0d0,0.0d0)
  do i3=1,FFTgrid(3)
    do i=1,Nrod
      j=(i3-1)/Nplane
      buffer_1D(i,i3-j*Nplane,j+1)=fftbox_1D(i3,i)
    enddo
  enddo
#ifdef MPI
  call MPI_Alltoall(buffer_1D(1,1,1),Nrod*Nplane,MPI_COMPLEX_DPC, &
    buffer_2D(1,1,1),Nrod*Nplane,MPI_COMPLEX_DPC,MPI_COMM_WORLD,mpierr)
#else
  buffer_2D(:,:,:)=buffer_1D(:,:,:)
#endif
  do k=1,Nplane
    do i2=1,FFTgrid(2)
      do i1=1,FFTgrid(1)
        i=(i2-1)*FFTgrid(1)+i1-1
        j=i/Nrod
        fftbox_2D(i1,i2,k)=buffer_2D(i-j*Nrod+1,k,j+1)
      enddo
    enddo
  enddo

  NSize(:)=FFTgrid(:)
  NSize(3)=1
  SAFE_ALLOCATE(fftbox_temp,(NSize(1),NSize(2),NSize(3)))
  do i=1,Nplane
    fftbox_temp(:,:,1)=fftbox_2D(:,:,i)
    call do_FFT(fftbox_temp,NSize,1)
    fftbox_2D(:,:,i)=fftbox_temp(:,:,1)
  enddo
  SAFE_DEALLOCATE(fftbox_temp)
  
  fftbox_2D(:,:,:)=fftbox_2D(:,:,:)*scale
  
  POP_SUB(fft_g2r_p)
  
  return
end subroutine fft_g2r_p

end module fft_parallel_m

#include "f_defs.h"

!*************************************************************************
Module ConjGradMod
!*************************************************************************

  use push_pop_m
  implicit none

  contains

!*************************************************************************
  Subroutine CGDiagonalize( hMatrix, eigenStates, kPoint,tol,period,ReportNo)
!*************************************************************************

    use SysParams,         only : double
    use TypeMod,           only : minVecT
    use EigenStatesMod,    only : EigenStatesT
    use HamiltonianMod,    only : hamiltonianArrayT
    use InitializeMod,     only : MinVecAllocate, MinVecInit, &
                                & MinVecDestroy, EigenStatesInit
    use NormalizeMod,      only : EigenStatesOrth
    use tiseOpsMod,        only : CalculateEPsi


    integer, intent( in ) :: kPoint,ReportNo,period
    real(double), intent(in) :: tol

    type( eigenStatesT ), pointer :: eigenStates
    type( hamiltonianArrayT ), pointer :: hMatrix
    type( MinVecT ), pointer :: minVec, oldVec
    complex( double ), dimension(:,:), allocatable :: h

    integer :: iBand, cntr, oldband
    real(double) :: tolerance

    PUSH_SUB(CGDiagonalize)
    
    allocate( h( hMatrix%hSize, hMatrix%hSize ))

    eigenStates%hSize = hMatrix%hSize
    eigenStates%hDim = hMatrix%hDim

    ! The size of HMatrix might be bigger than hMatrix%hSize, with only the 
    ! hMatrix%hSize * hMatrix%hSize part filled
    Call ConvertUTToFullMatrix( hMatrix%h, h, hMatrix%hSize )

    Call MinVecAllocate( minVec, hMatrix%hDim )
    Call MinVecAllocate( oldVec, hMatrix%hDim )

    cntr = 1
    iBand = 1
    tolerance = tol !eigenStates%tolerance

    do while( iBand <= eigenStates%numStates )

       oldband = iBand

       Call MinVecInit( minVec )
       Call MinVecInit( oldVec )

       Call EigenStatesInit( eigenStates, iBand, kPoint )

       Call EigenStatesOrth( eigenStates, iBand, kPoint )

       Call CalculateEPsi( eigenStates, h, iBand, kPoint )

       ! Calculate the Ritz values
       eigenStates%eigenValues( iBand, kPoint ) = &
           & Dot_Product( eigenStates%eigenVectors( :, iBand, kPoint ), &
           & eigenStates%ePsi( :, kPoint ))



       Call Diagonalize( hMatrix%hSize, h, eigenStates,& 
       & iBand, kPoint, tolerance, minVec, oldVec ,ReportNo)

       iBand = iBand + 1

       !   If the calculation for the band has converged then iBand has
       ! increased by one; if so then reset counter to 1 and tolerance to
       ! tol; else increase counter, if the counter crosses 10 (or some 
       ! user-defined number), then reset counter to 1 and decrease 
       ! tolerance. 
       if( oldband /= iBand) then
          cntr = 1
          tolerance = tol !eigenStates%tolerance
       else
          cntr = cntr + 1
          if( cntr > period )then
             cntr = 1
             tolerance = 100 * tolerance
             write( ReportNo, * ) 'Failed to converge in', period, &
                  & ' steps: Decreasing tolerance to ', tolerance
          end if
       end if

    end do

    Call ConvertFullToUTMatrix( hMatrix%h, h, hMatrix%hSize)

    deallocate( h )
    Call MinVecDestroy( minVec )
    Call MinVecDestroy( oldVec )

    POP_SUB(CGDiagonalize)

  end Subroutine CGDiagonalize

!*************************************************************************
  Subroutine ConvertUTToFullMatrix( hMatrix, h, hSize )
!*************************************************************************

    use SysParams, only : double

    integer, intent(in) :: hSize
    complex(double), dimension(:,:) :: h
    complex(double), pointer :: hMatrix(:)

    integer :: i, j

    PUSH_SUB(ConvertUTToFullMatrix)

    do i = 1, hSize
       h( i, i ) = hMatrix( i + i * ( i - 1 ) / 2 )
       do j = i + 1, hSize
          h(i,j) = hMatrix( i + j * ( j - 1 ) / 2 )
          h(j,i) = conjg(h(i,j))
       end do
    end do

    POP_SUB(ConvertUTToFullMatrix)
  end Subroutine ConvertUTToFullMatrix

!*************************************************************************
  Subroutine ConvertFullToUTMatrix( hMatrix, h, hSize )
!*************************************************************************

    use SysParams, only : double

    integer, intent(in) :: hSize
    complex(double), dimension(:,:) :: h
    complex(double), pointer :: hMatrix(:)

    integer :: i, j

    PUSH_SUB(ConvertFullToUTMatrix)

    do i = 1, hSize
       hMatrix( i + i * ( i - 1 ) / 2 ) = h( i, i )
       do j = i + 1, hSize
          hMatrix( i + j * ( j - 1 ) / 2 ) = h(i,j) 
       end do
    end do

    POP_SUB(ConvertFullToUTMatrix)

  end Subroutine ConvertFullToUTMatrix

!*************************************************************************
  Subroutine Diagonalize( hSize, hMatrix, eigenStates, & 
                        & iBand, kPoint, tol, minVec, oldVec, ReportNo)
!*************************************************************************

    use SysParams,         only : double
    use EigenStatesMod,    only : eigenStatesT
    use TypeMod,           only : minVecT
    use MinimizeMod,       only : StDescentVec, ConjDirection
    use NormalizeMod,      only : LowerBandOrthogonalize, BandOrthogonalize
    use tiseOpsMod,        only : PreCondition, ExactEnergyMinimize

    ! Define the types of the subroutine arguments
    integer, intent( in ) :: hSize, kPoint, ReportNo
    integer, intent( inout ) :: iBand
    real( double ), intent( in ) :: tol
    complex( double ), dimension(:,:) :: hMatrix

    type(eigenStatesT), pointer :: eigenStates
    type(MinVecT), pointer :: MinVec,OldVec

    integer :: iter
    real(double) :: residue, tolsq

    PUSH_SUB(Diagonalize)

    tolsq = 10.d0*tol**2

    !   Iterate the Eigen Vector until convergence before moving over to the
    ! next higher band.
    EigenVectorLoop: do iter = 1, hSize

       !   Evaluate the Steepest Descent diection as the negative gradient
       ! In this case it is StDesc = -(H-lambda)|Psi>        
       Call StDescentVec( eigenStates, MinVec, iBand, kPoint ) ! In "Minimize.f90"


       !   The residue is the Steepst Descent Vector, so its square is 
       ! calculated, and the iterations are carried out until userdefined
       ! convergence is reached, OR 'HamSize' iterations have been carried out.
       residue = Dot_Product( minVec%StDesc, minVec%StDesc )

       if( residue > tolsq ) then
          
          !   Orhtogonalize the steepst descent vector against all the LOWER
          ! Eigen Vectors. (In "NormalizeMod.f90")
          Call LowerBandOrthogonalize( eigenStates, minVec%StDesc, &
                                     & iBand, kPoint )

          !   PreCondition the Steepest Descent Vector In "HamiltonMod.f90"
          Call PreCondition( eigenStates, minVec, hMatrix, iBand, kPoint )
          
          !   Orthogonalize the PreConditioned Vector against all bands, lower 
          ! than and including the current band.  In "NormalizeMod.f90"
          Call BandOrthogonalize( eigenStates, minVec%StDesc, iBand, kPoint )
          
          !   Evaluate the conjugate direction orthogonal to the current band 
          ! and normalized. (In "MinimizeMod.f90")
          Call ConjDirection( eigenStates, minVec, oldVec, iBand, kPoint )

          !   Do the line minimization by searching for the energy minimum, and
          ! update the band.
          Call ExactEnergyMinimize( eigenStates, minVec, &
                                  & hMatrix, iBand, kPoint )
       else
          
          exit EigenVectorLoop

       end if

    end do EigenVectorLoop
    
    ! Print the eigenvalue and residue
    write( ReportNo, 11 ) iBand, eigenStates%eigenValues( iBand, kPoint ),&
         & sqrt( residue ), iter

11     format(1X,'Band:',I3,1X,'EigenValues:',E15.5,1X,'Norm Resed:',E15.5, &
            & 1X,'Iterations:',I3)

    if( residue > tolsq ) then
       iBand = iBand - 1
    end if

    POP_SUB(Diagonalize)
  end Subroutine Diagonalize

!*************************************************************************
  Subroutine cgEigenSystem( hamiltonian,eigenStates,k,tol,period,ReportNo )
!*************************************************************************

! Hamiltonian matrix is diagonalized by a call to conjugate gradient

    use SysParams,      only : double
    use EigenStatesMod, only : eigenStatesT
    use HamiltonianMod, only : hamiltonianArrayT

    implicit none
    
    integer, intent(in)                :: period,ReportNo,k
    real(double), intent(in)           :: tol
    type( hamiltonianArrayT ), pointer :: hamiltonian
    type( eigenStatesT ),      pointer :: eigenStates

    PUSH_SUB(cgEigenSystem)

    Call CGDiagonalize(hamiltonian,eigenStates,k,tol,period,ReportNo)

    POP_SUB(cgEigenSystem)
  end Subroutine cgEigenSystem

!*************************************************************************
  Subroutine cgFFTDiagonalise(hamArray,eigenStates,Grid,kPoint,tol,period, &
       & ReportNo)
!*************************************************************************

    use SysParams,           only : double
    use TypeMod,             only : minVecT,GridT
    use EigenStatesMod,      only : EigenStatesT
    use HamiltonianMod,      only : hamiltonianArrayT
    use InitializeMod,       only : MinVecAllocate, MinVecInit, &
                                  & MinVecDestroy, EigenStatesInit
    use NormalizeMod,        only : EigenStatesOrth
    use tiseOpsMod,          only : CalculateEPsi,CalcHPsi


    integer, intent( in )              :: kPoint,ReportNo,period
    real(double), intent(in)           :: tol

    type(GridT),               pointer :: Grid 
    type(eigenStatesT),        pointer :: eigenStates
    type(hamiltonianArrayT),   pointer :: hamArray
    type(MinVecT),             pointer :: minVec, oldVec
    
    integer :: iBand, cntr, oldband
    real(double) :: tolerance

    PUSH_SUB(cgFFTDiagonalise)

    eigenStates%hSize = hamArray%hSize
    eigenStates%hDim = hamArray%hDim

    Call MinVecAllocate( minVec, hamArray%hDim )
    Call MinVecAllocate( oldVec, hamArray%hDim )

    cntr = 1
    iBand = 1
    tolerance = tol 

    do while( iBand <= eigenStates%numStates )

       oldband = iBand

       Call MinVecInit( minVec )
       Call MinVecInit( oldVec )

       Call EigenStatesInit(eigenStates,iBand,kPoint)

       Call EigenStatesOrth(eigenStates,iBand,kPoint)

       Call CalcHPsi(eigenStates%hSize,hamArray%KineticG, &
            & eigenStates%eigenVectors(:,iBand,kPoint),eigenStates%epsi(:,kPoint), &
            & Grid)

       ! Calculate the Ritz values
       eigenStates%eigenValues( iBand, kPoint ) = &
           & Dot_Product( eigenStates%eigenVectors( :, iBand, kPoint ), &
           & eigenStates%ePsi( :, kPoint ))

       Call FFTDiagonalise(hamArray%KineticG,eigenStates,Grid,iBand,kPoint, &
       & tolerance,minVec,oldVec,ReportNo)

       iBand = iBand + 1

       !   If the calculation for the band has converged then iBand has
       ! increased by one; if so then reset counter to 1 and tolerance to
       ! tol; else increase counter, if the counter crosses 10(or some 
       ! user defined number), then reset counter to 1 and decrease 
       ! tolerance. 
       if( oldband /= iBand) then
          cntr = 1
          tolerance = tol !eigenStates%tolerance
       else
          cntr = cntr + 1
          if( cntr > period )then
             cntr = 1
             tolerance = 100 * tolerance
             write( ReportNo, * ) 'Failed to converge in', period, &
                  & ' steps: Decreasing tolerance to ', tolerance
          end if
       end if

    end do

    Call MinVecDestroy( minVec )
    Call MinVecDestroy( oldVec )

    POP_SUB(cgFFTDiagonalise)
  end Subroutine cgFFTDiagonalise

!*************************************************************************
  Subroutine FFTDiagonalise(T_G,eigenStates,Grid,iBand,kPoint, &
       & tol,minVec,oldVec,ReportNo)
!*************************************************************************

    use SysParams,           only : double
    use TypeMod,             only : minVecT,GridT
    use EigenStatesMod,      only : EigenStatesT
    use MinimizeMod,         only : StDescentVec, ConjDirection
    use NormalizeMod,        only : LowerBandOrthogonalize, BandOrthogonalize
    use tiseOpsMod,          only : FFTPreCondition, FFTEnergyMinimize

    type(GridT),           pointer :: Grid
    type(eigenStatesT),    pointer :: eigenStates
    type(minVecT),         pointer :: minVec,oldVec
    integer, intent(in)            :: kPoint,ReportNo
    real(double)                   :: tol
    real(double), dimension(:)     :: T_G

    integer :: iter,iBand
    real(double) :: residue, tolsq

    PUSH_SUB(FFTDiagonalise)

    tolsq = 10.d0*tol**2

    !   Iterate the Eigen Vector until convergence before moving over to the
    ! next higher band.
    EigenVectorLoop: do iter = 1, eigenStates%hSize

       !   Evaluate the Steepest Descent diection as the negative gradient
       ! In this case it is StDesc = -(H-lambda)|Psi>        
       Call StDescentVec( eigenStates, MinVec, iBand, kPoint )

       !   The residue is the Steepst Descent Vector, so its square is 
       ! calculated, and the iterations are carried out until userdefined
       ! convergence is reached, OR 'HamSize' iterations have been carried out.
       residue = Dot_Product( minVec%StDesc, minVec%StDesc )

       if( residue > tolsq ) then
          
          !   Orhtogonalize the steepst descent vector against all the LOWER
          ! Eigen Vectors. (In "NormalizeMod.f90")
          Call LowerBandOrthogonalize( eigenStates, minVec%StDesc, &
                                     & iBand, kPoint )

          !   PreCondition the Steepest Descent Vector In "HamiltonMod.f90"
          Call FFTPreCondition(eigenStates,minVec,T_g,iBand,kPoint)

          !   Orthogonalize the PreConditioned Vector against all bands, lower 
          ! than and including the current band.  In "NormalizeMod.f90"
          Call BandOrthogonalize( eigenStates, minVec%StDesc, iBand, kPoint )
          
          !   Evaluate the conjugate direction orthogonal to the current band 
          ! and normalized. (In "MinimizeMod.f90")
          Call ConjDirection( eigenStates, minVec, oldVec, iBand, kPoint )

          !   Do the line minimization by searching for the energy minimum, and
          ! update the band.
          Call FFTEnergyMinimize(eigenStates,MinVec,T_g,Grid,iBand,kPoint)

       else
          
          exit EigenVectorLoop

       end if

    end do EigenVectorLoop
    
    ! Print the eigenvalue and residue
    write( ReportNo, 11 ) iBand, eigenStates%eigenValues( iBand, kPoint ),&
         & sqrt( residue ), iter

11     format(1X,'Band:',I3,1X,'EigenValues:',E15.5,1X,'Norm Resed:',E15.5, &
            & 1X,'Iterations:',I3)


    if( residue > tolsq ) then
       iBand = iBand - 1
    end if

    POP_SUB(FFTDiagonalise)
  end Subroutine FFTDiagonalise

end Module ConjGradMod

!===============================================================================
!
! Utilities:
!
! (1) epsinvomega      Originally By gsm      Last Modified 11/17/2010 (gsm)
!
! Serial code that plots frequency dependence of Plasmon-Pole, Retarded,
! Advanced epsilon inverse for a given q, G, G` vectors. Input parameters
! are read from file epsinvomega.inp in the working directory.
!
! Note that epsInvPP constructed with full-frequency epsmat will be
! different from epsInvPP constructed with static epsmat because of
! finite broadening used in full-frequency epsmat.
!
! FIXME: use WFN_RHO_VXC for reading RHO
!
! FIXME: [2013-01-15 gsm] compact form of GPP model doesn`t work when
! wtilde2 < 0 which is often the case for G .ne. G`; replace with the
! explicit expression from Hybertsen & Louie (see commented out code
! in the GPP section of epsinvomega.f90)
!
!===============================================================================

#include "f_defs.h"

program epsinvomega

  use global_m
  use epsread_hdf5_m
#ifdef HDF5
  use hdf5
#endif

  implicit none

  integer :: i,j,k,iq,mq,ig,igp,iunit
  real(DP) :: omega
  
  character*256, parameter :: fninp = "epsinvomega.inp"
  character*256 :: fneps,fnrho,fngpp,fnffr,fnffa
  character :: infile*80
  real(DP) :: q(3)
  integer :: g(3),gp(3),gmgp(3)
  
  integer :: freq_dep,nFreq_tmp,nFreq,ii,nq,ng,nmtx,kgrid(3)
  real(DP) :: dDeltaFreq,dBrdning,ecuts,delta
  real(DP), allocatable :: qpt(:,:)
  real(DP), allocatable :: ekin(:)
  real(DP), allocatable :: dFreqGrid(:)
  integer, allocatable :: isrtx(:)
  integer, allocatable :: isorti(:)
  integer, allocatable :: nmtx_of_q(:)
  SCALAR, allocatable :: eps(:)
  complex(DPC), allocatable :: dFreqBrd(:)
  complex(DPC), allocatable :: epsPP(:)
  complex(DPC), allocatable :: epsR(:)
  complex(DPC), allocatable :: epsA(:)
  complex(DPC), allocatable :: epsRTemp(:,:)
  complex(DPC), allocatable :: epsATemp(:,:)
  
  real(DP) :: bvec(3,3),bdot(3,3),blat,celvol,reccelvol,ebind
  integer :: nvecs,nspin,qgrid(3)
  
  integer nproc_para,num_gvec, error
  complex(DPC) :: epsStatic
  real(DP) :: rho0
  SCALAR :: rhogmgp
  integer, allocatable :: gvec(:,:)
  SCALAR, allocatable :: xcdum(:,:)
  
  real(DP) :: wp2,qg(3),qgp(3),qgqg,qgqgp,lambda,phi
  SCALAR :: Omega2,wtilde2,epsggp,I_epsggp,eps_static,eps_dynamic
  complex(DPC) :: wtilde2_temp
!  real(DP) :: epsPPRe,epsPPIm
!  complex(DPC) :: wtilde,ampl

!-----------------------------
! read input file

  write(6,'(/,1x,"reading",1x,a,1x,"file",/)')trim(fninp)
  
  call open_file(55,file=trim(fninp),form='formatted',status='old')
  
  read(55,'(a)') fneps
  read(55,'(a)') fnrho
  read(55,*) (q(i),i=1,3)
  read(55,*) (g(i),i=1,3)
  read(55,*) (gp(i),i=1,3)
  read(55,*) nFreq
  read(55,*) dDeltaFreq
  read(55,*) dBrdning
  read(55,*) ebind
  read(55,'(a)') fngpp
  read(55,'(a)') fnffr
  read(55,'(a)') fnffa
  
  call close_file(55)
  
  write(6,'(2a)')         "     eps  file  = ", trim(fneps)
  write(6,'(2a)')         "     rho  file  = ", trim(fnrho)
  write(6,'(a, 3f15.12)') "     q  vector  = ", q(1:3)
  write(6,'(a, 3i4)')     "     G  vector  = ", g(1:3)
  write(6,'(a, 3i4)')     "     G' vector  = ", gp(1:3)
  write(6,'(a, i6)')      "     nFreq      = ", nFreq
  write(6,'(a, f7.3)')    "     dDeltaFreq = ", dDeltaFreq
  write(6,'(a, f7.3)')    "     dBrdning   = ", dBrdning
  write(6,'(a, f7.3)')    "     ebind      = ", ebind
  write(6,'(2a)')         "     GPP file   = ", trim(fngpp)
  write(6,'(2a)')         "     FFR file   = ", trim(fnffr)
  write(6,'(2a,/)')       "     FFA file   = ", trim(fnffa)
  
  gmgp(:)=g(:)-gp(:)
  
!-----------------------------
! read eps file

  write(6,'(1x,"reading",1x,a,1x,"file",/)')trim(fneps)

#ifdef HDF5

  call h5open_f(error)

  infile = trim(fneps)

  call read_eps_grid_sizes_hdf5(ng,nq,ecuts,nFreq_tmp,nmtx,qgrid,infile)
  freq_dep = 0
  if (nFreq_tmp .gt. 1) freq_dep = 2
  if (freq_dep==2 .and. nFreq_tmp/=nFreq) call die('nFreq mismatch')

  SAFE_ALLOCATE(dFreqGrid,(nFreq))
  SAFE_ALLOCATE(dFreqBrd,(nFreq))
  SAFE_ALLOCATE(qpt, (3,nq))
  SAFE_ALLOCATE(nmtx_of_q, (nq))
  SAFE_ALLOCATE(gvec, (3,ng))

  call read_eps_qgrid_hdf5(nq,qpt,nmtx_of_q,infile)
  if (freq_dep .eq. 2) then
    call read_eps_freqgrid_hdf5(nFreq,dFreqGrid,dFreqBrd,infile)
  else
    do i=1,nFreq
      dFreqGrid(i)=dDeltaFreq*dble(i-1)
      dFreqBrd(i)=dBrdning
    enddo
  endif

  call read_eps_old_gvecs_hdf5(ng,gvec,infile)

#else

  iunit=12
  call open_file(unit=iunit,file=trim(fneps),form='unformatted',status='old')

  read(iunit)
  read(iunit) freq_dep,ii
  if (freq_dep.eq.2) then
    nFreq_tmp=ii
  endif
  if (freq_dep==2 .and. nFreq_tmp/=nFreq) call die('nFreq mismatch')
  read(iunit) (kgrid(i),i=1,3)
  SAFE_ALLOCATE(dFreqGrid,(nFreq))
  SAFE_ALLOCATE(dFreqBrd,(nFreq))
  if (freq_dep.eq.2) then
    read(iunit) (dFreqGrid(i),i=1,nFreq),(dFreqBrd(i),i=1,nFreq)
    if (nFreq.gt.1) dDeltaFreq=dFreqGrid(2)-dFreqGrid(1)
    dBrdning=IMAG(dFreqBrd(1))
  else
    do i=1,nFreq
      dFreqGrid(i)=dDeltaFreq*dble(i-1)
      dFreqBrd(i)=dBrdning
    enddo
    read(iunit)
  endif
  read(iunit)
  read(iunit)
  read(iunit) ecuts
  read(iunit) nq
  read(iunit) ng
  
  rewind(iunit)
  
  SAFE_ALLOCATE(qpt, (3,nq))
  SAFE_ALLOCATE(gvec, (3,ng))
  
  read(iunit)
  read(iunit)
  read(iunit)
  read(iunit)
  read(iunit)
  read(iunit)
  read(iunit)
  read(iunit) nq,((qpt(j,i),j=1,3),i=1,nq)
  read(iunit) ng,((gvec(j,i),j=1,3),i=1,ng)

#endif
  
  ig=0
  igp=0
  do i=1,ng
    if (gvec(1,i).eq.g(1).and.gvec(2,i).eq.g(2).and. &
      gvec(3,i).eq.g(3)) ig=i
    if (gvec(1,i).eq.gp(1).and.gvec(2,i).eq.gp(2).and. &
      gvec(3,i).eq.gp(3)) igp=i
  enddo
  if (ig.eq.0) then
    call die("cannot find G vector in file " // trim(fneps))
  endif
  if (igp.eq.0) then
    call die("cannot find G' vector in file " // trim(fneps))
  endif
  
  mq=-1
  do iq=1,nq
    if (abs(q(1)-qpt(1,iq)).lt.TOL_Zero.and. &
      abs(q(2)-qpt(2,iq)).lt.TOL_Zero.and. &
      abs(q(3)-qpt(3,iq)).lt.TOL_Zero) then
      mq=iq-1
      exit
    endif
  enddo
  if (mq.eq.-1) then
    call die("cannot find q vector in file " // trim(fneps))
  endif

#ifdef HDF5

  SAFE_ALLOCATE(isrtx, (ng))
  SAFE_ALLOCATE(isorti, (ng))
  SAFE_ALLOCATE(ekin, (ng))
  call read_eps_gvecsofq_hdf5(ng,isrtx,isorti,ekin,mq+1,infile)
  nmtx = nmtx_of_q(mq+1)
  SAFE_DEALLOCATE(ekin)
  SAFE_DEALLOCATE(nmtx_of_q)

#else
  
  do iq=1,mq
    read(iunit) ng,nmtx
    read(iunit)
    read(iunit)
    if (freq_dep.eq.0) then
      do j=1,nmtx
        read(iunit)
      enddo
    endif
    if (freq_dep.eq.2) then
      do j=1,nmtx
        do i=1,nmtx
          read(iunit)
#ifdef CPLX
          read(iunit)
#endif
        enddo
      enddo
    endif
  enddo
  
  SAFE_ALLOCATE(isrtx, (ng))
  SAFE_ALLOCATE(isorti, (ng))
  
  read(iunit) ng,nmtx,(isrtx(i),isorti(i),i=1,ng)
  read(iunit)
  read(iunit)
 
#endif

  ig=isorti(ig)
  igp=isorti(igp)
  if (ig.eq.0) then
    call die("cannot find G vector in file " // trim(fneps))
  endif
  if (igp.eq.0) then
    call die("cannot find G' vector in file " // trim(fneps))
  endif
  
  SAFE_ALLOCATE(epsPP, (nFreq))
  SAFE_ALLOCATE(epsR, (nFreq))
  SAFE_ALLOCATE(epsA, (nFreq))
  
#ifdef HDF5

  if (freq_dep.eq.0) then
    SAFE_ALLOCATE(eps, (nmtx))
    call read_eps_matrix_col_hdf5(eps,igp,nmtx,mq+1,1,infile)
    epsStatic=eps(ig)
    SAFE_DEALLOCATE(eps)
  endif
  if (freq_dep.eq.2) then
    SAFE_ALLOCATE(epsRTemp, (nFreq,nmtx))
#ifdef CPLX
    SAFE_ALLOCATE(epsATemp, (nFreq,nmtx))
    call read_eps_matrix_col_f_hdf5(epsRTemp,epsATemp,nFreq,igp,nmtx,mq+1,1,infile)
    epsA(:)=epsATemp(:,ig)
    SAFE_DEALLOCATE(epsATemp)
#else
    call read_eps_matrix_col_f_hdf5(epsRTemp,nFreq,igp,nmtx,mq+1,1,infile)
#endif
    epsR(:)=epsRTemp(:,ig)
    SAFE_DEALLOCATE(epsRTemp)
    epsStatic=epsR(1)
  endif

#else

  if (freq_dep.eq.0) then
    SAFE_ALLOCATE(eps, (nmtx))
    do j=1,nmtx
      if (j.eq.igp) then
        read(iunit) (eps(i),i=1,nmtx)
        epsStatic=eps(ig)
      else
        read(iunit)
      endif
    enddo
    SAFE_DEALLOCATE(eps)
  endif
  if (freq_dep.eq.2) then
    do j=1,nmtx
      do i=1,nmtx
        if (j.eq.igp.and.i.eq.ig) then
          read(iunit) (epsR(k),k=1,nFreq)
          epsStatic=epsR(1)
        else
          read(iunit) 
        endif
      enddo
#ifdef CPLX
      do i=1,nmtx
        if (j.eq.igp.and.i.eq.ig) then
          read(iunit) (epsA(k),k=1,nFreq)
        else
          read(iunit)
        endif
      enddo
#endif
    enddo
#ifndef CPLX
    do i=1,nFreq
      epsA(i)=CONJG(epsR(i))
    enddo
#endif
  endif

  call close_file(iunit)

#endif
  
  SAFE_DEALLOCATE(isrtx)
  SAFE_DEALLOCATE(isorti)
  
  SAFE_DEALLOCATE(qpt)
  SAFE_DEALLOCATE(gvec)
  
  write(6,'(a,i6)')     "     omega num  = ", nFreq
  write(6,'(a,f7.3)')   "     omega step = ", dDeltaFreq
  write(6,'(a,f7.3,/)') "     omega brd  = ", dBrdning

!-----------------------------
! read rho file

  write(6,'(1x,"reading",1x,a,1x,"file",/)')trim(fnrho)
  
  iunit=95
  call open_file(unit=iunit,file=trim(fnrho),form='unformatted',status='old')
  
  rho0=0.0d0
  rhogmgp=ZERO

  read(iunit)
  read(iunit) nspin,nvecs
  read(iunit)
  read(iunit) celvol
  read(iunit) reccelvol, blat, ((bvec(i,j),i=1,3),j=1,3), ((bdot(i,j),i=1,3),j=1,3)
  read(iunit)
  read(iunit)
  read(iunit)
  SAFE_ALLOCATE(gvec, (3, nvecs))
  SAFE_ALLOCATE(xcdum, (nvecs, nspin))
  read(iunit) nproc_para
  ig = 1
  do i=1,nproc_para
    read(iunit) num_gvec
    read(iunit) ((gvec(k, j), k = 1, 3), j = ig, ig + num_gvec - 1)
    ig = ig + num_gvec
  enddo
  read(iunit) nproc_para
  ig = 1
  do i=1,nproc_para
    read(iunit) num_gvec
    read(iunit) ((xcdum(j, k), j = ig, ig + num_gvec - 1), k = 1, nspin)
    ig = ig + num_gvec
  enddo
  do j=1,nvecs
    if (gvec(1,j).eq.0.and.gvec(2,j).eq.0.and.gvec(3,j).eq.0) then
      do k=1,nspin
        rho0=rho0+dble(xcdum(j,k))
      enddo
    endif
    if (gvec(1,j).eq.gmgp(1).and.gvec(2,j).eq.gmgp(2).and.gvec(3,j).eq.gmgp(3)) then
      do k=1,nspin
        rhogmgp=rhogmgp+xcdum(j,k)
      enddo
    endif
  enddo
  SAFE_DEALLOCATE(gvec)
  SAFE_DEALLOCATE(xcdum)
    
  if (abs(rho0).le.TOL_Zero) then
    call die("cannot find rho(0) in file " // trim(fnrho))
  endif
  if (abs(rhogmgp).le.TOL_Zero) then
    call die("cannot find rho(G-G') in file " // trim(fnrho))
  endif
  
  call close_file(iunit)
  
  write(6,'(5x,"cel vol =",e20.12)') celvol
  write(6,'(5x,"rho(0) =",f10.3,/)') rho0

!-----------------------------
! construct generalized plasmon pole model

  write(6,'(1x,"constructing GPP model",/)')
  
  wp2=ryd*ryd*16.0d0*PI_D*rho0/celvol
  qg(:)=q(:)+dble(g(:))
  qgp(:)=q(:)+dble(gp(:))
  qgqg=dot_product(qg,matmul(bdot,qg))
  qgqgp=dot_product(qg,matmul(bdot,qgp))
  if (abs(qgqg) .lt. TOL_Zero) call die("GPP model diverges")
  Omega2=wp2*qgqgp/qgqg*rhogmgp/rho0
#ifdef CPLX
  epsggp = epsStatic
#else
  epsggp = dble(epsStatic)
#endif
  if (all(g(1:3) .eq. gp(1:3))) then
    delta = 1.0d0
  else
    delta = 0.0d0
  endif
  I_epsggp = delta - epsggp
  if (abs(I_epsggp) .lt. TOL_Small) call die("GPP model diverges")
#ifdef CPLX
! Complex GPP [PRB 40, 3162 (1989)]
  wtilde2_temp = Omega2 / I_epsggp
  lambda = abs(wtilde2_temp)
  if (lambda .lt. TOL_Small) call die("GPP model diverges")
  phi = atan2(IMAG(wtilde2_temp), dble(wtilde2_temp))
  if (abs(cos(phi)) .lt. TOL_Small) call die("GPP model diverges")
  wtilde2 = lambda / cos(phi)
  Omega2 = Omega2 * CMPLX(1.0d0, -tan(phi))
#else
! Real GPP [PRB 34, 5390 (1986)]
  wtilde2 = Omega2 / I_epsggp
  if (abs(wtilde2) .lt. TOL_Small) call die("GPP model diverges")
#endif
!  wtilde=dble(sqrt(COMPLEXIFY(wtilde2)))
!  ampl=-0.5d0*PI_D*sqrt(COMPLEXIFY(Omega2/wtilde2))
  do i=1,nFreq
    omega=dFreqGrid(i)
!    epsPPRe=delta+dble(Omega2/(omega**2-wtilde2))
!    epsPPIm=dble(ampl)/sqrt(PI_D)/dBrdning* &
!     (exp(-(omega-wtilde)**2/dBrdning**2) &
!     -exp(-(omega+wtilde)**2/dBrdning**2))
!    epsPP(i)=CMPLX(epsPPRe,epsPPIm)
! Instead of using the above, we write real and imaginary in a compact 
! form by adding dbrdning in denominator. The imaginary part should be 
! a sharp (delta function) at the plasmon frequency.
    epsPP(i)=delta+Omega2/(omega**2-wtilde2-CMPLX(0D0,dBrdning))
  enddo

  write(6,'(5x,"plasma frequency =",f10.3," eV",/)') sqrt(wp2)

!-----------------------------
! write generalized plasmon pole file

  write(6,'(1x,"writing",1x,a,1x,"file",/)')trim(fngpp)
    
  call open_file(unit=7,file=trim(fngpp),form='formatted',status='replace')
    
  do i=1,nFreq
    omega=dFreqGrid(i)
    write(7,100)omega,epsPP(i)
  enddo
    
  call close_file(7)

!-----------------------------
! write full frequency files

  if (freq_dep.eq.2) then
    write(6,'(1x,"writing",1x,a,1x,"and",1x,a,1x,"files",/)') &
      trim(fnffr),trim(fnffa)
    
    call open_file(unit=8,file=trim(fnffr),form='formatted',status='replace')
    call open_file(unit=9,file=trim(fnffa),form='formatted',status='replace')
    
    eps_static=epsR(1)
    eps_dynamic=eps_static
    
    do i=1,nFreq
      omega=dFreqGrid(i)
      write(8,100)omega,epsR(i)
      write(9,100)omega,epsA(i)
      if (i .gt. 1) then
        eps_dynamic=eps_dynamic-(2.0d0/PI_D)*(dFreqGrid(i)-dFreqGrid(i-1))* &
          IMAG(epsR(i))*((1.0d0/omega)-1.0d0/(omega+ebind))
      endif
    enddo
    write(6,*) 'Static Head:', eps_static, 'Dynamic Head:', eps_dynamic
    write(6,*)
      
    call close_file(8)
    call close_file(9)
  endif

!-----------------------------
! deallocate and finish
  
  SAFE_DEALLOCATE(epsPP)
  SAFE_DEALLOCATE(epsR)
  SAFE_DEALLOCATE(epsA)
  SAFE_DEALLOCATE(dFreqGrid)
  SAFE_DEALLOCATE(dFreqBrd)
  
100 format(3f25.15)
  
end program epsinvomega

!============================================================================
!
! Routines:
!
! (1) mtxel()   Originally By ?         Last Modified 7/8/2008 (JRD)
!
!     Subroutine computes required matrix elements
!     of the form <nn,k|exp{i(q+g).r}|n1,k-q>
!
!     input   nn               band index
!     input   ncoul              number of matrix elements required
!     input   isrtrq             index array for g-vectors in
!                                <nk|exp(i(q+g).r)|n1k-q>
!     output  aqs                matrix elements required
!
!============================================================================

#include "f_defs.h"

subroutine mtxel(nn,gvec,wfnkq,wfnk,ncoul,isrtrq,aqs,ispin,kp)

  use global_m
  use fftw_m
  use misc_m
  implicit none

  integer, intent(in) :: nn
  type (gspace), intent(in) :: gvec
  type (wfnkqstates), intent(in) :: wfnkq
  type (wfnkstates), intent(in) :: wfnk
  type (kpoints), intent(inout) :: kp
  integer, intent(in) :: ncoul
  integer, intent(in) :: isrtrq(gvec%ng)
  SCALAR, intent(out) :: aqs(ncoul,peinf%ntband_max)
  integer, intent(in) :: ispin

  integer :: n1,jspinor,jspinormin,jspinormax

!-------------------------
! If we are using FFT to calculate matrix elements...

! We use FFT to compute <u_nn,k|e^(iG.r)|u_n1,k-q> elements where
! u_nk is the periodic part of the wave function.
! The calculation is done in real space, and integration over
! the grid is replaced by the sum over the grid points p:
!
! <u_nn,k|e^(iG.r)|u_n1,k-q>  =
!     Volume/Np * sum_p { conj(u_nn,k(p))*e^(iG.p)*u_n1k-q(p) }
!
! Since u_nk(p) = Volume^-0.5 * sum_G { cnk(G)*e^(iG.p) },
! and FFT is defined as FFT(cnk,+,p) = sum_G { cnk(G)*e^{+iG.p} },
! we must compute
!
! <u_nn,k|e^(iG.r)|u_n1,k-q>
!   = 1/Np * sum_p { conj(FFT(c_nn k,+,p))*e^(iG.p)*FFT(c_n1 k-q,+,p) }
!   = 1/Np * FFT(conj(FFT(c_nn k,+,:)).*FFT(c_n1 k-q,+,:),+,G)
!
! where .* is a point by point multiplication on the grid

  complex(DPC), dimension(:,:,:), allocatable :: fftbox1,fftbox2
  integer, dimension(3) :: Nfft
  real(DP) :: scale
  SCALAR, dimension(:), allocatable :: tmparray

! Compute size of FFT box we need and scale factor

  PUSH_SUB(mtxel)

  call setup_FFT_sizes(gvec%FFTgrid,Nfft,scale)

! Allocate FFT boxes

  SAFE_ALLOCATE(fftbox1, (Nfft(1),Nfft(2),Nfft(3)))
  SAFE_ALLOCATE(fftbox2, (Nfft(1),Nfft(2),Nfft(3)))

! Put the data for band nn into FFT box 1 and do the FFT,zk(:,1)

  call set_jspinor(jspinormin,jspinormax,ispin,kp%nspinor)

  SAFE_ALLOCATE(tmparray, (ncoul))

  do jspinor = jspinormin,jspinormax

    call put_into_fftbox(wfnk%nkpt,wfnk%zk((nn-1)*wfnk%nkpt+1:,jspinor),gvec%components,wfnk%isrtk,fftbox1,Nfft)
    call do_FFT(fftbox1,Nfft,1)

! We need the complex conjugate of the |nk> band actually

    call conjg_fftbox(fftbox1,Nfft)

! Now we loop over the n1 states and get the matrix elements:
!  Get n1 wave function and put it into box 2,
!  do FFT,
!  multiply by box1 contents,
!  do FFT again,
!  and extract the resulting matrix elements

    do n1=1,peinf%ntband_node
      call put_into_fftbox(wfnkq%nkpt,wfnkq%zkq((n1-1)*wfnkq%nkpt+1:,jspinor),gvec%components,wfnkq%isrtkq,fftbox2,Nfft)
      call do_FFT(fftbox2,Nfft,1)
      call multiply_fftboxes(fftbox1,fftbox2,Nfft)
      call do_FFT(fftbox2,Nfft,1)
      call get_from_fftbox(ncoul,tmparray,gvec%components,isrtrq,fftbox2,Nfft,scale)
      if (kp%nspinor.eq.1 .or. jspinor.eq. 1) then
        aqs(:,n1) = tmparray(:)
      else
        aqs(:,n1) = aqs(:,n1) + tmparray(:)
      endif

    enddo

  enddo

  SAFE_DEALLOCATE(tmparray)

! We are done, so deallocate FFT boxes

  SAFE_DEALLOCATE(fftbox1)
  SAFE_DEALLOCATE(fftbox2)
  
  POP_SUB(mtxel)
  
  return
end subroutine mtxel

#include "f_defs.h"

!-----------------------------------------------------------------------
subroutine genwf_kernel(crys,gvec,kg,kgq,syms, &
  wfnc,wfnv,nspin,ik,ic,iv,indexq,xct,intwfnv,intwfnc)
!
!     input: crys, gvec, kg,  syms types
!            nspin  (number of spins)
!            ik     (index of k-point in full BZ)
!            ib     (index of ck block)
!     output: wfnc   (conduction states at point ik, block ib)
!             wfnv   (valence states at point ik)
!
!-----------------------------------------------------------------------

  use global_m
  use blas_m
  use gmap_m
  use spinor_symmetries_m
  use input_utils_m
  use sort_m
  implicit none

  type (crystal), intent(in) :: crys
  type (gspace), intent(in) :: gvec
  type (grid), intent(in) :: kg
  type (grid), intent(in) :: kgq
  type (symmetry), intent(in) :: syms
  type (wavefunction), intent(out) :: wfnc,wfnv
  integer, intent(in) :: nspin,ik,ic,iv
  integer, intent(in) :: indexq(kg%nf)
  type (int_wavefunction), intent(in) :: intwfnc,intwfnv
  type (xctinfo), intent(in) :: xct
      
  character :: errmsg*100
  integer :: cnb,cng,cns,vng,vns
  integer :: ii,kk,info
  integer :: ivown,icown,ikown,invband,incband,ijk
  real(DP) :: xnorm,qk(3)
  
  integer, save :: ikold=0
  integer, save :: ikold2=0
  integer, save :: vngold=0
  integer, save :: cngold=0
  integer, save :: ifirst=0
  
  integer, allocatable :: isorti(:)
  integer, allocatable :: ind(:),isort(:)
  integer, allocatable :: indq(:),isortq(:)
  integer, allocatable, save :: ind_old(:),isort_old(:)
  integer, allocatable, save :: indq_old(:),isortq_old(:)
  integer, allocatable, save :: ind_old2(:),isort_old2(:)
  integer, allocatable, save :: indq_old2(:),isortq_old2(:)
  real(DP), allocatable :: ekin(:)
  SCALAR, allocatable :: ccg(:,:,:),vcg(:,:,:),ph(:),phq(:)
  SCALAR, allocatable, save :: ph_old(:),phq_old(:)
  SCALAR, allocatable, save :: ph_old2(:),phq_old2(:)

  PUSH_SUB(genwf_kernel)

!-----------------------------------------------------------------------
! Deal with the valence wavefunctions

!      write(6,*) peinf%inode, 'in genwf',iv,ic,ik

  if (xct%qflag .eq. 0) then
    ivown = peinf%ipev(peinf%inode+1,iv,kgq%indr(indexq(ik)))
    ikown = peinf%ipek(peinf%inode+1,kgq%indr(indexq(ik)))
  elseif (xct%qflag .eq. 2) then
  else
    ivown = peinf%ipev(peinf%inode+1,iv,kg%indr(ik))
    ikown = peinf%ipek(peinf%inode+1,kg%indr(ik))
  endif
  
  vng = intwfnv%ng(ikown)
  vns = intwfnv%nspin
  if (xct%ivpar .eq. 1) then
    SAFE_ALLOCATE(vcg, (vng,1,vns))
  else
    SAFE_ALLOCATE(vcg, (vng,xct%nvb_co,vns))
  endif
  
  SAFE_ALLOCATE(indq, (vng))
  SAFE_ALLOCATE(phq, (vng))
  SAFE_ALLOCATE(isortq, (gvec%ng))

  if (ik .ne. ikold .and. ik .ne. ikold2 .and. ifirst .ne. 0) then
    SAFE_DEALLOCATE(indq_old2)
    SAFE_DEALLOCATE(phq_old2)
    SAFE_DEALLOCATE(isortq_old2)
    SAFE_ALLOCATE(indq_old2, (vngold))
    SAFE_ALLOCATE(phq_old2, (vngold))
    SAFE_ALLOCATE(isortq_old2, (gvec%ng))

    indq_old2 = indq_old
    phq_old2 = phq_old
    isortq_old2 = isortq_old

    SAFE_DEALLOCATE(indq_old)
    SAFE_DEALLOCATE(phq_old)
    SAFE_DEALLOCATE(isortq_old)
    SAFE_ALLOCATE(indq_old, (vng))
    SAFE_ALLOCATE(phq_old, (vng))
    SAFE_ALLOCATE(isortq_old, (gvec%ng))
  endif
  if (ifirst .eq. 0) then
    SAFE_ALLOCATE(indq_old, (vng))
    SAFE_ALLOCATE(phq_old, (vng))
    SAFE_ALLOCATE(isortq_old, (gvec%ng))
    SAFE_ALLOCATE(indq_old2, (vng))
    SAFE_ALLOCATE(phq_old2, (vng))
    SAFE_ALLOCATE(isortq_old2, (gvec%ng))
  endif
  
! Initalize parameters in variable wfnv

  wfnv%ng=vng
  wfnv%nband=1
  wfnv%nspin=vns
  if (intwfnv%nspin.ne.nspin) then
    write(errmsg,'(2a,2i2)') 'spin number mismatch: ', nspin, vns
    call die(errmsg, only_root_writes = .true.)
  endif

  if (xct%ivpar .eq. 1) then
    SAFE_ALLOCATE(wfnv%cg, (wfnv%ng,1,wfnv%nspin))
    vcg(1:vng,1,:) = intwfnv%cg(1:vng,ivown,:)
  else
    SAFE_ALLOCATE(wfnv%cg, (wfnv%ng,xct%nvb_co,wfnv%nspin))        
    vcg(1:vng,:,:) = intwfnv%cg(1:vng,ivown:ivown+xct%nvb_co-1,:)
  endif
  SAFE_ALLOCATE(wfnv%isort, (gvec%ng))
  
  isortq(:) = intwfnv%isort(:,ikown)

! Compute inverse index array of Fourier components around rk-kpoint

  if (ik .ne. ikold .and. ik .ne. ikold2) then
    SAFE_ALLOCATE(isorti, (gvec%ng))
    isorti(:)=0
    do ii=1,wfnv%ng
      isorti(isortq(ii))=ii
    enddo
  endif

! Compute index array of Fourier components around fk-kpoint

  if (ik .ne. ikold .and. ik .ne. ikold2) then
#ifdef VERBOSE
    write(6,*) 'ikneikold',peinf%inode,ik,ikold
#endif
    SAFE_ALLOCATE(ekin, (gvec%ng))
    if ((xct%qflag .eq. 0) .or. (xct%qflag .eq. 2)) then
      qk(1:3)=kgq%f(1:3,indexq(ik))
    else
      qk(1:3)=kg%f(1:3,ik)
    endif
    call kinetic_energies(gvec, crys%bdot, ekin, qvec = qk)
    call sortrx(gvec%ng,ekin,isortq)
    SAFE_DEALLOCATE(ekin)
    isortq_old(:)=isortq(:)
  else if (ik .eq. ikold) then
    isortq(:)=isortq_old(:)
  else 
    isortq(:)=isortq_old2(:)
  endif

! Find ind and ph relating wavefunctions in fk to rk-kpoint

  if (ik .ne. ikold .and. ik .ne. ikold2) then
    indq=0
    phq=ZERO
    if (xct%qflag .eq. 0) then
    else
      call gmap(gvec,syms,wfnv%ng,kg%itran(ik), &
        kg%kg0(:,ik),isortq,isorti,indq,phq,.true.)
    endif
    SAFE_DEALLOCATE(isorti)
    indq_old(:)=indq(:)
    phq_old(:)=phq(:)
  else if (ik .eq. ikold) then
    indq(:)=indq_old(:)
    phq(:)=phq_old(:)
  else
    indq(:)=indq_old2(:)
    phq(:)=phq_old2(:)
  endif

! Compute and renormalize valence wavefunctions in fk-kpoint

  if (xct%ivpar .eq. 1) invband = 1
  if (xct%ivpar .eq. 0) invband = xct%nvb_co
  
  do ijk = 1, invband
    do kk=1,wfnv%nspin
      do ii=1,wfnv%ng
        if (indq(ii) .gt. 0) then
          wfnv%cg(ii,ijk,kk)=phq(ii)*vcg(indq(ii),ijk,kk)
        else
          wfnv%cg(ii,ijk,kk) = ZERO
        endif
      enddo
      xnorm = blas_nrm2(wfnv%ng, wfnv%cg(:, ijk, kk), 1)
      wfnv%cg(1:wfnv%ng,ijk,kk)=wfnv%cg(1:wfnv%ng,ijk,kk)/xnorm
      if (abs(1.0d0-xnorm).gt.TOL_Small) then
        write(0,*) 'WARNING: bad normalization for wfnv', &
          kk,1,peinf%inode,xnorm
        if (xct%qflag .eq. 0) then
          write(0,*) 'ik,indexq,itran,kg0',ik,indexq(ik), &
            kgq%itran(indexq(ik)),kgq%kg0(:,ik)
          write(0,*) 'syms%tnp: ', syms%tnp(:,kgq%itran(indexq(ik)))
        elseif (xct%qflag .eq.2 ) then
          write(0,*) 'ik,indexq,itran,kg0',ik,indexq(ik), &
            kg%itran(ik),kgq%kg0(:,indexq(ik))
          write(0,*) 'syms%tnp: ', syms%tnp(:,kgq%itran(indexq(ik)))
        else
          write(0,*) 'ik,indexq,itran,kg0',ik,indexq(ik), &
            kg%itran(indexq(ik)),kg%kg0(:,ik)
          write(0,*) 'syms%tnp: ', syms%tnp(:,kg%itran(indexq(ik)))
        endif
        write(0,*) 'wfnv%ng,vng: ', wfnv%ng,vng
        info = 0
        do ii=1,wfnv%ng
          if (abs(phq(ii)).lt.1.0d-5 .or. &
            abs(phq(ii)) .gt. 2d0) info=info+1
        enddo
        xnorm = blas_nrm2(wfnv%ng, vcg(:, ijk, kk), 1)
        write(0,*) 'WARNING: proc,# of ph() bad,|vcg|', &
          peinf%inode,info,xnorm
      endif
    enddo
  enddo
  
  vcg=wfnv%cg
  wfnv%isort=isortq
  
  SAFE_DEALLOCATE(vcg)
  SAFE_DEALLOCATE(indq)
  SAFE_DEALLOCATE(phq)
  SAFE_DEALLOCATE(isortq)
  
!-----------------------------------------------------------------------
! Deal with the conduction wavefunctions

  icown = peinf%ipec(peinf%inode+1,ic,kg%indr(ik))
  ikown = peinf%ipek(peinf%inode+1,kg%indr(ik))
  
  cng = intwfnc%ng(ikown)
  cnb = 1
  cns = intwfnc%nspin
  
  if (xct%icpar .eq. 1) then
    SAFE_ALLOCATE(ccg, (cng,1,cns))
  else
    SAFE_ALLOCATE(ccg, (cng,xct%ncb_co,cns))
  endif
  
  SAFE_ALLOCATE(ind, (cng))
  SAFE_ALLOCATE(ph, (cng))
  SAFE_ALLOCATE(isort, (gvec%ng))

  if (ik .ne. ikold .and. ik .ne. ikold2 .and. ifirst .ne. 0) then
    SAFE_DEALLOCATE(ind_old2)
    SAFE_DEALLOCATE(ph_old2)
    SAFE_DEALLOCATE(isort_old2)
    SAFE_ALLOCATE(ind_old2, (cngold))
    SAFE_ALLOCATE(ph_old2, (cngold))
    SAFE_ALLOCATE(isort_old2, (gvec%ng))

    ind_old2 = ind_old
    ph_old2 = ph_old
    isort_old2 = isort_old

    SAFE_DEALLOCATE(ind_old)
    SAFE_DEALLOCATE(ph_old)
    SAFE_DEALLOCATE(isort_old)
    SAFE_ALLOCATE(ind_old, (cng))
    SAFE_ALLOCATE(ph_old, (cng))
    SAFE_ALLOCATE(isort_old, (gvec%ng))
  endif
  if (ifirst .eq. 0) then
    SAFE_ALLOCATE(ind_old, (cng))
    SAFE_ALLOCATE(ph_old, (cng))
    SAFE_ALLOCATE(isort_old, (gvec%ng))
    SAFE_ALLOCATE(ind_old2, (cng))
    SAFE_ALLOCATE(ph_old2, (cng))
    SAFE_ALLOCATE(isort_old2, (gvec%ng))
  endif
  
  wfnc%ng=cng
  wfnc%nband=1
  wfnc%nspin=cns
  
  if (cns.ne.nspin) then
    write(errmsg,'(2a,2i2)') 'spin number mismatch: ', nspin, cns
    call die(errmsg, only_root_writes = .true.)
  endif

  SAFE_ALLOCATE(wfnc%isort, (gvec%ng))
  
  isort(:)=intwfnc%isort(:,ikown)
  if (xct%icpar .eq. 1) then
    SAFE_ALLOCATE(wfnc%cg, (wfnc%ng,1,wfnc%nspin))
    ccg(1:cng,1,:) = intwfnc%cg(1:cng,icown,:)
  else
    SAFE_ALLOCATE(wfnc%cg, (wfnc%ng,xct%ncb_co,wfnc%nspin))
    ccg(1:cng,:,:) = intwfnc%cg(1:cng,icown:icown+xct%ncb_co-1,:)
  endif

! JRD: Below is now necessary because kg might be different from kgq
! Compute inverse index array of Fourier components around rk-kpoint

  if (ik .ne. ikold .and. ik .ne. ikold2) then
    SAFE_ALLOCATE(isorti, (gvec%ng))
    isorti(:)=0
    do ii=1,wfnc%ng
      isorti(isort(ii))=ii
    enddo
  endif
  
! Compute index array of Fourier components around fk-kpoint

  if (ik .ne. ikold .and. ik .ne. ikold2) then
    SAFE_ALLOCATE(ekin, (gvec%ng))
    call kinetic_energies(gvec, crys%bdot, ekin, qvec = kg%f(:, ik))
    call sortrx(gvec%ng,ekin,isort)
    SAFE_DEALLOCATE(ekin)
    isort_old(:) = isort(:)
  else if (ik .eq. ikold) then
    isort(:)=isort_old(:)
  else
    isort(:)=isort_old2(:)
  endif

! Find ind and ph relating wavefunctions in fk to rk-kpoint

  if (ik .ne. ikold .and. ik .ne. ikold2) then
    ind=0
    ph=ZERO
    call gmap(gvec,syms,wfnc%ng,kg%itran(ik), &
      kg%kg0(:,ik),isort,isorti,ind,ph,.true.)
    SAFE_DEALLOCATE(isorti)
    ind_old(:)=ind(:)
    ph_old(:)=ph(:)
  else if (ik .eq. ikold) then
    ind(:)=ind_old(:)
    ph(:)=ph_old(:)
  else
    ind(:)=ind_old2(:)
    ph(:)=ph_old2(:)
  endif

! Compute and renormalize conduction wavefunctions

  if (xct%icpar .eq. 1) incband =1
  if (xct%icpar .eq. 0) incband = xct%ncb_co
  
  do ijk =1, incband
    do kk=1,wfnc%nspin
      do ii=1,wfnc%ng
        if (ind(ii) .gt. 0) then
          wfnc%cg(ii,ijk,kk)=ph(ii)*ccg(ind(ii),ijk,kk)
        else
          wfnc%cg(ii,ijk,kk)=ZERO
        endif
      enddo
      xnorm = blas_nrm2(wfnc%ng, wfnc%cg(:,ijk,kk), 1)
      wfnc%cg(1:wfnc%ng,ijk,kk)=wfnc%cg(1:wfnc%ng,ijk,kk)/xnorm
      if (abs(1.0d0-xnorm).gt.TOL_Small) then
        write(0,*) 'WARNING: bad normalization for wfnc', &
          kk,1,peinf%inode,xnorm
        info = 0
        do ii=1,wfnc%ng
          if (abs(ph(ii)).lt.1.0d-5) info=info+1
        enddo
        xnorm = blas_nrm2(wfnc%ng, ccg(:,ijk,kk), 1)
        write(0,*) 'WARNING: proc,# of ph()=0,|ccg|', &
          peinf%inode,info,xnorm
      endif
    enddo
  enddo
  wfnc%isort=isort
  
  SAFE_DEALLOCATE(ccg)
  SAFE_DEALLOCATE(ind)
  SAFE_DEALLOCATE(ph)
  SAFE_DEALLOCATE(isort)
  
  if (ik .ne. ikold .and. ik .ne. ikold2) then
    ikold2=ikold
    ikold=ik
    cngold=cng
    vngold=vng
  endif

  ifirst=-1
  
  POP_SUB(genwf_kernel)
  
  return
end subroutine genwf_kernel

!===========================================================================
!
! Routines:
!
! (1) Xinvert_with_scalapack_d() Originally By JRD       Last Modified 11/2/2010 (DAS)
!
!     This routine inverts a matrix which is already distributed in block-diagonal
!     form with scaLAPACK.
!
! (2) Xinvert_serial()      Originally By JRD       Last Modified 11/2/2010 (DAS)
!
!     Inverts a matrix using LAPACK or ESSL.
!
!============================================================================

module inversion_m

  use global_m
#ifdef USEESSL
  use essl_m
#else
  use lapack_m
#endif
  use scalapack_m
  implicit none

  private

  public :: &
#ifdef USESCALAPACK
    dinvert_with_scalapack,  &
    zinvert_with_scalapack,  &
#endif
    dinvert_serial,          &
    zinvert_serial

contains

!overrules flavor.mk
#undef CPLX
#include "f_defs.h"
#include "inversion_inc.f90"

#include "undef.h"

#define CPLX
#include "f_defs.h"
#include "inversion_inc.f90"

end module inversion_m

!! Local Variables:
!! mode: f90
!! coding: utf-8
!! End:

!==============================================================================
!
! Modules:
!
! chi_summation_m                               Last Modified: 04/19/2012 (FHJ)
!
!   This module creates the (distributed) polarizability matrix chi by summing
!   the (distributed) pol%gme matrices. There are routines that communicate the
!   gme matrix using either matrix or element partitioning scheme.
!
!==============================================================================

#include "f_defs.h"

module chi_summation_m

  use global_m
  use blas_m
  use mtxelmultiply_m
  use scalapack_m
  use lin_denominator_m
  use io_utils_m

  implicit none

  private

  public :: create_chi_summator, free_chi_summator,&
    chi_summation_comm_matrix, chi_summation_comm_elements

  !> FHJ: the chi_summator "object"
  type chi_summator_t 
    real(DP) :: fact
    !> DWV: below are some temporary buffers needed for the chi summation. They are
    !! described in detail in this comment.
    !! gme = g-vector matrix element
    !! gmetempX where X = n,r,c are temporary arrays for static calculations
    !! n = normalized by the proper factor used in BGW
    !! r = row, meaning the matrix elements for all bands (nv*nc*nk) that the proc owns
    !! for the G-vectors in the rows of chi currently being computed
    !! c = column, the matrix elements for all bands (nv*nc*nk) that the proc owns
    !! for the G`-vectors in the rows of chi currently being computed
    !! the RDyn arrays are needed for full-frequency (FF) calculations, real and complex
    !! while the Adyn arrays are needed only for complex FF calculations
    !! r2 is used in FF with matrix communication because you have a different denominator for 
    !! each frequency. Only the r2 array (not the r) array is used for element communication
    !! the denominators are built into the gme`s for static calculations
    !! eden arrays hold the energy denominators for FF
    !! chilocal holds the contribution of a given processor to the GG` chunk of epsilon
    !! being computed
    !! chilocal2 holds the MPI reduced GG` chunk of epsilon being computed 
    SCALAR, allocatable :: chilocal(:,:)
    SCALAR, allocatable :: chilocal2(:,:,:)
    complex(DPC), allocatable :: chilocalRDyn(:,:,:)
    complex(DPC), allocatable :: chilocal2RDyn(:,:,:,:)
    complex(DPC), allocatable :: chiRDyntmp(:)
    SCALAR, allocatable :: gmetempr(:,:),gmetempc(:,:)
    SCALAR, allocatable :: gmetempn(:)
    complex(DPC), allocatable :: gmeRDyntempn(:)
    complex(DPC), allocatable :: gmeRDyntempr2(:,:,:)
    complex(DPC), allocatable :: gmeRDyntempc(:,:)
    complex(DPC), allocatable :: gmeRDyntempcs(:,:)

#ifdef CPLX
    complex(DPC), allocatable :: chiADyntmp(:)
    complex(DPC), allocatable :: chilocalADyn(:,:,:)
    complex(DPC), allocatable :: chilocal2ADyn(:,:,:,:)
    complex(DPC), allocatable :: gmeADyntempn(:)
    complex(DPC), allocatable :: gmeADyntempr2(:,:,:)
    complex(DPC), allocatable :: gmeADyntempc(:,:) 
#endif
    integer, allocatable :: deltaCount(:,:)
    integer, allocatable :: deltaCountReduce(:,:)
  end type chi_summator_t

  public :: chi_summator_t

contains

  subroutine create_chi_summator(this, pol, fact)
    type(chi_summator_t), intent(INOUT) :: this !<the chi_summator_t object
    type(polarizability), intent(IN) :: pol
    real(DP), intent(IN) :: fact

    PUSH_SUB(create_chi_summator)

    this%fact = fact

    if (pol%freq_dep .eq. 0) then
      SAFE_ALLOCATE(this%gmetempn, (pol%nmtx))
    endif
    if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 0)) then
      SAFE_ALLOCATE(this%gmeRDyntempn, (pol%nmtx))
      SAFE_ALLOCATE(this%chiRDyntmp, (pol%os_nfreq_para))
#ifdef CPLX
      SAFE_ALLOCATE(this%gmeADyntempn, (pol%nmtx))
      SAFE_ALLOCATE(this%chiADyntmp, (pol%os_nfreq_para))
#endif
    endif
    if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 1)) then
      SAFE_ALLOCATE(this%gmeRDyntempn, (pol%nmtx))
      SAFE_ALLOCATE(this%chiRDyntmp, (pol%os_nfreq_para))
    endif
    if (pol%freq_dep .eq. 3) then
      SAFE_ALLOCATE(this%gmeRDyntempn, (pol%nmtx))
      SAFE_ALLOCATE(this%chiRDyntmp, (pol%os_nfreq_para))
    endif

    POP_SUB(create_chi_summator)
    return

  end subroutine create_chi_summator

  subroutine free_chi_summator(this, pol)
    type(chi_summator_t), intent(INOUT) :: this !<the chi_summator_t object
    type(polarizability), intent(IN) :: pol

    PUSH_SUB(free_chi_summator)

    if (pol%freq_dep .eq. 0) then
      SAFE_DEALLOCATE(this%gmetempn)
    endif
    if (pol%freq_dep .eq. 2) then
      SAFE_DEALLOCATE(this%gmeRDyntempn)
      SAFE_DEALLOCATE(this%chiRDyntmp)
#ifdef CPLX
      SAFE_DEALLOCATE(this%gmeADyntempn)
      SAFE_DEALLOCATE(this%chiADyntmp)
#endif
    endif
    if (pol%freq_dep .eq. 3) then
      SAFE_DEALLOCATE(this%gmeRDyntempn)
      SAFE_DEALLOCATE(this%chiRDyntmp)
    endif

    POP_SUB(free_chi_summator)
    return

  end subroutine free_chi_summator

  !-----------------------------------------------------------------------------
  !                              GCOMM_MATRIX
  !-----------------------------------------------------------------------------

  !> Create the pol%chi matrix using gcomm_matrix sceheme
  subroutine chi_summation_comm_matrix(this,pol,scal,kp,kpq,vwfn,&
    nst,nrk,indt,pht)
    type(chi_summator_t), intent(INOUT) :: this
    type(polarizability), intent(INOUT) :: pol
    type(scalapack), intent(in) :: scal
    type(kpoints), intent(IN) :: kp,kpq
    type(valence_wfns), intent(IN) :: vwfn

    integer, intent(IN) :: nst(:)
    integer, intent(IN) :: nrk
    integer, intent(INOUT) :: indt(:,:,:)
    SCALAR,  intent(INOUT) :: pht(:,:,:)

    integer :: ntot_members(pol%os_para_freqs)
    integer :: icurr,ntot,ntot2,itot,ntotmax,ifreq_para
    integer :: ipe, ilimit, jj, iv, irk, it, ispin,im,mytot
    integer :: i_myband,tag,irank,grp_mtxel_start,tmp_iv,im_proc
    complex(DPC) :: negfact
    real(DP) :: zvalue, cv_energy
    type(cvpair_info) :: cvpair_temp
    integer, allocatable :: tmprowindex(:),tmpcolindex(:)
    SCALAR, allocatable :: tmprowph(:),tmpcolph(:)
    complex(DPC), allocatable :: gmeRDyntempr(:)
    complex(DPC), allocatable :: edenDRtemp(:)
#ifdef CPLX
    complex(DPC), allocatable :: edenDAtemp(:)
#endif

    ! frequency points for the spectral functions of the polarizability
    integer :: isfreql, isfreqr, nwarn
    real(DP) :: sfreql, sfreqr, wr, wl
    ! Hilbert transform coefficients
    complex(DPC) :: htwR(pol%nfreq,pol%nsfreq), htwA(pol%nfreq,pol%nsfreq)
    complex(DPC) :: c11,c12,c13,c14,c21,c22,c23,c24
    complex(DPC) :: cA11,cA12,cA13,cA14,cA21,cA22,cA23,cA24

    integer :: isf,nf,nsf
    real(DP) :: sf1,sf2
    real(DP) :: step1,step2,fqt,eta
    complex(DPC) :: c1,c2,j_dpc,cA1,cA2

    type(progress_info) :: prog_info

    PUSH_SUB(chi_summation_comm_matrix)

    !call alloc_summation_buffers(pol, this%fact)

    if (pol%freq_dep.eq.0) then
      SAFE_ALLOCATE(this%chilocal2, (scal%npr,scal%npc,kp%nspin))
      this%chilocal2=0
    endif

    if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 0)) then
      SAFE_ALLOCATE(this%chilocal2RDyn, (scal%npr,scal%npc,pol%os_nfreq_para,kp%nspin))
      this%chilocal2RDyn=0
#ifdef CPLX
      SAFE_ALLOCATE(this%chilocal2ADyn, (scal%npr,scal%npc,pol%os_nfreq_para,kp%nspin))
      this%chilocal2ADyn=0
#endif
    endif

! At this moment Shishkin and Kresse method only works for gcomm_elements.
! call die in inread.f90
    if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 1)) then
      SAFE_ALLOCATE(this%chilocal2RDyn, (scal%npr,scal%npc,pol%os_nfreq_para,kp%nspin))
      this%chilocal2RDyn=0
    endif

    if (pol%freq_dep .eq. 3) then
      SAFE_ALLOCATE(this%chilocal2RDyn, (scal%npr,scal%npc,pol%os_nfreq_para,kp%nspin))
      this%chilocal2RDyn=0
    endif

    ntot=0
    ntot2=0

    ntot = peinf%nvownactual*peinf%ncownactual
    do irk = 1, nrk
      ntot2=ntot2 + nst(irk)
    enddo
    ntot=ntot*ntot2
    !-------------------------------------------------------------------
    ! Static Be Here


    if (pol%freq_dep .eq. 0) then

      call progress_init(prog_info, 'building polarizability matrix', 'processor', &
        peinf%npes)
      do ipe = 1, peinf%npes
        call progress_step(prog_info)
        SAFE_ALLOCATE(this%chilocal, (scal%nprd(ipe),scal%npcd(ipe)))
        this%chilocal=0D0
        SAFE_ALLOCATE(this%gmetempr, (scal%nprd(ipe),ntot))
        SAFE_ALLOCATE(this%gmetempc, (ntot,scal%npcd(ipe)))

        do ispin = 1 , kp%nspin

          call mtxelmultiply(scal,ntot,nrk,nst,this%fact,vwfn, &
            this%gmetempr,this%gmetempc,this%chilocal,pol%gme,pol,indt,pht,ipe,ispin)

          if (peinf%inode.eq.0) call timacc(14,1)

#ifdef MPI
          call MPI_Reduce(this%chilocal(1,1),this%chilocal2(1,1,ispin),scal%npcd(ipe)*scal%nprd(ipe),MPI_SCALAR, &
            MPI_SUM,ipe-1,MPI_COMM_WORLD,mpierr)

#else
          this%chilocal2(:,:,ispin)=this%chilocal(:,:)
#endif
          if (peinf%inode.eq.0) call timacc(14,2)                  
        enddo ! ispin

        SAFE_DEALLOCATE(this%chilocal)
        SAFE_DEALLOCATE(this%gmetempr)
        SAFE_DEALLOCATE(this%gmetempc)

      enddo ! ipe
      call progress_free(prog_info)

      do ispin =1, kp%nspin
        pol%chi(:,:,ispin) = this%chilocal2(:,:,ispin)
      enddo
      SAFE_DEALLOCATE(this%chilocal2)

    endif ! pol%freq_dep .eq. 0

    !-------------------------------------
    ! Full Frequency Be Here

    negfact = -1D0*this%fact

    if ( ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 0)) .or. pol%freq_dep .eq. 3 ) then
      grp_mtxel_start=peinf%inode !for non-parallel freq case
      if(pol%os_para_freqs .gt. 1) then
      endif

      call progress_init(prog_info, 'building polarizability matrix', 'processor', &
        peinf%npes_freqgrp)
      do ipe = 1, peinf%npes_freqgrp
        call progress_step(prog_info)
#ifdef VERBOSE
        if(peinf%inode.eq.0) then
          write(6,'(A,i8,6x,A,i8,A)') '### ipe=',ipe,'(npes=',peinf%npes,')'
        endif
#endif
#ifdef MPI
        call MPI_barrier(MPI_COMM_WORLD,mpierr)
#endif
        SAFE_ALLOCATE(this%gmeRDyntempr2, (scal%nprd(ipe),ntot,pol%os_nfreq_para))
        SAFE_ALLOCATE(this%gmeRDyntempc, (ntot,scal%npcd(ipe)))
        SAFE_ALLOCATE(this%chilocalRDyn, (scal%nprd(ipe),scal%npcd(ipe),pol%os_nfreq_para))
        this%chilocalRDyn=0
#ifdef CPLX
        if( pol%freq_dep .ne. 3) then
          SAFE_ALLOCATE(this%gmeADyntempr2, (scal%nprd(ipe),ntot,pol%os_nfreq_para))
          SAFE_ALLOCATE(this%gmeADyntempc, (ntot,scal%npcd(ipe)))
          SAFE_ALLOCATE(this%chilocalADyn, (scal%nprd(ipe),scal%npcd(ipe),pol%os_nfreq_para))
          this%chilocalADyn=0
        endif
#endif


        do ispin = 1 , kp%nspin

          itot = 0

          if (peinf%inode.eq.0) call timacc(31,1)

          SAFE_ALLOCATE(tmprowindex,(scal%nprd(ipe)))
          SAFE_ALLOCATE(tmpcolindex,(scal%npcd(ipe)))
          SAFE_ALLOCATE(tmprowph,(scal%nprd(ipe)))
          SAFE_ALLOCATE(tmpcolph,(scal%npcd(ipe)))

          do im=1,pol%os_para_freqs                          ! im labels which member of the mtxel comm group are you
            im_proc=peinf%rank_f+1+(im-1)*peinf%npes_freqgrp ! im_proc gives this mtxel comm group member`s global
            do irk = 1, nrk                                  ! proc number
              do it = 1, nst(irk)

                do icurr=1,scal%nprd(ipe)
                  tmprowindex(icurr) = indt(scal%imyrowd(icurr,ipe),it,irk)
                  tmprowph(icurr) = pht(scal%imyrowd(icurr,ipe),it,irk)
                enddo
                do icurr=1,scal%npcd(ipe)
                  tmpcolindex(icurr) = indt(scal%imycold(icurr,ipe),it,irk)
                  tmpcolph(icurr) = pht(scal%imycold(icurr,ipe),it,irk)
                enddo
                do iv = 1,vwfn%nband+pol%ncrit

                  tmp_iv = peinf%global_indexv(iv,im_proc)

                  if (peinf%does_it_ownv(iv,im_proc)) then
                    ilimit = peinf%global_ncown(im_proc)
                  else
                    ilimit = 0
                  endif
#ifdef CPLX
                  !$OMP PARALLEL private (mytot,zvalue,edenDRtemp,edenDAtemp,gmeRDyntempr,jj,icurr)
                  if( pol%freq_dep .ne. 3) then
                    SAFE_ALLOCATE(edenDAtemp, (pol%os_nfreq_para))
                  endif
#else
                  !$OMP PARALLEL private (mytot,zvalue,edenDRtemp,gmeRDyntempr,jj,icurr)
#endif
                  SAFE_ALLOCATE(gmeRDyntempr, (scal%nprd(ipe)))
                  SAFE_ALLOCATE(edenDRtemp, (pol%os_nfreq_para))
                  !$OMP DO
                  do i_myband = 1, ilimit
                    mytot = itot + i_myband
                    zvalue = pol%edenDyn(peinf%global_indexv(iv,im_proc),i_myband,ispin,irk,im)
                    if(pol%lin_denominator<TOL_Zero) then
                      !this is when the lin_denominator mode is not active.
                      do jj=1+peinf%rank_mtxel,pol%nfreq,pol%os_para_freqs
                        ifreq_para=(jj+pol%os_para_freqs-1)/pol%os_para_freqs
                        if (abs(zvalue) .gt. Tol_Zero) then
                          edenDRtemp(ifreq_para)= -0.5d0*( &
                            1d0/(zvalue-(pol%dFreqBrd(jj)+pol%dFreqGrid(jj))/ryd)+ &
                            1d0/(zvalue+(pol%dFreqBrd(jj)+pol%dFreqGrid(jj))/ryd))
                        else
                          edenDRtemp(ifreq_para)= 0D0
                        endif
                      enddo

                    endif 
#ifdef CPLX
                    if(pol%freq_dep.ne. 3) then
                      if(pol%lin_denominator<TOL_Zero) then
                        !this is when the lin_denominator mode is not active.
                        do jj=1+peinf%rank_mtxel,pol%nfreq,pol%os_para_freqs
                          ifreq_para=(jj+pol%os_para_freqs-1)/pol%os_para_freqs
                          if (abs(zvalue) .gt. Tol_Zero) then
                            edenDAtemp(ifreq_para)= -0.5d0*( &
                              1d0/(zvalue-(-pol%dFreqBrd(jj)+pol%dFreqGrid(jj))/ryd)+ &
                              1d0/(zvalue+(-pol%dFreqBrd(jj)+pol%dFreqGrid(jj))/ryd))
                          else
                            edenDAtemp(ifreq_para)= 0D0
                          endif
                        enddo

                      endif
                    endif
#endif

                    do icurr=1,scal%nprd(ipe)
                      gmeRDyntempr(icurr)=pol%gme(tmprowindex(icurr), &
                        i_myband,tmp_iv,ispin,irk,im) * tmprowph(icurr)
                    enddo
                    do jj = 1+peinf%rank_mtxel,pol%nfreq,pol%os_para_freqs
                      ifreq_para=(jj+pol%os_para_freqs-1)/pol%os_para_freqs
                      this%gmeRDyntempr2(:,mytot,ifreq_para)=gmeRDyntempr(:)*edenDRtemp(ifreq_para)
                    enddo
                    do icurr=1,scal%npcd(ipe)
                      this%gmeRDyntempc(mytot,icurr) = &
                        MYCONJG( pol%gme(tmpcolindex(icurr),i_myband,tmp_iv,ispin,irk,im) * tmpcolph(icurr) )
                    enddo
#ifdef CPLX
                    if( pol%freq_dep .ne. 3) then
                      do jj = 1+peinf%rank_mtxel,pol%nfreq,pol%os_para_freqs
                        ifreq_para=(jj+pol%os_para_freqs-1)/pol%os_para_freqs
! POSSIBLY BAD FOR OPENMP
                        this%gmeADyntempr2(:,mytot,ifreq_para)=gmeRDyntempr(:)*edenDAtemp(ifreq_para)
                      enddo
                      do icurr=1,scal%npcd(ipe)
! PROBABLY BAD FOR OPENMP
                        this%gmeADyntempc(mytot,icurr)= &
                          MYCONJG( pol%gme(tmpcolindex(icurr),i_myband,tmp_iv,ispin,irk,im) * tmpcolph(icurr) )
                      enddo
                    endif
#endif
                  enddo ! i_myband
                  !$OMP END DO
                  SAFE_DEALLOCATE(edenDRtemp)
#ifdef CPLX
                  if( pol%freq_dep .ne. 3) then
                    SAFE_DEALLOCATE(edenDAtemp)
                  endif
#endif           
                  SAFE_DEALLOCATE(gmeRDyntempr)
                  !$OMP END PARALLEL
                  itot = itot+ilimit
                enddo ! iv
              enddo ! it
            enddo ! irk
          enddo ! im

          SAFE_DEALLOCATE(tmprowindex)
          SAFE_DEALLOCATE(tmpcolindex)
          SAFE_DEALLOCATE(tmprowph)
          SAFE_DEALLOCATE(tmpcolph)

          if (peinf%inode.eq.0) call timacc(31,2)          

          !Do the zgemm`s
          if(ntot > 0) then
            do jj =1+peinf%rank_mtxel,pol%nfreq,pol%os_para_freqs
              ifreq_para=(jj+pol%os_para_freqs-1)/pol%os_para_freqs
              if (peinf%inode.eq.0) call timacc(30,1)
              call zgemm('n','n',scal%nprd(ipe),scal%npcd(ipe),ntot, &
                negfact,this%gmeRDyntempr2(:,:,ifreq_para),scal%nprd(ipe),this%gmeRDyntempc(:,:),ntot,&
                (0D0,0D0),this%chilocalRDyn(:,:,ifreq_para),scal%nprd(ipe))
              if (peinf%inode.eq.0) call timacc(30,2)
#ifdef CPLX
              if(pol%freq_dep .ne. 3) then
                if (peinf%inode.eq.0) call timacc(30,1)
                call zgemm('n','n',scal%nprd(ipe),scal%npcd(ipe),ntot, &
                  negfact,this%gmeADyntempr2(:,:,ifreq_para),scal%nprd(ipe),this%gmeADyntempc(:,:),ntot,&
                  (0D0,0D0),this%chilocalADyn(:,:,ifreq_para),scal%nprd(ipe))
                if (peinf%inode.eq.0) call timacc(30,2)
              endif
#endif
            enddo
          endif

          if (peinf%inode.eq.0) call timacc(14,1)

          if(pol%os_para_freqs .eq. 1) then            
#ifdef MPI
            call MPI_Reduce(this%chilocalRDyn(1,1,1),this%chilocal2RDyn(1,1,1,ispin), &
              pol%os_nfreq_para*scal%npcd(ipe)*scal%nprd(ipe),MPI_COMPLEX_DPC,&
              MPI_SUM,ipe-1,MPI_COMM_WORLD,mpierr)
#ifdef CPLX
            if(pol%freq_dep .ne. 3) then
              call MPI_Reduce(this%chilocalADyn(1,1,1),this%chilocal2ADyn(1,1,1,ispin), &
                pol%os_nfreq_para*scal%npcd(ipe)*scal%nprd(ipe),MPI_COMPLEX_DPC,&
                MPI_SUM,ipe-1,MPI_COMM_WORLD,mpierr)
            endif
#endif
#endif
          else
#ifdef MPI
            call MPI_Reduce(this%chilocalRDyn(1,1,1),this%chilocal2RDyn(1,1,1,ispin), &
              pol%os_nfreq_para*scal%npcd(ipe)*scal%nprd(ipe),MPI_COMPLEX_DPC,&
              MPI_SUM,ipe-1,peinf%freq_comm,mpierr)
#ifdef CPLX
            if(pol%freq_dep .ne. 3) then
              call MPI_Reduce(this%chilocalADyn(1,1,1),this%chilocal2ADyn(1,1,1,ispin), &
                pol%os_nfreq_para*scal%npcd(ipe)*scal%nprd(ipe),MPI_COMPLEX_DPC,&
                MPI_SUM,ipe-1,peinf%freq_comm,mpierr)
            endif
#endif
#endif
          endif
#ifndef MPI
          this%chilocal2RDyn(:,:,:,ispin)=this%chilocalRDyn(:,:,:)
#ifdef CPLX
          if(pol%freq_dep .ne. 3) then
            this%chilocal2ADyn(:,:,:,ispin)=this%chilocalADyn(:,:,:)
          endif
#endif

#endif
          if (peinf%inode.eq.0) call timacc(14,2)

        enddo ! ispin
        if (peinf%inode.eq.0) call timacc(44,1)
        SAFE_DEALLOCATE(this%chilocalRDyn)
        SAFE_DEALLOCATE(this%gmeRDyntempr2)
        SAFE_DEALLOCATE(this%gmeRDyntempc)
#ifdef CPLX
        if(pol%freq_dep .ne. 3) then
          SAFE_DEALLOCATE(this%chilocalADyn)
          SAFE_DEALLOCATE(this%gmeADyntempr2)
          SAFE_DEALLOCATE(this%gmeADyntempc)
        endif
#endif
        if (peinf%inode.eq.0) call timacc(44,2)
      enddo ! ipe
      call progress_free(prog_info)

      do ispin =1, kp%nspin
        do jj=1+peinf%rank_mtxel,pol%nfreq,pol%os_para_freqs
          ifreq_para=(jj+pol%os_para_freqs-1)/pol%os_para_freqs
          pol%chiRDyn(ifreq_para,:,:,ispin) = this%chilocal2RDyn(:,:,ifreq_para,ispin)
#ifdef CPLX
          if( pol%freq_dep .ne. 3) then
            pol%chiADyn(ifreq_para,:,:,ispin) = this%chilocal2ADyn(:,:,ifreq_para,ispin)
          endif
#endif
        enddo ! jj
      enddo ! ispin
      SAFE_DEALLOCATE(this%chilocal2RDyn)
#ifdef CPLX
      if(pol%freq_dep .ne. 3) then
        SAFE_DEALLOCATE(this%chilocal2ADyn)
      endif
#endif
    endif ! (pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 0)

    !-------------------------------------
    ! Full Frequency Be Here.
    ! M. Shishkin and G. Kresse, Implementation and performance of the 
    ! frequency-dependent GW method within the PAW framework,
    ! PHYSICAL REVIEW B 74, 035101, 2006.

    negfact = -1D0*this%fact

    if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 1)) then
      grp_mtxel_start=peinf%inode !for non-parallel freq case
      if(pol%os_para_freqs .gt. 1) then
      endif

      ! -------------------------------------------
      ! compute the Hilbert transform coefficients
      ! -------------------------------------------
      j_dpc=(0.0,1.0)
      htwR(:,:)=(0.0,0.0)

      nf=pol%nfreq
      nsf=pol%nsfreq
      do jj=1,nf
        eta=pol%dBrdning/ryd
        fqt=pol%dFreqGrid(jj)/ryd
        do isf=1,nsf
          if (isf==1) then
            c1=(0.0,0.0)
            step1=1.0
#ifdef CPLX
            cA1=(0.0,0.0)
            step1=1.0
#endif
          else
            sf1=pol%dSFreqGrid(isf-1)/ryd
            sf2=pol%dSFreqGrid(isf)/ryd
            step1=sf2-sf1

            c11=((sf1-fqt)*(-1.0*j_dpc)-eta)*(atan((fqt-sf2)/(eta))&
              &          -atan((fqt-sf1)/(eta)))
            c12=0.50*(sf1-fqt+(-1.0*j_dpc)*eta)*log(((fqt-sf2)**2.0+eta*eta)&
              &          /(((fqt-sf1)**2.0+eta*eta)))

            c13=-((sf1+fqt)*j_dpc-eta)*(atan((fqt+sf2)/(eta))&
              &          -atan((fqt+sf1)/(eta)))
            c14=0.50*(sf1+fqt+j_dpc*eta)*log(((fqt+sf2)**2.0+eta*eta)&
              &          /(((fqt+sf1)**2.0+eta*eta)))

            c1=c11+c12+c13+c14
            c1=c1/step1

#ifdef CPLX
            cA11=((sf1-fqt)*(j_dpc)-eta)*(atan((fqt-sf2)/(eta))&
              &          -atan((fqt-sf1)/(eta)))
            cA12=0.50*(sf1-fqt+(j_dpc)*eta)*log(((fqt-sf2)**2.0+eta*eta)&
              &          /(((fqt-sf1)**2.0+eta*eta)))

            cA13=-((sf1+fqt)*(-1.0*j_dpc)-eta)*(atan((fqt+sf2)/(eta))&
              &          -atan((fqt+sf1)/(eta)))
            cA14=0.50*(sf1+fqt+(-1.0*j_dpc)*eta)*log(((fqt+sf2)**2.0+eta*eta)&
              &          /(((fqt+sf1)**2.0+eta*eta)))

            cA1=cA11+cA12+cA13+cA14
            cA1=cA1/step1
#endif
          endif

          if (isf==nsf) then
            c2=(0.0,0.0)
            step2=1.0
#ifdef CPLX
            cA2=(0.0,0.0)
            step2=1.0
#endif
          else
            sf1=pol%dSFreqGrid(isf)/ryd
            sf2=pol%dSFreqGrid(isf+1)/ryd

            step2=sf2-sf1

            c21=((sf2-fqt)*(-1.0*j_dpc)-eta)*(atan((fqt-sf1)/(eta))&
              &          -atan((fqt-sf2)/(eta)))
            c22=0.50*(sf2-fqt+(-1.0*j_dpc)*eta)*log(((fqt-sf1)**2.0+eta*eta)&
              &          /(((fqt-sf2)**2.0+eta*eta)))

            c23=-((sf2+fqt)*j_dpc-eta)*(atan((fqt+sf1)/(eta))&
              &          -atan((fqt+sf2)/(eta)))
            c24=0.50*(sf2+fqt+j_dpc*eta)*log(((fqt+sf1)**2.0+eta*eta)&
              &          /(((fqt+sf2)**2.0+eta*eta)))

            c2=c21+c22+c23+c24

            c2=c2/step2

#ifdef CPLX
            cA21=((sf2-fqt)*(j_dpc)-eta)*(atan((fqt-sf1)/(eta))&
              &          -atan((fqt-sf2)/(eta)))
            cA22=0.50*(sf2-fqt+(j_dpc)*eta)*log(((fqt-sf1)**2.0+eta*eta)&
              &          /(((fqt-sf2)**2.0+eta*eta)))

            cA23=-((sf2+fqt)*(-1.0*j_dpc)-eta)*(atan((fqt+sf1)/(eta))&
              &          -atan((fqt+sf2)/(eta)))
            cA24=0.50*(sf2+fqt+(-1.0*j_dpc)*eta)*log(((fqt+sf1)**2.0+eta*eta)&
              &          /(((fqt+sf2)**2.0+eta*eta)))

            cA2=cA21+cA22+cA23+cA24

            cA2=cA2/step2
#endif
          endif

          if (isf==1.or.isf==nsf) then
            htwR(jj,isf)=0.5d0*(c1/step1+c2/step2)
#ifdef CPLX
            htwA(jj,isf)=0.5d0*(cA1/step1+cA2/step2)
#endif
          else
            htwR(jj,isf)=1.0d0*(c1+c2)/(step1+step2)
#ifdef CPLX
            htwA(jj,isf)=1.0d0*(cA1+cA2)/(step1+step2)
#endif
          endif

        enddo
      enddo

      ! ----------------------------------------------------               
      ! compute the spectral functions of the polarizability
      ! ----------------------------------------------------

      call progress_init(prog_info, 'building polarizability matrix', 'processor', &
        peinf%npes_freqgrp)

      nwarn=0
      do ipe = 1, peinf%npes_freqgrp
        call progress_step(prog_info)
#ifdef VERBOSE
        if(peinf%inode.eq.0) then
          write(6,'(A,i8,6x,A,i8,A)') '### ipe=',ipe,'(npes=',peinf%npes,')'
        endif
#endif
#ifdef MPI
        call MPI_barrier(MPI_COMM_WORLD,mpierr)
#endif

        SAFE_ALLOCATE(gmeRDyntempr, (scal%nprd(ipe)))
        SAFE_ALLOCATE(this%gmeRDyntempr2, (scal%nprd(ipe),ntot,pol%os_nsfreq_para))
        SAFE_ALLOCATE(this%gmeRDyntempc, (ntot,scal%npcd(ipe)))
        SAFE_ALLOCATE(this%chilocalRDyn, (scal%nprd(ipe),scal%npcd(ipe),pol%os_nsfreq_para))
        this%chilocalRDyn=0

        gmeRDyntempr=(0.0,0.0)
        this%gmeRDyntempr2=(0.0,0.0)
        this%gmeRDyntempc=(0.0,0.0)

        do ispin = 1 , kp%nspin

          itot = 0

          if (peinf%inode.eq.0) call timacc(31,1)

          SAFE_ALLOCATE(tmprowindex,(scal%nprd(ipe)))
          SAFE_ALLOCATE(tmpcolindex,(scal%npcd(ipe)))
          SAFE_ALLOCATE(tmprowph,(scal%nprd(ipe)))
          SAFE_ALLOCATE(tmpcolph,(scal%npcd(ipe)))

          do im=1,pol%os_para_freqs                          ! im labels which member of the mtxel comm group are you
            im_proc=peinf%rank_f+1+(im-1)*peinf%npes_freqgrp ! im_proc gives this mtxel comm group member`s global
            do irk = 1, nrk                                  ! proc number
              do it = 1, nst(irk)

                do icurr=1,scal%nprd(ipe)
                  tmprowindex(icurr) = indt(scal%imyrowd(icurr,ipe),it,irk)
                  tmprowph(icurr) = pht(scal%imyrowd(icurr,ipe),it,irk)
                enddo
                do icurr=1,scal%npcd(ipe)
                  tmpcolindex(icurr) = indt(scal%imycold(icurr,ipe),it,irk)
                  tmpcolph(icurr) = pht(scal%imycold(icurr,ipe),it,irk)
                enddo

                do iv = 1,vwfn%nband+pol%ncrit

                  tmp_iv = peinf%global_indexv(iv,im_proc)

                  if (peinf%does_it_ownv(iv,im_proc)) then
                    ilimit = peinf%global_ncown(im_proc)
                  else
                    ilimit = 0
                  endif

                  !$OMP PARALLEL private (mytot,zvalue,gmeRDyntempr,icurr, &
                  !$OMP                   isfreql,isfreqr,sfreql,sfreqr, &
                  !$OMP                   wl,wr,i_myband,jj)
                  !$OMP DO
                  do i_myband = 1, ilimit

                    zvalue = -pol%edenDyn(peinf%global_indexv(iv,im_proc),i_myband,ispin,irk,im)
                    if (abs(zvalue) .gt. Tol_Zero) then

                      mytot = itot + i_myband
                      isfreql=-1

                      do jj=pol%nsfreq,1,-1
                        if ((pol%dSFreqGrid(jj)/ryd)<zvalue) then
                          isfreql=jj
                          EXIT
                        endif
                      enddo

                      if (isfreql.eq.pol%nsfreq) then
                        nwarn=nwarn+1
                        if (nwarn==1.and.peinf%inode.eq.0) then
                          write(0,*) 'WARNING: for accuracy, sfrequency_high_cutoff should be '
                          write(0,*) 'larger than energy difference between highest unoccupied '
                          write(0,*) 'state and lowest occupied state.'
                        endif
                        cycle
                      endif

                      sfreql=pol%dSFreqGrid(isfreql)/ryd
                      isfreqr=isfreql+1
                      sfreqr=pol%dSFreqGrid(isfreqr)/ryd
                    
                      wr=  (zvalue-sfreql)/(sfreqr-sfreql)
                      wl= -(zvalue-sfreqr)/(sfreqr-sfreql)
                    
                      do icurr=1,scal%nprd(ipe)
                        gmeRDyntempr(icurr)=pol%gme(tmprowindex(icurr), &
                          i_myband,tmp_iv,ispin,irk,im) * tmprowph(icurr)
                      enddo
                    
                      this%gmeRDyntempr2(:,mytot,isfreql)=gmeRDyntempr(:)*wl
                      this%gmeRDyntempr2(:,mytot,isfreqr)=gmeRDyntempr(:)*wr
                    
                      do icurr=1,scal%npcd(ipe)
                        this%gmeRDyntempc(mytot,icurr) = &
                          MYCONJG( pol%gme(tmpcolindex(icurr),i_myband,tmp_iv,ispin,irk,im) * tmpcolph(icurr) )
                      enddo
                    endif
                  enddo ! i_myband
                  !$OMP END DO
                  !$OMP END PARALLEL
                  itot = itot+ilimit

                enddo ! iv
              enddo ! it
            enddo ! irk
          enddo ! im

          SAFE_DEALLOCATE(tmprowindex)
          SAFE_DEALLOCATE(tmpcolindex)
          SAFE_DEALLOCATE(tmprowph)
          SAFE_DEALLOCATE(tmpcolph)

          if (peinf%inode.eq.0) call timacc(31,2)          

          !Do the zgemm`s
          if(ntot > 0) then
            do jj =1+peinf%rank_mtxel, pol%nsfreq,pol%os_para_freqs

              if (peinf%inode.eq.0) call timacc(30,1)
              call zgemm('n','n',scal%nprd(ipe),scal%npcd(ipe),ntot, &
                negfact,this%gmeRDyntempr2(:,:,jj),scal%nprd(ipe),this%gmeRDyntempc(:,:),ntot,&
                (0D0,0D0),this%chilocalRDyn(:,:,jj),scal%nprd(ipe))
              if (peinf%inode.eq.0) call timacc(30,2)
            enddo
          endif

          if (peinf%inode.eq.0) call timacc(14,1)

          if(pol%os_para_freqs .eq. 1) then            
#ifdef MPI
            call MPI_Reduce(this%chilocalRDyn(1,1,1),this%chilocal2RDyn(1,1,1,ispin), &
              pol%os_nsfreq_para*scal%npcd(ipe)*scal%nprd(ipe),MPI_COMPLEX_DPC,&
              MPI_SUM,ipe-1,MPI_COMM_WORLD,mpierr)
#endif
          else
#ifdef MPI
            call MPI_Reduce(this%chilocalRDyn(1,1,1),this%chilocal2RDyn(1,1,1,ispin), &
              pol%os_nsfreq_para*scal%npcd(ipe)*scal%nprd(ipe),MPI_COMPLEX_DPC,&
              MPI_SUM,ipe-1,peinf%freq_comm,mpierr)
#endif
          endif
#ifndef MPI
          this%chilocal2RDyn(:,:,:,ispin)=this%chilocalRDyn(:,:,:)
#endif
          if (peinf%inode.eq.0) call timacc(14,2)

        enddo ! ispin
        if (peinf%inode.eq.0) call timacc(44,1)
        SAFE_DEALLOCATE(this%chilocalRDyn)
        SAFE_DEALLOCATE(gmeRDyntempr)
        SAFE_DEALLOCATE(this%gmeRDyntempr2)
        SAFE_DEALLOCATE(this%gmeRDyntempc)

        if (peinf%inode.eq.0) call timacc(44,2)
      enddo ! ipe
      call progress_free(prog_info)

      do ispin =1, kp%nspin
        do jj=1+peinf%rank_mtxel,pol%nsfreq,pol%os_para_freqs
          pol%chiTDyn(jj,:,:,ispin) = this%chilocal2RDyn(:,:,jj,ispin)
        enddo ! jj
      enddo ! ispin
      SAFE_DEALLOCATE(this%chilocal2RDyn)

      ! -----------------------------
      ! Hilbert transform
      ! ------------------------------

      call zgemm('n','n',pol%nfreq,scal%npr*scal%npc*kp%nspin,pol%os_nsfreq_para, &
        (-1D0,0D0),htwR(:,:),pol%nfreq,pol%chiTDyn(:,:,:,:),pol%os_nsfreq_para, &
        (0D0,0D0),pol%chiRDyn(:,:,:,:),pol%nfreq)

#ifdef CPLX
      call zgemm('n','n',pol%nfreq,scal%npr*scal%npc*kp%nspin,pol%os_nsfreq_para, &
        (-1D0,0D0),htwA(:,:),pol%nfreq,pol%chiTDyn(:,:,:,:),pol%os_nsfreq_para, &
        (0D0,0D0),pol%chiADyn(:,:,:,:),pol%nfreq)
#endif

    endif ! pol%freq_dep.eq.2.and.pol%freq_dep_method.eq.1

    !call free_summation_buffers(pol)

    POP_SUB(chi_summation_comm_matrix)
    return

  end subroutine chi_summation_comm_matrix

  !-----------------------------------------------------------------------------
  !                              GCOMM_ELEMENTS
  !-----------------------------------------------------------------------------

  !> Create the pol%chi matrix using gcomm_elements sceheme
  subroutine chi_summation_comm_elements(this,pol,scal,kp,vwfn,cwfn,&
    nst,nrk,indt,pht)
    type(chi_summator_t), intent(INOUT) :: this
    type(polarizability), intent(INOUT) :: pol
    type(scalapack), intent(in) :: scal
    type(kpoints), intent(IN) :: kp
    type(valence_wfns), intent(IN) :: vwfn
    type(conduction_wfns), intent(IN) :: cwfn

    integer, intent(IN) :: nst(:)
    integer, intent(IN) :: nrk
    integer, intent(INOUT) :: indt(:,:,:)
    SCALAR,  intent(INOUT) :: pht(:,:,:)

    integer :: icurr,ntot,itot
    integer :: iv, ic, irk, it, ispin

    SCALAR :: temp_gme
    integer, allocatable :: iowna(:)
    integer :: isend

    complex(DPC), allocatable :: edenDRtemp(:)
#ifdef CPLX
    complex(DPC), allocatable :: edenDAtemp(:)
#endif

    real(DP) :: zvalue
    ! frequency points for the spectral functions of the polarizability
    integer :: isfreql, isfreqr
    real(DP) :: sfreql, sfreqr, wr, wl
    ! Hilbert tranform coefficients
    complex(DPC) :: htwR(pol%nfreq,pol%nsfreq), htwA(pol%nfreq,pol%nsfreq)
    complex(DPC) :: c11,c12,c13,c14,c21,c22,c23,c24
    complex(DPC) :: cA11,cA12,cA13,cA14,cA21,cA22,cA23,cA24

    integer :: isf,nf,nsf,ifreq_para
    real(DP) :: sf1,sf2
    real(DP) :: step1,step2,fqt,eta
    complex(DPC) :: c1,c2,j_dpc,cA1,cA2

    integer :: ii, jj
    type(progress_info) :: prog_info

    integer :: nsftot, il, ir, n1, n2, n3, max_nv, nwarn
    integer, allocatable :: count_v(:), ind_v(:,:), ind_sf(:) 
   
    PUSH_SUB(chi_summation_comm_elements)

    !call alloc_summation_buffers(pol, this%fact)

    if (peinf%inode.eq.0) call timacc(44,1)

    SAFE_ALLOCATE(iowna, (vwfn%nband+pol%ncrit))

    if (pol%freq_dep .eq. 0) then
      SAFE_ALLOCATE(this%chilocal, (scal%npr,scal%npc))
    endif

    if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 0)) then
      SAFE_ALLOCATE(this%chilocalRDyn, (scal%npr,scal%npc,pol%os_nfreq_para))
#ifdef CPLX
      SAFE_ALLOCATE(this%chilocalADyn, (scal%npr,scal%npc,pol%os_nfreq_para))
#endif
    endif

    if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 1)) then
      SAFE_ALLOCATE(this%chilocalRDyn, (scal%npr,scal%npc,pol%os_nsfreq_para))
  
      SAFE_ALLOCATE(count_v, (pol%os_nsfreq_para))
      SAFE_ALLOCATE(ind_sf, (pol%os_nsfreq_para))
    endif

    if (peinf%inode.eq.0) call timacc(44,2)

#ifdef VERBOSE
    call logit("Starting chi Sum")
#endif

    if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 1)) then
      ! -------------------------------------------
      ! compute the Hilbert transform coefficients
      ! -------------------------------------------

      if (peinf%inode.eq.0) call timacc(53,1)

      j_dpc=(0.0,1.0)
      htwR(:,:)=(0.0,0.0)

      nf=pol%nfreq
      nsf=pol%nsfreq
      do jj=1,nf
        eta=pol%dBrdning/ryd
        fqt=pol%dFreqGrid(jj)/ryd
        do isf=1,nsf
          if (isf==1) then
            c1=(0.0,0.0)
            step1=1.0
#ifdef CPLX
            cA1=(0.0,0.0)
            step1=1.0
#endif
          else
            sf1=pol%dSFreqGrid(isf-1)/ryd
            sf2=pol%dSFreqGrid(isf)/ryd
            step1=sf2-sf1

            c11=((sf1-fqt)*(-1.0*j_dpc)-eta)*(atan((fqt-sf2)/(eta))&
              &          -atan((fqt-sf1)/(eta)))
            c12=0.50*(sf1-fqt+(-1.0*j_dpc)*eta)*log(((fqt-sf2)**2.0+eta*eta)&
              &          /(((fqt-sf1)**2.0+eta*eta)))

            c13=-((sf1+fqt)*j_dpc-eta)*(atan((fqt+sf2)/(eta))&
              &          -atan((fqt+sf1)/(eta)))
            c14=0.50*(sf1+fqt+j_dpc*eta)*log(((fqt+sf2)**2.0+eta*eta)&
              &          /(((fqt+sf1)**2.0+eta*eta)))

            c1=c11+c12+c13+c14
            c1=c1/step1

#ifdef CPLX
            cA11=((sf1-fqt)*(j_dpc)-eta)*(atan((fqt-sf2)/(eta))&
              &          -atan((fqt-sf1)/(eta)))
            cA12=0.50*(sf1-fqt+(j_dpc)*eta)*log(((fqt-sf2)**2.0+eta*eta)&
              &          /(((fqt-sf1)**2.0+eta*eta)))

            cA13=-((sf1+fqt)*(-1.0*j_dpc)-eta)*(atan((fqt+sf2)/(eta))&
              &          -atan((fqt+sf1)/(eta)))
            cA14=0.50*(sf1+fqt+(-1.0*j_dpc)*eta)*log(((fqt+sf2)**2.0+eta*eta)&
              &          /(((fqt+sf1)**2.0+eta*eta)))

            cA1=cA11+cA12+cA13+cA14
            cA1=cA1/step1
#endif
          endif

          if (isf==nsf) then
            c2=(0.0,0.0)
            step2=1.0
#ifdef CPLX
            cA2=(0.0,0.0)
            step2=1.0
#endif
          else
            sf1=pol%dSFreqGrid(isf)/ryd
            sf2=pol%dSFreqGrid(isf+1)/ryd

            step2=sf2-sf1

            c21=((sf2-fqt)*(-1.0*j_dpc)-eta)*(atan((fqt-sf1)/(eta))&
              &          -atan((fqt-sf2)/(eta)))
            c22=0.50*(sf2-fqt+(-1.0*j_dpc)*eta)*log(((fqt-sf1)**2.0+eta*eta)&
              &          /(((fqt-sf2)**2.0+eta*eta)))

            c23=-((sf2+fqt)*j_dpc-eta)*(atan((fqt+sf1)/(eta))&
              &          -atan((fqt+sf2)/(eta)))
            c24=0.50*(sf2+fqt+j_dpc*eta)*log(((fqt+sf1)**2.0+eta*eta)&
              &          /(((fqt+sf2)**2.0+eta*eta)))

            c2=c21+c22+c23+c24

            c2=c2/step2

#ifdef CPLX
            cA21=((sf2-fqt)*(j_dpc)-eta)*(atan((fqt-sf1)/(eta))&
              &          -atan((fqt-sf2)/(eta)))
            cA22=0.50*(sf2-fqt+(j_dpc)*eta)*log(((fqt-sf1)**2.0+eta*eta)&
              &          /(((fqt-sf2)**2.0+eta*eta)))

            cA23=-((sf2+fqt)*(-1.0*j_dpc)-eta)*(atan((fqt+sf1)/(eta))&
              &          -atan((fqt+sf2)/(eta)))
            cA24=0.50*(sf2+fqt+(-1.0*j_dpc)*eta)*log(((fqt+sf1)**2.0+eta*eta)&
              &          /(((fqt+sf2)**2.0+eta*eta)))

            cA2=cA21+cA22+cA23+cA24

            cA2=cA2/step2
#endif
          endif

          if (isf==1.or.isf==nsf) then
            htwR(jj,isf)=0.5d0*(c1/step1+c2/step2)
#ifdef CPLX
            htwA(jj,isf)=0.5d0*(cA1/step1+cA2/step2)
#endif
          else
            htwR(jj,isf)=1.0d0*(c1+c2)/(step1+step2)
#ifdef CPLX
            htwA(jj,isf)=1.0d0*(cA1+cA2)/(step1+step2)
#endif
          endif

        enddo
      enddo

      if (peinf%inode.eq.0) call timacc(53,2)

    endif!(pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 1)

    if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 1)) then
      pol%chiTDyn=(0.0,0.0)
    endif

    call progress_init(prog_info, 'building polarizability matrix', 'blocks', &
      nrk*kp%nspin*(cwfn%nband-vwfn%nband))
    nwarn=0
    do irk=1,nrk
#ifdef VERBOSE
      if(peinf%inode.eq.0) then
        write(6,'(A,i8,6x,A,i8,A)') '### irk=',irk,'(nrk=',nrk,')'
      endif
#endif
#ifdef MPI
      call MPI_barrier(MPI_COMM_WORLD,mpierr)
#endif
      do ispin=1,kp%nspin
        if (peinf%inode.eq.0) call timacc(44,1)

        iowna(:)=1
        ntot=(vwfn%nband+pol%ncrit)*nst(irk)
        if (pol%freq_dep .eq. 0) then
          this%chilocal=0
          SAFE_ALLOCATE(this%gmetempr, (scal%npr,ntot))
          SAFE_ALLOCATE(this%gmetempc, (ntot,scal%npc))
        endif
        if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 0)) then
          this%chilocalRDyn=0
          SAFE_ALLOCATE(this%gmeRDyntempr2, (scal%npr,ntot,pol%os_nfreq_para))
          SAFE_ALLOCATE(this%gmeRDyntempc, (ntot,scal%npc))
#ifdef CPLX
          this%chilocalADyn=0
          SAFE_ALLOCATE(this%gmeADyntempr2, (scal%npr,ntot,pol%os_nfreq_para))
          SAFE_ALLOCATE(this%gmeADyntempc, (ntot,scal%npc))
#endif
        endif

        if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 1)) then
          this%chilocalRDyn=(0.0,0.0)
         
          max_nv=0
          do ic=1,cwfn%nband-vwfn%nband          
            count_v=0
            do iv=1,(vwfn%nband+pol%ncrit)

              isend=peinf%global_pairowner(iv,ic)-1
              if (isend .lt. 0) then
                write(0,*) 'Illegal value for mpi proc, isend: ',iv,ic
                call die("internal error in chi_summation")
              endif
              if (isend .eq. peinf%inode) then
                zvalue=-pol%edenDyn(peinf%indexv(iv),iowna(iv),ispin,irk,1)
                iowna(iv)=iowna(iv)+1
              endif

#ifdef MPI
              call MPI_Bcast(zvalue,1,MPI_REAL_DP,isend,MPI_COMM_WORLD,mpierr)
              call MPI_Bcast(pol%dSFreqGrid,pol%os_nsfreq_para,MPI_REAL_DP,isend,MPI_COMM_WORLD,mpierr)
#endif

              if (scal%npr*scal%npc .ne. 0) then
                do it=1, nst(irk)

                  if (abs(zvalue) .gt. Tol_Zero) then
                    isfreql=-1
                    do jj=pol%nsfreq,1,-1
                      if ((pol%dSFreqGrid(jj)/ryd)<zvalue) then
                        isfreql=jj
                        EXIT
                      endif
                    enddo

                    if (isfreql.eq.pol%nsfreq) then
                      nwarn=nwarn+1
                      if (nwarn==1.and.peinf%inode.eq.0) then
                        write(0,*) 'WARNING: for accuracy, sfrequency_high_cutoff should be '
                        write(0,*) 'larger than energy difference between highest unoccupied '
                        write(0,*) 'state and lowest occupied state.'
                      endif
                      cycle
                    endif

                    isfreqr=isfreql+1

                    count_v(isfreql)=count_v(isfreql)+1
                    count_v(isfreqr)=count_v(isfreqr)+1
                  endif
                enddo !it
              endif
            enddo !iv

            if (max_nv<maxval(count_v(:))) then
              max_nv=maxval(count_v(:))
            endif
          enddo !ic

          SAFE_ALLOCATE(this%gmeRDyntempr2, (scal%npr,max_nv,pol%os_nsfreq_para))
          SAFE_ALLOCATE(this%gmeRDyntempc, (ntot,scal%npc))
          SAFE_ALLOCATE(this%gmeRDyntempcs, (max_nv,scal%npc))

          this%gmeRDyntempr2=(0.0,0.0)
          this%gmeRDyntempc=(0.0,0.0)
          this%gmeRDyntempcs=(0.0,0.0)

          SAFE_ALLOCATE(ind_v, (pol%os_nsfreq_para, max_nv))

          this%gmeRDyntempr2=(0.0,0.0)
          iowna(:)=1
        endif!(pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 1)

        if (peinf%inode.eq.0) call timacc(44,2)

        do ic=1,cwfn%nband-vwfn%nband
          call progress_step(prog_info)

          ! We do two giant loops here for freq_dep cases
          if (pol%freq_dep .eq. 0) then
            itot=0
            if (peinf%inode.eq.0) call timacc(14,1)
            do iv=1,(vwfn%nband+pol%ncrit)
              isend=peinf%global_pairowner(iv,ic)-1
              if (isend .lt. 0) then
                write(0,*) 'Illegal value for mpi proc, isend:',&
                  peinf%inode,iv,ic,peinf%global_pairowner(iv,ic)
                call die("internal error in chi_summation")
              endif
              if (isend .eq. peinf%inode) then
                if (iowna(iv) .gt. peinf%ncownactual) call die('iowna(iv) bigger than ncownactual')
                this%gmetempn(:) = pol%gme(:,iowna(iv),peinf%indexv(iv), &
                  ispin,irk,1) * sqrt(this%fact)
                iowna(iv)=iowna(iv)+1
              endif
#ifdef MPI
              call MPI_Bcast(this%gmetempn,pol%nmtx,MPI_SCALAR,isend,MPI_COMM_WORLD,mpierr)
#endif
              if (scal%npr*scal%npc .ne. 0) then

                do it =1, nst(irk)
                  itot = itot + 1

                  do icurr=1,scal%npr
                    this%gmetempr(icurr,itot)=this%gmetempn(indt(scal%imyrow(icurr),it,irk)) * &
                      pht(scal%imyrow(icurr),it,irk)
                  enddo

                  do icurr=1,scal%npc
                    temp_gme = this%gmetempn(indt(scal%imycol(icurr),it,irk))
                    this%gmetempc(itot,icurr)=MYCONJG(temp_gme * pht(scal%imycol(icurr),it,irk) )
                  enddo
                enddo ! it
              endif
            enddo ! iv
            if (peinf%inode.eq.0) call timacc(14,2)

            ! JRD: Using Level3 BLAS here for better performance

            if (scal%npr*scal%npc .ne. 0 .and. ntot > 0) then
              if (peinf%inode.eq.0) call timacc(30,1)

              call X(gemm)('n','n',scal%npr,scal%npc,ntot, &
                -ONE,this%gmetempr,scal%npr,this%gmetempc,ntot,ONE,this%chilocal,scal%npr)

              if (peinf%inode.eq.0) call timacc(30,2)
            endif

          endif ! pol%freq_dep .eq. 0

          !---------------------
          ! JRD: Full Frequency Be Here

          if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 0)) then

            if (peinf%inode.eq.0) call timacc(44,1)

            SAFE_ALLOCATE(edenDRtemp, (pol%os_nfreq_para))
#ifdef CPLX
            SAFE_ALLOCATE(edenDAtemp, (pol%os_nfreq_para))
#endif
            if (peinf%inode.eq.0) call timacc(44,2)

            itot=0
            do iv=1,(vwfn%nband+pol%ncrit)
              if (peinf%inode.eq.0) call timacc(14,1)

              isend=peinf%global_pairowner(iv,ic)-1
              if (isend .lt. 0) then
                write(0,*) 'Illegal value for mpi proc, isend: ',iv,ic
                call die("internal error in chi_summation")
              endif
              if (isend .eq. peinf%inode) then
                this%gmeRDyntempn(:) = pol%gme(:,iowna(iv),peinf%indexv(iv), &
                  ispin,irk,1) * sqrt(this%fact)
                if (abs(pol%edenDyn(peinf%indexv(iv),iowna(iv),ispin,irk,1)) .gt. Tol_Zero) then
                  do jj=1+peinf%rank_mtxel,pol%nfreq,pol%os_para_freqs
                    ifreq_para=(jj+pol%os_para_freqs-1)/pol%os_para_freqs
                    edenDRtemp(ifreq_para)= -0.50d0 * ( 1d0/(pol%edenDyn(peinf%indexv(iv),iowna(iv),ispin,irk,1) &
                      -(pol%dFreqGrid(jj)+pol%dFreqBrd(jj))/ryd)+& 
                      1d0/(pol%edenDyn(peinf%indexv(iv),iowna(iv),ispin,irk,1)+&
                      (pol%dFreqGrid(jj)+pol%dFreqBrd(jj))/ryd))
                  enddo
                else
                  edenDRtemp(:)=0D0
                endif
#ifdef CPLX
                this%gmeADyntempn(:) = pol%gme(:,iowna(iv),peinf%indexv(iv),ispin,irk,1) * sqrt(this%fact)
                if (abs(pol%edenDyn(peinf%indexv(iv),iowna(iv),ispin,irk,1)) .gt. Tol_Zero) then
                  do jj=1+peinf%rank_mtxel,pol%nfreq,pol%os_para_freqs
                    ifreq_para=(jj+pol%os_para_freqs-1)/pol%os_para_freqs
                    edenDAtemp(ifreq_para)= -0.50d0 * ( 1d0/(pol%edenDyn(peinf%indexv(iv),iowna(iv),ispin,irk,1) &
                     -(pol%dFreqGrid(jj)-pol%dFreqBrd(jj))/ryd)+ &
                     1d0/(pol%edenDyn(peinf%indexv(iv),iowna(iv),ispin,irk,1)+&
                     (pol%dFreqGrid(jj)-pol%dFreqBrd(jj))/ryd))
                  enddo
                else
                  edenDAtemp(:)=0D0
                endif
#endif
                iowna(iv)=iowna(iv)+1
              endif

#ifdef MPI
              call MPI_Bcast(this%gmeRDyntempn,pol%nmtx,MPI_COMPLEX_DPC,isend,MPI_COMM_WORLD,mpierr)
              call MPI_Bcast(edenDRtemp,pol%os_nfreq_para,MPI_COMPLEX_DPC,isend,MPI_COMM_WORLD,mpierr)
#ifdef CPLX
              call MPI_Bcast(this%gmeADyntempn,pol%nmtx,MPI_COMPLEX_DPC,isend,MPI_COMM_WORLD,mpierr)
              call MPI_Bcast(edenDAtemp,pol%os_nfreq_para,MPI_COMPLEX_DPC,isend,MPI_COMM_WORLD,mpierr)
#endif
#endif
              if (peinf%inode.eq.0) call timacc(14,2)

              if (scal%npr*scal%npc .ne. 0) then
                do it =1, nst(irk)
                  if (peinf%inode.eq.0) call timacc(51,1)

                  itot = itot + 1
                  do icurr=1,scal%npr
                    this%gmeRDyntempr2(icurr,itot,:)= &
                      (this%gmeRDyntempn(indt(scal%imyrow(icurr),it,irk))*pht(scal%imyrow(icurr),it,irk))*edenDRtemp
                  enddo

                  if (peinf%inode.eq.0) call timacc(51,2)

                  if (peinf%inode.eq.0) call timacc(52,1)

                  do icurr=1,scal%npc
                    this%gmeRDyntempc(itot,icurr) = &
                      CONJG(this%gmeRDyntempn(indt(scal%imycol(icurr),it,irk))*pht(scal%imycol(icurr),it,irk))
                  enddo

                  if (peinf%inode.eq.0) call timacc(52,2)

#ifdef CPLX
                  if (peinf%inode.eq.0) call timacc(51,1)
                  do icurr=1,scal%npr
                    this%gmeADyntempr2(icurr,itot,:)=this%gmeADyntempn( &
                      indt(scal%imyrow(icurr),it,irk))*pht(scal%imyrow(icurr),it,irk)*edenDAtemp
                  enddo
                  if (peinf%inode.eq.0) call timacc(51,2)
                  if (peinf%inode.eq.0) call timacc(52,1)
                  do icurr=1,scal%npc
                    this%gmeADyntempc(itot,icurr) = &
                      CONJG(this%gmeADyntempn(indt(scal%imycol(icurr),it,irk))*pht(scal%imycol(icurr),it,irk))
                  enddo
                  if (peinf%inode.eq.0) call timacc(52,2)
#endif
                enddo ! it
              endif

            enddo ! iv


            ! JRD: Using Level3 BLAS here for better performance

            if (scal%npr*scal%npc .ne. 0 .and. ntot > 0) then
              do jj =1+peinf%rank_mtxel,pol%nfreq,pol%os_para_freqs
                if (peinf%inode.eq.0) call timacc(30,1)
                ifreq_para=(jj+pol%os_para_freqs-1)/pol%os_para_freqs
                call zgemm('n','n',scal%npr,scal%npc,ntot,(-1D0,0D0),this%gmeRDyntempr2(:,:,ifreq_para),scal%npr, &
                  this%gmeRDyntempc(:,:),ntot,(1D0,0D0),this%chilocalRDyn(:,:,ifreq_para),scal%npr)
                if (peinf%inode.eq.0) call timacc(30,2)
#ifdef CPLX
                if (peinf%inode.eq.0) call timacc(30,1)
                call zgemm('n','n',scal%npr,scal%npc,ntot,(-1D0,0D0),this%gmeADyntempr2(:,:,ifreq_para),scal%npr, &
                  this%gmeADyntempc(:,:),ntot,(1D0,0D0),this%chilocalADyn(:,:,ifreq_para),scal%npr)
                if (peinf%inode.eq.0) call timacc(30,2)
#endif
              enddo
            endif

            if (peinf%inode.eq.0) call timacc(44,1)
            SAFE_DEALLOCATE(edenDRtemp)
#ifdef CPLX
            SAFE_DEALLOCATE(edenDAtemp)
#endif
            if (peinf%inode.eq.0) call timacc(44,2)

          endif ! (pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 0)

          !---------------------
          ! Full Frequency Be Here(shishkin and Kresse 2006)

          if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 1)) then
            count_v=0
            ind_v=0
            ind_sf=0
            nsftot=0
            itot=0

            do iv=1,(vwfn%nband+pol%ncrit)
              if (peinf%inode.eq.0) call timacc(14,1)

              isend=peinf%global_pairowner(iv,ic)-1
              if (isend .lt. 0) then
                write(0,*) 'Illegal value for mpi proc, isend: ',iv,ic
                call die("internal error in chi_summation")
              endif
              if (isend .eq. peinf%inode) then
                this%gmeRDyntempn(:) = pol%gme(:,iowna(iv),peinf%indexv(iv), &
                  ispin,irk,1) * sqrt(this%fact)
                zvalue=-pol%edenDyn(peinf%indexv(iv),iowna(iv),ispin,irk,1)
                iowna(iv)=iowna(iv)+1
              endif

#ifdef MPI
              call MPI_Bcast(this%gmeRDyntempn,pol%nmtx,MPI_COMPLEX_DPC,isend,MPI_COMM_WORLD,mpierr)
              call MPI_Bcast(zvalue,1,MPI_REAL_DP,isend,MPI_COMM_WORLD,mpierr)
              call MPI_Bcast(pol%dSFreqGrid,pol%os_nsfreq_para,MPI_REAL_DP,isend,MPI_COMM_WORLD,mpierr)
#endif
              if (peinf%inode.eq.0) call timacc(14,2)
              ! compute spectral functions of the polarizability

              if (scal%npr*scal%npc .ne. 0) then
                do it=1, nst(irk)

                  if (abs(zvalue) .gt. Tol_Zero) then
                    if (peinf%inode.eq.0) call timacc(51,1)

                    itot=itot+1
                    isfreql=-1
                    do jj=pol%nsfreq,1,-1
                      if ((pol%dSFreqGrid(jj)/ryd)<zvalue) then
                        isfreql=jj
                        EXIT
                      endif
                    enddo

                    if (isfreql.eq.pol%nsfreq) then
                      cycle
                    endif
                  
                    isfreqr=isfreql+1
                  
                    count_v(isfreql)=count_v(isfreql)+1
                    count_v(isfreqr)=count_v(isfreqr)+1
                  
                    il=count_v(isfreql)
                    ir=count_v(isfreqr)
                  
                    ind_v(isfreql,il)=itot
                    ind_v(isfreqr,ir)=itot
                  
                    sfreql=pol%dSFreqGrid(isfreql)/ryd
                    sfreqr=pol%dSFreqGrid(isfreqr)/ryd
                  
                    wl=-(zvalue-sfreqr)/(sfreqr-sfreql)
                    wr=(zvalue-sfreql)/(sfreqr-sfreql)
                  
                    do icurr=1,scal%npr
                      this%gmeRDyntempr2(icurr,il,isfreql)=this%gmeRDyntempn( &
                        indt(scal%imyrow(icurr),it,irk))*pht(scal%imyrow(icurr),it,irk)*wl
                      this%gmeRDyntempr2(icurr,ir,isfreqr)=this%gmeRDyntempn( &
                        indt(scal%imyrow(icurr),it,irk))*pht(scal%imyrow(icurr),it,irk)*wr
                    enddo
                  
                    if (peinf%inode.eq.0) call timacc(51,2)
                  
                    if (peinf%inode.eq.0) call timacc(52,1)
                  
                    do icurr=1,scal%npc
                      this%gmeRDyntempc(itot,icurr) = &
                        CONJG(this%gmeRDyntempn(indt(scal%imycol(icurr),it,irk))*pht(scal%imycol(icurr),it,irk))
                    enddo

                    if (peinf%inode.eq.0) call timacc(52,2)
                  endif

                enddo ! it
              endif

            enddo ! iv

            if (peinf%inode.eq.0) call timacc(44,1)

            jj=0
            do ii=1+peinf%rank_mtxel,pol%nsfreq,pol%os_para_freqs
              if (count_v(ii)>0) then
                jj=jj+1
                ind_sf(jj)=ii
              endif
            enddo
            nsftot=jj
            if (peinf%inode.eq.0) call timacc(44,2)

            if (scal%npr*scal%npc .ne. 0 .and. ntot > 0) then
              do ii=1, nsftot
                if (peinf%inode.eq.0) call timacc(30,1)

                n1=ind_sf(ii)
                n2=count_v(n1)
                
                do jj=1,n2
                  n3=ind_v(n1,jj)
                  this%gmeRDyntempcs(jj,:)=this%gmeRDyntempc(n3,:)
                enddo

                call zgemm('n','n',scal%npr,scal%npc,n2,(-1D0,0D0),this%gmeRDyntempr2(:,:,n1),scal%npr, &
                  this%gmeRDyntempcs(:,:),max_nv,(1D0,0D0),this%chilocalRDyn(:,:,n1),scal%npr)

                if (peinf%inode.eq.0) call timacc(30,2)
              enddo
            endif
          endif ! (pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 1)

        enddo ! ic (loop over conduction bands)

        if (peinf%inode.eq.0) call timacc(44,1)
        if (pol%freq_dep .eq. 0) then
          if (scal%npr*scal%npc .ne. 0) then
            pol%chi(:,:,ispin) = pol%chi(:,:,ispin) + this%chilocal(:,:)
          endif
          SAFE_DEALLOCATE(this%gmetempr)
          SAFE_DEALLOCATE(this%gmetempc)
        endif

        if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 0)) then
          if (scal%npr*scal%npc .ne. 0) then
            do jj = 1+peinf%rank_mtxel,pol%nfreq,pol%os_para_freqs
              ifreq_para=(jj+pol%os_para_freqs-1)/pol%os_para_freqs 
              pol%chiRDyn(ifreq_para,:,:,ispin) = pol%chiRDyn(ifreq_para,:,:,ispin) + this%chilocalRDyn(:,:,ifreq_para)
#ifdef CPLX
              pol%chiADyn(ifreq_para,:,:,ispin) = pol%chiADyn(ifreq_para,:,:,ispin) + this%chilocalADyn(:,:,ifreq_para)
#endif
            enddo
          endif
          SAFE_DEALLOCATE(this%gmeRDyntempr2)
          SAFE_DEALLOCATE(this%gmeRDyntempc)
#ifdef CPLX
          SAFE_DEALLOCATE(this%gmeADyntempr2)
          SAFE_DEALLOCATE(this%gmeADyntempc)
#endif
        endif
        if (peinf%inode.eq.0) call timacc(44,2)

        if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 1)) then

          if (peinf%inode.eq.0) call timacc(44,1)
          if (scal%npr*scal%npc .ne. 0) then
            do jj = 1+peinf%rank_mtxel, pol%nsfreq,pol%os_para_freqs
              pol%chiTDyn(jj,:,:,ispin) = pol%chiTDyn(jj,:,:,ispin) + this%chilocalRDyn(:,:,jj)
            enddo
          endif
          SAFE_DEALLOCATE(this%gmeRDyntempr2)
          SAFE_DEALLOCATE(this%gmeRDyntempc)
          SAFE_DEALLOCATE(this%gmeRDyntempcs)
          SAFE_DEALLOCATE(ind_v)
          if (peinf%inode.eq.0) call timacc(44,2)
        endif
        
      enddo ! ispin (loop over spins)
    enddo ! irk (loop over k-points in set rk)
    call progress_free(prog_info)

    if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 1)) then

      ! -------------------------
      ! Hilbert transform
      ! -------------------------

      if (peinf%inode.eq.0) call timacc(53,1)

      call zgemm('n','n',pol%nfreq,scal%npr*scal%npc*kp%nspin,pol%os_nsfreq_para, &
        (-1D0,0D0),htwR(:,:),pol%nfreq,pol%chiTDyn(:,:,:,:),pol%os_nsfreq_para, &
        (0D0,0D0),pol%chiRDyn(:,:,:,:),pol%nfreq)

#ifdef CPLX
      call zgemm('n','n',pol%nfreq,scal%npr*scal%npc*kp%nspin,pol%os_nsfreq_para, &
        (-1D0,0D0),htwA(:,:),pol%nfreq,pol%chiTDyn(:,:,:,:),pol%os_nsfreq_para, &
        (0D0,0D0),pol%chiADyn(:,:,:,:),pol%nfreq)
#endif

       if (peinf%inode.eq.0) call timacc(53,2)
    endif !(pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 1)

    if (peinf%inode.eq.0) call timacc(44,1)
    if (pol%freq_dep .eq. 0) then
      SAFE_DEALLOCATE(this%chilocal)
    endif
    if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 0)) then
      SAFE_DEALLOCATE(this%chilocalRDyn)
#ifdef CPLX
      SAFE_DEALLOCATE(this%chilocalADyn)
#endif
    endif
    if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 1)) then
      SAFE_DEALLOCATE(this%chilocalRDyn)
      SAFE_DEALLOCATE(count_v)
      SAFE_DEALLOCATE(ind_sf)
    endif

    SAFE_DEALLOCATE(iowna)
    !call free_summation_buffers(pol)

    if (peinf%inode.eq.0) call timacc(44,2)

    POP_SUB(chi_summation_comm_elements)
    return

  end subroutine chi_summation_comm_elements

end module chi_summation_m 

!==========================================================================
!
! Routines:
!
! (1) find_kpt_match()    Originally by SIB
!
!   Look for rkq in the list of kpoints rotated by the symmetries.
!   If found, it puts its index in ikrkq, itqq is the index
!   of the symmetry that worked, and kgqq is an "umklapp" vector (i.e.
!   integer 3-vector) so that rkq = symm*kvec + kgqq.
!
!==========================================================================

#include "f_defs.h"

module find_kpt_match_m

  use global_m
  implicit none

  private
  public :: find_kpt_match

contains

  subroutine find_kpt_match(kp_point, syms, rkq, ikrkq, itqq, kgqq)
    type(kpoints), intent(in) :: kp_point
    type(symmetry), intent(in) :: syms
    real(DP), intent(in) :: rkq(3)
    integer, intent(out) :: ikrkq
    integer, intent(out) :: itqq
    integer, intent(out) :: kgqq(3)

    integer :: ik, itq, ii
    real(DP) :: qk(3), del(3)

    PUSH_SUB(find_kpt_match)

    ikrkq = 0
    ik_loop: do ik = 1, kp_point%nrk
      do itq = 1, syms%ntran
        qk(1:3) = matmul(syms%mtrx(1:3, 1:3, itq), kp_point%rk(1:3, ik))
        do ii = 1, 3
          del(ii) = rkq(ii) - qk(ii)
          if(del(ii).ge.0.0d0) kgqq(ii) = del(ii) + TOL_Small
          if(del(ii).lt.0.0d0) kgqq(ii) = del(ii) - TOL_Small
        enddo
        if(all(abs(del(1:3)-kgqq(1:3)) .lt. TOL_Small)) then
          ikrkq=ik
          itqq = itq
          exit ik_loop
        endif
      enddo
    enddo ik_loop
    
    POP_SUB(find_kpt_match)
    return

  end subroutine find_kpt_match

end module find_kpt_match_m

!==========================================================================
!
! Routines:
!
! (1) input_co_q()      Originally By ?         Last Modified 4/19/2009 (gsm)
!
!     input: crys, gvec,  syms, xct, flagbz types
!
!     output: kg, indexq_co, kgq, distgwfcoq types
!
!     Reads in the coarse grid q wavefunctions from file WFNq_co
!     and distributes them between processors (if xct%iwriteint=1)
!     or writes them in temporary files (if xct%iwriteint=0).
!     The k-point grid is stored in kgq.
!
!  WARNING: Since this routine is not used by a working part of the code,
!  it has not been tested since implementation of new wfn format. --DAS
!  eqp corrections, Fermi level check, scissor shift probably needed.
!==========================================================================

#include "f_defs.h"

subroutine input_co_q(kp,crys,gvec,kgq,syms,xct,flagbz,indexq_co,kg,distgwfcoq)
  
  use global_m
  use checkbz_m
  use eqpcor_m
  use fullbz_m
  use input_utils_m
  use misc_m
  use wfn_rho_vxc_io_m
  implicit none 

  type (kpoints), intent(in) :: kp
  type (crystal), intent(in) :: crys
  type (gspace), intent(in) :: gvec
  type (grid), intent(out) :: kgq
  type (symmetry), intent(in) :: syms
  type (xctinfo), intent(in) :: xct
  integer, intent(in) :: flagbz
  integer, intent(out) :: indexq_co(xct%nkpt_co)
  type (grid), intent(inout) :: kg
  type (tdistgwf), intent(out) :: distgwfcoq

  type (crystal) :: crys_co
  type (symmetry) :: syms_co
  type (wavefunction) :: wfnv,wfnc
  type (kpoints) :: kp_co
  character :: filenamev*20,filenamec*20
  character :: tmpfn*16
  integer :: iunit_v,iunit_c,ikq
  integer :: irk
  integer :: ii,jj,kk,ik,is,isp
  integer :: irks
  real(DP) :: delta,kt(3),div,qq(3)
  
  integer, allocatable :: dist(:)
  integer, allocatable :: indxk(:)
  SCALAR, allocatable :: cg(:,:), cgarray(:)

  character(len=3) :: sheader
  integer :: iflavor
  type(gspace) :: gvec_co, gvec_kpt

  logical :: skip_checkbz

  PUSH_SUB(input_co_q)

!-------------------------
! Print to stdout

  if (peinf%inode.eq.0) write(6,900)
900 format(/,1x,'Started reading coarse grid q wavefunctions from unit WFNq_co',/)
  
  ! ngmax, i.e. kp_co%ngkmax, was being read from WFN_co here
  ! seems more rational to use kp_co%ngkmax from WFNq_co -- DAS

  if (peinf%inode.eq.0) call open_file(unit=26,file='WFNq_co',form='unformatted',status='old')
  sheader = 'WFN'
  iflavor = 0
  call read_binary_header_type(26, sheader, iflavor, kp_co, gvec_co, syms_co, crys_co, warn = .false.)
  call check_trunc_kpts(xct%icutv, kp_co)

  call check_header('WFN_fi', kp, gvec, syms, crys, 'WFNq_co', kp_co, gvec_co, syms_co, crys_co, is_wfn = .true.)

  SAFE_ALLOCATE(gvec_co%components, (3, gvec_co%ng))
  call read_binary_gvectors(26, gvec_co%ng, gvec_co%ng, gvec_co%components, dont_read = .true.)
  SAFE_DEALLOCATE_P(gvec_co%components)

  if (crys_co%celvol.ne.crys%celvol) then
    call die('The crystal structure in WFNq_co is not the same as in WFN_fi.', only_root_writes = .true.)
  endif

  if (syms_co%ntran .ne. syms%ntran) then
    call die("The crystal symmetry in WFNq_co is not the same as in WFN_fi.", only_root_writes = .true.)
  endif

!-----------------------------------------------------------------------
!     Read k-points from file kpoints_co (if it exists) or from WFNq_co
!     Array indxk has the same meaning as in input

  if (xct%read_kpoints) then
    if (peinf%inode.eq.0) then
      call open_file(9,file='kpoints_co',form='formatted',status='old')
      read(9,*) kg%nr
      SAFE_ALLOCATE(kg%r, (3,kg%nr))
      do ii=1,kg%nr
        read(9,*) (kg%r(jj,ii),jj=1,3),div
        kg%r(:,ii) = kg%r(:,ii)/div
      enddo
      call close_file(9)
    endif
#ifdef MPI
    call MPI_BCAST(kg%nr,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
    if (peinf%inode.ne.0) then
      SAFE_ALLOCATE(kg%r, (3,kg%nr))
    endif
    call MPI_BCAST(kg%r,3*kg%nr,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
#endif
    SAFE_ALLOCATE(indxk, (kg%nr))
    indxk=0
    do jj=1,kg%nr
      do ii=1,kp_co%nrk
        kt(:) = kg%r(:,jj) - kp_co%rk(:,ii)
        if (all(abs(kt(1:3)) < TOL_Small)) then
          if (indxk(jj).ne.0 .and. peinf%inode.eq.0) write(6,996) jj,indxk(jj),kg%r(:,jj)
          indxk(jj)=ii
        endif
      enddo
      if (indxk(jj).eq.0 .and. peinf%inode.eq.0) write(6,995) kg%r(:,jj)
    enddo
  else
    kgq%nr=kp_co%nrk
    SAFE_ALLOCATE(kgq%r, (3,kgq%nr))
    kgq%r(1:3,1:kgq%nr)=kp_co%rk(1:3,1:kp_co%nrk)
    SAFE_ALLOCATE(indxk, (kgq%nr))
    do ii=1,kgq%nr
      indxk(ii)=ii
    enddo
  endif
996 format(1x,'WARNING: Multiple definition of k-point',2i4,3f10.6)
995 format(1x,'WARNING: Could not find k-point',3f10.6,1x,'in WFNq_co')

!-----------------------------------------------------------------------
! Initialization of distributed wavefunctions

  if (xct%iwriteint.eq.1) then
    
    distgwfcoq%ngm=kp_co%ngkmax
    distgwfcoq%nk=kg%nr
    distgwfcoq%ns=kp_co%nspin
    distgwfcoq%nspinor=kp_co%nspinor
    distgwfcoq%nv=xct%nvb_co
    distgwfcoq%nc=xct%ncb_co
    
    SAFE_ALLOCATE(dist, (peinf%npes))
    dist=0
    jj=peinf%npes
    do ii=1,kp_co%ngkmax
      dist(jj)=dist(jj)+1
      jj=jj-1
      if (jj.eq.0) jj=peinf%npes
    enddo
    distgwfcoq%ngl=dist(peinf%inode+1)
    jj=0
    do ii=1,peinf%inode
      jj=jj+dist(ii)
    enddo
    distgwfcoq%tgl=jj
    SAFE_DEALLOCATE(dist)
    
    SAFE_ALLOCATE(distgwfcoq%ng, (distgwfcoq%nk))
    SAFE_ALLOCATE(distgwfcoq%isort, (distgwfcoq%ngl,distgwfcoq%nk))
    SAFE_ALLOCATE(distgwfcoq%zv, (distgwfcoq%ngl,distgwfcoq%nv,distgwfcoq%ns*distgwfcoq%nspinor,distgwfcoq%nk))
    SAFE_ALLOCATE(distgwfcoq%zc, (distgwfcoq%ngl,distgwfcoq%nc,distgwfcoq%ns*distgwfcoq%nspinor,distgwfcoq%nk))
    
    distgwfcoq%ng(:)=0
    distgwfcoq%isort(:,:)=0
    distgwfcoq%zv(:,:,:,:)=ZERO
    distgwfcoq%zc(:,:,:,:)=ZERO
    
  endif ! xct%iwriteint.eq.1

! DAS: Something like this is needed for eqp_co_q.dat here
!-----------------------------------------------------------------------
!     Read eqp_co_q.dat for possible interpolation

! see input_co.f90 for what to do
  
!-----------------------------------------------------------------------
!     Generate full Brillouin zone from irreducible wedge, rk -> fk

  if (flagbz.eq.1) then
    call fullbz(crys,syms,kgq,1,skip_checkbz,wigner_seitz=.true.,paranoid=.true.)
  else
    call fullbz(crys,syms,kgq,syms%ntran,skip_checkbz,wigner_seitz=.true.,paranoid=.true.)
  endif
  tmpfn='WFNq_co'
  if (.not. skip_checkbz) then
    call checkbz(kgq%nf,kgq%f,kp_co%kgrid,kp_co%shift,crys%bdot, &
      tmpfn,'k',.true.,xct%freplacebz,xct%fwritebz)
  endif
  
  if (flagbz.eq.0.and.peinf%inode.eq.0) write(6,801)
  if (flagbz.eq.1.and.peinf%inode.eq.0) write(6,802)
801 format(1x,'Using symmetries to expand the coarse grid q sampling', &
      /)
802 format(1x,'No symmetries used in the coarse grid q sampling',/)

  if (xct%nkpt_co.ne.kgq%nf) then
    if (peinf%inode.eq.0) write(0,994) xct%nkpt_co,kgq%nf
    call die("input_co_q: coarse grid mismatch")
  endif
994 format(1x,'The given number of points in the coarse grid ',i4,' does not match',/,&
      '   with the number of points in file WFNq_co ', i4,'.')

!-----------------------------------------------------------------------
!     Find correspondence with fk from WFN_co
!     indexq : correspondence between a k-point in the full BZ, kg%f,
!     and its shifted vector, kgq%f

  do ik=1,kg%nf
    ikq=0
    delta=0.1d0
    do while ((delta.gt.TOL_Small).and.(ikq.lt.kgq%nf))
      ikq=ikq+1
      qq(:) = kg%f(:,ik)-(kgq%f(:,ikq)-xct%shift(:))
      do kk=1,3
        qq(kk) = qq(kk) - anint( qq(kk) )
      enddo
      delta=sqrt((qq(1))**2+(qq(2))**2+(qq(3))**2)
    enddo
    if(delta.gt.TOL_Small) then
      if(peinf%inode.eq.0) write(0,'(a,3f10.6)') 'Could not find point equivalent to ', (kg%f(ii,ik),ii=1,3)
      call die("k-point mismatch between WFN_co and WFNq_co.", only_root_writes = .true.)
    else

! make sure that kgq%f(:,ikq) - kg%f(:,ik) = shift vector
! near the zone edge, they may differ by a lattice vector

      do jj=1,3
        ii = nint( kgq%f(jj,ikq)-kg%f(jj,ik) )
        kgq%f(jj,ikq) = kgq%f(jj,ikq) - dble(ii)
        kgq%kg0(jj,ikq) = kgq%kg0(jj,ikq) - ii
      enddo
      qq(:) = kg%f(:,ik)-(kgq%f(:,ikq)-xct%shift(:))
      delta=sqrt((qq(1))**2+(qq(2))**2+(qq(3))**2)
      if (delta.gt.TOL_Small) then
        call die("k-point mismatch between WFN_co and WFNq_co. Wrong shift.", only_root_writes = .true.)
      endif
      indexq_co(ik)=ikq
    endif
  enddo
  if (peinf%inode.eq.0) write(6,990) indexq_co(1)
990 format(1x,'Finished correspondence between shifted and unshifted coarse grids.',/,3x,'indexq_co(1) =',i4)

!-----------------------------------------------------------------------
! Read the wavefunctions and distribute or write to temp files

  if (xct%iwriteint.eq.0) then
    
    ! No other part of the code is currently trying to read INT_CWFN_CO_Q -- why not? --DAS
    write(filenamec,'(a)') 'INT_CWFN_CO_Q'
    iunit_c=123
    write(filenamev,'(a)') 'INT_VWFN_CO_Q'
    iunit_v=124
    
    if (peinf%inode.eq.0) then
      call open_file(iunit_c,file=filenamec,form='unformatted',status='replace')
      call open_file(iunit_v,file=filenamev,form='unformatted',status='replace')
    endif ! node 0
    
  endif ! xct%iwriteint.eq.0
  
  SAFE_ALLOCATE(wfnv%isort, (gvec_co%ng))
  wfnv%nband=xct%nvb_co
  wfnv%nspin=kp_co%nspin
  wfnv%nspinor=kp_co%nspinor
  wfnc%nband=xct%ncb_co
  wfnc%nspin=kp_co%nspin
  wfnc%nspinor=kp_co%nspinor

  do irk=1,kp_co%nrk
    irks = 0
    do ii=1,kg%nf
      if (kgq%indr(indexq_co(ii)) == irk) then
        irks=ii
        exit
      endif
    enddo

    SAFE_ALLOCATE(gvec_kpt%components, (3, kp_co%ngk(irk)))
    call read_binary_gvectors(26, kp_co%ngk(irk), kp_co%ngk(irk), gvec_kpt%components)

    SAFE_ALLOCATE(cg, (kp_co%ngk(irk),kp_co%nspin))
    if(irks > 0) then
      do ii = 1, kp_co%ngk(irk)
        call findvector(wfnv%isort(ii), gvec_kpt%components(:, ii), gvec)
        if (wfnv%isort(ii) == 0) call die('Could not find g-vector.')
      enddo
      
      wfnv%ng=kp_co%ngk(irk)
      wfnc%ng=kp_co%ngk(irk)
      if(peinf%inode == 0) then
        SAFE_ALLOCATE(wfnv%cg, (wfnv%ng,wfnv%nband,wfnv%nspin*wfnv%nspinor))
        SAFE_ALLOCATE(wfnc%cg, (wfnc%ng,wfnc%nband,wfnc%nspin*wfnv%nspinor))
        SAFE_ALLOCATE(cgarray, (kp_co%ngk(irk)))
      endif
    endif

! Loop over the bands
      
    do ii=1,kp_co%mnband

! Read planewave coefficients for band ii
      call read_binary_data(26, kp_co%ngk(irk), kp_co%ngk(irk), kp_co%nspin*kp_co%nspinor, cg)

      if(irks == 0) cycle
        
      if(peinf%inode == 0) then  
        do is=1, kp_co%nspin
          if (ii .gt. kp_co%ifmax(irk,is)-xct%nvb_co .and. ii .le. kp_co%ifmax(irk,is)+xct%ncb_co) then

            do isp=1, kp_co%nspinor
              do kk = 1, kp_co%ngk(irk)
                cgarray(kk)=cg(kk, is*isp)
              end do
            
              if ((ii.le.kp_co%ifmax(irk,is)).and. &
                (ii.gt.kp_co%ifmax(irk,is)-xct%nvb_co)) &
                wfnv%cg(1:wfnv%ng,kp_co%ifmax(irk,is)-ii+1,is*isp)=cgarray
            
              if ((ii.gt.kp_co%ifmax(irk,is)).and. &
                (ii.le.kp_co%ifmax(irk,is)+xct%ncb_co)) &
                wfnc%cg(1:wfnc%ng,ii-kp_co%ifmax(irk,is),is*isp)=cgarray
            enddo
            call checknorm('WFNq_co',ii,irks,kp_co%ngk(irk),is,kp_co%nspinor,cg(:,:))
          end if
        end do
      endif
        
    enddo ! ii (loop over bands)

    SAFE_DEALLOCATE(cg)
    if(peinf%inode == 0) then
      SAFE_DEALLOCATE(cgarray)
    endif
    
    if (xct%iwriteint.eq.1) then
      
#ifdef MPI
      if (peinf%inode.ne.0) then
        SAFE_ALLOCATE(wfnv%cg, (wfnv%ng,wfnv%nband,wfnv%nspin*wfnv%nspinor))
        SAFE_ALLOCATE(wfnc%cg, (wfnc%ng,wfnc%nband,wfnc%nspin*wfnc%nspinor))
      endif
      call MPI_BCAST(wfnv%cg(1,1,1),wfnv%ng*wfnv%nband*wfnv%nspin*wfnv%nspinor,MPI_SCALAR,0,MPI_COMM_WORLD,mpierr)
      call MPI_BCAST(wfnc%cg(1,1,1),wfnc%ng*wfnc%nband*wfnc%nspin*wfnc%nspinor,MPI_SCALAR,0,MPI_COMM_WORLD,mpierr)
#endif
      
      distgwfcoq%ng(irks)=wfnv%ng
      do ii=1,distgwfcoq%ngl
        if (ii+distgwfcoq%tgl.le.wfnv%ng) &
          distgwfcoq%isort(ii,irks)=wfnv%isort(ii+distgwfcoq%tgl)
      enddo
      do kk=1,distgwfcoq%ns*distgwfcoq%nspinor
        do jj=1,distgwfcoq%nv
          do ii=1,distgwfcoq%ngl
            if (ii+distgwfcoq%tgl.le.wfnv%ng) then
              distgwfcoq%zv(ii,jj,kk,irks)=wfnv%cg(ii+distgwfcoq%tgl,jj,kk)
            endif
          enddo
        enddo
      enddo
      do kk=1,distgwfcoq%ns*distgwfcoq%nspinor
        do jj=1,distgwfcoq%nc
          do ii=1,distgwfcoq%ngl
            if (ii+distgwfcoq%tgl.le.wfnv%ng) then
              distgwfcoq%zc(ii,jj,kk,irks)=wfnc%cg(ii+distgwfcoq%tgl,jj,kk)
            endif
          enddo
        enddo
      enddo
            
    endif ! xct%iwriteint.eq.1
    
    if (xct%iwriteint.eq.0) then
      
      if (peinf%inode.eq.0) then
        write(iunit_v) irks,wfnv%ng,wfnv%nband,wfnv%nspin,wfnv%nspinor
        write(iunit_v) (wfnv%isort(ii),ii=1,gvec_co%ng), &
          (((wfnv%cg(ii,jj,kk),ii=1,wfnv%ng),jj=1,wfnv%nband),kk=1,wfnv%nspin*wfnv%nspinor)
        write(iunit_c) irks,wfnc%ng,wfnc%nband,wfnc%nspin,wfnc%nspinor
        write(iunit_c) (wfnv%isort(ii),ii=1,gvec_co%ng), &
          (((wfnc%cg(ii,jj,kk),ii=1,wfnc%ng),jj=1,wfnc%nband),kk=1,wfnc%nspin*wfnc%nspinor)
      endif ! node 0
      
    endif ! xct%iwriteint.eq.0
    
    if (peinf%inode == 0 .or. xct%iwriteint == 1) then
      SAFE_DEALLOCATE_P(wfnv%cg)
      SAFE_DEALLOCATE_P(wfnc%cg)
    endif ! node 0
    
  enddo ! loop over k-points
  
  SAFE_DEALLOCATE_P(wfnv%isort)
  SAFE_DEALLOCATE(indxk)
  
  if (peinf%inode.eq.0) then
    write(6,301)
    write(6,302) kg%nr
    write(6,303) ((kg%r(ii,jj),ii=1,3),jj=1,kg%nr)
    write(6,304) kg%nf,kg%sz
301 format(/,1x,'Finished reading coarse grid q wavefunctions from unit WFNq_co',/)
302 format(6x,'nrk =',i4,/)
303 format(6x,3f10.6)
304 format(/,6x,'nfk =',i6,1x,'ksz =',f10.6,/)
    if (xct%iwriteint.eq.0) then
      call close_file(iunit_v)
      call close_file(iunit_c)
    endif ! xct%iwriteint.eq.0
    call close_file(26)
  endif ! node 0
  
  SAFE_DEALLOCATE_P(kp_co%rk)
  SAFE_DEALLOCATE_P(kp_co%ifmin)
  SAFE_DEALLOCATE_P(kp_co%ifmax)
  SAFE_DEALLOCATE_P(kp_co%el)
  
  if(xct%iwriteint == 0) then
#ifdef MPI
    call MPI_Barrier(MPI_COMM_WORLD, mpierr)
#endif
  endif

  POP_SUB(input_co_q)
  
  return
end subroutine input_co_q

!============================================================================
!
! Routines:
!
! (1) distrib()         Originally By MLT       Last Modified (JRD) 5/29/08
!
!     Distributes k-points among processors.  It is best if number of kpoints
!     divides number of processor evenly, otherwise who knows...
!
!     nk = # of kpts
!     np = # of processors
!
!           peinf%nkpe = floor(nk/np) = # of kpts per proc
!           peinf%ikt(p) = # of kpoints belonging to proc p
!           peinf%ik(p,i) = kpt label (1..xct%nkpt_fi) of ith kpts on proc p
!
!
!     input: xct%nkpt_fi
!            xct%ncb_fi
!            xct%nvb_fi
!            xct%neps
!            xct%nspin
!
!=============================================================================

#include "f_defs.h"

subroutine distrib(xct,FFTgrid,kgrid,is_diag)

  use global_m
  use fftw_m
  use misc_m
  use scalapack_m
  implicit none

  type (xctinfo), intent(inout) :: xct
  integer, intent(in) :: FFTgrid(3),kgrid(3)
  logical, intent(in) :: is_diag

  integer :: ik,ipe,nmat,nmat_co,ic,iv,nblockstotal
  real(DP) :: mem,fmem,dmem,hmem,rmem,rmem2,scale,dscale,facdyn
  integer :: Nrod,Nplane,Nfft(3),dNfft(3),dkmax(3),nmpinode
  integer :: irank, rank_last, ibt_last
#ifdef MPI
  integer :: numbl_max,nnp,nn,np0,mq0,nq0,cls,neig,lrwork,lwork,nbr,nbc
  type(scalapack) :: scal
#endif

!---------------------------------
! Distribute work
! Each processor will own peinf%nblocks of size nblockd

  PUSH_SUB(distrib)

  peinf%nkpe=xct%nkpt_fi/peinf%npes
  if(xct%nkpt_fi-peinf%npes*peinf%nkpe.gt.0) peinf%nkpe=peinf%nkpe+1
  
  if (peinf%inode .eq. 0) then
    write(6,*)
  endif
  if (peinf%npes .le. xct%nkpt_fi) then
    peinf%nblocks=xct%nkpt_fi/peinf%npes
    xct%ipar=1
    if(xct%nkpt_fi-peinf%npes*peinf%nblocks.gt.0) &
      peinf%nblocks=peinf%nblocks+1
    nblockstotal = xct%nkpt_fi
    if (peinf%inode .eq. 0) then
      write(6,*) 'You are doing a class 1 calculation - npes <= nk' 
    endif
  else if (peinf%npes .le. xct%nkpt_fi * xct%ncb_fi) then
    peinf%nblocks=xct%nkpt_fi*xct%ncb_fi/peinf%npes
    xct%ipar=2
    if(xct%nkpt_fi*xct%ncb_fi-peinf%npes*peinf%nblocks.gt.0) &
      peinf%nblocks=peinf%nblocks+1
    nblockstotal = xct%nkpt_fi*xct%ncb_fi
    if (peinf%inode .eq. 0) then
      write(6,*) 'You are doing a class 2 calculation - npes <= nk*nc' 
    endif
  else
    peinf%nblocks=xct%nkpt_fi*xct%nvb_fi*xct%ncb_fi/peinf%npes
    xct%ipar=3
    if(xct%nkpt_fi*xct%nvb_fi*xct%ncb_fi-peinf%npes*peinf%nblocks.gt.0) &
      peinf%nblocks=peinf%nblocks+1
    nblockstotal = xct%nkpt_fi*xct%ncb_fi*xct%nvb_fi
    if (peinf%inode .eq. 0) then
      write(6,*) 'You are doing a class 3 calculation - npes > nk*nc' 
    endif
  endif
  
  SAFE_ALLOCATE(peinf%ik, (peinf%npes,peinf%nkpe))
  SAFE_ALLOCATE(peinf%ikb, (peinf%npes,peinf%nblocks))
  SAFE_ALLOCATE(peinf%ivb, (peinf%npes,peinf%nblocks))
  SAFE_ALLOCATE(peinf%icb, (peinf%npes,peinf%nblocks))
  SAFE_ALLOCATE(peinf%ikt, (peinf%npes))
  SAFE_ALLOCATE(peinf%ibt, (peinf%npes))
  
  peinf%ik=0
  peinf%ikt=0
  peinf%ikb=0
  peinf%icb=0
  peinf%ivb=0
  peinf%ibt=0
  
  ipe=0
  do ik=1,xct%nkpt_fi
    ipe=ipe+1
    if(ipe.eq.peinf%npes+1) ipe=1
    peinf%ikt(ipe)=peinf%ikt(ipe)+1
    peinf%ik(ipe,peinf%ikt(ipe))=ik
  enddo
  
  ipe=0
  if (xct%ipar .eq. 1) then
    do ik=1,xct%nkpt_fi
      ipe=ipe+1
      if(ipe.eq.peinf%npes+1) ipe=1
      peinf%ibt(ipe)=peinf%ibt(ipe)+1
      peinf%ikb(ipe,peinf%ibt(ipe))=ik
    enddo
  else if (xct%ipar .eq. 2) then
    do ik=1,xct%nkpt_fi
      do ic=1,xct%ncb_fi
        ipe=ipe+1
        if(ipe.eq.peinf%npes+1) ipe=1
        peinf%ibt(ipe)=peinf%ibt(ipe)+1
        peinf%ikb(ipe,peinf%ibt(ipe))=ik
        peinf%icb(ipe,peinf%ibt(ipe))=ic
      enddo
    enddo
  else
    do ik=1,xct%nkpt_fi
      do ic=1,xct%ncb_fi
        do iv=1,xct%nvb_fi
          ipe=ipe+1
          if(ipe.eq.peinf%npes+1) ipe=1
          peinf%ibt(ipe)=peinf%ibt(ipe)+1
          peinf%ikb(ipe,peinf%ibt(ipe))=ik
          peinf%ivb(ipe,peinf%ibt(ipe))=iv
          peinf%icb(ipe,peinf%ibt(ipe))=ic
        enddo
      enddo
    enddo
  endif
  
!---------------------------------
! Determine the available memory

  call procmem(mem,nmpinode)
  
  if(peinf%inode.eq.0) then
    write(6,998) mem/1024.0d0**2
  endif
998 format(/,1x,'Memory available:',f10.1,1x,'MB per PE')

  fmem=mem/8.0d0

!---------------------------------------------------------
! (gsm) Determine the amount of memory required for vcoul

! random numbers
  rmem=0.0D0
  if (xct%icutv.ne.5) then
! arrays ran, qran, and qran2
! (ran is deallocated before qran2 is allocated)
    rmem=rmem+6.0D0*dble(nmc)*8.0D0
  endif
! various truncation schemes
  call setup_FFT_sizes(FFTgrid,Nfft,scale)
  rmem2=0.0d0
! cell wire truncation
  if (xct%icutv.eq.4) then
    dkmax(1) = FFTgrid(1) * n_in_wire
    dkmax(2) = FFTgrid(2) * n_in_wire
    dkmax(3) = 1
    call setup_FFT_sizes(dkmax,dNfft,dscale)
! array fftbox_2D
    rmem2=rmem2+dble(dNfft(1))*dble(dNfft(2))*16.0d0
! array inv_indx
    rmem2=rmem2+dble(Nfft(1))*dble(Nfft(2))*dble(Nfft(3))*4.0d0
! array qran
    rmem2=rmem2+3.0D0*dble(nmc)*8.0D0
  endif
! cell box (parallel version only) & supercell box truncation
  if (xct%icutv.eq.5.or.xct%icutv.eq.7) then
    dkmax(1) = FFTgrid(1) * n_in_box
    dkmax(2) = FFTgrid(2) * n_in_box
    dkmax(3) = FFTgrid(3) * n_in_box
    call setup_FFT_sizes(dkmax,dNfft,dscale)
    if (xct%icutv.eq.7) then
      dNfft(1:3) = dNfft(1:3) * kgrid(1:3)
    endif
    if (mod(dNfft(3),peinf%npes) == 0) then
      Nplane = dNfft(3)/peinf%npes
    else
      Nplane = dNfft(3)/peinf%npes+1
    endif
    if (mod(dNfft(1)*dNfft(2),peinf%npes) == 0) then
      Nrod = (dNfft(1)*dNfft(2))/peinf%npes
    else
      Nrod = (dNfft(1)*dNfft(2))/peinf%npes+1
    endif
! array fftbox_2D
    rmem2=rmem2+dble(dNfft(1))*dble(dNfft(2))*dble(Nplane)*16.0d0
! array fftbox_1D
    rmem2=rmem2+dble(dNfft(3))*dble(Nrod)*16.0d0
! array dummy
!        rmem2=rmem2+dble(dNfft(1))*dble(dNfft(2))*16.0d0
! arrays dummy1 and dummy2
    rmem2=rmem2+dble(Nrod)*dble(peinf%npes+1)*16.0d0
! array inv_indx
    rmem2=rmem2+dble(Nfft(1))*dble(Nfft(2))*dble(Nfft(3))*4.0d0
  endif
  if (rmem2 .gt. rmem) rmem = rmem2
  if(peinf%inode.eq.0) then
    write(6,988) rmem/1024.0d0**2
  endif
988 format(1x,'Memory required for vcoul:',f7.1,1x,'MB per PE')
  
!---------------------------------
! Check how much memory is needed to allocate hamiltonian and
! eigenstates, in case of doing diagonalization. Only arrays with size
! that increase with ( # k-points )^2 are taken into account.
! Also include, bsedmatrix, bsedmt

! hmem : memory needed to store hmtrx and BSE arrays in intkernel
! dmem : memory needed to store all eigenvectors and the
! temporary arrays shs_bl,egs_bl (assumes that all eigenvectors
! are computed and stored)

  nmat= xct%nkpt_fi*xct%ncb_fi*xct%nvb_fi*xct%nspin
  nmat_co= xct%ncb_co*xct%nvb_co*xct%nspin

  facdyn = 1D0
  
! JRD: The factor of 3 here comes from bsedmattrix, bsedmatrix_loc and data in the HDF5 read area
#ifdef HDF5
  hmem = 3.0d0*8.0d0*nmat_co*nmat_co*xct%nkpt_co*facdyn
#else
  hmem = 2.0d0*8.0d0*nmat_co*nmat_co*xct%nkpt_co*facdyn
#endif  

  if (xct%ipar .eq. 1) then
    hmem = hmem + 8.0d0*nmat*peinf%nblocks*xct%nvb_fi*xct%ncb_fi*xct%nspin
    hmem = hmem + 8.0d0*(xct%nvb_fi*xct%ncb_fi*xct%nspin)**2
  else if (xct%ipar .eq. 2) then
    hmem = hmem + 8.0d0*nmat*peinf%nblocks*xct%nvb_fi*xct%nspin
    hmem = hmem + 8.0d0*(xct%nvb_fi*xct%ncb_fi*xct%nspin)*(xct%nvb_fi*xct%nspin)
  else
    hmem = hmem + 8.0d0*nmat*peinf%nblocks*xct%nspin
    hmem = hmem + 8.0d0*(xct%nvb_fi*xct%ncb_fi*xct%nspin)*xct%nspin
  endif

#ifdef CPLX
  hmem = hmem * sizeof_scalar() / 8.0d0
#endif

  if (is_diag) then 
    if (peinf%npes.eq.1) then
      dmem = 2D0*hmem + 4D0*6D0*nmat + 8D0*10D0*nmat
#ifdef CPLX
      dmem = dmem + 8D0*7D0*nmat
#endif

! MPI must be running if more than 1 processor is used...

#if defined MPI && !defined USESCALAPACK
#error ScaLAPACK is required for MPI builds.
#endif

#ifdef MPI
    else

! Estimate size of layout arrays in diagonalize
! assume mpi support

      call layout_scalapack(nmat, scal%nbl, peinf%npes, scal%nprow, scal%npcol)
      nbc = nmat/(scal%nbl*scal%npcol)
      if(mod(nmat,(scal%nbl*scal%npcol)).gt.scal%nbl*scal%npcol) nbc=nbc+1
      nbr = nmat/(scal%nbl*scal%nprow)
      if(mod(nmat,(scal%nbl*scal%nprow)).gt.scal%nbl*scal%nprow) nbr=nbr+1
      numbl_max = nbc*nbr
      
      cls = 50
      neig = nmat
      nn = max(nmat,scal%nbl,2)
      nnp = max(nmat,scal%nprow*scal%npcol+1,4)
      np0 = numroc(nn,scal%nbl,0,0,scal%nprow)
      mq0 = numroc(max(neig,scal%nbl,2),scal%nbl,0,0,scal%npcol)
#ifdef CPLX
!  use nq0 for lwork to be consistent with pcheevx, man pages wrong
      nq0 = numroc(nn,scal%nbl,0,0,scal%npcol)
      lwork = nmat + (np0+nq0+scal%nbl)*scal%nbl

      lrwork=4*nmat+max(5*nn,np0*mq0)+iceil(neig,scal%nprow*scal%npcol)*nn + &
        (cls-1)*nmat

#else
      lwork=5*nmat+max(5*nn,np0*mq0+2*scal%nbl*scal%nbl)+ &
        iceil(neig,scal%nprow*scal%npcol)*nn+(cls-1)*nmat
      lrwork=0
#endif
      dmem = 8D0*(nmat+lrwork+scal%nprow*scal%npcol) + sizeof_scalar() * (2D0*numbl_max*scal%nbl*scal%nbl+ &
       lwork+(dble(nmat)*dble(nmat)/dble(peinf%npes)))
#endif
    endif
    
  endif

  if(peinf%inode.eq.0) then
    write(6,996) hmem/0.1024d4**2
    if (is_diag) then
      write(6,997) dmem/0.1024d4**2
    endif
    write(6,*)
  endif
996 format(1x,'Memory needed to store the effective Hamiltonian and intkernel',/,&
      8x,'arrays:',f7.1,1x,'MB per PE')
997 format(1x,'Additional memory needed for eigenvectors and diagonalization:',f7.1,1x,'MB per PE')

!      if ((dmem+hmem).gt.8.0*fmem) then
!        if(peinf%inode.eq.0) then
!          write(6,995)dmem/0.1024d4**2,hmem/0.1024d4**2, &
!           fmem/0.1024d4**2,fmem*8.0d0/0.1024d4**2
!        endif
!  995 format(1x,'WARNING: not enough memory to solve BSE equations.' &
!       ,/,3x,'The job may stop before completion.',/,3x,'dmem:' &
!       ,f8.1,1x,'hmem:',f8.1,1x,'fmem',f8.1,1x,'8*fmem',f8.1)

! If there is not enough memory the job may stop
! while allocating hmtrx or in some other allocation

!      endif

  if(peinf%inode.eq.0) then
    write(6,'(1x,a)') 'Distribution of kcv blocks among PE ranks:'
    rank_last = 0
    ibt_last = peinf%ibt(rank_last+1)
    do irank = 1, peinf%npes-1
      if (peinf%ibt(irank+1)/=ibt_last) then
        write(6,70) rank_last, irank-1, ibt_last
        rank_last = irank
        ibt_last = peinf%ibt(rank_last+1)
      endif
    enddo
    write(6,70) rank_last, peinf%npes-1, ibt_last
    if (peinf%nblocks*peinf%npes.ne.nblockstotal) then
      write(0,90)
    endif
  endif
70 format(3x,'- PEs ',i0,' to ',i0,' : ',i0,' blocks')
90 format(1x,'WARNING: kcv-blocks not evenly distributed among PEs.' &
     ,/,3x,'This job will not run with optimum load balance.')
  
  POP_SUB(distrib)
  
  return
end subroutine distrib

!==========================================================================
!
! Routines:
!
! (1) input_co()        Originally By ?         Last Modified 4/19/2009 (gsm)
!
!     input: crys, gvec,  syms, xct, flagbz types
!
!     output: kg, distgwfco types
!
!     Reads in the coarse-grid wavefunctions from file WFN_co and
!     distributes them between processors (if xct%iwriteint=1)
!     or writes them in temporary files (if xct%iwriteint=0).
!     The k-point grid is stored in kg.
!
!==========================================================================

#include "f_defs.h"

subroutine input_co(kp,crys,gvec,kg,syms,xct,flagbz,distgwfco,eqp)

  use global_m
  use checkbz_m
  use eqpcor_m
  use fullbz_m
  use input_utils_m
  use misc_m
  use scissors_m
  use wfn_rho_vxc_io_m
  use io_utils_m
  implicit none

  type (kpoints), intent(inout) :: kp
  type (crystal), intent(in) :: crys
  type (gspace), intent(in) :: gvec
  type (grid), intent(out) :: kg
  type (symmetry), intent(in) :: syms
  type (xctinfo), intent(inout) :: xct
  integer, intent(in) :: flagbz
  type (tdistgwf), intent(out) :: distgwfco
  type (eqpinfo), intent(inout) :: eqp

  type (crystal) :: crys_co
  type (symmetry) :: syms_co
  type (wavefunction) :: wfnv,wfnc
  type (kpoints) :: kp_co
  character :: filenamev*20,filenamec*20
  character :: tmpfn*16
  character :: fncor*32
  integer :: iunit_v,iunit_c
  integer :: irk,irks
  integer :: ii,jj,kk,is,isp,minband,maxband
  real(DP) :: kt(3),div,tol
  integer, allocatable :: dist(:)
  integer, allocatable :: indxk(:)
  SCALAR, allocatable :: cg(:,:), cgarray(:)

  character(len=3) :: sheader
  integer :: iflavor
  type(gspace) :: gvec_co, gvec_kpt
  logical :: skip_checkbz, broken_degeneracy

  logical :: dont_die_consistency
  type(progress_info) :: prog_info

  PUSH_SUB(input_co)

!-------------------------
! Print to stdout

  if (peinf%inode.eq.0) call open_file(unit=25,file='WFN_co',form='unformatted',status='old')
  sheader = 'WFN'
  iflavor = 0
  call read_binary_header_type(25, sheader, iflavor, kp_co, gvec_co, syms_co, crys_co, warn = .false., &
    dont_warn_kgrid=xct%patched_sampling_co)
  call check_trunc_kpts(xct%icutv, kp_co)

  call check_header('WFN_fi', kp, gvec, syms, crys, 'WFN_co', kp_co, gvec_co, syms_co, crys_co, is_wfn = .true.)

  if(xct%skipinterp) then
    ! we check this first to be sure the second comparison will not segfault
    if(kp%nrk /= kp_co%nrk .or. any(kp%kgrid(1:3) /= kp_co%kgrid(1:3))) then
      call die("Cannot skip interpolation if coarse and fine grids differ.")
    endif
    if(any(abs(kp%rk(1:3, 1:kp%nrk) - kp_co%rk(1:3, 1:kp%nrk)) > TOL_Zero)) then
      call die("Cannot skip interpolation if coarse and fine k-points differ.")
    endif
    ! now we do not need the k-points anymore. This is the only place we change kp.
    SAFE_DEALLOCATE_P(kp%rk)
  endif

  SAFE_ALLOCATE(gvec_co%components, (3, gvec%ng))
  call read_binary_gvectors(25, gvec%ng, gvec%ng, gvec_co%components)
  SAFE_DEALLOCATE_P(gvec_co%components)

!-----------------------------------------------------------------------
! Read eqp_co.dat for possible interpolation

  SAFE_ALLOCATE(eqp%evshift_co, (xct%nvb_co,kp_co%nrk,kp_co%nspin))
  SAFE_ALLOCATE(eqp%ecshift_co, (xct%ncb_co,kp_co%nrk,kp_co%nspin))
  eqp%evshift_co=0D0
  eqp%ecshift_co=0D0
  
  fncor = ''

  if(xct%eqp_corrections .and. xct%skipinterp) fncor = 'eqp.dat'
  ! not interpolating, coarse and fine grids are identical.
  ! must correct this grid or wreck occupations. we need kp_co%el for efermi below.
  ! DAS: this is a hack to make things work. Better is never to read anything of the coarse grid if not interpolating!

  ! Note: eqp_co_corrections and skipinterp are incompatible and blocked in inread
  if(xct%eqp_co_corrections) then
    fncor = 'eqp_co.dat'
    xct%inteqp = .true.
  endif

  SAFE_ALLOCATE(kp_co%elda, (kp_co%mnband, kp_co%nrk, kp_co%nspin))
  kp_co%elda(:,:,:) = kp_co%el(:,:,:)

  minband = 1
  maxband = kp_co%mnband
  if(trim(fncor) /= '') then
    ! FIXME: for metals this is asking for a few more bands than actually needed on some k-points
    minband = minval(kp_co%ifmax(:,:)-xct%nvb_co+1)
    maxband = maxval(kp_co%ifmax(:,:)+xct%ncb_co)
    call eqpcor(fncor,peinf%inode,peinf%npes,kp_co, &
      minband,maxband,0,0,kp_co%el,eqp%evshift_co,eqp%ecshift_co,1,0)
  endif

  if(xct%eqp_co_corrections .and. xct%eqp_corrections) xct%inteqp = .false.
  ! if we have the fine-grid QP energies, we do not need to interpolate from the fine grid

  ! scissor shift is only needed for consistency with Fermi level shift here
  ! since 'interpolating' to fine grid is the same as just applying scissor shift directly
  call scissors_shift(kp_co, eqp%scis, eqp%spl_tck)

  ! FHJ: We don`t allow inconsistent ifmin/ifmax fields. The only exception is
  ! if we are running inteqp with unrestricted interpolation and we are not 
  ! changing the FE. In this case, we freeze ifmin/ifmax from LDA, which is
  ! fine b/c unrestricted_transf doesn`t distinguish val/cond states.
  dont_die_consistency = xct%inteqp.and.xct%unrestricted_transf.and.&
    xct%rfermi.and.(dabs(xct%efermi_input)<TOL_SMALL)
  ! JRD: If we are using eqp_co.dat, then this is our best estimate of the true fermi qp fermi
  ! energy, so we update it. If we don`t update it, we may also mess up the occupations of the
  ! coarse grid because qp efermi of coarse grid may not be lda efermi of fine grids.
  if(xct%eqp_co_corrections) then
    call find_efermi(xct%rfermi, xct%efermi, xct%efermi_input, kp_co, maxband, minband, &
      "coarse grid", should_search = .true., should_update = .true., write7 = .false., &
      dont_die_consistency=dont_die_consistency)
  else
    call find_efermi(xct%rfermi, xct%efermi, xct%efermi_input, kp_co, maxband, minband, &
      "coarse grid", should_search = .true., should_update = .false., write7 = .false., &
      dont_die_consistency=dont_die_consistency)
  endif

  ! now we call again to initialize the eqp arrays
  if(xct%eqp_co_corrections) then
    call eqpcor(fncor,peinf%inode,peinf%npes,kp_co,0,0, &
      xct%nvb_co,xct%ncb_co,kp_co%el,eqp%evshift_co,eqp%ecshift_co,1,2,dont_write=.true.)
  endif

  if(any(kp_co%ifmax(:,:) == 0)) & 
    call die("BSE codes cannot handle a system where some k-points have no occupied bands.", only_root_writes = .true.) 

  kp_co%nvband=minval(kp_co%ifmax(:,:)-kp_co%ifmin(:,:))+1
  kp_co%ncband=kp_co%mnband-maxval(kp_co%ifmax(:,:))

!----------------------------------------------------------------
! (gsm) check whether the requested number of bands
!       is available in the wavefunction file

  if(xct%nvb_co .gt. kp_co%nvband) then
    call die("The requested number of valence bands is not available in WFN_co.", only_root_writes = .true.)
  endif
  if(xct%ncb_co .gt. kp_co%ncband) then
    call die("The requested number of conduction bands is not available in WFN_co.", only_root_writes = .true.)
  endif

! DAS: degenerate subspace check

  if (peinf%inode.eq.0) then
    if(xct%ncb_co .eq. kp_co%ncband) then
      call die("You must provide one more conduction band in WFN_co in order to assess degeneracy.")
    endif
    broken_degeneracy = .false.
    do jj = 1, kp_co%nspin
      do ii = 1, kp_co%nrk
        if(kp_co%ifmax(ii, jj) - xct%nvb_co > 0) then
          ! no need to compare against band 0 if all valence are included
          if(abs(kp_co%elda(kp_co%ifmax(ii, jj) - xct%nvb_co + 1, ii, jj) &
            - kp_co%elda(kp_co%ifmax(ii, jj) - xct%nvb_co, ii, jj)) .lt. TOL_Degeneracy) then
            broken_degeneracy = .true.
          endif
        endif
      enddo
    enddo

    if(broken_degeneracy) then
      if(xct%degeneracy_check_override) then
        write(0,'(a)') &
          "WARNING: Selected number of valence bands breaks degenerate subspace in WFN_co. " // &
          "Run degeneracy_check.x for allowable numbers."
        write(0,*)
      else
        write(0,'(a)') &
          "Run degeneracy_check.x for allowable numbers, or use keyword " // &
          "degeneracy_check_override to run anyway (at your peril!)."
        call die("Selected number of valence bands breaks degenerate subspace in WFN_co.")
      endif
    endif
    
    broken_degeneracy = .false.
    do jj = 1, kp_co%nspin
      do ii = 1, kp_co%nrk
        if(abs(kp_co%elda(kp_co%ifmax(ii, jj) + xct%ncb_co, ii, jj) &
          - kp_co%elda(kp_co%ifmax(ii, jj) + xct%ncb_co + 1, ii, jj)) .lt. TOL_Degeneracy) then
          broken_degeneracy = .true.
        endif
      enddo
    enddo

    if(broken_degeneracy) then
      if(xct%degeneracy_check_override) then
        write(0,'(a)') &
          "WARNING: Selected number of conduction bands breaks degenerate subspace in WFN_co. " // &
          "Run degeneracy_check.x for allowable numbers."
        write(0,*)
      else
        write(0,'(a)') &
          "Run degeneracy_check.x for allowable numbers, or use keyword " // &
          "degeneracy_check_override to run anyway (at your peril!)."
        call die("Selected number of conduction bands breaks degenerate subspace in WFN_co.")
      endif
    endif
  endif

  SAFE_DEALLOCATE_P(kp_co%elda)

!-----------------------------------------------------------------------
!     Read k-points from file kpoints_co (if it exists) or from WFN_co
!     Array indxk has the same meaning as in input

  if (xct%read_kpoints) then
    if (peinf%inode.eq.0) then
      call open_file(9,file='kpoints_co',form='formatted',status='old')
      read(9,*) kg%nr
      SAFE_ALLOCATE(kg%r, (3,kg%nr))
      do ii=1,kg%nr
        read(9,*) (kg%r(jj,ii),jj=1,3),div
        kg%r(:,ii) = kg%r(:,ii)/div
      enddo
      call close_file(9)
    endif ! node 0
#ifdef MPI
    call MPI_BCAST(kg%nr,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
    if (peinf%inode.ne.0) then
      SAFE_ALLOCATE(kg%r, (3,kg%nr))
    endif
    call MPI_BCAST(kg%r,3*kg%nr,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
#endif
    tol = TOL_Small
    SAFE_ALLOCATE(indxk, (kg%nr))
    indxk=0
    do jj=1,kg%nr
      do ii=1,kp_co%nrk
        kt(:) = kg%r(:,jj) - kp_co%rk(:,ii)
        if (all(abs(kt(1:3)).lt.tol)) then
          if (indxk(jj).ne.0) then
            if (peinf%inode.eq.0) write(6,996) jj,indxk(jj),kg%r(:,jj)
          endif
          indxk(jj)=ii
        endif
      enddo
      if (indxk(jj).eq.0) then
        if (peinf%inode.eq.0) write(0,995) kg%r(:,jj)
      endif
    enddo
  else
    kg%nr=kp_co%nrk
    SAFE_ALLOCATE(kg%r, (3,kg%nr))
    kg%r(1:3,1:kg%nr)=kp_co%rk(1:3,1:kp_co%nrk)
    SAFE_ALLOCATE(indxk, (kg%nr))
    do ii=1,kg%nr
      indxk(ii)=ii
    enddo
  endif
#ifdef MPI
  call MPI_BCAST(indxk,kg%nr,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
996 format(1x,'WARNING: Multiple definition of k-point',2i4,3f10.6)
995 format(1x,'WARNING: Could not find k-point',3f10.6,1x,'in WFN_co')
  
!-----------------------------------------------------------------------
! Initialization of distributed wavefunctions

  if (xct%iwriteint.eq.1) then
    
    distgwfco%ngm=kp_co%ngkmax
    distgwfco%nk=kg%nr
    distgwfco%ns=kp_co%nspin
    distgwfco%nspinor=kp_co%nspinor
    distgwfco%nv=xct%nvb_co
    distgwfco%nc=xct%ncb_co
    
    SAFE_ALLOCATE(dist, (peinf%npes))
    dist=0
    jj=peinf%npes
    do ii=1,kp_co%ngkmax
      dist(jj)=dist(jj)+1
      jj=jj-1
      if (jj.eq.0) jj=peinf%npes
    enddo
    distgwfco%ngl=dist(peinf%inode+1)
    jj=0
    do ii=1,peinf%inode
      jj=jj+dist(ii)
    enddo
    distgwfco%tgl=jj
    SAFE_DEALLOCATE(dist)
    
    SAFE_ALLOCATE(distgwfco%ng, (distgwfco%nk))
    SAFE_ALLOCATE(distgwfco%isort, (distgwfco%ngl,distgwfco%nk))
    SAFE_ALLOCATE(distgwfco%zv, (distgwfco%ngl,distgwfco%nv,distgwfco%ns*distgwfco%nspinor,distgwfco%nk))
    SAFE_ALLOCATE(distgwfco%zc, (distgwfco%ngl,distgwfco%nc,distgwfco%ns*distgwfco%nspinor,distgwfco%nk))
    
    distgwfco%ng(:)=0
    distgwfco%isort(:,:)=0
    distgwfco%zv(:,:,:,:)=ZERO
    distgwfco%zc(:,:,:,:)=ZERO
    
  endif ! xct%iwriteint.eq.1
  
!-----------------------------------------------------------------------
!     Generate full Brillouin zone from irreducible wedge, rk -> fk

  if (flagbz.eq.1) then
    call fullbz(crys,syms,kg,1,skip_checkbz,wigner_seitz=.true.,paranoid=.true.)
  else
    call fullbz(crys,syms,kg,syms%ntran,skip_checkbz,wigner_seitz=.true.,paranoid=.true.)
  endif
  tmpfn='WFN_co'
  if (.not. skip_checkbz .and. .not.xct%patched_sampling) then
    call checkbz(kg%nf,kg%f,kp_co%kgrid,kp_co%shift,crys%bdot, &
      tmpfn,'k',.true.,xct%freplacebz,xct%fwritebz)
  endif
  
  if (flagbz.eq.0.and.peinf%inode.eq.0) write(6,801)
  if (flagbz.eq.1.and.peinf%inode.eq.0) write(6,802)
801 format(1x,'Using symmetries to expand the coarse-grid sampling',/)
802 format(1x,'No symmetries used in the coarse-grid sampling',/)

  if (xct%nkpt_co.ne.kg%nf) then
   if(peinf%inode == 0) write(0,994) xct%nkpt_co,kg%nf
994 format('The given number of points in the coarse grid (',i4, &
      ') does not match the number of points in file WFN_co after unfolding (',i4,').')
    call die('If you are sure WFN_co is correct, please change the .inp file and try again.', only_root_writes = .true.)
  endif

!-----------------------------------------------------------------------
! Read the wavefunctions and distribute or write to temp files

  if (xct%iwriteint.eq.0) then
    
    write(filenamec,'(a)') 'INT_CWFN_CO'
    iunit_c=126
    write(filenamev,'(a)') 'INT_VWFN_CO'
    iunit_v=127
    
    if (peinf%inode.eq.0) then
      call open_file(iunit_c,file=filenamec,form='unformatted',status='replace')
      call open_file(iunit_v,file=filenamev,form='unformatted',status='replace')
    endif ! node 0
    
  endif ! xct%iwriteint.eq.0
  
  SAFE_ALLOCATE(wfnv%isort, (gvec%ng))
  wfnv%nband=xct%nvb_co
  wfnv%nspin=kp_co%nspin
  wfnv%nspinor=kp_co%nspinor
  wfnc%nband=xct%ncb_co
  wfnc%nspin=kp_co%nspin
  wfnc%nspinor=kp_co%nspinor
  
  call progress_init(prog_info, 'reading wavefunctions (WFN_co)', 'k-point', kp_co%nrk)
  do irk=1,kp_co%nrk
    call progress_step(prog_info, irk)
    irks = 0
    do ii=1,kg%nr
      if (indxk(ii) == irk) then
        irks=ii
        exit
      endif
    enddo

    SAFE_ALLOCATE(gvec_kpt%components, (3, kp_co%ngk(irk)))
    call read_binary_gvectors(25, kp_co%ngk(irk), kp_co%ngk(irk), gvec_kpt%components)

    SAFE_ALLOCATE(cg, (kp_co%ngk(irk),kp_co%nspin*kp_co%nspinor))
    if(irks > 0) then
      do ii = 1, kp_co%ngk(irk)
        call findvector(wfnv%isort(ii), gvec_kpt%components(:, ii), gvec)
        if (wfnv%isort(ii) == 0) call die('Could not find g-vector.')
      enddo
      
      wfnv%ng=kp_co%ngk(irk)
      wfnc%ng=kp_co%ngk(irk)
      if(peinf%inode == 0) then
        SAFE_ALLOCATE(wfnv%cg, (wfnv%ng,wfnv%nband,wfnv%nspin*wfnv%nspinor))
        SAFE_ALLOCATE(wfnc%cg, (wfnc%ng,wfnc%nband,wfnc%nspin*wfnc%nspinor))
        SAFE_ALLOCATE(cgarray, (kp_co%ngk(irk)))
      endif
    endif
    SAFE_DEALLOCATE_P(gvec_kpt%components)

! Loop over the bands

    do ii=1,kp_co%mnband

! Read planewave coefficients for band ii
      call read_binary_data(25, kp_co%ngk(irk), kp_co%ngk(irk), kp_co%nspin*kp_co%nspinor, cg)

      if(irks == 0) cycle
        
      if(peinf%inode == 0) then
        do is=1, kp_co%nspin
          if (ii .gt. (kp_co%ifmax(irk,is)-xct%nvb_co) .and. ii .le. (kp_co%ifmax(irk,is)+xct%ncb_co)) then
            
            do isp=1, kp_co%nspinor
              do kk=1, kp_co%ngk(irk)
                cgarray(kk)=cg(kk, is*isp)
              end do
#ifdef VERBOSE
              write(*,'(a, 3i7, 2(f18.13))') 'input_co', irks, ii, is*isp, cgarray(1)
#endif
              if ((ii.le.kp_co%ifmax(irk,is)).and. &
                (ii.gt.kp_co%ifmax(irk,is)-xct%nvb_co)) &
                wfnv%cg(1:wfnv%ng,kp_co%ifmax(irk,is)-ii+1,is*isp)=cgarray
              if ((ii.gt.kp_co%ifmax(irk,is)).and. &
                (ii.le.kp_co%ifmax(irk,is)+xct%ncb_co)) &
                wfnc%cg(1:wfnc%ng,ii-kp_co%ifmax(irk,is),is*isp)=cgarray
            enddo
            call checknorm('WFN_co',ii,irks,kp_co%ngk(irk),is,kp_co%nspinor,cg(:,:))
          end if
        end do
      endif
        
    enddo ! ii (loop over bands)
    
    SAFE_DEALLOCATE(cg)
    if(peinf%inode == 0) then
      SAFE_DEALLOCATE(cgarray)
    endif

    if (xct%iwriteint.eq.1) then

#ifdef MPI
      if (peinf%inode.ne.0) then
        SAFE_ALLOCATE(wfnv%cg, (wfnv%ng,wfnv%nband,wfnv%nspin*wfnv%nspinor))
        SAFE_ALLOCATE(wfnc%cg, (wfnc%ng,wfnc%nband,wfnc%nspin*wfnc%nspinor))
      endif
      call MPI_BCAST(wfnv%cg(1,1,1),wfnv%ng*wfnv%nband*wfnv%nspin*wfnv%nspinor, &
        MPI_SCALAR,0,MPI_COMM_WORLD,mpierr)
      call MPI_BCAST(wfnc%cg(1,1,1),wfnc%ng*wfnc%nband*wfnc%nspin*wfnc%nspinor, &
        MPI_SCALAR,0,MPI_COMM_WORLD,mpierr)
#endif

      distgwfco%ng(irks)=wfnv%ng
      do ii=1,distgwfco%ngl
        if (ii+distgwfco%tgl.le.wfnv%ng) &
          distgwfco%isort(ii,irks)=wfnv%isort(ii+distgwfco%tgl)
      enddo
      do kk=1,distgwfco%ns*distgwfco%nspinor
        do jj=1,distgwfco%nv
          do ii=1,distgwfco%ngl
            if (ii+distgwfco%tgl.le.wfnv%ng) then
              distgwfco%zv(ii,jj,kk,irks)=wfnv%cg(ii+distgwfco%tgl,jj,kk)
            endif
          enddo
        enddo
      enddo
      do kk=1,distgwfco%ns*distgwfco%nspinor
        do jj=1,distgwfco%nc
          do ii=1,distgwfco%ngl
            if (ii+distgwfco%tgl.le.wfnv%ng) then
              distgwfco%zc(ii,jj,kk,irks)=wfnc%cg(ii+distgwfco%tgl,jj,kk)
            endif
          enddo
        enddo
      enddo

    endif ! xct%iwriteint.eq.1

    if (xct%iwriteint.eq.0) then
      
      if (peinf%inode.eq.0) then
        write(iunit_v) irks,wfnv%ng,wfnv%nband,wfnv%nspin,wfnv%nspinor
        write(iunit_v) (wfnv%isort(ii),ii=1,gvec%ng), &
          (((wfnv%cg(ii,jj,kk),ii=1,wfnv%ng),jj=1,wfnv%nband),kk=1,wfnv%nspin*wfnv%nspinor)
        write(iunit_c) irks,wfnc%ng,wfnc%nband,wfnc%nspin,wfnc%nspinor
        write(iunit_c) (wfnv%isort(ii),ii=1,gvec%ng), &
          (((wfnc%cg(ii,jj,kk),ii=1,wfnc%ng),jj=1,wfnc%nband),kk=1,wfnc%nspin*wfnc%nspinor)
      endif ! node 0

    endif ! xct%iwriteint.eq.0

    if (peinf%inode.eq.0 .or. xct%iwriteint == 1) then
      SAFE_DEALLOCATE_P(wfnv%cg)
      SAFE_DEALLOCATE_P(wfnc%cg)
    endif ! node 0

  enddo ! irk (loop over k-points)
  call progress_free(prog_info)

  SAFE_DEALLOCATE_P(wfnv%isort)    
  SAFE_DEALLOCATE(indxk)
  
  if (peinf%inode.eq.0) then
    write(6,'(/,1x,a)') 'Coarse-grid wavefunctions read from file WFN_co'
    write(6,'(1x,a,i8)') ' - Number k-points in irreducible BZ: ', kg%nr
    write(6,'(1x,a,i8)') ' - Number k-points in full BZ: ', kg%nf
    write(6,'(1x,a,f12.6,a)') ' - Effective k-point radius: ', kg%sz,' Bohr^-1'
#ifdef VERBOSE
    write(6,'(/,1x,a)') 'Listing all k-points:'
    write(6,'(3x,3f15.9)') ((kg%r(ii,jj),ii=1,3),jj=1,kg%nr)
    write(6,'(1x,a,/)') 'Done listing k-points'
#endif
    if (xct%iwriteint.eq.0) then
      call close_file(iunit_v)
      call close_file(iunit_c)
    endif ! xct%iwriteint.eq.0
    call close_file(25)
  endif ! node 0

  SAFE_DEALLOCATE_P(kp_co%rk)
  SAFE_DEALLOCATE_P(kp_co%ifmin)
  SAFE_DEALLOCATE_P(kp_co%ifmax)
  SAFE_DEALLOCATE_P(kp_co%el)
  
  if(xct%iwriteint == 0) then
#ifdef MPI
    call MPI_Barrier(MPI_COMM_WORLD, mpierr)
#endif
  endif

  POP_SUB(input_co)

  return
end subroutine input_co

!===============================================================================
!
! bsemat_check       Originally By FHJ (02/10/2013)
!
!     This utility can be used to:
!       1) check the hermiticity of a single BSE kernel file, or
!       2) compare the hermiticity and the equivalence of a restricted (TDA)
!          BSE kernel with an extended one.
!
!     NOTE: all matrices are read and *stored in memory*, so avoid large files!
!
!===============================================================================

#include "f_defs.h"

program bsemat_check

  use global_m
  use misc_m
  implicit none

  character*256 :: fname_tda, fname_ext
  character :: ftype
  integer, parameter :: F_TDA=20, F_EXT=21
  integer :: nargs
  integer :: nk, nc, nv, ns, nb, bse_sz
  integer :: nk_ext, nc_ext, nv_ext, ns_ext
  integer :: ik, ik_, kk1(3), kk2(3), nmatrix
  SCALAR, allocatable :: bsemat_tda(:,:,:), bsemat_ext(:,:,:)
  type(xctinfo) :: xct_tda, xct_ext
  character(len=*), parameter :: fmt1 = &
    "('  -  (matrix ',i1,')  MAX | ',a,' | = ',es8.2e2)"

  nargs = iargc()
  if(nargs == 2 .or. nargs == 3) then
    call getarg(1, ftype)
    call getarg(2, fname_tda)
    if (nargs==3) call getarg(3, fname_ext)
  else
    call die('Usage: bsemat_check.x "X"|"D" bsemat_tda bsemat_extended OR "X"|"D" bsemat')
  endif
  write(6,'(a)') 'TDA kernel file: '//TRUNC(fname_tda)
  if (nargs==3) then
    write(6,'(a)') 'Extended kernel file: '//TRUNC(fname_ext)
  endif
  if (ftype=="X") then
    write(6,'(a)') 'Matrix type: Exchange'
    nmatrix = 1
  elseif (ftype=="D") then
    write(6,'(a)') 'Matrix type: Direct'
    nmatrix = 3
  else
    call die('Unknown matrix type. Options are "X" or "D".')
  endif
  write(6,'(a)')

  call open_file(F_TDA, file=TRUNC(fname_tda), form='unformatted', status='old')
  read(F_TDA) nk, nc, nv, ns
  nb = nv + nc
  ! FHJ: technically, we should use ncb_co for kernel stuff, but the bse_index
  ! function thinks we are dealing with the absorption program.
  xct_tda%nvb_fi = nv
  xct_tda%ncb_fi = nc
  xct_tda%nspin = ns
  bse_sz = (ns*nv*nc*nk)
  SAFE_ALLOCATE(bsemat_tda, (bse_sz,bse_sz,nmatrix))

  if (nargs==2) then
    do ik = 1,nk
      read(F_TDA)
    enddo
  else
    call open_file(F_EXT, file=TRUNC(fname_ext), form='unformatted', status='old')
    read(F_EXT) nk_ext, nc_ext, nv_ext, ns_ext
    if (nk/=nk_ext) call die("Number of k-points don't match.")
    if (ns/=ns_ext) call die("Number of spins don't match.")
    if (nv_ext/=nc_ext) call die("File does not contain an extended BSE kernel.")
    if (nb/=nc_ext) call die("Number of bands are not compatible between files.")
    do ik = 1,nk
      read(F_TDA) ik_, kk1(1:3)
      read(F_EXT) ik_, kk2(1:3)
      if (any(kk1/=kk2)) call die("K-points do not match.")
    enddo
    xct_ext%nvb_fi = nb
    xct_ext%ncb_fi = nb
    xct_ext%nspin = ns
    bse_sz = (ns*nb*nb*nk)
    SAFE_ALLOCATE(bsemat_ext, (bse_sz,bse_sz,nmatrix))
  endif

  write(6,'(a,a)') 'Parameters for TDA kernel file:'
  write(6,'(a,i8)') 'nk=',nk
  write(6,'(a,i8)') 'nc=',nc
  write(6,'(a,i8)') 'nv=',nv
  write(6,'(a,i8)') 'ns=',ns
  write(6,'(a)')
  write(6,'(a)') 'Reading TDA BSE matrices.'
  call read_bsemat(F_TDA, xct_tda, bsemat_tda)
  if (nargs==3) then
    write(6,'(a)') 'Reading extended BSE matrices.'
    call read_bsemat(F_EXT, xct_ext, bsemat_ext)
  endif
  write(6,'(a)')

  write(6,'(a)') 'Checking hermiticity of TDA kernel file.'
  call check_hermiticity(xct_tda, bsemat_tda)
  write(6,'(a)')
  if (nargs==3) then
    write(6,'(a)') 'Checking hermiticity of extended kernel file.'
    call check_hermiticity(xct_ext, bsemat_ext)
    write(6,'(a)')
    write(6,'(a)') 'Checking equivalence of TDA and extended kernels:'
    call check_equivalence()
    write(6,'(a)')
    SAFE_DEALLOCATE(bsemat_ext)
    call close_file(F_EXT)
  endif
  SAFE_DEALLOCATE(bsemat_tda)
  call close_file(F_TDA)
  write(6,'(a)') 'All done.'

contains

  !> Reads bsemat file F_BSE and stores kernel matrices in bsemat (it, itp, imatrix)
  subroutine read_bsemat(F_BSE, xct, bsemat)
    integer, intent(in) :: F_BSE
    type(xctinfo), intent(in) :: xct
    SCALAR, intent(out) :: bsemat(:,:,:)

    integer :: nv_, nc_, ik_, ic_, iv_, imatrix
    integer :: ik, ic, iv, is, it
    integer :: ikp, icp, ivp, isp, itp
    SCALAR, allocatable :: buf(:,:,:,:,:) !<isp, is, ivp, icp, ikp

    PUSH_SUB(bsemat_check.read_bsemat)

    nv_ = xct%nvb_fi
    nc_ = xct%ncb_fi
    SAFE_ALLOCATE(buf, (ns,ns,nv_,nc_,nk))
    do ik = 1, nk
      do imatrix = 1, nmatrix
        do ic = 1, nc_
          do iv = 1, nv_
            read(F_BSE) ik_, ic_, iv_, buf(:,:,:,:,:)
            do is = 1, ns
              it = bse_index(ik, ic, iv, is, xct)
              do ikp = 1, nk
                do icp = 1, nc_
                  do ivp = 1, nv_
                    do isp = 1, ns
                      itp = bse_index(ikp, icp, ivp, isp, xct)
                      bsemat(it, itp, imatrix) = buf(isp, is, ivp, icp, ikp)
                    enddo
                  enddo
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
    enddo
    SAFE_DEALLOCATE(buf)

    POP_SUB(bsemat_check.read_bsemat)

  end subroutine read_bsemat

  !> Calculates the deviation from the hermiticity via K - K^H.
  subroutine check_hermiticity(xct, bsemat)
    type(xctinfo), intent(in) :: xct
    SCALAR, intent(in) :: bsemat(:,:,:)

    real(DP) :: diff_max
    integer :: imatrix, it, itp

    PUSH_SUB(bsemat_check.check_hermiticity)

    bse_sz = ns*xct%nvb_fi*xct%ncb_fi*nk
    do imatrix = 1, nmatrix
      diff_max = 0d0
      do itp = 1, bse_sz
        do it = itp, bse_sz
          diff_max = max(diff_max, abs(bsemat(it,itp,imatrix) &
            - MYCONJG(bsemat(itp,it,imatrix))))
        enddo
      enddo
      write(6,fmt1) imatrix, 'K - K^H', diff_max
    enddo

    POP_SUB(bsemat_check.check_hermiticity)

  end subroutine check_hermiticity

  !> Checks the equivalence of the TDA kernel matrices with the extended ones.
  !! For the extended matrices, both vc,v`c` and cv,c`v` transitions are
  !! considered.
  subroutine check_equivalence()
    real(DP) :: diff_max, diff_max2
    integer :: imatrix, it, itp
    integer :: it_ext, it_ext2, itp_ext, itp_ext2
    integer :: ik, ic, iv, is
    integer :: ikp, icp, ivp, isp

    PUSH_SUB(bsemat_check.check_equivalence)

    do imatrix = 1, nmatrix
      diff_max = 0d0
      diff_max2 = 0d0
      do ikp = 1, nk
        do icp = 1, nc
          do ivp = 1, nv
            do isp = 1, ns
              itp = bse_index(ikp, icp, ivp, isp, xct_tda)
              itp_ext = bse_index(ikp, nv+icp, ivp, isp, xct_ext)
              itp_ext2 = bse_index(ikp, ivp, nv+icp, isp, xct_ext)
              do ik = 1, nk
                do ic = 1, nc
                  do iv = 1, nv
                    do is = 1, ns
                      it = bse_index(ik, ic, iv, is, xct_tda)
                      it_ext = bse_index(ik, nv+ic, iv, is, xct_ext)
                      it_ext2 = bse_index(ik, iv, nv+ic, is, xct_ext)
                      diff_max = max(diff_max, abs(bsemat_tda(it,itp,imatrix) &
                        - bsemat_ext(it_ext,itp_ext,imatrix)))
                      diff_max2 = max(diff_max2, abs(bsemat_tda(it,itp,imatrix) &
                        - MYCONJG(bsemat_ext(it_ext2,itp_ext2,imatrix))))
                    enddo
                  enddo
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
      write(6,fmt1) imatrix, "K_TDA(vc,v`c`) - K_EXT(vc,v`c`)  ", diff_max
      write(6,fmt1) imatrix, "K_TDA(vc,v`c`) - K_EXT(cv,c`v`)^*", diff_max2
    enddo

    POP_SUB(bsemat_check.check_equivalence)

  end subroutine check_equivalence

end program bsemat_check

!-------------------------------------------------------------------------------
!
!   rho2cd.f90
!   converts BerkeleyGW file RHO to PARATEC file CD
!   written by M. Jain (May 2010)
!
!-------------------------------------------------------------------------------

#include "f_defs.h"

program rho2cd

  use global_m
  use wfn_rho_vxc_io_m
  implicit none

  character(len=24) :: bdate
  character(len=8) :: btime
  character(len=11) :: cdate
  character(len=14) :: stime

  type(kpoints) :: kp
  type(gspace) :: gvec
  type(symmetry) :: syms
  type(crystal) :: crys

  integer :: ig, is
  SCALAR, allocatable :: rho(:,:)

  integer :: iflavor
  character(len=3) :: sheader
  
  call open_file(95,file='RHO',form='unformatted',status='old')
  call open_file(21,file='CD',form='unformatted',status='replace')
  
  write(6,*) 'Opening RHO'

  sheader = 'RHO'
  iflavor = 0
  call read_binary_header_type(95, sheader, iflavor, kp, gvec, syms, crys, warn = .false.)

  SAFE_ALLOCATE(gvec%components, (3, gvec%ng))
  call read_binary_gvectors(95, gvec%ng, gvec%ng, gvec%components)

  SAFE_ALLOCATE(rho, (gvec%ng, kp%nspin))
  call read_binary_data(95, gvec%ng, gvec%ng, kp%nspin, rho)

  call date_time(cdate, stime)
  write(bdate, '(a11,13x)') cdate
  write(btime, '(a8)') stime(1:8)
  write(21) bdate, btime
  
  write(21) 1, kp%nspin
  
  do ig = 1, gvec%ng
    write(21) gvec%components(1:3, ig)
    write(21) (COMPLEXIFY(rho(ig, is)), is = 1, kp%nspin)
  enddo
  write(21) -1234567, 0, 0
  ! the purpose of this last line is a profound mystery
  
  call dealloc_header_type(sheader, crys, kp)
  SAFE_DEALLOCATE_P(gvec%components)
  SAFE_DEALLOCATE(rho)

  call close_file(95)
  call close_file(21)
  
end program rho2cd

!===============================================================================
!
! Routines:
!
! (1) absp0()           Originally By MLT       Last Modified 6/5/2008 (JRD)
!
!     input: eqp             eqpinfo type
!            xct             xctinfo type
!            s0              velocity or momentum matrix elements
!            vol             crystal volume (cell volume times # of k-points)
!            omega_plasma    plasma frequency, given in Ryd
!            flag            flags type
!
!     output: file "absorption_noeh.dat"
!
!     Calculate the absorption without electron-hole interaction,
!     using eq. (27) of Rohlfing & Louie PRB 62 4927 (2000).
!     Absorption and emission contributions are calculated separately.
!     The causal, retarded dielectric function is assumed.
!
!     For the time-ordered dielectric function, both real and imaginary
!     parts are even functions of frequency. For the causal, retarded
!     dielectric function, the real part is an even function and the
!     imaginary part is an odd function of frequency.
!
!     NOTE: I am not sure if the numerical factor in eqs. (26) and (27)
!     is right. There should be a 4*Pi^2 instead of 16*Pi. (Murilo)
!
!     REPLY: There was a typo in eqs. (26) and (27), the correct factor
!     is 16*Pi^2. The code, however, was correct, an additional factor
!     of Pi was hidden in the delta function (gaussian and lorentzian).
!     I put it in the prefactor. There is a factor of 4*Pi^2 in eq.
!     (6.48) of Yu & Cardona "Fundamentals of Semiconductors" because
!     they use the real representation for electromagnetic waves.
!     Using the complex representation and including spin,
!     their factor 4*Pi^2 becomes our 16*Pi^2. (gsm)
!
!     RE-REPLY: There is another typo in eqs. (26) and (27). Including spin,
!     the prefactor should be 8*Pi^2*e^2, where e^2 = 2 because we use 
!     Rydberg units. If we follow RMP 74, 2 (2002), eqn (4.12):
!       eps(q, w) = 1 - v(q) \sum |<n1|e^{-iq.r}|n2>*A|^2 / (w - E + i*eta)
!     But v(q) = 4*Pi*e^2 / q^2 and Im[1/(x + i*eta)] ~ pi * delta(x).
!     If we multiply by the spin degeneracy, we get the prefactor 8*Pi^2*e^2.
!     Another nice reference is PRB 73, 045112 (2006), eqn (13).
!     The bottom line is that the code was right, but the extra factor of two
!     comes from the e^2 and not from the real/complex representation. (FHJ)
!
!     Each delta function is replaced by a Lorentzian, Gaussian or Voigt peak:
!     delta(x) -> (xct%eta/pi)/(x^2+xct%eta^2)
!     delta(x) -> exp(-x^2/(2*xct%eta^2))/(sqrt(2*pi)*xct%eta)
!     delta(x) -> Voigt(x,xct%sigma,xct%gamma)
!
!     omega = frequency, given in eV
!     xct%eta,xct%sigma,xct%gamma = energy broadening, given in eV
!
!===============================================================================

#include "f_defs.h"

subroutine absp0(eqp,xct,s0,vol,omega_plasma,flag)

  use global_m
  use misc_m
  implicit none
  
  type (eqpinfo), intent(in) :: eqp
  type (xctinfo), intent(in) :: xct
  SCALAR, intent(in) :: s0(xct%nkpt_fi*xct%ncb_fi*xct%nvb_fi*xct%nspin)
  real(DP), intent(in) :: vol, omega_plasma
  type (flags), intent(in) :: flag

  integer :: ic,iv,ik,ikcvs,is,iemax,iw,nwstep
  real(DP) :: emin,emax,eps1,eps2,dos
  real(DP) :: omega,omegalda,fac1,fac2,sum1,sum2,pref,fac
  integer :: neig
  
  PUSH_SUB(absp0)
  
  pref = 16.d0 * PI_D**2 / (vol * dble(xct%nspin))
  neig = xct%nkpt_fi * xct%ncb_fi * xct%nvb_fi * xct%nspin

!----------------------------
! Check the f-sum rule using DFT and DFT+GW eigenvalues.
! The sum rule differs because of nonlocal contributions
! in the GW corrections.
! Exact value of the sum rule (nonlocal contributions neglected):
! sum1 = (pi / 2.d0) * (plasma frequency)^2

  emin = 1.d10
  emax = 0.d0
  sum1 = 0.d0
  sum2 = 0.d0
  do ik=1,xct%nkpt_fi
    do ic=1,xct%ncb_fi
      do iv=1,xct%nvb_fi
        do is=1,xct%nspin
          ikcvs = bse_index(ik, ic, iv, is, xct)
          omega = eqp%ecqp(ic,ik,is) - eqp%evqp(iv,ik,is)
          omegalda = eqp%eclda(ic,ik,is) - eqp%evlda(iv,ik,is)
          if (omega.lt.emin) emin = omega
          if (omega.gt.emax) emax = omega

          sum1 = sum1 + omega * abs(s0(ikcvs))**2
          sum2 = sum2 + omegalda * abs(s0(ikcvs))**2

!            ediff = eqp%eclda(ic,ik,is) - eqp%evlda(iv,ik,is)
!            sum1 = sum1 + omega * abs(s0(ikcvs))**2 / ediff**2
!            ediff = eqp%eclda(ic,ik,is) - eqp%evlda(iv,ik,is)
!            sum2 = sum2 + omegalda * abs(s0(ikcvs))**2 / ediff**2
        enddo
      enddo
    enddo
  enddo
  sum1 = sum1 * pref * ryd**2
  sum2 = sum2 * pref * ryd**2
  if (omega_plasma.lt.TOL_Small) then
    write(6,*)
    write(6,*) 'Sum rule (DFT) : ',sum2,' eV^2'
    write(6,*) 'Sum rule (GW)  : ',sum1,' eV^2'
    write(6,*)
  else
    sum1 = sum1 / (0.5d0 * PI_D * omega_plasma**2 * ryd**2)
    sum2 = sum2 / (0.5d0 * PI_D * omega_plasma**2 * ryd**2)
    write(6,*)
    write(6,*) 'Plasma Frequency : ',omega_plasma*ryd,' eV'
    write(6,*)
    write(6,*) 'Sum rule (DFT) : ',sum2
    write(6,*) 'Sum rule (GW)  : ',sum1
    write(6,*)
  endif
  emin = emin * ryd
  emax = emax * ryd
!      emin = max(emin - 10.d0 * xct%eta, 0.d0)
!      emax = emax + 10.d0 * xct%eta
!      nwstep = 10000
  emin = 0.d0
  iemax = int(emax + 10.d0 * xct%eta) + 1
  emax = dble(iemax)
  nwstep = 100 * iemax
 
  call open_file(10,file='eigenvalues_noeh.dat',form='formatted',status='replace')
  write(10,'(a,i8)') '# neig  = ', neig
  write(10,'(a,e16.9)') '# vol   = ', vol
  write(10,'(a,i8)') '# nspin = ', xct%nspin
  write(10,'(a)',advance='no') '#   ik    ic    iv    is        eig (eV)   abs(dipole)^2'
#ifdef CPLX
  write(10,'(a)') '      Re(dipole)      Im(dipole)'
#else
  write(10,'(a)') '          dipole'
#endif
  do ik=1,xct%nkpt_fi
    do ic=1,xct%ncb_fi
      do iv=1,xct%nvb_fi
        do is=1,xct%nspin
          ikcvs = bse_index(ik, ic, iv, is, xct)
          write(10,'(4i6,4e16.8)') ik, ic, iv, is, (eqp%ecqp(ic,ik,is) - eqp%evqp(iv,ik,is))*ryd, abs(s0(ikcvs))**2, s0(ikcvs)
        enddo
      enddo
    enddo
  enddo
  call close_file(10)

  call open_file(10,file='absorption_noeh.dat',form='formatted',status='replace')

  write(10,*) "# Column 1: omega"
  write(10,*) "# Column 2: eps2(omega)"
  write(10,*) "# Column 3: eps1(omega)"
  write(10,*) "# Column 4: JDOS(omega)"

  do iw=0,nwstep
    eps1 = 0.d0
    eps2 = 0.d0
    dos = 0.d0
    omega = emin + (emax - emin) * dble(iw) / dble(nwstep)

!----------------------------
! Absorption contribution

    sum1 = 0.d0
    sum2 = 0.d0
    do ik=1,xct%nkpt_fi
      do ic=1,xct%ncb_fi
        do iv=1,xct%nvb_fi
          do is=1,xct%nspin
            ikcvs = bse_index(ik, ic, iv, is, xct)
            fac = omega / ryd - eqp%ecqp(ic,ik,is) + eqp%evqp(iv,ik,is)
!          ediff = eqp%eclda(ic,ik,is) - eqp%evlda(iv,ik,is)
            fac1 = (-fac / PI_D) / (fac**2 + (xct%eta / ryd)**2)
            sum1 = sum1 + abs(s0(ikcvs))**2 * fac1

!            sum1 = sum1 + abs(s0(ikcvs))**2 * fac1 / ediff**2
            
            if (flag%lor.eq.0) then
              fac2 = (xct%eta / ryd / PI_D) / (fac**2 + (xct%eta / ryd)**2)
            else if (flag%lor.eq.1) then
              fac2 = exp(-fac**2 / (2.d0 * (xct%eta / ryd)**2)) / (sqrt(2.d0 * PI_D) * xct%eta / ryd)
            else
              fac2 = voigt(fac, xct%sigma, xct%gamma)
            endif
            
            sum2 = sum2 + abs(s0(ikcvs))**2 * fac2
!            sum2 = sum2 + abs(s0(ikcvs))**2 * fac2 / ediff**2
            dos = dos + fac2
          enddo
        enddo
      enddo
    enddo
    eps1 = 1.d0 + pref * sum1
    eps2 = pref * sum2
    dos = dos / (ryd * dble(neig))
    
!--------------------------
! Emission contribution
! eps2 gets negative contribution, so it vanishes at zero frequency

    sum1 = 0.d0
    sum2 = 0.d0
    do ik=1,xct%nkpt_fi
      do ic=1,xct%ncb_fi
        do iv=1,xct%nvb_fi
          do is=1,xct%nspin
            ikcvs = bse_index(ik, ic, iv, is, xct)
            fac = -omega / ryd - eqp%ecqp(ic,ik,is) + eqp%evqp(iv,ik,is)
!          ediff = eqp%eclda(ic,ik,is) - eqp%evlda(iv,ik,is)
            fac1 = (-fac / PI_D) / (fac**2 + (xct%eta/ryd)**2)
            sum1 = sum1 + abs(s0(ikcvs))**2 * fac1
!            sum1 = sum1 + abs(s0(ikcvs))**2 * fac1 / ediff**2
            
            if (flag%lor .eq. 0) then
              fac2 = -(xct%eta / ryd / PI_D) / (fac**2 + (xct%eta / ryd)**2)
            else if (flag%lor.eq.1) then
              fac2 = -exp(-fac**2 / (2.d0 * (xct%eta / ryd)**2)) / (sqrt(2.d0 * PI_D) * xct%eta / ryd)
            else
              fac2 = -voigt(fac, xct%sigma, xct%gamma)
            endif
            
            sum2 = sum2 + abs(s0(ikcvs))**2 * fac2
!            sum2 = sum2 + abs(s0(ikcvs))**2 * fac2 / ediff**2
          enddo
        enddo
      enddo
    enddo
!        if (flag%opr.eq.1) then
!          sum1 = sum1 / (omega / ryd)**2
!          sum2 = sum2 / (omega / ryd)**2
!        endif
    eps1 = eps1 + pref * sum1
    eps2 = eps2 + pref * sum2

100 format(4f16.9)
    write(10,100)omega,eps2,eps1,dos
  enddo
  
  call close_file(10)
  
  POP_SUB(absp0)
  
  return
  
end subroutine absp0

!==============================================================================
!
! Routines:
!
! (1) interpol()        Originally By MLT       Last Modified 6/2008 FJR
!
!     Computes the density at any point r by linear interpolation
!     inside the eight vertices of the surrounding cube
!
!==============================================================================

#include "f_defs.h"

subroutine interpol(rhole,nfft,wfnvint,fftboxv)

  use global_m
  implicit none

  real(DP), intent(in) :: rhole(3)
  integer, intent(in) :: nfft(3)
  complex(DPC), intent(out) :: wfnvint
  complex(DPC), intent(in) :: fftboxv(nfft(1),nfft(2),nfft(3))
  
  integer :: ir(3),pr(3)
  real(DP) :: rr(3),x(3),shift

!--------------------------
! Shift to [0,1) cell

  PUSH_SUB(interpol)
  
  shift = anint( 10.d0 + maxval(rhole) )
  rr(1:3) = rhole(1:3) + shift - aint( rhole(1:3) + shift )
  
! Define the surrouding cube
!   ir .le. rr*nfft .lt. pr ; 0 .lt. ir,pr .le. nfft

  ir(1:3) = int(rr(1:3) * nfft(1:3))
  
  pr(1:3) = mod(ir(1:3) + 1, nfft(1:3))
  
  x(1:3) = rr(1:3) * nfft(1:3) - ir(1:3)
  
! Periodic boundary conditions

  if(ir(1) == 0) ir(1) = nfft(1)
  if(ir(2) == 0) ir(2) = nfft(2)
  if(ir(3) == 0) ir(3) = nfft(3)
  
  if(pr(1) == 0) pr(1) = nfft(1)
  if(pr(2) == 0) pr(2) = nfft(2)
  if(pr(3) == 0) pr(3) = nfft(3)
  
! Interpolate

  wfnvint=0.0d0
  wfnvint=wfnvint+fftboxv(ir(1),ir(2),ir(3))*(1.0-x(1))*(1.0-x(2))*(1.0-x(3))
  wfnvint=wfnvint+fftboxv(pr(1),ir(2),ir(3))*x(1)*(1.0-x(2))*(1.0-x(3))
  wfnvint=wfnvint+fftboxv(ir(1),pr(2),ir(3))*(1.0-x(1))*x(2)*(1.0-x(3))
  wfnvint=wfnvint+fftboxv(ir(1),ir(2),pr(3))*(1.0-x(1))*(1.0-x(2))*x(3)
  wfnvint=wfnvint+fftboxv(pr(1),pr(2),ir(3))*x(1)*x(2)*(1.0-x(3))
  wfnvint=wfnvint+fftboxv(ir(1),pr(2),pr(3))*(1.0-x(1))*x(2)*x(3)
  wfnvint=wfnvint+fftboxv(pr(1),ir(2),pr(3))*x(1)*(1.0-x(2))*x(3)
  wfnvint=wfnvint+fftboxv(pr(1),pr(2),pr(3))*x(1)*x(2)*x(3)
  
  POP_SUB(interpol)
  
  return
end subroutine interpol

!===============================================================================
!
! Routines:
!
! 1. norm_wfng()        Originally By gsm        Last Modified 9/1/2010 (gsm)
!
!    Normalizes wavefunctions in G-space.
!
!===============================================================================

#include "f_defs.h"

subroutine norm_wfng(ngk_l,nbstart,nbend,nb,ns,nk,wfn_d)

  use global_m
  use blas_m
  implicit none

  integer, intent(in) :: ngk_l,nbstart,nbend,nb,ns,nk
  SCALAR, intent(inout) :: wfn_d(ngk_l,nb,ns,nk) !< parallelized over G-vectors

  integer :: ib,is,ik,nbnorm
  character(len=16) :: s1,s2,s3
  real(DP), allocatable :: norm2band(:)
  real(DP), allocatable :: norm2dummy(:)

  PUSH_SUB(norm_wfng)

  nbnorm=nbend-nbstart+1
  SAFE_ALLOCATE(norm2band, (nbnorm))
#ifdef MPI
  SAFE_ALLOCATE(norm2dummy, (nbnorm))
#endif
  do ik=1,nk
    do is=1,ns
      do ib=nbstart,nbend
        norm2band(ib-nbstart+1) = blas_nrm2(ngk_l, wfn_d(:,ib,is,ik), 1)**2
      enddo ! ib
#ifdef MPI
      norm2dummy=norm2band
      call MPI_Allreduce(norm2dummy,norm2band,nbnorm, &
        MPI_REAL_DP,MPI_SUM,MPI_COMM_WORLD,mpierr)
#endif
      do ib=nbstart,nbend
        if (norm2band(ib-nbstart+1) .gt. TOL_Zero) then
          call X(scal)(ngk_l, ONE/sqrt(norm2band(ib-nbstart+1)), wfn_d(:,ib,is,ik), 1)
        else ! norm2.gt.TOL_Zero
          if (peinf%inode.eq.0) then
            write(s1,111)ib
            write(s2,111)is
            write(s3,111)ik
            write(0,211)TRUNC(s1),TRUNC(s2),TRUNC(s3)
          endif ! peinf%inode.eq.0
        endif ! norm2.gt.TOL_Zero
      enddo ! ib
    enddo ! is
  enddo ! ik
  SAFE_DEALLOCATE(norm2band)
#ifdef MPI
  SAFE_DEALLOCATE(norm2dummy)
#endif
  
  POP_SUB(norm_wfng)
  
  return
  
111 format(i16)
  
211 format(1x,"WARNING: zero norm for k-point =",1x,a,1x,"spin =", &
      1x,a,1x,"band =",1x,a,/)
  
end subroutine norm_wfng

#include "f_defs.h"

module band_m

  use global_m
  use iolib_m
  implicit none

  type band 
    integer :: nrk, min(2), max, nspin
    integer, pointer :: nband(:,:), ifmax(:,:)
    real(DP), pointer :: energy(:,:,:), ekn(:,:,:), occup(:,:,:)
  end type band

contains

  subroutine read_band(fname,b)
    character(len=*), intent(in) :: fname      ! the filename
    type(band), intent(inout) :: b

    integer :: j, k, l, info
    integer, parameter :: mymarker = 6 
    integer :: nrk, max, nspin

    PUSH_SUB(read_band)

    call open_file(unit = 21, file = fname, status = 'unknown', &
      form = 'formatted')
    call iolib_find_marker(mymarker, 21, info)
    if (info == 0) then
      write(0,*) 'There is a problem'
      POP_SUB(read_band)
      return  
    end if
    read(21, *, end = 102) b%nrk, b%min, b%max, b%nspin
    nrk = b%nrk
    nspin = b%nspin
    max = b%max
    SAFE_ALLOCATE(b%nband, (nrk, nspin)); b%nband = 0
    SAFE_ALLOCATE(b%occup, (max, nrk, nspin)); b%occup = 0d0
    SAFE_ALLOCATE(b%energy, (max, nrk, nspin)); b%energy = 0d0
    SAFE_ALLOCATE(b%ekn, (max, nrk, nspin)); b%ekn = 0d0
    SAFE_ALLOCATE(b%ifmax, (nrk, nspin)); b%ifmax = 0


    read(21, *, end = 102) ((b%nband(k, j), k = 1, nrk), j = 1, nspin)
    read(21, *, end = 102) ((b%ifmax(k, j), k = 1, nrk), j = 1, nspin)
    read(21, *, end = 102) (((b%energy(l, k, j), l = 1, max), &
      k = 1, nrk), j = 1, nspin)
    read(21, *, end = 102) (((b%ekn(l, k, j), l = 1, max), &
      k = 1, nrk), j = 1, nspin)
    read(21, *, end = 102) (((b%occup(l, k, j), l = 1, max), &
      k = 1, nrk), j = 1, nspin)
    call close_file(21)

    POP_SUB(read_band)
    return

102 continue
    write(0, *) 'iolib: reached eof when reading bands'

    POP_SUB(read_band)

    return
  end subroutine read_band

  subroutine write_band(fname, struc)

    implicit none      ! implicit? no!

    character(len=*), intent(in) :: fname      ! the filename
    type(band), intent(in) :: struc

    !     ----------- local variables
    integer :: j, k, l
    integer, parameter :: mymarker = 6

    PUSH_SUB(write_band)

    call open_file(unit = 21, file = fname, position = 'rewind', status = 'unknown', &
      form = 'formatted')

    write(21, *) mymarker, ' band info'
    write(21, *) struc%nrk, struc%min, struc%max, struc%nspin
    write(21, *) ((struc%nband(k, j), k = 1, struc%nrk), j = 1, struc%nspin)
    write(21, *) ((struc%ifmax(k, j), k = 1, struc%nrk), j = 1, struc%nspin)

    write(21, *) (((struc%energy(l, k, j), l = 1, struc%max), &
      k = 1, struc%nrk), j = 1, struc%nspin)
    write(21, *) (((struc%ekn(l, k, j), l = 1, struc%max), &
      k = 1, struc%nrk), j = 1, struc%nspin)
    write(21, *) (((struc%occup(l, k, j), l = 1, struc%max), &
      k = 1, struc%nrk), j = 1, struc%nspin)
    call close_file(21)

    POP_SUB(write_band)
    return  

  end subroutine write_band

end module band_m

!===============================================================================
!
! MODULE:
!
! interp_m          Originally Dec/2012 by FHJ    Last Modified: Apr/2013 (FHJ)
!
!>  Bourne-again interpolation routines.
!
! DESCRIPTION:
!
!   This module contains routines to interpolate points. When initialized,
!   the code performs a Delaunay triangulation of the coarse points. When 
!   evaluating each interpolated point, the code finds the Delaunay simplex 
!   that encloses the point, and returns the appropriate coefficients.
!
!===============================================================================

#include "f_defs.h"

module interp_m

  use global_m
  use lapack_m
  use sort_m
  use tile_m

  implicit none

  !> The interpolator `object`
  type :: interp_t
    integer :: dims !< Number of dimensions
    integer :: npts_orig !< Number of points w/o periodicity
    integer :: npts !< Number of points including periodic images, if periodic
    !> Coarse points in "effective" crystal coords (this%dims, this%npts)
    !! "Effective" means that only the active dimensions are kept here, and
    !! they are selected/reordered according to dims_map(:).
    real(DP), pointer :: pts_crys(:,:)
    !> Coarse points in Cartesian coords (this%dims, this%npts)
    !! pts_cart = dot(bvec_, pts_crys). Only calculated for 2D and 3D.
    real(DP), pointer :: pts_cart(:,:)
    !> This is the effective transformation matrix from crystal to Cartesian,
    !! with dimensions this%dims x this%dims. Only calculated for 2D and 3D.
    real(DP), pointer :: bvec_(:,:)
    logical :: periodic !< If .true., add copy of pts in all directions
    !> Map each internal interpolated dimension to the crystal axes.
    !! This is needed b/c Qhull only accepts rank-1/-2 arrays for
    !! 1-/2-D interpolation.
    integer, pointer :: dims_map(:)
    !> For 1D systems only, this is a list of indices that sorts pts_crys.
    integer, pointer :: pts_crys_ind(:)
    !> For 1D systems, this is the sorted version of pts_crys, sorted. Same as
    !! pts_crys(1,pts_crys_ind(:)), but better for the cache.
    real(DP), pointer :: pts_crys_ord(:)
  end type interp_t

  public :: interp_init, interp_free, interp_eval

contains


  !> Initialize the interpolation object
  !! This routine:
  !! 1) Adds ghost copies of points in the periodic directions.
  !!    Reason: Qhull doesn`t deal with periodicity.
  !! 2) Finds an effective transformation from crystal coords to Cartesian,
  !!    so that the number of Cartesian coordinates = number of dimensions
  !!    This is trivial in 3D, and a bit tedious in 2D.
  !!    Reason: Qhull doesn`t accept "metrics", and requires #coordinates = 
  !!    dimensionality of the Delaunay tessellation.
  !! 3) Performs the Delaunay triangulation/tetrahedralization.
  subroutine interp_init(this, crys, pts, dims, periodic, active_dims)
    type(interp_t), intent(out) :: this
    type(crystal), intent(in) :: crys
    real(DP), intent(in) :: pts(:,:)
    integer, intent(in) :: dims
    logical, intent(in) :: periodic
    logical, intent(in) :: active_dims(3)

    integer :: ipt, ighost, n_ghost, jdim
    integer :: offset, ghost_G(3), ierr
    real(DP), pointer :: sub_pts(:,:)

    PUSH_SUB(interp_init)

#ifdef VERBOSE
    if (peinf%inode==0) then
      write(6,'(1x,a)') 'Starting inter_init:'
      write(6,'(2x,a,i0)') 'dims = ', dims
      write(6,'(2x,a,l1)') 'periodic = ', periodic
      write(6,'(2x,a,3(1x,l1))') 'active_dims =', active_dims
      write(6,'(2x,a,i0," x ",i0)') 'shape(pts) = ', size(pts, dim=1), size(pts, dim=2)
    endif
#endif
    ! FHJ: Initialize number of dimensions, figure out dims_map, etc.
    if (dims<0 .or. dims>3) &
      call die("Wrong number of dimensions", only_root_writes=.true.)
    if (dims/=count(active_dims)) &
      call die("Inconsistent parameters dims and active_dims", &
      only_root_writes=.true.)
    this%dims = dims
    this%periodic = periodic
    this%npts_orig = size(pts, dim=2)
    if (this%npts_orig<this%dims+1) then
      ! If we have less points than dims+1, we can`t really interpolate...
      this%dims = 0
      if (peinf%inode==0) then
        write(0,'(/,a)') 'WARNING: Insufficient points to perform linear interpolation.'
        write(0,'(a)') 'Please, make sure your coarse k-grid is correct.'
        write(0,'(a,/)') 'Falling back to constant extrapolation using 1st coarse point.'
      endif
    endif
    if (this%dims==0) then
      ! No initialization needed for 0D systems or nearest neighbor interpolation
      this%npts = 0
#ifdef VERBOSE
      if (peinf%inode==0) write(6,*)
#endif
      POP_SUB(interp_init)
      return
    endif
    SAFE_ALLOCATE(this%dims_map, (this%dims))
    call get_dims_map()

    ! FHJ: Deal with periodicity by adding ghost copies of the universe.
    ! Note: n_ghost=1 means only the original set of points
    n_ghost = 1
    if (this%periodic) n_ghost = 3**this%dims
    this%npts = this%npts_orig * n_ghost
    SAFE_ALLOCATE(this%pts_crys, (this%dims, this%npts))
    ghost_G(:) = 0
    do ighost = 0, n_ghost-1
      offset = this%npts_orig*ighost + 1
      ! FHJ: the outermost mod()`s map (0, 1, 2) to (0, 1, -1)
      ghost_G(1) = mod(mod(ighost, 3) + 1, 3) - 1
      if (this%dims>1) &
        ghost_G(2) = mod(mod(ighost/3, 3) + 1, 3) - 1
      if (this%dims>2) &
        ghost_G(3) = mod(mod(ighost/9, 3) + 1, 3) - 1

      sub_pts => this%pts_crys(1:this%dims, offset:offset+this%npts_orig-1)
      do ipt = 1, this%npts_orig
        do jdim = 1, this%dims
          sub_pts(jdim, ipt) = pts(this%dims_map(jdim), ipt) + ghost_G(jdim)
        enddo
      enddo
    enddo

    ! FHJ: For 1D, just sort the points in crystal coords. For 2D/3D, we
    ! need the effective metric and the Delaunay tessellation.
    if (dims==1) then ! 1D
      ! FHJ: Just sort the points.
      SAFE_ALLOCATE(this%pts_crys_ind, (this%npts))
      call sortrx(this%npts, this%pts_crys(1,:), this%pts_crys_ind)
      SAFE_ALLOCATE(this%pts_crys_ord, (this%npts))
      do ipt = 1, this%npts
        this%pts_crys_ord(ipt) = this%pts_crys(1, this%pts_crys_ind(ipt))
      enddo
    else ! 2D and 3D
      ! FHJ: Find the appropriate metric that transforms 3D/2D.
      ! crystal coordinates into Cartesian coordinates in the subspace.
      SAFE_ALLOCATE(this%bvec_, (this%dims, this%dims))
      if (dims==3) then
        call init_metric_3D()
      else if (dims==2) then
        call init_metric_2D()
      endif

      ! FHJ: Apply the transformation from the crystal coordinates to get the
      ! subspace Cartesian coordinates
      SAFE_ALLOCATE(this%pts_cart, (this%dims, this%npts))
      call dgemm('n', 'n', this%dims, this%npts, this%dims, 1D0, this%bvec_,&
        this%dims, this%pts_crys, this%dims, 0D0, this%pts_cart, this%dims)
    
      ! FHJ: Delaunay tessellation
      ierr = init_delaunay(this%pts_cart(:,:), this%npts, this%dims)
      if (ierr/=0) &
        call die('Could not perform Delaunay triangulation!', only_root_writes=.true.)
    endif

    POP_SUB(interp_init)

  contains

    !> Initialize the dims_map array with the periodic directions.
    !! E.g. #1: for a 2D system where z is truncated and x and y are 
    !! periodic, this%dims_map = (/1, 2/).
    !! E.g. #1: for a 1D system where z is periodic and x and y are 
    !! truncated, this%dims_map = (/3/).
    subroutine get_dims_map()
      integer :: jdim

      PUSH_SUB(interp_init.get_dims_map)

      if (this%dims==3) then
        this%dims_map(:) = (/1, 2, 3/)
      else if (this%dims==2) then
        if (.not.active_dims(3)) then
          this%dims_map = (/1, 2/)
        else if (.not.active_dims(2)) then
          this%dims_map = (/1, 3/)
        else
          this%dims_map = (/2, 3/)
        endif
      else
        do jdim = 1,3
          if (active_dims(jdim)) this%dims_map(1) = jdim
        enddo
      endif
#ifdef VERBOSE
      if (peinf%inode==0) then
        write(6,'(2x,a,3(1x,i1))') 'dims_map =', this%dims_map
        write(6,*)
      endif
#endif

      POP_SUB(interp_init.get_dims_map)
    end subroutine get_dims_map

    ! Initialize the metric for the 3D and 2D case.
    ! Note: we also slightly distort the metric so that the Delaunay
    ! triangulation is always the same for degenerate grids.
    !---------------------------------------------------------------------
    ! 3D: Effective vectors = crystal vectors
    !---------------------------------------------------------------------
    subroutine init_metric_3D()
      real(DP) :: delta

      PUSH_SUB(interp_init.init_metric_3D)

      this%bvec_(:,:) = crys%blat * crys%bvec(:,:)
      ! FHJ: Make a small perturbation to the off-diagonal terms of the
      ! transformation to make the Delaunay triangulation unique.
      delta = maxval(this%bvec_)*1d-10
      this%bvec_(1,2) = this%bvec_(1,2) + delta
      this%bvec_(1,3) = this%bvec_(1,3) + delta*sqrt(2d0)
      this%bvec_(2,3) = this%bvec_(2,3) + delta*sqrt(3d0)

      POP_SUB(interp_init.init_metric_3D)
    end subroutine init_metric_3D
    !---------------------------------------------------------------------
    ! 2D: Eff. vectors from Cholesky decomposition of leading 2x2 metric
    !---------------------------------------------------------------------
    subroutine init_metric_2D()
      real(DP) :: LT(2, 2)

      PUSH_SUB(interp_init.init_metric_2D)

      ! FHJ: Cholesky decomposition of the metric bdot = L * L^T
      LT(:,:) = crys%bdot(this%dims_map(1:2), this%dims_map(1:2))
      LT(1,1) = dsqrt(LT(1,1))
      LT(2,1) = 0d0
      LT(1,2) = LT(1,2)/LT(1,1)
      LT(2,2) = dsqrt(LT(2,2) - LT(1,2)**2)
      ! FHJ: Effective 2D transformation: V_eff = L^T
      this%bvec_(:,:) = LT(:,:)
      ! FHJ: Make a small perturbation to the off-diagonal term of the
      ! transformation to make the Delaunay triangulation unique.
      this%bvec_(1,2) = this%bvec_(1,2) + maxval(this%bvec_)*1d-10

      POP_SUB(interp_init.init_metric_2D)
    end subroutine init_metric_2D

  end subroutine interp_init


  !=========================================================================
  !=========================================================================


  !> Given a fine point `qq`, return the coarse points `ind_co` that enclose
  !! it and the coefficients `coefs_co` of the point in barycentric coordinates.
  subroutine interp_eval(this, qq, ind_co, coefs_co)
    type(interp_t), intent(in) :: this
    !> The fine point to be interpolated, in "regular" crystal coordinates.
    real(DP), intent(in) :: qq(:)
    !> Indices of the coarse point that form the simplex around `qq_fi`.
    integer, intent(out) :: ind_co(:)
    !> Coefficients of `qq_fi` in barycentric coordinates.
    real(DP), intent(out) :: coefs_co(:)

    real(DP) :: qq_crys(3), qq_cart(3), coefs_orig(4)
    real(DP) :: qq_co(3), dists(4)
    integer :: ind_orig(4), ierr, ipt, isort(4)

    PUSH_SUB(interp_eval)

    ind_co(:) = 1
    coefs_co(:) = 0d0
    if (this%dims==0) then ! 0D or nearest neighbor here
      coefs_co(1) = 1d0
      POP_SUB(interp_eval)
      return
    endif

    qq_crys(:) = 0d0
    qq_crys(1:this%dims) = qq(this%dims_map(:))
    if (this%dims==1) then ! 1D here
      call interp_1D()
      POP_SUB(interp_eval)
      return
    endif

    ! FHJ: only 2D/3D from now on.
    qq_cart(:) = 0d0
    qq_cart(1:this%dims) = matmul(this%bvec_, qq_crys(1:this%dims))

    ! Find the simplex that encloses the fine point `qq_fi`.
    ! Notes: `coefs_co` is just the sorted version of `coefs_orig`, and 
    ! `ind_co` is `ind_orig` sorted + with points mapped back to 1st BZ.
    ierr = find_delaunay_simplex(qq_cart(1:this%dims), ind_orig, coefs_orig)
    if (ierr/=0) then
      write(0,*) 'ERROR: could not find simplex:'
      write(0,'(a,3(f10.6,1x))') 'q(orig)=', qq(:)
      write(0,'(a,3(f10.6,1x))') 'q(crys)=', qq_crys(:)
      write(0,'(a,3(f10.6,1x))') 'q(cart)=', qq_cart(:)
      call die('Could not find Delaunay simplex.', only_root_writes=.true.)
    endif

    ! Sort: closets point should the first element of ind_co/coefs_co
    qq_co(:) = 0d0
    dists(:) = 0d0
    do ipt = 1, this%dims + 1
      qq_co(1:this%dims) = this%pts_cart(1:this%dims, ind_orig(ipt))
      dists(ipt) = sum( (qq_co(:)-qq_cart(:))**2 )
    enddo
    call sortrx(this%dims+1, dists, isort)
    do ipt = 1, this%dims + 1
      ! FHJ: This is how we map the ghost points to the original set
      ind_co(ipt) = mod(ind_orig(isort(ipt))-1, this%npts_orig) + 1
      coefs_co(ipt) = coefs_orig(isort(ipt))
    enddo

#ifdef VERBOSE
    if (peinf%inode==0) then
      write(6,'(1x,a,3(f10.6,1x))') 'q(orig)=', qq(:)
      write(6,'(1x,a,3(f10.6,1x))') 'q(crys)=', qq_crys(:)
      write(6,'(1x,a,3(f10.6,1x))') 'q(cart)=', qq_cart(:)
      write(6,'(1x,a,4(f7.3, 1x))') 'coefs=', coefs_co(:)
    endif
#endif

    POP_SUB(interp_eval)

  contains

    !> FHJ: For the 1D interpolation, just find the two neighboring points
    !! using a binary search algorithm, so we can claim we scale as O(log(N)).
    subroutine interp_1D()
      real(DP) :: dr
      integer :: imin, imid, imax
#ifdef DEBUG
      integer :: extrap_dir
#endif

      PUSH_SUB(interp_eval.interp_1D)

      imin = 1
      imax = this%npts
#ifdef DEBUG
      extrap_dir = 0
#endif

      if (this%pts_crys_ord(imax) < qq_crys(1) + TOL_SMALL) then
        ! FHJ: qq_crys is past the last point
        ind_co(1) = this%pts_crys_ind(this%npts)
        ind_co(2) = this%pts_crys_ind(this%npts-1)
        imax = this%npts
        imin = this%npts-1
        dr = this%pts_crys_ord(imax) - qq_crys(1)
#ifdef DEBUG
        extrap_dir = 1
#endif
      else if (this%pts_crys_ord(imin) > qq_crys(1) - TOL_SMALL) then
        ! FHJ: qq_crys is before the first point
        ind_co(1) = this%pts_crys_ind(1)
        ind_co(2) = this%pts_crys_ind(2)
        imax = 2
        imin = 1
        dr = qq_crys(1) - this%pts_crys_ord(imin)
#ifdef DEBUG
        extrap_dir = -1
#endif
      else
        ! FHJ: general case: use a binary search algorithm to locate one point
        ! larger and one smaller than the interpolant.
        do while (imin<imax-1)
          imid = (imin+imax)/2
          if (this%pts_crys_ord(imid) < qq_crys(1)) then
            imin = imid
          else
            imax = imid
          endif
        enddo
        if ( dabs(this%pts_crys_ord(imin)-qq_crys(1)) < &
             dabs(this%pts_crys_ord(imax)-qq_crys(1))) then
          dr = qq_crys(1) - this%pts_crys_ord(imin)
          ind_co(1) = this%pts_crys_ind(imin)
          ind_co(2) = this%pts_crys_ind(imax)
        else
          dr = this%pts_crys_ord(imax) - qq_crys(1)
          ind_co(1) = this%pts_crys_ind(imax)
          ind_co(2) = this%pts_crys_ind(imin)
        endif
      endif

      ind_co(1) = mod(ind_co(1)-1, this%npts_orig) + 1
      ind_co(2) = mod(ind_co(2)-1, this%npts_orig) + 1
      coefs_co(2) = dr / (this%pts_crys_ord(imax) - this%pts_crys_ord(imin))
      coefs_co(1) = 1d0 - coefs_co(2)
#ifdef DEBUG
      ! FHJ: Warn if we had to extrapolate the point, but don`t warn if the
      ! fine point is an almost "exact match".
      if (extrap_dir==1) then
        if (dabs(coefs_co(2))>TOL_SMALL) then
          write(0,'(a,f10.6,a)') 'WARNING: point ',qq_crys(1),' was extrapolated to positive values.'
        endif
      else if (extrap_dir==-1) then
        if (dabs(coefs_co(2))>TOL_SMALL) then
          write(0,'(a,f10.6,a)') 'WARNING: point ',qq_crys(1),' was extrapolated to negative values.'
        endif
      endif
#endif

      POP_SUB(interp_eval.interp_1D)
    end subroutine interp_1D

  end subroutine interp_eval

  !=========================================================================
  !=========================================================================


  !> Deallocate buffers used by interpolator object.
  subroutine interp_free(this)
    type(interp_t), intent(inout) :: this

    PUSH_SUB(interp_free)

    if (this%dims>0) then
      SAFE_DEALLOCATE_P(this%pts_crys)
      SAFE_DEALLOCATE_P(this%dims_map)
      if (this%dims==1) then
        SAFE_DEALLOCATE_P(this%pts_crys_ind)
        SAFE_DEALLOCATE_P(this%pts_crys_ord)
      else
        SAFE_DEALLOCATE_P(this%pts_cart)
        SAFE_DEALLOCATE_P(this%bvec_)
        if (free_delaunay()/=0) then
          call die("Error deallocating Delaunay triangulation.", only_root_writes=.true.)
        endif
      endif
    endif

    POP_SUB(interp_free)

  end subroutine interp_free

end module interp_m

!============================================================================
!
! Routines:
!
! (1) check_screening_trunc   Originally by JRD     Last Modified: 2/09/2009 (JRD)
!
!     Die if screening, truncation, and q0vec are not set consistently.
!
!============================================================================

#include "f_defs.h"

module check_screening_m

  use global_m
  implicit none

  private

  public :: check_screening_trunc

contains

subroutine check_screening_trunc(itruncflag,iscreen,q0vec,bdot)
  integer, intent(in) :: itruncflag
  integer, intent(in) :: iscreen
  real(DP), intent(in) :: q0vec(3)
  real(DP), intent(in) :: bdot(3,3)
  
  real(DP) :: q0len

  PUSH_SUB(check_screening_trunc)

  q0len = sqrt(DOT_PRODUCT(q0vec,MATMUL(bdot,q0vec)))

  if (iscreen .eq. 2 .and. q0len .lt. TOL_Small) then
    if(peinf%inode == 0) then
      write(0,*) ' '
      write(0,*) 'You want metallic screening but didn''t specify q0vec!!'
    endif
    call die('Inconsistent Screening', only_root_writes = .true.)
  endif
  
  if (iscreen .eq. 1 .and. q0len .lt. TOL_Small .and. itruncflag .eq. 0) then
    if(peinf%inode == 0) then
      write(0,*) ' '
      write(0,*) 'You want graphene screening with no truncation'
      write(0,*) 'but didn''t specify q0vec!!'
    endif
    call die('Inconsistent Screening', only_root_writes = .true.)
  endif
  
  if ((itruncflag .eq. 0 .or. itruncflag .eq. 4 .or. &
    itruncflag .eq. 6) .and. q0len .lt. TOL_Small) then
    if(peinf%inode == 0) then
      write(0,*) ' '
      write(0,*) 'You have a divergent Coulomb interaction but didn''t specify q0vec!!'
    endif
    call die('Inconsistent Screening', only_root_writes = .true.)
  endif
  
  if ((itruncflag .ne. 0 .and. itruncflag .ne. 4 .and. &
    itruncflag .ne. 6) .and. iscreen .ne. 2 .and. q0len .ge. TOL_Small) then
    if(peinf%inode == 0) then
      write(0,*) ''
      write(0,*) 'You want semiconductor or graphene screening with truncation'
      write(0,*) 'but specified nonzero q0vec!!'
    endif
    call die('Inconsistent Screening', only_root_writes = .true.)
  endif
  
  POP_SUB(check_screening_trunc)
  
  return
end subroutine check_screening_trunc

end module check_screening_m

!===========================================================================
!
! Module mtxelmultiply_m
!
! (1) mtxelMultiply()   Refactored from main.f90 By (PWD)     
!                                           Last Modified 10/21/2010 (PWD)
!
!     Combine the <c,k|e^(-i(q+G).r)|v,k+q><v,k+q|e^(i(q+G`).r)|c,k>
!                 -------------------------------------------------
!                                  energy denominator
!     Input:
!       pol%eden(band,spin) = 1/(e_val-e_cond) = energy denominators
!       pol%gme(band,g-vector,spin) = plane wave matrix elements
!       pol%isrtx   orders the |G(i)|^2   i=1,pol%nmtx
!       vwfn%isort  orders |qk+g|^2    (in vwfn type)
!
!       energies are apparently assumed in Rydbergs.
!
!===========================================================================

#include "f_defs.h"

module mtxelmultiply_m

  use global_m
  use blas_m
  use scalapack_m

  implicit none

  private

  public :: &
    mtxelMultiply

contains

  subroutine mtxelmultiply(scal,ntot,nrk,nst,fact,vwfn,gmetempr,gmetempc,chilocal, &
    polgme,pol,indt,pht,ipe,ispin)
    type (scalapack), intent(in) :: scal
    integer, intent(in) :: ntot
    integer, intent(in) :: nrk
    integer, intent(in) :: nst(:) !< (nrk)
    real(DP), intent(in) :: fact
    type (valence_wfns), intent(in) :: vwfn
    SCALAR, dimension(:,:), intent(inout) :: gmetempr(:,:),gmetempc(:,:)
    SCALAR, dimension(:,:), intent(inout) :: chilocal(:,:)
    SCALAR, intent(in) :: polgme(:,:,:,:,:,:)
    type (polarizability), intent(inout) :: pol
    integer, dimension(:,:,:), intent(in) :: indt
    SCALAR, dimension(:,:,:), intent(in) :: pht
    integer, intent(in) :: ipe
    integer, intent(in) :: ispin

    SCALAR :: negfact
    integer, allocatable :: tmprowindex(:),tmpcolindex(:)
    SCALAR, allocatable :: tmprowph(:),tmpcolph(:)
    integer :: irk, iv, ilimit, j, it, icurr, itot, mytot
    
    PUSH_SUB(mtxelMultiply)
    
    itot=0
    negfact = -1D0*fact
    
    if (peinf%inode.eq.0) call timacc(31,1)

    SAFE_ALLOCATE(tmprowindex,(scal%nprd(ipe)))
    SAFE_ALLOCATE(tmpcolindex,(scal%npcd(ipe)))
    SAFE_ALLOCATE(tmprowph,(scal%nprd(ipe)))
    SAFE_ALLOCATE(tmpcolph,(scal%npcd(ipe)))

    do irk = 1, nrk
      do it = 1, nst(irk) 

        do icurr=1,scal%nprd(ipe)
          tmprowindex(icurr) = indt(scal%imyrowd(icurr,ipe),it,irk)
          tmprowph(icurr) = pht(scal%imyrowd(icurr,ipe),it,irk)
        enddo
        do icurr=1,scal%npcd(ipe)
          tmpcolindex(icurr) = indt(scal%imycold(icurr,ipe),it,irk)
          tmpcolph(icurr) = pht(scal%imycold(icurr,ipe),it,irk)
        enddo
        
        do iv = 1,vwfn%nband+pol%ncrit
          if (peinf%doiownv(iv)) then
            ilimit = peinf%ncownactual
          else
            ilimit = 0
          endif
          
!$OMP PARALLEL private (mytot)
!$OMP DO
          do j = 1, ilimit 
            
            mytot = itot + j
            
            do icurr=1,scal%nprd(ipe)
              gmetempr(icurr,mytot)=polgme( &
                tmprowindex(icurr),j,peinf%indexv(iv), &
                ispin,irk,pol%os_para_freqs)* &
                tmprowph(icurr)
            enddo
            
            do icurr=1,scal%npcd(ipe)
              gmetempc(mytot,icurr)= &
                MYCONJG(polgme(tmpcolindex(icurr),j,peinf%indexv(iv),ispin,irk,pol%os_para_freqs)*tmpcolph(icurr))
            enddo
            
          enddo ! j
!$OMP END DO
!$OMP END PARALLEL
          itot = itot+ilimit
        enddo ! iv
      enddo ! it
    enddo ! irk
    
    if (peinf%inode.eq.0) call timacc(31,2)
    
    if (peinf%inode.eq.0) call timacc(30,1)
    
    if (ntot.ne.0) then
      call X(gemm)('n','n',scal%nprd(ipe),scal%npcd(ipe),ntot, &
        negfact,gmetempr,scal%nprd(ipe),gmetempc,ntot,ZERO,chilocal,scal%nprd(ipe))
      !call X(gemm)('n','t',scal%nprd(ipe),scal%npcd(ipe),ntot, &
      !  -ONE,gmetempr,scal%nprd(ipe),gmetempc,scal%npcd(ipe),ZERO,chilocal,scal%nprd(ipe))
    end if

    if (peinf%inode.eq.0) call timacc(30,2)

    SAFE_DEALLOCATE(tmprowindex)
    SAFE_DEALLOCATE(tmpcolindex)    
    SAFE_DEALLOCATE(tmprowph)
    SAFE_DEALLOCATE(tmpcolph)    
    
    POP_SUB(mtxelMultiply)
    
    return
    
  end subroutine mtxelMultiply
  
end module mtxelmultiply_m

!==========================================================================
!
! Routines:
!
! (1) mtxel_vxc()                          Last Modified: 5/12/2008 (JRD)
!
!     Calculates matrix elements of the DFT exchange-correlation potential
!     sig%vxc and puts the results into alda:
!
!     alda(in,1) = <nk|Vxc(r)|nk>  with  n = sig%diag(in)
!
!==========================================================================

#include "f_defs.h"

subroutine mtxel_vxc(kp,gvec,sig,wfnk,wfnkoff,alda,vxc2_flag)

  use global_m
  use fftw_m
  use misc_m
  implicit none

  type (kpoints), intent(in) :: kp
  type (gspace), intent(in) :: gvec
  type (siginfo), intent(in) :: sig
  type (wfnkstates), intent(inout) :: wfnk, wfnkoff
  SCALAR, intent(out) :: alda(sig%ndiag+sig%noffdiag,sig%nspin)
  logical, intent(in) :: vxc2_flag
  
  integer :: in,ioff,ispin
  integer :: spinordim,jspinor,jspinormin,jspinormax
  integer :: ig,iso,jso,ik,ii,jj,ij,js,source,dest,tag
  character (len=100) :: tmpstr
  SCALAR, allocatable :: alda2(:,:)

  complex(DPC), allocatable :: &
    fftbox1(:,:,:,:),fftbox2(:,:,:,:),fftbox3(:,:,:,:)
  integer, dimension(:), allocatable :: gvecindex
  integer, dimension(3) :: Nfft
  integer :: ix, iy, iz
  real(DP) :: scale
  SCALAR, allocatable :: vxctemp(:,:)
  SCALAR :: temp, tempxy


!-------------------- Begin Routine --------------------------------------------


  PUSH_SUB(mtxel_vxc)

! Nullify output

  alda=0.0d0

! Using FFT to compute matrix elements

! Allocate temporary wavefunction array

  call set_jspinor(jspinormin,jspinormax,sig%spin_index(sig%nspin),kp%nspinor)  
  spinordim=jspinormax-jspinormin+1

  if (sig%noffdiag.gt.0) then
    if (mod(peinf%inode,peinf%npes/peinf%npools).eq.0)  then 
      SAFE_ALLOCATE(wfnkoff%zk, (2*wfnk%nkpt,spinordim))
    endif
  endif

! Get FFT box sizes and scale factor

  call setup_FFT_sizes(gvec%FFTgrid,Nfft,scale)

! Get FFT box sizes and scale factor
! Allocate FFT boxes

  SAFE_ALLOCATE(fftbox1, (Nfft(1),Nfft(2),Nfft(3),spinordim**2))
  SAFE_ALLOCATE(fftbox2, (Nfft(1),Nfft(2),Nfft(3),spinordim))
  SAFE_ALLOCATE(fftbox3, (Nfft(1),Nfft(2),Nfft(3),spinordim))
  SAFE_ALLOCATE(vxctemp, (gvec%ng,sig%nspin*spinordim**2))

! Put the vxc data into fftbox 1 and FFT it to real space

  SAFE_ALLOCATE(gvecindex, (gvec%ng))
  do ig=1,gvec%ng
    gvecindex(ig)=ig
  enddo

  do ispin=1,sig%nspin
    
    if (spinordim.eq.2) then
      ! BAB: components 1 and 2 are upper and lower diagonal of VXC 2x2 matrix
      !      component 3 is the upper off-diagonal, lower off-diag is complex conjugate
      vxctemp(:,1) = sig%vxc(:,1) +   sig%vxc(:,4)
      vxctemp(:,2) = sig%vxc(:,1) -   sig%vxc(:,4)
      vxctemp(:,3) = sig%vxc(:,2) - CMPLX(0.0d0,1.0d0)*sig%vxc(:,3)
      vxctemp(:,4) = sig%vxc(:,2) + CMPLX(0.0d0,1.0d0)*sig%vxc(:,3)
    else
      if (.not. vxc2_flag) then
        vxctemp(:,ispin) = sig%vxc(:,sig%spin_index(ispin))
      else
        vxctemp(:,ispin) = sig%vxc2(:,sig%spin_index(ispin))
      endif
    endif

    do jspinor=1,spinordim**2
      call put_into_fftbox(gvec%ng,vxctemp(:,ispin*jspinor),gvec%components,gvecindex,fftbox1(:,:,:,jspinor),Nfft)
      call do_FFT(fftbox1(:,:,:,jspinor),Nfft,1)
    enddo

! Loop over the bands for which we need the matrix elements
! For each one, put the band into fftbox2, FFT to real space,
! and then integrate in real space vxc(r)*|psi(r)|^2
! Store result into alda(in,ispin).

    do in=1,peinf%ndiag_max
      temp=ZERO
      tempxy=ZERO
      write(tmpstr,'("Computing <n|Vxc|n> for n=",i4)') &
        sig%diag(peinf%index_diag(in))
      call logit(tmpstr)

        if (mod(peinf%inode,peinf%npes/peinf%npools).eq.0) then

          do jspinor=1,spinordim
            ij = ispin*jspinor ! for shortening lengthy call to put_into_fftbox
            call put_into_fftbox(wfnk%nkpt,wfnk%zk((in-1)*wfnk%nkpt+1:,ij),gvec%components,wfnk%isrtk,fftbox2(:,:,:,jspinor),Nfft)
            call do_FFT(fftbox2(:,:,:,jspinor),Nfft,1)
          enddo

          do jspinor=1,spinordim
            do iz=1,Nfft(3)
              do iy=1,Nfft(2)
                do ix=1,Nfft(1)
                  temp = temp + fftbox1(ix,iy,iz,jspinor) * abs(fftbox2(ix,iy,iz,jspinor))**2
                  if (jspinor.eq.2) then
                    tempxy = tempxy + fftbox1(ix,iy,iz,2*spinordim-1) * &
                      dble(conjg(fftbox2(ix,iy,iz,jspinor-1))) * dble(fftbox2(ix,iy,iz,jspinor))
                  endif
                enddo
              enddo
            enddo
          enddo ! jspinor
        endif

      if (peinf%flag_diag(in)) then
        alda(peinf%index_diag(in),ispin)=(temp + 2.0d0*dble(tempxy))*scale
      endif

    enddo ! in
    
    do ioff=1,peinf%noffdiag_max

      if (spinordim .eq. 2) then
        call die('Off diagonal bands not correctly implemented yet for spinors')
      endif

      write(tmpstr,'("Computing offdiag <n|Vxc|m> for n,m=",2i4)') &
        sig%off1(peinf%index_offdiag(ioff)), &
        sig%off2(peinf%index_offdiag(ioff))
      call logit(tmpstr)

      temp=ZERO
      tempxy=ZERO
      do jspinor=1,spinordim

! (gsm) begin gathering wavefunctions over pools

! $$$ inefficient communication, this should be rewritten $$$

        do jj=1,peinf%npools
          dest=(jj-1)*(peinf%npes/peinf%npools)
          do ii=1,2
            iso=sig%offmap(peinf%index_offdiag(ioff),ii)
#ifdef MPI
            call MPI_Bcast(iso,1,MPI_INTEGER,dest,MPI_COMM_WORLD,mpierr)
#endif
            jso=(iso-1)/peinf%npools+1
            source=mod(iso-1,peinf%npools)*(peinf%npes/peinf%npools)
            if (peinf%inode.eq.source.and.peinf%inode.eq.dest) then
              do ik=1,wfnk%nkpt
                wfnkoff%zk((ii-1)*wfnk%nkpt+ik,jspinor)= &
                  wfnk%zk((jso-1)*wfnk%nkpt+ik,ispin*jspinor)
              enddo
            else
#ifdef MPI
              tag=1024
              if (peinf%inode.eq.source) call MPI_Send &
                (wfnk%zk((jso-1)*wfnk%nkpt+1,ispin*jspinor),wfnk%nkpt, &
                MPI_SCALAR,dest,tag,MPI_COMM_WORLD,mpierr)
                if (peinf%inode.eq.dest) call MPI_Recv &
                  (wfnkoff%zk((ii-1)*wfnk%nkpt+1,jspinor),wfnk%nkpt, &
                    MPI_SCALAR,source,tag,MPI_COMM_WORLD,mpistatus,mpierr)
#else
              do ik=1,wfnk%nkpt
                wfnkoff%zk((ii-1)*wfnk%nkpt+ik,jspinor)= &
                  wfnk%zk((jso-1)*wfnk%nkpt+ik,ispin*jspinor)
              enddo
#endif
            endif
          enddo
        enddo
      enddo ! jspinor

! (gsm) end gathering wavefunctions over pools

      if (mod(peinf%inode,peinf%npes/peinf%npools).eq.0) then

        do jspinor=1,spinordim
          js = jspinor ! for shortening lengthy call to put_into_fftbox
          call put_into_fftbox(wfnk%nkpt,wfnkoff%zk(1:,jspinor),gvec%components,wfnk%isrtk,fftbox2(:,:,:,jspinor),Nfft)
          call do_FFT(fftbox2(:,:,:,jspinor),Nfft,1)
          call conjg_fftbox(fftbox2(:,:,:,jspinor),Nfft)
          call put_into_fftbox(wfnk%nkpt,wfnkoff%zk(wfnk%nkpt+1:,js),gvec%components,wfnk%isrtk,fftbox3(:,:,:,js),Nfft)
          call do_FFT(fftbox3(:,:,:,jspinor),Nfft,1)
        enddo

        do jspinor=1,spinordim
          do iz=1,Nfft(3)
            do iy=1,Nfft(2)
              do ix=1,Nfft(1)
                temp = temp + fftbox1(ix,iy,iz,jspinor)*fftbox2(ix,iy,iz,jspinor)*fftbox3(ix,iy,iz,jspinor)
                if(jspinor.eq.2) then
                  tempxy = tempxy + fftbox1(ix,iy,iz,4)*dble(fftbox2(ix,iy,iz,2))*dble(fftbox3(ix,iy,iz,1))
                  tempxy = tempxy + fftbox1(ix,iy,iz,3)*dble(fftbox2(ix,iy,iz,1))*dble(fftbox3(ix,iy,iz,2))
                endif
              enddo
            enddo
          enddo
        enddo

      endif
      if (peinf%flag_offdiag(ioff)) then
        alda(peinf%index_offdiag(ioff)+sig%ndiag,ispin)=(temp + tempxy)*scale*ryd
      endif
    enddo ! ioff
  
  enddo ! ispin

! Deallocate temporary wavefunction array

  if (sig%noffdiag.gt.0) then
    if (mod(peinf%inode,peinf%npes/peinf%npools).eq.0) then
      SAFE_DEALLOCATE_P(wfnkoff%zk)
    end if
  endif

! Deallocate FFT boxes

  SAFE_DEALLOCATE(gvecindex)
  SAFE_DEALLOCATE(fftbox1)
  SAFE_DEALLOCATE(fftbox2)
  SAFE_DEALLOCATE(fftbox3)
  

! If MPI add up all the work done in parallel


#ifdef MPI
  SAFE_ALLOCATE(alda2, (sig%ndiag+sig%noffdiag,sig%nspin))
  alda2=0.0d0
  call MPI_Allreduce(alda(1,1),alda2(1,1),(sig%ndiag+sig%noffdiag)*sig%nspin, &
    MPI_SCALAR,MPI_SUM,MPI_COMM_WORLD,mpierr)
  alda(:,:)=alda2(:,:)
  SAFE_DEALLOCATE(alda2)
#endif

  POP_SUB(mtxel_vxc)

  return
end subroutine mtxel_vxc

!===============================================================================
!
! Routines:
!
! (1) mtxel_m()         Originally By MLT               Last Modified 6/5/2008 JRD
!
!     input: crys, wfnc, wfnvq, gvec, eqp, xct types
!            ik   label of k-point in FBZ
!
!     output: s0  matrix element of the momentum operator at point ik
!
!     Calculates the momentum operator between two sets of wavefunctions
!     < ic,k | P dot 2 (G+k+q) exp(-i q.r) | iv,k+q > / | P |
!     Division by ( E_c^LDA - E_v^LDA ) is done only if divide_energy = .true.
!     Each set has its own isort vector and the number of bands is nband
!     The momentum operator is divided by electron mass m = 0.5 (in Ry atomic units)
!     q is an optional small shift to k in reciprocal space
!     P is the polarization vector
!
! (2) mtxel_v()         Originally By MLT       Last Modified: 6/5/2008 (JRD)
!
!     input: wfnc, wfnvq, gvec types
!            qshift   length of the q-shift vector
!
!     output: s0   velocity matrix elements at a k-point
!
!     Calculates the velocity operator between two sets of wavefunctions
!     < ic,k | exp(-i q.r) | iv,k+q > / q
!     Note that this form is also correct for intraband transitions. --FHJ
!     Each set has its own isort vector and the number of bands is nband
!     q is a small but finite shift to k in reciprocal space
!
!===============================================================================

#include "f_defs.h"

module mtxel_optical_m

  use global_m
  implicit none

  private
  public :: mtxel_m, mtxel_v

contains

subroutine mtxel_m(crys,wfnc,wfnvq,gvec,eqp,xct,s0_dim1,s0_dim2,s0,ik,divide_energy)
  type (crystal), intent(in) :: crys
  type (wavefunction), intent(in) :: wfnc, wfnvq
  type (gspace), intent(in) :: gvec
  type (eqpinfo), intent(in) :: eqp
  type (xctinfo), intent(in) :: xct
  integer, intent(in) :: s0_dim1, s0_dim2
  SCALAR, intent(out) :: s0(:,:,:) !< (s0_dim1, s0_dim2, wfnc%nspin)
  integer, intent(in) :: ik
  logical, intent(in) :: divide_energy
  
  real(DP) :: kpg(3)
  integer :: ig, igq, ic, iv, isc
  integer, allocatable :: isorti(:)
  real(DP) :: fac
  SCALAR :: sum
  
!---------------------------------
! Initialize isorti array

  PUSH_SUB(mtxel_m)

  s0 = ZERO
  SAFE_ALLOCATE(isorti, (gvec%ng))
  isorti(:)=0
  do ig=1, gvec%ng
    isorti(wfnvq%isort(ig)) = ig
  enddo

!----------------------------------
! Check if the polarization vector is properly defined

  if (abs(xct%lpol).lt.TOL_Zero) then
    write(0,*) xct%lpol, xct%pol(:)
    call die("zero length polarization vector")
  endif

!----------------------------------
! Calculate s0(ic,iv) = < ic,k | P dot 2 (G+k+q) exp(-i q.r) | iv,k+q > / | P |
!                     / ( E_c^LDA - E_v^LDA )
! Here, q = 0 and (P dot 2 (G+k)) is replaced with (P dot 2 G)
! because < ic,k | P dot 2 k | iv, k > = P dot 2 k < ic,k | iv,k > = 0
! (only true for interband transitions. --DAS)

  do isc=1,wfnc%nspin
    do ic=1,s0_dim1
      do iv=1,s0_dim2
        sum=ZERO
        do ig=1, wfnc%ng
          igq=isorti(wfnc%isort(ig))
          kpg(:) = gvec%components(:,wfnc%isort(ig))
          fac=DOT_PRODUCT(xct%pol,MATMUL(crys%bdot,kpg))
          if (igq.gt.wfnvq%ng) exit
          sum = sum + MYCONJG(wfnc%cg(ig,ic,isc)) * wfnvq%cg(igq,iv,isc) * fac
        enddo
        s0(ic,iv,isc) = 2.d0 * sum / xct%lpol
        if(divide_energy) then
          s0(ic,iv,isc) = s0(ic,iv,isc) / (eqp%eclda(ic,ik,isc)-eqp%evlda(iv,ik,isc))
        endif
      enddo
    enddo
  enddo
  
  SAFE_DEALLOCATE(isorti)
  
  POP_SUB(mtxel_m)
  
  return
end subroutine mtxel_m

!===============================================================================

subroutine mtxel_v(wfnc,wfnvq,gvec,qshift,s0_dim1,s0_dim2,s0)

  use global_m
  implicit none

  type (wavefunction), intent(in) :: wfnc, wfnvq
  type (gspace), intent(in) :: gvec
  real(DP), intent(in) :: qshift
  integer, intent(in) :: s0_dim1, s0_dim2
  SCALAR, intent(out) :: s0(:,:,:) !< (s0_dim1, s0_dim2, wfnc%nspin)
  
  integer :: ig, igq, ic, iv, isc
  integer, allocatable :: isorti(:)
  SCALAR :: sum

!--------------------------------
! Initialize isorti array

  PUSH_SUB(mtxel_v)
  
  s0 = ZERO
  SAFE_ALLOCATE(isorti, (gvec%ng))
  isorti(:)=0
  do ig=1, gvec%ng
    isorti(wfnvq%isort(ig)) = ig
  enddo

!--------------------------------
! Calculate s0(ic,iv) = < ic,k | exp(-i q.r) | iv,k+q > / q

  do isc=1,wfnc%nspin
    do ic=1,s0_dim1
      do iv=1,s0_dim2
        sum=ZERO
        do ig=1, wfnc%ng
          igq=isorti(wfnc%isort(ig))
          if (igq.gt.wfnvq%ng) exit
          sum = sum + MYCONJG(wfnc%cg(ig,ic,isc)) * wfnvq%cg(igq,iv,isc)
        enddo
        s0(ic,iv,isc) = sum / qshift
      enddo ! iv
    enddo ! ic
  enddo ! isc
  
  SAFE_DEALLOCATE(isorti)
  
  POP_SUB(mtxel_v)
  
  return
end subroutine mtxel_v

end module mtxel_optical_m

#include "f_defs.h"

!*************************************************************************
Module GVectorsMod
!*************************************************************************
! Information related to the reciprocal lattice vectors (G-vectors).
!*************************************************************************
! The module contains the public functions:
!    GVectorsInit         reads in EnergyCutOff and allocates space for gVectors,
!                         gVecIndex, and kineticE. It initializes gVectors,
!                         and gVecIndex. Finally it calls StructureFactorInit.
!    GVectorsDestroy      deallocates space for gVectors, gVecIndex, and kineticE.
!*************************************************************************
! The module contains the public variables:
!    energyCutOff         plane-wave energy cutoff (a.u.) for wavefunctions
!    numGVectors          total number of G-vectors  
!    gVectors(i,j)        i-th component (reciprocal lattice coordinates)
!                         of the j-th G-vector
!    gVecIndex(i,j,k)     index for the G-vectors: 
!                         gVectors(gVecIndex(i,j,k),:) is the G-vector
!                         with reciprocal lattice coordinates (i,j,k)
!    kineticE(i)          kineticE(gVecIndex(i,j,k)) is the kinetic energy
!                         of the G-vector with reciprocal lattice
!                         coordinates (i,j,k)
!    structureFactor(i,j) complex structure factor for atom type j and
!                         G-vector i
!*************************************************************************
! The module contains the private functions:
!    StructureFactorInit  allocates space for structureFactor and then
!                         initializes structureFactor.
!*************************************************************************

  use SysParams, only : double
  use push_pop_m
  implicit none

  save

  type gVectorObjectsT
    integer                  :: numGVectors     
    integer, pointer         :: gVectors(:,:)   
    integer, pointer         :: gVecIndex(:,:,:) 
    real(double)             :: energyCutOff    
    integer, dimension(3)    :: maxGLen      
    real(double), pointer    :: kineticE(:)     
    complex(double), pointer :: structureFactor(:,:)
  end type gVectorObjectsT

  private StructureFactorInit
    
  contains

!*************************************************************************
  Subroutine GVectorsInit( gVectors, structure1, tagHandler, v_of_q )
!*************************************************************************

! GVectorInit reads in the "EnergyCutOff" and creates the G-vectors lying
! in a sphere of radius sqrt(two * maxEnergy) where maxEnergy is the
! cutoff for the potential which is 4 * EnergyCutOff for the wavefunctions.
! It creates the corresponding index gVecIndex, and 
! calls StructureFactorinit.

! Defined Tags:
!     EnergyCutOff

    use SysParams,       only : four, two, twopi, electronMass, &
                              & hBar2, hartree2eV
    use TagHandlerMod,   only : FindTag, tagHandlerT
    use StructureMod,    only : StructureT
    
    implicit none

    type( gVectorObjectsT ), pointer :: gVectors
    type( StructureT ), pointer :: structure1
    type( tagHandlerT ), pointer :: tagHandler
    logical :: v_of_q

    real(double)              :: kinetic, maxEnergy, maxGradius
    integer                   :: i, j, k, maxNumGVec, error
    integer,      allocatable :: gVectors_temp(:,:)
    integer,      dimension(3):: g_trial 
    real(double), allocatable :: kineticE_temp(:)

    PUSH_SUB(GVectorsInit)

    allocate( gVectors, stat = error )
    if( error /= 0 ) stop 'Error: gVectors allocation failed.'

    !**********************************************************************
    ! Read in EnergyCutOff
    call FindTag( tagHandler,'EnergyCutOff', error)

    if(error .eq. 0) then

      read(unit = tagHandler%fileno, fmt = *, iostat = error) gVectors%energyCutOff
      if(error /= 0) stop 'Error, couldn''t read EnergyCutOff.'
    else
      stop 'Error, could not find EnergyCutOff.'
    endif

    ! Energies read in Rydberg must be converted to Hartree
    gVectors%energyCutoff = gVectors%energyCutoff * 0.5d0

    ! Energies read in eV must be converted to Hartree
    call FindTag( tagHandler, 'InputEnergiesInEV', error)
    if(error .eq. 0) then
       print *, 'InputEnergiesInEV'
       gVectors%energyCutoff = gVectors%energyCutoff / hartree2eV
    else
       print *, 'EnergyCutOff in Rydberg ', gVectors%energyCutOff * 2.0d0
    endif

    ! energyCutOff has been initialized.
    !**********************************************************************

    !**********************************************************************
    ! Initialize gVectors, kineticE and gVecIndex.
    gVectors%numGVectors = 0
    gVectors%maxGLen     = 0
    
    ! The maximum energy for a G vector is four times the cut off energy.
    maxEnergy   = four * gVectors%energyCutOff 
    maxGradius =  sqrt(two * maxEnergy)

    ! The maximum length maxGLen(i) of a G vector along the ith reciprocal
    ! lattice vector bLatVec(i).  Think about it.
    gVectors%maxGLen(1:structure1%ndim) = int(maxGradius * structure1%lattice%aLatVecLen / twopi) + 1

    ! The number of G vectors in the parallelepiped constructed with
    ! int(2*maxGLen(i)) + 1 cells in each direction.
    maxNumGVec              = product(2 * gVectors%maxGLen(1:structure1%ndim) + 1)

    allocate(gVectors%gVecIndex(-gVectors%maxGLen(1):gVectors%maxGLen(1), &
           & -gVectors%maxGLen(2):gVectors%maxGLen(2), &
           & -gVectors%maxGLen(3):gVectors%maxGLen(3)),&
           & stat=error)
    if(error /= 0) stop 'Error allocating gVectors%gVecIndex in GVectorsInit.'

    gVectors%gVecIndex   = 0

    allocate(gVectors_temp(structure1%ndim, maxNumGVec), &
           & kineticE_temp(maxNumGVec), &
           & stat=error)
    if(error /= 0) stop 'Error allocating temporary space in GVectorInit.'

    ! Loop over all cells in the parallelepiped containing the sphere of 
    ! G vectors with energy less than maxEnergy.
    do i = -gVectors%maxGLen(1), gVectors%maxGLen(1)
      do j = -gVectors%maxGLen(2), gVectors%maxGLen(2)
        do k = -gVectors%maxGLen(3), gVectors%maxGLen(3)

          g_trial = (/ i, j, k /)
          kinetic = dot_product(g_trial(1:structure1%ndim), &
                   & matmul(structure1%lattice%bLatMetricTensor,g_trial(1:structure1%ndim)))/two 

          ! If the energy is less than maxEnergy store the G vector for
          ! later StructureMod.
          if(kinetic < maxEnergy) then

            gVectors%numGVectors = gVectors%numGVectors + 1
            gVectors_temp(:,gVectors%numGVectors) = g_trial(1:structure1%ndim)
            kineticE_temp(gVectors%numGVectors) = kinetic
            gVectors%gVecIndex(i,j,k) = gVectors%numGVectors  ! determine index array  

          end if
        end do
      end do
    end do

    ! allocate final gVectors array and copy over from temporary storage
    allocate(gVectors%gVectors(structure1%ndim, gVectors%numGVectors), &
           & gVectors%kineticE(gVectors%numGVectors), stat=error)
    if(error /= 0) stop 'Error allocating space for G vectors in GVectorsInit.'

    ! transfer vectors to permanent storage
    gVectors%gVectors(:,1:gVectors%numGVectors) = gVectors_temp(:,1:gVectors%numGVectors) 
    gVectors%kineticE(1:gVectors%numGVectors)   = kineticE_temp(1:gVectors%numGVectors)

    deallocate(gVectors_temp,kineticE_temp) ! deallocate associated work space
    ! gVectors, kineticE, and gVecIndex initialized.
    !**********************************************************************

    ! Initialize the structure factors.
    call StructureFactorInit( gVectors, structure1, v_of_q )

    POP_SUB(GVectorsInit)
  end Subroutine GVectorsInit

!*************************************************************************
  Subroutine GVectorsDestroy( gVectors )
!*************************************************************************

! Deallocates the space allocated for the GVectors.

    implicit none

    type( gVectorObjectsT ), pointer :: gVectors
    integer :: error

    PUSH_SUB(GVectorsDestroy)

    if( .not. associated( gVectors )) stop 'Error: gVectors not allocated.'

    deallocate(gVectors%gVectors, gVectors%kineticE, gVectors%structureFactor, stat = error)
    if(error /= 0) stop 'Error gVectors deallocating in GVectorsDestroy.'

    deallocate(gVectors%gVecIndex, stat = error)
    if(error /= 0) stop 'Error gVectors%gVecIndex deallocating in GVectorsDestroy.'

    deallocate(gVectors, stat = error)
    if(error /= 0) stop 'Error gVectors deallocating in GVectorsDestroy.'

    POP_SUB(GVectorsDestroy)
  end Subroutine GVectorsDestroy

!*************************************************************************
  Subroutine StructureFactorInit( gVectors, structure1, v_of_q )
!*************************************************************************

!   calculates the structure factors for each atom type at each G-vector

    use SysParams,        only : one, twopi, double
    use StructureMod, only : StructureT

    implicit none

    type( gVectorObjectsT ), pointer :: gVectors
    type( StructureT ), pointer :: structure1
    logical :: v_of_q

    real(double) :: arg
    integer      :: iGVec, iElem, iAtom, iAtomMin, error, atomI

    PUSH_SUB(StructureFactorInit)

    allocate (gVectors%structureFactor(gVectors%numGVectors, structure1%atomBasis%numSpecies),stat=error)
    if(error /= 0) stop 'structureFactor allocation error'

    atomI = 0
    gVectors%structureFactor = 0

    ! Structure Factor exist for each G vector and each element.  Each
    ! structure factor has a contribution from each atom of that element =
    ! exp(i* 2 * pi (G * R))
    do iElem = 1, structure1%atomBasis%numSpecies

      if (v_of_q) then
        iAtomMin = 1
      else
        iAtomMin = structure1%atomBasis%numAtomsOfSpecies(iElem)
      endif

      do iAtom = iAtomMin, structure1%atomBasis%numAtomsOfSpecies(iElem)

        atomI = atomI + 1

        do iGVec = 1, gVectors%numGVectors                             

          arg = twopi * dot_product(gVectors%gVectors(:,iGVec), structure1%atomBasis%atomLat(:,atomI))
          gVectors%structureFactor(iGVec,iElem) = gVectors%structureFactor(iGVec,iElem) + &
                                   cmplx(cos(arg),-sin(arg),kind=double)

        end do
      end do
    end do

    ! Normalize the structure factors.
    if (v_of_q) then
      gVectors%structureFactor = gVectors%structureFactor / structure1%atomBasis%totalNumAtoms
    endif

    POP_SUB(StructureFactorInit)
  end Subroutine StructureFactorInit

! These legacy routines are not currently used and are wrong for anisotropic systems.
!!*************************************************************************
!  Subroutine GVectorScatter( gVectors, structure1, eigenStates, densityArray, k, n )
!!*************************************************************************
!
!    use StructureMod,    only : StructureT
!    use EigenStatesMod,  only : eigenStatesT
!    use densityArrayMod, only : densityArrayT
!
!    implicit none
!
!    type( gVectorObjectsT ),      pointer :: gVectors
!    type( StructureT ),     pointer :: structure1
!    type( eigenStatesT ),   pointer :: eigenStates
!    type( densityArrayT ), pointer :: densityArray
!
!    integer, intent(in) :: k, n
!    integer             :: i, j, index
!
!    PUSH_SUB(GVectorScatter)
!
!    densityArray%waveFunction = 0
!
!    do i = 1, eigenStates%numBasisVectors(k)  
!
!      if(gVectors%gVectors(structure1%ndim, eigenStates%basisIndex(i,k)) .ge. 0) then
!        index = gVectors%gVectors(structure1%ndim, eigenStates%basisIndex(i,k))
!      else
!        index = gVectors%gVectors(structure1%ndim, eigenStates%basisIndex(i,k)) + &
!              & densityArray%gridDimensions(structure1%ndim)
!      end if
!
!      do j = structure1%ndim-1, 1, -1
!        if(gVectors%gVectors(j, eigenStates%basisIndex(i,k)) .ge. 0) then
!          index = index * densityArray%gridDimensions(j+1) + gVectors%gVectors(j, eigenStates%basisIndex(i,k))
!        else
!          index = index * densityArray%gridDimensions(j+1) + gVectors%gVectors(j, eigenStates%basisIndex(i,k)) &
!                & + densityArray%gridDimensions(j)
!        end if
!      end do  
!      index = index + 1
!      densityArray%waveFunction(index) = eigenStates%eigenVectors(i, n, k)
!
!    end do
!
!    POP_SUB(GVectorScatter)
!  end Subroutine GVectorScatter
!
!!*************************************************************************
!  Subroutine GVectorCollect( gVectors, structure1, densityArray)
!!*************************************************************************
!
!    use StructureMod,    only : StructureT
!    use densityArrayMod, only : densityArrayT
!
!    implicit none
!
!    type( gVectorObjectsT ),      pointer :: gVectors
!    type( StructureT ),     pointer :: structure1
!    type( densityArrayT ), pointer :: densityArray
!
!    integer             :: i, j, index
!
!    PUSH_SUB(GVectorCollect)
!
!    densityArray%rhog = 0
!
!    do i = 1, gVectors%numGVectors
!
!      if(gVectors%gVectors(structure1%ndim, i) .ge. 0) then
!        index = gVectors%gVectors(structure1%ndim, i)
!      else
!        index = gVectors%gVectors(structure1%ndim, i) + &
!              & densityArray%gridDimensions(structure1%ndim)
!      end if
!
!      do j = structure1%ndim-1, 1, -1
!        if(gVectors%gVectors(j, i) .ge. 0) then
!          index = index * densityArray%gridDimensions(j+1) + gVectors%gVectors(j, i)
!        else
!          index = index * densityArray%gridDimensions(j+1) + gVectors%gVectors(j, i) &
!                & + densityArray%gridDimensions(j)
!        end if
!      end do  
!      index = index + 1
!      densityArray%rhog(i) = densityArray%densityArray(index)
!
!    end do
!
!    POP_SUB(GVectorCollect)
!  end Subroutine GVectorCollect

end Module GVectorsMod

#include "f_defs.h"

module plotxct_common_m
  
  use global_m
  implicit none

  private

  !> plotxct "type"
  type plotxct_t
    logical :: int_dim(3)          !< should integrate this dimension? Needs only_psi2=.true.
    integer :: nsuper(3)           !< number of unit-cell repetitions
    integer :: pstate              !< index of excited state to be plotted
    integer :: pstateLow           !< for PlotXctDens index of first excited state to be plotted
    integer :: pstateHigh          !< for PlotXctDens index of last excited state to be plotted
    integer :: offset              !< offset for PlotXctDens
    integer :: ispin               !< which spin component to plot
    logical :: plot_hole           !< plot hole probability
    logical :: plot_electron       !< plot electron probability
    real(DP) :: rhole(3)           !< coordinate of hole, with respect to lattice vectors
    real(DP) :: e_S                !< excitation energy
    real(DP), pointer :: e_Ses(:) !< excitation energies for PlotXctDens
    integer :: iwann               !< index of Wannier function to project valence bands onto
    character(len=128) :: seedname !< name of Wannier file will be seedname.chk
    logical :: unfold, unfoldq     !< use symmetries to unfold fine/shifted grid?
    integer :: subsample(3)        !< subsample each dimention of the real-space grid by this factor. Defaults to 2.
    logical :: bz_paranoid         !< use paranoid version of fullbz?
    logical :: only_psi2           !< only save |psi|^2, not Re(psi) & Im(psi)
  end type plotxct_t
  
  public :: plotxct_t

end module plotxct_common_m

!==============================================================================
!
! Routines:
!
! (1) intkernel()       Originally By MLT        Last Modified: 6/16/2011 (FHJ)
!
!     input: crys, kg, kp, syms, xct, peinf types
!            hmtrx     effective Hamiltonian, with only the diagonal part
!            dcc, dvv  transformation matrices
!            kco       coordinates of k-points in the coarse grid
!            fi2co_wfn map of k-points fine grid -> coarse grid;
!                      defines which point in the coarse grid is close to
!                      one in the fine grid
!     output: hmtrx    effective Hamiltonian, with diagonal part and
!                      interaction part (direct + exchange)
!
!     Build the interaction Kernel using the interpolation scheme
!     (see Rohlfing & Louie). The kernel on the coarse grid is read
!     from unit, "bsedmat" and "bsexmat", and used immediately
!     (using temporary files may speed up the calculation...)
!
!     interaction kernel K =  K_d + 2*K_x   <---- spin singlet
!                        K =  K_d           <---- spin triplet
!                        K =  2*K_x         <---- local fields
!
!     imatrix code: 1 dhead, 2 dwing, 3 dbody, 4 x (BSE)
!     imatrix code: 1 dhead, 2 dbody, 3 x, 4 fxc (TDDFT)
!
! (2) interpolate()     Originally By MLT        Last Modified: 7/1/2008 (JRD)
!
!     input: xct type
!            bse_co    kernel in the coarse grid
!            dcckp     dcc transf. matrix at point k`
!            dvvkp     dvv transf. matrix at point k`
!     output: bse_fi   (interpolated) kernel in the fine grid
!
!==============================================================================

#include "f_defs.h"

module intkernel_m

#ifdef HDF5
  use hdf5
#endif
  use global_m
  use blas_m
  use checkgriduniformity_m
  use epsdiag_m
  use intpts_m
  use interp_m
  use misc_m
  use vcoul_generator_m
  use cells_m
  use io_utils_m
  use wfn_rho_vxc_io_m
  use kernel_io_m

  implicit none

  private
  
  public :: intkernel

contains

subroutine intkernel(crys,kg,kp,syms,xct,hmtrx,dcc,dvv,kco,fi2co_wfn,flag,gvec,intp_coefs,hmtrx_B)
  type (crystal), intent(in) :: crys
  type (grid), intent(in) :: kg
  type (kpoints), intent(in) :: kp
  type (symmetry), intent(in) :: syms
  type (xctinfo), intent(inout) :: xct
  SCALAR, intent(inout) :: hmtrx(:,:) !< (xct%nkpt_fi*xct%ncb_fi*xct%nvb_fi*xct%nspin,peinf%nblocks*peinf%nblockd)
  !> (xct%nvb_fi,xct%n1b_co,xct%nspin,xct%nkpt_fi,xct%npts_intp_kernel) Band expansion coefficients
  SCALAR, intent(in) :: dcc(:,:,:,:,:), dvv(:,:,:,:,:)
  real(DP), intent(in) :: kco(:,:) !< (3,xct%nkpt_co)
  !> (xct%npts_intp_kernel, xct%nkpt_fi) For a given k-point in the fine grid
  !! returns the closest k-point in the coarse WFN k-grid.
  integer, intent(in) :: fi2co_wfn(:,:)
  type(flags), intent(in) :: flag
  type (gspace), intent(in) :: gvec
  !> (xct%npts_intp_kernel, xct%nkpt_fi) Delaunay/greedy interpolation coefficients
  real(DP), intent(in) :: intp_coefs(:,:)
  SCALAR, intent(inout), optional :: hmtrx_B(:,:)

  type (twork_scell) :: work_scell
  real(DP) :: vcoul, oneoverq
  real(DP) :: vcoul0(1), closeweights(4), q0temp(3)
  SCALAR   :: epshead_temp
  type (epsinfo) :: epsi

! FHJ: these arrays depend only on the distance w.r.t qq=0 (inside the BZ)
  real(DP), allocatable :: dist_array(:) !length of dq for a given index
  real(DP), allocatable :: vcoul_array(:), oneoverq_array(:)

  !> FHJ: cells structure that keeps all fine (k-kp) transitions
  type(cells_t) :: cells_fi
  ! FHJ: these variables store the cached value of |q|^2, v(q), epsinv, for 
  ! each dq in the same order as it appears in the cell structure.
  real(DP) :: dq(3), dq_bz(3), abs_q2
  real(DP), allocatable :: dqs(:,:), dqs_bz(:,:), abs_qs2(:), eps_intp(:)
  integer, allocatable :: vq_map(:)
  integer :: ik_cells, jkp_offset

  integer :: isrtrq(1), closepts(4)
  type(interp_t) :: eps_interp
  
  integer :: iscreentemp,iparallel,ijk,icb,ivb,imatrix, &
    ik,ic,iv,ikp,icp,ivp,ikt,ikcvs,ikcvsd,jj,jc,jv,js, &
    jcp,jvp,jsp,jk,jkp,dimbse,nmatrices,ifile, &
    i1,i2,i3,iold,icout,ivout,ncdim,nvdim,inew,tda_sz,ii
  !> (xct%nkpt_co) maps a k-point in the WFN_co to the bse*mat files.
  integer, allocatable :: wfn2bse(:)
  !> (xct%npts_intp_kernel, xct%nkpt_fi) For a given k-point in the fine grid,
  !! returns the closest k-point in the (coarse) bse*mat files.
  integer, allocatable :: fi2co_bse(:,:)
  integer :: ivertp, ivert
  integer, allocatable :: jkp2offset(:)

  real(DP) :: bsemat_fac,fac_d,fac_x,w_eff,eps,tol,factor,fac_t
  type(progress_info) :: prog_info
  type(kernel_header_t) :: kernel_header, kernel_header2, kernel_header3

#ifdef HDF5    
! JIM: variables used for HDF5 interface
  integer(HID_T) :: file_id       ! File identifier
  integer(HID_T) :: file_id_sub       ! File identifier
  integer(HID_T) :: kpoints_id    ! Property list identifier
  integer(HID_T) :: info_id       ! Property list identifier
  integer(HID_T) :: kspace        ! Property list identifier
  integer(HID_T) :: infospace     ! Property list identifier
  integer :: error, jt
  integer :: metadata(5)
  integer(HSIZE_T) :: metacount(1), kpointscount(2)
#endif


!------------------------------
! kernel and transformation matrices

  SCALAR, allocatable :: &
    bsedmatrix(:,:,:,:,:,:,:),bsedmt(:,:,:,:,:,:,:), &
    bsedmatrix_loc(:,:,:,:,:,:,:), &
    dcckp(:,:,:), dvvkp(:,:,:)

  if(abs(xct%scaling) < TOL_Zero) return ! everything will be zero

  PUSH_SUB(intkernel)

  if (.not.xct%tda.and..not.present(hmtrx_B)) &
    call die('Doing non-TDA but array hmtrx_B not present.', only_root_writes=.true.)

  if (xct%theory==0) then
!---------------------------------
! Read head of dielectric function from file (either 'epsdiag.dat' or
! 'eps0mat'/'epsmat')

    call logit('Calling epsdiag')

    call timacc(7,1)
    if(peinf%inode==0) then
      if(flag%read_epsdiag) then
        call read_epsdiag(epsi)
      else
        call epsdiag(crys,gvec,syms,epsi,xct)
      endif
    endif
    call timacc(7,2)
  
    call timacc(8,1)
#ifdef MPI
    call MPI_BCAST(epsi%nq,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
    call MPI_BCAST(epsi%q0vec,3,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,mpierr)
    call MPI_Bcast(epsi%epshead,1,MPI_SCALAR,0,MPI_COMM_WORLD,mpierr)
    call MPI_BCAST(epsi%emax,1,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
    if(peinf%inode.ne.0) then
      SAFE_ALLOCATE(epsi%eps, (epsi%nq))
    endif
    call MPI_BCAST(epsi%eps,epsi%nq,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
    if(peinf%inode.ne.0) then
      SAFE_ALLOCATE(epsi%q, (3,epsi%nq))
    endif
    call MPI_BCAST(epsi%q,3*epsi%nq,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
#endif
    call timacc(8,2)
  endif

  SAFE_ALLOCATE(wfn2bse, (xct%nkpt_co))
  SAFE_ALLOCATE(fi2co_bse, (xct%npts_intp_kernel, xct%nkpt_fi))

  tol=TOL_Small
  factor = -8.d0*PI_D/(crys%celvol*xct%nktotal)*xct%scaling
  if (flag%krnl.eq.0) then
    if(peinf%inode.eq.0) write(6,'(1x,a)') 'Spin Triplet Kernel'
    fac_d = factor
    fac_x = 0d0
    fac_t = factor
  elseif (flag%krnl.eq.1) then
    if(peinf%inode.eq.0) write(6,'(1x,a)') 'Spin Singlet Kernel'
    fac_d = factor
    fac_x = factor
    fac_t = factor
  elseif (flag%krnl.eq.2) then
    if(peinf%inode.eq.0) write(6,'(1x,a)') 'Local Fields'
    fac_d = 0d0
    fac_x = factor
    fac_t = 0d0
  else
    write(0,*) 'kernel type = ', flag%krnl
    call die("Illegal value of kernel type in intkernel.")
  endif
  
!-----------------------------------------------------------------------------!
!              EPSILON INTERPOLATION AND V(Q) PRE-CALCULATION
! FHJ: The interpolation of epsinv scales as O(nkpt) for regular grids.
! We pre-calculate all dqs = k(:,:) - k(:,1), move this quantity to the [0, 1) 
! range, and put them into a cell structure. For each dq, we interpolate epsinv.
! In a separate memory copy, we move all dqs to the 1st BZ (dqs_bz), and
! calculate v(dq_bz) and related quantities.
! When we reach the actual kernel interpolation, we calculate dq=k-kp, move it
! to the same [0, 1) range, and get the mapping to the dqs, which is done in
! O(1) using the cell structure.
! This algorithm should also works for coarse-grained grids (a fine grid with 
! holes), as long as the dqs are compute with all possible fine transitions.


! MJ: Only if we have an epsilon 
  if (xct%theory .eq. 0) then
! FHJ: Prepare the cells for the interpolation of epsilon
    if (xct%delaunay_interp) then
      call interp_init(eps_interp, crys, epsi%q, dims=xct%idimensions, &
        periodic=.false., active_dims=xct%is_periodic)
    else
      call alloc_intpts(epsi%nq, epsi%q(:,:), periodic=.false.)
    endif

    SAFE_ALLOCATE(eps_intp, (xct%nktotal))
  endif

! MJ : All of these are needed for V(Q) as well
  SAFE_ALLOCATE(dist_array, (xct%nktotal))
  SAFE_ALLOCATE(vcoul_array, (xct%nktotal))
  SAFE_ALLOCATE(oneoverq_array, (xct%nktotal))
  SAFE_ALLOCATE(dqs, (3, xct%nktotal))
  SAFE_ALLOCATE(dqs_bz, (3, xct%nktotal))
  SAFE_ALLOCATE(abs_qs2, (xct%nktotal))
  SAFE_ALLOCATE(vq_map, (xct%nktotal))

  ! FHJ: This block is equivalent to dqs(:,ik) = UNIT_RANGE(kg%f(:,ik)-kg%f(:,1))
  ! if nkpt_fi==nktotal, but only up to TOL_SMALL. In order for the testsuite not to
  ! fail, we explicitly break this into standard and patched_sampling cases.
  if (xct%patched_sampling) then
    ik=0
    do i1=0,kp%kgrid(1)-1
      do i2=0,kp%kgrid(2)-1
        do i3=0,kp%kgrid(3)-1
          ik=ik+1
          ! FHJ: This is already in the [0,1) range
          dqs(1,ik)=(dble(i1))/dble(kp%kgrid(1))
          dqs(2,ik)=(dble(i2))/dble(kp%kgrid(2))
          dqs(3,ik)=(dble(i3))/dble(kp%kgrid(3))
        enddo
      enddo
    enddo
  else
    do ik = 1, xct%nkpt_fi 
      dqs(:,ik) = UNIT_RANGE(kg%f(:,ik) - kg%f(:,1)) 
    enddo
  endif

  ! FHJ: TODO: parallelize this loop (trivial)
  call timacc(54,1)
  call cells_init(cells_fi, dqs, periodic=.true.)
  do ik = 1, xct%nktotal
    dq(:) = dqs(:, ik)
    
    ! FHJ: Move pt to 1st BZ and save it
    call point_to_bz(crys, dq, dq_bz, abs_q2)
    dqs_bz(:, ik) = dq_bz(:)
    abs_qs2(ik) = abs_q2
    if (xct%theory .eq. 0) then
      if (abs_q2 > epsi%emax) write(0,*) ' WARNING: emax too small, ', abs_q2, epsi%emax

      ! Interpolate epsinv - Just the head
      if (xct%icutv/=0 .and. xct%iscreen==0 .and. abs_q2<TOL_Zero) then
        ! SIB:  if q=0 and we are truncating the coulomb interaction, then
        !       the dielectric is 1 at q=0 for semiconductors.
#ifdef VERBOSE
        if (peinf%inode==0) write(6,'(a)') 'Coulomb truncation: epsinv(0,0) set to 1 for q=0'
#endif
        eps = 1.0d0
      else
        if (xct%delaunay_interp) then
          call interp_eval(eps_interp, dq_bz, closepts(:), closeweights(:))
        else
          call intpts_local(crys, dq_bz, epsi%nq, epsi%q(:,:), xct, closepts(:), &
            closeweights(:), periodic=.false.)
        endif
        eps=0D0
        do ijk = 1, xct%idimensions + 1
          eps = eps + closeweights(ijk)*epsi%eps(closepts(ijk)) 
        enddo
      endif
      eps_intp(ik) = eps
    endif ! theory=0
  enddo !ik
  if (xct%theory .eq. 0) then
    if (xct%delaunay_interp) then
      call interp_free(eps_interp)
    else
      call dealloc_intpts()
    endif
  endif ! theory=0
  call timacc(54,2)
! FHJ: Done with epsinv interpolation
!-----------------------------------

  if (xct%theory .eq. 0) then
    SAFE_DEALLOCATE_P(epsi%q)
    SAFE_DEALLOCATE_P(epsi%eps)
  endif

! FHJ: v(q) pre-calculation
!-------------------------------
! We should all contribute to calculating vcoul0 since it might involve minibz average

  call timacc(55,1)
  if (peinf%inode .eq. 0) then
    write(6,'(/,1x,a,i6,a)') 'Calculating v(q) with ',xct%nktotal ,' k-points'
  endif
  iscreentemp = 0
  iparallel = 1
  inew = 0

  if(peinf%inode == 0) call checkgriduniformity(kp%kgrid, crys, xct%icutv)

#ifdef VERBOSE
  if (peinf%inode .eq. 0) then
    write(6,'(a)')
    write(6,1000) 'Point','kpt','dq  = kg%f(:,ik)-kg%f(:,1)','   |dq|^2   ','index'
    write(6,1000) '-----','---','--------------------------','------------','-----'
1000  format(2x, a5,1x, a5,1x, a26,1x, a12,1x, a5)
1001  format(2x, a5,1x, i5,1x, 3(f8.5,1x), f12.9,1x, i5)
  endif
#endif

  do ik = 1, xct%nktotal
    dq(:) = dqs(:, ik)
    dq_bz(:) = dqs_bz(:, ik)
    abs_q2 = abs_qs2(ik)

    ! FHJ: Take a look if v(q) for this |q| has already been calculated
    ! We assume that v(q) = v(|q|), which is fine since we only include q`s
    ! in the periodic directions, so truncation doesn`t affect.
    iold=0
    do jj=inew,1,-1
      if (dabs(dist_array(jj)-abs_q2) < TOL_Small) then
        iold=jj
        exit
      endif
    enddo

    if (iold==0) then
      inew=inew+1
      dist_array(inew)=abs_q2
      vcoul0(1)=0.0d0
#ifdef VERBOSE
      if (peinf%inode .eq. 0) then
        write(6,1001) '~NEW~', ik, dq_bz, abs_q2, inew
      endif
#endif
      isrtrq(1) = 1
      if (xct%theory .eq. 0) then
        q0temp(:) = epsi%q0vec(:)
        epshead_temp = epsi%epshead
      else if (xct%theory .eq. 1) then
        q0temp(:) = xct%q0vec(:)
        epshead_temp = (1.0D0, 0.0d0)
        if ((xct%theory == 1) .and. ((1.0d0 - xct%coulomb_mod%long_range_frac_fock > TOL_SMALL) .or. &
           (1.0d0 - xct%coulomb_mod%short_range_frac_fock > TOL_SMALL))) then
            xct%coul_mod_flag=.true.
        endif
      endif

      if (.not. xct%coul_mod_flag) then
        call vcoul_generator(xct%icutv,xct%truncval,gvec, &
          crys%bdot,xct%nktotal,1,isrtrq(:),iscreentemp,dq_bz,q0temp, &
          vcoul0(:),xct%iwritecoul,iparallel,xct%avgcut,oneoverq, &
          kp%kgrid,epshead_temp,work_scell,xct%averagew,xct%wcoul0)
      else
        call vcoul_generator(xct%icutv,xct%truncval,gvec, &
          crys%bdot,xct%nktotal,1,isrtrq(:),iscreentemp,dq_bz,q0temp, &
          vcoul0(:),xct%iwritecoul,iparallel,xct%avgcut,oneoverq, &
          kp%kgrid,epshead_temp,work_scell,xct%averagew,xct%wcoul0, &
          coulomb_mod=xct%coulomb_mod)
      endif
     
      vcoul_array(inew) = vcoul0(1)/(8.0*Pi_D)
      oneoverq_array(inew) = oneoverq/(8.0*Pi_D)
      vq_map(ik) = inew
    else
#ifdef VERBOSE
      if (peinf%inode .eq. 0) then
        write(6,1001) ' old ', ik, dq_bz, abs_q2, iold
      endif
#endif
      vq_map(ik) = iold
    endif !iold == 0
  enddo !ik

! FHJ: Done with v(q) pre-calculation
!-----------------------------------

  call destroy_qran()

#ifdef VERBOSE
  if (peinf%inode .eq. 0) then
    write(6,'(a)')
    write(6,'(1x,a,i6,a)') 'Finished calculating Vcoul with ',inew,' unique points'
  endif
#endif

  if (xct%icutv .eq. 7) then
    SAFE_DEALLOCATE_P(work_scell%fftbox_1D)
  endif
  
  call timacc(55,2)
  call timacc(51,1)


    
!--------------------------------
! Allocate data

  if (peinf%inode .eq. 0) then
    if (.not. xct%skipinterp) then
      write(6,'(/,1x,a)') 'Performing Kernel Interpolation'
    else
      write(6,'(/,1x,a)') 'Building Interaction Kernel'
    endif
  endif

!  if(peinf%inode.eq.0) write(6,'(a)') 'Data allocation: intkernel'
  tda_sz = 1
  if (.not.xct%tda) tda_sz = 2
  if (xct%ipar .eq. 1) then
    SAFE_ALLOCATE(bsedmt, (xct%nvb_fi,xct%ncb_fi,xct%nvb_fi,xct%ncb_fi,xct%nspin,xct%nspin,tda_sz))
  else if (xct%ipar .eq. 2) then
    SAFE_ALLOCATE(bsedmt, (xct%nvb_fi,xct%ncb_fi,xct%nvb_fi,1,xct%nspin,xct%nspin,tda_sz))
  else
    SAFE_ALLOCATE(bsedmt, (xct%nvb_fi,xct%ncb_fi,1,1,xct%nspin,xct%nspin,tda_sz))
  endif
  SAFE_ALLOCATE(dcckp, (xct%n2b_co,xct%ncb_fi,xct%nspin))
  SAFE_ALLOCATE(dvvkp, (xct%n1b_co,xct%nvb_fi,xct%nspin))
 
  dimbse=xct%nkpt_co*(xct%n2b_co*xct%n1b_co*xct%nspin)**2
  wfn2bse=0

#ifdef MPI
  call MPI_BARRIER(MPI_COMM_WORLD,mpierr)
#endif

  call timacc(51,2)
  call timacc(52,1)

  if(.not. xct%use_hdf5) then
    if (peinf%inode==0) then
      call open_file(unit=11,file='bsedmat',form='unformatted',status='old')
      call open_file(unit=12,file='bsexmat',form='unformatted',status='old')
      if (xct%theory .eq. 1) call open_file(unit=13,file='bsetmat',form='unformatted',status='old')
    endif
    call read_binary_kernel_header(11, kernel_header)
    call require_version('bsedmat', kernel_header%mf%version, VER_BSE_FORT)
    call check_xctinfo_kernel_header('bsedmat', xct, kernel_header)
    call read_binary_kernel_header(12, kernel_header2)
    call require_version('bsexmat', kernel_header2%mf%version, VER_BSE_FORT)
    call check_xctinfo_kernel_header('bsexmat', xct, kernel_header2)

    if (.not.all(abs(kernel_header%kpt(:,:)-kernel_header2%kpt(:,:))<tol)) then
      call die('k-grids from bsedmat and bsexmat don`t match.', &
        only_root_writes=.true.)
    endif

    if (xct%theory .eq. 1) then
      call read_binary_kernel_header(13, kernel_header3)
      call require_version('bsetmat', kernel_header3%mf%version, VER_BSE_FORT)
      call check_xctinfo_kernel_header('bsetmat', xct, kernel_header3)
      if (.not.all(abs(kernel_header%kpt(:,:)-kernel_header3%kpt(:,:))<tol)) then
        call die('k-grids from bsedmat and bsexmat don`t match.', &
          only_root_writes=.true.)
      endif
    endif

#ifdef HDF5
  else
    if (peinf%inode==0) then
      call h5open_f(error)
      !call h5pcreate_f(H5P_FILE_ACCESS_F, plist_id, error)
      !call h5pset_fapl_mpio_f(plist_id, MPI_COMM_WORLD, MPI_INFO_NULL, error)
      call h5fopen_f('bsemat.h5', H5F_ACC_RDONLY_F, file_id, error)
      !call h5fopen_f('bsemat.h5', H5F_ACC_RDONLY_F, file_id, error, access_prp = plist_id)
      !call h5pclose_f(plist_id,error)

      call h5dopen_f(file_id, 'info', info_id, error)
      call h5dget_space_f(info_id,infospace,error)
      
      metacount(1) = 5
      call h5dread_f(info_id, H5T_NATIVE_INTEGER, metadata, metacount, error)
      
      jt = metadata(1)
      kernel_header%nk = metadata(2)
      kernel_header%n2b = metadata(3)
      kernel_header%n1b = metadata(4)
      kernel_header%ns = metadata(5)
      call h5sclose_f(infospace,error)
      call h5dclose_f(info_id,error)
      !call check_xctinfo_kernel_header('bsemat.h5', xct, kernel_header)
      
      kernel_header%nk = xct%nkpt_co
      SAFE_ALLOCATE(kernel_header%kpt, (3,xct%nkpt_co))
      call h5dopen_f(file_id, 'kpoints', kpoints_id, error)
      call h5dget_space_f(kpoints_id,kspace,error)
      kpointscount(1)=3
      kpointscount(2)=xct%nkpt_co
      call h5dread_f(kpoints_id, H5T_NATIVE_DOUBLE, kernel_header%kpt, kpointscount, error)
      call h5sclose_f(kspace,error)
      call h5dclose_f(kpoints_id,error)
    endif
    ! FHJ: Note: for HDF5, only inode==0 has the k-points
#endif
  endif

  if (peinf%inode==0) then
    i1 = 0
    ! Check consistency of files
    ! wfn2bse(ikp): index of coarse-grid point ikp in files bsedmat,bsexmat
    do jj=1,xct%nkpt_co
      ikp = 0
      do ik=xct%nkpt_co,1,-1
        ! FHJ: it`s all right if the two k-grids differ by a reciprocal lattice vector
        if (all(abs(MIN_RANGE(kernel_header%kpt(:,jj) - kco(:,ik))) < tol)) then
          ikp=ik
          exit
        endif
      enddo
      if (ikp==0) then
        write(0,'(a)') 'ERROR: found a k-point in the bsemat file that is not present in WFN_co.'
        write(0,'(a)') 'Are you using the exact same WFN_co from your kernel calculation?'
        write(0,'(a,i0)') 'jj = ', jj
        write(0,'(a,3(f10.6,1x))') 'k = ', kernel_header%kpt(:,jj)
        call die('found a k-point in the bsemat file that is not present in WFN_co', &
          only_root_writes=.true.)
      endif
      wfn2bse(ikp)=jj
      if (jj/=ikp) i1=i1+1
    enddo

    if (i1.ne.0) then
      write(6,'(1x,a)')
      write(6,'(1x,a)') 'The k-points in the kernel file has a different order than in the'
      write(6,'(1x,a)') 'WFN file. The mapping between the k-points was updated.'
      write(6,'(1x,a)')
#ifdef VERBOSE
      do jk=1,xct%nkpt_co
        write(6,'(2i4)') jk, wfn2bse(jk)
      enddo
#endif
    endif
  endif !peinf%inode = 0

#ifdef MPI
  call MPI_BCAST(wfn2bse, xct%nkpt_co, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
#endif
  do ik = 1, xct%nkpt_fi
    fi2co_bse(:,ik) = wfn2bse(fi2co_wfn(:,ik))
  enddo
  SAFE_DEALLOCATE(wfn2bse)

  call timacc(52,2)
  call logit('Done calculating Vcoul')




!------------- Read in coarse matrices: head, wings, body, exchange --------------------
! PE # 0 reads and broadcasts to everybody
#ifdef VERBOSE
  if (peinf%inode.eq.0) write(6,'(a)') ' Read in coarse matrices: head, wings, body, exchange '
#endif
  ! FHJ: this is to generate nice output / time estimate
  ! MJ: This is true irrespective of BSE/TDDFT
  if (flag%krnl==0) then ! triplet (only W)
    nmatrices = 3
  elseif (flag%krnl==2) then ! local fields (only V)
    nmatrices = 1
  else ! singlet (W + V)
    nmatrices = 4
  endif
  call progress_init(prog_info, 'interpolating BSE kernel', 'block', &
    maxval(peinf%ibt(:))*nmatrices)

  ! FHJ: For each PE, figure our which coarse k-points jkp it needs in order to
  ! interpolate the BSE matrix on the fine k-points it owns.
  SAFE_ALLOCATE(jkp2offset, (xct%nkpt_co))
  jkp2offset = -1 ! offset=-1 means we don`t need this coarse k-point
  jkp_offset = 0
  do jkp=1,xct%nkpt_co
    do ikt = 1, peinf%ibt(peinf%inode+1)
      ikp=peinf%ikb(peinf%inode+1,ikt)
      if (any(fi2co_bse(:,ikp)==jkp)) then
        jkp2offset(jkp) = jkp_offset
        jkp_offset = jkp_offset + xct%nkpt_co 
        exit
      endif
    enddo
  enddo

  SAFE_ALLOCATE(bsedmatrix_loc, (xct%n1b_co,xct%n2b_co,xct%n1b_co,xct%n2b_co,xct%nspin,xct%nspin,jkp_offset))
  nmatrices = 4
  do imatrix = 1, nmatrices     
    ! triplet kernel has no exchange term
    if(xct%theory == 0 .and. (imatrix == 4 .and. flag%krnl == 0)) cycle
    if(xct%theory == 1 .and. (imatrix == 3 .and. flag%krnl == 0)) cycle
    ! local-field kernel has no direct term
    if(xct%theory == 0 .and. ((imatrix >= 1 .and. imatrix <= 3) .and. flag%krnl == 2)) cycle
    if(xct%theory == 1 .and. ((imatrix == 1 .or. imatrix == 2 .or. imatrix == 4) .and. flag%krnl == 2)) cycle

    SAFE_ALLOCATE(bsedmatrix, (xct%n1b_co,xct%n2b_co,xct%n1b_co,xct%n2b_co,xct%nspin,xct%nspin,xct%nkpt_co))
    do jkp=1,xct%nkpt_co

      call timacc(53,1)

      bsedmatrix = 0.0
      if (peinf%inode.eq.0) then
        if(.not. xct%use_hdf5) then
          if (xct%theory==0) then
            if (imatrix .lt. 4) then
              ifile=11
            else if (imatrix .eq. 4) then
              ifile=12
            endif
          else if (xct%theory == 1) then
            if (imatrix .lt. 3) then
              ifile=11
            else if (imatrix .eq. 3) then
              ifile=12
            else if (imatrix .eq. 4) then
              ifile=13
            endif
          endif
        
! JRD: READ EVERYTHING FOR A GIVEN K

          do jj=1, xct%n2b_co * xct%n1b_co
            read(ifile) ikp,jcp,jvp,(((((bsedmatrix(jv,jc,jvp,jcp,js,jsp,jk), &
              jsp=1,xct%nspin),js=1,xct%nspin),jv=1,xct%n1b_co), &
              jc=1,xct%n2b_co),jk=1,xct%nkpt_co)
          enddo
#ifdef HDF5
        else
! XXX: Change to parallel
! JRD: HDF5 read in serial for now
          call bse_hdf5_read(xct,xct%nkpt_co,file_id,imatrix,jkp,bsedmatrix,subsample=.false.)
#endif
        endif
      endif
      
#ifdef MPI
      call MPI_BCAST(bsedmatrix(1,1,1,1,1,1,1), dimbse, MPI_SCALAR, 0, MPI_COMM_WORLD, mpierr)
#endif
      call timacc(53,2)

      if (jkp2offset(jkp)/=-1) then
        bsedmatrix_loc(:,:,:,:,:,:,jkp2offset(jkp)+1:jkp2offset(jkp)+xct%nkpt_co) = &
            bsedmatrix(:,:,:,:,:,:,1:xct%nkpt_co)
      endif
    enddo
    SAFE_DEALLOCATE(bsedmatrix)

!==============================================================================
! FHJ: Beginning of the big loop over k-points
!      For each fine k-points ik/ikp and expansion vertices ivert/iterp, find
!      the corresponding coarse-grid points jk/jkp and interpolate the kernel.
!==============================================================================
    do ikt = 1, peinf%ibt(peinf%inode+1)
      call progress_step(prog_info)
      ikp = peinf%ikb(peinf%inode+1,ikt)
#ifdef VERBOSE
      call logit('new ikp')
      if (peinf%inode==0) write(6,'(1x,a,i0)') 'ikp = ', ikp
#endif
      do ivertp = 1, xct%npts_intp_kernel
        jkp = fi2co_bse(ivertp, ikp)
        jkp_offset = jkp2offset(jkp)

          do js=1,xct%nspin
            dcckp(:,:,js) = transpose(dcc(:,:,js,ikp,ivertp))
            dvvkp(:,:,js) = transpose(dvv(:,:,js,ikp,ivertp))
          enddo

            ! FHJ: please don`t fix the indentation yet
            do ik = 1, xct%nkpt_fi
              do ivert = 1, xct%npts_intp_kernel
                jk = fi2co_bse(ivert, ik)
                bsedmt = ZERO
                
                if (ivert==1) then
                ! FHJ: No need to update this block for different jk`s
                dq(:) = kg%f(:,ik) - kg%f(:,ikp)
                ! FHJ: and now we can reuse all the information from the cell
                ! structure to get the mapping to the BZ, v(q) and the interpolated
                ! epsilon in O(1) operations.
                call timacc(56,1)
                call cells_find_exactly(cells_fi, dq, ik_cells)
                if (ik_cells==0) then
                  write(0,'(a)') 'Found a point that was not calculated before:'
                  write(0,'(3(f13.9,1x))') dq
                  write(0,'(a)') 'Are you using a non-uniform grid?'
                  call die('Found a point that was not calculated before.')
                endif
                abs_q2 = abs_qs2(ik_cells)
                if (xct%theory==0) then
                  eps = eps_intp(ik_cells)
                else
                  eps = 1.0d0
                endif
                iold = vq_map(ik_cells)

!------------------- Calculate Coulomb Interaction-------------------------------------
!
! SIB: Here we calculate the values of 1/q^2 and 1/q (no truncation case)
! for the fine q vector q=k-kp.  Things to note:
!
! (1) If q=0, then we want instead the averages of 1/q^2 and 1/q over
!     the "mini-BZ" (mini-BZ is the 1st BZ but scaled down by the
!     number of total q-points).
!
!JRD:
! (2) If we are using truncation, the wing is DEFINED as being
!     some smooth function multiplied by |q|*Vtrunc(G=0,q)*eps^-1(G=0,G`=0,q)
!     This is because the wings of the dielectric matrix are /propto |q| and pick up a factor
!     of eps^-1(G=0,G`=0,q) during the inversion process (see Epsilon/epsinv.f90).
!     We include this factor here and not above because eps^-1(G=0,G`=0,q) varies quicker in truncated case.
!     The Vtrunc(G=0,q) factor comes from the bare (truncated) coulomb interaction.

! We do it as if it were a semiconductor because we want q=0 here since the divergent
! parts were already removed in kernel

                ! The 1/(8*pi) is already included
                vcoul = vcoul_array(iold)
                oneoverq = oneoverq_array(iold)
                call timacc(56,2)
                
                if (xct%theory == 0) then
                  w_eff = vcoul * eps
                  if (abs_q2<TOL_Zero .and. xct%iscreen==0) then
                    w_eff = xct%wcoul0/(8.0*PI_D)
                  endif
                else if (xct%theory == 1) then
                  w_eff = vcoul
                  if (abs_q2<TOL_Zero .and. xct%iscreen==0) then
                    w_eff = vcoul
                  endif
                endif

!---------------- Start interpolation for the present pair (k,kp)----------------------------

!-----------------------------
! Head (spin diagonal)

                if (xct%ipar .eq. 1) then
                  ncdim=xct%ncb_fi
                  nvdim=xct%nvb_fi
                  icout=1
                  ivout=1
                else if (xct%ipar .eq. 2) then
                  ncdim=1
                  nvdim=xct%nvb_fi
                  icout=peinf%icb(peinf%inode+1,ikt)
                  ivout=1
                else if (xct%ipar .eq. 3) then
                  ncdim=1
                  nvdim=1
                  icout=peinf%icb(peinf%inode+1,ikt)
                  ivout=peinf%ivb(peinf%inode+1,ikt)
                endif
                endif !ivert==1

                call timacc(57,1)

                if (.not. xct%skipinterp ) then
                  call interpolate(xct, nvdim, ncdim, &
                    bsedmatrix_loc(:,:,:,:,:,:,jkp_offset+jk), bsedmt(:,:,:,:,:,:,1), &
                    dcc(:,:,:,ik,ivert), dcckp, dvv(:,:,:,ik,ivert), dvvkp, &
                    ivout, icout, imatrix, flag%krnl)
                else
! XXX Thread?
                  if (.not.xct%extended_kernel) then
                    do jsp=1,xct%nspin
                      do js=1,xct%nspin
                        do jcp=1,ncdim
                          do jvp=1,nvdim
                            do jc=1,xct%ncb_fi
                              do jv=1,xct%nvb_fi
                                bsedmt(jv,jc,jvp,jcp,js,jsp,1) = bsedmatrix_loc( &
                                  jv, jc, jvp+ivout-1, jcp+icout-1, &
                                  js, jsp, jkp_offset+jk)
                              enddo
                            enddo
                          enddo
                        enddo
                      enddo
                    enddo
                  else
! FHJ: A note on the indices:
! For restricted kernel, we distinguish valence and conduction states:
! valence -> (vbm, vbm-1, ..., vbm-nvb_co+1)
! conduction -> (cbm, cbm+1, ..., cbm+ncb_co-1)
! For extended kernel, we stack both band indices together in this funny ordering:
! band -> (vbm, ...,  vbm-nvb_co+1, cbm, ..., cbm+ncb_co-1)
! This only applies to bands from the coarse grid. Indices from fine grids
! (such as those in the bsedmt/hmtrx arrays) are either valence or conduction,
! but never mixed.
                    do jsp=1,xct%nspin
                      do js=1,xct%nspin
                        do jcp=1,ncdim
                          do jvp=1,nvdim
                            do jc=1,xct%ncb_fi
                              do jv=1,xct%nvb_fi
                                ! FHJ: (vc) -> (v`c`)
                                bsedmt(jv,jc,jvp,jcp,js,jsp,1) = bsedmatrix_loc( &
                                  jv, xct%nvb_co+jc, jvp+ivout-1, xct%nvb_co+jcp+icout-1, &
                                  js, jsp, jkp_offset+jk)
                              enddo
                            enddo
                          enddo
                        enddo
                      enddo
                    enddo
                  endif
                endif

                call timacc(57,2)

!------------------------------
! Add interaction kernel to the Hamiltonian

! JRD: bsemat_fac is the prefactor for the various head/wing/body/exchange and screening

! XXX: Some of this should be moved outside of the jk,jkp,ik,ikp loops right?

                if (imatrix .eq. 1) then
                  if (xct%iscreen .eq. 0) then
                    if (xct%theory==0) then
                      bsemat_fac = fac_d * w_eff
                    else
                      bsemat_fac = fac_d * w_eff !* xct%coulomb_mod%short_range_frac_fock 
                    endif
                  elseif (xct%iscreen .eq. 1) then
                    if (xct%icutv .eq. 0 .and. xct%theory .eq. 0) then
                      bsemat_fac = fac_d * oneoverq
                    else
                      bsemat_fac = fac_d * w_eff
                    endif
                  else
                    bsemat_fac = fac_d
                  endif
                else if (imatrix .eq. 2) then
                  if (xct%iscreen .eq. 0 .and. xct%icutv .eq. 0 .and. xct%theory .eq. 0) then
                    bsemat_fac = fac_d * oneoverq
                  elseif (xct%theory .eq. 0) then
                    bsemat_fac = fac_d
                  else
                    bsemat_fac = fac_d !* xct%coulomb_mod%short_range_frac_fock
                  endif
                else if (imatrix .eq. 3) then
                  if (xct%theory .eq. 0) then
                    bsemat_fac = fac_d
                  else
                    ! This matrix is exchange
                    bsemat_fac = -fac_x
                    if (xct%nspin .eq. 1) bsemat_fac = bsemat_fac * 2D0
                  endif
                else if (imatrix .eq. 4) then
                  if (xct%theory .eq. 0) then
                    bsemat_fac = -fac_x
                    if (xct%nspin .eq. 1) bsemat_fac = bsemat_fac * 2D0
                  else
                    ! change back
                    ! This is the fxc matrix
                    bsemat_fac = -fac_t !* ( 1.0d0 - xct%coulomb_mod%short_range_frac_fock)
                    if (xct%nspin .eq. 1) bsemat_fac = bsemat_fac * 2D0
                  endif
                endif
                bsemat_fac = bsemat_fac * intp_coefs(ivert, ik) * intp_coefs(ivertp, ikp)

                if(abs(bsemat_fac) < TOL_Zero) cycle
                call timacc(58,1)


! JRD: When comparing these loops with the loops in diag.f90 notice that:
! iv -> ivp
! ic -> icp
! ...
! 
! hmtrx array is accessed the same way since ikcvs here is based on ik,ic,iv and
! ikcvsd is based on ikp,icp,ivp. This is the opposite of diag.f90 which makes the 
! loops identical. Someone should fix the variable names to match at some point...

! XXX: Thread?
! XXX: WHY IS BSE_INDEX FASTER ON THE SPIN INDEX??

                do icp = 1, xct%ncb_fi
                  if (xct%ipar .eq. 1 .or. icp .eq. 1) then
                    do ivp = 1, xct%nvb_fi
                      if (xct%ipar .lt. 3 .or. ivp .eq. 1) then
                        do jsp = 1, xct%nspin
                          if (xct%ipar .eq. 1) then 
                            icb=icp
                            ivb=ivp
                            ikcvsd = bse_index(ikt, icb, ivb, jsp, xct)
                          else if (xct%ipar .eq. 2) then
                            !icb=peinf%icb(peinf%inode+1,ikt)
                            icb=1
                            ivb=ivp
                            ikcvsd = bse_index(ikt, icb, ivb, jsp, xct, ncband = 1)
                          else
                            !icb=peinf%icb(peinf%inode+1,ikt)
                            !ivb=peinf%ivb(peinf%inode+1,ikt)
                            icb=1
                            ivb=1
                            ikcvsd = bse_index(ikt, icb, ivb, jsp, xct, ncband = 1, nvband = 1)
                          endif

                          do ic = 1, xct%ncb_fi
                            do iv = 1, xct%nvb_fi
                              do js = 1,xct%nspin
                                ikcvs = bse_index(ik, ic, iv, js, xct)
                                hmtrx(ikcvs,ikcvsd) = hmtrx(ikcvs,ikcvsd) + &
                                  bsemat_fac * bsedmt(iv,ic,ivb,icb,js,jsp,1)
                              enddo              ! js
                            enddo              ! iv
                          enddo              ! ic
                        enddo              ! jsp
                      endif
                    enddo              ! ivp
                  endif
                enddo              ! icp
                call timacc(58,2)
              enddo ! ivert / jk
            enddo ! ik
      enddo ! ivertp / jkp
    enddo ! ikp
  enddo ! imatrix 
#ifdef MPI
    call MPI_BARRIER(MPI_COMM_WORLD,mpierr)
#endif



  call progress_free(prog_info)
!==============================================================================
! FHJ: End of the big loop over k-points
!==============================================================================

  if (peinf%inode.eq.0) then
    if(.not. xct%use_hdf5) then
      call close_file(11)
      call close_file(12)
#ifdef HDF5
    else
      call h5fclose_f(file_id, error)
      call h5close_f(error)
#endif
    endif
  endif

  call cells_free(cells_fi)

  SAFE_DEALLOCATE(bsedmatrix_loc)
  SAFE_DEALLOCATE(bsedmt)
  SAFE_DEALLOCATE(dcckp)
  SAFE_DEALLOCATE(dvvkp)
  SAFE_DEALLOCATE(dist_array)
  SAFE_DEALLOCATE(vcoul_array)
  SAFE_DEALLOCATE(oneoverq_array)
  SAFE_DEALLOCATE(dqs)
  SAFE_DEALLOCATE(dqs_bz)
  SAFE_DEALLOCATE(abs_qs2)
  if (xct%theory==0) then
    SAFE_DEALLOCATE(eps_intp)
  endif
  SAFE_DEALLOCATE(vq_map)
  SAFE_DEALLOCATE(fi2co_bse)
  SAFE_DEALLOCATE(jkp2offset)

  POP_SUB(intkernel)

  return
end subroutine intkernel

!=======================================================================================

subroutine interpolate(xct,nvdim,ncdim,bse_co,bse_fi,dcck,dcckp,dvvk,dvvkp,ivin,icin,imatrix,flag)
  type (xctinfo), intent(inout) :: xct
     ! xct should not be changed but ifort 12.0.0 -O3 compiles
     ! incorrectly if it is intent(in)
  integer, intent(in) :: nvdim,ncdim
  SCALAR, intent(in) :: bse_co(:,:,:,:,:,:) !< (xct%n1b_co,xct%n2b_co,xct%n1b_co,xct%n2b_co,xct%nspin,xct%nspin)
  SCALAR, intent(out) :: bse_fi(:,:,:,:,:,:) !< (xct%nvb_fi,xct%ncb_fi,nvdim,ncdim,xct%nspin,xct%nspin)
  SCALAR, intent(in) :: dcck(:,:,:)  !< (xct%ncb_fi,xct%n2b_co,xct%nspin)
  SCALAR, intent(in) :: dcckp(:,:,:) !< (xct%n2b_co,xct%ncb_fi,xct%nspin)
  SCALAR, intent(in) :: dvvk(:,:,:)  !< (xct%nvb_fi,xct%n1b_co,xct%nspin)
  SCALAR, intent(in) :: dvvkp(:,:,:) !< (xct%n1b_co,xct%nvb_fi,xct%nspin)
  integer, intent(in) :: ivin, icin, imatrix, flag

  integer :: js,jsp,iv,ivp,jc,jcp,icb,ivb,jv,jvp,ic,icp, &
    js_dvvk, js_dvvkp, js_dcck, js_dcckp, bse_co_js, bse_co_jsp
  
  SCALAR, allocatable :: mat_vcvc(:,:,:,:),mat_vfvc(:,:,:,:), &
    mat_vfvf(:,:,:,:),mat_cccc(:,:,:,:), &
    mat_cfcc(:,:,:,:),mat_cfcf(:,:,:,:), &
    dummy(:,:,:,:),dummyp(:,:,:,:), &
    dummy2(:,:,:,:),dummy3(:,:,:,:), dvvkn(:,:)
  
  PUSH_SUB(interpolate)
  
  bse_fi=0.0
  
  do js=1,xct%nspin
    do jsp=1,xct%nspin
      
      if (xct%theory .eq. 0) then
        if (xct%nspin .eq. 1) then
          js_dcck=1
          js_dcckp=1
          js_dvvk=1
          js_dvvkp=1
          bse_co_js=1
          bse_co_jsp=1
        elseif (flag .eq. 0 .and. imatrix .ne. 4 .and. js .eq. jsp ) then
          js_dcck=js
          js_dcckp=js
          bse_co_js=js
          if (js .eq. 1) then
            js_dvvk=js+1
            js_dvvkp=js+1   
            bse_co_jsp=js+1
          else             
            js_dvvk=js-1
            js_dvvkp=js-1                    
            bse_co_jsp=js-1
          end if
        else if((flag == 1 .and. imatrix /= 4 .and. js == jsp) .or. &
                (flag == 1 .and. imatrix == 4) .or. (flag == 2 .and. imatrix == 4)) then
          js_dcck=js
          js_dcckp=jsp
          js_dvvk=js
          js_dvvkp=jsp
          bse_co_js=js
          bse_co_jsp=jsp
        else
          cycle
        end if
      else ! theory = 2
        if (xct%nspin .eq. 1) then
          js_dcck=1
          js_dcckp=1
          js_dvvk=1
          js_dvvkp=1
          bse_co_js=1
          bse_co_jsp=1
        elseif (flag .eq. 0 .and. imatrix .ge. 3 .and. js .eq. jsp ) then
          js_dcck=js
          js_dcckp=js
          bse_co_js=js
          if (js .eq. 1) then
            js_dvvk=js+1
            js_dvvkp=js+1   
            bse_co_jsp=js+1
          else             
            js_dvvk=js-1
            js_dvvkp=js-1                    
            bse_co_jsp=js-1
          end if
        else if((flag == 1 .and. imatrix .le. 2 .and. js == jsp) .or. &
                (flag == 1 .and. imatrix .ge. 3) .or. (flag == 2 .and. imatrix .ge. 3)) then
          js_dcck=js
          js_dcckp=jsp
          js_dvvk=js
          js_dvvkp=jsp
          bse_co_js=js
          bse_co_jsp=jsp
        else
          cycle
        end if
      endif

! Reorder matrix

      if (xct%ipar .eq. 4) then

! Best on memory and fast if ncdim and nvdim are 1

        do icp=1,ncdim
          icb = icin
          do ivp=1,nvdim
            ivb = ivin
            do ic=1,xct%ncb_fi
              do iv=1,xct%nvb_fi
                do jcp=1,xct%n2b_co
                  do jvp=1,xct%n1b_co
                    do jc=1,xct%n2b_co
                      do jv=1,xct%n1b_co
                        bse_fi(iv,ic,ivp,icp,js,jsp) = bse_fi(iv,ic,ivp,icp,js,jsp) + &
                          bse_co(jv,jc,jvp,jcp,bse_co_js,bse_co_jsp) * dvvk(iv,jv,js_dvvk) &
                          * MYCONJG(dvvkp(jvp,ivb,js_dvvkp)) * &
                          MYCONJG(dcck(ic,jc,js_dcck)) * dcckp(jcp,icb,js_dcckp)
                      enddo
                    enddo
                  enddo
                enddo
              enddo
            enddo
          enddo
        enddo
        
      else if (xct%ipar .ge. 2) then

! Faster and better on memory when nvdim is not 1

        SAFE_ALLOCATE(dummy, (xct%n1b_co,xct%ncb_fi,xct%n1b_co,ncdim))
        dummy = 0.0
              
        do icp=1,ncdim
          icb = icin
          do jcp=1,xct%n2b_co
            do jvp=1,xct%n1b_co
              call X(gemm)('n','c',xct%n1b_co,xct%ncb_fi,xct%n2b_co, &
                dcckp(jcp,icb,js_dcckp),bse_co(:,:,jvp,jcp,bse_co_js,bse_co_jsp), &
                xct%n1b_co,dcck(:,:,js_dcck),xct%ncb_fi,ONE,dummy(:,:,jvp,icp),xct%n1b_co)
            enddo
          enddo
        enddo
        
        SAFE_ALLOCATE(dummyp, (xct%n1b_co,xct%n1b_co,xct%ncb_fi,ncdim))
        SAFE_ALLOCATE(dummy2, (xct%n1b_co,xct%ncb_fi,nvdim,ncdim))
        SAFE_ALLOCATE(dummy3, (xct%n1b_co,nvdim,xct%ncb_fi,ncdim))
        SAFE_ALLOCATE(dvvkn, (xct%n1b_co,nvdim))
        dummy3 = 0.0
        dummy2 = 0.0
        
        do icp = 1, ncdim
          do ic = 1, xct%ncb_fi
            do jvp = 1, xct%n1b_co
              dummyp(:,jvp,ic,icp) = dummy(:,ic,jvp,icp)
            enddo
          enddo
        enddo
        
        if (xct%ipar .eq. 2) then
          do ivp = 1,nvdim
            dvvkn(:,ivp) = MYCONJG(dvvkp(:,ivp,js_dvvkp))
          enddo
        else
          dvvkn(:,1) = MYCONJG(dvvkp(:,ivin,js_dvvkp))
        endif
        
        do icp=1,ncdim
          icb = icin
          do ic=1,xct%ncb_fi
            call X(gemm)('n','n',xct%n1b_co,nvdim,xct%n1b_co, &
              ONE,dummyp(1,1,ic,icp),xct%n1b_co,dvvkn(1,1),xct%n1b_co,ONE,dummy3(1,1,ic,icp),xct%n1b_co)
          enddo
        enddo
        
        do icp = 1, ncdim
          do ic = 1, xct%ncb_fi
            dummy2(:,ic,:,icp) = dummy3(:,:,ic,icp)
          enddo
        enddo
        
        SAFE_DEALLOCATE(dummy)
        SAFE_DEALLOCATE(dummyp)
        SAFE_DEALLOCATE(dummy3)
        SAFE_DEALLOCATE(dvvkn)
        
        do icp=1,ncdim
          icb = icin
          do ivp=1,nvdim
            call X(gemm)('n','n',xct%nvb_fi,xct%ncb_fi,xct%n1b_co,ONE,dvvk(:,:,js_dvvk),xct%nvb_fi, &
              dummy2(:,:,ivp,icp),xct%n1b_co,ONE,bse_fi(:,:,ivp,icp,js,jsp),xct%nvb_fi)
          enddo
        enddo
        
        SAFE_DEALLOCATE(dummy2)
              
      else if (xct%ipar .eq. 1) then

! Fastest but worst on memory

        SAFE_ALLOCATE(mat_vcvc, (xct%n1b_co,xct%n1b_co,xct%n2b_co,xct%n2b_co))

        do jcp=1,xct%n2b_co
          do jc=1,xct%n2b_co
            mat_vcvc(:xct%n1b_co,1:xct%n1b_co,jc,jcp) = &
              bse_co(1:xct%n1b_co,jc,1:xct%n1b_co,jcp,bse_co_js,bse_co_jsp)
          enddo
        enddo

! Interpolate v,v`

        SAFE_ALLOCATE(mat_vfvc, (xct%nvb_fi,xct%n1b_co,xct%n2b_co,xct%n2b_co))

        do jc=1,xct%n2b_co
          do jcp=1,xct%n2b_co
            mat_vfvc(1:xct%nvb_fi,1:xct%n1b_co,jc,jcp) = &
              MATMUL((dvvk(1:xct%nvb_fi,1:xct%n1b_co,js_dvvk)), &
              (mat_vcvc(1:xct%n1b_co,1:xct%n1b_co,jc,jcp)))
          enddo
        enddo

        SAFE_DEALLOCATE(mat_vcvc)
        SAFE_ALLOCATE(mat_vfvf, (xct%nvb_fi,xct%nvb_fi,xct%n2b_co,xct%n2b_co))

        do jc=1,xct%n2b_co
          do jcp=1,xct%n2b_co
            mat_vfvf(1:xct%nvb_fi,1:xct%nvb_fi,jc,jcp) = &
              MATMUL((mat_vfvc(1:xct%nvb_fi,1:xct%n1b_co,jc,jcp)), &
              MYCONJG(dvvkp(1:xct%n1b_co,1:xct%nvb_fi,js_dvvkp)))
          enddo
        enddo

! Reorder from v,v` to c,c`

        SAFE_DEALLOCATE(mat_vfvc)
        SAFE_ALLOCATE(mat_cccc, (xct%n2b_co,xct%n2b_co,xct%nvb_fi,xct%nvb_fi))

        do jcp=1,xct%n2b_co
          do jc=1,xct%n2b_co
            mat_cccc(jc,jcp,1:xct%nvb_fi,1:xct%nvb_fi) = &
              mat_vfvf(1:xct%nvb_fi,1:xct%nvb_fi,jc,jcp)
          enddo
        enddo

! Interpolate c,c`

        SAFE_DEALLOCATE(mat_vfvf)
        SAFE_ALLOCATE(mat_cfcc, (xct%ncb_fi,xct%n2b_co,xct%nvb_fi,xct%nvb_fi))

        do iv=1,xct%nvb_fi
          do ivp=1,xct%nvb_fi
            mat_cfcc(1:xct%ncb_fi,1:xct%n2b_co,iv,ivp) = &
              MATMUL(MYCONJG(dcck(1:xct%ncb_fi,1:xct%n2b_co,js_dcck)), &
              (mat_cccc(1:xct%n2b_co,1:xct%n2b_co,iv,ivp)))
          enddo
        enddo

        SAFE_DEALLOCATE(mat_cccc)
        SAFE_ALLOCATE(mat_cfcf, (xct%ncb_fi,xct%ncb_fi,xct%nvb_fi,xct%nvb_fi))

        do iv=1,xct%nvb_fi
          do ivp=1,xct%nvb_fi
            mat_cfcf(1:xct%ncb_fi,1:xct%ncb_fi,iv,ivp) = &
              MATMUL((mat_cfcc(1:xct%ncb_fi,1:xct%n2b_co,iv,ivp)), &
              (dcckp(1:xct%n2b_co,1:xct%ncb_fi,js_dcckp)))
          enddo
        enddo

        SAFE_DEALLOCATE(mat_cfcc)

! Reorder matrix

        do ivp=1,xct%nvb_fi
          do iv=1,xct%nvb_fi
            bse_fi(iv,1:xct%ncb_fi,ivp,1:xct%ncb_fi,js,jsp) = &
              mat_cfcf(1:xct%ncb_fi,1:xct%ncb_fi,iv,ivp)
          enddo
        enddo

        SAFE_DEALLOCATE(mat_cfcf)

      endif
    enddo
  enddo

  POP_SUB(interpolate)

  return
end subroutine interpolate

#ifdef HDF5
subroutine bse_hdf5_read(xct,nk,file_id,imatrix,ikp,bsedmatrix,subsample)
  type(xctinfo), intent(in) :: xct
  integer(HID_T), intent(in) :: file_id
  integer, intent(in) :: imatrix
  integer, intent(in) :: ikp, nk
  logical, intent(in) :: subsample
  SCALAR, intent(out) :: bsedmatrix(:,:,:,:,:,:,:)

  integer :: ik, ic, icp, iv, ivp, is, isp,ik_sub,ikprime
!  integer(HID_T) :: plist_id      ! Property list identifier
  integer(HID_T) :: filespace     ! Dataspace identifier in file
  integer(HID_T) :: memspace      ! Dataspace identifier in mem
  integer(HID_T) :: dset_id       ! Dataset identifier
  integer(HSIZE_T) :: count(7), offset(7)
  integer :: rank, error
  real(DP), allocatable :: data(:,:,:,:,:,:,:)

  PUSH_SUB(bse_hdf5_read)

  !write(6,*) "About to read matrix ", imatrix

  if(subsample) then
    ! Extracting <k_sub|H|k_co=1>
    ik_sub = ikp ! This is actually the file number
    ikprime = 1  ! coarse point is always the first point in the file
  else
    ikprime = ikp
  endif

  if (xct%theory == 0) then
    if (imatrix .eq. 1) then
      call h5dopen_f(file_id, 'head', dset_id, error)
    else if (imatrix .eq. 2) then
      call h5dopen_f(file_id, 'wing', dset_id, error)
    else if (imatrix .eq. 3) then
      call h5dopen_f(file_id, 'body', dset_id, error)
    else if (imatrix .eq. 4) then
      call h5dopen_f(file_id, 'exchange', dset_id, error)
    endif
  else
    if (imatrix .eq. 1) then
      call h5dopen_f(file_id, 'head', dset_id, error)
    else if (imatrix .eq. 2) then
      call h5dopen_f(file_id, 'body', dset_id, error)
    else if (imatrix .eq. 3) then
      call h5dopen_f(file_id, 'exchange', dset_id, error)
    else if (imatrix .eq. 4) then
      call h5dopen_f(file_id, 'fxc', dset_id, error)
    endif
  endif

  rank = 7
  count(1) = SCALARSIZE
  count(2) = xct%n1b_co
  count(3) = xct%n1b_co
  count(4) = xct%n2b_co
  count(5) = xct%n2b_co
  count(6) = nk
  count(7) = 1

  SAFE_ALLOCATE(data,(count(1),count(2),count(3),count(4),count(5),count(6),count(7)))

  do isp = 1, xct%nspin
    do is = 1, xct%nspin

! Get filespace

      call h5screate_simple_f(rank, count, memspace, error)
      call h5dget_space_f(dset_id,filespace,error)

! Construct data and offset

      offset(1)=0
      offset(2)=0
      offset(3)=0
      offset(4)=0
      offset(5)=0
      offset(6)=(isp-1)*xct%nkpt_co
      offset(7)=(ikprime-1)+(is-1)*xct%nkpt_co

! Select hyperslab

      call h5sselect_hyperslab_f(filespace, H5S_SELECT_SET_F, offset, count, error)

! Create property list for collective dataset read
! Read is serial for now

      !call h5pcreate_f(H5P_DATASET_XFER_F, plist_id, error)
      !call h5pset_dxpl_mpio_f(plist_id, H5FD_MPIO_COLLECTIVE_F, error)

! Collectively read the file
! Serial for now

      !call h5dread_f(dset_id, H5T_NATIVE_DOUBLE, data, count, error, memspace, filespace, &
      !                  xfer_prp = plist_id)
      call h5dread_f(dset_id, H5T_NATIVE_DOUBLE, data, count, error, memspace, filespace)
                      
! copy from data into bsedmatrix which holds everything for one kpoint
! XXX This isn`t optimal because bsedmatrix layout is funny.

      do ik=1,count(6)
        do icp=1,count(5)
          do ic=1,count(4)
            do ivp=1,count(3)
              do iv=1,count(2)
                if (subsample) then
                  bsedmatrix(imatrix,iv,ic,ivp,icp,ik_sub,ik)=SCALARIFY2(data(1,iv,ivp,ic,icp,ik,1),data(2,iv,ivp,ic,icp,ik,1))
                else
                  bsedmatrix(iv,ic,ivp,icp,is,isp,ik)=SCALARIFY2(data(1,iv,ivp,ic,icp,ik,1),data(2,iv,ivp,ic,icp,ik,1))
                endif
              enddo
            enddo
          enddo
        enddo
      enddo

! Close property list and filespace. Do we have to do this each time?

      call h5sclose_f(memspace, error)
      call h5sclose_f(filespace, error)

! JRD: Read is serial for now
      !call h5pclose_f(plist_id, error)

    enddo
  enddo

  call h5dclose_f(dset_id, error)

  SAFE_DEALLOCATE(data)
  POP_SUB(bse_hdf5_read)
  
end subroutine bse_hdf5_read
#endif

!> FHJ: Move a point (qq) to the 1st BZ (WS cell). Output vector is qq_bz, 
!! with length abs_qq2.
subroutine point_to_bz(crys, qq, qq_bz, abs_qq2)
  type(crystal), intent(in) :: crys
  real(DP), intent(in) :: qq(3)
  real(DP), intent(out) :: qq_bz(3)
  real(DP), intent(out) :: abs_qq2

  real(DP) :: abs_tmp, qq_tmp(3)
  integer :: i1, i2, i3

  !no push/pop, called too often
  abs_qq2 = INF
  do i1=-ncell,ncell+1
    qq_tmp(1) = qq(1) - i1
    do i2=-ncell,ncell+1
      qq_tmp(2) = qq(2) - i2
      do i3=-ncell,ncell+1
        qq_tmp(3) = qq(3) - i3
        abs_tmp = DOT_PRODUCT(qq_tmp, MATMUL(crys%bdot, qq_tmp))
        if (abs_tmp < abs_qq2) then
          abs_qq2 = abs_tmp
          qq_bz(:) = qq_tmp(:)
        endif
      enddo
    enddo
  enddo

end subroutine point_to_bz

end module intkernel_m

!==============================================================================================
!
! Utilities:
!
! (1) ploteps           Originally By JRD               Last Modified 6/30/2008 (JRD)
!
!==============================================================================================

#include "f_defs.h"

program ploteps

  use global_m
  implicit none

  integer, allocatable :: isrtq(:),oldx(:),oldy(:),oldz(:)
  integer, allocatable :: isrtold(:)
  real(DP) :: qvec(3),qk(3),gmax_in,garbaged
  integer :: ii, jj, nold, nge, nmtx, nrq0

  SCALAR, allocatable :: eps(:,:)

  character :: ajname*6, adate*11

  write(*,*) 'Welcome to Epsilon Plotting'

  call open_file(unit=10,file='eps0mat',form='unformatted',status='old')
!      call open_file(unit=11,file='epsmat',form='unformatted',status='old')
  call open_file(unit=42,file='eps_surface.out',status='replace')
  call open_file(unit=43,file='eps_diagonal.out',status='replace')

!---------------------------
! Now read eps0mat

  read(10)
  read(10) ii
  if (ii.ne.0) then
    call die('Full frequency dependence not supported')
  endif
  read(10)
  read(10)
  read(10)
  read(10)
  read(10)
  read(10)
  read(10) nold
  read(10) nge
  rewind(10)
!      deallocate(oldx)
  SAFE_ALLOCATE(oldx, (nold))
!      deallocate(oldy)
  SAFE_ALLOCATE(oldy, (nold))
!      deallocate(oldz)
  SAFE_ALLOCATE(oldz, (nold))
!      deallocate(ekold)
!      allocate(ekold(nge))
!      deallocate(isrtold)
  SAFE_ALLOCATE(isrtold, (nge))
!      deallocate(isrtq)
!      allocate(isrtq(nge))
!      deallocate(isrtq)
  SAFE_ALLOCATE(isrtq, (nge))

  read(10) ajname,adate
  read(10)
  read(10)
  read(10)
  read(10)
  read(10)
  read(10) gmax_in
  read(10) nrq0,(qvec(ii),ii=1,3)
  read(10) nold,(oldx(ii),oldy(ii),oldz(ii),ii=1,nold)
  
! JRD: This should be changed later

  if(nrq0.gt.1) then
    call die("There is more than one q-point in epsmat", only_root_writes = .true.)
  endif

! Read q->0 dielectric matrix

  read(10) nge,nmtx,(isrtold(ii),jj,ii=1,nge)
  write(*,*) 'nge, nmtx =', nge,nmtx
  SAFE_ALLOCATE(eps, (nmtx,nmtx))
  write(*,*) ' '
  write(*,*) 'Allocated eps!', nmtx
  write(*,*) ' '
  read(10) (garbaged,ii=1,nge)
  read(10) (qk(ii),ii=1,3)
  do jj = 1, nmtx
    read(10) (eps(ii,jj),ii=1,nmtx)
  enddo
!      read(10) (totalreal,ii=1,nge)
  write(*,*) 'read in eps'
  isrtq=0

  call close_file(10)
!      call close_file(11)

  do ii = 1, nmtx
    do jj = 1, nmtx
      write(42,*) ii, jj, dble(eps(ii,jj))
      if (ii .eq. jj) then
        write(43,*) ii,oldx(isrtold(ii)),oldy(isrtold(ii)), &
          oldz(isrtold(ii)),dble(eps(ii,jj))
      endif
    end do
    write(42,*) ' '
  end do

  write(*,*) 'Finalizing'
  
end program ploteps

!=================================================================================
!
! Routines:
!
! (1) w_sum()         Originally By JRD       Last Modified 4/1/2012 (JRD)
!
!  Multiply Valence-Valence matrix elements by W to create temporary arrays
!  for the head, wing and body.
!
!  This routine scales as N^3, but is nested within the the igp loop 
!  in mtxel_kernel. Thus, it represents an N^4 step. Doing the multiplication
!  here is cheaper than doing it in the N^5 g_sum subroutine.
!
!=================================================================================

#include "f_defs.h"

module w_sum_m
 
  use global_m
  implicit none

  public :: w_sum

  private

contains

  subroutine w_sum(xct,wptcol,ofs1,ofs1p,n1,n1p,temph,tempw,tempb,m11p,indinvigp,ng_eps)
    type (xctinfo), intent(in) :: xct
    SCALAR, intent(in) :: wptcol(:)
    !> offset (i.e., add this number to map a local index to the global band index)
    integer, intent(in) :: ofs1, ofs1p
    !> number of bands for each wfn
    integer, intent(in) :: n1, n1p
    SCALAR, intent(inout) :: tempw(:,:,:,:), tempb(:,:,:,:), temph(:,:,:), m11p(:,:,:,:)
    integer, intent(in) :: indinvigp
    integer, intent(in) :: ng_eps

    SCALAR, allocatable :: m11p_conj(:,:,:)
    integer :: isv, ig, i1, i1p

    PUSH_SUB(w_sum)

    ! JRD: We allocate a new temporary array in order to get better cache performance
    SAFE_ALLOCATE(m11p_conj,(n1,n1p,xct%nspin))
    m11p_conj(:,:,:) = MYCONJG(m11p(indinvigp,:,:,:))

    do isv=1,xct%nspin
      if (indinvigp .eq. 1) then
        temph(ofs1+1:ofs1+n1, ofs1p+1:ofs1p+n1p, isv) = wptcol(1)*m11p_conj(1:n1, 1:n1p, isv)

        !$OMP PARALLEL PRIVATE(i1p, i1, ig) SHARED(wptcol, tempb, m11p_conj)
        do i1p = 1, n1p
          do i1 = 1, n1
            !$OMP DO
            do ig=2,ng_eps
              tempw(ig, ofs1+i1, ofs1p+i1p, isv) = wptcol(ig)*m11p_conj(i1, i1p, isv)
            enddo
            !$OMP END DO
          enddo
        enddo
        !$OMP END PARALLEL

      else

        tempw(1, ofs1+1:ofs1+n1, ofs1p+1:ofs1p+n1p, isv) = tempw(1, ofs1+1:ofs1+n1, ofs1p+1:ofs1p+n1p, isv) + &
          wptcol(1)*m11p_conj(1:n1, 1:n1p, isv)

        !$OMP PARALLEL PRIVATE(i1p, i1, ig) SHARED(wptcol, tempb, m11p_conj)
        do i1p = 1, n1p
          do i1 = 1, n1
            !$OMP DO
            do ig=2,ng_eps
              tempb(ig, ofs1+i1, ofs1p+i1p, isv) = tempb(ig, ofs1+i1, ofs1p+i1p, isv) +&
                wptcol(ig)*m11p_conj(i1, i1p, isv)
            enddo
            !$OMP END DO NOWAIT
          enddo
        enddo
        !$OMP END PARALLEL

      endif

    enddo

    SAFE_DEALLOCATE(m11p_conj)

    POP_SUB(w_sum)

  end subroutine w_sum

end module w_sum_m

#include "f_defs.h"

!*************************************************************************
Module StructureMod
!*************************************************************************
! This module contains information on the crystal structure.
! The Dimensions portion reads in the space dimension ndim used throughout 
! The Lattice portion contains information on the direct and reciprocal 
! Bravais lattices.
! The Atoms portion contains information on the atoms in the basis, 
! mainly their type and position.
!*************************************************************************
! The module contains the public functions:
!    StructureInit         calls DimensionsRead, LatticeInit, AtomsInit 
!    StructureDestory      deallocates the StructureMod module memory
!*************************************************************************
! The module contains the public variables:
!*************************************************************************
  
  use SysParams,    only : double
  use AtomBasisMod, only : AtomBasisT, AtomBasisInit, AtomBasisDestroy
  use LatticeMod,   only : LatticeT, LatticeInit, LatticeDestroy
  use push_pop_m
  implicit none

  type StructureT
    integer ndim         ! dimension of space used for lattce and atom positions
    type( AtomBasisT ),  pointer :: atomBasis
    type( LatticeT ),    pointer :: lattice
  end type StructureT

  contains

!*************************************************************************
  Subroutine StructureInit( structure1, tagHandler )
!*************************************************************************

    use  TagHandlerMod, only : tagHandlerT
    implicit none

    type( StructureT ), pointer :: structure1
    type( tagHandlerT ), pointer :: tagHandler

    integer :: error

    PUSH_SUB(StructureInit)

    if( associated( structure1 )) stop 'Error: structure already allocated.'

    allocate( structure1, stat = error )

    if( error /= 0 ) stop 'Error allocating structure.'

    nullify( structure1%atomBasis )
    nullify( structure1%lattice )

    call DimensionsRead( structure1%ndim, tagHandler )

    call LatticeInit( structure1%lattice, structure1%ndim, tagHandler )

    call AtomBasisInit( structure1%atomBasis, structure1%ndim, structure1%lattice, tagHandler )

    POP_SUB(StructureInit)
  end Subroutine StructureInit

!*************************************************************************
  Subroutine StructureDestroy( structure1 )
!*************************************************************************

    implicit none

    type( StructureT ), pointer :: structure1
    integer :: error

    PUSH_SUB(StructureDestroy)

    if( .not. associated( structure1 )) stop 'Error structure not allocated.'

    call LatticeDestroy( structure1%lattice )

    call AtomBasisDestroy( structure1%atomBasis )

    deallocate( structure1, stat = error )

    if( error /= 0 ) stop 'Error deallocating structure.'

    nullify( structure1 )

    POP_SUB(StructureDestroy)
  end Subroutine StructureDestroy

!*************************************************************************
  Subroutine DimensionsRead(ndim, tagHandler )
!*************************************************************************

    use TagHandlerMod, only : FindTag, tagHandlerT
    implicit none

    type( tagHandlerT ), pointer :: taghandler
    integer, intent(out) :: ndim
    integer :: error1, error
    logical :: default

    PUSH_SUB(DimensionsRead)

    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Read in the number of dimensions.  If none is present or their is
    ! an error reading the number then the default value of 3 is used.  The
    ! number of dimensions must be from 1 to 3. 

    default = .True.

    call FindTag( tagHandler, 'NumberOfDimensions', error1)
    if(error1 .eq. 0) then
      read(unit = tagHandler%fileno, fmt = '(I10)', iostat = error) ndim

      if(error.eq. 0 .and.ndim .gt. 0 .and.ndim.lt. 4) then
        print *, 'NumberOfDimensions ', ndim
        default = .False.
      end if

    end if

    if(default) then
      ndim = 3
      print *, 'Using default value of NumberOfDimensions ', ndim
    end if

    ! ndim = space dimension has been initialized.
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    POP_SUB(DimensionsRead)
  end Subroutine DimensionsRead

end Module StructureMod

!===============================================================================
!
! Routines:
!
! 1. real_wfng()        Originally By gsm        Last Modified 9/1/2010 (gsm)
!
!    Constructs real wavefunctions in G-space for systems
!    with inversion symmetry by applying Gram-Schmidt process.
!    Based on paratecSGL/src/para/gwreal.f90
!
!===============================================================================

#include "f_defs.h"

module real_m

  use global_m

  implicit none

  private

  public :: real_wfng

contains

!-------------------------------------------------------------------------------

SUBROUTINE real_wfng ( ngk_l, nb, ns, nk, energy, wfn_d )

  integer, intent (in) :: ngk_l, nb, ns, nk
  real(DP), intent (in) :: energy ( :, :, : ) !< ( nb, nk, ns )
  complex(DPC), intent (inout) :: wfn_d ( :, :, :, : ) !< ( ngk_l, nb, ns, nk )
  
  real(DP), PARAMETER :: eps2 = 1.0D-2
  real(DP), PARAMETER :: eps5 = 1.0D-5
  real(DP), PARAMETER :: eps6 = 1.0D-6
  
  integer :: i, j, k, ik, is, ib, jb, ig, inum, deg, mdeg, inc
  integer :: dimension_span, reduced_span
  real(DP) :: x, y
  integer, allocatable :: imap ( :, : )
  integer, allocatable :: inums ( : )
  integer, allocatable :: inull ( : )
  integer, allocatable :: null_map ( :, : )
  real(DP), allocatable :: psi ( :, : )
  real(DP), allocatable :: phi ( :, : )
  real(DP), allocatable :: vec ( : )
  complex(DPC), allocatable :: wfc ( : )
  
  PUSH_SUB(real_wfng)
  
  DO ik = 1, nk
    
    mdeg = 1
    DO is = 1, ns
      DO ib = 1, nb - 1
        deg = 1
        DO jb = ib + 1, nb
          IF ( abs ( energy ( ib, ik, is ) - &
            energy ( jb, ik, is ) ) .LT. eps5 * &
            dble ( jb - ib + 1 ) ) deg = deg + 1
        ENDDO
        IF ( deg .GT. mdeg ) mdeg = deg
      ENDDO
    ENDDO
    mdeg = mdeg * 2
    
    SAFE_ALLOCATE ( imap, ( nb, ns ) )
    SAFE_ALLOCATE ( inums, ( ns ) )
    SAFE_ALLOCATE ( inull, ( nb ) )
    SAFE_ALLOCATE ( null_map, ( mdeg, nb ) )
    
    DO is = 1, ns
      inum = 1
      DO ib = 1, nb
        IF ( ib .EQ. nb ) THEN
          imap ( inum, is ) = ib
          inum = inum + 1
        ELSEIF ( abs ( energy ( ib, ik, is ) - &
          energy ( ib + 1, ik, is ) ) .GT. eps5 ) THEN
          imap ( inum, is ) = ib
          inum = inum + 1
        ENDIF
      ENDDO
      inum = inum - 1
      inums ( is ) = inum
    ENDDO
    
    SAFE_ALLOCATE ( wfc, ( ngk_l ) )
    SAFE_ALLOCATE ( psi, ( ngk_l, mdeg ) )
    SAFE_ALLOCATE ( phi, ( ngk_l, mdeg ) )
    SAFE_ALLOCATE ( vec, ( ngk_l ) )
    
    DO is = 1, ns
      inc = 1
      inum = inums ( is )
      DO i = 1, inum
        inull ( i ) = 1
        DO ib = inc, imap ( i, is )
          DO ig = 1, ngk_l
            wfc ( ig ) = wfn_d ( ig, ib, is, ik )
          ENDDO
          x = 0.0D0
          DO ig = 1, ngk_l
            x = x + dble ( wfc ( ig ) ) **2
          ENDDO
#ifdef MPI
          y = x
          CALL MPI_Allreduce ( y, x, 1, MPI_REAL_DP, MPI_SUM, MPI_COMM_WORLD, mpierr )
#endif
          IF ( x .LT. eps2 ) null_map ( inull ( i ), i ) = 0
          IF ( x .GT. eps2 ) null_map ( inull ( i ), i ) = 1
          inull ( i ) = inull ( i ) + 1
          x = 0.0D0
          DO ig = 1, ngk_l
            x = x + aimag ( wfc ( ig ) ) **2
          ENDDO
#ifdef MPI
          y = x
          CALL MPI_Allreduce ( y, x, 1, MPI_REAL_DP, MPI_SUM, MPI_COMM_WORLD, mpierr )
#endif
          IF ( x .LT. eps2 ) null_map ( inull ( i ), i ) = 0
          IF ( x .GT. eps2 ) null_map ( inull ( i ), i ) = 1
          inull ( i ) = inull ( i ) + 1
        ENDDO
        inull ( i ) = inull ( i ) - 1
        inc = imap ( i, is ) + 1
      ENDDO
      inc = 1
      ib = 1
      DO i = 1, inum
        k = 1
        DO j = 1, 2 * ( imap ( i, is ) - inc ) + 1, 2
          IF ( null_map ( j, i ) .EQ. 1 .OR. &
            null_map ( j + 1, i ) .EQ. 1 ) THEN
            DO ig = 1, ngk_l
              wfc ( ig ) = wfn_d ( ig, ib, is, ik )
            ENDDO
            IF ( null_map ( j, i ) .EQ. 1 ) THEN
              DO ig = 1, ngk_l
                phi ( ig, k ) = dble ( wfc ( ig ) )
              ENDDO
              k = k + 1
            ENDIF
            IF ( null_map ( j + 1, i ) .EQ. 1 ) THEN
              DO ig = 1, ngk_l
                phi ( ig, k ) = aimag ( wfc ( ig ) )
              ENDDO
              k = k + 1
            ENDIF
            ib = ib + 1
          ENDIF
        ENDDO
        dimension_span = k - 1
        IF ( dimension_span .EQ. 0 .AND. peinf%inode .EQ. 0 ) &
          WRITE ( 0, 201 ) ik, is, inc
        DO j = 1, dimension_span
          x = 0.0D0
          DO ig = 1, ngk_l
            x = x + phi ( ig, j ) **2
          ENDDO
#ifdef MPI
          y = x
          CALL MPI_Allreduce ( y, x, 1, MPI_REAL_DP, MPI_SUM, MPI_COMM_WORLD, mpierr )
#endif
          x = sqrt ( x )
          DO ig = 1, ngk_l
            phi ( ig, j ) = phi ( ig, j ) / x
          ENDDO
        ENDDO
!
! the Gram-Schmidt process begins
!
        reduced_span = 1
        DO ig = 1, ngk_l
          psi ( ig, 1 ) = phi ( ig, 1 )
        ENDDO
        DO j = 1, dimension_span - 1
          DO ig = 1, ngk_l
            vec ( ig ) = phi ( ig, j + 1 )
          ENDDO
          DO k = 1, reduced_span
            x = 0.0D0
            DO ig = 1, ngk_l
              x = x + phi ( ig, j + 1 ) * psi ( ig, k )
            ENDDO
#ifdef MPI
            y = x
            CALL MPI_Allreduce ( y, x, 1, MPI_REAL_DP, MPI_SUM, MPI_COMM_WORLD, mpierr )
#endif
            DO ig = 1, ngk_l
              vec ( ig ) = vec ( ig ) - psi ( ig, k ) * x
            ENDDO
          ENDDO
          x = 0.0D0
          DO ig = 1, ngk_l
            x = x + vec ( ig ) **2
          ENDDO
#ifdef MPI
          y = x
          CALL MPI_Allreduce ( y, x, 1, MPI_REAL_DP, MPI_SUM, MPI_COMM_WORLD, mpierr )
#endif
          x = sqrt ( x )
          IF ( x .GT. eps6 ) THEN
            reduced_span = reduced_span + 1
            DO ig = 1, ngk_l
              psi ( ig, reduced_span ) = vec ( ig ) / x
            ENDDO
          ENDIF
        ENDDO
!
! the Gram-Schmidt process ends
!
        IF ( reduced_span .LT. imap ( i, is ) - inc + 1 .AND. peinf%inode .EQ. 0 ) &
          WRITE ( 0, 202 ) ik, is, inc
        DO ib = inc, imap ( i, is )
          DO ig = 1, ngk_l
            wfn_d ( ig, ib, is, ik ) = &
              CMPLX ( psi ( ig, ib - inc + 1 ), 0.0D0 )
          ENDDO
        ENDDO
        inc = imap ( i, is ) + 1
      ENDDO
    ENDDO
    
    SAFE_DEALLOCATE ( vec )
    SAFE_DEALLOCATE ( phi )
    SAFE_DEALLOCATE ( psi )
    SAFE_DEALLOCATE ( wfc )
    SAFE_DEALLOCATE ( null_map )
    SAFE_DEALLOCATE ( inull )
    SAFE_DEALLOCATE ( inums )
    SAFE_DEALLOCATE ( imap )
    
  ENDDO
  
  POP_SUB(real_wfng)
  
  RETURN
  
201 FORMAT(1x,"WARNING: failed Gram-Schmidt dimension span",/,14x, &
      "k-point =",1x,i4.4,1x,"spin =",1x,i1.1,1x,"band =",1x,i4.4,/)
202 FORMAT(1x,"WARNING: failed Gram-Schmidt reduced span",/,14x, &
      "k-point =",1x,i4.4,1x,"spin =",1x,i1.1,1x,"band =",1x,i4.4,/)
  
END SUBROUTINE real_wfng

!-------------------------------------------------------------------------------

end module real_m

!===================================================================
!
! Modules:
!
! 1. io_utils_m      Originally By FHJ
!
!    Provides set of routines to standardize stdout operations.
!    Objects:
!
!    progress_info: tracks the progress of a task
!
!===================================================================

#include "f_defs.h"

module io_utils_m

  use global_m

  implicit none

  private

  !> Progress information object. Use this object whenever you want to have
  !! a nice standardized progress report on a given task, including an
  !! estimate of the remaining time to complete the task.
  !!
  !! \sa progress_init(), progress_step() and progress_free routines().
  type progress_info
    real(DP) :: t_pred  !< A prediction of when task will be done.
    !> Time when progress_init was called (before 1st step got executed).
    real(DP) :: t_wall0
    !> Time elapsed, wrt t_wall0, when 1st step finished (before 2nd step got executed).
    real(DP) :: dt1
    real(DP) :: report_every !< How often to report progress to stdout?
    integer :: num_steps !< Max. number of steps (not number of reports!)
    integer :: cur_step  !< Keep track of the current step
    !> What is the task we are tracking? This should be a noun(-phrase). Eg:
    !! "reading wavefunctions", "calculation of matrix elements", etc.
    character(len=256) :: str_task
    !> What defines each step/iteration? This should be a noun(-phrase). Eg:
    !! "k-point", "transition", etc.
    character(len=64) :: str_step
    character(len=11) :: str_tot !< this is the string " / $num_steps"
  end type progress_info

  public ::              &
    centralize,          &
    progress_info,       &
    progress_init,       &
    progress_step,       &
    progress_free,       &
    print_dealing_with

contains

  !> Trim and centralize a string. Max width hard-coded to 256.
  subroutine centralize(text_in, text_out, width)
    character(len=*), intent(in) :: text_in
    character(len=*), intent(out) :: text_out
    integer, intent(in) :: width

    character(len=256) :: text
    integer :: text_len, margin, wid

    PUSH_SUB(centralize)

    wid = width
    if (wid>256) wid=256
    if (len(TRUNC(text_in))>wid) then
      ! FHJ: avoid buffer overflow.
      text_out = text_in(1:wid)
      POP_SUB(centralize)
      return
    endif

    text = TRUNC(text_in)
    text_len = len(TRUNC(text))
    margin = (wid-text_len)/2
    text_out = repeat(' ', len(text_out))
    text_out(margin+1:margin+text_len) = text(1:text_len)

    POP_SUB(centralize)
    return

  end subroutine centralize

  !----------------------------------------------------------------------------
  ! FHJ: Progress report stuff
  !----------------------------------------------------------------------------

  !> Initialize a ::progress_info structure.
  !!
  !! This subroutine will also print the following sentence:
  !! "Started ${str_task} with ${num_steps} ${str_step}s at ${TIME}."
  subroutine progress_init(prog_info, str_task, str_step, num_steps, num_reports)
    type(progress_info), intent(out) :: prog_info
    character(len=*), intent(in) :: str_task !< See: progress_info%str_task
    character(len=*), intent(in) :: str_step !< See: progress_info%str_step
    integer, intent(in) :: num_steps !< How many times will you call progress_step?
    !> What is the total number of times we want to write the progress to
    !! stdout? Defaults to 10.
    integer, intent(in), optional :: num_reports

    character(len=15) :: mydate, mytime
    character(len=256) :: str_tmp
    real(DP) :: t_cpu
    integer :: num_rep

    PUSH_SUB(progress_init)

    prog_info%dt1 = 0d0
    prog_info%t_pred = 0d0
    prog_info%str_task = str_task
    prog_info%str_step = str_step
    prog_info%num_steps = num_steps
    num_rep = 10
    if (present(num_reports)) num_rep = num_reports
    if (num_steps<num_rep) then
      prog_info%report_every = 1d0
    else
      prog_info%report_every = dble(num_steps)/num_rep
    endif
    prog_info%cur_step = 0
    call timget(t_cpu, prog_info%t_wall0)

    if (peinf%inode==0) then
      call date_and_time(mydate,mytime)
      write(6,*)
      write(str_tmp,'(i8)') num_steps
      ! FHJ: eg: "Started reading WFNs with 65536 k-point(s) at 12:00:00."
      write(6,'(1x,4a,1x,3a)') &
        'Started ',TRUNC(str_task), ' with ', TRUNC(str_tmp), TRUNC(str_step), &
        '(s) at ', mytime(1:2)//':'//mytime(3:4)//':'//mytime(5:6)//'.'
      call centralize(str_step, str_tmp, 19)
      write(str_tmp,'(i8)') num_steps
      write(prog_info%str_tot,'(a,a)') ' / ', TRUNC(str_tmp)
    endif


    POP_SUB(progress_init)

  end subroutine progress_init

  !> Update prediction info for current task.
  !!
  !! Call this function at the beginning of your loop. The variable 
  !! prog_info%t_pred will be updated with the prediction of when the task will
  !! be finished. Depending on the current step, some info about the progress 
  !! of the current task will be printed. Although this function is pretty
  !! lightweight, you might consider not placing the call in the innermost loop
  !! if only a very simple operation is performed each step.
  subroutine progress_step(prog_info, step_)
    type(progress_info), intent(inout) :: prog_info
    integer, intent(in), optional :: step_ !< Current step/iteration

    !> Contains an estimate for the time remaining to finish the task
    character(len=11) :: str_remaining_tmp
    character(len=64) :: str_remaining
    real(DP) :: dt, t_cpu, t_remain
    character(len=15) :: mydate, mytime
    integer :: step, idx1, idx2
    character(len=15) :: step_str
  
    PUSH_SUB(progress_step)

    if (present(step_)) then
      prog_info%cur_step = step_
    else
      prog_info%cur_step = prog_info%cur_step + 1
    endif
    step = prog_info%cur_step

    if (step<=3 .or. mod(dble(step), prog_info%report_every)<1d0) then
      call timget(t_cpu, dt)
      str_remaining = '.'
      dt = dt - prog_info%t_wall0
      if (step==2) then
        prog_info%dt1 = dt
      elseif (step>2) then
        ! FHJ: to get a better estimate, we compare the time wrt step #2, since
        ! step #1 is usually atypical (setup_FFTs, allocate buffers, etc.)
        t_remain = (dt - prog_info%dt1) / (step-2d0) * (prog_info%num_steps-step+1d0)
        prog_info%t_pred = prog_info%t_wall0 + t_remain
        write(str_remaining_tmp, '(i6)') idnint(t_remain)
        write(str_remaining, '(3a)') ', remaining: ', TRUNC(str_remaining_tmp),' s.'
      endif

      if (peinf%inode==0 .and. ((step==1.or.step==3).or.&
          mod(dble(step), prog_info%report_every)<1d0)) then
        call date_and_time(mydate,mytime)
        ! FHJ: This ensures that the two numbers in (xx/yy) have the same width
        write(step_str, '(i15)') step
        idx2 = LEN(TRUNC(prog_info%str_tot)) - 2
        idx1 = 16 - idx2 
        idx2 = idx1 + idx2 - 1
        write(6,'(1x,3a,i3,a)', advance='no') & ! [ 12:00:00 |  20% ]
          '[ ', mytime(1:2)//':'//mytime(3:4)//':'//mytime(5:6), ' | ', &
          idnint((step - 1d0)/dble(prog_info%num_steps)*1d2), '% ]'
        write(6,'(1x,a,1x,a,1x,a)', advance='no') & ! transition  16 / 128
          TRUNC(prog_info%str_step), step_str(idx1:idx2), TRUNC(prog_info%str_tot)
        write(6,'(a)') TRUNC(str_remaining)    !, remaining:    10 s.
      endif
    endif

    POP_SUB(progress_step)

  end subroutine progress_step

  !> Finalize a progress information task.
  !!
  !! This will essentially print the following sentence:
  !! "Finished ${str_task} at ${TIME}."
  subroutine progress_free(prog_info)
    type(progress_info), intent(in) :: prog_info

    real(DP) :: dt, t_cpu
    character(len=15) :: mydate, mytime

    PUSH_SUB(progress_free)

    if (peinf%inode==0) then
      call date_and_time(mydate,mytime)
      write(6,'(1x,4a)') 'Finished ', TRUNC(prog_info%str_task), &
         ' at ', mytime(1:2)//':'//mytime(3:4)//':'//mytime(5:6)//'.'
      call timget(t_cpu, dt)
      dt = dt - prog_info%t_wall0
      write(mytime,'(i8)') idnint(dt)
      write(6,'(1x,a,a,a)') 'Elapsed time: ', TRUNC(mytime), ' s.'
      write(6,*)
    endif

    POP_SUB(progress_free)

  end subroutine progress_free

  !> Print a banner with the new q/k point we are calculating
  subroutine print_dealing_with(ik, ik_max, kk, label)
    integer, intent(in) :: ik !< Index of the current k-point
    integer, intent(in) :: ik_max !< Total numeber of k-points
    real(DP), intent(in) :: kk(:) !< (3) K-point as a vector
    character(len=*), intent(in) :: label !< Either "k" or "q"

    !> Contains an estimate for the time remaining to finish the task
    real(DP) :: t_cpu, t_wall
    character(len=15) :: mydate, mytime
    character(len=15) :: str_cur, str_max
    character(len=30) :: str_sulfix
    integer :: ii, idx1, idx2
  
    PUSH_SUB(print_dealing_with)

    call timget(t_cpu, t_wall)
    call date_and_time(mydate,mytime)
    write(6,'(a)') repeat('=', 80)
    write(6,'(1x,a)', advance='no') mytime(1:2)//':'//mytime(3:4)//':'//mytime(5:6)
    write(6,'(3x,a,3f10.6)', advance='no') 'Dealing with '//label(1:1)//' =', (kk(ii),ii=1,3)
    ! wrote 58 characters
    write(str_max,'(i15)') ik_max
    write(str_cur,'(i15)') ik
    idx2 = LEN(TRUNC(str_max))
    idx1 = 16 - idx2 
    idx2 = idx1 + idx2 - 1
    write(str_sulfix,'(a)') str_cur(idx1:idx2)//' / '//TRUNC(str_max)
    idx1 = 80 - 58 - LEN(TRUNC(str_sulfix))
    write(6,'(a)') repeat(' ', idx1)//TRUNC(str_sulfix)
    write(6,'(a,/)') repeat('=', 80)

    POP_SUB(print_dealing_with)

  end subroutine print_dealing_with

end module io_utils_m

!>=========================================================================
!!
!! Module:
!!
!! (1) wfn_io_hdf5_m     Originally by JIM     Last Modified 4/25/2012 (JIM)
!!
!!     Routines to read and write wavefunctions in HDF5 format.
!!     The code is generated through repeated inclusion of a file with
!!     different preprocessor definitions each time. You are not expected to
!!     understand this. Consult the resulting .p.f file for clarity.
!!
!!=========================================================================

#include "f_defs.h"

module hdf5_io_m
  use global_m
#ifdef HDF5
  use h5lt
  use hdf5
  
  implicit none
  
  private
  
  public :: &
    hdf5_read_int           , &
    hdf5_write_int          , &
    hdf5_read_int_array     , &
    hdf5_write_int_array    , &
    hdf5_read_double        , &
    hdf5_write_double       , &
    hdf5_read_double_array  , &
    hdf5_write_double_array

contains
  
!===============================================================================
#define TYPE_INT
#define READ
#include "hdf5_io_inc.f90"
#undef READ
#include "hdf5_io_inc.f90"
#undef TYPE_INT

#define TYPE_DOUBLE
#define READ
#include "hdf5_io_inc.f90"
#undef READ
#include "hdf5_io_inc.f90"
#undef TYPE_DOUBLE
!===============================================================================

#endif

end module hdf5_io_m

!! Local Variables:
!! mode: f90
!! coding: utf-8
!! End:

!=========================================================================
!
! Utilities:
!
! (1) epsbinasc()  Originally by JLL       Last Modified 5/5/2008 (JRD)
!
!     This utility converts a binary epsmat file to an ascii epsmat file.
!     It uses the input file epsconv.inp.
!
!=========================================================================

#include "f_defs.h"

program epsbinasc

  use global_m
  implicit none

  character :: ajname*6,adate*11,outfile*20
  real(DP) :: ecuts1,ecuts2
  real(DP), allocatable :: dFreqGrid(:)
  complex(DPC), allocatable :: dFreqBrd(:)
  integer :: iunit,ig,im,iq,istart,j,jm, &
    nfiles,ng1,ng2,ngq1,ngq2,nmtx1,nmtx2,nq,nqtot, &
    ii,qgrid(3),freq_dep,nFreq,ijk
  
  character*120, allocatable :: filename(:)
  real(DP), allocatable :: ekin(:),q2(:,:)
  SCALAR, allocatable :: eps(:)
  integer, allocatable :: isort1(:),isort2(:),kx(:),ky(:),kz(:)

  logical :: file_exists

  write(6,*) 'This routine should only be used on non HDF5-based epsmat files.'
  write(6,*) 'If you built with HDF5 support (which is ideal), or otherwise'
  write(6,*) 'have HDF5-based epsmat files, you can use the h5dump command'
  write(6,*) 'to see your data in ascii format.'

  call open_file(55,file='epsconv.inp',form='formatted',status='old')
  read(55,*) nqtot
  SAFE_ALLOCATE(q2, (3,nqtot))
  read(55,'(a20)') outfile
  write(6,*) 'Output -> ',outfile
  write(6,*)

!--------------------------
! Find maximal values, and check consistency between
! the input file and the epsmat files...

  istart=1
  ng1=0
  ngq1=0
  nmtx1=0
  read(55,*) nfiles
  SAFE_ALLOCATE(filename, (nfiles))
  do iunit=1,nfiles
    read(55,'(a20)') filename(iunit)
#ifdef HDF5
    ! stop without error to allow the testsuite to run when compiled with -DHDF5
    INQUIRE(FILE=filename(iunit), EXIST=file_exists)
    if (.not. file_exists) then
      write(0,'(a)') 'WARNING: File "' // trim(filename(iunit)) // '" does not exist. Stopping.'
      stop
    endif
#endif
    write(6,*) 'Checking file ',TRUNC(filename(iunit))
    call open_file(unit=11,file=filename(iunit),form='unformatted',status='old')
    
    read(11) ajname,adate
    if(ajname /= 'chiGG0') then
      call die("Incorrect header '" // ajname // "' (must be 'chiGG0') in file '" // TRUNC(filename(iunit)) // "'")
    endif
    read(11) freq_dep,nFreq
    if (freq_dep.ne.0) then
      call die('epsbinasc: freq_dep')
    endif
    read(11) (qgrid(ii),ii=1,3)
    if (freq_dep .eq. 2) then
      SAFE_ALLOCATE(dFreqGrid,(nFreq))
      SAFE_ALLOCATE(dFreqBrd,(nFreq))
      read(11) (dFreqGrid(ijk),ijk=1,nFreq),(dFreqBrd(ijk),ijk=1,nFreq)
    else
      read(11)
    endif
    read(11)
    read(11)
    read(11) ecuts2
    
    if(iunit == 1) then
      ecuts1 = ecuts2
    else
      if(ecuts2.ne.ecuts1) then
        write(0,*) 'The cut-off in previous file (',ecuts1,') does not match ', &
          'the one in file ',TRUNC(filename(iunit)),' (',ecuts2,').'
        call die('epsbinasc cutoff mismatch')
      endif
    endif

    read(11) nq,((q2(j,iq),j=1,3),iq=istart,istart+nq-1)

    read(11) ng2
    if(ng1.eq.0) ng1=ng2
    if(ng2.ne.ng1) then
      call die('The number of G-vectors differs in epsmat files.')
    endif

    do iq=istart,istart+nq-1
      read(11) ngq2,nmtx2
      if(ngq1.lt.ngq2) ngq1=ngq2
      if(nmtx1.lt.nmtx2) nmtx1=nmtx2
      read(11)
      read(11) (q2(j,iq),j=1,3)
      do jm =1, nmtx2
        read(11)
      enddo
    enddo

    istart=istart+nq
    call close_file(11)
  enddo
  if(istart-1.ne.nqtot) then
    write(0,*) 'found = ', istart - 1, ' expected ', nqtot
    call die('Number of q-vectors found differs from number in input file.')
  endif

  SAFE_ALLOCATE(kx, (ng1))
  SAFE_ALLOCATE(ky, (ng1))
  SAFE_ALLOCATE(kz, (ng1))
  call open_file(unit=11,file=filename(1),form='unformatted',status='old')
  read(11)
  read(11)
  read(11)
  read(11)
  read(11)
  read(11)
  read(11)
  read(11)
  read(11) ng1,(kx(ig),ky(ig),kz(ig),ig=1,ng1)
  call close_file(11)
  SAFE_ALLOCATE(isort1, (ng1))
  SAFE_ALLOCATE(isort2, (ng1))
  SAFE_ALLOCATE(ekin, (ngq1))
  SAFE_ALLOCATE(eps, (nmtx1))
  
  call open_file(unit=12,file=outfile,form='formatted',status='replace')
  write(12,'(1x,a6,1x,a11)') ajname,adate
  write(12,*) freq_dep,nFreq
  write(12,*) (qgrid(ii),ii=1,3)
  if (freq_dep .eq. 2) then
    write(12,*) (dFreqGrid(ii),ii=1,nFreq),(dFreqBrd(ii),ii=1,nFreq)
  else
    write(12,*)
  endif
  write(12,*)
  write(12,*)
  write(12,*) ecuts1
  write(12,*) nqtot,((q2(j,iq),j=1,3),iq=1,nqtot)
  write(12,*) ng1,(kx(ig),ky(ig),kz(ig),ig=1,ng1)

  write(6,*)
  istart=1
  do iunit=1,nfiles
    write(6,*) 'Dealing with file ',TRUNC(filename(iunit))
    call open_file(unit=11,file=filename(iunit),form='unformatted',status='old')
    
    read(11)
    read(11)
    read(11)
    read(11)
    read(11)
    read(11)
    read(11)
    read(11) nq
    read(11)
    do iq=istart,istart+nq-1
      write(6,'(a,f9.6,3x,f9.6,3x,f9.6)') ' -> q=',(q2(j,iq),j=1,3)
      read(11) ngq2,nmtx2,(isort1(ig),isort2(ig),ig=1,ngq2)
      write(12,*) ngq2,nmtx2,(isort1(ig),isort2(ig),ig=1,ngq2)
      read(11) (ekin(ig),ig=1,ngq2)
      write(12,*) (ekin(ig),ig=1,ngq2)
      read(11)
      write(12,*) (q2(j,iq),j=1,3)
      do jm = 1, nmtx2
        read(11) (eps(im),im=1,nmtx2)
        write(12,*) (eps(im),im=1,nmtx2)
      enddo
    enddo

    istart=istart+nq
    call close_file(11)
  enddo
  call close_file(12)

end program epsbinasc

!=========================================================================
!
! Routines:
!
! (1) write_program_header  Originally by DAS       Last Modified 10/15/2010 (DAS)
!
!     Write a header for the beginning of each program.
!
!=========================================================================

#include "f_defs.h"

subroutine write_program_header(aname, write_to_7)
  use global_m
  use svninfo_m
  implicit none

  character(len=*), intent(in) :: aname
  logical, intent(in) :: write_to_7

  character :: asvninfo*256, aversion*15, adate*11, atime*14

  PUSH_SUB(write_program_header)

  aversion = MYFLAVOR // ' version'
  call getsvninfo(asvninfo)
  call date_time(adate,atime)
  if (peinf%inode .eq. 0) then
    write(6,10) trim(asvninfo)
    if (write_to_7) write(7,10) trim(asvninfo)
 10 format(/,' BerkeleyGW ',a,/)
    write(6,20) trim(aname),trim(aversion), &
     trim(ondate),trim(adate),trim(attime),trim(atime)
    if (write_to_7) write(7,20) trim(aname),trim(aversion), &
     trim(ondate),trim(adate),trim(attime),trim(atime)
 20 format(1x,a,2x,a,2x,a,2x,a,2x,a,2x,a,/)
    write(6,50)
    write(6,51)
    write(6,50)
    write(6,52)
 50 format('--------------------------------------------------------------------------------')
 51 format(1x,'Please cite the following papers when using results from BerkeleyGW:',/,/, &
           1x,'Jack Deslippe, Georgy Samsonidze, David A. Strubbe, Manish Jain, Marvin L.',/, &
           1x,'Cohen, and Steven G. Louie, "BerkeleyGW: A Massively Parallel Computer Package',/, &
           1x,'for the Calculation of the Quasiparticle and Optical Properties of Materials',/, &
           1x,'and Nanostructures," Comput. Phys. Commun. 183, 1269 (2012)',/,/, &
           1x,'Mark S. Hybertsen and Steven G. Louie, "Electron correlation in semiconductors',/, &
           1x,'and insulators: Band gaps and quasiparticle energies," Phys. Rev. B 34, 5390',/, &
           1x,'(1986)',/,/, &
           1x,'Michael Rohlfing and Steven G. Louie, "Electron-hole excitations and optical',/, &
           1x,'spectra from first principles," Phys. Rev. B 62, 4927 (2000)')
 52 format('')
    write(6,30)
    if (write_to_7) write(7,30)
#ifdef MPI
 30 format(1x,'Running MPI version (parallel)',/)
    write(6,40) peinf%npes
    if (write_to_7) write(7,40) peinf%npes
 40 format(1x,'Running with ',i0,' MPI task(s)',/)
#else
 30 format(1x,'Running serial version (no MPI)',/)
#endif
  endif

#ifdef OMP
    if (peinf%inode .eq. 0) write(6,'(1x,a,i0)') "Using OpenMP. Number of threads per MPI task: ", peinf%nthreads
    if (peinf%inode .eq. 0) write(6,*)
#endif

  POP_SUB(write_program_header)
  return

end subroutine write_program_header

#include "f_defs.h"

!-----------------------------------------------------------------------
subroutine input_q(kp,crys,gvec,kg,kgq,kpq,syms,xct, &
  indexq,eqp,flag,intwfnv)
!-----------------------------------------------------------------------
!
!     Read data from file WFN_fi or WFNq_fi and initialize variables
!     (only called if flag%vm.ne.1.or.flag%dtm.ne.1)
!
!     input: crys, gvec, kg, kp, syms, xct types
!
!     output: kgq type
!             indexq(1:xct%nkpt_fi) - mapping of points in shifted grid
!             INT_VWFNQ_* files
!
  use global_m
  use checkbz_m
  use eqpcor_m
  use fullbz_m
  use input_utils_m
  use misc_m
  use scissors_m
  use wfn_rho_vxc_io_m
  use io_utils_m
  implicit none

  type (crystal), intent(in) :: crys
  type (kpoints), intent(in) :: kp
  type (gspace), intent(in) :: gvec
  type (grid), intent(in) :: kg
  type (grid), intent(out) :: kgq
  type (kpoints), intent(out) :: kpq
  type (symmetry), intent(in) :: syms
  type (xctinfo), intent(inout) :: xct
  type (flags), intent(in) :: flag
  integer, intent(out) :: indexq(xct%nkpt_fi)
  type (eqpinfo), intent(inout) :: eqp
  type (int_wavefunction), intent(out) :: intwfnv      

  type (symmetry) :: symsq
  type (crystal) :: crysq
  type (wavefunction) :: wfnv
  character :: wfnq0*16
  character :: filenamev*20
  character :: tmpfn*16
  character :: fncor*32
  integer :: iunit_v,iwrite
  integer :: ii,jj,kk,ik,ikq,irkq,is,ispinor,ib,ibq, irk
  integer :: dest,tag,dummygvec(1,1)
  integer :: iwritetotal,ijk,minband
  real(DP) :: delta,qq(3),tol
  integer, allocatable :: isend(:),iwriteik(:)
  SCALAR, allocatable :: cg(:,:), cgarray(:)

  character(len=3) :: sheader
  integer :: iflavor
  type(gspace) :: gvecq, gvec_kpt
  logical :: irkq_match
  integer :: last_ng, last_ng_match, last_ikt
  logical :: skip_checkbz, broken_degeneracy
  !> Number of bands that were corrected (via scissors or eqp). We can`t find 
  !! the FE using more bands than this number.
  integer :: bands_cor
  type(progress_info) :: prog_info

  PUSH_SUB(input_q)

  if (flag%opr .eq. 0) then
    wfnq0 = 'WFNq_fi'
    fncor='eqp_q.dat'
  else
    wfnq0 = 'WFN_fi'
    fncor='eqp.dat'
  endif

  if(peinf%inode == 0) call open_file(26,file=wfnq0,form='unformatted',status='old')

  sheader = 'WFN'
  iflavor = 0
  call read_binary_header_type(26, sheader, iflavor, kpq, gvecq, symsq, crysq, &
    warn = .false., dont_warn_kgrid = xct%patched_sampling.or..not.xct%is_absorption)

! When using the velocity operator and q shift in a truncated direction,
! WFNq_fi will have k-points with nonzero coordinates in that direction, so
! we should not issue a warning in that case. --DAS
!  call check_trunc_kpts(xct%icutv, kpq)
    
  call check_header('WFN_fi', kp, gvec, syms, crys, wfnq0, kpq, gvecq, symsq, crysq, is_wfn = .true.)

  if(any(kp%kgrid(1:3) /= kpq%kgrid(1:3))) then
    if(peinf%inode == 0) then
      write(0,*) 'WFN_fi  kgrid = ', kp%kgrid(1:3)
      write(0,*) 'WFNq_fi kgrid = ', kpq%kgrid(1:3)
    endif
    call die('kgrids for WFN_fi and WFNq_fi must be the same', only_root_writes = .true.)
  endif

  SAFE_ALLOCATE(kpq%elda, (kpq%mnband, kpq%nrk, kpq%nspin))
  kpq%elda(1:kpq%mnband, 1:kpq%nrk, 1:kpq%nspin) = kpq%el(1:kpq%mnband, 1:kpq%nrk, 1:kpq%nspin)
  call scissors_shift(kpq, eqp%scis, eqp%spl_tck)

!-----------------------------------------------------------------------
! If quasi-particle correction requested, read the corrected
! qp energies from file (in eV)

  minband = 1
  bands_cor = kpq%mnband
  if(xct%eqp_corrections) then
    if (flag%opr .eq. 0) then !eqp_q.dat
      bands_cor = maxval(kpq%ifmax(:,:))
    else !eqp.dat
      bands_cor = maxval(kpq%ifmax(:,:)) + xct%ncb_fi
    endif
    bands_cor = min(bands_cor, kpq%mnband)
    minband = minval(kpq%ifmax(:,:)-xct%nvb_fi+1)
    ! FIXME: for metals this is asking for a few more bands than actually needed on some k-points
    call eqpcor(fncor,peinf%inode,peinf%npes,kpq, &
      minband,bands_cor,0,0,kpq%el,kpq%el,kpq%el,1,0)
  endif

  call find_efermi(xct%rfermi, xct%efermi, xct%efermi_input, kpq, bands_cor, minband, &
    "shifted fine grid", should_search = .false., should_update = .false., write7 = .false.)
  
  call read_binary_gvectors(26, gvec%ng, gvec%ng, dummygvec, dont_read = .true.)

  if(any(kpq%ifmax(:,:) == 0)) & 
    call die("BSE codes cannot handle a system where some k-points have no occupied bands.", only_root_writes = .true.) 
 
  kpq%nvband=minval(kpq%ifmax(:,:)-kpq%ifmin(:,:))+1
  kpq%ncband=kpq%mnband-maxval(kpq%ifmax(:,:))

!----------------------------------
! Manual override of band numbers
!
  if (xct%vmax.ne.0) then
    kpq%nvband = xct%vmax-xct%vmin+1
    kpq%ncband = kpq%mnband-xct%vmax
    if (peinf%inode.eq.0) then
      write(6,*)
      write(6,*) '*** Overwrite min/max occupied state for fine grid wavefunctions'
      write(6,*) '*** kpq%nvband =',kpq%nvband,' kpq%ncband =',kpq%ncband
      write(6,*)
    endif
  endif

!----------------------------------------------------------------
! (gsm) check whether the requested number of bands
!       is available in the wavefunction file

! we only use the valence bands from WFNq_fi
! if flag%vm.eq.1.and.flag%dtm.eq.1 we don`t need them at all
! subroutine input_q is only called if flag%vm.ne.1.or.flag%dtm.ne.1

  if(xct%nvb_fi .gt. kpq%nvband) then
    call die("The requested number of valence bands is not available in " // TRUNC(wfnq0) // ".")
  endif
!  if(xct%ncb_fi .gt. kpq%ncband) then
!    call die("The requested number of conduction bands is not available in " // TRUNC(wfnq0) // ".")
!  endif

! DAS: degenerate subspace check

  ! degeneracy does not matter for WFNq_fi in inteqp
  if (peinf%inode.eq.0 .and. xct%is_absorption) then
    broken_degeneracy = .false.
    do jj = 1, kpq%nspin
      do ii = 1, kpq%nrk
        if(kpq%ifmax(ii, jj) - xct%nvb_fi > 0) then
          ! no need to compare against band 0 if all valence are included
          if(abs(kpq%elda(kpq%ifmax(ii, jj) - xct%nvb_fi + 1, ii, jj) &
            - kpq%elda(kpq%ifmax(ii, jj) - xct%nvb_fi, ii, jj)) .lt. TOL_Degeneracy) then
            broken_degeneracy = .true.
          endif
        endif
      enddo
    enddo

    if(broken_degeneracy) then
      if(xct%degeneracy_check_override) then
        write(0,'(a)') &
          "WARNING: Selected number of valence bands breaks degenerate subspace in " // TRUNC(wfnq0) // &
          ". Run degeneracy_check.x for allowable numbers."
        write(0,*)
      else
        write(0,'(a)') &
          "Run degeneracy_check.x for allowable numbers, or use keyword " // &
          "degeneracy_check_override to run anyway (at your peril!)."
        call die("Selected number of valence bands breaks degenerate subspace in " // TRUNC(wfnq0) // ".")
      endif
    endif
  endif

!-----------------------------------------------------------------------
!     Define shifted irreducible BZ, kgq%r, and define the shift vector
!     (if not done before). Make sure it is right!
!
  kgq%nr=kpq%nrk
  SAFE_ALLOCATE(kgq%r, (3,kgq%nr))
  kgq%r(1:3,1:kgq%nr)=kpq%rk(1:3,1:kpq%nrk)
  xct%qshift= sqrt( DOT_PRODUCT(xct%shift(:), MATMUL(crys%bdot,xct%shift(:) )) )
  if (.not. xct%read_kpoints .and. abs(xct%qshift).lt.TOL_Zero) then
    xct%shift(:)=kgq%r(:,1)-kg%r(:,1)
    xct%qshift= sqrt( DOT_PRODUCT(xct%shift(:), MATMUL(crys%bdot,xct%shift(:) )) )
  endif
  ! We only need q_shift for the velocity operator
  if(flag%opr == 0) then
    if(peinf%inode.eq.0) write(6,90) xct%shift(:),xct%qshift
90 format(1x,'Shift vector : ',3f9.5,2x,'Length =',f8.5,/)
    if(xct%qshift < TOL_Small) call die("q-shift vector may not be zero.", only_root_writes = .true.)
  endif

!-----------------------------------------------------------------------
!     Define the polarization vector (used only with momentum operator and absorption)
!
  xct%lpol=sqrt(DOT_PRODUCT(xct%pol,MATMUL(crys%bdot,xct%pol)))
  if (abs(xct%lpol).lt.TOL_Zero) then
    xct%pol = xct%shift(:)
    xct%lpol=sqrt(DOT_PRODUCT(xct%pol,MATMUL(crys%bdot,xct%pol)))
  endif
  if(flag%opr == 1 .and. xct%is_absorption) then
    if(peinf%inode.eq.0) write(6,92) xct%pol(:),xct%lpol
92 format(1x,'Polarization vector : ',3f9.5,2x,'Length =',f8.5,/)
    if(xct%lpol < TOL_Small) call die("Polarization vector may not be zero.", only_root_writes = .true.)
  endif
  
!-----------------------------------------------------------------------
!     Generate full Brillouin zone from irreducible wedge, rk -> fk
!
  if (flag%bzq.eq.1 .and. .not. xct%is_absorption) then
    ! in the inteqp code, we want to leave the k-points alone, if symmetries are not being used.
    call fullbz(crys,symsq,kgq,1,skip_checkbz,wigner_seitz=.false.,paranoid=.false.,do_nothing=.true.)
  else if (flag%bzq.eq.1) then
    call fullbz(crys,symsq,kgq,1,skip_checkbz,wigner_seitz=.true.,paranoid=.true.)
  else
    call fullbz(crys,symsq,kgq,symsq%ntran,skip_checkbz,wigner_seitz=.true.,paranoid=.true.)
  endif
  xct%nkptq_fi = kgq%nf
  tmpfn=wfnq0
  if (.not. skip_checkbz .and. .not.xct%patched_sampling) then
    call checkbz(kgq%nf,kgq%f,kpq%kgrid,kpq%shift,crys%bdot, &
      tmpfn,'k',.true.,xct%freplacebz,xct%fwritebz)
  endif

  if (flag%bzq.eq.0.and.peinf%inode.eq.0) write(6,801)
  if (flag%bzq.eq.1.and.peinf%inode.eq.0) write(6,802)
801 format(1x,'Using symmetries to expand the shifted-grid sampling',/)
802 format(1x,'No symmetries used in the shifted-grid sampling',/)

  SAFE_ALLOCATE(xct%ifmaxq, (kgq%nf,xct%nspin))
  xct%ifmaxq(:,:)=kpq%ifmax(kgq%indr(:),:)

!
!-----------------------------------------------------------------------
!     Find correspondence with fk from WFN_fi
!
!     indexq : correspondence between a k-point in the full BZ, kg%f, and
!       its shifted vector, in kgq%f
!     tol : tolerance
!
  tol = TOL_Small

!-----------------------------------------------------------------------
!      For a test by Cheol Hwan (1.26.05)
!          write(6,*) 'kg%nf =', kg%nf, 'kgq%nf =', kgq%nf,
!     >                 xct%shift(1),xct%shift(2),xct%shift(3)

  do ik=1,kg%nf
    ikq=0
    delta=0.1d0
    do while((delta.gt.tol).and.(ikq.lt.kgq%nf))
      ikq=ikq+1
      
!-----------------------------------------------------------------------
!      For a test by Cheol Hwan (1.26.05)
!         write(6,*) kg%f(1,ik),kg%f(2,ik),kg%f(3,ik),
!     >         kgq%f(1,ikq)-xct%shift(1),kgq%f(2,ikq)-xct%shift(2),
!     >         kgq%f(3,ikq)-xct%shift(3)

      qq(:) = kg%f(:,ik)-(kgq%f(:,ikq)-xct%shift(:))
      do kk=1,3
        qq(kk) = qq(kk) - anint( qq(kk) )
      enddo
      delta=sqrt(sum(qq(1:3)**2))
    enddo
    if(delta.gt.tol) then
      if(peinf%inode.eq.0) then
        write(0,*) 'Could not find point equivalent to ', (kg%f(ii,ik),ii=1,3)
      endif
      call die('k-point mismatch between WFN_fi and ' // TRUNC(wfnq0), only_root_writes = .true.)
    else
!
!     make sure that kgq%f(:,ikq)-kg%f(:,ik) = shift vector
!     Near the zone edge, they may differ by a lattice vector
!
      do jj=1,3
        ii = nint( kgq%f(jj,ikq)-kg%f(jj,ik) )
        kgq%f(jj,ikq) = kgq%f(jj,ikq) - dble(ii)
        kgq%kg0(jj,ikq) = kgq%kg0(jj,ikq) - ii
      enddo
      qq(:) = kg%f(:,ik)-(kgq%f(:,ikq)-xct%shift(:))
      delta=sqrt((qq(1))**2+(qq(2))**2+(qq(3))**2)
      if (delta.gt.tol) then
        call die('k-point mismatch between WFN_fi and ' // TRUNC(wfnq0) // '. Wrong shift')
      endif
      indexq(ik)=ikq
    endif
  enddo

  if(kgq%nf /= kg%nf) then
    if(peinf%inode == 0) write(0,'(a,i7,a,i7,a)') 'WFNq_fi unfolds to ', kgq%nf, &
      ' k-points; WFN_fi unfolds to ', kg%nf, ' k-points.'
    call die("WFNq_fi and WFN_fi must have the same number of k-points in the unfolded BZ.", only_root_writes = .true.)
  endif
  ! Each WFN_fi point only needs one WFNq_fi point. In principle it would be ok to have extra unused WFNq_fi points, but in fact
  ! the subsequent code assumes that there are the same number of points, so we will check that here rather than allow mysterious
  ! segfaults or incorrect results later. --DAS

!-----------------------------------------------------------------------
!     Read the wavefunctions and create INT_VWFNQ_*
!

! JRD: Debugging
!      if (peinf%inode .eq. 0) then
!         write(6,*) 'Creating INT_VWFNQ_* files'
!      end if

  wfnv%nband=xct%nvb_fi
  wfnv%nspin=kpq%nspin
  wfnv%nspinor=kpq%nspinor
  
  if (xct%iwriteint .eq. 0) then
    if(peinf%inode.lt.10000) then
      write(filenamev,'(a,i4.4)') 'INT_VWFNQ_', peinf%inode
    else
      call die("input_q: cannot use more than 10000 nodes")
    endif
    iunit_v=128+(2*peinf%inode)+2
    call open_file(iunit_v,file=filenamev,form='unformatted',status='replace')
  else
    SAFE_ALLOCATE(intwfnv%ng, (peinf%ikt(peinf%inode+1)))
    SAFE_ALLOCATE(intwfnv%isort, (gvec%ng,peinf%ikt(peinf%inode+1)))
    SAFE_ALLOCATE(intwfnv%cgk, (kpq%ngkmax,wfnv%nband,kpq%nspin*kpq%nspinor,peinf%ikt(peinf%inode+1)))
  endif

  SAFE_ALLOCATE(wfnv%isort, (gvec%ng))
  SAFE_ALLOCATE(isend, (peinf%npes))
  wfnv%isort=0
  last_ng=-1
  last_ng_match=-1
  last_ikt=-1
  call progress_init(prog_info, 'reading wavefunctions (WFNq_fi)', 'k-point', kpq%nrk)
  do irkq = 1, kpq%nrk
    call progress_step(prog_info, irkq)
    irkq_match = .false.
    do ii=1,kg%nf
      if (irkq == kgq%indr(indexq(ii))) then
        irkq_match = .true.
        exit
      endif
    enddo

    wfnv%ng = kpq%ngk(irkq)

! FHJ: Realloc arrays. Note that we can`t do something like
!      "if (wfnv%ng>last_ng)"  b/c fortran complains at read_binary_gvectors 
!      if the vectors are not exactly wfnv%ng big.
    if(wfnv%ng/=last_ng) then
      if(last_ng/=-1) then
        SAFE_DEALLOCATE_P(gvec_kpt%components)
        SAFE_DEALLOCATE(cg)
      endif
      SAFE_ALLOCATE(gvec_kpt%components, (3, wfnv%ng))
      SAFE_ALLOCATE(cg, (wfnv%ng, kpq%nspin*kpq%nspinor))
      last_ng = wfnv%ng
    endif

    call read_binary_gvectors(26, wfnv%ng, wfnv%ng, gvec_kpt%components)

!    Skip this k-point if there is no k-point in kg%f that
!    corresponds to it
    if(irkq_match) then
      do ii = 1, kpq%ngk(irkq)
        call findvector(wfnv%isort(ii), gvec_kpt%components(:, ii), gvec)
        if(wfnv%isort(ii) == 0) call die('input_q: could not find gvec')
      enddo

! FHJ: Realloc arrays.
      if(wfnv%ng/=last_ng_match) then
        if(last_ng_match/=-1) then
          SAFE_DEALLOCATE_P(wfnv%cg)
          SAFE_DEALLOCATE(cgarray)
        endif
        SAFE_ALLOCATE(wfnv%cg, (wfnv%ng, wfnv%nband, wfnv%nspin*wfnv%nspinor))
        SAFE_ALLOCATE(cgarray, (wfnv%ng))
        last_ng_match = wfnv%ng
      endif        
      if(peinf%ikt(peinf%inode+1)/=last_ikt) then
        if(last_ikt/=-1) then
          SAFE_DEALLOCATE(iwriteik)
        endif
        SAFE_ALLOCATE(iwriteik,(peinf%ikt(peinf%inode+1)))
        last_ikt = peinf%ikt(peinf%inode+1)
      endif

!       Determine which PEs will write the valence bands for this k-point
      iwrite=0
      iwritetotal=0
      iwriteik=0
      do ii=1, peinf%ikt(peinf%inode+1)
        if(kgq%indr(indexq(peinf%ik(peinf%inode+1,ii))) == irkq) then
          iwritetotal=iwritetotal+1
          iwriteik(iwritetotal)=ii
          iwrite=1
        endif
      enddo

!       Determine to which PEs the valence bands for this k-point
!       need to be sent...
      isend=0
      if(peinf%inode.eq.0) then
        do jj=2,peinf%npes
          do ii=1, peinf%ikt(jj)
            if(kgq%indr(indexq(peinf%ik(jj,ii))) == irkq) then
              isend(jj)=1
              exit
            endif
          enddo
        enddo
      endif
    endif
!
!       Loop over the bands
!
    do ii=1,kpq%mnband
      call read_binary_data(26, kpq%ngk(irkq), kpq%ngk(irkq), kpq%nspin*kpq%nspinor, cg, bcast=.false.)

      if(.not. irkq_match) cycle

      do is=1, kpq%nspin
!         If ii is one of the selected valence bands...
        if((ii.le.kpq%ifmax(irkq,is).and. &
          ii.gt.kpq%ifmax(irkq,is)-xct%nvb_fi)) then

          do ispinor=1, kpq%nspinor
            if (peinf%inode.eq.0) then
              cgarray(1:kpq%ngk(irkq))=cg(1:kpq%ngk(irkq), is*ispinor)
#ifdef VERBOSE
              write(*,'(a, 3i7, 2(f18.13))') 'input_q', irkq, ii, is*ispinor, cgarray(1)
#endif
            end if
#ifdef MPI
            if(peinf%inode.eq.0) then
              do jj=2,peinf%npes
                if(isend(jj).eq.1) then
                  dest=jj-1
                  tag=1000+dest*2-(is-1)
                  call MPI_SEND(cgarray,kpq%ngk(irkq),MPI_SCALAR, &
                    dest,tag,MPI_COMM_WORLD,mpierr)
                endif
              enddo
            else
              if(iwrite.eq.1) then
                tag=1000+peinf%inode*2-(is-1)
                call MPI_RECV(cgarray,kpq%ngk(irkq),MPI_SCALAR,0,tag, &
                  MPI_COMM_WORLD,mpistatus,mpierr)
              endif
            endif
#endif
            if(iwrite.eq.1) then
              wfnv%cg(1:wfnv%ng,kpq%ifmax(irkq,is)-ii+1,is*ispinor) = cgarray
            endif
          enddo
          if(iwrite.eq.1) then
            !FHJ: We only Send/Recv and check one spin at a time
            call checknorm(wfnq0,ii,irkq,kpq%ngk(irkq),is,kpq%nspinor,&
                         wfnv%cg(:,kpq%ifmax(irkq,is)-ii+1,:))
          endif
        end if
      end do
    enddo

    if(.not. irkq_match) cycle
    
    if(iwrite.eq.1) then
      if (xct%iwriteint .eq. 0) then
        write(iunit_v) irkq,wfnv%ng,wfnv%nband,wfnv%nspin,wfnv%nspinor
        write(iunit_v) (wfnv%isort(ii),ii=1,gvec%ng), &
          (((wfnv%cg(ii,jj,kk),ii=1,wfnv%ng),jj=1,wfnv%nband), kk=1,wfnv%nspin*wfnv%nspinor)
      else
        do ijk = 1, iwritetotal
          intwfnv%ng(iwriteik(ijk))=wfnv%ng
          intwfnv%isort(:,iwriteik(ijk))=wfnv%isort(:)
          intwfnv%cgk(1:wfnv%ng,:,:,iwriteik(ijk))=wfnv%cg(1:wfnv%ng,:,:)
        enddo
      endif
    endif
  enddo
  call progress_free(prog_info)

  SAFE_DEALLOCATE(isend)
  SAFE_DEALLOCATE_P(wfnv%isort)

  if(last_ikt/=-1) then
    SAFE_DEALLOCATE(iwriteik)
  endif
  if(last_ng_match/=-1) then
    SAFE_DEALLOCATE_P(wfnv%cg)
    SAFE_DEALLOCATE(cgarray)
  endif
  if(last_ng/=-1) then
    SAFE_DEALLOCATE_P(gvec_kpt%components)
    SAFE_DEALLOCATE(cg)
  endif
      
!
! End loop over k-points
!--------------------------------------------------------------------------------
           
! JRD: For Finite Q we need valence energies
! FHJ: loop thru indices on `eqp` grid, and then find the
!      corresponding labels on the shifted grid
  do is=1,xct%nspin
    do irk=1,xct%nkpt_fi
      !irkq = index of q-pt on shifted grid
      irkq = kgq%indr(indexq(irk))

      !loop thru bands of shifted grid
      do ibq=1, kpq%mnband

        !ib = band index on `eqp` grid
        ib = kpq%ifmax(irkq,is) - ibq + 1

        if ( (ib > 0) .and. (ib <= xct%nvb_fi) ) then
          eqp%evqp (ib, irk, is) = kpq%el(ibq, irkq, is)
          eqp%evlda(ib, irk, is) = kpq%elda(ibq, irkq, is) 
        endif

      enddo
    enddo
  enddo

!-----------------------------
! Deallocate

  SAFE_DEALLOCATE_P(kpq%ifmin)
  SAFE_DEALLOCATE_P(kpq%ifmax)
  SAFE_DEALLOCATE_P(kpq%rk)
  SAFE_DEALLOCATE_P(kpq%el)
  SAFE_DEALLOCATE_P(kpq%elda)


! JRD: Debugging
!      if (peinf%inode .eq. 0) then
!         write(6,*) 'Deallocated arrays'
!      end if

!-----------------------------
! Write out info about xtal

  if(peinf%inode.eq.0) then
    write(6,'(/,1x,a,a)') 'Valence wavefunctions read from file ',TRUNC(wfnq0)
    write(6,'(1x,a,i8)') ' - Number k-points in irreducible BZ: ', kgq%nr
    write(6,'(1x,a,i8)') ' - Number k-points in full BZ: ', kgq%nf
#ifdef VERBOSE
    write(6,'(/,1x,a)') 'Listing all k-points:'
    write(6,'(3x,3f15.9)') ((kgq%r(ii,jj),ii=1,3),jj=1,kgq%nr)
    write(6,'(1x,a,/)') 'Done listing k-points'
#endif
    call close_file(26)
  endif ! node 0

  if (xct%iwriteint .eq. 0) call close_file(iunit_v)

  POP_SUB(input_q)

  return
end subroutine input_q

#include "f_defs.h"

!-----------------------------------------------------------------------
subroutine input_q(crys,gvec,kg,kgq,syms,xct,indexq,pxct)
!-----------------------------------------------------------------------
!
!     input: crys, gvec, kg,  syms, xct types
!
!     output: kgq type
!             indexq(1:xct%nkpt_fi_fi) : mapping of points in shifted grid
!             INT_VWFNQ_* files
!
  use global_m
  use checkbz_m
  use fullbz_m
  use misc_m
  use wfn_rho_vxc_io_m
  use plotxct_common_m
  use input_common_m
  implicit none

  type (crystal), intent(in) :: crys
  type (gspace), intent(in) :: gvec
  type (grid), intent(in) :: kg
  type (grid), intent(out) :: kgq
  type (symmetry), intent(in) :: syms
  type (xctinfo), intent(inout) :: xct
  integer, intent(out) :: indexq(xct%nkpt_fi)
  type (plotxct_t), intent(in) :: pxct

  type (input_reader_t) :: inp !< the input reader `object`
  type (crystal) :: crysq
  type (kpoints) :: kpq
  type (symmetry) :: symsq
  character :: filenamev*20
  character :: tmpfn*16, errmsg*100
  integer :: iunit_v,dummygvec(1,1)
  logical :: send_any !< = any(send_to)
  integer :: ii,jj,ik,ikq,irkq
  logical :: irkq_match
  real(DP) :: delta,qq(3),tol

  character(len=3) :: sheader
  integer :: iflavor
  type(gspace) :: gvecq

  logical :: skip_checkbz
  
  PUSH_SUB(input_q)

!-----------------------------------------------------------------------
!     Read data in WFNq_fi

  if(peinf%inode.eq.0) call open_file(unit=26,file='WFNq_fi',form='unformatted',status='old')

  sheader = 'WFN'
  iflavor = 0
  call read_binary_header_type(26, sheader, iflavor, kpq, gvecq, symsq, crysq, warn = .false.)

  call check_header('WFN_fi', kpq, gvec, syms, crys, 'WFNq_fi', kpq, gvecq, symsq, crysq, is_wfn = .true.)
  ! there is no kp object in this code??

  kpq%nvband=minval(kpq%ifmax(:,:)-kpq%ifmin(:,:))+1
  if(xct%nvb_fi.gt.kpq%nvband) then
    write(errmsg,'(a,i6,a,i6,a)') 'You requested ', xct%nvb_fi, ' valence bands but WFNq_fi contains only ', kpq%nvband, '.'
    call die(errmsg, only_root_writes = .true.)
  endif
  
  call read_binary_gvectors(26, gvec%ng, gvec%ng, dummygvec, dont_read = .true.)

!
!     Define shifted irreducible BZ, kgq%r, and define the shift vector
!     (if not done before). Make sure it is right!
!
  kgq%nr=kpq%nrk
  SAFE_ALLOCATE(kgq%r, (3,kgq%nr))
  kgq%r(1:3,1:kgq%nr)=kpq%rk(1:3,1:kpq%nrk)
  xct%qshift= sqrt( DOT_PRODUCT(xct%shift(:), &
    MATMUL(crys%bdot,xct%shift(:) )) )
  if (xct%qshift.eq.0.d0) then
    xct%shift(:)=kgq%r(:,1)-kg%r(:,1)
    xct%qshift= sqrt( DOT_PRODUCT(xct%shift(:), &
      MATMUL(crys%bdot,xct%shift(:) )) )
  endif
  if(peinf%inode.eq.0) write(6,90) xct%shift(:),xct%qshift
90 format(/,2x,'Shift vector : ',3f9.5,2x,'Length =',f8.5,/)

!-----------------------------------------------------------------------
!     Generate full brillouin zone from irreducible wedge, rk -> fk

  if (.not.pxct%unfoldq) then
    call fullbz(crys,symsq,kgq,1,skip_checkbz,wigner_seitz=.true.,paranoid=pxct%bz_paranoid)
  else
    call fullbz(crys,symsq,kgq,symsq%ntran,skip_checkbz,wigner_seitz=.true.,paranoid=pxct%bz_paranoid)
  endif
  tmpfn='WFNq_fi'
  if (.not. skip_checkbz) then
    call checkbz(kgq%nf,kgq%f,kpq%kgrid,kpq%shift,crys%bdot, &
      tmpfn,'k',.true.,xct%freplacebz,xct%fwritebz)
  endif
  call logit('input_q:  done unfolding/checking BZ')

!-----------------------------------------------------------------------
!     Find correspondence with fk from WFNq_fi
!
!     indexq : correspondence between a k-point in the full BZ, kg%f, and
!       its shifted vector, in kgq%f
!     tol : tolerance

  tol = 1.d-6
  do ik=1,kg%nf
    ikq=0
    delta=0.1d0
    do while((delta.gt.tol).and.(ikq.lt.kgq%nf))
      ikq=ikq+1
      qq(:) = kg%f(:,ik)-(kgq%f(:,ikq)-xct%shift(:))
      qq(:) = qq(:) - anint( qq(:) )
      delta=sqrt(sum(qq(:)**2))
    enddo
    if(delta.gt.tol) then
      if(peinf%inode.eq.0) then
        write(0,'(a,3f12.6)') 'Could not find point equivalent to ', (kg%f(ii,ik),ii=1,3)
      endif
      call die('k-point mismatch between WFN_fi and WFNq_fi.', only_root_writes = .true.)
    else
!
!     make sure that kgq%f(:,ikq)-kg%f(:,ik) = shift vector
!     Near the zone edge, they may differ by a lattice vector
!
      do jj=1,3
        ii = nint( kgq%f(jj,ikq)-kg%f(jj,ik) )
        kgq%f(jj,ikq) = kgq%f(jj,ikq) - dble(ii)
        kgq%kg0(jj,ikq) = kgq%kg0(jj,ikq) - ii
      enddo
      qq(:) = kg%f(:,ik)-(kgq%f(:,ikq)-xct%shift(:))
      delta=sqrt(sum(qq(:)**2))
      if (delta.gt.tol) then
        call die('k-point mismatch between WFN_fi and WFNq_fi. Wrong shift', only_root_writes = .true.)
      endif
      indexq(ik)=ikq
    endif
  enddo
  call logit('input_q:  done mapping kpts (1)')

!-----------------------------------------------------------------------
!     Read the wavefunctions and create INT_VWFNQ_*

  call logit('input_q:  reading WFNq_fi')

  if(peinf%inode.lt.10000) then
    write(filenamev,'(a,i4.4)') 'INT_VWFNQ_', peinf%inode
  else
    call die('input_q: cannot use more than 10000 nodes')
  endif
  iunit_v=128+(2*peinf%inode)+2
  call open_file(iunit_v,file=filenamev,form='unformatted',status='replace')

  !FHJ : set up input reader `object`
  call init_reader(inp, 26, iunit_v, 'WFNq_fi', kpq, xct, gvec)

  do irkq = 1, kpq%nrk

    inp%ng = kpq%ngk(irkq)

    ! FHJ: this scales as nk^2, but could scale as nk*log(nk)
    irkq_match = .false.
    do ii=1,kg%nf
      if (irkq == kgq%indr(indexq(ii))) then
        irkq_match = .true.
        exit
      endif
    enddo

    ! FHJ: Determine to which PE the wavefunctions for this k-point need to be sent.
    send_any = .false.
    inp%send_to(:) = .false.
    do jj=1,peinf%npes
      do ii=1, peinf%ikt(jj)
        if(kgq%indr(indexq(peinf%ik(jj,ii))).eq.irkq) then
          inp%send_to(jj) = .true.
          send_any = .true.
          exit
        endif
      enddo
    enddo

    ! FHJ: Don`t bother reading data if we don`t need the kpt
    if((.not. send_any) .or. (.not. irkq_match)) then
      call skip_kpt(inp)
      cycle
    endif

    ! FHJ: Read gvectors` indices, store in inp%isort
    call read_gvecs(inp, irkq, gvec)

    ! FHJ: Read all bands and distribute
    call read_bands(inp, irkq)

  enddo !end loop over k-points

  call free_reader(inp)
  
  if (peinf%inode.eq.0) then
    SAFE_DEALLOCATE_P(kpq%rk)
    SAFE_DEALLOCATE_P(kpq%ifmin)
    SAFE_DEALLOCATE_P(kpq%ifmax)
    SAFE_DEALLOCATE_P(kpq%el)
  endif
  
!-------------------------------
! Write out info about xtal

  if(peinf%inode.eq.0) then
    write(6,4004)
4004 format(/,2x,'crystal wavefunctions read from unit WFNq_fi')
    write(6,3007) kgq%nr
3007 format(/,6x,'nrk= ',i6,26x)
    write(6,3070) kgq%nf,kgq%sz
3070 format(/,6x,'  fine grid     nfk= ',i6,4x,'ksz=',f10.5)
    
    call close_file(26)
  endif !end if(inode.eq.0)
  
  call close_file(iunit_v)

  ! only needed for comm_disk
#ifdef MPI
  call MPI_Barrier(MPI_COMM_WORLD, mpierr)
#endif
  call logit('input_q:  done reading WFNq_fi')

  POP_SUB(input_q)

  return
end subroutine input_q

!===============================================================================
!
! Routines:
!
! 1. groupk()        Originally By gsm       Last Modified 8/31/2010 (gsm)
!
!    Generates symmetries of the k-point.
!
!===============================================================================

#include "f_defs.h"

module groupk_m

  use global_m
  implicit none

  private

  public :: groupk

contains

subroutine groupk(kvec,nsyml,rotl,nsymk,rotk)
  real(DP), intent(in) :: kvec(:) !< (3)
  integer, intent(in) :: nsyml
  integer, intent(in) :: rotl(:,:,:) !< (3,3,48)
  integer, intent(out) :: nsymk
  integer, intent(out) :: rotk(:,:,:) !< (3,3,48)
  
  integer :: isyml
  real(DP) :: krot(3)
  
  PUSH_SUB(groupk)

  nsymk=0
  do isyml=1,nsyml
    krot(1:3) = matmul(dble(rotl(1:3, 1:3, isyml)), kvec(1:3))
    if (all(abs(krot(1:3)-kvec(1:3)).lt.TOL_Small)) then
      nsymk=nsymk+1
      rotk(1:3, 1:3, nsymk) = rotl(1:3, 1:3, isyml)
    endif
  enddo
  
  POP_SUB(groupk)
  return  
end subroutine groupk

end module groupk_m

!=============================================================================
!
! Module:
!
! (1) intwfn()  Originally By MLT               Last Modified 7/8/2008 (JRD)
!
!     Evaluate the transformation matrices and store them
!     in the arrays dcc,dvv.
!     The matrices are defined according to eq. (39) of Rohlfing & Louie:
!
!     dcc(ic,jc,ik,is,ivert) == d_{ic,ik}^{\tilde jc,\tilde jk)
!        ik: index of k-point in fine grid
!        ic: index of cond. band in fine grid
!        jk: index of k-point in coarse grid, fi2co_wfn(ivert,ik)=jk
!        jc: index of cond. band in coarse grid
!        is: spin index (the same in both grids)
!
!     dvv(iv,jv,ik,is,ivert) == d_{iv,ik}^{\tilde jv,\tilde jk)
!        ik: index of k-point in fine grid
!        iv: index of valence band in fine grid
!        jk: index of k-point in coarse grid, fi2co_wfn(ivert,ik)=jk
!        jv: index of valence band in coarse grid
!        is: spin index (the same in both grids)
!
!     Mixing between valence/conduction states is taken into account
!     by allowing jc to be also an occupied band, and similarly
!     for jv.
!
!     input: crys,syms,xct,gvec,kg_fi,kgq_fi types
!            indexq_fi (mapping between shifted and unshifted k-points)
!
!     output: dcc,dvv arrays
!             kco array
!             fi2co_wfn array
!
!===============================================================================

#include "f_defs.h"

module intwfn_m

  use global_m
  use fullbz_m
  use genwf_m
  use intpts_m
  use interp_m
  use mtxel_t_m
  use io_utils_m
  use misc_m

  implicit none

  private

  public :: intwfn

contains

subroutine intwfn(kp,crys,syms,xct,flag,gvec,kg_fi,kgq_fi, &
  dcc,dvv,kco,fi2co_wfn,indexq_fi,eqp,intwfnv,intwfnc,intp_coefs)
  type (kpoints), intent(inout) :: kp
  type (crystal), intent(in) :: crys
  type (symmetry), intent(in) :: syms
  type (xctinfo), intent(inout) :: xct
  type (flags), intent(in) :: flag
  type (gspace), intent(in) :: gvec
  type (grid), intent(in) :: kg_fi
  type (grid), intent(in) :: kgq_fi
  !> (xct%ncb_fi,xct%n2b_co,xct%nspin,xct%nkpt_fi,xct%npts_intp_kernel) Interp coefs.
  SCALAR, intent(out), target :: dcc(:,:,:,:,:)
  !> (xct%nvb_fi,xct%n1b_co,xct%nspin,xct%nkpt_fi,xct%npts_intp_kernel) Interp coefs.
  SCALAR, intent(out), target :: dvv(:,:,:,:,:)
  real(DP), intent(out) :: kco(:,:) !< 3,xct%nkpt_co
  integer, intent(out) :: fi2co_wfn(:,:) !< (xct%npts_intp_kernel, xct%nkpt_fi)
  integer, intent(in) :: indexq_fi(:) !< xct%nkpt_fi
  type (eqpinfo), intent(inout) :: eqp
  type (int_wavefunction), intent(inout) :: intwfnc
  type (int_wavefunction), intent(inout) :: intwfnv
  !> (xct%npts_intp_kernel, xct%nkpt_fi) Delaunay/greedy interpolation coefficients
  real(DP), intent(out) :: intp_coefs(:,:)

  integer :: closepts(4)
  real(DP) :: closeweights(4)
  type(work_genwf) :: work, workq, workco, workcoq
  type (grid) :: kg_co, kg_co_q
  type (wavefunction) :: wfnc_co,wfnc_fi
  type (wavefunction) :: wfnv_co,wfnvq_fi
  type (tdistgwf) :: distgwfco,distgwfcoq

  integer :: ik,ikt,ik_co,ik_fi,ikq_fi,vunit,eqp_dat_size
  integer :: ik_co_q, igumkq, ijk, ivert
  integer :: ic,ic_co,ic_fi,iv,iv_co,iv_fi,is
  integer :: ii,jj,kk,gumk(3),igumk
  real(DP) :: dist,qg(3),dnorm,tempshift,tempsum,dweight,worst_normc, worst_normv
  real(DP), allocatable :: normc(:,:,:,:),normv(:,:,:,:)
  integer, allocatable :: idum(:,:)
  SCALAR, allocatable :: dummy(:,:,:,:,:)
  real(DP), allocatable :: edummy(:,:,:),  dummy_coefs(:,:)
  integer, allocatable :: indexq_co(:)
  type(interp_t) :: wfn_interp
  !> (xct%nvb_fi, xct%n1b, xct%nspin, xct%nkpt_fi, xct%npts_intp_kernel)
  !> dvn points to dvv if we are restricting the transf right away,
  !! or if we never restrict it (i.e., extended_kernel==.true.). Otherwise,
  !! we allocate a buffer, calculate the unrestricted transf, and restrict+copy
  ! dvn to dvv later on.
  SCALAR, pointer :: dvn(:,:,:,:,:) 
  SCALAR, pointer :: dcn(:,:,:,:,:) !< See: dvn
  !> .true. if we calculate the unrestricted transformation, but the kernel is
  !! restricted (i.e., we`ll have to truncate the dvn to dvv later on).
  logical :: truncate_coefs
  type(progress_info) :: prog_info

  PUSH_SUB(intwfn)

  ! FHJ: Normally, xct%n1b_co depends only on xct%extended_kernel. However,
  ! we`ll temporarily overwrite this value depending on xct%unrestricted_transf
  ! till the end of the subroutine, because if xct%unrestricted_transf==.true,
  ! intwfn "thinks" it`s dealing with an extended kernel when calculating dvn/dcn.
  if (xct%unrestricted_transf) then
    xct%n1b_co = xct%nvb_co + xct%ncb_co
    xct%n2b_co = xct%n1b_co
  else
    xct%n1b_co = xct%nvb_co
    xct%n2b_co = xct%ncb_co
  endif
  truncate_coefs = xct%unrestricted_transf.and.(.not.xct%extended_kernel)
  if (truncate_coefs) then
    ! FHJ: we`ll restrict the coefficients later on, but we want to do the
    ! right expansion here => need a temp buffer.
    SAFE_ALLOCATE(dvn, (xct%nvb_fi, xct%n1b_co, xct%nspin, xct%nkpt_fi, xct%npts_intp_kernel))
    SAFE_ALLOCATE(dcn, (xct%ncb_fi, xct%n2b_co, xct%nspin, xct%nkpt_fi, xct%npts_intp_kernel))
    dvn = 0.d0
    dcn = 0.d0
  else
    ! FHJ: we either do not restrict, or restrict right from the beginning.
    dvn => dvv
    dcn => dcc
  endif
  dcc = 0.d0
  dvv = 0.d0

  SAFE_ALLOCATE(normc, (xct%nkpt_fi,xct%ncb_fi,xct%nspin,xct%npts_intp_kernel))
  SAFE_ALLOCATE(normv, (xct%nkpt_fi,xct%nvb_fi,xct%nspin,xct%npts_intp_kernel))
  SAFE_ALLOCATE(indexq_co, (xct%nkpt_co))
  intp_coefs = 0d0
  fi2co_wfn = 0
  if (flag%read_dtmat) then
    if (peinf%inode.eq.0) then

!-------------------------------
! Read transformation matrices, if they exist...
! FHJ: TODO - test this part for xct%unrestricted_transf=.true.

      if (xct%unrestricted_transf) then
        write(6,*) 'Reading dcn,dvn matrices from file'
      else
        write(6,*) 'Reading dcc,dvv matrices from file'
      endif
      
! Check if dtmat has the right parameters

      call open_file(unit=13,file='dtmat',form='unformatted',status='old')
      read(13)
      read(13) ik_co,ic_co,iv_co,ik,ic_fi,iv_fi,is

      if(ik_co /= xct%nkpt_co) then
        write(0,*) 'File has ', ik_co, '; we need ', xct%nkpt_co
        call die("dtmat does not have the correct number of k-points in coarse grid")
      endif
      if(ic_co /= xct%n2b_co) then
        write(0,*) 'File has ', ic_co, '; we need ', xct%n2b_co
        call die("dtmat does not have the correct number of conduction bands in coarse grid")
      endif
      if(iv_co /= xct%n1b_co) then
        write(0,*) 'File has ', iv_co, '; we need ', xct%n1b_co
        call die("dtmat does not have the correct number of valence bands in coarse grid")
      endif
      if(ik /= xct%nkpt_fi) then
        write(0,*) 'File has ', ik, '; we need ', xct%nkpt_fi
        call die("dtmat does not have the correct number of k-points in fine grid")
      endif
      if(ic_fi /= xct%ncb_fi) then
        write(0,*) 'File has ', ic_fi, '; we need ', xct%ncb_fi
        call die("dtmat does not have the correct number of conduction bands in fine grid")
      endif
      if(iv_fi /= xct%nvb_fi) then
        write(0,*) 'File has ', iv_fi, '; we need ', xct%nvb_fi
        call die("dtmat does not have the correct number of valence bands in fine grid")
      endif
      if(is /= xct%nspin) then
        write(0,*) 'File has ', is, '; we need ', xct%nspin
        call die("dtmat does not have the correct number of spins")
      endif
          
! kco(1:3,1:xct%nkpt_co) has the coordinates of k-points in
! the coarse grid used to generate "dtmat" (in general, this
! is equal to kg_co%fk(1:3,1:xct%nkpt_co) of a previous run)
!
! fi2co_wfn(1:xct%nkpt_fi) is a mapping array between a point in
! the fine grid and the closest ones in the coarse grid

      do jj = 1, xct%nkpt_co
        read(13) kco(1,jj),kco(2,jj),kco(3,jj)
      enddo
      do ivert = 1, xct%npts_intp_kernel
        do jj = 1, xct%nkpt_fi * xct%ncb_fi * xct%n2b_co * xct%nspin
          read(13) ik_fi,ic_fi,ik_co,ic_co,is,dcn(ic_fi,ic_co,is,ik_fi,ivert)
        enddo
      enddo
      do ivert = 1, xct%npts_intp_kernel
        do jj = 1, xct%nkpt_fi * xct%nvb_fi * xct%n1b_co * xct%nspin
          read(13) ik_fi,iv_fi,ik_co,iv_co,is,dvn(iv_fi,iv_co,is,ik_fi,ivert)
          fi2co_wfn(ivert,ik_fi) = ik_co
        enddo
      enddo

      intp_coefs(:,:) = 1d0
      if (xct%npts_intp_kernel>1) then
        read(13) intp_coefs(:,:)
      endif
      call close_file(13)
    endif

! PE # 0 distribute data

#ifdef MPI
    call MPI_BCAST(fi2co_wfn(1,1), xct%npts_intp_kernel*xct%nkpt_fi, MPI_INTEGER, 0, MPI_COMM_WORLD,mpierr)
    call MPI_BCAST(kco, 3*xct%nkpt_co, MPI_REAL_DP, 0, MPI_COMM_WORLD,mpierr)
    call MPI_BCAST(dcn(1,1,1,1,1), xct%nkpt_fi*xct%ncb_fi*xct%n2b_co*xct%nspin*xct%npts_intp_kernel, &
      MPI_SCALAR, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(dvn(1,1,1,1,1), xct%nkpt_fi*xct%nvb_fi*xct%n1b_co*xct%nspin*xct%npts_intp_kernel, &
      MPI_SCALAR, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(intp_coefs(1,1), xct%npts_intp_kernel*xct%nkpt_fi, MPI_REAL_DP, 0, MPI_COMM_WORLD,mpierr)
#endif

  else

!-------------------------------
! ...Otherwise, start the computation of them

! Read the wavefunctions on the coarse grid and initialize dtmat

    if (xct%qflag .eq. 0) then
      if (peinf%inode .eq. 0) then
        write(6,999)
      endif
    endif
999 format(/,1x,'We are doing a Finite Q Calculation',/)

    call timacc(41, 1)
    call input_co(kp,crys,gvec,kg_co,syms,xct,flag%bzc,distgwfco,eqp)
    call timacc(41, 2)

!---------------------------------------------------- 
! If skip_interpolation keyword is present don`t interpolate

    if (xct%skipinterp) then

      intp_coefs = 1d0
      if (peinf%inode.eq.0) then
        write(6,'(a)') ' Skipping interpolation'
        write(6,'(a)')
      endif

      do ii = 1, xct%nkpt_fi
        do jj = 1, xct%nkpt_co
          if (all(abs(kg_fi%f(1:3,ii)-kg_co%f(1:3,jj)) .lt. TOL_Small)) then
            fi2co_wfn(1,ii)=jj
            kco(1:3,jj)=kg_co%f(1:3,jj)
          endif
        enddo
      enddo

      dcn(:,:,:,:,:) = 0d0
      do ik = 1, xct%nkpt_fi
        do is = 1, xct%nspin
          do ic = 1, xct%ncb_co
            dcn(ic,ic,is,ik,1) = 1d0
          enddo
        enddo
      enddo
      dvn(:,:,:,:,:) = 0d0
      do ik = 1, xct%nkpt_fi
        do is = 1, xct%nspin
          do iv = 1, xct%nvb_co
            dvn(iv,iv,is,ik,1) = 1d0
          enddo
        enddo
      enddo

    else ! xct%skipinterp

      call timacc(42, 1)
      if (xct%delaunay_interp) then
        call interp_init(wfn_interp, crys, kg_co%f, dims=xct%idimensions, &
          periodic=.true., active_dims=xct%is_periodic)
      else
        call alloc_intpts(kg_co%nf, kg_co%f(:,:), periodic=.true.)
      endif
      call timacc(42, 2)

!---------------------------------------------------- 
! JRD: If we do finite Q we need the coarse Q shifted grid wavefunctions

      if (xct%qflag .eq. 0) then
        call timacc(41, 1)
        call input_co_q(kp,crys,gvec,kg_co_q,syms,xct,flag%bzc, &
          indexq_co,kg_co,distgwfcoq)
        call timacc(41, 2)
      else
        do ijk = 1, xct%nkpt_co
          indexq_co(ijk) = ijk
        enddo
      endif
      
      do kk=1,xct%nkpt_co
        kco(:,kk) = kg_co%f(:,kk)
      enddo
      
      if (peinf%inode.eq.0) then
        call open_file(unit=13,file='dtmat',form='unformatted',status='replace')
        write(13) xct%idimensions, xct%is_periodic(1:3), xct%npts_intp_kernel, xct%nkpt_co
        write(13) xct%nkpt_co,xct%n2b_co,xct%n1b_co, &
          xct%nkpt_fi,xct%ncb_fi,xct%nvb_fi,xct%nspin,xct%npts_intp_kernel
        do kk=1,xct%nkpt_co
          write(13) (kco(ii,kk),ii=1,3)
        enddo
        call close_file(13)
      endif

!-------------------------
! Loop over k-points in fine grid
  
      if (xct%inteqp) then
        SAFE_ALLOCATE(eqp%evshift, (xct%nvb_fi,kg_fi%nf,xct%nspin))
        SAFE_ALLOCATE(eqp%ecshift, (xct%ncb_fi,kg_fi%nf,xct%nspin))
        eqp%evshift=0D0
        eqp%ecshift=0D0
      endif

     call progress_init(prog_info, 'wavefunction interpolation', 'k-point', &
      peinf%nkpe)
      do ii=1,peinf%nkpe
        call progress_step(prog_info)
        ik_fi=peinf%ik(peinf%inode+1,ii)

! JRD: Find the points in coarse grid closest to each point in the fine grid
! We need 4 points here for 3D

        if (ik_fi .ne. 0) then
          ikq_fi = indexq_fi(ik_fi)
        else
          ! this process has no work to do
          ikq_fi = 0
        endif
          
! JRD: In principle, we should be calling the below function twice. Once for ik_fi and once for ikq_fi. If using 
! momentum operator, it makes no difference. And for velocity operator, it makes insignificant difference for typical small q`s.

        if (kg_co%nf .gt. 1 .and. ik_fi > 0) then
          call timacc(42, 1)
          if (xct%delaunay_interp) then
            call interp_eval(wfn_interp, kg_fi%f(:,ik_fi), closepts(:), closeweights(:))
          else
            call intpts_local(crys, kg_fi%f(:,ik_fi), kg_co%nf, kg_co%f(:,:), &
              xct, closepts(:), closeweights(:), periodic=.true.)
          endif
          if (xct%npts_intp_kernel>1) then
            intp_coefs(:,ik_fi) = closeweights(1:xct%npts_intp_kernel)
          else
            intp_coefs(1,ik_fi) = 1d0
          endif
          call timacc(42, 2)
        else
          closepts(:)=1
          closeweights(:)=0D0
          closeweights(1)=1D0
          if (ik_fi>0) intp_coefs(1,ik_fi) = 1d0
        endif

        do ijk = xct%idimensions + 1, 1, -1
          
          ik_co=closepts(ijk)
          dweight=closeweights(ijk)
          
          if (xct%qflag .eq. 0) then
            ik_co_q=indexq_co(ik_co)
          else
            ik_co_q=ik_co
          endif

          ! Store the umklapp G-vector, if not zero
          if (ik_fi .ne. 0) then
            qg(:)=kg_fi%f(:,ik_fi)-kg_co%f(:,ik_co)
            gumk(:)=nint(qg(:))
            call findvector(igumk, gumk, gvec)

            ! Store the umklapp G-vector, if not zero - Finite Q
            if (xct%qflag .eq. 0) then
              qg(:)=kgq_fi%f(:,ik_fi)-kg_co_q%f(:,ik_co_q)
              gumk(:)=nint(qg(:))
              call findvector(igumkq, gumk, gvec)
            else
              igumkq=igumk
            endif
          endif
      
!------------------------------
! Read needed wavefunctions: conduction bands from unshifted grid
! and valence bands from shifted grid

          if (ik_fi .ne. 0) then
            call timacc(43, 1)
            ! Need to initialize nspinor value for genwf
            intwfnc%nspinor=kp%nspinor
            intwfnv%nspinor=kp%nspinor
            call genwf(crys,gvec,kg_fi,syms,wfnc_fi,xct,ik_fi,ik_fi,work,intwfnc, is_cond = .true.)
            call genwf(crys,gvec,kgq_fi,syms,wfnvq_fi,xct,ik_fi,ikq_fi,workq,intwfnv, is_cond = .false.)
            call timacc(43, 2)
          endif
          
          if (xct%qflag .eq. 0) then
            call timacc(44, 1)
            call genwf_co(crys,gvec,kg_co,kg_co_q,syms,wfnc_co, &
              wfnv_co,xct,ik_co,ik_co_q,distgwfco,distgwfcoq,workco,workcoq)
            call timacc(44, 2)
          else
            call timacc(44, 1)
            call genwf_co(crys,gvec,kg_co,kg_co_q,syms,wfnc_co, &
              wfnv_co,xct,ik_co,ik_co_q,distgwfco,distgwfco,workco,workcoq)
            call timacc(44, 2)
          endif

          if (ik_fi .ne. 0) then
            call timacc(45, 1)
            ivert = 1
            if (xct%npts_intp_kernel>1) ivert = ijk
            call mtxel_t(gvec,wfnc_co, wfnc_fi, wfnv_co, wfnvq_fi, &
              dcn(:,:,:,ik_fi,ivert), dvn(:,:,:,ik_fi,ivert),  &
              igumk, igumkq, .not.xct%unrestricted_transf)
            call timacc(45, 2)
          endif
          
          SAFE_DEALLOCATE_P(wfnc_co%cg)
          SAFE_DEALLOCATE_P(wfnc_co%isort)
          SAFE_DEALLOCATE_P(wfnv_co%cg)
          SAFE_DEALLOCATE_P(wfnv_co%isort)
          
          if (ik_fi .ne. 0) then
            SAFE_DEALLOCATE_P(wfnc_fi%cg)
            SAFE_DEALLOCATE_P(wfnc_fi%isort)
            SAFE_DEALLOCATE_P(wfnvq_fi%cg)
            SAFE_DEALLOCATE_P(wfnvq_fi%isort)
            fi2co_wfn(ivert, ik_fi) = ik_co
          endif

! Construct Interpolated eqp shifts
          
          if (xct%inteqp .and. ik_fi .ne. 0) then
            
            do is=1,xct%nspin
              do iv_fi=1,xct%nvb_fi
                tempshift=0d0
                tempsum=0d0
                do iv_co=1,xct%nvb_co
                  tempshift = tempshift + (abs(dvn(iv_fi,iv_co,is,ik_fi,ivert))**2)*&
                    eqp%evshift_co(iv_co,kg_co%indr(ik_co),is)
                  tempsum = tempsum + (abs(dvn(iv_fi,iv_co,is,ik_fi,ivert))**2)
                enddo
                do iv_co=xct%nvb_co+1,xct%n1b_co
                  tempshift = tempshift + (abs(dvn(iv_fi,iv_co,is,ik_fi,ivert))**2)*&
                    eqp%ecshift_co(iv_co-xct%nvb_co,kg_co%indr(ik_co),is)
                  tempsum = tempsum + (abs(dvn(iv_fi,iv_co,is,ik_fi,ivert))**2)
                enddo
                if (.not.xct%renorm_transf) tempsum = 1d0
                eqp%evshift(iv_fi,ik_fi,is)= eqp%evshift(iv_fi,ik_fi,is)+tempshift*dweight/(tempsum)
              enddo
            enddo
            
            do is=1,xct%nspin
              do ic_fi=1,xct%ncb_fi
                tempshift=0d0
                tempsum=0d0
                if (xct%unrestricted_transf) then
                  do ic_co=1,xct%nvb_co
                    tempshift = tempshift + (abs(dcn(ic_fi,ic_co,is,ik_fi,ivert))**2)*&
                      eqp%evshift_co(ic_co,kg_co%indr(ik_co),is)
                    tempsum = tempsum + (abs(dcn(ic_fi,ic_co,is,ik_fi,ivert))**2)
                  enddo
                  do ic_co=xct%nvb_co+1,xct%n2b_co
                    tempshift = tempshift + (abs(dcn(ic_fi,ic_co,is,ik_fi,ivert))**2)*&
                      eqp%ecshift_co(ic_co-xct%nvb_co,kg_co%indr(ik_co),is)
                    tempsum = tempsum + (abs(dcn(ic_fi,ic_co,is,ik_fi,ivert))**2)
                  enddo
                else
                  do ic_co=1,xct%ncb_co
                    tempshift = tempshift + (abs(dcn(ic_fi,ic_co,is,ik_fi,ivert))**2)*&
                      eqp%ecshift_co(ic_co,kg_co%indr(ik_co),is)
                    tempsum = tempsum + (abs(dcn(ic_fi,ic_co,is,ik_fi,ivert))**2)
                  enddo
                endif
                if (.not.xct%renorm_transf) tempsum = 1d0
                eqp%ecshift(ic_fi,ik_fi,is)= eqp%ecshift(ic_fi,ik_fi,is)+ tempshift*dweight/(tempsum)
              enddo
            enddo
          endif
      
        enddo ! ijk
      enddo ! ii
      call progress_free(prog_info)
  
      if (xct%inteqp) then
        
        if (xct%nkpt_fi .ne. kg_fi%nf) then
          write(0,*) "WARNING: nkpt != nf", xct%nkpt_fi, kg_fi%nf
        endif
        
        call timacc(46, 1)
#ifdef MPI 
        SAFE_ALLOCATE(edummy, (xct%nvb_fi,xct%nkpt_fi,xct%nspin))
        edummy = eqp%evshift
        call MPI_Allreduce(edummy(1,1,1),eqp%evshift(1,1,1),xct%nkpt_fi*xct%nvb_fi* &
          xct%nspin,MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,mpierr)
        SAFE_DEALLOCATE(edummy)
        
        SAFE_ALLOCATE(edummy, (xct%ncb_fi,xct%nkpt_fi,xct%nspin))
        edummy = eqp%ecshift
        call MPI_Allreduce(edummy(1,1,1),eqp%ecshift(1,1,1),xct%nkpt_fi*xct%ncb_fi* &
          xct%nspin,MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,mpierr)
        SAFE_DEALLOCATE(edummy)
#endif
        
        if (peinf%inode .eq. 0) then
          
          ! Only write eqp_q.dat for velocity. For momentum, it is identical to valence bands of eqp.dat.
          if(flag%opr == 0) then
            call open_file(unit=21,file='eqp_q.dat',form='formatted',status='replace')
            vunit = 21
            eqp_dat_size = xct%ncb_fi*xct%nspin
          else
            vunit = 22
            eqp_dat_size = (xct%nvb_fi+xct%ncb_fi)*xct%nspin
          endif
          call open_file(unit=22,file='eqp.dat',  form='formatted',status='replace')
          do ik_fi = 1, kg_fi%nf
            if(flag%opr == 0) &
              write(21,'(3f13.9,i8)') kgq_fi%f(1,ik_fi),kgq_fi%f(2,ik_fi),kgq_fi%f(3,ik_fi),xct%nvb_fi*xct%nspin
            write(22,'(3f13.9,i8)') kg_fi%f(1,ik_fi),kg_fi%f(2,ik_fi),kg_fi%f(3,ik_fi),eqp_dat_size
            do is = 1, xct%nspin
              do iv_fi = xct%nvb_fi, 1, -1
                write(vunit,'(2i8,2f15.9)') is, xct%ifmaxq(ik_fi ,is) + 1 - iv_fi, eqp%evlda(iv_fi,ik_fi,is)*RYD, &
                  (eqp%evlda(iv_fi,ik_fi,is)+eqp%evshift(iv_fi,ik_fi,is))*RYD
              enddo
              do ic_fi = 1, xct%ncb_fi
                write(22,'(2i8,2f15.9)') is, xct%ifmax(ik_fi ,is) + ic_fi, eqp%eclda(ic_fi,ik_fi,is)*RYD, &
                  (eqp%eclda(ic_fi,ik_fi,is)+eqp%ecshift(ic_fi,ik_fi,is))*RYD
              enddo
            enddo
          enddo
          if(flag%opr == 0) call close_file(21)
          call close_file(22)
          
          call open_file(unit=23,file='bandstructure.dat',form='formatted',status='replace')
          ! Write k-points in cart. coord. instead of cryst. coord. for the 
          ! band structure plot (as it is done in espresso and wannier90) --GSM
          write(23,'(a)') '# spin    band          kx          ky          kz          E(MF)          E(QP)        Delta E'
          write(23,'(a)') '#                        (Cartesian coordinates)             (eV)           (eV)           (eV)'

          do is = 1, xct%nspin
            do iv_fi = xct%nvb_fi, 1, -1
              ! For the valence bands, the "q" structures are the ones that contained the calculated info. NOTE: kgq%fi = kg%fi
              do ik_fi = 1,kgq_fi%nf
                write(23,'(i6,i8,3f12.5,3f15.9)') is,xct%ifmaxq(ik_fi,is) + 1 - iv_fi, &
                  matmul(crys%bvec(1:3,1:3),kgq_fi%f(1:3,ik_fi))*crys%blat, &
                  eqp%evlda(iv_fi,ik_fi,is)*RYD,(eqp%evlda(iv_fi,ik_fi,is)+eqp%evshift(iv_fi,ik_fi,is))*RYD, &
                  eqp%evshift(iv_fi,ik_fi,is)*RYD
              enddo
            enddo
            do ic_fi = 1,xct%ncb_fi
              do ik_fi = 1,kg_fi%nf
                write(23,'(i6,i8,3f12.5,3f15.9)') is,xct%ifmax(ik_fi,is) + ic_fi, &
                  matmul(crys%bvec(1:3,1:3),kg_fi%f(1:3,ik_fi))*crys%blat, &
                  eqp%eclda(ic_fi,ik_fi,is)*RYD,(eqp%eclda(ic_fi,ik_fi,is)+eqp%ecshift(ic_fi,ik_fi,is))*RYD, &
                  eqp%ecshift(ic_fi,ik_fi,is)*RYD
              enddo
            enddo
          enddo
          call close_file(23)

! JRD: We now update our fine-grid eigenvalues with the interpolated ones.
  
        endif ! peinf%inode .eq. 0

        call timacc(46, 2)
        eqp%ecqp(:,:,:)=eqp%eclda(:,:,:)+eqp%ecshift(:,:,:)
        eqp%evqp(:,:,:)=eqp%evlda(:,:,:)+eqp%evshift(:,:,:)    
        
      endif ! xct%inteqp
      
      call dealloc_grid(kg_co)
      
      if (xct%qflag .eq. 0) call dealloc_grid(kg_co_q)
      
      ! typedefs initializes all of these ikolds to 0
      if (work%ikold .ne. 0) then
        SAFE_DEALLOCATE_P(work%cg)
        SAFE_DEALLOCATE_P(work%ph)
        SAFE_DEALLOCATE_P(work%ind)
        SAFE_DEALLOCATE_P(work%isort)
      endif
      if (workq%ikold .ne. 0) then
        SAFE_DEALLOCATE_P(workq%cg)
        SAFE_DEALLOCATE_P(workq%ph)
        SAFE_DEALLOCATE_P(workq%ind)
        SAFE_DEALLOCATE_P(workq%isort)
      endif
      if (workco%ikold .ne. 0) then
        SAFE_DEALLOCATE_P(workco%cg)
        SAFE_DEALLOCATE_P(workco%ph)
        SAFE_DEALLOCATE_P(workco%ind)
        SAFE_DEALLOCATE_P(workco%isort)
      endif
      if (workcoq%ikold .ne. 0) then
        SAFE_DEALLOCATE_P(workcoq%cg)
        SAFE_DEALLOCATE_P(workcoq%ph)
        SAFE_DEALLOCATE_P(workcoq%ind)
        SAFE_DEALLOCATE_P(workcoq%isort)
      endif

!--------------------------------
! Write out dcn,dvn. All PEs access dtmat
! FHJ: TODO - only one PE should do the job!
      
      do ivert = 1, xct%npts_intp_kernel
      do ii=1,peinf%npes
        if(peinf%inode+1.eq.ii) then
          call open_file(unit=13,file='dtmat',position='append',form='unformatted',status='old')
          do ikt=1,peinf%ikt(peinf%inode+1)
            ik_fi=peinf%ik(peinf%inode+1,ikt)
            do is=1,xct%nspin
              do ic_co=1,xct%n2b_co
                do ic_fi=1,xct%ncb_fi
                  write(13) ik_fi,ic_fi,fi2co_wfn(ivert,ik_fi),ic_co,is, &
                    dcn(ic_fi,ic_co,is,ik_fi,ivert)
                enddo
              enddo
            enddo
          enddo
          call close_file(13)
        endif
#ifdef MPI
        call MPI_BARRIER(MPI_COMM_WORLD,mpierr)
#endif
      enddo
      enddo
  
      do ivert = 1, xct%npts_intp_kernel
      do ii=1,peinf%npes
        if(peinf%inode+1.eq.ii) then
          call open_file(unit=13,file='dtmat',position='append',form='unformatted',status='old')
          do ikt=1,peinf%ikt(peinf%inode+1)
            ik_fi=peinf%ik(peinf%inode+1,ikt)
            do is=1,xct%nspin
              do iv_fi=1,xct%nvb_fi
                do iv_co=1,xct%n1b_co
                  write(13) ik_fi,iv_fi,fi2co_wfn(ivert,ik_fi),iv_co,is, &
                    dvn(iv_fi,iv_co,is,ik_fi,ivert)
                enddo
              enddo
            enddo
          enddo
          call close_file(13)
        endif
#ifdef MPI
        call MPI_BARRIER(MPI_COMM_WORLD,mpierr)
#endif
      enddo
      enddo
      
      if (xct%iwriteint.eq.1) then
        SAFE_DEALLOCATE_P(distgwfco%isort)
        SAFE_DEALLOCATE_P(distgwfco%zv)
        SAFE_DEALLOCATE_P(distgwfco%zc)
        if (xct%qflag .eq. 0) then
          SAFE_DEALLOCATE_P(distgwfcoq%isort)
          SAFE_DEALLOCATE_P(distgwfcoq%zv)
          SAFE_DEALLOCATE_P(distgwfcoq%zc)
        endif
      endif ! xct%iwriteint.eq.1
      

!--------------------------------
! Finished the computation of transformation matrices, dcn/dvn
! Now, PEs share the information

      call timacc(47, 1)
#ifdef MPI
      SAFE_ALLOCATE(dummy, (xct%ncb_fi,xct%n2b_co,xct%nspin,xct%nkpt_fi,xct%npts_intp_kernel))
      dummy = dcn
      call MPI_Allreduce(dummy(1,1,1,1,1),dcn(1,1,1,1,1),xct%nkpt_fi*xct%ncb_fi* &
        xct%n2b_co*xct%nspin*xct%npts_intp_kernel,MPI_SCALAR,MPI_SUM,MPI_COMM_WORLD,mpierr)
      SAFE_DEALLOCATE(dummy)
      SAFE_ALLOCATE(dummy, (xct%nvb_fi,xct%n1b_co,xct%nspin,xct%nkpt_fi,xct%npts_intp_kernel))
      dummy = dvn
      call MPI_Allreduce(dummy(1,1,1,1,1),dvn(1,1,1,1,1),xct%nkpt_fi*xct%nvb_fi* &
        xct%n1b_co*xct%nspin*xct%npts_intp_kernel,MPI_SCALAR,MPI_SUM,MPI_COMM_WORLD,mpierr)
      SAFE_DEALLOCATE(dummy)
      SAFE_ALLOCATE(idum, (xct%npts_intp_kernel, xct%nkpt_fi))
      idum = fi2co_wfn
      call MPI_Allreduce(idum(1,1),fi2co_wfn(1,1),xct%nkpt_fi*xct%npts_intp_kernel,MPI_INTEGER, &
        MPI_SUM,MPI_COMM_WORLD,mpierr)
      SAFE_DEALLOCATE(idum)
      SAFE_ALLOCATE(dummy_coefs, (xct%npts_intp_kernel, xct%nkpt_fi))
      dummy_coefs = intp_coefs
      call MPI_Allreduce(dummy_coefs(1,1), intp_coefs(1,1), xct%nkpt_fi*xct%npts_intp_kernel, MPI_REAL_DP, &
        MPI_SUM, MPI_COMM_WORLD, mpierr)
      SAFE_DEALLOCATE(dummy_coefs)
#endif
      call timacc(47, 2)

      ! I am not sure why but this barrier is necessary to avoid hanging. --DAS
#ifdef MPI
      call MPI_BARRIER(MPI_COMM_WORLD,mpierr)
#endif

      if (xct%npts_intp_kernel>1 .and. peinf%inode==0) then
        call open_file(unit=13,file='dtmat',position='append',form='unformatted',status='old')
        write(13) intp_coefs(:,:)
        call close_file(13)
      endif

#ifdef MPI
      call MPI_BARRIER(MPI_COMM_WORLD,mpierr)
#endif

      if (xct%delaunay_interp) then
        call interp_free(wfn_interp)
      else
        call dealloc_intpts()
      endif
    
    endif ! xct%skipinterp

    if (xct%iwriteint.eq.0) then
      if(peinf%inode.eq.0) then
        call open_file(126, 'INT_CWFN_CO', status='old')
        call close_file(126, delete = .true.) ! delete INT_CWFN_CO
        call open_file(127, 'INT_VWFN_CO', status='old')
        call close_file(127, delete = .true.) ! delete INT_VWFN_CO
        if (xct%qflag .eq. 0) then
          call open_file(123, 'INT_CWFN_CO_Q', status='old')
          call close_file(123, delete = .true.) ! delete INT_CWFN_CO_Q
          call open_file(124, 'INT_VWFN_CO_Q', status='old')
          call close_file(124, delete = .true.) ! delete INT_VWFN_CO_Q
        endif
      endif
    endif ! xct%iwriteint.eq.0
  endif ! flag%read_dtmat

!--------------------------------
! Check if transformation matrices are unitary and print out their
! norm (i.e., the norm of wavefunctions in the fine grid)
! The norm should be as close as possible to 1.d0. If it is not,
! important overlaps are being neglected.
  do ivert = 1, xct%npts_intp_kernel
  do is = 1, xct%nspin
    do ik_fi=1,xct%nkpt_fi
      do iv=1,xct%nvb_fi
        dnorm = 0.d0
        do iv_co=1,xct%n1b_co
          dnorm = dnorm + abs(dvn(iv,iv_co,is,ik_fi,ivert))**2
        enddo
        normv(ik_fi,iv,is,ivert) = dnorm
      enddo
      
      do ic=1,xct%ncb_fi
        dnorm = 0.d0
        do ic_co=1,xct%n2b_co
          dnorm = dnorm + abs(dcn(ic,ic_co,is,ik_fi,ivert))**2
        enddo
        normc(ik_fi,ic,is,ivert) = dnorm
      enddo
    enddo
  enddo
  enddo
      
  if (.not.flag%read_dtmat .and. peinf%inode==0) then
    call open_file(20,file='dcmat_norm.dat',form='formatted',status='replace')
    write(20,'(a,i12,a)') ' -------  Norm of dcc matrices : Spins = ', xct%nspin,'  -------'
    if (xct%nspin.eq.1) then
      write(20,'(a)') '           k-point           ik_co    c   dist    |dcc|^2      '
    else
      write(20,'(a)') '           k-point           ik_co    c   dist    |dcc|^2 (spin up)  |dcc|^2 (spin down) '
    endif
    write(20,'(21a3)') ('---',kk=1,21)
    do ik_fi=1,xct%nkpt_fi
      ik_co= fi2co_wfn(1,ik_fi)
      do kk=1,3
        qg(kk)=kg_fi%f(kk,ik_fi)-kco(kk,ik_co)
        qg(kk) = qg(kk) - anint( qg(kk) )
      enddo
      dist= DOT_PRODUCT(qg,MATMUL(crys%bdot,qg))
      do jj=1,xct%ncb_fi
        write(20,250) kg_fi%f(:,ik_fi),ik_co,jj,sqrt(dist),(normc(ik_fi,jj,is,1), is = 1, xct%nspin)
      enddo
    enddo
    call close_file(20)
    
    call open_file(20,file='dvmat_norm.dat',form='formatted',status='replace')
    write(20,'(a,i12,a)') ' -------  Norm of dvv matrices : Spins = ', xct%nspin,'  -------'
    if (xct%nspin.eq.1) then
      write(20,'(a)') '           k-point           ik_co    v   dist    |dvv|^2      '
    else
      write(20,'(a)') '           k-point           ik_co    v   dist    |dvv|^2 (spin up)  |dvv|^2 (spin down) '
    endif
    write(20,'(21a3)') ('---',kk=1,21)
    do ik_fi=1,xct%nkpt_fi
      ik_co= fi2co_wfn(1,ik_fi)
      do kk=1,3
        qg(kk)=kg_fi%f(kk,ik_fi)-kco(kk,ik_co)
        qg(kk) = qg(kk) - anint( qg(kk) )
      enddo
      dist= DOT_PRODUCT(qg,MATMUL(crys%bdot,qg))
      do jj=1,xct%nvb_fi
        write(20,250) kg_fi%f(:,ik_fi),ik_co,jj,sqrt(dist),(normv(ik_fi,jj,is,1), is = 1, xct%nspin)
      enddo
    enddo
    call close_file(20)
250   format(' ( ',f6.3,' , ',f6.3,' , ',f6.3, ' ) ',i4,1x,i4,1x,f6.3,1x,f10.6,9x,f10.6)
  endif    

!---------------------------------
! Renormalize transformation matrices: matrices dcn,dvn are
! renormalized to 1.d0 (ideally, this step should not be
! performed but the interpolation can be really bad if dcn,dvn
! do not have unitary norm).

  ! FHJ: Print worst norm before restriction/renormalization
  worst_normv = minval(normv)
  worst_normc = minval(normc)
  if (peinf%inode==0) then    
    write(6,'(1x,a)') 'Max. error in norm of transformation coefficients (1 - \sum_co |d_fi,co|^2):'
    write(6,'(1x,a,es9.3e2)') ' - For valence states: ', 1d0 - worst_normv
    write(6,'(1x,a,es9.3e2)') ' - For conduction states: ', 1d0 - worst_normc
    call warn_norm(xct, worst_normv, worst_normc)
  endif
  ! FHJ: truncate or zero out coefficients. User doesn`t care about the details...
  if (truncate_coefs) then
    if (peinf%inode==0) write(6,'(1x,a)') "Restricting transformation to dvv',dcc' subspaces."
    dvv(:,:,:,:,:) = dvn(:,:xct%nvb_co,:,:,:)
    dcc(:,:,:,:,:) = dcn(:,xct%nvb_co+1:,:,:,:)
  elseif (xct%zero_unrestricted_contrib) then
    if (peinf%inode==0) write(6,'(1x,a)') "Restricting transformation to dvv',dcc' subspaces."
    dvn(:,xct%nvb_co+1:,:,:,:) = ZERO
    dcn(:,:xct%nvb_co,:,:,:) = ZERO
  endif

  ! FHJ: And from now on, xct%n1b_co will depend only on xct%extended_kernel.
  if (.not.xct%extended_kernel) then
    xct%n1b_co = xct%nvb_co
    xct%n2b_co = xct%ncb_co
  else
    xct%n1b_co = xct%nvb_co + xct%ncb_co
    xct%n2b_co = xct%n1b_co
  endif

  ! FHJ: inteqp also renormalizes the coefs for consistency (and someone might
  ! need this in the future). And note that we go here if truncate_coefs==.true.
  ! only to recalculate the worst norm.
  if (truncate_coefs.or.xct%renorm_transf) then
    worst_normc = INF
    worst_normv = INF
    do ivert = 1, xct%npts_intp_kernel
    do is=1, xct%nspin
      do ik=1,xct%nkpt_fi
        do ic_fi=1,xct%ncb_fi
          dnorm = sum(abs(dcc(ic_fi,:,is,ik,ivert))**2)
          worst_normc = min(worst_normc, dnorm)
          if (xct%renorm_transf) then
            dnorm = sqrt(dnorm)
            dcc(ic_fi,:,is,ik,ivert) = dcc(ic_fi,:,is,ik,ivert)/dnorm
          endif
        enddo
        do iv_fi=1,xct%nvb_fi
          dnorm = sum(abs(dvv(iv_fi,:,is,ik,ivert))**2)
          worst_normv = min(worst_normv, dnorm)
          if (xct%renorm_transf) then
            dnorm = sqrt(dnorm)
            dvv(iv_fi,:,is,ik,ivert) = dvv(iv_fi,:,is,ik,ivert)/dnorm
          endif
        enddo
      enddo
    enddo
    enddo
  endif
  if (peinf%inode==0.and.(truncate_coefs.or.xct%zero_unrestricted_contrib)) then
    write(6,'(1x,a)') 'Max. error after restricting WFN transformation:'
    write(6,'(1x,a,es9.3e2)') ' - For valence states: ', 1d0 - worst_normv
    write(6,'(1x,a,es9.3e2)') ' - For conduction states: ', 1d0 - worst_normc
    call warn_norm(xct, worst_normv, worst_normc)
  endif

!-------------------------------------
! Print out information about the number of k-points in the fine grid
! interpolated from each point in the coarse grid
! ii : number of fine-grid points close to point ik_co

#ifdef VERBOSE
  if (peinf%inode==0) then
    write(6,*)
    write(6,'(1x,a)') 'K-points in coarse matrix:'
    do ik_co=1,xct%nkpt_co
      ii = 0
      do ik=1,xct%nkpt_fi
        if (any(fi2co_wfn(:,ik)==ik_co)) ii = ii + 1
      enddo
      write(6,'(i6,1x,3f10.6,1x,i6)') ik_co,kco(:,ik_co),ii
    enddo
    write(6,*)
  endif
#endif

  if (.not.associated(dvn,dvv)) then
    SAFE_DEALLOCATE_P(dvn)
  endif
  if (.not.associated(dcn,dcc)) then
    SAFE_DEALLOCATE_P(dcn)
  endif
  SAFE_DEALLOCATE(normc)
  SAFE_DEALLOCATE(normv)
  SAFE_DEALLOCATE(indexq_co)

  POP_SUB(intwfn)
  
  return
end subroutine intwfn

    subroutine warn_norm(xct, worst_normv, worst_normc)
      type(xctinfo), intent(in) :: xct
      real(DP), intent(in) :: worst_normv, worst_normc

      logical, save :: warned = .false.

      PUSH_SUB(warn_norm)

      if (.not.warned) then
        ! FHJ: for HEP calculations, change the criterion below to 5 sigma.
        if (worst_normv<95d-2 .or. worst_normc<95d-2) then
          write(0,'(/,a)') 'WARNING: there are fine/coarse transformation coefficients with 2-norm < 95%.'
          write(0,'(a)') 'To improve convergence, you might want to consider:'
          if (xct%is_absorption) then
            write(0,'(a)') '- recalculating the kernel using the "extended_kernel" flag'
          endif
          if (.not. xct%unrestricted_transf) then
            write(0,'(a)') '- using the "unrestricted_transformation" flag in the input file'
          endif
          write(0,'(a)') '- including more bands from the coarse WFN_co file (number_*_bands_coarse)'
          write(0,'(a)') '- using a coarse WFN_co file with a denser k-mesh'
          write(0,*)
          warned = .true.
        endif
      endif

      POP_SUB(warn_norm)

    end subroutine warn_norm

end module intwfn_m

#include "f_defs.h"

!*************************************************************************
Module tiseOpsMod
!*************************************************************************

  use SysParams, only : double
  use push_pop_m
  implicit none

! DAS 1/13/2011 -- this line has no purpose since zdotu is not called
!  complex(double), external :: zdotu
  
  contains

!*************************************************************************
  Subroutine EigenValues( eigenStates, minVec, iBand, kPoint)
!*************************************************************************

    use EigenStatesMod, only : eigenStatesT
    use TypeMod, only : minVecT

    integer, intent(in) :: iBand, kPoint
    type(minVecT),    pointer :: minVec   
    type(eigenStatesT), pointer :: eigenStates

    PUSH_SUB(EigenValues)

    Call CalcIterEPsi( eigenStates, minVec, kPoint )

    ! Store the RitzValue in eigenStates
    eigenStates%eigenValues( iBand, kPoint ) = Dot_Product( &
         & eigenStates%eigenVectors(:, iBand, kPoint), &
         & eigenStates%ePsi( :, kPoint ))

    POP_SUB(EigenValues)
  end Subroutine EigenValues

!*************************************************************************
  Subroutine CalcIterEPsi( eigenStates, minVec, kPoint )
!*************************************************************************

    use EigenStatesMod, only : eigenStatesT
    use TypeMod, only : minVecT

    integer, intent(in)    :: kPoint
    type(minVecT), pointer :: minVec
    type(eigenStatesT), pointer :: eigenStates

    PUSH_SUB(CalcIterEPsi)

    eigenStates%ePsi( :, kPoint ) = &
        & minVec%cosine * eigenStates%ePsi( :, kPoint ) + &
        & minVec%sine * minVec%EPhi

    POP_SUB(CalcIterEPsi)
  end Subroutine CalcIterEPsi

!*************************************************************************
  Subroutine CalculateEPsi( eigenStates, hMatrix,iBand, kPoint)
!*************************************************************************

    use EigenStatesMod, only : eigenStatesT
    use SysParams, only : double
    use blas_m

    integer, intent( in ) :: iBand, kPoint
    complex( double ), dimension(:,:) :: hMatrix
    type( eigenStatesT ), pointer :: eigenStates

    integer :: nSize
    complex( double ) :: a, b

    PUSH_SUB(CalculateEPsi)

    a = cmplx(1.d0,0.d0,kind=double)
    b = cmplx(0.d0,0.d0,kind=double)

    nSize = eigenStates%hSize

    ! Evaluate hMatrix * EigenState, this matrix multiplication is done
    ! by a BLAS routine.

    Call zgemv('N', nSize, nSize, a, hMatrix, nSize, &
         & eigenStates%eigenVectors( :, iBand, kPoint ), &
         & 1, b, eigenStates%ePsi(:, kPoint ), 1 )

    POP_SUB(CalculateEPsi)
  end Subroutine CalculateEPsi

!*************************************************************************
  Subroutine PreCondition( eigenStates, minVec, hMatrix, iBand, kPoint )
!*************************************************************************

    use EigenStatesMod, only : eigenStatesT
    use SysParams, only : double
    use TypeMod, only : minVecT

    integer, intent(in) :: iBand, kPoint
    complex( double ), dimension(:,:) :: hMatrix
    type(eigenStatesT), pointer :: eigenStates
    type(minVecT), pointer :: minVec
    
    integer :: i, nSize
    real( double ) :: eKinIter, x, k

    PUSH_SUB(PreCondition)

    nSize = eigenStates%hSize

    ! There is a preconditioning matrix K for every iBand, to calculate
    ! that we have to first find the quantity x, the ratio of the kinetic
    ! energy with the kinetic energy of that iteration. This is different
    ! for every band.
    eKinIter = cmplx(0.d0,0.d0,kind=double)
    do i = 1, nSize
       eKinIter = eKinIter + hMatrix( i, i ) * &
            & conjg( eigenStates%eigenVectors( i, iBand, kPoint )) * &
            & eigenStates%eigenVectors( i, iBand, kPoint )
    end do

    ! Now calculate x and K.
    do i = 1, nSize
       x = hMatrix( i, i ) /( eKinIter + 1.d-30 )
       
       k = (27.d0 + 18.d0 * x + 12.d0 * x**2 + 8.d0 * x**3 ) / &
         & (27.d0 + 18.d0 * x + 12.d0 * x**2 + 8.d0 * x**3 + 16.d0 * x**4 )

       ! Update the StDescVector
       minVec%StDesc( i ) = k * minVec%StDesc( i )

    end do

    POP_SUB(PreCondition)
  end Subroutine PreCondition

!*************************************************************************
  Subroutine ExactEnergyMinimize( eigenStates, minVec, hMatrix, iBand, kPoint )
!*************************************************************************

    use EigenStatesMod, only : eigenStatesT
    use SysParams, only : double
    use TypeMod, only : minVecT
    use blas_m

    integer, intent(in) :: iBand, kPoint
    complex( double ), dimension(:,:) :: hMatrix
    type(eigenStatesT), pointer :: eigenStates
    type(minVecT), pointer :: minVec

    integer :: nSize
    real( double ) :: e0, theta, ePhi
    complex( double ) :: phiHPsi, a, b
    complex( double ), dimension(:), allocatable :: hPhi

    PUSH_SUB(ExactEnergyMinimize)

    nSize = eigenStates%hSize

    a = cmplx(1.d0,0.d0,kind=double)
    b = cmplx(0.d0,0.d0,kind=double)

    e0 = cmplx(eigenStates%eigenValues(iBand,kPoint),0.0d0,kind=double)
    phiHPsi = Dot_Product( minVec%Phi, eigenStates%ePsi( :, kPoint ))

    allocate( hPhi( nSize ))

    !    Evaluate Phi.hMatrix.Phi, by calling the BLAS routine. First
    ! calulate hMatrix.Phi

    Call zgemv('N', nSize, nSize, a, hMatrix, nSize, minVec%Phi, 1, b, hPhi, 1 )

    ePhi = Dot_Product( minVec%Phi, hPhi )

    minVec%EPhi = hPhi
    minVec%EPhi(eigenStates%hsize+1:eigenStates%hDim) = cmplx(0.d0,0.d0,kind=double)
    deallocate( hPhi )

    theta = 0.5d0 * abs( atan(( 2.d0 * real( phiHPsi )/( e0 - ePhi +10.d-30 ))))
!    print *, 'theta:',theta

    minVec%sine = sin( theta )
    minVec%cosine = cos( theta )

    eigenStates%eigenVectors( :, iBand, kPoint ) = &
         & eigenStates%eigenVectors( :, iBand, kPoint ) * minVec%cosine + &
         & minVec%Phi * minVec%sine

    ! Update the Ritz values
    Call EigenValues( eigenStates, minVec, iBand, kPoint )

    POP_SUB(ExactEnergyMinimize)
  end Subroutine ExactEnergyMinimize

!*************************************************************************
  Subroutine CalcHPsi(size,T_G,vector1,vector2,Grid)
!*************************************************************************

    ! H in T_G and Grid
    ! Psi in vector1
    ! HPsi in vector2

    use sysparams, only               : double
    use typeMod,   only               : GridT

    type(GridT),               pointer :: Grid
    integer, intent(in)                :: size
    real(double), dimension(:)         :: T_G
    complex(double), dimension(:)      :: vector1,vector2

    integer :: r
    integer :: i,j,k,G

    PUSH_SUB(CalcHPsi)

    ! Zero the Psi Grid
    Grid%Psi = cmplx(0.d0,0.d0,kind=double)

    ! Put the  Statevector on the grid (Translation)
    do r = 1, size
       G = Grid%BasisIndex(r,Grid%k)
       Grid%Psi(Grid%GVecIndex(1,G)+Grid%Size(1)+1,Grid%GVecIndex(2,G)+ &
            & Grid%Size(2)+1, Grid%GVecIndex(3,G)+Grid%Size(3)+1) = &
            & vector1(r)
    end do
    
    ! Multiply V_r and Psi_r
    do i = 1, 2*Grid%Size(1)
       do j = 1, 2*Grid%Size(2)
          do k = 1, 2*Grid%Size(3)
!             s = i+j+k-3 ! If the output from potential is not centered.
             Grid%VPsi(i,j,k) = real(Grid%V(i,j,k))*Grid%Psi(i,j,k)!*(-1)**s
          end do
       end do
    end do

    ! Since this is a backward transform, scale the grid
    Grid%VPsi = Grid%VPsi/Grid%fac

    ! Evaluate (T+V)*StateVector
    do r = 1, size
       G = Grid%BasisIndex(r,Grid%k) 
       vector2(r) = T_G(r)*vector1(r) +  &
            & Grid%VPsi(Grid%GVecIndex(1,G)+ &
            & Grid%Size(1)+1,Grid%GVecIndex(2,G)+Grid%Size(2)+1, &
            & Grid%GVecIndex(3,G)+Grid%Size(3)+1)
    end do

    POP_SUB(CalcHPsi)
  end Subroutine CalcHPsi

!*************************************************************************
  Subroutine FFTPreCondition(eigenStates,minVec,T_g,iBand,kPoint)
!*************************************************************************

    use eigenStatesMod,          only : eigenStatesT
    use sysparams,               only : double 
    use typeMod,                 only : minVecT

    type(eigenStatesT),       pointer :: eigenStates
    type(minVecT),            pointer :: minVec

    integer, intent(in)               :: iBand,kPoint
    real(double), dimension(:)        :: T_G

    integer                           :: r
    real(double)                      :: Ekin_Iter,x,K

    PUSH_SUB(FFTPreCondition)

    ! There is a preconditioning matrix K for every iband, to calculate
    ! that we have to first find the quantity x, the ratio of the kinetic
    ! energy with the kinetic energy of that iteration. this is different
    ! for every band
    Ekin_iter=cmplx(0.d0,0.d0,kind=double)
    do r = 1, eigenStates%hSize
       Ekin_iter = Ekin_iter + T_g(r) * &
            & conjg(eigenStates%eigenVectors(r,iband,kPoint))* &
            & eigenStates%eigenVectors(r,iband,kPoint)
    end do

    ! Now calculate x and K
    do r = 1, eigenStates%hSize
       x = T_g(r)/(Ekin_iter+1.d-30)
       
       K =    (27.d0+18.d0*x+12.d0*x**2+8.d0*x**3)/ &
            & (27.d0+18.d0*x+12.d0*x**2+8.d0*x**3+16.d0*x**4)

       ! Update the StDescVector
       MinVec%StDesc(r) = K*MinVec%StDesc(r)

    end do

    POP_SUB(FFTPreCondition)
  end Subroutine FFTPreCondition

!*************************************************************************
  Subroutine FFTEnergyMinimize(eigenStates,minvec,T_G,Grid,iBand,kPoint)
!*************************************************************************

    use EigenStatesMod, only : eigenStatesT
    use SysParams, only : double
    use TypeMod, only : minVecT,GridT

    integer, intent(in) :: iBand, kPoint
    real( double ), dimension(:)  :: T_G
    type(eigenStatesT), pointer :: eigenStates
    type(minVecT), pointer :: minVec
    type(GridT), pointer   :: Grid

    integer            :: nSize
    real(double)       :: theta, ephi, e0
    complex(double)    :: a,b,phiHPsi
    complex( double ), dimension(:), allocatable :: hPhi

    PUSH_SUB(FFTEnergyMinimize)

    nSize = eigenStates%hSize

    a = cmplx(1.d0,0.d0,kind=double)
    b = cmplx(0.d0,0.d0,kind=double)

    e0 = cmplx(eigenStates%eigenValues(iBand,kPoint),0.0d0,kind=double)
    phiHPsi = Dot_Product(minVec%Phi(1:nSize), &
         & eigenStates%ePsi(1:nSize,kPoint ))

    allocate(hPhi(nSize))

    ! Evaluate Phi.HMatrix.Phi, by calling the FFT routine. First
    ! calculate HMatrix.Phi
    Call CalcHPSi(nSize,T_G,minVec%Phi,hPhi,Grid)

    ePhi = Dot_Product(MinVec%Phi(1:nSize),hPhi)
    MinVec%EPhi = hPhi
    minVec%EPhi(eigenStates%hsize+1:eigenStates%hDim) = cmplx(0.d0,0.d0,kind=double)
    deallocate(HPhi)

    theta = 0.5d0*abs(atan((2.d0*real(PhiHPsi)/(e0 - ePhi +10.d-30))))

    MinVec%cosine = cos(theta)
    MinVec%sine = sin(theta)

    eigenStates%eigenVectors( :, iBand, kPoint ) = &
         & eigenStates%eigenVectors( :, iBand, kPoint ) * minVec%cosine + &
         & minVec%Phi * minVec%sine

    ! Update the Ritz values
    Call EigenValues( eigenStates, minVec, iBand, kPoint )

    POP_SUB(FFTEnergyMinimize)
  end Subroutine FFTEnergyMinimize

end Module tiseOpsMod

!>===================================================================
!!
!! Module misc_m
!!
!! Routines:
!!
!! 1. checknorm()        Originally By (SIB)     Last Modified 5/02/2012 (BAB)
!!
!!    Checks normalization of a wavefunction, one spin at a time.
!!    By normalization we mean that sum_l { |z(l,m)|^2 } = 1 for each m.
!!    It aborts if norm is off by more than TOL_Small from 1.
!!
!! 2. compute_norm()      Originally by BAB   5/02/12
!!
!!    Computes the norm of an input wavefunction.
!!
!! 3. get_volume()       Originally By (SIB)     Last Modified 6/12/2008 (JRD)
!!
!!    This assumes that b is a symmetric matrix.  It sets
!!    vol = (2pi)^3 / square_root(|det(b)|)
!!    This makes sense if b is the matrix of dot products of the recip
!!    lattice vectors, so vol is the real space volume.
!!
!! 4. findvector()       Originally By (SIB)     Last Modified 6/12/2008 (JRD)
!!
!!    Looks for the vector in the list of vectors
!!    gvec%components(1:3,1:gvec%ng).  If found, iout is its index.  Otherwise
!!    iout is zero.
!!
!! 5. invert_matrix()    Originally By (SIB)     Last Modified 6/12/2008 (JRD)
!!
!!    Inverts 3x3 matrix.
!!
!! 6. invert_matrix_int()   Originally by DAS  12/28/11  Last Modified 8/27/2012 (BAB)
!!
!!    Like invert_matrix, but for integer input. Dies if output is not integers.
!!
!! 7. compute_det()      Originally By (BAB)     Last Modified 8/27/2012 (BAB)
!!
!!    Computes determinant of 3x3 matrix.
!!
!! 8. compute_det_int()      Originally By (BAB)     Last Modified 8/27/2012 (BAB)
!!
!!    Like compute_det, but for integer input. Does not die if output not integer
!!
!! 9. compute_cofac()        Originally By (BAB)      Last Modified 9/4/2012 (BAB)
!!
!!    Computes matrix of cofactors for input matrix.
!!
!! 10. compute_cofac_int()        Originally By (BAB)      Last Modified 9/4/2012 (BAB)
!!
!!    Computes matrix of cofactors for input matrix, but for integer input.
!!
!! 11. procmem()          Originally By (gsm)     Last Modified 4/14/2009 (gsm)
!!
!!     Determines the amount of free memory per processor
!!     from the proc file system
!!
!! 12. sizeof_scalar()    Originally By (DAS)     Last Modified 1/25/2011 (DAS)
!!
!!     Return the size of the SCALAR type, for memory estimation.
!!
!! 13. voigt()            Originally By (gsm)     Last Modified 1/31/2011 (gsm)
!!
!!     Returns Voigt function (convolution of Gaussian and Lorentzian).
!!     Based on the rational approximation to the complex error function
!!     from A. K. Hui, B. H. Armstrong and A. A. Wray,
!!     "Rapid computation of the Voigt and complex error functions,"
!!     Journal of Quantitative Spectroscopy and Radiative Transfer,
!!     Volume 19, Issue 5, Pages 509 - 516, Year 1978.
!!
!! 14. k_range()        Originally By gsm       Last Modified 8/18/2010 (gsm)
!!
!!    Translates k-point kpt(1:3) to [0,1) interval. Returns G-vector gpt(1:3)
!!    that brings kpt(1:3) to [0,1) interval. The interval is satisfied within
!!    a given tolerance, the actual interval is [-tol,1-tol).
!!
!! 15. bse_index()         Originally by DAS   4/19/12
!!
!!    Defines the mapping of k-point, conduction band, valence band, and spin
!!    into a single index (traditionally called 'ikcvs'), as used in BSE codes.
!!
!! 16. set_jspinor()       Originally by BAB   5/18/12
!!
!!    Sets values for jspinormin and jspinormax for use with loops
!!    where spinor components are summed over.
!!
!!===================================================================

#include "f_defs.h"

module misc_m

  use global_m
  use blas_m

  implicit none

  private

  public ::        &
    checknorm,     &
    compute_norm,  &
    get_volume,    &
    findvector,    &
    invert_matrix, &
    invert_matrix_int, &
    compute_det,   &
    compute_det_int,   &
    procmem,       &
    sizeof_scalar, &
    voigt,         &
    k_range,       &
    bse_index,     &
    set_jspinor

contains

!> Checking normalization of only one spin component at a time
  subroutine checknorm(filename,iband,ik,ng,ispin,nspinor,wfn)
    character (len=*), intent(in) :: filename
    integer, intent(in) :: iband,ik,ng,ispin,nspinor
    SCALAR, intent(in) :: wfn(:,:) !< (ng,nspin*nspinor)

    real(DP) :: xnorm

    PUSH_SUB(checknorm)

    call compute_norm(xnorm,ispin,ng,nspinor,wfn)
    if(abs(xnorm - 1.0d0) > TOL_Small) then
      write(0,555) TRUNC(filename),abs(xnorm-1.0d0),iband,ispin,ik
555   format(1x,'Wavefunction is not normalized in file',1x,a,/,&
        3x,'abs(norm - 1) =',f10.6,/,&
        3x,'iband =',i6,1x,'ispin =',i2,1x,'ik =',i6,/)
      call die("Incorrect normalization.")
    endif

    POP_SUB(checknorm)
    
    return
  end subroutine checknorm

!=====================================================================

  subroutine compute_norm(xnorm,ispin,ng,nspinor,wfn)
    real(DP), intent(out) :: xnorm
    integer, intent(in) :: ispin,ng,nspinor
    SCALAR, intent(in) :: wfn(:,:) !< (ng,nspin*nspinor)

    integer :: ispinor
    real(DP) :: vnorm(nspinor)

    PUSH_SUB(compute_norm)

    do ispinor=1,nspinor
      vnorm(ispinor) = blas_nrm2(ng, wfn(:,ispin*ispinor), 1)
    enddo
    xnorm = sqrt(sum(vnorm(:)**2))

    POP_SUB(compute_norm)
    
    return
  end subroutine compute_norm

!=====================================================================

  subroutine get_volume(vol,b)
    real(DP), intent(out) :: vol
    real(DP), intent(in)  :: b(3,3)
    
    PUSH_SUB(get_volume)
    
    vol = b(1,1)*(b(2,2)*b(3,3) - b(2,3)**2) &
      + 2*b(1,2)*b(2,3)*b(3,1) &
      - b(2,2)*b(1,3)**2 - b(3,3)*b(1,2)**2
    vol = sqrt(abs(vol))
    vol = ((2.0d0*PI_D)**3)/vol
    
    POP_SUB(get_volume)

    return
  end subroutine get_volume

!=====================================================================

  subroutine findvector(iout,kk,gvec)
    integer, intent(out) :: iout
    integer, intent(in)  :: kk(3)
    type (gspace), intent(in) :: gvec
    
! no push/pop since called too frequently

    iout=((kk(1)+gvec%FFTgrid(1)/2)*gvec%FFTgrid(2)+kk(2)+gvec%FFTgrid(2)/2)* &
      gvec%FFTgrid(3)+kk(3)+gvec%FFTgrid(3)/2+1
    if (iout .ge. 1 .and. iout .le. gvec%nFFTgridpts) then
      iout=gvec%index_vec(iout)
      if (iout .ge. 1 .and. iout .le. gvec%ng) then
        if (any(kk(1:3) /= gvec%components(1:3, iout))) iout = 0
      else
        iout = 0
      endif
    else
      iout = 0
    endif

    return
  end subroutine findvector

!=====================================================================

  subroutine invert_matrix(mat, inv)
    real(DP), intent(in) :: mat(:,:)  !< (3,3)
    real(DP), intent(out) :: inv(:,:) !< (3,3)
    
    real(DP) :: aa(3,3), det
    
    PUSH_SUB(invert_matrix)
    
    call compute_cofac(mat, aa)
    call compute_det(mat, det)
    if (abs(det) .lt. TOL_Small) call die('Cannot invert singular matrix.')
    
    inv(1:3, 1:3) = aa(1:3, 1:3) / det
    
    POP_SUB(invert_matrix)
    
    return
  end subroutine invert_matrix

!================================================================================

  subroutine invert_matrix_int(mat, inv)
    integer, intent(in)  :: mat(:,:) !< (3,3)
    integer, intent(out) :: inv(:,:) !< (3,3)

    integer :: aa(3,3), det
    
    PUSH_SUB(invert_matrix_int)
    
    call compute_cofac_int(mat, aa)
    call compute_det_int(mat, det)
    if (det == 0) call die('Cannot invert singular matrix.')

    inv(1:3, 1:3) = aa(1:3, 1:3) / det
    
    if (any(inv(1:3, 1:3) * det /= aa(1:3, 1:3))) then
      write(0,*) 'determinant = ', det
      call die('Inverse of this integer matrix is not an integer matrix.')
    endif
    
    POP_SUB(invert_matrix_int)
    
    return
  end subroutine invert_matrix_int

!=====================================================================

  subroutine compute_det(mat, det)
    real(DP), intent(in) :: mat(:,:)  !< (3,3)
    real(DP), intent(out) :: det
    
    real(DP) :: aa(3,3)

    PUSH_SUB(compute_det)
    
!> Compute matrix of cofactors

    call compute_cofac(mat, aa)

!> Compute determinant

    det = sum(mat(1, 1:3) * aa(1:3, 1))
    
    POP_SUB(compute_det)
    
    return
  end subroutine compute_det

!================================================================================

  subroutine compute_det_int(mat, det)
    integer, intent(in) :: mat(:,:)  !< (3,3)
    integer, intent(out) :: det
    
    integer :: aa(3,3)

    PUSH_SUB(compute_det_int)
    
!> Compute matrix of cofactors

    call compute_cofac_int(mat, aa)

!> Compute determinant

    det = sum(mat(1, 1:3) * aa(1:3, 1))
    
    POP_SUB(compute_det_int)
    
    return
  end subroutine compute_det_int

!================================================================================

  subroutine compute_cofac(mat, aa)
    real(DP), intent(in) :: mat(:,:)  !< (3,3)
    real(DP), intent(out) :: aa(3,3)
    
    PUSH_SUB(compute_cofac)
    
!> Compute matrix of cofactors

    aa(1,1) =  mat(2,2) * mat(3,3) - mat(2,3) * mat(3,2)
    aa(2,1) = -mat(2,1) * mat(3,3) + mat(2,3) * mat(3,1)
    aa(3,1) =  mat(2,1) * mat(3,2) - mat(2,2) * mat(3,1)
    aa(1,2) = -mat(1,2) * mat(3,3) + mat(1,3) * mat(3,2)
    aa(2,2) =  mat(1,1) * mat(3,3) - mat(1,3) * mat(3,1)
    aa(3,2) = -mat(1,1) * mat(3,2) + mat(1,2) * mat(3,1)
    aa(1,3) =  mat(1,2) * mat(2,3) - mat(1,3) * mat(2,2)
    aa(2,3) = -mat(1,1) * mat(2,3) + mat(1,3) * mat(2,1)
    aa(3,3) =  mat(1,1) * mat(2,2) - mat(1,2) * mat(2,1)
    
    POP_SUB(compute_cofac)
    
    return
  end subroutine compute_cofac

!================================================================================

  subroutine compute_cofac_int(mat, aa)
    integer, intent(in) :: mat(:,:)  !< (3,3)
    integer, intent(out) :: aa(3,3)
    
    PUSH_SUB(compute_cofac_int)
    
!> Compute matrix of cofactors

    aa(1,1) =  mat(2,2) * mat(3,3) - mat(2,3) * mat(3,2)
    aa(2,1) = -mat(2,1) * mat(3,3) + mat(2,3) * mat(3,1)
    aa(3,1) =  mat(2,1) * mat(3,2) - mat(2,2) * mat(3,1)
    aa(1,2) = -mat(1,2) * mat(3,3) + mat(1,3) * mat(3,2)
    aa(2,2) =  mat(1,1) * mat(3,3) - mat(1,3) * mat(3,1)
    aa(3,2) = -mat(1,1) * mat(3,2) + mat(1,2) * mat(3,1)
    aa(1,3) =  mat(1,2) * mat(2,3) - mat(1,3) * mat(2,2)
    aa(2,3) = -mat(1,1) * mat(2,3) + mat(1,3) * mat(2,1)
    aa(3,3) =  mat(1,1) * mat(2,2) - mat(1,2) * mat(2,1)
    
    POP_SUB(compute_cofac_int)
    
    return
  end subroutine compute_cofac_int

!================================================================================

  subroutine procmem(mem,nmpinode)
    real(DP), intent(out) :: mem
    integer, intent(out) :: nmpinode

    integer :: ierr,eof,info,iunit,m,n,p,i,j,pagesize
    real(DP) :: x,y,mac_m,mac_n
!    integer :: ntot
!    real(DP) :: xtot,ytot ! we do not use the total memory actually
    character*80 :: s, filename
    character*80, allocatable :: a(:)
    integer, allocatable :: b(:)

    PUSH_SUB(procmem)

!-----------------------------------------------------
!> determine the amount of free memory per node in kB

    m=0
    iunit=14
    x=0

    call open_file(unit=iunit,file='/proc/meminfo',form='formatted',iostat=ierr,status='old')
    if (ierr.eq.0) then
      eof=0
      do while(eof.eq.0)
        read(iunit,'(a)',iostat=eof)s
        if (s(1:7).eq."MemFree") then
          read(s(9:),*)n
          m=m+n
        endif
!        if (s(1:8).eq."MemTotal") then
!          read(s(10:),*)ntot
!        endif
        if (s(1:6).eq."Cached") then
          read(s(8:),*)n
          m=m+n
        endif
      enddo
      x=dble(m)/dble(peinf%npes)
      call close_file(iunit)
    endif

    if(m == 0) then
      !> this is for Mac OS
      !! total memory is accessible instead from sysctl -n hw.usermem
      write(filename,'(a,i9.9)') 'vm_stat_', peinf%inode
      SYSTEMCALL("vm_stat > " // TRUNC(filename) // " 2> /dev/null")
      !> Fortran 2008 would use execute_command_line instead
      !! even if the command failed, still open file in order to delete it
      call open_file(unit=iunit,file=TRUNC(filename),form='formatted',iostat=ierr,status='old')
      if (ierr.eq.0) then
        eof=0
        do while(eof.eq.0)
          read(iunit,'(a)',iostat=eof)s
          if (s(1:45).eq."Mach Virtual Memory Statistics: (page size of") then
            read(s(46:),*)pagesize ! in bytes
          endif
          if (s(1:11).eq."Pages free:") then
            read(s(12:),*) mac_n
            mac_m = mac_m + mac_n
          endif
          if (s(1:18).eq."Pages speculative:") then
            read(s(19:),*) mac_n
            mac_m = mac_m + mac_n
          endif
        enddo
        call close_file(iunit, delete = .true.)
        x = mac_m * dble(pagesize) / dble(peinf%npes * 1024) ! to kB
      endif
    endif

!> === Example output from vm_stat ===
!! Mach Virtual Memory Statistics: (page size of 4096 bytes)
!! Pages free:                           2886.
!! Pages active:                       139635.
!! Pages inactive:                      66906.
!! Pages speculative:                    2376.
!! Pages wired down:                    50096.
!! "Translation faults":            123564742.
!! Pages copy-on-write:              10525831.
!! Pages zero filled:                53274329.
!! Pages reactivated:                  739514.
!! Pageins:                           2282166.
!! Pageouts:                           306727.
!! Object cache: 25 hits of 522230 lookups (0% hit rate)

    if(m == 0 .and. mac_m == 0) then ! BSD
      !> http://mario79t.wordpress.com/2008/08/29/memory-usage-on-freebsd/
      !! -bash-2.05b$ sysctl vm.stats.vm.v_free_count
      !! vm.stats.vm.v_free_count: 29835
      !! -bash-2.05b$ sysctl vm.stats.vm.v_page_count
      !! vm.stats.vm.v_page_count: 124419
      !! -bash-2.05b$ sysctl hw.pagesize
      !! hw.pagesize: 4096
      write(filename,'(a,i9.9)') 'sysctl_', peinf%inode
      SYSTEMCALL("sysctl -a > " // TRUNC(filename) // " 2> /dev/null")
      !> Fortran 2008 would use execute_command_line instead
      !! even if the command failed, still open file in order to delete it
      call open_file(unit=iunit,file=TRUNC(filename),form='formatted',iostat=ierr,status='old')
      if (ierr.eq.0) then
        eof=0
        do while(eof.eq.0)
          read(iunit,'(a)',iostat=eof)s
          if (s(1:12).eq."hw.pagesize:") then
            read(s(13:),*)pagesize ! in bytes
          endif
          if (s(1:25).eq."vm.stats.vm.v_free_count:") then
            read(s(26:),*) mac_n
            mac_m = mac_m + mac_n
          endif
          if (s(1:26).eq."vm.stats.vm.v_cache_count:") then
            read(s(27:),*) mac_n
            mac_m = mac_m + mac_n
          endif
        enddo
        call close_file(iunit, delete = .true.)
        x = mac_m * dble(pagesize) / dble(peinf%npes * 1024) ! to kB
      endif
    endif

!    xtot=dble(ntot)/dble(peinf%npes)
    
#ifdef MPI
    call MPI_Allreduce(x,y,1,MPI_REAL_DP,MPI_SUM,MPI_COMM_WORLD,mpierr)
!    call MPI_Allreduce(xtot,ytot,1,MPI_REAL_DP,MPI_SUM,MPI_COMM_WORLD,mpierr)
#else
    y=x
!    ytot=xtot
#endif

!----------------------------------------------
!> determine the number of processors per node
    
    SAFE_ALLOCATE(a, (peinf%npes))
    HOSTNAMECALL(a(peinf%inode+1),info)
!    write(a(peinf%inode+1),'(a4,i16.16)') 'HOST', peinf%inode
    
#ifdef MPI
    do i=1,peinf%npes
      call MPI_Bcast(a(i),80,MPI_BYTE,i-1,MPI_COMM_WORLD,mpierr)
    enddo
#endif
    
    if (peinf%inode.eq.0) then
      SAFE_ALLOCATE(b, (peinf%npes))
      b(:)=0
      do i=1,peinf%npes
        do j=1,peinf%npes
          if (trim(a(j)).eq.trim(a(i))) b(i)=b(i)+1
        enddo
      enddo
      p=0
      do i=1,peinf%npes
        if (p.lt.b(i)) p=b(i)
      enddo
      SAFE_DEALLOCATE(b)
    endif
    SAFE_DEALLOCATE(a)
    
#ifdef MPI
    call MPI_Bcast(p,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif

!-----------------------------------
!> report the available memory in B

    if (p.gt.1) y=y/dble(p)
    mem=y*1024.0d0
    
!-----------------------------------
!> report the number of MPI processes per node

    nmpinode=p

!-----------------------------------
!> warn if zero memory

    if (mem .lt. TOL_Small .and. peinf%inode .eq. 0) then
      write(0,666)
666   format(1x,'WARNING: estimation of memory available is zero, probably failed.',/)
    endif

    POP_SUB(procmem)
  
    return
  end subroutine procmem

!================================================================================

!> for memory estimation, tell what size of SCALAR type is
  integer function sizeof_scalar()

#ifdef NOSIZEOF
!> if no sizeof, take a guess

#ifdef CPLX
    sizeof_scalar = 16
#else
    sizeof_scalar = 8
#endif

#else

    SCALAR :: dummy
    sizeof_scalar = sizeof(dummy)

#endif

  end function sizeof_scalar

!================================================================================

  real(DP) function voigt(x, sigma, gamma)
    real(DP), intent(in) :: x, sigma, gamma

    real(DP), parameter :: a0 = 122.607931777104326d0
    real(DP), parameter :: a1 = 214.382388694706425d0
    real(DP), parameter :: a2 = 181.928533092181549d0
    real(DP), parameter :: a3 =  93.155580458138441d0
    real(DP), parameter :: a4 =  30.180142196210589d0
    real(DP), parameter :: a5 =   5.912626209773153d0
    real(DP), parameter :: a6 =   0.564189583562615d0
    real(DP), parameter :: b0 = 122.607931773875350d0
    real(DP), parameter :: b1 = 352.730625110963558d0
    real(DP), parameter :: b2 = 457.334478783897737d0
    real(DP), parameter :: b3 = 348.703917719495792d0
    real(DP), parameter :: b4 = 170.354001821091472d0
    real(DP), parameter :: b5 =  53.992906912940207d0
    real(DP), parameter :: b6 =  10.479857114260399d0

    complex(DPC) :: z, zh, f

    PUSH_SUB(voigt)

    if (sigma .lt. TOL_Zero .or. gamma.lt.-TOL_Zero) &
     call die('Voigt function invalid broadening')

    z = CMPLX(abs(x), gamma) / (sqrt(2.0d0) * sigma)
    zh = CMPLX(IMAG(z), -dble(z))
    f = ((((((a6*zh + a5)*zh + a4)*zh + a3)*zh + a2)*zh + a1)*zh + a0) / &
     (((((((zh + b6)*zh + b5)*zh + b4)*zh + b3)*zh + b2)*zh + b1)*zh + b0)
    if (x .lt. 0.0d0) f = conjg(f)
    voigt = dble(f) / (sqrt(2.0d0 * PI_D) * sigma)

    POP_SUB(voigt)

    return
  end function voigt

!================================================================================

  subroutine k_range(kpt, gpt, tol)
    real(DP), intent(inout) :: kpt(3)
    integer, intent(out) :: gpt(3)
    real(DP), intent(in) :: tol

    integer :: ii

    ! no push_sub, called too frequently
    
    do ii = 1, 3
      gpt(ii) = 0
      do while (kpt(ii) .lt. -tol)
        gpt(ii) = gpt(ii) + 1
        kpt(ii) = kpt(ii) + 1.0d0
      enddo
      do while (kpt(ii) .ge. 1.0d0 - tol)
        gpt(ii) = gpt(ii) - 1
        kpt(ii) = kpt(ii) - 1.0d0
      enddo
    enddo

    return
  end subroutine k_range

!=====================================================================

  integer function bse_index(ik, ic, iv, is, xct, ncband, nvband)
    integer, intent(in) :: ik, ic, iv, is
    type(xctinfo), intent(in) :: xct
    integer, optional, intent(in) :: ncband !< default is xct%ncb_fi
    integer, optional, intent(in) :: nvband !< default is xct%nvb_fi

    integer :: ncband_, nvband_

    ! The optionals are needed for the parallelization scheme sometimes, to be set to 1.
    if(present(ncband)) then
      ncband_ = ncband
    else
      ncband_ = xct%ncb_fi
    endif

    if(present(nvband)) then
      nvband_ = nvband
    else
      nvband_ = xct%nvb_fi
    endif

    ! no push_sub, called too frequently

    bse_index = is + (iv - 1 + (ic - 1 + (ik - 1)*ncband_)*nvband_)*xct%nspin
    return
  end function bse_index

!=====================================================================

  subroutine set_jspinor(jspinormin,jspinormax,ispin,nspinor)
    integer, intent(out) :: jspinormin,jspinormax
    integer, intent(in) :: ispin,nspinor

    PUSH_SUB(set_jspinor)

    if (nspinor.eq.2) then
      jspinormin = 1
      jspinormax = 2
      if (ispin .ne. 1) then
        call die('ispin not equal to 1')
      endif
    else
      jspinormin = ispin
      jspinormax = ispin
    endif

    POP_SUB(set_jspinor)
    
    return
  end subroutine set_jspinor

!=====================================================================

end module misc_m

!=============================================================================
!
! Utilities:
!
! (1) mf_convert         Originally By DAS      Last Modified 10/17/2010 (DAS)
!
!     Converts WFN/RHO/VXC files, Real/Complex flavor, binary <--> ascii
!
!==============================================================================

#include "f_defs.h"

program mf_convert

  use global_m
  use wfn_rho_vxc_io_m
  implicit none

  type(crystal) :: crys
  type(symmetry) :: syms
  type(kpoints) :: kp
  type(gspace) :: gvec
  character*3 :: sheader, sformat
  character*7 :: sflavor
  character*11 :: inform, outform
  character*256 :: infile, outfile, usage
  integer :: ik, ib, iflavor
  integer :: nargs
  real(DP), pointer :: dwfn(:,:)
  complex(DPC), pointer :: zwfn(:,:)
  logical :: informat, outformat

  usage = 'Usage: mf_convert.x A2B|B2A infile outfile'

! Get file names from command-line arguments

  nargs = iargc()

  if (nargs < 3) then
    call die(usage)
  endif

! mpiexec from mpich1 may add 4 extra arguments to the list
  if (nargs > 3) then
    write(0,'(a,i3,a)') 'WARNING: ', nargs, ' arguments found, only first 3 being used.'
  endif

  call getarg(1, sformat)
  call getarg(2, infile)
  call getarg(3, outfile)

! Open units

  if (sformat .eq. 'A2B') then
    informat = .true.
    inform = 'formatted'
    outformat = .false.
    outform = 'unformatted'
  elseif (sformat .eq. 'B2A') then
    informat = .false.
    inform = 'unformatted'
    outformat = .true.
    outform = 'formatted'
  else  
    call die(usage)
  endif

  call open_file(unit=7,file=TRUNC(infile),form=inform,status='old')
  call open_file(unit=8,file=TRUNC(outfile),form=outform,status='replace')

  write(6,'(/,3x,a,/)') 'Converting file ' // TRUNC(infile) // ' from ' // &
    TRUNC(inform) // ' to ' // TRUNC(outform)

  sheader = 'GET'
  iflavor = -1
  call read_header_type(7, informat, sheader, iflavor, kp, gvec, syms, crys, dont_warn_kgrid = .true.)

  if (iflavor .eq. 1) then
    sflavor = RFLAVOR
  else
    sflavor = CFLAVOR
  endif

! Output info

  write(6,'(3x,"File header:",17x,a,/)') sheader // '-' // TRUNC(sflavor)
  write(6,'(3x,"Crystal volume:",f32.14)') crys%celvol
  write(6,'(3x,"Number of G-vectors:",i12)') gvec%ng
  write(6,'(3x,"Number of spins:",i16)') kp%nspin
  if (sheader .eq. 'WFN') then
    write(6,'(3x,"Number of bands:",i16)') kp%mnband
    write(6,'(3x,"Number of k-points:",i13)') kp%nrk
  endif
  write(6,*)

  call write_header_type(8, outformat, sheader, iflavor, kp, gvec, syms, crys)

  SAFE_ALLOCATE(gvec%components, (3, gvec%ng))

  call read_gvectors(7, informat, gvec%ng, gvec%ng, gvec%components)
  call write_gvectors(8, outformat, gvec%ng, gvec%ng, gvec%components)

  if(iflavor == 1) then
    if (sheader .eq. 'WFN') then
      SAFE_ALLOCATE(dwfn, (kp%ngkmax, kp%nspin))
    else
      SAFE_ALLOCATE(dwfn, (gvec%ng, kp%nspin))
    endif
  else
    if (sheader .eq. 'WFN') then
      SAFE_ALLOCATE(zwfn, (kp%ngkmax, kp%nspin*kp%nspinor))
    else if (sheader .eq. 'VXC') then
      SAFE_ALLOCATE(zwfn, (gvec%ng, kp%nspin*kp%nspinor**2))
    else
      SAFE_ALLOCATE(zwfn, (gvec%ng, kp%nspin))
    endif
  endif

  if (sheader .eq. 'WFN') then
    do ik = 1, kp%nrk
      call read_gvectors(7, informat, kp%ngk(ik), kp%ngkmax, gvec%components)
      call write_gvectors(8, outformat, kp%ngk(ik), kp%ngkmax, gvec%components)

      do ib = 1, kp%mnband
        if(iflavor == 1) then
          call read_real_data(7, informat, kp%ngk(ik), kp%ngkmax, kp%nspin, dwfn)
          call write_real_data(8, outformat, kp%ngk(ik), kp%ngkmax, kp%nspin, dwfn)
        else
          call read_complex_data(7, informat, kp%ngk(ik), kp%ngkmax, kp%nspin*kp%nspinor, zwfn)
          call write_complex_data(8, outformat, kp%ngk(ik), kp%ngkmax, kp%nspin*kp%nspinor, zwfn)
        endif
      enddo
    enddo
  else if (sheader .eq. 'VXC' .and. iflavor .ne. 1) then
    call read_complex_data(7, informat, gvec%ng, gvec%ng, kp%nspin*kp%nspinor**2, zwfn)
    call write_complex_data(8, outformat, gvec%ng, gvec%ng, kp%nspin*kp%nspinor**2, zwfn)
  else
    if(iflavor == 1) then
      call read_real_data(7, informat, gvec%ng, gvec%ng, kp%nspin, dwfn)
      call write_real_data(8, outformat, gvec%ng, gvec%ng, kp%nspin, dwfn)
    else
      call read_complex_data(7, informat, gvec%ng, gvec%ng, kp%nspin, zwfn)
      call write_complex_data(8, outformat, gvec%ng, gvec%ng, kp%nspin, zwfn)
    endif
  endif

  if(iflavor == 1) then
    SAFE_DEALLOCATE_P(dwfn)
  else
    SAFE_DEALLOCATE_P(zwfn)
  endif

  SAFE_DEALLOCATE_P(gvec%components)

  call dealloc_header_type(sheader, crys, kp)

  call close_file(7)
  call close_file(8)

  write(6,'(3x,"Done",/)')

end program mf_convert

!===========================================================================
!
! Routines:
!
! (1) write_result()    Originally By ?         Last Modified 7/3/2008 (JRD)
!
!     Writes the quasiparticle spectrum to the output.
!
!===========================================================================

#include "f_defs.h"

module write_result_m

  use global_m
  implicit none

  private
  public :: write_result

contains

subroutine write_result(kp,wfnk,sig,ach_n1,ax,asx,ach,achcor,asig,alda,efsto,enew, &
  zrenorm,ikn)
  type (kpoints), intent(in) :: kp
  type (wfnkstates), intent(in) :: wfnk
  type (siginfo), intent(in) :: sig
  SCALAR, intent(in) :: ach_n1(:,:,:) !< (sig%ntband,sig%ndiag+sig%noffdiag,sig%nspin)
  SCALAR, intent(in) :: ax(:,:) !< (sig%ndiag+sig%noffdiag,sig%nspin)
  SCALAR, intent(in) :: asx(:,:,:) !< (nfreqgpp,sig%ndiag+sig%noffdiag,sig%nspin)
  SCALAR, intent(in) :: ach(:,:,:) !< (nfreqgpp,sig%ndiag+sig%noffdiag,sig%nspin)
  complex(DPC), intent(in) :: achcor(:,:) !< (sig%ndiag+sig%noffdiag,sig%nspin)
  SCALAR, intent(in) :: asig(:,:) !< (sig%ndiag+sig%noffdiag,sig%nspin)
  SCALAR, intent(in) :: alda(:,:) !< (sig%ndiag+sig%noffdiag,sig%nspin)
  real(DP), intent(in) :: efsto(:,:) !< (sig%ndiag,sig%nspin)
  real(DP), intent(in) :: enew(:,:) !< (sig%ndiag,sig%nspin)
  real(DP), intent(in) :: zrenorm(:,:) !< (sig%ndiag,sig%nspin)
  integer, intent(in) :: ikn

  integer :: i, j, ivbm, icbm, idis, ispin, iw
  real(DP) :: sumvcor, sumccor, sumdcor, sumdconv, eval
  real(DP), allocatable :: sumv(:), sumc(:), sumd(:)
  SCALAR :: achconv
  
! Initialization
  
  PUSH_SUB(write_result)
  
  if (sig%freq_dep /= -1 .and. sig%fullConvLog .eq. 0) then
    SAFE_ALLOCATE(sumv, (sig%ntband))
    SAFE_ALLOCATE(sumc, (sig%ntband))
    SAFE_ALLOCATE(sumd, (sig%ntband))
    ivbm=0
    icbm=0
    do i = 1, sig%ndiag
      if (sig%diag(i).eq.sig%nvband) ivbm=i
      if (sig%diag(i).eq.sig%nvband+1) icbm=i
    enddo
  endif
  
  do ispin=1,sig%nspin

! Sigma Diagonal

    if (sig%fdf .eq. -3) then
      do i=1, sig%ndiag
          do iw=1,sig%nfreqeval
            eval = sig%freqevalmin + (iw-1)*sig%freqevalstep
            write(8000,2000) kp%rk(:,ikn), ispin, i, iw, eval, dble(asx(iw,i,ispin)), & 
                          dble(ach(iw,i,ispin))+dble(achcor(i,ispin)), & 
                          dble(asx(iw,i,ispin)+ax(i,ispin)+ach(iw,i,ispin))+dble(achcor(i,ispin))
          enddo
          write(8000,*) ''
      enddo
    endif

2000 format(3F12.5,2x,3i4,2x,4F12.5)

    call write_qp(6)
    call write_qp(7)

! CH Convergence Log

    if(sig%freq_dep .ne. -1 .and. .not. (sig%freq_dep .eq. 0 .and. sig%exact_ch .eq. 1)) then
      if (sig%fullConvLog .eq. 0) then

        write(127,'(a,3e16.8,a,i2)') '# k =', (kp%rk(j,ikn),j=1,3), ' spin=',sig%spin_index(ispin)
        write(127,*) '# n1 <i|Sigma_ch|i> (eV), partial sum'
        write(127,*) '#      nbands   ch(vbm)          ch(cbm)           diff        converged'

        if (ivbm.ne.0) then
          do j = 1, sig%ntband
            sumv(j) = ryd * sum(dble(ach_n1(1:j,ivbm,ispin)))
          enddo
          sumvcor = sumv(sig%ntband) + dble(achcor(ivbm,ispin))
        else
          do j = 1, sig%ntband
            sumv(j) = 0.0d0
          enddo
          sumvcor = 0.0d0
        endif
        if (icbm.ne.0) then
          do j = 1, sig%ntband
            sumc(j) = ryd * sum(dble(ach_n1(1:j,icbm,ispin)))
          enddo
          sumccor = sumc(sig%ntband) + dble(achcor(icbm,ispin))
        else
          do j = 1, sig%ntband
            sumc(j) = 0.0d0
          enddo
          sumccor = 0.0d0
        endif
        do j = 1, sig%ntband
          sumd(j) = sumc(j) - sumv(j)
        enddo
        sumdcor = sumccor - sumvcor

        if (sig%freq_dep .eq. 1 .and. sig%exact_ch .eq. 0) then
          idis = sig%ntband / 10
          if (idis.gt.0) then
            sumdconv = (dble(sig%ntband) * sumd(sig%ntband) - &
              dble(sig%ntband - idis) * sumd(sig%ntband - idis)) / dble(idis)
          else
            sumdconv = 0.0d0
          endif
        else
          sumdconv = sumdcor
        endif

        do j = 1, sig%ntband
          write(127,'(i8,4e16.8)') j, sumv(j), sumc(j), sumd(j), sumdconv
        enddo

      elseif (sig%fullConvLog .eq. 1) then

        write(127,801) (kp%rk(j,ikn),j=1,3), ikn, sig%spin_index(ispin)
        write(127,802) sig%ndiag
        do i = 1, sig%ndiag
          write(127,803) sig%diag(i)
          if (sig%freq_dep .eq. 1 .and. sig%exact_ch .eq. 0) then
            do j = 1, sig%ntband
              write(127,804) j, ryd * sum(dble(ach_n1(1:j,i,ispin)))
            enddo
          else
            achconv = SCALARIFY(achcor(i,ispin)) + ryd * sum(ach_n1(1:sig%ntband,i,ispin))
            do j = 1, sig%ntband
              write(127,804) j, ryd * sum(dble(ach_n1(1:j,i,ispin))), dble(achconv)
            enddo
          endif
        enddo

      elseif (sig%fullConvLog .eq. 2) then

        write(127,801) (kp%rk(j,ikn),j=1,3), ikn, sig%spin_index(ispin)
        write(127,802) sig%ndiag
        do i = 1, sig%ndiag
          write(127,803) sig%diag(i)
          if (sig%freq_dep .eq. 1 .and. sig%exact_ch .eq. 0) then
            do j = 1, sig%ntband
              write(127,804) j, ryd * sum(ach_n1(1:j,i,ispin))
            enddo
          else
            achconv = SCALARIFY(achcor(i,ispin)) + ryd * sum(ach_n1(1:sig%ntband,i,ispin))
            do j = 1, sig%ntband
              write(127,804) j, ryd * sum(ach_n1(1:j,i,ispin)), achconv
            enddo
          endif
        enddo

      endif ! sig%fullConvLog
    endif ! sig%freq_dep

801 format('#',1x,'k =',3f10.6,1x,'ik =',i4,1x,'spin =',i2)
802 format(2x,'nbands',i5)
803 format(2x,'band =',i5)
804 format(i8,4e16.8)

  enddo ! ispin

  if (sig%fullConvLog .eq. 0 .and. sig%freq_dep .ne. 0) then
    SAFE_DEALLOCATE(sumv)
    SAFE_DEALLOCATE(sumc)
    SAFE_DEALLOCATE(sumd)
  endif

  POP_SUB(write_result)

  return

contains

  subroutine write_qp(iunit)
    integer, intent(in) :: iunit

    write(iunit,979) (kp%rk(j,ikn),j=1,3),ikn,sig%spin_index(ispin)
979 format(/,7x,"k =",3f10.6,1x,"ik =",i4,1x,"spin =",i2)   

    write(iunit,978)
978 format(/,3x,"n",5x,"elda",5x,"ecor",8x,"x",5x,"sx-x",7x,"ch", &
      6x,"sig",6x,"vxc",5x,"eqp0",5x,"eqp1",6x,"Znk")

! JRD: Not ideal for fdf -3, but user should see spectrum.dat
    write(iunit,977) (sig%diag(i),wfnk%elda(sig%diag(i),ispin), &
      wfnk%ek(sig%diag(i),ispin),dble(ax(i,ispin)),dble(asx(2,i,ispin)), &
      dble(ach(2,i,ispin)+achcor(i,ispin)),dble(asig(i,ispin)+achcor(i,ispin)), &
      dble(alda(i,ispin)),efsto(i,ispin)+dble(achcor(i,ispin)), &
      enew(i,ispin)+dble(achcor(i,ispin))*zrenorm(i,ispin), &
      zrenorm(i,ispin),i=1,sig%ndiag)
977 format(i4,10f9.3)
    
! Sigma Off-Diagonal

! JRD: Not ideal for fdf -3, but user should see spectrum.dat
    if (sig%noffdiag.gt.0) then
      write(iunit,969)
969 format(/,3x,"n",3x,"m",3x,"l",18x,"x",5x,"sx-x",7x,"ch",6x, &
      "sig",6x,"vxc")

      do i=sig%ndiag+1,sig%ndiag+sig%noffdiag
        write(iunit,968) sig%off1(i-sig%ndiag),sig%off2(i-sig%ndiag), &
          sig%off3(i-sig%ndiag),dble(ax(i,ispin)),dble(asx(2,i,ispin)), &
          dble(ach(2,i,ispin)+achcor(i,ispin)), &
          dble(ax(i,ispin)+asx(2,i,ispin)+ach(2,i,ispin)+achcor(i,ispin)), &
          dble(alda(i,ispin))
968 format(3i4,3x,"real",3x,5f9.3)
#ifdef CPLX
        write(iunit,967) sig%off1(i-sig%ndiag),sig%off2(i-sig%ndiag), &
          sig%off3(i-sig%ndiag),IMAG(ax(i,ispin)),IMAG(asx(2,i,ispin)), &
          IMAG(ach(2,i,ispin)+achcor(i,ispin)), &
          IMAG(ax(i,ispin)+asx(2,i,ispin)+ach(2,i,ispin)+achcor(i,ispin)), &
          IMAG(alda(i,ispin))
967 format(3i4,3x,"imag",3x,5f9.3)
#endif
      enddo
    endif

  end subroutine write_qp

end subroutine write_result

end module write_result_m

#include "f_defs.h"

!*************************************************************************
Module pwHamMod
!*************************************************************************
! The generic name of the module "SpecificHamMod" and the subroutines
! "HGenerate", "HamInfoInit", "HamInfoDestroy",  must be used so they
! are called properly by the general hamiltonian routines
!*************************************************************************
! This module contains all the routines needs for seeting up the
! Plane wave hamiltonian h (a 1d array which is upper triangular part
! of the H matrix of size = hSize)  Size is fixed by energy cutoff
! read from input file in the GVectors module
!*************************************************************************
! Function atomPotential(q2,elementLabel) is called here - It is
! in module AtomPotentialMod - it is the only subroutine
! needs to be changed for different potentials 
!*************************************************************************
! This module uses the following modules:
!    SysParams
!    GVectorsMod
!    Hamiltonian
!    kPointsMod
!    LatticeMod (only for bLatMetricTensor used to find lengths of k + G)
!*************************************************************************
! The module contains the public functions:
!    HGenerate       Generates the plane wave hamiltonian for
!                    the given k point K_Points$kPointsLat(:,k).
!    HamInfoInit     Sets up relevant information for the hamiltonian
!    HamInfoDestroy
!    GridInit
!    GridDestroy
!*************************************************************************
! The module contains the private functions:
!   PotentialInit    Allocates space for initializes potentialV.
!   PotentialDestroy Deallocates the space for potentialV
!*************************************************************************
! The module contains the private variables:
!   potentialV(i)    Fourier component of the crystal (pseudo)potential
!                    for G-vector gVectors(i,:)
!*************************************************************************

  use SysParams,        only : double
  use GVectorsMod,      only : gVectorObjectsT
  Use EigenStatesMod,   only : eigenStatesT
  use typeMod,          only : GridT
  use fftw_m
  use push_pop_m

  implicit none

  save

  type hamInfoT
    integer                    :: hMaxSize
    complex(double),   pointer :: potentialV(:)
    type( gVectorObjectsT ), pointer :: gVectors
  end type hamInfoT
  
  private PotentialInit
  private PotentialDestroy

  contains

!*************************************************************************
  Subroutine HamInfoInit( hamInfo, struct, tagHandler, v_of_q, ff )
!*************************************************************************

    use SysParams,     only : double
    use GVectorsMod,   only : GVectorsInit
    use StructureMod,  only : structureT
    use TagHandlerMod, only : tagHandlerT, FindTag

    implicit none

    type( hamInfoT ),    pointer :: hamInfo
    type( structureT ),  pointer :: struct
    type( tagHandlerT ), pointer :: tagHandler
    logical :: v_of_q
    real ( double ) :: ff(6)

    integer :: error

    PUSH_SUB(HamInfoInit)

    if( associated( hamInfo )) stop 'Error: SpecificHamiltonian already allocated.'
    allocate( hamInfo, stat = error )
    if( error /= 0 ) stop 'Error: SpecificHamiltonian allocation failed.'
    nullify( hamInfo%potentialV )
    nullify( hamInfo%gVectors )

    call GVectorsInit( hamInfo%gVectors, struct, tagHandler, v_of_q )
    call PotentialInit( hamInfo, struct, v_of_q, ff )

    POP_SUB(HamInfoInit)
  end Subroutine HamInfoInit

!*************************************************************************
  Subroutine HamInfoDestroy( hamInfo )
!*************************************************************************

    use GVectorsMod, only : GVectorsDestroy
    implicit none

    type( hamInfoT ), pointer :: hamInfo

    integer :: error

    PUSH_SUB(HamInfoDestroy)
    if( .not. associated( hamInfo )) stop 'Error: SpecificHamiltonian not allocated.'

    call GVectorsDestroy( hamInfo%gVectors )
    call PotentialDestroy( hamInfo )

    deallocate( hamInfo, stat = error )
    if( error /= 0 ) stop 'Error: specificHamiltonian deallocation failed.'

    POP_SUB(HamInfoDestroy)
  end Subroutine HamInfoDestroy

!*************************************************************************
  Subroutine PotentialInit( hamInfo, struct, v_of_q, ff )
!*************************************************************************

!  For all local potentials the Hamiltonian matrix depends on k only through
!  the diagonal terms. The Fourier components of the potential terms 
!  are independent of k and can be set up only once for all k.

    use SysParams,    only : two, twopi, half, double
    use StructureMod, only : StructureT
    use AtomPotentialMod

    implicit none

    real( double ), parameter :: eps6 = 1.0d-6

    type( hamInfoT ),   pointer :: hamInfo
    type( StructureT ), pointer :: struct
    logical :: v_of_q
    real( double ) :: ff(6)

    integer :: error, i, j, i2
    real( double ) :: q2, ffr, ffi, sfr, sfi

    PUSH_SUB(PotentialInit)

    allocate( hamInfo%potentialV(hamInfo%gVectors%numGVectors), stat=error )
    if( error /= 0 ) stop 'Error allocating potential space.'
                
    hamInfo%potentialV(:) = 0

    if (v_of_q) then

      do j = 1, struct%atomBasis%numSpecies
        do i = 1, hamInfo%gVectors%numGVectors

          ! Compute potential at G-vectors
          hamInfo%potentialV(i) = hamInfo%potentialV(i) + &
                  & atomPotential(two * hamInfo%gVectors%kineticE(i), struct%atomBasis%elementLabel(j)) * &
                  & hamInfo%gVectors%structureFactor(i,j)

        end do
      end do

    else

      do i = 1, hamInfo%gVectors%numGVectors

        q2 = two * hamInfo%gVectors%kineticE(i) &
               & * (struct%lattice%latticeConst / twopi)**2
        i2 = int(q2 + eps6)
        if (abs(q2 - dble(i2)) .gt. eps6) &
        stop 'Error, q2 is not integer.'

        select case (i2)
        case(3)
          ffr = ff(1)
          ffi = ff(4)
        case(4)
          ffr = 0.0d0
          ffi = ff(5)
        case(8)
          ffr = ff(2)
          ffi = 0.0d0
        case(11)
          ffr = ff(3)
          ffi = ff(6)
        case default
          ffr = 0.0d0
          ffi = 0.0d0
        end select
        ffr = ffr * half
        ffi = ffi * half

        sfr = dble(hamInfo%gVectors%structureFactor(i,1))
        sfi = -aimag(hamInfo%gVectors%structureFactor(i,1))

        hamInfo%potentialV(i) = hamInfo%potentialV(i) + &
                & cmplx(ffr * sfr, ffi * sfi, kind = double)

      end do

    endif

    ! Explicitly put the potential at the origin to be zero.
    hamInfo%PotentialV(hamInfo%gVectors%gVecIndex(0,0,0)) = cmplx(0.d0,0.d0,kind=double)

    POP_SUB(PotentialInit)
  end Subroutine PotentialInit

!*************************************************************************
  Subroutine PotentialDestroy( hamInfo )
!*************************************************************************

    implicit none

    type( hamInfoT ), pointer :: hamInfo
    integer :: error

    PUSH_SUB(PotentialDestroy)

    deallocate( hamInfo%potentialV, stat=error )
    if(error /= 0) stop 'Error deallocating potential space.'

    POP_SUB(PotentialDestroy)
  end Subroutine PotentialDestroy


!*************************************************************************
  Subroutine FindhMaxSize( hamInfo, struct, kPoints )
!*************************************************************************

!   This subroutine goes through the same loops as for generating the Hamiltonian
!   in order to find the maximum memory needed 
!
!   Output is hamInfo%hMaxSize which is defined in module variables and is public

    use SysParams,     only : double, two
    use StructureMod,  only : StructureT
    use kPointsMod,    only : kPointsT

    implicit none

    type( StructureT ),   pointer :: struct
    type( kPointsT ),     pointer :: kPoints
    type( hamInfoT ),     pointer :: hamInfo
    integer                        :: i
    integer                        :: k, hSize, ktemp 
    real(double)                   :: ek
    real(double), dimension(3)     :: kPlusG

    PUSH_SUB(FindhMaxSize)

    hamInfo%hMaxSize = 0

    do k = 1, kPoints%numKPoints

    hSize = 0
    kPlusG = 0

! This section is
! inefficient since their are a lot of G vectors in gVectors that
! will never be within the energy cut off radius, because all of the
! G vectors within two times the cut off radius are stored in gVectors
! for the structure factor calculation.

       do i = 1, hamInfo%gVectors%numGVectors

         kPlusG(1:struct%ndim) = kPoints%kPointsLat(:,k) + hamInfo%gVectors%gVectors(:,i)
         ek = dot_product(kPlusG(1:struct%ndim), &
             & matmul(struct%lattice%bLatMetricTensor, kPlusG(1:struct%ndim)))/two

         if(ek <= hamInfo%gVectors%energyCutOff) then
           hSize        = hSize + 1
         end if

       end do


       if(hSize < kPoints%numBands) then
         print *, 'Error number of bands = ', kPoints%numBands, &
             & ' > size of the hamiltonian = ', hSize, &
             & ' for kPoint = ', k
         stop
       end if


       if(hSize > hamInfo%hMaxSize) then
         hamInfo%hMaxSize = hSize ! hamInfo%hMaxSize set to largest hSize
         ktemp = k
       end if 

    end do

!  print *, 'Maximum size of the hamiltonian = ', hamInfo%hMaxSize, &
!                & ' for k point = ', ktemp, numKPoints
!  print *, 'In recip. lattice basis vectors, this k point is:'
!  print *, kPointsLat(:,ktemp)

    POP_SUB(FindhMaxSize)
  end Subroutine FindhMaxSize

!*************************************************************************
  Subroutine KineticGenerate(hamInfo,struct,kPoints,eigenStates,k,Kinetic, & 
       & hSize)
!*************************************************************************

!   This subroutine will fill up the kinetic energy T_{G} array of the 
!   hamiltonian. T_{G} = |k+G|^2/2, and the range of G is such that the 
!   energy cutoff is satisfied.

    use EigenStatesMod,   only : eigenStatesT
    use SysParams,        only : double, two
    use StructureMod,     only : StructureT
    use kPointsMod,       only : kPointsT

    Implicit None

    type( StructureT ),   pointer :: struct
    type( kPointsT ),     pointer :: kPoints
    type( eigenStatesT ), pointer :: eigenStates
    type( hamInfoT ),     pointer :: hamInfo

    integer, intent(in)           :: k
    integer                       :: hSize,i
    real(double)                  :: ek
    real(double), dimension(3)    :: kPlusG
    real(double), dimension(:)    :: Kinetic

    PUSH_SUB(KineticGenerate)

    hSize = 0
    kPlusG = 0

    do i = 1, hamInfo%gVectors%numGVectors
       kPlusG(1:struct%ndim) = kPoints%kPointsLat(:,k) + & 
            & hamInfo%gVectors%gVectors(:,i) 
       ek = dot_product(kPlusG(1:struct%ndim), &
            & matmul(struct%lattice%bLatMetricTensor, & 
            & kPlusG(1:struct%ndim)))/two

       if(ek <= hamInfo%gVectors%energyCutOff) then
          hSize        = hSize + 1
          Kinetic(hSize) = ek
          eigenStates%basisIndex(hSize,k) = i

       end if
    end do

    POP_SUB(KineticGenerate)
  end Subroutine KineticGenerate

!*************************************************************************
  Subroutine PotentialRGenerate(hamInfo,Grid)
!*************************************************************************

!   This subroutine will put the Potential_{G} array on the grid, the backward
!   fourier transform into V_{r}

    Type(hamInfoT),           pointer :: hamInfo
    Type(GridT),              pointer :: Grid
    integer                           :: i,j,k,s,ii

    PUSH_SUB(PotentialRGenerate)

    ! size of the VGrid has to be up to maxGLen
    Grid%V = cmplx(0.d0,0.d0,kind=double)

    ! Translation
    do i = 1, 2*Grid%Size(1)
       do j = 1, 2*Grid%Size(2)
          do k = 1, 2*Grid%Size(3)
             ii = Grid%GInvIndex(i-1-Grid%Size(1), &
                  & j-1-Grid%Size(2),k-1-Grid%Size(3))
             if (ii.gt.0) Grid%V(i,j,k) = hamInfo%PotentialV(ii)
          end do
       end do
    end do

    ! This is so that the final grid VPsi_G is centered at the origin.
    do i = 1, 2*Grid%Size(1)
       do j = 1, 2*Grid%Size(2)
          do k = 1, 2*Grid%Size(3)
             s = i+j+k-3
             Grid%V(i,j,k) = Grid%V(i,j,k)*(-1)**s
          end do
       end do
    end do

    POP_SUB(PotentialRGenerate)
  end Subroutine PotentialRGenerate

!*************************************************************************
  Subroutine HGenerate( hamInfo, struct, kPoints, eigenStates, &
                      & k, h, sqH, hSize )
!*************************************************************************

    use EigenStatesMod,   only : eigenStatesT
    use SysParams,        only : double, two
    use StructureMod,     only : StructureT
    use kPointsMod,       only : kPointsT

    implicit none

    type( StructureT ),   pointer :: struct
    type( kPointsT ),     pointer :: kPoints
    type( eigenStatesT ), pointer :: eigenStates
    type( hamInfoT ),     pointer :: hamInfo
    integer, intent(in)            :: k
    complex(double), intent(inout) :: h(:)     
    complex(double), intent(inout) :: SqH(:,:)     
    integer, intent(inout)         :: hSize

    integer, dimension(3)          :: gg       
    integer                        :: i,j,indx
    real(double)                   :: ek
    real(double), dimension(3)     :: kPlusG

    !!!!!!!!!!!!!!!! CHANGED ddas !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    integer :: N

    PUSH_SUB(HGenerate)

    N = 180
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    hSize = 0
    kPlusG = 0

    ! For each G vector calculate the kinetic energy if it is less than the 
    ! cut off energy add a row for it on the hamiltonian insert the kinetic
    ! energy along the diagonal.  BasisIndex is used to store the indices 
    ! of the G vectors that are in the hamiltonian.  This section is
    ! inefficient since their are a lot of G vectors in gVectors that
    ! will never be within the energy cut off radius, because all of the
    ! G vectors within two times the cut off radius are stored in gVectors
    ! for the structure factor calculation.

    do i = 1, hamInfo%gVectors%numGVectors

      kPlusG(1:struct%ndim) = kPoints%kPointsLat(:,k) + hamInfo%gVectors%gVectors(:,i) 
      ek = dot_product(kPlusG(1:struct%ndim), &
        & matmul(struct%lattice%bLatMetricTensor, kPlusG(1:struct%ndim)))/two

      if(ek <= hamInfo%gVectors%energyCutOff) then

        hSize        = hSize + 1
        h(hSize * (hSize + 1) / 2) = ek

        SqH(hSize,hSize) = ek                       ! For the square matrix

        eigenStates%basisIndex(hSize,k) = i

      end if
    end do

!!$    !!!!!!!!!!!!!!! CHANGED ddas !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!$    do i = 1, N
!!$       SqH(i,i) = cmplx(1.d0,0.d0,kind=double)    
!!$    end do
!!$
!!$    do i = 1, N
!!$       do j = i+1, N
!!$          SqH(i,j) = cmplx(0.d0,0.d0,kind=double)
!!$          SqH(j,i) = conjg(SqH(i,j))
!!$       end do
!!$    end do
!!$    !!!!!!!!!!!!!!! CHANGED ddas !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    eigenStates%numBasisVectors(k) = hSize

    if(hSize < kPoints%numBands) then
      print *, 'Error number of bands = ', kPoints%numBands, &
             & ' > size of the hamiltonian = ', hSize
      stop
    end if

    ! For each row in the hamiltonian store the kinetic energy along the
    ! diagonal and calculate the off diagonal terms.
    do i = 1, hSize

      do j = i+1, hSize

        gg(1:struct%ndim) = &
      & hamInfo%gVectors%gVectors(1:struct%ndim, eigenStates%basisIndex(i, k))&
    & - hamInfo%gVectors%gVectors(1:struct%ndim, eigenStates%basisIndex(j, k))
        if(struct%ndim < 3) gg(struct%ndim+1:3) = 0
        indx = hamInfo%gVectors%gVecIndex(gg(1),gg(2),gg(3))    ! index for G-G` vector
        h(i+j*(j-1)/2) = hamInfo%potentialV(indx)

        SqH(i,j) = hamInfo%potentialV(indx)
        SqH(j,i) = conjg(SqH(i,j))

      end do
    end do

    POP_SUB(HGenerate)
  end Subroutine HGenerate

!*************************************************************************
  Subroutine CalculateDensity( hamInfo, kPoints, eigenStates, densityArray )
!*************************************************************************

    use EigenStatesMod,  only : eigenStatesT
    use densityArrayMod, only : densityArrayT
    use StructureMod,    only : StructureT
    use kPointsMod,      only : kPointsT

    implicit none

    type( kPointsT ),       pointer :: kPoints
    type( densityArrayT ),  pointer :: densityArray
    type( eigenStatesT ),   pointer :: eigenStates
    type( hamInfoT ),       pointer :: hamInfo
    integer :: n, k, ig

    integer, allocatable :: identity(:)

    PUSH_SUB(CalculateDensity)

    densityArray%densityArray(:,:,:) = 0

    do k = 1, kPoints%numKPoints
      do n = 1, kPoints%numOccupiedBands
        call put_into_fftbox(eigenStates%numBasisVectors(k), eigenStates%eigenVectors(:, n, k), hamInfo%gVectors%gVectors, &
          eigenStates%basisIndex(:, k), densityArray%waveFunction, densityArray%gridDimensions)
        call do_FFT(densityArray%waveFunction, densityArray%gridDimensions, -1)
        ! normalization
        densityArray%waveFunction = densityArray%waveFunction / sqrt(dble(densityArray%gridSize))
        densityArray%densityArray = densityArray%densityArray + &
          & densityArray%waveFunction*conjg(densityArray%waveFunction) &
          & *kPoints%kPointWeights(k)
      end do
    end do

    call do_FFT(densityArray%densityArray, densityArray%gridDimensions, +1)
    allocate(identity(hamInfo%gVectors%numGVectors))
    do ig = 1, hamInfo%gVectors%numGVectors
      identity(ig) = ig
    enddo
    call get_from_fftbox(hamInfo%gVectors%numGVectors, densityArray%rhog, hamInfo%gVectors%gVectors, identity, &
      densityArray%densityArray, densityArray%gridDimensions, 1d0)
    deallocate(identity)
!    write(0,*) 'RHO G=0 : ', densityArray%rhog(hamInfo%gVectors%gVecIndex(0, 0, 0)), &
!      hamInfo%gVectors%gVectors(:, hamInfo%gVectors%gVecIndex(0, 0, 0))

    call destroy_fftw_plans()

    POP_SUB(CalculateDensity)
  end Subroutine CalculateDensity

!*************************************************************************
  Subroutine GridInit(Grid,hamInfo,eigenStates,ndim)
!*************************************************************************

    type(GridT),                               pointer :: Grid
    type(hamInfoT),                            pointer :: hamInfo
    Type(eigenStatesT),                        pointer :: eigenStates    
    integer,                                   intent(in) :: ndim      

    PUSH_SUB(GridInit)

    !  Allocate space for the Grid Type
    allocate(Grid)
    nullify(Grid%V)
    nullify(Grid%Psi)
    nullify(Grid%VPsi)
    nullify(Grid%VPsiG)
    nullify(Grid%Work)
    nullify(Grid%GVecIndex)
    nullify(Grid%GInvIndex)
    nullify(Grid%BasisIndex)

    !  Length of the Grid in each direction
    Grid%Size = hamInfo%gVectors%maxGLen

    Grid%fac = dble(8*Grid%Size(1)*Grid%Size(2)*Grid%Size(3))

    !  Number of GVectors
    Grid%NumGVec = hamInfo%gVectors%numGVectors

    !  Allocate space for the VGrid, and initialise it to zero
    allocate(Grid%V(2*Grid%Size(1),2*Grid%Size(2),2*Grid%Size(3)))
    allocate(Grid%Psi(2*Grid%Size(1),2*Grid%Size(2),2*Grid%Size(3)))
    allocate(Grid%VPsi(2*Grid%Size(1),2*Grid%Size(2),2*Grid%Size(3)))

    allocate(Grid%VPsiG(-Grid%Size(1):Grid%Size(1),-Grid%Size(2):Grid%Size(2),&
         &  -Grid%Size(3):Grid%Size(3)))


    Grid%V   = cmplx(0.d0,0.d0,kind=double)

    !  Allocate and Initialise the Grid Index
    allocate(Grid%GVecIndex(ndim,Grid%NumGVec))
    Grid%GVecIndex = hamInfo%gVectors%gVectors

    allocate(Grid%GInvIndex( &
         & -hamInfo%gVectors%maxGLen(1):hamInfo%gVectors%maxGLen(1), &
         & -hamInfo%gVectors%maxGLen(2):hamInfo%gVectors%maxGLen(2), &
         & -hamInfo%gVectors%maxGLen(3):hamInfo%gVectors%maxGLen(3)))
    Grid%GInvIndex = hamInfo%gVectors%gVecIndex

    allocate(Grid%BasisIndex(EigenStates%maxBasisVectors, & 
         & EigenStates%numKPoints))

    POP_SUB(GridInit)
  end Subroutine GridInit

!*************************************************************************
  Subroutine GridDestroy(Grid)
!*************************************************************************
! by DAS. original developers did not see fit to include such a thing.

    type(GridT), pointer :: Grid !< intent not permitted for pointer

    integer :: error

    PUSH_SUB(GridDestroy)

    deallocate(Grid%V, Grid%Psi, Grid%VPsi, Grid%VPsiG, Grid%GVecIndex, &
         & Grid%GInvIndex, Grid%BasisIndex, stat = error)
    if( error /= 0 ) stop 'Error deallocating Grid space.'
    deallocate(Grid, stat = error)
    if( error /= 0 ) stop 'Error deallocating Grid.'

    POP_SUB(GridDestroy)
  end Subroutine GridDestroy

end Module pwHamMod

!================================================================================
!
! Routines:
!
! 1. trunc_scell_box_d()        Originally By JRD       Last Modified 8/10/2010 (gsm)
!
!    WARNING - THIS ROUTINE IS CURRENTLY NOT TESTED UNDER THE TESTSUITE. 
!    IT NEEDS TO BE VALIDATED (COMPARED TO CELL_BOX_D) BEFORE USED IN PRODUCTION!!!
!
!    Modification of trunc_cell_box_d to perform calculation on a supercell
!    and fold it into q-points.
!
!    Calculate Coulomb interaction with SuperCell Box Truncation.
!
!    The Coulomb potential is calculated through FFT on the extended cell.
!
!    n_in_box is a (positive integer) parameter for real-space resolution.
!    If the energy cutoff is too small, then the FFT grid may not be very
!    dense and the Coulomb singularity at r=0 may be poorly handled.
!    Larger values of n_in_box will add extra points in between the original
!    FFT grid. If the original grid has N points covering a space of length
!    L, then the grid used to do 3-dimensional FFTs will have N * n_in_box
!    points covering a space of length L.
!
!    When V_coul(x,y,z) is calculated, we add a shift on the grid in
!    order to avoid the singularity at x = y = z = 0.
!
!    Output is truncated Vcoul(G_1,G_2,G_3) in reciprocal space such that,
!    without truncation, its value would be:
!
!             Vcoul(ig) = 8 Pi/(q + G)*2
!
!    for each G-vector  G = gvec%components(:,isrtq(ig)) in the list.
!
!    Calculation is distributed over processors but array vcoul returns
!    with global value.
!
!================================================================================

#include "f_defs.h"

subroutine trunc_scell_box_d(gvec,verbose,inode,npes,bdot,q,qgrid,ncoul,isrtq,vcoul,work_scell)

  use global_m
  use fft_parallel_m
  use fftw_m
  use misc_m
  implicit none

  type (gspace),      intent(in)    :: gvec         !< Reciprocal space structure
  logical,            intent(in)    :: verbose      !< Flag for extra output on unit 6
  integer,            intent(in)    :: inode, npes  !< MPI parameters: processor rank, number of processors
  real(DP),           intent(in)    :: bdot(3,3)    !< Metric matrix in reciprocal space
  real(DP),           intent(in)    :: q(3)         !< q-vector
  integer,            intent(in)    :: qgrid(3)     !< q-grid
  integer,            intent(in)    :: ncoul        !< Number of G-vectors
  integer,            intent(in)    :: isrtq(ncoul) !< Indices of G-vectors
  real(DP),           intent(out)   :: vcoul(ncoul) !< Coulomb potential
  type (twork_scell), intent(inout) :: work_scell   !< Work structure to store data computed on first call

  logical, save :: first_call = .true.
  integer :: i1, i2, i3, j1, j2, j3, l1, l2, l3, ig, &
    Nfft(3), dNfft(3), dkmax(3), Nrod, Nplane, i, j, k, iq(3), NSize(3)
  real(DP) :: r_len, rr(3), t_len, tt(3), adot(3,3), scale, dscale, phase, vimag, vdummy, b(3,3), sq(3)
  complex(DPC) :: vtemp
  real(DP), allocatable :: xdummy(:)
  complex(DPC), allocatable :: fftbox_2D(:,:,:)
  complex(DPC), allocatable :: fftbox_temp(:,:,:)
  complex(DPC), allocatable :: buffer_2D(:,:,:)
  complex(DPC), allocatable :: buffer_1D(:,:,:)
  integer, allocatable :: inv_indx(:,:,:)

  PUSH_SUB(trunc_scell_box_d)

! Initialize FFT grids.

  call setup_FFT_sizes(gvec%FFTgrid,Nfft,scale)
  dkmax(1) = gvec%FFTgrid(1) * n_in_box
  dkmax(2) = gvec%FFTgrid(2) * n_in_box
  dkmax(3) = gvec%FFTgrid(3) * n_in_box
  call setup_FFT_sizes(dkmax,dNfft,dscale)

! Initialize real-space metric.

  rr = 0.0d0
  call invert_matrix(bdot, adot)
  adot = adot * 4.0d0 * PI_D * PI_D
  
  do i =1,3
    do j=1,3
      adot(i,j) = adot(i,j) / dble(dNfft(i) * dNfft(j))
    enddo
  enddo

  do i = 1, 3
    dNfft(i) = dNfft(i) * qgrid(i)
  enddo

! Initialize boxes.

  call fft_set_p(dNfft,Nplane,Nrod)

  if (first_call) then

    SAFE_ALLOCATE(fftbox_2D, (dNfft(1),dNfft(2),Nplane))
    SAFE_ALLOCATE(work_scell%fftbox_1D, (dNfft(3),Nrod))
    SAFE_ALLOCATE(buffer_2D, (Nrod,Nplane,npes))
    SAFE_ALLOCATE(buffer_1D, (Nrod,Nplane,npes))

    if (verbose) then
      if (inode .eq. 0) then
        write(6,555) qgrid, dNfft, n_in_box
      endif
    endif
555 format(/,1x,"Supercell truncation.",/,2x,"Building truncated Coulomb", &
      1x,"potential using 2-D/1-D FFTs.",/,2x,"Supercell =",3i3,2x, &
      "2-D/1-D FFT grid =",3i5,/,2x,"Extra points between two points", &
      1x,"in a 2-D/1-D FFT grid =",i3,/)

  endif ! first_call

  sq(1:3) = q(1:3) * dble(qgrid(1:3))
  call k_range(sq, iq, TOL_Small)
  if (any(abs(sq(1:3)) .gt. TOL_Small)) call die('supercell truncation: q-vector mismatch')

! Invert G-index

  SAFE_ALLOCATE(inv_indx, (Nfft(1),Nfft(2),Nfft(3)))
  call fft_map_s(ncoul,Nfft,isrtq,gvec%components,inv_indx)

  if (first_call) then

! For each G_3 plane, calculate the potential V_trunc(r1,r2,r3).
! The potential is not zero only inside the Wigner-Seitz cell.

    fftbox_2D(:,:,:)=(0.0d0,0.0d0)
    do i3 = Nplane*inode+1, min(Nplane*(inode+1),dNfft(3))
      rr(3) = dble(i3 - 1) + trunc_shift(3)
      do i2 = 1, dNfft(2)
        rr(2) = dble(i2 - 1) + trunc_shift(2)
        do i1 = 1, dNfft(1)
          rr(1) = dble(i1 - 1) + trunc_shift(1)
          
          r_len = INF
          
          do l3 = -ncell+1, ncell
            tt(3) = rr(3) - dble(l3 * dNfft(3))
            do l2 = -ncell+1, ncell
              tt(2) = rr(2) - dble(l2 * dNfft(2))
              do l1 = -ncell+1, ncell
                tt(1) = rr(1) - dble(l1 * dNfft(1))
                t_len = dot_product(tt,matmul(adot,tt))
                if (t_len < r_len) r_len = t_len
              enddo
            enddo
          enddo
          
          r_len = sqrt(r_len)
          
          fftbox_2D(i1,i2,i3-Nplane*inode) = 1.0d0 / r_len
          
        enddo
      enddo
    enddo

!---------------------------------------
! gsm: Below is equivalent to fft_r2g_p/_s except we multiply by a phase,
!      collect the real part and check that the imaginary part is smaller
!      than the tolerance. Calling fft_r2g_p directly and then altering
!      the result would cost extra memory and code execution.

! Do two-dimensional Fourier transforms:
! V_trunc(r1,r2,r3) -> V_trunc(G_1,G_2,r3)

    NSize(:)=dNfft(:)
    NSize(3)=1
    SAFE_ALLOCATE(fftbox_temp,(NSize(1),NSize(2),NSize(3)))
    do i = 1, Nplane
      fftbox_temp(:,:,1)=fftbox_2D(:,:,i)
      call do_FFT(fftbox_temp,NSize,-1)
      fftbox_2D(:,:,i)=fftbox_temp(:,:,1)
    enddo
    SAFE_DEALLOCATE(fftbox_temp)

! Transfer data from fftbox_2D to fftbox_1D

    buffer_2D(:,:,:)=(0.0d0,0.0d0)
    do k = 1, Nplane
      do i2 = 1, dNfft(2)
        do i1 = 1, dNfft(1)
          i = (i2-1)*dNfft(1)+i1-1
          j = i/Nrod
          buffer_2D(i-j*Nrod+1,k,j+1) = fftbox_2D(i1,i2,k)
        enddo
      enddo
    enddo
#ifdef MPI
    call MPI_Alltoall(buffer_2D(1,1,1),Nrod*Nplane,MPI_COMPLEX_DPC, &
      buffer_1D(1,1,1),Nrod*Nplane,MPI_COMPLEX_DPC,MPI_COMM_WORLD,mpierr)
#else
    buffer_1D(:,:,:)=buffer_2D(:,:,:)
#endif
    do i3 = 1, dNfft(3)
      do i = 1, Nrod
        j = (i3-1)/Nplane
        work_scell%fftbox_1D(i3,i) = buffer_1D(i,i3-j*Nplane,j+1)
      enddo
    enddo

! Do one-dimensional Fourier transforms:
! V_trunc(G_1,G_2,r3) -> V_trunc(G_1,G_2,G_3)

    NSize(:)=1
    NSize(1)=dNfft(3)
    SAFE_ALLOCATE(fftbox_temp,(NSize(1),NSize(2),NSize(3)))
    do i = 1, Nrod
      fftbox_temp(:,1,1)=work_scell%fftbox_1D(:,i)
      call do_FFT(fftbox_temp,NSize,-1)
      work_scell%fftbox_1D(:,i)=fftbox_temp(:,1,1)
    enddo
    SAFE_DEALLOCATE(fftbox_temp)

  endif ! first_call

! Collect components of V_trunc for G-vectors in Coulomb list.

  vcoul = 0.0d0
  vimag = 0.0d0
  do j3 = - Nfft(3)/2, Nfft(3) - Nfft(3)/2 - 1
    l3 = j3 + 1
    if (j3 < 0) l3 = Nfft(3) + l3
    i3 = j3 * qgrid(3) + iq(3) + 1
    if (i3 < 1) i3 = dNfft(3) + i3
    if (i3 > dNfft(3)) cycle
    do j2 = - Nfft(2)/2, Nfft(2) - Nfft(2)/2 - 1
      l2 = j2 + 1
      if (j2 < 0) l2 = Nfft(2) + l2
      i2 = j2 * qgrid(2) + iq(2) + 1
      if (i2 < 1) i2 = dNfft(2) + i2
      if (i2 > dNfft(2)) cycle
      do j1 = - Nfft(1)/2, Nfft(1) - Nfft(1)/2 - 1
        l1 = j1 + 1
        if (j1 < 0) l1 = Nfft(1) + l1
        i1 = j1 * qgrid(1) + iq(1) + 1
        if (i1 < 1) i1 = dNfft(1) + i1
        if (i1 > dNfft(1)) cycle
        ig = inv_indx(l1,l2,l3)
        if (ig == 0) cycle
        i = (i2-1)*dNfft(1)+i1-1
        j = i/Nrod

! (gsm) [2010-06-17] there was a bug here
! the singularity of the Coulomb potential was shifted from
! the origin of the coordinate system by half a grid step

!            if (j == inode) vcoul(ig) = &
!            dble(fftbox_1D(i3,i-j*Nrod+1))

        if (j == inode) then
          phase = dble(j1 * qgrid(1) + iq(1)) * trunc_shift(1) / dble(dNfft(1)) &
            + dble(j2 * qgrid(2) + iq(2)) * trunc_shift(2) / dble(dNfft(2)) &
            + dble(j3 * qgrid(3) + iq(3)) * trunc_shift(3) / dble(dNfft(3))
          phase = 2.0d0 * PI_D * phase
          vtemp = work_scell%fftbox_1D(i3,i-j*Nrod+1)
          vtemp = vtemp * CMPLX(cos(phase), -sin(phase))
          vcoul(ig) = dble(vtemp)
          vdummy = abs(IMAG(vtemp))
          if (vdummy.gt.vimag) vimag=vdummy
        endif
      enddo
    enddo
  enddo

#ifdef MPI
  if (npes .gt. 1) then
    vdummy = vimag
    call MPI_Reduce(vdummy, vimag, 1, MPI_REAL_DP, MPI_MAX, 0, MPI_COMM_WORLD, mpierr)
  endif
#endif
  if (vimag.gt.TOL_Small) &
    call die("The Coulomb interaction was incorrectly computed as complex: most likely a problem with your FFT library.", &
    only_root_writes = .true.)

  if (first_call) then
 
    call destroy_fftw_plans()   
    SAFE_DEALLOCATE(fftbox_2D)
    SAFE_DEALLOCATE(buffer_2D)
    SAFE_DEALLOCATE(buffer_1D)
    
  endif ! first_call

  SAFE_DEALLOCATE(inv_indx)

! Rescale with the volume of the unit cell.

  b = adot
  scale = b(1,1)*(b(2,2)*b(3,3) - b(2,3)**2) &
    + 2*b(1,2)*b(2,3)*b(3,1) &
    - b(2,2)*b(1,3)**2 - b(3,3)*b(1,2)**2
  scale = 2.0d0 * dsqrt(scale)
  vcoul = vcoul * scale
  
! Global reduction if there is more than one processor.

#ifdef MPI
  if (npes .gt. 1) then
    SAFE_ALLOCATE(xdummy, (ncoul))
    xdummy = vcoul
    call MPI_Allreduce(xdummy, vcoul, ncoul, MPI_REAL_DP, MPI_SUM, MPI_COMM_WORLD, mpierr)
    SAFE_DEALLOCATE(xdummy)
  endif
#endif

  first_call = .false.

  POP_SUB(trunc_scell_box_d)
  
  return
end subroutine trunc_scell_box_d

!===============================================================================
!
! Program:
!
! (1) SAPO             Originally By gsm        Last Modified 12/24/2012 (gsm)
!
! The SAPO (Simple Approximate Physical Orbitals) code reads DFT
! wavefunctions from WFN file, generates additional wavefunctions on top
! of them, and writes both to another WFN file. It can generate plane waves,
! decompose them into irreducible representations of the space group of the
! Bravais lattice or the crystal, and orthonormalize them with respect to
! DFT wavefunctions. It can insert SIESTA wavefunctions read from auxiliary
! WFN file in between plane waves and orthonormalize them altogether.
! It can apply a random variation to the plane waves and SIESTA wavefunctions
! or generate completely random wavefunctions and orthonormalize them.
! It can correct eigenvalues during orthonormalization or perform subspace
! diagonalization. It can drop the plane waves and SIESTA wavefunctions which
! have a large overlap with DFT wavefunctions. It can keep wavefunctions with
! the eigenvalues in a given energy range. It can extract eigenvalues and
! plane wave coefficients from WFN file for plotting purposes.
!
! The SAPO method is described in Phys. Rev. Lett. 107, 186404 (2011)
!
! 2012-12-24 (gsm): added iterative Davidson diagonalization, see
! examples/DFT/Si2_sapo for details
!
! Note: wfng_input_file should contain all occupied orbitals (and may or
! may not contain some unoccupied orbitals), otherwise occupations written
! to wfng_output_file will be wrong.
!
! Note: Symmetrization of planewaves (sapo_symmetry .gt. 0) has no effect
! on a SAPO calculation since it is just a linear combination in a degenerate
! subspace. It is currently disabled because it requires symmetry subroutines
! from Quantum ESPRESSO. To enable it open MeanField/SAPO/pw.f90, comment out
! die, and uncomment s_axis_to_cart, find_group, set_irr_rap, divide_class.
!
! Input is read from file sapo.inp.
!
!===============================================================================

#include "f_defs.h"

program SAPO

  use global_m
  use check_inversion_m
  use fft_parallel_m
  use groupk_m
  use random_m
  use sort_m
  use symmetries_m
  use wfn_rho_vxc_io_m
  use pw_m
  use ortho_m
  use hdiag_m
  implicit none

!------------------------
! Allocatable arrays

  integer, pointer :: atyp(:)
  real(DP), pointer :: apos(:,:)
  real(DP), pointer :: kw(:)
  real(DP), pointer :: kpt(:,:)
  integer, pointer :: ifmin(:,:)
  integer, pointer :: ifmax(:,:)
  real(DP), pointer :: occ(:,:,:)
  real(DP), pointer :: en(:,:,:)
  real(DP), allocatable :: ensrt(:)
  integer, allocatable :: gvec(:,:)
  integer, allocatable :: gvectmp(:,:)
  integer, pointer :: ngk(:)
  SCALAR, allocatable :: wfn(:,:)
  SCALAR, allocatable :: wfnaux(:,:)
  SCALAR, allocatable :: wfn_d(:,:,:,:)
  SCALAR, allocatable :: wfnsrt_d(:,:)
  integer, allocatable :: index_vec(:)
  integer, allocatable :: isort(:)
  integer, allocatable :: srtmap(:)
  integer, allocatable :: idummy(:)
  integer, allocatable :: isort_d(:,:)
  integer, allocatable :: pw_num(:,:,:)
  integer, allocatable :: pw_ind(:,:,:,:,:)
  integer, allocatable :: isrti(:)
  integer, allocatable :: isrtort(:,:,:)
  SCALAR, allocatable :: vsc(:,:)
  SCALAR, allocatable :: vsc_d(:,:)
  integer, allocatable :: idrop(:)
  integer, allocatable :: ityp(:)
  integer, allocatable :: nh(:)
  real(DP), allocatable :: deeq(:,:,:,:)
  complex(DPC), allocatable :: vkb(:,:)
  complex(DPC), allocatable :: vkb_d(:,:,:,:)
  SCALAR, allocatable :: wfnsp(:)
  SCALAR, allocatable :: wfnspdummy(:)
  real(DP), allocatable :: ekin(:)
  integer, allocatable :: isrt(:)
  integer, allocatable :: rdeg(:,:)
  integer, allocatable :: ideg(:)
  real(DP), allocatable :: proj(:,:)
  real(DP), allocatable :: projdummy(:,:)
  real(DP), allocatable :: amplx(:)
  real(DP), allocatable :: amply(:)
  real(DP), allocatable :: ampldummy(:)
  real(DP), allocatable :: comp(:)
  real(DP), allocatable :: compdummy(:)
  real(DP), pointer :: en_i(:,:,:)
  integer, pointer :: atyp_x(:)
  real(DP), pointer :: apos_x(:,:)
  integer, pointer :: ngk_x(:)
  real(DP), pointer :: kw_x(:)
  real(DP), pointer :: kpt_x(:,:)
  integer, pointer :: ifmin_x(:,:)
  integer, pointer :: ifmax_x(:,:)
  real(DP), pointer :: en_x(:,:,:)
  real(DP), pointer :: occ_x(:,:,:)
  real(DP), pointer :: apos_lat(:,:)

!------------------------
! Local variables

  logical :: sapo_energy_match,sapo_print_ir,aux_flag, &
    sapo_random_norm,sapo_overlap_flag,sapo_orthonormal, &
    sapo_ortho_energy,sapo_energy_sort,sapo_hamiltonian, &
    sapo_ham_resinc,sapo_do_all_bands,sapo_energy_range, &
    sapo_check_norm,sapo_eigenvalue,sapo_amplitude, &
    pw_flag,vkbg_flag,out_flag,pwsym,ffastsp,ffastsp_ib, &
    forder,fecor,fsym,fout,fshift,fvkbg,fparafft,fparala, &
    fblas,fblas_ort,fblas_ham
  integer :: sapo_band_number,sapo_planewave_min, &
    sapo_planewave_max,sapo_symmetry,aux_band_min, &
    aux_band_max,sapo_random,sapo_ortho_block, &
    sapo_ortho_order,sapo_plot_kpoint,sapo_plot_spin, &
    sapo_plot_bandmin,sapo_plot_bandmax,sapo_plot_pwmin, &
    sapo_plot_pwmax,sapo_projection,sapo_ampl_num, &
    sapo_ham_nrestart,sapo_ham_ndiag,sapo_ham_ndim, &
    cell_symmetry,iflavor,i,j,k,iadd,iout,ierr,info, &
    nFFTgridpts,is,ik,ib,ib1,ib2,jb,ig,jg,nsym,nsyml,nsymk, &
    npwdeg,ns,nk,nb,nbinp,nbaux,nbauxtot,nbpw,nbtot,nbmax, &
    nbstart,nbend,ng,ngkmax,ng_l,ng_g,ngk_l,ngk_g,b2g, &
    ndeg,mdeg,ipw,ipw1,ipw2,iat,isp,ih,jh,nat,nsp,ikb,nkb, &
    nhm,seed,ncount,iblock,iorder,idir,FFTgrid(3),kgrid(3), &
    rot(3,3,48),rotl(3,3,48),rotk(3,3,48),values(8), &
    ns_x,ng_x,nsym_x,cell_symmetry_x,nat_x,nk_x,ngkmax_x, &
    FFTgrid_x(3),kgrid_x(3),rot_x(3,3,48),real_or_complex, &
    spacegroup
  real(DP) :: sapo_energy_shift,aux_energy_shift,sapo_random_ampl, &
    sapo_overlap_max,sapo_energy_min,sapo_energy_max,sapo_ampl_del, &
    sapo_ampl_brd,sapo_ham_tol,ecutrho,ecutwfn,arnd,brnd,x, &
    celvol,recvol,al,bl,eshift,dotmax,dotcur,tsec(2),a(3,3), &
    b(3,3),adot(3,3),bdot(3,3),kshift(3),kvec(3),tau(3,48), &
    ecutrho_x,ecutwfn_x,kshift_x(3),celvol_x,al_x,a_x(3,3), &
    adot_x(3,3),recvol_x,bl_x,b_x(3,3),bdot_x(3,3),tau_x(3,48), &
    taul(3,48)
  SCALAR :: z
  character :: stitle*32,sdate*32,stime*32
  character(len=256) :: wfng_input_file,wfng_aux_file, &
    vscg_input_file,vkbg_input_file,wfng_output_file,tmpstr
  character(len=16) :: s1,s2,s3,s4,s5,s6
  character(len=16) :: routnam(26)
  character :: sheader*3
  character*21 :: symbol

!------------------------
! Parameters

  integer, parameter :: drnd = 500000
  integer, parameter :: nrnd = 5000000
  character(len=256), parameter :: sapo_input_file = 'sapo.inp'

!------------------------
! Input namelist

  namelist /input_sapo/ wfng_input_file, wfng_aux_file, &
    vscg_input_file, vkbg_input_file, wfng_output_file, &
    sapo_band_number, sapo_planewave_min, sapo_planewave_max, &
    sapo_energy_shift, sapo_energy_match, sapo_symmetry, &
    sapo_print_ir, aux_flag, aux_band_min, aux_band_max, &
    aux_energy_shift, sapo_random, sapo_random_ampl, &
    sapo_random_norm, sapo_overlap_flag, sapo_overlap_max, &
    sapo_orthonormal, sapo_ortho_block, sapo_ortho_order, &
    sapo_ortho_energy, sapo_energy_sort, sapo_hamiltonian, &
    sapo_ham_nrestart, sapo_ham_ndiag, sapo_ham_ndim, &
    sapo_ham_tol, sapo_ham_resinc, sapo_do_all_bands, &
    sapo_energy_range, sapo_energy_min, sapo_energy_max, &
    sapo_check_norm, sapo_plot_kpoint, sapo_plot_spin, &
    sapo_plot_bandmin, sapo_plot_bandmax, sapo_plot_pwmin, &
    sapo_plot_pwmax, sapo_eigenvalue, sapo_projection, &
    sapo_amplitude, sapo_ampl_num, sapo_ampl_del, sapo_ampl_brd

!------------------------
! Inirialize MPI

  call peinfo_init()

#ifdef MPI
  fblas_ort=.true.
  fblas_ham=.true.
  fparafft=.true.
#else
  fblas_ort=.true.
  fblas_ham=.true.
  fparafft=.false.
#endif

#ifdef USESCALAPACK
  fparala=.true.
#else
  fparala=.false.
#endif

#ifdef CPLX
  real_or_complex = 2
#else
  real_or_complex = 1
#endif

!------------------------
! Check libraries

  ierr=0
  if (fparala) then
#ifndef USESCALAPACK
    call die('ScaLAPACK is not available.')
#endif
  endif ! fparala

!------------------------
! Initialize timer

  call timacc(0,0)
  
  call timacc(1,1)
  
  call timacc(2,1)

!------------------------
! Write header

  call write_program_header('SAPO', .false.)

!------------------------
! Read input file

  if (peinf%inode.eq.0) then
    write(6,801) trim(sapo_input_file)
    wfng_input_file = ''
    wfng_aux_file = ''
    vscg_input_file = ''
    vkbg_input_file = ''
    wfng_output_file = ''
    sapo_band_number = -1
    sapo_planewave_min = 0
    sapo_planewave_max = 0
    sapo_energy_shift = 0.0d0
    sapo_energy_match = .false.
    sapo_symmetry = 0
    sapo_print_ir = .false.
    aux_flag = .false.
    aux_band_min = 0
    aux_band_max = 0
    aux_energy_shift = 0.0d0
    sapo_random = 0
    sapo_random_ampl = 0.0d0
    sapo_random_norm = .false.
    sapo_overlap_flag = .false.
    sapo_overlap_max = 0.0d0
    sapo_orthonormal = .false.
    sapo_ortho_block = 0
    sapo_ortho_order = 0
    sapo_ortho_energy = .false.
    sapo_energy_sort = .false.
    sapo_hamiltonian = .false.
    sapo_ham_nrestart = 0
    sapo_ham_ndiag = 0
    sapo_ham_ndim = 0
    sapo_ham_tol = 0.0d0
    sapo_ham_resinc = .false.
    sapo_do_all_bands = .false.
    sapo_energy_range = .false.
    sapo_energy_min = 0.0d0
    sapo_energy_max = 0.0d0
    sapo_check_norm = .false.
    sapo_plot_kpoint = 0
    sapo_plot_spin = 0
    sapo_plot_bandmin = 0
    sapo_plot_bandmax = 0
    sapo_plot_pwmin = 0
    sapo_plot_pwmax = 0
    sapo_eigenvalue = .false.
    sapo_projection = 0
    sapo_amplitude = .false.
    sapo_ampl_num = 0
    sapo_ampl_del = 0.0d0
    sapo_ampl_brd = 0.0d0
    call open_file(55,file=sapo_input_file,status='old',form='formatted')
    read(55,input_sapo,iostat=ierr)
    if (ierr.eq.0) call close_file(55)
    if (sapo_band_number.lt.-1.or. &
      sapo_planewave_min.lt.0.or. &
      sapo_planewave_max.lt.sapo_planewave_min.or. &
      sapo_symmetry.lt.0.or.sapo_symmetry.gt.2.or. &
      aux_band_min.lt.0.or. &
      aux_band_max.lt.aux_band_min.or. &
      sapo_random.lt.0.or.sapo_random.gt.2.or. &
      sapo_random_ampl.lt.-TOL_Zero.or. &
      sapo_overlap_max.lt.-TOL_Zero.or. &
      sapo_overlap_max.gt.1.0d0+TOL_Zero.or. &
      sapo_ortho_block.lt.0.or.sapo_ortho_block.gt.2.or. &
      sapo_ortho_order.lt.0.or.sapo_ortho_order.gt.1.or. &
      sapo_energy_max.lt.(sapo_energy_min-TOL_Zero).or. &
      sapo_plot_kpoint.lt.0.or. &
      sapo_plot_spin.lt.0.or. &
      sapo_plot_bandmin.lt.0.or. &
      sapo_plot_bandmax.lt.sapo_plot_bandmin.or. &
      sapo_plot_pwmin.lt.0.or. &
      sapo_plot_pwmax.lt.sapo_plot_pwmin.or. &
      sapo_projection.lt.0.or.sapo_projection.gt.7.or. &
      (sapo_amplitude.and.(sapo_ampl_num.le.0.or. &
      sapo_ampl_del.lt.TOL_Small.or.sapo_ampl_brd.lt.TOL_Small))) &
      ierr=1
    if (ierr.eq.0) then
      pw_flag=sapo_planewave_max.ne.0
      if (pw_flag.and.sapo_energy_match.and. &
        sapo_planewave_min.lt.2) then
        write(0,921)
        sapo_energy_match=.false.
      endif
      if (pw_flag.and.sapo_energy_match.and. &
        abs(sapo_energy_shift).gt.TOL_Zero) then
        write(0,922)
        sapo_energy_shift=0.0d0
      endif
      if (sapo_symmetry.gt.0.and..not.pw_flag) then
        write(0,923)
        sapo_symmetry=0
      endif
      if (aux_flag.and.len(trim(wfng_aux_file)).eq.0) then
        write(0,924)
        aux_flag=.false.
      endif
      if (sapo_random.ne.0.and..not.sapo_do_all_bands.and. &
        .not.pw_flag.and..not.aux_flag) then
        write(0,937)
        sapo_random=0
      endif
      if (sapo_random.eq.2) then
        if (sapo_symmetry.gt.0) write(0,925)
        if (aux_flag) write(0,926)
      endif
      if (sapo_overlap_flag.and..not.pw_flag.and..not.aux_flag) then
        write(0,927)
        sapo_overlap_flag=.false.
      endif
      if (sapo_overlap_flag.and.(sapo_planewave_min.gt.1.or. &
        aux_band_min.gt.1)) then
        write(0,928)
      endif
      if (sapo_orthonormal.and..not.sapo_do_all_bands.and. &
        .not.pw_flag.and..not.aux_flag) then
        write(0,929)
        sapo_orthonormal=.false.
      endif
      if (sapo_orthonormal.and.sapo_ortho_block.eq.2.and. &
        (.not.pw_flag.or..not.aux_flag)) then
        write(0,930)
        if (.not.aux_flag) sapo_ortho_block=0
        if (.not.pw_flag) sapo_ortho_block=1
      endif
      if (sapo_overlap_flag.and.sapo_orthonormal.and. &
        pw_flag.and.aux_flag.and.sapo_ortho_block.ne.2) then
        write(0,931)
        sapo_overlap_flag=.false.
      endif
      if (sapo_orthonormal.and.sapo_ortho_energy.and. &
        .not.pw_flag.and..not.aux_flag) then
        write(0,932)
        sapo_ortho_energy=.false.
      endif
      if (sapo_energy_sort.and..not.pw_flag.and..not.aux_flag) then
        write(0,933)
        sapo_energy_sort=.false.
      endif
      if (sapo_hamiltonian.and.len(trim(vscg_input_file)).eq.0) then
        write(0,934)
        sapo_hamiltonian=.false.
      endif
      if (sapo_hamiltonian.and..not.sapo_do_all_bands.and. &
        .not.pw_flag.and..not.aux_flag) then
        write(0,935)
        sapo_hamiltonian=.false.
      endif
      if (sapo_energy_range.and..not.(sapo_energy_sort.or. &
        sapo_hamiltonian)) then
        write(0,936)
        sapo_energy_range=.false.
      endif
      vkbg_flag=sapo_hamiltonian.and.len(trim(vkbg_input_file)).ne.0
      ffastsp=pw_flag.and.sapo_random.eq.0.and.sapo_orthonormal
      out_flag=len(trim(wfng_output_file)).ne.0
    endif
  endif
#ifdef MPI
  call MPI_Bcast(ierr,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
  if (ierr.ne.0) then
    call die('failed to read input file ' // trim(sapo_input_file), only_root_writes = .true.)
  endif
#ifdef MPI
  call MPI_Bcast(wfng_input_file,256,MPI_CHARACTER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(wfng_aux_file,256,MPI_CHARACTER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(vscg_input_file,256,MPI_CHARACTER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(vkbg_input_file,256,MPI_CHARACTER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(wfng_output_file,256,MPI_CHARACTER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_band_number,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_planewave_min,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_planewave_max,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_energy_shift,1,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_energy_match,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_symmetry,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_print_ir,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(aux_flag,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(aux_band_min,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(aux_band_max,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(aux_energy_shift,1,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_random,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_random_ampl,1,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_random_norm,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_overlap_flag,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_overlap_max,1,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_orthonormal,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_ortho_block,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_ortho_order,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_ortho_energy,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_energy_sort,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_hamiltonian,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_ham_nrestart,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_ham_ndiag,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_ham_ndim,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_ham_tol,1,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_ham_resinc,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_do_all_bands,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_energy_range,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_energy_min,1,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_energy_max,1,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_check_norm,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_plot_kpoint,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_plot_spin,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_plot_bandmin,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_plot_bandmax,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_plot_pwmin,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_plot_pwmax,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_eigenvalue,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_projection,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_amplitude,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_ampl_num,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_ampl_del,1,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(sapo_ampl_brd,1,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(pw_flag,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(vkbg_flag,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(ffastsp,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(out_flag,1,MPI_LOGICAL,0,MPI_COMM_WORLD,mpierr)
#endif

!------------------------
! Read header of input wavefunction file

  if (peinf%inode.eq.0) then
    call open_file(7,file=wfng_input_file,status='old',form='unformatted')
  endif ! peinf%inode.eq.0
  sheader = 'WFN'
  iflavor = 0
  call read_binary_header(7, sheader, iflavor, ns, ng, nsym, &
    cell_symmetry, nat, nk, nb, ngkmax, ecutrho, ecutwfn, FFTgrid, &
    kgrid, kshift, celvol, al, a, adot, recvol, bl, b, bdot, &
    rot, tau, atyp, apos, ngk, kw, kpt, ifmin, ifmax, en_i, occ, &
    dont_warn_kgrid = .true.)

!------------------------
! Check if real/complex version is appropriate

  call check_inversion(real_or_complex, nsym, rot, ns, .true., .true., tnp = tau)

!------------------------
! Read header of auxiliary wavefunction file

  nbauxtot = 0
  if (aux_flag) then
    if (peinf%inode.eq.0) then
      call open_file(8,file=wfng_aux_file,status='old',form='unformatted')
    endif ! peinf%inode.eq.0
    sheader = 'WFN'
    iflavor = 0
    call read_binary_header(8, sheader, iflavor, ns_x, ng_x, nsym_x, &
      cell_symmetry_x, nat_x, nk_x, nbauxtot, ngkmax_x, ecutrho_x, ecutwfn_x, &
      FFTgrid_x, kgrid_x, kshift_x, celvol_x, al_x, a_x, adot_x, recvol_x, &
      bl_x, b_x, bdot_x, rot_x, tau_x, atyp_x, apos_x, ngk_x, kw_x, kpt_x, &
      ifmin_x, ifmax_x, en_x, occ_x, dont_warn_kgrid = .true.)
    
    ierr=0
    if (ns_x .ne. ns) ierr = 1
    if (ng_x .ne. ng) ierr = 2
    if (nsym_x .ne. nsym) ierr = 3
    if (cell_symmetry_x .ne. cell_symmetry) ierr = 4
    if (nat_x .ne. nat) ierr = 5
    if (nk_x .ne. nk) ierr = 6
    if (ngkmax_x .ne. ngkmax) ierr = 7
    if (abs(ecutrho_x - ecutrho) .gt. TOL_Small) ierr = 8
    if (abs(ecutwfn_x - ecutwfn) .gt. TOL_Small) ierr = 9
    if (any(FFTgrid_x(1:3) .ne. FFTgrid(1:3))) ierr = 10
    if (any(kgrid_x(1:3) .ne. kgrid(1:3))) ierr = 11
    if (any(abs(kshift_x(1:3) - kshift(1:3)) .gt. TOL_Small)) ierr = 12
    if (abs(celvol_x / celvol - 1.0d0) .gt. TOL_Small) ierr = 13
    if (abs(recvol_x / recvol - 1.0d0) .gt. TOL_Small) ierr = 14
    if (any(abs(al_x * a_x(1:3, 1:3) / al - a(1:3, 1:3)) .gt. TOL_Small)) ierr = 15
    if (any(abs(bl_x * b_x(1:3, 1:3) / bl - b(1:3, 1:3)) .gt. TOL_Small)) ierr = 16
    !if (any(rot_x(1:3, 1:3, 1:nsym_x) .ne. rot(1:3, 1:3, 1:nsym))) ierr = 17
    !if (any(abs(tau_x(1:3, 1:nsym_x) - tau(1:3, 1:nsym)) .gt. TOL_Small)) ierr = 18
    if (any(atyp_x(1:nat_x) .ne. atyp(1:nat))) ierr = 19
    if (any(abs(al_x * apos_x(1:3, 1:nat_x) / al - apos(1:3, 1:nat)) .gt. TOL_Small)) ierr = 20
    if (any(ngk_x(1:nk_x) .ne. ngk(1:nk))) ierr = 21
    if (any(abs(kw_x(1:nk_x) - kw(1:nk)) .gt. TOL_Small)) ierr = 22
    if (any(abs(kpt_x(1:3, 1:nk_x) - kpt(1:3, 1:nk)) .gt. TOL_Small)) ierr = 23
    
    if (ierr.ne.0) then
      call die('different content in wavefunction files ' // trim(wfng_input_file) // ' and ' // &
        trim(wfng_aux_file), only_root_writes = .true.)
    endif ! ierr
    
    SAFE_DEALLOCATE_P(atyp_x)
    SAFE_DEALLOCATE_P(apos_x)
    SAFE_DEALLOCATE_P(ngk_x)
    SAFE_DEALLOCATE_P(kw_x)
    SAFE_DEALLOCATE_P(kpt_x)
    SAFE_DEALLOCATE_P(ifmin_x)
    SAFE_DEALLOCATE_P(ifmax_x)
    SAFE_DEALLOCATE_P(occ_x)
  endif ! aux_flag

!------------------------
! Distribute G-vectors over processors, set internal variables,
! and print report to stdout

  if (mod(ng,peinf%npes).eq.0) then
    ng_l=ng/peinf%npes
  else
    ng_l=ng/peinf%npes+1
  endif
  ng_g=ng_l*peinf%npes
  
  if (mod(ngkmax,peinf%npes).eq.0) then
    ngk_l=ngkmax/peinf%npes
  else
    ngk_l=ngkmax/peinf%npes+1
  endif
  ngk_g=ngk_l*peinf%npes
  
  nFFTgridpts=FFTgrid(1)*FFTgrid(2)*FFTgrid(3)
  
  nbinp=sapo_band_number
  if (nbinp.eq.-1.or.nbinp.gt.nb) nbinp=nb
  
  if (sapo_planewave_min.eq.0) sapo_planewave_min=1
  if (sapo_planewave_max.eq.0) sapo_planewave_max=1
  if (sapo_planewave_min.gt.ng) sapo_planewave_min=ng
  if (sapo_planewave_max.gt.ng) sapo_planewave_max=ng
  if (pw_flag) then
    nbpw=sapo_planewave_max-sapo_planewave_min+1
    b2g=nbinp+1-sapo_planewave_min
  else
    nbpw=0
    b2g=0
  endif
  
  if (aux_band_min.eq.0) aux_band_min=1
  if (aux_band_max.eq.0) aux_band_max=nbauxtot
  if (aux_band_min.gt.nbauxtot) aux_band_min=nbauxtot
  if (aux_band_max.gt.nbauxtot) aux_band_max=nbauxtot
  if (aux_flag) then
    nbaux=aux_band_max-aux_band_min+1
  else
    nbaux=0
  endif
  
  nbtot=nbinp+nbpw+nbaux
  nbmax=nbtot
  
  if (peinf%inode.eq.0) then
    
    write(s1,101)nsym
    write(s2,101)nk
    write(s3,101)ns
    write(s4,101)nb
    write(s5,101)ng
    write(s6,101)ngkmax
    write(6,110)TRUNC(s1),TRUNC(s2),TRUNC(s3),TRUNC(s4), &
      TRUNC(s5),TRUNC(s6)
    write(s1,101)ng_l
    write(s2,101)ng_g
    write(s3,101)ngk_l
    write(s4,101)ngk_g
    write(6,120)TRUNC(s1),TRUNC(s2),TRUNC(s3),TRUNC(s4)
    write(s1,101)FFTgrid(1)
    write(s2,101)FFTgrid(2)
    write(s3,101)FFTgrid(3)
    write(s4,101)nFFTgridpts
    write(6,130)TRUNC(s1),TRUNC(s2),TRUNC(s3),TRUNC(s4)
    write(s1,101)nbinp
    write(s2,101)nbpw
    write(s3,101)b2g
    write(s4,101)nbaux
    write(s5,101)nbtot
    write(6,140)TRUNC(s1),TRUNC(s2),TRUNC(s3),TRUNC(s4), &
      TRUNC(s5)
    
  endif

!------------------------
! Distribute input and auxiliary eigenvalues

  SAFE_ALLOCATE(en, (nbmax,nk,ns))
  
  do is=1,ns
    do ik=1,nk
      do ib=1,nbinp
        en(ib,ik,is)=en_i(ib,ik,is)
      enddo
    enddo
  enddo
  do is=1,ns
    do ik=1,nk
      do ib=nbinp+1,nbinp+nbpw
        en(ib,ik,is)=0.0d0
      enddo
    enddo
  enddo
  if (aux_flag) then
    do is=1,ns
      do ik=1,nk
        do ib=aux_band_min,aux_band_max
          jb=ib-aux_band_max+nbtot
          en(jb,ik,is)=en_x(ib,ik,is)+aux_energy_shift/RYD
        enddo
      enddo
    enddo
  endif
  
  SAFE_DEALLOCATE_P(en_i)
  SAFE_DEALLOCATE_P(en_x)
  
#ifdef MPI
  call MPI_Bcast(en(1,1,1),nbmax*nk*ns,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
#endif

!------------------------
! Allocate distributed arrays for wavefunctions

  SAFE_ALLOCATE(wfn_d, (ngk_l,nbmax,ns,nk))
  SAFE_ALLOCATE(isort_d, (ngk_l,nk))

!------------------------
! Reset output wavefunction file

  if (out_flag) then
    if (peinf%inode.eq.0) then
      call open_file(9,file=wfng_output_file,status='replace',form='unformatted')
      if (ierr.eq.0) call close_file(9)
    endif
#ifdef MPI
    call MPI_Bcast(ierr,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
    if (ierr.ne.0) then
      call die('failed to write wavefunction file ' // trim(wfng_output_file), only_root_writes = .true.)
    endif
    if (peinf%inode.eq.0) then
      call open_file(9,file=wfng_output_file,status='old',form='unformatted')
    endif
  endif ! out_flag
  
  call timacc(2,2)
  
  call timacc(3,1)

!------------------------
! Read master list of G-vectors

  if (peinf%inode.eq.0) then
    write(6,802) trim(wfng_input_file)
  endif
  
  SAFE_ALLOCATE(gvec, (3, ng))
  call read_binary_gvectors(7, ng, ng, gvec)

!------------------------
! Allocate and compute index_vec indices

  SAFE_ALLOCATE(index_vec, (nFFTgridpts))
  index_vec=0
  do ig=1,ng
    iadd=((gvec(1,ig)+FFTgrid(1)/2)*FFTgrid(2)+gvec(2,ig)+FFTgrid(2)/2)* &
      FFTgrid(3)+gvec(3,ig)+FFTgrid(3)/2+1
    index_vec(iadd)=ig
  enddo

!------------------------
! Loop over k-points

  SAFE_ALLOCATE(gvectmp, (3, ngkmax))
  SAFE_ALLOCATE(wfn, (ngk_g,ns))
  SAFE_ALLOCATE(isort, (ngk_g))
  
  do ik=1,nk

!------------------------
! Read g-vectors for current k-point
! Determine their indices in list of g-vectors
! Distribute index arrays over processors

    call read_binary_gvectors(7, ngk(ik), ngkmax, gvectmp, bcast = .false.)
    if (peinf%inode.eq.0) then
      ierr=0
      isort(:)=0
      do ig=1,ngk(ik)
        info=0
        iout=((gvectmp(1,ig)+FFTgrid(1)/2)*FFTgrid(2)+gvectmp(2,ig)+FFTgrid(2)/2)* &
          FFTgrid(3)+gvectmp(3,ig)+FFTgrid(3)/2+1
        if (iout.ge.1.and.iout.le.nFFTgridpts) then
          iout=index_vec(iout)
          if (iout.ge.1.and.iout.le.ng) then
            if (gvectmp(1,ig).ne.gvec(1,iout).or.gvectmp(2,ig).ne. &
              gvec(2,iout).or.gvectmp(3,ig).ne.gvec(3,iout)) info=-1
          else
            info=-1
          endif
        else
          info=-1
        endif
        isort(ig)=iout
        ierr=ierr+info
      enddo
    endif
#ifdef MPI
    call MPI_Bcast(ierr,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
    if (ierr.ne.0) then
      write(s1,101)ik
      call die('failed to find G-vector for k-point ' // TRUNC(s1), only_root_writes = .true.)
    endif
#ifdef MPI
    call MPI_Barrier(MPI_COMM_WORLD,mpierr)
    call MPI_Scatter(isort,ngk_l,MPI_INTEGER,isort_d(:,ik),ngk_l, &
      MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#else
    isort_d(:,ik)=isort(:)
#endif

!------------------------
! Read band and spin wavefunctions for current k-point
! and distribute over processors

    do ib=1,nbinp
      wfn(:,:)=ZERO
      call read_binary_data(7, ngk(ik), ngk_g, ns, wfn, bcast = .false.)
      do is=1,ns
#ifdef MPI
        ! FHJ: The following barrier is likely superfluous, but can help
        ! mitigate buffer overflows. Uncomment it if you experience MPI errors.
        !call MPI_Barrier(MPI_COMM_WORLD,mpierr) ! Uncomment if you have MPI errors
        call MPI_Scatter(wfn(:,is),ngk_l,MPI_SCALAR, &
          wfn_d(:,ib,is,ik),ngk_l,MPI_SCALAR, &
          0,MPI_COMM_WORLD,mpierr)
#else
        wfn_d(:,ib,is,ik)=wfn(:,is)
#endif
      enddo
    enddo
    
    if (ik .lt. nk) then
      do ib=nbinp+1,nb
        call read_binary_data(7, ngk(ik), ngk_g, ns, wfn, dont_read = .true.)
      enddo
    endif
    
  enddo ! ik
  
  SAFE_DEALLOCATE(gvectmp)
  SAFE_DEALLOCATE(wfn)
  SAFE_DEALLOCATE(isort)

  call timacc(3,2)
  
  call timacc(4,1)

!------------------------
! Read auxiliary wavefunction file

  if (aux_flag) then
    
    if (peinf%inode.eq.0) then
      write(6,802) trim(wfng_aux_file)
    endif
    
    SAFE_ALLOCATE(gvectmp, (3, ng))
    call read_binary_gvectors(8, ng, ng, gvectmp, bcast = .false.)
    SAFE_DEALLOCATE(gvectmp)

!------------------------
! Loop over k-points

    SAFE_ALLOCATE(gvectmp, (3, ngkmax))
    SAFE_ALLOCATE(wfn, (ngk_g,ns))
    SAFE_ALLOCATE(isort, (ngk_g))
    SAFE_ALLOCATE(srtmap, (ngk_g))
    SAFE_ALLOCATE(idummy, (ngk_g))
    SAFE_ALLOCATE(wfnaux, (ngkmax,ns))
    
    do ik=1,nk

!------------------------
! Read g-vectors for current k-point
! Determine their indices in list of g-vectors

      call read_binary_gvectors(8, ngk(ik), ngkmax, gvectmp, bcast = .false.)
      if (peinf%inode.eq.0) then
        ierr=0
        isort(:)=0
        do ig=1,ngk(ik)
          info=0
          iout=((gvectmp(1,ig)+FFTgrid(1)/2)*FFTgrid(2)+gvectmp(2,ig)+FFTgrid(2)/2)* &
            FFTgrid(3)+gvectmp(3,ig)+FFTgrid(3)/2+1
          if (iout.ge.1.and.iout.le.nFFTgridpts) then
            iout=index_vec(iout)
            if (iout.ge.1.and.iout.le.ng) then
              if (gvectmp(1,ig).ne.gvec(1,iout).or.gvectmp(2,ig).ne. &
                gvec(2,iout).or.gvectmp(3,ig).ne.gvec(3,iout)) info=-1
            else
              info=-1
            endif
          else
            info=-1
          endif
          isort(ig)=iout
          ierr=ierr+info
        enddo
      endif
#ifdef MPI
      call MPI_Bcast(ierr,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
      if (ierr.ne.0) then
        write(s1,101)ik
        call die('failed to find G-vector for k-point ' // TRUNC(s1), only_root_writes = .true.)
      endif
#ifdef MPI
      call MPI_Bcast(isort,ngk_g,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif

!------------------------
! Build a sorting map between aux isort indices
! and inp isort_d distributed indices

      srtmap(:)=0
      do ig=1,ngk(ik)
        do jg=1,ngk_l
          if (isort(ig).eq.isort_d(jg,ik)) &
            srtmap(ig)=peinf%inode*ngk_l+jg
        enddo
      enddo
#ifdef MPI
      idummy(:)=srtmap(:)
      call MPI_Reduce(idummy,srtmap,ngk_g, &
        MPI_INTEGER,MPI_SUM,0,MPI_COMM_WORLD,mpierr)
#endif

!------------------------
! Read band and spin wavefunctions for current k-point
! reorder them according to the sorting map
! and distribute over processors

      do ib=1,aux_band_min-1
        call read_binary_data(8, ngk(ik), ngkmax, ns, wfnaux, dont_read = .true.)
      enddo
      do ib=aux_band_min,aux_band_max
        jb=ib-aux_band_max+nbtot
        call read_binary_data(8, ngk(ik), ngkmax, ns, wfnaux, bcast = .false.)
        if (peinf%inode.eq.0) then
          wfn(:,:)=ZERO
          do is=1,ns
            do ig=1,ngk(ik)
              wfn(srtmap(ig),is)=wfnaux(ig,is)
            enddo
          enddo
        endif
        do is=1,ns
#ifdef MPI
          !call MPI_Barrier(MPI_COMM_WORLD,mpierr) ! Uncomment if you have MPI errors
          call MPI_Scatter(wfn(:,is),ngk_l,MPI_SCALAR, &
            wfn_d(:,jb,is,ik),ngk_l,MPI_SCALAR, &
            0,MPI_COMM_WORLD,mpierr)
#else
          wfn_d(:,jb,is,ik)=wfn(:,is)
#endif
        enddo
      enddo
      do ib=aux_band_max+1,nbauxtot
        call read_binary_data(8, ngk(ik), ngkmax, ns, wfnaux, dont_read = .true.)
      enddo
      
    enddo ! ik
    
    SAFE_DEALLOCATE(gvectmp)
    SAFE_DEALLOCATE(wfn)
    SAFE_DEALLOCATE(isort)
    SAFE_DEALLOCATE(srtmap)
    SAFE_DEALLOCATE(idummy)
    SAFE_DEALLOCATE(wfnaux)
    
  endif ! aux_flag
  
  call timacc(4,2)
  
  call timacc(11,1)

!------------------------
! Check self-consistent potential file

  if (sapo_hamiltonian) then
    if (peinf%inode.eq.0) then
      call open_file(10,file=vscg_input_file,status='old',form='unformatted')
    endif ! peinf%inode.eq.0
    sheader = 'VXC'
    iflavor = 0
    call read_binary_header(10, sheader, iflavor, ns_x, ng_x, nsym_x, &
      cell_symmetry_x, nat_x, nk_x, nbauxtot, ngkmax_x, ecutrho_x, ecutwfn_x, &
      FFTgrid_x, kgrid_x, kshift_x, celvol_x, al_x, a_x, adot_x, recvol_x, &
      bl_x, b_x, bdot_x, rot_x, tau_x, atyp_x, apos_x, ngk_x, kw_x, kpt_x, &
      ifmin_x, ifmax_x, en_x, occ_x, dont_warn_kgrid = .true.)

    ierr=0
    if (ns_x .ne. ns) ierr = 1
    if (ng_x .ne. ng) ierr = 2
    if (nsym_x .ne. nsym) ierr = 3
    if (cell_symmetry_x .ne. cell_symmetry) ierr = 4
    if (nat_x .ne. nat) ierr = 5
    if (abs(ecutrho_x - ecutrho) .gt. TOL_Small) ierr = 8
    if (any(FFTgrid_x(1:3) .ne. FFTgrid(1:3))) ierr = 10
    if (abs(celvol_x / celvol - 1.0d0) .gt. TOL_Small) ierr = 13
    if (abs(recvol_x / recvol - 1.0d0) .gt. TOL_Small) ierr = 14
    if (any(abs(al_x * a_x(1:3, 1:3) / al - a(1:3, 1:3)) .gt. TOL_Small)) ierr = 15
    if (any(abs(bl_x * b_x(1:3, 1:3) / bl - b(1:3, 1:3)) .gt. TOL_Small)) ierr = 16
    !if (any(rot_x(1:3, 1:3, 1:nsym_x) .ne. rot(1:3, 1:3, 1:nsym))) ierr = 17
    !if (any(abs(tau_x(1:3, 1:nsym_x) - tau(1:3, 1:nsym)) .gt. TOL_Small)) ierr = 18
    if (any(atyp_x(1:nat_x) .ne. atyp(1:nat))) ierr = 19
    if (any(abs(al_x * apos_x(1:3, 1:nat_x) / al - apos(1:3, 1:nat)) .gt. TOL_Small)) ierr = 20

    if (ierr.ne.0) then
      call die('failed to read potential file ' // trim(vscg_input_file), only_root_writes = .true.)
    endif ! ierr.ne.0

    SAFE_DEALLOCATE_P(atyp_x)
    SAFE_DEALLOCATE_P(apos_x)
  endif ! sapo_hamiltonian

!------------------------
! Check Kleinman-Bylander projectors file

  if (vkbg_flag) then
    if (peinf%inode.eq.0) then
      call open_file(11,file=vkbg_input_file,status='old',form='unformatted')
      
      read(11) stitle, sdate, stime
      read(11) ns_x, ng_x, nsym_x, cell_symmetry_x, nat_x, ecutrho_x, &
        nk_x, nsp, nkb, nhm, ngkmax_x, ecutwfn_x
      read(11) (FFTgrid_x(i), i = 1, 3), (kgrid_x(i), i = 1, 3), (kshift_x(i), i = 1, 3)
      read(11) celvol_x, al_x, ((a_x(j, i), j = 1, 3), i = 1, 3), &
        ((adot_x(j, i), j = 1, 3), i = 1, 3)
      read(11) recvol_x, bl_x, ((b_x(j, i), j = 1, 3), i = 1, 3), &
        ((bdot_x(j, i), j = 1, 3), i = 1, 3)
      read(11) (((rot_x(k, j, i), k = 1, 3), j = 1, 3), i = 1, nsym_x)
      read(11) ((tau_x(j, i), j = 1, 3), i = 1, nsym_x)
      
      SAFE_ALLOCATE(atyp_x, (nat_x))
      SAFE_ALLOCATE(apos_x, (3, nat_x))
      SAFE_ALLOCATE(ngk_x, (nk_x))
      SAFE_ALLOCATE(kw_x, (nk_x))
      SAFE_ALLOCATE(kpt_x, (3, nk_x))
      
      read(11) ((apos_x(j, i), j = 1, 3), atyp_x(i), i = 1, nat_x)
      read(11) (ngk_x(i), i = 1, nk_x)
      read(11) (kw_x(i), i = 1, nk_x)
      read(11) ((kpt_x(j, i), j = 1, 3), i = 1, nk_x)
      
      ierr=0
      if (stitle(1:11) /= 'VKB-Complex') ierr = -1
      if (ns_x .ne. ns) ierr = 1
      if (ng_x .ne. ng) ierr = 2
      if (nsym_x .ne. nsym) ierr = 3
      if (cell_symmetry_x .ne. cell_symmetry) ierr = 4
      if (nat_x .ne. nat) ierr = 5
      if (nk_x .ne. nk) ierr = 6
      if (ngkmax_x .ne. ngkmax) ierr = 7
      if (abs(ecutrho_x - ecutrho) .gt. TOL_Small) ierr = 8
      if (abs(ecutwfn_x - ecutwfn) .gt. TOL_Small) ierr = 9
      if (any(FFTgrid_x(1:3) .ne. FFTgrid(1:3))) ierr = 10
      if (any(kgrid_x(1:3) .ne. kgrid(1:3))) ierr = 11
      if (any(abs(kshift_x(1:3) - kshift(1:3)) .gt. TOL_Small)) ierr = 12
      if (abs(celvol_x / celvol - 1.0d0) .gt. TOL_Small) ierr = 13
      if (abs(recvol_x / recvol - 1.0d0) .gt. TOL_Small) ierr = 14
      if (any(abs(al_x * a_x(1:3, 1:3) / al - a(1:3, 1:3)) .gt. TOL_Small)) ierr = 15
      if (any(abs(bl_x * b_x(1:3, 1:3) / bl - b(1:3, 1:3)) .gt. TOL_Small)) ierr = 16
      !if (any(rot_x(1:3, 1:3, 1:nsym_x) .ne. rot(1:3, 1:3, 1:nsym))) ierr = 17
      !if (any(abs(tau_x(1:3, 1:nsym_x) - tau(1:3, 1:nsym)) .gt. TOL_Small)) ierr = 18
      if (any(atyp_x(1:nat_x) .ne. atyp(1:nat))) ierr = 19
      if (any(abs(al_x * apos_x(1:3, 1:nat_x) / al - apos(1:3, 1:nat)) .gt. TOL_Small)) ierr = 20
      if (any(ngk_x(1:nk_x) .ne. ngk(1:nk))) ierr = 21
      if (any(abs(kw_x(1:nk_x) - kw(1:nk)) .gt. TOL_Small)) ierr = 22
      if (any(abs(kpt_x(1:3, 1:nk_x) - kpt(1:3, 1:nk)) .gt. TOL_Small)) ierr = 23
      
      SAFE_DEALLOCATE_P(atyp_x)
      SAFE_DEALLOCATE_P(apos_x)
      SAFE_DEALLOCATE_P(ngk_x)
      SAFE_DEALLOCATE_P(kw_x)
      SAFE_DEALLOCATE_P(kpt_x)
    endif ! peinf%inode.eq.0
#ifdef MPI
    call MPI_Bcast(ierr,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
    if (ierr.ne.0) then
      call die('failed to read potential file ' // trim(vkbg_input_file), only_root_writes = .true.)
    endif ! ierr.ne.0
    
#ifdef MPI
    call MPI_Bcast(nsp,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
    call MPI_Bcast(nkb,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
    call MPI_Bcast(nhm,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
    SAFE_ALLOCATE(ityp, (nat))
    SAFE_ALLOCATE(nh, (nsp))
    SAFE_ALLOCATE(deeq, (nhm,nhm,nat,ns))
    if (peinf%inode.eq.0) then
      read(11) (ityp(iat), iat = 1, nat)
      read(11) (nh(isp), isp = 1, nsp)
      read(11) ((((deeq(jh, ih, iat, is), jh = 1, nhm), ih = 1, nhm), iat = 1, nat), is = 1, ns)
      SAFE_ALLOCATE(gvectmp, (3, ng))
      call read_binary_gvectors(11, ng, ng, gvectmp, bcast = .false.)
      SAFE_DEALLOCATE(gvectmp)
    endif
#ifdef MPI
    call MPI_Bcast(ityp,nat,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
    call MPI_Bcast(nh,nsp,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
    call MPI_Bcast(deeq(1,1,1,1),nhm*nhm*nat*ns,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
#endif
  endif ! vkbg_flag
  
  call timacc(11,2)
  
  call timacc(2,1)

!------------------------
! Generate symmetries of the bravais lattice or the crystal

  if (sapo_symmetry.eq.2) then
    SAFE_ALLOCATE(apos_lat, (3, nat))
    apos_lat = matmul(transpose(b),apos) / al ! convert to crystal coords
    call get_symmetries(nat, atyp, apos_lat, a, FFTgrid, cell_symmetry, nsyml, rotl, taul, spacegroup, symbol)
    SAFE_DEALLOCATE_P(apos_lat)
  elseif (sapo_symmetry.eq.1) then
    nsyml=nsym
    rotl(:,:,:)=rot(:,:,:)
  else
    nsyml=1
    rotl(:,:,1)=0
    do i=1,3
      rotl(i,i,1)=1
    enddo
  endif

!------------------------
! Initialize random numbers

  if (sapo_random.gt.0) then
    call date_and_time(VALUES=values)
    seed=((values(5)*24+values(6))*60+values(7))*1000+values(8)
    seed=seed+peinf%inode*drnd
    call genrand_init(put=seed)
    do i=1,nrnd
      call genrand_real4(x)
    enddo
    if (sapo_random.eq.1) then
      ! add a small random variation to the wavefunctions
      arnd=1.0d0
      brnd=sapo_random_ampl
    elseif (sapo_random.eq.2) then
      ! generate completely random wavefunctions
      arnd=0.0d0
      brnd=1.0d0
    endif
  endif

!------------------------
! Allocate arrays for fast scalar products

  if (ffastsp) then
    if (sapo_symmetry.eq.0) then
      npwdeg=1
    else
      npwdeg=48
    endif
    SAFE_ALLOCATE(pw_num, (nbmax,ns,nk))
    SAFE_ALLOCATE(pw_ind, (2,npwdeg,nbmax,ns,nk))
    pw_num(:,:,:)=0
    pw_ind(:,:,:,:,:)=0
  else ! ffastsp
    SAFE_ALLOCATE(pw_num, (1,1,1))
    SAFE_ALLOCATE(pw_ind, (1,1,1,1,1))
  endif ! ffastsp
  
  call timacc(2,2)
  
  call timacc(5,1)

!------------------------
! Generate plane waves and optionally decompose them
! into irreducible representations of the space group
! of the Bravais lattice or the crystal

  if (pw_flag) then
    
    if (peinf%inode.eq.0) then
      if (sapo_symmetry.eq.0) write(6,804)
      if (sapo_symmetry.eq.1) write(6,805)
      if (sapo_symmetry.eq.2) write(6,806)
    endif
    
    fsym=sapo_symmetry.gt.0
    fout=sapo_print_ir
    fshift=sapo_energy_match
    eshift=sapo_energy_shift
    
    call pwgen(fsym,fout,ffastsp,fshift,nk,ns,nbinp, &
      nbpw,nbmax,nsyml,b2g,npwdeg,ngk_l,ng,rotl,gvec, &
      pw_num,pw_ind,isort_d,eshift,a,b,bdot,kpt,en,wfn_d)
    
  endif ! pw_flag
  
  call timacc(5,2)
  
  call timacc(6,1)

!------------------------
! Add random variation to wavefunctions
! Normalize randomized wavefunctions

  if (sapo_random.ne.0) then

    if (peinf%inode.eq.0) then
      if (sapo_random.eq.1) then
        write(s1,102)brnd
        write(6,807)TRUNC(s1)
      elseif (sapo_random.eq.2) then
        write(6,808)
      endif ! sapo_random
    endif

    if (sapo_do_all_bands) then
      nbstart=1
    else
      nbstart=nbinp+1
    endif
    nbend=nbtot

    do ik=1,nk
      do is=1,ns

        call random_wfng(nk,ns,nbstart,nbend,nbmax,ngk_l,ik,is,ngk, &
          arnd,brnd,wfn_d)

      enddo ! is
    enddo ! ik

    if (sapo_random_norm) then

      call norm_wfng(ngk_l,nbstart,nbend,nbmax,ns,nk,wfn_d)

    endif ! sapo_random_norm

  endif ! sapo_random.ne.0
  
  call timacc(6,2)
  
  call timacc(7,1)
  
!------------------------
! Drop PW & AUX states that have a large overlap with DFT states,
! drop PW states that have a large overlap with AUX states

  if (sapo_overlap_flag) then
    
    if (peinf%inode.eq.0) write(6,809)
    
    SAFE_ALLOCATE(idrop, (nbinp+1:nbtot))
    SAFE_ALLOCATE(wfnsp, (max(nbinp,nbaux)))
#ifdef MPI
    SAFE_ALLOCATE(wfnspdummy, (max(nbinp,nbaux)))
#endif
    
    ib1=0
    do ik=1,nk
      do is=1,ns
        ! check overlap of PW & AUX states with DFT states
        if (peinf%inode.eq.0) then
          write(s1,101)ik
          write(s2,101)is
          write(tmpstr,601)TRUNC(s1),TRUNC(s2)
          call open_file(12,file=tmpstr,status='replace',form='formatted')
        endif ! peinf%inode.eq.0
        idrop(:)=0
        do ib=nbinp+1,nbtot
          if (ffastsp) then
            ffastsp_ib=pw_num(ib,is,ik).ne.0
          else ! ffastsp
            ffastsp_ib=.false.
          endif ! ffastsp
          wfnsp(:)=ZERO
          if (ffastsp_ib) then
            do jb=1,nbinp
              z=ZERO
              do i=1,pw_num(ib,is,ik)
                if (peinf%inode.eq.pw_ind(1,i,ib,is,ik)) &
                  z=z+MYCONJG(wfn_d(pw_ind(2,i,ib,is,ik),jb,is,ik))* &
                  wfn_d(pw_ind(2,i,ib,is,ik),ib,is,ik)
              enddo ! i
              wfnsp(jb)=z
            enddo ! jb
          else ! ffastsp_ib
            do jb=1,nbinp
              z=ZERO
              do ig=1,ngk_l
                z=z+MYCONJG(wfn_d(ig,jb,is,ik))*wfn_d(ig,ib,is,ik)
              enddo ! ig
              wfnsp(jb)=z
            enddo ! jb
          endif ! ffastsp_ib
#ifdef MPI
          wfnspdummy(:)=wfnsp(:)
          call MPI_Allreduce(wfnspdummy,wfnsp,nbinp, &
            MPI_SCALAR,MPI_SUM,MPI_COMM_WORLD,mpierr)
#endif
          if (maxval(abs(wfnsp(1:nbinp))).gt.sapo_overlap_max) idrop(ib)=1
          if (peinf%inode.eq.0) then
            if (ierr.eq.0) write(12,603)ib,maxval(abs(wfnsp(1:nbinp)))
          endif ! peinf%inode.eq.0
        enddo ! ib
        if (peinf%inode.eq.0) then
          if (ierr.eq.0) call close_file(12)
        endif ! peinf%inode.eq.0
        ! check overlap of PW states with AUX states
        if (pw_flag.and.aux_flag) then
          if (peinf%inode.eq.0) then
            write(s1,101)ik
            write(s2,101)is
            write(tmpstr,602)TRUNC(s1),TRUNC(s2)
            call open_file(12,file=tmpstr,status='replace',form='formatted')
          endif ! peinf%inode.eq.0
          do ib=nbinp+1,nbinp+nbpw
            if (idrop(ib).eq.1) cycle
            if (ffastsp) then
              ffastsp_ib=pw_num(ib,is,ik).ne.0
            else ! ffastsp
              ffastsp_ib=.false.
            endif ! ffastsp
            wfnsp(:)=ZERO
            if (ffastsp_ib) then
              do jb=nbinp+nbpw+1,nbtot
                z=ZERO
                do i=1,pw_num(ib,is,ik)
                  if (peinf%inode.eq.pw_ind(1,i,ib,is,ik)) &
                    z=z+MYCONJG(wfn_d(pw_ind(2,i,ib,is,ik),jb,is,ik))* &
                    wfn_d(pw_ind(2,i,ib,is,ik),ib,is,ik)
                enddo ! i
                wfnsp(jb-nbinp-nbpw)=z
              enddo ! jb
            else ! ffastsp_ib
              do jb=nbinp+nbpw+1,nbtot
                z=ZERO
                do ig=1,ngk_l
                  z=z+MYCONJG(wfn_d(ig,jb,is,ik))*wfn_d(ig,ib,is,ik)
                enddo ! ig
                wfnsp(jb-nbinp-nbpw)=z
              enddo ! jb
            endif ! ffastsp_ib
#ifdef MPI
            wfnspdummy(:)=wfnsp(:)
            call MPI_Allreduce(wfnspdummy,wfnsp,nbaux, &
              MPI_SCALAR,MPI_SUM,MPI_COMM_WORLD,mpierr)
#endif
            if (maxval(abs(wfnsp(1:nbaux))).gt.sapo_overlap_max) idrop(ib)=1
            if (peinf%inode.eq.0) then
              if (ierr.eq.0) write(12,603)ib,maxval(abs(wfnsp(1:nbaux)))
            endif ! peinf%inode.eq.0
          enddo ! ib
          if (peinf%inode.eq.0) then
            if (ierr.eq.0) call close_file(12)
          endif ! peinf%inode.eq.0
        endif ! pw_flag.and.aux_flag
        ! keep record of maximum number of PW & AUX states we drop 
        if (ib1.lt.sum(idrop(nbinp+1:nbtot))) ib1=sum(idrop(nbinp+1:nbtot))
        ! drop PW & AUX states that have large overlap
        do ib=nbinp+1,nbtot
          ib2=sum(idrop(nbinp+1:ib))
          if (idrop(ib).eq.0.and.ib2.gt.0) then
            if (ffastsp) then
              pw_num(ib-ib2,is,ik)=pw_num(ib,is,ik)
              pw_ind(:,:,ib-ib2,is,ik)=pw_ind(:,:,ib,is,ik)
            endif ! ffastsp
            en(ib-ib2,ik,is)=en(ib,ik,is)
            wfn_d(:,ib-ib2,is,ik)=wfn_d(:,ib,is,ik)
          endif ! idrop
        enddo ! ib
      enddo ! is
    enddo ! ik
    
    if (ib1.gt.0) then
      nbtot=nbtot-ib1
      if (.not.aux_flag) then
        nbpw=nbpw-ib1
      elseif (.not.pw_flag) then
        nbaux=nbaux-ib1
      else
        nbpw=0
        nbaux=0
      endif
      if (peinf%inode.eq.0) then
        write(s1,101)ib1
        write(s2,101)nbtot
        write(6,810)TRUNC(s1),TRUNC(s2)
      endif ! peinf%inode.eq.0
    else ! ib1.gt.0
      if (peinf%inode.eq.0) write(6,*)
    endif ! ib1.gt.0
    
    SAFE_DEALLOCATE(idrop)
    SAFE_DEALLOCATE(wfnsp)
#ifdef MPI
    SAFE_DEALLOCATE(wfnspdummy)
#endif
    
  endif ! sapo_overlap_flag
  
  call timacc(7,2)
  
  call timacc(8,1)

!------------------------
! Orthonormalize plane wave and auxiliary wavefunctions
! with respect to input wavefunctions

  if (sapo_orthonormal) then
    
    if (peinf%inode.eq.0) write(6,811)
    
    forder=sapo_ortho_block.ne.0.or.sapo_ortho_order.ne.0
    
    if (forder) then
      ! build the index array that specifies in which
      ! order to orthonormalize the wavefunctions
      SAFE_ALLOCATE(isrtort, (nbtot,ns,nk))
      iblock=sapo_ortho_block
      iorder=sapo_ortho_order
      call orderindex(iblock,iorder,nk,ns,nbtot,nbinp,nbpw,nbaux, &
        nbmax,isrtort,en)
      idir=1
      call orderarray(ffastsp,idir,nk,ns,nbtot,nbmax,ngk_l,npwdeg, &
        isrtort,pw_num,pw_ind,en,wfn_d)
    endif
    
    fblas=fblas_ort
    fecor=sapo_ortho_energy
    if (sapo_do_all_bands) then
      nbstart=1
    else
      nbstart=nbinp+1
    endif
    nbend=nbtot

    call orthonormalize(ffastsp,fblas,fecor,nk,ns,nbstart, &
      nbend,nbmax,ngk_l,npwdeg,pw_num,pw_ind,en,wfn_d)
    
    if (forder) then
      idir=2
      call orderarray(ffastsp,idir,nk,ns,nbtot,nbmax,ngk_l,npwdeg, &
        isrtort,pw_num,pw_ind,en,wfn_d)
      SAFE_DEALLOCATE(isrtort)
    endif ! forder
    
  endif ! sapo_orthonormal
  
  call timacc(8,2)
  
  call timacc(2,1)

!------------------------
! Deallocate arrays for fast scalar products

  SAFE_DEALLOCATE(pw_num)
  SAFE_DEALLOCATE(pw_ind)
  
  call timacc(2,2)
  
  call timacc(9,1)

!------------------------
! Sort plane wave and auxiliary wavefunctions by eigenvalues

  if (sapo_energy_sort) then
    
    if (peinf%inode.eq.0) write(6,812)
    
    SAFE_ALLOCATE(ensrt, (nbtot-nbinp))
    SAFE_ALLOCATE(isrt, (nbtot-nbinp))
    SAFE_ALLOCATE(wfnsrt_d, (ngk_l,nbtot-nbinp))
    
    do ik=1,nk
      do is=1,ns
        do ib=nbinp+1,nbtot
          ensrt(ib-nbinp)=en(ib,ik,is)
        enddo ! ib
        call sortrx(nbtot-nbinp,ensrt,isrt)
        do ib=nbinp+1,nbtot
          en(ib,ik,is)=ensrt(isrt(ib-nbinp))
        enddo ! ib
        do ib=nbinp+1,nbtot
          wfnsrt_d(:,ib-nbinp)=wfn_d(:,ib,is,ik)
        enddo ! ib
        do ib=nbinp+1,nbtot
          wfn_d(:,ib,is,ik)=wfnsrt_d(:,isrt(ib-nbinp))
        enddo ! ib
      enddo ! is
    enddo ! ik
    
    SAFE_DEALLOCATE(ensrt)
    SAFE_DEALLOCATE(isrt)
    SAFE_DEALLOCATE(wfnsrt_d)
    
  endif ! sapo_energy_sort
  
  call timacc(9,2)
  
  call timacc(10,1)

!------------------------
! Construct and diagonalize Hamiltonian, update plane wave
! and auxiliary wavefunctions and eigenvalues

  if (sapo_hamiltonian) then
    
    SAFE_ALLOCATE(vsc_d, (ng_l,ns))
    if (vkbg_flag) then
      SAFE_ALLOCATE(vkb_d, (ngk_l,nkb,ns,nk))
    endif ! vkbg_flag
    
    call timacc(11,1)
    
    if (peinf%inode.eq.0) write(6,813) trim(vscg_input_file)

    SAFE_ALLOCATE(gvectmp, (3, ng))
    call read_binary_gvectors(10, ng, ng, gvectmp, bcast = .false.)
    if (peinf%inode .eq. 0) then
      info=0
      do ig=1,ng
        if (gvectmp(1,ig).ne.gvec(1,ig).or.gvectmp(2,ig).ne. &
          gvec(2,ig).or.gvectmp(3,ig).ne.gvec(3,ig)) info=-1
      enddo
      if (info .ne. 0) then
        call die('inconsistent G-vectors in potential file ' // trim(vscg_input_file), only_root_writes = .true.)
      endif
    endif ! peinf%inode
    SAFE_DEALLOCATE(gvectmp)

    SAFE_ALLOCATE(vsc, (ng_g, ns))
    call read_binary_data(10, ng, ng_g, ns, vsc, bcast = .false.)
    do is=1,ns
      do ig=ng+1,ng_g
        vsc(ig,is)=ZERO
      enddo
#ifdef MPI
      !call MPI_Barrier(MPI_COMM_WORLD,mpierr) ! Uncomment if you have MPI errors
      call MPI_Scatter(vsc(:,is),ng_l,MPI_SCALAR, &
        vsc_d(:,is),ng_l,MPI_SCALAR,0,MPI_COMM_WORLD,mpierr)
#else
      vsc_d(:,is)=vsc(:,is)
#endif
    enddo
    SAFE_DEALLOCATE(vsc)
    if (ierr.ne.0) then
      call die('failed to read potential file ' // trim(vscg_input_file), only_root_writes = .true.)
    endif

    if (peinf%inode.eq.0) then
      call close_file(10)
    endif ! peinf%inode.eq.0
    
    if (vkbg_flag) then
      
      if (peinf%inode.eq.0) write(6,813) trim(vkbg_input_file)
      
      SAFE_ALLOCATE(isort, (ngk_g))
      SAFE_ALLOCATE(gvectmp, (3, ngkmax))
      SAFE_ALLOCATE(vkb, (ngk_g, 1))
      do ik=1,nk
#ifdef MPI
        !call MPI_Barrier(MPI_COMM_WORLD,mpierr) ! Uncomment if you have MPI errors
        call MPI_Gather(isort_d(:,ik),ngk_l,MPI_INTEGER, &
          isort,ngk_l,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#else
        isort(:)=isort_d(:,ik)
#endif
        call read_binary_gvectors(11, ngk(ik), ngkmax, gvectmp, bcast = .false.)
        
        if (peinf%inode .eq. 0) then
          do ig=1,ngk(ik)
            info=0
            iout=((gvectmp(1,ig)+FFTgrid(1)/2)*FFTgrid(2)+gvectmp(2,ig)+FFTgrid(2)/2)* &
              FFTgrid(3)+gvectmp(3,ig)+FFTgrid(3)/2+1
            if (iout.ge.1.and.iout.le.nFFTgridpts) then
              iout=index_vec(iout)
              if (iout.ge.1.and.iout.le.ng) then
                if (gvectmp(1,ig).ne.gvec(1,iout).or.gvectmp(2,ig).ne. &
                  gvec(2,iout).or.gvectmp(3,ig).ne.gvec(3,iout)) info=-1
              else
                info=-1
              endif
            else
              info=-1
            endif
            if (iout.ne.isort(ig)) info=-1
            ierr=ierr+info
          enddo ! ig
          if (info .ne. 0) then
            call die('inconsistent G-vectors in potential file ' // trim(vkbg_input_file), only_root_writes = .true.)
          endif
        endif ! peinf%inode
        
        do is=1,ns
          do ikb=1,nkb
            vkb(:,:)=(0.0d0,0.0d0)
            call read_binary_complex_data(11, ngk(ik), ngk_g, 1, vkb, bcast = .false.)
#ifdef MPI
            !call MPI_Barrier(MPI_COMM_WORLD,mpierr) ! Uncomment if you have MPI errors
            call MPI_Scatter(vkb(:,1),ngk_l,MPI_COMPLEX_DPC, &
              vkb_d(:,ikb,is,ik),ngk_l,MPI_COMPLEX_DPC, &
              0,MPI_COMM_WORLD,mpierr)
#else
            vkb_d(:,ikb,is,ik)=vkb(:,1)
#endif
          enddo ! ikb
        enddo ! is
      enddo ! ik
      SAFE_DEALLOCATE(isort)
      SAFE_DEALLOCATE(gvectmp)
      SAFE_DEALLOCATE(vkb)
      
      if (peinf%inode.eq.0) then
        call close_file(11)
      endif ! peinf%inode.eq.0
      
    endif ! vkbg_flag
        
    call timacc(11,2)
    
    if (peinf%inode.eq.0) write(6,814)
    
    fblas=fblas_ham
    fvkbg=vkbg_flag
    if (sapo_do_all_bands) then
      nbstart=1
    else
      nbstart=nbinp+1
    endif
    nbend=nbtot

    call hdiag(fparafft,fparala,fblas,fvkbg,nk,ns,nbstart, &
      nbend,nbmax,ng,ng_l,ng_g,ngk_l,ngk_g,nat,nsp,nkb,nhm,FFTgrid, &
      ngk,ityp,nh,gvec,isort_d,celvol,bdot,kpt,vsc_d,deeq,vkb_d, &
      en,wfn_d,sapo_ham_nrestart,sapo_ham_ndiag,sapo_ham_ndim, &
      sapo_ham_tol,sapo_ham_resinc)
    
    SAFE_DEALLOCATE(vsc_d)
    if (vkbg_flag) then
      SAFE_DEALLOCATE(ityp)
      SAFE_DEALLOCATE(nh)
      SAFE_DEALLOCATE(deeq)
      SAFE_DEALLOCATE(vkb_d)
    endif ! vkbg_flag
    
  endif ! sapo_hamiltonian
  
  call timacc(10,2)

!------------------------
! Deallocate index_vec indices

  SAFE_DEALLOCATE(index_vec)
  
  call timacc(21,1)
  
!------------------------
! Keep plane wave and auxiliary eigenvalues in a given energy range

  if (sapo_energy_range) then
    
    if (peinf%inode.eq.0) write(6,815)
    
    ib1=0
    ib2=0
    do ib=nbinp+1,nbtot
      if (any(en(ib,1:nk,1:ns).lt.sapo_energy_min-TOL_Zero)) then
        ib1=ib1+1
      endif
      if (all(en(ib,1:nk,1:ns).gt.sapo_energy_max+TOL_Zero)) then
        ib2=ib2+1
      endif
    enddo ! ib
    
    if (ib1.gt.0) then
      if (peinf%inode.eq.0) then
        write(0,941)
      endif
      do ik=1,nk
        do is=1,ns
          do ib=nbinp+1,nbtot-ib1-ib2
            en(ib,ik,is)=en(ib+ib1,ik,is)
          enddo ! ib
          do ib=nbinp+1,nbtot-ib1-ib2
            wfn_d(:,ib,is,ik)=wfn_d(:,ib+ib1,is,ik)
          enddo ! ib
        enddo ! is
      enddo ! ik
    endif ! ib1.gt.0
    
    if (ib1.gt.0.or.ib2.gt.0) then
      nbtot=nbtot-ib1-ib2
      if (.not.aux_flag) then
        nbpw=nbpw-ib1-ib2
      elseif (.not.pw_flag) then
        nbaux=nbaux-ib1-ib2
      else
        nbpw=0
        nbaux=0
      endif
      if (peinf%inode.eq.0) then
        write(s1,101)ib1+ib2
        write(s2,103)sapo_energy_min
        write(s3,103)sapo_energy_max
        write(s4,101)nbtot
        write(6,816)TRUNC(s1),TRUNC(s2),TRUNC(s3),TRUNC(s4)
      endif ! peinf%inode.eq.0
    else ! ib1.gt.0.or.ib2.gt.0
      if (peinf%inode.eq.0) write(6,*)
    endif ! ib1.gt.0.or.ib2.gt.0
    
  endif ! sapo_energy_range

  call timacc(21,2)

  call timacc(2,1)

!------------------------
! Reallocate occupations

  SAFE_ALLOCATE(occ_x, (nb, nk, ns))
  occ_x(1:nb, 1:nk, 1:ns) = occ(1:nb, 1:nk, 1:ns)
  SAFE_DEALLOCATE_P(occ)
  SAFE_ALLOCATE(occ, (nbtot, nk, ns))
  occ(1:nb, 1:nk, 1:ns) = occ_x(1:nb, 1:nk, 1:ns)
  SAFE_DEALLOCATE_P(occ_x)
  occ(nb+1:nbtot, 1:nk, 1:ns) = 0.0d0
  
  call timacc(2,2)

  if (out_flag) then
  
    call timacc(22,1)

!------------------------
! Write header of wavefunction file

    if (peinf%inode.eq.0) then
      write(6,803) trim(wfng_output_file)
      sheader = 'WFN'
      iflavor = 0
      call write_binary_header(9, sheader, iflavor, ns, ng, nsym, &
        cell_symmetry, nat, nk, nbtot, ngkmax, ecutrho, ecutwfn, FFTgrid, &
        kgrid, kshift, celvol, al, a, adot, recvol, bl, b, bdot, &
        rot, tau, atyp, apos, ngk, kw, kpt, ifmin, ifmax, en, occ)
      call write_binary_gvectors(9, ng, ng, gvec)
    endif

!------------------------
! Loop over k-points

    SAFE_ALLOCATE(wfn, (ngk_g,ns))
    SAFE_ALLOCATE(isort, (ngk_g))
  
    do ik=1,nk

!------------------------
! Gather indices of g-vectors for current k-point
! Write list of g-vectors to wavefunction file

#ifdef MPI
      call MPI_Barrier(MPI_COMM_WORLD,mpierr)
      call MPI_Gather(isort_d(:,ik),ngk_l,MPI_INTEGER, &
        isort,ngk_l,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#else
      isort(:)=isort_d(:,ik)
#endif
      call write_binary_gvectors(9, ngk(ik), ng, gvec, gindex = isort)
        
!------------------------
! Gather band and spin wavefunctions for current k-point
! Write them to wavefunction file

      do ib=1,nbtot
        do is=1,ns
#ifdef MPI
          !call MPI_Barrier(MPI_COMM_WORLD,mpierr) ! Uncomment if you have MPI errors
          call MPI_Gather(wfn_d(:,ib,is,ik),ngk_l, &
            MPI_SCALAR,wfn(:,is),ngk_l, &
            MPI_SCALAR,0,MPI_COMM_WORLD,mpierr)
#else
          wfn(:,is)=wfn_d(:,ib,is,ik)
#endif
        enddo
        call write_binary_data(9, ngk(ik), ngk_g, ns, wfn)
      enddo
    
    enddo
  
    SAFE_DEALLOCATE(wfn)
    SAFE_DEALLOCATE(isort)
  
    call timacc(22,2)

  endif ! out_flag
  
  call timacc(2,1)

!------------------------
! Close files

  if (peinf%inode.eq.0) then
    call close_file(7)
  endif
  
  if (aux_flag.and.peinf%inode.eq.0) then
    call close_file(8)
  endif
  
  if (out_flag.and.peinf%inode.eq.0) then
    call close_file(9)
  endif
  
  call timacc(2,2)
  
  call timacc(23,1)

!------------------------
! Check the orthonormality of the generated wavefunctions

  if (sapo_check_norm) then
    
    SAFE_ALLOCATE(wfnsp, (nbtot))
#ifdef MPI
    SAFE_ALLOCATE(wfnspdummy, (nbtot))
#endif
    
    dotmax=0.0d0
    do ik=1,nk
      do is=1,ns
        if (peinf%inode.eq.0) then
          write(s1,101)ik
          write(s2,101)is
          write(6,301)TRUNC(s1),TRUNC(s2)
        endif
        do ib=1,nbtot
          wfnsp(:)=ZERO
          do jb=1,nbtot
            z=ZERO
            do ig=1,ngk_l
              z=z+MYCONJG(wfn_d(ig,jb,is,ik))*wfn_d(ig,ib,is,ik)
            enddo ! ig
            wfnsp(jb)=z
          enddo ! jb
#ifdef MPI
          wfnspdummy(:)=wfnsp(:)
          call MPI_Allreduce(wfnspdummy,wfnsp,nbtot, &
            MPI_SCALAR,MPI_SUM,MPI_COMM_WORLD,mpierr)
#endif
          do jb=1,nbtot
            if (jb.eq.ib) then
              dotcur = abs(wfnsp(jb)-ONE)
            else
              dotcur = abs(wfnsp(jb))
            endif
            if (dotmax.lt.dotcur) dotmax = dotcur
            if (dotcur.gt.TOL_Small.and.peinf%inode.eq.0) then
              write(s1,101)ib
              write(s2,101)jb
#ifdef CPLX
              write(s3,102)dble(wfnsp(jb))
              write(s4,102)IMAG(wfnsp(jb))
              write(0,303)TRUNC(s1),TRUNC(s2),TRUNC(s3),TRUNC(s4)
#else
              write(s3,102)wfnsp(jb)
              write(0,302)TRUNC(s1),TRUNC(s2),TRUNC(s3)
#endif
            endif
          enddo ! jb
        enddo ! ib
      enddo ! is
    enddo ! ik
    if (peinf%inode.eq.0) write(6,304) dotmax
    
    SAFE_DEALLOCATE(wfnsp)
#ifdef MPI
    SAFE_DEALLOCATE(wfnspdummy)
#endif
    
  endif ! sapo_check_norm
  
  call timacc(23,2)
  
  call timacc(24,1)

!------------------------
! Plot the energy eigenvalues of the generated wavefunctions
! with respect to band index

  if (sapo_eigenvalue) then
    ! determine range of bands
    if (sapo_plot_bandmin.eq.0.and.sapo_plot_bandmax.eq.0) then
      ib1=1
      ib2=nbtot
    else
      ib1=max(1,sapo_plot_bandmin)
      ib2=min(nbtot,sapo_plot_bandmax)
    endif
    !
    do ik=1,nk
      if (sapo_plot_kpoint.ne.0.and.ik.ne.sapo_plot_kpoint) cycle
      do is=1,ns
        if (sapo_plot_spin.ne.0.and.is.ne.sapo_plot_spin) cycle
        if (peinf%inode.eq.0) then
          write(s1,101)ik
          write(s2,101)is
          write(6,401)TRUNC(s1),TRUNC(s2)
        endif
        if (peinf%inode.eq.0) then
          write(s1,101)ik
          write(s2,101)is
          write(tmpstr,402)TRUNC(s1),TRUNC(s2)
          call open_file(9,file=tmpstr,status='replace',form='formatted')
          if (ierr.eq.0) then
            write(9,403)TRUNC(s1),TRUNC(s2)
            do ib=ib1,ib2
              write(9,404)ib,en(ib,ik,is)*RYD
            enddo ! ib
          endif
          if (ierr.eq.0) call close_file(9)
        endif
#ifdef MPI
        call MPI_Bcast(ierr,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
        if (ierr.ne.0) then
          call die('failed to write eigenvalue file ' // trim(tmpstr), only_root_writes = .true.)
        endif
      enddo ! is
    enddo ! ik
    !
    if (peinf%inode.eq.0) write(6,*)
  endif ! sapo_eigenvalue
  
  call timacc(24,2)
  
  call timacc(25,1)

!------------------------
! Plot projections of the generated wavefunctions
! with respect to band index

  if (iand(sapo_projection,1).ne.0) then
    ! determine range of bands
    if (sapo_plot_bandmin.eq.0.and.sapo_plot_bandmax.eq.0) then
      ib1=1
      ib2=nbtot
    else
      ib1=max(1,sapo_plot_bandmin)
      ib2=min(nbtot,sapo_plot_bandmax)
    endif
    ! determine range of plane waves
    if (sapo_plot_pwmin.eq.0.and.sapo_plot_pwmax.eq.0) then
      ipw1=1
      ipw2=ngkmax
    else
      ipw1=max(1,sapo_plot_pwmin)
      ipw2=min(ngkmax,sapo_plot_pwmax)
    endif
    !
    SAFE_ALLOCATE(ekin, (ng))
    SAFE_ALLOCATE(isrt, (ng))
    SAFE_ALLOCATE(rdeg, (2,ng))
    SAFE_ALLOCATE(ideg, (ng))
    SAFE_ALLOCATE(isrti, (ng))
    SAFE_ALLOCATE(comp, (ib1:ib2))
    SAFE_ALLOCATE(compdummy, (ib1:ib2))
    !
    do ik=1,nk
      if (sapo_plot_kpoint.ne.0.and.ik.ne.sapo_plot_kpoint) cycle
      ! sort G-vectors by kinetic energies
      call groupk(kpt(:,ik),nsyml,rotl,nsymk,rotk)
      do ig=1,ng
        do i=1,3
          kvec(i)=kpt(i,ik)+dble(gvec(i,ig))
        enddo ! i
        ekin(ig)=DOT_PRODUCT(kvec,MATMUL(bdot,kvec))
      enddo ! ig
      call sortrx(ng,ekin,isrt,gvec=gvec)
      pwsym=.true.
      call pwdeg(pwsym,nsymk,rotk,ng,gvec,ekin,isrt,ndeg,mdeg,rdeg,ideg)
      ! invert isrt array
      isrti(:)=0
      do ig=1,ng
        isrti(isrt(ig))=ig
      enddo ! ig
      do is=1,ns
        if (sapo_plot_spin.ne.0.and.is.ne.sapo_plot_spin) cycle
        do ipw=ipw1,ipw2
          if (peinf%inode.eq.0) then
            write(s1,101)ik
            write(s2,101)is
            write(s3,101)ipw
            write(6,411)TRUNC(s1),TRUNC(s2),TRUNC(s3)
          endif
          comp(:)=0.0d0
          do ig=1,ngk_l
            jg=isort_d(ig,ik)
            if (jg.ne.0) then
              jg=isrti(jg)
              if (jg.eq.ipw) &
                comp(ib1:ib2)=abs(wfn_d(ig,ib1:ib2,is,ik))
            endif
          enddo ! ig
#ifdef MPI
          compdummy(:)=comp(:)
          call MPI_Reduce(compdummy,comp,ib2-ib1+1, &
            MPI_REAL_DP,MPI_SUM,0,MPI_COMM_WORLD,mpierr)
#endif
          if (peinf%inode.eq.0) then
            write(s1,101)ik
            write(s2,101)is
            write(s3,101)ipw
            write(tmpstr,412)TRUNC(s1),TRUNC(s2),TRUNC(s3)
            call open_file(9,file=tmpstr,status='replace',form='formatted')
            if (ierr.eq.0) then
              write(9,413)TRUNC(s1),TRUNC(s2),TRUNC(s3)
              do ib=ib1,ib2
                write(9,414)ib,comp(ib)
              enddo ! ib
            endif
            if (ierr.eq.0) call close_file(9)
          endif
#ifdef MPI
          call MPI_Bcast(ierr,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
          if (ierr.ne.0) then
            call die('failed to write projection file ' // trim(tmpstr), only_root_writes = .true.)
          endif
        enddo ! ipw
      enddo ! is
    enddo ! ik
    !
    !
    SAFE_DEALLOCATE(ekin)
    SAFE_DEALLOCATE(isrt)
    SAFE_DEALLOCATE(rdeg)
    SAFE_DEALLOCATE(ideg)
    SAFE_DEALLOCATE(isrti)
    SAFE_DEALLOCATE(comp)
    SAFE_DEALLOCATE(compdummy)
    !
    if (peinf%inode.eq.0) write(6,*)
  endif ! iand(sapo_projection,1).ne.0
  
!------------------------
! Plot projections of the generated wavefunctions
! with respect to plane wave

  if (iand(sapo_projection,2).ne.0) then
    ! determine range of bands
    if (sapo_plot_bandmin.eq.0.and.sapo_plot_bandmax.eq.0) then
      ib1=1
      ib2=nbtot
    else
      ib1=max(1,sapo_plot_bandmin)
      ib2=min(nbtot,sapo_plot_bandmax)
    endif
    ! determine range of plane waves
    if (sapo_plot_pwmin.eq.0.and.sapo_plot_pwmax.eq.0) then
      ipw1=1
      ipw2=ngkmax
    else
      ipw1=max(1,sapo_plot_pwmin)
      ipw2=min(ngkmax,sapo_plot_pwmax)
    endif
    !
    SAFE_ALLOCATE(ekin, (ng))
    SAFE_ALLOCATE(isrt, (ng))
    SAFE_ALLOCATE(rdeg, (2,ng))
    SAFE_ALLOCATE(ideg, (ng))
    SAFE_ALLOCATE(isrti, (ng))
    SAFE_ALLOCATE(comp, (ipw1:ipw2))
    SAFE_ALLOCATE(compdummy, (ipw1:ipw2))
    !
    do ik=1,nk
      if (sapo_plot_kpoint.ne.0.and.ik.ne.sapo_plot_kpoint) cycle
      ! sort G-vectors by kinetic energies
      call groupk(kpt(:,ik),nsyml,rotl,nsymk,rotk)
      do ig=1,ng
        do i=1,3
          kvec(i)=kpt(i,ik)+dble(gvec(i,ig))
        enddo ! i
        ekin(ig)=DOT_PRODUCT(kvec,MATMUL(bdot,kvec))
      enddo ! ig
      call sortrx(ng,ekin,isrt,gvec=gvec)
      pwsym=.true.
      call pwdeg(pwsym,nsymk,rotk,ng,gvec,ekin,isrt,ndeg,mdeg,rdeg,ideg)
      ! invert isrt array
      isrti(:)=0
      do ig=1,ng
        isrti(isrt(ig))=ig
      enddo ! ig
      do is=1,ns
        if (sapo_plot_spin.ne.0.and.is.ne.sapo_plot_spin) cycle
        do ib=ib1,ib2
          if (peinf%inode.eq.0) then
            write(s1,101)ik
            write(s2,101)is
            write(s3,101)ib
            write(6,421)TRUNC(s1),TRUNC(s2),TRUNC(s3)
          endif
          comp(:)=0.0d0
          do ig=1,ngk_l
            jg=isort_d(ig,ik)
            if (jg.ne.0) then
              jg=isrti(jg)
              if (jg.ge.ipw1.and.jg.le.ipw2) &
                comp(jg)=abs(wfn_d(ig,ib,is,ik))
            endif
          enddo ! ig
#ifdef MPI
          compdummy(:)=comp(:)
          call MPI_Reduce(compdummy,comp,ipw2-ipw1+1, &
            MPI_REAL_DP,MPI_SUM,0,MPI_COMM_WORLD,mpierr)
#endif
          if (peinf%inode.eq.0) then
            write(s1,101)ik
            write(s2,101)is
            write(s3,101)ib
            write(tmpstr,422)TRUNC(s1),TRUNC(s2),TRUNC(s3)
            call open_file(9,file=tmpstr,status='replace',form='formatted')
            if (ierr.eq.0) then
              write(9,423)TRUNC(s1),TRUNC(s2),TRUNC(s3)
              do ipw=ipw1,ipw2
                write(9,424)ipw,comp(ipw)
              enddo ! ipw
            endif
            if (ierr.eq.0) call close_file(9)
          endif
#ifdef MPI
          call MPI_Bcast(ierr,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
          if (ierr.ne.0) then
            call die('failed to write projection file ' // trim(tmpstr), only_root_writes = .true.)
          endif
        enddo ! ib
      enddo ! is
    enddo ! ik
    !
    SAFE_DEALLOCATE(ekin)
    SAFE_DEALLOCATE(isrt)
    SAFE_DEALLOCATE(rdeg)
    SAFE_DEALLOCATE(ideg)
    SAFE_DEALLOCATE(isrti)
    SAFE_DEALLOCATE(comp)
    SAFE_DEALLOCATE(compdummy)
    !
    if (peinf%inode.eq.0) write(6,*)
  endif ! iand(sapo_projection,2).ne.0

!------------------------
! Plot projections of the generated wavefunctions
! with respect to band index and plane wave

  if (iand(sapo_projection,4).ne.0) then
    ! determine range of bands
    if (sapo_plot_bandmin.eq.0.and.sapo_plot_bandmax.eq.0) then
      ib1=1
      ib2=nbtot
    else
      ib1=max(1,sapo_plot_bandmin)
      ib2=min(nbtot,sapo_plot_bandmax)
    endif
    ! determine range of plane waves
    if (sapo_plot_pwmin.eq.0.and.sapo_plot_pwmax.eq.0) then
      ipw1=1
      ipw2=ngkmax
    else
      ipw1=max(1,sapo_plot_pwmin)
      ipw2=min(ngkmax,sapo_plot_pwmax)
    endif
    !
    SAFE_ALLOCATE(ekin, (ng))
    SAFE_ALLOCATE(isrt, (ng))
    SAFE_ALLOCATE(rdeg, (2,ng))
    SAFE_ALLOCATE(ideg, (ng))
    SAFE_ALLOCATE(isrti, (ng))
    SAFE_ALLOCATE(proj, (ipw1:ipw2,ib1:ib2))
    SAFE_ALLOCATE(projdummy, (ipw1:ipw2,ib1:ib2))
    !
    do ik=1,nk
      if (sapo_plot_kpoint.ne.0.and.ik.ne.sapo_plot_kpoint) cycle
      ! sort G-vectors by kinetic energies
      call groupk(kpt(:,ik),nsyml,rotl,nsymk,rotk)
      do ig=1,ng
        do i=1,3
          kvec(i)=kpt(i,ik)+dble(gvec(i,ig))
        enddo ! i
        ekin(ig)=DOT_PRODUCT(kvec,MATMUL(bdot,kvec))
      enddo ! ig
      call sortrx(ng,ekin,isrt,gvec=gvec)
      pwsym=.true.
      call pwdeg(pwsym,nsymk,rotk,ng,gvec,ekin,isrt,ndeg,mdeg,rdeg,ideg)
      ! invert isrt array
      isrti(:)=0
      do ig=1,ng
        isrti(isrt(ig))=ig
      enddo ! ig
      ! calculate projections
      do is=1,ns
        if (sapo_plot_spin.ne.0.and.is.ne.sapo_plot_spin) cycle
        if (peinf%inode.eq.0) then
          write(s1,101)ik
          write(s2,101)is
          write(6,431)TRUNC(s1),TRUNC(s2)
        endif
        proj(:,:)=0.0d0
        do ib=ib1,ib2
          do ig=1,ngk_l
            jg=isort_d(ig,ik)
            if (jg.ne.0) then
              ipw=isrti(jg)
              if (ipw.ge.ipw1.and.ipw.le.ipw2) &
                proj(ipw,ib)=abs(wfn_d(ig,ib,is,ik))
            endif
          enddo ! ig
        enddo ! ib
#ifdef MPI
        projdummy(:,:)=proj(:,:)
        call MPI_Reduce(projdummy(1,1),proj(1,1),(ipw2-ipw1+1)*(ib2-ib1+1), &
          MPI_REAL_DP,MPI_SUM,0,MPI_COMM_WORLD,mpierr)
#endif
        if (peinf%inode.eq.0) then
          write(s1,101)ik
          write(s2,101)is
          write(s3,101)ib1
          write(s4,101)ib2
          write(s5,101)ipw1
          write(s6,101)ipw2
          write(tmpstr,432)TRUNC(s1),TRUNC(s2)
          call open_file(9,file=tmpstr,status='replace',form='formatted')
          write(9,433)TRUNC(s1),TRUNC(s2),TRUNC(s3),TRUNC(s4), &
            TRUNC(s5),TRUNC(s6)
          if (ierr.eq.0) then
            do ipw=ipw1,ipw2
              write(9,434)(proj(ipw,ib),ib=ib1,ib2)
            enddo ! ipw
          endif
          if (ierr.eq.0) call close_file(9)
        endif
#ifdef MPI
        call MPI_Bcast(ierr,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
        if (ierr.ne.0) then
          call die('failed to write projection file ' // trim(tmpstr), only_root_writes = .true.)
        endif
      enddo ! is
    enddo ! ik
    !
    SAFE_DEALLOCATE(ekin)
    SAFE_DEALLOCATE(isrt)
    SAFE_DEALLOCATE(rdeg)
    SAFE_DEALLOCATE(ideg)
    SAFE_DEALLOCATE(isrti)
    SAFE_DEALLOCATE(proj)
    SAFE_DEALLOCATE(projdummy)
    !
    if (peinf%inode.eq.0) write(6,*)
  endif ! iand(sapo_projection,4).ne.0
  
  call timacc(25,2)
  
  call timacc(26,1)

!------------------------
! Plot the squared absolute values of amplitudes of the generated
! wavefunctions with respect to kinetic energies of plane waves

  if (sapo_amplitude) then
    ! determine range of bands
    if (sapo_plot_bandmin.eq.0.and.sapo_plot_bandmax.eq.0) then
      ib1=1
      ib2=nbtot
    else
      ib1=max(1,sapo_plot_bandmin)
      ib2=min(nbtot,sapo_plot_bandmax)
    endif
    !
    SAFE_ALLOCATE(ekin, (ng))
    SAFE_ALLOCATE(amplx, (sapo_ampl_num))
    SAFE_ALLOCATE(amply, (sapo_ampl_num))
    SAFE_ALLOCATE(ampldummy, (sapo_ampl_num))
    !
    do i=1,sapo_ampl_num
      amplx(i)=sapo_ampl_del*dble(i-1)
    enddo ! i
    !
    do ik=1,nk
      if (sapo_plot_kpoint.ne.0.and.ik.ne.sapo_plot_kpoint) cycle
      ! compute kinetic energies of G-vectors
      do ig=1,ng
        do i=1,3
          kvec(i)=kpt(i,ik)+dble(gvec(i,ig))
        enddo ! i
        ekin(ig)=DOT_PRODUCT(kvec,MATMUL(bdot,kvec))
      enddo ! ig
      do is=1,ns
        if (sapo_plot_spin.ne.0.and.is.ne.sapo_plot_spin) cycle
        do ib=ib1,ib2
          if (peinf%inode.eq.0) then
            write(s1,101)ik
            write(s2,101)is
            write(s3,101)ib
            write(6,441)TRUNC(s1),TRUNC(s2),TRUNC(s3)
          endif
          amply(:)=0.0d0
          do ig=1,ngk_l
            jg=isort_d(ig,ik)
            if (jg.ne.0) then
              x=abs(wfn_d(ig,ib,is,ik))**2
              do i=1,sapo_ampl_num
                amply(i)=amply(i)+x/(sqrt(2.0d0*PI_D)*sapo_ampl_brd)* &
                  exp(-(amplx(i)-ekin(jg))**2/(2.0d0*sapo_ampl_brd**2))
              enddo ! i
            endif
          enddo ! ig
#ifdef MPI
          ampldummy(:)=amply(:)
          call MPI_Reduce(ampldummy,amply,sapo_ampl_num, &
            MPI_REAL_DP,MPI_SUM,0,MPI_COMM_WORLD,mpierr)
#endif
          if (peinf%inode.eq.0) then
            write(s1,101)ik
            write(s2,101)is
            write(s3,101)ib
            write(tmpstr,442)TRUNC(s1),TRUNC(s2),TRUNC(s3)
            call open_file(9,file=tmpstr,status='replace',form='formatted')
            if (ierr.eq.0) then
              write(9,443)TRUNC(s1),TRUNC(s2),TRUNC(s3)
              do i=1,sapo_ampl_num
                write(9,444)amplx(i),amply(i)
              enddo ! i
            endif
            if (ierr.eq.0) call close_file(9)
          endif
#ifdef MPI
          call MPI_Bcast(ierr,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
          if (ierr.ne.0) then
            call die('failed to write amplitude file ' // trim(tmpstr), only_root_writes = .true.)
          endif
        enddo ! ib
      enddo ! is
    enddo ! ik
    !
    SAFE_DEALLOCATE(ekin)
    SAFE_DEALLOCATE(amplx)
    SAFE_DEALLOCATE(amply)
    SAFE_DEALLOCATE(ampldummy)
    !
    if (peinf%inode.eq.0) write(6,*)
  endif ! sapo_amplitude
  
  call timacc(26,2)
  
  call timacc(2,1)

!------------------------
! Deallocate arrays

  SAFE_DEALLOCATE_P(atyp)
  SAFE_DEALLOCATE_P(apos)
  SAFE_DEALLOCATE_P(kw)
  SAFE_DEALLOCATE_P(kpt)
  SAFE_DEALLOCATE_P(ifmin)
  SAFE_DEALLOCATE_P(ifmax)
  SAFE_DEALLOCATE_P(occ)
  SAFE_DEALLOCATE_P(en)
  SAFE_DEALLOCATE(gvec)
  SAFE_DEALLOCATE_P(ngk)
  SAFE_DEALLOCATE(wfn_d)
  SAFE_DEALLOCATE(isort_d)
  
  call timacc(2,2)
  
  call timacc(1,2)

!------------------------
! Time Accounting

  routnam(1)='TOTAL:'
  routnam(2)='INIT:'
  routnam(3)='INPUT:'
  routnam(4)='INPUT_AUX:'
  routnam(5)='GEN_PW:'
  routnam(6)='RANDOM:'
  routnam(7)='DROP:'
  routnam(8)='ORTHONORM:'
  routnam(9)='SORT:'
  routnam(10)='HAMILTONIAN:'
  routnam(11)='HAM (INPUT):'
  routnam(12)='HAM (COMM):'
  routnam(13)='HAM (PLAN):'
  routnam(14)='HAM (FFT):'
  routnam(15)='HAM (KIN):'
  routnam(16)='HAM (VSC):'
  routnam(17)='HAM (VKB):'
  routnam(18)='HAM (GATHER):'
  routnam(19)='HAM (DIAG):'
  routnam(20)='HAM (WFN):'
  routnam(21)='RANGE:'
  routnam(22)='OUTPUT:'
  routnam(23)='CHECK_NORM:'
  routnam(24)='PLOT_ENER:'
  routnam(25)='PLOT_PROJ:'
  routnam(26)='PLOT_AMPL:'
  
  if(peinf%inode.eq.0) then
    write(6,9000)
    do i=2,26
      if (.not.sapo_hamiltonian.and.i.ge.10.and.i.le.19) cycle
      call timacc(i,3,tsec,ncount)
      write(6,9001) routnam(i),tsec(1),tsec(2),ncount
    enddo
    write(6,*)
    call timacc(1,3,tsec,ncount)
    write(6,9002) routnam(1),tsec(1),tsec(2)
    write(6,*)
9000 format(/,22x,"CPU [s]",8x,"WALL [s]",11x,"#",/)
9001 format(a16,f13.3,3x,f13.3,3x,i9)
9002 format(a16,f13.3,3x,f13.3)
  endif

!------------------------
! Finish

#ifdef MPI
  call MPI_Finalize(mpierr)
#endif

101 format(i16)
102 format(f16.6)
103 format(f16.3)
  
110 format(1x,'nsym =',1x,a,2x,'nk =',1x,a,2x,'ns =',1x,a,2x,'nb =', &
      1x,a,2x,'ng =',1x,a,2x,'ngkmax =',1x,a)
120 format(1x,'ng_l =',1x,a,2x,'ng_g =',1x,a,2x,'ngk_l =',1x,a,2x, &
      'ngk_g =',1x,a)
130 format(1x,'FFTgrid =',1x,'(',1x,a,1x,a,1x,a,1x,')',2x,'nFFTgridpts =',1x,a)
140 format(1x,'nbinp =',1x,a,2x,'nbpw =',1x,a,2x,'b2g =',1x,a,2x, &
      'nbaux =',1x,a,2x,'nbtot =',1x,a,/)
  
301 format(1x,'Checking orthonormality for ik =',1x,a,1x,'is =', &
      1x,a)
302 format(4x,'WARNING: ib =',1x,a,1x,'jb =',1x,a,1x, &
      'scalar product =',1x,a)
303 format(4x,'WARNING: ib =',1x,a,1x,'jb =',1x,a,1x, &
      'scalar product =',1x,'(',1x,a,1x,a,1x,')')
304 format(/,1x,'Maximum deviation from orthonormality:',/, &
      4x,'max ( < nk | mk > - delta_nm ) =',f20.15,/)
  
401 format(1x,'Generating eigenvalues for ik =',1x,a,1x,'is =',1x,a)
402 format(1x,'ener_k',a,'_s',a,'.dat')
403 format('# E(kpt=',a,',spin=',a,') [eV] vs band')
404 format(i6,f12.6)
  
411 format(1x,'Generating projections for ik =',1x,a,1x,'is =', &
      1x,a,1x,'ipw =',1x,a)
412 format(1x,'proj_k',a,'_s',a,'_pw',a,'.dat')
413 format('# |psi(kpt=',a,',spin=',a,',pw=',a,')| vs band')
414 format(i6,f10.6)
  
421 format(1x,'Generating projections for ik =',1x,a,1x,'is =', &
      1x,a,1x,'ib =',1x,a)
422 format(1x,'proj_k',a,'_s',a,'_b',a,'.dat')
423 format('# |psi(kpt=',a,',spin=',a,',band=',a,')| vs pw')
424 format(i6,f10.6)
  
431 format(1x,'Generating projections for ik =',1x,a,1x,'is =',1x,a)
432 format(1x,'proj_k',a,'_s',a,'.dat')
433 format('# |psi(kpt=',a,',spin=',a,')| vs', &
      1x,'(row/band=',a,':',a,',col/pw=',a,':',a,')')
434 format(10000f10.6)
  
441 format(1x,'Generating amplitudes for ik =',1x,a,1x,'is =', &
      1x,a,1x,'ib =',1x,a)
442 format(1x,'ampl_k',a,'_s',a,'_b',a,'.dat')
443 format('# |psi(kpt=',a,',spin=',a,',band=',a,')|^2', &
      1x,'vs E_kin(pw) [Ry]')
444 format(2f10.6)
  
601 format(1x,'overlap_dft_k',a,'_s',a,'.dat')
602 format(1x,'overlap_aux_k',a,'_s',a,'.dat')
603 format(i6,f12.6)
  
801 format(1x,'Reading parameters from file',1x,a,/)
802 format(1x,'Reading wavefunctions from file',1x,a,/)
803 format(1x,'Writing wavefunctions to file',1x,a,/)
804 format(1x,'Generating plane waves',/)
805 format(1x,'Generating plane waves and decomposing them into irreducible representations',/,&
      4x,'of the space group of the crystal',/)
806 format(1x,'Generating plane waves and decomposing them into irreducible representations',/,&
      4x,'of the space group of the Bravais lattice',/)
807 format(1x,'Applying random variation with amplitude',1x,a,/)
808 format(1x,'Generating completely random wavefunctions',/)
809 format(1x,'Checking overlap of PW & AUX wavefunctions with DFT wavefunctions')
810 format(1x,'Dropping',1x,a,1x,'PW & AUX states that have a large overlap with DFT states',/,&
      3x,'Keeping',1x,a,1x,'DFT & PW & AUX states',/)
811 format(1x,'Orthonormalizing PW & AUX wavefunctions w.r.t. DFT',/)
812 format(1x,'Sorting PW & AUX wavefunctions by eigenvalues',/)
813 format(1x,'Reading potential from file',1x,a,/)
814 format(1x,'Constructing and diagonalizing Hamiltonian',/)
815 format(1x,'Checking if new PW & AUX eigenvalues fall outside the energy range')
816 format(1x,'Dropping',1x,a,1x,'PW & AUX states outside the energy range of',1x,a,1x,'to',1x,a,1x,'Ry',/,&
      3x,'Keeping',1x,a,1x,'DFT & PW & AUX states',/)
  
921 format(1x,'WARNING:',1x,'cannot match kinetic energies if starting from 1st plane wave',/)
922 format(1x,'WARNING:',1x,'cannot use energy shift if matching kinetic energies',/)
923 format(1x,'WARNING:',1x,'cannot use symmetries if there are no plane waves',/)
924 format(1x,'WARNING:',1x,'using AUX wavefunctions requires AUX input file',/)
925 format(1x,'WARNING:',1x,'random numbers overwrite irreducible representations',/)
926 format(1x,'WARNING:',1x,'random numbers overwrite auxiliary wavefunctions',/)
927 format(1x,'WARNING:',1x,'dropping PW & AUX states requires PW or AUX input',/)
928 format(1x,'WARNING:',1x,'set min PW & AUX to 0 since dropping states with a large overlap',/)
929 format(1x,'WARNING:',1x,'orthonormalizing wavefunctions requires PW or AUX input',/,3x,'or sapo_do_all_bands',/)
930 format(1x,'WARNING:',1x,'orthonormalizing PW & AUX together requires both PW & AUX input',/)
931 format(1x,'WARNING:',1x,'dropping PW & AUX states incompatible with not ordered',/,&
      3x,'in energy orthonormalization',/)
932 format(1x,'WARNING:',1x,'correcting PW & AUX eigenvalues requires PW or AUX input',/)
933 format(1x,'WARNING:',1x,'sorting PW & AUX eigenvalues requires PW or AUX input',/)
934 format(1x,'WARNING:',1x,'constructing Hamiltonian requires local potential input file',/)
935 format(1x,'WARNING:',1x,'constructing Hamiltonian requires PW or AUX input',/,3x,'or sapo_do_all_bands',/)
936 format(1x,'WARNING:',1x,'setting the range of PW & AUX eigenvalues requires sorting them or diagonalizing Hamiltonian',/)
937 format(1x,'WARNING:',1x,'randomizing wavefunctions requires PW or AUX input',/,3x,'or sapo_do_all_bands',/)
  
941 format(1x,'WARNING:',1x,'lowest PW & AUX state overlaps in energy with highest DFT state',/)

end program SAPO

!==============================================================================================
!
! Utilities:
!
! (1) printchi           Originally By JRD               Last Modified 6/30/2008 (JRD)
!
!==============================================================================================

#include "f_defs.h"

program printchi

  use global_m
  implicit none

  integer, allocatable :: irow(:), isrtx(:)
  real(DP) :: tnp(200, 3)
  real(DP), allocatable :: ekinx(:)
  integer :: ii, jj, nmtx, ntranq, mtrx(200, 3, 3), kg0(200, 3), ttt

  SCALAR, allocatable :: eps(:,:)

  character :: ajname*6, adate*11
  character :: aheadinput*6
  integer :: ps, ps2, np, i, k, j, n, nband
  integer :: freq_dep, nfreq, kgrid(3), nrk, ng, nFFTgridpts, FFTgrid(3), nq, indexq0
  real(DP) :: initfreq, deltafreq, brdning, ecuts, bdot(3, 3)
  integer, allocatable :: kgg(:, :), index_vec(:)
  real(DP), allocatable :: qpt(:, :)



  write(6,*) 'Welcome to Chi Printing'
  call open_file(unit=10,file='chi0mat',form='unformatted',status='old')
  ttt=1
  !       call open_file(unit=10,file='chi0mat',form='unformatted',status='old')
  !  ttt=nq-1! nq is number of q points in epsilon.inp      
  call open_file(unit=11,file='chi.gconv',status='replace')

  !       call open_file(unit=6, file='temp.dat')

  !       write(6, *) 1111

  !--------------------------
  ! Now read chi0mat

  !       read(10)
  !       read(10) ii
  !       if (ii.ne.0) then
  !         call die('Full frequency dependence not supported')
  !       endif
  !       read(10)
  !       read(10)
  !       read(10)
  !       read(10)
  !       read(10)
  !       read(10)
  !       read(10) nold
  !       read(10)
  !       read(10)
  !       read(10) nge
  !       rewind(10)
  ! !      deallocate(oldx)
  !       SAFE_ALLOCATE(oldx, (nold))
  ! !      deallocate(oldy)
  !       SAFE_ALLOCATE(oldy, (nold))
  ! !      deallocate(oldz)
  !       SAFE_ALLOCATE(oldz, (nold))
  ! !      deallocate(ekold)
  ! !      allocate(ekold(nge))
  ! !      deallocate(isrtold)
  !       SAFE_ALLOCATE(isrtold, (nge))
  ! !      deallocate(isrtq)
  ! !      allocate(isrtq(nge))
  ! !      deallocate(isrtq)
  !       SAFE_ALLOCATE(isrtq, (nge))

  read(10) aheadinput,ajname,adate
  write(11, *) 'line-1'
  write(11, *) aheadinput,ajname,adate
  read(10) freq_dep, nFreq, InitFreq, &
       DeltaFreq,Brdning
  write(11, *) 'line-2'
  write(11, *) freq_dep, nFreq, InitFreq, &
       DeltaFreq,Brdning
  read(10) (kgrid(i),i=1,3)
  write(11, *) 'line-3'
  write(11, *) (kgrid(i),i=1,3)
  read(10)
  write(11, *) 'line-4'
  write(11, *)
  read(10)
  write(11, *) 'line-5'      
  write(11, *)
  read(10)
  write(11, *) 'line-6'      
  write(11, *)
  read(10) ecuts, nband
  write(11, *) 'line-7'      
  write(11, *) ecuts, nband
  read(10) nrk ! also invflag is here, but not needed
  write(11, *) 'line-8'      
  write(11, *) nrk, 1 ! invflag
  read(10) ng, nFFTgridpts
  SAFE_ALLOCATE(kgg, (3, ng))
  SAFE_ALLOCATE(index_vec, (nFFTgridpts))
  backspace(10)
  read(10) ng,nFFTgridpts,(FFTgrid(i),i=1,3), &
       ((kgg(j,i),j=1,3),i=1,ng), &
       ((bdot(i,j),j=1,3),i=1,3),(index_vec(i),i=1,nFFTgridpts)
  write(11, *) 'line-9'      
  write(11, *) ng,nFFTgridpts,(FFTgrid(i),i=1,3), &
       ((kgg(j,i),j=1,3),i=1,ng), &
       ((bdot(i,j),j=1,3),i=1,3),(index_vec(i),i=1,nFFTgridpts)
  read(10) nq
  SAFE_ALLOCATE(qpt, (3, nq))
  backspace(10)
  read(10) nq,indexq0,((qpt(j,i),j=1,3),i=1,nq)
  write(11, *) 'line-10'      
  write(11, *) nq,indexq0,((qpt(j,i),j=1,3),i=1,nq)
  SAFE_DEALLOCATE(kgg)
  SAFE_DEALLOCATE(index_vec)
  SAFE_DEALLOCATE(qpt)

  !       write(6, *) 'temp1'

  ! Read q->0 dielectric matrix
  do ps2=1, ttt
     mtrx=0
     tnp=0.0d0
     kg0=0
     read(10) ntranq
     backspace(10)

     read(10) ntranq, (((mtrx(n,i,j),i=1,3),j=1,3), &
          (tnp(n,k), &
          kg0(n,k),k=1,3),n=1,ntranq)
     write(11, *) 'line-11', ps2
     write(11, *) ntranq, (((mtrx(n,i,j),i=1,3),j=1,3), &
          (tnp(n,k), &
          kg0(n,k),k=1,3),n=1,ntranq)
     read(10) nmtx
     backspace(10)
     SAFE_ALLOCATE(isrtx, (ng))
     SAFE_ALLOCATE(ekinx, (ng))
     SAFE_ALLOCATE(irow, (nmtx))
     read(10) nmtx, np,(isrtx(i),ekinx(i),i=1 &
          ,ng),(irow(i),i=1,nmtx)
     write(11, *) 'line-12', ps2
     write(11, *) nmtx, np,(isrtx(i),ekinx(i),i=1 &
          ,ng),(irow(i),i=1,nmtx)
     SAFE_ALLOCATE(eps, (nmtx,nmtx))
     write(11, *) 'line-13', ps2
     do jj = 1, nmtx
        read(10) (eps(ii,jj),ii=1,nmtx)
        do ps=1, nmtx
           write(11,*) jj, eps(ps,jj)
        end do
     enddo
     FLUSH(11)
     SAFE_DEALLOCATE(eps)
     SAFE_DEALLOCATE(isrtx)
     SAFE_DEALLOCATE(ekinx)
     SAFE_DEALLOCATE(irow)
  end do
  !      read(10) (totalreal,ii=1,nge)
  call close_file(10)
  call close_file(11)

end program printchi

!================================================================================
!
! Module eqpcor_m
!
! 1. eqpcor()        Originally By gsm       Last Modified 8/13/2010 (gsm)
!
!    Reads quasiparticle energy corrections from eqp.dat-type files.
!    Such files are made by bin/eqp.py.
!
!    There are some differences in how eqpcor is called from different codes.
!
!    In Epsilon, eqpcor is called from proc 0, so set inode = 0 and npes = 1.
!    In other places, set inode = peinf%inode and npes = peinf%npes.
!
!    Epsilon and BSE require quasiparticle energies in Rydbergs, so set
!    irydflag = 1. Sigma (outer) requires energies in eVs, so set irydflag = 0.
!
!    In Epsilon and Sigma, the quasiparticle energies are returned in
!    array eqp(nbmin:nbmax,1:kp%nrk,1:kp%nspin). In BSE, the valence and
!    conduction energies indexed with respect to the Fermi level are
!    returned in arrays eqpv(:,1:kp%nrk,1:kp%nspin) and eqpc(:,1:kp%nrk,1:kp%nspin).
!
!    In inteqp, set ivalflag = 2 to return the difference Eqp - Edft.
!    In other places, set ivalflag = 0 to return Eqp.
!
!    DO NOT try to use both styles, they will overwrite each other!
!
!================================================================================

#include "f_defs.h"

module eqpcor_m

  use global_m
  implicit none

  private

  public :: eqpcor

contains

subroutine eqpcor(fn,inode,npes,kp,nbmin,nbmax, &
  nbvnum,nbcnum,eqp,eqpv,eqpc,irydflag,ivalflag,dont_write,kpt_required)

  character(len=32), intent(in) :: fn
  integer, intent(in) :: inode,npes
  type(kpoints), intent(in) :: kp !< however, usually kp%el will be passed to eqp, eqpv, eqpc
  integer, intent(in) :: nbmin,nbmax,nbvnum,nbcnum
  real(DP), intent(inout) :: eqp(:,:,:)      !< (nb,  kp%nrk, kp%nspin)
  real(DP), intent(inout) :: eqpv(:,:,:)     !< (nbv, kp%nrk, kp%nspin)
  real(DP), intent(inout) :: eqpc(:,:,:)     !< (nbc, kp%nrk, kp%nspin)
  integer, intent(in) :: irydflag,ivalflag
  logical, optional, intent(in) :: dont_write !< silence output
  !> (kp%nrk) Which k-points are required in the eqp file? Defaults to all
  logical, optional, intent(in) :: kpt_required(:)

  integer :: iflag,eof,ik,jk,kk,is,ib,isb,nsb, &
    nbvmin,nbvmax,nbcmin,nbcmax,corsmin,corsmax,corbmin,corbmax
  real(DP) :: dummydft,dummyqp,k(3),dk(3)
  character(100) :: errmsg
  logical :: dowrite
  logical, allocatable :: kpt_present(:)

  ! eqp.py from sigma.log may not give better precision than this.
  real(DP), parameter :: TOL_eqp = 2d-6
  
  PUSH_SUB(eqpcor)

  dowrite = .true.
  if(present(dont_write)) dowrite = .not. dont_write
  if (inode.eq.0) then
    SAFE_ALLOCATE(kpt_present, (kp%nrk))
    kpt_present(:) = .false.
    iflag=0
    write(6,901) trim(fn)
901 format(/,1x,"Reading quasiparticle energy corrections from",1x,a)

    call open_file(9,file=trim(fn),form='formatted',status='old')

    if (ivalflag.eq.2) then
      if(dowrite) write(6,922)
922 format(/,6x,"band",3x,"k-point",6x,"spin",4x,"DeltaElda[eV]",3x,"DeltaEqp[eV]")

    else
      if(dowrite) write(6,902)
902 format(/,6x,"band",3x,"k-point",6x,"spin",7x,"Elda[eV]",8x,"Eqp[eV]")
    endif
    corsmin=kp%nspin+1
    corsmax=0
    corbmin=kp%mnband+1
    corbmax=0
    do ik=1,kp%nrk
      read(9,*,iostat=eof)k(:),nsb
      if (eof.eq.0) then
        kk=0
        do jk=1,kp%nrk
          dk(:)=k(:)-kp%rk(:,jk)
          ! this allows Umklapp, i.e. either 0.1 or -0.9 to be supplied
          if (all(abs(dk(1:3)-dble(nint(dk(1:3)))).lt.TOL_Small)) then
            kk = jk
            kpt_present(kk) = .true.
            exit
          endif
        enddo
        if(kk == 0) iflag = 3
        do isb=1,nsb
          read(9,*,iostat=eof)is,ib,dummydft,dummyqp
          if(kk == 0) cycle
          if (ivalflag.eq.2) then
            dummyqp=dummyqp-dummydft
          endif
          nbvmin=kp%ifmax(kk,is)-nbvnum+1
          nbvmax=kp%ifmax(kk,is)
          nbcmin=kp%ifmax(kk,is)+1
          nbcmax=kp%ifmax(kk,is)+nbcnum
          if (eof.eq.0) then
            if (is.lt.corsmin) corsmin=is
            if (is.gt.corsmax) corsmax=is
            if (ib.lt.corbmin) corbmin=ib
            if (ib.gt.corbmax) corbmax=ib
            if (ib.ge.nbmin.and.ib.le.nbmax) then
              if (irydflag.eq.0) then
                if(dowrite) write(6,903)ib,kk,is,eqp(ib,kk,is),dummyqp
                ! with ivalflag == 2, we do not have the DFT energy in eqp so cannot compare.
                if(ivalflag /= 2 .and. abs(dummydft - eqp(ib,kk,is)) > TOL_eqp) &
                  call die("eqpcor mean-field energy mismatch")
                eqp(ib,kk,is)=dummyqp
              else
                if(dowrite) write(6,903)ib,kk,is,eqp(ib,kk,is)*RYD,dummyqp
                if(ivalflag /= 2 .and. abs(dummydft/RYD - eqp(ib,kk,is)) > TOL_eqp) &
                  call die("eqpcor mean-field energy mismatch")
                eqp(ib,kk,is)=dummyqp/RYD
              endif
903           format(3i10,2f15.5)
            endif
            if (ib.ge.nbvmin.and.ib.le.nbvmax) then
              if (irydflag.eq.0) then
                if(dowrite) write(6,904)ib,kk,is,eqpv(nbvmax-ib+1,kk,is),dummyqp
                if(ivalflag /= 2 .and. abs(dummydft - eqpv(nbvmax-ib+1,kk,is)) > TOL_eqp) &
                  call die("eqpcor mean-field energy mismatch")
                eqpv(nbvmax-ib+1,kk,is)=dummyqp
              else
                if(ivalflag /= 2 .and. abs(dummydft/RYD - eqpv(nbvmax-ib+1,kk,is)) > TOL_eqp) &
                  call die("eqpcor mean-field energy mismatch")
                if(dowrite) write(6,904)ib,kk,is,eqpv(nbvmax-ib+1,kk,is)*RYD,dummyqp
                eqpv(nbvmax-ib+1,kk,is)=dummyqp/RYD
              endif
904           format("v",i9,2i10,2f15.5)
            endif
            if (ib.ge.nbcmin.and.ib.le.nbcmax) then
              if (irydflag.eq.0) then
                if(dowrite) write(6,905)ib,kk,is,eqpc(ib-nbcmin+1,kk,is),dummyqp
                if(ivalflag /= 2 .and. abs(dummydft - eqpc(ib-nbcmin+1,kk,is)) > TOL_eqp) &
                  call die("eqpcor mean-field energy mismatch")
                eqpc(ib-nbcmin+1,kk,is)=dummyqp
              else
                if(dowrite) write(6,905)ib,kk,is,eqpc(ib-nbcmin+1,kk,is)*RYD,dummyqp
                if(ivalflag /= 2 .and. abs(dummydft/RYD - eqpc(ib-nbcmin+1,kk,is)) > TOL_eqp) &
                  call die("eqpcor mean-field energy mismatch")
                eqpc(ib-nbcmin+1,kk,is)=dummyqp/RYD
              endif
905           format("c",i9,2i10,2f15.5)
            endif
          else
            iflag=2
          endif
        enddo
      else
        iflag=1
      endif
    enddo
    ! operations in this block are meaningless if nothing was read,
    ! and may overwrite the appropriate error message (iflag = 3)
    if(any(kpt_present)) then
      nbvmin=minval(kp%ifmax(:,:))-nbvnum+1
      nbvmax=maxval(kp%ifmax(:,:))
      nbcmin=minval(kp%ifmax(:,:))+1
      nbcmax=maxval(kp%ifmax(:,:))+nbcnum
      if (corsmin.gt.1.or.corsmax.lt.kp%nspin) iflag=4
      if (nbmin.ne.0.and.nbmax.ne.0) then
        if (corbmin.gt.nbmin.or.corbmax.lt.nbmax) iflag=5
      endif
      if (nbvnum.ne.0) then
        if (corbmin.gt.nbvmin.or.corbmax.lt.nbvmax) iflag=6
      endif
      if (nbcnum.ne.0) then
        if (corbmin.gt.nbcmin.or.corbmax.lt.nbcmax) iflag=7
      endif
    endif
    call close_file(9)
    if(dowrite) write(6,*)
    ! FHJ: We might think there are missing kpts, so make sure all k-points
    ! we care about were present in the file.
    if (present(kpt_required)) then
      if (iflag==1) then
        if (all(kpt_present(:).or.(.not.kpt_required(:)))) then
          iflag = 0
        endif
      endif
    endif
    SAFE_DEALLOCATE(kpt_present)
  endif

#ifdef MPI
  if (npes.gt.1) then
    call MPI_Bcast(iflag,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  endif
#endif
  if (iflag.gt.0) then
    if (iflag.eq.1) write(errmsg,801) trim(fn)
801 format(1x,"insufficient number of k-point blocks in file ", a)
    if (iflag.eq.2) write(errmsg,802) trim(fn)
802 format(1x,"wrong contents of k-point blocks in file ", a)
    if (iflag.eq.3) write(errmsg,803) trim(fn)
803 format(1x,"missing k-points in file ", a)
    if (iflag.eq.4) write(errmsg,804) trim(fn)
804 format(1x,"missing spins in file ", a)
    if (iflag.eq.5) write(errmsg,805) trim(fn)
805 format(1x,"missing bands in file ", a)
    if (iflag.eq.6) write(errmsg,806) trim(fn)
806 format(1x,"missing valence bands in file ", a)
    if (iflag.eq.7) write(errmsg,807) trim(fn)
807 format(1x,"missing conduction bands in file ", a)
    call die(errmsg, only_root_writes = .true.)
  endif

#ifdef MPI
  if (iflag.eq.0.and.npes.gt.1) then
    if (nbmin.ne.0.and.nbmax.ne.0) then
      call MPI_Bcast(eqp(1,1,1),size(eqp),MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
    endif
    if (nbvnum.ne.0) then
      call MPI_Bcast(eqpv(1,1,1),size(eqpv),MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
    endif
    if (nbcnum.ne.0) then
      call MPI_Bcast(eqpc(1,1,1),size(eqpc),MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
    endif
  endif
#endif
  
  POP_SUB(eqpcor) 
  return
  
end subroutine eqpcor

end module eqpcor_m

!===========================================================================
!
! Routines()
!
! (1) shiftenergy()     Originally by ?         Last Edited: 5/12/2008 (JRD)
!
!     Computes and symmetrizes the quasiparticle spectrum
!
!===========================================================================

#include "f_defs.h"

subroutine shiftenergy(sig,wfnk,alda,asx,ach,achcor,ax,efsto,asig,enew,zrenorm,&
                       nfreqgpp)

  use global_m
  implicit none

  type (siginfo), intent(in) :: sig
  type (wfnkstates), intent(in) :: wfnk
  integer, intent(in) :: nfreqgpp
  SCALAR, intent(inout) :: & 
    alda(sig%ndiag+sig%noffdiag,sig%nspin), & !< vxc
    asx(nfreqgpp,sig%ndiag+sig%noffdiag,sig%nspin), & !< sx
    ach(nfreqgpp,sig%ndiag+sig%noffdiag,sig%nspin)    !< ch
  complex(DPC), intent(inout) :: achcor(sig%ndiag+sig%noffdiag,sig%nspin) !< static remainder
  SCALAR, intent(inout) :: ax(sig%ndiag+sig%noffdiag,sig%nspin) !< x
  real(DP), intent(out) :: efsto(sig%ndiag,sig%nspin) !< eqp0
  SCALAR, intent(inout) :: asig(sig%ndiag+sig%noffdiag,sig%nspin) !< sig
  real(DP), intent(out) :: enew(sig%ndiag,sig%nspin)  !< eqp1
  real(DP), intent(out) :: zrenorm(sig%ndiag,sig%nspin) !< Znk

  integer :: ii,jj,istart,istop,nl,iflag,ispin
  integer, allocatable :: ndeg(:)
  real(DP) :: fact,dek,dele
  SCALAR :: aldai,axi
  SCALAR, allocatable :: asigi(:),asxi(:),achi(:)
  complex(DPC) :: achcori
  
  PUSH_SUB(shiftenergy)
  
  SAFE_ALLOCATE(ndeg, (sig%ntband))
  SAFE_ALLOCATE(asigi, (nfreqgpp))
  SAFE_ALLOCATE(asxi, (nfreqgpp))
  SAFE_ALLOCATE(achi, (nfreqgpp))

  do ispin=1,sig%nspin
    
    nl=1
    ndeg(nl)=1
    do ii=2,sig%ndiag
      iflag=0
      dek = wfnk%elda(sig%diag(ii),ispin) - wfnk%elda(sig%diag(ii-1),ispin)
      if(abs(dek) .lt. sig%tol) iflag=1
      if (iflag.eq.0) nl=nl+1
      if (iflag.eq.0) ndeg(nl)=1
      if (iflag.eq.1) ndeg(nl)=ndeg(nl)+1
    enddo
    
    istop = 0
    do ii=1,nl
      istart = istop + 1
      istop = istart + ndeg(ii) - 1
      aldai = ZERO
      axi = ZERO
      asxi = ZERO
      achi = ZERO
      achcori = (0.0d0, 0.0d0)
      do jj=istart,istop
        aldai = aldai + alda(jj,ispin)
        axi = axi + ax(jj,ispin)
        asxi(:) = asxi(:) + asx(:,jj,ispin)
        achi(:) = achi(:) + ach(:,jj,ispin)
        achcori = achcori + achcor(jj,ispin)
      enddo
      
      fact = ryd / dble(ndeg(ii))
      do jj=istart,istop
        alda(jj,ispin) = aldai * fact
        ax(jj,ispin) = axi * fact
        asx(:,jj,ispin) = asxi(:) * fact
        ach(:,jj,ispin) = achi(:) * fact
        achcor(jj,ispin) = achcori * fact
        asigi(:) = ax(jj,ispin) + asx(:,jj,ispin) + ach(:,jj,ispin)
! JRD. Not ideal for fdf -3, but user should see spectrum.dat
        asig(jj,ispin) = asigi(2)

! Correcting Eqp [Eq. (37) of Hybertsen & Louie PRB]
! by Murilo (Aug 11, 2000)

        efsto(jj,ispin) = wfnk%elda(sig%diag(jj),ispin) - &
          alda(jj,ispin) + asig(jj,ispin)
        dele = efsto(jj,ispin) - wfnk%ek(sig%diag(jj),ispin)

! SIB:  It seems silly to have the if below.  If we really
! believe that Sigma is a linear function of energy (which
! is assumed by doing the correction to efsto), then using
! both -dw (asig1) and +dw (asig3) is pointless.
!
!            if (dele.gt.0.0d0) enew(jj,ispin) = efsto(jj,ispin)
!     >       +(asig3-asig2)/( sig%dw-asig3+asig2)*dele
!            if (dele.le.0.0d0) enew(jj,ispin) = efsto(jj,ispin)
!     >       +(asig1-asig2)/(-sig%dw-asig1+asig2)*dele
!
! gsm: Instead, let`s use either -dw (asig1) or +dw (asig3)
! or both depending on the value of sig%fdf.  This allows
! us to skip either iw=1 or iw=3 in subroutine mtxel_sxch.

        if (sig%fdf.eq.-1) then
          enew(jj,ispin) = efsto(jj,ispin) + &
            (asigi(2)-asigi(1))/(sig%dw-asigi(2)+asigi(1))*dele
          zrenorm(jj, ispin) = 1d0 / (1d0 - (asigi(2) - asigi(1))/sig%dw)
        elseif (sig%fdf.eq.0) then
          enew(jj,ispin) = efsto(jj,ispin) + &
            (asigi(3)-asigi(1))/(2.0d0*sig%dw-asigi(3)+asigi(1))*dele
          zrenorm(jj, ispin) = 1d0 / (1d0 - (asigi(3) - asigi(1))/(2d0 * sig%dw))
        elseif (sig%fdf.eq.1.or.sig%fdf.eq.2) then
          enew(jj,ispin) = efsto(jj,ispin) + &
            (asigi(3)-asigi(2))/(sig%dw-asigi(3)+asigi(2))*dele
          zrenorm(jj, ispin) = 1d0 / (1d0 - (asigi(3) - asigi(2))/sig%dw)
        else
          enew(jj,ispin) = efsto(jj,ispin)
          zrenorm(jj, ispin) = 1d0
        endif

      enddo ! jj
    enddo ! ii
  enddo ! ispin

  SAFE_DEALLOCATE(ndeg)
  SAFE_DEALLOCATE(asigi)
  SAFE_DEALLOCATE(asxi)
  SAFE_DEALLOCATE(achi)
  SAFE_DEALLOCATE(ndeg)
  
  POP_SUB(shiftenergy)
  
  return
end subroutine shiftenergy

!=============================================================================
!
! Utilities:
!
! (1) convert_old_to_new    Originally By DAS
!
!     Takes binary GWR/GWC (and CD95 and VXC files), either real or complex,
!     in format as of MBPT-1.0, plus input file of other info, and writes corresponding
!     binary WFN (and RHO and VXC) files in new format.
!     See example file "convert_old_to_new.inp" in this directory.
!
!==============================================================================

#include "f_defs.h"

program convert_old_to_new

  use global_m
  use input_utils_m
  use wfn_rho_vxc_io_m
  implicit none

  type(crystal) :: crys
  type(symmetry) :: syms
  type(kpoints) :: kp
  type(gspace) :: gvec
  character*3 :: sheader
  character*7 :: sflavor
  character*9 :: symgrp
  character*8 :: latunit, posunit
  character*64 :: str0, str1, str2
  character*256 :: progname, inputfile, inwfn, inrho, invxc, &
   outwfn, outrho, outvxc, str
  integer :: ik, is, ib, ig, iat, iflavor, ii, jj, isym
  integer :: nargs, iter
  real(DP) :: dummycelvol, dummypos(3), dummybdot(3,3), efermi
  real(DP), pointer :: dwfn(:,:)
  complex(DPC), pointer :: zwfn(:,:)
  real(DP) :: qtot, omega_plasma, ksum

! Get file names from command-line arguments

  nargs = iargc()

  call getarg(0, progname)

  if (nargs .ne. 8 .and. nargs .ne. 6 .and. nargs .ne. 4) then
    write(6,'(3a)') 'Usage 1: ', TRUNC(progname), &
      ' Real/Complex convert_old_to_new.inp inwfn outwfn'
    write(6,'(3a)') 'Usage 2: ', TRUNC(progname), &
      ' Real/Complex convert_old_to_new.inp inwfn inrho outwfn outrho'
    write(6,'(3a)') 'Usage 3: ', TRUNC(progname), &
      ' Real/Complex convert_old_to_new.inp inwfn inrho invxc outwfn outrho outvxc'
    stop
  endif

  call getarg(1, sflavor)
  call getarg(2, inputfile)
  call getarg(3, inwfn)

  if(nargs .eq. 8) then
    call getarg(4, inrho)
    call getarg(5, invxc)
    call getarg(6, outwfn)
    call getarg(7, outrho)
    call getarg(8, outvxc)
  else if(nargs .eq. 6) then
    call getarg(4, inrho)
    call getarg(5, outwfn)
    call getarg(6, outrho)
  else
    call getarg(4, outwfn)
  endif

  if (TRUNC(sflavor) .eq. RFLAVOR) then
    iflavor = 1
  else if (TRUNC(sflavor) .eq. CFLAVOR) then
    iflavor = 2
  else
    call die('Unknown flavor ' // sflavor // '.')
  endif

  call open_file(unit=10,file=TRUNC(inputfile),form='formatted',status='old')

  call open_file(unit=21,file=TRUNC(outwfn),form='unformatted',status='replace')

  if(nargs > 4) then
    call open_file(unit=12,file=TRUNC(inrho),form='unformatted',status='old')
    call open_file(unit=22,file=TRUNC(outrho),form='unformatted',status='replace')
    if(nargs > 6) then
      call open_file(unit=13,file=TRUNC(invxc),form='unformatted',status='old')
      call open_file(unit=23,file=TRUNC(outvxc),form='unformatted',status='replace')
    endif
  endif

  write(6,'(a)') 'Using ' // TRUNC(sflavor) // ' flavor and input file ' // TRUNC(inputfile) // ':'
  if(nargs .eq. 8) then
    write(6,'(a)') 'Converting old files ' // TRUNC(inwfn) // ', ' // TRUNC(inrho) // ', ' // TRUNC(invxc)
    write(6,'(a)') 'to new files ' // TRUNC(outwfn) // ', ' // TRUNC(outrho) // ', ' // TRUNC(outvxc)
  else
    write(6,'(a)') 'Converting old file ' // TRUNC(inwfn) // ' to new file ' // TRUNC(outwfn)
  endif

  ! Read input file
  
  read(10,*) gvec%ecutrho, kp%ecutwfc
  read(10,*) symgrp
  read(10,*) latunit
  do jj = 1, 3
    read(10,*) (crys%avec(ii, jj), ii = 1, 3)
  enddo
  read(10,*) posunit
  read(10,*) crys%nat
  SAFE_ALLOCATE(crys%atyp, (crys%nat))
  SAFE_ALLOCATE(crys%apos, (3, crys%nat))
  read(10,*) ((crys%apos(ii, iat), ii = 1, 3), crys%atyp(iat), iat = 1, crys%nat)
    
  ! in round 1, we read and allocate.
  ! in round 2, we read and throw away just to back to the right place.
  do iter = 1, 2

    call open_file(unit=11,file=TRUNC(inwfn),form='unformatted',status='old')

    ! Read inwfn
    
    read(11) ((dummybdot(ii,jj),ii=1,3),jj=1,3)
    read(11) dummycelvol
    
    read(11) syms%ntran
    do isym=1,syms%ntran
      read(11) ((syms%mtrx(ii,jj,isym),ii=1,3),jj=1,3)
    enddo
    do isym=1,syms%ntran
      read(11) (syms%tnp(ii,isym),ii=1,3)
    enddo
    
    read(11) kp%nspin
    read(11) kp%nrk
    read(11) (kp%kgrid(ii),ii=1,3)
    read(11) (kp%shift(ii),ii=1,3)
    if(iter == 1) then
      SAFE_ALLOCATE(kp%w, (kp%nrk))
    endif
    read(11) (kp%w(ik),ik=1,kp%nrk)
    if(iter == 1) then
      SAFE_ALLOCATE(kp%rk, (3,kp%nrk))
    endif
    do ik=1,kp%nrk
      read(11) (kp%rk(ii,ik),ii=1,3)
    enddo
    
    read(11) kp%mnband
    if(iter == 1) then
      SAFE_ALLOCATE(kp%ifmin, (kp%nrk,kp%nspin))
      SAFE_ALLOCATE(kp%ifmax, (kp%nrk,kp%nspin))
    endif
    read(11) ((kp%ifmin(ik,is),ik=1,kp%nrk),is=1,kp%nspin)
    read(11) ((kp%ifmax(ik,is),ik=1,kp%nrk),is=1,kp%nspin)
    
    if(iter == 1) then
      SAFE_ALLOCATE(kp%el, (kp%mnband,kp%nrk,kp%nspin))
    endif
    do is=1,kp%nspin
      do ik=1,kp%nrk
        read(11) (kp%el(ib,ik,is),ib=1,kp%mnband)
      enddo
    enddo

    read(11) (gvec%FFTgrid(ii),ii=1,3)
    read(11) gvec%ng
    if(iter == 1) then
      SAFE_ALLOCATE(gvec%components, (3, gvec%ng))
    endif
    do ig=1,gvec%ng
      read(11) (gvec%components(ii,ig), ii=1,3)
    enddo
    
    ! Read numbers of gvectors on each k-point
    ! throwing away other info

    if(iter == 1) then
      SAFE_ALLOCATE(kp%ngk, (kp%nrk))
      do ik=1,kp%nrk
        read(11) kp%ngk(ik)
        do ig=1,kp%ngk(ik)
          read(11)
        enddo
        do ib=1,kp%mnband
          read(11)
        enddo
      enddo
      call close_file(11)
    endif
  enddo

  write(6,'(3x,"Crystal volume:",f32.14)') dummycelvol
  write(6,'(3x,"Number of G-vectors:",i12)') gvec%ng
  write(6,'(3x,"Number of spins:",i16)') kp%nspin
  write(6,'(3x,"Number of bands:",i16)') kp%mnband
  write(6,'(3x,"Number of k-points:",i13)') kp%nrk
  
  ksum = sum(kp%w(1:kp%nrk))
  if(abs(ksum - 1d0) > TOL_Zero) then
    write(0,'(a,f10.6,a)') 'WARNING: k-point weights sum to ', ksum, '; renormalizing.'
    kp%w(1:kp%nrk) = kp%w(1:kp%nrk) / ksum
  endif
  
  ! paratec shifted grids before r307 have
  ! kgrid = 0, shift = 0 for unknown reasons
  ! This is considered illegal by BGW, so we have to reset it
  if(any(kp%kgrid(1:3) <= 0)) then
    write(0,'(a,3i4)') 'WARNING: illegal value in k-grid. k-grid = ', kp%kgrid(1:3)
    write(0,'(a)') 'Reading kgrid from input file'
    read(10,*) (kp%kgrid(ii),ii=1,3)
    if(any(kp%kgrid(1:3) <= 0)) then
      write(0,*) 'read kgrid = ', kp%kgrid(1:3)
      call die("Read illegal kgrid from input file.")
    endif
  endif
  
  call close_file(10)

  ! Compute some other quantities    
  if (symgrp .eq. 'cubic') then
    syms%cell_symmetry = 0
  elseif (symgrp .eq. 'hexagonal') then
    syms%cell_symmetry = 1
  else
    call die('unknown symmetry group')
  endif
  
  if (latunit .eq. 'bohr') then
    continue
  elseif (latunit .eq. 'angstrom') then
    crys%avec(1:3, 1:3) = crys%avec(1:3, 1:3) / BOHR
  else
    call die('unknown units of the lattice vectors')
  endif
  
  if (posunit .eq. 'bohr') then
    continue
  elseif (posunit .eq. 'angstrom') then
    crys%apos(1:3, 1:crys%nat) = crys%apos(1:3, 1:crys%nat) / BOHR
  elseif (posunit .eq. 'crystal') then
    do iat = 1, crys%nat
      dummypos(1:3) = crys%apos(1:3, iat)
      crys%apos(1:3, iat) = 0
      do ii = 1, 3
        do jj = 1, 3
          crys%apos(jj, iat) = crys%apos(jj, iat) + &
            dummypos(ii) * crys%avec(jj, ii)
        enddo
      enddo
    enddo
  else
    call die('unknown units of the atomic positions')
  endif
  
  crys%alat = sqrt(crys%avec(1, 1)**2 + crys%avec(2, 1)**2 + crys%avec(3, 1)**2)
  crys%avec(1:3, 1:3) = crys%avec(1:3, 1:3) / crys%alat
  crys%apos(1:3, 1:crys%nat) = crys%apos(1:3, 1:crys%nat) / crys%alat
  
  crys%celvol = crys%avec(1, 1) * (crys%avec(2, 2) * crys%avec(3, 3) - crys%avec(2, 3) * crys%avec(3, 2)) - &
    crys%avec(2, 1) * (crys%avec(1, 2) * crys%avec(3, 3) - crys%avec(1, 3) * crys%avec(3, 2)) + &
    crys%avec(3, 1) * (crys%avec(1, 2) * crys%avec(2, 3) - crys%avec(1, 3) * crys%avec(2, 2))
  
  crys%blat = 2.0d0 * PI_D / crys%alat
  crys%bvec(1,1) = (crys%avec(2,2) * crys%avec(3,3) - crys%avec(3,2) * crys%avec(2,3)) / crys%celvol
  crys%bvec(2,1) = (crys%avec(3,2) * crys%avec(1,3) - crys%avec(1,2) * crys%avec(3,3)) / crys%celvol
  crys%bvec(3,1) = (crys%avec(1,2) * crys%avec(2,3) - crys%avec(2,2) * crys%avec(1,3)) / crys%celvol
  crys%bvec(1,2) = (crys%avec(2,3) * crys%avec(3,1) - crys%avec(3,3) * crys%avec(2,1)) / crys%celvol
  crys%bvec(2,2) = (crys%avec(3,3) * crys%avec(1,1) - crys%avec(1,3) * crys%avec(3,1)) / crys%celvol
  crys%bvec(3,2) = (crys%avec(1,3) * crys%avec(2,1) - crys%avec(2,3) * crys%avec(1,1)) / crys%celvol
  crys%bvec(1,3) = (crys%avec(2,1) * crys%avec(3,2) - crys%avec(3,1) * crys%avec(2,2)) / crys%celvol
  crys%bvec(2,3) = (crys%avec(3,1) * crys%avec(1,2) - crys%avec(1,1) * crys%avec(3,2)) / crys%celvol
  crys%bvec(3,3) = (crys%avec(1,1) * crys%avec(2,2) - crys%avec(2,1) * crys%avec(1,2)) / crys%celvol
  
  crys%celvol = abs(crys%celvol) * crys%alat**3
  crys%recvol = (2.0d0 * PI_D)**3 / crys%celvol
  
  do ii=1,3
    do jj=1,3
      crys%adot(jj,ii) = dot_product(crys%avec(1:3,jj), crys%avec(1:3,ii)) * crys%alat**2
    enddo
  enddo
  
  do ii=1,3
    do jj=1,3
      crys%bdot(jj,ii) = dot_product(crys%bvec(1:3,jj), crys%bvec(1:3,ii)) * crys%blat**2
    enddo
  enddo
  
  kp%ngkmax = maxval(kp%ngk(1:kp%nrk))
  
  call find_efermi(.true., efermi, 0d0, kp, kp%mnband, 1, "grid", should_search = .true., should_update = .true., write7 = .false.)
  call calc_qtot(kp, crys%celvol, efermi, qtot, omega_plasma, write7 = .false.)
  
  SAFE_ALLOCATE(kp%occ, (kp%mnband, kp%nrk, kp%nspin))
  do is = 1, kp%nspin
    do ik = 1 , kp%nrk
      do ib = 1, kp%mnband
        if(abs(kp%el(ib, ik, is) - efermi) < TOL_Degeneracy) then
          kp%occ(ib, ik, is) = 0.5
        else
          if(ib < kp%ifmin(ik, is) .or. ib > kp%ifmax(ik, is)) then
            kp%occ(ib, ik, is) = 0
          else
            kp%occ(ib, ik, is) = 1
          endif
        endif
      enddo
    enddo
  enddo
  
  ! Check consistency
  
  if (abs(dummycelvol - crys%celvol) .gt. TOL_Small) then
    write(str1,'(f32.14)') dummycelvol
    write(str2,'(f32.14)') crys%celvol
    str = 'unit cell volume read from file (' // TRUNC(str1) // &
      ') differs from unit cell volume computed from lattice vectors (' // &
      TRUNC(str2) // ')'
    call die(str)
  endif
  
  do ii = 1, 3
    do jj = 1, 3
      if (abs(dummybdot(jj, ii) - crys%bdot(jj, ii)) .gt. TOL_Small) then
        write(str0,'("bdot(",i1,",",i1,")")') jj, ii
        write(str1,'(f32.14)') dummybdot(jj, ii)
        write(str2,'(f32.14)') crys%bdot(jj, ii)
        str = TRUNC(str0) // ' read from file (' // TRUNC(str1) // &
          ') differ from ' // TRUNC(str0) // ' computed from lattice vectors (' // &
          TRUNC(str2) // ')'
        call die(str)
      endif
    enddo
  enddo
  
  write(6,'(a)') "Calculations complete."
      
  ! Finally we can write the header and G-vectors for all the files
  ! The G-vectors will be overwritten later, so we need to do it now
  
  sheader = 'WFN'
  call write_binary_header_type(21, sheader, iflavor, kp, gvec, syms, crys)
  call write_binary_gvectors(21, gvec%ng, gvec%ng, gvec%components)
  
  if(nargs > 4) then
    sheader = 'RHO'
    call write_binary_header_type(22, sheader, iflavor, kp, gvec, syms, crys)
    call write_binary_gvectors(22, gvec%ng, gvec%ng, gvec%components)
    
    if(nargs > 6) then
      sheader = 'VXC'
      call write_binary_header_type(23, sheader, iflavor, kp, gvec, syms, crys)
      call write_binary_gvectors(23, gvec%ng, gvec%ng, gvec%components)
    endif
    
    write(6,'(a)') 'Wrote headers.'
  else
    write(6,'(a)') 'Wrote header.'
  endif

  if(iflavor == 1) then
    SAFE_ALLOCATE(dwfn, (kp%ngkmax, kp%nspin))
  else
    SAFE_ALLOCATE(zwfn, (kp%ngkmax, kp%nspin))
  endif
  
  do ik=1,kp%nrk
    read(11) kp%ngk(ik)
    do ig=1,kp%ngk(ik)
      read(11) (gvec%components(ii,ig), ii=1,3)
    enddo
    call write_binary_gvectors(21, kp%ngk(ik), kp%ngk(ik), gvec%components)

    do ib=1,kp%mnband
      if(iflavor == 1) then
        read(11) ((dwfn(ig,is),ig=1,kp%ngk(ik)),is=1,kp%nspin)
        call write_binary_real_data(21, kp%ngk(ik), kp%ngkmax, kp%nspin, dwfn)
      else
        read(11) ((zwfn(ig,is),ig=1,kp%ngk(ik)),is=1,kp%nspin)
        call write_binary_complex_data(21, kp%ngk(ik), kp%ngkmax, kp%nspin, zwfn)
      endif
    enddo
  enddo

  if(iflavor == 1) then
    SAFE_DEALLOCATE_P(dwfn)
  else
    SAFE_DEALLOCATE_P(zwfn)
  endif

  call close_file(11)
  call close_file(21)

  if(nargs > 4) then

    ! CD95 -> RHO

    call rho_vxc_body(12, 22, iflavor, kp, gvec)
    
    write(6,'(a)') 'Wrote charge density.'
    
    call close_file(12)
    call close_file(22)
    
    ! VXC

    if(nargs > 6) then
      call rho_vxc_body(13, 23, iflavor, kp, gvec)
      
      write(6,'(a)') 'Wrote exchange-correlation potential.'

      call close_file(13)
      call close_file(23)
    endif

  endif

  SAFE_DEALLOCATE_P(gvec%components)

  call dealloc_header_type(sheader, crys, kp)

  write(6,'(3x,"Done",/)')

end program convert_old_to_new


!=============================================================================
subroutine rho_vxc_body(iunit_in, iunit_out, iflavor, kp, gvec)

  use global_m
  use wfn_rho_vxc_io_m
  implicit none

  integer, intent(in) :: iunit_in, iunit_out
  integer, intent(in) :: iflavor
  type(kpoints), intent(in) :: kp
  type(gspace), intent(in) :: gvec

  integer :: nproc_para ! number of divisions of file
  integer :: gs_proc    ! number of G-vectors per division
  integer :: ig, igg, is, ii
  real(DP), pointer :: dwfn(:,:)
  complex(DPC), pointer :: zwfn(:,:)

  if(iflavor == 1) then
    SAFE_ALLOCATE(dwfn, (gvec%ng, kp%nspin))
  else
    SAFE_ALLOCATE(zwfn, (gvec%ng, kp%nspin))
  endif

  read(iunit_in) ! bdate, btime
  read(iunit_in) ! nbands, nspin
  read(iunit_in) nproc_para
  igg = 1
  do ii = 1, nproc_para
    read(iunit_in) gs_proc
    do ig = igg, igg + gs_proc - 1
      read(iunit_in) ! gx, gy, gz
      if(iflavor == 1) then
        read(iunit_in) (dwfn(ig,is),is=1,kp%nspin)
      else
        read(iunit_in) (zwfn(ig,is),is=1,kp%nspin)
      endif
    enddo
    igg = igg + gs_proc
  enddo

  if(iflavor == 1) then
    call write_binary_real_data(iunit_out, gvec%ng, gvec%ng, kp%nspin, dwfn)
  else
    call write_binary_complex_data(iunit_out, gvec%ng, gvec%ng, kp%nspin, zwfn)
  endif

  if(iflavor == 1) then
    SAFE_DEALLOCATE_P(dwfn)
  else
    SAFE_DEALLOCATE_P(zwfn)
  endif

  return
end subroutine rho_vxc_body

!==============================================================================
!
! Routines:
!
! (1) absh()    Originally By MLT               Last Modified 7/1/2008 (JRD)
!
!     Calculates absorption spectra in haydock code.
!
!     input: mmts type (has the Haydock coefficients, a_n b_n)
!            nspin    number of spins
!            eta      energy resolution
!
!     output: file "absorption_eh.dat"
!
!     Calculate the dielectric function (real and imaginary parts),
!     from coefficients mmts%an, mmts%bn
!
!     omega = frequency, given in eV
!     eta = energy broadening, given in eV
!
!==============================================================================

#include "f_defs.h"

subroutine absh(mmts,nspin,eta)

  use global_m
  implicit none

  type (mmtsinfo), intent(in) :: mmts
  integer, intent(in) :: nspin
  real(DP), intent(in) :: eta

  integer :: ih,iw,nwstep
  real(DP) :: w0,wfin,omega,pref,eps1,eps2
  complex(DPC) :: sum,zo

  pref = 16.d0 * PI_D**2 /(mmts%vol * dble(nspin))

  PUSH_SUB(absh)

  w0 =  0.d0
  wfin = 20.d0
  nwstep = 2000
  
  call open_file(10,file='absorption_eh.dat',form='formatted',status='replace')

  write(10,*) "# Column 1: omega"
  write(10,*) "# Column 2: eps2(omega)"
  write(10,*) "# Column 3: eps1(omega)"

  do iw=0,nwstep
    eps2 = 0.d0
    eps1 = 0.d0
    omega = w0 + (wfin - w0) * dble(iw) / dble(nwstep)

!------------------------------------
! Absorption contribution

    zo = CMPLX(omega,eta)/RYD

! Assume that all coefficients above mmts%nmax are constant...
!
!        sum = sqrt( ((zo - mmts%an(mmts%nmax) )/2.d0)**2 - mmts%bn(mmts%nmax) )
!
! or zero... (it doesn`t matter if mmts%nmax is sufficiently high)

    sum = CMPLX(0.d0,0.d0)
    do ih= mmts%nmax, 2, -1
      sum = mmts%bn(ih-1)/( zo - mmts%an(ih) - sum)
    enddo
    sum = CMPLX(mmts%norm / PI_D, 0.d0)/( zo - mmts%an(1) - sum)
    eps2 = -pref*IMAG(sum)
    eps1 = -pref*dble(sum) + 1.d0
    
!-------------------------------------
! Emission contribution

    zo = CMPLX(-omega,eta)/RYD

! Assume that all coefficients above mmts%nmax are constant...
!
!         sum = sqrt( ((zo - mmts%an(mmts%nmax) )/2.d0)**2 -
!     >                       mmts%bn(mmts%nmax) )
!
! or zero...

    sum = CMPLX(0.d0,0.d0)
    do ih= mmts%nmax, 2, -1
      sum = mmts%bn(ih-1)/( zo - mmts%an(ih) - sum)
    enddo
    sum = CMPLX(mmts%norm / PI_D, 0.d0)/( zo - mmts%an(1) - sum)
    eps2 = pref*IMAG(sum) + eps2
    eps1 = -pref*dble(sum) + eps1
    write(10,100) omega,eps2,eps1
  enddo
  
100 format(3f16.9)
  
  call close_file(10)
  
  POP_SUB(absh)
  
  return
end subroutine absh

!*************************************************************************
Program EPM
!*************************************************************************
! EPM calculates the band structure along various directions in
! k-space using a plane-wave basis and a fixed effective potential.
! Several choices of empirical pseudopotentials are provided.
!*************************************************************************
! Written by William Mattson and Richard M. Martin of the University
! of Illinois, based upon program written by K. Glassford and I. Souza.
! Modified by G. Samsonidze for use with BerkeleyGW (August 2008).
!*************************************************************************
! Note: atomic units (a.u.) are used throughout the program.
!*************************************************************************

  use sysParams,           only : double, zero, one, hartree2eV, hbar, bohr, &
                                  echarge, emass
  use TagHandlerMod,       only : tagHandlerT, TagHandlerInit, TagHandlerDestroy, &
                                  & FindTag
  use StructureMod,        only : StructureT, StructureInit, StructureDestroy
  use kPointsMod,          only : kPointsT, KPointsInit, KPointsDestroy
  use graphMod,            only : graphT, PlotBands
  use hamiltonianMod,      only : hamiltonianArrayT, HInit, HDestroy, HDiagonalize, & 
                                  & HPrint
  use eigenStatesMod,      only : eigenStatesT, EigenStatesInit, EigenStatesDestroy, &
                                  & PrintEigenvalues
  use pwHamMod,            only : hamInfoT, HamInfoInit, HamInfoDestroy, &
                                  & HGenerate, FindHMaxSize, GridInit, &
                                  & PotentialRGenerate, KineticGenerate, GridDestroy
  use cgParamsMod,         only : cgParamsT, cgParamsInit
  use typeMod,             only : GridT
  use ConjGradMod,         only : cgEigenSystem,cgFFTDiagonalise

  use message_m, only : open_file, close_file
  implicit none

  type(tagHandlerT),       pointer :: tagHandler
  type(hamInfoT),          pointer :: hamInfo
  type(StructureT),        pointer :: structure1
  type(kPointsT),          pointer :: kPoints
  type(eigenStatesT),      pointer :: eigenStates
  type(hamiltonianArrayT), pointer :: hamiltonian
  type(graphT),            pointer :: graphinfo
  type(cgParamsT)                  :: cgParams
  type(GridT),             pointer :: Grid

  logical :: gap_flag, mass_flag, v_of_q
  integer :: kpt, error, ReportNo, k, n, i, kv, kc
  real(double) :: homo, lumo, gap, e1, e2, e3, d12, d23
  real(double) :: kvPoint(3), kcPoint(3), dk, md(3,3)
  real(double) :: dv1, dv2, dv3, dc1, dc2, dc3, a, b, c
  real(double) :: mv1h, mv2h, mv3h, mv1l, mv2l, mv3l, mc1, mc2, mc3
  real(double) :: mvl, mvh, mct, mcl
  real(double) :: eps, abstol, ff(6)
  character(80) :: filename
  character(256) :: str
  character(256) :: gap_file
  character(256) :: mass_file

  nullify(tagHandler)
  nullify(hamInfo)
  nullify(structure1)
  nullify(kPoints)
  nullify(eigenStates)
  nullify(hamiltonian)
  nullify(graphinfo)
  nullify(Grid)

  ReportNo = 110

  filename = 'input.tmp'
  call open_file(unit = 10, file = filename, status = 'replace')
  i = 0
  do while (i .eq. 0)
     read(unit = 5, fmt = '(a)', iostat = i) str
     write(unit = 10, fmt = '(a)') str
  enddo
  call close_file(unit = 10)

  ! Necessary if using conjugate-gradients method
  call Random_Seed

  ! Initialize "tag handler" to read the input from file 'filename'.
  call TagHandlerInit( tagHandler, 10, filename)

  ! Input parameter gap_flag for BerkeleyGW band gap file
  call FindTag( tagHandler, 'gap_flag', error)
  if(error .eq. 0) then
     read(unit = tagHandler%fileno, fmt = *, iostat = error) gap_flag
  endif
  if(error .ne. 0) gap_flag = .false.
  write(*,'(" gap_flag ",l1)')gap_flag

  ! Input parameter gap_file for BerkeleyGW band gap file
  call FindTag( tagHandler, 'gap_file', error)
  if(error .eq. 0) then
     read(unit = tagHandler%fileno, fmt = *, iostat = error) gap_file
  endif
  if(error .ne. 0) write(gap_file,'("gap.dat")')
  write(*,'(" gap_file ",a)')trim(gap_file)

  ! Input parameter mass_flag for BerkeleyGW effective mass file
  call FindTag( tagHandler, 'mass_flag', error)
  if(error .eq. 0) then
     read(unit = tagHandler%fileno, fmt = *, iostat = error) mass_flag
  endif
  if(error .ne. 0) mass_flag = .false.
  write(*,'(" mass_flag ",l1)')mass_flag

  ! Input parameter mass_file for BerkeleyGW effective mass file
  call FindTag( tagHandler, 'mass_file', error)
  if(error .eq. 0) then
     read(unit = tagHandler%fileno, fmt = *, iostat = error) mass_file
  endif
  if(error .ne. 0) write(mass_file,'("mass.dat")')
  write(*,'(" mass_file ",a)')trim(mass_file)

  ! Use form-factors from input file or hard-coded V(q) potentials
  call FindTag( tagHandler,'FormFactors', error)
  if(error .eq. 0) then
    read(unit = tagHandler%fileno, fmt = *, iostat = error) ff
    if(error /= 0) stop 'Error, could not read FormFactors.'
    v_of_q = .false.
    write(*,'("Using Form Factors V_3,8,11^S & V_3,4,11^A")')
  else
    ff(:) = 0.0d0
    v_of_q = .true.
    write(*,'("Using Potentials V(q) for Species")')
  endif

  ! Read LAPACK Absolute Tolerance
  call FindTag( tagHandler, 'AbsoluteTolerance', error)
  if(error .eq. 0) then
     read(unit = tagHandler%fileno, fmt = *, iostat = error) abstol
  endif
  if(error .ne. 0) abstol = -one
  write(*,'(" AbsoluteTolerance ",e13.6)')abstol

  ! Read the Conjugate Gradient Parameter
  call cgParamsInit(cgParams,tagHandler)

  ! This will call DimensionsInit, LatticeInit, and AtomsInit.
  call StructureInit( structure1, tagHandler )

  call KPointsInit( kPoints, graphInfo, structure1%ndim, structure1%lattice, tagHandler)

  ! Gvector list and structurefactor
  call HamInfoInit( hamInfo, structure1, tagHandler, v_of_q, ff )

  ! Find hMaxSize = max size of H at any k point
  call FindHMaxSize( hamInfo, structure1, kPoints )
  
  ! Allocates array for H and work arrays
  call HInit( hamiltonian, hamInfo%hMaxSize )
  hamiltonian%abstol = abstol

  ! Allocates array for eigenStates array
  call EigenStatesInit( eigenStates, kPoints%numBands, kPoints%numKPoints, &
                      & hamInfo%hMaxSize, -1.0d0, 1)
  eigenStates%eigenVectors = zero

  ! Initialise the FFT Grid and Plans
  Call GridInit(Grid,hamInfo,eigenStates,structure1%ndim)

! DAS -- do not write this useless file if not using CG
  if(cgParams%Switch.eq.1) then
    call open_file(unit=ReportNo,file='Report.cg',status='replace', position='rewind')
    write(ReportNo,*) 'Eigenvalues:'
    write(ReportNo,*) 'The FFT Grid Size +/-',Grid%Size(1)
    write(ReportNo,*) 'The number of GVectors:',Grid%NumgVec
    write(ReportNo,*) 'Eigenvalues:'
  endif

  ! Calculate the Potential and FFT to Vr
  Call PotentialRGenerate(hamInfo,Grid)

  if(cgParams%Switch.eq.1) then 
     do kpt = 1, kPoints%numKPoints 
        call HGenerate( hamInfo, structure1, kPoints, eigenStates, &
             & kpt, hamiltonian%h, hamiltonian%sqH, hamiltonian%hSize )

        write(ReportNo,*) 'k:',kpt

        call cgEigenSystem( hamiltonian,eigenStates,kpt,cgParams%tol, &
             & cgParams%period,ReportNo)

        print *, kpt,'completed out of a total of ',kPoints%numKPoints

     end do ! kpt
  else
     do kpt = 1, kPoints%numKPoints

        call HGenerate( hamInfo, structure1, kPoints, eigenStates, &
             & kpt, hamiltonian%h, hamiltonian%sqH, hamiltonian%hSize )

! DAS -- do not write this useless file      
!        write(ReportNo,*) 'k:',kpt
     
        call HDiagonalize( hamiltonian, eigenStates, kpt )

        print *, kpt,'completed out of a total of ',kPoints%numKPoints
        
     end do ! kpt

  end if

  if(cgParams%Switch.eq.1) then 
    call close_file(unit=ReportNo)
  endif

  ! Convert eigenvalues from Hartree to eV
    do k = 1, kPoints%numKPoints
       do n = 1, kPoints%numBands
          eigenStates%eigenValues(n,k) = eigenStates%eigenValues(n,k) * hartree2eV
       enddo
    enddo

  ! Creates files bands.dat and bands.plt (Display with: gnuplot bands.plt)
  if( associated( graphinfo ) )    call PlotBands( graphinfo, eigenStates )

  if( .not. associated( graphinfo ) )  call PrintEigenvalues(eigenStates, kPoints%numKPoints)

  if (gap_flag .or. mass_flag) then

     homo=-1.0d6
     lumo=1.0d6

     do k=1,kPoints%numKPoints
        do n=1,kPoints%numBands
           if (n.eq.kPoints%numOccupiedBands &
           & .and.eigenStates%eigenValues(n,k).gt.homo) then
              kv=k
              homo=eigenStates%eigenValues(n,k)
           endif
           if (n.eq.kPoints%numOccupiedBands+1 &
           & .and.eigenStates%eigenValues(n,k).lt.lumo) then
              kc=k
              lumo=eigenStates%eigenValues(n,k)
           endif
        enddo
     enddo

  endif

  if (gap_flag) then

     write(*,*)

     if (kv.eq.1.or.kv.eq.kPoints%numKPoints) then
        homo=eigenStates%eigenValues(kPoints%numOccupiedBands,kv)
     else
        e1=eigenStates%eigenValues(kPoints%numOccupiedBands,kv-1)
        e2=eigenStates%eigenValues(kPoints%numOccupiedBands,kv)
        e3=eigenStates%eigenValues(kPoints%numOccupiedBands,kv+1)
        d12=0.0d0
        d23=0.0d0
        do i=1,3
           d12=d12+(kPoints%kPointsLat(1,kv)-kPoints%kPointsLat(1,kv-1))**2
           d23=d23+(kPoints%kPointsLat(1,kv+1)-kPoints%kPointsLat(1,kv))**2
        enddo
        d12=dsqrt(d12)
        d23=dsqrt(d23)
        c=e2
        a=((e1-c)*d23+(e3-c)*d12)/(d12*d23*(d12+d23))
        b=(e3-a*d23**2-c)/d23
        homo=c-b**2/(4.0d0*a)
     endif

     if (kc.eq.1.or.kc.eq.kPoints%numKPoints) then
        lumo=eigenStates%eigenValues(kPoints%numOccupiedBands+1,kc)
     else
        e1=eigenStates%eigenValues(kPoints%numOccupiedBands+1,kc-1)
        e2=eigenStates%eigenValues(kPoints%numOccupiedBands+1,kc)
        e3=eigenStates%eigenValues(kPoints%numOccupiedBands+1,kc+1)
        d12=0.0d0
        d23=0.0d0
        do i=1,3
           d12=d12+(kPoints%kPointsLat(1,kc)-kPoints%kPointsLat(1,kc-1))**2
           d23=d23+(kPoints%kPointsLat(1,kc+1)-kPoints%kPointsLat(1,kc))**2
        enddo
        d12=dsqrt(d12)
        d23=dsqrt(d23)
        c=e2
        a=((e1-c)*d23+(e3-c)*d12)/(d12*d23*(d12+d23))
        b=(e3-a*d23**2-c)/d23
        lumo=c-b**2/(4.0d0*a)
     endif

     gap=lumo-homo

     write(*,'(" Writing band gap...")')

     call open_file(20,file=trim(gap_file),status='replace',form='formatted')
     write(20,'(1x,"Eg =",1x,f9.6,1x,"eV")')gap
     call close_file(20)

     write(*,'(" ...done!")')

  endif

  if (mass_flag) then

     write(*,*)
     write(0,'(1x,a,/)') "WARNING: The effective-mass calculation assumes a bandstructure similar to bulk Si."

     kvPoint(:) = kPoints%kPointsLat(:,kv)
     kcPoint(:) = kPoints%kPointsLat(:,kc)

     kPoints%numKPoints = 14
     do k=1,7
       kPoints%kPointsLat(:,k)=kvPoint(:)
     enddo
     do k=8,14
       kPoints%kPointsLat(:,k)=kcPoint(:)
     enddo

     dk = 1.0d-3

     md(1,1) = 1.0d0/dsqrt(2.0d0)
     md(2,1) = 0.0d0
     md(3,1) = 1.0d0/dsqrt(2.0d0)
     md(1,2) = 0.0d0
     md(2,2) = 1.0d0/dsqrt(2.0d0)
     md(3,2) = 1.0d0/dsqrt(2.0d0)
     md(1,3) = 1.0d0/dsqrt(2.0d0)
     md(2,3) = 1.0d0/dsqrt(2.0d0)
     md(3,3) = 0.0d0

     kPoints%kPointsLat(:, 2)  = kPoints%kPointsLat(:, 2)  - dk * md(:,1)
     kPoints%kPointsLat(:, 3)  = kPoints%kPointsLat(:, 3)  + dk * md(:,1)
     kPoints%kPointsLat(:, 4)  = kPoints%kPointsLat(:, 4)  - dk * md(:,2)
     kPoints%kPointsLat(:, 5)  = kPoints%kPointsLat(:, 5)  + dk * md(:,2)
     kPoints%kPointsLat(:, 6)  = kPoints%kPointsLat(:, 6)  - dk * md(:,3)
     kPoints%kPointsLat(:, 7)  = kPoints%kPointsLat(:, 7)  + dk * md(:,3)

     kPoints%kPointsLat(:, 9)  = kPoints%kPointsLat(:, 9)  - dk * md(:,1)
     kPoints%kPointsLat(:, 10) = kPoints%kPointsLat(:, 10) + dk * md(:,1)
     kPoints%kPointsLat(:, 11) = kPoints%kPointsLat(:, 11) - dk * md(:,2)
     kPoints%kPointsLat(:, 12) = kPoints%kPointsLat(:, 12) + dk * md(:,2)
     kPoints%kPointsLat(:, 13) = kPoints%kPointsLat(:, 13) - dk * md(:,3)
     kPoints%kPointsLat(:, 14) = kPoints%kPointsLat(:, 14) + dk * md(:,3)

     do kpt = 1, kPoints%numKPoints
        call HGenerate( hamInfo, structure1, kPoints, eigenStates, &
             & kpt, hamiltonian%h, hamiltonian%sqH, hamiltonian%hSize )
        call HDiagonalize( hamiltonian, eigenStates, kpt )
     enddo

     n=kPoints%numOccupiedBands-2
     dv1=-(eigenStates%eigenValues(n, 2)+eigenStates%eigenValues(n, 3)-2.0d0*eigenStates%eigenValues(n, 1)) &
       /(dk*structure1%lattice%bLatVecLen(1))**2
     dv2=-(eigenStates%eigenValues(n, 4)+eigenStates%eigenValues(n, 5)-2.0d0*eigenStates%eigenValues(n, 1)) &
       /(dk*structure1%lattice%bLatVecLen(2))**2
     dv3=-(eigenStates%eigenValues(n, 6)+eigenStates%eigenValues(n, 7)-2.0d0*eigenStates%eigenValues(n, 1)) &
       /(dk*structure1%lattice%bLatVecLen(3))**2
     dv1=dv1*hartree2eV*echarge*bohr**2
     dv2=dv2*hartree2eV*echarge*bohr**2
     dv3=dv3*hartree2eV*echarge*bohr**2
     mv1l=hbar**2/dv1/emass
     mv2l=hbar**2/dv2/emass
     mv3l=hbar**2/dv3/emass

     n=kPoints%numOccupiedBands
     dv1=-(eigenStates%eigenValues(n, 2)+eigenStates%eigenValues(n, 3)-2.0d0*eigenStates%eigenValues(n, 1)) &
       /(dk*structure1%lattice%bLatVecLen(1))**2
     dv2=-(eigenStates%eigenValues(n, 4)+eigenStates%eigenValues(n, 5)-2.0d0*eigenStates%eigenValues(n, 1)) &
       /(dk*structure1%lattice%bLatVecLen(2))**2
     dv3=-(eigenStates%eigenValues(n, 6)+eigenStates%eigenValues(n, 7)-2.0d0*eigenStates%eigenValues(n, 1)) &
       /(dk*structure1%lattice%bLatVecLen(3))**2
     dv1=dv1*hartree2eV*echarge*bohr**2
     dv2=dv2*hartree2eV*echarge*bohr**2
     dv3=dv3*hartree2eV*echarge*bohr**2
     mv1h=hbar**2/dv1/emass
     mv2h=hbar**2/dv2/emass
     mv3h=hbar**2/dv3/emass

     n=kPoints%numOccupiedBands+1
     dc1=(eigenStates%eigenValues(n, 9)+eigenStates%eigenValues(n,10)-2.0d0*eigenStates%eigenValues(n, 8)) &
       /(dk*structure1%lattice%bLatVecLen(1))**2
     dc2=(eigenStates%eigenValues(n,11)+eigenStates%eigenValues(n,12)-2.0d0*eigenStates%eigenValues(n, 8)) &
       /(dk*structure1%lattice%bLatVecLen(2))**2
     dc3=(eigenStates%eigenValues(n,13)+eigenStates%eigenValues(n,14)-2.0d0*eigenStates%eigenValues(n, 8)) &
       /(dk*structure1%lattice%bLatVecLen(3))**2
     dc1=dc1*hartree2eV*echarge*bohr**2
     dc2=dc2*hartree2eV*echarge*bohr**2
     dc3=dc3*hartree2eV*echarge*bohr**2
     mc1=hbar**2/dc1/emass
     mc2=hbar**2/dc2/emass
     mc3=hbar**2/dc3/emass

! DAS -- This is where strong assumptions about the bandstructure were made by GSM.
!     mv=(dsqrt(mv1h*mv2h*mv3h)+dsqrt(mv1l*mv2l*mv3l))**(2.0d0/3.0d0)
!     mc=(6.0d0*dsqrt(mc1*mc2*mc3))**(2.0d0/3.0d0)

     eps=1.0d-6
     mvl=0.0d0
     mvh=0.0d0
     mct=0.0d0
     mcl=0.0d0
     if (abs(mv1l-mv2l).lt.eps.and.abs(mv2l-mv3l).lt.eps) mvl=mv1l
     if (abs(mv1h-mv2h).lt.eps.and.abs(mv2h-mv3h).lt.eps) mvh=mv1h
     if (abs(mc1-mc2).lt.eps) then
        mcl=mc3
        mct=mc1
     elseif (abs(mc2-mc3).lt.eps) then
        mcl=mc1
        mct=mc2
     elseif (abs(mc1-mc3).lt.eps) then
        mcl=mc2
        mct=mc1
     endif

     write(*,'(" Writing effective masses...")')

     call open_file(20,file=trim(mass_file),status='replace',form='formatted')
!     write(20,'(1x,"mh =",1x,f9.6,1x,"m0")')mv
!     write(20,'(1x,"me =",1x,f9.6,1x,"m0")')mc
     write(20,'("        light hole     - mlh = ",f9.6," m0")')mvl
     write(20,'("        heavy hole     - mhh = ",f9.6," m0")')mvh
     write(20,'(" longitudinal electron - mle = ",f9.6," m0")')mcl
     write(20,'("   transverse electron - mte = ",f9.6," m0")')mct
     call close_file(20)

     write(*,'(" ...done!")')

  endif

  write(*,*)

  ! Clean up memory
  call EigenStatesDestroy( eigenStates )

  call HDestroy( hamiltonian )

  call GridDestroy ( Grid )
                
  call HamInfoDestroy( hamInfo )

  call KPointsDestroy( kPoints )

  call StructureDestroy( structure1 )

  ! Clean up and close the input file
  call TagHandlerDestroy( tagHandler )

  call open_file(unit = 10, file = filename, status = 'old')
  call close_file(unit = 10, delete = .true.)

end Program EPM

#include "f_defs.h"

!*************************************************************************
Module TagHandlerMod
!*************************************************************************
! The module contains the public functions:
!    TagHandlerInit(tagHandler, fileno, filename)
!                              Opens the file filename with unit number
!                              fileno, then sets up the case insensitivity.
!                              Copies the filename.
!    TagHandlerDestroy         Closes the unit fileno, deallocates
!                              the copy of filename.
!    FindTag(tagname, fterr)   Searches the file filename from the 
!                              begining to find the tag tagname.  It
!                              returns fterr = 0 if the tag was found.
!                              The unit fileno will be set at
!                              immediately after tagname.  Search is
!                              case insensitive.
!   StringCompare(str1, str2)  Logical function that returns true if
!                              str1 has a subset equal to str2.  The
!                              comparison is case insensitive.
!*************************************************************************
! The module contains the public variables:
!    fileno                    The unit number of the file that taghandler
!                              will search.
!*************************************************************************
! The module contains the private functions:
!    CopyString(str, pstr)     Allocates space in pstr equal to the size of
!                              str then copies the contents of str into pstr.
!    CUpperCase(c)             Converts the character c to uppercase.
!    CopyToUppercase(str,pstr) Like CopyString except that it converts the
!                              string to uppercase letters.
!*************************************************************************
! The module contains the private variables:
!    ucase                     The integer index of A in the ascii sequence.
!    lcase                     The integer index of a in the ascii sequence.
!    filename                  A copy of the parameter to TagHandlerInit.
!*************************************************************************
! Rules:                       Tags must be contain only alphabetic characters.
!                              Tags are case insensitive.
!*************************************************************************

  use push_pop_m
  implicit none

  integer              :: ucase, lcase
 
  type tagHandlerT
    integer            :: fileno
    character, pointer :: filename(:)
  end type tagHandlerT

  private ucase
  private lcase
  private CopyString
  private CUpperCase
  private CopyToUpperCase

  contains

!*************************************************************************
  Subroutine CopyString(str, pstr)
!*************************************************************************

    implicit none

    character*(*), intent(in) :: str
    character, pointer        :: pstr(:)
    integer                   :: error, i, clen

    PUSH_SUB(CopyString)

    clen = len(str)
    allocate(pstr(clen), stat = error)
    if(error /= 0) then
      stop 'Error allocating space in CopyString.'
    end if

    do i = 1, clen
      pstr(i) = str(i:i)
    end do

    POP_SUB(CopyString)
  end Subroutine CopyString

!*************************************************************************
  Function CUpperCase(c)
!*************************************************************************

    implicit none

    character, intent(in) :: c
    character             :: CUpperCase
    integer               :: i

    ! no push_sub, called too frequently

    i = ichar(c)
    CUpperCase = char(mod(i,lcase) + int(i/lcase) * ucase)

  end function CUpperCase

!*************************************************************************
  Subroutine CopyToUpperCase(str, pstr)
!*************************************************************************

    implicit none

    character*(*), intent(in) :: str
    character, pointer        :: pstr(:)
    integer                   :: clen, i

    PUSH_SUB(CopyToUpperCase)

    call CopyString(str, pstr)
! Changed below since we know from routine above that lbound = 1.
! And if it weren`t, the loop below would fail despite this 'precaution.' --DAS
!    clen = ubound(pstr,1) - lbound(pstr,1) + 1
    clen = ubound(pstr,1)

    do i = 1, clen
      pstr(i) = CUpperCase(pstr(i))
    end do

    POP_SUB(CopyToUpperCase)
  end Subroutine CopyToUpperCase

!*************************************************************************
  Function StringCompare(str1, str2)
!*************************************************************************

    implicit none

    character*(*), intent(in) :: str1, str2
    character, pointer        :: ustr1(:), ustr2(:)
    integer                   :: clen1, clen2, i, match, error
    logical                   :: StringCompare

    PUSH_SUB(StringCompare)

    StringCompare = .False.
    call CopyToUpperCase(str1, ustr1)
    call CopyToUpperCase(str2, ustr2)
    clen1 = len(str1)
    clen2 = len(str2)
    if(clen1 .lt. 1 .or. clen2 .lt. 1) then
      stop 'Error in StringCompare, string has zero length.'
    end if
    match = 1
    i = 1

    do while(match .le. clen2 .and. i .le. clen1)
      if(ustr1(i) .eq. ustr2(match)) then
        match = match + 1
      else
        match = 1
      end if
      i = i + 1
    end do

    if(match .gt. clen2) StringCompare = .True.

    deallocate(ustr1, ustr2, stat = error)
    if(error /= 0) stop 'Error deallocating ustr1 in StingCompare.'

    POP_SUB(StringCompare)
  end Function StringCompare

!*************************************************************************
  Subroutine TagHandlerInit(tagHandler, no, fname)
!*************************************************************************

    use message_m
    implicit none

    type( tagHandlerT ), pointer :: tagHandler
    integer, intent(in)          :: no
    character*(*), intent(in)    :: fname
    integer                      :: error

    PUSH_SUB(TagHandlerInit)

    if(associated( tagHandler )) stop 'Error, tagHandler is already allocated.'

    allocate( tagHandler , stat = error )
    if( error /= 0 ) stop 'Error, tagHandler allocation failed.'

    call open_file(unit = no, file = fname, status = 'OLD', FORM = 'formatted')

    taghandler%fileno = no
    call CopyString(fname, taghandler%filename)
    ucase = ichar('A')
    lcase = ichar('a')

    if(lcase .lt. ucase) then

      error = lcase
      lcase = ucase
      ucase = error

    end if

    POP_SUB(TagHandlerInit)
  end Subroutine TagHandlerInit

!*************************************************************************
  Subroutine TagHandlerDestroy( tagHandler )
!*************************************************************************

    use message_m
    implicit none

    type( tagHandlerT ), pointer :: tagHandler
    integer :: error

    PUSH_SUB(TagHandlerDestroy)

    if( .not. associated( tagHandler )) stop 'Error; tagHandler not allocated.'

    call close_file(unit = taghandler%fileno)

!   close_file handles this issue now. --DAS
!    if(error /= 0) then
!      stop 'Error closing file in TagHandler.'
!    end if

!BUS ERROR begin
    deallocate(tagHandler%filename, stat = error)

    if(error /= 0) then
      stop 'Error deallocating filename in TagHandler.'
    end if

    deallocate( tagHandler, stat = error )
    
    if(error /= 0) then
      stop 'Error deallocating TagHandler.'
    end if

    nullify( tagHandler )
!BUS ERROR end

    POP_SUB(TagHandlerDestroy)
  end Subroutine TagHandlerDestroy

!*************************************************************************
  Subroutine FindTag(tagHandler, tag, fterr)
!*************************************************************************

    implicit none

    type( tagHandlerT ), pointer :: tagHandler
    character*(*), intent(in)    :: tag
    integer, intent(out)         :: fterr
    character, pointer           :: uppercasetag(:)
    character                    :: c
    integer                      :: error, clen, match

    PUSH_SUB(FindTag)

    if( .not. associated( tagHandler )) stop 'Error, tagHandler not allocated in FindTag.'
    fterr = 0
    clen = len(tag)
    rewind(unit = tagHandler%fileno, iostat = error)

    if(error /= 0) then
      stop 'Error rewinding file in FindTag'
      fterr = 2
    end if

    match = 1
    
    call CopyToUpperCase(tag, uppercasetag)

    do while(match .le. clen)
      read(unit = tagHandler%fileno, FMT = '(A1)', advance = 'NO', &
          & iostat = error, end = 100) c
      if(CUpperCase(c) .eq. uppercasetag(match)) then
        match = match + 1
      else
        match = 1
      end if
    end do

100 if(match .le. clen) then
      print *, 'Warning: tag ', tag, ' could not be found in the input file.'
      fterr = 1
    end if

    deallocate(uppercasetag, stat = error)
    if(error /= 0) then
      stop 'Error, in TagHandler, deallocating uppercasetag.'
    end if

    POP_SUB(FindTag)
  end Subroutine FindTag

end Module TagHandlerMod

!=============================================================================
!
! Routines:
!
! (1) intpts_local()    Originally By JRD        Last Modified: 6/16/2011 (FHJ)
!  
!     Calculates the interpolating coefficients for a fine point qq given a
!     coarse grid. The function is optimized for a large number of points
!     using a local search algorithm. The routine only looks for coarse points
!     that are in neighborhood of the fine point, which is accomplished by
!     dividing the space into cells. This subroutine might is especially useful
!     if the coarse grid contains more than ~1000 points.
!
!     - Note 1: before using the function, you must prepare the cell structure
!     via alloc_intpts(), and later decommission it via dealloc_intpts().
!     - Note 2: results are mostly the same as those obtained by the original
!     function intpts_full(). But there might be some reproducible differences
!     in unshifted grids due to the way the points are sorted.
!
!     Changelog:
!       2010/28/06 [FHJ] Mostly rewritten to make control flow more logical.
!
!     intpts_full()     Originally By JRD        Last Modified: 6/16/2011 (FHJ)
!
!     Original "non-local" version of intpts written by JRD.
!
!     Changelog:
!       2010/14/06 [FHJ] Fixed the interpolation near the border of the BZ
!                  when umklapp = false (amat should be the smallest distance)
!     This routine was decommissioned at r3253.
!     We used to have ESSL support here. It could be put back if desired.
!
! (2) alloc_intpts()    Originally by FHJ        Last Modified: 6/16/2011 (FHJ)
!      
!     Allocates memory and initializes cell structure for intpts_local. You
!     should decommission and reinitialize the cells for each kind of
!     interpolation that you perform.
!
! (3) dealloc_intpts()  Originally by FHJ        Last Modified: 6/16/2011 (FHJ)
!     Free memory allocated by alloc_intpts().
!
! (4) get_ndims()       Originally by FHJ        Last Modified: 2/08/2012 (FHJ)
!
!     
!==============================================================================

#include "f_defs.h"

module intpts_m

  use global_m
  use lapack_m
  use sort_m

  implicit none

  public :: alloc_intpts, dealloc_intpts, intpts_local, get_ndims

  private

  real(DP), allocatable :: cell_head(:,:,:), cell_list(:)
! FHJ: cell_factor = 1/length of the individual cell
!      cell_shift = length of the individual cell / 2
  real(DP), dimension(3) :: cell_dmin, cell_dmax, cell_factor, cell_shift
  integer , dimension(3) :: cell_N
  !> size of the list that keep the nearest neighbors.
  integer, parameter :: NEI_BUFFER = 1000
  !> These variables represent what alloc_intpts *thinks* that the space
  !! (geometry/#dims) looks like
  integer :: cell_ndims
  logical :: cell_active_dim(3) !< .true. if system is non-deg. in a particular dim

contains

!> FHJ: interpolate a point qq using a coarse grid coarsepts. Call alloc_intpts
!!      before calling this function, and dealloc_intpts after.
  subroutine intpts_local(crys,qq,ncoarse,coarsepts,xct,closepts,closeweights,periodic)
    type (crystal), intent(in) :: crys
    real(DP), intent(in) :: qq(3)
    integer, intent(in) :: ncoarse
    real(DP), intent(in) :: coarsepts(3, ncoarse)
    type (xctinfo), intent(in) :: xct
    integer, intent(out) :: closepts(4)
    real(DP), intent(out) :: closeweights(4)
    logical, intent(in) :: periodic
    
    real(DP) :: qq_(3)
    real(DP) :: norm,den,closediffs(4)
    integer ii,jj,info,indx(4),iq,iii,jjj,kkk,kkk_max,iqarray(2)
    real(DP) :: diff(3),vol_sum,delta_r
    integer :: ipiv(4)
    real(DP) :: amat(4,4),vol(3,3),amatt(3,3),bvec(4,4)
    real(DP) :: fct1,fct2,fct3
! FHJ: The size of arrays like iqnear are now fixed. This way, we make use of
!      the stack memory, which is faster than the heap. This is important b/c
!      this function is called many times.
    real(DP) :: diffl(NEI_BUFFER), tempr(NEI_BUFFER)
    integer :: iqnear(NEI_BUFFER), idx_found(NEI_BUFFER), tempi(NEI_BUFFER)
! FHJ: We should find at least this number of neighbors for a given dimension
    integer :: min_pts

    integer :: nn_found, cell_idx(3), cell_min(3), cell_max(3)
    integer :: cell_dist, cell_dist_max
    integer :: j1,j2,j3, i1,i2,i3

    PUSH_SUB(intpts_local)

! FHJ: number of neighbors to find
    min_pts = xct%idimensions + 1

! FHJ: The qq_ is a vector inside the cubic reciprocal cell.
    qq_(:) = qq(:)
    if (periodic) then
      ! FHJ: this is guaranteed to be in [0, 1)
      qq_(:) = UNIT_RANGE(qq_(:))
    endif

! FHJ: Find the central cell for this qq_
    call get_cell_idx(qq_, cell_idx, periodic)

! FHJ: Initially, we only consider the +/- 1 neighboring cells, and if the cell
!      partition is good, the routine will return when cell_dist=1.
!      If we can`t find the minimum number of neighbors, include cells farther
!      away, up to cell_dist_max apart.
    cell_dist_max = idint(maxval(cell_N)*0.5 + TOL_SMALL)
    if (cell_dist_max<1) cell_dist_max=1
cell_dist_do:&
    do cell_dist = 1,cell_dist_max
      iqnear=0
      indx=0

! FHJ: Cell_min and cell_max are the starting/ending local neighboring cells
!      But start/end cells should not overlap!
      do ii=1,3
        if ((2*cell_dist+1).ge.cell_N(ii)) then
          cell_min(ii) = 1
          cell_max(ii) = cell_N(ii)
        else
          cell_min(ii) = cell_idx(ii) - cell_dist
          cell_max(ii) = cell_idx(ii) + cell_dist
        endif
      enddo
      if (.not.periodic) then
        cell_min(:) = max(cell_min(:), 1)
        cell_max(:) = min(cell_max(:), cell_N)
      endif

! FHJ: Search for points in neighboring cells.
      nn_found=0
do_:  do i1=cell_min(1),cell_max(1)
        j1 = fix_index(i1,1)
        do i2=cell_min(2),cell_max(2)
          j2 = fix_index(i2,2)
          do i3=cell_min(3),cell_max(3)
            j3 = fix_index(i3,3)
            call get_cell_pts()
            if (nn_found >= nei_buffer) exit do_
          enddo
        enddo
      enddo do_

! FHJ: Require a minimum number of pts, which depend on the # of dimensions
      if (nn_found < min_pts) then
        if (peinf%inode==0) then
          write(0,'(a,i1,a)') 'WARNING: Could not find ',min_pts,' points.'
          write(0,*) 'Increasing the number of neighboring cells'
        endif
        cycle cell_dist_do !continue to the next value of cell_dist
      endif

! FHJ: Sort the distances and break ties by the index on the coarse grid.
!      This should mimic the behavior of the original code, so that results are
!      almost compatible with the non-local routine. Deviations are due
!      to rounding errors, and b/c of the stability of the sorting algorithm.
!      Instead of doing one search with the two conditions, we break it into
!      2 searches (ideally, we should make the second search stable!)
!   1) Sort by indices and rearrange vectors.
      call sortix(nn_found, idx_found, iqnear)
      ! DAS: one shot without the temp arrays may be optimized incorrectly
      tempi(1:nn_found) = idx_found(iqnear(1:nn_found))
      tempr(1:nn_found) = diffl(iqnear(1:nn_found))
      idx_found(1:nn_found) = tempi(1:nn_found)
      diffl(1:nn_found) = tempr(1:nn_found)
!   2) Sort by distances.
      call sortrx(nn_found, diffl, iqnear)

! FHJ: iqnear stores the indices of the (nn_found) *nearest* q-points. Also,
!      idx_co stores the *coarse* point corresponding to a neighbor. Example:
!      to get the index of the *closest coarse* pt, use idx_co(iqnear(1))

! FHJ: For the interpolation scheme, we have to consider now triangles or
!      tetrahedrons. However, the points may be degenerate. So, we have
!      to test many combinations of 4 points. Obviously, we can always fix the
!      first coordinate idx_co(iqnear(1)) and loop only through the other ones.

! FHJ: Now, instead of looping through coordinates, we can loop through all the
!      possible combinations of indices. We define:
!      - indx(:): one particular combination of indices for the iqnear list of
!        near points. For 3D, some possible values are
!          {indx(:)} = {(1,2,3,4), (1,2,3,5), ..., (1,N-2,N-1,N)}
!        where N=nn_found. For 2D:
!          {indx(:)} = {(1,2,3), (1,2,4), ..., (1,N-1,N)}
!      - closepts(i) = idx_found(indx(i)): index of the coarse pt associated to
!        the ith-vertex of the tetrahedron.
!      - closediffs(i) = diffl(indx(i)): distance from the ith-vertex to the
!        point qq. 
!     Note: indx(1), closepts(1) and closediffs(1) are always fixed
      indx(1) = iqnear(1)
      closepts(1) = idx_found(indx(1))
      closediffs(1) = diffl(indx(1))

! FHJ: Before doing anything too fancy, are we within the numerical error of 
!     a point in the coarse grid?
!------------------------
      if (closediffs(1)<TOL_Small) then
        call return_first_pt()
        POP_SUB(intpts_local)
        return
      endif    

! FHJ: Special case: 1 dimension (just do a simple linear interpolation)
!------------------------
      if (xct%idimensions==1) then
        closepts(2) = idx_found(iqnear(2))
        closediffs(2) = diffl(iqnear(2))

        closeweights(1) = closediffs(2)/(closediffs(1)+closediffs(2))
        closeweights(2) = closediffs(1)/(closediffs(1)+closediffs(2))
        POP_SUB(intpts_local)
        return
      endif

! FHJ: For 2D, if nn_found==3, we have to make up a third point to avoid
!       memory problems. Either this or writing lots of if`s later...
      if ((xct%idimensions==2).and.(nn_found==3)) iqnear(4) = iqnear(3)

! FHJ: 2 and 3 dimensions
!------------------------
      do iii = 2,nn_found-1
        do jjj = iii+1,nn_found

! FHJ: If there are only 2 dimensions, we don`t have to loop through kkk.
!      The simplest solution is to make kkk constant. Note that, for 3D,
!      kkk_max automatically sets the maximum values of iii and jjj to
!      nn_found-2 and nn_found-1, respectively.
          if (xct%idimensions==3) then
            kkk_max = nn_found
          else
            kkk_max = jjj+1
          endif
          do kkk = jjj+1,kkk_max
            indx(2) = iqnear(iii)
            indx(3) = iqnear(jjj)
            indx(4) = iqnear(kkk) !not used for 2D
            closepts(2:4) = idx_found(indx(2:4))
            closediffs(2:4) = diffl(indx(2:4))

! FHJ: amat(ii,:) is the coordinate of the ii-th vertex of the tetrah./triang.
            do ii=1,4
              do jj=1,3
                amat(ii,jj)=coarsepts(jj,closepts(ii))
! FHJ: If periodic, then center amat around the qq point
                if (periodic) then
                  delta_r = amat(ii,jj) - qq(jj)
                  amat(ii,jj) = MIN_RANGE(delta_r) + qq(jj)
                endif
              enddo
              amat(ii,4) = 1.d0
            enddo

! FHJ: Check if the four/three vertices form a tetrahedron/triangle with non-zero volume
            if (xct%idimensions==3) then
              do ii=1,3 !note: we are indeed using all the 4 vertices
                norm=0.d0
                do jj=1,3
                  vol(ii,jj) = amat(ii+1,jj) - amat(1,jj)
                  norm = norm + vol(ii,jj)**2
                enddo
                norm=sqrt(norm) !normalize the vectors 
                if(abs(norm) < TOL_Zero) call die("intpts polyhedron has zero norm")
                do jj=1,3
                  vol(ii,jj) = vol(ii,jj)/norm
                enddo
              enddo
              vol_sum = vol(1,1)*vol(2,2)*vol(3,3) + vol(1,2)*vol(2,3)*vol(3,1) + &
                vol(1,3)*vol(2,1)*vol(3,2) - vol(1,1)*vol(2,3)*vol(3,2) - &
                vol(1,2)*vol(2,1)*vol(3,3) - vol(1,3)*vol(2,2)*vol(3,1)
              vol_sum = dabs(vol_sum)
            else !2D case
              do ii=1,2
                norm=0.d0
                do jj=1,3
                vol(ii,jj) = amat(ii+1,jj) - amat(1,jj)
                norm = norm + vol(ii,jj)**2
                enddo

                norm=sqrt(norm) ! FHJ: Normalize the vectors 
                do jj=1,3
                  vol(ii,jj) = vol(ii,jj)/norm
                enddo
              enddo
! JRD: This does a cross product
              fct1 = vol(1,2)*vol(2,3) - vol(2,2)*vol(1,3)
              fct2 = vol(1,3)*vol(2,1) - vol(1,1)*vol(2,3)
              fct3 = vol(1,1)*vol(2,2) - vol(1,2)*vol(2,1)
              vol_sum = sqrt(fct1**2+fct2**2+fct3**2)
            endif !3D/2D cases

            if (vol_sum > TOL_Small) then! this is a valid tetrahedron/triangle
              if (xct%idimensions==3) then
                bvec(:,:)=0D0
                bvec(1,1)=1D0
                bvec(2,2)=1D0
                bvec(3,3)=1D0
                bvec(4,4)=1D0
                call DGESV(4,4,amat,4,ipiv,bvec,4,info)

                if (info.ne.0) then
                  write(0,*) 'WARNING: LAPACK failed at intpts_local, which is unexpected. Cycling indices.'
                  cycle
                else
                  do i1 = 1,4
                    closeweights(i1) = bvec(1,i1)*qq(1) + &
                      bvec(2,i1)*qq(2)+bvec(3,i1)*qq(3) + bvec(4,i1)
                  enddo
                endif
              else !2D
                do ii=1,3
                  iq=0
                  do jj=1,3
                    if (xct%is_periodic(jj)) then
                      iq=iq+1
                      iqarray(iq)=jj
                      amatt(ii,iq)=amat(ii,jj)
                    endif
                  enddo
                  amatt(ii,3)=1.d0
                enddo

                den=-1.d0*amatt(2,1)*amatt(1,2)+ &
                  amatt(3,1)*amatt(1,2)+ &
                  amatt(1,1)*amatt(2,2)- &
                  amatt(3,1)*amatt(2,2)- &
                  amatt(1,1)*amatt(3,2)+ &
                  amatt(2,1)*amatt(3,2)

                closeweights(1) = qq(iqarray(1))*(amatt(2,2)-amatt(3,2))/den + &
                            qq(iqarray(2))*(amatt(3,1)-amatt(2,1))/den + &
                            (amatt(2,1)*amatt(3,2)-amatt(3,1)*amatt(2,2))/den
                closeweights(2) = qq(iqarray(1))*(amatt(3,2)-amatt(1,2))/den + &
                            qq(iqarray(2))*(amatt(1,1)-amatt(3,1))/den + &
                            (amatt(3,1)*amatt(1,2)-amatt(1,1)*amatt(3,2))/den
                closeweights(3) = qq(iqarray(1))*(amatt(1,2)-amatt(2,2))/den + &
                            qq(iqarray(2))*(amatt(2,1)-amatt(1,1))/den + &
                            (amatt(1,1)*amatt(2,2)-amatt(2,1)*amatt(1,2))/den
              endif !3D/2D
              
              POP_SUB(intpts_local)
              return !since we got a valid set of vertices
            endif !sum_vol>TOL_Small (valid vertices)
            
          enddo !kkk
        enddo !jjj
      enddo !iii

      if (peinf%inode==0) then
        write(0,*)
        write(0,'(/,a,i3,a)') ' WARNING: could not perform the interpolation using ',&
          cell_dist,'-order cell neighbors.'
        if (cell_dist<cell_dist_max) then
          write(0,'(/,a,i3,a)') ' Increasing to ',cell_dist+1,'-order neighbors.'
        else
          write(0,*) ' Interpolation failed! Using nearest point available.'
          write(0,*) ' Check if the coarse grid is well-behaved and if the cell'
          write(0,*) ' population is evenly distributed.'
        endif
      endif
    enddo cell_dist_do !the loop over cell_dist

! FHJ: Epic Fail! Just return the nearest-neighbor.
    call return_first_pt()
    POP_SUB(intpts_local)
    return

!------------------------------------------------------------------------------

  contains
  
    subroutine return_first_pt()
      PUSH_SUB(intpts_local.return_first_pt)
! FHJ: closepts(1) was already set, and memory for 2:4 has to be accessible
      closepts(2:4) = 1
      closeweights(1) = 1.0D0
      closeweights(2:4) = 0D0
      POP_SUB(intpts_local.return_first_pt)
      return
    end subroutine return_first_pt
  
    subroutine get_cell_pts()

      integer :: idx_co, ikb     

      ! no push/pop since called too frequently
      idx_co=cell_head(j1,j2,j3)
      do while (idx_co>0)
        nn_found = nn_found+1

        ! FHJ: we don`t need to punish b/c the coarse grid, by construction,
        ! doesn`t have points in non-periodic directions.
        ! TODO: die if WFN and epsilon grids are incompatible.
        diff(:) = qq_(:) - coarsepts(:, idx_co)
        if (periodic) then
          diff(:) = MIN_RANGE(diff(:))
        endif
        diffl(nn_found)=DOT_PRODUCT(diff,MATMUL(crys%bdot,diff))
        if (xct%idimensions==1) then
          diffl(nn_found)=sqrt(diffl(nn_found))
        endif
        idx_found(nn_found) = idx_co
        ! FHJ - Avoid buffer overflow
        if (nn_found >= NEI_BUFFER) return ! no push/pop since called too frequently
        ! FHJ - Move to next point in this cell
        idx_co=cell_list(idx_co)
      enddo

      ! no push/pop since called too frequently
    end subroutine get_cell_pts
          
    !Returns n such that 1 <= n <= N
    integer function fix_index(idx, dim_)
      integer, intent(in) :: idx, dim_

      ! no push/pop since called too frequently
      fix_index = idx
      if (periodic) then
        fix_index = modulo(fix_index-1, cell_N(dim_)) + 1
      endif
    end function fix_index
    
  end subroutine intpts_local

!------------------------------------------------------------------------------   
!> Calculate the kgrid geometry by looking at the space spawned by the kpoints
!! This is useful when the value passed as kgrid is (0,0,0), when doing
!! inteqp, for instance. This function actually works by allocating and 
!! deallocating a cell structure, so make sure there is no active cell
!! before calling this function!
  subroutine get_ndims(kg, xct)
    type (grid), intent(in) :: kg
    type (xctinfo), intent(inout) :: xct
    integer :: ii

    PUSH_SUB(get_ndims)

    call alloc_intpts(kg%nf, kg%f, periodic=.true., quiet=.true.)
    xct%idimensions = cell_ndims
    do ii=1,3
      xct%is_periodic(ii) = .false.
      if (cell_active_dim(ii)) xct%is_periodic(ii) = .true.
    enddo
    call dealloc_intpts()

    POP_SUB(get_ndims)

  end subroutine get_ndims

!------------------------------------------------------------------------------   
  subroutine alloc_intpts(ncoarse,coarsepts_,periodic,quiet)
    integer, intent(in) :: ncoarse
    real(DP), intent(in) :: coarsepts_(3,ncoarse)
    logical, intent(in) :: periodic
    logical, optional :: quiet

! FHJ: These are the coarsepts_ mapped to the cubic cell (if periodic)
    real(DP) :: coarsepts(3,ncoarse)
    integer :: j1,j2,j3, ii, idx_co,cell_idx(3)
    real(DP) :: dim_vol, prop_const
    logical :: should_write

    PUSH_SUB(alloc_intpts)

    should_write = .true.
    if (present(quiet)) should_write = .not. quiet

#ifdef VERBOSE
    if (peinf%inode==0.and.should_write) write(6,'(/,a)') 'Starting alloc_intpts'
#endif

    if (periodic) then
      ! FHJ: this is guaranteed to be in [0, 1)
      coarsepts(:,:) = UNIT_RANGE(coarsepts_(:,:))
    else
      coarsepts(:,:) = coarsepts_(:,:)
    endif
   
! FHJ: Avoid problems that a very small dimension may cause
    cell_active_dim(:) = .false.
    cell_ndims = 0
    cell_dmin(:) = minval(coarsepts(:,:), dim=2)
    cell_dmax(:) = maxval(coarsepts(:,:), dim=2)
    do ii=1,3
      if ((cell_dmax(ii)-cell_dmin(ii)) > TOL_Small) then
        cell_active_dim(ii) = .true.
        cell_ndims = cell_ndims + 1
        if (periodic) then
          cell_dmin(ii) = 0d0
          cell_dmax(ii) = 1d0
        endif
      endif
    enddo

    ! This is only to avoid division by zero later on
    cell_dmin(:) = cell_dmin(:) - TOL_Small
    cell_dmax(:) = cell_dmax(:) + TOL_Small

! FHJ: number of cells is proportional to the length of each active dimension
!      this should work for any number of dimensions. Proof:
!        d1*d2*... = V
!        n1 = c*d1*(N)^(1/D)
!        n1*n2*... = c^(D)*V*N = N => c = (1/V)^(1/D)
!      so, const = (N/V)^(1/D)
    cell_N(:) = 1
    if (cell_ndims>0) then
      dim_vol=1.0d0
      do ii=1,3
        if (cell_active_dim(ii)) dim_vol = dim_vol * (cell_dmax(ii)-cell_dmin(ii))
      enddo
      prop_const = (ncoarse/dim_vol)**(1.0d0/cell_ndims)
      do ii=1,3
        if (cell_active_dim(ii)) then
          cell_N(ii) = dnint(prop_const * (cell_dmax(ii)-cell_dmin(ii)))
          cell_N(ii) = min(max(cell_N(ii), 1), ncoarse)
        endif
      enddo
    endif
    
    cell_factor(:) = cell_N(:) / (cell_dmax(:) - cell_dmin(:))
    cell_shift(:) = (cell_dmax(:) - cell_dmin(:)) / (2.0d0*cell_N(:))

#ifdef VERBOSE
    if (peinf%inode==0.and.should_write) then
      write(6,*)
      write(6,'(a,i6,a)') ' Automatically creating a cell structure for ',ncoarse,' points'
      write(6,'(a,i1,a)') '  Found ',cell_ndims,' dimension(s)'
      write(6,'(a,i5,i5,i5)') '  Number of cells:', cell_N(1),cell_N(2),cell_N(3)
      write(6,'(a,i6)') '  Total number of cells:', cell_N(1)*cell_N(2)*cell_N(3)
    endif
#endif
   
    SAFE_ALLOCATE(cell_head, (cell_N(1),cell_N(2),cell_N(3)))
    SAFE_ALLOCATE(cell_list, (ncoarse))

! FHJ: Initialize and populate cells
    cell_head(:,:,:) = 0

#ifdef VERBOSE
    if (peinf%inode==0.and.should_write) then
      write(6,*)
      do ii=1,3
        write(6,801) ii,cell_dmin(ii),cell_dmax(ii),cell_shift(ii)*2.0d0
801     format(' Cells [',i1,'], dmin= ',f8.5,' dmax= ',f8.5,' length= ',f12.5)
      enddo
    endif
#endif

    do idx_co=1,ncoarse
      call get_cell_idx(coarsepts(:,idx_co), cell_idx, periodic)
      cell_list(idx_co) = cell_head(cell_idx(1),cell_idx(2),cell_idx(3))
      cell_head(cell_idx(1),cell_idx(2),cell_idx(3)) = idx_co
    enddo

#ifdef VERBOSE
    if (peinf%inode==0.and.should_write) then
      write(6,*)
      write(6,*) 'Cell Population Analysis'
      write(6,*)
      write(6,900) ' x ',' y ',' z ',' members '
      write(6,900) '---','---','---','---------'
  900 format(2x, 3(a3,1x), a9)
      do j1=1,cell_N(1)
        do j2=1,cell_N(2)
          do j3=1,cell_N(3)
            write(6,'(2x,3(i3,1x))',advance='no') j1,j2,j3      
            idx_co=cell_head(j1,j2,j3)
            do while (idx_co.gt.0)
              write(6,'(1x,i5)',advance='no') idx_co
              idx_co=cell_list(idx_co)
            enddo
            write(6,*)
          enddo
        enddo
      enddo
    endif

    if (peinf%inode==0.and.should_write) write(6,'(/,a)') 'Finished alloc_intpts'
#endif

    POP_SUB(alloc_intpts)

  end subroutine alloc_intpts

  subroutine dealloc_intpts()
    PUSH_SUB(dealloc_intpts)

    SAFE_DEALLOCATE(cell_head)
    SAFE_DEALLOCATE(cell_list)

    POP_SUB(dealloc_intpts)
  end subroutine dealloc_intpts

  !> Returns the cell index for point `pt`.
  subroutine get_cell_idx(pt, cell_idx, periodic)
    real(DP), intent(in) :: pt(3)
    integer, intent(out) :: cell_idx(3)
    logical, intent(in) :: periodic

    ! no push/pop, called too frequently
    cell_idx(:) = idint((pt(:)-cell_dmin(:)+cell_shift(:))*cell_factor(:))
    if (periodic) then
      cell_idx(:) = modulo(cell_idx(:), cell_N(:)) + 1
    else
      cell_idx(:) = min(max(cell_idx(:)+1, 1), cell_N(:))
    endif

  end subroutine get_cell_idx

end module intpts_m

!=============================================================================
!
! Utilities:
!
! (1) wfnmix_spinor        Originally By BAB       Last Modified 5/14/2012 (BAB)
!
!     Based on DWV`s wfnmix_QSGW, this code takes an ordinary wavefunction
!     and mixes it into a spinor that would diagonalize either sigma_z 
!     or sigma_x.
!
!     The purpose is to debug the spinor functionality of BGW.
!
!==============================================================================

#include "f_defs.h"

program wfnmix_spinor

  use blas_m
  use global_m
  use misc_m
  use wfn_rho_vxc_io_m
  implicit none

  type(crystal) :: crys
  type(symmetry) :: syms
  type(kpoints) :: kp,kps
  type(gspace) :: gvec

  character*80  :: infile, outfile, spin_vec
  integer :: nargs,ik,ib,jb,ispin,ispinor,spin_x
  
  complex(DPC) :: z
  
  SCALAR, allocatable :: wfn(:,:,:), wfn_new(:,:,:)

  character*3 :: sheader
  integer :: iflavor
  
  write(6,*) MYFLAVOR // ' version is used to convert file'

!---------------------------------
! Get file names from command-line arguments

  nargs = iargc()
  
  if (nargs .ne. 3) then
    call die('Usage: wfnmix_spinor WFN WFN2 x_or_z')
  endif
  
  call getarg(1,infile)
  call getarg(2,outfile)
  call getarg(3,spin_vec)
  if (spin_vec == 'x' .or. spin_vec == 'X') then
    spin_x = 1
  else if (spin_vec == 'z' .or. spin_vec == 'Z') then
    spin_x = 0
  else
    call die('Type "x" or "X" or "z" or "Z" only')
  endif

! Open units

  call open_file(unit=7,file=TRUNC(infile),form='unformatted',status='old')
  call open_file(unit=8,file=TRUNC(outfile),form='unformatted',status='replace')
  write(6,*) 'Converting file ',TRUNC(infile),' into spinor wavefunction file'

! Read/write data

  sheader = 'WFN'
  iflavor = 0
  call read_binary_header_type(7, sheader, iflavor, kp, gvec, syms, crys, warn = .false.)
  if (iflavor.eq.1) then
    call die('WFN must be type CPLX')
  endif

! Allocating arrays for kps type

  if (kp%nspinor.eq.2) then 
    call die('Input WFN file already has two spinor components')
  endif

  kps%nspinor=2
  kps%nspin=kp%nspin
  if (kps%nspin.ne.1) then
    call die('nspin not equal to unity')
  endif
  kps%mnband=2*kp%mnband
  kps%nvband=2*kp%nvband
  kps%ncband=2*kp%ncband
  kps%nrk=kp%nrk
  kps%kgrid(:)=kp%kgrid(:)
  kps%shift(:)=kp%shift(:)
  kps%ecutwfc=kp%ecutwfc

  SAFE_ALLOCATE( kps%ngk, (kp%nrk))
  kps%ngk(:)=kp%ngk(:)
  kps%ngkmax=kp%ngkmax        

  SAFE_ALLOCATE( kps%ifmin, (kp%nrk, kps%nspinor*kps%nspin))
  SAFE_ALLOCATE( kps%ifmax, (kp%nrk, kps%nspinor*kps%nspin))
  do ispinor=1,kps%nspinor
    kps%ifmin(:,ispinor) = 2*kp%ifmin(:,kp%nspin)-1
    kps%ifmax(:,ispinor) = 2*kp%ifmax(:,kp%nspin)
  enddo

  SAFE_ALLOCATE( kps%w, (kp%nrk))
  kps%w(:)=kp%w(:)

  SAFE_ALLOCATE( kps%rk, (UBOUND(kp%rk,1)-LBOUND(kp%rk,1)+1,kp%nrk))
  kps%rk(:,:)=kp%rk(:,:)

  SAFE_ALLOCATE( kps%el, (kps%mnband, UBOUND(kp%el,2)-LBOUND(kp%el,2)+1, UBOUND(kp%el,3)-LBOUND(kp%el,3)+1))
  do ib=1,kp%mnband
    kps%el(2*ib-1,:,:)=kp%el(ib,:,:)
    kps%el(2*ib,:,:)=kp%el(ib,:,:)
  enddo

  SAFE_ALLOCATE(kps%occ, (kps%mnband, kp%nrk, kps%nspin*kps%nspinor))
  do ispinor=1, kps%nspinor
    do ib=1,kp%mnband
      kps%occ(2*ib-1,:,ispinor)=kp%occ(ib,:,kp%nspinor)
      kps%occ(2*ib,:,ispinor)=kp%occ(ib,:,kp%nspinor)
    enddo
  enddo

  ! Now write new header info
  call write_binary_header_type(8, sheader, iflavor, kps, gvec, syms, crys)

  SAFE_ALLOCATE(gvec%components, (3, gvec%ng))

  call read_binary_gvectors(7, gvec%ng, gvec%ng, gvec%components)
  call write_binary_gvectors(8, gvec%ng, gvec%ng, gvec%components)

! Output info

  write(6,*) ' crystal volume: ',crys%celvol
  write(6,*) ' number of spins: ',kps%nspin
  write(6,*) ' number of spinors: ',kps%nspinor
  write(6,*) ' number of bands in file: ',kps%mnband
  
  SAFE_ALLOCATE(wfn, (kp%ngkmax, kp%mnband, kp%nspin))
  SAFE_ALLOCATE(wfn_new, (kps%ngkmax, kps%mnband, kps%nspin*kps%nspinor))

  do ik = 1, kp%nrk
    call read_binary_gvectors(7, kp%ngk(ik), kp%ngk(ik), gvec%components)
    call write_binary_gvectors(8, kps%ngk(ik), kps%ngk(ik), gvec%components)

    do ib = 1, kp%mnband
      call read_binary_data(7, kp%ngk(ik), kp%ngkmax, kp%nspin, wfn(:,ib,:))
      do ispin = 1, kp%nspin
        call checknorm('old wfn',ib,ik,kp%ngk(ik),ispin,kp%nspinor,wfn(1:kp%ngk(ik),ib,:))
      enddo
    enddo

    !
    ! We construct two-component spinor out of single-component wavefucntions here
    !
    do ib = 1, kps%mnband
      if (spin_x.eq.1) then
        if (mod(ib,2) == 1) then
          wfn_new(:,ib,1) = 1.0D0/SQRT(2.0d0)*wfn(:,ib/2+1,1) 
          wfn_new(:,ib,2) = 1.0D0/SQRT(2.0d0)*wfn(:,ib/2+1,1)
        else 
          wfn_new(:,ib,1) = 1.0D0/SQRT(2.0d0)*wfn(:,ib/2,1) 
          wfn_new(:,ib,2) = -1.0D0/SQRT(2.0d0)*wfn(:,ib/2,1)
        endif 
        call checknorm('new wfn',ib,ik,kps%ngk(ik),1,2,wfn_new(1:kps%ngk(ik),ib,:))
      else
        if (mod(ib,2) == 1) then
          wfn_new(:,ib,1) = wfn(:,ib/2+1,1)
        else 
          wfn_new(:,ib,2) = wfn(:,ib/2,1) 
        endif
        call checknorm('new wfn',ib,ik,kps%ngk(ik),1,2,wfn_new(1:kps%ngk(ik),ib,:))
      endif
    enddo

    do ib=1,kps%mnband
      do jb=1,ib-1
        z = ZERO
        do ispinor=1,kps%nspinor*kps%nspin
          z=z+blas_dot(kp%ngk(ik),(wfn_new(:,ib,ispinor)),1,(wfn_new(:,jb,ispinor)),1)
        enddo
        if (abs(z).gt.TOL_Small) then
          write(6,998) ik,ispinor,ib,jb,z
998       format(1x,"dot_prod error: ik =",i4,1x,"is =",i2,1x,"ib =",i4,1x,"jb =",i4,1x,"prod =",2f12.6)
        endif

      enddo ! jb
    enddo ! ib

    do ib = 1,kps%mnband
      call write_binary_data(8, kps%ngk(ik), kps%ngkmax, kps%nspin*kps%nspinor, wfn_new(1:kps%ngkmax,ib,1:kps%nspin*kps%nspinor))
    enddo ! ib
 
  enddo ! ik

  call close_file(7)
  call close_file(8)

  SAFE_DEALLOCATE_P(gvec%components)
  SAFE_DEALLOCATE_P(kps%ngk)
  SAFE_DEALLOCATE_P(kps%w)
  SAFE_DEALLOCATE_P(kps%rk)
  SAFE_DEALLOCATE_P(kps%ifmin)
  SAFE_DEALLOCATE_P(kps%ifmax)
  SAFE_DEALLOCATE_P(kps%el)
  SAFE_DEALLOCATE_P(kps%occ)

  call dealloc_header_type(sheader, crys, kp)
  call dealloc_header_type(sheader, crys, kps)
  
  write(6,*) 'Done '
  
end program wfnmix_spinor

!==========================================================================
!
! Routines:
!
! 1. subgrp()   Originally By ?                 Last Modified 6/12/2008 (JRD)
!
!    Determines a subgroup of the symmetry group that preserves a q-vector.
!
!===========================================================================

#include "f_defs.h"

subroutine subgrp(qq, syms)
  use global_m
  use misc_m
  implicit none

  type (symmetry), intent(inout) :: syms
  real(DP), intent(in) :: qq(3)

  integer ::  it, kg(3)
  real(DP) :: qk(3), dqk(3)

  PUSH_SUB(subgrp)
  
!---------------------
! Loop over transformations testing for r(q) = q + kg0

  syms%rq = qq
  syms%ntranq = 0
  do it = 1, syms%ntran
    qk(1:3) = matmul(syms%mtrx(1:3, 1:3, it), qq(1:3))
    dqk(1:3) = qk(1:3) - qq(1:3)
    call k_range(dqk(1:3), kg(1:3), TOL_Small)
    
    if (all(abs(dqk(1:3)) .lt. TOL_Small)) then
      !--------------------
      ! Store index of element of subgroup
      syms%ntranq = syms%ntranq + 1
      syms%indsub(syms%ntranq) = it
      syms%kgzero(1:3, syms%ntranq) = -kg(1:3)
    endif
  enddo
  
  POP_SUB(subgrp)
  
  return
end subroutine subgrp

!===============================================================================
!
! Utilities:
!
! (1) epsomega      Originally By gsm      Last Modified 11/18/2010 (gsm)
!
! Parallel code that plots frequency dependence of Plasmon-Pole, Retarded,
! Advanced epsilon for a given q, G, G` vectors. Input parameters are read
! from file epsomega.inp in the working directory.
!
! Note that epsPP constructed with full-frequency epsmat will be
! different from epsPP constructed with static epsmat because of
! finite broadening used in full-frequency epsmat.
!
! FIXME: use WFN_RHO_VXC for reading RHO
!
! FIXME: [2013-01-15 gsm] compact form of GPP model doesn`t work when
! wtilde2 < 0 which is often the case for G .ne. G`; replace with the
! explicit expression from Hybertsen & Louie (see commented out code
! in the GPP section of epsinvomega.f90)
!
!===============================================================================

#include "f_defs.h"

program epsomega

  use global_m
  use input_utils_m
  use inversion_m
  use read_matrix_m
  use scalapack_m
  use epsread_hdf5_m
#ifdef HDF5
  use hdf5
#endif

  implicit none
  
  logical :: sflag
  integer :: i,j,k,iq,mq,ig,igp,jg,jgp,iunit,ierr
  integer :: icurr,icol,irow,icolm,irowm,icols,irows
  integer :: iout,nFFTgridpts,FFTgrid(3)
  real(DP) :: omega
  
  character*256, parameter :: fninp = "epsomega.inp"
  character*256 :: fneps,fnrho,fngpp,fnffr,fnffa
  real(DP) :: q(3)
  integer :: g(3),gp(3)

  character :: infile*80
  
  type(gspace) :: gvec
  integer :: freq_dep,nFreq,ii,nq,ng,nmtx,kgrid(3)
  real(DP) :: dDeltaFreq,dBrdning,ecuts,delta,qvec(3)
  real(DP), allocatable :: qpt(:,:)
  real(DP), allocatable :: ekin(:)
  real(DP), allocatable :: dFreqGrid(:)
  integer, allocatable :: isrtx(:)
  integer, allocatable :: isorti(:)
  integer, allocatable :: nmtx_of_q(:)
  SCALAR, allocatable :: eps(:,:)
  complex(DPC), allocatable :: dFreqBrd(:)
  complex(DPC), allocatable :: epsPP(:,:,:)
  complex(DPC), allocatable :: epsR(:,:,:)
  complex(DPC), allocatable :: epsA(:,:,:)
  complex(DPC), allocatable :: epsAux(:,:)
  SCALAR, allocatable :: rhog(:)  
  real(DP) :: bvec(3,3),bdot(3,3),blat,celvol,reccelvol
  integer :: nvecs,nspin
  
  integer :: nproc_para,num_gvec,gx,gy,gz,qgrid(3),error
  real(DP) :: rho0
  integer, allocatable :: gvec_rho(:,:)
  SCALAR, allocatable :: xcdum(:,:)
  
  real(DP) :: wp2,qg(3),qgp(3),qgqg,qgqgp,lambda,phi
  SCALAR :: Omega2,wtilde2,epsggp,I_epsggp
  complex(DPC) :: wtilde2_temp

  type (scalapack) :: scal

  call peinfo_init()

!-----------------------------
! read input file

  if (peinf%inode.eq.0) then
    write(6,'(/,1x,"reading",1x,a,1x,"file",/)')trim(fninp)
    
    call open_file(55,file=trim(fninp),form='formatted',status='old')
    
    read(55,'(a)') fneps
    read(55,'(a)') fnrho
    read(55,*) (q(i),i=1,3)
    read(55,*) (g(i),i=1,3)
    read(55,*) (gp(i),i=1,3)
    read(55,*) nFreq
    read(55,*) dDeltaFreq
    read(55,*) dBrdning
    read(55,'(a)') fngpp
    read(55,'(a)') fnffr
    read(55,'(a)') fnffa
    
    call close_file(55)

    write(6,'(2a)')         "     eps  file  = ", trim(fneps)
    write(6,'(2a)')         "     rho  file  = ", trim(fnrho)
    write(6,'(a, 3f15.12)') "     q  vector  = ", q(1:3)
    write(6,'(a, 3i4)')     "     G  vector  = ", g(1:3)
    write(6,'(a, 3i4)')     "     G' vector  = ", gp(1:3)
    write(6,'(a, i6)')      "     nFreq      = ", nFreq
    write(6,'(a, f7.3)')    "     dDeltaFreq = ", dDeltaFreq
    write(6,'(a, f7.3)')    "     dBrdning   = ", dBrdning
    write(6,'(2a)')         "     GPP file   = ", trim(fngpp)
    write(6,'(2a)')         "     FFR file   = ", trim(fnffr)
    write(6,'(2a,/)')       "     FFA file   = ", trim(fnffa)
  endif
  
#ifdef MPI
  call MPI_Bcast(fneps,256,MPI_CHARACTER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(fnrho,256,MPI_CHARACTER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(q,3,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(g,3,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(gp,3,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(fngpp,256,MPI_CHARACTER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(fnffr,256,MPI_CHARACTER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(fnffa,256,MPI_CHARACTER,0,MPI_COMM_WORLD,mpierr)
#endif

!-----------------------------
! read eps file

  if (peinf%inode.eq.0) then
    write(6,'(1x,"reading",1x,a,1x,"file",/)')trim(fneps)

#ifdef HDF5

    ! JRD: There is no equivalent on read_matrix_d
    ! yet. So, the beginings of HDF5 support are here.
    ! But, it is not complete
    call die("No Support for HDF5 Yet. epsinvomega routine does support HDF5.")

    call h5open_f(error)

    infile = trim(fneps)

    call read_eps_grid_sizes_hdf5(ng,nq,ecuts,nFreq,nmtx,qgrid,infile)
    ! FB: dirty trick, but it is really unlikely to have a full freq
    ! calculations with only 2 freqs
    select case(nFreq)
    case(1)
      freq_dep = 0
    case(2)
      freq_dep = 3
    case default
      freq_dep = 2
    end select

    SAFE_ALLOCATE(dFreqGrid,(nFreq))
    SAFE_ALLOCATE(dFreqBrd,(nFreq))
    SAFE_ALLOCATE(qpt, (3,nq))
    SAFE_ALLOCATE(nmtx_of_q, (nq))
    SAFE_ALLOCATE(gvec%components, (3,ng))

    call read_eps_qgrid_hdf5(nq,qpt,nmtx_of_q,infile)
    if (freq_dep .ne. 0) then
      call read_eps_freqgrid_hdf5(nFreq,dFreqGrid,dFreqBrd,infile)
    endif

#else
    
    iunit=12
    call open_file(unit=iunit,file=trim(fneps),form='unformatted',status='old')
    
    read(iunit)
    read(iunit) freq_dep,ii
    if (freq_dep.ne.0) then
      nFreq=ii
    endif
    read(iunit) (kgrid(i),i=1,3)
    SAFE_ALLOCATE(dFreqGrid,(nFreq))
    SAFE_ALLOCATE(dFreqBrd,(nFreq))
    if (freq_dep.ne.0) then
      read(iunit) (dFreqGrid(i),i=1,nFreq),(dFreqBrd(i),i=1,nFreq)
      if (nFreq.gt.1) dDeltaFreq=dFreqGrid(2)-dFreqGrid(1)
      dBrdning=IMAG(dFreqBrd(1))
    else
      do i=1,nFreq
        dFreqGrid(i)=dDeltaFreq*dble(i-1)
        dFreqBrd(i)=dBrdning
      enddo
      read(iunit)
    endif
    read(iunit)
    read(iunit)
    read(iunit) ecuts
    read(iunit) nq
    read(iunit) ng
    
    rewind(iunit)
    
    SAFE_ALLOCATE(qpt, (3,nq))
    SAFE_ALLOCATE(gvec%components, (3,ng))
    
    read(iunit)
    read(iunit)
    read(iunit)
    read(iunit)
    read(iunit)
    read(iunit)
    read(iunit)
    read(iunit) nq,((qpt(j,i),j=1,3),i=1,nq)
    read(iunit) ng,((gvec%components(j,i),j=1,3),i=1,ng)

#endif
    
    ig=0
    igp=0
    do i=1,ng
      if (gvec%components(1,i).eq.g(1).and.gvec%components(2,i).eq.g(2).and. &
        gvec%components(3,i).eq.g(3)) ig=i
      if (gvec%components(1,i).eq.gp(1).and.gvec%components(2,i).eq.gp(2).and. &
        gvec%components(3,i).eq.gp(3)) igp=i
    enddo
    
    mq=-1
    do iq=1,nq
      if (abs(q(1)-qpt(1,iq)).lt.TOL_Zero.and. &
        abs(q(2)-qpt(2,iq)).lt.TOL_Zero.and. &
        abs(q(3)-qpt(3,iq)).lt.TOL_Zero) then
        mq=iq-1
        exit
      endif
    enddo
    
    SAFE_DEALLOCATE(qpt)
    
    write(6,'(a,i6)')     "     omega num  = ", nFreq
  endif
  
#ifdef MPI
  call MPI_Bcast(freq_dep,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(nFreq,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(dDeltaFreq,1,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(dBrdning,1,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(mq,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(ig,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(igp,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(ng,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  if (peinf%inode.ne.0) then
    SAFE_ALLOCATE(dFreqGrid,(nFreq))
    SAFE_ALLOCATE(dFreqBrd,(nFreq))
    SAFE_ALLOCATE(gvec%components, (3,ng))
  endif
  call MPI_Bcast(dFreqGrid,nFreq,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(dFreqBrd,nFreq,MPI_COMPLEX_DPC,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(gvec%components,3*ng,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
  
  if (mq.eq.-1) then
    call die("cannot find q vector in file " // trim(fneps))
  endif
  if (ig.eq.0) then
    call die("cannot find G vector in file " // trim(fneps))
  endif
  if (igp.eq.0) then
    call die("cannot find G' vector in file " // trim(fneps))
  endif
  
  if (peinf%inode.eq.0) then

#ifdef HDF5

    SAFE_ALLOCATE(isrtx, (ng))
    SAFE_ALLOCATE(isorti, (ng))
    SAFE_ALLOCATE(ekin, (ng))
    call read_eps_gvecsofq_hdf5(ng,isrtx,isorti,ekin,mq+1,infile)
    nmtx = nmtx_of_q(mq+1)
    SAFE_DEALLOCATE(ekin)
    SAFE_DEALLOCATE(isorti)
    SAFE_DEALLOCATE(nmtx_of_q)

#else

    do iq=1,mq
      read(iunit) ng,nmtx
      read(iunit)
      read(iunit)
      if (freq_dep.eq.0) then
        do j=1,nmtx
          read(iunit)
        enddo
      else
        do j=1,nmtx
          do i=1,nmtx
            read(iunit)
#ifdef CPLX
            if(freq_dep.ne.3) then
              read(iunit)
            endif
#endif
          enddo
        enddo
      endif
    enddo
    
    SAFE_ALLOCATE(isrtx, (ng))
    SAFE_ALLOCATE(isorti, (ng))
    isrtx(:)=0
    isorti(:)=0
    
    read(iunit) ng,nmtx,(isrtx(i),isorti(i),i=1,ng)
    read(iunit)
    read(iunit)
    
    ig=isorti(ig)
    igp=isorti(igp)
    
    SAFE_DEALLOCATE(isorti)

#endif

  endif
  
#ifdef MPI
  call MPI_Bcast(nmtx,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(ig,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(igp,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  if (peinf%inode.ne.0) then
    SAFE_ALLOCATE(isrtx, (ng))
  endif
  call MPI_Bcast(isrtx,ng,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
  
  if (ig.eq.0) then
    call die("cannot find G vector in file " // trim(fneps))
  endif
  if (igp.eq.0) then
    call die("cannot find G' vector in file " // trim(fneps))
  endif
  
  call blacs_setup(scal, nmtx, .true.)

!-----------------------------
! read distributed matrices

  SAFE_ALLOCATE(eps, (scal%npr,scal%npc))
  SAFE_ALLOCATE(epsPP, (nFreq,scal%npr,scal%npc))
  if (freq_dep.ne.0) then
    SAFE_ALLOCATE(epsR, (nFreq,scal%npr,scal%npc))
    SAFE_ALLOCATE(epsA, (nFreq,scal%npr,scal%npc))
  endif
  SAFE_ALLOCATE(epsAux, (scal%npr,scal%npc))
  
  if (freq_dep.eq.0) then
    call read_matrix_d(scal,eps,nmtx,iunit)
  else
    peinf%rank_mtxel=0
    call read_matrix_f(scal,nFreq,nFreq,epsR,epsA,nmtx,1,iunit)
#ifndef CPLX
    do icolm=1,scal%npc
      do irowm=1,scal%npr
        do i=1,nFreq
          epsA(i,irowm,icolm)=CONJG(epsR(i,irowm,icolm))
        enddo
      enddo
    enddo
#else
    if (freq_dep.eq.3) then
      do icolm=1,scal%npc
        do irowm=1,scal%npr
          do i=1,nFreq
            epsA(i,irowm,icolm)=CONJG(epsR(i,irowm,icolm))
          enddo
        enddo
      enddo
    endif
#endif
    do icolm=1,scal%npc
      do irowm=1,scal%npr
#ifdef CPLX
        eps(irowm,icolm)=epsR(1,irowm,icolm)
#else
        eps(irowm,icolm)=dble(epsR(1,irowm,icolm))
#endif
      enddo
    enddo
  endif
  
  if (peinf%inode.eq.0) then
    call close_file(iunit)
  endif
  
  if (peinf%inode.eq.0) then
    write(6,'(a,i6)')     "     omega num  = ", nFreq
    write(6,'(a,f7.3)')   "     omega step = ", dDeltaFreq
    write(6,'(a,f7.3,/)') "     omega brd  = ", dBrdning
  endif

!-----------------------------
! read rho file

  SAFE_ALLOCATE(rhog, (ng))
  rhog(:)=ZERO
  
  if (peinf%inode.eq.0) then
    write(6,'(1x,"reading",1x,a,1x,"file",/)')trim(fnrho)
    
    iunit=95
    call open_file(unit=iunit,file=trim(fnrho),form='unformatted',status='old')
    
    rho0=0.0d0

    read(iunit)
    read(iunit) nspin,nvecs
    read(iunit) (FFTgrid(i),i=1,3)
  endif
! (gsm) this is ugly but the only way I see to quickly fix the mess
! with gvec structure and gvec_index subroutine
#ifdef MPI
  call MPI_Bcast(FFTgrid,3,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
  gvec%ng=ng
  gvec%FFTgrid=FFTgrid
  call gvec_index(gvec)
  nFFTgridpts=gvec%nFFTgridpts
  if (peinf%inode.eq.0) then
    read(iunit) celvol
    read(iunit) reccelvol, blat, ((bvec(i,j),i=1,3),j=1,3), ((bdot(i,j),i=1,3),j=1,3)
    read(iunit)
    read(iunit)
    read(iunit)
    SAFE_ALLOCATE(gvec_rho, (3, nvecs))
    SAFE_ALLOCATE(xcdum, (nvecs, nspin))
    read(iunit) nproc_para
    jg = 1
    do i=1,nproc_para
      read(iunit) num_gvec
      read(iunit) ((gvec_rho(k, j), k = 1, 3), j = jg, jg + num_gvec - 1)
      jg = jg + num_gvec
    enddo
    read(iunit) nproc_para
    jg = 1
    do i=1,nproc_para
      read(iunit) num_gvec
      read(iunit) ((xcdum(j, k), j = jg, jg + num_gvec - 1), k = 1, nspin)
      jg = jg + num_gvec
    enddo
    ierr=0
    do j=1,nvecs
      if (gvec_rho(1,j).eq.0.and.gvec_rho(2,j).eq.0.and.gvec_rho(3,j).eq.0) then
        do k=1,nspin
          rho0=rho0+dble(xcdum(j,k))
        enddo
      endif
      iout=((gvec_rho(1,j)+FFTgrid(1)/2)*FFTgrid(2)+gvec_rho(2,j)+FFTgrid(2)/2)* &
        FFTgrid(3)+gvec_rho(3,j)+FFTgrid(3)/2+1
      if (iout.ge.1.and.iout.le.nFFTgridpts) then
        iout=gvec%index_vec(iout)
        if (iout.ge.1.and.iout.le.ng) then
          rhog(iout)=ZERO
          do k=1,nspin
            rhog(iout)=rhog(iout) + xcdum(j,k)
          enddo
        else
          ierr=1
        endif
      else
        ierr=1
      endif
    enddo
    SAFE_DEALLOCATE(gvec_rho)
    SAFE_DEALLOCATE(xcdum)

    call close_file(iunit)
    
    write(6,'(5x,"cel vol =",e20.12)') celvol
    write(6,'(5x,"rho(0) =",f10.3,/)') rho0
  endif
  
#ifdef MPI
  call MPI_Bcast(bdot,9,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(celvol,1,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(FFTgrid,3,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(ierr,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(rho0,1,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(rhog,ng,MPI_SCALAR,0,MPI_COMM_WORLD,mpierr)
#endif
  
  if (ierr.ne.0) then
    call die("unknown G vector in file " // trim(fnrho))
  endif
  if (abs(rho0).le.TOL_Zero) then
    call die("cannot find rho(0) in file " // trim(fnrho))
  endif

!-----------------------------
! construct generalized plasmon pole model

  if (peinf%inode.eq.0) then
    write(6,'(1x,"constructing GPP model",/)')
  endif
  
  epsPP(:,:,:)=(0.0d0,0.0d0)
  wp2=ryd*ryd*16.0d0*PI_D*rho0/celvol
  sflag=.false.
  irows=0
  icols=0
  icurr=0
  do jgp=1,nmtx
    icol=mod(int(((jgp-1)/scal%nbl)+TOL_Small),scal%npcol)
    do jg=1,nmtx
      irow=mod(int(((jg-1)/scal%nbl)+TOL_Small),scal%nprow)
      if (irow.eq.scal%myprow.and.icol.eq.scal%mypcol) then
        icurr=icurr+1
        icolm=int((icurr-1)/scal%npr+TOL_Small)+1
        irowm=mod((icurr-1),scal%npr)+1
        if (jg.eq.ig.and.jgp.eq.igp) then
          sflag=.true.
          irows=irowm
          icols=icolm
        endif
        qg(:)=q(:)+dble(gvec%components(:,isrtx(jg)))
        qgp(:)=q(:)+dble(gvec%components(:,isrtx(jgp)))
        qgqg=dot_product(qg,matmul(bdot,qg))
        qgqgp=dot_product(qg,matmul(bdot,qgp))
        if (abs(qgqg).lt.TOL_Zero) cycle
        gx=gvec%components(1,isrtx(jg))-gvec%components(1,isrtx(jgp))
        gy=gvec%components(2,isrtx(jg))-gvec%components(2,isrtx(jgp))
        gz=gvec%components(3,isrtx(jg))-gvec%components(3,isrtx(jgp))
        iout=((gx+FFTgrid(1)/2)*FFTgrid(2)+gy+FFTgrid(2)/2)* &
          FFTgrid(3)+gz+FFTgrid(3)/2+1
        if (iout.lt.1.or.iout.gt.nFFTgridpts) cycle
        iout=gvec%index_vec(iout)
        if (iout.lt.1.or.iout.gt.ng) cycle
        Omega2=wp2*qgqgp/qgqg*rhog(iout)/rho0
        epsggp=eps(irowm,icolm)
        if (jg.eq.jgp) then
          delta=1.0d0
        else
          delta=0.0d0
        endif
        I_epsggp=delta-epsggp
        if (abs(I_epsggp).lt.TOL_Small) cycle
#ifdef CPLX
! Complex GPP [PRB 40, 3162 (1989)]
        wtilde2_temp = Omega2 / I_epsggp
        lambda = abs(wtilde2_temp)
        if (lambda .lt. TOL_Small) cycle
        phi = atan2(IMAG(wtilde2_temp), dble(wtilde2_temp))
        if (abs(cos(phi)) .lt. TOL_Small) cycle
        wtilde2 = lambda / cos(phi)
        Omega2 = Omega2 * CMPLX(1.0d0, -tan(phi))
#else
! Real GPP [PRB 34, 5390 (1986)]
        wtilde2 = Omega2 / I_epsggp
        if (abs(wtilde2) .lt. TOL_Small) cycle
#endif
        do i=1,nFreq
          omega=dFreqGrid(i)
          epsPP(i,irowm,icolm)=delta+Omega2/(omega**2-wtilde2-CMPLX(0D0,dBrdning))
        enddo
      endif
    enddo
  enddo
  
  if (peinf%inode.eq.0) then
    write(6,'(5x,"plasma frequency =",f10.3," eV",/)') sqrt(wp2)
  endif

!-----------------------------
! invert matrices
  
  if (peinf%inode.eq.0) then
    write(6,'(1x,"inverting matrices",/)')
  endif

#if defined USESCALAPACK
  do i=1,nFreq
    epsAux(:,:) = epsPP(i,:,:)
    call zinvert_with_scalapack(nmtx, scal, epsAux)
    epsPP(i,:,:) = epsAux(:,:)
  enddo
  if(freq_dep .ne. 0) then
    do i=1,nFreq
      epsAux(:,:) = epsR(i,:,:)
      call zinvert_with_scalapack(nmtx, scal, epsAux)
      epsR(i,:,:) = epsAux(:,:)
      epsAux(:,:) = epsA(i,:,:)
      call zinvert_with_scalapack(nmtx, scal, epsAux)
      epsA(i,:,:) = epsAux(:,:)
    enddo
  endif
#else
  do i=1,nFreq
    epsAux(:,:) = epsPP(i,:,:)
    call zinvert_serial(nmtx, epsAux)
    epsPP(i,:,:) = epsAux(:,:)
  enddo
  if(freq_dep .ne. 0) then
    do i=1,nFreq
      epsAux(:,:) = epsR(i,:,:)
      call zinvert_serial(nmtx, epsAux)
      epsR(i,:,:) = epsAux(:,:)
      epsAux(:,:) = epsA(i,:,:)
      call zinvert_serial(nmtx, epsAux)
      epsA(i,:,:) = epsAux(:,:)
    enddo
  endif
#endif

!-----------------------------
! write generalized plasmon pole file

  if (sflag) then
    write(6,'(1x,"writing",1x,a,1x,"file",/)')trim(fngpp)
    
    call open_file(unit=7,file=trim(fngpp),form='formatted',status='replace')
    
    do i=1,nFreq
      omega=dFreqGrid(i)
      write(7,100)omega,epsPP(i,irows,icols)
    enddo
    
    call close_file(7)
  endif

!-----------------------------
! write full frequency files

  if (sflag) then
    if (freq_dep.ne.0) then
      write(6,'(1x,"writing",1x,a,1x,"and",1x,a,1x,"files",/)') &
        trim(fnffr),trim(fnffa)
      
      call open_file(unit=8,file=trim(fnffr),form='formatted',status='replace')
      call open_file(unit=9,file=trim(fnffa),form='formatted',status='replace')
      
      do i=1,nFreq
        omega=dFreqGrid(i)
        write(8,100)omega,epsR(i,irows,icols)
        write(9,100)omega,epsA(i,irows,icols)
      enddo
      
      call close_file(8)
      call close_file(9)
    endif
  endif

!-----------------------------
! deallocate and finish
  
  SAFE_DEALLOCATE_P(gvec%components)
  SAFE_DEALLOCATE(isrtx)
  SAFE_DEALLOCATE_P(gvec%index_vec)
  SAFE_DEALLOCATE(eps)
  SAFE_DEALLOCATE(epsPP)
  SAFE_DEALLOCATE(dFreqGrid)
  SAFE_DEALLOCATE(dFreqBrd)
  if (freq_dep.ne.0) then
    SAFE_DEALLOCATE(epsR)
    SAFE_DEALLOCATE(epsA)
  endif
  SAFE_DEALLOCATE(epsAux)
  SAFE_DEALLOCATE(rhog)
  
#ifdef MPI
  call MPI_Finalize(mpierr)
#endif
  
100 format(3f25.15)
  
end program epsomega

!=================================================================================
!
! Module write_matrix_m
!
! (1) write_matrix_d()          Originally by JRD       Last Modified 5/1/2008 (JRD)
!
! This program writes a distributed matrix like chimat or epsmat to file.
!
! (2) write_matrix_f()          Originally by JRD       Last Modified 2/5/2009 (CHP)
!
! Modification of write_matrix_d for full-frequency.
!
!=================================================================================

#include "f_defs.h"

module write_matrix_m

  use global_m
#ifdef HDF5
  use hdf5
#endif
  use scalapack_m
  use io_utils_m

  implicit none

  private

  public :: &
    write_matrix_d, &
    write_matrix_f
#ifdef HDF5
  public :: &
    write_matrix_ser_hdf, &
    write_matrix_f_ser_hdf, &
    write_matrix_d_hdf, &
    write_matrix_f_hdf, &
    write_matrix_diagonal_hdf, &
    write_gvec_indices_hdf
#ifdef USESCALAPACK
  public :: &
    write_matrix_d_par_hdf, &
    write_matrix_f_par_hdf
#endif
#endif

contains

!===================================================================================

subroutine write_matrix_d(scal,matrix,nmtx,iunit)
  type(scalapack), intent(in) :: scal
  SCALAR, intent(in) :: matrix(:,:) !< (scal%npr,scal%npc)
  integer, intent(in) :: nmtx
  integer, intent(in) :: iunit
  
  integer :: ii, jj
#ifdef USESCALAPACK
  SCALAR, allocatable :: tempcol(:),tempcol2(:)
  integer :: irow, icol, irowm, icolm
  integer :: icurr
#endif
  type(progress_info) :: prog_info !< a user-friendly progress report

  PUSH_SUB(write_matrix_d)

#ifdef VERBOSE
  if(peinf%inode .eq. 0) then
    write(6,*) ' Writing matrix: ', nmtx, iunit
    write(6,*) ' '
  endif
#endif

#ifdef USESCALAPACK
  SAFE_ALLOCATE(tempcol, (nmtx))
  SAFE_ALLOCATE(tempcol2, (nmtx))
  
  icurr=0
  
  call progress_init(prog_info, 'writing matrix', 'column', nmtx)
  do jj = 1, nmtx
    call progress_step(prog_info, jj)
!        if (peinf%inode .eq. 0) then
!          write(6,*) ' In loop: ', ii
!        endif
    icol=MOD(INT(((jj-1)/scal%nbl)+TOL_SMALL),scal%npcol)
    tempcol=0d0
    if (icol .eq. scal%mypcol) then
      do ii = 1, nmtx
        irow=MOD(INT(((ii-1)/scal%nbl)+TOL_SMALL),scal%nprow)
        if (irow .eq. scal%myprow) then
          icurr=icurr+1
          icolm=INT((icurr-1)/scal%npr+TOL_SMALL)+1
          irowm=MOD((icurr-1),scal%npr)+1
          tempcol(ii)=matrix(irowm,icolm)
          
!                if (icolm .gt. scal%npc .or. irowm.gt.scal%npr) then
!                  write(6,*) 'Error: ', scal%npc,scal%npr,icolm,irowm
!                endif

        endif
      enddo
    endif
    if (peinf%inode .eq. 0) then
      tempcol2=0d0
    endif
    call MPI_REDUCE(tempcol,tempcol2,nmtx,MPI_SCALAR,MPI_SUM,0, &
      MPI_COMM_WORLD,mpierr)
    if (peinf%inode .eq. 0) then
      write(iunit) (tempcol2(ii),ii=1,nmtx)
    endif
    
    call MPI_barrier(MPI_COMM_WORLD,mpierr)
    
  enddo
  call progress_free(prog_info)
  
  SAFE_DEALLOCATE(tempcol)
  SAFE_DEALLOCATE(tempcol2)

!      if(peinf%inode .eq. 0) then
!        write(6,*) ' Done Writing chimat: '
!      endif

#else

  if (peinf%inode .eq. 0) then
    call progress_init(prog_info, 'writing matrix', 'column', nmtx)
    do jj = 1, nmtx
      call progress_step(prog_info, jj)
      write(iunit) (matrix(ii, jj), ii = 1, nmtx)
    enddo
    call progress_free(prog_info)
  endif
  
#endif
  
  POP_SUB(write_matrix_d)
  
  return
end subroutine write_matrix_d

!=================================================================================

subroutine write_matrix_f(scal,nfreq,retarded,ONLYIFCPLX(advanced)nmtx,iunit,para_freqs)
  type(scalapack), intent(in) :: scal
  integer, intent(in) :: nfreq
  complex(DPC), intent(in) :: retarded(:,:,:) !< (nfreq_para,scal%npr,scal%npc)
#ifdef CPLX
  complex(DPC), intent(in) :: advanced(:,:,:) !< (nfreq_para,scal%npr,scal%npc)
#endif
  integer, intent(in) :: nmtx
  integer, intent(in) :: iunit
  integer, intent(in) :: para_freqs
  
  integer :: ii, jj, ifreq
#ifdef USESCALAPACK
  complex(DPC), allocatable :: tempcolR(:,:),tempcolR2(:,:)
  complex(DPC), allocatable :: tempcolA(:,:),tempcolA2(:,:)
  integer :: irow, icol, irowm, icolm,freq_grp_ind,ifreq_para
  integer :: icurr
#endif
  type(progress_info) :: prog_info !< a user-friendly progress report

  PUSH_SUB(write_matrix_f)
  
#ifdef VERBOSE
  if(peinf%inode .eq. 0) then
    write(6,*) ' Writing matrix: ', nfreq, nmtx, iunit
    write(6,*) ' '
  endif
#endif
  
#ifdef USESCALAPACK
  
  SAFE_ALLOCATE(tempcolR, (nfreq,nmtx))
  SAFE_ALLOCATE(tempcolR2, (nfreq,nmtx))
#ifdef CPLX
  SAFE_ALLOCATE(tempcolA, (nfreq,nmtx))
  SAFE_ALLOCATE(tempcolA2, (nfreq,nmtx))
#endif

  icurr=0
  
  call progress_init(prog_info, 'writing matrix', 'column', nmtx)
  do jj = 1, nmtx
    call progress_step(prog_info, jj)
!        if (peinf%inode .eq. 0) then
!          write(6,*) ' In loop: ', ii
!        endif
    icol=MOD(INT(((jj-1)/scal%nbl)+TOL_SMALL),scal%npcol)
    tempcolR=0d0
#ifdef CPLX
    tempcolA=0d0
#endif
    if (icol .eq. scal%mypcol) then
      do ii = 1, nmtx
        irow=MOD(INT(((ii-1)/scal%nbl)+TOL_SMALL),scal%nprow)
        if (irow .eq. scal%myprow) then
          icurr=icurr+1
          icolm=INT((icurr-1)/scal%npr+TOL_SMALL)+1
          irowm=MOD((icurr-1),scal%npr)+1
          do ifreq=1,nfreq
            freq_grp_ind=mod(ifreq-1,para_freqs)
            ifreq_para=(ifreq+para_freqs-1)/para_freqs
            if(freq_grp_ind .eq. peinf%rank_mtxel) then
              tempcolR(ifreq,ii)=retarded(ifreq_para,irowm,icolm)
#ifdef CPLX
              tempcolA(ifreq,ii)=advanced(ifreq_para,irowm,icolm)
#endif
            endif
          enddo
        endif
      enddo
    endif
    if (peinf%inode .eq. 0) then
      tempcolR2=0d0
#ifdef CPLX
      tempcolA2=0d0
#endif
    endif
    call MPI_REDUCE(tempcolR(1,1),tempcolR2(1,1),nfreq*nmtx, &
      MPI_COMPLEX_DPC,MPI_SUM,0,MPI_COMM_WORLD,mpierr)
#ifdef CPLX
    call MPI_REDUCE(tempcolA(1,1),tempcolA2(1,1),nfreq*nmtx, &
      MPI_COMPLEX_DPC,MPI_SUM,0,MPI_COMM_WORLD,mpierr)
#endif
    if (peinf%inode .eq. 0) then
      do ii = 1, nmtx
        write(iunit) (tempcolR2(ifreq,ii),ifreq=1,nfreq)
      enddo
#ifdef CPLX
      do ii = 1, nmtx
        write(iunit) (tempcolA2(ifreq,ii),ifreq=1,nfreq)
      enddo
#endif
    endif
    
    call MPI_barrier(MPI_COMM_WORLD,mpierr)
    
  enddo
  call progress_free(prog_info)
  
  SAFE_DEALLOCATE(tempcolR)
  SAFE_DEALLOCATE(tempcolR2)
#ifdef CPLX
  SAFE_DEALLOCATE(tempcolA)
  SAFE_DEALLOCATE(tempcolA2)
#endif

#else

  if(peinf%inode .eq. 0) then
    call progress_init(prog_info, 'writing matrix', 'column', nmtx)
    do jj = 1, nmtx
      call progress_step(prog_info, jj)
      do ii = 1, nmtx
        write(iunit) (retarded(ifreq, ii, jj), ifreq= 1, nfreq)
      enddo
#ifdef CPLX
      do ii = 1, nmtx
        write(iunit) (advanced(ifreq, ii, jj),ifreq = 1, nfreq)
      enddo
#endif
    enddo
    call progress_free(prog_info)
  endif
  
#endif
  
  POP_SUB(write_matrix_f)
  
  return
end subroutine write_matrix_f

#ifdef HDF5

!========================================================================
! JRD: The HDF5 Equivalents of the above routines.
!========================================================================

!==========================================================================================

subroutine write_matrix_diagonal_hdf(epsdiag,nmtx,iq,isize,name)
  real(DP), intent(in) :: epsdiag(:,:,:) !< (isize,nmtx,1)
  integer, intent(in) :: nmtx
  integer, intent(in) :: iq
  integer, intent(in) :: isize
  character(len=*), intent(in) :: name

  integer(HID_T) :: file_id       ! File identifier
  integer(HID_T) :: dset_id       ! Dataset identifier
  integer(HID_T) :: filespace     ! Dataspace identifier in file
  integer(HID_T) :: memspace      ! Dataspace identifier in mem

  integer(HSIZE_T) :: dims(3), offset(3), offsetm(3)

  integer :: error, rank

  PUSH_SUB(write_matrix_diagonal_hdf)

  call h5fopen_f(trim(name), H5F_ACC_RDWR_F, file_id, error)

! Write Array

  rank = 3
  dims(1) = isize
  dims(2) = nmtx
  dims(3) = 1
  offset(1) = 0
  offset(2) = 0
  offset(3) = iq - 1
  offsetm(:) = 0

  call h5dopen_f(file_id, 'matrix-diagonal', dset_id, error)
  call h5screate_simple_f(rank, dims, memspace, error)
  call h5dget_space_f(dset_id,filespace,error)
  call h5sselect_hyperslab_f(memspace, H5S_SELECT_SET_F, offsetm, dims, error)
  call h5sselect_hyperslab_f(filespace, H5S_SELECT_SET_F, offset, dims, error)
  call h5dwrite_f(dset_id, H5T_NATIVE_DOUBLE, epsdiag, dims, error, memspace, filespace)
  call h5dclose_f(dset_id, error)
  call h5sclose_f(memspace, error)
  call h5sclose_f(filespace, error)

  call h5fclose_f(file_id, error)

  POP_SUB(write_matrix_diagonal_hdf)

end subroutine write_matrix_diagonal_hdf

!===================================================================================

subroutine write_matrix_ser_hdf(matrix,nmtx,iq,is,name)
  SCALAR, intent(in) :: matrix(:,:) !< (nmtx,nmtx)
  integer, intent(in) :: nmtx
  integer, intent(in) :: iq
  integer, intent(in) :: is
  character(len=*), intent(in) :: name

  integer :: error, rank, ii, jj

  integer(HID_T) :: file_id       ! File identifier
  integer(HID_T) :: dset_id       ! Dataset identifier
  integer(HID_T) :: filespace     ! Dataspace identifier in file
  integer(HID_T) :: memspace      ! Dataspace identifier in mem

  integer(HSIZE_T) :: count(6), offset(6), offsetm(6)

  real(DP), allocatable :: data(:,:,:,:,:,:)

  PUSH_SUB(write_matrix_ser_hdf)

  call h5fopen_f(trim(name), H5F_ACC_RDWR_F, file_id, error)

  rank=6
  count(1) = SCALARSIZE
  count(2) = 1
  count(3) = nmtx
  count(4) = nmtx
  count(5) = 1
  count(6) = 1

  offset(:) = 0
  offset(5) = is - 1
  offset(6) = iq - 1

  offsetm(:) = 0

  SAFE_ALLOCATE(data,(count(1),count(2),count(3),count(4),count(5),count(6)))

  do jj = 1, nmtx
  do ii = 1, nmtx
    data(1,1,ii,jj,1,1) = dble(matrix(ii,jj))
#ifdef CPLX
    data(2,1,ii,jj,1,1) = IMAG(matrix(ii,jj))
#endif
  enddo
  enddo

  call h5dopen_f(file_id, 'matrix', dset_id, error)
  call h5screate_simple_f(rank, count, memspace, error)
  call h5dget_space_f(dset_id,filespace,error)
  call h5sselect_hyperslab_f(memspace, H5S_SELECT_SET_F, offsetm, count, error)
  call h5sselect_hyperslab_f(filespace, H5S_SELECT_SET_F, offset, count, error)
  call h5dwrite_f(dset_id, H5T_NATIVE_DOUBLE, data, count, error, memspace, filespace)

  SAFE_DEALLOCATE(data)

  call h5dclose_f(dset_id, error)
  call h5sclose_f(memspace, error)
  call h5sclose_f(filespace, error)

  call h5fclose_f(file_id, error)

  POP_SUB(write_matrix_ser_hdf)

end subroutine write_matrix_ser_hdf

!========================================================================

subroutine write_matrix_f_ser_hdf(nfreq,retarded,ONLYIFCPLX(advanced)nmtx,iq,is,name)
  integer, intent(in) :: nfreq
  complex(DPC), intent(in) :: retarded(:,:,:) !< (nfreq,nmtx,nmtx)
#ifdef CPLX
  complex(DPC), intent(in) :: advanced(:,:,:) !< (nfreq,nmtx,nmtx)
#endif
  integer, intent(in) :: nmtx
  integer, intent(in) :: iq
  integer, intent(in) :: is
  character(len=*), intent(in) :: name

  integer :: ii, jj, error, rank
  real(DP), allocatable :: data(:,:,:,:,:,:)
  type(progress_info) :: prog_info !< a user-friendly progress report

  integer(HID_T) :: file_id       ! File identifier
  integer(HID_T) :: dset_id       ! Dataset identifier
  integer(HID_T) :: filespace     ! Dataspace identifier in file
  integer(HID_T) :: memspace      ! Dataspace identifier in mem

  integer(HSIZE_T) :: count(6), offset(6), offsetm(6)

  PUSH_SUB(write_matrix_f_ser_hdf)

! DVF: this routine was built off of write_matrix_f_hdf to do the serial
! writing of an hdf format matrix. This is needed for epsmat_old2hdf5.f90

  rank=6
  count(1) = 2
  count(2) = nfreq
  count(3) = nmtx
  count(4) = 1
  count(5) = SCALARSIZE
  count(6) = 1

  SAFE_ALLOCATE(data, (count(1),count(2),count(3),count(4),count(5),count(6)))
  call h5fopen_f(trim(name), H5F_ACC_RDWR_F, file_id, error)
  call h5dopen_f(file_id, 'matrix', dset_id, error)
  call h5screate_simple_f(rank, count, memspace, error)
  call h5dget_space_f(dset_id,filespace,error)

  call progress_init(prog_info, 'writing matrix', 'column', nmtx)
  do jj = 1, nmtx
    call progress_step(prog_info, jj)
    do ii = 1, nmtx
      data(1,:,ii,1,1,1)=dble(retarded(:,ii,jj))
      data(2,:,ii,1,1,1)=IMAG(retarded(:,ii,jj))
#ifdef CPLX
      data(1,:,ii,1,2,1)=dble(advanced(:,ii,jj))
      data(2,:,ii,1,2,1)=IMAG(advanced(:,ii,jj))
#endif
    enddo

    offsetm(:) = 0
    call h5sselect_hyperslab_f(memspace, H5S_SELECT_SET_F, offsetm, count, error)

    offset(1)=0
    offset(2)=0
    offset(3)=0
    offset(4)=jj-1
    offset(5)=SCALARSIZE*(is-1)
    offset(6)=iq-1

    call h5sselect_hyperslab_f(filespace, H5S_SELECT_SET_F, offset, count, error)
    call h5dwrite_f(dset_id, H5T_NATIVE_DOUBLE, data, count, error, memspace, filespace)
  enddo
  call progress_free(prog_info)

  SAFE_DEALLOCATE(data)
  call h5dclose_f(dset_id, error)
  call h5sclose_f(memspace, error)
  call h5sclose_f(filespace, error)
  call h5fclose_f(file_id, error)

  POP_SUB(write_matrix_f_ser_hdf)
  
  return

end subroutine write_matrix_f_ser_hdf

!========================================================================

subroutine write_matrix_d_hdf(scal,matrix,nmtx,iq,is,name)
  type(scalapack), intent(in) :: scal
  SCALAR, intent(in) :: matrix(:,:) !< (scal%npr,scal%npc)
  integer, intent(in) :: nmtx
  integer, intent(in) :: iq
  integer, intent(in) :: is
  character(len=*), intent(in) :: name
  
  integer :: ii, jj, error, size, rank
#ifdef USESCALAPACK
  real(DP), allocatable :: datatmp(:,:,:,:,:,:)
  integer :: irow, icol, irowm, icolm
  integer :: icurr
#endif
  real(DP), allocatable :: data(:,:,:,:,:,:)
  type(progress_info) :: prog_info !< a user-friendly progress report

  integer(HID_T) :: file_id       ! File identifier
  integer(HID_T) :: dset_id       ! Dataset identifier
  integer(HID_T) :: filespace     ! Dataspace identifier in file
  integer(HID_T) :: memspace      ! Dataspace identifier in mem
#ifdef USESCALAPACK
!  integer(HID_T) :: plist_id      ! Property list identifier for parallel IO
!                                 ! Not used yet...
#endif

  integer(HSIZE_T) :: count(6), offset(6), offsetm(6)

  PUSH_SUB(write_matrix_d_hdf)

#ifdef VERBOSE
  if(peinf%inode .eq. 0) then
    write(6,*) ' Writing matrix: ', nmtx
    write(6,*) ' '
  endif
#endif

! XXX: For now, we will still have only proc 0 write...
! We should changes this to parallel writes. But doing
! this effectively from the scalapack, block cyclic layout
! seems a bit tricky. So, ignoring for now...

  rank=6
  count(1) = SCALARSIZE
  count(2) = 1
  count(3) = nmtx
  count(4) = 1
  count(5) = 1
  count(6) = 1

  if (peinf%inode .eq. 0) then
    SAFE_ALLOCATE(data,(count(1),count(2),count(3),count(4),count(5),count(6)))
    call h5fopen_f(trim(name), H5F_ACC_RDWR_F, file_id, error)
    call h5dopen_f(file_id, 'matrix', dset_id, error)
    call h5screate_simple_f(rank, count, memspace, error)
    call h5dget_space_f(dset_id,filespace,error)
  endif

#ifdef USESCALAPACK
  SAFE_ALLOCATE(datatmp, (count(1),count(2),count(3),count(4),count(5),count(6)))
  icurr=0  
#endif  

  call progress_init(prog_info, 'writing matrix', 'column', nmtx)
  do jj = 1, nmtx

    call progress_step(prog_info, jj)
#ifdef USESCALAPACK

    if(peinf%inode.eq.0) call timacc(47,1)

    icol=MOD(INT(((jj-1)/scal%nbl)+TOL_SMALL),scal%npcol)
    datatmp=0d0
    if (icol .eq. scal%mypcol) then
      do ii = 1, nmtx
        irow=MOD(INT(((ii-1)/scal%nbl)+TOL_SMALL),scal%nprow)
        if (irow .eq. scal%myprow) then
          icurr=icurr+1
          icolm=INT((icurr-1)/scal%npr+TOL_SMALL)+1
          irowm=MOD((icurr-1),scal%npr)+1
          datatmp(1,1,ii,1,1,1)=dble(matrix(irowm,icolm))
#ifdef CPLX
          datatmp(2,1,ii,1,1,1)=IMAG(matrix(irowm,icolm))
#endif
        endif
      enddo
    endif
    if (peinf%inode .eq. 0) then
      data=0d0
    endif

! XXX This is a big waste of communication. Should be fixed when do
! parallel IO.

    size = nmtx * SCALARSIZE

    call MPI_REDUCE(datatmp,data,size,MPI_DOUBLE_PRECISION,MPI_SUM,0, &
      MPI_COMM_WORLD,mpierr)

    if(peinf%inode.eq.0) call timacc(47,2)

#else

    if (peinf%inode .eq. 0) then
      do ii = 1, nmtx
        data(1,1,ii,1,1,1) = dble(matrix(ii,jj))
#ifdef CPLX
        data(2,1,ii,1,1,1) = IMAG(matrix(ii,jj))
#endif
      enddo
    endif

#endif

    if(peinf%inode.eq.0) call timacc(48,1)

    if (peinf%inode .eq. 0) then

      offsetm(:) = 0
      call h5sselect_hyperslab_f(memspace, H5S_SELECT_SET_F, offsetm, count, error)

      offset(1)=0
      offset(2)=0
      offset(3)=0
      offset(4)=jj-1
      offset(5)=is-1
      offset(6)=iq-1

      call h5sselect_hyperslab_f(filespace, H5S_SELECT_SET_F, offset, count, error)

      call h5dwrite_f(dset_id, H5T_NATIVE_DOUBLE, data, count, error, memspace, filespace)

    endif

    if(peinf%inode.eq.0) call timacc(48,2)

#ifdef USESCALAPACK
    call MPI_barrier(MPI_COMM_WORLD,mpierr)
#endif    

  enddo
  call progress_free(prog_info)

#ifdef USESCALAPACK
  SAFE_DEALLOCATE(datatmp)
#endif  

  if (peinf%inode .eq. 0) then
    SAFE_DEALLOCATE(data)
    call h5dclose_f(dset_id, error)
    call h5sclose_f(memspace, error)
    call h5sclose_f(filespace, error)
    call h5fclose_f(file_id, error)
  endif

  POP_SUB(write_matrix_d_hdf)
  
  return
end subroutine write_matrix_d_hdf

!========================================================================

#ifdef USESCALAPACK

subroutine write_matrix_d_par_hdf(scal,matrix,nmtx,iq,is,name)
  type(scalapack), intent(in) :: scal
  SCALAR, intent(in) :: matrix(:,:) !< (scal%npr,scal%npc)
  integer, intent(in) :: nmtx
  integer, intent(in) :: iq
  integer, intent(in) :: is
  character(len=*), intent(in) :: name
  
  integer :: ii, jj, error, rank
  real(DP), allocatable :: data(:,:,:,:,:,:)

  integer(HID_T) :: file_id       ! File identifier
  integer(HID_T) :: dset_id       ! Dataset identifier
  integer(HID_T) :: filespace     ! Dataspace identifier in file
  integer(HID_T) :: memspace      ! Dataspace identifier in mem
  integer(HID_T) :: plist_id      ! Property list identifier for parallel IO

  integer(HSIZE_T) :: count(6), countm(6), offset(6), offsetm(6), stride(6), block(6)
  integer(HSIZE_T) :: countr(6), offsetr(6), strider(6), blockr(6)

  integer :: comm, info, rowremainder, colremainder

  PUSH_SUB(write_matrix_d_par_hdf)

  if(peinf%inode.eq.0) call timacc(47,1)

! JRD: We need a barrier here or else parallel file opening gets mixed up with
! peinf%inode 0 opening the file to write the diagonal (which is called first).
  call MPI_barrier(MPI_COMM_WORLD,mpierr)

  comm = MPI_COMM_WORLD
  info = MPI_INFO_NULL

#ifdef VERBOSE
  if(peinf%inode .eq. 0) then
    write(6,*) ' Writing matrix: ', nmtx
    write(6,*) ' '
  endif
#endif

! JRD Should be ok with npr and npc = 0

  !if (scal%npr .eq. 0 .or. scal%npc .eq. 0) then
  !  write(6,*) peinf%inode,"Zero npr or npc!!", scal%npr, scal%npc
  !endif

  rank=6
  countm(1) = SCALARSIZE
  countm(2) = 1
  countm(3) = scal%npr
  countm(4) = scal%npc
  !countm(3) = scal%npr - mod(scal%npr,scal%nbl)
  !countm(4) = scal%npc - mod(scal%npc,scal%nbl)
  countm(5) = 1
  countm(6) = 1

  offsetm(:) = 0

  count(1) = 1
  count(2) = 1
  count(3) = scal%npr/scal%nbl
  count(4) = scal%npc/scal%nbl
  count(5) = 1
  count(6) = 1

  block(1) = SCALARSIZE
  block(2) = 1
  block(3) = scal%nbl
  block(4) = scal%nbl
  block(5) = 1
  block(6) = 1

  offset(1) = 0
  offset(2) = 0
  offset(3) = scal%myprow*scal%nbl
  offset(4) = scal%mypcol*scal%nbl
  offset(5) = is-1
  offset(6) = iq-1

  stride(1) = 1
  stride(2) = 1
  stride(3) = scal%nprow*scal%nbl
  stride(4) = scal%npcol*scal%nbl
  stride(5) = 1
  stride(6) = 1

  call h5pcreate_f(H5P_FILE_ACCESS_F, plist_id, error)
  call h5pset_fapl_mpio_f(plist_id, comm, info, error)
  call h5fopen_f(trim(name), H5F_ACC_RDWR_F, file_id, error, access_prp = plist_id)
  call h5pclose_f(plist_id,error)

  SAFE_ALLOCATE(data,(countm(1),countm(2),countm(3),countm(4),countm(5),countm(6)))
!XXX create data can we avoid duplication?
  do jj = 1, scal%npc
  !do jj = 1, scal%npc - mod(scal%npc,scal%nbl)
    do ii = 1, scal%npr
    !do ii = 1, scal%npr - mod(scal%npr,scal%nbl)
        data(1,1,ii,jj,1,1) = dble(matrix(ii,jj))
#ifdef CPLX
        data(2,1,ii,jj,1,1) = IMAG(matrix(ii,jj))
#endif
    enddo
  enddo

  call h5screate_simple_f(rank, countm, memspace, error)
  call h5sselect_hyperslab_f(memspace, H5S_SELECT_SET_F, offsetm, countm, error)

  call h5dopen_f(file_id, 'matrix', dset_id, error)
  call h5dget_space_f(dset_id,filespace,error)

  call h5sselect_hyperslab_f(filespace, H5S_SELECT_SET_F, offset, count, error, stride, block)

! Add in remainders, in case scal%nbl doesnt perfectly divide nmtx

! Bottom Rows
  rowremainder = mod(scal%npr,scal%nbl)
  if (rowremainder .ne. 0) then
    offsetr=offset
    countr=count
    blockr=block
    strider=stride
    offsetr(3)=nmtx-rowremainder
    countr(3)=rowremainder
    blockr(3)=1
    strider(3)=1
    call h5sselect_hyperslab_f(filespace, H5S_SELECT_OR_F, offsetr, countr, error, strider, blockr)
    !write(6,*) peinf%inode, "I have the bottom row", rowremainder, scal%npc
  endif

! Right Columns
  colremainder = mod(scal%npc,scal%nbl)
  if (colremainder .ne. 0) then
    offsetr=offset
    countr=count
    blockr=block
    strider=stride
    offsetr(4)=nmtx-colremainder
    countr(4)=colremainder
    blockr(4)=1
    strider(4)=1
    call h5sselect_hyperslab_f(filespace, H5S_SELECT_OR_F, offsetr, countr, error, strider, blockr)
    !write(6,*) peinf%inode, "I have the right column", colremainder, scal%npr
! Bottom Corner of Matrix
    if (rowremainder .ne. 0) then
      offsetr=offset
      countr=count
      blockr=block
      strider=stride
      offsetr(3)=nmtx-rowremainder
      countr(3)=rowremainder
      blockr(3)=1
      strider(3)=1
      offsetr(4)=nmtx-colremainder
      countr(4)=colremainder
      blockr(4)=1
      strider(4)=1
      call h5sselect_hyperslab_f(filespace, H5S_SELECT_OR_F, offsetr, countr, error, strider, blockr)
      !write(6,*) peinf%inode, "I have bottom both" 
    endif
  endif

  call h5pcreate_f(H5P_DATASET_XFER_F, plist_id, error)
  !call h5pset_dxpl_mpio_f(plist_id, H5FD_MPIO_INDEPENDENT_F, error)
  call h5pset_dxpl_mpio_f(plist_id, H5FD_MPIO_COLLECTIVE_F, error)
  if(peinf%inode.eq.0) call timacc(47,2)
  if(peinf%inode.eq.0) call timacc(48,1)
  call h5dwrite_f(dset_id, H5T_NATIVE_DOUBLE, data, countm, error, memspace, filespace, &
                      xfer_prp = plist_id)
  if(peinf%inode.eq.0) call timacc(48,2)
  call h5pclose_f(plist_id, error)

  SAFE_DEALLOCATE(data)
  call h5dclose_f(dset_id, error)
  call h5sclose_f(memspace, error)
  call h5sclose_f(filespace, error)
  call h5fclose_f(file_id, error)

  POP_SUB(write_matrix_d_par_hdf)
  
  return
end subroutine write_matrix_d_par_hdf

subroutine write_matrix_f_par_hdf(scal,nfreq,retarded,ONLYIFCPLX(advanced)nmtx,iq,is,name)
  type(scalapack), intent(in) :: scal
  integer, intent(in) :: nfreq
  complex(DPC), intent(in) :: retarded(:,:,:) !< (nfreq,scal%npr,scal%npc)
#ifdef CPLX
  complex(DPC), intent(in) :: advanced(:,:,:) !< (nfreq,scal%npr,scal%npc)
#endif
  integer, intent(in) :: nmtx
  integer, intent(in) :: iq
  integer, intent(in) :: is
  character(len=*), intent(in) :: name

  integer :: ii, jj, error, rank
  real(DP), allocatable :: data(:,:,:,:,:,:)

  integer(HID_T) :: file_id       ! File identifier
  integer(HID_T) :: dset_id       ! Dataset identifier
  integer(HID_T) :: filespace     ! Dataspace identifier in file
  integer(HID_T) :: memspace      ! Dataspace identifier in mem
  integer(HID_T) :: plist_id      ! Property list identifier for parallel IO

  integer(HSIZE_T) :: count(6), countm(6), offset(6), offsetm(6), stride(6), block(6)
  integer(HSIZE_T) :: countr(6), offsetr(6), strider(6), blockr(6)

  integer :: comm, info, rowremainder, colremainder

  PUSH_SUB(write_matrix_f_par_hdf)

  if(peinf%inode.eq.0) call timacc(47,1)

! JRD: We need a barrier here or else parallel file opening gets mixed up with
! peinf%inode 0 opening the file to write the diagonal (which is called first).
  call MPI_barrier(MPI_COMM_WORLD,mpierr)

  comm = MPI_COMM_WORLD
  info = MPI_INFO_NULL

#ifdef VERBOSE
  if(peinf%inode .eq. 0) then
    write(6,*) ' Writing matrix: ', nmtx
    write(6,*) ' '
  endif
#endif

! JRD Should be ok with npr and npc = 0

  rank=6
  countm(1) = 2
  countm(2) = nfreq
  countm(3) = scal%npr
  countm(4) = scal%npc
  countm(5) = SCALARSIZE
  countm(6) = 1

  offsetm(:) = 0

  count(1) = 1
  count(2) = 1
  count(3) = scal%npr/scal%nbl
  count(4) = scal%npc/scal%nbl
  count(5) = 1
  count(6) = 1

  block(1) = 2
  block(2) = nfreq
  block(3) = scal%nbl
  block(4) = scal%nbl
  block(5) = SCALARSIZE
  block(6) = 1

  offset(1) = 0
  offset(2) = 0
  offset(3) = scal%myprow*scal%nbl
  offset(4) = scal%mypcol*scal%nbl
  offset(5) = SCALARSIZE*(is-1)
  offset(6) = iq-1

  stride(1) = 1
  stride(2) = 1
  stride(3) = scal%nprow*scal%nbl
  stride(4) = scal%npcol*scal%nbl
  stride(5) = 1
  stride(6) = 1

  call h5pcreate_f(H5P_FILE_ACCESS_F, plist_id, error)
  call h5pset_fapl_mpio_f(plist_id, comm, info, error)
  call h5fopen_f(trim(name), H5F_ACC_RDWR_F, file_id, error, access_prp = plist_id)
  call h5pclose_f(plist_id,error)

  SAFE_ALLOCATE(data,(countm(1),countm(2),countm(3),countm(4),countm(5),countm(6)))
!XXX create data can we avoid duplication?
!XXX THREAD?
  do jj = 1, scal%npc
    do ii = 1, scal%npr
        data(1,:,ii,jj,1,1) = dble(retarded(:,ii,jj))
        data(2,:,ii,jj,1,1) = IMAG(retarded(:,ii,jj))
#ifdef CPLX
        data(1,:,ii,jj,2,1) = dble(advanced(:,ii,jj))
        data(2,:,ii,jj,2,1) = IMAG(advanced(:,ii,jj))
#endif
    enddo
  enddo

  call h5screate_simple_f(rank, countm, memspace, error)
  call h5sselect_hyperslab_f(memspace, H5S_SELECT_SET_F, offsetm, countm, error)

  call h5dopen_f(file_id, 'matrix', dset_id, error)
  call h5dget_space_f(dset_id,filespace,error)

  call h5sselect_hyperslab_f(filespace, H5S_SELECT_SET_F, offset, count, error, stride, block)

! Add in remainders, in case scal%nbl doesnt perfectly divide nmtx

! Bottom Rows
  rowremainder = mod(scal%npr,scal%nbl)
  if (rowremainder .ne. 0) then
    offsetr=offset
    countr=count
    blockr=block
    strider=stride
    offsetr(3)=nmtx-rowremainder
    countr(3)=rowremainder
    blockr(3)=1
    strider(3)=1
    call h5sselect_hyperslab_f(filespace, H5S_SELECT_OR_F, offsetr, countr, error, strider, blockr)
    !write(6,*) peinf%inode, "I have the bottom row", rowremainder, scal%npc
  endif

! Right Columns
  colremainder = mod(scal%npc,scal%nbl)
  if (colremainder .ne. 0) then
    offsetr=offset
    countr=count
    blockr=block
    strider=stride
    offsetr(4)=nmtx-colremainder
    countr(4)=colremainder
    blockr(4)=1
    strider(4)=1
    call h5sselect_hyperslab_f(filespace, H5S_SELECT_OR_F, offsetr, countr, error, strider, blockr)
    !write(6,*) peinf%inode, "I have the right column", colremainder, scal%npr
! Bottom Corner of Matrix
    if (rowremainder .ne. 0) then
      offsetr=offset
      countr=count
      blockr=block
      strider=stride
      offsetr(3)=nmtx-rowremainder
      countr(3)=rowremainder
      blockr(3)=1
      strider(3)=1
      offsetr(4)=nmtx-colremainder
      countr(4)=colremainder
      blockr(4)=1
      strider(4)=1
      call h5sselect_hyperslab_f(filespace, H5S_SELECT_OR_F, offsetr, countr, error, strider, blockr)
      !write(6,*) peinf%inode, "I have bottom both" 
    endif
  endif

  call h5pcreate_f(H5P_DATASET_XFER_F, plist_id, error)
  !call h5pset_dxpl_mpio_f(plist_id, H5FD_MPIO_INDEPENDENT_F, error)
  call h5pset_dxpl_mpio_f(plist_id, H5FD_MPIO_COLLECTIVE_F, error)
  if(peinf%inode.eq.0) call timacc(47,2)
  if(peinf%inode.eq.0) call timacc(48,1)
  call h5dwrite_f(dset_id, H5T_NATIVE_DOUBLE, data, countm, error, memspace, filespace, &
                      xfer_prp = plist_id)
  if(peinf%inode.eq.0) call timacc(48,2)
  call h5pclose_f(plist_id, error)

  SAFE_DEALLOCATE(data)
  call h5dclose_f(dset_id, error)
  call h5sclose_f(memspace, error)
  call h5sclose_f(filespace, error)
  call h5fclose_f(file_id, error)

  POP_SUB(write_matrix_f_par_hdf)
  
  return

end subroutine write_matrix_f_par_hdf

#endif


!==========================================================================================

subroutine write_matrix_f_hdf(scal,nfreq,retarded,ONLYIFCPLX(advanced)nmtx,iq,is,name)
  type(scalapack), intent(in) :: scal
  integer, intent(in) :: nfreq
  complex(DPC), intent(in) :: retarded(:,:,:) !< (nfreq,scal%npr,scal%npc)
#ifdef CPLX
  complex(DPC), intent(in) :: advanced(:,:,:) !< (nfreq,scal%npr,scal%npc)
#endif
  integer, intent(in) :: nmtx
  integer, intent(in) :: iq
  integer, intent(in) :: is
  character(len=*), intent(in) :: name

  integer :: ii, jj, error, size, rank
#ifdef USESCALAPACK
  real(DP), allocatable :: datatmp(:,:,:,:,:,:)
  integer :: irow, icol, irowm, icolm
  integer :: icurr
#endif
  real(DP), allocatable :: data(:,:,:,:,:,:)
  type(progress_info) :: prog_info !< a user-friendly progress report

  integer(HID_T) :: file_id       ! File identifier
  integer(HID_T) :: dset_id       ! Dataset identifier
  integer(HID_T) :: filespace     ! Dataspace identifier in file
  integer(HID_T) :: memspace      ! Dataspace identifier in mem

  integer(HSIZE_T) :: count(6), offset(6), offsetm(6)

  PUSH_SUB(write_matrix_f_hdf)

#ifdef VERBOSE
  if(peinf%inode .eq. 0) then
    write(6,*) ' Writing matrix: ', nmtx, nfreq
    write(6,*) ' '
  endif
#endif

! XXX: For now, we will still have only proc 0 write...
! We should changes this to parallel writes. But doing
! this effectively from the scalapack, block cyclic layout
! seems a bit tricky. So, ignoring for now...

  rank=6
  count(1) = 2
  count(2) = nfreq
  count(3) = nmtx
  count(4) = 1
  count(5) = SCALARSIZE
  count(6) = 1

  if (peinf%inode .eq. 0) then
    SAFE_ALLOCATE(data, (count(1),count(2),count(3),count(4),count(5),count(6)))
    call h5fopen_f(trim(name), H5F_ACC_RDWR_F, file_id, error)
    call h5dopen_f(file_id, 'matrix', dset_id, error)
    call h5screate_simple_f(rank, count, memspace, error)
    call h5dget_space_f(dset_id,filespace,error)
  endif

#ifdef USESCALAPACK
  SAFE_ALLOCATE(datatmp, (count(1),count(2),count(3),count(4),count(5),count(6)))
  icurr=0
#endif  

  call progress_init(prog_info, 'writing matrix', 'column', nmtx)
  do jj = 1, nmtx
    call progress_step(prog_info, jj)

#ifdef USESCALAPACK

!    if(peinf%inode.eq.0) call timacc(51,1)

    icol=MOD(INT(((jj-1)/scal%nbl)+TOL_SMALL),scal%npcol)
    datatmp=0d0
    if (icol .eq. scal%mypcol) then
      do ii = 1, nmtx
        irow=MOD(INT(((ii-1)/scal%nbl)+TOL_SMALL),scal%nprow)
        if (irow .eq. scal%myprow) then
          icurr=icurr+1
          icolm=INT((icurr-1)/scal%npr+TOL_SMALL)+1
          irowm=MOD((icurr-1),scal%npr)+1
          datatmp(1,:,ii,1,1,1)=dble(retarded(:,irowm,icolm))
          datatmp(2,:,ii,1,1,1)=IMAG(retarded(:,irowm,icolm))
#ifdef CPLX
          datatmp(1,:,ii,1,2,1)=dble(advanced(:,irowm,icolm))
          datatmp(2,:,ii,1,2,1)=IMAG(advanced(:,irowm,icolm))
#endif
        endif
      enddo
    endif
    if (peinf%inode .eq. 0) then
      data=0d0
    endif
! XXX This is a big waste of communication. Should be fixed when do
! parallel IO.

    size = nmtx*nfreq*2*SCALARSIZE

!    if(peinf%inode.eq.0) call timacc(51,2)
!    if(peinf%inode.eq.0) call timacc(52,1)

    call MPI_REDUCE(datatmp,data,size,MPI_DOUBLE_PRECISION,MPI_SUM,0, &
      MPI_COMM_WORLD,mpierr)

!    if(peinf%inode.eq.0) call timacc(52,2)

#else

    if (peinf%inode .eq. 0) then
      do ii = 1, nmtx
          data(1,:,ii,1,1,1)=dble(retarded(:,ii,jj))
          data(2,:,ii,1,1,1)=IMAG(retarded(:,ii,jj))
#ifdef CPLX
          data(1,:,ii,1,2,1)=dble(advanced(:,ii,jj))
          data(2,:,ii,1,2,1)=IMAG(advanced(:,ii,jj))
#endif
      enddo
    endif

#endif

!    if(peinf%inode.eq.0) call timacc(53,1)

    if (peinf%inode .eq. 0) then

      offsetm(:) = 0
      call h5sselect_hyperslab_f(memspace, H5S_SELECT_SET_F, offsetm, count, error)

      offset(1)=0
      offset(2)=0
      offset(3)=0
      offset(4)=jj-1
      offset(5)=SCALARSIZE*(is-1)
      offset(6)=iq-1

      call h5sselect_hyperslab_f(filespace, H5S_SELECT_SET_F, offset, count, error)

      call h5dwrite_f(dset_id, H5T_NATIVE_DOUBLE, data, count, error, memspace, filespace)

    endif

!    if(peinf%inode.eq.0) call timacc(53,2)
!    if(peinf%inode.eq.0) call timacc(54,1)

#ifdef USESCALAPACK
    call MPI_barrier(MPI_COMM_WORLD,mpierr)
#endif    

!    if(peinf%inode.eq.0) call timacc(54,2)


  enddo
  call progress_free(prog_info)

#ifdef USESCALAPACK
  SAFE_DEALLOCATE(datatmp)
#endif  

  if (peinf%inode .eq. 0) then
    SAFE_DEALLOCATE(data)
  endif

  if (peinf%inode .eq. 0) then
    call h5dclose_f(dset_id, error)
    call h5sclose_f(memspace, error)
    call h5sclose_f(filespace, error)
    call h5fclose_f(file_id, error)
  endif  

  POP_SUB(write_matrix_f_hdf)
  
  return
end subroutine write_matrix_f_hdf

!===================================================================================

subroutine write_gvec_indices_hdf(ng,isrtx,isorti,ekin,iq,name)
  integer, intent(in) :: ng
  integer, intent(in) :: isrtx(:) !< (ng)
  integer, intent(in) :: isorti(:) !< (ng)
  real(DP), intent(in) :: ekin(:) !< (ng)
  integer, intent(in) :: iq
  character(len=*), intent(in) :: name

  integer(HID_T) :: file_id       ! File identifier
  integer(HID_T) :: dset_id       ! Dataset identifier
  integer(HID_T) :: filespace     ! Dataspace identifier in file
  integer(HID_T) :: memspace      ! Dataspace identifier in mem

  integer(HSIZE_T) :: adims(3), edims(2), aoffset(3), eoffset(2), aoffsetm(3), eoffsetm(2)

  integer :: error, rank
  integer, allocatable :: sortarrays(:,:,:)
  real(DP), allocatable :: ekinarray(:,:)

  PUSH_SUB(write_gvec_indices_hdf)

  call h5fopen_f(trim(name), H5F_ACC_RDWR_F, file_id, error)

  SAFE_ALLOCATE(sortarrays,(ng,2,1))

! Write Arrays

  rank = 3
  adims(1) = ng
  adims(2) = 2
  adims(3) = 1
  aoffset(1) = 0
  aoffset(2) = 0
  aoffset(3) = iq - 1
  aoffsetm(:) = 0
  sortarrays(1:ng,1,1) = isrtx(1:ng)
  sortarrays(1:ng,2,1) = isorti(1:ng)
  call h5dopen_f(file_id, 'q-gvec-index', dset_id, error)
  call h5screate_simple_f(rank, adims, memspace, error)
  call h5dget_space_f(dset_id,filespace,error)
  call h5sselect_hyperslab_f(memspace, H5S_SELECT_SET_F, aoffsetm, adims, error)
  call h5sselect_hyperslab_f(filespace, H5S_SELECT_SET_F, aoffset, adims, error)
  call h5dwrite_f(dset_id, H5T_NATIVE_INTEGER, sortarrays, adims, error, memspace, filespace)
  call h5dclose_f(dset_id, error)
  call h5sclose_f(memspace, error)
  call h5sclose_f(filespace, error)

  SAFE_DEALLOCATE(sortarrays)
  SAFE_ALLOCATE(ekinarray,(ng,1))

  rank = 2
  edims(1) = ng
  edims(2) = 1
  eoffset(1) = 0
  eoffset(2) = iq - 1
  eoffsetm(:) = 0
  ekinarray(1:ng,1) = ekin(1:ng)
  call h5dopen_f(file_id, 'q-gvec-ekin', dset_id, error)
  call h5screate_simple_f(rank, edims, memspace, error)
  call h5dget_space_f(dset_id,filespace,error)
  call h5sselect_hyperslab_f(memspace, H5S_SELECT_SET_F, eoffsetm, edims, error)
  call h5sselect_hyperslab_f(filespace, H5S_SELECT_SET_F, eoffset, edims, error)
  call h5dwrite_f(dset_id, H5T_NATIVE_DOUBLE, ekinarray, edims, error, memspace, filespace)
  call h5dclose_f(dset_id, error)
  call h5sclose_f(memspace, error)
  call h5sclose_f(filespace, error)

  SAFE_DEALLOCATE(ekinarray)

  call h5fclose_f(file_id, error)

  POP_SUB(write_gvec_indices_hdf)

end subroutine write_gvec_indices_hdf

#endif

end module write_matrix_m

!=============================================================
! Utility:
! 
! wfn_time_reversal (flavorless). Originally by DAS.
!
!  Unfold the k-points in a WFN file according to time-reversal.
!  This allows use of the 'automatic' k-points from ESPRESSO
!  for an unshifted or half-shifted Monkhorst-Pack grid.
!  u_{-k}(G) = u_{k}(-G)* (spinless)
!  For spin-polarized or spinors:
!  u_{-k}(G,up) = -u_{k}(-G,dn)*
!  u_{-k}(G,dn) =  u_{k}(-G,up)*
!
!  You can use this utility for real WFNs but it is probably
!  useless: time-reversal has the same effect on k-points as
!  inversion, which needs to present for real WFNs to be allowed.
!
!=============================================================
! In this section we study another discrete symmetry operator,
! called 'time reversal'. This is a difficult topic for the novice,
! partly because the term 'time reversal' is a misnomer; it reminds
! us of science fiction. What we do in this section can be more
! appropriately characterized by the term 'reversal of motion.'
!           - J. J. Sakurai, Modern Quantum Mechanics
!=============================================================

#include "f_defs.h"

program wfn_time_reversal

  use global_m
  use find_kpt_match_m
  use misc_m
  use wfn_rho_vxc_io_m
  implicit none

  type(crystal) :: crys
  type(symmetry) :: syms
  type(kpoints) :: kp, kp2
  type(gspace) :: gvec, gvec_kpt
  character*3 :: sheader
  character*11 :: inform
  character*256 :: sformat, file_in, file_out, usage
  integer :: ik, ib, iflavor, ig, nargs, sym_umklapp(3), isym, ik_match
  real(DP) :: new_kpt(3)
  real(DP), allocatable :: dwfn(:,:), dwfn_spin(:)
  complex(DPC), allocatable :: zwfn(:,:), zwfn_spin(:)
  logical :: informat
  logical, allocatable :: time_reversible(:)
  integer, allocatable :: umklapp(:,:), new_gvecs(:,:)

  usage = 'Usage: wfn_time_reversal.x A|B WFN_in WFN_out'

  ! Get file names from command-line arguments

  nargs = iargc()

  if (nargs < 3) then
    call die(usage)
  endif

  ! mpiexec from mpich1 may add 4 extra arguments to the list
  if (nargs > 3) then
    write(0,'(a,i3,a)') 'WARNING: ', nargs, ' arguments found, only first 3 being used.'
  endif

  call getarg(1, sformat)
  call getarg(2, file_in)
  call getarg(3, file_out)

  ! Open units

  if (TRUNC(sformat) .eq. 'A') then
    informat = .true.
    inform = 'formatted'
  elseif (TRUNC(sformat) .eq. 'B') then
    informat = .false.
    inform = 'unformatted'
  else  
    call die(usage)
  endif

  ! Read header

  sheader='WFN'
  iflavor=-1
  write(6,'(a)') 'Reading ' // TRUNC(inform) // ' file ' // TRUNC(file_in)
  call open_file(unit=7,file=TRUNC(file_in),form=inform,status='old')
  call read_header_type(7, informat, sheader, iflavor, kp, gvec, syms, crys, warn = .false., dont_warn_kgrid = .true.)

  kp2%nspinor  = kp%nspinor
  kp2%nspin    = kp%nspin
  kp2%mnband   = kp%mnband
  kp2%kgrid(:) = kp%kgrid
  kp2%shift(:) = kp%shift(:)
  kp2%ecutwfc  = kp%ecutwfc
  kp2%ngkmax   = kp%ngkmax

  SAFE_ALLOCATE(kp2%ngk, (2*kp%nrk))
  kp2%ngk(1:kp%nrk) = kp%ngk(1:kp%nrk)
  SAFE_ALLOCATE(kp2%rk, (3, 2*kp%nrk))
  kp2%rk(1:3, 1:kp%nrk) = kp%rk(1:3, 1:kp%nrk)
  SAFE_ALLOCATE(kp2%ifmin, (2*kp%nrk, kp%nspin))
  kp2%ifmin(1:kp%nrk, 1:kp%nspin) = kp%ifmin(1:kp%nrk, 1:kp%nspin)
  SAFE_ALLOCATE(kp2%ifmax, (2*kp%nrk, kp%nspin))
  kp2%ifmax(1:kp%nrk, 1:kp%nspin) = kp%ifmax(1:kp%nrk, 1:kp%nspin)
  SAFE_ALLOCATE(kp2%w, (2*kp%nrk))
  kp2%w(1:kp%nrk) = kp%w(1:kp%nrk)
  SAFE_ALLOCATE(kp2%el, (kp%mnband, 2*kp%nrk, kp%nspin))
  kp2%el(1:kp%mnband, 1:kp%nrk, 1:kp%nspin) = kp%el(1:kp%mnband, 1:kp%nrk, 1:kp%nspin)
  SAFE_ALLOCATE(kp2%occ, (kp%mnband, 2*kp%nrk, kp%nspin))
  kp2%occ(1:kp%mnband, 1:kp%nrk, 1:kp%nspin) = kp%occ(1:kp%mnband, 1:kp%nrk, 1:kp%nspin)

  kp2%nrk = kp%nrk
  SAFE_ALLOCATE(time_reversible, (1:kp%nrk))
  SAFE_ALLOCATE(umklapp, (1:3, 1:kp%nrk))

  do ik = 1, kp%nrk
    write(6,'(a,i6,a,3f12.6)') 'Old k-point ', ik, ': ', kp%rk(1:3, ik)

    new_kpt(:) = -kp%rk(:, ik)
    call k_range(new_kpt(:), umklapp(:, ik), TOL_Zero)
    write(6,'(a,3f12.6)') '  Time-reverses to : ', new_kpt(1:3)

    ! Make sure this is not related by symmetry/Umklapp to a k-point already in the set
    ! k-coordinates 0 or 0.5 are mapped to themselves by time-reversal (and possible Umklapp)
    call find_kpt_match(kp, syms, new_kpt(:), ik_match, isym, sym_umklapp)
    time_reversible(ik) = (ik_match == 0)

    if(time_reversible(ik)) then
      kp2%nrk = kp2%nrk + 1
      kp2%rk(:, kp2%nrk) = new_kpt(:)

      ! divide weight between new and old k-points
      kp2%w(ik)      = kp%w(ik) * 0.5d0
      kp2%w(kp2%nrk) = kp%w(ik) * 0.5d0

      kp2%ngk(kp2%nrk) = kp%ngk(ik)
      kp2%ifmin(kp2%nrk, 1:kp%nspin) = kp%ifmin(ik, 1:kp%nspin)
      kp2%ifmax(kp2%nrk, 1:kp%nspin) = kp%ifmax(ik, 1:kp%nspin)
      kp2%el (1:kp%mnband, kp2%nrk, 1:kp%nspin) = kp%el (1:kp%mnband, ik, 1:kp%nspin)
      kp2%occ(1:kp%mnband, kp2%nrk, 1:kp%nspin) = kp%occ(1:kp%mnband, ik, 1:kp%nspin)
    else
      write(6,'(a,i6,a,i2,a,3i3)') '  But matches old k-point ', ik_match, &
        ' with symmetry number ', isym, ' and Umklapp ', sym_umklapp(:)
      kp2%w(ik) = kp%w(ik)
    endif
  enddo

  if(.not. any(time_reversible(1:kp%nrk))) then
    write(6,'(a)') 'No new unique k-points are generated by time-reversal. Not writing a new WFN file.'
    stop
  endif

  write(6,'(a)') 'Writing ' // TRUNC(inform) // ' file ' // TRUNC(file_out)
  call open_file(unit=8,file=TRUNC(file_out),form=inform,status='replace')
  call write_header_type(8, informat, sheader, iflavor, kp2, gvec, syms, crys, warn = .false.)

  ! charge density gvectors
  SAFE_ALLOCATE(gvec%components, (3, gvec%ng))
  call read_gvectors (7, informat, gvec%ng, gvec%ng, gvec%components)
  call write_gvectors(8, informat, gvec%ng, gvec%ng, gvec%components)

  if (iflavor .eq. 1) then
    SAFE_ALLOCATE(dwfn, (gvec%ng, kp%nspin))
    if(kp%nspin == 2) then
      SAFE_ALLOCATE(dwfn_spin, (gvec%ng))
    endif
  else
    SAFE_ALLOCATE(zwfn, (gvec%ng, kp%nspin))
    if(kp%nspin*kp%nspinor == 2) then
      SAFE_ALLOCATE(zwfn_spin, (gvec%ng))
    endif
  end if

  SAFE_ALLOCATE(gvec_kpt%components, (3, kp%ngkmax))
  SAFE_ALLOCATE(new_gvecs, (3, kp%ngkmax))

  ! Re-write original k-points
  do ik = 1, kp%nrk
    call read_gvectors (7, informat, kp%ngk(ik), kp%ngkmax, gvec_kpt%components)
    call write_gvectors(8, informat, kp%ngk(ik), kp%ngkmax, gvec_kpt%components)

    do ib = 1, kp%mnband
      if(iflavor == 1) then
        call read_real_data    (7, informat, kp%ngk(ik), gvec%ng, kp%nspin, dwfn(:,:))
        call write_real_data   (8, informat, kp%ngk(ik), gvec%ng, kp%nspin, dwfn(:,:))
      else
        call read_complex_data (7, informat, kp%ngk(ik), gvec%ng, kp%nspin*kp%nspinor, zwfn(:,:))
        call write_complex_data(8, informat, kp%ngk(ik), gvec%ng, kp%nspin*kp%nspinor, zwfn(:,:))
      endif
    enddo
  enddo

  call close_file(7)
  call dealloc_header_type(sheader, crys, kp)
  call open_file(unit=7,file=TRUNC(file_in),form=inform,status='old')
  call read_header_type(7, informat, sheader, iflavor, kp, gvec, syms, crys, warn = .false., dont_warn_kgrid = .true.)
  call read_gvectors(7, informat, gvec%ng, gvec%ng, gvec%components)

  ! Write new k-points
  do ik = 1, kp%nrk
    call read_gvectors (7, informat, kp%ngk(ik), kp%ngkmax,  gvec_kpt%components, dont_read = .not. time_reversible(ik))

    if(time_reversible(ik)) then
      do ig = 1, kp%ngk(ik)
        new_gvecs(1:3, ig) = -umklapp(1:3, ik) - gvec_kpt%components(1:3, ig)
      enddo
      call write_gvectors(8, informat, kp%ngk(ik), kp%ngkmax, new_gvecs)
    endif

    ! Even if we will not generate a new k-point, we must read through the data to get to the next k-point.
    do ib = 1, kp%mnband
      if(iflavor == 1) then
        call read_real_data(7, informat, kp%ngk(ik), gvec%ng, kp%nspin, dwfn(:,:), &
          dont_read = .not. time_reversible(ik) .and. .not. informat)
        if(time_reversible(ik)) then
          if(kp%nspin == 2) then
            dwfn_spin(:) = dwfn(:, 2)
            dwfn(:, 2) = dwfn(:, 1)
            dwfn(:, 1) = -dwfn_spin(:)
          endif
          call write_real_data   (8, informat, kp%ngk(ik), gvec%ng, kp%nspin, dwfn(:,:))
        endif
      else
        call read_complex_data(7, informat, kp%ngk(ik), gvec%ng, kp%nspin*kp%nspinor, zwfn(:,:), &
          dont_read = .not. time_reversible(ik) .and. .not. informat)
        if(time_reversible(ik)) then
          if(kp%nspin*kp%nspinor == 1) then
            zwfn(:,:) = conjg(zwfn(:,:))
          else
            zwfn_spin(:) = conjg(zwfn(:, 2))
            zwfn(:, 2) = conjg(zwfn(:, 1))
            zwfn(:, 1) = -conjg(zwfn_spin(:))
          endif
          call write_complex_data(8, informat, kp%ngk(ik), gvec%ng, kp%nspin*kp%nspinor, zwfn(:,:))
        endif
      endif
    enddo
  enddo

  ! Close files

  call close_file(7)
  call close_file(8)

  ! Deallocate

  if (iflavor .eq. 1) then
    SAFE_DEALLOCATE(dwfn)
    if(kp%nspin == 2) then
      SAFE_DEALLOCATE(dwfn_spin)
    endif
  else
    SAFE_DEALLOCATE(zwfn)
    if(kp%nspin*kp%nspinor == 2) then
      SAFE_DEALLOCATE(zwfn_spin)
    endif
  endif

  SAFE_DEALLOCATE_P(gvec%components)
  SAFE_DEALLOCATE_P(gvec_kpt%components)
  SAFE_DEALLOCATE(time_reversible)
  SAFE_DEALLOCATE(umklapp)
  SAFE_DEALLOCATE(new_gvecs)
  call dealloc_header_type(sheader, crys, kp)
  call dealloc_kp(kp2)

end program wfn_time_reversal

!============================================================================
!
! (3) bse_hdf5_setup
!
!============================================================================

#include "f_defs.h"

module epswrite_hdf5_m
#ifdef HDF5

  use h5lt
  use hdf5
  use global_m
  use hdf5_io_m
  implicit none

  private

  public :: &
    eps_hdf5_setup, &
    set_qpt_done, &
    is_qpt_done

contains


subroutine eps_hdf5_setup(freq_dep,nFreq,dFreqGrid,dFreqBrd,ecuts,kgrid,&
  ng,gcomponents,nq,qpts,nmtx_of_q,nmtxmax,nspin,name,restart)
  integer, intent(in) :: freq_dep
  integer, intent(in) :: nFreq
  real(DP), intent(in) :: dFreqGrid(:) !< (nFreq)
  complex(DPC), intent(in) :: dFreqBrd(:) !< (nFreq)
  real(DP), intent(in) :: ecuts 
  integer, intent(in) :: ng
  integer, intent(in) :: gcomponents(:,:) !< (3,ng)
  integer, intent(in) :: kgrid(3)
  integer, intent(in) :: nq
  real(DP), intent(in) :: qpts(:,:) !< (3,nq)
  integer, intent(in) :: nmtx_of_q(:) !< (nq)
  integer, intent(in) :: nmtxmax
  integer, intent(in) :: nspin !< number of spins in the dielectric matrix/polarizability!
  character(len=*), intent(in) :: name
  logical, intent(inout), optional :: restart

  integer(HID_T) :: file_id       ! File identifier
  integer(HID_T) :: matrix_id     ! Dataset identifier
  integer(HID_T) :: filespace     ! Dataspace identifier in file
  integer(HID_T) :: qpointspace
  integer(HID_T) :: qpoints_id
  integer(HSIZE_T) :: dims(6)

  integer :: error, intinfo(9), intinfo_old(9), ii, eps_size, num_matrix, intdata(1), qpt_done(nq)
  real(DP), allocatable :: tmp(:,:)
  real(DP) :: realdata(1)
  logical :: restart_, file_exists, file_ok

  PUSH_SUB(eps_hdf5_setup)

  intinfo(1) = SCALARSIZE - 1 !FHJ: FIXME - don`t subtract unity!
  intinfo(2) = nq
  intinfo(3) = freq_dep
  intinfo(4) = nFreq
  intinfo(5) = ng
  intinfo(6) = nmtxmax
  intinfo(7:9) = kgrid(1:3)

  restart_=.false.
  if (present(restart)) restart_ = restart
! XXX NEED THIS?
  !write(13) "ajname,ajdate"

  ! FHJ: try to restart the calculation, if possible and desired.
  ! We ignore the restart flags if the file doesn`t exist. However, the code
  ! dies if the file exists and is incompatible or looks corrupted.
  if (restart_) then
    write(6,'(1x,2a)') "Trying to restart file ", trim(name)
    inquire(file=trim(name), exist=file_exists)
    if (file_exists) then
      call h5fopen_f(trim(name), H5F_ACC_RDONLY_F, file_id, error)
      if (error==0) then
        ! FHJ: a simply consistency checks. Could be improved..
        file_ok = h5ltfind_dataset_f(file_id, 'qpt_done')==1
        if (file_ok) then
          call hdf5_read_int_array(file_id, 'intinfo', (/9/), intinfo_old, error)
          file_ok = error==0 .and. all(intinfo_old==intinfo)
        endif
        call h5fclose_f(file_id, error)
        if (file_ok) then
          ! FHJ: File *seems* alright, we don`t have to initialize it
          write(6,'(1x,2a)') "Everything looks ok: restarting file ", trim(name)
          return
        endif
        write(0,'(3a)') "ERROR: file ", trim(name), " is incompatible with the current calculation."
        write(0,'(a,9(i0,1x))') 'old intinfo: ', intinfo_old
        write(0,'(a,9(i0,1x))') 'new intinfo: ', intinfo
        call die("file "//trim(name)//" is incompatible with the current calculation.", only_root_writes=.true.)
      else
        write(0,'(3a,i0,a)') "ERROR: ", trim(name), " is not a valid HDF5 file (error code: ", error," )."
        write(0,'(a)') 'Make sure the file is not corrupted'
        call die("file "//trim(name)//" looks corrupted", only_root_writes=.true.)
      endif
    endif
    write(0,'(3a)') "WARNING: file ", trim(name), " doesn`t exist. We`ll start the calculation from scratch."   
    restart_ = .false.
    if (present(restart)) restart = .false.
  endif

  ! JRD: Create the file
  write(6,'(1x,2a)') "Initializing ", trim(name)
  call h5fcreate_f(trim(name), H5F_ACC_TRUNC_F, file_id, error)

! FHJ: FF calculations always compute complex dielectric matrices, and
! need two matrices (retarded+advanced)
  num_matrix = 1
  eps_size = SCALARSIZE
  if (freq_dep/=0) then
    num_matrix = SCALARSIZE
    eps_size = 2
  endif

! JRD: Create Space For Matrix
  dims(1) = eps_size
  if (freq_dep .eq. 0) then
    dims(2) = 1
  else
    dims(2) = nFreq
  endif
  dims(3) = nmtxmax
  dims(4) = nmtxmax
  dims(5) = num_matrix*nspin
  dims(6) = nq
  call h5screate_simple_f(6, dims, filespace, error)
  call h5dcreate_f(file_id, 'matrix', H5T_NATIVE_DOUBLE, filespace, matrix_id, error)
  call h5dclose_f(matrix_id, error)
  call h5sclose_f(filespace, error)

! Create Space for static matrix diagonal
  dims(1:3) = (/eps_size,nmtxmax,nq/)
  call h5screate_simple_f(3, dims(1:3), filespace, error)
  call h5dcreate_f(file_id, 'matrix-diagonal', H5T_NATIVE_DOUBLE, filespace, matrix_id, error)
  call h5dclose_f(matrix_id, error)
  call h5sclose_f(filespace, error)

! JRD: Write integer MetaData
  dims(1) = 9
  call H5LTmake_dataset_int_f(file_id, 'intinfo', 1, dims(1:1), intinfo, error)

! JRD: Write file version number
  dims(1) = 1
  intdata(1) = 1
  call H5LTmake_dataset_int_f(file_id, 'versionnumber', 1, dims(1:1), intdata, error)

! JRD: Write double precision metadata (ecuts)
  dims(1:1) = 1
  realdata(1) = ecuts
  call H5LTmake_dataset_double_f(file_id, 'dblinfo', 1, dims(1:1), realdata, error)

! JRD: Write g-vecs
  dims(1:2) = (/3,ng/)
  call H5LTmake_dataset_int_f(file_id, 'gvecs', 2, dims(1:2), gcomponents, error)

! JRD: Write q-points
  dims(1:2) = (/3,nq/)
  call H5LTmake_dataset_double_f(file_id, 'qpoints', 2, dims(1:2), qpts, error)

! JRD: Create Space for q-gvec-index
  dims(1:3) = (/ng,2,nq/)
  call h5screate_simple_f(3, dims(1:3), qpointspace, error)
  call h5dcreate_f(file_id, 'q-gvec-index', H5T_NATIVE_INTEGER, qpointspace, &
                      qpoints_id, error)
  call h5dclose_f(qpoints_id, error)
  call h5sclose_f(qpointspace, error)

! JRD: Create Space for q-gvec-ekin
  dims(1:2) = (/ng,nq/)
  call h5screate_simple_f(2, dims(1:2), qpointspace, error)
  call h5dcreate_f(file_id, 'q-gvec-ekin', H5T_NATIVE_DOUBLE, qpointspace, &
                      qpoints_id, error)
  call h5dclose_f(qpoints_id, error)
  call h5sclose_f(qpointspace, error)

! JRD: Write nmtx list
  dims(1) = nq
  call H5LTmake_dataset_int_f(file_id, 'nmtx-of-q', 1, dims(1:1), nmtx_of_q, error)

! JRD: Write frequencies
  if (freq_dep .ne. 0) then 
    dims(1:1) = (/nFreq/)
    call H5LTmake_dataset_double_f(file_id, 'freqs', 1, dims(1:1), dFreqGrid, error)

    SAFE_ALLOCATE(tmp,(2,nFreq))
    do ii = 1, nFreq
      tmp(1,ii) = DBLE(dFreqBrd(ii))
      tmp(2,ii) = IMAG(dFreqBrd(ii))
    enddo
    dims(1:2) = (/2,nFreq/)
    call H5LTmake_dataset_double_f(file_id, 'freqbrds', 2, dims(1:2), tmp, error)
    SAFE_DEALLOCATE(tmp) 
  endif

  call hdf5_write_int(file_id, 'nspin', nspin, error)
  qpt_done = 0
  call hdf5_write_int_array(file_id, 'qpt_done', (/nq/), qpt_done, error)

  call h5fclose_f(file_id, error)

  POP_SUB(eps_hdf5_setup)

end subroutine eps_hdf5_setup


subroutine set_qpt_done(fname, iq)
  character(len=*), intent(in) :: fname
  integer, intent(in) :: iq

  integer(HID_T) :: file_id
  integer :: nq, error, intinfo(9)
  integer, allocatable :: qpt_done(:)

  PUSH_SUB(set_qpt_done)

  call h5fopen_f(trim(fname), H5F_ACC_RDWR_F, file_id, error)
  call hdf5_read_int_array(file_id, 'intinfo', (/9/), intinfo, error)
  nq = intinfo(2)
  SAFE_ALLOCATE(qpt_done, (nq))
  call hdf5_read_int_array(file_id, 'qpt_done', (/nq/), qpt_done, error)
  qpt_done(iq) = 1
  call hdf5_write_int_array(file_id, 'qpt_done', (/nq/), qpt_done, error)
  call h5fclose_f(file_id, error)
  SAFE_DEALLOCATE(qpt_done)

  POP_SUB(set_qpt_done)

end subroutine set_qpt_done


logical function is_qpt_done(fname, iq)
  character(len=*), intent(in) :: fname
  integer, intent(in) :: iq

  integer(HID_T) :: file_id
  integer :: nq, error, intinfo(9)
  integer, allocatable :: qpt_done(:)

  PUSH_SUB(is_qpt_done)

  call h5fopen_f(trim(fname), H5F_ACC_RDONLY_F, file_id, error)
  call hdf5_read_int_array(file_id, 'intinfo', (/9/), intinfo, error)
  nq = intinfo(2)
  SAFE_ALLOCATE(qpt_done, (nq))
  call hdf5_read_int_array(file_id, 'qpt_done', (/nq/), qpt_done, error)
  is_qpt_done = qpt_done(iq)==1
  call h5fclose_f(file_id, error)
  SAFE_DEALLOCATE(qpt_done)

  POP_SUB(is_qpt_done)

end function is_qpt_done

#endif
end module epswrite_hdf5_m

!=================================================================================
!
! Routines:
!
! (1) gx_sum()         Originally By JRD       Last Modified 4/1/2012 (JRD)
!
!  Sum over G vectors for a given (v,c,v',c') set for the exchange contribution.
!
!  This routine scales as N^5 with number of atoms.
!
!=================================================================================

#include "f_defs.h"

module gx_sum_m

  use global_m
  use blas_m
  implicit none

  public :: gx_sum_TDA, gx_sum_extended

  private

  contains

    !> Sum G vectors to get the exchange kernel block.
    !! Works only with TDA kernel calculations.
    subroutine gx_sum_TDA(xct, invband, incband, vcoul, mvc, mvpcp, &
                     bsex, ivp_in, icp_in, ikp, iv_in, ic_in, ik)
      type (xctinfo), intent(in) :: xct
      integer, intent(in) :: invband,incband
      integer, intent(in) :: ivp_in,icp_in,ikp,iv_in,ic_in,ik
      real(DP), intent(in) :: vcoul(:) !< Modified Coulomb potential (vbar).
      SCALAR, intent(in) :: mvc(:,:,:,:) !< (ng, invband, incband, nspin)
      SCALAR, intent(inout) :: mvpcp(:,:,:,:) !< (ng, invband, incband, nspin)
      SCALAR, intent(inout) :: bsex(:,:,:) !< (leadingdim, nspin, nspin)

      SCALAR, allocatable :: outtemp(:,:,:,:)
      integer :: iscp, isc, iv, ivp, ic, icp, iit

      PUSH_SUB(gx_sum_TDA)

      SAFE_ALLOCATE(outtemp,(invband,incband,invband,incband))
      ! FHJ: Note: we are using the modified Coulomb potential here, where vbar(G=0)=0.
      do iscp=1,xct%nspin
        do icp=1,incband
          do ivp=1,invband
            mvpcp(:,ivp,icp,iscp) = vcoul(:) * mvpcp(:,ivp,icp,iscp)
          enddo
        enddo

        do isc=1,xct%nspin
          ! JRD: Sum over all G
          call X(gemm)('c','n',invband*incband,invband*incband,xct%ng, &
           ONE,mvc(:,:,:,isc),xct%ng,mvpcp(:,:,:,iscp),xct%ng, &
           ZERO,outtemp,invband*incband)

          do icp=1,incband
            do ivp=1,invband
              do ic=1,incband
                do iv=1,invband
                  if (xct%icpar .eq. 0) then
                    iit = peinf%wown(1,1,ikp,1,1,ik) + xct%nvb_co*xct%nvb_co*xct%ncb_co*(icp-1) &
                     + xct%nvb_co*xct%nvb_co*(ic-1) + xct%nvb_co*(ivp-1) + iv -1
                  else if (xct%ivpar .eq. 0) then
                    iit = peinf%wown(1,icp_in,ikp,1,ic_in,ik) + xct%nvb_co*(ivp-1) + iv -1
                  else
                    iit = peinf%wown(ivp_in,icp_in,ikp,iv_in,ic_in,ik)
                  endif
                  bsex(iit,isc,iscp) = bsex(iit,isc,iscp) + outtemp(iv,ic,ivp,icp)
                enddo !iv
              enddo !ic
            enddo !ivp
          enddo !icp
        enddo !isc
      enddo !iscp

      SAFE_DEALLOCATE(outtemp)

      POP_SUB(gx_sum_TDA)

    end subroutine gx_sum_TDA

    !> Sum G vectors to get the exchange kernel blocks.
    !! Works with TDA and extended kernel calculations.
    subroutine gx_sum_extended(xct, ofs1, ofs2, ofs1p, ofs2p, n1, n2, n1p, n2p, &
      m12, v_m1p2p, bsex, i1p_in, i2p_in, ikp, i1_in, i2_in, ik)
      type (xctinfo), intent(in) :: xct
      !> offset (i.e., add this number to map a local index to the global band index)
      integer, intent(in) :: ofs1, ofs2, ofs1p, ofs2p
      !> number of bands for each wfn
      integer, intent(in) :: n1, n2, n1p, n2p
      integer, intent(in) :: i1p_in, i2p_in, ikp, i1_in, i2_in, ik
      SCALAR, intent(in) :: m12(:,:,:,:) !< (ng, in1band, in2band, nspin)
      SCALAR, intent(in) :: v_m1p2p(:,:,:,:) !< (ng, in1band, in2band, nspin)
      SCALAR, intent(inout) :: bsex(:,:,:) !< (leadingdim, nspin, nspin)

      SCALAR, allocatable :: outtemp(:,:,:,:)
      integer :: iscp, isc, i1, i1p, i2, i2p, iit
      integer :: gi1, gi1p, gi2, gi2p

      PUSH_SUB(gx_sum_extended)

      SAFE_ALLOCATE(outtemp,(n1,n2,n1p,n2p))

      do iscp=1,xct%nspin
        do isc=1,xct%nspin
          ! JRD: Sum over all G
          call X(gemm)('c','n',n1*n2,n1p*n2p,xct%ng, &
           ONE,m12(:,:,:,isc),xct%ng,v_m1p2p(:,:,:,iscp),xct%ng, &
           ZERO,outtemp,n1*n2)

          do i2p=1,n2p
            gi2p = i2p + ofs2p
            do i1p=1,n1p
              gi1p = i1p + ofs1p
              do i2=1,n2
                gi2 = i2 + ofs2
                do i1=1,n1
                  gi1 = i1 + ofs1
                  if (xct%icpar .eq. 0) then
                    iit = peinf%wown(1,1,ikp,1,1,ik) + xct%n1b_co*xct%n1b_co*xct%n2b_co*(gi2p-1) &
                     + xct%n1b_co*xct%n1b_co*(gi2-1) + xct%n1b_co*(gi1p-1) + gi1 -1
                  else if (xct%ivpar .eq. 0) then
                    iit = peinf%wown(1,i2p_in,ikp,1,i2_in,ik) + xct%n1b_co*(gi1p-1) + gi1 -1
                  else
                    iit = peinf%wown(i1p_in,i2p_in,ikp,i1_in,i2_in,ik)
                  endif
                  bsex(iit,isc,iscp) = bsex(iit,isc,iscp) + outtemp(i1,i2,i1p,i2p)
                enddo !i1
              enddo !i2
            enddo !i1p
          enddo !i2p
        enddo !isc
      enddo !iscp

      SAFE_DEALLOCATE(outtemp)

      POP_SUB(gx_sum_extended)

    end subroutine gx_sum_extended

end module gx_sum_m

!==============================================================================
!
! Module bse_init_m
!
! (1) bse_init()         Originally By FHJ       Last Modified  3/24/2012 (FHJ)
!
!     Performs initializations required by absorption and inteqp calculations.
!
!==============================================================================

#include "f_defs.h"

module bse_init_m

  use global_m
  use fullbz_m
  use intpts_m
  use wfn_rho_vxc_io_m

  implicit none

  private

  public :: bse_init

contains

!> FHJ: Figures out the number of k-points in the corase grid and the
!!      dimensionality of the system for interpolation pourposes.
!! FIXME: am I freeing all buffers correctly?
subroutine bse_init(xct,flag)
  type (xctinfo), intent(inout) :: xct
  type (flags), intent(in) :: flag

  character(len=3) :: sheader
  integer :: iflavor
  type (crystal) :: crys, crys_co
  type (gspace) :: gvec, gvec_co
  type (grid) :: kg, kg_co
  type (kpoints) :: kp, kp_co
  type (symmetry) :: syms, syms_co
  logical :: skip_checkbz

  logical :: is_periodic_old(3)
  integer :: jdim, npts_intp_kernel

  PUSH_SUB(bse_init)

  if (flag%read_dtmat) then
    call open_file(unit=13,file='dtmat',form='unformatted',status='old')
    read(13) xct%idimensions, xct%is_periodic(1:3), npts_intp_kernel, xct%nkpt_co
    call close_file(13)
    return
  endif

  if (peinf%inode==0) write(6,*)

  ! FHJ: Read the header of WFN_co
  if (peinf%inode == 0) &
    call open_file(unit=25, file='WFN_co', form='unformatted', status='old')
  sheader = 'WFN'
  iflavor = 0
  call read_binary_header_type(25, sheader, iflavor, kp_co, gvec_co, &
    syms_co, crys_co, warn=.false., dont_warn_kgrid=.true.)
  if (peinf%inode == 0) call close_file(25)
  kg_co%nr = kp_co%nrk
  SAFE_ALLOCATE(kg_co%r, (3,kg_co%nr))
  kg_co%r(:,:) = kp_co%rk(:,:)

  ! FHJ: We just need to unfold the k-points fast to get the number of k-points
  !      in each direction, so we won`t build the wigner seitz cell.
  if (flag%bzc==1) then
    call fullbz(crys_co, syms_co, kg_co, 1, skip_checkbz, &
                wigner_seitz=.false., paranoid=.false., do_nothing=.true.)
  else
    call fullbz(crys_co, syms_co, kg_co, syms_co%ntran, skip_checkbz, &
                wigner_seitz=.false., paranoid=.false.)
  endif

  xct%nkpt_co = kg_co%nf
  if (peinf%inode==0) then
    write(6,'(1x,a,i0)') 'Number of k-points in the coarse k-grid: ', xct%nkpt_co
  endif

  ! FHJ: find the number of periodic dimensions from the kpt sampling.
  !      Don`t trust kp%kgrid!
  call get_ndims(kg_co, xct)

  SAFE_DEALLOCATE_P(kg_co%r)
  SAFE_DEALLOCATE_P(kg_co%f)


  if (xct%skipinterp) then
    xct%npts_intp_kernel = 1
  else
    ! FHJ: Read the header of WFN, if we are interpolating
    if (peinf%inode == 0) &
      call open_file(25, file='WFN_fi', form='unformatted', status='old')
    sheader = 'WFN'
    iflavor = 0
    call read_binary_header_type(25, sheader, iflavor, kp, gvec, syms, crys, &
      dont_warn_kgrid=.true.)
    if (peinf%inode == 0) call close_file(25)
    kg%nr = kp%nrk
    SAFE_ALLOCATE(kg%r, (3,kg%nr))
    kg%r(:,:) = kp%rk(:,:)

    if (flag%bz0==0.and.xct%is_absorption) then
      call fullbz(crys, syms, kg, syms%ntran, skip_checkbz, &
                  wigner_seitz=.false., paranoid=.false.)
    else
      call fullbz(crys, syms, kg, 1, skip_checkbz, &
                  wigner_seitz=.false., paranoid=.false., do_nothing=.true.)
    endif

    is_periodic_old = xct%is_periodic
    call get_ndims(kg, xct)
    xct%is_periodic = xct%is_periodic .or. is_periodic_old
    xct%idimensions = 0
    do jdim = 1, 3
      if (xct%is_periodic(jdim)) xct%idimensions = xct%idimensions + 1
    enddo

    SAFE_DEALLOCATE_P(kg%r)
    SAFE_DEALLOCATE_P(kg%f)


    if (peinf%inode==0) then
      write(6,'(1x,a,i1,a)') 'A ',xct%idimensions,'-D interpolation algorithm will be employed.'
    endif
  endif ! xct%skipinterp

  POP_SUB(bse_init)

end subroutine bse_init

end module bse_init_m

!=============================================================================
!
! Routines:
!
! (1) distrib()         Originally By MLT       Last Modified 6/2008 FJR
!
!     Distributes kpoints among the processors
!
!=============================================================================

#include "f_defs.h"

subroutine distrib(xct)

  use global_m
  implicit none

  type (xctinfo), intent(in) :: xct
  
  integer :: ik,ipe
  
  PUSH_SUB(distrib)

  peinf%nkpe=xct%nn/peinf%npes
  if(xct%nn-peinf%npes*peinf%nkpe.gt.0) peinf%nkpe=peinf%nkpe+1
  
  SAFE_ALLOCATE(peinf%ik, (peinf%npes,peinf%nkpe))
  SAFE_ALLOCATE(peinf%ikt, (peinf%npes))
  
  peinf%ik=0
  peinf%ikt=0
  
  ipe=0
  do ik=1,xct%nn
    ipe=ipe+1
    if(ipe.eq.peinf%npes+1) ipe=1
    peinf%ikt(ipe)=peinf%ikt(ipe)+1
    peinf%ik(ipe,peinf%ikt(ipe))=ik
  enddo
  
  if(peinf%inode.eq.0) then
    write(6,70)
70  format(/,1x,'Number of kpoints treated by each PE:')
    write(6,80) peinf%ikt
80  format(3x,8i4)
  endif
  
  POP_SUB(distrib)
  
  return
end subroutine distrib

!=============================================================================
!
! Routines:
!
! (1) wpeff()    Originally By SIB              Last Modified 5/1/2008 (JRD)
!
!     This routine computes effective plasma frequencies (squared).
!
!     Specifically, for each G` (igp) it computes for all G (ig),
!     the quantity in formula (31) on page 5396 of
!     Hybertsen and Louie, PRB vol 34, #8 (1986) given by
!
!     Omega(G,G`)^2 = wp^2 * [rho(G-G`)/rho(0)] * (q+G).(q+G`)*vc(q+G)/(8pi)
!
!     (vc(q+G) is the Coulomb interaction), and places the numbers
!     into wpmtx(ig).  Units are eV^2.
!
!     Computes effective plasma freq matrix-
!     wp(g,g`) = wp**2 (rho(g-g`)/rho(0)) (q+g).(q+g`) vc(q+g)/8pi
!
!     isrtrq             index array, (rq+g)**2
!     nelec,wpsq         rho(g=0), feg plasma frequency^2
!     rho                rho(g)
!
!=============================================================================

#include "f_defs.h"

subroutine wpeff(crys, gvec, wpg, sig, neps, isrtrq, igp, ncouls, wpmtx, nspin, qk,vcoul,coulfact)

  use global_m
  use misc_m
  implicit none

  type (crystal), intent(in) :: crys
  type (gspace), intent(in) :: gvec
  type (wpgen), intent(in) :: wpg
  type (siginfo), intent(in) :: sig
  integer, intent(in) :: neps
  integer, intent(in) :: isrtrq(neps), igp, ncouls
  SCALAR, intent(out) :: wpmtx(neps)
  integer, intent(in) :: nspin
  real(DP), intent(in) :: qk(3), vcoul(ncouls), coulfact

  SCALAR :: rho_g_minus_gp
  integer :: ig, igadd, igpadd, kadd, gg(3)
  real(DP) :: qg(3), qgp(3)

!-----------------------------
! SIB: stuff that is remembered between calls in order to speed
! things up
! 'save' is deprecated, replace with an object... DAS

  !logical, save :: first_call = .true.
  !logical, save :: q_is_not_zero
  !real(DP), save :: qk_old(3), fact, qnorm2
  !real(DP), allocatable, save :: precalc(:,:)
  real(DP) :: fact, qnorm2
  logical :: q_is_not_zero
  real(DP), allocatable :: precalc(:,:)

  ! no push_sub, called too frequently

! WARNING: if Fermi level is adjusted, the charge density here does not change,
! which will make the plasma frequency inconsistent. -- DAS

  if((abs(sig%efermi_input) > TOL_Zero .or. .not. sig%rfermi) &
    .and. (peinf%inode == 0)) then
    write(0,'(a)') "WARNING: GPP plasma frequency does not respond to manual adjustment of the Fermi level."
  endif

!--------------- Begin Calculation ------------------------------------------------------


!------------------------
! SIB: Calculate stuff that is the same between calls for a given qk.
! The precalculated table contains:
!
! precalc(:,ig) = wp**2/rho(0)*(vc(q+G)/8pi)*(q+G)

  !if (sum(abs(qk-qk_old)) > 1.0d-12) then
    SAFE_ALLOCATE(precalc, (3,ncouls))
    precalc = 0.0d0

! Common factor

    fact=(wpg%wpsq(1)+(nspin-1)*wpg%wpsq(2))/(wpg%nelec(1)+(nspin-1)*wpg%nelec(2))

! Square length of qk

    qnorm2=dot_product(qk,matmul(crys%bdot,qk))

! Set a flag if q is not "zero"

    if (qnorm2 > 1.0d-12) then
      q_is_not_zero = .true.
    else
      q_is_not_zero = .false.
    endif


!---------- Loop over g and tabulate -------------------------------

    do ig=1,ncouls

! Get q+g and |q+g|^2

      igadd=isrtrq(ig)

! If g<>0 or q<>0, we just calculate the formula

      if (igadd.ne.1 .or. q_is_not_zero) then
        qg(:)=gvec%components(:,igadd)+qk(:)
        precalc(:,ig) = fact*vcoul(ig)*qg(:)/coulfact
      else

! If g=q=0, we have to avoid dividing by zero;
! we handle this special case separately below

        precalc(:,ig) = 0.0d0
      endif

    enddo ! g loop
  !endif


!----------------- Here starts the main calculation! ----------------------------


! Get q+gp

  igpadd=isrtrq(igp)
  qgp(:)=gvec%components(:,igpadd)+qk(:)


!!----------- Loop over g and calculate Omega^2(g,gp) -------------------------


  do ig=1,ncouls
    igadd=isrtrq(ig)
    
    wpmtx(ig) = ZERO

! Compute address of g-gp, and if it is a vector for which
! we have the density, get rho(g-gp); if out of bounds,
! skip this g
    
    gg(:) = gvec%components(:, igadd) - gvec%components(:, igpadd)
    call findvector(kadd, gg, gvec)
    if(kadd.eq.0) cycle
    rho_g_minus_gp = sum(wpg%rho(kadd,1:nspin))

! Using precalculated stuff, assemble together wpmtx
! if g<>0 or q<>0, we can just do what the formula says

    if (igadd.ne.1 .or. q_is_not_zero) then
      wpmtx(ig) = dot_product(qgp(:),matmul(crys%bdot,precalc(:,ig)))*rho_g_minus_gp

! The special case q=g=0

    else

! If gp=0, then wpmtx=wp**2 times a possible
! (1-cos(0))=0 if truncating

      if (igpadd.eq.1) then
        wpmtx(ig) = fact*rho_g_minus_gp
!            if (sig%icutv.ne.0) wpmtx(ig) = 0.0d0

! When q=g=0, gp<>0, the result is just set to zero
! (it is infinite for true coulomb interaction and zero
! if truncated).

      else
        wpmtx(ig) = 0.0d0
      endif
    endif

  enddo !! g loop

  SAFE_DEALLOCATE(precalc)

  return
end subroutine wpeff

!==========================================================================
!
! Modules:
!
! (1) typedefs      Originally By GMR      Last Modified 7/8/2008 (JRD)
!
!>    Derived types that are used throughout the code.
!
!==========================================================================

#include "f_defs.h"

module typedefs_m

  use nrtype_m

  implicit none

  public ! only types in this module

!---------------------------

  type crystal
    real(DP) :: celvol !< cell volume in real space (a.u.)
    real(DP) :: recvol !< cell volume in reciprocal space (a.u.)
    real(DP) :: alat !< lattice constant in real space (a.u.)
    real(DP) :: blat !< lattice constant in reciprocal space (a.u.)
    real(DP) :: avec(3,3) !< lattice vectors in real space (alat)
    real(DP) :: bvec(3,3) !< lattice vectors in reciprocal space (blat)
    real(DP) :: adot(3,3) !< metric tensor in real space (a.u.)
    real(DP) :: bdot(3,3) !< metric tensor in reciprocal space (a.u.)
    integer :: nat !< number of atoms
    integer, pointer :: atyp(:) !< atomic species, atyp(1:nat)
    real(DP), pointer :: apos(:,:) !< atomic positions, apos(1:3,1:nat) (alat)
  end type crystal

!---------------------------

  type kpoints
    integer :: nspinor = 1 !< nspinor = 2 if doing two-component spinor calculation; 1 is default
    integer :: nspin   !< nspin = 1 or 2; nspin = 1 when npsinor = 2
    integer :: nrk     !< number of k-points
    integer :: mnband  !< max number of bands
    integer :: nvband  !< number of valence bands
    integer :: ncband  !< number of conduction bands
    integer  :: kgrid(3) !< Monkhorst-Pack number of k-points in each direction
    real(DP) :: shift(3) !< Monkhorst-Pack shift of grid
    real(DP) :: ecutwfc            !< wave-function cutoff, in Ry
    integer, pointer :: ngk(:)     !< number of g-vectors for each k-point
    integer :: ngkmax              !< max(ngk(:))
    integer, pointer :: ifmin(:,:) !< lowest occupied band (kpoint,spin)
    integer, pointer :: ifmax(:,:) !< highest occupied band (kpoint,spin)
    real(DP), pointer :: w(:)      !< weights (kpoint) (between 0 and 1)
    real(DP), pointer :: rk(:,:)   !< k-vector (3, kpoint) in crystal coords
    real(DP), pointer :: el(:,:,:) !< band energies (band, kpoint, spin)
    real(DP), pointer :: elda(:,:,:) !< band energies before eqp correction
    real(DP), pointer :: occ(:,:,:)  !< occupations (between 0 and 1)
    integer, pointer :: degeneracy(:,:,:) !< size of deg. subspace for (band, kpoint, spin)
  end type kpoints
  
!---------------------------
  
  type symmetry
    integer :: ntran         !< number of operations in full group
    integer :: ntranq        !< number of operations in small group of q
    real(DP) :: rq(3)        !< The q-point this ntranq belongs to
    integer :: mtrx(3,3,48)  !< symmetry matrix
    real(DP) :: tnp(3,48)    !< fractional translations
    integer :: indsub(48)    !< symmetry operations in subgroup of q
    integer :: kgzero(3,48)  !< Umklapp vectors for subgroup symmetry operations
    integer :: cell_symmetry !< 0 = cubic, 1 = hexagonal
  end type symmetry
      
!---------------------------

  type grid
    integer :: nr  !< number in reduced zone
    integer :: nf  !< number in full zone
    real(DP) :: sz !< radius of a spherical subzone equivalent to
                   !! one point in the set f
    integer, pointer :: itran(:) !< sym op to go from irrbz to fullbz
    integer, pointer :: indr(:)  !< irrbz k/q-point mapped to fullbz
    integer, pointer :: kg0(:,:) !< Umklapp vectors (for Wigner-Seitz cell)
    real(DP), pointer :: r(:,:)  !< k/q-points in reduced zone
    real(DP), pointer :: f(:,:)  !< k/q-points in full zone
  end type grid

!-----------------------------------

  type gspace
    integer :: ng       !< number of G-vectors
    integer :: nFFTgridpts !< number in FFT grid = product(FFTgrid(1:3))
    real(DP) :: ecutrho !< charge-density cutoff, in Ry
    integer, pointer :: components(:,:) !< the G-vectors, in units of 2 pi / a
    integer :: FFTgrid(3)  !< gsm: FFTgrid is the size of the FFT grid, not the maximum G-vector   
    integer, pointer :: index_vec(:) ! mapping to FFT grid
    real(DP), pointer :: ekin(:) !< kinetic energy of G-vectors
  end type gspace

!---------------------------
!> Parameters for scissors operators
!> e_cor = e_in + es + edel * (e_in - e0)
!> es and e0 are in eV. edel is a dimensionless slope.
  type sub_scissors_t
    real(DP) :: es
    real(DP) :: edel
    real(DP) :: e0
  end type sub_scissors_t

  type scissors_t
    type(sub_scissors_t) :: val
    type(sub_scissors_t) :: cond
  end type scissors_t

!---------------------------

  type wavefunction
    integer :: ng
    integer :: nband
    integer :: nspin
    integer :: nspinor = 1 !< nspinor = 2 if doing two-component spinor calculation; 1 is default
    integer, pointer :: isort(:)
    SCALAR, pointer :: cg(:,:,:)
  end type wavefunction

!---------------------------

!> For Epsilon: this is the wavefunction before unfolding the irr. BZ.
!! For BSE: ??
  type int_wavefunction
    integer :: nspin
    integer :: nspinor = 1 !< nspinor = 2 if doing two-component spinor calculation; 1 is default
    integer, pointer ::  ng(:)     !< (nk)
    integer, pointer :: isort(:,:) !< (ngmax, nk)
    integer, pointer :: cbi(:)
    !> I think this can be decommisioned if we use kp%rk instead
    real(DP), pointer :: qk(:,:)
    SCALAR, pointer :: cg(:,:,:)
    SCALAR, pointer :: cgk(:,:,:,:)
  end type int_wavefunction

!------------------------------------

  !> FHJ: valence WFNs for 1 particular kpt and 1 band
  !! It stores all bands in the case of real-space WFNs
  type valence_wfns
    integer :: nband  !< This is indeed the number of valence bands
    integer :: ngv    !< Number of G-vectors
    integer :: idx_kp !< Idx of current kpt in kp/kpq structure
    integer, pointer :: isort(:)
    !> (nband+ncrit,spin). Note: the nband+ncrit index is actually useless!
    real(DP), pointer :: ev(:,:)
    SCALAR, pointer :: zv(:,:)   !< (ngv,spin)
    !> real-space wavefunction for all "local" val. bands (fft1,fft2,fft3,band)
    complex(DPC), pointer :: wfn_fft(:,:,:,:)
  end type valence_wfns

!-------------------------------

  !> FHJ: conduction WFNs for 1 particular kpt and all bands (!) the processor owns
  type conduction_wfns
    integer :: nband  !< This is actually the number of valence+conduction bands!
    integer :: ngc    !< Number of G-vectors
    integer :: idx_kp !< Idx of current kpt in kp structure
    integer, pointer :: isort(:)
    integer, pointer :: band_index(:)
    real(DP), pointer :: ec(:,:) !< (nband,nspin)
    SCALAR, pointer :: zc(:,:)   !< (ngc*ncownactual,spin)
    !> real-space wavefunction for all "local" cond. bands (fft1,fft2,fft3,band)
    complex(DPC), pointer :: wfn_fft(:,:,:,:)
  end type conduction_wfns

!----------------------------

  !> splines knots and coefficients
  type spline_tck
    integer :: n              !< number of knots
    integer :: k              !< degree of spline (1=linear, etc.)
    real(DP), pointer :: t(:) !< position of knots
    real(DP), pointer :: c(:) !< splines coefficient
  end type spline_tck

!-------------------------------------

  type coulomb_modifier_t

    real(DP) :: short_range_frac_fock  !< Short range exchange fraction
    real(DP) :: long_range_frac_fock   !< Long range exchange fraction
    real(DP) :: screening_length       !< Screening length
                                       !< The above 3 parameters are used 
                                       !< only for TDDFT and sigma calculations.

  end type coulomb_modifier_t

!----------------------------

  type siginfo
    integer :: freq_dep    !< frequency dependence of the inverse dielectric matrix
    integer :: nFreq       !< number of frequencies used in full frequency calculation
    real(DP) :: dDeltaFreq !< frequency increment (eV) for polarizability energy denominator
    real(DP) :: dBrdning   !< Lorentzian broadening (eV) for polarizability energy denominator
    real(DP), pointer :: dFreqGrid(:)   !< Grid of Frequencies for Full Frequency
    complex(DPC), pointer :: dFreqBrd(:) !< Corresponding Broadenings for Full Frequency

    integer :: nSFreq    !< number of frequencies used in spectral functions
    real(DP) :: dDeltaSFreq !< frequency increment (eV) for spectral functions
    real(DP), pointer :: dSFreqGrid(:)   !< Grid of Frequencies for spectral functions

    integer :: exact_ch    !< compute the exact static CH
    integer :: fullConvLog !< logging CH convergence
    integer :: iwritecoul  !< flag to write vcoul
    real(DP) :: tol        !< energy tolerance for degeneracy
    integer :: ggpsum
    logical :: use_hdf5     !< with -DHDF5, whether or not we actually use hdf5
    logical :: use_xdat     !< use saved exchange matrix elements from file x.dat
    logical :: use_vxcdat   !< use saved exchange-correlation matrix elements from file vxc.dat
    logical :: use_vxc2dat  !< use saved exchange-correlation matrix elements from file vxc2.dat
    integer :: nkn          !< number of k-points on which to calculate Sigma (from sigma.inp)
    integer :: nfreqeval
    integer :: nq0, nq1, nq !< Number of q->0 points, q/=0 points, and total number of q-points
    logical :: subsample !< whether we perform a subsampling of the voronoi cell of q=0
    real(DP), pointer :: subweights(:) !< (nq0) weight for each subsampling q-point
    integer :: nvband
    integer :: ntband
    integer :: igamma       !< nonzero if Gamma is the only q-point, 0 otherwise
    integer :: nspin
    integer :: spin_index(2)
    integer :: icutv               !< icutv encodes presence and type of truncation
    integer :: iwriteint           !< = 0 for comm_disk, = 1 for comm_mpi
    integer :: iuseremainder
    integer :: qgrid(3)
    integer :: iscreen !< what type of screening is present. 0 = semiconductor, 1 = graphene, 2 = metal
    integer :: fdf !< finite difference form for numerical derivative of Sigma
    integer, pointer :: indkn(:) !< mapping of k-points from sigma.inp to those in kp%rk from WFN files
    integer, pointer :: diag(:) !< energy bands for which Sigma diagonal matrix elements are calculated
    integer :: ndiag    !< number of bands contained in diag(:)
    integer :: noffdiag !< offdiag
    integer :: loff
    integer :: toff
    integer :: bmin
    integer :: bmax
    integer, pointer :: off1(:) !< offdiag <bra|
    integer, pointer :: off2(:) !< offdiag |ket>
    integer, pointer :: off3(:) !< offdiag energy at which to evaluate
    integer, pointer :: offmap(:,:)  !< sig%off1(ii) = sig%diag(sig%offmap(ii,1))
    integer, pointer :: band_index(:)
    real(DP) :: dw       !< finite difference spacing for numerical derivative of Sigma in eV
    real(DP) :: ecutb    !< energy cutoff of bare coulomb interaction in Ry
    real(DP) :: ecuts    !< energy cutoff of screened coulomb interaction in Ry
    real(DP) :: xfrac    !< fraction of bare exchange
    real(DP) :: gamma    !< GPP broadening
    real(DP) :: sexcut   !< GPP SX cutoff
    real(DP) :: q0vec(3)
    real(DP) :: freqevalmin
    real(DP) :: freqevalstep
    logical :: eqp_corrections !< are we using eqp.dat
    logical :: eqp_outer_corrections !< are we using eqp_outer.dat
    type(scissors_t) :: scis
    type(scissors_t) :: scis_outer
    logical  :: wfn_outer_present
    type(spline_tck) :: spl_tck       !< scissors b-spline coefficients
    type(spline_tck) :: spl_tck_outer !< scissors b-spline coeffs for WFN_outer
    real(DP) :: avgpot
    real(DP) :: avgpot_outer
    real(DP) :: truncval(3)    !< in Bohr (au)
    real(DP) :: avgcut         !< Cut in which we do cell averages on
    real(DP), pointer :: kpt(:,:)
    real(DP), pointer :: qpt(:,:) !< (3,nq) q-points in eps0mat+epsmat files, or provided in sigma.inp
    integer :: ncrit           !< number of partially occupied bands
    real(DP) :: efermi         !< Fermi level
    real(DP) :: efermi_input   !< what is set in the input file
    logical :: rfermi          !< Fermi level relative to neutral system
    SCALAR, pointer :: vxc(:,:) !< Vxc(G)
    SCALAR, pointer :: vxc2(:,:) !< Vxc(G) for hybrid functional type calculations
    SCALAR :: wcoul0
    logical :: freplacebz
    logical :: fwritebz
    logical :: degeneracy_check_override
    logical :: offdiagsym
    logical :: qgridsym
    logical :: die_outside_sphere
    logical :: averagew
    type(coulomb_modifier_t) :: coulomb_mod 
    logical :: coul_mod_flag   !< Flag which tells if the coulomb interaction has been 
                               !< modified (for hybrid functional like calculation in sigma)
  end type siginfo

!---------------------------
  !> dielectric matrix info using comm_mpi
  type epsmpiinfo
    integer :: ngpown
    integer :: ngpown_max
    integer :: ngpown_rem
    integer, pointer :: isrtq(:,:)   !< These 3 arrays have a dimension of (1:gvec%ng,1:(nq+1)) where
    integer, pointer :: isrtqi(:,:)  !! (nq+1) is the total # of q`s including q0.
    
    integer, pointer :: igp_owner(:)
    integer, pointer :: igp_index(:)
    integer, pointer :: inv_igp_index(:)
    integer, pointer :: nmtx(:)      !< dimension of eps(q) for each q
    real(DP), pointer :: qk(:,:)
    SCALAR, pointer :: eps(:,:,:)    !< eps(1:gvec%ng,1:ngpown,1:(nq+1))
    
    !> dimension of epsR and epsA (1:sig%nfreq,1:gvec%ng,1:ngpown,1:(nq+1))
    complex(DPC), pointer :: epsR(:,:,:,:)
    complex(DPC), pointer :: epsA(:,:,:,:)
  end type epsmpiinfo

!---------------------------

  type wfnkqmpiinfo
    integer, pointer ::  nkptotal(:)
    integer, pointer :: isort(:,:)
    integer, pointer :: band_index(:,:)
    real(DP), pointer :: qk(:,:)
    real(DP), pointer :: el(:,:,:)
    SCALAR, pointer :: cg(:,:,:,:)
  end type wfnkqmpiinfo

!---------------------------

  type wfnkmpiinfo
    integer, pointer ::  nkptotal(:)
    integer, pointer :: isort(:,:)
    real(DP), pointer :: qk(:,:)
    real(DP), pointer :: el(:,:,:)
    real(DP), pointer :: elda(:,:,:)
    SCALAR, pointer :: cg(:,:,:)
  end type wfnkmpiinfo

!---------------------------

  type wpgen
    real(DP) :: wpsq(2) !< square of free el plasma freq for each spin
    real(DP) :: nelec(2) !< number of electrons for each spin per cell
    SCALAR, pointer :: rho(:,:) !< density, (ig, ispin)
  end type wpgen

!---------------------------

  type polarizability
    integer :: freq_dep        !< frequency dependence of the inverse dielectric matrix
                               ! 0: static calculation 2: full frequency 3: two imaginary frequencies
    integer :: freq_dep_method !< full frequency calculation. 0: Adler-Wiser; 1: Shishkin and Kresse 2006
    integer :: nFreq           !< number of frequencies used in full frequency calculation
    real(DP) :: dInitFreq      !< initial frequency (eV) for polarizability energy denominator
    real(DP) :: dDeltaFreq     !< frequency increment (eV) for polarizability energy denominator
    real(DP) :: dBrdning       !< Lorentzian broadening (eV) for polarizability energy denominator
    real(DP), pointer :: dFreqGrid(:) !< Grid of Frequencies for Full Frequency 
    real(DP) :: dFreqStepIncrease
    real(DP) :: dFreqCutoff1
    real(DP) :: dFreqCutoff2

    integer :: nSFreq    !< number of frequencies used in spectral function
    real(DP) :: dInitSFreq  !< initial frequency (eV) for polarizability spectral function
    real(DP) :: dDeltaSFreq !< frequency increment (eV) for polarizability spectral function
    real(DP), pointer :: dSFreqGrid(:) !< Grid of Frequencies for spectral function

    real(DP) :: dSFreqStepIncrease
    real(DP) :: dSFreqCutoff1
    real(DP) :: dSFreqCutoff2

    type(scissors_t) :: scis
    logical :: eqp_corrections !< are we using eqp.dat and eqp_q.dat files
    complex(DPC), pointer :: dFreqBrd(:)  !< Corresponding Broadenings for Full Frequency
    integer :: fullConvLog !< logging pol matrix head & tail convergence
    integer :: iwritecoul !< flag to write vcoul
    integer :: nmtx
    integer, pointer :: nmtx_of_q(:)
    integer :: nq0, nq1, nq !< Number of q->0 points, q/=0 points, and total number of q-points
    logical :: subsample !< whether we have more than one q0 point (used in subsampled calculation)
    integer :: gcomm
    logical :: min_fftgrid   !< use the smallest possible fftbox
    ! FHJ: These flags control some experimental optimizations
    integer :: os_opt_ffts       !< optimizes calculation/reuse of FFTs (real-space WFNs)
    integer :: os_para_freqs     !< num. of frequencies to calculate in parallel
    integer :: os_nfreq_para  !< num. of epsilon frequencies held by any processor 
    integer :: os_nsfreq_para !< num. of spectral frequencies held by any processor 
    logical :: os_hdf5           !< use parallel IO?
    logical :: restart        !< are we restarting the calculation? Only ok with HDF5
    integer :: stop_after_qpt !< pretent the calculation was prematurely killed after this qpt (-1=don`t kill)
    integer :: intraband_flag !< 0=regular calculation, 1=only include intraband, 2=only interband
    real(DP) :: intraband_overlap_min !< a transition is intraband if |<uvk|uvk+q>| is larger than this
    logical :: patched_sampling !< Do we have only a patch in the BZ?
    !
    integer :: WFN_FFTgrid(3)!< max. size FFTgrid that holds all WFNs
    integer :: FFTgrid(3)    !< FFT grid to use (RHO or economical one)
    !!
    integer :: iwriteint            !< = 0 for comm_disk, = 1 for comm_mpi
    logical :: skip_epsilon
    logical :: skip_chi
    logical :: use_hdf5      !< with -DHDF5, whether or not we actually use hdf5
    logical :: need_WFNq     !< will we need the WFNq file? (nq0>0.and.valueq0==1.and.iqexactlyzero==0)
    integer :: iqexactlyzero !< 1 if the q->0 point is *exactly* zero and will be read from WFN; 0 otherwise
    integer :: valueq0       !< 1=semiconductor (read from WFNq); 2=metal (read from WFN)
    integer, pointer :: irow(:)
    integer, pointer :: isrtx(:)
    integer, pointer :: isrtxi(:)
    integer :: icutv               !< icutv encodes presence and type of truncation
    real(DP) :: truncval(3)   !< in Bohr (au)
    real(DP), pointer :: eden(:,:,:)
    real(DP), pointer :: qpt(:,:)
    !> FHJ: gme = <c,k|e^(-i(q+G).r)|v,k+q>, and the indices are:
    !! (nmtx, ncownactual, nvownactual, nspin, nrk, os_para_freqs)
    SCALAR, pointer :: gme(:,:,:,:,:,:)
    SCALAR, pointer :: chi(:,:,:)
    integer :: ncrit
    real(DP) :: efermi
    real(DP) :: efermi_input
    logical :: rfermi
    real(DP) :: ecuts    !< energy cutoff of screened coulomb interaction in Ry
    real(DP) :: ecutsExtra
!> Reference regarding retarded/advanced functions: Catalin`s thesis, Eq. (1.44)
    complex(DPC), pointer :: chiRDyn(:,:,:,:) !< Retarded polarizability
    complex(DPC), pointer :: chiADyn(:,:,:,:) !< Advanced polarizability
    complex(DPC), pointer :: chiTDyn(:,:,:,:) !< Spectral function of polarizability

    real(DP), pointer :: edenDyn(:,:,:,:,:) !< Dynamic energy denominator
    logical :: freplacebz
    logical :: fwritebz
    logical :: degeneracy_check_override
    real(DP) :: lin_denominator !< energy threshold below which to activate lin_denominator
    type(cvpair_info), pointer :: lin_edenDyn(:,:,:,:,:) !< energies and
    ! velocities for calculating linearized denominator in dynamic case
  end type polarizability


!--------------------------------

  type cvpair_info
    real(DP) :: vc(2) !< conduction band velocity
    real(DP) :: vv(2) !< valence band velocity
    real(DP) :: ec !< conduction band energy
    real(DP) :: ev !< valence band energy
    integer :: idx_kp !< kpoint index
    logical :: vltc !< ev - ec < TOL_Degeneracy
  end type cvpair_info

!--------------------------------

  type wfnkstates
    integer :: nkpt
    integer :: ndv
    integer, pointer :: isrtk(:)
    real(DP) :: k(3)
    real(DP), pointer :: ek(:,:)
    real(DP), pointer :: elda(:,:)
    SCALAR, pointer :: zk(:,:)
  end type wfnkstates

!---------------------------

  type wfnkqstates
    integer :: nkpt
    integer, pointer :: isrtkq(:)
    real(DP), pointer :: ekq(:,:)
    SCALAR, pointer :: zkq(:,:)
  end type wfnkqstates

!---------------------------------

!> Used in haydock/diag only (see epsdiag.f90)
  type epsinfo
    integer :: nq !< number of q-vectors stored
    real(DP) :: emax !< maximum length of the stored q-vectors
    real(DP), pointer :: q(:,:) !< (3, nq) coordinates of q-vectors
    real(DP), pointer :: eps(:) !< (nq) head of dielectric matrix at each q-vector
    SCALAR :: epshead !< head of dielectric matrix at q->0
    real(DP) :: q0vec(3) !< coordinates of the q->0 vector
  end type epsinfo

!------------------------------------

!> Used in haydock/diag only
!! Note that the bands in eqpv/eqpc are indexed with respect to the Fermi
!! level, i.e., eqpv(1,:,:) is the VBM, eqpv(2,:,:) is VMB-1, etc.
  type eqpinfo
    type(scissors_t) :: scis
    type(spline_tck) :: spl_tck       !< scissors spline coefficients
    real(DP), pointer :: evqp(:,:,:)
    real(DP), pointer :: ecqp(:,:,:)
    real(DP), pointer :: evqp_co(:,:,:)
    real(DP), pointer :: ecqp_co(:,:,:)
    real(DP), pointer :: evlda(:,:,:)
    real(DP), pointer :: eclda(:,:,:)
    real(DP), pointer :: evlda_co(:,:,:)
    real(DP), pointer :: eclda_co(:,:,:)
    real(DP), pointer :: evshift(:,:,:)
    real(DP), pointer :: ecshift(:,:,:)
    real(DP), pointer :: evshift_co(:,:,:)
    real(DP), pointer :: ecshift_co(:,:,:)
  end type eqpinfo

!------------------------------------

!> moments for Haydock
  type mmtsinfo
    integer :: nmax
    integer :: nmaxp
    real(DP) :: norm
    real(DP) :: vol
    real(DP), pointer :: an(:)
    real(DP), pointer :: bn(:)
  end type mmtsinfo
  
!------------------------------------

  type xctinfo
    logical :: is_absorption         !< whether we are running the absorption code
    logical :: inteqp                !< whether we are interpolating
    logical :: is_periodic(3)        !< which dimensions are periodic
    integer :: idimensions           !< how many total periodic dimensions
    integer :: nkpt_co               !< number of kpts in the coarse grid
    integer :: nkptq_co              !< number of kpts in the q-shifted coarse grid
    integer :: nvb_co                !< number of valence bands in the coarse grid
    integer :: ncb_co                !< number of conduction bands in the coarse grid
    integer :: n1b_co                !< nvb_co for TDA calculations, nvb_co + ncb_co for non-TDA
    integer :: n2b_co                !< ncb_co for TDA calculations, nvb_co + ncb_co for non-TDA
    integer :: nspin
    integer :: qflag                 !< =0 for finite Q calculation with arbitrary Q (deprecated)
                                     !< =1 for Q=0 calculation (default)
                                     !< =2 use Q commensurate with WFN_co kgrid (under construction)
    logical :: read_kpoints
    integer :: ipar
    integer :: iscreen !< what type of screening is present. 0 = semiconductor, 1 = graphene, 2 = metal
    logical :: renorm_transf         !< renormalize the dcc/dvv interpolation transformation?
    !> Calculate kernel blocks other than (vc)->(v'c') transitions? This will 
    !! even include transitions such as (e,e)->(e',e'). In principle, we should
    !! always include these blocks if we are interpolating later on, but they
    !! are typically not important for semiconductors within TDA.
    logical :: extended_kernel
    !> If true, we extend the co/fi transf. to WFNs of different characters:
    !! |v> = \sum_n` d_vn`|n`>, where |n`> can be |v`> or |c`>
    !! If false, we restrict the character of the expansion coefficients:
    !! |v> = \sum_v` d_vv`|v`>
    logical :: unrestricted_transf
    !> Zero out dvc/dcv coefficients
    logical :: zero_unrestricted_contrib
    logical :: patched_sampling      !< simplest case of non-uniform sampling. See absorption.inp.
    logical :: patched_sampling_co   !< Use non-uniform sampling for coarse grid for Kernel. See absorption.inp.
    integer :: zero_q0_element       !< Zero q=0 matrix element of BSE Hamiltonian? See absorption.inp
    logical :: tda                   !< use Tamm-Dancoff approximation? (Absorption only)
    integer :: iabsorp0              !< 1 means noeh_only, 0 otherwise
    integer :: iwriteint             !< = 0 for comm_disk, = 1 for comm_mpi
    logical :: eqp_corrections       !< do we use eqp.dat and eqp_q.dat
    logical :: eqp_co_corrections    !< do we use eqp_co.dat
    
!> For Coulomb interaction truncation
    integer :: iwritecoul
    integer :: icutv              !< icutv encodes presence and type of truncation
    real(DP) :: truncval(3)       !< in Bohr (au)
    integer :: nint               !< number of intervals used in
                                  !! double integral truncated_factor
    logical :: use_hdf5       !< with -DHDF5, whether or not we actually use hdf5
    logical :: bLowComm       !< If this is true, each processor will store the entire epsilon matrix
    logical :: delaunay_interp!< use Delaunay interpolation?
    integer :: neps           !< Number of G vectors to capture the dielectric cutoff
    integer :: ilowmem
    logical :: skipinterp
    integer :: ivpar, icpar
    integer :: nn             !< PlotXct restrict_kpoints
    integer :: ng
    integer :: nktotal        !< total number of unit cells
    !> Number of vertices in co k-grid that are used to expand each k-point in
    !! the fine grid for the **kernel** interpolation. This is 1 for the
    !! greedy interpolation (previous behaviour of the code), and ndims+1
    !! if we are performing Delaunay interpolation.
    integer :: npts_intp_kernel
    real(DP) :: eta           !< energy resolution
    real(DP) :: sigma         !< (used to calculate the optical spectrum)
    real(DP) :: gamma         !< (used to calculate the optical spectrum)
    real(DP) :: qshift
    real(DP) :: shift(3)      !< shift vector (this is the small shift,
                              !< used to generate WFNq_fi, referenced only if xct%read_kpoints)
    real(DP) :: finiteq(3)    !< center-of-mass momentum of exciton
    real(DP) :: lpol          !< norm of pol
    real(DP) :: pol(3)        !< light polarization for transition matrix elements
    integer :: nmtxmax        !< max. number of columns in epsmat or eps0mat
    integer :: maxpet         !< max. number of eps columns a PE can have
    integer :: theory         !< theory level in kernel calculation
                              !< 0 - GW-BSE, 1 - TDDFT
    integer :: qgrid(3)
    real(DP) :: q0vec(3)      ! This is a hack for passing q0vec for
                              ! TDDFT calculations (never used otherwise)
                              ! when there is no epsilon
    type(coulomb_modifier_t) :: coulomb_mod 
    logical :: coul_mod_flag   !< Flag which tells if the coulomb interaction has been 
                               !< modified (for TDDFT calculations)
    !> (nmtxmax): for all PEs, a global eps column igp gets mapped the local
    !! column igp_l = epsown(igp)
    integer, pointer :: epsown(:)
    !> (maxpet, npes): local eps column igp_l owned by processor ipe
    !! corresponds to the global column index ig = epsowni(igp_l, ipe)
    integer, pointer :: epsowni(:,:)
    !> (npes): number of eps cols each processor owns
    integer, pointer :: maxpe(:)
    integer, pointer :: indexq(:), isrtqi(:,:), nmtxa(:)
    integer, pointer :: ifmax(:,:), ifmaxq(:,:)
    real(DP) :: ecute         !< energy cutoff used in dielectric matrix
    real(DP) :: scaling       !< multiply kernel by arbitrary factor
    real(DP) :: ecutg         !< energy cutoff used in wavefunctions and interaction
                              !< kernel, see Rohlfing & Louie, PRB 62(8),p. 4938
                              !< (must be slightly longer than xct%ecute because of umklapp vectors)
    real(DP) :: efermi        !< computed efermi
    real(DP) :: efermi_input  !< as set in input file
    logical :: rfermi         !< relative or absolute Fermi level
    SCALAR, pointer :: epsdiag(:,:) !< (nmtxmax, nq+1)
    !> Regular comm: (nmtxmax, maxpet, nq+1). The local processor stores row ig
    !! and a "local column" igp_l from epsilon in epscol(ig, igp_l, ik).
    !! Low comm: (nmtxmax, nmtxmax, nq+1). Each processor stores all eps(0)mat.
    !! local column = global epsilon column.
    SCALAR, pointer :: epscol(:,:,:)
    type (wpgen) :: wpg !< charge density/fxc for TDDFT

!> Used in haydock/diag only
    integer :: nkpt_fi         !< number of kpts in the fine grid
    integer :: nkptq_fi        !< number of kpts in the q-shifted fine grid
    integer :: nvb_fi          !< number of valence bands in the fine grid
    integer :: ncb_fi          !< number of conduction bands in the fine grid
    real(DP) :: avgcut         !< Cut in which we do cell averages on
    real(DP) :: wplasmon
    SCALAR :: wcoul0
    integer :: vmin,vmax
    integer :: rgrid(3) !< regular grid used to calculate qpt_averages (default is kgrid)
    logical :: freplacebz
    logical :: fwritebz
    logical :: degeneracy_check_override
    logical :: die_outside_sphere
    logical :: averagew
    logical :: subsample_line    !< during kernel interpolation, replace interpolated matrix
                                 !< elements with matrix elements from a precalculated bsemat file
                                 !< on a subsampled grid
    real(DP) :: subsample_cutoff !< use subsampled BSE matrix elements when |q| is less than cutoff
  end type xctinfo

!------------------------------------

  type flags

!>
!> Used in haydock, diag, nonlinearoptics
!>
!> Defined flags:
!>
!>  bz0  = 0 --> use symmetries to unfold the Brillouin zone in WFN_fi file
!>         1 --> do not unfold the BZ in WFN_fi file (default)
!>  bzq  = 0 --> use symmetries to unfold the BZ in WFNq_fi file
!>         1 --> do not unfold the BZ in WFNq_fi file (default)
!>  bzc  = 0 --> use symmetries to unfold the BZ in WFN_co file
!>         1 --> do not unfold the BZ in WFN_co file (default)
!>
!>  read_dtmat = false --> calculate dcc,dvv matrices (default)
!>               true  --> take dcc,dvv matrices from file dtmat
!>
!>  eig = 0  --> do not write eigenvectors (default)
!>      < 0 --> write all eigenvectors
!>      > 0 --> write the first flag%eig eigenvectors
!>
!>  read_epsdiag = false --> read files 'eps0mat'/'epsmat' (default)
!>                 true  --> read file 'epsdiag.dat'
!>
!>  krnl = 0 --> spin triplet kernel, direct kernel only (only allow for nspin = 1)
!>         1 --> spin singlet kernel (default)
!>         2 --> local-fields + RPA, exchange kernel only
!>
!>  opr = 0 --> use velocity operator
!>        1 --> use momentum operator
!>        2 --> use JDOS operator (Haydock only)
!>
!>  lor = 0 --> use Lorentzian broadening
!>        1 --> use Gaussian broadening
!>        2 --> use Voigt broadening
!>
!>  spec = 0 --> go through the whole exciton calculation (default)
!>         1 --> calculate only absorption spectrum (this option skips
!>               all calculation and goes right to the end of the code)
!>
!>  vm = 0 --> calculate velocity/momentum matrix elements (default)
!>       1 --> read velocity/momentum matrix elements from file vmtxel
!>       2 --> use vectors from previous iteration (Haydock only!)
!>
!>  job = 0 --> ultrafast calculation
!>  job = 1 --> two-photon calculation
!>

    integer :: bz0
    integer :: lor
    integer :: bzq
    integer :: bzc
    logical :: read_dtmat
    integer :: eig
    logical :: read_epsdiag
    integer :: krnl
    integer :: opr
    integer :: spec
    integer :: vm
    integer :: job
  end type flags

!---------------------------------

  type otherinfo
    integer :: ithreeD
    integer :: knx
    integer :: kny
    integer :: knz
    real(DP) :: keta
  end type otherinfo

!---------------------------------

  type windowinfo
    real(DP) :: evalue
    real(DP) :: emax
    real(DP), pointer :: cstates(:)
    real(DP), pointer :: estates(:)
    integer, pointer :: istates(:)
    integer :: nstates
  end type windowinfo

!-----------------------------
  !> coarse-grid wavefunctions for diag/haydock
  type tdistgwf
    
    integer :: ngm !< maximum number of G-vectors
    integer :: ngl !< local number of G-vectors
    integer :: tgl !< local to global translation

!> local to global index translation : ig_g = ig_l + tgl
!> ig_g = 1 ... ng(ik) is the global G-index
!> ig_l = 1 ... ngl is the local G-index

    integer :: nk !< number of k-points
    integer :: ns !< number of spin components
    integer :: nspinor = 1 !< nspinor = 2 if doing two-component spinor calculation; 1 is default
    integer :: nv !< number of valence bands
    integer :: nc !< number of conduction bands

    integer, pointer :: ng(:) !< (nk)
    integer, pointer :: isort(:,:) !< (ngl,nk)
    SCALAR, pointer :: zv(:,:,:,:) !< (ngl,nv,ns*nspinor,nk) 
    SCALAR, pointer :: zc(:,:,:,:) !< (ngl,nc,ns*nspinor,nk)

  end type tdistgwf

!-----------------------------
!> MJ: work arrays - getting rid of save statements

  type work_genwf
    integer :: ikold = 0
    integer :: ikoldq = 0
    integer :: nb
    integer :: ng
    integer :: ns
    integer :: nspinor = 1 !< nspinor = 2 if doing two-component spinor calculation; 1 is default
    SCALAR, pointer :: cg(:,:,:)
    SCALAR, pointer :: ph(:)
    integer, pointer :: ind(:)
    integer, pointer :: isort(:)
  end type work_genwf

!-----------------------------
!> (gsm) work arrays - getting rid of save statements

  type twork_scell
    integer :: dNfft(3)
    integer :: Nplane
    integer :: Nrod
    complex(DPC), pointer :: fftbox_1D(:,:)
  end type twork_scell

  !> FHJ: mean-field header
  type mf_header_t
    integer :: version
    character(len=3) :: sheader
    character(len=32) :: sdate
    character(len=32) :: stime
    integer :: iflavor
    type(crystal) :: crys
    type(kpoints) :: kp
    type(symmetry) :: syms
    type(gspace):: gvec
  end type mf_header_t

  !> FHJ: header information for kernel files (bsedmat, bsexmat, bsemat.h5)
  type kernel_header_t

    ! Mean-field and other general information 
    type(mf_header_t) :: mf !< mf header containing number of k-points, WFN cutoff, etc.
    integer :: iscreen !< screening flag
    integer :: icutv   !< truncation flag
    real(DP) :: ecute  !< epsilon cutoff

    ! Variables specific to kernel files
    integer :: nk      !< number of k-points 
    real(DP), pointer :: kpt(:,:)
    integer :: ns      !< number of spins
    integer :: nspinor = 1 !< nspinor = 2 if doing two-component spinor calculation; 1 is default
    integer :: nvb     !< number of valence bands in the coarse grid
    integer :: ncb     !< number of conduction bands in the coarse grid
    integer :: n1b     !< nvb_co if kernel_sz==1; nvb_co + ncb_co if kernel_sz=4
    integer :: n2b     !< ncb_co if kernel_sz==1; nvb_co + ncb_co if kernel_sz=4
    integer :: theory  !< 0 for GW-BSE, 1 for TD-HF, 2 for TD-DFT
    integer :: nmat    !< number of matrices in the file (1 for bsexmat, 3 for bsedmat)
    integer :: storage !< 0 if storing full matrix (only option supported now)
    !> How many transitions blocks are there in the kernel matrix?
    !! 1 for restricted TDA kernel: vc -> v`c`
    !! 2 for restricted non-TDA kernel: {vc,cv} -> {v`c`,c`v`}  [not implemented]
    !! 4 for extended kernel: {n1,n2} -> {n1`,n2`}
    integer :: nblocks

  end type kernel_header_t

end module typedefs_m

#include "f_defs.h"

module input_common_m

  use global_m
  use wfn_rho_vxc_io_m
  use misc_m
  implicit none

  private

  !> the input reader `object`
  type input_reader_t
    character(len=7) :: fname !< WFN_fi or WFNq_fi
    logical :: is_cond   !< .true. if using WFN_fi, .false. if WFNq_fi
    integer :: iunit     !< unit corresponding to the WFN file
    integer :: iunit_xct !< unit corresponding to the INT* file
    integer :: nk        !< number of k-points in the WFN file
    integer :: ng        !< number of g vectors in the current k-point
    integer :: nb_wfn    !< number of bands in the WFN file
    integer :: nv_wfn    !< number of valence bands in the WFN file
    integer :: nv_xct    !< number of valence bands in the XCT file
    integer :: nc_xct    !< number of conduction bands in the XCT file
    integer :: ns        !< number of spin components
    integer :: nspinor = 1  !< number of spinor components
    integer :: gvec_ng
    logical, pointer :: send_to(:)
    integer, pointer :: isort(:)
  end type input_reader_t

  public :: input_reader_t, init_reader, free_reader, skip_kpt, read_gvecs, read_bands

contains

  !> Initialize the input reader `object`
  subroutine init_reader(inp, iunit, iunit_xct, fname, kpts, xct, gvec)
    type (input_reader_t), intent(out) :: inp !< the input reader `object`
    integer, intent(in) :: iunit              !< unit of the WFN file
    integer, intent(in) :: iunit_xct          !< unit of the WFN file
    character(len=*), intent(in) :: fname     !< WFN file name
    type (kpoints), intent(in) :: kpts        !< kp/kpq
    type (xctinfo), intent(in) :: xct
    type (gspace), intent(in) :: gvec

    PUSH_SUB(init_reader)

    inp%iunit = iunit
    inp%fname = fname
    inp%is_cond = fname=='WFN_fi'
    inp%iunit_xct = iunit_xct
    inp%nk = kpts%nrk
    inp%nb_wfn = kpts%mnband
    inp%nv_wfn = kpts%nvband
    inp%nv_xct = xct%nvb_fi
    inp%nc_xct = xct%ncb_fi
    inp%ns = kpts%nspin
    inp%nspinor = kpts%nspinor
    inp%gvec_ng = gvec%ng
    SAFE_ALLOCATE(inp%isort, (gvec%ng))
    SAFE_ALLOCATE(inp%send_to, (peinf%npes))
    inp%isort(:) = 0

    POP_SUB(init_reader)

  end subroutine init_reader

  !> Deallocates buffers from input reader `object`
  subroutine free_reader(inp)
    type (input_reader_t), intent(inout) :: inp !< the input reader `object`

    PUSH_SUB(free_reader)

    SAFE_DEALLOCATE_P(inp%isort)
    SAFE_DEALLOCATE_P(inp%send_to)

    POP_SUB(free_reader)

  end subroutine free_reader


  !> Skip the WFNs of the current k-point.
  subroutine skip_kpt(inp)
    type (input_reader_t), intent(in) :: inp !< the input reader `object`

    integer, allocatable :: gvecs_comp(:,:)
    SCALAR, allocatable :: cg(:,:)
    integer :: ib

    PUSH_SUB(skip_kpt)

    SAFE_ALLOCATE(gvecs_comp, (3, inp%ng))
    call read_binary_gvectors(inp%iunit, inp%ng, inp%ng, gvecs_comp, dont_read=.true.)
    SAFE_DEALLOCATE(gvecs_comp)
    SAFE_ALLOCATE(cg, (inp%ng, inp%ns*inp%nspinor))
    do ib=1,inp%nb_wfn
      call read_binary_data(inp%iunit, inp%ng, inp%ng, inp%ns*inp%nspinor, cg, dont_read=.true.)
    enddo
    SAFE_DEALLOCATE(cg)

    POP_SUB(skip_kpt)

  end subroutine skip_kpt

  !> Read all gvectors for the current k-point.
  subroutine read_gvecs(inp, ik, gvec)
    type (input_reader_t), intent(inout) :: inp !< the input reader `object`
    integer, intent(in) :: ik    !< kpt in question

    type (gspace), intent(in) :: gvec
    integer, allocatable :: gvecs_comp(:,:)
    integer :: ipe, ig
    logical :: should_write

    PUSH_SUB(read_gvecs)

    should_write = inp%send_to(peinf%inode+1)
    ! FHJ: Idle nodes can leave the function
    if (.not. (peinf%inode==0 .or. should_write)) then 
      POP_SUB(read_gvecs)
      return
    endif

    ! FHJ: If we need the kpt, read gvector indices.
    ! Note: we don`t bcast, and only the receiving nodes call findvector
    SAFE_ALLOCATE(gvecs_comp, (3, inp%ng))
    call read_binary_gvectors(inp%iunit, inp%ng, inp%ng, gvecs_comp, bcast=.false.)
#ifdef MPI
    if (peinf%inode==0) then
      do ipe=2,peinf%npes !FHJ: root already has the data!
        if (inp%send_to(ipe)) then
          call MPI_Send(gvecs_comp, 3*inp%ng, MPI_INTEGER, ipe-1, ik, MPI_COMM_WORLD, mpierr)
        endif
      enddo
    else 
      call MPI_Recv(gvecs_comp, 3*inp%ng, MPI_INTEGER, &
        0, ik, MPI_COMM_WORLD, MPI_STATUS_IGNORE, mpierr)
    endif
#endif
    if (should_write) then
      do ig = 1, inp%ng
        call findvector(inp%isort(ig), gvecs_comp(:, ig), gvec)
        if(inp%isort(ig) == 0) call die('could not find gvec')
      enddo
    endif
    SAFE_DEALLOCATE(gvecs_comp)

    POP_SUB(read_gvecs)

  end subroutine read_gvecs

  !> Read all WFNs the current k-point.
  subroutine read_bands(inp, ik)
    type (input_reader_t), intent(inout) :: inp !< the input reader `object`
    integer, intent(in) :: ik    !< kpt in question

    SCALAR, allocatable :: cg_xct(:,:,:)
    SCALAR :: cg_dummy(1,1)
    integer :: ipe, ig, ib_wfn, ib_xct, ib_xct_max, is, tag
    logical :: should_write
    logical :: cond

    PUSH_SUB(read_bands)

    should_write = inp%send_to(peinf%inode+1)
    ! FHJ: Idle nodes can leave the function
    if (.not. (peinf%inode==0 .or. should_write)) then 
      POP_SUB(read_bands)
      return
    endif

    if (inp%is_cond) then !input
      ib_xct_max = inp%nc_xct       
    else !input_q
      ib_xct_max = inp%nv_xct
    endif

    ! FHJ: note that we use a non-default order for the indices of cg_all.
    ! This makes MPI_Sends/Recvs easier
    SAFE_ALLOCATE(cg_xct, (inp%ng,inp%ns*inp%nspinor,ib_xct_max))
    do ib_wfn=1,inp%nb_wfn

      if (inp%is_cond) then !input
        ib_xct = ib_wfn - inp%nv_wfn
      else !input_q
        ib_xct = inp%nv_wfn - ib_wfn + 1
      endif

      cond = (ib_xct > 0) .and. (ib_xct <= ib_xct_max)

      ! If ib_xct is one of the selected bands...
      if (cond) then

        call read_binary_data(inp%iunit, inp%ng, inp%ng, inp%ns*inp%nspinor, &
          cg_xct(:,:,ib_xct), bcast=.false.)

#ifdef MPI
        tag = (ib_wfn-1)*inp%nk + ik
        if (peinf%inode==0) then
          do ipe=2,peinf%npes
            if (inp%send_to(ipe)) then
              call MPI_Send(cg_xct(1,1,ib_xct), inp%ng*inp%ns*inp%nspinor, MPI_SCALAR, &
                ipe-1, tag, MPI_COMM_WORLD, mpierr)
            endif
          enddo
        else
          call MPI_Recv(cg_xct(1,1,ib_xct), inp%ng*inp%ns*inp%nspinor, MPI_SCALAR, &
            0, tag, MPI_COMM_WORLD, MPI_STATUS_IGNORE, mpierr)
        endif
#endif

        if (should_write) &
          call checknorm(inp%fname,ib_wfn,ik,inp%ng,inp%ns,inp%nspinor,cg_xct(:,:,ib_xct))

      else

        ! FHJ: not a selected band => ignore. cg_xct should not be touched!!
        call read_binary_data(inp%iunit, 1, 1, 1, cg_dummy(:,:), dont_read=.true.)

      endif !ib_xct is one of the selected valence band

    enddo

    if (should_write) then
      write(inp%iunit_xct) ik,inp%ng,ib_xct_max,inp%ns,inp%nspinor
      write(inp%iunit_xct) (inp%isort(ig),ig=1,inp%gvec_ng), &
        (((cg_xct(ig,is,ib_xct),ig=1,inp%ng),ib_xct=1,ib_xct_max),is=1,inp%ns*inp%nspinor)
    endif

    SAFE_DEALLOCATE(cg_xct)
    POP_SUB(read_bands)

  end subroutine read_bands

end module input_common_m

!============================================================================
!
! Utilities:
!
! (1) bsebinasc()       Originally By MLT        Last Modified 7/1/2008
!
!     File converter. Converts files "bsedmat","bsexmat","dtmat",
!     "vmtxel","eps2_moments","eigenvectors"
!     from binary to ascii. If a file is unavailable, just skip it.
!
!     input: [filename][ext_in]
!     output: [filename][ext_out]
!
!     Default for ext_in is "".
!
!============================================================================

#include "f_defs.h"

program bsebinasc

  use global_m
  use bse_convert_m
  implicit none

  character*18 :: ext_in,ext_out
  integer :: nargs, err

  nargs = iargc()

  if(nargs == 1) then
    ext_in = ""
    call getarg(1, ext_out)
  else if(nargs == 2) then
    call getarg(1,ext_in)
    call getarg(2,ext_out)
  else
    call die('Usage: bsebinasc [ext_in] ext_out')
  endif
  
!-----------------------------------
! Convert bsedmat

  write(6,*) ' Converting bsedmat',TRUNC(ext_in),' -> bsedmat', TRUNC(ext_out)
  call open_file(10,file='bsedmat'//TRUNC(ext_in),form='unformatted', status='old',iostat=err)
  if (err.ne.0) then
    write(0,*) 'WARNING: could not open bsedmat',TRUNC(ext_in), '. Skipping.'
  else
    call open_file(11,file='bsedmat'//TRUNC(ext_out),form='formatted',status='replace')
    call bsemat_binasc(10, 11)
    call close_file(11)
    call close_file(10)
  endif

!---------------------------------------
! Convert bsexmat

  write(6,*) ' Converting bsexmat',TRUNC(ext_in),' -> bsexmat', TRUNC(ext_out)
  call open_file(20,file='bsexmat'//TRUNC(ext_in),form='unformatted', status='old',iostat=err)
  if (err.ne.0) then
    write(0,*) 'WARNING: could not open bsexmat',TRUNC(ext_in), '. Skipping.'
  else
    call open_file(11,file='bsexmat'//TRUNC(ext_out),form='formatted',status='replace')
    call bsemat_binasc(20, 11)
    call close_file(11)
    call close_file(20)
  endif


!---------------------------------
! Convert dtmat
  
  write(6,*) ' Converting dtmat',TRUNC(ext_in),' -> dtmat', TRUNC(ext_out)
  call open_file(30,file='dtmat'//TRUNC(ext_in),form='unformatted',status='old',iostat=err)
  if (err.ne.0) then
    write(0,*) 'WARNING: could not open dtmat',TRUNC(ext_in), '. Skipping.'
  else
    call open_file(31,file='dtmat'//TRUNC(ext_out),form='formatted',status='replace')
    call dtmat_binasc(30, 31)
    call close_file(31) 
    call close_file(30)
  endif

!----------------------------------
! Convert vmtxel

  write(6,*) ' Converting vmtxel',TRUNC(ext_in),' -> vmtxel', TRUNC(ext_out)
  call open_file(40,file='vmtxel'//TRUNC(ext_in),form='unformatted',status='old',iostat=err)
  if (err.ne.0) then
    write(0,*) 'WARNING: could not open vmtxel',TRUNC(ext_in), '. Skipping.'
  else
    call open_file(41,file='vmtxel'//TRUNC(ext_out),form='formatted',status='replace')
    call vmtxel_binasc(40, 41)
    call close_file(40)
    call close_file(41)
  endif

!----------------------------------
! Convert eps2_moments

  write(6,*) ' Converting eps2_moments',TRUNC(ext_in), ' -> eps2_moments',TRUNC(ext_out)
  call open_file(50,file='eps2_moments'//TRUNC(ext_in),form='unformatted', status='old',iostat=err)
  if (err.ne.0) then
    write(0,*) 'WARNING: could not open eps2_moments',TRUNC(ext_in), '. Skipping.'
  else
    call open_file(51,file='eps2_moments'//TRUNC(ext_out),form='formatted',status='replace')
    call eps2_moments_binasc(50, 51)
    call close_file(50)
    call close_file(51)
  endif
  
!-----------------------------
! Convert eigenvectors
  
  write(6,*) ' Converting eigenvectors',TRUNC(ext_in),' -> eigenvectors',TRUNC(ext_out)
  call open_file(60,file='eigenvectors'//TRUNC(ext_in),form='unformatted',status='old',iostat=err)
  if (err.ne.0) then
    write(0,*) 'WARNING: could not open eigenvectors',TRUNC(ext_in),'. Skipping.'
  else
    call open_file(61,file='eigenvectors'//TRUNC(ext_out),form='formatted',status='replace')
    call eigenvectors_binasc(60, 61)
    call close_file(60)
    call close_file(61)
  endif
  
  write(6,*) ' Done '
    
end program bsebinasc

!===================================================================
!
! Modules:
!
! 1. message_m      Originally By DAS
!
!    die routine "gracefully" kills the computation.
!    alloc_check writes warnings and errors for memory allocation problems.
!    write_memory_usage provides a memory report at the end of a run.
!    open_file opens a file unit, and writes an error if it does not work.
!
!===================================================================

#include "f_defs.h"

module message_m

  use nrtype_m
  use peinfo_m

  implicit none

  private

  public ::              &
    die,                 &
    alloc_check,         &
    write_memory_usage,  &
    open_file,           &
    close_file

  !> these names are as short as practical to avoid lines being too long
  integer, public :: alc  !< allocation status for safe(de)allocate
  INTSIZEOF, public :: sz !< size returned from sizeof for safe(de)allocate
  !> set to .true. to print array size in bytes, .false. in KB/MB/GB
  logical, parameter :: reportsizeexact = .false.

contains

  subroutine die(str, only_root_writes)
    character (len=*), intent(in) :: str
    logical, optional, intent(in) :: only_root_writes

    logical :: should_write, should_write_prefix, is_open

    should_write = .true.
    should_write_prefix = peinf%npes > 1
    if(present(only_root_writes)) then
      if(only_root_writes) then
        should_write = peinf%inode == 0
        should_write_prefix = .false.
      endif
    endif

    ! There is no good reason why unit 6 would not be open, but ifort 11 -O3 will crash on FLUSH(6)
    ! with the message "forrtl: severe (707): FLUSH: Unit 6 is not connected", but inclusion of just
    ! the inquire line is sufficient to avoid the incorrect optimization of this routine. And if we
    ! are going to inquire, we may as well use the result to decide whether to flush.
    inquire(unit = 6, opened = is_open)
    if(is_open) then
      FLUSH(6)
    endif
    ! FHJ: FLUSH is not really reliable because the OS might cache the stdout.
    ! Sleeping for 1s is the best solution I found to make the output clean,
    ! otherwise the error message would show up before regular output.
    MYSLEEP(1)
    ! FHJ: if we are not writing, wait 60s for the root node to get here and
    ! write the error message. If the root doesn`t get here, we all print the
    ! error messsage anyways and die.
    if (.not.should_write) then
      MYSLEEP(60)
    endif
    write(0,*)
    if(should_write_prefix) write(0, '(a, i6, a)', advance='no') "From proc ", peinf%inode, ": "
    write(0, '(2a)') "ERROR: ", TRUNC(str)
    write(0,*)
    FLUSH(0)

    ! skip MPI calls if we are running in serial, this is needed
    ! for calling check_FFT_size from MeanField/EPM/epm2bgw and MeanField/Utilities/wfnreduce
    if (peinf%npes .gt. 1) then
#ifdef MPI
      ! we return error code -1
      call MPI_Abort(MPI_COMM_WORLD, -1, mpierr)
      call MPI_Finalize(mpierr)
#endif
    endif
    ! return an error code so the system knows this run has failed
    ! unfortunately, not all compilers will actually give this error code back to the OS
    stop 999

    return
  end subroutine die


  !---------------------------------------------------------------------------------------------------
  subroutine alloc_check(status, size, name, file, line, flag)
    integer, intent(in) :: status
    !> on some platforms there is a different return value for sizeof if build is 64-bit
    INTSIZEOF, intent(in) :: size
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: file
    integer, intent(in) :: line
    logical, intent(in) :: flag
    
    real(DP) :: sizekb,sizemb,sizegb
    character(len=16) :: prefix
    character(len=32) :: sizestr

    sizekb = dble(size) / dble(1024)
    sizemb = sizekb / dble(1024)
    sizegb = sizemb / dble(1024)
    if (sizekb.le.1.0d1.or.reportsizeexact) then
      write(sizestr,'(i20,1x,"bytes")')size
    elseif (sizemb.le.1.0d1) then
      write(sizestr,'(f20.3,1x,"KB")')sizekb
    elseif (sizegb.le.1.0d1) then
      write(sizestr,'(f20.3,1x,"MB")')sizemb
    else
      write(sizestr,'(f20.3,1x,"GB")')sizegb
    endif
    
    if (flag) then
      prefix = "Allocation"
      peinf%mymem = peinf%mymem + size
      peinf%mymaxmem = max(peinf%mymaxmem, peinf%mymem)
    else
      prefix = "Deallocation"
      peinf%mymem = peinf%mymem - size
    endif

#ifdef VERBOSE
    if(sizemb .gt. 100 .and. peinf%inode .eq. 0) then
      write(0,347) trim(prefix), trim(name), TRUNC(sizestr), &
        trim(file), line
    endif
#endif

    if(size .lt. 0 .and. peinf%inode .eq. 0) then
      write(0,345) trim(prefix), trim(name), TRUNC(sizestr), &
        trim(file), line
    endif

    if(status .eq. 0) return
    
    write(0,346) trim(prefix), trim(name), peinf%inode, &
      trim(file), line
    write(0,348) status, TRUNC(sizestr)
    FLUSH(0)

    call die('Allocation failure.')
        
345 format(1x,"WARNING:",1x,a,1x,"of array",1x,a,1x, &
      "of size",1x,a,/,3x,"in file",1x,a,1x,"at line",i5, &
      1x,"may fail.",/)
346 format(1x,"ERROR:",1x,a,1x,"of array",1x,a,1x, &
      "on processor",i5,/,3x,"in file",1x,a,1x, &
      "at line",i5,1x,"failed.")
347 format(1x,"NOTICE:",1x,a,1x,"of array",1x,a,1x, &
      "of size",1x,a,/,3x,"in file",1x,a,1x,"at line",i5, &
      1x,"occurring.",/)
348 format(3x,"Allocation status =",i4,",",1x,"Array size =",1x,a)
    
  end subroutine alloc_check


  !---------------------------------------------------------------------------------------------------
  subroutine write_memory_usage()

    ! the memory is not tracked if not in debug mode, so everything would just be zero
#ifdef DEBUG

    integer :: iunit = 6
#ifdef MPI
    real(DP) :: mymemarray(2), maxmemarray(2), mymemresult(2), maxresult(2), minresult(2)
#endif

    if(peinf%inode == 0) write(iunit,'(/a)') '==== Memory Usage ===='

#ifdef MPI
    mymemarray(1) = peinf%mymem
    mymemarray(2) = peinf%inode
    call MPI_Reduce(mymemarray, mymemresult, 1, MPI_2DOUBLE_PRECISION, MPI_MAXLOC, 0, MPI_COMM_WORLD, mpierr)

    maxmemarray(1) = peinf%mymaxmem
    maxmemarray(2) = peinf%inode
    call MPI_Reduce(maxmemarray, maxresult, 1, MPI_2DOUBLE_PRECISION, MPI_MAXLOC,  0, MPI_COMM_WORLD, mpierr)
    call MPI_Reduce(maxmemarray, minresult, 1, MPI_2DOUBLE_PRECISION, MPI_MINLOC,  0, MPI_COMM_WORLD, mpierr)

    if(peinf%inode == 0) then
      write(iunit,'(a,f14.4,a,i6)') 'Maximum memory currently allocated (MB): ', &
        mymemresult(1) / (1024d0)**2, ' on processor ', nint(mymemresult(2))
      write(iunit,'(a,f14.4,a,i6)') 'Maximum memory high-water-mark     (MB): ', &
        maxresult(1)   / (1024d0)**2, ' on processor ', nint(maxresult(2))
      write(iunit,'(a,f14.4,a,i6)') 'Minimum memory high-water-mark     (MB): ', &
        minresult(1)   / (1024d0)**2, ' on processor ', nint(minresult(2))
    endif
#else
    write(iunit,'(a,f14.4)') 'Currently allocated    (MB): ', peinf%mymem    / (1024d0)**2
    write(iunit,'(a,f14.4)') 'Memory high-water-mark (MB): ', peinf%mymaxmem / (1024d0)**2
#endif

#endif

    return
  end subroutine write_memory_usage

  !---------------------------------------------------------------------------------------------------
  !> This is a wrapper to the Fortran 'open' statement, to provide clear error-handling.
  !> arguments 'status', 'form', 'position' have the same meaning as for 'open'.
  !> 'iostat', if provided, will make 'iostat' be passed to 'open', and return its value, rather
  !> than writing a message, if there is an error (e.g. status='old' but file does not exist, or
  !> status='new' but file does exist).
  subroutine open_file(unit, file, status, form, position, iostat)
    integer,          intent(in) :: unit
    character(len=*), intent(in) :: file
    character(len=*), intent(in) :: status
    character(len=*), optional, intent(in) :: form
    character(len=*), optional, intent(in) :: position
    integer, optional, intent(out) :: iostat

    integer :: ierr, unit_other
    character*80 :: form_, position_, name, unit_str, unit_other_str
    character*200 :: string
    logical :: is_open, does_exist

    if(unit == 0) call die("You may not open unit 0, it is reserved for standard error.")
    if(unit == 5) call die("You may not open unit 5, it is reserved for standard input.")
    if(unit == 6) call die("You may not open unit 6, it is reserved for standard output.")
    ! Cray Fortran has its own reserved units: http://docs.cray.com/books/S-3695-35/html-S-3695-35/pdollsmg.html
    if(unit == 100) call die("You may not open unit 100, it is reserved for standard input (crayftn).")
    if(unit == 101) call die("You may not open unit 101, it is reserved for standard output (crayftn).")
    if(unit == 102) call die("You may not open unit 102, it is reserved for standard error (crayftn).")

    ! these issues would be caught below too, but we can give more helpful messages than just an error code
    inquire(unit = unit, opened = is_open, name = name)
    if(is_open) then
      write(string,'(3a,i6,3a)') "Cannot open file '", TRUNC(file), "' on unit ", unit, &
        ": unit already open for file '", TRUNC(name), "'."
      call die(string)
    endif

    if((trim(status) == 'old' .or. trim(status) == 'OLD') .and. .not. present(iostat)) then 
      inquire(file = TRUNC(file), exist = does_exist, opened = is_open, number = unit_other)
      if(.not. does_exist) call die("Cannot open file '" // TRUNC(file) // "' for reading: does not exist.")
      if(is_open) then
        write(unit_str,*)       unit
        write(unit_other_str,*) unit_other
        call die("Cannot open file '" // TRUNC(file) // "' for reading on unit " // TRUNC(unit_str) &
          // ": already opened on unit " // TRUNC(unit_other_str) // ".")
      endif

! From the Fortran 95 standard, Section 9.3.4:
! 
!    If a file is already connected to a unit, execution of an OPEN
!    statement on that file and a different unit is not permitted.
! 
! From the Fortran 77 Standard, Section 12.3.2:
! 
!    A unit must not be connected to more than one file at the same time,
!    and a file must not be connected to more than one unit at the same time.

    endif

    if((trim(status) == 'new' .or. trim(status) == 'NEW') .and. .not. present(iostat)) then 
      inquire(file = TRUNC(file), exist = does_exist)
      if(does_exist) call die("Cannot open file '" // TRUNC(file) // "' for writing as 'new': already exists.")
    endif

    form_   = 'formatted'
    if(present(form    )) form_     = form
    position_ = 'asis'
    if(present(position)) position_ = position

    ! passing the optionals to 'open' if not given to this routine does not work!
    open(unit=unit, file = TRUNC(file), form=trim(form_), position=trim(position_), status=trim(status), iostat=ierr)
    if(present(iostat)) then
      iostat = ierr
    else if(ierr /= 0) then
      write(string,'(5a,i4)') "Failed to open file '", TRUNC(file), "' as status ", trim(status), " with error ", ierr
      call die(string)
    endif

    return
  end subroutine open_file

  !---------------------------------------------------------------------------------------------------
  subroutine close_file(unit, delete)
    integer,           intent(in) :: unit
    logical, optional, intent(in) :: delete

    character*80 :: string, status
    logical :: is_open
    integer :: ierr

    if(unit == 0) call die("You may not close unit 0, it is reserved for standard error.")
    if(unit == 5) call die("You may not close unit 5, it is reserved for standard input.")
    if(unit == 6) call die("You may not close unit 6, it is reserved for standard output.")
    ! Cray Fortran has its own reserved units: http://docs.cray.com/books/S-3695-35/html-S-3695-35/pdollsmg.html
    if(unit == 100) call die("You may not close unit 100, it is reserved for standard input (crayftn).")
    if(unit == 101) call die("You may not close unit 101, it is reserved for standard output (crayftn).")
    if(unit == 102) call die("You may not close unit 102, it is reserved for standard error (crayftn).")

    ! these issues would be caught below too, but we can give more helpful messages than just an error code
    inquire(unit = unit, opened = is_open, iostat = ierr)
    if(ierr /= 0) then
      write(string,'(a,i6,a,i4)') "inquire in close_file failed for unit ", unit, " with error ", ierr
      call die(string)
    endif
    if(.not. is_open) then
      write(string,'(a,i6,a)') "Cannot close unit ", unit, ": not open."
      call die(string)
    endif

    status = 'keep'
    if(present(delete)) then
      if(delete) status = 'delete'
    endif

    close(unit=unit, status=trim(status), iostat=ierr)
    if(ierr /= 0) then
      write(string,'(a,i6,a,i4)') "Failed to close unit ", unit, " with error ", ierr
      call die(string)
    endif

    return
  end subroutine close_file

end module message_m

!===============================================================================
!
! Routines:
!
! 1. createpools()        Originally By gsm        Last Modified 06/11/2012 (DWV)
!
!    Create pools of valence bands/diagonal matrix elements for Epsilon/Sigma. Number of pools
!    is chosen to minimize memory in calculation. This is also used in BSE, which has multiple
!    options for what is pooled based on the parameters of the problem.
!
!===============================================================================

#include "f_defs.h"

module createpools_m

  use global_m
  implicit none

  private

  public :: createpools

contains

  !> Create pools of valence bands (for epsilon) or diagonal matrix elements (for sigma). For BSE,
  !! the description starts at `Finally,` below. You will probably still need to reference the 
  !! information above the `Finally,`. The description before `Finally,` is for Sigma and Epsilon.
  !!
  !! Each pool is defined as a group of *valence* bands or diagonal matrix elements.
  !! The behaviour of the code is to minimize the memory requirement.
  !! For epsilon, in a naive algorithm, if we distributed all (v,c) pairs round-robin,
  !! each process could potentially get as many as (Nk*)Nc*Nv/Nproc 
  !! bands, which can be pretty large. The usage of pools tackles this
  !! memory issue. The same holds for sigma, except Nv -> Ndiag, Nc -> Nband, where Ndiag
  !! is the number of diagonal bands for which you are computing sigma (offdiagonal calculations
  !! do not use this routine), and Nband is the number of bands in the CH summation (`summation bands`).
  !! Obviously, (v,c) pairs goes to (diagonal matrix elements,summation bands) pairs in the above description. 
  !! The current algorithm works in two levels (this is for epsilon; for sigma make the replacements
  !! valence bands -> diagonal matrix elements, conduction bands -> summation bands, Nv -> Ndiag):
  !! (1) First, we divide the valence bands into groups (the "pools")
  !! (2) Then, the conduction bands are spread across the MPI processes.
  !!     If the pools don`t have all the same size (i.e., if Nv is not
  !!     divisible by Nproc), then some MPI processes will be idle.
  !! Variable description: formal name first, then actual name in epsilon and sigma in parentheses (epsilon first).
  !! The variable name npq means number of pooled quantity (valence bands or diagonal matrix elements), 
  !! while nsq means number of spread quantity (conduction bands or summation bands), in the sense above. 
  !! If there is better technical language for describing this, feel free to update this description. 
  !! \param npq        num. of pooled quantity (valence bands or diagonal matrix elements)
  !! \param nsq        num. of spread quantity (conduction or summation bands)
  !! \param npes      num. of MPI processes
  !! \param npoolsout num. of (valence band or diagonal matrix element) pools created
  !! \param npqownmaxout  max num. of pool quantity (valence bands or diagonal matrix elements)/MPI process
  !! \param nsqwnmaxout  max num. of spread quantity (conduction or summation bands)/MPI process
  !!
  !! Finally, this routine is also used in BSE, where the pooled quantity and spread quantity depends on the 
  !! parameters of the problem. See BSE/distrib_kernel.f90 . The choices are 1) pooled quantity and spread
  !! quantity = num. valence bands, 2) pooled quantity and spread quantity = num. cond. bands, and 
  !! 3) pooled quantity and spread quantity = num. k-points . The above description changes accordingly. 

  subroutine createpools(npq,nsq,npes,npoolsout,npqownmaxout,nsqownmaxout)

    integer, intent(in) :: npq,nsq,npes 
    integer, intent(out) :: npoolsout,npqownmaxout,nsqownmaxout

    integer :: nmemmin
    integer :: npools,nsqownmax,npqownmax,nmem
    integer :: npes_per_npools

    PUSH_SUB(createpools)

    nmemmin = npq + nsq + 1
    npoolsout = 0
    npqownmaxout = 0
    nsqownmaxout = 0

    ! FHJ: we can`t have more pools than the number of pool quantities or MPI processes
    do npools = 1, min(npq,npes)

      ! FHJ: npqownmax = max num. of pooled quantity per proc. for this number of pools
      npqownmax = (npq + npools - 1) / npools
      
      ! FHJ: nsqownmax = max num. of spread quantity per proc. for this number of pools
      !      For a given pool, we have (npes/npools) MPI processes over which the
      !      pooled quantity is parallelized.
      npes_per_npools = npes/npools
      nsqownmax = (nsq + npes_per_npools - 1) / npes_per_npools

      ! FHJ: Note that both npqownmax and nsqownmax are max. number of the pooled/spread quantity, and for
      !      this reason we round the divisions up. We also round (npes/npools)
      !      down, so we are conservative (and pessimistic) about the resources.

      ! FHJ: Upper bound on the memory required for each proc to store the WFNs
      nmem = npqownmax + nsqownmax
      !ntime = npqownmax * nsqownmax
      
      if (nmem .lt. nmemmin) then
        nmemmin = nmem
        npoolsout = npools
        npqownmaxout = npqownmax
        nsqownmaxout = nsqownmax
      endif
      
    enddo
    
    POP_SUB(createpools)
    
    return

  end subroutine createpools

end module createpools_m

!================================================================================
!
! Routines:
!
! (1) epscopy()  Originally By MLT               Last Modified: 5/5/2008 (JRD)
!
!     This routine reads in epsmat/eps0mat and creates temporary files INT_EPS_*
!     if comm_disk option is on.
!
!     Input: crys,gvec,syms types
!            xct%ecute
!            xct%ecutg
!
!     Output: qg type
!             INT_EPS_* files
!
!================================================================================

#include "f_defs.h"

subroutine epscopy(crys,gvec,syms,qg,xct,q0vec)

  use global_m
  use checkbz_m
  use fullbz_m
  use misc_m
  use epsread_hdf5_m
  implicit none

  type (crystal), intent(in) :: crys
  type (gspace), intent(in) :: gvec
  type (symmetry), intent(in) :: syms
  type (grid), intent(out) :: qg
  type (xctinfo), intent(inout) :: xct
  real(DP), intent(out) :: q0vec(3)

!---------------------------
! From units 10 and 11

  integer :: igamma,nrq0,nrq1,nmtx,ng,ngmax,iowner
  real(DP) :: q0(3),q0t(3,1),qk(3)
  real(DP), allocatable :: q1(:,:),eknq(:)
  SCALAR, allocatable :: epscol(:),tempepsdiag(:,:),eps(:,:)

!---------------------------
! Local stuff

  character :: ajname*6,adate*10
  character :: ajname2*6,adate2*10
  character :: filename*20,tmpstr*100
  character :: tmpfn*16
  integer :: ii,jj,kk,ll,nold,gg(3),ngt,nmtxmax0,nmtxmax1,nmtxt,j,i
  integer :: iout,irq,ijk,qgrid(3),idummy,ig
  real(DP) :: gmax_in,emax,qshift(3)

  integer, allocatable :: nmtx_of_q(:),nmtx0_of_q(:)
  integer, allocatable :: isrtold(:),isrtinvdummy(:),oldg(:,:)
  real(DP), allocatable :: ekold(:)
  logical :: skip_checkbz

  character :: filenameh5*80
  character :: filenameh50*80

  logical :: file_exists

  PUSH_SUB(epscopy)

  qgrid(:)=0
  SAFE_ALLOCATE(eknq, (gvec%ng))

!----------------- Read information for inverse dielectric matrix for q->0 unit10 --

  filenameh5 = 'epsmat.h5'
  filenameh50 = 'eps0mat.h5'

  if(peinf%inode.eq.0) then

#ifdef HDF5
    if(xct%use_hdf5) then

      call read_eps_grid_sizes_hdf5(nold,nrq0,gmax_in,idummy,nmtxmax0,qgrid,filenameh50)
      ng=nold
      xct%nmtxmax = nmtxmax0

! XXX Check sanity below. Make sure nold doesn`t change
! XXX NEED igamma

      INQUIRE(FILE="epsmat.h5", EXIST=file_exists)
      if ( file_exists ) then
        igamma = 0 
      else
        igamma = 1
      endif
      
      if(igamma.eq.0) then
        call read_eps_grid_sizes_hdf5(nold,nrq1,gmax_in,idummy,nmtxmax1,qgrid,filenameh5)
        if (nmtxmax1 .gt. xct%nmtxmax) xct%nmtxmax = nmtxmax1
      else
        nrq1=0
      endif
      
      ngmax=nold

    else
#endif

      call open_file(unit=10,file='eps0mat',form='unformatted',status='old')
      call open_file(unit=11,file='epsmat',form='unformatted',status='old',iostat=igamma)
    
      read(10) 
      read(10) ii
      if (ii.ne.0) call die('epscopy: freq_dep')
      read(10)
      read(10)
      read(10)
      read(10)
      read(10)
      read(10)
      read(10) nold
      read(10) ng, nmtx
      call close_file(10)
      
      xct%nmtxmax = nmtx
      
      if(igamma.eq.0) then
        read(11) 
        read(11) ii
        if (ii.ne.0) call die('epscopy: freq_dep')
        read(11)
        read(11)
        read(11)
        read(11)
        read(11)
        read(11) nrq1
        read(11) nold
        ngmax= 0
        do ii=1,nrq1
          read(11) ngt, nmtxt
          read(11)
          read(11)
          do jj = 1, nmtxt
            read(11)
          enddo
          if (ngt.gt.ngmax) ngmax= ngt
          if (nmtxt.gt.xct%nmtxmax) xct%nmtxmax= nmtxt
        enddo
        call close_file(11)
      else
        nrq1=0
      endif

#ifdef HDF5
    endif
#endif

    if(ng > gvec%ng) then
      write(0,*) 'Read from epsmat ng = ', ng, ' > gvec%ng = ', gvec%ng
      call die("epscopy: read illegal ng from epsmat")
    endif

    SAFE_ALLOCATE(oldg, (3, nold))
    SAFE_ALLOCATE(isrtold, (ng))
    SAFE_ALLOCATE(ekold, (ng))
    
#ifdef HDF5
    if(xct%use_hdf5) then

      ajname='chiGG0'
      adate = 'nodate'

      SAFE_ALLOCATE(nmtx0_of_q,(nrq0))
      call read_eps_qgrid_hdf5(nrq0,q0t,nmtx0_of_q,filenameh50)
      q0(:)=q0t(:,1)

      call read_eps_old_gvecs_hdf5(nold,oldg,filenameh50)

    else
#endif

      call open_file(unit=10,file='eps0mat',form='unformatted',status='old')    
      
      read(10) ajname,adate
      read(10)
      read(10) (qgrid(ii),ii=1,3)
      read(10)
      read(10)
      read(10)
      read(10) gmax_in
      read(10) nrq0,(q0(ii),ii=1,3)
      read(10) nold,(oldg(1:3,ii),ii=1,nold)

#ifdef HDF5
    endif
#endif

    if(nrq0.gt.1) then
      call die("There is more than one q-point in eps0mat.", only_root_writes = .true.)
    endif
    write(6,'(/,1x,a)') 'Epsilon matrix for q->0 read from eps0mat'
    write(6,'(1x,a,i0,2x,a,f12.6)') 'nrq0 = ', nrq0, 'gmax = ', gmax_in
#ifdef VERBOSE
    write(6,*)
    write(6,'(1x,3f10.6)') q0(1:3)
    write(6,*)
#endif
  endif

#ifdef MPI
  call MPI_BCAST(nrq0,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_BCAST(nrq1,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_BCAST(xct%nmtxmax,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_BCAST(igamma,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_BCAST(q0,3,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
#endif
  
  xct%maxpet=xct%nmtxmax/peinf%npes
  if (mod(xct%nmtxmax,peinf%npes) .ne. 0) then
    xct%maxpet=xct%maxpet+1
  endif

  SAFE_ALLOCATE(xct%nmtxa, (nrq1+1))
  if (peinf%inode .eq. 0 .or. xct%bLowComm) then
    SAFE_ALLOCATE(xct%isrtqi, (gvec%ng,nrq1+1))
  endif
  if (xct%iwriteint .eq. 1) then
    if (xct%bLowComm) then
      SAFE_ALLOCATE(xct%epscol, (xct%nmtxmax,xct%nmtxmax,nrq1+1))
    else 
      SAFE_ALLOCATE(xct%epscol, (xct%nmtxmax,xct%maxpet,nrq1+1))
    endif
    SAFE_ALLOCATE(xct%epsown, (xct%nmtxmax))
    SAFE_ALLOCATE(xct%epsowni, (xct%maxpet,peinf%npes))
  endif
  SAFE_ALLOCATE(xct%maxpe, (peinf%npes))
  
  xct%maxpe=0
  if (xct%iwriteint .eq. 0) then
    xct%maxpe(1) = xct%nmtxmax
  else
    do jj = 1, xct%nmtxmax
      xct%epsown(jj)=(jj/peinf%npes)
      if (mod(jj,peinf%npes).ne.0) xct%epsown(jj) = xct%epsown(jj) +1
      iowner=mod(jj,peinf%npes)
      xct%epsowni(xct%epsown(jj),iowner+1)=jj
      if (xct%maxpe(iowner+1) .lt. xct%epsown(jj)) xct%maxpe(iowner+1) = xct%epsown(jj)
    enddo
  endif  

  SAFE_ALLOCATE(xct%epsdiag, (xct%nmtxmax,nrq1+1))

! Read q->0 dielectric matrix

  if(peinf%inode.eq.0) then

#ifdef HDF5
    if(xct%use_hdf5) then

      SAFE_ALLOCATE(isrtinvdummy, (ng))
      call read_eps_gvecsofq_hdf5(ng,isrtold,isrtinvdummy,ekold,1,filenameh50)
      SAFE_DEALLOCATE(isrtinvdummy)
      nmtx = nmtx0_of_q(1)
      qk = q0

    else
#endif

      read(10) ng,nmtx,(isrtold(ii),jj,ii=1,ng)
      read(10) (ekold(ii),ii=1,ng)
      read(10) (qk(ii),ii=1,3)

#ifdef HDF5
    endif
#endif

    xct%isrtqi(:,1)= 0

!---------------------
! Sort the eps. matrix elements according to gvec%.
! Emax is some large energy, bigger than xct%ecute (but it does not
! need to be as large as the ekmax used to write epsmat/eps0mat).
! Check if the value of emax is OK.

    emax=xct%ecutg

    do ii=1,ng
      if (ekold(isrtold(ii)).lt.emax) then
        gg(1:3)=oldg(1:3, isrtold(ii))
        call findvector(iout,gg,gvec)
        if (iout.gt.gvec%ng) call die('epscopy: iout > ng')
        if (iout.le.0) call die('epscopy: iout <= 0')

!--------------------------------
! isrtqi has the sorting of G-vectors from eps to gvec%components

        if (peinf%inode .eq. 0) then
          xct%isrtqi(iout,1)=ii
        endif
      endif
    enddo
    SAFE_DEALLOCATE(isrtold)
    SAFE_DEALLOCATE(ekold)
    SAFE_DEALLOCATE(oldg)
  endif

#ifdef VERBOSE
  if (peinf%inode .eq. 0) write(6,*) ' '
  if (peinf%inode .eq. 0) write(6,*) 'Example elements: '
#endif

  q0vec=q0
  q0 = 0.0d0

! JRD: Write header of INT_EPS_*

  irq=0
  
  if (peinf%inode .eq. 0 .and. xct%iwriteint .eq. 0) then
    write(filename,'(a,i4.4)') 'INT_EPS_', irq
    call open_file(17,file=filename,form='unformatted',status='replace')
  endif

#ifdef MPI
  call MPI_BCAST(nmtx,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif

  xct%nmtxa(1)=nmtx

!------------------------------
! JRD: Finally Read In Eps (Proc 0)

#ifdef HDF5
  if(xct%use_hdf5) then

    if (xct%iwriteint .eq. 0) then
      if (peinf%inode .eq. 0) then
        SAFE_ALLOCATE(epscol, (nmtx))
        do j=1,nmtx
          call read_eps_matrix_col_hdf5(epscol,j,nmtx,1,1,filenameh50)
          write(17) (epscol(i),i=1,nmtx)
          xct%epsdiag(j,1) = epscol(j)  
        enddo
        SAFE_DEALLOCATE(epscol)
      endif
    else if (xct%bLowComm) then
! JRD: XXX This is slower than need be. Should use parallel read + MPI_ALL_ALL
      SAFE_ALLOCATE(eps,(nmtx,nmtx))
      if (peinf%inode .eq. 0) then
        call read_eps_matrix_ser_hdf5(eps,nmtx,1,1,filenameh50)
      endif
#ifdef MPI
      call MPI_BCAST(eps(1,1),nmtx*nmtx,MPI_SCALAR,0,MPI_COMM_WORLD,mpierr)
#endif
      xct%epscol(1:nmtx,1:nmtx,1) = eps(1:nmtx,1:nmtx)
      SAFE_DEALLOCATE(eps)
    else
      call read_eps_matrix_par_hdf5(xct%epscol(:,:,1),xct%maxpe(peinf%inode+1),&
        xct%maxpet,xct%epsowni(:,peinf%inode+1),nmtx,1,1,filenameh50)
    endif

! XXX  Print Constant

  else
#endif

    SAFE_ALLOCATE(epscol, (nmtx))
    do jj =1,nmtx
      if (peinf%inode .eq. 0) then
        read(10) (epscol(ii),ii=1,nmtx)

!------------------------------
! SIB: print out a small section of the dielectric matrix for testing purposes

#ifdef VERBOSE
        if (jj .le. 4) then
          do ii=1,4
            do ig = 1, gvec%ng
              if(xct%isrtqi(ig, 1) == ii) kk = ig
              if(xct%isrtqi(ig, 1) == jj) ll = ig
            enddo
            write(tmpstr,'(3i3,1x,3i3,1x,2f10.5)') gvec%components(:,kk),gvec%components(:,ll),epscol(ii)
            call logit(tmpstr)
          enddo
        endif
#endif

! Report on dielectric constant

        if (jj .eq. 1) then
          write(6,'(a)') ''
          write(6,*) 'Head of epsilon inverse : ', epscol(1)
          write(6,'(a)') ''
          
          if(dble(epscol(1)) < 1d-3 .and. xct%iscreen == 0 .and. peinf%inode == 0) then
            write(0,'(a)') 'WARNING: You are using semiconductor screening, but the'
            write(0,'(a)') 'head of epsilon inverse is very small and seems metallic.'
          endif
        endif
      endif

! Write dielectric matrix column for q->0 to unit17 unformatted
      
      if (xct%iwriteint .eq. 0) then
        if (peinf%inode .eq. 0) then
          write(17) epscol(1:nmtx)
        endif
      else
#ifdef MPI
        call MPI_BCAST(epscol,nmtx,MPI_SCALAR,0,MPI_COMM_WORLD,mpierr)
#endif
        xct%epsown(jj)=(jj/peinf%npes)
        if (mod(jj,peinf%npes).ne.0) xct%epsown(jj) = xct%epsown(jj) +1
        iowner=mod(jj,peinf%npes)
        xct%epsowni(xct%epsown(jj),iowner+1)=jj
        if (xct%maxpe(iowner+1) .lt. xct%epsown(jj)) xct%maxpe(iowner+1) = xct%epsown(jj)
        
        if (xct%bLowComm) then
          xct%epscol(1:nmtx,jj,1)=epscol(:)
        else
          if (iowner .eq. peinf%inode) then
            xct%epscol(1:nmtx,xct%epsown(jj),1)=epscol(:)
          endif
        endif
      endif
      if (peinf%inode .eq. 0) then
        xct%epsdiag(jj,1) = epscol(jj)  
      endif
    enddo
    SAFE_DEALLOCATE(epscol)
    
    if (peinf%inode .eq. 0) then
      call close_file(10)
    endif
    
#ifdef HDF5
  endif
#endif

! Close comm_disk file
  if (xct%iwriteint .eq. 0 .and. peinf%inode .eq. 0) then
    call close_file(17)
  endif


!----------------- Read dielectric matrices from unit11 for q<>0 --------------------

  if(igamma.ne.0) then
    nrq1=0
  else

! Have to allocate oldg again...

    if(peinf%inode.eq.0) then
      SAFE_ALLOCATE(oldg, (3, nold))
      SAFE_ALLOCATE(isrtold, (ngmax))
      SAFE_ALLOCATE(ekold, (ngmax))
      SAFE_ALLOCATE(q1, (3,nrq1))
#ifdef HDF5
      if(xct%use_hdf5) then
        SAFE_ALLOCATE(nmtx_of_q,(nrq1))
        call read_eps_qgrid_hdf5(nrq1,q1,nmtx_of_q,filenameh5)
        
        call read_eps_old_gvecs_hdf5(nold,oldg,filenameh5)
      else
#endif
        call open_file(unit=11,file='epsmat',form='unformatted',status='old')
        read(11) ajname2,adate2
        read(11)
        read(11) (qgrid(ii),ii=1,3)
        read(11)
        read(11)
        read(11)
        read(11) gmax_in
        read(11) nrq1,((q1(ii,jj),ii=1,3),jj=1,nrq1)
        read(11) nold,(oldg(1:3,ii),ii=1,nold)
#ifdef HDF5
      endif
#endif

    endif

#ifdef MPI
    if(peinf%inode.ne.0) then
      SAFE_ALLOCATE(q1, (3,nrq1))
    endif
    call MPI_BCAST(q1,3*nrq1,  MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
#endif

    if(peinf%inode.eq.0) then
      write(6,'(/,1x,a)') 'Epsilon matrix for q/=0 read from epsmat'
      write(6,'(1x,a,i0,2x,a,f12.6)') 'nrq = ', nrq1, 'gmax = ', gmax_in
#ifdef VERBOSE
      write(6,*)
      write(6,'(1x,3f10.6)') q1(1:3,1:nrq1)
      write(6,*)
#endif
    endif
    
  endif
  qg%nr=nrq1+1
  SAFE_ALLOCATE(qg%r, (3,qg%nr))
  qg%r(1:3,1)=q0
  if(nrq1.ne.0) then
    qg%r(1:3,2:qg%nr)=q1(1:3,1:nrq1)
    SAFE_DEALLOCATE(q1)
  endif

! Read inverse dielectric matrices from unit11 for q<>0

  if(igamma == 0) then

    do irq=1,nrq1
      if(peinf%inode.eq.0) then
        isrtold=0
        ekold=0.d0
        xct%isrtqi(:,irq+1)=0
#ifdef HDF5
        if(xct%use_hdf5) then
          SAFE_ALLOCATE(isrtinvdummy, (nold))
          call read_eps_gvecsofq_hdf5(nold,isrtold,isrtinvdummy,ekold,irq,filenameh5)
          SAFE_DEALLOCATE(isrtinvdummy)
          nmtx = nmtx_of_q(irq)
          qk(:) = qg%r(:,irq+1)
        else
#endif
          read(11) ng,nmtx,(isrtold(ii),jj,ii=1,ng)
          read(11) (ekold(ii),ii=1,ng)
          read(11) (qk(ii),ii=1,3)
#ifdef HDF5
        endif
#endif
        
        do ii=1,ng
          if (ekold(isrtold(ii)).lt.emax) then
            gg(1:3)=oldg(1:3, isrtold(ii))
            call findvector(iout,gg,gvec)
            if (iout.gt.gvec%ng) call die('epscopy: iout > ng')
            if (iout.le.0) call die('epscopy: iout <= 0')
            xct%isrtqi(iout,irq+1)=ii
            eknq(ii)=ekold(isrtold(ii))
          endif
        enddo

!----------------------------
! Copy dielectric matrices to unit17 unformatted

! Actually, the dielectric matrix at each q-point is written
! in a separate INT_EPS_* file. INT_EPS_0000 has the q=0 point.
! q-points in IBZ = qg%nrk < 10001

        if (xct%iwriteint .eq. 0) then
          if (irq.lt.10000) then
            write(filename,'(a,i4.4)') 'INT_EPS_', irq
          else
            call die("irq > 9999")
          endif

          call open_file(17,file=filename,form='unformatted',status='replace')
        endif
      endif
      
#ifdef MPI
      call MPI_BCAST(nmtx,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
#endif
      
      xct%nmtxa(irq+1)=nmtx

#ifdef HDF5
      if(xct%use_hdf5) then

        if (xct%iwriteint .eq. 0) then
          if (peinf%inode .eq. 0) then
            SAFE_ALLOCATE(epscol, (nmtx))
            do j=1,nmtx
              call read_eps_matrix_col_hdf5(epscol,j,nmtx,irq,1,filenameh5)
              write(17) (epscol(i),i=1,nmtx)
              xct%epsdiag(j,irq+1) = epscol(j)  
            enddo
            SAFE_DEALLOCATE(epscol)
          endif
        else if (xct%bLowComm) then
! JRD: XXX This is slower than need be. Should use parallel read + MPI_ALL_ALL
          SAFE_ALLOCATE(eps,(nmtx,nmtx))
          if (peinf%inode .eq. 0) then
            call read_eps_matrix_ser_hdf5(eps,nmtx,irq,1,filenameh5)
          endif
#ifdef MPI
          call MPI_BCAST(eps(1,1),nmtx*nmtx,MPI_SCALAR,0,MPI_COMM_WORLD,mpierr)
#endif
          xct%epscol(1:nmtx,1:nmtx,irq+1) = eps(1:nmtx,1:nmtx)
          SAFE_DEALLOCATE(eps)
        else
          call read_eps_matrix_par_hdf5(xct%epscol(:,:,irq+1),xct%maxpe(peinf%inode+1),&
            xct%maxpet,xct%epsowni(:,peinf%inode+1),nmtx,irq,1,filenameh5)
        endif

      else
#endif
        SAFE_ALLOCATE(epscol, (nmtx))

        do jj=1,nmtx
          if (peinf%inode .eq. 0) then
            read(11) (epscol(ii),ii=1,nmtx)
            xct%epsdiag(jj,irq+1)=epscol(jj)
          endif
          if (xct%iwriteint .eq. 0) then
            if (peinf%inode .eq. 0) write(17) epscol(1:nmtx)
          else
#ifdef MPI
            call MPI_BCAST(epscol,nmtx,MPI_SCALAR,0,MPI_COMM_WORLD,mpierr)
#endif
            xct%epsown(jj)=(jj/peinf%npes)
            if (mod(jj,peinf%npes).ne.0) xct%epsown(jj) = xct%epsown(jj) +1
            iowner=mod(jj,peinf%npes)
            xct%epsowni(xct%epsown(jj),iowner+1)=jj
            if (xct%maxpe(iowner+1) .lt. xct%epsown(jj)) xct%maxpe(iowner+1) = xct%epsown(jj)
            
            if (xct%bLowComm) then
              xct%epscol(1:nmtx,jj,irq+1)=epscol(:)
            else
              if (iowner .eq. peinf%inode) then
                xct%epscol(1:nmtx,xct%epsown(jj),irq+1)=epscol(:)
              endif
            endif

          endif
        
        enddo

        SAFE_DEALLOCATE(epscol)
#ifdef HDF5
      endif
#endif

      if (xct%iwriteint .eq. 0 .and. peinf%inode.eq.0) then
        call close_file(17)
      endif

    enddo
    
    if (peinf%inode .eq. 0) then
      SAFE_DEALLOCATE(isrtold)
      SAFE_DEALLOCATE(ekold)
      SAFE_DEALLOCATE(oldg)
      if(.not. xct%use_hdf5) call close_file(11)
    endif
    
  endif
  
  SAFE_DEALLOCATE(eknq)

!-------------------------
! Generate full brillouin zone from irreducible wedge
! rq -> fq

  call timacc(7,1)
  call fullbz(crys,syms,qg,syms%ntran,skip_checkbz,wigner_seitz=.true.,paranoid=.true.)
  qshift(:)=0.0d0
  if (igamma.ne.0) then
    tmpfn='eps0mat'
  else
    tmpfn='epsmat'
  endif
  if (.not. skip_checkbz) then
    call checkbz(qg%nf,qg%f,qgrid,qshift,crys%bdot,tmpfn,'q',.true.,xct%freplacebz,xct%fwritebz)
  endif
  call timacc(7,2)
  
  if(peinf%inode.eq.0) then
    write(6,'(1x,a,i0,2x,a,f10.6)') 'nfq = ', qg%nf, 'qsz = ', qg%sz
#ifdef VERBOSE
    write(6,*)
    do ii=1,qg%nf
      write(6,'(i6,3f10.6)') ii, qg%f(:,ii)
    enddo
    write(6,*)
#endif
    write(6,*)
  endif
  
#ifdef MPI
  call MPI_Barrier(MPI_COMM_WORLD,mpierr)
  ! Doing the communication once here. Saves us a communication each time mtxel_kernel
  ! is called
  if (xct%bLowComm) then
    call MPI_BCAST(xct%isrtqi,gvec%ng*(nrq1+1),MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  endif

  if (xct%use_hdf5 .and. .not. xct%bLowComm .and. xct%iwriteint .ne. 0) then
! XXX This should be ALL to ALL not ALL REDUCE
! XXX IT SHOULD ACTUALLY USE THE NEW matrix_diagonal ROUTINE INSTEAD
    xct%epsdiag=0D0
    SAFE_ALLOCATE(tempepsdiag, (xct%nmtxmax,nrq1+1))
    do ijk=1,xct%maxpe(peinf%inode+1)
      do irq=1,nrq1+1
        tempepsdiag(xct%epsowni(ijk,peinf%inode+1),irq)=xct%epscol(xct%epsowni(ijk,peinf%inode+1),ijk,irq)
      enddo
    enddo
    call MPI_ALLREDUCE(tempepsdiag(1,1),xct%epsdiag(1,1),xct%nmtxmax*(nrq1+1),MPI_SCALAR,MPI_SUM,MPI_COMM_WORLD,mpierr)
    SAFE_DEALLOCATE(tempepsdiag)
  else
    call MPI_BCAST(xct%epsdiag,xct%nmtxmax*(nrq1+1),MPI_SCALAR,0,MPI_COMM_WORLD,mpierr)
  endif
#endif
  
  if (xct%use_hdf5 .and. peinf%inode .eq. 0) then
    SAFE_DEALLOCATE(nmtx0_of_q)
    if (igamma.eq.0) then
      SAFE_DEALLOCATE(nmtx_of_q)
    endif
  endif
  
  POP_SUB(epscopy)
  
  return
end subroutine epscopy

subroutine tddft_bz_gen(crys,syms,qg,xct)

  use global_m
  use checkbz_m
  use fullbz_m
  use misc_m
  implicit none

  type (crystal), intent(in) :: crys
  type (symmetry), intent(in) :: syms
  type (grid), intent(out) :: qg
  type (xctinfo), intent(inout) :: xct

  real(DP) :: qshift(3)
  character :: tmpfn*16
  logical :: skip_checkbz
  integer :: ii
!-------------------------
! Generate full brillouin zone from irreducible wedge
! rq -> fq

  PUSH_SUB(tddft_bz_gen)
  call timacc(7,1)
  call fullbz(crys,syms,qg,syms%ntran,skip_checkbz,wigner_seitz=.true.,paranoid=.true.)
  qshift(:)=0.0d0
  tmpfn='tddft_q'

  if (.not. skip_checkbz) then
    call checkbz(qg%nf,qg%f,xct%qgrid,qshift,crys%bdot,tmpfn,'q',.true.,xct%freplacebz,xct%fwritebz)
  endif
  call timacc(7,2)
  
  if(peinf%inode.eq.0) then
    write(6,'(/,1x,a,i0,2x,a,f10.6)') 'nfq = ', qg%nf, 'qsz = ', qg%sz
#ifdef VERBOSE
    write(6,*)
    do ii=1,qg%nf
      write(6,'(i6,3f10.6)') ii, qg%f(:,ii)
    enddo
    write(6,*)
#endif
  endif
  POP_SUB(tddft_bz_gen)

  return
end subroutine tddft_bz_gen

!===============================================================================
!
! Routines:
!
! 1. orthonormalize()      Originally By gsm      Last Modified 9/18/2010 (gsm)
!
!    Orthonormalizes distributed wavefunctions in G-space by applying
!    Gram-Schmidt process.
!
! 2. orderindex()          Originally By gsm      Last Modified 9/18/2010 (gsm)
!
!    Builds an index array for reordering wavefunctions, eigenvalues and
!    arrays for fast scalar products.
!
! 3. orderarray()          Originally By gsm      Last Modified 9/18/2010 (gsm)
!
!    Reorders wavefunctions, eigenvalues and arrays for fast scalar products
!    according to the index array.
!
!===============================================================================

#include "f_defs.h"

module ortho_m

  use global_m
  use blas_m
  use sort_m

  implicit none

  private

  public :: orthonormalize, orderindex, orderarray

contains

subroutine orthonormalize(ffastsp,fblas,fecor,nk,ns,nbstart, &
  nbend,nbmax,ngk_l,npwdeg,pw_num,pw_ind,en,wfn_d)

  logical, intent(in) :: ffastsp,fblas,fecor
  integer, intent(in) :: nk,ns,nbstart,nbend,nbmax,ngk_l,npwdeg
  integer, intent(in) :: pw_num(:,:,:) !< (nbmax,ns,nk)
  integer, intent(in) :: pw_ind(:,:,:,:,:) !< (2,npwdeg,nbmax,ns,nk)
  real(DP), intent(inout) :: en(:,:,:) !< (nbmax,nk,ns)
  SCALAR, intent(inout) :: wfn_d(:,:,:,:) !< (ngk_l,nbmax,ns,nk)
  
  integer :: i,ik,is,ib,jb,ig
  logical :: ffastsp_ib
  real(DP) :: norm2,normi,de,desp2,norm2_dummy
  SCALAR :: z
  character(len=16) :: s1,s2,s3
  real(DP), allocatable :: wfnsp2(:)
  SCALAR, allocatable :: wfnsp(:)
  SCALAR, allocatable :: wfnspdummy(:)
  
  PUSH_SUB(orthonormalize)
  
  SAFE_ALLOCATE(wfnsp2, (nbend-1))
  SAFE_ALLOCATE(wfnsp, (nbend-1))
#ifdef MPI
  SAFE_ALLOCATE(wfnspdummy, (nbend-1))
#endif

  do ik=1,nk
    do is=1,ns
      do ib=nbstart,nbend

        ! check whether to compute fast scalar products
        ! for the current wavefunction
        ! (if .not.ffastsp pw_num may be unallocated)
        if (ffastsp) then
          ffastsp_ib=pw_num(ib,is,ik).ne.0
        else ! ffastsp
          ffastsp_ib=.false.
        endif ! ffastsp
        
        ! compute scalar products of the current wavefunction
        ! with the previous wavefunctions
        wfnsp(:)=ZERO
        if (ffastsp_ib) then
          ! fast scalar product
          do jb=1,ib-1
            z=ZERO
            do i=1,pw_num(ib,is,ik)
              if (peinf%inode.eq.pw_ind(1,i,ib,is,ik)) &
                z=z+MYCONJG(wfn_d(pw_ind(2,i,ib,is,ik),jb,is,ik))* &
                wfn_d(pw_ind(2,i,ib,is,ik),ib,is,ik)
            enddo ! i
            wfnsp(jb)=z
          enddo ! jb
        else ! ffastsp_ib
          ! full scalar product
          if (fblas) then
            call X(gemv)('C',ngk_l,ib-1,ONE,wfn_d(:,:,is,ik), &
              ngk_l,wfn_d(:,ib,is,ik),1,ZERO,wfnsp(:),1)
          else ! fblas
            do jb=1,ib-1
              z=ZERO
              do ig=1,ngk_l
                z=z+MYCONJG(wfn_d(ig,jb,is,ik))* &
                  wfn_d(ig,ib,is,ik)
              enddo ! ig
              wfnsp(jb)=z
            enddo ! jb
          endif ! fblas
        endif ! ffastsp_ib
#ifdef MPI
        wfnspdummy(1:ib-1)=wfnsp(1:ib-1)
        call MPI_Allreduce(wfnspdummy,wfnsp,ib-1, &
          MPI_SCALAR,MPI_SUM,MPI_COMM_WORLD,mpierr)
#endif
        
        ! orthogonalize the current wavefunction
        ! to the previous wavefunctions
        if (fblas) then
          call X(gemv)('N',ngk_l,ib-1,-ONE,wfn_d(:,:,is,ik), &
            ngk_l,wfnsp(:),1,ONE,wfn_d(:,ib,is,ik),1)
        else ! fblas
          do jb=1,ib-1
            do ig=1,ngk_l
              wfn_d(ig,ib,is,ik)=wfn_d(ig,ib,is,ik)- &
                wfnsp(jb)*wfn_d(ig,jb,is,ik)
            enddo ! ig
          enddo ! jb
        endif ! fblas
        
        ! compute the squared scalar products
        wfnsp2(:)=0.0d0
        do jb=1,ib-1
          wfnsp2(jb)=abs(wfnsp(jb))**2
        enddo ! jb
        
        ! normalize the current wavefunction
        norm2 = sum(abs(wfn_d(:,ib,is,ik))**2)
#ifdef MPI
        norm2_dummy = norm2
        call MPI_Allreduce(norm2_dummy, norm2, 1, &
          MPI_REAL_DP, MPI_SUM, MPI_COMM_WORLD, mpierr)
#endif
        
        if (norm2.gt.TOL_Zero) then
          normi=1.0d0/sqrt(norm2)
          if (fblas) then
            call X(SCAL)(ngk_l,normi*ONE,wfn_d(:,ib,is,ik),1)
          else ! fblas
            do ig=1,ngk_l
              wfn_d(ig,ib,is,ik)=wfn_d(ig,ib,is,ik)*normi
            enddo ! ig
          endif ! fblas
        else ! norm2.gt.TOL_Zero
          write(s1,151)ib
          write(s2,151)is
          write(s3,151)ik
          ! aka, "ortho went bananas"
          call die('Failed to orthonormalize band ' // TRUNC(s1) // &
            ' for spin ' // TRUNC(s2) // ' and k-point ' // TRUNC(s3))
        endif ! norm2.gt.TOL_Zero
        
        ! correct the eigenvalue of the current
        ! wavefunction by perturbative approach
        if (fecor) then
          desp2=0.0d0
          do jb=1,ib-1
            de=en(ib,ik,is)-en(jb,ik,is)
            desp2=desp2+de*wfnsp2(jb)
          enddo ! jb
          en(ib,ik,is)=en(ib,ik,is)+desp2/norm2
        endif ! fecor
        
      enddo ! ib
    enddo ! is
  enddo ! ik
  
  SAFE_DEALLOCATE(wfnsp2)
  SAFE_DEALLOCATE(wfnsp)
#ifdef MPI
  SAFE_DEALLOCATE(wfnspdummy)
#endif
  
  POP_SUB(orthonormalize)
  
  return
  
151 format(i16)
  
end subroutine orthonormalize

!-------------------------------------------------------------------------------

subroutine orderindex(iblock,iorder,nk,ns,nbtot,nbinp,nbpw, &
  nbaux,nbmax,isrtort,en)
  
  integer, intent(in) :: iblock,iorder,nk,ns,nbtot,nbinp,nbpw, &
    nbaux,nbmax
  integer, intent(out) :: isrtort(:,:,:) !< (nbtot,ns,nk)
  real(DP), intent(in) :: en(:,:,:) !< (nbmax,nk,ns)
  
  integer :: ik,is,ib
  real(DP), allocatable :: ensrt(:)
  integer, allocatable :: isrt(:)
  
  PUSH_SUB(orderindex)
  
  isrtort(:,:,:)=0
  
  if (iblock.eq.2) then
    SAFE_ALLOCATE(ensrt, (nbtot-nbinp))
    SAFE_ALLOCATE(isrt, (nbtot-nbinp))
  endif ! iblock.eq.2
  
  do ik=1,nk
    do is=1,ns
      
      if (iblock.eq.0) then
        
        if (iorder.eq.0) then
          do ib=1,nbtot
            isrtort(ib,is,ik)=ib
          enddo ! ib
        elseif (iorder.eq.1) then
          do ib=1,nbinp
            isrtort(ib,is,ik)=nbinp+1-ib
          enddo ! ib
          do ib=nbinp+1,nbinp+nbpw
            isrtort(ib,is,ik)=nbinp+1+nbinp+nbpw-ib
          enddo ! ib
          do ib=nbinp+nbpw+1,nbtot
            isrtort(ib,is,ik)=nbinp+nbpw+1+nbtot-ib
          enddo ! ib
        endif ! iorder
        
      elseif (iblock.eq.1) then
        
        if (iorder.eq.0) then
          do ib=1,nbinp
            isrtort(ib,is,ik)=ib
          enddo ! ib
          do ib=nbinp+1,nbinp+nbaux
            isrtort(ib,is,ik)=ib+nbpw
          enddo ! ib
          do ib=nbinp+nbaux+1,nbtot
            isrtort(ib,is,ik)=ib-nbaux
          enddo ! ib
        elseif (iorder.eq.1) then
          do ib=1,nbinp
            isrtort(ib,is,ik)=nbinp+1-ib
          enddo ! ib
          do ib=nbinp+1,nbtot
            isrtort(ib,is,ik)=nbinp+1+nbtot-ib
          enddo ! ib
        endif ! iorder
        
      elseif (iblock.eq.2) then
        
        do ib=nbinp+1,nbtot
          ensrt(ib-nbinp)=en(ib,ik,is)
        enddo ! ib
        call sortrx(nbtot-nbinp,ensrt,isrt)
        
        if (iorder.eq.0) then
          do ib=1,nbinp
            isrtort(ib,is,ik)=ib
          enddo ! ib
          do ib=nbinp+1,nbtot
            isrtort(ib,is,ik)=isrt(ib-nbinp)+nbinp
          enddo ! ib
        elseif (iorder.eq.1) then
          do ib=1,nbinp
            isrtort(ib,is,ik)=nbinp+1-ib
          enddo ! ib
          do ib=nbinp+1,nbtot
            isrtort(ib,is,ik)=isrt(nbtot+1-ib)+nbinp
          enddo ! ib
        endif ! iorder
        
      endif ! iblock
      
    enddo ! is
  enddo ! ik
  
  if (iblock.eq.2) then
    SAFE_DEALLOCATE(ensrt)
    SAFE_DEALLOCATE(isrt)
  endif ! iblock.eq.2
  
  POP_SUB(orderindex)
  
  return
  
end subroutine orderindex

!-------------------------------------------------------------------------------

subroutine orderarray(ffastsp,idir,nk,ns,nbtot,nbmax,ngk_l, &
  npwdeg,isrtort,pw_num,pw_ind,en,wfn_d)
  
  logical, intent(in) :: ffastsp
  integer, intent(in) :: idir,nk,ns,nbtot,nbmax,ngk_l,npwdeg
  integer, intent(in) :: isrtort(:,:,:) !< (nbtot,ns,nk)
  integer, intent(inout) :: pw_num(:,:,:) !< (nbmax,ns,nk)
  integer, intent(inout) :: pw_ind(:,:,:,:,:) !< (2,npwdeg,nbmax,ns,nk)
  real(DP), intent(inout) :: en(:,:,:) !< (nbmax,nk,ns)
  SCALAR, intent(inout) :: wfn_d(:,:,:,:) !< (ngk_l,nbmax,ns,nk)
  
  integer :: ik,is,ib
  integer, allocatable :: pw_numsrt(:)
  integer, allocatable :: pw_indsrt(:,:,:)
  real(DP), allocatable :: ensrt(:)
  SCALAR, allocatable :: wfnsrt_d(:,:)
  
  PUSH_SUB(orderarray)
  
  if (ffastsp) then
    SAFE_ALLOCATE(pw_numsrt, (nbtot))
    SAFE_ALLOCATE(pw_indsrt, (2,npwdeg,nbtot))
  endif ! ffastsp
  SAFE_ALLOCATE(ensrt, (nbtot))
  SAFE_ALLOCATE(wfnsrt_d, (ngk_l,nbtot))
  
  if (idir.eq.1) then
    
    do ik=1,nk
      do is=1,ns
        if (ffastsp) then
          do ib=1,nbtot
            pw_numsrt(ib)=pw_num(isrtort(ib,is,ik),is,ik)
          enddo ! ib
          do ib=1,nbtot
            pw_num(ib,is,ik)=pw_numsrt(ib)
          enddo ! ib
          do ib=1,nbtot
            pw_indsrt(:,:,ib)=pw_ind(:,:,isrtort(ib,is,ik),is,ik)
          enddo ! ib
          do ib=1,nbtot
            pw_ind(:,:,ib,is,ik)=pw_indsrt(:,:,ib)
          enddo ! ib
        endif ! ffastsp
        do ib=1,nbtot
          ensrt(ib)=en(isrtort(ib,is,ik),ik,is)
        enddo ! ib
        do ib=1,nbtot
          en(ib,ik,is)=ensrt(ib)
        enddo ! ib
        do ib=1,nbtot
          wfnsrt_d(:,ib)=wfn_d(:,isrtort(ib,is,ik),is,ik)
        enddo ! ib
        do ib=1,nbtot
          wfn_d(:,ib,is,ik)=wfnsrt_d(:,ib)
        enddo ! ib
      enddo ! is
    enddo ! ik
    
  elseif (idir.eq.2) then
    
    do ik=1,nk
      do is=1,ns
        if (ffastsp) then
          do ib=1,nbtot
            pw_numsrt(isrtort(ib,is,ik))=pw_num(ib,is,ik)
          enddo ! ib
          do ib=1,nbtot
            pw_num(ib,is,ik)=pw_numsrt(ib)
          enddo ! ib
          do ib=1,nbtot
            pw_indsrt(:,:,isrtort(ib,is,ik))=pw_ind(:,:,ib,is,ik)
          enddo ! ib
          do ib=1,nbtot
            pw_ind(:,:,ib,is,ik)=pw_indsrt(:,:,ib)
          enddo ! ib
        endif ! ffastsp
        do ib=1,nbtot
          ensrt(isrtort(ib,is,ik))=en(ib,ik,is)
        enddo ! ib
        do ib=1,nbtot
          en(ib,ik,is)=ensrt(ib)
        enddo ! ib
        do ib=1,nbtot
          wfnsrt_d(:,isrtort(ib,is,ik))=wfn_d(:,ib,is,ik)
        enddo ! ib
        do ib=1,nbtot
          wfn_d(:,ib,is,ik)=wfnsrt_d(:,ib)
        enddo ! ib
      enddo ! is
    enddo ! ik
    
  endif ! idir
  
  if (ffastsp) then
    SAFE_DEALLOCATE(pw_numsrt)
    SAFE_DEALLOCATE(pw_indsrt)
  endif ! ffastsp
  SAFE_DEALLOCATE(ensrt)
  SAFE_DEALLOCATE(wfnsrt_d)
  
  POP_SUB(orderarray)
  
  return
  
end subroutine orderarray

end module ortho_m

!==========================================================================
!
! Routines:
!
! (1) plotxct(main)     Originally By MLT       Last Modified 6/2008 FJR
!
!     Original developers:
!
!        Murilo Tiago, Berkeley CA, mtiago@civet.berkeley.edu
!           original creator
!
!        Sohrab Ismail-Beigi, Berkeley CA, sohrab@civet.berkeley.edu
!           FFTW interface routines
!
!        Filipe Ribeiro, Berkeley CA, fribeiro@alum.berkeley.edu
!           single output xct.<ie>.r.asc
!
!=================================================================================

#include "f_defs.h"

program plotxct

  use global_m
  use fftw_m
  use fullbz_m
  use genwf_m
  use inread_m
  use misc_m
  use read_wannier_m
  use sort_m
  use write_xct_m
  use plotxct_common_m
  implicit none

  type (crystal) :: crys
  type (symmetry) :: syms
  type (gspace) :: gvec
  type (xctinfo) :: xct
  type (grid) :: kg,kgq
  type (wavefunction) :: wfnc,wfnv
  type (work_genwf) :: work, workq
  type (int_wavefunction) :: intwfn
  type (plotxct_t) :: pxct

  integer :: ii,ikq,ik,ikt,ic,iv,ikcvs,i1,i2,i3,ir1,ir2,ir3,ip1,ip2,ip3
  integer :: ncount,ntim,nmat,iunit_c,iunit_v
  integer :: nw(3),nw_eff(3),nfft(3),step
  real(DP) :: sum,sumf,scale
  real(DP) :: phhole,phel,kk(3),rel(3)
  real(DP) :: tsec(2)
  complex(DPC) :: wfnvint
  character :: filename*20 
  character*16, allocatable :: routnam(:)
  integer, allocatable :: indexq(:),index_k(:)
  real(DP), allocatable :: wwk(:),kgr(:,:)

  complex(DPC), allocatable :: fel(:,:,:,:) !< (nfft1, nfft2, nfft3, ncb)
  complex(DPC), allocatable :: fhole(:) !< (nvb)
  complex(DPC), allocatable :: coefficients(:,:) !< (nvb, pxct%nsuper)
  complex(DPC), allocatable :: ucfftv(:,:,:) !< (nfft1, nfft2, nfft3)
  complex(DPC), allocatable :: scfft(:,:,:) !< (nw_eff1, nw_eff2, nw_eff3)
  SCALAR, allocatable :: ucfftv_sum(:,:,:), ucfftc_sum(:,:,:) !< (nfft1, nfft2, nfft3)
  real(DP), allocatable :: hole_prob(:,:,:), elec_prob(:,:,:) !< (nfft1, nfft2, nfft3)

  SCALAR, allocatable :: Asvck(:)

  call peinfo_init()

  call timacc(0,0)
  call timacc(1,1)

  call write_program_header('PlotXct', .false.)

  !---------------------------------
  ! Read plotxct.inp

  call inread(xct,pxct)

  !---------------------------------
  ! Read eigenvectors

  call logit('plotxct: reading file eigenvectors')
  if(peinf%inode.eq.0) then
    call open_file(unit=10,file='eigenvectors',form='unformatted',status='old')
    read(10) xct%nspin
    read(10) xct%nvb_fi
    read(10) xct%ncb_fi
    read(10) xct%nkpt_fi
    SAFE_ALLOCATE(kgr, (3,xct%nkpt_fi))
    read(10) ((kgr(ii,ik),ii=1,3),ik=1,xct%nkpt_fi)
  endif

  if(pxct%ispin == 2 .and. xct%nspin == 1) then
    call die("plot_spin = 2 but calculation is not spin_polarized", only_root_writes = .true.)
  endif

#ifdef MPI
  call MPI_BCAST(xct%nspin, 1, MPI_INTEGER,0, MPI_COMM_WORLD,mpierr)
  call MPI_BCAST(xct%nvb_fi, 1, MPI_INTEGER,0, MPI_COMM_WORLD,mpierr)
  call MPI_BCAST(xct%ncb_fi, 1, MPI_INTEGER,0, MPI_COMM_WORLD,mpierr)
  call MPI_BCAST(xct%nkpt_fi, 1, MPI_INTEGER,0, MPI_COMM_WORLD,mpierr)
  if (peinf%inode.ne.0) then
    SAFE_ALLOCATE(kgr, (3,xct%nkpt_fi))
  endif
  call MPI_BCAST(kgr, 3*xct%nkpt_fi,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
#endif

  !-------------------------------
  ! Read selected state

  nmat= xct%nkpt_fi*xct%ncb_fi*xct%nvb_fi*xct%nspin
  SAFE_ALLOCATE(Asvck, (nmat))
  if(peinf%inode.eq.0) then
    do ii=1,pxct%pstate-1
      read(10)
      read(10)
    enddo
    read(10) pxct%e_S
    read(10) (Asvck(ii),ii=1,nmat)
    write(6,*) ' Reading state # ',pxct%pstate
    write(6,*) ' Excitation energy = ',pxct%e_S,' eV'
  endif
#ifdef MPI
  call MPI_BCAST(Asvck,nmat,MPI_SCALAR,0,MPI_COMM_WORLD,mpierr)
#endif
  call logit('plotxct: done reading file eigenvectors')

  !-------------------------------
  ! Restrict the # of k-points to xct%nn

  if (xct%nn.eq.0) xct%nn=xct%nkpt_fi
  SAFE_ALLOCATE(wwk, (xct%nkpt_fi))
  wwk=0.d0
  do ik=1,xct%nkpt_fi
    do iv=1,xct%nvb_fi
      do ic=1,xct%ncb_fi
        ikcvs = bse_index(ik, ic, iv, pxct%ispin, xct)
        wwk(ik) = wwk(ik) + abs(Asvck(ikcvs))**2
      enddo
    enddo
  enddo

  SAFE_ALLOCATE(index_k, (xct%nkpt_fi))
  index_k=0
  call sortrx(xct%nkpt_fi, wwk, index_k)
  ! cannot use gvec here, not read in yet!
  do ii=1,xct%nkpt_fi/2
    ik=index_k(ii)
    index_k(ii)=index_k(xct%nkpt_fi+1-ii)
    index_k(xct%nkpt_fi+1-ii)=ik
  enddo

  ! Index_k reversed (check if it works!)

  if(peinf%inode.eq.0) then
    write(6,*) ' Reducing k-points to ',xct%nn
    sumf=0.d0
    do ik=1,xct%nkpt_fi
      sumf=sumf + wwk(ik)
    enddo
    sum=0.d0
    do ii=1,xct%nn
      sum=sum + wwk(index_k(ii))
    enddo
    write(6,*) ' Wfn norm (restricted sum): ',sum
    write(6,*) ' Wfn norm (full): ',sumf
  endif

  SAFE_DEALLOCATE(wwk)

  !------------------------------
  ! Read WFN_fi

  call timacc(2,1)
  call input(crys,gvec,kg,syms,xct,kgr,index_k,pxct)

  if(peinf%inode.eq.0) then
    write(6,*) ' # valence bands = ',xct%nvb_fi
    write(6,*) ' # cond. bands   = ',xct%ncb_fi
    if(pxct%plot_hole) write(6,*) 'Plotting hole probability.'
    if(pxct%plot_electron) write(6,*) 'Plotting electron probability.'
    if(pxct%iwann == 0) then
      write(6,*) ' Coordinates of hole = ',pxct%rhole(:)
    else
      write(6,*) ' Projecting onto Wannier function # ', pxct%iwann
    endif
    write(6,*) ' Plotting spin component ',pxct%ispin
    write(6,*) ' lattice box = ',pxct%nsuper(:)
    call timacc(2,2)
  endif
  SAFE_DEALLOCATE(kgr)

  !----------------------------------
  ! Read WFNq_fi

  SAFE_ALLOCATE(indexq, (kg%nf))
  call timacc(3,1)
  call input_q(crys,gvec,kg,kgq,syms,xct,indexq,pxct)
  call timacc(3,2)


  !----------------------------------
  ! Compute size of FFT box we need
  call setup_FFT_sizes(gvec%FFTgrid,nfft,scale)

  ! nw defines the mesh in supercell. Should be defined so that
  ! nfft(ii)*pxct%nsuper(ii)/nw(ii) = integer for ii=1,3

  nw(:) = nfft(:)*pxct%nsuper(:)

  !  Allocate FFT boxes

  if(pxct%iwann == 0 .or. pxct%plot_hole) then
    SAFE_ALLOCATE(ucfftv, (nfft(1),nfft(2),nfft(3)))
  endif
  if(pxct%plot_hole) then
    SAFE_ALLOCATE(ucfftv_sum, (nfft(1),nfft(2),nfft(3)))
    SAFE_ALLOCATE(hole_prob, (nfft(1),nfft(2),nfft(3)))
    hole_prob(:,:,:) = 0d0
  endif
  if(pxct%plot_electron) then
    SAFE_ALLOCATE(ucfftc_sum, (nfft(1),nfft(2),nfft(3)))
    SAFE_ALLOCATE(elec_prob, (nfft(1),nfft(2),nfft(3)))
    elec_prob(:,:,:) = 0d0
  endif
  SAFE_ALLOCATE(fel, (nfft(1),nfft(2),nfft(3),xct%ncb_fi))
  SAFE_ALLOCATE(fhole, (xct%nvb_fi))

  !FHJ : effective supercell taking into consideration the subsampling
  nw_eff = (nw + pxct%subsample - 1) / pxct%subsample

  SAFE_ALLOCATE(scfft, (nw_eff(1),nw_eff(2),nw_eff(3)))
  scfft=0.d0
  if (peinf%inode.eq.0) then
    write(6,'(a,3i6)') ' FFT box size = ',nfft
    write(6,'(a,3i6)') ' Supercell grid = ',nw
    write(6,'(a,3i6)') ' Effective supercell grid = ',nw_eff
  endif

  step = max(1,(peinf%nkpe/20))

  xct%iwriteint = 0 ! do not use intwfn
  do ikt=1,peinf%ikt(peinf%inode+1)
    ik=peinf%ik(peinf%inode+1,ikt)
    ikq=indexq(ik)
    call timacc(5,1)
    call genwf(crys,gvec,kg,syms,wfnc,xct,ik,ik,work,intwfn, is_cond = .true.)
    call timacc(5,2)

    if(pxct%iwann == 0 .or. pxct%plot_hole) then
      call timacc(6,1)
      call genwf(crys,gvec,kgq,syms,wfnv,xct,ik,ikq,workq,intwfn, is_cond = .false.)
      call timacc(6,2)
    endif

    phhole = 2.0d0*PI_D*DOT_PRODUCT( kgq%f(:,ikq), pxct%rhole )
    kk(:) = kg%f(:,ik)

    !-------------------------------
    ! Calculate all needed valence wavefunctions in real space and
    ! store their value at hole position in fhole

    do iv=1,xct%nvb_fi
      if(pxct%iwann == 0) then
        call put_into_fftbox(wfnv%ng,wfnv%cg(1:,iv,pxct%ispin),gvec%components,wfnv%isort,ucfftv,nfft)
        call do_FFT(ucfftv,nfft,1)
        call interpol(pxct%rhole,nfft,wfnvint,ucfftv)
        fhole(iv) = CONJG(wfnvint)*CMPLX(cos(phhole),-sin(phhole))
      else
        fhole(iv) = CONJG(coefficients(xct%nvb_fi - iv + 1,ikq))
      endif
    enddo ! iv

    if(pxct%plot_hole) then
      do ic=1,xct%ncb_fi
        ucfftv_sum(:,:,:) = ZERO
        do iv=1,xct%nvb_fi
          call put_into_fftbox(wfnv%ng,wfnv%cg(1:,iv,pxct%ispin),gvec%components,wfnv%isort,ucfftv,nfft)
          call do_FFT(ucfftv,nfft,1)
          ucfftv_sum(:,:,:) = ucfftv_sum(:,:,:) + MYCONJG(Asvck(bse_index(ik, ic, iv, pxct%ispin, xct))) * ucfftv(:,:,:)
        enddo
        ! this is accumulating over k-points too since we are inside that loop
        hole_prob(:,:,:) = hole_prob(:,:,:) + abs(ucfftv_sum(:,:,:))**2
      enddo
    endif

    fel=0.d0

    !---------------------------------
    ! Calculate all needed conduction wavefunctions in the unit cell

    do ic=1,xct%ncb_fi
      call put_into_fftbox(wfnc%ng,wfnc%cg(1:,ic,pxct%ispin),gvec%components,wfnc%isort,fel(:,:,:,ic),nfft)
      call do_FFT(fel(:,:,:,ic),nfft,1)
    enddo !ic

    !---------------------------------
    ! Calculate contribution from each kcvs quadruplet in the excited state

    do ic=1,xct%ncb_fi
      do iv=1,xct%nvb_fi
        ikcvs = bse_index(index_k(ik), ic, iv, pxct%ispin, xct)

        !$omp parallel default(shared) private(i1,i2,i3,ip1,ip2,ip3,ir1,ir2,ir3,rel,phel)
        !$omp do schedule(dynamic)
        do i3=1,nw(3),pxct%subsample(3)
          ip3 = ((i3-1) / pxct%subsample(3)) + 1
          rel(3) = dble(i3)/dble(nfft(3))
          ir3 = mod(i3-1, nfft(3)) + 1
          ip2 = 0
          do i2=1,nw(2),pxct%subsample(2)
            ip2 = ip2 + 1
            rel(2) = dble(i2)/dble(nfft(2))
            ir2 = mod(i2-1, nfft(2)) + 1
            ip1 = 0
            do i1=1,nw(1),pxct%subsample(1)
              ip1 = ip1 + 1
              rel(1) = dble(i1)/dble(nfft(1))
              ir1 = mod(i1-1, nfft(1)) + 1

              phel = 2.0d0*PI_D*DOT_PRODUCT( kk, rel )
              scfft(ip1,ip2,ip3) = scfft(ip1,ip2,ip3) + &
                Asvck(ikcvs) * fhole(iv) * fel(ir1,ir2,ir3,ic) * &
                CMPLX(cos(phel),sin(phel))

            enddo ! i1
          enddo ! i2
        enddo ! i3
        !$omp end do

        !$omp end parallel

      enddo ! iv
    enddo ! ic

    SAFE_DEALLOCATE_P(wfnc%cg)
    SAFE_DEALLOCATE_P(wfnc%isort)
    SAFE_DEALLOCATE_P(wfnv%cg)
    SAFE_DEALLOCATE_P(wfnv%isort)

    if (peinf%inode.eq.0.and.mod(ikt,step).eq.0) &
      write(6,*)'PE #0 working at k-point # ',ikt,' out of ',peinf%ikt(1)

  enddo ! ik

  call dealloc_grid(kg)
  call dealloc_grid(kgq)

  call destroy_fftw_plans()

  ! typedefs initializes all of these ikolds to 0
  if(work%ikold.ne.0) then
    SAFE_DEALLOCATE_P(work%cg)
    SAFE_DEALLOCATE_P(work%ph)
    SAFE_DEALLOCATE_P(work%ind)
    SAFE_DEALLOCATE_P(work%isort)
  endif
  if(workq%ikold.ne.0) then
    SAFE_DEALLOCATE_P(workq%cg)
    SAFE_DEALLOCATE_P(workq%ph)
    SAFE_DEALLOCATE_P(workq%ind)
    SAFE_DEALLOCATE_P(workq%isort)
  endif

  if(pxct%iwann == 0) then
    SAFE_DEALLOCATE(ucfftv)
  else
    SAFE_DEALLOCATE(coefficients)
  endif
  SAFE_DEALLOCATE(fel)
  SAFE_DEALLOCATE(indexq)
  SAFE_DEALLOCATE(index_k)

  !-----------------------------
  ! Add up information on supercell 'scfft' (dest = PE 0)

  call gather_data()

  !-----------------------------------
  ! Write output (only PE 0)

  if (peinf%inode.eq.0) call write_xct(pxct, crys, nfft, scfft)

  !------------------------------------
  ! Time accounting

  ntim=6
  SAFE_ALLOCATE(routnam, (ntim))
  routnam(1)='TOTAL:'
  routnam(2)='INPUT:'
  routnam(3)='INPUT_Q:'
  routnam(4)='FULLBZ:'
  routnam(5)='GENWF:'
  routnam(6)='GENWF_Q:'

  call timacc(1,2)
  if(peinf%inode.eq.0) then
    write(6,*)
    write(6,9000) 'CPU [s]','WALL [s]','#'
    write(6,*)
    do ii=2,ntim
      call timacc(ii,3,tsec,ncount)
      write(6,9001) routnam(ii),tsec(1),tsec(2),ncount
    enddo
    call timacc(1,3,tsec,ncount)
    write(6,9004) routnam(1),tsec(1),tsec(2)
    write(6,*)

9000 format(22x,a13,  3x,a13,  3x,a8)
9001 format(1x,a16,'      ',f13.3,3x,f13.3,3x,i8)
9004 format(1x,a16,'      ',f13.3,3x,f13.3)

  endif

  SAFE_DEALLOCATE(scfft)

  iunit_v = 128+2*(peinf%inode-1)+2
  write(filename,'(a,i4.4)') 'INT_VWFNQ_', peinf%inode
  call open_file(iunit_v, filename, status = 'old')
  call close_file(iunit_v, delete = .true.) ! files INT_VWFNQ*

  iunit_c = 128+2*(peinf%inode-1)+1
  write(filename,'(a,i4.4)') 'INT_CWFN_', peinf%inode
  call open_file(iunit_c, filename, status = 'old')
  call close_file(iunit_c, delete = .true.) ! files INT_CWFN_*

  call write_memory_usage()

#ifdef MPI
  call MPI_FINALIZE(mpierr)
#endif

contains

  !> Gather the scfft array to node 0 by slicing it in the larger axis and
  !! performing multiple MPI_Gather`s. We could do only one large MPI_Gather
  !! without temporary buffers if we could use in-place MPI routines...
  subroutine gather_data()

    complex(DPC), allocatable :: buf_send(:,:), buf_recv(:,:)
    integer :: slice_idx  !< the index that we will use to break the scfft array
    integer :: aux_idx(2) !< the other two indices
    integer :: islice

    PUSH_SUB(gather_data)

    if (nw_eff(3)>=nw_eff(1).and.nw_eff(3)>=nw_eff(2)) then
      slice_idx = 3
      aux_idx = [1,2]
    else if (nw_eff(2)>=nw_eff(1).and.nw_eff(2)>=nw_eff(3)) then
      slice_idx = 2
      aux_idx = [1,3]
    else
      slice_idx = 1
      aux_idx = [2,3]
    endif

    SAFE_ALLOCATE(buf_send, (nw_eff(aux_idx(1)),nw_eff(aux_idx(2))))
    SAFE_ALLOCATE(buf_recv, (nw_eff(aux_idx(1)),nw_eff(aux_idx(2))))

    if (peinf%inode==0) then
      write(6,'(/,1x,a,i5,a)') 'Gathering data: breaking array in ',nw_eff(slice_idx),' arrays containing'
      write(6,'(1x,i8,a,/)') SIZE(buf_recv), ' elements each.'
    endif

    do islice=1,nw_eff(slice_idx)

      if (slice_idx==3) then
        buf_send(:,:) = scfft(:,:,islice)
      else if (slice_idx==2) then
        buf_send(:,:) = scfft(:,islice,:)
      else
        buf_send(:,:) = scfft(islice,:,:)
      endif

      buf_recv = ZERO

#ifdef MPI
      !FHJ: only node 0 wants this, so don`t Allreduce!
      call MPI_Reduce(buf_send(1,1), buf_recv(1,1), SIZE(buf_recv), &
        MPI_COMPLEX_DPC, MPI_SUM, 0, MPI_COMM_WORLD, mpierr)
#else
      buf_recv = buf_send
#endif

      if (peinf%inode==0) then
        if (slice_idx==3) then
          scfft(:,:,islice) = buf_recv(:,:)
        else if (slice_idx==2) then
          scfft(:,islice,:) = buf_recv(:,:)
        else
          scfft(islice,:,:) = buf_recv(:,:)
        endif
      endif

    enddo

    SAFE_DEALLOCATE(buf_send)
    SAFE_DEALLOCATE(buf_recv)

    POP_SUB(gather_data)

  end subroutine gather_data

end program plotxct

!===============================================================================
!
! Routines:
!
! (1) genwf_disk()   Originally By ?                 Last Modified 9/23/2009
!
! Generates valence and conduction wavefunctions at k-point rkq = rkn - rq
! from wavefunctions at k-point rkn read from temporary INT_CWFN_* files.
!
!===============================================================================

#include "f_defs.h"

subroutine genwf_disk(rkq,syms,gvec,crys,kp,sig,wfnkq,iunit_c,fnc)

  use global_m
  use gmap_m
  use input_utils_m
  use sort_m
  use misc_m

  implicit none

  real(DP), intent(in) :: rkq(3)
  type (symmetry), intent(in) :: syms
  type (gspace), intent(in) :: gvec
  type (crystal), intent(in) :: crys
  type (kpoints), intent(in) :: kp
  type (siginfo), intent(in) :: sig
  type (wfnkqstates), intent(inout) :: wfnkq !< pointers are allocated outside
  integer, intent(in) :: iunit_c
  character*20, intent(in) :: fnc

  integer :: nkpti
  integer :: nbandi
  integer, allocatable :: isrtk(:)
  SCALAR, allocatable :: zin(:,:)

  integer :: ii,ij,jj,ik,iin,irk,ikn1,it,iband,icount,ispin
  integer :: naddv
  integer :: nkpt2,kg0(3)
  integer, allocatable :: isorti(:),ind(:)
  real(DP) :: del,qk(3)
  real(DP), allocatable :: xnorm(:,:)
  real(DP), allocatable :: ekin(:)
  SCALAR, allocatable :: ph(:)
  logical :: found

!---------------------------------------
! find rotation (R), translation (g0), and reduced k-point (rk)
! such that krq = rkn - rq = R(rk) + g0
! it = rotation, kg0 = translation, irk = reduced k-point

  PUSH_SUB(genwf_disk)

  found = .false.
  irk_loop: do irk=1,kp%nrk
    it_loop: do it=1,syms%ntran
      do ii=1,3
        qk(ii) = DOT_PRODUCT(dble(syms%mtrx(ii,:,it)),kp%rk(:,irk))
        del = rkq(ii) - qk(ii)
        if (del .ge. 0.0d0) kg0(ii) = del + TOL_Small
        if (del .lt. 0.0d0) kg0(ii) = del - TOL_Small
        if (abs(del-kg0(ii)) .gt. TOL_Small) cycle it_loop
      enddo
      found = .true.
      exit irk_loop
    enddo it_loop
  enddo irk_loop
  if(.not. found) call die('genwf: rkq mismatch')
  ikn1 = irk

!---------------------------------------
! Read in (rk-q) wavefunction

  call open_file(iunit_c,file=fnc,form='unformatted',status='old')
  
  if (ikn1.gt.1) then
    icount=0
    do ii=1,ikn1-1
      icount=icount+peinf%ntband_node+1
    enddo
    do ii=1,icount
      read(iunit_c)
    enddo
  endif
  SAFE_ALLOCATE(ekin, (gvec%ng))
  SAFE_ALLOCATE(isrtk, (gvec%ng))
  SAFE_ALLOCATE(isorti, (gvec%ng))
  SAFE_ALLOCATE(ind, (gvec%ng))
  SAFE_ALLOCATE(ph, (gvec%ng))
  read(iunit_c) nkpti,nbandi,(isrtk(ij),ij=1,gvec%ng), &
    ((wfnkq%ekq(ij,ik),ij=1,nbandi),ik=1,sig%nspin),(qk(ii),ii=1,3)
  wfnkq%nkpt=nkpti
  if (any(abs(kp%rk(1:3,ikn1)-qk(1:3)) .gt. TOL_Small)) then
    call die('genwf: kp mismatch')
  endif

!---------------------------------------
! Compute inverse to array isort
! isrtk orders |rk + G|^2
! isrtkq  orders |rkn - rq + G|^2
! with krq = rkn - rq = R(rk) + g0

  isorti(:)=0
  do ii=1,nkpti
    isorti(isrtk(ii))=ii
  enddo
  SAFE_DEALLOCATE(isrtk)

!---------------------------------------
! compute kinetic energy for rkq = rk-q

  call kinetic_energies(gvec, crys%bdot, ekin, qvec = rkq)

!---------------------------------------
! sort array ekin to ascending order
! store indices in array isort

  call sortrx(gvec%ng, ekin, wfnkq%isrtkq, gvec = gvec%components)

!---------------------------------------
! map indices for rk(ikn1) to those for rkq

  call gmap(gvec,syms,nkpti,it,kg0, &
    wfnkq%isrtkq,isorti,ind,ph,.true.)

!---------------------------------------
! loop over wfnkq%zkq wavefunctions
! map zin wfns onto wfnkq%zkq

  SAFE_ALLOCATE(xnorm, (sig%ntband,sig%nspin))
  SAFE_ALLOCATE(zin, (wfnkq%nkpt,sig%nspin*kp%nspinor))
  SAFE_ALLOCATE(wfnkq%zkq, (peinf%ntband_node*wfnkq%nkpt,sig%nspin*kp%nspinor))
  do iin=1,peinf%ntband_node
    read(iunit_c) iband,nkpt2,((zin(jj,ik),jj=1,nkpt2),ik=1,sig%nspin*kp%nspinor)
    if (iband.ne.peinf%indext(iin)) then
      if(peinf%inode.eq.0) then
        write(0,*) 'iband=',iband,' <> ',peinf%indext(iin)
      endif
      call die('genwf: iband error')
    endif
    
    naddv = (iin-1)*wfnkq%nkpt

!---------------------------------------
! loop over components of zv

    do ispin=1,sig%nspin*kp%nspinor
      wfnkq%zkq(1+naddv:wfnkq%nkpt+naddv,ispin) = &
        zin(ind(1:wfnkq%nkpt),ispin)*ph(1:wfnkq%nkpt)
    enddo


! BAB: We check if the norm differs appreciably from unity.
! There is no longer a need to further normalize the vector.

    do ispin=1,sig%nspin
      call compute_norm(xnorm(iin,ispin),ispin,wfnkq%nkpt,kp%nspinor,wfnkq%zkq(:,:))
      if(abs(xnorm(iin,ispin) - 1d0) > TOL_Small) then
        write(0,*) 'Bad norm: irk=',irk,'ispin=',ispin,'norm=',xnorm(iin,ispin)
        call die('genwf_mpi: Bad norm')
      endif
    enddo
  enddo
  SAFE_DEALLOCATE(ekin)
  SAFE_DEALLOCATE(isorti)
  SAFE_DEALLOCATE(ind)
  SAFE_DEALLOCATE(ph)

  call close_file(iunit_c)

!---------------------------------------
! end of loop over wavefunctions

  POP_SUB(genwf_disk)
  
  return
end subroutine genwf_disk

!==============================================================================
!
! Module:
!
! (1) read_wannier_m        Originally By DAS  April 2012
!
!     Reads binary checkpoint file "seedname.chk" produced by Wannier90 v1.2
!     to obtain the coefficients relating the Wannier to Bloch functions.
!     Reference: wannier90-1.2/src/parameters.F90 routine param_write_chkpt
!
!==============================================================================

#include "f_defs.h"

module read_wannier_m

  use global_m
  implicit none

  private

  public :: read_wannier

contains

  subroutine read_wannier(seedname, crys, kg, iwann, nvband, coefficients)
    character(len=*), intent(in) :: seedname !< read file seedname.chk
    type(crystal), intent(in) :: crys !< for checking lattice vectors
    type(grid), intent(in) :: kg !< for assigning k-points
    integer, intent(in) :: iwann !< index of Wannier function to read
    integer, intent(in) :: nvband !< number of valence bands in plotxct calculation
    complex(DPC), intent(out) :: coefficients(:,:) !< u_matrix relating Bloch to Wannier. (band, k-point)
    
    integer, parameter :: chk_unit = 73
    integer :: ib,iw,ii,jj,ik,ik2,num_bands,num_kpts,num_wann,ikmatch
    character :: filename*50, header*33, chkpt1*20
    logical :: have_disentangled
    real(DP) :: real_lattice(3,3), recip_lattice(3,3)
    real(DP), allocatable :: kpt_latt(:,:)
    complex(DPC), allocatable :: u_matrix(:,:,:)
    
    PUSH_SUB(read_wannier)
    
    filename = trim(seedname)//'.chk'
    write(6,'(a)') "Reading file " // trim(filename)
    call open_file(unit=chk_unit,file=filename,form='unformatted',status='old')
    
    if(iwann <= 0) then
      call die("iwann cannot be negative", only_root_writes = .true.)
    endif

    read(chk_unit) header                                       ! Date and time
    write(6,'(a)') header
    
    read(chk_unit) num_bands                                    ! Number of bands
    if(num_bands < nvband) then
      if(peinf%inode == 0) then
        write(0,'(a,9f11.6)') 'read ', num_bands, ' bands but need at least ', nvband, ' = number of valence bands'
      endif
      call die("not enough bands in " // trim(filename), only_root_writes = .true.)
    endif

    read(chk_unit) ! num_exclude_bands (don`t care)             ! Number of excluded bands  
    read(chk_unit) ! (exclude_bands(ib),ib=1,num_exclude_bands) ! Excluded bands 

    read(chk_unit) ((real_lattice(ii,jj),ii=1,3),jj=1,3)        ! Real lattice (a.u.)
    if(any(abs(real_lattice(:,:) - crys%avec(:,:) * crys%alat) > TOL_Small)) then
      if(peinf%inode == 0) then
        write(0,'(a,9f11.6)') 'read lattice vectors ', real_lattice(:,:)
        write(0,'(a,9f11.6)') 'should be ', crys%avec(:,:) * crys%alat
      endif
      call die("incorrect real-space lattice vectors", only_root_writes = .true.)
    endif

    read(chk_unit) ((recip_lattice(ii,jj),ii=1,3),jj=1,3)       ! Reciprocal lattice (a.u.)
    if(any(abs(real_lattice(:,:) - crys%bvec(:,:) * crys%alat) > TOL_Small)) then
      if(peinf%inode == 0) then
        write(0,'(a,9f11.6)') 'read lattice vectors ', recip_lattice(:,:)
        write(0,'(a,9f11.6)') 'should be ', crys%bvec(:,:) * crys%blat
      endif
      call die("incorrect reciprocal lattice vectors", only_root_writes = .true.)
    endif

    read(chk_unit) num_kpts                                     ! Number of k-points
    if(num_kpts < kg%nf) then
      if(peinf%inode == 0) write(0,'(a,i6,a,i6)') 'Need ', kg%nf, 'kpoints but file has only ', num_kpts
      call die("Not enough kpoints in " // trim(filename), only_root_writes = .true.)
    endif

    read(chk_unit) !(mp_grid(ii),ii=1,3) (don`t care)           ! M-P grid
    SAFE_ALLOCATE(kpt_latt, (3, num_kpts))
    read(chk_unit) ((kpt_latt(ii,ik),ii=1,3),ik=1,num_kpts)     ! K-points in lattice vectors
    read(chk_unit) !nntot (don`t care)                          ! Number of nearest k-point neighbours

    read(chk_unit) num_wann                                     ! Number of wannier functions
    if(iwann > num_wann) then
      if(peinf%inode == 0) write(0,'(2a)') 'Requested Wannier function ', iwann, ' > number of Wannier functions ', num_wann
      call die("iwann out of bounds", only_root_writes = .true.)
    endif
    read(chk_unit) chkpt1                                       ! Position of checkpoint
    if(trim(chkpt1) /= 'post_wann') then
      if(peinf%inode == 0) write(0,'(2a)') 'chkpt1 = ', trim(chkpt1)
      call die("Wannier90 checkpoint position must be post_wann.", only_root_writes = .true.)
    endif
    read(chk_unit) have_disentangled                            ! Whether a disentanglement has been performed
    if (have_disentangled) then
      call die("disentanglement not implemented")
!      read(chk_unit) omega_invariant     ! Omega invariant
! lwindow, ndimwin and U_matrix_opt 
!      read(chk_unit) ((lwindow(i,nkp),i=1,num_bands),nkp=1,num_kpts)
!      read(chk_unit) (ndimwin(nkp),nkp=1,num_kpts)
!      read(chk_unit) (((u_matrix_opt(i,j,nkp),i=1,num_bands),j=1,num_wann),nkp=1,num_kpts)
    endif
    SAFE_ALLOCATE(u_matrix, (num_wann, num_wann, num_kpts))
    read(chk_unit) (((u_matrix(ib,iw,ik),ib=1,num_wann),iw=1,num_wann),ik=1,num_kpts) ! U_matrix
!    read(chk_unit) ((((m_matrix(i,j,k,l),i=1,num_wann),j=1,num_wann),k=1,nntot),l=1,num_kpts) ! M_matrix
!    read(chk_unit) ((wannier_centres(i,j),i=1,3),j=1,num_wann)
!    read(chk_unit) (wannier_spreads(ib),i=1,num_wann)
    call close_file(chk_unit)

    ! relate wannier90 kpts to those in plotxct
    do ik = 1, kg%nf
      ikmatch = 0
      do ik2 = 1, num_kpts
        if(all(abs(kg%f(1:3, ik) - kpt_latt(1:3, ik2)) < TOL_Small)) then
          ikmatch = ik2
          exit
        endif
      enddo
      if(ikmatch > 0) then
        do ib = 1, nvband
          coefficients(ib, ik) = u_matrix(nvband - ib + 1, iwann, ikmatch)
        enddo
      else
        if(peinf%inode == 0) write(0,*) 'no match for kpoint ', kg%f(1:3, ik)
        call die("need kpoint not present in " // trim(filename), only_root_writes = .true.)
      endif
    enddo

    SAFE_DEALLOCATE(u_matrix)
    SAFE_DEALLOCATE(kpt_latt)
    
    POP_SUB(read_wannier)
    return
  end subroutine read_wannier
  
end module read_wannier_m

!=============================================================================
!
! Routines:
!
! (1) inread_kernel()
!
!     Read input parameters from file kernel.inp
!
!     input: none
!
!     output: xct%nvb_co
!             xct%ncb_co
!             xct%ecute    energy cutoff used to calculate the
!                          interaction matrices (see Rohlfing and Louie PRB 2000 eq. 43-45)
!             xct%read_kpoints     tells whether the list of k-points is taken
!                          from "WFN_fi" or from the input "kpoints"
!                          (useful if you are working with partial samplings)
!             flagbz = 0   use all symmetries to unfold the Brillouin zone
!                    = 1   do not unfold the Brillouin zone (default)
!
!=============================================================================

#include "f_defs.h"

subroutine inread_kernel(xct,flagbz,q0vec,qg)

  use global_m
  implicit none

  type (xctinfo), intent(out) :: xct
  integer, intent(out) :: flagbz  
  real(DP), intent(out) :: q0vec(3)
  type (grid), intent(out) :: qg


  character*256 :: keyword,line,errmsg,blockword
  integer :: iostat


  integer :: ii,jj,itestq
  real(DP) :: qpt_read(3,MAX_KPTS),div
  
  PUSH_SUB(inread_kernel)

#ifdef MPI
  ! Non-root nodes should wait for root to read the whole file.
  ! That way, we can be sure root gets a chance to write errors before
  ! any die call is issued by another node. Root calls MPI_Barrier below.
  if(peinf%inode /= 0) call MPI_Barrier(MPI_COMM_WORLD, mpierr)
#endif

!-------------------------
! Set default values

  xct%ecute=0.d0
  xct%ecutg=0.d0
  xct%read_kpoints = .false.
  xct%icutv=0
  xct%iscreen=0
  xct%iwritecoul=0
  xct%truncval(1:3)=0.0d0
  xct%bLowComm=.false.
  xct%shift(:)=0.d0
  xct%qflag=1
  xct%finiteq(:)=0.d0
  xct%ilowmem=0
  flagbz=1
  xct%efermi_input=0.0d0
  xct%rfermi=.true.
  xct%iwriteint=1
  xct%freplacebz=.false.
  xct%fwritebz=.false.
  xct%degeneracy_check_override=.true.
  xct%die_outside_sphere=.false.
  xct%extended_kernel=.false.
  xct%theory=0
  xct%coulomb_mod%short_range_frac_fock=1.0d0
  xct%coulomb_mod%long_range_frac_fock=1.0d0
  xct%coulomb_mod%screening_length=0.0d0
  xct%coul_mod_flag=.false.
  xct%patched_sampling_co=.false.
#ifdef HDF5
  xct%use_hdf5 = .true.
#else
  xct%use_hdf5 = .false.
#endif

!-----------------------------------
! Never ending loop...

  do while(0.eq.0)

! Actually the loop ends when the end of the file is reached

    read(8,'(a256)',iostat=iostat) line
    if(iostat < 0) exit

! Skip comment lines

    if(len_trim(line).eq.0) cycle
    if(line(1:1).eq.'#') cycle

! Determine keyword:

    keyword=line(1:scan(line," ")-1)
    line=adjustl(line(scan(line," ")+1:256))
    
    if(trim(keyword).eq.'number_val_bands') then
      read(line,*,err=110) xct%nvb_co
    elseif(trim(keyword).eq.'number_cond_bands') then
      read(line,*,err=110) xct%ncb_co
    elseif(trim(keyword).eq.'dont_use_hdf5') then
      xct%use_hdf5 = .false.
    elseif(trim(keyword).eq.'screened_coulomb_cutoff') then
      read(line,*,err=110) xct%ecute
    elseif(trim(keyword).eq.'bare_coulomb_cutoff') then
      read(line,*,err=110) xct%ecutg
    elseif(trim(keyword).eq.'read_kpoints') then
      xct%read_kpoints = .true.
    elseif(trim(keyword).eq.'screening_semiconductor') then
      xct%iscreen=0
    elseif(trim(keyword).eq.'screening_graphene') then
      xct%iscreen=1
    elseif(trim(keyword).eq.'screening_metal') then
      xct%iscreen=2
    elseif(trim(keyword).eq.'spherical_truncation') then
      xct%icutv=2
    elseif(trim(keyword).eq.'cell_wire_truncation') then
      xct%icutv=4
    elseif(trim(keyword).eq.'cell_box_truncation') then
      xct%icutv=5
    elseif(trim(keyword).eq.'cell_slab_truncation') then
      xct%icutv=6
    elseif(trim(keyword).eq.'write_vcoul') then
      xct%iwritecoul=1
    elseif(trim(keyword).eq.'comm_mpi') then
      xct%iwriteint=1
    elseif(trim(keyword).eq.'comm_disk') then
      xct%iwriteint=0
    elseif(trim(keyword).eq.'low_comm') then
      xct%bLowComm=.true.
    elseif(trim(keyword).eq.'low_memory') then
      xct%ilowmem=1
    elseif(trim(keyword).eq.'high_memory') then
      xct%ilowmem=-1
    elseif(trim(keyword).eq.'coulomb_truncation_radius') then
      read(line,*,err=110) xct%truncval(1)
    elseif(trim(keyword).eq.'fermi_level') then
      read(line,*,err=110) xct%efermi_input
    elseif(trim(keyword).eq.'fermi_level_absolute') then
      xct%rfermi=.false.
    elseif(trim(keyword).eq.'fermi_level_relative') then
      xct%rfermi=.true.
    elseif(trim(keyword).eq.'no_symmetries_coarse_grid') then
      flagbz = 1
    elseif(trim(keyword).eq.'use_symmetries_coarse_grid') then
      flagbz = 0
    elseif(trim(keyword).eq.'fullbz_replace') then
      xct%freplacebz=.true.
    elseif(trim(keyword).eq.'fullbz_write') then
      xct%fwritebz=.true.
! There is no problem with degeneracy in kernel, actually.
!    elseif(trim(keyword).eq.'degeneracy_check_override') then
!      xct%degeneracy_check_override=.true.
    elseif(trim(keyword).eq.'die_outside_sphere') then
      xct%die_outside_sphere=.true.
    elseif(trim(keyword).eq.'ignore_outside_sphere') then
      xct%die_outside_sphere=.false.
    else
      write(errmsg,'(3a)') 'Unexpected keyword ', trim(keyword), ' was found in kernel.inp.'
      call die(errmsg, only_root_writes = .true.)
    end if
  enddo
  
  if(abs(xct%ecute).lt.TOL_Zero .and. xct%theory.eq.0) then
    call die("The screened_coulomb_cutoff keyword could not be found.")
  endif

! FHJ: How many kernel blocks to compute?
  if (xct%extended_kernel) then
    if (peinf%inode==0) write(6,'(1x,a)') &
      "Calculating the kernel for all possible (n1,n2)->(n1',n2') transitions."
    xct%n1b_co = xct%nvb_co + xct%ncb_co
    xct%n2b_co = xct%n1b_co
    if (xct%ilowmem>=0.and.peinf%inode==0) then
      write (6,'(1x,a)') 'Note: this type of kernel calculation requires the high_memory flag.'
    endif
    xct%ilowmem=-1
  else
    if (peinf%inode==0) write(6,'(1x,a)') &
      "Calculating the kernel only for (v,c)->(v',c') transitions."
    xct%n1b_co = xct%nvb_co
    xct%n2b_co = xct%ncb_co
  endif
  if (peinf%inode==0) write(6,*)

! JRD: Make a note if we have finite Q

! JRD: What screening is present?

  if(peinf%inode.eq.0) then
    if(xct%iscreen.eq.0) then
      write(6,800)
    elseif(xct%iscreen.eq.1) then
      write(6,801)
    elseif(xct%iscreen.eq.2) then
      write(6,802)
    else
      call die('Need to specify screening type')
    endif
  endif
800 format(1x,'Running with Semiconductor Screening',/)
801 format(1x,'Running with Graphene Screening',/)
802 format(1x,'Running with Metal Screening',/)

  if(peinf%inode == 0) then
    if(xct%iwriteint == 1) then ! comm_mpi
      if(peinf%npes > 1) then
        write(6,803)
      else
        write(6,805)
      endif
    else ! comm_disk
      write(6,804)
    endif
  endif
803 format(1x,'We are communicating via MPI',/)
804 format(1x,'We are communicating via disk',/)
805 format(1x,'We are not communicating',/)

  if (peinf%inode == 0) then
    if (xct%ilowmem == 1) then
      write(6,'(1x,a)') 'We are using the low-memory option.'
    elseif (xct%ilowmem == -1) then
      write(6,'(1x,a)') 'We are using the high-memory option.'
    endif
    if(xct%bLowComm) then
      write(6,'(1x,a)') 'We are using the low-communication option.'
    endif
  endif

! JRD: What truncation scheme are we using?

  if(peinf%inode.eq.0) then
    if(xct%icutv.eq.0) then
      write(6,900)
    elseif(xct%icutv.eq.2) then
      write(6,902)
      write(6,912)xct%truncval(1)
    elseif(xct%icutv.eq.4) then
      write(6,904)
    elseif(xct%icutv.eq.5) then
      write(6,905)
    elseif(xct%icutv.eq.6) then
      write(6,906)
    endif
  endif
900 format(1x,'We are using no truncation',/)
902 format(1x,'We are using a truncated Coulomb interaction (spherical)')
904 format(1x,'We are using a truncated Coulomb interaction: Cell Wire',/)
905 format(1x,'We are using a truncated Coulomb interaction: Cell Box',/)
906 format(1x,'We are using a truncated Coulomb interaction: Cell Slab',/)
912 format(1x,'r_cut = ',f10.6,' Bohr'/)
  
#ifdef MPI
  ! root lets the others go after it is done reading (see beginning of function)
  if(peinf%inode == 0) call MPI_Barrier(MPI_COMM_WORLD, mpierr)
#endif

  POP_SUB(inread_kernel)
  
  return
  
110 write(errmsg,'(3a)') 'Unexpected characters were found while reading the value for the keyword ', &
      trim(keyword), '. '
  call die(errmsg, only_root_writes = .true.)
  
end subroutine inread_kernel

!>=========================================================================
!!
!! Module:
!!
!! (1) wfn_rho_vxc_io_m     Originally by DAS     Last Modified 10/17/2010 (DAS)
!!
!!     Routines to read and write wavefunctions, density, and Vxc, and 
!!     deallocate associated variables. The "type" routines use typedefs.
!!     The code is generated through repeated inclusion of a file with
!!     different preprocessor definitions each time. You are not expected to
!!     understand this. Consult the resulting .p.f file for clarity.
!!
!! Specification for ASCII matrix element files (vxc.dat, x.dat):
!! Matrix elements are in eV and are always written with real and imaginary parts.
!! They may contain any number of k-points in any order.
!! Each k-point block begins with the line:
!!   kx, ky, kz [crystal coordinates], ndiag*nspin, noffdiag*nspin
!! There are then ndiag*nspin lines of the form
!!   ispin, idiag, Re <idiag|V|idiag>, Im <idiag|V|idiag>
!! There are then noffdiag*nspin lines of the form
!!   ispin, ioff1, ioff2, Re <ioff1|V|ioff2>, Im <ioff1|V|ioff2>
!!
!!=========================================================================

#include "f_defs.h"

module wfn_rho_vxc_io_m

  use global_m
  use check_inversion_m
  use sort_m

  implicit none

  private
 !> For library usage, do not make global_m contents available
 !! to avoid namespace clashes.

  public ::                        &
    bgw_conf_test,                 &
    read_binary_header,            &
    write_binary_header,           &
    read_format_header,            &
    write_format_header,           &
    read_binary_header_type,       &
    write_binary_header_type,      &
    read_format_header_type,       &
    write_format_header_type,      &
    read_binary_gvectors,          &
    write_binary_gvectors,         &
    read_format_gvectors,          &
    write_format_gvectors,         &
    read_binary_real_data,         &
    write_binary_real_data,        &
    read_format_real_data,         &
    write_format_real_data,        &
    read_binary_complex_data,      &
    write_binary_complex_data,     &
    read_format_complex_data,      &
    write_format_complex_data,     &
    read_binary_data,              &
    write_binary_data,             &
    read_format_data,              &
    write_format_data,             &
    read_header,                   &
    write_header,                  &
    read_header_type,              &
    write_header_type,             &
    read_gvectors,                 &
    write_gvectors,                &
    read_real_data,                &
    write_real_data,               &
    read_complex_data,             &
    write_complex_data,            &
    read_data,                     &
    write_data,                    &
    dealloc_header,                &
    dealloc_header_type,           &
    dealloc_crys,                  &
    dealloc_kp,                    &
    check_header,                  &
    write_matrix_elements,         &
    write_matrix_elements_type,    &
    read_matrix_elements,          &
    read_matrix_elements_type,     &
    require_version,               &
    write_mf_header,               &
    read_mf_header,                &
    init_mf_header_from_types



!> These interfaces can be used to avoid explicit ifdef CPLX switches
  interface read_binary_data
    module procedure read_binary_real_data, read_binary_complex_data
  end interface

  interface write_binary_data
    module procedure write_binary_real_data, write_binary_complex_data
  end interface

  interface read_format_data
    module procedure read_format_real_data, read_format_complex_data
  end interface

  interface write_format_data
    module procedure write_format_real_data, write_format_complex_data
  end interface

  interface read_data
    module procedure read_real_data, read_complex_data
  end interface

  interface write_data
    module procedure write_real_data, write_complex_data
  end interface

  interface read_matrix_elements
    module procedure read_matrix_elements_real, read_matrix_elements_cplx
  end interface

  interface read_matrix_elements_type
    module procedure read_matrix_elements_type_real, read_matrix_elements_type_cplx
  end interface

contains

#define FORMATTED
#define READ
#include "wfn_rho_vxc_io_inc.f90"
!> write
#undef READ
#include "wfn_rho_vxc_io_inc.f90"

#undef FORMATTED
#define BINARY
#define READ
#include "wfn_rho_vxc_io_inc.f90"
!> write
#undef READ
#include "wfn_rho_vxc_io_inc.f90"

#undef BINARY
#define READ
#include "wfn_rho_vxc_io_inc.f90"
!> write
#undef READ
#include "wfn_rho_vxc_io_inc.f90"

#define TEMP_COMPLEX
#define FORMATTED
#define READ
#include "wfn_rho_vxc_io_inc.f90"
!> write
#undef READ
#include "wfn_rho_vxc_io_inc.f90"

#undef FORMATTED
#define BINARY
#define READ
#include "wfn_rho_vxc_io_inc.f90"
!> write
#undef READ
#include "wfn_rho_vxc_io_inc.f90"

#undef BINARY
#define READ
#include "wfn_rho_vxc_io_inc.f90"
!> write
#undef READ
#include "wfn_rho_vxc_io_inc.f90"

#undef TEMP_COMPLEX
#define TEMP_REAL
#define FORMATTED
#define READ
#include "wfn_rho_vxc_io_inc.f90"
!> write
#undef READ
#include "wfn_rho_vxc_io_inc.f90"

#undef FORMATTED
#define BINARY
#define READ
#include "wfn_rho_vxc_io_inc.f90"
!> write
#undef READ
#include "wfn_rho_vxc_io_inc.f90"

#undef BINARY
#define READ
#include "wfn_rho_vxc_io_inc.f90"
!> write
#undef READ
#include "wfn_rho_vxc_io_inc.f90"

!=========================================================================
!> this routine is purely for use in configure scripts to test module accessibility
subroutine bgw_conf_test()

  write(6,*) 'Yes, it works.'

end subroutine bgw_conf_test

!=========================================================================
!> this routine is used to write the ASCII files vxc.dat and x.dat, without typedefs types
subroutine write_matrix_elements(iunit, kk, nspin, ndiag, noffdiag, spin_index, diag, offdiag1, offdiag2, mtxel)
  integer, intent(in) :: iunit !< file unit to write to
  real(DP), intent(in) :: kk(3) !< kpoint to write, in crystal coords
  integer, intent(in) :: nspin !< number of spins to write
  integer, intent(in) :: ndiag !< number of diagonal elements to write
  integer, intent(in) :: noffdiag !< number of offdiagonal elements to write
  integer, intent(in) :: spin_index(:) !< (nspin) mapping of 1:nspin to actual spins. 3 choices:
    !! spin-unpolarized: spin_index(1) = 1
    !! spin-polarized: spin_index(1) = 1, spin_index(2) = 2
    !! spin-polarized, spin 2 only: spin_index(1) = 1, spin_index(2) = 2     
  integer, intent(in) :: diag(:) !< (ndiag) mapping of 1:ndiag onto band indices for diagonals
  integer, intent(in) :: offdiag1(:) !< (noffdiag) mapping of 1:noffdiag onto band indices for offdiagonal 1
  integer, intent(in) :: offdiag2(:) !< (noffdiag) mapping of 1:noffdiag onto band indices for offdiagonal 2
  complex(DPC), intent(in) :: mtxel(:,:) !< (ndiag+noffdiag,nspin)

  integer :: ispin, idiag, ioff

  PUSH_SUB(write_matrix_elements)

  if(any(spin_index(1:nspin) < 1 .or. spin_index(1:nspin) > 2)) &
    call die("write_matrix_elements: spin_index out of bounds")
  if(nspin < 1 .or. nspin > 2) call die("write_matrix_elements: nspin out of bounds")
  if(ndiag < 0) call die("write_matrix_elements: ndiag < 0")
  if(noffdiag < 0) call die("write_matrix_elements: noffdiag < 0")

  !> write header
  write(iunit,'(3f15.10,2i12)') kk(1:3), ndiag*nspin, noffdiag*nspin
  !> write diagonal matrix elements
  do idiag=1,ndiag
    do ispin=1,nspin
      write(iunit,'(i3,i10,2g22.10)') spin_index(ispin), diag(idiag), dble(mtxel(idiag,ispin)), IMAG(mtxel(idiag,ispin))
    enddo
  enddo
  !> write off-diagonal matrix elements
  do ioff=1,noffdiag
    do ispin=1,nspin
      write(iunit,'(i3,2i10,2g22.10)') spin_index(ispin), offdiag1(ioff), offdiag2(ioff), &
        dble(mtxel(ioff+ndiag,ispin)), IMAG(mtxel(ioff+ndiag,ispin))
    enddo
  enddo

  POP_SUB(write_matrix_elements)
  return
end subroutine write_matrix_elements

!=========================================================================
!> this routine is used to write the ASCII files vxc.dat and x.dat, with typedefs types
subroutine write_matrix_elements_type(iunit, kk, sig, mtxel)
  integer, intent(in) :: iunit !< file unit to write to
  real(DP), intent(in) :: kk(3) !< kpoint to write, in crystal coords
  type(siginfo), intent(in) :: sig !< structure containing other needed data
  complex(DPC), intent(in) :: mtxel(:,:) !< (sig%ndiag+sig%noffdiag,sig%nspin)

  PUSH_SUB(write_matrix_elements_type)

  call write_matrix_elements(iunit, kk, sig%nspin, sig%ndiag, sig%noffdiag, &
    sig%spin_index, sig%diag, sig%off1, sig%off2, mtxel)

  POP_SUB(write_matrix_elements_type)
  return
end subroutine write_matrix_elements_type

!=========================================================================
!> this routine is used to read the ASCII files vxc.dat and x.dat, without typedefs types. do not call directly
subroutine read_matrix_elements_base(iunit, iostat, kk, nspin, ndiag, noffdiag, &
  spin_index, diag, offdiag1, offdiag2, mtxel_real, mtxel_cplx)
  integer, intent(in) :: iunit !< file unit to read from
  integer, intent(out) :: iostat !< status of reading header, to detect end of file
  real(DP), intent(out) :: kk(3) !< kpoint read, in crystal coords
  integer, intent(in) :: nspin !< number of spins to read
  integer, intent(in) :: ndiag !< number of diagonal elements to read
  integer, intent(in) :: noffdiag !< number of offdiagonal elements to read
  integer, intent(in) :: spin_index(:) !< (nspin) mapping of 1:nspin to actual spins. 3 choices:
    !! spin-unpolarized: spin_index(1) = 1
    !! spin-polarized: spin_index(1) = 1, spin_index(2) = 2
    !! spin-polarized, spin 2 only: spin_index(1) = 1, spin_index(2) = 2     
  integer, intent(in) :: diag(:) !< (ndiag) mapping of 1:ndiag onto band indices for diagonals
  integer, intent(in) :: offdiag1(:) !< (noffdiag) mapping of 1:noffdiag onto band indices for offdiagonal 1
  integer, intent(in) :: offdiag2(:) !< (noffdiag) mapping of 1:noffdiag onto band indices for offdiagonal 2
  real(DP), optional, intent(out) :: mtxel_real(:,:) !< (ndiag+noffdiag,nspin) this or mtxel_cplx must be given
  complex(DPC), optional, intent(out) :: mtxel_cplx(:,:) !< (ndiag+noffdiag,nspin) this or mtxel_real must be given

  integer :: ispin, idiag, ioff, ime, ndiag_read, noffdiag_read, ispin_read, diag_read, off1_read, off2_read
  real(DP) :: mtxel_re, mtxel_im
  logical, allocatable :: found(:,:)

  PUSH_SUB(read_matrix_elements_base)

  if(any(spin_index(1:nspin) < 1 .or. spin_index(1:nspin) > 2)) &
    call die("read_matrix_elements: spin_index out of bounds")
  if(nspin < 1 .or. nspin > 2) call die("read_matrix_elements: nspin out of bounds")
  if(ndiag < 0) call die("read_matrix_elements: ndiag < 0")
  if(noffdiag < 0) call die("read_matrix_elements: noffdiag < 0")
  if((.not. present(mtxel_real) .and. .not. present(mtxel_cplx)) .or. (present(mtxel_real) .and. present(mtxel_cplx))) &
    call die("read_matrix elements must be called with exactly one of mtxel_real and mtxel_cplx")

  !> read header
  read(iunit,*,iostat = iostat) kk(1:3), ndiag_read, noffdiag_read
  if(iostat /= 0) then !< we are at the end of the file
    POP_SUB(read_matrix_elements)
    return
  endif

  if(ndiag_read < ndiag * nspin) call die("read_matrix_elements: not enough diagonals present")
  if(noffdiag_read < noffdiag * nspin) call die("read_matrix_elements: not enough offdiagonals present")
  
  SAFE_ALLOCATE(found, (ndiag+noffdiag,nspin))
  found(:,:) = .false.

  !> read diagonal matrix elements
  do ime = 1, ndiag_read
    read(iunit,*) ispin_read, diag_read, mtxel_re, mtxel_im
    if(present(mtxel_real) .and. abs(mtxel_im) > TOL_Zero) call die("cannot have complex matrix elements in real version")
    do ispin = 1, nspin
      do idiag = 1, ndiag
        if (spin_index(ispin) == ispin_read .and. diag(idiag) == diag_read) then
          if(present(mtxel_real)) then
            mtxel_real(idiag, ispin) = mtxel_re
          else
            mtxel_cplx(idiag, ispin) = CMPLX(mtxel_re, mtxel_im)
          endif
          found(idiag, ispin) = .true.
        endif
      enddo
    enddo
  enddo

  if(any(.not. found(1:ndiag, :))) then
    if(peinf%inode == 0) then
      write(0,*) 'missing diagonal matrix elements (band, spin): '
      do ispin = 1, nspin
        do idiag = 1, ndiag
          write(0,*) '(', diag(idiag), ',', spin_index(ispin), ')'
        enddo
      enddo
    endif
    call die("read_matrix_elements: not all needed data present")
  endif

  !> read off-diagonal matrix elements
  do ime = 1, noffdiag_read
    read(iunit,*) ispin_read, off1_read, off2_read, mtxel_re, mtxel_im
    if(present(mtxel_real) .and. abs(mtxel_im) > TOL_Zero) call die("cannot have complex matrix elements in real version")
    do ispin = 1, nspin
      do ioff = 1, noffdiag
        if (spin_index(ispin) == ispin_read .and. offdiag1(ioff) == off1_read .and. offdiag2(ioff) == off2_read) then
          if(present(mtxel_real)) then
            mtxel_real(ndiag + ioff, ispin) = mtxel_re
          else
            mtxel_cplx(ndiag + ioff, ispin) = CMPLX(mtxel_re, mtxel_im)
          endif
          found(ndiag + ioff, ispin) = .true.
        endif
      enddo
    enddo
  enddo

  if(any(.not. found(ndiag + 1:ndiag + noffdiag, :))) then
    if(peinf%inode == 0) then
      write(0,*) 'missing off-diagonal matrix elements (band, band, spin): '
      do ispin = 1, nspin
        do ioff = 1, noffdiag
          write(0,*) '(', offdiag1(ioff), ',', offdiag2(ioff), ',', spin_index(ispin), ')'
        enddo
      enddo
    endif
    call die("read_matrix_elements: not all needed data present")
  endif

  SAFE_DEALLOCATE(found)

  POP_SUB(read_matrix_elements_base)
  return
end subroutine read_matrix_elements_base

!=========================================================================
!> this routine is used to read the ASCII files vxc.dat and x.dat, without typedefs types, with real output
subroutine read_matrix_elements_real(iunit, iostat, kk, nspin, ndiag, noffdiag, spin_index, diag, offdiag1, offdiag2, mtxel)
  integer, intent(in) :: iunit !< file unit to read from
  integer, intent(out) :: iostat !< status of reading header, to detect end of file
  real(DP), intent(out) :: kk(3) !< kpoint read, in crystal coords
  integer, intent(in) :: nspin !< number of spins to read
  integer, intent(in) :: ndiag !< number of diagonal elements to read
  integer, intent(in) :: noffdiag !< number of offdiagonal elements to read
  integer, intent(in) :: spin_index(:) !< (nspin) mapping of 1:nspin to actual spins. 3 choices:
    !! spin-unpolarized: spin_index(1) = 1
    !! spin-polarized: spin_index(1) = 1, spin_index(2) = 2
    !! spin-polarized, spin 2 only: spin_index(1) = 1, spin_index(2) = 2     
  integer, intent(in) :: diag(:) !< (ndiag) mapping of 1:ndiag onto band indices for diagonals
  integer, intent(in) :: offdiag1(:) !< (noffdiag) mapping of 1:noffdiag onto band indices for offdiagonal 1
  integer, intent(in) :: offdiag2(:) !< (noffdiag) mapping of 1:noffdiag onto band indices for offdiagonal 2
  real(DP), intent(out) :: mtxel(:,:) !< (ndiag+noffdiag,nspin)

  PUSH_SUB(read_matrix_elements_real)

  call read_matrix_elements_base(iunit, iostat, kk, nspin, ndiag, noffdiag, &
    spin_index, diag, offdiag1, offdiag2, mtxel_real = mtxel)

  POP_SUB(read_matrix_elements_real)
  return
end subroutine read_matrix_elements_real

!=========================================================================
!> this routine is used to read the ASCII files vxc.dat and x.dat, without typedefs types, with cplx output
subroutine read_matrix_elements_cplx(iunit, iostat, kk, nspin, ndiag, noffdiag, spin_index, diag, offdiag1, offdiag2, mtxel)
  integer, intent(in) :: iunit !< file unit to read from
  integer, intent(out) :: iostat !< status of reading header, to detect end of file
  real(DP), intent(out) :: kk(3) !< kpoint read, in crystal coords
  integer, intent(in) :: nspin !< number of spins to read
  integer, intent(in) :: ndiag !< number of diagonal elements to read
  integer, intent(in) :: noffdiag !< number of offdiagonal elements to read
  integer, intent(in) :: spin_index(:) !< (nspin) mapping of 1:nspin to actual spins. 3 choices:
    !! spin-unpolarized: spin_index(1) = 1
    !! spin-polarized: spin_index(1) = 1, spin_index(2) = 2
    !! spin-polarized, spin 2 only: spin_index(1) = 1, spin_index(2) = 2     
  integer, intent(in) :: diag(:) !< (ndiag) mapping of 1:ndiag onto band indices for diagonals
  integer, intent(in) :: offdiag1(:) !< (noffdiag) mapping of 1:noffdiag onto band indices for offdiagonal 1
  integer, intent(in) :: offdiag2(:) !< (noffdiag) mapping of 1:noffdiag onto band indices for offdiagonal 2
  complex(DPC), intent(out) :: mtxel(:,:) !< (ndiag+noffdiag,nspin)

  PUSH_SUB(read_matrix_elements_cplx)

  call read_matrix_elements_base(iunit, iostat, kk, nspin, ndiag, noffdiag, &
    spin_index, diag, offdiag1, offdiag2, mtxel_cplx = mtxel)

  POP_SUB(read_matrix_elements_cplx)
  return
end subroutine read_matrix_elements_cplx

!=========================================================================
!> this routine is used to read the ASCII files vxc.dat and x.dat, with typedefs types, with real output
subroutine read_matrix_elements_type_real(iunit, iostat, kk, sig, mtxel)
  integer, intent(in) :: iunit !< file unit to read from
  integer, intent(out) :: iostat !< status of reading header, to detect end of file
  real(DP), intent(out) :: kk(3) !< kpoint read, in crystal coords
  type(siginfo), intent(in) :: sig !< structure containing other needed data
  real(DP), intent(out) :: mtxel(:,:) !< (ndiag+noffdiag,nspin)

  PUSH_SUB(read_matrix_elements_type_real)

  call read_matrix_elements(iunit, iostat, kk, sig%nspin, sig%ndiag, sig%noffdiag, &
    sig%spin_index, sig%diag, sig%off1, sig%off2, mtxel)

  POP_SUB(read_matrix_elements_type_real)
  return
end subroutine read_matrix_elements_type_real

!=========================================================================
!> this routine is used to read the ASCII files vxc.dat and x.dat, with typedefs types, with cplx output
subroutine read_matrix_elements_type_cplx(iunit, iostat, kk, sig, mtxel)
  integer, intent(in) :: iunit !< file unit to read from
  integer, intent(out) :: iostat !< status of reading header, to detect end of file
  real(DP), intent(out) :: kk(3) !< kpoint read, in crystal coords
  type(siginfo), intent(in) :: sig !< structure containing other needed data
  complex(DPC), intent(out) :: mtxel(:,:) !< (ndiag+noffdiag,nspin)

  PUSH_SUB(read_matrix_elements_type_cplx)

  call read_matrix_elements(iunit, iostat, kk, sig%nspin, sig%ndiag, sig%noffdiag, &
    sig%spin_index, sig%diag, sig%off1, sig%off2, mtxel)

  POP_SUB(read_matrix_elements_type_cplx)
  return
end subroutine read_matrix_elements_type_cplx

!=========================================================================
!> deallocate variables allocated by read_header
  subroutine dealloc_header(sheader, atyp, apos, ngk, kw, kpt, ifmin, ifmax, energies, occupations)
    character(len=3), intent(in) :: sheader
    integer, pointer, intent(inout) :: atyp(:)
    real(DP), pointer, intent(inout) :: apos(:,:)
    integer, pointer, intent(inout) :: ngk(:)
    real(DP), pointer, intent(inout) :: kw(:), kpt(:, :)
    integer, pointer, intent(inout) :: ifmin(:, :), ifmax(:, :)
    real(DP), pointer, intent(inout) :: energies(:, :, :)
    real(DP), pointer, intent(inout) :: occupations(:, :, :)

    logical :: wfnflag

    PUSH_SUB(dealloc_header)

    if (sheader .eq. 'WFN') then
      wfnflag = .true.
    elseif (sheader .eq. 'RHO' .or. sheader .eq. 'VXC') then
      wfnflag = .false.
    else
      call die("unknown file header: '" // sheader // "' (should be 'WFN'/'RHO'/'VXC')")
    endif
    
    SAFE_DEALLOCATE_P(atyp)
    SAFE_DEALLOCATE_P(apos)
    if (wfnflag) then
      SAFE_DEALLOCATE_P(ngk)
      SAFE_DEALLOCATE_P(kw)
      SAFE_DEALLOCATE_P(kpt)
      SAFE_DEALLOCATE_P(ifmin)
      SAFE_DEALLOCATE_P(ifmax)
      SAFE_DEALLOCATE_P(energies)
      SAFE_DEALLOCATE_P(occupations)
    endif

    POP_SUB(dealloc_header)
    return
  end subroutine dealloc_header

!=========================================================================
  subroutine dealloc_header_type(sheader, crys, kp)
    character(len=3), intent(in) :: sheader
    type(crystal), intent(inout) :: crys
    type(kpoints), intent(inout) :: kp

    PUSH_SUB(dealloc_header_type)

    call dealloc_header(sheader, crys%atyp, crys%apos, kp%ngk, kp%w, kp%rk, kp%ifmin, kp%ifmax, kp%el, kp%occ)

    POP_SUB(dealloc_header_type)
    return
  end subroutine dealloc_header_type

!=========================================================================
  subroutine dealloc_kp(kp)
    type(kpoints), intent(inout) :: kp

    PUSH_SUB(dealloc_kp)

    SAFE_DEALLOCATE_P(kp%ngk)
    SAFE_DEALLOCATE_P(kp%w)
    SAFE_DEALLOCATE_P(kp%rk)
    SAFE_DEALLOCATE_P(kp%ifmin)
    SAFE_DEALLOCATE_P(kp%ifmax)
    SAFE_DEALLOCATE_P(kp%el)
    SAFE_DEALLOCATE_P(kp%occ)

    POP_SUB(dealloc_kp)
    return
  end subroutine dealloc_kp

!=========================================================================
  subroutine dealloc_crys(crys)
    type(crystal), intent(inout) :: crys

    PUSH_SUB(dealloc_crys)

    SAFE_DEALLOCATE_P(crys%atyp)
    SAFE_DEALLOCATE_P(crys%apos)

    POP_SUB(dealloc_crys)
    return
  end subroutine dealloc_crys

!=========================================================================
!> detect incompatibility between header info for wfns supposedly describing same system
  subroutine check_header(name, kp, gvec, syms, crys, name2, kp2, gvec2, syms2, crys2, is_wfn, tolerant)
    character(len=*), intent(in) :: name
    type(kpoints), intent(in) :: kp
    type(gspace), intent(in) :: gvec
    type(symmetry), intent(in) :: syms
    type(crystal), intent(in) :: crys
    character(len=*), intent(in) :: name2
    type(kpoints), intent(in) :: kp2
    type(gspace), intent(in) :: gvec2
    type(symmetry), intent(in) :: syms2
    type(crystal), intent(in) :: crys2
    logical, intent(in) :: is_wfn
      !< set to false if RHO or VXC is one of the two being compared to avoid checking uninitialized fields
    logical, optional, intent(in) :: tolerant !< set to true to allow difference in symmetries and atoms

    character*100 :: string
    logical :: tolerant_

    PUSH_SUB(check_header)

    tolerant_ = .false.
    if(present(tolerant)) tolerant_ = tolerant
    string = TRUNC(name) // " vs. " // TRUNC(name2)

    !> kpoints
    if(kp%nspin /= kp2%nspin) call die(TRUNC(string) // ": spin mismatch")
    if(kp%nspinor /= kp2%nspinor) call die(TRUNC(string) // ": nspinor mismatch")
    if(is_wfn .and. abs(kp%ecutwfc - kp2%ecutwfc) > TOL_Small) call die(TRUNC(string) // ": wfn cutoff mismatch")

    !> gspace
    if(gvec%ng /= gvec2%ng) call die(TRUNC(string) // ": total number of G-vectors mismatch")
    if(abs(gvec%ecutrho - gvec2%ecutrho) > TOL_Small) call die(TRUNC(string) // ": charge-density cutoff mismatch")
    if(any(gvec%FFTgrid(1:3) /= gvec2%FFTgrid(1:3))) call die(TRUNC(string) // ": FFT grid mismatch")

    if(.not. tolerant_) then
      !> symmetries
      if(syms%ntran /= syms2%ntran) call die(TRUNC(string) // ": number of symmetries mismatch")
      if(syms%cell_symmetry /= syms2%cell_symmetry) call die(TRUNC(string) // ": type of cell symmetry mismatch")
      if(any(syms%mtrx(1:3, 1:3, 1:syms%ntran) /= syms2%mtrx(1:3, 1:3, 1:syms2%ntran))) &
        call die(TRUNC(string) // ": symmetry rotation matrix mismatch")
      if(any(abs(syms%tnp(1:3, 1:syms%ntran) - syms2%tnp(1:3, 1:syms2%ntran)) > TOL_Small)) &
        call die(TRUNC(string) // ": symmetry fractional translation mismatch")

      !> atoms
      if(crys%nat /= crys2%nat) call die(TRUNC(string) // ": number of atoms mismatch")
      if(any(crys%atyp(1:crys%nat) /= crys2%atyp(1:crys2%nat))) call die(TRUNC(string) // ": atom species mismatch")
      if(any(abs(crys%alat * crys%apos(1:3, 1:crys%nat) - crys2%alat * crys2%apos(1:3, 1:crys2%nat)) > TOL_Small)) &
        call die(TRUNC(string) // ": atom position mismatch")
    endif

    !> lattice
    if(abs(crys%celvol - crys2%celvol) > TOL_Small) call die(TRUNC(string) // ": cell volume mismatch")
    if(abs(crys%recvol - crys2%recvol) > TOL_Small) call die(TRUNC(string) // ": reciprocal cell volume mismatch")
    if(any(abs(crys%alat * crys%avec(1:3, 1:3) - crys2%alat * crys2%avec(1:3, 1:3)) > TOL_Small)) &
      call die(TRUNC(string) // ": lattice vector mismatch")
    if(any(abs(crys%blat * crys%bvec(1:3, 1:3) - crys2%blat * crys2%bvec(1:3, 1:3)) > TOL_Small)) &
      call die(TRUNC(string) // ": reciprocal lattice vector mismatch")
    if(any(abs(crys%adot(1:3, 1:3) - crys2%adot(1:3, 1:3)) > TOL_Small)) &
      call die(TRUNC(string) // ": real-space metric mismatch")
    if(any(abs(crys%bdot(1:3, 1:3) - crys2%bdot(1:3, 1:3)) > TOL_Small)) &
      call die(TRUNC(string) // ": reciprocal-space metric mismatch")

    POP_SUB(check_header)
    return
  end subroutine check_header

  !> require `version` to be the same as `version_ref`
  subroutine require_version(fname, version, version_ref)
    character(len=*), intent(in) :: fname
    integer, intent(in) :: version
    integer, intent(in) :: version_ref
    
    PUSH_SUB(require_version)

    if (version/=version_ref) then
      if (peinf%inode==0) then
        write(0,*) 'ERROR: Wrong version for file "'//TRUNC(fname)//'".'
        write(0,*) 'Expected: ', version_ref
        write(0,*) 'Got: ', version
      endif
      call die('Wrong version for file "'//TRUNC(fname)//'".', only_root_writes=.true.)
    endif

    POP_SUB(require_version)

  end subroutine require_version

  !> A high-level wrapper for write_*_header* functions
  subroutine write_mf_header(iunit, mf)
    integer, intent(in) :: iunit
    type(mf_header_t), intent(in) :: mf

    character(len=3) :: sheader
    character(len=16) :: fmt_str
    logical :: is_fmt = .false.

    PUSH_SUB(write_mf_header)

    if (peinf%inode==0) then
      inquire(unit=iunit, form=fmt_str)
      if (TRUNC(fmt_str)=='FORMATTED') then
        is_fmt = .true.
      else if (TRUNC(fmt_str)/='UNFORMATTED') then
        call die('Unkown value for formatted string: '//TRUNC(fmt_str), &
          only_root_writes=.true.)
      endif
    endif
    ! FHJ: No need to bcast is_fmt because only inode==0 reads the file.

    sheader = mf%sheader
    call write_header_type(iunit, is_fmt, sheader, mf%iflavor, &
      mf%kp, mf%gvec, mf%syms, mf%crys, version=mf%version)

    POP_SUB(write_mf_header)

  end subroutine write_mf_header
  
  !> A high-level wrapper for write_*_header* functions
  subroutine read_mf_header(iunit, mf, iflavor, sheader, warn, dont_warn_kgrid)
    integer, intent(in) :: iunit
    type(mf_header_t), intent(out) :: mf
    integer, intent(in), optional :: iflavor
    character(len=3), intent(in), optional :: sheader
    logical, intent(in), optional :: warn
    logical, intent(in), optional :: dont_warn_kgrid

    character(len=16) :: fmt_str
    logical :: is_fmt = .false.

    PUSH_SUB(read_mf_header)

    if (peinf%inode==0) then
      inquire(unit=iunit, form=fmt_str)
      if (TRUNC(fmt_str)=='FORMATTED') then
        is_fmt = .true.
      else if (TRUNC(fmt_str)/='UNFORMATTED') then
        call die('Unkown value for formatted string: '//TRUNC(fmt_str), &
          only_root_writes=.true.)
      endif
    endif
    ! FHJ: No need to bcast is_fmt because only inode==0 reads the file.

    if (present(sheader)) then
      mf%sheader = sheader
    else
      mf%sheader = 'GET'
    endif
    if (present(iflavor)) then
      mf%iflavor = iflavor
    else
      mf%iflavor = -1
    endif
    call read_header_type(iunit, is_fmt, mf%sheader, mf%iflavor, &
      mf%kp, mf%gvec, mf%syms, mf%crys, version=mf%version, sdate=mf%sdate, stime=mf%stime, &
      warn=warn, dont_warn_kgrid=dont_warn_kgrid)

    POP_SUB(read_mf_header)

  end subroutine read_mf_header

  !> Routine to initialize the mf_header_t type from a bunch of separated data types
  subroutine init_mf_header_from_types(mf_header, sheader, iflavor, version, kp, gvec, syms, crys)
    type(mf_header_t), intent(out) :: mf_header
    character(len=*), intent(in) :: sheader
    integer, intent(in) :: iflavor
    integer, intent(in) :: version
    type(kpoints), intent(in) :: kp
    type(gspace), intent(in) :: gvec
    type(symmetry), intent(in) :: syms
    type(crystal), intent(in) :: crys

    PUSH_SUB(init_mf_header_from_types)

    mf_header%version = version
    mf_header%sheader = sheader
    mf_header%sdate = ''
    mf_header%stime = ''
    mf_header%iflavor = iflavor
    mf_header%kp = kp
    mf_header%gvec = gvec
    mf_header%syms = syms
    mf_header%crys = crys

    POP_SUB(init_mf_header_from_types)

  end subroutine init_mf_header_from_types


end module wfn_rho_vxc_io_m

!! Local Variables:
!! mode: f90
!! coding: utf-8
!! End:

!>================================================================================
!!
!! Modules:
!!
!! (1) nrtype_m      Originally By ?      Last Modified 8/22/2010 (gsm)
!!
!!     Global constants and parameters.
!!
!!================================================================================

#include "f_defs.h"

#ifdef HDF5
#define AUTO_VER(x) VER_ ## x ## _HDF5
#else
#define AUTO_VER(x) VER_ ## x ## _FORT
#endif

module nrtype_m
    
  implicit none

  public ! only public parameters here

! Below are the version number for each BerkeleyGW file. These numbers should
! be changed whenever the structure of the file is altered and there`s either
! incompatibility with the previous version or a new feature. The version
! should be -1 if that file is not versioned yet, which corresponds to
! the formats used in the Berkeley 1.0.x family.
  integer, parameter :: VER_WFN_FORT = -1
  integer, parameter :: VER_WFN_HDF5 = 1
  integer, parameter :: VER_WFN = AUTO_VER(WFN)
  integer, parameter :: VER_EPS_FORT = -1
  integer, parameter :: VER_EPS_HDF5 = 1
  integer, parameter :: VER_EPS = AUTO_VER(EPS)
  integer, parameter :: VER_BSE_FORT = 1
  integer, parameter :: VER_BSE_HDF5 = 1
  integer, parameter :: VER_BSE = AUTO_VER(BSE)

!> Maximum number of bands supported by the *inread* routines. This sets the
!! size of arrays such as "occupations". These arrays should all be allocated
!! dynamically in the future.
  integer, parameter :: MAX_BANDS = 1000000 ! "occupations" array => 7MB
!> Maximum number of {k,q}-points supported by the *inread* routines.
!! The actual number of k-points/q-points in the WFN/bsemat/epsmat files
!! can be larger.
  integer, parameter :: MAX_KPTS = 100000 ! "kpt_read" array => 0.8 MB

!> parameters for real-space resolution in cell-truncation schemes
  integer, parameter :: n_in_box = 2
  integer, parameter :: n_in_wire = 4

!> parameter for construction of Wigner-Seitz cell
  integer, parameter :: ncell = 3

!> number of Monte-Carlo integration points
  integer, parameter :: nmc_coarse = 250000
  integer, parameter :: nmc_fine = 2500000
  integer, parameter :: nmc = nmc_fine

!> type definitions following the convention of Numerical Recipes
!! do not ever use single-precision!!
!  integer, parameter :: SP = kind(1.0)
  integer, parameter :: DP = kind(1.0d0)
!  integer, parameter :: SPC = kind((1.0,1.0))
  integer, parameter :: DPC = kind((1.0d0,1.0d0))

!> a shift on the grid in order to avoid the singularity for truncation
  real(DP), parameter :: trunc_shift(3) = (/0.5d0, 0.5d0, 0.5d0/)

!> physical constants
!!
!! These are the "2010 CODATA recommended values" taken from
!! "The NIST Reference on Constants, Units, and Uncertainty"
!! http://physics.nist.gov/cuu/
!!
!! The following variables are used throughout the package:
!!     'BOHR', 'bohr' is Bohr radius, in Angstrom
!!     'RYD', 'ryd2eV', 'rydberg' is Rydberg constant times hc, in eV
!!     'HARTREE', 'hartree' is Hartree energy, in eV
!!     'LIGHTSPEED' is inverse alpha (fine-structure constant)
!!
!! These variables are defined in the following files:
!!     Common/nrtype.f90
!!     Common/svninfo.f90
!!     Common/wfn_utils.cpp
!!     MeanField/EPM/ff2vq.py
!!     MeanField/EPM/sysParams.f90
!!     MeanField/EPM/vca.py
!!     MeanField/ICM/icm.cpp
!!     Visual/common.py
!!
  real(DP), parameter :: BOHR = 0.52917721092_dp
  real(DP), parameter :: RYD = 13.60569253_dp
  real(DP), parameter :: LIGHTSPEED = 137.035999074_dp

!> mathematical constants
!!  real(SP), parameter :: PI_S = 3.1415926535897932384626433832795_sp
  real(DP), parameter :: PI_D = 3.1415926535897932384626433832795_dp
  real(DP), parameter :: TOL_Small = 1.0d-6
  real(DP), parameter :: TOL_Zero = 1.0d-12
  real(DP), parameter :: TOL_Degeneracy = 1.0d-6
  real(DP), parameter :: INF = 1.0d12

!> string constants appearing at output
  character(len=16) :: ondate = 'Run on'
  character(len=16) :: attime = 'at'

end module nrtype_m

#undef AUTO_VER

!-------------------------------------------------------------------------------
!
!   Routines for kgrid.x
!   Generates a list of k-points with a small q-shift for espresso input file
!   inspired by espresso-3.2.3/pwtools/kpoints.f
!   written by G. Samsonidze (March 2008)
!
!-------------------------------------------------------------------------------

#include "f_defs.h"

module kgrid_routines_m

  use global_m
  use misc_m

  implicit none
  
  private

  public :: fold, reduce, sort, dqunfold, dqsubgrp, dqfold, dqsort, write_sym, &
    write_espresso, write_octopus

contains

!-------------------------------------------------------------------------------

  subroutine fold(nkf,kpoint,kweight,kfold,ksymmetry,nr,r,trs,eps)
    integer, intent(in) :: nkf
    real(DP), intent(in) :: kpoint(:,:) !< (3,nkf)
    integer, intent(inout) :: kweight(:) !< (nkf)
    integer, intent(inout) :: kfold(:) !< (nkf)
    integer, intent(inout) :: ksymmetry(:) !< (nkf)
    integer, intent(in) :: nr
    integer, intent(in) :: r(:,:,:) !< (3,3,48)
    logical, intent(in) :: trs !< time-reversal symmetry
    real(DP), intent(in) :: eps
    
    integer :: ik1,ik2,ikf,ir,gpt(3)
    real(DP) :: k(3)
    
    PUSH_SUB(fold)
    
    do ik1 = 1, nkf
! DAS: a cleaner way to write the loop, removing warning about infinite loop
      ir_loop: do ir = 1, nr
        k(1:3) = matmul(dble(r(1:3, 1:3, ir)), kpoint(1:3, ik1))
        call k_range(k,gpt,eps)
! DAS: a cleaner way to write the loop, removing warning about infinite loop
        do ik2 = 1, ik1 - 1
          if(all(abs(k(1:3)-kpoint(1:3,ik2)-dble(nint(k(1:3)-kpoint(1:3,ik2)))).lt.eps) .or. &
            (trs .and. all(abs(k(1:3)+kpoint(1:3,ik2)-dble(nint(k(1:3)+kpoint(1:3,ik2)))).lt.eps))) then
            kweight(ik1)=0
            ikf=ik2
            do while(kweight(ikf).eq.0)
              ikf=kfold(ikf)
            enddo
            kweight(ikf)=kweight(ikf)+1
            kfold(ik1)=ikf
            ksymmetry(ik1)=ir
            exit ir_loop
          endif
        enddo
      enddo ir_loop
    enddo
    
    POP_SUB(fold)
    return
    
  end subroutine fold
  
!-------------------------------------------------------------------------------

  subroutine reduce(nkf,kweight,kfold)
    integer, intent(in) :: nkf
    integer, intent(inout) :: kweight(:),kfold(:) !< (nkf)
    
    integer :: ik1,ik2
    integer, allocatable :: ws(:),fs(:)
    
    PUSH_SUB(reduce)
    
    SAFE_ALLOCATE(ws, (nkf))
    SAFE_ALLOCATE(fs, (nkf))
    do ik1=1,nkf
      if (kweight(ik1).gt.0) then
        do ik2=1,nkf
          if (kfold(ik2).eq.ik1.or.ik2.eq.ik1) then
            ws(ik2)=0
            fs(ik2)=ik1
          endif
        enddo
        ws(ik1)=kweight(ik1)
        fs(ik1)=0
      endif
    enddo
    kweight(1:nkf)=ws(1:nkf)
    kfold(1:nkf)=fs(1:nkf)
    SAFE_DEALLOCATE(ws)
    SAFE_DEALLOCATE(fs)
    
    POP_SUB(reduce)
    return
    
  end subroutine reduce

!-------------------------------------------------------------------------------

  subroutine sort(nkf,nkr,kpoint,kweight,kindex,eps)
    integer, intent(in) :: nkf,nkr
    real(DP), intent(in) :: kpoint(:,:) !< (3,nkf)
    integer, intent(inout) :: kweight(:) !< (nkf)
    integer, intent(out) :: kindex(:) !< (nkf)
    real(DP), intent(in) :: eps
    
    integer :: ik1,ik2,ki1,ki2
    
    PUSH_SUB(sort)
    
    ik1=0
    do ik2=1,nkf
      if (kweight(ik2).gt.0) then
        ik1=ik1+1
        kindex(ik1)=ik2
      endif
    enddo
    do ik1=1,nkr
      do ik2=1,nkr-1
        if ((kpoint(1,kindex(ik2+1)).lt. &
          kpoint(1,kindex(ik2))-eps).or. &
          (abs(kpoint(1,kindex(ik2+1))- &
          kpoint(1,kindex(ik2))).lt.eps.and. &
          kpoint(2,kindex(ik2+1)).lt. &
          kpoint(2,kindex(ik2))-eps).or. &
          (abs(kpoint(1,kindex(ik2+1))- &
          kpoint(1,kindex(ik2))).lt.eps.and. &
          abs(kpoint(2,kindex(ik2+1))- &
          kpoint(2,kindex(ik2))).lt.eps.and. &
          kpoint(3,kindex(ik2+1)).lt. &
          kpoint(3,kindex(ik2))-eps)) then
          ki1=kindex(ik2)
          ki2=kindex(ik2+1)
          kindex(ik2)=ki2
          kindex(ik2+1)=ki1
        endif
      enddo
    enddo
    
    POP_SUB(sort)
    return
    
  end subroutine sort
  
!-------------------------------------------------------------------------------

  subroutine dqunfold(nkr,kr,nkf,kf,kfw,nr,r,trs,eps)
    integer, intent(in) :: nkr !< number of kpoints before unfolding
    real(DP), intent(in) :: kr(:,:) !< (3,nkr) coords of kpoints before unfolding
    integer, intent(out) :: nkf
    real(DP), intent(out) :: kf(:,:) !< (3,nkf)
    real(DP), intent(out) :: kfw(:) !< (nkf)
    integer, intent(in) :: nr !< number of symmetries with which to unfold
    integer, intent(in) :: r(:,:,:) !< (3,3,48) symmetry matrices
    logical, intent(in) :: trs !< time-reversal symmetry
    real(DP), intent(in) :: eps
    
    integer :: ikr,ikf,ir,gpt(3)
    real(DP) :: k(3),minusk(3)
    logical :: add_kpt, add_kpt_trs
    
    PUSH_SUB(dqunfold)
    
    nkf=0
    do ikr=1,nkr
      ! see whether it is unique, with and without trs
      do ir=1,nr
        k(1:3) = matmul(dble(r(1:3, 1:3, ir)), kr(1:3, ikr))
        minusk(1:3) = -k(1:3)
        call k_range(k,gpt,eps)
        call k_range(minusk,gpt,eps)

        add_kpt = .true.
        add_kpt_trs = trs .and. .not. all(abs(k(1:3)-minusk(1:3)).lt.eps)
        if (nkf.gt.0) then
          do ikf=1,nkf
            if (all(abs(kf(1:3,ikf)-k(1:3)).lt.eps)) add_kpt = .false.
            if (all(abs(kf(1:3,ikf)-minusk(1:3)).lt.eps)) add_kpt_trs=.false.
          enddo
        endif
        if(add_kpt) then
          nkf=nkf+1
          kf(1:3,nkf)=k(1:3)
          kfw(nkf)=1.0d0
        endif
        if(add_kpt_trs) then
          nkf=nkf+1
          kf(1:3,nkf)=minusk(1:3)
          kfw(nkf)=1.0d0
        endif
      enddo
    enddo

    POP_SUB(dqunfold)
    return
    
  end subroutine dqunfold

!-------------------------------------------------------------------------------
  
  subroutine dqsubgrp(dq,nr,r,nrq,rq,syms,trs,eps)
    real(DP), intent(in) :: dq(:) !< (3)
    integer, intent(in) :: nr
    integer, intent(in) :: r(:,:,:) !< (3,3,48)
    integer, intent(out) :: nrq
    integer, intent(out) :: rq(:,:,:) !< (3,3,48)
    logical, intent(out) :: syms(:) !< (48)
    logical, intent(out) :: trs !< time-reversal symmetry
    real(DP), intent(in) :: eps
    
    integer :: ir,irq
    real(DP) :: k(3)
    integer :: rq_inv(3,3)
    
    PUSH_SUB(dqsubgrp)
    
    irq=0
    do ir=1,nr
      syms(ir)=.false.
      k(1:3) = matmul(dble(r(1:3, 1:3, ir)), dq(1:3))
      if (all(abs(k(1:3)-dq(1:3)).lt.eps)) then
        irq=irq+1
        rq(1:3,1:3,irq)=r(1:3,1:3,ir)
        syms(ir)=.true.
      endif
    enddo
    nrq=irq
    do irq=1,nrq
      call invert_matrix_int(rq(1:3, 1:3, irq), rq_inv)
      rq(1:3, 1:3, irq) = rq_inv(1:3, 1:3)
    enddo
    
    ! is dq invariant under time-reversal symmetry?
    trs = all(abs(dq(:)) < eps .or. abs(abs(dq(:)) - 0.5d0) < eps)

    POP_SUB(dqsubgrp)
    return
  
  end subroutine dqsubgrp

!-------------------------------------------------------------------------------

  subroutine dqfold(nkf,kf,kfw,nkq,kq,kqw,nrq,rq,trs,eps)
    integer, intent(in) :: nkf
    real(DP), intent(in) :: kf(:,:) !< (3,nkf)
    real(DP), intent(in) :: kfw(:) !< (nkf)
    integer, intent(inout) :: nkq
    real(DP), intent(out) :: kq(:,:) !< (3,nkq)
    real(DP), intent(out) :: kqw(:) !< (nkq)
    integer, intent(in) :: nrq
    integer, intent(in) :: rq(:,:,:) !< (3,3,48)
    logical, intent(in) :: trs !< time-reversal symmetry
    real(DP), intent(in) :: eps
    
    integer :: ikf,ikq,irq,gpt(3)
    real(DP) :: k(3), minusk(3)
  
    PUSH_SUB(dqfold)
    
    nkq=0
    ikf_loop: do ikf=1,nkf
      if (ikf.gt.1) then
        do irq=1,nrq
          k(1:3) = matmul(rq(1:3, 1:3, irq), kf(1:3, ikf))
          minusk(1:3) = -k(1:3)
          call k_range(k,gpt,eps)
          call k_range(minusk,gpt,eps)
          do ikq=1,nkq
            if (all(abs(kq(1:3,ikq)-k(1:3)).lt.eps) .or. &
              (trs .and. all(abs(kq(1:3,ikq)-minusk(1:3)).lt.eps))) then
              kqw(ikq)=kqw(ikq)+kfw(ikf)
              cycle ikf_loop
            endif
          enddo
        enddo
      endif
      nkq=nkq+1
      kq(1:3, nkq) = kf(1:3, ikf)
      kqw(nkq)=kfw(ikf)
    enddo ikf_loop
  
    POP_SUB(dqfold)
    return
  
  end subroutine dqfold

!-------------------------------------------------------------------------------

  subroutine dqsort(nkq,kq,kqw,eps)
    integer, intent(in) :: nkq
    real(DP), intent(inout) :: kq(:,:) !< (3,nkq)
    real(DP), intent(inout) :: kqw(:) !< (nkq)
    real(DP), intent(in) :: eps
    
    integer :: ik1,ik2,imin
    real(DP) :: kmin(3),kwmin
    
    PUSH_SUB(dqsort)
    
    do ik1=1,nkq-1
      imin=0
      kmin(1:3)=INF
      do ik2=ik1,nkq
        if ((kq(1,ik2).lt.kmin(1)-eps).or. &
          (abs(kq(1,ik2)-kmin(1)).lt.eps.and. &
          kq(2,ik2).lt.kmin(2)-eps).or. &
          (abs(kq(1,ik2)-kmin(1)).lt.eps.and. &
          abs(kq(2,ik2)-kmin(2)).lt.eps.and. &
          kq(3,ik2).lt.kmin(3)-eps)) then
          imin=ik2
          kmin(1:3)=kq(1:3,ik2)
          kwmin=kqw(ik2)
        endif
      enddo
      if (imin.ne.ik1) then
        kq(1:3,imin)=kq(1:3,ik1)
        kqw(imin)=kqw(ik1)
        kq(1:3,ik1)=kmin(1:3)
        kqw(ik1)=kwmin
      endif
    enddo
    
    POP_SUB(dqsort)
    return
    
  end subroutine dqsort

!-------------------------------------------------------------------------------

  subroutine write_sym(name, symbol, nr, sym_ops, frac_trans, spacegroup)
    character(len=*),  intent(in) :: name
    character(len=*),  intent(in) :: symbol
    integer,           intent(in) :: nr !< number of symmetry operations
    integer,           intent(in) :: sym_ops(:,:,:) !< (3,3,nr)
    real(DP),          intent(in) :: frac_trans(:,:) !< (3,nr)
    integer, optional, intent(in) :: spacegroup

    integer :: ir, ii, jj

    PUSH_SUB(write_sym)

    write(23,'(a)')
    write(23,'(2a)') "symmetries ", TRUNC(name)
    write(23,'(i3)') nr
    write(23,'(a,i3,a,a)') 'Space group ', spacegroup, ', symbol ', symbol
    do ir=1,nr
      write(23,'("r",i2.2," =",3(2x,3i4),2x,3f12.6)') &
        ir,((sym_ops(jj,ii,ir),jj=1,3),ii=1,3),(frac_trans(ii,ir),ii=1,3)
    enddo
    if (nr.eq.0) write(23,'("none")')

    POP_SUB(write_sym)
    return

  end subroutine write_sym

  subroutine write_espresso(iunit, nk, coords, weights)
    integer,  intent(in) :: iunit
    integer,  intent(in) :: nk
    real(DP), intent(in) :: coords(:,:) !< (3, nk)
    real(DP), intent(in) :: weights(:) !< (nk)

    integer :: ik

    PUSH_SUB(write_espresso)

    write(iunit,'(a)') "K_POINTS crystal"
    write(iunit,'(i5)') nk

    do ik = 1, nk
      write(iunit,'(3f13.9,f6.1)') coords(1:3, ik), weights(ik)
    enddo

    POP_SUB(write_espresso)
  end subroutine write_espresso

  subroutine write_octopus(iunit, nk, coords, weights, kgrid, shift)
    integer,  intent(in) :: iunit
    integer,  intent(in) :: nk
    real(DP), intent(in) :: coords(:,:) !< (3, nk)
    real(DP), intent(in) :: weights(:) !< (nk)
    integer,  intent(in) :: kgrid(:) !< (3)
    real(DP), intent(in) :: shift(:) !< (3); shift = dk + dq*nk.

    integer :: ik

    PUSH_SUB(write_octopus)

    write(iunit,'(a)') "%KGrid"
    write(iunit,'(i10,a,i10,a,i10)')       kgrid(1), ' | ', kgrid(2), ' | ', kgrid(3)
    write(iunit,'(f10.8,a,f10.8,a,f10.8)') shift(1), ' | ', shift(2), ' | ', shift(3)
    write(iunit,'(a)') "%"

    write(iunit,'(a)') "%KPointsReduced"

    do ik = 1, nk
      write(iunit,'(f6.1,3(" | ",f13.9))') weights(ik), coords(1:3, ik)
    enddo

    write(iunit,'(a)') "%"

    POP_SUB(write_octopus)
  end subroutine write_octopus

end module kgrid_routines_m

!===========================================================================
!
! Routines()
!
! (1) mtxel()   Originally By (?)               Last Modified 5/6/2012 (FHJ)
!
!     Compute matrix elements (gme) for valence state iv with all
!     conduction bands and for all G-vectors.
!
!                <c,k,ispin|exp(-i(q+G).r)|v,k+q,ispin>
!
!     On exit,
!       pol%eden(band,spin) = 1/(e_val-e_cond) = energy denominators
!       pol%gme(band,g-vector,spin) = plane wave matrix elements
!       pol%isrtx   orders the |G(i)|^2   i=1,pol%nmtx
!       vwfn%isort  orders |qk+g|^2    (in vwfn type)
!
!       energies are apparently assumed in Rydbergs.
!
!===========================================================================

#include "f_defs.h"

module mtxel_m

  use global_m
  use fftw_m
  use misc_m
  use lin_denominator_m
  implicit none

  private

  public :: mtxel_init_FFT_cond, mtxel_free_FFT_cond, mtxel

contains

!> Precalculates the FFTs for all conduction bands
subroutine mtxel_init_FFT_cond(gvec,pol,cwfn,kp)
  type (gspace), intent(in) :: gvec
  type (polarizability), intent(inout) :: pol
  type (conduction_wfns), intent(inout) :: cwfn
  type (kpoints), intent(inout) :: kp

  real(DP) :: scale
  integer, dimension(3) :: Nfft
  integer :: j, jcad, jspinor

  PUSH_SUB(mtxel_init_FFT_cond)

  if (kp%nspinor>1) then
      call die('Epsilon on Steroids only supports one spin at the moment.')
  endif
      
  if(peinf%inode.eq.0) call timacc(40,1)
  if(peinf%inode.eq.0) call timacc(43,1)
  call setup_FFT_sizes(pol%FFTgrid,Nfft,scale)
  SAFE_ALLOCATE(cwfn%wfn_fft, (Nfft(1),Nfft(2),Nfft(3),peinf%ncownactual))

  jspinor = 1
  do j=1,peinf%ncownactual
    jcad = (j-1)*cwfn%ngc

    call put_into_fftbox(cwfn%ngc,cwfn%zc(jcad+1:,jspinor),gvec%components,cwfn%isort,cwfn%wfn_fft(:,:,:,j),Nfft)

    call do_FFT(cwfn%wfn_fft(:,:,:,j),Nfft,1)
  enddo
  
  if(peinf%inode.eq.0) call timacc(43,2)
  if(peinf%inode.eq.0) call timacc(40,2)
  
  POP_SUB(mtxel_init_FFT_cond)
  return

end subroutine mtxel_init_FFT_cond

!> Frees ffts_cond buffer
subroutine mtxel_free_FFT_cond(cwfn)
  type (conduction_wfns), intent(inout) :: cwfn
  
  PUSH_SUB(mtxel_free_FFT_cond)

  SAFE_DEALLOCATE_P(cwfn%wfn_fft)

  POP_SUB(mtxel_free_FFT_cond)
  return

end subroutine mtxel_free_FFT_cond

subroutine mtxel(iv,gvec,vwfn,cwfn,pol,ispin,irk,kp,kpq,rank_mtxel)
  integer, intent(in) :: iv
  type (gspace), intent(in) :: gvec
  type (valence_wfns), intent(in) :: vwfn
  type (conduction_wfns), intent(in) :: cwfn
  type (polarizability), intent(inout) :: pol
  type (kpoints), intent(inout) :: kp,kpq
  integer, intent(in) :: ispin,irk
  integer, intent(in) :: rank_mtxel

  integer :: j,jspinor,jspinormin,jspinormax,iband,jcad,jj,ig,iband1
  real(DP), allocatable :: edenTemp(:)
  type(cvpair_info), allocatable :: lin_edenTemp(:)
  real(DP) :: eval,econd,occ_v,occ_c,occ_diff,lin_eden_val
      
  integer, dimension(3) :: Nfft
  real(DP) :: scale
  complex(DPC), dimension(:,:,:), allocatable :: fftbox1,fftbox2
  SCALAR, dimension(:), allocatable :: tmparray
  real(DP) :: vk(2),vkq(2)
  logical :: keep_transition

  PUSH_SUB(mtxel)

!-----------------------
! Compute energy denominators; eden depends on which iv we treat

  if(peinf%inode.eq.0) call timacc(25,1)
  if (pol%freq_dep .eq. 2 .or. pol%freq_dep .eq. 3) then
    SAFE_ALLOCATE(edenTemp, (cwfn%nband-vwfn%nband))
    edentemp(:)=0D0
  endif

  eval=vwfn%ev(iv,ispin)
  !FHJ: Do we really need all energy denominators, even for the bands we don`t own?
  !!    I guess this doesn`t take much time anyways...
  do j=vwfn%nband+1,cwfn%nband
    
    iband=j-vwfn%nband
    econd=cwfn%ec(j,ispin)
    
    ! guess occupations based on efermi; eventually this should be replaced by use of kp%occ
    if(eval*ryd > pol%efermi + TOL_Degeneracy) then
      occ_v = 0d0
    else if (eval*ryd < pol%efermi - TOL_Degeneracy) then
      occ_v = 1d0
    else
      occ_v = 0.5  ! within TOL_Degeneracy of the Fermi level, use FD(E_F) = 1/2
    endif

    if(econd*ryd > pol%efermi + TOL_Degeneracy) then
      occ_c = 0d0
    else if (econd*ryd < pol%efermi - TOL_Degeneracy) then
      occ_c = 1d0
    else
      occ_c = 0.5  ! within TOL_Degeneracy of the Fermi level, use FD(E_F) = 1/2
    endif

    occ_diff = occ_v - occ_c

! JRD/JBN: If ncrit is specified we have a metal

    if(pol%freq_dep .eq. 0) then
      if(eval - econd < TOL_Degeneracy .and. occ_diff > TOL_Zero) then
        ! avoid dividing by zero or making eden > 0
        pol%eden(iv,iband,ispin) = occ_diff / (eval - econd)
      else
        pol%eden(iv,iband,ispin) = 0d0 ! in this case, occ_diff = 0 too
      endif



    endif
    
    if(pol%freq_dep .eq. 2 .or. pol%freq_dep .eq. 3) then
      if (.not.peinf%doiownv(iv)) then
        POP_SUB(mtxel)
        return
      endif

      if(eval - econd < TOL_Degeneracy .and. occ_diff > TOL_Zero) then
        edenTemp(iband) = (eval - econd) / occ_diff
      else
        edenTemp(iband) = 0.0d0
        !!write(6,*) peinf%inode,' In a O band pair',iv,iband
      endif


    endif
  enddo

  if (pol%freq_dep .eq. 2 .or. pol%freq_dep .eq. 3) then
    if (peinf%doiownv(iv)) then
      do j = 1, peinf%ncownactual
        if(pol%os_para_freqs .gt. 1 .and. pol%gcomm .eq. 0) then
          pol%edenDyn(peinf%indexv(iv),j,ispin,irk,1) = edenTemp(peinf%invindexc(j))
        else
          pol%edenDyn(peinf%indexv(iv),j,ispin,irk,rank_mtxel+1) = edenTemp(peinf%invindexc(j))
        endif
      enddo
    endif
    SAFE_DEALLOCATE(edenTemp)
  endif
  
  if(peinf%inode.eq.0) call timacc(25,2)
  
  if(peinf%inode.eq.0) call timacc(26,1)

!-------------------- Calculate Matrix Elements -------------------------------


!--------------------------
! Use FFTs to calculate matrix elements

! Compute size of FFT box we need

  call setup_FFT_sizes(pol%FFTgrid,Nfft,scale)
! Allocate FFT boxes
  SAFE_ALLOCATE(fftbox2, (Nfft(1),Nfft(2),Nfft(3)))

! Put the data for valence band iv into FFT box 1 and do the FFT

  call set_jspinor(jspinormin,jspinormax,ispin,kp%nspinor)

  if (pol%os_opt_ffts/=2) then
    SAFE_ALLOCATE(fftbox1, (Nfft(1),Nfft(2),Nfft(3)))
  endif

  if(pol%os_para_freqs .gt. 1 .and. pol%gcomm .eq. 0) then
    pol%gme(1:pol%nmtx,1:peinf%ncownactual,peinf%indexv(iv),ispin,irk,1) = ZERO
  else
    pol%gme(1:pol%nmtx,1:peinf%ncownactual,peinf%indexv(iv),ispin,irk,rank_mtxel+1) = ZERO
  endif

  SAFE_ALLOCATE(tmparray, (pol%nmtx))

  do jspinor=jspinormin,jspinormax

    if (pol%os_opt_ffts/=2) then
      call put_into_fftbox(vwfn%ngv,vwfn%zv(:,jspinor),gvec%components,vwfn%isort,fftbox1,Nfft)
      call do_FFT(fftbox1,Nfft,1)
      ! We need the complex conjugate of the |ivk> band actually
      call conjg_fftbox(fftbox1,Nfft)
    endif

! Now we loop over the conduction states and get the matrix elements:
! 1. Get conduction wave function and put it into box 2,
! 2. do FFT,
! 3. multiply by box1 contents,
! 4. do FFT again, and extract the resulting matrix elements and put the into pol
! We conjugate the final result since we really want <c|e^(-ig.r)|v>
! but we have calculated <v|e^(ig.r)|c>.

    do j=1,peinf%ncownactual
      iband = peinf%invindexc(j)
      jcad = (j-1)*cwfn%ngc

      if (pol%os_opt_ffts==2) then
        ! FHJ: optimization level 2 precomputed all the FFTs
        fftbox2(:,:,:) = vwfn%wfn_fft(:,:,:,peinf%indexv(iv)) * cwfn%wfn_fft(:,:,:,j)
      else
        if (pol%os_opt_ffts==1) then
          ! FHJ: Optimization level 1 precalculated at least these cond. FFTs
          fftbox2(:,:,:) = fftbox1(:,:,:) * cwfn%wfn_fft(:,:,:,j)
        else
          call put_into_fftbox(cwfn%ngc,cwfn%zc(jcad+1:,jspinor),gvec%components,cwfn%isort,fftbox2,Nfft)
          call do_FFT(fftbox2,Nfft,1)
          call multiply_fftboxes(fftbox1,fftbox2,Nfft)
        endif
      endif

      call do_FFT(fftbox2,Nfft,1)
      call get_from_fftbox(pol%nmtx,tmparray,gvec%components,pol%isrtx,fftbox2,Nfft,scale)

      keep_transition = .true.

      if (keep_transition) then
        if(pol%os_para_freqs .gt. 1 .and. pol%gcomm .eq. 0) then
          pol%gme(1:pol%nmtx,j,peinf%indexv(iv),ispin,irk,1) = &
            pol%gme(1:pol%nmtx,j,peinf%indexv(iv),ispin,irk,1) + MYCONJG(tmparray)
        else
          pol%gme(1:pol%nmtx,j,peinf%indexv(iv),ispin,irk,rank_mtxel+1) = &
            pol%gme(1:pol%nmtx,j,peinf%indexv(iv),ispin,irk,rank_mtxel+1) + MYCONJG(tmparray)
        endif
      endif

! JRD: Debugging of mtxel symmetries

!    do ijk = 1, pol%nmtx
!      call findvector(ijkm,-gvec%components(:,pol%isrtx(ijk)),gvec)
!      ijkm=pol%isrtxi(ijkm)
!      if (ijkm .le. pol%nmtx) then
!        write(3003,*) iv,j,ijk,ijkm,Abs(pol%gme(ijk,j,peinf%indexv(iv),ispin,irk,1))&
!                        -Abs(pol%gme(ijkm,j,peinf%indexv(iv),ispin,irk,1))
!      endif
!    enddo
     
      if (kp%nspinor.eq.1 .or. jspinor.eq.2) then
        if (pol%freq_dep .eq. 0) then
          pol%gme(1:pol%nmtx,j,peinf%indexv(iv),ispin,irk,1) = &
            pol%gme(1:pol%nmtx,j,peinf%indexv(iv),ispin,irk,1) * &
            sqrt(-1D0*pol%eden(iv,iband,ispin))

        endif
      endif

    enddo

  enddo 

  SAFE_DEALLOCATE(tmparray)

! We are done, so deallocate FFT boxes
  if (pol%os_opt_ffts.ne.2) then
    SAFE_DEALLOCATE(fftbox1)
  endif
  SAFE_DEALLOCATE(fftbox2)


! End FFT Case
!---------------------------

! End Calculation of matrix elements
!----------------------------------------------------------------------------

!--------- Renormalize q-->0 matrix elements by q0norm -----------------------

! SIB: gvec%components(:,isave) is the null vector.  Used to scale by 1/q0
! at the end.
! JRD:  The set of entries in gme with g-vector index isave (g=0)
! are divided by q0norm.  JRD: But if we truncate, we will include
! this factor in epsinv.f90

  if(peinf%inode.eq.0) call timacc(26,2)

  POP_SUB(mtxel)

  return
end subroutine mtxel

end module mtxel_m

!=======================================================================
!
! Routines:
!
! 1. haydock      Originally By MLT       Last Modified 6/24/08 (JRD)
!
!     Calculates the real and imaginary parts of the macroscopic dielectric
!     function starting from interaction matrix elements calculated by
!     the Kernel code. It uses interpolation in the matrix elements and
!     the Haydock recursion method. Spin-polarized case implemented.
!
!     For more details, see:
!     Rohlfing & Louie, PRB 62:(8), 4927 (2000)
!     Benedict & Shirley, PRB 59:(8), 5441 (1999)
!     R. Haydock, Comput. Phys. Commun. 20, 11 (1980)
!     G. Strinati, Rivista del Nuovo Cimento 11:(12), 1 (1988)
!
!     Please report bugs to: jdeslip@civet.berkeley.edu
!
!========================================================================

#include "f_defs.h"

subroutine haydock(eqp,xct,flag,nmax)

  use global_m
  use fullbz_m
  use genwf_m
  use intkernel_m
  use intwfn_m
  use misc_m
  use mtxel_optical_m
  use random_m
  implicit none

  type (eqpinfo), intent(inout) :: eqp
  type (xctinfo), intent(inout) :: xct
  type (flags), intent(in) :: flag
  integer, intent(in) :: nmax

  type (crystal) :: crys
  type (mmtsinfo) :: mmts
  type (symmetry) :: syms
  type (gspace) :: gvec
  type (grid) :: kg_fi, kgq_fi
  type (kpoints) :: kp_fi, kpq_fi
  type (wavefunction) :: wfnc_fi
  type (wavefunction) :: wfnvq_fi
  type (work_genwf) :: work, workq
  type (int_wavefunction) :: intwfnc
  type (int_wavefunction) :: intwfnv

  character :: tmpstr*128,filename*20
  integer :: ii,jj,ncount,nmat,nblock
  integer :: ikb, icb, ivb
  integer :: ik,ikq,ikt,ikrq,ikcvs,ikcvst,ic,iv,is
  integer :: seed, iunit_c,iunit_v
  integer :: ih,ith,n0
  real(DP) :: vol,vol1,sum,sum1
  real(DP) :: tsec(2),tmin(2),tmax(2),omega_plasma
  
  character*16, allocatable :: routnam(:)
  integer, allocatable :: routsrt(:)
  integer, allocatable :: fi2co_wfn(:,:),indexq_fi(:)
  real(DP), allocatable :: kco(:,:)
  SCALAR, allocatable :: &
    dcc(:,:,:,:,:),dvv(:,:,:,:,:),s1(:),s1_l(:),s1k(:,:,:),dummy(:), &
    hmtrx(:,:),s0(:),s0_l(:),hqpcc(:,:,:),hqpvv(:,:,:)
  real(DP), allocatable :: intp_coefs(:,:)

  PUSH_SUB(haydock)

  mmts%nmax = nmax

  if (xct%read_kpoints .and. peinf%inode.eq.0) then
    write(0,*) 'WARNING: you are using partial sampling with the Haydock iterative scheme!'
    write(0,*) 'The optical spectrum may not be meaningful...'
  endif
  if(mmts%nmax.eq.0.and.flag%spec.ne.1) then
    call die('missing number of iterations')
  endif

! If flag%spec.eq.1, just calculate the spectrum from input coefficients

  ith=21
  if (flag%spec.eq.1) then
    if (peinf%inode.eq.0) then
      call open_file(ith,file='eps2_moments',form='unformatted',status='old')
      read(ith) mmts%nmax,mmts%norm,mmts%vol,ii,xct%nspin
      SAFE_ALLOCATE(mmts%an, (mmts%nmax))
      SAFE_ALLOCATE(mmts%bn, (mmts%nmax))
      read(ith) (mmts%an(ii),ii=1,mmts%nmax)
      read(ith) (mmts%bn(ii),ii=1,mmts%nmax)
      write(6,*)
      write(6,*) 'Reading coefficients from file; nmax = ',mmts%nmax, ' norm= ',mmts%norm
      write(6,*) '     n    a(n)        b(n)  '
      do ii=1,mmts%nmax
        write(6,120) ii, mmts%an(ii),mmts%bn(ii)
      enddo
      call close_file(ith)
    endif
120 format(3x,i4,3x,2e12.5)

  else

!-----------------------
! Read wavefunctions on the fine grid

  call logit('Calling input')
  call timacc(2,1)
  call input(crys,gvec,kg_fi,kp_fi,syms,eqp,xct,flag, &
    omega_plasma,.false.,intwfnc)
  
  nmat = xct%nkpt_fi*xct%ncb_fi*xct%nvb_fi*xct%nspin
  vol = xct%nktotal*crys%celvol
  if (peinf%inode.eq.0) then
    write(6,'(a,f32.14,a)') 'Crystal volume = ',vol,' a.u.'
    write(6,*) ' number of valence bands = ',xct%nvb_fi
    write(6,*) ' number of cond. bands   = ',xct%ncb_fi
    write(6,*) ' number of spins   = ',xct%nspin
    write(6,'(a,f7.4,a)') ' Broadening: ',xct%eta,' eV'
  endif
  call timacc(2,2)

  SAFE_ALLOCATE(indexq_fi, (xct%nkpt_fi))
  if (flag%vm.eq.0 .or. .not. flag%read_dtmat) then
    call timacc(3,1)
    call logit('Calling input_q')
    call input_q(kp_fi,crys,gvec,kg_fi,kgq_fi,kpq_fi, &
      syms,xct,indexq_fi,eqp,flag,intwfnv)
    call timacc(3,2)
  endif

!----------------------------
! Calculate the transformation matrices from coarse-grid wavefunctions
! FHJ: These are the final transformation coefs that will be used to interpolate
! the kernel. However, we might use an unrestricted version of dvv/dcc to
! interpolate eqp if xct%unrestricted_transf==.true..
  SAFE_ALLOCATE(dvv, (xct%nvb_fi,xct%n1b_co,xct%nspin,xct%nkpt_fi,xct%npts_intp_kernel))
  SAFE_ALLOCATE(dcc, (xct%ncb_fi,xct%n2b_co,xct%nspin,xct%nkpt_fi,xct%npts_intp_kernel))
  SAFE_ALLOCATE(kco, (3,xct%nkpt_co))
  SAFE_ALLOCATE(fi2co_wfn, (xct%npts_intp_kernel,xct%nkpt_fi))
  SAFE_ALLOCATE(intp_coefs, (xct%npts_intp_kernel, xct%nkpt_fi))

  call logit('Calling intwfn')
  call timacc(4,1)
  call intwfn(kp_fi,crys,syms,xct,flag,gvec,kg_fi,kgq_fi, &
    dcc,dvv,kco,fi2co_wfn,indexq_fi,eqp,intwfnv,intwfnc,intp_coefs)
  call timacc(4,2)

  SAFE_DEALLOCATE_P(xct%ifmax)
  if (flag%vm.eq.0 .or. .not. flag%read_dtmat) then
    ! otherwise, we did not call input_q to allocate it
    SAFE_DEALLOCATE_P(xct%ifmaxq)
  endif

!----------------------------
! Initialize recursion states and coefficients.
! If there is a previous run, read previous states from unit ith and
! skip the calculation of velocity/momentum matrix elements.
!
!       nblock : size of cvs block in hmtrx

  nblock = xct%ncb_fi*xct%nvb_fi*xct%nspin
  if (xct%ipar .eq. 1) then
    peinf%nblockd=nblock
  else if (xct%ipar .eq. 2) then
    peinf%nblockd = xct%nvb_fi*xct%nspin
  else    
    peinf%nblockd = xct%nspin
  endif
  nmat= xct%nkpt_fi*nblock
  SAFE_ALLOCATE(s1, (nmat))
  SAFE_ALLOCATE(s1k, (xct%ncb_fi,xct%nvb_fi,xct%nspin))
  s1= 0.d0
  s1k= 0.d0

! Since this code always compute an odd number of an's and bn's,
! it will calculate nmax+1 coefficients if nmax is even
! solution: overshoot the array size

  mmts%nmaxp=mmts%nmax+1
  SAFE_ALLOCATE(mmts%an, (mmts%nmaxp))
  SAFE_ALLOCATE(mmts%bn, (mmts%nmaxp))
  mmts%an(:) = 0.d0
  mmts%bn(:) = 0.d0
  mmts%vol = vol
  SAFE_ALLOCATE(s0, (nmat))
  s0 = 0.d0

  if (flag%vm.eq.2) then
    if (peinf%inode.eq.0) then
      call open_file(ith,file='eps2_moments',form='unformatted',status='old')
      read(ith) n0,mmts%norm,vol1,ii,is
      if ((abs(vol1-mmts%vol).gt.1.d-10).or.ii.ne.nmat.or.is.ne.xct%nspin) then
        call die(' Parameter mismatch in old file eps2_moments')
      endif
      
      read(ith) (mmts%an(ii),ii=1,n0)
      read(ith) (mmts%bn(ii),ii=1,n0)
      
      read(ith) (s1(ii),ii=1,nmat)
      read(ith) (s0(ii),ii=1,nmat)
      call close_file(ith)
      write(6,*) 'Reading old data from file eps2_moments'
      sum = (4.d0*PI_D*ryd)**2*mmts%norm*mmts%an(1)/(mmts%vol*xct%nspin)
      write(6,*) 'Sum rule (excitons) : ',sum,' eV^2'
      write(6,*) '      n         a(n)        b(n)'
      do ih=1,n0
        write(6,120) ih,mmts%an(ih),mmts%bn(ih)
      enddo
    endif
#ifdef MPI
    call MPI_BCAST(n0, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(mmts%norm, 1, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(mmts%an, mmts%nmaxp, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(mmts%bn, mmts%nmaxp, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(s1, nmat, MPI_SCALAR, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(s0, nmat, MPI_SCALAR, 0, MPI_COMM_WORLD, mpierr)
#endif

  else
    n0=1
  endif

!-------------------------
! Calculate the velocity (or momentum) matrix elements.
! Each PE calculates a small number of them. At the end, share data.
!
! If flag%vm.eq.1, skip this part and just read the matrix elements
! from "vmtxel".

  call logit('Calling v/p matrix elements')
  if (flag%vm.eq.0) then
    if (flag%opr .eq. 2) then
      seed =5000
      call genrand_init(put=seed)
      ! Just set the s1 vector to be random numbers on all processors 
      ! The seed has to be the same on all processors otherwise we need
      ! to set this on one and broadcast..
      call mtxel_jdos(s1,nmat)
    else

      do ikt=1, peinf%ikt(peinf%inode+1)
        ik = peinf%ik(peinf%inode+1,ikt)
        ikq = indexq_fi(ik)
        ikrq = kg_fi%indr(ik)
      
        call genwf(crys,gvec,kg_fi,syms,wfnc_fi,xct,ik,ik,work,intwfnc, is_cond = .true.)
      
        call genwf(crys,gvec,kgq_fi,syms,wfnvq_fi,xct,ik,ikq,workq,intwfnv, is_cond = .false.)
        if (flag%opr.eq.0) then
          call mtxel_v(wfnc_fi,wfnvq_fi,gvec,xct%qshift,wfnc_fi%nband,wfnvq_fi%nband,s1k)
        elseif (flag%opr.eq.1) then
          call mtxel_m(crys,wfnc_fi,wfnvq_fi,gvec,eqp,xct,wfnc_fi%nband,wfnvq_fi%nband,s1k,ik,.true.)
        endif
        do is=1,xct%nspin
          do ic=1,xct%ncb_fi
            do iv=1,xct%nvb_fi
              s1(bse_index(ik, ic, iv, is, xct)) = s1k(ic,iv,is)
            enddo
          enddo
        enddo
        SAFE_DEALLOCATE_P(wfnc_fi%cg)
        SAFE_DEALLOCATE_P(wfnc_fi%isort)
        SAFE_DEALLOCATE_P(wfnvq_fi%cg)
        SAFE_DEALLOCATE_P(wfnvq_fi%isort)
      enddo

      ! typedefs initializes all of these ikolds to 0
      if(work%ikold /= 0) then
        SAFE_DEALLOCATE_P(work%cg)
        SAFE_DEALLOCATE_P(work%isort)
        SAFE_DEALLOCATE_P(work%ph)
        SAFE_DEALLOCATE_P(work%ind)
      endif
      if(workq%ikold /= 0) then
        SAFE_DEALLOCATE_P(workq%cg)
        SAFE_DEALLOCATE_P(workq%isort)
        SAFE_DEALLOCATE_P(workq%ph)
        SAFE_DEALLOCATE_P(workq%ind)
      endif

! Share matrix elements

#ifdef MPI
      SAFE_ALLOCATE(dummy, (nmat))
      dummy = s1
      call MPI_ALLREDUCE(dummy,s1,nmat,MPI_SCALAR,MPI_SUM, MPI_COMM_WORLD,mpierr)
      SAFE_DEALLOCATE(dummy)
#endif

    endif ! Whether jdos or (velocity/momentum)

    if (peinf%inode.eq.0) then
      write(6,'(1x,a)') 'Writing matrix elements into vmtxel'
      call open_file(16,file='vmtxel',form='unformatted',status='replace')
      write(16) xct%nkpt_fi,xct%ncb_fi,xct%nvb_fi,xct%nspin,flag%opr
      write(16) (s1(ikcvs),ikcvs=1,nmat)
      call close_file(16)
    endif

  else if(flag%vm == 1) then  ! ...if the matrix elements were calculated already

    if (peinf%inode.eq.0) then
      write(6,'(1x,a)') 'Reading matrix elements from vmtxel'
      call open_file(16,file='vmtxel',form='unformatted',status='old')
      read(16) ik,ic,iv,is,ii
      if (ik.ne.xct%nkpt_fi.or.ic.ne.xct%ncb_fi.or.iv.ne.xct%nvb_fi &
        .or.is.ne.xct%nspin.or.ii.ne.flag%opr) then
        write(tmpstr,*) 'parameter mismatch in vmtxel ', &
          ik,ic,iv,is,ii,xct%nkpt_fi,xct%ncb_fi,xct%nvb_fi,xct%nspin,flag%opr
        call die(tmpstr)
      endif
      
      read(16) (s1(ikcvs),ikcvs=1,nmat)
      call close_file(16)
    endif
#ifdef MPI
    call MPI_BCAST(s1,nmat,MPI_SCALAR,0,MPI_COMM_WORLD,mpierr)
#endif

  endif

  if (flag%vm.eq.0 .or. .not. flag%read_dtmat) then
    call dealloc_grid(kgq_fi)
  endif

  SAFE_DEALLOCATE(s1k)
  SAFE_DEALLOCATE(indexq_fi)

! JRD: Now close the no longer needed wavefunction files

  if (xct%iwriteint.eq.1) then
    SAFE_DEALLOCATE_P(intwfnc%cgk)
    SAFE_DEALLOCATE_P(intwfnv%cgk)
    SAFE_DEALLOCATE_P(intwfnc%isort)
    SAFE_DEALLOCATE_P(intwfnv%isort)
  endif
  
  if (xct%iwriteint.eq.0 .and. (flag%vm.ne.1 .or. .not. flag%read_dtmat)) then
    write(filename,'(a,i4.4)') 'INT_VWFNQ_', peinf%inode
    iunit_v = 128+(2*peinf%inode)+2
    call open_file(iunit_v, filename, status = 'old')
    call close_file(iunit_v, delete = .true.) ! files INT_VWFNQ_*

    write(filename,'(a,i4.4)') 'INT_CWFN_', peinf%inode
    iunit_c = 128+(2*peinf%inode)+1
    call open_file(iunit_c, filename, status = 'old')
    call close_file(iunit_c, delete = .true.) ! files INT_CWFN_*
  endif

!-------------------------
! Calculate the non-interacting spectrum. Only one PE works

  call logit('Calling absp0')

  if (peinf%inode.eq.0) call absp0(eqp,xct,s1,vol,omega_plasma,flag)

!---------------------------
! Build Hamiltonian matrix. Diagonal part comes from the "non-interacting"
! quasiparticle Hamiltonians.  If the QP Greens func is diagonal,
! then these are just the quasiparticle energy differences on the
! diagonal.  The more general case is:
!
!       <cvk|H0|c'v'k'> = delta(k,k') *
!            [ <c|hqp|c'>*delta(v',v) - delta(c,c')*<v'|hqp|v> ]
!
! The rest of the Hamiltonian, which is the electron-hole interaction,
! comes from interpolation further below.

  call logit('Building non-interacting Hamiltonian')
  SAFE_ALLOCATE(hmtrx, (xct%nkpt_fi*nblock,peinf%nblocks*peinf%nblockd))
  hmtrx(:,:) = 0.d0

! Loop over kpoints

  do ikt=1,peinf%ibt(peinf%inode + 1)
    ik=peinf%ikb(peinf%inode+1,ikt)

! Build <c|hqp|c'> and <v|hqp|v'> for this kpoint

    SAFE_ALLOCATE(hqpcc, (xct%ncb_fi,xct%ncb_fi,xct%nspin))
    SAFE_ALLOCATE(hqpvv, (xct%nvb_fi,xct%nvb_fi,xct%nspin))
    hqpcc = 0.0d0
    hqpvv = 0.0d0

! Put QP energies on diagonals of hqpcc and hqpvv to start

    do is=1,xct%nspin
      do ic=1,xct%ncb_fi
        hqpcc(ic,ic,is) = eqp%ecqp(ic,ik,is)
      enddo
      do iv=1,xct%nvb_fi
        hqpvv(iv,iv,is) = eqp%evqp(iv,ik,is)
      enddo
    enddo

! Read possible offdiagonal QP elements from "hqp.<ik>" file
! if it exists JRD: This is broken for now.  Someone should fix
! it in the future if they want to use it

        !if (ik.lt.10) then
        !  write(tmpstr,'(a,i1)') 'hqp.',ik
        !else if (ik.lt.100) then
        !  write(tmpstr,'(a,i2)') 'hqp.',ik
        !else if (ik.lt.1000) then
        !  write(tmpstr,'(a,i3)') 'hqp.',ik
        !else if (ik.lt.10000) then
        !  write(tmpstr,'(a,i4)') 'hqp.',ik
        !else
        !  write(0,*) 'too many kpoints for reading hqp'
        !endif
        !call open_file(9,file=tmpstr,form='formatted',status='old',iostat=is)
        !if (is.eq.0) then
        !  if (peinf%inode.eq.0) then
        !    write(6,*) 'Reading offdiagonal hqp from file ',tmpstr
        !    write(6,*) 'All values in eV'
        !  endif
        !  do
        !    read(9,*,end=999) nocc,ii,jj,x,y
!
!! if ii and jj both refer to valence, states, put
!! matrix element into hqpvv
!
!            if ((ii<=nocc).and.(ii>nocc-xct%nvb_fi).and. &
!            (jj<=nocc).and.(jj>nocc-xct%nvb_fi)) then
!              if (peinf%inode.eq.0) write(6,'(a,2i5,2f20.10)') ' hqp(v,vp) = ',ii,jj,x,y
!              ii=nocc-ii+1
!              jj=nocc-jj+1
!              is = 1
!#ifdef CPLX
!              hqpvv(ii,jj,is) = CMPLX(x,y)/ryd
!#else
!              hqpvv(ii,jj,is) = x/ryd
!#endif
!            else if ((ii>nocc).and.(ii<=nocc+xct%ncb_fi).and. &
!            (jj>nocc).and.(jj<=nocc+xct%ncb_fi)) then
!              if (peinf%inode.eq.0) write(6,'(a,2i5,2f20.10)') ' hqp(c,cp) = ',ii,jj,x,y
!              ii=ii-nocc
!              jj=jj-nocc
!              is = 1
!#ifdef CPLX
!              hqpcc(ii,jj,is) = CMPLX(x,y)/ryd
!#else
!              hqpcc(ii,jj,is) = x/ryd
!#endif
!            endif
!          enddo
! 999      call close_file(9)
!          write(6,*)
!        endif ! if hqp.<ik> was found

! Now build hamiltonian from hqpcc and hqpvv

    do is=1,xct%nspin
      do iv=1,xct%nvb_fi
        do ic=1,xct%ncb_fi
          !do icp=1,xct%ncb_fi
          ikb=peinf%ikb(peinf%inode+1,ikt)
          if (xct%ipar .eq. 1) then
            ikcvs = bse_index(ikt, ic, iv, is, xct)
            ivb=iv
            icb=ic
          else if (xct%ipar .eq. 2 .and. ic .eq. 1) then
            ikcvs = bse_index(ikt, ic, iv, is, xct, ncband = 1)
            icb=peinf%icb(peinf%inode+1,ikt)
            ivb=iv
          else if (xct%ipar .eq. 3 .and. iv .eq. 1 .and. ic .eq. 1) then
            ikcvs = bse_index(ikt, ic, iv, is, xct, ncband = 1, nvband = 1)
            ivb=peinf%ivb(peinf%inode+1,ikt)
            icb=peinf%icb(peinf%inode+1,ikt)
          else
            cycle
          endif
          ikcvst = bse_index(ikb, icb, ivb, is, xct)
          hmtrx(ikcvst,ikcvs) = hqpcc(icb,icb,is) - hqpvv(ivb,ivb,is)

          !enddo
        enddo
      enddo

    enddo
    SAFE_DEALLOCATE(hqpcc)
    SAFE_DEALLOCATE(hqpvv)
  enddo ! loop on k-points on this processor

!#ifdef VERBOSE
!      call logit('Non-int Hamiltonian, node 0, kpt (0,0):', &
!      peinf)
!      if (peinf%inode.eq.0) then
!        ikt=peinf%ik(peinf%inode+1,1)
!        ik=1
!        do ic=1,min(5,xct%ncb_fi)
!          do iv=1,xct%nvb_fi
!            do icp=1,min(5,xct%ncb_fi)
!              do ivp=1,xct%nvb_fi
!                is = 1
!                ikcvs = bse_index(ik, ic, iv, is, xct)
!                ikcvst = bse_index(ikt, icp, ivp, is, xct)
!                write(6,'(4i5,2f15.8)') ic,iv,icp,ivp,hmtrx(ikcvs,ikcvst)
!              enddo
!            enddo
!          enddo
!        enddo
!      endif
!#endif

!-----------------------------------------------------------------------
! Define the mapping of eigenvectors: the ii-th column of the matrix
! egs(:,:) stored in PE #ipe will contain the eigenvector of order
! peinf%peig(ipe,ii). The total number of eigenvectors stored in
! each processor is given by peinf%neig(1:peinf%npes).
!  pblock >= maxval(peinf%neig(1:peinf%npes))
! NOTE: this is taken from diag code, but it also holds for the
! mapping of hmtrx, that has the same layout as egs (Murilo)

  SAFE_ALLOCATE(peinf%neig, (peinf%npes))
  SAFE_ALLOCATE(peinf%peig, (peinf%npes,peinf%nblocks*peinf%nblockd))
  peinf%neig=0
  peinf%peig=0
  ii=1
  do jj=1,nmat
    if (ii.eq.peinf%npes+1) ii=1
    peinf%neig(ii)=peinf%neig(ii)+1
    peinf%peig(ii,peinf%neig(ii))=jj
    if (mod(jj,peinf%nblockd).eq.0) ii=ii+1
  enddo

!---------------------------------
! Initialize local states : s1_l  --> local part of s1
!                           s0_l  --> local part of s0
! Whenever s1 and s0 change, their local parts must be updated

  SAFE_ALLOCATE(s1_l, (peinf%nblocks*peinf%nblockd))
  !MJ : CHANGE THIS

  call local_s(nmat,s1,s1_l)
  SAFE_ALLOCATE(s0_l, (peinf%nblocks*peinf%nblockd))
  call local_s(nmat,s0,s0_l)

!--------------------------------
! Interpolation scheme in the Kernel

  call logit('Calling intkernel')
  call timacc(5,1)
  call intkernel(crys,kg_fi,kp_fi,syms,xct,hmtrx,dcc,dvv,kco,fi2co_wfn,flag,gvec,intp_coefs)
  call timacc(5,2)
  call dealloc_grid(kg_fi)

  SAFE_DEALLOCATE(fi2co_wfn)
  SAFE_DEALLOCATE(dcc)
  SAFE_DEALLOCATE(dvv)
  SAFE_DEALLOCATE(kco)

#ifdef VERBOSE
  call logit('Interacting Hamiltonian, node 0, kpt (0,0):')
!      if (peinf%inode.eq.0) then
!        ikt=peinf%ik(peinf%inode+1,1)
!        ik=1
!        do ic=1,min(5,xct%ncb_fi)
!          do iv=1,xct%nvb_fi
!            do icp=1,min(5,xct%ncb_fi)
!              do ivp=1,xct%nvb_fi
!                is = 1
!                ikcvs = bse_index(ik, ic, iv, is, xct)
!                ikcvst = bse_index(ikt, icp, ivp, is, xct)
!                write(6,'(4i5,2f15.8)') ic,iv,icp,ivp,hmtrx(ikcvs,ikcvst)
!              enddo
!            enddo
!          enddo
!        enddo
!      endif
#endif

!------------------------------
! Normalize s1 to get the first-order Haydock state: |1>= (e.v) |Ground>
! Calculate the first a coefficient

  if (flag%vm .ne. 2) then

    mmts%norm =  dble( DOT_PRODUCT(s1,s1) )
    sum = sqrt(mmts%norm)
    s1(:) = s1(:)/sum
    call local_s(nmat,s1,s1_l)
  
    sum1 = dble( DOT_PRODUCT(s1,MATMUL(hmtrx,s1_l)) )
#ifdef MPI
    call MPI_Allreduce(sum1,sum,1,MPI_REAL_DP,MPI_SUM,MPI_COMM_WORLD,mpierr)
    sum1 = sum
#endif
    mmts%an(1) = sum1

#ifdef MPI
    call MPI_BARRIER(MPI_COMM_WORLD,mpierr)
#endif

!--------------------------
! Calculate the second order state, s0, and the first b coefficient

    s0 = MATMUL(hmtrx,s1_l)

#ifdef MPI
    SAFE_ALLOCATE(dummy, (nmat))
    dummy = s0
    call MPI_Allreduce(dummy,s0,nmat,MPI_SCALAR,MPI_SUM,MPI_COMM_WORLD,mpierr)
    SAFE_DEALLOCATE(dummy)
#endif

    s0(:) = s0(:) - s1(:)*mmts%an(1)
    sum = dble( DOT_PRODUCT(s0,s0) )
    mmts%bn(1) = sum
    s0(:) = s0(:)/sqrt(sum)
    call local_s(nmat,s0,s0_l)

  endif

  if (peinf%inode.eq.0) then
    write(6,750) mmts%nmax
750 format(/,'Performing Haydock recursion with ',i5,' steps. ')
    write(6,*) 'Norm of first state : ',mmts%norm
    
! Check plasmon sum rule
!
! Exact value of sum rule:
! sum = (pi/2.d0)*( plasma frequency )^2

    sum = (4.d0*PI_D*ryd)**2*mmts%norm*mmts%an(1)/ &
      (mmts%vol*xct%nspin)
    write(6,*) 'Sum rule (excitons) : ',sum,' eV^2'
    write(6,*) '      n         a(n)        b(n)'
    write(6,120) n0,mmts%an(n0),mmts%bn(n0)
  endif

#ifdef MPI
  call MPI_BARRIER(MPI_COMM_WORLD,mpierr)
#endif

!-----------------------------------------------------------------------
! Start Haydock recursion method. At this point, n0 is always an odd number
! After each pair of iterations, we have the states:
!              | ih+1 >  ---  s1
!              | ih+2 >  ---  s0
! Lower states are lost.

  call timacc(6,1)
  do ih=n0+1,mmts%nmax,2
    call iterate(mmts,xct,nmat,ih,hmtrx,s1,s0)
  enddo
  call timacc(6,2)
  SAFE_DEALLOCATE(hmtrx)
  SAFE_DEALLOCATE(s1)
  SAFE_DEALLOCATE(s0)
  SAFE_DEALLOCATE_P(peinf%neig)
  SAFE_DEALLOCATE_P(peinf%peig)

!---------------------------
! Calculate absorption spectrum using Haydock recursion

  endif

  if (peinf%inode.eq.0) call absh(mmts,xct%nspin,xct%eta)
  SAFE_DEALLOCATE_P(mmts%an)
  SAFE_DEALLOCATE_P(mmts%bn)
  SAFE_DEALLOCATE_P(eqp%eclda)
  SAFE_DEALLOCATE_P(eqp%evlda)
  SAFE_DEALLOCATE(intp_coefs)

  if (xct%iwritecoul .eq. 1 .and. peinf%inode .eq. 0) then
    call close_file(19) ! file vcoul
  endif

#ifdef MPI
  call MPI_BARRIER(MPI_COMM_WORLD,mpierr)
#endif
  if (eqp%spl_tck%n>0) then
    SAFE_DEALLOCATE_P(eqp%spl_tck%t)
    SAFE_DEALLOCATE_P(eqp%spl_tck%c)
  endif

!----------------------------
! Time accounting

  SAFE_ALLOCATE(routnam, (60))
  routnam(1)='TOTAL:'
  routnam(2)='INPUT:'
  routnam(3)='INPUT_Q:'
  routnam(4)='INTWFN:'
  routnam(5)='INTKERNEL:'
  routnam(6)='ITERATE:'
  routnam(41)='IW Input_co:'
  routnam(42)='IW Interp:'
  routnam(43)='IW Genwf:'
  routnam(44)='IW Gwnwf_Co:'
  routnam(45)='IW Mtxel_t:'
  routnam(46)='IW Write:'
  routnam(47)='IW Reduce:'
  routnam(51)='IK Setup:'
  routnam(52)='IK C-Check:'
  routnam(53)='IK Input:'
  routnam(54)='IK Inteps:'
  routnam(55)='IK Vcoul:'
  routnam(56)='IK Cache:'
  routnam(57)='IK Interp:'
  routnam(58)='IK Sum:'
  SAFE_ALLOCATE(routsrt, (21))
  routsrt=(/ (ii,ii=2,6), (ii,ii=41,47), (ii,ii=51,58), 1 /)

  call timacc(1,2)
  if(peinf%inode.eq.0) then
    write(6,*)
    write(6,9000) 'CPU [s]','WALL [s]','#'
    write(6,*)
  endif
  
  do ii=1,ubound(routsrt, 1)
    call timacc(routsrt(ii),3,tsec,ncount)
#ifdef MPI
    call MPI_ALLREDUCE(tsec,tmin,2,MPI_REAL_DP,MPI_MIN,MPI_COMM_WORLD,mpierr)
    call MPI_ALLREDUCE(tsec,tmax,2,MPI_REAL_DP,MPI_MAX,MPI_COMM_WORLD,mpierr)
#else
    tmin = tsec
    tmax = tsec
#endif
    if(peinf%inode==0) then
      if (ii>1) then
        if (routsrt(ii)-routsrt(ii-1)/=1) write(6,*)
      endif
      write(6,9001) routnam(routsrt(ii)),tmin(1),tmin(2),ncount
      write(6,9002) tsec(1),tsec(2)
      write(6,9003) tmax(1),tmax(2)
    endif
  enddo

9000 format(17x,a13,  3x,a13,  3x,a8)
9001 format(1x,a11,'(min.)',f13.3,3x,f13.3,3x,i8)
9002 format(  12x,'(PE 0)',f13.3,3x,f13.3)
9003 format(  12x,'(max.)',f13.3,3x,f13.3)

  POP_SUB(haydock)
  return

end subroutine haydock

!==========================================================================
!
! Routines:
!
! (1) inread()  Originally By (SIB)             Last Modified 5/9/2008 (JRD)
!
!     Reads the input file and sets various values
!
!       ecuts is the epsilon_cutoff
!       cwfn%nband is number_bands
!       cwfn%band_index() gets setup from band_occupation
!       pol%qpt(1:3,1:pol%nq) is the q vector information
!
!       pol%icutv to 0 if use no truncation
!
!       pol%icutv to 2 if use spherical truncation
!          transval(1) means r cut
!
!       pol%icutv to 4 if use cell wire truncation
!       pol%icutv to 5 if use cell box truncation
!       pol%icutv to 6 if use cell slab truncation
!
!==============================================================================

#include "f_defs.h"

subroutine inread(pol,vwfn,cwfn)

  use global_m
  use scissors_m
  use inread_common_m
  implicit none

  type (polarizability), intent(out) :: pol
  type (valence_wfns), intent(out) :: vwfn
  type (conduction_wfns), intent(out) :: cwfn
  
  character*256 :: blockword,keyword,line,errmsg
  integer :: ii,itestq,jj,nqpt_read,iostat
  
  real(DP) :: div,qpt_read(3,MAX_KPTS)
  integer :: band_occ(MAX_BANDS), ifreqCounter
  real(DP) :: tmpFreq, freqStep
  logical :: funny_occs, found, on_steroids

! for default settings for full-frequency calculation(Adler-Wiser)
  integer :: flag_DeltaFreq, flag_FreqStepIncrease, flag_FreqCutoff2  
! for default settings for full-frequency calculation(Shishkin-Kresse)
  integer :: flag_InitSFreq, flag_DeltaSFreq, flag_SFreqStepIncrease
  integer :: flag_SFreqCutoff1, flag_SFreqCutoff2
  character(len=9) :: str_intra
!-----------------------------
! Set default values

  PUSH_SUB(inread)
  
#ifdef MPI
  ! Non-root nodes should wait for root to read the whole file.
  ! That way, we can be sure root gets a chance to write errors before
  ! any die call is issued by another node. Root calls MPI_Barrier below.
  if(peinf%inode /= 0) call MPI_Barrier(MPI_COMM_WORLD, mpierr)
#endif

  nqpt_read=0
  pol%nq=0
  pol%nq0=0
  pol%nq1=0
  pol%subsample=.false.
  band_occ=0
  call scissors_zero(pol%scis)
  vwfn%nband=0
  cwfn%nband=0
  pol%freq_dep=0
  pol%freq_dep_method=0
  pol%nFreq=1
  pol%dInitFreq=0.0d0
  pol%dDeltaFreq=0.0d0
  pol%dFreqStepIncrease=0.0d0 
  pol%dFreqCutoff1=0.0d0
  pol%dFreqCutoff2=0.0d0
  pol%dBrdning=0.0d0
  pol%stop_after_qpt=-1

  flag_DeltaFreq=0
  flag_FreqStepIncrease=0
  flag_FreqCutoff2=0
  
  pol%nSFreq=1
  pol%dInitSFreq=0.0d0
  pol%dDeltaSFreq=0.0d0
  pol%dSFreqStepIncrease=0.0d0
  pol%dSFreqCutoff1=0.0d0
  pol%dSFreqCutoff2=0.0d0

  flag_InitSFreq=0
  flag_DeltaSFreq=0
  flag_SFreqStepIncrease=0
  flag_SFreqCutoff1=0
  flag_SFreqCutoff2=0  

  pol%fullConvLog=0
  pol%icutv=0
  pol%iwritecoul=0
  pol%truncval(1)=0.0d0
  pol%truncval(2)=0.0d0
  pol%truncval(3)=0.0d0
  pol%ecuts=0.0d0
  pol%valueq0=0
  pol%iqexactlyzero=0
  pol%ncrit=0
#ifdef HDF5
  pol%use_hdf5 = .true.
#else
  pol%use_hdf5 = .false.
#endif
  pol%efermi_input=0.0d0
  pol%rfermi=.true.
  pol%gcomm=-1
  pol%os_opt_ffts=0
  pol%restart=.false.
  pol%min_fftgrid=.true.
  pol%lin_denominator=0d0
  pol%os_para_freqs=1
  pol%os_hdf5=.false.
  pol%iwriteint=1
  pol%skip_epsilon=.false.
  pol%skip_chi=.false.
  pol%freplacebz=.false.
  pol%fwritebz=.false.
  pol%degeneracy_check_override=.false.
  peinf%npools=0
  pol%eqp_corrections=.false.
  pol%intraband_flag=0
  pol%intraband_overlap_min=0.9d0
  pol%patched_sampling=.false.
      
!----------------- Never ending loop ---------------------------------------

! Actually the loop ends when the end of the file is reached


  do while(0.eq.0)

    read(55,'(a256)',iostat=iostat) line
    if(iostat < 0) exit

! Skip comment lines

    if(len_trim(line).eq.0) cycle
    if(line(1:1).eq.'#') cycle

! Determine keyword:

    keyword=line(1:scan(line," ")-1)
    line=adjustl(line(scan(line," ")+1:256))

! SIB: If we have a 'begin', then in scan the information up to 'end'
! For now, only 'qpoints' is recognized

    if(trim(keyword).eq.'begin') then
      blockword=line(1:scan(line," ")-1)
      ii=0
      do while(trim(line).ne.'end')
        read(55,'(a256)',end=105) line
        if(trim(line).ne.'end') then
          ii=ii+1
          call check_bounds_nkq(ii, 'q', 'begin qpoints')
          if(trim(blockword).eq.'qpoints') then
            read(line,*,iostat=iostat) (qpt_read(jj,ii),jj=1,3), div,itestq
            if(iostat /= 0) then
              write(errmsg,'(3a)') 'Unexpected characters were found while reading elements of the ', &
                trim(blockword),' block.'
              call die(errmsg, only_root_writes = .true.)
            endif
            if (itestq.ne.0) then
              if(itestq /= 1 .and. itestq /= 2) &
                call die("Illegal value for last column in qpoints. May only be 0, 1, 2.", only_root_writes = .true.)
              pol%nq0 = pol%nq0 + 1
              if (pol%valueq0/=0 .and. itestq/=pol%valueq0) &
                call die("All q->0 points must have the same value for last column.", only_root_writes=.true.)
              pol%valueq0=itestq
              if (all(abs(qpt_read(:,ii))<TOL_Zero)) then
                pol%iqexactlyzero = 1
                if (peinf%inode .eq. 0) write(6,921)
              endif
            endif
            qpt_read(1:3,ii)=qpt_read(1:3,ii)/div
          else
            write(errmsg,'(3a)') 'Unexpected blockword ', trim(blockword), ' was found in epsilon.inp.'
            call die(errmsg, only_root_writes = .true.)
          end if
        end if
      end do
      if(trim(blockword).eq.'qpoints') then
        nqpt_read=ii
      endif

! SIB: Other keywords than 'begin'

    elseif(trim(keyword).eq.'frequency_dependence') then
      read(line,*,err=110) pol%freq_dep
    elseif(trim(keyword).eq.'frequency_dependence_method') then
      read(line,*,err=110) pol%freq_dep_method
    elseif(trim(keyword).eq.'init_frequency') then
      read(line,*,err=110) pol%dInitFreq
    elseif(trim(keyword).eq.'delta_frequency') then
      read(line,*,err=110) pol%dDeltaFreq
      flag_DeltaFreq=1
    elseif(trim(keyword).eq.'delta_frequency_step') then
      read(line,*,err=110) pol%dFreqStepIncrease
      flag_FreqStepIncrease=1
    elseif(trim(keyword).eq.'frequency_low_cutoff') then
      read(line,*,err=110) pol%dFreqCutoff1
    elseif(trim(keyword).eq.'frequency_high_cutoff') then
      read(line,*,err=110) pol%dFreqCutoff2
      flag_FreqCutoff2=1
    elseif(trim(keyword).eq.'broadening') then
      read(line,*,err=110) pol%dBrdning
    elseif(trim(keyword).eq.'init_sfrequency') then
      read(line,*,err=110) pol%dInitSFreq
      flag_InitSFreq=1
    elseif(trim(keyword).eq.'delta_sfrequency') then
      read(line,*,err=110) pol%dDeltaSFreq
      flag_DeltaSFreq=1
    elseif(trim(keyword).eq.'delta_sfrequency_step') then
      read(line,*,err=110) pol%dSFreqStepIncrease
      flag_SFreqStepIncrease=1
    elseif(trim(keyword).eq.'sfrequency_low_cutoff') then
      read(line,*,err=110) pol%dSFreqCutoff1
      flag_SFreqCutoff1=1
    elseif(trim(keyword).eq.'sfrequency_high_cutoff') then
      read(line,*,err=110) pol%dSFreqCutoff2
      flag_SFreqCutoff2=1
    elseif(trim(keyword).eq.'full_chi_conv_log') then
      read(line,*,err=110) pol%fullConvLog
    elseif(trim(keyword).eq.'number_qpoints') then
      read(line,*,err=110) pol%nq ! FHJ: deprecated
    elseif(trim(keyword).eq.'number_valence_pools') then
      read(line,*,err=110) peinf%npools
    elseif(trim(keyword).eq.'skip_epsilon') then
      pol%skip_epsilon=.true.
    elseif(trim(keyword).eq.'skip_chi') then
      pol%skip_chi=.true.
    elseif(trim(keyword).eq.'spherical_truncation') then
      pol%icutv=2
    elseif(trim(keyword).eq.'cell_wire_truncation') then
      pol%icutv=4
    elseif(trim(keyword).eq.'cell_box_truncation') then
      pol%icutv=5
    elseif(trim(keyword).eq.'cell_slab_truncation') then
      pol%icutv=6
    elseif(trim(keyword).eq.'comm_mpi') then
      pol%iwriteint=1
    elseif(trim(keyword).eq.'comm_disk') then
      pol%iwriteint=0
    elseif(trim(keyword).eq.'gcomm_elements') then
      pol%gcomm=0
    elseif(trim(keyword).eq.'gcomm_matrix') then
      pol%gcomm=-1
    elseif(trim(keyword).eq.'dont_use_hdf5') then
      pol%use_hdf5 = .false.
    elseif(trim(keyword).eq.'no_min_fftgrid') then
      pol%min_fftgrid = .false.
    elseif(trim(keyword).eq.'restart') then
      pol%restart = .true.
    elseif(trim(keyword).eq.'stop_after_qpt') then
      read(line,*,err=110) pol%stop_after_qpt
    elseif(trim(keyword).eq.'write_vcoul') then
      pol%iwritecoul=1
    elseif(trim(keyword).eq.'coulomb_truncation_x') then
      read(line,*,err=110) pol%truncval(1)
    elseif(trim(keyword).eq.'coulomb_truncation_radius') then
      read(line,*,err=110) pol%truncval(1)
    elseif(trim(keyword).eq.'epsilon_cutoff') then
      read(line,*,err=110) pol%ecuts
    elseif(trim(keyword).eq.'number_bands') then
      read(line,*,err=110) cwfn%nband
      call check_bounds_nbands(cwfn%nband, 'number_bands')
    elseif(trim(keyword).eq.'wavefunction_cutoff') then
      if(peinf%inode.eq.0) then 
        write(0,123) 
      endif
123   format(1x,"WARNING: Found keyword wavefunction_cutoff in the input file.",/,&
        10x,"This option is obsolete, use program wfnreduce instead.",/)
    elseif(trim(keyword).eq.'band_occupation') then
      read(line,*,err=110) (band_occ(ii),ii=1,cwfn%nband)
    elseif(trim(keyword).eq.'number_partial_occup') then
      read(line,*,err=110) pol%ncrit
    elseif(trim(keyword).eq.'ncrit') then
      if(peinf%inode.eq.0) then 
        write(0,124) 
      endif
124   format(1x,"WARNING: Found keyword ncrit in the input file.",/,&
        10x,"This option is deprecated, use keyword number_partial_occup instead.",/)
      read(line,*,err=110) pol%ncrit
    elseif(trim(keyword).eq.'fermi_level') then
      read(line,*,err=110) pol%efermi_input
    elseif(trim(keyword).eq.'fermi_level_absolute') then
      pol%rfermi=.false.
    elseif(trim(keyword).eq.'fermi_level_relative') then
      pol%rfermi=.true.
    elseif(trim(keyword).eq.'fullbz_replace') then
      pol%freplacebz=.true.
    elseif(trim(keyword).eq.'fullbz_write') then
      pol%fwritebz=.true.
    elseif(trim(keyword).eq.'degeneracy_check_override') then
      pol%degeneracy_check_override=.true.
    elseif(trim(keyword).eq.'eqp_corrections') then
      pol%eqp_corrections=.true.
    else
      call scissors_inread(keyword, line, pol%scis, found)
      if(.not. found) then
        write(errmsg,'(3a)') 'Unexpected keyword ', trim(keyword), ' was found in epsilon.inp.'
        call die(errmsg, only_root_writes = .true.)
      endif
    end if
  enddo

! End of Big Input Loop

  if ((pol%freq_dep==2).and.(pol%freq_dep_method==1)) then
    if (peinf%inode==0) then
      write(0,*)
      write(0,*) 'WARNING: Shishkin and Kresse method for polarizability is under development.'
      write(0,*) 'Please, double check your results against the Adler-Wiser formulation.'
      write(0,*)
    endif
    if (pol%gcomm==-1) then
      pol%gcomm=0
      if (peinf%inode==0) then
        write(0,*)
        write(0,*) 'WARNING: Shishkin and Kresse method for polarizability does not work with gcomm_matrix.'
        write(0,*) 'Changing communication method to gcomm_elements.'
        write(0,*)
      endif
    endif
  endif

! Default settings for full-frequency calculation
  if (pol%freq_dep .eq. 2) then
    if (flag_DeltaFreq .eq. 0) then
      pol%dDeltaFreq=pol%dBrdning
      if (peinf%inode==0) then
        write(6,'(1x,a,1x,f11.6)') 'Default: delta_frequency =', pol%dDeltaFreq 
      endif 
    endif
      
    if (flag_FreqStepIncrease .eq. 0) then
      pol%dFreqStepIncrease=1.0
      if (peinf%inode==0) then
        write(6,'(1x,a,1x,f11.6)') 'Default: delta_frequency_step =', pol%dFreqStepIncrease
      endif
    endif

    if (flag_FreqCutoff2 .eq. 0) then
      pol%dFreqCutoff2=4*pol%dFreqCutoff1
      if (peinf%inode==0) then        
        write(6,'(1x,a,1x,f11.6)') 'Default: frequency_high_cutoff =', pol%dFreqCutoff2
      endif
    endif

    if (pol%freq_dep_method .eq. 1) then
      if (flag_InitSFreq .eq. 0) then
        pol%dInitSFreq=0D0
        if (peinf%inode==0) then
          write(6,'(1x,a,1x,f11.6)') 'Default: init_sfrequency =', pol%dInitSFreq
        endif
      endif
   
      if (flag_DeltaSFreq .eq. 0) then
        pol%dDeltaSFreq=pol%dDeltaFreq
        if (peinf%inode==0) then
          write(6,'(1x,a,1x,f11.6)') 'Default: delta_sfrequency =', pol%dDeltaSFreq
        endif
      endif
   
      if (flag_SFreqStepIncrease .eq. 0) then
        pol%dSFreqStepIncrease=0D0
        if (peinf%inode==0) then
          write(6,'(1x,a,1x,f11.6)') 'Default: delta_sfrequency_step =', pol%dSFreqStepIncrease
        endif
      endif

      if (flag_SFreqCutoff1 .eq. 0) then
        pol%dSFreqCutoff1=1D0
        if (peinf%inode==0) then
          write(6,'(1x,a,1x,f11.6)') 'Default: sfrequency_low_cutoff =', pol%dSFreqCutoff1
        endif
      endif

      if (flag_SFreqCutoff2 .eq. 0) then
        pol%dSFreqCutoff2=pol%dFreqCutoff1
        if (peinf%inode==0) then
          write(6,'(1x,a,1x,f11.6)') 'Default: sfrequency_high_cutoff =', pol%dSFreqCutoff2
        endif
      endif
    endif !FF and pol%freq_dep_method .eq. 1 
  endif
!-----------------------------------------------------------------------

!------------ This is where we end up if the file was read successfully -----------

  if (.not.pol%use_hdf5) pol%restart = .false.
  if (peinf%inode==0) then
    if (pol%restart) then
      write(6,'(/,1x,a,/)') 'We will restart the calculation from the last finished q-point.'
    else
      write(6,'(/,1x,a,/)') 'We will start a new calculation from scratch.'
    endif
  endif

  if (pol%iwriteint==0) then
    ! FHJ: min_fftgrid doesn`t support COMM_DISK
    pol%min_fftgrid=.false.
  endif


  if ((pol%freq_dep .eq. 2) .and. abs(pol%dDeltaFreq) .gt. TOL_Zero) then
    !SAFE_ALLOCATE(pol%dFreqGrid,(pol%nFreq))
    !SAFE_ALLOCATE(pol%dFreqBrd,(pol%nFreq))
    !do jj=1,pol%nFreq
    !  pol%dFreqGrid(jj)=dble(jj-1)*pol%dDeltaFreq + pol%dInitFreq
    !  pol%dFreqBrd(jj)=pol%dBrdning*(0.0,1.0)
    !enddo 

    tmpFreq = pol%dInitFreq
    ifreqCounter = 0
    freqStep = pol%dDeltaFreq
    do while (tmpFreq .le. pol%dFreqCutoff2)
      ifreqCounter = ifreqCounter+1
      if (tmpFreq .lt. pol%dFreqCutoff1) then
        tmpFreq=tmpFreq+pol%dDeltaFreq
      else 
        freqstep = freqstep + pol%dFreqStepIncrease
        tmpFreq=tmpFreq+freqStep
      endif
    enddo
    
    pol%nFreq = iFreqCounter
    SAFE_ALLOCATE(pol%dFreqGrid,(pol%nFreq))
    SAFE_ALLOCATE(pol%dFreqBrd,(pol%nFreq))
    
    tmpFreq = pol%dInitFreq
    ifreqCounter = 0
    freqStep = pol%dDeltaFreq
    do while (tmpFreq .le. pol%dFreqCutoff2)
      ifreqCounter = ifreqCounter+1
      pol%dFreqGrid(iFreqCounter)=tmpFreq
      pol%dFreqBrd(iFreqCounter)=pol%dBrdning*(0.0,1.0)
      
      if (tmpFreq .lt. pol%dFreqCutoff1) then
        tmpFreq=tmpFreq+pol%dDeltaFreq
      else 
        freqstep = freqstep + pol%dFreqStepIncrease
        tmpFreq=tmpFreq+freqStep
      endif
    enddo
  
    if(pol%freq_dep_method .eq. 1) then

      tmpFreq = pol%dInitSFreq
      ifreqCounter = 0
      freqStep = pol%dDeltaSFreq
      do while (tmpFreq .le. pol%dSFreqCutoff2)
        ifreqCounter = ifreqCounter+1
        if (tmpFreq .lt. pol%dSFreqCutoff1) then
          tmpFreq=tmpFreq+pol%dDeltaSFreq
        else
          freqstep = freqstep + pol%dSFreqStepIncrease
          tmpFreq=tmpFreq+freqStep
        endif
      enddo

      pol%nSFreq = ifreqCounter
      if (peinf%inode.eq.0) then 
        print*, 'pol%nSFreq',pol%nSFreq
      endif

      SAFE_ALLOCATE(pol%dSFreqGrid,(pol%nSFreq))

      tmpFreq = pol%dInitSFreq
      ifreqCounter = 0
      freqStep = pol%dDeltaSFreq
      do while (tmpFreq .le. pol%dSFreqCutoff2)
        ifreqCounter = ifreqCounter+1
        pol%dSFreqGrid(ifreqCounter)=tmpFreq

        if (tmpFreq .lt. pol%dSFreqCutoff1) then
          tmpFreq=tmpFreq+pol%dDeltaSFreq
        else
          freqstep = freqstep + pol%dSFreqStepIncrease
          tmpFreq=tmpFreq+freqStep
        endif
      enddo
    endif
  else if ((pol%freq_dep .eq. 2) .and. abs(pol%dDeltaFreq) .le. TOL_Zero) then
    call die("Illegal value for Delta Frequency in full frequency calculation")
  else
    pol%nFreq=1
    SAFE_ALLOCATE(pol%dFreqGrid,(pol%nFreq))
    SAFE_ALLOCATE(pol%dFreqBrd,(pol%nFreq))  
    pol%dFreqGrid = 0D0
    pol%dFreqBrd = 0D0
  endif

  if (peinf%inode==0 .and. pol%nq>0) then
    write(0,'(/,a)') 'WARNING: the `number_qpoints` flag is deprecated. The code now'
    write(0,'(a,/)') 'automatically figures out the number of q-points from the input.'
  endif
  pol%nq = nqpt_read

  pol%nq1 = pol%nq - pol%nq0
  if (.not.pol%subsample.and.pol%nq0>1) then
    call die('Can only have one q->0 point', only_root_writes=.true.)
  endif
  
  ! SIB: allocate polarizability q-points array pol%qpt(3,1:pol:nq)
  ! and copy what was read from qpt_read into it
  SAFE_ALLOCATE(pol%qpt, (3,pol%nq))
  pol%qpt(1:3,1:pol%nq)=qpt_read(1:3,1:pol%nq)
  
  ! SIB: check for bad input
  if(abs(pol%ecuts).lt.TOL_Zero) then
    call die("The epsilon_cutoff keyword could not be found.", only_root_writes = .true.)
  endif

  ! FHJ: Make sure the user entered a valid number of bands
  call check_consistency_nbands(cwfn%nband, .true.)

! SIB: Allocate cwfn%band_index(cwfn%nband), which is ALL the bands,
! and initialize it.  By the end of this, band_index() will have indices
! pointing to the bands with the order being first all valence states
! (occupancy 1.0) and then all conduction states (occupancy 0.0)

  SAFE_ALLOCATE(cwfn%band_index, (cwfn%nband))
  vwfn%nband=0
  jj=0
  do ii=1,cwfn%nband
    vwfn%nband=vwfn%nband+band_occ(ii)
    if(band_occ(ii).eq.1) then
      jj=jj+1
      cwfn%band_index(ii)=jj
    endif
  enddo
  if(vwfn%nband == 0 .and. pol%ncrit == 0) &
    call die("There are no occupied or partially occupied bands.", only_root_writes = .true.)
  if(vwfn%nband == cwfn%nband) &
    call die("There are no unoccupied bands.", only_root_writes = .true.)
  do ii=1,cwfn%nband
    if(band_occ(ii).eq.0) then
      jj=jj+1
      cwfn%band_index(ii)=jj
    endif
  enddo

  funny_occs = .false.
  do ii=1,cwfn%nband
    if(cwfn%band_index(ii) /= ii) funny_occs = .true.
  enddo
  if(funny_occs) call die("Non-equilibrium occupations not working.", only_root_writes = .true.)
  ! The problem is that the v-c pairs are weighted based on inferred occupations from E_F in mtxel, ignoring these. --DAS

!  if(funny_occs .and. peinf%inode == 0) then
!    write(0,'(a)') 'WARNING: degeneracy check will be incorrect if non-equilibrium occupations are used.'
!  endif

  if(pol%fullConvLog.lt.-1.or.pol%fullConvLog.gt.2) then
    call die('Invalid full_chi_conv_log', only_root_writes = .true.)
  endif
  
  if(pol%skip_epsilon .and. pol%skip_chi) then
    call die('Cannot skip_epsilon and skip_chi', only_root_writes = .true.)
  endif

  ! FHJ: will we need to read at least one q-point from WFNq?
  pol%need_WFNq = (pol%nq0>0.and.pol%valueq0==1.and.pol%iqexactlyzero==0).or.pol%patched_sampling

! gsm: What frequency dependence we are using?

  if(peinf%inode.eq.0) then
    if(pol%freq_dep.eq.0) then
      write(6,700)
      write(7,700)
    elseif((pol%freq_dep.eq.2).and.(pol%freq_dep_method.eq.0)) then
      write(6,702)
      write(7,702)
    elseif((pol%freq_dep.eq.2).and.(pol%freq_dep_method.eq.1)) then
      write(6,703)
      write(7,703)
    elseif(pol%freq_dep.eq.3) then
      write(6,704)
      write(7,704)
    else
      call die('Need to specify frequency dependence', only_root_writes = .true.)
    endif
  endif
700 format(1x,'Computing the static inverse dielectric matrix',/)
702 format(1x,'Computing the full frequency-dependent inverse dielectric matrix (Adler-Wiser formulation)',/)
703 format(1x,'Computing the full frequency-dependent inverse dielectric matrix (Shishkin-Kresse formulation)',/)
704 format(1x,'Computing the inverse dielectric matrix for two purely imaginary frequencies (Godby-Needs formulation)',/)

! JRD: What Communication Scheme are we using?
! We should make a better default choice based on 
! whether nv*nc*nk(reduced) > nmtx*nfreq
  
  if (peinf%inode.eq.0) then
    if (pol%gcomm .eq. -1) then
      write(6,801)
      write(7,801)
    else
      write(6,802)
      write(7,802)
    endif
  endif
801 format(1x,'We are using matrix communication scheme',/)
802 format(1x,'We are using element communication scheme',/)

  if(peinf%inode == 0) then
    if(pol%iwriteint == 1) then ! comm_mpi
      if(peinf%npes > 1) then
        write(6,803)
        write(7,803)
      else
        write(6,805)
        write(7,805)
      endif
    else ! comm_disk
      write(6,804)
      write(7,804)
    endif
  endif
803 format(1x,'We are communicating via MPI',/)
804 format(1x,'We are communicating via disk',/)
805 format(1x,'We are not communicating',/)

! JRD: What truncation scheme are we using?

  if(peinf%inode.eq.0) then
    if(pol%icutv.eq.0) then
      write(6,900)
      write(7,900)
    elseif(pol%icutv.eq.2) then
      write(6,902)
      write(7,902)
      write(6,912)pol%truncval(1)
      write(7,912)pol%truncval(1)
    elseif(pol%icutv.eq.4) then
      write(6,904)
      write(7,904)
    elseif(pol%icutv.eq.5) then
      write(6,905)
      write(7,905)
    elseif(pol%icutv.eq.6) then
      write(6,906)
      write(7,906)
    endif
  endif
  900 format(1x,'We are using no truncation',/)
  902 format(1x,'We are using a truncated Coulomb interaction (spherical)')
  904 format(1x,'We are using a truncated Coulomb interaction: Cell Wire',/)
  905 format(1x,'We are using a truncated Coulomb interaction: Cell Box',/)
  906 format(1x,'We are using a truncated Coulomb interaction: Cell Slab',/)
  912 format(1x,'r_cut = ',f10.6,' Bohr'/)
  921 format(1x,'Doing q exactly zero',/)

! JRD: Do we have partially occupied bands?

  if(peinf%inode.eq.0) then
    if(pol%ncrit.gt.0) then
      write(6,951)pol%ncrit
      write(7,951)pol%ncrit
951   format(1x,'We have partially occupied bands',/, &
        1x,'number_partial_occup (ncrit) =',i3,/)
    endif
  endif

  if (peinf%inode==0 .and. pol%intraband_flag/=0) then
    if (pol%intraband_flag<0 .or. pol%intraband_flag>2) &
      call die('Invalid value for flag `intraband_flag`', only_root_writes=.true.)
    if (pol%intraband_overlap_min<0d0 .or. pol%intraband_overlap_min>1d0) &
      call die('Invalid value for flag `intraband_overlap_min`', only_root_writes=.true.)
    if (pol%intraband_flag==1) then
      str_intra = 'intraband'
    else
      str_intra = 'interband'
    endif
    write(6,'(/,1x,3a,f9.6,/)') 'Calculating only ', str_intra, &
      ' transitions, intraband_overlap_min = ', pol%intraband_overlap_min
    if (.not.pol%skip_epsilon) then
      write(0,'(/1x,3a)') 'WARNING: you are only calculating ', str_intra, ' transitions, but'
      write(0,'(1x,a)') 'you are not skipping epsilon. Remember that inverse dielectric matrices cannot'
      write(0,'(1x,a,/)') 'not be added toghether, only the polarizability!'
    endif
  endif

#ifdef MPI
  ! root lets the others go after it is done reading (see beginning of function)
  if(peinf%inode == 0) call MPI_Barrier(MPI_COMM_WORLD, mpierr)
#endif

  POP_SUB(inread)
  
  return
  
105 write(errmsg,'(3a)') 'The end of the file was reached while reading elements of the ', &
      trim(blockword),' block.'
  call die(errmsg, only_root_writes = .true.)
  
110 write(errmsg,'(3a)') 'Unexpected characters were found while reading the value for the keyword ', &
      trim(keyword), '. '
  call die(errmsg, only_root_writes = .true.)
  
end subroutine inread

!=============================================================
! Utilities:
! 
! wfnmerge  Originally by JLL. Modifications by JRD. Version compatible 
! with new wavefunction format by BDM.
!
! Merges many WFN files into one. It assumes that all input files have the 
! same number and same ordering of G-vectors for the charge density.
! The number and name of input files is read from "wfnmerge.inp", as well
! as the k-grid and the k-shift.
!
! FAQ:
! Q: Why would someone want to use this?
! A: For example, maybe to do a converged calculation one needs to include a
!     large number of unoccupied states. There may not be the resources (either
!     CPUs or wallclock) to do this all in one shot, so it may be beneficial to
!     split up a calculation of kpoints (e.g., 4x4x4 MP grid) into smaller
!     pieces and then add up the final wavefunctions.
! Q: What is the deal with kpoint weights?
! A: Quantum Espresso renormalizes the kpoint weights that you use in a 
!    calculation. If you are splitting up a MP grid into different groups of 
!    kpoints, and each group is normalized, the relative weights between
!    kpoints in different groups is no longer correct. BerkeleyGW does not 
!    make use of the kpoint weights (except for in determining whether the 
!    Fermi level is reasonable for metallic calculations). So for most uses
!    the fact that these weights are incorrect does not matter and you can
!    set the relative weights for each group of k-points to 1 in the input
!    file. If it matters to you, set the relative weights according to the
!    weights of k-points in the original MP grid and check the weights in
!    the final WFN file using wfn_rho_vxc_info.x.
!=============================================================

#include "f_defs.h"

program wfnmerge

  use global_m
  use wfn_rho_vxc_io_m
  implicit none

  integer, pointer :: atyp(:)
  real(DP),pointer :: kw(:)
  real(DP),pointer :: tkw(:)    !< total kweights
  real(DP),pointer :: kpt(:,:)
  real(DP),pointer :: tkpt(:,:)  !< total list of kpoints
  integer,pointer  :: ifmin(:,:)
  integer, pointer :: tifmin(:,:)  !< total ifmin
  integer,pointer  :: ifmax(:,:)
  integer, pointer :: tifmax(:,:)  !< total ifmax
  real(DP),pointer :: occ(:,:,:)
  real(DP),pointer :: tocc(:,:,:)  !< total occupancy
  real(DP),pointer :: en(:,:,:)
  real(DP),pointer :: ten(:,:,:)   !< total energies
  integer, pointer :: ngk(:)
  integer, pointer :: tngk(:)      !< total number of gvectors
  real(DP),pointer :: apos(:,:)
  integer, allocatable :: gvec(:,:)
  integer, allocatable :: kptfile(:)  !< kpts per file
  integer, allocatable :: tngkmax(:)  !< ngkmax for each file
  real(DP), allocatable :: rdata(:,:)
  complex(DPC), allocatable :: cdata(:,:)
  integer :: cell_symmetry,iflavor,ns,ng,nsym,nat,nk,nb,&
       ngkmax,kmax(3),kgrid(3),rot(3,3,48),expkpt
  real(DP) :: ecutrho,ecutwfn,celvol,recvol,al,bl,a(3,3),b(3,3),adot(3,3),&
       bdot(3,3),kshift(3),tau(3,48),thesum

  integer :: total_kgrid(3),ifil,ik,ikindex,ib
  integer :: mngkmax  !< maximum number of gvectors for all kpoints
  real(DP) :: grid_shift(3)
  character*80 :: outfile
  character*80, allocatable :: infile(:)
  real(DP), allocatable :: relweight(:)
  character*3 :: sheader
  integer :: nfil,iunit,index
  integer, allocatable :: nkfil(:)
  integer :: tnk ! total number of kpoints

! Read wfnmerge.inp

  call open_file(55,file='wfnmerge.inp',form='formatted',status='old')
  read(55,'(a80)') outfile
  read(55,*) total_kgrid(1),total_kgrid(2),total_kgrid(3)
  read(55,*) grid_shift(1),grid_shift(2),grid_shift(3)
  read(55,*) nfil
  read(55,*) expkpt  ! the expected number of kpoints
  SAFE_ALLOCATE(infile,(nfil))
  SAFE_ALLOCATE(relweight,(nfil))
  SAFE_ALLOCATE(nkfil,(nfil))
  do ifil=1,nfil
    read(55,'(a80)') infile(ifil)
  enddo
  do ifil=1,nfil
    read(55,*) relweight(ifil)
  enddo
  call close_file(55)

  write(6,*) 'Output -> ', TRUNC(outfile)

  SAFE_ALLOCATE(tkw,(expkpt))
  SAFE_ALLOCATE(tkpt,(3,expkpt))
  SAFE_ALLOCATE(tngk,(expkpt))
  SAFE_ALLOCATE(kptfile,(nfil))
  SAFE_ALLOCATE(tngkmax,(nfil))

! Open all the WFN files to be read

  call open_file(8,file=outfile,form='unformatted',status='replace')
  do ifil=1,nfil
    iunit=128+ifil
    call open_file(iunit,file=infile(ifil),form='unformatted',status='old')
  end do

! Read headers

  tnk=0
  index=1
  sheader='WFN'
  iflavor=-1
  mngkmax=-1000
  do ifil=1,nfil
    iunit=128+ifil
    call read_binary_header(iunit,sheader,iflavor,ns,ng,nsym,&
      cell_symmetry,nat,nk,nb,ngkmax,ecutrho,ecutwfn,kmax, &
      kgrid,kshift,celvol,al,a,adot,recvol,bl,b,bdot, & 
      rot,tau,atyp,apos,ngk,kw,kpt,ifmin,ifmax,en,occ,dont_warn_kgrid=.true.)
    if (ifil.eq.1) then
      SAFE_ALLOCATE(tifmin,(expkpt,ns))
      SAFE_ALLOCATE(tifmax,(expkpt,ns))
      SAFE_ALLOCATE(ten,(nb,expkpt,ns))
      SAFE_ALLOCATE(tocc,(nb,expkpt,ns))
    end if
    tnk=tnk+nk
    kptfile(ifil)=nk
    if (ngkmax>mngkmax) mngkmax=ngkmax
    tngkmax(ifil)=ngkmax
    tkw(index:index+nk-1)=kw(1:nk)*relweight(ifil)
    tkpt(:,index:index+nk-1)=kpt(:,1:nk)
    tifmin(index:index+nk-1,:)=ifmin(1:nk,:)
    tifmax(index:index+nk-1,:)=ifmax(1:nk,:)
    ten(:,index:index+nk-1,:)=en(:,1:nk,:)
    tocc(:,index:index+nk-1,:)=occ(:,1:nk,:)
    tngk(index:index+nk-1)=ngk(1:nk)
    index=index+nk
  end do

! Renormalize the weights.
! See note in the header for more about this

  thesum=sum(tkw(1:tnk))
  do ik=1,tnk
    tkw(ik)=tkw(ik)/thesum
  end do

  write(6,*) 'Total number of kpoints found=',tnk
  if (tnk.ne.expkpt) then
    call die('Unexpected number of kpoints found!')
  end if

! Headers read. Write output header

  call write_binary_header(8,sheader,iflavor,ns,ng,nsym,&
    cell_symmetry,nat,tnk,nb,mngkmax,ecutrho,ecutwfn,kmax,&
    total_kgrid,grid_shift,celvol,al,a,adot,recvol,bl,b,bdot,&
    rot,tau,atyp,apos,tngk,tkw,tkpt,tifmin,tifmax,ten,tocc,dont_warn_kgrid=.true.)

! Read charge density gvectors

  SAFE_ALLOCATE(gvec,(3,ng))
  do ifil=1,nfil
    iunit=128+ifil
    call read_binary_gvectors(iunit,ng,ng,gvec)
    if (ifil.eq.1) then
      call write_binary_gvectors(8,ng,ng,gvec)
    end if
  end do
  SAFE_DEALLOCATE(gvec)

! Now we loop over kpoints, get their respective gvectors, and 
! read/write data band-by-band

  SAFE_ALLOCATE(gvec,(3,mngkmax))
  if (iflavor .eq. 1) then
     SAFE_ALLOCATE(rdata,(mngkmax,ns))
  else
     SAFE_ALLOCATE(cdata,(mngkmax,ns))
  end if
  ikindex=0
  do ifil=1,nfil
    iunit=128+ifil
    do ik=1,kptfile(ifil)
      ikindex=ikindex+1
      write(6,*) 'Working on kpoint #', ikindex
      ! read g-vectors for current k-point
      call read_binary_gvectors(iunit,tngk(ikindex),tngkmax(ifil),gvec)
      ! write these g-vectors back to the outfile
      call write_binary_gvectors(8,tngk(ikindex),mngkmax,gvec)
      ! now read/write band data
      do ib=1,nb
        if (iflavor .eq. 1) then
           rdata(:,:) = 0d0
           call read_binary_data(iunit,tngk(ikindex),tngkmax(ifil),ns,rdata(1:tngkmax(ifil),:))
           call write_binary_data(8,tngk(ikindex),mngkmax,ns,rdata)
        else
           cdata(:,:) = CMPLX(0d0, 0d0)
           call read_binary_data(iunit,tngk(ikindex),tngkmax(ifil),ns,cdata(1:tngkmax(ifil),:))
           call write_binary_data(8,tngk(ikindex),mngkmax,ns,cdata)
        endif
      end do
    end do ! ik   
  end do ! ifil

! Close files

  do ifil=1,nfil
    iunit=128+ifil
    call close_file(iunit)
  end do
  call close_file(8)

! Deallocate arrays

  if (iflavor .eq. 1) then
     SAFE_DEALLOCATE(rdata)
  else
     SAFE_DEALLOCATE(cdata)
  endif
  SAFE_DEALLOCATE(gvec)
  SAFE_DEALLOCATE(tngkmax)
  SAFE_DEALLOCATE(kptfile)
  SAFE_DEALLOCATE_P(tkw)
  SAFE_DEALLOCATE_P(tngk)
  SAFE_DEALLOCATE_P(tkpt)
  SAFE_DEALLOCATE_P(tifmin)
  SAFE_DEALLOCATE_P(tifmax)
  SAFE_DEALLOCATE_P(ten)
  SAFE_DEALLOCATE_P(tocc)
  SAFE_DEALLOCATE(infile)
  SAFE_DEALLOCATE(relweight)
  SAFE_DEALLOCATE(nkfil)

end program wfnmerge

!==========================================================================
!
! Routines:
!
! (1) genwf_disk()  Originally By (JRD)             Last Modified 11/2009 (JRD)
!
!     On entry:
!     qq  = current q-vector
!     rk  = current k point in irr. zone
!     irk = its index
!
!     On exit:
!     vwfn%ev and vwfn%zv hold eigenvalues and wavefunctions (valence)
!     cwfn%ec and cwfn%zc hold eigenvalues and wavefunctions (conduction)
!
!     with proper phases and ordering for the k-point rk (given the
!     data on disk for irr. zone)
!
!     subroutine generates valence-band wavefunctions for rk(irk)
!     and conduction-band wavefunctions for rk(irk) from the
!     wavefunctions available for rk in the irreducible wedge of the
!     bz
!
!     i   rk                 rk(irk)
!     o c ngv,...,ev       valence-band wavefunctions for rk+q
!     and associated data
!     o c ngc,...,ec       conduction-band wavefunctions for rk
!     and associated data
!
!==========================================================================

#include "f_defs.h"

module genwf_disk_m

  use global_m
  use find_kpt_match_m
  use gmap_m
  use input_utils_m
  use misc_m
  use sort_m

  implicit none

  private

  public :: genwf_disk

contains  

subroutine genwf_disk(syms,gvec,crys,kp,kpq,irk,rk,qq,vwfn,pol,cwfn,use_wfnq,ivin)
  type (symmetry), intent(in) :: syms
  type (gspace), intent(in) :: gvec
  type (crystal), intent(in) :: crys
  type (kpoints), target, intent(in) :: kp
  type (kpoints), target, intent(in) :: kpq
  integer, intent(in) :: irk
  real(DP), intent(in) :: rk(3)
  real(DP), intent(in) :: qq(3)
  type (valence_wfns), intent(inout) :: vwfn
  type (polarizability), intent(in) :: pol
  type (conduction_wfns), intent(inout) :: cwfn
  logical, intent(in) :: use_wfnq
  integer, intent(in) :: ivin

  integer :: ng
  integer, allocatable :: isortc(:)
  real(DP), allocatable :: eig(:,:)
  SCALAR, allocatable :: zin(:,:),zinc(:,:)
  SCALAR, allocatable :: zintemp(:,:)
  type(kpoints), pointer :: kp_point

  character :: filename*20, filenamev*20, filenamevq*20
  character :: tmpstr*120
  integer :: itqq,i,j,k,ng2
  integer :: n,ig,ispin,iunit_c,iunit_v,iband
  integer :: naddc,jj,icount
  integer :: ikrkq,kgq(3),kgqq(3)
  integer, allocatable :: ind(:),isorti(:)
  real(DP), allocatable :: xnorm(:)
  real(DP) :: qk(3),rkq(3)
  real(DP), allocatable :: ekin(:)
  real(DP) :: rkmatch(3)

  SCALAR, allocatable :: ph(:)

  integer, save :: irk_old=0

  PUSH_SUB(genwf_disk)
  
  if(peinf%inode.eq.0) then
    write(filenamev,'(a)') 'INT_VWFN'
    write(filenamevq,'(a)') 'INT_VWFQ'
  endif

  SAFE_ALLOCATE(isortc, (gvec%ng))
  SAFE_ALLOCATE(eig, (cwfn%nband,kp%nspin))
  SAFE_ALLOCATE(xnorm, (kp%nspin))

  if(peinf%inode.eq.0) call timacc(16,1)

! rkq = rk + qq   (i.e. rkq = current kpoint in irr. zone + qq)

  rkq(1:3) = rk(1:3) + qq(1:3)

! Should we look for the valence WFNs in WFNq or WFN?
  if (use_wfnq) then
    kp_point => kpq
  else
    kp_point => kp
  endif

! We used to assume WFNq contained the needed q->0 point,
! but it is better to unfold the shifted grid for more flexibility.

  call find_kpt_match(kp_point, syms, rkq, ikrkq, itqq, kgqq)

  if(ikrkq == 0) then
    if(peinf%inode == 0) write(0,'(a,3f12.6,/,a,3f12.6)') 'rk = ', rk(:), 'qq = ', qq(:)
    write(tmpstr,'(a,3f8.3,a)') 'genwf_disk: No match for rkq point:',rkq,' in file'
    if(use_wfnq) then
      write(tmpstr,'(a,a)') TRUNC(tmpstr), ' WFNq'
    else
      write(tmpstr,'(a,a)') TRUNC(tmpstr), ' WFN'
    endif
    call die(tmpstr, only_root_writes = .true.)
  endif

  rkmatch(1:3) = kp_point%rk(1:3, ikrkq)
  vwfn%idx_kp = ikrkq

!
! SIB:  proc 0 will read from unit iunit_v and
! skip as many records as needed until it reads all the ikrkq`th valence
! wavefunctions. It then broadcasts the valence data (if MPI).
!

  if(peinf%inode.eq.0) then
    if (use_wfnq) then
      iunit_v=300028
      call open_file(iunit_v,file=filenamevq,form='unformatted',status='old')
    else
      iunit_v=200028
      call open_file(iunit_v,file=filenamev,form='unformatted',status='old')
    endif
    if(ikrkq.gt.1) then
      do i=1,ikrkq-1
        read(iunit_v)
        do j=1,(vwfn%nband+pol%ncrit)
          read(iunit_v)
        enddo
      enddo
    endif

! SIB: isortc(j) from disk tells us what the index of the j`th g-vector
! is in the array of g-vectors in gvec

    read(iunit_v) ng,(isortc(j),j=1,ng), &
      ((eig(j,k),j=1,(vwfn%nband+pol%ncrit)),k=1,kp%nspin),(qk(i),i=1,3)
  endif

#ifdef MPI
  call MPI_Bcast(ng, 1, MPI_INTEGER,0, MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(isortc,ng,MPI_INTEGER,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(eig,cwfn%nband*kp%nspin,MPI_REAL_DP,0,MPI_COMM_WORLD,mpierr)
  call MPI_Bcast(qk, 3, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
#endif

  SAFE_ALLOCATE(zintemp, (ng,kp%nspin*kp%nspinor))
  SAFE_ALLOCATE(zin, (ng,kp%nspin*kp%nspinor))
  
  do i=1,(vwfn%nband+pol%ncrit)
    zintemp=0D0
    if (peinf%inode .eq. 0) then
      read(iunit_v) ((zintemp(j,k),j=1,ng),k=1,kp%nspin*kp%nspinor)
    endif

#ifdef MPI
    call MPI_Bcast(zintemp, ng*kp%nspin, MPI_SCALAR, 0, MPI_COMM_WORLD, mpierr)
#endif

!        if (peinf%nvownmax(i) .eq. 1) then
    if (i .eq. ivin) then
!          zin(((peinf%nvindex(i)-1)*ng+1):((peinf%nvindex(i)) &
!          *ng),:)=zintemp(:,:)
      zin(:,:)=zintemp(:,:)
    endif
  enddo

  if(peinf%inode == 0) call close_file(iunit_v)

  SAFE_DEALLOCATE(zintemp)
  
  if (ivin .eq. -1) then 
    SAFE_DEALLOCATE(zin)
    SAFE_DEALLOCATE(xnorm)
    SAFE_DEALLOCATE(eig)
    SAFE_DEALLOCATE(isortc)
    irk_old=irk
    POP_SUB(genwf_disk)
    return
  endif

! Check kpoint

  if(any(abs(rkmatch(1:3) - qk(1:3)) .gt. TOL_Small)) call die('genwf_disk: rkmatch')

! Compute kinetic energies for rkq+g

  SAFE_ALLOCATE(ekin, (gvec%ng))
  call kinetic_energies(gvec, crys%bdot, ekin, qvec = rkq)

! sort array ekin to ascending order, store indices in array vwfn%isort
! WARNING: one should not assume that in the case of
! q-->0 the orders as provided below and as read in from
! WFNq file is the same (sorting may change....)
! ===> need to call gmap also for q-->0 (see below)
! EKC: We initialize vwfn%isort to the appropriate array
! before reading in. this way we do not get zeroes in the array
! these are the valence wave-functions that do not need
! to be changed

  call sortrx(gvec%ng,ekin,vwfn%isort,gvec=gvec%components)

  SAFE_ALLOCATE(isorti, (gvec%ng))
  do i=1,gvec%ng
    isorti(vwfn%isort(i))=i
  enddo
  do i=1,ng
    isorti(isortc(i))=i
  enddo
  
  vwfn%ngv=ng

! SIB: put read eigenvalues into vwfn%ev(band,spin).
! Set xnorm(1:(vwfn%nband+pol%ncrit),1:nspin)=0

  if (irk .ne. irk_old) then
    SAFE_ALLOCATE(vwfn%ev, ((vwfn%nband+pol%ncrit),kp%nspin))
    vwfn%ev(1:(vwfn%nband+pol%ncrit),:) = eig(1:(vwfn%nband+pol%ncrit),:)
  endif
  SAFE_DEALLOCATE(eig)

! JRD: Map planewave components for rk+q, to those of rk
! (even for q--> 0)
!
! SIB: get phases (ph) and indices (ind) for g-vectors
! gvec%components(:,vwfn%isort(1:vwfn%ngv))+kgqq

  SAFE_ALLOCATE(ind, (vwfn%ngv))
  SAFE_ALLOCATE(ph, (vwfn%ngv))
  call gmap(gvec,syms,vwfn%ngv,itqq,kgqq,vwfn%isort,isorti,ind,ph,.true.)

  SAFE_ALLOCATE(vwfn%zv, (vwfn%ngv,kp%nspin*kp%nspinor))

! XAV: vwfn%zv(ig) corresponds really to the
! vwfn%isort(ig) G-vector (between 1 and ng)
! The subroutine gmap assumes that, as read from WFNq or WFN,
! zin(ig) corresponds really to isortc(ig) G-vector !!!
!
! SIB:  checks that zin vectors have norm greater than 1e-6, and then
! normalizes them to have unit square modulus.
!
! BAB:  we check if the norm differs appreciably from unity.
! there is no longer a need to further normalize the vector

  do ispin=1,kp%nspin*kp%nspinor
    vwfn%zv(:,ispin)=zin(ind(:),ispin)*ph(:)
  enddo

! In spinor case, we must rotate spinors according to spinor rotation matrix umtrx


  do ispin=1,kp%nspin
    call compute_norm(xnorm(ispin),ispin,vwfn%ngv,kp%nspinor,vwfn%zv(:,:))
    if(abs(xnorm(ispin) - 1d0) > TOL_Small) then
      write(0,*) 'Bad norm: sym op=',itqq,'ik=',ikrkq,'ispin=',ispin,'norm=',xnorm(ispin)
      call die('genwf_disk: Bad norm')
    endif
  enddo

! End calculation of valence-band wavefunctions

  SAFE_DEALLOCATE(zin)
  SAFE_DEALLOCATE(ind)
  SAFE_DEALLOCATE(ph)
  SAFE_DEALLOCATE(xnorm)
  if(peinf%inode.eq.0) call timacc(16,2)

  if(irk .ne. irk_old) then

!------------------------------------------------------------------------
! Generate conduction-band wavefunctions for rk
! find rk, r, g0 such that rk=r(rk)+g0

! SIB: This seems redundant, but find a k-point and symmetry so that
! rk = sym%mtrx(:,:,itqq)*kp%rk(irk_,:) + kgq, where kgq is integer 3-vec

    if(peinf%inode.eq.0) call timacc(17,1)

    call find_kpt_match(kp, syms, rk, ikrkq, itqq, kgq)
    cwfn%idx_kp = ikrkq

    if(ikrkq == 0) call die('genwf_disk: kgq mismatch')

! Write out rk, it and kgq

#ifdef VERBOSE
    if(peinf%inode.eq.0) then
      write(6,7000) (rk(i),i=1,3),ikrkq,(kp%rk(i,ikrkq),i=1,3),itqq,(kgq(i),i=1,3)
7000  format(1x,'rk=',3f7.3,1x,'irk_=',i5,1x,' rk=',3f7.3,1x,'it=',i5,1x,'kg0=',3i3)
    endif
#endif

! SIB: if we already found this k-point last time, get its qk, ng,
! and isortc(:).  Otherwise, open from unit iunit_c=128+peinf%inode,
! skip ikrkq-1 records, and read in information (qk,cwfn%ec,ng,isortc),
! JRD: Now need open
  
    if(peinf%inode.lt.10000) then
      write(filename,'(a,i4.4)') 'INT_CWFN_', peinf%inode
    else
      call die('too many nodes required')
    endif
  
    iunit_c=100028+peinf%inode
    call open_file(iunit_c,file=filename,form='unformatted',status='old')
    
    if(ikrkq.gt.1) then
      icount=0
      do i=1,ikrkq-1
        icount=icount+peinf%ncownactual+1
      enddo
      do i=1,icount
        read(iunit_c)
      enddo
    endif
    
    SAFE_ALLOCATE(cwfn%ec, (cwfn%nband,kp%nspin))
    read(iunit_c) (qk(i),i=1,3),((cwfn%ec(j,k),j=1,cwfn%nband),k=1,kp%nspin),ng,(isortc(j),j=1,ng)
  
! Check kpoint (again ...  boring...)
! Check that kp%rk(:,ikrkq) = qk  (why it wouldn`t is a mystery!)

    if(any(abs(kp%rk(1:3, ikrkq) - qk(1:3)) .gt. TOL_Small)) &
      call die('genwf_disk: qk mismatch')

    cwfn%ngc=ng

! Compute inverse to isort
! NOTE: isortc orders   |kp%rk+G|^2
! It is not necessarily the same order than |rk+G|^2
! (particularly if umklapp, ie kgq non zero)

    if(peinf%inode.eq.0) call timacc(28,1)

    call kinetic_energies(gvec, crys%bdot, ekin, qvec = rk)

    if(peinf%inode.eq.0) call timacc(28,2)

! Sort array ekin to ascending order
! store indices in array isort

    if(peinf%inode.eq.0) call timacc(29,1)

    call sortrx(gvec%ng,ekin,cwfn%isort,gvec=gvec%components)

    if(peinf%inode.eq.0) call timacc(29,2)

    do i=1,gvec%ng
      isorti(cwfn%isort(i))=i !to initialize
    enddo
    do i=1,ng
      isorti(isortc(i))=i
    enddo
    SAFE_DEALLOCATE(isortc)
    SAFE_DEALLOCATE(ekin)

! map planewave components for rk to those of rk
! compute phases
! We do not the isorti related to kp%rk BUT the cwfn%isort related to rk

    SAFE_ALLOCATE(ind, (cwfn%ngc))
    SAFE_ALLOCATE(ph, (cwfn%ngc))
    call gmap(gvec,syms,cwfn%ngc,itqq,kgq,cwfn%isort,isorti,ind,ph,.true.)
    SAFE_DEALLOCATE(isorti)

! generate conduction-band wavefunctions
! loop over wavefunctions
! read conduction-band from file one by one

    SAFE_ALLOCATE(cwfn%zc, (peinf%ncownactual*cwfn%ngc,kp%nspin*kp%nspinor))
    SAFE_ALLOCATE(zinc, (cwfn%ngc,kp%nspin*kp%nspinor))

    do n=1,peinf%ncownactual
      
      read(iunit_c) iband,ng2,((zinc(jj,k),jj=1,ng2),k=1,kp%nspin*kp%nspinor)
      
      if(ng2 .ne. cwfn%ngc) call die('genwf_disk: ngc mismatch')
      if(iband .ne. peinf%invindexc(n)) call die('genwf_disk: invindexc mismatch')

      naddc=(n-1)*cwfn%ngc

!
! Loop over components of wfns
! note that only conduction-band wfns are stored-
! they start in the 1st position with the state nvband+1
!
      do ig=1,cwfn%ngc
        cwfn%zc(naddc+ig,:)=ph(ig)*zinc(ind(ig),:)
      enddo

! In spinor case, we must rotate spinors according to spinor rotation matrix umtrx


    enddo  ! n (cond-bands per node [ncownactual] loop)

    call close_file(iunit_c)

    SAFE_DEALLOCATE(zinc)
    SAFE_DEALLOCATE(ind)
    SAFE_DEALLOCATE(ph)

!     end generation of conduction-band wavefunctions for rk

    if(peinf%inode.eq.0) call timacc(17,2)

  endif ! (irk .ne. irk_old)

  irk_old = irk

  POP_SUB(genwf_disk)

  return
end subroutine genwf_disk

end module genwf_disk_m

!=============================================================================
! Utilities:
! 
! fix_occ         Originally By FHJ      Last Modified 06/04/2014 (FHJ)
!
! Fix the occupations of a WFN file. This is useful if you have split a
! large nscf calculations into smaller blocks, and you want the occupations
! of the merged WFN to be consistent. It can also fix inconsistencies in the
! occupations and in the FE for metals.
!
! Additionally, the script can also manually add an extra charge to the WFN
! file (useful for internal testings).
!
! Note: this file is not compiled by default, you should type: make fix_occ.x
!
!=============================================================================

#include "f_defs.h"

program fix_occ

  use global_m
  use wfn_rho_vxc_io_m
  use sort_m

  implicit none

  character :: ierror_C
  integer :: iflavor

  type(kpoints) :: kp
  type(gspace) :: gvec
  type(symmetry) :: syms
  type(crystal) :: crys

  real(DP) :: n_el, charge
  integer :: n_occ, n_sort
  real(DP) :: n_el2
  integer, allocatable :: sort(:)
  real(DP), pointer :: en_ord(:), weight_orig(:,:,:), weight_ord(:)
  real(DP) :: E_F, E_M
  integer :: is,ik,ib
  integer :: ii, ii2

  character(len=80) :: outfile, infile
  character(len=30) :: sheader
  integer, parameter :: file_out = 11, file_in = 10

  ! Read fix_occ.inp
  call open_file(15, file='fix_occ.inp', form='formatted', status='old')
  read(15,*) infile
  read(15,*) outfile
  read(15,*) n_el    ! orig number of electrons (leave as -1 to auto detect)
  read(15,*) charge  ! additional number of electrons to put in/remove
  call close_file(15)

  write(6,*) 'Input  -> ' , TRUNC(infile)
  write(6,*) 'Output -> ' , TRUNC(outfile)

  ! Open all the WFN files to be read
  call open_file(file_in,  file=infile,  form='unformatted', status='old')
  call open_file(file_out, file=outfile, form='unformatted', status='unknown')

  ! Read original header
  sheader='WFN'
  iflavor=0
  call read_header_type(file_in, .false., sheader, iflavor, kp, gvec, syms, crys, .true.)

  ! calculate number of electrons, if the user requests
  if (n_el <= TOL_SMALL) then
    n_el = calc_nel(kp)
  endif

  write(6,*) 'Original number of electrons:', n_el
  n_el = n_el + charge
  write(6,*) 'Number of electrons with extra charge:', n_el
  n_occ = IDNINT(n_el*0.5d0 * kp%nspin * kp%nrk)
  write(6,*) 'Target # of occ. states:', n_occ

  n_sort = kp%mnband * kp%nrk * kp%nspin
  SAFE_ALLOCATE(sort, (n_sort))
  SAFE_ALLOCATE(en_ord, (n_sort))
  SAFE_ALLOCATE(weight_orig, (kp%mnband, kp%nrk, kp%nspin))
  SAFE_ALLOCATE(weight_ord, (n_sort))

  ! flattens the energy array and sort by energy
  en_ord = RESHAPE(kp%el, (/n_sort/))
  call sortrx(n_sort, en_ord, sort)
  en_ord = en_ord(sort)

  ! make sure sum(kw)==1
  if (abs(sum(kp%w)-1)>TOL_SMALL) then
    write(0,'(a,f0.12)') 'ERROR: sum of the k-weights = ', sum(kp%w)
    call die('k-weights don`t add up to 1.')
  endif

  do ik=1, kp%nrk
    weight_orig(:, ik, :) = kp%w(ik)
  enddo
  weight_ord(:) = RESHAPE(weight_orig, (/n_sort/))
  weight_ord(:) = weight_ord(sort)*(2.0d0/kp%nspin)

  !Determine Fermi energy by counting electrons
  n_el2 = 0.0d0
  !looping over states
  ii2 = 0
  do ii=1, n_sort
    if (weight_ord(ii) < (n_el-n_el2)) then
      n_el2 = n_el2 + weight_ord(ii)
    else
      ii2 = ii - 1
      exit
    endif
  enddo

  if (ii2==0) ii2 = n_sort

  E_F = en_ord(ii2)
  if (ii2==n_sort) then
    E_M = E_F
    write(0,*) 'WARNING: could not find Fermi Energy! Assuming all states are occupied.'
  else
    E_M = (E_F + en_ord(ii2+1))*0.5d0
  endif

  write(6,*) 'Fermi Energy  (eV):', E_F*ryd
  write(6,*) 'Middle Energy (eV):', E_M*ryd

  kp%ifmin(:,:)=1
  kp%ifmax(:,:)=0
  kp%occ(:,:,:)=0.0d0

  write(6,*) 'Resetting occupations' 
  !TODO: deal with case where Fermi level spans a degenerate subspace
  do is=1,kp%nspin
    do ik=1,kp%nrk
      do ib=1,kp%mnband
        if (kp%el(ib,ik,is)<E_M) then
          kp%ifmax(ik,is) = kp%ifmax(ik,is) + 1
          kp%occ(ib,ik,is) = 1.0d0
        endif
      enddo
    enddo
  enddo

  n_el = calc_nel(kp)

  write(6,*) 'Final number of electrons:', n_el

  write(6,*) 'Saving new header' 
  call write_header_type(file_out, .false., sheader, iflavor, kp, gvec, syms, crys, .true.)

  call close_file(file_in)
  call close_file(file_out)

  write(6,*) 'Copying rest of the file'
  ! this is an external C subroutine
  call copy_tail(ierror_C)

  write(6,*) 'Done' 

contains

  ! We can`t use calc_qtot here, b/c that subroutine assumes that there is a 
  ! partial occupation in some cases, which would not be true here.
  ! However, we can simply sum the occupations from the WFN (assuming it`s correct)
  real(DP) function calc_nel (kp_)
    type(kpoints), intent(in) :: kp_
    integer :: ik_

    calc_nel = 0
    do ik_ = 1, kp_%nrk
      calc_nel = calc_nel + kp_%w(ik_) * sum(kp_%occ(:,ik_,:))
    enddo
    ! note: occ is normalized to 1
    calc_nel = calc_nel * 2.0d0 / dble(kp_%nspin)
    return
  end function calc_nel

end program fix_occ

#include "f_defs.h"

!*************************************************************************
Module AtomPotentialMod

  use push_pop_m
!*************************************************************************
! Function atomPotential(q2,elementLabel) is contained here. It is
! the only part of the plane wave program that needs to be changed
! for different potentials.
!*************************************************************************

  contains

!*************************************************************************
  Function atomPotential(q2,elementLabel)
!*************************************************************************

!   pseudopotentials for Si, Ga, and As taken from
!   Zhang, Yeh, and Zunger, Phys. Rev. B 48, 11204 (1993)

    use SysParams,      only : two, zero, double

    implicit none

    character*2, intent(in)  :: elementLabel  ! atomic species
    real(double), intent(in) :: q2            ! squared reciprocal q-value
    real(double)             :: atomPotential ! pseudopotential V(q)
    real(double)             :: rs
 
    ! no push_sub, called too frequently

    select case (elementLabel)

    case("H")    
      rs = 1.d0
      atomPotential = - (3.d0/rs**3)/(q2 + 2.43/rs)

    case("Si")
      atomPotential = 0.53706*(q2-2.19104)/(2.05716*exp(0.48716*q2)-1)/two

    case("Ga")
      atomPotential = 1.22*(q2-2.45)/(exp(0.54*(q2+2.71))+1)/two

    case("As")
      atomPotential = 0.35*(q2-2.62)/(exp(0.93*(q2-1.57))+1)/two

    case("El")
      atomPotential = zero ! free-electron case

    case default
      stop 'Error: pseudopotential not coded for this element.'

    end select

  end Function atomPotential

end Module AtomPotentialMod

!============================================================================
!
! (1) read_eps_grid_sizes_hdf5
!
!============================================================================

#include "f_defs.h"

module epsread_hdf5_m
#ifdef HDF5

  use global_m
  use hdf5
  implicit none

  private

  public :: &
    read_eps_grid_sizes_hdf5, &
    read_eps_matrix_diagonal_hdf5, &
    read_eps_qgrid_hdf5, &
    read_eps_freqgrid_hdf5, &
    read_eps_old_gvecs_hdf5, &
    read_eps_gvecsofq_hdf5, &
    read_eps_matrix_col_f_hdf5, &
    read_eps_matrix_col_hdf5, &
    read_eps_matrix_ser_hdf5, &
    read_eps_matrix_par_hdf5, &
    read_eps_matrix_par_f_hdf5

contains

subroutine read_eps_grid_sizes_hdf5(nold,nq,gmax_in,nFreq,nmtxmax,qgrid,name)
  integer, intent(out) :: nold
  integer, intent(out) :: nq
  real(DP), intent(out) :: gmax_in
  integer, intent(out) :: nFreq
  integer, intent(out) :: nmtxmax
  integer, intent(out) :: qgrid(3)
  character(len=*), intent(in) :: name

  integer(HID_T) :: file_id       ! File identifier
  integer(HID_T) :: info_id       ! Property list identifier
  integer(HID_T) :: infospace     ! Property list identifier
  integer :: error,complexflag
  integer :: imetadata(9)
  real(DP) :: dmetadata(1)
  integer(HSIZE_T) :: imetacount(1), dmetacount(1)

  PUSH_SUB(read_eps_grid_sizes_hdf5)

  call h5fopen_f(trim(name), H5F_ACC_RDONLY_F, file_id, error)
  call h5dopen_f(file_id, 'intinfo', info_id, error)
  call h5dget_space_f(info_id,infospace,error)

  imetacount(1) = 9

  call h5dread_f(info_id, H5T_NATIVE_INTEGER, imetadata, imetacount, error)

  complexflag = imetadata(1)
  nq = imetadata(2)
  nFreq = imetadata(4)
  nold = imetadata(5)
  nmtxmax = imetadata(6)
  qgrid(1) = imetadata(7)
  qgrid(2) = imetadata(8)
  qgrid(3) = imetadata(9)

#ifdef CPLX
  if (complexflag .eq. 0) call die("Using real epsilon in complex code")
#else
  if (complexflag .eq. 1) call die("Using complex epsilon in real code")
#endif

  call h5sclose_f(infospace,error)
  call h5dclose_f(info_id,error)

  call h5dopen_f(file_id, 'dblinfo', info_id, error)
  call h5dget_space_f(info_id,infospace,error)

  dmetacount(1) = 1

  call h5dread_f(info_id, H5T_NATIVE_DOUBLE, dmetadata, dmetacount, error)

  gmax_in = dmetadata(1)

  call h5sclose_f(infospace,error)
  call h5dclose_f(info_id,error)
  call h5fclose_f(file_id,error)

  POP_SUB(read_eps_grid_sizes_hdf5)

end subroutine read_eps_grid_sizes_hdf5

!====================================================================================

subroutine read_eps_matrix_diagonal_hdf5(nmtx, isize, iq, epsdiag, name)
  integer, intent(in) :: nmtx
  integer, intent(in) :: isize
  integer, intent(in) :: iq
  real(DP), intent(out) :: epsdiag(:,:,:) !< (isize,nmtx,1)
  character(len=*), intent(in) :: name

  integer(HID_T) :: file_id       ! File identifier
  integer(HID_T) :: data_id       ! Property list identifier
  integer(HID_T) :: dataspace        ! Property list identifier
  integer(HID_T) :: memspace        ! Property list identifier
  integer :: error, rank
  integer(HSIZE_T) :: ranks(3), offset(3)

  PUSH_SUB(read_eps_matrix_diagonal_hdf5)

  call h5fopen_f(trim(name), H5F_ACC_RDONLY_F, file_id, error)
  call h5dopen_f(file_id, 'matrix-diagonal', data_id, error)
  call h5dget_space_f(data_id,dataspace,error)

  rank = 3
  ranks(1) = isize
  ranks(2) = nmtx
  ranks(3) = 1

  call h5screate_simple_f(rank, ranks, memspace, error)

  offset(1)=0
  offset(2)=0
  offset(3)=iq-1

! Select hyperslab

  call h5sselect_hyperslab_f(dataspace, H5S_SELECT_SET_F, offset, ranks, error)

  call h5dread_f(data_id, H5T_NATIVE_DOUBLE, epsdiag, ranks, error, memspace, dataspace)

  call h5sclose_f(dataspace,error)
  call h5dclose_f(data_id,error)
  call h5fclose_f(file_id,error)

  POP_SUB(read_eps_matrix_diagonal_hdf5)

end subroutine read_eps_matrix_diagonal_hdf5

!====================================================================================

subroutine read_eps_qgrid_hdf5(nq,q,nmtx_of_q,name)
  integer, intent(in) :: nq
  real(DP), intent(inout) :: q(:,:) !< (3,nq)
  integer, intent(out) :: nmtx_of_q(:) !< (nq)
  character(len=*), intent(in) :: name

  integer(HID_T) :: file_id       ! File identifier
  integer(HID_T) :: data_id       ! Property list identifier
  integer(HID_T) :: dataspace        ! Property list identifier
  integer :: error
  integer(HSIZE_T) :: ranks(2), nmranks(1)

  PUSH_SUB(read_eps_qgrid_hdf5)

  call h5fopen_f(trim(name), H5F_ACC_RDONLY_F, file_id, error)
  call h5dopen_f(file_id, 'qpoints', data_id, error)
  call h5dget_space_f(data_id,dataspace,error)

  ranks(1) = 3
  ranks(2) = nq

  call h5dread_f(data_id, H5T_NATIVE_DOUBLE, q, ranks, error)

  call h5sclose_f(dataspace,error)
  call h5dclose_f(data_id,error)

  call h5dopen_f(file_id, 'nmtx-of-q', data_id, error)
  call h5dget_space_f(data_id,dataspace,error)

  nmranks(1) = nq

  call h5dread_f(data_id, H5T_NATIVE_INTEGER, nmtx_of_q, nmranks, error)

  call h5sclose_f(dataspace,error)
  call h5dclose_f(data_id,error)
  call h5fclose_f(file_id,error)

  POP_SUB(read_eps_qgrid_hdf5)

end subroutine read_eps_qgrid_hdf5

!===================================================================================

subroutine read_eps_freqgrid_hdf5(nFreq,dFreqGrid,dFreqBrd,name)
  integer, intent(in) :: nFreq
  real(DP), intent(out) :: dFreqGrid(:) !< (nFreq)
  complex(DPC), intent(out) :: dFreqBrd(:) !< (nFreq)
  character(len=*), intent(in) :: name

  real(DP), allocatable :: tmp(:,:)

  integer(HID_T) :: file_id       ! File identifier
  integer(HID_T) :: data_id       ! Property list identifier
  integer(HID_T) :: dataspace        ! Property list identifier
  integer :: error
  integer(HSIZE_T) :: ranks(1),branks(2)

  PUSH_SUB(read_eps_freqgrid_hdf5)

  call h5fopen_f(trim(name), H5F_ACC_RDONLY_F, file_id, error)

  call h5dopen_f(file_id, 'freqs', data_id, error)
  call h5dget_space_f(data_id,dataspace,error)

  ranks(1) = nFreq

  call h5dread_f(data_id, H5T_NATIVE_DOUBLE, dFreqGrid, ranks, error)

  call h5sclose_f(dataspace,error)
  call h5dclose_f(data_id,error)

  call h5dopen_f(file_id, 'freqbrds', data_id, error)
  call h5dget_space_f(data_id,dataspace,error)

  branks(1) = 2
  branks(2) = nFreq

  SAFE_ALLOCATE(tmp,(2,nFreq))

  call h5dread_f(data_id, H5T_NATIVE_DOUBLE, tmp, branks, error)

  dFreqBrd(:) = CMPLX(tmp(1,:),tmp(2,:))

  call h5sclose_f(dataspace,error)
  call h5dclose_f(data_id,error)
  call h5fclose_f(file_id,error)

  SAFE_DEALLOCATE(tmp)

  POP_SUB(read_eps_freqgrid_hdf5)

end subroutine read_eps_freqgrid_hdf5

!=================================================================================

subroutine read_eps_old_gvecs_hdf5(nold,old,name)
  integer, intent(in) :: nold
  integer, intent(out) :: old(:,:) !< (3,nold)
  character(len=*), intent(in) :: name

  integer(HID_T) :: file_id       ! File identifier
  integer(HID_T) :: data_id       ! Property list identifier
  integer(HID_T) :: dataspace        ! Property list identifier
  integer :: error
  integer(HSIZE_T) :: ranks(2)

  PUSH_SUB(read_eps_old_gvecs_hdf5)

  call h5fopen_f(trim(name), H5F_ACC_RDONLY_F, file_id, error)

  call h5dopen_f(file_id, 'gvecs', data_id, error)
  call h5dget_space_f(data_id,dataspace,error)

  ranks(1) = 3
  ranks(2) = nold

  call h5dread_f(data_id, H5T_NATIVE_INTEGER, old, ranks, error)

  call h5sclose_f(dataspace,error)
  call h5dclose_f(data_id,error)
  call h5fclose_f(file_id,error)

  POP_SUB(read_eps_old_gvecs_hdf5)

end subroutine read_eps_old_gvecs_hdf5

!====================================================================================

subroutine read_eps_gvecsofq_hdf5(ngq,isrtold,isrtold_inv,ekold,iq,name)
  integer, intent(in) :: ngq
  integer, intent(out) :: isrtold(:) !< (ngq)
  integer, intent(out) :: isrtold_inv(:) !< (ngq)
  real(DP), intent(out) :: ekold(:) !< (ngq)
  integer, intent(in) :: iq
  character(len=*), intent(in) :: name

  integer(HID_T) :: file_id       ! File identifier
  integer(HID_T) :: data_id       ! Property list identifier
  integer(HID_T) :: dataspace        ! Property list identifier
  integer(HID_T) :: memspace        ! Property list identifier
  integer :: idata(ngq,2,1)
  real(DP) :: data(ngq,1)
  integer :: error
  integer :: rank
  integer(HSIZE_T) :: count(2), offset(2)
  integer(HSIZE_T) :: icount(3), ioffset(3)

  PUSH_SUB(read_eps_gvecsofq_hdf5)

  call h5fopen_f(trim(name), H5F_ACC_RDONLY_F, file_id, error)

! READ ISRTOLD

  call h5dopen_f(file_id, 'q-gvec-index', data_id, error)
  call h5dget_space_f(data_id,dataspace,error)

  rank = 3
  icount(1) = ngq
  icount(2) = 2
  icount(3) = 1

  call h5screate_simple_f(rank, icount, memspace, error)

! Construct data and offset

  ioffset(1)=0
  ioffset(2)=0
  ioffset(3)=iq-1

! Select hyperslab

  call h5sselect_hyperslab_f(dataspace, H5S_SELECT_SET_F, ioffset, icount, error)

! Collectively read the file
! Serial for now

  call h5dread_f(data_id, H5T_NATIVE_INTEGER, idata, icount, error, memspace, dataspace)
  isrtold(:) = idata(:,1,1)
  isrtold_inv(:) = idata(:,2,1)

  call h5sclose_f(memspace, error)
  call h5sclose_f(dataspace, error)
  call h5dclose_f(data_id,error)

! READ EKOLD

  call h5dopen_f(file_id, 'q-gvec-ekin', data_id, error)
  call h5dget_space_f(data_id,dataspace,error)

  rank = 2
  count(1) = ngq
  count(2) = 1

  call h5screate_simple_f(rank, count, memspace, error)

! Construct data and offset

  offset(1)=0
  offset(2)=iq-1

! Select hyperslab

  call h5sselect_hyperslab_f(dataspace, H5S_SELECT_SET_F, offset, count, error)

! Collectively read the file
! Serial for now

  call h5dread_f(data_id, H5T_NATIVE_DOUBLE, data, count, error, memspace, dataspace)
  ekold(:) = data(:,1)

  call h5sclose_f(memspace, error)
  call h5sclose_f(dataspace, error)
  call h5dclose_f(data_id,error)
  
  call h5fclose_f(file_id,error)

  POP_SUB(read_eps_gvecsofq_hdf5)

end subroutine read_eps_gvecsofq_hdf5

!===========================================================================================

subroutine read_eps_matrix_col_f_hdf5(epsR,&
#ifdef CPLX 
   epsA,&
#endif
   nFreq,j,nmtx,iq,is,name)
  integer, intent(in) :: iq
  integer, intent(in) :: is
  integer, intent(in) :: nFreq
  integer, intent(in) :: nmtx
  integer, intent(in) :: j
  complex(DPC), intent(out) :: epsR(:,:) !< (nFreq,nmtx)
#ifdef CPLX
  complex(DPC), intent(out) :: epsA(:,:) !< (nFreq,nmtx)
#endif
  character(len=*), intent(in) :: name

  integer(HID_T) :: file_id       ! File identifier
  integer(HID_T) :: data_id       ! Property list identifier
  integer(HID_T) :: dataspace        ! Property list identifier
  integer(HID_T) :: memspace        ! Property list identifier
  integer :: error, rank
  integer(HSIZE_T) :: count(6), offset(6)

  real(DP), allocatable :: data(:,:,:,:,:,:)

  PUSH_SUB(read_eps_matrix_col_f_hdf5)

  call h5fopen_f(trim(name), H5F_ACC_RDONLY_F, file_id, error)

  call h5dopen_f(file_id, 'matrix', data_id, error)
  call h5dget_space_f(data_id,dataspace,error)

  rank = 6
  count(1) = 2
  count(2) = nFreq
  count(3) = nmtx
  count(4) = 1
  count(5) = SCALARSIZE
  count(6) = 1 !iq

  call h5screate_simple_f(rank, count, memspace, error)

  offset(:) = 0
  offset(4) = j - 1
  offset(5) = SCALARSIZE*(is-1)
  offset(6) = iq - 1

  call h5sselect_hyperslab_f(dataspace, H5S_SELECT_SET_F, offset, count, error)

! XXX - this is bad because we double memory usage. Oh well.
  SAFE_ALLOCATE(data,(count(1),count(2),count(3),count(4),count(5),count(6)))
  call h5dread_f(data_id, H5T_NATIVE_DOUBLE, data, count, error, memspace, dataspace)
  epsR(1:nFreq,1:nmtx) = CMPLX(data(1,1:nFreq,1:nmtx,1,1,1),data(2,1:nFreq,1:nmtx,1,1,1))
#ifdef CPLX
  epsA(1:nFreq,1:nmtx) = CMPLX(data(1,1:nFreq,1:nmtx,1,2,1),data(2,1:nFreq,1:nmtx,1,2,1))
#endif
  SAFE_DEALLOCATE(data)

  call h5sclose_f(memspace, error)
  call h5sclose_f(dataspace, error)
  call h5dclose_f(data_id,error)  
  call h5fclose_f(file_id,error)

  POP_SUB(read_eps_matrix_col_f_hdf5)

end subroutine read_eps_matrix_col_f_hdf5

!===========================================================================================

subroutine read_eps_matrix_col_hdf5(eps,j,nmtx,iq,is,name)
  integer, intent(in) :: iq
  integer, intent(in) :: is
  integer, intent(in) :: nmtx
  integer, intent(in) :: j
  SCALAR, intent(out) :: eps(:) !< (nmtx)
  character(len=*), intent(in) :: name

  integer(HID_T) :: file_id       ! File identifier
  integer(HID_T) :: data_id       ! Property list identifier
  integer(HID_T) :: dataspace        ! Property list identifier
  integer(HID_T) :: memspace        ! Property list identifier
  integer :: error, rank
  integer(HSIZE_T) :: count(6), offset(6)

  real(DP), allocatable :: data(:,:,:,:,:,:)

  PUSH_SUB(read_eps_matrix_col_hdf5)

  call h5fopen_f(trim(name), H5F_ACC_RDONLY_F, file_id, error)

  call h5dopen_f(file_id, 'matrix', data_id, error)
  call h5dget_space_f(data_id,dataspace,error)

  rank = 6
#ifdef CPLX
  count(1) = 2
#else
  count(1) = 1
#endif
  count(2) = 1
  count(3) = nmtx
  count(4) = 1
  count(5) = 1 !mat
  count(6) = 1 !iq

  call h5screate_simple_f(rank, count, memspace, error)

  offset(:) = 0
  offset(4) = j - 1
  offset(5) = is - 1
  offset(6) = iq - 1

  call h5sselect_hyperslab_f(dataspace, H5S_SELECT_SET_F, offset, count, error)

! XXX - this is bad because we double memory usage. Oh well.
  SAFE_ALLOCATE(data,(count(1),count(2),count(3),count(4),count(5),count(6)))
  call h5dread_f(data_id, H5T_NATIVE_DOUBLE, data, count, error, memspace, dataspace)
!  write(6,*) 'About to die?', nmtx, data(1,1,:,1,1,1)
  eps(1:nmtx) = SCALARIFY2(data(1,1,1:nmtx,1,1,1),data(2,1,1:nmtx,1,1,1))
  SAFE_DEALLOCATE(data)

  call h5sclose_f(memspace, error)
  call h5sclose_f(dataspace, error)
  call h5dclose_f(data_id,error)  
  call h5fclose_f(file_id,error)

  POP_SUB(read_eps_matrix_col_hdf5)

end subroutine read_eps_matrix_col_hdf5

!===========================================================================================

subroutine read_eps_matrix_ser_hdf5(eps,nmtx,iq,is,name)
  integer, intent(in) :: iq
  integer, intent(in) :: is
  integer, intent(in) :: nmtx
  SCALAR, intent(out) :: eps(:,:) !< (nmtx,nmtx)
  character(len=*), intent(in) :: name

  integer(HID_T) :: file_id       ! File identifier
  integer(HID_T) :: data_id       ! Property list identifier
  integer(HID_T) :: dataspace        ! Property list identifier
  integer(HID_T) :: memspace        ! Property list identifier
  integer :: error, rank
  integer(HSIZE_T) :: count(6), offset(6)

  real(DP), allocatable :: data(:,:,:,:,:,:)

  PUSH_SUB(read_eps_matrix_ser_hdf5)

  call h5fopen_f(trim(name), H5F_ACC_RDONLY_F, file_id, error)

  call h5dopen_f(file_id, 'matrix', data_id, error)
  call h5dget_space_f(data_id,dataspace,error)

  rank = 6
#ifdef CPLX
  count(1) = 2
#else
  count(1) = 1
#endif
  count(2) = 1
  count(3) = nmtx
  count(4) = nmtx
  count(5) = 1 !mat
  count(6) = 1 !iq

  call h5screate_simple_f(rank, count, memspace, error)

  offset(:) = 0
  offset(5) = is - 1
  offset(6) = iq - 1

  call h5sselect_hyperslab_f(dataspace, H5S_SELECT_SET_F, offset, count, error)

! XXX - this is bad because we double memory usage. Oh well.
  SAFE_ALLOCATE(data,(count(1),count(2),count(3),count(4),count(5),count(6)))
  call h5dread_f(data_id, H5T_NATIVE_DOUBLE, data, count, error, memspace, dataspace)
  eps(1:nmtx,1:nmtx) = SCALARIFY2(data(1,1,1:nmtx,1:nmtx,1,1),data(2,1,1:nmtx,1:nmtx,1,1))
  SAFE_DEALLOCATE(data)

  call h5sclose_f(memspace, error)
  call h5sclose_f(dataspace, error)
  call h5dclose_f(data_id,error)  
  call h5fclose_f(file_id,error)

  POP_SUB(read_eps_matrix_ser_hdf5)

end subroutine read_eps_matrix_ser_hdf5

!===========================================================================================

subroutine read_eps_matrix_par_hdf5(eps,ngpown,&
   ngpown_max,inv_igp_index,nmtx,iq,is,name)
  SCALAR, intent(inout) :: eps(:,:) !< (neps,ngpown)
  integer, intent(in) :: ngpown
  integer, intent(in) :: ngpown_max
  integer, intent(in) :: inv_igp_index(:) !< (ngpown_max)
  integer, intent(in) :: nmtx
  integer, intent(in) :: iq
  integer, intent(in) :: is
  character(len=*), intent(in) :: name

  integer(HID_T) :: file_id       ! File identifier
  integer(HID_T) :: data_id       ! Property list identifier
  integer(HID_T) :: plist_id       ! Property list identifier
  integer(HID_T) :: dataspace        ! Property list identifier
  integer(HID_T) :: memspace        ! Property list identifier
  integer :: error
  integer :: rank, comm, info
  integer(HSIZE_T) :: count(6), offset(6), countm(6)

  real(DP), allocatable :: data(:,:,:,:,:,:)

  integer ijk, my_igp

  PUSH_SUB(read_eps_matrix_par_hdf5)

  !write(6,*) "In par read", ngpown, ngpown_max, nmtx, ubound(eps, 1), iq

  !if (ngpown .ne. 0) then
#ifdef CPLX
    SAFE_ALLOCATE(data,(2,1,nmtx,1,1,1))
    !SAFE_ALLOCATE(data,(2,1,nmtx,ngpown,1,1))
#else
    SAFE_ALLOCATE(data,(1,1,nmtx,1,1,1))
    !SAFE_ALLOCATE(data,(1,1,nmtx,ngpown,1,1))
#endif
  !else
  !  SAFE_ALLOCATE(data,(1,1,1,1,1,1))
  !endif

#ifdef MPI
  comm = MPI_COMM_WORLD
  info = MPI_INFO_NULL

  call h5pcreate_f(H5P_FILE_ACCESS_F, plist_id, error)
  call h5pset_fapl_mpio_f(plist_id, comm, info, error)
  call h5fopen_f(trim(name), H5F_ACC_RDONLY_F, file_id, error, access_prp = plist_id)
  call h5pclose_f(plist_id,error)
#else
  call h5fopen_f(trim(name), H5F_ACC_RDONLY_F, file_id, error)
#endif


  do ijk = 1, ngpown_max

    my_igp = 0
    !if (ngpown .ne. 0) my_igp = inv_igp_index(1)
    if (ngpown .ne. 0) my_igp = inv_igp_index(ijk)

    call h5dopen_f(file_id, 'matrix', data_id, error)
    call h5dget_space_f(data_id,dataspace,error)

    rank = 6

! JRD: The commented code in this routine represents efforts to use a single HDF5 read call
! with an appropriate block and stride for each proc. In general, it currently appears to 
! perform worse (though this may be related to size of matrix. So, it is commented until
! further investigation.

    countm(1) = SCALARSIZE
    countm(2) = 1
    countm(3) = nmtx
    countm(4) = 1
    !countm(4) = ngpown
    countm(5) = 1
    countm(6) = 1

    call h5screate_simple_f(rank, countm, memspace, error)

    count(1) = SCALARSIZE
    !count(1) = 1
    count(2) = 1
    count(3) = nmtx
    !count(3) = 1
    count(4) = 1
    !count(4) = ngpown
    count(5) = 1
    count(6) = 1

! Construct data and offset

    if (ijk .le. ngpown .and. my_igp .le. nmtx) then
    !if (ngpown .ne. 0 .and. my_igp .le. nmtx) then

      offset(1)=0
      offset(2)=0
      offset(3)=0
      offset(4)=my_igp-1
      offset(5)=is-1
      offset(6)=iq-1

!      stride(1)=1
!      stride(2)=1
!      stride(3)=1
!      stride(4)=nprocs
!      stride(5)=1
!      stride(6)=1

!      block(1)=SCALARSIZE
!      block(2)=1
!      block(3)=nmtx
!      block(4)=1
!      block(5)=1
!      block(6)=1

! Select hyperslab

      call h5sselect_hyperslab_f(dataspace, H5S_SELECT_SET_F, offset, count, error)
!      call h5sselect_hyperslab_f(dataspace, H5S_SELECT_SET_F, offset, count, error, stride, block)

    else

      call H5sselect_none_f(memspace,error);
      call H5sselect_none_f(dataspace,error);

    endif

! Create property list for collective dataset read

#ifdef MPI
    call h5pcreate_f(H5P_DATASET_XFER_F, plist_id, error)
    call h5pset_dxpl_mpio_f(plist_id, H5FD_MPIO_COLLECTIVE_F, error)

! Collectively read the file

    call h5dread_f(data_id, H5T_NATIVE_DOUBLE, data, countm, error, memspace, dataspace, &
                      xfer_prp = plist_id)
# else
    call h5dread_f(data_id, H5T_NATIVE_DOUBLE, data, countm, error, memspace, dataspace)
#endif

    if (ijk .le. ngpown .and. my_igp .le. nmtx) then
!    if (ngpown .ne. 0 .and. my_igp .le. nmtx) then
!XXX PROBABLY NEED THREADED LOOP HERE
      eps(1:nmtx,ijk) = SCALARIFY2(data(1,1,1:nmtx,1,1,1),data(2,1,1:nmtx,1,1,1))
!      eps(1:nmtx,1:ngpown) = SCALARIFY2(data(1,1,1:nmtx,1:ngpown,1,1),data(2,1,1:nmtx,1:ngpown,1,1))
    endif

    call h5sclose_f(memspace, error)
    call h5sclose_f(dataspace, error)
    call h5dclose_f(data_id, error)

  enddo

  call h5fclose_f(file_id,error)

  SAFE_DEALLOCATE(data)

  POP_SUB(read_eps_matrix_par_hdf5)

end subroutine read_eps_matrix_par_hdf5

!==========================================================================================

subroutine read_eps_matrix_par_f_hdf5(epsR, &
#ifdef CPLX
  epsA, &
#endif
  ngpown,ngpown_max,inv_igp_index,nmtx,nFreq,iq,is,name)
  complex(DPC), intent(inout) :: epsR(:,:,:) !< (nFreq,neps,ngpown)
#ifdef CPLX
  complex(DPC), intent(inout) :: epsA(:,:,:) !< (nFreq,neps,ngpown)
#endif
  integer, intent(in) :: ngpown
  integer, intent(in) :: ngpown_max
  integer, intent(in) :: inv_igp_index(:) !< (ngpown_max)
  integer, intent(in) :: nmtx
  integer, intent(in) :: nFreq
  integer, intent(in) :: iq
  integer, intent(in) :: is
  character(len=*), intent(in) :: name

  integer(HID_T) :: file_id       ! File identifier
  integer(HID_T) :: data_id       ! Property list identifier
  integer(HID_T) :: plist_id       ! Property list identifier
  integer(HID_T) :: dataspace        ! Property list identifier
  integer(HID_T) :: memspace        ! Property list identifier
  integer :: error
  integer :: rank,comm,info
  integer(HSIZE_T) :: count(6), offset(6)

  real(DP), allocatable :: data(:,:,:,:,:,:)

  integer ijk, my_igp

  PUSH_SUB(read_eps_matrix_par_f_hdf5)

#ifdef CPLX
  SAFE_ALLOCATE(data,(2,nFreq,nmtx,1,2,1))
#else
  SAFE_ALLOCATE(data,(2,nFreq,nmtx,1,1,1))
#endif

#ifdef MPI
  comm = MPI_COMM_WORLD
  info = MPI_INFO_NULL

  call h5pcreate_f(H5P_FILE_ACCESS_F, plist_id, error)
  call h5pset_fapl_mpio_f(plist_id, comm, info, error)
  call h5fopen_f(trim(name), H5F_ACC_RDONLY_F, file_id, error, access_prp = plist_id)
  call h5pclose_f(plist_id,error)
#else
  call h5fopen_f(trim(name), H5F_ACC_RDONLY_F, file_id, error)
#endif

  do ijk = 1, ngpown_max

    if (ijk .le. ngpown) my_igp = inv_igp_index(ijk)

    call h5dopen_f(file_id, 'matrix', data_id, error)
    call h5dget_space_f(data_id,dataspace,error)

    rank = 6
    count(1) = 2
    count(2) = nFreq
    count(3) = nmtx
    count(4) = 1
    count(5) = SCALARSIZE
    count(6) = 1 !iq

    call h5screate_simple_f(rank, count, memspace, error)

! Construct data and offset

    if (ijk .le. ngpown .and. my_igp .le. nmtx) then

      offset(1)=0
      offset(2)=0
      offset(3)=0
      offset(4)=my_igp-1
      offset(5)=SCALARSIZE*(is-1)
      offset(6)=iq-1

! Select hyperslab

      call h5sselect_hyperslab_f(dataspace, H5S_SELECT_SET_F, offset, count, error)

    else

      call H5sselect_none_f(memspace,error);
      call H5sselect_none_f(dataspace,error);

    endif

! Create property list for collective dataset read
! Read is serial for now

#ifdef MPI
    call h5pcreate_f(H5P_DATASET_XFER_F, plist_id, error)
    call h5pset_dxpl_mpio_f(plist_id, H5FD_MPIO_COLLECTIVE_F, error)

! Collectively read the file

    call h5dread_f(data_id, H5T_NATIVE_DOUBLE, data, count, error, memspace, dataspace, &
                      xfer_prp = plist_id)
#else
    call h5dread_f(data_id, H5T_NATIVE_DOUBLE, data, count, error, memspace, dataspace)
#endif

    if (ijk .le. ngpown .and. my_igp .le. nmtx) then
      epsR(1:nFreq,1:nmtx,ijk) = CMPLX(data(1,1:nFreq,1:nmtx,1,1,1),data(2,1:nFreq,1:nmtx,1,1,1))
#ifdef CPLX
      epsA(1:nFreq,1:nmtx,ijk) = CMPLX(data(1,1:nFreq,1:nmtx,1,2,1),data(2,1:nFreq,1:nmtx,1,2,1))
#endif
    endif

    call h5sclose_f(memspace, error)
    call h5sclose_f(dataspace, error)
    call h5dclose_f(data_id, error)

  enddo

  call h5fclose_f(file_id,error)

  SAFE_DEALLOCATE(data)

  POP_SUB(read_eps_matrix_par_f_hdf5)

end subroutine read_eps_matrix_par_f_hdf5

!==========================================================================================

#endif
end module epsread_hdf5_m

!===========================================================================
!
! Routines()
!
! (1) shiftenergy_dyn() Originally by ?         Last Edited: 5/12/2008 (JRD)
!
!     Computes and symmetrizes the quasiparticle spectrum
!
!===========================================================================

#include "f_defs.h"

subroutine shiftenergy_dyn(sig,wfnk,alda,asx,ach,ach_cor,ach_corb,ach2,achcor,ax, &
  efsto,asig,ikn,kp)

  use global_m
  implicit none

  type (siginfo), intent(in) :: sig
  type (wfnkstates), intent(in) :: wfnk
  SCALAR, intent(inout) :: alda(sig%ndiag+sig%noffdiag,sig%nspin)
  complex(DPC), intent(inout) :: &
    asx(sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin), &
    ach(sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin), &
    ach_cor(sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin), &
    ach_corb(sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin), &
    ach2(sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin), &
    achcor(sig%ndiag+sig%noffdiag,sig%nspin)
  SCALAR, intent(inout) :: ax(sig%ndiag+sig%noffdiag,sig%nspin)
  complex(DPC), intent(out) :: efsto(sig%ndiag,sig%nspin)
  complex(DPC), intent(inout) :: asig(sig%ndiag+sig%noffdiag,sig%nspin)
  integer, intent(in) :: ikn
  type (kpoints), intent(in) :: kp

  integer :: iwlda,iw
  integer :: ii,jj,istart,istop,nl,iflag,ispin
  integer, allocatable :: ndeg(:)
  real(DP) :: fact,dek,eval,diff,diffmin,e_lk
  real(DP) :: specsum(sig%nfreqeval)
  SCALAR :: aldai,axi
  complex(DPC) :: asxi(sig%nfreqeval), achi(sig%nfreqeval), asigt(sig%nfreqeval)
  complex(DPC) :: ach_cori(sig%nfreqeval)
  complex(DPC) :: ach_corbi(sig%nfreqeval)
  complex(DPC) :: asigt_cor(sig%nfreqeval)
  complex(DPC) :: asigt_corb(sig%nfreqeval)
  complex(DPC) :: ach2i(sig%nfreqeval), asigt2(sig%nfreqeval), achcori
  
! JRD: CHANGE THIS ROUTINE A----LOT!!! :) 

  PUSH_SUB(shiftenergy_dyn)

  SAFE_ALLOCATE(ndeg, (sig%ntband))
  
  do ispin=1,sig%nspin
    
    nl=1
    ndeg(nl)=1
    do ii=2,sig%ndiag
      iflag=0
      dek = wfnk%elda(sig%diag(ii),ispin) - wfnk%elda(sig%diag(ii-1),ispin)
      if(abs(dek) .lt. sig%tol) iflag=1
      if (iflag.eq.0) nl=nl+1
      if (iflag.eq.0) ndeg(nl)=1
      if (iflag.eq.1) ndeg(nl)=ndeg(nl)+1
    enddo
    
    specsum = 0D0
    
    istop = 0
    do ii=1,nl
      istart = istop + 1
      istop = istart + ndeg(ii) - 1
      aldai =0.0d0
      axi =0.0d0
      asxi(:) = 0.0d0
      achi(:) = 0.0d0
      ach_cori(:) = 0.0d0
      ach_corbi(:) = 0.0d0
      ach2i(:) = 0.0d0
      achcori = 0.0d0
      do jj=istart,istop
        aldai = aldai + alda(jj,ispin)
        axi = axi + ax(jj,ispin)
        asxi(:) = asxi(:) + asx(:,jj,ispin)
        achi(:) = achi(:) + ach(:,jj,ispin)
        ach_cori(:) = ach_cori(:) + ach_cor(:,jj,ispin)
        ach_corbi(:) = ach_corbi(:) + ach_corb(:,jj,ispin)
        ach2i(:) = ach2i(:) + ach2(:,jj,ispin)
        achcori = achcori + achcor(jj,ispin)
      enddo
      
      fact = ryd / dble(ndeg(ii))
      do jj=istart,istop
        alda(jj,ispin) = aldai * fact
        ax(jj,ispin) = axi * fact
        asx(:,jj,ispin) = asxi(:) * fact
        ach(:,jj,ispin) = achi(:) * fact
        ach_cor(:,jj,ispin) = ach_cori(:) * fact
        ach_corb(:,jj,ispin) = ach_corbi(:) * fact
        ach2(:,jj,ispin) = ach2i(:) * fact
        achcor(jj,ispin) = achcori * fact
        asigt(:) = ax(jj,ispin) + asx(:,jj,ispin) + ach(:,jj,ispin) + achcor(jj,ispin)
        asigt_cor(:) = ax(jj,ispin) + ach_cor(:,jj,ispin) + achcor(jj,ispin)
        asigt_corb(:) = ax(jj,ispin) + ach_corb(:,jj,ispin) + achcor(jj,ispin)
        asigt2(:) = ax(jj,ispin) + asx(:,jj,ispin) + ach2(:,jj,ispin) + achcor(jj,ispin)

! JRD: Find iw closest to e_lk
        
        diffmin = INF
        e_lk = wfnk%ek(sig%diag(jj),ispin)
        do iw=1,sig%nfreqeval
          diff = abs(sig%freqevalmin + (iw-1)*sig%freqevalstep - e_lk)
          if (diff .lt. diffmin) then
            diffmin=diff
            iwlda=iw
          endif
        enddo
        
!            write(6,*) 'ShiftEnergy - iwlda', j, e_lk, iwlda 

! gsm: asig shall not contain static remainder, it is added in write_result_dyn/write_result_dyn_hp
!            asig(jj,ispin) = asigt(iwlda) - achcor(jj,ispin)
        asig(jj,ispin) = ax(jj,ispin) + asx(iwlda,jj,ispin) + ach(iwlda,jj,ispin)

! JRD: Write out Sigma(omega)

        if (peinf%inode .eq. 0) then
          write(8000,2001) 
          do iw=1,sig%nfreqeval
            eval = sig%freqevalmin + (iw-1)*sig%freqevalstep
            if (IMAG(asigt(iw)) .gt. TOL_Zero) then
              write(0,'(a,3f12.6)') 'WARNING: You have a positive imaginary Sigma at k = ', kp%rk(:,ikn)
              write(0,'(a,i6,a,f12.6,a,2f12.6)') 'band calc ', jj, ', evaluation energy ', eval, ' : Im Sigma = ', IMAG(asigt(iw))
            endif
!                eval2 = wfnk%elda(sig%diag(jj),ispin) + dble(asigt(iw)) - alda(jj,ispin)
!
! CHP: spectral function is not very meaningful unless one knows the final Fermi energy
!      (i.e., after the GW correction) conserving the Fermi sphere volume. In practice,
!      one has to (1) read the calculated real part of the self energy, (2) find out
!      what is the new Fermi energy (manually), (3) subtract this value from the
!      real part of the self energies, (4) and calculate the spectral function.
!
!      Also, EQP(k,w) is not physical.  EQP is a function only of k which can
!      be obtained by solving EQP(k)=E0(k)+Re(Sig(k,EQP(k))).  This process is
!      straightforward once one knows Re(Sig(k,w)).
!
!      Printed energy is now with respect to the Fermi energy (sig%efermi).
!
!                spectral = (1D0/PI_D) * abs(IMAG(asigt(iw))) / ( (eval - eval2)**2 + IMAG(asigt(iw))**2)
!                specsum(iw) = specsum(iw) + spectral
!                write(8000,2000) kp%rk(:,ikn), ispin, sig%diag(jj), iw, eval, eval2, &
!                 dble(asigt(iw)),IMAG(asigt(iw)),spectral
            write(8000,2000) kp%rk(:,ikn), ispin, sig%diag(jj), iw, eval, &
              dble(asigt(iw)),IMAG(asigt(iw)),dble(asigt2(iw)),IMAG(asigt2(iw)), &
              dble(asigt_corb(iw)),IMAG(asigt_corb(iw)),dble(asigt_cor(iw)),IMAG(asigt_cor(iw))

! CHP: IM(asigt2) was obtained by using a zero energy broadening in the energy
!      denominator for the self energy evaluation.  Thus, IM(asigt2) vanishes
!      at the Fermi level, which is physically correct: the scattering rate of
!      a quasiparticle at the Fermi surface is zero.  However, (1) this routine
!      currently is meaningful only for systems having inversion symmetry
!      and (2) IM(asigt2) does not satisfy the Kramers-Kronig relation with
!      RE(asigt) for obvious reasons.

          enddo
          write(8000,*) ''
        endif
              

! Correcting Eqp [Eq. (37) of Hybertsen & Louie PRB]
! by Murilo (Aug 11, 2000)

        efsto(jj,ispin) = wfnk%elda(sig%diag(jj),ispin) - &
          alda(jj,ispin) + asig(jj,ispin)

!            dele = efsto(jj,ispin) - wfnk%ek(sig%diag(jj),ispin)

      enddo ! jj
    enddo ! ii
  enddo ! ispin

!      if (peinf%inode .eq. 0) then
!        do iw = 1, sig%nfreqeval
!          eval = sig%freqevalmin + (iw-1)*sig%freqevalstep
!          write(8001,2002) kp%rk(:,ikn), eval, specsum(iw)
!        enddo
!          write(8001,*) ''
!      endif

! CHP: not to printout the spectral function

! 2000 format(3F12.5,2x,3i4,2x,7F12.5)
! 2001 format("#",6x,"kx",10x,"ky",10x,"kz",7x,"spn",1x,"bnd",2x,"iw",8x,"Ew",10x,"EQP", &
!      5x,"RE(SIGMA)",3x,"IM(SIGMA)",6x,"SPEC")
! 2002 format(3F12.5,2x,2F12.5)
2000 format(3F12.5,2x,3i4,2x,9F12.5)
 2001 format("#",6x,"kx",10x,"ky",10x,"kz",7x,"spn",1x,"bnd",2x,"iw",8x,"Ew", &
        6x,"RE(SIGMA)",3x,"IM(SIGMA)",2x,"RE(SIGMA2)",2x,"IM(SIGMA2)",2x,"RE(SIGMA3)",2x,"IM(SIGMA3)", &
        2x,"RE(SIGMA4)",2x,"IM(SIGMA4)")

  SAFE_DEALLOCATE(ndeg)

  POP_SUB(shiftenergy_dyn)

  return
end subroutine shiftenergy_dyn

!===============================================================================
!
! Routines:
!
! (1) inread()  Originally By ?         Last Modified 7/8/2008 (JRD)
!
!     Reads parameters from sigma.inp for the current job.
!
!===============================================================================

#include "f_defs.h"

subroutine inread(sig)

  use global_m
  use scissors_m
  use inread_common_m
  implicit none

  type (siginfo), intent(out) :: sig

  character*256 :: blockword,keyword,line, errmsg
  integer :: ii,jj,kk,nkpt_read,nqpt_read,ndiag_read,noff_read
  integer :: nbnmin,nbnmax,itestq,iostat
  
  real(DP) :: kpt_read(3,MAX_KPTS),qpt_read(3,MAX_KPTS),div
  integer :: off1_read(MAX_BANDS),off2_read(MAX_BANDS),off3_read(MAX_BANDS)
  integer :: band_occ(MAX_BANDS),diag(MAX_BANDS),spinmin,spinmax
  logical :: q0vec_read, VXC_exists, found

  PUSH_SUB(inread)

#ifdef MPI
  ! Non-root nodes should wait for root to read the whole file.
  ! That way, we can be sure root gets a chance to write errors before
  ! any die call is issued by another node. Root calls MPI_Barrier below.
  if(peinf%inode /= 0) call MPI_Barrier(MPI_COMM_WORLD, mpierr)
#endif

!----------------------
! Initialize sig%igamma

  sig%igamma = 0

!----------------------
! Initialize wcoul0
  sig%wcoul0 = ZERO


!---------------------------------
! Set default values

  q0vec_read = .false.
  nkpt_read=0
  nqpt_read=0
  noff_read=0
  band_occ=0
  nbnmin=0
  nbnmax=0
  spinmin=1
  spinmax=1
  diag=0
#ifdef HDF5
  sig%use_hdf5 = .true.
#else
  sig%use_hdf5 = .false.
#endif
  sig%loff=0
  sig%toff=0
  sig%freq_dep=1
  sig%nFreq=1
  sig%exact_ch=-1
  sig%freqevalmin=-1.0d3
  sig%freqevalstep=-1.0d0
  sig%nfreqeval=1
  sig%iuseremainder=0
  sig%nkn=0
  sig%nq=0
  sig%nq0=0
  sig%nq1=0
  sig%subsample=.false.
  sig%ndiag=0
  sig%noffdiag=0
  sig%nspin=0
  call scissors_zero(sig%scis)
  call scissors_zero(sig%scis_outer)
  sig%spl_tck%n=0 
  sig%spl_tck_outer%n=0
  sig%avgpot=0.0d0
  sig%avgpot_outer=0.0d0
  sig%tol = TOL_Degeneracy
  sig%ggpsum=2
  sig%use_xdat=.false.
  sig%use_vxcdat=.TRUE.
  sig%use_vxc2dat=.TRUE.
  sig%ecuts=0.d0
  sig%ecutb=0.d0
  sig%ntband=0
  sig%fdf=2
  sig%dw=1.0d0
  sig%xfrac=1.0d0
  sig%gamma=0.5d0
  sig%sexcut=4.0d0
  sig%icutv=0
  sig%iscreen=0
  sig%iwritecoul=0
  sig%truncval(1:3)=0.0d0
  sig%ncrit=0
  sig%efermi_input=0.0d0
  sig%rfermi=.true.
  sig%fullConvLog=0
  sig%qgrid(1:3)=0
  sig%avgcut=TOL_Zero
  sig%iwriteint=1
  sig%freplacebz=.false.
  sig%fwritebz=.false.
  sig%degeneracy_check_override=.false.
  sig%offdiagsym=.true.
  sig%qgridsym=.true.
  sig%die_outside_sphere=.true.
  sig%averagew=.true.
  peinf%npools=0
  sig%eqp_corrections=.false.
  sig%eqp_outer_corrections=.false.
  sig%coulomb_mod%short_range_frac_fock=1.0d0
  sig%coulomb_mod%long_range_frac_fock=1.0d0
  sig%coulomb_mod%screening_length=0.0d0
  sig%coul_mod_flag=.false.

!---------------------------------
! Never-ending loop...

  do while(0.eq.0)

! Actually the loop ends when the end of the file is reached

    read(55,'(a256)',iostat=iostat) line
    if(iostat < 0) exit

! Skip comment lines

    if(len_trim(line).eq.0) cycle
    if(line(1:1).eq.'#') cycle

! Determine keyword

    keyword=line(1:scan(line," ")-1)
    line=adjustl(line(scan(line," ")+1:256))

    if (trim(keyword).eq.'begin') then
      blockword=line(1:scan(line," ")-1)
      ii=0
      do while(trim(line).ne.'end')
        read(55,'(a256)',iostat=iostat) line
        if(iostat /= 0) then
          write(errmsg,'(3a)') 'The end of the file was reached while reading elements of the ', &
            trim(blockword),' block.'
          call die(errmsg, only_root_writes = .true.)
        endif
        
        if(trim(line).ne.'end') then
          ii=ii+1
          if(trim(blockword).eq.'kpoints') then
            call check_bounds_nkq(ii, 'k', 'begin kpoints')
            read(line,*,err=112) (kpt_read(jj,ii),jj=1,3),div
            kpt_read(1:3,ii)=kpt_read(1:3,ii)/div
          elseif(trim(blockword).eq.'qpoints') then
            call check_bounds_nkq(ii, 'q', 'begin qpoints')
            read(line,*,err=112) (qpt_read(jj,ii),jj=1,3),div,itestq
            qpt_read(1:3,ii)=qpt_read(1:3,ii)/div
            ! for Hartree-Fock
            if (itestq.eq.1) then
              sig%nq0 = sig%nq0 + 1
              if (.not.q0vec_read) then
                sig%q0vec(1:3)=qpt_read(1:3,ii)
                q0vec_read = .true.
              endif
            endif
          elseif(trim(blockword).eq.'diag') then
            call check_bounds_nbands(ii, 'begin diag')
            read(line,*,err=112) diag(ii)
          elseif(trim(blockword).eq.'offdiag') then
            call check_bounds_nbands(ii, 'begin offdiag')
            read(line,*,err=112) off1_read(ii),off2_read(ii),off3_read(ii)
          else
            write(errmsg,'(3a)') 'Unexpected blockword ', trim(blockword), ' was found in sigma.inp.'
            call die(errmsg, only_root_writes = .true.)
          end if
        end if
      end do
      if(trim(blockword).eq.'kpoints') then
        nkpt_read=ii
      elseif(trim(blockword).eq.'qpoints') then
        nqpt_read=ii
      elseif(trim(blockword).eq.'diag') then
        ndiag_read=ii
      elseif(trim(blockword).eq.'offdiag') then
        noff_read=ii
      endif

! Spline scissors
    elseif(trim(keyword).eq.'spline_scissors') then
      if (peinf%inode==0) then
        write(6,*) 'Reading spline coefficients from `spline_scissors.dat`'
        write(6,*)
        ! read number of pts, knots, coefficients, degree
        call open_file(20,file='spline_scissors.dat',form='formatted',status='old')
        read(20,*) sig%spl_tck%n
        SAFE_ALLOCATE(sig%spl_tck%t, (sig%spl_tck%n))
        SAFE_ALLOCATE(sig%spl_tck%c, (sig%spl_tck%n))
        read(20,*) (sig%spl_tck%t(ii), ii=1,sig%spl_tck%n)
        read(20,*) (sig%spl_tck%c(ii), ii=1,sig%spl_tck%n)
        read(20,*) sig%spl_tck%k
        call close_file(20)
      endif

! Spline scissors, outer
    elseif(trim(keyword).eq.'spline_scissors_outer') then
      if (peinf%inode==0) then
        write(6,*) 'Reading outer spline coefficients from `spline_scissors_outer.dat`'
        write(6,*)
        ! read number of pts, knots, coefficients, degree
        call open_file(20,file='spline_scissors_outer.dat',form='formatted',status='old')
        read(20,*) sig%spl_tck_outer%n
        SAFE_ALLOCATE(sig%spl_tck_outer%t, (sig%spl_tck_outer%n))
        SAFE_ALLOCATE(sig%spl_tck_outer%c, (sig%spl_tck_outer%n))
        read(20,*) (sig%spl_tck_outer%t(ii), ii=1,sig%spl_tck_outer%n)
        read(20,*) (sig%spl_tck_outer%c(ii), ii=1,sig%spl_tck_outer%n)
        read(20,*) sig%spl_tck_outer%k
        call close_file(20)
      endif

! The average potential on the faces of the unit cell in the non-periodic directions for the bands in WFN_inner

    elseif(trim(keyword).eq.'avgpot') then
      read(line,*,err=110) sig%avgpot

! The average potential on the faces of the unit cell in the non-periodic directions for the bands in WFN_outer

    elseif(trim(keyword).eq.'avgpot_outer') then
      read(line,*,err=110) sig%avgpot_outer

! Frequency dependence of the inverse dielectric matrix

    elseif(trim(keyword).eq.'frequency_dependence') then
      read(line,*,err=110) sig%freq_dep

! Frequency grid for numerical integration of full-frequency sigma (may be different from Epsilon)

    elseif(trim(keyword).eq.'init_frequency_eval') then
      read(line,*,err=110) sig%freqevalmin
    elseif(trim(keyword).eq.'delta_frequency_eval') then
      read(line,*,err=110) sig%freqevalstep
    elseif(trim(keyword).eq.'number_frequency_eval') then
      read(line,*,err=110) sig%nfreqeval

! Use full frequency tail for better energies

    elseif(trim(keyword).eq.'use_epsilon_remainder') then
      sig%iuseremainder = 1

! Grid of Qs in Epsilon

    elseif(trim(keyword).eq.'qgrid') then
      read(line,*,err=110) sig%qgrid(1), sig%qgrid(2), sig%qgrid(3)

! Compute the exact static CH

    elseif(trim(keyword).eq.'exact_static_ch') then
      read(line,*,err=110) sig%exact_ch

! Full CH convergence logging of all calculated bands

    elseif(trim(keyword).eq.'full_ch_conv_log') then
      read(line,*,err=110) sig%fullConvLog

! Half sum or full sum over G and G` vectors

    elseif(trim(keyword).eq.'ggpsum') then
      read(line,*,err=110) sig%ggpsum
      sig%ggpsum=2
! JRD. Tmp message
      if (peinf%inode .eq. 0) write(6,*) "ggpsum keyword no longer supported"

! Use use_xdat to skip the computation of bare exchange

    elseif(trim(keyword).eq.'use_xdat') then
      sig%use_xdat = .true.

! Use dont_use_vxcdat to compute exchange-correlation matrix elements from VXC

    elseif(trim(keyword).eq.'dont_use_vxcdat') then
      sig%use_vxcdat = .false.
    elseif(trim(keyword).eq.'dont_use_vxc2dat') then
      sig%use_vxc2dat = .false.
    elseif(trim(keyword).eq.'dont_use_hdf5') then
      sig%use_hdf5 = .false.
    elseif(trim(keyword).eq.'number_kpoints') then
      read(line,*,err=110) sig%nkn ! FHJ: deprecated
    elseif(trim(keyword).eq.'number_qpoints') then
      read(line,*,err=110) sig%nq ! FHJ: deprecated
    elseif(trim(keyword).eq.'number_sigma_pools') then
      read(line,*,err=110) peinf%npools
    elseif(trim(keyword).eq.'bare_coulomb_cutoff') then
      read(line,*,err=110) sig%ecutb
    elseif(trim(keyword).eq.'cell_average_cutoff') then
      read(line,*,err=110) sig%avgcut
    elseif(trim(keyword).eq.'screened_coulomb_cutoff') then
      read(line,*,err=110) sig%ecuts
    elseif(trim(keyword).eq.'number_bands') then
      read(line,*,err=110) sig%ntband
      call check_bounds_nbands(sig%ntband, 'number_bands')
    elseif(trim(keyword).eq.'band_index_min') then
      read(line,*,err=110) nbnmin
    elseif(trim(keyword).eq.'band_index_max') then
      read(line,*,err=110) nbnmax
    elseif(trim(keyword).eq.'spin_index_min') then
      read(line,*,err=110) spinmin
    elseif(trim(keyword).eq.'spin_index_max') then
      read(line,*,err=110) spinmax
    elseif(trim(keyword).eq.'finite_difference_form') then
      read(line,*,err=110) sig%fdf
    elseif(trim(keyword).eq.'finite_difference_spacing') then
      read(line,*,err=110) sig%dw
    elseif(trim(keyword).eq.'bare_exchange_fraction') then
      read(line,*,err=110) sig%xfrac
    elseif(trim(keyword).eq.'short_range_frac_fock') then
      read(line,*,err=110) sig%coulomb_mod%short_range_frac_fock
    elseif(trim(keyword).eq.'long_range_frac_fock') then
      read(line,*,err=110) sig%coulomb_mod%long_range_frac_fock
    elseif(trim(keyword).eq.'screening_length') then
      read(line,*,err=110) sig%coulomb_mod%screening_length
    elseif(trim(keyword).eq.'coulomb_truncation_radius') then
      read(line,*,err=110) sig%truncval(1)
    elseif(trim(keyword).eq.'spherical_truncation') then
      sig%icutv=2
    elseif(trim(keyword).eq.'cell_wire_truncation') then
      sig%icutv=4
    elseif(trim(keyword).eq.'cell_box_truncation') then
      sig%icutv=5
    elseif(trim(keyword).eq.'cell_slab_truncation') then
      sig%icutv=6
    elseif(trim(keyword).eq.'write_vcoul') then
      sig%iwritecoul=1
    elseif(trim(keyword).eq.'tol_degeneracy') then
      read(line,*,err=110) sig%tol
    elseif(trim(keyword).eq.'gpp_broadening') then
      read(line,*,err=110) sig%gamma
    elseif(trim(keyword).eq.'gpp_sexcutoff') then
      read(line,*,err=110) sig%sexcut
    elseif(trim(keyword).eq.'wavefunction_cutoff') then
      if(peinf%inode.eq.0) then
        write(0,123)
      endif
123   format(1x,"WARNING: Found keyword wavefunction_cutoff in the input file.",/,&
        10x,"This option is obsolete, use program wfnreduce instead.",/)
    elseif(trim(keyword).eq.'number_diag') then
      read(line,*,err=110) sig%ndiag
    elseif(trim(keyword).eq.'number_offdiag') then
      read(line,*,err=110) sig%noffdiag
    elseif(trim(keyword).eq.'sigma_matrix') then
      read(line,*,err=110) sig%loff, sig%toff
    elseif(trim(keyword).eq.'screening_semiconductor') then
      sig%iscreen=0
    elseif(trim(keyword).eq.'screening_graphene') then
      sig%iscreen=1
    elseif(trim(keyword).eq.'screening_metal') then
      sig%iscreen=2
    elseif(trim(keyword).eq.'band_occupation') then
      read(line,*,err=110) (band_occ(ii),ii=1,sig%ntband)
    elseif(trim(keyword).eq.'number_partial_occup') then
      read(line,*,err=110) sig%ncrit
    elseif(trim(keyword).eq.'ncrit') then
      if(peinf%inode.eq.0) then
        write(0,124)           
      endif
124   format(1x,"WARNING: Found keyword ncrit in the input file.",/,&
        10x,"This option is deprecated, use keyword number_partial_occup instead.",/)
      read(line,*,err=110) sig%ncrit
    elseif(trim(keyword).eq.'fermi_level') then
      read(line,*,err=110) sig%efermi_input
    elseif(trim(keyword).eq.'fermi_level_absolute') then
      sig%rfermi=.false.
    elseif(trim(keyword).eq.'fermi_level_relative') then
      sig%rfermi=.true.
    elseif(trim(keyword).eq.'comm_mpi') then
      sig%iwriteint=1
    elseif(trim(keyword).eq.'comm_disk') then
      sig%iwriteint=0
    elseif(trim(keyword).eq.'fullbz_replace') then
      sig%freplacebz=.true.
    elseif(trim(keyword).eq.'fullbz_write') then
      sig%fwritebz=.true.
    elseif(trim(keyword).eq.'degeneracy_check_override') then
      sig%degeneracy_check_override=.true.
    elseif(trim(keyword).eq.'no_symmetries_offdiagonals') then
      sig%offdiagsym=.false.
    elseif(trim(keyword).eq.'no_symmetries_q_grid') then
      sig%qgridsym=.false.
    elseif(trim(keyword).eq.'use_symmetries_q_grid') then
      sig%qgridsym=.true.
    elseif(trim(keyword).eq.'die_outside_sphere') then
      sig%die_outside_sphere=.true.
    elseif(trim(keyword).eq.'ignore_outside_sphere') then
      sig%die_outside_sphere=.false.
    elseif(trim(keyword).eq.'eqp_corrections') then
      sig%eqp_corrections=.true.
    elseif(trim(keyword).eq.'eqp_outer_corrections') then
      sig%eqp_outer_corrections=.true.
    elseif(trim(keyword).eq.'skip_averagew') then
      sig%averagew = .false.
    else
      call scissors_inread(keyword, line, sig%scis, found)
      if(.not. found) call scissors_inread(keyword, line, sig%scis_outer, found, "_outer")
      if(.not. found) then
        write(errmsg,'(3a)') 'Unexpected keyword ', trim(keyword), ' was found in sigma.inp.'
        call die(errmsg, only_root_writes = .true.)
      endif
    end if
  enddo

  ! entered in Ryd, stored in eV since kp%el and kp%elda are soon converted to eV.
  sig%tol = sig%tol * RYD

  if (peinf%inode==0 .and. sig%nkn>0) then
    write(0,'(/,a)') 'WARNING: the `number_kpoints` flag is deprecated. The code now'
    write(0,'(a,/)') 'automatically figures out the number of q-points from the input.'
  endif
  sig%nkn = nkpt_read
  if (peinf%inode==0 .and. sig%nq>0) then
    write(0,'(/,a)') 'WARNING: the `number_qpoints` flag is deprecated. The code now'
    write(0,'(a,/)') 'automatically figures out the number of k-points from the input.'
  endif
  sig%nq = nqpt_read
  if(sig%freq_dep==-1 .and. sig%nq<1) then
    write(0,'(/,a)') 'ERROR: Hartree-Fock calculations require a list of q-points'
    call die('The `begin qpoints` block could not be found.', only_root_writes=.true.)
  endif
  sig%nq1 = sig%nq - sig%nq0

  if(any(sig%qgrid(1:3) == 0).and.sig%freq_dep.eq.-1) then
    call die('qgrid must be specified for Hartree-Fock.', only_root_writes = .true.)
  endif
  
  if(.not. q0vec_read .and. sig%freq_dep .eq. -1) then
    call die('No q0 specified in qpoints block.', only_root_writes = .true.)
  endif
  
  SAFE_ALLOCATE(sig%kpt, (3,sig%nkn))
  sig%kpt(1:3,1:sig%nkn)=kpt_read(1:3,1:sig%nkn)
 
! This was true when we were not averaging V as well. So while a misnomer (ie we are
! not really averaging W but V and recalculating eps such that epsinv*V(q0vec) = epsnewinv*V(q=0)
! we still use this flag to be true.
  !if (sig%iscreen .eq. 2) then
  !  sig%averagew = .false.
  !endif

  if (sig%nq>0) then
    if (sig%freq_dep/=-1) then
      if (peinf%inode==0) &
        write(0,'(/,a,/)') 'WARNING: ignoring the qpoints block for calculations other than HF.'
    else
      SAFE_ALLOCATE(sig%qpt, (3,sig%nq))
      sig%qpt(1:3,1:sig%nq)=qpt_read(1:3,1:sig%nq)
    endif
  endif
  
  if(sig%ndiag.ne.0) then
    SAFE_ALLOCATE(sig%diag, (sig%ndiag))
    sig%diag(1:sig%ndiag)=diag(1:sig%ndiag)
  endif
  
  if(sig%ndiag.eq.0.and.nbnmin*nbnmax.ne.0) then
    sig%ndiag= nbnmax - nbnmin + 1
    ndiag_read = sig%ndiag
    SAFE_ALLOCATE(sig%diag, (sig%ndiag))
    do ii=1,sig%ndiag
      sig%diag(ii)= ii + nbnmin - 1
    enddo
  endif
  
  if(sig%ndiag.eq.0.and.nbnmin*nbnmax.eq.0) then
    write(errmsg,'(a,3i6)') 'Incomprehensible list of energy bands: ', sig%ndiag, nbnmin, nbnmax
    call die(errmsg, only_root_writes = .true.)
  endif
  
  if(ndiag_read.lt.sig%ndiag) then
    if(peinf%inode.eq.0) then
      write(0,*) 'The number of diagonal elements found in the diag block (',ndiag_read,')'
      write(0,*) '  is smaller than the one specified by the keyword number_diag (',sig%ndiag,').'
    endif
    call die("ndiag too small", only_root_writes = .true.)
  endif
  
  ! no finite-difference evaluation unless GPP
  if(sig%freq_dep /= 1 .and. sig%freq_dep /= 3) sig%fdf=-2

  if(ndiag_read.gt.sig%ndiag) then
    if(peinf%inode.eq.0) then
      write(0,887) ndiag_read, sig%ndiag, sig%ndiag
    endif
  endif
887 format(1x,"WARNING: The number of diag elements in the diag block (",i4,") is larger",/,&
      3x,"than the one specified by the keyword number_diag (",i4,").",/,&
      3x,"The program will continue using only",i4,1x,"diagonal elements.",/)
  
  if(nbnmin*nbnmax.eq.0) then
    nbnmin=max_bands
    nbnmax=-max_bands
    do ii=1,sig%ndiag
      if (sig%diag(ii).lt.nbnmin) nbnmin=sig%diag(ii)
      if (sig%diag(ii).gt.nbnmax) nbnmax=sig%diag(ii)
    enddo
  endif
  
  sig%bmin=nbnmin
  sig%bmax=nbnmax

  if(sig%loff.lt.-2.or.(sig%loff.gt.0.and.sig%loff.lt.nbnmin).or. &
    sig%loff.gt.nbnmax.or.sig%toff.lt.-1.or.sig%toff.gt.1) then
    call die("sigma_matrix parameters out of range", only_root_writes = .true.)
  endif
  
  if(sig%loff.ne.0) then
    if(noff_read.ne.0.or.sig%noffdiag.gt.0) then
      if(peinf%inode.eq.0) then
        write(0,994)
      endif
    endif
    kk=0
    do ii=nbnmin,nbnmax
      do jj=nbnmin,nbnmax
        if (sig%toff.eq.-1.and.ii.lt.jj) cycle
        if (sig%toff.eq.1.and.ii.gt.jj) cycle
        kk=kk+1
        off1_read(kk)=ii
        off2_read(kk)=jj
        if (sig%loff.eq.-1) then
          off3_read(kk)=ii
        else if (sig%loff.eq.-2) then
          off3_read(kk)=jj
        else
          off3_read(kk)=sig%loff
        endif
      enddo
    enddo
    sig%noffdiag=kk
    noff_read=sig%noffdiag
  endif
994 format(1x,"WARNING: both offdiag and sigma_matrix found in sigma.inp.",/,&
      3x,"The latter overrides the former.",/)
  
  if(noff_read.lt.sig%noffdiag) then
    if(peinf%inode.eq.0) then
      write(0,997) noff_read, sig%noffdiag
    endif
    call die("offdiag error", only_root_writes = .true.)
  endif
997 format(1x,"The number of offdiag elements in the offdiag block (",i4,") is",/,&
      3x,"smaller than the one specified by the keyword number_offdiag (",i4,").")
  
  if(noff_read.gt.sig%noffdiag) then
    if(peinf%inode.eq.0) then
      write(0,996) noff_read, sig%noffdiag, sig%noffdiag
    endif
  endif
996 format(1x,"WARNING: The number of offdiag elements in the offdiag block (",i4,") is",/,&
      3x,"larger than the one specified by the keyword number_offdiag (",i4,").",/,&
      3x,"The program will continue using only",i4,1x,"offdiag elements.",/)
  
  ! allocate even if noffdiag = 0 since sunf90 -xcheck will complain when passed unallocated to read_matrix_elements
  SAFE_ALLOCATE(sig%off1, (sig%noffdiag))
  SAFE_ALLOCATE(sig%off2, (sig%noffdiag))
  SAFE_ALLOCATE(sig%off3, (sig%noffdiag))
  if(sig%noffdiag.gt.0) then
    sig%off1(1:sig%noffdiag)=off1_read(1:sig%noffdiag)
    sig%off2(1:sig%noffdiag)=off2_read(1:sig%noffdiag)
    sig%off3(1:sig%noffdiag)=off3_read(1:sig%noffdiag)
  endif
  
  if(abs(sig%ecuts).lt.TOL_Zero) then
    call die("The screened_coulomb_cutoff keyword could not be found.", only_root_writes = .true.)
  endif
  
  if(abs(sig%ecutb).lt.TOL_Zero) then
    call die("The bare_coulomb_cutoff keyword could not be found.", only_root_writes = .true.)
  endif

  if(sig%ecuts > sig%ecutb) then
    call die("The screened_coulomb_cutoff cannot be greater than the bare_coulomb_cutoff.", only_root_writes = .true.)
  endif

  ! FHJ: Make sure the user entered a valid number of bands
  call check_consistency_nbands(sig%ntband, .true.)
  
  do ii=1,sig%ndiag
    if (sig%diag(ii).gt.sig%ntband) then
      write(errmsg,'(a,3i6)') 'The band_index_max cannot be greater than number_bands: ', ii, sig%diag(ii), sig%ntband
      call die(errmsg, only_root_writes = .true.)
    endif
  enddo
  
  if(spinmin.eq.1.and.spinmax.eq.1) then
    sig%nspin=1
    sig%spin_index(1)=1
    sig%spin_index(2)=2 ! only used for spinor case
  elseif(spinmin.eq.2.and.spinmax.eq.2) then
    sig%nspin=1
    sig%spin_index(1)=2
  elseif(spinmin.eq.1.and.spinmax.eq.2) then
    sig%nspin=2
    sig%spin_index(1)=1
    sig%spin_index(2)=2
  else
    write(errmsg,'(a,i2,a,i2,a,i2)') 'Illegal range of spin indices from ', spinmin, ' to ', spinmax
    call die(errmsg, only_root_writes = .true.)
  endif

!------------------------------
! Build the map sig%offmap
!         sig%off1(ii) = sig%diag(sig%offmap(ii,1))
!         sig%off2(ii) = sig%diag(sig%offmap(ii,2))
!         sig%off3(ii) = sig%diag(sig%offmap(ii,3))
! This is done only if sig%noffdiag .ne. 0

  if(sig%noffdiag.gt.0) then
    SAFE_ALLOCATE(sig%offmap, (sig%noffdiag,3))
    sig%offmap(1:sig%noffdiag, 1:3) = 0
    do ii=1,sig%noffdiag
      do jj=1,sig%ndiag
        if(sig%diag(jj) .eq. sig%off1(ii)) sig%offmap(ii, 1) = jj
        if(sig%diag(jj) .eq. sig%off2(ii)) sig%offmap(ii, 2) = jj
        if(sig%diag(jj) .eq. sig%off3(ii)) sig%offmap(ii, 3) = jj
      enddo
      
      if(sig%offmap(ii, 1) == 0) then
        write(errmsg,'(a,i6,a)') 'Off-diagonal matrix el. requested for band ', &
          sig%off1(ii),' but no corresponding diagonal matrix el. is requested'
        call die(errmsg, only_root_writes = .true.)
      endif
      
      if(sig%offmap(ii, 2) == 0) then
        write(errmsg,'(a,i6,a)') 'Off-diagonal matrix el. requested for band ', &
          sig%off2(ii),' but no corresponding diagonal matrix el. is requested'
        call die(errmsg, only_root_writes = .true.)
      endif
      
      if(sig%offmap(ii, 3) == 0) then
        write(errmsg,'(a,i6,a)') 'Off-diagonal matrix el. requested at energy of band ', &
          sig%off3(ii),' but no corresponding diagonal matrix el. is requested'
        call die(errmsg, only_root_writes = .true.)
      endif
    enddo
  endif ! sig%noffdiag.gt.0
  
  SAFE_ALLOCATE(sig%band_index, (sig%ntband))
  sig%nvband=0
  jj=0
  do ii=1,sig%ntband
    sig%nvband=sig%nvband+band_occ(ii)
    if(band_occ(ii).eq.1) then
      jj=jj+1
      sig%band_index(ii)=jj
    endif
  enddo
  do ii=1,sig%ntband
    if(band_occ(ii).eq.0) then
      jj=jj+1
      sig%band_index(ii)=jj
    endif
  enddo
  if((sig%nvband+sig%ncrit).eq.0) then
    call die("The band_occupation keyword could not be found or was placed before the number_bands keyword.", &
      only_root_writes = .true.)
  endif
  
  if(sig%fullConvLog.lt.0.or.sig%fullConvLog.gt.2) then
    call die('Invalid full_ch_conv_log', only_root_writes = .true.)
  endif

! gsm: What frequency dependence we are using?

  if(peinf%inode.eq.0) then
    if(sig%freq_dep.eq.-1) then
      write(6,699)
      write(7,699)
    elseif(sig%freq_dep.eq.0) then
      write(6,700)
      write(7,700)
    elseif(sig%freq_dep.eq.1) then
      write(6,701)
      write(7,701)
    elseif(sig%freq_dep.eq.2) then
      write(6,702)
      write(7,702)
    elseif(sig%freq_dep.eq.3) then
      write(6,703)
      write(7,703)
    else
      call die('Need to specify frequency dependence')
    endif
  endif
699 format(1x,'Using the Hartree-Fock approximation',/)
700 format(1x,'Using the static COHSEX approximation',/)
701 format(1x,'Using the Generalized Plasmon Pole model',/)
702 format(1x,'Using the full frequency-dependent inverse dielectric matrix',/)
703 format(1x,'Using the Generalized Plasmon Pole model (GN flavor)',/)

  if(peinf%inode == 0) then
    if(sig%iwriteint == 1) then ! comm_mpi
      if(peinf%npes > 1) then
        write(6,803)
        write(7,803)
      else
        write(6,805)
        write(7,805)
      endif
    else ! comm_disk
      write(6,804)
      write(7,804)
    endif
  endif
803 format(1x,'We are communicating via MPI',/)
804 format(1x,'We are communicating via disk',/)
805 format(1x,'We are not communicating',/)

! gsm: Do we compute the exact static CH?

  if(sig%exact_ch.eq.-1) then ! set default according to freq_dep
    if(sig%freq_dep .eq. 0) then
      sig%exact_ch = 1
    else
      sig%exact_ch = 0
    endif
  endif
  if(sig%freq_dep.ne.-1) then ! HF has no CH sum so don`t write any comments about it
    if(sig%exact_ch.eq.0) then
      if(peinf%inode.eq.0) write(6,750)
      if(peinf%inode.eq.0) write(7,750)
    elseif(sig%exact_ch.eq.1.and.sig%freq_dep.eq.0) then
      if(peinf%inode.eq.0) write(6,751)
      if(peinf%inode.eq.0) write(7,751)
      if(sig%ntband .gt. max(maxval(sig%diag(1:sig%ndiag)), sig%nvband + sig%ncrit)) then
        ! this makes that we do not waste time and memory with the unoccupied bands which will not be used
        sig%ntband = max(maxval(sig%diag(1:sig%ndiag)), sig%nvband + sig%ncrit)
        if(peinf%inode.eq.0) &
          write(0,'(a)') "WARNING: Resetting number_bands to number of bands actually needed for exact static CH."
      endif
    elseif(sig%exact_ch.eq.1.and.(sig%freq_dep.eq.1.or.sig%freq_dep.eq.2&
& .or. sig%freq_dep.eq.3)) then
      if(peinf%inode.eq.0) write(6,752)
      if(peinf%inode.eq.0) write(7,752)
      if(peinf%inode.eq.0) write(0,753)
    else
      call die('Illegal value for exact_static_ch')
    endif
  endif
750 format(1x,'Computing CH as a partial sum over empty bands',/)
751 format(1x,'Computing the exact static CH',/)
752 format(1x,'Computing CH as a partial sum over empty bands with the static remainder',/)
753 format(1x,'WARNING: Static remainder is an experimental feature',/, &
      3x,'Only use if you know what you''re doing',/)
  
! gsm: Do we run half sum or full sum over G and G` vectors?

  if(peinf%inode.eq.0) then
    if(sig%ggpsum.eq.1) then
      write(6,771)
      write(7,771)
    elseif(sig%ggpsum.eq.2) then
      write(6,772)
      write(7,772)
    else
      call die('Need to set ggpsum to either 1 or 2')
    endif
  endif
771 format(1x,'Computing half sum over G and G'' vectors',/)
772 format(1x,'Computing full sum over G and G'' vectors',/)
  
! JRD: What screening is present?

  if(peinf%inode.eq.0) then
    if(sig%ncrit < 0) then
      call die("number_partial_occup < 0")
    endif

    if(sig%iscreen.eq.0) then
      if(sig%ncrit > 0) then
        write(0,'(a)') "WARNING: Semiconductor screening is inappropriate for number_partial_occup > 0."
        write(0,'(a)') "If a band really crosses the Fermi level, graphene or metal screening must be used."
        ! this only makes sense if ncrit was used to handle two spins, or
        ! to tune the number of conduction and valence bands for optimal parallelization.
      endif
      write(6,800)
      write(7,800)
    elseif(sig%iscreen.eq.1) then
      if(sig%ncrit == 0) then
        write(0,*) "WARNING: Graphene screening usually should have number_partial_occup > 0."
      endif
      write(6,801)
      write(7,801)
    elseif(sig%iscreen.eq.2) then
      if(sig%ncrit == 0) then
        write(0,*) "WARNING: Metal screening usually should have number_partial_occup > 0."
      endif
      write(6,802)
      write(7,802)
    else
      call die('Unknown screening type')
    endif
  endif
800 format(1x,'Running with semiconductor screening',/)
801 format(1x,'Running with graphene screening',/)
802 format(1x,'Running with metal screening',/)

! JRD: What truncation scheme are we using?

  if(peinf%inode.eq.0) then
    if(sig%icutv.eq.0) then
      write(6,900)
      write(7,900)
    elseif(sig%icutv.eq.2) then
      write(6,902)
      write(7,902)
      write(6,912)sig%truncval(1)
      write(7,912)sig%truncval(1)
    elseif(sig%icutv.eq.4) then
      write(6,904)
      write(7,904)
    elseif(sig%icutv.eq.5) then
      write(6,905)
      write(7,905)
    elseif(sig%icutv.eq.6) then
      write(6,906)
      write(7,906)
    endif
  endif
900 format(1x,'We are using no truncation',/)
902 format(1x,'We are using a truncated Coulomb interaction (spherical)')
904 format(1x,'We are using a truncated Coulomb interaction: Cell Wire',/)
905 format(1x,'We are using a truncated Coulomb interaction: Cell Box',/)
906 format(1x,'We are using a truncated Coulomb interaction: Cell Slab',/)
912 format(1x,'r_cut = ',f10.6,' Bohr'/)

  if(peinf%inode.eq.0) then
    if(sig%ncrit.gt.0) then
      write(6,951)sig%ncrit
      write(7,951)sig%ncrit
951   format(1x,'We have partially occupied bands',/, &
        1x,'number_partial_occup (ncrit) =',i3,/)
    endif
  endif

  if(sig%use_xdat) then
    inquire(file='x.dat', exist=sig%use_xdat)
    if(sig%use_xdat .and. peinf%inode == 0) then
      write(6,899)
      write(7,899)
899   format(1x,"Reading bare exchange matrix elements from x.dat file."/)
    endif
  endif
  if(sig%use_vxcdat) then
    inquire(file='vxc.dat', exist=sig%use_vxcdat)
    if(sig%use_vxcdat .and. peinf%inode == 0) then
      write(6,898)
      write(7,898)
898   format(1x,"Reading exchange-correlation matrix elements from vxc.dat file",/)
    endif
  endif
  if(.not. sig%use_vxcdat) then
    inquire(file='VXC', exist=VXC_exists)
    if(.not. VXC_exists) call die("VXC file is missing.", only_root_writes = .true.)
    if(peinf%inode == 0) then
      write(6,897)
      write(7,897)
897   format(1x,"Computing exchange-correlation matrix elements from VXC file",/)
    endif
  endif
  ! This is for hybrid functional like calculation (one shot)
  if (sig%freq_dep.eq.-1 .and. ((1.0d0 - sig%coulomb_mod%long_range_frac_fock > TOL_SMALL) .or. &
    (1.0d0 - sig%coulomb_mod%short_range_frac_fock > TOL_SMALL)))  then

    sig%coul_mod_flag = .true.             
    if(sig%use_vxc2dat) then
      inquire(file='vxc2.dat', exist=sig%use_vxc2dat)
      if(sig%use_vxc2dat .and. peinf%inode == 0) then
        write(6,896)
        write(7,896)
896     format(1x,"Reading exchange-correlation matrix elements from vxc2.dat file",/)
      endif
    endif
    if(.not. sig%use_vxc2dat) then
      inquire(file='VXC2', exist=VXC_exists)
      if(.not. VXC_exists) call die("VXC2 file is missing.", only_root_writes = .true.)
      if(peinf%inode == 0) then
        write(6,895)
        write(7,895)
895     format(1x,"Computing exchange-correlation matrix elements from VXC2 file",/)
      endif
    endif
  endif
  
#ifdef MPI
  ! root lets the others go after it is done reading (see beginning of function)
  if(peinf%inode == 0) call MPI_Barrier(MPI_COMM_WORLD, mpierr)

  ! FHJ: Broadcast spline scissors (this must be called after the barrier)
  ! FHJ: inner splines
  call MPI_BCAST(sig%spl_tck%n, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
  if ( sig%spl_tck%n > 0 ) then
    if(peinf%inode/=0) then
      SAFE_ALLOCATE(sig%spl_tck%t, (sig%spl_tck%n))
      SAFE_ALLOCATE(sig%spl_tck%c, (sig%spl_tck%n))
    endif
    call MPI_BCAST(sig%spl_tck%t, sig%spl_tck%n, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(sig%spl_tck%c, sig%spl_tck%n, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(sig%spl_tck%k, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
  endif
  ! FHJ: outer splines
  call MPI_BCAST(sig%spl_tck_outer%n, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
  if ( sig%spl_tck_outer%n > 0 ) then
    if(peinf%inode/=0) then
      SAFE_ALLOCATE(sig%spl_tck_outer%t, (sig%spl_tck_outer%n))
      SAFE_ALLOCATE(sig%spl_tck_outer%c, (sig%spl_tck_outer%n))
    endif
    call MPI_BCAST(sig%spl_tck_outer%t, sig%spl_tck_outer%n, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(sig%spl_tck_outer%c, sig%spl_tck_outer%n, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(sig%spl_tck_outer%k, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
  endif
#endif

  POP_SUB(inread)

  return
  
110 write(errmsg,'(3a)') 'Unexpected characters were found while reading the value for the keyword ', &
      trim(keyword), '. '
  call die(errmsg, only_root_writes = .true.)
  
112 write(errmsg,'(3a)') 'Unexpected characters were found while reading elements of the ', &
      trim(blockword),' block.'
  call die(errmsg, only_root_writes = .true.)
  
end subroutine inread

!===================================================================================
!
! Routines:
!
! (1) kernel (main)      Originally By MLT       Last Modified: 5/5/2008 (JRD)
!
!     See README_kernel for more information.
!
!     Calculates the kernel, direct and exchange parts, of the Bethe-Salpeter
!     equation. The direct part is decomposed in head, wing, body, and the
!     exchange part involves only the "proper" part of the Coulomb
!     interaction. Spin-polarized case implemented.
!
!     For more details, see:
!     Rohlfing & Louie, PRB 62:(8), 4927 (2000)
!     G. Strinati, Rivista del Nuovo Cimento 11:(12), 1 (1988)
!
!     Code originally written by Gian-Marco Rignanese, Eric K Chang.
!
!     All cited equations refer to Rohlfing & Louie (PRB (62):4927, 2000)
!     unless specified otherwise.
!
!===================================================================================

#include "f_defs.h"

program kernel

#ifdef HDF5
  use hdf5
#endif

  use global_m
  use check_screening_m
  use fftw_m
  use fullbz_m
  use io_utils_m
  use mtxel_kernel_m
  use vcoul_generator_m
  use bsewrite_m
  implicit none

  type (crystal) :: crys
  type (symmetry) :: syms
  type (gspace) :: gvec
  type (xctinfo) :: xct
  type (grid) :: kg,qg,kgq
  type (kpoints) :: kp
  type (wavefunction) :: wfnc,wfncp
  type (wavefunction) :: wfnv,wfnvp
  type (int_wavefunction) :: intwfnv,intwfnc
  type (twork_scell) :: work_scell

  character :: filename*20
  integer :: ii,jj,ijk,ikq,iparallel,iownsize
  integer :: ik,ikp
  integer :: ncount,ntim,flagbz
  integer :: ic,iv,icp,ivp,error,umk
  integer :: ifqa_dummy,irqa_dummy,g0a_dummy(3)
  real(DP) :: vq0, avgcut, oneoverq, q0len,delta
  real(DP) :: tsec(2),tmin(2),tmax(2),q0vec(3),vq(3),qq(3)
  real(DP) :: qqa_dummy,fqa_dummy(3),vcoul0(1)
  SCALAR :: epsheaddummy, wcoul0dummy

  character*16, allocatable :: routnam(:)
  integer, allocatable :: indexq(:),irqa(:),ifqa(:),g0a(:,:)
  integer, allocatable :: isrtq(:)
  real(DP), allocatable :: vcoul(:),vcoularray(:,:),fqa(:,:),qqa(:),vcoularray_mod(:,:)
  SCALAR, allocatable :: &
    bsedbody(:,:,:),bsedhead(:,:,:), &
    bsedwing(:,:,:),bsex(:,:,:),bset(:,:,:)

  type(progress_info) :: prog_info !< a user-friendly progress report

!----------------- Begin Program ----------------------------------------------

  call peinfo_init()

!----------------------
! Dont create random numbers

  peinf%jobtypeeval = 0

!----------------------
! Initialize timer

  call timacc(0,0)
  call timacc(1,1)
  
  call write_program_header('BSE/Kernel', .false.)
  
!------------------------
! Read kernel.inp

  call logit('Calling inread_kernel')
  call open_file(8,file='kernel.inp',form='formatted',status='old')
  call inread_kernel(xct,flagbz,q0vec,qg)
  call close_file(8)

  if (xct%iwritecoul .eq. 1 .and. peinf%inode .eq. 0) then
    call open_file(19,file='vcoul',form='formatted',status='replace')
  endif

!----------------------

#ifdef HDF5
  if(xct%use_hdf5) call h5open_f(error)
#endif

!-------------------------
! Read WFN_fi

  call timacc(2,1)
  call logit('Calling input_kernel')

! JRD: What routine we call depends on if we have center-of-mass momentum.

  if (xct%qflag .eq. 0) then
    call die("Center-of-mass momentum is broken.") ! if indeed it ever worked...
    !call input_kernel_q(crys,gvec,kg,kgq,kp,kpq,syms,xct,flagbz)
    SAFE_ALLOCATE(indexq, (kg%nf))
    do ijk = 1, kg%nf
      indexq(ijk)=xct%indexq(ijk)
    enddo
  else
    call input_kernel(crys,gvec,kg,kp,syms,xct,flagbz,intwfnv,intwfnc)
    SAFE_ALLOCATE(indexq, (kg%nf))
    ! DYQ: Use a center-of-mass momentum commensurate with the kgrid of WFN_co, when qflag=2
    ! Find the index of the point in kg corresponding to kg%f+xct%finiteq
    ! and store the index mapping in indexq
    if (xct%qflag .eq. 2) then 
    else
      do ijk=1,kg%nf
        indexq(ijk)=ijk
      enddo
    endif
  endif

  call timacc(2,2)

!      if(peinf%inode.eq.0) write(6,*) 'Exit input_kernel'

! JRD: Write some info about our calculation

  if (peinf%inode.eq.0) then
    write(6,*)
    if (xct%theory.eq.0) then
      write(6,*) ' Bethe-Salpeter Calculation'
    elseif (xct%theory.eq.1) then
      write(6,*) ' Time-dependent Density Functional Theory Calculation'
    endif
    write(6,*) ' valence bands limits : ', xct%nvb_co,' (total) '
    write(6,*) ' cond.   bands limits : ', xct%ncb_co,' (total) '
    write(6,*) ' number of spins   = ',xct%nspin
  endif

!----------------------------------
! Read eps0mat and epsmat

  if (xct%theory.eq.0) then
    call logit('Calling epscopy')
    call timacc(3,1)
    call epscopy(crys,gvec,syms,qg,xct,q0vec)
    call timacc(3,2)
  elseif (xct%theory.eq.1) then
    call logit('Calling tddft_bz_gen')
    call timacc(3,1)
    call tddft_bz_gen(crys,syms,qg,xct)
    call timacc(3,2)
  endif

!------------------ Initialize BSE Arrays ----------------------------------------------
  if ( xct%ivpar .eq. 1) then
    iownsize=1
  else if ( xct%icpar .eq. 1) then
    iownsize=(xct%nvb_co)**2
  else
    iownsize=(xct%n1b_co*xct%n2b_co)**2
  endif

  if (xct%theory .eq. 0) then
    SAFE_ALLOCATE(bsedbody, (peinf%myown*iownsize,xct%nspin,xct%nspin))
    SAFE_ALLOCATE(bsedhead, (peinf%myown*iownsize,xct%nspin,xct%nspin))
    SAFE_ALLOCATE(bsedwing, (peinf%myown*iownsize, xct%nspin,xct%nspin))
    bsedbody(:,:,:) = ZERO
    bsedhead(:,:,:) = ZERO
    bsedwing(:,:,:) = ZERO
  else if (xct%theory .eq. 1) then
    SAFE_ALLOCATE(bsedbody, (peinf%myown*iownsize,xct%nspin,xct%nspin))
    SAFE_ALLOCATE(bsedhead, (peinf%myown*iownsize,xct%nspin,xct%nspin))
    SAFE_ALLOCATE(bset, (peinf%myown*iownsize,xct%nspin,xct%nspin))
    bsedbody(:,:,:) = ZERO
    bsedhead(:,:,:) = ZERO
    bset(:,:,:) = ZERO
  endif
  ! We always need exchange
  SAFE_ALLOCATE(bsex, (peinf%myown*iownsize,xct%nspin,xct%nspin))
  bsex(:,:,:) = ZERO

  if (peinf%inode.eq.0) write(6,*)
  
!--------- Calculate Needed Coulomb Interaction -------------------------------

  SAFE_ALLOCATE(vcoul, (xct%ng))
  SAFE_ALLOCATE(vcoularray, (xct%ng,qg%nf))
  vcoularray=0d0

  ! This array is for the direct part of the TDDFT and
  ! vcoularray will be for the exchange. This part will
  ! get modified if one is doing TD-Hybrids
  if (xct%theory .eq. 1) then
    SAFE_ALLOCATE(vcoularray_mod, (xct%ng,qg%nf))
    vcoularray_mod=0d0
  endif
  SAFE_ALLOCATE(isrtq, (xct%ng))
  do ijk=1,xct%ng
    isrtq(ijk) = ijk
  enddo
  
  if (peinf%inode .eq. 0) then
    write(6,701)
  endif
  701 format(1x,'Calculating Vcoul',/)

  avgcut=TOL_ZERO
  q0len = sqrt(DOT_PRODUCT(q0vec,MATMUL(crys%bdot,q0vec)))

  iparallel=1

  do ik=1,qg%nf
    vq(:)=qg%f(:,ik)
    vq0 = DOT_PRODUCT(vq,MATMUL(crys%bdot,vq))
    
#ifdef VERBOSE
    if (peinf%inode .eq. 0) then
      write(6,*) 'Calculating Vcoul', ik, qg%nf
    endif
#endif

    call vcoul_generator(xct%icutv,xct%truncval,gvec, &
      crys%bdot,kg%nf,xct%ng,isrtq,xct%iscreen,vq,q0vec, &
      vcoul,xct%iwritecoul,iparallel,avgcut,oneoverq, &
      kp%kgrid,epsheaddummy,work_scell,.false.,wcoul0dummy)
    vcoularray(:,ik)=vcoul(:)

    if (xct%theory .eq. 1) then
      if (xct%coul_mod_flag) then
        call vcoul_generator(xct%icutv,xct%truncval,gvec, &
          crys%bdot,kg%nf,xct%ng,isrtq,xct%iscreen,vq,q0vec, &
          vcoul,xct%iwritecoul,iparallel,avgcut,oneoverq, &
          kp%kgrid,epsheaddummy,work_scell,.false.,wcoul0dummy,coulomb_mod=xct%coulomb_mod)
        vcoularray_mod(:,ik)=vcoul(:)
      else
        vcoularray_mod(:,ik)=vcoul(:)
      endif
    endif

    if (vq0 .lt. TOL_Zero) then
      if (peinf%inode .eq. 0) then
        write(6,801) q0vec
      endif
      vq(:) = q0vec(:)
801 format(1x,'For G=0: setting q0 =',3f10.6,/)

      if (xct%theory .ne. 1) call check_screening_trunc(xct%icutv,xct%iscreen,q0vec,crys%bdot)
    
      vcoul0(1)=0d0
      call vcoul_generator(xct%icutv,xct%truncval,gvec, &
      crys%bdot,kg%nf,1,isrtq,xct%iscreen,vq,q0vec, &
        vcoul0(:),xct%iwritecoul,iparallel,avgcut,oneoverq, &
        kp%kgrid,epsheaddummy,work_scell,.false.,wcoul0dummy)

      vcoularray(1,ik)=vcoul0(1)

      if (xct%theory .eq. 1) then
        if (xct%coul_mod_flag) then
          vcoul0(1)=0d0
          call vcoul_generator(xct%icutv,xct%truncval,gvec, &
            crys%bdot,kg%nf,1,isrtq,xct%iscreen,vq,q0vec, &
            vcoul0(:),xct%iwritecoul,iparallel,avgcut,oneoverq, &
            kp%kgrid,epsheaddummy,work_scell,.false.,wcoul0dummy,coulomb_mod=xct%coulomb_mod)

          vcoularray_mod(1,ik)=vcoul0(1)
        else
          vcoularray_mod(1,ik)=vcoul0(1)
        endif
      endif
    endif

  enddo ! ik

  SAFE_DEALLOCATE(isrtq)
  call destroy_qran()

  vcoularray=vcoularray/(8d0*PI_D)
  if (xct%theory .eq. 1) then
    vcoularray_mod=vcoularray_mod/(8d0*PI_D)
  endif
  
#ifdef VERBOSE
  if (peinf%inode .eq. 0) then
    write(6,*) 'Finished Vcoul', ik, qg%nf
  endif
#endif

  SAFE_DEALLOCATE(vcoul)

!--------- Start the computation. ---------------------------------------------

  call logit('Starting main kernel loop')
  if (peinf%inode.eq.0) write(6,771) peinf%myown
771 format(1x,"Starting calculation of kernel with",i6,1x, &
      "blocks of pairs per PE",/)
  
  SAFE_ALLOCATE(qqa, (peinf%myown))
  SAFE_ALLOCATE(fqa, (3,peinf%myown))
  SAFE_ALLOCATE(g0a, (3,peinf%myown))
  SAFE_ALLOCATE(irqa, (peinf%myown))
  SAFE_ALLOCATE(ifqa, (peinf%myown))
  
  call sortbyq(fqa,qqa,g0a,ifqa,irqa,qg,kg,crys)

! JRD: The below may be useful for debugging
!
!  call mpi_barrier(mpi_comm_world,mpierr)
!  write(6,*) 'myown',peinf%inode,peinf%myown
!  call mpi_barrier(mpi_comm_world,mpierr)

  ! FHJ: this is to generate nice output / time estimate
  call progress_init(prog_info, 'calculation of matrix elements', 'block', peinf%nckpe)

  do ii=1,peinf%nckpe

   ! FHJ : friendly output / running time estimate
    call progress_step(prog_info, ii)

    call logitint('   Main loop:  ii=',ii)
    if (ii .le. peinf%myown) then
      ik=peinf%ik(peinf%inode+1,ii)
      ikp=peinf%ikp(peinf%inode+1,ii)
      
      if (xct%icpar .eq. 1) then
        ic=peinf%ic(peinf%inode+1,ii)
        icp=peinf%icp(peinf%inode+1,ii)
      else
        ic=1
        icp=1
      endif
      
      if (xct%ivpar .eq. 1) then
        iv=peinf%iv(peinf%inode+1,ii)
        ivp=peinf%ivp(peinf%inode+1,ii)
      else
        iv=1 
        ivp=1 
      endif
      
      call timacc(4,1)
      call logit('   Calling genwf_kernel')
      
      !write(6,*) peinf%inode,'calling gw 1', ii, ik
      ! DYQ: returns wfnv at indexq(ik) and wfnc at ik
      call genwf_kernel(crys,gvec,kg,kgq,syms,wfnc, &
        wfnv,xct%nspin,ik,ic,iv,indexq,xct,intwfnv,intwfnc)
      
      !write(6,*) peinf%inode,'calling gw 2', ii, ikp

      ! returns wfnv at indexq(ikp) and wfnc at ikp
      call genwf_kernel(crys,gvec,kg,kgq,syms,wfncp, &
        wfnvp,xct%nspin,ikp,icp,ivp,indexq,xct,intwfnv,intwfnc)

      call timacc(4,2)
      
    else
      ik=-1
      ikp=-1
      ic=-1
      icp=-1
      iv=-1
      ivp=-1
    endif
#ifdef VERBOSE
    if (peinf%inode.eq.0) then
      write(6,772) ii
      write(6,773) ik,ikp,ic,icp,iv,ivp
    endif
772 format(1x,"PE # 0 dealing with block",i6)
773 format(1x,"ik =",i6,1x,"ikp =",i6,1x,"ic =",i6,1x,"icp =",i6,1x,"iv =",i6,1x,"ivp =",i6)
#endif

    call logit('      Calling mtxel_kernel')
    call timacc(6,1)

    if (ii .le. peinf%myown) then
      if (xct%theory .eq. 0) then
        call mtxel_kernel(crys,gvec,syms,qg,wfnc,wfncp,wfnvp, &
          wfnv,xct,peinf%myown*iownsize,bsedbody,bsedhead,bsedwing,bsex,ii,ik,ikp, &
          ic,icp,iv,ivp, &
          vcoularray,fqa(:,ii),qqa(ii),g0a(:,ii),ifqa(ii),irqa(ii),q0len)
      else if (xct%theory .eq. 1) then
      endif

      SAFE_DEALLOCATE_P(wfncp%cg)
      SAFE_DEALLOCATE_P(wfncp%isort)
      SAFE_DEALLOCATE_P(wfnvp%cg)
      SAFE_DEALLOCATE_P(wfnvp%isort)
      SAFE_DEALLOCATE_P(wfnc%cg)
      SAFE_DEALLOCATE_P(wfnc%isort)
      SAFE_DEALLOCATE_P(wfnv%cg)
      SAFE_DEALLOCATE_P(wfnv%isort)
    else
      if (xct%iwriteint .ne. 0) then
        !            write(6,*) peinf%inode, 'Calling mtxel without task'
        fqa_dummy(:)=0.0d0
        qqa_dummy=0.0d0
        g0a_dummy(:)=0
        ifqa_dummy=0
        irqa_dummy=0
        if (xct%theory .eq. 0) then
          call mtxel_kernel(crys,gvec,syms,qg,wfnc,wfncp,wfnvp,wfnv, &
            xct,peinf%myown*iownsize,bsedbody,bsedhead,bsedwing,bsex,ii,ik,ikp,ic,icp, &
            iv,ivp, &
            vcoularray,fqa_dummy,qqa_dummy,g0a_dummy,ifqa_dummy,irqa_dummy,q0len)
        else if (xct%theory .eq. 1) then
        endif

      endif
    endif
    
    call timacc(6,2)

  enddo !ii

  if (xct%qflag .eq. 0) call dealloc_grid(kgq)
  call dealloc_grid(qg)
  call progress_free(prog_info)

  SAFE_DEALLOCATE_P(intwfnv%cg)
  SAFE_DEALLOCATE_P(intwfnc%cg)
  SAFE_DEALLOCATE_P(intwfnv%isort)
  SAFE_DEALLOCATE_P(intwfnc%isort)
  SAFE_DEALLOCATE_P(intwfnv%ng)
  SAFE_DEALLOCATE_P(intwfnc%ng)
  
  SAFE_DEALLOCATE(qqa)
  SAFE_DEALLOCATE(fqa)
  SAFE_DEALLOCATE(g0a)
  SAFE_DEALLOCATE(irqa)
  SAFE_DEALLOCATE(ifqa)
  if (xct%theory .eq. 0) then
    SAFE_DEALLOCATE_P(xct%epsdiag)
  endif
  if (peinf%inode .eq. 0 .or. xct%bLowComm) then
    SAFE_DEALLOCATE_P(xct%isrtqi)
  endif
  if (xct%iwriteint .eq. 1 .and. xct%theory .eq. 0) then
    SAFE_DEALLOCATE_P(xct%epsown)
    SAFE_DEALLOCATE_P(xct%epsowni)
    SAFE_DEALLOCATE_P(xct%maxpe)
    SAFE_DEALLOCATE_P(xct%epscol)
  endif
  SAFE_DEALLOCATE_P(peinf%nxqown)
  SAFE_DEALLOCATE_P(peinf%nxqi)
  

!--------------- Write BSE matrices ----------------------------------------------

  call timacc(8,1)
  if (xct%theory .eq. 0) then
    call bsewrite(xct,iownsize,bsedbody,bsedhead,bsex,kg,kp,gvec,syms,crys, &
      bsedwing=bsedwing)
  else if (xct%theory .eq. 1) then
    call bsewrite(xct,iownsize,bsedbody,bsedhead,bsex,kg,kp,gvec,syms,crys, &
      bset=bset)
  endif
  call timacc(8,2)

  call dealloc_grid(kg)

  call destroy_fftw_plans()

  if (xct%theory .eq. 0) then
    SAFE_DEALLOCATE(bsedhead)
    SAFE_DEALLOCATE(bsedwing)
    SAFE_DEALLOCATE(bsedbody)
  else if (xct%theory .eq. 1) then
    SAFE_DEALLOCATE(bsedhead)
    SAFE_DEALLOCATE(bsedbody)
    SAFE_DEALLOCATE(bset)
  endif 
  SAFE_DEALLOCATE(bsex)
  SAFE_DEALLOCATE(indexq)

  if (xct%iwritecoul .eq. 1) then
    if (peinf%inode .eq. 0) then
      call close_file(19) ! file vcoul
    endif
  endif

!---------------- Time accounting -----------------------------------------------


  ntim=8
  SAFE_ALLOCATE(routnam, (76))
  routnam(1)='TOTAL:'
  routnam(2)='INPUT:'
  routnam(3)='EPSCOPY:'
  routnam(4)='GENWF:'
  routnam(5)='EXCWF:'
  routnam(6)='MTXEL:'
  routnam(7)='FULLBZ:'
  routnam(8)='BSEWRITE:'
  
  call timacc(1,2)
  if(peinf%inode.eq.0) then
    write(6,*)
    write(6,9000) 'CPU [s]','WALL [s]','#'
    write(6,*)
  endif
  
  do ii=2,ntim
    call timacc(ii,3,tsec,ncount)
#ifdef MPI
    call MPI_ALLREDUCE(tsec,tmin,2,MPI_REAL_DP,MPI_MIN,MPI_COMM_WORLD,mpierr)
    call MPI_ALLREDUCE(tsec,tmax,2,MPI_REAL_DP,MPI_MAX,MPI_COMM_WORLD,mpierr)
#else
    tmin = tsec
    tmax = tsec
#endif
    if(peinf%inode.eq.0) then
      write(6,9001) routnam(ii),tmin(1),tmin(2),ncount
      write(6,9002) tsec(1),tsec(2)
      write(6,9003) tmax(1),tmax(2)
    endif
  enddo

! JRD More Time Accounting for mtxel_kernel

  routnam(61)='MTXEL Setup:'
  routnam(62)='MTXEL Vcoul:'
  routnam(63)='MTXEL W:'
  routnam(64)='MTXEL W-Sum:'
  routnam(65)='MTXEL FFT Dir:'
  routnam(66)='MTXEL High G:'
  routnam(67)='MTXEL FFT X:'
  routnam(68)='MTXEL BSEX:'
  routnam(69)='MTXEL INDEX:'
  routnam(70)='MTXEL EPSHEAD:'
  routnam(71)='MTXEL EPSREAD:'
  routnam(72)='MTXEL EPSOPEN:'
  routnam(73)='MTXEL G SUM:'
  routnam(74)='MTXEL COMM:'
  routnam(75)='BSEWRITE COMM:'
  routnam(76)='BSEWRITE I/O:'
  
  do ii=61,76
    call timacc(ii,3,tsec,ncount)
#ifdef MPI
    call MPI_Reduce(tsec,tmin,2,MPI_REAL_DP,MPI_MIN,0,MPI_COMM_WORLD,mpierr)
    call MPI_Reduce(tsec,tmax,2,MPI_REAL_DP,MPI_MAX,0,MPI_COMM_WORLD,mpierr)
#else
    tmin=tsec
    tmax=tsec
#endif
    if(peinf%inode.eq.0) then
      write(6,9001) routnam(ii),tmin(1),tmin(2),ncount
      write(6,9002) tsec(1),tsec(2)
      write(6,9003) tmax(1),tmax(2)
    endif
  enddo

  routnam(30)='MTXEL FFT CC:'
  routnam(31)='MTXEL FFT VV:'
  routnam(32)='MTXEL FIND:'
  routnam(33)='MTXEL ALLOC:'
  routnam(34)='MTXEL FFTBOX:'
  routnam(35)='MTXEL FFT VC:'

  do ii=30,35
    call timacc(ii,3,tsec,ncount)
#ifdef MPI
    call MPI_Reduce(tsec,tmin,2,MPI_REAL_DP,MPI_MIN,0,MPI_COMM_WORLD,mpierr)
    call MPI_Reduce(tsec,tmax,2,MPI_REAL_DP,MPI_MAX,0,MPI_COMM_WORLD,mpierr)
#else
    tmin=tsec
    tmax=tsec
#endif
    if(peinf%inode.eq.0) then
      write(6,9001) routnam(ii),tmin(1),tmin(2),ncount
      write(6,9002) tsec(1),tsec(2)
      write(6,9003) tmax(1),tmax(2)
    endif
  enddo
  
  if(peinf%inode.eq.0) write(6,*)
  
  call timacc(1,3,tsec,ncount)
#ifdef MPI
  call MPI_Reduce(tsec,tmin,2,MPI_REAL_DP,MPI_MIN,0,MPI_COMM_WORLD,mpierr)
  call MPI_Reduce(tsec,tmax,2,MPI_REAL_DP,MPI_MAX,0,MPI_COMM_WORLD,mpierr)
#else
  tmin=tsec
  tmax=tsec
#endif
  
  if(peinf%inode.eq.0) then
    write(6,9004) routnam(1),tmin(1),tmin(2)
    write(6,9002) tsec(1),tsec(2)
    write(6,9003) tmax(1),tmax(2)
    write(6,*)
  endif
  
9000 format(22x,a13,3x,a13,3x,a8)
9001 format(1x,a16,'(min.)',f13.3,3x,f13.3,3x,i8)
9002 format(  17x,'(PE 0)',f13.3,3x,f13.3)
9003 format(  17x,'(max.)',f13.3,3x,f13.3)
9004 format(1x,a16,'(min.)',f13.3,3x,f13.3)
  
  call write_memory_usage()

! Delete the intermediate working files

!  do ii = 0, peinf%npes-1
!    if (ii.eq.peinf%inode) then
!      call close_file(128+3*ii  , delete = .true.) ! files INT_VWFN_*
!      call close_file(128+3*ii+1, delete = .true.) ! files INT_CWFN_*
!    endif
!  enddo
  if (peinf%inode.eq.0 .and. xct%iwriteint .eq. 0) then
    do ii = 0, qg%nr-1
      if (ii.lt.10000) then
        write(filename,'(a,i4.4)') 'INT_EPS_',ii
      endif
      call open_file(128+ii,file=filename,form='unformatted',status='old')
      call close_file(128+ii, delete = .true.) ! files INT_EPS_*
    end do
  endif
  
#ifdef MPI
  call MPI_FINALIZE(mpierr)
#endif

end program kernel

!==============================================================================
!
!  test_delaunay_f        Originally by FHJ     Last Modified 12/04/2012 (FHJ)
!
!    A simple Fortran program that tests the BerkeleyGW bindings for Qhull.
!
!    This file is part of the BerkeleyGW package.
!
!==============================================================================

#include "f_defs.h"

program test_delaunay_f

  use global_m
  use tile_m
  implicit none

  integer ::  n_nei, dim_, npts, nrep
  integer :: ip, idim_, div, rem
  integer, allocatable ::  indices(:), base(:)
  real(DP), allocatable :: points(:,:), pt(:), coefs(:)
  logical :: show_coords = .true.;
  integer :: ierr
  
  PUSH_SUB(test_delaunay_f)

  !TODO: make this configurable!
  write(6,'(a)') "Testing libtile_qhull - Fortran bindings."
  nrep = 1000
  dim_ = 3
  n_nei = 8
  npts = n_nei ** dim_
  
  write(6,'(a,i1)') "Dimensions: ", dim_
  write(6,'(a,i6,a,i1)') "Mesh size : ",n_nei,"^",dim_
  SAFE_ALLOCATE(points, (dim_, npts))
  SAFE_ALLOCATE(base, (dim_))
  ! To work in arbitrary dimensions, we notice that we can assign each
  !axis a number = (# neighbors)^(axis number)
  base(dim_) = 1
  do idim_ = dim_-1, 1, -1
    base(idim_) = n_nei * base(idim_+1)
  enddo
  do ip = 1, npts
    rem = ip-1
    do idim_ = 1, dim_
      div = rem / base(idim_)
      points(idim_, ip) = div / dble(n_nei)
      rem = rem - div * base(idim_)
    enddo
  enddo
  SAFE_DEALLOCATE(base)

  if (show_coords) then
    write(6,'(/,a)') "Input coordinates:";
    do ip = 1, npts
      call print_vect(ip, points(:,ip), dim_)
    enddo
  endif

  SAFE_ALLOCATE(indices, (dim_+1))
  SAFE_ALLOCATE(coefs, (dim_+1))
  SAFE_ALLOCATE(pt, (dim_))
  pt(:) = 0
  pt(1) = 0.125d0
  pt(2) = 0.75d0
  write(6,'(/,a)') "Test coordinate:"
  call print_vect(0, pt, dim_)
  write(6,*)

  write(6,'(a)') "Calling init_delaunay."
  ierr = init_delaunay(points, npts, dim_)
  write(6,'(a,i8,a)') "Calling find_delaunay_simplex ", nrep, " times."
  do ip = 1, nrep
    ierr = find_delaunay_simplex(pt, indices, coefs)
  enddo
  write(6,'(a)') "Calling free_delaunay."
  ierr = free_delaunay()

  write(6,'(/,a)') "Found vertices:"
  do ip = 1, dim_+1
    call print_vect(indices(ip), points(:,indices(ip)), dim_)
  enddo
  write(6,'(/,a)',advance='no') "Coefficients: "
  call print_vect(-1, coefs, dim_+1)

  SAFE_DEALLOCATE(indices)
  SAFE_DEALLOCATE(coefs)
  SAFE_DEALLOCATE(pt)
  SAFE_DEALLOCATE(points)
  write(6,'(/,a)') "All Done!"

  POP_SUB(test_delaunay_f)

  contains

    subroutine print_vect(id, vec, dims)

      integer, intent(in) :: id
      real(DP), intent(in) :: vec(:)
      integer, intent(in) :: dims

      integer :: jdim_

      PUSH_SUB(print_vect)

      if (id>=0) write(6,'(1x,i4,1x)',advance='no') id
      do jdim_ = 1, dims
        write(6,'(f5.3,1x)',advance='no') vec(jdim_)
      enddo
      write(6,*)

      POP_SUB(print_vect)

    end subroutine print_vect

end program test_delaunay_f

#include "f_defs.h"

!*************************************************************************
Module AtomBasisMod
!*************************************************************************
! This module contains information on the atom basis.
! The Atoms portion contains information on the atoms in the basis, 
! mainly their type and position.
!*************************************************************************
! The module contains the public functions:
!    AtomBasisInit            reads information on atom positions and types
!                         allocates the space for the dynamic variables
!    AtomBasisDestroy         deallocates space for the dynamic variables
!*************************************************************************
! The module contains the type:
! AtomBasisT which contains the variables:
!    totalNumAtoms        total number of atoms in the unit cell
!    atomCart(k,n)        k-th component (in cartesian coordinates) of
!                         the position of the n-th atom, n = 1, .., totalNumAtoms
!    atomLat(k,n)         k-th component (in primitive lattice 
!                         coordinates) of the position of the n-th atom
!    speciesOfAtom(n)     The species number ( = 1, .., numSpecies) of the n-th atom
!    numSpecies           number of species of atoms
!    numAtomsOfSpecies(i) number of atoms of species i = 1, .., numSpecies in the unit cell
!    elementLabel(i)      chemical symbol for the atom species i
!    atomicNumber(i)      atomic number for the atom species i -- added by DAS
!*************************************************************************

  use SysParams,    only : double
  use push_pop_m
  implicit none

  type AtomBasisT  
    integer                      :: totalNumAtoms
    real(double),    pointer     :: atomCart(:,:)
    real(double),    pointer     :: atomLat(:,:)
    integer,         pointer     :: speciesOfAtom(:) 

    integer                      :: numSpecies   
    integer,         pointer     :: numAtomsOfSpecies(:) 
    character*4,     pointer     :: elementLabel(:)
    integer,         pointer     :: atomicNumber(:) ! added by DAS
  end type AtomBasisT


  integer, parameter           :: scaledByLatVec = 1
  integer, parameter           :: scaledCart = 2

  private scaledByLatVec
  private scaledCart

  contains

!*************************************************************************
  Subroutine AtomBasisInit( atomBasis, ndim, lattice, tagHandler )
!*************************************************************************

    use TagHandlerMod, only : FindTag, StringCompare, tagHandlerT
    use Sysparams,  only : one, twopi
    use LatticeMod,    only : LatticeT

    implicit none

    type( AtomBasisT ),  pointer :: atomBasis
    type( LatticeT ),    pointer :: lattice
    type( TagHandlerT ), pointer :: tagHandler
    integer, intent(in)  :: ndim

    integer       :: atomFormat ! Format for positions in input file  
    integer       :: i, j, error
    character(80) :: buff
    logical       :: default
    real(double), allocatable :: atomCoorTemp(:,:)

    PUSH_SUB(AtomBasisInit)

    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Read in the number of atomic species.  If there is no entry in the 
    ! input file or there is an error reading the number a default of 1 will
    ! be used.

    allocate(atomBasis, stat = error)

    if(error /= 0 ) stop 'Error, atomBasis allocation failed.'

    default = .True.
    call FindTag(tagHandler, 'NumberOfSpecies', error)

    if(error .eq. 0) then

    read(unit = tagHandler%fileno, fmt = '(I10)', iostat = error) atomBasis%numSpecies

      if(error .eq. 0) then

        print *, 'NumberOfSpecies ', atomBasis%numSpecies
        default = .False.

      end if
    end if

    if(default) then

      atomBasis%numSpecies = 1
      print *, 'Using default value of NumberOfSpecies  1.'

    end if
    ! numSpecies has been initialized.
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Allocate the space for the number of atoms for each element and the
    ! chemical label for each element.
    allocate(atomBasis%numAtomsOfSpecies(atomBasis%numSpecies), &
           & atomBasis%elementLabel(atomBasis%numSpecies), &
           & atomBasis%atomicNumber(atomBasis%numSpecies), stat = error)
    if(error /= 0) stop 'Error allocating atom space in AtomBasisInit.'
    ! Allocation succeeded.
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Read in the number of atoms for each element.  If number is not in
    ! the file or there is an error reading the program will halt.
    call FindTag( tagHandler, 'NumberOfAtoms', error)

    if(error .eq. 0) then

      read(unit = tagHandler%fileno, fmt ='(I10)', iostat = error) atomBasis%totalNumAtoms
      if(error /= 0) stop 'Error, couldn''t read NumberOfAtoms.'
      print *, 'NumberOfAtoms ', atomBasis%totalNumAtoms

    else

      stop 'Error, could not find the NumberOfAtoms.'

    end if
    ! totalNumAtoms initialized.
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Read in the Labels for each element.  If there is an error, or
    ! the labels are not in the input file then the program will exit.
    call FindTag( tagHandler, 'ChemicalSpeciesLabel', error)

    if(error .eq. 0) then

      read(unit = tagHandler%fileno, fmt = '(I10)') i

      print *, 'ChemicalSpeciesLabel '
      do i = 1, atomBasis%numSpecies

        read(unit = tagHandler%fileno, fmt = *, iostat = error) j, atomBasis%atomicNumber(i), atomBasis%elementLabel(i)
        if(error /= 0) stop 'Error reading ChemicalSpeciesLabel.'
        print *, j, ' ', atomBasis%atomicNumber(i), ' ', atomBasis%elementLabel(i)
        if(j /= i) stop 'Wrong order of ChemicalSpeciesLabel.'

      end do
    else

      stop 'Error, could not find ChemicalSpeciesLabel.'

    end if
    ! elementLabel has been initialized.
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! 1.  Allocate temporary space to store the atom coordinates before they
    ! are sorted into atomCart.  
    ! 2.  Then read in the atomic coordinates into the array atoms. 
    ! The format of the atom 
    ! coordinates in the input file is a set of ndim = numDimensions coordinates
    ! followed by an integer that refers to the place of the element label 
    ! in the list of labels in the input file.  
    ! 3.  Read 'AtomicCoordinatesFormat' and assign the integer atomFormat
    ! to treat the coordinates input file 
    ! 4.  If the coordinates are not in the input file or there is an
    ! error reading them the program will exit.  
    ! 5. atomCart atomLat are then allocated and the
    ! atomic coordinates are sorted and stored in them.

    allocate(atomCoorTemp(ndim, atomBasis%totalNumAtoms), &
           & atomBasis%speciesOfAtom(atomBasis%totalNumAtoms), stat = error)
    if(error /= 0) stop 'Error allocating atoms in AtomBasisInit.'
    
    call FindTag( tagHandler, 'AtomicCoordinatesFormat', error)
    
    default = .True.

    if(error .eq. 0) then

      read(unit = tagHandler%fileno, fmt = '(A80)', iostat = error) buff

      if(error .eq. 0) then

        if(StringCompare(buff, 'ScaledCartesian')) then

          atomFormat = scaledCart
          print *, 'AtomicCoordinatesFormat ScaledCartesian'
          default = .False.

        else if(StringCompare(buff, 'ScaledByLatticeVectors')) then

          atomFormat = scaledByLatVec
          print *, 'AtomicCoordinatesFormat ScaledByLatticeVectors'
          default = .False.

        end if
      end if
    end if

    if(default) then
      atomFormat = scaledByLatVec
      print *, 'Using default AtomicCoordinatesFormat ScaledByLatticeVectors'
    end if

    call FindTag( tagHandler, 'AtomicCoordinatesAndAtomicSpecies', error)
    atomBasis%numAtomsOfSpecies = 0

    if(error .eq. 0 .and. (atomFormat .ne. scaledByLatVec &
           & .or. atomFormat .ne. scaledCart)) then

      read(unit = tagHandler%fileno, fmt = '(I10)') i

      do i = 1, atomBasis%totalNumAtoms

        read( unit=tagHandler%fileno, fmt=*, iostat=error) atomCoorTemp(:,i), atomBasis%speciesOfAtom(i)

        if(error /= 0) stop 'Error reading AtomicCoord(Cart,Lat).'

        atomBasis%numAtomsOfSpecies(atomBasis%speciesOfAtom(i)) = &
                 & atomBasis%numAtomsOfSpecies(atomBasis%speciesOfAtom(i)) + 1

      end do

    else

      stop 'Error, could not find AtomicCoord(Cart,Lat).'

    end if

    allocate(atomBasis%atomCart(ndim, atomBasis%totalNumAtoms), &
           & atomBasis%atomLat(ndim, atomBasis%totalNumAtoms), &
           & stat = error)
    if(error /= 0) stop 'Error allocating atomCart in AtomBasisInit.'

    if(atomFormat .eq. scaledCart) then

      call AtomSort(atomBasis, atomBasis%atomCart, atomCoorTemp)
      atomBasis%atomCart = atomBasis%atomCart * lattice%latticeConst
      atomBasis%atomLat = matmul(transpose(lattice%bLatVec),atomBasis%atomCart) / twopi

      ! do i = 1, ndim
      !   do j = 1, totalNumAtoms
      !     atomLat(i,j) = sum(lattice%bLatVec(:,i) * atomCart(:,j)) / twopi
      !   end do
      ! end do

    else if(atomFormat .eq. scaledByLatVec) then

      call AtomSort(atomBasis, atomBasis%atomLat, atomCoorTemp)
      atomBasis%atomCart = matmul(lattice%aLatVec,atomBasis%atomLat)

      ! do i = 1, ndim
      !   do j = 1, totalNumAtoms
      !     atomCart(i,j) = sum(lattice%aLatVec(i,:) * atomLat(:,j))
      !   end do
      ! end do

    end if

    print *, 'AtomicCoordinatesAndAtomicSpecies'
    do i = 1, atomBasis%totalNumAtoms
      print *, atomCoorTemp(:,i), atomBasis%speciesOfAtom(i)
    end do
    ! atomCart and atomLat have been initialized.
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Deallocate temp space for reading in atomic coordinates.
    deallocate(atomCoorTemp, stat = error)
    if(error /= 0) stop 'Error deallocating in AtomBasisInit.'
    ! All temp space has been freed.
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    POP_SUB(AtomBasisInit)

  end Subroutine AtomBasisInit

!*************************************************************************
  Subroutine AtomBasisDestroy( atomBasis )
!*************************************************************************

!  Deallocate space for atomic positions and information

    implicit none

    type(AtomBasisT), pointer :: atomBasis
    integer :: error

    PUSH_SUB(AtomBasisDestroy)

    if( .not. associated( atomBasis )) stop 'Error: atomBasis not allocated.'
    deallocate(atomBasis%numAtomsOfSpecies, atomBasis%elementLabel, &
             & atomBasis%speciesOfAtom, atomBasis%atomicNumber, stat = error)
    if(error /= 0) stop 'Error deallocating numAtoms in AtomBasisDestroy.'

    deallocate(atomBasis%atomCart, atomBasis%atomLat, stat = error)
    if(error /= 0) stop 'Error deallocating atomCart in AtomBasisDestroy.'

    deallocate(atomBasis, stat = error)
    if(error /= 0) stop 'Error deallocating atomCart in AtomBasisDestroy.'

    nullify( atomBasis )

    POP_SUB(AtomBasisDestroy)

  end Subroutine AtomBasisDestroy

!*************************************************************************
  Subroutine AtomSort(atomBasis, atomCoor, atomCoorTemp)
!*************************************************************************

!  Sort atoms so that they are grouped by element

  implicit none
  type( atomBasisT ), pointer :: atomBasis
  real( double ),     pointer :: atomCoor(:,:)
  real( double ),     intent( in )  :: atomCoorTemp(:,:)
  integer :: i, j, k

    PUSH_SUB(AtomSort)
    
    k = 0

    do i = 1, atomBasis%numSpecies
      do j = 1, atomBasis%totalNumAtoms
        if(atomBasis%speciesOfAtom(j) .eq. i) then
          k = k + 1
          atomCoor(:, k) = atomCoorTemp(:, j)
        end if
      end do
    end do

    k = 0

    do i = 1, atomBasis%numSpecies
      do j = 1, atomBasis%numAtomsOfSpecies(i)
        k = k + 1
        atomBasis%speciesOfAtom(k) = i
      end do
    end do

    POP_SUB(AtomSort)

  end Subroutine AtomSort

!*************************************************************************
  Subroutine AtomsPrint( atomBasis )
!*************************************************************************

    implicit none
    type(AtomBasisT), pointer :: atomBasis
    integer :: i

    PUSH_SUB(AtomsPrint)

    print *, 'Atomic cartesian coordinates:'
      do i = 1, atomBasis%totalNumAtoms
        print *, atomBasis%atomCart(:,i),  &
          & atomBasis%elementLabel(atomBasis%speciesOfAtom(i))
      end do

    print *, 'Atomic lattice vector coordinates:'
      do i = 1, atomBasis%totalNumAtoms
        print *, atomBasis%atomLat(:,i), &
          & atomBasis%elementLabel(atomBasis%speciesOfAtom(i))
        end do

    POP_SUB(AtomsPrint)

  end Subroutine AtomsPrint

!*************************************************************************
  Subroutine XYZCoordPrint( atomBasis, ndim, lattice )
!*************************************************************************
  
!RMM    use DimensionsMod, only : DimensionsT
        use LatticeMod,    only : LatticeT

    use message_m
    implicit none

    type( AtomBasisT ), pointer :: atomBasis
!RMM    type( DimensionsT ), pointer :: dimensions
        type( LatticeT ),    pointer :: lattice
        integer, intent(in)  :: ndim
    integer :: i, k

    PUSH_SUB(XYZCoordPrint)

    call open_file(7, file = 'coord.xyz',status='replace')
    write(7, '(I4)') 10 * atomBasis%totalNumAtoms

    do k = 1, atomBasis%totalNumAtoms

      write(7, '(A2, I1)', advance = "no") &
         & atomBasis%elementLabel(atomBasis%speciesOfAtom(k)), k
      write(7, '(3F13.6)') atomBasis%atomCart(:,k)

    end do

    do i = 1, ndim

      do k = 1, atomBasis%totalNumAtoms

        write(7, '(A2, I1)', advance = "no") &
            & atomBasis%elementLabel(atomBasis%speciesOfAtom(k)), k
        write(7, '(3F13.6)') atomBasis%atomCart(:,k) + lattice%aLatVec(:,i)

      end do

      do k = 1, atomBasis%totalNumAtoms

        write(7, '(A2, I1)', advance = "no") &
            & atomBasis%elementLabel(atomBasis%speciesOfAtom(k)), k
        write(7, '(3F13.6)') atomBasis%atomCart(:,k) - lattice%aLatVec(:,i)

      end do
    end do

    call close_file(7)

    POP_SUB(XYZCoordPrint)

  end Subroutine XYZCoordPrint

end Module AtomBasisMod

!============================================================================
!
! Routines:
!
! (1) spinor_symmetries     Originally by BAB          Last Modified: 4/01/2014 (BAB)
!
!     Find the 2x2 matrix to rotate spinor components of wavefunctions,
!     given the integer rotation matrix in lattice coordinates.
!     This function must be called in all genwf files for spinor calculations.
!
!============================================================================

#include "f_defs.h"

module spinor_symmetries_m

  use global_m
  use misc_m

  implicit none

  private

  public :: spinor_symmetries, rot_axis_angle

contains

  subroutine spinor_symmetries(bvec, mtrx, umtrx, itqq)

    real(DP), intent(in) :: bvec(:,:) !< crystal%bvec (3, 3)
    integer, intent(in) :: mtrx(:,:)   !< rotation matrices (3, 3)
    complex(DPC), allocatable, intent(out) :: umtrx(:,:)   !< spinor rotation matrix (2, 2)
    integer, intent(in) :: itqq  !< symmetry index

    real(DP), allocatable :: axis(:)   !< rotation axis (3)
    real(DP) :: angle, cosa, sina, bvecinv(3,3)
    real(DP) :: mtrxtemp(3,3),det

    PUSH_SUB(spinor_symmetries)

    ! NOTE: mtrx usually has a third index, indicating symmetry type

    ! Check if identity
    SAFE_ALLOCATE(umtrx,(2,2))

    if (itqq.eq.1) then
      umtrx(1,1) = (1.0d0,0.0d0)
      umtrx(1,2) = (0.0d0,0.0d0)
      umtrx(2,1) = (0.0d0,0.0d0)
      umtrx(2,2) = (1.0d0,0.0d0)
      return
    endif

    ! calculate determinant of matrix mtrx

    ! for umtrx, improper rotations should be turned into proper rotations
    ! mtrxtemp = TRANSPOSE(mtrx)
    mtrxtemp = mtrx
    call compute_det(mtrxtemp,det)
    if (det.lt.TOL_Zero) then
      mtrxtemp = -mtrxtemp
    endif

    ! convert rotation matrix for lattice vectors to cartesian coordinates
    ! R_cart =  B_Transpose * R * (B_Transpose)_Inverse
    ! Note: bvec is already transposed

    call invert_matrix(bvec, bvecinv)

    mtrxtemp = MATMUL(bvec,(MATMUL(mtrxtemp,bvecinv)))

    ! get rotation axis and rotation angle

    SAFE_ALLOCATE(axis,(3))

    call rot_axis_angle(axis,angle,mtrxtemp)

    angle = 0.5*angle
    cosa = COS(angle)
    sina = SIN(angle)

    ! Note: this is actually the transpose of the usual U matrix, for use with genwf
    umtrx(1,1) = CMPLX(cosa,-axis(3)*sina)
    umtrx(2,1) = CMPLX(-axis(2)*sina,-axis(1)*sina)
    umtrx(1,2) = -conjg(umtrx(2,1))
    umtrx(2,2) = conjg(umtrx(1,1))

    POP_SUB(spinor_symmetries)
    return

  end subroutine spinor_symmetries

!===============================================================================

  !> Given a 3x3 orthogonal matrix, this routine gives the rotation axis and angle
  !!
  !! This algorithm is based on the publication
  !! F. Landis Markley, Journal of Guidance, Control, and Dynamics 31 (2008), p. 440

  subroutine rot_axis_angle(axis, angle, mtrx)

    real(DP), intent(in) :: mtrx(:,:)   !< rotation matrices (3, 3)
    real(DP), intent(out) :: axis(:) !< rotation axis (3)
    real(DP), intent(out) :: angle

    integer :: ind, ii, jj, indmax, cyclic(3)
    real(DP) :: tr, vecnorm, maxnorm, quat(4), xquat(4,4), normx(4)

    PUSH_SUB(rot_axis_angle)

    quat(:) = 0.0d0
    ! Ordering for quaternion:
    ! (axis(1) sin(angle/2), axis(2) sin(angle/2), axis(3) sin(angle/2), cos(angle/2))
    tr = 0.0d0
    do ind=1,3
      tr = tr + mtrx(ind,ind)
    enddo

    cyclic(1) = 2
    cyclic(2) = 3
    cyclic(3) = 1

    do ii=1,4
      do jj=1,4

        if (ii.eq.jj .and. jj.lt.4) then
          xquat(ii,jj) = 1 + 2*mtrx(ii,jj) - tr

        else if (ii.ne.jj .and. ii.lt.4 .and. jj.lt.4) then
          xquat(ii,jj) = mtrx(jj,ii) + mtrx(ii,jj)

        else if (ii.eq.jj .and. jj.eq.4) then
          xquat(ii,jj) = 1 + tr

        else if (ii.ne.jj .and. jj.eq.4) then
          xquat(ii,jj) = mtrx(6-cyclic(ii)-ii,cyclic(ii)) - mtrx(cyclic(ii),6-cyclic(ii)-ii)

        endif
      enddo
    enddo 

    do ii=1,4
      do jj=ii+1,4
        xquat(jj,ii) = xquat(ii,jj);
      enddo 
    enddo

    normx(:) = 0.0d0

    do ii=1,4
      do jj=1,4
        normx(ii) = normx(ii) + xquat(ii,jj)**2;
      enddo
      normx(ii) = sqrt(normx(ii));
    enddo

    ! Note that maxnorm is guaranteed to be at least 1.0d0
    maxnorm = 0.0d0
    indmax = 0
    do ii=1,4
      if (normx(ii) .gt. maxnorm) then
        maxnorm = normx(ii)
        indmax = ii
      endif
    enddo

    quat(:) = xquat(:,indmax)/maxnorm

    vecnorm = 0.0d0
    do ii=1,3
      vecnorm = vecnorm + quat(ii)**2
    enddo
    vecnorm = sqrt(vecnorm)

    angle = 2*atan2(vecnorm,quat(4))

    if (vecnorm.eq.0) then
      ! probably does not happen since unity matrix is treated separately
      axis(1) = 0.0d0
      axis(2) = 0.0d0
      axis(3) = 1.0d0
    else
      axis(:) = quat(1:3)/vecnorm
    endif

    POP_SUB(rot_axis_angle)
    return

  end subroutine rot_axis_angle

!===============================================================================

end module spinor_symmetries_m

!============================================================================
!
! Routines:
!
! (1) gmap          Originally by ?          Last Modified: 1/24/2011 (gsm)
!
!     Find the index array and phases needed to map G-vectors for a
!     wavefunction at one k-point to the corresponding wavefunction
!     at a symmetry-related k-point. This routine is flavorless.
!     In the real version, pass dphase. In complex, pass zphase.
!
!============================================================================

#include "f_defs.h"

module gmap_m

  use global_m
  use misc_m

  implicit none

  private

  public :: gmap

  interface gmap
    module procedure dgmap, zgmap
  end interface gmap

contains

subroutine dgmap(gvec, syms, ngk, itran, kgq, isortc, isorti, ind, phase, die_outside_sphere)
  type (gspace), intent(in) :: gvec         !< uses gvec%components(:,isrtc(1:ngk)), and index_vec
  type (symmetry), intent(in) :: syms       !< uses syms%mtrx(:,:,itran) & syms%tnp(:,itran)
  integer, intent(in) :: ngk                !< number of g-vector entries in a wavefunction
  integer, intent(in) :: itran              !< index of transformation
  integer, intent(in) :: kgq(3)             !< an umklapp vector (i.e. integer 3-vector)
  integer, intent(in) :: isortc(:)          !< index array for R(q) (1:ngk)
  integer, intent(in) :: isorti(:)          !< inverse index array for q (1:gvec%ng)
  integer, intent(out) :: ind(:)            !< indices for the vectors inv(symm(itran))*(g+kgq) (ngk)
  real(DP), intent(out) :: phase(:)         !< exp(-i*(g+kgq).dot.syms%tnp(itran)) (ngk)
  logical, intent(in) :: die_outside_sphere !< specifies whether to die if G-vectors are falling outside of the sphere

  PUSH_SUB(dgmap)

  call gmap_base(gvec, syms, ngk, itran, kgq, isortc, isorti, ind, die_outside_sphere, dphase = phase)

  POP_SUB(dgmap)
  return
end subroutine dgmap

!===============================================================================

subroutine zgmap(gvec, syms, ngk, itran, kgq, isortc, isorti, ind, phase, die_outside_sphere)
  type (gspace), intent(in) :: gvec         !< uses gvec%components(:,isrtc(1:ngk)), and index_vec
  type (symmetry), intent(in) :: syms       !< uses syms%mtrx(:,:,itran) & syms%tnp(:,itran)
  integer, intent(in) :: ngk                !< number of g-vector entries in a wavefunction
  integer, intent(in) :: itran              !< index of transformation
  integer, intent(in) :: kgq(3)             !< an umklapp vector (i.e. integer 3-vector)
  integer, intent(in) :: isortc(:)          !< index array for R(q) (1:ngk)
  integer, intent(in) :: isorti(:)          !< inverse index array for q (1:gvec%ng)
  integer, intent(out) :: ind(:)            !< indices for the vectors inv(symm(itran))*(g+kgq) (ngk)
  complex(DPC), intent(out) :: phase(:)     !< exp(-i*(g+kgq).dot.syms%tnp(itran)) (ngk)
  logical, intent(in) :: die_outside_sphere !< specifies whether to die if G-vectors are falling outside of the sphere

  PUSH_SUB(zgmap)

  call gmap_base(gvec, syms, ngk, itran, kgq, isortc, isorti, ind, die_outside_sphere, zphase = phase)

  POP_SUB(zgmap)
  return
end subroutine zgmap

!===============================================================================

subroutine gmap_base(gvec, syms, ngk, itran, kgq, isortc, isorti, ind, die_outside_sphere, dphase, zphase)
  type (gspace), intent(in) :: gvec         !< uses gvec%components(:,isrtc(1:ngk)), and index_vec
  type (symmetry), intent(in) :: syms       !< uses syms%mtrx(:,:,itran) & syms%tnp(:,itran)
  integer, intent(in) :: ngk                !< number of g-vector entries in a wavefunction
  integer, intent(in) :: itran              !< index of transformation
  integer, intent(in) :: kgq(3)             !< an umklapp vector (i.e. integer 3-vector)
  integer, intent(in) :: isortc(:)          !< index array for R(q) (1:ngk)
  integer, intent(in) :: isorti(:)          !< inverse index array for q (1:gvec%ng)
  integer, intent(out) :: ind(:)            !< indices for the vectors inv(symm(itran))*(g+kgq) (ngk)
  logical, intent(in) :: die_outside_sphere !< specifies whether to die if G-vectors are falling outside of the sphere
  real(DP),     optional, intent(out) :: dphase(:) !< exp(-i*(g+kgq).dot.syms%tnp(itran)) (ngk)
  complex(DPC), optional, intent(out) :: zphase(:) !< exp(-i*(g+kgq).dot.syms%tnp(itran)) (ngk)

  integer :: ig, kd(3), kadd, kgrad, kgrad1
  integer :: kg(3), kgr(3), mtrxi(3,3), nout, nin
  real(DP) :: fi
  
  PUSH_SUB(gmap_base)

  if(present(dphase) .and. present(zphase)) then
    call die("gmap: cannot pass both dphase and zphase")
  else if(.not. present(dphase) .and. .not. present(zphase)) then
    call die("gmap: must pass either dphase or zphase")
  endif

  if(ngk > gvec%ng) call die("gmap: ngk (wfn cutoff) is greater than gvec%ng (rho cutoff)")

  if(ubound(isorti, 1) < gvec%ng)  call die("gmap: isorti size < gvec%ng")
!  if(any(isorti(1:gvec%ng) < 1))       call die("gmap: isorti cannot be less than 1.")
  if(any(isorti(1:gvec%ng) > gvec%ng)) call die("gmap: isorti cannot be greater than gvec%ng.")

  if(ubound(isortc, 1) < ngk)      call die("gmap: isortc size < ngk")
  if(any(isortc(1:ngk) < 1))       call die("gmap: isortc cannot be less than 1.")
  if(any(isortc(1:ngk) > gvec%ng)) call die("gmap: isortc cannot be greater than ng.")

  if(ubound(gvec%index_vec, 1) /= gvec%nFFTgridpts) call die("gmap: gvec%index_vec has wrong size")
  if(any(gvec%index_vec(1:gvec%nFFTgridpts) < 0)) call die("gmap: index_vec cannot be less than 0")
  if(any(gvec%index_vec(1:gvec%nFFTgridpts) > gvec%ng)) call die("gmap: index_vec cannot be greater than ng")

  if(present(dphase)) then
    if(ubound(dphase, 1) < ngk) call die("gmap: dphase size < ngk")
  else
    if(ubound(zphase, 1) < ngk) call die("gmap: zphase size < ngk")
  endif
  if(ubound(ind, 1) < ngk) call die("gmap: ind size < ngk")

! Invert rotation matrix that gives rq

  call invert_matrix_int(syms%mtrx(1:3, 1:3, itran), mtrxi(1:3, 1:3))

! JRD: Temporary Debugging

!      write(6,*) peinf%inode,'itran: ',itran
!      write(6,*) peinf%inode,'mtrxi: '
!      do i = 1, 3
!        write(6,*) peinf%inode,(mtrxi(i,j),j=1,3)
!      enddo
!      write(6,*) peinf%inode,'kgq',kgq

! Loop over g-vectors in function of r(q)

  nout = 0  ! number of waves outside sphere
  nin = 0  ! number of waves inside sphere

  do ig = 1, ngk

! kg = g(ig) + kgq

    kg(1:3) = gvec%components(1:3, isortc(ig)) + kgq(1:3)

! kgr = (r**-1) kg

    kgr(1:3) = MATMUL(mtrxi(1:3, 1:3), kg(1:3))
    
! Compute address of kgr -> kgrad

    kd(1:3) = kgr(1:3) + gvec%FFTgrid(1:3) / 2 + 1
    if (any(kd(1:3) .lt. 1 .or. kd(1:3) .gt. gvec%FFTgrid(1:3))) then
      call die('gmap: kd out of bounds')
    endif
    kadd = ((kd(1) - 1) * gvec%FFTgrid(2) + kd(2) - 1) * gvec%FFTgrid(3) + kd(3)
    kgrad1 = gvec%index_vec(kadd) ! index_vec relate cube and sphere
    if (kgrad1 .lt. 1 .or. kgrad1 .gt. gvec%ng) then
      write(0,*) 'itran = ', itran, 'ig = ', ig, ', kadd = ', kadd, ', kgrad1 = ', kgrad1
      call die('gmap: G-vectors falling outside of the charge-density G-sphere')
    endif
    kgrad = isorti(kgrad1)

! SIB: if kgr is outside the sphere, then increment out counter,
! set its phase to zero, and its ind() entry to the maximum.
    if (kgrad .gt. ngk) then ! outside sphere
      nout = nout + 1
      ind(ig) = ngk
      if(present(zphase)) then
        zphase(ig) = CMPLX(0d0, 0d0)
      else
        dphase(ig) = 0d0
      endif
!    else if (kgrad <  1) then ! inside sphere
!      nin = nin + 1
!      ind(ig) = 1
!      if(present(zphase)) then
!        zphase(ig) = CMPLX(0d0, 0d0)
!      else
!        dphase(ig) = 0d0
!      endif
    else
! SIB:  Otherwise, record the index of kgr (kgrad) into ind(ig)
! and compute the phase = exp(-i*kg.dot.syms%tnp(:,itran))
      ind(ig) = kgrad
      fi = dot_product(dble(kg(:)), syms%tnp(:,itran))

      if(present(zphase)) then
        zphase(ig) = CMPLX(cos(fi), -sin(fi))
      else

! DAS: The imaginary part can be thrown away because it is always zero
! if we have inversion and time-reversal symmetries, and so can use the real version.
! phase = +/- 1. Otherwise the wavefunction would not be normalized.
! c(G) -> c(G) e^iGt with fractional translation.
! c(G) e^iGt = c(-G)* e^-iGt by time-reversal symmetry
!  = c(G)* e^-iGt by inversion symmetry. c(G) = c(G)* since real.
! Therefore e^iGt = e^-iGt. e^iGt is real, and hence 1 or -1.
! Note there is also a global phase e^ikt, but it is just a convention
! and can be safely ignored here.

        dphase(ig) = cos(fi)

        if(abs(abs(dphase(ig)) - 1) .gt. TOL_Small) then
          write(0,'(a,i8,a,f12.8,a)') 'phase(', ig, ') = ', dphase(ig), ' != +/- 1'
          call die("Illegal non-unity phase in gmap, error in fractional translation.")
        endif
        if(abs(sin(fi)) .gt. TOL_Small) then
          write(0,'(a,i8,a,f12.8)') 'Im phase(', ig, ') = ', -sin(fi)
          call die("Illegal complex phase in gmap, error in fractional translation.")
        endif
      endif
    endif
  enddo !end loop over g-vectors (ig)

  if (die_outside_sphere .and. nout .gt. 0) then
    call die('G-vectors are falling outside of the sphere in gmap')
  endif

!  if (die_outside_sphere .and. nin .gt. 0) then
!    call die('G-vectors are falling inside of the sphere in gmap')
!  endif

  POP_SUB(gmap_base)

  return
  end subroutine gmap_base

!===============================================================================

end module gmap_m

!===============================================================================
!
! subsample_plan       Originally By FHJ       Last Modified 07/27/2014 (FHJ)
!
!
! Given a WFN file, automatically finds the radial subsampling q-points, their
! weights, and the k-points associated to a WFNq file. The final WFNq file,
! along with WFN, can be used in Epsilon to generate the subsampled eps0mat file.
!
! TODO:
! - Support HDF5
!
!===============================================================================

#include "f_defs.h"

program subsample_plan

  use global_m
  use wfn_rho_vxc_io_m
  use random_m
  use irrbz_m
  use fullbz_m
  use checkbz_m
  implicit none

  integer :: narg
  character(len=256) :: fname_wfn, tmpstr
  character(len=5) file_fmt

  real(DP) :: dq(3), dq_abs, qmax, bdot(3,3), ee(3), ee_abs, dq_cur
  real(DP) :: qq(3), qq_min(3), qq_tmp(3), len_min, len_tmp
  real(DP), allocatable  :: qran(:,:), qlen(:), qq_abs(:)
  real(DP) :: dq_abs_min, dq_abs_max, weight
  integer :: nn, degree
  integer :: i1, i2, i3, iq, nq, ii, ni(3)
  type(mf_header_t) :: mf
  logical :: auto_mode, skip_checkbz
  logical, allocatable :: cond(:)
  type(grid) :: gr
  
  PUSH_SUB(subsample_plan)

  narg = iargc()
  if (narg/=3.and.narg/=6.and.narg/=7) then
    write(0,*) 'Usage: subsample_plan.x ASCII|BIN|HDF5 WFN nq [e1 e2 e3] [degree]'
    write(0,*)
    write(0,*) 'Required arguments:'
    write(0,*) '  ASCII|BIN|HDF5: format of the WFN file'
    write(0,*) '  WFN: WFN file to used in the Epsilon/Sigma calculation'
    write(0,*) '  nq: number of radial subsampled q-points'
    write(0,*)
    write(0,*) 'Optional arguments:'
    write(0,*) '  e1, e2, e3: direction of the shift in crystal coords (defaults to 1 0 0)'
    write(0,*) '  degree: the radial intervals are define by dq(i) = dq0 * i^{degree};'
    write(0,*) '          valid options are 0, 1 and 2 (default is 1)'
    stop
  endif
  call getarg(1, file_fmt)
  call getarg(2, fname_wfn)
  call getarg(3, tmpstr)
  read(tmpstr,*) nq
  degree = 1
  auto_mode = .true.
  if (narg>3) then
    call getarg(4, tmpstr)
    read(tmpstr,*) ee(1)
    call getarg(5, tmpstr)
    read(tmpstr,*) ee(2)
    call getarg(6, tmpstr)
    read(tmpstr,*) ee(3)
    auto_mode = .false.
  endif
  if (narg==7) then
    call getarg(6, tmpstr)
    read(tmpstr,*) degree
  endif
  if (file_fmt=='ASCII') then
    call open_file(unit=11, file=TRIM(fname_wfn), form='formatted', status='old')
    call read_mf_header(11, mf)
    call close_file(11)
  elseif (file_fmt=='BIN  ') then
    call open_file(unit=11, file=TRIM(fname_wfn), form='unformatted', status='old')
    call read_mf_header(11, mf)
    call close_file(11)
  elseif (file_fmt=='HDF5 ') then
    call die('not implemented')
    call read_mf_header(11, mf)
  else
    call die('Unknown format "'//TRIM(file_fmt)//'". Must be either ASCII, BIN or HDF5.')
  endif
  write(6,'(a,3(1x,i0))') 'Read k-grid:', mf%kp%kgrid

  if (auto_mode) then
    ee(:) = 0d0
    do ii=1,3
      if (mf%kp%kgrid(ii)>1) then
        ee(ii) = 1d0
        exit
      endif
    enddo
    if (all(ee==0d0)) then
      call die('There must be at least one periodic direction.')
    endif
  endif ! auto_mode
  write(6,'(a,3(1x,f5.3))') 'Shifting in direction:', ee
  write(6,*)

  ! FHJ: sample Voronoi cell
  nn = 10000000
  write(6,'(a,i0,a)') 'Sampling q=0 Voronoi cell stocastically with ', nn, ' points.'
  SAFE_ALLOCATE(qran, (3,nn))
  SAFE_ALLOCATE(qlen, (nn))
  call genrand_init(put=5000)
  do iq = 1, nn
    do ii = 1, 3
      call genrand_real4(qran(ii, iq))
    enddo
  enddo
  do ii = 1, 3
    if (mf%kp%kgrid(ii)==1d0) qran(ii,:) = 0d0
  enddo

  ni(:) = 1
  where (mf%kp%kgrid==1d0)
    ni(:) = 0
  endwhere

  do ii = 1, 3
    bdot(:,ii) = mf%crys%bdot(:,ii)/mf%kp%kgrid(ii)
  enddo
  do ii = 1, 3
    bdot(ii,:) = bdot(ii,:)/mf%kp%kgrid(ii)
  enddo
  do iq = 1, nn
    len_min = INF
    qq(:) = qran(:,iq)
    do i1 = -ni(1), ni(1)
      qq_tmp(1) = qq(1) - i1
      do i2 = -ni(2), ni(2)
        qq_tmp(2) = qq(2) - i2
        do i3 = -ni(3), ni(3)
          qq_tmp(3) = qq(3) - i3
          len_tmp = DOT_PRODUCT(qq_tmp,MATMUL(bdot,qq_tmp))
          if (len_tmp<len_min) then
            len_min = len_tmp
            qq_min(:) = qq_tmp(:)
          endif
        enddo
      enddo
    enddo
    qlen(iq) = sqrt(len_min)
    qran(1:3,iq) = qq_min(1:3)
  enddo ! iq
  qmax = maxval(qlen)
  write(6,'(2x,a,es12.6,a)') 'Maximum |q| in Voronoi cell = ', qmax,' 1/bohr'

  ! We want to bin the random q-points radially and find the appropriate weights
  ! |           *           |           *        ...        |
  ! 0           dq         2dq         3dq          (2nq)dq = qmax
  ! 
  ! where: * is a point where we`ll calculated epsinv(q)
  !        | is the boundary of each interval
  SAFE_ALLOCATE(qq_abs, (nq))
  degree = 1
  if (degree==0) then
    ! sum_(i=1)^n i^0 = n 
    dq_abs = qmax/(2d0*nq)
  elseif (degree==1) then
    ! sum_(i=1)^n i^1 = 1/2 n (n+1)
    dq_abs = qmax/(nq*(nq+1d0))
  elseif (degree==2) then
    ! sum_(i=1)^n i^2 = 1/6 n (n+1) (2 n+1)
    dq_abs = 3d0*qmax/(nq*(nq+1d0)*(2d0*nq+1d0))
  else
    call die('Unsupported degree.')
  endif

  ee_abs = sqrt(DOT_PRODUCT(ee,MATMUL(mf%crys%bdot,ee)))
  dq = ee/ee_abs * dq_abs
  write(6,'(2x,a,3(1x,es22.15),a)') 'dq = ', dq, ' (crystal units)'
  write(6,'(2x,a,1x,es22.15,1x,a)') '|dq| = ', dq_abs, ' 1/bohr'
  write(6,*)

  write(6,'(a,a)') 'Determining q0 weights.'
  SAFE_ALLOCATE(cond, (nn))
  dq_abs_min = 0d0
  call open_file(unit=13, file='subweights.dat', form='formatted', status='replace')
  write(13,'(i0)') nq
  do iq=1,nq
    dq_cur = 2d0*dq_abs*(iq**degree)
    dq_abs_max = dq_abs_min + dq_cur
    cond = qlen>=dq_abs_min.and.qlen<dq_abs_max
    weight = count(cond)
    qq_abs(iq) = dq_abs_min + 0.5d0*dq_cur
    write(6,'(2x,3(a,es12.6,2x))') '|q| = ', qq_abs(iq), 'weight = ', weight
    write(13,'(2(es12.6,2x))') weight, qq_abs(iq)
    dq_abs_min = dq_abs_max
  enddo
  SAFE_DEALLOCATE(cond)
  call close_file(13)
  write(6,'(2x,2a)') 'Wrote q0 weights to subweights.dat'

  call open_file(unit=13, file='epsilon_q0s.inp', form='formatted', status='replace')
  write(13,*)
  write(13,'(a)') 'subsample'
  write(13,'(a,i0)') 'number_qpoints ', nq
  write(13,'(a)') 'begin qpoints'
  do iq = 1, nq
    write(13,'(3(es22.15,1x),a)') qq_abs(iq)/dq_abs*dq, '1 1'
  enddo
  write(13,'(a)') 'end'
  write(13,*)
  call close_file(13)
  write(6,'(2x,a)') 'Wrote lines for epsilon.inp in epsilon_q0s.inp'
  write(6,*)

  write (6,'(a)') 'Generating k-points for WFNq file(s)'
  ! FHJ: Use symmetries to unfold BZ from WFN
  gr%nr = mf%kp%nrk
  SAFE_ALLOCATE(gr%r, (3, gr%nr))
  gr%r = mf%kp%rk
  call fullbz(mf%crys, mf%syms, gr, mf%syms%ntran, skip_checkbz, wigner_seitz=.false., paranoid=.true.)
  if (.not.skip_checkbz) call checkbz(gr%nf, gr%f, mf%kp%kgrid, mf%kp%shift, &
    mf%crys%bdot, TRUNC(fname_wfn), 'k', .false., .false., .false.)
  ! FHJ: Find subgroup that leaves dq invariant
  call subgrp(dq, mf%syms)
  ! FHJ: For each dq, displace k-points by dq and use symmetries in the
  ! subgroup to fold the k-points
  do ii=0,nq
    call gen_kpoints_file(ii)
  enddo
  write(6,*)

  POP_SUB(subsample_plan)

  contains

    subroutine gen_kpoints_file(iq_in)
      integer, intent(in) :: iq_in

      real(DP), allocatable :: kpts_new(:,:)
      integer :: nk_new, nk_fold, iq_min, iq_max, ik
      integer, allocatable :: neq(:), indrk(:)
      character(len=64) :: fname_kpts

      POP_SUB(subsample_plan.gen_kpoints_file)

      if (iq_in>0) then
        nk_new = gr%nf
        iq_min = iq_in
        iq_max = iq_in
        write(fname_kpts,'(a,i3.3,a)') 'kpoints_', iq_in, '.dat'
      else
        nk_new = gr%nf*nq
        iq_min = 1
        iq_max = nq
        fname_kpts = 'kpoints_all.dat'
      endif

      SAFE_ALLOCATE(kpts_new, (3,nk_new))
      SAFE_ALLOCATE(indrk, (nk_new))
      SAFE_ALLOCATE(neq, (nk_new))
      nk_new = 0
      do iq=iq_min,iq_max
        qq = qq_abs(iq)/dq_abs*dq
        forall(ik=1:gr%nf) kpts_new(1:3, nk_new+ik) = gr%f(1:3, ik) + qq(1:3)
        nk_new = nk_new + gr%nf
      enddo
      call irrbz(mf%syms, nk_new, kpts_new, nk_fold, neq, indrk)

      call open_file(unit=13, file=TRUNC(fname_kpts), form='formatted', status='replace')
      write(13,'(a)') 'K_POINTS crystal'
      write(13,'(i0)') nk_fold
      do iq=1, nk_fold
        write(13, '(3(f13.9),f6.1)') kpts_new(:,indrk(iq)), dble(neq(iq))
      enddo
      call close_file(13)
      write(6,'(2x,2a)') 'Wrote kpoints to ', TRUNC(fname_kpts)

      SAFE_DEALLOCATE(kpts_new)
      SAFE_DEALLOCATE(neq)
      SAFE_DEALLOCATE(indrk)

      PUSH_SUB(subsample_plan.gen_kpoints_file)

    end subroutine gen_kpoints_file

end program subsample_plan

!-------------------------------------------------------------------------------
!
!     The primitive iolib modules
!
!     The following integer markers have been used:
!
!     Int      Object:
!
!       1      gspace (not the parallel one)
!       2      isrt arrays
!       3      wave functions
!       4      kpoint
!       5      level
!       6      bands
!       7      crystal structure
!       8      symmetry info
!
!     If you add a new one, make sure you update iolib_skip()
!     in iolib_m
!
!-------------------------------------------------------------------------------

#include "f_defs.h"

module iolib_m

  use global_m
  implicit none

contains  

  !
  !     =============== generic routine to find certain marker ===========
  !
  subroutine iolib_find_marker(imark, iunit, info)
    !
    !     INPUT:
    !
    integer, intent(in) :: imark, &    ! integer marker
         iunit                         ! the unit to be browsed
    !
    !     OUTPUT:
    !
    integer, intent(out) :: info       ! 1 if marker found, 0 otherwise
    !
    !     ------------- local variables
    !
    integer :: marker, ierr, iostat

    PUSH_SUB(iolib_find_marker)

    rewind(iunit)  
    !      write(0,*) 'searching for marker:', imark
    do while (.true.)  
       read(iunit, *, iostat=iostat) marker  
       if(iostat < 0) exit
       !         write(0,*) 'found marker:', marker
       ! found the right object
       if (marker == imark) then  
          info = 1  
          exit
       else  
          ! found other object. skip
          call iolib_skip(iunit, marker, ierr)  
          if (ierr /= 0) then
            info = 0
            exit
          endif
       end if
    end do

    POP_SUB(iolib_find_marker)

    return  

  end subroutine iolib_find_marker
  !
  !     ============= routine to skip an object. has to be updated =======
  !
  !
  !
  !
  subroutine iolib_skip(iunit, imark, ierr)
    !
    !     INPUT:
    !
    integer, intent(in) :: iunit, &    ! the io unit to be used
         imark                   ! the marker code of the object to be skipped
    !
    !     OUTPUT:
    !
    integer, intent(out) :: ierr  ! error code. if error, then 1. Zero otherwise
    !
    !     ------- local variables
    !
    integer :: i, iostat
    !
    !     take whatever action is necessary to skip the object
    !

    PUSH_SUB(iolib_skip)

    select case(imark)  
    case default  
       write(0, *) 'iolib: illegal marker: ', imark  
       call die('the linked iolib probably not up to date')
    case(1)  
       ! ------ how to skip object 1
       read(iunit, *, iostat=iostat)
       read(iunit, *, iostat=iostat)
       read(iunit, *, iostat=iostat)  
       read(iunit, *, iostat=iostat)  
       read(iunit, *, iostat=iostat)  
       read(iunit, *, iostat=iostat)  
       read(iunit, *, iostat=iostat)  
       read(iunit, *, iostat=iostat)  
    case(2)  
       ! ------ how to skip object 2
       do i = 1, 4  
          read(iunit, *, iostat=iostat)  
       end do
    case(3)  
       ! ------ how to skip object 3
       do i = 1, 7  
          read(iunit, *, iostat=iostat)  
       end do
    case(4)  
       ! ------ how to skip object 4
       do i = 1, 10  
          read(iunit, *, iostat=iostat)  
       end do
    case(5)  
       ! ------ how to skip object 5
       do i = 1, 10  
          read(iunit, *, iostat=iostat)  
       end do
    case(6)  
       ! ------ how to skip object 6
       do i = 1, 6  
          read(iunit, *, iostat=iostat)  
       end do
    case(7)  
       ! ------ how to skip object 7
       do i = 1, 11  
          read(iunit, *, iostat=iostat)  
       end do
    case(8)  
       ! ------ how to skip object 8
       do i = 1, 5  
          read(iunit, *, iostat=iostat)  
       end do
    end select

    ierr = iostat

    POP_SUB(iolib_skip)
    return  

  end subroutine iolib_skip

end module iolib_m

#include "f_defs.h"

!*************************************************************************
Module cgParamsMod
!*************************************************************************

  use sysparams, only : double
  use push_pop_m

  use TagHandlerMod

  Type cgParamsT
     integer          :: period,switch
     real(double)     :: tol
  end Type cgParamsT

  contains

!*************************************************************************
  Subroutine cgParamsInit(Params,TagHandler)
!*************************************************************************

    type(TagHandlerT), pointer :: TagHandler
    type(cgParamsT) :: Params    
    
    integer :: error,error1
    logical :: default

    PUSH_SUB(cgParamsInit)
    
    ! Fill in the tolerance in Params%tol
    default = .True.
    Call FindTag(TagHandler,'CGTolerance',error1)
    if(error1.eq.0) then
       read(unit=tagHandler%fileno, fmt = *, iostat=error ) & 
            & Params%tol
       if(error.eq.0 .and. Params%tol.ne.0 ) default = .False.
    end if
    if(default) then
       Params%tol = 1.d-5
       print *, 'Using the default value of CGTolerance',Params%tol
    end if

    ! Fill in the tolerance in Params%switch
    default = .True.
    Call FindTag(TagHandler,'DiagonalizationSwitch',error1)
    if(error1.eq.0) then
       read(unit=tagHandler%fileno, fmt = '(I10)', iostat=error ) & 
            & Params%Switch
       if(error.eq.0 .and. Params%Switch.le.2) &
            & default = .False.
    end if
    if(default) then
       Params%Switch = 0
       print *, 'Using the Lapack routine for Diagonalisation'
    end if

    if(Params%Switch.eq.1) then

       ! Fill in the tolerance in Params%period
       default = .True.
       Call FindTag(TagHandler,'CGIterationPeriod',error1)
       if(error1.eq.0) then
          read(unit=tagHandler%fileno, fmt = '(I10)', iostat=error ) & 
               & Params%period
          if(error.eq.0 .and. Params%period.gt.0 ) default = .False.
       end if
       if(default) then
          Params%period = 3
          print *, 'Using the default value of CGIterationPeriod',Params%period
       end if

       ! These parameters are never used. Why were they here?? --DAS
       ! Fill in the preconditioning in Params%precond
!       default = .True.
!       Call FindTag(TagHandler,'CGPreConditioner',error1)
!       if(error1.eq.0) then
!          read(unit=tagHandler%fileno, fmt = '(I10)', iostat=error ) & 
!               & Params%precond
!          if(error.eq.0 .and. (Params%precond.eq.0 .or. Params%precond.eq.1)) default = .False.
!       end if
!       if(default) then
!          Params%precond = 0
!          print *, 'Using the default Preconditioner',Params%precond
!       end if

       ! Fill in the convergence switch in Params%conv
!       default = .True.
!       Call FindTag(TagHandler,'CGConvergenceSwitch',error1)
!       if(error1.eq.0) then
!          read(unit=tagHandler%fileno, fmt = '(I10)', iostat=error ) & 
!               & Params%conv
!          if(error.eq.0 .and. (Params%conv.eq.0 .or. Params%conv.eq.1)) default = .False.
!       end if
!       if(default) then
!          Params%conv = 0
!          print *, 'Not testing for convergence'
!       end if

    end if

    POP_SUB(cgParamsInit)

  end Subroutine cgParamsInit

end Module cgParamsMod

!===============================================================================
!
! Routines:
!
! (1) diag main         Originally by MLT       Last Edited: 5/12/2008 (JRD)
!
!     For more details see the README_absorption file.
!
!     Calculates the real and imaginary parts of the macroscopic dielectric
!     function starting from interaction matrix elements calculated by
!     the Kernel code. It uses interpolation in the matrix elements and
!     direct diagonalization of the Bethe-Salpeter equation.
!     Spin-polarized case implemented.
!
!     For more details, see:
!     Rohlfing & Louie, PRB 62:(8), 4927 (2000)
!     G. Strinati, Rivista del Nuovo Cimento 11:(12), 1 (1988)
!
!     Please report bugs to: jdeslip@civet.berkeley.edu
!     
!================================================================================

#include "f_defs.h"

subroutine diag(eqp,xct,flag,neig)

  use global_m
  use fullbz_m
  use genwf_m
  use intkernel_m
  use intwfn_m
  use misc_m
  use mtxel_optical_m
  implicit none

  type (eqpinfo), intent(inout) :: eqp
  type (xctinfo), intent(inout) :: xct
  type (flags), intent(inout) :: flag
  integer, intent(inout) :: neig

  type (crystal) :: crys
  type (symmetry) :: syms
  type (gspace) :: gvec
  type (grid) :: kg_fi, kgq_fi
  type (kpoints) :: kp_fi, kpq_fi
  type (wavefunction) :: wfnc_fi
  type (wavefunction) :: wfnvq_fi
  type (work_genwf) :: work, workq
  type (int_wavefunction) :: intwfnc
  type (int_wavefunction) :: intwfnv

  character :: tmpstr*128,filename*20
  integer :: ii,jj,ncount,nmat,nblock,pblock
  integer :: ikb, icb, ivb
  integer :: ik,ikq,ikt,ikrq,ikcvs,ikcvsd,ic,iv,is
  integer :: iunit_c,iunit_v
  real(DP) :: vol,omega_plasma
  real(DP) :: tsec(2),tmin(2),tmax(2)
  
  character*16, allocatable :: routnam(:)
  integer, allocatable :: routsrt(:)
  integer, allocatable :: fi2co_wfn(:,:),indexq_fi(:)
  real(DP), allocatable :: egv(:), kco(:,:),cs(:),rdum(:)

  SCALAR, allocatable :: &
    dcc(:,:,:,:,:),dvv(:,:,:,:,:),s1(:),s1k(:,:,:),dummy(:), &
    egs(:,:),hqpcc(:,:,:),hqpvv(:,:,:),dipoles(:), &
    rdum2(:)
  !> (kcvs, k`c`v`s`), "A" block of BSE Hamiltonian
  SCALAR, allocatable :: hmtrx_A(:,:)
  !> (kcvs, k`c`v`s`), "B" block of BSE Hamiltonian, only if tda=.false.
  SCALAR, allocatable :: hmtrx_B(:,:)
  real(DP), allocatable :: intp_coefs(:,:)
  
  PUSH_SUB(diag)

! JRD: A Check for Finite Q

!      if (peinf%inode .eq. 0) then
!        write(6,*) 'nkpt_co = ', xct%nkpt_co
!      endif

  if(flag%vm.eq.2) then
    if (peinf%inode.eq.0) then
      write(0,*) 'WARNING: read_eps2_moments not supported in this diagonalization code. Ignoring keyword.'
    endif
    flag%vm=0
  endif
  
!--------------------------
! If eigenvalues.dat is available, read them and go straight to
! calculation of the absorption spectrum


  if (flag%spec.eq.1) then
    if (peinf%inode.eq.0) then
      call open_file(unit=14,file='eigenvalues.dat',form='formatted',status='old')
      read(14,'(10x,i8)') neig
      read(14,'(10x,e16.9)') vol
      read(14,'(10x,i8)') xct%nspin
      write(6,'(a,i8)') '# neig  = ', neig
      write(6,'(a,e16.9)') '# vol   = ', vol
      write(6,'(a,i8)') '# nspin = ', xct%nspin
      read(14,*)
      SAFE_ALLOCATE(cs, (neig))
      SAFE_ALLOCATE(egv, (neig))
      do ii=1,neig
        read(14,*) egv(ii),cs(ii)
      enddo
      call close_file(14)
    endif
    omega_plasma = 0.d0
    if (peinf%inode .eq. 0) then
      call absp(xct,neig,cs,egv,vol,omega_plasma,flag)
    endif
    if (xct%iabsorp0 .eq. 0) then
      if (peinf%inode .eq. 0) write(6,*) 'Create absorption_eh.dat from eigenvalues.dat'
      if (peinf%inode .eq. 0) write(6,*) 'If you want absorption_noeh.dat add the noeh_only flag'
      call diag_end()
      POP_SUB(diag)
      return
    endif
  endif
!--------------------------
! Read wavefunctions on the fine grid

  call logit('Calling input')
  call timacc(2,1)
  call input(crys,gvec,kg_fi,kp_fi,syms,eqp,xct,flag, &
    omega_plasma,.true.,intwfnc)
  
! If there is no specified number of eigenvalues, calculate
! all eigenvalues

  nmat = xct%nkpt_fi*xct%ncb_fi*xct%nvb_fi*xct%nspin
  if (neig.eq.0) neig = nmat
  if ((neig.gt.nmat).or.(neig.le.0)) then
    write(tmpstr,'(a,2i6)') 'Incomprehensible request of eigenvalues : ', neig, nmat
    call die(tmpstr, only_root_writes = .true.)
  endif
  
  vol = xct%nktotal*crys%celvol
  if (peinf%inode.eq.0) then
    write(6,*) ' '
    write(6,*) 'More Job Parameters: '
    write(6,'(a,f32.14,a)') ' Crystal volume = ',vol,' a.u.'
    write(6,*) 'Number of valence bands = ',xct%nvb_fi
    write(6,*) 'Number of cond. bands   = ',xct%ncb_fi
    write(6,*) 'Number of spins   = ',xct%nspin
    write(6,'(a,f7.4,a)') ' Broadening: ',xct%eta,' eV'
    write(6,*) 'Number of eigenvalues to be computed = ',neig
    write(6,*) ' '
  endif
  call timacc(2,2)
      
  SAFE_ALLOCATE(indexq_fi, (xct%nkpt_fi))
  if (flag%vm.ne.1.or. .not. flag%read_dtmat) then
    call timacc(3,1)
    call logit('Calling input_q')
    call input_q(kp_fi,crys,gvec,kg_fi,kgq_fi,kpq_fi,syms,xct,indexq_fi,eqp,flag,intwfnv)
    call timacc(3,2)
  endif
      
! JRD: Don`t do this next section if only want absorption_noeh.dat

  if (xct%iabsorp0 .eq. 0) then

!------------------------------
! Calculate the transformation matrices from coarse grid wavefunctions
! FHJ: These are the final transformation coefs that will be used to interpolate
! the kernel. However, we might use an unrestricted version of dvv/dcc to
! interpolate eqp if xct%unrestricted_transf==.true..
    SAFE_ALLOCATE(dvv, (xct%nvb_fi,xct%n1b_co,xct%nspin,xct%nkpt_fi,xct%npts_intp_kernel))
    SAFE_ALLOCATE(dcc, (xct%ncb_fi,xct%n2b_co,xct%nspin,xct%nkpt_fi,xct%npts_intp_kernel))
    SAFE_ALLOCATE(kco, (3,xct%nkpt_co))
    SAFE_ALLOCATE(fi2co_wfn, (xct%npts_intp_kernel,xct%nkpt_fi))
    SAFE_ALLOCATE(intp_coefs, (xct%npts_intp_kernel, xct%nkpt_fi))

    call logit('Calling intwfn')
    call timacc(4,1)
    call intwfn(kp_fi,crys,syms,xct,flag,gvec,kg_fi,kgq_fi,dcc,dvv,&
      kco,fi2co_wfn,indexq_fi,eqp,intwfnv,intwfnc,intp_coefs)
    call timacc(4,2)

  endif

  SAFE_DEALLOCATE_P(xct%ifmax)
  if (flag%vm.ne.1.or. .not. flag%read_dtmat) then
    ! otherwise, we did not call input_q to allocate it
    SAFE_DEALLOCATE_P(xct%ifmaxq)
  endif
  
!------------ Calculate the velocity (or momentum) matrix elements -------------

! Each PE calculates a small number of them. At the end, share data
!
! If flag%vm.eq.1, skip this part and just read the matrix elements
! from "vmtxel".
!
! nblock : size of cvs block in hmtrx


  call logit('Calculating v/p matrix elememts')
  nblock = xct%ncb_fi*xct%nvb_fi*xct%nspin
  if (xct%ipar .eq. 1) then
    peinf%nblockd=nblock
  else if (xct%ipar .eq. 2) then
    peinf%nblockd = xct%nvb_fi*xct%nspin
  else
    peinf%nblockd = xct%nspin
  endif
  nmat= xct%nkpt_fi*nblock
  SAFE_ALLOCATE(s1, (nmat))
  SAFE_ALLOCATE(s1k, (xct%ncb_fi,xct%nvb_fi,xct%nspin))
  s1= 0.d0
  s1k= 0.d0

  call timacc(10,1)

  if (flag%vm.eq.0) then
    do ikt=1, peinf%ikt(peinf%inode+1)
      ik = peinf%ik(peinf%inode+1,ikt)
      ikq = indexq_fi(ik)
      ikrq = kg_fi%indr(ik)
      
      call genwf(crys,gvec,kg_fi,syms,wfnc_fi,xct,ik,ik,work,intwfnc,is_cond = .true.)
      call genwf(crys,gvec,kgq_fi,syms,wfnvq_fi,xct,ik,ikq,workq,intwfnv,is_cond = .false.)

      if (flag%opr.eq.0) then
        call mtxel_v(wfnc_fi,wfnvq_fi,gvec,xct%qshift,wfnc_fi%nband,wfnvq_fi%nband,s1k)
      elseif (flag%opr.eq.1) then
        call mtxel_m(crys,wfnc_fi,wfnvq_fi,gvec,eqp,xct,wfnc_fi%nband,wfnvq_fi%nband,s1k,ik,.true.)
      endif
      do is=1,xct%nspin
        do ic=1,xct%ncb_fi
          do iv=1,xct%nvb_fi
            s1(bse_index(ik, ic, iv, is, xct)) = s1k(ic,iv,is)
          enddo
        enddo
      enddo
      SAFE_DEALLOCATE_P(wfnc_fi%cg)
      SAFE_DEALLOCATE_P(wfnc_fi%isort)
      SAFE_DEALLOCATE_P(wfnvq_fi%cg)
      SAFE_DEALLOCATE_P(wfnvq_fi%isort)
    enddo
    
    ! typedefs initializes all of these ikolds to 0
    if(work%ikold.ne.0) then
      SAFE_DEALLOCATE_P(work%cg)
      SAFE_DEALLOCATE_P(work%ph)
      SAFE_DEALLOCATE_P(work%ind)
      SAFE_DEALLOCATE_P(work%isort)
    endif
    if(workq%ikold.ne.0) then
      SAFE_DEALLOCATE_P(workq%cg)
      SAFE_DEALLOCATE_P(workq%ph)
      SAFE_DEALLOCATE_P(workq%ind)
      SAFE_DEALLOCATE_P(workq%isort)
    endif
! Share matrix elements

#ifdef MPI
    SAFE_ALLOCATE(dummy, (nmat))
    dummy = s1
    call MPI_ALLREDUCE(dummy,s1,nmat,MPI_SCALAR,MPI_SUM, &
      MPI_COMM_WORLD,mpierr)
    SAFE_DEALLOCATE(dummy)
#endif
    if (peinf%inode.eq.0) then
      write(6,'(1x,a)') 'Writing matrix elements into vmtxel'
      call open_file(16,file='vmtxel',form='unformatted',status='replace')
      write(16) xct%nkpt_fi,xct%ncb_fi,xct%nvb_fi,xct%nspin,flag%opr
      write(16) (s1(ikcvs),ikcvs=1,nmat)
      call close_file(16)

! If you want this file, you can get it by bsebinasc anyway.
!      call open_file(17,file='vmtxel.dat',form='formatted',status='replace')
!      write(17,*) xct%nkpt_fi,xct%ncb_fi,xct%nvb_fi,xct%nspin,flag%opr
!      write(17,*) (s1(ikcvs),ikcvs=1,nmat)
!      call close_file(17)
    endif
    
  else ! ...if the matrix elements were calculated already
    
    if (peinf%inode.eq.0) then
      write(6,'(1x,a)') 'Reading matrix elements from vmtxel'
      call open_file(16,file='vmtxel',form='unformatted',status='old')
      read(16) ik,ic,iv,is,ii
      if (ik.ne.xct%nkpt_fi.or.ic.ne.xct%ncb_fi.or.iv.ne.xct%nvb_fi &
        .or.is.ne.xct%nspin.or.ii.ne.flag%opr) then
        write(0,'(a,5i6)') 'read  : ', ik,ic,iv,is,ii
        write(0,'(a,5i6)') 'needed: ', xct%nkpt_fi,xct%ncb_fi,xct%nvb_fi,xct%nspin,flag%opr
        call die('parameter mismatch in vmtxel')
      endif
      
      read(16) (s1(ikcvs),ikcvs=1,nmat)
      call close_file(16)
    endif
    
#ifdef MPI
    call MPI_BCAST(s1,nmat,MPI_SCALAR,0,MPI_COMM_WORLD,mpierr)
#endif

  endif

  call timacc(10,2)

  if (flag%vm.ne.1.or. .not. flag%read_dtmat) then
    call dealloc_grid(kgq_fi)
  endif

  if (xct%iwriteint.eq.1 .and. flag%vm == 0 .and. .not. flag%read_dtmat) then
    SAFE_DEALLOCATE_P(intwfnc%cgk)
    SAFE_DEALLOCATE_P(intwfnv%cgk)
    SAFE_DEALLOCATE_P(intwfnc%isort)
    SAFE_DEALLOCATE_P(intwfnv%isort)
  endif

! JRD: Now close the no longer needed wavefunction files

  if (xct%iwriteint.eq.0 .and. (flag%vm.ne.1 .or. .not. flag%read_dtmat)) then
    write(filename,'(a,i4.4)') 'INT_VWFNQ_', peinf%inode
    iunit_v = 128+(2*peinf%inode)+2
    call open_file(iunit_v, filename, status = 'old')
    call close_file(iunit_v, delete = .true.) ! files INT_VWFNQ_*
    
    write(filename,'(a,i4.4)') 'INT_CWFN_', peinf%inode
    iunit_c = 128+(2*peinf%inode)+1
    call open_file(iunit_c, filename, status = 'old')
    call close_file(iunit_c, delete = .true.) ! files INT_CWFN_*
  endif

! End Calculating Matrix Elements
!-------------------------------------------------------------------------------

!----------------------------
! Calculate the non-interacting spectrum. Only one PE works

  call timacc(9,1)
  call logit('Calling absp0')
  if (peinf%inode.eq.0) then
    call absp0(eqp,xct,s1,vol,omega_plasma,flag)
  end if
  call timacc(9,2)
  
  SAFE_DEALLOCATE_P(eqp%eclda)
  SAFE_DEALLOCATE_P(eqp%evlda)
  SAFE_DEALLOCATE(s1k)
  SAFE_DEALLOCATE(indexq_fi)

! JRD If we only want absorp0 - we finish here

  if (xct%iabsorp0 .eq. 1) then
    call diag_end()
    POP_SUB(diag)
    return
  endif

!------------ Build Hamiltonian Matrix --------------------------------------------

! Build Hamiltonian matrix. Diagonal part comes from the "non-interacting"
! quasiparticle Hamiltonians.  If the QP Greens function is diagonal,
! then these are just the quasiparticle energy differences on the
! diagonal.  The more general case is:
!
!       <cvk|H0|c'v'k'> = delta(k,k') *
!            [ <c|hqp|c'>*delta(v',v) - delta(c,c')*<v'|hqp|v> ]
!
! The rest of the Hamiltonian, which is the electron-hole interaction,
! comes from interpolation further below.

  call logit('Building non-interacting Hamiltonian')
  SAFE_ALLOCATE(hmtrx_A, (xct%nkpt_fi*nblock, peinf%nblocks*peinf%nblockd))
  hmtrx_A(:,:) = 0.0d0
  if (.not.xct%tda) then
    SAFE_ALLOCATE(hmtrx_B, (xct%nkpt_fi*nblock, peinf%nblocks*peinf%nblockd))
    hmtrx_B(:,:) = 0.0d0
  endif

! ikt loop. This loop is over proc owned k if ipar = 1, (k,c)  if 
! ipar = 2 and (k,c,v) if ipar = 3 

  do ikt=1,peinf%ibt(peinf%inode + 1)
    ik=peinf%ikb(peinf%inode+1,ikt)
    
    if (ik .eq. 0) then
      write(0,*) "Illegal value for ik",peinf%inode, ikt, ik
      call die("internal error in diag, ik = 0")
    endif
    
! Build <c|hqp|c'> and <v|hqp|v'> for this kpoint

    SAFE_ALLOCATE(hqpcc, (xct%ncb_fi,xct%ncb_fi,xct%nspin))
    SAFE_ALLOCATE(hqpvv, (xct%nvb_fi,xct%nvb_fi,xct%nspin))
    hqpcc = 0.0d0
    hqpvv = 0.0d0
    
! Put QP energies on diagonals of hqpcc and hqpvv to start

    do is=1,xct%nspin
      do ic=1,xct%ncb_fi
        hqpcc(ic,ic,is) = eqp%ecqp(ic,ik,is)
      enddo
      do iv=1,xct%nvb_fi
        hqpvv(iv,iv,is) = eqp%evqp(iv,ik,is)
      enddo
    enddo
    
! Read possible offdiagonal QP elements from "hqp.<ik>" file
! if it exists.  JRD: This is broken for now.  Someone should fix
! it in the future if they want to use it

    !if (ik.lt.10) then
    !  write(tmpstr,'(a,i1)') 'hqp.',ik
    !else if (ik.lt.100) then
    !  write(tmpstr,'(a,i2)') 'hqp.',ik
    !else if (ik.lt.1000) then
    !  write(tmpstr,'(a,i3)') 'hqp.',ik
    !else if (ik.lt.100000) then
    !  write(tmpstr,'(a,i5)') 'hqp.',ik
        !else
    !  write(0,*) 'too many kpoints for reading hqp'
    !endif
    !call open_file(9,file=tmpstr,form='formatted',status='old')
    !if (is.eq.0) then
    !  if (peinf%inode.eq.0) then
    !    write(6,*) 'Reading offdiagonal hqp from file ',tmpstr
    !    write(6,*) 'All values in eV'
    !  endif
    !  do
    !    read(9,*,end=999) nocc,ii,jj,x,y
    
    ! if ii and jj both refer to valence, states, put
    ! matrix element into hqpvv
    
    !    if ((ii<=nocc).and.(ii>nocc-xct%nvb_fi).and. &
    !    (jj<=nocc).and.(jj>nocc-xct%nvb_fi)) then
    !      if (peinf%inode.eq.0) write(6,'(a,2i5,2f20.10)') ' hqp(v,vp) = ',ii,jj,x,y
    !      ii=nocc-ii+1
    !      jj=nocc-jj+1
    !      is = 1
#ifdef CPLX
    !      hqpvv(ii,jj,is) = CMPLX(x,y)/ryd
#else
    !      hqpvv(ii,jj,is) = x/ryd
#endif
    !    else if ((ii>nocc).and.(ii<=nocc+xct%ncb_fi).and. &
    !    (jj>nocc).and.(jj<=nocc+xct%ncb_fi)) then
    !      if (peinf%inode.eq.0) write(6,'(a,2i5,2f20.10)') ' hqp(c,cp) = ',ii,jj,x,y
    !      ii=ii-nocc
    !      jj=jj-nocc
    !      is = 1
#ifdef CPLX
    !      hqpcc(ii,jj,is) = CMPLX(x,y)/ryd
#else
    !      hqpcc(ii,jj,is) = x/ryd
#endif
    !    endif
    !  enddo
    !999      call close_file(9)
    !  write(6,*)
    !endif ! if hqp.<ik> was found
    
    ! Now build hamiltonian from hqcc and hqvv
    
    do is=1,xct%nspin 
      do iv=1,xct%nvb_fi  
        do ic=1,xct%ncb_fi
          ikb=peinf%ikb(peinf%inode+1,ikt)
          if (xct%ipar .eq. 1) then
            ikcvsd = bse_index(ikt, ic, iv, is, xct)
            ivb=iv
            icb=ic
! JRD: if ipar is 2, the ikt loop above is over both k and c. So we don`t need
! the c loop here.
          else if (xct%ipar .eq. 2 .and. ic .eq. 1) then
            ikcvsd = bse_index(ikt, ic, iv, is, xct, ncband = 1)
            icb=peinf%icb(peinf%inode+1,ikt)
            ivb=iv
! JRD: if ipar is 3, the ikt loop above is over all over k,v and c. So we don`t need
! the c or v loops here.
          else if (xct%ipar .eq. 3 .and. iv .eq. 1 .and. ic .eq. 1) then
            ikcvsd = bse_index(ikt, ic, iv, is, xct, ncband = 1, nvband = 1)
            ivb=peinf%ivb(peinf%inode+1,ikt)
            icb=peinf%icb(peinf%inode+1,ikt)
          else
            cycle
          endif
          ikcvs = bse_index(ikb, icb, ivb, is, xct)
          
          hmtrx_A(ikcvs,ikcvsd) = hqpcc(icb,icb,is) - hqpvv(ivb,ivb,is)
        enddo
      enddo
    enddo
    SAFE_DEALLOCATE(hqpcc)
    SAFE_DEALLOCATE(hqpvv)
  enddo ! loop on k-points on this processor

!----------------------------
! Define the mapping of eigenvectors: the ii-th column of the matrix
! egs(:,:) stored in PE #ipe will contain the eigenvector of order
! peinf%peig(ipe,ii). The total number of eigenvectors stored in
! each processor is given by peinf%neig(1:peinf%npes).
! pblock >= maxval(peinf%neig(1:peinf%npes))


  pblock = neig/(peinf%npes*peinf%nblockd)
  if (pblock*peinf%npes*peinf%nblockd.lt.neig) pblock = pblock + 1
  pblock = pblock*peinf%nblockd
  SAFE_ALLOCATE(peinf%neig, (peinf%npes))
  SAFE_ALLOCATE(peinf%peig, (peinf%npes,pblock))
  peinf%neig=0
  peinf%peig=0
  ii=1
  do jj=1,neig
    if (ii.eq.peinf%npes+1) ii=1
    peinf%neig(ii)=peinf%neig(ii)+1
    peinf%peig(ii,peinf%neig(ii))=jj
    if (mod(jj,peinf%nblockd).eq.0) ii=ii+1
  enddo

!-----------------------------
! Interpolation scheme in the Kernel

  call logit('Calling intkernel')
  call timacc(5,1)
  if (xct%tda) then
    call intkernel(crys,kg_fi,kp_fi,syms,xct,hmtrx_A,dcc,dvv,kco,fi2co_wfn,flag,gvec,intp_coefs)
  else
    call intkernel(crys,kg_fi,kp_fi,syms,xct,hmtrx_A,dcc,dvv,kco,fi2co_wfn,flag,gvec,intp_coefs,hmtrx_B=hmtrx_B)
  endif
  call logit('Done intkernel')
  call timacc(5,2)
  SAFE_DEALLOCATE(fi2co_wfn)
  SAFE_DEALLOCATE(dcc)
  SAFE_DEALLOCATE(dvv)
  SAFE_DEALLOCATE(kco)


!--------------------------------
! Exact diagonalization

  call logit('Calling diagonalize')
  SAFE_ALLOCATE(egv, (neig))
  SAFE_ALLOCATE(egs, (nmat,pblock))
  call timacc(6,1)
  call diagonalize(pblock,neig,nmat,hmtrx_A,egv,egs)
  call timacc(6,2)
  
!--------------------------------
! Calculate transition matrix elements
! oscillator strength = 2 * cs / omega, as defined below

  call timacc(11,1)

  call logit('Computing transition matrix elements')
  SAFE_ALLOCATE(cs, (neig))
  SAFE_ALLOCATE(dipoles, (neig))
  cs = 0d0
  dipoles = ZERO

  do ii=1,peinf%neig(peinf%inode+1)
    jj= peinf%peig(peinf%inode+1,ii)
    dipoles(jj) = sum(MYCONJG( egs(1:nmat,ii) )*s1(1:nmat)) / sqrt(dble(xct%nspin))
    ! this factor is required to obtain the same transition matrix elements for the singlet excitons
    ! for nspin = 1 and nspin = 2, and is related to different normalization of the excitons
    ! see just after eq. (25) in Rohlfing and Louie, PRB 62, 4927 (2000)
    cs(jj) = ( abs(dipoles(jj)) )**2
  enddo

#ifdef MPI
  SAFE_ALLOCATE(rdum, (neig))
  SAFE_ALLOCATE(rdum2, (neig))
  rdum = cs
  rdum2 = dipoles
  call MPI_REDUCE(rdum,cs,neig,MPI_REAL_DP,MPI_SUM,0,MPI_COMM_WORLD,mpierr)
  call MPI_REDUCE(rdum2,dipoles,neig,MPI_SCALAR,MPI_SUM,0,MPI_COMM_WORLD,mpierr)
  SAFE_DEALLOCATE(rdum)
  SAFE_DEALLOCATE(rdum2)
#endif

  call timacc(11,2)

!-------------------------------
! Convert eigenvalues to eV and write them out

  egv(:) = egv(:)*ryd
  if (peinf%inode.eq.0) then
    if(any(egv(1:neig) < -TOL_Zero)) write(0,'(a)') "WARNING: There are negative excitation energies."
    call open_file(unit=14,file='eigenvalues.dat',form='formatted',status='replace')
    write(14,'(a,i8)') '# neig  = ', neig
    write(14,'(a,e16.9)') '# vol   = ', vol
    write(14,'(a,i8)') '# nspin = ', xct%nspin
    write(14,'(a)',advance='no') '#       eig (eV)   abs(dipole)^2'
    if (flag%krnl .ne. 0) then
      write(14,'(a)',advance='no') '      '
    else ! triplet transition matrix element = 0 if we consider spin overlap
      write(14,'(a)',advance='no') ' magn '
    endif
#ifdef CPLX
    write(14,'(a)') 'Re(dipole)      Im(dipole)'
#else
    write(14,'(a)') '    dipole'
#endif
    
    do ii=1,neig
      write(14,'(4e16.8)') egv(ii),cs(ii),dipoles(ii)
    enddo
    call close_file(14)
  endif
  
  SAFE_DEALLOCATE(s1)
  SAFE_DEALLOCATE(dipoles)
  
!------------------------------
! Calculate the absorption and density of excitonic states

  call timacc(12,1)

  call logit('Calling absp')
  if (peinf%inode.eq.0) then
    call absp(xct,neig,cs,egv,vol,omega_plasma,flag)
  endif

  call timacc(12,2)

!------------------------------
! Write out eigenvectors to file if needed

  call timacc(13,1)

  if (flag%eig.ne.0) then
    call logit('Calling write_eigenvectors')
    call write_eigenvectors(xct,kg_fi,nblock,pblock, &
      neig,egv,egs,flag%eig)
  endif

  call timacc(13,2)
  
!-------------------------------
! Deallocate stuff

  SAFE_DEALLOCATE_P(peinf%neig)
  SAFE_DEALLOCATE_P(peinf%peig)
  call dealloc_grid(kg_fi)

  if (eqp%spl_tck%n>0) then
    SAFE_DEALLOCATE_P(eqp%spl_tck%t)
    SAFE_DEALLOCATE_P(eqp%spl_tck%c)
  endif

  SAFE_DEALLOCATE(cs)
  SAFE_DEALLOCATE(egv)
  SAFE_DEALLOCATE(hmtrx_A)
  if (.not.xct%tda) then
    SAFE_DEALLOCATE(hmtrx_B)
  endif
  SAFE_DEALLOCATE(egs)
  SAFE_DEALLOCATE_P(eqp%ecqp)
  SAFE_DEALLOCATE_P(eqp%evqp)
  SAFE_DEALLOCATE(intp_coefs)

  if (xct%iwritecoul .eq. 1 .and. peinf%inode .eq. 0) then
    call close_file(19) ! file vcoul
  endif

  call diag_end()

  POP_SUB(diag)
  return

contains

  subroutine diag_end()

    PUSH_SUB(diag.diag_end)

#ifdef MPI
    call MPI_BARRIER(MPI_COMM_WORLD,mpierr)
#endif

!--------------------------------
! Time accounting

    SAFE_ALLOCATE(routnam, (60))
    routnam(1)='TOTAL:'
    routnam(2)='INPUT:'
    routnam(3)='INPUT_Q:'
    routnam(4)='INTWFN:'
    routnam(5)='INTKERNEL:'
    routnam(6)='DIAGONALIZE:'
    routnam(7)='EPSDIAG:'
    routnam(8)='EPS COMM:'
    routnam(9)='ABSORP0:'
    routnam(10)='VMTXEL:'
    routnam(11)='TRANS MTXEL:'
    routnam(12)='ABSORP:'
    routnam(13)='WRITE EIG:'
    routnam(41)='IW Input_co:'
    routnam(42)='IW Interp:'
    routnam(43)='IW Genwf:'
    routnam(44)='IW Gwnwf_Co:'
    routnam(45)='IW Mtxel_t:'
    routnam(46)='IW Write:'
    routnam(47)='IW Reduce:'
    routnam(51)='IK Setup:'
    routnam(52)='IK C-Check:'
    routnam(53)='IK Input:'
    routnam(54)='IK Inteps:'
    routnam(55)='IK Vcoul:'
    routnam(56)='IK Cache:'
    routnam(57)='IK Interp:'
    routnam(58)='IK Sum:'
    SAFE_ALLOCATE(routsrt, (28))
    routsrt=(/ (ii,ii=2,13), (ii,ii=41,47), (ii,ii=51,58), 1 /)
  
    call timacc(1,2)
    if(peinf%inode.eq.0) then
      write(6,*)
      write(6,9000) 'CPU [s]','WALL [s]','#'
      write(6,*)
    endif
    
    do ii=1,ubound(routsrt, 1)
      call timacc(routsrt(ii),3,tsec,ncount)
#ifdef MPI
      call MPI_ALLREDUCE(tsec,tmin,2,MPI_REAL_DP,MPI_MIN,MPI_COMM_WORLD,mpierr)
      call MPI_ALLREDUCE(tsec,tmax,2,MPI_REAL_DP,MPI_MAX,MPI_COMM_WORLD,mpierr)
#else
      tmin = tsec
      tmax = tsec
#endif
      if(peinf%inode==0) then
        if (ii>1) then
          if (routsrt(ii)-routsrt(ii-1)/=1) write(6,*)
        endif
        write(6,9001) routnam(routsrt(ii)),tmin(1),tmin(2),ncount
        write(6,9002) tsec(1),tsec(2)
        write(6,9003) tmax(1),tmax(2)
      endif
    enddo
    
9000 format(22x,a13,  3x,a13,  3x,a8)
9001 format(1x,a16,'(min.)',f13.3,3x,f13.3,3x,i8)
9002 format(  17x,'(PE 0)',f13.3,3x,f13.3)
9003 format(  17x,'(max.)',f13.3,3x,f13.3)

    POP_SUB(diag.diag_end)
    return
  end subroutine diag_end

end subroutine diag

!============================================================================
!
! Routines:
!
! (1) mtxel_ch()        Originally By ?         Last Modified 5/31/2009 (gsm)
!
!     Adapted from subroutine mtxel.
!     Subroutine computes required matrix elements
!     of the form <nk|exp{i g.r}|nk>
!
!     input   n,m                band indices
!     input   ncoul              number of matrix elements required
!     input   isrtrq             index array for g-vectors in
!                                <nk|exp{i g.r}|nk>
!     output  aqs                matrix elements required
!
!============================================================================

#include "f_defs.h"

subroutine mtxel_ch(n,m,gvec,wfnk,ncoul,isrtrq,aqs,ispin,kp)

  use global_m
  use fftw_m
  use misc_m
  implicit none

  integer, intent(in) :: n, m
  type (gspace), intent(in) :: gvec
  type (wfnkstates), intent(in) :: wfnk
  type (kpoints), intent(inout) :: kp
  integer, intent(in) :: ncoul
  integer, intent(in) :: isrtrq(gvec%ng)
  SCALAR, intent(out) :: aqs(ncoul)
  integer, intent(in) :: ispin

  integer :: jspinor,jspinormax,jspinormin

!-------------------------
! If we are using FFT to calculate matrix elements...

! We use FFT to compute <u_nk|e^(iG.r)|u_nk> elements where
! u_nk is the periodic part of the wave function.
! The calculation is done in real space, and integration over
! the grid is replaced by the sum over the grid points p:
!
! <u_nk|e^(iG.r)|u_nk>  =
!     Volume/Np * sum_p { conj(u_nk(p))*e^(iG.p)*u_nk(p) }
!
! Since u_nk(p) = Volume^-0.5 * sum_G { cnk(G)*e^(iG.p) },
! and FFT is defined as FFT(cnk,+,p) = sum_G { cnk(G)*e^{+iG.p} },
! we must compute
!
! <u_nk|e^(iG.r)|u_nk>
!   = 1/Np * sum_p { conj(FFT(cnk,+,p))*e^(iG.p)*FFT(cnk,+,p) }
!   = 1/Np * FFT(conj(FFT(cnk,+,:)).*FFT(cnk,+,:),+,G)
!
! where .* is a point by point multiplication on the grid

  complex(DPC), dimension(:,:,:), allocatable :: fftbox1,fftbox2
  integer, dimension(3) :: Nfft
  real(DP) :: scale
  SCALAR, dimension(:), allocatable :: tmparray

  PUSH_SUB(mtxel_ch)

! Compute size of FFT box we need and scale factor

  call setup_FFT_sizes(gvec%FFTgrid,Nfft,scale)

! Allocate FFT boxes

  SAFE_ALLOCATE(fftbox1, (Nfft(1),Nfft(2),Nfft(3)))
  SAFE_ALLOCATE(fftbox2, (Nfft(1),Nfft(2),Nfft(3)))

! Put the data for band n into FFT box 1 and do the FFT,zk(:,1)

  call set_jspinor(jspinormin,jspinormax,ispin,kp%nspinor)

  SAFE_ALLOCATE(tmparray, (ncoul))

  do jspinor = jspinormin,jspinormax

    call put_into_fftbox(wfnk%nkpt,wfnk%zk((n-1)*wfnk%nkpt+1:,jspinor),gvec%components,wfnk%isrtk,fftbox1,Nfft)
    call do_FFT(fftbox1,Nfft,1)

! We need the complex conjugate of the |nk> band actually

    call conjg_fftbox(fftbox1,Nfft)

! Now we get the matrix elements:
!  Get n wave function and put it into box 2,
!  do FFT,
!  multiply by box1 contents,
!  do FFT again,
!  and extract the resulting matrix elements

    call put_into_fftbox(wfnk%nkpt,wfnk%zk((m-1)*wfnk%nkpt+1:,jspinor),gvec%components,wfnk%isrtk,fftbox2,Nfft)
    call do_FFT(fftbox2,Nfft,1)
    call multiply_fftboxes(fftbox1,fftbox2,Nfft)
    call do_FFT(fftbox2,Nfft,1)
    call get_from_fftbox(ncoul,tmparray,gvec%components,isrtrq,fftbox2,Nfft,scale)
    if (kp%nspinor.eq.1 .or. jspinor.eq. 1) then
      aqs(:) = tmparray(:)
    else
      aqs(:) = aqs(:) + tmparray(:)
    endif

  enddo

  SAFE_DEALLOCATE(tmparray)

! We are done, so deallocate FFT boxes

  SAFE_DEALLOCATE(fftbox1)
  SAFE_DEALLOCATE(fftbox2)
  
  POP_SUB(mtxel_ch)
  
  return
end subroutine mtxel_ch

!=========================================================================
!
! Included from file wfn_rho_vxc_io.f90.
! You are not expected to understand this. --DAS
!
!=========================================================================

#ifdef READ
  #define READ_WRITE(x) read ## x
  #define INTENT out
  #define FLAVOR_INTENT inout
#else
  #define READ_WRITE(x) write ## x
  #define INTENT in
  #define FLAVOR_INTENT in
#endif

#ifdef FORMATTED
  #define NAME(x) READ_WRITE(_format ## x)
  #define FORMAT , *
#elif defined BINARY
  #define NAME(x) READ_WRITE(_binary ## x)
  #define FORMAT
#else
  #define NAME(x) READ_WRITE(x)
#endif

#define NAMEHEADER NAME(_header)

#undef GVECTORS
#ifdef TEMP_COMPLEX
  #define LONGNAME(x) NAME(x ## _complex_data)
  #define TEMP_SCALAR complex(DPC)
  #define MPI_TEMP_SCALAR MPI_COMPLEX_DPC
#elif defined TEMP_REAL
  #define LONGNAME(x) NAME(x ## _real_data)
  #define TEMP_SCALAR real(DP)
  #define MPI_TEMP_SCALAR MPI_REAL_DP
#else
  #define GVECTORS
  #define LONGNAME(x) NAME(x ## _gvectors)
#endif
#ifdef GVECTORS
  #define ARGUMENTS gvec
#else
  #define ARGUMENTS ns, data
#endif

#if defined FORMATTED || defined BINARY 
#ifndef TEMP_SCALAR
!=========================================================================
subroutine NAMEHEADER(iunit, sheader, iflavor, ns, ng, ntran, cell_symmetry, &
  nat, nk, nbands, ngkmax, ecutrho, ecutwfc, FFTgrid, kgrid, kshift, celvol, &
  alat, avec, adot, recvol, blat, bvec, bdot, mtrx, tnp, atyp, apos, ngk, &
  kw, kpt, ifmin, ifmax, energies, occupations, nspinor, warn, dont_warn_kgrid, sdate, stime, version)
  integer, intent(in) :: iunit !< unit number
  character(len=3), intent(inout) :: sheader !< file header 'WFN'/'RHO'/'VXC'/'GET' -- last one is to read, and return it
  integer, intent(FLAVOR_INTENT) :: iflavor !< define type. always must be initialized. modified only if -1 on input
                            !! -1 = read from file and return it, 0 = as defined by -DCPLX, 1 = real, 2 = complex
  integer, intent(INTENT) :: ns, ng, ntran, cell_symmetry, nat, nk, nbands, ngkmax !< numbers of spins, G-vectors, symmetries,
                             !! cell type (0 = cubic, 1 = hexagonal), numbers of atoms, k-points, bands, max(ngk)
  real(DP), intent(INTENT) :: ecutrho, ecutwfc !< charge-density and wave-function cutoffs, in Ry
  integer, intent(INTENT) :: FFTgrid(3), kgrid(3) !< FFT grid size, k-grid size
  real(DP), intent(INTENT) :: kshift(3) !< k-grid offset
  real(DP), intent(INTENT) :: celvol, alat, avec(3, 3), adot(3, 3) !< cell volume, lattice constant,
                              !! lattice vectors, metric tensor in real space (in a.u., avec in units of alat)
  real(DP), intent(INTENT) :: recvol, blat, bvec(3, 3), bdot(3, 3) !< cell volume, lattice constant,
                              !! lattice vectors, metric tensor in reciprocal space (in a.u., bvec in units of blat)
  integer, intent(INTENT) :: mtrx(3, 3, 48) !< symmetry matrix
  real(DP), intent(INTENT) :: tnp(3, 48) !< fractional translation
  integer, pointer, intent(INTENT) :: atyp(:) !< atomic species
  real(DP), pointer, intent(INTENT) :: apos(:,:) !< atomic positions (in units of alat)
  integer, pointer, intent(INTENT) :: ngk(:) !< number of G-vectors for each k-pt, ngk(nk)
  real(DP), pointer, intent(INTENT) :: kw(:), kpt(:, :) !< k-weight, kw(nk); k-coord, kpt(3, nk) in crystal coords
  integer, pointer, intent(INTENT) :: ifmin(:, :), ifmax(:, :) !< lowest and highest occupied band, ifmin/max(nk, ns)
  real(DP), pointer, intent(INTENT) :: energies(:, :, :) !< energies(nbands, nk, ns) in Ry
  real(DP), pointer, intent(INTENT) :: occupations(:, :, :) !< occupations(nbands, nk, ns) between 0 and 1
  integer, optional, intent(INTENT) :: nspinor !< 2 if doing a two-component spinor calculation; 1 if not present
  logical, optional, intent(in) :: warn !< if false, suppresses warnings about inversion symmetries etc.
  logical, optional, intent(in) :: dont_warn_kgrid !< if true, validity of kgrid read will not be checked.
                                                   !! use for inteqp to allow interpolation onto non-uniform fine grids
  character(len=32), optional, intent(out) :: sdate, stime !< if read, result from file is returned; if write, current is returned
  integer, optional, intent(INTENT) :: version !< version of the header. -1 if no version was/should be specified

  character :: sdate_*32, stime_*32, stitle*32, sflavor*7
  integer :: ii, jj, is, ib, ik, itran, iat, ierr, nspin
  logical :: wfnflag, readwrite_version

#ifdef READ
  logical :: is_get, warn_, warn_kgrid, die_spinors
#else
  character :: adate*11, atime*14
#endif

  PUSH_SUB(NAMEHEADER)

  if (sheader .eq. 'WFN') then
    wfnflag = .true.
  elseif (sheader .eq. 'RHO' .or. sheader .eq. 'VXC' .or. sheader .eq. 'KER') then
    wfnflag = .false.
  elseif (sheader .ne. 'GET') then
    call die("Unknown file header '" // sheader // "' passed to " // TOSTRING(NAMEHEADER) &
      // ": must be 'WFN'/'RHO'/'VXC'/'KER'/'GET'")
  endif

#ifndef READ
  if(sheader .eq. 'GET') call die("Header 'GET' may not be passed to " // TOSTRING(NAMEHEADER) &
    // ": must be 'WFN'/'RHO'/'VXC'")
#endif

  if (peinf%inode .eq. 0) then

    select case(iflavor)
    case(-1)
#ifndef READ
      call die("iflavor = -1 cannot be passed to " // TOSTRING(NAMEHEADER))
#endif
    case(0)
      sflavor = MYFLAVOR
    case(1)
      sflavor = RFLAVOR
    case(2)
      sflavor = CFLAVOR
    case default
      write(sflavor, '(i7)') iflavor
      call die("Illegal value iflavor = " // TRUNC(sflavor) // " passed to " // TOSTRING(NAMEHEADER) &
        // ": must be -1,0,1,2.")
    end select

#ifndef READ
    call date_time(adate, atime) 
    sdate_ = adate 
    stime_ = atime 
    stitle = sheader // "-" // sflavor
#endif

    ! FHJ: we try to READ the version tag if the argument "version" was passed,
    ! and we only WRITE the version if the argument is present and /= -1.
    readwrite_version=.false.
    if (present(version)) then
#ifdef READ
      readwrite_version = .true.
#else
      readwrite_version = version/=-1
#endif
    endif

    ierr = -1
    ! FHJ: try to read/write a first time, including the version tag
    if (readwrite_version) then
      READ_WRITE()(iunit FORMAT, iostat = ierr) version, stitle, sdate_, stime_
    endif

    ! FHJ: if there was no version tag, or if we don`t care about version...
    if (ierr /= 0) then
      ! FHJ: go back one record if we tried reading before
      if (readwrite_version) backspace(iunit, iostat = ierr)
      READ_WRITE()(iunit FORMAT, iostat = ierr) stitle, sdate_, stime_

      if(ierr /= 0) then
        call die("Failed " // TOSTRING(READ_WRITE()) // " operation in " // TOSTRING(NAMEHEADER) &
          // " on header record in mode " // sheader // ".")
      endif
#ifdef READ
      if (present(version)) version = -1
#endif
    endif

#ifdef READ
    is_get = .false.
    if(sheader == 'GET') then
      sheader = stitle(1:3)
      is_get = .true.
      wfnflag = (sheader == 'WFN')
    endif

    if(iflavor == -1) then
      sflavor = TRUNC(stitle(5:))
      if(TRUNC(sflavor) .eq. RFLAVOR) then
        iflavor = 1
      else if (TRUNC(sflavor) .eq. CFLAVOR) then
        iflavor = 2
      else
        call die("Read unknown flavor '" // TRUNC(sflavor) // "' in " // &
          TOSTRING(NAMEHEADER) // ": must be '" // RFLAVOR // "'/'" // CFLAVOR // "'")
      endif
    endif
    if(TRUNC(stitle) .ne. TRUNC(sheader // "-" // sflavor)) then
      call die("File header mismatch: read '" // TRUNC(stitle) // "' but expected '" &
        // sheader // "-" // TRUNC(sflavor) // "'")
    endif
#endif

#ifndef READ
    nspin = ns
    if(present(nspinor)) then
      if(nspinor==2) then
        nspin = 4
      endif
    endif
#endif

! scalar variables
    if(wfnflag) then
      READ_WRITE()(iunit FORMAT) nspin, ng, ntran, cell_symmetry, nat, ecutrho, nk, nbands, ngkmax, ecutwfc
#if defined READ
      if(nk < 1) call die("nk out of bounds in wfn")
      if(nbands < 1) call die("nbands out of bounds in wfn")
      if(ngkmax < 1) call die("ngkmax out of bounds in wfn")
      if(ecutwfc < -TOL_Zero) call die("ecutwfc out of bounds in wfn")
#endif
    else
      READ_WRITE()(iunit FORMAT) nspin, ng, ntran, cell_symmetry, nat, ecutrho
    endif

#if defined READ    
    if(nspin /= 1 .and. nspin /= 2 .and. nspin /= 4) call die("nspin out of bounds")
    if(nspin == 4) then
      if(.not. present(nspinor)) call die("nspinor not passed but read nspin==4")
      nspinor = 2
      ns = 1

      die_spinors = .true.
      if(die_spinors) call die("Cannot use spinor WFN file (nspin = 4).")
    else
      if(present(nspinor)) nspinor = 1
      ns = nspin
    endif
    if(ng < 1) call die("ng out of bounds")
    if(ntran < 1 .or. ntran > 48) call die("ntran out of bounds")
    if(cell_symmetry /= 0 .and. cell_symmetry /= 1) call die("cell_symmetry out of bounds")
    if(nat < 1) call die("nat out of bounds")
    if(ecutrho < -TOL_Zero) call die("ecutrho out of bounds")
#endif

! arrays of fixed size
    if(wfnflag) then
      READ_WRITE()(iunit FORMAT) (FFTgrid(ii), ii = 1, 3), (kgrid(ii), ii = 1, 3), (kshift(ii), ii = 1, 3)
#if defined READ    
      warn_kgrid = .true.
      if(present(dont_warn_kgrid)) warn_kgrid = .not. dont_warn_kgrid
      if(warn_kgrid) then
        if (any(kgrid(1:3) < 1)) call die("kgrid out of bounds in wfn")
        if (all(abs(kshift(1:3)) < TOL_Zero) .and. product(kgrid(1:3)) < nk) call die("kgrid too small for nk")
        ! You might think such a condition would hold always but it does not necessarily, since a shifted uniform grid
        ! generally does not include all the points you can get from unfolding it with symmetries. --DAS
        if (product(kgrid(1:3)) > nk * ntran) call die("kgrid too large compared to unfolded nk")
      endif
      if(any(abs(kshift(1:3)) > 1 + TOL_Zero)) call die("kshift out of bounds in wfn")
#endif
    else
      READ_WRITE()(iunit FORMAT) (FFTgrid(ii), ii = 1, 3)
    endif
    READ_WRITE()(iunit FORMAT) celvol, alat, ((avec(jj, ii), jj = 1, 3), ii = 1, 3), ((adot(jj, ii), jj = 1, 3), ii = 1, 3)
    READ_WRITE()(iunit FORMAT) recvol, blat, ((bvec(jj, ii), jj = 1, 3), ii = 1, 3), ((bdot(jj, ii), jj = 1, 3), ii = 1, 3)
#ifdef READ
    mtrx(:,:,:) = 0
    tnp(:,:) = 0d0
#endif
    READ_WRITE()(iunit FORMAT) (((mtrx(ii, jj, itran), ii = 1, 3), jj = 1, 3), itran = 1, ntran)
    READ_WRITE()(iunit FORMAT) ((tnp(jj, itran), jj = 1, 3), itran = 1, ntran)
#if defined READ
    call make_identity_symmetry_first(ntran, mtrx, tnp)
    if(any(FFTgrid(1:3) < 1)) then
      call die("FFTgrid out of bounds")
    endif
    if(product(FFTgrid(1:3)) * 1.05 < ng * 6 / PI_D) then ! consistency of FFT grid with G-vectors, with a 5% tolerance
      write(0,*) 'FFTgrid = ', FFTgrid
      write(0,*) 'ng = ', ng
      if(product(FFTgrid(1:3)) < ng) then
        call die("FFTgrid inconsistent with ng")
      else
        write(0,*) 'WARNING: FFTgrid is suspiciously small. This is ok only if this system is'
        write(0,*) 'extremely anisotropic. Otherwise, use the Visual/gsphere.py utility to double'
        write(0,*) 'check that the G-vectors are compatible with this FFT grid.'
      endif
    endif
    if(celvol < -TOL_Zero) call die("celvol out of bounds")
    if(recvol < -TOL_Zero) call die("recvol out of bounds")
    if(any(abs(mtrx(:,:,1:ntran)) > 1)) call die("symmetry matrix may only contain -1, 0, 1")
#endif
  endif

  if(present(sdate)) sdate = sdate_
  if(present(stime)) stime = stime_
#ifdef MPI
  if(peinf%npes > 1) then
#ifdef READ
    if(present(version)) call MPI_BCAST(version, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(iflavor, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
#endif
    if(present(sdate)) call MPI_BCAST(sdate, 32, MPI_CHARACTER, 0, MPI_COMM_WORLD, mpierr)
    if(present(stime)) call MPI_BCAST(stime, 32, MPI_CHARACTER, 0, MPI_COMM_WORLD, mpierr)
  endif
#endif

#ifdef READ
#ifdef MPI
  if (peinf%npes .gt. 1) then
    call MPI_BCAST(is_get, 1, MPI_LOGICAL, 0, MPI_COMM_WORLD, mpierr)
    if(is_get) call MPI_BCAST(sheader, 3, MPI_CHARACTER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(ns, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    if(present(nspinor)) call MPI_BCAST(nspinor, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(ng, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(ntran, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(cell_symmetry, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(nat, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(ecutrho, 1, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(FFTgrid, 3, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(celvol, 1, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(alat, 1, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(avec, 9, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(adot, 9, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(recvol, 1, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(blat, 1, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(bvec, 9, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(bdot, 9, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(mtrx(1,1,1), 3*3*48, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(tnp, 3*48, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(wfnflag, 1, MPI_LOGICAL, 0, MPI_COMM_WORLD, mpierr)
    if (wfnflag) then
      call MPI_BCAST(nk, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
      call MPI_BCAST(nbands, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
      call MPI_BCAST(ngkmax, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
      call MPI_BCAST(ecutwfc, 1, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
      call MPI_BCAST(kgrid, 3, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
      call MPI_BCAST(kshift, 3, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
    endif
  endif
#endif
! MPI

  SAFE_ALLOCATE(atyp, (nat))
  SAFE_ALLOCATE(apos, (3, nat))
  if (wfnflag) then
    SAFE_ALLOCATE(ngk, (nk))
    SAFE_ALLOCATE(kw, (nk))
    SAFE_ALLOCATE(kpt, (3, nk))
    SAFE_ALLOCATE(ifmin, (nk, ns))
    SAFE_ALLOCATE(ifmax, (nk, ns))
    SAFE_ALLOCATE(energies, (nbands, nk, ns))
    SAFE_ALLOCATE(occupations, (nbands, nk, ns))
  endif
#endif
! READ

! allocatable arrays
  if (peinf%inode .eq. 0) then

    READ_WRITE()(iunit FORMAT) ((apos(ii, iat), ii = 1, 3), atyp(iat), iat = 1, nat)
    if (wfnflag) then
      READ_WRITE()(iunit FORMAT) (ngk(ik), ik = 1, nk)
      READ_WRITE()(iunit FORMAT) (kw(ik), ik = 1, nk)
      READ_WRITE()(iunit FORMAT) ((kpt(ii, ik), ii = 1, 3), ik = 1, nk)
      READ_WRITE()(iunit FORMAT) ((ifmin(ik, is), ik = 1, nk), is = 1, ns)
      READ_WRITE()(iunit FORMAT) ((ifmax(ik, is), ik = 1, nk), is = 1, ns)
      READ_WRITE()(iunit FORMAT) (((energies(ib, ik, is), ib = 1, nbands), ik = 1, nk), is = 1, ns)
      READ_WRITE()(iunit FORMAT) (((occupations(ib, ik, is), ib = 1, nbands), ik = 1, nk), is = 1, ns)

#if defined READ    
      if(any(ngk(1:nk) < 1)) then
        call die("ngk out of bounds in wfn")
      endif
      if(maxval(ngk(1:nk)) /= ngkmax) then
        call die("max(ngk(1:nk)) /= ngkmax in wfn")
      endif
      if(ngkmax > ng) then
        call die("ngkmax > ng in wfn")
      endif
      if(any(kw(1:nk) < -TOL_Zero .or. kw(1:nk) > 1d0 + TOL_Zero)) then
        call die("kw out of bounds in wfn")
      endif
      if(abs(sum(kw(1:nk)) - 1d0) > TOL_Zero) then
        write(0,*) 'sum = ', sum(kw(1:nk))
        write(0,*) kw(1:nk)
        call die("kweights do not sum to 1 in wfn")
      endif
      if(any(ifmin(1:nk, 1:ns) < 0 .or. ifmin(1:nk, 1:ns) > ifmax(1:nk, 1:ns))) then
        call die("ifmin out of bounds in wfn")
      endif
      if(any(ifmax(1:nk, 1:ns) < 0 .or. ifmax(1:nk, 1:ns) > nbands)) then
        call die("ifmax out of bounds in wfn")
      endif
      if(any(ifmin(1:nk, 1:ns) == 0 .and. ifmax(1:nk, 1:ns) /= 0)) then
        call die("ifmin can be zero only when ifmax is zero too; out of bounds in wfn")
      endif
      if(any(occupations(1:nbands, 1:nk, 1:ns) < -0.5 .or. occupations(1:nbands, 1:nk, 1:ns) > 1.5)) then
        call die("occupations out of bounds in wfn")
      endif
      if(any(occupations(1:nbands, 1:nk, 1:ns) < -TOL_Zero .or. occupations(1:nbands, 1:nk, 1:ns) > 1 + TOL_Zero)) then
        write(0,'(a)') "WARNING: occupations outside of range [0,1] in wfn" 
        ! this is expected for cold smearing and Methfessel-Paxton smearing
      endif
#endif

    endif

  endif

#if defined READ && defined MPI
  if (peinf%npes .gt. 1) then
    call MPI_BCAST(atyp, nat, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    call MPI_BCAST(apos, 3*nat, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
    if (wfnflag) then
      call MPI_BCAST(ngk, nk, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
      call MPI_BCAST(kw, nk, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
      call MPI_BCAST(kpt, 3*nk, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
      call MPI_BCAST(ifmin, ns*nk, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
      call MPI_BCAST(ifmax, ns*nk, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
      call MPI_BCAST(energies(1,1,1), nbands*ns*nk, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
      call MPI_BCAST(occupations(1,1,1), nbands*ns*nk, MPI_REAL_DP, 0, MPI_COMM_WORLD, mpierr)
    endif
  endif
#endif

#ifdef READ
! converters and utilities should not write a warning for complex with inversion
  warn_ = .not. is_get
  if(present(warn)) warn_ = warn
  call check_inversion(iflavor, ntran, mtrx, ns, warn_, .false., tnp = tnp)
#endif

  POP_SUB(NAMEHEADER)
  return
end subroutine NAMEHEADER

!=========================================================================
!> wrapper routine that uses typedefs types
subroutine NAME(_header_type)(iunit, sheader, iflavor, kp, gvec, syms, crys, warn, dont_warn_kgrid, sdate, stime, version)
  integer, intent(in) :: iunit
  character(len=3), intent(inout) :: sheader
  integer, intent(FLAVOR_INTENT) :: iflavor
  type(kpoints), intent(INTENT) :: kp
  type(gspace), intent(INTENT) :: gvec
  type(symmetry), intent(INTENT) :: syms
  type(crystal), intent(INTENT) :: crys
  logical, optional, intent(in) :: warn !< if false, suppresses warnings about inversion symmetries etc.
  logical, optional, intent(in) :: dont_warn_kgrid !< if true, validity of kgrid will not be checked.
                                                   !! use for inteqp to allow interpolation onto non-uniform fine grids
  character(len=32), optional, intent(out) :: sdate, stime !< if read, result from file is returned; if write, current is returned
  integer, optional, intent(INTENT) :: version !< version of the header. -1 if no version was/should be specified

  PUSH_SUB(NAME(_header_type))

  call NAMEHEADER(iunit, sheader, iflavor, kp%nspin, gvec%ng, syms%ntran, syms%cell_symmetry, crys%nat, &
    kp%nrk, kp%mnband, kp%ngkmax, gvec%ecutrho, kp%ecutwfc, gvec%FFTgrid, kp%kgrid, kp%shift, crys%celvol, &
    crys%alat, crys%avec, crys%adot, crys%recvol, crys%blat, crys%bvec, crys%bdot, syms%mtrx, syms%tnp, &
    crys%atyp, crys%apos, kp%ngk, kp%w, kp%rk, kp%ifmin, kp%ifmax, kp%el, kp%occ, nspinor = kp%nspinor, &
    warn = warn, dont_warn_kgrid = dont_warn_kgrid, sdate = sdate, stime = stime, version = version)

#ifdef READ
  gvec%nFFTgridpts = product(gvec%FFTgrid(1:3))
#endif

  POP_SUB(NAME(_header_type))
  return
end subroutine NAME(_header_type)

#endif
!TEMP_SCALAR

!=========================================================================
!> This routine is turned into 12 variants by preprocessing.
!! If nrecord and ng_record are not provided for read, the routine simply does not tell you what it found.
!! For write, nrecord is given the default 1 if not provided. ng_record defaults to ng if nrecord = 1, but
!! if nrecord > 1, ng_record must be provided to specify how to divide up the g-vectors.
subroutine LONGNAME()(iunit, ng, ng_bound, ARGUMENTS, nrecord, ng_record, bcast, gindex, dont_read)
  integer, intent(in) :: iunit
  integer, intent(in) :: ng       !< used size of array
  integer, intent(in) :: ng_bound !< actual size of array, >= ng
#ifdef GVECTORS
  integer, intent(INTENT) :: gvec(:, :) !< (3, ng_bound)
#else
  integer, intent(in) :: ns
  TEMP_SCALAR, intent(INTENT) :: data(:, :) !< (ng_bound, ns)
#endif
  integer, optional, intent(INTENT) :: nrecord !< data/gvectors will be distributed among this many records
  integer, optional, pointer, intent(INTENT) :: ng_record(:) !< number of gvectors in each record
    !! must be provided for write if nrecord > 1
  logical, optional, intent(in) :: bcast     !< whether to do MPI_Bcast of what is read
  integer, optional, intent(in) :: gindex(:) !< map of order in file to order in gvec
  logical, optional, intent(in) :: dont_read !< if true, records will just be skipped; only for unformatted

  integer :: ig, igg, irecord, ii, nrecord_internal, ng_irecord
  character*100 :: tmpstr
  logical :: bcast_, dont_read_

  PUSH_SUB(LONGNAME())

  if(ng_bound < ng) then
    write(tmpstr,'(a,i10,a,i10,a)') "In routine " // TOSTRING(LONGNAME()) // ", ng_bound = ", ng_bound, " < ", ng, " = ng"
    call die(tmpstr)
  endif

  dont_read_ = .false.
  if(present(dont_read)) then
#ifdef READ
#ifdef FORMATTED
    if(dont_read) call die("Formatted routine " // TOSTRING(LONGNAME()) // " cannot take argument dont_read = .true.")
#endif
    dont_read_ = dont_read
#else
    call die("Write routine " // TOSTRING(LONGNAME()) // " cannot take argument dont_read.")
#endif
  endif

  if(peinf%inode .eq. 0) then
    if(present(gindex) .and. .not. dont_read_) then
      if(ubound(gindex, 1) < ng) &
        call die("In routine " // TOSTRING(LONGNAME()) // ", gindex array is too small")
      if(any(gindex(1:ng) > ng_bound) .or. any(gindex(1:ng) <= 0)) then
        call die("gindex out of bounds in " // TOSTRING(LONGNAME()))
      endif
    endif
  endif

  bcast_ = .not. dont_read_
  ! if not read, no point in broadcasting
  if(present(bcast)) then
#ifdef READ
    bcast_ = bcast
#else
    call die("Write routine " // TOSTRING(LONGNAME()) // " cannot take argument bcast.")
#endif
  endif

  ! if not reading, the size of the array passed is irrelevant
  if(.not. dont_read_) then
#ifdef GVECTORS
    if(ubound(gvec, 1) /= 3)        &
      call die("In routine " // TOSTRING(LONGNAME()) // ", mismatch of dimension 1 for G-vectors array")
    if(ubound(gvec, 2) < ng_bound)  &
      call die("In routine " // TOSTRING(LONGNAME()) // ", ng_bound is larger than dimension 2 for G-vectors array")
#else
    if(ubound(data, 1) /= ng_bound) &
      call die("In routine " // TOSTRING(LONGNAME()) // ", mismatch of dimension 1 for data array")
    if(ubound(data, 2) /= ns)       &
      call die("In routine " // TOSTRING(LONGNAME()) // ", mismatch of dimension 2 for data array")
#endif
  endif

#ifndef READ
  if(.not. present(nrecord)) then
    nrecord_internal = 1
    ng_irecord = ng
  else
    nrecord_internal = nrecord

    !> check validity of information if going to write
    if(nrecord_internal .ne. 1 .and. .not. present(ng_record)) then
      call die("Routine " // TOSTRING(LONGNAME()) // " requires ng_record array if nrecord > 1.")
    endif

    if(present(ng_record)) then
      if(nrecord_internal .ne. sum(ng_record(1:nrecord))) then
        write(tmpstr,'(a, i10, a, i10, a, a)') "sum(ng_record) = ", sum(ng_record), " ! = ", nrecord , &
          " = nrecord in arguments to routine ", TOSTRING(LONGNAME())
        call die(tmpstr)
      endif
    endif
  endif
#endif

  if(peinf%inode .eq. 0) then
    READ_WRITE()(iunit FORMAT) nrecord_internal
    if(nrecord_internal < 0) then
      write(tmpstr,'(3a, i10)') "In routine ", TOSTRING(LONGNAME()), " illegal nrecord ", nrecord_internal
      call die(tmpstr)
    endif
  endif

#ifdef READ
  if(present(nrecord)) then
    nrecord = nrecord_internal
#ifdef MPI
    if(peinf%npes > 1) call MPI_BCAST(nrecord, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
#endif
  endif
  if(present(ng_record)) then
    SAFE_ALLOCATE(ng_record, (nrecord_internal))
  endif
#endif

  if (peinf%inode.eq.0) call timacc(81,1)

  ! FHJ: zero buffers
#ifdef READ
#ifdef GVECTORS
  gvec(:,:) = 0
#else
  data(:,:) = ZERO
#endif
#endif

  if(peinf%inode .eq. 0) then
    ig = 1
!This is a PGI pragma to force the optimization level of this routine to -O1.
!With -O2 or higher (including -fast) the line after the pragma causes a segmentation fault.
!pgi$r opt=1
    do irecord = 1, nrecord_internal
#ifndef READ
      if(present(ng_record)) ng_irecord = ng_record(irecord)
#endif
      READ_WRITE()(iunit FORMAT) ng_irecord
#ifdef READ
      if(present(ng_record)) ng_record(irecord) = ng_irecord
#endif
      if(dont_read_) then
        READ_WRITE()(iunit FORMAT)
      else
#ifdef GVECTORS
        if(present(gindex)) then
          READ_WRITE()(iunit FORMAT) ((gvec(ii, gindex(igg)), ii = 1, 3), igg = ig, ig + ng_irecord - 1)
        else
          READ_WRITE()(iunit FORMAT) ((gvec(ii, igg), ii = 1, 3), igg = ig, ig + ng_irecord - 1)
        endif
#else
        if(present(gindex)) then
          READ_WRITE()(iunit FORMAT) ((data(gindex(igg), ii), igg = ig, ig + ng_irecord - 1), ii = 1, ns)
        else
          READ_WRITE()(iunit FORMAT) ((data(igg, ii), igg = ig, ig + ng_irecord - 1), ii = 1, ns)
        endif
#endif
      endif
      ig = ig + ng_irecord
    enddo
  endif

  if (peinf%inode.eq.0) call timacc(81,2)
  if (peinf%inode.eq.0) call timacc(82,1)

#if defined READ && defined MPI
  if(peinf%npes > 1) then
    if(present(ng_record)) call MPI_BCAST(ng_record, nrecord_internal, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
    if(bcast_) then
#ifdef GVECTORS
      call MPI_BCAST(gvec, 3 * ng, MPI_INTEGER, 0, MPI_COMM_WORLD, mpierr)
      ! same effect, for the actual data, as 3 * ng_bound
#else
      call MPI_BCAST(data, ng_bound * ns, MPI_TEMP_SCALAR, 0, MPI_COMM_WORLD, mpierr)
#endif
    endif
  endif
#endif

  if (peinf%inode.eq.0) call timacc(82,2)

  POP_SUB(LONGNAME())
  return
end subroutine LONGNAME()

#else
! defined FORMATTED || defined BINARY

#ifndef TEMP_SCALAR
!> wrappers allowing selection of formatted/binary by argument
!=========================================================================
subroutine NAMEHEADER(iunit, is_formatted, sheader, iflavor, ns, ng, ntran, cell_symmetry, &
  nat, nk, nbands, ngkmax, ecutrho, ecutwfc, FFTgrid, kgrid, kshift, celvol, alat, avec, adot, &
  recvol, blat, bvec, bdot, mtrx, tnp, atyp, apos, ngk, kw, kpt, ifmin, ifmax, energies, occupations, &
  nspinor, warn, sdate, stime, version)
  integer, intent(in) :: iunit !< unit number
  logical, intent(in) :: is_formatted !< true = formatted, false = binary
  character(len=3), intent(inout) :: sheader !< file header 'WFN'/'RHO'/'VXC'/'GET'
  integer, intent(FLAVOR_INTENT) :: iflavor !< define type. always must be initialized. modified only if -1 on input
  integer, intent(INTENT) :: ns, ng, ntran, cell_symmetry, nat, nk, nbands, ngkmax !< numbers of spins, G-vectors, symmetries,
  real(DP), intent(INTENT) :: ecutrho, ecutwfc !< charge-density and wave-function cutoffs, in Ry
  integer, intent(INTENT) :: FFTgrid(3), kgrid(3) !< FFT grid size, k-grid size
  real(DP), intent(INTENT) :: kshift(3) !< k-grid offset
  real(DP), intent(INTENT) :: celvol, alat, avec(3, 3), adot(3, 3) !< cell volume, lattice constant,
  real(DP), intent(INTENT) :: recvol, blat, bvec(3, 3), bdot(3, 3) !< cell volume, lattice constant,
  integer, intent(INTENT) :: mtrx(3, 3, 48) !< symmetry matrix
  real(DP), intent(INTENT) :: tnp(3, 48) !< fractional translation
  integer, pointer, intent(INTENT) :: atyp(:) !< atomic species
  real(DP), pointer, intent(INTENT) :: apos(:,:) !< atomic positions (in units of alat)
  integer, pointer, intent(INTENT) :: ngk(:) !< number of G-vectors for each k-pt, ngk(nk)
  real(DP), pointer, intent(INTENT) :: kw(:), kpt(:, :) !< k-weight, kw(nk); k-coord, kpt(3, nk) in crystal coords
  integer, pointer, intent(INTENT) :: ifmin(:, :), ifmax(:, :) !< lowest and highest occupied band, ifmin/max(nk, ns)
  real(DP), pointer, intent(INTENT) :: energies(:, :, :) !< energies(nbands, nk, ns) in Ry
  real(DP), pointer, intent(INTENT) :: occupations(:, :, :) !< occupations(nbands, nk, ns) between 0 and 1
  integer, intent(INTENT) :: nspinor !< 2 if doing a two-component spinor calculation; 1 if not present
  logical, optional, intent(in) :: warn !< if false, suppresses warnings about inversion symmetries etc.
  character(len=32), optional, intent(out) :: sdate, stime !< if read, result from file is returned; if write, current is returned
  integer, optional, intent(INTENT) :: version !< version of the header. -1 if no version was/should be specified

  PUSH_SUB(NAMEHEADER)

  if(is_formatted) then
    call NAME(_format_header)(iunit, sheader, iflavor, ns, ng, ntran, cell_symmetry, nat, nk, nbands, ngkmax, &
      ecutrho, ecutwfc, FFTgrid, kgrid, kshift, celvol, alat, avec, adot, recvol, blat, bvec, bdot, mtrx, tnp, &
      atyp, apos, ngk, kw, kpt, ifmin, ifmax, energies, occupations, &
      nspinor = nspinor, warn = warn, sdate = sdate, stime = stime, version=version)
  else
    call NAME(_binary_header)(iunit, sheader, iflavor, ns, ng, ntran, cell_symmetry, nat, nk, nbands, ngkmax, &
      ecutrho, ecutwfc, FFTgrid, kgrid, kshift, celvol, alat, avec, adot, recvol, blat, bvec, bdot, mtrx, tnp, &
      atyp, apos, ngk, kw, kpt, ifmin, ifmax, energies, occupations, &
      nspinor = nspinor, warn = warn, sdate = sdate, stime = stime, version=version)
  endif

  POP_SUB(NAMEHEADER)
  return
end subroutine NAMEHEADER

!=========================================================================
!> wrapper routine that uses typedefs types
subroutine NAME(_header_type)(iunit, is_formatted, sheader, iflavor, kp, gvec, syms, crys, &
  warn, dont_warn_kgrid, sdate, stime, version)
  integer, intent(in) :: iunit
  logical, intent(in) :: is_formatted !< true = formatted, false = binary
  character(len=3), intent(inout) :: sheader
  integer, intent(FLAVOR_INTENT) :: iflavor
  type(kpoints), intent(INTENT) :: kp
  type(gspace), intent(INTENT) :: gvec
  type(symmetry), intent(INTENT) :: syms
  type(crystal), intent(INTENT) :: crys
  logical, optional, intent(in) :: warn !< if false, suppresses warnings about inversion symmetries etc.
  logical, optional, intent(in) :: dont_warn_kgrid !< if true, validity of kgrid will not be checked.
                                                   !! use for inteqp to allow interpolation onto non-uniform fine grids
  character(len=32), optional, intent(out) :: sdate, stime !< if read, result from file is returned; if write, current is returned
  integer, optional, intent(INTENT) :: version !< version of the header. -1 if no version was/should be specified

  PUSH_SUB(NAME(_header_type))

  if(is_formatted) then
    call NAME(_format_header_type)(iunit, sheader, iflavor, kp, gvec, syms, crys, warn = warn, &
      dont_warn_kgrid = dont_warn_kgrid, sdate = sdate, stime = stime, version=version)
  else
    call NAME(_binary_header_type)(iunit, sheader, iflavor, kp, gvec, syms, crys, warn = warn, &
      dont_warn_kgrid = dont_warn_kgrid, sdate = sdate, stime = stime, version=version)
  endif

  POP_SUB(NAME(_header_type))
  return
end subroutine NAME(_header_type)

#endif
! defined TEMP_SCALAR

!=========================================================================
subroutine LONGNAME()(iunit, is_formatted, ng, ng_bound, ARGUMENTS, nrecord, ng_record, bcast, gindex, dont_read)
  integer, intent(in) :: iunit
  logical, intent(in) :: is_formatted !< true = formatted, false = binary
  integer, intent(in) :: ng       !< used size of array
  integer, intent(in) :: ng_bound !< actual size of array, >= ng
#ifdef GVECTORS
  integer, intent(INTENT) :: gvec(:, :) !< (3, ng_bound)
#else
  integer, intent(in) :: ns
  TEMP_SCALAR, intent(INTENT) :: data(:, :) !< (ng_bound, ns)
#endif
  integer, optional, intent(INTENT) :: nrecord !< data/gvectors will be distributed among this many records
  integer, optional, pointer, intent(INTENT) :: ng_record(:) !< number of gvectors in each record
  logical, optional, intent(in) :: bcast     !< whether to do MPI_Bcast of what is read
  integer, optional, intent(in) :: gindex(:) !< map of order in file to order in gvec
  logical, optional, intent(in) :: dont_read !< if true, records will just be skipped; only for unformatted

  PUSH_SUB(LONGNAME())

! note: surprisingly, the Fortran standard permits passing optional arguments to other routines
! in which those arguments are also optional.
  if(is_formatted) then
    call LONGNAME(_format)(iunit, ng, ng_bound, ARGUMENTS, nrecord = nrecord, &
      ng_record = ng_record, bcast = bcast, gindex = gindex, dont_read = dont_read)
  else
    call LONGNAME(_binary)(iunit, ng, ng_bound, ARGUMENTS, nrecord = nrecord, &
      ng_record = ng_record, bcast = bcast, gindex = gindex, dont_read = dont_read)
  endif

  POP_SUB(LONGNAME())
  return
end subroutine LONGNAME()

#endif
! defined FORMATTED || defined BINARY

! these undefs prevent lots of cpp warnings
#undef READ_WRITE
#undef INTENT
#undef FLAVOR_INTENT
#undef NAME
#undef FORMAT
#undef NAMEHEADER
#undef GVECTORS
#undef LONGNAME
#undef TEMP_SCALAR
#undef MPI_TEMP_SCALAR
#undef ARGUMENTS

#include "f_defs.h"

!*************************************************************************
Module InitializeMod
!*************************************************************************

  use push_pop_m
  implicit none

  contains

!*************************************************************************
  Subroutine MinVecAllocate( minVec, nSize )
!*************************************************************************

    use TypeMod, only : minVecT

    integer, intent( in ) :: nSize
    type( minVecT ), pointer :: minVec

    integer :: error

    PUSH_SUB(MinVecAllocate)
    if( associated( minVec )) stop 'Error minVec already allocated'

    allocate( minVec, stat = error )

    if( error /= 0 ) stop 'Error, Vector allocation failed.'

    allocate( minVec%Phi( NSize ), minVec%StDesc( nSize), minVec%EPhi(nSize), &
         & stat = error )

    if( error /= 0 ) stop 'Error in allocating minVec space'

    POP_SUB(MinVecAllocate)
  end Subroutine MinVecAllocate

!*************************************************************************
  Subroutine MinVecDestroy(minVec)
!*************************************************************************

    use TypeMod, only : minVecT

    type(minVecT), pointer :: minVec

    PUSH_SUB(MinVecDestroy)

    deallocate(minVec%StDesc,minVec%Phi,minVec%EPhi)
    deallocate(minVec)

    POP_SUB(MinVecDestroy)
  end Subroutine MinVecDestroy

!*************************************************************************
  Subroutine EigenStatesInit( eigenStates, iband, kPoint )
!*************************************************************************

    use SysParams, only : double
    use EigenStatesMod, only : eigenStatesT

    integer, intent(in) :: iband, kPoint
    type(EigenStatesT),  pointer :: eigenStates

    integer :: nSize,r
    real( double ) :: R1,rnd1,rnd2,del

    PUSH_SUB(EigenStatesInit)

    nSize = eigenStates%hSize
    del = 0.1

    eigenStates%eigenVectors( :, iband, kPoint) = cmplx(0.d0,0.d0,kind=double)

    do r = 1, nSize
       call Random_Number(R1)
       rnd1 = -1.d0 + 2.d0*R1
       call Random_Number(R1)
       rnd2 = -1.d0 + 2.d0*R1
       eigenStates%eigenVectors( r, iband, kPoint) = cmplx(rnd1,rnd2,kind=double)
    end do

    eigenStates%ePsi( :, kPoint ) = cmplx(0.d0,0.d0,kind=double)

    POP_SUB(EigenStatesInit)
  end Subroutine EigenStatesInit

!*************************************************************************
  Subroutine MinVecInit( minVec )
!*************************************************************************

    use SysParams, only : double
    use TypeMod, only : minVecT

    type(minVecT), pointer :: minVec

    PUSH_SUB(MinVecInit)

    ! Initialize all these vectors to 0.d0
    minVec%cosine = 1.d0
    minVec%sine = 0.d0
    minVec%Phi = cmplx(0.d0,0.d0,kind=double)
    minVec%EPhi = cmplx(0.d0,0.d0,kind=double)
    minVec%StDesc = cmplx(0.d0,0.d0,kind=double)

    POP_SUB(MinVecInit)
  end Subroutine MinVecInit

end Module InitializeMod

!>==========================================================================
!!
!! Module sort_m:
!!
!! (1) gcutoff
!!
!!     Given G-vectors sorted by kinetic energy and an energy cutoff,
!!     find the corresponding G-vector cutoff.
!!
!! (2,3) sortrx, sortix
!!
!!     Sorts an array by the quicksort method. real(DP) and integer versions.
!!     See included sort_inc.f90.
!!
!! (4) make_identity_symmetry_first
!!
!!     The identity must always be the first symmetry, as assumed in various places
!!     in the code. We enforce this by swapping it with op #1 if it is not first.
!!
!! (5) sort_symmetries
!!
!!     Bring symmetries into a standardized order. We are not currently using this.
!!
!!==========================================================================

#include "f_defs.h"

module sort_m
  use global_m

  implicit none

  private

  public ::   &
    gcutoff,  &
    sortrx, &
    sortix, &
    make_identity_symmetry_first, &
    sort_symmetries

  interface sortrx
    module procedure sortrx_gvec, sortrx_no_gvec
  end interface
  interface sortix
    module procedure sortix_gvec, sortix_no_gvec
  end interface

contains

  !> Given G-vectors sorted by kinetic energy and an energy cutoff, find the corresponding G-vector cutoff
  !! such that all(ekin(isrtrq(ig)) <= ecutoff) for ig <= gcutoff.
  integer function gcutoff(ng, ekin, isrtrq, ecutoff)
    integer, intent(in) :: ng !< number of G-vectors
    real(DP), intent(in) :: ekin(:) !< (ng) kinetic energies, should be sorted already
    integer, intent(in) :: isrtrq(:) !< (ng) this is the index array returned by sorting ekin
    real(DP), intent(in) :: ecutoff  !< energy cutoff, in same units as ekin (Ry typically)

    integer :: gup, gdn, gmid, ig

    PUSH_SUB(gcutoff)

    ! perhaps all G-vectors fall within the cutoff
    if(ekin(isrtrq(ng)) < ecutoff) then
      gcutoff = ng
      POP_SUB(gcutoff)
      return
    endif

    ! otherwise, use bisection
    gup = ng
    gdn = 1

    do ig = 1, ng
      gmid = (gup + gdn) / 2
      if(gmid == gdn) exit
      if(ekin(isrtrq(gmid)) > ecutoff) then
        gup = gmid
      else
        gdn = gmid
      endif
    enddo
    gcutoff = gdn

    POP_SUB(gcutoff)
    return
  end function gcutoff

!=====================================================================
!> The identity must always be the first symmetry, as assumed in various places in the code.
  subroutine make_identity_symmetry_first(nsyms, mtrx, tnp)
    integer,  intent(in)    :: nsyms
    integer,  intent(inout) :: mtrx(3, 3, 48)
    real(DP), intent(inout) :: tnp(3, 48)

    integer :: isym, mtrx_temp(3, 3), identity(3,3)
    real(DP) :: tnp_temp(3)
    logical :: found

    PUSH_SUB(make_identity_symmetry_first)

    identity = reshape((/1, 0, 0, 0, 1, 0, 0, 0, 1/), shape(identity))
    found = all(mtrx(1:3, 1:3, 1) == identity(1:3, 1:3))

    do isym = 2, nsyms
      if(all(mtrx(1:3, 1:3, isym) == identity(1:3, 1:3))) then
        if(.not. found) then
          ! if identity is not first, swap
          mtrx_temp(1:3, 1:3)  = mtrx(1:3, 1:3, 1)
          mtrx(1:3, 1:3, 1)    = mtrx(1:3, 1:3, isym)
          mtrx(1:3, 1:3, isym) = mtrx_temp(1:3, 1:3)

          tnp_temp(1:3)  = tnp(1:3, 1)
          tnp(1:3, 1)    = tnp(1:3, isym)
          tnp(1:3, isym) = tnp_temp(1:3)

          found = .true.
          write(0,'(a,i2)') 'WARNING: making identity first by swapping with symmetry op #', isym
        else
          call die("There is a duplicate identity in the symmetry operations.")
        endif
      endif
    enddo

    if(.not. found) then
      call die("Identity is not present in the list of symmetries.")
    endif

    POP_SUB(make_identity_symmetry_first)
    return
  end subroutine make_identity_symmetry_first

!=====================================================================
!> Bring symmetries into a standardized order.
!! The identity is always the first one.
  subroutine sort_symmetries(nsyms, mtrx, tnp)
    integer,  intent(in)    :: nsyms
    integer,  intent(inout) :: mtrx(3, 3, 48)
    real(DP), intent(inout) :: tnp(3, 48)

    integer :: isym, ii, jj, factor, hash(48), order(48), mtrx_temp(3, 3, 48), identity(3,3)
    real(DP) :: tnp_temp(3, 48)

    PUSH_SUB(sort_symmetries)

    identity = reshape((/1, 0, 0, 0, 1, 0, 0, 0, 1/), shape(identity))

    do isym = 1, nsyms

      ! make sure the identity comes first
      if(all(mtrx(1:3, 1:3, isym) == identity(1:3, 1:3))) then
        hash(isym) = -1d9
        cycle
      endif

      hash(isym) = 0
      factor = 1
      do jj = 1, 3
        if(jj > 1) factor = factor * 3
        do ii = 1, 3
          if(ii > 1) factor = factor * 3
          hash(isym) = hash(isym) + mtrx(4 - ii, 4 - jj, isym) * factor
        enddo
      enddo
    enddo

    call sortix(nsyms, hash, order)

    do isym = 1, nsyms
      mtrx_temp(1:3, 1:3, isym) = mtrx(1:3, 1:3, order(isym))
      tnp_temp(1:3, isym) = tnp(1:3, order(isym))
    enddo

    mtrx(1:3, 1:3, 1:nsyms) = mtrx_temp(1:3, 1:3, 1:nsyms)
    tnp(1:3, 1:nsyms) = tnp_temp(1:3, 1:nsyms)

    POP_SUB(sort_symmetries)
    return
  end subroutine sort_symmetries

!=====================================================================

! FHJ: Use the preprocessor to create the following routines:
! sortix_gvec, sortix_no_gvec, sortrx_gvec, sortrx_no_gvec

#define DTYPE integer
#define LABEL sortix_gvec
#define HAS_GVEC
#include "sort_inc.f90"
#undef LABEL
#undef HAS_GVEC
#define LABEL sortix_no_gvec
#include "sort_inc.f90"
#undef LABEL
#undef DTYPE

#define DTYPE real(DP)
#define LABEL sortrx_gvec
#define HAS_GVEC
#include "sort_inc.f90"
#undef LABEL
#undef HAS_GVEC
#define LABEL sortrx_no_gvec
#include "sort_inc.f90"
#undef LABEL
#undef DTYPE

end module sort_m

!! Local Variables:
!! mode: f90
!! coding: utf-8
!! End:

!=================================================================================
!
! Routines:
!
! (1) g_sum()         Originally By JRD       Last Modified 2/11/2012 (FHJ)
!
!  Performs the sum over G for each (v,c,v',c') set.
!
!  This routine scales as N^5. This routine represents the worst 
!  scaling with number of atoms in Kernel code.
!
!  Bow down before it.
!
!=================================================================================

#include "f_defs.h"

module g_sum_m

  use global_m
  use blas_m
  implicit none

  public :: g_sum_TDA, g_sum_extended

  private

contains

  !> FHJ: Performs the summation over Gp to get the direct kernel term.
  !! This routine is specialized for TDA kernels.
  subroutine g_sum_TDA(xct,invband,incband,temph,tempb,mccp, &
    bsedhead,bsedbody,leading_dim,ivp_in,icp_in,ikp,iv_in,ic_in,ik,&
    tempw,bsedwing)
    type (xctinfo), intent(in) :: xct
    integer, intent(in) :: invband,incband,leading_dim
    integer, intent(in) :: ivp_in,icp_in,ikp,iv_in,ic_in,ik
    SCALAR, intent(in) :: tempb(:,:,:,:), temph(:,:,:), mccp(:,:,:,:)
    SCALAR, intent(inout) :: bsedhead(:,:,:), bsedbody(:,:,:)
    SCALAR, intent(in), optional :: tempw(:,:,:,:)
    SCALAR, intent(inout), optional :: bsedwing(:,:,:)

    integer :: isv, isc, iv, ivp, ic, icp, iit, iitend, iitbeG

    PUSH_SUB(g_sum_TDA)

    do isv=1,xct%nspin
      do isc=1,xct%nspin

        if (xct%icpar .eq. 0) then
          iit = peinf%wown(1,1,ikp,1,1,ik) - 1
        else if (xct%ivpar .eq. 0) then 
          iit = peinf%wown(1,icp_in,ikp,1,ic_in,ik) - 1
        else
          iit = peinf%wown(ivp_in,icp_in,ikp,iv_in,ic_in,ik) - 1
        endif

        iitbeg = iit + 1
        iitend = iit + invband*invband*incband*incband

        if (incband .gt. 1) then

          call X(gemm)('t','n',invband*invband,incband*incband,xct%ng, &
            ONE,tempb(:,:,:,isv),xct%ng,mccp(:,:,:,isc),xct%ng, &
            ONE,bsedbody(iitbeg:iitend,isc,isv),invband*invband)

          if (present(bsedwing)) &
            call X(gemm)('t','n',invband*invband,incband*incband,xct%ng, &
            ONE,tempw(:,:,:,isv),xct%ng,mccp(:,:,:,isc),xct%ng, &
            ONE,bsedwing(iitbeg:iitend,isc,isv),invband*invband)

        else

          call X(gemv)('t',xct%ng,invband*invband,ONE,tempb(:,:,:,isv),xct%ng,mccp(:,:,:,isc), &
            1,ZERO,bsedbody(iitbeg:iitend,isc,isv),1)

          if (present(bsedwing)) &
            call X(gemv)('t',xct%ng,invband*invband,ONE,tempw(:,:,:,isv),xct%ng,mccp(:,:,:,isc), &
            1,ZERO,bsedwing(iitbeg:iitend,isc,isv),1)

        endif

        if (iit + (incband*invband)**2 > leading_dim) then
          write(0,*) peinf%inode, ik, ikp
          write(0,*) peinf%wown(1,1,ikp,1,1,ik), iit
          write(0,*) peinf%nckpe, peinf%myown, leading_dim
          call die("Internal error in g_sum with array dimensions.")
        endif

        ! Head
        do icp = 1, incband
          do ic = 1, incband      
            do ivp = 1, invband
              do iv = 1, invband
                iit = iit + 1
                bsedhead(iit,isc,isv) = bsedhead(iit,isc,isv) + &
                  mccp(1,ic,icp,isc) * temph(iv,ivp,isv)
              enddo
            enddo
          enddo
        enddo

      enddo
    enddo

    POP_SUB(g_sum_TDA)

  end subroutine g_sum_TDA

  !> FHJ: Performs the summation over Gp to get the direct kernel term.
  !! This routine is generalized for extended kernels calculations.
  subroutine g_sum_extended(xct,ofs2,ofs2p,n2,n2p,temph,tempb,m22p, &
    bsedhead,bsedbody,leading_dim,ivp_in,icp_in,ikp,iv_in,ic_in,ik, &
    tempw, bsedwing)
    type (xctinfo), intent(in) :: xct
    integer, intent(in) :: ofs2, ofs2p
    integer, intent(in) :: n2, n2p
    integer, intent(in) :: leading_dim
    integer, intent(in) :: ivp_in,icp_in,ikp,iv_in,ic_in,ik
    SCALAR, intent(in) :: tempb(:,:,:,:), temph(:,:,:), m22p(:,:,:,:)
    SCALAR, intent(inout) :: bsedhead(:,:,:), bsedbody(:,:,:)
    SCALAR, intent(in), optional :: tempw(:,:,:,:)
    SCALAR, intent(inout), optional :: bsedwing(:,:,:)

    integer :: isv, isc, i1, i1p, i2, i2p, it, itbeg, it_buf
    integer :: n_left, n_right, buf_sz
    SCALAR, pointer :: buf_b(:), buf_w(:)

    PUSH_SUB(g_sum_extended)

    ! FHJ: n_left/n_right is the total number of val/cond states that this PE
    ! deals with. The number will be nv+nc for extended kernel calculations.
    ! However, whenever we deal with m22p, we should actually use n2/n2p +
    ! offsets, b/c the matrix m22p is decomposed in blocks.
    n_left = xct%n1b_co
    if (xct%ivpar==1) n_left = 1
    n_right = xct%n2b_co
    if (xct%icpar==1) n_right = 1
    buf_sz = n_left**2 * n2 * n2p
    SAFE_ALLOCATE(buf_b, (buf_sz))
    if (present(bsedwing)) then
      SAFE_ALLOCATE(buf_w, (buf_sz))
    endif

    do isv=1,xct%nspin
      do isc=1,xct%nspin

        if (xct%icpar .eq. 0) then
          itbeg = peinf%wown(1,1,ikp,1,1,ik)
        else if (xct%ivpar .eq. 0) then 
          itbeg = peinf%wown(1,icp_in,ikp,1,ic_in,ik)
        else
          itbeg = peinf%wown(ivp_in,icp_in,ikp,iv_in,ic_in,ik)
        endif

        if (n2>1 .or. n2p>1) then
          call X(gemm)('t','n',n_left**2,n2*n2p,xct%ng, &
            ONE,tempb(:,:,:,isv),xct%ng,m22p(:,:,:,isc),xct%ng, &
            ZERO,buf_b(:),n_left**2)

          if (present(bsedwing)) &
            call X(gemm)('t','n',n_left**2,n2*n2p,xct%ng, &
            ONE,tempw(:,:,:,isv),xct%ng,m22p(:,:,:,isc),xct%ng, &
            ZERO,buf_w(:),n_left**2)
        else
          call X(gemv)('t',xct%ng,n_left**2,ONE,tempb(:,:,:,isv),xct%ng,m22p(:,:,:,isc), &
            1,ZERO,buf_b(:),1)

          if (present(bsedwing)) &
            call X(gemv)('t',xct%ng,n_left**2,ONE,tempw(:,:,:,isv),xct%ng,m22p(:,:,:,isc), &
            1,ZERO,buf_w(:),1)
        endif

        if (itbeg-1 + (n_left*n_right)**2 > leading_dim) then
          write(0,*) peinf%inode, ik, ikp
          write(0,*) peinf%wown(1,1,ikp,1,1,ik), itbeg, n_left, n_right
          write(0,*) peinf%nckpe, peinf%myown, leading_dim
          call die("Internal error in g_sum with array dimensions.")
        endif

        do i2p = 1, n2p
          do i2 = 1, n2
            ! FHJ: max(it_buf) = n_left**2 * n2*n2p
            it_buf = 1 + n_left*n_left*((i2-1) + n2*(i2p-1))
            ! FHJ: max(it) = n_left**2 * n_right**2
            it = itbeg + n_left*n_left*((ofs2+i2-1) + n_right*(ofs2p+i2p-1))
            do i1p = 1, n_left
              do i1 = 1, n_left
                bsedhead(it,isc,isv) = temph(i1,i1p,isv) * m22p(1,i2,i2p,isc)
                if (present(bsedwing)) bsedwing(it,isc,isv) = buf_w(it_buf)
                bsedbody(it,isc,isv) = buf_b(it_buf)
                it = it + 1
                it_buf = it_buf + 1
              enddo
            enddo
          enddo
        enddo

      enddo
    enddo

    SAFE_DEALLOCATE_P(buf_b)
    if (present(bsedwing)) then
      SAFE_DEALLOCATE_P(buf_w)
    endif

    POP_SUB(g_sum_extended)

  end subroutine g_sum_extended

end module g_sum_m

!==============================================================================
!
! Utilities:
!
! (1) summarize_eigenvectors()       Originally By JRD,CHP   Last Modified: 6/5/2008 (JRD)
!
!     This program prints some useful information about the exciton wavefunction.
!
!==============================================================================

#include "f_defs.h"

program summarize_eigenvectors

  use global_m
  implicit none

  integer :: ns, nc, nv, nk, nmat, i, m, uu, c, v, s, ik, ikmax
  integer :: ijk, up,nexc, ninfile
  real(DP) :: energy, weight, wmax, emax, emin
  real(DP), allocatable :: kk(:,:), energies(:)
  SCALAR, allocatable :: Aread(:),A(:,:,:,:)
  character*20, allocatable :: filename(:)
  
  uu = 10
  up = 11
  
  call open_file(unit=uu,file='eigenvectors',form='unformatted',status='old')
  call open_file(unit=up,file='summarize_eigenvectors.inp',status='old')
  
  read(up,*) ninfile
  read(up,*) emin, emax
  read(up,*) nexc
  if (nexc .gt. 0) then
    SAFE_ALLOCATE(energies, (nexc))
    SAFE_ALLOCATE(filename, (nexc))
    do ijk =1, nexc
      read(up,*) energies(ijk)
    enddo
    do ijk =1, nexc
      write(filename(ijk),'(a8,i2.2)') 'exciton_',ijk
    enddo
  endif
  
  read(uu) ns
  read(uu) nv
  read(uu) nc
  read(uu) nk
  nmat = ns*nv*nc*nk
  
  if (ninfile .eq. 0) then
    ninfile = nmat
  endif
  
  write(6,'(a)')
  write(6,'(a)') 'Reading eigenvectors'
  write(6,'(a)')
  write(6,'(a,4i5)') ' ns, nv, nc, nk = ',ns,nv,nc,nk
  write(6,'(a,i8)') ' nmat = ',nmat
  SAFE_ALLOCATE(kk, (3,nk))
  read(uu) kk(:,:)
  write(6,'(a)')
  write(6,'(a)') 'kpoints follow:'
  do ik=1,nk
    write(6,'(i5,3f10.5)') ik, kk(:,ik)
  enddo
  write(6,'(a)')
  write(6,'(a)') 'exciton energies follow (eV)'
  write(6,'(a)') 'wtot = sum_k |A_vck|^2. wmax = max_k |A_vck|^2. |A_vc (ikmax)|^2 = wmax.'

  SAFE_ALLOCATE(Aread, (nmat))
  SAFE_ALLOCATE(A, (ns,nv,nc,nk))
  do i=1,ninfile
    read(uu) energy
    read(uu) Aread(:)
    if ((energy <= emax) .and. (energy >= emin))  then
      m = 0
      do ik=1,nk
        do c=1,nc
          do v=1,nv
            do s=1,ns
              m = m+1
              A(s,v,c,ik) = Aread(m)
            enddo
          enddo
        enddo
      enddo
      write(6,'(a)')
      write(6,'(a,i5,f10.5)') ' Special analysis for state ',i,energy
      write(6,'(2a5,3a10)') 'c','v','wtot','wmax','ikmax'
      do c=1,nc
        do v=1,nv
          weight = 0.0d0
          wmax = 0.0d0
          do ik=1,nk
            do s=1,ns
              weight = weight + abs(A(s,v,c,ik))**2
              if (abs(A(s,v,c,ik))**2 > wmax) then
                wmax = abs(A(s,v,c,ik))**2
                ikmax = ik
              endif
            enddo
          enddo
          write(6,'(2i5,2f10.5,i10)') c, v, weight, wmax, ikmax
        enddo
      enddo
      
      do ijk = 1, nexc
        if (abs(energy - energies(ijk)) .le. 1d-5) then
          write(6,'(a,i6,f12.6)') 'Calculating A(k) for :',ijk,energies(ijk)
          call open_file(unit=200+ijk,file=filename(ijk),status='replace')
          write(200+ijk, '(a,a9,2a10,a18)') '#', 'kx', 'ky', 'kz', 'sum |A(k)|^2'
          do ik=1,nk
            weight = 0.0d0
            do c=1,nc
              do v=1,nv
                do s=1,ns
                  weight = weight + abs(A(s,v,c,ik))**2
                enddo
              enddo
            enddo
            write(200+ijk,'(3f10.5,f18.5)') kk(1:3,ik),weight
          enddo
          call close_file(200+ijk)
        endif
      enddo
      
    endif
  enddo
  write(6,'(a)')
  call close_file(uu)
  
  SAFE_DEALLOCATE(kk)
  SAFE_DEALLOCATE(Aread)
  SAFE_DEALLOCATE(A)
  
end program summarize_eigenvectors

!================================================================================
!
! Modules:
!
! (1) global_m      Originally By das      Last Modified 8/20/2010 (das)
!
!     Global module to be used everywhere.
!
!================================================================================

#include "f_defs.h"

module global_m
    
  use intrinsics_m
  use message_m
  use nrtype_m
  use peinfo_m
  use push_pop_m
  use timing_m
  use typedefs_m
    
  implicit none
      
end module global_m

!================================================================================
!
! Program:
!
! printsvninfo      Originally By DAS
!
! Returns information on svn repository name, version, and revision number.
! For use by scripts to add version info to output.
!
!================================================================================

#include "f_defs.h"

program printsvninfo

  use global_m
  use svninfo_m
  implicit none

  character*256 :: string

  call getsvninfo(string)

  write(6,'(a)') trim(string)

end program printsvninfo

!================================================================================
!
! Modules:
!
! (1) lapack_m      Originally By DAS      Last Modified 1/13/2011 (das)
!
!     Interfaces for LAPACK functions, taken from http://www.netlib.org/lapack/double
!     and http://www.netlib.org/lapack/complex16.
!     Every LAPACK function used in the code should be listed here, and this
!     module should be used in every routine containing LAPACK calls to ensure
!     the argument types are correct.
!
!     Note that if any array name from netlib.org is X, the interface will
!     be interpreted as a preprocessor macro and cause a compilation failure,
!     solved by changed to lower-case x.
!
!================================================================================

#include "f_defs.h"

module lapack_m

  public ! only interfaces in this module

  interface
    SUBROUTINE DGESV( N, NRHS, A, LDA, IPIV, B, LDB, INFO )
      implicit none
      INTEGER            INFO, LDA, LDB, N, NRHS
      INTEGER            IPIV( * )
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * )
    end SUBROUTINE DGESV
  end interface

  interface
    SUBROUTINE ZGESV( N, NRHS, A, LDA, IPIV, B, LDB, INFO )
      implicit none
      INTEGER            INFO, LDA, LDB, N, NRHS
      INTEGER            IPIV( * )
      COMPLEX*16         A( LDA, * ), B( LDB, * )
    end SUBROUTINE ZGESV
  end interface

  interface
    SUBROUTINE ZHPEVX( JOBZ, RANGE, UPLO, N, AP, VL, VU, IL, IU, &
      ABSTOL, M, W, Z, LDZ, WORK, RWORK, IWORK, IFAIL, INFO )
      implicit none
      CHARACTER          JOBZ, RANGE, UPLO
      INTEGER            IL, INFO, IU, LDZ, M, N
      DOUBLE PRECISION   ABSTOL, VL, VU
      INTEGER            IFAIL( * ), IWORK( * )
      DOUBLE PRECISION   RWORK( * ), W( * )
      COMPLEX*16         AP( * ), WORK( * ), Z( LDZ, * )
    end SUBROUTINE ZHPEVX
  end interface

  interface
    SUBROUTINE ZHEEVX( JOBZ, RANGE, UPLO, N, A, LDA, VL, VU, IL, IU, &
      ABSTOL, M, W, Z, LDZ, WORK, LWORK, RWORK, IWORK, IFAIL, INFO )
      implicit none
      CHARACTER          JOBZ, RANGE, UPLO
      INTEGER            IL, INFO, IU, LDA, LDZ, LWORK, M, N
      DOUBLE PRECISION   ABSTOL, VL, VU
      INTEGER            IFAIL( * ), IWORK( * )
      DOUBLE PRECISION   RWORK( * ), W( * )
      COMPLEX*16         A( LDA, * ), WORK( * ), Z( LDZ, * )
    end SUBROUTINE ZHEEVX
  end interface

  interface
    SUBROUTINE DGETRF( M, N, A, LDA, IPIV, INFO )
      implicit none
      INTEGER            INFO, LDA, M, N
      INTEGER            IPIV( * )
      DOUBLE PRECISION   A( LDA, * )
    end SUBROUTINE DGETRF
  end interface

  interface
    SUBROUTINE DGETRI( N, A, LDA, IPIV, WORK, LWORK, INFO )
      implicit none
      INTEGER            INFO, LDA, LWORK, N
      INTEGER            IPIV( * )
      DOUBLE PRECISION   A( LDA, * ), WORK( * )
    end SUBROUTINE DGETRI
  end interface

  interface
    SUBROUTINE ZGETRF( M, N, A, LDA, IPIV, INFO )
      implicit none
      INTEGER            INFO, LDA, M, N
      INTEGER            IPIV( * )
      COMPLEX*16         A( LDA, * )
    end SUBROUTINE ZGETRF
  end interface

  interface
    SUBROUTINE ZGETRI( N, A, LDA, IPIV, WORK, LWORK, INFO )
      implicit none
      INTEGER            INFO, LDA, LWORK, N
      INTEGER            IPIV( * )
      COMPLEX*16         A( LDA, * ), WORK( * )
    end SUBROUTINE ZGETRI
  end interface

  interface
    SUBROUTINE ZHEEV( JOBZ, UPLO, N, A, LDA, W, WORK, LWORK, RWORK, INFO )
      implicit none
      CHARACTER          JOBZ, UPLO
      INTEGER            INFO, LDA, LWORK, N
      DOUBLE PRECISION   RWORK( * ), W( * )
      COMPLEX*16         A( LDA, * ), WORK( * )
    end SUBROUTINE ZHEEV
  end interface

  interface
    SUBROUTINE DSYEV( JOBZ, UPLO, N, A, LDA, W, WORK, LWORK, INFO )
      implicit none
      CHARACTER          JOBZ, UPLO
      INTEGER            INFO, LDA, LWORK, N
      DOUBLE PRECISION   A( LDA, * ), W( * ), WORK( * )
    end SUBROUTINE DSYEV
  end interface

  interface
    SUBROUTINE DGEQRF( M, N, A, LDA, TAU, WORK, LWORK, INFO )
      implicit none
      INTEGER            INFO, LDA, LWORK, M, N
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( * )
    end SUBROUTINE DGEQRF
  end interface

  interface
    SUBROUTINE ZGEQRF( M, N, A, LDA, TAU, WORK, LWORK, INFO )
      implicit none
      INTEGER            INFO, LDA, LWORK, M, N
      COMPLEX*16         A( LDA, * ), TAU( * ), WORK( * )
    end SUBROUTINE ZGEQRF
  end interface

  interface
    SUBROUTINE DORGQR( M, N, K, A, LDA, TAU, WORK, LWORK, INFO )
      implicit none
      INTEGER            INFO, K, LDA, LWORK, M, N
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( * )
    end SUBROUTINE DORGQR
  end interface

  interface
    SUBROUTINE ZUNGQR( M, N, K, A, LDA, TAU, WORK, LWORK, INFO )
      implicit none
      INTEGER            INFO, K, LDA, LWORK, M, N
      COMPLEX*16         A( LDA, * ), TAU( * ), WORK( * )
    end SUBROUTINE ZUNGQR
  end interface

  interface
    SUBROUTINE DPOTRF( UPLO, N, A, LDA, INFO )
      implicit none
      CHARACTER          UPLO
      INTEGER            INFO, LDA, N
      DOUBLE PRECISION   A( LDA, * )
    end SUBROUTINE DPOTRF
  end interface
  
end module lapack_m

!==========================================================================
!
! lin_denominator_m   Originally By Liang Z. Tan         2/8/2013
!
!    computes the integral of
!
!      Theta(Ef-Ev(k))Theta(Ec(k+q)-Ef)/(Ev(k)-Ec(k+q)+w+i0+)
!
!    where the range of integration over k is the mini-BZ and 
!    Ec(k+q) and Ev(k) are approximated as linear functions of k 
!    (i.e. planes).
!    Currently implemented for 2D. 
!    z-direction is the out-of-plane direction.
!
!    input: k, energies and velocities at k, k+q, frequency, Ef.
!    output: (complex) value of the integral.
!
!==========================================================================



#include "f_defs.h"

module lin_denominator_m

  use global_m
  use sort_m
  implicit none

  !> define boundaries as a useful type
  !! x = slope * y + intercept
  type boundary 
    real(DP) :: slope, intercept
    real(DP) :: sgn 
  end type boundary

  private
  public :: integrate_mbz
   
contains
 
  !> this integrates log|ax+b| over x in [0,1].
  real(DP) function integratelog(a,b)
    real(DP), intent(in) :: a,b

    PUSH_SUB(integratelog)

    if(abs(a) > TOL_Zero .and. abs(b)>TOL_Zero) then
      if(abs(a+b) > TOL_Zero) then
        integratelog = -1.0d0 -(b/a)*log(abs(b))+((a+b)/a)*log(abs(a+b))
      else
        integratelog = -1.0d0 -(b/a)*log(abs(b))
      endif
    elseif(abs(a) > TOL_Zero .and. abs(b)<TOL_Zero) then
      if(abs(a+b) > TOL_Zero) then
        integratelog = -1.0d0 +((a+b)/a)*log(abs(a+b))
      else
        integratelog = -1.0d0 
      endif
    else
      integratelog = log(abs(b))
    endif
    !write(6,*) "integratelog: a= ",a," b= ",b," ans= ",integratelog

    POP_SUB(integratelog)

  end function integratelog

  !> evaluate a linear function at a point
  real(DP) function evalb(b,y)
    type(boundary), intent(in) :: b
    real(DP), intent(in) :: y

    PUSH_SUB(evalb)

    evalb = b%slope * y + b%intercept

    POP_SUB(evalb)
  end function evalb

  !> intersection point of two lines
  real(DP) function critfn(b1,b2)
    type(boundary), intent(in) :: b1, b2

    PUSH_SUB(critfn)
    if(b1%slope /= b2%slope) then
      critfn = (b2%intercept - b1%intercept)/(b1%slope - b2%slope)
    else
      critfn = 100
    end if

    POP_SUB(critfn)
  end function critfn


  !> imaginary part of the integral 1/(ux*kx+uy*ky+1+J*eta)
  !! over a trapezoid in 2D
  real(DP) function trapzimagpart(ux,uy,y0,y1,bdl,bdu)
    real(DP),intent(in) :: ux,uy,y0,y1
    type(boundary),intent(in) :: bdl, bdu

    real(DP) :: yl,yu,x1,x0,x0l,x0u,x1l,x1u,pi,yc
    type(boundary) :: bdsing

    PUSH_SUB(trapzimagpart)

    pi = 4.d0*datan(1.d0)

    if(evalb(bdl,(y0+y1)/2) > evalb(bdu,(y0+y1)/2)) then
      trapzimagpart = 0d0 
    elseif(abs(ux)<TOL_Zero .and. abs(uy)<TOL_Zero) then
      trapzimagpart = 0d0
    elseif (abs(ux)<TOL_Zero) then
      yc = -1.0d0/uy
      if( yc<y1 .and. yc>y0) then
        trapzimagpart = -pi*(evalb(bdu,yc)-evalb(bdl,yc))/abs(uy)
      else
        trapzimagpart = 0d0
      endif
    else
      bdsing%slope = -uy/ux
      bdsing%intercept = -1.0d0/ux
      yu = critfn(bdsing,bdu)
      yl = critfn(bdsing,bdl)
      x1 = evalb(bdsing,y1)
      x0 = evalb(bdsing,y0)
      x0l= evalb(bdl,y0)
      x0u= evalb(bdu,y0)
      x1l= evalb(bdl,y1)
      x1u= evalb(bdu,y1)
      if ((x0<x0l .and. x1<x1l) .or. (x0>x0u .and. x1>x1u)) then 
        trapzimagpart=0d0
      elseif(x0>x0l .and. x0<x0u .and. x1>x1l .and. x1<x1u) then
        trapzimagpart= -pi*abs(y1-y0)/abs(ux)
      elseif((x0<x0l .and. x1>x1u) .or. (x0>x0u .and. x1<x1l))then
        trapzimagpart = -pi*abs(yl-yu)/abs(ux)
      elseif(x0<x0l .and. x1>x1l .and. x1<x1u) then
        trapzimagpart = -pi*abs(y1-yl)/abs(ux)
      elseif(x0>x0u .and. x1>x1l .and. x1<x1u) then 
        trapzimagpart = -pi*abs(y1-yu)/abs(ux)
      elseif(x1<x1l .and. x0>x0l .and. x0<x0u) then 
        trapzimagpart = -pi*abs(yl-y0)/abs(ux)
      !elseif(x1>x1u .and. x0>x0l .and. x0<x0u) then
      else
        trapzimagpart = -pi*abs(yu-y0)/abs(ux)
      endif
    endif

    POP_SUB(trapzimagpart)
  end function trapzimagpart

  !> real part of the integral 1/(ux*kx+uy*ky+1+J*eta)
  !! over a trapezoid in 2D
  real(DP) function trapzrealpart(ux,uy,y0,y1,bdl,bdu)
    real(DP),intent(in) :: ux,uy,y0,y1
    type(boundary),intent(in) :: bdl, bdu

    real(DP) :: a,b,part1, part2

    PUSH_SUB(trapzrealpart)

    if(evalb(bdl,(y0+y1)/2) > evalb(bdu,(y0+y1)/2)) then
      trapzrealpart = 0d0 
    elseif( abs(ux)<TOL_Small .and. abs(uy)<TOL_Small) then
      trapzrealpart = 0.5*(y1-y0)&
      *(evalb(bdu,y0)-evalb(bdl,y0)+evalb(bdu,y1)-evalb(bdl,y1))
    elseif(abs(ux)<TOL_Small) then
      a = (bdu%slope-bdl%slope)/uy
      b = bdu%intercept-bdl%intercept - a
      part1 = (y1-y0)*a
      part2 = (b/uy)*(log(abs(uy*y1+1.0d0))-log(abs(uy*y0+1.0d0)))
      trapzrealpart = part1 + part2
    else
      a = (ux*bdu%slope+uy)*(y1-y0)
      b = (ux*bdu%slope+uy)*y0+ux*bdu%intercept+1.0d0
      part1 = (y1-y0)/ux * integratelog(a,b)
      a = (ux*bdl%slope+uy)*(y1-y0)
      b = (ux*bdl%slope+uy)*y0+ux*bdl%intercept+1.0d0
      part2 = (y1-y0)/ux * integratelog(a,b)
      trapzrealpart = part1 - part2
    endif

    POP_SUB(trapzrealpart)
  end function trapzrealpart

  !> picks the relevant boundaries from a list
  subroutine actb(bs,y,b0,b1)
    type(boundary), intent(in) :: bs(4)
    type(boundary), intent(out) :: b0,b1

    type(boundary) :: b,bs0(4), bs1(4)
    integer :: i,nbs0,nbs1, xidx
    real(DP), intent(in) :: y
    real(DP) :: x,xtry

    PUSH_SUB(actb)

    nbs0=0
    nbs1=0
    do i = 1,4
      b = bs(i)
      if(b%sgn>0) then
        nbs0 = nbs0 +1
        bs0(nbs0) = b
      else
        nbs1 = nbs1 +1
        bs1(nbs1) = b
      endif
    enddo

    x = -100
    do i = 1,nbs0
      xtry = evalb(bs0(i),y)
      if(xtry> x) then
        x = xtry
        xidx = i
      endif
    enddo
    b0 = bs0(xidx) 
   
    x = 100
    do i = 1,nbs1
      xtry = evalb(bs1(i),y)
      if(xtry<x) then
        x = xtry
        xidx = i
      endif
    enddo
    b1 = bs1(xidx)
    POP_SUB(actb) 
  end subroutine actb

  !> computes the interval (ymin,ymax) from a set of n linear inequalities
  !! that y satisfies.
  !! Each inequality is modelled as a boundary a*y + c > 0 or a*y + c < 0
  !! where a = slope, c = intercept, > : sgn=1.0, < : sgn=-1.0
  !! Implicit bounds (0,1) assumed.
  !! If there is no solution, a zero-length interval is returned.
  subroutine intervals(n,ineqs,ymin,ymax)
    integer,intent(in) :: n
    type(boundary),intent(in) :: ineqs(:)
    real(DP),intent(out) :: ymin,ymax

    integer :: ii
    real(DP) :: a,c,s,y2

    PUSH_SUB(intervals)

    ymin = 0.0d0
    ymax = 1.0d0

    do ii = 1,n
      a=ineqs(ii)%slope
      c=ineqs(ii)%intercept
      s=ineqs(ii)%sgn
      if(abs(a)<TOL_Small)then
        if(s*c<0.0d0) then
          ymax = ymin
          exit
        endif
      else
        if(s*a>0.0) then
          y2 = -c/a
          if(y2>ymin)then 
            ymin = y2
          endif
          if(ymin>ymax) then 
            ymin = ymax
            exit
          endif
        else
          y2 = -c/a
          if(y2<ymax)then 
            ymax = y2
          endif
          if(ymax<ymin) then 
            ymax = ymin
            exit
          endif
        endif
      endif
    enddo

    POP_SUB(intervals)
  end subroutine intervals

  !> exact value of the integral Theta(a.r+c)Theta(b.r+c)/(u.r+1) 
  !! over the unit square in 2D.
  complex(DP) function exactmodel1(ax,ay,c,bx,by,d,ux,uy)
    real(DP), intent(in) :: ax,ay,c,bx,by,d,ux,uy 

    type(boundary) :: bd0, bd1, bd2, bd3, bds(4)
    type(boundary) :: bl,bu,bls(7),bus(7),intv1,intv2
    real(DP) :: critpts0(5), y(7), yval, accu_real, accu_imag,ymin,ymax
    complex(DP) :: accu
    integer ::  critpts0_idx(5)
    integer :: num_crit
    integer :: i 

    PUSH_SUB(exactmodel1)

    !make boundaries
    bd0%slope = 0d0
    bd0%intercept = 0d0
    bd0%sgn = 1.0d0
    bd1%slope = 0d0
    bd1%intercept = 1.0d0
    bd1%sgn = -1.0d0

    if(abs(ax)>TOL_Small .and. abs(bx)>TOL_Small) then
      bd2%slope = -ay/ax
      bd2%intercept = -c/ax
      bd2%sgn = sign(1.0d0,ax)
      bd3%slope = -by/bx
      bd3%intercept = -d/bx
      bd3%sgn = sign(1.0d0,bx)

      ymin = 0.0d0
      ymax = 1.0d0
    elseif(abs(ax)<TOL_Small .and. abs(bx)>TOL_Small) then
      bd2%slope = 1.0d0 !< dummy boundary
      bd2%intercept = 100.0 !<dummy boundary
      bd2%sgn = -1.0d0 !<dummy boundary

      bd3%slope = -by/bx
      bd3%intercept = -d/bx
      bd3%sgn = sign(1.0d0,bx)

      intv1 = boundary(ay,c,1.0d0)
      call intervals(1,(/intv1/),ymin,ymax)
      !write(6,*) "ymin= ",ymin,"ymax= ",ymax

 
    elseif(abs(ax)>TOL_Small .and. abs(bx)<TOL_Small) then
      bd2%slope = -ay/ax
      bd2%intercept = -c/ax
      bd2%sgn = sign(1.0d0,ax)
      bd3%slope = 1.0d0 !< dummy boundary
      bd3%intercept = 100.0d0 !<dummy boundary
      bd3%sgn = -1.0d0 !<dummy boundary

      intv1 = boundary(by,d,1.0d0)
      call intervals(1,(/intv1/),ymin,ymax)
 
    else !both ax and bx small
      bd2%slope = 0.9d0 !< dummy boundary
      bd2%intercept = 101.0d0 !<dummy boundary
      bd2%sgn = -1.0d0 !<dummy boundary
      bd3%slope = 1.0d0 !< dummy boundary
      bd3%intercept = 100.0d0 !<dummy boundary
      bd3%sgn = -1.0d0 !<dummy boundary

      intv1 = boundary(ay,c,1.0d0)
      intv2 = boundary(by,d,1.0d0)
      call intervals(2,(/intv1,intv2/),ymin,ymax)
      !write(6,*) "ymin= ",ymin,"ymax= ",ymax
    endif

    bds(1) = bd0
    bds(2) = bd1
    bds(3) = bd2
    bds(4) = bd3
     
    !first split integration region into trapezoids
    !start by finding where the boundaries intersect
    critpts0(1) = critfn(bd0,bd2)
    critpts0(2) = critfn(bd0,bd3)
    critpts0(3) = critfn(bd1,bd2)
    critpts0(4) = critfn(bd1,bd3)
    critpts0(5) = critfn(bd2,bd3)
  
    call sortrx(5,critpts0,critpts0_idx)
    num_crit = 2
    y(1) = ymin
    do i = 1,5
      yval = critpts0(critpts0_idx(i))
      if(yval>ymin .and. yval<ymax) then
        y(num_crit) = yval
        num_crit = num_crit + 1
      endif
    enddo
    y(num_crit) = ymax
    

    !make the list of lower and upper boundaries
    do i = 1,num_crit-1
      call actb(bds,(y(i)+y(i+1))/2,bl,bu)
      bls(i) = bl
      bus(i) = bu
    enddo

    !sum over all the trapezoids
    accu = (0,0)
    do i = 1,num_crit-1
      !write(6,*) "ux= ",ux,"uy= ",uy,"yi= ",y(i),"yi1= ",y(i+1),&
      !"bls= ",bls(i),"bus= ",bus(i)
      accu_real = trapzrealpart(ux,uy,y(i),y(i+1),bls(i),bus(i))
      accu_imag = trapzimagpart(ux,uy,y(i),y(i+1),bls(i),bus(i))
      accu = accu + CMPLX(accu_real,accu_imag)
    enddo

    exactmodel1 = accu

    !write(6,*) "exactmodel1= ",exactmodel1

    POP_SUB(exactmodel1)
  end function exactmodel1

  !> compute integral in miniBZ from energies and velocities
  !! NOTE: currently for 2D only. z-direction is the out-of-plane direction.
  complex(DP) function integrate_mbz(kpts,k,ek,ekq,vk,vkq,w,ef)
    type(kpoints), intent(in) :: kpts
    real(DP), intent(in) :: k(3)
    real(DP), intent(in):: ek, ekq, vk(2), vkq(2), w,ef 

    real(DP) :: kx,ky,dkx,dky,kxmin,kymin,vkx,vky,vkqx,vkqy, &
                cc,ux,uy,ax,ay,c,bx,by,d
    complex(DP) :: accu
    integer :: ii, ix, iy

    PUSH_SUB(integrate_mbz)

    ! need to know which is the out of plane direction
    ix = 1
    iy = 2
    do ii = 1,3
      if(kpts%kgrid(ii) == 1) then
        if(ii <= ix) then
          ix = ix +1
        endif
        if(ii <= iy) then
          iy = iy +1
        endif
      endif 
    enddo

    dkx = 1.0d0/real(kpts%kgrid(ix)) 
    dky = 1.0d0/real(kpts%kgrid(iy)) 
    kx = k(ix)
    ky = k(iy)
    vkx = vk(1)
    vky = vk(2)
    vkqx = vkq(1)
    vkqy = vkq(2)
    kxmin = kx-dkx/2.0
    kymin = ky-dky/2.0

    cc = (vkx-vkqx)*kxmin + (vky-vkqy)*kymin + &
         (ek - ekq +(vkqx-vkx)*kx +(vkqy-vky)*ky + w)
    ux = (vkx-vkqx)*dkx/cc
    uy = (vky-vkqy)*dky/cc

    
    accu = (0,0)
    !k occ, kq unocc
    ax = vkx*dkx
    ay = vky*dky
    c = vkx*kxmin+vky*kymin-vkx*kx-vky*ky+ek-ef
    bx = -vkqx*dkx
    by = -vkqy*dky
    d = -vkqx*kxmin-vkqy*kymin+vkqx*kx+vkqy*ky+(ef-ekq)
    accu = accu -  exactmodel1(ax,ay,c,bx,by,d,ux,uy)/cc

    !if(dble(accu)> 0.0) then
    !  write(6,*) "accu1= ",accu,"vkx= ",vkx,"vky= ",vky,&
    !  "vkqx= ",vkqx,"vkqy= ",vkqy,&
    !  "ax",ax,"ay",ay,"bx",bx,"by",by,&
    !  "c= ",c,"d= ",d,"cc= ",cc
    !endif

    ! k occ, kq unocc
    ax = -vkx*dkx
    ay = -vky*dky
    c = -1.0d0*(vkx*kxmin+vky*kymin-vkx*kx-vky*ky+ek-ef)
    bx = vkqx*dkx
    by = vkqy*dky
    d = -1.0d0*(-vkqx*kxmin-vkqy*kymin+vkqx*kx+vkqy*ky+(ef-ekq))
    accu = accu +  exactmodel1(ax,ay,c,bx,by,d,ux,uy)/cc

    !if(dble(accu)> 0.0) then
    !  write(6,*) "accu2= ",accu,"vkx= ",vkx,"vky= ",vky,&
    !  "vkqx= ",vkqx,"vkqy= ",vkqy,&
    !  "ax",ax,"ay",ay,"bx",bx,"by",by,&
    !  "c= ",c,"d= ",d,"cc= ",cc
    !endif

    integrate_mbz = accu
    POP_SUB(integrate_mbz)
  end function integrate_mbz

end module lin_denominator_m

!================================================================================
!
! Routines:
!
! 1. trunc_cell_wire()        Originally By MLT       Last Modified 6/12/2008 (JRD)
!
!    Calculate Coulomb interaction with wire boundary conditions. V_coul
!    is calculated using truncation of periodic images following this method:
!    S. Ismail-Beigi, PRB 73, 233103 (2006).
!
!    The Coulomb potential is calculated through 2-D FFT on the extended cell.
!
!    n_in_wire is a (positive integer) parameter for real-space resolution.
!    If the energy cutoff is too small, then the FFT grid may not be very
!    dense and the Coulomb singularity at r=0 may be poorly handled.
!    Larger values of n_in_wire will add extra points in between the original
!    FFT grid. If the original grid has N points covering a space of length
!    L, then the grid used to do 2-dimensional FFTs will have N * n_in_wire
!    points covering a space of length L.
!
!    When V_coul(x,y,G_3+qz) is calculated, we add a shift on the grid in
!    order to avoid the singularity at x = y = 0.
!
!    Output is truncated Vcoul(G_1,G_2,G_3+qz) in reciprocal space such that,
!    without truncation, its value would be:
!
!             Vcoul(ig) = 8 Pi/(q + G)*2
!
!    for each G-vector  G = gvec%components(:,isrtq(ig)) in the list.
!
!    Calculation is distributed over processors but array vcoul returns
!    with global value.
!
!================================================================================

#include "f_defs.h"

subroutine trunc_cell_wire(gvec,verbose,inode,npes,bdot,qz,ncoul,isrtq,vcoul)

  use global_m
  use bessel_m
  use fft_parallel_m
  use fftw_m
  use misc_m
  implicit none

  type (gspace), intent(in)  :: gvec         !< Reciprocal space structure
  logical,       intent(in)  :: verbose      !< Flag for extra output on unit 6
  integer,       intent(in)  :: inode, npes  !< MPI parameters: processor rank, number of processors
  real(DP),      intent(in)  :: bdot(3,3)    !< Metric matrix in reciprocal space, assumed to be symmetric 
                                             !! and such that bdot(1,3) = bdot(2,3) = 0
  real(DP),      intent(in)  :: qz           !< Length of q-vector along z (z component only, not the entire vector!)
  integer,       intent(in)  :: ncoul        !< Number of G-vectors
  integer,       intent(in)  :: isrtq(ncoul) !< Indices of G-vectors
  real(DP),      intent(out) :: vcoul(ncoul) !< Coulomb potential

  integer :: i1, i2, j1, j2, j3, l1, l2, l3, ig, &
    Nfft(3), dNfft(3), dkmax(3), i, j, Gzmin, Gzmax, NSize(3)
  real(DP) :: gpq_z, r_len, rr(3), t_len, tt(3), adot(3,3), &
    scale, dscale, phase, vimag, vdummy
  complex(DPC) :: vtemp
  real(DP), allocatable :: xdummy(:)
  complex(DPC), allocatable :: fftbox_2D(:,:,:)
  integer, allocatable :: inv_indx(:,:,:)

  PUSH_SUB(trunc_cell_wire)
  
  ! Check metric matrix in reciprocal space
  
  if (abs(bdot(1,3)) .gt. TOL_Zero .or. abs(bdot(2,3)) .gt. TOL_Zero) &
    call die('For wire truncation, the 1st and 2nd lattice vectors must be perpendicular to the 3rd.', only_root_writes = .true.)

  ! Initialize FFT grids.
  
  call setup_FFT_sizes(gvec%FFTgrid,Nfft,scale)
  dkmax(1) = gvec%FFTgrid(1) * n_in_wire
  dkmax(2) = gvec%FFTgrid(2) * n_in_wire
  dkmax(3) = 1
  call setup_FFT_sizes(dkmax,dNfft,dscale)

! Initialize real-space metric. If everything goes well, value of
! rr(3) should remain always zero.

  rr = 0.0d0
  tt = 0.0d0
  call invert_matrix(bdot, adot)
  adot = adot * 4.d0 * PI_D * PI_D
  
  do i=1,2
    do j=1,2
      adot(i,j)=adot(i,j)/(1.d0 * dNfft(i) * dNfft(j))
    enddo
  enddo

! Initialize boxes.

  SAFE_ALLOCATE(fftbox_2D, (dNfft(1),dNfft(2),1))
  
  if (verbose) then
    if (inode .eq. 0) then
      write(6,555) dNfft(1:2), n_in_wire
    endif
  endif
555 format(/,1x,"Cell truncation.",/,2x,"Building truncated Coulomb", &
      1x,"potential using 2-D FFTs.",/,2x,"2-D FFT grid =",2i5,/,2x, &
      "Extra points between two points in a 2-D FFT grid =",i3,/)

! Invert G-index.

  SAFE_ALLOCATE(inv_indx, (Nfft(1),Nfft(2),Nfft(3)))
  call fft_map_s(ncoul,Nfft,isrtq,gvec%components,inv_indx)

! Find Gzmin & Gzmax.

  Gzmin = 0
  Gzmax = 0
  do ig = 1, ncoul
    if (gvec%components(3,isrtq(ig)) .lt. Gzmin) &
      Gzmin = gvec%components(3,isrtq(ig))
    if (gvec%components(3,isrtq(ig)) .gt. Gzmax) &
      Gzmax = gvec%components(3,isrtq(ig))
  enddo

  vcoul = 0.0d0
  vimag = 0.0d0
  do j3 = Gzmin, Gzmax
    if (mod(j3 - Gzmin, npes) /= inode) cycle

!#ifdef VERBOSE
!    if (verbose) then
!      if (inode .eq. 0) then
!        write(6,*) 'vcoul_cell', inode, j3
!      endif
!    endif
!#endif

    l3 = j3 + 1
    if (j3 < 0) l3 = Nfft(3) + l3
    gpq_z = abs(j3 + qz) * sqrt( bdot(3,3) )

! For each G_3 plane, calculate the potential V_trunc(r1,r2,G_3+qz).
! The potential is not zero only inside the Wigner-Seitz cell.
! Because of the logarithmic singularity, we must separate the case
! G_3 + qz = 0.

    do i2 = 1, dNfft(2)
      rr(2) = dble(i2 - 1) + trunc_shift(2)
      do i1 = 1, dNfft(1)
        rr(1) = dble(i1 - 1) + trunc_shift(1)
        
        r_len = INF
        
        do l2 = -ncell+1, ncell
          tt(2) = rr(2) - dble(l2 * dNfft(2))
          do l1 = -ncell+1, ncell
            tt(1) = rr(1) - dble(l1 * dNfft(1))
            t_len = dot_product(tt,matmul(adot,tt))
            if (t_len < r_len) r_len = t_len
          enddo
        enddo
        
        r_len = sqrt(r_len)

! JRD/MJ: You can split the log into two terms and the divergent gpq_z term
! is zero if you use the framework of Ismail-Beigi

        if (abs(gpq_z) < TOL_Small) then
          fftbox_2D(i1,i2,1) = -log( r_len )
        else
          fftbox_2D(i1,i2,1) = dbesk0( gpq_z * r_len )
        endif
        
      enddo
    enddo

! Do a two-dimensional Fourier transform:
! V_trunc(r1,r2,G_3+qz) -> V_trunc(G_1,G_2,G_3+qz)

! Do FFT

    NSize(:)=dNfft(:)
    NSize(3)=1
    call do_fft(fftbox_2D,NSize,-1)

! Collect components of V_trunc for G-vectors in Coulomb list.

    do j2 = - Nfft(2)/2, Nfft(2) - Nfft(2)/2 - 1
      l2 = j2 + 1
      if (j2 < 0) l2 = Nfft(2) + l2
      i2 = j2 + 1
      if (j2 < 0) i2 = dNfft(2) + i2
      do j1 = - Nfft(1)/2, Nfft(1) - Nfft(1)/2 - 1
        l1 = j1 + 1
        if (j1 < 0) l1 = Nfft(1) + l1
        i1 = j1 + 1
        if (j1 < 0) i1 = dNfft(1) + i1
        ig = inv_indx(l1,l2,l3)
        if (ig == 0) cycle

! (gsm) [2010-06-17] there was a bug here
! the singularity of the Coulomb potential was shifted from
! the origin of the coordinate system by half a grid step

!            vcoul(ig) = dble(fftbox_2D(i1,i2))

        phase = dble(j1) * trunc_shift(1) / dble(dNfft(1)) + dble(j2) * trunc_shift(2) / dble(dNfft(2))
        phase = 2.0d0 * PI_D * phase
        vtemp = fftbox_2D(i1,i2,1)
        vtemp = vtemp * CMPLX(cos(phase), -sin(phase))
        vcoul(ig) = dble(vtemp)
        vdummy = abs(IMAG(vtemp))
        if (vdummy.gt.vimag) vimag=vdummy
      enddo
    enddo

  enddo ! j3

#ifdef MPI
  if (npes .gt. 1) then
    vdummy = vimag
    call MPI_Reduce(vdummy, vimag, 1, MPI_REAL_DP, MPI_MAX, 0, MPI_COMM_WORLD, mpierr)
  endif
#endif
  if (vimag.gt.TOL_Small) &
    call die("The Coulomb interaction was incorrectly computed as complex: most likely a problem with your FFT library.", &
    only_root_writes = .true.)

  call destroy_fftw_plans()
  SAFE_DEALLOCATE(fftbox_2D)
  SAFE_DEALLOCATE(inv_indx)
  
! Rescale with the area of the unit cell in the xy plane.

  scale = adot(1,1)*adot(2,2) - adot(1,2)*adot(2,1)
  scale = 4.d0 * sqrt(scale)
  vcoul = vcoul * scale

! Global reduction if there is more than one processor.

#ifdef MPI
  if (npes .gt. 1) then
    SAFE_ALLOCATE(xdummy, (ncoul))
    xdummy = vcoul
    call MPI_Allreduce(xdummy, vcoul, ncoul, MPI_REAL_DP, MPI_SUM, MPI_COMM_WORLD, mpierr)
    SAFE_DEALLOCATE(xdummy)
  endif
#endif

  POP_SUB(trunc_cell_wire)

  return
end subroutine trunc_cell_wire

!===============================================================================
!
! MODULE:
!
!   cells_m                Originally by FHJ     Last Modified 10/24/2011 (FHJ)
!
!>    Implements cell lists to partition the space and permit quick search of
!!    points.
!
!===============================================================================

#include "f_defs.h"

module cells_m

  use global_m
  implicit none

  private

  type :: cells_t
    integer :: dims !< Number of dimensions
    integer :: npts !< Number of points/particles/etc
    integer :: n_cells(3) !< Number of cells in each particular dimension
    real(DP) :: dmin(3) !< Min coordinate of cell
    real(DP) :: dmax(3) !< Max coordinate of cell
    real(DP) :: shift(3) !< 
    real(DP) :: factor(3) !< 
    real(DP), pointer :: pts(:,:) !< The points (dims, npts)
    integer, pointer :: head(:,:,:)
    integer, pointer :: list(:)
    logical :: periodic !< Use periodic boundary conditions?
    logical :: active_dim(3) !< Whether a direction is active or degenerate
  end type cells_t

  public :: cells_t, &
    cells_init, &
    cells_free, &
    cells_get_cell_idx, &
    cells_find_exactly

contains


  !> Puts all points pts(3,:) into a cell structure.
  !! If the cell is periodic, all points are moved to the [0, 1) range.
  !! This subroutine automatically detects the number of dimension spanned by
  !! the points, and it might be a good idea for the caller to check that.
  !! eg: this%dims == xct%idimensions
  subroutine cells_init(this, pts, periodic, quiet)
    type(cells_t), intent(out) :: this
    real(DP), intent(in) :: pts(:,:)
    logical, intent(in) :: periodic
    logical, intent(in), optional :: quiet

    real(DP) :: dim_vol, prop_const
    integer :: jdim
    logical :: should_write

    PUSH_SUB(cells_init)

    should_write = .true.
    if (present(quiet)) should_write = .not. quiet

#ifdef VERBOSE
    if (peinf%inode==0.and.should_write) &
      write(6,'(/,a)') 'Initializing cell structure.'
#endif

    this%periodic = periodic
    this%npts = size(pts, dim=2)
    SAFE_ALLOCATE(this%pts, (3, this%npts))
    if (this%periodic) then
      ! FHJ: this is guaranteed to be in [0, 1)
      this%pts(:,:) = UNIT_RANGE(pts(:,:))
    else
      this%pts(:,:) = pts(:,:)
    endif

    ! FHJ: Avoid problems that a very small dimension may cause
    this%active_dim(:) = .false.
    this%dims = 0
    this%dmin(:) = minval(this%pts(:,:), dim=2)
    this%dmax(:) = maxval(this%pts(:,:), dim=2)
    do jdim=1,3
      if ((this%dmax(jdim)-this%dmin(jdim)) > TOL_Small) then
        this%active_dim(jdim) = .true.
        this%dims = this%dims + 1
        if (this%periodic) then
          this%dmin(jdim) = 0d0
          this%dmax(jdim) = 1d0
        endif
      endif
    enddo

    ! FHJ: This is only to avoid division by zero later on
    this%dmin(:) = this%dmin(:) - TOL_Small
    this%dmax(:) = this%dmax(:) + TOL_Small

    ! FHJ: number of cells is proportional to the length of each active dimension
    !      this should work for any number of dimensions. Proof:
    !        d1*d2*... = V
    !        n1 = c*d1*(N)^(1/D)
    !        n1*n2*... = c^(D)*V*N = N => c = (1/V)^(1/D)
    !      so, const = (N/V)^(1/D)
    this%n_cells(:) = 1
    if (this%dims>0) then
      dim_vol=1.0d0
      do jdim=1,3
        if (this%active_dim(jdim)) dim_vol = dim_vol * (this%dmax(jdim)-this%dmin(jdim))
      enddo
      prop_const = (this%npts/dim_vol)**(1.0d0/this%dims)
      do jdim=1,3
        if (this%active_dim(jdim)) then
          this%n_cells(jdim) = idnint(prop_const * (this%dmax(jdim)-this%dmin(jdim)))
          this%n_cells(jdim) = min(max(this%n_cells(jdim), 1), this%npts)
        endif
      enddo
    endif

    this%factor(:) = this%n_cells(:) / (this%dmax(:) - this%dmin(:))
    this%shift(:) = (this%dmax(:) - this%dmin(:)) / (2.0d0*this%n_cells(:))

#ifdef VERBOSE
    if (peinf%inode==0.and.should_write) then
      write(6,*)
      write(6,'(a,i6,a)') ' Automatically creating a cell structure for ',this%npts,' points'
      write(6,'(a,i1,a)') '  Found ',this%dims,' dimension(s)'
      write(6,'(a,i5,i5,i5)') '  Number of cells:', this%n_cells(1),this%n_cells(2),this%n_cells(3)
      write(6,'(a,i6)') '  Total number of cells:', this%n_cells(1)*this%n_cells(2)*this%n_cells(3)
    endif
#endif

    SAFE_ALLOCATE(this%head, (this%n_cells(1),this%n_cells(2),this%n_cells(3)))
    SAFE_ALLOCATE(this%list, (this%npts))

    ! FHJ: Initialize and populate cells
    this%head(:,:,:) = 0
    this%list(:) = 0

#ifdef VERBOSE
    if (peinf%inode==0 .and. should_write) then
      write(6,*)
      do jdim=1,3
        write(6,801) jdim,this%dmin(jdim),this%dmax(jdim),this%shift(jdim)*2.0d0
801     format(' Cells [',i1,'], dmin= ',f8.5,' dmax= ',f8.5,' length= ',f12.5)
      enddo
    endif
#endif

    call cells_populate(this)

#ifdef VERBOSE
    if (peinf%inode==0 .and. should_write) then
      call cells_show_population(this)
      write(6,'(/,a)') 'Finished initializing cells'
    endif
#endif

    POP_SUB(cells_init)

  end subroutine cells_init


  !> Used internally by cells_init. Puts all points into the cells, update
  !! head and list structures.
  subroutine cells_populate(this)
    type(cells_t), intent(inout) :: this

    integer :: idx_co
    integer :: cell_idx(3)

    PUSH_SUB(cells_populate)
    do idx_co=1,this%npts
      call cells_get_cell_idx(this, this%pts(:,idx_co), cell_idx)
      this%list(idx_co) = this%head(cell_idx(1),cell_idx(2),cell_idx(3))
      this%head(cell_idx(1),cell_idx(2),cell_idx(3)) = idx_co
    enddo
    POP_SUB(cells_populate)

  end subroutine cells_populate


  !> Returns the cell index for point `pt`.
  subroutine cells_get_cell_idx(this, pt, cell_idx)
    type(cells_t), intent(in) :: this
    real(DP), intent(in) :: pt(3)
    integer, intent(out) :: cell_idx(3)

    ! no push/pop, called too frequently
    cell_idx(:) = idint((pt(:)-this%dmin(:)+this%shift(:))*this%factor(:))
    if (this%periodic) then
      cell_idx(:) = modulo(cell_idx(:), this%n_cells(:)) + 1
    else
      cell_idx(:) = min(max(cell_idx(:)+1, 1), this%n_cells(:))
    endif
  end subroutine cells_get_cell_idx


  !> Find the index idx such that this%pts(:, idx) == pt(:)
  !! The algorithm also looks for nearby cells.
  subroutine cells_find_exactly(this, pt_in, idx_found)
    type(cells_t), intent(in) :: this
    real(DP), intent(in) :: pt_in(3)
    integer, intent(out) :: idx_found

    real(DP) :: pt(3), delta(3)
    integer :: cell_idx(3)
    integer :: i1,i2,i3,j1,j2,j3
    integer :: cell_min(3), cell_max(3)

    ! no push/pop, called too frequently
    pt(:) = pt_in(:)
    if (this%periodic) pt(:) = UNIT_RANGE(pt(:))

    ! See if the point is in this central cell. The subroutine should
    ! usually return here
    call cells_get_cell_idx(this, pt, cell_idx)
    call find_exactly_in_cell(cell_idx, idx_found)
    if (idx_found/=0) return

    ! Otherwise look in neighboring cells. The routine will probably fail...
    call cells_get_search_bounds(this, 1, cell_idx, cell_min, cell_max)
    do i1 = cell_min(1), cell_max(1)
      j1 = cells_fix_index(this, i1, 1)
      cell_idx(1) = j1
      do i2 = cell_min(2), cell_max(2)
        j2 = cells_fix_index(this, i2, 2)
        cell_idx(2) = j2
        do i3 = cell_min(3), cell_max(3)
          j3 = cells_fix_index(this, i3, 3)
          cell_idx(3) = j3
          call find_exactly_in_cell(cell_idx, idx_found)
          if (idx_found/=0) then
            if (peinf%inode==0) then
              write(0,'(a)') &
                'WARNING: find_exactly: point was not located in central cell.'
              write(0,'(a)') &
                'The cell structure is non-optimal.'
            endif
            return
          endif
        enddo
      enddo
    enddo

  contains

    subroutine find_exactly_in_cell(c_idx, i_found)
      integer, intent(in) :: c_idx(3) !< only search in this cell index
      integer, intent(out) :: i_found !< this%pts(:,i_found) == pts

      integer :: idx_pt

      ! no push/pop, called too frequently
      i_found = 0
      idx_pt = this%head(c_idx(1), c_idx(2), c_idx(3))
      do while (idx_pt/=0)
        delta(:) = this%pts(:, idx_pt) - pt(:)
        if (this%periodic) delta(:) = MIN_RANGE(delta(:))
        if (all(dabs(delta)<TOL_SMALL)) then
          i_found = idx_pt
          return
        endif
        idx_pt = this%list(idx_pt)
      enddo

    end subroutine find_exactly_in_cell

  end subroutine cells_find_exactly

  !> Given a central cell and a Manhattan radius, returns the minimum and 
  !! maximum indices to be used in do-loops. The min and max indices obeying
  !! the periodicity or finiteness of the system, and never overlap.
  !! Away from borders, the subroutine simply returns:
  !!  cell_dmin(:) = cell_idx(:) - radius
  !!  cell_dmax(:) = cell_idx(:) + radius
  subroutine cells_get_search_bounds(this, radius, center_idx, cell_min, cell_max)
    type(cells_t), intent(in) :: this
    integer, intent(in) :: radius
    integer, intent(in) :: center_idx(3)
    integer, intent(out) :: cell_min(3), cell_max(3)

    integer :: ii

    ! no push/pop, called too often
    do ii=1,3
      if ((2*radius+1) > this%n_cells(ii)) then
        cell_min(ii) = 1
        cell_max(ii) = this%n_cells(ii)
      else
        cell_min(ii) = center_idx(ii) - radius
        cell_max(ii) = center_idx(ii) + radius
      endif
    enddo
    if (.not.this%periodic) then
      cell_min(:) = max(cell_min(:), 1)
      cell_max(:) = min(cell_max(:), this%n_cells(:))
    endif
  end subroutine cells_get_search_bounds

  !> Fixed an index so that it respects the periodic boundary conditions.
  !! No check is made for non-periodic cells, since functions like
  !! cells_get_search_bounds are already bounded by [1, n_cells]
  integer function cells_fix_index(this, idx_in, dim_)
    type(cells_t), intent(in) :: this
    integer, intent(in) :: idx_in
    integer, intent(in) :: dim_

    ! no push/pop since called too frequently
    cells_fix_index = idx_in
    if (this%periodic) then
      cells_fix_index = modulo(idx_in-1, this%n_cells(dim_)) + 1
    endif
  end function cells_fix_index

  !> Prints a summary of the cells population
  subroutine cells_show_population(this, iunit_)
    type(cells_t), intent(in) :: this
    integer, intent(in), optional :: iunit_

    integer :: j1, j2, j3, idx_co, iunit

    PUSH_SUB(cells_show_population)
    iunit = 6
    if (present(iunit_)) iunit = iunit_
    write(iunit,*)
    write(iunit,*) 'Cell Population Analysis'
    write(iunit,*)
    write(iunit,900) ' x ',' y ',' z ',' members '
    write(iunit,900) '---','---','---','---------'
900 format(2x, 3(a3,1x), a9)
    do j1 = 1, this%n_cells(1)
      do j2 = 1, this%n_cells(2)
        do j3 = 1, this%n_cells(3)
          write(iunit,'(2x,3(i3,1x))',advance='no') j1,j2,j3      
          idx_co = this%head(j1,j2,j3)
          do while (idx_co>0)
            write(iunit,'(1x,i5)',advance='no') idx_co
            idx_co = this%list(idx_co)
          enddo
          write(iunit,*)
        enddo
      enddo
    enddo
    write(iunit,*)
    POP_SUB(cells_show_population)

  end subroutine cells_show_population

  !> Deallocates buffers related to a cell structure
  subroutine cells_free(this)
    type(cells_t), intent(inout) :: this

    PUSH_SUB(cells_free)
    SAFE_DEALLOCATE_P(this%head)
    SAFE_DEALLOCATE_P(this%list)
    SAFE_DEALLOCATE_P(this%pts)
    POP_SUB(cells_free)

  end subroutine cells_free

end module cells_m

!================================================================================
!
! Routines:
!
! 1. trunc_cell_box()        Originally By JRD       Last Modified 3/01/2009 (JRD)
!
!    Calculate Coulomb interaction with Cell Box Truncation.
!
!    The Coulomb potential is calculated through FFT on the extended cell.
!
!    n_in_box is a (positive integer) parameter for real-space resolution.
!    If the energy cutoff is too small, then the FFT grid may not be very
!    dense and the Coulomb singularity at r=0 may be poorly handled.
!    Larger values of n_in_box will add extra points in between the original
!    FFT grid. If the original grid has N points covering a space of length
!    L, then the grid used to do 3-dimensional FFTs will have N * n_in_box
!    points covering a space of length L.
!
!    When V_coul(x,y,z) is calculated, we add a shift on the grid in
!    order to avoid the singularity at x = y = z = 0.
!
!    Output is truncated Vcoul(G_1,G_2,G_3) in reciprocal space such that,
!    without truncation, its value would be:
!
!             Vcoul(ig) = 8 Pi/(q + G)*2
!
!    for each G-vector  G = gvec%components(:,isrtq(ig)) in the list.
!
!    Calculation is distributed over processors but array vcoul returns
!    with global value.
!
!================================================================================

#include "f_defs.h"

module trunc_cell_box_m

  use global_m
  use fft_parallel_m
  use fftw_m
  use misc_m

  implicit none

  private

  public ::          &
    trunc_cell_box

contains

subroutine trunc_cell_box(gvec,verbose,bdot,ncoul,isrtq,vcoul,coulomb_mod)

  type (gspace),      intent(in)    :: gvec         !< Reciprocal space structure
  logical,            intent(in)    :: verbose      !< Flag for extra output on unit 6
  real(DP),           intent(in)    :: bdot(3,3)    !< Metric matrix in reciprocal space
  integer,            intent(in)    :: ncoul        !< Number of G-vectors
  integer,            intent(in)    :: isrtq(ncoul) !< Indices of G-vectors
  real(DP),           intent(out)   :: vcoul(ncoul) !< Coulomb potential
  !> Optional coulomb modifier parameters. Used in TDDFT and hybrid functional calculations
  !! they allow one to change the bare coulomb interaction. 
  type(coulomb_modifier_t), optional, intent(in) :: coulomb_mod

  integer :: i1, i2, i3, j1, j2, j3, l1, l2, l3, ig, &
    Nfft(3), dNfft(3), dkmax(3), i, j
  real(DP) :: r_len, rr(3), t_len, tt(3), adot(3,3), &
    scale, dscale, phase, vimag, vdummy, fac1, fac2, &
    screening_length
  real(DP) :: b(3,3)
  complex(DPC) :: vtemp
  complex(DPC), allocatable :: fftbox_3D(:,:,:)
  complex(DPC), allocatable :: dummy(:,:,:)
  integer, allocatable :: inv_indx(:,:,:)
  real(DP) :: derf, derfc

  PUSH_SUB(trunc_cell_box)

! Initialize FFT grids.

  call setup_FFT_sizes(gvec%FFTgrid,Nfft,scale)
  dkmax(1) = gvec%FFTgrid(1) * n_in_box
  dkmax(2) = gvec%FFTgrid(2) * n_in_box
  dkmax(3) = gvec%FFTgrid(3) * n_in_box
  call setup_FFT_sizes(dkmax,dNfft,dscale)

! Initialize real-space metric.

  rr = 0.0d0
  call invert_matrix(bdot, adot)
  adot = adot * 4.0d0 * PI_D * PI_D

  do i =1,3
    do j=1,3
      adot(i,j) = adot(i,j) / dble(dNfft(i) * dNfft(j))
    enddo
  enddo

! Initialize boxes.

  SAFE_ALLOCATE(fftbox_3D, (dNfft(1),dNfft(2),dNfft(3))) 
  SAFE_ALLOCATE(dummy, (dNfft(1),dNfft(2),dNfft(3)))

  if (verbose) then
    if (peinf%inode .eq. 0) then
      write(6,555) dNfft, n_in_box
    endif
  endif
555 format(/,1x,"Cell truncation.",/,2x,"Building truncated Coulomb", &
      1x,"potential using 3-D FFTs.",/,2x,"3-D FFT grid =",3i5,/,2x, &
      "Extra points between two points in a 3-D FFT grid =",i3,/)

! Rescale with the volume of the unit cell.

  b = adot
  scale = b(1,1)*(b(2,2)*b(3,3) - b(2,3)**2) &
    + 2*b(1,2)*b(2,3)*b(3,1) &
    - b(2,2)*b(1,3)**2 - b(3,3)*b(1,2)**2
  scale = 2.0d0 * dsqrt(scale)
  if (present(coulomb_mod)) then
    screening_length = coulomb_mod%screening_length*BOHR
    fac1 = coulomb_mod%short_range_frac_fock * scale
    fac2 = coulomb_mod%long_range_frac_fock * scale
  else
    fac1 = scale
    fac2 = 0.0d0
    screening_length = 0.0d0
  endif


! Invert G-index

  SAFE_ALLOCATE(inv_indx, (Nfft(1),Nfft(2),Nfft(3)))
  call fft_map_s(ncoul,Nfft,isrtq,gvec%components,inv_indx)

! For each G_3 plane, calculate the potential V_trunc(r1,r2,r3).
! The potential is not zero only inside the Wigner-Seitz cell.

  fftbox_3D = (0.0d0,0.0d0)
  do i3 = 1, dNfft(3)
    if (mod(i3-1,peinf%npes) /= peinf%inode) cycle
    rr(3) = dble(i3 - 1) + trunc_shift(3)
    do i2 = 1, dNfft(2)
      rr(2) = dble(i2 - 1) + trunc_shift(2)
      do i1 = 1, dNfft(1)
        rr(1) = dble(i1 - 1) + trunc_shift(1)
        
        r_len = INF
        
        do l3 = -ncell+1, ncell
          tt(3) = rr(3) - dble(l3 * dNfft(3))
          do l2 = -ncell+1, ncell
            tt(2) = rr(2) - dble(l2 * dNfft(2))
            do l1 = -ncell+1, ncell
              tt(1) = rr(1) - dble(l1 * dNfft(1))
              t_len = dot_product(tt,matmul(adot,tt))
              if (t_len < r_len) r_len = t_len
            enddo
          enddo
        enddo

        r_len = sqrt(r_len)
        
        !fftbox_3D(i1,i2,i3) = 1.0d0 / r_len
          fftbox_3D(i1,i2,i3) = fac1/ r_len

        
      enddo
    enddo
  enddo

#ifdef MPI
  call MPI_Allreduce(fftbox_3D(1,1,1),dummy(1,1,1),dNfft(1)*dNfft(2)*dNfft(3), &
    MPI_COMPLEX_DPC,MPI_SUM,MPI_COMM_WORLD,mpierr)
  fftbox_3D=dummy
#endif

!---------------------------------------
! gsm: Below is equivalent to fft_r2g_s except we multiply by a phase,
!      collect the real part and check that the imaginary part is smaller
!      than the tolerance. Calling fft_r2g_s directly and then altering
!      the result would cost extra memory and code execution.

! Do a three-dimensional Fourier transform:
! V_trunc(r1,r2,r3) -> V_trunc(G_1,G_2,G_3)

  call do_FFT(fftbox_3D,dNfft,-1)

! Collect components of V_trunc for G-vectors in Coulomb list.

  vcoul = 0.0d0
  vimag = 0.0d0
  do j3 = - Nfft(3)/2, Nfft(3) - Nfft(3)/2 - 1
    l3 = j3 + 1
    if (j3 < 0) l3 = Nfft(3) + l3
    i3 = j3 + 1
    if (j3 < 0) i3 = dNfft(3) + i3
    do j2 = - Nfft(2)/2, Nfft(2) - Nfft(2)/2 - 1
      l2 = j2 + 1
      if (j2 < 0) l2 = Nfft(2) + l2
      i2 = j2 + 1
      if (j2 < 0) i2 = dNfft(2) + i2
      do j1 = - Nfft(1)/2, Nfft(1) - Nfft(1)/2 - 1
        l1 = j1 + 1
        if (j1 < 0) l1 = Nfft(1) + l1
        i1 = j1 + 1
        if (j1 < 0) i1 = dNfft(1) + i1
        ig = inv_indx(l1,l2,l3)
        if (ig == 0) cycle

! (gsm) [2010-06-17] there was a bug here
! the singularity of the Coulomb potential was shifted from
! the origin of the coordinate system by half a grid step

!            vcoul(ig) = dble(fftbox_3D(i1,i2,i3))

        phase = dble(j1) * trunc_shift(1) / dble(dNfft(1)) &
          + dble(j2) * trunc_shift(2) / dble(dNfft(2)) &
          + dble(j3) * trunc_shift(3) / dble(dNfft(3))
        phase = 2.0d0 * PI_D * phase
        vtemp = fftbox_3D(i1,i2,i3)
        vtemp = vtemp * CMPLX(cos(phase), -sin(phase))
        vcoul(ig) = dble(vtemp)
        vdummy = abs(IMAG(vtemp))
        if (vdummy.gt.vimag) vimag=vdummy
      enddo
    enddo
  enddo

  if (vimag.gt.TOL_Small) &
    call die("The Coulomb interaction was incorrectly computed as complex: most likely a problem with your FFT library.", &
    only_root_writes = .true.)

  call destroy_fftw_plans()
  SAFE_DEALLOCATE(fftbox_3D)
  SAFE_DEALLOCATE(dummy)
  SAFE_DEALLOCATE(inv_indx)

  POP_SUB(trunc_cell_box)

  return
end subroutine trunc_cell_box

end module trunc_cell_box_m

!================================================================================
!
! Routines:
!
! (1) mtxel_md()        Originally By MLT               Last Modified 7/1/2008 (JRD)
!
!     Calculates matrix elements based on model.  Is currently not used in code.
!     Was replaced by ab initio matrix elements in kernel.
!
!================================================================================

#include "f_defs.h"

subroutine mtxel_md(crys,gvec,syms,kg,wfnc,wfncp, &
  wfnvp,wfnv,xct,bsedbody,bsedhead,bsedwing,bsex,ii,iip,ipe)

  use global_m
  implicit none

  type (crystal), intent(in) :: crys
  type (gspace), intent(in) :: gvec
  type (symmetry), intent(in) :: syms
  type (grid), intent(in) :: kg
  type (wavefunction), intent(in) :: wfnc,wfncp,wfnvp,wfnv
  type (xctinfo), intent(in) :: xct
  SCALAR, intent(inout) :: &
    bsedbody(xct%nvband,peinf%nck,xct%nvband,peinf%nckpe,xct%nspin,xct%nspin), &
    bsedhead(xct%nvband,peinf%nck,xct%nvband,peinf%nckpe,xct%nspin,xct%nspin), &
    bsedwing(xct%nvband,peinf%nck,xct%nvband,peinf%nckpe,xct%nspin,xct%nspin), &
    bsex(xct%nvband,peinf%nck,xct%nvband,peinf%nckpe,xct%nspin,xct%nspin)
  integer, intent(in) :: ii,iip,ipe

  integer :: jj,jjp,kk,i1,i2,i3,irq
  integer :: ic,ick,ickp,icp,ik,ikp,ifq,ig,ign,igp, &
    igadd,igaddn,igaddp,isc,iscp,isv,isvp,iv,ivp
  integer :: ngq,neps
  integer :: kxm,kxn,kym,kyn,kzm,kzn,kaddn,g0(3),ifqmin
  real(DP) :: ekin,wval,fq(3),qq,fqq(3),diffl,difmin,diff(3)
  real(DP) :: fqmin(3),lmin,length,epsinv
      
  integer, allocatable :: isorti(:)
  SCALAR :: bsed
  SCALAR, allocatable :: wpt(:),mcc(:,:,:,:),mvv(:,:,:,:),mvc(:,:,:,:),mvpcp(:,:,:,:)
  
! Compute maximum size of the cube

  PUSH_SUB(mtxel_md)

  kxm=gvec%FFTgrid(1)
  kym=gvec%FFTgrid(2)
  kzm=gvec%FFTgrid(3)
  ik=peinf%ik(peinf%inode+1,ii)
  ikp=peinf%ik(ipe+1,iip)

!-------------------------------------
! Read epsinv for q + g0 =kp-k

  fq(:)=kg%f(:,ik)-kg%f(:,ikp)
  fqq(:) = fq(:)

! Reduce to BZ

  jj=2
  lmin = 1.d10
  do i1=-jj,jj
    diff(1) = fq(1) - i1
    do i2=-jj,jj
      diff(2) = fq(2) - i2
      do i3=-jj,jj
        diff(3) = fq(3) - i3
        length = DOT_PRODUCT(diff,MATMUL(crys%bdot,diff))
        if (length.lt.lmin) then
          lmin = length
          fqmin(:) = diff(:)
        endif
      enddo
    enddo
  enddo
  fq(:) = fqmin(:)
  g0(:) = fqq(:) - fq(:)
      
! Model

  SAFE_ALLOCATE(wpt, (xct%neps))
  wpt=0.d0

!-------------------------------------
! Compute W(g,gp) for q + g0 =kp-k

! head for q=0 and q<>0, *no interpolation* !!
  wpt(1)= 1.d0
! body for q=0 and qq<>0
  do igp=2,xct%neps
    fqq(:) = fq(:) + gvec%components(:,igp)
    ekin= DOT_PRODUCT(fqq,MATMUL(crys%bdot,fqq))
    call epsmodel(crys,fqq,epsinv)
    wpt(igp)=epsinv/ekin
  enddo

!-------------------------------------
! Compute direct term matrices

  SAFE_ALLOCATE(mcc, (xct%ng,xct%ncband,xct%ncband,xct%nspin))
  SAFE_ALLOCATE(mvv, (xct%ng,xct%nvband,xct%nvband,xct%nspin))
  mcc=0.0d0
  mvv=0.0d0

! Compute inverse array to wfnc%isort

  SAFE_ALLOCATE(isorti, (gvec%ng))
  isorti=0
  do ig=1,gvec%ng
    isorti(wfnc%isort(ig))=ig
  enddo

! Loop G

  do ig=1,xct%ng
    igadd=ig

! Loop over G`

    do igp=1,wfncp%ng
      igaddp=wfncp%isort(igp)

! Compute address of Gn=Gp+G-G0:
! if the result is beyond planewaves included
! in wavefunction, skip

      kxn=gvec%components(1,igaddp)+gvec%components(1,igadd)-g0(1)+gvec%FFTgrid(1)/2+1
      if((kxn.lt.1).or.(kxn.gt.kxm)) cycle
      kyn=gvec%components(2,igaddp)+gvec%components(2,igadd)-g0(2)+gvec%FFTgrid(2)/2+1
      if((kyn.lt.1).or.(kyn.gt.kym)) cycle
      kzn=gvec%components(3,igaddp)+gvec%components(3,igadd)-g0(3)+gvec%FFTgrid(3)/2+1
      if((kzn.lt.1).or.(kzn.gt.kzm)) cycle
      kaddn=((kxn-1)*kym+kyn-1)*kzm+kzn
      igaddn=gvec%index_vec(kaddn) ! relate the cube to the sphere
      ign=isorti(igaddn)
      if(ign.gt.wfnc%ng) cycle

! Compute matrix element: <c`k`|exp(i(k`-k-G+G0).r)|ck>

      do jj=ii,ii+peinf%nckmem-1
        do jjp=iip,iip+peinf%nckmem-1
          ic=peinf%ic(peinf%inode+1,jj)
          icp=peinf%ic(ipe+1,jjp)
          ick=peinf%ick(ic,ik)
          ickp=peinf%ick(icp,ikp)
          do isc=1,xct%nspin
            mcc(ig,ic,icp,isc)=mcc(ig,ic,icp,isc)+ &
              MYCONJG(wfncp%cg(igp,icp,isc))*(wfnc%cg(ign,ic,isc))
          enddo
        enddo
      enddo

! Compute matrix element: <v`k`|exp(i(k`-k-G+G0).r)|vk>

      do iv=1,xct%nvband
!          do ivp=iv,xct%nvband
        do ivp=1,xct%nvband
          do isv=1,xct%nspin
            mvv(ig,iv,ivp,isv)=mvv(ig,iv,ivp,isv)+ &
              MYCONJG(wfnvp%cg(igp,ivp,isv))*wfnv%cg(ign,iv,isv)
          enddo
        enddo
      enddo

    enddo !end loop over gp

  enddo !end loop over g

  SAFE_DEALLOCATE(isorti)

  do ig=1,xct%neps
    wval=wpt(ig)
    if(abs(wval).lt.TOL_Zero) cycle
    do jj=ii,ii+peinf%nckmem-1
      do jjp=iip,iip+peinf%nckmem-1
        ic=peinf%ic(peinf%inode+1,jj)
        icp=peinf%ic(ipe+1,jjp)
        ick=peinf%ick(ic,ik)
        ickp=peinf%ick(icp,ikp)
        do iv=1,xct%nvband
          do ivp=1,xct%nvband
            do isc=1,xct%nspin
              do isv=1,xct%nspin
                bsed=wval*MYCONJG(mcc(ig,ic,icp,isc))*mvv(ig,iv,ivp,isv)
                if(ig.ne.1) then
                  bsedbody(ivp,ickp,iv,jj,isc,isv)= &
                    bsedbody(ivp,ickp,iv,jj,isc,isv)+bsed
                else
                  bsedhead(ivp,ickp,iv,jj,isc,isv)= &
                    bsedhead(ivp,ickp,iv,jj,isc,isv)+bsed
                endif
              enddo !isv
            enddo !isc
          enddo !ivp
        enddo !iv
      enddo !icp
    enddo !ic
  enddo !ig
  
  SAFE_DEALLOCATE(mcc)
  SAFE_DEALLOCATE(mvv)
  SAFE_DEALLOCATE(wpt)

!-------------------------------------
! Compute exchange term matrices

  SAFE_ALLOCATE(mvc, (xct%ng,xct%nvband,xct%ncband,xct%nspin))
  mvc=0.0d0

! Compute inverse array to wfnc%isort

  SAFE_ALLOCATE(isorti, (gvec%ng))
  isorti=0
  do ig=1,gvec%ng
    isorti(wfnc%isort(ig))=ig
  enddo

! Loop G

  do ig=2,xct%ng
    igadd=ig

! Loop over G`

    do igp=1,wfnv%ng
      igaddp=wfnv%isort(igp)

! Compute address of gn=gp-g:
! If the result is beyond planewaves included
! in wavefunction, skip

      kxn=gvec%components(1,igaddp)-gvec%components(1,igadd)+gvec%FFTgrid(1)/2+1
      if((kxn.lt.1).or.(kxn.gt.kxm)) cycle
      kyn=gvec%components(2,igaddp)-gvec%components(2,igadd)+gvec%FFTgrid(2)/2+1
      if((kyn.lt.1).or.(kyn.gt.kym)) cycle
      kzn=gvec%components(3,igaddp)-gvec%components(3,igadd)+gvec%FFTgrid(3)/2+1
      if((kzn.lt.1).or.(kzn.gt.kzm)) cycle
      kaddn=((kxn-1)*kym+kyn-1)*kzm+kzn
      igaddn=gvec%index_vec(kaddn) ! relate the cube to the sphere
      ign=isorti(igaddn)
      if(ign.gt.wfnc%ng) cycle

! Compute matrix elements: <vk|exp(iG.r)|ck>  ,  G.ne.0

      do jj=ii,ii+peinf%nckmem-1
        ic=peinf%ic(peinf%inode+1,jj)
        do iv=1,xct%nvband
          do isc=1,xct%nspin

! MLT: valence,conduction states should have the same spin!

!              isv=xct%nspin+1-isc
            isv=isc
            mvc(ig,iv,ic,isc)=mvc(ig,iv,ic,isc)+ &
              MYCONJG(wfnv%cg(igp,iv,isv))*wfnc%cg(ign,ic,isc)
          enddo
        enddo
      enddo
      
    enddo !end loop over gp
  enddo !end loop over g

  SAFE_DEALLOCATE(isorti)
  
  SAFE_ALLOCATE(mvpcp, (xct%ng,xct%nvband,xct%ncband,xct%nspin))
  mvpcp=0.0d0

! Compute inverse array to wfncp%isort

  SAFE_ALLOCATE(isorti, (gvec%ng))
  isorti=0
  do ig=1,gvec%ng
    isorti(wfncp%isort(ig))=ig
  enddo

! Loop G

  do ig=2,xct%ng
    igadd=ig

! Loop over G`

    do igp=1,wfnvp%ng
      igaddp=wfnvp%isort(igp)

! Compute address of gn=gp-g:
! if the result is beyond planewaves included
! in wavefunction, skip

      kxn=gvec%components(1,igaddp)-gvec%components(1,igadd)+gvec%FFTgrid(1)/2+1
      if((kxn.lt.1).or.(kxn.gt.kxm)) cycle
      kyn=gvec%components(2,igaddp)-gvec%components(2,igadd)+gvec%FFTgrid(2)/2+1
      if((kyn.lt.1).or.(kyn.gt.kym)) cycle
      kzn=gvec%components(3,igaddp)-gvec%components(3,igadd)+gvec%FFTgrid(3)/2+1
      if((kzn.lt.1).or.(kzn.gt.kzm)) cycle
      kaddn=((kxn-1)*kym+kyn-1)*kzm+kzn
      igaddn=gvec%index_vec(kaddn) ! relate the cube to the sphere
      ign=isorti(igaddn)
      if(ign.gt.wfncp%ng) cycle

! Compute matrix element:
!   mvpcp = <v`k`|exp(iG.r)|c`k`> ,   G.ne.0

      do jjp=iip,iip+peinf%nckmem-1
        icp=peinf%ic(ipe+1,jjp)
        do ivp=1,xct%nvband
          do iscp=1,xct%nspin

! MLT: valence,conduction states should have the same spin!

!              isvp=xct%nspin+1-iscp
            isvp=iscp
            mvpcp(ig,ivp,icp,iscp)=mvpcp(ig,ivp,icp,iscp)+ &
              MYCONJG(wfnvp%cg(igp,ivp,isvp))*wfncp%cg(ign,icp,iscp)
          enddo
        enddo
      enddo
      
    enddo !end loop over gp
  enddo !end loop over g

  SAFE_DEALLOCATE(isorti)
  
  do ig=2,xct%neps
    ekin=gvec%ekin(ig)
    do jj=ii,ii+peinf%nckmem-1
      do jjp=iip,iip+peinf%nckmem-1
        ic=peinf%ic(peinf%inode+1,jj)
        icp=peinf%ic(ipe+1,jjp)
        ick=peinf%ick(ic,ik)
        ickp=peinf%ick(icp,ikp)
        do iv=1,xct%nvband
          do ivp=1,xct%nvband
            do isc=1,xct%nspin
              do iscp=1,xct%nspin
                bsex(ivp,ickp,iv,jj,isc,iscp)= &
                  bsex(ivp,ickp,iv,jj,isc,iscp)+1.0d0/ekin* &
                  mvpcp(ig,ivp,icp,iscp)*MYCONJG(mvc(ig,iv,ic,isc))
              enddo !iscp
            enddo !isc
          enddo !ivp
        enddo !iv
      enddo !icp
    enddo !ic
  enddo !ig
  
  SAFE_DEALLOCATE(mvc)
  SAFE_DEALLOCATE(mvpcp)
  
  POP_SUB(mtxel_md)
  
  return
end subroutine mtxel_md

!=========================================================================
!
! Utilities:
!
! (1) epsmat_converter     Originally by DVF      Last Modified 09/20/2013 (DVF)
!
!     This utility converts epsmat files from the old epsilon format to
!     the new HDF5 format, to facilitate people switching to HDF5.
!
!=========================================================================

#include "f_defs.h"

program epsmat_converter

  use global_m
  use hdf5
  use write_matrix_m
  use epswrite_hdf5_m

  implicit none
  
  character :: ajname*6,adate*11,outfile*80,infile*80
  real(DP)  :: ecuts,qk(3)
  real(DP), allocatable :: dFreqGrid(:), epsdiag(:,:,:),ekin(:),qpts(:,:)
  complex(DPC), allocatable :: dFreqBrd(:),epsRDyn(:,:,:),epsADyn(:,:,:)
  integer   :: ig,ng,ngq, ii,iq,qgrid(3),freq_dep,nFreq, &
    nq, nq_file,nmtxmax,isize,jj,ifreq,error
  SCALAR, allocatable :: eps(:,:)
  integer, allocatable :: isort(:),isorti(:),gcomponents(:,:),nmtx0_of_q(:),nmtx0_of_q_file(:)
  
  write(6,*) MYFLAVOR // ' version is used to convert old epsmat format to hdf5 format'

  call h5open_f(error)
  
!------------------
! DVF : get gvector & qpoint information from input file, and the input/output file names
! Want number of gvectors so that we can read in g-vector components before the call
! to write the hdf5 epsmat header - call eps_hdf5_setup
! Want number of qpoints so that we can read in nmtx0_of_q. We want to read in this
! array because otherwise we`d have to read get it from the file by looping through
! the whole file, which can take a long time for big files

  call open_file(unit=10,file='epsmat_old2hdf5.inp',form='formatted',status='old')
  read(10,*) infile
  read(10,*) outfile
  read(10,*) nq
  close(10)

  SAFE_ALLOCATE(qpts,(3,nq))
  SAFE_ALLOCATE(nmtx0_of_q,(nq))
  SAFE_ALLOCATE(nmtx0_of_q_file,(nq))
  SAFE_ALLOCATE(gcomponents, (3,ng))

  nmtxmax=0

!--------------------------
!  Read in the epsmat file
!
  call open_file(unit=11,file=TRUNC(infile),form='unformatted',status='old')
  read(11) ajname,adate
  read(11) freq_dep,nFreq
  read(11) (qgrid(ii),ii=1,3)
  if (freq_dep .eq. 2) then
    SAFE_ALLOCATE(dFreqGrid,(nFreq))
    SAFE_ALLOCATE(dFreqBrd,(nFreq))
    read(11) (dFreqGrid(ii),ii=1,nFreq),(dFreqBrd(ii),ii=1,nFreq)
  else
    read(11)
  endif
  read(11)
  read(11)
  read(11) ecuts
  read(11) nq_file,((qpts(jj,iq),jj=1,3),iq=1,nq)
  if(nq_file .ne. nq) then
    call die('Number of qpoints in input file not the same as what is in epsmat file')
  endif
  read(11) ng
  do iq=1,nq
    read(11) ngq,nmtx0_of_q(iq)
    if(nmtx0_of_q(iq) .gt. nmtxmax) then
      nmtxmax=nmtx0_of_q(iq)
    endif
    read(11)
    read(11)
    if (freq_dep .eq. 2) then    
      do jj = 1, nmtx0_of_q(iq)
        do ii = 1, nmtx0_of_q(iq)
          read(11)
        enddo
#ifdef CPLX
        do ii = 1, nmtx0_of_q(iq)
          read(11)
        enddo
#endif
      enddo
    else
      do jj = 1, nmtx0_of_q(iq)
        read(11)
      enddo
    endif
  enddo

! JRD - LETS READ the nmtx here... Putting it in .inp is too much to ask user

  call close_file(11)

  SAFE_ALLOCATE(isort, (ng))  
  SAFE_ALLOCATE(isorti, (ng)) 
  SAFE_ALLOCATE(ekin, (ng))   
                              
! Write header for hdf5 file

! Read body of epsmat from old format and write to hdf5 file

  call open_file(unit=11,file=TRUNC(infile),form='unformatted',status='old')
  read(11)
  read(11)
  read(11)
  read(11)
  read(11)
  read(11)
  read(11)
  read(11) nq
  read(11) ng,((gcomponents(jj,ig),jj=1,3),ig=1,ng)

  call eps_hdf5_setup(freq_dep,nFreq,dFreqGrid,dFreqBrd,ecuts,&
    qgrid,ng,gcomponents,nq,qpts,nmtx0_of_q,nmtxmax,1,outfile)

  SAFE_DEALLOCATE(dFreqBrd)
  SAFE_DEALLOCATE(dFreqGrid)

  do iq=1,nq
    write(*,*) "iq",iq
    if(freq_dep .eq. 2) then
      SAFE_ALLOCATE(epsRDyn, (nFreq,nmtx0_of_q(iq),nmtx0_of_q(iq)))
#ifdef CPLX
      SAFE_ALLOCATE(epsADyn, (nFreq,nmtx0_of_q(iq),nmtx0_of_q(iq)))
#endif 
    else
      SAFE_ALLOCATE(eps, (nmtx0_of_q(iq),nmtx0_of_q(iq))) 
    endif
    read(11) ngq,nmtx0_of_q_file(iq),(isort(ig),isorti(ig),ig=1,ngq)
    if(nmtx0_of_q_file(iq) .ne. nmtx0_of_q(iq)) then
      call die('nmtx0_of_q in input file not the same as what is in epsmat file')
    endif
    read(11) (ekin(ig),ig=1,ngq)
    read(11) (qk(jj),jj=1,3)
    if (freq_dep .eq. 2) then    
      do jj = 1, nmtx0_of_q(iq)
        do ii = 1, nmtx0_of_q(iq)
          read(11) (epsRDyn(ifreq, ii, jj), ifreq= 1, nFreq)
        enddo
#ifdef CPLX
        do ii = 1, nmtx0_of_q(iq)
          read(11) (epsADyn(ifreq, ii, jj),ifreq = 1, nFreq)
        enddo
#endif
      enddo
    else
      do jj = 1, nmtx0_of_q(iq)
         read(11) (eps(ii,jj),ii=1,nmtx0_of_q(iq))
      enddo
    endif
    call write_gvec_indices_hdf(ng,isort,isorti,ekin,iq,outfile)

    isize=SCALARSIZE
    if(freq_dep .eq. 2) then
#ifdef CPLX
      call write_matrix_f_ser_hdf(nFreq,epsRDyn,epsADyn,nmtx0_of_q(iq),iq,1,outfile)
#else
      call write_matrix_f_ser_hdf(nFreq,epsRDyn,nmtx0_of_q(iq),iq,1,outfile)
#endif
    else
      call write_matrix_ser_hdf(eps,nmtx0_of_q(iq),iq,1,outfile)
    endif

    SAFE_ALLOCATE(epsdiag,(isize,nmtx0_of_q(iq),1))

    if (freq_dep .ne. 2) then
      do jj = 1, nmtx0_of_q(iq)
        epsdiag(1,jj,1) = dble(eps(jj,jj))
#ifdef CPLX
        epsdiag(2,jj,1) = IMAG(eps(jj,jj))
#endif
      enddo
    else
      do jj = 1, nmtx0_of_q(iq)
        epsdiag(1,jj,1) = dble(epsRDyn(1,jj,jj))
        epsdiag(2,jj,1) = IMAG(epsRDyn(2,jj,jj))
      enddo
    endif
    call write_matrix_diagonal_hdf(epsdiag,nmtx0_of_q(iq),iq,isize,outfile)

    SAFE_DEALLOCATE(epsdiag)
    if(freq_dep .eq. 2) then
      SAFE_DEALLOCATE(epsRDyn)
#ifdef CPLX
      SAFE_DEALLOCATE(epsADyn)
#endif 
    else
      SAFE_DEALLOCATE(eps)
    endif
  enddo

  call close_file(11)

end program epsmat_converter

#include "f_defs.h"

!-----------------------------------------------------------------------
subroutine input(crys,gvec,kg,syms,xct,kgr,index_k,pxct)
!-----------------------------------------------------------------------
!
!       Read data from file WFN_fi and initialize variables
!
!     input: xct types
!
!     output: crys,gvec,kg,syms types
!             peinf type (from distrib.f90)
!             INT_VWFN_* and INT_CWFN_* files
!
!     Copied from BSE/input.f90, without eqp arrays.
!
  use global_m
  use checkbz_m
  use fullbz_m
  use input_utils_m
  use misc_m
  use sort_m
  use wfn_rho_vxc_io_m
  use plotxct_common_m
  use input_common_m
  implicit none

  type (crystal), intent(out) :: crys
  type (gspace), intent(out) :: gvec
  type (grid), intent(out) :: kg
  type (symmetry), intent(out) :: syms
  type (xctinfo), intent(inout) :: xct
  real(DP), intent(in) :: kgr(3,xct%nkpt_fi)
  integer, intent(in) :: index_k(xct%nkpt_fi)
  type (plotxct_t), intent(in) :: pxct

  type (input_reader_t) :: inp !< the input reader `object`
  type (kpoints) :: kp
  type (grid) :: kgt

  character :: filenamec*20
  character :: tmpfn*16, errmsg*100
  integer :: iunit_c
  logical :: send_any !< = any(send_to)
  integer :: ii,jj,irk
  integer :: irks
  real(DP) :: diffvol,vcell,kt(3)
  real(DP) :: tol
  real(DP), allocatable :: ek_tmp(:)
  integer, allocatable :: indxk(:),k_tmp(:,:)
  integer, allocatable :: index(:)
  
  character(len=3) :: sheader
  integer :: iflavor

  logical :: skip_checkbz

  PUSH_SUB(input)

  call logit('entering input')

  if(peinf%inode == 0) call open_file(25,file='WFN_fi',form='unformatted',status='old')

  sheader = 'WFN'
  iflavor = 0
  call read_binary_header_type(25, sheader, iflavor, kp, gvec, syms, crys)
  
  SAFE_ALLOCATE(gvec%components, (3, gvec%ng))
  call read_binary_gvectors(25, gvec%ng, gvec%ng, gvec%components)
  
  call get_volume(vcell,crys%bdot)
  diffvol=abs(crys%celvol-vcell)
  if (diffvol.gt.1.0d-6) then
    call die('volume mismatch.', only_root_writes = .true.)
  endif
  
  kp%nvband=minval(kp%ifmax(:,:)-kp%ifmin(:,:))+1
  kp%ncband=kp%mnband-maxval(kp%ifmax(:,:))
  
  if(xct%nvb_fi.gt.kp%nvband) then
    write(errmsg,'(a,i6,a,i6,a)') 'You requested ', xct%nvb_fi, ' valence bands but WFN_fi contains only ', kp%nvband, '.'
    call die(errmsg, only_root_writes = .true.)
  endif
  if(xct%ncb_fi.gt.kp%ncband) then
    write(errmsg,'(a,i6,a,i6,a)') 'You requested ', xct%ncb_fi, ' conduction bands but WFN_fi contains only ', kp%ncband, '.'
    call die(errmsg, only_root_writes = .true.)
  endif
  if(xct%nspin.ne.kp%nspin) then
    write(errmsg,'(a,2i6)') 'Number of spins mismatch: ', xct%nspin, kp%nspin
    call die(errmsg, only_root_writes = .true.)
  endif
!-----------------------------------------------------------------------
!     Check if all k-points are available and define grid
!
  tol = 1.d-4
  kgt%nr=kp%nrk
  SAFE_ALLOCATE(kgt%r, (3,kgt%nr))
  kgt%r(1:3,1:kgt%nr)=kp%rk(1:3,1:kp%nrk)
  if (.not.pxct%unfold) then
    call fullbz(crys,syms,kgt,1,skip_checkbz,wigner_seitz=.true.,paranoid=pxct%bz_paranoid)
  else
    call fullbz(crys,syms,kgt,syms%ntran,skip_checkbz,wigner_seitz=.true.,paranoid=pxct%bz_paranoid)
  endif
  tmpfn='WFN_fi'
  if (.not. skip_checkbz) then
    call checkbz(kgt%nf,kgt%f,kp%kgrid,kp%shift,crys%bdot, &
      tmpfn,'k',.true.,xct%freplacebz,xct%fwritebz)
  endif
  call logit('input:  done unfolding/checking BZ')
!
  ! FHJ: map the xct grid kgr(:,:) to the WFN grid kgt%f(:,:)
  SAFE_ALLOCATE(indxk, (xct%nkpt_fi))
  indxk=0
  do jj=1,xct%nkpt_fi
    do ii=1,kgt%nf
      kt(:) = mod(kgr(:,jj) - kgt%f(:,ii)+10.0,1.0d0)
      if (all(abs(kt(1:3)).lt.tol)) then
        if (indxk(jj).ne.0) write(0,*) 'WARNING: multiple definition of k-point',jj,indxk(jj),kgr(:,jj)
        indxk(jj)=ii
      endif
    enddo
!
!     If some k-point listed in kgr is not found in WFN_fi, indxk
!     will store zero.
!
    if (indxk(jj).eq.0) then
      write(errmsg,'(a,3f12.6,a)') 'Could not find vector ', kgr(:,jj), ' in WFN_fi'
      call die(errmsg, only_root_writes = .true.)
    endif
  enddo
  call logit('input:  done mapping kpts (1)')
!
!   update kgt -> kg
!
  kg%nr = kgt%nr
  kg%nf = xct%nn
  SAFE_ALLOCATE(kg%r, (3,kg%nr))
  kg%r = kgt%r
  kg%sz = kgt%sz
  SAFE_ALLOCATE(kg%itran, (kg%nf))
  SAFE_ALLOCATE(kg%indr, (kg%nf))
  SAFE_ALLOCATE(kg%f, (3,kg%nf))
  SAFE_ALLOCATE(kg%kg0, (3,kg%nf))
  do jj=1,xct%nn
    kg%itran(jj) = kgt%itran(indxk(index_k(jj)))
    kg%indr(jj) = kgt%indr(indxk(index_k(jj)))
    kg%kg0(:,jj) = kgt%kg0(:,indxk(index_k(jj)))
    kg%f(:,jj) = kgt%f(:,indxk(index_k(jj)))
  enddo
  call dealloc_grid(kgt)
  SAFE_DEALLOCATE(indxk)
!
!     indxk : stores the correspondence between k-points kg%r and kp%rk
!     (it is used to select the set of wavefunctions to be stored)
!     tol : tolerance in the coordinates of k-points
!
  SAFE_ALLOCATE(indxk, (kg%nr))
  indxk=0
  do jj=1,kg%nr
    do ii=1,kp%nrk
      kt(:) = kg%r(:,jj) - kp%rk(:,ii)
      if (all(abs(kt(1:3)).lt.tol)) then
        if (indxk(jj).ne.0) write(0,*) 'WARNING: multiple definition of k-point',jj,indxk(jj),kg%r(:,jj)
        indxk(jj)=ii
      endif
    enddo
!
!     If some k-point listed in kg%r is not found in WFN_fi, indxk
!     will store zero. Later, the job will stop in genwf.
!
    if (indxk(jj).eq.0) write(0,'(a,3f12.6,a)') 'WARNING: could not find vector ',kg%r(:,jj),' in WFN_fi'
  enddo
  call logit('input:  done mapping kpts (2)')

!-----------------------------------------------------------------------
!       Distribute kpoints among the PEs
!
  call logit('input:  calling distrib')
  call distrib(xct)
!

!-----------------------------------------------------------------------
!     Order g-vectors with respect to their kinetic energy
!
  call logit('input:  reordering gvecs')
  SAFE_ALLOCATE(index, (gvec%ng))
  SAFE_ALLOCATE(gvec%ekin, (gvec%ng))
  call kinetic_energies(gvec, crys%bdot, gvec%ekin)
  call sortrx(gvec%ng, gvec%ekin, index, gvec = gvec%components)
  
  SAFE_ALLOCATE(ek_tmp, (gvec%ng))
  ek_tmp = gvec%ekin
  SAFE_ALLOCATE(k_tmp, (3,gvec%ng))
  k_tmp = gvec%components
  do ii=1,gvec%ng
    gvec%ekin(ii) = ek_tmp(index(ii))
    gvec%components(:,ii) = k_tmp(:,index(ii))
  enddo
  SAFE_DEALLOCATE(ek_tmp)
  SAFE_DEALLOCATE(k_tmp)
  SAFE_DEALLOCATE(index)

  call gvec_index(gvec)

!-----------------------------------------------------------------------
!     Read the wavefunctions and create INT_CWFN_*
!

  call logit('input:  reading WFN_fi')

  if(peinf%inode.lt.10000) then
    write(filenamec,'(a,i4.4)') 'INT_CWFN_', peinf%inode
  else
    call die('input: cannot use more than 10000 nodes')
  endif
  iunit_c=128+(2*peinf%inode)+1
  call open_file(iunit_c,file=filenamec,form='unformatted',status='replace')

  !FHJ : set up input reader `object`
  call init_reader(inp, 25, iunit_c, 'WFN_fi', kp, xct, gvec)

  do irk=1,kp%nrk

    inp%ng = kp%ngk(irk)

    ! FHJ: this scales as nk^2, but could scale as nk*log(nk)
    irks = 0
    do ii=1,kg%nr
      if (irk.eq.indxk(ii)) then
        irks=ii
        exit
      endif
    enddo
    if (irks==0) then
      if (peinf%inode==0) write(6,*) 'irk=',irk,' rk=',kp%rk(:,irk)
      call die('Cannot find k-point!', only_root_writes=.true.)
    endif

    ! FHJ: Determine to which PE the wavefunctions for this k-point need to be sent.
    send_any = .false.
    inp%send_to(:) = .false.
    do jj=1,peinf%npes
      do ii=1, peinf%ikt(jj)
        if(kg%indr(peinf%ik(jj,ii))==irks) then
          inp%send_to(jj) = .true.
          send_any = .true.
          exit
        endif
      enddo
    enddo

    ! FHJ: Don`t bother reading data if we don`t need the kpt
    if ( .not. send_any ) then
      call skip_kpt(inp)
      cycle
    endif

    ! FHJ: Read gvectors` indices, store in wfnv%isort
    call read_gvecs(inp, irk, gvec)

    ! FHJ: Read all bands and distribute
    call read_bands(inp, irk)

  enddo !end loop over k-points

  call free_reader(inp)

  SAFE_DEALLOCATE(indxk)
  call close_file(iunit_c)

  if(peinf%inode.eq.0) then
    write(6,3004)
3004 format(/,2x,'crystal wavefunctions read from unit WFN_fi')
    write(6,3007) kg%nr
3007 format(/,6x,'nrk= ',i6,26x)
    write(6,'(12x,3f10.4)') ((kg%r(ii,jj),ii=1,3),jj=1,kg%nr)
    write(6,3070) kg%nf,kg%sz
3070 format(/,6x,'  fine grid     nfk= ',i6,4x,'ksz=',f10.5)
    
    call close_file(25)
  endif !end if(inode.eq.0)
  
  SAFE_DEALLOCATE_P(kp%rk)
  SAFE_DEALLOCATE_P(kp%ifmin)
  SAFE_DEALLOCATE_P(kp%ifmax)
  SAFE_DEALLOCATE_P(kp%el)

  ! only needed for comm_disk
#ifdef MPI
  call MPI_Barrier(MPI_COMM_WORLD, mpierr)
#endif
  call logit('input:  done reading WFN_fi')
  call logit('leaving input')

  POP_SUB(input)

  return
end subroutine input

!=========================================================================
!
! Included from file hdf5_io_hdf5.f90.
! You are not expected to understand this. --JIM
!
!=========================================================================

#ifdef READ
  #define READ_WRITE(x) hdf5_read ## x
  #define INTENT inout
  #define H5F_FILE_ACCESS H5F_ACC_RDONLY_F
#else
  #define READ_WRITE(x) hdf5_write ## x
  #define INTENT in
  #define H5F_FILE_ACCESS H5F_ACC_RDWR_F
#endif

#ifdef TYPE_INT
  #define THE_TYPE integer
  #define SUBROUTINE_NAME_SCALAR READ_WRITE(_int)
  #define SUBROUTINE_NAME_ARRAY READ_WRITE(_int_array)
  #define TYPE_SUFFIX(x) x ## _int_f
  #define H5TYPE H5T_NATIVE_INTEGER
#endif
#ifdef TYPE_DOUBLE
  #define THE_TYPE real(DP)
  #define SUBROUTINE_NAME_SCALAR READ_WRITE(_double)
  #define SUBROUTINE_NAME_ARRAY READ_WRITE(_double_array)
  #define TYPE_SUFFIX(x) x ## _double_f
  #define H5TYPE H5T_NATIVE_DOUBLE
#endif

#ifdef READ
  #define H5LT_READ_WRITE TYPE_SUFFIX(h5ltread_dataset)
#else
  #define H5LT_READ_WRITE TYPE_SUFFIX(h5ltmake_dataset)
#endif

subroutine SUBROUTINE_NAME_SCALAR(loc_id, dset_name, buf, errcode)
  integer(HID_T), intent(in) :: loc_id !< HDF5 file id
  character(LEN=*), intent(in) :: dset_name !< HDF5 dataset name
  THE_TYPE, intent(INTENT) :: buf !< data buffer
  integer :: errcode !< HDF5 error code
  
  integer(HSIZE_T), dimension(1) :: dims_h5type(1)
# ifdef READ
  THE_TYPE, dimension(1) :: buf_1(1)
#else
  logical :: exists_
  integer(HID_T) :: dset_id
#endif
  
  PUSH_SUB(SUBROUTINE_NAME_SCALAR)
  
  dims_h5type(1) = 0
  
#ifdef READ
  call H5LT_READ_WRITE(loc_id, dset_name, buf_1, dims_h5type, errcode)
  buf = buf_1(1)
#else
  !FHJ: We can`t use H5LTmake_dataset_* if the dataset already exists!
  exists_ = H5LTfind_dataset_f(loc_id, dset_name)==1
  if (exists_) then
    call h5dopen_f(loc_id, dset_name, dset_id, errcode)
    call h5dwrite_f(dset_id, H5TYPE, (/buf/), dims_h5type, errcode)
    call h5dclose_f(dset_id, errcode)
  else
    call H5LT_READ_WRITE(loc_id, dset_name, 0, dims_h5type, (/buf/), errcode)
  endif
#endif
  
  POP_SUB(SUBROUTINE_NAME_SCALAR)
end subroutine

subroutine SUBROUTINE_NAME_ARRAY(loc_id, dset_name, dims, buf, errcode)
  integer(HID_T), intent(in) :: loc_id !< HDF5 file id
  character(LEN=*), intent(in) :: dset_name !< HDF5 dataset name
  integer, intent(in), dimension(:) :: dims !< size of the buffer buf
  THE_TYPE, intent(INTENT), dimension(*) :: buf !< data buffer
  integer :: errcode !< error code
  
  integer :: rank
  integer(HSIZE_T), dimension(size(dims)) :: dims_h5type
#ifndef READ
  logical :: exists_
  integer(HID_T) :: dset_id
#endif
  
  PUSH_SUB(SUBROUTINE_NAME_ARRAY)
  
  rank = size(dims)
  dims_h5type = dims
    
#ifdef READ
  call H5LT_READ_WRITE(loc_id, dset_name, buf, dims_h5type, errcode)
#else
  !FHJ: We can`t use H5LTmake_dataset_* if the dataset already exists!
  exists_ = H5LTfind_dataset_f(loc_id, dset_name)==1
  if (exists_) then
    call h5dopen_f(loc_id, dset_name, dset_id, errcode)
    call h5dwrite_f(dset_id, H5TYPE, buf, dims_h5type, errcode)
    call h5dclose_f(dset_id, errcode)
  else
    call H5LT_READ_WRITE(loc_id, dset_name, rank, dims_h5type, buf, errcode)
  endif
#endif
  
  POP_SUB(SUBROUTINE_NAME_ARRAY)
end subroutine

#undef READ_WRITE
#undef INTENT
#undef THE_TYPE
#undef TYPE_SUFFIX
#undef H5TYPE
#undef SUBROUTINE_NAME_SCALAR
#undef SUBROUTINE_NAME_ARRAY

#undef H5LT_READ_WRITE
#undef H5F_FILE_ACCESS

!==============================================================================
!
! Routines:
!
! (1) epsilon           Originally by (MSH)      Last Edited 5/1/2008 (JRD)
!
!     Send comments/bugs to jdeslip@berkeley.edu
!
!     See README file for more details
!
!==============================================================================

#include "f_defs.h"

program epsilon

  use global_m
  use blas_m
  use chi_summation_m
  use chi_convergence_m
  use fftw_m
  use fullbz_m
  use genwf_eps_m
  use gmap_m
  use input_m
  use input_q_m
  use input_utils_m
  use irrbz_m
  use mtxel_m
  use mtxelmultiply_m
  use read_matrix_m
  use scalapack_m
  use sort_m
  use vcoul_generator_m
  use write_matrix_m
  use io_utils_m
  use epswrite_hdf5_m

#ifdef HDF5
  use hdf5
#endif
  
  implicit none

  type (kpoints) :: kp
  type (kpoints) :: kpq
  type (symmetry) :: syms
  type (gspace) :: gvec
  type (crystal) :: crys
  type (polarizability) :: pol
  type (valence_wfns) :: vwfn
  type (conduction_wfns) :: cwfn
  type (scalapack) :: scal
  type (int_wavefunction) :: intwfnv
  type (int_wavefunction) :: intwfnvq
  type (int_wavefunction) :: intwfnc
  type(chi_summator_t) :: chi_summator
  type(chi_converger_t) :: chi_converger
  type(wfn_FFT_comm_t) :: wfn_FFT_comm

!-----------------------
! Arrays for kpoints (fullbz, ...etc)

  integer :: nrk
  integer :: indst(48)
  integer, allocatable :: indrk(:),neq(:)
  type(grid) :: gr

!-----------------------
! Arrays for polarizability matrix

  integer :: nstar
  logical :: is_q0, use_WFNq, qpt_done
  integer :: npcmax,nprmax,ivin,neqmax
  integer, allocatable :: ind(:),indt(:,:,:)
  integer, allocatable :: nprdtemp(:),npcdtemp(:)
  integer, allocatable :: imyrowdtemp(:,:),imycoldtemp(:,:)
  real(DP) :: qq(3) !< The current q-pt under consideration
  real(DP) :: omega_plasma
  real(DP), allocatable :: ekin(:)
  SCALAR, allocatable :: ph(:)
  SCALAR, allocatable :: pht(:,:,:)
  integer, allocatable :: nst(:)

!-----------------------
! Variables used with HDF5

#ifdef HDF5
  integer :: hdf5_error
  integer :: my_iq
  integer, allocatable :: isorti(:)
  character(len=13) :: filename_chi_hdf5, filename_eps_hdf5, filename_out_hdf5
#endif

  character :: tmpstr*100
  character :: filename*13
  integer :: initial_access = 0
  integer :: i,j,k,n,irk,iv,itran,it
  integer :: ncount,ix,jx,kgq(3)
  integer :: np,iunit,iq,icurr
  integer :: ik, ij
  integer :: nmtx_t
  real(DP) :: tsec(2)
  real(DP) :: fact,rk(3)
  integer :: ispin,icol,irow,icolm,irowm
  character*24 :: routnam(120)
  integer :: routsrt(50)
  integer :: iunit_v, iunit_c
  real(DP) :: dnpcr,dnpcrmax

  integer :: jj

  type(progress_info) :: prog_info !< a user-friendly progress report

!--------------- Begin Program ---------------------------------------

  call peinfo_init()
  
!----------------------
! Initialize random numbers

  peinf%jobtypeeval = 0

!--------------------
! Initialize timer

  if(peinf%inode .eq. 0) then
    call timacc(0,0)
    call timacc(1,1)
  endif

!------------------------
! Initialize files

  if(peinf%inode .eq. 0) call timacc(19,1)
  
  call open_file(55,file='epsilon.inp',form='formatted',status='old')
  if(peinf%inode .eq. 0) then
    call open_file(7,file='epsilon.log',form='formatted',status='replace')
  endif
  
  call write_program_header('Epsilon', .true.)

!----------- Call Input: Read crystal data from unit 25 ---------------

! read parameters and q-points from unit 55 (input file)
! initialize unit 10 (output for polarizability matrix)

  if(peinf%inode .eq. 0) call timacc(19,2)
  
  if(peinf%inode .eq. 0) call timacc(2,1)
  call input(kp,crys,syms,gvec,pol,cwfn,vwfn,intwfnv,intwfnc,omega_plasma,gr)
  pol%FFTgrid = gvec%FFTgrid
  if (pol%min_fftgrid) then
    ! FHJ: Figure our the FFT grid that holds the WFNs
    call get_wfn_fftgrid(pol, gvec, kp, intwfnv)
  endif

  if(.not. pol%skip_chi .and. peinf%inode == 0) then
    call open_file(17,file='chi_converge.dat',form='formatted',status='replace')
  endif

#ifdef CPLX
  if(peinf%inode == 0 .and. pol%freq_dep == 2) &
    call open_file(83,file='polchiA.log',form='formatted',status='replace')
#endif

  if (pol%iwritecoul .eq. 1) then
    if (peinf%inode .eq. 0) then
      call open_file(19,file='vcoul',form='formatted',status='replace')
    endif
  endif

! CHP: saves the (G=0,G`=0) component of (retarded) epsilon inverse
  if(peinf%inode .eq. 0 .and. pol%freq_dep .eq. 2) then
    call open_file(51,file='EpsInvDyn',form='formatted',status='replace')
    call open_file(52,file='EpsDyn',form='formatted',status='replace')
  endif

  SAFE_ALLOCATE(vwfn%isort, (gvec%ng))
  SAFE_ALLOCATE(cwfn%isort, (gvec%ng))

  if (pol%nq0>0) then
    ! FHJ: no q->0 point can have all coordinates set to zero
    if (pol%icutv==0.and.any(all(abs(pol%qpt(:,:pol%nq0))<TOL_ZERO,dim=1))) then
      call die('No truncation and zero q0', only_root_writes=.true.)
    endif
  endif
  
  if(peinf%inode .eq. 0) call timacc(2,2)


!-------------- Read wavefunctions for (k+q) points ---------------------

! SIB:  The input_q routine looks the same as the input routine but
! if reads from a file called WFNq instead of WFN.  Presumably
! these are the shifted (by "q") wave functions.

  if(peinf%inode .eq. 0) call timacc(3,1)
  if (pol%need_WFNq) then
    if (peinf%inode .eq. 0) then
      write(6,*) 'You have a slightly shifted q0 vector and a semiconductor.'
      write(6,*) 'So reading from WFNq.'
    endif
    call input_q(gvec,kpq,cwfn,vwfn,pol,intwfnvq)
  elseif (pol%lin_denominator>TOL_Zero) then
  endif
  if(peinf%inode .eq. 0) call timacc(3,2)


!-------------- GENERATE FULL BZ ----------------------------------------

! SIB:  fullbz() takes the kpoints in kp%components(1:3,kp%nrk) and applies all
! the symmetries in syms to them.  The resulting set of unique vectors
! are in gr%f(1:3,gr%nf) (gr%nf of them).

  if (peinf%inode .eq. 0) then
#ifdef VERBOSE
    write(6,*)
    write(6,*) 'Calling fullbz to generate full zone from'
    write(6,*) 'syms%ntran = ',syms%ntran
    write(6,*) 'kp%nrk = ',kp%nrk
    do iq=1,kp%nrk
      write(6,'(3f10.4)') kp%rk(:,iq)
    enddo
    write(6,*)
#endif
    write(6,*) 'nfk=',gr%nf
#ifdef VERBOSE
    do iq=1,gr%nf
      write(6,'(3f10.4)') gr%f(:,iq)
    enddo
#endif
  endif

  SAFE_ALLOCATE(ekin, (gvec%ng))  
  SAFE_ALLOCATE(scal%nprd, (peinf%npes_freqgrp))
  SAFE_ALLOCATE(scal%npcd, (peinf%npes_freqgrp))

  if (pol%os_opt_ffts==2) then
    ! FHJ: FFTs opt. level 2 => do all the FFTs using all the processor, int_wfn arrays
    call genwf_FFT_Isend(wfn_FFT_comm,crys,gvec,syms,kp,kpq,vwfn,pol,cwfn,intwfnv,intwfnvq,intwfnc)
    !call genwf_FFT(crys,gvec,syms,kp,kpq,vwfn,pol,cwfn,intwfnv,intwfnvq,intwfnc,need_WFNq)
  endif

!----------- LOOP over q points for which chi and eps are calculated -----
  do iq=1,pol%nq

    if (pol%stop_after_qpt>-1 .and. iq>pol%stop_after_qpt) then
      if (peinf%inode==0) write(6,'(/,1x,a,/)') 'stop_after_qpt: emulating a sudden application stop.'
      FLUSH(6)
      FLUSH(0)
#ifdef MPI
      call MPI_Barrier(MPI_COMM_WORLD, mpierr)
      call MPI_Finalize(mpierr)
#endif
      MYSLEEP(1)
      stop
    endif

    ! SIB: qq(1:3) is the current q vector under consideration
    qq(:)=pol%qpt(:,iq)
    if(peinf%inode.eq.0) then
      call print_dealing_with(iq, pol%nq, qq, 'q')
    endif
    is_q0 = iq<=pol%nq0
    use_WFNq = (is_q0.and.pol%need_WFNq).or.pol%patched_sampling
    if (peinf%inode==0) then
      if (is_q0) then
        write(6,'(1x,a)') 'This is the special q->0 point.'
      else
        write(6,'(1x,a)') 'This is a regular non-zero q-point.'
      endif
    endif

#ifdef HDF5
    my_iq = iq
    if (.not.is_q0) my_iq = iq - pol%nq0
    if (is_q0) then
      filename_eps_hdf5 = 'eps0mat.h5'
      filename_chi_hdf5 = 'chi0mat.h5'
    else
      filename_eps_hdf5 = 'epsmat.h5'
      filename_chi_hdf5 = 'chimat.h5'
    endif
    if (pol%skip_epsilon) then
      filename_out_hdf5 = filename_chi_hdf5 ! Write to/restart chimat file
    else
      filename_out_hdf5 = filename_eps_hdf5 ! Write to/restart epsmat file
    endif
    if (pol%use_hdf5.and.pol%restart) then
      if (peinf%inode==0) qpt_done = is_qpt_done(TRUNC(filename_out_hdf5), my_iq)
#ifdef MPI
      call MPI_BCAST(qpt_done, 1, MPI_LOGICAL, 0, MPI_COMM_WORLD, mpierr)
#endif
      if (qpt_done) then
        if (peinf%inode==0) then
          write(6,'(/,1x,a,/)') 'This q-point was already calculated: skipping.'
        endif
        cycle
      endif
    endif
#endif

    if(peinf%inode.eq.0) call timacc(20,1)

!--------------------
! Determine number of matrix elements
!
! Calculate kinetic energies |q+G|^2

    if (is_q0) then
      call kinetic_energies(gvec, crys%bdot, ekin)
    else
      call kinetic_energies(gvec, crys%bdot, ekin, qvec = qq)
    endif

!--------------------
! Sort kinetic energies
! index of ordered kinetic energies in array isrtx
!
! SIB: pol%isrtx has the indices for sorted ekin

    SAFE_ALLOCATE(pol%isrtx, (gvec%ng))

    if(peinf%inode.eq.0) call timacc(20,2)
    
    if(peinf%inode.eq.0) call timacc(5,1)
#ifdef VERBOSE
    call logit('sorting gvec')
#endif
    call sortrx(gvec%ng, ekin, pol%isrtx, gvec = gvec%components)
    if(peinf%inode.eq.0) call timacc(5,2)

!---------------------
! Compute inverse array to isrtx

    SAFE_ALLOCATE(pol%isrtxi, (gvec%ng))
    do i=1,gvec%ng
      pol%isrtxi(pol%isrtx(i))=i
    enddo

! SIB:  pol%nmtx becomes the number of matrix elements to be computed;
! the matrix is computed if its ekin is < ecuts

    if(peinf%inode.eq.0) call timacc(21,1)

    pol%nmtx = gcutoff(gvec%ng, ekin, pol%isrtx, pol%ecuts)
    if(peinf%inode.eq.0) then
      write(6, '(1x,a,i0)') 'Rank of the polarizability matrix (nmtx): ', pol%nmtx
    endif
    ! FHJ: Do we want to use the economical fftgrid/box? If so, we pad the WFN FFTbox
    ! by the box that holds nmtx gvectors, which is much smaller than the WFN fftbox.
    if (pol%min_fftgrid.and.pol%os_opt_ffts<2) call get_eps_fftgrid(pol, gvec)
    
    if(peinf%inode.eq.0) call timacc(21,2)
    if(peinf%inode.eq.0) call timacc(22,1)

    SAFE_ALLOCATE(pol%irow, (pol%nmtx))
    pol%irow=0

! JRD:  Determine size of distributed matrices


    if(pol%os_para_freqs .gt. 1) then
    else
      call blacs_setup(scal, pol%nmtx, .true.)
    endif
#ifdef USESCALAPACK
#ifdef VERBOSE
    call logit('Initializing scaLAPACK')
    if (peinf%inode .eq. 0) then
      write(6,*) ' '
    endif
#endif
#endif

#ifdef MPI
    SAFE_ALLOCATE(nprdtemp, (peinf%npes_freqgrp))
    SAFE_ALLOCATE(npcdtemp, (peinf%npes_freqgrp))
    
    scal%nprd = 0
    scal%npcd = 0
    nprdtemp = 0
    npcdtemp = 0

    if(pol%os_para_freqs .gt. 1) then
    else
      nprdtemp(peinf%inode + 1) = scal%npr
      npcdtemp(peinf%inode + 1) = scal%npc
      call MPI_ALLREDUCE(nprdtemp,scal%nprd,peinf%npes_freqgrp,MPI_INTEGER,MPI_SUM, MPI_COMM_WORLD,mpierr)
      call MPI_ALLREDUCE(npcdtemp,scal%npcd,peinf%npes_freqgrp,MPI_INTEGER,MPI_SUM, MPI_COMM_WORLD,mpierr)
    endif
    SAFE_DEALLOCATE(nprdtemp)
    SAFE_DEALLOCATE(npcdtemp)
#else
    scal%nprd = scal%npr
    scal%npcd = scal%npc
#endif

! DWV: Get the maximum number of columns/rows owned by one of the processors. This is so you can
! allocate arrays of the right size. For what determines how many rows and columns a procesor
! has, see blacs_setup routine in Common directory and google the numroc routine of scalapack
! Numroc is a nifty little routine

    dnpcr = scal%npc*1D0*scal%npr

#ifdef MPI
    call MPI_ALLREDUCE(scal%npc,npcmax,1,MPI_INTEGER,MPI_MAX,MPI_COMM_WORLD,mpierr)
    call MPI_ALLREDUCE(scal%npr,nprmax,1,MPI_INTEGER,MPI_MAX,MPI_COMM_WORLD,mpierr)
    call MPI_ALLREDUCE(dnpcr,dnpcrmax,1,MPI_DOUBLE_PRECISION,MPI_MAX,MPI_COMM_WORLD,mpierr)
#else
    npcmax = scal%npc
    nprmax = scal%npr
#endif

    if (dnpcr .gt. (pol%nmtx*1.5D0*pol%nmtx/(1D0*peinf%npes))) then
      if (peinf%inode .eq. 0) write(0,'(a)') ' WARNING: ScaLAPACK layout is not well load-balanced.'
      if (peinf%inode .eq. 0) write(0,'(a,f12.0)') ' Max number of elements owned by one task is:', dnpcr
    endif

! Allocate scalapack arrays needed later. See scalapack in Common/scalapack.f90 to see what
! these arrays hold

    SAFE_ALLOCATE(scal%isrtxcol, (scal%npc))
    SAFE_ALLOCATE(scal%isrtxrow, (scal%npr))
    SAFE_ALLOCATE(scal%imycol, (scal%npc))
    SAFE_ALLOCATE(scal%imyrow, (scal%npr))
    SAFE_ALLOCATE(scal%imycolinv, (pol%nmtx))
    SAFE_ALLOCATE(scal%imyrowinv, (pol%nmtx))
    SAFE_ALLOCATE(scal%imycold, (npcmax,peinf%npes))
    SAFE_ALLOCATE(scal%imyrowd, (nprmax,peinf%npes))
    SAFE_ALLOCATE(imycoldtemp, (npcmax,peinf%npes))
    SAFE_ALLOCATE(imyrowdtemp, (nprmax,peinf%npes))
    scal%imycold = 0
    scal%imyrowd = 0
    imycoldtemp = 0
    imyrowdtemp = 0

    icurr=0
    
    do ij = 1, pol%nmtx
      irow=MOD(INT(((ij-1)/scal%nbl)+TOL_SMALL),scal%nprow)
      if (irow .eq. scal%myprow) then
        do ik = 1, pol%nmtx
          icol=MOD(INT(((ik-1)/scal%nbl)+TOL_SMALL),scal%npcol)
          if(icol .eq. scal%mypcol) then
            icurr=icurr+1
            irowm=INT((icurr-1)/scal%npc+TOL_SMALL)+1
            icolm=MOD((icurr-1),scal%npc)+1
            scal%isrtxrow(irowm)=pol%isrtx(ij)
            scal%isrtxcol(icolm)=pol%isrtx(ik)
            scal%imyrow(irowm)=ij
            scal%imycol(icolm)=ik
            scal%imyrowinv(ij)=irowm
            scal%imycolinv(ik)=icolm
            imyrowdtemp(irowm,peinf%inode+1)=ij
            imycoldtemp(icolm,peinf%inode+1)=ik
          endif
        enddo
      endif
    enddo

#ifdef MPI
    call MPI_ALLREDUCE(imyrowdtemp(1,1),scal%imyrowd(1,1),nprmax*peinf%npes,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,mpierr)
    call MPI_ALLREDUCE(imycoldtemp(1,1),scal%imycold(1,1),npcmax*peinf%npes,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,mpierr)
#else
    scal%imyrowd = imyrowdtemp
    scal%imycold = imycoldtemp
#endif

    SAFE_DEALLOCATE(imycoldtemp)
    SAFE_DEALLOCATE(imyrowdtemp)

    if(peinf%inode.eq.0) call timacc(22,2)

    if(peinf%inode.eq.0) call timacc(23,1)

!----------------------
! Determine subgroup which leaves qq invariant
!
! SIB:  figures out which symmetries acting on qq result in qq + integer
! entries.  syms%ntranq is their number, syms%indsub are their indices
! (pointing to syms%mtrx), and syms%kgzero(1:3,:) are the integer entries.

    if(peinf%inode.eq.0) call timacc(6,1)
    call subgrp(qq,syms)
    if (pol%patched_sampling) then
      syms%ntranq = 1
    endif
    if(peinf%inode.eq.0) call timacc(6,2)

!-----------------------
! Determine independent elements of polarizability matrix
!
! SIB:  independent means due to symmetries.  This initializes
! the polarizability matrix pol%chi to zero (for independent entries)
! and figure out phases due to symmetries for dependent ones,
! and points dependent ones to the entries they depend on (pol%kxi indices)

! JRD: we don`t do this anymore

!        if(peinf%inode.eq.0) call timacc(7,1)
!#ifdef VERBOSE
!        call logit('calling indep')
!#endif
!        call indep(nind,gvec,syms,pol,kp%nspin)
!
! JRD: Testing what if we set pol%kxi to zero
!        pol%kxi = 0
!        pol%chi = 0D0
!        nind=pol%nmtx*(pol%nmtx+1)/2
!
!        if(peinf%inode.eq.0) call timacc(7,2)

!----------------------
! Reduce the k-points to the irr. bz with respect to q
!
! SIB:  figure out k-points in irr. BZ (based on symmetries for current q)
! nrk is # of irr. points, indrk are their indices in the full zone,
! and neq is the number of equiv. points for an irr. point.
! (Full zone vectors come in through gr%f(1:3,1:gr%nf).)

    if(peinf%inode.eq.0) call timacc(8,1)
    SAFE_ALLOCATE(indrk, (gr%nf))
    SAFE_ALLOCATE(neq, (gr%nf))
    call irrbz(syms,gr%nf,gr%f,nrk,neq,indrk)
    if(peinf%inode.eq.0) call timacc(8,2)

    neqmax = maxval(neq(1:nrk))

!        write(6,*) peinf%inode, 'neqmax', neq(1), neqmax

!---------------------------
! Output points in irr. bz

    if(peinf%inode.eq.0) then
      write(6,'(1x,a,i0)') 'Number of k-points in the irreducible BZ(q) (nrk): ', nrk
#ifdef VERBOSE
      do j=1,nrk
        write(6,60) (gr%f(i,indrk(j)),i=1,3),neq(j)
60      format(3f10.5,i5)
      enddo
#endif
      write(7,70) (qq(i),i=1,3),pol%nmtx,nrk
70    format(/ /,5x,'q=',3f7.4,2x,'nmtx=',i8,2x,'nrk=',i3)
    endif

    if (pol%patched_sampling) then
      fact=4.0d0/(product(kp%kgrid)*crys%celvol*kp%nspin*kp%nspinor)
    else
      fact=4.0d0/(dble(gr%nf)*crys%celvol*kp%nspin*kp%nspinor)
    endif

    if (pol%freq_dep .eq. 0) then
      SAFE_ALLOCATE(pol%chi, (scal%npr,scal%npc,kp%nspin))
      pol%chi=ZERO
    endif

    if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 0)) then
      SAFE_ALLOCATE(pol%chiRDyn, (pol%os_nfreq_para,scal%npr,scal%npc,kp%nspin))
      pol%chiRDyn=(0.0,0.0)
#ifdef CPLX
      SAFE_ALLOCATE(pol%chiADyn, (pol%os_nfreq_para,scal%npr,scal%npc,kp%nspin))
      pol%chiADyn=(0.0,0.0)
#endif
    endif

    if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 1)) then
      SAFE_ALLOCATE(pol%chiRDyn, (pol%os_nfreq_para,scal%npr,scal%npc,kp%nspin))
      pol%chiRDyn=(0.0,0.0)
#ifdef CPLX
      SAFE_ALLOCATE(pol%chiADyn, (pol%os_nfreq_para,scal%npr,scal%npc,kp%nspin))
      pol%chiADyn=(0.0,0.0)
#endif
      SAFE_ALLOCATE(pol%chiTDyn, (pol%os_nsfreq_para,scal%npr,scal%npc,kp%nspin))
      pol%chiTDyn=(0.0,0.0)
    endif

    if (pol%freq_dep .eq. 3) then
      SAFE_ALLOCATE(pol%chiRDyn, (pol%os_nfreq_para,scal%npr,scal%npc,kp%nspin))
      pol%chiRDyn=(0.0,0.0)
    endif

    if (.not. pol%skip_chi) then

!------------------------------------
! SIB:  allocate space

!        write(6,*) peinf%inode, 'allocating pht', neqmax, pol%nmtx, nrk

      SAFE_ALLOCATE(ind, (pol%nmtx))
      SAFE_ALLOCATE(ph, (pol%nmtx))
      SAFE_ALLOCATE(pht, (pol%nmtx,neqmax,nrk))
      SAFE_ALLOCATE(indt, (pol%nmtx,neqmax,nrk))
      ind=0

      SAFE_ALLOCATE(nst, (nrk))

! JRD: Possible Memory Hazard.  We can speed this up by possibly
! only allocating number of bands on current proc and doing send/recvs
      if(pol%os_para_freqs .gt. 1) then      
      else
        SAFE_ALLOCATE(pol%gme, (pol%nmtx,peinf%ncownactual,peinf%nvownactual,kp%nspin,nrk,pol%os_para_freqs))
      endif
    
      if (pol%freq_dep .eq. 2 .or. pol%freq_dep .eq. 3) then
        if(pol%os_para_freqs .eq. 1) then      
          SAFE_ALLOCATE(pol%edenDyn, (peinf%nvownactual,peinf%ncownactual,kp%nspin,nrk,pol%os_para_freqs))
        else
        endif
      endif

      if(peinf%inode.eq.0) call timacc(23,2)

!--------- LOOP OVER K-POINTS IN SET RK ---------------------------------
      ! FHJ: this is to generate nice output / time estimate
      call progress_init(prog_info, 'calculation of matrix elements', 'transition', nrk)

! SIB:  loop over points in irreducible zone
      do irk=1,nrk
        ! FHJ : friendly output / running time estimate
        call progress_step(prog_info, irk)
        
        if (pol%freq_dep .eq. 0) then
          SAFE_ALLOCATE(pol%eden, (vwfn%nband+pol%ncrit,cwfn%nband,kp%nspin))
          
        endif
        
        rk(:)=gr%f(:,indrk(irk)) ! rk(:) is the current irr. k-point

! Regenerate star of rk,store the index of the rotation
! SIB:  Star is the set of vectors generated by applying all
! subgroup operations for the current q-vector to the k-point rk.

        if(peinf%inode.eq.0) call timacc(11,1)
        call rqstar(syms,nstar,indst,rk)
        if(nstar.ne.neq(irk)) then
          write(0,*) 'nstar?',irk,nstar,neq(irk)
          call die('nstar mismatch')
        endif
        if(peinf%inode.eq.0) call timacc(11,2)

! JRD: loop over transfs which generate the star of rk for gmap

        nst(irk) = nstar
        if(peinf%inode.eq.0) call timacc(12,1)
        do it=1,nstar

! Map g-vectors in polarizability to r**(-1)(g-gq)
! note that gmap requires index of transf in full group
! whereas indst gives index in subgroup

          itran = syms%indsub(indst(it))
          kgq(:) = -syms%kgzero(:,indst(it)) ! note minus sign
          call gmap(gvec,syms,pol%nmtx,itran,kgq,pol%isrtx,pol%isrtxi,ind,ph,.true.)

          pht(:,it,irk) = ph(:)
          indt(:,it,irk) = ind(:)

! debug Statement here
        enddo
        if(peinf%inode.eq.0) call timacc(12,2)


!--------- loop over occupied states -------------------------------------

! SIB:  loop over valence states (iv,ispin) where iv is the band index.

        if (pol%os_opt_ffts==2) then
          if (.not.wfn_FFT_comm%done) call genwf_FFT_Wait(wfn_FFT_comm)
          !FHJ: TODO free me later!
          call genwf_lvl2(kp,kpq,vwfn,pol,cwfn)
        endif
        pol%gme(:,:,:,:,irk,:)=0D0
        do iv=1,peinf%nvownmax
#ifdef VERBOSE
          if (peinf%inode .eq. 0) write(6,*) 'Doing iv', iv,'of', peinf%nvownmax
#endif

          if (pol%os_opt_ffts/=2) then
            call genwf_gen(syms,gvec,crys,kp,kpq,irk,rk,qq,vwfn,pol,cwfn,use_WFNq,intwfnv,intwfnvq,intwfnc,iv)

            if (pol%os_opt_ffts==1) then
              ! FHJ: FFT opt. level 1: precalculates FFTs of the conduction bands
              !      each kpt at a time.
              if (iv==1) then
                call mtxel_init_FFT_cond(gvec,pol,cwfn,kp)
              endif
            endif
          endif

! SIB:  compute matrix elements and energy denominators for (iv,ispin)
! with all other conduction bands.

          do ispin=1,kp%nspin

#ifdef VERBOSE
            write(tmpstr,'(a,i2,a,i4,a)') "is =", ispin, " iv = ", iv, " calling mtxel" 
            call logit(tmpstr)
#endif

            if ( iv .le. peinf%nvownactual) then
              if(peinf%inode.eq.0) call timacc(10,1)
              ivin=peinf%invindexv(iv)

              call mtxel(ivin,gvec,vwfn,cwfn,pol,ispin,irk,kp,kpq,peinf%rank_mtxel)

              if(peinf%inode.eq.0) call timacc(10,2)
            endif

          enddo ! ispin

          if (pol%os_opt_ffts<2) then
            ! FHJ: opt. lvl 2 doesn`t even own the WFNs..
            if ( iv .le. peinf%nvownactual) then
              SAFE_DEALLOCATE_P(vwfn%zv)
            endif
          endif

        enddo ! iv

        if (peinf%nvownactual>0) then
          if (pol%os_opt_ffts<2) then
            SAFE_DEALLOCATE_P(cwfn%zc)
          endif
          if (pol%os_opt_ffts==1) then
            ! FHJ: destroy FFTs of conduction bands
            call mtxel_free_FFT_cond(cwfn)
          endif

          SAFE_DEALLOCATE_P(vwfn%ev)
          SAFE_DEALLOCATE_P(cwfn%ec)
        endif

        if (pol%freq_dep .eq. 0) then
          SAFE_DEALLOCATE_P(pol%eden)
        endif
        
      enddo ! irk
      call progress_free(prog_info)

!------------------------------------------------------------------
! DWV: if requested, test convergence of chi with conduction bands

      if (peinf%inode .eq. 0 .and. pol%freq_dep .eq. 0 .and. pol%fullConvLog .ne. -1) then
        write(6,*) 'Allocating Convergence Arrays of Dim', cwfn%nband-vwfn%nband
      endif

      if(peinf%inode.eq.0) call timacc(24,1)

      if (pol%freq_dep .eq. 0 .and. pol%fullConvLog .ne. -1) then

        call create_chi_converger(chi_converger,vwfn%nband,cwfn%nband)

#ifdef VERBOSE
        if (peinf%inode .eq. 0) write(6,'(/,1x,"Starting Convergence Tests")')
#endif
        call chi_convergence_test(pol,pht,indt,kp,nrk,nst,vwfn%nband,cwfn%nband,fact,chi_converger)
 
        if(peinf%inode .eq. 0) then
          call chi_convergence_print(pol,iq,vwfn%nband,cwfn%nband,chi_converger)
        endif

        call free_chi_converger(chi_converger)

!        write(6,*) 'End Convergence Writing'

      endif ! pol%freq_dep .eq. 0

      if(peinf%inode.eq.0) call timacc(24,2)


!-----------------------------------------------------------------------
! Construct part of chi that this proc owns by summing the pol%gme matrices

#ifdef VERBOSE
      if (peinf%inode .eq. 0) write(6,'(/,1x,"Doing chi Summation")')
#endif
      if (peinf%inode.eq.0) call timacc(15,1)

      call create_chi_summator(chi_summator, pol, fact)

      if (pol%gcomm .eq. 0) then
        call chi_summation_comm_elements(chi_summator,&
                                     pol,scal,kp,vwfn,cwfn,&
                                     nst,nrk,indt,pht)
      else
        call chi_summation_comm_matrix(chi_summator,&
                                       pol,scal,kp,kpq,vwfn,&
                                       nst,nrk,indt,pht)
      endif

      call free_chi_summator(chi_summator, pol)
          
      if(peinf%inode.eq.0) call timacc(15,2)
#ifdef VERBOSE 
      if (peinf%inode .eq. 0) write(6,'(1x,a)') "Done Polarizability"
#endif


! Done ChiSum
!-----------------------------------------------------------------------
! Deallocate some arrays no longer needed

      SAFE_DEALLOCATE(pht)
      SAFE_DEALLOCATE(indt)
      SAFE_DEALLOCATE(ind)
      SAFE_DEALLOCATE(ph)
      SAFE_DEALLOCATE(nst)
      SAFE_DEALLOCATE_P(pol%gme)

      if (pol%freq_dep .eq. 2 .or. pol%freq_dep .eq. 3) then
        SAFE_DEALLOCATE_P(pol%edenDyn)
      endif

    else ! pol%skip_chi
!DWV: read chi from chi if this is specified

#ifdef HDF5
      if (pol%use_hdf5) then
        if (peinf%inode .eq. 0) then
          ! FHJ: FIXME: consistency checks...
        endif
        ! FHJ: TODO - write diagonal elements (I actually think this is useless)
        if (pol%freq_dep .eq. 0) then
          do ispin=1,kp%nspin
            call read_matrix_d_hdf5(scal, pol%chi(:,:,ispin), pol%nmtx, TRUNC(filename_chi_hdf5), my_iq, ispin)
          enddo
        else
          do ispin=1,kp%nspin
            call read_matrix_f_hdf5(scal, pol%nFreq, pol%os_nfreq_para, pol%chiRDyn(:,:,:,ispin), &
              pol%chiADyn(:,:,:,ispin), pol%nmtx, pol%os_para_freqs, TRUNC(filename_chi_hdf5), my_iq, ispin)
          enddo
        endif
      else
#endif

      if (is_q0) then
        
        iunit=10
        if(peinf%inode.eq.0) then
          write(6,'(1x,a)') 'Reading from file chi0mat.'
          call open_file(unit=10,file='chi0mat',form='unformatted',status='old')
          read(10)
          read(10)
          read(10)
          read(10)
          read(10)
          read(10)
          read(10)
          read(10)
          read(10)
          read(10)
          read(10) 
          read(10) nmtx_t
!                write(6,*) 'nmtx_t for chi0mat', nmtx_t
        endif
#ifdef MPI
        call mpi_barrier(MPI_COMM_WORLD,mpierr)
#endif
        do ispin=1,kp%nspin
          if (pol%freq_dep .eq. 0) then
            call read_matrix_d(scal,pol%chi(:,:,ispin),pol%nmtx,iunit)
          endif ! pol%freq_dep .eq. 0
          if (pol%freq_dep .eq. 2) then
            call read_matrix_f(scal,pol%nFreq,pol%os_nfreq_para,pol%chiRDyn(:,:,:,ispin), &
              pol%chiADyn(:,:,:,ispin),pol%nmtx,pol%os_para_freqs,iunit)
          endif ! pol%freq_dep .eq. 2!Note here!
        enddo ! ispin

      else ! is_q0

        iunit=11
        if(peinf%inode.eq.0) then
          write(6,'(1x,a)') 'Reading from file chimat.'
          if (initial_access .eq. 0) then
            call open_file(unit=11,file='chimat',form='unformatted',status='old')
            read(11)
            read(11)
            read(11)
            read(11)
            read(11)
            read(11)
            read(11)
            read(11)
            read(11)
            read(11)
          endif
          read(11)
          read(11) nmtx_t
!                write(6,*) 'nmtx_t for chimat', nmtx_t
        endif
#ifdef MPI
        call mpi_barrier(MPI_COMM_WORLD,mpierr)
#endif
        do ispin=1,kp%nspin
          if (pol%freq_dep .eq. 0) then
            call read_matrix_d(scal,pol%chi(:,:,ispin),pol%nmtx,iunit)
          endif ! pol%freq_dep .eq. 0
          if (pol%freq_dep .eq. 2) then
            call read_matrix_f(scal,pol%nFreq,pol%os_nfreq_para,pol%chiRDyn(:,:,:,ispin),&
                               pol%chiADyn(:,:,:,ispin),pol%nmtx,pol%os_para_freqs,iunit)
          endif ! pol%freq_dep .eq. 2!note here!

        enddo ! ispin
        initial_access = 1
      endif ! is_q0
#ifdef HDF5
      endif
#endif

    endif ! pol%skip_chi

!-----------------------------------------------------------------------
! JRD: Now write out elements that Proc 1 owns

    do ispin = 1, kp%nspin

      if (pol%freq_dep.eq.0 .and. peinf%inode.eq.0) then
        write(7,940) ispin,kp%nspin
        do i=1,scal%npr
          ix=scal%isrtxrow(i)
          do j=1,scal%npc

! JRD: Diagonal, subdiagonal and wings only

            jx=scal%isrtxcol(j)
            if(i.eq.j .or. (gvec%components(1,ix) .eq. 0 .and. gvec%components(2,ix) .eq. 0 .and. gvec%components(3,ix) .eq. 0)) &
              write(7,950) (gvec%components(k,ix),k=1,3),ekin(ix),(gvec%components(k,jx),k=1,3),ekin(jx), &
                            pol%chi(i,j,ispin)
          enddo
        enddo
      endif ! pol%freq_dep.eq.0 .and. peinf%inode.eq.0
      
      if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 0) .and. peinf%inode.eq.0) then
        write(7,940) ispin,kp%nspin

        do jj=1,pol%os_nfreq_para
          write(7,*)'frq=',jj
          do i=1,scal%npr
            ix=scal%isrtxrow(i)
            do j=1,scal%npc
              
 !!!JRD: Diagonal and subdiagonal only
   
              jx=scal%isrtxcol(j)
              if(i.eq.j) &
                write(7,950) (gvec%components(k,ix),k=1,3),ekin(ix),(gvec%components(k,jx),k=1,3),ekin(jx), &
                              pol%chiRDyn(jj,i,j,ispin)
            enddo
          enddo
        enddo

#ifdef CPLX
        do jj=1,pol%os_nfreq_para
          write(83,*)'frq=',jj
          do i=1,scal%npr
            ix=scal%isrtxrow(i)
            do j=1,scal%npc

!JRD: Diagonal and subdiagonal only

              jx=scal%isrtxcol(j)
              if(i.eq.j) &
                write(83,950) (gvec%components(k,ix),k=1,3),ekin(ix),(gvec%components(k,jx),k=1,3),ekin(jx), &
                              pol%chiADyn(jj,i,j,ispin)
            enddo
          enddo
        enddo
#endif
!       write(7,940) ispin,kp%nspin
      endif ! (pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 0) .and. peinf%inode.eq.0
     
      if ((pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 1).and. peinf%inode.eq.0) then
        write(7,940) ispin,kp%nspin

         do jj=1,pol%os_nfreq_para
           write(7,*) 'frq=',jj
           do i=1,scal%npr
            ix=scal%isrtxrow(i)
            do j=1,scal%npc
              jx=scal%isrtxcol(j)
              if(i.eq.j) &
                write(7,950) (gvec%components(k,ix),k=1,3),ekin(ix),(gvec%components(k,jx),k=1,3),ekin(jx), &
                              pol%chiRDyn(jj,i,j,ispin)
            enddo
          enddo
        enddo

#ifdef CPLX
        do jj=1,pol%os_nfreq_para
           write(83,*) 'frq=',jj
           do i=1,scal%npr
            ix=scal%isrtxrow(i)
            do j=1,scal%npc
              jx=scal%isrtxcol(j)
              if(i.eq.j) &
                write(83,950) (gvec%components(k,ix),k=1,3),ekin(ix),(gvec%components(k,jx),k=1,3),ekin(jx), &
                              pol%chiADyn(jj,i,j,ispin)
            enddo
          enddo
        enddo
#endif
      endif ! (pol%freq_dep .eq. 2).and.(pol%freq_dep_method .eq. 1) .and. peinf%inode.eq.0
 
940   format(/,10x,' independent matrix elements of chi', 7x,'spin index= ',1i1,1x,1i1,/,/,&
        10x,'g',10x,'g**2',10x,'gp',10x,'gp**2',10x,'chi(g,gp)')
! if last value is real, only one of the f13.8 will be used.
950   format(3i5,f10.5,5x,3i5,f10.5,5x,2f15.10)

    enddo ! ispin (loop over spins)

!        write(6,*) 'End Element Writing'


!--------- write polarizability matrix and crystal info to file ---------

    if (pol%skip_epsilon) then
      
#ifdef HDF5
      if (pol%use_hdf5) then
        if (peinf%inode .eq. 0) then
          SAFE_ALLOCATE(isorti, (gvec%ng))
          do i=1,gvec%ng
            isorti(pol%isrtx(i)) = i
          enddo
          call write_gvec_indices_hdf(gvec%ng,pol%isrtx,isorti,ekin,my_iq,TRUNC(filename_chi_hdf5))
          SAFE_DEALLOCATE(isorti)
        endif
        ! FHJ: TODO - write diagonal elements (I actually think this is useless)
        if (pol%freq_dep .eq. 0) then
          do ispin=1,kp%nspin
            ! FHJ: FIXME: We should unify these routines!
#ifdef USESCALAPACK
            call write_matrix_d_par_hdf(scal, pol%chi(:,:,ispin), pol%nmtx, my_iq, ispin, TRUNC(filename_chi_hdf5))
#else
            call write_matrix_d_hdf(scal, pol%chi(:,:,ispin), pol%nmtx, my_iq, ispin, TRUNC(filename_chi_hdf5))
#endif
          enddo
        else
          do ispin=1,kp%nspin
            ! FHJ: FIXME: We should unify these routines!
#ifdef USESCALAPACK
            call write_matrix_f_par_hdf(scal, pol%nFreq, pol%chiRDyn(:,:,:,ispin), &
#ifdef CPLX
              pol%chiADyn(:,:,:,ispin), &
#endif
              pol%nmtx, my_iq, ispin, TRUNC(filename_chi_hdf5))
#else
            call write_matrix_f_hdf(scal, pol%nFreq, pol%chiRDyn(:,:,:,ispin), &
#ifdef CPLX
              pol%chiADyn(:,:,:,ispin), &
#endif
              pol%nmtx, my_iq, ispin, TRUNC(filename_chi_hdf5))
#endif
          enddo
        endif
      else
#endif
        iunit=11
        if (is_q0) iunit=10
        if(peinf%inode.eq.0) then
          write(iunit) syms%ntranq,(((syms%mtrx(i,j,syms%indsub(n)),i=1,3),j=1,3), &
            (syms%tnp(k,syms%indsub(n)),syms%kgzero(k,n),k=1,3),n=1,syms%ntranq)
          np=pol%nmtx*(pol%nmtx+1)/2
          write(iunit) pol%nmtx,np,(pol%isrtx(i),ekin(i),i=1,gvec%ng),(pol%irow(i),i=1,pol%nmtx)
        endif
        do ispin=1,kp%nspin
          if (pol%freq_dep .eq. 0) then
            call write_matrix_d(scal,pol%chi(:,:,ispin),pol%nmtx,iunit)
          endif ! pol%freq_dep .eq. 0
          if (pol%freq_dep .eq. 2) then
            call write_matrix_f(scal,pol%nFreq,pol%chiRDyn(:,:,:,ispin), &
#ifdef CPLX
            pol%chiADyn(:,:,:,ispin),&
#endif
            pol%nmtx, iunit,pol%os_para_freqs)
          endif ! pol%freq_dep .eq. 2
        enddo ! ispin
#ifdef HDF5
      endif
#endif
    endif ! pol%skip_epsilon

! Use pol%chi(j,1) as sum over spin components
! JRD: Why was proc 0 the only one doing this??!!

    if (pol%freq_dep .eq. 0) then
      if(kp%nspin.eq.2) pol%chi(:,:,1)=pol%chi(:,:,1)+pol%chi(:,:,2)
    endif ! pol%freq_dep .eq. 0
    if (pol%freq_dep .eq. 2) then
      if(kp%nspin.eq.2) pol%chiRDyn(:,:,:,1)=pol%chiRDyn(:,:,:,1)+pol%chiRDyn(:,:,:,2)
#ifdef CPLX
      if(kp%nspin.eq.2) pol%chiADyn(:,:,:,1)=pol%chiADyn(:,:,:,1)+pol%chiADyn(:,:,:,2)
#endif
    endif ! pol%freq_dep .eq. 2

    if (peinf%inode .eq. 0) then
      call timacc(13,1)
#ifdef VERBOSE
      call logit('Calling epsinv')
#endif
    endif ! peinf%inode .eq. 0

    if (.not. pol%skip_epsilon) then
        call epsinv(gvec,pol,ekin,qq,is_q0,crys,scal,kp,omega_plasma,iq)

      if(peinf%inode.eq.0) then
#ifdef VERBOSE
        call logit('Finished epsinv')
#endif
        call timacc(13,2)
      endif ! peinf%inode.eq.0
      
    endif ! pol%skip_epsilon

    if (pol%freq_dep .eq. 0) then
      SAFE_DEALLOCATE_P(pol%chi)
    endif
    if (pol%freq_dep .eq. 2) then
      SAFE_DEALLOCATE_P(pol%chiRDyn)
#ifdef CPLX
      SAFE_DEALLOCATE_P(pol%chiADyn)
#endif
      if(pol%freq_dep_method .eq. 1) then
        SAFE_DEALLOCATE_P(pol%chiTDyn)
      endif
    endif
    if (pol%freq_dep .eq. 3) then
      SAFE_DEALLOCATE_P(pol%chiRDyn)
    endif


    SAFE_DEALLOCATE(indrk)
    SAFE_DEALLOCATE(neq)

    SAFE_DEALLOCATE_P(pol%isrtx)
    SAFE_DEALLOCATE_P(pol%isrtxi)
    SAFE_DEALLOCATE_P(pol%irow)
    SAFE_DEALLOCATE_P(scal%isrtxcol)
    SAFE_DEALLOCATE_P(scal%isrtxrow)
    SAFE_DEALLOCATE_P(scal%imycol)
    SAFE_DEALLOCATE_P(scal%imyrow)
    SAFE_DEALLOCATE_P(scal%imycolinv)
    SAFE_DEALLOCATE_P(scal%imyrowinv)
    SAFE_DEALLOCATE_P(scal%imycold)
    SAFE_DEALLOCATE_P(scal%imyrowd)

#ifdef HDF5
    if (pol%use_hdf5.and.peinf%inode==0) call set_qpt_done(TRUNC(filename_out_hdf5), my_iq)
#endif

  enddo ! iq (loop over q points)

  SAFE_DEALLOCATE_P(scal%nprd)
  SAFE_DEALLOCATE_P(scal%npcd)
  call dealloc_grid(gr)

! End q point loop!
!-------------------------------------------------------------------


!----------- Clean House -------------------------------------------

#ifdef VERBOSE
  call logit('Cleaning up')
#endif

  if (.not. pol%skip_epsilon) then
    call destroy_qran()
  endif

  if(.not. pol%skip_chi) then
    if(peinf%inode == 0) call close_file(17) ! file chi_converge.dat
    call destroy_fftw_plans()
  endif
  if (pol%iwritecoul .eq. 1) then
    if (peinf%inode .eq. 0) then
      call close_file(19) ! file vcoul
    endif
  endif

  if (peinf%inode .eq. 0 .and. pol%freq_dep .eq. 2) then 
    call close_file(51) !file EpsInvDyn
    call close_file(52) !file EpsDyn 
  endif


  SAFE_DEALLOCATE(ekin)
  SAFE_DEALLOCATE_P(kp%w)
  SAFE_DEALLOCATE_P(kp%rk)
  SAFE_DEALLOCATE_P(kp%el)

  if(pol%need_WFNq) then
    SAFE_DEALLOCATE_P(kpq%w)
    SAFE_DEALLOCATE_P(kpq%rk)
    SAFE_DEALLOCATE_P(kpq%el)
  endif
  SAFE_DEALLOCATE_P(gvec%components)
  SAFE_DEALLOCATE_P(gvec%index_vec)
  SAFE_DEALLOCATE_P(pol%qpt)
  SAFE_DEALLOCATE_P(vwfn%isort)
  SAFE_DEALLOCATE_P(cwfn%isort)
  SAFE_DEALLOCATE_P(cwfn%band_index)
  SAFE_DEALLOCATE_P(peinf%global_nvown)
  SAFE_DEALLOCATE_P(peinf%global_ncown)
  SAFE_DEALLOCATE_P(peinf%indexc)
  SAFE_DEALLOCATE_P(peinf%indexv)
  SAFE_DEALLOCATE_P(peinf%global_indexv)
  SAFE_DEALLOCATE_P(peinf%invindexv)
  SAFE_DEALLOCATE_P(peinf%invindexc)
  SAFE_DEALLOCATE_P(peinf%doiownv)
  SAFE_DEALLOCATE_P(peinf%doiownc)
  SAFE_DEALLOCATE_P(peinf%does_it_ownv)
  SAFE_DEALLOCATE_P(peinf%does_it_ownc)
  SAFE_DEALLOCATE_P(peinf%global_pairowner)
  SAFE_DEALLOCATE_P(pol%dFreqGrid)
  SAFE_DEALLOCATE_P(pol%dFreqBrd)
  if(peinf%inode.eq.0) then
    SAFE_DEALLOCATE_P(pol%nmtx_of_q)
    call close_file(7) ! epsilon.log
#ifdef CPLX
    if(pol%freq_dep == 2) call close_file(83) !polchiA.log
#endif

    if (pol%skip_epsilon.and..not.pol%use_hdf5) then      
      if (pol%nq0>0) call close_file(10) ! chi0mat
      if (pol%nq1>0) call close_file(11) ! chimat 
    else 
      if (.not.pol%use_hdf5) then
        if (pol%nq0>0) call close_file(12) ! eps0mat 
        if (pol%nq1>0) call close_file(13) ! epsmat 
      endif
    endif ! pol%skip_epsilon 
  endif

  call free_wfns(pol, intwfnv, intwfnvq, intwfnc, .true.)

!------------- Print Timing Info -----------------------------------------

#ifdef MPI
  call MPI_barrier(MPI_COMM_WORLD,mpierr)
#endif

#ifdef VERBOSE
  call logit('Calculating Timing Info')
#endif

  routnam(1)='TOTAL:'
  routnam(2)='INPUT:'
  routnam(3)='INPUT_Q:'
  routnam(4)='FULLBZ:'
  routnam(5)='GVEC:'
  routnam(6)='SUBGRP:'
  routnam(8)='IRRBZ:'
  routnam(9)='GENWF:'
  routnam(10)='MTXEL:'
  routnam(11)='RQSTAR:'
  routnam(12)='GMAP:'
  routnam(13)='EPSINV (TOTAL):'
  routnam(14)='CHI SUM (COMM):'
  routnam(15)='CHI SUM (TOTAL):'
  routnam(16)='GENWF (VAL):'
  routnam(17)='GENWF (COND):'
  routnam(18)='EPSINV (VCOUL):'
  routnam(19)='JOB SETUP:'
  routnam(20)='Q LOOP SETUP:'
  routnam(21)='INIT CUTOFF:'
  routnam(22)='INIT SCALAPACK:'
  routnam(23)='INIT ARRAYS:'
  routnam(24)='CONVERGE TESTS:'
  routnam(25)='MTXEL (DENOM):'
  routnam(26)='MTXEL (FFT):'
  routnam(28)='GENWF (C-Ekin):'
  routnam(29)='GENWF (C-Sort):'
  routnam(30)='CHI SUM (' // TOSTRING(X(GEMM)) // '):'
  routnam(31)='CHI SUM (PREP):'
  routnam(32)='MTXEL EXP(DENOM):'
  routnam(33)='MTXEL EXP (FFT):'
  routnam(40)='OPT FFT:'
  routnam(41)='OPT FFT (INIT):'
  routnam(42)='OPT FFT (COMM_FFT):'
  routnam(43)='OPT FFT (FFT):'
  routnam(44)='CHI SUM (ARRAY ALLOC):'
  routnam(45)='EPSINV (I/O)'
  routnam(46)='EPSINV (INVERT)'
  routnam(47)='EPS (I/O) COMM'
  routnam(48)='EPS (I/O) IO'
  routnam(51)='CHI SUM (ROW):'
  routnam(52)='CHI SUM (COLUMN):'
  routnam(53)='CHI SUM (HT):'
  routnam(81)='INPUT(Q) I/O'
  routnam(82)='INPUT(Q) COMM'
  routnam(91)='FFT ZERO'
  routnam(92)='FFT PUT'
  routnam(93)='FFT PLAN'
  routnam(94)='FFT EXEC'
  routnam(95)='FFT MLTPLY'

  routsrt=(/ 1,4,8,6,11,12,5,2,3,81,82,9,16,17,28,29,19,20,21,22,23, &
    10,25,26,32,33,15,14,31,44,51,52,30,53,13,18,45,46,47,48,24,40,41,42,43, &
    91,92,93,94,95 /)

  if(peinf%inode.eq.0) then
    call timacc(1,2)
    write(6,*)
    write(6,9000) 'CPU [s]','WALL [s]','#'
    write(6,*)
    do i=2,ubound(routsrt, 1)
      call timacc(routsrt(i),3,tsec,ncount)
      write(6,9001) routnam(routsrt(i)),tsec(1),tsec(2),ncount
    enddo
    write(6,*)
    call timacc(routsrt(1),3,tsec,ncount)
    write(6,9002) routnam(routsrt(1)),tsec(1),tsec(2)
    write(6,*)
    write(6,*)
9000 format(24x,a13,  3x,a13,  3x,a9)
9001 format(a24,f13.3,3x,f13.3,3x,i9)
9002 format(a24,f13.3,3x,f13.3)
  endif

  call write_memory_usage()
  
  if (pol%iwriteint .eq. 0) then
    iunit_c = 100028+peinf%inode
    write(filename,'(a,i4.4)') 'INT_CWFN_', peinf%inode
    call open_file(iunit_c, file = filename, status='old')
    call close_file(iunit_c, delete = .true.) ! files INT_CWFN_*

    if(peinf%inode == 0) then
      iunit_v = 200028
      call open_file(iunit_v, file = 'INT_VWFN', status='old')
      call close_file(iunit_v, delete = .true.) ! files INT_VWFN

      ! this is the condition for calling input_q above
      if(pol%need_WFNq) then
        iunit_v = 300028
        call open_file(iunit_v, file = 'INT_VWFQ', status='old')
        call close_file(iunit_v, delete = .true.) ! files INT_VWFQ
      endif
    endif
  endif

!-------------------------------
! JIM: Close HDF interface
#ifdef HDF5
  if(pol%use_hdf5.or.pol%os_hdf5) call h5close_f(hdf5_error)
#endif
  
#ifdef MPI
  call MPI_Finalize(mpierr)
#endif

end program epsilon

!*************************************************************************
Module SysParams
!*************************************************************************
  implicit none

  save

  integer, parameter         :: double = kind(0.0D0) ! double precision
  real(double), parameter    :: zero   = 0.0D0
  real(double), parameter    :: half   = 0.5D0
  real(double), parameter    :: one    = 1.0D0      
  real(double), parameter    :: two    = 2.0D0
  real(double), parameter    :: four   = 4.0D0

  ! define some mathematical & physical constants

  real(double), parameter    :: epsilon = 1.0d-30
  real(double), parameter    :: twopi = 6.2831853071795864769252867665590D0
  real(double), parameter    :: log2 = 0.301030103010301030103010D0
  real(double), parameter    :: ryd2eV = 13.60569253D0    ! Rydberg atomic unit of energy
  real(double), parameter    :: hartree2eV = two * ryd2eV ! Hartree atomic unit of energy
  real(double), parameter    :: hBar2 = 1.0d0             ! in Hartree atomic units
  real(double), parameter    :: electronMass = 1.0d0      ! in Hartree atomic units
  real(double), parameter    :: hbar = 1.054571628d-34
  real(double), parameter    :: emass = 9.10938215D-31
  real(double), parameter    :: echarge = 1.602176487D-19
  real(double), parameter    :: bohr = 0.52917721092D-10
  real(double), parameter    :: bohr2ang = bohr * 1.0D10

  complex(double), parameter :: imaginary = (0.0d0, 1.0d0)
  integer, parameter         :: maxDimensions = 3

end Module SysParams

!===============================================================================
!
! MODULE:
!
! tile_m                                          Last Modified: Dec/2012 (FHJ)
!
!>  Tiling and tessellation routines for the R^2/R^3. Currently, only Delaunay 
!!  triangulation is available, but Voronoi tessellation should be added soon.
!
! DESCRIPTION:
!
!   This module is an abstraction layer that provides tessellation methods in
!   arbitrary dimensions. The "API" declared here (in the `contains` section)
!   should be generic, and the methods may be implemented by in external 
!   libraries. In this case, please write appropriate wrappers so that the
!   routines declared here do not depend on the technical details of the
!   external back end.
!
!   We currently use Qhull as the back end for the Delaunay tessellation.
!
!===============================================================================

#include "f_defs.h"

module tile_m

  use global_m

  implicit none

  public :: &
#ifdef USEVORO
    pts2bz, &
#endif
    init_delaunay, &
    find_delaunay_simplex, &
    get_num_simplices, &
    get_simplices, &
    get_neighbors, &
    free_delaunay

  private
  
  interface

    !---------------------------------------------------------------------------
    ! FHJ: these tessellation functions are implemented in qhull/libtile_qhull.a

    integer function qhull_init_delaunay(points, num_points, dimensions, inode)
      implicit none
      real(8), intent(in) :: points
      integer, intent(in) :: num_points
      integer, intent(in) :: dimensions
      integer, intent(in) :: inode
    end function qhull_init_delaunay

    integer function qhull_find_delaunay_simplex(point, indices, coefs)
      implicit none
      real(8), intent(in) :: point
      integer, intent(out) :: indices
      real(8), intent(out) :: coefs
    end function qhull_find_delaunay_simplex

    integer function qhull_get_num_simplices(num_simplices)
      implicit none
      integer, intent(out) :: num_simplices
    end function qhull_get_num_simplices

    integer function qhull_get_simplices(indices)
      implicit none
      integer, intent(out) :: indices
    end function qhull_get_simplices

    integer function qhull_get_neighbors(neighbors)
      implicit none
      integer, intent(out) :: neighbors
    end function qhull_get_neighbors

    integer function qhull_free_delaunay()
      implicit none
    end function qhull_free_delaunay

#ifdef USEVORO
    !---------------------------------------------------------------------------
    ! FHJ: this function is implemented in voro/libtile_voro.a

    integer function voro_pts2bz(M, pts_cart, npts, umks)
      implicit none
      real(8), intent(in) :: M
      real(8), intent(in) :: pts_cart
      integer, intent(in) :: npts
      integer, intent(out) :: umks
    end function voro_pts2bz

    !---------------------------------------------------------------------------
#endif

  end interface

contains

  !> Calculates the Delaunay triangulation/tetrahedralization of a set of points.
  !!
  !! For performance issues, only one Delaunay triangulation can be active at
  !! a given time.
  !!
  !! \param points [inout] coarse points (dim, npts)
  !! \param num_points [in] number of points.
  !! \param dim [in] number of dimensions
  !! \return 0 for success
  integer function init_delaunay(points, num_points, dimensions)
    real(DP), intent(in) :: points(:,:)
    integer, intent(in) :: num_points
    integer, intent(in) :: dimensions
    
    PUSH_SUB(init_delaunay)
    init_delaunay = qhull_init_delaunay(points(1,1), num_points, dimensions, peinf%inode)
    POP_SUB(init_delaunay)
    return

  end function init_delaunay

  !> Finds the Delaunay triangle/tetrahedron that encloses point.
  !!
  !! \param point [in] real array (dim) containing the coordinates.
  !! \param indices [out] integer array (dim+1) with the indices of the vertices.
  !! \param coefs [out] coefficients of point in barycentric coordinates.
  integer function find_delaunay_simplex(point, indices, coefs)
    real(DP), intent(in) :: point(:)
    integer, intent(out) :: indices(:)
    real(DP), intent(out) :: coefs(:)

    PUSH_SUB(find_delaunay_simplex)
    find_delaunay_simplex = qhull_find_delaunay_simplex(point(1), indices(1), coefs(1))
    POP_SUB(find_delaunay_simplex)
    return

  end function find_delaunay_simplex

  !> Returns the total number of simplices obtained from the Delaunay
  !! triangulation.
  !!
  !! \param num_simplices [out] number of simplices.
  integer function get_num_simplices(num_simplices)
    integer, intent(out) :: num_simplices

    PUSH_SUB(get_num_simplices)
    get_num_simplices = qhull_get_num_simplices(num_simplices)
    POP_SUB(get_num_simplices)
    return

  end function get_num_simplices

  !> Returns the indices of the points that define each simplex.
  !!
  !! \param simplices [out] (ndims+1, num_simplices) Vertex ivert of
  !! simplex isimp corresponds to the point simplices(ivert,isimp) of
  !! the original list of points.
  integer function get_simplices(simplices)
    integer, intent(out) :: simplices(:,:)

    PUSH_SUB(get_simplices)
    get_simplices = qhull_get_simplices(simplices(1,1))
    POP_SUB(get_simplices)
    return

  end function get_simplices

  !> Returns the indices of the neighbors for each simplex.
  !!
  !! \param neighbors [out] (ndims+1, num_simplices) The neighbor ivert
  !! of simplex isimp is neighbors(ivert,isimp), and corresponds to the
  !! simplex reached by following the ridge opposite to vertex ivert.
  integer function get_neighbors(neighbors)
    integer, intent(out) :: neighbors(:,:)

    PUSH_SUB(get_neighbors)
    get_neighbors = qhull_get_neighbors(neighbors(1,1))
    POP_SUB(get_neighbors)
    return

  end function get_neighbors

  !> Frees buffers associated to the Delaunay triangulation.
  integer function free_delaunay()

    PUSH_SUB(free_delaunay)
    free_delaunay = qhull_free_delaunay()
    POP_SUB(free_delaunay)
    return

  end function free_delaunay

#ifdef USEVORO
  !> Puts points into Brillouin Zone
  !!
  !! \param bdot [in] (3,3) reciprocal metric
  !! \param pts_crys [in] (3,npts) input points, in crystal coords
  !! \param umks [out] (3,npts) umklapp vectors, defined such that:
  !!   pts_crys_bz = pts_crys + umks
  subroutine pts2bz(bdot, pts_crys, umks)
    real(DP), intent(in) :: bdot(3,3)
    real(DP), intent(in) :: pts_crys(:,:)
    integer, intent(out) :: umks(:,:)

    real(DP), parameter :: FX=1d0+1d-12, FY=1d0+1d-13, FZ=1d0+1d-14
    real(DP) :: xx, xy, xz, yy, yz, zz, M(6)
    real(DP), allocatable :: pts_cart(:,:)
    integer :: npts, ierr

    PUSH_SUB(pts2bz)

#if defined(VERBOSE) && defined(DEBUG)
    write(6,*) 'BDOT'
    write(6,'(3(f12.9,1x))') bdot
#endif

    ! FHJ: Cholesky decomposition of the metric, required by voro++
    xx = sqrt(bdot(1,1))
    xy = bdot(2,1)/xx
    xz = bdot(3,1)/xx
    yy = sqrt(bdot(2,2)-xy*xy)
    yz = (bdot(3,2)-xy*xz)/yy
    zz = sqrt(bdot(3,3)-(xz*xz+xy*xy))
    M = (/xx, xy, yy, xz, yz, zz/)

    npts = size(pts_crys, 2)
    SAFE_ALLOCATE(pts_cart, (3,npts))
    ! FHJ: We slightly shift the crystal coords to make the umklapp vectors unique
    pts_cart(1,:) = xx*(pts_crys(1,:)*FX) + xy*(pts_crys(2,:)*FY) + xz*(pts_crys(3,:)*FZ)
    pts_cart(2,:) = yy*(pts_crys(2,:)*FY) + yz*(pts_crys(3,:)*FZ)
    pts_cart(3,:) = zz*(pts_crys(3,:)*FZ)

#if defined(VERBOSE) && defined(DEBUG)
    write(6,'(a,f12.9)') 'xx=',xx
    write(6,'(a,f12.9)') 'xy=',xy
    write(6,'(a,f12.9)') 'xz=',xz
    write(6,'(a,f12.9)') 'yy=',yy
    write(6,'(a,f12.9)') 'yz=',yz
    write(6,'(a,f12.9)') 'zz=',zz
    write(6,*) 'M'
    write(6,'(6(f12.9,1x))') M
#endif

    ierr = voro_pts2bz(M(1), pts_cart(1,1), npts, umks(1,1))
    SAFE_DEALLOCATE(pts_cart)

    POP_SUB(pts2bz)

  end subroutine pts2bz
#endif

end module tile_m

!===========================================================================
!
! Routines:
!
! (1) rqstar()          Originally By SIB       Last Modified 9/1/2010 (DAS)
!
!     Takes vector rq (in irr. zone) and applies all the symmetries
!     of current q-vector to it, and compiles a list of the unique vectors
!     thus generated.  On exit,
!       nstar = number of such vectors
!       insdt = indices of symmetries which generate them, where indices
!               are in the list of those of q (subgroup).
!
!===========================================================================

#include "f_defs.h"

subroutine rqstar(syms,nstar,indst,rq)

  use global_m
  use misc_m
  implicit none

  type (symmetry), intent(in) :: syms
  integer, intent(out) :: nstar,indst(*)
  real(DP), intent(in) :: rq(3)

  integer :: it,istar,gpt(3)
  real(DP) :: qk(3),rqs(3,48)
  logical :: found

!-------------- loop over elements of subgroup ---------------------------

  PUSH_SUB(rqstar)

  nstar = 0
  do it = 1, syms%ntranq

! Rotate rq, so qk = syms%mtrix(indsub(it))*rq,
! and ensure qk(i) is between 0 and 1.

    qk(1:3) = matmul(syms%mtrx(1:3, 1:3, syms%indsub(it)), rq(1:3))
    call k_range(qk(1:3), gpt(1:3), TOL_Small)

! Compare to other elements of star to see if it is already present
    found = .false.
    do istar = 1, nstar
      if (all(abs(qk(1:3) - rqs(1:3, istar)) .lt. TOL_Small)) then
        found = .true.
        exit
      endif
    enddo
    
    if(.not. found) then
! Store new element of star and rotation which gives it
      nstar = nstar + 1
      rqs(1:3, nstar) = qk(1:3)
      indst(nstar) = it
    endif
  enddo

!-------------- end loop over elements of subgroup -----------------------

  POP_SUB(rqstar)
  
  return
end subroutine rqstar

 !===========================================================================
!
! Routines:
!
! (1) write_result_dyn_hp()        Originally By ?         Last Modified 7/3/2008 (JRD)
!
!     Writes the quasiparticle spectrum to the output
!
!===========================================================================

#include "f_defs.h"

module write_result_dyn_hp_m

  use global_m
  implicit none

  private
  public :: write_result_dyn_hp

contains

subroutine write_result_dyn_hp(kp,wfnk,sig,ax,asx,ach,ach_cor,achcor,asig,alda,efsto,ikn)
  type (kpoints), intent(in) :: kp
  type (wfnkstates), intent(in) :: wfnk
  type (siginfo), intent(in) :: sig
  SCALAR, intent(in) :: ax(:,:) !< (sig%ndiag+sig%noffdiag,sig%nspin)
  complex(DPC), intent(in) :: asx(:,:,:) !< (sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin)
  complex(DPC), intent(in) :: ach(:,:,:) !< (sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin)
  complex(DPC), intent(in) :: ach_cor(:,:,:) !< (sig%nfreqeval,sig%ndiag+sig%noffdiag,sig%nspin)
  complex(DPC), intent(in) :: achcor(:,:) !< (sig%ndiag+sig%noffdiag,sig%nspin)
  complex(DPC), intent(in) :: asig(:,:) !< (sig%ndiag+sig%noffdiag,sig%nspin)
  SCALAR, intent(in) :: alda(:,:) !< (sig%ndiag+sig%noffdiag,sig%nspin)
  complex(DPC), intent(in) :: efsto(:,:) !< (sig%ndiag,sig%nspin)
  integer, intent(in) :: ikn
  
  integer :: iw, i, j, ispin
  integer, allocatable :: iwlda(:)
  real(DP) :: diff, diffmin, e_lk
  
  PUSH_SUB(write_result_dyn_hp)

  do ispin=1,sig%nspin

! Sigma Diagonal

    SAFE_ALLOCATE(iwlda, (sig%ndiag))

! JRD: Find iw closest to e_lk

    do i = 1, sig%ndiag
      diffmin = INF
      e_lk = wfnk%ek(sig%diag(i),ispin)
      do iw=1,sig%nfreqeval
        diff = abs(sig%freqevalmin + (iw-1)*sig%freqevalstep - e_lk)
        if (diff .lt. diffmin) then
          diffmin=diff
          iwlda(i)=iw
        endif
      enddo
    enddo

    write(8,979) (kp%rk(j,ikn),j=1,3),ikn,sig%spin_index(ispin)
979 format(7x,"k =",3f10.6,1x,"ik =",i4,1x,"spin =",i2)
    
    if(sig%exact_ch .eq. 0) then
      write(8,978)
      write(8,977) (sig%diag(i),wfnk%elda(sig%diag(i),ispin), &
        wfnk%ek(sig%diag(i),ispin),dble(ax(i,ispin)),dble(asx(iwlda(i),i,ispin)), &
        dble(ach(iwlda(i),i,ispin)),dble(asig(i,ispin)),dble(ach_cor(iwlda(i),i,ispin)),dble(alda(i,ispin)), &
        dble(efsto(i,ispin)),IMAG(asx(iwlda(i),i,ispin)), &
        IMAG(ach(iwlda(i),i,ispin)),IMAG(asig(i,ispin)),IMAG(ach_cor(iwlda(i),i,ispin)),&
        IMAG(efsto(i,ispin)),i=1,sig%ndiag)
978   format(/,3x,"n",8x,"elda",8x,"ecor",11x,"x",5x,"re sx-x",7x, &
        "re ch",6x,"re sig",9x,"re cor",5x,"vxc",5x,"re eqp0", &
        /,45x,"im sx-x",7x,"im ch",6x,"im sig",4x,"im cor",17x,"im eqp0")
977   format(i4,9f12.6,/,40x,4f12.6,12x,f12.6)
    else         
      write(8,980)
      write(8,981) (sig%diag(i),wfnk%elda(sig%diag(i),ispin), &
        wfnk%ek(sig%diag(i),ispin),dble(ax(i,ispin)),dble(asx(iwlda(i),i,ispin)), &
        dble(ach(iwlda(i),i,ispin)+achcor(i,ispin)),dble(asig(i,ispin)+achcor(i,ispin)), &
        dble(ach_cor(iwlda(i),i,ispin)+achcor(i,ispin)),dble(alda(i,ispin)), &
        dble(efsto(i,ispin)+achcor(i,ispin)),dble(ach(iwlda(i),i,ispin)),dble(asig(i,ispin)),&
        dble(ach_cor(iwlda(i),i,ispin)),dble(efsto(i,ispin)),&
        IMAG(asx(iwlda(i),i,ispin)),IMAG(ach(iwlda(i),i,ispin)),IMAG(asig(i,ispin)),&
        IMAG(ach_cor(iwlda(i),i,ispin)),IMAG(efsto(i,ispin)),i=1,sig%ndiag)
980   format(/,3x,"n",8x,"elda",8x,"ecor",11x,"x",5x,"re sx-x",7x, &
        "re ch",6x,"re sig",4x,"re cor",5x,"vxc",10x,"re eqp0",6x,"re ch'",5x,"re sig'",5x,"re cor'",4x,"re eqp0'", &
        /,45x,"im sx-x",7x,"im ch",6x,"im sig",4x,"im cor",18x,"im eqp0")
981   format(i4,13f12.6,/,40x,4f12.6,12x,f12.6)
    endif

! Sigma Off-Diagonal

    if (sig%noffdiag.gt.0) then
      if(sig%exact_ch == 0) then
        write(8,969)
      else
        write(8,970)
      endif
      do i=sig%ndiag+1,sig%ndiag+sig%noffdiag
        iw=iwlda(sig%offmap(i-sig%ndiag, 3))
        if (sig%exact_ch .eq. 0) then
          write(8,968) sig%off1(i-sig%ndiag),sig%off2(i-sig%ndiag), &
            sig%off3(i-sig%ndiag),dble(ax(i,ispin)),dble(asx(iw,i,ispin)), &
            dble(ach(iw,i,ispin)+achcor(i,ispin)),dble(ax(i,ispin)+asx(iw,i,ispin)+ach(iw,i,ispin)+achcor(i,ispin)), &
            dble(alda(i,ispin))
        else
          write(8,971) sig%off1(i-sig%ndiag),sig%off2(i-sig%ndiag), &
            sig%off3(i-sig%ndiag),dble(ax(i,ispin)),dble(asx(iw,i,ispin)), &
            dble(ach(iw,i,ispin)+achcor(i,ispin)),dble(ax(i,ispin)+asx(iw,i,ispin)+ach(iw,i,ispin)+achcor(i,ispin)), &
            dble(alda(i,ispin)), dble(ach(iw,i,ispin)), dble(ax(i,ispin)+asx(iw,i,ispin)+ach(iw,i,ispin))
        endif
#ifdef CPLX
        write(8,967) sig%off1(i-sig%ndiag),sig%off2(i-sig%ndiag), &
          sig%off3(i-sig%ndiag),IMAG(ax(i,ispin)),IMAG(asx(iw,i,ispin)), &
          IMAG(ach(iw,i,ispin)+achcor(i,ispin)),IMAG(ax(i,ispin)+asx(iw,i,ispin)+ach(iw,i,ispin)+achcor(i,ispin)), &
          IMAG(alda(i,ispin))
#else
972 format(3i4,3x,"imag",3x,7f12.6)
        write(8,972) sig%off1(i-sig%ndiag),sig%off2(i-sig%ndiag), &
          sig%off3(i-sig%ndiag),0.0d0,IMAG(asx(iw,i,ispin)), &
          IMAG(ach(iw,i,ispin)+achcor(i,ispin)),IMAG(asx(iw,i,ispin)+ach(iw,i,ispin)+achcor(i,ispin)), &
          0.0d0
#endif
      enddo
    endif
969 format(/,3x,"n",3x,"m",3x,"l",21x,"x",8x,"sx-x",10x,"ch",9x, &
      "sig",9x,"vxc")
968 format(3i4,3x,"real",3x,5f12.6)
967 format(3i4,3x,"imag",3x,5f12.6)
971 format(3i4,3x,"real",3x,7f12.6)
970 format(/,3x,"n",3x,"m",3x,"l",21x,"x",8x,"sx-x",10x,"ch",9x, &
      "sig",9x,"vxc",9x,"ch'",8x,"sig'")
    
    SAFE_DEALLOCATE(iwlda)
    
    write(8,*)
    
  enddo ! ispin
  
  POP_SUB(write_result_dyn_hp)
  
  return
end subroutine write_result_dyn_hp

end module write_result_dyn_hp_m

!==============================================================================
!
! Routine:
!
! (1) inread        Originally By ?
!
!     Read information from input file plotxct.inp.
!
!==============================================================================

#include "f_defs.h"

module inread_m

  use global_m
  use plotxct_common_m
  implicit none
  
  public :: inread

contains

subroutine inread(xct,pxct)
  type (xctinfo), intent(out) :: xct
  type (plotxct_t), intent(out) :: pxct

  character*256 :: blockword,keyword,line,errmsg
  integer :: ii,iostat
  
  PUSH_SUB(inread)

#ifdef MPI
  ! Non-root nodes should wait for root to read the whole file.
  ! That way, we can be sure root gets a chance to write errors before
  ! any die call is issued by another node. Root calls MPI_Barrier below.
  if(peinf%inode /= 0) call MPI_Barrier(MPI_COMM_WORLD, mpierr)
#endif

  call open_file(8,file='plotxct.inp',form='formatted',status='old')

!     Set default values
  pxct%nsuper(:)=0
  pxct%pstate=0
  pxct%plot_hole=.false.
  pxct%plot_electron=.false.
  pxct%ispin=1
  pxct%rhole(:)=0.d0
  pxct%iwann=0
  pxct%seedname=''
  xct%shift(:)=0.d0
  xct%freplacebz=.false.
  xct%fwritebz=.false.
  xct%nn=0
  pxct%int_dim(:)=.false.
  pxct%unfold=.true.
  pxct%unfoldq=.true.
  pxct%subsample(:)=2
  pxct%bz_paranoid=.true.
  pxct%only_psi2=.false.

!     Never ending loop...
  do while(0.eq.0)

!       Actually the loop ends when the end of the file is reached
    read(8,'(a256)',iostat=iostat) line
    if(iostat < 0) exit

!       Skip comment lines
    if(len_trim(line).eq.0) cycle
    if(line(1:1).eq.'#') cycle

!       Determine keyword:
    keyword=line(1:scan(line," ")-1)
    line=adjustl(line(scan(line," ")+1:256))

    if(trim(keyword).eq.'begin') then
      blockword=line(1:scan(line," ")-1)
      ii=0
      do while(trim(line).ne.'end')
        read(8,'(a256)',iostat=iostat) line
        if(iostat /= 0) then
          write(errmsg,'(3a)') 'The end of the file was reached while reading elements of the ', &
            trim(blockword),' block.'
          call die(errmsg, only_root_writes = .true.)
        endif
        if(trim(line).ne.'end') then
          write(errmsg,'(3a)') 'Unexpected blockword ', trim(blockword), ' was found in plotxct.inp.'
          call die(errmsg, only_root_writes = .true.)
        end if
      end do
    elseif(trim(keyword).eq.'restrict_kpoints') then
      read(line,*,err=110) xct%nn
    elseif(trim(keyword).eq.'no_symmetries_fine_grid') then
      pxct%unfold = .false.
    elseif(trim(keyword).eq.'use_symmetries_fine_grid') then
      pxct%unfold = .true.
    elseif(trim(keyword).eq.'no_symmetries_shifted_grid') then
      pxct%unfoldq = .false.
    elseif(trim(keyword).eq.'use_symmetries_shifted_grid') then
      pxct%unfoldq = .true.
    elseif(trim(keyword).eq.'plot_state') then
      read(line,*,err=110) pxct%pstate
    elseif(trim(keyword).eq.'plot_spin') then
      read(line,*,err=110) pxct%ispin
    elseif(trim(keyword).eq.'hole_position') then
      if(pxct%iwann /= 0) call die("Keywords hole_position and wannier_index are incompatible.", only_root_writes = .true.)
      read(line,*,err=110) (pxct%rhole(ii),ii=1,3)
    elseif(trim(keyword).eq.'q_shift') then
      read(line,*,err=110) (xct%shift(ii),ii=1,3)
    elseif(trim(keyword).eq.'supercell_size') then
      read(line,*,err=110) (pxct%nsuper(ii),ii=1,3)
    elseif(trim(keyword).eq.'fullbz_replace') then
      xct%freplacebz=.true.
    elseif(trim(keyword).eq.'fullbz_write') then
      xct%fwritebz=.true.
    else
      write(errmsg,'(3a)') 'Unexpected keyword ', trim(keyword), ' was found in plotxct.inp.'
      call die(errmsg, only_root_writes = .true.)
    end if
  enddo
  
  call close_file(8)
  
  if (peinf%inode==0) then
    if (pxct%unfold) then
      write(6,'(1x,a)') 'Unfolding fine BZ'
    else
      write(6,'(1x,a)') 'Not unfolding fine BZ'
    endif
    if (pxct%unfoldq) then
      write(6,'(1x,a)') 'Unfolding shifted BZ'
    else
      write(6,'(1x,a)') 'Not unfolding shifted BZ'
    endif
    if (pxct%int_dim(1)) then
      write(6,'(1x,a)') 'Integrating wavefunction modulus squared in x-direction'
    endif
    if (pxct%int_dim(2)) then
      write(6,'(1x,a)') 'Integrating wavefunction modulus squared in y-direction'
    endif
    if (pxct%int_dim(3)) then
      write(6,'(1x,a)') 'Integrating wavefunction modulus squared in z-direction'
    endif
    if (pxct%only_psi2) then
      write(6,'(1x,a)') 'We will only output the exciton wavefunction modulus squared'
    endif
    if (.not.pxct%bz_paranoid) then
      write(6,'(1x,a)') 'We won`t be paranoid when unfolding the BZ'
    endif
    write(6,'(1x,a,3(i2,1x))') 'Real-space grid will be subsampled by:', pxct%subsample
  endif

  if (any(pxct%subsample<1)) then
    call die('Invalid value for real-space grid subsampling.', only_root_writes = .true.)
  endif

  if (.not.pxct%only_psi2.and.any(pxct%int_dim)) then
    call die('integrate_* flags require only_psi2 flag.', only_root_writes = .true.)
  endif
  if (all(pxct%int_dim)) then
    call die('It makes no sense to integrate all dimensions!', only_root_writes = .true.)
  endif

  if(pxct%pstate.eq.0) call die("The plot_state keyword could not be found.", only_root_writes = .true.)
  if(pxct%ispin < 0 .or. pxct%ispin > 2) call die("plot_spin out of bounds", only_root_writes = .true.)
  ! we don`t know if we are spin-polarized yet so we cannot check that consistency here

  if(pxct%iwann /= 0 .and. trim(pxct%seedname) == '') &
    call die("If wannier_index is specified, wannier_seedname must be set.", only_root_writes = .true.)

  if(pxct%iwann == 0 .and. trim(pxct%seedname) /= '') &
    call die("If wannier_seedname is set, wannier_index must be specified.", only_root_writes = .true.)
  
  if(product(pxct%nsuper(:))==0) then
    if(peinf%inode == 0) write(0,'(a,3i6)') 'supercell = ', pxct%nsuper(1:3)
    call die("supercell cannot be zero", only_root_writes = .true.)
  endif
  
  if(peinf%inode.eq.0) write(6,*)
  
#ifdef MPI
  ! root lets the others go after it is done reading (see beginning of function)
  if(peinf%inode == 0) call MPI_Barrier(MPI_COMM_WORLD, mpierr)
#endif

  POP_SUB(inread)
  
  return
  
110 write(errmsg,'(3a)') 'Unexpected characters were found while reading the value for the keyword ', &
      trim(keyword), '. '
  call die(errmsg, only_root_writes = .true.)
  
end subroutine inread

end module inread_m

#!/usr/bin/env bash
# gen_doxygen.sh
#
# Create an input file for doxygen (Doxyfile). We have to use this script
# (instead of simple wildcards) because doxygen gets confused with Fortran
# preprocessing macros.
#
# Felipe H. da Jornada, Berkeley, October 2011

path='../Common ../Epsilon ../Sigma ../BSE ../PlotXct ../MeanField ../NonLinearOptics ../Visual ../GW+C'
exts='*.f90 *.F90 *.cpp *.c *.cc'
cond='-false'
for ext in $exts; do
	cond="$cond -or ( -name $ext ) "
done
cond="( ( $cond ) -and ( -not -name *_inc.f90 ) )"
input=`find $path $cond | tr "\n" ' '`

base=${PWD%/doxygen}

cat Doxyfile.template | sed -e "s!%BASE%!$base!" -e "s!%INPUT%!$input!" -e "s!%INCLUDE_PATH%!$path!" > Doxyfile

#!/usr/bin/env bash
#
PATH_BIN="$HOME/BerkeleyGW/bin"
KGRID="$PATH_BIN/kgrid.x"
#
cd ./0-kgrid
$KGRID ./WFN.in ./WFN.out ./WFN.log
$KGRID ./WFNq.in ./WFNq.out ./WFNq.log
$KGRID ./WFN_co.in ./WFN_co.out ./WFN_co.log
$KGRID ./WFN_fi.in ./WFN_fi.out ./WFN_fi.log
$KGRID ./WFNq_fi.in ./WFNq_fi.out ./WFNq_fi.log
cd ..
#

#!/usr/bin/env bash

# Script to patch ESPRESSO and install pw2bgw and bgw2pw in an ESPRESSO build,
# as described in the headers of those files.
# Usage: Go to espresso directory (e.g. cd espresso-4.3.2).
# Then run this script (e.g. sh ../BerkeleyGW/MeanField/ESPRESSO/version-4.3.2/install.sh)
# D. Strubbe Nov 2011

DIR=$(cd $(dirname "$0"); pwd)
QEDIR=$PWD

cd ..
patch -p0 -i $DIR/espresso-4.3.2-patch

cd $QEDIR
ln -s $DIR/pw2bgw.f90 PP/
ln -s $DIR/bgw2pw.f90 PP/
ln -s $DIR/make.bgw PP/

echo "include make.bgw" >> PP/Makefile

make pw
cd PP && make pw2bgw.x bgw2pw.x

#!/usr/bin/env bash

# David Strubbe, October 2010
# Wrapper to run epm2bgw.x with complex wavefunctions, using same input
# file as for real wavefunctions. To reduce duplication in testsuite.

if [ -n "$SHEXEC" ]; then
  echo bash -c \"$SHEXEC `dirname $0`/epm2bgw.x\" >&2
fi
( echo "real_or_complex 2"
cat - ) | bash -c "$SHEXEC `dirname $0`/epm2bgw.x"

#!/usr/bin/env bash
#
ln -s ../1-wfn/wfn.real ./6-epsilon/WFN
ln -s ../2-wfnq/wfn.real ./6-epsilon/WFNq
#
ln -s ../3-wfn_co/vxc.dat ./7-sigma/vxc.dat
ln -s ../3-wfn_co/RHO ./7-sigma
ln -s ../3-wfn_co/wfn.real ./7-sigma/WFN_inner
ln -s ../6-epsilon/eps0mat ./7-sigma
ln -s ../6-epsilon/epsmat ./7-sigma
ln -s ../6-epsilon/eps0mat.h5 ./7-sigma
ln -s ../6-epsilon/epsmat.h5 ./7-sigma
#
ln -s ../3-wfn_co/wfn.real ./8-kernel/WFN_co
ln -s ../6-epsilon/eps0mat ./8-kernel
ln -s ../6-epsilon/epsmat ./8-kernel
ln -s ../6-epsilon/eps0mat.h5 ./8-kernel
ln -s ../6-epsilon/epsmat.h5 ./8-kernel
#
ln -s ../3-wfn_co/wfn.real ./9-absorption/WFN_co
ln -s ../4-wfn_fi/wfn.real ./9-absorption/WFN_fi
ln -s ../5-wfnq_fi/wfn.real ./9-absorption/WFNq_fi
ln -s ../6-epsilon/eps0mat ./9-absorption
ln -s ../6-epsilon/epsmat ./9-absorption
ln -s ../6-epsilon/eps0mat.h5 ./9-absorption
ln -s ../6-epsilon/epsmat.h5 ./9-absorption
ln -s ../8-kernel/bsedmat ./9-absorption
ln -s ../8-kernel/bsexmat ./9-absorption
ln -s ../8-kernel/bsemat.h5 ./9-absorption
#

#!/usr/bin/env bash

# David Strubbe, April 2011
# Wrapper to run epm2bgw.x with complex wavefunctions and spin-polarized,
# using same input file as for real unpolarized wavefunctions.
# To reduce duplication in testsuite.

if [ -n "$SHEXEC" ]; then
  echo bash -c \"$SHEXEC `dirname $0`/epm2bgw.x\" >&2
fi
( echo "real_or_complex 2"
echo "nspin 2"
cat - ) | bash -c "$SHEXEC `dirname $0`/epm2bgw.x"

#!/usr/bin/env bash

# David Strubbe, March 2012, UC Berkeley
# Script to automagically backport a commit from trunk to a branch.
# Usage (from checked-out version of branch): sh backport.sh revision#
# Has been tested for svn versions 1.6, 1.7, 1.8

if [ $# -ne 1 ]; then
    echo "Usage: $0 revision"
    exit
fi

# Without this, svn 1.8 may give an error such as:
#svn: E195020: Cannot merge into mixed-revision working copy [5751:5752]; try updating first
svn update

#Sample output from svn info with subversion 1.6
#Path: .
#URL: https://civet.berkeley.edu/svn/BerkeleyGW/trunk
#Repository Root: https://civet.berkeley.edu/svn/BerkeleyGW
#Repository UUID: f37f1971-f941-45b3-b7f3-995b68ab9ef1
#Revision: 5160
#Node Kind: directory
#Schedule: normal
#Last Changed Author: dstrubbe
#Last Changed Rev: 5160
#Last Changed Date: 2013-02-23 11:57:20 -0500 (Sat, 23 Feb 2013)

#Sample output from svn info with subversion 1.7 -- as above, except after Path comes also:
#Working Copy Root Path: /Users/dstrubbe/Software/BerkeleyGW

#Sample output from svn info with subversion 1.8 -- as above, except after URL comes also:
#Relative URL: ^/trunk

# e.g. https://civet.berkeley.edu/svn/BerkeleyGW
Root=`svn info | grep "Repository Root" | awk '{print $3}'`
# e.g. https://civet.berkeley.edu/svn/BerkeleyGW/branches/1.0.x
URL=`svn info | grep URL | awk '{print $2; exit}'`
# e.g. branches/1.0.x
Branch=${URL#$Root/}

echo "svn merge -c $1 $Root/trunk ."
svn merge -c $1 $Root/trunk . --accept postpone --quiet

# Common/svninfo.90 will always be in conflict.
# --accept postpone avoids an interactive query of what to do
# --quiet suppresses any output about that fact.
# Now we resolve that file. Any other conflicts will be left alone
# for the user to decide what to do, however, and shown below.
svn revert Common/svninfo.f90 --quiet

# Make our own change to svninfo.f90
sed "s/! Modify text here before making a commit -->.*/! Modify text here before making a commit --> r$1 is decommissioned/" < Common/svninfo.f90 > tmp
mv tmp Common/svninfo.f90

# We will accumulate annoying and useless merge tracking properties otherwise
svn revert . --quiet

echo
echo "Compiling with make all ..."
make all
echo "===== svn status ====="
svn status

echo "Backport of $1 to $Branch:" > svn-commit.tmp
svn log $Root -r $1 >> svn-commit.tmp

echo
echo "===== log message ====="
cat svn-commit.tmp

echo
echo "Ok to commit? [y/n]"
read response

if [ "$response" = "y" ]; then
# remove temporary file, but only if commit succeeds
  svn commit --file=svn-commit.tmp && rm -f svn-commit.tmp
else
  echo "Not committing."
fi

#!/usr/bin/env bash
#
# Copyright (C) 2005-2009 Heiko Appel, David Strubbe
#
# Originally GPL, dual-licensed under BerkeleyGW license by permission of these authors.
#
# Based on Octopus file:
# $Id: oct-run_testsuite 2730 2007-02-28 20:57:45Z xavier $


# Paths.
#prefix=/global/home/users/dstrubbe/octopus
#pkgdatadir=${prefix}/share/octopus
#testsuite="$pkgdatadir/testsuite"
testsuite="."

# Failure reporting.
failed_tests=0
skipped_tests=0
passed_tests=0
total_tests=0
failure_report=""


# Usage.
function usage() {
    cat <<EOF

 Copyright (C) 2005-2009 by Heiko Appel, David Strubbe

Usage: run_testsuite [options]
    
     -h            this message
     -n            dry-run mode (show what would be executed)
     -g LIST       comma-separated list of test groups to run
     -q            query testfiles for the given groups (no tests are run)
     -d DIR        directory where to look for the testsuite
     -l            local run
     -p PREFIX     installation prefix [default: /usr]
     -w            without MPI tests (do not run parallel tests)
     -c            delete all .log files and work directories after the run

Report bugs to <BerkeleyGW@civet.berkeley.edu>.
EOF
 exit 0;
}


# Find tests to run. Takes as argument the string passed to the
# -g command line option.
function find_tests() {
    groups="$1"
    if [ -n "$groups" ]; then
	groups_pat=`echo "$groups" | sed 's/ *, */|/'`
	groups_pat="^TestGroups *:.*($groups_pat)"
    else # No groups given defaults to all tests.
	groups_pat="."
    fi
    testfiles=`find $testsuite -name "*.test" | \
	xargs grep -E "$groups_pat" | \
	awk -F: '{print $1}' | sort -u`
    echo "$testfiles"
}


# Run all tests. Takes as first argument a list of testfile names.
function run_testsuite() {

tests="$1"

# Check for 'preserve working directories' flag.
if [ "$cleanup" == "yes" ]; then
    preserve_opt=""
else
    preserve_opt="-p"
fi

for y in $tests; do
    total_tests=$((total_tests + 1))
    ybase=`basename $y`
    xybase=${ybase%.test}
    bin_directory=../bin
#    if [ "${local_run}" == "yes" ]; then
#	bin_directory=`pwd`/../src/main
#	runtest_directory=$testsuite
#    else
#	bin_directory=$prefix/bin
#	runtest_directory=$bin_directory
#    fi
#    if [ -n "${exec_suffix}" ]; then
#	suffix_opt="-s ${exec_suffix}"
#    else
#	suffix_opt=""
#    fi
    if [ -d "${bin_directory}" ]; then
	./run_regression_test.pl -l $opt_n \
	    $preserve_opt -D $bin_directory -f $y $serial_opt | \
	    tee ${xybase}.log
	# Look for failed/passed/skipped testcases and add
	# to failure summary.
	failures=${PIPESTATUS[0]}
	if [ "${failures}" -eq 0 ]; then
	    passed_tests=$((passed_tests + 1))
	elif [ ${failures} -eq 254 ]; then
	    skipped_tests=$((skipped_tests + 1))
	else
	    failed_tests=$((failed_tests + 1))
	    test_name=`echo $y | sed "s|$testsuite/||"`
	    name_length=`echo -n $test_name | wc -m`
	    space_length=$((50 - name_length))
	    spaces=`for((i = 1; i <= space_length; i++)); do echo -n ' '; done`
	    failure_report="$failure_report    $test_name$spaces$failures\n"
	fi
    fi
    [ -e out.log ] && mv out.log ${xybase}.out.log
done
}


# Parse command line.

# Some default settings.
query="no"
cleanup="yes"
test_groups=""
dry_run="no"

# default is yes
# environment variable can set to no
if [ "x$SAVETESTDIRS" == "xyes" ]; then
    cleanup="no";
fi

while getopts "hnlwps:e:m:d:cg:q:" opt ; do
    case "$opt" in
        h) usage;;
        n) dry_run="yes";; 
#        p) prefix="$OPTARG"; testsuite=$prefix/share/octopus/testsuite;;
#        e) exec_suffix="$OPTARG";;
        l) local_run="yes";;
	g) test_groups="$OPTARG";;
	q) test_groups="$OPTARG"; query="yes";;
        w) serial_opt="-s";;
	d) directory="$OPTARG";;
#	c) cleanup="yes";;
        ?) echo "Error parsing arguments"; exit 1;;
    esac
done
shift $[ OPTIND - 1 ]


# Find testfiles.
if [ -n "$directory" ]; then
    testsuite="$directory"
else
    [ "$local_run" == "yes" ] && testsuite=$(pwd)
fi

testfiles=`find_tests "$test_groups"`


# Query mode? If so, list files and exit.
if [ "$query" == "yes" ]; then
    echo "Testfiles for groups $test_groups:"
    echo ""
    for f in $testfiles; do
	echo ${f##$testsuite/}
    done
    exit 0
fi


# No testfiles found, abort.
if [ -z "$testfiles" ]; then
    echo "No testfiles for group(s) $test_groups found."

# Otherwise, start the whole machinery.
else
    # Get epoch seconds at testsuite start.
    testsuite_start=$(date +%s) 

    if [ "$dry_run" == "yes" ]; then
	opt_n="-n"
    else
	opt_n=""
    fi

    # Run testsuite.
    run_testsuite "$testfiles"

    # Failure reporting to STDOUT.
    echo -e "    Passed:  $passed_tests / $total_tests"
    echo -e "    Skipped: $skipped_tests / $total_tests"
    if [ $failed_tests -gt 0 ]; then
	echo "    Failed:  $failed_tests / $total_tests"
	echo
	echo "    testfile                                          # failed testcases"
	echo "    --------------------------------------------------------------------"
	echo -e "$failure_report"
    else
	if [ $passed_tests -gt 0 ]; then
	    echo -e "\nEverything seems to be OK"
	else
	    echo -e "\nAll tests were skipped."
	    # make sure a failure will be reported by the exit status
	    failed_tests=100
	fi
    fi
    echo

    # Clean up.
    [ "$cleanup" == "yes" ] && rm -f *.log

    # Get epoch seconds after we are done and compute time difference.
    testsuite_end=$(date +%s)
    timediff_sec=$[ testsuite_end - testsuite_start ]

    RUNTIME="Total run-time of the testsuite: \
    $(printf '%02d:%02d:%02d' $[timediff_sec / 3600] \
    $[(timediff_sec % 3600) / 60 ] $[timediff_sec % 60])"

    echo $RUNTIME
    echo ""
fi

exit $failed_tests


# Local Variables:
# mode: shell-script
# coding: utf-8
# End:

#!/usr/bin/env bash

# To run interactively:
# qsub -I hbar.scr
# cd $PBS_O_WORKDIR
# sh interactive_hbar.sh

export TEMPDIRPATH=$SCRATCH/tmp

export MPIEXEC="`which mpiexec` --mca btl gm,self"
make check-parallel | tee test.out

echo "Exit status = $?"

#!/usr/bin/env bash

# David Strubbe, October 2010
# Wrapper for mf_convert.x
# Automatically detects whether input file is ascii or binary
# and passes on to the executable. Fortran cannot do this.

if [ $# -ne 2 ]; then
    echo "Usage: $0 infile outfile" >&2
    exit 999
fi

file_type=`file -b $1`

if [[ $file_type == *text* ]]; then
    FORM=A2B
else
    FORM=B2A
fi

echo bash -c \"$SHEXEC `dirname $0`/mf_convert.x $FORM $1 $2\" >&2
bash -c "$SHEXEC `dirname $0`/mf_convert.x $FORM $1 $2"

#!/bin/bash

# Some clusters will not have the Perl package Time::HiRes installed which is needed for
# timing in the testsuite. You can just deactivate the usage with this script.

sed -i '/gettimeofday/d' run_regression_test.pl
sed -i '/elapsed/d' run_regression_test.pl

#!/usr/bin/env bash

# Assemble README and .inp files into a crude manual.
# Usage: bin/assemble_manual.sh > manual.html
# To make PDF, open in Google Chrome browser in an "Incognito Window" (to avoid coloring visited links),
# go to print it, and use "Save as PDF".
# David Strubbe April 2012/November 2013

# Check the list of files here against the output of:
#find . -name "*README*"; find . -name "*.inp"

cd `dirname $0`/..

FILES="
SECTION:Preliminaries
README
license.txt
CONTRIBUTORS
LITERATURE.html
config/README
testsuite/README
library/README
bin/README
examples/README
END
SECTION:MeanField
MeanField/README
SECTION:ESPRESSO
MeanField/ESPRESSO/README
MeanField/ESPRESSO/kgrid.inp
MeanField/ESPRESSO/version-5.1/INPUT_pw2bgw.html
MeanField/ESPRESSO/version-5.1/INPUT_bgw2pw.html
MeanField/ESPRESSO/version-5.0/INPUT_pw2bgw.html
MeanField/ESPRESSO/version-5.0/INPUT_bgw2pw.html
MeanField/ESPRESSO/version-4.3.2/pw2bgw.inp
MeanField/ESPRESSO/version-4.3.2/bgw2pw.inp
MeanField/ESPRESSO/version-4.3.2/README_patch
MeanField/ESPRESSO/patch_oldversions/README
END
SECTION:PARATEC
MeanField/PARATEC/README
END
SECTION:SIESTA
MeanField/SIESTA/README
MeanField/SIESTA/patch/README
MeanField/SIESTA/siesta2bgw.inp
END
SECTION:Octopus
MeanField/Octopus/README
END
SECTION:EPM
MeanField/EPM/README
MeanField/EPM/epm.inp
END
SECTION:ICM
MeanField/ICM/README
END
SECTION:Utilities
MeanField/Utilities/README
MeanField/Utilities/convert_old_to_new.inp
MeanField/Utilities/wfnmerge.inp
MeanField/Utilities/fix_occ.inp
END
SECTION:SAPO
MeanField/SAPO/README
MeanField/SAPO/sapo.inp
END
END
SECTION:Epsilon
Epsilon/README
Epsilon/epsilon.inp
Epsilon/epsconv.inp
Epsilon/epsomega.inp
Epsilon/epsinvomega.inp
Epsilon/epsmat_merge.inp
Epsilon/epsmat_old2hdf5.inp"
FILES="$FILES
END
SECTION:Sigma
Sigma/README
Sigma/sigma.inp
Sigma/sig2wan.inp
END
SECTION:BSE
BSE/README_kernel
BSE/kernel.inp
BSE/README_absorption
BSE/absorption.inp
BSE/inteqp.inp
BSE/README_inteqp
BSE/summarize_eigenvectors.inp
END
SECTION:PlotXct
PlotXct/README
PlotXct/plotxct.inp
END"
FILES="$FILES
SECTION:Visual
Visual/README
Visual/surface.inp
Visual/gsphere.inp
END
SECTION:Developers
doxygen/README
Common/README
Common/qhull/README
MeanField/spglib-1.0.9/README
END"

# check for things that can be misinterpreted as HTML, e.g.
#  grep '<' manual.html | grep -v '<pre>' | grep -v '</pre>' | grep -v '<hr>' | grep -v '<h2>' | grep -v '</h2>'

# Including these in the manual doesn't seem especially useful
#
# examples/EPM/silicon/README
# examples/DFT/silicon/README
# examples/DFT/silicon/PREBUILT/README
# examples/DFT/Si2_sapo/README
# examples/DFT/CO/README
# examples/DFT/benzene/README
# examples/DFT/sodium/README
# examples/DFT/swcnt_5-5/README
# examples/DFT/swcnt_8-0/README
# Common/qhull/README.txt

version_string=`bin/printsvninfo.x`
title="BerkeleyGW manual ($version_string)"

# style trick for <pre> courtesy http://labnol.blogspot.com/2006/10/html-css-trick-for-displaying-code.html
echo "<html>"
echo "<title>$title</title>"
echo "<style> pre {
white-space: pre-wrap; /* css-3 */
white-space: -moz-pre-wrap !important; /* Mozilla, since 1999 */
white-space: -pre-wrap; /* Opera 4-6 */
white-space: -o-pre-wrap; /* Opera 7 */
word-wrap: break-word; /* Internet Explorer 5.5+ */
}</style>"
echo "<body>"

echo "<h1>$title</h1>"
echo "<img src=LOGO/donkey.png>"

echo "<h2>Contents</h2>"
echo "<ol>"
for filename in $FILES; do
  if [[ "$filename" =~ "SECTION" ]]; then
      trimname=${filename#SECTION:}
      echo "<li><a href=#$filename>$trimname</a><ol>"
  elif [[ "$filename" == "END" ]]; then
      echo "</ol>"
  else
      echo "<li><a href=#$filename>$filename</a>"
  fi
done
echo "</ol>"

echo "<h2>About</h2>
This manual is assembled automatically from the various documentation files in the BerkeleyGW distribution.
The headings are the paths and filenames. For each executable, consult the corresponding .inp file for information about input parameters.
The homepage is <a href=http://www.berkeleygw.org>http://www.berkeleygw.org</a>."

for filename in $FILES; do
    case $filename in
	"SECTION"*)
	    trimname=${filename#SECTION:}
	    echo "<a id=$filename><h2>$trimname</h2>" ;;
	"END") ;;
	*)
	    echo "<hr>"
	    echo "<a id=$filename><h2>$filename</h2>"
	    # HTML files do not need to be considered pre-formatted text.
	    if [[ ! "$filename" =~ "html" ]]; then
		echo "<pre>"
	    fi
	    # remove style headers from QE documentation to avoid controlling format of whole manual
	    if [[ "$filename" =~ INPUT.*html ]]; then
		tail -n +7 $filename
	    else
		cat $filename
	    fi
	    if [[ ! "$filename" =~ "html" ]]; then
		echo "</pre>"
	    fi
	    echo ;;
    esac
done

# xmp prevents interpreting part of the donkey as HTML tags!
echo "<hr><xmp>"
`dirname $0`/../LOGO/donkeyfy.sh
echo "</xmp>"

echo "</body>"
echo "</html>"

#!/usr/bin/env bash

# Script to automatically generate complex version of Si-EPM test file
# Input is Si.test, output is Si_cplx.test. All matches should be identical
# between the two versions, ensured by dynamic generation by this script.
# David Strubbe, 16 Oct 2010

cd `dirname $0`
sed 's/(real)/(complex)/' Si.test | \
sed 's/epm2bgw.sh/epm2bgw.cplx.sh/' | \
sed 's/.real.x/.cplx.x/' > Si_cplx.test

#!/usr/bin/env bash

# David Strubbe, Aug 2012
# Dummy wrapper that just runs epm2bgw.x.
# To provide same interface as with epm2bgw.cplx.sh, for use in testsuite.

if [ -n "$SHEXEC" ]; then
  echo bash -c \"$SHEXEC `dirname $0`/epm2bgw.x\" >&2
fi
(cat - ) | bash -c "$SHEXEC `dirname $0`/epm2bgw.x"

#!/usr/bin/env bash

# To run interactively:
# qsub -I lawrencium.scr [or nano.scr]
# cd $PBS_O_WORKDIR
# sh interactive_lr_nano.sh

export TEMPDIRPATH=$SCRATCH/tmp

export MPIEXEC="`which mpiexec` --mca btl openib,self"
make check-parallel | tee test.out

echo "Exit status = $?"

#!/usr/bin/env bash
#
PATH_BIN="$HOME/BerkeleyGW/bin"
EPSILON="$PATH_BIN/epsilon.real.x"
SIGMA="$PATH_BIN/sigma.real.x"
KERNEL="$PATH_BIN/kernel.real.x"
ABSORPTION="$PATH_BIN/absorption.real.x"
MPIRUN=mpirun
#
cd ./6-epsilon
$MPIRUN $EPSILON &> ./OUT.eps
cd ..
#
cd ./7-sigma
$MPIRUN $SIGMA &> ./OUT.sig
cd ..
#
cd ./8-kernel
$MPIRUN $KERNEL &> ./OUT.krn
cd ..
#
cd ./9-absorption
$MPIRUN $ABSORPTION &> ./OUT.abs
cd ..
#

#!/usr/bin/env bash
#
PATH_BIN="$HOME/BerkeleyGW/bin"
EPM="$PATH_BIN/epm2bgw.x"
#
cd ./1-wfn
$EPM < ./in &> out
cd ..
#
cd ./2-wfnq
$EPM < ./in &> out
cd ..
#
cd ./3-wfn_co
$EPM < ./in &> out
cd ..
#
cd ./4-wfn_fi
$EPM < ./in &> out
cd ..
#
cd ./5-wfnq_fi
$EPM < ./in &> out
cd ..
#

#!/usr/bin/env bash

KGRID=../../../bin/kgrid.x

$KGRID WFN.in WFN.out WFN.log
$KGRID WFNq.in WFNq.out WFNq.log
$KGRID WFN_co.in WFN_co.out WFN_co.log
$KGRID WFN_fi.in WFN_fi.out WFN_fi.log
$KGRID WFNq_fi.in WFNq_fi.out WFNq_fi.log

# Then update EPM input files from *.out files.
